/*
Copyright (c) 2014-2015, Michael Daines
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

(function(global) {
var Module = function(Module) {
  Module = Module || {};

var Module;if(!Module)Module=(typeof Module!=="undefined"?Module:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=typeof window==="object";var ENVIRONMENT_IS_WORKER=typeof importScripts==="function";var ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;var ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER;if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=function print(x){process["stdout"].write(x+"\n")};if(!Module["printErr"])Module["printErr"]=function printErr(x){process["stderr"].write(x+"\n")};var nodeFS=require("fs");var nodePath=require("path");Module["read"]=function read(filename,binary){filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);if(!ret&&filename!=nodePath["resolve"](filename)){filename=path.join(__dirname,"..","src",filename);ret=nodeFS["readFileSync"](filename)}if(ret&&!binary)ret=ret.toString();return ret};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function read(){throw"no read() available (jsc?)"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function printErr(x){console.log(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){eval.call(null,x)}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}var Runtime={setTempRet0:(function(value){tempRet0=value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){if(!args.splice)args=Array.prototype.slice.call(args);args.splice(0,0,ptr);return Module["dynCall_"+sig].apply(null,args)}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,arguments)}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=DYNAMICTOP;DYNAMICTOP=DYNAMICTOP+size|0;DYNAMICTOP=DYNAMICTOP+15&-16;if(DYNAMICTOP>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){DYNAMICTOP=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var __THREW__=0;var ABORT=false;var EXITSTATUS=0;var undef=0;var tempValue,tempInt,tempBigInt,tempInt2,tempBigInt2,tempPair,tempBigIntI,tempBigIntR,tempBigIntS,tempBigIntP,tempBigIntD,tempDouble,tempFloat;var tempI64,tempI64b;var tempRet0,tempRet1,tempRet2,tempRet3,tempRet4,tempRet5,tempRet6,tempRet7,tempRet8,tempRet9;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}var globalScope=this;function getCFunc(ident){var func=Module["_"+ident];if(!func){try{func=eval("_"+ident)}catch(e){}}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){ret=Runtime.stackAlloc((str.length<<2)+1);writeStringToMemory(str,ret)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};var sourceRegex=/^function\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSsource={};for(var fun in JSfuncs){if(JSfuncs.hasOwnProperty(fun)){JSsource[fun]=parseJSFunc(JSfuncs[fun])}}cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident);var numericArgs=argTypes.every((function(type){return type==="number"}));var numericRet=returnType!=="string";if(numericRet&&numericArgs){return cfunc}var argNames=argTypes.map((function(x,i){return"$"+i}));var funcstr="(function("+argNames.join(",")+") {";var nargs=argTypes.length;if(!numericArgs){funcstr+="var stack = "+JSsource["stackSave"].body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if(type==="number")continue;var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";";funcstr+=convertCode.body+";";funcstr+=arg+"="+convertCode.returnValue+";"}}var cfuncname=parseJSFunc((function(){return cfunc})).returnValue;funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");";if(!numericRet){var strgfy=parseJSFunc((function(){return Pointer_stringify})).returnValue;funcstr+="ret = "+strgfy+"(ret);"}if(!numericArgs){funcstr+=JSsource["stackRestore"].body.replace("()","(stack)")+";"}funcstr+="return ret})";return eval(funcstr)}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[_malloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(typeof _sbrk!=="undefined"&&!_sbrk.called||!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;function UTF8ArrayToString(u8Array,idx){var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;function UTF16ToString(ptr){var i=0;var str="";while(1){var codeUnit=HEAP16[ptr+i*2>>1];if(codeUnit==0)return str;++i;str+=String.fromCharCode(codeUnit)}}Module["UTF16ToString"]=UTF16ToString;function stringToUTF16(str,outPtr,maxBytesToWrite){if(maxBytesToWrite===undefined){maxBytesToWrite=2147483647}if(maxBytesToWrite<2)return 0;maxBytesToWrite-=2;var startPtr=outPtr;var numCharsToWrite=maxBytesToWrite<str.length*2?maxBytesToWrite/2:str.length;for(var i=0;i<numCharsToWrite;++i){var codeUnit=str.charCodeAt(i);HEAP16[outPtr>>1]=codeUnit;outPtr+=2}HEAP16[outPtr>>1]=0;return outPtr-startPtr}Module["stringToUTF16"]=stringToUTF16;function lengthBytesUTF16(str){return str.length*2}Module["lengthBytesUTF16"]=lengthBytesUTF16;function UTF32ToString(ptr){var i=0;var str="";while(1){var utf32=HEAP32[ptr+i*4>>2];if(utf32==0)return str;++i;if(utf32>=65536){var ch=utf32-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}else{str+=String.fromCharCode(utf32)}}}Module["UTF32ToString"]=UTF32ToString;function stringToUTF32(str,outPtr,maxBytesToWrite){if(maxBytesToWrite===undefined){maxBytesToWrite=2147483647}if(maxBytesToWrite<4)return 0;var startPtr=outPtr;var endPtr=startPtr+maxBytesToWrite-4;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343){var trailSurrogate=str.charCodeAt(++i);codeUnit=65536+((codeUnit&1023)<<10)|trailSurrogate&1023}HEAP32[outPtr>>2]=codeUnit;outPtr+=4;if(outPtr+4>endPtr)break}HEAP32[outPtr>>2]=0;return outPtr-startPtr}Module["stringToUTF32"]=stringToUTF32;function lengthBytesUTF32(str){var len=0;for(var i=0;i<str.length;++i){var codeUnit=str.charCodeAt(i);if(codeUnit>=55296&&codeUnit<=57343)++i;len+=4}return len}Module["lengthBytesUTF32"]=lengthBytesUTF32;function demangle(func){var hasLibcxxabi=!!Module["___cxa_demangle"];if(hasLibcxxabi){try{var buf=_malloc(func.length);writeStringToMemory(func.substr(1),buf);var status=_malloc(4);var ret=Module["___cxa_demangle"](buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}}var i=3;var basicTypes={"v":"void","b":"bool","c":"char","s":"short","i":"int","l":"long","f":"float","d":"double","w":"wchar_t","a":"signed char","h":"unsigned char","t":"unsigned short","j":"unsigned int","m":"unsigned long","x":"long long","y":"unsigned long long","z":"..."};var subs=[];var first=true;function dump(x){if(x)Module.print(x);Module.print(func);var pre="";for(var a=0;a<i;a++)pre+=" ";Module.print(pre+"^")}function parseNested(){i++;if(func[i]==="K")i++;var parts=[];while(func[i]!=="E"){if(func[i]==="S"){i++;var next=func.indexOf("_",i);var num=func.substring(i,next)||0;parts.push(subs[num]||"?");i=next+1;continue}if(func[i]==="C"){parts.push(parts[parts.length-1]);i+=2;continue}var size=parseInt(func.substr(i));var pre=size.toString().length;if(!size||!pre){i--;break}var curr=func.substr(i+pre,size);parts.push(curr);subs.push(curr);i+=pre+size}i++;return parts}function parse(rawList,limit,allowVoid){limit=limit||Infinity;var ret="",list=[];function flushList(){return"("+list.join(", ")+")"}var name;if(func[i]==="N"){name=parseNested().join("::");limit--;if(limit===0)return rawList?[name]:name}else{if(func[i]==="K"||first&&func[i]==="L")i++;var size=parseInt(func.substr(i));if(size){var pre=size.toString().length;name=func.substr(i+pre,size);i+=pre+size}}first=false;if(func[i]==="I"){i++;var iList=parse(true);var iRet=parse(true,1,true);ret+=iRet[0]+" "+name+"<"+iList.join(", ")+">"}else{ret=name}paramLoop:while(i<func.length&&limit-->0){var c=func[i++];if(c in basicTypes){list.push(basicTypes[c])}else{switch(c){case"P":list.push(parse(true,1,true)[0]+"*");break;case"R":list.push(parse(true,1,true)[0]+"&");break;case"L":{i++;var end=func.indexOf("E",i);var size=end-i;list.push(func.substr(i,size));i+=size+2;break};case"A":{var size=parseInt(func.substr(i));i+=size.toString().length;if(func[i]!=="_")throw"?";i++;list.push(parse(true,1,true)[0]+" ["+size+"]");break};case"E":break paramLoop;default:ret+="?"+c;break paramLoop}}}if(!allowVoid&&list.length===1&&list[0]==="void")list=[];if(rawList){if(ret){list.push(ret+"?")}return list}else{return ret+flushList()}}var parsed=func;try{if(func=="Object._main"||func=="_main"){return"main()"}if(typeof func==="number")func=Pointer_stringify(func);if(func[0]!=="_")return func;if(func[1]!=="_")return func;if(func[2]!=="Z")return func;switch(func[3]){case"n":return"operator new()";case"d":return"operator delete()"}parsed=parse()}catch(e){parsed+="?"}if(parsed.indexOf("?")>=0&&!hasLibcxxabi){Runtime.warnOnce("warning: a problem occurred in builtin C++ name demangling; build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling")}return parsed}function demangleAll(text){return text.replace(/__Z[\w\d_]+/g,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){return demangleAll(jsStackTrace())}Module["stackTrace"]=stackTrace;var PAGE_SIZE=4096;function alignMemoryPage(x){if(x%4096>0){x+=4096-x%4096}return x}var HEAP;var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;var STATIC_BASE=0,STATICTOP=0,staticSealed=false;var STACK_BASE=0,STACKTOP=0,STACK_MAX=0;var DYNAMIC_BASE=0,DYNAMICTOP=0;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which adjusts the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}function enlargeMemory(){abortOnCannotGrowMemory()}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||16777216;var totalMemory=64*1024;while(totalMemory<TOTAL_MEMORY||totalMemory<2*TOTAL_STACK){if(totalMemory<16*1024*1024){totalMemory*=2}else{totalMemory+=16*1024*1024}}if(totalMemory!==TOTAL_MEMORY){TOTAL_MEMORY=totalMemory}assert(typeof Int32Array!=="undefined"&&typeof Float64Array!=="undefined"&&!!(new Int32Array(1))["subarray"]&&!!(new Int32Array(1))["set"],"JS engine does not provide full typed array support");var buffer;if(Module["buffer"]){buffer=Module["buffer"];assert(buffer.byteLength===TOTAL_MEMORY,"provided buffer should be "+TOTAL_MEMORY+" bytes, but it is "+buffer.byteLength)}else{buffer=new ArrayBuffer(TOTAL_MEMORY)}HEAP8=new Int8Array(buffer);HEAP16=new Int16Array(buffer);HEAP32=new Int32Array(buffer);HEAPU8=new Uint8Array(buffer);HEAPU16=new Uint16Array(buffer);HEAPU32=new Uint32Array(buffer);HEAPF32=new Float32Array(buffer);HEAPF64=new Float64Array(buffer);HEAP32[0]=255;assert(HEAPU8[0]===255&&HEAPU8[3]===0,"Typed arrays 2 must be run on a little-endian system");Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Runtime.dynCall("v",func)}else{Runtime.dynCall("vi",func,[callback.arg])}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){var array=intArrayFromString(string,dontAddNull);var i=0;while(i<array.length){var chr=array[i];HEAP8[buffer+i>>0]=chr;i=i+1}}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){for(var i=0;i<array.length;i++){HEAP8[buffer++>>0]=array[i]}}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;function unSign(value,bits,ignore){if(value>=0){return value}return bits<=32?2*Math.abs(1<<bits-1)+value:Math.pow(2,bits)+value}function reSign(value,bits,ignore){if(value<=0){return value}var half=bits<=32?Math.abs(1<<bits-1):Math.pow(2,bits-1);if(value>=half&&(bits<=32||value>half)){value=-2*half+value}return value}if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_min=Math.min;var Math_clz32=Math.clz32;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var memoryInitializer=null;var ASM_CONSTS=[(function($0){{appendError($0)}})];function _emscripten_asm_const_1(code,a0){return ASM_CONSTS[code](a0)}STATIC_BASE=8;STATICTOP=STATIC_BASE+193488;__ATINIT__.push();allocate([0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,32,193,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,64,0,0,0,0,0,0,82,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,64,0,0,0,0,0,0,82,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,2,16,0,0,0,0,0,0,0,0,0,0,0,0,16,64,184,176,0,0,8,0,0,0,1,0,0,0,0,0,0,0,2,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,150,64,0,0,0,0,0,128,150,64,4,144,195,0,0,0,0,0,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,64,0,0,0,0,0,0,88,64,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,64,0,0,0,0,0,0,88,64,0,32,3,2,0,0,0,0,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,66,64,0,0,0,0,0,0,66,64,0,0,0,0,0,32,131,64,0,0,0,0,0,192,136,64,0,0,0,0,0,0,82,64,0,0,0,0,0,0,82,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,66,64,0,0,0,0,0,0,66,64,0,0,0,0,0,32,131,64,0,0,0,0,0,192,136,64,0,0,0,0,0,0,82,64,0,0,0,0,0,0,82,64,0,176,193,0,0,0,0,0,0,0,0,0,0,0,16,64,176,182,0,0,147,0,0,0,1,0,0,0,0,0,0,0,64,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,64,0,0,0,0,0,0,82,64,0,16,0,2,0,0,0,0,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,64,0,0,0,0,0,0,88,64,0,176,193,0,0,0,0,0,0,0,0,0,0,0,0,0,176,186,0,0,16,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,64,0,0,0,0,0,0,88,64,64,32,62,3,0,0,0,0,0,0,0,0,0,0,16,64,184,187,0,0,122,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,64,0,0,0,0,0,0,82,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,64,0,0,0,0,0,0,82,64],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([255,255,255,255,255,255,239,127,255,255,255,255,255,255,239,127,255,255,255,255,255,255,239,255,255,255,255,255,255,255,239,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,51,51,51,51,51,51,211,63,0,0,0,0,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,154,153,153,153,153,153,169,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,154,153,153,153,153,153,169,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,169,241,210,77,98,80,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,52,38,245,107,12,195,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,1,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,2,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,3,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,4,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,51,51,51,51,51,51,243,63,5,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,154,153,153,153,153,153,233,63,6,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,7,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,255,255,255,255,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,51,51,51,51,51,51,211,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,128,70,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,154,153,153,153,153,153,217,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,51,51,51,51,51,51,227,63,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,123,20,174,71,225,122,228,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,1,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,128,102,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,128,102,64,154,153,153,153,153,153,217,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,128,102,64,123,20,174,71,225,122,228,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,128,70,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,0,1,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,223,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,64,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,81,218,27,124,97,50,227,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,244,108,86,125,174,182,214,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,196,66,173,105,222,113,236,63,16,122,54,171,62,87,229,63,245,219,215,129,115,70,204,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,136,133,90,211,188,227,216,63,1,77,132,13,79,175,226,63,211,188,227,20,29,201,209,63,88,168,53,205,59,78,213,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,1,77,132,13,79,175,226,63,1,77,132,13,79,175,226,63,1,77,132,13,79,175,226,63,181,21,251,203,238,201,225,63,204,93,75,200,7,61,240,63,16,122,54,171,62,87,229,63,16,122,54,171,62,87,229,63,210,111,95,7,206,25,231,63,210,111,95,7,206,25,231,63,16,122,54,171,62,87,229,63,120,11,36,40,126,140,227,63,106,222,113,138,142,228,232,63,210,111,95,7,206,25,231,63,211,188,227,20,29,201,209,63,0,0,0,0,0,0,224,63,16,122,54,171,62,87,229,63,181,21,251,203,238,201,225,63,44,212,154,230,29,167,234,63,210,111,95,7,206,25,231,63,106,222,113,138,142,228,232,63,16,122,54,171,62,87,229,63,106,222,113,138,142,228,232,63,210,111,95,7,206,25,231,63,16,122,54,171,62,87,229,63,120,11,36,40,126,140,227,63,210,111,95,7,206,25,231,63,16,122,54,171,62,87,229,63,134,56,214,197,109,52,238,63,16,122,54,171,62,87,229,63,16,122,54,171,62,87,229,63,120,11,36,40,126,140,227,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,166,10,70,37,117,2,222,63,181,21,251,203,238,201,225,63,72,191,125,29,56,103,204,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,0,0,0,0,0,0,224,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,211,188,227,20,29,201,209,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,72,191,125,29,56,103,204,63,72,191,125,29,56,103,204,63,0,0,0,0,0,0,224,63,72,191,125,29,56,103,204,63,44,212,154,230,29,167,234,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,224,63,211,188,227,20,29,201,209,63,181,21,251,203,238,201,225,63,0,0,0,0,0,0,224,63,210,111,95,7,206,25,231,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,2,154,8,27,158,94,213,63,224,190,14,156,51,162,208,63,2,154,8,27,158,94,213,63,1,77,132,13,79,175,226,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,88,168,53,205,59,78,213,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,62,232,217,172,250,92,197,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,29,56,103,68,105,111,200,63,88,168,53,205,59,78,213,63,181,21,251,203,238,201,225,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,211,188,227,20,29,201,209,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,231,29,167,232,72,46,225,63,162,180,55,248,194,100,214,63,72,191,125,29,56,103,204,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,181,21,251,203,238,201,225,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,211,188,227,20,29,201,209,63,120,11,36,40,126,140,227,63,211,188,227,20,29,201,209,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,211,188,227,20,29,201,209,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,211,188,227,20,29,201,209,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,240,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,0,0,0,0,0,0,240,63,211,188,227,20,29,201,209,63,234,149,178,12,113,172,215,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,181,21,251,203,238,201,225,63,106,222,113,138,142,228,232,63,0,0,0,0,0,0,240,63,152,221,147,135,133,90,215,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,196,66,173,105,222,113,236,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,72,191,125,29,56,103,204,63,120,11,36,40,126,140,227,63,134,56,214,197,109,52,238,63,120,11,36,40,126,140,227,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,88,168,53,205,59,78,213,63,37,117,2,154,8,27,218,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,44,212,154,230,29,167,234,63,106,222,113,138,142,228,232,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,224,63,93,220,70,3,120,11,226,63,0,0,0,0,0,0,208,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,208,63,211,188,227,20,29,201,209,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,93,220,70,3,120,11,226,63,93,220,70,3,120,11,226,63,93,220,70,3,120,11,226,63,13,113,172,139,219,104,220,63,100,93,220,70,3,120,237,63,210,111,95,7,206,25,231,63,16,122,54,171,62,87,229,63,16,122,54,171,62,87,229,63,210,111,95,7,206,25,231,63,120,11,36,40,126,140,227,63,181,21,251,203,238,201,225,63,210,111,95,7,206,25,231,63,210,111,95,7,206,25,231,63,88,168,53,205,59,78,213,63,136,133,90,211,188,227,216,63,210,111,95,7,206,25,231,63,120,11,36,40,126,140,227,63,196,66,173,105,222,113,236,63,210,111,95,7,206,25,231,63,210,111,95,7,206,25,231,63,181,21,251,203,238,201,225,63,210,111,95,7,206,25,231,63,16,122,54,171,62,87,229,63,181,21,251,203,238,201,225,63,120,11,36,40,126,140,227,63,210,111,95,7,206,25,231,63,210,111,95,7,206,25,231,63,134,56,214,197,109,52,238,63,210,111,95,7,206,25,231,63,210,111,95,7,206,25,231,63,120,11,36,40,126,140,227,63,88,168,53,205,59,78,213,63,211,188,227,20,29,201,209,63,88,168,53,205,59,78,213,63,166,10,70,37,117,2,222,63,0,0,0,0,0,0,224,63,88,168,53,205,59,78,213,63,13,113,172,139,219,104,220,63,0,0,0,0,0,0,224,63,13,113,172,139,219,104,220,63,0,0,0,0,0,0,224,63,13,113,172,139,219,104,220,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,211,188,227,20,29,201,209,63,211,188,227,20,29,201,209,63,0,0,0,0,0,0,224,63,211,188,227,20,29,201,209,63,106,222,113,138,142,228,232,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,88,168,53,205,59,78,213,63,136,133,90,211,188,227,216,63,211,188,227,20,29,201,209,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,210,111,95,7,206,25,231,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,13,113,172,139,219,104,220,63,244,108,86,125,174,182,222,63,17,54,60,189,82,150,201,63,244,108,86,125,174,182,222,63,59,1,77,132,13,79,225,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,62,232,217,172,250,92,197,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,130,115,70,148,246,6,199,63,13,113,172,139,219,104,220,63,0,0,0,0,0,0,224,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,181,21,251,203,238,201,225,63,181,21,251,203,238,201,225,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,7,240,22,72,80,252,220,63,162,180,55,248,194,100,214,63,88,168,53,205,59,78,213,63,13,113,172,139,219,104,220,63,13,113,172,139,219,104,220,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,208,63,13,113,172,139,219,104,220,63,0,0,0,0,0,0,208,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,208,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,208,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,88,168,53,205,59,78,213,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,196,66,173,105,222,113,236,63,0,0,0,0,0,0,208,63,127,217,61,121,88,168,209,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,120,11,36,40,126,140,227,63,210,111,95,7,206,25,231,63,196,66,173,105,222,113,236,63,19,242,65,207,102,213,211,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,16,122,54,171,62,87,229,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,211,188,227,20,29,201,209,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,211,188,227,20,29,201,209,63,0,0,0,0,0,0,224,63,210,111,95,7,206,25,231,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,0,0,0,0,0,0,208,63,132,245,127,14,243,101,15,64,96,118,79,30,22,42,43,192,98,189,81,43,76,223,205,191,23,133,184,205,175,65,138,63,212,130,23,125,5,105,241,191,93,134,255,116,3,133,235,63,247,21,214,83,204,189,55,63,186,205,91,66,44,5,46,63,58,205,2,237,14,41,238,191,250,185,161,41,59,253,216,63,249,97,41,55,246,145,128,63,167,57,30,216,150,166,125,63,155,200,204,5,46,143,231,191,198,51,104,232,159,224,202,63,54,130,67,94,197,152,138,63,26,142,66,237,18,48,133,63,122,52,213,147,249,71,217,191,205,228,155,109,110,76,27,64,229,103,126,144,192,122,185,63,254,198,232,202,177,6,137,63,115,243,141,232,158,117,225,191,231,86,99,100,36,214,179,63,209,99,239,32,209,95,155,63,231,208,216,77,223,33,139,63,7,242,71,172,32,97,171,63,15,149,235,18,122,162,182,191,179,181,190,72,104,203,137,63,124,90,234,197,245,148,161,63,7,234,148,71,55,194,202,63,70,227,154,76,38,184,174,191,51,242,129,54,156,166,125,191,45,30,197,214,191,45,128,63,210,26,131,78,8,29,182,63,88,57,180,200,118,30,39,192,85,193,168,164,78,128,5,192,246,9,160,24,89,50,199,63,137,149,209,200,231,21,207,63,98,45,62,5,192,248,252,191,11,94,244,21,164,25,249,63,129,236,245,238,143,247,250,63,43,47,249,159,252,221,205,63,115,187,151,251,228,40,221,191,250,210,219,159,139,134,204,63,235,201,252,163,111,210,217,63,230,44,162,220,108,98,175,63,228,132,9,163,89,217,186,191,225,188,147,170,72,224,166,63,204,197,8,118,54,195,129,63,88,55,222,29,25,171,157,63,234,178,152,216,124,188,26,64,206,0,23,100,203,242,197,63,117,250,139,234,190,173,149,63,192,189,33,67,125,129,159,63,171,93,19,210,26,131,170,191,36,176,222,77,92,51,150,63,170,17,85,83,237,46,179,191,9,198,28,95,214,31,168,191,63,198,220,181,132,124,192,63,82,147,133,84,246,2,180,191,0,0,0,0,0,0,0,64,111,210,217,110,39,182,159,191,60,37,49,82,57,55,171,63,66,108,250,253,172,67,151,191,197,80,243,250,56,63,166,63,123,20,174,71,225,122,148,63,164,112,61,10,215,163,6,64,0,0,0,0,0,0,192,63,123,20,174,71,225,122,132,63,81,160,79,228,73,210,14,64,180,200,118,190,159,58,53,192,58,34,223,165,212,37,213,191,243,130,62,71,154,46,138,63,159,229,121,112,119,214,249,191,126,253,16,27,44,156,230,63,150,236,216,8,196,235,204,63,205,206,162,119,42,224,208,63,176,227,191,64,16,32,237,191],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+33272);allocate([173,161,212,94,68,219,216,63,59,161,124,230,81,150,118,63,211,110,112,249,122,132,123,63,129,204,206,162,119,42,228,191,209,173,215,244,160,160,200,63,106,223,55,25,176,63,132,63,190,202,144,25,94,255,132,63,28,150,6,126,84,195,196,191,165,73,41,232,246,226,35,64,169,217,3,173,192,144,193,63,8,196,144,65,147,105,137,63,250,68,158,36,93,51,208,191,1,240,153,54,45,194,94,63,13,156,125,47,207,148,151,63,137,181,248,20,0,227,137,63,229,169,88,70,52,203,177,191,143,0,201,207,161,103,166,191,92,181,198,251,204,180,136,63,77,164,143,84,58,179,144,63,230,199,4,161,97,214,160,191,199,105,103,28,19,247,130,191,42,127,107,229,45,112,92,191,228,87,98,84,8,154,117,63,209,241,135,85,114,4,183,63,149,212,9,104,34,60,51,192,100,35,16,175,235,119,16,192,167,33,170,240,103,120,199,63,218,255,0,107,213,174,193,63,78,40,68,192,33,84,247,191,170,72,133,177,133,32,245,63,157,104,87,33,229,39,246,63,77,46,198,192,58,142,205,63,89,107,40,181,23,209,220,191,3,63,170,97,191,39,204,63,166,71,83,61,153,127,218,63,182,129,59,80,167,60,174,63,81,76,222,0,51,223,185,191,245,118,149,255,218,11,166,63,212,165,53,188,15,246,148,63,31,173,32,188,44,220,144,63,40,44,241,128,178,201,35,64,35,90,225,76,2,138,183,63,72,163,101,81,150,41,127,63,187,180,134,247,193,158,147,63,23,168,123,83,71,125,160,191,33,43,174,224,109,148,139,63,51,115,220,132,214,30,181,191,160,120,132,137,245,252,143,63,105,53,36,238,177,244,145,191,184,205,51,122,94,191,106,63,146,62,173,162,63,52,205,191,126,176,231,198,79,62,152,191,7,35,155,80,45,199,164,63,62,24,194,123,88,185,145,191,45,124,125,173,75,141,198,63,252,169,241,210,77,98,80,63,236,81,184,30,133,235,19,64,229,208,34,219,249,126,202,63,83,150,33,142,117,113,123,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,223,65,0,0,0,64,251,33,249,63,0,0,0,0,45,68,116,62,0,0,0,128,152,70,248,60,0,0,0,96,81,204,120,59,0,0,0,128,131,27,240,57,0,0,0,64,32,37,122,56,0,0,0,128,34,130,227,54,0,0,0,0,29,243,105,53,0,0,0,0,0,0,0,0,0,0,0,0,93,153,1,0,116,172,0,0,3,0,0,0,64,174,0,0,3,0,0,0,144,176,0,0,3,0,0,0,52,177,0,0,3,0,0,0,104,178,0,0,3,0,0,0,136,182,0,0,3,0,0,0,172,185,0,0,3,0,0,0,120,186,0,0,3,0,0,0,72,190,0,0,3,0,0,0,144,187,0,0,0,0,0,0,4,174,0,0,0,0,0,0,104,176,0,0,0,0,0,0,12,177,0,0,0,0,0,0,64,178,0,0,0,0,0,0,96,182,0,0,0,0,0,0,132,185,0,0,0,0,0,0,80,186,0,0,0,0,0,0,32,190,0,0,0,0,0,0,104,187,0,0,4,0,0,0,152,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,209,24,2,0,1,0,0,0,20,173,0,0,8,0,0,0,4,0,0,0,101,153,1,0,1,0,0,0,140,173,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,106,153,1,0,1,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,114,153,1,0,1,0,0,0,0,0,0,0,128,0,0,0,1,0,0,0,121,153,1,0,1,0,0,0,0,0,0,0,72,0,0,0,2,0,0,0,131,153,1,0,1,0,0,0,0,0,0,0,128,0,0,0,3,0,0,0,141,153,1,0,1,0,0,0,0,0,0,0,128,0,0,0,4,0,0,0,155,153,1,0,1,0,0,0,0,0,0,0,128,0,0,0,5,0,0,0,165,153,1,0,1,0,0,0,0,0,0,0,128,0,0,0,6,0,0,0,178,153,1,0,1,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,175,0,0,128,175,0,0,144,175,0,0,160,175,0,0,176,175,0,0,192,175,0,0,208,175,0,0,224,175,0,0,128,175,0,0,128,175,0,0,192,175,0,0,192,175,0,0,0,0,0,0,31,0,0,0,63,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,1,0,0,0,5,0,0,0,2,0,0,0,2,0,0,0,6,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,120,154,1,0,1,0,0,0,240,175,0,0,24,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,124,154,1,0,1,0,0,0,0,0,0,0,56,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,171,2,0,74,148,2,0,219,149,2,0,27,156,2,0,18,163,2,0,81,167,2,0,209,170,2,0,226,170,2,0,0,0,0,0,69,171,2,0,74,148,2,0,27,156,2,0,219,149,2,0,81,167,2,0,18,163,2,0,226,170,2,0,209,170,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,72,156,1,0,1,0,0,0,192,177,0,0,112,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,76,156,1,0,1,0,0,0,0,0,0,0,144,1,0,0,2,0,0,0,86,156,1,0,1,0,0,0,0,0,0,0,200,1,0,0,0,0,0,0,95,156,1,0,1,0,0,0,0,0,0,0,200,1,0,0,3,0,0,0,104,156,1,0,1,0,0,0,0,0,0,0,200,1,0,0,0,0,0,0,114,156,1,0,1,0,0,0,0,0,0,0,144,1,0,0,3,0,0,0,126,156,1,0,1,0,0,0,0,0,0,0,144,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,125,33,2,0,1,0,0,0,184,178,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,49,217,1,0,1,0,0,0,0,0,0,0,32,2,0,0,1,0,0,0,197,157,1,0,1,0,0,0,0,0,0,0,32,2,0,0,2,0,0,0,42,217,1,0,1,0,0,0,0,0,0,0,88,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,3,0,0,0,9,0,0,0,3,0,0,0,3,0,0,0,0,0,0,0,196,161,1,0,210,161,1,0,232,161,1,0,86,185,2,0,246,161,1,0,5,162,1,0,10,162,1,0,40,162,1,0,86,185,2,0,58,162,1,0,106,162,1,0,86,185,2,0,136,162,1,0,176,162,1,0,190,162,1,0,237,162,1,0,33,163,1,0,50,163,1,0,87,163,1,0,122,163,1,0,128,163,1,0,156,163,1,0,185,163,1,0,212,163,1,0,245,163,1,0,15,164,1,0,49,164,1,0,80,164,1,0,118,164,1,0,142,164,1,0,174,164,1,0,203,164,1,0,239,164,1,0,251,164,1,0,86,185,2,0,6,165,1,0,44,165,1,0,80,165,1,0,118,165,1,0,86,185,2,0,172,165,1,0,196,165,1,0,209,165,1,0,0,166,1,0,251,164,1,0,86,185,2,0,13,166,1,0,22,166,1,0,55,166,1,0,114,166,1,0,189,166,1,0,17,167,1,0,51,167,1,0,72,167,1,0,95,167,1,0,117,167,1,0,141,167,1,0,86,185,2,0,163,167,1,0,190,167,1,0,226,167,1,0,6,168,1,0,43,168,1,0,86,185,2,0,76,168,1,0,102,168,1,0,120,168,1,0,133,168,1,0,146,168,1,0,166,168,1,0,181,168,1,0,189,168,1,0,210,168,1,0,224,168,1,0,30,169,1,0,41,169,1,0,251,164,1,0,86,185,2,0,47,169,1,0,59,169,1,0,74,169,1,0,122,163,1,0,86,185,2,0,93,169,1,0,134,169,1,0,164,169,1,0,180,169,1,0,197,169,1,0,204,169,1,0,219,169,1,0,235,169,1,0,47,170,1,0,54,170,1,0,122,163,1,0,86,185,2,0,64,170,1,0,108,170,1,0,119,170,1,0,128,170,1,0,137,170,1,0,154,170,1,0,171,170,1,0,191,170,1,0,251,164,1,0,86,185,2,0,203,170,1,0,219,170,1,0,233,170,1,0,247,170,1,0,4,171,1,0,17,171,1,0,39,171,1,0,48,171,1,0,63,171,1,0,76,171,1,0,93,171,1,0,251,164,1,0,86,185,2,0,104,171,1,0,135,171,1,0,86,185,2,0,153,171,1,0,168,171,1,0,216,171,1,0,226,171,1,0,239,171,1,0,252,171,1,0,9,172,1,0,22,172,1,0,25,172,1,0,86,185,2,0,29,172,1,0,86,185,2,0,64,172,1,0,113,172,1,0,160,172,1,0,183,172,1,0,210,172,1,0,237,172,1,0,251,164,1,0,86,185,2,0,9,173,1,0,86,185,2,0,49,173,1,0,61,173,1,0,80,173,1,0,99,173,1,0,120,173,1,0,141,173,1,0,145,173,1,0,122,163,1,0,86,185,2,0,157,173,1,0,86,185,2,0,173,173,1,0,187,173,1,0,199,173,1,0,212,173,1,0,244,173,1,0,4,174,1,0,26,174,1,0,86,185,2,0,46,174,1,0,119,174,1,0,189,174,1,0,237,174,1,0,32,175,1,0,39,175,1,0,78,175,1,0,117,175,1,0,86,185,2,0,122,175,1,0,0,0,0,0,26,0,0,0,0,0,0,0,27,0,0,0,28,0,0,0,5,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,4,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,11,0,0,0,6,0,0,0,4,0,0,0,12,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,128,33,2,0,1,0,0,0,232,181,0,0,144,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,218,1,0,1,0,0,0,0,0,0,0,176,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,147,2,0,108,147,2,0,50,184,1,0,177,147,2,0,236,147,2,0,14,148,2,0,20,148,2,0,69,171,2,0,59,148,2,0,74,148,2,0,103,148,2,0,114,148,2,0,148,148,2,0,202,148,2,0,0,149,2,0,59,149,2,0,113,149,2,0,147,149,2,0,162,149,2,0,211,149,2,0,219,149,2,0,238,175,1,0,247,175,1,0,248,149,2,0,0,176,1,0,66,150,2,0,9,176,1,0,76,150,2,0,18,176,1,0,86,150,2,0,165,150,2,0,224,150,2,0,30,176,1,0,27,151,2,0,38,151,2,0,107,151,2,0,121,151,2,0,195,151,2,0,209,151,2,0,223,151,2,0,234,151,2,0,27,152,2,0,91,152,2,0,99,152,2,0,107,152,2,0,166,152,2,0,220,152,2,0,232,152,2,0,55,184,1,0,244,152,2,0,254,152,2,0,9,153,2,0,38,153,2,0,92,153,2,0,27,156,2,0,61,156,2,0,73,156,2,0,8,159,2,0,57,159,2,0,101,159,2,0,155,159,2,0,168,159,2,0,202,159,2,0,236,159,2,0,245,159,2,0,63,160,2,0,73,160,2,0,142,160,2,0,196,160,2,0,207,160,2,0,84,161,2,0,105,161,2,0,38,176,1,0,115,161,2,0,125,161,2,0,179,161,2,0,243,161,2,0,1,162,2,0,85,162,2,0,100,162,2,0,115,162,2,0,194,162,2,0,63,184,1,0,2,163,2,0,12,163,2,0,18,163,2,0,62,163,2,0,101,163,2,0,118,163,2,0,129,163,2,0,198,163,2,0,11,164,2,0,26,164,2,0,42,164,2,0,60,164,2,0,76,164,2,0,92,164,2,0,105,164,2,0,115,164,2,0,169,164,2,0,178,164,2,0,242,164,2,0,5,165,2,0,68,184,1,0,13,165,2,0,67,165,2,0,106,165,2,0,160,165,2,0,199,165,2,0,213,165,2,0,11,166,2,0,85,166,2,0,159,166,2,0,170,166,2,0,224,166,2,0,229,166,2,0,2,167,2,0,31,167,2,0,42,167,2,0,81,167,2,0,105,167,2,0,159,167,2,0,213,167,2,0,225,167,2,0,8,168,2,0,19,168,2,0,68,168,2,0,117,168,2,0,111,196,1,0,156,168,2,0,200,168,2,0,254,168,2,0,52,169,2,0,62,169,2,0,91,169,2,0,155,169,2,0,209,169,2,0,74,184,1,0,233,169,2,0,21,170,2,0,60,170,2,0,114,170,2,0,175,170,2,0,209,170,2,0,215,170,2,0,226,170,2,0,9,171,2,0,214,176,1,0,210,176,1,0,0,0,0,0,0,0,0,0,39,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,14,0,0,0,7,0,0,0,5,0,0,0,15,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,195,182,1,0,1,0,0,0,12,185,0,0,232,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,198,182,1,0,1,0,0,0,0,0,0,0,8,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,43,0,0,0,0,0,0,0,44,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,17,0,0,0,8,0,0,0,6,0,0,0,18,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,38,184,1,0,1,0,0,0,216,185,0,0,64,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,42,184,1,0,1,0,0,0,0,0,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,50,184,1,0,69,171,2,0,74,148,2,0,55,184,1,0,92,153,2,0,27,156,2,0,63,184,1,0,62,163,2,0,242,164,2,0,68,184,1,0,42,167,2,0,81,167,2,0,111,196,1,0,74,184,1,0,209,170,2,0,226,170,2,0,47,0,0,0,0,0,0,0,48,0,0,0,49,0,0,0,9,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,20,0,0,0,10,0,0,0,7,0,0,0,21,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,249,194,1,0,1,0,0,0,240,186,0,0,152,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,253,194,1,0,1,0,0,0,0,0,0,0,184,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,177,147,2,0,5,195,1,0,69,171,2,0,74,148,2,0,103,148,2,0,16,195,1,0,22,195,1,0,33,195,1,0,40,195,1,0,114,148,2,0,202,148,2,0,48,195,1,0,54,195,1,0,65,195,1,0,113,149,2,0,147,149,2,0,219,149,2,0,72,195,1,0,66,150,2,0,86,150,2,0,224,150,2,0,82,195,1,0,107,151,2,0,121,151,2,0,195,151,2,0,93,195,1,0,209,151,2,0,101,195,1,0,110,195,1,0,124,195,1,0,134,195,1,0,166,152,2,0,143,195,1,0,232,152,2,0,9,153,2,0,38,153,2,0,149,195,1,0,109,153,2,0,152,153,2,0,193,153,2,0,228,153,2,0,13,154,2,0,48,154,2,0,89,154,2,0,124,154,2,0,165,154,2,0,200,154,2,0,241,154,2,0,20,155,2,0,61,155,2,0,96,155,2,0,137,155,2,0,172,155,2,0,213,155,2,0,248,155,2,0,27,156,2,0,156,195,1,0,61,156,2,0,168,195,1,0,101,159,2,0,202,159,2,0,142,160,2,0,181,195,1,0,115,162,2,0,194,195,1,0,2,163,2,0,18,163,2,0,204,195,1,0,62,163,2,0,101,163,2,0,118,163,2,0,219,195,1,0,237,195,1,0,129,163,2,0,11,164,2,0,26,164,2,0,42,164,2,0,60,164,2,0,76,164,2,0,253,195,1,0,8,196,1,0,19,196,1,0,92,164,2,0,242,164,2,0,247,164,2,0,24,196,1,0,33,196,1,0,42,196,1,0,58,196,1,0,65,196,1,0,67,165,2,0,106,165,2,0,160,165,2,0,213,165,2,0,229,166,2,0,2,167,2,0,73,196,1,0,81,167,2,0,80,196,1,0,225,167,2,0,89,196,1,0,19,168,2,0,97,196,1,0,117,168,2,0,111,196,1,0,156,168,2,0,200,168,2,0,118,196,1,0,91,169,2,0,155,169,2,0,128,196,1,0,209,169,2,0,233,169,2,0,60,170,2,0,138,196,1,0,152,196,1,0,114,170,2,0,121,170,2,0,175,170,2,0,209,170,2,0,226,170,2,0,9,171,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,61,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,0,0,0,0,0,0,0,23,0,0,0,11,0,0,0,8,0,0,0,24,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,206,1,0,255,255,255,255,168,189,0,0,240,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,206,1,0,255,255,255,255,0,0,0,0,16,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,206,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,66,0,0,160,52,2,0,65,73,0,0,122,52,2,0,65,82,0,0,77,52,2,0,65,88,0,0,181,52,2,0,66,32,0,0,241,54,2,0,66,73,0,0,2,55,2,0,67,66,0,0,58,53,2,0,67,79,0,0,40,53,2,0,67,88,0,0,71,53,2,0,72,32,0,0,107,53,2,0,72,66,0,0,117,53,2,0,72,73,0,0,1,54,2,0,72,88,0,0,132,53,2,0,72,98,0,0,181,53,2,0,72,105,0,0,232,53,2,0,72,114,0,0,154,53,2,0,72,120,0,0,203,53,2,0,73,32,0,0,19,55,2,0,75,66,0,0,204,52,2,0,75,73,0,0,20,53,2,0,75,82,0,0,0,53,2,0,75,88,0,0,237,52,2,0,78,66,0,0,19,54,2,0,78,73,0,0,90,54,2,0,78,82,0,0,114,54,2,0,78,88,0,0,62,54,2,0,80,65,0,0,211,54,2,0,80,66,0,0,143,54,2,0,80,73,0,0,195,54,2,0,80,88,0,0,175,54,2,0,82,32,0,0,193,56,2,0,83,32,0,0,226,54,2,0,90,68,0,0,80,55,2,0,0,0,0,0,0,0,0,0,1,0,0,0,15,0,0,0,170,216,1,0,1,0,0,0,128,195,0,0,0,0,0,0,16,0,0,0,178,216,1,0,1,0,0,0,128,195,0,0,0,0,0,0,17,0,0,0,186,216,1,0,1,0,0,0,128,195,0,0,0,0,0,0,17,0,0,0,195,216,1,0,1,0,0,0,128,195,0,0,0,0,0,0,17,0,0,0,203,216,1,0,1,0,0,0,128,195,0,0,0,0,0,0,19,0,0,0,211,216,1,0,1,0,0,0,132,195,0,0,0,0,0,0,20,0,0,0,219,216,1,0,1,0,0,0,132,195,0,0,0,0,0,0,21,0,0,0,227,216,1,0,1,0,0,0,132,195,0,0,0,0,0,0,21,0,0,0,236,216,1,0,1,0,0,0,132,195,0,0,0,0,0,0,21,0,0,0,244,216,1,0,1,0,0,0,132,195,0,0,0,0,0,0,22,0,0,0,252,216,1,0,1,0,0,0,136,195,0,0,0,0,0,0,23,0,0,0,5,217,1,0,1,0,0,0,136,195,0,0,0,0,0,0,24,0,0,0,14,217,1,0,1,0,0,0,136,195,0,0,0,0,0,0,24,0,0,0,24,217,1,0,1,0,0,0,136,195,0,0,0,0,0,0,24,0,0,0,33,217,1,0,1,0,0,0,136,195,0,0,0,0,0,0,25,0,0,0,42,217,1,0,1,0,0,0,140,195,0,0,0,0,0,0,25,0,0,0,49,217,1,0,1,0,0,0,140,195,0,0,0,0,0,0,26,0,0,0,55,217,1,0,1,0,0,0,144,195,0,0,0,0,0,0,10,0,0,0,64,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,11,0,0,0,72,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,12,0,0,0,80,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,12,0,0,0,89,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,12,0,0,0,97,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,14,0,0,0,105,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,14,0,0,0,112,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,13,0,0,0,120,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,5,0,0,0,128,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,6,0,0,0,136,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,7,0,0,0,144,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,7,0,0,0,153,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,7,0,0,0,161,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,9,0,0,0,169,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,9,0,0,0,176,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,8,0,0,0,184,217,1,0,1,0,0,0,148,195,0,0,0,0,0,0,0,0,0,0,192,217,1,0,1,0,0,0,152,195,0,0,0,0,0,0,1,0,0,0,201,217,1,0,1,0,0,0,152,195,0,0,0,0,0,0,2,0,0,0,210,217,1,0,1,0,0,0,152,195,0,0,0,0,0,0,2,0,0,0,220,217,1,0,1,0,0,0,152,195,0,0,0,0,0,0,2,0,0,0,229,217,1,0,1,0,0,0,152,195,0,0,0,0,0,0,4,0,0,0,238,217,1,0,1,0,0,0,152,195,0,0,0,0,0,0,4,0,0,0,246,217,1,0,1,0,0,0,152,195,0,0,0,0,0,0,3,0,0,0,255,217,1,0,1,0,0,0,152,195,0,0,0,0,0,0,18,0,0,0,8,218,1,0,1,0,0,0,128,195,0,0,0,0,0,0,27,0,0,0,16,218,1,0,1,0,0,0,156,195,0,0,0,0,0,0,28,0,0,0,24,218,1,0,1,0,0,0,156,195,0,0,0,0,0,0,29,0,0,0,32,218,1,0,1,0,0,0,156,195,0,0,0,0,0,0,29,0,0,0,41,218,1,0,1,0,0,0,156,195,0,0,0,0,0,0,29,0,0,0,49,218,1,0,1,0,0,0,156,195,0,0,0,0,0,0,30,0,0,0,57,218,1,0,1,0,0,0,160,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,164,221,1,0,172,195,0,0,1,0,0,0,200,195,0,0,0,0,0,0,0,0,0,0,63,0,0,0,64,0,0,0,1,0,0,0,0,0,0,0,209,24,2,0,0,0,0,0,188,195,0,0,196,195,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,1,0,0,48,1,0,0,176,0,0,0,47,229,1,0,52,229,1,0,56,229,1,0,63,229,1,0,67,229,1,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,234,1,0,120,197,0,0,1,0,0,0,212,197,0,0,0,0,0,0,0,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,66,0,0,0,76,0,0,0,66,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,50,234,1,0,0,0,0,0,136,197,0,0,208,197,0,0,1,0,0,0,56,234,1,0,0,0,0,0,144,197,0,0,208,197,0,0,2,0,0,0,60,234,1,0,0,0,0,0,152,197,0,0,208,197,0,0,3,0,0,0,65,234,1,0,0,0,0,0,160,197,0,0,208,197,0,0,4,0,0,0,71,234,1,0,0,0,0,0,168,197,0,0,208,197,0,0,5,0,0,0,77,234,1,0,0,0,0,0,192,197,0,0,208,197,0,0,6,0,0,0,87,234,1,0,0,0,0,0,200,197,0,0,208,197,0,0,7,0,0,0,93,234,1,0,0,0,0,0,176,197,0,0,208,197,0,0,7,0,0,0,97,234,1,0,0,0,0,0,176,197,0,0,208,197,0,0,7,0,0,0,102,234,1,0,0,0,0,0,184,197,0,0,208,197,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,242,236,1,0,8,0,0,0,48,0,0,0,0,0,0,0,1,0,0,0,28,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,185,2,0,0,0,0,0,0,165,2,0,1,0,0,0,245,252,1,0,7,0,0,0,253,252,1,0,3,0,0,0,63,186,2,0,5,0,0,0,5,253,1,0,15,0,0,0,101,33,2,0,8,0,0,0,101,33,2,0,16,0,0,0,13,253,1,0,4,0,0,0,13,253,1,0,17,0,0,0,18,253,1,0,5,0,0,0,18,253,1,0,2,0,0,0,24,253,1,0,6,0,0,0,31,253,1,0,4,0,0,0,43,253,1,0,7,0,0,0,51,253,1,0,7,0,0,0,67,253,1,0,5,0,0,0,73,253,1,0,8,0,0,0,96,253,1,0,8,0,0,0,73,253,1,0,9,0,0,0,105,253,1,0,7,0,0,0,113,253,1,0,10,0,0,0,139,253,1,0,7,0,0,0,147,253,1,0,11,0,0,0,173,253,1,0,6,0,0,0,180,253,1,0,12,0,0,0,210,253,1,0,9,0,0,0,180,253,1,0,13,0,0,0,220,253,1,0,8,0,0,0,229,253,1,0,14,0,0,0,6,254,1,0,8,0,0,0,15,254,1,0,18,0,0,0,48,254,1,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,13,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,12,0,0,0,2,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,3,0,0,0,29,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,4,0,0,0,30,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,64,0,0,0,228,202,0,0,109,11,2,0,8,203,0,0,16,203,0,0,6,0,0,0,4,0,0,0,252,202,0,0,6,0,0,0,4,0,0,0,6,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,8,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,11,2,0,0,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,9,0,0,0,11,0,0,0,8,0,0,0,10,0,0,0,196,204,0,0,68,204,0,0,172,204,0,0,0,0,0,0,1,0,0,0,1,0,0,0,7,0,0,0,32,0,0,0,8,0,0,0,81,0,0,0,33,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,9,0,0,0,2,0,0,0,5,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,3,0,0,0,12,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,34,0,0,0,14,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,10,0,0,0,1,0,0,0,1,0,0,0,11,0,0,0,1,0,0,0,12,0,0,0,1,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,19,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,1,0,0,0,30,0,0,0,1,0,0,0,1,0,0,0,19,0,0,0,1,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,19,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,19,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,46,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,47,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,48,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+43512);allocate([19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,4,0,0,0,1,0,0,0,5,0,0,0,1,0,0,0,6,0,0,0,7,0,0,0,7,0,0,0,1,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,3,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,92,70,2,0,87,70,2,0,213,14,2,0,106,70,2,0,112,70,2,0,97,70,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,89,19,2,0,96,19,2,0,133,70,2,0,103,19,2,0,110,19,2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,145,20,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,220,20,2,0,8,0,0,0,3,0,0,0,229,20,2,0,233,20,2,0,11,0,0,0,6,0,0,0,125,33,2,0,245,20,2,0,2,0,0,0,1,0,0,0,248,20,2,0,252,20,2,0,4,0,0,0,2,0,0,0,1,21,2,0,5,21,2,0,4,0,0,0,4,0,0,0,10,21,2,0,15,21,2,0,5,0,0,0,5,0,0,0,21,21,2,0,25,21,2,0,4,0,0,0,7,0,0,0,30,21,2,0,34,21,2,0,5,0,0,0,9,0,0,0,40,21,2,0,44,21,2,0,4,0,0,0,10,0,0,0,49,21,2,0,54,21,2,0,4,0,0,0,12,0,0,0,59,21,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,29,2,0,0,0,0,0,1,0,0,0,94,29,2,0,1,0,0,0,0,0,0,0,47,69,2,0,1,0,0,0,1,0,0,0,0,165,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,243,24,2,0,49,0,0,0,0,0,0,0,0,0,0,0,230,57,2,0,16,0,0,0,142,177,2,0,128,0,0,0,236,24,2,0,64,0,0,0,23,47,2,0,16,0,0,0,238,24,2,0,64,0,0,0,0,0,0,0,0,0,0,0,193,24,2,0,1,0,0,0,200,24,2,0,2,0,0,0,205,24,2,0,3,0,0,0,212,64,2,0,4,0,0,0,107,47,2,0,5,0,0,0,209,24,2,0,6,0,0,0,0,165,2,0,8,0,0,0,213,24,2,0,33,0,0,0,217,24,2,0,34,0,0,0,221,24,2,0,34,0,0,0,225,24,2,0,1,0,0,0,230,24,2,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,228,28,2,0,235,28,2,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,208,132,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,122,33,2,0,125,33,2,0,128,33,2,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,255,255,255,255,61,33,2,0,67,33,2,0,0,165,2,0,0,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,39,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,11,0,0,0,40,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,212,64,2,0,208,222,0,0,80,133,0,0,0,0,0,0,58,47,2,0,208,222,0,0,128,133,0,0,0,0,0,0,185,56,2,0,208,222,0,0,176,133,0,0,0,0,0,0,66,47,2,0,208,222,0,0,176,133,0,0,0,0,0,0,71,47,2,0,208,222,0,0,224,133,0,0,0,0,0,0,78,47,2,0,232,222,0,0,224,133,0,0,0,0,0,0,84,47,2,0,208,222,0,0,16,134,0,0,0,0,0,0,88,47,2,0,208,222,0,0,64,134,0,0,0,0,0,0,0,165,2,0,208,222,0,0,112,134,0,0,0,0,0,0,97,47,2,0,208,222,0,0,112,134,0,0,0,0,0,0,107,47,2,0,208,222,0,0,160,134,0,0,0,0,0,0,115,47,2,0,208,222,0,0,208,134,0,0,0,0,0,0,125,47,2,0,208,222,0,0,0,135,0,0,0,0,0,0,139,47,2,0,208,222,0,0,48,135,0,0,0,0,0,0,145,47,2,0,208,222,0,0,96,135,0,0,0,0,0,0,154,47,2,0,208,222,0,0,144,135,0,0,0,0,0,0,162,47,2,0,208,222,0,0,192,135,0,0,0,0,0,0,171,47,2,0,208,222,0,0,240,135,0,0,0,0,0,0,179,47,2,0,208,222,0,0,32,136,0,0,0,0,0,0,184,47,2,0,208,222,0,0,80,136,0,0,0,0,0,0,188,47,2,0,208,222,0,0,128,136,0,0,0,0,0,0,195,47,2,0,208,222,0,0,176,136,0,0,0,0,0,0,201,47,2,0,208,222,0,0,224,136,0,0,0,0,0,0,211,47,2,0,208,222,0,0,80,133,0,0,0,0,0,0,216,47,2,0,208,222,0,0,80,133,0,0,0,0,0,0,226,47,2,0,208,222,0,0,16,137,0,0,0,0,0,0,233,47,2,0,208,222,0,0,64,137,0,0,0,0,0,0,246,47,2,0,208,222,0,0,112,137,0,0,0,0,0,0,4,48,2,0,208,222,0,0,160,137,0,0,0,0,0,0,18,48,2,0,208,222,0,0,208,137,0,0,0,0,0,0,30,48,2,0,208,222,0,0,0,138,0,0,0,0,0,0,43,48,2,0,208,222,0,0,48,138,0,0,0,0,0,0,52,48,2,0,208,222,0,0,96,138,0,0,0,0,0,0,62,48,2,0,208,222,0,0,144,138,0,0,0,0,0,0,71,48,2,0,208,222,0,0,192,138,0,0,0,0,0,0,79,48,2,0,208,222,0,0,240,138,0,0,0,0,0,0,87,48,2,0,208,222,0,0,32,139,0,0,0,0,0,0,96,48,2,0,208,222,0,0,80,139,0,0,0,0,0,0,100,48,2,0,208,222,0,0,128,139,0,0,0,0,0,0,111,48,2,0,208,222,0,0,176,139,0,0,0,0,0,0,115,48,2,0,208,222,0,0,224,139,0,0,0,0,0,0,125,48,2,0,208,222,0,0,16,140,0,0,0,0,0,0,134,48,2,0,208,222,0,0,64,140,0,0,0,0,0,0,142,48,2,0,208,222,0,0,112,140,0,0,0,0,0,0,155,48,2,0,208,222,0,0,160,140,0,0,0,0,0,0,167,48,2,0,208,222,0,0,208,140,0,0,0,0,0,0,178,48,2,0,208,222,0,0,0,141,0,0,0,0,0,0,194,48,2,0,208,222,0,0,48,141,0,0,0,0,0,0,208,48,2,0,208,222,0,0,96,141,0,0,0,0,0,0,223,48,2,0,208,222,0,0,144,141,0,0,0,0,0,0,233,48,2,0,208,222,0,0,192,141,0,0,0,0,0,0,242,48,2,0,208,222,0,0,240,141,0,0,0,0,0,0,252,48,2,0,208,222,0,0,32,142,0,0,0,0,0,0,6,49,2,0,208,222,0,0,80,142,0,0,0,0,0,0,13,49,2,0,208,222,0,0,128,142,0,0,0,0,0,0,20,49,2,0,208,222,0,0,176,142,0,0,0,0,0,0,30,49,2,0,0,223,0,0,0,0,0,0,0,0,0,0,37,49,2,0,0,223,0,0,0,0,0,0,0,0,0,0,9,47,2,0,24,223,0,0,0,0,0,0,0,0,0,0,45,49,2,0,48,223,0,0,224,142,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,47,2,0,23,47,2,0,233,177,2,0,25,47,2,0,82,0,0,0,83,0,0,0,21,0,0,0,4,0,0,0,2,0,0,0,10,0,0,0,84,0,0,0,83,0,0,0,21,0,0,0,5,0,0,0,0,0,0,0,11,0,0,0,85,0,0,0,86,0,0,0,22,0,0,0,6,0,0,0,3,0,0,0,12,0,0,0,87,0,0,0,88,0,0,0,21,0,0,0,7,0,0,0,0,0,0,0,13,0,0,0,82,0,0,0,83,0,0,0,21,0,0,0,8,0,0,0,2,0,0,0,10,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,50,2,0,54,50,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,4,0,0,0,6,0,0,0,2,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,8,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,52,2,0,93,52,2,0,106,52,2,0,0,0,0,0,0,0,0,0,4,0,0,0,111,52,2,0,0,0,0,0,0,0,0,0,122,52,2,0,93,52,2,0,106,52,2,0,0,0,0,0,145,52,2,0,5,0,0,0,111,52,2,0,0,0,0,0,153,52,2,0,160,52,2,0,93,52,2,0,176,52,2,0,0,0,0,0,0,0,0,0,6,0,0,0,111,52,2,0,165,68,2,0,0,0,0,0,181,52,2,0,93,52,2,0,176,52,2,0,0,0,0,0,145,52,2,0,7,0,0,0,111,52,2,0,165,68,2,0,153,52,2,0,204,52,2,0,217,52,2,0,176,52,2,0,0,0,0,0,0,0,0,0,10,0,0,0,231,52,2,0,165,68,2,0,0,0,0,0,237,52,2,0,217,52,2,0,176,52,2,0,0,0,0,0,153,52,2,0,11,0,0,0,231,52,2,0,165,68,2,0,153,52,2,0,0,53,2,0,217,52,2,0,14,53,2,0,0,0,0,0,0,0,0,0,8,0,0,0,231,52,2,0,0,0,0,0,0,0,0,0,20,53,2,0,217,52,2,0,14,53,2,0,0,0,0,0,153,52,2,0,9,0,0,0,231,52,2,0,0,0,0,0,153,52,2,0,40,53,2,0,40,53,2,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,48,53,2,0,0,0,0,0,0,0,0,0,58,53,2,0,40,53,2,0,165,68,2,0,0,0,0,0,0,0,0,0,14,0,0,0,48,53,2,0,165,68,2,0,0,0,0,0,71,53,2,0,40,53,2,0,165,68,2,0,0,0,0,0,145,52,2,0,15,0,0,0,48,53,2,0,165,68,2,0,153,52,2,0,91,53,2,0,40,53,2,0,0,0,0,0,0,0,0,0,145,52,2,0,13,0,0,0,48,53,2,0,0,0,0,0,153,52,2,0,107,53,2,0,107,53,2,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,111,52,2,0,0,0,0,0,0,0,0,0,117,53,2,0,107,53,2,0,165,68,2,0,0,0,0,0,0,0,0,0,18,0,0,0,111,52,2,0,165,68,2,0,0,0,0,0,132,53,2,0,107,53,2,0,165,68,2,0,0,0,0,0,145,52,2,0,19,0,0,0,111,52,2,0,165,68,2,0,153,52,2,0,154,53,2,0,107,53,2,0,0,0,0,0,171,53,2,0,0,0,0,0,20,0,0,0,111,52,2,0,0,0,0,0,0,0,0,0,181,53,2,0,107,53,2,0,165,68,2,0,171,53,2,0,0,0,0,0,22,0,0,0,111,52,2,0,165,68,2,0,0,0,0,0,203,53,2,0,107,53,2,0,165,68,2,0,171,53,2,0,145,52,2,0,23,0,0,0,111,52,2,0,165,68,2,0,153,52,2,0,232,53,2,0,107,53,2,0,0,0,0,0,171,53,2,0,145,52,2,0,21,0,0,0,111,52,2,0,0,0,0,0,153,52,2,0,1,54,2,0,107,53,2,0,0,0,0,0,0,0,0,0,145,52,2,0,17,0,0,0,111,52,2,0,0,0,0,0,153,52,2,0,19,54,2,0,41,54,2,0,165,68,2,0,0,0,0,0,0,0,0,0,26,0,0,0,231,52,2,0,165,68,2,0,0,0,0,0,62,54,2,0,41,54,2,0,165,68,2,0,0,0,0,0,153,52,2,0,27,0,0,0,231,52,2,0,165,68,2,0,153,52,2,0,90,54,2,0,41,54,2,0,0,0,0,0,0,0,0,0,153,52,2,0,25,0,0,0,231,52,2,0,0,0,0,0,153,52,2,0,114,54,2,0,41,54,2,0,137,54,2,0,0,0,0,0,0,0,0,0,24,0,0,0,231,52,2,0,0,0,0,0,0,0,0,0,143,54,2,0,157,54,2,0,165,68,2,0,0,0,0,0,0,0,0,0,30,0,0,0,231,52,2,0,165,68,2,0,0,0,0,0,175,54,2,0,157,54,2,0,165,68,2,0,0,0,0,0,153,52,2,0,31,0,0,0,231,52,2,0,165,68,2,0,153,52,2,0,195,54,2,0,157,54,2,0,0,0,0,0,0,0,0,0,153,52,2,0,29,0,0,0,231,52,2,0,0,0,0,0,153,52,2,0,211,54,2,0,157,54,2,0,137,54,2,0,0,0,0,0,0,0,0,0,28,0,0,0,231,52,2,0,0,0,0,0,0,0,0,0,226,54,2,0,226,54,2,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,233,54,2,0,0,0,0,0,0,0,0,0,241,54,2,0,252,54,2,0,165,68,2,0,0,0,0,0,0,0,0,0,2,0,0,0,231,52,2,0,165,68,2,0,0,0,0,0,2,55,2,0,252,54,2,0,165,68,2,0,0,0,0,0,153,52,2,0,3,0,0,0,231,52,2,0,165,68,2,0,153,52,2,0,19,55,2,0,252,54,2,0,0,0,0,0,0,0,0,0,153,52,2,0,1,0,0,0,231,52,2,0,0,0,0,0,153,52,2,0,193,56,2,0,252,54,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,231,52,2,0,0,0,0,0,0,0,0,0,32,55,2,0,58,55,2,0,73,55,2,0,0,0,0,0,153,52,2,0,33,0,0,0,231,52,2,0,0,0,0,0,153,52,2,0,80,55,2,0,93,55,2,0,0,0,0,0,0,0,0,0,0,0,0,0,34,0,0,0,233,54,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,12,0,0,0,42,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,58,2,0,198,0,0,0,80,58,2,0,193,0,0,0,87,58,2,0,194,0,0,0,93,58,2,0,192,0,0,0,100,58,2,0,145,3,0,0,106,58,2,0,197,0,0,0,112,58,2,0,195,0,0,0,119,58,2,0,196,0,0,0,124,58,2,0,146,3,0,0,129,58,2,0,199,0,0,0,136,58,2,0,167,3,0,0,140,58,2,0,33,32,0,0,147,58,2,0,148,3,0,0,153,58,2,0,208,0,0,0,157,58,2,0,201,0,0,0,164,58,2,0,202,0,0,0,170,58,2,0,200,0,0,0,177,58,2,0,149,3,0,0,185,58,2,0,151,3,0,0,189,58,2,0,203,0,0,0,194,58,2,0,147,3,0,0,200,58,2,0,205,0,0,0,207,58,2,0,206,0,0,0,213,58,2,0,204,0,0,0,220,58,2,0,153,3,0,0,225,58,2,0,207,0,0,0,230,58,2,0,154,3,0,0,236,58,2,0,155,3,0,0,243,58,2,0,156,3,0,0,246,58,2,0,209,0,0,0,253,58,2,0,157,3,0,0,0,59,2,0,82,1,0,0,6,59,2,0,211,0,0,0,13,59,2,0,212,0,0,0,19,59,2,0,210,0,0,0,26,59,2,0,169,3,0,0,32,59,2,0,159,3,0,0,40,59,2,0,216,0,0,0,47,59,2,0,213,0,0,0,54,59,2,0,214,0,0,0,59,59,2,0,166,3,0,0,63,59,2,0,160,3,0,0,66,59,2,0,51,32,0,0,72,59,2,0,168,3,0,0,76,59,2,0,161,3,0,0,80,59,2,0,96,1,0,0,87,59,2,0,163,3,0,0,93,59,2,0,222,0,0,0,99,59,2,0,164,3,0,0,103,59,2,0,152,3,0,0,109,59,2,0,218,0,0,0,116,59,2,0,219,0,0,0,122,59,2,0,217,0,0,0,129,59,2,0,165,3,0,0,137,59,2,0,220,0,0,0,142,59,2,0,158,3,0,0,145,59,2,0,221,0,0,0,152,59,2,0,120,1,0,0,157,59,2,0,150,3,0,0,162,59,2,0,225,0,0,0,169,59,2,0,226,0,0,0,175,59,2,0,180,0,0,0,181,59,2,0,230,0,0,0,187,59,2,0,224,0,0,0,194,59,2,0,53,33,0,0,202,59,2,0,177,3,0,0,208,59,2,0,38,0,0,0,212,59,2,0,39,34,0,0,216,59,2,0,32,34,0,0,220,59,2,0,229,0,0,0,226,59,2,0,72,34,0,0,232,59,2,0,227,0,0,0,239,59,2,0,228,0,0,0,244,59,2,0,30,32,0,0,250,59,2,0,178,3,0,0,255,59,2,0,166,0,0,0,6,60,2,0,34,32,0,0,11,60,2,0,41,34,0,0,15,60,2,0,231,0,0,0,22,60,2,0,184,0,0,0,28,60,2,0,162,0,0,0,33,60,2,0,199,3,0,0,37,60,2,0,198,2,0,0,42,60,2,0,99,38,0,0,48,60,2,0,69,34,0,0,53,60,2,0,169,0,0,0,58,60,2,0,181,33,0,0,64,60,2,0,42,34,0,0,68,60,2,0,164,0,0,0,75,60,2,0,211,33,0,0,80,60,2,0,32,32,0,0,87,60,2,0,147,33,0,0,92,60,2,0,176,0,0,0,96,60,2,0,180,3,0,0,102,60,2,0,102,38,0,0,108,60,2,0,247,0,0,0,115,60,2,0,233,0,0,0,122,60,2,0,234,0,0,0,128,60,2,0,232,0,0,0,135,60,2,0,5,34,0,0,141,60,2,0,3,32,0,0,146,60,2,0,2,32,0,0,151,60,2,0,181,3,0,0,159,60,2,0,97,34,0,0,165,60,2,0,183,3,0,0,169,60,2,0,240,0,0,0,173,60,2,0,235,0,0,0,178,60,2,0,172,32,0,0,183,60,2,0,3,34,0,0,189,60,2,0,146,1,0,0,194,60,2,0,0,34,0,0,201,60,2,0,189,0,0,0,208,60,2,0,188,0,0,0,215,60,2,0,190,0,0,0,222,60,2,0,68,32,0,0,228,60,2,0,179,3,0,0,234,60,2,0,101,34,0,0,237,60,2,0,62,0,0,0,240,60,2,0,212,33,0,0,245,60,2,0,148,33,0,0,250,60,2,0,101,38,0,0,1,61,2,0,38,32,0,0,8,61,2,0,237,0,0,0,15,61,2,0,238,0,0,0,21,61,2,0,161,0,0,0,27,61,2,0,236,0,0,0,34,61,2,0,17,33,0,0,40,61,2,0,30,34,0,0,46,61,2,0,43,34,0,0,50,61,2,0,185,3,0,0,55,61,2,0,191,0,0,0,62,61,2,0,8,34,0,0,67,61,2,0,239,0,0,0,72,61,2,0,186,3,0,0,78,61,2,0,208,33,0,0,83,61,2,0,187,3,0,0,90,61,2,0,41,35,0,0,95,61,2,0,171,0,0,0,101,61,2,0,144,33,0,0,106,61,2,0,8,35,0,0,112,61,2,0,28,32,0,0,118,61,2,0,100,34,0,0,121,61,2,0,10,35,0,0,128,61,2,0,23,34,0,0,135,61,2,0,202,37,0,0,139,61,2,0,14,32,0,0,143,61,2,0,57,32,0,0,150,61,2,0,24,32,0,0,156,61,2,0,60,0,0,0,159,61,2,0,175,0,0,0,164,61,2,0,20,32,0,0,170,61,2,0,181,0,0,0,176,61,2,0,183,0,0,0,32,70,2,0,18,34,0,0,183,61,2,0,188,3,0,0,186,61,2,0,7,34,0,0,192,61,2,0,160,0,0,0,197,61,2,0,19,32,0,0,203,61,2,0,96,34,0,0,206,61,2,0,11,34,0,0,209,61,2,0,172,0,0,0,213,61,2,0,9,34,0,0,219,61,2,0,132,34,0,0,224,61,2,0,241,0,0,0,231,61,2,0,189,3,0,0,234,61,2,0,243,0,0,0,241,61,2,0,244,0,0,0,247,61,2,0,83,1,0,0,253,61,2,0,242,0,0,0,4,62,2,0,62,32,0,0,10,62,2,0,201,3,0,0,16,62,2,0,191,3,0,0,24,62,2,0,149,34,0,0,30,62,2,0,40,34,0,0,33,62,2,0,170,0,0,0,38,62,2,0,186,0,0,0,43,62,2,0,248,0,0,0,50,62,2,0,245,0,0,0,57,62,2,0,151,34,0,0,64,62,2,0,246,0,0,0,69,62,2,0,182,0,0,0,74,62,2,0,2,34,0,0,79,62,2,0,48,32,0,0,86,62,2,0,165,34,0,0,91,62,2,0,198,3,0,0,95,62,2,0,192,3,0,0,98,62,2,0,214,3,0,0,102,62,2,0,177,0,0,0,109,62,2,0,163,0,0,0,115,62,2,0,50,32,0,0,121,62,2,0,15,34,0,0,126,62,2,0,29,34,0,0,131,62,2,0,200,3,0,0,135,62,2,0,34,0,0,0,140,62,2,0,210,33,0,0,145,62,2,0,26,34,0,0,151,62,2,0,42,35,0,0,156,62,2,0,187,0,0,0,162,62,2,0,146,33,0,0,167,62,2,0,9,35,0,0,173,62,2,0,29,32,0,0,179,62,2,0,28,33,0,0,184,62,2,0,174,0,0,0,188,62,2,0,11,35,0,0,195,62,2,0,193,3,0,0,199,62,2,0,15,32,0,0,203,62,2,0,58,32,0,0,210,62,2,0,25,32,0,0,216,62,2,0,26,32,0,0,222,62,2,0,97,1,0,0,229,62,2,0,197,34,0,0,234,62,2,0,167,0,0,0,239,62,2,0,173,0,0,0,243,62,2,0,195,3,0,0,249,62,2,0,194,3,0,0,0,63,2,0,60,34,0,0,4,63,2,0,96,38,0,0,11,63,2,0,130,34,0,0,15,63,2,0,134,34,0,0,20,63,2,0,17,34,0,0,24,63,2,0,131,34,0,0,28,63,2,0,185,0,0,0,33,63,2,0,178,0,0,0,38,63,2,0,179,0,0,0,43,63,2,0,135,34,0,0,48,63,2,0,223,0,0,0,54,63,2,0,196,3,0,0,58,63,2,0,52,34,0,0,65,63,2,0,184,3,0,0,71,63,2,0,209,3,0,0,80,63,2,0,9,32,0,0,87,63,2,0,254,0,0,0,93,63,2,0,220,2,0,0,99,63,2,0,215,0,0,0,105,63,2,0,34,33,0,0,111,63,2,0,209,33,0,0,116,63,2,0,250,0,0,0,123,63,2,0,145,33,0,0,128,63,2,0,251,0,0,0,134,63,2,0,249,0,0,0,141,63,2,0,168,0,0,0,145,63,2,0,210,3,0,0,151,63,2,0,197,3,0,0,159,63,2,0,252,0,0,0,164,63,2,0,24,33,0,0,171,63,2,0,190,3,0,0,174,63,2,0,253,0,0,0,181,63,2,0,165,0,0,0,185,63,2,0,255,0,0,0,190,63,2,0,182,3,0,0,195,63,2,0,13,32,0,0,199,63,2,0,12,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,8,0,0,0,1,1,0,0,239,65,2,0,131,65,2,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,44,0,0,0,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,45,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,194,69,2,0,203,69,2,0,210,69,2,0,0,0,0,0,0,0,0,0,224,69,2,0,9,0,0,0,226,69,2,0,10,0,0,0,231,69,2,0,10,0,0,0,239,69,2,0,11,0,0,0,245,69,2,0,11,0,0,0,254,69,2,0,12,0,0,0,1,70,2,0,12,0,0,0,7,70,2,0,13,0,0,0,12,70,2,0,13,0,0,0,20,70,2,0,14,0,0,0,25,70,2,0,14,0,0,0,32,70,2,0,15,0,0,0,38,70,2,0,15,0,0,0,50,70,2,0,16,0,0,0,14,0,0,0,89,0,0,0,46,0,0,0,47,0,0,0,16,0,0,0,48,0,0,0,90,0,0,0,49,0,0,0,17,0,0,0,50,0,0,0,166,187,2,0,87,70,2,0,78,70,2,0,69,70,2,0,65,70,2,0,120,187,2,0,61,70,2,0,92,70,2,0,112,70,2,0,106,70,2,0,97,70,2,0,8,0,0,0,4,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,134,71,2,0,85,93,201,127,201,127,255,0,145,71,2,0,187,45,212,190,174,212,255,0,156,71,2,0,20,119,253,253,192,134,255,0,167,71,2,0,85,93,201,127,201,127,255,0,178,71,2,0,187,45,212,190,174,212,255,0,189,71,2,0,20,119,253,253,192,134,255,0,200,71,2,0,42,102,255,255,255,153,255,0,211,71,2,0,85,93,201,127,201,127,255,0,222,71,2,0,187,45,212,190,174,212,255,0,233,71,2,0,20,119,253,253,192,134,255,0,244,71,2,0,42,102,255,255,255,153,255,0,255,71,2,0,151,173,176,56,108,176,255,0,10,72,2,0,85,93,201,127,201,127,255,0,21,72,2,0,187,45,212,190,174,212,255,0,32,72,2,0,20,119,253,253,192,134,255,0,43,72,2,0,42,102,255,255,255,153,255,0,54,72,2,0,151,173,176,56,108,176,255,0,65,72,2,0,232,252,240,240,2,127,255,0,76,72,2,0,85,93,201,127,201,127,255,0,87,72,2,0,187,45,212,190,174,212,255,0,98,72,2,0,20,119,253,253,192,134,255,0,109,72,2,0,42,102,255,255,255,153,255,0,120,72,2,0,151,173,176,56,108,176,255,0,131,72,2,0,232,252,240,240,2,127,255,0,142,72,2,0,17,224,191,191,91,23,255,0,153,72,2,0,85,93,201,127,201,127,255,0,164,72,2,0,187,45,212,190,174,212,255,0,175,72,2,0,20,119,253,253,192,134,255,0,186,72,2,0,42,102,255,255,255,153,255,0,197,72,2,0,151,173,176,56,108,176,255,0,208,72,2,0,232,252,240,240,2,127,255,0,219,72,2,0,17,224,191,191,91,23,255,0,230,72,2,0,0,0,102,102,102,102,255,0,241,72,2,0,147,25,247,222,235,247,255,0,251,72,2,0,142,75,225,158,202,225,255,0,5,73,2,0,145,188,189,49,130,189,255,0,15,73,2,0,159,16,255,239,243,255,255,0,25,73,2,0,143,46,231,189,215,231,255,0,35,73,2,0,143,127,214,107,174,214,255,0,45,73,2,0,147,208,181,33,113,181,255,0,55,73,2,0,159,16,255,239,243,255,255,0,65,73,2,0,143,46,231,189,215,231,255,0,75,73,2,0,143,127,214,107,174,214,255,0,85,73,2,0,145,188,189,49,130,189,255,0,95,73,2,0,149,241,156,8,81,156,255,0,105,73,2,0,159,16,255,239,243,255,255,0,115,73,2,0,148,43,239,198,219,239,255,0,125,73,2,0,142,75,225,158,202,225,255,0,135,73,2,0,143,127,214,107,174,214,255,0,145,73,2,0,145,188,189,49,130,189,255,0,155,73,2,0,149,241,156,8,81,156,255,0,165,73,2,0,159,16,255,239,243,255,255,0,175,73,2,0,148,43,239,198,219,239,255,0,185,73,2,0,142,75,225,158,202,225,255,0,195,73,2,0,143,127,214,107,174,214,255,0,205,73,2,0,144,169,198,66,146,198,255,0,215,73,2,0,147,208,181,33,113,181,255,0,225,73,2,0,151,241,148,8,69,148,255,0,235,73,2,0,148,8,255,247,251,255,255,0,245,73,2,0,147,25,247,222,235,247,255,0,255,73,2,0,148,43,239,198,219,239,255,0,9,74,2,0,142,75,225,158,202,225,255,0,19,74,2,0,143,127,214,107,174,214,255,0,29,74,2,0,144,169,198,66,146,198,255,0,39,74,2,0,147,208,181,33,113,181,255,0,49,74,2,0,151,241,148,8,69,148,255,0,59,74,2,0,148,8,255,247,251,255,255,0,69,74,2,0,147,25,247,222,235,247,255,0,79,74,2,0,148,43,239,198,219,239,255,0,89,74,2,0,142,75,225,158,202,225,255,0,99,74,2,0,143,127,214,107,174,214,255,0,109,74,2,0,144,169,198,66,146,198,255,0,119,74,2,0,147,208,181,33,113,181,255,0,129,74,2,0,149,241,156,8,81,156,255,0,139,74,2,0,152,235,107,8,48,107,255,0,149,74,2,0,23,239,84,84,48,5,255,0,159,74,2,0,119,255,60,0,60,48,255,0,170,74,2,0,23,236,140,140,81,10,255,0,180,74,2,0,24,194,191,191,129,45,255,0,190,74,2,0,29,112,223,223,194,125,255,0,200,74,2,0,30,52,246,246,232,195,255,0,210,74,2,0,121,38,234,199,234,229,255,0,220,74,2,0,120,95,205,128,205,193,255,0,230,74,2,0,124,165,151,53,151,143,255,0,240,74,2,0,124,252,102,1,102,94,255,0,250,74,2,0,23,239,84,84,48,5,255,0,4,75,2,0,124,252,102,1,102,94,255,0,15,75,2,0,119,255,60,0,60,48,255,0,26,75,2,0,23,236,140,140,81,10,255,0,36,75,2,0,24,194,191,191,129,45,255,0,46,75,2,0,29,112,223,223,194,125,255,0,56,75,2,0,30,52,246,246,232,195,255,0,66,75,2,0,0,0,245,245,245,245,255,0,76,75,2,0,121,38,234,199,234,229,255,0,86,75,2,0,120,95,205,128,205,193,255,0,96,75,2,0,124,165,151,53,151,143,255,0,106,75,2,0,28,135,216,216,179,101,255,0,115,75,2,0,0,0,245,245,245,245,255,0,124,75,2,0,123,127,180,90,180,172,255,0,133,75,2,0,21,215,166,166,97,26,255,0,142,75,2,0,29,112,223,223,194,125,255,0,151,75,2,0,120,95,205,128,205,193,255,0,160,75,2,0,121,253,133,1,133,113,255,0,169,75,2,0,21,215,166,166,97,26,255,0,178,75,2,0,29,112,223,223,194,125,255,0,187,75,2,0,0,0,245,245,245,245,255,0,196,75,2,0,120,95,205,128,205,193,255,0,205,75,2,0,121,253,133,1,133,113,255,0,214,75,2,0,23,236,140,140,81,10,255,0,223,75,2,0,28,135,216,216,179,101,255,0,232,75,2,0,30,52,246,246,232,195,255,0,241,75,2,0,121,38,234,199,234,229,255,0,250,75,2,0,123,127,180,90,180,172,255,0,3,76,2,0,124,252,102,1,102,94,255,0,12,76,2,0,23,236,140,140,81,10,255,0,21,76,2,0,28,135,216,216,179,101,255,0,30,76,2,0,30,52,246,246,232,195,255,0,39,76,2,0,0,0,245,245,245,245,255,0,48,76,2,0,121,38,234,199,234,229,255,0,57,76,2,0,123,127,180,90,180,172,255,0,66,76,2,0,124,252,102,1,102,94,255,0,75,76,2,0,23,236,140,140,81,10,255,0,84,76,2,0,24,194,191,191,129,45,255,0,93,76,2,0,29,112,223,223,194,125,255,0,102,76,2,0,30,52,246,246,232,195,255,0,111,76,2,0,121,38,234,199,234,229,255,0,120,76,2,0,120,95,205,128,205,193,255,0,129,76,2,0,124,165,151,53,151,143,255,0,138,76,2,0,124,252,102,1,102,94,255,0,147,76,2,0,23,236,140,140,81,10,255,0,156,76,2,0,24,194,191,191,129,45,255,0,165,76,2,0,29,112,223,223,194,125,255,0,174,76,2,0,30,52,246,246,232,195,255,0,183,76,2,0,0,0,245,245,245,245,255,0,192,76,2,0,121,38,234,199,234,229,255,0,201,76,2,0,120,95,205,128,205,193,255,0,210,76,2,0,124,165,151,53,151,143,255,0,219,76,2,0,124,252,102,1,102,94,255,0,228,76,2,0,135,20,249,229,245,249,255,0,237,76,2,0,117,74,216,153,216,201,255,0,246,76,2,0,103,185,162,44,162,95,255,0,255,76,2,0,136,14,251,237,248,251,255,0,8,77,2,0,127,54,226,178,226,226,255,0,17,77,2,0,113,120,194,102,194,164,255,0,26,77,2,0,98,190,139,35,139,69,255,0,35,77,2,0,136,14,251,237,248,251,255,0,44,77,2,0,127,54,226,178,226,226,255,0,53,77,2,0,113,120,194,102,194,164,255,0,62,77,2,0,103,185,162,44,162,95,255,0,71,77,2,0,102,255,109,0,109,44,255,0,80,77,2,0,136,14,251,237,248,251,255,0,89,77,2,0,119,34,236,204,236,230,255,0,98,77,2,0,117,74,216,153,216,201,255,0,107,77,2,0,113,120,194,102,194,164,255,0,116,77,2,0,103,185,162,44,162,95,255,0,125,77,2,0,102,255,109,0,109,44,255,0,134,77,2,0,136,14,251,237,248,251,255,0,143,77,2,0,119,34,236,204,236,230,255,0,152,77,2,0,117,74,216,153,216,201,255,0,161,77,2,0,113,120,194,102,194,164,255,0,170,77,2,0,105,159,174,65,174,118,255,0,179,77,2,0,98,190,139,35,139,69,255,0,188,77,2,0,102,255,88,0,88,36,255,0,197,77,2,0,134,6,253,247,252,253,255,0,206,77,2,0,135,20,249,229,245,249,255,0,215,77,2,0,119,34,236,204,236,230,255,0,224,77,2,0,117,74,216,153,216,201,255,0,233,77,2,0,113,120,194,102,194,164,255,0,242,77,2,0,105,159,174,65,174,118,255,0,251,77,2,0,98,190,139,35,139,69,255,0,4,78,2,0,102,255,88,0,88,36,255,0,13,78,2,0,134,6,253,247,252,253,255,0,22,78,2,0,135,20,249,229,245,249,255,0,31,78,2,0,119,34,236,204,236,230,255,0,40,78,2,0,117,74,216,153,216,201,255,0,49,78,2,0,113,120,194,102,194,164,255,0,58,78,2,0,105,159,174,65,174,118,255,0,67,78,2,0,98,190,139,35,139,69,255,0,76,78,2,0,102,255,109,0,109,44,255,0,85,78,2,0,101,255,68,0,68,27,255,0,94,78,2,0,144,20,244,224,236,244,255,0,103,78,2,0,148,70,218,158,188,218,255,0,112,78,2,0,196,123,167,136,86,167,255,0,121,78,2,0,136,14,251,237,248,251,255,0,130,78,2,0,146,53,227,179,205,227,255,0,139,78,2,0,162,74,198,140,150,198,255,0,148,78,2,0,202,149,157,136,65,157,255,0,157,78,2,0,136,14,251,237,248,251,255,0,166,78,2,0,146,53,227,179,205,227,255,0,175,78,2,0,162,74,198,140,150,198,255,0,184,78,2,0,196,123,167,136,86,167,255,0,193,78,2,0,214,225,129,129,15,124,255,0,202,78,2,0,136,14,251,237,248,251,255,0,211,78,2,0,148,43,230,191,211,230,255,0,220,78,2,0,148,70,218,158,188,218,255,0,229,78,2,0,162,74,198,140,150,198,255,0,238,78,2,0,196,123,167,136,86,167,255,0,247,78,2,0,214,225,129,129,15,124,255,0,0,79,2,0,136,14,251,237,248,251,255,0,9,79,2,0,148,43,230,191,211,230,255,0,18,79,2,0,148,70,218,158,188,218,255,0,27,79,2,0,162,74,198,140,150,198,255,0,36,79,2,0,190,100,177,140,107,177,255,0,45,79,2,0,202,149,157,136,65,157,255,0,54,79,2,0,213,252,110,110,1,107,255,0,63,79,2,0,134,6,253,247,252,253,255,0,72,79,2,0,144,20,244,224,236,244,255,0,81,79,2,0,148,43,230,191],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+53752);allocate([211,230,255,0,90,79,2,0,148,70,218,158,188,218,255,0,99,79,2,0,162,74,198,140,150,198,255,0,108,79,2,0,190,100,177,140,107,177,255,0,117,79,2,0,202,149,157,136,65,157,255,0,126,79,2,0,213,252,110,110,1,107,255,0,135,79,2,0,134,6,253,247,252,253,255,0,144,79,2,0,144,20,244,224,236,244,255,0,153,79,2,0,148,43,230,191,211,230,255,0,162,79,2,0,148,70,218,158,188,218,255,0,171,79,2,0,162,74,198,140,150,198,255,0,180,79,2,0,190,100,177,140,107,177,255,0,189,79,2,0,202,149,157,136,65,157,255,0,198,79,2,0,214,225,129,129,15,124,255,0,207,79,2,0,213,255,77,77,0,75,255,0,216,79,2,0,114,211,158,27,158,119,255,0,226,79,2,0,18,252,217,217,95,2,255,0,236,79,2,0,173,95,179,117,112,179,255,0,246,79,2,0,114,211,158,27,158,119,255,0,0,80,2,0,18,252,217,217,95,2,255,0,10,80,2,0,173,95,179,117,112,179,255,0,20,80,2,0,233,209,231,231,41,138,255,0,30,80,2,0,114,211,158,27,158,119,255,0,40,80,2,0,18,252,217,217,95,2,255,0,50,80,2,0,173,95,179,117,112,179,255,0,60,80,2,0,233,209,231,231,41,138,255,0,70,80,2,0,62,208,166,102,166,30,255,0,80,80,2,0,114,211,158,27,158,119,255,0,90,80,2,0,18,252,217,217,95,2,255,0,100,80,2,0,173,95,179,117,112,179,255,0,110,80,2,0,233,209,231,231,41,138,255,0,120,80,2,0,62,208,166,102,166,30,255,0,130,80,2,0,31,252,230,230,171,2,255,0,140,80,2,0,114,211,158,27,158,119,255,0,150,80,2,0,18,252,217,217,95,2,255,0,160,80,2,0,173,95,179,117,112,179,255,0,170,80,2,0,233,209,231,231,41,138,255,0,180,80,2,0,62,208,166,102,166,30,255,0,190,80,2,0,31,252,230,230,171,2,255,0,200,80,2,0,27,210,166,166,118,29,255,0,210,80,2,0,114,211,158,27,158,119,255,0,220,80,2,0,18,252,217,217,95,2,255,0,230,80,2,0,173,95,179,117,112,179,255,0,240,80,2,0,233,209,231,231,41,138,255,0,250,80,2,0,62,208,166,102,166,30,255,0,4,81,2,0,31,252,230,230,171,2,255,0,14,81,2,0,27,210,166,166,118,29,255,0,24,81,2,0,0,0,102,102,102,102,255,0,34,81,2,0,76,25,243,224,243,219,255,0,43,81,2,0,95,61,221,168,221,181,255,0,52,81,2,0,140,170,202,67,162,202,255,0,61,81,2,0,65,17,249,240,249,232,255,0,70,81,2,0,87,46,228,186,228,188,255,0,79,81,2,0,123,101,204,123,204,196,255,0,88,81,2,0,141,197,190,43,140,190,255,0,97,81,2,0,65,17,249,240,249,232,255,0,106,81,2,0,87,46,228,186,228,188,255,0,115,81,2,0,123,101,204,123,204,196,255,0,124,81,2,0,140,170,202,67,162,202,255,0,133,81,2,0,145,243,172,8,104,172,255,0,142,81,2,0,65,17,249,240,249,232,255,0,151,81,2,0,77,41,235,204,235,197,255,0,160,81,2,0,95,61,221,168,221,181,255,0,169,81,2,0,123,101,204,123,204,196,255,0,178,81,2,0,140,170,202,67,162,202,255,0,187,81,2,0,145,243,172,8,104,172,255,0,196,81,2,0,65,17,249,240,249,232,255,0,205,81,2,0,77,41,235,204,235,197,255,0,214,81,2,0,95,61,221,168,221,181,255,0,223,81,2,0,123,101,204,123,204,196,255,0,232,81,2,0,137,160,211,78,179,211,255,0,241,81,2,0,141,197,190,43,140,190,255,0,250,81,2,0,147,242,158,8,88,158,255,0,3,82,2,0,60,12,252,247,252,240,255,0,12,82,2,0,76,25,243,224,243,219,255,0,21,82,2,0,77,41,235,204,235,197,255,0,30,82,2,0,95,61,221,168,221,181,255,0,39,82,2,0,123,101,204,123,204,196,255,0,48,82,2,0,137,160,211,78,179,211,255,0,57,82,2,0,141,197,190,43,140,190,255,0,66,82,2,0,147,242,158,8,88,158,255,0,75,82,2,0,60,12,252,247,252,240,255,0,84,82,2,0,76,25,243,224,243,219,255,0,93,82,2,0,77,41,235,204,235,197,255,0,102,82,2,0,95,61,221,168,221,181,255,0,111,82,2,0,123,101,204,123,204,196,255,0,120,82,2,0,137,160,211,78,179,211,255,0,129,82,2,0,141,197,190,43,140,190,255,0,138,82,2,0,145,243,172,8,104,172,255,0,147,82,2,0,150,239,129,8,64,129,255,0,156,82,2,0,74,21,245,229,245,224,255,0,167,82,2,0,80,72,217,161,217,155,255,0,178,82,2,0,98,178,163,49,163,84,255,0,189,82,2,0,73,15,248,237,248,233,255,0,200,82,2,0,78,54,228,186,228,179,255,0,211,82,2,0,86,104,196,116,196,118,255,0,222,82,2,0,98,190,139,35,139,69,255,0,233,82,2,0,73,15,248,237,248,233,255,0,244,82,2,0,78,54,228,186,228,179,255,0,255,82,2,0,86,104,196,116,196,118,255,0,10,83,2,0,98,178,163,49,163,84,255,0,21,83,2,0,102,255,109,0,109,44,255,0,32,83,2,0,73,15,248,237,248,233,255,0,43,83,2,0,77,44,233,199,233,192,255,0,54,83,2,0,80,72,217,161,217,155,255,0,65,83,2,0,86,104,196,116,196,118,255,0,76,83,2,0,98,178,163,49,163,84,255,0,87,83,2,0,102,255,109,0,109,44,255,0,98,83,2,0,73,15,248,237,248,233,255,0,109,83,2,0,77,44,233,199,233,192,255,0,120,83,2,0,80,72,217,161,217,155,255,0,131,83,2,0,86,104,196,116,196,118,255,0,142,83,2,0,96,158,171,65,171,93,255,0,153,83,2,0,98,190,139,35,139,69,255,0,164,83,2,0,108,255,90,0,90,50,255,0,175,83,2,0,72,7,252,247,252,245,255,0,186,83,2,0,74,21,245,229,245,224,255,0,197,83,2,0,77,44,233,199,233,192,255,0,208,83,2,0,80,72,217,161,217,155,255,0,219,83,2,0,86,104,196,116,196,118,255,0,230,83,2,0,96,158,171,65,171,93,255,0,241,83,2,0,98,190,139,35,139,69,255,0,252,83,2,0,108,255,90,0,90,50,255,0,7,84,2,0,72,7,252,247,252,245,255,0,18,84,2,0,74,21,245,229,245,224,255,0,29,84,2,0,77,44,233,199,233,192,255,0,40,84,2,0,80,72,217,161,217,155,255,0,51,84,2,0,86,104,196,116,196,118,255,0,62,84,2,0,96,158,171,65,171,93,255,0,73,84,2,0,98,190,139,35,139,69,255,0,84,84,2,0,102,255,109,0,109,44,255,0,95,84,2,0,101,255,68,0,68,27,255,0,106,84,2,0,0,0,240,240,240,240,255,0,116,84,2,0,0,0,189,189,189,189,255,0,126,84,2,0,0,0,99,99,99,99,255,0,136,84,2,0,0,0,247,247,247,247,255,0,146,84,2,0,0,0,204,204,204,204,255,0,156,84,2,0,0,0,150,150,150,150,255,0,166,84,2,0,0,0,82,82,82,82,255,0,176,84,2,0,0,0,247,247,247,247,255,0,186,84,2,0,0,0,204,204,204,204,255,0,196,84,2,0,0,0,150,150,150,150,255,0,206,84,2,0,0,0,99,99,99,99,255,0,216,84,2,0,0,0,37,37,37,37,255,0,226,84,2,0,0,0,247,247,247,247,255,0,236,84,2,0,0,0,217,217,217,217,255,0,246,84,2,0,0,0,189,189,189,189,255,0,0,85,2,0,0,0,150,150,150,150,255,0,10,85,2,0,0,0,99,99,99,99,255,0,20,85,2,0,0,0,37,37,37,37,255,0,30,85,2,0,0,0,247,247,247,247,255,0,40,85,2,0,0,0,217,217,217,217,255,0,50,85,2,0,0,0,189,189,189,189,255,0,60,85,2,0,0,0,150,150,150,150,255,0,70,85,2,0,0,0,115,115,115,115,255,0,80,85,2,0,0,0,82,82,82,82,255,0,90,85,2,0,0,0,37,37,37,37,255,0,100,85,2,0,0,0,255,255,255,255,255,0,110,85,2,0,0,0,240,240,240,240,255,0,120,85,2,0,0,0,217,217,217,217,255,0,130,85,2,0,0,0,189,189,189,189,255,0,140,85,2,0,0,0,150,150,150,150,255,0,150,85,2,0,0,0,115,115,115,115,255,0,160,85,2,0,0,0,82,82,82,82,255,0,170,85,2,0,0,0,37,37,37,37,255,0,180,85,2,0,0,0,255,255,255,255,255,0,190,85,2,0,0,0,240,240,240,240,255,0,200,85,2,0,0,0,217,217,217,217,255,0,210,85,2,0,0,0,189,189,189,189,255,0,220,85,2,0,0,0,150,150,150,150,255,0,230,85,2,0,0,0,115,115,115,115,255,0,240,85,2,0,0,0,82,82,82,82,255,0,250,85,2,0,0,0,37,37,37,37,255,0,4,86,2,0,0,0,0,0,0,0,255,0,14,86,2,0,21,48,254,254,230,206,255,0,26,86,2,0,19,147,253,253,174,107,255,0,38,86,2,0,14,240,230,230,85,13,255,0,50,86,2,0,19,32,254,254,237,222,255,0,62,86,2,0,20,120,253,253,190,133,255,0,74,86,2,0,17,194,253,253,141,60,255,0,86,86,2,0,13,253,217,217,71,1,255,0,98,86,2,0,19,32,254,254,237,222,255,0,110,86,2,0,20,120,253,253,190,133,255,0,122,86,2,0,17,194,253,253,141,60,255,0,134,86,2,0,14,240,230,230,85,13,255,0,146,86,2,0,13,250,166,166,54,3,255,0,158,86,2,0,19,32,254,254,237,222,255,0,170,86,2,0,21,91,253,253,208,162,255,0,182,86,2,0,19,147,253,253,174,107,255,0,194,86,2,0,17,194,253,253,141,60,255,0,206,86,2,0,14,240,230,230,85,13,255,0,218,86,2,0,13,250,166,166,54,3,255,0,230,86,2,0,19,32,254,254,237,222,255,0,242,86,2,0,21,91,253,253,208,162,255,0,254,86,2,0,19,147,253,253,174,107,255,0,10,87,2,0,17,194,253,253,141,60,255,0,22,87,2,0,16,234,241,241,105,19,255,0,34,87,2,0,13,253,217,217,72,1,255,0,46,87,2,0,12,247,140,140,45,4,255,0,58,87,2,0,21,20,255,255,245,235,255,0,70,87,2,0,21,48,254,254,230,206,255,0,82,87,2,0,21,91,253,253,208,162,255,0,94,87,2,0,19,147,253,253,174,107,255,0,106,87,2,0,17,194,253,253,141,60,255,0,118,87,2,0,16,234,241,241,105,19,255,0,130,87,2,0,13,253,217,217,72,1,255,0,142,87,2,0,12,247,140,140,45,4,255,0,154,87,2,0,21,20,255,255,245,235,255,0,166,87,2,0,21,48,254,254,230,206,255,0,178,87,2,0,21,91,253,253,208,162,255,0,190,87,2,0,19,147,253,253,174,107,255,0,202,87,2,0,17,194,253,253,141,60,255,0,214,87,2,0,16,234,241,241,105,19,255,0,226,87,2,0,13,253,217,217,72,1,255,0,238,87,2,0,13,250,166,166,54,3,255,0,250,87,2,0,12,246,127,127,39,4,255,0,6,88,2,0,25,54,254,254,232,200,255,0,15,88,2,0,19,121,253,253,187,132,255,0,24,88,2,0,5,197,227,227,74,51,255,0,33,88,2,0,26,37,254,254,240,217,255,0,42,88,2,0,24,115,253,253,204,138,255,0,51,88,2,0,13,164,252,252,141,89,255,0,60,88,2,0,3,218,215,215,48,31,255,0,69,88,2,0,26,37,254,254,240,217,255,0,78,88,2,0,24,115,253,253,204,138,255,0,87,88,2,0,13,164,252,252,141,89,255,0,96,88,2,0,5,197,227,227,74,51,255,0,105,88,2,0,0,255,179,179,0,0,255,0,114,88,2,0,26,37,254,254,240,217,255,0,123,88,2,0,24,95,253,253,212,158,255,0,132,88,2,0,19,121,253,253,187,132,255,0,141,88,2,0,13,164,252,252,141,89,255,0,150,88,2,0,5,197,227,227,74,51,255,0,159,88,2,0,0,255,179,179,0,0,255,0,168,88,2,0,26,37,254,254,240,217,255,0,177,88,2,0,24,95,253,253,212,158,255,0,186,88,2,0,19,121,253,253,187,132,255,0,195,88,2,0,13,164,252,252,141,89,255,0,204,88,2,0,7,178,239,239,101,72,255,0,213,88,2,0,3,218,215,215,48,31,255,0,222,88,2,0,0,255,153,153,0,0,255,0,231,88,2,0,24,18,255,255,247,236,255,0,240,88,2,0,25,54,254,254,232,200,255,0,249,88,2,0,24,95,253,253,212,158,255,0,2,89,2,0,19,121,253,253,187,132,255,0,11,89,2,0,13,164,252,252,141,89,255,0,20,89,2,0,7,178,239,239,101,72,255,0,29,89,2,0,3,218,215,215,48,31,255,0,38,89,2,0,0,255,153,153,0,0,255,0,47,89,2,0,24,18,255,255,247,236,255,0,56,89,2,0,25,54,254,254,232,200,255,0,65,89,2,0,24,95,253,253,212,158,255,0,74,89,2,0,19,121,253,253,187,132,255,0,83,89,2,0,13,164,252,252,141,89,255,0,92,89,2,0,7,178,239,239,101,72,255,0,101,89,2,0,3,218,215,215,48,31,255,0,110,89,2,0,0,255,179,179,0,0,255,0,119,89,2,0,0,255,127,127,0,0,255,0,128,89,2,0,142,68,227,166,206,227,255,0,140,89,2,0,190,153,154,106,61,154,255,0,153,89,2,0,144,211,180,31,120,180,255,0,165,89,2,0,65,97,223,178,223,138,255,0,177,89,2,0,82,184,160,51,160,44,255,0,189,89,2,0,0,99,251,251,154,153,255,0,201,89,2,0,254,225,227,227,26,28,255,0,213,89,2,0,23,143,253,253,191,111,255,0,225,89,2,0,21,255,255,255,127,0,255,0,237,89,2,0,198,42,214,202,178,214,255,0,249,89,2,0,142,68,227,166,206,227,255,0,5,90,2,0,190,153,154,106,61,154,255,0,18,90,2,0,42,102,255,255,255,153,255,0,31,90,2,0,144,211,180,31,120,180,255,0,43,90,2,0,65,97,223,178,223,138,255,0,55,90,2,0,82,184,160,51,160,44,255,0,67,90,2,0,0,99,251,251,154,153,255,0,79,90,2,0,254,225,227,227,26,28,255,0,91,90,2,0,23,143,253,253,191,111,255,0,103,90,2,0,21,255,255,255,127,0,255,0,115,90,2,0,198,42,214,202,178,214,255,0,127,90,2,0,142,68,227,166,206,227,255,0,139,90,2,0,190,153,154,106,61,154,255,0,152,90,2,0,42,102,255,255,255,153,255,0,165,90,2,0,15,197,177,177,89,40,255,0,178,90,2,0,144,211,180,31,120,180,255,0,190,90,2,0,65,97,223,178,223,138,255,0,202,90,2,0,82,184,160,51,160,44,255,0,214,90,2,0,0,99,251,251,154,153,255,0,226,90,2,0,254,225,227,227,26,28,255,0,238,90,2,0,23,143,253,253,191,111,255,0,250,90,2,0,21,255,255,255,127,0,255,0,6,91,2,0,198,42,214,202,178,214,255,0,18,91,2,0,142,68,227,166,206,227,255,0,29,91,2,0,144,211,180,31,120,180,255,0,40,91,2,0,65,97,223,178,223,138,255,0,51,91,2,0,142,68,227,166,206,227,255,0,62,91,2,0,144,211,180,31,120,180,255,0,73,91,2,0,65,97,223,178,223,138,255,0,84,91,2,0,82,184,160,51,160,44,255,0,95,91,2,0,142,68,227,166,206,227,255,0,106,91,2,0,144,211,180,31,120,180,255,0,117,91,2,0,65,97,223,178,223,138,255,0,128,91,2,0,82,184,160,51,160,44,255,0,139,91,2,0,0,99,251,251,154,153,255,0,150,91,2,0,142,68,227,166,206,227,255,0,161,91,2,0,144,211,180,31,120,180,255,0,172,91,2,0,65,97,223,178,223,138,255,0,183,91,2,0,82,184,160,51,160,44,255,0,194,91,2,0,0,99,251,251,154,153,255,0,205,91,2,0,254,225,227,227,26,28,255,0,216,91,2,0,142,68,227,166,206,227,255,0,227,91,2,0,144,211,180,31,120,180,255,0,238,91,2,0,65,97,223,178,223,138,255,0,249,91,2,0,82,184,160,51,160,44,255,0,4,92,2,0,0,99,251,251,154,153,255,0,15,92,2,0,254,225,227,227,26,28,255,0,26,92,2,0,23,143,253,253,191,111,255,0,37,92,2,0,142,68,227,166,206,227,255,0,48,92,2,0,144,211,180,31,120,180,255,0,59,92,2,0,65,97,223,178,223,138,255,0,70,92,2,0,82,184,160,51,160,44,255,0,81,92,2,0,0,99,251,251,154,153,255,0,92,92,2,0,254,225,227,227,26,28,255,0,103,92,2,0,23,143,253,253,191,111,255,0,114,92,2,0,21,255,255,255,127,0,255,0,125,92,2,0,142,68,227,166,206,227,255,0,136,92,2,0,144,211,180,31,120,180,255,0,147,92,2,0,65,97,223,178,223,138,255,0,158,92,2,0,82,184,160,51,160,44,255,0,169,92,2,0,0,99,251,251,154,153,255,0,180,92,2,0,254,225,227,227,26,28,255,0,191,92,2,0,23,143,253,253,191,111,255,0,202,92,2,0,21,255,255,255,127,0,255,0,213,92,2,0,198,42,214,202,178,214,255,0,224,92,2,0,3,78,251,251,180,174,255,0,236,92,2,0,146,53,227,179,205,227,255,0,248,92,2,0,77,41,235,204,235,197,255,0,4,93,2,0,3,78,251,251,180,174,255,0,16,93,2,0,146,53,227,179,205,227,255,0,28,93,2,0,77,41,235,204,235,197,255,0,40,93,2,0,202,27,228,222,203,228,255,0,52,93,2,0,3,78,251,251,180,174,255,0,64,93,2,0,146,53,227,179,205,227,255,0,76,93,2,0,77,41,235,204,235,197,255,0,88,93,2,0,202,27,228,222,203,228,255,0,100,93,2,0,24,88,254,254,217,166,255,0,112,93,2,0,3,78,251,251,180,174,255,0,124,93,2,0,146,53,227,179,205,227,255,0,136,93,2,0,77,41,235,204,235,197,255,0,148,93,2,0,202,27,228,222,203,228,255,0,160,93,2,0,24,88,254,254,217,166,255,0,172,93,2,0,42,50,255,255,255,204,255,0,184,93,2,0,3,78,251,251,180,174,255,0,196,93,2,0,146,53,227,179,205,227,255,0,208,93,2,0,77,41,235,204,235,197,255,0,220,93,2,0,202,27,228,222,203,228,255,0,232,93,2,0,24,88,254,254,217,166,255,0,244,93,2,0,42,50,255,255,255,204,255,0,0,94,2,0,28,44,229,229,216,189,255,0,12,94,2,0,3,78,251,251,180,174,255,0,24,94,2,0,146,53,227,179,205,227,255,0,36,94,2,0,77,41,235,204,235,197,255,0,48,94,2,0,202,27,228,222,203,228,255,0,60,94,2,0,24,88,254,254,217,166,255,0,72,94,2,0,42,50,255,255,255,204,255,0,84,94,2,0,28,44,229,229,216,189,255,0,96,94,2,0,233,35,253,253,218,236,255,0,108,94,2,0,3,78,251,251,180,174,255,0,120,94,2,0,146,53,227,179,205,227,255,0,132,94,2,0,77,41,235,204,235,197,255,0,144,94,2,0,202,27,228,222,203,228,255,0,156,94,2,0,24,88,254,254,217,166,255,0,168,94,2,0,42,50,255,255,255,204,255,0,180,94,2,0,28,44,229,229,216,189,255,0,192,94,2,0,233,35,253,253,218,236,255,0,204,94,2,0,0,0,242,242,242,242,255,0,216,94,2,0,108,53,226,179,226,205,255,0,228,94,2,0,17,81,253,253,205,172,255,0,240,94,2,0,155,31,232,203,213,232,255,0,252,94,2,0,108,53,226,179,226,205,255,0,8,95,2,0,17,81,253,253,205,172,255,0,20,95,2,0,155,31,232,203,213,232,255,0,32,95,2,0,228,43,244,244,202,228,255,0,44,95,2,0,108,53,226,179,226,205,255,0,56,95,2,0,17,81,253,253,205,172,255,0,68,95,2,0,155,31,232,203,213,232,255,0,80,95,2,0,228,43,244,244,202,228,255,0,92,95,2,0,56,45,245,230,245,201,255,0,104,95,2,0,108,53,226,179,226,205,255,0,116,95,2,0,17,81,253,253,205,172,255,0,128,95,2,0,155,31,232,203,213,232,255,0,140,95,2,0,228,43,244,244,202,228,255,0,152,95,2,0,56,45,245,230,245,201,255,0,164,95,2,0,35,81,255,255,242,174,255,0,176,95,2,0,108,53,226,179,226,205,255,0,188,95,2,0,17,81,253,253,205,172,255,0,200,95,2,0,155,31,232,203,213,232,255,0,212,95,2,0,228,43,244,244,202,228,255,0,224,95,2,0,56,45,245,230,245,201,255,0,236,95,2,0,35,81,255,255,242,174,255,0,248,95,2,0,25,39,241,241,226,204,255,0,4,96,2,0,108,53,226,179,226,205,255,0,16,96,2,0,17,81,253,253,205,172,255,0,28,96,2,0,155,31,232,203,213,232,255,0,40,96,2,0,228,43,244,244,202,228,255,0,52,96,2,0,56,45,245,230,245,201,255,0,64,96,2,0,35,81,255,255,242,174,255,0,76,96,2,0,25,39,241,241,226,204,255,0,88,96,2,0,0,0,204,204,204,204,255,0,100,96,2,0,230,253,142,142,1,82,255,0,110,96,2,0,77,191,100,39,100,25,255,0,121,96,2,0,230,220,197,197,27,125,255,0,131,96,2,0,232,118,222,222,119,174,255,0,141,96,2,0,229,62,241,241,182,218,255,0,151,96,2,0,233,29,253,253,224,239,255,0,161,96,2,0,59,38,245,230,245,208,255,0,171,96,2,0,61,103,225,184,225,134,255,0,181,96,2,0,63,166,188,127,188,65,255,0,191,96,2,0,68,197,146,77,146,33,255,0,201,96,2,0,230,253,142,142,1,82,255,0,211,96,2,0,68,197,146,77,146,33,255,0,222,96,2,0,77,191,100,39,100,25,255,0,233,96,2,0,230,220,197,197,27,125,255,0,243,96,2,0,232,118,222,222,119,174,255,0,253,96,2,0,229,62,241,241,182,218,255,0,7,97,2,0,233,29,253,253,224,239,255,0,17,97,2,0,0,0,247,247,247,247,255,0,27,97,2,0,59,38,245,230,245,208,255,0,37,97,2,0,61,103,225,184,225,134,255,0,47,97,2,0,63,166,188,127,188,65,255,0,57,97,2,0,231,76,233,233,163,201,255,0,66,97,2,0,0,0,247,247,247,247,255,0,75,97,2,0,63,129,215,161,215,106,255,0,84,97,2,0,228,220,208,208,28,139,255,0,93,97,2,0,229,62,241,241,182,218,255,0,102,97,2,0,61,103,225,184,225,134,255,0,111,97,2,0,72,198,172,77,172,38,255,0,120,97,2,0,228,220,208,208,28,139,255,0,129,97,2,0,229,62,241,241,182,218,255,0,138,97,2,0,0,0,247,247,247,247,255,0,147,97,2,0,61,103,225,184,225,134,255,0,156,97,2,0,72,198,172,77,172,38,255,0,165,97,2,0,230,220,197,197,27,125,255,0,174,97,2,0,231,76,233,233,163,201,255,0,183,97,2,0,233,29,253,253,224,239,255,0,192,97,2,0,59,38,245,230,245,208,255,0,201,97,2,0,63,129,215,161,215,106,255,0,210,97,2,0,68,197,146,77,146,33,255,0,219,97,2,0,230,220,197,197,27,125,255,0,228,97,2,0,231,76,233,233,163,201,255,0,237,97,2,0,233,29,253,253,224,239,255,0,246,97,2,0,0,0,247,247,247,247,255,0,255,97,2,0,59,38,245,230,245,208,255,0,8,98,2,0,63,129,215,161,215,106,255,0,17,98,2,0,68,197,146,77,146,33,255,0,26,98,2,0,230,220,197,197,27,125,255,0,35,98,2,0,232,118,222,222,119,174,255,0,44,98,2,0,229,62,241,241,182,218,255,0,53,98,2,0,233,29,253,253,224,239,255,0,62,98,2,0,59,38,245,230,245,208,255,0,71,98,2,0,61,103,225,184,225,134,255,0,80,98,2,0,63,166,188,127,188,65,255,0,89,98,2,0,68,197,146,77,146,33,255,0,98,98,2,0,230,220,197,197,27,125,255,0,107,98,2,0,232,118,222,222,119,174,255,0,116,98,2,0,229,62,241,241,182,218,255,0,125,98,2,0,233,29,253,253,224,239,255,0,134,98,2,0,0,0,247,247,247,247,255,0,143,98,2,0,59,38,245,230,245,208,255,0,152,98,2,0,61,103,225,184,225,134,255,0,161,98,2,0,63,166,188,127,188,65,255,0,170,98,2,0,68,197,146,77,146,33,255,0,179,98,2,0,206,255,75,64,0,75,255,0,189,98,2,0,101,255,68,0,68,27,255,0,200,98,2,0,206,173,131,118,42,131,255,0,210,98,2,0,199,87,171,153,112,171,255,0,220,98,2,0,199,51,207,194,165,207,255,0,230,98,2,0,210,21,232,231,212,232,255,0,240,98,2,0,76,30,240,217,240,211,255,0,250,98,2,0,80,68,219,166,219,160,255,0,4,99,2,0,88,123,174,90,174,97,255,0,14,99,2,0,97,197,120,27,120,55,255,0,24,99,2,0,206,255,75,64,0,75,255,0,34,99,2,0,97,197,120,27,120,55,255,0,45,99,2,0,101,255,68,0,68,27,255,0,56,99,2,0,206,173,131,118,42,131,255,0,66,99,2,0,199,87,171,153,112,171,255,0,76,99,2,0,199,51,207,194,165,207,255,0,86,99,2,0,210,21,232,231,212,232,255,0,96,99,2,0,0,0,247,247,247,247,255,0,106,99,2,0,76,30,240,217,240,211,255,0,116,99,2,0,80,68,219,166,219,160,255,0,126,99,2,0,88,123,174,90,174,97,255,0,136,99,2,0,196,70,195,175,141,195,255,0,145,99,2,0,0,0,247,247,247,247,255,0,154,99,2,0,82,90,191,127,191,123,255,0,163,99,2,0,201,168,148,123,50,148,255,0,172,99,2,0,199,51,207,194,165,207,255,0,181,99,2,0,80,68,219,166,219,160,255,0,190,99,2,0,102,255,136,0,136,55,255,0,199,99,2,0,201,168,148,123,50,148,255,0,208,99,2,0,199,51,207,194,165,207,255,0,217,99,2,0,0,0,247,247,247,247,255,0,226,99,2,0,80,68,219,166,219,160,255,0,235,99,2,0,102,255,136,0,136,55,255,0,244,99,2,0,206,173,131,118,42,131,255,0,253,99,2,0,196,70,195,175,141,195,255,0,6,100,2,0,210,21,232,231,212,232,255,0,15,100,2,0,76,30,240,217,240,211,255,0,24,100,2,0,82,90,191,127,191,123,255,0,33,100,2,0,97,197,120,27,120,55,255,0,42,100,2,0,206,173,131,118,42,131,255,0,51,100,2,0,196,70,195,175,141,195,255,0,60,100,2,0,210,21,232,231,212,232,255,0,69,100,2,0,0,0,247,247,247,247,255,0,78,100,2,0,76,30,240,217,240,211,255,0,87,100,2,0,82,90,191,127,191,123,255,0,96,100,2,0,97,197,120,27,120,55,255,0,105,100,2,0,206,173,131,118,42,131,255,0,114,100,2,0,199,87,171,153,112,171,255,0,123,100,2,0,199,51,207,194,165,207,255,0,132,100,2,0,210,21,232,231,212,232,255,0,141,100,2,0,76,30,240,217,240,211,255,0,150,100,2,0,80,68,219,166,219,160,255,0,159,100,2,0,88,123,174,90,174,97,255,0,168,100,2,0,97,197,120,27,120,55,255,0,177,100,2,0,206,173,131,118,42,131,255,0,186,100,2,0,199,87,171,153,112,171,255,0,195,100,2,0,199,51,207,194,165,207,255,0,204,100,2,0,210,21,232,231,212,232,255,0,213,100,2,0,0,0,247,247,247,247,255,0,222,100,2,0,76,30,240,217,240,211,255,0,231,100,2,0,80,68,219,166,219,160,255,0,240,100,2,0,88,123,174,90,174,97,255,0,249,100,2,0,97,197,120,27,120,55,255,0,2,101,2,0,189,11,242,236,231,242,255,0,11,101,2,0,151,61,219,166,189,219,255,0,20,101,2,0,141,197,190,43,140,190,255,0,29,101,2,0,185,8,246,241,238,246,255,0,38,101,2,0,155,40,225,189,201,225,255,0,47,101,2,0,145,112,207,116,169,207,255,0,56,101,2,0,143,247,176,5,112,176,255,0,65,101,2,0,185,8,246,241,238,246,255,0,74,101,2,0,155,40,225,189,201,225,255,0,83,101,2,0,145,112,207,116,169,207,255,0,92,101,2,0,141,197,190,43,140,190,255,0,101,101,2,0,143,247,141,4,90,141,255,0,110,101,2,0,185,8,246,241,238,246,255,0,119,101,2,0,168,24,230,208,209,230,255,0,128,101,2,0,151,61,219,166,189,219,255,0,137,101,2,0,145,112,207,116,169,207,255,0,146,101,2,0,141,197,190,43,140,190,255,0,155,101,2,0,143,247,141,4,90,141,255,0,164,101,2,0,185,8,246,241,238,246,255,0,173,101,2,0,168,24,230,208,209,230,255,0,182,101,2,0,151,61,219,166,189,219,255,0,191,101,2,0,145,112,207,116,169,207,255,0,200,101,2,0,142,183,192,54,144,192,255,0,209,101,2,0,143,247,176,5,112,176,255,0,218,101,2,0,143,248,123,3,78,123,255,0,227,101,2,0,233,8,255,255,247,251,255,0,236,101,2,0,189,11,242,236,231,242,255,0,245,101,2,0,168,24,230,208,209,230,255,0,254,101,2,0,151,61,219,166,189,219,255,0,7,102,2,0,145,112,207,116,169,207,255,0,16,102,2,0,142,183,192,54,144,192,255,0,25,102,2,0,143,247,176,5,112,176,255,0,34,102,2,0,143,248,123,3,78,123,255,0,43,102,2,0,233,8,255,255,247,251,255,0,52,102,2,0,189,11,242,236,231,242,255,0,61,102,2,0,168,24,230,208,209,230,255,0,70,102,2,0,151,61,219,166,189,219,255,0,79,102,2,0,145,112,207,116,169,207,255,0,88,102,2,0,142,183,192,54,144,192,255,0,97,102,2,0,143,247,176,5,112,176,255,0,106,102,2,0,143,247,141,4,90,141,255,0,115,102,2,0,143,249,88,2,56,88,255,0,124,102,2,0,200,14,240,236,226,240,255,0,135,102,2,0,151,61,219,166,189,219,255,0,146,102,2,0,130,208,153,28,144,153,255,0,157,102,2,0,207,8,247,246,239,247,255,0,168,102,2,0,155,40,225,189,201,225,255,0,179,102,2,0,143,128,207,103,169,207,255,0,190,102,2,0,130,251,138,2,129,138,255,0,201,102,2,0,207,8,247,246,239,247,255,0,212,102,2,0,155,40,225,189,201,225,255,0,223,102,2,0,143,128,207,103,169,207,255,0,234,102,2,0,130,208,153,28,144,153,255,0,245,102,2,0,119,252,108,1,108,89,255,0,0,103,2,0,207,8,247,246,239,247,255,0,11,103,2,0,168,24,230,208,209,230,255,0,22,103,2,0,151,61,219,166,189,219,255,0,33,103,2,0,143,128,207,103,169,207,255,0,44,103,2,0,130,208,153,28,144,153,255,0,55,103,2,0,119,252,108,1,108,89,255,0,66,103,2,0,207,8,247,246,239,247,255,0,77,103,2,0,168,24,230,208,209,230,255,0,88,103,2,0,151,61,219,166,189,219,255,0,99,103,2,0,143,128,207,103,169,207,255,0,110,103,2,0,142,183,192,54,144,192,255,0,121,103,2,0,130,251,138,2,129,138,255,0,132,103,2,0,118,252,100,1,100,80,255,0,143,103,2,0,233,8,255,255,247,251,255,0,154,103,2,0,200,14,240,236,226,240,255,0,165,103,2,0,168,24,230,208,209,230,255,0,176,103,2,0,151,61,219,166,189,219,255,0,187,103,2,0,143,128,207,103,169,207,255,0,198,103,2,0,142,183,192,54,144,192,255,0,209,103,2,0,130,251,138,2,129,138,255,0,220,103,2,0,118,252,100,1,100,80,255,0,231,103,2,0,233,8,255,255,247,251,255,0,242,103,2,0,200,14,240,236,226,240,255,0,253,103,2,0,168,24,230,208,209,230,255,0,8,104,2,0,151,61,219,166,189,219,255,0,19,104,2,0,143,128,207,103,169,207,255,0,30,104,2,0,142,183,192,54,144,192,255,0,41,104,2,0,130,251,138,2,129,138,255,0,52,104,2,0,119,252,108,1,108,89,255,0,63,104,2,0,117,251,70,1,70,54,255,0,74,104,2,0,18,238,127,127,59,8,255,0,84,104,2,0,195,255,75,45,0,75,255,0,95,104,2,0,20,246,179,179,88,6,255,0,105,104,2,0,22,232,224,224,130,20,255,0,115,104,2,0,23,155,253,253,184,99,255,0,125,104,2,0,24,72,254,254,224,182,255,0,135,104,2,0,165,20,235,216,218,235,255,0,145,104,2,0,177,47,210,178,171,210,255,0,155,104,2,0,179,84,172,128,115,172,255,0,165,104,2,0,189,181,136,84,39,136,255,0,175,104,2,0,18,238,127,127,59,8,255,0,185,104,2,0,189,181,136,84,39,136,255,0,196,104,2,0,195,255,75,45,0,75,255,0,207,104,2,0,20,246,179,179,88,6,255,0,217,104,2,0,22,232,224,224,130,20,255,0,227,104,2,0,23,155,253,253,184,99,255,0,237,104,2,0,24,72,254,254,224,182,255,0,247,104,2,0,0,0,247,247,247,247,255,0,1,105,2,0,165,20,235,216,218,235,255,0,11,105,2,0,177,47,210,178,171,210,255,0,21,105,2,0,179,84,172,128,115,172,255,0,31,105,2,0,23,187,241,241,163,64,255,0,40,105,2,0,0,0,247,247,247,247,255,0,49,105,2,0,178,69,195,153,142,195,255,0,58,105,2,0,17,253,230,230,97,1,255,0,67,105,2,0,23,155,253,253,184,99,255,0,76,105,2,0,177,47,210,178,171,210,255,0,85,105,2,0,185,155,153,94,60,153,255,0,94,105,2,0,17,253,230,230,97,1,255,0,103,105,2,0,23,155,253,253,184,99,255,0,112,105,2,0,0,0,247,247,247,247,255,0,121,105,2,0,177,47,210,178,171,210,255,0,130,105,2,0,185,155,153,94,60,153,255,0,139,105,2,0,20,246,179,179,88,6,255,0,148,105,2,0,23,187,241,241,163,64,255,0,157,105,2,0,24,72,254,254,224,182,255,0,166,105,2,0,165,20,235,216,218,235,255,0,175,105,2,0,178,69,195,153,142,195,255,0,184,105,2,0,189,181,136,84,39,136,255,0,193,105,2,0,20,246,179,179,88,6,255,0,202,105,2,0,23,187,241,241,163,64,255,0,211,105,2,0,24,72,254,254,224,182,255,0,220,105,2,0,0,0,247,247,247,247,255,0,229,105,2,0,165,20,235,216,218,235,255,0,238,105,2,0,178,69,195,153,142,195,255,0,247,105,2,0,189,181,136,84,39,136,255,0,0,106,2,0,20,246,179,179,88,6,255,0,9,106,2,0,22,232,224,224,130,20,255,0,18,106,2,0,23,155,253,253,184,99,255,0,27,106,2,0,24,72,254,254,224,182,255,0,36,106,2,0,165,20,235,216,218,235,255,0,45,106,2,0,177,47,210,178,171,210,255,0,54,106,2,0,179,84,172,128,115,172,255,0,63,106,2,0,189,181,136,84,39,136,255,0,72,106,2,0,20,246,179,179,88,6,255,0,81,106,2,0,22,232,224,224,130,20,255,0,90,106,2,0,23,155,253,253,184,99,255,0,99,106,2,0,24,72,254,254,224,182,255,0,108,106,2,0,0,0,247,247,247,247,255,0,117,106,2,0,165,20,235,216,218,235,255,0,126,106,2,0,177,47,210,178,171,210,255,0,135,106,2,0,179,84,172,128,115,172,255,0,144,106,2,0,189,181,136,84,39,136,255,0,153,106,2,0,188,14,239,231,225,239,255,0,162,106,2,0,214,67,201,201,148,199,255,0,171,106,2,0,234,222,221,221,28,119,255,0,180,106,2,0,185,8,246,241,238,246,255,0,189,106,2,0,211,41,216,215,181,216,255,0,198,106,2,0,228,139,223,223,101,176,255,0,207,106,2,0,239,232,206,206,18,86,255,0,216,106,2,0,185,8,246,241,238,246,255,0,225,106,2,0,211,41,216,215,181,216,255,0,234,106,2,0,228,139,223,223,101,176,255,0,243,106,2,0,234,222,221,221,28,119,255,0,252,106,2,0,236,255,152,152,0,67,255,0,5,107,2,0,185,8,246,241,238,246,255,0,14,107,2,0,204,38,218,212,185,218,255,0,23,107,2,0,214,67,201,201,148,199,255,0,32,107,2,0,228,139,223,223,101,176,255,0,41,107,2,0,234,222,221,221,28,119,255,0,50,107,2,0,236,255,152,152,0,67,255,0,59,107,2,0,185,8,246,241,238,246,255,0,68,107,2,0,204,38,218,212,185,218,255,0,77,107,2,0,214,67,201,201,148,199,255,0,86,107,2,0,228,139,223,223,101,176,255,0,95,107,2,0,233,209,231,231,41,138,255,0,104,107,2,0,239,232,206,206,18,86,255,0,113,107,2,0,236,255,145,145,0,63,255,0,122,107,2,0,195,5,249,247,244,249,255,0,131,107,2,0,188,14,239,231,225,239,255,0,140,107,2,0,204,38,218,212,185,218,255,0,149,107,2,0,214,67,201,201,148,199,255,0,158,107,2,0,228,139,223,223,101,176,255,0,167,107,2,0,233,209,231,231,41,138,255,0,176,107,2,0,239,232,206,206,18,86,255,0,185,107,2,0,236,255,145,145,0,63,255,0,194,107,2,0,195,5,249,247,244,249,255,0,203,107,2,0,188,14,239,231,225,239,255,0,212,107,2,0,204,38,218,212,185,218,255,0,221,107,2,0,214,67,201,201,148,199,255,0,230,107,2,0,228,139,223,223,101,176,255,0,239,107,2,0,233,209,231,231,41,138,255,0,248,107,2,0,239,232,206,206,18,86,255,0,1,108,2,0,236,255,152,152,0,67,255,0,10,108,2,0,242,255,103,103,0,31,255,0,19,108,2,0,180,8,245,239,237,245,255,0,31,108,2,0,168,37,220,188,189,220,255,0,43,108,2,0,176,100,177,117,107,177,255,0,55,108,2,0,182,7,247,242,240,247,255,0,67,108,2,0,173,28,226,203,201,226,255,0,79,108,2,0,173,58,200,158,154,200,255,0,91,108,2,0,182,128,163,106,81,163,255,0,103,108,2,0,182,7,247,242,240,247,255,0,115,108,2,0,173,28,226,203,201,226,255,0,127,108,2,0,173,58,200,158,154,200,255,0,139,108,2,0,176,100,177,117,107,177,255,0,151,108,2,0,188,185,143,84,39,143,255,0,163,108,2,0,182,7,247,242,240,247,255,0,175,108,2,0,170,18,235,218,218,235,255,0,187,108,2,0,168,37,220,188,189,220,255,0,199,108,2,0,173,58,200,158,154,200,255,0,211,108,2,0,176,100,177,117,107,177,255,0,223,108,2,0,188,185,143,84,39,143,255,0,235,108,2,0,182,7,247,242,240,247,255,0,247,108,2,0,170,18,235,218,218,235,255,0,3,109,2,0,168,37,220,188,189,220,255,0,15,109,2,0,173,58,200,158,154,200,255,0,27,109,2,0,172,83,186,128,125,186,255,0,39,109,2,0,182,128,163,106,81,163,255,0,51,109,2,0,190,216,134,74,20,134,255,0,63,109,2,0,191,2,253,252,251,253,255,0,75,109,2,0,180,8,245,239,237,245,255,0,87,109,2,0,170,18,235,218,218,235,255,0,99,109,2,0,168,37,220,188,189,220,255,0,111,109,2,0,173,58,200,158,154,200,255,0,123,109,2,0,172,83,186,128,125,186,255,0,135,109,2,0,182,128,163,106,81,163,255,0,147,109,2,0,190,216,134,74,20,134,255,0,159,109,2,0,191,2,253,252,251,253,255,0,171,109,2,0,180,8,245,239,237,245,255,0,183,109,2,0,170,18,235,218,218,235,255,0,195,109,2,0,168,37,220,188,189,220,255,0,207,109,2,0,173,58,200,158,154,200,255,0,219,109,2,0,172,83,186,128,125,186,255,0,231,109,2,0,182,128,163,106,81,163,255,0,243,109,2,0,188,185,143,84,39,143,255,0,255,109,2,0,191,255,125,63,0,125,255,0,11,110,2,0,242,255,103,103,0,31,255,0,21,110,2,0,150,241,97,5,48,97,255,0,32,110,2,0,249,220,178,178,24,43,255,0,42,110,2,0,5,163,214,214,96,77,255,0,52,110,2,0,13,119,244,244,165,130,255,0,62,110,2,0,15,54,253,253,219,199,255,0,72,110,2,0,142,32,240,209,229,240,255,0,82,110,2,0,141,87,222,146,197,222,255,0,92,110,2,0,143,167,195,67,147,195,255,0,102,110,2,0,148,206,172,33,102,172,255,0,112,110,2,0,242,255,103,103,0,31,255,0,122,110,2,0,148,206,172,33,102,172,255,0,133,110,2,0,150,241,97,5,48,97,255,0,144,110,2,0,249,220,178,178,24,43,255,0,154,110,2,0,5,163,214,214,96,77,255,0,164,110,2,0,13,119,244,244,165,130,255,0,174,110,2,0,15,54,253,253,219,199,255,0,184,110,2,0,0,0,247,247,247,247,255,0,194,110,2,0,142,32,240,209,229,240,255,0,204,110,2,0,141,87,222,146,197,222,255,0,214,110,2,0,143,167,195,67,147,195,255,0,224,110,2,0,12,150,239,239,138,98,255,0,233,110,2,0,0,0,247,247,247,247,255,0,242,110,2,0,143,128,207,103,169,207,255,0,251,110,2,0,248,255,202,202,0,32,255,0,4,111,2,0,13,119,244,244,165,130,255,0,13,111,2,0,141,87,222,146,197,222,255,0,22,111,2,0,143,247,176,5,113,176,255,0,31,111,2,0,248,255,202,202,0,32,255,0,40,111,2,0,13,119,244,244,165,130,255,0,49,111,2,0,0,0,247,247,247,247,255,0,58,111,2,0,141,87,222,146,197,222,255,0,67,111,2,0,143,247,176,5,113,176,255,0,76,111,2,0,249,220,178,178,24,43,255,0,85,111,2,0,12,150,239,239,138,98,255,0,94,111,2,0,15,54,253,253,219,199,255,0,103,111,2,0,142,32,240,209,229,240,255,0,112,111,2,0,143,128,207,103,169,207,255,0,121,111,2,0,148,206,172,33,102,172,255,0,130,111,2,0,249,220,178,178,24,43,255,0,139,111,2,0,12,150,239,239,138,98,255,0,148,111,2,0,15,54,253,253,219,199,255,0,157,111,2,0,0,0,247,247,247,247,255,0,166,111,2,0,142,32,240,209,229,240,255,0,175,111,2,0,143,128,207,103,169,207,255,0,184,111,2,0,148,206,172,33,102,172,255,0,193,111,2,0,249,220,178,178,24,43,255,0,202,111,2,0,5,163,214,214,96,77,255,0,211,111,2,0,13,119,244,244,165,130,255,0,220,111,2,0,15,54,253,253,219,199,255,0,229,111,2,0,142,32,240,209,229,240,255,0,238,111,2,0,141,87,222,146,197,222,255,0,247,111,2,0,143,167,195,67,147,195,255,0,0,112,2,0,148,206,172,33,102,172,255,0,9,112,2,0,249,220,178,178,24,43,255,0,18,112,2,0,5,163,214,214,96,77,255,0,27,112,2,0,13,119,244,244,165,130,255,0,36,112,2,0,15,54,253,253,219,199,255,0,45,112,2,0,0,0,247,247,247,247,255,0,54,112,2,0,142,32,240,209,229,240,255,0,63,112,2,0,141,87,222,146,197,222,255,0,72,112,2,0,143,167,195,67,147,195,255,0,81,112,2,0,148,206,172,33,102,172,255,0,90,112,2,0,242,255,103,103,0,31,255,0,100,112,2,0,0,0,26,26,26,26,255,0,111,112,2,0,249,220,178,178,24,43,255,0,121,112,2,0,5,163,214,214,96,77,255,0,131,112,2,0,13,119,244,244,165,130,255,0,141,112,2,0,15,54,253,253,219,199,255,0,151,112,2,0,0,0,224,224,224,224,255,0,161,112,2,0,0,0,186,186,186,186,255,0,171,112,2,0,0,0,135,135,135,135,255,0,181,112,2,0,0,0,77,77,77,77,255,0,191,112,2,0,242,255,103,103,0,31,255,0,201,112,2,0,0,0,77,77,77,77,255,0,212,112,2,0,0,0,26,26,26,26,255,0,223,112,2,0,249,220,178,178,24,43,255,0,233,112,2,0,5,163,214,214,96,77,255,0,243,112,2,0,13,119,244,244,165,130,255,0,253,112,2,0,15,54,253,253,219,199,255,0,7,113,2,0,0,0,255,255,255,255,255,0,17,113,2,0,0,0,224,224,224,224,255,0,27,113,2,0,0,0,186,186,186,186,255,0,37,113,2,0,0,0,135,135,135,135,255,0,47,113,2,0,12,150,239,239,138,98,255,0,56,113,2,0,0,0,255,255,255,255,255,0,65,113,2,0,0,0,153,153,153,153,255,0,74,113,2,0,248,255,202,202,0,32,255,0,83,113,2,0,13,119,244,244,165,130,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+63992);allocate([92,113,2,0,0,0,186,186,186,186,255,0,101,113,2,0,0,0,64,64,64,64,255,0,110,113,2,0,248,255,202,202,0,32,255,0,119,113,2,0,13,119,244,244,165,130,255,0,128,113,2,0,0,0,255,255,255,255,255,0,137,113,2,0,0,0,186,186,186,186,255,0,146,113,2,0,0,0,64,64,64,64,255,0,155,113,2,0,249,220,178,178,24,43,255,0,164,113,2,0,12,150,239,239,138,98,255,0,173,113,2,0,15,54,253,253,219,199,255,0,182,113,2,0,0,0,224,224,224,224,255,0,191,113,2,0,0,0,153,153,153,153,255,0,200,113,2,0,0,0,77,77,77,77,255,0,209,113,2,0,249,220,178,178,24,43,255,0,218,113,2,0,12,150,239,239,138,98,255,0,227,113,2,0,15,54,253,253,219,199,255,0,236,113,2,0,0,0,255,255,255,255,255,0,245,113,2,0,0,0,224,224,224,224,255,0,254,113,2,0,0,0,153,153,153,153,255,0,7,114,2,0,0,0,77,77,77,77,255,0,16,114,2,0,249,220,178,178,24,43,255,0,25,114,2,0,5,163,214,214,96,77,255,0,34,114,2,0,13,119,244,244,165,130,255,0,43,114,2,0,15,54,253,253,219,199,255,0,52,114,2,0,0,0,224,224,224,224,255,0,61,114,2,0,0,0,186,186,186,186,255,0,70,114,2,0,0,0,135,135,135,135,255,0,79,114,2,0,0,0,77,77,77,77,255,0,88,114,2,0,249,220,178,178,24,43,255,0,97,114,2,0,5,163,214,214,96,77,255,0,106,114,2,0,13,119,244,244,165,130,255,0,115,114,2,0,15,54,253,253,219,199,255,0,124,114,2,0,0,0,255,255,255,255,255,0,133,114,2,0,0,0,224,224,224,224,255,0,142,114,2,0,0,0,186,186,186,186,255,0,151,114,2,0,0,0,135,135,135,135,255,0,160,114,2,0,0,0,77,77,77,77,255,0,169,114,2,0,3,32,253,253,224,221,255,0,178,114,2,0,244,92,250,250,159,181,255,0,187,114,2,0,227,220,197,197,27,138,255,0,196,114,2,0,13,28,254,254,235,226,255,0,205,114,2,0,252,72,251,251,180,185,255,0,214,114,2,0,238,147,247,247,104,161,255,0,223,114,2,0,224,253,174,174,1,126,255,0,232,114,2,0,13,28,254,254,235,226,255,0,241,114,2,0,252,72,251,251,180,185,255,0,250,114,2,0,238,147,247,247,104,161,255,0,3,115,2,0,227,220,197,197,27,138,255,0,12,115,2,0,213,252,122,122,1,119,255,0,21,115,2,0,13,28,254,254,235,226,255,0,30,115,2,0,3,60,252,252,197,192,255,0,39,115,2,0,244,92,250,250,159,181,255,0,48,115,2,0,238,147,247,247,104,161,255,0,57,115,2,0,227,220,197,197,27,138,255,0,66,115,2,0,213,252,122,122,1,119,255,0,75,115,2,0,13,28,254,254,235,226,255,0,84,115,2,0,3,60,252,252,197,192,255,0,93,115,2,0,244,92,250,250,159,181,255,0,102,115,2,0,238,147,247,247,104,161,255,0,111,115,2,0,230,195,221,221,52,151,255,0,120,115,2,0,224,253,174,174,1,126,255,0,129,115,2,0,213,252,122,122,1,119,255,0,138,115,2,0,14,12,255,255,247,243,255,0,147,115,2,0,3,32,253,253,224,221,255,0,156,115,2,0,3,60,252,252,197,192,255,0,165,115,2,0,244,92,250,250,159,181,255,0,174,115,2,0,238,147,247,247,104,161,255,0,183,115,2,0,230,195,221,221,52,151,255,0,192,115,2,0,224,253,174,174,1,126,255,0,201,115,2,0,213,252,122,122,1,119,255,0,210,115,2,0,14,12,255,255,247,243,255,0,219,115,2,0,3,32,253,253,224,221,255,0,228,115,2,0,3,60,252,252,197,192,255,0,237,115,2,0,244,92,250,250,159,181,255,0,246,115,2,0,238,147,247,247,104,161,255,0,255,115,2,0,230,195,221,221,52,151,255,0,8,116,2,0,224,253,174,174,1,126,255,0,17,116,2,0,213,252,122,122,1,119,255,0,26,116,2,0,199,255,106,73,0,106,255,0,35,116,2,0,245,255,165,165,0,38,255,0,47,116,2,0,167,171,149,49,54,149,255,0,60,116,2,0,2,208,215,215,48,39,255,0,72,116,2,0,10,184,244,244,109,67,255,0,84,116,2,0,20,157,253,253,174,97,255,0,96,116,2,0,30,110,254,254,224,144,255,0,108,116,2,0,136,24,248,224,243,248,255,0,120,116,2,0,138,67,233,171,217,233,255,0,132,116,2,0,143,113,209,116,173,209,255,0,144,116,2,0,151,157,180,69,117,180,255,0,156,116,2,0,245,255,165,165,0,38,255,0,168,116,2,0,151,157,180,69,117,180,255,0,181,116,2,0,167,171,149,49,54,149,255,0,194,116,2,0,2,208,215,215,48,39,255,0,206,116,2,0,10,184,244,244,109,67,255,0,218,116,2,0,20,157,253,253,174,97,255,0,230,116,2,0,30,110,254,254,224,144,255,0,242,116,2,0,42,64,255,255,255,191,255,0,254,116,2,0,136,24,248,224,243,248,255,0,10,117,2,0,138,67,233,171,217,233,255,0,22,117,2,0,143,113,209,116,173,209,255,0,34,117,2,0,13,164,252,252,141,89,255,0,45,117,2,0,42,64,255,255,255,191,255,0,56,117,2,0,143,86,219,145,191,219,255,0,67,117,2,0,254,225,215,215,25,28,255,0,78,117,2,0,20,157,253,253,174,97,255,0,89,117,2,0,138,67,233,171,217,233,255,0,100,117,2,0,145,193,182,44,123,182,255,0,111,117,2,0,254,225,215,215,25,28,255,0,122,117,2,0,20,157,253,253,174,97,255,0,133,117,2,0,42,64,255,255,255,191,255,0,144,117,2,0,138,67,233,171,217,233,255,0,155,117,2,0,145,193,182,44,123,182,255,0,166,117,2,0,2,208,215,215,48,39,255,0,177,117,2,0,13,164,252,252,141,89,255,0,188,117,2,0,30,110,254,254,224,144,255,0,199,117,2,0,136,24,248,224,243,248,255,0,210,117,2,0,143,86,219,145,191,219,255,0,221,117,2,0,151,157,180,69,117,180,255,0,232,117,2,0,2,208,215,215,48,39,255,0,243,117,2,0,13,164,252,252,141,89,255,0,254,117,2,0,30,110,254,254,224,144,255,0,9,118,2,0,42,64,255,255,255,191,255,0,20,118,2,0,136,24,248,224,243,248,255,0,31,118,2,0,143,86,219,145,191,219,255,0,42,118,2,0,151,157,180,69,117,180,255,0,53,118,2,0,2,208,215,215,48,39,255,0,64,118,2,0,10,184,244,244,109,67,255,0,75,118,2,0,20,157,253,253,174,97,255,0,86,118,2,0,30,110,254,254,224,144,255,0,97,118,2,0,136,24,248,224,243,248,255,0,108,118,2,0,138,67,233,171,217,233,255,0,119,118,2,0,143,113,209,116,173,209,255,0,130,118,2,0,151,157,180,69,117,180,255,0,141,118,2,0,2,208,215,215,48,39,255,0,152,118,2,0,10,184,244,244,109,67,255,0,163,118,2,0,20,157,253,253,174,97,255,0,174,118,2,0,30,110,254,254,224,144,255,0,185,118,2,0,42,64,255,255,255,191,255,0,196,118,2,0,136,24,248,224,243,248,255,0,207,118,2,0,138,67,233,171,217,233,255,0,218,118,2,0,143,113,209,116,173,209,255,0,229,118,2,0,151,157,180,69,117,180,255,0,240,118,2,0,245,255,165,165,0,38,255,0,252,118,2,0,107,255,104,0,104,55,255,0,9,119,2,0,2,208,215,215,48,39,255,0,21,119,2,0,10,184,244,244,109,67,255,0,33,119,2,0,20,157,253,253,174,97,255,0,45,119,2,0,31,115,254,254,224,139,255,0,57,119,2,0,51,106,239,217,239,139,255,0,69,119,2,0,62,130,217,166,217,106,255,0,81,119,2,0,83,121,189,102,189,99,255,0,93,119,2,0,103,211,152,26,152,80,255,0,105,119,2,0,245,255,165,165,0,38,255,0,117,119,2,0,103,211,152,26,152,80,255,0,130,119,2,0,107,255,104,0,104,55,255,0,143,119,2,0,2,208,215,215,48,39,255,0,155,119,2,0,10,184,244,244,109,67,255,0,167,119,2,0,20,157,253,253,174,97,255,0,179,119,2,0,31,115,254,254,224,139,255,0,191,119,2,0,42,64,255,255,255,191,255,0,203,119,2,0,51,106,239,217,239,139,255,0,215,119,2,0,62,130,217,166,217,106,255,0,227,119,2,0,83,121,189,102,189,99,255,0,239,119,2,0,13,164,252,252,141,89,255,0,250,119,2,0,42,64,255,255,255,191,255,0,5,120,2,0,66,136,207,145,207,96,255,0,16,120,2,0,254,225,215,215,25,28,255,0,27,120,2,0,20,157,253,253,174,97,255,0,38,120,2,0,62,130,217,166,217,106,255,0,49,120,2,0,98,210,150,26,150,65,255,0,60,120,2,0,254,225,215,215,25,28,255,0,71,120,2,0,20,157,253,253,174,97,255,0,82,120,2,0,42,64,255,255,255,191,255,0,93,120,2,0,62,130,217,166,217,106,255,0,104,120,2,0,98,210,150,26,150,65,255,0,115,120,2,0,2,208,215,215,48,39,255,0,126,120,2,0,13,164,252,252,141,89,255,0,137,120,2,0,31,115,254,254,224,139,255,0,148,120,2,0,51,106,239,217,239,139,255,0,159,120,2,0,66,136,207,145,207,96,255,0,170,120,2,0,103,211,152,26,152,80,255,0,181,120,2,0,2,208,215,215,48,39,255,0,192,120,2,0,13,164,252,252,141,89,255,0,203,120,2,0,31,115,254,254,224,139,255,0,214,120,2,0,42,64,255,255,255,191,255,0,225,120,2,0,51,106,239,217,239,139,255,0,236,120,2,0,66,136,207,145,207,96,255,0,247,120,2,0,103,211,152,26,152,80,255,0,2,121,2,0,2,208,215,215,48,39,255,0,13,121,2,0,10,184,244,244,109,67,255,0,24,121,2,0,20,157,253,253,174,97,255,0,35,121,2,0,31,115,254,254,224,139,255,0,46,121,2,0,51,106,239,217,239,139,255,0,57,121,2,0,62,130,217,166,217,106,255,0,68,121,2,0,83,121,189,102,189,99,255,0,79,121,2,0,103,211,152,26,152,80,255,0,90,121,2,0,2,208,215,215,48,39,255,0,101,121,2,0,10,184,244,244,109,67,255,0,112,121,2,0,20,157,253,253,174,97,255,0,123,121,2,0,31,115,254,254,224,139,255,0,134,121,2,0,42,64,255,255,255,191,255,0,145,121,2,0,51,106,239,217,239,139,255,0,156,121,2,0,62,130,217,166,217,106,255,0,167,121,2,0,83,121,189,102,189,99,255,0,178,121,2,0,103,211,152,26,152,80,255,0,189,121,2,0,13,44,254,254,224,210,255,0,198,121,2,0,9,139,252,252,146,114,255,0,207,121,2,0,1,211,222,222,45,38,255,0,216,121,2,0,13,37,254,254,229,217,255,0,225,121,2,0,11,108,252,252,174,145,255,0,234,121,2,0,7,179,251,251,106,74,255,0,243,121,2,0,253,224,203,203,24,29,255,0,252,121,2,0,13,37,254,254,229,217,255,0,5,122,2,0,11,108,252,252,174,145,255,0,14,122,2,0,7,179,251,251,106,74,255,0,23,122,2,0,1,211,222,222,45,38,255,0,32,122,2,0,253,231,165,165,15,21,255,0,41,122,2,0,13,37,254,254,229,217,255,0,50,122,2,0,12,92,252,252,187,161,255,0,59,122,2,0,9,139,252,252,146,114,255,0,68,122,2,0,7,179,251,251,106,74,255,0,77,122,2,0,1,211,222,222,45,38,255,0,86,122,2,0,253,231,165,165,15,21,255,0,95,122,2,0,13,37,254,254,229,217,255,0,104,122,2,0,12,92,252,252,187,161,255,0,113,122,2,0,9,139,252,252,146,114,255,0,122,122,2,0,7,179,251,251,106,74,255,0,131,122,2,0,3,208,239,239,59,44,255,0,140,122,2,0,253,224,203,203,24,29,255,0,149,122,2,0,251,255,153,153,0,13,255,0,158,122,2,0,14,15,255,255,245,240,255,0,167,122,2,0,13,44,254,254,224,210,255,0,176,122,2,0,12,92,252,252,187,161,255,0,185,122,2,0,9,139,252,252,146,114,255,0,194,122,2,0,7,179,251,251,106,74,255,0,203,122,2,0,3,208,239,239,59,44,255,0,212,122,2,0,253,224,203,203,24,29,255,0,221,122,2,0,251,255,153,153,0,13,255,0,230,122,2,0,14,15,255,255,245,240,255,0,239,122,2,0,13,44,254,254,224,210,255,0,248,122,2,0,12,92,252,252,187,161,255,0,1,123,2,0,9,139,252,252,146,114,255,0,10,123,2,0,7,179,251,251,106,74,255,0,19,123,2,0,3,208,239,239,59,44,255,0,28,123,2,0,253,224,203,203,24,29,255,0,37,123,2,0,253,231,165,165,15,21,255,0,46,123,2,0,249,255,103,103,0,13,255,0,55,123,2,0,254,225,228,228,26,28,255,0,64,123,2,0,146,178,184,55,126,184,255,0,73,123,2,0,83,147,175,77,175,74,255,0,82,123,2,0,254,225,228,228,26,28,255,0,91,123,2,0,146,178,184,55,126,184,255,0,100,123,2,0,83,147,175,77,175,74,255,0,109,123,2,0,207,132,163,152,78,163,255,0,118,123,2,0,254,225,228,228,26,28,255,0,127,123,2,0,146,178,184,55,126,184,255,0,136,123,2,0,83,147,175,77,175,74,255,0,145,123,2,0,207,132,163,152,78,163,255,0,154,123,2,0,21,255,255,255,127,0,255,0,163,123,2,0,254,225,228,228,26,28,255,0,172,123,2,0,146,178,184,55,126,184,255,0,181,123,2,0,83,147,175,77,175,74,255,0,190,123,2,0,207,132,163,152,78,163,255,0,199,123,2,0,21,255,255,255,127,0,255,0,208,123,2,0,42,204,255,255,255,51,255,0,217,123,2,0,254,225,228,228,26,28,255,0,226,123,2,0,146,178,184,55,126,184,255,0,235,123,2,0,83,147,175,77,175,74,255,0,244,123,2,0,207,132,163,152,78,163,255,0,253,123,2,0,21,255,255,255,127,0,255,0,6,124,2,0,42,204,255,255,255,51,255,0,15,124,2,0,15,193,166,166,86,40,255,0,24,124,2,0,254,225,228,228,26,28,255,0,33,124,2,0,146,178,184,55,126,184,255,0,42,124,2,0,83,147,175,77,175,74,255,0,51,124,2,0,207,132,163,152,78,163,255,0,60,124,2,0,21,255,255,255,127,0,255,0,69,124,2,0,42,204,255,255,255,51,255,0,78,124,2,0,15,193,166,166,86,40,255,0,87,124,2,0,232,121,247,247,129,191,255,0,96,124,2,0,254,225,228,228,26,28,255,0,105,124,2,0,146,178,184,55,126,184,255,0,114,124,2,0,83,147,175,77,175,74,255,0,123,124,2,0,207,132,163,152,78,163,255,0,132,124,2,0,21,255,255,255,127,0,255,0,141,124,2,0,42,204,255,255,255,51,255,0,150,124,2,0,15,193,166,166,86,40,255,0,159,124,2,0,232,121,247,247,129,191,255,0,168,124,2,0,0,0,153,153,153,153,255,0,177,124,2,0,114,120,194,102,194,165,255,0,186,124,2,0,11,155,252,252,141,98,255,0,195,124,2,0,156,77,203,141,160,203,255,0,204,124,2,0,114,120,194,102,194,165,255,0,213,124,2,0,11,155,252,252,141,98,255,0,222,124,2,0,156,77,203,141,160,203,255,0,231,124,2,0,228,102,231,231,138,195,255,0,240,124,2,0,114,120,194,102,194,165,255,0,249,124,2,0,11,155,252,252,141,98,255,0,2,125,2,0,156,77,203,141,160,203,255,0,11,125,2,0,228,102,231,231,138,195,255,0,20,125,2,0,58,155,216,166,216,84,255,0,29,125,2,0,114,120,194,102,194,165,255,0,38,125,2,0,11,155,252,252,141,98,255,0,47,125,2,0,156,77,203,141,160,203,255,0,56,125,2,0,228,102,231,231,138,195,255,0,65,125,2,0,58,155,216,166,216,84,255,0,74,125,2,0,34,208,255,255,217,47,255,0,83,125,2,0,114,120,194,102,194,165,255,0,92,125,2,0,11,155,252,252,141,98,255,0,101,125,2,0,156,77,203,141,160,203,255,0,110,125,2,0,228,102,231,231,138,195,255,0,119,125,2,0,58,155,216,166,216,84,255,0,128,125,2,0,34,208,255,255,217,47,255,0,137,125,2,0,25,90,229,229,196,148,255,0,146,125,2,0,114,120,194,102,194,165,255,0,155,125,2,0,11,155,252,252,141,98,255,0,164,125,2,0,156,77,203,141,160,203,255,0,173,125,2,0,228,102,231,231,138,195,255,0,182,125,2,0,58,155,216,166,216,84,255,0,191,125,2,0,34,208,255,255,217,47,255,0,200,125,2,0,25,90,229,229,196,148,255,0,209,125,2,0,0,0,179,179,179,179,255,0,218,125,2,0,120,84,211,141,211,199,255,0,228,125,2,0,211,82,189,188,128,189,255,0,239,125,2,0,42,76,255,255,255,179,255,0,249,125,2,0,175,37,218,190,186,218,255,0,3,126,2,0,4,139,251,251,128,114,255,0,13,126,2,0,144,100,211,128,177,211,255,0,23,126,2,0,22,156,253,253,180,98,255,0,33,126,2,0,58,134,222,179,222,105,255,0,43,126,2,0,233,47,252,252,205,229,255,0,53,126,2,0,0,0,217,217,217,217,255,0,63,126,2,0,120,84,211,141,211,199,255,0,73,126,2,0,211,82,189,188,128,189,255,0,84,126,2,0,77,41,235,204,235,197,255,0,95,126,2,0,42,76,255,255,255,179,255,0,105,126,2,0,175,37,218,190,186,218,255,0,115,126,2,0,4,139,251,251,128,114,255,0,125,126,2,0,144,100,211,128,177,211,255,0,135,126,2,0,22,156,253,253,180,98,255,0,145,126,2,0,58,134,222,179,222,105,255,0,155,126,2,0,233,47,252,252,205,229,255,0,165,126,2,0,0,0,217,217,217,217,255,0,175,126,2,0,120,84,211,141,211,199,255,0,185,126,2,0,211,82,189,188,128,189,255,0,196,126,2,0,77,41,235,204,235,197,255,0,207,126,2,0,37,144,255,255,237,111,255,0,218,126,2,0,42,76,255,255,255,179,255,0,228,126,2,0,175,37,218,190,186,218,255,0,238,126,2,0,4,139,251,251,128,114,255,0,248,126,2,0,144,100,211,128,177,211,255,0,2,127,2,0,22,156,253,253,180,98,255,0,12,127,2,0,58,134,222,179,222,105,255,0,22,127,2,0,233,47,252,252,205,229,255,0,32,127,2,0,0,0,217,217,217,217,255,0,42,127,2,0,120,84,211,141,211,199,255,0,51,127,2,0,42,76,255,255,255,179,255,0,60,127,2,0,175,37,218,190,186,218,255,0,69,127,2,0,120,84,211,141,211,199,255,0,78,127,2,0,42,76,255,255,255,179,255,0,87,127,2,0,175,37,218,190,186,218,255,0,96,127,2,0,4,139,251,251,128,114,255,0,105,127,2,0,120,84,211,141,211,199,255,0,114,127,2,0,42,76,255,255,255,179,255,0,123,127,2,0,175,37,218,190,186,218,255,0,132,127,2,0,4,139,251,251,128,114,255,0,141,127,2,0,144,100,211,128,177,211,255,0,150,127,2,0,120,84,211,141,211,199,255,0,159,127,2,0,42,76,255,255,255,179,255,0,168,127,2,0,175,37,218,190,186,218,255,0,177,127,2,0,4,139,251,251,128,114,255,0,186,127,2,0,144,100,211,128,177,211,255,0,195,127,2,0,22,156,253,253,180,98,255,0,204,127,2,0,120,84,211,141,211,199,255,0,213,127,2,0,42,76,255,255,255,179,255,0,222,127,2,0,175,37,218,190,186,218,255,0,231,127,2,0,4,139,251,251,128,114,255,0,240,127,2,0,144,100,211,128,177,211,255,0,249,127,2,0,22,156,253,253,180,98,255,0,2,128,2,0,58,134,222,179,222,105,255,0,11,128,2,0,120,84,211,141,211,199,255,0,20,128,2,0,42,76,255,255,255,179,255,0,29,128,2,0,175,37,218,190,186,218,255,0,38,128,2,0,4,139,251,251,128,114,255,0,47,128,2,0,144,100,211,128,177,211,255,0,56,128,2,0,22,156,253,253,180,98,255,0,65,128,2,0,58,134,222,179,222,105,255,0,74,128,2,0,233,47,252,252,205,229,255,0,83,128,2,0,120,84,211,141,211,199,255,0,92,128,2,0,42,76,255,255,255,179,255,0,101,128,2,0,175,37,218,190,186,218,255,0,110,128,2,0,4,139,251,251,128,114,255,0,119,128,2,0,144,100,211,128,177,211,255,0,128,128,2,0,22,156,253,253,180,98,255,0,137,128,2,0,58,134,222,179,222,105,255,0,146,128,2,0,233,47,252,252,205,229,255,0,155,128,2,0,0,0,217,217,217,217,255,0,164,128,2,0,237,253,158,158,1,66,255,0,178,128,2,0,177,130,162,94,79,162,255,0,193,128,2,0,250,180,213,213,62,79,255,0,207,128,2,0,10,184,244,244,109,67,255,0,221,128,2,0,20,157,253,253,174,97,255,0,235,128,2,0,31,115,254,254,224,139,255,0,249,128,2,0,49,96,245,230,245,152,255,0,7,129,2,0,79,65,221,171,221,164,255,0,21,129,2,0,114,120,194,102,194,165,255,0,35,129,2,0,143,187,189,50,136,189,255,0,49,129,2,0,237,253,158,158,1,66,255,0,63,129,2,0,143,187,189,50,136,189,255,0,78,129,2,0,177,130,162,94,79,162,255,0,93,129,2,0,250,180,213,213,62,79,255,0,107,129,2,0,10,184,244,244,109,67,255,0,121,129,2,0,20,157,253,253,174,97,255,0,135,129,2,0,31,115,254,254,224,139,255,0,149,129,2,0,42,64,255,255,255,191,255,0,163,129,2,0,49,96,245,230,245,152,255,0,177,129,2,0,79,65,221,171,221,164,255,0,191,129,2,0,114,120,194,102,194,165,255,0,205,129,2,0,13,164,252,252,141,89,255,0,218,129,2,0,42,64,255,255,255,191,255,0,231,129,2,0,81,77,213,153,213,148,255,0,244,129,2,0,254,225,215,215,25,28,255,0,1,130,2,0,20,157,253,253,174,97,255,0,14,130,2,0,79,65,221,171,221,164,255,0,27,130,2,0,143,196,186,43,131,186,255,0,40,130,2,0,254,225,215,215,25,28,255,0,53,130,2,0,20,157,253,253,174,97,255,0,66,130,2,0,42,64,255,255,255,191,255,0,79,130,2,0,79,65,221,171,221,164,255,0,92,130,2,0,143,196,186,43,131,186,255,0,105,130,2,0,250,180,213,213,62,79,255,0,118,130,2,0,13,164,252,252,141,89,255,0,131,130,2,0,31,115,254,254,224,139,255,0,144,130,2,0,49,96,245,230,245,152,255,0,157,130,2,0,81,77,213,153,213,148,255,0,170,130,2,0,143,187,189,50,136,189,255,0,183,130,2,0,250,180,213,213,62,79,255,0,196,130,2,0,13,164,252,252,141,89,255,0,209,130,2,0,31,115,254,254,224,139,255,0,222,130,2,0,42,64,255,255,255,191,255,0,235,130,2,0,49,96,245,230,245,152,255,0,248,130,2,0,81,77,213,153,213,148,255,0,5,131,2,0,143,187,189,50,136,189,255,0,18,131,2,0,250,180,213,213,62,79,255,0,31,131,2,0,10,184,244,244,109,67,255,0,44,131,2,0,20,157,253,253,174,97,255,0,57,131,2,0,31,115,254,254,224,139,255,0,70,131,2,0,49,96,245,230,245,152,255,0,83,131,2,0,79,65,221,171,221,164,255,0,96,131,2,0,114,120,194,102,194,165,255,0,109,131,2,0,143,187,189,50,136,189,255,0,122,131,2,0,250,180,213,213,62,79,255,0,135,131,2,0,10,184,244,244,109,67,255,0,148,131,2,0,20,157,253,253,174,97,255,0,161,131,2,0,31,115,254,254,224,139,255,0,174,131,2,0,42,64,255,255,255,191,255,0,187,131,2,0,49,96,245,230,245,152,255,0,200,131,2,0,79,65,221,171,221,164,255,0,213,131,2,0,114,120,194,102,194,165,255,0,226,131,2,0,143,187,189,50,136,189,255,0,239,131,2,0,147,15,255,240,248,255,255,0,254,131,2,0,24,35,250,250,235,215,255,0,16,132,2,0,127,255,255,0,255,255,255,0,26,132,2,0,113,128,255,127,255,212,255,0,42,132,2,0,127,15,255,240,255,255,255,0,53,132,2,0,42,26,245,245,245,220,255,0,64,132,2,0,23,58,255,255,228,196,255,0,76,132,2,0,0,0,0,0,0,0,255,0,87,132,2,0,25,49,255,255,235,205,255,0,107,132,2,0,170,255,255,0,0,255,255,0,117,132,2,0,192,206,226,138,43,226,255,0,133,132,2,0,0,190,165,165,42,42,255,0,144,132,2,0,23,99,222,222,184,135,255,0,159,132,2,0,128,103,160,95,158,160,255,0,174,132,2,0,63,255,255,127,255,0,255,0,190,132,2,0,17,218,210,210,105,30,255,0,205,132,2,0,11,175,255,255,127,80,255,0,216,132,2,0,154,147,237,100,149,237,255,0,236,132,2,0,33,34,255,255,248,220,255,0,250,132,2,0,246,231,220,220,20,60,255,0,7,133,2,0,127,255,255,0,255,255,255,0,17,133,2,0,170,255,139,0,0,139,255,0,31,133,2,0,127,255,139,0,139,139,255,0,45,133,2,0,30,239,184,184,134,11,255,0,64,133,2,0,0,0,169,169,169,169,255,0,78,133,2,0,85,255,100,0,100,0,255,0,93,133,2,0,0,0,169,169,169,169,255,0,107,133,2,0,39,110,189,189,183,107,255,0,122,133,2,0,212,255,139,139,0,139,255,0,139,133,2,0,58,142,107,85,107,47,255,0,159,133,2,0,23,255,255,255,140,0,255,0,175,133,2,0,198,192,204,153,50,204,255,0,191,133,2,0,0,255,139,139,0,0,255,0,204,133,2,0,10,121,233,233,150,122,255,0,220,133,2,0,85,61,188,143,188,143,255,0,238,133,2,0,175,143,139,72,61,139,255,0,1,134,2,0,127,103,79,47,79,79,255,0,20,134,2,0,127,103,79,47,79,79,255,0,39,134,2,0,128,255,209,0,206,209,255,0,58,134,2,0,199,255,211,148,0,211,255,0,74,134,2,0,232,235,255,255,20,147,255,0,88,134,2,0,138,255,255,0,191,255,255,0,105,134,2,0,0,0,105,105,105,105,255,0,118,134,2,0,0,0,105,105,105,105,255,0,131,134,2,0,148,225,255,30,144,255,255,0,147,134,2,0,0,206,178,178,34,34,255,0,162,134,2,0,28,15,255,255,250,240,255,0,179,134,2,0,85,192,139,34,139,34,255,0,196,134,2,0,212,255,255,255,0,255,255,0,209,134,2,0,0,0,220,220,220,220,255,0,224,134,2,0,170,7,255,248,248,255,255,0,240,134,2,0,35,255,255,255,215,0,255,0,250,134,2,0,30,217,218,218,165,32,255,0,9,135,2,0,0,0,128,128,128,128,255,0,19,135,2,0,85,255,128,0,128,0,255,0,30,135,2,0,59,208,255,173,255,47,255,0,47,135,2,0,0,0,128,128,128,128,255,0,57,135,2,0,85,15,255,240,255,240,255,0,71,135,2,0,233,150,255,255,105,180,255,0,84,135,2,0,0,140,205,205,92,92,255,0,99,135,2,0,194,255,130,75,0,130,255,0,111,135,2,0,42,15,255,255,255,240,255,0,122,135,2,0,38,106,240,240,230,140,255,0,133,135,2,0,170,20,250,230,230,250,255,0,147,135,2,0,240,15,255,255,240,245,255,0,166,135,2,0,64,255,252,124,252,0,255,0,181,135,2,0,38,49,255,255,250,205,255,0,199,135,2,0,137,63,230,173,216,230,255,0,214,135,2,0,0,119,240,240,128,128,255,0,230,135,2,0,127,31,255,224,255,255,255,0,245,135,2,0,42,40,250,250,250,210,255,0,15,136,2,0,0,0,211,211,211,211,255,0,30,136,2,0,85,100,238,144,238,144,255,0,46,136,2,0,0,0,211,211,211,211,255,0,61,136,2,0,248,73,255,255,182,193,255,0,76,136,2,0,12,132,255,255,160,122,255,0,93,136,2,0,125,209,178,32,178,170,255,0,112,136,2,0,143,117,250,135,206,250,255,0,130,136,2,0,148,56,153,119,136,153,255,0,150,136,2,0,148,56,153,119,136,153,255,0,170,136,2,0,151,52,222,176,196,222,255,0,190,136,2,0,42,31,255,255,255,224,255,0,207,136,2,0,85,255,255,0,255,0,255,0,217,136,2,0,85,192,205,50,205,50,255,0,232,136,2,0,21,20,250,250,240,230,255,0,243,136,2,0,212,255,255,255,0,255,255,0,0,137,2,0,0,255,128,128,0,0,255,0,12,137,2,0,113,128,205,102,205,170,255,0,34,137,2,0,170,255,205,0,0,205,255,0,50,137,2,0,204,152,211,186,85,211,255,0,68,137,2,0,183,124,219,147,112,219,255,0,86,137,2,0,103,169,179,60,179,113,255,0,106,137,2,0,176,143,238,123,104,238,255,0,127,137,2,0,111,255,250,0,250,154,255,0,150,137,2,0,125,167,209,72,209,204,255,0,171,137,2,0,228,228,199,199,21,133,255,0,192,137,2,0,170,198,112,25,25,112,255,0,210,137,2,0,106,9,255,245,255,250,255,0,225,137,2,0,4,30,255,255,228,225,255,0,240,137,2,0,26,73,255,255,228,181,255,0,254,137,2,0,25,81,255,255,222,173,255,0,15,138,2,0,170,255,128,0,0,128,255,0,25,138,2,0,27,23,253,253,245,230,255,0,38,138,2,0,42,255,128,128,128,0,255,0,49,138,2,0,56,192,142,107,142,35,255,0,64,138,2,0,27,255,255,255,165,0,255,0,76,138,2,0,11,255,255,255,69,0,255,0,91,138,2,0,214,123,218,218,112,214,255,0,103,138,2,0,38,72,238,238,232,170,255,0,122,138,2,0,85,100,251,152,251,152,255,0,137,138,2,0,127,67,238,175,238,238,255,0,156,138,2,0,241,124,219,219,112,147,255,0,175,138,2,0,26,41,255,255,239,213,255,0,191,138,2,0,20,70,255,255,218,185,255,0,206,138,2,0,20,176,205,205,133,63,255,0,216,138,2,0,247,63,255,255,192,203,255,0,226,138,2,0,212,70,221,221,160,221,255,0,236,138,2,0,132,59,230,176,224,230,255,0,252,138,2,0,212,255,128,128,0,128,255,0,8,139,2,0,0,255,255,255,0,0,255,0,17,139,2,0,0,61,188,188,143,143,255,0,32,139,2,0,159,181,225,65,105,225,255,0,47,139,2,0,17,220,139,139,69,19,255,0,64,139,2,0,4,138,250,250,128,114,255,0,76,139,2,0,19,154,244,244,164,96,255,0,92,139,2,0,103,170,139,46,139,87,255,0,106,139,2,0,17,16,255,255,245,238,255,0,120,139,2,0,13,183,160,160,82,45,255,0,132,139,2,0,0,0,192,192,192,192,255,0,144,139,2,0,139,108,235,135,206,235,255,0,157,139,2,0,175,143,205,106,90,205,255,0,172,139,2,0,148,56,144,112,128,144,255,0,187,139,2,0,148,56,144,112,128,144,255,0,202,139,2,0,0,5,255,255,250,250,255,0,212,139,2,0,106,255,255,0,255,127,255,0,229,139,2,0,146,155,180,70,130,180,255,0,244,139,2,0,24,84,210,210,180,140,255,0,253,139,2,0,127,255,128,0,128,128,255,0,7,140,2,0,212,29,216,216,191,216,255,0,20,140,2,0,6,184,255,255,99,71,255,0,32,140,2,0,123,182,224,64,224,208,255,0,47,140,2,0,212,115,238,238,130,238,255,0,59,140,2,0,27,68,245,245,222,179,255,0,70,140,2,0,0,0,255,255,255,255,255,0,81,140,2,0,0,0,245,245,245,245,255,0,97,140,2,0,42,255,255,255,255,0,255,0,109,140,2,0,56,192,205,154,205,50,255,0,126,140,2,0,45,67,252,247,252,185,255,0,135,140,2,0,68,91,221,173,221,142,255,0,144,140,2,0,98,178,163,49,163,84,255,0,153,140,2,0,42,50,255,255,255,204,255,0,162,140,2,0,62,85,230,194,230,153,255,0,171,140,2,0,85,100,198,120,198,121,255,0,180,140,2,0,99,187,132,35,132,67,255,0,189,140,2,0,42,50,255,255,255,204,255,0,198,140,2,0,62,85,230,194,230,153,255,0,207,140,2,0,85,100,198,120,198,121,255,0,216,140,2,0,98,178,163,49,163,84,255,0,225,140,2,0,107,255,104,0,104,55,255,0,234,140,2,0,42,50,255,255,255,204,255,0,243,140,2,0,55,81,240,217,240,163,255,0,252,140,2,0,68,91,221,173,221,142,255,0,5,141,2,0,85,100,198,120,198,121,255,0,14,141,2,0,98,178,163,49,163,84,255,0,23,141,2,0,107,255,104,0,104,55,255,0,32,141,2,0,42,50,255,255,255,204,255,0,41,141,2,0,55,81,240,217,240,163,255,0,50,141,2,0,68,91,221,173,221,142,255,0,59,141,2,0,85,100,198,120,198,121,255,0,68,141,2,0,96,158,171,65,171,93,255,0,77,141,2,0,99,187,132,35,132,67,255,0,86,141,2,0,108,255,90,0,90,50,255,0,95,141,2,0,42,25,255,255,255,229,255,0,104,141,2,0,45,67,252,247,252,185,255,0,113,141,2,0,55,81,240,217,240,163,255,0,122,141,2,0,68,91,221,173,221,142,255,0,131,141,2,0,85,100,198,120,198,121,255,0,140,141,2,0,96,158,171,65,171,93,255,0,149,141,2,0,99,187,132,35,132,67,255,0,158,141,2,0,108,255,90,0,90,50,255,0,167,141,2,0,42,25,255,255,255,229,255,0,176,141,2,0,45,67,252,247,252,185,255,0,185,141,2,0,55,81,240,217,240,163,255,0,194,141,2,0,68,91,221,173,221,142,255,0,203,141,2,0,85,100,198,120,198,121,255,0,212,141,2,0,96,158,171,65,171,93,255,0,221,141,2,0,99,187,132,35,132,67,255,0,230,141,2,0,107,255,104,0,104,55,255,0,239,141,2,0,110,255,69,0,69,41,255,0,248,141,2,0,49,73,248,237,248,177,255,0,3,142,2,0,117,97,205,127,205,187,255,0,14,142,2,0,144,194,184,44,127,184,255,0,25,142,2,0,42,50,255,255,255,204,255,0,36,142,2,0,99,66,218,161,218,180,255,0,47,142,2,0,132,170,196,65,182,196,255,0,58,142,2,0,150,203,168,34,94,168,255,0,69,142,2,0,42,50,255,255,255,204,255,0,80,142,2,0,99,66,218,161,218,180,255,0,91,142,2,0,132,170,196,65,182,196,255,0,102,142,2,0,144,194,184,44,127,184,255,0,113,142,2,0,164,191,148,37,52,148,255,0,124,142,2,0,42,50,255,255,255,204,255,0,135,142,2,0,69,58,233,199,233,180,255,0,146,142,2,0,117,97,205,127,205,187,255,0,157,142,2,0,132,170,196,65,182,196,255,0,168,142,2,0,144,194,184,44,127,184,255,0,179,142,2,0,164,191,148,37,52,148,255,0,190,142,2,0,42,50,255,255,255,204,255,0,201,142,2,0,69,58,233,199,233,180,255,0,212,142,2,0,117,97,205,127,205,187,255,0,223,142,2,0,132,170,196,65,182,196,255,0,234,142,2,0,139,216,192,29,145,192,255,0,245,142,2,0,150,203,168,34,94,168,255,0,0,143,2,0,158,231,132,12,44,132,255,0,11,143,2,0,42,38,255,255,255,217,255,0,22,143,2,0,49,73,248,237,248,177,255,0,33,143,2,0,69,58,233,199,233,180,255,0,44,143,2,0,117,97,205,127,205,187,255,0,55,143,2,0,132,170,196,65,182,196,255,0,66,143,2,0,139,216,192,29,145,192,255,0,77,143,2,0,150,203,168,34,94,168,255,0,88,143,2,0,158,231,132,12,44,132,255,0,99,143,2,0,42,38,255,255,255,217,255,0,110,143,2,0,49,73,248,237,248,177,255,0,121,143,2,0,69,58,233,199,233,180,255,0,132,143,2,0,117,97,205,127,205,187,255,0,143,143,2,0,132,170,196,65,182,196,255,0,154,143,2,0,139,216,192,29,145,192,255,0,165,143,2,0,150,203,168,34,94,168,255,0,176,143,2,0,164,191,148,37,52,148,255,0,187,143,2,0,158,231,88,8,29,88,255,0,198,143,2,0,37,66,255,255,247,188,255,0,209,143,2,0,28,175,254,254,196,79,255,0,220,143,2,0,16,238,217,217,95,14,255,0,231,143,2,0,42,42,255,255,255,212,255,0,242,143,2,0,28,112,254,254,217,142,255,0,253,143,2,0,22,213,254,254,153,41,255,0,8,144,2,0,15,252,204,204,76,2,255,0,19,144,2,0,42,42,255,255,255,212,255,0,30,144,2,0,28,112,254,254,217,142,255,0,41,144,2,0,22,213,254,254,153,41,255,0,52,144,2,0,16,238,217,217,95,14,255,0,63,144,2,0,13,248,153,153,52,4,255,0,74,144,2,0,42,42,255,255,255,212,255,0,85,144,2,0,31,109,254,254,227,145,255,0,96,144,2,0,28,175,254,254,196,79,255,0,107,144,2,0,22,213,254,254,153,41,255,0,118,144,2,0,16,238,217,217,95,14,255,0,129,144,2,0,13,248,153,153,52,4,255,0,140,144,2,0,42,42,255,255,255,212,255,0,151,144,2,0,31,109,254,254,227,145,255,0,162,144,2,0,28,175,254,254,196,79,255,0,173,144,2,0,22,213,254,254,153,41,255,0,184,144,2,0,18,233,236,236,112,20,255,0,195,144,2,0,15,252,204,204,76,2,255,0,206,144,2,0,12,247,140,140,45,4,255,0,217,144,2,0,42,25,255,255,255,229,255,0,228,144,2,0,37,66,255,255,247,188,255,0,239,144,2,0,31,109,254,254,227,145,255,0,250,144,2,0,28,175,254,254,196,79,255,0,5,145,2,0,22,213,254,254,153,41,255,0,16,145,2,0,18,233,236,236,112,20,255,0,27,145,2,0,15,252,204,204,76,2,255,0,38,145,2,0,12,247,140,140,45,4,255,0,49,145,2,0,42,25,255,255,255,229,255,0,60,145,2,0,37,66,255,255,247,188,255,0,71,145,2,0,31,109,254,254,227,145,255,0,82,145,2,0,28,175,254,254,196,79,255,0,93,145,2,0,22,213,254,254,153,41,255,0,104,145,2,0,18,233,236,236,112,20,255,0,115,145,2,0,15,252,204,204,76,2,255,0,126,145,2,0,13,248,153,153,52,4,255,0,137,145,2,0,13,240,102,102,37,6,255,0,148,145,2,0,34,95,255,255,237,160,255,0,159,145,2,0,24,178,254,254,178,76,255,0,170,145,2,0,5,221,240,240,59,32,255,0,181,145,2,0,42,77,255,255,255,178,255,0,192,145,2,0,29,162,254,254,204,92,255,0,203,145,2,0,17,194,253,253,141,60,255,0,214,145,2,0,254,225,227,227,26,28,255,0,225,145,2,0,42,77,255,255,255,178,255,0,236,145,2,0,29,162,254,254,204,92,255,0,247,145,2,0,17,194,253,253,141,60,255,0,2,146,2,0,5,221,240,240,59,32,255,0,13,146,2,0,246,255,189,189,0,38,255,0,24,146,2,0,42,77,255,255,255,178,255,0,35,146,2,0,30,136,254,254,217,118,255,0,46,146,2,0,24,178,254,254,178,76,255,0,57,146,2,0,17,194,253,253,141,60,255,0,68,146,2,0,5,221,240,240,59,32,255,0,79,146,2,0,246,255,189,189,0,38,255,0,90,146,2,0,42,77,255,255,255,178,255,0,101,146,2,0,30,136,254,254,217,118,255,0,112,146,2,0,24,178,254,254,178,76,255,0,123,146,2,0,17,194,253,253,141,60,255,0,134,146,2,0,7,212,252,252,78,42,255,0,145,146,2,0,254,225,227,227,26,28,255,0,156,146,2,0,245,255,177,177,0,38,255,0,167,146,2,0,42,50,255,255,255,204,255,0,178,146,2,0,34,95,255,255,237,160,255,0,189,146,2,0,30,136,254,254,217,118,255,0,200,146,2,0,24,178,254,254,178,76,255,0,211,146,2,0,17,194,253,253,141,60,255,0,222,146,2,0,7,212,252,252,78,42,255,0,233,146,2,0,254,225,227,227,26,28,255,0,244,146,2,0,245,255,177,177,0,38,255,0,255,146,2,0,42,50,255,255,255,204,255,0,10,147,2,0,34,95,255,255,237,160,255,0,21,147,2,0,30,136,254,254,217,118,255,0,32,147,2,0,24,178,254,254,178,76,255,0,43,147,2,0,17,194,253,253,141,60,255,0,54,147,2,0,7,212,252,252,78,42,255,0,65,147,2,0,254,225,227,227,26,28,255,0,76,147,2,0,246,255,189,189,0,38,255,0,87,147,2,0,242,255,128,128,0,38,255,0,98,147,2,0,147,15,255,240,248,255,255,0,108,147,2,0,24,35,250,250,235,215,255,0,121,147,2,0,23,36,255,255,239,219,255,0,135,147,2,0,23,36,238,238,223,204,255,0,149,147,2,0,23,36,205,205,192,176,255,0,163,147,2,0,24,34,139,139,131,120,255,0,177,147,2,0,113,128,255,127,255,212,255,0,188,147,2,0,113,128,255,127,255,212,255,0,200,147,2,0,113,128,238,118,238,198,255,0,212,147,2,0,113,128,205,102,205,170,255,0,224,147,2,0,113,128,139,69,139,116,255,0,236,147,2,0,127,15,255,240,255,255,255,0,242,147,2,0,127,15,255,240,255,255,255,0,249,147,2,0,127,15,238,224,238,238,255,0,0,148,2,0,127,14,205,193,205,205,255,0,7,148,2,0,127,14,139,131,139,139,255,0,14,148,2,0,42,26,245,245,245,220,255,0,20,148,2,0,23,58,255,255,228,196,255,0,27,148,2,0,23,58,255,255,228,196,255,0,35,148,2,0,23,58,238,238,213,183,255,0,43,148,2,0,22,58,205,205,183,158,255,0,51,148,2,0,23,58,139,139,125,107,255,0,69,171,2,0,0,0,0,0,0,0,255,0,59,148,2,0,25,49,255,255,235,205,255,0,74,148,2,0,170,255,255,0,0,255,255,0,79,148,2,0,170,255,255,0,0,255,255,0,85,148,2,0,170,255,238,0,0,238,255,0,91,148,2,0,170,255,205,0,0,205,255,0,97,148,2,0,170,255,139,0,0,139,255,0,103,148,2,0,192,206,226,138,43,226,255,0,114,148,2,0,0,190,165,165,42,42,255,0,120,148,2,0,0,191,255,255,64,64,255,0,127,148,2,0,0,191,238,238,59,59,255,0,134,148,2,0,0,191,205,205,51,51,255,0,141,148,2,0,0,190,139,139,35,35,255,0,148,148,2,0,23,99,222,222,184,135,255,0,158,148,2,0,23,100,255,255,211,155,255,0,169,148,2,0,23,99,238,238,197,145,255,0,180,148,2,0,23,99,205,205,170,125,255,0,191,148,2,0,23,99,139,139,115,85,255,0,202,148,2,0,128,103,160,95,158,160,255,0,212,148,2,0,131,103,255,152,245,255,255,0,223,148,2,0,131,102,238,142,229,238,255,0,234,148,2,0,131,103,205,122,197,205,255,0,245,148,2,0,131,102,139,83,134,139,255,0,0,149,2,0,63,255,255,127,255,0,255,0,11,149,2,0,63,255,255,127,255,0,255,0,23,149,2,0,63,255,238,118,238,0,255,0,35,149,2,0,63,255,205,102,205,0,255,0,47,149,2,0,63,255,139,69,139,0,255,0,59,149,2,0,17,218,210,210,105,30,255,0,69,149,2,0,17,219,255,255,127,36,255,0,80,149,2,0,17,219,238,238,118,33,255,0,91,149,2,0,17,218,205,205,102,29,255,0,102,149,2,0,17,220,139,139,69,19,255,0,113,149,2,0,11,175,255,255,127,80,255,0,119,149,2,0,7,169,255,255,114,86,255,0,126,149,2,0,6,169,238,238,106,80,255,0,133,149,2,0,6,169,205,205,91,69,255,0,140,149,2,0,6,168,139,139,62,47,255,0,147,149,2,0,154,147,237,100,149,237,255,0,162,149,2,0,33,34,255,255,248,220,255,0,171,149,2,0,33,34,255,255,248,220,255,0,181,149,2,0,34,35,238,238,232,205,255,0,191,149,2,0,34,34,205,205,200,177,255,0,201,149,2,0,35,34,139,139,136,120,255,0,211,149,2,0,246,231,220,220,20,60,255,0,219,149,2,0,127,255,255,0,255,255,255,0,224,149,2,0,127,255,255,0,255,255,255,0,230,149,2,0,127,255,238,0,238,238,255,0,236,149,2,0,127,255,205,0,205,205,255,0,242,149,2,0,127,255,139,0,139,139,255,0,248,149,2,0,30,239,184,184,134,11,255,0,6,150,2,0,30,240,255,255,185,15,255,0,21,150,2,0,30,240,238,238,173,14,255,0,36,150,2,0,30,240,205,205,149,12,255,0,51,150,2,0,30,240,139,139,101,8,255,0,66,150,2,0,85,255,100,0,100,0,255,0,76,150,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+74232);allocate([39,110,189,189,183,107,255,0,86,150,2,0,58,142,107,85,107,47,255,0,101,150,2,0,58,143,255,202,255,112,255,0,117,150,2,0,58,143,238,188,238,104,255,0,133,150,2,0,58,143,205,162,205,90,255,0,149,150,2,0,58,143,139,110,139,61,255,0,165,150,2,0,23,255,255,255,140,0,255,0,176,150,2,0,21,255,255,255,127,0,255,0,188,150,2,0,21,255,238,238,118,0,255,0,200,150,2,0,21,255,205,205,102,0,255,0,212,150,2,0,21,255,139,139,69,0,255,0,224,150,2,0,198,192,204,153,50,204,255,0,235,150,2,0,198,193,255,191,62,255,255,0,247,150,2,0,198,192,238,178,58,238,255,0,3,151,2,0,198,192,205,154,50,205,255,0,15,151,2,0,198,192,139,104,34,139,255,0,27,151,2,0,10,121,233,233,150,122,255,0,38,151,2,0,85,61,188,143,188,143,255,0,51,151,2,0,85,62,255,193,255,193,255,0,65,151,2,0,85,62,238,180,238,180,255,0,79,151,2,0,85,62,205,155,205,155,255,0,93,151,2,0,85,62,139,105,139,105,255,0,107,151,2,0,175,143,139,72,61,139,255,0,121,151,2,0,127,103,79,47,79,79,255,0,135,151,2,0,127,104,255,151,255,255,255,0,150,151,2,0,127,103,238,141,238,238,255,0,165,151,2,0,127,104,205,121,205,205,255,0,180,151,2,0,127,104,139,82,139,139,255,0,195,151,2,0,127,103,79,47,79,79,255,0,209,151,2,0,128,255,209,0,206,209,255,0,223,151,2,0,199,255,211,148,0,211,255,0,234,151,2,0,232,235,255,255,20,147,255,0,243,151,2,0,232,235,255,255,20,147,255,0,253,151,2,0,232,235,238,238,18,137,255,0,7,152,2,0,232,235,205,205,16,118,255,0,17,152,2,0,231,236,139,139,10,80,255,0,27,152,2,0,138,255,255,0,191,255,255,0,39,152,2,0,138,255,255,0,191,255,255,0,52,152,2,0,138,255,238,0,178,238,255,0,65,152,2,0,138,255,205,0,154,205,255,0,78,152,2,0,138,255,139,0,104,139,255,0,91,152,2,0,0,0,105,105,105,105,255,0,99,152,2,0,0,0,105,105,105,105,255,0,107,152,2,0,148,225,255,30,144,255,255,0,118,152,2,0,148,225,255,30,144,255,255,0,130,152,2,0,148,225,238,28,134,238,255,0,142,152,2,0,148,225,205,24,116,205,255,0,154,152,2,0,148,225,139,16,78,139,255,0,166,152,2,0,0,206,178,178,34,34,255,0,176,152,2,0,0,207,255,255,48,48,255,0,187,152,2,0,0,207,238,238,44,44,255,0,198,152,2,0,0,207,205,205,38,38,255,0,209,152,2,0,0,207,139,139,26,26,255,0,220,152,2,0,28,15,255,255,250,240,255,0,232,152,2,0,85,192,139,34,139,34,255,0,244,152,2,0,0,0,220,220,220,220,255,0,254,152,2,0,170,7,255,248,248,255,255,0,9,153,2,0,35,255,255,255,215,0,255,0,14,153,2,0,35,255,255,255,215,0,255,0,20,153,2,0,35,255,238,238,201,0,255,0,26,153,2,0,35,255,205,205,173,0,255,0,32,153,2,0,35,255,139,139,117,0,255,0,38,153,2,0,30,217,218,218,165,32,255,0,48,153,2,0,30,218,255,255,193,37,255,0,59,153,2,0,30,218,238,238,180,34,255,0,70,153,2,0,30,218,205,205,155,29,255,0,81,153,2,0,30,218,139,139,105,20,255,0,92,153,2,0,0,0,192,192,192,192,255,0,97,153,2,0,0,0,0,0,0,0,255,0,103,153,2,0,0,0,3,3,3,3,255,0,109,153,2,0,0,0,26,26,26,26,255,0,116,153,2,0,0,0,255,255,255,255,255,0,124,153,2,0,0,0,28,28,28,28,255,0,131,153,2,0,0,0,31,31,31,31,255,0,138,153,2,0,0,0,33,33,33,33,255,0,145,153,2,0,0,0,36,36,36,36,255,0,152,153,2,0,0,0,38,38,38,38,255,0,159,153,2,0,0,0,41,41,41,41,255,0,166,153,2,0,0,0,43,43,43,43,255,0,173,153,2,0,0,0,46,46,46,46,255,0,180,153,2,0,0,0,48,48,48,48,255,0,187,153,2,0,0,0,5,5,5,5,255,0,193,153,2,0,0,0,51,51,51,51,255,0,200,153,2,0,0,0,54,54,54,54,255,0,207,153,2,0,0,0,56,56,56,56,255,0,214,153,2,0,0,0,59,59,59,59,255,0,221,153,2,0,0,0,61,61,61,61,255,0,228,153,2,0,0,0,64,64,64,64,255,0,235,153,2,0,0,0,66,66,66,66,255,0,242,153,2,0,0,0,69,69,69,69,255,0,249,153,2,0,0,0,71,71,71,71,255,0,0,154,2,0,0,0,74,74,74,74,255,0,7,154,2,0,0,0,8,8,8,8,255,0,13,154,2,0,0,0,77,77,77,77,255,0,20,154,2,0,0,0,79,79,79,79,255,0,27,154,2,0,0,0,82,82,82,82,255,0,34,154,2,0,0,0,84,84,84,84,255,0,41,154,2,0,0,0,87,87,87,87,255,0,48,154,2,0,0,0,89,89,89,89,255,0,55,154,2,0,0,0,92,92,92,92,255,0,62,154,2,0,0,0,94,94,94,94,255,0,69,154,2,0,0,0,97,97,97,97,255,0,76,154,2,0,0,0,99,99,99,99,255,0,83,154,2,0,0,0,10,10,10,10,255,0,89,154,2,0,0,0,102,102,102,102,255,0,96,154,2,0,0,0,105,105,105,105,255,0,103,154,2,0,0,0,107,107,107,107,255,0,110,154,2,0,0,0,110,110,110,110,255,0,117,154,2,0,0,0,112,112,112,112,255,0,124,154,2,0,0,0,115,115,115,115,255,0,131,154,2,0,0,0,117,117,117,117,255,0,138,154,2,0,0,0,120,120,120,120,255,0,145,154,2,0,0,0,122,122,122,122,255,0,152,154,2,0,0,0,125,125,125,125,255,0,159,154,2,0,0,0,13,13,13,13,255,0,165,154,2,0,0,0,127,127,127,127,255,0,172,154,2,0,0,0,130,130,130,130,255,0,179,154,2,0,0,0,133,133,133,133,255,0,186,154,2,0,0,0,135,135,135,135,255,0,193,154,2,0,0,0,138,138,138,138,255,0,200,154,2,0,0,0,140,140,140,140,255,0,207,154,2,0,0,0,143,143,143,143,255,0,214,154,2,0,0,0,145,145,145,145,255,0,221,154,2,0,0,0,148,148,148,148,255,0,228,154,2,0,0,0,150,150,150,150,255,0,235,154,2,0,0,0,15,15,15,15,255,0,241,154,2,0,0,0,153,153,153,153,255,0,248,154,2,0,0,0,156,156,156,156,255,0,255,154,2,0,0,0,158,158,158,158,255,0,6,155,2,0,0,0,161,161,161,161,255,0,13,155,2,0,0,0,163,163,163,163,255,0,20,155,2,0,0,0,166,166,166,166,255,0,27,155,2,0,0,0,168,168,168,168,255,0,34,155,2,0,0,0,171,171,171,171,255,0,41,155,2,0,0,0,173,173,173,173,255,0,48,155,2,0,0,0,176,176,176,176,255,0,55,155,2,0,0,0,18,18,18,18,255,0,61,155,2,0,0,0,179,179,179,179,255,0,68,155,2,0,0,0,181,181,181,181,255,0,75,155,2,0,0,0,184,184,184,184,255,0,82,155,2,0,0,0,186,186,186,186,255,0,89,155,2,0,0,0,189,189,189,189,255,0,96,155,2,0,0,0,191,191,191,191,255,0,103,155,2,0,0,0,194,194,194,194,255,0,110,155,2,0,0,0,196,196,196,196,255,0,117,155,2,0,0,0,199,199,199,199,255,0,124,155,2,0,0,0,201,201,201,201,255,0,131,155,2,0,0,0,20,20,20,20,255,0,137,155,2,0,0,0,204,204,204,204,255,0,144,155,2,0,0,0,207,207,207,207,255,0,151,155,2,0,0,0,209,209,209,209,255,0,158,155,2,0,0,0,212,212,212,212,255,0,165,155,2,0,0,0,214,214,214,214,255,0,172,155,2,0,0,0,217,217,217,217,255,0,179,155,2,0,0,0,219,219,219,219,255,0,186,155,2,0,0,0,222,222,222,222,255,0,193,155,2,0,0,0,224,224,224,224,255,0,200,155,2,0,0,0,227,227,227,227,255,0,207,155,2,0,0,0,23,23,23,23,255,0,213,155,2,0,0,0,229,229,229,229,255,0,220,155,2,0,0,0,232,232,232,232,255,0,227,155,2,0,0,0,235,235,235,235,255,0,234,155,2,0,0,0,237,237,237,237,255,0,241,155,2,0,0,0,240,240,240,240,255,0,248,155,2,0,0,0,242,242,242,242,255,0,255,155,2,0,0,0,245,245,245,245,255,0,6,156,2,0,0,0,247,247,247,247,255,0,13,156,2,0,0,0,250,250,250,250,255,0,20,156,2,0,0,0,252,252,252,252,255,0,27,156,2,0,85,255,255,0,255,0,255,0,33,156,2,0,85,255,255,0,255,0,255,0,40,156,2,0,85,255,238,0,238,0,255,0,47,156,2,0,85,255,205,0,205,0,255,0,54,156,2,0,85,255,139,0,139,0,255,0,61,156,2,0,59,208,255,173,255,47,255,0,73,156,2,0,0,0,192,192,192,192,255,0,78,156,2,0,0,0,0,0,0,0,255,0,84,156,2,0,0,0,3,3,3,3,255,0,90,156,2,0,0,0,26,26,26,26,255,0,97,156,2,0,0,0,255,255,255,255,255,0,105,156,2,0,0,0,28,28,28,28,255,0,112,156,2,0,0,0,31,31,31,31,255,0,119,156,2,0,0,0,33,33,33,33,255,0,126,156,2,0,0,0,36,36,36,36,255,0,133,156,2,0,0,0,38,38,38,38,255,0,140,156,2,0,0,0,41,41,41,41,255,0,147,156,2,0,0,0,43,43,43,43,255,0,154,156,2,0,0,0,46,46,46,46,255,0,161,156,2,0,0,0,48,48,48,48,255,0,168,156,2,0,0,0,5,5,5,5,255,0,174,156,2,0,0,0,51,51,51,51,255,0,181,156,2,0,0,0,54,54,54,54,255,0,188,156,2,0,0,0,56,56,56,56,255,0,195,156,2,0,0,0,59,59,59,59,255,0,202,156,2,0,0,0,61,61,61,61,255,0,209,156,2,0,0,0,64,64,64,64,255,0,216,156,2,0,0,0,66,66,66,66,255,0,223,156,2,0,0,0,69,69,69,69,255,0,230,156,2,0,0,0,71,71,71,71,255,0,237,156,2,0,0,0,74,74,74,74,255,0,244,156,2,0,0,0,8,8,8,8,255,0,250,156,2,0,0,0,77,77,77,77,255,0,1,157,2,0,0,0,79,79,79,79,255,0,8,157,2,0,0,0,82,82,82,82,255,0,15,157,2,0,0,0,84,84,84,84,255,0,22,157,2,0,0,0,87,87,87,87,255,0,29,157,2,0,0,0,89,89,89,89,255,0,36,157,2,0,0,0,92,92,92,92,255,0,43,157,2,0,0,0,94,94,94,94,255,0,50,157,2,0,0,0,97,97,97,97,255,0,57,157,2,0,0,0,99,99,99,99,255,0,64,157,2,0,0,0,10,10,10,10,255,0,70,157,2,0,0,0,102,102,102,102,255,0,77,157,2,0,0,0,105,105,105,105,255,0,84,157,2,0,0,0,107,107,107,107,255,0,91,157,2,0,0,0,110,110,110,110,255,0,98,157,2,0,0,0,112,112,112,112,255,0,105,157,2,0,0,0,115,115,115,115,255,0,112,157,2,0,0,0,117,117,117,117,255,0,119,157,2,0,0,0,120,120,120,120,255,0,126,157,2,0,0,0,122,122,122,122,255,0,133,157,2,0,0,0,125,125,125,125,255,0,140,157,2,0,0,0,13,13,13,13,255,0,146,157,2,0,0,0,127,127,127,127,255,0,153,157,2,0,0,0,130,130,130,130,255,0,160,157,2,0,0,0,133,133,133,133,255,0,167,157,2,0,0,0,135,135,135,135,255,0,174,157,2,0,0,0,138,138,138,138,255,0,181,157,2,0,0,0,140,140,140,140,255,0,188,157,2,0,0,0,143,143,143,143,255,0,195,157,2,0,0,0,145,145,145,145,255,0,202,157,2,0,0,0,148,148,148,148,255,0,209,157,2,0,0,0,150,150,150,150,255,0,216,157,2,0,0,0,15,15,15,15,255,0,222,157,2,0,0,0,153,153,153,153,255,0,229,157,2,0,0,0,156,156,156,156,255,0,236,157,2,0,0,0,158,158,158,158,255,0,243,157,2,0,0,0,161,161,161,161,255,0,250,157,2,0,0,0,163,163,163,163,255,0,1,158,2,0,0,0,166,166,166,166,255,0,8,158,2,0,0,0,168,168,168,168,255,0,15,158,2,0,0,0,171,171,171,171,255,0,22,158,2,0,0,0,173,173,173,173,255,0,29,158,2,0,0,0,176,176,176,176,255,0,36,158,2,0,0,0,18,18,18,18,255,0,42,158,2,0,0,0,179,179,179,179,255,0,49,158,2,0,0,0,181,181,181,181,255,0,56,158,2,0,0,0,184,184,184,184,255,0,63,158,2,0,0,0,186,186,186,186,255,0,70,158,2,0,0,0,189,189,189,189,255,0,77,158,2,0,0,0,191,191,191,191,255,0,84,158,2,0,0,0,194,194,194,194,255,0,91,158,2,0,0,0,196,196,196,196,255,0,98,158,2,0,0,0,199,199,199,199,255,0,105,158,2,0,0,0,201,201,201,201,255,0,112,158,2,0,0,0,20,20,20,20,255,0,118,158,2,0,0,0,204,204,204,204,255,0,125,158,2,0,0,0,207,207,207,207,255,0,132,158,2,0,0,0,209,209,209,209,255,0,139,158,2,0,0,0,212,212,212,212,255,0,146,158,2,0,0,0,214,214,214,214,255,0,153,158,2,0,0,0,217,217,217,217,255,0,160,158,2,0,0,0,219,219,219,219,255,0,167,158,2,0,0,0,222,222,222,222,255,0,174,158,2,0,0,0,224,224,224,224,255,0,181,158,2,0,0,0,227,227,227,227,255,0,188,158,2,0,0,0,23,23,23,23,255,0,194,158,2,0,0,0,229,229,229,229,255,0,201,158,2,0,0,0,232,232,232,232,255,0,208,158,2,0,0,0,235,235,235,235,255,0,215,158,2,0,0,0,237,237,237,237,255,0,222,158,2,0,0,0,240,240,240,240,255,0,229,158,2,0,0,0,242,242,242,242,255,0,236,158,2,0,0,0,245,245,245,245,255,0,243,158,2,0,0,0,247,247,247,247,255,0,250,158,2,0,0,0,250,250,250,250,255,0,1,159,2,0,0,0,252,252,252,252,255,0,8,159,2,0,85,15,255,240,255,240,255,0,17,159,2,0,85,15,255,240,255,240,255,0,27,159,2,0,85,15,238,224,238,224,255,0,37,159,2,0,85,14,205,193,205,193,255,0,47,159,2,0,85,14,139,131,139,131,255,0,57,159,2,0,233,150,255,255,105,180,255,0,65,159,2,0,234,145,255,255,110,180,255,0,74,159,2,0,235,141,238,238,106,167,255,0,83,159,2,0,236,135,205,205,96,144,255,0,92,159,2,0,234,148,139,139,58,98,255,0,101,159,2,0,0,140,205,205,92,92,255,0,111,159,2,0,0,148,255,255,106,106,255,0,122,159,2,0,0,148,238,238,99,99,255,0,133,159,2,0,0,149,205,205,85,85,255,0,144,159,2,0,0,148,139,139,58,58,255,0,155,159,2,0,194,255,130,75,0,130,255,0,162,159,2,0,42,0,255,255,255,254,0,0,168,159,2,0,42,15,255,255,255,240,255,0,174,159,2,0,42,15,255,255,255,240,255,0,181,159,2,0,42,15,238,238,238,224,255,0,188,159,2,0,42,14,205,205,205,193,255,0,195,159,2,0,42,14,139,139,139,131,255,0,202,159,2,0,38,106,240,240,230,140,255,0,208,159,2,0,39,112,255,255,246,143,255,0,215,159,2,0,39,112,238,238,230,133,255,0,222,159,2,0,39,111,205,205,198,115,255,0,229,159,2,0,39,111,139,139,134,78,255,0,236,159,2,0,170,20,250,230,230,250,255,0,245,159,2,0,240,15,255,255,240,245,255,0,3,160,2,0,240,15,255,255,240,245,255,0,18,160,2,0,239,15,238,238,224,229,255,0,33,160,2,0,240,14,205,205,193,197,255,0,48,160,2,0,239,14,139,139,131,134,255,0,63,160,2,0,64,255,252,124,252,0,255,0,73,160,2,0,38,49,255,255,250,205,255,0,86,160,2,0,38,49,255,255,250,205,255,0,100,160,2,0,37,50,238,238,233,191,255,0,114,160,2,0,38,49,205,205,201,165,255,0,128,160,2,0,39,49,139,139,137,112,255,0,142,160,2,0,137,63,230,173,216,230,255,0,152,160,2,0,138,64,255,191,239,255,255,0,163,160,2,0,138,64,238,178,223,238,255,0,174,160,2,0,138,63,205,154,192,205,255,0,185,160,2,0,137,64,139,104,131,139,255,0,196,160,2,0,0,119,240,240,128,128,255,0,207,160,2,0,127,31,255,224,255,255,255,0,217,160,2,0,127,31,255,224,255,255,255,0,228,160,2,0,127,31,238,209,238,238,255,0,239,160,2,0,127,31,205,180,205,205,255,0,250,160,2,0,127,31,139,122,139,139,255,0,5,161,2,0,35,115,238,238,221,130,255,0,20,161,2,0,35,116,255,255,236,139,255,0,36,161,2,0,35,115,238,238,220,130,255,0,52,161,2,0,35,115,205,205,190,112,255,0,68,161,2,0,35,115,139,139,129,76,255,0,84,161,2,0,42,40,250,250,250,210,255,0,105,161,2,0,0,0,211,211,211,211,255,0,115,161,2,0,0,0,211,211,211,211,255,0,125,161,2,0,248,73,255,255,182,193,255,0,135,161,2,0,249,81,255,255,174,185,255,0,146,161,2,0,248,81,238,238,162,173,255,0,157,161,2,0,249,80,205,205,140,149,255,0,168,161,2,0,249,80,139,139,95,101,255,0,179,161,2,0,12,132,255,255,160,122,255,0,191,161,2,0,12,132,255,255,160,122,255,0,204,161,2,0,11,132,238,238,149,114,255,0,217,161,2,0,12,133,205,205,129,98,255,0,230,161,2,0,12,133,139,139,87,66,255,0,243,161,2,0,125,209,178,32,178,170,255,0,1,162,2,0,143,117,250,135,206,250,255,0,14,162,2,0,143,79,255,176,226,255,255,0,28,162,2,0,143,79,238,164,211,238,255,0,42,162,2,0,142,79,205,141,182,205,255,0,56,162,2,0,143,78,139,96,123,139,255,0,70,162,2,0,175,143,255,132,112,255,255,0,85,162,2,0,148,56,153,119,136,153,255,0,100,162,2,0,148,56,153,119,136,153,255,0,115,162,2,0,151,52,222,176,196,222,255,0,130,162,2,0,151,53,255,202,225,255,255,0,146,162,2,0,151,53,238,188,210,238,255,0,162,162,2,0,151,53,205,162,181,205,255,0,178,162,2,0,150,53,139,110,123,139,255,0,194,162,2,0,42,31,255,255,255,224,255,0,206,162,2,0,42,31,255,255,255,224,255,0,219,162,2,0,42,31,238,238,238,209,255,0,232,162,2,0,42,31,205,205,205,180,255,0,245,162,2,0,42,31,139,139,139,122,255,0,2,163,2,0,85,192,205,50,205,50,255,0,12,163,2,0,21,20,250,250,240,230,255,0,18,163,2,0,212,255,255,255,0,255,255,0,26,163,2,0,212,255,255,255,0,255,255,0,35,163,2,0,212,255,238,238,0,238,255,0,44,163,2,0,212,255,205,205,0,205,255,0,53,163,2,0,212,255,139,139,0,139,255,0,62,163,2,0,239,185,176,176,48,96,255,0,69,163,2,0,228,203,255,255,52,179,255,0,77,163,2,0,228,203,238,238,48,167,255,0,85,163,2,0,228,204,205,205,41,144,255,0,93,163,2,0,228,203,139,139,28,98,255,0,101,163,2,0,113,128,205,102,205,170,255,0,118,163,2,0,170,255,205,0,0,205,255,0,129,163,2,0,204,152,211,186,85,211,255,0,142,163,2,0,203,153,255,224,102,255,255,0,156,163,2,0,203,153,238,209,95,238,255,0,170,163,2,0,203,153,205,180,82,205,255,0,184,163,2,0,203,154,139,122,55,139,255,0,198,163,2,0,183,124,219,147,112,219,255,0,211,163,2,0,183,125,255,171,130,255,255,0,225,163,2,0,183,125,238,159,121,238,255,0,239,163,2,0,183,125,205,137,104,205,255,0,253,163,2,0,183,124,139,93,71,139,255,0,11,164,2,0,103,169,179,60,179,113,255,0,26,164,2,0,176,143,238,123,104,238,255,0,42,164,2,0,111,255,250,0,250,154,255,0,60,164,2,0,125,167,209,72,209,204,255,0,76,164,2,0,228,228,199,199,21,133,255,0,92,164,2,0,170,198,112,25,25,112,255,0,105,164,2,0,106,9,255,245,255,250,255,0,115,164,2,0,4,30,255,255,228,225,255,0,125,164,2,0,4,30,255,255,228,225,255,0,136,164,2,0,4,30,238,238,213,210,255,0,147,164,2,0,3,29,205,205,183,181,255,0,158,164,2,0,5,29,139,139,125,123,255,0,169,164,2,0,26,73,255,255,228,181,255,0,178,164,2,0,25,81,255,255,222,173,255,0,190,164,2,0,25,81,255,255,222,173,255,0,203,164,2,0,25,82,238,238,207,161,255,0,216,164,2,0,25,82,205,205,179,139,255,0,229,164,2,0,25,82,139,139,121,94,255,0,242,164,2,0,170,255,128,0,0,128,255,0,247,164,2,0,170,255,128,0,0,128,255,0,0,165,2,0,42,0,255,255,255,254,0,0,5,165,2,0,27,23,253,253,245,230,255,0,13,165,2,0,56,192,142,107,142,35,255,0,23,165,2,0,56,193,255,192,255,62,255,0,34,165,2,0,56,192,238,179,238,58,255,0,45,165,2,0,56,192,205,154,205,50,255,0,56,165,2,0,56,192,139,105,139,34,255,0,67,165,2,0,27,255,255,255,165,0,255,0,74,165,2,0,27,255,255,255,165,0,255,0,82,165,2,0,27,255,238,238,154,0,255,0,90,165,2,0,27,255,205,205,133,0,255,0,98,165,2,0,27,255,139,139,90,0,255,0,106,165,2,0,11,255,255,255,69,0,255,0,116,165,2,0,11,255,255,255,69,0,255,0,127,165,2,0,11,255,238,238,64,0,255,0,138,165,2,0,11,255,205,205,55,0,255,0,149,165,2,0,11,255,139,139,37,0,255,0,160,165,2,0,214,123,218,218,112,214,255,0,167,165,2,0,214,124,255,255,131,250,255,0,175,165,2,0,214,124,238,238,122,233,255,0,183,165,2,0,214,124,205,205,105,201,255,0,191,165,2,0,213,124,139,139,71,137,255,0,199,165,2,0,38,72,238,238,232,170,255,0,213,165,2,0,85,100,251,152,251,152,255,0,223,165,2,0,85,101,255,154,255,154,255,0,234,165,2,0,85,100,238,144,238,144,255,0,245,165,2,0,85,100,205,124,205,124,255,0,0,166,2,0,85,100,139,84,139,84,255,0,11,166,2,0,127,67,238,175,238,238,255,0,25,166,2,0,127,68,255,187,255,255,255,0,40,166,2,0,127,68,238,174,238,238,255,0,55,166,2,0,127,68,205,150,205,205,255,0,70,166,2,0,127,67,139,102,139,139,255,0,85,166,2,0,241,124,219,219,112,147,255,0,99,166,2,0,241,125,255,255,130,171,255,0,114,166,2,0,241,125,238,238,121,159,255,0,129,166,2,0,241,125,205,205,104,137,255,0,144,166,2,0,241,124,139,139,71,93,255,0,159,166,2,0,26,41,255,255,239,213,255,0,170,166,2,0,20,70,255,255,218,185,255,0,180,166,2,0,20,70,255,255,218,185,255,0,191,166,2,0,19,69,238,238,203,173,255,0,202,166,2,0,19,69,205,205,175,149,255,0,213,166,2,0,20,69,139,139,119,101,255,0,224,166,2,0,20,176,205,205,133,63,255,0,229,166,2,0,247,63,255,255,192,203,255,0,234,166,2,0,245,73,255,255,181,197,255,0,240,166,2,0,245,73,238,238,169,184,255,0,246,166,2,0,245,74,205,205,145,158,255,0,252,166,2,0,245,73,139,139,99,108,255,0,2,167,2,0,212,70,221,221,160,221,255,0,7,167,2,0,212,68,255,255,187,255,255,0,13,167,2,0,212,68,238,238,174,238,255,0,19,167,2,0,212,68,205,205,150,205,255,0,25,167,2,0,212,67,139,139,102,139,255,0,31,167,2,0,132,59,230,176,224,230,255,0,42,167,2,0,196,221,240,160,32,240,255,0,49,167,2,0,191,207,255,155,48,255,255,0,57,167,2,0,192,207,238,145,44,238,255,0,65,167,2,0,192,207,205,125,38,205,255,0,73,167,2,0,192,207,139,85,26,139,255,0,81,167,2,0,0,255,255,255,0,0,255,0,85,167,2,0,0,255,255,255,0,0,255,0,90,167,2,0,0,255,238,238,0,0,255,0,95,167,2,0,0,255,205,205,0,0,255,0,100,167,2,0,0,255,139,139,0,0,255,0,105,167,2,0,0,61,188,188,143,143,255,0,115,167,2,0,0,62,255,255,193,193,255,0,126,167,2,0,0,62,238,238,180,180,255,0,137,167,2,0,0,62,205,205,155,155,255,0,148,167,2,0,0,62,139,139,105,105,255,0,159,167,2,0,159,181,225,65,105,225,255,0,169,167,2,0,159,183,255,72,118,255,255,0,180,167,2,0,159,183,238,67,110,238,255,0,191,167,2,0,159,182,205,58,95,205,255,0,202,167,2,0,159,183,139,39,64,139,255,0,213,167,2,0,17,220,139,139,69,19,255,0,225,167,2,0,4,138,250,250,128,114,255,0,232,167,2,0,9,150,255,255,140,105,255,0,240,167,2,0,9,150,238,238,130,98,255,0,248,167,2,0,9,150,205,205,112,84,255,0,0,168,2,0,9,150,139,139,76,57,255,0,8,168,2,0,19,154,244,244,164,96,255,0,19,168,2,0,103,170,139,46,139,87,255,0,28,168,2,0,103,171,255,84,255,159,255,0,38,168,2,0,103,171,238,78,238,148,255,0,48,168,2,0,103,171,205,67,205,128,255,0,58,168,2,0,103,170,139,46,139,87,255,0,68,168,2,0,17,16,255,255,245,238,255,0,77,168,2,0,17,16,255,255,245,238,255,0,87,168,2,0,18,17,238,238,229,222,255,0,97,168,2,0,18,17,205,205,197,191,255,0,107,168,2,0,18,16,139,139,134,130,255,0,117,168,2,0,13,183,160,160,82,45,255,0,124,168,2,0,13,184,255,255,130,71,255,0,132,168,2,0,13,184,238,238,121,66,255,0,140,168,2,0,13,184,205,205,104,57,255,0,148,168,2,0,13,185,139,139,71,38,255,0,156,168,2,0,139,108,235,135,206,235,255,0,164,168,2,0,144,120,255,135,206,255,255,0,173,168,2,0,144,120,238,126,192,238,255,0,182,168,2,0,144,120,205,108,166,205,255,0,191,168,2,0,145,119,139,74,112,139,255,0,200,168,2,0,175,143,205,106,90,205,255,0,210,168,2,0,175,144,255,131,111,255,255,0,221,168,2,0,175,144,238,122,103,238,255,0,232,168,2,0,175,144,205,105,89,205,255,0,243,168,2,0,175,144,139,71,60,139,255,0,254,168,2,0,148,56,144,112,128,144,255,0,8,169,2,0,149,56,255,198,226,255,255,0,19,169,2,0,149,56,238,185,211,238,255,0,30,169,2,0,148,57,205,159,182,205,255,0,41,169,2,0,149,56,139,108,123,139,255,0,52,169,2,0,148,56,144,112,128,144,255,0,62,169,2,0,0,5,255,255,250,250,255,0,67,169,2,0,0,5,255,255,250,250,255,0,73,169,2,0,0,5,238,238,233,233,255,0,79,169,2,0,0,4,205,205,201,201,255,0,85,169,2,0,0,3,139,139,137,137,255,0,91,169,2,0,106,255,255,0,255,127,255,0,103,169,2,0,106,255,255,0,255,127,255,0,116,169,2,0,106,255,238,0,238,118,255,0,129,169,2,0,106,255,205,0,205,102,255,0,142,169,2,0,106,255,139,0,139,69,255,0,155,169,2,0,146,155,180,70,130,180,255,0,165,169,2,0,146,156,255,99,184,255,255,0,176,169,2,0,146,156,238,92,172,238,255,0,187,169,2,0,146,156,205,79,148,205,255,0,198,169,2,0,147,155,139,54,100,139,255,0,209,169,2,0,24,84,210,210,180,140,255,0,213,169,2,0,20,176,255,255,165,79,255,0,218,169,2,0,20,176,238,238,154,73,255,0,223,169,2,0,20,176,205,205,133,63,255,0,228,169,2,0,20,176,139,139,90,43,255,0,233,169,2,0,212,29,216,216,191,216,255,0,241,169,2,0,212,30,255,255,225,255,255,0,250,169,2,0,212,30,238,238,210,238,255,0,3,170,2,0,212,29,205,205,181,205,255,0,12,170,2,0,212,29,139,139,123,139,255,0,21,170,2,0,6,184,255,255,99,71,255,0,28,170,2,0,6,184,255,255,99,71,255,0,36,170,2,0,6,184,238,238,92,66,255,0,44,170,2,0,6,184,205,205,79,57,255,0,52,170,2,0,6,185,139,139,54,38,255,0,70,173,2,0,42,0,255,255,255,254,0,0,60,170,2,0,123,182,224,64,224,208,255,0,70,170,2,0,129,255,255,0,245,255,255,0,81,170,2,0,129,255,238,0,229,238,255,0,92,170,2,0,129,255,205,0,197,205,255,0,103,170,2,0,129,255,139,0,134,139,255,0,114,170,2,0,212,115,238,238,130,238,255,0,121,170,2,0,227,215,208,208,32,144,255,0,131,170,2,0,235,193,255,255,62,150,255,0,142,170,2,0,235,192,238,238,58,140,255,0,153,170,2,0,235,192,205,205,50,120,255,0,164,170,2,0,235,192,139,139,34,82,255,0,175,170,2,0,27,68,245,245,222,179,255,0,181,170,2,0,27,69,255,255,231,186,255,0,188,170,2,0,27,68,238,238,216,174,255,0,195,170,2,0,27,68,205,205,186,150,255,0,202,170,2,0,27,67,139,139,126,102,255,0,209,170,2,0,0,0,255,255,255,255,255,0,215,170,2,0,0,0,245,245,245,245,255,0,226,170,2,0,42,255,255,255,255,0,255,0,233,170,2,0,42,255,255,255,255,0,255,0,241,170,2,0,42,255,238,238,238,0,255,0,249,170,2,0,42,255,205,205,205,0,255,0,1,171,2,0,42,255,139,139,139,0,255,0,9,171,2,0,56,192,205,154,205,50,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,227,175,2,0,228,172,2,0,230,172,2,0,232,172,2,0,234,172,2,0,236,172,2,0,238,172,2,0,240,172,2,0,242,172,2,0,244,172,2,0,246,172,2,0,249,172,2,0,252,172,2,0,255,172,2,0,2,173,2,0,5,173,2,0,8,173,2,0,11,173,2,0,14,173,2,0,17,173,2,0,20,173,2,0,0,0,0,0,0,0,0,0,4,0,0,0,4,0,0,0,13,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,173,2,0,175,174,2,0,8,0,0,0,16,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,16,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,173,185,2,0,165,185,2,0,63,186,2,0,9,0,0,0,69,186,2,0,10,0,0,0,78,186,2,0,11,0,0,0,144,186,2,0,12,0,0,0,150,186,2,0,13,0,0,0,155,186,2,0,14,0,0,0,78,186,2,0,15,0,0,0,35,187,2,0,16,0,0,0,42,187,2,0,17,0,0,0,50,187,2,0,18,0,0,0,57,187,2,0,19,0,0,0,69,187,2,0,20,0,0,0,144,186,2,0,21,0,0,0,81,187,2,0,22,0,0,0,89,187,2,0,23,0,0,0,99,187,2,0,24,0,0,0,113,187,2,0,25,0,0,0,120,187,2,0,26,0,0,0,125,187,2,0,27,0,0,0,128,187,2,0,28,0,0,0,133,187,2,0,29,0,0,0,141,187,2,0,30,0,0,0,147,187,2,0,31,0,0,0,153,187,2,0,32,0,0,0,160,187,2,0,33,0,0,0,166,187,2,0,33,0,0,0,174,187,2,0,34,0,0,0,181,187,2,0,35,0,0,0,78,186,2,0,36,0,0,0,42,187,2,0,17,0,0,0,50,187,2,0,18,0,0,0,172,189,2,0,37,0,0,0,57,187,2,0,19,0,0,0,69,187,2,0,20,0,0,0,144,186,2,0,21,0,0,0,183,189,2,0,38,0,0,0,89,187,2,0,23,0,0,0,99,187,2,0,24,0,0,0,113,187,2,0,25,0,0,0,120,187,2,0,26,0,0,0,125,187,2,0,27,0,0,0,128,187,2,0,28,0,0,0,191,189,2,0,39,0,0,0,141,187,2,0,30,0,0,0,147,187,2,0,31,0,0,0,153,187,2,0,32,0,0,0,160,187,2,0,33,0,0,0,166,187,2,0,33,0,0,0,174,187,2,0,34,0,0,0,181,187,2,0,35,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,164,191,2,0,178,191,2,0,191,191,2,0,208,191,2,0,240,191,2,0,255,191,2,0,17,192,2,0,32,192,2,0,52,192,2,0,80,192,2,0,115,192,2,0,132,192,2,0,159,192,2,0,179,192,2,0,217,192,2,0,244,192,2,0,30,193,2,0,77,193,2,0,94,193,2,0,145,193,2,0,168,193,2,0,214,193,2,0,241,193,2,0,36,194,2,0,72,194,2,0,124,194,2,0,169,194,2,0,184,194,2,0,210,194,2,0,248,194,2,0,24,195,2,0,57,195,2,0,91,195,2,0,108,195,2,0,129,195,2,0,145,195,2,0,162,195,2,0,206,195,2,0,30,196,2,0,89,196,2,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,40,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,15,0,0,0,23,0,0,0,31,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,40,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,15,0,0,0,23,0,0,0,31,0,0,0,8,0,0,0,9,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+84472);allocate([22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,45,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,40,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,15,0,0,0,23,0,0,0,31,0,0,0,8,0,0,0,9,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,45,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,92,116,1,0,204,117,1,0,60,119,1,0,172,120,1,0,172,120,1,0,28,122,1,0,60,119,1,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,40,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,15,0,0,0,23,0,0,0,31,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,40,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,15,0,0,0,23,0,0,0,31,0,0,0,10,0,0,0,7,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,40,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,15,0,0,0,23,0,0,0,31,0,0,0,8,0,0,0,9,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,45,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,16,0,0,0,38,0,0,0,51,0,0,0,52,0,0,0,39,0,0,0,53,0,0,0,17,0,0,0,24,0,0,0,40,0,0,0,11,0,0,0,12,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,18,0,0,0,47,0,0,0,54,0,0,0,55,0,0,0,48,0,0,0,56,0,0,0,19,0,0,0,25,0,0,0,49,0,0,0,13,0,0,0,14,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,106,1,0,168,123,1,0,24,125,1,0,136,126,1,0,136,126,1,0,248,127,1,0,24,125,1,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,40,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,15,0,0,0,23,0,0,0,31,0,0,0,10,0,0,0,7,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,40,0,0,0,41,0,0,0,30,0,0,0,42,0,0,0,15,0,0,0,23,0,0,0,31,0,0,0,8,0,0,0,9,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,45,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,16,0,0,0,38,0,0,0,51,0,0,0,52,0,0,0,39,0,0,0,53,0,0,0,17,0,0,0,24,0,0,0,40,0,0,0,11,0,0,0,12,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,18,0,0,0,47,0,0,0,54,0,0,0,55,0,0,0,48,0,0,0,56,0,0,0,19,0,0,0,25,0,0,0,49,0,0,0,13,0,0,0,14,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,33,2,0,127,199,2,0,8,33,2,0,74,199,2,0,136,199,2,0,145,199,2,0,240,199,2,0,246,199,2,0,249,199,2,0,255,199,2,0,154,199,2,0,6,200,2,0,15,200,2,0,23,200,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,184,132,1,0,40,133,1,0,152,133,1,0,152,133,1,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,0,0,0,0,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,3,0,0,0,4,0,0,0,4,0,0,0,6,0,0,0,131,249,162,0,68,78,110,0,252,41,21,0,209,87,39,0,221,52,245,0,98,219,192,0,60,153,149,0,65,144,67,0,99,81,254,0,187,222,171,0,183,97,197,0,58,110,36,0,210,77,66,0,73,6,224,0,9,234,46,0,28,146,209,0,235,29,254,0,41,177,28,0,232,62,167,0,245,53,130,0,68,187,46,0,156,233,132,0,180,38,112,0,65,126,95,0,214,145,57,0,83,131,57,0,156,244,57,0,139,95,132,0,40,249,189,0,248,31,59,0,222,255,151,0,15,152,5,0,17,47,239,0,10,90,139,0,109,31,109,0,207,126,54,0,9,203,39,0,70,79,183,0,158,102,63,0,45,234,95,0,186,39,117,0,229,235,199,0,61,123,241,0,247,57,7,0,146,82,138,0,251,107,234,0,31,177,95,0,8,93,141,0,48,3,86,0,123,252,70,0,240,171,107,0,32,188,207,0,54,244,154,0,227,169,29,0,94,97,145,0,8,27,230,0,133,153,101,0,160,20,95,0,141,64,104,0,128,216,255,0,39,115,77,0,6,6,49,0,202,86,21,0,201,168,115,0,123,226,96,0,107,140,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,0,0,0,22,0,0,0,88,241,2,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,0,0,0,0,0,0,22,0,0,0,80,237,2,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,0,0,22,0,0,0,72,233,2,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,110,243,2,0,110,0,0,0,112,243,2,0,114,0,0,0,114,243,2,0,102,0,0,0,116,243,2,0,97,0,0,0,118,243,2,0,101,0,0,0,120,243,2,0,119,0,0,0,122,243,2,0,87,0,0,0,135,243,2,0,115,0,0,0,149,243,2,0,83,0,0,0,161,243,2,0,100,0,0,0,174,243,2,0,68,0,0,0,186,243,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+94712);allocate([4,0,4,0,27,0,27,0,32,0,32,0,35,0,33,0,10,0,2,0,22,0,9,0,33,0,33,0,33,0,21,0,28,0,1,0,20,0,20,0,20,0,20,0,20,0,20,0,20,0,8,0,4,0,5,0,27,0,2,0,23,0,27,0,32,0,31,0,30,0,29,0,9,0,19,0,0,0,21,0,18,0,21,0,3,0,7,0,21,0,21,0,20,0,20,0,20,0,20,0,20,0,20,0,20,0,20,0,8,0,4,0,5,0,5,0,6,0,27,0,26,0,24,0,25,0,32,0,7,0,21,0,20,0,20,0,20,0,20,0,20,0,20,0,11,0,20,0,13,0,20,0,12,0,20,0,20,0,20,0,14,0,20,0,20,0,20,0,16,0,20,0,15,0,20,0,17,0,0,0,0,0,0,0,142,0,46,0,47,0,51,0,53,0,48,0,55,0,146,0,230,0,230,0,230,0,230,0,0,0,61,0,125,0,55,0,55,0,230,0,230,0,0,0,40,0,53,0,46,0,50,0,47,0,81,0,0,0,0,0,71,0,0,0,0,0,230,0,81,0,0,0,230,0,230,0,230,0,0,0,230,0,113,0,85,0,230,0,86,0,230,0,0,0,89,0,230,0,0,0,62,0,66,0,75,0,83,0,77,0,86,0,67,0,0,0,0,0,98,0,99,0,230,0,0,0,230,0,230,0,230,0,0,0,0,0,102,0,83,0,95,0,90,0,98,0,98,0,101,0,0,0,108,0,0,0,103,0,0,0,110,0,102,0,104,0,0,0,104,0,120,0,117,0,0,0,116,0,0,0,121,0,0,0,230,0,158,0,165,0,172,0,179,0,182,0,73,0,188,0,195,0,202,0,209,0,216,0,222,0,0,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,1,0,3,0,4,0,7,0,3,0,4,0,5,0,5,0,6,0,6,0,8,0,7,0,7,0,17,0,22,0,18,0,17,0,18,0,8,0,8,0,15,0,15,0,23,0,15,0,24,0,15,0,25,0,26,0,26,0,30,0,22,0,98,0,30,0,5,0,50,0,6,0,34,0,34,0,51,0,23,0,24,0,52,0,25,0,26,0,26,0,42,0,44,0,42,0,44,0,47,0,50,0,47,0,53,0,55,0,51,0,54,0,59,0,60,0,52,0,59,0,60,0,69,0,68,0,34,0,68,0,70,0,56,0,71,0,72,0,53,0,55,0,54,0,73,0,74,0,76,0,41,0,78,0,69,0,80,0,27,0,81,0,82,0,70,0,71,0,84,0,72,0,85,0,16,0,73,0,74,0,86,0,76,0,78,0,88,0,90,0,80,0,81,0,82,0,9,0,2,0,84,0,0,0,0,0,85,0,0,0,0,0,86,0,0,0,0,0,88,0,90,0,93,0,93,0,93,0,93,0,93,0,93,0,93,0,94,0,94,0,94,0,94,0,94,0,94,0,94,0,95,0,95,0,95,0,95,0,95,0,95,0,95,0,96,0,0,0,96,0,96,0,96,0,96,0,96,0,97,0,97,0,99,0,0,0,99,0,99,0,99,0,99,0,99,0,100,0,0,0,100,0,0,0,100,0,100,0,100,0,101,0,0,0,101,0,101,0,101,0,101,0,101,0,102,0,102,0,0,0,102,0,102,0,102,0,102,0,103,0,0,0,103,0,103,0,103,0,103,0,104,0,0,0,104,0,104,0,104,0,104,0,104,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,0,0,92,0,1,0,93,0,93,0,94,0,94,0,95,0,95,0,92,0,92,0,92,0,92,0,92,0,96,0,92,0,92,0,92,0,97,0,92,0,92,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,99,0,100,0,101,0,102,0,102,0,92,0,92,0,103,0,92,0,92,0,92,0,96,0,92,0,92,0,97,0,92,0,97,0,92,0,104,0,97,0,92,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,99,0,100,0,101,0,101,0,92,0,102,0,92,0,92,0,92,0,103,0,104,0,97,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,98,0,0,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,0,0,10,0,11,0,12,0,13,0,14,0,10,0,15,0,16,0,17,0,18,0,19,0,10,0,20,0,21,0,21,0,21,0,22,0,23,0,21,0,24,0,21,0,21,0,25,0,21,0,21,0,21,0,26,0,21,0,21,0,10,0,21,0,21,0,21,0,22,0,23,0,24,0,21,0,21,0,25,0,21,0,21,0,21,0,26,0,21,0,21,0,21,0,21,0,27,0,12,0,12,0,36,0,30,0,30,0,32,0,33,0,32,0,33,0,36,0,37,0,38,0,45,0,50,0,47,0,46,0,42,0,37,0,38,0,40,0,41,0,51,0,42,0,52,0,43,0,53,0,54,0,55,0,60,0,50,0,49,0,61,0,34,0,69,0,34,0,63,0,64,0,70,0,51,0,52,0,71,0,53,0,54,0,55,0,47,0,92,0,42,0,44,0,92,0,69,0,68,0,72,0,74,0,70,0,73,0,92,0,60,0,71,0,92,0,61,0,76,0,92,0,65,0,68,0,77,0,75,0,78,0,79,0,72,0,74,0,73,0,80,0,81,0,82,0,44,0,83,0,76,0,84,0,56,0,85,0,86,0,77,0,78,0,87,0,79,0,88,0,44,0,80,0,81,0,89,0,82,0,83,0,90,0,91,0,84,0,85,0,86,0,92,0,28,0,87,0,92,0,92,0,88,0,92,0,92,0,89,0,92,0,92,0,90,0,91,0,29,0,29,0,29,0,29,0,29,0,29,0,29,0,31,0,31,0,31,0,31,0,31,0,31,0,31,0,35,0,35,0,35,0,35,0,35,0,35,0,35,0,39,0,92,0,39,0,39,0,39,0,39,0,39,0,48,0,48,0,57,0,92,0,57,0,57,0,57,0,57,0,57,0,58,0,92,0,58,0,92,0,58,0,58,0,58,0,59,0,92,0,59,0,59,0,59,0,59,0,59,0,62,0,62,0,92,0,62,0,62,0,62,0,62,0,66,0,92,0,66,0,66,0,66,0,66,0,67,0,92,0,67,0,67,0,67,0,67,0,67,0,9,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,92,0,8,0,174,255,209,0,10,0,174,255,174,255,11,0,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,5,0,209,0,174,255,209,0,209,0,209,0,209,0,209,0,209,0,209,0,209,0,174,255,251,255,174,255,14,0,236,255,174,255,174,255,174,255,174,255,209,0,209,0,209,0,209,0,209,0,13,0,37,0,12,0,66,0,16,0,80,0,19,0,109,0,123,0,20,0,152,0,15,0,166,0,195,0,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,23,0,174,255,119,0,174,255,7,0,46,0,174,255,38,0,174,255,23,0,17,0,35,0,174,255,13,0,174,255,174,255,174,255,174,255,58,0,174,255,174,255,53,0,174,255,174,255,174,255,40,0,174,255,7,0,174,255,59,0,69,0,174,255,72,0,174,255,174,255,174,255,174,255,174,255,174,255,174,255,252,255,232,0,246,255,255,255,26,0,0,0,39,0,1,0,50,0,174,255,174,255,2,0,36,0,3,0,47,0,174,255,174,255,174,255,174,255,174,255,254,255,148,0,174,255,9,0,27,0,174,255,188,255,174,255,174,255,175,255,174,255,174,255,174,255,174,255,174,255,174,255,174,255,0,0,0,0,0,0,109,230,236,222,5,0,11,0,0,0,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,123,32,97,112,112,101,110,100,69,114,114,111,114,40,36,48,41,59,32,125,0,99,111,114,101,0,73,32,0,120,100,111,116,0,100,111,116,58,100,111,116,0,103,118,58,100,111,116,0,99,97,110,111,110,58,100,111,116,0,112,108,97,105,110,58,100,111,116,0,112,108,97,105,110,45,101,120,116,58,100,111,116,0,120,100,111,116,58,120,100,111,116,0,120,100,111,116,49,46,50,58,120,100,111,116,0,120,100,111,116,49,46,52,58,120,100,111,116,0,32,37,100,32,0,0,0,0,0,0,0,0,0,0,0,35,37,48,50,120,37,48,50,120,37,48,50,120,37,48,50,120,0,115,101,116,108,105,110,101,119,105,100,116,104,40,0,37,46,51,102,0,83,32,0,67,32,0,50,32,0,37,115,37,100,32,45,0,69,32,0,101,32,0,70,32,0,116,32,37,117,32,0,84,32,0,120,100,111,116,118,101,114,115,105,111,110,0,49,46,52,0,49,46,50,0,49,46,55,0,95,108,100,114,97,119,95,0,95,104,100,114,97,119,95,0,95,116,100,114,97,119,95,0,95,104,108,100,114,97,119,95,0,95,116,108,100,114,97,119,95,0,120,100,111,116,32,118,101,114,115,105,111,110,32,34,37,115,34,32,116,111,111,32,108,111,110,103,0,37,46,48,50,102,0,102,105,103,0,102,105,103,58,102,105,103,0,35,32,37,115,10,0,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,46,49,102,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,10,0,110,32,62,61,32,52,0,103,118,114,101,110,100,101,114,95,99,111,114,101,95,102,105,103,46,99,0,102,105,103,95,98,101,122,105,101,114,0,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,46,49,102,32,37,100,32,37,100,32,37,100,32,37,100,10,0,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,46,51,102,32,37,100,32,37,46,52,102,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,10,0,37,100,32,37,100,32,35,37,48,50,120,37,48,50,120,37,48,50,120,10,0,102,105,103,95,114,101,115,111,108,118,101,95,99,111,108,111,114,0,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,46,49,102,32,37,46,52,102,32,37,100,32,37,46,49,102,32,37,46,49,102,32,37,100,32,37,100,32,37,115,92,48,48,49,10,0,35,32,101,110,100,32,111,102,32,70,73,71,32,102,105,108,101,10,0,35,70,73,71,32,51,46,50,10,0,35,32,71,101,110,101,114,97,116,101,100,32,98,121,32,37,115,32,118,101,114,115,105,111,110,32,37,115,32,40,37,115,41,10,0,35,32,84,105,116,108,101,58,32,37,115,10,0,35,32,80,97,103,101,115,58,32,37,100,10,0,80,111,114,116,114,97,105,116,10,0,67,101,110,116,101,114,10,0,73,110,99,104,101,115,10,0,76,101,116,116,101,114,10,0,49,48,48,46,48,48,10,0,83,105,110,103,108,101,10,0,45,50,10,0,49,50,48,48,0,32,50,10,0,109,97,112,0,105,115,109,97,112,58,109,97,112,0,99,109,97,112,58,109,97,112,0,105,109,97,112,58,109,97,112,0,99,109,97,112,120,58,109,97,112,0,105,109,97,112,95,110,112,58,109,97,112,0,99,109,97,112,120,95,110,112,58,109,97,112,0,114,101,99,116,32,37,115,32,37,100,44,37,100,32,37,100,44,37,100,10,0,99,105,114,99,108,101,32,37,115,32,37,100,44,37,100,44,37,100,10,0,112,111,108,121,32,37,115,0,32,37,100,44,37,100,0,103,118,114,101,110,100,101,114,95,99,111,114,101,95,109,97,112,46,99,0,109,97,112,95,111,117,116,112,117,116,95,115,104,97,112,101,0,114,101,99,116,97,110,103,108,101,32,40,37,100,44,37,100,41,32,40,37,100,44,37,100,41,32,37,115,32,37,115,10,0,60,97,114,101,97,32,115,104,97,112,101,61,34,99,105,114,99,108,101,34,0,60,97,114,101,97,32,115,104,97,112,101,61,34,114,101,99,116,34,0,60,97,114,101,97,32,115,104,97,112,101,61,34,112,111,108,121,34,0,32,105,100,61,34,0,32,104,114,101,102,61,34,0,32,116,105,116,108,101,61,34,0,32,97,108,116,61,34,34,0,32,99,111,111,114,100,115,61,34,0,37,100,44,37,100,44,37,100,0,37,100,44,37,100,44,37,100,44,37,100,0,37,100,44,37,100,0,44,37,100,44,37,100,0,34,62,10,0,60,47,109,97,112,62,10,0,98,97,115,101,32,114,101,102,101,114,101,114,10,0,100,101,102,97,117,108,116,32,0,60,109,97,112,32,105,100,61,34,0,34,32,110,97,109,101,61,34,0,112,115,50,58,112,115,0,32,93,32,32,37,100,32,116,114,117,101,32,37,115,10,0,32,93,32,32,37,100,32,102,97,108,115,101,32,37,115,10,0,32,115,101,116,108,105,110,101,119,105,100,116,104,10,0,37,115,32,0,115,101,116,104,115,98,0,37,46,53,103,32,37,46,53,103,32,37,46,53,103,32,37,115,99,111,108,111,114,10,0,37,32,0,110,101,119,112,97,116,104,32,0,32,109,111,118,101,116,111,10,0,32,108,105,110,101,116,111,10,0,115,116,114,111,107,101,10,0,32,99,117,114,118,101,116,111,10,0,99,108,111,115,101,112,97,116,104,32,102,105,108,108,10,0,99,108,111,115,101,112,97,116,104,32,115,116,114,111,107,101,10,0,32,101,108,108,105,112,115,101,95,112,97,116,104,32,102,105,108,108,10,0,32,101,108,108,105,112,115,101,95,112,97,116,104,32,115,116,114,111,107,101,10,0,32,47,37,115,32,115,101,116,95,102,111,110,116,10,0,32,109,111,118,101,116,111,32,0,32,37,115,32,97,108,105,103,110,101,100,116,101,120,116,10,0,91,32,47,82,101,99,116,32,91,32,0,32,93,10,0,32,32,47,66,111,114,100,101,114,32,91,32,48,32,48,32,48,32,93,10,32,32,47,65,99,116,105,111,110,32,60,60,32,47,83,117,98,116,121,112,101,32,47,85,82,73,32,47,85,82,73,32,37,115,32,62,62,10,32,32,47,83,117,98,116,121,112,101,32,47,76,105,110,107,10,47,65,78,78,32,112,100,102,109,97,114,107,10,0,103,115,97,118,101,10,0,37,37,32,37,115,10,0,48,32,48,32,48,32,101,100,103,101,99,111,108,111,114,10,0,101,110,100,112,97,103,101,10,115,104,111,119,112,97,103,101,10,103,114,101,115,116,111,114,101,10,0,37,37,80,97,103,101,84,114,97,105,108,101,114,10,0,37,37,37,37,69,110,100,80,97,103,101,58,32,37,100,10,0,37,37,37,37,80,97,103,101,58,32,37,100,32,37,100,10,0,37,37,37,37,80,97,103,101,66,111,117,110,100,105,110,103,66,111,120,58,32,37,100,32,37,100,32,37,100,32,37,100,10,0,76,97,110,100,115,99,97,112,101,0,80,111,114,116,114,97,105,116,0,37,37,37,37,80,97,103,101,79,114,105,101,110,116,97,116,105,111,110,58,32,37,115,10,0,60,60,32,47,80,97,103,101,83,105,122,101,32,91,37,100,32,37,100,93,32,62,62,32,115,101,116,112,97,103,101,100,101,118,105,99,101,10,0,37,100,32,37,100,32,37,100,32,98,101,103,105,110,112,97,103,101,10,0,103,115,97,118,101,10,37,100,32,37,100,32,37,100,32,37,100,32,98,111,120,112,114,105,109,32,99,108,105,112,32,110,101,119,112,97,116,104,10,0,37,103,32,37,103,32,115,101,116,95,115,99,97,108,101,32,37,100,32,114,111,116,97,116,101,32,37,103,32,37,103,32,116,114,97,110,115,108,97,116,101,10,0,99,97,110,118,97,115,32,115,105,122,101,32,40,37,100,44,37,100,41,32,101,120,99,101,101,100,115,32,80,68,70,32,108,105,109,105,116,32,40,37,100,41,10,9,40,115,117,103,103,101,115,116,32,115,101,116,116,105,110,103,32,97,32,98,111,117,110,100,105,110,103,32,98,111,120,32,115,105,122,101,44,32,115,101,101,32,100,111,116,40,49,41,41,10,0,91,32,47,67,114,111,112,66,111,120,32,91,37,100,32,37,100,32,37,100,32,37,100,93,32,47,80,65,71,69,83,32,112,100,102,109,97,114,107,10,0,37,100,32,37,100,32,115,101,116,108,97,121,101,114,10,0,0,37,37,37,37,84,105,116,108,101,58,32,37,115,10,0,37,37,80,97,103,101,115,58,32,40,97,116,101,110,100,41,10,0,37,37,80,97,103,101,115,58,32,49,10,0,37,37,66,111,117,110,100,105,110,103,66,111,120,58,32,40,97,116,101,110,100,41,10,0,37,37,37,37,66,111,117,110,100,105,110,103,66,111,120,58,32,37,100,32,37,100,32,37,100,32,37,100,10,0,37,37,69,110,100,67,111,109,109,101,110,116,115,10,115,97,118,101,10,0,115,101,116,117,112,76,97,116,105,110,49,10,0,91,32,123,67,97,116,97,108,111,103,125,32,60,60,32,47,85,82,73,32,60,60,32,47,66,97,115,101,32,37,115,32,62,62,32,62,62,10,47,80,85,84,32,112,100,102,109,97,114,107,10,0,37,37,66,101,103,105,110,80,114,111,108,111,103,0,47,68,111,116,68,105,99,116,32,50,48,48,32,100,105,99,116,32,100,101,102,0,68,111,116,68,105,99,116,32,98,101,103,105,110,0,47,115,101,116,117,112,76,97,116,105,110,49,32,123,0,109,97,114,107,0,47,69,110,99,111,100,105,110,103,86,101,99,116,111,114,32,50,53,54,32,97,114,114,97,121,32,100,101,102,0,32,69,110,99,111,100,105,110,103,86,101,99,116,111,114,32,48,0,73,83,79,76,97,116,105,110,49,69,110,99,111,100,105,110,103,32,48,32,50,53,53,32,103,101,116,105,110,116,101,114,118,97,108,32,112,117,116,105,110,116,101,114,118,97,108,0,69,110,99,111,100,105,110,103,86,101,99,116,111,114,32,52,53,32,47,104,121,112,104,101,110,32,112,117,116,0,37,32,83,101,116,32,117,112,32,73,83,79,32,76,97,116,105,110,32,49,32,99,104,97,114,97,99,116,101,114,32,101,110,99,111,100,105,110,103,0,47,115,116,97,114,110,101,116,73,83,79,32,123,0,32,32,32,32,32,32,32,32,100,117,112,32,100,117,112,32,102,105,110,100,102,111,110,116,32,100,117,112,32,108,101,110,103,116,104,32,100,105,99,116,32,98,101,103,105,110,0,32,32,32,32,32,32,32,32,123,32,49,32,105,110,100,101,120,32,47,70,73,68,32,110,101,32,123,32,100,101,102,32,125,123,32,112,111,112,32,112,111,112,32,125,32,105,102,101,108,115,101,0,32,32,32,32,32,32,32,32,125,32,102,111,114,97,108,108,0,32,32,32,32,32,32,32,32,47,69,110,99,111,100,105,110,103,32,69,110,99,111,100,105,110,103,86,101,99,116,111,114,32,100,101,102,0,32,32,32,32,32,32,32,32,99,117,114,114,101,110,116,100,105,99,116,32,101,110,100,32,100,101,102,105,110,101,102,111,110,116,0,125,32,100,101,102,0,47,84,105,109,101,115,45,82,111,109,97,110,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,84,105,109,101,115,45,73,116,97,108,105,99,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,84,105,109,101,115,45,66,111,108,100,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,84,105,109,101,115,45,66,111,108,100,73,116,97,108,105,99,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,72,101,108,118,101,116,105,99,97,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,72,101,108,118,101,116,105,99,97,45,79,98,108,105,113,117,101,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,72,101,108,118,101,116,105,99,97,45,66,111,108,100,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,72,101,108,118,101,116,105,99,97,45,66,111,108,100,79,98,108,105,113,117,101,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,67,111,117,114,105,101,114,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,67,111,117,114,105,101,114,45,79,98,108,105,113,117,101,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,67,111,117,114,105,101,114,45,66,111,108,100,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,47,67,111,117,114,105,101,114,45,66,111,108,100,79,98,108,105,113,117,101,32,115,116,97,114,110,101,116,73,83,79,32,100,101,102,0,99,108,101,97,114,116,111,109,97,114,107,0,125,32,98,105,110,100,32,100,101,102,0,37,37,66,101,103,105,110,82,101,115,111,117,114,99,101,58,32,112,114,111,99,115,101,116,32,103,114,97,112,104,118,105,122,32,48,32,48,0,47,99,111,111,114,100,45,102,111,110,116,45,102,97,109,105,108,121,32,47,84,105,109,101,115,45,82,111,109,97,110,32,100,101,102,0,47,100,101,102,97,117,108,116,45,102,111,110,116,45,102,97,109,105,108,121,32,47,84,105,109,101,115,45,82,111,109,97,110,32,100,101,102,0,47,99,111,111,114,100,102,111,110,116,32,99,111,111,114,100,45,102,111,110,116,45,102,97,109,105,108,121,32,102,105,110,100,102,111,110,116,32,56,32,115,99,97,108,101,102,111,110,116,32,100,101,102,0,47,73,110,118,83,99,97,108,101,70,97,99,116,111,114,32,49,46,48,32,100,101,102,0,47,115,101,116,95,115,99,97,108,101,32,123,0,32,32,32,32,32,32,32,100,117,112,32,49,32,101,120,99,104,32,100,105,118,32,47,73,110,118,83,99,97,108,101,70,97,99,116,111,114,32,101,120,99,104,32,100,101,102,0,32,32,32,32,32,32,32,115,99,97,108,101,0,37,32,115,116,121,108,101,115,0,47,115,111,108,105,100,32,123,32,91,93,32,48,32,115,101,116,100,97,115,104,32,125,32,98,105,110,100,32,100,101,102,0,47,100,97,115,104,101,100,32,123,32,91,57,32,73,110,118,83,99,97,108,101,70,97,99,116,111,114,32,109,117,108,32,100,117,112,32,93,32,48,32,115,101,116,100,97,115,104,32,125,32,98,105,110,100,32,100,101,102,0,47,100,111,116,116,101,100,32,123,32,91,49,32,73,110,118,83,99,97,108,101,70,97,99,116,111,114,32,109,117,108,32,54,32,73,110,118,83,99,97,108,101,70,97,99,116,111,114,32,109,117,108,93,32,48,32,115,101,116,100,97,115,104,32,125,32,98,105,110,100,32,100,101,102,0,47,105,110,118,105,115,32,123,47,102,105,108,108,32,123,110,101,119,112,97,116,104,125,32,100,101,102,32,47,115,116,114,111,107,101,32,123,110,101,119,112,97,116,104,125,32,100,101,102,32,47,115,104,111,119,32,123,112,111,112,32,110,101,119,112,97,116,104,125,32,100,101,102,125,32,98,105,110,100,32,100,101,102,0,47,98,111,108,100,32,123,32,50,32,115,101,116,108,105,110,101,119,105,100,116,104,32,125,32,98,105,110,100,32,100,101,102,0,47,102,105,108,108,101,100,32,123,32,125,32,98,105,110,100,32,100,101,102,0,47,117,110,102,105,108,108,101,100,32,123,32,125,32,98,105,110,100,32,100,101,102,0,47,114,111,117,110,100,101,100,32,123,32,125,32,98,105,110,100,32,100,101,102,0,47,100,105,97,103,111,110,97,108,115,32,123,32,125,32,98,105,110,100,32,100,101,102,0,47,116,97,112,101,114,101,100,32,123,32,125,32,98,105,110,100,32,100,101,102,0,37,32,104,111,111,107,115,32,102,111,114,32,115,101,116,116,105,110,103,32,99,111,108,111,114,32,0,47,110,111,100,101,99,111,108,111,114,32,123,32,115,101,116,104,115,98,99,111,108,111,114,32,125,32,98,105,110,100,32,100,101,102,0,47,101,100,103,101,99,111,108,111,114,32,123,32,115,101,116,104,115,98,99,111,108,111,114,32,125,32,98,105,110,100,32,100,101,102,0,47,103,114,97,112,104,99,111,108,111,114,32,123,32,115,101,116,104,115,98,99,111,108,111,114,32,125,32,98,105,110,100,32,100,101,102,0,47,110,111,112,99,111,108,111,114,32,123,112,111,112,32,112,111,112,32,112,111,112,125,32,98,105,110,100,32,100,101,102,0,47,98,101,103,105,110,112,97,103,101,32,123,9,37,32,105,32,106,32,110,112,97,103,101,115,0,9,47,110,112,97,103,101,115,32,101,120,99,104,32,100,101,102,0,9,47,106,32,101,120,99,104,32,100,101,102,0,9,47,105,32,101,120,99,104,32,100,101,102,0,9,47,115,116,114,32,49,48,32,115,116,114,105,110,103,32,100,101,102,0,9,110,112,97,103,101,115,32,49,32,103,116,32,123,0,9,9,103,115,97,118,101,0,9,9,9,99,111,111,114,100,102,111,110,116,32,115,101,116,102,111,110,116,0,9,9,9,48,32,48,32,109,111,118,101,116,111,0,9,9,9,40,92,40,41,32,115,104,111,119,32,105,32,115,116,114,32,99,118,115,32,115,104,111,119,32,40,44,41,32,115,104,111,119,32,106,32,115,116,114,32,99,118,115,32,115,104,111,119,32,40,92,41,41,32,115,104,111,119,0,9,9,103,114,101,115,116,111,114,101,0,9,125,32,105,102,0,47,115,101,116,95,102,111,110,116,32,123,0,9,102,105,110,100,102,111,110,116,32,101,120,99,104,0,9,115,99,97,108,101,102,111,110,116,32,115,101,116,102,111,110,116,0,37,32,100,114,97,119,32,116,101,120,116,32,102,105,116,116,101,100,32,116,111,32,105,116,115,32,101,120,112,101,99,116,101,100,32,119,105,100,116,104,0,47,97,108,105,103,110,101,100,116,101,120,116,32,123,9,9,9,37,32,119,105,100,116,104,32,116,101,120,116,0,9,47,116,101,120,116,32,101,120,99,104,32,100,101,102,0,9,47,119,105,100,116,104,32,101,120,99,104,32,100,101,102,0,9,103,115,97,118,101,0,9,9,119,105,100,116,104,32,48,32,103,116,32,123,0,9,9,9,91,93,32,48,32,115,101,116,100,97,115,104,0,9,9,9,116,101,120,116,32,115,116,114,105,110,103,119,105,100,116,104,32,112,111,112,32,119,105,100,116,104,32,101,120,99,104,32,115,117,98,32,116,101,120,116,32,108,101,110,103,116,104,32,100,105,118,32,48,32,116,101,120,116,32,97,115,104,111,119,0,9,9,125,32,105,102,0,9,103,114,101,115,116,111,114,101,0,47,98,111,120,112,114,105,109,32,123,9,9,9,9,37,32,120,99,111,114,110,101,114,32,121,99,111,114,110,101,114,32,120,115,105,122,101,32,121,115,105,122,101,0,9,9,52,32,50,32,114,111,108,108,0,9,9,109,111,118,101,116,111,0,9,9,50,32,99,111,112,121,0,9,9,101,120,99,104,32,48,32,114,108,105,110,101,116,111,0,9,9,48,32,101,120,99,104,32,114,108,105,110,101,116,111,0,9,9,112,111,112,32,110,101,103,32,48,32,114,108,105,110,101,116,111,0,9,9,99,108,111,115,101,112,97,116,104,0,47,101,108,108,105,112,115,101,95,112,97,116,104,32,123,0,9,47,114,121,32,101,120,99,104,32,100,101,102,0,9,47,114,120,32,101,120,99,104,32,100,101,102,0,9,47,121,32,101,120,99,104,32,100,101,102,0,9,47,120,32,101,120,99,104,32,100,101,102,0,9,109,97,116,114,105,120,32,99,117,114,114,101,110,116,109,97,116,114,105,120,0,9,110,101,119,112,97,116,104,0,9,120,32,121,32,116,114,97,110,115,108,97,116,101,0,9,114,120,32,114,121,32,115,99,97,108,101,0,9,48,32,48,32,49,32,48,32,51,54,48,32,97,114,99,0,9,115,101,116,109,97,116,114,105,120,0,47,101,110,100,112,97,103,101,32,123,32,115,104,111,119,112,97,103,101,32,125,32,98,105,110,100,32,100,101,102,0,47,115,104,111,119,112,97,103,101,32,123,32,125,32,100,101,102,0,47,108,97,121,101,114,99,111,108,111,114,115,101,113,0,9,91,9,37,32,108,97,121,101,114,32,99,111,108,111,114,32,115,101,113,117,101,110,99,101,32,45,32,100,97,114,107,101,115,116,32,116,111,32,108,105,103,104,116,101,115,116,0,9,9,91,48,32,48,32,48,93,0,9,9,91,46,50,32,46,56,32,46,56,93,0,9,9,91,46,52,32,46,56,32,46,56,93,0,9,9,91,46,54,32,46,56,32,46,56,93,0,9,9,91,46,56,32,46,56,32,46,56,93,0,9,93,0,100,101,102,0,47,108,97,121,101,114,108,101,110,32,108,97,121,101,114,99,111,108,111,114,115,101,113,32,108,101,110,103,116,104,32,100,101,102,0,47,115,101,116,108,97,121,101,114,32,123,47,109,97,120,108,97,121,101,114,32,101,120,99,104,32,100,101,102,32,47,99,117,114,108,97,121,101,114,32,101,120,99,104,32,100,101,102,0,9,108,97,121,101,114,99,111,108,111,114,115,101,113,32,99,117,114,108,97,121,101,114,32,49,32,115,117,98,32,108,97,121,101,114,108,101,110,32,109,111,100,32,103,101,116,0,9,97,108,111,97,100,32,112,111,112,32,115,101,116,104,115,98,99,111,108,111,114,0,9,47,110,111,100,101,99,111,108,111,114,32,123,110,111,112,99,111,108,111,114,125,32,100,101,102,0,9,47,101,100,103,101,99,111,108,111,114,32,123,110,111,112,99,111,108,111,114,125,32,100,101,102,0,9,47,103,114,97,112,104,99,111,108,111,114,32,123,110,111,112,99,111,108,111,114,125,32,100,101,102,0,47,111,110,108,97,121,101,114,32,123,32,99,117,114,108,97,121,101,114,32,110,101,32,123,105,110,118,105,115,125,32,105,102,32,125,32,100,101,102,0,47,111,110,108,97,121,101,114,115,32,123,0,9,47,109,121,117,112,112,101,114,32,101,120,99,104,32,100,101,102,0,9,47,109,121,108,111,119,101,114,32,101,120,99,104,32,100,101,102,0,9,99,117,114,108,97,121,101,114,32,109,121,108,111,119,101,114,32,108,116,0,9,99,117,114,108,97,121,101,114,32,109,121,117,112,112,101,114,32,103,116,0,9,111,114,0,9,123,105,110,118,105,115,125,32,105,102,0,47,99,117,114,108,97,121,101,114,32,48,32,100,101,102,0,37,37,69,110,100,82,101,115,111,117,114,99,101,0,37,37,69,110,100,80,114,111,108,111,103,0,37,37,66,101,103,105,110,83,101,116,117,112,0,49,52,32,100,101,102,97,117,108,116,45,102,111,110,116,45,102,97,109,105,108,121,32,115,101,116,95,102,111,110,116,0,49,32,115,101,116,109,105,116,101,114,108,105,109,105,116,0,37,32,47,97,114,114,111,119,108,101,110,103,116,104,32,49,48,32,100,101,102,0,37,32,47,97,114,114,111,119,119,105,100,116,104,32,53,32,100,101,102,0,37,32,109,97,107,101,32,115,117,114,101,32,112,100,102,109,97,114,107,32,105,115,32,104,97,114,109,108,101,115,115,32,102,111,114,32,80,83,45,105,110,116,101,114,112,114,101,116,101,114,115,32,111,116,104,101,114,32,116,104,97,110,32,68,105,115,116,105,108,108,101,114,0,47,112,100,102,109,97,114,107,32,119,104,101,114,101,32,123,112,111,112,125,32,123,117,115,101,114,100,105,99,116,32,47,112,100,102,109,97,114,107,32,47,99,108,101,97,114,116,111,109,97,114,107,32,108,111,97,100,32,112,117,116,125,32,105,102,101,108,115,101,0,37,32,109,97,107,101,32,39,60,60,39,32,97,110,100,32,39,62,62,39,32,115,97,102,101,32,111,110,32,80,83,32,76,101,118,101,108,32,49,32,100,101,118,105,99,101,115,0,47,108,97,110,103,117,97,103,101,108,101,118,101,108,32,119,104,101,114,101,32,123,112,111,112,32,108,97,110,103,117,97,103,101,108,101,118,101,108,125,123,49,125,32,105,102,101,108,115,101,0,50,32,108,116,32,123,0,32,32,32,32,117,115,101,114,100,105,99,116,32,40,60,60,41,32,99,118,110,32,40,91,41,32,99,118,110,32,108,111,97,100,32,112,117,116,0,32,32,32,32,117,115,101,114,100,105,99,116,32,40,62,62,41,32,99,118,110,32,40,91,41,32,99,118,110,32,108,111,97,100,32,112,117,116,0,125,32,105,102,0,37,37,69,110,100,83,101,116,117,112,0,37,37,84,114,97,105,108,101,114,10,0,37,37,37,37,80,97,103,101,115,58,32,37,100,10,0,101,110,100,10,114,101,115,116,111,114,101,10,0,37,37,69,79,70,10,0,37,33,80,83,45,65,100,111,98,101,45,51,46,48,0,32,69,80,83,70,45,51,46,48,10,0,37,37,37,37,67,114,101,97,116,111,114,58,32,37,115,32,118,101,114,115,105,111,110,32,37,115,32,40,37,115,41,10,0,100,97,114,107,98,108,117,101,0,100,97,114,107,99,121,97,110,0,100,97,114,107,103,114,97,121,0,100,97,114,107,103,114,101,121,0,100,97,114,107,109,97,103,101,110,116,97,0,100,97,114,107,114,101,100,0,108,105,103,104,116,103,114,101,101,110,0,60,33,45,45,32,0,60,112,111,108,121,108,105,110,101,0,32,112,111,105,110,116,115,61,34,0,37,103,44,37,103,32,0,34,47,62,10,0,32,102,105,108,108,61,34,0,117,114,108,40,35,108,95,37,100,41,0,117,114,108,40,35,114,95,37,100,41,0,34,32,102,105,108,108,45,111,112,97,99,105,116,121,61,34,37,102,0,34,32,115,116,114,111,107,101,61,34,0,34,32,115,116,114,111,107,101,45,119,105,100,116,104,61,34,37,103,0,34,32,115,116,114,111,107,101,45,100,97,115,104,97,114,114,97,121,61,34,37,115,0,34,32,115,116,114,111,107,101,45,111,112,97,99,105,116,121,61,34,37,102,0,49,44,53,0,53,44,50,0,103,118,114,101,110,100,101,114,95,99,111,114,101,95,115,118,103,46,99,0,115,118,103,95,112,114,105,110,116,95,99,111,108,111,114,0,60,112,97,116,104,0,32,100,61,34,0,37,99,37,103,44,37,103,0,60,100,101,102,115,62,10,60,114,97,100,105,97,108,71,114,97,100,105,101,110,116,32,105,100,61,34,114,95,37,100,34,32,99,120,61,34,53,48,37,37,34,32,99,121,61,34,53,48,37,37,34,32,114,61,34,55,53,37,37,34,32,102,120,61,34,37,100,37,37,34,32,102,121,61,34,37,100,37,37,34,62,10,0,60,115,116,111,112,32,111,102,102,115,101,116,61,34,48,34,32,115,116,121,108,101,61,34,115,116,111,112,45,99,111,108,111,114,58,0,59,115,116,111,112,45,111,112,97,99,105,116,121,58,0,49,46,0,59,34,47,62,10,0,60,115,116,111,112,32,111,102,102,115,101,116,61,34,49,34,32,115,116,121,108,101,61,34,115,116,111,112,45,99,111,108,111,114,58,0,59,34,47,62,10,60,47,114,97,100,105,97,108,71,114,97,100,105,101,110,116,62,10,60,47,100,101,102,115,62,10,0,60,100,101,102,115,62,10,60,108,105,110,101,97,114,71,114,97,100,105,101,110,116,32,105,100,61,34,108,95,37,100,34,32,103,114,97,100,105,101,110,116,85,110,105,116,115,61,34,117,115,101,114,83,112,97,99,101,79,110,85,115,101,34,32,0,120,49,61,34,37,103,34,32,121,49,61,34,37,103,34,32,120,50,61,34,37,103,34,32,121,50,61,34,37,103,34,32,62,10,0,60,115,116,111,112,32,111,102,102,115,101,116,61,34,37,46,48,51,102,34,32,115,116,121,108,101,61,34,115,116,111,112,45,99,111,108,111,114,58,0,59,34,47,62,10,60,47,108,105,110,101,97,114,71,114,97,100,105,101,110,116,62,10,60,47,100,101,102,115,62,10,0,60,112,111,108,121,103,111,110,0,37,103,44,37,103,0,60,101,108,108,105,112,115,101,0,32,99,120,61,34,37,103,34,32,99,121,61,34,37,103,34,0,32,114,120,61,34,37,103,34,32,114,121,61,34,37,103,34,0,60,116,101,120,116,0,32,116,101,120,116,45,97,110,99,104,111,114,61,34,115,116,97,114,116,34,0,32,116,101,120,116,45,97,110,99,104,111,114,61,34,101,110,100,34,0,32,116,101,120,116,45,97,110,99,104,111,114,61,34,109,105,100,100,108,101,34,0,32,120,61,34,37,103,34,32,121,61,34,37,103,34,0,32,102,111,110,116,45,102,97,109,105,108,121,61,34,37,115,0,44,37,115,0,32,102,111,110,116,45,119,101,105,103,104,116,61,34,37,115,34,0,32,102,111,110,116,45,115,116,114,101,116,99,104,61,34,37,115,34,0,32,102,111,110,116,45,115,116,121,108,101,61,34,37,115,34,0,32,102,111,110,116,45,102,97,109,105,108,121,61,34,37,115,34,0,32,102,111,110,116,45,119,101,105,103,104,116,61,34,98,111,108,100,34,0,32,102,111,110,116,45,115,116,121,108,101,61,34,105,116,97,108,105,99,34,0,32,116,101,120,116,45,100,101,99,111,114,97,116,105,111,110,61,34,0,37,115,111,118,101,114,108,105,110,101,0,37,115,108,105,110,101,45,116,104,114,111,117,103,104,0,32,98,97,115,101,108,105,110,101,45,115,104,105,102,116,61,34,115,117,112,101,114,34,0,32,98,97,115,101,108,105,110,101,45,115,104,105,102,116,61,34,115,117,98,34,0,32,102,111,110,116,45,115,105,122,101,61,34,37,46,50,102,34,0,32,102,105,108,108,61,34,37,115,34,0,32,102,105,108,108,61,34,35,37,48,50,120,37,48,50,120,37,48,50,120,34,0,115,118,103,95,116,101,120,116,115,112,97,110,0,62,0,60,47,116,101,120,116,62,10,0,60,47,103,62,10,0,60,103,0,32,105,100,61,34,97,95,0,32,120,108,105,110,107,58,104,114,101,102,61,34,0,32,120,108,105,110,107,58,116,105,116,108,101,61,34,0,32,116,97,114,103,101,116,61,34,0,60,103,32,105,100,61,34,0,34,32,99,108,97,115,115,61,34,101,100,103,101,34,62,0,60,116,105,116,108,101,62,0,60,47,116,105,116,108,101,62,10,0,95,37,115,0,34,32,99,108,97,115,115,61,34,110,111,100,101,34,62,0,34,32,99,108,97,115,115,61,34,99,108,117,115,116,101,114,34,62,0,34,32,99,108,97,115,115,61,34,103,114,97,112,104,34,0,32,116,114,97,110,115,102,111,114,109,61,34,115,99,97,108,101,40,37,103,32,37,103,41,32,114,111,116,97,116,101,40,37,100,41,32,116,114,97,110,115,108,97,116,101,40,37,103,32,37,103,41,34,62,10,0,34,32,99,108,97,115,115,61,34,108,97,121,101,114,34,62,10,0,60,47,115,118,103,62,10,0,60,33,45,45,0,32,80,97,103,101,115,58,32,37,100,32,45,45,62,10,0,60,115,118,103,32,119,105,100,116,104,61,34,37,100,112,116,34,32,104,101,105,103,104,116,61,34,37,100,112,116,34,10,0,32,118,105,101,119,66,111,120,61,34,37,46,50,102,32,37,46,50,102,32,37,46,50,102,32,37,46,50,102,34,0,32,120,109,108,110,115,61,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,115,118,103,34,0,32,120,109,108,110,115,58,120,108,105,110,107,61,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,49,57,57,57,47,120,108,105,110,107,34,0,60,63,120,109,108,32,118,101,114,115,105,111,110,61,34,49,46,48,34,32,101,110,99,111,100,105,110,103,61,34,85,84,70,45,56,34,32,115,116,97,110,100,97,108,111,110,101,61,34,110,111,34,63,62,10,0,115,116,121,108,101,115,104,101,101,116,0,60,63,120,109,108,45,115,116,121,108,101,115,104,101,101,116,32,104,114,101,102,61,34,0,34,32,116,121,112,101,61,34,116,101,120,116,47,99,115,115,34,63,62,10,0,60,33,68,79,67,84,89,80,69,32,115,118,103,32,80,85,66,76,73,67,32,34,45,47,47,87,51,67],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+101982);allocate([47,47,68,84,68,32,83,86,71,32,49,46,49,47,47,69,78,34,10,0,32,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,71,114,97,112,104,105,99,115,47,83,86,71,47,49,46,49,47,68,84,68,47,115,118,103,49,49,46,100,116,100,34,62,10,0,60,33,45,45,32,71,101,110,101,114,97,116,101,100,32,98,121,32,0,116,107,0,116,107,58,116,107,0,35,32,0,32,99,114,101,97,116,101,32,108,105,110,101,32,0,32,45,102,105,108,108,32,0,32,45,100,97,115,104,32,53,0,32,45,100,97,115,104,32,50,0,103,114,97,112,104,32,108,97,98,101,108,0,103,118,114,101,110,100,101,114,95,99,111,114,101,95,116,107,46,99,0,116,107,103,101,110,95,112,114,105,110,116,95,116,97,103,115,0,32,45,116,97,103,115,32,123,37,100,37,115,37,100,125,0,116,107,103,101,110,95,112,114,105,110,116,95,99,111,108,111,114,0,36,99,0,32,45,119,105,100,116,104,32,0,32,45,115,109,111,111,116,104,32,98,101,122,105,101,114,32,0,32,99,114,101,97,116,101,32,112,111,108,121,103,111,110,32,0,32,45,111,117,116,108,105,110,101,32,0,32,99,114,101,97,116,101,32,111,118,97,108,32,0,32,99,114,101,97,116,101,32,116,101,120,116,32,0,32,45,116,101,120,116,32,123,0,125,0,32,45,102,111,110,116,32,123,0,32,37,100,125,0,32,45,97,110,99,104,111,114,32,119,0,32,45,97,110,99,104,111,114,32,101,0,35,0,32,84,105,116,108,101,58,32,0,32,80,97,103,101,115,58,32,37,100,10,0,35,32,71,101,110,101,114,97,116,101,100,32,98,121,32,0,41,10,0,69,114,114,111,114,32,100,117,114,105,110,103,32,99,111,110,118,101,114,115,105,111,110,32,116,111,32,34,85,84,70,45,56,34,46,32,32,81,117,105,116,105,110,103,46,10,0,118,109,108,0,118,109,108,58,118,109,108,0,97,113,117,97,0,102,117,99,104,115,105,97,0,108,105,109,101,0,111,108,105,118,101,0,116,101,97,108,0,32,32,32,32,32,32,60,33,45,45,32,0,32,45,45,62,10,0,32,60,118,58,115,104,97,112,101,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,97,98,115,111,108,117,116,101,59,32,0,32,119,105,100,116,104,58,32,37,100,59,32,104,101,105,103,104,116,58,32,37,100,34,32,102,105,108,108,101,100,61,34,102,97,108,115,101,34,62,0,60,118,58,112,97,116,104,32,118,61,34,0,32,109,32,0,37,46,48,102,44,37,46,48,102,32,0,32,108,32,0,32,101,32,0,34,47,62,0,60,47,118,58,115,104,97,112,101,62,10,0,60,118,58,115,116,114,111,107,101,32,99,111,108,111,114,61,34,0,34,32,119,101,105,103,104,116,61,34,37,46,48,102,112,116,0,34,32,100,97,115,104,115,116,121,108,101,61,34,100,97,115,104,0,34,32,100,97,115,104,115,116,121,108,101,61,34,100,111,116,0,34,32,47,62,0,35,37,48,50,120,37,48,50,120,37,48,50,120,0,103,118,114,101,110,100,101,114,95,99,111,114,101,95,118,109,108,46,99,0,118,109,108,95,112,114,105,110,116,95,99,111,108,111,114,0,32,119,105,100,116,104,58,32,37,100,59,32,104,101,105,103,104,116,58,32,37,100,34,0,32,62,0,60,118,58,112,97,116,104,32,32,118,61,34,0,47,62,60,47,118,58,115,104,97,112,101,62,10,0,109,32,0,37,115,37,46,48,102,44,37,46,48,102,32,0,99,32,0,32,102,105,108,108,101,100,61,34,116,114,117,101,34,32,102,105,108,108,99,111,108,111,114,61,34,0,34,32,0,32,102,105,108,108,101,100,61,34,102,97,108,115,101,34,32,0,37,46,48,102,32,37,46,48,102,32,0,108,32,0,120,32,101,32,34,47,62,0,32,32,60,118,58,111,118,97,108,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,97,98,115,111,108,117,116,101,59,0,32,108,101,102,116,58,32,37,46,50,102,59,32,116,111,112,58,32,37,46,50,102,59,0,32,119,105,100,116,104,58,32,37,46,50,102,59,32,104,101,105,103,104,116,58,32,37,46,50,102,34,0,60,47,118,58,111,118,97,108,62,10,0,60,118,58,114,101,99,116,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,97,98,115,111,108,117,116,101,59,32,0,32,115,116,114,111,107,101,100,61,34,102,97,108,115,101,34,32,102,105,108,108,101,100,61,34,102,97,108,115,101,34,62,10,0,60,118,58,116,101,120,116,98,111,120,32,105,110,115,101,116,61,34,48,44,48,44,48,44,48,34,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,97,98,115,111,108,117,116,101,59,32,118,45,116,101,120,116,45,119,114,97,112,112,105,110,103,58,39,102,97,108,115,101,39,59,112,97,100,100,105,110,103,58,39,48,39,59,0,102,111,110,116,45,102,97,109,105,108,121,58,32,39,37,115,39,59,0,102,111,110,116,45,119,101,105,103,104,116,58,32,37,115,59,0,102,111,110,116,45,115,116,114,101,116,99,104,58,32,37,115,59,0,102,111,110,116,45,115,116,121,108,101,58,32,37,115,59,0,32,102,111,110,116,45,115,105,122,101,58,32,37,46,50,102,112,116,59,0,99,111,108,111,114,58,37,115,59,0,99,111,108,111,114,58,35,37,48,50,120,37,48,50,120,37,48,50,120,59,0,118,109,108,95,116,101,120,116,115,112,97,110,0,34,62,60,99,101,110,116,101,114,62,0,60,47,99,101,110,116,101,114,62,60,47,118,58,116,101,120,116,98,111,120,62,10,0,60,47,118,58,114,101,99,116,62,10,0,60,47,97,62,10,0,60,97,0,32,104,114,101,102,61,34,37,115,34,0,32,116,105,116,108,101,61,34,37,115,34,0,32,116,97,114,103,101,116,61,34,37,115,34,0,62,10,0,60,47,118,58,103,114,111,117,112,62,10,0,60,47,68,73,86,62,10,0,60,68,73,86,32,105,100,61,39,95,86,77,76,50,95,39,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,114,101,108,97,116,105,118,101,59,118,105,115,105,98,105,108,105,116,121,58,104,105,100,100,101,110,34,62,10,0,60,33,45,45,32,105,110,115,101,114,116,32,97,110,121,32,111,116,104,101,114,32,104,116,109,108,32,99,111,110,116,101,110,116,32,104,101,114,101,32,45,45,62,10,0,60,68,73,86,32,105,100,61,39,95,110,111,116,86,77,76,49,95,39,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,114,101,108,97,116,105,118,101,59,34,62,10,0,60,33,45,45,32,116,104,105,115,32,115,104,111,117,108,100,32,111,110,108,121,32,100,105,115,112,108,97,121,32,111,110,32,78,79,78,45,73,69,32,98,114,111,119,115,101,114,115,32,45,45,62,10,0,60,72,50,62,83,111,114,114,121,44,32,116,104,105,115,32,100,105,97,103,114,97,109,32,119,105,108,108,32,111,110,108,121,32,100,105,115,112,108,97,121,32,99,111,114,114,101,99,116,108,121,32,111,110,32,73,110,116,101,114,110,101,116,32,69,120,112,108,111,114,101,114,32,53,32,40,97,110,100,32,117,112,41,32,98,114,111,119,115,101,114,115,46,60,47,72,50,62,10,0,60,68,73,86,32,105,100,61,39,95,110,111,116,86,77,76,50,95,39,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,114,101,108,97,116,105,118,101,59,34,62,10,0,60,33,45,45,32,105,110,115,101,114,116,32,97,110,121,32,111,116,104,101,114,32,78,79,78,45,73,69,32,104,116,109,108,32,99,111,110,116,101,110,116,32,104,101,114,101,32,45,45,62,10,0,60,47,66,79,68,89,62,10,60,47,72,84,77,76,62,10,0,60,72,69,65,68,62,0,60,77,69,84,65,32,104,116,116,112,45,101,113,117,105,118,61,34,67,111,110,116,101,110,116,45,84,121,112,101,34,32,99,111,110,116,101,110,116,61,34,116,101,120,116,47,104,116,109,108,59,32,99,104,97,114,115,101,116,61,85,84,70,45,56,34,62,10,0,60,84,73,84,76,69,62,0,60,47,84,73,84,76,69,62,0,60,33,45,45,32,80,97,103,101,115,58,32,37,100,32,45,45,62,10,0,32,32,32,60,83,67,82,73,80,84,32,76,65,78,71,85,65,71,69,61,39,74,97,118,97,115,99,114,105,112,116,39,62,10,0,32,32,32,102,117,110,99,116,105,111,110,32,98,114,111,119,115,101,114,99,104,101,99,107,40,41,10,0,32,32,32,123,10,0,32,32,32,32,32,32,118,97,114,32,117,97,32,61,32,119,105,110,100,111,119,46,110,97,118,105,103,97,116,111,114,46,117,115,101,114,65,103,101,110,116,10,0,32,32,32,32,32,32,118,97,114,32,109,115,105,101,32,61,32,117,97,46,105,110,100,101,120,79,102,32,40,32,39,77,83,73,69,32,39,32,41,10,0,32,32,32,32,32,32,118,97,114,32,105,101,118,101,114,115,59,10,0,32,32,32,32,32,32,118,97,114,32,105,116,101,109,59,10,0,32,32,32,32,32,32,118,97,114,32,86,77,76,121,101,115,61,110,101,119,32,65,114,114,97,121,40,39,95,86,77,76,49,95,39,44,39,95,86,77,76,50,95,39,41,59,10,0,32,32,32,32,32,32,118,97,114,32,86,77,76,110,111,61,110,101,119,32,65,114,114,97,121,40,39,95,110,111,116,86,77,76,49,95,39,44,39,95,110,111,116,86,77,76,50,95,39,41,59,10,0,32,32,32,32,32,32,105,102,32,40,32,109,115,105,101,32,62,32,48,32,41,123,32,32,32,32,32,32,47,47,32,73,102,32,73,110,116,101,114,110,101,116,32,69,120,112,108,111,114,101,114,44,32,114,101,116,117,114,110,32,118,101,114,115,105,111,110,32,110,117,109,98,101,114,10,0,32,32,32,32,32,32,32,32,32,105,101,118,101,114,115,61,32,112,97,114,115,101,73,110,116,32,40,117,97,46,115,117,98,115,116,114,105,110,103,32,40,109,115,105,101,43,53,44,32,117,97,46,105,110,100,101,120,79,102,32,40,39,46,39,44,32,109,115,105,101,32,41,41,41,10,0,32,32,32,32,32,32,125,10,0,32,32,32,32,32,32,105,102,32,40,105,101,118,101,114,115,62,61,53,41,123,10,0,32,32,32,32,32,32,32,102,111,114,32,40,120,32,105,110,32,86,77,76,121,101,115,41,123,10,0,32,32,32,32,32,32,32,32,32,105,116,101,109,32,61,32,100,111,99,117,109,101,110,116,46,103,101,116,69,108,101,109,101,110,116,66,121,73,100,40,86,77,76,121,101,115,91,120,93,41,59,10,0,32,32,32,32,32,32,32,32,32,105,102,32,40,105,116,101,109,41,32,123,10,0,32,32,32,32,32,32,32,32,32,32,32,105,116,101,109,46,115,116,121,108,101,46,118,105,115,105,98,105,108,105,116,121,61,39,118,105,115,105,98,108,101,39,59,10,0,32,32,32,32,32,32,32,32,32,125,10,0,32,32,32,32,32,32,32,125,10,0,32,32,32,32,32,32,32,102,111,114,32,40,120,32,105,110,32,86,77,76,110,111,41,123,10,0,32,32,32,32,32,32,32,32,32,105,116,101,109,32,61,32,100,111,99,117,109,101,110,116,46,103,101,116,69,108,101,109,101,110,116,66,121,73,100,40,86,77,76,110,111,91,120,93,41,59,10,0,32,32,32,32,32,32,32,32,32,32,32,105,116,101,109,46,115,116,121,108,101,46,118,105,115,105,98,105,108,105,116,121,61,39,104,105,100,100,101,110,39,59,10,0,32,32,32,32,32,125,101,108,115,101,123,10,0,32,32,32,32,32,125,10,0,32,32,32,125,10,0,32,32,32,60,47,83,67,82,73,80,84,62,10,0,60,47,72,69,65,68,62,0,60,66,79,68,89,32,111,110,108,111,97,100,61,39,98,114,111,119,115,101,114,99,104,101,99,107,40,41,59,39,62,10,0,60,68,73,86,32,105,100,61,39,95,86,77,76,49,95,39,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,114,101,108,97,116,105,118,101,59,32,100,105,115,112,108,97,121,58,105,110,108,105,110,101,59,32,118,105,115,105,98,105,108,105,116,121,58,104,105,100,100,101,110,0,32,119,105,100,116,104,58,32,37,100,112,116,59,32,104,101,105,103,104,116,58,32,37,100,112,116,34,62,10,0,60,83,84,89,76,69,62,10,0,118,92,58,42,32,123,32,98,101,104,97,118,105,111,114,58,32,117,114,108,40,35,100,101,102,97,117,108,116,35,86,77,76,41,59,100,105,115,112,108,97,121,58,105,110,108,105,110,101,45,98,108,111,99,107,125,10,0,60,47,83,84,89,76,69,62,10,0,60,120,109,108,58,110,97,109,101,115,112,97,99,101,32,110,115,61,34,117,114,110,58,115,99,104,101,109,97,115,45,109,105,99,114,111,115,111,102,116,45,99,111,109,58,118,109,108,34,32,112,114,101,102,105,120,61,34,118,34,32,47,62,10,0,32,60,118,58,103,114,111,117,112,32,115,116,121,108,101,61,34,112,111,115,105,116,105,111,110,58,114,101,108,97,116,105,118,101,59,32,0,32,119,105,100,116,104,58,32,37,100,112,116,59,32,104,101,105,103,104,116,58,32,37,100,112,116,34,0,32,99,111,111,114,100,111,114,105,103,105,110,61,34,48,44,48,34,32,99,111,111,114,100,115,105,122,101,61,34,37,100,44,37,100,34,32,62,0,60,72,84,77,76,62,10,0,10,60,33,45,45,32,71,101,110,101,114,97,116,101,100,32,98,121,32,0,32,118,101,114,115,105,111,110,32,0,32,40,0,41,10,45,45,62,10,0,112,111,118,32,114,101,110,100,101,114,101,114,58,101,108,32,45,32,37,115,10,0,112,111,118,0,112,111,118,58,112,111,118,0,98,97,107,101,114,115,99,104,111,99,0,98,114,97,115,115,0,98,114,105,103,104,116,103,111,108,100,0,98,114,111,110,122,101,0,98,114,111,110,122,101,50,0,99,108,101,97,114,0,99,111,111,108,99,111,112,112,101,114,0,99,111,112,112,101,114,0,100,97,114,107,98,114,111,119,110,0,100,97,114,107,112,117,114,112,108,101,0,100,97,114,107,116,97,110,0,100,97,114,107,119,111,111,100,0,100,107,103,114,101,101,110,99,111,112,112,101,114,0,100,117,115,116,121,114,111,115,101,0,102,101,108,100,115,112,97,114,0,102,108,101,115,104,0,103,114,97,121,48,53,0,103,114,101,101,110,99,111,112,112,101,114,0,104,117,110,116,101,114,115,103,114,101,101,110,0,108,105,103,104,116,95,112,117,114,112,108,101,0,108,105,103,104,116,119,111,111,100,0,109,97,110,100,97,114,105,110,111,114,97,110,103,101,0,109,101,100,105,117,109,102,111,114,101,115,116,103,114,101,101,110,0,109,101,100,105,117,109,103,111,108,100,101,110,114,111,100,0,109,101,100,105,117,109,119,111,111,100,0,109,101,100,95,112,117,114,112,108,101,0,109,105,99,97,0,110,101,111,110,98,108,117,101,0,110,101,111,110,112,105,110,107,0,110,101,119,109,105,100,110,105,103,104,116,98,108,117,101,0,110,101,119,116,97,110,0,111,108,100,103,111,108,100,0,113,117,97,114,116,122,0,114,105,99,104,98,108,117,101,0,115,99,97,114,108,101,116,0,115,101,109,105,83,119,101,101,116,67,104,111,99,0,115,105,108,118,101,114,0,115,112,105,99,121,112,105,110,107,0,115,117,109,109,101,114,115,107,121,0,118,101,114,121,100,97,114,107,98,114,111,119,110,0,118,101,114,121,95,108,105,103,104,116,95,112,117,114,112,108,101,0,47,47,42,42,42,32,99,111,109,109,101,110,116,58,32,37,115,10,0,47,47,42,42,42,32,112,111,108,121,108,105,110,101,10,0,115,99,97,108,101,32,32,32,32,60,37,57,46,51,102,44,32,37,57,46,51,102,44,32,37,57,46,51,102,62,10,0,114,111,116,97,116,101,32,32,32,60,37,57,46,51,102,44,32,37,57,46,51,102,44,32,37,57,46,51,102,62,10,0,116,114,97,110,115,108,97,116,101,60,37,57,46,51,102,44,32,37,57,46,51,102,44,32,37,57,46,51,102,62,10,0,115,112,104,101,114,101,95,115,119,101,101,112,32,123,10,32,32,32,32,37,115,10,32,32,32,32,37,100,44,10,0,108,105,110,101,97,114,95,115,112,108,105,110,101,0,60,37,57,46,51,102,44,32,37,57,46,51,102,44,32,37,57,46,51,102,62,44,32,37,46,51,102,10,0,37,115,32,32,32,32,37,115,0,32,32,32,32,116,111,108,101,114,97,110,99,101,32,48,46,48,49,10,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,125,10,0,37,115,37,115,0,37,115,32,116,114,97,110,115,109,105,116,32,37,46,51,102,0,82,101,100,0,71,114,101,101,110,0,66,108,117,101,0,114,103,98,60,37,57,46,51,102,44,32,37,57,46,51,102,44,32,37,57,46,51,102,62,32,116,114,97,110,115,109,105,116,32,37,46,51,102,0,111,111,112,115,44,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,58,32,117,110,104,97,110,100,108,101,100,32,99,111,108,111,114,32,116,121,112,101,61,37,100,32,37,115,10,0,103,118,114,101,110,100,101,114,95,99,111,114,101,95,112,111,118,46,99,0,112,111,118,95,99,111,108,111,114,95,97,115,95,115,116,114,0,112,105,103,109,101,110,116,32,123,32,99,111,108,111,114,32,37,115,32,125,10,0,47,47,42,42,42,32,98,101,122,105,101,114,10,0,98,95,115,112,108,105,110,101,0,32,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,32,48,46,48,49,10,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,125,10,0,47,47,42,42,42,32,112,111,108,121,103,111,110,10,0,32,32,32,32,116,111,108,101,114,97,110,99,101,32,48,46,49,10,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,125,10,0,112,111,108,121,103,111,110,32,123,32,37,100,44,10,0,60,37,57,46,51,102,44,32,37,57,46,51,102,44,32,37,57,46,51,102,62,0,37,115,10,32,32,32,32,37,115,0,10,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,125,10,0,47,47,42,42,42,32,101,108,108,105,112,115,101,10,0,116,111,114,117,115,32,123,32,37,46,51,102,44,32,37,46,51,102,10,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,125,10,0,115,112,104,101,114,101,32,123,60,37,57,46,51,102,44,32,37,57,46,51,102,44,32,37,57,46,51,102,62,44,32,49,46,48,10,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,125,10,0,47,47,42,42,42,32,116,101,120,116,115,112,97,110,58,32,37,115,44,32,102,111,110,116,115,105,122,101,32,61,32,37,46,51,102,44,32,102,111,110,116,110,97,109,101,32,61,32,37,115,10,0,115,99,97,108,101,32,37,46,51,102,10,0,116,101,120,116,32,123,10,32,32,32,32,116,116,102,32,34,37,115,34,44,10,32,32,32,32,34,37,115,34,44,32,37,46,51,102,44,32,37,46,51,102,10,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,32,32,32,32,37,115,125,10,0,32,32,32,32,110,111,95,115,104,97,100,111,119,10,0,47,47,42,42,42,32,101,110,100,95,101,100,103,101,10,0,47,47,42,42,42,32,98,101,103,105,110,95,101,100,103,101,10,0,47,47,42,42,42,32,101,110,100,95,110,111,100,101,10,0,47,47,42,42,42,32,98,101,103,105,110,95,110,111,100,101,58,32,37,115,10,0,47,47,42,42,42,32,101,110,100,95,99,108,117,115,116,101,114,10,0,47,47,42,42,42,32,98,101,103,105,110,95,99,108,117,115,116,101,114,10,0,47,47,42,42,42,32,101,110,100,95,112,97,103,101,10,0,47,47,42,42,42,32,98,101,103,105,110,95,112,97,103,101,10,0,47,47,42,42,42,32,101,110,100,95,108,97,121,101,114,10,0,47,47,42,42,42,32,98,101,103,105,110,95,108,97,121,101,114,58,32,37,115,44,32,37,100,47,37,100,10,0,47,47,42,42,42,32,101,110,100,95,103,114,97,112,104,10,0,47,47,42,42,42,32,98,101,103,105,110,95,103,114,97,112,104,32,37,115,10,0,99,97,109,101,114,97,32,123,32,108,111,99,97,116,105,111,110,32,60,37,46,51,102,32,44,32,37,46,51,102,32,44,32,37,46,51,102,62,10,32,32,32,32,32,32,32,32,32,108,111,111,107,95,97,116,32,32,60,37,46,51,102,32,44,32,37,46,51,102,32,44,32,37,46,51,102,62,10,32,32,32,32,32,32,32,32,32,114,105,103,104,116,32,120,32,42,32,105,109,97,103,101,95,119,105,100,116,104,32,47,32,105,109,97,103,101,95,104,101,105,103,104,116,10,32,32,32,32,32,32,32,32,32,97,110,103,108,101,32,37,46,51,102,10,125,10,0,47,47,115,107,121,10,112,108,97,110,101,32,123,32,60,48,44,32,49,44,32,48,62,44,32,49,32,104,111,108,108,111,119,10,32,32,32,32,116,101,120,116,117,114,101,32,123,10,32,32,32,32,32,32,32,32,112,105,103,109,101,110,116,32,123,32,98,111,122,111,32,116,117,114,98,117,108,101,110,99,101,32,48,46,57,53,10,32,32,32,32,32,32,32,32,32,32,32,32,99,111,108,111,114,95,109,97,112,32,123,10,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,91,48,46,48,48,32,114,103,98,32,60,48,46,48,53,44,32,48,46,50,48,44,32,48,46,53,48,62,93,10,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,91,48,46,53,48,32,114,103,98,32,60,48,46,48,53,44,32,48,46,50,48,44,32,48,46,53,48,62,93,10,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,91,48,46,55,53,32,114,103,98,32,60,49,46,48,48,44,32,49,46,48,48,44,32,49,46,48,48,62,93,10,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,91,48,46,55,53,32,114,103,98,32,60,48,46,50,53,44,32,48,46,50,53,44,32,48,46,50,53,62,93,10,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,91,49,46,48,48,32,114,103,98,32,60,48,46,53,48,44,32,48,46,53,48,44,32,48,46,53,48,62,93,10,32,32,32,32,32,32,32,32,32,32,32,32,125,10,32,32,32,32,32,32,32,32,32,32,32,32,115,99,97,108,101,32,60,49,46,48,48,44,32,49,46,48,48,44,32,49,46,53,48,62,32,42,32,50,46,53,48,10,32,32,32,32,32,32,32,32,32,32,32,32,116,114,97,110,115,108,97,116,101,32,60,48,46,48,48,44,32,48,46,48,48,44,32,48,46,48,48,62,10,32,32,32,32,32,32,32,32,125,10,32,32,32,32,32,32,32,32,102,105,110,105,115,104,32,123,32,97,109,98,105,101,110,116,32,49,32,100,105,102,102,117,115,101,32,48,32,125,10,32,32,32,32,125,10,32,32,32,32,115,99,97,108,101,32,49,48,48,48,48,10,125,10,47,47,109,105,115,116,10,102,111,103,32,123,32,102,111,103,95,116,121,112,101,32,50,10,32,32,32,32,100,105,115,116,97,110,99,101,32,53,48,10,32,32,32,32,99,111,108,111,114,32,114,103,98,32,60,49,46,48,48,44,32,49,46,48,48,44,32,49,46,48,48,62,32,42,32,48,46,55,53,10,32,32,32,32,102,111,103,95,111,102,102,115,101,116,32,48,46,49,48,10,32,32,32,32,102,111,103,95,97,108,116,32,49,46,53,48,10,32,32,32,32,116,117,114,98,117,108,101,110,99,101,32,49,46,55,53,10,125,10,47,47,103,110,100,10,112,108,97,110,101,32,123,32,60,48,46,48,48,44,32,49,46,48,48,44,32,48,46,48,48,62,44,32,48,10,32,32,32,32,116,101,120,116,117,114,101,32,123,10,32,32,32,32,32,32,32,32,112,105,103,109,101,110,116,123,32,99,111,108,111,114,32,114,103,98,32,60,48,46,50,53,44,32,48,46,52,53,44,32,48,46,48,48,62,32,125,10,32,32,32,32,32,32,32,32,110,111,114,109,97,108,32,123,32,98,117,109,112,115,32,48,46,55,53,32,115,99,97,108,101,32,48,46,48,49,32,125,10,32,32,32,32,32,32,32,32,102,105,110,105,115,104,32,123,32,112,104,111,110,103,32,48,46,49,48,32,125,10,32,32,32,32,125,10,125,10,0,108,105,103,104,116,95,115,111,117,114,99,101,32,123,32,60,49,53,48,48,44,51,48,48,48,44,45,50,53,48,48,62,32,99,111,108,111,114,32,87,104,105,116,101,32,125,10,0,35,118,101,114,115,105,111,110,32,51,46,54,59,10,0,103,108,111,98,97,108,95,115,101,116,116,105,110,103,115,32,123,32,97,115,115,117,109,101,100,95,103,97,109,109,97,32,49,46,48,32,125,10,0,35,100,101,102,97,117,108,116,32,123,32,102,105,110,105,115,104,32,123,32,97,109,98,105,101,110,116,32,48,46,49,32,100,105,102,102,117,115,101,32,48,46,57,32,125,32,125,10,0,35,105,110,99,108,117,100,101,32,34,99,111,108,111,114,115,46,105,110,99,34,10,35,105,110,99,108,117,100,101,32,34,116,101,120,116,117,114,101,115,46,105,110,99,34,10,35,105,110,99,108,117,100,101,32,34,115,104,97,112,101,115,46,105,110,99,34,10,0,35,100,101,99,108,97,114,101,32,37,115,32,61,32,37,115,59,10,0,66,108,97,99,107,0,87,104,105,116,101,0,112,105,99,0,112,105,99,58,112,105,99,0,37,115,32,37,115,10,0,46,92,34,32,0,32,37,100,32,37,100,0,32,37,115,10,0,32,37,100,0,102,105,108,108,32,0,101,108,108,105,112,115,101,32,97,116,116,114,115,37,100,32,37,115,119,105,100,32,37,46,53,102,32,104,116,32,37,46,53,102,32,97,116,32,40,37,46,53,102,44,37,46,53,102,41,59,10,0,46,102,116,32,37,115,10,0,46,112,115,32,37,100,42,92,110,40,83,70,117,47,37,46,48,102,117,10,0,34,37,115,34,32,97,116,32,40,37,46,53,102,44,37,46,53,102,41,59,10,0,37,48,51,111,0,37,115,37,115,32,105,115,32,110,111,116,32,97,32,116,114,111,102,102,32,102,111,110,116,10,0,100,111,116,32,112,105,99,32,112,108,117,103,105,110,58,32,0,82,0,93,10,46,80,69,10,0,46,80,83,32,37,46,53,102,32,37,46,53,102,10,0,37,115,32,116,111,32,99,104,97,110,103,101,32,100,114,97,119,105,110,103,32,115,105,122,101,44,32,109,117,108,116,105,112,108,121,32,116,104,101,32,119,105,100,116,104,32,97,110,100,32,104,101,105,103,104,116,32,111,110,32,116,104,101,32,46,80,83,32,108,105,110,101,32,97,98,111,118,101,32,97,110,100,32,116,104,101,32,110,117,109,98,101,114,32,111,110,32,116,104,101,32,116,119,111,32,108,105,110,101,115,32,98,101,108,111,119,32,40,114,111,117,110,100,101,100,32,116,111,32,116,104,101,32,110,101,97,114,101,115,116,32,105,110,116,101,103,101,114,41,32,98,121,32,97,32,115,99,97,108,101,32,102,97,99,116,111,114,10,0,46,110,114,32,83,70,32,37,46,48,102,10,115,99,97,108,101,116,104,105,99,107,110,101,115,115,32,61,32,37,46,48,102,10,0,37,115,32,100,111,110,39,116,32,99,104,97,110,103,101,32,97,110,121,116,104,105,110,103,32,98,101,108,111,119,32,116,104,105,115,32,108,105,110,101,32,105,110,32,116,104,105,115,32,100,114,97,119,105,110,103,10,0,37,115,32,110,111,110,45,102,97,116,97,108,32,114,117,110,45,116,105,109,101,32,112,105,99,32,118,101,114,115,105,111,110,32,100,101,116,101,114,109,105,110,97,116,105,111,110,44,32,118,101,114,115,105,111,110,32,50,10,0,98,111,120,114,97,100,61,50,46,48,32,37,115,32,119,105,108,108,32,98,101,32,114,101,115,101,116,32,116,111,32,48,46,48,32,98,121,32,103,112,105,99,32,111,110,108,121,10,0,115,99,97,108,101,61,49,46,48,32,37,115,32,114,101,113,117,105,114,101,100,32,102,111,114,32,99,111,109,112,97,114,105,115,111,110,115,10,0,37,115,32,98,111,120,114,97,100,32,105,115,32,110,111,119,32,48,46,48,32,105,110,32,103,112,105,99,44,32,101,108,115,101,32,105,116,32,114,101,109,97,105,110,115,32,50,46,48,10,0,37,115,32,100,97,115,104,119,105,100,32,105,115,32,48,46,49,32,105,110,32,49,48,116,104,32,69,100,105,116,105,111,110,44,32,48,46,48,53,32,105,110,32,68,87,66,32,50,32,97,110,100,32,105,110,32,103,112,105,99,10,0,37,115,32,102,105,108,108,118,97,108,32,105,115,32,48,46,51,32,105,110,32,49,48,116,104,32,69,100,105,116,105,111,110,32,40,102,105,108,108,32,48,32,109,101,97,110,115,32,98,108,97,99,107,41,44,32,48,46,53,32,105,110,32,103,112,105,99,32,40,102,105,108,108,32,48,32,109,101,97,110,115,32,119,104,105,116,101,41,44,32,117,110,100,101,102,105,110,101,100,32,105,110,32,68,87,66,32,50,10,0,37,115,32,102,105,108,108,32,104,97,115,32,110,111,32,109,101,97,110,105,110,103,32,105,110,32,68,87,66,32,50,44,32,103,112,105,99,32,99,97,110,32,117,115,101,32,102,105,108,108,32,111,114,32,102,105,108,108,101,100,44,32,49,48,116,104,32,69,100,105,116,105,111,110,32,117,115,101,115,32,102,105,108,108,32,111,110,108,121,10,0,37,115,32,68,87,66,32,50,32,100,111,101,115,110,39,116,32,117,115,101,32,102,105,108,108,32,97,110,100,32,100,111,101,115,110,39,116,32,100,101,102,105,110,101,32,102,105,108,108,118,97,108,10,0,37,115,32,114,101,115,101,116,32,119,111,114,107,115,32,105,110,32,103,112,105,99,32,97,110,100,32,49,48,116,104,32,101,100,105,116,105,111,110,44,32,98,117,116,32,105,115,110,39,116,32,100,101,102,105,110,101,100,32,105,110,32,68,87,66,32,50,10,0,37,115,32,68,87,66,32,50,32,99,111,109,112,97,116,105,98,105,108,105,116,121,32,100,101,102,105,110,105,116,105,111,110,115,10,0,105,102,32,98,111,120,114,97,100,32,62,32,49,46,48,32,38,38,32,100,97,115,104,119,105,100,32,60,32,48,46,48,55,53,32,116,104,101,110,32,88,10,9,102,105,108,108,118,97,108,32,61,32,49,59,10,9,100,101,102,105,110,101,32,102,105,108,108,32,89,32,89,59,10,9,100,101,102,105,110,101,32,115,111,108,105,100,32,89,32,89,59,10,9,100,101,102,105,110,101,32,114,101,115,101,116,32,89,32,115,99,97,108,101,61,49,46,48,32,89,59,10,88,10,0,114,101,115,101,116,32,37,115,32,115,101,116,32,116,111,32,107,110,111,119,110,32,115,116,97,116,101,10,0,37,115,32,71,78,85,32,112,105,99,32,118,115,46,32,49,48,116,104,32,69,100,105,116,105,111,110,32,100,92,40,101,39,116,101,110,116,101,10,0,105,102,32,102,105,108,108,118,97,108,32,62,32,48,46,52,32,116,104,101,110,32,88,10,9,100,101,102,105,110,101,32,115,101,116,102,105,108,108,118,97,108,32,89,32,102,105,108,108,118,97,108,32,61,32,49,32,45,32,89,59,10,9,100,101,102,105,110,101,32,98,111,108,100,32,89,32,116,104,105,99,107,110,101,115,115,32,50,32,89,59,10,0,9,37,115,32,105,102,32,121,111,117,32,117,115,101,32,103,112,105,99,32,97,110,100,32,105,116,32,98,97,114,102,115,32,111,110,32,101,110,99,111,117,110,116,101,114,105,110,103,32,34,115,111,108,105,100,34,44,10,0,9,37,115,9,105,110,115,116,97,108,108,32,97,32,109,111,114,101,32,114,101,99,101,110,116,32,118,101,114,115,105,111,110,32,111,102,32,103,112,105,99,32,111,114,32,115,119,105,116,99,104,32,116,111,32,68,87,66,32,111,114,32,49,48,116,104,32,69,100,105,116,105,111,110,32,112,105,99,59,10,0,9,37,115,9,115,111,114,114,121,44,32,116,104,101,32,103,114,111,102,102,32,102,111,108,107,115,32,99,104,97,110,103,101,100,32,103,112,105,99,59,32,115,101,110,100,32,97,110,121,32,99,111,109,112,108,97,105,110,116,32,116,111,32,116,104,101,109,59,10,0,88,32,101,108,115,101,32,90,10,9,100,101,102,105,110,101,32,115,101,116,102,105,108,108,118,97,108,32,89,32,102,105,108,108,118,97,108,32,61,32,89,59,10,9,100,101,102,105,110,101,32,98,111,108,100,32,89,32,89,59,10,9,100,101,102,105,110,101,32,102,105,108,108,101,100,32,89,32,102,105,108,108,32,89,59,10,90,10,0,37,115,32,97,114,114,111,119,104,101,97,100,32,104,97,115,32,110,111,32,109,101,97,110,105,110,103,32,105,110,32,68,87,66,32,50,44,32,97,114,114,111,119,104,101,97,100,32,61,32,55,32,109,97,107,101,115,32,102,105,108,108,101,100,32,97,114,114,111,119,104,101,97,100,115,32,105,110,32,103,112,105,99,32,97,110,100,32,105,110,32,49,48,116,104,32,69,100,105,116,105,111,110,10,0,37,115,32,97,114,114,111,119,104,101,97,100,32,105,115,32,117,110,100,101,102,105,110,101,100,32,105,110,32,68,87,66,32,50,44,32,105,110,105,116,105,97,108,108,121,32,49,32,105,110,32,103,112,105,99,44,32,50,32,105,110,32,49,48,116,104,32,69,100,105,116,105,111,110,10,0,97,114,114,111,119,104,101,97,100,32,61,32,55,32,37,115,32,110,111,116,32,117,115,101,100,32,98,121,32,103,114,97,112,104,118,105,122,10,0,37,115,32,71,78,85,32,112,105,99,32,115,117,112,112,111,114,116,115,32,97,32,98,111,120,114,97,100,32,118,97,114,105,97,98,108,101,32,116,111,32,100,114,97,119,32,98,111,120,101,115,32,119,105,116,104,32,114,111,117,110,100,101,100,32,99,111,114,110,101,114,115,59,32,68,87,66,32,97,110,100,32,49,48,116,104,32,69,100,46,32,100,111,32,110,111,116,10,0,98,111,120,114,97,100,32,61,32,48,32,37,115,32,110,111,32,114,111,117,110,100,101,100,32,99,111,114,110,101,114,115,32,105,110,32,103,114,97,112,104,118,105,122,10,0,37,115,32,71,78,85,32,112,105,99,32,115,117,112,112,111,114,116,115,32,97,32,108,105,110,101,116,104,105,99,107,32,118,97,114,105,97,98,108,101,32,116,111,32,115,101,116,32,108,105,110,101,32,116,104,105,99,107,110,101,115,115,59,32,68,87,66,32,97,110,100,32,49,48,116,104,32,69,100,46,32,100,111,32,110,111,116,10,0,108,105,110,101,116,104,105,99,107,32,61,32,48,59,32,111,108,100,108,105,110,101,116,104,105,99,107,32,61,32,108,105,110,101,116,104,105,99,107,10,0,37,115,32,46,80,83,32,119,47,111,32,97,114,103,115,32,99,97,117,115,101,115,32,71,78,85,32,112,105,99,32,116,111,32,115,99,97,108,101,32,100,114,97,119,105,110,103,32,116,111,32,102,105,116,32,56,46,53,120,49,49,32,112,97,112,101,114,59,32,68,87,66,32,100,111,101,115,32,110,111,116,10,0,37,115,32,109,97,120,112,115,104,116,32,97,110,100,32,109,97,120,112,115,119,105,100,32,104,97,118,101,32,110,111,32,109,101,97,110,105,110,103,32,105,110,32,68,87,66,32,50,46,48,44,32,115,101,116,32,112,97,103,101,32,98,111,117,110,100,97,114,105,101,115,32,105,110,32,103,112,105,99,32,97,110,100,32,105,110,32,49,48,116,104,32,69,100,105,116,105,111,110,10,0,37,115,32,109,97,120,112,115,104,116,32,97,110,100,32,109,97,120,112,115,119,105,100,32,97,114,101,32,112,114,101,100,101,102,105,110,101,100,32,116,111,32,49,49,46,48,32,97,110,100,32,56,46,53,32,105,110,32,103,112,105,99,10,0,109,97,120,112,115,104,116,32,61,32,37,102,10,109,97,120,112,115,119,105,100,32,61,32,37,102,10,0,68,111,116,58,32,91,10,0,100,101,102,105,110,101,32,97,116,116,114,115,48,32,37,37,32,37,37,59,32,100,101,102,105,110,101,32,117,110,102,105,108,108,101,100,32,37,37,32,37,37,59,32,100,101,102,105,110,101,32,114,111,117,110,100,101,100,32,37,37,32,37,37,59,32,100,101,102,105,110,101,32,100,105,97,103,111,110,97,108,115,32,37,37,32,37,37,10,0,37,115,37,115,32,117,110,115,117,112,112,111,114,116,101,100,10,0,37,115,32,114,101,115,116,111,114,101,32,112,111,105,110,116,32,115,105,122,101,32,97,110,100,32,102,111,110,116,10,46,112,115,32,92,110,40,46,83,10,46,102,116,32,92,110,40,68,70,10,0,37,115,32,67,114,101,97,116,111,114,58,32,37,115,32,118,101,114,115,105,111,110,32,37,115,32,40,37,115,41,10,0,37,115,32,84,105,116,108,101,58,32,37,115,10,0,37,115,32,115,97,118,101,32,112,111,105,110,116,32,115,105,122,101,32,97,110,100,32,102,111,110,116,10,46,110,114,32,46,83,32,92,110,40,46,115,10,46,110,114,32,68,70,32,92,110,40,46,102,10,0,112,110,103,58,115,118,103,0,103,105,102,58,115,118,103,0,106,112,101,103,58,115,118,103,0,106,112,101,58,115,118,103,0,106,112,103,58,115,118,103,0,112,110,103,58,102,105,103,0,103,105,102,58,102,105,103,0,106,112,101,103,58,102,105,103,0,106,112,101,58,102,105,103,0,106,112,103,58,102,105,103,0,112,110,103,58,118,114,109,108,0,103,105,102,58,118,114,109,108,0,106,112,101,103,58,118,114,109,108,0,106,112,101,58,118,114,109,108,0,106,112,103,58,118,114,109,108,0,101,112,115,58,112,115,0,112,115,58,112,115,0,40,108,105,98,41,58,112,115,0,112,110,103,58,109,97,112,0,103,105,102,58,109,97,112,0,106,112,101,103,58,109,97,112,0,106,112,101,58,109,97,112,0,106,112,103,58,109,97,112,0,112,115,58,109,97,112,0,101,112,115,58,109,97,112,0,115,118,103,58,109,97,112,0,112,110,103,58,100,111,116,0,103,105,102,58,100,111,116,0,106,112,101,103,58,100,111,116,0,106,112,101,58,100,111,116,0,106,112,103,58,100,111,116,0,112,115,58,100,111,116,0,101,112,115,58,100,111,116,0,115,118,103,58,100,111,116,0,112,110,103,58,120,100,111,116,0,103,105,102,58,120,100,111,116,0,106,112,101,103,58,120,100,111,116,0,106,112,101,58,120,100,111,116,0,106,112,103,58,120,100,111,116,0,112,115,58,120,100,111,116,0,101,112,115,58,120,100,111,116,0,115,118,103,58,120,100,111,116,0,115,118,103,58,115,118,103,0,112,110,103,58,118,109,108,0,103,105,102,58,118,109,108,0,106,112,101,103,58,118,109,108,0,106,112,101,58,118,109,108,0,106,112,103,58,118,109,108,0,103,105,102,58,116,107,0,105,109,97,103,101,32,99,114,101,97,116,101,32,112,104,111,116,111,32,34,112,104,111,116,111,95,37,115,34,32,45,102,105,108,101,32,34,37,115,34,10,0,36,99,32,99,114,101,97,116,101,32,105,109,97,103,101,32,37,46,50,102,32,37,46,50,102,32,45,105,109,97,103,101,32,34,112,104,111,116,111,95,37,115,34,10,0,60,118,58,105,109,97,103,101,32,115,114,99,61,34,37,115,34,32,115,116,121,108,101,61,34,32,112,111,115,105,116,105,111,110,58,97,98,115,111,108,117,116,101,59,32,119,105,100,116,104,58,37,46,50,102,59,32,104,101,105,103,104,116,58,37,46,50,102,59,32,108,101,102,116,58,37,46,50,102,32,59,32,116,111,112,58,37,46,50,102,34,0,32,47,62,10,0,103,118,108,111,97,100,105,109,97,103,101,95,99,111,114,101,46,99,0,99,111,114,101,95,108,111,97,100,105,109,97,103,101,95,112,115,108,105,98,0,91,32,0,37,103,32,37,103,32,0,93,32,32,37,100,32,116,114,117,101,32,37,115,10,0,93,32,32,37,100,32,102,97,108,115,101,32,37,115,10,0,99,111,114,101,95,108,111,97,100,105,109,97,103,101,95,112,115,0,103,115,97,118,101,32,37,103,32,37,103,32,116,114,97,110,115,108,97,116,101,32,110,101,119,112,97,116,104,10,0,117,115,101,114,95,115,104,97,112,101,95,37,100,10,0,103,114,101,115,116,111,114,101,10,0,99,111,114,101,95,108,111,97,100,105,109,97,103,101,95,118,114,109,108,0,83,104,97,112,101,32,123,10,0,32,32,97,112,112,101,97,114,97,110,99,101,32,65,112,112,101,97,114,97,110,99,101,32,123,10,0,32,32,32,32,109,97,116,101,114,105,97,108,32,77,97,116,101,114,105,97,108,32,123,10,0,32,32,32,32,32,32,97,109,98,105,101,110,116,73,110,116,101,110,115,105,116,121,32,48,46,51,51,10,0,32,32,32,32,32,32,32,32,100,105,102,102,117,115,101,67,111,108,111,114,32,49,32,49,32,49,10,0,32,32,32,32,125,10,0,32,32,32,32,116,101,120,116,117,114,101,32,73,109,97,103,101,84,101,120,116,117,114,101,32,123,32,117,114,108,32,34,37,115,34,32,125,10,0,32,32,125,10,0,99,111,114,101,95,108,111,97,100,105,109,97,103,101,95,102,105,103,0,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,46,49,102,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,10,32,37,100,32,37,115,10,0,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,32,37,100,10,0,99,111,114,101,95,108,111,97,100,105,109,97,103,101,95,115,118,103,0,60,105,109,97,103,101,32,120,108,105,110,107,58,104,114,101,102,61,34,0,34,32,119,105,100,116,104,61,34,37,103,112,120,34,32,104,101,105,103,104,116,61,34,37,103,112,120,34,32,112,114,101,115,101,114,118,101,65,115,112,101,99,116,82,97,116,105,111,61,34,120,77,105,100,89,77,105,100,32,109,101,101,116,34,32,120,61,34,37,103,34,32,121,61,34,37,103,34,0,32,116,114,97,110,115,102,111,114,109,61,34,114,111,116,97,116,101,40,37,100,32,37,103,32,37,103,41,34,0,34,32,119,105,100,116,104,61,34,37,103,112,120,34,32,104,101,105,103,104,116,61,34,37,103,112,120,34,32,112,114,101,115,101,114,118,101,65,115,112,101,99,116,82,97,116,105,111,61,34,120,77,105,110,89,77,105,110,32,109,101,101,116,34,32,120,61,34,37,103,34,32,121,61,34,37,103,34,0,47,62,10,0,100,111,116,95,108,97,121,111,117,116,0,112,104,97,115,101,0,100,111,116,32,100,111,101,115,32,110,111,116,32,115,117,112,112,111,114,116,32,116,104,101,32,97,115,112,101,99,116,32,97,116,116,114,105,98,117,116,101,32,102,111,114,32,100,105,115,99,111,110,110,101,99,116,101,100,32,103,114,97,112,104,115,32,111,114,32,103,114,97,112,104,115,32,119,105,116,104,32,99,108,117,115,116,101,114,115,10,0,99,111,109,112,111,117,110,100,0,118,32,61,61,32,110,0,100,111,116,105,110,105,116,46,99,0,114,101,109,111,118,101,95,102,114,111,109,95,114,97,110,107,0,111,114,100,101,114,0,101,100,103,101,32,108,97,98,101,108,115,32,119,105,116,104,32,115,112,108,105,110,101,115,61,99,117,114,118,101,100,32,110,111,116,32,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+112222);allocate([117,112,112,111,114,116,101,100,32,105,110,32,100,111,116,32,45,32,117,115,101,32,120,108,97,98,101,108,115,10,0,69,68,95,108,97,98,101,108,40,102,101,41,0,100,111,116,115,112,108,105,110,101,115,46,99,0,95,100,111,116,95,115,112,108,105,110,101,115,0,120,120,120,0,49,48,48,48,48,0,123,37,115,125,0,97,117,120,103,0,108,97,98,101,108,95,102,108,111,97,116,0,102,105,120,101,100,0,40,108,32,61,32,69,68,95,108,97,98,101,108,40,102,101,41,41,0,115,101,116,69,100,103,101,76,97,98,101,108,80,111,115,0,101,32,33,61,32,78,85,76,76,0,102,97,115,116,103,114,46,99,0,100,101,108,101,116,101,95,102,97,115,116,95,101,100,103,101,0,110,32,33,61,32,78,68,95,110,101,120,116,40,110,41,0,102,97,115,116,95,110,111,100,101,0,117,32,33,61,32,118,0,102,97,115,116,95,110,111,100,101,97,112,112,0,78,68,95,110,101,120,116,40,118,41,32,61,61,32,78,85,76,76,0,102,105,110,100,95,102,97,115,116,95,110,111,100,101,40,103,44,32,110,41,0,100,101,108,101,116,101,95,102,97,115,116,95,110,111,100,101,0,100,101,108,101,116,101,95,102,108,97,116,95,101,100,103,101,0,109,101,114,103,101,95,111,110,101,119,97,121,32,103,108,105,116,99,104,10,0,109,101,114,103,101,95,111,110,101,119,97,121,0,115,97,102,101,95,100,101,108,101,116,101,95,102,97,115,116,95,101,100,103,101,0,114,101,109,105,110,99,114,111,115,115,0,0,105,110,115,116,97,108,108,95,105,110,95,114,97,110,107,44,32,108,105,110,101,32,37,100,58,32,37,115,32,37,115,32,114,97,110,107,32,37,100,32,105,32,61,32,37,100,32,97,110,32,61,32,48,10,0,71,68,95,114,97,110,107,40,103,41,91,114,93,46,110,32,60,61,32,71,68,95,114,97,110,107,40,103,41,91,114,93,46,97,110,0,109,105,110,99,114,111,115,115,46,99,0,105,110,115,116,97,108,108,95,105,110,95,114,97,110,107,0,105,110,115,116,97,108,108,95,105,110,95,114,97,110,107,44,32,108,105,110,101,32,37,100,58,32,78,68,95,111,114,100,101,114,40,37,115,41,32,91,37,100,93,32,62,32,71,68,95,114,97,110,107,40,82,111,111,116,41,91,37,100,93,46,97,110,32,91,37,100,93,10,0,105,110,115,116,97,108,108,95,105,110,95,114,97,110,107,44,32,108,105,110,101,32,37,100,58,32,114,97,110,107,32,37,100,32,110,111,116,32,105,110,32,114,97,110,107,32,114,97,110,103,101,32,91,37,100,44,37,100,93,10,0,105,110,115,116,97,108,108,95,105,110,95,114,97,110,107,44,32,108,105,110,101,32,37,100,58,32,71,68,95,114,97,110,107,40,103,41,91,37,100,93,46,118,32,43,32,78,68,95,111,114,100,101,114,40,37,115,41,32,91,37,100,93,32,62,32,71,68,95,114,97,110,107,40,103,41,91,37,100,93,46,97,118,32,43,32,71,68,95,114,97,110,107,40,82,111,111,116,41,91,37,100,93,46,97,110,32,91,37,100,93,10,0,115,117,114,112,114,105,115,101,10,0,78,68,95,111,114,100,101,114,40,118,41,32,60,32,78,68,95,111,114,100,101,114,40,119,41,0,116,114,97,110,115,112,111,115,101,95,115,116,101,112,0,118,0,110,101,105,103,104,98,111,114,0,40,114,118,32,61,61,32,48,41,32,124,124,32,40,78,68,95,111,114,100,101,114,40,114,118,41,45,78,68,95,111,114,100,101,114,40,118,41,41,42,100,105,114,32,62,32,48,0,109,105,110,99,114,111,115,115,32,37,115,58,32,37,100,32,99,114,111,115,115,105,110,103,115,44,32,37,46,50,102,32,115,101,99,115,46,10,0,99,111,110,115,116,114,97,105,110,105,110,103,95,102,108,97,116,95,101,100,103,101,40,103,44,118,44,101,41,32,61,61,32,70,65,76,83,69,0,102,108,97,116,95,114,101,111,114,100,101,114,0,78,68,95,114,97,110,107,40,118,41,32,61,61,32,114,0,112,111,115,116,111,114,100,101,114,0,102,108,97,116,105,110,100,101,120,40,97,103,104,101,97,100,40,101,41,41,32,60,32,77,45,62,110,114,111,119,115,0,102,108,97,116,95,115,101,97,114,99,104,0,102,108,97,116,105,110,100,101,120,40,97,103,116,97,105,108,40,101,41,41,32,60,32,77,45,62,110,99,111,108,115,0,111,117,116,0,111,114,100,101,114,105,110,103,32,39,37,115,39,32,110,111,116,32,114,101,99,111,103,110,105,122,101,100,46,10,0,111,114,100,101,114,105,110,103,32,39,37,115,39,32,110,111,116,32,114,101,99,111,103,110,105,122,101,100,32,102,111,114,32,110,111,100,101,32,39,37,115,39,46,10,0,109,101,114,103,101,50,58,32,103,114,97,112,104,32,37,115,44,32,114,97,110,107,32,37,100,32,104,97,115,32,111,110,108,121,32,37,100,32,60,32,37,100,32,110,111,100,101,115,10,0,109,105,110,99,114,111,115,115,58,32,112,97,115,115,32,37,100,32,105,116,101,114,32,37,100,32,116,114,121,105,110,103,32,37,100,32,99,117,114,95,99,114,111,115,115,32,37,100,32,98,101,115,116,95,99,114,111,115,115,32,37,100,10,0,98,97,108,97,110,99,101,0,95,110,101,119,95,114,97,110,107,0,109,99,108,105,109,105,116,0,114,97,110,107,40,103,44,32,50,44,32,110,115,105,116,101,114,50,40,103,41,41,32,61,61,32,48,0,112,111,115,105,116,105,111,110,46,99,0,100,111,116,95,112,111,115,105,116,105,111,110,0,69,100,103,101,32,108,101,110,103,116,104,32,37,102,32,108,97,114,103,101,114,32,116,104,97,110,32,109,97,120,105,109,117,109,32,37,117,32,97,108,108,111,119,101,100,46,10,67,104,101,99,107,32,102,111,114,32,111,118,101,114,119,105,100,101,32,110,111,100,101,40,115,41,46,10,0,65,82,61,37,48,46,52,108,102,9,32,65,114,101,97,61,32,37,48,46,52,108,102,9,0,68,117,109,109,121,61,37,100,10,0,71,111,105,110,103,32,116,111,32,97,112,112,108,121,32,97,110,111,116,104,101,114,32,101,120,112,97,110,115,105,111,110,46,10,0,110,101,120,116,35,105,116,101,114,61,37,100,10,0,104,112,0,99,111,110,110,101,99,116,71,114,97,112,104,0,110,115,108,105,109,105,116,0,99,111,110,116,97,105,110,95,110,111,100,101,115,32,99,108,117,115,116,32,37,115,32,114,97,110,107,32,37,100,32,109,105,115,115,105,110,103,32,110,111,100,101,10,0,110,115,108,105,109,105,116,49,0,110,101,119,114,97,110,107,0,77,97,120,114,97,110,107,32,61,32,37,100,44,32,109,105,110,114,97,110,107,32,61,32,37,100,10,0,108,101,97,100,101,114,32,33,61,32,78,85,76,76,0,114,97,110,107,46,99,0,99,108,117,115,116,101,114,95,108,101,97,100,101,114,0,40,78,68,95,85,70,95,115,105,122,101,40,110,41,32,60,61,32,49,41,32,124,124,32,40,110,32,61,61,32,108,101,97,100,101,114,41,0,97,103,104,101,97,100,40,101,41,32,61,61,32,85,70,95,102,105,110,100,40,97,103,104,101,97,100,40,101,41,41,0,109,105,110,109,97,120,95,101,100,103,101,115,0,97,103,116,97,105,108,40,101,41,32,61,61,32,85,70,95,102,105,110,100,40,97,103,116,97,105,108,40,101,41,41,0,114,97,110,107,0,115,97,109,101,0,109,105,110,0,115,111,117,114,99,101,0,109,97,120,0,115,105,110,107,0,108,101,118,101,108,32,97,115,115,105,103,110,109,101,110,116,32,99,111,110,115,116,114,97,105,110,116,115,0,108,101,118,101,108,32,103,114,97,112,104,32,114,101,99,0,127,114,111,111,116,0,127,116,111,112,0,127,98,111,116,0,99,111,109,112,97,99,116,0,95,119,101,97,107,95,37,100,0,114,97,110,107,105,110,103,58,32,102,97,105,108,117,114,101,32,116,111,32,99,114,101,97,116,101,32,115,116,114,111,110,103,32,99,111,110,115,116,114,97,105,110,116,32,101,100,103,101,32,98,101,116,119,101,101,110,32,110,111,100,101,115,32,37,115,32,97,110,100,32,37,115,10,0,37,115,32,104,97,115,32,117,110,114,101,99,111,103,110,105,122,101,100,32,114,97,110,107,61,37,115,0,108,101,118,101,108,32,101,100,103,101,32,114,101,99,0,108,101,118,101,108,32,110,111,100,101,32,114,101,99,0,115,97,109,101,104,101,97,100,0,115,97,109,101,116,97,105,108,0,116,111,111,32,109,97,110,121,32,40,62,32,37,100,41,32,115,97,109,101,123,104,101,97,100,44,116,97,105,108,125,32,103,114,111,117,112,115,32,102,111,114,32,110,111,100,101,32,37,115,10,0,99,111,109,98,105,65,82,32,61,32,37,108,102,10,0,37,108,102,44,37,100,0,116,104,101,32,97,115,112,101,99,116,32,97,116,116,114,105,98,117,116,101,32,104,97,115,32,98,101,101,110,32,100,105,115,97,98,108,101,100,32,100,117,101,32,116,111,32,105,109,112,108,101,109,101,110,116,97,116,105,111,110,32,102,108,97,119,115,32,45,32,97,116,116,114,105,98,117,116,101,32,105,103,110,111,114,101,100,46,10,0,69,68,95,116,111,95,118,105,114,116,40,101,41,32,61,61,32,78,85,76,76,0,99,108,97,115,115,50,46,99,0,109,101,114,103,101,95,99,104,97,105,110,0,69,68,95,116,111,95,118,105,114,116,40,111,114,105,103,41,32,61,61,32,78,85,76,76,0,109,97,107,101,95,99,104,97,105,110,0,69,68,95,116,111,95,118,105,114,116,40,111,114,105,103,41,32,33,61,32,78,85,76,76,0,37,115,32,119,97,115,32,97,108,114,101,97,100,121,32,105,110,32,97,32,114,97,110,107,115,101,116,44,32,100,101,108,101,116,101,100,32,102,114,111,109,32,99,108,117,115,116,101,114,32,37,115,10,0,78,68,95,114,97,110,107,40,102,114,111,109,41,32,60,32,78,68,95,114,97,110,107,40,116,111,41,0,99,108,117,115,116,101,114,46,99,0,109,97,112,95,112,97,116,104,0,108,104,101,97,100,0,108,116,97,105,108,0,37,115,32,45,62,32,37,115,58,32,115,112,108,105,110,101,32,115,105,122,101,32,62,32,49,32,110,111,116,32,115,117,112,112,111,114,116,101,100,10,0,37,115,32,45,62,32,37,115,58,32,104,101,97,100,32,110,111,116,32,105,110,115,105,100,101,32,104,101,97,100,32,99,108,117,115,116,101,114,32,37,115,10,0,37,115,32,45,62,32,37,115,58,32,116,97,105,108,32,105,115,32,105,110,115,105,100,101,32,104,101,97,100,32,99,108,117,115,116,101,114,32,37,115,10,0,98,101,122,45,62,115,102,108,97,103,0,99,111,109,112,111,117,110,100,46,99,0,109,97,107,101,67,111,109,112,111,117,110,100,69,100,103,101,0,98,101,122,45,62,101,102,108,97,103,0,37,115,32,45,62,32,37,115,58,32,116,97,105,108,32,110,111,116,32,105,110,115,105,100,101,32,116,97,105,108,32,99,108,117,115,116,101,114,32,37,115,10,0,37,115,32,45,62,32,37,115,58,32,104,101,97,100,32,105,115,32,105,110,115,105,100,101,32,116,97,105,108,32,99,108,117,115,116,101,114,32,37,115,10,0,115,101,103,109,101,110,116,32,91,37,115,44,37,115,93,32,100,111,101,115,32,110,111,116,32,105,110,116,101,114,115,101,99,116,32,98,111,120,32,108,108,61,37,115,44,117,114,61,37,115,10,0,98,111,120,73,110,116,101,114,115,101,99,116,102,0,40,37,46,53,103,44,37,46,53,103,41,0,99,108,117,115,116,101,114,32,110,97,109,101,100,32,37,115,32,110,111,116,32,102,111,117,110,100,10,0,99,111,110,99,101,110,116,114,97,116,101,61,116,114,117,101,32,109,97,121,32,110,111,116,32,119,111,114,107,32,99,111,114,114,101,99,116,108,121,46,10,0,114,101,98,117,105,108,116,100,95,118,108,105,115,116,115,58,32,114,97,110,107,32,108,101,97,100,32,37,115,32,110,111,116,32,105,110,32,111,114,100,101,114,32,37,100,32,111,102,32,114,97,110,107,32,37,100,10,0,100,101,103,101,110,101,114,97,116,101,32,99,111,110,99,101,110,116,114,97,116,101,100,32,114,97,110,107,32,37,115,44,37,100,10,0,78,68,95,105,110,40,114,105,103,104,116,41,46,115,105,122,101,32,43,32,78,68,95,111,117,116,40,114,105,103,104,116,41,46,115,105,122,101,32,61,61,32,48,0,99,111,110,99,46,99,0,109,101,114,103,101,118,105,114,116,117,97,108,0,0,78,68,95,111,117,116,40,118,41,46,115,105,122,101,32,61,61,32,50,0,102,108,97,116,46,99,0,115,101,116,98,111,117,110,100,115,0,71,68,95,109,105,110,114,97,110,107,40,103,41,32,61,61,32,48,0,97,98,111,109,105,110,97,116,105,111,110,0,110,101,97,116,111,95,108,97,121,111,117,116,0,110,101,97,116,111,0,102,100,112,0,115,102,100,112,0,116,119,111,112,105,0,99,105,114,99,111,0,112,97,116,99,104,119,111,114,107,0,111,115,97,103,101,0,110,111,112,0,110,111,112,49,0,110,111,112,50,0,37,108,102,44,37,108,102,44,37,108,102,37,99,0,110,111,100,101,32,37,115,44,32,112,111,115,105,116,105,111,110,32,37,115,44,32,101,120,112,101,99,116,101,100,32,116,119,111,32,100,111,117,98,108,101,115,10,0,110,111,100,101,32,37,115,32,105,110,32,103,114,97,112,104,32,37,115,32,104,97,115,32,110,111,32,112,111,115,105,116,105,111,110,10,0,115,116,97,114,116,0,115,101,108,102,0,114,97,110,100,111,109,0,110,111,100,101,32,112,111,115,105,116,105,111,110,115,32,97,114,101,32,105,103,110,111,114,101,100,32,117,110,108,101,115,115,32,115,116,97,114,116,61,114,97,110,100,111,109,10,0,97,115,32,114,101,113,117,105,114,101,100,32,98,121,32,116,104,101,32,45,110,32,102,108,97,103,10,0,103,114,97,112,104,32,37,115,32,105,115,32,100,105,115,99,111,110,110,101,99,116,101,100,46,32,72,101,110,99,101,44,32,116,104,101,32,99,105,114,99,117,105,116,32,109,111,100,101,108,10,0,65,108,116,101,114,110,97,116,105,118,101,108,121,44,32,99,111,110,115,105,100,101,114,32,114,117,110,110,105,110,103,32,110,101,97,116,111,32,117,115,105,110,103,32,45,71,112,97,99,107,61,116,114,117,101,32,111,114,32,100,101,99,111,109,112,111,115,105,110,103,10,0,116,104,101,32,103,114,97,112,104,32,105,110,116,111,32,99,111,110,110,101,99,116,101,100,32,99,111,109,112,111,110,101,110,116,115,46,10,0,83,111,108,118,105,110,103,32,109,111,100,101,108,32,37,100,32,105,116,101,114,97,116,105,111,110,115,32,37,100,32,116,111,108,32,37,102,10,0,78,68,95,105,100,40,110,112,41,32,61,61,32,105,0,110,101,97,116,111,105,110,105,116,46,99,0,109,97,107,101,71,114,97,112,104,68,97,116,97,0,102,32,60,32,103,114,97,112,104,91,106,93,46,110,101,100,103,101,115,0,100,102,115,67,121,99,108,101,0,109,111,100,101,108,32,37,100,32,115,109,97,114,116,95,105,110,105,116,32,37,100,32,115,116,114,101,115,115,119,116,32,37,100,32,105,116,101,114,97,116,105,111,110,115,32,37,100,32,116,111,108,32,37,102,10,0,99,111,110,118,101,114,116,32,103,114,97,112,104,58,32,0,109,97,106,111,114,105,122,97,116,105,111,110,10,0,37,100,32,110,111,100,101,115,32,37,46,50,102,32,115,101,99,10,0,108,101,118,101,108,115,103,97,112,0,108,97,121,111,117,116,32,97,98,111,114,116,101,100,10,0,115,116,114,101,115,115,119,116,0,37,115,32,97,116,116,114,105,98,117,116,101,32,118,97,108,117,101,32,109,117,115,116,32,98,101,32,49,32,111,114,32,50,32,45,32,105,103,110,111,114,105,110,103,10,0,95,110,101,97,116,111,95,99,99,0,109,111,100,101,108,0,99,105,114,99,117,105,116,0,115,117,98,115,101,116,0,115,104,111,114,116,112,97,116,104,0,109,100,115,0,101,100,103,101,115,32,105,110,32,103,114,97,112,104,32,37,115,32,104,97,118,101,32,110,111,32,108,101,110,32,97,116,116,114,105,98,117,116,101,46,32,72,101,110,99,101,44,32,116,104,101,32,109,100,115,32,109,111,100,101,108,10,0,105,115,32,105,110,97,112,112,114,111,112,114,105,97,116,101,46,32,82,101,118,101,114,116,105,110,103,32,116,111,32,116,104,101,32,115,104,111,114,116,101,115,116,32,112,97,116,104,32,109,111,100,101,108,46,10,0,85,110,107,110,111,119,110,32,118,97,108,117,101,32,37,115,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,34,109,111,100,101,108,34,32,105,110,32,103,114,97,112,104,32,37,115,32,45,32,105,103,110,111,114,101,100,10,0,109,111,100,101,0,75,75,0,109,97,106,111,114,0,104,105,101,114,0,73,108,108,101,103,97,108,32,118,97,108,117,101,32,37,115,32,102,111,114,32,97,116,116,114,105,98,117,116,101,32,34,109,111,100,101,34,32,105,110,32,103,114,97,112,104,32,37,115,32,45,32,105,103,110,111,114,101,100,10,0,115,44,37,108,102,44,37,108,102,37,110,0,32,101,44,37,108,102,44,37,108,102,37,110,0,0,112,111,115,32,97,116,116,114,105,98,117,116,101,32,102,111,114,32,101,100,103,101,32,40,37,115,44,37,115,41,32,100,111,101,115,110,39,116,32,104,97,118,101,32,51,110,43,49,32,112,111,105,110,116,115,10,0,37,108,102,44,37,108,102,37,110,0,115,121,110,116,97,120,32,101,114,114,111,114,32,105,110,32,112,111,115,32,97,116,116,114,105,98,117,116,101,32,102,111,114,32,101,100,103,101,32,40,37,115,44,37,115,41,10,0,37,108,102,44,37,108,102,44,37,108,102,44,37,108,102,0,109,97,107,101,83,112,108,105,110,101,58,32,102,97,105,108,101,100,32,116,111,32,109,97,107,101,32,115,112,108,105,110,101,32,101,100,103,101,32,40,37,115,44,37,115,41,10,0,115,112,108,105,110,101,32,37,115,32,37,115,10,0,116,104,101,32,98,111,117,110,100,105,110,103,32,98,111,120,101,115,32,111,102,32,115,111,109,101,32,110,111,100,101,115,32,116,111,117,99,104,32,45,32,102,97,108,108,105,110,103,32,98,97,99,107,32,116,111,32,115,116,114,97,105,103,104,116,32,108,105,110,101,32,101,100,103,101,115,10,0,115,111,109,101,32,110,111,100,101,115,32,119,105,116,104,32,109,97,114,103,105,110,32,40,37,46,48,50,102,44,37,46,48,50,102,41,32,116,111,117,99,104,32,45,32,102,97,108,108,105,110,103,32,98,97,99,107,32,116,111,32,115,116,114,97,105,103,104,116,32,108,105,110,101,32,101,100,103,101,115,10,0,112,111,108,121,108,105,110,101,115,0,108,105,110,101,32,115,101,103,109,101,110,116,115,0,111,114,116,104,111,103,111,110,97,108,32,108,105,110,101,115,0,67,114,101,97,116,105,110,103,32,101,100,103,101,115,32,117,115,105,110,103,32,37,115,10,0,112,111,108,121,108,105,110,101,32,37,115,32,37,115,10,0,98,32,61,61,32,110,0,110,101,97,116,111,115,112,108,105,110,101,115,46,99,0,109,97,107,101,95,98,97,114,114,105,101,114,115,0,109,100,115,77,111,100,101,108,58,32,100,101,108,116,97,32,61,32,37,102,10,0,83,101,116,116,105,110,103,32,117,112,32,115,116,114,101,115,115,32,102,117,110,99,116,105,111,110,0,83,111,108,118,105,110,103,32,109,111,100,101,108,58,32,0,10,102,105,110,97,108,32,101,32,61,32,37,102,32,37,100,32,105,116,101,114,97,116,105,111,110,115,32,37,46,50,102,32,115,101,99,10,0,83,99,97,110,110,105,110,103,32,103,114,97,112,104,32,37,115,44,32,37,100,32,110,111,100,101,115,10,0,68,97,109,112,105,110,103,0,100,101,102,97,117,108,116,100,105,115,116,0,83,101,116,116,105,110,103,32,105,110,105,116,105,97,108,32,112,111,115,105,116,105,111,110,115,10,0,115,116,97,114,116,61,37,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,119,105,116,104,32,109,111,100,101,61,115,101,108,102,32,45,32,105,103,110,111,114,101,100,10,0,83,101,116,116,105,110,103,32,117,112,32,115,112,114,105,110,103,32,109,111,100,101,108,58,32,0,37,46,50,102,32,115,101,99,10,0,10,102,105,110,97,108,32,101,32,61,32,37,102,0,33,0,32,37,100,37,115,32,105,116,101,114,97,116,105,111,110,115,32,37,46,50,102,32,115,101,99,10,0,77,97,120,46,32,105,116,101,114,97,116,105,111,110,115,32,40,37,100,41,32,114,101,97,99,104,101,100,32,111,110,32,103,114,97,112,104,32,37,115,10,0,37,46,51,102,32,0,37,115,32,37,46,51,102,10,0,78,68,95,104,101,97,112,105,110,100,101,120,40,118,41,32,60,32,48,0,115,116,117,102,102,46,99,0,110,101,97,116,111,95,101,110,113,117,101,117,101,0,67,97,108,99,117,108,97,116,105,110,103,32,115,104,111,114,116,101,115,116,32,112,97,116,104,115,58,32,0,32,105,110,32,37,115,32,45,32,115,101,116,116,105,110,103,32,116,111,32,37,46,48,50,102,10,0,98,97,100,32,101,100,103,101,32,108,101,110,32,34,37,115,34,0,115,112,101,99,105,102,105,101,100,32,114,111,111,116,32,110,111,100,101,32,34,37,115,34,32,119,97,115,32,110,111,116,32,102,111,117,110,100,46,0,85,115,105,110,103,32,100,101,102,97,117,108,116,32,99,97,108,99,117,108,97,116,105,111,110,32,102,111,114,32,114,111,111,116,32,110,111,100,101,10,0,114,101,112,111,115,105,116,105,111,110,32,37,115,10,0,37,115,32,58,32,37,102,32,37,102,10,0,37,115,32,58,32,37,102,32,37,102,32,37,102,32,37,102,10,0,32,32,0,71,114,97,112,104,32,37,115,32,104,97,115,32,97,114,114,97,121,32,112,97,99,107,105,110,103,32,119,105,116,104,32,117,115,101,114,32,118,97,108,117,101,115,32,98,117,116,32,110,111,32,34,115,111,114,116,118,34,32,97,116,116,114,105,98,117,116,101,115,32,97,114,101,32,100,101,102,105,110,101,100,46,0,112,105,110,0,87,97,114,110,105,110,103,58,32,110,111,100,101,32,37,115,44,32,112,111,115,105,116,105,111,110,32,37,115,44,32,101,120,112,101,99,116,101,100,32,116,119,111,32,102,108,111,97,116,115,10,0,99,111,111,114,100,115,0,115,112,108,105,110,101,115,32,97,110,100,32,99,108,117,115,116,101,114,32,101,100,103,101,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,45,32,117,115,105,110,103,32,108,105,110,101,32,115,101,103,109,101,110,116,115,10,0,108,97,121,111,117,116,32,37,115,10,0,101,110,100,32,37,115,10,0,105,100,120,32,61,61,32,115,122,0,108,97,121,111,117,116,46,99,0,101,120,112,97,110,100,67,108,117,115,116,101,114,0,105,32,61,61,32,100,101,103,0,103,101,116,69,100,103,101,76,105,115,116,0,95,100,103,95,37,100,0,100,101,114,105,118,101,32,103,114,97,112,104,32,37,115,32,111,102,32,37,115,10,0,110,111,100,101,32,34,37,115,34,32,105,115,32,99,111,110,116,97,105,110,101,100,32,105,110,32,116,119,111,32,110,111,110,45,99,111,109,112,97,114,97,98,108,101,32,99,108,117,115,116,101,114,115,32,34,37,115,34,32,97,110,100,32,34,37,115,34,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,95,112,111,114,116,95,37,115,95,37,115,95,37,115,95,37,108,100,0,95,112,111,114,116,95,37,115,95,40,37,100,41,95,40,37,100,41,95,37,108,100,0,37,108,102,44,37,108,102,44,37,108,102,44,37,108,102,37,99,0,103,114,97,112,104,32,37,115,44,32,99,111,111,114,100,32,37,115,44,32,101,120,112,101,99,116,101,100,32,102,111,117,114,32,100,111,117,98,108,101,115,10,0,109,97,120,105,116,101,114,0,84,48,0,102,100,112,32,100,111,101,115,32,110,111,116,32,115,117,112,112,111,114,116,32,115,116,97,114,116,61,115,101,108,102,32,45,32,105,103,110,111,114,105,110,103,10,0,120,76,97,121,111,117,116,32,0,57,58,112,114,105,115,109,0,116,114,105,101,115,32,61,32,37,100,44,32,109,111,100,101,32,61,32,37,115,10,0,100,101,114,105,118,101,100,0,105,110,102,111,0,101,120,116,114,97,99,116,101,100,32,97,32,37,100,45,110,101,105,103,104,98,111,114,104,111,111,100,32,103,114,97,112,104,32,111,102,32,37,100,32,101,100,103,101,115,32,102,114,111,109,32,97,32,103,114,97,112,104,32,111,102,32,37,100,32,101,100,103,101,115,10,0,115,102,100,112,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,115,116,97,114,116,61,114,97,110,100,111,109,10,0,75,0,114,101,112,117,108,115,105,118,101,102,111,114,99,101,0,108,101,118,101,108,115,0,115,109,111,111,116,104,105,110,103,0,113,117,97,100,116,114,101,101,0,98,101,97,117,116,105,102,121,0,111,118,101,114,108,97,112,95,115,104,114,105,110,107,0,114,111,116,97,116,105,111,110,0,108,97,98,101,108,95,115,99,104,101,109,101,0,108,97,98,101,108,95,115,99,104,101,109,101,32,61,32,37,100,32,62,32,52,32,58,32,105,103,110,111,114,105,110,103,10,0,102,97,115,116,0,97,118,103,95,100,105,115,116,0,103,114,97,112,104,95,100,105,115,116,0,112,111,119,101,114,95,100,105,115,116,0,115,112,114,105,110,103,0,100,105,109,101,110,0,100,105,109,0,13,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,105,116,101,114,32,61,32,37,100,44,32,115,116,101,112,32,61,32,37,102,32,70,110,111,114,109,32,61,32,37,102,32,110,122,32,61,32,37,100,32,32,75,32,61,32,37,102,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,0,115,112,114,105,110,103,95,101,108,101,99,116,114,105,99,97,108,95,101,109,98,101,100,100,105,110,103,95,115,108,111,119,0,110,115,117,112,101,114,95,97,118,103,61,37,102,44,32,99,111,117,110,116,115,95,97,118,103,32,61,32,37,102,32,50,42,110,115,117,112,101,114,43,99,111,117,110,116,115,61,37,102,10,0,100,109,101,97,110,32,61,32,37,102,44,32,114,104,111,32,61,32,37,102,10,0,115,101,110,100,32,114,97,110,100,111,109,32,99,111,111,114,100,105,110,97,116,101,115,10,0,81,85,65,68,95,84,82,69,69,95,72,89,66,82,73,68,44,32,115,105,122,101,32,108,97,114,103,101,114,32,116,104,97,110,32,37,100,44,32,115,119,105,116,99,104,32,116,111,32,102,97,115,116,32,113,117,97,100,116,114,101,101,0,99,116,114,108,45,62,111,118,101,114,108,97,112,61,37,100,10,0,120,120,120,32,37,100,32,37,100,10,0,37,100,32,37,100,10,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,102,10,0,117,110,105,102,111,114,109,95,115,116,114,101,115,115,46,99,0,85,110,105,102,111,114,109,83,116,114,101,115,115,83,109,111,111,116,104,101,114,95,110,101,119,0,83,112,97,114,115,101,77,97,116,114,105,120,95,105,115,95,115,121,109,109,101,116,114,105,99,40,66,44,32,70,65,76,83,69,41,0,117,110,105,102,111,114,109,95,115,116,114,101,115,115,0,124,101,100,103,101,108,97,98,101,108,124,0,108,101,110,0,111,118,101,114,108,97,112,0,65,100,106,117,115,116,105,110,103,32,37,115,32,117,115,105,110,103,32,37,115,10,0,85,110,104,97,110,100,108,101,100,32,97,100,106,117,115,116,32,111,112,116,105,111,110,32,37,115,10,0,115,101,112,0,101,115,101,112,0,78,111,100,101,32,115,101,112,97,114,97,116,105,111,110,58,32,97,100,100,61,37,100,32,40,37,102,44,37,102,41,10,0,69,100,103,101,32,115,101,112,97,114,97,116,105,111,110,58,32,97,100,100,61,37,100,32,40,37,102,44,37,102,41,10,0,37,102,44,37,102,0,78,117,109,98,101,114,32,111,102,32,105,116,101,114,97,116,105,111,110,115,32,61,32,37,100,10,0,78,117,109,98,101,114,32,111,102,32,105,110,99,114,101,97,115,101,115,32,61,32,37,100,10,0,111,118,101,114,108,97,112,32,91,37,100,93,32,58,32,37,100,10,0,118,111,114,111,95,109,97,114,103,105,110,0,115,99,97,108,101,32,61,32,40,37,46,48,51,102,44,37,46,48,51,102,41,10,0,79,118,101,114,108,97,112,32,118,97,108,117,101,32,34,37,115,34,32,117,110,115,117,112,112,111,114,116,101,100,32,45,32,105,103,110,111,114,101,100,10,0,85,110,114,101,99,111,103,110,105,122,101,100,32,111,118,101,114,108,97,112,32,118,97,108,117,101,32,34,37,115,34,32,45,32,117,115,105,110,103,32,102,97,108,115,101,10,0,111,118,101,114,108,97,112,95,115,99,97,108,105,110,103,0,118,111,114,111,110,111,105,0,86,111,114,111,110,111,105,0,115,99,97,108,105,110,103,0,118,112,115,99,0,105,112,115,101,112,0,111,115,99,97,108,101,0,111,108,100,32,115,99,97,108,105,110,103,0,115,99,97,108,101,120,121,0,120,32,97,110,100,32,121,32,115,99,97,108,105,110,103,0,111,114,116,104,111,0,111,114,116,104,111,103,111,110,97,108,32,99,111,110,115,116,114,97,105,110,116,115,0,111,114,116,104,111,95,121,120,0,111,114,116,104,111,120,121,0,120,121,32,111,114,116,104,111,103,111,110,97,108,32,99,111,110,115,116,114,97,105,110,116,115,0,111,114,116,104,111,121,120,0,121,120,32,111,114,116,104,111,103,111,110,97,108,32,99,111,110,115,116,114,97,105,110,116,115,0,112,111,114,116,104,111,0,112,115,101,117,100,111,45,111,114,116,104,111,103,111,110,97,108,32,99,111,110,115,116,114,97,105,110,116,115,0,112,111,114,116,104,111,95,121,120,0,112,111,114,116,104,111,120,121,0,120,121,32,112,115,101,117,100,111,45,111,114,116,104,111,103,111,110,97,108,32,99,111,110,115,116,114,97,105,110,116,115,0,112,111,114,116,104,111,121,120,0,121,120,32,112,115,101,117,100,111,45,111,114,116,104,111,103,111,110,97,108,32,99,111,110,115,116,114,97,105,110,116,115,0,112,114,105,115,109,0,110,111,114,109,97,108,105,122,101,0,67,97,108,99,117,108,97,116,105,110,103,32,99,105,114,99,117,105,116,32,109,111,100,101,108,0,99,111,110,106,117,103,97,116,101,95,103,114,97,100,105,101,110,116,58,32,117,110,101,120,112,101,99,116,101,100,32,108,101,110,103,116,104,32,48,32,118,101,99,116,111,114,10,0,67,97,108,99,117,108,97,116,105,110,103,32,115,117,98,115,101,116,32,109,111,100,101,108,0,103,114,97,112,104,32,105,115,32,100,105,115,99,111,110,110,101,99,116,101,100,46,32,72,101,110,99,101,44,32,116,104,101,32,99,105,114,99,117,105,116,32,109,111,100,101,108,10,0,105,115,32,117,110,100,101,102,105,110,101,100,46,32,82,101,118,101,114,116,105,110,103,32,116,111,32,116,104,101,32,115,104,111,114,116,101,115,116,32,112,97,116,104,32,109,111,100,101,108,46,10,0,67,97,108,99,117,108,97,116,105,110,103,32,77,68,83,32,109,111,100,101,108,0,67,97,108,99,117,108,97,116,105,110,103,32,115,104,111,114,116,101,115,116,32,112,97,116,104,115,0,58,32,37,46,50,102,32,115,101,99,10,0,83,101,116,116,105,110,103,32,105,110,105,116,105,97,108,32,112,111,115,105,116,105,111,110,115,0,58,32,37,46,50,102,32,115,101,99,0,99,111,109,112,114,101,115,115,32,37,103,32,10,0,115,99,97,108,101,32,98,121,32,37,103,44,37,103,32,10,0,98,101,115,116,99,111,115,116,32,60,32,72,85,71,69,95,86,65,76,0,99,111,110,115,116,114,97,105,110,116,46,99,0,99,111,109,112,117,116,101,83,99,97,108,101,88,89,0,99,103,0,100,101,108,116,97,32,60,61,32,48,120,70,70,70,70,0,109,107,78,67,111,110,115,116,114,97,105,110,116,71,0,118,103,0,100,101,108,97,117,110,97,121,95,116,114,105,97,110,103,117,108,97,116,105,111,110,58,32,37,115,10,0,100,101,108,97,117,110,97,121,95,116,114,105,58,32,37,115,10,0,71,114,97,112,104,118,105,122,32,98,117,105,108,116,32,119,105,116,104,111,117,116,32,97,110,121,32,116,114,105,97,110,103,117,108,97,116,105,111,110,32,108,105,98,114,97,114,121,10,0,116,114,121,105,110,103,32,116,111,32,100,101,108,101,116,101,32,97,32,110,111,110,45,108,105,110,101,10,0,10,105,110,116,101,114,115,101,99,116,105,111,110,32,97,116,32,37,46,51,102,32,37,46,51,102,10,0,115,101,103,35,37,100,32,58,32,40,37,46,51,102,44,32,37,46,51,102,41,32,40,37,46,51,102,44,32,37,46,51,102,41,10,0,114,101,109,111,118,101,95,111,118,101,114,108,97,112,58,32,71,114,97,112,104,118,105,122,32,110,111,116,32,98,117,105,108,116,32,119,105,116,104,32,116,114,105,97,110,103,117,108,97,116,105,111,110,32,108,105,98,114,97,114,121,10,0,109,97,107,101,65,100,100,80,111,108,121,58,32,117,110,107,110,111,119,110,32,115,104,97,112,101,32,116,121,112,101,32,37,115,10,0,109,97,107,101,80,111,108,121,58,32,117,110,107,110,111,119,110,32,115,104,97,112,101,32,116,121,112,101,32,37,115,10,0,120,33,61,78,85,76,76,0,115,109,97,114,116,95,105,110,105,95,120,46,99,0,73,77,68,83,95,103,105,118,101,110,95,100,105,109,0,105,108,108,45,99,111,110,100,105,116,105,111,110,101,100,10,0,116,119,111,112,105,58,32,117,115,101,32,111,102,32,119,101,105,103,104,116,61,48,32,99,114,101,97,116,101,115,32,100,105,115,99,111,110,110,101,99,116,101,100,32,99,111,109,112,111,110,101,110,116,46,10,0,82,97,110,107,32,115,101,112,97,114,97,116,105,111,110,32,61,32,0,37,46,48,51,108,102,32,0,97,114,101,97,0,105,110,115,101,116,0,37,115,32,99,111,111,114,100,32,37,46,53,103,32,37,46,53,103,32,104,116,32,37,102,32,119,105,100,116,104,32,37,102,10,0,37,46,48,51,102,0,114,101,99,32,37,102,32,37,102,32,37,102,32,37,102,10,0,37,102,32,45,32,37,102,32,37,102,32,37,102,32,37,102,32,61,32,37,102,32,40,37,102,32,37,102,32,37,102,32,37,102,41,10,0,116,114,121,105,110,103,32,116,111,32,97,100,100,32,116,111,32,114,101,99,116,32,123,37,102,32,43,47,45,32,37,102,44,32,37,102,32,43,47,45,32,37,102,125,10,0,116,111,116,97,108,32,97,100,100,101,100,32,115,111,32,102,97,114,32,61,32,37,100,10,0,97,100,100,105,110,103,32,37,100,32,105,116,101,109,115,44,32,116,111,116,97,108,32,97,114,101,97,32,61,32,37,102,44,32,119,32,61,32,37,102,44,32,97,114,101,97,47,119,61,37,102,10,0,99,111,109,112,111,117,110,100,69,100,103,101,115,58,32,99,111,117,108,100,32,110,111,116,32,99,111,110,115,116,114,117,99,116,32,111,98,115,116,97,99,108,101,115,32,45,32,102,97,108,108,105,110,103,32,98,97,99,107,32,116,111,32,115,116,114,97,105,103,104,116,32,108,105,110,101,32,101,100,103,101,115,10,0,110,111,100,101,115,32,116,111,117,99,104,32,45,32,102,97,108,108,105,110,103,32,98,97,99,107,32,116,111,32,115,116,114,97,105,103,104,116,32,108,105,110,101,32,101,100,103,101,115,10,0,99,99,37,115,95,37,100,0,99,99,37,115,43,37,100,0,99,95,99,110,116,32,61,61,32,48,0,99,111,109,112,46,99,0,102,105,110,100,67,67,111,109,112,0,103,114,105,100,40,37,100,44,37,100,41,58,32,37,115,10,0,119,105,100,116,104,32,62,32,48,0,81,117,97,100,84,114,101,101,46,99,0,81,117,97,100,84,114,101,101,95,110,101,119,0,33,40,113,45,62,108,41,0,81,117,97,100,84,114,101,101,95,97,100,100,95,105,110,116,101,114,110,97,108,0,105,105,32,60,32,49,60,60,100,105,109,32,38,38,32,105,105,32,62,61,32,48,0,113,45,62,113,116,115,91,105,105,93,0,113,45,62,110,32,61,61,32,49,0,33,40,113,45,62,113,116,115,41,0,113,45,62,108,0,119,103,116,32,62,32,48,0,81,117,97,100,84,114,101,101,95,114,101,112,117,108,115,105,118,101,95,102,111,114,99,101,95,97,99,99,117,109,117,108,97,116,101,0,113,116,50,45,62,110,32,62,32,48,0,113,116,49,45,62,110,32,62,32,48,32,38,38,32,113,116,50,45,62,110,32,62,32,48,0,81,117,97,100,84,114,101,101,95,114,101,112,117,108,115,105,118,101,95,102,111,114,99,101,95,105,110,116,101,114,97,99,116,0,100,105,115,116,32,62,32,48,0,65,45,62,102,111,114,109,97,116,32,61,61,32,70,79,82,77,65,84,95,67,83,82,0,83,112,97,114,115,101,77,97,116,114,105,120,46,99,0,83,112,97,114,115,101,77,97,116,114,105,120,95,116,114,97,110,115,112,111,115,101,0,83,112,97,114,115,101,77,97,116,114,105,120,95,105,115,95,115,121,109,109,101,116,114,105,99,0,65,32,38,38,32,66,0,83,112,97,114,115,101,77,97,116,114,105,120,95,97,100,100,0,65,45,62,102,111,114,109,97,116,32,61,61,32,66,45,62,102,111,114,109,97,116,32,38,38,32,65,45,62,102,111,114,109,97,116,32,61,61,32,70,79,82,77,65,84,95,67,83,82,0,65,45,62,116,121,112,101,32,61,61,32,66,45,62,116,121,112,101,0,65,45,62,102,111,114,109,97,116,32,61,61,32,70,79,82,77,65,84,95,67,79,79,82,68,0,83,112,97,114,115,101,77,97,116,114,105,120,95,102,114,111,109,95,99,111,111,114,100,105,110,97,116,101,95,102,111,114,109,97,116,0,83,112,97,114,115,101,77,97,116,114,105,120,95,109,117,108,116,105,112,108,121,95,118,101,99,116,111,114,0,65,45,62,116,121,112,101,32,61,61,32,77,65,84,82,73,88,95,84,89,80,69,95,82,69,65,76,32,124,124,32,65,45,62,116,121,112,101,32,61,61,32,77,65,84,82,73,88,95,84,89,80,69,95,73,78,84,69,71,69,82,0,65,45,62,116,121,112,101,32,61,61,32,77,65,84,82,73,88,95,84,89,80,69,95,82,69,65,76,0,83,112,97,114,115,101,77,97,116,114,105,120,95,109,117,108,116,105,112,108,121,0,106,99,91,109,97,115,107,91,106,98,91,107,93,93,93,32,61,61,32,106,98,91,107,93,0,83,112,97,114,115,101,77,97,116,114,105,120,95,109,117,108,116,105,112,108,121,51,0,106,100,91,109,97,115,107,91,106,99,91,107,93,93,93,32,61,61,32,106,99,91,107,93,0,106,97,91,109,97,115,107,91,106,97,91,106,93,93,93,32,61,61,32,106,97,91,106,93,0,83,112,97,114,115,101,77,97,116,114,105,120,95,115,117,109,95,114,101,112,101,97,116,95,101,110,116,114,105,101,115,0,105,100,32,60,32,110,42,40,121,109,97,120,45,121,109,105,110,43,49,41,0,106,97,91,109,97,115],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+122462);allocate([107,91,105,100,93,93,32,61,61,32,106,97,91,106,93,0,83,112,97,114,115,101,77,97,116,114,105,120,95,99,111,111,114,100,105,110,97,116,101,95,102,111,114,109,95,97,100,100,95,101,110,116,114,105,101,115,0,83,112,97,114,115,101,77,97,116,114,105,120,95,100,105,118,105,100,101,95,114,111,119,95,98,121,95,100,101,103,114,101,101,0,114,111,111,116,32,62,61,32,48,32,38,38,32,114,111,111,116,32,60,32,109,0,83,112,97,114,115,101,77,97,116,114,105,120,95,108,101,118,101,108,95,115,101,116,115,95,105,110,116,101,114,110,97,108,0,109,32,61,61,32,65,45,62,110,0,83,112,97,114,115,101,77,97,116,114,105,120,95,105,115,95,115,121,109,109,101,116,114,105,99,40,65,44,32,84,82,85,69,41,0,109,32,61,61,32,110,0,83,112,97,114,115,101,77,97,116,114,105,120,95,100,105,115,116,97,110,99,101,95,109,97,116,114,105,120,95,107,104,111,112,115,0,110,108,101,118,101,108,45,49,32,60,61,32,107,104,111,112,115,0,109,97,115,107,91,108,101,118,101,108,115,101,116,91,106,93,93,32,61,61,32,105,43,49,0,68,105,106,107,115,116,114,97,95,105,110,116,101,114,110,97,108,0,104,0,104,101,97,112,95,105,100,115,91,114,111,111,116,93,32,62,61,32,48,0,110,100,97,116,97,45,62,105,100,32,61,61,32,106,106,0,83,112,97,114,115,101,77,97,116,114,105,120,95,109,117,108,116,105,112,108,121,95,100,101,110,115,101,50,0,83,112,97,114,115,101,77,97,116,114,105,120,95,109,117,108,116,105,112,108,121,95,100,101,110,115,101,49,0,109,32,62,32,48,32,38,38,32,110,32,62,32,48,32,38,38,32,110,122,32,62,61,32,48,0,83,112,97,114,115,101,77,97,116,114,105,120,95,102,114,111,109,95,99,111,111,114,100,105,110,97,116,101,95,97,114,114,97,121,115,95,105,110,116,101,114,110,97,108,0,65,0,110,32,62,32,49,0,103,101,110,101,114,97,108,46,99,0,105,114,97,110,100,0,111,110,101,98,108,111,99,107,0,109,105,110,100,105,115,116,0,97,114,116,105,99,117,108,97,116,105,111,110,95,112,111,115,0,114,111,111,116,0,80,114,105,111,114,105,116,121,81,117,101,117,101,46,99,0,80,114,105,111,114,105,116,121,81,117,101,117,101,95,112,117,115,104,0,103,97,105,110,32,60,61,32,113,45,62,110,103,97,105,110,0,83,112,97,114,115,101,77,97,116,114,105,120,95,105,115,95,115,121,109,109,101,116,114,105,99,40,65,44,32,70,65,76,83,69,41,0,112,111,115,116,95,112,114,111,99,101,115,115,46,99,0,105,100,101,97,108,95,100,105,115,116,97,110,99,101,95,109,97,116,114,105,120,0,108,101,110,32,62,32,48,0,83,116,114,101,115,115,77,97,106,111,114,105,122,97,116,105,111,110,83,109,111,111,116,104,101,114,50,95,110,101,119,0,110,122,32,62,32,48,0,105,100,101,97,108,95,100,105,115,116,95,115,99,104,101,109,101,32,118,97,108,117,101,32,119,114,111,110,103,0,83,112,97,114,115,101,77,97,116,114,105,120,95,105,115,95,115,121,109,109,101,116,114,105,99,40,65,44,32,70,65,76,83,69,41,32,38,38,32,65,45,62,116,121,112,101,32,61,61,32,77,65,84,82,73,88,95,84,89,80,69,95,82,69,65,76,0,83,112,97,114,115,101,83,116,114,101,115,115,77,97,106,111,114,105,122,97,116,105,111,110,83,109,111,111,116,104,101,114,95,110,101,119,0,105,100,105,97,103,32,62,61,32,48,0,83,116,114,101,115,115,77,97,106,111,114,105,122,97,116,105,111,110,83,109,111,111,116,104,101,114,95,115,109,111,111,116,104,0,84,114,105,97,110,103,108,101,83,109,111,111,116,104,101,114,95,110,101,119,0,106,100,105,97,103,32,62,61,32,48,0,83,112,114,105,110,103,83,109,111,111,116,104,101,114,95,110,101,119,0,33,102,108,97,103,0,83,112,114,105,110,103,83,109,111,111,116,104,101,114,95,115,109,111,111,116,104,0,40,33,106,99,110,41,32,38,38,32,40,33,118,97,108,41,0,103,101,116,95,101,100,103,101,95,108,97,98,101,108,95,109,97,116,114,105,120,0,110,101,105,103,104,98,61,37,100,10,0,104,45,62,105,100,95,116,111,95,112,111,115,91,105,100,93,32,61,61,32,112,111,115,0,66,105,110,97,114,121,72,101,97,112,46,99,0,66,105,110,97,114,121,72,101,97,112,95,105,110,115,101,114,116,0,104,45,62,112,111,115,95,116,111,95,105,100,91,112,111,115,93,32,61,61,32,105,100,0,112,111,115,32,60,32,104,45,62,108,101,110,0,66,105,110,97,114,121,72,101,97,112,95,101,120,116,114,97,99,116,95,105,116,101,109,0,112,97,114,101,110,116,80,111,115,32,60,32,104,45,62,108,101,110,0,115,119,97,112,0,110,111,100,101,80,111,115,32,60,32,104,45,62,108,101,110,0,114,111,111,116,32,61,32,37,115,10,0,95,98,108,111,99,107,95,37,100,0,115,45,62,115,122,32,62,32,48,0,98,108,111,99,107,116,114,101,101,46,99,0,112,111,112,0,97,99,116,117,97,108,0,110,111,100,101,108,105,115,116,46,99,0,105,110,115,101,114,116,78,111,100,101,108,105,115,116,0,95,115,112,97,110,95,37,100,0,95,99,108,111,110,101,95,37,100,0,105,112,0,100,101,103,108,105,115,116,46,99,0,114,101,109,111,118,101,68,101,103,108,105,115,116,0,10,64,40,35,41,36,73,100,36,0,10,0,69,114,114,111,114,0,87,97,114,110,105,110,103,0,37,115,58,32,0,117,115,101,114,111,117,116,58,32,99,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,10,0,95,65,71,95,100,97,116,97,100,105,99,116,0,97,103,100,105,99,116,111,102,58,32,117,110,107,110,111,119,110,32,107,105,110,100,32,37,100,10,0,95,65,71,95,115,116,114,100,97,116,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,99,37,108,100,0,109,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,117,114,101,0,97,103,100,101,108,101,116,101,32,111,110,32,119,114,111,110,103,32,103,114,97,112,104,0,95,65,71,95,112,101,110,100,105,110,103,0,97,103,114,101,99,111,114,100,95,99,97,108,108,98,97,99,107,32,111,102,32,97,32,98,97,100,32,111,98,106,101,99,116,0,112,101,110,100,32,100,105,99,116,111,102,32,97,32,98,97,100,32,111,98,106,101,99,116,0,109,111,118,101,32,116,111,32,102,114,111,110,116,32,108,111,99,107,32,105,110,99,111,110,115,105,115,116,101,110,99,121,0,0,92,92,0,102,97,116,97,108,32,102,108,101,120,32,115,99,97,110,110,101,114,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,45,45,110,111,32,97,99,116,105,111,110,32,102,111,117,110,100,0,111,117,116,32,111,102,32,100,121,110,97,109,105,99,32,109,101,109,111,114,121,32,105,110,32,97,97,103,95,99,114,101,97,116,101,95,98,117,102,102,101,114,40,41,0,58,32,0,32,105,110,32,108,105,110,101,32,37,100,32,110,101,97,114,32,39,0,39,10,0,102,108,101,120,32,115,99,97,110,110,101,114,32,112,117,115,104,45,98,97,99,107,32,111,118,101,114,102,108,111,119,0,37,115,10,0,102,97,116,97,108,32,102,108,101,120,32,115,99,97,110,110,101,114,32,105,110,116,101,114,110,97,108,32,101,114,114,111,114,45,45,101,110,100,32,111,102,32,98,117,102,102,101,114,32,109,105,115,115,101,100,0,102,97,116,97,108,32,101,114,114,111,114,32,45,32,115,99,97,110,110,101,114,32,105,110,112,117,116,32,98,117,102,102,101,114,32,111,118,101,114,102,108,111,119,0,105,110,112,117,116,32,105,110,32,102,108,101,120,32,115,99,97,110,110,101,114,32,102,97,105,108,101,100,0,111,117,116,32,111,102,32,100,121,110,97,109,105,99,32,109,101,109,111,114,121,32,105,110,32,97,97,103,95,103,101,116,95,110,101,120,116,95,98,117,102,102,101,114,40,41,0,105,110,112,117,116,0,115,121,110,116,97,120,32,97,109,98,105,103,117,105,116,121,32,45,32,98,97,100,108,121,32,100,101,108,105,109,105,116,101,100,32,110,117,109,98,101,114,32,39,0,39,32,105,110,32,108,105,110,101,32,37,100,32,111,102,32,0,32,115,112,108,105,116,115,32,105,110,116,111,32,116,119,111,32,116,111,107,101,110,115,10,0,108,105,110,101,0,37,100,32,37,49,91,34,93,37,110,0,111,117,116,32,111,102,32,100,121,110,97,109,105,99,32,109,101,109,111,114,121,32,105,110,32,97,97,103,101,110,115,117,114,101,95,98,117,102,102,101,114,95,115,116,97,99,107,40,41,0,108,105,110,101,108,101,110,103,116,104,0,59,10,0,32,91,107,101,121,61,0,93,0,32,91,0,44,10,0,61,0,95,37,108,100,95,83,85,83,80,69,67,84,0,0,100,105,0,115,116,114,105,99,116,32,0,123,10,0,93,59,10,0,34,34,0,115,116,114,105,99,116,0,18,238,238,20,9,3,238,254,238,238,238,1,238,238,238,1,238,238,10,254,238,19,25,21,238,19,1,238,238,238,238,11,17,238,238,238,238,238,238,238,238,238,1,238,238,22,9,1,1,29,15,23,238,238,26,23,27,238,238,28,238,238,238,238,1,25,251,238,238,238,1,238,16,238,238,30,238,238,238,238,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,23,17,2,2,2,2,2,2,2,2,2,2,2,2,2,18,16,2,19,2,2,22,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,20,2,21,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,14,2,15,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,3,4,5,6,7,8,9,10,11,12,13,11,3,4,5,15,7,3,12,13,6,12,13,14,12,13,26,21,22,0,1,0,3,7,14,6,15,8,12,13,18,19,42,16,17,9,16,47,48,17,50,23,19,13,20,18,46,18,20,65,19,50,19,44,64,42,66,25,44,66,70,34,12,13,14,35,15,9,16,17,10,16,17,201,16,17,45,69,70,252,1,6,246,15,7,246,36,2,16,17,47,48,54,77,78,40,38,59,60,42,54,49,57,61,63,47,58,64,216,68,48,62,37,55,67,53,75,43,56,73,76,0,3,9,0,0,0,1,14,2,11,12,8,35,36,37,54,59,61,0,13,16,18,27,22,28,18,39,50,34,23,51,30,60,6,7,53,5,15,17,20,24,41,0,19,41,0,0,0,0,0,55,21,40,29,30,0,33,38,52,31,48,62,25,44,0,27,0,32,26,42,0,43,58,46,47,0,49,56,57,45,0,2,2,1,0,3,3,1,0,1,0,1,1,1,0,2,1,1,0,2,2,3,1,1,0,0,5,0,1,3,1,3,5,3,1,1,1,1,2,0,1,0,4,2,0,2,1,1,3,2,1,0,3,2,1,0,1,1,0,1,1,1,3,0,24,25,25,25,26,27,28,28,29,29,30,30,31,31,32,32,33,33,34,34,35,36,36,38,39,37,37,40,40,41,41,41,42,42,43,43,43,44,44,45,45,46,47,47,48,49,49,50,51,52,54,53,55,55,55,56,56,56,57,57,58,58,238,238,255,238,238,238,238,238,238,31,32,238,0,239,238,238,238,12,238,238,238,8,13,238,238,238,248,238,238,238,238,238,238,245,238,255,3,8,4,33,5,11,18,19,39,20,21,22,41,50,65,23,24,25,26,44,51,52,66,71,72,27,74,28,29,46,30,79,31,32,0,1,8,25,27,29,0,14,26,3,6,30,3,4,5,7,12,13,31,32,34,35,36,40,41,42,43,50,52,53,55,57,58,28,57,57,15,34,16,33,9,37,17,33,44,57,54,18,19,23,38,45,46,41,57,45,46,19,26,57,57,13,36,20,18,39,47,57,37,21,22,48,49,50,51,57,57,16,17,56,107,101,121,0,97,116,116,114,105,98,117,116,101,32,109,97,99,114,111,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,37,115,58,37,115,0,67,111,117,108,100,32,110,111,116,32,111,112,101,110,32,34,37,115,34,32,102,111,114,32,119,114,105,116,105,110,103,32,58,32,37,115,10,0,78,111,32,108,105,98,122,32,115,117,112,112,111,114,116,46,10,0,103,118,119,114,105,116,101,95,110,111,95,122,32,112,114,111,98,108,101,109,32,37,100,10,0,78,111,32,108,105,98,122,32,115,117,112,112,111,114,116,10,0,103,118,112,114,105,110,116,102,58,32,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,46,57,57,0,109,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,102,97,105,108,117,114,101,10,0,46,37,100,0,110,111,110,97,109,101,46,103,118,0,100,121,110,97,109,105,99,32,108,111,97,100,105,110,103,32,110,111,116,32,97,118,97,105,108,97,98,108,101,10,0,60,98,117,105,108,116,105,110,62,0,65,99,116,105,118,97,116,101,100,32,112,108,117,103,105,110,32,108,105,98,114,97,114,121,58,32,37,115,10,0,85,115,105,110,103,32,37,115,58,32,37,115,58,37,115,10,0,114,101,110,100,101,114,0,108,97,121,111,117,116,0,100,101,118,105,99,101,0,108,111,97,100,105,109,97,103,101,0,103,118,117,115,101,114,115,104,97,112,101,46,99,0,103,118,117,115,101,114,115,104,97,112,101,95,102,105,110,100,0,103,118,117,115,101,114,115,104,97,112,101,95,102,105,108,101,95,97,99,99,101,115,115,0,70,105,108,101,110,97,109,101,32,34,37,115,34,32,105,115,32,117,110,115,97,102,101,10,0,37,115,32,119,104,105,108,101,32,111,112,101,110,105,110,103,32,37,115,10,0,117,115,45,62,102,0,103,118,117,115,101,114,115,104,97,112,101,95,111,112,101,110,0,34,37,115,34,32,119,97,115,32,110,111,116,32,102,111,117,110,100,32,97,115,32,97,32,102,105,108,101,32,111,114,32,97,115,32,97,32,115,104,97,112,101,32,108,105,98,114,97,114,121,32,109,101,109,98,101,114,10,0,47,77,101,100,105,97,66,111,120,0,99,97,110,110,111,116,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,32,37,115,0,37,108,102,37,50,115,0,112,116,0,118,105,101,119,66,111,120,0,37,108,102,32,37,108,102,32,37,108,102,32,37,108,102,0,105,110,0,112,120,0,112,99,0,34,0,99,109,0,109,109,0,40,91,97,45,122,93,91,97,45,122,65,45,90,93,42,41,61,34,40,91,94,34,93,42,41,34,0,37,37,66,111,117,110,100,105,110,103,66,111,120,58,0,1,208,209,210,211,212,213,214,215,216,217,0,60,115,118,103,0,87,69,66,80,0,119,101,98,112,0,40,108,105,98,41,0,137,80,78,71,13,10,26,10,0,112,110,103,0,37,33,80,83,45,65,100,111,98,101,45,0,66,77,0,98,109,112,0,71,73,70,56,0,103,105,102,0,255,216,255,224,0,106,112,101,103,0,37,80,68,70,45,0,112,100,102,0,197,208,211,198,0,101,112,115,0,60,63,120,109,108,0,120,109,108,0,82,73,70,70,0,114,105,102,102,0,0,0,1,0,0,105,99,111,0,76,97,121,111,117,116,32,116,121,112,101,58,32,34,37,115,34,32,110,111,116,32,114,101,99,111,103,110,105,122,101,100,46,32,85,115,101,32,111,110,101,32,111,102,58,37,115,10,0,37,100,32,37,100,32,37,100,32,37,100,0,70,111,114,109,97,116,58,32,34,37,115,34,32,110,111,116,32,114,101,99,111,103,110,105,122,101,100,46,32,85,115,101,32,111,110,101,32,111,102,58,37,115,10,0,76,97,121,111,117,116,32,119,97,115,32,110,111,116,32,100,111,110,101,10,0,102,97,105,108,117,114,101,32,109,97,108,108,111,99,39,105,110,103,32,102,111,114,32,114,101,115,117,108,116,32,115,116,114,105,110,103,0,99,99,103,114,97,112,104,105,110,102,111,0,99,99,103,110,111,100,101,105,110,102,111,0,40,37,52,108,100,41,32,37,55,108,100,32,110,111,100,101,115,32,37,55,108,100,32,101,100,103,101,115,10,0,32,32,32,32,32,32,32,37,55,100,32,110,111,100,101,115,32,37,55,100,32,101,100,103,101,115,32,37,55,108,100,32,99,111,109,112,111,110,101,110,116,115,32,37,115,10,0,100,103,0,69,114,114,111,114,58,32,110,111,100,101,32,34,37,115,34,32,98,101,108,111,110,103,115,32,116,111,32,116,119,111,32,110,111,110,45,110,101,115,116,101,100,32,99,108,117,115,116,101,114,115,32,34,37,115,34,32,97,110,100,32,34,37,115,34,10,0,103,99,58,32,79,117,116,32,111,102,32,109,101,109,111,114,121,10,0,95,99,99,95,0,115,111,114,116,118,0,112,105,110,102,111,0,112,97,99,107,46,99,0,103,101,116,80,97,99,107,73,110,102,111,0,32,32,109,97,114,103,105,110,32,37,100,10,0,112,97,114,115,101,80,97,99,107,77,111,100,101,73,110,102,111,0,97,114,114,97,121,0,97,115,112,101,99,116,0,37,102,0,112,97,99,107,32,105,110,102,111,58,10,0,32,32,109,111,100,101,32,32,32,37,115,10,0,32,32,97,115,112,101,99,116,32,37,102,10,0,32,32,115,105,122,101,32,32,32,37,100,10,0,32,32,102,108,97,103,115,32,32,37,100,10,0,112,97,99,107,109,111,100,101,0,112,97,99,107,0,117,110,100,101,102,105,110,101,100,0,115,116,101,112,32,115,105,122,101,32,61,32,37,100,10,0,112,111,115,91,37,100,93,32,37,100,32,37,100,10,0,99,99,32,40,37,100,32,99,101,108,108,115,41,32,97,116,32,40,37,100,44,37,100,41,32,40,37,100,44,37,100,41,10,0,37,115,32,110,111,46,32,99,101,108,108,115,32,37,100,32,87,32,37,100,32,72,32,37,100,10,0,32,32,37,100,32,37,100,32,99,101,108,108,10,0,108,105,98,112,97,99,107,58,32,100,105,115,99,32,61,32,37,102,32,40,32,60,32,48,41,10,0,80,97,99,107,105,110,103,58,32,99,111,109,112,117,116,101,32,103,114,105,100,32,115,105,122,101,10,0,97,32,37,102,32,98,32,37,102,32,99,32,37,102,32,100,32,37,102,32,114,32,37,102,10,0,114,111,111,116,32,37,100,32,40,37,102,41,32,37,100,32,40,37,102,41,10,0,32,114,49,32,37,102,32,114,50,32,37,102,10,0,114,111,119,32,109,97,106,111,114,0,99,111,108,117,109,110,32,109,97,106,111,114,0,97,114,114,97,121,32,112,97,99,107,105,110,103,58,32,37,115,32,37,100,32,114,111,119,115,32,37,100,32,99,111,108,117,109,110,115,10,0,98,98,91,37,115,93,32,37,46,53,103,32,37,46,53,103,32,37,46,53,103,32,37,46,53,103,10,0,99,99,32,40,37,100,32,99,101,108,108,115,41,32,97,116,32,40,37,100,44,37,100,41,10,0,65,114,114,111,119,32,116,121,112,101,32,34,37,115,34,32,117,110,107,110,111,119,110,32,45,32,105,103,110,111,114,105,110,103,10,0,110,111,114,109,97,108,0,99,114,111,119,0,116,101,101,0,100,111,116,0,105,110,118,0,118,101,101,0,112,101,110,0,109,112,116,121,0,99,117,114,118,101,0,108,0,104,97,108,102,0,105,110,118,101,109,112,116,121,0,95,98,97,99,107,103,114,111,117,110,100,0,95,100,114,97,119,95,0,67,111,117,108,100,32,110,111,116,32,112,97,114,115,101,32,34,95,98,97,99,107,103,114,111,117,110,100,34,32,97,116,116,114,105,98,117,116,101,32,105,110,32,103,114,97,112,104,32,37,115,10,0,32,32,34,37,115,34,10,0,110,111,32,109,101,109,111,114,121,32,102,114,111,109,32,122,109,97,108,108,111,99,40,41,10,0,111,98,106,0,101,109,105,116,46,99,0,112,111,112,95,111,98,106,95,115,116,97,116,101,0,99,108,117,115,116,0,37,108,100,0,108,110,114,99,111,108,111,114,115,99,104,101,109,101,0,105,110,32,99,108,117,115,116,101,114,32,37,115,10,0,77,111,114,101,32,116,104,97,110,32,50,32,99,111,108,111,114,115,32,115,112,101,99,105,102,105,101,100,32,102,111,114,32,97,32,103,114,97,100,105,101,110,116,32,45,32,105,103,110,111,114,105,110,103,32,114,101,109,97,105,110,105,110,103,10,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,101,115,116,105,110,103,32,110,111,116,32,97,108,108,111,119,101,100,32,105,110,32,115,116,121,108,101,58,32,37,115,10,0,117,110,109,97,116,99,104,101,100,32,39,41,39,32,105,110,32,115,116,121,108,101,58,32,37,115,10,0,116,114,117,110,99,97,116,105,110,103,32,115,116,121,108,101,32,39,37,115,39,10,0,117,110,109,97,116,99,104,101,100,32,39,40,39,32,105,110,32,115,116,121,108,101,58,32,37,115,10,0,67,0,76,97,121,111,117,116,32,119,97,115,32,110,111,116,32,100,111,110,101,46,32,32,77,105,115,115,105,110,103,32,108,97,121,111,117,116,32,112,108,117,103,105,110,115,63,32,10,0,103,118,82,101,110,100,101,114,74,111,98,115,32,37,115,58,32,37,46,50,102,32,115,101,99,115,46,10,0,108,97,121,111,117,116,32,119,97,115,32,110,111,116,32,100,111,110,101,10,0,114,101,110,100,101,114,101,114,32,102,111,114,32,37,115,32,105,115,32,117,110,97,118,97,105,108,97,98,108,101,10,0,112,97,103,101,100,105,114,61,37,115,32,105,103,110,111,114,101,100,10,0,118,105,101,119,112,111,114,116,0,37,108,102,44,37,108,102,44,37,108,102,44,39,37,91,94,39,93,39,0,37,108,102,44,37,108,102,44,37,108,102,44,37,91,94,44,93,37,115,0,37,108,102,44,37,108,102,44,37,108,102,44,37,108,102,44,37,108,102,0,111,117,116,112,117,116,111,114,100,101,114,0,111,100,101,115,102,105,114,115,116,0,100,103,101,115,102,105,114,115,116,0,108,97,121,101,114,115,0,108,97,121,101,114,115,101,108,101,99,116,0,84,104,101,32,108,97,121,101,114,115,101,108,101,99,116,32,97,116,116,114,105,98,117,116,101,32,34,37,115,34,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,97,110,121,32,108,97,121,101,114,32,115,112,101,99,105,102,101,100,32,98,121,32,116,104,101,32,108,97,121,101,114,115,32,97,116,116,114,105,98,117,116,101,32,45,32,105,103,110,111,114,101,100,46,10,0,97,108,108,0,108,97,121,101,114,115,101,112,0,58,9,32,0,108,97,121,101,114,108,105,115,116,115,101,112,0,44,0,84,104,101,32,99,104,97,114,97,99,116,101,114,32,39,37,99,39,32,97,112,112,101,97,114,115,32,105,110,32,98,111,116,104,32,116,104,101,32,108,97,121,101,114,115,101,112,32,97,110,100,32,108,97,121,101,114,108,105,115,116,115,101,112,32,97,116,116,114,105,98,117,116,101,115,32,45,32,108,97,121,101,114,108,105,115,116,115,101,112,32,105,103,110,111,114,101,100,46,10,0,112,97,100,0,66,76,0,112,97,103,101,100,105,114,0,115,111,108,105,100,0,0,115,101,116,108,105,110,101,119,105,100,116,104,0,49,0,0,115,112,108,45,62,115,105,122,101,32,62,32,48,0,105,110,105,116,95,115,112,108,105,110,101,115,95,98,98,0,98,122,46,115,105,122,101,32,62,32,48,0,98,101,122,105,101,114,95,98,98,0,98,122,46,115,105,122,101,32,37,32,51,32,61,61,32,49,0,101,109,105,116,95,101,100,103,101,95,108,97,98,101,108,0,37,115,45,37,115,0,102,111,114,119,97,114,100,0,98,97,99,107,0,32,45,62,32,0,32,45,45,32,0,105,110,32,101,100,103,101,32,37,115,37,115,37,115,10,0,101,100,103,101,104,114,101,102,0,101,100,103,101,85,82,76,0,108,97,98,101,108,104,114,101,102,0,108,97,98,101,108,85,82,76,0,116,97,105,108,104,114,101,102,0,116,97,105,108,85,82,76,0,104,101,97,100,104,114,101,102,0,104,101,97,100,85,82,76,0,101,100,103,101,116,97,114,103,101,116,0,108,97,98,101,108,116,97,114,103,101,116,0,116,97,105,108,116,97,114,103,101,116,0,104,101,97,100,116,97,114,103,101,116,0,101,100,103,101,116,111,111,108,116,105,112,0,108,97,98,101,108,116,111,111,108,116,105,112,0,116,97,105,108,116,111,111,108,116,105,112,0,104,101,97,100,116,111,111,108,116,105,112,0,103,114,97,100,105,101,110,116,32,112,101,110,32,99,111,108,111,114,115,32,110,111,116,32,121,101,116,32,115,117,112,112,111,114,116,101,100,46,10,0,73,109,97,103,101,115,32,117,110,115,117,112,112,111,114,116,101,100,32,105,110,32,34,98,97,99,107,103,114,111,117,110,100,34,32,97,116,116,114,105,98,117,116,101,10,0,108,97,121,101,114,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,37,115,32,111,117,116,112,117,116,10,0,84,111,116,97,108,32,115,105,122,101,32,62,32,49,32,105,110,32,34,37,115,34,32,99,111,108,111,114,32,115,112,101,99,32,0,73,108,108,101,103,97,108,32,108,101,110,103,116,104,32,118,97,108,117,101,32,105,110,32,34,37,115,34,32,99,111,108,111,114,32,97,116,116,114,105,98,117,116,101,32,0,112,97,103,101,37,100,44,37,100,95,0,0,0,0,37,108,102,0,102,111,110,116,112,97,116,104,0,68,79,84,70,79,78,84,80,65,84,72,0,71,68,70,79,78,84,80,65,84,72,0,105,109,97,103,101,112,97,116,104,0,113,117,97,110,116,117,109,0,114,97,110,107,100,105,114,0,76,82,0,66,84,0,82,76,0,110,111,100,101,115,101,112,0,114,97,110,107,115,101,112,0,101,113,117,97,108,108,121,0,115,104,111,119,98,111,120,101,115,0,102,111,110,116,110,97,109,101,115,0,115,105,122,101,0,112,97,103,101,0,99,101,110,116,101,114,0,114,111,116,97,116,101,0,111,114,105,101,110,116,97,116,105,111,110,0,108,97,110,100,115,99,97,112,101,0,99,108,117,115,116,101,114,114,97,110,107,0,99,111,110,99,101,110,116,114,97,116,101,0,100,112,105,0,114,101,115,111,108,117,116,105,111,110,0,111,114,100,101,114,105,110,103,0,102,105,108,108,99,111,108,111,114,0,102,111,110,116,115,105,122,101,0,102,111,110,116,110,97,109,101,0,102,111,110,116,99,111,108,111,114,0,120,108,97,98,101,108,0,112,101,110,119,105,100,116,104,0,112,101,114,105,112,104,101,114,105,101,115,0,115,107,101,119,0,100,105,115,116,111,114,116,105,111,110,0,110,111,106,117,115,116,105,102,121,0,108,97,121,101,114,0,103,114,111,117,112,0,99,111,109,109,101,110,116,0,118,101,114,116,105,99,101,115,0,122,0,119,101,105,103,104,116,0,108,97,98,101,108,102,108,111,97,116,0,100,105,114,0,97,114,114,111,119,104,101,97,100,0,97,114,114,111,119,116,97,105,108,0,104,101,97,100,108,97,98,101,108,0,116,97,105,108,108,97,98,101,108,0,108,97,98,101,108,102,111,110,116,115,105,122,101,0,108,97,98,101,108,102,111,110,116,110,97,109,101,0,108,97,98,101,108,102,111,110,116,99,111,108,111,114,0,108,97,98,101,108,100,105,115,116,97,110,99,101,0,108,97,98,101,108,97,110,103,108,101,0,109,105,110,108,101,110,0,100,101,99,111,114,97,116,101,0,97,114,114,111,119,115,105,122,101,0,99,111,110,115,116,114,97,105,110,116,0,116,97,105,108,99,108,105,112,0,104,101,97,100,99,108,105,112,0,108,97,98,101,108,106,117,115,116,0,85,84,70,45,56,0,73,83,79,45,56,56,53,57,45,49,0,66,73,71,45,53,0,85,110,115,117,112,112,111,114,116,101,100,32,99,104,97,114,115,101,116,32,118,97,108,117,101,32,37,100,10,0,108,111,99,97,108,0,103,108,111,98,97,108,0,37,108,102,44,37,108,102,37,99,0,37,108,102,37,99,0,114,97,116,105,111,0,97,117,116,111,0,99,111,109,112,114,101,115,115,0,101,120,112,97,110,100,0,102,105,108,108,0,103,100,0,112,115,0,115,118,103,0,99,104,97,114,115,101,116,0,117,116,102,45,56,0,108,97,116,105,110,45,49,0,108,97,116,105,110,49,0,108,49,0,73,83,79,95,56,56,53,57,45,49,0,73,83,79,56,56,53,57,45,49,0,73,83,79,45,73,82,45,49,48,48,0,98,105,103,45,53,0,98,105,103,53,0,117,116,102,56,0,85,110,115,117,112,112,111,114,116,101,100,32,99,104,97,114,115,101,116,32,34,37,115,34,32,45,32,97,115,115,117,109,105,110,103,32,117,116,102,45,56,10,0,105,110,32,108,97,98,101,108,32,111,102,32,103,114,97,112,104,32,37,115,10,0,105,110,32,108,97,98,101,108,32,111,102,32,110,111,100,101,32,37,115,10,0,105,110,32,108,97,98,101,108,32,111,102,32,101,100,103,101,32,37,115,32,37,115,32,37,115,10,0,107,105,110,100,32,61,61,32,76,84,95,78,79,78,69,0,108,97,98,101,108,115,46,99,0,109,97,107,101,95,108,97,98,101,108,0,38,97,109,112,59,0,38,108,116,59,0,38,103,116,59,0,38,35,52,53,59,0,38,35,49,54,48,59,0,38,113,117,111,116,59,0,38,35,51,57,59,0,92,71,0,92,69,0,92,72,0,92,84,0,92,76,0,110,101,116,119,111,114,107,32,115,105,109,112,108,101,120,58,32,0,37,115,32,37,100,32,110,111,100,101,115,32,37,100,32,101,100,103,101,115,32,109,97,120,105,116,101,114,61,37,100,32,98,97,108,97,110,99,101,61,37,100,10,0,37,100,32,0,37,115,37,100,32,110,111,100,101,115,32,37,100,32,101,100,103,101,115,32,37,100,32,105,116,101,114,32,37,46,50,102,32,115,101,99,10,0,115,101,97,114,99,104,115,105,122,101,0,117,112,100,97,116,101,58,32,109,105,115,109,97,116,99,104,101,100,32,108,99,97,32,105,110,32,116,114,101,101,117,112,100,97,116,101,115,10,0,97,100,100,95,116,114,101,101,95,101,100,103,101,58,32,109,105,115,115,105,110,103,32,116,114,101,101,32,101,100,103,101,10,0,97,100,100,95,116,114,101,101,95,101,100,103,101,58,32,101,109,112,116,121,32,111,117,116,101,100,103,101,32,108,105,115,116,10,0,97,100,100,95,116,114,101,101,95,101,100,103,101,58,32,101,109,112,116,121,32,105,110,101,100,103,101,32,108,105,115,116,10,0,116,114,111,117,98,108,101,32,105,110,32,105,110,105,116,95,114,97,110,107,10,0,9,37,115,32,37,100,10,0,103,114,97,112,104,32,0,32,0,110,111,100,101,32,0,115,116,111,112,10,0,112,111,115,0,114,101,99,116,115,0,120,108,112,0,108,112,0,104,101,97,100,95,108,112,0,116,97,105,108,95,108,112,0,108,119,105,100,116,104,0,108,104,101,105,103,104,116,0,98,98,0,37,46,53,103,44,37,46,53,103,44,37,46,53,103,0,44,37,46,53,103,0,37,46,53,103,44,37,46,53,103,0,37,46,53,103,0,115,97,109,112,108,101,112,111,105,110,116,115,0,37,46,53,103,32,37,46,53,103,0,115,44,37,46,53,103,44,37,46,53,103,32,0,101,44,37,46,53,103,44,37,46,53,103,32,0,37,46,53,103,44,37,46,53,103,44,37,46,53,103,44,37,46,53,103,0,37,46,50,102,0,37,46,53,103,44,37,46,53,103,44,37,46,53,103,44,37,46,53,103,32,0,0,0,0,47,112,97,116,104,98,111,120,32,123,10,32,32,32,32,47,88,32,101,120,99,104,32,110,101,103,32,37,46,53,103,32,115,117,98,32,100,101,102,10,32,32,32,32,47,89,32,101,120,99,104,32,37,46,53,103,32,115,117,98,32,100,101,102,10,32,32,32,32,47,120,32,101,120,99,104,32,110,101,103,32,37,46,53,103,32,115,117,98,32,100,101,102,10,32,32,32,32,47,121,32,101,120,99,104,32,37,46,53,103,32,115,117,98,32,100,101,102,10,32,32,32,32,110,101,119,112,97,116,104,32,120,32,121,32,109,111,118,101,116,111,10,32,32,32,32,88,32,121,32,108,105,110,101,116,111,10,32,32,32,32,88,32,89,32,108,105,110,101,116,111,10,32,32,32,32,120,32,89,32,108,105,110,101,116,111,10,32,32,32,32,99,108,111,115,101,112,97,116,104,32,115,116,114,111,107,101,10,125,32,100,101,102,10,0,47,112,97,116,104,98,111,120,32,123,10,32,32,32,32,47,89,32,101,120,99,104,32,37,46,53,103,32,115,117,98,32,100,101,102,10,32,32,32,32,47,88,32,101,120,99,104,32,37,46,53,103,32,115,117,98,32,100,101,102,10,32,32,32,32,47,121,32,101,120,99,104,32,37,46,53,103,32,115,117,98,32,100,101,102,10,32,32,32,32,47,120,32,101,120,99,104,32,37,46,53,103,32,115,117,98,32,100,101,102,10,32,32,32,32,110,101,119,112,97,116,104,32,120,32,121,32,109,111,118,101,116,111,10,32,32,32,32,88,32,121,32,108,105,110,101,116,111,10,32,32,32,32,88,32,89,32,108,105,110,101,116,111,10,32,32,32,32,120,32,89,32,108,105,110,101,116,111,10,32,32,32,32,99,108,111,115,101,112,97,116,104,32,115,116,114,111,107,101,10,32,125,32,100,101,102,10,47,100,98,103,115,116,97,114,116,32,123,32,103,115,97,118,101,32,37,46,53,103,32,37,46,53,103,32,116,114,97,110,115,108,97,116,101,32,125,32,100,101,102,10,47,97,114,114,111,119,108,101,110,103,116,104,32,49,48,32,100,101,102,10,47,97,114,114,111,119,119,105,100,116,104,32,97,114,114,111,119,108,101,110,103,116,104,32,50,32,100,105,118,32,100,101,102,10,47,97,114,114,111,119,104,101,97,100,32,123,10,32,32,32,32,103,115,97,118,101,10,32,32,32,32,114,111,116,97,116,101,10,32,32,32,32,99,117,114,114,101,110,116,112,111,105,110,116,10,32,32,32,32,110,101,119,112,97,116,104,10,32,32,32,32,109,111,118,101,116,111,10,32,32,32,32,97,114,114,111,119,108,101,110,103,116,104,32,97,114,114,111,119,119,105,100,116,104,32,50,32,100,105,118,32,114,108,105,110,101,116,111,10,32,32,32,32,48,32,97,114,114,111,119,119,105,100,116,104,32,110,101,103,32,114,108,105,110,101,116,111,10,32,32,32,32,99,108,111,115,101,112,97,116,104,32,102,105,108,108,10,32,32,32,32,103,114,101,115,116,111,114,101,10,125,32,98,105,110,100,32,100,101,102,10,47,109,97,107,101,97,114,114,111,119,32,123,10,32,32,32,32,99,117,114,114,101,110,116,112,111,105,110,116,32,101,120,99,104,32,112,111,112,32,115,117,98,32,101,120,99,104,32,99,117,114,114,101,110,116,112,111,105,110,116,32,112,111,112,32,115,117,98,32,97,116,97,110,10,32,32,32,32,97,114,114,111,119,104,101,97,100,10,125,32,98,105,110,100,32,100,101,102,10,47,112,111,105,110,116,32,123,32,32,32,32,110,101,119,112,97,116,104,32,32,32,32,50,32,48,32,51,54,48,32,97,114,99,32,102,105,108,108,125,32,100,101,102,47,109,97,107,101,118,101,99,32,123,10,32,32,32,32,47,89,32,101,120,99,104,32,100,101,102,10,32,32,32,32,47,88,32,101,120,99,104,32,100,101,102,10,32,32,32,32,47,121,32,101,120,99,104,32,100,101,102,10,32,32,32,32,47,120,32,101,120,99,104,32,100,101,102,10,32,32,32,32,110,101,119,112,97,116,104,32,120,32,121,32,109,111,118,101,116,111,10,32,32,32,32,88,32,89,32,108,105,110,101,116,111,32,115,116,114,111,107,101,10,32,32,32,32,88,32,89,32,109,111,118,101,116,111,10,32,32,32,32,120,32,121,32,109,97,107,101,97,114,114,111,119,10,125,32,100,101,102,10,0,108,111,115,116,32,37,115,32,37,115,32,101,100,103,101,10,0,110,111,32,112,111,115,105,116,105,111,110,32,102,111,114,32,101,100,103,101,32,119,105,116,104,32,108,97,98,101,108,32,37,115,0,110,111,32,112,111,115,105,116,105,111,110,32,102,111,114,32,101,100,103,101,32,119,105,116,104,32,116,97,105,108,32,108,97,98,101,108,32,37,115,0,110,111,32,112,111,115,105,116,105,111,110,32,102,111,114,32,101,100,103,101,32,119,105,116,104,32,104,101,97,100,32,108,97,98,101,108,32,37,115,0,110,111,32,112,111,115,105,116,105,111,110,32,102,111,114,32,101,100,103,101,32,119,105,116,104,32,120,108,97,98,101,108,32,37,115,0,102,111,114,99,101,108,97,98,101,108,115,0,37,100,32,111,117,116,32,111,102,32,37,100,32,108,97,98,101,108,115,32,112,111,115,105,116,105,111,110,101,100,46,10,0,37,100,32,111,117,116,32,111,102,32,37,100,32,101,120,116,101,114,105,111,114,32,108,97,98,101,108,115,32,112,111,115,105,116,105,111,110,101,100,46,10,0,37,100,32,111,98,106,115,32,37,100,32,120,108,97,98,101,108,115,32,102,111,114,99,101,61,37,100,32,98,98,61,40,37,46,48,50,102,44,37,46,48,50,102,41,32,40,37,46,48,50,102,44,37,46,48,50,102,41,10,0,111,98,106,101,99,116,115,10,0,32,91,37,100,93,32,40,37,46,48,50,102,44,37,46,48,50,102,41,32,40,37,46,48,50,102,44,37,46,48,50,102,41,32,37,112,32,34,37,115,34,10,0,120,108,97,98,101,108,115,10,0,32,91,37,100,93,32,37,112,32,115,101,116,32,37,100,32,40,37,46,48,50,102,44,37,46,48,50,102,41,32,40,37,46,48,50,102,44,37,46,48,50,102,41,32,37,115,10,0,115,104,97,112,101,102,105,108,101,32,110,111,116,32,115,101,116,32,111,114,32,110,111,116,32,102,111,117,110,100,32,102,111,114,32,101,112,115,102,32,110,111,100,101,32,37,115,10,0,99,97,110,39,116,32,102,105,110,100,32,108,105,98,114,97,114,121,32,102,105,108,101,32,37,115,10,0,99,97,110,39,116,32,111,112,101,110,32,108,105,98,114,97,114,121,32,102,105,108,101,32,37,115,10,0,69,79,70,0,66,69,71,73,78,0,69,78,68,0,84,82,65,73,76,69,82,0,47,117,115,101,114,95,115,104,97,112,101,95,37,100,32,123,10,0,37,37,66,101,103,105,110,68,111,99,117,109,101,110,116,58,10,0,37,37,69,110,100,68,111,99,117,109,101,110,116,10,0,125,32,98,105,110,100,32,100,101,102,10,0,85,84,70,45,56,32,105,110,112,117,116,32,117,115,101,115,32,110,111,110,45,76,97,116,105,110,49,32,99,104,97,114,97,99,116,101,114,115,32,119,104,105,99,104,32,99,97,110,110,111,116,32,98,101,32,104,97,110,100,108,101,100,32,98,121,32,116,104,105,115,32,80,111,115,116,83,99,114,105,112,116,32,100,114,105,118,101,114,10,0,99,111,117,108,100,110,39,116,32,111,112,101,110,32,101,112,115,102,32,102,105,108,101,32,37,115,10,0,37,37,37,37,66,111,117,110,100,105,110,103,66,111,120,58,32,37,100,32,37,100,32,37,100,32,37,100,0,114,101,97,100,0,66,111,117,110,100,105,110,103,66,111,120,32,110,111,116,32,102,111,117,110,100,32,105,110,32,101,112,115,102,32,102,105,108,101,32,37,115,10,0,114,111,117,116,101,115,112,108,105,110,101,115,105,110,105,116,58,32,99,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,112,115,10,0,114,111,117,116,101,115,112,108,105,110,101,115,58,32,37,100,32,101,100,103,101,115,44,32,37,100,32,98,111,120,101,115,32,37,46,50,102,32,115,101,99,10,0,105,110,32,114,111,117,116,101,115,112,108,105,110,101,115,44,32,99,97,110,110,111,116,32,102,105,110,100,32,78,79,82,77,65,76,32,101,100,103,101,10,0,105,110,32,114,111,117,116,101,115,112,108,105,110,101,115,44,32,105,108,108,101,103,97,108,32,118,97,108,117,101,115,32,111,102,32,112,114,101,118,32,37,100,32,97,110,100,32,110,101,120,116,32,37,100,44,32,108,105,110,101,32,37,100,10,0,105,110,32,114,111,117,116,101,115,112,108,105,110,101,115,44,32,101,100,103,101,32,105,115,32,97,32,108,111,111,112,32,97,116,32,37,115,10,0,105,110,32,114,111,117,116,101,115,112,108,105,110,101,115,44,32,80,115,104,111,114,116,101,115,116,112,97,116,104,32,102,97,105,108,101,100,10,0,105,110,32,114,111,117,116,101,115,112,108,105,110,101,115,44,32,80,114,111,117,116,101,115,112,108,105,110,101,32,102,97,105,108,101,100,10,0,85,110,97,98,108,101,32,116,111,32,114,101,99,108,97,105,109,32,98,111,120,32,115,112,97,99,101,32,105,110,32,115,112,108,105,110,101,32,114,111,117,116,105,110,103,32,102,111,114,32,101,100,103,101,32,34,37,115,34,32,45,62,32,34,37,115,34,46,32,83,111,109,101,116,104,105,110,103,32,105,115,32,112,114,111,98,97,98,108,121,32,115,101,114,105,111,117,115,108,121,32,119,114,111,110,103,46,10,0,105,110,32,99,104,101,99,107,112,97,116,104,44,32,98,111,120,32,48,32,104,97,115,32,76,76,32,99,111,111,114,100,32,62,32,85,82,32,99,111,111,114,100,10,0,105,110,32,99,104,101,99,107,112,97,116,104,44,32,98,111,120,32,37,100,32,104,97,115,32,76,76,32,99,111,111,114,100,32,62,32,85,82,32,99,111,111,114,100,10,0,105,110,32,99,104,101,99,107,112,97,116,104,44,32,98,111,120,101,115,32,37,100,32,97,110,100,32,37,100,32,100,111,110,39,116,32,116,111,117,99,104,10,0,105,110,32,99,104,101,99,107,112,97,116,104,44,32,115,116,97,114,116,32,112,111,114,116,32,110,111,116,32,105,110,32,102,105,114,115,116,32,98,111,120,10,0,105,110,32,99,104,101,99,107,112,97,116,104,44,32,101,110,100,32,112,111,114,116,32,110,111,116,32,105,110,32,108,97,115,116,32,98,111,120,10,0,37,100,32,98,111,120,101,115,58,10,0,37,100,32,40,37,46,53,103,44,32,37,46,53,103,41,44,32,40,37,46,53,103,44,32,37,46,53,103,41,10,0,99,111,110,115,116,114,97,105,110,101,100,0,110,111,116,32,99,111,110,115,116,114,97,105,110,101,100,0,115,116,97,114],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+132702);allocate([116,32,112,111,114,116,58,32,40,37,46,53,103,44,32,37,46,53,103,41,44,32,116,97,110,103,101,110,116,32,97,110,103,108,101,58,32,37,46,53,103,44,32,37,115,10,0,101,110,100,32,112,111,114,116,58,32,40,37,46,53,103,44,32,37,46,53,103,41,44,32,116,97,110,103,101,110,116,32,97,110,103,108,101,58,32,37,46,53,103,44,32,37,115,10,0,99,97,110,110,111,116,32,114,101,45,97,108,108,111,99,97,116,101,32,112,115,10,0,115,105,100,101,115,32,61,61,32,52,0,115,104,97,112,101,115,46,99,0,114,111,117,110,100,95,99,111,114,110,101,114,115,0,115,104,97,112,101,102,105,108,101,0,101,112,115,102,0,99,117,115,116,111,109,0,115,0,101,0,119,0,117,115,105,110,103,32,37,115,32,102,111,114,32,117,110,107,110,111,119,110,32,115,104,97,112,101,32,37,115,10,0,112,111,108,121,103,111,110,0,111,118,97,108,0,99,105,114,99,108,101,0,112,111,105,110,116,0,101,103,103,0,116,114,105,97,110,103,108,101,0,112,108,97,105,110,116,101,120,116,0,100,105,97,109,111,110,100,0,116,114,97,112,101,122,105,117,109,0,112,97,114,97,108,108,101,108,111,103,114,97,109,0,104,111,117,115,101,0,112,101,110,116,97,103,111,110,0,104,101,120,97,103,111,110,0,115,101,112,116,97,103,111,110,0,111,99,116,97,103,111,110,0,110,111,116,101,0,116,97,98,0,102,111,108,100,101,114,0,98,111,120,51,100,0,99,111,109,112,111,110,101,110,116,0,114,101,99,116,0,114,101,99,116,97,110,103,108,101,0,115,113,117,97,114,101,0,100,111,117,98,108,101,99,105,114,99,108,101,0,100,111,117,98,108,101,111,99,116,97,103,111,110,0,116,114,105,112,108,101,111,99,116,97,103,111,110,0,105,110,118,116,114,105,97,110,103,108,101,0,105,110,118,116,114,97,112,101,122,105,117,109,0,105,110,118,104,111,117,115,101,0,117,110,100,101,114,108,105,110,101,0,77,100,105,97,109,111,110,100,0,77,115,113,117,97,114,101,0,77,99,105,114,99,108,101,0,112,114,111,109,111,116,101,114,0,99,100,115,0,116,101,114,109,105,110,97,116,111,114,0,117,116,114,0,105,110,115,117,108,97,116,111,114,0,114,105,98,111,115,105,116,101,0,114,110,97,115,116,97,98,0,112,114,111,116,101,97,115,101,115,105,116,101,0,112,114,111,116,101,105,110,115,116,97,98,0,112,114,105,109,101,114,115,105,116,101,0,114,101,115,116,114,105,99,116,105,111,110,115,105,116,101,0,102,105,118,101,112,111,118,101,114,104,97,110,103,0,116,104,114,101,101,112,111,118,101,114,104,97,110,103,0,110,111,118,101,114,104,97,110,103,0,97,115,115,101,109,98,108,121,0,115,105,103,110,97,116,117,114,101,0,114,112,114,111,109,111,116,101,114,0,108,97,114,114,111,119,0,114,97,114,114,111,119,0,108,112,114,111,109,111,116,101,114,0,114,101,99,111,114,100,0,77,114,101,99,111,114,100,0,115,116,97,114,0,35,56,48,56,48,56,48,0,35,102,99,102,99,102,99,0,35,51,48,51,48,51,48,0,35,101,56,101,56,101,56,0,35,101,48,101,48,101,48,0,35,102,48,102,48,102,48,0,35,49,48,49,48,49,48,0,35,102,56,102,56,102,56,0,105,110,32,110,111,100,101,32,37,115,10,0,114,111,117,110,100,101,100,0,100,105,97,103,111,110,97,108,115,0,114,97,100,105,97,108,0,115,116,114,105,112,101,100,0,119,101,100,103,101,100,0,95,0,110,111,100,101,32,37,115,44,32,112,111,114,116,32,37,115,44,32,117,110,114,101,99,111,103,110,105,122,101,100,32,99,111,109,112,97,115,115,32,112,111,105,110,116,32,39,37,115,39,32,45,32,105,103,110,111,114,101,100,10,0,110,111,100,101,32,37,115,44,32,112,111,114,116,32,37,115,32,117,110,114,101,99,111,103,110,105,122,101,100,10,0,37,46,53,103,32,37,46,53,103,32,116,114,97,110,115,108,97,116,101,32,110,101,119,112,97,116,104,32,117,115,101,114,95,115,104,97,112,101,95,37,100,10,0,105,110,118,105,115,0,0,102,105,108,108,101,100,0,0,98,97,100,32,108,97,98,101,108,32,102,111,114,109,97,116,32,37,115,10,0,92,78,0,109,97,114,103,105,110,0,37,108,102,44,37,108,102,0,114,101,103,117,108,97,114,0,60,110,105,108,62,0,78,111,32,111,114,32,105,109,112,114,111,112,101,114,32,115,104,97,112,101,102,105,108,101,61,34,37,115,34,32,102,111,114,32,110,111,100,101,32,34,37,115,34,10,0,78,111,32,111,114,32,105,109,112,114,111,112,101,114,32,105,109,97,103,101,61,34,37,115,34,32,102,111,114,32,110,111,100,101,32,34,37,115,34,10,0,108,97,98,101,108,108,111,99,0,110,111,100,101,32,39,37,115,39,44,32,103,114,97,112,104,32,39,37,115,39,32,115,105,122,101,32,116,111,111,32,115,109,97,108,108,32,102,111,114,32,108,97,98,101,108,10,0,115,112,108,105,110,101,115,46,99,0,98,101,103,105,110,112,97,116,104,0,80,45,62,101,110,100,46,116,104,101,116,97,32,60,32,50,32,42,32,77,95,80,73,0,101,110,100,112,97,116,104,0,109,97,107,101,83,101,108,102,69,100,103,101,0,103,101,116,115,112,108,105,110,101,112,111,105,110,116,115,58,32,110,111,32,115,112,108,105,110,101,32,112,111,105,110,116,115,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,101,100,103,101,32,40,37,115,44,37,115,41,10,0,112,111,108,121,108,105,110,101,77,105,100,112,111,105,110,116,0,115,112,97,110,45,62,102,111,110,116,0,116,101,120,116,115,112,97,110,46,99,0,116,101,120,116,115,112,97,110,95,115,105,122,101,0,102,111,110,116,45,62,110,97,109,101,0,102,111,110,116,110,97,109,101,58,32,34,37,115,34,32,114,101,115,111,108,118,101,100,32,116,111,58,32,37,115,10,0,102,111,110,116,110,97,109,101,58,32,117,110,97,98,108,101,32,116,111,32,114,101,115,111,108,118,101,32,34,37,115,34,10,0,99,111,117,114,0,91,105,110,116,101,114,110,97,108,32,99,111,117,114,105,101,114,93,0,97,114,105,97,108,0,104,101,108,118,101,116,105,99,97,0,91,105,110,116,101,114,110,97,108,32,97,114,105,97,108,93,0,91,105,110,116,101,114,110,97,108,32,116,105,109,101,115,93,0,65,118,97,110,116,71,97,114,100,101,45,66,111,111,107,0,85,82,87,32,71,111,116,104,105,99,32,76,0,98,111,111,107,0,115,97,110,115,45,83,101,114,105,102,0,65,118,97,110,116,71,97,114,100,101,45,66,111,111,107,79,98,108,105,113,117,101,0,111,98,108,105,113,117,101,0,105,116,97,108,105,99,0,65,118,97,110,116,71,97,114,100,101,45,68,101,109,105,0,100,101,109,105,0,65,118,97,110,116,71,97,114,100,101,45,68,101,109,105,79,98,108,105,113,117,101,0,66,111,111,107,109,97,110,45,68,101,109,105,0,85,82,87,32,66,111,111,107,109,97,110,32,76,0,115,101,114,105,102,0,66,111,111,107,109,97,110,45,68,101,109,105,73,116,97,108,105,99,0,66,111,111,107,109,97,110,45,76,105,103,104,116,0,108,105,103,104,116,0,66,111,111,107,109,97,110,45,76,105,103,104,116,73,116,97,108,105,99,0,67,111,117,114,105,101,114,0,109,111,110,111,115,112,97,99,101,0,67,111,117,114,105,101,114,45,66,111,108,100,0,67,111,117,114,105,101,114,45,66,111,108,100,79,98,108,105,113,117,101,0,67,111,117,114,105,101,114,45,79,98,108,105,113,117,101,0,72,101,108,118,101,116,105,99,97,0,72,101,108,118,101,116,105,99,97,45,66,111,108,100,0,72,101,108,118,101,116,105,99,97,45,66,111,108,100,79,98,108,105,113,117,101,0,72,101,108,118,101,116,105,99,97,45,78,97,114,114,111,119,0,99,111,110,100,101,110,115,101,100,0,72,101,108,118,101,116,105,99,97,45,78,97,114,114,111,119,45,66,111,108,100,0,72,101,108,118,101,116,105,99,97,45,78,97,114,114,111,119,45,66,111,108,100,79,98,108,105,113,117,101,0,72,101,108,118,101,116,105,99,97,45,78,97,114,114,111,119,45,79,98,108,105,113,117,101,0,72,101,108,118,101,116,105,99,97,45,79,98,108,105,113,117,101,0,78,101,119,67,101,110,116,117,114,121,83,99,104,108,98,107,45,66,111,108,100,0,67,101,110,116,117,114,121,32,83,99,104,111,111,108,98,111,111,107,32,76,0,78,101,119,67,101,110,116,117,114,121,83,99,104,108,98,107,45,66,111,108,100,73,116,97,108,105,99,0,78,101,119,67,101,110,116,117,114,121,83,99,104,108,98,107,45,73,116,97,108,105,99,0,78,101,119,67,101,110,116,117,114,121,83,99,104,108,98,107,45,82,111,109,97,110,0,114,111,109,97,110,0,80,97,108,97,116,105,110,111,45,66,111,108,100,0,80,97,108,97,116,105,110,111,32,76,105,110,111,116,121,112,101,0,80,97,108,97,116,105,110,111,45,66,111,108,100,73,116,97,108,105,99,0,80,97,108,97,116,105,110,111,45,73,116,97,108,105,99,0,80,97,108,97,116,105,110,111,45,82,111,109,97,110,0,83,121,109,98,111,108,0,102,97,110,116,97,115,121,0,84,105,109,101,115,45,66,111,108,100,0,84,105,109,101,115,0,84,105,109,101,115,45,66,111,108,100,73,116,97,108,105,99,0,84,105,109,101,115,45,73,116,97,108,105,99,0,90,97,112,102,67,104,97,110,99,101,114,121,45,77,101,100,105,117,109,73,116,97,108,105,99,0,85,82,87,32,67,104,97,110,99,101,114,121,32,76,0,109,101,100,105,117,109,0,90,97,112,102,68,105,110,103,98,97,116,115,0,68,105,110,103,98,97,116,115,0,105,110,112,117,116,115,99,97,108,101,0,117,116,105,108,115,46,99,0,117,32,61,61,32,85,70,95,102,105,110,100,40,117,41,0,85,70,95,115,101,116,110,97,109,101,0,1,102,105,108,101,32,108,111,97,100,105,110,103,32,105,115,32,100,105,115,97,98,108,101,100,32,98,101,99,97,117,115,101,32,116,104,101,32,101,110,118,105,114,111,110,109,101,110,116,32,99,111,110,116,97,105,110,115,32,83,69,82,86,69,82,95,78,65,77,69,61,34,37,115,34,10,97,110,100,32,116,104,101,32,71,86,95,70,73,76,69,95,80,65,84,72,32,118,97,114,105,97,98,108,101,32,105,115,32,117,110,115,101,116,32,111,114,32,101,109,112,116,121,46,10,0,80,97,116,104,32,112,114,111,118,105,100,101,100,32,116,111,32,102,105,108,101,58,32,34,37,115,34,32,104,97,115,32,98,101,101,110,32,105,103,110,111,114,101,100,32,98,101,99,97,117,115,101,32,102,105,108,101,115,32,97,114,101,32,111,110,108,121,32,112,101,114,109,105,116,116,101,100,32,116,111,32,98,101,32,108,111,97,100,101,100,32,102,114,111,109,32,116,104,101,32,100,105,114,101,99,116,111,114,105,101,115,32,105,110,32,34,37,115,34,32,119,104,101,110,32,114,117,110,110,105,110,103,32,105,110,32,97,110,32,104,116,116,112,32,115,101,114,118,101,114,46,10,0,47,0,110,111,0,116,114,117,101,0,121,101,115,0,101,108,108,105,112,115,101,0,84,105,109,101,115,45,82,111,109,97,110,0,99,108,117,115,116,101,114,0,95,95,99,108,117,115,116,101,114,110,111,100,101,115,0,0,85,84,70,56,32,99,111,100,101,115,32,62,32,52,32,98,121,116,101,115,32,97,114,101,32,110,111,116,32,99,117,114,114,101,110,116,108,121,32,115,117,112,112,111,114,116,101,100,32,40,103,114,97,112,104,32,37,115,41,32,45,32,116,114,101,97,116,101,100,32,97,115,32,76,97,116,105,110,45,49,46,32,80,101,114,104,97,112,115,32,34,45,71,99,104,97,114,115,101,116,61,108,97,116,105,110,49,34,32,105,115,32,110,101,101,100,101,100,63,10,0,73,110,118,97,108,105,100,32,37,100,45,98,121,116,101,32,85,84,70,56,32,102,111,117,110,100,32,105,110,32,105,110,112,117,116,32,111,102,32,103,114,97,112,104,32,37,115,32,45,32,116,114,101,97,116,101,100,32,97,115,32,76,97,116,105,110,45,49,46,32,80,101,114,104,97,112,115,32,34,45,71,99,104,97,114,115,101,116,61,108,97,116,105,110,49,34,32,105,115,32,110,101,101,100,101,100,63,10,0,117,114,118,101,100,0,111,109,112,111,117,110,100,0,97,108,115,101,0,105,110,101,0,111,110,101,0,111,0,114,116,104,111,0,111,108,121,108,105,110,101,0,112,108,105,110,101,0,114,117,101,0,101,115,0,85,110,107,110,111,119,110,32,34,115,112,108,105,110,101,115,34,32,118,97,108,117,101,58,32,34,37,115,34,32,45,32,105,103,110,111,114,101,100,10,0,115,112,108,105,110,101,115,0,98,122,46,115,105,122,101,0,111,118,101,114,108,97,112,95,98,101,122,105,101,114,0,65,69,108,105,103,0,65,97,99,117,116,101,0,65,99,105,114,99,0,65,103,114,97,118,101,0,65,108,112,104,97,0,65,114,105,110,103,0,65,116,105,108,100,101,0,65,117,109,108,0,66,101,116,97,0,67,99,101,100,105,108,0,67,104,105,0,68,97,103,103,101,114,0,68,101,108,116,97,0,69,84,72,0,69,97,99,117,116,101,0,69,99,105,114,99,0,69,103,114,97,118,101,0,69,112,115,105,108,111,110,0,69,116,97,0,69,117,109,108,0,71,97,109,109,97,0,73,97,99,117,116,101,0,73,99,105,114,99,0,73,103,114,97,118,101,0,73,111,116,97,0,73,117,109,108,0,75,97,112,112,97,0,76,97,109,98,100,97,0,77,117,0,78,116,105,108,100,101,0,78,117,0,79,69,108,105,103,0,79,97,99,117,116,101,0,79,99,105,114,99,0,79,103,114,97,118,101,0,79,109,101,103,97,0,79,109,105,99,114,111,110,0,79,115,108,97,115,104,0,79,116,105,108,100,101,0,79,117,109,108,0,80,104,105,0,80,105,0,80,114,105,109,101,0,80,115,105,0,82,104,111,0,83,99,97,114,111,110,0,83,105,103,109,97,0,84,72,79,82,78,0,84,97,117,0,84,104,101,116,97,0,85,97,99,117,116,101,0,85,99,105,114,99,0,85,103,114,97,118,101,0,85,112,115,105,108,111,110,0,85,117,109,108,0,88,105,0,89,97,99,117,116,101,0,89,117,109,108,0,90,101,116,97,0,97,97,99,117,116,101,0,97,99,105,114,99,0,97,99,117,116,101,0,97,101,108,105,103,0,97,103,114,97,118,101,0,97,108,101,102,115,121,109,0,97,108,112,104,97,0,97,109,112,0,97,110,100,0,97,110,103,0,97,114,105,110,103,0,97,115,121,109,112,0,97,116,105,108,100,101,0,97,117,109,108,0,98,100,113,117,111,0,98,101,116,97,0,98,114,118,98,97,114,0,98,117,108,108,0,99,97,112,0,99,99,101,100,105,108,0,99,101,100,105,108,0,99,101,110,116,0,99,104,105,0,99,105,114,99,0,99,108,117,98,115,0,99,111,110,103,0,99,111,112,121,0,99,114,97,114,114,0,99,117,112,0,99,117,114,114,101,110,0,100,65,114,114,0,100,97,103,103,101,114,0,100,97,114,114,0,100,101,103,0,100,101,108,116,97,0,100,105,97,109,115,0,100,105,118,105,100,101,0,101,97,99,117,116,101,0,101,99,105,114,99,0,101,103,114,97,118,101,0,101,109,112,116,121,0,101,109,115,112,0,101,110,115,112,0,101,112,115,105,108,111,110,0,101,113,117,105,118,0,101,116,97,0,101,116,104,0,101,117,109,108,0,101,117,114,111,0,101,120,105,115,116,0,102,110,111,102,0,102,111,114,97,108,108,0,102,114,97,99,49,50,0,102,114,97,99,49,52,0,102,114,97,99,51,52,0,102,114,97,115,108,0,103,97,109,109,97,0,103,101,0,103,116,0,104,65,114,114,0,104,97,114,114,0,104,101,97,114,116,115,0,104,101,108,108,105,112,0,105,97,99,117,116,101,0,105,99,105,114,99,0,105,101,120,99,108,0,105,103,114,97,118,101,0,105,109,97,103,101,0,105,110,102,105,110,0,105,110,116,0,105,111,116,97,0,105,113,117,101,115,116,0,105,115,105,110,0,105,117,109,108,0,107,97,112,112,97,0,108,65,114,114,0,108,97,109,98,100,97,0,108,97,110,103,0,108,97,113,117,111,0,108,97,114,114,0,108,99,101,105,108,0,108,100,113,117,111,0,108,101,0,108,102,108,111,111,114,0,108,111,119,97,115,116,0,108,111,122,0,108,114,109,0,108,115,97,113,117,111,0,108,115,113,117,111,0,108,116,0,109,97,99,114,0,109,100,97,115,104,0,109,105,99,114,111,0,109,105,100,100,111,116,0,109,117,0,110,97,98,108,97,0,110,98,115,112,0,110,100,97,115,104,0,110,101,0,110,105,0,110,111,116,0,110,111,116,105,110,0,110,115,117,98,0,110,116,105,108,100,101,0,110,117,0,111,97,99,117,116,101,0,111,99,105,114,99,0,111,101,108,105,103,0,111,103,114,97,118,101,0,111,108,105,110,101,0,111,109,101,103,97,0,111,109,105,99,114,111,110,0,111,112,108,117,115,0,111,114,0,111,114,100,102,0,111,114,100,109,0,111,115,108,97,115,104,0,111,116,105,108,100,101,0,111,116,105,109,101,115,0,111,117,109,108,0,112,97,114,97,0,112,97,114,116,0,112,101,114,109,105,108,0,112,101,114,112,0,112,104,105,0,112,105,0,112,105,118,0,112,108,117,115,109,110,0,112,111,117,110,100,0,112,114,105,109,101,0,112,114,111,100,0,112,114,111,112,0,112,115,105,0,113,117,111,116,0,114,65,114,114,0,114,97,100,105,99,0,114,97,110,103,0,114,97,113,117,111,0,114,97,114,114,0,114,99,101,105,108,0,114,100,113,117,111,0,114,101,97,108,0,114,101,103,0,114,102,108,111,111,114,0,114,104,111,0,114,108,109,0,114,115,97,113,117,111,0,114,115,113,117,111,0,115,98,113,117,111,0,115,99,97,114,111,110,0,115,100,111,116,0,115,101,99,116,0,115,104,121,0,115,105,103,109,97,0,115,105,103,109,97,102,0,115,105,109,0,115,112,97,100,101,115,0,115,117,98,0,115,117,98,101,0,115,117,109,0,115,117,112,0,115,117,112,49,0,115,117,112,50,0,115,117,112,51,0,115,117,112,101,0,115,122,108,105,103,0,116,97,117,0,116,104,101,114,101,52,0,116,104,101,116,97,0,116,104,101,116,97,115,121,109,0,116,104,105,110,115,112,0,116,104,111,114,110,0,116,105,108,100,101,0,116,105,109,101,115,0,116,114,97,100,101,0,117,65,114,114,0,117,97,99,117,116,101,0,117,97,114,114,0,117,99,105,114,99,0,117,103,114,97,118,101,0,117,109,108,0,117,112,115,105,104,0,117,112,115,105,108,111,110,0,117,117,109,108,0,119,101,105,101,114,112,0,120,105,0,121,97,99,117,116,101,0,121,101,110,0,121,117,109,108,0,122,101,116,97,0,122,119,106,0,122,119,110,106,0,109,97,112,78,0,84,119,111,32,99,108,117,115,116,101,114,115,32,110,97,109,101,100,32,37,115,32,45,32,116,104,101,32,115,101,99,111,110,100,32,119,105,108,108,32,98,101,32,105,103,110,111,114,101,100,10,0,99,108,117,115,116,101,114,32,99,121,99,108,101,32,37,115,32,45,45,32,37,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,10,0,116,97,105,108,32,99,108,117,115,116,101,114,32,37,115,32,105,110,115,105,100,101,32,104,101,97,100,32,99,108,117,115,116,101,114,32,37,115,10,0,104,101,97,100,32,99,108,117,115,116,101,114,32,37,115,32,105,110,115,105,100,101,32,116,97,105,108,32,99,108,117,115,116,101,114,32,37,115,10,0,116,97,105,108,32,110,111,100,101,32,37,115,32,105,110,115,105,100,101,32,104,101,97,100,32,99,108,117,115,116,101,114,32,37,115,10,0,104,101,97,100,32,110,111,100,101,32,37,115,32,105,110,115,105,100,101,32,116,97,105,108,32,99,108,117,115,116,101,114,32,37,115,10,0,95,95,0,108,97,98,101,108,0,115,104,97,112,101,0,98,111,120,0,37,115,37,115,37,115,0,111,100,98,0,79,114,116,104,111,103,111,110,97,108,32,101,100,103,101,115,32,100,111,32,110,111,116,32,99,117,114,114,101,110,116,108,121,32,104,97,110,100,108,101,32,101,100,103,101,32,108,97,98,101,108,115,46,32,84,114,121,32,117,115,105,110,103,32,120,108,97,98,101,108,115,46,10,0,111,114,116,104,111,32,37,115,32,37,115,10,0,99,104,97,110,105,0,111,114,116,104,111,46,99,0,99,104,97,110,83,101,97,114,99,104,0,99,112,0,37,115,0,37,100,32,37,100,32,116,114,97,110,115,108,97,116,101,10,0,48,46,56,32,48,46,56,32,48,46,56,32,115,101,116,114,103,98,99,111,108,111,114,10,0,115,104,111,119,112,97,103,101,10,37,37,37,37,84,114,97,105,108,101,114,10,37,37,37,37,66,111,117,110,100,105,110,103,66,111,120,58,32,37,100,32,37,100,32,37,100,32,37,100,10,0,110,101,119,112,97,116,104,32,37,100,32,37,100,32,109,111,118,101,116,111,10,0,37,100,32,37,100,32,108,105,110,101,116,111,10,0,37,100,32,37,100,32,108,105,110,101,116,111,32,115,116,114,111,107,101,10,0,37,37,33,80,83,45,65,100,111,98,101,45,50,46,48,10,37,37,37,37,66,111,117,110,100,105,110,103,66,111,120,58,32,40,97,116,101,110,100,41,10,47,112,111,105,110,116,32,123,10,32,32,47,89,32,101,120,99,104,32,100,101,102,10,32,32,47,88,32,101,120,99,104,32,100,101,102,10,32,32,110,101,119,112,97,116,104,10,32,32,88,32,89,32,51,32,48,32,51,54,48,32,97,114,99,32,102,105,108,108,10,125,32,100,101,102,10,47,99,101,108,108,32,123,10,32,32,47,89,32,101,120,99,104,32,100,101,102,10,32,32,47,88,32,101,120,99,104,32,100,101,102,10,32,32,47,121,32,101,120,99,104,32,100,101,102,10,32,32,47,120,32,101,120,99,104,32,100,101,102,10,32,32,110,101,119,112,97,116,104,10,32,32,120,32,121,32,109,111,118,101,116,111,10,32,32,120,32,89,32,108,105,110,101,116,111,10,32,32,88,32,89,32,108,105,110,101,116,111,10,32,32,88,32,121,32,108,105,110,101,116,111,10,32,32,99,108,111,115,101,112,97,116,104,32,115,116,114,111,107,101,10,125,32,100,101,102,10,47,110,111,100,101,32,123,10,32,47,117,32,101,120,99,104,32,100,101,102,10,32,47,114,32,101,120,99,104,32,100,101,102,10,32,47,100,32,101,120,99,104,32,100,101,102,10,32,47,108,32,101,120,99,104,32,100,101,102,10,32,110,101,119,112,97,116,104,32,108,32,100,32,109,111,118,101,116,111,10,32,114,32,100,32,108,105,110,101,116,111,32,114,32,117,32,108,105,110,101,116,111,32,108,32,117,32,108,105,110,101,116,111,10,32,99,108,111,115,101,112,97,116,104,32,102,105,108,108,10,125,32,100,101,102,10,10,0,99,104,97,110,110,101,108,32,37,100,32,40,37,102,44,37,102,41,10,0,32,45,62,10,0,32,32,32,32,32,0,40,40,37,102,44,37,102,41,44,40,37,102,44,37,102,41,41,32,37,115,32,37,115,0,66,95,78,79,68,69,0,66,95,85,80,0,66,95,76,69,70,84,0,66,95,68,79,87,78,0,66,95,82,73,71,72,84,0,115,101,103,0,110,101,120,116,95,115,101,103,0,100,101,99,105,100,101,95,112,111,105,110,116,0,105,110,99,111,109,112,97,114,97,98,108,101,32,115,101,103,109,101,110,116,115,32,33,33,32,45,45,32,65,98,111,114,116,105,110,103,10,0,115,49,45,62,99,111,109,109,95,99,111,111,114,100,61,61,115,50,45,62,99,111,109,109,95,99,111,111,114,100,0,105,115,95,112,97,114,97,108,108,101,108,0,103,114,97,112,104,32,71,32,123,10,0,32,110,111,100,101,91,115,104,97,112,101,61,112,111,105,110,116,93,10,0,32,32,37,100,32,91,112,111,115,61,34,37,100,44,37,100,34,93,10,0,32,32,37,100,32,45,45,32,37,100,91,108,101,110,61,34,37,102,34,93,10,0,125,10,0,115,111,108,105,100,0,105,110,118,105,115,105,98,108,101,0,98,111,108,100,0,115,101,116,108,105,110,101,119,105,100,116,104,0,102,105,108,108,101,100,0,117,110,102,105,108,108,101,100,0,116,97,112,101,114,101,100,0,103,118,114,101,110,100,101,114,95,115,101,116,95,115,116,121,108,101,58,32,117,110,115,117,112,112,111,114,116,101,100,32,115,116,121,108,101,32,37,115,32,45,32,105,103,110,111,114,105,110,103,10,0,103,118,114,101,110,100,101,114,46,99,0,103,118,114,101,110,100,101,114,95,117,115,101,114,115,104,97,112,101,0,110,97,109,101,0,110,97,109,101,91,48,93,0,98,111,116,104,0,99,111,108,111,114,32,37,115,0,37,115,32,105,115,32,110,111,116,32,97,32,107,110,111,119,110,32,99,111,108,111,114,46,10,0,101,114,114,111,114,32,105,110,32,99,111,108,120,108,97,116,101,40,41,10,0,106,111,98,0,103,118,108,111,97,100,105,109,97,103,101,46,99,0,103,118,108,111,97,100,105,109,97,103,101,0,117,115,0,117,115,45,62,110,97,109,101,0,117,115,45,62,110,97,109,101,91,48,93,0,58,0,78,111,32,108,111,97,100,105,109,97,103,101,32,112,108,117,103,105,110,32,102,111,114,32,34,37,115,34,10,0,103,114,97,112,104,118,105,122,0,50,46,51,56,46,48,0,50,48,49,52,48,52,49,51,46,50,48,52,49,0,81,0,76,101,102,116,0,75,80,95,76,101,102,116,0,82,105,103,104,116,0,75,80,95,82,105,103,104,116,0,85,112,0,75,80,95,85,112,0,68,111,119,110,0,75,80,95,68,111,119,110,0,112,108,117,115,0,75,80,95,65,100,100,0,109,105,110,117,115,0,75,80,95,83,117,98,116,114,97,99,116,0,70,0,71,0,110,101,119,46,103,118,0,85,82,76,0,107,101,121,0,104,101,97,100,112,111,114,116,0,116,97,105,108,112,111,114,116,0,101,100,103,101,0,110,111,100,101,0,115,117,98,103,114,97,112,104,0,103,114,97,112,104,0,100,105,103,114,97,112,104,0,95,76,84,88,95,108,105,98,114,97,114,121,0,116,101,120,116,108,97,121,111,117,116,0,111,98,106,112,45,62,108,98,108,0,120,108,97,98,101,108,115,46,99,0,120,108,97,100,106,117,115,116,0,120,108,105,110,116,101,114,115,101,99,116,105,111,110,115,0,108,112,32,33,61,32,99,108,112,0,103,101,116,105,110,116,114,115,120,105,0,111,98,106,112,49,45,62,115,122,46,120,32,61,61,32,48,32,38,38,32,111,98,106,112,49,45,62,115,122,46,121,32,61,61,32,48,0,108,98,108,101,110,99,108,111,115,105,110,103,0,118,112,0,120,108,104,100,120,117,110,108,111,97,100,0,115,105,122,101,61,61,102,114,101,101,100,0,114,101,99,116,46,98,111,117,110,100,97,114,121,91,50,93,32,60,32,73,78,84,95,77,65,88,0,111,98,106,112,108,112,109,107,115,0,114,101,99,116,46,98,111,117,110,100,97,114,121,91,51,93,32,60,32,73,78,84,95,77,65,88,0,111,117,116,32,111,102,32,109,101,109,111,114,121,10,0,35,37,50,120,37,50,120,37,50,120,37,50,120,0,37,108,102,37,108,102,37,108,102,0,47,97,99,99,101,110,116,51,47,49,0,47,97,99,99,101,110,116,51,47,50,0,47,97,99,99,101,110,116,51,47,51,0,47,97,99,99,101,110,116,52,47,49,0,47,97,99,99,101,110,116,52,47,50,0,47,97,99,99,101,110,116,52,47,51,0,47,97,99,99,101,110,116,52,47,52,0,47,97,99,99,101,110,116,53,47,49,0,47,97,99,99,101,110,116,53,47,50,0,47,97,99,99,101,110,116,53,47,51,0,47,97,99,99,101,110,116,53,47,52,0,47,97,99,99,101,110,116,53,47,53,0,47,97,99,99,101,110,116,54,47,49,0,47,97,99,99,101,110,116,54,47,50,0,47,97,99,99,101,110,116,54,47,51,0,47,97,99,99,101,110,116,54,47,52,0,47,97,99,99,101,110,116,54,47,53,0,47,97,99,99,101,110,116,54,47,54,0,47,97,99,99,101,110,116,55,47,49,0,47,97,99,99,101,110,116,55,47,50,0,47,97,99,99,101,110,116,55,47,51,0,47,97,99,99,101,110,116,55,47,52,0,47,97,99,99,101,110,116,55,47,53,0,47,97,99,99,101,110,116,55,47,54,0,47,97,99,99,101,110,116,55,47,55,0,47,97,99,99,101,110,116,56,47,49,0,47,97,99,99,101,110,116,56,47,50,0,47,97,99,99,101,110,116,56,47,51,0,47,97,99,99,101,110,116,56,47,52,0,47,97,99,99,101,110,116,56,47,53,0,47,97,99,99,101,110,116,56,47,54,0,47,97,99,99,101,110,116,56,47,55,0,47,97,99,99,101,110,116,56,47,56,0,47,98,108,117,101,115,51,47,49,0,47,98,108,117,101,115,51,47,50,0,47,98,108,117,101,115,51,47,51,0,47,98,108,117,101,115,52,47,49,0,47,98,108,117,101,115,52,47,50,0,47,98,108,117,101,115,52,47,51,0,47,98,108,117,101,115,52,47,52,0,47,98,108,117,101,115,53,47,49,0,47,98,108,117,101,115,53,47,50,0,47,98,108,117,101,115,53,47,51,0,47,98,108,117,101,115,53,47,52,0,47,98,108,117,101,115,53,47,53,0,47,98,108,117,101,115,54,47,49,0,47,98,108,117,101,115,54,47,50,0,47,98,108,117,101,115,54,47,51,0,47,98,108,117,101,115,54,47,52,0,47,98,108,117,101,115,54,47,53,0,47,98,108,117,101,115,54,47,54,0,47,98,108,117,101,115,55,47,49,0,47,98,108,117,101,115,55,47,50,0,47,98,108,117,101,115,55,47,51,0,47,98,108,117,101,115,55,47,52,0,47,98,108,117,101,115,55,47,53,0,47,98,108,117,101,115,55,47,54,0,47,98,108,117,101,115,55,47,55,0,47,98,108,117,101,115,56,47,49,0,47,98,108,117,101,115,56,47,50,0,47,98,108,117,101,115,56,47,51,0,47,98,108,117,101,115,56,47,52,0,47,98,108,117,101,115,56,47,53,0,47,98,108,117,101,115,56,47,54,0,47,98,108,117,101,115,56,47,55,0,47,98,108,117,101,115,56,47,56,0,47,98,108,117,101,115,57,47,49,0,47,98,108,117,101,115,57,47,50,0,47,98,108,117,101,115,57,47,51,0,47,98,108,117,101,115,57,47,52,0,47,98,108,117,101,115,57,47,53,0,47,98,108,117,101,115,57,47,54,0,47,98,108,117,101,115,57,47,55,0,47,98,108,117,101,115,57,47,56,0,47,98,108,117,101,115,57,47,57,0,47,98,114,98,103,49,48,47,49,0,47,98,114,98,103,49,48,47,49,48,0,47,98,114,98,103,49,48,47,50,0,47,98,114,98,103,49,48,47,51,0,47,98,114,98,103,49,48,47,52,0,47,98,114,98,103,49,48,47,53,0,47,98,114,98,103,49,48,47,54,0,47,98,114,98,103,49,48,47,55,0,47,98,114,98,103,49,48,47,56,0,47,98,114,98,103,49,48,47,57,0,47,98,114,98,103,49,49,47,49,0,47,98,114,98,103,49,49,47,49,48,0,47,98,114,98,103,49,49,47,49,49,0,47,98,114,98,103,49,49,47,50,0,47,98,114,98,103,49,49,47,51,0,47,98,114,98,103,49,49,47,52,0,47,98,114,98,103,49,49,47,53,0,47,98,114,98,103,49,49,47,54,0,47,98,114,98,103,49,49,47,55,0,47,98,114,98,103,49,49,47,56,0,47,98,114,98,103,49,49,47,57,0,47,98,114,98,103,51,47,49,0,47,98,114,98,103,51,47,50,0,47,98,114,98,103,51,47,51,0,47,98,114,98,103,52,47,49,0,47,98,114,98,103,52,47,50,0,47,98,114,98,103,52,47,51,0,47,98,114,98,103,52,47,52,0,47,98,114,98,103,53,47,49,0,47,98,114,98,103,53,47,50,0,47,98,114,98,103,53,47,51,0,47,98,114,98,103,53,47,52,0,47,98,114,98,103,53,47,53,0,47,98,114,98,103,54,47,49,0,47,98,114,98,103,54,47,50,0,47,98,114,98,103,54,47,51,0,47,98,114,98,103,54,47,52,0,47,98,114,98,103,54,47,53,0,47,98,114,98,103,54,47,54,0,47,98,114,98,103,55,47,49,0,47,98,114,98,103,55,47,50,0,47,98,114,98,103,55,47,51,0,47,98,114,98,103,55,47,52,0,47,98,114,98,103,55,47,53,0,47,98,114,98,103,55,47,54,0,47,98,114,98,103,55,47,55,0,47,98,114,98,103,56,47,49,0,47,98,114,98,103,56,47,50,0,47,98,114,98,103,56,47,51,0,47,98,114,98,103,56,47,52,0,47,98,114,98,103,56,47,53,0,47,98,114,98,103,56,47,54,0,47,98,114,98,103,56,47,55,0,47,98,114,98,103,56,47,56,0,47,98,114,98,103,57,47,49,0,47,98,114,98,103,57,47,50,0,47,98,114,98,103,57,47,51,0,47,98,114,98,103,57,47,52,0,47,98,114,98,103,57,47,53,0,47,98,114,98,103,57,47,54,0,47,98,114,98,103,57,47,55,0,47,98,114,98,103,57,47,56,0,47,98,114,98,103,57,47,57,0,47,98,117,103,110,51,47,49,0,47,98,117,103,110,51,47,50,0,47,98,117,103,110,51,47,51,0,47,98,117,103,110,52,47,49,0,47,98,117,103,110,52,47,50,0,47,98,117,103,110,52,47,51,0,47,98,117,103,110,52,47,52,0,47,98,117,103,110,53,47,49,0,47,98,117,103,110,53,47,50,0,47,98,117,103,110,53,47,51,0,47,98,117,103,110,53,47,52,0,47,98,117,103,110,53,47,53,0,47,98,117,103,110,54,47,49,0,47,98,117,103,110,54,47,50,0,47,98,117,103,110,54,47,51,0,47,98,117,103,110,54,47,52,0,47,98,117,103,110,54,47,53,0,47,98,117,103,110,54,47,54,0,47,98,117,103,110,55,47,49,0,47,98,117,103,110,55,47,50,0,47,98,117,103,110,55,47,51,0,47,98,117,103,110,55,47,52,0,47,98,117,103,110,55,47,53,0,47,98,117,103,110,55,47,54,0,47,98,117,103,110,55,47,55,0,47,98,117,103,110,56,47,49,0,47,98,117,103,110,56,47,50,0,47,98,117,103,110,56,47,51,0,47,98,117,103,110,56,47,52,0,47,98,117,103,110,56,47,53,0,47,98,117,103,110,56,47,54,0,47,98,117,103,110,56,47,55,0,47,98,117,103,110,56,47,56,0,47,98,117,103,110,57,47,49,0,47,98,117,103,110,57,47,50,0,47,98,117,103,110,57,47,51,0,47,98,117,103,110,57,47,52,0,47,98,117,103,110,57,47,53,0,47,98,117,103,110,57,47,54,0,47,98,117,103,110,57,47,55,0,47,98,117,103,110,57,47,56,0,47,98,117,103,110,57,47,57,0,47,98,117,112,117,51,47,49,0,47,98,117,112,117,51,47,50,0,47,98,117,112,117,51,47,51,0,47,98,117,112,117,52,47,49,0,47,98,117,112,117,52,47,50,0,47,98,117,112,117,52,47,51,0,47,98,117,112,117,52,47,52,0,47,98,117,112,117,53,47,49,0,47,98,117,112,117,53,47,50,0,47,98,117,112,117,53,47,51,0,47,98,117,112,117,53,47,52,0,47,98,117,112,117,53,47,53,0,47,98,117,112,117,54,47,49,0,47,98,117,112,117,54,47,50,0,47,98,117,112,117,54,47,51,0,47,98,117,112,117,54,47,52,0,47,98,117,112,117,54,47,53,0,47,98,117,112,117,54,47,54,0,47,98,117,112,117,55,47,49,0,47,98,117,112,117,55,47,50,0,47,98,117,112,117,55,47,51,0,47,98,117,112,117,55,47,52,0,47,98,117,112,117,55,47,53,0,47,98,117,112,117,55,47,54,0,47,98,117,112,117,55,47,55,0,47,98,117,112,117,56,47,49,0,47,98,117,112,117,56,47,50,0,47,98,117,112,117,56,47,51,0,47,98,117,112,117,56,47,52,0,47,98,117,112,117,56,47,53,0,47,98,117,112,117,56,47,54,0,47,98,117,112,117,56,47,55,0,47,98,117,112,117,56,47,56,0,47,98,117,112,117,57,47,49,0,47,98,117,112,117,57,47,50,0,47,98,117,112,117,57,47,51,0,47,98,117,112,117,57,47,52,0,47,98,117,112,117,57,47,53,0,47,98,117,112,117,57,47,54,0,47,98,117,112,117,57,47,55,0,47,98,117,112,117,57,47,56,0,47,98,117,112,117,57,47,57,0,47,100,97,114,107,50,51,47,49,0,47,100,97,114,107,50,51,47,50,0,47,100,97,114,107,50,51,47,51,0,47,100,97,114,107,50,52,47,49,0,47,100,97,114,107,50,52,47,50,0,47,100,97,114,107,50,52,47,51,0,47,100,97,114,107,50,52,47,52,0,47,100,97,114,107,50,53,47,49,0,47,100,97,114,107,50,53,47,50,0,47,100,97,114,107,50,53,47,51,0,47,100,97,114,107,50,53,47,52,0,47,100,97,114,107,50,53,47,53,0,47,100,97,114,107,50,54,47,49,0,47,100,97,114,107,50,54,47,50,0,47,100,97,114,107,50,54,47,51,0,47,100,97,114,107,50,54,47,52,0,47,100,97,114,107,50,54,47,53,0,47,100,97,114,107,50,54,47,54,0,47,100,97,114,107,50,55,47,49,0,47,100,97,114,107,50,55,47,50,0,47,100,97,114,107,50,55,47,51,0,47,100,97,114,107,50,55,47,52,0,47,100,97,114,107,50,55,47,53,0,47,100,97,114,107,50,55,47,54,0,47,100,97,114,107,50,55,47,55,0,47,100,97,114,107,50,56,47,49,0,47,100,97,114,107,50,56,47,50,0,47,100,97,114,107,50,56,47,51,0,47,100,97,114,107,50,56,47,52,0,47,100,97,114,107,50,56,47,53,0,47,100,97,114,107,50,56,47,54,0,47,100,97,114,107,50,56,47,55,0,47,100,97,114,107,50,56,47,56,0,47,103,110,98,117,51,47,49,0,47,103,110,98,117,51,47,50,0,47,103,110,98,117,51,47,51,0,47,103,110,98,117,52,47,49,0,47,103,110,98,117,52,47,50,0,47,103,110,98,117,52,47,51,0,47,103,110,98,117,52,47,52,0,47,103,110,98,117,53,47,49,0,47,103,110,98,117,53,47,50,0,47,103,110,98,117,53,47,51,0,47,103,110,98,117,53,47,52,0,47,103,110,98,117,53,47,53,0,47,103,110,98,117,54,47,49,0,47,103,110,98,117,54,47,50,0,47,103,110,98,117,54,47,51,0,47,103,110,98,117,54,47,52,0,47,103,110,98,117,54,47,53,0,47,103,110,98,117,54,47,54,0,47,103,110,98,117,55,47,49,0,47,103,110,98,117,55,47,50,0,47,103,110,98,117,55,47,51,0,47,103,110,98,117,55,47,52,0,47,103,110,98,117,55,47,53,0,47,103,110,98,117,55,47,54,0,47,103,110,98,117,55,47,55,0,47,103,110,98,117,56,47,49,0,47,103,110,98,117,56,47,50,0,47,103,110,98,117,56,47,51,0,47,103,110,98,117,56,47,52,0,47,103,110,98,117,56,47,53,0,47,103,110,98,117,56,47,54,0,47,103,110,98,117,56,47,55,0,47,103,110,98,117,56,47,56,0,47,103,110,98,117,57,47,49,0,47,103,110,98,117,57,47,50,0,47,103,110,98,117,57,47,51,0,47,103,110,98,117,57,47,52,0,47,103,110,98,117,57,47,53,0,47,103,110,98,117,57,47,54,0,47,103,110,98,117,57,47,55,0,47,103,110,98,117,57,47,56,0,47,103,110,98,117,57,47,57,0,47,103,114,101,101,110,115,51,47,49,0,47,103,114,101,101,110,115,51,47,50,0,47,103,114,101,101,110,115,51,47,51,0,47,103,114,101,101,110,115,52,47,49,0,47,103,114,101,101,110,115,52,47,50,0,47,103,114,101,101,110,115,52,47,51,0,47,103,114,101,101,110,115,52,47,52,0,47,103,114,101,101,110,115,53,47,49,0,47,103,114,101,101,110,115,53,47,50,0,47,103,114,101,101,110,115,53,47,51,0,47,103,114,101,101,110,115,53,47,52,0,47,103,114,101,101,110,115,53,47,53,0,47,103,114,101,101,110,115,54,47,49,0,47,103,114,101,101,110,115,54,47,50,0,47,103,114,101,101,110,115,54,47,51,0,47,103,114,101,101,110,115,54,47,52,0,47,103,114,101,101,110,115,54,47,53,0,47,103,114,101,101,110,115,54,47,54,0,47,103,114,101,101,110,115,55,47,49,0,47,103,114,101,101,110,115,55,47,50,0,47,103,114,101,101,110,115,55,47,51,0,47,103,114,101,101,110,115,55,47,52,0,47,103,114,101,101,110,115,55,47,53,0,47,103,114,101,101,110,115,55,47,54,0,47,103,114,101,101,110,115,55,47,55,0,47,103,114,101,101,110,115,56,47,49,0,47,103,114,101,101,110,115,56,47,50,0,47,103,114,101,101,110,115,56,47,51,0,47,103,114,101,101,110,115,56,47,52,0,47,103,114,101,101,110,115,56,47,53,0,47,103,114,101,101,110,115,56,47,54,0,47,103,114,101,101,110,115,56,47,55,0,47,103,114,101,101,110,115,56,47,56,0,47,103,114,101,101,110,115,57,47,49,0,47,103,114,101,101,110,115,57,47,50,0,47,103,114,101,101,110,115,57,47,51,0,47,103,114,101,101,110,115,57,47,52,0,47,103,114,101,101,110,115,57,47,53,0,47,103,114,101,101,110,115,57,47,54,0,47,103,114,101,101,110,115,57,47,55,0,47,103,114,101,101,110,115,57,47,56,0,47,103,114,101,101,110,115,57,47,57,0,47,103,114,101,121,115,51,47,49,0,47,103,114,101,121,115,51,47,50,0,47,103,114,101,121,115,51,47,51,0,47,103,114,101,121,115,52,47,49,0,47,103,114,101,121,115,52,47,50,0,47,103,114,101,121,115,52,47,51,0,47,103,114,101,121,115,52,47,52,0,47,103,114,101,121,115,53,47,49,0,47,103,114,101,121,115,53,47,50,0,47,103,114,101,121,115,53,47,51,0,47,103,114,101,121,115,53,47,52,0,47,103,114,101,121,115,53,47,53,0,47,103,114,101,121,115,54,47,49,0,47,103,114,101,121,115,54,47,50,0,47,103,114,101,121,115,54,47,51,0,47,103,114,101,121,115,54,47,52,0,47,103,114,101,121,115,54,47,53,0,47,103,114,101,121,115,54,47,54,0,47,103,114,101,121,115,55,47,49,0,47,103,114,101,121,115,55,47,50,0,47,103,114,101,121,115,55,47,51,0,47,103,114,101,121,115,55,47,52,0,47,103,114,101,121,115,55,47,53,0,47,103,114,101,121,115,55,47,54,0,47,103,114,101,121,115,55,47,55,0,47,103,114,101,121,115,56,47,49,0,47,103,114,101,121,115,56,47,50,0,47,103,114,101,121,115,56,47,51,0,47,103,114,101,121,115,56,47,52,0,47,103,114,101,121,115,56,47,53,0,47,103,114,101,121,115,56,47,54,0,47,103,114,101,121,115,56,47,55,0,47,103,114,101,121,115,56,47,56,0,47,103,114,101,121,115,57,47,49,0,47,103,114,101,121,115,57,47,50,0,47,103,114,101,121,115,57,47,51,0,47,103,114,101,121,115,57,47,52,0,47,103,114,101,121,115,57,47,53,0,47,103,114,101,121,115,57,47,54,0,47,103,114,101,121,115,57,47,55,0,47,103,114,101,121,115,57,47,56,0,47,103,114,101,121,115,57,47,57,0,47,111,114,97,110,103,101,115,51,47,49,0,47,111,114,97,110,103,101,115,51,47,50,0,47,111,114,97,110,103,101,115,51,47,51,0,47,111,114,97,110,103,101,115,52,47,49,0,47,111,114,97,110,103,101,115,52,47,50,0,47,111,114,97,110,103,101,115,52,47,51,0,47,111,114,97,110,103,101,115,52,47,52,0,47,111,114,97],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+142942);allocate([110,103,101,115,53,47,49,0,47,111,114,97,110,103,101,115,53,47,50,0,47,111,114,97,110,103,101,115,53,47,51,0,47,111,114,97,110,103,101,115,53,47,52,0,47,111,114,97,110,103,101,115,53,47,53,0,47,111,114,97,110,103,101,115,54,47,49,0,47,111,114,97,110,103,101,115,54,47,50,0,47,111,114,97,110,103,101,115,54,47,51,0,47,111,114,97,110,103,101,115,54,47,52,0,47,111,114,97,110,103,101,115,54,47,53,0,47,111,114,97,110,103,101,115,54,47,54,0,47,111,114,97,110,103,101,115,55,47,49,0,47,111,114,97,110,103,101,115,55,47,50,0,47,111,114,97,110,103,101,115,55,47,51,0,47,111,114,97,110,103,101,115,55,47,52,0,47,111,114,97,110,103,101,115,55,47,53,0,47,111,114,97,110,103,101,115,55,47,54,0,47,111,114,97,110,103,101,115,55,47,55,0,47,111,114,97,110,103,101,115,56,47,49,0,47,111,114,97,110,103,101,115,56,47,50,0,47,111,114,97,110,103,101,115,56,47,51,0,47,111,114,97,110,103,101,115,56,47,52,0,47,111,114,97,110,103,101,115,56,47,53,0,47,111,114,97,110,103,101,115,56,47,54,0,47,111,114,97,110,103,101,115,56,47,55,0,47,111,114,97,110,103,101,115,56,47,56,0,47,111,114,97,110,103,101,115,57,47,49,0,47,111,114,97,110,103,101,115,57,47,50,0,47,111,114,97,110,103,101,115,57,47,51,0,47,111,114,97,110,103,101,115,57,47,52,0,47,111,114,97,110,103,101,115,57,47,53,0,47,111,114,97,110,103,101,115,57,47,54,0,47,111,114,97,110,103,101,115,57,47,55,0,47,111,114,97,110,103,101,115,57,47,56,0,47,111,114,97,110,103,101,115,57,47,57,0,47,111,114,114,100,51,47,49,0,47,111,114,114,100,51,47,50,0,47,111,114,114,100,51,47,51,0,47,111,114,114,100,52,47,49,0,47,111,114,114,100,52,47,50,0,47,111,114,114,100,52,47,51,0,47,111,114,114,100,52,47,52,0,47,111,114,114,100,53,47,49,0,47,111,114,114,100,53,47,50,0,47,111,114,114,100,53,47,51,0,47,111,114,114,100,53,47,52,0,47,111,114,114,100,53,47,53,0,47,111,114,114,100,54,47,49,0,47,111,114,114,100,54,47,50,0,47,111,114,114,100,54,47,51,0,47,111,114,114,100,54,47,52,0,47,111,114,114,100,54,47,53,0,47,111,114,114,100,54,47,54,0,47,111,114,114,100,55,47,49,0,47,111,114,114,100,55,47,50,0,47,111,114,114,100,55,47,51,0,47,111,114,114,100,55,47,52,0,47,111,114,114,100,55,47,53,0,47,111,114,114,100,55,47,54,0,47,111,114,114,100,55,47,55,0,47,111,114,114,100,56,47,49,0,47,111,114,114,100,56,47,50,0,47,111,114,114,100,56,47,51,0,47,111,114,114,100,56,47,52,0,47,111,114,114,100,56,47,53,0,47,111,114,114,100,56,47,54,0,47,111,114,114,100,56,47,55,0,47,111,114,114,100,56,47,56,0,47,111,114,114,100,57,47,49,0,47,111,114,114,100,57,47,50,0,47,111,114,114,100,57,47,51,0,47,111,114,114,100,57,47,52,0,47,111,114,114,100,57,47,53,0,47,111,114,114,100,57,47,54,0,47,111,114,114,100,57,47,55,0,47,111,114,114,100,57,47,56,0,47,111,114,114,100,57,47,57,0,47,112,97,105,114,101,100,49,48,47,49,0,47,112,97,105,114,101,100,49,48,47,49,48,0,47,112,97,105,114,101,100,49,48,47,50,0,47,112,97,105,114,101,100,49,48,47,51,0,47,112,97,105,114,101,100,49,48,47,52,0,47,112,97,105,114,101,100,49,48,47,53,0,47,112,97,105,114,101,100,49,48,47,54,0,47,112,97,105,114,101,100,49,48,47,55,0,47,112,97,105,114,101,100,49,48,47,56,0,47,112,97,105,114,101,100,49,48,47,57,0,47,112,97,105,114,101,100,49,49,47,49,0,47,112,97,105,114,101,100,49,49,47,49,48,0,47,112,97,105,114,101,100,49,49,47,49,49,0,47,112,97,105,114,101,100,49,49,47,50,0,47,112,97,105,114,101,100,49,49,47,51,0,47,112,97,105,114,101,100,49,49,47,52,0,47,112,97,105,114,101,100,49,49,47,53,0,47,112,97,105,114,101,100,49,49,47,54,0,47,112,97,105,114,101,100,49,49,47,55,0,47,112,97,105,114,101,100,49,49,47,56,0,47,112,97,105,114,101,100,49,49,47,57,0,47,112,97,105,114,101,100,49,50,47,49,0,47,112,97,105,114,101,100,49,50,47,49,48,0,47,112,97,105,114,101,100,49,50,47,49,49,0,47,112,97,105,114,101,100,49,50,47,49,50,0,47,112,97,105,114,101,100,49,50,47,50,0,47,112,97,105,114,101,100,49,50,47,51,0,47,112,97,105,114,101,100,49,50,47,52,0,47,112,97,105,114,101,100,49,50,47,53,0,47,112,97,105,114,101,100,49,50,47,54,0,47,112,97,105,114,101,100,49,50,47,55,0,47,112,97,105,114,101,100,49,50,47,56,0,47,112,97,105,114,101,100,49,50,47,57,0,47,112,97,105,114,101,100,51,47,49,0,47,112,97,105,114,101,100,51,47,50,0,47,112,97,105,114,101,100,51,47,51,0,47,112,97,105,114,101,100,52,47,49,0,47,112,97,105,114,101,100,52,47,50,0,47,112,97,105,114,101,100,52,47,51,0,47,112,97,105,114,101,100,52,47,52,0,47,112,97,105,114,101,100,53,47,49,0,47,112,97,105,114,101,100,53,47,50,0,47,112,97,105,114,101,100,53,47,51,0,47,112,97,105,114,101,100,53,47,52,0,47,112,97,105,114,101,100,53,47,53,0,47,112,97,105,114,101,100,54,47,49,0,47,112,97,105,114,101,100,54,47,50,0,47,112,97,105,114,101,100,54,47,51,0,47,112,97,105,114,101,100,54,47,52,0,47,112,97,105,114,101,100,54,47,53,0,47,112,97,105,114,101,100,54,47,54,0,47,112,97,105,114,101,100,55,47,49,0,47,112,97,105,114,101,100,55,47,50,0,47,112,97,105,114,101,100,55,47,51,0,47,112,97,105,114,101,100,55,47,52,0,47,112,97,105,114,101,100,55,47,53,0,47,112,97,105,114,101,100,55,47,54,0,47,112,97,105,114,101,100,55,47,55,0,47,112,97,105,114,101,100,56,47,49,0,47,112,97,105,114,101,100,56,47,50,0,47,112,97,105,114,101,100,56,47,51,0,47,112,97,105,114,101,100,56,47,52,0,47,112,97,105,114,101,100,56,47,53,0,47,112,97,105,114,101,100,56,47,54,0,47,112,97,105,114,101,100,56,47,55,0,47,112,97,105,114,101,100,56,47,56,0,47,112,97,105,114,101,100,57,47,49,0,47,112,97,105,114,101,100,57,47,50,0,47,112,97,105,114,101,100,57,47,51,0,47,112,97,105,114,101,100,57,47,52,0,47,112,97,105,114,101,100,57,47,53,0,47,112,97,105,114,101,100,57,47,54,0,47,112,97,105,114,101,100,57,47,55,0,47,112,97,105,114,101,100,57,47,56,0,47,112,97,105,114,101,100,57,47,57,0,47,112,97,115,116,101,108,49,51,47,49,0,47,112,97,115,116,101,108,49,51,47,50,0,47,112,97,115,116,101,108,49,51,47,51,0,47,112,97,115,116,101,108,49,52,47,49,0,47,112,97,115,116,101,108,49,52,47,50,0,47,112,97,115,116,101,108,49,52,47,51,0,47,112,97,115,116,101,108,49,52,47,52,0,47,112,97,115,116,101,108,49,53,47,49,0,47,112,97,115,116,101,108,49,53,47,50,0,47,112,97,115,116,101,108,49,53,47,51,0,47,112,97,115,116,101,108,49,53,47,52,0,47,112,97,115,116,101,108,49,53,47,53,0,47,112,97,115,116,101,108,49,54,47,49,0,47,112,97,115,116,101,108,49,54,47,50,0,47,112,97,115,116,101,108,49,54,47,51,0,47,112,97,115,116,101,108,49,54,47,52,0,47,112,97,115,116,101,108,49,54,47,53,0,47,112,97,115,116,101,108,49,54,47,54,0,47,112,97,115,116,101,108,49,55,47,49,0,47,112,97,115,116,101,108,49,55,47,50,0,47,112,97,115,116,101,108,49,55,47,51,0,47,112,97,115,116,101,108,49,55,47,52,0,47,112,97,115,116,101,108,49,55,47,53,0,47,112,97,115,116,101,108,49,55,47,54,0,47,112,97,115,116,101,108,49,55,47,55,0,47,112,97,115,116,101,108,49,56,47,49,0,47,112,97,115,116,101,108,49,56,47,50,0,47,112,97,115,116,101,108,49,56,47,51,0,47,112,97,115,116,101,108,49,56,47,52,0,47,112,97,115,116,101,108,49,56,47,53,0,47,112,97,115,116,101,108,49,56,47,54,0,47,112,97,115,116,101,108,49,56,47,55,0,47,112,97,115,116,101,108,49,56,47,56,0,47,112,97,115,116,101,108,49,57,47,49,0,47,112,97,115,116,101,108,49,57,47,50,0,47,112,97,115,116,101,108,49,57,47,51,0,47,112,97,115,116,101,108,49,57,47,52,0,47,112,97,115,116,101,108,49,57,47,53,0,47,112,97,115,116,101,108,49,57,47,54,0,47,112,97,115,116,101,108,49,57,47,55,0,47,112,97,115,116,101,108,49,57,47,56,0,47,112,97,115,116,101,108,49,57,47,57,0,47,112,97,115,116,101,108,50,51,47,49,0,47,112,97,115,116,101,108,50,51,47,50,0,47,112,97,115,116,101,108,50,51,47,51,0,47,112,97,115,116,101,108,50,52,47,49,0,47,112,97,115,116,101,108,50,52,47,50,0,47,112,97,115,116,101,108,50,52,47,51,0,47,112,97,115,116,101,108,50,52,47,52,0,47,112,97,115,116,101,108,50,53,47,49,0,47,112,97,115,116,101,108,50,53,47,50,0,47,112,97,115,116,101,108,50,53,47,51,0,47,112,97,115,116,101,108,50,53,47,52,0,47,112,97,115,116,101,108,50,53,47,53,0,47,112,97,115,116,101,108,50,54,47,49,0,47,112,97,115,116,101,108,50,54,47,50,0,47,112,97,115,116,101,108,50,54,47,51,0,47,112,97,115,116,101,108,50,54,47,52,0,47,112,97,115,116,101,108,50,54,47,53,0,47,112,97,115,116,101,108,50,54,47,54,0,47,112,97,115,116,101,108,50,55,47,49,0,47,112,97,115,116,101,108,50,55,47,50,0,47,112,97,115,116,101,108,50,55,47,51,0,47,112,97,115,116,101,108,50,55,47,52,0,47,112,97,115,116,101,108,50,55,47,53,0,47,112,97,115,116,101,108,50,55,47,54,0,47,112,97,115,116,101,108,50,55,47,55,0,47,112,97,115,116,101,108,50,56,47,49,0,47,112,97,115,116,101,108,50,56,47,50,0,47,112,97,115,116,101,108,50,56,47,51,0,47,112,97,115,116,101,108,50,56,47,52,0,47,112,97,115,116,101,108,50,56,47,53,0,47,112,97,115,116,101,108,50,56,47,54,0,47,112,97,115,116,101,108,50,56,47,55,0,47,112,97,115,116,101,108,50,56,47,56,0,47,112,105,121,103,49,48,47,49,0,47,112,105,121,103,49,48,47,49,48,0,47,112,105,121,103,49,48,47,50,0,47,112,105,121,103,49,48,47,51,0,47,112,105,121,103,49,48,47,52,0,47,112,105,121,103,49,48,47,53,0,47,112,105,121,103,49,48,47,54,0,47,112,105,121,103,49,48,47,55,0,47,112,105,121,103,49,48,47,56,0,47,112,105,121,103,49,48,47,57,0,47,112,105,121,103,49,49,47,49,0,47,112,105,121,103,49,49,47,49,48,0,47,112,105,121,103,49,49,47,49,49,0,47,112,105,121,103,49,49,47,50,0,47,112,105,121,103,49,49,47,51,0,47,112,105,121,103,49,49,47,52,0,47,112,105,121,103,49,49,47,53,0,47,112,105,121,103,49,49,47,54,0,47,112,105,121,103,49,49,47,55,0,47,112,105,121,103,49,49,47,56,0,47,112,105,121,103,49,49,47,57,0,47,112,105,121,103,51,47,49,0,47,112,105,121,103,51,47,50,0,47,112,105,121,103,51,47,51,0,47,112,105,121,103,52,47,49,0,47,112,105,121,103,52,47,50,0,47,112,105,121,103,52,47,51,0,47,112,105,121,103,52,47,52,0,47,112,105,121,103,53,47,49,0,47,112,105,121,103,53,47,50,0,47,112,105,121,103,53,47,51,0,47,112,105,121,103,53,47,52,0,47,112,105,121,103,53,47,53,0,47,112,105,121,103,54,47,49,0,47,112,105,121,103,54,47,50,0,47,112,105,121,103,54,47,51,0,47,112,105,121,103,54,47,52,0,47,112,105,121,103,54,47,53,0,47,112,105,121,103,54,47,54,0,47,112,105,121,103,55,47,49,0,47,112,105,121,103,55,47,50,0,47,112,105,121,103,55,47,51,0,47,112,105,121,103,55,47,52,0,47,112,105,121,103,55,47,53,0,47,112,105,121,103,55,47,54,0,47,112,105,121,103,55,47,55,0,47,112,105,121,103,56,47,49,0,47,112,105,121,103,56,47,50,0,47,112,105,121,103,56,47,51,0,47,112,105,121,103,56,47,52,0,47,112,105,121,103,56,47,53,0,47,112,105,121,103,56,47,54,0,47,112,105,121,103,56,47,55,0,47,112,105,121,103,56,47,56,0,47,112,105,121,103,57,47,49,0,47,112,105,121,103,57,47,50,0,47,112,105,121,103,57,47,51,0,47,112,105,121,103,57,47,52,0,47,112,105,121,103,57,47,53,0,47,112,105,121,103,57,47,54,0,47,112,105,121,103,57,47,55,0,47,112,105,121,103,57,47,56,0,47,112,105,121,103,57,47,57,0,47,112,114,103,110,49,48,47,49,0,47,112,114,103,110,49,48,47,49,48,0,47,112,114,103,110,49,48,47,50,0,47,112,114,103,110,49,48,47,51,0,47,112,114,103,110,49,48,47,52,0,47,112,114,103,110,49,48,47,53,0,47,112,114,103,110,49,48,47,54,0,47,112,114,103,110,49,48,47,55,0,47,112,114,103,110,49,48,47,56,0,47,112,114,103,110,49,48,47,57,0,47,112,114,103,110,49,49,47,49,0,47,112,114,103,110,49,49,47,49,48,0,47,112,114,103,110,49,49,47,49,49,0,47,112,114,103,110,49,49,47,50,0,47,112,114,103,110,49,49,47,51,0,47,112,114,103,110,49,49,47,52,0,47,112,114,103,110,49,49,47,53,0,47,112,114,103,110,49,49,47,54,0,47,112,114,103,110,49,49,47,55,0,47,112,114,103,110,49,49,47,56,0,47,112,114,103,110,49,49,47,57,0,47,112,114,103,110,51,47,49,0,47,112,114,103,110,51,47,50,0,47,112,114,103,110,51,47,51,0,47,112,114,103,110,52,47,49,0,47,112,114,103,110,52,47,50,0,47,112,114,103,110,52,47,51,0,47,112,114,103,110,52,47,52,0,47,112,114,103,110,53,47,49,0,47,112,114,103,110,53,47,50,0,47,112,114,103,110,53,47,51,0,47,112,114,103,110,53,47,52,0,47,112,114,103,110,53,47,53,0,47,112,114,103,110,54,47,49,0,47,112,114,103,110,54,47,50,0,47,112,114,103,110,54,47,51,0,47,112,114,103,110,54,47,52,0,47,112,114,103,110,54,47,53,0,47,112,114,103,110,54,47,54,0,47,112,114,103,110,55,47,49,0,47,112,114,103,110,55,47,50,0,47,112,114,103,110,55,47,51,0,47,112,114,103,110,55,47,52,0,47,112,114,103,110,55,47,53,0,47,112,114,103,110,55,47,54,0,47,112,114,103,110,55,47,55,0,47,112,114,103,110,56,47,49,0,47,112,114,103,110,56,47,50,0,47,112,114,103,110,56,47,51,0,47,112,114,103,110,56,47,52,0,47,112,114,103,110,56,47,53,0,47,112,114,103,110,56,47,54,0,47,112,114,103,110,56,47,55,0,47,112,114,103,110,56,47,56,0,47,112,114,103,110,57,47,49,0,47,112,114,103,110,57,47,50,0,47,112,114,103,110,57,47,51,0,47,112,114,103,110,57,47,52,0,47,112,114,103,110,57,47,53,0,47,112,114,103,110,57,47,54,0,47,112,114,103,110,57,47,55,0,47,112,114,103,110,57,47,56,0,47,112,114,103,110,57,47,57,0,47,112,117,98,117,51,47,49,0,47,112,117,98,117,51,47,50,0,47,112,117,98,117,51,47,51,0,47,112,117,98,117,52,47,49,0,47,112,117,98,117,52,47,50,0,47,112,117,98,117,52,47,51,0,47,112,117,98,117,52,47,52,0,47,112,117,98,117,53,47,49,0,47,112,117,98,117,53,47,50,0,47,112,117,98,117,53,47,51,0,47,112,117,98,117,53,47,52,0,47,112,117,98,117,53,47,53,0,47,112,117,98,117,54,47,49,0,47,112,117,98,117,54,47,50,0,47,112,117,98,117,54,47,51,0,47,112,117,98,117,54,47,52,0,47,112,117,98,117,54,47,53,0,47,112,117,98,117,54,47,54,0,47,112,117,98,117,55,47,49,0,47,112,117,98,117,55,47,50,0,47,112,117,98,117,55,47,51,0,47,112,117,98,117,55,47,52,0,47,112,117,98,117,55,47,53,0,47,112,117,98,117,55,47,54,0,47,112,117,98,117,55,47,55,0,47,112,117,98,117,56,47,49,0,47,112,117,98,117,56,47,50,0,47,112,117,98,117,56,47,51,0,47,112,117,98,117,56,47,52,0,47,112,117,98,117,56,47,53,0,47,112,117,98,117,56,47,54,0,47,112,117,98,117,56,47,55,0,47,112,117,98,117,56,47,56,0,47,112,117,98,117,57,47,49,0,47,112,117,98,117,57,47,50,0,47,112,117,98,117,57,47,51,0,47,112,117,98,117,57,47,52,0,47,112,117,98,117,57,47,53,0,47,112,117,98,117,57,47,54,0,47,112,117,98,117,57,47,55,0,47,112,117,98,117,57,47,56,0,47,112,117,98,117,57,47,57,0,47,112,117,98,117,103,110,51,47,49,0,47,112,117,98,117,103,110,51,47,50,0,47,112,117,98,117,103,110,51,47,51,0,47,112,117,98,117,103,110,52,47,49,0,47,112,117,98,117,103,110,52,47,50,0,47,112,117,98,117,103,110,52,47,51,0,47,112,117,98,117,103,110,52,47,52,0,47,112,117,98,117,103,110,53,47,49,0,47,112,117,98,117,103,110,53,47,50,0,47,112,117,98,117,103,110,53,47,51,0,47,112,117,98,117,103,110,53,47,52,0,47,112,117,98,117,103,110,53,47,53,0,47,112,117,98,117,103,110,54,47,49,0,47,112,117,98,117,103,110,54,47,50,0,47,112,117,98,117,103,110,54,47,51,0,47,112,117,98,117,103,110,54,47,52,0,47,112,117,98,117,103,110,54,47,53,0,47,112,117,98,117,103,110,54,47,54,0,47,112,117,98,117,103,110,55,47,49,0,47,112,117,98,117,103,110,55,47,50,0,47,112,117,98,117,103,110,55,47,51,0,47,112,117,98,117,103,110,55,47,52,0,47,112,117,98,117,103,110,55,47,53,0,47,112,117,98,117,103,110,55,47,54,0,47,112,117,98,117,103,110,55,47,55,0,47,112,117,98,117,103,110,56,47,49,0,47,112,117,98,117,103,110,56,47,50,0,47,112,117,98,117,103,110,56,47,51,0,47,112,117,98,117,103,110,56,47,52,0,47,112,117,98,117,103,110,56,47,53,0,47,112,117,98,117,103,110,56,47,54,0,47,112,117,98,117,103,110,56,47,55,0,47,112,117,98,117,103,110,56,47,56,0,47,112,117,98,117,103,110,57,47,49,0,47,112,117,98,117,103,110,57,47,50,0,47,112,117,98,117,103,110,57,47,51,0,47,112,117,98,117,103,110,57,47,52,0,47,112,117,98,117,103,110,57,47,53,0,47,112,117,98,117,103,110,57,47,54,0,47,112,117,98,117,103,110,57,47,55,0,47,112,117,98,117,103,110,57,47,56,0,47,112,117,98,117,103,110,57,47,57,0,47,112,117,111,114,49,48,47,49,0,47,112,117,111,114,49,48,47,49,48,0,47,112,117,111,114,49,48,47,50,0,47,112,117,111,114,49,48,47,51,0,47,112,117,111,114,49,48,47,52,0,47,112,117,111,114,49,48,47,53,0,47,112,117,111,114,49,48,47,54,0,47,112,117,111,114,49,48,47,55,0,47,112,117,111,114,49,48,47,56,0,47,112,117,111,114,49,48,47,57,0,47,112,117,111,114,49,49,47,49,0,47,112,117,111,114,49,49,47,49,48,0,47,112,117,111,114,49,49,47,49,49,0,47,112,117,111,114,49,49,47,50,0,47,112,117,111,114,49,49,47,51,0,47,112,117,111,114,49,49,47,52,0,47,112,117,111,114,49,49,47,53,0,47,112,117,111,114,49,49,47,54,0,47,112,117,111,114,49,49,47,55,0,47,112,117,111,114,49,49,47,56,0,47,112,117,111,114,49,49,47,57,0,47,112,117,111,114,51,47,49,0,47,112,117,111,114,51,47,50,0,47,112,117,111,114,51,47,51,0,47,112,117,111,114,52,47,49,0,47,112,117,111,114,52,47,50,0,47,112,117,111,114,52,47,51,0,47,112,117,111,114,52,47,52,0,47,112,117,111,114,53,47,49,0,47,112,117,111,114,53,47,50,0,47,112,117,111,114,53,47,51,0,47,112,117,111,114,53,47,52,0,47,112,117,111,114,53,47,53,0,47,112,117,111,114,54,47,49,0,47,112,117,111,114,54,47,50,0,47,112,117,111,114,54,47,51,0,47,112,117,111,114,54,47,52,0,47,112,117,111,114,54,47,53,0,47,112,117,111,114,54,47,54,0,47,112,117,111,114,55,47,49,0,47,112,117,111,114,55,47,50,0,47,112,117,111,114,55,47,51,0,47,112,117,111,114,55,47,52,0,47,112,117,111,114,55,47,53,0,47,112,117,111,114,55,47,54,0,47,112,117,111,114,55,47,55,0,47,112,117,111,114,56,47,49,0,47,112,117,111,114,56,47,50,0,47,112,117,111,114,56,47,51,0,47,112,117,111,114,56,47,52,0,47,112,117,111,114,56,47,53,0,47,112,117,111,114,56,47,54,0,47,112,117,111,114,56,47,55,0,47,112,117,111,114,56,47,56,0,47,112,117,111,114,57,47,49,0,47,112,117,111,114,57,47,50,0,47,112,117,111,114,57,47,51,0,47,112,117,111,114,57,47,52,0,47,112,117,111,114,57,47,53,0,47,112,117,111,114,57,47,54,0,47,112,117,111,114,57,47,55,0,47,112,117,111,114,57,47,56,0,47,112,117,111,114,57,47,57,0,47,112,117,114,100,51,47,49,0,47,112,117,114,100,51,47,50,0,47,112,117,114,100,51,47,51,0,47,112,117,114,100,52,47,49,0,47,112,117,114,100,52,47,50,0,47,112,117,114,100,52,47,51,0,47,112,117,114,100,52,47,52,0,47,112,117,114,100,53,47,49,0,47,112,117,114,100,53,47,50,0,47,112,117,114,100,53,47,51,0,47,112,117,114,100,53,47,52,0,47,112,117,114,100,53,47,53,0,47,112,117,114,100,54,47,49,0,47,112,117,114,100,54,47,50,0,47,112,117,114,100,54,47,51,0,47,112,117,114,100,54,47,52,0,47,112,117,114,100,54,47,53,0,47,112,117,114,100,54,47,54,0,47,112,117,114,100,55,47,49,0,47,112,117,114,100,55,47,50,0,47,112,117,114,100,55,47,51,0,47,112,117,114,100,55,47,52,0,47,112,117,114,100,55,47,53,0,47,112,117,114,100,55,47,54,0,47,112,117,114,100,55,47,55,0,47,112,117,114,100,56,47,49,0,47,112,117,114,100,56,47,50,0,47,112,117,114,100,56,47,51,0,47,112,117,114,100,56,47,52,0,47,112,117,114,100,56,47,53,0,47,112,117,114,100,56,47,54,0,47,112,117,114,100,56,47,55,0,47,112,117,114,100,56,47,56,0,47,112,117,114,100,57,47,49,0,47,112,117,114,100,57,47,50,0,47,112,117,114,100,57,47,51,0,47,112,117,114,100,57,47,52,0,47,112,117,114,100,57,47,53,0,47,112,117,114,100,57,47,54,0,47,112,117,114,100,57,47,55,0,47,112,117,114,100,57,47,56,0,47,112,117,114,100,57,47,57,0,47,112,117,114,112,108,101,115,51,47,49,0,47,112,117,114,112,108,101,115,51,47,50,0,47,112,117,114,112,108,101,115,51,47,51,0,47,112,117,114,112,108,101,115,52,47,49,0,47,112,117,114,112,108,101,115,52,47,50,0,47,112,117,114,112,108,101,115,52,47,51,0,47,112,117,114,112,108,101,115,52,47,52,0,47,112,117,114,112,108,101,115,53,47,49,0,47,112,117,114,112,108,101,115,53,47,50,0,47,112,117,114,112,108,101,115,53,47,51,0,47,112,117,114,112,108,101,115,53,47,52,0,47,112,117,114,112,108,101,115,53,47,53,0,47,112,117,114,112,108,101,115,54,47,49,0,47,112,117,114,112,108,101,115,54,47,50,0,47,112,117,114,112,108,101,115,54,47,51,0,47,112,117,114,112,108,101,115,54,47,52,0,47,112,117,114,112,108,101,115,54,47,53,0,47,112,117,114,112,108,101,115,54,47,54,0,47,112,117,114,112,108,101,115,55,47,49,0,47,112,117,114,112,108,101,115,55,47,50,0,47,112,117,114,112,108,101,115,55,47,51,0,47,112,117,114,112,108,101,115,55,47,52,0,47,112,117,114,112,108,101,115,55,47,53,0,47,112,117,114,112,108,101,115,55,47,54,0,47,112,117,114,112,108,101,115,55,47,55,0,47,112,117,114,112,108,101,115,56,47,49,0,47,112,117,114,112,108,101,115,56,47,50,0,47,112,117,114,112,108,101,115,56,47,51,0,47,112,117,114,112,108,101,115,56,47,52,0,47,112,117,114,112,108,101,115,56,47,53,0,47,112,117,114,112,108,101,115,56,47,54,0,47,112,117,114,112,108,101,115,56,47,55,0,47,112,117,114,112,108,101,115,56,47,56,0,47,112,117,114,112,108,101,115,57,47,49,0,47,112,117,114,112,108,101,115,57,47,50,0,47,112,117,114,112,108,101,115,57,47,51,0,47,112,117,114,112,108,101,115,57,47,52,0,47,112,117,114,112,108,101,115,57,47,53,0,47,112,117,114,112,108,101,115,57,47,54,0,47,112,117,114,112,108,101,115,57,47,55,0,47,112,117,114,112,108,101,115,57,47,56,0,47,112,117,114,112,108,101,115,57,47,57,0,47,114,100,98,117,49,48,47,49,0,47,114,100,98,117,49,48,47,49,48,0,47,114,100,98,117,49,48,47,50,0,47,114,100,98,117,49,48,47,51,0,47,114,100,98,117,49,48,47,52,0,47,114,100,98,117,49,48,47,53,0,47,114,100,98,117,49,48,47,54,0,47,114,100,98,117,49,48,47,55,0,47,114,100,98,117,49,48,47,56,0,47,114,100,98,117,49,48,47,57,0,47,114,100,98,117,49,49,47,49,0,47,114,100,98,117,49,49,47,49,48,0,47,114,100,98,117,49,49,47,49,49,0,47,114,100,98,117,49,49,47,50,0,47,114,100,98,117,49,49,47,51,0,47,114,100,98,117,49,49,47,52,0,47,114,100,98,117,49,49,47,53,0,47,114,100,98,117,49,49,47,54,0,47,114,100,98,117,49,49,47,55,0,47,114,100,98,117,49,49,47,56,0,47,114,100,98,117,49,49,47,57,0,47,114,100,98,117,51,47,49,0,47,114,100,98,117,51,47,50,0,47,114,100,98,117,51,47,51,0,47,114,100,98,117,52,47,49,0,47,114,100,98,117,52,47,50,0,47,114,100,98,117,52,47,51,0,47,114,100,98,117,52,47,52,0,47,114,100,98,117,53,47,49,0,47,114,100,98,117,53,47,50,0,47,114,100,98,117,53,47,51,0,47,114,100,98,117,53,47,52,0,47,114,100,98,117,53,47,53,0,47,114,100,98,117,54,47,49,0,47,114,100,98,117,54,47,50,0,47,114,100,98,117,54,47,51,0,47,114,100,98,117,54,47,52,0,47,114,100,98,117,54,47,53,0,47,114,100,98,117,54,47,54,0,47,114,100,98,117,55,47,49,0,47,114,100,98,117,55,47,50,0,47,114,100,98,117,55,47,51,0,47,114,100,98,117,55,47,52,0,47,114,100,98,117,55,47,53,0,47,114,100,98,117,55,47,54,0,47,114,100,98,117,55,47,55,0,47,114,100,98,117,56,47,49,0,47,114,100,98,117,56,47,50,0,47,114,100,98,117,56,47,51,0,47,114,100,98,117,56,47,52,0,47,114,100,98,117,56,47,53,0,47,114,100,98,117,56,47,54,0,47,114,100,98,117,56,47,55,0,47,114,100,98,117,56,47,56,0,47,114,100,98,117,57,47,49,0,47,114,100,98,117,57,47,50,0,47,114,100,98,117,57,47,51,0,47,114,100,98,117,57,47,52,0,47,114,100,98,117,57,47,53,0,47,114,100,98,117,57,47,54,0,47,114,100,98,117,57,47,55,0,47,114,100,98,117,57,47,56,0,47,114,100,98,117,57,47,57,0,47,114,100,103,121,49,48,47,49,0,47,114,100,103,121,49,48,47,49,48,0,47,114,100,103,121,49,48,47,50,0,47,114,100,103,121,49,48,47,51,0,47,114,100,103,121,49,48,47,52,0,47,114,100,103,121,49,48,47,53,0,47,114,100,103,121,49,48,47,54,0,47,114,100,103,121,49,48,47,55,0,47,114,100,103,121,49,48,47,56,0,47,114,100,103,121,49,48,47,57,0,47,114,100,103,121,49,49,47,49,0,47,114,100,103,121,49,49,47,49,48,0,47,114,100,103,121,49,49,47,49,49,0,47,114,100,103,121,49,49,47,50,0,47,114,100,103,121,49,49,47,51,0,47,114,100,103,121,49,49,47,52,0,47,114,100,103,121,49,49,47,53,0,47,114,100,103,121,49,49,47,54,0,47,114,100,103,121,49,49,47,55,0,47,114,100,103,121,49,49,47,56,0,47,114,100,103,121,49,49,47,57,0,47,114,100,103,121,51,47,49,0,47,114,100,103,121,51,47,50,0,47,114,100,103,121,51,47,51,0,47,114,100,103,121,52,47,49,0,47,114,100,103,121,52,47,50,0,47,114,100,103,121,52,47,51,0,47,114,100,103,121,52,47,52,0,47,114,100,103,121,53,47,49,0,47,114,100,103,121,53,47,50,0,47,114,100,103,121,53,47,51,0,47,114,100,103,121,53,47,52,0,47,114,100,103,121,53,47,53,0,47,114,100,103,121,54,47,49,0,47,114,100,103,121,54,47,50,0,47,114,100,103,121,54,47,51,0,47,114,100,103,121,54,47,52,0,47,114,100,103,121,54,47,53,0,47,114,100,103,121,54,47,54,0,47,114,100,103,121,55,47,49,0,47,114,100,103,121,55,47,50,0,47,114,100,103,121,55,47,51,0,47,114,100,103,121,55,47,52,0,47,114,100,103,121,55,47,53,0,47,114,100,103,121,55,47,54,0,47,114,100,103,121,55,47,55,0,47,114,100,103,121,56,47,49,0,47,114,100,103,121,56,47,50,0,47,114,100,103,121,56,47,51,0,47,114,100,103,121,56,47,52,0,47,114,100,103,121,56,47,53,0,47,114,100,103,121,56,47,54,0,47,114,100,103,121,56,47,55,0,47,114,100,103,121,56,47,56,0,47,114,100,103,121,57,47,49,0,47,114,100,103,121,57,47,50,0,47,114,100,103,121,57,47,51,0,47,114,100,103,121,57,47,52,0,47,114,100,103,121,57,47,53,0,47,114,100,103,121,57,47,54,0,47,114,100,103,121,57,47,55,0,47,114,100,103,121,57,47,56,0,47,114,100,103,121,57,47,57,0,47,114,100,112,117,51,47,49,0,47,114,100,112,117,51,47,50,0,47,114,100,112,117,51,47,51,0,47,114,100,112,117,52,47,49,0,47,114,100,112,117,52,47,50,0,47,114,100,112,117,52,47,51,0,47,114,100,112,117,52,47,52,0,47,114,100,112,117,53,47,49,0,47,114,100,112,117,53,47,50,0,47,114,100,112,117,53,47,51,0,47,114,100,112,117,53,47,52,0,47,114,100,112,117,53,47,53,0,47,114,100,112,117,54,47,49,0,47,114,100,112,117,54,47,50,0,47,114,100,112,117,54,47,51,0,47,114,100,112,117,54,47,52,0,47,114,100,112,117,54,47,53,0,47,114,100,112,117,54,47,54,0,47,114,100,112,117,55,47,49,0,47,114,100,112,117,55,47,50,0,47,114,100,112,117,55,47,51,0,47,114,100,112,117,55,47,52,0,47,114,100,112,117,55,47,53,0,47,114,100,112,117,55,47,54,0,47,114,100,112,117,55,47,55,0,47,114,100,112,117,56,47,49,0,47,114,100,112,117,56,47,50,0,47,114,100,112,117,56,47,51,0,47,114,100,112,117,56,47,52,0,47,114,100,112,117,56,47,53,0,47,114,100,112,117,56,47,54,0,47,114,100,112,117,56,47,55,0,47,114,100,112,117,56,47,56,0,47,114,100,112,117,57,47,49,0,47,114,100,112,117,57,47,50,0,47,114,100,112,117,57,47,51,0,47,114,100,112,117,57,47,52,0,47,114,100,112,117,57,47,53,0,47,114,100,112,117,57,47,54,0,47,114,100,112,117,57,47,55,0,47,114,100,112,117,57,47,56,0,47,114,100,112,117,57,47,57,0,47,114,100,121,108,98,117,49,48,47,49,0,47,114,100,121,108,98,117,49,48,47,49,48,0,47,114,100,121,108,98,117,49,48,47,50,0,47,114,100,121,108,98,117,49,48,47,51,0,47,114,100,121,108,98,117,49,48,47,52,0,47,114,100,121,108,98,117,49,48,47,53,0,47,114,100,121,108,98,117,49,48,47,54,0,47,114,100,121,108,98,117,49,48,47,55,0,47,114,100,121,108,98,117,49,48,47,56,0,47,114,100,121,108,98,117,49,48,47,57,0,47,114,100,121,108,98,117,49,49,47,49,0,47,114,100,121,108,98,117,49,49,47,49,48,0,47,114,100,121,108,98,117,49,49,47,49,49,0,47,114,100,121,108,98,117,49,49,47,50,0,47,114,100,121,108,98,117,49,49,47,51,0,47,114,100,121,108,98,117,49,49,47,52,0,47,114,100,121,108,98,117,49,49,47,53,0,47,114,100,121,108,98,117,49,49,47,54,0,47,114,100,121,108,98,117,49,49,47,55,0,47,114,100,121,108,98,117,49,49,47,56,0,47,114,100,121,108,98,117,49,49,47,57,0,47,114,100,121,108,98,117,51,47,49,0,47,114,100,121,108,98,117,51,47,50,0,47,114,100,121,108,98,117,51,47,51,0,47,114,100,121,108,98,117,52,47,49,0,47,114,100,121,108,98,117,52,47,50,0,47,114,100,121,108,98,117,52,47,51,0,47,114,100,121,108,98,117,52,47,52,0,47,114,100,121,108,98,117,53,47,49,0,47,114,100,121,108,98,117,53,47,50,0,47,114,100,121,108,98,117,53,47,51,0,47,114,100,121,108,98,117,53,47,52,0,47,114,100,121,108,98,117,53,47,53,0,47,114,100,121,108,98,117,54,47,49,0,47,114,100,121,108,98,117,54,47,50,0,47,114,100,121,108,98,117,54,47,51,0,47,114,100,121,108,98,117,54,47,52,0,47,114,100,121,108,98,117,54,47,53,0,47,114,100,121,108,98,117,54,47,54,0,47,114,100,121,108,98,117,55,47,49,0,47,114,100,121,108,98,117,55,47,50,0,47,114,100,121,108,98,117,55,47,51,0,47,114,100,121,108,98,117,55,47,52,0,47,114,100,121,108,98,117,55,47,53,0,47,114,100,121,108,98,117,55,47,54,0,47,114,100,121,108,98,117,55,47,55,0,47,114,100,121,108,98,117,56,47,49,0,47,114,100,121,108,98,117,56,47,50,0,47,114,100,121,108,98,117,56,47,51,0,47,114,100,121,108,98,117,56,47,52,0,47,114,100,121,108,98,117,56,47,53,0,47,114,100,121,108,98,117,56,47,54,0,47,114,100,121,108,98,117,56,47,55,0,47,114,100,121,108,98,117,56,47,56,0,47,114,100,121,108,98,117,57,47,49,0,47,114,100,121,108,98,117,57,47,50,0,47,114,100,121,108,98,117,57,47,51,0,47,114,100,121,108,98,117,57,47,52,0,47,114,100,121,108,98,117,57,47,53,0,47,114,100,121,108,98,117,57,47,54,0,47,114,100,121,108,98,117,57,47,55,0,47,114,100,121,108,98,117,57,47,56,0,47,114,100,121,108,98,117,57,47,57,0,47,114,100,121,108,103,110,49,48,47,49,0,47,114,100,121,108,103,110,49,48,47,49,48,0,47,114,100,121,108,103,110,49,48,47,50,0,47,114,100,121,108,103,110,49,48,47,51,0,47,114,100,121,108,103,110,49,48,47,52,0,47,114,100,121,108,103,110,49,48,47,53,0,47,114,100,121,108,103,110,49,48,47,54,0,47,114,100,121,108,103,110,49,48,47,55,0,47,114,100,121,108,103,110,49,48,47,56,0,47,114,100,121,108,103,110,49,48,47,57,0,47,114,100,121,108,103,110,49,49,47,49,0,47,114,100,121,108,103,110,49,49,47,49,48,0,47,114,100,121,108,103,110,49,49,47,49,49,0,47,114,100,121,108,103,110,49,49,47,50,0,47,114,100,121,108,103,110,49,49,47,51,0,47,114,100,121,108,103,110,49,49,47,52,0,47,114,100,121,108,103,110,49,49,47,53,0,47,114,100,121,108,103,110,49,49,47,54,0,47,114,100,121,108,103,110,49,49,47,55,0,47,114,100,121,108,103,110,49,49,47,56,0,47,114,100,121,108,103,110,49,49,47,57,0,47,114,100,121,108,103,110,51,47,49,0,47,114,100,121,108,103,110,51,47,50,0,47,114,100,121,108,103,110,51,47,51,0,47,114,100,121,108,103,110,52,47,49,0,47,114,100,121,108,103,110,52,47,50,0,47,114,100,121,108,103,110,52,47,51,0,47,114,100,121,108,103,110,52,47,52,0,47,114,100,121,108,103,110,53,47,49,0,47,114,100,121,108,103,110,53,47,50,0,47,114,100,121,108,103,110,53,47,51,0,47,114,100,121,108,103,110,53,47,52,0,47,114,100,121,108,103,110,53,47,53,0,47,114,100,121,108,103,110,54,47,49,0,47,114,100,121,108,103,110,54,47,50,0,47,114,100,121,108,103,110,54,47,51,0,47,114,100,121,108,103,110,54,47,52,0,47,114,100,121,108,103,110,54,47,53,0,47,114,100,121,108,103,110,54,47,54,0,47,114,100,121,108,103,110,55,47,49,0,47,114,100,121,108,103,110,55,47,50,0,47,114,100,121,108,103,110,55,47,51,0,47,114,100,121,108,103,110,55,47,52,0,47,114,100,121,108,103,110,55,47,53,0,47,114,100,121,108,103,110,55,47,54,0,47,114,100,121,108,103,110,55,47,55,0,47,114,100,121,108,103,110,56,47,49,0,47,114,100,121,108,103,110,56,47,50,0,47,114,100,121,108,103,110,56,47,51,0,47,114,100,121,108,103,110,56,47,52,0,47,114,100,121,108,103,110,56,47,53,0,47,114,100,121,108,103,110,56,47,54,0,47,114,100,121,108,103,110,56,47,55,0,47,114,100,121,108,103,110,56,47,56,0,47,114,100,121,108,103,110,57,47,49,0,47,114,100,121,108,103,110,57,47,50,0,47,114,100,121,108,103,110,57,47,51,0,47,114,100,121,108,103,110,57,47,52,0,47,114,100,121,108,103,110,57,47,53,0,47,114,100,121,108,103,110,57,47,54,0,47,114,100,121,108,103,110,57,47,55,0,47,114,100,121,108,103,110,57,47,56,0,47,114,100,121,108,103,110,57,47,57,0,47,114,101,100,115,51,47,49,0,47,114,101,100,115,51,47,50,0,47,114,101,100,115,51,47,51,0,47,114,101,100,115,52,47,49,0,47,114,101,100,115,52,47,50,0,47,114,101,100,115,52,47,51,0,47,114,101,100,115,52,47,52,0,47,114,101,100,115,53,47,49,0,47,114,101,100,115,53,47,50,0,47,114,101,100,115,53,47,51,0,47,114,101,100,115,53,47,52,0,47,114,101,100,115,53,47,53,0,47,114,101,100,115,54,47,49,0,47,114,101,100,115,54,47,50,0,47,114,101,100,115,54,47,51,0,47,114,101,100,115,54,47,52,0,47,114,101,100,115,54,47,53,0,47,114,101,100,115,54,47,54,0,47,114,101,100,115,55,47,49,0,47,114,101,100,115,55,47,50,0,47,114,101,100,115,55,47,51,0,47,114,101,100,115,55,47,52,0,47,114,101,100,115,55,47,53,0,47,114,101,100,115,55,47,54,0,47,114,101,100,115,55,47,55,0,47,114,101,100,115,56,47,49,0,47,114,101,100,115,56,47,50,0,47,114,101,100,115,56,47,51,0,47,114,101,100,115,56,47,52,0,47,114,101,100,115,56,47,53,0,47,114,101,100,115,56,47,54,0,47,114,101,100,115,56,47,55,0,47,114,101,100,115,56,47,56,0,47,114,101,100,115,57,47,49,0,47,114,101,100,115,57,47,50,0,47,114,101,100,115,57,47,51,0,47,114,101,100,115,57,47,52,0,47,114,101,100,115,57,47,53,0,47,114,101,100,115,57,47,54,0,47,114,101,100,115,57,47,55,0,47,114,101,100,115,57,47,56,0,47,114,101,100,115,57,47,57,0,47,115,101,116,49,51,47,49,0,47,115,101,116,49,51,47,50,0,47,115,101,116,49,51,47,51,0,47,115,101,116,49,52,47,49,0,47,115,101,116,49,52,47,50,0,47,115,101,116,49,52,47,51,0,47,115,101,116,49,52,47,52,0,47,115,101,116,49,53,47,49,0,47,115,101,116,49,53,47,50,0,47,115,101,116,49,53,47,51,0,47,115,101,116,49,53,47,52,0,47,115,101,116,49,53,47,53,0,47,115,101,116,49,54,47,49,0,47,115,101,116,49,54,47,50,0,47,115,101,116,49,54,47,51,0,47,115,101,116,49,54,47,52,0,47,115,101,116,49,54,47,53,0,47,115,101,116,49,54,47,54,0,47,115,101,116,49,55,47,49,0,47,115,101,116,49,55,47,50,0,47,115,101,116,49,55,47,51,0,47,115,101,116,49,55,47,52,0,47,115,101,116,49,55,47,53,0,47,115,101,116,49,55,47,54,0,47,115,101,116,49,55,47,55,0,47,115,101,116,49,56,47,49,0,47,115,101,116,49,56,47,50,0,47,115,101,116,49,56,47,51,0,47,115,101,116,49,56,47,52,0,47,115,101,116,49,56,47,53,0,47,115,101,116,49,56,47,54,0,47,115,101,116,49,56,47,55,0,47,115,101,116,49,56,47,56,0,47,115,101,116,49,57,47,49,0,47,115,101,116,49,57,47,50,0,47,115,101,116,49,57,47,51,0,47,115,101,116,49,57,47,52,0,47,115,101,116,49,57,47,53,0,47,115,101,116,49,57,47,54,0,47,115,101,116,49,57,47,55,0,47,115,101,116,49,57,47,56,0,47,115,101,116,49,57,47,57,0,47,115,101,116,50,51,47,49,0,47,115,101,116,50,51,47,50,0,47,115,101,116,50,51,47,51,0,47,115,101,116,50,52,47,49,0,47,115,101,116,50,52,47,50,0,47,115,101,116,50,52,47,51,0,47,115,101,116,50,52,47,52,0,47,115,101,116,50,53,47,49,0,47,115,101,116,50,53,47,50,0,47,115,101,116,50,53,47,51,0,47,115,101,116,50,53,47,52,0,47,115,101,116,50,53,47,53,0,47,115,101,116,50,54,47,49,0,47,115,101,116,50,54,47,50,0,47,115,101,116,50,54,47,51,0,47,115,101,116,50,54,47,52,0,47,115,101,116,50,54,47,53,0,47,115,101,116,50,54,47,54,0,47,115,101,116,50,55,47,49,0,47,115,101,116,50,55,47,50,0,47,115,101,116,50,55,47,51,0,47,115,101,116,50,55,47,52,0,47,115,101,116,50,55,47,53,0,47,115,101,116,50,55,47,54,0,47,115,101,116,50,55,47,55,0,47,115,101,116,50,56,47,49,0,47,115,101,116,50,56,47,50,0,47,115,101,116,50,56,47,51,0,47,115,101,116,50,56,47,52,0,47,115,101,116,50,56,47,53,0,47,115,101,116,50,56,47,54,0,47,115,101,116,50,56,47,55,0,47,115,101,116,50,56,47,56,0,47,115,101,116,51,49,48,47,49,0,47,115,101,116,51,49,48,47,49,48,0,47,115,101,116,51,49,48,47,50,0,47,115,101,116,51,49,48,47,51,0,47,115,101,116,51,49,48,47,52,0,47,115,101,116,51,49,48,47,53,0,47,115,101,116,51,49,48,47,54,0,47,115,101,116,51,49,48,47,55,0,47,115,101,116,51,49,48,47,56,0,47,115,101,116,51,49,48,47,57,0,47,115,101,116,51,49,49,47,49,0,47,115,101,116,51,49,49,47,49,48,0,47,115,101,116,51,49,49,47,49,49,0,47,115,101,116,51,49,49],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+153182);allocate([47,50,0,47,115,101,116,51,49,49,47,51,0,47,115,101,116,51,49,49,47,52,0,47,115,101,116,51,49,49,47,53,0,47,115,101,116,51,49,49,47,54,0,47,115,101,116,51,49,49,47,55,0,47,115,101,116,51,49,49,47,56,0,47,115,101,116,51,49,49,47,57,0,47,115,101,116,51,49,50,47,49,0,47,115,101,116,51,49,50,47,49,48,0,47,115,101,116,51,49,50,47,49,49,0,47,115,101,116,51,49,50,47,49,50,0,47,115,101,116,51,49,50,47,50,0,47,115,101,116,51,49,50,47,51,0,47,115,101,116,51,49,50,47,52,0,47,115,101,116,51,49,50,47,53,0,47,115,101,116,51,49,50,47,54,0,47,115,101,116,51,49,50,47,55,0,47,115,101,116,51,49,50,47,56,0,47,115,101,116,51,49,50,47,57,0,47,115,101,116,51,51,47,49,0,47,115,101,116,51,51,47,50,0,47,115,101,116,51,51,47,51,0,47,115,101,116,51,52,47,49,0,47,115,101,116,51,52,47,50,0,47,115,101,116,51,52,47,51,0,47,115,101,116,51,52,47,52,0,47,115,101,116,51,53,47,49,0,47,115,101,116,51,53,47,50,0,47,115,101,116,51,53,47,51,0,47,115,101,116,51,53,47,52,0,47,115,101,116,51,53,47,53,0,47,115,101,116,51,54,47,49,0,47,115,101,116,51,54,47,50,0,47,115,101,116,51,54,47,51,0,47,115,101,116,51,54,47,52,0,47,115,101,116,51,54,47,53,0,47,115,101,116,51,54,47,54,0,47,115,101,116,51,55,47,49,0,47,115,101,116,51,55,47,50,0,47,115,101,116,51,55,47,51,0,47,115,101,116,51,55,47,52,0,47,115,101,116,51,55,47,53,0,47,115,101,116,51,55,47,54,0,47,115,101,116,51,55,47,55,0,47,115,101,116,51,56,47,49,0,47,115,101,116,51,56,47,50,0,47,115,101,116,51,56,47,51,0,47,115,101,116,51,56,47,52,0,47,115,101,116,51,56,47,53,0,47,115,101,116,51,56,47,54,0,47,115,101,116,51,56,47,55,0,47,115,101,116,51,56,47,56,0,47,115,101,116,51,57,47,49,0,47,115,101,116,51,57,47,50,0,47,115,101,116,51,57,47,51,0,47,115,101,116,51,57,47,52,0,47,115,101,116,51,57,47,53,0,47,115,101,116,51,57,47,54,0,47,115,101,116,51,57,47,55,0,47,115,101,116,51,57,47,56,0,47,115,101,116,51,57,47,57,0,47,115,112,101,99,116,114,97,108,49,48,47,49,0,47,115,112,101,99,116,114,97,108,49,48,47,49,48,0,47,115,112,101,99,116,114,97,108,49,48,47,50,0,47,115,112,101,99,116,114,97,108,49,48,47,51,0,47,115,112,101,99,116,114,97,108,49,48,47,52,0,47,115,112,101,99,116,114,97,108,49,48,47,53,0,47,115,112,101,99,116,114,97,108,49,48,47,54,0,47,115,112,101,99,116,114,97,108,49,48,47,55,0,47,115,112,101,99,116,114,97,108,49,48,47,56,0,47,115,112,101,99,116,114,97,108,49,48,47,57,0,47,115,112,101,99,116,114,97,108,49,49,47,49,0,47,115,112,101,99,116,114,97,108,49,49,47,49,48,0,47,115,112,101,99,116,114,97,108,49,49,47,49,49,0,47,115,112,101,99,116,114,97,108,49,49,47,50,0,47,115,112,101,99,116,114,97,108,49,49,47,51,0,47,115,112,101,99,116,114,97,108,49,49,47,52,0,47,115,112,101,99,116,114,97,108,49,49,47,53,0,47,115,112,101,99,116,114,97,108,49,49,47,54,0,47,115,112,101,99,116,114,97,108,49,49,47,55,0,47,115,112,101,99,116,114,97,108,49,49,47,56,0,47,115,112,101,99,116,114,97,108,49,49,47,57,0,47,115,112,101,99,116,114,97,108,51,47,49,0,47,115,112,101,99,116,114,97,108,51,47,50,0,47,115,112,101,99,116,114,97,108,51,47,51,0,47,115,112,101,99,116,114,97,108,52,47,49,0,47,115,112,101,99,116,114,97,108,52,47,50,0,47,115,112,101,99,116,114,97,108,52,47,51,0,47,115,112,101,99,116,114,97,108,52,47,52,0,47,115,112,101,99,116,114,97,108,53,47,49,0,47,115,112,101,99,116,114,97,108,53,47,50,0,47,115,112,101,99,116,114,97,108,53,47,51,0,47,115,112,101,99,116,114,97,108,53,47,52,0,47,115,112,101,99,116,114,97,108,53,47,53,0,47,115,112,101,99,116,114,97,108,54,47,49,0,47,115,112,101,99,116,114,97,108,54,47,50,0,47,115,112,101,99,116,114,97,108,54,47,51,0,47,115,112,101,99,116,114,97,108,54,47,52,0,47,115,112,101,99,116,114,97,108,54,47,53,0,47,115,112,101,99,116,114,97,108,54,47,54,0,47,115,112,101,99,116,114,97,108,55,47,49,0,47,115,112,101,99,116,114,97,108,55,47,50,0,47,115,112,101,99,116,114,97,108,55,47,51,0,47,115,112,101,99,116,114,97,108,55,47,52,0,47,115,112,101,99,116,114,97,108,55,47,53,0,47,115,112,101,99,116,114,97,108,55,47,54,0,47,115,112,101,99,116,114,97,108,55,47,55,0,47,115,112,101,99,116,114,97,108,56,47,49,0,47,115,112,101,99,116,114,97,108,56,47,50,0,47,115,112,101,99,116,114,97,108,56,47,51,0,47,115,112,101,99,116,114,97,108,56,47,52,0,47,115,112,101,99,116,114,97,108,56,47,53,0,47,115,112,101,99,116,114,97,108,56,47,54,0,47,115,112,101,99,116,114,97,108,56,47,55,0,47,115,112,101,99,116,114,97,108,56,47,56,0,47,115,112,101,99,116,114,97,108,57,47,49,0,47,115,112,101,99,116,114,97,108,57,47,50,0,47,115,112,101,99,116,114,97,108,57,47,51,0,47,115,112,101,99,116,114,97,108,57,47,52,0,47,115,112,101,99,116,114,97,108,57,47,53,0,47,115,112,101,99,116,114,97,108,57,47,54,0,47,115,112,101,99,116,114,97,108,57,47,55,0,47,115,112,101,99,116,114,97,108,57,47,56,0,47,115,112,101,99,116,114,97,108,57,47,57,0,47,115,118,103,47,97,108,105,99,101,98,108,117,101,0,47,115,118,103,47,97,110,116,105,113,117,101,119,104,105,116,101,0,47,115,118,103,47,97,113,117,97,0,47,115,118,103,47,97,113,117,97,109,97,114,105,110,101,0,47,115,118,103,47,97,122,117,114,101,0,47,115,118,103,47,98,101,105,103,101,0,47,115,118,103,47,98,105,115,113,117,101,0,47,115,118,103,47,98,108,97,99,107,0,47,115,118,103,47,98,108,97,110,99,104,101,100,97,108,109,111,110,100,0,47,115,118,103,47,98,108,117,101,0,47,115,118,103,47,98,108,117,101,118,105,111,108,101,116,0,47,115,118,103,47,98,114,111,119,110,0,47,115,118,103,47,98,117,114,108,121,119,111,111,100,0,47,115,118,103,47,99,97,100,101,116,98,108,117,101,0,47,115,118,103,47,99,104,97,114,116,114,101,117,115,101,0,47,115,118,103,47,99,104,111,99,111,108,97,116,101,0,47,115,118,103,47,99,111,114,97,108,0,47,115,118,103,47,99,111,114,110,102,108,111,119,101,114,98,108,117,101,0,47,115,118,103,47,99,111,114,110,115,105,108,107,0,47,115,118,103,47,99,114,105,109,115,111,110,0,47,115,118,103,47,99,121,97,110,0,47,115,118,103,47,100,97,114,107,98,108,117,101,0,47,115,118,103,47,100,97,114,107,99,121,97,110,0,47,115,118,103,47,100,97,114,107,103,111,108,100,101,110,114,111,100,0,47,115,118,103,47,100,97,114,107,103,114,97,121,0,47,115,118,103,47,100,97,114,107,103,114,101,101,110,0,47,115,118,103,47,100,97,114,107,103,114,101,121,0,47,115,118,103,47,100,97,114,107,107,104,97,107,105,0,47,115,118,103,47,100,97,114,107,109,97,103,101,110,116,97,0,47,115,118,103,47,100,97,114,107,111,108,105,118,101,103,114,101,101,110,0,47,115,118,103,47,100,97,114,107,111,114,97,110,103,101,0,47,115,118,103,47,100,97,114,107,111,114,99,104,105,100,0,47,115,118,103,47,100,97,114,107,114,101,100,0,47,115,118,103,47,100,97,114,107,115,97,108,109,111,110,0,47,115,118,103,47,100,97,114,107,115,101,97,103,114,101,101,110,0,47,115,118,103,47,100,97,114,107,115,108,97,116,101,98,108,117,101,0,47,115,118,103,47,100,97,114,107,115,108,97,116,101,103,114,97,121,0,47,115,118,103,47,100,97,114,107,115,108,97,116,101,103,114,101,121,0,47,115,118,103,47,100,97,114,107,116,117,114,113,117,111,105,115,101,0,47,115,118,103,47,100,97,114,107,118,105,111,108,101,116,0,47,115,118,103,47,100,101,101,112,112,105,110,107,0,47,115,118,103,47,100,101,101,112,115,107,121,98,108,117,101,0,47,115,118,103,47,100,105,109,103,114,97,121,0,47,115,118,103,47,100,105,109,103,114,101,121,0,47,115,118,103,47,100,111,100,103,101,114,98,108,117,101,0,47,115,118,103,47,102,105,114,101,98,114,105,99,107,0,47,115,118,103,47,102,108,111,114,97,108,119,104,105,116,101,0,47,115,118,103,47,102,111,114,101,115,116,103,114,101,101,110,0,47,115,118,103,47,102,117,99,104,115,105,97,0,47,115,118,103,47,103,97,105,110,115,98,111,114,111,0,47,115,118,103,47,103,104,111,115,116,119,104,105,116,101,0,47,115,118,103,47,103,111,108,100,0,47,115,118,103,47,103,111,108,100,101,110,114,111,100,0,47,115,118,103,47,103,114,97,121,0,47,115,118,103,47,103,114,101,101,110,0,47,115,118,103,47,103,114,101,101,110,121,101,108,108,111,119,0,47,115,118,103,47,103,114,101,121,0,47,115,118,103,47,104,111,110,101,121,100,101,119,0,47,115,118,103,47,104,111,116,112,105,110,107,0,47,115,118,103,47,105,110,100,105,97,110,114,101,100,0,47,115,118,103,47,105,110,100,105,103,111,0,47,115,118,103,47,105,118,111,114,121,0,47,115,118,103,47,107,104,97,107,105,0,47,115,118,103,47,108,97,118,101,110,100,101,114,0,47,115,118,103,47,108,97,118,101,110,100,101,114,98,108,117,115,104,0,47,115,118,103,47,108,97,119,110,103,114,101,101,110,0,47,115,118,103,47,108,101,109,111,110,99,104,105,102,102,111,110,0,47,115,118,103,47,108,105,103,104,116,98,108,117,101,0,47,115,118,103,47,108,105,103,104,116,99,111,114,97,108,0,47,115,118,103,47,108,105,103,104,116,99,121,97,110,0,47,115,118,103,47,108,105,103,104,116,103,111,108,100,101,110,114,111,100,121,101,108,108,111,119,0,47,115,118,103,47,108,105,103,104,116,103,114,97,121,0,47,115,118,103,47,108,105,103,104,116,103,114,101,101,110,0,47,115,118,103,47,108,105,103,104,116,103,114,101,121,0,47,115,118,103,47,108,105,103,104,116,112,105,110,107,0,47,115,118,103,47,108,105,103,104,116,115,97,108,109,111,110,0,47,115,118,103,47,108,105,103,104,116,115,101,97,103,114,101,101,110,0,47,115,118,103,47,108,105,103,104,116,115,107,121,98,108,117,101,0,47,115,118,103,47,108,105,103,104,116,115,108,97,116,101,103,114,97,121,0,47,115,118,103,47,108,105,103,104,116,115,108,97,116,101,103,114,101,121,0,47,115,118,103,47,108,105,103,104,116,115,116,101,101,108,98,108,117,101,0,47,115,118,103,47,108,105,103,104,116,121,101,108,108,111,119,0,47,115,118,103,47,108,105,109,101,0,47,115,118,103,47,108,105,109,101,103,114,101,101,110,0,47,115,118,103,47,108,105,110,101,110,0,47,115,118,103,47,109,97,103,101,110,116,97,0,47,115,118,103,47,109,97,114,111,111,110,0,47,115,118,103,47,109,101,100,105,117,109,97,113,117,97,109,97,114,105,110,101,0,47,115,118,103,47,109,101,100,105,117,109,98,108,117,101,0,47,115,118,103,47,109,101,100,105,117,109,111,114,99,104,105,100,0,47,115,118,103,47,109,101,100,105,117,109,112,117,114,112,108,101,0,47,115,118,103,47,109,101,100,105,117,109,115,101,97,103,114,101,101,110,0,47,115,118,103,47,109,101,100,105,117,109,115,108,97,116,101,98,108,117,101,0,47,115,118,103,47,109,101,100,105,117,109,115,112,114,105,110,103,103,114,101,101,110,0,47,115,118,103,47,109,101,100,105,117,109,116,117,114,113,117,111,105,115,101,0,47,115,118,103,47,109,101,100,105,117,109,118,105,111,108,101,116,114,101,100,0,47,115,118,103,47,109,105,100,110,105,103,104,116,98,108,117,101,0,47,115,118,103,47,109,105,110,116,99,114,101,97,109,0,47,115,118,103,47,109,105,115,116,121,114,111,115,101,0,47,115,118,103,47,109,111,99,99,97,115,105,110,0,47,115,118,103,47,110,97,118,97,106,111,119,104,105,116,101,0,47,115,118,103,47,110,97,118,121,0,47,115,118,103,47,111,108,100,108,97,99,101,0,47,115,118,103,47,111,108,105,118,101,0,47,115,118,103,47,111,108,105,118,101,100,114,97,98,0,47,115,118,103,47,111,114,97,110,103,101,0,47,115,118,103,47,111,114,97,110,103,101,114,101,100,0,47,115,118,103,47,111,114,99,104,105,100,0,47,115,118,103,47,112,97,108,101,103,111,108,100,101,110,114,111,100,0,47,115,118,103,47,112,97,108,101,103,114,101,101,110,0,47,115,118,103,47,112,97,108,101,116,117,114,113,117,111,105,115,101,0,47,115,118,103,47,112,97,108,101,118,105,111,108,101,116,114,101,100,0,47,115,118,103,47,112,97,112,97,121,97,119,104,105,112,0,47,115,118,103,47,112,101,97,99,104,112,117,102,102,0,47,115,118,103,47,112,101,114,117,0,47,115,118,103,47,112,105,110,107,0,47,115,118,103,47,112,108,117,109,0,47,115,118,103,47,112,111,119,100,101,114,98,108,117,101,0,47,115,118,103,47,112,117,114,112,108,101,0,47,115,118,103,47,114,101,100,0,47,115,118,103,47,114,111,115,121,98,114,111,119,110,0,47,115,118,103,47,114,111,121,97,108,98,108,117,101,0,47,115,118,103,47,115,97,100,100,108,101,98,114,111,119,110,0,47,115,118,103,47,115,97,108,109,111,110,0,47,115,118,103,47,115,97,110,100,121,98,114,111,119,110,0,47,115,118,103,47,115,101,97,103,114,101,101,110,0,47,115,118,103,47,115,101,97,115,104,101,108,108,0,47,115,118,103,47,115,105,101,110,110,97,0,47,115,118,103,47,115,105,108,118,101,114,0,47,115,118,103,47,115,107,121,98,108,117,101,0,47,115,118,103,47,115,108,97,116,101,98,108,117,101,0,47,115,118,103,47,115,108,97,116,101,103,114,97,121,0,47,115,118,103,47,115,108,97,116,101,103,114,101,121,0,47,115,118,103,47,115,110,111,119,0,47,115,118,103,47,115,112,114,105,110,103,103,114,101,101,110,0,47,115,118,103,47,115,116,101,101,108,98,108,117,101,0,47,115,118,103,47,116,97,110,0,47,115,118,103,47,116,101,97,108,0,47,115,118,103,47,116,104,105,115,116,108,101,0,47,115,118,103,47,116,111,109,97,116,111,0,47,115,118,103,47,116,117,114,113,117,111,105,115,101,0,47,115,118,103,47,118,105,111,108,101,116,0,47,115,118,103,47,119,104,101,97,116,0,47,115,118,103,47,119,104,105,116,101,0,47,115,118,103,47,119,104,105,116,101,115,109,111,107,101,0,47,115,118,103,47,121,101,108,108,111,119,0,47,115,118,103,47,121,101,108,108,111,119,103,114,101,101,110,0,47,121,108,103,110,51,47,49,0,47,121,108,103,110,51,47,50,0,47,121,108,103,110,51,47,51,0,47,121,108,103,110,52,47,49,0,47,121,108,103,110,52,47,50,0,47,121,108,103,110,52,47,51,0,47,121,108,103,110,52,47,52,0,47,121,108,103,110,53,47,49,0,47,121,108,103,110,53,47,50,0,47,121,108,103,110,53,47,51,0,47,121,108,103,110,53,47,52,0,47,121,108,103,110,53,47,53,0,47,121,108,103,110,54,47,49,0,47,121,108,103,110,54,47,50,0,47,121,108,103,110,54,47,51,0,47,121,108,103,110,54,47,52,0,47,121,108,103,110,54,47,53,0,47,121,108,103,110,54,47,54,0,47,121,108,103,110,55,47,49,0,47,121,108,103,110,55,47,50,0,47,121,108,103,110,55,47,51,0,47,121,108,103,110,55,47,52,0,47,121,108,103,110,55,47,53,0,47,121,108,103,110,55,47,54,0,47,121,108,103,110,55,47,55,0,47,121,108,103,110,56,47,49,0,47,121,108,103,110,56,47,50,0,47,121,108,103,110,56,47,51,0,47,121,108,103,110,56,47,52,0,47,121,108,103,110,56,47,53,0,47,121,108,103,110,56,47,54,0,47,121,108,103,110,56,47,55,0,47,121,108,103,110,56,47,56,0,47,121,108,103,110,57,47,49,0,47,121,108,103,110,57,47,50,0,47,121,108,103,110,57,47,51,0,47,121,108,103,110,57,47,52,0,47,121,108,103,110,57,47,53,0,47,121,108,103,110,57,47,54,0,47,121,108,103,110,57,47,55,0,47,121,108,103,110,57,47,56,0,47,121,108,103,110,57,47,57,0,47,121,108,103,110,98,117,51,47,49,0,47,121,108,103,110,98,117,51,47,50,0,47,121,108,103,110,98,117,51,47,51,0,47,121,108,103,110,98,117,52,47,49,0,47,121,108,103,110,98,117,52,47,50,0,47,121,108,103,110,98,117,52,47,51,0,47,121,108,103,110,98,117,52,47,52,0,47,121,108,103,110,98,117,53,47,49,0,47,121,108,103,110,98,117,53,47,50,0,47,121,108,103,110,98,117,53,47,51,0,47,121,108,103,110,98,117,53,47,52,0,47,121,108,103,110,98,117,53,47,53,0,47,121,108,103,110,98,117,54,47,49,0,47,121,108,103,110,98,117,54,47,50,0,47,121,108,103,110,98,117,54,47,51,0,47,121,108,103,110,98,117,54,47,52,0,47,121,108,103,110,98,117,54,47,53,0,47,121,108,103,110,98,117,54,47,54,0,47,121,108,103,110,98,117,55,47,49,0,47,121,108,103,110,98,117,55,47,50,0,47,121,108,103,110,98,117,55,47,51,0,47,121,108,103,110,98,117,55,47,52,0,47,121,108,103,110,98,117,55,47,53,0,47,121,108,103,110,98,117,55,47,54,0,47,121,108,103,110,98,117,55,47,55,0,47,121,108,103,110,98,117,56,47,49,0,47,121,108,103,110,98,117,56,47,50,0,47,121,108,103,110,98,117,56,47,51,0,47,121,108,103,110,98,117,56,47,52,0,47,121,108,103,110,98,117,56,47,53,0,47,121,108,103,110,98,117,56,47,54,0,47,121,108,103,110,98,117,56,47,55,0,47,121,108,103,110,98,117,56,47,56,0,47,121,108,103,110,98,117,57,47,49,0,47,121,108,103,110,98,117,57,47,50,0,47,121,108,103,110,98,117,57,47,51,0,47,121,108,103,110,98,117,57,47,52,0,47,121,108,103,110,98,117,57,47,53,0,47,121,108,103,110,98,117,57,47,54,0,47,121,108,103,110,98,117,57,47,55,0,47,121,108,103,110,98,117,57,47,56,0,47,121,108,103,110,98,117,57,47,57,0,47,121,108,111,114,98,114,51,47,49,0,47,121,108,111,114,98,114,51,47,50,0,47,121,108,111,114,98,114,51,47,51,0,47,121,108,111,114,98,114,52,47,49,0,47,121,108,111,114,98,114,52,47,50,0,47,121,108,111,114,98,114,52,47,51,0,47,121,108,111,114,98,114,52,47,52,0,47,121,108,111,114,98,114,53,47,49,0,47,121,108,111,114,98,114,53,47,50,0,47,121,108,111,114,98,114,53,47,51,0,47,121,108,111,114,98,114,53,47,52,0,47,121,108,111,114,98,114,53,47,53,0,47,121,108,111,114,98,114,54,47,49,0,47,121,108,111,114,98,114,54,47,50,0,47,121,108,111,114,98,114,54,47,51,0,47,121,108,111,114,98,114,54,47,52,0,47,121,108,111,114,98,114,54,47,53,0,47,121,108,111,114,98,114,54,47,54,0,47,121,108,111,114,98,114,55,47,49,0,47,121,108,111,114,98,114,55,47,50,0,47,121,108,111,114,98,114,55,47,51,0,47,121,108,111,114,98,114,55,47,52,0,47,121,108,111,114,98,114,55,47,53,0,47,121,108,111,114,98,114,55,47,54,0,47,121,108,111,114,98,114,55,47,55,0,47,121,108,111,114,98,114,56,47,49,0,47,121,108,111,114,98,114,56,47,50,0,47,121,108,111,114,98,114,56,47,51,0,47,121,108,111,114,98,114,56,47,52,0,47,121,108,111,114,98,114,56,47,53,0,47,121,108,111,114,98,114,56,47,54,0,47,121,108,111,114,98,114,56,47,55,0,47,121,108,111,114,98,114,56,47,56,0,47,121,108,111,114,98,114,57,47,49,0,47,121,108,111,114,98,114,57,47,50,0,47,121,108,111,114,98,114,57,47,51,0,47,121,108,111,114,98,114,57,47,52,0,47,121,108,111,114,98,114,57,47,53,0,47,121,108,111,114,98,114,57,47,54,0,47,121,108,111,114,98,114,57,47,55,0,47,121,108,111,114,98,114,57,47,56,0,47,121,108,111,114,98,114,57,47,57,0,47,121,108,111,114,114,100,51,47,49,0,47,121,108,111,114,114,100,51,47,50,0,47,121,108,111,114,114,100,51,47,51,0,47,121,108,111,114,114,100,52,47,49,0,47,121,108,111,114,114,100,52,47,50,0,47,121,108,111,114,114,100,52,47,51,0,47,121,108,111,114,114,100,52,47,52,0,47,121,108,111,114,114,100,53,47,49,0,47,121,108,111,114,114,100,53,47,50,0,47,121,108,111,114,114,100,53,47,51,0,47,121,108,111,114,114,100,53,47,52,0,47,121,108,111,114,114,100,53,47,53,0,47,121,108,111,114,114,100,54,47,49,0,47,121,108,111,114,114,100,54,47,50,0,47,121,108,111,114,114,100,54,47,51,0,47,121,108,111,114,114,100,54,47,52,0,47,121,108,111,114,114,100,54,47,53,0,47,121,108,111,114,114,100,54,47,54,0,47,121,108,111,114,114,100,55,47,49,0,47,121,108,111,114,114,100,55,47,50,0,47,121,108,111,114,114,100,55,47,51,0,47,121,108,111,114,114,100,55,47,52,0,47,121,108,111,114,114,100,55,47,53,0,47,121,108,111,114,114,100,55,47,54,0,47,121,108,111,114,114,100,55,47,55,0,47,121,108,111,114,114,100,56,47,49,0,47,121,108,111,114,114,100,56,47,50,0,47,121,108,111,114,114,100,56,47,51,0,47,121,108,111,114,114,100,56,47,52,0,47,121,108,111,114,114,100,56,47,53,0,47,121,108,111,114,114,100,56,47,54,0,47,121,108,111,114,114,100,56,47,55,0,47,121,108,111,114,114,100,56,47,56,0,47,121,108,111,114,114,100,57,47,49,0,47,121,108,111,114,114,100,57,47,50,0,47,121,108,111,114,114,100,57,47,51,0,47,121,108,111,114,114,100,57,47,52,0,47,121,108,111,114,114,100,57,47,53,0,47,121,108,111,114,114,100,57,47,54,0,47,121,108,111,114,114,100,57,47,55,0,47,121,108,111,114,114,100,57,47,56,0,47,121,108,111,114,114,100,57,47,57,0,97,108,105,99,101,98,108,117,101,0,97,110,116,105,113,117,101,119,104,105,116,101,0,97,110,116,105,113,117,101,119,104,105,116,101,49,0,97,110,116,105,113,117,101,119,104,105,116,101,50,0,97,110,116,105,113,117,101,119,104,105,116,101,51,0,97,110,116,105,113,117,101,119,104,105,116,101,52,0,97,113,117,97,109,97,114,105,110,101,0,97,113,117,97,109,97,114,105,110,101,49,0,97,113,117,97,109,97,114,105,110,101,50,0,97,113,117,97,109,97,114,105,110,101,51,0,97,113,117,97,109,97,114,105,110,101,52,0,97,122,117,114,101,0,97,122,117,114,101,49,0,97,122,117,114,101,50,0,97,122,117,114,101,51,0,97,122,117,114,101,52,0,98,101,105,103,101,0,98,105,115,113,117,101,0,98,105,115,113,117,101,49,0,98,105,115,113,117,101,50,0,98,105,115,113,117,101,51,0,98,105,115,113,117,101,52,0,98,108,97,110,99,104,101,100,97,108,109,111,110,100,0,98,108,117,101,0,98,108,117,101,49,0,98,108,117,101,50,0,98,108,117,101,51,0,98,108,117,101,52,0,98,108,117,101,118,105,111,108,101,116,0,98,114,111,119,110,0,98,114,111,119,110,49,0,98,114,111,119,110,50,0,98,114,111,119,110,51,0,98,114,111,119,110,52,0,98,117,114,108,121,119,111,111,100,0,98,117,114,108,121,119,111,111,100,49,0,98,117,114,108,121,119,111,111,100,50,0,98,117,114,108,121,119,111,111,100,51,0,98,117,114,108,121,119,111,111,100,52,0,99,97,100,101,116,98,108,117,101,0,99,97,100,101,116,98,108,117,101,49,0,99,97,100,101,116,98,108,117,101,50,0,99,97,100,101,116,98,108,117,101,51,0,99,97,100,101,116,98,108,117,101,52,0,99,104,97,114,116,114,101,117,115,101,0,99,104,97,114,116,114,101,117,115,101,49,0,99,104,97,114,116,114,101,117,115,101,50,0,99,104,97,114,116,114,101,117,115,101,51,0,99,104,97,114,116,114,101,117,115,101,52,0,99,104,111,99,111,108,97,116,101,0,99,104,111,99,111,108,97,116,101,49,0,99,104,111,99,111,108,97,116,101,50,0,99,104,111,99,111,108,97,116,101,51,0,99,104,111,99,111,108,97,116,101,52,0,99,111,114,97,108,0,99,111,114,97,108,49,0,99,111,114,97,108,50,0,99,111,114,97,108,51,0,99,111,114,97,108,52,0,99,111,114,110,102,108,111,119,101,114,98,108,117,101,0,99,111,114,110,115,105,108,107,0,99,111,114,110,115,105,108,107,49,0,99,111,114,110,115,105,108,107,50,0,99,111,114,110,115,105,108,107,51,0,99,111,114,110,115,105,108,107,52,0,99,114,105,109,115,111,110,0,99,121,97,110,0,99,121,97,110,49,0,99,121,97,110,50,0,99,121,97,110,51,0,99,121,97,110,52,0,100,97,114,107,103,111,108,100,101,110,114,111,100,0,100,97,114,107,103,111,108,100,101,110,114,111,100,49,0,100,97,114,107,103,111,108,100,101,110,114,111,100,50,0,100,97,114,107,103,111,108,100,101,110,114,111,100,51,0,100,97,114,107,103,111,108,100,101,110,114,111,100,52,0,100,97,114,107,103,114,101,101,110,0,100,97,114,107,107,104,97,107,105,0,100,97,114,107,111,108,105,118,101,103,114,101,101,110,0,100,97,114,107,111,108,105,118,101,103,114,101,101,110,49,0,100,97,114,107,111,108,105,118,101,103,114,101,101,110,50,0,100,97,114,107,111,108,105,118,101,103,114,101,101,110,51,0,100,97,114,107,111,108,105,118,101,103,114,101,101,110,52,0,100,97,114,107,111,114,97,110,103,101,0,100,97,114,107,111,114,97,110,103,101,49,0,100,97,114,107,111,114,97,110,103,101,50,0,100,97,114,107,111,114,97,110,103,101,51,0,100,97,114,107,111,114,97,110,103,101,52,0,100,97,114,107,111,114,99,104,105,100,0,100,97,114,107,111,114,99,104,105,100,49,0,100,97,114,107,111,114,99,104,105,100,50,0,100,97,114,107,111,114,99,104,105,100,51,0,100,97,114,107,111,114,99,104,105,100,52,0,100,97,114,107,115,97,108,109,111,110,0,100,97,114,107,115,101,97,103,114,101,101,110,0,100,97,114,107,115,101,97,103,114,101,101,110,49,0,100,97,114,107,115,101,97,103,114,101,101,110,50,0,100,97,114,107,115,101,97,103,114,101,101,110,51,0,100,97,114,107,115,101,97,103,114,101,101,110,52,0,100,97,114,107,115,108,97,116,101,98,108,117,101,0,100,97,114,107,115,108,97,116,101,103,114,97,121,0,100,97,114,107,115,108,97,116,101,103,114,97,121,49,0,100,97,114,107,115,108,97,116,101,103,114,97,121,50,0,100,97,114,107,115,108,97,116,101,103,114,97,121,51,0,100,97,114,107,115,108,97,116,101,103,114,97,121,52,0,100,97,114,107,115,108,97,116,101,103,114,101,121,0,100,97,114,107,116,117,114,113,117,111,105,115,101,0,100,97,114,107,118,105,111,108,101,116,0,100,101,101,112,112,105,110,107,0,100,101,101,112,112,105,110,107,49,0,100,101,101,112,112,105,110,107,50,0,100,101,101,112,112,105,110,107,51,0,100,101,101,112,112,105,110,107,52,0,100,101,101,112,115,107,121,98,108,117,101,0,100,101,101,112,115,107,121,98,108,117,101,49,0,100,101,101,112,115,107,121,98,108,117,101,50,0,100,101,101,112,115,107,121,98,108,117,101,51,0,100,101,101,112,115,107,121,98,108,117,101,52,0,100,105,109,103,114,97,121,0,100,105,109,103,114,101,121,0,100,111,100,103,101,114,98,108,117,101,0,100,111,100,103,101,114,98,108,117,101,49,0,100,111,100,103,101,114,98,108,117,101,50,0,100,111,100,103,101,114,98,108,117,101,51,0,100,111,100,103,101,114,98,108,117,101,52,0,102,105,114,101,98,114,105,99,107,0,102,105,114,101,98,114,105,99,107,49,0,102,105,114,101,98,114,105,99,107,50,0,102,105,114,101,98,114,105,99,107,51,0,102,105,114,101,98,114,105,99,107,52,0,102,108,111,114,97,108,119,104,105,116,101,0,102,111,114,101,115,116,103,114,101,101,110,0,103,97,105,110,115,98,111,114,111,0,103,104,111,115,116,119,104,105,116,101,0,103,111,108,100,0,103,111,108,100,49,0,103,111,108,100,50,0,103,111,108,100,51,0,103,111,108,100,52,0,103,111,108,100,101,110,114,111,100,0,103,111,108,100,101,110,114,111,100,49,0,103,111,108,100,101,110,114,111,100,50,0,103,111,108,100,101,110,114,111,100,51,0,103,111,108,100,101,110,114,111,100,52,0,103,114,97,121,0,103,114,97,121,48,0,103,114,97,121,49,0,103,114,97,121,49,48,0,103,114,97,121,49,48,48,0,103,114,97,121,49,49,0,103,114,97,121,49,50,0,103,114,97,121,49,51,0,103,114,97,121,49,52,0,103,114,97,121,49,53,0,103,114,97,121,49,54,0,103,114,97,121,49,55,0,103,114,97,121,49,56,0,103,114,97,121,49,57,0,103,114,97,121,50,0,103,114,97,121,50,48,0,103,114,97,121,50,49,0,103,114,97,121,50,50,0,103,114,97,121,50,51,0,103,114,97,121,50,52,0,103,114,97,121,50,53,0,103,114,97,121,50,54,0,103,114,97,121,50,55,0,103,114,97,121,50,56,0,103,114,97,121,50,57,0,103,114,97,121,51,0,103,114,97,121,51,48,0,103,114,97,121,51,49,0,103,114,97,121,51,50,0,103,114,97,121,51,51,0,103,114,97,121,51,52,0,103,114,97,121,51,53,0,103,114,97,121,51,54,0,103,114,97,121,51,55,0,103,114,97,121,51,56,0,103,114,97,121,51,57,0,103,114,97,121,52,0,103,114,97,121,52,48,0,103,114,97,121,52,49,0,103,114,97,121,52,50,0,103,114,97,121,52,51,0,103,114,97,121,52,52,0,103,114,97,121,52,53,0,103,114,97,121,52,54,0,103,114,97,121,52,55,0,103,114,97,121,52,56,0,103,114,97,121,52,57,0,103,114,97,121,53,0,103,114,97,121,53,48,0,103,114,97,121,53,49,0,103,114,97,121,53,50,0,103,114,97,121,53,51,0,103,114,97,121,53,52,0,103,114,97,121,53,53,0,103,114,97,121,53,54,0,103,114,97,121,53,55,0,103,114,97,121,53,56,0,103,114,97,121,53,57,0,103,114,97,121,54,0,103,114,97,121,54,48,0,103,114,97,121,54,49,0,103,114,97,121,54,50,0,103,114,97,121,54,51,0,103,114,97,121,54,52,0,103,114,97,121,54,53,0,103,114,97,121,54,54,0,103,114,97,121,54,55,0,103,114,97,121,54,56,0,103,114,97,121,54,57,0,103,114,97,121,55,0,103,114,97,121,55,48,0,103,114,97,121,55,49,0,103,114,97,121,55,50,0,103,114,97,121,55,51,0,103,114,97,121,55,52,0,103,114,97,121,55,53,0,103,114,97,121,55,54,0,103,114,97,121,55,55,0,103,114,97,121,55,56,0,103,114,97,121,55,57,0,103,114,97,121,56,0,103,114,97,121,56,48,0,103,114,97,121,56,49,0,103,114,97,121,56,50,0,103,114,97,121,56,51,0,103,114,97,121,56,52,0,103,114,97,121,56,53,0,103,114,97,121,56,54,0,103,114,97,121,56,55,0,103,114,97,121,56,56,0,103,114,97,121,56,57,0,103,114,97,121,57,0,103,114,97,121,57,48,0,103,114,97,121,57,49,0,103,114,97,121,57,50,0,103,114,97,121,57,51,0,103,114,97,121,57,52,0,103,114,97,121,57,53,0,103,114,97,121,57,54,0,103,114,97,121,57,55,0,103,114,97,121,57,56,0,103,114,97,121,57,57,0,103,114,101,101,110,0,103,114,101,101,110,49,0,103,114,101,101,110,50,0,103,114,101,101,110,51,0,103,114,101,101,110,52,0,103,114,101,101,110,121,101,108,108,111,119,0,103,114,101,121,0,103,114,101,121,48,0,103,114,101,121,49,0,103,114,101,121,49,48,0,103,114,101,121,49,48,48,0,103,114,101,121,49,49,0,103,114,101,121,49,50,0,103,114,101,121,49,51,0,103,114,101,121,49,52,0,103,114,101,121,49,53,0,103,114,101,121,49,54,0,103,114,101,121,49,55,0,103,114,101,121,49,56,0,103,114,101,121,49,57,0,103,114,101,121,50,0,103,114,101,121,50,48,0,103,114,101,121,50,49,0,103,114,101,121,50,50,0,103,114,101,121,50,51,0,103,114,101,121,50,52,0,103,114,101,121,50,53,0,103,114,101,121,50,54,0,103,114,101,121,50,55,0,103,114,101,121,50,56,0,103,114,101,121,50,57,0,103,114,101,121,51,0,103,114,101,121,51,48,0,103,114,101,121,51,49,0,103,114,101,121,51,50,0,103,114,101,121,51,51,0,103,114,101,121,51,52,0,103,114,101,121,51,53,0,103,114,101,121,51,54,0,103,114,101,121,51,55,0,103,114,101,121,51,56,0,103,114,101,121,51,57,0,103,114,101,121,52,0,103,114,101,121,52,48,0,103,114,101,121,52,49,0,103,114,101,121,52,50,0,103,114,101,121,52,51,0,103,114,101,121,52,52,0,103,114,101,121,52,53,0,103,114,101,121,52,54,0,103,114,101,121,52,55,0,103,114,101,121,52,56,0,103,114,101,121,52,57,0,103,114,101,121,53,0,103,114,101,121,53,48,0,103,114,101,121,53,49,0,103,114,101,121,53,50,0,103,114,101,121,53,51,0,103,114,101,121,53,52,0,103,114,101,121,53,53,0,103,114,101,121,53,54,0,103,114,101,121,53,55,0,103,114,101,121,53,56,0,103,114,101,121,53,57,0,103,114,101,121,54,0,103,114,101,121,54,48,0,103,114,101,121,54,49,0,103,114,101,121,54,50,0,103,114,101,121,54,51,0,103,114,101,121,54,52,0,103,114,101,121,54,53,0,103,114,101,121,54,54,0,103,114,101,121,54,55,0,103,114,101,121,54,56,0,103,114,101,121,54,57,0,103,114,101,121,55,0,103,114,101,121,55,48,0,103,114,101,121,55,49,0,103,114,101,121,55,50,0,103,114,101,121,55,51,0,103,114,101,121,55,52,0,103,114,101,121,55,53,0,103,114,101,121,55,54,0,103,114,101,121,55,55,0,103,114,101,121,55,56,0,103,114,101,121,55,57,0,103,114,101,121,56,0,103,114,101,121,56,48,0,103,114,101,121,56,49,0,103,114,101,121,56,50,0,103,114,101,121,56,51,0,103,114,101,121,56,52,0,103,114,101,121,56,53,0,103,114,101,121,56,54,0,103,114,101,121,56,55,0,103,114,101,121,56,56,0,103,114,101,121,56,57,0,103,114,101,121,57,0,103,114,101,121,57,48,0,103,114,101,121,57,49,0,103,114,101,121,57,50,0,103,114,101,121,57,51,0,103,114,101,121,57,52,0,103,114,101,121,57,53,0,103,114,101,121,57,54,0,103,114,101,121,57,55,0,103,114,101,121,57,56,0,103,114,101,121,57,57,0,104,111,110,101,121,100,101,119,0,104,111,110,101,121,100,101,119,49,0,104,111,110,101,121,100,101,119,50,0,104,111,110,101,121,100,101,119,51,0,104,111,110,101,121,100,101,119,52,0,104,111,116,112,105,110,107,0,104,111,116,112,105,110,107,49,0,104,111,116,112,105,110,107,50,0,104,111,116,112,105,110,107,51,0,104,111,116,112,105,110,107,52,0,105,110,100,105,97,110,114,101,100,0,105,110,100,105,97,110,114,101,100,49,0,105,110,100,105,97,110,114,101,100,50,0,105,110,100,105,97,110,114,101,100,51,0,105,110,100,105,97,110,114,101,100,52,0,105,110,100,105,103,111,0,105,110,118,105,115,0,105,118,111,114,121,0,105,118,111,114,121,49,0,105,118,111,114,121,50,0,105,118,111,114,121,51,0,105,118,111,114,121,52,0,107,104,97,107,105,0,107,104,97,107,105,49,0,107,104,97,107,105,50,0,107,104,97,107,105,51,0,107,104,97,107,105,52,0,108,97,118,101,110,100,101,114,0,108,97,118,101,110,100,101,114,98,108,117,115,104,0,108,97,118,101,110,100,101,114,98,108,117,115,104,49,0,108,97,118,101,110,100,101,114,98,108,117,115,104,50,0,108,97,118,101,110,100,101,114,98,108,117,115,104,51,0,108,97,118,101,110,100,101,114,98,108,117,115,104,52,0,108,97,119,110,103,114,101,101,110,0,108,101,109,111,110,99,104,105,102,102,111,110,0,108,101,109,111,110,99,104,105,102,102,111,110,49,0,108,101,109,111,110,99,104,105,102,102,111,110,50,0,108,101,109,111,110,99,104,105,102,102,111,110,51,0,108,101,109,111,110,99,104,105,102,102,111,110,52,0,108,105,103,104,116,98,108,117,101,0,108,105,103,104,116,98,108,117,101,49,0,108,105,103,104,116,98,108,117,101,50,0,108,105,103,104,116,98,108,117,101,51,0,108,105,103,104,116,98,108,117,101,52,0,108,105,103,104,116,99,111,114,97,108,0,108,105,103,104,116,99,121,97,110,0,108,105,103,104,116,99,121,97,110,49,0,108,105,103,104,116,99,121,97,110,50,0,108,105,103,104,116,99,121,97,110,51,0,108,105,103,104,116,99,121,97,110,52,0,108,105,103,104,116,103,111,108,100,101,110,114,111,100,0,108,105,103,104,116,103,111,108,100,101,110,114,111,100,49,0,108,105,103,104,116,103,111,108,100,101,110,114,111,100,50,0,108,105,103,104,116,103,111,108,100,101,110,114,111,100,51,0,108,105,103,104,116,103,111,108,100,101,110,114,111,100,52,0,108,105,103,104,116,103,111,108,100,101,110,114,111,100,121,101,108,108,111,119,0,108,105,103,104,116,103,114,97,121,0,108,105,103,104,116,103,114,101,121,0,108,105,103,104,116,112,105,110,107,0,108,105,103,104,116,112,105,110,107,49,0,108,105,103,104,116,112,105,110,107,50,0,108,105,103,104,116,112,105,110,107,51,0,108,105,103,104,116,112,105,110,107,52,0,108,105,103,104,116,115,97,108,109,111,110,0,108,105,103,104,116,115,97,108,109,111,110,49,0,108,105,103,104,116,115,97,108,109,111,110,50,0,108,105,103,104,116,115,97,108,109,111,110,51,0,108,105,103,104,116,115,97,108,109,111,110,52,0,108,105,103,104,116,115,101,97,103,114,101,101,110,0,108,105,103,104,116,115,107,121,98,108,117,101,0,108,105,103,104,116,115,107,121,98,108,117,101,49,0,108,105,103,104,116,115,107,121,98,108,117,101,50,0,108,105,103,104,116,115,107,121,98,108,117,101,51,0,108,105,103,104,116,115,107,121,98,108,117,101,52,0,108,105,103,104,116,115,108,97,116,101,98,108,117,101,0,108,105,103,104,116,115,108,97,116,101,103,114,97,121,0,108,105,103,104,116,115,108,97,116,101,103,114,101,121,0,108,105,103,104,116,115,116,101,101,108,98,108,117,101,0,108,105,103,104,116,115,116,101,101,108,98,108,117,101,49,0,108,105,103,104,116,115,116,101,101,108,98,108,117,101,50,0,108,105,103,104,116,115,116,101,101,108,98,108,117,101,51,0,108,105,103,104,116,115,116,101,101,108,98,108,117,101,52,0,108,105,103,104,116,121,101,108,108,111,119,0,108,105,103,104,116,121,101,108,108,111,119,49,0,108,105,103,104,116,121,101,108,108,111,119,50,0,108,105,103,104,116,121,101,108,108,111,119,51,0,108,105,103,104,116,121,101,108,108,111,119,52,0,108,105,109,101,103,114,101,101,110,0,108,105,110,101,110,0,109,97,103,101,110,116,97,0,109,97,103,101,110,116,97,49,0,109,97,103,101,110,116,97,50,0,109,97,103,101,110,116,97,51,0,109,97,103,101,110,116,97,52,0,109,97,114,111,111,110,0,109,97,114,111,111,110,49,0,109,97,114,111,111,110,50,0,109,97,114,111,111,110,51,0,109,97,114,111,111,110,52,0,109,101,100,105,117,109,97,113,117,97,109,97,114,105,110,101,0,109,101,100,105,117,109,98,108,117,101,0,109,101,100,105,117,109,111,114,99,104,105,100,0,109,101,100,105,117,109,111,114,99,104,105,100,49,0,109,101,100,105,117,109,111,114,99,104,105,100,50,0,109,101,100,105,117,109,111,114,99,104,105,100,51,0,109,101,100,105,117,109,111,114,99,104,105,100,52,0,109,101,100,105,117,109,112,117,114,112,108,101,0,109,101,100,105,117,109,112,117,114,112,108,101,49,0,109,101,100,105,117,109,112,117,114,112,108,101,50,0,109,101,100,105,117,109,112,117,114,112,108,101,51,0,109,101,100,105,117,109,112,117,114,112,108,101,52,0,109,101,100,105,117,109,115,101,97,103,114,101,101,110,0,109,101,100,105,117,109,115,108,97,116,101,98,108,117,101,0,109,101,100,105,117,109,115,112,114,105,110,103,103,114,101,101,110,0,109,101,100,105,117,109,116,117,114,113,117,111,105,115,101,0,109,101,100,105,117,109,118,105,111,108,101,116,114,101,100,0,109,105,100,110,105,103,104,116,98,108,117,101,0,109,105,110,116,99,114,101,97,109,0,109,105,115,116,121,114,111,115,101,0,109,105,115,116,121,114,111,115,101,49,0,109,105,115,116,121,114,111,115,101,50,0,109,105,115,116,121,114,111,115,101,51,0,109,105,115,116,121,114,111,115,101,52,0,109,111,99,99,97,115,105,110,0,110,97,118,97,106,111,119,104,105,116,101,0,110,97,118,97,106,111,119,104,105,116,101,49,0,110,97,118,97,106,111,119,104,105,116,101,50,0,110,97,118,97,106,111,119,104,105,116,101,51,0,110,97,118,97,106,111,119,104,105,116,101,52,0,110,97,118,121,0,110,97,118,121,98,108,117,101,0,110,111,110,101,0,111,108,100,108,97,99,101,0,111,108,105,118,101,100,114,97,98,0,111,108,105,118,101,100,114,97,98,49,0,111,108,105,118,101,100,114,97,98,50,0,111,108,105,118,101,100,114,97,98,51,0,111,108,105,118,101,100,114,97,98,52,0,111,114,97,110,103,101,0,111,114,97,110,103,101,49,0,111,114,97,110,103,101,50,0,111,114,97,110,103,101,51,0,111,114,97,110,103,101,52,0,111,114,97,110,103,101,114,101,100,0,111,114,97,110,103,101,114,101,100,49,0,111,114,97,110,103,101,114,101,100,50,0,111,114,97,110,103,101,114,101,100,51,0,111,114,97,110,103,101,114,101,100,52,0,111,114,99,104,105,100,0,111,114,99,104,105,100,49,0,111,114,99,104,105,100,50,0,111,114,99,104,105,100,51,0,111,114,99,104,105,100,52,0,112,97,108,101,103,111,108,100,101,110,114,111,100,0,112,97,108,101,103,114,101,101,110,0,112,97,108,101,103,114,101,101,110,49,0,112,97,108,101,103,114,101,101,110,50,0,112,97,108,101,103,114,101,101,110,51,0,112,97,108,101,103,114,101,101,110,52,0,112,97,108,101,116,117,114,113,117,111,105,115,101,0,112,97,108,101,116,117,114,113,117,111,105,115,101,49,0,112,97,108,101,116,117,114,113,117,111,105,115,101,50,0,112,97,108,101,116,117,114,113,117,111,105,115,101,51,0,112,97,108,101,116,117,114,113,117,111,105,115,101,52,0,112,97,108,101,118,105,111,108,101,116,114,101,100,0,112,97,108],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+163422);allocate([101,118,105,111,108,101,116,114,101,100,49,0,112,97,108,101,118,105,111,108,101,116,114,101,100,50,0,112,97,108,101,118,105,111,108,101,116,114,101,100,51,0,112,97,108,101,118,105,111,108,101,116,114,101,100,52,0,112,97,112,97,121,97,119,104,105,112,0,112,101,97,99,104,112,117,102,102,0,112,101,97,99,104,112,117,102,102,49,0,112,101,97,99,104,112,117,102,102,50,0,112,101,97,99,104,112,117,102,102,51,0,112,101,97,99,104,112,117,102,102,52,0,112,101,114,117,0,112,105,110,107,0,112,105,110,107,49,0,112,105,110,107,50,0,112,105,110,107,51,0,112,105,110,107,52,0,112,108,117,109,0,112,108,117,109,49,0,112,108,117,109,50,0,112,108,117,109,51,0,112,108,117,109,52,0,112,111,119,100,101,114,98,108,117,101,0,112,117,114,112,108,101,0,112,117,114,112,108,101,49,0,112,117,114,112,108,101,50,0,112,117,114,112,108,101,51,0,112,117,114,112,108,101,52,0,114,101,100,0,114,101,100,49,0,114,101,100,50,0,114,101,100,51,0,114,101,100,52,0,114,111,115,121,98,114,111,119,110,0,114,111,115,121,98,114,111,119,110,49,0,114,111,115,121,98,114,111,119,110,50,0,114,111,115,121,98,114,111,119,110,51,0,114,111,115,121,98,114,111,119,110,52,0,114,111,121,97,108,98,108,117,101,0,114,111,121,97,108,98,108,117,101,49,0,114,111,121,97,108,98,108,117,101,50,0,114,111,121,97,108,98,108,117,101,51,0,114,111,121,97,108,98,108,117,101,52,0,115,97,100,100,108,101,98,114,111,119,110,0,115,97,108,109,111,110,0,115,97,108,109,111,110,49,0,115,97,108,109,111,110,50,0,115,97,108,109,111,110,51,0,115,97,108,109,111,110,52,0,115,97,110,100,121,98,114,111,119,110,0,115,101,97,103,114,101,101,110,0,115,101,97,103,114,101,101,110,49,0,115,101,97,103,114,101,101,110,50,0,115,101,97,103,114,101,101,110,51,0,115,101,97,103,114,101,101,110,52,0,115,101,97,115,104,101,108,108,0,115,101,97,115,104,101,108,108,49,0,115,101,97,115,104,101,108,108,50,0,115,101,97,115,104,101,108,108,51,0,115,101,97,115,104,101,108,108,52,0,115,105,101,110,110,97,0,115,105,101,110,110,97,49,0,115,105,101,110,110,97,50,0,115,105,101,110,110,97,51,0,115,105,101,110,110,97,52,0,115,107,121,98,108,117,101,0,115,107,121,98,108,117,101,49,0,115,107,121,98,108,117,101,50,0,115,107,121,98,108,117,101,51,0,115,107,121,98,108,117,101,52,0,115,108,97,116,101,98,108,117,101,0,115,108,97,116,101,98,108,117,101,49,0,115,108,97,116,101,98,108,117,101,50,0,115,108,97,116,101,98,108,117,101,51,0,115,108,97,116,101,98,108,117,101,52,0,115,108,97,116,101,103,114,97,121,0,115,108,97,116,101,103,114,97,121,49,0,115,108,97,116,101,103,114,97,121,50,0,115,108,97,116,101,103,114,97,121,51,0,115,108,97,116,101,103,114,97,121,52,0,115,108,97,116,101,103,114,101,121,0,115,110,111,119,0,115,110,111,119,49,0,115,110,111,119,50,0,115,110,111,119,51,0,115,110,111,119,52,0,115,112,114,105,110,103,103,114,101,101,110,0,115,112,114,105,110,103,103,114,101,101,110,49,0,115,112,114,105,110,103,103,114,101,101,110,50,0,115,112,114,105,110,103,103,114,101,101,110,51,0,115,112,114,105,110,103,103,114,101,101,110,52,0,115,116,101,101,108,98,108,117,101,0,115,116,101,101,108,98,108,117,101,49,0,115,116,101,101,108,98,108,117,101,50,0,115,116,101,101,108,98,108,117,101,51,0,115,116,101,101,108,98,108,117,101,52,0,116,97,110,0,116,97,110,49,0,116,97,110,50,0,116,97,110,51,0,116,97,110,52,0,116,104,105,115,116,108,101,0,116,104,105,115,116,108,101,49,0,116,104,105,115,116,108,101,50,0,116,104,105,115,116,108,101,51,0,116,104,105,115,116,108,101,52,0,116,111,109,97,116,111,0,116,111,109,97,116,111,49,0,116,111,109,97,116,111,50,0,116,111,109,97,116,111,51,0,116,111,109,97,116,111,52,0,116,117,114,113,117,111,105,115,101,0,116,117,114,113,117,111,105,115,101,49,0,116,117,114,113,117,111,105,115,101,50,0,116,117,114,113,117,111,105,115,101,51,0,116,117,114,113,117,111,105,115,101,52,0,118,105,111,108,101,116,0,118,105,111,108,101,116,114,101,100,0,118,105,111,108,101,116,114,101,100,49,0,118,105,111,108,101,116,114,101,100,50,0,118,105,111,108,101,116,114,101,100,51,0,118,105,111,108,101,116,114,101,100,52,0,119,104,101,97,116,0,119,104,101,97,116,49,0,119,104,101,97,116,50,0,119,104,101,97,116,51,0,119,104,101,97,116,52,0,119,104,105,116,101,0,119,104,105,116,101,115,109,111,107,101,0,121,101,108,108,111,119,0,121,101,108,108,111,119,49,0,121,101,108,108,111,119,50,0,121,101,108,108,111,119,51,0,121,101,108,108,111,119,52,0,121,101,108,108,111,119,103,114,101,101,110,0,108,97,99,107,0,104,105,116,101,0,105,103,104,116,103,114,101,121,0,88,49,49,47,0,47,37,115,47,37,115,0,105,109,97,103,101,115,99,97,108,101,0,102,97,108,115,101,0,98,108,97,99,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,100,0,65,103,110,111,100,101,105,110,102,111,95,116,0,114,111,119,103,0,99,111,108,103,0,65,103,114,97,112,104,105,110,102,111,95,116,0,100,101,108,120,32,62,61,32,48,0,104,116,109,108,116,97,98,108,101,46,99,0,112,111,115,95,104,116,109,108,95,116,98,108,0,100,101,108,121,32,62,61,32,48,0,116,97,98,108,101,32,115,105,122,101,32,116,111,111,32,115,109,97,108,108,32,102,111,114,32,99,111,110,116,101,110,116,10,0,102,105,120,101,100,32,116,97,98,108,101,32,115,105,122,101,32,119,105,116,104,32,117,110,115,112,101,99,105,102,105,101,100,32,119,105,100,116,104,32,111,114,32,104,101,105,103,104,116,10,0,99,101,108,108,32,115,105,122,101,32,116,111,111,32,115,109,97,108,108,32,102,111,114,32,99,111,110,116,101,110,116,10,0,102,105,120,101,100,32,99,101,108,108,32,115,105,122,101,32,119,105,116,104,32,117,110,115,112,101,99,105,102,105,101,100,32,119,105,100,116,104,32,111,114,32,104,101,105,103,104,116,10,0,78,111,32,111,114,32,105,109,112,114,111,112,101,114,32,105,109,97,103,101,32,102,105,108,101,61,34,37,115,34,10,0,112,101,110,99,111,108,111,114,0,45,62,0,65,103,101,100,103,101,105,110,102,111,95,116,0,49,0,50,0,51,0,52,0,53,0,54,0,55,0,56,0,57,0,49,48,0,49,49,0,49,50,0,49,51,0,49,52,0,49,53,0,49,54,0,49,55,0,49,56,0,49,57,0,50,48,0,100,97,115,104,101,100,0,100,111,116,116,101,100,0,99,112,45,62,115,114,99,0,101,109,105,116,95,104,116,109,108,95,105,109,103,0,99,112,45,62,115,114,99,91,48,93,0,116,114,97,110,115,112,97,114,101,110,116,0,95,37,100,0,102,80,81,46,99,0,80,81,99,104,101,99,107,0,72,101,97,112,32,111,118,101,114,102,108,111,119,10,0,37,33,80,83,45,65,100,111,98,101,45,50,46,48,10,47,110,111,100,101,32,123,10,32,32,47,89,32,101,120,99,104,32,100,101,102,10,32,32,47,88,32,101,120,99,104,32,100,101,102,10,32,32,47,121,32,101,120,99,104,32,100,101,102,10,32,32,47,120,32,101,120,99,104,32,100,101,102,10,32,32,110,101,119,112,97,116,104,10,32,32,120,32,121,32,109,111,118,101,116,111,10,32,32,120,32,89,32,108,105,110,101,116,111,10,32,32,88,32,89,32,108,105,110,101,116,111,10,32,32,88,32,121,32,108,105,110,101,116,111,10,32,32,99,108,111,115,101,112,97,116,104,32,102,105,108,108,10,125,32,100,101,102,10,47,99,101,108,108,32,123,10,32,32,47,89,32,101,120,99,104,32,100,101,102,10,32,32,47,88,32,101,120,99,104,32,100,101,102,10,32,32,47,121,32,101,120,99,104,32,100,101,102,10,32,32,47,120,32,101,120,99,104,32,100,101,102,10,32,32,110,101,119,112,97,116,104,10,32,32,120,32,121,32,109,111,118,101,116,111,10,32,32,120,32,89,32,108,105,110,101,116,111,10,32,32,88,32,89,32,108,105,110,101,116,111,10,32,32,88,32,121,32,108,105,110,101,116,111,10,32,32,99,108,111,115,101,112,97,116,104,32,115,116,114,111,107,101,10,125,32,100,101,102,10,0,115,104,111,119,112,97,103,101,10,0,102,97,105,108,101,100,32,97,116,32,110,111,100,101,32,37,100,91,48,93,10,0,110,112,45,62,99,101,108,108,115,91,48,93,0,109,97,122,101,46,99,0,99,104,107,83,103,114,97,112,104,0,102,97,105,108,101,100,32,97,116,32,110,111,100,101,32,37,100,91,49,93,10,0,110,112,45,62,99,101,108,108,115,91,49,93,0,100,105,116,101,109,115,0,102,105,110,100,83,86,101,114,116,0,37,37,37,37,80,97,103,101,58,32,49,32,49,10,37,37,37,37,80,97,103,101,66,111,117,110,100,105,110,103,66,111,120,58,32,37,100,32,37,100,32,37,100,32,37,100,10,0,37,102,32,37,102,32,116,114,97,110,115,108,97,116,101,10,0,48,32,48,32,49,32,115,101,116,114,103,98,99,111,108,111,114,10,0,37,102,32,37,102,32,37,102,32,37,102,32,110,111,100,101,10,0,48,32,48,32,48,32,115,101,116,114,103,98,99,111,108,111,114,10,0,37,102,32,37,102,32,37,102,32,37,102,32,99,101,108,108,10,0,49,32,48,32,48,32,115,101,116,114,103,98,99,111,108,111,114,10,0,117,110,101,120,112,101,99,116,101,100,32,99,97,115,101,32,105,110,32,108,111,99,97,116,101,95,101,110,100,112,111,105,110,116,10,0,48,0,116,114,97,112,101,122,111,105,100,46,99,0,108,111,99,97,116,101,95,101,110,100,112,111,105,110,116,0,97,100,100,95,115,101,103,109,101,110,116,58,32,101,114,114,111,114,10,0,110,101,119,110,111,100,101,58,32,81,117,101,114,121,45,116,97,98,108,101,32,111,118,101,114,102,108,111,119,10,0,110,101,119,110,111,100,101,0,110,101,119,116,114,97,112,58,32,84,114,97,112,101,122,111,105,100,45,116,97,98,108,101,32,111,118,101,114,102,108,111,119,32,37,100,10,0,110,101,119,116,114,97,112,0,105,110,100,101,120,46,99,0,82,84,114,101,101,83,101,97,114,99,104,0,110,45,62,108,101,118,101,108,32,62,61,32,48,0,82,84,114,101,101,73,110,115,101,114,116,0,108,101,118,101,108,32,62,61,32,48,32,38,38,32,108,101,118,101,108,32,60,61,32,40,42,110,41,45,62,108,101,118,101,108,0,114,45,62,98,111,117,110,100,97,114,121,91,105,93,32,60,61,32,114,45,62,98,111,117,110,100,97,114,121,91,78,85,77,68,73,77,83,32,43,32,105,93,0,114,32,38,38,32,110,32,38,38,32,110,101,119,0,82,84,114,101,101,73,110,115,101,114,116,50,0,108,101,118,101,108,32,62,61,32,48,32,38,38,32,108,101,118,101,108,32,60,61,32,110,45,62,108,101,118,101,108,0,70,65,76,83,69,0,110,111,100,101,46,99,0,78,111,100,101,67,111,118,101,114,0,114,32,38,38,32,110,0,80,105,99,107,66,114,97,110,99,104,0,65,100,100,66,114,97,110,99,104,0,105,32,60,32,78,79,68,69,67,65,82,68,0,110,101,119,0,110,32,38,38,32,105,32,62,61,32,48,32,38,38,32,105,32,60,32,78,79,68,69,67,65,82,68,0,68,105,115,99,111,110,66,114,97,110,99,104,0,114,0,114,101,99,116,97,110,103,108,101,46,99,0,82,101,99,116,65,114,101,97,0,108,97,98,101,108,58,32,97,114,101,97,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,114,116,114,101,101,10,0,114,32,38,38,32,114,114,0,67,111,109,98,105,110,101,82,101,99,116,0,114,32,38,38,32,115,0,79,118,101,114,108,97,112,0,110,0,115,112,108,105,116,46,113,46,99,0,83,112,108,105,116,78,111,100,101,0,98,0,110,45,62,99,111,117,110,116,32,43,32,40,42,110,110,41,45,62,99,111,117,110,116,32,61,61,32,78,79,68,69,67,65,82,68,32,43,32,49,0,76,111,97,100,78,111,100,101,115,0,113,0,112,0,114,116,112,45,62,115,112,108,105,116,46,80,97,114,116,105,116,105,111,110,115,91,48,93,46,112,97,114,116,105,116,105,111,110,91,105,93,32,61,61,32,48,32,124,124,32,114,116,112,45,62,115,112,108,105,116,46,80,97,114,116,105,116,105,111,110,115,91,48,93,46,112,97,114,116,105,116,105,111,110,91,105,93,32,61,61,32,49,0,114,116,112,45,62,115,112,108,105,116,46,80,97,114,116,105,116,105,111,110,115,91,48,93,46,99,111,117,110,116,91,48,93,32,43,32,114,116,112,45,62,115,112,108,105,116,46,80,97,114,116,105,116,105,111,110,115,91,48,93,46,99,111,117,110,116,91,49,93,32,61,61,32,78,79,68,69,67,65,82,68,32,43,32,49,0,77,101,116,104,111,100,90,101,114,111,0,114,116,112,45,62,115,112,108,105,116,46,80,97,114,116,105,116,105,111,110,115,91,48,93,46,99,111,117,110,116,91,48,93,32,62,61,32,114,116,112,45,62,77,105,110,70,105,108,108,32,38,38,32,114,116,112,45,62,115,112,108,105,116,46,80,97,114,116,105,116,105,111,110,115,91,48,93,46,99,111,117,110,116,91,49,93,32,62,61,32,114,116,112,45,62,77,105,110,70,105,108,108,0,33,114,116,112,45,62,115,112,108,105,116,46,80,97,114,116,105,116,105,111,110,115,91,48,93,46,116,97,107,101,110,91,105,93,0,67,108,97,115,115,105,102,121,0,71,101,116,66,114,97,110,99,104,101,115,0,110,45,62,98,114,97,110,99,104,91,105,93,46,99,104,105,108,100,0,0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,2,2,2,2,2,2,16,12,89,1,0,31,80,8,3,7,18,19,20,87,22,23,8,11,105,12,31,10,5,12,14,41,17,43,15,45,16,47,48,32,50,6,52,53,27,28,29,30,11,12,33,34,35,36,37,38,39,40,12,24,25,23,4,10,27,28,26,32,42,10,33,34,35,36,37,38,39,40,12,10,14,83,10,44,88,49,88,88,88,88,88,88,12,27,28,15,46,88,51,33,34,35,36,37,38,39,40,27,28,255,83,255,255,33,34,35,36,37,38,39,40,12,255,255,5,255,255,255,9,20,255,255,255,255,255,12,27,28,255,16,21,22,33,34,35,36,37,38,39,40,27,28,255,255,255,255,33,34,35,36,37,38,39,40,12,255,18,19,20,17,22,23,255,255,255,255,255,255,12,27,28,255,255,255,18,33,34,35,36,37,38,39,40,27,28,255,255,255,255,33,34,35,36,37,38,39,40,12,255,255,255,255,255,255,19,255,255,255,255,255,255,12,27,28,255,255,255,255,33,34,35,36,37,38,39,40,27,28,255,255,255,255,33,34,35,36,37,38,39,40,18,19,20,21,22,23,24,25,255,255,255,255,255,255,255,255,255,35,36,37,38,39,27,18,19,20,22,23,34,54,104,1,31,56,86,33,32,2,27,27,27,94,27,27,55,57,112,54,210,194,79,4,60,34,71,34,63,34,68,34,34,88,34,101,34,34,5,6,95,96,57,4,7,8,9,10,11,12,13,14,4,102,103,93,106,109,5,6,111,88,59,113,7,8,9,10,11,12,13,14,4,114,60,91,115,62,97,70,27,18,19,20,22,23,4,5,6,63,65,98,73,7,8,9,10,11,12,13,14,5,6,0,92,0,0,7,8,9,10,11,12,13,14,4,0,0,79,0,0,0,83,66,0,0,0,0,0,4,5,6,0,68,84,85,7,8,9,10,11,12,13,14,5,6,0,0,0,0,7,8,9,10,11,12,13,14,4,0,42,44,46,71,49,51,0,0,0,0,0,0,4,5,6,0,0,0,74,7,8,9,10,11,12,13,14,5,6,0,0,0,0,7,8,9,10,11,12,13,14,4,0,0,0,0,0,0,76,0,0,0,0,0,0,4,5,6,0,0,0,0,7,8,9,10,11,12,13,14,5,6,0,0,0,0,7,8,9,10,11,12,13,14,41,43,45,47,48,50,52,53,0,0,0,0,0,0,0,0,0,41,43,45,48,50,0,4,47,0,36,35,0,18,20,22,26,28,30,32,24,0,5,7,47,47,47,0,47,47,0,0,9,8,40,0,0,1,34,2,6,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,37,3,38,19,10,41,21,11,42,23,14,45,25,17,27,12,43,29,13,44,31,15,33,16,0,51,0,48,0,47,67,0,49,0,47,0,53,46,39,66,50,65,0,58,56,0,60,52,69,0,54,0,64,0,0,63,0,68,55,59,57,61,0,2,3,3,1,1,2,1,1,1,3,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,2,0,6,1,3,3,3,3,3,1,0,1,2,3,0,4,1,2,3,0,4,0,4,0,4,0,3,2,1,2,1,2,1,83,121,110,116,97,120,32,101,114,114,111,114,58,32,110,111,110,45,115,112,97,99,101,32,115,116,114,105,110,103,32,117,115,101,100,32,98,101,102,111,114,101,32,60,84,65,66,76,69,62,0,83,121,110,116,97,120,32,101,114,114,111,114,58,32,110,111,110,45,115,112,97,99,101,32,115,116,114,105,110,103,32,117,115,101,100,32,97,102,116,101,114,32,60,47,84,65,66,76,69,62,0,0,41,42,42,42,43,44,44,45,45,45,45,45,45,45,45,45,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,62,63,63,65,64,66,66,66,66,66,66,67,67,68,68,68,70,69,71,71,71,73,72,74,72,75,72,76,72,77,77,78,78,79,79,255,3,15,16,17,35,58,36,61,37,64,21,67,38,69,39,72,24,75,25,77,26,40,28,78,29,30,80,81,82,89,90,108,107,110,99,100,87,105,69,114,114,111,114,58,32,100,105,115,99,97,114,100,105,110,103,0,0,1,7,42,12,27,28,33,34,35,36,37,38,39,40,43,44,45,46,48,50,52,54,56,58,60,62,63,64,66,67,0,3,8,45,46,48,50,54,56,63,44,64,44,64,44,64,44,44,64,44,64,44,44,12,8,31,11,47,47,14,49,49,15,51,51,20,53,16,55,55,17,57,57,18,59,19,61,65,5,68,69,70,9,21,22,69,78,32,71,72,63,67,23,69,29,30,43,66,76,77,6,24,25,72,79,4,74,73,10,75,26,72,10,10,10,69,114,114,111,114,58,32,112,111,112,112,105,110,103,0,109,101,109,111,114,121,32,101,120,104,97,117,115,116,101,100,0,67,108,101,97,110,117,112,58,32,100,105,115,99,97,114,100,105,110,103,32,108,111,111,107,97,104,101,97,100,0,67,108,101,97,110,117,112,58,32,112,111,112,112,105,110,103,0,68,101,108,101,116,105,110,103,0,0,37,115,32,105,110,32,108,105,110,101,32,37,100,32,10,0,45,45,0,76,97,98,101,108,32,99,108,111,115,101,100,32,98,101,102,111,114,101,32,101,110,100,32,111,102,32,72,84,77,76,32,101,108,101,109,101,110,116,10,0,85,110,99,108,111,115,101,100,32,99,111,109,109,101,110,116,10,0,60,47,72,84,77,76,62,0,60,72,84,77,76,62,0,84,65,66,76,69,0,84,82,0,84,72,0,84,68,0,72,84,77,76,0,70,79,78,84,0,66,0,85,0,79,0,73,0,83,85,80,0,83,85,66,0,83,0,66,82,0,72,82,0,86,82,0,73,77,71,0,85,110,107,110,111,119,110,32,72,84,77,76,32,101,108,101,109,101,110,116,32,60,37,115,62,32,111,110,32,108,105,110,101,32,37,100,32,10,0,60,73,77,71,62,0,73,108,108,101,103,97,108,32,97,116,116,114,105,98,117,116,101,32,37,115,32,105,110,32,37,115,32,45,32,105,103,110,111,114,101,100,10,0,115,99,97,108,101,0,115,114,99,0,60,66,82,62,0,97,108,105,103,110,0,73,71,72,84,0,69,70,84,0,69,78,84,69,82,0,73,108,108,101,103,97,108,32,118,97,108,117,101,32,37,115,32,102,111,114,32,65,76,73,71,78,32,45,32,105,103,110,111,114,101,100,10,0,60,70,79,78,84,62,0,99,111,108,111,114,0,102,97,99,101,0,112,111,105,110,116,45,115,105,122,101,0,80,79,73,78,84,45,83,73,90,69,0,73,109,112,114,111,112,101,114,32,37,115,32,118,97,108,117,101,32,37,115,32,45,32,105,103,110,111,114,101,100,0,37,115,32,118,97,108,117,101,32,37,115,32,62,32,37,100,32,45,32,116,111,111,32,108,97,114,103,101,32,45,32,105,103,110,111,114,101,100,0,37,115,32,118,97,108,117,101,32,37,115,32,60,32,37,100,32,45,32,116,111,111,32,115,109,97,108,108,32,45,32,105,103,110,111,114,101,100,0,60,84,68,62,0,98,97,108,105,103,110,0,98,103,99,111,108,111,114,0,98,111,114,100,101,114,0,99,101,108,108,112,97,100,100,105,110,103,0,99,101,108,108,115,112,97,99,105,110,103,0,99,111,108,115,112,97,110,0,102,105,120,101,100,115,105,122,101,0,103,114,97,100,105,101,110,116,97,110,103,108,101,0,104,101,105,103,104,116,0,104,114,101,102,0,105,100,0,112,111,114,116,0,114,111,119,115,112,97,110,0,115,105,100,101,115,0,115,116,121,108,101,0,116,97,114,103,101,116,0,116,105,116,108,101,0,116,111,111,108,116,105,112,0,118,97,108,105,103,110,0,119,105,100,116,104,0,87,73,68,84,72,0,79,84,84,79,77,0,79,80,0,73,68,68,76,69,0,73,108,108,101,103,97,108,32,118,97,108,117,101,32,37,115,32,102,111,114,32,86,65,76,73,71,78,32,45,32,105,103,110,111,114,101,100,10,0,32,44,0,79,85,78,68,69,68,0,65,68,73,65,76,0,73,108,108,101,103,97,108,32,118,97,108,117,101,32,37,115,32,102,111,114,32,83,84,89,76,69,32,45,32,105,103,110,111,114,101,100,10,0,83,79,76,73,68,0,73,78,86,73,83,73,66,76,69,0,73,78,86,73,83,0,68,79,84,84,69,68,0,68,65,83,72,69,68,0,85,110,114,101,99,111,103,110,105,122,101,100,32,99,104,97,114,97,99,116,101,114,32,39,37,99,39,32,40,37,100,41,32,105,110,32,115,105,100,101,115,32,97,116,116,114,105,98,117,116,101,10,0,82,79,87,83,80,65,78,0,82,79,87,83,80,65,78,32,118,97,108,117,101,32,99,97,110,110,111,116,32,98,101,32,48,32,45,32,105,103,110,111,114,101,100,10,0,72,69,73,71,72,84,0,71,82,65,68,73,69,78,84,65,78,71,76,69,0,82,85,69,0,65,76,83,69,0,73,108,108,101,103,97,108,32,118,97,108,117,101,32,37,115,32,102,111,114,32,70,73,88,69,68,83,73,90,69,32,45,32,105,103,110,111,114,101,100,10,0,67,79,76,83,80,65,78,0,67,79,76,83,80,65,78,32,118,97,108,117,101,32,99,97,110,110,111,116,32,98,101,32,48,32,45,32,105,103,110,111,114,101,100,10,0,67,69,76,76,83,80,65,67,73,78,71,0,67,69,76,76,80,65,68,68,73,78,71,0,66,79,82,68,69,82,0,73,108,108,101,103,97,108,32,118,97,108,117,101,32,37,115,32,102,111,114,32,66,65,76,73,71,78,32,105,110,32,84,68,32,45,32,105,103,110,111,114,101,100,10,0,69,88,84,0,73,108,108,101,103,97,108,32,118,97,108,117,101,32,37,115,32,102,111,114,32,65,76,73,71,78,32,105,110,32,84,68,32,45,32,105,103,110,111,114,101,100,10,0,60,84,65,66,76,69,62,0,99,101,108,108,98,111,114,100,101,114,0,99,111,108,117,109,110,115,0,114,111,119,115,0,85,110,107,110,111,119,110,32,118,97,108,117,101,32,37,115,32,102,111,114,32,82,79,87,83,32,45,32,105,103,110,111,114,101,100,10,0,85,110,107,110,111,119,110,32,118,97,108,117,101,32,37,115,32,102,111,114,32,67,79,76,85,77,78,83,32,45,32,105,103,110,111,114,101,100,10,0,67,69,76,76,83,66,79,82,68,69,82,0,46,46,46,32,37,115,32,46,46,46,10,0,106,32,61,61,32,48,0,99,118,116,46,99,0,80,111,98,115,112,97,116,104,0,114,111,117,116,101,46,99,0,108,105,98,112,97,116,104,47,37,115,58,37,100,58,32,37,115,10,0,115,104,111,114,116,101,115,116,46,99,0,115,111,117,114,99,101,32,112,111,105,110,116,32,110,111,116,32,105,110,32,97,110,121,32,116,114,105,97,110,103,108,101,0,100,101,115,116,105,110,97,116,105,111,110,32,112,111,105,110,116,32,110,111,116,32,105,110,32,97,110,121,32,116,114,105,97,110,103,108,101,0,99,97,110,110,111,116,32,102,105,110,100,32,116,114,105,97,110,103,108,101,32,112,97,116,104,0,99,97,110,110,111,116,32,109,97,108,108,111,99,32,111,112,115,0,99,97,110,110,111,116,32,114,101,97,108,108,111,99,32,111,112,115,0,116,114,105,97,110,103,117,108,97,116,105,111,110,32,102,97,105,108,101,100,0,99,97,110,110,111,116,32,109,97,108,108,111,99,32,116,114,105,115,0,99,97,110,110,111,116,32,114,101,97,108,108,111,99,32,116,114,105,115,0,99,97,110,110,111,116,32,109,97,108,108,111,99,32,100,113,46,112,110,108,115,0,99,97,110,110,111,116,32,114,101,97,108,108,111,99,32,100,113,46,112,110,108,115,0,99,97,110,110,111,116,32,109,97,108,108,111,99,32,112,110,108,115,0,99,97,110,110,111,116,32,109,97,108,108,111,99,32,112,110,108,112,115,0,99,97,110,110,111,116,32,114,101,97,108,108,111,99,32,112,110,108,115,0,99,97,110,110,111,116,32,114,101,97,108,108,111,99,32,112,110,108,112,115,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,115,121,110,116,97,120,32,101,114,114,111,114,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,67,68,65,84,65,0,73,68,0,73,68,82,69,70,0,73,68,82,69,70,83,0,69,78,84,73,84,89,0,69,78,84,73,84,73,69,83,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,124,0,78,79,84,65,84,73,79,78,40,0,40,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,67,68,65,84,65,91,67,68,65,84,65,91,67,68,65,84,65,91,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,115,116,97,110,100,97,108,111,110,101,0,85,83,45,65,83,67,73,73,0,85,84,70,45,49,54,66,69,0,85,84,70,45,49,54,76,69,0,69,78,84,73,84,89,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,83,89,83,84,69,77,0,80,85,66,76,73,67,0,69,77,80,84,89,0,65,78,89,0,80,67,68,65,84,65,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,70,73,88,69,68,0,67,68,65,84,65,0,73,68,0,73,68,82,69,70,0,73,68,82,69,70,83,0,69,78,84,73,84,73,69,83,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,78,68,65,84,65,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,68,79,67,84,89,80,69,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+173662);allocate([255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,105,110,102,105,110,105,116,121,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,47,112,114,111,99,47,115,101,108,102,47,102,100,47,0,67,46,85,84,70,45,56,0,114,119,97,0,119,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,116,109,112,0,47,116,109,112,47,116,37,120,45,37,120],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+183902);allocate([17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,45,43,32,32,32,48,88,48,120,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,110,97,110,0,78,65,78,0,46,0,9,0,10,0,13,0,12,0,7,0,27,0,91,91,58,97,108,110,117,109,58,93,95,93,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,91,91,58,115,112,97,99,101,58,93,93,0,91,94,91,58,115,112,97,99,101,58,93,93,0,91,91,58,100,105,103,105,116,58,93,93,0,91,94,91,58,100,105,103,105,116,58,93,93,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+192848);var tempDoublePtr=Runtime.alignMemory(allocate(12,"i8",ALLOC_STATIC),8);assert(tempDoublePtr%8==0);function copyTempFloat(ptr){HEAP8[tempDoublePtr]=HEAP8[ptr];HEAP8[tempDoublePtr+1]=HEAP8[ptr+1];HEAP8[tempDoublePtr+2]=HEAP8[ptr+2];HEAP8[tempDoublePtr+3]=HEAP8[ptr+3]}function copyTempDouble(ptr){HEAP8[tempDoublePtr]=HEAP8[ptr];HEAP8[tempDoublePtr+1]=HEAP8[ptr+1];HEAP8[tempDoublePtr+2]=HEAP8[ptr+2];HEAP8[tempDoublePtr+3]=HEAP8[ptr+3];HEAP8[tempDoublePtr+4]=HEAP8[ptr+4];HEAP8[tempDoublePtr+5]=HEAP8[ptr+5];HEAP8[tempDoublePtr+6]=HEAP8[ptr+6];HEAP8[tempDoublePtr+7]=HEAP8[ptr+7]}Module["_i64Subtract"]=_i64Subtract;Module["_i64Add"]=_i64Add;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up--;up){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var fd=process.stdin.fd;var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null);if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.buffer.byteLength:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var errored=false;var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){flags&=~32768;flags&=~524288;if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount:(function(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);var createdParents={};function ensureParent(path){var parts=path.split("/");var parent=root;for(var i=0;i<parts.length-1;i++){var curr=parts.slice(0,i+1).join("/");if(!createdParents[curr]){createdParents[curr]=WORKERFS.createNode(parent,curr,WORKERFS.DIR_MODE,0)}parent=createdParents[curr]}return parent}function base(path){var parts=path.split("/");return parts[parts.length-1]}Array.prototype.forEach.call(mount.opts["files"]||[],(function(file){WORKERFS.createNode(ensureParent(file.name),base(file.name),WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)}));(mount.opts["blobs"]||[]).forEach((function(obj){WORKERFS.createNode(ensureParent(obj["name"]),base(obj["name"]),WORKERFS.FILE_MODE,0,obj["data"])}));(mount.opts["packages"]||[]).forEach((function(pack){pack["metadata"].files.forEach((function(file){var name=file.filename.substr(1);WORKERFS.createNode(ensureParent(name),base(name),WORKERFS.FILE_MODE,0,pack["blob"].slice(file.start,file.end))}))}));return root}),createNode:(function(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();assert(WORKERFS.FILE_MODE!==WORKERFS.DIR_MODE);if(mode===WORKERFS.FILE_MODE){node.size=contents.size;node.contents=contents}else{node.size=4096;node.contents={}}if(parent){parent.contents[name]=node}return node}),node_ops:{getattr:(function(node){return{dev:1,ino:undefined,mode:node.mode,nlink:1,uid:0,gid:0,rdev:undefined,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}}),lookup:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}),mknod:(function(parent,name,mode,dev){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rename:(function(oldNode,newDir,newName){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),unlink:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rmdir:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readdir:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),symlink:(function(parent,newName,oldPath){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readlink:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)})},stream_ops:{read:(function(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size}),write:(function(stream,buffer,offset,length,position){throw new FS.ErrnoError(ERRNO_CODES.EIO)}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var _stdin=allocate(1,"i32*",ALLOC_STATIC);var _stdout=allocate(1,"i32*",ALLOC_STATIC);var _stderr=allocate(1,"i32*",ALLOC_STATIC);var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}var mounts=FS.getMounts(FS.root.mount);var completed=0;function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=mounts.length){callback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){if(err===ERRNO_CODES.EISDIR)err=ERRNO_CODES.EPERM;throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;Module["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)}),munmap:(function(stream){return 0}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(stream,buffer,offset,length,pos){return length})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createSpecialDirectories:(function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:(function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:(function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:(function(){return stream.path})}};ret.parent=ret;return ret})};return node})},{},"/proc/self/fd")}),createStandardStreams:(function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={"MEMFS":MEMFS,"IDBFS":IDBFS,"NODEFS":NODEFS,"WORKERFS":WORKERFS}}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;var fflush=Module["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(Module["read"]){try{obj.contents=intArrayFromString(Module["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;console.log("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperties(lazyArray,{length:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})},chunkSize:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})}});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:(function(){return this.contents.length})}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;Module["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency(dep)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:(function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);dir=dirstream.path}path=PATH.join2(dir,path)}return path}),doStat:(function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-ERRNO_CODES.ENOTDIR}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;HEAP32[buf+36>>2]=stat.size;HEAP32[buf+40>>2]=4096;HEAP32[buf+44>>2]=stat.blocks;HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+52>>2]=0;HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ino;return 0}),doMsync:(function(addr,stream,len,flags){var buffer=new Uint8Array(HEAPU8.subarray(addr,addr+len));FS.msync(stream,buffer,0,len,flags)}),doMkdir:(function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}),doMknod:(function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-ERRNO_CODES.EINVAL}FS.mknod(path,mode,dev);return 0}),doReadlink:(function(path,buf,bufsize){if(bufsize<=0)return-ERRNO_CODES.EINVAL;var ret=FS.readlink(path);ret=ret.slice(0,Math.max(0,bufsize));writeStringToMemory(ret,buf,true);return ret.length}),doAccess:(function(path,amode){if(amode&~7){return-ERRNO_CODES.EINVAL}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-ERRNO_CODES.EACCES}return 0}),doDup:(function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd}),doReadv:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret}),doWritev:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret}),varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),getStreamFromFD:(function(){var stream=FS.getStream(SYSCALLS.get());if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return stream}),getSocketFromFD:(function(){var socket=SOCKFS.getSocket(SYSCALLS.get());if(!socket)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return socket}),getSocketAddress:(function(allowNull){var addrp=SYSCALLS.get(),addrlen=SYSCALLS.get();if(allowNull&&addrp===0)return null;var info=__read_sockaddr(addrp,addrlen);if(info.errno)throw new FS.ErrnoError(info.errno);info.addr=DNS.lookup_addr(info.addr)||info.addr;return info}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall192(which,varargs){SYSCALLS.varargs=varargs;try{var addr=SYSCALLS.get(),len=SYSCALLS.get(),prot=SYSCALLS.get(),flags=SYSCALLS.get(),fd=SYSCALLS.get(),off=SYSCALLS.get();off<<=12;var ptr;var allocated=false;if(fd===-1){ptr=_malloc(len);if(!ptr)return-ERRNO_CODES.ENOMEM;_memset(ptr,0,len);allocated=true}else{var info=FS.getStream(fd);if(!info)return-ERRNO_CODES.EBADF;var res=FS.mmap(info,HEAPU8,addr,len,off,prot,flags);ptr=res.ptr;allocated=res.allocated}SYSCALLS.mappings[ptr]={malloc:ptr,len:len,allocated:allocated,fd:fd,flags:flags};return ptr}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall195(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr(),buf=SYSCALLS.get();return SYSCALLS.doStat(FS.stat,path,buf)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall197(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),buf=SYSCALLS.get();return SYSCALLS.doStat(FS.stat,stream.path,buf)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var _emscripten_check_longjmp=true;var _emscripten_cleanup_setjmp=true;var _emscripten_postinvoke=true;function _realloc(){throw"bad"}Module["_realloc"]=_realloc;Module["_saveSetjmp"]=_saveSetjmp;var _environ=allocate(1,"i32*",ALLOC_STATIC);var ___environ=_environ;function ___buildEnvironment(env){var MAX_ENV_VALUES=64;var TOTAL_ENV_SIZE=1024;var poolPtr;var envPtr;if(!___buildEnvironment.called){___buildEnvironment.called=true;ENV["USER"]=ENV["LOGNAME"]="web_user";ENV["PATH"]="/";ENV["PWD"]="/";ENV["HOME"]="/home/web_user";ENV["LANG"]="C";ENV["_"]=Module["thisProgram"];poolPtr=allocate(TOTAL_ENV_SIZE,"i8",ALLOC_STATIC);envPtr=allocate(MAX_ENV_VALUES*4,"i8*",ALLOC_STATIC);HEAP32[envPtr>>2]=poolPtr;HEAP32[_environ>>2]=envPtr}else{envPtr=HEAP32[_environ>>2];poolPtr=HEAP32[envPtr>>2]}var strings=[];var totalSize=0;for(var key in env){if(typeof env[key]==="string"){var line=key+"="+env[key];strings.push(line);totalSize+=line.length}}if(totalSize>TOTAL_ENV_SIZE){throw new Error("Environment size exceeded TOTAL_ENV_SIZE!")}var ptrSize=4;for(var i=0;i<strings.length;i++){var line=strings[i];writeAsciiToMemory(line,poolPtr);HEAP32[envPtr+i*ptrSize>>2]=poolPtr;poolPtr+=line.length+1}HEAP32[envPtr+strings.length*ptrSize>>2]=0}var ENV={};function _setenv(envname,envval,overwrite){if(envname===0){___setErrNo(ERRNO_CODES.EINVAL);return-1}var name=Pointer_stringify(envname);var val=Pointer_stringify(envval);if(name===""||name.indexOf("=")!==-1){___setErrNo(ERRNO_CODES.EINVAL);return-1}if(ENV.hasOwnProperty(name)&&!overwrite)return 0;ENV[name]=val;___buildEnvironment(ENV);return 0}function ___syscall91(which,varargs){SYSCALLS.varargs=varargs;try{var addr=SYSCALLS.get(),len=SYSCALLS.get();var info=SYSCALLS.mappings[addr];if(!info)return 0;if(len===info.len){var stream=FS.getStream(info.fd);SYSCALLS.doMsync(addr,stream,len,info.flags);FS.munmap(stream);SYSCALLS.mappings[addr]=null;if(info.allocated){_free(info.malloc)}}return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __exit(status){Module["exit"](status)}function _exit(status){__exit(status)}function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),op=SYSCALLS.get();switch(op){case 21505:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21506:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21519:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0};case 21520:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return-ERRNO_CODES.EINVAL};case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)};default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _sysconf(name){switch(name){case 30:return PAGE_SIZE;case 85:return totalMemory/PAGE_SIZE;case 132:case 133:case 12:case 137:case 138:case 15:case 235:case 16:case 17:case 18:case 19:case 20:case 149:case 13:case 10:case 236:case 153:case 9:case 21:case 22:case 159:case 154:case 14:case 77:case 78:case 139:case 80:case 81:case 82:case 68:case 67:case 164:case 11:case 29:case 47:case 48:case 95:case 52:case 51:case 46:return 200809;case 79:return 0;case 27:case 246:case 127:case 128:case 23:case 24:case 160:case 161:case 181:case 182:case 242:case 183:case 184:case 243:case 244:case 245:case 165:case 178:case 179:case 49:case 50:case 168:case 169:case 175:case 170:case 171:case 172:case 97:case 76:case 32:case 173:case 35:return-1;case 176:case 177:case 7:case 155:case 8:case 157:case 125:case 126:case 92:case 93:case 129:case 130:case 131:case 94:case 91:return 1;case 74:case 60:case 69:case 70:case 4:return 1024;case 31:case 42:case 72:return 32;case 87:case 26:case 33:return 2147483647;case 34:case 1:return 47839;case 38:case 36:return 99;case 43:case 37:return 2048;case 0:return 2097152;case 3:return 65536;case 28:return 32768;case 44:return 32767;case 75:return 16384;case 39:return 1e3;case 89:return 700;case 71:return 256;case 40:return 255;case 2:return 100;case 180:return 64;case 25:return 20;case 5:return 16;case 6:return 6;case 73:return 4;case 84:{if(typeof navigator==="object")return navigator["hardwareConcurrency"]||1;return 1}}___setErrNo(ERRNO_CODES.EINVAL);return-1}Module["_bitshift64Lshr"]=_bitshift64Lshr;var _emscripten_prep_setjmp=true;function ___syscall33(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr(),amode=SYSCALLS.get();return SYSCALLS.doAccess(path,amode)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var _BDtoIHigh=true;function _pthread_cleanup_push(routine,arg){__ATEXIT__.push((function(){Runtime.dynCall("vi",routine,[arg])}));_pthread_cleanup_push.level=__ATEXIT__.length}Module["_testSetjmp"]=_testSetjmp;function _longjmp(env,value){asm["setThrew"](env,value||1);throw"longjmp"}function _emscripten_longjmp(env,value){_longjmp(env,value)}var _ceil=Math_ceil;function _pthread_cleanup_pop(){assert(_pthread_cleanup_push.level==__ATEXIT__.length,"cannot pop if something else added meanwhile!");__ATEXIT__.pop();_pthread_cleanup_push.level=__ATEXIT__.length}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}Module["_memcpy"]=_memcpy;var _llvm_pow_f64=Math_pow;function _sbrk(bytes){var self=_sbrk;if(!self.called){DYNAMICTOP=alignMemoryPage(DYNAMICTOP);self.called=true;assert(Runtime.dynamicAlloc);self.alloc=Runtime.dynamicAlloc;Runtime.dynamicAlloc=(function(){abort("cannot dynamically allocate, sbrk now has control")})}var ret=DYNAMICTOP;if(bytes!=0){var success=self.alloc(bytes);if(!success)return-1>>>0}return ret}Module["_memmove"]=_memmove;var _emscripten_preinvoke=true;var _BItoD=true;function ___assert_fail(condition,filename,line,func){ABORT=true;throw"Assertion failed: "+Pointer_stringify(condition)+", at: "+[filename?Pointer_stringify(filename):"unknown filename",line,func?Pointer_stringify(func):"unknown function"]+" at "+stackTrace()}var PROCINFO={ppid:1,pid:42,sid:42,pgid:42};function ___syscall20(which,varargs){SYSCALLS.varargs=varargs;try{return PROCINFO.pid}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["_memset"]=_memset;var _BDtoILow=true;Module["_bitshift64Shl"]=_bitshift64Shl;function _abort(){Module["abort"]()}var _tan=Math_tan;function ___lock(){}function ___unlock(){}var _asin=Math_asin;var _llvm_fabs_f64=Math_abs;var _atanf=Math_atan;var _fabs=Math_abs;var _floor=Math_floor;var _sqrt=Math_sqrt;var _emscripten_asm_const_int=true;var _abs=Math_abs;function _emscripten_set_main_loop_timing(mode,value){Browser.mainLoop.timingMode=mode;Browser.mainLoop.timingValue=value;if(!Browser.mainLoop.func){return 1}if(mode==0){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setTimeout(){setTimeout(Browser.mainLoop.runner,value)};Browser.mainLoop.method="timeout"}else if(mode==1){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_rAF(){Browser.requestAnimationFrame(Browser.mainLoop.runner)};Browser.mainLoop.method="rAF"}else if(mode==2){if(!window["setImmediate"]){var setImmediates=[];var emscriptenMainLoopMessageId="__emcc";function Browser_setImmediate_messageHandler(event){if(event.source===window&&event.data===emscriptenMainLoopMessageId){event.stopPropagation();setImmediates.shift()()}}window.addEventListener("message",Browser_setImmediate_messageHandler,true);window["setImmediate"]=function Browser_emulated_setImmediate(func){setImmediates.push(func);window.postMessage(emscriptenMainLoopMessageId,"*")}}Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setImmediate(){window["setImmediate"](Browser.mainLoop.runner)};Browser.mainLoop.method="immediate"}return 0}function _emscripten_set_main_loop(func,fps,simulateInfiniteLoop,arg,noSetTiming){Module["noExitRuntime"]=true;assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");Browser.mainLoop.func=func;Browser.mainLoop.arg=arg;var thisMainLoopId=Browser.mainLoop.currentlyRunningMainloop;Browser.mainLoop.runner=function Browser_mainLoop_runner(){if(ABORT)return;if(Browser.mainLoop.queue.length>0){var start=Date.now();var blocker=Browser.mainLoop.queue.shift();blocker.func(blocker.arg);if(Browser.mainLoop.remainingBlockers){var remaining=Browser.mainLoop.remainingBlockers;var next=remaining%1==0?remaining-1:Math.floor(remaining);if(blocker.counted){Browser.mainLoop.remainingBlockers=next}else{next=next+.5;Browser.mainLoop.remainingBlockers=(8*remaining+next)/9}}console.log('main loop blocker "'+blocker.name+'" took '+(Date.now()-start)+" ms");Browser.mainLoop.updateStatus();setTimeout(Browser.mainLoop.runner,0);return}if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0;if(Browser.mainLoop.timingMode==1&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0){Browser.mainLoop.scheduler();return}if(Browser.mainLoop.method==="timeout"&&Module.ctx){Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");Browser.mainLoop.method=""}Browser.mainLoop.runIter((function(){if(typeof arg!=="undefined"){Runtime.dynCall("vi",func,[arg])}else{Runtime.dynCall("v",func)}}));if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;if(typeof SDL==="object"&&SDL.audio&&SDL.audio.queueNewAudioData)SDL.audio.queueNewAudioData();Browser.mainLoop.scheduler()};if(!noSetTiming){if(fps&&fps>0)_emscripten_set_main_loop_timing(0,1e3/fps);else _emscripten_set_main_loop_timing(1,1);Browser.mainLoop.scheduler()}if(simulateInfiniteLoop){throw"SimulateInfiniteLoop"}}var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:(function(){Browser.mainLoop.scheduler=null;Browser.mainLoop.currentlyRunningMainloop++}),resume:(function(){Browser.mainLoop.currentlyRunningMainloop++;var timingMode=Browser.mainLoop.timingMode;var timingValue=Browser.mainLoop.timingValue;var func=Browser.mainLoop.func;Browser.mainLoop.func=null;_emscripten_set_main_loop(func,0,false,Browser.mainLoop.arg,true);_emscripten_set_main_loop_timing(timingMode,timingValue);Browser.mainLoop.scheduler()}),updateStatus:(function(){if(Module["setStatus"]){var message=Module["statusMessage"]||"Please wait...";var remaining=Browser.mainLoop.remainingBlockers;var expected=Browser.mainLoop.expectedBlockers;if(remaining){if(remaining<expected){Module["setStatus"](message+" ("+(expected-remaining)+"/"+expected+")")}else{Module["setStatus"](message)}}else{Module["setStatus"]("")}}}),runIter:(function(func){if(ABORT)return;if(Module["preMainLoop"]){var preRet=Module["preMainLoop"]();if(preRet===false){return}}try{func()}catch(e){if(e instanceof ExitStatus){return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}if(Module["postMainLoop"])Module["postMainLoop"]()})},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:(function(){if(!Module["preloadPlugins"])Module["preloadPlugins"]=[];if(Browser.initted)return;Browser.initted=true;try{new Blob;Browser.hasBlobConstructor=true}catch(e){Browser.hasBlobConstructor=false;console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder=typeof MozBlobBuilder!="undefined"?MozBlobBuilder:typeof WebKitBlobBuilder!="undefined"?WebKitBlobBuilder:!Browser.hasBlobConstructor?console.log("warning: no BlobBuilder"):null;Browser.URLObject=typeof window!="undefined"?window.URL?window.URL:window.webkitURL:undefined;if(!Module.noImageDecoding&&typeof Browser.URLObject==="undefined"){console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");Module.noImageDecoding=true}var imagePlugin={};imagePlugin["canHandle"]=function imagePlugin_canHandle(name){return!Module.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(name)};imagePlugin["handle"]=function imagePlugin_handle(byteArray,name,onload,onerror){var b=null;if(Browser.hasBlobConstructor){try{b=new Blob([byteArray],{type:Browser.getMimetype(name)});if(b.size!==byteArray.length){b=new Blob([(new Uint8Array(byteArray)).buffer],{type:Browser.getMimetype(name)})}}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}}if(!b){var bb=new Browser.BlobBuilder;bb.append((new Uint8Array(byteArray)).buffer);b=bb.getBlob()}var url=Browser.URLObject.createObjectURL(b);var img=new Image;img.onload=function img_onload(){assert(img.complete,"Image "+name+" could not be decoded");var canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;var ctx=canvas.getContext("2d");ctx.drawImage(img,0,0);Module["preloadedImages"][name]=canvas;Browser.URLObject.revokeObjectURL(url);if(onload)onload(byteArray)};img.onerror=function img_onerror(event){console.log("Image "+url+" could not be decoded");if(onerror)onerror()};img.src=url};Module["preloadPlugins"].push(imagePlugin);var audioPlugin={};audioPlugin["canHandle"]=function audioPlugin_canHandle(name){return!Module.noAudioDecoding&&name.substr(-4)in{".ogg":1,".wav":1,".mp3":1}};audioPlugin["handle"]=function audioPlugin_handle(byteArray,name,onload,onerror){var done=false;function finish(audio){if(done)return;done=true;Module["preloadedAudios"][name]=audio;if(onload)onload(byteArray)}function fail(){if(done)return;done=true;Module["preloadedAudios"][name]=new Audio;if(onerror)onerror()}if(Browser.hasBlobConstructor){try{var b=new Blob([byteArray],{type:Browser.getMimetype(name)})}catch(e){return fail()}var url=Browser.URLObject.createObjectURL(b);var audio=new Audio;audio.addEventListener("canplaythrough",(function(){finish(audio)}),false);audio.onerror=function audio_onerror(event){if(done)return;console.log("warning: browser could not fully decode audio "+name+", trying slower base64 approach");function encode64(data){var BASE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var PAD="=";var ret="";var leftchar=0;var leftbits=0;for(var i=0;i<data.length;i++){leftchar=leftchar<<8|data[i];leftbits+=8;while(leftbits>=6){var curr=leftchar>>leftbits-6&63;leftbits-=6;ret+=BASE[curr]}}if(leftbits==2){ret+=BASE[(leftchar&3)<<4];ret+=PAD+PAD}else if(leftbits==4){ret+=BASE[(leftchar&15)<<2];ret+=PAD}return ret}audio.src="data:audio/x-"+name.substr(-3)+";base64,"+encode64(byteArray);finish(audio)};audio.src=url;Browser.safeSetTimeout((function(){finish(audio)}),1e4)}else{return fail()}};Module["preloadPlugins"].push(audioPlugin);var canvas=Module["canvas"];function pointerLockChange(){Browser.pointerLock=document["pointerLockElement"]===canvas||document["mozPointerLockElement"]===canvas||document["webkitPointerLockElement"]===canvas||document["msPointerLockElement"]===canvas}if(canvas){canvas.requestPointerLock=canvas["requestPointerLock"]||canvas["mozRequestPointerLock"]||canvas["webkitRequestPointerLock"]||canvas["msRequestPointerLock"]||(function(){});canvas.exitPointerLock=document["exitPointerLock"]||document["mozExitPointerLock"]||document["webkitExitPointerLock"]||document["msExitPointerLock"]||(function(){});canvas.exitPointerLock=canvas.exitPointerLock.bind(document);document.addEventListener("pointerlockchange",pointerLockChange,false);document.addEventListener("mozpointerlockchange",pointerLockChange,false);document.addEventListener("webkitpointerlockchange",pointerLockChange,false);document.addEventListener("mspointerlockchange",pointerLockChange,false);if(Module["elementPointerLock"]){canvas.addEventListener("click",(function(ev){if(!Browser.pointerLock&&canvas.requestPointerLock){canvas.requestPointerLock();ev.preventDefault()}}),false)}}}),createContext:(function(canvas,useWebGL,setInModule,webGLContextAttributes){if(useWebGL&&Module.ctx&&canvas==Module.canvas)return Module.ctx;var ctx;var contextHandle;if(useWebGL){var contextAttributes={antialias:false,alpha:false};if(webGLContextAttributes){for(var attribute in webGLContextAttributes){contextAttributes[attribute]=webGLContextAttributes[attribute]}}contextHandle=GL.createContext(canvas,contextAttributes);if(contextHandle){ctx=GL.getContext(contextHandle).GLctx}canvas.style.backgroundColor="black"}else{ctx=canvas.getContext("2d")}if(!ctx)return null;if(setInModule){if(!useWebGL)assert(typeof GLctx==="undefined","cannot set in module if GLctx is used, but we are a non-GL context that would replace it");Module.ctx=ctx;if(useWebGL)GL.makeContextCurrent(contextHandle);Module.useWebGL=useWebGL;Browser.moduleContextCreatedCallbacks.forEach((function(callback){callback()}));Browser.init()}return ctx}),destroyContext:(function(canvas,useWebGL,setInModule){}),fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:(function(lockPointer,resizeCanvas,vrDevice){Browser.lockPointer=lockPointer;Browser.resizeCanvas=resizeCanvas;Browser.vrDevice=vrDevice;if(typeof Browser.lockPointer==="undefined")Browser.lockPointer=true;if(typeof Browser.resizeCanvas==="undefined")Browser.resizeCanvas=false;if(typeof Browser.vrDevice==="undefined")Browser.vrDevice=null;var canvas=Module["canvas"];function fullScreenChange(){Browser.isFullScreen=false;var canvasContainer=canvas.parentNode;if((document["webkitFullScreenElement"]||document["webkitFullscreenElement"]||document["mozFullScreenElement"]||document["mozFullscreenElement"]||document["fullScreenElement"]||document["fullscreenElement"]||document["msFullScreenElement"]||document["msFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvasContainer){canvas.cancelFullScreen=document["cancelFullScreen"]||document["mozCancelFullScreen"]||document["webkitCancelFullScreen"]||document["msExitFullscreen"]||document["exitFullscreen"]||(function(){});canvas.cancelFullScreen=canvas.cancelFullScreen.bind(document);if(Browser.lockPointer)canvas.requestPointerLock();Browser.isFullScreen=true;if(Browser.resizeCanvas)Browser.setFullScreenCanvasSize()}else{canvasContainer.parentNode.insertBefore(canvas,canvasContainer);canvasContainer.parentNode.removeChild(canvasContainer);if(Browser.resizeCanvas)Browser.setWindowedCanvasSize()}if(Module["onFullScreen"])Module["onFullScreen"](Browser.isFullScreen);Browser.updateCanvasDimensions(canvas)}if(!Browser.fullScreenHandlersInstalled){Browser.fullScreenHandlersInstalled=true;document.addEventListener("fullscreenchange",fullScreenChange,false);document.addEventListener("mozfullscreenchange",fullScreenChange,false);document.addEventListener("webkitfullscreenchange",fullScreenChange,false);document.addEventListener("MSFullscreenChange",fullScreenChange,false)}var canvasContainer=document.createElement("div");canvas.parentNode.insertBefore(canvasContainer,canvas);canvasContainer.appendChild(canvas);canvasContainer.requestFullScreen=canvasContainer["requestFullScreen"]||canvasContainer["mozRequestFullScreen"]||canvasContainer["msRequestFullscreen"]||(canvasContainer["webkitRequestFullScreen"]?(function(){canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null);if(vrDevice){canvasContainer.requestFullScreen({vrDisplay:vrDevice})}else{canvasContainer.requestFullScreen()}}),nextRAF:0,fakeRequestAnimationFrame:(function(func){var now=Date.now();if(Browser.nextRAF===0){Browser.nextRAF=now+1e3/60}else{while(now+2>=Browser.nextRAF){Browser.nextRAF+=1e3/60}}var delay=Math.max(Browser.nextRAF-now,0);setTimeout(func,delay)}),requestAnimationFrame:function requestAnimationFrame(func){if(typeof window==="undefined"){Browser.fakeRequestAnimationFrame(func)}else{if(!window.requestAnimationFrame){window.requestAnimationFrame=window["requestAnimationFrame"]||window["mozRequestAnimationFrame"]||window["webkitRequestAnimationFrame"]||window["msRequestAnimationFrame"]||window["oRequestAnimationFrame"]||Browser.fakeRequestAnimationFrame}window.requestAnimationFrame(func)}},safeCallback:(function(func){return(function(){if(!ABORT)return func.apply(null,arguments)})}),allowAsyncCallbacks:true,queuedAsyncCallbacks:[],pauseAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=false}),resumeAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=true;if(Browser.queuedAsyncCallbacks.length>0){var callbacks=Browser.queuedAsyncCallbacks;Browser.queuedAsyncCallbacks=[];callbacks.forEach((function(func){func()}))}}),safeRequestAnimationFrame:(function(func){return Browser.requestAnimationFrame((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}))}),safeSetTimeout:(function(func,timeout){Module["noExitRuntime"]=true;return setTimeout((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}),timeout)}),safeSetInterval:(function(func,timeout){Module["noExitRuntime"]=true;return setInterval((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}}),timeout)}),getMimetype:(function(name){return{"jpg":"image/jpeg","jpeg":"image/jpeg","png":"image/png","bmp":"image/bmp","ogg":"audio/ogg","wav":"audio/wav","mp3":"audio/mpeg"}[name.substr(name.lastIndexOf(".")+1)]}),getUserMedia:(function(func){if(!window.getUserMedia){window.getUserMedia=navigator["getUserMedia"]||navigator["mozGetUserMedia"]}window.getUserMedia(func)}),getMovementX:(function(event){return event["movementX"]||event["mozMovementX"]||event["webkitMovementX"]||0}),getMovementY:(function(event){return event["movementY"]||event["mozMovementY"]||event["webkitMovementY"]||0}),getMouseWheelDelta:(function(event){var delta=0;switch(event.type){case"DOMMouseScroll":delta=event.detail;break;case"mousewheel":delta=event.wheelDelta;break;case"wheel":delta=event["deltaY"];break;default:throw"unrecognized mouse wheel event: "+event.type}return delta}),mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:(function(event){if(Browser.pointerLock){if(event.type!="mousemove"&&"mozMovementX"in event){Browser.mouseMovementX=Browser.mouseMovementY=0}else{Browser.mouseMovementX=Browser.getMovementX(event);Browser.mouseMovementY=Browser.getMovementY(event)}if(typeof SDL!="undefined"){Browser.mouseX=SDL.mouseX+Browser.mouseMovementX;Browser.mouseY=SDL.mouseY+Browser.mouseMovementY}else{Browser.mouseX+=Browser.mouseMovementX;Browser.mouseY+=Browser.mouseMovementY}}else{var rect=Module["canvas"].getBoundingClientRect();var cw=Module["canvas"].width;var ch=Module["canvas"].height;var scrollX=typeof window.scrollX!=="undefined"?window.scrollX:window.pageXOffset;var scrollY=typeof window.scrollY!=="undefined"?window.scrollY:window.pageYOffset;if(event.type==="touchstart"||event.type==="touchend"||event.type==="touchmove"){var touch=event.touch;if(touch===undefined){return}var adjustedX=touch.pageX-(scrollX+rect.left);var adjustedY=touch.pageY-(scrollY+rect.top);adjustedX=adjustedX*(cw/rect.width);adjustedY=adjustedY*(ch/rect.height);var coords={x:adjustedX,y:adjustedY};if(event.type==="touchstart"){Browser.lastTouches[touch.identifier]=coords;Browser.touches[touch.identifier]=coords}else if(event.type==="touchend"||event.type==="touchmove"){var last=Browser.touches[touch.identifier];if(!last)last=coords;Browser.lastTouches[touch.identifier]=last;Browser.touches[touch.identifier]=coords}return}var x=event.pageX-(scrollX+rect.left);var y=event.pageY-(scrollY+rect.top);x=x*(cw/rect.width);y=y*(ch/rect.height);Browser.mouseMovementX=x-Browser.mouseX;Browser.mouseMovementY=y-Browser.mouseY;Browser.mouseX=x;Browser.mouseY=y}}),xhrLoad:(function(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)}),asyncLoad:(function(url,onload,onerror,noRunDep){Browser.xhrLoad(url,(function(arrayBuffer){assert(arrayBuffer,'Loading data file "'+url+'" failed (no arrayBuffer).');onload(new Uint8Array(arrayBuffer));if(!noRunDep)removeRunDependency("al "+url)}),(function(event){if(onerror){onerror()}else{throw'Loading data file "'+url+'" failed.'}}));if(!noRunDep)addRunDependency("al "+url)}),resizeListeners:[],updateResizeListeners:(function(){var canvas=Module["canvas"];Browser.resizeListeners.forEach((function(listener){listener(canvas.width,canvas.height)}))}),setCanvasSize:(function(width,height,noUpdates){var canvas=Module["canvas"];Browser.updateCanvasDimensions(canvas,width,height);if(!noUpdates)Browser.updateResizeListeners()}),windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags|8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),setWindowedCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags&~8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),updateCanvasDimensions:(function(canvas,wNative,hNative){if(wNative&&hNative){canvas.widthNative=wNative;canvas.heightNative=hNative}else{wNative=canvas.widthNative;hNative=canvas.heightNative}var w=wNative;var h=hNative;if(Module["forcedAspectRatio"]&&Module["forcedAspectRatio"]>0){if(w/h<Module["forcedAspectRatio"]){w=Math.round(h*Module["forcedAspectRatio"])}else{h=Math.round(w/Module["forcedAspectRatio"])}}if((document["webkitFullScreenElement"]||document["webkitFullscreenElement"]||document["mozFullScreenElement"]||document["mozFullscreenElement"]||document["fullScreenElement"]||document["fullscreenElement"]||document["msFullScreenElement"]||document["msFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvas.parentNode&&typeof screen!="undefined"){var factor=Math.min(screen.width/w,screen.height/h);w=Math.round(w*factor);h=Math.round(h*factor)}if(Browser.resizeCanvas){if(canvas.width!=w)canvas.width=w;if(canvas.height!=h)canvas.height=h;if(typeof canvas.style!="undefined"){canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}else{if(canvas.width!=wNative)canvas.width=wNative;if(canvas.height!=hNative)canvas.height=hNative;if(typeof canvas.style!="undefined"){if(w!=wNative||h!=hNative){canvas.style.setProperty("width",w+"px","important");canvas.style.setProperty("height",h+"px","important")}else{canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}}}),wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:(function(){var handle=Browser.nextWgetRequestHandle;Browser.nextWgetRequestHandle++;return handle})};var _emscripten_get_longjmp_result=true;var _sin=Math_sin;var _exp=Math_exp;var _atan=Math_atan;function ___syscall10(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr();FS.unlink(path);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _getenv(name){if(name===0)return 0;name=Pointer_stringify(name);if(!ENV.hasOwnProperty(name))return 0;if(_getenv.ret)_free(_getenv.ret);_getenv.ret=allocate(intArrayFromString(ENV[name]),"i8",ALLOC_NORMAL);return _getenv.ret}function ___syscall5(which,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(),flags=SYSCALLS.get(),mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var _acos=Math_acos;function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}var _emscripten_setjmp=true;var _cos=Math_cos;function _times(buffer){if(buffer!==0){_memset(buffer,0,16)}return 0}var _atan2=Math_atan2;function ___syscall265(which,varargs){SYSCALLS.varargs=varargs;try{return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _time(ptr){var ret=Date.now()/1e3|0;if(ptr){HEAP32[ptr>>2]=ret}return ret}function _pthread_self(){return 0}function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;assert(offset_high===0);FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doWritev(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall221(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),cmd=SYSCALLS.get();switch(cmd){case 0:{var arg=SYSCALLS.get();if(arg<0){return-ERRNO_CODES.EINVAL}var newStream;newStream=FS.open(stream.path,stream.flags,0,arg);return newStream.fd};case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=SYSCALLS.get();stream.flags|=arg;return 0};case 12:case 12:{var arg=SYSCALLS.get();var offset=0;HEAP16[arg+offset>>1]=2;return 0};case 13:case 14:case 13:case 14:return 0;case 16:case 8:return-ERRNO_CODES.EINVAL;case 9:___setErrNo(ERRNO_CODES.EINVAL);return-1;default:{return-ERRNO_CODES.EINVAL}}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}FS.staticInit();__ATINIT__.unshift((function(){if(!Module["noFSInit"]&&!FS.init.initialized)FS.init()}));__ATMAIN__.push((function(){FS.ignorePermissions=false}));__ATEXIT__.push((function(){FS.quit()}));Module["FS_createFolder"]=FS.createFolder;Module["FS_createPath"]=FS.createPath;Module["FS_createDataFile"]=FS.createDataFile;Module["FS_createPreloadedFile"]=FS.createPreloadedFile;Module["FS_createLazyFile"]=FS.createLazyFile;Module["FS_createLink"]=FS.createLink;Module["FS_createDevice"]=FS.createDevice;Module["FS_unlink"]=FS.unlink;__ATINIT__.unshift((function(){TTY.init()}));__ATEXIT__.push((function(){TTY.shutdown()}));if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}___buildEnvironment(ENV);Module["requestFullScreen"]=function Module_requestFullScreen(lockPointer,resizeCanvas,vrDevice){Browser.requestFullScreen(lockPointer,resizeCanvas,vrDevice)};Module["requestAnimationFrame"]=function Module_requestAnimationFrame(func){Browser.requestAnimationFrame(func)};Module["setCanvasSize"]=function Module_setCanvasSize(width,height,noUpdates){Browser.setCanvasSize(width,height,noUpdates)};Module["pauseMainLoop"]=function Module_pauseMainLoop(){Browser.mainLoop.pause()};Module["resumeMainLoop"]=function Module_resumeMainLoop(){Browser.mainLoop.resume()};Module["getUserMedia"]=function Module_getUserMedia(){Browser.getUserMedia()};Module["createContext"]=function Module_createContext(canvas,useWebGL,setInModule,webGLContextAttributes){return Browser.createContext(canvas,useWebGL,setInModule,webGLContextAttributes)};STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);staticSealed=true;STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=DYNAMICTOP=Runtime.alignMemory(STACK_MAX);assert(DYNAMIC_BASE<TOTAL_MEMORY,"TOTAL_MEMORY not big enough for stack");var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_DYNAMIC);function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiidd(index,a1,a2,a3,a4){try{return Module["dynCall_iiidd"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10){try{return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_di(index,a1){try{return Module["dynCall_di"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_dddd(index,a1,a2,a3){try{return Module["dynCall_dddd"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9){try{Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_d(index){try{return Module["dynCall_d"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_i(index){try{return Module["dynCall_i"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiiddi(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiddi"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;asm["setThrew"](1,0)}}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity};Module.asmLibraryArg={"abort":abort,"assert":assert,"invoke_viiiii":invoke_viiiii,"invoke_vi":invoke_vi,"invoke_iiidd":invoke_iiidd,"invoke_vii":invoke_vii,"invoke_iiiiiiiiiii":invoke_iiiiiiiiiii,"invoke_ii":invoke_ii,"invoke_iiiiii":invoke_iiiiii,"invoke_iiii":invoke_iiii,"invoke_viiiiii":invoke_viiiiii,"invoke_di":invoke_di,"invoke_iiiiiii":invoke_iiiiiii,"invoke_dddd":invoke_dddd,"invoke_viiiiiii":invoke_viiiiiii,"invoke_viiiiiiiii":invoke_viiiiiiiii,"invoke_iii":invoke_iii,"invoke_d":invoke_d,"invoke_i":invoke_i,"invoke_viiiddi":invoke_viiiddi,"invoke_iiiii":invoke_iiiii,"invoke_viii":invoke_viii,"invoke_v":invoke_v,"invoke_viiii":invoke_viiii,"_pthread_cleanup_pop":_pthread_cleanup_pop,"_fabs":_fabs,"_sin":_sin,"_exp":_exp,"_llvm_pow_f64":_llvm_pow_f64,"___syscall265":___syscall265,"___syscall146":___syscall146,"_abort":_abort,"_llvm_fabs_f64":_llvm_fabs_f64,"_atan2":_atan2,"_emscripten_set_main_loop_timing":_emscripten_set_main_loop_timing,"___syscall20":___syscall20,"___assert_fail":___assert_fail,"_floor":_floor,"_asin":_asin,"___buildEnvironment":___buildEnvironment,"_longjmp":_longjmp,"_cos":_cos,"_times":_times,"___setErrNo":___setErrNo,"_sbrk":_sbrk,"___syscall192":___syscall192,"___syscall197":___syscall197,"___syscall195":___syscall195,"_sysconf":_sysconf,"_ceil":_ceil,"___syscall221":___syscall221,"_emscripten_memcpy_big":_emscripten_memcpy_big,"___syscall91":___syscall91,"_atanf":_atanf,"_atan":_atan,"_pthread_self":_pthread_self,"_acos":_acos,"_getenv":_getenv,"_sqrt":_sqrt,"___syscall33":___syscall33,"___syscall54":___syscall54,"___unlock":___unlock,"_emscripten_set_main_loop":_emscripten_set_main_loop,"___syscall10":___syscall10,"___syscall5":___syscall5,"_tan":_tan,"__exit":__exit,"___lock":___lock,"___syscall6":___syscall6,"_pthread_cleanup_push":_pthread_cleanup_push,"_setenv":_setenv,"_time":_time,"_emscripten_longjmp":_emscripten_longjmp,"_abs":_abs,"___syscall140":___syscall140,"_exit":_exit,"___syscall145":___syscall145,"_emscripten_asm_const_1":_emscripten_asm_const_1,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"cttz_i8":cttz_i8};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=0;var o=0;var p=0;var q=0;var r=global.NaN,s=global.Infinity;var t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0;var C=0;var D=0;var E=0;var F=0;var G=0;var H=0;var I=0;var J=0;var K=0;var L=0;var M=global.Math.floor;var N=global.Math.abs;var O=global.Math.sqrt;var P=global.Math.pow;var Q=global.Math.cos;var R=global.Math.sin;var S=global.Math.tan;var T=global.Math.acos;var U=global.Math.asin;var V=global.Math.atan;var W=global.Math.atan2;var X=global.Math.exp;var Y=global.Math.log;var Z=global.Math.ceil;var _=global.Math.imul;var $=global.Math.min;var aa=global.Math.clz32;var ba=env.abort;var ca=env.assert;var da=env.invoke_viiiii;var ea=env.invoke_vi;var fa=env.invoke_iiidd;var ga=env.invoke_vii;var ha=env.invoke_iiiiiiiiiii;var ia=env.invoke_ii;var ja=env.invoke_iiiiii;var ka=env.invoke_iiii;var la=env.invoke_viiiiii;var ma=env.invoke_di;var na=env.invoke_iiiiiii;var oa=env.invoke_dddd;var pa=env.invoke_viiiiiii;var qa=env.invoke_viiiiiiiii;var ra=env.invoke_iii;var sa=env.invoke_d;var ta=env.invoke_i;var ua=env.invoke_viiiddi;var va=env.invoke_iiiii;var wa=env.invoke_viii;var xa=env.invoke_v;var ya=env.invoke_viiii;var za=env._pthread_cleanup_pop;var Aa=env._fabs;var Ba=env._sin;var Ca=env._exp;var Da=env._llvm_pow_f64;var Ea=env.___syscall265;var Fa=env.___syscall146;var Ga=env._abort;var Ha=env._llvm_fabs_f64;var Ia=env._atan2;var Ja=env._emscripten_set_main_loop_timing;var Ka=env.___syscall20;var La=env.___assert_fail;var Ma=env._floor;var Na=env._asin;var Oa=env.___buildEnvironment;var Pa=env._longjmp;var Qa=env._cos;var Ra=env._times;var Sa=env.___setErrNo;var Ta=env._sbrk;var Ua=env.___syscall192;var Va=env.___syscall197;var Wa=env.___syscall195;var Xa=env._sysconf;var Ya=env._ceil;var Za=env.___syscall221;var _a=env._emscripten_memcpy_big;var $a=env.___syscall91;var ab=env._atanf;var bb=env._atan;var cb=env._pthread_self;var db=env._acos;var eb=env._getenv;var fb=env._sqrt;var gb=env.___syscall33;var hb=env.___syscall54;var ib=env.___unlock;var jb=env._emscripten_set_main_loop;var kb=env.___syscall10;var lb=env.___syscall5;var mb=env._tan;var nb=env.__exit;var ob=env.___lock;var pb=env.___syscall6;var qb=env._pthread_cleanup_push;var rb=env._setenv;var sb=env._time;var tb=env._emscripten_longjmp;var ub=env._abs;var vb=env.___syscall140;var wb=env._exit;var xb=env.___syscall145;var yb=env._emscripten_asm_const_1;var zb=0.0;
// EMSCRIPTEN_START_FUNCS
function qz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[d>>2]=c[d>>2]|1;c[j>>2]=TA(c[f>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;d=c[j>>2]|0;c[k>>2]=c[((c[c[j>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];if((c[k>>2]|0)==(c[g>>2]|0)){d=c[j>>2]|0;c[k>>2]=c[((c[c[j>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]}if(!(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]&1)){YA(c[h>>2]|0,c[j>>2]|0,1)|0;c[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]=c[g>>2];qz(c[f>>2]|0,c[k>>2]|0,c[h>>2]|0)}c[j>>2]=UA(c[f>>2]|0,c[j>>2]|0,c[g>>2]|0)|0}i=e;return}function rz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+176|0;e=d+8|0;f=d;g=d+44|0;h=d+40|0;j=d+36|0;k=d+32|0;l=d+28|0;m=d+24|0;n=d+20|0;o=d+16|0;p=d+12|0;q=d+48|0;c[g>>2]=a;c[h>>2]=b;b=c[12966]|0;c[12966]=b+1;c[f>>2]=b;k3(q,133960,f)|0;c[j>>2]=FD(c[g>>2]|0,q,1)|0;MC(c[j>>2]|0,175049,280,1)|0;f=c[12966]|0;c[12966]=f+1;c[e>>2]=f;k3(q,133960,e)|0;c[e>>2]=c[(c[g>>2]|0)+12>>2];c[k>>2]=gB(q,e,0)|0;c[l>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;eC(c[j>>2]|0,c[l>>2]|0,1)|0;e=c[k>>2]|0;c[m>>2]=fC(e,wB(c[l>>2]|0)|0,1)|0;MC(c[m>>2]|0,175026,304,1)|0;c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]=c[m>>2];c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}c[l>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;c[m>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2];c[o>>2]=OA(c[g>>2]|0,c[l>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;YA(c[j>>2]|0,c[o>>2]|0,1)|0;e=c[o>>2]|0;c[n>>2]=c[(c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2];c[p>>2]=VA(c[k>>2]|0,c[m>>2]|0,c[n>>2]|0,0,1)|0;MC(c[p>>2]|0,175319,176,1)|0;c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]=c[o>>2];e=(c[(c[m>>2]|0)+8>>2]|0)+236|0;c[e>>2]=(c[e>>2]|0)+1;e=(c[(c[n>>2]|0)+8>>2]|0)+236|0;c[e>>2]=(c[e>>2]|0)+1;c[o>>2]=QA(c[g>>2]|0,c[o>>2]|0)|0}c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}c[c[h>>2]>>2]=c[k>>2];i=d;return c[j>>2]|0}function sz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=uz()|0;c[f>>2]=$B(c[d>>2]|0)|0;while(1){g=c[e>>2]|0;if(!(c[f>>2]|0))break;wz(g,c[f>>2]|0);c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}i=b;return g|0}function tz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+80|0;f=e+72|0;g=e+68|0;h=e+64|0;j=e+60|0;k=e+56|0;l=e+52|0;m=e+48|0;n=e+44|0;o=e+40|0;p=e+36|0;q=e+32|0;r=e+28|0;s=e+24|0;t=e+20|0;u=e+16|0;v=e+12|0;w=e+8|0;x=e+4|0;y=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[s>>2]=0;c[t>>2]=0;c[v>>2]=0;c[u>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2];c[j>>2]=cK(c[u>>2]<<2)|0;c[k>>2]=cK(c[u>>2]<<2)|0;c[l>>2]=TA(c[f>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;d=c[l>>2]|0;c[o>>2]=c[((c[c[l>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];if((c[o>>2]|0)==(c[g>>2]|0)){d=c[l>>2]|0;c[o>>2]=c[((c[c[l>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]}c[q>>2]=0;c[m>>2]=TA(c[f>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;if((c[m>>2]|0)!=(c[l>>2]|0)){d=c[m>>2]|0;c[p>>2]=c[((c[c[m>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];if((c[p>>2]|0)==(c[g>>2]|0)){d=c[m>>2]|0;c[p>>2]=c[((c[c[m>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]}c[n>>2]=VA(c[f>>2]|0,c[o>>2]|0,c[p>>2]|0,0,0)|0;if(((c[n>>2]|0)!=0?(c[q>>2]=1,(c[o>>2]|0)>>>0<(c[p>>2]|0)>>>0):0)?(c[v>>2]=(c[v>>2]|0)+1,(c[(c[(c[n>>2]|0)+8>>2]|0)+116>>2]|0)!=0):0){pC(c[h>>2]|0,c[(c[(c[n>>2]|0)+8>>2]|0)+116>>2]|0)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+116>>2]=0}}c[m>>2]=UA(c[f>>2]|0,c[m>>2]|0,c[g>>2]|0)|0}d=c[o>>2]|0;if(c[q>>2]|0){c[(c[j>>2]|0)+(c[s>>2]<<2)>>2]=d;c[s>>2]=(c[s>>2]|0)+1}else{c[(c[k>>2]|0)+(c[t>>2]<<2)>>2]=d;c[t>>2]=(c[t>>2]|0)+1}c[l>>2]=UA(c[f>>2]|0,c[l>>2]|0,c[g>>2]|0)|0}c[r>>2]=(c[u>>2]|0)-1-(c[v>>2]|0);if((c[r>>2]|0)<=0){z=c[k>>2]|0;O4(z);A=c[j>>2]|0;O4(A);i=e;return}if((c[r>>2]|0)>=(c[t>>2]|0)){if((c[r>>2]|0)!=(c[t>>2]|0)){z=c[k>>2]|0;O4(z);A=c[j>>2]|0;O4(A);i=e;return}c[y>>2]=c[c[j>>2]>>2];c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[t>>2]|0))break;c[x>>2]=c[(c[k>>2]|0)+(c[w>>2]<<2)>>2];MC(VA(c[f>>2]|0,c[y>>2]|0,c[x>>2]|0,0,1)|0,175319,176,1)|0;v=(c[(c[y>>2]|0)+8>>2]|0)+236|0;c[v>>2]=(c[v>>2]|0)+1;v=(c[(c[x>>2]|0)+8>>2]|0)+236|0;c[v>>2]=(c[v>>2]|0)+1;c[w>>2]=(c[w>>2]|0)+1}z=c[k>>2]|0;O4(z);A=c[j>>2]|0;O4(A);i=e;return}c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[t>>2]|0))break;if(((c[w>>2]|0)+1|0)>=(c[t>>2]|0))break;c[y>>2]=c[(c[k>>2]|0)+(c[w>>2]<<2)>>2];c[x>>2]=c[(c[k>>2]|0)+((c[w>>2]|0)+1<<2)>>2];MC(VA(c[f>>2]|0,c[y>>2]|0,c[x>>2]|0,0,1)|0,175319,176,1)|0;v=(c[(c[y>>2]|0)+8>>2]|0)+236|0;c[v>>2]=(c[v>>2]|0)+1;v=(c[(c[x>>2]|0)+8>>2]|0)+236|0;c[v>>2]=(c[v>>2]|0)+1;c[r>>2]=(c[r>>2]|0)+-1;c[w>>2]=(c[w>>2]|0)+2}c[w>>2]=2;while(1){if((c[r>>2]|0)<=0)break;c[y>>2]=c[c[k>>2]>>2];c[x>>2]=c[(c[k>>2]|0)+(c[w>>2]<<2)>>2];MC(VA(c[f>>2]|0,c[y>>2]|0,c[x>>2]|0,0,1)|0,175319,176,1)|0;t=(c[(c[y>>2]|0)+8>>2]|0)+236|0;c[t>>2]=(c[t>>2]|0)+1;t=(c[(c[x>>2]|0)+8>>2]|0)+236|0;c[t>>2]=(c[t>>2]|0)+1;c[w>>2]=(c[w>>2]|0)+1;c[r>>2]=(c[r>>2]|0)+-1}z=c[k>>2]|0;O4(z);A=c[j>>2]|0;O4(A);i=e;return}function uz(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=Nz(51868,c[12989]|0)|0;i=a;return c[b>>2]|0}function vz(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Jz(c[d>>2]|0)|0;i=b;return}function wz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+8|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g+8>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2];c[h>>2]=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,1)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]=c[(c[h>>2]|0)+12>>2];c[(c[h>>2]|0)+12>>2]=c[f>>2];i=d;return}function xz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+16|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;c[g+8>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2];c[h>>2]=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,4)|0;if(!(c[h>>2]|0))La(133970,133973,107,133983);if((c[(c[h>>2]|0)+12>>2]|0)==(c[f>>2]|0)){c[(c[h>>2]|0)+12>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2];if(c[(c[h>>2]|0)+12>>2]|0){i=d;return}Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,c[h>>2]|0,2)|0;i=d;return}c[k>>2]=c[(c[h>>2]|0)+12>>2];c[j>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2];while(1){if(c[j>>2]|0)l=(c[j>>2]|0)!=(c[f>>2]|0);else l=0;m=c[j>>2]|0;if(!l)break;c[k>>2]=m;c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+164>>2]}if(!m){i=d;return}c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+164>>2];i=d;return}function yz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,0,128)|0;if(!(c[f>>2]|0)){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[g>>2]=c[(c[f>>2]|0)+12>>2];c[(c[f>>2]|0)+12>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2];if(!(c[(c[f>>2]|0)+12>>2]|0))Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,c[f>>2]|0,2)|0;c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}function zz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=cK(16)|0;c[(c[g>>2]|0)+12>>2]=0;c[(c[g>>2]|0)+8>>2]=c[(c[f>>2]|0)+8>>2];i=e;return c[g>>2]|0}function Az(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function Bz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;c[f+12>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f>>2]=e;do if((c[c[h>>2]>>2]|0)>=(c[c[j>>2]>>2]|0))if((c[c[h>>2]>>2]|0)>(c[c[j>>2]>>2]|0)){c[g>>2]=1;break}else{c[g>>2]=0;break}else c[g>>2]=-1;while(0);i=f;return c[g>>2]|0}function Cz(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=Nz(51904,c[12989]|0)|0;i=a;return c[b>>2]|0}function Dz(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Jz(c[d>>2]|0)|0;i=b;return}function Ez(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g+8>>2]=c[f>>2];Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,1)|0;i=d;return}function Fz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g+8>>2]=c[f>>2];Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,2)|0;i=d;return}function Gz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=cK(12)|0;c[(c[g>>2]|0)+8>>2]=c[(c[f>>2]|0)+8>>2];i=e;return c[g>>2]|0}function Hz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function Iz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;c[f+12>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f>>2]=e;do if((c[c[h>>2]>>2]|0)>>>0<=(c[c[j>>2]>>2]|0)>>>0)if((c[c[h>>2]>>2]|0)>>>0<(c[c[j>>2]>>2]|0)>>>0){c[g>>2]=-1;break}else{c[g>>2]=0;break}else c[g>>2]=1;while(0);i=f;return c[g>>2]|0}function Jz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[g>>2]=0;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+24>>2]|0)<=0:0){c[f>>2]=c[(c[e>>2]|0)+4>>2];if((c[(c[f>>2]|0)+32>>2]|0)!=0?(a=Sb[c[(c[f>>2]|0)+32>>2]&127](c[e>>2]|0,2,0,c[f>>2]|0)|0,c[g>>2]=a,(a|0)<0):0){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}if(c[(c[e>>2]|0)+28>>2]|0)Sz(c[e>>2]|0,0)|0;if(!(c[g>>2]|0)){Hb[c[c[(c[e>>2]|0)+16>>2]>>2]&63](c[e>>2]|0,0,64)|0;if((Pz(c[e>>2]|0)|0)>0){c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}if((c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)>0)Sb[c[(c[e>>2]|0)+12>>2]&127](c[e>>2]|0,c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0,0,c[f>>2]|0)|0;Sb[c[(c[e>>2]|0)+12>>2]&127](c[e>>2]|0,c[(c[e>>2]|0)+8>>2]|0,0,c[f>>2]|0)|0}if(c[(c[e>>2]|0)+20>>2]|0){if((c[g>>2]|0)==0?(c[(c[e>>2]|0)+20>>2]|0)==1:0)Sb[c[(c[e>>2]|0)+12>>2]&127](c[e>>2]|0,c[e>>2]|0,0,c[f>>2]|0)|0}else O4(c[e>>2]|0);if(c[(c[f>>2]|0)+32>>2]|0)Sb[c[(c[f>>2]|0)+32>>2]&127](c[e>>2]|0,6,0,c[f>>2]|0)|0;c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[d>>2]=-1;h=c[d>>2]|0;i=b;return h|0}function Kz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;a=c[(c[d>>2]|0)+8>>2]|0;a:do if(c[c[(c[d>>2]|0)+8>>2]>>2]&12)c[e>>2]=c[a+4>>2];else{h=c[d>>2]|0;if(!(c[a>>2]&3)){c[e>>2]=c[(c[h+8>>2]|0)+8>>2];c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]=0;break}c[e>>2]=Lz(h)|0;h=c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0;c[f>>2]=h;c[g>>2]=h+(c[(c[(c[d>>2]|0)+8>>2]|0)+12>>2]<<2);while(1){if((c[f>>2]|0)>>>0>=(c[g>>2]|0)>>>0)break a;c[c[f>>2]>>2]=0;c[f>>2]=(c[f>>2]|0)+4}}while(0);f=c[(c[d>>2]|0)+8>>2]|0;c[f>>2]=c[f>>2]&-4097;c[(c[(c[d>>2]|0)+8>>2]|0)+16>>2]=0;c[(c[(c[d>>2]|0)+8>>2]|0)+4>>2]=0;i=b;return c[e>>2]|0}function Lz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+32|0;d=b+28|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b;c[e>>2]=a;if(c[c[(c[e>>2]|0)+8>>2]>>2]&4096){c[d>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+4>>2];m=c[d>>2]|0;i=b;return m|0}c[j>>2]=0;c[h>>2]=0;a=c[(c[e>>2]|0)+8>>2]|0;a:do if(!(c[c[(c[e>>2]|0)+8>>2]>>2]&3)){n=c[(c[e>>2]|0)+8>>2]|0;if(c[a>>2]&112){c[h>>2]=c[n+8>>2];break}o=c[n+4>>2]|0;c[g>>2]=o;if(o){while(1){o=c[(c[g>>2]|0)+4>>2]|0;c[f>>2]=o;if(!o)break;c[(c[g>>2]|0)+4>>2]=c[c[f>>2]>>2];c[c[f>>2]>>2]=c[g>>2];c[g>>2]=c[f>>2]}o=c[g>>2]|0;c[j>>2]=o;c[h>>2]=o;c[g>>2]=c[c[g>>2]>>2];while(1){if(!(c[g>>2]|0))break a;o=c[(c[g>>2]|0)+4>>2]|0;c[f>>2]=o;if(o){do{c[(c[g>>2]|0)+4>>2]=c[c[f>>2]>>2];c[c[f>>2]>>2]=c[g>>2];c[g>>2]=c[f>>2];o=c[(c[g>>2]|0)+4>>2]|0;c[f>>2]=o}while((o|0)!=0);c[c[j>>2]>>2]=c[g>>2]}c[j>>2]=c[g>>2];c[g>>2]=c[c[g>>2]>>2]}}}else{o=c[a+8>>2]|0;c[k>>2]=o;c[l>>2]=o+(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]<<2);while(1){if((c[k>>2]|0)>>>0>=(c[l>>2]|0)>>>0)break a;o=c[c[k>>2]>>2]|0;c[f>>2]=o;if(o){o=c[f>>2]|0;if(c[j>>2]|0)c[c[j>>2]>>2]=o;else{c[j>>2]=o;c[h>>2]=o}while(1){p=c[j>>2]|0;if(!(c[c[j>>2]>>2]|0))break;c[j>>2]=c[p>>2]}c[c[k>>2]>>2]=p}c[k>>2]=(c[k>>2]|0)+4}}while(0);c[(c[(c[e>>2]|0)+8>>2]|0)+4>>2]=c[h>>2];k=c[(c[e>>2]|0)+8>>2]|0;c[k>>2]=c[k>>2]|4096;c[d>>2]=c[h>>2];m=c[d>>2]|0;i=b;return m|0}function Mz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;h=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e+4|0;s=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[c[(c[g>>2]|0)+8>>2]>>2]&4096)Oz(c[g>>2]|0,0)|0;c[o>>2]=c[(c[g>>2]|0)+4>>2];c[m>>2]=c[c[o>>2]>>2];c[l>>2]=c[(c[o>>2]|0)+4>>2];c[k>>2]=c[(c[o>>2]|0)+8>>2];c[n>>2]=c[(c[o>>2]|0)+20>>2];d=(c[g>>2]|0)+20|0;c[d>>2]=c[d>>2]&-32769;d=c[j>>2]|0;do if(c[h>>2]|0){if(!(d&2049)){if((c[j>>2]&512|0)==0?(b=c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]|0,c[p>>2]=b,(b|0)!=0):0){b=c[p>>2]|0;if((c[k>>2]|0)<0)t=c[b+8>>2]|0;else t=b+(0-(c[k>>2]|0))|0;if((t|0)!=(c[h>>2]|0))u=78}else u=78;a:do if((u|0)==78){if(!(c[j>>2]&512)){b=(c[h>>2]|0)+(c[m>>2]|0)|0;if((c[l>>2]|0)<0)v=c[b>>2]|0;else v=b}else v=c[h>>2]|0;c[r>>2]=v;c[p>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2];while(1){if(!(c[p>>2]|0))break a;b=c[p>>2]|0;if((c[k>>2]|0)<0)w=c[b+8>>2]|0;else w=b+(0-(c[k>>2]|0))|0;c[s>>2]=w;b=(c[s>>2]|0)+(c[m>>2]|0)|0;if((c[l>>2]|0)<0)x=c[b>>2]|0;else x=b;c[s>>2]=x;do if(!(c[n>>2]|0)){b=c[r>>2]|0;a=c[s>>2]|0;if((c[l>>2]|0)<=0){y=J3(b,a)|0;break}else{y=B3(b,a,c[l>>2]|0)|0;break}}else y=Sb[c[n>>2]&127](c[g>>2]|0,c[r>>2]|0,c[s>>2]|0,c[o>>2]|0)|0;while(0);if(!y)break a;c[p>>2]=c[c[p>>2]>>2]}}while(0);if(!(c[p>>2]|0)){c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}a=(c[g>>2]|0)+20|0;c[a>>2]=c[a>>2]|32768;if(c[j>>2]&4098)break;if(!(c[j>>2]&8)){if(c[j>>2]&16){if((c[p>>2]|0)==(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0))A=0;else A=c[(c[p>>2]|0)+4>>2]|0;c[p>>2]=A}}else c[p>>2]=c[c[p>>2]>>2];c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=c[p>>2];do if(c[p>>2]|0){a=c[p>>2]|0;if((c[k>>2]|0)<0){B=c[a+8>>2]|0;break}else{B=a+(0-(c[k>>2]|0))|0;break}}else B=0;while(0);c[f>>2]=B;z=c[f>>2]|0;i=e;return z|0}if(((c[(c[o>>2]|0)+12>>2]|0)!=0?(c[j>>2]&1|0)!=0:0)?(a=Hb[c[(c[o>>2]|0)+12>>2]&63](c[g>>2]|0,c[h>>2]|0,c[o>>2]|0)|0,c[h>>2]=a,(a|0)==0):0){c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}do if((c[k>>2]|0)>=0)c[p>>2]=(c[h>>2]|0)+(c[k>>2]|0);else{c[p>>2]=Sb[c[(c[g>>2]|0)+12>>2]&127](c[g>>2]|0,0,12,c[o>>2]|0)|0;if(c[p>>2]|0){c[(c[p>>2]|0)+8>>2]=c[h>>2];break}if(((c[(c[o>>2]|0)+12>>2]|0)!=0?(c[(c[o>>2]|0)+16>>2]|0)!=0:0)?(c[j>>2]&1|0)!=0:0)Tb[c[(c[o>>2]|0)+16>>2]&127](c[g>>2]|0,c[h>>2]|0,c[o>>2]|0);c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}while(0);do if(c[c[(c[g>>2]|0)+8>>2]>>2]&128)if(c[j>>2]&8192)u=62;else u=58;else{if(!(c[c[(c[g>>2]|0)+8>>2]>>2]&16))if(c[c[(c[g>>2]|0)+8>>2]>>2]&32){u=58;break}else{u=62;break}a=(c[j>>2]&8192|0)!=0;b=c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]|0;c[q>>2]=b;C=(b|0)!=0;if(a){if(!C){u=62;break}if(!(c[c[q>>2]>>2]|0)){u=62;break}c[c[p>>2]>>2]=c[c[q>>2]>>2];c[(c[c[p>>2]>>2]|0)+4>>2]=c[p>>2];c[(c[p>>2]|0)+4>>2]=c[q>>2];c[c[(c[p>>2]|0)+4>>2]>>2]=c[p>>2];break}else{if(!C){u=58;break}if((c[q>>2]|0)==(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)){u=58;break}c[(c[p>>2]|0)+4>>2]=c[(c[q>>2]|0)+4>>2];c[c[(c[p>>2]|0)+4>>2]>>2]=c[p>>2];c[c[p>>2]>>2]=c[q>>2];c[(c[c[p>>2]>>2]|0)+4>>2]=c[p>>2];break}}while(0);if((u|0)==58){C=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0;c[q>>2]=C;c[c[p>>2]>>2]=C;if(c[q>>2]|0){c[(c[p>>2]|0)+4>>2]=c[(c[q>>2]|0)+4>>2];c[(c[q>>2]|0)+4>>2]=c[p>>2]}else c[(c[p>>2]|0)+4>>2]=c[p>>2];c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]=c[p>>2]}else if((u|0)==62){C=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0;c[q>>2]=C;a=c[p>>2]|0;if(C){c[c[(c[q>>2]|0)+4>>2]>>2]=a;c[(c[p>>2]|0)+4>>2]=c[(c[q>>2]|0)+4>>2];c[(c[q>>2]|0)+4>>2]=c[p>>2]}else{c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]=a;c[(c[p>>2]|0)+4>>2]=c[p>>2]}c[c[p>>2]>>2]=0}if((c[(c[(c[g>>2]|0)+8>>2]|0)+16>>2]|0)>=0){a=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[a>>2]=(c[a>>2]|0)+1}c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=c[p>>2];a=c[p>>2]|0;if((c[k>>2]|0)<0)D=c[a+8>>2]|0;else D=a+(0-(c[k>>2]|0))|0;c[f>>2]=D;z=c[f>>2]|0;i=e;return z|0}else{if(d&384){a=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0;c[p>>2]=a;if(a){if(c[j>>2]&256)c[p>>2]=c[(c[p>>2]|0)+4>>2];c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=c[p>>2]}do if(c[p>>2]|0){a=c[p>>2]|0;if((c[k>>2]|0)<0){E=c[a+8>>2]|0;break}else{E=a+(0-(c[k>>2]|0))|0;break}}else E=0;while(0);c[f>>2]=E;z=c[f>>2]|0;i=e;return z|0}if(c[j>>2]&4098){if((c[c[(c[g>>2]|0)+8>>2]>>2]&144|0)==0?(a=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0,c[p>>2]=a,(a|0)!=0):0)break;c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}if(!(c[j>>2]&64)){c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}if(!((c[(c[o>>2]|0)+16>>2]|0)==0?(c[(c[o>>2]|0)+8>>2]|0)>=0:0))u=21;b:do if((u|0)==21){c[p>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2];while(1){if(!(c[p>>2]|0))break b;c[q>>2]=c[c[p>>2]>>2];if(c[(c[o>>2]|0)+16>>2]|0){a=c[p>>2]|0;if((c[k>>2]|0)<0)F=c[a+8>>2]|0;else F=a+(0-(c[k>>2]|0))|0;Tb[c[(c[o>>2]|0)+16>>2]&127](c[g>>2]|0,F,c[o>>2]|0)}if((c[(c[o>>2]|0)+8>>2]|0)<0)Sb[c[(c[g>>2]|0)+12>>2]&127](c[g>>2]|0,c[p>>2]|0,0,c[o>>2]|0)|0;c[p>>2]=c[q>>2]}}while(0);c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=0;c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]=0;c[(c[(c[g>>2]|0)+8>>2]|0)+16>>2]=0;c[f>>2]=0;z=c[f>>2]|0;i=e;return z|0}while(0);if(c[c[p>>2]>>2]|0)c[(c[c[p>>2]>>2]|0)+4>>2]=c[(c[p>>2]|0)+4>>2];F=c[p>>2]|0;u=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0;c[q>>2]=u;E=c[c[p>>2]>>2]|0;if((F|0)==(u|0)){c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]=E;if(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]=c[(c[q>>2]|0)+4>>2]}else{c[c[(c[p>>2]|0)+4>>2]>>2]=E;if((c[p>>2]|0)==(c[(c[q>>2]|0)+4>>2]|0))c[(c[q>>2]|0)+4>>2]=c[(c[p>>2]|0)+4>>2]}if((c[p>>2]|0)==(c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]|0))G=c[c[p>>2]>>2]|0;else G=0;c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=G;G=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[G>>2]=(c[G>>2]|0)-1;G=c[p>>2]|0;if((c[k>>2]|0)<0)H=c[G+8>>2]|0;else H=G+(0-(c[k>>2]|0))|0;c[h>>2]=H;if((c[(c[o>>2]|0)+16>>2]|0)!=0?(c[j>>2]&2|0)!=0:0)Tb[c[(c[o>>2]|0)+16>>2]&127](c[g>>2]|0,c[h>>2]|0,c[o>>2]|0);if((c[(c[o>>2]|0)+8>>2]|0)<0)Sb[c[(c[g>>2]|0)+12>>2]&127](c[g>>2]|0,c[p>>2]|0,0,c[o>>2]|0)|0;c[f>>2]=c[h>>2];z=c[f>>2]|0;i=e;return z|0}function Nz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[12988];if(!((c[f>>2]|0)!=0&(c[g>>2]|0)!=0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}b=N4(40)|0;c[h>>2]=b;if(!b){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[c[h>>2]>>2]=0;c[(c[h>>2]|0)+16>>2]=0;c[(c[h>>2]|0)+4>>2]=0;Vz(c[h>>2]|0,c[f>>2]|0,0)|0;c[(c[h>>2]|0)+20>>2]=0;c[(c[h>>2]|0)+24>>2]=0;c[(c[h>>2]|0)+32>>2]=0;c[(c[h>>2]|0)+28>>2]=0;c[(c[h>>2]|0)+36>>2]=0;do if(c[(c[f>>2]|0)+32>>2]|0){c[k>>2]=0;b=Sb[c[(c[f>>2]|0)+32>>2]&127](c[h>>2]|0,1,k,c[f>>2]|0)|0;c[j>>2]=b;if((b|0)>=0)if((c[j>>2]|0)>0){if(c[k>>2]|0)if(c[c[k>>2]>>2]&c[(c[g>>2]|0)+4>>2])break;else{m=15;break}if(c[(c[f>>2]|0)+28>>2]|0){O4(c[h>>2]|0);b=Sb[c[(c[f>>2]|0)+28>>2]&127](0,0,40,c[f>>2]|0)|0;c[h>>2]=b;if(b){c[c[h>>2]>>2]=0;c[(c[h>>2]|0)+16>>2]=0;c[(c[h>>2]|0)+4>>2]=0;Vz(c[h>>2]|0,c[f>>2]|0,0)|0;c[(c[h>>2]|0)+20>>2]=1;c[(c[h>>2]|0)+24>>2]=0;c[(c[h>>2]|0)+32>>2]=0;c[(c[h>>2]|0)+28>>2]=0;m=14;break}c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else m=15}else m=14;else m=15}else m=14;while(0);if((m|0)==14){j=Sb[c[(c[h>>2]|0)+12>>2]&127](c[h>>2]|0,0,28,c[f>>2]|0)|0;c[k>>2]=j;if(j){c[c[k>>2]>>2]=c[(c[g>>2]|0)+4>>2];c[(c[k>>2]|0)+4>>2]=0;c[(c[k>>2]|0)+8>>2]=0;c[(c[k>>2]|0)+20>>2]=0;c[(c[k>>2]|0)+16>>2]=0;c[(c[k>>2]|0)+12>>2]=0;c[(c[k>>2]|0)+24>>2]=0}else m=15}if((m|0)==15){O4(c[h>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[(c[h>>2]|0)+8>>2]=c[k>>2];c[c[h>>2]>>2]=c[c[g>>2]>>2];c[(c[h>>2]|0)+16>>2]=c[g>>2];if(c[(c[f>>2]|0)+32>>2]|0)Sb[c[(c[f>>2]|0)+32>>2]&127](c[h>>2]|0,5,c[h>>2]|0,c[f>>2]|0)|0;c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}function Oz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[m>>2]=c[c[(c[f>>2]|0)+16>>2]>>2];c[l>>2]=c[c[(c[f>>2]|0)+8>>2]>>2]&4096;do if(c[g>>2]|0){if(!(c[(c[(c[f>>2]|0)+8>>2]|0)+16>>2]|0)){c[l>>2]=0;break}c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else{if(c[l>>2]|0){c[g>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+4>>2];break}c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}while(0);b=c[(c[f>>2]|0)+8>>2]|0;c[b>>2]=c[b>>2]&-4097;b=c[(c[f>>2]|0)+8>>2]|0;a:do if(!(c[c[(c[f>>2]|0)+8>>2]>>2]&3)){if(c[b>>2]&12)c[(c[(c[f>>2]|0)+8>>2]|0)+4>>2]=c[g>>2];else{c[(c[(c[f>>2]|0)+8>>2]|0)+4>>2]=0;c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]=c[g>>2]}if(!(c[l>>2]|0))c[(c[(c[f>>2]|0)+8>>2]|0)+16>>2]=-1}else{c[b+4>>2]=0;a=c[(c[f>>2]|0)+8>>2]|0;if(!(c[l>>2]|0)){c[a+16>>2]=0;while(1){if(!(c[g>>2]|0))break a;c[h>>2]=c[c[g>>2]>>2];Hb[c[m>>2]&63](c[f>>2]|0,c[g>>2]|0,32)|0;c[g>>2]=c[h>>2]}}o=c[a+8>>2]|0;c[j>>2]=o;c[k>>2]=o+(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]<<2);while(1){if((c[j>>2]|0)>>>0>=(c[k>>2]|0)>>>0)break a;o=c[c[j>>2]>>2]|0;c[h>>2]=o;if(o){c[c[j>>2]>>2]=c[g>>2];c[g>>2]=c[c[h>>2]>>2];c[c[h>>2]>>2]=0}c[j>>2]=(c[j>>2]|0)+4}}while(0);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}function Pz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(c[c[(c[d>>2]|0)+8>>2]>>2]&4096)Oz(c[d>>2]|0,0)|0;do if((c[(c[(c[d>>2]|0)+8>>2]|0)+16>>2]|0)<0){a=c[(c[d>>2]|0)+8>>2]|0;if(c[c[(c[d>>2]|0)+8>>2]>>2]&12){g=Qz(c[a+4>>2]|0)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+16>>2]=g;break}if(c[a>>2]&112){c[f>>2]=0;c[e>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2];while(1){h=c[f>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=h+1;c[e>>2]=c[c[e>>2]>>2]}c[(c[(c[d>>2]|0)+8>>2]|0)+16>>2]=h}}while(0);i=b;return c[(c[(c[d>>2]|0)+8>>2]|0)+16>>2]|0}function Qz(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){e=0;i=b;return e|0}a=Qz(c[(c[d>>2]|0)+4>>2]|0)|0;e=a+(Qz(c[c[d>>2]>>2]|0)|0)+1|0;i=b;return e|0}function Rz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;e=i;i=i+208|0;f=e+204|0;g=e+200|0;h=e+196|0;j=e+192|0;k=e+188|0;l=e+184|0;m=e+180|0;n=e+176|0;o=e+172|0;p=e+168|0;q=e+164|0;r=e+160|0;s=e+156|0;t=e+152|0;u=e+148|0;v=e+144|0;w=e+136|0;x=e+132|0;y=e+128|0;z=e+8|0;A=e+4|0;B=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[c[(c[g>>2]|0)+8>>2]>>2]&4096)Oz(c[g>>2]|0,0)|0;c[B>>2]=c[(c[g>>2]|0)+4>>2];c[p>>2]=c[c[B>>2]>>2];c[o>>2]=c[(c[B>>2]|0)+4>>2];c[n>>2]=c[(c[B>>2]|0)+8>>2];c[A>>2]=c[(c[B>>2]|0)+20>>2];d=(c[g>>2]|0)+20|0;c[d>>2]=c[d>>2]&-32769;c[k>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2];if(!(c[h>>2]|0)){if((c[k>>2]|0)!=0?(c[j>>2]&448|0)!=0:0){if(!(c[j>>2]&64)){a:do if(c[j>>2]&256)while(1){d=c[c[k>>2]>>2]|0;c[l>>2]=d;if(!d)break a;c[c[k>>2]>>2]=c[(c[l>>2]|0)+4>>2];c[(c[l>>2]|0)+4>>2]=c[k>>2];c[k>>2]=c[l>>2]}else while(1){d=c[(c[k>>2]|0)+4>>2]|0;c[l>>2]=d;if(!d)break a;c[(c[k>>2]|0)+4>>2]=c[c[l>>2]>>2];c[c[l>>2]>>2]=c[k>>2];c[k>>2]=c[l>>2]}while(0);c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=c[k>>2];d=c[k>>2]|0;if((c[n>>2]|0)<0)C=c[d+8>>2]|0;else C=d+(0-(c[n>>2]|0))|0;c[f>>2]=C;D=c[f>>2]|0;i=e;return D|0}if(!((c[(c[B>>2]|0)+16>>2]|0)==0?(c[(c[B>>2]|0)+8>>2]|0)>=0:0))E=10;if((E|0)==10)while(1){E=0;C=c[(c[k>>2]|0)+4>>2]|0;c[l>>2]=C;if(C){c[(c[k>>2]|0)+4>>2]=c[c[l>>2]>>2];c[c[l>>2]>>2]=c[k>>2];c[k>>2]=c[l>>2];E=10;continue}c[l>>2]=c[c[k>>2]>>2];if(c[(c[B>>2]|0)+16>>2]|0){C=c[k>>2]|0;if((c[n>>2]|0)<0)F=c[C+8>>2]|0;else F=C+(0-(c[n>>2]|0))|0;Tb[c[(c[B>>2]|0)+16>>2]&127](c[g>>2]|0,F,c[B>>2]|0)}if((c[(c[B>>2]|0)+8>>2]|0)<0)Sb[c[(c[g>>2]|0)+12>>2]&127](c[g>>2]|0,c[k>>2]|0,0,c[B>>2]|0)|0;C=c[l>>2]|0;c[k>>2]=C;if(C)E=10;else break}c[(c[(c[g>>2]|0)+8>>2]|0)+16>>2]=0;c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=0;c[f>>2]=0;D=c[f>>2]|0;i=e;return D|0}c[f>>2]=0;D=c[f>>2]|0;i=e;return D|0}c[u>>2]=w;c[t>>2]=w;b:do if((c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)==8?(c[j>>2]&4098|0)!=0:0){F=(c[h>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)G=c[F>>2]|0;else G=F;c[s>>2]=G;c[q>>2]=Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,c[h>>2]|0,4)|0;while(1){if(!(c[q>>2]|0)){E=47;break b}F=(c[q>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)H=c[F>>2]|0;else H=F;c[r>>2]=H;do if(!(c[A>>2]|0)){F=c[s>>2]|0;C=c[r>>2]|0;if((c[o>>2]|0)<=0){I=J3(F,C)|0;break}else{I=B3(F,C,c[o>>2]|0)|0;break}}else I=Sb[c[A>>2]&127](c[g>>2]|0,c[s>>2]|0,c[r>>2]|0,c[B>>2]|0)|0;while(0);if(I){E=47;break b}J=c[g>>2]|0;if((c[q>>2]|0)==(c[h>>2]|0))break;c[q>>2]=Hb[c[J>>2]&63](c[g>>2]|0,c[q>>2]|0,8)|0}c[k>>2]=c[(c[J+8>>2]|0)+4>>2];c[c[t>>2]>>2]=c[(c[k>>2]|0)+4>>2];c[(c[u>>2]|0)+4>>2]=c[c[k>>2]>>2];E=192}else E=47;while(0);c:do if((E|0)==47){J=c[j>>2]|0;do if(c[j>>2]&2565){if(!(J&512)){q=(c[h>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)K=c[q>>2]|0;else K=q}else K=c[h>>2]|0;c[s>>2]=K;if(c[k>>2]|0)E=68}else{if(J&32){c[v>>2]=c[h>>2];q=c[v>>2]|0;if((c[n>>2]|0)<0)L=c[q+8>>2]|0;else L=q+(0-(c[n>>2]|0))|0;c[h>>2]=L;q=(c[h>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)M=c[q>>2]|0;else M=q;c[s>>2]=M;if(c[k>>2]|0){E=68;break}else break}if(c[k>>2]|0){q=c[k>>2]|0;if((c[n>>2]|0)<0)N=c[q+8>>2]|0;else N=q+(0-(c[n>>2]|0))|0;if((N|0)!=(c[h>>2]|0)){q=(c[h>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)O=c[q>>2]|0;else O=q;c[s>>2]=O;E=68}}}while(0);d:do if((E|0)==68){e:do if(((c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0)==4?(J=c[(c[(c[g>>2]|0)+8>>2]|0)+24>>2]|0,c[y>>2]=J,(J|0)!=0):0)?(c[j>>2]&516|0)!=0:0){c[l>>2]=c[k>>2];c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[y>>2]|0)){E=94;break}J=c[l>>2]|0;if((c[n>>2]|0)<0)P=c[J+8>>2]|0;else P=J+(0-(c[n>>2]|0))|0;c[r>>2]=P;J=(c[r>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)Q=c[J>>2]|0;else Q=J;c[r>>2]=Q;do if(!(c[A>>2]|0)){J=c[s>>2]|0;q=c[r>>2]|0;if((c[o>>2]|0)<=0){R=J3(J,q)|0;break}else{R=B3(J,q,c[o>>2]|0)|0;break}}else R=Sb[c[A>>2]&127](c[g>>2]|0,c[s>>2]|0,c[r>>2]|0,c[B>>2]|0)|0;while(0);c[m>>2]=R;if(!R){E=84;break}c[z+(c[x>>2]<<2)>>2]=c[m>>2];q=c[l>>2]|0;if((c[m>>2]|0)<0)S=c[q+4>>2]|0;else S=c[q>>2]|0;c[l>>2]=S;if(!S){E=92;break}c[x>>2]=(c[x>>2]|0)+1}if((E|0)==84){q=c[l>>2]|0;if((c[n>>2]|0)<0)T=c[q+8>>2]|0;else T=q+(0-(c[n>>2]|0))|0;c[f>>2]=T;D=c[f>>2]|0;i=e;return D|0}else if((E|0)==92){c[f>>2]=0;D=c[f>>2]|0;i=e;return D|0}else if((E|0)==94){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[y>>2]|0))break e;q=c[k>>2]|0;do if((c[z+(c[x>>2]<<2)>>2]|0)<0){c[l>>2]=c[q+4>>2];J=c[l>>2]|0;if((c[z+((c[x>>2]|0)+1<<2)>>2]|0)<0){c[(c[k>>2]|0)+4>>2]=c[J>>2];c[c[l>>2]>>2]=c[k>>2];I=c[l>>2]|0;c[(c[u>>2]|0)+4>>2]=I;c[u>>2]=I;c[k>>2]=c[(c[l>>2]|0)+4>>2];break}else{c[c[t>>2]>>2]=J;c[t>>2]=J;J=c[k>>2]|0;c[(c[u>>2]|0)+4>>2]=J;c[u>>2]=J;c[k>>2]=c[c[l>>2]>>2];break}}else{c[l>>2]=c[q>>2];J=c[l>>2]|0;if((c[z+((c[x>>2]|0)+1<<2)>>2]|0)>0){c[c[k>>2]>>2]=c[J+4>>2];c[(c[l>>2]|0)+4>>2]=c[k>>2];I=c[l>>2]|0;c[c[t>>2]>>2]=I;c[t>>2]=I;c[k>>2]=c[c[l>>2]>>2];break}else{c[(c[u>>2]|0)+4>>2]=J;c[u>>2]=J;J=c[k>>2]|0;c[c[t>>2]>>2]=J;c[t>>2]=J;c[k>>2]=c[(c[l>>2]|0)+4>>2];break}}while(0);c[x>>2]=(c[x>>2]|0)+2}}}while(0);while(1){q=c[k>>2]|0;if((c[n>>2]|0)<0)U=c[q+8>>2]|0;else U=q+(0-(c[n>>2]|0))|0;c[r>>2]=U;q=(c[r>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)V=c[q>>2]|0;else V=q;c[r>>2]=V;do if(!(c[A>>2]|0)){q=c[s>>2]|0;J=c[r>>2]|0;if((c[o>>2]|0)<=0){W=J3(q,J)|0;break}else{W=B3(q,J,c[o>>2]|0)|0;break}}else W=Sb[c[A>>2]&127](c[g>>2]|0,c[s>>2]|0,c[r>>2]|0,c[B>>2]|0)|0;while(0);c[m>>2]=W;if(!W)break d;J=c[k>>2]|0;if((c[m>>2]|0)<0){q=c[J+4>>2]|0;c[l>>2]=q;if(!q){E=132;break}q=c[l>>2]|0;if((c[n>>2]|0)<0)X=c[q+8>>2]|0;else X=q+(0-(c[n>>2]|0))|0;c[r>>2]=X;q=(c[r>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)Y=c[q>>2]|0;else Y=q;c[r>>2]=Y;do if(!(c[A>>2]|0)){q=c[s>>2]|0;I=c[r>>2]|0;if((c[o>>2]|0)<=0){Z=J3(q,I)|0;break}else{Z=B3(q,I,c[o>>2]|0)|0;break}}else Z=Sb[c[A>>2]&127](c[g>>2]|0,c[s>>2]|0,c[r>>2]|0,c[B>>2]|0)|0;while(0);c[m>>2]=Z;if((Z|0)<0){c[(c[k>>2]|0)+4>>2]=c[c[l>>2]>>2];c[c[l>>2]>>2]=c[k>>2];I=c[l>>2]|0;c[(c[u>>2]|0)+4>>2]=I;c[u>>2]=I;I=c[(c[l>>2]|0)+4>>2]|0;c[k>>2]=I;if(I)continue;else break d}if(!(c[m>>2]|0)){E=130;break}I=c[l>>2]|0;c[c[t>>2]>>2]=I;c[t>>2]=I;I=c[k>>2]|0;c[(c[u>>2]|0)+4>>2]=I;c[u>>2]=I;I=c[c[l>>2]>>2]|0;c[k>>2]=I;if(I)continue;else break d}else{I=c[J>>2]|0;c[l>>2]=I;if(!I){E=149;break}I=c[l>>2]|0;if((c[n>>2]|0)<0)_=c[I+8>>2]|0;else _=I+(0-(c[n>>2]|0))|0;c[r>>2]=_;I=(c[r>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)$=c[I>>2]|0;else $=I;c[r>>2]=$;do if(!(c[A>>2]|0)){I=c[s>>2]|0;q=c[r>>2]|0;if((c[o>>2]|0)<=0){aa=J3(I,q)|0;break}else{aa=B3(I,q,c[o>>2]|0)|0;break}}else aa=Sb[c[A>>2]&127](c[g>>2]|0,c[s>>2]|0,c[r>>2]|0,c[B>>2]|0)|0;while(0);c[m>>2]=aa;if((aa|0)>0){c[c[k>>2]>>2]=c[(c[l>>2]|0)+4>>2];c[(c[l>>2]|0)+4>>2]=c[k>>2];J=c[l>>2]|0;c[c[t>>2]>>2]=J;c[t>>2]=J;J=c[c[l>>2]>>2]|0;c[k>>2]=J;if(J)continue;else break d}if(!(c[m>>2]|0)){E=147;break}J=c[l>>2]|0;c[(c[u>>2]|0)+4>>2]=J;c[u>>2]=J;J=c[k>>2]|0;c[c[t>>2]>>2]=J;c[t>>2]=J;J=c[(c[l>>2]|0)+4>>2]|0;c[k>>2]=J;if(J)continue;else break d}}if((E|0)==130){J=c[k>>2]|0;c[(c[u>>2]|0)+4>>2]=J;c[u>>2]=J;c[k>>2]=c[l>>2];break}else if((E|0)==132){J=c[k>>2]|0;c[(c[u>>2]|0)+4>>2]=J;c[u>>2]=J;c[k>>2]=0;break}else if((E|0)==147){J=c[k>>2]|0;c[c[t>>2]>>2]=J;c[t>>2]=J;c[k>>2]=c[l>>2];break}else if((E|0)==149){J=c[k>>2]|0;c[c[t>>2]>>2]=J;c[t>>2]=J;c[k>>2]=0;break}}while(0);do if(c[k>>2]|0){J=(c[g>>2]|0)+20|0;c[J>>2]=c[J>>2]|32768;c[c[t>>2]>>2]=c[(c[k>>2]|0)+4>>2];c[(c[u>>2]|0)+4>>2]=c[c[k>>2]>>2];if(!(c[j>>2]&516)){if(c[j>>2]&8){c[(c[k>>2]|0)+4>>2]=c[w>>2];c[c[k>>2]>>2]=0;c[w>>2]=c[k>>2];E=181;break}if(c[j>>2]&16){c[c[k>>2]>>2]=c[w+4>>2];c[(c[k>>2]|0)+4>>2]=0;c[w+4>>2]=c[k>>2];E=187;break}if(c[j>>2]&4098){E=192;break c}if(c[j>>2]&2049){if(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]&4)break;c[(c[k>>2]|0)+4>>2]=0;c[c[k>>2]>>2]=c[w+4>>2];c[w+4>>2]=c[k>>2];E=219;break}if(!(c[j>>2]&32)){c[f>>2]=0;D=c[f>>2]|0;i=e;return D|0}if(!(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]&4)){c[(c[v>>2]|0)+4>>2]=0;c[c[v>>2]>>2]=c[w+4>>2];c[w+4>>2]=c[v>>2];J=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[J>>2]=(c[J>>2]|0)+1;break}if(c[(c[B>>2]|0)+16>>2]|0)Tb[c[(c[B>>2]|0)+16>>2]&127](c[g>>2]|0,c[h>>2]|0,c[B>>2]|0);if((c[(c[B>>2]|0)+8>>2]|0)<0)Sb[c[(c[g>>2]|0)+12>>2]&127](c[g>>2]|0,c[v>>2]|0,0,c[B>>2]|0)|0}}else{c[(c[u>>2]|0)+4>>2]=0;c[c[t>>2]>>2]=0;if(!(c[j>>2]&8))if(!(c[j>>2]&16)){if(c[j>>2]&516)break c;if(!(c[j>>2]&2049))if(c[j>>2]&32){c[k>>2]=c[v>>2];J=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[J>>2]=(c[J>>2]|0)+1;break}else{c[h>>2]=0;break c}else E=219}else E=187;else E=181}while(0);if((E|0)==181){J=c[w+4>>2]|0;c[k>>2]=J;if(!J)break;while(1){J=c[(c[k>>2]|0)+4>>2]|0;c[l>>2]=J;if(!J)break;c[(c[k>>2]|0)+4>>2]=c[c[l>>2]>>2];c[c[l>>2]>>2]=c[k>>2];c[k>>2]=c[l>>2]}c[w+4>>2]=c[c[k>>2]>>2]}else if((E|0)==187){J=c[w>>2]|0;c[k>>2]=J;if(!J)break;while(1){J=c[c[k>>2]>>2]|0;c[l>>2]=J;if(!J)break;c[c[k>>2]>>2]=c[(c[l>>2]|0)+4>>2];c[(c[l>>2]|0)+4>>2]=c[k>>2];c[k>>2]=c[l>>2]}c[w>>2]=c[(c[k>>2]|0)+4>>2]}else if((E|0)==219){if((c[(c[B>>2]|0)+12>>2]|0)!=0?(c[j>>2]&1|0)!=0:0)c[h>>2]=Hb[c[(c[B>>2]|0)+12>>2]&63](c[g>>2]|0,c[h>>2]|0,c[B>>2]|0)|0;do if(c[h>>2]|0){if((c[n>>2]|0)>=0){c[k>>2]=(c[h>>2]|0)+(c[n>>2]|0);break}c[k>>2]=Sb[c[(c[g>>2]|0)+12>>2]&127](c[g>>2]|0,0,12,c[B>>2]|0)|0;if(c[k>>2]|0){c[(c[k>>2]|0)+8>>2]=c[h>>2];break}if(((c[(c[B>>2]|0)+12>>2]|0)!=0?(c[(c[B>>2]|0)+16>>2]|0)!=0:0)?(c[j>>2]&1|0)!=0:0)Tb[c[(c[B>>2]|0)+16>>2]&127](c[g>>2]|0,c[h>>2]|0,c[B>>2]|0)}while(0);if(!(c[k>>2]|0))break;if((c[(c[(c[g>>2]|0)+8>>2]|0)+16>>2]|0)>=0){J=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[J>>2]=(c[J>>2]|0)+1}}c[(c[k>>2]|0)+4>>2]=c[w>>2];c[c[k>>2]>>2]=c[w+4>>2];f:do if((c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]&8|0)!=0?(c[j>>2]&516|0)!=0:0){J=c[k>>2]|0;if((c[n>>2]|0)<0)ba=c[J+8>>2]|0;else ba=J+(0-(c[n>>2]|0))|0;c[s>>2]=ba;J=(c[s>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)ca=c[J>>2]|0;else ca=J;c[s>>2]=ca;while(1){J=c[(c[k>>2]|0)+4>>2]|0;c[l>>2]=J;if(!J)break f;while(1){J=c[c[l>>2]>>2]|0;c[u>>2]=J;if(!J)break;c[c[l>>2]>>2]=c[(c[u>>2]|0)+4>>2];c[(c[u>>2]|0)+4>>2]=c[l>>2];c[l>>2]=c[u>>2]}c[(c[k>>2]|0)+4>>2]=c[l>>2];J=c[l>>2]|0;if((c[n>>2]|0)<0)da=c[J+8>>2]|0;else da=J+(0-(c[n>>2]|0))|0;c[r>>2]=da;J=(c[r>>2]|0)+(c[p>>2]|0)|0;if((c[o>>2]|0)<0)ea=c[J>>2]|0;else ea=J;c[r>>2]=ea;do if(!(c[A>>2]|0)){J=c[s>>2]|0;q=c[r>>2]|0;if((c[o>>2]|0)<=0){fa=J3(J,q)|0;break}else{fa=B3(J,q,c[o>>2]|0)|0;break}}else fa=Sb[c[A>>2]&127](c[g>>2]|0,c[s>>2]|0,c[r>>2]|0,c[B>>2]|0)|0;while(0);if(fa)break f;c[(c[k>>2]|0)+4>>2]=c[c[l>>2]>>2];c[c[l>>2]>>2]=c[k>>2];c[k>>2]=c[l>>2]}}while(0);c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=c[k>>2];q=c[k>>2]|0;if((c[n>>2]|0)<0)ga=c[q+8>>2]|0;else ga=q+(0-(c[n>>2]|0))|0;c[f>>2]=ga;D=c[f>>2]|0;i=e;return D|0}while(0);if((E|0)==192){E=c[k>>2]|0;if((c[n>>2]|0)<0)ha=c[E+8>>2]|0;else ha=E+(0-(c[n>>2]|0))|0;c[h>>2]=ha;if((c[(c[B>>2]|0)+16>>2]|0)!=0?(c[j>>2]&2|0)!=0:0)Tb[c[(c[B>>2]|0)+16>>2]&127](c[g>>2]|0,c[h>>2]|0,c[B>>2]|0);if((c[(c[B>>2]|0)+8>>2]|0)<0)Sb[c[(c[g>>2]|0)+12>>2]&127](c[g>>2]|0,c[k>>2]|0,0,c[B>>2]|0)|0;B=(c[(c[g>>2]|0)+8>>2]|0)+16|0;k=(c[B>>2]|0)-1|0;c[B>>2]=k;if((k|0)<0)c[(c[(c[g>>2]|0)+8>>2]|0)+16>>2]=-1}while(1){k=c[(c[u>>2]|0)+4>>2]|0;c[l>>2]=k;if(!k)break;c[u>>2]=c[l>>2]}c[(c[u>>2]|0)+4>>2]=c[w>>2];c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=c[w+4>>2];c[f>>2]=(c[j>>2]&2|0)!=0?c[h>>2]|0:0;D=c[f>>2]|0;i=e;return D|0}function Sz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(c[c[(c[f>>2]|0)+8>>2]>>2]&4096)Oz(c[f>>2]|0,0)|0;if(c[g>>2]|0){if(c[c[(c[g>>2]|0)+8>>2]>>2]&4096)Oz(c[g>>2]|0,0)|0;if((c[(c[g>>2]|0)+16>>2]|0)!=(c[(c[f>>2]|0)+16>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}}c[h>>2]=c[g>>2];while(1){if(!(c[h>>2]|0))break;if((c[h>>2]|0)==(c[f>>2]|0)){k=11;break}c[h>>2]=c[(c[h>>2]|0)+28>>2]}if((k|0)==11){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}k=c[(c[f>>2]|0)+28>>2]|0;c[h>>2]=k;if(k){k=(c[h>>2]|0)+24|0;c[k>>2]=(c[k>>2]|0)-1}c[(c[f>>2]|0)+32>>2]=0;c[(c[f>>2]|0)+28>>2]=0;if(c[g>>2]|0){c[(c[f>>2]|0)+28>>2]=c[g>>2];c[c[f>>2]>>2]=33;k=(c[g>>2]|0)+24|0;c[k>>2]=(c[k>>2]|0)+1;c[e>>2]=c[g>>2];j=c[e>>2]|0;i=d;return j|0}else{c[c[f>>2]>>2]=c[c[(c[f>>2]|0)+16>>2]>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function Tz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e+48|0;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e+20|0;q=e+16|0;r=e+12|0;s=e+8|0;t=e+4|0;u=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[j>>2]&99){c[f>>2]=Hb[c[c[(c[g>>2]|0)+16>>2]>>2]&63](c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;v=c[f>>2]|0;i=e;return v|0}do if(!(c[j>>2]&516)){if((c[j>>2]&384|0)!=0?(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]&12|0)==0:0)break;d=c[j>>2]|0;if(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]&12){if(!(d&408)){c[f>>2]=0;v=c[f>>2]|0;i=e;return v|0}c[p>>2]=0;c[n>>2]=0;c[l>>2]=0;c[k>>2]=c[g>>2];while(1){if(!(c[k>>2]|0))break;b=Hb[c[c[(c[k>>2]|0)+16>>2]>>2]&63](c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[m>>2]=b;do if(b){c[t>>2]=c[c[(c[k>>2]|0)+4>>2]>>2];c[s>>2]=c[(c[(c[k>>2]|0)+4>>2]|0)+4>>2];c[r>>2]=c[(c[(c[k>>2]|0)+4>>2]|0)+8>>2];c[u>>2]=c[(c[(c[k>>2]|0)+4>>2]|0)+20>>2];a=(c[m>>2]|0)+(c[t>>2]|0)|0;if((c[s>>2]|0)<0)w=c[a>>2]|0;else w=a;c[o>>2]=w;if(c[n>>2]|0){do if(!(c[u>>2]|0)){a=c[o>>2]|0;x=c[p>>2]|0;if((c[s>>2]|0)<=0){y=J3(a,x)|0;break}else{y=B3(a,x,c[s>>2]|0)|0;break}}else y=Sb[c[u>>2]&127](c[k>>2]|0,c[o>>2]|0,c[p>>2]|0,c[(c[k>>2]|0)+4>>2]|0)|0;while(0);c[q>>2]=y;if(!((c[j>>2]&136|0)!=0&(c[q>>2]|0)<0)?!((c[j>>2]&272|0)!=0&(c[q>>2]|0)>0):0)break}c[l>>2]=c[k>>2];c[n>>2]=c[m>>2];c[p>>2]=c[o>>2]}while(0);c[k>>2]=c[(c[k>>2]|0)+28>>2]}c[(c[g>>2]|0)+32>>2]=c[l>>2];c[f>>2]=c[n>>2];v=c[f>>2]|0;i=e;return v|0}if(!(d&24)){c[f>>2]=0;v=c[f>>2]|0;i=e;return v|0}if(c[(c[g>>2]|0)+32>>2]|0){b=c[(c[(c[(c[g>>2]|0)+32>>2]|0)+8>>2]|0)+4>>2]|0;if((c[(c[(c[(c[g>>2]|0)+32>>2]|0)+4>>2]|0)+8>>2]|0)<0)z=c[b+8>>2]|0;else z=b+(0-(c[(c[(c[(c[g>>2]|0)+32>>2]|0)+4>>2]|0)+8>>2]|0))|0;if((c[h>>2]|0)!=(z|0))A=37}else A=37;if((A|0)==37){c[k>>2]=c[g>>2];while(1){if(!(c[k>>2]|0))break;b=Hb[c[c[(c[k>>2]|0)+16>>2]>>2]&63](c[k>>2]|0,c[h>>2]|0,4)|0;c[m>>2]=b;if(b)break;c[k>>2]=c[(c[k>>2]|0)+28>>2]}c[(c[g>>2]|0)+32>>2]=c[k>>2];d=c[m>>2]|0;c[h>>2]=d;if(!d){c[f>>2]=0;v=c[f>>2]|0;i=e;return v|0}}c[k>>2]=c[(c[g>>2]|0)+32>>2];c[h>>2]=Hb[c[c[(c[k>>2]|0)+16>>2]>>2]&63](c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;a:while(1){if(!(c[h>>2]|0)){d=c[(c[k>>2]|0)+28>>2]|0;c[(c[g>>2]|0)+32>>2]=d;c[k>>2]=d;if(!d){A=52;break}d=c[c[(c[k>>2]|0)+16>>2]>>2]|0;b=c[k>>2]|0;if(c[j>>2]&8){c[h>>2]=Hb[d&63](b,0,128)|0;continue}else{c[h>>2]=Hb[d&63](b,0,256)|0;continue}}c[l>>2]=c[g>>2];while(1){if((c[l>>2]|0)==(c[k>>2]|0)){A=47;break a}if(Hb[c[c[(c[l>>2]|0)+16>>2]>>2]&63](c[l>>2]|0,c[h>>2]|0,4)|0)break;c[l>>2]=c[(c[l>>2]|0)+28>>2]}c[h>>2]=Hb[c[c[(c[k>>2]|0)+16>>2]>>2]&63](c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0}if((A|0)==47){c[f>>2]=c[h>>2];v=c[f>>2]|0;i=e;return v|0}else if((A|0)==52){c[f>>2]=0;v=c[f>>2]|0;i=e;return v|0}}while(0);c[k>>2]=c[g>>2];while(1){if(!(c[k>>2]|0))break;A=Hb[c[c[(c[k>>2]|0)+16>>2]>>2]&63](c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[m>>2]=A;if(A)break;c[k>>2]=c[(c[k>>2]|0)+28>>2]}c[(c[g>>2]|0)+32>>2]=c[k>>2];c[f>>2]=c[m>>2];v=c[f>>2]|0;i=e;return v|0}function Uz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,0,128)|0;while(1){if(!(c[k>>2]|0)){o=8;break}d=c[(c[g>>2]|0)+32>>2]|0;c[m>>2]=d;if(!d)c[m>>2]=c[g>>2];c[l>>2]=Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,c[k>>2]|0,8)|0;d=Hb[c[h>>2]&63](c[m>>2]|0,c[k>>2]|0,c[j>>2]|0)|0;c[n>>2]=d;if((d|0)<0){o=6;break}c[k>>2]=c[l>>2]}if((o|0)==6){c[f>>2]=c[n>>2];p=c[f>>2]|0;i=e;return p|0}else if((o|0)==8){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}return 0}function Vz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=c[(c[g>>2]|0)+4>>2]|0;c[o>>2]=d;b=c[h>>2]|0;if(!d){c[(c[g>>2]|0)+4>>2]=b;d=c[(c[h>>2]|0)+28>>2]|0;c[(c[g>>2]|0)+12>>2]=d;if(!d)c[(c[g>>2]|0)+12>>2]=51;c[f>>2]=c[h>>2];r=c[f>>2]|0;i=e;return r|0}if(!b){c[f>>2]=c[o>>2];r=c[f>>2]|0;i=e;return r|0}c[k>>2]=c[c[(c[g>>2]|0)+16>>2]>>2];if(c[c[(c[g>>2]|0)+8>>2]>>2]&4096)Oz(c[g>>2]|0,0)|0;if((c[(c[o>>2]|0)+32>>2]|0)!=0?(Sb[c[(c[o>>2]|0)+32>>2]&127](c[g>>2]|0,3,c[h>>2]|0,c[o>>2]|0)|0)<0:0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}c[(c[g>>2]|0)+4>>2]=c[h>>2];b=c[(c[h>>2]|0)+28>>2]|0;c[(c[g>>2]|0)+12>>2]=b;if(!b)c[(c[g>>2]|0)+12>>2]=51;a:do if(!(c[c[(c[g>>2]|0)+8>>2]>>2]&112)){do if(c[c[(c[g>>2]|0)+8>>2]>>2]&2){if(c[j>>2]&2)break a}else{b=c[j>>2]|0;if(!(c[c[(c[g>>2]|0)+8>>2]>>2]&3))if(b&1)break a;else break;if((b&2|0)!=0?(c[j>>2]&1|0)!=0:0)break a}while(0);c[l>>2]=Lz(c[g>>2]|0)|0;b=c[(c[g>>2]|0)+8>>2]|0;c[b>>2]=c[b>>2]&-4097;c[(c[(c[g>>2]|0)+8>>2]|0)+4>>2]=0;c[(c[(c[g>>2]|0)+8>>2]|0)+16>>2]=0;b:do if(c[c[(c[g>>2]|0)+8>>2]>>2]&3){b=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0;c[p>>2]=b;c[q>>2]=b+(c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]<<2);while(1){if((c[p>>2]|0)>>>0>=(c[q>>2]|0)>>>0)break b;b=c[p>>2]|0;c[p>>2]=b+4;c[b>>2]=0}}while(0);while(1){if(!(c[l>>2]|0))break a;c[m>>2]=c[c[l>>2]>>2];if(!(c[j>>2]&2)){b=c[l>>2]|0;if((c[(c[h>>2]|0)+8>>2]|0)<0)s=c[b+8>>2]|0;else s=b+(0-(c[(c[h>>2]|0)+8>>2]|0))|0;c[n>>2]=s;b=(c[n>>2]|0)+(c[c[h>>2]>>2]|0)|0;if((c[(c[h>>2]|0)+4>>2]|0)<0)t=c[b>>2]|0;else t=b;c[n>>2]=t;if(c[(c[h>>2]|0)+24>>2]|0)u=Hb[c[(c[h>>2]|0)+24>>2]&63](c[g>>2]|0,c[n>>2]|0,c[h>>2]|0)|0;else u=Xz(0,c[n>>2]|0,c[(c[h>>2]|0)+4>>2]|0)|0;c[(c[l>>2]|0)+4>>2]=u}Hb[c[k>>2]&63](c[g>>2]|0,c[l>>2]|0,32)|0;c[l>>2]=c[m>>2]}}while(0);c[f>>2]=c[o>>2];r=c[f>>2]|0;i=e;return r|0}function Wz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;c[f+12>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f>>2]=e;e=c[j>>2]|0;do if(c[h>>2]|0){d=c[h>>2]|0;if(!e){O4(d);c[g>>2]=0;break}else{c[g>>2]=Q4(d,c[j>>2]|0)|0;break}}else{if(e>>>0>0)k=N4(c[j>>2]|0)|0;else k=0;c[g>>2]=k}while(0);i=f;return c[g>>2]|0}function Xz(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=e;c[k>>2]=c[h>>2];if((c[j>>2]|0)<=0){while(1){if(!(d[c[k>>2]>>0]|0))break;c[g>>2]=_((c[g>>2]|0)+((d[c[k>>2]>>0]|0)<<8)+(d[(c[k>>2]|0)+1>>0]|0)|0,17109811)|0;c[k>>2]=(c[k>>2]|0)+((d[(c[k>>2]|0)+1>>0]|0|0)!=0?2:1)}c[j>>2]=(c[k>>2]|0)-(c[h>>2]|0);m=c[g>>2]|0;n=c[j>>2]|0;o=m+n|0;p=_(o,17109811)|0;i=f;return p|0}c[l>>2]=(c[k>>2]|0)+(c[j>>2]|0)+-1;while(1){if((c[k>>2]|0)>>>0>=(c[l>>2]|0)>>>0)break;c[g>>2]=_((c[g>>2]|0)+((d[c[k>>2]>>0]|0)<<8)+(d[(c[k>>2]|0)+1>>0]|0)|0,17109811)|0;c[k>>2]=(c[k>>2]|0)+2}if((c[k>>2]|0)>>>0>(c[l>>2]|0)>>>0){m=c[g>>2]|0;n=c[j>>2]|0;o=m+n|0;p=_(o,17109811)|0;i=f;return p|0}c[g>>2]=_((c[g>>2]|0)+((d[c[k>>2]>>0]|0)<<8)|0,17109811)|0;m=c[g>>2]|0;n=c[j>>2]|0;o=m+n|0;p=_(o,17109811)|0;i=f;return p|0}function Yz(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[12998];c[12998]=c[d>>2];i=b;return c[e>>2]|0}function Zz(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[12999];c[12999]=c[d>>2];i=b;return c[e>>2]|0}function _z(){var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;if(c[13e3]|0){T2(c[13e3]|0)|0;c[e>>2]=f3(c[13e3]|0)|0;c[f>>2]=(c[e>>2]|0)-(c[13001]|0);c[g>>2]=N4((c[f>>2]|0)+1|0)|0;c3(c[13e3]|0,c[13001]|0,0)|0;$2(c[g>>2]|0,1,c[f>>2]|0,c[13e3]|0)|0;a[(c[g>>2]|0)+(c[f>>2]|0)>>0]=0;c3(c[13e3]|0,c[e>>2]|0,0)|0;c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}else{c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}return 0}function $z(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=bA(c[f>>2]|0,c[g>>2]|0,h)|0;i=e;return d|0}function aA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+16|0;f=d;c[e>>2]=a;c[f>>2]=b;bA(1,c[e>>2]|0,f)|0;i=d;return}function bA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;if((c[h>>2]|0)==3)m=c[13003]|0;else m=(c[h>>2]|0)==2?1:c[h>>2]|0;c[l>>2]=m;c[13003]=c[l>>2];c[13002]=(c[13002]|0)>>>0>(c[13003]|0)>>>0?c[13002]|0:c[13003]|0;if((c[l>>2]|0)>>>0>=(c[12999]|0)>>>0){l=c[h>>2]|0;if(c[12998]|0)cA(l,c[j>>2]|0,c[k>>2]|0);else{if((l|0)!=3){l=c[24742]|0;c[f>>2]=(c[h>>2]|0)==1?134009:134015;Y2(l,134023,f)|0}o3(c[24742]|0,c[j>>2]|0,c[k>>2]|0)|0}c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}if((c[13e3]|0)==0?(c[13e3]=m3()|0,(c[13e3]|0)==0):0){c[g>>2]=1;n=c[g>>2]|0;i=e;return n|0}if((c[h>>2]|0)!=3)c[13001]=f3(c[13e3]|0)|0;o3(c[13e3]|0,c[j>>2]|0,c[k>>2]|0)|0;c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}function cA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[13004]|0)==0?(c[13004]=N4(c[13005]|0)|0,(c[13004]|0)==0):0){_2(134028,c[24742]|0)|0;i=e;return}if((c[f>>2]|0)!=3){Fb[c[12998]&63]((c[f>>2]|0)==1?134009:134015)|0;Fb[c[12998]&63](134408)|0}while(1){c[k>>2]=q3(c[13004]|0,c[13005]|0,c[g>>2]|0,c[h>>2]|0)|0;if((c[k>>2]|0)>-1?(c[k>>2]|0)<(c[13005]|0):0){l=8;break}c[13005]=(c[13005]<<1|0)>((c[k>>2]|0)+1|0)?c[13005]<<1:(c[k>>2]|0)+1|0;f=Q4(c[13004]|0,c[13005]|0)|0;c[j>>2]=f;if(!f){l=10;break}}if((l|0)==8){Fb[c[12998]&63](c[13004]|0)|0;i=e;return}else if((l|0)==10){_2(134028,c[24742]|0)|0;i=e;return}}function dA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;if(c[j>>2]|0){c[c[g>>2]>>2]=c[j>>2];c[(c[g>>2]|0)+12>>2]=0}else{if(!(c[h>>2]|0))c[h>>2]=1024;c[(c[g>>2]|0)+12>>2]=1;j=N4(c[h>>2]|0)|0;c[c[g>>2]>>2]=j}c[(c[g>>2]|0)+8>>2]=(c[c[g>>2]>>2]|0)+(c[h>>2]|0);c[(c[g>>2]|0)+4>>2]=c[c[g>>2]>>2];a[c[(c[g>>2]|0)+4>>2]>>0]=0;i=f;return}function eA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=(c[(c[e>>2]|0)+8>>2]|0)-(c[c[e>>2]>>2]|0);c[j>>2]=c[h>>2]<<1;if(((c[h>>2]|0)+(c[f>>2]|0)|0)>(c[j>>2]|0))c[j>>2]=(c[h>>2]|0)+(c[f>>2]|0);c[g>>2]=(c[(c[e>>2]|0)+4>>2]|0)-(c[c[e>>2]>>2]|0);if(c[(c[e>>2]|0)+12>>2]|0)c[k>>2]=Q4(c[c[e>>2]>>2]|0,c[j>>2]|0)|0;else{c[k>>2]=N4(c[j>>2]|0)|0;Z4(c[k>>2]|0,c[c[e>>2]>>2]|0,c[g>>2]|0)|0;c[(c[e>>2]|0)+12>>2]=1}c[c[e>>2]>>2]=c[k>>2];c[(c[e>>2]|0)+4>>2]=(c[c[e>>2]>>2]|0)+(c[g>>2]|0);c[(c[e>>2]|0)+8>>2]=(c[c[e>>2]>>2]|0)+(c[j>>2]|0);i=d;return 0}function fA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(((c[(c[f>>2]|0)+4>>2]|0)+(c[h>>2]|0)|0)>>>0>(c[(c[f>>2]|0)+8>>2]|0)>>>0)eA(c[f>>2]|0,c[h>>2]|0)|0;Z4(c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;g=(c[f>>2]|0)+4|0;c[g>>2]=(c[g>>2]|0)+(c[h>>2]|0);i=e;return c[h>>2]|0}function gA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=N3(c[f>>2]|0)|0;b=fA(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0)|0;i=d;return b|0}function hA(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[(c[d>>2]|0)+12>>2]|0)){i=b;return}O4(c[c[d>>2]>>2]|0);i=b;return}function iA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[f>>2]=a;if((c[(c[f>>2]|0)+4>>2]|0)>>>0>(c[c[f>>2]>>2]|0)>>>0){a=(c[f>>2]|0)+4|0;f=c[a>>2]|0;c[a>>2]=f+-1;c[g>>2]=d[f>>0];c[e>>2]=c[g>>2];h=c[e>>2]|0;i=b;return h|0}else{c[e>>2]=-1;h=c[e>>2]|0;i=b;return h|0}return 0}function jA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=LC(c[f>>2]|0,134064,0)|0;if((c[h>>2]|0)==0&(c[g>>2]|0)!=0){EA(c[f>>2]|0);c[h>>2]=LC(c[f>>2]|0,134064,0)|0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function kA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=jA(c[f>>2]|0,0)|0;a:do if(c[h>>2]|0)switch(c[g>>2]|0){case 0:{c[j>>2]=c[(c[h>>2]|0)+8+8>>2];break a;break}case 1:{c[j>>2]=c[(c[h>>2]|0)+8>>2];break a;break}case 2:case 3:{c[j>>2]=c[(c[h>>2]|0)+8+4>>2];break a;break}default:{c[e>>2]=c[g>>2];$z(1,134077,e)|0;c[j>>2]=0;break a}}else c[j>>2]=0;while(0);i=d;return c[j>>2]|0}function lA(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=UB(c[j>>2]|0,24)|0;a[(c[o>>2]|0)+20>>0]=c[n>>2];n=YC(c[j>>2]|0,c[k>>2]|0)|0;c[(c[o>>2]|0)+8>>2]=n;n=YC(c[j>>2]|0,c[l>>2]|0)|0;c[(c[o>>2]|0)+12>>2]=n;c[(c[o>>2]|0)+16>>2]=c[m>>2];i=h;return c[o>>2]|0}function mA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g+8>>2]=c[f>>2];f=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,4)|0;i=d;return f|0}function nA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=Sz(c[e>>2]|0,0)|0;c[g>>2]=mA(c[e>>2]|0,c[f>>2]|0)|0;Sz(c[e>>2]|0,c[h>>2]|0)|0;i=d;return c[g>>2]|0}function oA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=c[f>>2];c[g>>2]=pA(c[e>>2]|0)|0;if(c[g>>2]|0){c[h>>2]=mA(c[(c[g>>2]|0)+8>>2]|0,c[j>>2]|0)|0;k=c[h>>2]|0;i=d;return k|0}else{c[h>>2]=0;k=c[h>>2]|0;i=d;return k|0}return 0}function pA(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=LC(c[d>>2]|0,c[13015]|0,0)|0;i=b;return a|0}function qA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[h>>2]|0)){if(!(c[13016]|0)){c[g>>2]=c[13017];c[13016]=gB(0,g,0)|0}c[h>>2]=c[13016]}g=c[h>>2]|0;h=c[j>>2]|0;j=c[k>>2]|0;if(c[l>>2]|0){c[m>>2]=FA(g,h,j,c[l>>2]|0)|0;n=c[m>>2]|0;i=f;return n|0}else{c[m>>2]=GA(g,h,j)|0;n=c[m>>2]|0;i=f;return n|0}return 0}function rA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=kA(c[f>>2]|0,c[g>>2]|0)|0;c[j>>2]=d;if(!d){c[k>>2]=0;l=c[k>>2]|0;i=e;return l|0}d=c[c[j>>2]>>2]|0;g=c[j>>2]|0;if(c[h>>2]|0){c[k>>2]=Hb[d&63](g,c[h>>2]|0,8)|0;l=c[k>>2]|0;i=e;return l|0}else{c[k>>2]=Hb[d&63](g,0,128)|0;l=c[k>>2]|0;i=e;return l|0}return 0}function sA(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;b=(c[e>>2]|0)+12|0;a[b>>0]=a[b>>0]&-65|64;HA(c[e>>2]|0)|0;b=ID(c[e>>2]|0)|0;c[f>>2]=b;if(!b)c[f>>2]=c[e>>2];IA(c[f>>2]|0,c[e>>2]|0)|0;i=d;return}function tA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[13072]=c[e>>2];a=pA(c[e>>2]|0)|0;c[g>>2]=a;if(a){JA(c[e>>2]|0,c[g>>2]|0);NC(c[e>>2]|0,c[c[g>>2]>>2]|0)|0}g=jA(c[e>>2]|0,0)|0;c[f>>2]=g;do if(g){if(QD(c[e>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0){c[d>>2]=1;h=c[d>>2]|0;i=b;return h|0}if(QD(c[e>>2]|0,c[(c[f>>2]|0)+8+4>>2]|0)|0){c[d>>2]=1;h=c[d>>2]|0;i=b;return h|0}if(!(QD(c[e>>2]|0,c[(c[f>>2]|0)+8+8>>2]|0)|0)){NC(c[e>>2]|0,c[c[f>>2]>>2]|0)|0;break}c[d>>2]=1;h=c[d>>2]|0;i=b;return h|0}while(0);c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}function uA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=pA(c[f>>2]|0)|0;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+8>>2]|0)!=0:0){i=d;return}IA(c[e>>2]|0,c[f>>2]|0)|0;i=d;return}function vA(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=pA(c[d>>2]|0)|0;c[e>>2]=a;if(!a){i=b;return}JA(c[d>>2]|0,c[e>>2]|0);NC(c[d>>2]|0,c[13015]|0)|0;i=b;return}function wA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=pA(c[f>>2]|0)|0;if((c[g>>2]|0)!=0?(c[(c[g>>2]|0)+8>>2]|0)!=0:0){i=d;return}IA(c[e>>2]|0,c[f>>2]|0)|0;i=d;return}function xA(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=pA(c[d>>2]|0)|0;c[e>>2]=a;if(!a){i=b;return}JA(c[d>>2]|0,c[e>>2]|0);NC(c[d>>2]|0,c[13015]|0)|0;i=b;return}function yA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=oA(c[e>>2]|0,c[f>>2]|0)|0;if(!(c[g>>2]|0)){c[j>>2]=0;k=c[j>>2]|0;i=d;return k|0}else{c[h>>2]=pA(c[e>>2]|0)|0;c[j>>2]=c[(c[(c[h>>2]|0)+12>>2]|0)+(c[(c[g>>2]|0)+16>>2]<<2)>>2];k=c[j>>2]|0;i=d;return k|0}return 0}function zA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=pA(c[e>>2]|0)|0;c[h>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+(c[(c[f>>2]|0)+16>>2]<<2)>>2];i=d;return c[h>>2]|0}function AA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=oA(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[k>>2]=-1;l=c[k>>2]|0;i=e;return l|0}else{c[k>>2]=BA(c[f>>2]|0,c[j>>2]|0,c[h>>2]|0)|0;l=c[k>>2]|0;i=e;return l|0}return 0}function BA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=qC(c[f>>2]|0)|0;c[k>>2]=c[f>>2];c[l>>2]=pA(c[k>>2]|0)|0;_C(c[j>>2]|0,c[(c[(c[l>>2]|0)+12>>2]|0)+(c[(c[g>>2]|0)+16>>2]<<2)>>2]|0)|0;d=YC(c[j>>2]|0,c[h>>2]|0)|0;c[(c[(c[l>>2]|0)+12>>2]|0)+(c[(c[g>>2]|0)+16>>2]<<2)>>2]=d;if(c[c[k>>2]>>2]&3){o=c[j>>2]|0;p=c[f>>2]|0;q=c[g>>2]|0;uC(o,p,q);i=e;return 0}c[n>>2]=c[(jA(c[j>>2]|0,0)|0)+8+8>>2];d=nA(c[n>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;c[m>>2]=d;l=c[j>>2]|0;if(d){_C(l,c[(c[m>>2]|0)+12>>2]|0)|0;d=YC(c[j>>2]|0,c[h>>2]|0)|0;c[(c[m>>2]|0)+12>>2]=d;o=c[j>>2]|0;p=c[f>>2]|0;q=c[g>>2]|0;uC(o,p,q);i=e;return 0}else{c[m>>2]=lA(l,c[(c[g>>2]|0)+8>>2]|0,c[h>>2]|0,c[(c[g>>2]|0)+16>>2]|0,c[c[k>>2]>>2]&3)|0;Hb[c[c[n>>2]>>2]&63](c[n>>2]|0,c[m>>2]|0,1)|0;o=c[j>>2]|0;p=c[f>>2]|0;q=c[g>>2]|0;uC(o,p,q);i=e;return 0}return 0}function CA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=qC(c[g>>2]|0)|0;c[l>>2]=qA(e,c[c[g>>2]>>2]&3,c[h>>2]|0,0)|0;if(c[l>>2]|0){m=c[g>>2]|0;n=c[l>>2]|0;o=c[j>>2]|0;p=BA(m,n,o)|0;i=f;return p|0}e=qC(c[g>>2]|0)|0;c[l>>2]=qA(e,c[c[g>>2]>>2]&3,c[h>>2]|0,c[k>>2]|0)|0;m=c[g>>2]|0;n=c[l>>2]|0;o=c[j>>2]|0;p=BA(m,n,o)|0;i=f;return p|0}function DA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;c[n>>2]=1;c[h>>2]=qC(c[f>>2]|0)|0;if((c[c[f>>2]>>2]&3|0)!=(c[c[g>>2]>>2]&3|0)){c[e>>2]=1;o=c[e>>2]|0;i=d;return o|0}c[j>>2]=0;while(1){b=rA(c[h>>2]|0,c[c[f>>2]>>2]&3,c[j>>2]|0)|0;c[j>>2]=b;if(!b){p=9;break}c[k>>2]=oA(c[g>>2]|0,c[(c[j>>2]|0)+8>>2]|0)|0;if(!(c[k>>2]|0)){p=6;break}c[l>>2]=zA(c[f>>2]|0,c[j>>2]|0)|0;c[n>>2]=BA(c[g>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(!($C(c[l>>2]|0)|0))continue;c[m>>2]=zA(c[g>>2]|0,c[k>>2]|0)|0;aD(c[m>>2]|0)}if((p|0)==6){c[e>>2]=1;o=c[e>>2]|0;i=d;return o|0}else if((p|0)==9){c[e>>2]=c[n>>2];o=c[e>>2]|0;i=d;return o|0}return 0}function EA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=rC(c[d>>2]|0)|0;vE(c[e>>2]|0,c[e>>2]|0,98,0,1)|0;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;uA(c[d>>2]|0,c[f>>2]|0);c[g>>2]=OA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;wA(c[d>>2]|0,c[g>>2]|0);c[g>>2]=QA(c[e>>2]|0,c[g>>2]|0)|0}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}i=b;return}function FA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+64|0;g=f+52|0;h=f+48|0;j=f+44|0;k=f+40|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;t=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[r>>2]=rC(c[g>>2]|0)|0;c[f+36>>2]=jA(c[g>>2]|0,1)|0;c[l>>2]=kA(c[g>>2]|0,c[h>>2]|0)|0;c[n>>2]=nA(c[l>>2]|0,c[j>>2]|0)|0;do if(c[n>>2]|0){_C(c[g>>2]|0,c[(c[n>>2]|0)+12>>2]|0)|0;e=YC(c[g>>2]|0,c[k>>2]|0)|0;c[(c[n>>2]|0)+12>>2]=e;c[q>>2]=c[n>>2]}else{c[o>>2]=mA(c[l>>2]|0,c[j>>2]|0)|0;if(c[o>>2]|0){c[n>>2]=lA(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0,c[(c[o>>2]|0)+16>>2]|0,c[h>>2]|0)|0;Hb[c[c[l>>2]>>2]&63](c[l>>2]|0,c[n>>2]|0,1)|0;c[q>>2]=c[n>>2];break}c[m>>2]=kA(c[r>>2]|0,c[h>>2]|0)|0;e=c[g>>2]|0;d=c[j>>2]|0;b=c[k>>2]|0;a=Pz(c[m>>2]|0)|0;c[p>>2]=lA(e,d,b,a,c[h>>2]|0)|0;Hb[c[c[m>>2]>>2]&63](c[m>>2]|0,c[p>>2]|0,1)|0;a:do switch(c[h>>2]|0){case 0:{vE(c[r>>2]|0,c[r>>2]|0,54,c[p>>2]|0,1)|0;break}case 1:{c[s>>2]=$B(c[r>>2]|0)|0;while(1){if(!(c[s>>2]|0))break a;NA(c[g>>2]|0,c[s>>2]|0,c[p>>2]|0);c[s>>2]=aC(c[r>>2]|0,c[s>>2]|0)|0}break}case 2:case 3:{c[s>>2]=$B(c[r>>2]|0)|0;while(1){if(!(c[s>>2]|0))break a;c[t>>2]=OA(c[r>>2]|0,c[s>>2]|0)|0;while(1){if(!(c[t>>2]|0))break;NA(c[g>>2]|0,c[t>>2]|0,c[p>>2]|0);c[t>>2]=QA(c[r>>2]|0,c[t>>2]|0)|0}c[s>>2]=aC(c[r>>2]|0,c[s>>2]|0)|0}break}default:{}}while(0);c[q>>2]=c[p>>2]}while(0);if(!((c[q>>2]|0)!=0&(c[h>>2]|0)==0)){u=c[g>>2]|0;v=c[g>>2]|0;w=c[q>>2]|0;uC(u,v,w);x=c[q>>2]|0;i=f;return x|0}BA(c[g>>2]|0,c[q>>2]|0,c[k>>2]|0)|0;u=c[g>>2]|0;v=c[g>>2]|0;w=c[q>>2]|0;uC(u,v,w);x=c[q>>2]|0;i=f;return x|0}function GA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;c[k>>2]=kA(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[k>>2]|0)){l=c[j>>2]|0;i=e;return l|0}c[j>>2]=mA(c[k>>2]|0,c[h>>2]|0)|0;l=c[j>>2]|0;i=e;return l|0}function HA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[g>>2]=MC(c[d>>2]|0,134064,20,0)|0;a=OD(c[d>>2]|0,52024,c[12993]|0)|0;c[(c[g>>2]|0)+8>>2]=a;a=OD(c[d>>2]|0,52024,c[12993]|0)|0;c[(c[g>>2]|0)+8+4>>2]=a;a=OD(c[d>>2]|0,52024,c[12993]|0)|0;c[(c[g>>2]|0)+8+8>>2]=a;a=ID(c[d>>2]|0)|0;c[e>>2]=a;if(a){c[f>>2]=jA(c[e>>2]|0,0)|0;Sz(c[(c[g>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+8>>2]|0)|0;Sz(c[(c[g>>2]|0)+8+4>>2]|0,c[(c[f>>2]|0)+8+4>>2]|0)|0;Sz(c[(c[g>>2]|0)+8+8>>2]|0,c[(c[f>>2]|0)+8+8>>2]|0)|0;h=c[g>>2]|0;i=b;return h|0}if(!(c[13016]|0)){h=c[g>>2]|0;i=b;return h|0}if((c[d>>2]|0)==(c[13016]|0)){h=c[g>>2]|0;i=b;return h|0}c[f>>2]=jA(c[13016]|0,0)|0;MA(c[(c[f>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+8>>2]|0,c[d>>2]|0,1);MA(c[(c[f>>2]|0)+8+4>>2]|0,c[(c[g>>2]|0)+8+4>>2]|0,c[d>>2]|0,2);MA(c[(c[f>>2]|0)+8+8>>2]|0,c[(c[g>>2]|0)+8+8>>2]|0,c[d>>2]|0,0);h=c[g>>2]|0;i=b;return h|0}function IA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=MC(c[f>>2]|0,c[13015]|0,16,0)|0;c[k>>2]=kA(c[e>>2]|0,c[c[f>>2]>>2]&3)|0;if(c[(c[h>>2]|0)+8>>2]|0){l=c[h>>2]|0;i=d;return l|0}b=rC(c[e>>2]|0)|0;e=kA(b,c[c[f>>2]>>2]&3)|0;c[(c[h>>2]|0)+8>>2]=e;e=LA(c[f>>2]|0)|0;c[g>>2]=e;c[g>>2]=(c[g>>2]|0)<4?4:e;e=qC(c[f>>2]|0)|0;b=UB(e,c[g>>2]<<2)|0;c[(c[h>>2]|0)+12>>2]=b;c[j>>2]=Hb[c[c[k>>2]>>2]&63](c[k>>2]|0,0,128)|0;while(1){if(!(c[j>>2]|0))break;b=qC(c[f>>2]|0)|0;g=YC(b,c[(c[j>>2]|0)+12>>2]|0)|0;c[(c[(c[h>>2]|0)+12>>2]|0)+(c[(c[j>>2]|0)+16>>2]<<2)>>2]=g;c[j>>2]=Hb[c[c[k>>2]>>2]&63](c[k>>2]|0,c[j>>2]|0,8)|0}l=c[h>>2]|0;i=d;return l|0}function JA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=qC(c[e>>2]|0)|0;c[h>>2]=LA(c[e>>2]|0)|0;c[g>>2]=0;while(1){k=c[j>>2]|0;if((c[g>>2]|0)>=(c[h>>2]|0))break;_C(k,c[(c[(c[f>>2]|0)+12>>2]|0)+(c[g>>2]<<2)>>2]|0)|0;c[g>>2]=(c[g>>2]|0)+1}VB(k,c[(c[f>>2]|0)+12>>2]|0);i=d;return}function KA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=c[f>>2];_C(c[13072]|0,c[(c[g>>2]|0)+8>>2]|0)|0;_C(c[13072]|0,c[(c[g>>2]|0)+12>>2]|0)|0;VB(c[13072]|0,c[g>>2]|0);i=e;return}function LA(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=rC(qC(c[d>>2]|0)|0)|0;c[e>>2]=kA(a,c[c[d>>2]>>2]&3)|0;if(!(c[e>>2]|0)){f=0;i=b;return f|0}f=Pz(c[e>>2]|0)|0;i=b;return f|0}function MA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=Hb[c[c[h>>2]>>2]&63](c[h>>2]|0,0,128)|0;while(1){if(!(c[m>>2]|0))break;c[n>>2]=lA(c[k>>2]|0,c[(c[m>>2]|0)+8>>2]|0,c[(c[m>>2]|0)+12>>2]|0,c[(c[m>>2]|0)+16>>2]|0,c[l>>2]|0)|0;a[(c[n>>2]|0)+22>>0]=a[(c[m>>2]|0)+22>>0]|0;a[(c[n>>2]|0)+21>>0]=a[(c[m>>2]|0)+21>>0]|0;Hb[c[c[j>>2]>>2]&63](c[j>>2]|0,c[n>>2]|0,1)|0;c[m>>2]=Hb[c[c[h>>2]>>2]&63](c[h>>2]|0,c[m>>2]|0,8)|0}i=g;return}function NA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=pA(c[g>>2]|0)|0;if((c[(c[h>>2]|0)+16>>2]|0)>=4){g=Sb[c[(c[c[(c[f>>2]|0)+52>>2]>>2]|0)+8>>2]&127](c[(c[(c[f>>2]|0)+52>>2]|0)+12>>2]|0,c[(c[j>>2]|0)+12>>2]|0,c[(c[h>>2]|0)+16>>2]<<2,(c[(c[h>>2]|0)+16>>2]|0)+1<<2)|0;c[(c[j>>2]|0)+12>>2]=g}g=YC(c[f>>2]|0,c[(c[h>>2]|0)+12>>2]|0)|0;c[(c[(c[j>>2]|0)+12>>2]|0)+(c[(c[h>>2]|0)+16>>2]<<2)>>2]=g;i=e;return}function OA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=0;c[g>>2]=PA(c[e>>2]|0,c[f>>2]|0)|0;if(!(c[g>>2]|0)){j=c[h>>2]|0;i=d;return j|0}Oz(c[(c[e>>2]|0)+32>>2]|0,c[(c[g>>2]|0)+32>>2]|0)|0;c[h>>2]=Hb[c[c[(c[e>>2]|0)+32>>2]>>2]&63](c[(c[e>>2]|0)+32>>2]|0,0,128)|0;f=Kz(c[(c[e>>2]|0)+32>>2]|0)|0;c[(c[g>>2]|0)+32>>2]=f;j=c[h>>2]|0;i=d;return j|0}function PA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+44|0;f=d+40|0;g=d+36|0;h=d;c[e>>2]=a;c[f>>2]=b;b=c[f>>2]|0;if((c[e>>2]|0)==(c[(c[f>>2]|0)+12>>2]|0)){c[g>>2]=b+16;j=c[g>>2]|0;i=d;return j|0}else{c[h+16>>2]=b;c[g>>2]=Hb[c[c[(c[e>>2]|0)+28>>2]>>2]&63](c[(c[e>>2]|0)+28>>2]|0,h,4)|0;j=c[g>>2]|0;i=d;return j|0}return 0}function QA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=0;b=c[f>>2]|0;c[g>>2]=c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2];c[h>>2]=PA(c[e>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){k=c[j>>2]|0;i=d;return k|0}Oz(c[(c[e>>2]|0)+32>>2]|0,c[(c[h>>2]|0)+32>>2]|0)|0;c[j>>2]=Hb[c[c[(c[e>>2]|0)+32>>2]>>2]&63](c[(c[e>>2]|0)+32>>2]|0,c[f>>2]|0,8)|0;f=Kz(c[(c[e>>2]|0)+32>>2]|0)|0;c[(c[h>>2]|0)+32>>2]=f;k=c[j>>2]|0;i=d;return k|0}function RA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=0;c[g>>2]=PA(c[e>>2]|0,c[f>>2]|0)|0;if(!(c[g>>2]|0)){j=c[h>>2]|0;i=d;return j|0}Oz(c[(c[e>>2]|0)+32>>2]|0,c[(c[g>>2]|0)+28>>2]|0)|0;c[h>>2]=Hb[c[c[(c[e>>2]|0)+32>>2]>>2]&63](c[(c[e>>2]|0)+32>>2]|0,0,128)|0;f=Kz(c[(c[e>>2]|0)+32>>2]|0)|0;c[(c[g>>2]|0)+28>>2]=f;j=c[h>>2]|0;i=d;return j|0}function SA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=0;b=c[f>>2]|0;c[g>>2]=c[((c[c[f>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];c[h>>2]=PA(c[e>>2]|0,c[g>>2]|0)|0;if(!(c[h>>2]|0)){k=c[j>>2]|0;i=d;return k|0}Oz(c[(c[e>>2]|0)+32>>2]|0,c[(c[h>>2]|0)+28>>2]|0)|0;c[j>>2]=Hb[c[c[(c[e>>2]|0)+32>>2]>>2]&63](c[(c[e>>2]|0)+32>>2]|0,c[f>>2]|0,8)|0;f=Kz(c[(c[e>>2]|0)+32>>2]|0)|0;c[(c[h>>2]|0)+28>>2]=f;k=c[j>>2]|0;i=d;return k|0}function TA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=OA(c[e>>2]|0,c[f>>2]|0)|0;if(c[g>>2]|0){h=c[g>>2]|0;i=d;return h|0}c[g>>2]=RA(c[e>>2]|0,c[f>>2]|0)|0;h=c[g>>2]|0;i=d;return h|0}function UA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;a:do if((c[c[g>>2]>>2]&3|0)==2){c[j>>2]=QA(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0))do{d=c[f>>2]|0;if(c[j>>2]|0)k=SA(d,c[j>>2]|0)|0;else k=RA(d,c[h>>2]|0)|0;c[j>>2]=k;if(!(c[j>>2]|0))break a}while((c[(c[j>>2]|0)+28>>2]|0)==(c[h>>2]|0))}else do{c[j>>2]=SA(c[f>>2]|0,c[g>>2]|0)|0;c[g>>2]=c[j>>2];if(!(c[j>>2]|0))break a}while((c[(c[j>>2]|0)+28>>2]|0)==(c[h>>2]|0));while(0);i=e;return c[j>>2]|0}function VA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+64|0;h=g+48|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[r>>2]=tB(c[k>>2]|0,2,c[n>>2]|0,q,0)|0;if(!(c[r>>2]|0)){if(!(c[n>>2]|0))if(!((c[o>>2]|0)!=0?(pB(c[k>>2]|0)|0)==0:0))t=5}else t=5;if((t|0)==5){c[s>>2]=c[13054];c[s+4>>2]=c[13055];if(c[r>>2]|0){c[s+4>>2]=c[q>>2];c[s>>2]=c[s>>2]&-4|2}else{c[s>>2]=c[s>>2]&-4;c[s+4>>2]=0}r=c[k>>2]|0;t=c[l>>2]|0;f=c[m>>2]|0;c[h>>2]=c[s>>2];c[h+4>>2]=c[s+4>>2];c[p>>2]=cB(r,t,f,h)|0;if((c[p>>2]|0)==0?(oB(c[k>>2]|0)|0)!=0:0){f=c[k>>2]|0;t=c[m>>2]|0;r=c[l>>2]|0;c[h>>2]=c[s>>2];c[h+4>>2]=c[s+4>>2];c[p>>2]=cB(f,t,r,h)|0}if(c[p>>2]|0){c[j>>2]=c[p>>2];u=c[j>>2]|0;i=g;return u|0}if(c[o>>2]|0){r=rC(c[k>>2]|0)|0;t=c[l>>2]|0;f=c[m>>2]|0;c[h>>2]=c[s>>2];c[h+4>>2]=c[s+4>>2];c[p>>2]=cB(r,t,f,h)|0;if((c[p>>2]|0)==0?(oB(c[k>>2]|0)|0)!=0:0){f=rC(c[k>>2]|0)|0;t=c[m>>2]|0;r=c[l>>2]|0;c[h>>2]=c[s>>2];c[h+4>>2]=c[s+4>>2];c[p>>2]=cB(f,t,r,h)|0}if(c[p>>2]|0){aB(c[k>>2]|0,c[p>>2]|0);c[j>>2]=c[p>>2];u=c[j>>2]|0;i=g;return u|0}}}if(((c[o>>2]|0)!=0?($A(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0)!=0:0)?(tB(c[k>>2]|0,2,c[n>>2]|0,q,1)|0)!=0:0){c[p>>2]=bB(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[q>>2]|0)|0;xB(c[k>>2]|0,2,c[p>>2]|0)}else c[p>>2]=0;c[j>>2]=c[p>>2];u=c[j>>2]|0;i=g;return u|0}function WA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[e+20>>2]=d;d=c[g>>2]|0;if((c[c[g>>2]>>2]&3|0)==3){c[h>>2]=d;c[j>>2]=(c[g>>2]|0)+-32}else{c[j>>2]=d;c[h>>2]=(c[g>>2]|0)+32}c[k>>2]=c[(c[h>>2]|0)+28>>2];c[l>>2]=c[(c[j>>2]|0)+28>>2];c[m>>2]=PA(c[f>>2]|0,c[k>>2]|0)|0;dB(c[(c[f>>2]|0)+32>>2]|0,(c[m>>2]|0)+32|0,c[j>>2]|0);dB(c[(c[f>>2]|0)+36>>2]|0,(c[m>>2]|0)+24|0,c[j>>2]|0);c[m>>2]=PA(c[f>>2]|0,c[l>>2]|0)|0;dB(c[(c[f>>2]|0)+32>>2]|0,(c[m>>2]|0)+28|0,c[h>>2]|0);dB(c[(c[f>>2]|0)+36>>2]|0,(c[m>>2]|0)+20|0,c[h>>2]|0);i=e;return}function XA(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;h=e+4|0;j=e;c[h>>2]=a;c[j>>2]=b;b=c[j>>2]|0;c[j>>2]=(c[c[j>>2]>>2]&3|0)==2?b:b+-32|0;b=c[h>>2]|0;a=c[j>>2]|0;k=c[((c[c[j>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0;a=c[j>>2]|0;l=c[((c[c[j>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0;a=c[j>>2]|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];if(!(cB(b,k,l,f)|0)){c[g>>2]=-1;m=c[g>>2]|0;i=e;return m|0}f=c[h>>2]|0;if((f|0)==(rC(c[h>>2]|0)|0)){if((d[(c[h>>2]|0)+12>>0]|0)>>>6&1)xA(c[j>>2]|0);wC(c[h>>2]|0,c[j>>2]|0);QC(c[j>>2]|0);vB(c[h>>2]|0,2,c[(c[j>>2]|0)+4>>2]|0)}if(vE(c[h>>2]|0,c[j>>2]|0,55,0,0)|0){c[g>>2]=-1;m=c[g>>2]|0;i=e;return m|0}f=c[h>>2]|0;if((f|0)==(rC(c[h>>2]|0)|0))VB(c[h>>2]|0,c[j>>2]|0);c[g>>2]=0;m=c[g>>2]|0;i=e;return m|0}function YA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=0;d=c[h>>2]|0;c[k>>2]=eC(c[g>>2]|0,c[((c[c[h>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0,c[j>>2]|0)|0;d=c[h>>2]|0;c[l>>2]=eC(c[g>>2]|0,c[((c[c[h>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0,c[j>>2]|0)|0;if(!((c[k>>2]|0)!=0&(c[l>>2]|0)!=0)){n=c[m>>2]|0;i=e;return n|0}d=c[g>>2]|0;b=c[k>>2]|0;k=c[l>>2]|0;l=c[h>>2]|0;c[f>>2]=c[l>>2];c[f+4>>2]=c[l+4>>2];c[m>>2]=cB(d,b,k,f)|0;if((c[j>>2]|0)!=0&(c[m>>2]|0)==0){eB(c[g>>2]|0,c[h>>2]|0);c[m>>2]=c[h>>2]}if(!(c[m>>2]|0)){n=c[m>>2]|0;i=e;return n|0}if((c[c[m>>2]>>2]&3|0)==(c[c[h>>2]>>2]&3|0)){n=c[m>>2]|0;i=e;return n|0}h=c[m>>2]|0;c[m>>2]=(c[c[m>>2]>>2]&3|0)==3?h+-32|0:h+32|0;n=c[m>>2]|0;i=e;return n|0}function ZA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;k=f+4|0;l=f;c[f+24>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f+12>>2]=e;c[k>>2]=c[g>>2];c[l>>2]=c[h>>2];c[j>>2]=(c[(c[(c[k>>2]|0)+28>>2]|0)+4>>2]|0)-(c[(c[(c[l>>2]|0)+28>>2]|0)+4>>2]|0);do if(!(c[j>>2]|0)){if((c[c[k>>2]>>2]&3|0)!=0?(c[c[l>>2]>>2]&3|0)!=0:0){c[j>>2]=(c[(c[k>>2]|0)+4>>2]|0)-(c[(c[l>>2]|0)+4>>2]|0);break}c[j>>2]=0}while(0);if(!(c[j>>2]|0)){m=0;i=f;return m|0}m=(c[j>>2]|0)<0?-1:1;i=f;return m|0}function _A(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;k=f+4|0;l=f;c[f+24>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f+12>>2]=e;c[k>>2]=c[g>>2];c[l>>2]=c[h>>2];h=c[k>>2]|0;if((c[(c[k>>2]|0)+28>>2]|0)!=(c[(c[l>>2]|0)+28>>2]|0))c[j>>2]=((c[c[h+28>>2]>>2]|0)>>>4)-((c[c[(c[l>>2]|0)+28>>2]>>2]|0)>>>4);else c[j>>2]=((c[h>>2]|0)>>>4)-((c[c[l>>2]>>2]|0)>>>4);if(!(c[j>>2]|0)){m=0;i=f;return m|0}m=(c[j>>2]|0)<0?-1:1;i=f;return m|0}function $A(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;if(pB(c[j>>2]|0)|0){if(((d[(c[j>>2]|0)+12>>0]|0)>>>2&1|0)!=0?(c[k>>2]|0)==(c[l>>2]|0):0){c[h>>2]=0;n=c[h>>2]|0;i=f;return n|0};c[m>>2]=c[13054];c[m+4>>2]=c[13055];c[m>>2]=c[m>>2]&-4;e=c[j>>2]|0;j=c[k>>2]|0;k=c[l>>2]|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];if(cB(e,j,k,g)|0){c[h>>2]=0;n=c[h>>2]|0;i=f;return n|0}}c[h>>2]=1;n=c[h>>2]|0;i=f;return n|0}function aB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;eB(c[e>>2]|0,c[f>>2]|0);i=d;return}function bB(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;eC(c[h>>2]|0,c[j>>2]|0,1)|0;eC(c[h>>2]|0,c[k>>2]|0,1)|0;c[m>>2]=UB(c[h>>2]|0,64)|0;c[n>>2]=(c[m>>2]|0)+32;c[o>>2]=c[m>>2];c[p>>2]=iB(c[h>>2]|0,2)|0;m=c[n>>2]|0;c[m>>2]=c[m>>2]&-4|3;m=c[o>>2]|0;c[m>>2]=c[m>>2]&-4|2;m=c[l>>2]|0;c[(c[o>>2]|0)+4>>2]=m;c[(c[n>>2]|0)+4>>2]=m;m=c[o>>2]|0;l=c[p>>2]&268435455;c[m>>2]=c[m>>2]&15|l<<4;m=c[n>>2]|0;c[m>>2]=c[m>>2]&15|(l&268435455)<<4;c[(c[n>>2]|0)+28>>2]=c[j>>2];c[(c[o>>2]|0)+28>>2]=c[k>>2];eB(c[h>>2]|0,c[o>>2]|0);if(!((d[(c[h>>2]|0)+12>>0]|0)>>>6&1)){q=c[h>>2]|0;r=c[o>>2]|0;sC(q,r);s=c[o>>2]|0;i=g;return s|0}MC(c[o>>2]|0,c[13015]|0,16,0)|0;wA(c[h>>2]|0,c[o>>2]|0);q=c[h>>2]|0;r=c[o>>2]|0;sC(q,r);s=c[o>>2]|0;i=g;return s|0}function cB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f+56|0;h=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+8|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;if((c[j>>2]|0)==0|(c[k>>2]|0)==0){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0};c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+28>>2]=c[j>>2];c[n>>2]=PA(c[h>>2]|0,c[k>>2]|0)|0;if(c[n>>2]|0){Oz(c[(c[h>>2]|0)+36>>2]|0,c[(c[n>>2]|0)+20>>2]|0)|0;c[l>>2]=Hb[c[c[(c[h>>2]|0)+36>>2]>>2]&63](c[(c[h>>2]|0)+36>>2]|0,m,4)|0;m=Kz(c[(c[h>>2]|0)+36>>2]|0)|0;c[(c[n>>2]|0)+20>>2]=m}else c[l>>2]=0;c[g>>2]=c[l>>2];o=c[g>>2]|0;i=f;return o|0}function dB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;Oz(c[f>>2]|0,c[c[g>>2]>>2]|0)|0;c[e>>2]=Hb[c[c[f>>2]>>2]&63](c[f>>2]|0,c[h>>2]|0,2)|0;h=Kz(c[f>>2]|0)|0;c[c[g>>2]>>2]=h;i=e;return}function eB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+48|0;e=d+32|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;b=c[g>>2]|0;c[k>>2]=(c[c[g>>2]>>2]&3|0)==2?b:b+-32|0;b=c[g>>2]|0;c[l>>2]=(c[c[g>>2]>>2]&3|0)==3?b:b+32|0;b=c[g>>2]|0;c[h>>2]=c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2];b=c[g>>2]|0;c[j>>2]=c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];while(1){if(!(c[f>>2]|0)){n=5;break}b=c[f>>2]|0;a=c[h>>2]|0;o=c[j>>2]|0;p=c[g>>2]|0;c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];if(cB(b,a,o,e)|0){n=5;break}c[m>>2]=PA(c[f>>2]|0,c[h>>2]|0)|0;fB(c[(c[f>>2]|0)+32>>2]|0,(c[m>>2]|0)+32|0,c[k>>2]|0);fB(c[(c[f>>2]|0)+36>>2]|0,(c[m>>2]|0)+24|0,c[k>>2]|0);c[m>>2]=PA(c[f>>2]|0,c[j>>2]|0)|0;fB(c[(c[f>>2]|0)+32>>2]|0,(c[m>>2]|0)+28|0,c[l>>2]|0);fB(c[(c[f>>2]|0)+36>>2]|0,(c[m>>2]|0)+20|0,c[l>>2]|0);c[f>>2]=ID(c[f>>2]|0)|0}if((n|0)==5){i=d;return}}function fB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;Oz(c[f>>2]|0,c[c[g>>2]>>2]|0)|0;Hb[c[c[f>>2]>>2]&63](c[f>>2]|0,c[h>>2]|0,1)|0;h=Kz(c[f>>2]|0)|0;c[c[g>>2]>>2]=h;i=e;return}function gB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=b;c[h>>2]=e;c[k>>2]=rB(c[h>>2]|0)|0;c[j>>2]=Ob[c[(c[c[k>>2]>>2]|0)+4>>2]&127](c[(c[k>>2]|0)+12>>2]|0,56)|0;e=c[j>>2]|0;c[e>>2]=c[e>>2]&-4;c[(c[j>>2]|0)+52>>2]=c[k>>2];c[(c[j>>2]|0)+12>>2]=c[d>>2];d=(c[j>>2]|0)+12|0;a[d>>0]=a[d>>0]&-9|8;c[(c[j>>2]|0)+48>>2]=c[j>>2];d=Ob[c[c[(c[(c[j>>2]|0)+52>>2]|0)+4>>2]>>2]&127](c[j>>2]|0,c[h>>2]|0)|0;c[(c[(c[j>>2]|0)+52>>2]|0)+12+4>>2]=d;if(!(tB(c[j>>2]|0,0,c[g>>2]|0,l,1)|0)){m=c[j>>2]|0;n=hB(m)|0;c[j>>2]=n;o=c[j>>2]|0;p=c[j>>2]|0;xB(o,0,p);q=c[j>>2]|0;i=f;return q|0}c[(c[j>>2]|0)+4>>2]=c[l>>2];m=c[j>>2]|0;n=hB(m)|0;c[j>>2]=n;o=c[j>>2]|0;p=c[j>>2]|0;xB(o,0,p);q=c[j>>2]|0;i=f;return q|0}function hB(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;a=OD(c[e>>2]|0,52476,c[12993]|0)|0;c[(c[e>>2]|0)+24>>2]=a;a=OD(c[e>>2]|0,52440,c[12993]|0)|0;c[(c[e>>2]|0)+28>>2]=a;a=c[e>>2]|0;g=c[e>>2]|0;h=(g|0)==(rC(c[e>>2]|0)|0);g=OD(a,h?52072:52108,c[12993]|0)|0;c[(c[e>>2]|0)+32>>2]=g;g=c[e>>2]|0;h=c[e>>2]|0;a=(h|0)==(rC(c[e>>2]|0)|0);h=OD(g,a?52144:52180,c[12993]|0)|0;c[(c[e>>2]|0)+36>>2]=h;h=OD(c[e>>2]|0,52224,c[12993]|0)|0;c[(c[e>>2]|0)+40>>2]=h;c[f>>2]=ID(c[e>>2]|0)|0;if(c[f>>2]|0){h=iB(c[f>>2]|0,0)|0;a=c[e>>2]|0;c[a>>2]=c[a>>2]&15|(h&268435455)<<4;Hb[c[c[(c[f>>2]|0)+40>>2]>>2]&63](c[(c[f>>2]|0)+40>>2]|0,c[e>>2]|0,1)|0}if((c[f>>2]|0)!=0?((d[(c[f>>2]|0)+12>>0]|0)>>>6&1|0)==0:0){j=c[e>>2]|0;k=c[e>>2]|0;sC(j,k);l=c[e>>2]|0;i=b;return l|0}sA(c[e>>2]|0);j=c[e>>2]|0;k=c[e>>2]|0;sC(j,k);l=c[e>>2]|0;i=b;return l|0}function iB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=(c[(c[e>>2]|0)+52>>2]|0)+24+(c[f>>2]<<2)|0;f=(c[b>>2]|0)+1|0;c[b>>2]=f;i=d;return f|0}function jB(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+48|0;e=b+36|0;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;o=b;c[f>>2]=a;c[j>>2]=ID(c[f>>2]|0)|0;if((c[j>>2]|0)==0?(c[(c[c[(c[f>>2]|0)+52>>2]>>2]|0)+16>>2]|0)!=0:0){wC(c[f>>2]|0,c[f>>2]|0);vB(c[f>>2]|0,0,c[(c[f>>2]|0)+4>>2]|0);Bb[c[(c[c[(c[f>>2]|0)+52>>2]>>2]|0)+16>>2]&127](c[(c[(c[f>>2]|0)+52>>2]|0)+12>>2]|0);c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}c[g>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[h>>2]=HD(c[g>>2]|0)|0;jB(c[g>>2]|0)|0;c[g>>2]=c[h>>2]}c[k>>2]=$B(c[f>>2]|0)|0;while(1){q=c[f>>2]|0;if(!(c[k>>2]|0))break;c[l>>2]=aC(q,c[k>>2]|0)|0;hC(c[f>>2]|0,c[k>>2]|0)|0;c[k>>2]=c[l>>2]}KB(q);wC(c[f>>2]|0,c[f>>2]|0);if(QD(c[f>>2]|0,c[(c[f>>2]|0)+28>>2]|0)|0){c[e>>2]=-1;p=c[e>>2]|0;i=b;return p|0}if(QD(c[f>>2]|0,c[(c[f>>2]|0)+24>>2]|0)|0){c[e>>2]=-1;p=c[e>>2]|0;i=b;return p|0}if(QD(c[f>>2]|0,c[(c[f>>2]|0)+36>>2]|0)|0){c[e>>2]=-1;p=c[e>>2]|0;i=b;return p|0}if(QD(c[f>>2]|0,c[(c[f>>2]|0)+32>>2]|0)|0){c[e>>2]=-1;p=c[e>>2]|0;i=b;return p|0}if(QD(c[f>>2]|0,c[(c[f>>2]|0)+40>>2]|0)|0){c[e>>2]=-1;p=c[e>>2]|0;i=b;return p|0}if(((d[(c[f>>2]|0)+12>>0]|0)>>>6&1|0)!=0?(tA(c[f>>2]|0)|0)!=0:0){c[e>>2]=-1;p=c[e>>2]|0;i=b;return p|0}QC(c[f>>2]|0);vB(c[f>>2]|0,0,c[(c[f>>2]|0)+4>>2]|0);do if(c[j>>2]|0){JD(c[j>>2]|0,c[f>>2]|0)|0;VB(c[j>>2]|0,c[f>>2]|0)}else{while(1){r=c[f>>2]|0;if(!(c[(c[(c[f>>2]|0)+52>>2]|0)+36>>2]|0))break;zC(r,c[c[(c[(c[f>>2]|0)+52>>2]|0)+36>>2]>>2]|0)|0}Bb[c[(c[(c[r+52>>2]|0)+4>>2]|0)+20>>2]&127](c[(c[(c[f>>2]|0)+52>>2]|0)+12+4>>2]|0);if(!(WC(c[f>>2]|0)|0)){c[m>>2]=c[c[(c[f>>2]|0)+52>>2]>>2];c[n>>2]=c[(c[(c[f>>2]|0)+52>>2]|0)+12>>2];c[o>>2]=c[(c[f>>2]|0)+52>>2];Db[c[(c[m>>2]|0)+12>>2]&31](c[n>>2]|0,c[f>>2]|0);Db[c[(c[m>>2]|0)+12>>2]&31](c[n>>2]|0,c[o>>2]|0);break}c[e>>2]=-1;p=c[e>>2]|0;i=b;return p|0}while(0);c[e>>2]=0;p=c[e>>2]|0;i=b;return p|0}function kB(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=Pz(c[(c[d>>2]|0)+28>>2]|0)|0;i=b;return a|0}function lB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=0;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;a=mB(c[d>>2]|0,c[e>>2]|0,0,1)|0;c[f>>2]=(c[f>>2]|0)+a;c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return c[f>>2]|0}function mB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=0;c[l>>2]=PA(c[g>>2]|0,c[h>>2]|0)|0;if(!(c[l>>2]|0)){n=c[m>>2]|0;i=f;return n|0}if(c[k>>2]|0){k=sB(c[(c[g>>2]|0)+32>>2]|0,(c[l>>2]|0)+32|0)|0;c[m>>2]=(c[m>>2]|0)+k}if(!(c[j>>2]|0)){n=c[m>>2]|0;i=f;return n|0}j=sB(c[(c[g>>2]|0)+32>>2]|0,(c[l>>2]|0)+28|0)|0;c[m>>2]=(c[m>>2]|0)+j;n=c[m>>2]|0;i=f;return n|0}function nB(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;i=d;return a[(c[e>>2]|0)+12>>0]&1|0}function oB(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=((nB(c[d>>2]|0)|0)!=0^1)&1;i=b;return a|0}function pB(a){a=a|0;var b=0,e=0;b=i;i=i+16|0;e=b;c[e>>2]=a;i=b;return (d[(c[e>>2]|0)+12>>0]|0)>>>1&1|0}function qB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;k=f+4|0;l=f;c[f+24>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f+12>>2]=e;c[k>>2]=c[g>>2];c[l>>2]=c[h>>2];c[j>>2]=(c[(c[k>>2]|0)+4>>2]|0)-(c[(c[l>>2]|0)+4>>2]|0);if(!(c[j>>2]|0)){m=0;i=f;return m|0}m=(c[j>>2]|0)<0?-1:1;i=f;return m|0}function rB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=b;if((c[e>>2]|0)!=0?(c[c[e>>2]>>2]|0)!=0:0)j=c[c[e>>2]>>2]|0;else j=52420;c[f>>2]=j;c[g>>2]=Fb[c[c[f>>2]>>2]&63](c[e>>2]|0)|0;c[h>>2]=Ob[c[(c[f>>2]|0)+4>>2]&127](c[g>>2]|0,68)|0;c[c[h>>2]>>2]=c[f>>2];c[(c[h>>2]|0)+12>>2]=c[g>>2];if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+4>>2]|0)!=0:0)k=c[(c[e>>2]|0)+4>>2]|0;else k=52292;c[(c[h>>2]|0)+4>>2]=k;if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+8>>2]|0)!=0:0)l=c[(c[e>>2]|0)+8>>2]|0;else l=52396;c[(c[h>>2]|0)+8>>2]=l;a[(c[h>>2]|0)+40>>0]=1;i=d;return c[h>>2]|0}function sB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;Oz(c[e>>2]|0,c[c[f>>2]>>2]|0)|0;c[g>>2]=Pz(c[e>>2]|0)|0;b=Kz(c[e>>2]|0)|0;c[c[f>>2]>>2]=b;i=d;return c[g>>2]|0}function tB(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;if(((c[m>>2]|0)!=0?(a[c[m>>2]>>0]|0)!=37:0)?(c[p>>2]=Gb[c[(c[(c[(c[k>>2]|0)+52>>2]|0)+4>>2]|0)+4>>2]&63](c[(c[(c[k>>2]|0)+52>>2]|0)+12+4>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0,(c[p>>2]|0)!=0):0){c[j>>2]=c[p>>2];q=c[j>>2]|0;i=h;return q|0}if(c[m>>2]|0){c[p>>2]=FB(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;if(c[p>>2]|0){c[j>>2]=c[p>>2];q=c[j>>2]|0;i=h;return q|0}}else c[p>>2]=0;if((c[o>>2]|0)!=0?(c[p>>2]=Gb[c[(c[(c[(c[k>>2]|0)+52>>2]|0)+4>>2]|0)+4>>2]&63](c[(c[(c[k>>2]|0)+52>>2]|0)+12+4>>2]|0,c[l>>2]|0,0,c[n>>2]|0,c[o>>2]|0)|0,(c[p>>2]|0)!=0&(c[m>>2]|0)!=0):0)GB(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[c[n>>2]>>2]|0);c[j>>2]=c[p>>2];q=c[j>>2]|0;i=h;return q|0}function uB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=Hb[c[(c[(c[(c[f>>2]|0)+52>>2]|0)+4>>2]|0)+8>>2]&63](c[(c[(c[f>>2]|0)+52>>2]|0)+12+4>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;i=e;return d|0}function vB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;IB(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;Tb[c[(c[(c[(c[f>>2]|0)+52>>2]|0)+4>>2]|0)+12>>2]&127](c[(c[(c[f>>2]|0)+52>>2]|0)+12+4>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function wB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;c[f>>2]=a;c[g>>2]=qC(c[f>>2]|0)|0;a=HB(c[g>>2]|0,c[c[f>>2]>>2]&3,c[(c[f>>2]|0)+4>>2]|0)|0;c[h>>2]=a;if(a){c[e>>2]=c[h>>2];j=c[e>>2]|0;i=b;return j|0}if((c[(c[(c[(c[g>>2]|0)+52>>2]|0)+4>>2]|0)+16>>2]|0)!=0?(a=Hb[c[(c[(c[(c[g>>2]|0)+52>>2]|0)+4>>2]|0)+16>>2]&63](c[(c[(c[g>>2]|0)+52>>2]|0)+12+4>>2]|0,c[c[f>>2]>>2]&3,c[(c[f>>2]|0)+4>>2]|0)|0,c[h>>2]=a,(a|0)!=0):0){c[e>>2]=c[h>>2];j=c[e>>2]|0;i=b;return j|0}if((c[c[f>>2]>>2]&3|0)!=2){a=c[(c[f>>2]|0)+4>>2]|0;c[d>>2]=37;c[d+4>>2]=a;k3(134116,134148,d)|0;c[h>>2]=134116}else c[h>>2]=0;c[e>>2]=c[h>>2];j=c[e>>2]|0;i=b;return j|0}function xB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;Tb[c[(c[(c[(c[f>>2]|0)+52>>2]|0)+4>>2]|0)+24>>2]&127](c[(c[(c[f>>2]|0)+52>>2]|0)+12+4>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function yB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+4|0;c[e>>2]=a;c[d>>2]=b;i=d;return c[e>>2]|0}function zB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+24|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[g+20>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;if(!(c[j>>2]|0)){c[c[k>>2]>>2]=c[13080];c[13080]=(c[13080]|0)+2;i=g;return 1}c[n>>2]=c[h>>2];h=c[n>>2]|0;n=c[j>>2]|0;if(c[l>>2]|0)c[m>>2]=YC(h,n)|0;else c[m>>2]=XC(h,n)|0;c[c[k>>2]>>2]=c[m>>2];i=g;return 1}function AB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;i=i+16|0;c[e+8>>2]=a;c[e+4>>2]=b;c[e>>2]=d;i=e;return 0}function BB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[f>>2]=a;c[e+4>>2]=b;c[g>>2]=d;if(((c[g>>2]|0)>>>0)%2|0){i=e;return}_C(c[f>>2]|0,c[g>>2]|0)|0;i=e;return}function CB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+12|0;g=e;c[e+8>>2]=a;c[e+4>>2]=b;c[g>>2]=d;if(!(((c[g>>2]|0)>>>0)%2|0)){c[f>>2]=c[g>>2];h=c[f>>2]|0;i=e;return h|0}else{c[f>>2]=0;h=c[f>>2]|0;i=e;return h|0}return 0}function DB(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return}function EB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;i=i+16|0;c[e+8>>2]=a;c[e+4>>2]=b;c[e>>2]=d;i=e;return}function FB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+64|0;g=f+56|0;h=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+8|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[j>>2]|0)==3)c[j>>2]=2;e=c[(c[(c[h>>2]|0)+52>>2]|0)+44+(c[j>>2]<<2)>>2]|0;c[m>>2]=e;if(((e|0)!=0?(e=XC(c[h>>2]|0,c[k>>2]|0)|0,c[p>>2]=e,(e|0)!=0):0)?(c[o+20>>2]=c[p>>2],c[n>>2]=Hb[c[c[m>>2]>>2]&63](c[m>>2]|0,o,4)|0,(c[n>>2]|0)!=0):0){c[c[l>>2]>>2]=c[(c[n>>2]|0)+16>>2];c[g>>2]=1;q=c[g>>2]|0;i=f;return q|0}c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}function GB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=UB(c[g>>2]|0,24)|0;c[(c[l>>2]|0)+16>>2]=c[k>>2];k=YC(c[g>>2]|0,c[j>>2]|0)|0;c[(c[l>>2]|0)+20>>2]=k;if((c[h>>2]|0)==3)c[h>>2]=2;k=c[(c[(c[g>>2]|0)+52>>2]|0)+44+(c[h>>2]<<2)>>2]|0;c[m>>2]=k;if(!k){k=OD(c[g>>2]|0,52324,c[12993]|0)|0;c[(c[(c[g>>2]|0)+52>>2]|0)+44+(c[h>>2]<<2)>>2]=k;c[m>>2]=k}k=c[(c[(c[g>>2]|0)+52>>2]|0)+56+(c[h>>2]<<2)>>2]|0;c[n>>2]=k;if(k){o=c[m>>2]|0;p=c[o>>2]|0;q=c[m>>2]|0;r=c[l>>2]|0;Hb[p&63](q,r,1)|0;s=c[n>>2]|0;t=c[s>>2]|0;u=c[n>>2]|0;v=c[l>>2]|0;Hb[t&63](u,v,1)|0;i=f;return}k=OD(c[g>>2]|0,52360,c[12993]|0)|0;c[(c[(c[g>>2]|0)+52>>2]|0)+56+(c[h>>2]<<2)>>2]=k;c[n>>2]=k;o=c[m>>2]|0;p=c[o>>2]|0;q=c[m>>2]|0;r=c[l>>2]|0;Hb[p&63](q,r,1)|0;s=c[n>>2]|0;t=c[s>>2]|0;u=c[n>>2]|0;v=c[l>>2]|0;Hb[t&63](u,v,1)|0;i=f;return}function HB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=LB(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[k>>2]=d;if(d){c[f>>2]=c[(c[k>>2]|0)+20>>2];l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function IB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[h>>2]|0)==3)c[h>>2]=2;d=LB(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;c[k>>2]=d;if(d){Hb[c[c[(c[(c[g>>2]|0)+52>>2]|0)+44+(c[h>>2]<<2)>>2]>>2]&63](c[(c[(c[g>>2]|0)+52>>2]|0)+44+(c[h>>2]<<2)>>2]|0,c[k>>2]|0,2)|0;Hb[c[c[(c[(c[g>>2]|0)+52>>2]|0)+56+(c[h>>2]<<2)>>2]>>2]&63](c[(c[(c[g>>2]|0)+52>>2]|0)+56+(c[h>>2]<<2)>>2]|0,c[k>>2]|0,2)|0;_C(c[g>>2]|0,c[(c[k>>2]|0)+20>>2]|0)|0;VB(c[g>>2]|0,c[k>>2]|0);c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function JB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[13072]=c[e>>2];c[j>>2]=(c[(c[e>>2]|0)+52>>2]|0)+44;c[f>>2]=0;while(1){if((c[f>>2]|0)>=3)break;a:do if(c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0){c[g>>2]=Hb[c[c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]>>2]&63](c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0,0,128)|0;while(1){if(!(c[g>>2]|0))break a;c[h>>2]=Hb[c[c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]>>2]&63](c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0,c[g>>2]|0,8)|0;if((a[c[(c[g>>2]|0)+20>>2]>>0]|0)==37)IB(c[e>>2]|0,c[f>>2]|0,c[(c[g>>2]|0)+16>>2]|0)|0;c[g>>2]=c[h>>2]}}while(0);c[f>>2]=(c[f>>2]|0)+1}i=d;return}function KB(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[13072]=c[d>>2];MB((c[(c[d>>2]|0)+52>>2]|0)+44|0);MB((c[(c[d>>2]|0)+52>>2]|0)+56|0);i=b;return}function LB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)==3)c[g>>2]=2;d=c[(c[(c[f>>2]|0)+52>>2]|0)+56+(c[g>>2]<<2)>>2]|0;c[j>>2]=d;if(d){c[l+16>>2]=c[h>>2];c[k>>2]=Hb[c[c[j>>2]>>2]&63](c[j>>2]|0,l,4)|0;m=c[k>>2]|0;i=e;return m|0}else{c[k>>2]=0;m=c[k>>2]|0;i=e;return m|0}return 0}function MB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;while(1){if((c[e>>2]|0)>=3)break;if(c[(c[d>>2]|0)+(c[e>>2]<<2)>>2]|0){Jz(c[(c[d>>2]|0)+(c[e>>2]<<2)>>2]|0)|0;c[(c[d>>2]|0)+(c[e>>2]<<2)>>2]=0}c[e>>2]=(c[e>>2]|0)+1}i=b;return}function NB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+4|0;k=f;c[f+20>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f+8>>2]=e;c[j>>2]=c[g>>2];c[k>>2]=c[h>>2];i=f;return (c[(c[j>>2]|0)+16>>2]|0)-(c[(c[k>>2]|0)+16>>2]|0)|0}function OB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+4|0;k=f;c[f+20>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f+8>>2]=e;c[j>>2]=c[g>>2];c[k>>2]=c[h>>2];i=f;return (c[(c[j>>2]|0)+20>>2]|0)-(c[(c[k>>2]|0)+20>>2]|0)|0}function PB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+28|0;e=b+24|0;f=b+12|0;g=b;c[d>>2]=a;c[13103]=c[13100];c[13104]=c[13101];c[f>>2]=c[d>>2];c[f+4>>2]=N3(c[d>>2]|0)|0;c[f+8>>2]=0;c[g>>2]=52420;c[g+4>>2]=52292;c[g+8>>2]=52408;c[e>>2]=CE(f,g)|0;i=b;return c[e>>2]|0}function QB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(V2(c[h>>2]|0,c[j>>2]|0,c[g>>2]|0)|0){c[f>>2]=N3(c[h>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}return 0}function RB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=_2(c[f>>2]|0,c[e>>2]|0)|0;i=d;return b|0}function SB(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=T2(c[d>>2]|0)|0;i=b;return a|0}function TB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+32|0;o=f+4|0;p=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[k>>2]|0)){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[p>>2]=c[h>>2];if((c[(c[p>>2]|0)+8>>2]|0)>=(c[(c[p>>2]|0)+4>>2]|0)){c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}c[o>>2]=0;c[l>>2]=(c[c[p>>2]>>2]|0)+(c[(c[p>>2]|0)+8>>2]|0);c[m>>2]=c[j>>2];j=c[l>>2]|0;c[l>>2]=j+1;a[n>>0]=a[j>>0]|0;do{j=a[n>>0]|0;h=c[m>>2]|0;c[m>>2]=h+1;a[h>>0]=j;c[o>>2]=(c[o>>2]|0)+1;if((a[n>>0]|0)==10)break;if((c[o>>2]|0)>=(c[k>>2]|0))break;j=c[l>>2]|0;c[l>>2]=j+1;h=a[j>>0]|0;a[n>>0]=h}while((h<<24>>24|0)!=0);n=(c[p>>2]|0)+8|0;c[n>>2]=(c[n>>2]|0)+(c[o>>2]|0);c[g>>2]=c[o>>2];q=c[g>>2]|0;i=f;return q|0}function UB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;c[e>>2]=a;c[f>>2]=b;c[g>>2]=Ob[c[(c[c[(c[e>>2]|0)+52>>2]>>2]|0)+4>>2]&127](c[(c[(c[e>>2]|0)+52>>2]|0)+12>>2]|0,c[f>>2]|0)|0;if(c[g>>2]|0){h=c[g>>2]|0;i=d;return h|0}$z(1,134154,d)|0;h=c[g>>2]|0;i=d;return h|0}function VB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[f>>2]|0)){i=d;return}Db[c[(c[c[(c[e>>2]|0)+52>>2]>>2]|0)+12>>2]&31](c[(c[(c[e>>2]|0)+52>>2]|0)+12>>2]|0,c[f>>2]|0);i=d;return}function WB(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return 0}function XB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[d+8>>2]=a;c[e>>2]=b;c[f>>2]=N4(c[e>>2]|0)|0;$4(c[f>>2]|0,0,c[e>>2]|0)|0;i=d;return c[f>>2]|0}function YB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[f+16>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[k>>2]=Q4(c[g>>2]|0,c[j>>2]|0)|0;if((c[j>>2]|0)>>>0<=(c[h>>2]|0)>>>0){l=c[k>>2]|0;i=f;return l|0}$4((c[k>>2]|0)+(c[h>>2]|0)|0,0,(c[j>>2]|0)-(c[h>>2]|0)|0)|0;l=c[k>>2]|0;i=f;return l|0}function ZB(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[d+4>>2]=a;c[e>>2]=b;O4(c[e>>2]|0);i=d;return}function _B(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[13129]=c[f>>2];c[13145]=52512;c[g>>2]=Hb[c[c[(c[e>>2]|0)+28>>2]>>2]&63](c[(c[e>>2]|0)+28>>2]|0,52564,4)|0;if(!(c[g>>2]|0)){h=0;i=d;return h|0}h=c[(c[g>>2]|0)+16>>2]|0;i=d;return h|0}function $B(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=Hb[c[c[(c[d>>2]|0)+24>>2]>>2]&63](c[(c[d>>2]|0)+24>>2]|0,0,128)|0;if(!(c[e>>2]|0)){f=0;i=b;return f|0}f=c[(c[e>>2]|0)+16>>2]|0;i=b;return f|0}function aC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=PA(c[e>>2]|0,c[f>>2]|0)|0;if(c[g>>2]|0)c[g>>2]=Hb[c[c[(c[e>>2]|0)+24>>2]>>2]&63](c[(c[e>>2]|0)+24>>2]|0,c[g>>2]|0,8)|0;if(!(c[g>>2]|0)){h=0;i=d;return h|0}h=c[(c[g>>2]|0)+16>>2]|0;i=d;return h|0}function bC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=Hb[c[c[(c[d>>2]|0)+24>>2]>>2]&63](c[(c[d>>2]|0)+24>>2]|0,0,256)|0;if(!(c[e>>2]|0)){f=0;i=b;return f|0}f=c[(c[e>>2]|0)+16>>2]|0;i=b;return f|0}function cC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=PA(c[e>>2]|0,c[f>>2]|0)|0;if(c[g>>2]|0)c[g>>2]=Hb[c[c[(c[e>>2]|0)+24>>2]>>2]&63](c[(c[e>>2]|0)+24>>2]|0,c[g>>2]|0,16)|0;if(!(c[g>>2]|0)){h=0;i=d;return h|0}h=c[(c[g>>2]|0)+16>>2]|0;i=d;return h|0}function dC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[k>>2]=_B(c[f>>2]|0,c[g>>2]|0)|0;if(!((c[k>>2]|0)==0&(c[h>>2]|0)!=0)){l=c[k>>2]|0;i=e;return l|0}c[j>>2]=rC(c[f>>2]|0)|0;if((c[f>>2]|0)!=(c[j>>2]|0)?(h=_B(c[j>>2]|0,c[g>>2]|0)|0,c[k>>2]=h,(h|0)!=0):0){eC(c[f>>2]|0,c[k>>2]|0,1)|0;l=c[k>>2]|0;i=e;return l|0}if(uB(c[f>>2]|0,1,c[g>>2]|0)|0){h=c[f>>2]|0;j=c[g>>2]|0;c[k>>2]=kC(h,j,iB(c[f>>2]|0,1)|0)|0;lC(c[f>>2]|0,c[k>>2]|0);mC(c[f>>2]|0,c[k>>2]|0);l=c[k>>2]|0;i=e;return l|0}else{c[k>>2]=0;l=c[k>>2]|0;i=e;return l|0}return 0}function eC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=rC(c[g>>2]|0)|0;if((d|0)!=(c[(c[h>>2]|0)+12>>2]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[l>>2]=_B(c[g>>2]|0,c[(c[h>>2]|0)+4>>2]|0)|0;if((c[l>>2]|0)==0&(c[j>>2]|0)!=0?(d=ID(c[g>>2]|0)|0,c[k>>2]=d,(d|0)!=0):0){c[l>>2]=eC(c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;nC(c[g>>2]|0,c[l>>2]|0)}c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}function fC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=rC(c[g>>2]|0)|0;if(tB(c[g>>2]|0,1,c[h>>2]|0,m,0)|0){d=_B(c[g>>2]|0,c[m>>2]|0)|0;c[l>>2]=d;if(d){c[f>>2]=c[l>>2];n=c[f>>2]|0;i=e;return n|0}if(((c[j>>2]|0)!=0?(c[g>>2]|0)!=(c[k>>2]|0):0)?(d=_B(c[k>>2]|0,c[m>>2]|0)|0,c[l>>2]=d,(d|0)!=0):0){c[f>>2]=eC(c[g>>2]|0,c[l>>2]|0,1)|0;n=c[f>>2]|0;i=e;return n|0}}if((c[j>>2]|0)!=0?(tB(c[g>>2]|0,1,c[h>>2]|0,m,1)|0)!=0:0){h=c[g>>2]|0;j=c[m>>2]|0;c[l>>2]=kC(h,j,iB(c[g>>2]|0,1)|0)|0;lC(c[g>>2]|0,c[l>>2]|0);mC(c[g>>2]|0,c[l>>2]|0);xB(c[g>>2]|0,1,c[l>>2]|0);c[f>>2]=c[l>>2];n=c[f>>2]|0;i=e;return n|0}c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function gC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[e+8>>2]=d;c[13154]=c[g>>2];c[h>>2]=TA(c[f>>2]|0,c[g>>2]|0)|0;while(1){k=c[f>>2]|0;if(!(c[h>>2]|0))break;c[j>>2]=UA(k,c[h>>2]|0,c[g>>2]|0)|0;WA(c[f>>2]|0,c[h>>2]|0,0);c[h>>2]=c[j>>2]}Hb[c[c[k+28>>2]>>2]&63](c[(c[f>>2]|0)+28>>2]|0,52600,2)|0;Hb[c[c[(c[f>>2]|0)+24>>2]>>2]&63](c[(c[f>>2]|0)+24>>2]|0,52600,2)|0;i=e;return}function hC(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;if(!(_B(c[g>>2]|0,c[(c[h>>2]|0)+4>>2]|0)|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}b=c[g>>2]|0;if((b|0)==(rC(c[g>>2]|0)|0)){c[j>>2]=TA(c[g>>2]|0,c[h>>2]|0)|0;while(1){m=c[g>>2]|0;if(!(c[j>>2]|0))break;c[k>>2]=UA(m,c[j>>2]|0,c[h>>2]|0)|0;XA(c[g>>2]|0,c[j>>2]|0)|0;c[j>>2]=c[k>>2]}if((d[m+12>>0]|0)>>>6&1)vA(c[h>>2]|0);wC(c[g>>2]|0,c[h>>2]|0);QC(c[h>>2]|0);vB(c[g>>2]|0,1,c[(c[h>>2]|0)+4>>2]|0)}if(vE(c[g>>2]|0,c[h>>2]|0,56,0,0)|0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}m=c[g>>2]|0;if((m|0)==(rC(c[g>>2]|0)|0))VB(c[g>>2]|0,c[h>>2]|0);c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function iC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;k=f+4|0;l=f;c[f+24>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f+12>>2]=e;c[k>>2]=c[g>>2];c[l>>2]=c[h>>2];c[j>>2]=(c[(c[(c[k>>2]|0)+16>>2]|0)+4>>2]|0)-(c[(c[(c[l>>2]|0)+16>>2]|0)+4>>2]|0);if(!(c[j>>2]|0)){m=0;i=f;return m|0}m=(c[j>>2]|0)<0?-1:1;i=f;return m|0}function jC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+8|0;k=f+4|0;l=f;c[f+24>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f+12>>2]=e;c[j>>2]=c[g>>2];c[k>>2]=c[h>>2];c[l>>2]=((c[c[(c[j>>2]|0)+16>>2]>>2]|0)>>>4)-((c[c[(c[k>>2]|0)+16>>2]>>2]|0)>>>4);if(!(c[l>>2]|0)){m=0;i=f;return m|0}m=(c[l>>2]|0)<0?-1:1;i=f;return m|0}function kC(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=e;c[k>>2]=UB(c[g>>2]|0,52)|0;e=c[k>>2]|0;c[e>>2]=c[e>>2]&-4|1;c[(c[k>>2]|0)+4>>2]=c[h>>2];h=c[k>>2]|0;c[h>>2]=c[h>>2]&15|(c[j>>2]&268435455)<<4;j=rC(c[g>>2]|0)|0;c[(c[k>>2]|0)+12>>2]=j;if(!((d[(rC(c[g>>2]|0)|0)+12>>0]|0)>>>6&1)){l=c[k>>2]|0;i=f;return l|0}MC(c[k>>2]|0,c[13015]|0,16,0)|0;l=c[k>>2]|0;i=f;return l|0}function lC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;nC(c[e>>2]|0,c[f>>2]|0);b=ID(c[e>>2]|0)|0;c[g>>2]=b;if(!b){i=d;return}lC(c[g>>2]|0,c[f>>2]|0);i=d;return}function mC(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=a;c[g>>2]=b;if((d[(rC(c[f>>2]|0)|0)+12>>0]|0)>>>6&1)uA(c[f>>2]|0,c[g>>2]|0);sC(c[f>>2]|0,c[g>>2]|0);i=e;return}function nC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;c[e>>2]=a;c[f>>2]=b;c[d>>2]=Pz(c[(c[e>>2]|0)+28>>2]|0)|0;b=c[e>>2]|0;if((b|0)==(rC(c[e>>2]|0)|0))c[g>>2]=(c[f>>2]|0)+16;else c[g>>2]=UB(c[e>>2]|0,36)|0;c[(c[g>>2]|0)+16>>2]=c[f>>2];Hb[c[c[(c[e>>2]|0)+28>>2]>>2]&63](c[(c[e>>2]|0)+28>>2]|0,c[g>>2]|0,1)|0;Hb[c[c[(c[e>>2]|0)+24>>2]>>2]&63](c[(c[e>>2]|0)+24>>2]|0,c[g>>2]|0,1)|0;i=d;return}function oC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;if((c[f>>2]|0)==((c[(c[f>>2]|0)+16>>2]|0)+16|0)){i=e;return}VB(c[(c[(c[f>>2]|0)+16>>2]|0)+12>>2]|0,c[f>>2]|0);i=e;return}function pC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;h=d+4|0;c[g>>2]=a;c[h>>2]=b;if((c[c[h>>2]>>2]&3|0)==0?(b=c[g>>2]|0,(b|0)!=(ID(c[h>>2]|0)|0)):0){$z(1,134180,e)|0;c[f>>2]=-1}else j=4;a:do if((j|0)==4)switch(c[c[h>>2]>>2]&3|0){case 1:{c[f>>2]=hC(c[g>>2]|0,c[h>>2]|0)|0;break a;break}case 2:case 3:{c[f>>2]=XA(c[g>>2]|0,c[h>>2]|0)|0;break a;break}case 0:{c[f>>2]=jB(c[h>>2]|0)|0;break a;break}default:{}}while(0);i=d;return c[f>>2]|0}function qC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;switch(c[c[e>>2]>>2]&3|0){case 2:case 3:{c[d>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+12>>2];break}case 1:{c[d>>2]=c[(c[e>>2]|0)+12>>2];break}case 0:{c[d>>2]=c[e>>2];break}default:{}}i=b;return c[d>>2]|0}function rC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;switch(c[c[e>>2]>>2]&3|0){case 2:case 3:{c[d>>2]=c[(c[(c[e>>2]|0)+28>>2]|0)+12>>2];break}case 1:{c[d>>2]=c[(c[e>>2]|0)+12>>2];break}case 0:{c[d>>2]=c[(c[e>>2]|0)+48>>2];break}default:{}}i=b;return c[d>>2]|0}function sC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;d=c[f>>2]|0;b=c[g>>2]|0;if(a[(c[(c[f>>2]|0)+52>>2]|0)+40>>0]|0){tC(d,b,c[(c[(c[f>>2]|0)+52>>2]|0)+36>>2]|0);i=e;return}else{CC(d,b,100,0);i=e;return}}function tC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[h>>2]|0)){i=e;return}tC(c[f>>2]|0,c[g>>2]|0,c[(c[h>>2]|0)+8>>2]|0);c[j>>2]=0;switch(c[c[g>>2]>>2]&3|0){case 0:{c[j>>2]=c[c[c[h>>2]>>2]>>2];break}case 1:{c[j>>2]=c[(c[c[h>>2]>>2]|0)+12>>2];break}case 2:{c[j>>2]=c[(c[c[h>>2]>>2]|0)+24>>2];break}default:{}}if(!(c[j>>2]|0)){i=e;return}Tb[c[j>>2]&127](c[f>>2]|0,c[g>>2]|0,c[(c[h>>2]|0)+4>>2]|0);i=e;return}function uC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;e=c[g>>2]|0;d=c[h>>2]|0;if(a[(c[(c[g>>2]|0)+52>>2]|0)+40>>0]|0){vC(e,d,c[j>>2]|0,c[(c[(c[g>>2]|0)+52>>2]|0)+36>>2]|0);i=f;return}else{CC(e,d,101,c[j>>2]|0);i=f;return}}function vC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[k>>2]|0)){i=f;return}vC(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[(c[k>>2]|0)+8>>2]|0);c[l>>2]=0;switch(c[c[h>>2]>>2]&3|0){case 0:{c[l>>2]=c[(c[c[k>>2]>>2]|0)+4>>2];break}case 1:{c[l>>2]=c[(c[c[k>>2]>>2]|0)+12+4>>2];break}case 2:{c[l>>2]=c[(c[c[k>>2]>>2]|0)+24+4>>2];break}default:{}}if(!(c[l>>2]|0)){i=f;return}Vb[c[l>>2]&31](c[g>>2]|0,c[h>>2]|0,c[(c[k>>2]|0)+4>>2]|0,c[j>>2]|0);i=f;return}function wC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;d=c[f>>2]|0;b=c[g>>2]|0;if(a[(c[(c[f>>2]|0)+52>>2]|0)+40>>0]|0){xC(d,b,c[(c[(c[f>>2]|0)+52>>2]|0)+36>>2]|0);i=e;return}else{CC(d,b,102,0);i=e;return}}function xC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[h>>2]|0)){i=e;return}xC(c[f>>2]|0,c[g>>2]|0,c[(c[h>>2]|0)+8>>2]|0);c[j>>2]=0;switch(c[c[g>>2]>>2]&3|0){case 0:{c[j>>2]=c[(c[c[h>>2]>>2]|0)+8>>2];break}case 1:{c[j>>2]=c[(c[c[h>>2]>>2]|0)+12+8>>2];break}case 2:{c[j>>2]=c[(c[c[h>>2]>>2]|0)+24+8>>2];break}default:{}}if(!(c[j>>2]|0)){i=e;return}Tb[c[j>>2]&127](c[f>>2]|0,c[g>>2]|0,c[(c[h>>2]|0)+4>>2]|0);i=e;return}function yC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=UB(c[f>>2]|0,12)|0;c[c[j>>2]>>2]=c[g>>2];c[(c[j>>2]|0)+4>>2]=c[h>>2];c[(c[j>>2]|0)+8>>2]=c[(c[(c[f>>2]|0)+52>>2]|0)+36>>2];c[(c[(c[f>>2]|0)+52>>2]|0)+36>>2]=c[j>>2];i=e;return}function zC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[(c[f>>2]|0)+52>>2]|0)+36>>2];if(c[h>>2]|0){if((c[c[h>>2]>>2]|0)!=(c[g>>2]|0)){while(1){if(c[h>>2]|0)j=(c[c[(c[h>>2]|0)+8>>2]>>2]|0)!=(c[g>>2]|0);else j=0;k=c[h>>2]|0;if(!j)break;c[h>>2]=c[k+8>>2]}if((k|0)!=0?(c[(c[h>>2]|0)+8>>2]|0)!=0:0)c[(c[h>>2]|0)+8>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]}else c[(c[(c[f>>2]|0)+52>>2]|0)+36>>2]=c[(c[h>>2]|0)+8>>2];if(c[h>>2]|0){VB(c[f>>2]|0,c[h>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}}c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}function AC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;b=rC(c[f>>2]|0)|0;a:do if((b|0)!=(rC(c[g>>2]|0)|0))c[e>>2]=0;else switch(c[c[g>>2]>>2]&3|0){case 0:{c[h>>2]=c[g>>2];while(1){if((c[h>>2]|0)==(c[f>>2]|0)){j=6;break}a=ID(c[h>>2]|0)|0;c[h>>2]=a;if(!a){j=8;break}}if((j|0)==6){c[e>>2]=1;break a}else if((j|0)==8){c[e>>2]=0;break a}break}case 1:{c[e>>2]=(dC(c[f>>2]|0,c[(c[g>>2]|0)+4>>2]|0,0)|0)!=0&1;break a;break}default:{c[e>>2]=(YA(c[f>>2]|0,c[g>>2]|0,0)|0)!=0&1;break a}}while(0);i=d;return c[e>>2]|0}function BC(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[c[d>>2]>>2]&3|0}function CC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=MC(c[g>>2]|0,134204,44,0)|0;switch(c[j>>2]|0){case 100:{c[m>>2]=DC(c[l>>2]|0,c[h>>2]|0,100)|0;c[n>>2]=EC(c[m>>2]|0,c[h>>2]|0)|0;if(c[n>>2]|0){i=f;return}c[n>>2]=FC(c[m>>2]|0,c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;i=f;return}case 101:{if(EC(DC(c[l>>2]|0,c[h>>2]|0,100)|0,c[h>>2]|0)|0){i=f;return}if(EC(DC(c[l>>2]|0,c[h>>2]|0,102)|0,c[h>>2]|0)|0){i=f;return}c[m>>2]=DC(c[l>>2]|0,c[h>>2]|0,101)|0;c[n>>2]=EC(c[m>>2]|0,c[h>>2]|0)|0;if(!(c[n>>2]|0))c[n>>2]=FC(c[m>>2]|0,c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;GC(c[h>>2]|0,c[n>>2]|0,c[k>>2]|0);i=f;return}case 102:{HC(DC(c[l>>2]|0,c[h>>2]|0,100)|0,c[h>>2]|0);HC(DC(c[l>>2]|0,c[h>>2]|0,101)|0,c[h>>2]|0);c[m>>2]=DC(c[l>>2]|0,c[h>>2]|0,102)|0;c[n>>2]=EC(c[m>>2]|0,c[h>>2]|0)|0;if(c[n>>2]|0){i=f;return}c[n>>2]=FC(c[m>>2]|0,c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;i=f;return}default:{$z(1,134216,f)|0;i=f;return}}}function DC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;c[k>>2]=0;a:do switch(c[c[h>>2]>>2]&3|0){case 0:{switch(c[j>>2]|0){case 100:{c[k>>2]=(c[g>>2]|0)+8;break a;break}case 101:{c[k>>2]=(c[g>>2]|0)+20;break a;break}case 102:{c[k>>2]=(c[g>>2]|0)+32;break a;break}default:break a}break}case 1:{switch(c[j>>2]|0){case 100:{c[k>>2]=(c[g>>2]|0)+8+4;break a;break}case 101:{c[k>>2]=(c[g>>2]|0)+20+4;break a;break}case 102:{c[k>>2]=(c[g>>2]|0)+32+4;break a;break}default:break a}break}case 2:{switch(c[j>>2]|0){case 100:{c[k>>2]=(c[g>>2]|0)+8+8;break a;break}case 101:{c[k>>2]=(c[g>>2]|0)+20+8;break a;break}case 102:{c[k>>2]=(c[g>>2]|0)+32+8;break a;break}default:break a}break}default:{}}while(0);if(!(c[k>>2]|0))$z(1,134250,f)|0;if(c[c[k>>2]>>2]|0){l=c[k>>2]|0;m=c[l>>2]|0;i=e;return m|0}f=qC(c[h>>2]|0)|0;h=OD(f,52636,c[12993]|0)|0;c[c[k>>2]>>2]=h;l=c[k>>2]|0;m=c[l>>2]|0;i=e;return m|0}function EC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+8|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g+8>>2]=IC(c[f>>2]|0)|0;c[h>>2]=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,4)|0;i=d;return c[h>>2]|0}function FC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=UB(qC(c[j>>2]|0)|0,24)|0;c[(c[l>>2]|0)+16>>2]=c[j>>2];e=IC(c[j>>2]|0)|0;c[(c[l>>2]|0)+8>>2]=e;c[(c[l>>2]|0)+12>>2]=c[h>>2];if(!(c[k>>2]|0)){m=c[g>>2]|0;n=c[m>>2]|0;o=c[g>>2]|0;p=c[l>>2]|0;Hb[n&63](o,p,1)|0;q=c[l>>2]|0;i=f;return q|0}h=UB(c[(c[l>>2]|0)+12>>2]|0,8)|0;c[(c[l>>2]|0)+20>>2]=h;c[c[(c[l>>2]|0)+20>>2]>>2]=c[k>>2];m=c[g>>2]|0;n=c[m>>2]|0;o=c[g>>2]|0;p=c[l>>2]|0;Hb[n&63](o,p,1)|0;q=c[l>>2]|0;i=f;return q|0}function GC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[l>>2]=0;c[j>>2]=c[(c[g>>2]|0)+20>>2];while(1){if(!(c[j>>2]|0)){m=9;break}if((c[c[j>>2]>>2]|0)==(c[h>>2]|0)){m=9;break}do if(!(c[j>>2]|0)){c[k>>2]=UB(qC(c[f>>2]|0)|0,8)|0;c[c[k>>2]>>2]=c[h>>2];d=c[k>>2]|0;if(c[l>>2]|0){c[(c[l>>2]|0)+4>>2]=d;break}else{c[(c[g>>2]|0)+20>>2]=d;break}}while(0);c[l>>2]=c[j>>2];c[j>>2]=c[(c[j>>2]|0)+4>>2]}if((m|0)==9){i=e;return}}function HC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;b=EC(c[e>>2]|0,c[f>>2]|0)|0;c[g>>2]=b;if(!b){i=d;return}Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,c[g>>2]|0,2)|0;i=d;return}function IC(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[(c[d>>2]|0)+4>>2]|0}function JC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=c[f>>2];KC(c[g>>2]|0);VB(c[(c[g>>2]|0)+12>>2]|0,c[g>>2]|0);i=e;return}function KC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+20>>2];while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[(c[e>>2]|0)+4>>2];VB(c[(c[d>>2]|0)+12>>2]|0,c[e>>2]|0);c[e>>2]=c[f>>2]}i=b;return}function LC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[h>>2];h=c[(c[l>>2]|0)+8>>2]|0;c[m>>2]=h;c[n>>2]=h;while(1){if(!(c[m>>2]|0))break;if((c[c[m>>2]>>2]|0)==(c[j>>2]|0))break;if((a[c[j>>2]>>0]|0)==(a[c[c[m>>2]>>2]>>0]|0)?(J3(c[j>>2]|0,c[c[m>>2]>>2]|0)|0)==0:0)break;c[m>>2]=c[(c[m>>2]|0)+4>>2];if((c[m>>2]|0)==(c[n>>2]|0)){o=7;break}}if((o|0)==7)c[m>>2]=0;if(!(c[m>>2]|0)){p=c[m>>2]|0;i=f;return p|0}if(!((c[c[l>>2]>>2]|0)>>>2&1)){if((c[m>>2]|0)==(c[n>>2]|0)?(c[k>>2]|0)==((c[c[l>>2]>>2]|0)>>>2&1|0):0){p=c[m>>2]|0;i=f;return p|0}RC(c[l>>2]|0,c[m>>2]|0,c[k>>2]|0);p=c[m>>2]|0;i=f;return p|0}if(!(c[k>>2]|0)){p=c[m>>2]|0;i=f;return p|0}if((c[(c[l>>2]|0)+8>>2]|0)==(c[m>>2]|0)){p=c[m>>2]|0;i=f;return p|0}$z(1,134275,g)|0;p=c[m>>2]|0;i=f;return p|0}function MC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=c[g>>2];c[l>>2]=qC(c[m>>2]|0)|0;c[n>>2]=LC(c[m>>2]|0,c[h>>2]|0,0)|0;a:do if((c[n>>2]|0)==0&(c[j>>2]|0)>>>0>0){c[n>>2]=UB(c[l>>2]|0,c[j>>2]|0)|0;e=YC(c[l>>2]|0,c[h>>2]|0)|0;c[c[n>>2]>>2]=e;switch(c[c[m>>2]>>2]&3|0){case 0:{SC(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0);break a;break}case 1:{SC(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0);break a;break}case 2:case 3:{SC(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0);break a;break}default:{}}}while(0);if(!(c[k>>2]|0)){o=c[n>>2]|0;i=f;return o|0}LC(c[g>>2]|0,c[h>>2]|0,1)|0;o=c[n>>2]|0;i=f;return o|0}function NC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[f>>2];c[k>>2]=qC(c[h>>2]|0)|0;c[j>>2]=LC(c[h>>2]|0,c[g>>2]|0,0)|0;if(!(c[j>>2]|0)){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}TC(c[h>>2]|0,c[j>>2]|0);g=c[k>>2]|0;if((c[c[h>>2]>>2]&3)>>>0<1)UC(g,c[h>>2]|0,c[j>>2]|0);else{f=rC(g)|0;vE(f,c[h>>2]|0,57,c[j>>2]|0,0)|0}_C(c[k>>2]|0,c[c[j>>2]>>2]|0)|0;VB(c[k>>2]|0,c[j>>2]|0);c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}function OC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if((c[l>>2]|0)<0){c[r>>2]=1;c[q>>2]=0-(c[l>>2]|0)}else{c[r>>2]=0;c[q>>2]=c[l>>2]}switch(c[j>>2]|0){case 0:{MC(c[h>>2]|0,c[k>>2]|0,c[q>>2]|0,c[m>>2]|0)|0;if(!(c[r>>2]|0)){i=g;return}c[p>>2]=GD(c[h>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;OC(c[p>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0);c[p>>2]=HD(c[p>>2]|0)|0}i=g;return}case 3:case 2:case 1:{c[n>>2]=$B(c[h>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;a:do if((c[j>>2]|0)==1)MC(c[n>>2]|0,c[k>>2]|0,c[q>>2]|0,c[m>>2]|0)|0;else{c[o>>2]=OA(c[h>>2]|0,c[n>>2]|0)|0;while(1){if(!(c[o>>2]|0))break a;MC(c[o>>2]|0,c[k>>2]|0,c[q>>2]|0,c[m>>2]|0)|0;c[o>>2]=QA(c[h>>2]|0,c[o>>2]|0)|0}}while(0);c[n>>2]=aC(c[h>>2]|0,c[n>>2]|0)|0}i=g;return}default:{i=g;return}}}function PC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;switch(c[g>>2]|0){case 0:{vE(c[f>>2]|0,c[f>>2]|0,58,c[h>>2]|0,1)|0;i=e;return}case 3:case 2:case 1:{c[j>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;a:do if((c[g>>2]|0)==1)NC(c[j>>2]|0,c[h>>2]|0)|0;else{c[k>>2]=OA(c[f>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[k>>2]|0))break a;NC(c[k>>2]|0,c[h>>2]|0)|0;c[k>>2]=QA(c[f>>2]|0,c[k>>2]|0)|0}}while(0);c[j>>2]=aC(c[f>>2]|0,c[j>>2]|0)|0}i=e;return}default:{i=e;return}}}function QC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=qC(c[d>>2]|0)|0;a=c[(c[d>>2]|0)+8>>2]|0;c[f>>2]=a;if(!a){h=c[d>>2]|0;j=h+8|0;c[j>>2]=0;i=b;return}do{c[g>>2]=c[(c[f>>2]|0)+4>>2];_C(c[e>>2]|0,c[c[f>>2]>>2]|0)|0;VB(c[e>>2]|0,c[f>>2]|0);c[f>>2]=c[g>>2]}while((c[f>>2]|0)!=(c[(c[d>>2]|0)+8>>2]|0));h=c[d>>2]|0;j=h+8|0;c[j>>2]=0;i=b;return}function RC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[(c[f>>2]|0)+8>>2]=c[g>>2];d=c[f>>2]|0;c[d>>2]=c[d>>2]&-5|(c[h>>2]&1)<<2;if((c[c[f>>2]>>2]&3|0)!=3?(c[c[f>>2]>>2]&3|0)!=2:0){i=e;return}d=c[f>>2]|0;c[j>>2]=(c[c[f>>2]>>2]&3|0)==3?d+-32|0:d+32|0;c[(c[j>>2]|0)+8>>2]=c[g>>2];g=c[j>>2]|0;c[g>>2]=c[g>>2]&-5|(c[h>>2]&1)<<2;i=e;return}function SC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[e+16>>2]=a;c[f>>2]=b;c[g>>2]=d;c[j>>2]=c[g>>2];c[h>>2]=c[(c[f>>2]|0)+8>>2];do if(c[h>>2]|0)if((c[(c[h>>2]|0)+4>>2]|0)==(c[h>>2]|0)){c[(c[h>>2]|0)+4>>2]=c[j>>2];c[(c[j>>2]|0)+4>>2]=c[h>>2];break}else{c[(c[j>>2]|0)+4>>2]=c[(c[h>>2]|0)+4>>2];c[(c[h>>2]|0)+4>>2]=c[j>>2];break}else c[(c[j>>2]|0)+4>>2]=c[j>>2];while(0);if((c[c[f>>2]>>2]|0)>>>2&1){i=e;return}RC(c[f>>2]|0,c[j>>2]|0,0);i=e;return}function TC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[e>>2]|0)+8>>2];while(1){if((c[(c[g>>2]|0)+4>>2]|0)==(c[f>>2]|0))break;c[g>>2]=c[(c[g>>2]|0)+4>>2]}c[(c[g>>2]|0)+4>>2]=c[(c[f>>2]|0)+4>>2];i=d;return}function UC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[e+16>>2]=a;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[g>>2];if((c[(c[f>>2]|0)+8>>2]|0)!=(c[h>>2]|0)){i=e;return}if((c[(c[h>>2]|0)+4>>2]|0)==(c[h>>2]|0))c[j>>2]=0;else c[j>>2]=c[(c[h>>2]|0)+4>>2];RC(c[f>>2]|0,c[j>>2]|0,0);i=e;return}function VC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[e+8>>2]=a;c[f>>2]=b;c[g>>2]=d;NC(c[f>>2]|0,c[g>>2]|0)|0;i=e;return}function WC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[d>>2]|0;e=QD(a,bD(c[d>>2]|0)|0)|0;i=b;return e|0}function XC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=bD(c[e>>2]|0)|0;e=cD(b,c[f>>2]|0)|0;i=d;return e|0}function YC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=bD(c[f>>2]|0)|0;c[h>>2]=dD(c[j>>2]|0,c[g>>2]|0)|0;if(c[h>>2]|0){b=(c[h>>2]|0)+8|0;c[b>>2]=(c[b>>2]|0)+1}else{c[k>>2]=20+(N3(c[g>>2]|0)|0);if(c[f>>2]|0)c[h>>2]=UB(c[f>>2]|0,c[k>>2]|0)|0;else c[h>>2]=N4(c[k>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=1;K3((c[h>>2]|0)+16|0,c[g>>2]|0)|0;c[(c[h>>2]|0)+12>>2]=(c[h>>2]|0)+16;Hb[c[c[j>>2]>>2]&63](c[j>>2]|0,c[h>>2]|0,1)|0}c[e>>2]=c[(c[h>>2]|0)+12>>2];l=c[e>>2]|0;i=d;return l|0}function ZC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[j>>2]=bD(c[f>>2]|0)|0;c[h>>2]=dD(c[j>>2]|0,c[g>>2]|0)|0;if(c[h>>2]|0){b=(c[h>>2]|0)+8|0;c[b>>2]=(c[b>>2]|0)+1}else{c[k>>2]=20+(N3(c[g>>2]|0)|0);if(c[f>>2]|0)c[h>>2]=UB(c[f>>2]|0,c[k>>2]|0)|0;else c[h>>2]=N4(c[k>>2]|0)|0;c[(c[h>>2]|0)+8>>2]=1|c[13168];K3((c[h>>2]|0)+16|0,c[g>>2]|0)|0;c[(c[h>>2]|0)+12>>2]=(c[h>>2]|0)+16;Hb[c[c[j>>2]>>2]&63](c[j>>2]|0,c[h>>2]|0,1)|0}c[e>>2]=c[(c[h>>2]|0)+12>>2];l=c[e>>2]|0;i=d;return l|0}function _C(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}c[j>>2]=bD(c[f>>2]|0)|0;c[h>>2]=dD(c[j>>2]|0,c[g>>2]|0)|0;if(((c[h>>2]|0)!=0?(c[(c[h>>2]|0)+12>>2]|0)==(c[g>>2]|0):0)?(g=(c[h>>2]|0)+8|0,c[g>>2]=(c[g>>2]|0)+-1,(((c[(c[h>>2]|0)+8>>2]|0)!=0?(c[13169]|0)!=0:0)&1|0)==0):0)PD(c[f>>2]|0,c[j>>2]|0,c[h>>2]|0)|0;if(!(c[h>>2]|0)){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}else{c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function $C(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[f>>2]=(c[e>>2]|0)+(0-16);c[d>>2]=c[(c[f>>2]|0)+8>>2]&c[13168];g=c[d>>2]|0;i=b;return g|0}return 0}function aD(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[e>>2]=(c[d>>2]|0)+(0-16);d=(c[e>>2]|0)+8|0;c[d>>2]=c[d>>2]|c[13168];i=b;return}function bD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(c[d>>2]|0)c[e>>2]=(c[(c[d>>2]|0)+52>>2]|0)+20;else c[e>>2]=52680;if(c[c[e>>2]>>2]|0){f=c[e>>2]|0;g=c[f>>2]|0;i=b;return g|0}a=OD(c[d>>2]|0,52684,c[12993]|0)|0;c[c[e>>2]>>2]=a;c[13168]=-2147483648;c[13169]=~c[13168];f=c[e>>2]|0;g=c[f>>2]|0;i=b;return g|0}function cD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=dD(c[f>>2]|0,c[g>>2]|0)|0;if(c[h>>2]|0){c[e>>2]=c[(c[h>>2]|0)+12>>2];j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function dD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g+12>>2]=c[f>>2];c[h>>2]=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,4)|0;i=d;return c[h>>2]|0}function eD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[13184]=c[d>>2];i=b;return}function fD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[13186]=c[e>>2];c[13187]=c[f>>2];c[13188]=0;i=d;return}function gD(){var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+32|0;m=e+8|0;n=e+4|0;o=e;if(!(c[13189]|0)){c[13189]=1;if(!(c[13190]|0))c[13190]=1;if(!(c[13180]|0))c[13180]=c[24743];if(!(c[13181]|0))c[13181]=c[24744];if(!((c[13191]|0)!=0?(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)!=0:0)){qD();p=hD(c[13180]|0,16384)|0;c[(c[13191]|0)+(c[13192]<<2)>>2]=p}rD()}a:while(1){c[h>>2]=c[13193];a[c[h>>2]>>0]=a[134308]|0;c[j>>2]=c[h>>2];c[g>>2]=c[13190];c[g>>2]=(c[g>>2]|0)+(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]|0);b:while(1){a[l>>0]=c[52776+(d[c[h>>2]>>0]<<2)>>2];if(b[101984+(c[g>>2]<<1)>>1]|0){c[13450]=c[g>>2];c[13451]=c[h>>2]}while(1){q=c[g>>2]|0;if((b[102380+((b[102170+(c[g>>2]<<1)>>1]|0)+(d[l>>0]|0)<<1)>>1]|0)==(c[g>>2]|0))break;c[g>>2]=b[102938+(q<<1)>>1];if((c[g>>2]|0)<93)continue;a[l>>0]=c[53808+(d[l>>0]<<2)>>2]}c[g>>2]=b[103148+((b[102170+(q<<1)>>1]|0)+(d[l>>0]|0)<<1)>>1];c[h>>2]=(c[h>>2]|0)+1;if((b[102170+(c[g>>2]<<1)>>1]|0)!=230)continue;c:while(1){c[k>>2]=b[101984+(c[g>>2]<<1)>>1];if(!(c[k>>2]|0)){c[h>>2]=c[13451];c[g>>2]=c[13450];c[k>>2]=b[101984+(c[g>>2]<<1)>>1]}c[13182]=c[j>>2];c[13183]=(c[h>>2]|0)-(c[j>>2]|0);a[134308]=a[c[h>>2]>>0]|0;a[c[h>>2]>>0]=0;c[13193]=c[h>>2];d:while(1){switch(c[k>>2]|0){case 1:{r=24;break a;break}case 12:{r=51;break a;break}case 13:{r=54;break a;break}case 14:{r=57;break a;break}case 15:{r=62;break a;break}case 16:{r=67;break a;break}case 17:{r=70;break a;break}case 18:{r=73;break a;break}case 19:{r=78;break a;break}case 20:{r=83;break a;break}case 21:{r=86;break a;break}case 23:{r=94;break a;break}case 33:{r=126;break a;break}case 39:case 38:case 37:case 36:{r=132;break a;break}case 2:{r=27;break b;break}case 3:{r=30;break b;break}case 4:{r=33;break b;break}case 5:{r=35;break b;break}case 6:{r=37;break b;break}case 7:{r=40;break b;break}case 8:{r=42;break b;break}case 9:{r=45;break b;break}case 10:{r=47;break b;break}case 11:{r=49;break b;break}case 22:{r=91;break b;break}case 24:{r=97;break b;break}case 25:{r=100;break b;break}case 26:{r=103;break b;break}case 27:{r=106;break b;break}case 28:{r=109;break b;break}case 29:{r=112;break b;break}case 30:{r=117;break b;break}case 31:{r=120;break b;break}case 32:{r=123;break b;break}case 34:{r=129;break b;break}case 0:{r=23;break d;break}case 35:break;default:{r=146;break b}}c[n>>2]=(c[h>>2]|0)-(c[13182]|0)-1;a[c[h>>2]>>0]=a[134308]|0;if(!(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+44>>2]|0)){c[13502]=c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+16>>2];c[c[(c[13191]|0)+(c[13192]<<2)>>2]>>2]=c[13180];c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+44>>2]=1}if((c[13193]|0)>>>0<=((c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+(c[13502]|0)|0)>>>0){r=136;break}switch(AD()|0){case 0:{r=144;break c;break}case 2:{r=145;break d;break}case 1:break;default:continue a}c[13503]=0;if(!(iD()|0)){r=142;break b}c[13193]=c[13182];c[k>>2]=35+(((c[13190]|0)-1|0)/2|0)+1}if((r|0)==23){r=0;a[c[h>>2]>>0]=a[134308]|0;c[h>>2]=c[13451];c[g>>2]=c[13450];continue}else if((r|0)==136){r=0;c[13193]=(c[13182]|0)+(c[n>>2]|0);c[g>>2]=yD()|0;c[o>>2]=zD(c[g>>2]|0)|0;c[j>>2]=c[13182];s=c[13193]|0;if(c[o>>2]|0){r=137;break}c[h>>2]=s;continue}else if((r|0)==145){r=0;c[13193]=(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+(c[13502]|0);c[g>>2]=yD()|0;c[h>>2]=c[13193];c[j>>2]=c[13182];continue}}if((r|0)==137){r=0;p=s+1|0;c[13193]=p;c[h>>2]=p;c[g>>2]=c[o>>2];continue}else if((r|0)==144){r=0;c[13193]=(c[13182]|0)+(c[n>>2]|0);c[g>>2]=yD()|0;c[h>>2]=c[13193];c[j>>2]=c[13182];continue}}switch(r|0){case 27:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13184]=(c[13184]|0)+1;continue a;break}case 30:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13190]=3;continue a;break}case 33:{r=0;if((c[13183]|0)>>>0<=0)continue a;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;continue a;break}case 35:{r=0;if((c[13183]|0)>>>0<=0)continue a;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;continue a;break}case 37:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13190]=1;continue a;break}case 40:{r=0;if((c[13183]|0)>>>0<=0)continue a;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;continue a;break}case 42:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;sD();continue a;break}case 45:{r=0;if((c[13183]|0)>>>0<=0)continue a;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;continue a;break}case 47:{r=0;if((c[13183]|0)>>>0<=0)continue a;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;continue a;break}case 49:{r=0;if((c[13183]|0)>>>0<=0)continue a;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;continue a;break}case 91:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13190]=5;uD();continue a;break}case 97:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;wD(136329);continue a;break}case 100:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;wD(134309);continue a;break}case 103:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13184]=(c[13184]|0)+1;continue a;break}case 106:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;wD(c[13182]|0);continue a;break}case 109:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13190]=7;c[13501]=1;uD();continue a;break}case 112:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13501]=(c[13501]|0)+-1;if(!(c[13501]|0)){r=116;break a}wD(c[13182]|0);continue a;break}case 117:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13501]=(c[13501]|0)+1;wD(c[13182]|0);continue a;break}case 120:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;wD(c[13182]|0);c[13184]=(c[13184]|0)+1;continue a;break}case 123:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;wD(c[13182]|0);continue a;break}case 129:{r=0;if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;h3(c[13182]|0,c[13183]|0,1,c[13181]|0)|0;continue a;break}case 142:{r=0;if(c[13503]|0)continue a;jD(c[13180]|0);continue a;break}case 146:{r=0;BD(134312);continue a;break}}}switch(r|0){case 24:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[f>>2]=-1;t=c[f>>2]|0;i=e;return t|0}case 51:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[f>>2]=259;t=c[f>>2]|0;i=e;return t|0}case 54:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[f>>2]=260;t=c[f>>2]|0;i=e;return t|0}case 57:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;if(!(c[13188]|0))c[13188]=258;c[f>>2]=258;t=c[f>>2]|0;i=e;return t|0}case 62:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;if(!(c[13188]|0))c[13188]=261;c[f>>2]=261;t=c[f>>2]|0;i=e;return t|0}case 67:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[f>>2]=263;t=c[f>>2]|0;i=e;return t|0}case 70:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[f>>2]=262;t=c[f>>2]|0;i=e;return t|0}case 73:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;if((c[13188]|0)==261){c[f>>2]=264;t=c[f>>2]|0;i=e;return t|0}else{c[f>>2]=45;t=c[f>>2]|0;i=e;return t|0}break}case 78:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;if((c[13188]|0)==258){c[f>>2]=264;t=c[f>>2]|0;i=e;return t|0}else{c[f>>2]=45;t=c[f>>2]|0;i=e;return t|0}break}case 83:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13526]=YC(c[13072]|0,c[13182]|0)|0;c[f>>2]=267;t=c[f>>2]|0;i=e;return t|0}case 86:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;if(tD()|0){c[m>>2]=(c[13183]|0)-1;a[c[h>>2]>>0]=a[134308]|0;r=(c[j>>2]|0)+(c[m>>2]|0)|0;c[h>>2]=r;c[13193]=r;c[13182]=c[j>>2];c[13183]=(c[h>>2]|0)-(c[j>>2]|0);a[134308]=a[c[h>>2]>>0]|0;a[c[h>>2]>>0]=0;c[13193]=c[h>>2]}c[13526]=YC(c[13072]|0,c[13182]|0)|0;c[f>>2]=267;t=c[f>>2]|0;i=e;return t|0}case 94:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[13190]=1;vD();c[f>>2]=268;t=c[f>>2]|0;i=e;return t|0}case 116:{c[13190]=1;xD();c[f>>2]=268;t=c[f>>2]|0;i=e;return t|0}case 126:{if((c[13183]|0)>>>0>0)c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]=(a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0)==10&1;c[f>>2]=a[c[13182]>>0];t=c[f>>2]|0;i=e;return t|0}case 132:{c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}}return 0}function hD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=kD(48)|0;if(!(c[g>>2]|0))BD(134363);c[(c[g>>2]|0)+12>>2]=c[f>>2];f=kD((c[(c[g>>2]|0)+12>>2]|0)+2|0)|0;c[(c[g>>2]|0)+4>>2]=f;if(!(c[(c[g>>2]|0)+4>>2]|0))BD(134363);c[(c[g>>2]|0)+20>>2]=1;CD(c[g>>2]|0,c[e>>2]|0);i=d;return c[g>>2]|0}function iD(){return 1}function jD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!((c[13191]|0)!=0?(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)!=0:0)){qD();a=hD(c[13180]|0,16384)|0;c[(c[13191]|0)+(c[13192]<<2)>>2]=a}if(!(c[13191]|0)){e=0;f=c[d>>2]|0;CD(e,f);rD();i=b;return}e=c[(c[13191]|0)+(c[13192]<<2)>>2]|0;f=c[d>>2]|0;CD(e,f);rD();i=b;return}function kD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=N4(c[d>>2]|0)|0;i=b;return a|0}function lD(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if(!(c[e>>2]|0)){i=d;return}c[(c[e>>2]|0)+16>>2]=0;a[c[(c[e>>2]|0)+4>>2]>>0]=0;a[(c[(c[e>>2]|0)+4>>2]|0)+1>>0]=0;c[(c[e>>2]|0)+8>>2]=c[(c[e>>2]|0)+4>>2];c[(c[e>>2]|0)+28>>2]=1;c[(c[e>>2]|0)+44>>2]=0;if(c[13191]|0)f=c[(c[13191]|0)+(c[13192]<<2)>>2]|0;else f=0;if((c[e>>2]|0)!=(f|0)){i=d;return}rD();i=d;return}function mD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Q4(c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function nD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+2096|0;e=d;f=d+32|0;g=d+40|0;h=d+16|0;c[f>>2]=b;dA(h,1024,d+1064|0);if(c[13185]|0){gA(h,c[13185]|0)|0;gA(h,134408)|0}gA(h,c[f>>2]|0)|0;c[e>>2]=c[13184];k3(g,134411,e)|0;gA(h,g)|0;gA(h,c[13182]|0)|0;gA(h,134430)|0;if((c[h+4>>2]|0)>>>0>=(c[h+8>>2]|0)>>>0)eA(h,1)|0;g=h+4|0;e=c[g>>2]|0;c[g>>2]=e+1;a[e>>0]=0;e=c[h>>2]|0;c[h+4>>2]=e;$z(1,e,d+8|0)|0;hA(h);i=d;return}function oD(){DD(64,c[13182]|0);return}function pD(){var a=0;if(!(c[13191]|0)){a=0;lD(a);return}a=c[(c[13191]|0)+(c[13192]<<2)>>2]|0;lD(a);return}function qD(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;if(!(c[13191]|0)){c[b>>2]=1;c[13191]=kD(c[b>>2]<<2)|0;if(!(c[13191]|0))BD(134753);$4(c[13191]|0,0,c[b>>2]<<2|0)|0;c[13504]=c[b>>2];c[13192]=0;i=a;return}if((c[13192]|0)>>>0<((c[13504]|0)-1|0)>>>0){i=a;return}c[d>>2]=8;c[b>>2]=(c[13504]|0)+(c[d>>2]|0);c[13191]=mD(c[13191]|0,c[b>>2]<<2)|0;if(!(c[13191]|0))BD(134753);$4((c[13191]|0)+(c[13504]<<2)|0,0,c[d>>2]<<2|0)|0;c[13504]=c[b>>2];i=a;return}function rD(){var b=0;c[13502]=c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+16>>2];b=c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+8>>2]|0;c[13193]=b;c[13182]=b;c[13180]=c[c[(c[13191]|0)+(c[13192]<<2)>>2]>>2];a[134308]=a[c[13193]>>0]|0;return}function sD(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+48|0;d=b;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;c[h>>2]=(c[13182]|0)+1;if(!(P3(c[h>>2]|0,134737,4)|0))c[h>>2]=(c[h>>2]|0)+4;l=c[h>>2]|0;c[d>>2]=g;c[d+4>>2]=b+36;c[d+8>>2]=f;c[e>>2]=l3(l,134742,d)|0;if((c[e>>2]|0)<=0){i=b;return}c[13184]=(c[g>>2]|0)-1;if((c[e>>2]|0)<=1){i=b;return}c[j>>2]=(c[h>>2]|0)+(c[f>>2]|0);c[k>>2]=c[j>>2];while(1){if(a[c[k>>2]>>0]|0)m=(a[c[k>>2]>>0]|0)!=34;else m=0;n=c[k>>2]|0;if(!m)break;c[k>>2]=n+1}if((n|0)==(c[j>>2]|0)){i=b;return}a[c[k>>2]>>0]=0;ED(c[j>>2]|0,(c[k>>2]|0)-(c[j>>2]|0)|0);i=b;return}function tD(){var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+2096|0;e=b+8|0;f=b;g=b+32|0;h=b+2088|0;j=b+1064|0;k=b+40|0;l=b+16|0;m=b+12|0;a[h>>0]=a[(c[13182]|0)+((c[13183]|0)-1)>>0]|0;if((p1(d[h>>0]|0)|0)==0?(d[h>>0]|0|0)!=46:0){if(c[13185]|0)c[m>>2]=c[13185];else c[m>>2]=134645;dA(l,1024,j);gA(l,134651)|0;gA(l,c[13182]|0)|0;c[f>>2]=c[13184];k3(k,134695,f)|0;gA(l,k)|0;gA(l,c[m>>2]|0)|0;gA(l,134712)|0;if((c[l+4>>2]|0)>>>0>=(c[l+8>>2]|0)>>>0)eA(l,1)|0;m=l+4|0;k=c[m>>2]|0;c[m>>2]=k+1;a[k>>0]=0;k=c[l>>2]|0;c[l+4>>2]=k;$z(0,k,e)|0;hA(l);c[g>>2]=1;n=c[g>>2]|0;i=b;return n|0}c[g>>2]=0;n=c[g>>2]|0;i=b;return n|0}function uD(){if(!(c[13505]|0)){c[13505]=N4(1024)|0;c[13507]=(c[13505]|0)+1024}c[13506]=c[13505];a[c[13506]>>0]=0;return}function vD(){c[13526]=YC(c[13072]|0,c[13505]|0)|0;return}function wD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+12|0;g=d+4|0;h=d;c[e>>2]=b;if((c[13506]|0)>>>0>(c[13505]|0)>>>0)c[13506]=(c[13506]|0)+-1;while(1){b=c[e>>2]|0;c[e>>2]=b+1;j=a[b>>0]|0;b=c[13506]|0;c[13506]=b+1;a[b>>0]=j;a[f>>0]=j;if((a[f>>0]|0)!=0?(c[13506]|0)>>>0<(c[13507]|0)>>>0:0)continue;if(a[f>>0]|0){c[g>>2]=(c[13507]|0)-(c[13505]|0);c[h>>2]=(c[13506]|0)-(c[13505]|0);c[g>>2]=c[g>>2]<<1;c[13505]=Q4(c[13505]|0,c[g>>2]|0)|0;c[13507]=(c[13505]|0)+(c[g>>2]|0);c[13506]=(c[13505]|0)+(c[h>>2]|0)}if(!(a[f>>0]|0))break}i=d;return}function xD(){c[13526]=ZC(c[13072]|0,c[13505]|0)|0;return}function yD(){var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;h=e+8|0;c[f>>2]=c[13190];c[f>>2]=(c[f>>2]|0)+(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+28>>2]|0);c[g>>2]=c[13182];while(1){if((c[g>>2]|0)>>>0>=(c[13193]|0)>>>0)break;if(a[c[g>>2]>>0]|0)j=c[52776+(d[c[g>>2]>>0]<<2)>>2]|0;else j=1;a[h>>0]=j;if(b[101984+(c[f>>2]<<1)>>1]|0){c[13450]=c[f>>2];c[13451]=c[g>>2]}while(1){k=c[f>>2]|0;if((b[102380+((b[102170+(c[f>>2]<<1)>>1]|0)+(d[h>>0]|0)<<1)>>1]|0)==(c[f>>2]|0))break;c[f>>2]=b[102938+(k<<1)>>1];if((c[f>>2]|0)<93)continue;a[h>>0]=c[53808+(d[h>>0]<<2)>>2]}c[f>>2]=b[103148+((b[102170+(k<<1)>>1]|0)+(d[h>>0]|0)<<1)>>1];c[g>>2]=(c[g>>2]|0)+1}i=e;return c[f>>2]|0}function zD(e){e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;k=f+12|0;c[g>>2]=e;c[j>>2]=c[13193];a[k>>0]=1;if(b[101984+(c[g>>2]<<1)>>1]|0){c[13450]=c[g>>2];c[13451]=c[j>>2]}while(1){l=c[g>>2]|0;if((b[102380+((b[102170+(c[g>>2]<<1)>>1]|0)+(d[k>>0]|0)<<1)>>1]|0)==(c[g>>2]|0))break;c[g>>2]=b[102938+(l<<1)>>1];if((c[g>>2]|0)<93)continue;a[k>>0]=c[53808+(d[k>>0]<<2)>>2]}c[g>>2]=b[103148+((b[102170+(l<<1)>>1]|0)+(d[k>>0]|0)<<1)>>1];c[h>>2]=(c[g>>2]|0)==92&1;i=f;return ((c[h>>2]|0)!=0?0:c[g>>2]|0)|0}function AD(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+48|0;d=b+40|0;e=b+36|0;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;o=b;c[e>>2]=c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2];c[f>>2]=c[13182];if((c[13193]|0)>>>0>((c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+((c[13502]|0)+1)|0)>>>0)BD(134469);p=(c[13193]|0)-(c[13182]|0)|0;if(!(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+40>>2]|0))if((p-0|0)==1){c[d>>2]=1;q=c[d>>2]|0;i=b;return q|0}else{c[d>>2]=2;q=c[d>>2]|0;i=b;return q|0}c[g>>2]=p-1;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[g>>2]|0))break;p=c[f>>2]|0;c[f>>2]=p+1;r=a[p>>0]|0;p=c[e>>2]|0;c[e>>2]=p+1;a[p>>0]=r;c[h>>2]=(c[h>>2]|0)+1}if((c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+44>>2]|0)==2){c[13502]=0;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+16>>2]=0}else{c[k>>2]=(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+12>>2]|0)-(c[g>>2]|0)-1;while(1){if((c[k>>2]|0)>>>0>0)break;c[l>>2]=c[(c[13191]|0)+(c[13192]<<2)>>2];c[m>>2]=(c[13193]|0)-(c[(c[l>>2]|0)+4>>2]|0);h=c[l>>2]|0;if(c[(c[l>>2]|0)+20>>2]|0){c[n>>2]=c[h+12>>2]<<1;e=(c[l>>2]|0)+12|0;f=c[e>>2]|0;if((c[n>>2]|0)>>>0<=0){r=(c[l>>2]|0)+12|0;c[r>>2]=(c[r>>2]|0)+((f>>>0)/8|0)}else c[e>>2]=f<<1;f=mD(c[(c[l>>2]|0)+4>>2]|0,(c[(c[l>>2]|0)+12>>2]|0)+2|0)|0;c[(c[l>>2]|0)+4>>2]=f}else c[h+4>>2]=0;if(!(c[(c[l>>2]|0)+4>>2]|0))BD(134525);c[13193]=(c[(c[l>>2]|0)+4>>2]|0)+(c[m>>2]|0);c[k>>2]=(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+12>>2]|0)-(c[g>>2]|0)-1}if((c[k>>2]|0)>>>0>8192)c[k>>2]=8192;m=Hb[c[c[(c[13186]|0)+8>>2]>>2]&63](c[13187]|0,(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+(c[g>>2]|0)|0,c[k>>2]|0)|0;c[13502]=m;if(m>>>0<0)BD(134569);c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+16>>2]=c[13502]}do if(!(c[13502]|0))if(!(c[g>>2]|0)){c[j>>2]=1;jD(c[13180]|0);break}else{c[j>>2]=2;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+44>>2]=2;break}else c[j>>2]=0;while(0);if(((c[13502]|0)+(c[g>>2]|0)|0)>>>0>(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+12>>2]|0)>>>0?(c[o>>2]=(c[13502]|0)+(c[g>>2]|0)+((c[13502]|0)>>>1),m=mD(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0,c[o>>2]|0)|0,c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]=m,(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)==0):0)BD(134598);c[13502]=(c[13502]|0)+(c[g>>2]|0);a[(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+(c[13502]|0)>>0]=0;a[(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+((c[13502]|0)+1)>>0]=0;c[13182]=c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2];c[d>>2]=c[j>>2];q=c[d>>2]|0;i=b;return q|0}function BD(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[24742]|0;c[d>>2]=c[e>>2];Y2(a,134465,d)|0;wb(2)}function CD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(L1()|0)>>2];lD(c[e>>2]|0);c[c[e>>2]>>2]=c[f>>2];c[(c[e>>2]|0)+40>>2]=1;if(c[13191]|0)h=c[(c[13191]|0)+(c[13192]<<2)>>2]|0;else h=0;if((c[e>>2]|0)!=(h|0)){c[(c[e>>2]|0)+32>>2]=1;c[(c[e>>2]|0)+36>>2]=0}c[(c[e>>2]|0)+24>>2]=(c[f>>2]|0)!=0?0:0;f=c[g>>2]|0;c[(L1()|0)>>2]=f;i=d;return}function DD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[13193];a[c[h>>2]>>0]=a[134308]|0;if((c[h>>2]|0)>>>0<((c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+2|0)>>>0){c[j>>2]=(c[13502]|0)+2;c[k>>2]=(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+((c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+12>>2]|0)+2);c[l>>2]=(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+(c[j>>2]|0);while(1){if((c[l>>2]|0)>>>0<=(c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)>>>0)break;j=(c[l>>2]|0)+-1|0;c[l>>2]=j;d=a[j>>0]|0;j=(c[k>>2]|0)+-1|0;c[k>>2]=j;a[j>>0]=d}c[h>>2]=(c[h>>2]|0)+((c[k>>2]|0)-(c[l>>2]|0));c[g>>2]=(c[g>>2]|0)+((c[k>>2]|0)-(c[l>>2]|0));l=c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+12>>2]|0;c[13502]=l;c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+16>>2]=l;if((c[h>>2]|0)>>>0<((c[(c[(c[13191]|0)+(c[13192]<<2)>>2]|0)+4>>2]|0)+2|0)>>>0)BD(134433)}l=c[f>>2]&255;f=(c[h>>2]|0)+-1|0;c[h>>2]=f;a[f>>0]=l;c[13182]=c[g>>2];a[134308]=a[c[h>>2]>>0]|0;c[13193]=c[h>>2];i=e;return}function ED(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[f>>2]|0)>(c[13508]|0)){if(c[13508]|0)c[13509]=Q4(c[13509]|0,(c[f>>2]|0)+1|0)|0;else c[13509]=N4((c[f>>2]|0)+1|0)|0;c[13508]=c[f>>2]}K3(c[13509]|0,c[e>>2]|0)|0;c[13185]=c[13509];i=d;return}function FD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(((c[h>>2]|0)!=0?(tB(c[g>>2]|0,0,c[h>>2]|0,k,0)|0)!=0:0)?(d=KD(c[g>>2]|0,c[k>>2]|0)|0,c[l>>2]=d,(d|0)!=0):0){c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}if((c[j>>2]|0)!=0?(tB(c[g>>2]|0,0,c[h>>2]|0,k,1)|0)!=0:0){c[l>>2]=LD(c[g>>2]|0,c[k>>2]|0)|0;xB(c[g>>2]|0,0,c[l>>2]|0);c[f>>2]=c[l>>2];m=c[f>>2]|0;i=e;return m|0}c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}function GD(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=Hb[c[c[(c[d>>2]|0)+40>>2]>>2]&63](c[(c[d>>2]|0)+40>>2]|0,0,128)|0;i=b;return a|0}function HD(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=ID(c[d>>2]|0)|0;if(!(c[e>>2]|0)){f=0;i=b;return f|0}f=Hb[c[c[(c[e>>2]|0)+40>>2]>>2]&63](c[(c[e>>2]|0)+40>>2]|0,c[d>>2]|0,8)|0;i=b;return f|0}function ID(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[(c[d>>2]|0)+44>>2]|0}function JD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Hb[c[c[(c[e>>2]|0)+40>>2]>>2]&63](c[(c[e>>2]|0)+40>>2]|0,c[f>>2]|0,2)|0;i=d;return b|0}function KD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+64|0;e=d+60|0;f=d+56|0;g=d;c[e>>2]=a;c[f>>2]=b;RD(c[e>>2]|0,c[(c[e>>2]|0)+40>>2]|0,52224);c[g+4>>2]=c[f>>2];f=Hb[c[c[(c[e>>2]|0)+40>>2]>>2]&63](c[(c[e>>2]|0)+40>>2]|0,g,4)|0;i=d;return f|0}function LD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=KD(c[g>>2]|0,c[h>>2]|0)|0;if(c[j>>2]|0){c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}else{c[j>>2]=UB(c[g>>2]|0,56)|0;c[(c[j>>2]|0)+52>>2]=c[(c[g>>2]|0)+52>>2];c[(c[j>>2]|0)+12>>2]=c[(c[g>>2]|0)+12>>2];d=(c[j>>2]|0)+12|0;a[d>>0]=a[d>>0]&-9;c[(c[j>>2]|0)+44>>2]=c[g>>2];c[(c[j>>2]|0)+48>>2]=c[(c[g>>2]|0)+48>>2];c[(c[j>>2]|0)+4>>2]=c[h>>2];c[f>>2]=hB(c[j>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}return 0}function MD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;h=f+12|0;j=f+8|0;k=f;c[f+16>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f+4>>2]=e;c[k>>2]=c[13510];e=(c[h>>2]|0)!=0;do if(c[k>>2]|0){d=c[k>>2]|0;if(e){VB(d,c[h>>2]|0);break}c[g>>2]=UB(d,c[j>>2]|0)|0;l=c[g>>2]|0;i=f;return l|0}else{if(e){O4(c[h>>2]|0);break}c[g>>2]=N4(c[j>>2]|0)|0;l=c[g>>2]|0;i=f;return l|0}while(0);c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}function ND(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=c[13510];if(c[g>>2]|0){VB(c[g>>2]|0,c[f>>2]|0);i=e;return}else{O4(c[f>>2]|0);i=e;return}}function OD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[(c[g>>2]|0)+28>>2];c[(c[g>>2]|0)+28>>2]=7;c[13510]=c[f>>2];c[k>>2]=Nz(c[g>>2]|0,c[h>>2]|0)|0;c[(c[g>>2]|0)+28>>2]=c[j>>2];c[13510]=0;i=e;return c[k>>2]|0}function PD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[13510]=c[f>>2];f=Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,c[h>>2]|0,2)|0;i=e;return f|0}function QD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=Vz(c[g>>2]|0,0,0)|0;c[h>>2]=c[(c[j>>2]|0)+28>>2];c[(c[j>>2]|0)+28>>2]=7;c[13510]=c[f>>2];if(Jz(c[g>>2]|0)|0){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}else{c[(c[j>>2]|0)+28>>2]=c[h>>2];c[13510]=0;c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function RD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[e+8>>2]=a;c[f>>2]=b;c[g>>2]=d;if(!(c[g>>2]|0)){i=e;return}d=Vz(c[f>>2]|0,0,0)|0;if((d|0)==(c[g>>2]|0)){i=e;return}Vz(c[f>>2]|0,c[g>>2]|0,0)|0;i=e;return}function SD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=($C(c[f>>2]|0)|0)!=0;a=c[f>>2]|0;f=c[g>>2]|0;if(b){c[e>>2]=WD(a,f)|0;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=XD(a,f)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function TD(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[d>>2]|0;e=SD(a,YD(c[d>>2]|0)|0)|0;i=b;return e|0}function UD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[h>>2]|0)){j=7;break}if((ZD(c[h>>2]|0)|0)==0?(eC(c[h>>2]|0,c[g>>2]|0,0)|0)!=0:0){j=5;break}c[h>>2]=HD(c[h>>2]|0)|0}if((j|0)==5){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}else if((j|0)==7){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function VD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[13511]=0;d=yA(c[g>>2]|0,134803)|0;c[j>>2]=d;if(((d|0)!=0?(p1(a[c[j>>2]>>0]|0)|0)!=0:0)?(c[k>>2]=z3(c[j>>2]|0,0,10)|0,(c[k>>2]|0)==0|(c[k>>2]|0)>=60):0)c[13512]=c[k>>2];_D(c[g>>2]|0,1,0);if(($D(c[g>>2]|0,c[h>>2]|0,1)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if((aE(c[g>>2]|0,c[h>>2]|0)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if((bE(c[g>>2]|0,c[h>>2]|0)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[13512]=128;c[f>>2]=Fb[c[(c[(c[(c[g>>2]|0)+52>>2]|0)+8>>2]|0)+8>>2]&63](c[h>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}return 0}function WD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[f>>2];c[j>>2]=c[g>>2];f=c[j>>2]|0;c[j>>2]=f+1;a[f>>0]=60;while(1){if(!(a[c[h>>2]>>0]|0))break;f=c[h>>2]|0;c[h>>2]=f+1;d=a[f>>0]|0;f=c[j>>2]|0;c[j>>2]=f+1;a[f>>0]=d}h=c[j>>2]|0;c[j>>2]=h+1;a[h>>0]=62;a[c[j>>2]>>0]=0;i=e;return c[g>>2]|0}function XD(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+48|0;g=f+40|0;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+44|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[h>>2]=b;c[j>>2]=e;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;c[r>>2]=0;if((c[h>>2]|0)!=0?(a[c[h>>2]>>0]|0)!=0:0){c[k>>2]=c[h>>2];c[l>>2]=c[j>>2];e=c[l>>2]|0;c[l>>2]=e+1;a[e>>0]=34;e=c[k>>2]|0;c[k>>2]=e+1;a[m>>0]=a[e>>0]|0;if((p1(d[m>>0]|0)|0)==0?(d[m>>0]|0)!=46:0)t=(d[m>>0]|0)==45;else t=1;c[q>>2]=t&1;a:while(1){if(!(a[m>>0]|0))break;do if((d[m>>0]|0)!=34){t=d[m>>0]|0;if(!(c[q>>2]|0)){if(l1(t)|0)break;if((d[m>>0]|0)==95)break;if(!(n1(d[m>>0]|0)|0))break;c[p>>2]=1;break}if((t|0)==45){if(!(c[n>>2]|0))break;c[q>>2]=0;c[p>>2]=1;break}if((d[m>>0]|0)==46){t=c[o>>2]|0;c[o>>2]=t+1;if(!t)break;c[q>>2]=0;c[p>>2]=1;break}else{if(p1(d[m>>0]|0)|0)break;c[q>>2]=0;c[p>>2]=1;break}}else{t=c[l>>2]|0;c[l>>2]=t+1;a[t>>0]=92;c[p>>2]=1}while(0);t=a[m>>0]|0;e=c[l>>2]|0;c[l>>2]=e+1;a[e>>0]=t;t=c[k>>2]|0;c[k>>2]=t+1;a[m>>0]=a[t>>0]|0;c[n>>2]=(c[n>>2]|0)+1;if(!(c[13512]|0))continue;do if((((((d[m>>0]|0)!=0&(c[r>>2]|0)!=0?(l1(a[(c[l>>2]|0)+-1>>0]|0)|0)==0:0)?(a[(c[l>>2]|0)+-1>>0]|0)!=46:0)?(a[(c[l>>2]|0)+-1>>0]|0)!=45:0)?(n1(a[(c[l>>2]|0)+-1>>0]|0)|0)!=0:0)?(a[(c[l>>2]|0)+-1>>0]|0)!=92:0){if((((l1(d[m>>0]|0)|0)==0?(d[m>>0]|0)!=46:0)?(d[m>>0]|0)!=45:0)?(n1(d[m>>0]|0)|0)!=0:0)break;t=c[l>>2]|0;c[l>>2]=t+1;a[t>>0]=92;t=c[l>>2]|0;c[l>>2]=t+1;a[t>>0]=10;c[p>>2]=1;c[r>>2]=0;c[n>>2]=0;continue a}while(0);if(!(d[m>>0]|0))continue;if((c[n>>2]|0)<(c[13512]|0))continue;b:do if(((((l1(a[(c[l>>2]|0)+-1>>0]|0)|0)==0?(a[(c[l>>2]|0)+-1>>0]|0)!=46:0)?(a[(c[l>>2]|0)+-1>>0]|0)!=45:0)?(n1(a[(c[l>>2]|0)+-1>>0]|0)|0)!=0:0)?(a[(c[l>>2]|0)+-1>>0]|0)!=92:0){do if((l1(d[m>>0]|0)|0)==0?(d[m>>0]|0)!=46:0){if((d[m>>0]|0)==45)break;if(n1(d[m>>0]|0)|0)break b}while(0);t=c[l>>2]|0;c[l>>2]=t+1;a[t>>0]=92;t=c[l>>2]|0;c[l>>2]=t+1;a[t>>0]=10;c[p>>2]=1;c[n>>2]=0;continue a}while(0);c[r>>2]=1}r=c[l>>2]|0;c[l>>2]=r+1;a[r>>0]=34;a[c[l>>2]>>0]=0;do if(!(c[p>>2]|0)){if((c[n>>2]|0)==1){if((a[c[h>>2]>>0]|0)==46)break;if((a[c[h>>2]>>0]|0)==45)break}c[s>>2]=54068;while(1){if(!(c[c[s>>2]>>2]|0)){u=59;break}if(!(F3(c[c[s>>2]>>2]|0,c[h>>2]|0)|0)){u=57;break}c[s>>2]=(c[s>>2]|0)+4}if((u|0)==57){c[g>>2]=c[j>>2];v=c[g>>2]|0;i=f;return v|0}else if((u|0)==59){c[g>>2]=c[h>>2];v=c[g>>2]|0;i=f;return v|0}}while(0);c[g>>2]=c[j>>2];v=c[g>>2]|0;i=f;return v|0}c[g>>2]=134866;v=c[g>>2]|0;i=f;return v|0}function YD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if((((N3(c[d>>2]|0)|0)<<1)+2|0)>>>0>1024)f=((N3(c[d>>2]|0)|0)<<1)+2|0;else f=1024;c[e>>2]=f;if((c[e>>2]|0)<=(c[13515]|0)){g=c[13516]|0;i=b;return g|0}if(c[13516]|0)c[13516]=Q4(c[13516]|0,c[e>>2]|0)|0;else c[13516]=N4(c[e>>2]|0)|0;c[13515]=c[e>>2];g=c[13516]|0;i=b;return g|0}function ZD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=b;c[n>>2]=wB(c[f>>2]|0)|0;if((c[n>>2]|0)!=0?(a[c[n>>2]>>0]|0)!=37:0){c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}n=pA(c[f>>2]|0)|0;c[j>>2]=n;a:do if((n|0)!=0?(b=pA(ID(c[f>>2]|0)|0)|0,c[k>>2]=b,(b|0)!=0):0){c[l>>2]=pA(rC(c[f>>2]|0)|0)|0;c[h>>2]=Pz(c[(c[l>>2]|0)+8>>2]|0)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[h>>2]|0))break a;if(((c[(c[(c[j>>2]|0)+12>>2]|0)+(c[g>>2]<<2)>>2]|0)!=0?(c[(c[(c[k>>2]|0)+12>>2]|0)+(c[g>>2]<<2)>>2]|0)!=0:0)?(J3(c[(c[(c[j>>2]|0)+12>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[(c[k>>2]|0)+12>>2]|0)+(c[g>>2]<<2)>>2]|0)|0)!=0:0)break;c[g>>2]=(c[g>>2]|0)+1}c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}while(0);c[m>>2]=jA(c[f>>2]|0,0)|0;if(!(c[m>>2]|0)){c[e>>2]=1;o=c[e>>2]|0;i=d;return o|0}if((Pz(c[(c[m>>2]|0)+8>>2]|0)|0)<=0?(Pz(c[(c[m>>2]|0)+8+4>>2]|0)|0)<=0:0){c[e>>2]=1;o=c[e>>2]|0;i=d;return o|0}c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}function _D(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=c[f>>2]|0;c[d>>2]=c[d>>2]&-9|(c[h>>2]&1)<<3;c[j>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;_D(c[j>>2]|0,0,c[h>>2]|0);c[j>>2]=HD(c[j>>2]|0)|0}if(!(c[g>>2]|0)){i=e;return}c[k>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;g=c[k>>2]|0;c[g>>2]=c[g>>2]&-9|(c[h>>2]&1)<<3;c[l>>2]=OA(c[f>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;g=c[l>>2]|0;c[g>>2]=c[g>>2]&-9|(c[h>>2]&1)<<3;c[l>>2]=QA(c[f>>2]|0,c[l>>2]|0)|0}c[k>>2]=aC(c[f>>2]|0,c[k>>2]|0)|0}i=e;return}function $D(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[p>>2]=0;a[134847]=(c[c[h>>2]>>2]|0)>>>3&1;c[o>>2]=178518;if((c[k>>2]|0)==0?(ID(c[h>>2]|0)|0)!=0:0)c[n>>2]=147211;else{c[p>>2]=1;if(a[(c[h>>2]|0)+12>>0]&1)c[n>>2]=134848;else c[n>>2]=178518;if(pB(c[h>>2]|0)|0)c[o>>2]=134851;c[13513]=qA(c[h>>2]|0,2,149070,0)|0;c[13514]=qA(c[h>>2]|0,2,149061,0)|0}c[l>>2]=wB(c[h>>2]|0)|0;c[m>>2]=140232;if(!((c[l>>2]|0)!=0?(a[c[l>>2]>>0]|0)!=37:0)){c[l>>2]=178518;c[m>>2]=178518}if((cE(c[h>>2]|0,c[j>>2]|0)|0)==-1){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}if((dE(c[h>>2]|0,c[j>>2]|0,c[o>>2]|0)|0)==-1){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}if((c[p>>2]|0)!=0?1:(a[c[l>>2]>>0]|0)!=0){if((dE(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0)|0)==-1){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}if((dE(c[h>>2]|0,c[j>>2]|0,140225)|0)==-1){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}}if((a[c[l>>2]>>0]|0)!=0?(oE(c[h>>2]|0,c[j>>2]|0,c[l>>2]|0)|0)==-1:0){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}if((dE(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0)|0)==-1){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}if((dE(c[h>>2]|0,c[j>>2]|0,134859)|0)==-1){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}c[13511]=(c[13511]|0)+1;if((tE(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0)==-1){c[g>>2]=-1;q=c[g>>2]|0;i=f;return q|0}else{k=c[h>>2]|0;c[k>>2]=c[k>>2]&-9|8;c[g>>2]=0;q=c[g>>2]|0;i=f;return q|0}return 0}function aE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;if((eE(c[f>>2]|0,c[g>>2]|0)|0)==-1){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}c[l>>2]=jA(rC(c[f>>2]|0)|0,0)|0;c[h>>2]=$B(c[f>>2]|0)|0;a:while(1){if(!(c[h>>2]|0)){n=26;break}if(fE(c[f>>2]|0,c[h>>2]|0,(c[c[h>>2]>>2]|0)>>>4)|0){if(c[l>>2]|0)o=c[(c[l>>2]|0)+8>>2]|0;else o=0;if((gE(c[h>>2]|0,c[g>>2]|0,o)|0)==-1){n=9;break}}c[j>>2]=c[h>>2];c[k>>2]=OA(c[f>>2]|0,c[h>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;b=c[k>>2]|0;if((c[j>>2]|0)!=(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)?(b=c[k>>2]|0,(fE(c[f>>2]|0,c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,(c[c[h>>2]>>2]|0)>>>4)|0)!=0):0){b=c[k>>2]|0;if(c[l>>2]|0)p=c[(c[l>>2]|0)+8>>2]|0;else p=0;if((gE(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,c[g>>2]|0,p)|0)==-1){n=17;break a}b=c[k>>2]|0;c[j>>2]=c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]}if(hE(c[f>>2]|0,c[k>>2]|0)|0){if(c[l>>2]|0)q=c[(c[l>>2]|0)+8+4>>2]|0;else q=0;if((iE(c[k>>2]|0,c[g>>2]|0,q)|0)==-1){n=23;break a}}c[k>>2]=QA(c[f>>2]|0,c[k>>2]|0)|0}c[h>>2]=aC(c[f>>2]|0,c[h>>2]|0)|0}if((n|0)==9){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else if((n|0)==17){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else if((n|0)==23){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else if((n|0)==26){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}return 0}function bE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;c[13511]=(c[13511]|0)+-1;do if((cE(c[f>>2]|0,c[g>>2]|0)|0)!=-1)if((dE(c[f>>2]|0,c[g>>2]|0,148626)|0)==-1){c[e>>2]=-1;break}else{c[e>>2]=0;break}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function cE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[13511];while(1){if((c[h>>2]|0)<=0){j=6;break}if((dE(c[f>>2]|0,c[g>>2]|0,193390)|0)==-1){j=4;break}c[h>>2]=(c[h>>2]|0)+-1}if((j|0)==4){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}else if((j|0)==6){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function dE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=Ob[c[(c[(c[(c[f>>2]|0)+52>>2]|0)+8>>2]|0)+4>>2]&127](c[g>>2]|0,c[h>>2]|0)|0;i=e;return d|0}function eE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[h>>2]|0)){j=12;break}f=(ZD(c[h>>2]|0)|0)!=0;b=c[h>>2]|0;a=c[g>>2]|0;if(!f){if(($D(b,a,0)|0)==-1){j=6;break}if((aE(c[h>>2]|0,c[g>>2]|0)|0)==-1){j=8;break}if((bE(c[h>>2]|0,c[g>>2]|0)|0)==-1){j=10;break}}else eE(b,a)|0;c[h>>2]=HD(c[h>>2]|0)|0}if((j|0)==6){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}else if((j|0)==8){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}else if((j|0)==10){c[e>>2]=-1;k=c[e>>2]|0;i=d;return k|0}else if((j|0)==12){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function fE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if((UD(c[g>>2]|0,c[h>>2]|0)|0)==0?(qE(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)!=0:0){if((rE(c[g>>2]|0,c[h>>2]|0)|0)==0?(sE(c[g>>2]|0,c[h>>2]|0)|0)==0:0)break;c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}while(0);c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function gE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=qC(c[g>>2]|0)|0;if((cE(c[k>>2]|0,c[h>>2]|0)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if((jE(c[g>>2]|0,c[h>>2]|0)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if((lE(c[g>>2]|0)|0)==0?(mE(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)==-1:0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[f>>2]=dE(c[k>>2]|0,c[h>>2]|0,134814)|0;l=c[f>>2]|0;i=e;return l|0}function hE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[h>>2]|0)){j=7;break}if((ZD(c[h>>2]|0)|0)==0?(YA(c[h>>2]|0,c[g>>2]|0,0)|0)!=0:0){j=5;break}c[h>>2]=HD(c[h>>2]|0)|0}if((j|0)==5){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}else if((j|0)==7){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}return 0}function iE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=c[g>>2]|0;c[k>>2]=c[((c[c[g>>2]>>2]&3|0)==3?d:d+32|0)+28>>2];d=c[g>>2]|0;c[l>>2]=c[((c[c[g>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];c[m>>2]=qC(c[k>>2]|0)|0;do if((cE(c[m>>2]|0,c[h>>2]|0)|0)==-1)c[f>>2]=-1;else{if((jE(c[k>>2]|0,c[h>>2]|0)|0)==-1){c[f>>2]=-1;break}if((kE(c[g>>2]|0,c[h>>2]|0,c[13513]|0)|0)==-1){c[f>>2]=-1;break}d=c[m>>2]|0;b=c[h>>2]|0;a=(nB(qC(c[k>>2]|0)|0)|0)!=0;if((dE(d,b,a?138595:138600)|0)==-1){c[f>>2]=-1;break}if((jE(c[l>>2]|0,c[h>>2]|0)|0)==-1){c[f>>2]=-1;break}if((kE(c[g>>2]|0,c[h>>2]|0,c[13514]|0)|0)==-1){c[f>>2]=-1;break}a=(lE(c[g>>2]|0)|0)!=0;b=c[g>>2]|0;if(a){if((nE(b,c[h>>2]|0,1)|0)==-1){c[f>>2]=-1;break}}else if((mE(b,c[h>>2]|0,c[j>>2]|0)|0)==-1){c[f>>2]=-1;break}c[f>>2]=dE(c[m>>2]|0,c[h>>2]|0,134814)|0}while(0);i=e;return c[f>>2]|0}function jE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+48|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+24|0;l=d+4|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=wB(c[g>>2]|0)|0;c[l>>2]=qC(c[g>>2]|0)|0;if(c[j>>2]|0){if((oE(c[l>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)==-1){c[f>>2]=-1;m=c[f>>2]|0;i=d;return m|0}}else{c[e>>2]=c[(c[g>>2]|0)+4>>2];k3(k,134834,e)|0;if((dE(c[l>>2]|0,c[h>>2]|0,k)|0)==-1){c[f>>2]=-1;m=c[f>>2]|0;i=d;return m|0}}c[f>>2]=0;m=c[f>>2]|0;i=d;return m|0}function kE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;a:do if(c[k>>2]|0){c[m>>2]=qC(c[h>>2]|0)|0;c[l>>2]=zA(c[h>>2]|0,c[k>>2]|0)|0;if(!(a[c[l>>2]>>0]|0)){c[g>>2]=0;break}if((dE(c[m>>2]|0,c[j>>2]|0,148898)|0)==-1){c[g>>2]=-1;break}do if($C(c[l>>2]|0)|0){if((oE(c[m>>2]|0,c[j>>2]|0,c[l>>2]|0)|0)==-1){c[g>>2]=-1;break a}}else{c[n>>2]=H3(c[l>>2]|0,58)|0;if(!(c[n>>2]|0)){if((pE(c[m>>2]|0,c[j>>2]|0,c[l>>2]|0,0)|0)!=-1)break;c[g>>2]=-1;break a}a[c[n>>2]>>0]=0;if((pE(c[m>>2]|0,c[j>>2]|0,c[l>>2]|0,0)|0)==-1){c[g>>2]=-1;break a}if((dE(c[m>>2]|0,c[j>>2]|0,148898)|0)==-1){c[g>>2]=-1;break a}if((pE(c[m>>2]|0,c[j>>2]|0,(c[n>>2]|0)+1|0,0)|0)==-1){c[g>>2]=-1;break a}else{a[c[n>>2]>>0]=58;break}}while(0);c[g>>2]=0}else c[g>>2]=0;while(0);i=f;return c[g>>2]|0}function lE(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return (c[c[d>>2]>>2]|0)>>>3&1|0}function mE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[n>>2]=0;if(!((c[c[g>>2]>>2]&3|0)!=3?(c[c[g>>2]>>2]&3|0)!=2:0))p=3;do if((p|0)==3){d=nE(c[g>>2]|0,c[h>>2]|0,0)|0;c[o>>2]=d;if((d|0)==-1){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}else{if(!(c[o>>2]|0))break;c[n>>2]=(c[n>>2]|0)+1;break}}while(0);c[k>>2]=pA(c[g>>2]|0)|0;c[m>>2]=qC(c[g>>2]|0)|0;a:do if(c[k>>2]|0){c[l>>2]=Hb[c[c[j>>2]>>2]&63](c[j>>2]|0,0,128)|0;while(1){if(!(c[l>>2]|0))break a;if((c[c[g>>2]>>2]&3|0)!=3?(c[c[g>>2]>>2]&3|0)!=2:0)p=16;else p=12;do if((p|0)==12){p=0;if((c[13513]|0)!=0?(c[(c[l>>2]|0)+16>>2]|0)==(c[(c[13513]|0)+16>>2]|0):0)break;if(!((c[13514]|0)!=0?(c[(c[l>>2]|0)+16>>2]|0)==(c[(c[13514]|0)+16>>2]|0):0))p=16}while(0);if((p|0)==16?(p=0,(c[(c[(c[k>>2]|0)+12>>2]|0)+(c[(c[l>>2]|0)+16>>2]<<2)>>2]|0)!=(c[(c[l>>2]|0)+12>>2]|0)):0){o=c[n>>2]|0;c[n>>2]=o+1;d=c[m>>2]|0;b=c[h>>2]|0;if(o){if((dE(d,b,134829)|0)==-1){p=24;break}if((cE(c[m>>2]|0,c[h>>2]|0)|0)==-1){p=26;break}}else{if((cE(d,b)|0)==-1){p=19;break}if((dE(c[m>>2]|0,c[h>>2]|0,134826)|0)==-1){p=21;break}c[13511]=(c[13511]|0)+1}if((oE(c[m>>2]|0,c[h>>2]|0,c[(c[l>>2]|0)+8>>2]|0)|0)==-1){p=28;break}if((dE(c[m>>2]|0,c[h>>2]|0,134832)|0)==-1){p=30;break}if((oE(c[m>>2]|0,c[h>>2]|0,c[(c[(c[k>>2]|0)+12>>2]|0)+(c[(c[l>>2]|0)+16>>2]<<2)>>2]|0)|0)==-1){p=32;break}}c[l>>2]=Hb[c[c[j>>2]>>2]&63](c[j>>2]|0,c[l>>2]|0,8)|0}if((p|0)==19){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}else if((p|0)==21){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}else if((p|0)==24){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}else if((p|0)==26){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}else if((p|0)==28){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}else if((p|0)==30){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}else if((p|0)==32){c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}}while(0);do if((c[n>>2]|0)>0){if((dE(c[m>>2]|0,c[h>>2]|0,134824)|0)!=-1){c[13511]=(c[13511]|0)+-1;break}c[f>>2]=-1;q=c[f>>2]|0;i=e;return q|0}while(0);h=c[g>>2]|0;c[h>>2]=c[h>>2]&-9|8;c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}function nE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=wB(c[h>>2]|0)|0;c[n>>2]=qC(c[h>>2]|0)|0;if((c[m>>2]|0)!=0?(a[c[m>>2]>>0]|0)!=0:0){if((dE(c[n>>2]|0,c[j>>2]|0,134817)|0)==-1){c[g>>2]=-1;o=c[g>>2]|0;i=f;return o|0}if((oE(c[n>>2]|0,c[j>>2]|0,c[m>>2]|0)|0)==-1){c[g>>2]=-1;o=c[g>>2]|0;i=f;return o|0}if((c[k>>2]|0)!=0?(dE(c[n>>2]|0,c[j>>2]|0,134824)|0)==-1:0){c[g>>2]=-1;o=c[g>>2]|0;i=f;return o|0}c[l>>2]=1}else c[l>>2]=0;c[g>>2]=c[l>>2];o=c[g>>2]|0;i=f;return o|0}function oE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=pE(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,1)|0;i=e;return d|0}function pE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=c[j>>2]|0;if(c[k>>2]|0)c[j>>2]=TD(e)|0;else c[j>>2]=XD(e,YD(c[j>>2]|0)|0)|0;e=dE(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;i=f;return e|0}function qE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[c[h>>2]>>2]|0)>>>4>>>0<(c[j>>2]|0)>>>0){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=RA(c[g>>2]|0,c[h>>2]|0)|0;while(1){if(!(c[k>>2]|0)){m=8;break}if((c[c[(c[k>>2]|0)+28>>2]>>2]|0)>>>4>>>0<(c[j>>2]|0)>>>0){m=6;break}c[k>>2]=SA(c[g>>2]|0,c[k>>2]|0)|0}if((m|0)==6){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else if((m|0)==8){c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}return 0}function rE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(RA(c[e>>2]|0,c[f>>2]|0)|0){g=0;h=g&1;i=d;return h|0}g=(OA(c[e>>2]|0,c[f>>2]|0)|0)==0;h=g&1;i=d;return h|0}function sE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d+4|0;h=d;c[d+12>>2]=a;c[f>>2]=b;b=pA(c[f>>2]|0)|0;c[g>>2]=b;a:do if(b){c[h>>2]=Hb[c[c[(c[g>>2]|0)+8>>2]>>2]&63](c[(c[g>>2]|0)+8>>2]|0,0,128)|0;while(1){if(!(c[h>>2]|0))break a;if((c[(c[(c[g>>2]|0)+12>>2]|0)+(c[(c[h>>2]|0)+16>>2]<<2)>>2]|0)!=(c[(c[h>>2]|0)+12>>2]|0))break;c[h>>2]=Hb[c[c[(c[g>>2]|0)+8>>2]>>2]&63](c[(c[g>>2]|0)+8>>2]|0,c[h>>2]|0,8)|0}c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}while(0);c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function tE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=jA(c[g>>2]|0,0)|0;c[k>>2]=d;if(d){if((uE(c[g>>2]|0,c[h>>2]|0,149098,c[(c[k>>2]|0)+8+8>>2]|0,c[j>>2]|0)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if((uE(c[g>>2]|0,c[h>>2]|0,149084,c[(c[k>>2]|0)+8>>2]|0,c[j>>2]|0)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}if((uE(c[g>>2]|0,c[h>>2]|0,149079,c[(c[k>>2]|0)+8+4>>2]|0,c[j>>2]|0)|0)==-1){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}}c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}function uE(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+48|0;k=j+36|0;l=j+32|0;m=j+28|0;n=j+24|0;o=j+20|0;p=j+16|0;q=j+12|0;r=j+8|0;s=j+4|0;t=j;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;c[q>>2]=0;if(c[p>>2]|0)c[r>>2]=0;else c[r>>2]=Sz(c[o>>2]|0,0)|0;c[s>>2]=Hb[c[c[o>>2]>>2]&63](c[o>>2]|0,0,128)|0;while(1){if(!(c[s>>2]|0)){u=32;break}if((c[(c[s>>2]|0)+12>>2]|0)!=0?(a[c[(c[s>>2]|0)+12>>2]>>0]|0)!=0:0)u=13;else u=8;do if((u|0)==8){u=0;if(!(a[(c[s>>2]|0)+22>>0]|0)){if(c[r>>2]|0){c[t>>2]=Hb[c[c[r>>2]>>2]&63](c[r>>2]|0,c[s>>2]|0,4)|0;if((c[(c[t>>2]|0)+12>>2]|0)!=0?(a[c[(c[t>>2]|0)+12>>2]>>0]|0)!=0:0){u=13;break}if(!(d[(c[t>>2]|0)+22>>0]|0))u=13}}else u=13}while(0);if((u|0)==13){u=0;h=c[q>>2]|0;c[q>>2]=h+1;g=c[l>>2]|0;f=c[m>>2]|0;if(h){if((dE(g,f,134829)|0)==-1){u=22;break}if((cE(c[l>>2]|0,c[m>>2]|0)|0)==-1){u=24;break}}else{if((cE(g,f)|0)==-1){u=15;break}if((dE(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0)==-1){u=17;break}if((dE(c[l>>2]|0,c[m>>2]|0,134826)|0)==-1){u=19;break}c[13511]=(c[13511]|0)+1}if((oE(c[l>>2]|0,c[m>>2]|0,c[(c[s>>2]|0)+8>>2]|0)|0)==-1){u=26;break}if((dE(c[l>>2]|0,c[m>>2]|0,134832)|0)==-1){u=28;break}if((oE(c[l>>2]|0,c[m>>2]|0,c[(c[s>>2]|0)+12>>2]|0)|0)==-1){u=30;break}}c[s>>2]=Hb[c[c[o>>2]>>2]&63](c[o>>2]|0,c[s>>2]|0,8)|0}if((u|0)==15){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else if((u|0)==17){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else if((u|0)==19){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else if((u|0)==22){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else if((u|0)==24){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else if((u|0)==26){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else if((u|0)==28){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else if((u|0)==30){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}else if((u|0)==32){if((c[q>>2]|0)>0){c[13511]=(c[13511]|0)+-1;if((c[q>>2]|0)>1){if((dE(c[l>>2]|0,c[m>>2]|0,193392)|0)==-1){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}if((cE(c[l>>2]|0,c[m>>2]|0)|0)==-1){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}}if((dE(c[l>>2]|0,c[m>>2]|0,134862)|0)==-1){c[k>>2]=-1;v=c[k>>2]|0;i=j;return v|0}}if(!(c[p>>2]|0))Sz(c[o>>2]|0,c[r>>2]|0)|0;c[k>>2]=0;v=c[k>>2]|0;i=j;return v|0}return 0}function vE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[c[k>>2]>>2]&3|0){case 0:{c[p>>2]=82;break}case 1:{c[p>>2]=83;break}case 3:case 2:{c[p>>2]=84;break}default:{}}f=Ob[c[p>>2]&127](c[j>>2]|0,c[k>>2]|0)|0;c[o>>2]=f;if(f){zE(c[j>>2]|0,c[o>>2]|0,c[l>>2]|0,c[m>>2]|0,c[p>>2]|0,c[n>>2]|0);c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}else{c[h>>2]=-1;q=c[h>>2]|0;i=g;return q|0}return 0}function wE(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+4|0;c[e>>2]=a;c[d>>2]=b;i=d;return c[e>>2]|0}function xE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=qC(c[g>>2]|0)|0;if((b|0)==(c[f>>2]|0)){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=eC(c[f>>2]|0,c[g>>2]|0,0)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function yE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=qC(c[g>>2]|0)|0;if((b|0)==(c[f>>2]|0)){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=YA(c[f>>2]|0,c[g>>2]|0,0)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function zE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;if(c[o>>2]|0)Tb[c[l>>2]&127](c[j>>2]|0,c[k>>2]|0,c[m>>2]|0);c[p>>2]=GD(c[j>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;g=Ob[c[n>>2]&127](c[p>>2]|0,c[k>>2]|0)|0;c[q>>2]=g;if(g)zE(c[p>>2]|0,c[q>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0);c[p>>2]=HD(c[p>>2]|0)|0}if(c[o>>2]|0){i=h;return}Tb[c[l>>2]&127](c[j>>2]|0,c[k>>2]|0,c[m>>2]|0);i=h;return}function AE(){var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+1280|0;f=e+868|0;g=e+864|0;h=e+872|0;j=e+860|0;k=e+856|0;l=e+48|0;m=e+44|0;n=e+40|0;o=e+36|0;p=e+32|0;q=e+28|0;r=e+24|0;s=e+20|0;t=e+16|0;u=e+12|0;v=e+8|0;w=e+4|0;x=e;c[s>>2]=0;c[q>>2]=0;c[j>>2]=h;c[l>>2]=e+56;c[n>>2]=200;c[f>>2]=0;c[g>>2]=0;c[13524]=0;c[13525]=-2;c[k>>2]=c[j>>2];c[m>>2]=c[l>>2];a:while(1){b[c[k>>2]>>1]=c[f>>2];if(((c[j>>2]|0)+(c[n>>2]<<1)+-2|0)>>>0<=(c[k>>2]|0)>>>0){c[t>>2]=(((c[k>>2]|0)-(c[j>>2]|0)|0)/2|0)+1;if(1e4<=(c[n>>2]|0)>>>0){y=88;break}z=c[n>>2]<<1;c[n>>2]=z;c[n>>2]=1e4<(c[n>>2]|0)>>>0?1e4:z;c[u>>2]=c[j>>2];c[v>>2]=N4(((c[n>>2]|0)*6|0)+3|0)|0;if(!(c[v>>2]|0)){y=88;break}Z4(c[v>>2]|0,c[j>>2]|0,c[t>>2]<<1|0)|0;c[j>>2]=c[v>>2];c[w>>2]=(c[n>>2]<<1)+3;c[v>>2]=(c[v>>2]|0)+((((c[w>>2]|0)>>>0)/4|0)<<2);Z4(c[v>>2]|0,c[l>>2]|0,c[t>>2]<<2|0)|0;c[l>>2]=c[v>>2];c[x>>2]=(c[n>>2]<<2)+3;c[v>>2]=(c[v>>2]|0)+((((c[x>>2]|0)>>>0)/4|0)<<2);if((c[u>>2]|0)!=(h|0))O4(c[u>>2]|0);c[k>>2]=(c[j>>2]|0)+(c[t>>2]<<1)+-2;c[m>>2]=(c[l>>2]|0)+(c[t>>2]<<2)+-4;if(((c[j>>2]|0)+(c[n>>2]<<1)+-2|0)>>>0<=(c[k>>2]|0)>>>0){y=87;break}}if((c[f>>2]|0)==6){y=86;break}c[o>>2]=a[134876+(c[f>>2]|0)>>0];do if((c[o>>2]|0)!=-18){if((c[13525]|0)==-2)c[13525]=gD()|0;if((c[13525]|0)<=0){c[q>>2]=0;c[13525]=0}else{if((c[13525]|0)>>>0<=268)A=d[134956+(c[13525]|0)>>0]|0;else A=2;c[q>>2]=A}c[o>>2]=(c[o>>2]|0)+(c[q>>2]|0);if(!((c[o>>2]|0)<0|59<(c[o>>2]|0))?(d[135225+(c[o>>2]|0)>>0]|0)==(c[q>>2]|0):0){c[o>>2]=a[135285+(c[o>>2]|0)>>0];if((c[o>>2]|0)<=0){c[o>>2]=0-(c[o>>2]|0);y=26;break}if(c[g>>2]|0)c[g>>2]=(c[g>>2]|0)+-1;c[13525]=-2;c[f>>2]=c[o>>2];z=(c[m>>2]|0)+4|0;c[m>>2]=z;c[z>>2]=c[13526]}else y=25}else y=25;while(0);if((y|0)==25){y=0;c[o>>2]=d[135345+(c[f>>2]|0)>>0];if(!(c[o>>2]|0)){if((c[13525]|0)!=-2)if((c[13525]|0)>>>0<=268)B=d[134956+(c[13525]|0)>>0]|0;else B=2;else B=-2;c[q>>2]=B;if(!(c[g>>2]|0)){c[13524]=(c[13524]|0)+1;nD(180146)}do if((c[g>>2]|0)==3)if((c[13525]|0)<=0)if(!(c[13525]|0)){y=87;break a}else break;else{OE(178296,c[q>>2]|0,54104);c[13525]=-2;break}while(0);c[g>>2]=3;while(1){c[o>>2]=a[134876+(c[f>>2]|0)>>0];if((((c[o>>2]|0)!=-18?(c[o>>2]=(c[o>>2]|0)+1,0<=(c[o>>2]|0)&(c[o>>2]|0)<=59):0)?(d[135225+(c[o>>2]|0)>>0]|0)==1:0)?(c[o>>2]=a[135285+(c[o>>2]|0)>>0],0<(c[o>>2]|0)):0)break;if((c[k>>2]|0)==(c[j>>2]|0)){y=87;break a}OE(178430,d[135621+(c[f>>2]|0)>>0]|0,c[m>>2]|0);c[m>>2]=(c[m>>2]|0)+-4;c[k>>2]=(c[k>>2]|0)+-2;c[f>>2]=b[c[k>>2]>>1]}z=(c[m>>2]|0)+4|0;c[m>>2]=z;c[z>>2]=c[13526];c[f>>2]=c[o>>2]}else y=26}do if((y|0)==26){y=0;c[s>>2]=d[135425+(c[o>>2]|0)>>0];c[r>>2]=c[(c[m>>2]|0)+(1-(c[s>>2]|0)<<2)>>2];b:do switch(c[o>>2]|0){case 2:{DE();break}case 3:{if(c[13527]|0){jB(c[13527]|0)|0;c[13072]=0;c[13527]=0}break}case 6:{EE(c[c[m>>2]>>2]|0,c[(c[m>>2]|0)+-4>>2]|0,c[(c[m>>2]|0)+-8>>2]|0);break}case 7:{c[r>>2]=c[c[m>>2]>>2];break}case 8:{c[r>>2]=0;break}case 9:{c[r>>2]=1;break}case 10:{c[r>>2]=0;break}case 11:{c[r>>2]=0;break}case 12:{c[r>>2]=1;break}case 21:{if(c[(c[m>>2]|0)+-4>>2]|0){FE();break b}else{GE();break b}break}case 24:{HE(1);break}case 25:{HE(2);break}case 26:{c[r>>2]=1;break}case 27:{c[r>>2]=0;break}case 30:{IE(c[c[m>>2]>>2]|0,0,0);break}case 31:{IE(c[(c[m>>2]|0)+-8>>2]|0,c[c[m>>2]>>2]|0,0);break}case 32:{IE(c[(c[m>>2]|0)+-16>>2]|0,c[(c[m>>2]|0)+-8>>2]|0,c[c[m>>2]>>2]|0);break}case 33:{JE(c[(c[m>>2]|0)+-8>>2]|0,c[(c[m>>2]|0)+-4>>2]|0);break}case 34:{JE(258,0);break}case 35:{c[r>>2]=258;break}case 36:{c[r>>2]=259;break}case 37:{c[r>>2]=260;break}case 38:{c[r>>2]=c[(c[m>>2]|0)+-4>>2];break}case 39:{c[r>>2]=0;break}case 48:{KE(c[(c[m>>2]|0)+-8>>2]|0,c[c[m>>2]>>2]|0);break}case 49:{KE(c[c[m>>2]>>2]|0,0);break}case 51:{LE(c[c[m>>2]>>2]|0);break}case 52:{ME();break}case 53:{c[r>>2]=c[c[m>>2]>>2];break}case 54:{c[r>>2]=0;break}case 55:{c[r>>2]=0;break}case 59:{c[r>>2]=c[c[m>>2]>>2];break}case 60:{c[r>>2]=c[c[m>>2]>>2];break}case 61:{c[r>>2]=c[c[m>>2]>>2];break}case 62:{c[r>>2]=NE(c[(c[m>>2]|0)+-8>>2]|0,c[c[m>>2]>>2]|0)|0;break}default:{}}while(0);c[m>>2]=(c[m>>2]|0)+(0-(c[s>>2]|0)<<2);c[k>>2]=(c[k>>2]|0)+(0-(c[s>>2]|0)<<1);c[s>>2]=0;z=(c[m>>2]|0)+4|0;c[m>>2]=z;c[z>>2]=c[r>>2];c[o>>2]=d[135488+(c[o>>2]|0)>>0];c[f>>2]=(a[135551+((c[o>>2]|0)-24)>>0]|0)+(b[c[k>>2]>>1]|0);if(0<=(c[f>>2]|0)&(c[f>>2]|0)<=59?(d[135225+(c[f>>2]|0)>>0]|0)==(b[c[k>>2]>>1]|0):0){c[f>>2]=a[135285+(c[f>>2]|0)>>0];break}c[f>>2]=a[135586+((c[o>>2]|0)-24)>>0]}while(0);c[k>>2]=(c[k>>2]|0)+2}if((y|0)==86)c[p>>2]=0;else if((y|0)==87)c[p>>2]=1;else if((y|0)==88){nD(178445);c[p>>2]=2}if((c[13525]|0)!=-2){if((c[13525]|0)>>>0<=268)C=d[134956+(c[13525]|0)>>0]|0;else C=2;c[q>>2]=C;OE(178462,c[q>>2]|0,54104)}c[m>>2]=(c[m>>2]|0)+(0-(c[s>>2]|0)<<2);c[k>>2]=(c[k>>2]|0)+(0-(c[s>>2]|0)<<1);while(1){if((c[k>>2]|0)==(c[j>>2]|0))break;OE(178492,d[135621+(b[c[k>>2]>>1]|0)>>0]|0,c[m>>2]|0);c[m>>2]=(c[m>>2]|0)+-4;c[k>>2]=(c[k>>2]|0)+-2}if((c[j>>2]|0)==(h|0)){D=c[p>>2]|0;i=e;return D|0}O4(c[j>>2]|0);D=c[p>>2]|0;i=e;return D|0}function BE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[13180]=c[g>>2];c[13527]=c[f>>2];c[13072]=0;c[13528]=(c[h>>2]|0)!=0?c[h>>2]|0:52276;fD(c[13528]|0,c[g>>2]|0);AE()|0;if(c[13072]|0){j=c[13072]|0;i=e;return j|0}pD();j=c[13072]|0;i=e;return j|0}function CE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=BE(0,c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function DE(){oD();JB(c[13527]|0);return}function EE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[13527]|0)){a[54120]=a[54120]&-2|c[j>>2]&1;a[54120]=a[54120]&-3|(c[k>>2]&1)<<1&255;a[54120]=a[54120]&-9|8;k=c[h>>2]|0;j=c[13528]|0;c[g>>2]=c[13530];e=gB(k,g,j)|0;c[13527]=e;c[13072]=e;l=c[13529]|0;m=c[13527]|0;n=QE(l,m)|0;c[13529]=n;o=c[h>>2]|0;_C(0,o)|0;i=f;return}else{c[13072]=c[13527];l=c[13529]|0;m=c[13527]|0;n=QE(l,m)|0;c[13529]=n;o=c[h>>2]|0;_C(0,o)|0;i=f;return}}function FE(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;VE(2);c[d>>2]=0;c[e>>2]=c[(c[13529]|0)+24>>2];while(1){if(!(c[e>>2]|0))break;if(((c[c[e>>2]>>2]|0)==267?(a[c[(c[e>>2]|0)+4>>2]>>0]|0)==(a[135701]|0):0)?(J3(c[(c[e>>2]|0)+4>>2]|0,135701)|0)==0:0)c[d>>2]=c[(c[e>>2]|0)+8>>2];c[e>>2]=c[(c[e>>2]|0)+12>>2]}c[g>>2]=c[(c[13529]|0)+16>>2];while(1){if(!(c[(c[g>>2]|0)+12>>2]|0))break;e=(c[g>>2]|0)+4|0;a:do if((c[c[g>>2]>>2]|0)==262){c[j>>2]=c[e>>2];c[h>>2]=$B(c[j>>2]|0)|0;while(1){if(!(c[h>>2]|0))break a;k=eC(c[c[13529]>>2]|0,c[h>>2]|0,0)|0;bF(k,0,c[(c[g>>2]|0)+12>>2]|0,c[d>>2]|0);c[h>>2]=aC(c[j>>2]|0,c[h>>2]|0)|0}}else{c[f>>2]=c[e>>2];while(1){if(!(c[f>>2]|0))break a;bF(c[(c[f>>2]|0)+4>>2]|0,c[(c[f>>2]|0)+8>>2]|0,c[(c[g>>2]|0)+12>>2]|0,c[d>>2]|0);c[f>>2]=c[(c[f>>2]|0)+12>>2]}}while(0);c[g>>2]=c[(c[g>>2]|0)+12>>2]}WE((c[13529]|0)+8|0);WE((c[13529]|0)+16|0);WE((c[13529]|0)+24|0);c[(c[13529]|0)+4>>2]=0;i=b;return}function GE(){var a=0,b=0;a=i;i=i+16|0;b=a;VE(1);c[b>>2]=c[(c[13529]|0)+8>>2];while(1){if(!(c[b>>2]|0))break;aF(c[(c[b>>2]|0)+4>>2]|0);c[b>>2]=c[(c[b>>2]|0)+12>>2]}WE((c[13529]|0)+8|0);WE((c[13529]|0)+24|0);WE((c[13529]|0)+16|0);c[(c[13529]|0)+4>>2]=0;i=a;return}function HE(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[b+4>>2]=a;c[d>>2]=0;a=c[13529]|0;if(c[(c[13529]|0)+8>>2]|0){c[d>>2]=_E(c[a+8>>2]|0)|0;c[(c[13529]|0)+8+4>>2]=0;c[(c[13529]|0)+8>>2]=0}else{if(c[a+4>>2]|0)c[d>>2]=$E(c[(c[13529]|0)+4>>2]|0)|0;c[(c[13529]|0)+4>>2]=0}if(!(c[d>>2]|0)){i=b;return}SE((c[13529]|0)+16|0,c[d>>2]|0);i=b;return}function IE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(c[h>>2]|0)c[g>>2]=YE(c[g>>2]|0,c[h>>2]|0)|0;h=fC(c[c[13529]>>2]|0,c[f>>2]|0,1)|0;c[j>>2]=ZE(h,c[g>>2]|0)|0;SE((c[13529]|0)+8|0,c[j>>2]|0);_C(c[13527]|0,c[f>>2]|0)|0;i=e;return}function JE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;if(c[g>>2]|0)UE();c[h>>2]=c[(c[13529]|0)+24>>2];while(1){if(!(c[h>>2]|0))break;if(!(c[(c[h>>2]|0)+8>>2]|0))UE();c[h>>2]=c[(c[h>>2]|0)+12>>2]}switch(c[f>>2]|0){case 258:{c[j>>2]=0;break}case 259:{c[j>>2]=1;break}case 260:{c[j>>2]=2;break}default:{}}VE(c[j>>2]|0);c[h>>2]=c[(c[13529]|0)+24>>2];while(1){if(!(c[h>>2]|0))break;if((a[(c[(c[h>>2]|0)+4>>2]|0)+21>>0]|0)!=0?(c[c[13529]>>2]|0)==(c[13527]|0):0)c[k>>2]=c[(c[h>>2]|0)+4>>2];else c[k>>2]=qA(c[c[13529]>>2]|0,c[j>>2]|0,c[(c[(c[h>>2]|0)+4>>2]|0)+8>>2]|0,c[(c[h>>2]|0)+8>>2]|0)|0;if((c[c[13529]>>2]|0)==(c[13527]|0))a[(c[k>>2]|0)+22>>0]=1;c[h>>2]=c[(c[h>>2]|0)+12>>2]}WE((c[13529]|0)+24|0);i=e;return}function KE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=RE(c[e>>2]|0,c[f>>2]|0)|0;SE((c[13529]|0)+24|0,c[g>>2]|0);i=d;return}function LE(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[13529]|0;c[13529]=QE(a,FD(c[c[13529]>>2]|0,c[d>>2]|0,1)|0)|0;_C(c[13527]|0,c[d>>2]|0)|0;i=b;return}function ME(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=c[c[13529]>>2];c[13529]=PE(c[13529]|0)|0;c[(c[13529]|0)+4>>2]=c[b>>2];i=a;return}function NE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+1056|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+24|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;b=N3(c[e>>2]|0)|0;c[k>>2]=b+(N3(c[f>>2]|0)|0)+1;if((c[k>>2]|0)<=1024)c[j>>2]=h;else c[j>>2]=N4(c[k>>2]|0)|0;K3(c[j>>2]|0,c[e>>2]|0)|0;G3(c[j>>2]|0,c[f>>2]|0)|0;c[g>>2]=YC(c[13527]|0,c[j>>2]|0)|0;_C(c[13527]|0,c[e>>2]|0)|0;_C(c[13527]|0,c[f>>2]|0)|0;if((c[j>>2]|0)==(h|0)){l=c[g>>2]|0;i=d;return l|0}O4(c[j>>2]|0);l=c[g>>2]|0;i=d;return l|0}function OE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+8|0;c[f>>2]=a;c[e+4>>2]=b;c[e>>2]=d;if(c[f>>2]|0){i=e;return}c[f>>2]=178509;i=e;return}function PE(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[13529]|0)+32>>2];VB(c[13527]|0,c[d>>2]|0);i=b;return c[e>>2]|0}function QE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=UB(c[13527]|0,36)|0;c[(c[g>>2]|0)+32>>2]=c[e>>2];c[c[g>>2]>>2]=c[f>>2];i=d;return c[g>>2]|0}function RE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=TE(267,c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function SE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(c[(c[e>>2]|0)+4>>2]|0)c[(c[(c[e>>2]|0)+4>>2]|0)+12>>2]=c[f>>2];c[(c[e>>2]|0)+4>>2]=c[f>>2];if(c[c[e>>2]>>2]|0){i=d;return}c[c[e>>2]>>2]=c[f>>2];i=d;return}function TE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=UB(c[13527]|0,16)|0;c[c[j>>2]>>2]=c[f>>2];c[(c[j>>2]|0)+4>>2]=c[g>>2];c[(c[j>>2]|0)+8>>2]=c[h>>2];i=e;return c[j>>2]|0}function UE(){var a=0;a=i;i=i+16|0;$z(0,135705,a)|0;i=a;return}function VE(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=b;c[f>>2]=c[(c[13529]|0)+24>>2];while(1){if(!(c[f>>2]|0))break;c[g>>2]=c[(c[f>>2]|0)+4>>2];if(!(((c[e>>2]|0)==2?(a[c[g>>2]>>0]|0)==(a[135701]|0):0)?(J3(c[g>>2]|0,135701)|0)==0:0)){b=qA(c[c[13529]>>2]|0,c[e>>2]|0,c[g>>2]|0,0)|0;c[(c[f>>2]|0)+4>>2]=b;if(!b){b=qA(c[c[13529]>>2]|0,c[e>>2]|0,c[g>>2]|0,178518)|0;c[(c[f>>2]|0)+4>>2]=b}c[c[f>>2]>>2]=266;_C(c[13527]|0,c[g>>2]|0)|0}c[f>>2]=c[(c[f>>2]|0)+12>>2]}i=d;return}function WE(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;XE(c[c[d>>2]>>2]|0);c[(c[d>>2]|0)+4>>2]=0;c[c[d>>2]>>2]=0;i=b;return}function XE(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=c[d>>2];while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[(c[e>>2]|0)+12>>2];switch(c[c[e>>2]>>2]|0){case 265:{XE(c[(c[e>>2]|0)+4>>2]|0);break}case 266:case 267:{_C(c[13527]|0,c[(c[e>>2]|0)+8>>2]|0)|0;break}default:{}}VB(c[13527]|0,c[e>>2]|0);c[e>>2]=c[f>>2]}i=b;return}function YE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+1056|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;j=d+32|0;k=d+12|0;l=d+8|0;c[f>>2]=a;c[g>>2]=b;b=N3(c[f>>2]|0)|0;c[l>>2]=b+(N3(c[g>>2]|0)|0)+2;if((c[l>>2]|0)<=1024)c[k>>2]=j;else c[k>>2]=N4(c[l>>2]|0)|0;l=c[k>>2]|0;b=c[g>>2]|0;c[e>>2]=c[f>>2];c[e+4>>2]=b;k3(l,135738,e)|0;c[h>>2]=YC(c[13527]|0,c[k>>2]|0)|0;_C(c[13527]|0,c[f>>2]|0)|0;_C(c[13527]|0,c[g>>2]|0)|0;if((c[k>>2]|0)==(j|0)){m=c[h>>2]|0;i=d;return m|0}O4(c[k>>2]|0);m=c[h>>2]|0;i=d;return m|0}function ZE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=TE(259,c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function _E(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=TE(265,c[d>>2]|0,0)|0;i=b;return a|0}function $E(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=TE(262,c[d>>2]|0,0)|0;i=b;return a|0}function aF(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[13529]|0)+24>>2];while(1){if(!(c[e>>2]|0))break;if((c[c[e>>2]>>2]|0)==266?(c[(c[e>>2]|0)+4>>2]|0)!=0:0)BA(c[d>>2]|0,c[(c[e>>2]|0)+4>>2]|0,c[(c[e>>2]|0)+8>>2]|0)|0;c[e>>2]=c[(c[e>>2]|0)+12>>2]}i=b;return}function bF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=(c[j>>2]|0)+4|0;if((c[c[j>>2]>>2]|0)==262){c[m>>2]=c[e>>2];c[l>>2]=$B(c[m>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;j=c[g>>2]|0;d=c[h>>2]|0;b=eC(c[c[13529]>>2]|0,c[l>>2]|0,0)|0;cF(j,d,b,0,c[k>>2]|0);c[l>>2]=aC(c[m>>2]|0,c[l>>2]|0)|0}i=f;return}else{c[n>>2]=c[e>>2];while(1){if(!(c[n>>2]|0))break;e=c[g>>2]|0;l=c[h>>2]|0;m=eC(c[c[13529]>>2]|0,c[(c[n>>2]|0)+4>>2]|0,0)|0;cF(e,l,m,c[(c[n>>2]|0)+8>>2]|0,c[k>>2]|0);c[n>>2]=c[(c[n>>2]|0)+12>>2]}i=f;return}}function cF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=VA(c[c[13529]>>2]|0,c[h>>2]|0,c[k>>2]|0,c[m>>2]|0,1)|0;if(!(c[n>>2]|0)){i=g;return}c[o>>2]=c[j>>2];c[p>>2]=c[l>>2];l=c[n>>2]|0;j=c[n>>2]|0;if((c[((c[c[n>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)!=(c[((c[c[n>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)?(j=c[n>>2]|0,(c[((c[c[n>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)==(c[h>>2]|0)):0){c[q>>2]=c[o>>2];c[o>>2]=c[p>>2];c[p>>2]=c[q>>2]}dF(c[n>>2]|0,149070,c[o>>2]|0);dF(c[n>>2]|0,149061,c[p>>2]|0);aF(c[n>>2]|0);i=g;return}function dF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[h>>2]|0)){i=e;return}d=qA(c[c[13529]>>2]|0,2,c[g>>2]|0,0)|0;c[j>>2]=d;if(!d)c[j>>2]=qA(c[c[13529]>>2]|0,2,c[g>>2]|0,178518)|0;BA(c[f>>2]|0,c[j>>2]|0,c[h>>2]|0)|0;i=e;return}function eF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=yF(c[f>>2]|0,1,c[g>>2]|0)|0;if(c[h>>2]|0){c[j>>2]=c[(c[h>>2]|0)+16>>2];c[(c[f>>2]|0)+172+12>>2]=c[(c[j>>2]|0)+4>>2];c[(c[f>>2]|0)+172>>2]=c[(c[j>>2]|0)+12>>2];c[(c[f>>2]|0)+172+4>>2]=c[c[j>>2]>>2];c[(c[f>>2]|0)+172+8>>2]=c[(c[j>>2]|0)+16>>2];c[e>>2]=300;k=c[e>>2]|0;i=d;return k|0}else{c[e>>2]=999;k=c[e>>2]|0;i=d;return k|0}return 0}function fF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;c[g>>2]=a;c[h>>2]=b;MC(c[h>>2]|0,175049,280,1)|0;c[(c[(c[h>>2]|0)+8>>2]|0)+144>>2]=c[g>>2];b=c[h>>2]|0;if((b|0)!=(rC(c[h>>2]|0)|0)){b=c[g>>2]|0;c[(c[(rC(c[h>>2]|0)|0)+8>>2]|0)+144>>2]=b}b=yA(c[h>>2]|0,136032)|0;c[k>>2]=b;if((b|0)!=0?(c[(c[g>>2]|0)+172>>2]=0,c[l>>2]=eF(c[g>>2]|0,c[k>>2]|0)|0,(c[l>>2]|0)==999):0){l=c[k>>2]|0;b=zF(c[g>>2]|0,1,c[k>>2]|0)|0;c[e>>2]=l;c[e+4>>2]=b;$z(1,136511,e)|0;c[f>>2]=-1;m=c[f>>2]|0;i=d;return m|0}c[j>>2]=c[(c[g>>2]|0)+172>>2];if(!(c[j>>2]|0)){c[f>>2]=-1;m=c[f>>2]|0;i=d;return m|0}KH(1);KJ(c[h>>2]|0,c[c[(c[g>>2]|0)+172+8>>2]>>2]&1);g=c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0;c[(c[(rC(c[h>>2]|0)|0)+8>>2]|0)+8>>2]=g;if(((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)!=0:0)?(Bb[c[c[j>>2]>>2]&127](c[h>>2]|0),(c[(c[j>>2]|0)+4>>2]|0)!=0):0)c[(c[(c[h>>2]|0)+8>>2]|0)+148>>2]=c[(c[j>>2]|0)+4>>2];KH(0);c[f>>2]=0;m=c[f>>2]|0;i=d;return m|0}function gF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d;c[d+4>>2]=a;c[f>>2]=b;if(!(MC(c[f>>2]|0,175049,0,1)|0)){c[e>>2]=0;g=c[e>>2]|0;i=d;return g|0}if(c[(c[(c[f>>2]|0)+8>>2]|0)+148>>2]|0){Bb[c[(c[(c[f>>2]|0)+8>>2]|0)+148>>2]&127](c[f>>2]|0);c[(c[(c[f>>2]|0)+8>>2]|0)+148>>2]=0}if(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)MJ(c[f>>2]|0);c[e>>2]=0;g=c[e>>2]|0;i=d;return g|0}function hF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+8|0;f=d;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;c[h>>2]=b;c[j>>2]=c[(c[h>>2]|0)+76>>2];c[k>>2]=c[c[h>>2]>>2];if((c[j>>2]|0)!=0?(c[c[j>>2]>>2]|0)!=0:0)Bb[c[c[j>>2]>>2]&127](c[h>>2]|0);else l=4;do if(((l|0)==4?(c[(c[h>>2]|0)+40>>2]|0)==0:0)?(c[(c[h>>2]|0)+36>>2]|0)==0:0){if(a[(c[k>>2]|0)+13>>0]|0)sF(c[h>>2]|0);if(!(c[(c[h>>2]|0)+32>>2]|0)){c[(c[h>>2]|0)+36>>2]=c[24744];break}j=X2(c[(c[h>>2]|0)+32>>2]|0,143129)|0;c[(c[h>>2]|0)+36>>2]=j;if(!(c[(c[h>>2]|0)+36>>2]|0)){j=c[(c[(c[h>>2]|0)+12>>2]|0)+16>>2]|0;b=c[(c[h>>2]|0)+32>>2]|0;m=M1(c[(L1()|0)>>2]|0)|0;c[f>>2]=b;c[f+4>>2]=m;Db[j&31](135744,f);c[g>>2]=1;n=c[g>>2]|0;i=d;return n|0}}while(0);if(c[(c[h>>2]|0)+152>>2]&1024){Db[c[(c[(c[h>>2]|0)+12>>2]|0)+16>>2]&31](135782,e);c[g>>2]=1;n=c[g>>2]|0;i=d;return n|0}else{c[g>>2]=0;n=c[g>>2]|0;i=d;return n|0}return 0}function iF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+8|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;if(!((c[k>>2]|0)!=0&(c[j>>2]|0)!=0)){c[g>>2]=0;m=c[g>>2]|0;i=e;return m|0}d=c[h>>2]|0;if(c[(c[h>>2]|0)+152>>2]&1024){Db[c[(c[d+12>>2]|0)+16>>2]&31](135782,e);wb(1)}c[l>>2]=tF(d,c[j>>2]|0,c[k>>2]|0)|0;if((c[l>>2]|0)!=(c[k>>2]|0)){l=c[(c[(c[h>>2]|0)+12>>2]|0)+16>>2]|0;c[f>>2]=c[k>>2];Db[l&31](135800,f);wb(1)}c[g>>2]=c[k>>2];m=c[g>>2]|0;i=e;return m|0}function jF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=N3(c[g>>2]|0)|0;b=iF(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;if((b|0)!=(c[h>>2]|0)){c[e>>2]=-1;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}return 0}function kF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[g>>2]=b;c[h>>2]=d;a[j>>0]=c[h>>2];if((iF(c[g>>2]|0,j,1)|0)!=1){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=c[h>>2];k=c[f>>2]|0;i=e;return k|0}return 0}function lF(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;if(((c[(c[f>>2]|0)+36>>2]|0)!=0?(a[(c[f>>2]|0)+144>>0]|0)==0:0)?(c[(c[c[f>>2]>>2]|0)+104>>2]|0)==0:0){c[e>>2]=T2(c[(c[f>>2]|0)+36>>2]|0)|0;g=c[e>>2]|0;i=d;return g|0}c[e>>2]=0;g=c[e>>2]|0;i=d;return g|0}function mF(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+76>>2];if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+4>>2]|0)!=0:0)Bb[c[(c[e>>2]|0)+4>>2]&127](c[d>>2]|0);lF(c[d>>2]|0)|0;i=b;return}function nF(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d+12|0;c[e>>2]=b;c[f>>2]=c[(c[e>>2]|0)+76>>2];a[g>>0]=0;if(c[(c[e>>2]|0)+152>>2]&1024){Db[c[(c[(c[e>>2]|0)+12>>2]|0)+16>>2]&31](135825,d);wb(1)}if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)!=0:0){Bb[c[(c[f>>2]|0)+8>>2]&127](c[e>>2]|0);a[g>>0]=1}if(a[g>>0]|0){i=d;return}lF(c[e>>2]|0)|0;uF(c[e>>2]|0);i=d;return}function oF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+1072|0;f=e;g=e+32|0;h=e+28|0;j=e+40|0;k=e+24|0;l=e+8|0;m=e+4|0;c[g>>2]=a;c[h>>2]=b;c[m>>2]=j;c[l>>2]=d;c[k>>2]=q3(j,1024,c[h>>2]|0,l)|0;if((c[k>>2]|0)>>>0<0){c[f>>2]=M1(c[(L1()|0)>>2]|0)|0;$z(1,135842,f)|0;i=e;return}if((c[k>>2]|0)>>>0>=1024){c[m>>2]=cK((c[k>>2]|0)+1|0)|0;c[l>>2]=d;c[k>>2]=r3(c[m>>2]|0,c[h>>2]|0,l)|0}iF(c[g>>2]|0,c[m>>2]|0,c[k>>2]|0)|0;if((c[m>>2]|0)==(j|0)){i=e;return}O4(c[m>>2]|0);i=e;return}function pF(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d;g=d+12|0;j=d+8|0;c[e>>2]=a;h[f>>3]=b;c[g>>2]=vF(j,+h[f>>3])|0;iF(c[e>>2]|0,c[g>>2]|0,c[j>>2]|0)|0;i=d;return}function qF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=vF(g,+h[b>>3])|0;iF(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0)|0;iF(c[e>>2]|0,140232,1)|0;c[f>>2]=vF(g,+h[b+8>>3])|0;iF(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0)|0;i=d;return}function rF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){d=c[g>>2]|0;b=(c[h>>2]|0)+(c[k>>2]<<4)|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];qF(d,f);d=(c[k>>2]|0)+1|0;c[k>>2]=d;if((d|0)>=(c[j>>2]|0))break;iF(c[g>>2]|0,140232,1)|0}i=e;return}function sF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+128|0;e=d;f=d+20|0;g=d+24|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;c[f>>2]=b;if(c[(c[f>>2]|0)+24>>2]|0){c[e>>2]=(c[(c[f>>2]|0)+24>>2]|0)+1;k3(g,135923,e)|0}else a[g>>0]=0;e=c[(c[f>>2]|0)+20>>2]|0;c[h>>2]=e;c[h>>2]=(e|0)!=0?e:135927;e=N3(c[h>>2]|0)|0;b=e+(N3(g)|0)+1|0;c[l>>2]=b+(N3(c[(c[f>>2]|0)+52>>2]|0)|0)+1;if((c[13531]|0)>>>0<(c[l>>2]|0)>>>0){c[13531]=(c[l>>2]|0)+10;c[13532]=Q4(c[13532]|0,c[13531]|0)|0}K3(c[13532]|0,c[h>>2]|0)|0;G3(c[13532]|0,g)|0;G3(c[13532]|0,193388)|0;c[j>>2]=M3(c[(c[f>>2]|0)+52>>2]|0)|0;while(1){g=S3(c[j>>2]|0,58)|0;c[k>>2]=g;m=c[13532]|0;if(!g)break;G3(m,(c[k>>2]|0)+1|0)|0;G3(c[13532]|0,193388)|0;a[c[k>>2]>>0]=0}G3(m,c[j>>2]|0)|0;O4(c[j>>2]|0);c[(c[f>>2]|0)+32>>2]=c[13532];i=d;return}function tF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;e=c[j>>2]|0;if(c[(c[c[j>>2]>>2]|0)+104>>2]|0){c[h>>2]=Hb[c[(c[e>>2]|0)+104>>2]&63](c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;m=c[h>>2]|0;i=f;return m|0}if(!(c[e+40>>2]|0)){c[h>>2]=h3(c[k>>2]|0,1,c[l>>2]|0,c[(c[j>>2]|0)+36>>2]|0)|0;m=c[h>>2]|0;i=f;return m|0}if((c[l>>2]|0)>>>0>((c[(c[j>>2]|0)+44>>2]|0)-((c[(c[j>>2]|0)+48>>2]|0)+1)|0)>>>0?(c[(c[j>>2]|0)+44>>2]=(c[(c[j>>2]|0)+48>>2]|0)+(c[l>>2]|0)+1+4095&-4096,e=Q4(c[(c[j>>2]|0)+40>>2]|0,c[(c[j>>2]|0)+44>>2]|0)|0,c[(c[j>>2]|0)+40>>2]=e,(c[(c[j>>2]|0)+40>>2]|0)==0):0){Db[c[(c[(c[j>>2]|0)+12>>2]|0)+16>>2]&31](135896,g);wb(1)}Z4((c[(c[j>>2]|0)+40>>2]|0)+(c[(c[j>>2]|0)+48>>2]|0)|0,c[k>>2]|0,c[l>>2]|0)|0;k=(c[j>>2]|0)+48|0;c[k>>2]=(c[k>>2]|0)+(c[l>>2]|0);a[(c[(c[j>>2]|0)+40>>2]|0)+(c[(c[j>>2]|0)+48>>2]|0)>>0]=0;c[h>>2]=c[l>>2];m=c[h>>2]|0;i=f;return m|0}function uF(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if(!(c[(c[e>>2]|0)+32>>2]|0)){i=d;return}if((c[(c[e>>2]|0)+36>>2]|0)==(c[24744]|0)){i=d;return}if(a[(c[e>>2]|0)+144>>0]|0){i=d;return}if(c[(c[e>>2]|0)+36>>2]|0){R2(c[(c[e>>2]|0)+36>>2]|0)|0;c[(c[e>>2]|0)+36>>2]=0}c[(c[e>>2]|0)+32>>2]=0;i=d;return}function vF(b,e){b=b|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+28|0;j=f+24|0;k=f;l=f+20|0;m=f+16|0;n=f+33|0;o=f+32|0;p=f+12|0;q=f+8|0;c[j>>2]=b;h[k>>3]=e;c[l>>2]=135876;if(+h[k>>3]<+h[4216]){c[c[j>>2]>>2]=19;c[g>>2]=135876;r=c[g>>2]|0;i=f;return r|0}if(+h[k>>3]>-+h[4216]){c[c[j>>2]>>2]=18;c[g>>2]=135877;r=c[g>>2]|0;i=f;return r|0}h[k>>3]=+h[k>>3]*100.0;e=+h[k>>3];if(+h[k>>3]<0.0)c[m>>2]=~~(e-.5);else c[m>>2]=~~(e+.5);if(!(c[m>>2]|0)){c[c[j>>2]>>2]=1;c[g>>2]=176099;r=c[g>>2]|0;i=f;return r|0}k=(c[m>>2]|0)<0&255;a[o>>0]=k;if(k<<24>>24)c[m>>2]=0-(c[m>>2]|0);a[n>>0]=0;c[q>>2]=2;while(1){if(!((c[m>>2]|0)!=0?1:(c[q>>2]|0)>0))break;c[p>>2]=(c[m>>2]|0)%10|0;c[m>>2]=(c[m>>2]|0)/10|0;if(!((c[p>>2]|0)==0?(d[n>>0]|0)==0:0)){k=(c[p>>2]|48)&255;b=(c[l>>2]|0)+-1|0;c[l>>2]=b;a[b>>0]=k;a[n>>0]=1}if((c[q>>2]|0)==1){if(a[n>>0]|0){k=(c[l>>2]|0)+-1|0;c[l>>2]=k;a[k>>0]=46}a[n>>0]=1}c[q>>2]=(c[q>>2]|0)+-1}if(a[o>>0]|0){o=(c[l>>2]|0)+-1|0;c[l>>2]=o;a[o>>0]=45}c[c[j>>2]>>2]=135876-(c[l>>2]|0);c[g>>2]=c[l>>2];r=c[g>>2]|0;i=f;return r|0}function wF(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+176|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+8|0;r=j+4|0;s=j;t=j+104|0;u=j+40|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;Q3(t,c[m>>2]|0,63)|0;h=H3(t,58)|0;c[s>>2]=h;if(h)a[c[s>>2]>>0]=0;c[r>>2]=(c[k>>2]|0)+60+(c[l>>2]<<2);while(1){if(!(c[c[r>>2]>>2]|0))break;Q3(u,c[(c[c[r>>2]>>2]|0)+4>>2]|0,63)|0;l=H3(u,58)|0;c[s>>2]=l;if(l)a[c[s>>2]>>0]=0;if((J3(t,u)|0)<=0)break;c[r>>2]=c[c[r>>2]>>2]}while(1){if(!(c[c[r>>2]>>2]|0))break;Q3(u,c[(c[c[r>>2]>>2]|0)+4>>2]|0,63)|0;l=H3(u,58)|0;c[s>>2]=l;if(l)a[c[s>>2]>>0]=0;if(J3(t,u)|0)break;if((c[n>>2]|0)>=(c[(c[c[r>>2]>>2]|0)+8>>2]|0))break;c[r>>2]=c[c[r>>2]>>2]}c[q>>2]=cK(20)|0;c[c[q>>2]>>2]=c[c[r>>2]>>2];c[c[r>>2]>>2]=c[q>>2];c[(c[q>>2]|0)+4>>2]=c[m>>2];c[(c[q>>2]|0)+8>>2]=c[n>>2];c[(c[q>>2]|0)+12>>2]=c[o>>2];c[(c[q>>2]|0)+16>>2]=c[p>>2];i=j;return 1}function xF(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;c[d+8>>2]=a;c[d+4>>2]=b;$z(1,135937,d)|0;i=d;return 0}function yF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;f=i;i=i+208|0;g=f+8|0;h=f;j=f+68|0;k=f+64|0;l=f+60|0;m=f+56|0;n=f+52|0;o=f+48|0;p=f+44|0;q=f+40|0;r=f+136|0;s=f+72|0;t=f+36|0;u=f+32|0;v=f+28|0;w=f+24|0;x=f+20|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[u>>2]=0;if((c[k>>2]|0)==3|(c[k>>2]|0)==4)c[x>>2]=0;else c[x>>2]=c[k>>2];Q3(r,c[l>>2]|0,63)|0;c[t>>2]=H3(r,58)|0;if(c[t>>2]|0){l=c[t>>2]|0;c[t>>2]=l+1;a[l>>0]=0;c[v>>2]=H3(c[t>>2]|0,58)|0;if(c[v>>2]|0){l=c[v>>2]|0;c[v>>2]=l+1;a[l>>0]=0}}else c[v>>2]=0;c[m>>2]=(c[j>>2]|0)+60+(c[k>>2]<<2);a:while(1){if(!(c[c[m>>2]>>2]|0))break;Q3(s,c[(c[c[m>>2]>>2]|0)+4>>2]|0,63)|0;c[u>>2]=H3(s,58)|0;if(c[u>>2]|0){l=c[u>>2]|0;c[u>>2]=l+1;a[l>>0]=0}do if(!(J3(s,r)|0)){if((c[u>>2]|0)!=0&(c[t>>2]|0)!=0?(J3(c[u>>2]|0,c[t>>2]|0)|0)!=0:0)break;if((c[v>>2]|0)!=0?(J3(c[v>>2]|0,c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+8>>2]|0)|0)!=0:0)break;if(!(c[u>>2]|0))break a;if((c[x>>2]|0)==(c[k>>2]|0))break a;if(yF(c[j>>2]|0,c[x>>2]|0,c[u>>2]|0)|0)break a}while(0);c[m>>2]=c[c[m>>2]>>2]}c[n>>2]=c[c[m>>2]>>2];if(((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+16>>2]|0)==0:0)?(c[o>>2]=xF(c[j>>2]|0,c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]|0)|0,(c[o>>2]|0)!=0):0){c[p>>2]=c[(c[o>>2]|0)+4>>2];while(1){m=c[(c[p>>2]|0)+4>>2]|0;c[q>>2]=m;if(!m)break;c[w>>2]=0;while(1){if(!(c[(c[q>>2]|0)+((c[w>>2]|0)*20|0)+4>>2]|0))break;AF(c[j>>2]|0,c[c[p>>2]>>2]|0,c[(c[q>>2]|0)+((c[w>>2]|0)*20|0)+4>>2]|0,c[c[o>>2]>>2]|0,c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]|0,(c[q>>2]|0)+((c[w>>2]|0)*20|0)|0)|0;c[w>>2]=(c[w>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+8}if((c[(c[j>>2]|0)+8>>2]|0)>=1){p=c[24742]|0;if(c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]|0)y=c[(c[(c[n>>2]|0)+12>>2]|0)+4>>2]|0;else y=135968;c[h>>2]=y;Y2(p,135978,h)|0}}if((c[n>>2]|0)!=0?(c[(c[n>>2]|0)+16>>2]|0)==0:0)c[n>>2]=0;if(!(c[n>>2]|0)){z=c[n>>2]|0;A=c[k>>2]|0;B=c[j>>2]|0;C=B+80|0;D=C+(A<<2)|0;c[D>>2]=z;E=c[n>>2]|0;i=f;return E|0}if((c[(c[j>>2]|0)+8>>2]|0)<1){z=c[n>>2]|0;A=c[k>>2]|0;B=c[j>>2]|0;C=B+80|0;D=C+(A<<2)|0;c[D>>2]=z;E=c[n>>2]|0;i=f;return E|0}h=c[24742]|0;p=c[(c[n>>2]|0)+4>>2]|0;y=c[(c[(c[n>>2]|0)+12>>2]|0)+8>>2]|0;c[g>>2]=c[54132+(c[k>>2]<<2)>>2];c[g+4>>2]=p;c[g+8>>2]=y;Y2(h,136008,g)|0;z=c[n>>2]|0;A=c[k>>2]|0;B=c[j>>2]|0;C=B+80|0;D=C+(A<<2)|0;c[D>>2]=z;E=c[n>>2]|0;i=f;return E|0}function zF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+40|0;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f;s=f+44|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;a[s>>0]=1;if(!(c[k>>2]|0)){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}if(c[13538]|0){dA(54156,0,0);c[13538]=0}c[o>>2]=M3(c[k>>2]|0)|0;c[p>>2]=H3(c[o>>2]|0,58)|0;if(c[p>>2]|0){k=c[p>>2]|0;c[p>>2]=k+1;a[k>>0]=0}c[m>>2]=(c[h>>2]|0)+60+(c[j>>2]<<2);a:do if(c[p>>2]|0){c[l>>2]=c[m>>2];while(1){if(!(c[c[l>>2]>>2]|0))break a;c[q>>2]=M3(c[(c[c[l>>2]>>2]|0)+4>>2]|0)|0;j=H3(c[q>>2]|0,58)|0;c[p>>2]=j;if(j){j=c[p>>2]|0;c[p>>2]=j+1;a[j>>0]=0}if(!((a[c[o>>2]>>0]|0)!=0?(F3(c[o>>2]|0,c[q>>2]|0)|0)!=0:0)){if((c[13540]|0)>>>0>=(c[13541]|0)>>>0)eA(54156,1)|0;j=c[13540]|0;c[13540]=j+1;a[j>>0]=32;gA(54156,c[(c[c[l>>2]>>2]|0)+4>>2]|0)|0;if((c[13540]|0)>>>0>=(c[13541]|0)>>>0)eA(54156,1)|0;j=c[13540]|0;c[13540]=j+1;a[j>>0]=58;gA(54156,c[(c[(c[c[l>>2]>>2]|0)+12>>2]|0)+8>>2]|0)|0;a[s>>0]=0}O4(c[q>>2]|0);c[l>>2]=c[c[l>>2]>>2]}}while(0);O4(c[o>>2]|0);if(a[s>>0]|0){c[r>>2]=0;c[l>>2]=c[m>>2];while(1){if(!(c[c[l>>2]>>2]|0))break;c[q>>2]=M3(c[(c[c[l>>2]>>2]|0)+4>>2]|0)|0;m=H3(c[q>>2]|0,58)|0;c[p>>2]=m;if(m){m=c[p>>2]|0;c[p>>2]=m+1;a[m>>0]=0}if(!((c[r>>2]|0)!=0?(F3(c[r>>2]|0,c[q>>2]|0)|0)==0:0)){if((c[13540]|0)>>>0>=(c[13541]|0)>>>0)eA(54156,1)|0;m=c[13540]|0;c[13540]=m+1;a[m>>0]=32;gA(54156,c[q>>2]|0)|0;a[s>>0]=0}if(!(c[r>>2]|0))O4(c[r>>2]|0);c[r>>2]=c[q>>2];c[l>>2]=c[c[l>>2]>>2]}if(!(c[r>>2]|0))O4(c[r>>2]|0)}if(a[s>>0]|0)c[n>>2]=178518;else{if((c[13540]|0)>>>0>=(c[13541]|0)>>>0)eA(54156,1)|0;s=c[13540]|0;c[13540]=s+1;a[s>>0]=0;s=c[13539]|0;c[13540]=s;c[n>>2]=s}c[g>>2]=c[n>>2];t=c[g>>2]|0;i=f;return t|0}function AF(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+32|0;k=j+28|0;l=j+24|0;m=j+20|0;n=j+16|0;o=j+12|0;p=j+8|0;q=j+4|0;r=j;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=(c[l>>2]|0)+60+(c[m>>2]<<2);while(1){if(!(c[c[r>>2]>>2]|0)){s=9;break}if((((F3(c[n>>2]|0,c[(c[c[r>>2]>>2]|0)+4>>2]|0)|0)==0?(F3(c[o>>2]|0,c[(c[(c[c[r>>2]>>2]|0)+12>>2]|0)+8>>2]|0)|0)==0:0)?(c[(c[(c[c[r>>2]>>2]|0)+12>>2]|0)+4>>2]|0)!=0:0)?(F3(c[p>>2]|0,c[(c[(c[c[r>>2]>>2]|0)+12>>2]|0)+4>>2]|0)|0)==0:0){s=7;break}c[r>>2]=c[c[r>>2]>>2]}if((s|0)==7){c[(c[c[r>>2]>>2]|0)+16>>2]=c[q>>2];a[k>>0]=1;t=a[k>>0]|0;i=j;return t|0}else if((s|0)==9){a[k>>0]=0;t=a[k>>0]|0;i=j;return t|0}return 0}function BF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;if(!(c[f>>2]|0))La(148770,136056,577,136070);if(!(a[c[f>>2]>>0]|0))La(148775,136056,578,136070);if(c[13543]|0){c[g>>2]=Hb[c[c[13543]>>2]&63](c[13543]|0,c[f>>2]|0,512)|0;c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}return 0}function CF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+8|0;f=d;g=d+24|0;h=d+20|0;j=d+16|0;c[h>>2]=b;if(!(c[h>>2]|0))La(148874,136056,593,136087);if(!(c[(c[h>>2]|0)+8>>2]|0))La(148877,136056,594,136087);if(!(a[c[(c[h>>2]|0)+8>>2]>>0]|0))La(148886,136056,595,136087);b=c[h>>2]|0;do if(!(c[(c[h>>2]|0)+20>>2]|0)){k=sO(c[b+8>>2]|0)|0;c[j>>2]=k;if(!k){c[f>>2]=c[(c[h>>2]|0)+8>>2];$z(0,136111,f)|0;a[g>>0]=0;l=a[g>>0]|0;i=d;return l|0}k=X2(c[j>>2]|0,176526)|0;c[(c[h>>2]|0)+20>>2]=k;if(!(c[(c[h>>2]|0)+20>>2]|0)){k=M1(c[(L1()|0)>>2]|0)|0;m=c[j>>2]|0;c[e>>2]=k;c[e+4>>2]=m;$z(0,136136,e)|0;a[g>>0]=0;l=a[g>>0]|0;i=d;return l|0}if((c[13544]|0)>=50){a[(c[h>>2]|0)+17>>0]=1;break}else{c[13544]=(c[13544]|0)+1;break}}else c3(c[b+20>>2]|0,0,0)|0;while(0);if(!(c[(c[h>>2]|0)+20>>2]|0))La(136157,136056,618,136087);a[g>>0]=1;l=a[g>>0]|0;i=d;return l|0}function DF(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if(!(a[(c[e>>2]|0)+17>>0]|0)){i=d;return}if(!(c[(c[e>>2]|0)+20>>2]|0)){i=d;return}R2(c[(c[e>>2]|0)+20>>2]|0)|0;c[(c[e>>2]|0)+20>>2]=0;i=d;return}function EF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0;e=i;i=i+16|0;f=e+8|0;g=e;c[f>>2]=b;if(!(c[f>>2]|0)){c[g+4>>2]=-1;c[g>>2]=-1;c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];i=e;return}if(c[(c[f>>2]|0)+48>>2]|0){j=+(c[(c[f>>2]|0)+48>>2]|0);h[d+8>>3]=j;h[d>>3]=j}c[g>>2]=~~(+((c[(c[f>>2]|0)+40>>2]|0)*72|0)/+h[d>>3]);c[g+4>>2]=~~(+((c[(c[f>>2]|0)+44>>2]|0)*72|0)/+h[d+8>>3]);c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];i=e;return}function FF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;f=i;i=i+64|0;g=f+16|0;j=f+60|0;k=f+56|0;l=f+48|0;m=f;n=f+40|0;o=f+32|0;c[j>>2]=d;c[k>>2]=e;if((c[k>>2]|0)!=0?(a[c[k>>2]>>0]|0)!=0:0){if(((c[13794]|0)==0?(c[13545]|0)!=(c[13793]|0):0)?(c[13545]=c[13793],(c[13543]|0)!=0):0){Jz(c[13543]|0)|0;c[13543]=0}p=+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3];h[m+8>>3]=p;j=m+8|0;if(p>=1.0)h[m>>3]=+h[j>>3];else{h[j>>3]=96.0;h[m>>3]=96.0}c[n>>2]=GF(c[k>>2]|0)|0;k=c[n>>2]|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];EF(o,k,g);c[l>>2]=c[o>>2];c[l+4>>2]=c[o+4>>2];c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];i=f;return}c[l+4>>2]=-1;c[l>>2]=-1;c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];i=f;return}function GF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=b+12|0;f=b+8|0;g=b+4|0;c[f>>2]=a;if(!(c[f>>2]|0))La(148770,136056,636,136163);if(!(c[13543]|0))c[13543]=Nz(54184,c[12993]|0)|0;a=BF(c[f>>2]|0)|0;c[g>>2]=a;if(a){DF(c[g>>2]|0);c[e>>2]=c[g>>2];h=c[e>>2]|0;i=b;return h|0}a=bK(64)|0;c[g>>2]=a;if(!a){c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}a=YC(0,c[f>>2]|0)|0;c[(c[g>>2]|0)+8>>2]=a;if(!((CF(c[g>>2]|0)|0)<<24>>24)){c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}if(!(c[(c[g>>2]|0)+20>>2]|0))La(136157,136056,649,136163);do switch(HF(c[g>>2]|0)|0){case 0:{a=fM(c[(c[g>>2]|0)+8>>2]|0)|0;c[(c[g>>2]|0)+52>>2]=a;if(!a){c[d>>2]=c[(c[g>>2]|0)+8>>2];$z(0,136180,d)|0}O4(c[g>>2]|0);c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}case 2:{IF(c[g>>2]|0);break}case 3:{JF(c[g>>2]|0);break}case 1:{KF(c[g>>2]|0);break}case 4:{LF(c[g>>2]|0);break}case 6:{MF(c[g>>2]|0);break}case 11:{NF(c[g>>2]|0);break}case 8:{OF(c[g>>2]|0);break}case 5:{PF(c[g>>2]|0);break}case 12:{QF(c[g>>2]|0);break}default:{}}while(0);DF(c[g>>2]|0);Hb[c[c[13543]>>2]&63](c[13543]|0,c[g>>2]|0,1)|0;c[e>>2]=c[g>>2];h=c[e>>2]|0;i=b;return h|0}function HF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+240|0;d=b+8|0;e=b+4|0;f=b+216|0;g=b+16|0;h=b;c[e>>2]=a;a:do if((c[(c[e>>2]|0)+20>>2]|0)!=0?($2(f,1,20,c[(c[e>>2]|0)+20>>2]|0)|0)==20:0){c[h>>2]=0;while(1){if((c[h>>2]|0)>>>0>=10)break a;a=(B3(f,c[54260+(c[h>>2]<<4)>>2]|0,c[54260+(c[h>>2]<<4)+4>>2]|0)|0)!=0;j=c[h>>2]|0;if(!a)break;c[h>>2]=j+1}c[(c[e>>2]|0)+28>>2]=c[54260+(j<<4)+12>>2];c[(c[e>>2]|0)+24>>2]=c[54260+(c[h>>2]<<4)+8>>2];b:do if((c[(c[e>>2]|0)+24>>2]|0)!=9){if((c[(c[e>>2]|0)+24>>2]|0)==10?(B3(f+8|0,136396,4)|0)==0:0){c[(c[e>>2]|0)+28>>2]=136401;c[(c[e>>2]|0)+24>>2]=11;c[d>>2]=11;k=c[d>>2]|0;i=b;return k|0}}else{do if(!(V2(g,200,c[(c[e>>2]|0)+20>>2]|0)|0))break b;while((B3(g,136391,4)|0)!=0);c[(c[e>>2]|0)+28>>2]=139648;c[(c[e>>2]|0)+24>>2]=8;c[d>>2]=8;k=c[d>>2]|0;i=b;return k|0}while(0);c[d>>2]=c[(c[e>>2]|0)+24>>2];k=c[d>>2]|0;i=b;return k|0}while(0);c[(c[e>>2]|0)+28>>2]=136406;c[(c[e>>2]|0)+24>>2]=0;c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}function IF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[(c[d>>2]|0)+48>>2]=0;c3(c[(c[d>>2]|0)+20>>2]|0,6,0)|0;if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,2,e)|0)&255)){i=b;return}if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,2,f)|0)&255)){i=b;return}c[(c[d>>2]|0)+40>>2]=c[e>>2];c[(c[d>>2]|0)+44>>2]=c[f>>2];i=b;return}function JF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[(c[d>>2]|0)+48>>2]=0;c3(c[(c[d>>2]|0)+20>>2]|0,16,0)|0;if(!((RF(c[(c[d>>2]|0)+20>>2]|0,4,e)|0)&255)){i=b;return}if(!((RF(c[(c[d>>2]|0)+20>>2]|0,4,f)|0)&255)){i=b;return}c[(c[d>>2]|0)+40>>2]=c[e>>2];c[(c[d>>2]|0)+44>>2]=c[f>>2];i=b;return}function KF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[(c[d>>2]|0)+48>>2]=0;c3(c[(c[d>>2]|0)+20>>2]|0,16,0)|0;if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,2,e)|0)&255)){i=b;return}if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,2,f)|0)&255)){i=b;return}if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,2,g)|0)&255)){i=b;return}if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,2,h)|0)&255)){i=b;return}c[(c[d>>2]|0)+40>>2]=c[e>>2]<<16|c[f>>2];c[(c[d>>2]|0)+44>>2]=c[g>>2]<<16|c[h>>2];i=b;return}function LF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[(c[d>>2]|0)+48>>2]=0;while(1){if(!((RF(c[(c[d>>2]|0)+20>>2]|0,1,e)|0)<<24>>24)){k=17;break}if((c[e>>2]|0)==255)continue;if(H3(136379,c[e>>2]|0)|0)continue;if((c[e>>2]|0)==192){k=6;break}l=c[(c[d>>2]|0)+20>>2]|0;if((c[e>>2]|0)==194){k=11;break}if(!((RF(l,2,f)|0)<<24>>24)){k=17;break}c3(c[(c[d>>2]|0)+20>>2]|0,(c[f>>2]|0)-2|0,1)|0}if((k|0)==6){if(!((RF(c[(c[d>>2]|0)+20>>2]|0,3,j)|0)&255)){i=b;return}if(!((RF(c[(c[d>>2]|0)+20>>2]|0,2,g)|0)&255)){i=b;return}if(!((RF(c[(c[d>>2]|0)+20>>2]|0,2,h)|0)&255)){i=b;return}c[(c[d>>2]|0)+44>>2]=c[g>>2];c[(c[d>>2]|0)+40>>2]=c[h>>2];i=b;return}else if((k|0)==11){if(!((RF(l,3,j)|0)<<24>>24)){i=b;return}if(!((RF(c[(c[d>>2]|0)+20>>2]|0,2,g)|0)&255)){i=b;return}if(!((RF(c[(c[d>>2]|0)+20>>2]|0,2,h)|0)&255)){i=b;return}c[(c[d>>2]|0)+44>>2]=c[g>>2];c[(c[d>>2]|0)+40>>2]=c[h>>2];i=b;return}else if((k|0)==17){i=b;return}}function MF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+1072|0;e=d;f=d+36|0;g=d+48|0;h=d+40|0;j=d+32|0;k=d+28|0;l=d+24|0;m=d+20|0;n=d+16|0;c[f>>2]=b;c[(c[f>>2]|0)+48>>2]=72;c3(c[(c[f>>2]|0)+20>>2]|0,0,0)|0;a[h>>0]=0;while(1){if(!(V2(g,1024,c[(c[f>>2]|0)+20>>2]|0)|0))break;b=U3(g,136364)|0;c[n>>2]=b;if(!b)continue;b=c[n>>2]|0;c[e>>2]=j;c[e+4>>2]=k;c[e+8>>2]=l;c[e+12>>2]=m;if((l3(b,142173,e)|0)==4){o=5;break}}if((o|0)==5)a[h>>0]=1;if(!(a[h>>0]|0)){i=d;return}c[(c[f>>2]|0)+32>>2]=c[j>>2];c[(c[f>>2]|0)+36>>2]=c[k>>2];c[(c[f>>2]|0)+40>>2]=(c[l>>2]|0)-(c[j>>2]|0);c[(c[f>>2]|0)+44>>2]=(c[m>>2]|0)-(c[k>>2]|0);i=d;return}function NF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[(c[d>>2]|0)+48>>2]=0;c3(c[(c[d>>2]|0)+20>>2]|0,15,0)|0;a=(U2(c[(c[d>>2]|0)+20>>2]|0)|0)==88;g=c[(c[d>>2]|0)+20>>2]|0;if(a){c3(g,24,0)|0;if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,4,e)|0)&255)){i=b;return}if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,4,f)|0)&255)){i=b;return}c[(c[d>>2]|0)+40>>2]=c[e>>2];c[(c[d>>2]|0)+44>>2]=c[f>>2];i=b;return}else{c3(g,26,0)|0;if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,2,e)|0)&255)){i=b;return}if(!((ZF(c[(c[d>>2]|0)+20>>2]|0,2,f)|0)&255)){i=b;return}c[(c[d>>2]|0)+40>>2]=c[e>>2];c[(c[d>>2]|0)+44>>2]=c[f>>2];i=b;return}}function OF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;d=i;i=i+384|0;e=d+80|0;f=d+72|0;g=d+64|0;j=d+56|0;k=d+48|0;l=d+40|0;m=d+148|0;n=d+144|0;o=d+140|0;p=d+32|0;q=d+24|0;r=d+16|0;s=d+8|0;t=d;u=d+360|0;v=d+136|0;w=d+132|0;x=d+128|0;y=d+160|0;z=d+153|0;A=d+152|0;B=d+96|0;c[m>>2]=b;c[n>>2]=0;c[o>>2]=0;a[z>>0]=0;a[A>>0]=0;if(!(c[13555]|0)){if(w2(54228,c[13556]|0,1)|0){c[l>>2]=c[13556];$z(1,136249,l)|0}c[13555]=54228}c3(c[(c[m>>2]|0)+20>>2]|0,0,0)|0;a:while(1){if(!(V2(y,200,c[(c[m>>2]|0)+20>>2]|0)|0)){C=26;break}if((a[z>>0]|0)!=0?!((a[A>>0]|0)!=0^1):0){C=26;break}c[x>>2]=y;while(1){if(y2(54228,c[x>>2]|0,4,B,0)|0)continue a;a[(c[x>>2]|0)+(c[B+8+4>>2]|0)>>0]=0;a[(c[x>>2]|0)+(c[B+16+4>>2]|0)>>0]=0;c[v>>2]=(c[x>>2]|0)+(c[B+8>>2]|0);c[w>>2]=(c[x>>2]|0)+(c[B+16>>2]|0);c[x>>2]=(c[x>>2]|0)+((c[B+4>>2]|0)+1);if(!(J3(c[v>>2]|0,179125)|0)){l=c[w>>2]|0;c[k>>2]=p;c[k+4>>2]=u;if((l3(l,136286,k)|0)!=2){l=c[w>>2]|0;c[j>>2]=p;if((l3(l,139001,j)|0)==1){c[n>>2]=YF(+h[p>>3],136293)|0;a[z>>0]=1}}else{c[n>>2]=YF(+h[p>>3],u)|0;a[z>>0]=1}if(a[A>>0]|0)continue a;else continue}if(J3(c[v>>2]|0,179057)|0){if(J3(c[v>>2]|0,136296)|0)continue;l=c[w>>2]|0;c[e>>2]=q;c[e+4>>2]=r;c[e+8>>2]=s;c[e+12>>2]=t;if((l3(l,136304,e)|0)==4)break;else continue}l=c[w>>2]|0;c[g>>2]=p;c[g+4>>2]=u;if((l3(l,136286,g)|0)!=2){l=c[w>>2]|0;c[f>>2]=p;if((l3(l,139001,f)|0)==1){c[o>>2]=YF(+h[p>>3],136293)|0;a[A>>0]=1}}else{c[o>>2]=YF(+h[p>>3],u)|0;a[A>>0]=1}if(a[z>>0]|0)continue a}c[n>>2]=~~(+h[s>>3]-+h[q>>3]+1.0)>>>0;c[o>>2]=~~(+h[t>>3]-+h[r>>3]+1.0)>>>0;a[z>>0]=1;a[A>>0]=1}if((C|0)==26){c[(c[m>>2]|0)+48>>2]=0;c[(c[m>>2]|0)+40>>2]=c[n>>2];c[(c[m>>2]|0)+44>>2]=c[o>>2];i=d;return}}function PF(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+48|0;d=b+32|0;e=b;c[d>>2]=a;c[(c[d>>2]|0)+48>>2]=0;c3(c[(c[d>>2]|0)+20>>2]|0,0,0)|0;if(SF(c[(c[d>>2]|0)+20>>2]|0,e)|0){i=b;return}c[(c[d>>2]|0)+32>>2]=~~+h[e>>3];c[(c[d>>2]|0)+36>>2]=~~+h[e+8>>3];c[(c[d>>2]|0)+40>>2]=~~(+h[e+16>>3]-+h[e>>3]);c[(c[d>>2]|0)+44>>2]=~~(+h[e+16+8>>3]-+h[e+8>>3]);i=b;return}function QF(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[(c[d>>2]|0)+48>>2]=0;c3(c[(c[d>>2]|0)+20>>2]|0,6,0)|0;if(!((RF(c[(c[d>>2]|0)+20>>2]|0,1,e)|0)&255)){i=b;return}if(!((RF(c[(c[d>>2]|0)+20>>2]|0,1,f)|0)&255)){i=b;return}c[(c[d>>2]|0)+40>>2]=c[e>>2];c[(c[d>>2]|0)+44>>2]=c[f>>2];i=b;return}function RF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[c[k>>2]>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>>>0>=(c[j>>2]|0)>>>0){n=6;break}c[l>>2]=U2(c[h>>2]|0)|0;if(S2(c[h>>2]|0)|0){n=4;break}e=c[k>>2]|0;c[e>>2]=c[e>>2]<<8;e=c[k>>2]|0;c[e>>2]=c[e>>2]|c[l>>2];c[m>>2]=(c[m>>2]|0)+1}if((n|0)==4){a[g>>0]=0;o=a[g>>0]|0;i=f;return o|0}else if((n|0)==6){a[g>>0]=1;o=a[g>>0]|0;i=f;return o|0}return 0}function SF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+1056|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+4|0;j=d;k=d+32|0;c[f>>2]=a;c[g>>2]=b;while(1){if(!(V2(k,1024,c[f>>2]|0)|0)){l=5;break}b=U3(k,136239)|0;c[j>>2]=b;if(b){l=4;break}}if((l|0)==4){c[h+4>>2]=k;c[h>>2]=(c[j>>2]|0)+9;c[h+8>>2]=c[f>>2];c[e>>2]=TF(h,c[g>>2]|0)|0;m=c[e>>2]|0;i=d;return m|0}else if((l|0)==5){c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}return 0}function TF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1040|0;f=e+8|0;g=e+4|0;h=e;j=e+16|0;c[g>>2]=b;c[h>>2]=d;UF(c[g>>2]|0);d=c[g>>2]|0;if(a[c[c[g>>2]>>2]>>0]|0)k=a[c[d>>2]>>0]|0;else k=(VF(d)|0)&255;do if((k|0)==91){d=c[g>>2]|0;c[d>>2]=(c[d>>2]|0)+1;WF(c[g>>2]|0,j);if(XF(j,c[h>>2]|0)|0){c[f>>2]=1;break}WF(c[g>>2]|0,j);if(XF(j,(c[h>>2]|0)+8|0)|0){c[f>>2]=1;break}WF(c[g>>2]|0,j);if(XF(j,(c[h>>2]|0)+16|0)|0){c[f>>2]=1;break}WF(c[g>>2]|0,j);if(XF(j,(c[h>>2]|0)+16+8|0)|0){c[f>>2]=1;break}else{c[f>>2]=0;break}}else c[f>>2]=1;while(0);i=e;return c[f>>2]|0}function UF(b){b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;g=e+4|0;c[f>>2]=b;while(1){b=c[f>>2]|0;if(a[c[c[f>>2]>>2]>>0]|0)h=a[c[b>>2]>>0]|0;else h=(VF(b)|0)&255;b=h&255;a[g>>0]=b;if(!(b<<24>>24)){j=8;break}if(!(r1(d[g>>0]|0)|0)){j=8;break}b=c[f>>2]|0;c[b>>2]=(c[b>>2]|0)+1}if((j|0)==8){i=e;return}}function VF(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;if(V2(c[(c[f>>2]|0)+4>>2]|0,1024,c[(c[f>>2]|0)+8>>2]|0)|0){c[c[f>>2]>>2]=c[(c[f>>2]|0)+4>>2];a[e>>0]=a[c[c[f>>2]>>2]>>0]|0;g=a[e>>0]|0;i=d;return g|0}else{a[e>>0]=0;g=a[e>>0]|0;i=d;return g|0}return 0}function WF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[f>>2]=b;c[g>>2]=d;c[h>>2]=0;UF(c[f>>2]|0);do{d=c[f>>2]|0;if(a[c[c[f>>2]>>2]>>0]|0)k=a[c[d>>2]>>0]|0;else k=(VF(d)|0)&255;d=k&255;a[j>>0]=d;if(!(d<<24>>24))break;if((p1(a[j>>0]|0)|0)==0?(a[j>>0]|0)!=46:0)break;d=a[j>>0]|0;b=c[h>>2]|0;c[h>>2]=b+1;a[(c[g>>2]|0)+b>>0]=d;d=c[f>>2]|0;c[d>>2]=(c[d>>2]|0)+1}while((c[h>>2]|0)!=1023);a[(c[g>>2]|0)+(c[h>>2]|0)>>0]=0;i=e;return}function XF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;j=d+8|0;k=d;c[f>>2]=a;c[g>>2]=b;h[k>>3]=+x3(c[f>>2]|0,j);if((c[f>>2]|0)==(c[j>>2]|0)){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}else{h[c[g>>2]>>3]=+h[k>>3];c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}return 0}function YF(a,b){a=+a;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d;g=d+8|0;h[f>>3]=a;c[g>>2]=b;if(!(J3(c[g>>2]|0,136320)|0)){a=+h[f>>3]*72.0;c[e>>2]=~~(+h[f>>3]*72.0>=0.0?a+.5:a-.5);j=c[e>>2]|0;i=d;return j|0}if(!(J3(c[g>>2]|0,136323)|0)){a=+h[f>>3]*72.0/96.0;c[e>>2]=~~(+h[f>>3]*72.0/96.0>=0.0?a+.5:a-.5);j=c[e>>2]|0;i=d;return j|0}if(!(J3(c[g>>2]|0,136326)|0)){a=+h[f>>3]*72.0/6.0;c[e>>2]=~~(+h[f>>3]*72.0/6.0>=0.0?a+.5:a-.5);j=c[e>>2]|0;i=d;return j|0}if((J3(c[g>>2]|0,136293)|0)!=0?(J3(c[g>>2]|0,136329)|0)!=0:0){if(!(J3(c[g>>2]|0,136331)|0)){a=+h[f>>3]*28.346456664;c[e>>2]=~~(+h[f>>3]*28.346456664>=0.0?a+.5:a-.5);j=c[e>>2]|0;i=d;return j|0}if(!(J3(c[g>>2]|0,136334)|0)){a=+h[f>>3]*2.8346456663999997;c[e>>2]=~~(+h[f>>3]*2.8346456663999997>=0.0?a+.5:a-.5);j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}}a=+h[f>>3];c[e>>2]=~~(+h[f>>3]>=0.0?a+.5:a-.5);j=c[e>>2]|0;i=d;return j|0}function ZF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[c[k>>2]>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>>>0>=(c[j>>2]|0)>>>0){n=6;break}c[l>>2]=U2(c[h>>2]|0)|0;if(S2(c[h>>2]|0)|0){n=4;break}e=c[k>>2]|0;c[e>>2]=c[e>>2]|c[l>>2]<<(c[m>>2]<<3);c[m>>2]=(c[m>>2]|0)+1}if((n|0)==4){a[g>>0]=0;o=a[g>>0]|0;i=f;return o|0}else if((n|0)==6){a[g>>0]=1;o=a[g>>0]|0;i=f;return o|0}return 0}function _F(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=c[f>>2];if(c[(c[g>>2]|0)+20>>2]|0)R2(c[(c[g>>2]|0)+20>>2]|0)|0;if(!(c[(c[g>>2]|0)+52>>2]|0)){h=c[g>>2]|0;O4(h);i=e;return}if(!(c[(c[g>>2]|0)+60>>2]|0)){h=c[g>>2]|0;O4(h);i=e;return}Bb[c[(c[g>>2]|0)+60>>2]&127](c[g>>2]|0);h=c[g>>2]|0;O4(h);i=e;return}function $F(){var a=0,b=0;a=i;i=i+16|0;b=a;qA(0,1,147656,143955)|0;c[b>>2]=FR(0,1)|0;nS(c[b>>2]|0,0);i=a;return c[b>>2]|0}function aG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0;f=i;i=i+320|0;g=f+24|0;j=f+8|0;k=f;l=f+56|0;m=f+52|0;n=f+48|0;o=f+44|0;p=f+64|0;q=f+40|0;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[q>>2]=eF(c[m>>2]|0,c[o>>2]|0)|0;if((c[q>>2]|0)==999){q=c[o>>2]|0;e=zF(c[m>>2]|0,1,c[o>>2]|0)|0;c[k>>2]=q;c[k+4>>2]=e;$z(1,136511,k)|0;c[l>>2]=-1;r=c[l>>2]|0;i=f;return r|0}if((fF(c[m>>2]|0,c[n>>2]|0)|0)==-1){c[l>>2]=-1;r=c[l>>2]|0;i=f;return r|0}m=(c[(c[n>>2]|0)+8>>2]|0)+16|0;if(a[(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)+81>>0]|0){s=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3];t=+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3];k=~~(+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3]>=0.0?t+.5:t-.5);t=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+16+8>>3];e=~~(+h[(c[(c[n>>2]|0)+8>>2]|0)+16+16+8>>3]>=0.0?t+.5:t-.5);t=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+16>>3];q=~~(+h[(c[(c[n>>2]|0)+8>>2]|0)+16+16>>3]>=0.0?t+.5:t-.5);c[j>>2]=~~(+h[m+8>>3]>=0.0?s+.5:s-.5);c[j+4>>2]=k;c[j+8>>2]=e;c[j+12>>2]=q;k3(p,136560,j)|0}else{s=+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3];t=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3];j=~~(+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3]>=0.0?t+.5:t-.5);t=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+16>>3];q=~~(+h[(c[(c[n>>2]|0)+8>>2]|0)+16+16>>3]>=0.0?t+.5:t-.5);t=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+16+8>>3];e=~~(+h[(c[(c[n>>2]|0)+8>>2]|0)+16+16+8>>3]>=0.0?t+.5:t-.5);c[g>>2]=~~(+h[m>>3]>=0.0?s+.5:s-.5);c[g+4>>2]=j;c[g+8>>2]=q;c[g+12>>2]=e;k3(p,136560,g)|0}CA(c[n>>2]|0,140294,p,178518)|0;c[l>>2]=0;r=c[l>>2]|0;i=f;return r|0}function bG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+8|0;h=f;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[l>>2]=c[(c[l>>2]|0)+48>>2];c[o>>2]=(HR(c[k>>2]|0,c[m>>2]|0)|0)&255;c[p>>2]=c[(c[k>>2]|0)+164>>2];if((c[o>>2]|0)==999){e=c[m>>2]|0;d=zF(c[k>>2]|0,3,c[m>>2]|0)|0;c[h>>2]=e;c[h+4>>2]=d;$z(1,136572,h)|0;c[j>>2]=-1;q=c[j>>2]|0;i=f;return q|0}h=QQ(c[p>>2]|0,c[(c[p>>2]|0)+52>>2]|0)|0;c[(c[p>>2]|0)+56>>2]=h;if(!((MC(c[l>>2]|0,175049,0,1)|0)!=0?(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0))r=5;if((r|0)==5?(c[(c[p>>2]|0)+152>>2]&67108864|0)==0:0){aA(136616,g);c[j>>2]=-1;q=c[j>>2]|0;i=f;return q|0}GR(c[k>>2]|0,c[n>>2]|0);c[o>>2]=LH(c[k>>2]|0,c[l>>2]|0)|0;SQ(c[p>>2]|0);nF(c[p>>2]|0);MR(c[k>>2]|0);c[j>>2]=c[o>>2];q=c[j>>2]|0;i=f;return q|0}function cG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+64|0;h=g+16|0;j=g+8|0;k=g;l=g+48|0;m=g+44|0;n=g+40|0;o=g+36|0;p=g+32|0;q=g+28|0;r=g+24|0;s=g+20|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[n>>2]=c[(c[n>>2]|0)+48>>2];c[r>>2]=(HR(c[m>>2]|0,c[o>>2]|0)|0)&255;c[s>>2]=c[(c[m>>2]|0)+164>>2];if((c[r>>2]|0)==999){f=c[o>>2]|0;e=zF(c[m>>2]|0,3,c[o>>2]|0)|0;c[k>>2]=f;c[k+4>>2]=e;$z(1,136572,k)|0;c[l>>2]=-1;t=c[l>>2]|0;i=g;return t|0}k=QQ(c[s>>2]|0,c[(c[s>>2]|0)+52>>2]|0)|0;c[(c[s>>2]|0)+56>>2]=k;if(!((MC(c[n>>2]|0,175049,0,1)|0)!=0?(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0))u=5;if((u|0)==5?(c[(c[s>>2]|0)+152>>2]&67108864|0)==0:0){aA(136616,j);c[l>>2]=-1;t=c[l>>2]|0;i=g;return t|0}if((c[p>>2]|0)!=0?(j=N4(4096)|0,c[c[p>>2]>>2]=j,(j|0)!=0):0){c[(c[s>>2]|0)+40>>2]=c[c[p>>2]>>2];c[(c[s>>2]|0)+44>>2]=4096;c[(c[s>>2]|0)+48>>2]=0;c[r>>2]=LH(c[m>>2]|0,c[n>>2]|0)|0;SQ(c[s>>2]|0);if(!(c[r>>2]|0)){c[c[p>>2]>>2]=c[(c[s>>2]|0)+40>>2];c[c[q>>2]>>2]=c[(c[s>>2]|0)+48>>2]}MR(c[m>>2]|0);c[l>>2]=c[r>>2];t=c[l>>2]|0;i=g;return t|0}$z(1,136637,h)|0;c[l>>2]=-1;t=c[l>>2]|0;i=g;return t|0}function dG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;mS(c[e>>2]|0,0,c[f>>2]|0);i=d;return}function eG(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ja=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,sa=0,ta=0,ua=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0;h=i;i=i+4288|0;j=h+8|0;k=h;l=4;m=N4(40)|0;c[m>>2]=0;p=h+4152|0;q=h+4148|0;r=h+4128|0;s=h+4112|0;t=h+16|0;n=0;u=ia(24,b|0)|0;v=n;n=0;if((v|0)!=0&(o|0)!=0){w=Y4(c[v>>2]|0,m|0,l|0)|0;if(!w)Pa(v|0,o|0);C=o}else w=-1;a:do if((w|0)!=1){if(!u){c[e>>2]=0;x=0;O4(m|0);i=h;return x|0}n=0;v=va(52,f|0,q|0,p|0,128)|0;y=n;n=0;if((y|0)!=0&(o|0)!=0){z=Y4(c[y>>2]|0,m|0,l|0)|0;if(!z)Pa(y|0,o|0);C=o}else z=-1;if((z|0)!=1){n=0;y=ia(23,4*10|0)|0;A=n;n=0;if((A|0)!=0&(o|0)!=0){B=Y4(c[A>>2]|0,m|0,l|0)|0;if(!B)Pa(A|0,o|0);C=o}else B=-1;if((B|0)!=1){n=0;da(16,r|0,s|0,t|0,19,85);A=n;n=0;if((A|0)!=0&(o|0)!=0){D=Y4(c[A>>2]|0,m|0,l|0)|0;if(!D)Pa(A|0,o|0);C=o}else D=-1;if((D|0)!=1){n=0;A=ia(25,b|0)|0;E=n;n=0;if((E|0)!=0&(o|0)!=0){F=Y4(c[E>>2]|0,m|0,l|0)|0;if(!F)Pa(E|0,o|0);C=o}else F=-1;if((F|0)!=1){E=A;while(1){if(!E)break;n=0;ra(c[r+16>>2]|0,E|0,0)|0;A=n;n=0;if((A|0)!=0&(o|0)!=0){G=Y4(c[A>>2]|0,m|0,l|0)|0;if(!G)Pa(A|0,o|0);C=o}else G=-1;if((G|0)==1){H=C;I=10;J=0;K=y;L=0;M=v;N=0;O=0;break a}n=0;A=ra(86,b|0,E|0)|0;P=n;n=0;if((P|0)!=0&(o|0)!=0){Q=Y4(c[P>>2]|0,m|0,l|0)|0;if(!Q)Pa(P|0,o|0);C=o}else Q=-1;if((Q|0)==1){H=C;I=10;J=0;K=y;L=0;M=v;N=0;O=0;break a}E=A}m=W4(54420,1,m|0,l|0)|0;l=C;n=0;E=n;n=0;if((E|0)!=0&(o|0)!=0){R=Y4(c[E>>2]|0,m|0,l|0)|0;if(!R)Pa(E|0,o|0);C=o}else R=-1;if((R|0)!=1){H=0;I=10;J=0;K=y;L=0;M=v;N=0;O=0}else{H=C;I=10;J=0;K=y;L=0;M=v;N=0;O=0}}else{H=C;I=10;J=0;K=y;L=0;M=v;N=0;O=0}}else{H=C;I=10;J=0;K=y;L=0;M=v;N=0;O=0}}else{H=C;I=10;J=0;K=0;L=0;M=v;N=0;O=0}}else{H=C;I=10;J=0;K=0;L=0;M=0;N=0;O=0}}else{H=C;I=10;J=0;K=0;L=0;M=0;N=0;O=0}while(0);b:while(1){c:do if(H){S=I;T=J;U=K;V=1;W=N;X=O}else{n=0;R=ia(25,b|0)|0;Q=n;n=0;if((Q|0)!=0&(o|0)!=0){Y=Y4(c[Q>>2]|0,m|0,l|0)|0;if(!Y)Pa(Q|0,o|0);C=o}else Y=-1;if((Y|0)==1){Z=M;_=L;$=K;aa=I;H=C;M=Z;L=_;K=$;I=aa;continue b}Q=J;G=R;R=N;F=O;while(1){if(!G)break;n=0;D=ra(c[r+16>>2]|0,G|0,-1)|0;t=n;n=0;if((t|0)!=0&(o|0)!=0){ba=Y4(c[t>>2]|0,m|0,l|0)|0;if(!ba)Pa(t|0,o|0);C=o}else ba=-1;if((ba|0)==1){Z=M;_=L;$=K;aa=I;H=C;J=Q;N=R;O=F;M=Z;L=_;K=$;I=aa;continue b}if((D|0)==0?(d[(c[G+8>>2]|0)+119>>0]|0|0)==3:0){if(R){ca=Q;fa=R;ga=F}else{D=M+(c[q>>2]|0)|0;n=0;c[k>>2]=Q;ka(34,D|0,175023,k|0)|0;D=n;n=0;if((D|0)!=0&(o|0)!=0){ha=Y4(c[D>>2]|0,m|0,l|0)|0;if(!ha)Pa(D|0,o|0);C=o}else ha=-1;if((ha|0)==1){Z=M;_=L;$=K;aa=I;H=C;J=Q;N=R;O=F;M=Z;L=_;K=$;I=aa;continue b}n=0;D=ka(35,b|0,M|0,1)|0;t=n;n=0;if((t|0)!=0&(o|0)!=0){ja=Y4(c[t>>2]|0,m|0,l|0)|0;if(!ja)Pa(t|0,o|0);C=o}else ja=-1;if((ja|0)==1){Z=M;_=L;$=K;aa=I;H=C;J=Q;N=R;O=F;M=Z;L=_;K=$;I=aa;continue b}n=0;va(53,D|0,175049,280,1)|0;t=n;n=0;if((t|0)!=0&(o|0)!=0){la=Y4(c[t>>2]|0,m|0,l|0)|0;if(!la)Pa(t|0,o|0);C=o}else la=-1;if((la|0)==1){Z=M;_=L;$=K;aa=I;H=C;J=Q;N=D;O=F;M=Z;L=_;K=$;I=aa;continue b}c[K+(Q<<2)>>2]=D;ca=Q+1|0;fa=D;ga=1}n=0;va(54,b|0,G|0,fa|0,r|0)|0;D=n;n=0;if((D|0)!=0&(o|0)!=0){ma=Y4(c[D>>2]|0,m|0,l|0)|0;if(!ma)Pa(D|0,o|0);C=o}else ma=-1;if((ma|0)==1){Z=M;_=L;$=K;aa=I;H=C;J=ca;N=fa;O=ga;M=Z;L=_;K=$;I=aa;continue b}na=ca;oa=fa;pa=ga}else{na=Q;oa=R;pa=F}n=0;D=ra(86,b|0,G|0)|0;t=n;n=0;if((t|0)!=0&(o|0)!=0){qa=Y4(c[t>>2]|0,m|0,l|0)|0;if(!qa)Pa(t|0,o|0);C=o}else qa=-1;if((qa|0)==1){Z=M;_=L;$=K;aa=I;H=C;J=na;N=oa;O=pa;M=Z;L=_;K=$;I=aa;continue b}Q=na;G=D;R=oa;F=pa}n=0;G=ia(25,b|0)|0;D=n;n=0;if((D|0)!=0&(o|0)!=0){sa=Y4(c[D>>2]|0,m|0,l|0)|0;if(!sa)Pa(D|0,o|0);C=o}else sa=-1;if((sa|0)==1){Z=M;_=L;$=K;aa=I;H=C;J=Q;N=R;O=F;M=Z;L=_;K=$;I=aa;continue b}D=I;t=Q;s=K;B=G;G=R;while(1){if(!B){S=D;T=t;U=s;V=L;W=G;X=F;break c}n=0;z=ra(c[r+16>>2]|0,B|0,-1)|0;f=n;n=0;if((f|0)!=0&(o|0)!=0){ta=Y4(c[f>>2]|0,m|0,l|0)|0;if(!ta)Pa(f|0,o|0);C=o}else ta=-1;if((ta|0)==1){Z=M;_=L;H=C;I=D;J=t;K=s;N=G;O=F;M=Z;L=_;continue b}if(z){ua=D;wa=t;xa=s;ya=G}else{z=M+(c[q>>2]|0)|0;n=0;c[j>>2]=t;ka(34,z|0,175023,j|0)|0;z=n;n=0;if((z|0)!=0&(o|0)!=0){za=Y4(c[z>>2]|0,m|0,l|0)|0;if(!za)Pa(z|0,o|0);C=o}else za=-1;if((za|0)==1){Z=M;_=L;H=C;I=D;J=t;K=s;N=G;O=F;M=Z;L=_;continue b}n=0;z=ka(35,b|0,M|0,1)|0;f=n;n=0;if((f|0)!=0&(o|0)!=0){Aa=Y4(c[f>>2]|0,m|0,l|0)|0;if(!Aa)Pa(f|0,o|0);C=o}else Aa=-1;if((Aa|0)==1){Z=M;_=L;H=C;I=D;J=t;K=s;N=G;O=F;M=Z;L=_;continue b}n=0;va(53,z|0,175049,280,1)|0;f=n;n=0;if((f|0)!=0&(o|0)!=0){Ba=Y4(c[f>>2]|0,m|0,l|0)|0;if(!Ba)Pa(f|0,o|0);C=o}else Ba=-1;if((Ba|0)==1){Z=M;_=L;H=C;I=D;J=t;K=s;N=z;O=F;M=Z;L=_;continue b}n=0;va(54,b|0,B|0,z|0,r|0)|0;f=n;n=0;if((f|0)!=0&(o|0)!=0){Ca=Y4(c[f>>2]|0,m|0,l|0)|0;if(!Ca)Pa(f|0,o|0);C=o}else Ca=-1;if((Ca|0)==1){Z=M;_=L;H=C;I=D;J=t;K=s;N=z;O=F;M=Z;L=_;continue b}if((t|0)==(D|0)){f=D<<1;n=0;u=ra(87,s|0,f<<2|0)|0;w=n;n=0;if((w|0)!=0&(o|0)!=0){Da=Y4(c[w>>2]|0,m|0,l|0)|0;if(!Da)Pa(w|0,o|0);C=o}else Da=-1;if((Da|0)==1){Z=M;_=L;H=C;I=f;J=t;K=s;N=z;O=F;M=Z;L=_;continue b}Ea=f;Fa=u}else{Ea=D;Fa=s}c[Fa+(t<<2)>>2]=z;ua=Ea;wa=t+1|0;xa=Fa;ya=z}n=0;z=ra(86,b|0,B|0)|0;u=n;n=0;if((u|0)!=0&(o|0)!=0){Ga=Y4(c[u>>2]|0,m|0,l|0)|0;if(!Ga)Pa(u|0,o|0);C=o}else Ga=-1;if((Ga|0)==1){Z=M;_=L;H=C;I=ua;J=wa;K=xa;N=ya;O=F;M=Z;L=_;continue b}D=ua;t=wa;s=xa;B=z;G=ya}}while(0);n=0;ea(99,r|0);v=n;n=0;if((v|0)!=0&(o|0)!=0){Ha=Y4(c[v>>2]|0,m|0,l|0)|0;if(!Ha)Pa(v|0,o|0);C=o}else Ha=-1;if((Ha|0)==1){Z=M;H=C;I=S;J=T;K=U;L=V;N=W;O=X;M=Z;continue}if((M|0)!=(p|0)){n=0;ea(96,M|0);v=n;n=0;if((v|0)!=0&(o|0)!=0){Ia=Y4(c[v>>2]|0,m|0,l|0)|0;if(!Ia)Pa(v|0,o|0);C=o}else Ia=-1;if((Ia|0)==1){Z=M;H=C;I=S;J=T;K=U;L=V;N=W;O=X;M=Z;continue}}if(!V){n=0;Ja=ra(87,U|0,T<<2|0)|0;v=n;n=0;if((v|0)!=0&(o|0)!=0){Ka=Y4(c[v>>2]|0,m|0,l|0)|0;if(!Ka)Pa(v|0,o|0);C=o}else Ka=-1;if((Ka|0)==1){Z=M;H=C;I=S;J=T;K=U;L=V;N=W;O=X;M=Z;continue}else{La=59;break}}c[e>>2]=0;v=0;while(1){if((v|0)>=(T|0))break;n=0;ia(26,c[U+(v<<2)>>2]|0)|0;y=n;n=0;if((y|0)!=0&(o|0)!=0){Ma=Y4(c[y>>2]|0,m|0,l|0)|0;if(!Ma)Pa(y|0,o|0);C=o}else Ma=-1;if((Ma|0)==1){Z=M;H=C;I=S;J=T;K=U;L=V;N=W;O=X;M=Z;continue b}v=v+1|0}n=0;ea(96,U|0);v=n;n=0;if((v|0)!=0&(o|0)!=0){Na=Y4(c[v>>2]|0,m|0,l|0)|0;if(!Na)Pa(v|0,o|0);C=o}else Na=-1;if((Na|0)==1){Z=M;H=C;I=S;J=T;K=U;L=V;N=W;O=X;M=Z}else{La=57;break}}if((La|0)==57)Oa=0;else if((La|0)==59){c[e>>2]=T;a[g>>0]=X;Oa=Ja}x=Oa;O4(m|0);i=h;return x|0}function fG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ga=0,ha=0,ja=0,la=0;e=i;i=i+4272|0;f=e;g=4;h=N4(40)|0;c[h>>2]=0;j=e+4144|0;k=e+4140|0;l=e+4120|0;m=e+4104|0;p=e+8|0;n=0;q=ia(24,a|0)|0;r=n;n=0;if((r|0)!=0&(o|0)!=0){s=Y4(c[r>>2]|0,h|0,g|0)|0;if(!s)Pa(r|0,o|0);C=o}else s=-1;a:do if((s|0)!=1){if(!q){c[b>>2]=0;t=0;O4(h|0);i=e;return t|0}n=0;r=va(52,d|0,k|0,j|0,128)|0;u=n;n=0;if((u|0)!=0&(o|0)!=0){v=Y4(c[u>>2]|0,h|0,g|0)|0;if(!v)Pa(u|0,o|0);C=o}else v=-1;if((v|0)!=1){n=0;u=ia(23,4*10|0)|0;w=n;n=0;if((w|0)!=0&(o|0)!=0){x=Y4(c[w>>2]|0,h|0,g|0)|0;if(!x)Pa(w|0,o|0);C=o}else x=-1;if((x|0)!=1){n=0;da(16,l|0,m|0,p|0,19,85);w=n;n=0;if((w|0)!=0&(o|0)!=0){y=Y4(c[w>>2]|0,h|0,g|0)|0;if(!y)Pa(w|0,o|0);C=o}else y=-1;if((y|0)!=1){n=0;w=ia(25,a|0)|0;z=n;n=0;if((z|0)!=0&(o|0)!=0){A=Y4(c[z>>2]|0,h|0,g|0)|0;if(!A)Pa(z|0,o|0);C=o}else A=-1;if((A|0)!=1){z=w;while(1){if(!z)break;n=0;ra(c[l+16>>2]|0,z|0,0)|0;w=n;n=0;if((w|0)!=0&(o|0)!=0){B=Y4(c[w>>2]|0,h|0,g|0)|0;if(!B)Pa(w|0,o|0);C=o}else B=-1;if((B|0)==1){D=C;E=10;F=0;G=u;H=r;break a}n=0;w=ra(86,a|0,z|0)|0;I=n;n=0;if((I|0)!=0&(o|0)!=0){J=Y4(c[I>>2]|0,h|0,g|0)|0;if(!J)Pa(I|0,o|0);C=o}else J=-1;if((J|0)==1){D=C;E=10;F=0;G=u;H=r;break a}z=w}h=W4(54420,1,h|0,g|0)|0;g=C;n=0;z=n;n=0;if((z|0)!=0&(o|0)!=0){K=Y4(c[z>>2]|0,h|0,g|0)|0;if(!K)Pa(z|0,o|0);C=o}else K=-1;if((K|0)!=1){D=0;E=10;F=0;G=u;H=r}else{D=C;E=10;F=0;G=u;H=r}}else{D=C;E=10;F=0;G=u;H=r}}else{D=C;E=10;F=0;G=u;H=r}}else{D=C;E=10;F=0;G=0;H=r}}else{D=C;E=10;F=0;G=0;H=0}}else{D=C;E=10;F=0;G=0;H=0}while(0);b:while(1){if(D){n=0;ea(99,l|0);K=n;n=0;if((K|0)!=0&(o|0)!=0){L=Y4(c[K>>2]|0,h|0,g|0)|0;if(!L)Pa(K|0,o|0);C=o}else L=-1;if((L|0)==1){M=H;N=G;O=F;P=E;D=C;H=M;G=N;F=O;E=P;continue}n=0;ea(96,G|0);K=n;n=0;if((K|0)!=0&(o|0)!=0){Q=Y4(c[K>>2]|0,h|0,g|0)|0;if(!Q)Pa(K|0,o|0);C=o}else Q=-1;if((Q|0)==1){M=H;N=G;O=F;P=E;D=C;H=M;G=N;F=O;E=P;continue}if((H|0)==(j|0)){R=21;break}n=0;ea(96,H|0);K=n;n=0;if((K|0)!=0&(o|0)!=0){S=Y4(c[K>>2]|0,h|0,g|0)|0;if(!S)Pa(K|0,o|0);C=o}else S=-1;if((S|0)==1){M=H;N=G;O=F;P=E;D=C;H=M;G=N;F=O;E=P;continue}else{R=20;break}}n=0;K=ia(25,a|0)|0;J=n;n=0;if((J|0)!=0&(o|0)!=0){T=Y4(c[J>>2]|0,h|0,g|0)|0;if(!T)Pa(J|0,o|0);C=o}else T=-1;if((T|0)==1){M=H;N=G;O=F;P=E;D=C;H=M;G=N;F=O;E=P;continue}J=E;U=F;B=G;A=K;while(1){if(!A)break;n=0;K=ra(c[l+16>>2]|0,A|0,-1)|0;y=n;n=0;if((y|0)!=0&(o|0)!=0){V=Y4(c[y>>2]|0,h|0,g|0)|0;if(!V)Pa(y|0,o|0);C=o}else V=-1;if((V|0)==1){M=H;D=C;E=J;F=U;G=B;H=M;continue b}if(K){W=J;X=U;Y=B}else{K=H+(c[k>>2]|0)|0;n=0;c[f>>2]=U;ka(34,K|0,175023,f|0)|0;K=n;n=0;if((K|0)!=0&(o|0)!=0){Z=Y4(c[K>>2]|0,h|0,g|0)|0;if(!Z)Pa(K|0,o|0);C=o}else Z=-1;if((Z|0)==1){M=H;D=C;E=J;F=U;G=B;H=M;continue b}n=0;K=ka(35,a|0,H|0,1)|0;y=n;n=0;if((y|0)!=0&(o|0)!=0){_=Y4(c[y>>2]|0,h|0,g|0)|0;if(!_)Pa(y|0,o|0);C=o}else _=-1;if((_|0)==1){M=H;D=C;E=J;F=U;G=B;H=M;continue b}n=0;va(53,K|0,175049,280,1)|0;y=n;n=0;if((y|0)!=0&(o|0)!=0){$=Y4(c[y>>2]|0,h|0,g|0)|0;if(!$)Pa(y|0,o|0);C=o}else $=-1;if(($|0)==1){M=H;D=C;E=J;F=U;G=B;H=M;continue b}n=0;va(54,a|0,A|0,K|0,l|0)|0;y=n;n=0;if((y|0)!=0&(o|0)!=0){aa=Y4(c[y>>2]|0,h|0,g|0)|0;if(!aa)Pa(y|0,o|0);C=o}else aa=-1;if((aa|0)==1){M=H;D=C;E=J;F=U;G=B;H=M;continue b}if((U|0)==(J|0)){y=J<<1;n=0;p=ra(87,B|0,y<<2|0)|0;m=n;n=0;if((m|0)!=0&(o|0)!=0){ba=Y4(c[m>>2]|0,h|0,g|0)|0;if(!ba)Pa(m|0,o|0);C=o}else ba=-1;if((ba|0)==1){M=H;D=C;E=y;F=U;G=B;H=M;continue b}ca=y;fa=p}else{ca=J;fa=B}c[fa+(U<<2)>>2]=K;W=ca;X=U+1|0;Y=fa}n=0;K=ra(86,a|0,A|0)|0;p=n;n=0;if((p|0)!=0&(o|0)!=0){ga=Y4(c[p>>2]|0,h|0,g|0)|0;if(!ga)Pa(p|0,o|0);C=o}else ga=-1;if((ga|0)==1){M=H;D=C;E=W;F=X;G=Y;H=M;continue b}J=W;U=X;B=Y;A=K}n=0;ea(99,l|0);A=n;n=0;if((A|0)!=0&(o|0)!=0){ha=Y4(c[A>>2]|0,h|0,g|0)|0;if(!ha)Pa(A|0,o|0);C=o}else ha=-1;if((ha|0)==1){M=H;D=C;E=J;F=U;G=B;H=M;continue}n=0;A=G;G=ra(87,B|0,U<<2|0)|0;A=n;n=0;if((A|0)!=0&(o|0)!=0){ja=Y4(c[A>>2]|0,h|0,g|0)|0;if(!ja)Pa(A|0,o|0);C=o}else ja=-1;if((ja|0)==1){M=H;D=C;E=J;F=U;G=B;H=M;continue}if((H|0)==(j|0)){R=42;break}n=0;ea(96,H|0);A=n;n=0;if((A|0)!=0&(o|0)!=0){la=Y4(c[A>>2]|0,h|0,g|0)|0;if(!la)Pa(A|0,o|0);C=o}else la=-1;if((la|0)!=1){R=41;break}else{M=H;D=C;E=J;F=U;H=M}}if((R|0)==20)R=21;else if((R|0)==41)R=42;if((R|0)==21){c[b>>2]=0;t=0;O4(h|0);i=e;return t|0}else if((R|0)==42){c[b>>2]=U;t=G;O4(h|0);i=e;return t|0}return 0}function gG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=0;c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[h>>2]=OA(c[f>>2]|0,c[g>>2]|0)|0;while(1){k=c[e>>2]|0;if(!(c[h>>2]|0))break;b=c[h>>2]|0;if(eC(k,c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,0)|0){YA(c[e>>2]|0,c[h>>2]|0,1)|0;c[j>>2]=(c[j>>2]|0)+1}c[h>>2]=QA(c[f>>2]|0,c[h>>2]|0)|0}c[g>>2]=aC(k,c[g>>2]|0)|0}i=d;return c[j>>2]|0}function hG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+4368|0;g=f+24|0;h=f+8|0;j=f;k=f+4228|0;l=f+4224|0;m=f+4220|0;n=f+4216|0;o=f+4212|0;p=f+4208|0;q=f+4204|0;r=f+4200|0;s=f+4196|0;t=f+4192|0;u=f+4188|0;v=f+4184|0;w=f+4232|0;x=f+4180|0;y=f+4160|0;z=f+44|0;A=f+40|0;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[A>>2]=12;if(!(kB(c[l>>2]|0)|0)){c[c[m>>2]>>2]=0;c[k>>2]=0;B=c[k>>2]|0;i=f;return B|0}OC(c[l>>2]|0,0,136674,0-(c[A>>2]|0)|0,0);OC(c[l>>2]|0,1,136686,16,0);c[s>>2]=jG(c[n>>2]|0,z,w,128)|0;c[o>>2]=pG(c[l>>2]|0)|0;c[x>>2]=cK((kB(c[o>>2]|0)|0)<<2)|0;mG(y,f+4144|0,f+48|0,19,88);c[q>>2]=0;c[v>>2]=$B(c[o>>2]|0)|0;while(1){if(!(c[v>>2]|0))break;if(!(Ob[c[y+16>>2]&127](c[v>>2]|0,-1)|0)){n=(c[s>>2]|0)+(c[z>>2]|0)|0;c[j>>2]=c[q>>2];k3(n,137605,j)|0;c[u>>2]=FD(c[o>>2]|0,c[s>>2]|0,1)|0;c[t>>2]=FD(c[l>>2]|0,c[s>>2]|0,1)|0;MC(c[t>>2]|0,136674,12,0)|0;a[(LC(c[t>>2]|0,136674,0)|0)+8>>0]=1;c[p>>2]=nG(c[o>>2]|0,c[v>>2]|0,c[u>>2]|0,y)|0;rG(c[u>>2]|0,c[t>>2]|0);c[r>>2]=iG(c[t>>2]|0)|0;sG(c[l>>2]|0,c[t>>2]|0);c[(c[x>>2]|0)+(c[q>>2]<<2)>>2]=c[t>>2];pC(c[o>>2]|0,c[u>>2]|0)|0;if(a[138998]|0){n=c[24742]|0;A=c[p>>2]|0;e=c[r>>2]|0;c[h>>2]=c[q>>2];c[h+4>>2]=A;c[h+8>>2]=e;Y2(n,136698,h)|0}c[q>>2]=(c[q>>2]|0)+1}c[v>>2]=aC(c[o>>2]|0,c[v>>2]|0)|0}if(a[138998]|0){v=c[24742]|0;h=kB(c[l>>2]|0)|0;r=lB(c[l>>2]|0)|0;p=c[q>>2]|0;u=wB(c[l>>2]|0)|0;c[g>>2]=h;c[g+4>>2]=r;c[g+8>>2]=p;c[g+12>>2]=u;Y2(v,136728,g)|0}jB(c[o>>2]|0)|0;PC(c[l>>2]|0,0,136674);PC(c[l>>2]|0,1,136686);oG(y);c[x>>2]=eK(c[x>>2]|0,c[q>>2]<<2)|0;if((c[s>>2]|0)!=(w|0))O4(c[s>>2]|0);c[c[m>>2]>>2]=c[q>>2];c[k>>2]=c[x>>2];B=c[k>>2]|0;i=f;return B|0}function iG(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=gG(c[d>>2]|0,c[(c[d>>2]|0)+48>>2]|0)|0;i=b;return a|0}function jG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!((c[h>>2]|0)!=0?(zG(c[h>>2]|0)|0)!=0:0))c[h>>2]=136864;c[m>>2]=N3(c[h>>2]|0)|0;if(((c[m>>2]|0)+25|0)>(c[l>>2]|0)){l=cK((c[m>>2]|0)+25|0)|0;c[n>>2]=l;if(!l){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}}else c[n>>2]=c[k>>2];K3(c[n>>2]|0,c[h>>2]|0)|0;c[c[j>>2]>>2]=c[m>>2];c[g>>2]=c[n>>2];o=c[g>>2]|0;i=f;return o|0}function kG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;eC(c[f>>2]|0,c[e>>2]|0,1)|0;i=d;return}function lG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;d=a[(c[(c[g>>2]|0)+8>>2]|0)+157>>0]|0;if((c[h>>2]|0)<0){c[f>>2]=d;k=c[f>>2]|0;i=e;return k|0}else{c[j>>2]=d;a[(c[(c[g>>2]|0)+8>>2]|0)+157>>0]=c[h>>2];c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}return 0}function mG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[c[j>>2]>>2]=c[k>>2];c[(c[j>>2]|0)+4>>2]=(c[c[j>>2]>>2]|0)+4096;c[(c[j>>2]|0)+12>>2]=0;c[(c[j>>2]|0)+8>>2]=0;k=c[j>>2]|0;c[c[h>>2]>>2]=k;c[(c[h>>2]|0)+4>>2]=k;c[(c[h>>2]|0)+8>>2]=c[c[(c[h>>2]|0)+4>>2]>>2];c[(c[h>>2]|0)+12>>2]=c[l>>2];c[(c[h>>2]|0)+16>>2]=c[m>>2];i=g;return}function nG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[n>>2]=0;xG(c[k>>2]|0,c[h>>2]|0);a:while(1){e=yG(c[k>>2]|0)|0;c[h>>2]=e;o=c[n>>2]|0;if(!e)break;c[n>>2]=o+1;if(c[(c[k>>2]|0)+12>>2]|0)Db[c[(c[k>>2]|0)+12>>2]&31](c[h>>2]|0,c[j>>2]|0);c[l>>2]=TA(c[g>>2]|0,c[h>>2]|0)|0;while(1){if(!(c[l>>2]|0))continue a;e=c[l>>2]|0;d=c[((c[c[l>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0;c[m>>2]=d;if((d|0)==(c[h>>2]|0)){d=c[l>>2]|0;c[m>>2]=c[((c[c[l>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]}if(!(Ob[c[(c[k>>2]|0)+16>>2]&127](c[m>>2]|0,-1)|0))xG(c[k>>2]|0,c[m>>2]|0);c[l>>2]=UA(c[g>>2]|0,c[l>>2]|0,c[h>>2]|0)|0}}i=f;return o|0}function oG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=c[(c[c[d>>2]>>2]|0)+12>>2];while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[(c[e>>2]|0)+12>>2];wG(c[e>>2]|0);c[e>>2]=c[f>>2]}i=b;return}function pG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+28|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b+8|0;k=b+4|0;l=b;c[e>>2]=a;c[d>>2]=c[13068];c[f>>2]=gB(136775,d,0)|0;vG(c[f>>2]|0,c[e>>2]|0);c[h>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;if(!(c[(LC(c[h>>2]|0,136686,0)|0)+12>>2]|0)){d=c[f>>2]|0;c[g>>2]=fC(d,wB(c[h>>2]|0)|0,1)|0;MC(c[g>>2]|0,136686,16,1)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]=c[h>>2];d=c[g>>2]|0;c[(LC(c[h>>2]|0,136686,0)|0)+12>>2]=d}c[h>>2]=aC(c[e>>2]|0,c[h>>2]|0)|0}c[h>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;c[l>>2]=c[(LC(c[h>>2]|0,136686,0)|0)+12>>2];c[j>>2]=OA(c[e>>2]|0,c[h>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;g=c[j>>2]|0;c[k>>2]=c[((c[c[j>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2];c[k>>2]=c[(LC(c[k>>2]|0,136686,0)|0)+12>>2];do if((c[k>>2]|0)!=(c[l>>2]|0)){g=c[f>>2]|0;if((c[k>>2]|0)>>>0>(c[l>>2]|0)>>>0){VA(g,c[l>>2]|0,c[k>>2]|0,0,1)|0;break}else{VA(g,c[k>>2]|0,c[l>>2]|0,0,1)|0;break}}while(0);c[j>>2]=QA(c[e>>2]|0,c[j>>2]|0)|0}c[h>>2]=aC(c[e>>2]|0,c[h>>2]|0)|0}i=b;return c[f>>2]|0}function qG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;d=a[(c[(c[g>>2]|0)+8>>2]|0)+8>>0]|0;if((c[h>>2]|0)<0){c[f>>2]=d;k=c[f>>2]|0;i=e;return k|0}else{c[j>>2]=d;a[(c[(c[g>>2]|0)+8>>2]|0)+8>>0]=c[h>>2];c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}return 0}function rG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;a:do if((c[c[(c[(c[h>>2]|0)+8>>2]|0)+12>>2]>>2]&3|0)==1)eC(c[f>>2]|0,c[(c[(c[h>>2]|0)+8>>2]|0)+12>>2]|0,1)|0;else{c[j>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+12>>2];c[g>>2]=$B(c[j>>2]|0)|0;while(1){if(!(c[g>>2]|0))break a;eC(c[f>>2]|0,c[g>>2]|0,1)|0;c[g>>2]=aC(c[j>>2]|0,c[g>>2]|0)|0}}while(0);c[h>>2]=aC(c[e>>2]|0,c[h>>2]|0)|0}i=d;return}function sG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;tG(c[e>>2]|0,c[f>>2]|0,0);i=d;return}function tG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[k>>2]=GD(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;if((a[(LC(c[k>>2]|0,136674,0)|0)+8>>0]|0)==0?(g=uG(c[k>>2]|0,c[h>>2]|0,c[j>>2]|0)|0,c[l>>2]=g,(g|0)!=0):0){if(c[j>>2]|0)n=1;else n=(P3(wB(c[k>>2]|0)|0,145613,7)|0)==0;c[m>>2]=n&1;tG(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)}c[k>>2]=HD(c[k>>2]|0)|0}i=f;return}function uG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;c[k>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;d=c[g>>2]|0;b=fC(d,wB(c[k>>2]|0)|0,0)|0;c[l>>2]=b;if(b){if(!(c[j>>2]|0)){b=c[g>>2]|0;c[j>>2]=FD(b,wB(c[f>>2]|0)|0,1)|0}eC(c[j>>2]|0,c[l>>2]|0,1)|0}c[k>>2]=aC(c[f>>2]|0,c[k>>2]|0)|0}if((c[j>>2]|0)==0&(c[h>>2]|0)!=0){h=c[g>>2]|0;c[j>>2]=FD(h,wB(c[f>>2]|0)|0,1)|0}if(!(c[j>>2]|0)){m=c[j>>2]|0;i=e;return m|0}gG(c[j>>2]|0,c[f>>2]|0)|0;DA(c[f>>2]|0,c[j>>2]|0)|0;m=c[j>>2]|0;i=e;return m|0}function vG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=GD(c[g>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;g=(P3(wB(c[h>>2]|0)|0,145613,7)|0)==0;b=c[f>>2]|0;a=c[h>>2]|0;a:do if(g){c[j>>2]=fC(b,wB(a)|0,1)|0;MC(c[j>>2]|0,136686,16,1)|0;c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2]=c[h>>2];c[k>>2]=$B(c[h>>2]|0)|0;while(1){if(!(c[k>>2]|0))break a;if(c[(LC(c[k>>2]|0,136686,0)|0)+12>>2]|0){l=c[24742]|0;m=wB(c[k>>2]|0)|0;n=wB(c[h>>2]|0)|0;o=wB(c[(LC(c[k>>2]|0,136686,0)|0)+12>>2]|0)|0;c[e>>2]=m;c[e+4>>2]=n;c[e+8>>2]=o;Y2(l,136778,e)|0}l=c[j>>2]|0;c[(LC(c[k>>2]|0,136686,0)|0)+12>>2]=l;c[k>>2]=aC(c[h>>2]|0,c[k>>2]|0)|0}}else vG(b,a);while(0);c[h>>2]=HD(c[h>>2]|0)|0}i=d;return}function wG(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[d>>2]>>2]|0);O4(c[d>>2]|0);i=b;return}function xG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+32|0;e=d+8|0;f=d;g=d+20|0;h=d+16|0;j=d+12|0;c[g>>2]=a;c[h>>2]=b;if((c[(c[g>>2]|0)+8>>2]|0)!=(c[(c[(c[g>>2]|0)+4>>2]|0)+4>>2]|0)){k=c[g>>2]|0;l=k+16|0;m=c[l>>2]|0;n=c[h>>2]|0;Ob[m&127](n,1)|0;o=c[h>>2]|0;p=c[g>>2]|0;q=p+8|0;r=c[q>>2]|0;s=r+4|0;c[q>>2]=s;c[r>>2]=o;i=d;return}do if(!(c[(c[(c[g>>2]|0)+4>>2]|0)+12>>2]|0)){c[j>>2]=cK(16)|0;if(!(c[j>>2]|0)){$z(1,136845,f)|0;Pa(54420,1)}c[(c[j>>2]|0)+8>>2]=c[(c[g>>2]|0)+4>>2];c[(c[j>>2]|0)+12>>2]=0;b=cK(4e6)|0;c[c[j>>2]>>2]=b;if(!(c[c[j>>2]>>2]|0)){$z(1,136845,e)|0;Pa(54420,1)}else{c[(c[j>>2]|0)+4>>2]=(c[c[j>>2]>>2]|0)+4e6;c[(c[(c[g>>2]|0)+4>>2]|0)+12>>2]=c[j>>2];break}}while(0);c[(c[g>>2]|0)+4>>2]=c[(c[(c[g>>2]|0)+4>>2]|0)+12>>2];c[(c[g>>2]|0)+8>>2]=c[c[(c[g>>2]|0)+4>>2]>>2];k=c[g>>2]|0;l=k+16|0;m=c[l>>2]|0;n=c[h>>2]|0;Ob[m&127](n,1)|0;o=c[h>>2]|0;p=c[g>>2]|0;q=p+8|0;r=c[q>>2]|0;s=r+4|0;c[q>>2]=s;c[r>>2]=o;i=d;return}function yG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;do if((c[(c[e>>2]|0)+8>>2]|0)==(c[c[(c[e>>2]|0)+4>>2]>>2]|0)){if((c[(c[e>>2]|0)+4>>2]|0)!=(c[c[e>>2]>>2]|0)){c[(c[e>>2]|0)+4>>2]=c[(c[(c[e>>2]|0)+4>>2]|0)+8>>2];c[(c[e>>2]|0)+8>>2]=c[(c[(c[e>>2]|0)+4>>2]|0)+4>>2];break}c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}while(0);a=(c[e>>2]|0)+8|0;c[a>>2]=(c[a>>2]|0)+-4;c[d>>2]=c[c[(c[e>>2]|0)+8>>2]>>2];f=c[d>>2]|0;i=b;return f|0}function zG(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;h=e+8|0;c[g>>2]=b;while(1){b=c[g>>2]|0;c[g>>2]=b+1;j=a[b>>0]|0;a[h>>0]=j;if(!(j<<24>>24)){k=6;break}if((d[h>>0]|0|0)==95)continue;if(!(l1(d[h>>0]|0)|0)){k=5;break}}if((k|0)==5){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else if((k|0)==6){c[f>>2]=1;l=c[f>>2]|0;i=e;return l|0}return 0}function AG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;e=i;i=i+64|0;f=e+52|0;g=e+48|0;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e+20|0;q=e+16|0;r=e+12|0;s=e+8|0;t=e+4|0;u=e;c[f>>2]=d;v=+h[a>>3];c[g>>2]=~~(+h[a>>3]>=0.0?v+.5:v-.5);v=+h[a+8>>3];c[j>>2]=~~(+h[a+8>>3]>=0.0?v+.5:v-.5);v=+h[b>>3];c[k>>2]=~~(+h[b>>3]>=0.0?v+.5:v-.5);v=+h[b+8>>3];c[l>>2]=~~(+h[b+8>>3]>=0.0?v+.5:v-.5);c[t>>2]=(c[k>>2]|0)-(c[g>>2]|0);b=c[t>>2]|0;c[p>>2]=((c[t>>2]|0)>=0?b:0-b|0)<<1;c[r>>2]=(c[t>>2]|0)<0?-1:1;c[u>>2]=(c[l>>2]|0)-(c[j>>2]|0);t=c[u>>2]|0;c[q>>2]=((c[u>>2]|0)>=0?t:0-t|0)<<1;c[s>>2]=(c[u>>2]|0)<0?-1:1;c[n>>2]=c[g>>2];c[o>>2]=c[j>>2];if((c[p>>2]|0)>(c[q>>2]|0)){c[m>>2]=(c[q>>2]|0)-(c[p>>2]>>1);while(1){YK(c[f>>2]|0,c[n>>2]|0,c[o>>2]|0);if((c[n>>2]|0)==(c[k>>2]|0))break;if((c[m>>2]|0)>=0){c[o>>2]=(c[o>>2]|0)+(c[s>>2]|0);c[m>>2]=(c[m>>2]|0)-(c[p>>2]|0)}c[n>>2]=(c[n>>2]|0)+(c[r>>2]|0);c[m>>2]=(c[m>>2]|0)+(c[q>>2]|0)}i=e;return}else{c[m>>2]=(c[p>>2]|0)-(c[q>>2]>>1);while(1){YK(c[f>>2]|0,c[n>>2]|0,c[o>>2]|0);if((c[o>>2]|0)==(c[l>>2]|0))break;if((c[m>>2]|0)>=0){c[n>>2]=(c[n>>2]|0)+(c[r>>2]|0);c[m>>2]=(c[m>>2]|0)-(c[q>>2]|0)}c[o>>2]=(c[o>>2]|0)+(c[s>>2]|0);c[m>>2]=(c[m>>2]|0)+(c[p>>2]|0)}i=e;return}}function BG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;if((c[j>>2]|0)<=0){c[h>>2]=0;t=c[h>>2]|0;i=f;return t|0}e=c[j>>2]|0;if((c[(c[m>>2]|0)+16>>2]|0)>>>0<=3){c[h>>2]=KG(e,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;t=c[h>>2]|0;i=f;return t|0}c[p>>2]=cK(e<<5)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[j>>2]|0))break;c[q>>2]=c[(c[k>>2]|0)+(c[n>>2]<<2)>>2];BO(c[q>>2]|0);e=(c[p>>2]|0)+(c[n>>2]<<5)|0;l=(c[(c[q>>2]|0)+8>>2]|0)+16|0;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];c[e+16>>2]=c[l+16>>2];c[e+20>>2]=c[l+20>>2];c[e+24>>2]=c[l+24>>2];c[e+28>>2]=c[l+28>>2];c[n>>2]=(c[n>>2]|0)+1}if((c[(c[m>>2]|0)+16>>2]|0)==4){a:do if(c[(c[m>>2]|0)+28>>2]&2){q=bK(c[j>>2]<<2)|0;c[(c[m>>2]|0)+24>>2]=q;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[j>>2]|0))break a;c[s>>2]=yA(c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]|0,136869)|0;if((c[s>>2]|0)!=0?(q=c[s>>2]|0,c[g>>2]=o,l=(l3(q,175023,g)|0)>0,l&(c[o>>2]|0)>=0):0)c[(c[(c[m>>2]|0)+24>>2]|0)+(c[n>>2]<<2)>>2]=c[o>>2];c[n>>2]=(c[n>>2]|0)+1}}while(0);c[r>>2]=LG(c[j>>2]|0,c[p>>2]|0,c[m>>2]|0)|0;if(c[(c[m>>2]|0)+28>>2]&2)O4(c[(c[m>>2]|0)+24>>2]|0)}O4(c[p>>2]|0);c[h>>2]=c[r>>2];t=c[h>>2]|0;i=f;return t|0}function CG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if((c[g>>2]|0)<=0)c[f>>2]=0;else{if((c[(c[j>>2]|0)+16>>2]|0)!=2?(c[(c[j>>2]|0)+16>>2]|0)!=1:0){if((c[(c[j>>2]|0)+16>>2]|0)==3){c[f>>2]=MG(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;break}if((c[(c[j>>2]|0)+16>>2]|0)==4){c[f>>2]=LG(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;break}else{c[f>>2]=0;break}}c[f>>2]=0}while(0);i=e;return c[f>>2]|0}function DG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+80|0;j=g+72|0;k=g+68|0;l=g+64|0;m=g+60|0;n=g+56|0;o=g+52|0;p=g+48|0;q=g+44|0;r=g+40|0;s=g+8|0;t=g;u=g+32|0;v=g+28|0;w=g+24|0;x=g+20|0;y=g+16|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;if((c[k>>2]|0)<=0){c[j>>2]=N(c[k>>2]|0)|0;z=c[j>>2]|0;i=g;return z|0}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[k>>2]|0))break;c[v>>2]=c[(c[l>>2]|0)+(c[p>>2]<<2)>>2];if(c[n>>2]|0)c[w>>2]=c[n>>2];else c[w>>2]=c[v>>2];f=(c[m>>2]|0)+(c[p>>2]<<3)|0;c[u>>2]=c[f>>2];c[u+4>>2]=c[f+4>>2];c[q>>2]=c[u>>2];c[r>>2]=c[u+4>>2];h[s>>3]=+(c[q>>2]|0)/72.0;h[t>>3]=+(c[r>>2]|0)/72.0;c[x>>2]=$B(c[v>>2]|0)|0;while(1){if(!(c[x>>2]|0))break;f=c[(c[(c[x>>2]|0)+8>>2]|0)+132>>2]|0;h[f>>3]=+h[f>>3]+ +h[s>>3];f=(c[(c[(c[x>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[f>>3]=+h[f>>3]+ +h[t>>3];f=(c[(c[x>>2]|0)+8>>2]|0)+16|0;h[f>>3]=+h[f>>3]+ +(c[q>>2]|0);f=(c[(c[x>>2]|0)+8>>2]|0)+16+8|0;h[f>>3]=+h[f>>3]+ +(c[r>>2]|0);if(c[(c[(c[x>>2]|0)+8>>2]|0)+108>>2]|0){f=(c[(c[(c[x>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;h[f>>3]=+h[f>>3]+ +(c[q>>2]|0);f=(c[(c[(c[x>>2]|0)+8>>2]|0)+108>>2]|0)+56+8|0;h[f>>3]=+h[f>>3]+ +(c[r>>2]|0)}a:do if(c[o>>2]|0){c[y>>2]=OA(c[w>>2]|0,c[x>>2]|0)|0;while(1){if(!(c[y>>2]|0))break a;NG(c[y>>2]|0,c[q>>2]|0,c[r>>2]|0);c[y>>2]=QA(c[w>>2]|0,c[y>>2]|0)|0}}while(0);c[x>>2]=aC(c[v>>2]|0,c[x>>2]|0)|0}OG(c[v>>2]|0,c[q>>2]|0,c[r>>2]|0);c[p>>2]=(c[p>>2]|0)+1}c[j>>2]=0;z=c[j>>2]|0;i=g;return z|0}function EG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=BG(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(c[n>>2]|0){c[m>>2]=DG(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,c[k>>2]|0,c[(c[l>>2]|0)+12>>2]|0)|0;O4(c[n>>2]|0);c[g>>2]=c[m>>2];o=c[g>>2]|0;i=f;return o|0}else{c[g>>2]=1;o=c[g>>2]|0;i=f;return o|0}return 0}function FG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0;f=i;i=i+64|0;g=f+60|0;j=f+56|0;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;o=f+36|0;p=f;q=f+32|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=EG(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(c[m>>2]|0){r=c[m>>2]|0;i=f;return r|0}BO(c[k>>2]|0);l=(c[(c[k>>2]|0)+8>>2]|0)+16|0;c[p>>2]=c[l>>2];c[p+4>>2]=c[l+4>>2];c[p+8>>2]=c[l+8>>2];c[p+12>>2]=c[l+12>>2];c[p+16>>2]=c[l+16>>2];c[p+20>>2]=c[l+20>>2];c[p+24>>2]=c[l+24>>2];c[p+28>>2]=c[l+28>>2];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[g>>2]|0))break;c[q>>2]=c[(c[j>>2]|0)+(c[n>>2]<<2)>>2];c[o>>2]=1;while(1){if((c[o>>2]|0)>(c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]|0))break;if(+h[p>>3]<+h[(c[(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0)+8>>2]|0)+16>>3])s=+h[p>>3];else s=+h[(c[(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0)+8>>2]|0)+16>>3];h[p>>3]=s;if(+h[p+8>>3]<+h[(c[(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0)+8>>2]|0)+16+8>>3])t=+h[p+8>>3];else t=+h[(c[(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0)+8>>2]|0)+16+8>>3];h[p+8>>3]=t;if(+h[p+16>>3]>+h[(c[(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0)+8>>2]|0)+16+16>>3])u=+h[p+16>>3];else u=+h[(c[(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0)+8>>2]|0)+16+16>>3];h[p+16>>3]=u;if(+h[p+16+8>>3]>+h[(c[(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0)+8>>2]|0)+16+16+8>>3])v=+h[p+16+8>>3];else v=+h[(c[(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0)+8>>2]|0)+16+16+8>>3];h[p+16+8>>3]=v;c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+1}n=(c[(c[k>>2]|0)+8>>2]|0)+16|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];c[n+16>>2]=c[p+16>>2];c[n+20>>2]=c[p+20>>2];c[n+24>>2]=c[p+24>>2];c[n+28>>2]=c[p+28>>2];r=c[m>>2]|0;i=f;return r|0}function GG(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!(c[m>>2]|0))La(136875,136881,1400,136888);f=JG(c[j>>2]|0,c[l>>2]|0,c[l>>2]|0)|0;c[(c[m>>2]|0)+8>>2]=f;if(a[138998]|0){f=c[24742]|0;c[h>>2]=c[(c[m>>2]|0)+8>>2];Y2(f,136900,h)|0}c[(c[m>>2]|0)+12>>2]=0;c[(c[m>>2]|0)+20>>2]=0;IG(c[j>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;i=g;return c[(c[m>>2]|0)+16>>2]|0}function HG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+80|0;j=f+48|0;k=f+40|0;l=f+32|0;m=f+24|0;n=f+16|0;o=f+8|0;p=f;q=f+68|0;r=f+64|0;s=f+60|0;t=f+56|0;u=f+52|0;c[q>>2]=b;c[r>>2]=d;c[s>>2]=e;if(!(c[s>>2]|0))La(136875,136881,1292,136913);c[(c[s>>2]|0)+28>>2]=0;c[(c[s>>2]|0)+16>>2]=c[r>>2];c[(c[s>>2]|0)+4>>2]=0;c[(c[s>>2]|0)+24>>2]=0;a:do if((c[q>>2]|0)!=0?(a[c[q>>2]>>0]|0)!=0:0)switch(a[c[q>>2]>>0]|0){case 97:{if(!(P3(c[q>>2]|0,136931,5)|0)){c[(c[s>>2]|0)+16>>2]=4;c[q>>2]=(c[q>>2]|0)+5;c[q>>2]=PG(c[q>>2]|0,c[s>>2]|0)|0;r=c[q>>2]|0;c[p>>2]=u;e=(l3(r,175023,p)|0)>0;if(!(e&(c[u>>2]|0)>0))break a;c[(c[s>>2]|0)+4>>2]=c[u>>2];break a}if(P3(c[q>>2]|0,136937,6)|0)break a;c[(c[s>>2]|0)+16>>2]=5;e=(c[q>>2]|0)+5|0;c[o>>2]=t;if((l3(e,136944,o)|0)>0&+g[t>>2]>0.0){g[c[s>>2]>>2]=+g[t>>2];break a}else{g[c[s>>2]>>2]=1.0;break a}break}case 99:{if((a[c[q>>2]>>0]|0)!=(a[145613]|0))break a;if(J3(c[q>>2]|0,145613)|0)break a;c[(c[s>>2]|0)+16>>2]=1;break a;break}case 103:{if((a[c[q>>2]>>0]|0)!=(a[149098]|0))break a;if(J3(c[q>>2]|0,149098)|0)break a;c[(c[s>>2]|0)+16>>2]=3;break a;break}case 110:{if((a[c[q>>2]>>0]|0)!=(a[149084]|0))break a;if(J3(c[q>>2]|0,149084)|0)break a;c[(c[s>>2]|0)+16>>2]=2;break a;break}default:break a}while(0);if(!(a[138998]|0)){v=c[s>>2]|0;w=v+16|0;x=c[w>>2]|0;i=f;return x|0}Y2(c[24742]|0,136947,n)|0;n=c[24742]|0;c[m>>2]=QG(c[(c[s>>2]|0)+16>>2]|0)|0;Y2(n,136959,m)|0;if((c[(c[s>>2]|0)+16>>2]|0)==5){m=c[24742]|0;h[l>>3]=+g[c[s>>2]>>2];Y2(m,136972,l)|0}l=c[24742]|0;c[k>>2]=c[(c[s>>2]|0)+4>>2];Y2(l,136985,k)|0;k=c[24742]|0;c[j>>2]=c[(c[s>>2]|0)+28>>2];Y2(k,136998,j)|0;v=c[s>>2]|0;w=v+16|0;x=c[w>>2]|0;i=f;return x|0}function IG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=yA(c[f>>2]|0,137011)|0;f=HG(d,c[g>>2]|0,c[h>>2]|0)|0;i=e;return f|0}function JG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[n>>2]=c[j>>2];j=yA(c[h>>2]|0,137020)|0;c[l>>2]=j;if(!j){o=c[n>>2]|0;i=f;return o|0}j=c[l>>2]|0;c[g>>2]=m;h=(l3(j,175023,g)|0)==1;if(h&(c[m>>2]|0)>=0){c[n>>2]=c[m>>2];o=c[n>>2]|0;i=f;return o|0}if((a[c[l>>2]>>0]|0)!=116?(a[c[l>>2]>>0]|0)!=84:0){o=c[n>>2]|0;i=f;return o|0}c[n>>2]=c[k>>2];o=c[n>>2]|0;i=f;return o|0}function KG(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0;j=i;i=i+224|0;k=j+208|0;l=j+64|0;m=j+48|0;n=j+40|0;o=j;p=j+200|0;q=j+196|0;r=j+192|0;s=j+188|0;t=j+184|0;u=j+180|0;v=j+176|0;w=j+172|0;x=j+168|0;y=j+164|0;z=j+160|0;A=j+156|0;B=j+152|0;C=j+136|0;D=j+120|0;E=j+112|0;F=j+104|0;G=j+100|0;H=j+96|0;c[q>>2]=b;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[A>>2]=c[(c[t>>2]|0)+20>>2];c[B>>2]=0;c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[D+12>>2]=0;if((c[q>>2]|0)<=0){c[p>>2]=0;I=c[p>>2]|0;i=j;return I|0}c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break;c[G>>2]=c[(c[r>>2]|0)+(c[z>>2]<<2)>>2];BO(c[G>>2]|0);if((c[A>>2]|0)!=0?(d[(c[A>>2]|0)+(c[z>>2]|0)>>0]|0)!=0:0){J=+h[(c[(c[G>>2]|0)+8>>2]|0)+16>>3];c[C>>2]=~~(+h[(c[(c[G>>2]|0)+8>>2]|0)+16>>3]>=0.0?J+.5:J-.5);J=+h[(c[(c[G>>2]|0)+8>>2]|0)+16+8>>3];c[C+4>>2]=~~(+h[(c[(c[G>>2]|0)+8>>2]|0)+16+8>>3]>=0.0?J+.5:J-.5);J=+h[(c[(c[G>>2]|0)+8>>2]|0)+16+16>>3];c[C+8>>2]=~~(+h[(c[(c[G>>2]|0)+8>>2]|0)+16+16>>3]>=0.0?J+.5:J-.5);J=+h[(c[(c[G>>2]|0)+8>>2]|0)+16+16+8>>3];c[C+8+4>>2]=~~(+h[(c[(c[G>>2]|0)+8>>2]|0)+16+16+8>>3]>=0.0?J+.5:J-.5);if(c[B>>2]|0){c[D>>2]=(c[C>>2]|0)<(c[D>>2]|0)?c[C>>2]|0:c[D>>2]|0;c[D+4>>2]=(c[C+4>>2]|0)<(c[D+4>>2]|0)?c[C+4>>2]|0:c[D+4>>2]|0;c[D+8>>2]=(c[C+8>>2]|0)>(c[D+8>>2]|0)?c[C+8>>2]|0:c[D+8>>2]|0;if((c[C+8+4>>2]|0)>(c[D+8+4>>2]|0))K=c[C+8+4>>2]|0;else K=c[D+8+4>>2]|0;c[D+8+4>>2]=K}else{c[D>>2]=c[C>>2];c[D+4>>2]=c[C+4>>2];c[D+8>>2]=c[C+8>>2];c[D+12>>2]=c[C+12>>2]}c[B>>2]=(c[B>>2]|0)+1}if((d[138998]|0)>2){g=c[24742]|0;f=wB(c[G>>2]|0)|0;J=+h[(c[(c[G>>2]|0)+8>>2]|0)+16>>3];L=+h[(c[(c[G>>2]|0)+8>>2]|0)+16+8>>3];M=+h[(c[(c[G>>2]|0)+8>>2]|0)+16+16>>3];N=+h[(c[(c[G>>2]|0)+8>>2]|0)+16+16+8>>3];c[o>>2]=f;h[o+8>>3]=J;h[o+16>>3]=L;h[o+24>>3]=M;h[o+32>>3]=N;Y2(g,137319,o)|0}c[z>>2]=(c[z>>2]|0)+1}c[F>>2]=cK(c[q>>2]<<5)|0;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break;o=(c[F>>2]|0)+(c[z>>2]<<5)|0;G=(c[(c[(c[r>>2]|0)+(c[z>>2]<<2)>>2]|0)+8>>2]|0)+16|0;c[o>>2]=c[G>>2];c[o+4>>2]=c[G+4>>2];c[o+8>>2]=c[G+8>>2];c[o+12>>2]=c[G+12>>2];c[o+16>>2]=c[G+16>>2];c[o+20>>2]=c[G+20>>2];c[o+24>>2]=c[G+24>>2];c[o+28>>2]=c[G+28>>2];c[z>>2]=(c[z>>2]|0)+1}c[u>>2]=RG(c[q>>2]|0,c[F>>2]|0,c[(c[t>>2]|0)+8>>2]|0)|0;if(a[138998]|0){G=c[24742]|0;c[n>>2]=c[u>>2];Y2(G,137035,n)|0}if((c[u>>2]|0)<=0){c[p>>2]=0;I=c[p>>2]|0;i=j;return I|0}if(c[A>>2]|0){c[E>>2]=((c[D>>2]|0)+(c[D+8>>2]|0)|0)/2|0;c[E+4>>2]=((c[D+4>>2]|0)+(c[D+8+4>>2]|0)|0)/2|0}else{c[E+4>>2]=0;c[E>>2]=0}c[v>>2]=bK(c[q>>2]<<4)|0;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break;c[H>>2]=c[(c[r>>2]|0)+(c[z>>2]<<2)>>2];c[(c[v>>2]|0)+(c[z>>2]<<4)+12>>2]=c[z>>2];if((c[(c[t>>2]|0)+16>>2]|0)!=3){D=c[s>>2]|0;n=c[(c[r>>2]|0)+(c[z>>2]<<2)>>2]|0;G=(c[v>>2]|0)+(c[z>>2]<<4)|0;o=c[u>>2]|0;B=c[t>>2]|0;c[k>>2]=c[E>>2];c[k+4>>2]=c[E+4>>2];if(YG(D,n,G,o,B,k)|0){O=32;break}}else{B=(c[(c[H>>2]|0)+8>>2]|0)+16|0;o=(c[v>>2]|0)+(c[z>>2]<<4)|0;G=c[u>>2]|0;n=c[(c[t>>2]|0)+8>>2]|0;D=wB(c[H>>2]|0)|0;c[l>>2]=c[B>>2];c[l+4>>2]=c[B+4>>2];c[l+8>>2]=c[B+8>>2];c[l+12>>2]=c[B+12>>2];c[l+16>>2]=c[B+16>>2];c[l+20>>2]=c[B+20>>2];c[l+24>>2]=c[B+24>>2];c[l+28>>2]=c[B+28>>2];c[k>>2]=c[E>>2];c[k+4>>2]=c[E+4>>2];SG(l,o,G,n,k,D)}c[z>>2]=(c[z>>2]|0)+1}if((O|0)==32){c[p>>2]=0;I=c[p>>2]|0;i=j;return I|0}c[w>>2]=bK(c[q>>2]<<2)|0;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break;c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]=(c[v>>2]|0)+(c[z>>2]<<4);c[z>>2]=(c[z>>2]|0)+1}w3(c[w>>2]|0,c[q>>2]|0,4,89);c[y>>2]=VK()|0;c[x>>2]=bK(c[q>>2]<<3)|0;O=(c[A>>2]|0)!=0;c[z>>2]=0;a:do if(O){while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break;if(a[(c[A>>2]|0)+(c[z>>2]|0)>>0]|0){l=c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]|0;H=c[y>>2]|0;r=(c[x>>2]|0)+(c[(c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]|0)+12>>2]<<3)|0;c[k>>2]=c[E>>2];c[k+4>>2]=c[E+4>>2];ZG(l,H,r,k)}c[z>>2]=(c[z>>2]|0)+1}c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break a;if(!(a[(c[A>>2]|0)+(c[z>>2]|0)>>0]|0))UG(c[z>>2]|0,c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]|0,c[y>>2]|0,(c[x>>2]|0)+(c[(c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]|0)+12>>2]<<3)|0,c[u>>2]|0,c[(c[t>>2]|0)+8>>2]|0,c[F>>2]|0);c[z>>2]=(c[z>>2]|0)+1}}else while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break a;UG(c[z>>2]|0,c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]|0,c[y>>2]|0,(c[x>>2]|0)+(c[(c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]|0)+12>>2]<<3)|0,c[u>>2]|0,c[(c[t>>2]|0)+8>>2]|0,c[F>>2]|0);c[z>>2]=(c[z>>2]|0)+1}while(0);O4(c[w>>2]|0);c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break;O4(c[(c[v>>2]|0)+(c[z>>2]<<4)+4>>2]|0);c[z>>2]=(c[z>>2]|0)+1}O4(c[v>>2]|0);WK(c[y>>2]|0);O4(c[F>>2]|0);b:do if((d[138998]|0)>1){c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break b;F=c[24742]|0;y=c[(c[x>>2]|0)+(c[z>>2]<<3)>>2]|0;v=c[(c[x>>2]|0)+(c[z>>2]<<3)+4>>2]|0;c[m>>2]=c[z>>2];c[m+4>>2]=y;c[m+8>>2]=v;Y2(F,137051,m)|0;c[z>>2]=(c[z>>2]|0)+1}}while(0);c[p>>2]=c[x>>2];I=c[p>>2]|0;i=j;return I|0}function LG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;f=i;i=i+144|0;g=f+56|0;j=f+132|0;k=f+128|0;l=f+124|0;m=f+120|0;n=f+116|0;o=f+112|0;p=f+108|0;q=f+104|0;r=f+100|0;s=f+96|0;t=f+92|0;u=f+88|0;v=f+84|0;w=f+48|0;x=f+40|0;y=f+32|0;z=f+80|0;A=f;B=f+76|0;C=f+72|0;D=f+68|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=0;c[z>>2]=bK(c[j>>2]<<3)|0;c[B>>2]=c[(c[l>>2]|0)+4>>2];do if(c[(c[l>>2]|0)+28>>2]&1){c[C>>2]=0;if((c[B>>2]|0)>0){c[n>>2]=c[B>>2];c[o>>2]=((c[j>>2]|0)+((c[n>>2]|0)-1)|0)/(c[n>>2]|0)|0;break}else{c[n>>2]=~~+Z(+(+O(+(+(c[j>>2]|0)))));c[o>>2]=((c[j>>2]|0)+((c[n>>2]|0)-1)|0)/(c[n>>2]|0)|0;break}}else{c[C>>2]=1;if((c[B>>2]|0)>0){c[o>>2]=c[B>>2];c[n>>2]=((c[j>>2]|0)+((c[o>>2]|0)-1)|0)/(c[o>>2]|0)|0;break}else{c[o>>2]=~~+Z(+(+O(+(+(c[j>>2]|0)))));c[n>>2]=((c[j>>2]|0)+((c[o>>2]|0)-1)|0)/(c[o>>2]|0)|0;break}}while(0);if(a[138998]|0){B=c[24742]|0;e=c[n>>2]|0;d=c[o>>2]|0;c[g>>2]=(c[C>>2]|0)!=0?137258:137268;c[g+4>>2]=e;c[g+8>>2]=d;Y2(B,137281,g)|0}c[u>>2]=bK((c[o>>2]|0)+1<<3)|0;c[v>>2]=bK((c[n>>2]|0)+1<<3)|0;g=bK((c[j>>2]|0)*24|0)|0;c[r>>2]=g;c[s>>2]=g;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;g=(c[k>>2]|0)+(c[m>>2]<<5)|0;c[A>>2]=c[g>>2];c[A+4>>2]=c[g+4>>2];c[A+8>>2]=c[g+8>>2];c[A+12>>2]=c[g+12>>2];c[A+16>>2]=c[g+16>>2];c[A+20>>2]=c[g+20>>2];c[A+24>>2]=c[g+24>>2];c[A+28>>2]=c[g+28>>2];h[c[s>>2]>>3]=+h[A+16>>3]-+h[A>>3]+ +((c[(c[l>>2]|0)+8>>2]|0)>>>0);h[(c[s>>2]|0)+8>>3]=+h[A+16+8>>3]-+h[A+8>>3]+ +((c[(c[l>>2]|0)+8>>2]|0)>>>0);c[(c[s>>2]|0)+16>>2]=c[m>>2];c[m>>2]=(c[m>>2]|0)+1;c[s>>2]=(c[s>>2]|0)+24}c[t>>2]=bK(c[j>>2]<<2)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=(c[r>>2]|0)+((c[m>>2]|0)*24|0);c[m>>2]=(c[m>>2]|0)+1}g=c[l>>2]|0;if(!(c[(c[l>>2]|0)+24>>2]|0)){if(!(c[g+28>>2]&64))w3(c[t>>2]|0,c[j>>2]|0,4,91)}else{c[13644]=c[g+24>>2];w3(c[t>>2]|0,c[j>>2]|0,4,90)}c[q>>2]=0;c[p>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;c[s>>2]=c[(c[t>>2]|0)+(c[m>>2]<<2)>>2];if(+h[(c[u>>2]|0)+(c[q>>2]<<3)>>3]>+h[c[s>>2]>>3])E=+h[(c[u>>2]|0)+(c[q>>2]<<3)>>3];else E=+h[c[s>>2]>>3];h[(c[u>>2]|0)+(c[q>>2]<<3)>>3]=E;if(+h[(c[v>>2]|0)+(c[p>>2]<<3)>>3]>+h[(c[s>>2]|0)+8>>3])F=+h[(c[v>>2]|0)+(c[p>>2]<<3)>>3];else F=+h[(c[s>>2]|0)+8>>3];h[(c[v>>2]|0)+(c[p>>2]<<3)>>3]=F;if(c[C>>2]|0){c[q>>2]=(c[q>>2]|0)+1;if((c[q>>2]|0)==(c[o>>2]|0)){c[q>>2]=0;c[p>>2]=(c[p>>2]|0)+1}}else{c[p>>2]=(c[p>>2]|0)+1;if((c[p>>2]|0)==(c[n>>2]|0)){c[p>>2]=0;c[q>>2]=(c[q>>2]|0)+1}}c[m>>2]=(c[m>>2]|0)+1;c[s>>2]=(c[s>>2]|0)+24}h[x>>3]=0.0;c[m>>2]=0;while(1){if((c[m>>2]|0)>(c[o>>2]|0))break;h[w>>3]=+h[(c[u>>2]|0)+(c[m>>2]<<3)>>3];h[(c[u>>2]|0)+(c[m>>2]<<3)>>3]=+h[x>>3];h[x>>3]=+h[x>>3]+ +h[w>>3];c[m>>2]=(c[m>>2]|0)+1}h[y>>3]=0.0;c[m>>2]=c[n>>2];while(1){if(0>=(c[m>>2]|0))break;h[w>>3]=+h[(c[v>>2]|0)+((c[m>>2]|0)-1<<3)>>3];h[(c[v>>2]|0)+(c[m>>2]<<3)>>3]=+h[y>>3];h[y>>3]=+h[y>>3]+ +h[w>>3];c[m>>2]=(c[m>>2]|0)+-1}h[c[v>>2]>>3]=+h[y>>3];c[q>>2]=0;c[p>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;c[s>>2]=c[(c[t>>2]|0)+(c[m>>2]<<2)>>2];c[D>>2]=c[(c[s>>2]|0)+16>>2];y=(c[k>>2]|0)+(c[D>>2]<<5)|0;c[A>>2]=c[y>>2];c[A+4>>2]=c[y+4>>2];c[A+8>>2]=c[y+8>>2];c[A+12>>2]=c[y+12>>2];c[A+16>>2]=c[y+16>>2];c[A+20>>2]=c[y+20>>2];c[A+24>>2]=c[y+24>>2];c[A+28>>2]=c[y+28>>2];do if(!(c[(c[l>>2]|0)+28>>2]&4)){y=c[q>>2]|0;if(c[(c[l>>2]|0)+28>>2]&8){c[(c[z>>2]|0)+(c[D>>2]<<3)>>2]=~~(+h[(c[u>>2]|0)+(y+1<<3)>>3]-(+h[A+16>>3]-+h[A>>3]));break}else{c[(c[z>>2]|0)+(c[D>>2]<<3)>>2]=~~((+h[(c[u>>2]|0)+(y<<3)>>3]+ +h[(c[u>>2]|0)+((c[q>>2]|0)+1<<3)>>3]-+h[A+16>>3]-+h[A>>3])/2.0);break}}else c[(c[z>>2]|0)+(c[D>>2]<<3)>>2]=~~+h[(c[u>>2]|0)+(c[q>>2]<<3)>>3];while(0);do if(!(c[(c[l>>2]|0)+28>>2]&16)){y=c[p>>2]|0;if(c[(c[l>>2]|0)+28>>2]&32){c[(c[z>>2]|0)+(c[D>>2]<<3)+4>>2]=~~+h[(c[v>>2]|0)+(y+1<<3)>>3];break}else{c[(c[z>>2]|0)+(c[D>>2]<<3)+4>>2]=~~((+h[(c[v>>2]|0)+(y<<3)>>3]+ +h[(c[v>>2]|0)+((c[p>>2]|0)+1<<3)>>3]-+h[A+16+8>>3]-+h[A+8>>3])/2.0);break}}else c[(c[z>>2]|0)+(c[D>>2]<<3)+4>>2]=~~(+h[(c[v>>2]|0)+(c[p>>2]<<3)>>3]-(+h[A+16+8>>3]-+h[A+8>>3]));while(0);if(c[C>>2]|0){c[q>>2]=(c[q>>2]|0)+1;if((c[q>>2]|0)==(c[o>>2]|0)){c[q>>2]=0;c[p>>2]=(c[p>>2]|0)+1}}else{c[p>>2]=(c[p>>2]|0)+1;if((c[p>>2]|0)==(c[n>>2]|0)){c[p>>2]=0;c[q>>2]=(c[q>>2]|0)+1}}c[m>>2]=(c[m>>2]|0)+1;c[s>>2]=(c[s>>2]|0)+24}O4(c[r>>2]|0);O4(c[t>>2]|0);O4(c[u>>2]|0);O4(c[v>>2]|0);i=f;return c[z>>2]|0}function MG(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;h=g+104|0;j=g+24|0;k=g+8|0;l=g;m=g+100|0;n=g+96|0;o=g+92|0;p=g+88|0;q=g+84|0;r=g+80|0;s=g+76|0;t=g+72|0;u=g+68|0;v=g+64|0;w=g+56|0;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=RG(c[n>>2]|0,c[o>>2]|0,c[(c[p>>2]|0)+8>>2]|0)|0;if(a[138998]|0){f=c[24742]|0;c[l>>2]=c[q>>2];Y2(f,137035,l)|0}if((c[q>>2]|0)<=0){c[m>>2]=0;x=c[m>>2]|0;i=g;return x|0}c[w+4>>2]=0;c[w>>2]=0;c[r>>2]=bK(c[n>>2]<<4)|0;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break;c[(c[r>>2]|0)+(c[v>>2]<<4)+12>>2]=c[v>>2];l=(c[o>>2]|0)+(c[v>>2]<<5)|0;f=(c[r>>2]|0)+(c[v>>2]<<4)|0;e=c[q>>2]|0;b=c[(c[p>>2]|0)+8>>2]|0;c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[j+16>>2]=c[l+16>>2];c[j+20>>2]=c[l+20>>2];c[j+24>>2]=c[l+24>>2];c[j+28>>2]=c[l+28>>2];c[h>>2]=c[w>>2];c[h+4>>2]=c[w+4>>2];SG(j,f,e,b,h,178518);c[v>>2]=(c[v>>2]|0)+1}c[s>>2]=bK(c[n>>2]<<2)|0;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break;c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=(c[r>>2]|0)+(c[v>>2]<<4);c[v>>2]=(c[v>>2]|0)+1}w3(c[s>>2]|0,c[n>>2]|0,4,89);c[u>>2]=VK()|0;c[t>>2]=bK(c[n>>2]<<3)|0;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break;UG(c[v>>2]|0,c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]|0,c[u>>2]|0,(c[t>>2]|0)+(c[(c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]|0)+12>>2]<<3)|0,c[q>>2]|0,c[(c[p>>2]|0)+8>>2]|0,c[o>>2]|0);c[v>>2]=(c[v>>2]|0)+1}O4(c[s>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break;O4(c[(c[r>>2]|0)+(c[v>>2]<<4)+4>>2]|0);c[v>>2]=(c[v>>2]|0)+1}O4(c[r>>2]|0);WK(c[u>>2]|0);a:do if((d[138998]|0)>1){c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break a;u=c[24742]|0;r=c[(c[t>>2]|0)+(c[v>>2]<<3)>>2]|0;s=c[(c[t>>2]|0)+(c[v>>2]<<3)+4>>2]|0;c[k>>2]=c[v>>2];c[k+4>>2]=r;c[k+8>>2]=s;Y2(u,137051,k)|0;c[v>>2]=(c[v>>2]|0)+1}}while(0);c[m>>2]=c[t>>2];x=c[m>>2]|0;i=g;return x|0}function NG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+80|0;f=e+64|0;g=e+60|0;j=e+56|0;k=e+52|0;l=e+48|0;m=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;if(c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0){d=(c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;h[d>>3]=+h[d>>3]+ +(c[g>>2]|0);d=(c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0)+56+8|0;h[d>>3]=+h[d>>3]+ +(c[j>>2]|0)}if(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0){d=(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;h[d>>3]=+h[d>>3]+ +(c[g>>2]|0);d=(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0)+56+8|0;h[d>>3]=+h[d>>3]+ +(c[j>>2]|0)}if(c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]|0){d=(c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]|0)+56|0;h[d>>3]=+h[d>>3]+ +(c[g>>2]|0);d=(c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]|0)+56+8|0;h[d>>3]=+h[d>>3]+ +(c[j>>2]|0)}if(c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]|0){d=(c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]|0)+56|0;h[d>>3]=+h[d>>3]+ +(c[g>>2]|0);d=(c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]|0)+56+8|0;h[d>>3]=+h[d>>3]+ +(c[j>>2]|0)}if(!(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)){i=e;return}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;d=m;b=(c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[k>>2]|0)*48|0)|0;a=d+48|0;do{c[d>>2]=c[b>>2];d=d+4|0;b=b+4|0}while((d|0)<(a|0));c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[m+4>>2]|0))break;b=(c[m>>2]|0)+(c[l>>2]<<4)|0;h[b>>3]=+h[b>>3]+ +(c[g>>2]|0);b=(c[m>>2]|0)+(c[l>>2]<<4)+8|0;h[b>>3]=+h[b>>3]+ +(c[j>>2]|0);c[l>>2]=(c[l>>2]|0)+1}if(c[m+8>>2]|0){b=(c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[k>>2]|0)*48|0)+16|0;h[b>>3]=+h[b>>3]+ +(c[g>>2]|0);b=(c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[k>>2]|0)*48|0)+16+8|0;h[b>>3]=+h[b>>3]+ +(c[j>>2]|0)}if(c[m+12>>2]|0){b=(c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[k>>2]|0)*48|0)+32|0;h[b>>3]=+h[b>>3]+ +(c[g>>2]|0);b=(c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[k>>2]|0)*48|0)+32+8|0;h[b>>3]=+h[b>>3]+ +(c[j>>2]|0)}c[k>>2]=(c[k>>2]|0)+1}i=e;return}function OG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;j=e+40|0;k=e+36|0;l=e;m=e+32|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;d=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[d>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];c[l+16>>2]=c[d+16>>2];c[l+20>>2]=c[d+20>>2];c[l+24>>2]=c[d+24>>2];c[l+28>>2]=c[d+28>>2];d=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[d>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];c[l+16>>2]=c[d+16>>2];c[l+20>>2]=c[d+20>>2];c[l+24>>2]=c[d+24>>2];c[l+28>>2]=c[d+28>>2];h[l>>3]=+h[l>>3]+ +(c[g>>2]|0);d=l+16|0;h[d>>3]=+h[d>>3]+ +(c[g>>2]|0);d=l+8|0;h[d>>3]=+h[d>>3]+ +(c[j>>2]|0);d=l+16+8|0;h[d>>3]=+h[d>>3]+ +(c[j>>2]|0);d=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[d>>2]=c[l>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];c[d+16>>2]=c[l+16>>2];c[d+20>>2]=c[l+20>>2];c[d+24>>2]=c[l+24>>2];c[d+28>>2]=c[l+28>>2];if(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0){l=(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;h[l>>3]=+h[l>>3]+ +(c[g>>2]|0);l=(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)+56+8|0;h[l>>3]=+h[l>>3]+ +(c[j>>2]|0)}c[m>>2]=1;while(1){if((c[m>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;c[k>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[m>>2]<<2)>>2];OG(c[k>>2]|0,c[g>>2]|0,c[j>>2]|0);c[m>>2]=(c[m>>2]|0)+1}i=e;return}function PG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;d=c[g>>2]|0;if((a[c[g>>2]>>0]|0)!=95){c[f>>2]=d;l=c[f>>2]|0;i=e;return l|0}c[g>>2]=d+1;c[k>>2]=1;a:while(1){if(!(c[k>>2]|0))break;d=a[c[g>>2]>>0]|0;c[j>>2]=d;if(!d)break;switch(c[j>>2]|0){case 99:{d=(c[h>>2]|0)+28|0;c[d>>2]=c[d>>2]|1;c[g>>2]=(c[g>>2]|0)+1;continue a;break}case 105:{d=(c[h>>2]|0)+28|0;c[d>>2]=c[d>>2]|64;c[g>>2]=(c[g>>2]|0)+1;continue a;break}case 117:{d=(c[h>>2]|0)+28|0;c[d>>2]=c[d>>2]|2;c[g>>2]=(c[g>>2]|0)+1;continue a;break}case 116:{d=(c[h>>2]|0)+28|0;c[d>>2]=c[d>>2]|16;c[g>>2]=(c[g>>2]|0)+1;continue a;break}case 98:{d=(c[h>>2]|0)+28|0;c[d>>2]=c[d>>2]|32;c[g>>2]=(c[g>>2]|0)+1;continue a;break}case 108:{d=(c[h>>2]|0)+28|0;c[d>>2]=c[d>>2]|4;c[g>>2]=(c[g>>2]|0)+1;continue a;break}case 114:{d=(c[h>>2]|0)+28|0;c[d>>2]=c[d>>2]|8;c[g>>2]=(c[g>>2]|0)+1;continue a;break}default:{c[k>>2]=0;continue a}}}c[f>>2]=c[g>>2];l=c[f>>2]|0;i=e;return l|0}function QG(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;switch(c[d>>2]|0){case 1:{c[e>>2]=145613;break}case 2:{c[e>>2]=149084;break}case 3:{c[e>>2]=149098;break}case 4:{c[e>>2]=136931;break}case 5:{c[e>>2]=136937;break}default:c[e>>2]=137025}i=b;return c[e>>2]|0}function RG(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0.0,G=0.0,H=0.0;f=i;i=i+240|0;g=f+192|0;j=f+160|0;k=f+120|0;l=f+112|0;m=f+104|0;n=f+228|0;o=f+224|0;p=f+220|0;q=f+216|0;r=f+96|0;s=f+88|0;t=f+80|0;u=f+72|0;v=f+64|0;w=f+56|0;x=f+48|0;y=f+40|0;z=f+32|0;A=f+212|0;B=f+208|0;C=f;c[o>>2]=a;c[p>>2]=b;c[q>>2]=e;h[t>>3]=+(((c[o>>2]|0)*100|0)-1|0);h[v>>3]=0.0;h[u>>3]=0.0;c[A>>2]=0;while(1){if((c[A>>2]|0)>=(c[o>>2]|0))break;e=(c[p>>2]|0)+(c[A>>2]<<5)|0;c[C>>2]=c[e>>2];c[C+4>>2]=c[e+4>>2];c[C+8>>2]=c[e+8>>2];c[C+12>>2]=c[e+12>>2];c[C+16>>2]=c[e+16>>2];c[C+20>>2]=c[e+20>>2];c[C+24>>2]=c[e+24>>2];c[C+28>>2]=c[e+28>>2];h[y>>3]=+h[C+16>>3]-+h[C>>3]+ +(c[q>>2]<<1|0);h[z>>3]=+h[C+16+8>>3]-+h[C+8>>3]+ +(c[q>>2]<<1|0);h[u>>3]=+h[u>>3]-(+h[y>>3]+ +h[z>>3]);h[v>>3]=+h[v>>3]-+h[y>>3]*+h[z>>3];c[A>>2]=(c[A>>2]|0)+1}h[w>>3]=+h[u>>3]*+h[u>>3]-+h[t>>3]*4.0*+h[v>>3];D=+h[w>>3];if(+h[w>>3]<0.0){h[m>>3]=D;$z(1,137141,m)|0;c[n>>2]=-1;E=c[n>>2]|0;i=f;return E|0}h[x>>3]=+O(+D);h[r>>3]=(-+h[u>>3]+ +h[x>>3])/(+h[t>>3]*2.0);h[s>>3]=(-+h[u>>3]-+h[x>>3])/(+h[t>>3]*2.0);m=~~+h[r>>3];c[B>>2]=m;c[B>>2]=(c[B>>2]|0)==0?1:m;if((d[138998]|0|0)>2){Y2(c[24742]|0,137168,l)|0;l=c[24742]|0;D=+h[u>>3];F=+h[v>>3];G=+h[w>>3];H=+h[x>>3];h[k>>3]=+h[t>>3];h[k+8>>3]=D;h[k+16>>3]=F;h[k+24>>3]=G;h[k+32>>3]=H;Y2(l,137196,k)|0;k=c[24742]|0;H=+h[r>>3];l=~~+h[s>>3];G=+h[s>>3];c[j>>2]=c[B>>2];h[j+8>>3]=H;c[j+16>>2]=l;h[j+24>>3]=G;Y2(k,137222,j)|0;j=c[24742]|0;G=+h[t>>3]*+h[s>>3]*+h[s>>3]+ +h[u>>3]*+h[s>>3]+ +h[v>>3];h[g>>3]=+h[t>>3]*+h[r>>3]*+h[r>>3]+ +h[u>>3]*+h[r>>3]+ +h[v>>3];h[g+8>>3]=G;Y2(j,137244,g)|0}c[n>>2]=c[B>>2];E=c[n>>2]|0;i=f;return E|0}function SG(a,b,e,f,g,j){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+112|0;l=k+16|0;m=k;n=k+96|0;o=k+92|0;p=k+88|0;q=k+84|0;r=k+80|0;s=k+76|0;t=k+72|0;u=k+64|0;v=k+56|0;w=k+40|0;x=k+32|0;y=k+28|0;z=k+24|0;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=j;A=+h[a>>3];c[w>>2]=~~(+h[a>>3]>=0.0?A+.5:A-.5);A=+h[a+8>>3];c[w+4>>2]=~~(+h[a+8>>3]>=0.0?A+.5:A-.5);A=+h[a+16>>3];c[w+8>>2]=~~(+h[a+16>>3]>=0.0?A+.5:A-.5);A=+h[a+16+8>>3];c[w+8+4>>2]=~~(+h[a+16+8>>3]>=0.0?A+.5:A-.5);c[r>>2]=VK()|0;c[v>>2]=(c[g>>2]|0)-(c[p>>2]|0);c[v+4>>2]=(c[g+4>>2]|0)-(c[p>>2]|0);c[u>>2]=(c[g>>2]|0)+(c[w+8>>2]|0)-(c[w>>2]|0)+(c[p>>2]|0);c[u+4>>2]=(c[g+4>>2]|0)+(c[w+8+4>>2]|0)-(c[w+4>>2]|0)+(c[p>>2]|0);w=c[v>>2]|0;if((c[v>>2]|0)>=0)B=(w|0)/(c[o>>2]|0)|0;else B=((w+1|0)/(c[o>>2]|0)|0)-1|0;c[v>>2]=B;B=c[v+4>>2]|0;if((c[v+4>>2]|0)>=0)C=(B|0)/(c[o>>2]|0)|0;else C=((B+1|0)/(c[o>>2]|0)|0)-1|0;c[v+4>>2]=C;C=c[u>>2]|0;if((c[u>>2]|0)>=0)D=(C|0)/(c[o>>2]|0)|0;else D=((C+1|0)/(c[o>>2]|0)|0)-1|0;c[u>>2]=D;D=c[u+4>>2]|0;if((c[u+4>>2]|0)>=0)E=(D|0)/(c[o>>2]|0)|0;else E=((D+1|0)/(c[o>>2]|0)|0)-1|0;c[u+4>>2]=E;c[x>>2]=c[v>>2];while(1){if((c[x>>2]|0)>(c[u>>2]|0))break;c[y>>2]=c[v+4>>2];while(1){if((c[y>>2]|0)>(c[u+4>>2]|0))break;YK(c[r>>2]|0,c[x>>2]|0,c[y>>2]|0);c[y>>2]=(c[y>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+1}x=aL(c[r>>2]|0)|0;c[(c[n>>2]|0)+4>>2]=x;x=$K(c[r>>2]|0)|0;c[(c[n>>2]|0)+8>>2]=x;c[s>>2]=~~+Z(+((+h[a+16>>3]-+h[a>>3]+ +(c[p>>2]<<1|0))/+(c[o>>2]|0)));c[t>>2]=~~+Z(+((+h[a+16+8>>3]-+h[a+8>>3]+ +(c[p>>2]<<1|0))/+(c[o>>2]|0)));c[c[n>>2]>>2]=(c[s>>2]|0)+(c[t>>2]|0);if((d[138998]|0|0)<=2){F=c[r>>2]|0;WK(F);i=k;return}o=c[24742]|0;p=c[(c[n>>2]|0)+8>>2]|0;a=c[s>>2]|0;s=c[t>>2]|0;c[m>>2]=c[q>>2];c[m+4>>2]=p;c[m+8>>2]=a;c[m+12>>2]=s;Y2(o,137100,m)|0;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[(c[n>>2]|0)+8>>2]|0))break;m=c[24742]|0;o=c[(c[(c[n>>2]|0)+4>>2]|0)+(c[z>>2]<<3)+4>>2]|0;c[l>>2]=c[(c[(c[n>>2]|0)+4>>2]|0)+(c[z>>2]<<3)>>2];c[l+4>>2]=o;Y2(m,137127,l)|0;c[z>>2]=(c[z>>2]|0)+1}F=c[r>>2]|0;WK(F);i=k;return}function TG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[c[e>>2]>>2];c[h>>2]=c[c[f>>2]>>2];i=d;return (c[c[h>>2]>>2]|0)-(c[c[g>>2]>>2]|0)|0}function UG(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=i;i=i+80|0;l=k+76|0;m=k+72|0;n=k+68|0;o=k+64|0;p=k+60|0;q=k+56|0;r=k+52|0;s=k+48|0;t=k+44|0;u=k+40|0;v=k+36|0;w=k+32|0;x=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;j=(c[r>>2]|0)+(c[(c[m>>2]|0)+12>>2]<<5)|0;c[x>>2]=c[j>>2];c[x+4>>2]=c[j+4>>2];c[x+8>>2]=c[j+8>>2];c[x+12>>2]=c[j+12>>2];c[x+16>>2]=c[j+16>>2];c[x+20>>2]=c[j+20>>2];c[x+24>>2]=c[j+24>>2];c[x+28>>2]=c[j+28>>2];if((c[l>>2]|0)==0?(c[u>>2]=~~+Z(+((+h[x+16>>3]-+h[x>>3]+ +(c[q>>2]<<1|0))/+(c[p>>2]|0))),c[v>>2]=~~+Z(+((+h[x+16+8>>3]-+h[x+8>>3]+ +(c[q>>2]<<1|0))/+(c[p>>2]|0))),(VG((0-(c[u>>2]|0)|0)/2|0,(0-(c[v>>2]|0)|0)/2|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0)!=0):0){i=k;return}if(VG(0,0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){i=k;return}c[u>>2]=~~+Z(+(+h[x+16>>3]-+h[x>>3]));c[v>>2]=~~+Z(+(+h[x+16+8>>3]-+h[x+8>>3]));x=(c[u>>2]|0)>=(c[v>>2]|0);c[w>>2]=1;if(x){a:while(1){c[s>>2]=0;c[t>>2]=0-(c[w>>2]|0);while(1){if((c[s>>2]|0)>=(c[w>>2]|0))break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break a}c[s>>2]=(c[s>>2]|0)+1}while(1){if((c[t>>2]|0)>=(c[w>>2]|0))break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break a}c[t>>2]=(c[t>>2]|0)+1}while(1){if((c[s>>2]|0)<=(0-(c[w>>2]|0)|0))break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break a}c[s>>2]=(c[s>>2]|0)+-1}while(1){if((c[t>>2]|0)<=(0-(c[w>>2]|0)|0))break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break a}c[t>>2]=(c[t>>2]|0)+-1}while(1){if((c[s>>2]|0)>=0)break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break a}c[s>>2]=(c[s>>2]|0)+1}c[w>>2]=(c[w>>2]|0)+1}if((y|0)==39){i=k;return}}else{b:while(1){c[t>>2]=0;c[s>>2]=0-(c[w>>2]|0);while(1){if((c[t>>2]|0)<=(0-(c[w>>2]|0)|0))break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break b}c[t>>2]=(c[t>>2]|0)+-1}while(1){if((c[s>>2]|0)>=(c[w>>2]|0))break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break b}c[s>>2]=(c[s>>2]|0)+1}while(1){if((c[t>>2]|0)>=(c[w>>2]|0))break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break b}c[t>>2]=(c[t>>2]|0)+1}while(1){if((c[s>>2]|0)<=(0-(c[w>>2]|0)|0))break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break b}c[s>>2]=(c[s>>2]|0)+-1}while(1){if((c[t>>2]|0)<=0)break;if(VG(c[s>>2]|0,c[t>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0)|0){y=39;break b}c[t>>2]=(c[t>>2]|0)+-1}c[w>>2]=(c[w>>2]|0)+1}if((y|0)==39){i=k;return}}}function VG(a,b,e,f,g,j,k){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;l=i;i=i+96|0;m=l+88|0;n=l;o=l+84|0;p=l+80|0;q=l+76|0;r=l+72|0;s=l+68|0;t=l+64|0;u=l+60|0;v=l+56|0;w=l+52|0;x=l+48|0;y=l+40|0;z=l+32|0;A=l+24|0;c[p>>2]=a;c[q>>2]=b;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=j;c[v>>2]=k;c[w>>2]=c[(c[r>>2]|0)+4>>2];c[x>>2]=c[(c[r>>2]|0)+8>>2];c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[x>>2]|0))break;k=c[w>>2]|0;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[y>>2]=(c[y>>2]|0)+(c[p>>2]|0);k=y+4|0;c[k>>2]=(c[k>>2]|0)+(c[q>>2]|0);k=c[s>>2]|0;c[m>>2]=c[y>>2];c[m+4>>2]=c[y+4>>2];if(ZK(k,m)|0){B=4;break}c[w>>2]=(c[w>>2]|0)+8;c[z>>2]=(c[z>>2]|0)+1}if((B|0)==4){c[o>>2]=0;C=c[o>>2]|0;i=l;return C|0}D=+h[(c[v>>2]|0)+(c[(c[r>>2]|0)+12>>2]<<5)>>3];c[A>>2]=~~(+h[(c[v>>2]|0)+(c[(c[r>>2]|0)+12>>2]<<5)>>3]>=0.0?D+.5:D-.5);D=+h[(c[v>>2]|0)+(c[(c[r>>2]|0)+12>>2]<<5)+8>>3];c[A+4>>2]=~~(+h[(c[v>>2]|0)+(c[(c[r>>2]|0)+12>>2]<<5)+8>>3]>=0.0?D+.5:D-.5);v=_(c[u>>2]|0,c[p>>2]|0)|0;c[c[t>>2]>>2]=v-(c[A>>2]|0);v=_(c[u>>2]|0,c[q>>2]|0)|0;c[(c[t>>2]|0)+4>>2]=v-(c[A+4>>2]|0);c[w>>2]=c[(c[r>>2]|0)+4>>2];c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[x>>2]|0))break;r=c[w>>2]|0;c[y>>2]=c[r>>2];c[y+4>>2]=c[r+4>>2];c[y>>2]=(c[y>>2]|0)+(c[p>>2]|0);r=y+4|0;c[r>>2]=(c[r>>2]|0)+(c[q>>2]|0);r=c[s>>2]|0;c[m>>2]=c[y>>2];c[m+4>>2]=c[y+4>>2];XK(r,m);c[w>>2]=(c[w>>2]|0)+8;c[z>>2]=(c[z>>2]|0)+1}if((d[138998]|0|0)>=2){z=c[24742]|0;w=c[p>>2]|0;p=c[q>>2]|0;q=c[c[t>>2]>>2]|0;m=c[(c[t>>2]|0)+4>>2]|0;c[n>>2]=c[x>>2];c[n+4>>2]=w;c[n+8>>2]=p;c[n+12>>2]=q;c[n+16>>2]=m;Y2(z,137066,n)|0}c[o>>2]=1;C=c[o>>2]|0;i=l;return C|0}function WG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[c[f>>2]>>2];c[j>>2]=c[c[g>>2]>>2];c[k>>2]=c[(c[13644]|0)+(c[(c[h>>2]|0)+16>>2]<<2)>>2];c[l>>2]=c[(c[13644]|0)+(c[(c[j>>2]|0)+16>>2]<<2)>>2];if((c[k>>2]|0)>(c[l>>2]|0)){c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}if((c[k>>2]|0)<(c[l>>2]|0)){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else{c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}return 0}function XG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;j=d+20|0;k=d+16|0;l=d+8|0;m=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[c[f>>2]>>2];c[k>>2]=c[c[g>>2]>>2];h[l>>3]=+h[(c[j>>2]|0)+8>>3]+ +h[c[j>>2]>>3];h[m>>3]=+h[(c[k>>2]|0)+8>>3]+ +h[c[k>>2]>>3];if(+h[l>>3]<+h[m>>3]){c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}if(+h[l>>3]>+h[m>>3]){c[e>>2]=-1;n=c[e>>2]|0;i=d;return n|0}else{c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}return 0}function YG(a,b,e,f,g,j){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;k=i;i=i+256|0;l=k+248|0;m=k+240|0;n=k+64|0;o=k+48|0;p=k+236|0;q=k+232|0;r=k+228|0;s=k+224|0;t=k+220|0;u=k+216|0;v=k+212|0;w=k+208|0;x=k+200|0;y=k+192|0;z=k+184|0;A=k+176|0;B=k+32|0;C=k+172|0;D=k+168|0;E=k+164|0;F=k+160|0;G=k+156|0;H=k+152|0;I=k+148|0;J=k+144|0;K=k+140|0;L=k+136|0;M=k+120|0;N=k+116|0;O=k+112|0;P=k+16|0;Q=k+104|0;R=k+96|0;S=k;T=k+88|0;U=k+80|0;V=k+72|0;c[p>>2]=a;c[q>>2]=b;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[K>>2]=c[(c[t>>2]|0)+8>>2];c[L>>2]=c[(c[t>>2]|0)+12>>2];if(c[p>>2]|0)c[C>>2]=c[p>>2];else c[C>>2]=c[q>>2];c[u>>2]=VK()|0;W=+h[(c[(c[q>>2]|0)+8>>2]|0)+16>>3];c[H>>2]=(c[j>>2]|0)-~~(+h[(c[(c[q>>2]|0)+8>>2]|0)+16>>3]>=0.0?W+.5:W-.5);W=+h[(c[(c[q>>2]|0)+8>>2]|0)+16+8>>3];c[I>>2]=(c[j+4>>2]|0)-~~(+h[(c[(c[q>>2]|0)+8>>2]|0)+16+8>>3]>=0.0?W+.5:W-.5);j=c[q>>2]|0;a:do if((c[(c[t>>2]|0)+16>>2]|0)==1){c[O>>2]=cK((kB(j)|0)<<2)|0;c[N>>2]=0;c[D>>2]=$B(c[q>>2]|0)|0;while(1){if(!(c[D>>2]|0))break;p=c[(c[(c[D>>2]|0)+8>>2]|0)+112>>2]|0;g=c[N>>2]|0;c[N>>2]=g+1;c[(c[O>>2]|0)+(g<<2)>>2]=p;c[(c[(c[D>>2]|0)+8>>2]|0)+112>>2]=0;c[D>>2]=aC(c[q>>2]|0,c[D>>2]|0)|0}c[N>>2]=1;while(1){if((c[N>>2]|0)>(c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]|0))break;c[J>>2]=c[(c[(c[(c[q>>2]|0)+8>>2]|0)+184>>2]|0)+(c[N>>2]<<2)>>2];W=+h[(c[(c[J>>2]|0)+8>>2]|0)+16>>3];c[M>>2]=~~(+h[(c[(c[J>>2]|0)+8>>2]|0)+16>>3]>=0.0?W+.5:W-.5);W=+h[(c[(c[J>>2]|0)+8>>2]|0)+16+8>>3];c[M+4>>2]=~~(+h[(c[(c[J>>2]|0)+8>>2]|0)+16+8>>3]>=0.0?W+.5:W-.5);W=+h[(c[(c[J>>2]|0)+8>>2]|0)+16+16>>3];c[M+8>>2]=~~(+h[(c[(c[J>>2]|0)+8>>2]|0)+16+16>>3]>=0.0?W+.5:W-.5);W=+h[(c[(c[J>>2]|0)+8>>2]|0)+16+16+8>>3];c[M+8+4>>2]=~~(+h[(c[(c[J>>2]|0)+8>>2]|0)+16+16+8>>3]>=0.0?W+.5:W-.5);b:do if((c[M+8>>2]|0)>(c[M>>2]|0)?(c[M+8+4>>2]|0)>(c[M+4>>2]|0):0){c[M>>2]=(c[M>>2]|0)+(c[H>>2]|0);p=M+4|0;c[p>>2]=(c[p>>2]|0)+(c[I>>2]|0);p=M+8|0;c[p>>2]=(c[p>>2]|0)+(c[H>>2]|0);p=M+8+4|0;c[p>>2]=(c[p>>2]|0)+(c[I>>2]|0);c[M>>2]=(c[M>>2]|0)-(c[K>>2]|0);p=M+4|0;c[p>>2]=(c[p>>2]|0)-(c[K>>2]|0);p=M+8|0;c[p>>2]=(c[p>>2]|0)+(c[K>>2]|0);p=M+8+4|0;c[p>>2]=(c[p>>2]|0)+(c[K>>2]|0);p=c[M>>2]|0;if((c[M>>2]|0)>=0)X=(p|0)/(c[s>>2]|0)|0;else X=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[M>>2]=X;p=c[M+4>>2]|0;if((c[M+4>>2]|0)>=0)Y=(p|0)/(c[s>>2]|0)|0;else Y=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[M+4>>2]=Y;p=c[M+8>>2]|0;if((c[M+8>>2]|0)>=0)_=(p|0)/(c[s>>2]|0)|0;else _=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[M+8>>2]=_;p=c[M+8+4>>2]|0;if((c[M+8+4>>2]|0)>=0)$=(p|0)/(c[s>>2]|0)|0;else $=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[M+8+4>>2]=$;c[F>>2]=c[M>>2];while(1){if((c[F>>2]|0)>(c[M+8>>2]|0))break;c[G>>2]=c[M+4>>2];while(1){if((c[G>>2]|0)>(c[M+8+4>>2]|0))break;YK(c[u>>2]|0,c[F>>2]|0,c[G>>2]|0);c[G>>2]=(c[G>>2]|0)+1}c[F>>2]=(c[F>>2]|0)+1}c[D>>2]=$B(c[J>>2]|0)|0;while(1){if(!(c[D>>2]|0))break b;c[(c[(c[D>>2]|0)+8>>2]|0)+212>>2]=c[J>>2];c[D>>2]=aC(c[J>>2]|0,c[D>>2]|0)|0}}while(0);c[N>>2]=(c[N>>2]|0)+1}c[D>>2]=$B(c[q>>2]|0)|0;while(1){if(!(c[D>>2]|0))break;pO(P,c[D>>2]|0);c[B>>2]=c[P>>2];c[B+4>>2]=c[P+4>>2];c[B+8>>2]=c[P+8>>2];c[B+12>>2]=c[P+12>>2];W=+h[B>>3];c[z>>2]=~~(+h[B>>3]>=0.0?W+.5:W-.5);W=+h[B+8>>3];c[z+4>>2]=~~(+h[B+8>>3]>=0.0?W+.5:W-.5);c[z>>2]=(c[z>>2]|0)+(c[H>>2]|0);p=z+4|0;c[p>>2]=(c[p>>2]|0)+(c[I>>2]|0);c:do if(c[(c[(c[D>>2]|0)+8>>2]|0)+212>>2]|0){p=c[z>>2]|0;if((c[z>>2]|0)>=0)aa=(p|0)/(c[s>>2]|0)|0;else aa=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[z>>2]=aa;p=c[z+4>>2]|0;if((c[z+4>>2]|0)>=0)ba=(p|0)/(c[s>>2]|0)|0;else ba=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[z+4>>2]=ba;c[E>>2]=OA(c[C>>2]|0,c[D>>2]|0)|0;while(1){if(!(c[E>>2]|0))break c;p=c[E>>2]|0;if((c[(c[(c[D>>2]|0)+8>>2]|0)+212>>2]|0)!=(c[(c[(c[((c[c[E>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)){p=c[E>>2]|0;g=c[u>>2]|0;f=c[H>>2]|0;e=c[I>>2]|0;b=c[s>>2]|0;a=c[L>>2]|0;c[l>>2]=c[z>>2];c[l+4>>2]=c[z+4>>2];aH(p,l,g,f,e,b,a)}c[E>>2]=QA(c[C>>2]|0,c[E>>2]|0)|0}}else{c[A>>2]=~~(+(c[K>>2]|0)+(+h[(c[(c[D>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[D>>2]|0)+8>>2]|0)+96>>3])/2.0);c[A+4>>2]=~~(+(c[K>>2]|0)+ +h[(c[(c[D>>2]|0)+8>>2]|0)+80>>3]/2.0);c[m>>2]=c[z>>2];c[m+4>>2]=c[z+4>>2];c[l>>2]=c[A>>2];c[l+4>>2]=c[A+4>>2];_G(Q,m,l);c[x>>2]=c[Q>>2];c[x+4>>2]=c[Q+4>>2];c[m>>2]=c[z>>2];c[m+4>>2]=c[z+4>>2];c[l>>2]=c[A>>2];c[l+4>>2]=c[A+4>>2];$G(R,m,l);c[y>>2]=c[R>>2];c[y+4>>2]=c[R+4>>2];a=c[x>>2]|0;if((c[x>>2]|0)>=0)ca=(a|0)/(c[s>>2]|0)|0;else ca=((a+1|0)/(c[s>>2]|0)|0)-1|0;c[x>>2]=ca;a=c[x+4>>2]|0;if((c[x+4>>2]|0)>=0)da=(a|0)/(c[s>>2]|0)|0;else da=((a+1|0)/(c[s>>2]|0)|0)-1|0;c[x+4>>2]=da;a=c[y>>2]|0;if((c[y>>2]|0)>=0)ea=(a|0)/(c[s>>2]|0)|0;else ea=((a+1|0)/(c[s>>2]|0)|0)-1|0;c[y>>2]=ea;a=c[y+4>>2]|0;if((c[y+4>>2]|0)>=0)fa=(a|0)/(c[s>>2]|0)|0;else fa=((a+1|0)/(c[s>>2]|0)|0)-1|0;c[y+4>>2]=fa;c[F>>2]=c[x>>2];while(1){if((c[F>>2]|0)>(c[y>>2]|0))break;c[G>>2]=c[x+4>>2];while(1){if((c[G>>2]|0)>(c[y+4>>2]|0))break;YK(c[u>>2]|0,c[F>>2]|0,c[G>>2]|0);c[G>>2]=(c[G>>2]|0)+1}c[F>>2]=(c[F>>2]|0)+1}a=c[z>>2]|0;if((c[z>>2]|0)>=0)ga=(a|0)/(c[s>>2]|0)|0;else ga=((a+1|0)/(c[s>>2]|0)|0)-1|0;c[z>>2]=ga;a=c[z+4>>2]|0;if((c[z+4>>2]|0)>=0)ha=(a|0)/(c[s>>2]|0)|0;else ha=((a+1|0)/(c[s>>2]|0)|0)-1|0;c[z+4>>2]=ha;c[E>>2]=OA(c[C>>2]|0,c[D>>2]|0)|0;while(1){if(!(c[E>>2]|0))break c;a=c[E>>2]|0;b=c[u>>2]|0;e=c[H>>2]|0;f=c[I>>2]|0;g=c[s>>2]|0;p=c[L>>2]|0;c[l>>2]=c[z>>2];c[l+4>>2]=c[z+4>>2];aH(a,l,b,e,f,g,p);c[E>>2]=QA(c[C>>2]|0,c[E>>2]|0)|0}}while(0);c[D>>2]=aC(c[q>>2]|0,c[D>>2]|0)|0}c[N>>2]=0;c[D>>2]=$B(c[q>>2]|0)|0;while(1){if(!(c[D>>2]|0))break;p=c[N>>2]|0;c[N>>2]=p+1;c[(c[(c[D>>2]|0)+8>>2]|0)+112>>2]=c[(c[O>>2]|0)+(p<<2)>>2];c[D>>2]=aC(c[q>>2]|0,c[D>>2]|0)|0}O4(c[O>>2]|0)}else{c[D>>2]=$B(j)|0;while(1){if(!(c[D>>2]|0))break a;pO(S,c[D>>2]|0);c[B>>2]=c[S>>2];c[B+4>>2]=c[S+4>>2];c[B+8>>2]=c[S+8>>2];c[B+12>>2]=c[S+12>>2];W=+h[B>>3];c[z>>2]=~~(+h[B>>3]>=0.0?W+.5:W-.5);W=+h[B+8>>3];c[z+4>>2]=~~(+h[B+8>>3]>=0.0?W+.5:W-.5);c[z>>2]=(c[z>>2]|0)+(c[H>>2]|0);p=z+4|0;c[p>>2]=(c[p>>2]|0)+(c[I>>2]|0);c[A>>2]=~~(+(c[K>>2]|0)+(+h[(c[(c[D>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[D>>2]|0)+8>>2]|0)+96>>3])/2.0);c[A+4>>2]=~~(+(c[K>>2]|0)+ +h[(c[(c[D>>2]|0)+8>>2]|0)+80>>3]/2.0);c[m>>2]=c[z>>2];c[m+4>>2]=c[z+4>>2];c[l>>2]=c[A>>2];c[l+4>>2]=c[A+4>>2];_G(T,m,l);c[x>>2]=c[T>>2];c[x+4>>2]=c[T+4>>2];c[m>>2]=c[z>>2];c[m+4>>2]=c[z+4>>2];c[l>>2]=c[A>>2];c[l+4>>2]=c[A+4>>2];$G(U,m,l);c[y>>2]=c[U>>2];c[y+4>>2]=c[U+4>>2];p=c[x>>2]|0;if((c[x>>2]|0)>=0)ia=(p|0)/(c[s>>2]|0)|0;else ia=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[x>>2]=ia;p=c[x+4>>2]|0;if((c[x+4>>2]|0)>=0)ja=(p|0)/(c[s>>2]|0)|0;else ja=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[x+4>>2]=ja;p=c[y>>2]|0;if((c[y>>2]|0)>=0)ka=(p|0)/(c[s>>2]|0)|0;else ka=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[y>>2]=ka;p=c[y+4>>2]|0;if((c[y+4>>2]|0)>=0)la=(p|0)/(c[s>>2]|0)|0;else la=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[y+4>>2]=la;c[F>>2]=c[x>>2];while(1){if((c[F>>2]|0)>(c[y>>2]|0))break;c[G>>2]=c[x+4>>2];while(1){if((c[G>>2]|0)>(c[y+4>>2]|0))break;YK(c[u>>2]|0,c[F>>2]|0,c[G>>2]|0);c[G>>2]=(c[G>>2]|0)+1}c[F>>2]=(c[F>>2]|0)+1}p=c[z>>2]|0;if((c[z>>2]|0)>=0)ma=(p|0)/(c[s>>2]|0)|0;else ma=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[z>>2]=ma;p=c[z+4>>2]|0;if((c[z+4>>2]|0)>=0)na=(p|0)/(c[s>>2]|0)|0;else na=((p+1|0)/(c[s>>2]|0)|0)-1|0;c[z+4>>2]=na;c[E>>2]=OA(c[C>>2]|0,c[D>>2]|0)|0;while(1){if(!(c[E>>2]|0))break;p=c[E>>2]|0;g=c[u>>2]|0;f=c[H>>2]|0;e=c[I>>2]|0;b=c[s>>2]|0;a=c[L>>2]|0;c[l>>2]=c[z>>2];c[l+4>>2]=c[z+4>>2];aH(p,l,g,f,e,b,a);c[E>>2]=QA(c[C>>2]|0,c[E>>2]|0)|0}c[D>>2]=aC(c[q>>2]|0,c[D>>2]|0)|0}}while(0);D=aL(c[u>>2]|0)|0;c[(c[r>>2]|0)+4>>2]=D;D=$K(c[u>>2]|0)|0;c[(c[r>>2]|0)+8>>2]=D;c[v>>2]=~~+Z(+((+h[(c[(c[q>>2]|0)+8>>2]|0)+16+16>>3]-+h[(c[(c[q>>2]|0)+8>>2]|0)+16>>3]+ +(c[K>>2]<<1|0))/+(c[s>>2]|0)));c[w>>2]=~~+Z(+((+h[(c[(c[q>>2]|0)+8>>2]|0)+16+16+8>>3]-+h[(c[(c[q>>2]|0)+8>>2]|0)+16+8>>3]+ +(c[K>>2]<<1|0))/+(c[s>>2]|0)));c[c[r>>2]>>2]=(c[v>>2]|0)+(c[w>>2]|0);if((d[138998]|0|0)<=2){oa=c[u>>2]|0;WK(oa);i=k;return 0}s=c[24742]|0;K=wB(c[q>>2]|0)|0;q=c[(c[r>>2]|0)+8>>2]|0;D=c[v>>2]|0;v=c[w>>2]|0;c[o>>2]=K;c[o+4>>2]=q;c[o+8>>2]=D;c[o+12>>2]=v;Y2(s,137100,o)|0;c[V>>2]=0;while(1){if((c[V>>2]|0)>=(c[(c[r>>2]|0)+8>>2]|0))break;o=c[24742]|0;s=c[(c[(c[r>>2]|0)+4>>2]|0)+(c[V>>2]<<3)+4>>2]|0;c[n>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+(c[V>>2]<<3)>>2];c[n+4>>2]=s;Y2(o,137127,n)|0;c[V>>2]=(c[V>>2]|0)+1}oa=c[u>>2]|0;WK(oa);i=k;return 0}function ZG(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+48|0;h=g+40|0;j=g;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+12|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=e;c[n>>2]=c[(c[k>>2]|0)+4>>2];c[o>>2]=c[(c[k>>2]|0)+8>>2];c[c[m>>2]>>2]=0-(c[f>>2]|0);c[(c[m>>2]|0)+4>>2]=0-(c[f+4>>2]|0);c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[o>>2]|0))break;f=c[l>>2]|0;k=c[n>>2]|0;c[n>>2]=k+8;c[h>>2]=c[k>>2];c[h+4>>2]=c[k+4>>2];XK(f,h);c[p>>2]=(c[p>>2]|0)+1}if((d[138998]|0|0)<2){i=g;return}p=c[24742]|0;h=c[c[m>>2]>>2]|0;n=c[(c[m>>2]|0)+4>>2]|0;c[j>>2]=c[o>>2];c[j+4>>2]=h;c[j+8>>2]=n;Y2(p,137347,j)|0;i=g;return}function _G(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=(c[b>>2]|0)-(c[d>>2]|0);c[f+4>>2]=(c[b+4>>2]|0)-(c[d+4>>2]|0);c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];i=e;return}function $G(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=(c[b>>2]|0)+(c[d>>2]|0);c[f+4>>2]=(c[b+4>>2]|0)+(c[d+4>>2]|0);c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];i=e;return}function aH(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;k=i;i=i+176|0;l=k+112|0;m=k+96|0;n=k+160|0;o=k+156|0;p=k+152|0;q=k+148|0;r=k+144|0;s=k+140|0;t=k+136|0;u=k+132|0;v=k+48|0;w=k+32|0;x=k+16|0;y=k+128|0;z=k;c[n>>2]=a;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;h[w>>3]=+(c[b>>2]|0);h[w+8>>3]=+(c[b+4>>2]|0);if((c[s>>2]|0)!=0?(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;s=v;b=(c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[t>>2]|0)*48|0)|0;j=s+48|0;do{c[s>>2]=c[b>>2];s=s+4|0;b=b+4|0}while((s|0)<(j|0));if(c[v+8>>2]|0){b=v+16|0;c[w>>2]=c[b>>2];c[w+4>>2]=c[b+4>>2];c[w+8>>2]=c[b+8>>2];c[w+12>>2]=c[b+12>>2];b=c[v>>2]|0;c[x>>2]=c[b>>2];c[x+4>>2]=c[b+4>>2];c[x+8>>2]=c[b+8>>2];c[x+12>>2]=c[b+12>>2];c[u>>2]=1}else{b=c[v>>2]|0;c[w>>2]=c[b>>2];c[w+4>>2]=c[b+4>>2];c[w+8>>2]=c[b+8>>2];c[w+12>>2]=c[b+12>>2];b=(c[v>>2]|0)+16|0;c[x>>2]=c[b>>2];c[x+4>>2]=c[b+4>>2];c[x+8>>2]=c[b+8>>2];c[x+12>>2]=c[b+12>>2];c[u>>2]=2}h[w>>3]=+h[w>>3]+ +(c[p>>2]|0);b=w+8|0;h[b>>3]=+h[b>>3]+ +(c[q>>2]|0);A=+h[w>>3];if(+h[w>>3]>=0.0)B=A/+(c[r>>2]|0);else B=(A+1.0)/+(c[r>>2]|0)-1.0;h[w>>3]=B;A=+h[w+8>>3];if(+h[w+8>>3]>=0.0)C=A/+(c[r>>2]|0);else C=(A+1.0)/+(c[r>>2]|0)-1.0;h[w+8>>3]=C;h[x>>3]=+h[x>>3]+ +(c[p>>2]|0);b=x+8|0;h[b>>3]=+h[b>>3]+ +(c[q>>2]|0);A=+h[x>>3];if(+h[x>>3]>=0.0)D=A/+(c[r>>2]|0);else D=(A+1.0)/+(c[r>>2]|0)-1.0;h[x>>3]=D;A=+h[x+8>>3];if(+h[x+8>>3]>=0.0)E=A/+(c[r>>2]|0);else E=(A+1.0)/+(c[r>>2]|0)-1.0;h[x+8>>3]=E;b=c[o>>2]|0;c[m>>2]=c[w>>2];c[m+4>>2]=c[w+4>>2];c[m+8>>2]=c[w+8>>2];c[m+12>>2]=c[w+12>>2];c[l>>2]=c[x>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[l+12>>2]=c[x+12>>2];AG(m,l,b);while(1){if((c[u>>2]|0)>=(c[v+4>>2]|0))break;c[w>>2]=c[x>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];b=(c[v>>2]|0)+(c[u>>2]<<4)|0;c[x>>2]=c[b>>2];c[x+4>>2]=c[b+4>>2];c[x+8>>2]=c[b+8>>2];c[x+12>>2]=c[b+12>>2];h[x>>3]=+h[x>>3]+ +(c[p>>2]|0);b=x+8|0;h[b>>3]=+h[b>>3]+ +(c[q>>2]|0);A=+h[x>>3];if(+h[x>>3]>=0.0)F=A/+(c[r>>2]|0);else F=(A+1.0)/+(c[r>>2]|0)-1.0;h[x>>3]=F;A=+h[x+8>>3];if(+h[x+8>>3]>=0.0)G=A/+(c[r>>2]|0);else G=(A+1.0)/+(c[r>>2]|0)-1.0;h[x+8>>3]=G;b=c[o>>2]|0;c[m>>2]=c[w>>2];c[m+4>>2]=c[w+4>>2];c[m+8>>2]=c[w+8>>2];c[m+12>>2]=c[w+12>>2];c[l>>2]=c[x>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[l+12>>2]=c[x+12>>2];AG(m,l,b);c[u>>2]=(c[u>>2]|0)+1}if(c[v+12>>2]|0){c[w>>2]=c[x>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];c[w+12>>2]=c[x+12>>2];b=v+32|0;c[x>>2]=c[b>>2];c[x+4>>2]=c[b+4>>2];c[x+8>>2]=c[b+8>>2];c[x+12>>2]=c[b+12>>2];h[x>>3]=+h[x>>3]+ +(c[p>>2]|0);b=x+8|0;h[b>>3]=+h[b>>3]+ +(c[q>>2]|0);A=+h[x>>3];if(+h[x>>3]>=0.0)H=A/+(c[r>>2]|0);else H=(A+1.0)/+(c[r>>2]|0)-1.0;h[x>>3]=H;A=+h[x+8>>3];if(+h[x+8>>3]>=0.0)I=A/+(c[r>>2]|0);else I=(A+1.0)/+(c[r>>2]|0)-1.0;h[x+8>>3]=I;b=c[o>>2]|0;c[m>>2]=c[w>>2];c[m+4>>2]=c[w+4>>2];c[m+8>>2]=c[w+8>>2];c[m+12>>2]=c[w+12>>2];c[l>>2]=c[x>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[l+12>>2]=c[x+12>>2];AG(m,l,b)}c[t>>2]=(c[t>>2]|0)+1}i=k;return}t=c[n>>2]|0;c[y>>2]=c[((c[c[n>>2]>>2]&3|0)==2?t:t+-32|0)+28>>2];pO(z,c[y>>2]|0);c[x>>2]=c[z>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];h[x>>3]=+h[x>>3]+ +(c[p>>2]|0);p=x+8|0;h[p>>3]=+h[p>>3]+ +(c[q>>2]|0);I=+h[x>>3];if(+h[x>>3]>=0.0)J=I/+(c[r>>2]|0);else J=(I+1.0)/+(c[r>>2]|0)-1.0;h[x>>3]=J;J=+h[x+8>>3];if(+h[x+8>>3]>=0.0)K=J/+(c[r>>2]|0);else K=(J+1.0)/+(c[r>>2]|0)-1.0;h[x+8>>3]=K;r=c[o>>2]|0;c[m>>2]=c[w>>2];c[m+4>>2]=c[w+4>>2];c[m+8>>2]=c[w+8>>2];c[m+12>>2]=c[w+12>>2];c[l>>2]=c[x>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[l+12>>2]=c[x+12>>2];AG(m,l,r);i=k;return}function bH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[c[h>>2]>>2]=0;e=(nB(qC(c[g>>2]|0)|0)|0)!=0;c[c[j>>2]>>2]=e?1:0;a:do if((c[13868]|0)!=0?(e=zA(c[g>>2]|0,c[13868]|0)|0,c[k>>2]=e,(a[e>>0]|0)!=0):0){c[l>>2]=54580;while(1){if(!(c[c[l>>2]>>2]|0))break a;if((a[c[k>>2]>>0]|0)==(a[c[c[l>>2]>>2]>>0]|0)?(J3(c[k>>2]|0,c[c[l>>2]>>2]|0)|0)==0:0)break;c[l>>2]=(c[l>>2]|0)+12}c[c[h>>2]>>2]=c[(c[l>>2]|0)+4>>2];c[c[j>>2]>>2]=c[(c[l>>2]|0)+8>>2]}while(0);if(((c[13879]|0)!=0?(c[c[j>>2]>>2]|0)==1:0)?(l=zA(c[g>>2]|0,c[13879]|0)|0,c[k>>2]=l,(a[l>>0]|0)!=0):0)iH(c[k>>2]|0,c[j>>2]|0);if(((c[13880]|0)!=0?(c[c[h>>2]>>2]|0)==1:0)?(l=zA(c[g>>2]|0,c[13880]|0)|0,c[k>>2]=l,(a[l>>0]|0)!=0):0)iH(c[k>>2]|0,c[h>>2]|0);if(!(a[(c[(c[g>>2]|0)+8>>2]|0)+153>>0]|0)){i=f;return}k=c[g>>2]|0;l=qC(c[((c[c[g>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)|0;k=c[g>>2]|0;e=c[g>>2]|0;c[m>>2]=VA(l,c[((c[c[g>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0,c[((c[c[g>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0,0,0)|0;bH(c[m>>2]|0,n,o);c[c[j>>2]>>2]=c[c[j>>2]>>2]|c[n>>2];c[c[h>>2]>>2]=c[c[h>>2]>>2]|c[o>>2];i=f;return}function cH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;j=d;k=d+12|0;l=d+8|0;c[e>>2]=a;c[f>>2]=b;h[j>>3]=0.0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=4)break;c[k>>2]=c[f>>2]>>(c[l>>2]<<3)&15;c[g>>2]=33736;while(1){if(!(c[(c[g>>2]|0)+16>>2]|0))break;m=c[g>>2]|0;if((c[k>>2]|0)==(c[c[g>>2]>>2]|0)){n=6;break}c[g>>2]=m+24}if((n|0)==6){n=0;h[j>>3]=+h[j>>3]+ +h[m+8>>3]}c[l>>2]=(c[l>>2]|0)+1}o=+h[j>>3]*10.0;p=o*+fO(c[e>>2]|0,c[13872]|0,1.0,0.0);i=d;return +p}function dH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+112|0;k=j+108|0;l=j+104|0;m=j+100|0;n=j+96|0;o=j+92|0;p=j+88|0;q=j+80|0;r=j+16|0;s=j+8|0;t=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;h[s>>3]=+cH(c[k>>2]|0,c[p>>2]|0);h[t>>3]=+h[s>>3]*+h[s>>3];c[(c[o>>2]|0)+12>>2]=c[p>>2];p=(c[o>>2]|0)+32|0;s=(c[l>>2]|0)+((c[n>>2]|0)+3<<4)|0;c[p>>2]=c[s>>2];c[p+4>>2]=c[s+4>>2];c[p+8>>2]=c[s+8>>2];c[p+12>>2]=c[s+12>>2];if((c[n>>2]|0)>(c[m>>2]|0)?(+h[(c[l>>2]|0)+(c[n>>2]<<4)>>3]-+h[(c[l>>2]|0)+((c[n>>2]|0)+3<<4)>>3])*(+h[(c[l>>2]|0)+(c[n>>2]<<4)>>3]-+h[(c[l>>2]|0)+((c[n>>2]|0)+3<<4)>>3])+(+h[(c[l>>2]|0)+(c[n>>2]<<4)+8>>3]-+h[(c[l>>2]|0)+((c[n>>2]|0)+3<<4)+8>>3])*(+h[(c[l>>2]|0)+(c[n>>2]<<4)+8>>3]-+h[(c[l>>2]|0)+((c[n>>2]|0)+3<<4)+8>>3])<+h[t>>3]:0)c[n>>2]=(c[n>>2]|0)-3;m=r+48|0;s=(c[l>>2]|0)+(c[n>>2]<<4)|0;c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];s=r+32|0;m=(c[l>>2]|0)+((c[n>>2]|0)+1<<4)|0;c[s>>2]=c[m>>2];c[s+4>>2]=c[m+4>>2];c[s+8>>2]=c[m+8>>2];c[s+12>>2]=c[m+12>>2];m=r+16|0;s=(c[l>>2]|0)+((c[n>>2]|0)+2<<4)|0;c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];s=(c[o>>2]|0)+32|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];c[q>>2]=r;c[q+4>>2]=t;gN(q,92,r,1);q=(c[l>>2]|0)+(c[n>>2]<<4)|0;t=r+48|0;c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];c[q+12>>2]=c[t+12>>2];t=(c[l>>2]|0)+((c[n>>2]|0)+1<<4)|0;q=r+32|0;c[t>>2]=c[q>>2];c[t+4>>2]=c[q+4>>2];c[t+8>>2]=c[q+8>>2];c[t+12>>2]=c[q+12>>2];q=(c[l>>2]|0)+((c[n>>2]|0)+2<<4)|0;t=r+16|0;c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];c[q+12>>2]=c[t+12>>2];t=(c[l>>2]|0)+((c[n>>2]|0)+3<<4)|0;c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];c[t+12>>2]=c[r+12>>2];i=j;return c[n>>2]|0}
function PN(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[f>>2]=a;h[g>>3]=d;if((c[(c[f>>2]|0)+4>>2]|0)>=(c[(c[f>>2]|0)+8>>2]|0)){a=(c[f>>2]|0)+8|0;c[a>>2]=c[a>>2]<<1;a=eK(c[c[f>>2]>>2]|0,c[(c[f>>2]|0)+8>>2]<<6)|0;c[c[f>>2]>>2]=a}h[(c[c[f>>2]>>2]|0)+(c[(c[f>>2]|0)+4>>2]<<6)>>3]=+h[b>>3];h[(c[c[f>>2]>>2]|0)+(c[(c[f>>2]|0)+4>>2]<<6)+8>>3]=+h[b+8>>3];d=+h[g>>3];g=(c[f>>2]|0)+4|0;b=c[g>>2]|0;c[g>>2]=b+1;h[(c[c[f>>2]>>2]|0)+(b<<6)+16>>3]=d;i=e;return}function QN(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0;c=i;i=i+16|0;d=c+8|0;e=c;h[d>>3]=+h[a>>3]-+h[b>>3];h[e>>3]=+h[a+8>>3]-+h[b+8>>3];f=+O(+(+h[d>>3]*+h[d>>3]+ +h[e>>3]*+h[e>>3]));i=c;return +f}function RN(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[(c[d>>2]|0)+8>>2]|0)<=(c[(c[d>>2]|0)+4>>2]|0)){i=b;return}a=eK(c[c[d>>2]>>2]|0,c[(c[d>>2]|0)+4>>2]<<6)|0;c[c[d>>2]>>2]=a;i=b;return}function SN(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+8|0;h=f;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=0;c[m>>2]=0;if(!(c[(c[k>>2]|0)+4>>2]|0))La(144274,144285,202,144296);c[n>>2]=c[(c[k>>2]|0)+4>>2];if(!(c[c[n>>2]>>2]|0))La(144310,144285,205,144296);if(!(c[(c[n>>2]|0)+8>>2]|0)){e=UN(c[c[n>>2]>>2]|0)|0;c[(c[n>>2]|0)+8>>2]=e}if((d[138998]|0|0)!=0?(GH(c[c[n>>2]>>2]|0)|0)!=0:0)c[l>>2]=m;if(!((rS(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0)<<24>>24))VN(c[k>>2]|0,c[l>>2]|0);do if(c[l>>2]|0){j=c[24742]|0;e=c[c[n>>2]>>2]|0;if(c[m>>2]|0){b=c[m>>2]|0;c[h>>2]=e;c[h+4>>2]=b;Y2(j,144321,h)|0;break}else{c[g>>2]=e;Y2(j,144353,g)|0;break}}while(0);g=(c[k>>2]|0)+32|0;c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=f;return}function TN(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[(c[d>>2]|0)+108>>2]=0;c[(c[d>>2]|0)+108+4>>2]=32;c[(c[d>>2]|0)+108+8>>2]=-1;c[(c[d>>2]|0)+108+12>>2]=37;c[(c[d>>2]|0)+108+16>>2]=60;c[(c[d>>2]|0)+108+20>>2]=55;c[(c[d>>2]|0)+108+24>>2]=0;c[(c[d>>2]|0)+108+28>>2]=0;c[(c[d>>2]|0)+108+32>>2]=0;a=Nz((c[d>>2]|0)+108|0,c[12989]|0)|0;c[(c[d>>2]|0)+144>>2]=a;i=b;return c[(c[d>>2]|0)+144>>2]|0}function UN(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[14384]|0)!=0?(F3(c[14384]|0,c[d>>2]|0)|0)==0:0){e=c[14708]|0;i=b;return e|0}c[14384]=c[d>>2];c[14708]=v3(57536,57572,35,36,95)|0;e=c[14708]|0;i=b;return e|0}function VN(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f+28|0;j=f+24|0;k=f+20|0;l=f;m=f+32|0;n=f+16|0;o=f+12|0;p=f+8|0;c[g>>2]=b;c[j>>2]=e;c[p>>2]=c[c[(c[g>>2]|0)+4>>2]>>2];h[l>>3]=+h[(c[(c[g>>2]|0)+4>>2]|0)+16>>3];h[(c[g>>2]|0)+32>>3]=0.0;h[(c[g>>2]|0)+32+8>>3]=+h[l>>3]*1.2;h[(c[g>>2]|0)+16>>3]=0.0;h[(c[g>>2]|0)+24>>3]=+h[l>>3]*.1;c[(c[g>>2]|0)+8>>2]=0;c[(c[g>>2]|0)+12>>2]=0;do if(O3(c[p>>2]|0,144387,4)|0){if((O3(c[p>>2]|0,144411,5)|0)!=0?(O3(c[p>>2]|0,144417,9)|0)!=0:0){c[o>>2]=144444;c[k>>2]=40856;break}c[o>>2]=144427;c[k>>2]=38808}else{c[o>>2]=144392;c[k>>2]=36760}while(0);if(c[j>>2]|0)c[c[j>>2]>>2]=c[o>>2];o=c[c[g>>2]>>2]|0;c[n>>2]=o;if(!o){i=f;return}while(1){o=c[n>>2]|0;c[n>>2]=o+1;j=a[o>>0]|0;a[m>>0]=j;if(!(j<<24>>24))break;j=(c[g>>2]|0)+32|0;h[j>>3]=+h[j>>3]+ +h[(c[k>>2]|0)+((d[m>>0]|0)<<3)>>3]}m=(c[g>>2]|0)+32|0;h[m>>3]=+h[m>>3]*+h[l>>3];i=f;return}function WN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+12|0;g=e+4|0;j=e;c[e+16>>2]=a;c[f>>2]=b;c[e+8>>2]=d;c[g>>2]=c[f>>2];c[j>>2]=P4(1,32)|0;if(c[c[g>>2]>>2]|0){f=M3(c[c[g>>2]>>2]|0)|0;c[c[j>>2]>>2]=f}if(c[(c[g>>2]|0)+4>>2]|0){f=M3(c[(c[g>>2]|0)+4>>2]|0)|0;c[(c[j>>2]|0)+4>>2]=f}f=(c[j>>2]|0)+24|0;c[f>>2]=c[f>>2]&-128|c[(c[g>>2]|0)+24>>2]&127;h[(c[j>>2]|0)+16>>3]=+h[(c[g>>2]|0)+16>>3];c[(c[j>>2]|0)+8>>2]=c[(c[g>>2]|0)+8>>2];i=e;return c[j>>2]|0}function XN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=c[f>>2];if(c[c[g>>2]>>2]|0)O4(c[c[g>>2]>>2]|0);if(!(c[(c[g>>2]|0)+4>>2]|0)){h=c[g>>2]|0;O4(h);i=e;return}O4(c[(c[g>>2]|0)+4>>2]|0);h=c[g>>2]|0;O4(h);i=e;return}function YN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+28|0;j=f+20|0;k=f+16|0;l=f+8|0;m=f+4|0;n=f;c[f+24>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f+12>>2]=e;c[m>>2]=c[j>>2];c[n>>2]=c[k>>2];if((c[c[m>>2]>>2]|0)==0?(c[c[n>>2]>>2]|0)==0:0)o=9;else o=3;do if((o|0)==3){if(!(c[c[m>>2]>>2]|0)){c[g>>2]=-1;break}if(!(c[c[n>>2]>>2]|0)){c[g>>2]=1;break}c[l>>2]=J3(c[c[m>>2]>>2]|0,c[c[n>>2]>>2]|0)|0;if(c[l>>2]|0)c[g>>2]=c[l>>2];else o=9}while(0);do if((o|0)==9){if(!((c[(c[m>>2]|0)+4>>2]|0)==0?(c[(c[n>>2]|0)+4>>2]|0)==0:0)){if(!(c[(c[m>>2]|0)+4>>2]|0)){c[g>>2]=-1;break}if(!(c[(c[n>>2]|0)+4>>2]|0)){c[g>>2]=1;break}c[l>>2]=J3(c[(c[m>>2]|0)+4>>2]|0,c[(c[n>>2]|0)+4>>2]|0)|0;if(c[l>>2]|0){c[g>>2]=c[l>>2];break}}c[l>>2]=(c[(c[m>>2]|0)+24>>2]&127)-(c[(c[n>>2]|0)+24>>2]&127);if(c[l>>2]|0){c[g>>2]=c[l>>2];break}if(+h[(c[m>>2]|0)+16>>3]<+h[(c[n>>2]|0)+16>>3]){c[g>>2]=-1;break}if(+h[(c[m>>2]|0)+16>>3]>+h[(c[n>>2]|0)+16>>3]){c[g>>2]=1;break}else{c[g>>2]=0;break}}while(0);i=f;return c[g>>2]|0}function ZN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=F3(c[c[e>>2]>>2]|0,c[c[f>>2]>>2]|0)|0;i=d;return b|0}function _N(){Ra(58836)|0;return}function $N(){var a=0,b=0,d=0;a=i;i=i+32|0;b=a+8|0;d=a;Ra(b|0)|0;h[d>>3]=+((c[b>>2]|0)+(c[b+4>>2]|0)-(c[14709]|0)-(c[14710]|0)|0)/60.0;i=a;return +(+h[d>>3])}function aO(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=bK(16)|0;if((c[d>>2]|0)<=1)c[d>>2]=2;a=bK(c[d>>2]<<2)|0;c[c[e>>2]>>2]=a;c[(c[e>>2]|0)+12>>2]=a;c[(c[e>>2]|0)+8>>2]=a;c[(c[e>>2]|0)+4>>2]=(c[c[e>>2]>>2]|0)+(c[d>>2]<<2);i=b;return c[e>>2]|0}function bO(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[d>>2]>>2]|0);O4(c[d>>2]|0);i=b;return}function cO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=c[f>>2]|0;f=(c[e>>2]|0)+12|0;a=c[f>>2]|0;c[f>>2]=a+4;c[a>>2]=b;if((c[(c[e>>2]|0)+12>>2]|0)>>>0<(c[(c[e>>2]|0)+4>>2]|0)>>>0){i=d;return}c[(c[e>>2]|0)+12>>2]=c[c[e>>2]>>2];i=d;return}function dO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if((c[(c[d>>2]|0)+8>>2]|0)==(c[(c[d>>2]|0)+12>>2]|0)){c[e>>2]=0;f=c[e>>2]|0;i=b;return f|0}a=(c[d>>2]|0)+8|0;g=c[a>>2]|0;c[a>>2]=g+4;c[e>>2]=c[g>>2];if((c[(c[d>>2]|0)+8>>2]|0)>>>0<(c[(c[d>>2]|0)+4>>2]|0)>>>0){f=c[e>>2]|0;i=b;return f|0}c[(c[d>>2]|0)+8>>2]=c[c[d>>2]>>2];f=c[e>>2]|0;i=b;return f|0}function eO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;do if(!(c[k>>2]|0))c[h>>2]=c[l>>2];else{c[n>>2]=zA(c[j>>2]|0,c[k>>2]|0)|0;if((c[n>>2]|0)!=0?(a[c[n>>2]>>0]|0)!=0:0){c[p>>2]=z3(c[n>>2]|0,o,10)|0;if((c[n>>2]|0)==(c[o>>2]|0)){c[h>>2]=c[l>>2];break}if((c[p>>2]|0)<(c[m>>2]|0)){c[h>>2]=c[m>>2];break}else{c[h>>2]=c[p>>2];break}}c[h>>2]=c[l>>2]}while(0);i=g;return c[h>>2]|0}function fO(b,d,e,f){b=b|0;d=d|0;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+48|0;j=g+24|0;k=g+44|0;l=g+40|0;m=g+16|0;n=g+8|0;o=g+36|0;p=g+32|0;q=g;c[k>>2]=b;c[l>>2]=d;h[m>>3]=e;h[n>>3]=f;do if((c[l>>2]|0)!=0&(c[k>>2]|0)!=0){c[o>>2]=zA(c[k>>2]|0,c[l>>2]|0)|0;if((c[o>>2]|0)!=0?(a[c[o>>2]>>0]|0)!=0:0){h[q>>3]=+x3(c[o>>2]|0,p);if((c[o>>2]|0)==(c[p>>2]|0)){h[j>>3]=+h[m>>3];break}if(+h[q>>3]<+h[n>>3]){h[j>>3]=+h[n>>3];break}else{h[j>>3]=+h[q>>3];break}}h[j>>3]=+h[m>>3]}else h[j>>3]=+h[m>>3];while(0);i=g;return +(+h[j>>3])}function gO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+8|0;e=b+16|0;f=b;c[e>>2]=a;do if(!(+h[4246]>0.0)){a=c[e>>2]|0;h[f>>3]=+fO(a,qA(c[e>>2]|0,0,145254,0)|0,-1.0,0.0);if(+h[f>>3]==0.0){h[d>>3]=72.0;break}else{h[d>>3]=+h[f>>3];break}}else h[d>>3]=+h[4246];while(0);i=b;return +(+h[d>>3])}function hO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[h>>2]|0)!=0&(c[g>>2]|0)!=0){c[f>>2]=zA(c[g>>2]|0,c[h>>2]|0)|0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=c[j>>2];k=c[f>>2]|0;i=e;return k|0}return 0}function iO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[k>>2]=hO(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;if((c[k>>2]|0)!=0?(a[c[k>>2]>>0]|0)!=0:0){l=c[k>>2]|0;i=f;return l|0}c[k>>2]=c[j>>2];l=c[k>>2]|0;i=f;return l|0}function jO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[j>>2]|0)){a[g>>0]=c[k>>2];l=a[g>>0]|0;i=f;return l|0}else{a[g>>0]=kO(zA(c[h>>2]|0,c[j>>2]|0)|0)|0;l=a[g>>0]|0;i=f;return l|0}return 0}function kO(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=uO(c[d>>2]|0,0)|0;i=b;return a|0}function lO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;while(1){if(c[(c[(c[d>>2]|0)+8>>2]|0)+220>>2]|0)e=(c[(c[(c[d>>2]|0)+8>>2]|0)+220>>2]|0)!=(c[d>>2]|0);else e=0;f=c[d>>2]|0;if(!e)break;if(c[(c[(c[(c[f+8>>2]|0)+220>>2]|0)+8>>2]|0)+220>>2]|0)c[(c[(c[d>>2]|0)+8>>2]|0)+220>>2]=c[(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+220>>2]|0)+8>>2]|0)+220>>2];c[d>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+220>>2]}i=b;return f|0}function mO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=b;h=c[e>>2]|0;i=d;return h|0}a=c[f>>2]|0;if(!(c[(c[b+8>>2]|0)+220>>2]|0)){c[(c[(c[f>>2]|0)+8>>2]|0)+220>>2]=a;c[(c[(c[f>>2]|0)+8>>2]|0)+216>>2]=1}else c[f>>2]=lO(a)|0;a=c[g>>2]|0;if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+220>>2]|0)){c[(c[(c[g>>2]|0)+8>>2]|0)+220>>2]=a;c[(c[(c[g>>2]|0)+8>>2]|0)+216>>2]=1}else c[g>>2]=lO(a)|0;if((c[(c[(c[f>>2]|0)+8>>2]|0)+120>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+120>>2]|0)){c[(c[(c[f>>2]|0)+8>>2]|0)+220>>2]=c[g>>2];a=(c[(c[g>>2]|0)+8>>2]|0)+216|0;c[a>>2]=(c[a>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+216>>2]|0)}else{c[(c[(c[g>>2]|0)+8>>2]|0)+220>>2]=c[f>>2];a=(c[(c[f>>2]|0)+8>>2]|0)+216|0;c[a>>2]=(c[a>>2]|0)+(c[(c[(c[g>>2]|0)+8>>2]|0)+216>>2]|0);c[g>>2]=c[f>>2]}c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}function nO(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]=1;c[(c[(c[e>>2]|0)+8>>2]|0)+220>>2]=0;a[(c[(c[e>>2]|0)+8>>2]|0)+159>>0]=0;i=d;return}function oO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=c[e>>2]|0;if((b|0)==(lO(c[e>>2]|0)|0)){c[(c[(c[e>>2]|0)+8>>2]|0)+220>>2]=c[f>>2];b=(c[(c[f>>2]|0)+8>>2]|0)+216|0;c[b>>2]=(c[b>>2]|0)+(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0);i=d;return}else La(145273,145265,195,145289)}function pO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+16|0;f=d;c[e>>2]=b;h[f>>3]=+h[c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]>>3]*72.0;h[f+8>>3]=+h[(c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]*72.0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=d;return}function qO(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+608|0;k=j+604|0;l=j+600|0;m=j+576|0;n=j+596|0;o=j+592|0;p=j+588|0;q=j+584|0;r=j;c[k>>2]=b;c[l>>2]=d;h[m>>3]=e;c[n>>2]=f;c[o>>2]=g;c[q>>2]=0;while(1){if((c[q>>2]|0)>(c[l>>2]|0))break;g=r+(c[q>>2]<<4)|0;f=(c[k>>2]|0)+(c[q>>2]<<4)|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];c[q>>2]=(c[q>>2]|0)+1}c[p>>2]=1;while(1){if((c[p>>2]|0)>(c[l>>2]|0))break;c[q>>2]=0;while(1){if((c[q>>2]|0)>((c[l>>2]|0)-(c[p>>2]|0)|0))break;h[r+((c[p>>2]|0)*96|0)+(c[q>>2]<<4)>>3]=(1.0-+h[m>>3])*+h[r+(((c[p>>2]|0)-1|0)*96|0)+(c[q>>2]<<4)>>3]+ +h[m>>3]*+h[r+(((c[p>>2]|0)-1|0)*96|0)+((c[q>>2]|0)+1<<4)>>3];h[r+((c[p>>2]|0)*96|0)+(c[q>>2]<<4)+8>>3]=(1.0-+h[m>>3])*+h[r+(((c[p>>2]|0)-1|0)*96|0)+(c[q>>2]<<4)+8>>3]+ +h[m>>3]*+h[r+(((c[p>>2]|0)-1|0)*96|0)+((c[q>>2]|0)+1<<4)+8>>3];c[q>>2]=(c[q>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}a:do if(c[n>>2]|0){c[q>>2]=0;while(1){if((c[q>>2]|0)>(c[l>>2]|0))break a;p=(c[n>>2]|0)+(c[q>>2]<<4)|0;m=r+((c[q>>2]|0)*96|0)|0;c[p>>2]=c[m>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2];c[p+12>>2]=c[m+12>>2];c[q>>2]=(c[q>>2]|0)+1}}while(0);if(!(c[o>>2]|0)){s=c[l>>2]|0;t=r+(s*96|0)|0;c[a>>2]=c[t>>2];c[a+4>>2]=c[t+4>>2];c[a+8>>2]=c[t+8>>2];c[a+12>>2]=c[t+12>>2];i=j;return}c[q>>2]=0;while(1){if((c[q>>2]|0)>(c[l>>2]|0))break;n=(c[o>>2]|0)+(c[q>>2]<<4)|0;m=r+(((c[l>>2]|0)-(c[q>>2]|0)|0)*96|0)+(c[q>>2]<<4)|0;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];c[q>>2]=(c[q>>2]|0)+1}s=c[l>>2]|0;t=r+(s*96|0)|0;c[a>>2]=c[t>>2];c[a+4>>2]=c[t+4>>2];c[a+8>>2]=c[t+8>>2];c[a+12>>2]=c[t+12>>2];i=j;return}function rO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=b;c[h>>2]=0;do{if(((c[14713]|0)-(c[h>>2]|0)|0)<1024){c[14713]=(c[14713]|0)+1024;c[14714]=eK(c[14714]|0,c[14713]|0)|0}c[g>>2]=V2((c[14714]|0)+(c[h>>2]|0)|0,(c[14713]|0)-(c[h>>2]|0)|0,c[f>>2]|0)|0;if(!(c[g>>2]|0))break;b=N3(c[g>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+b}while((a[(c[14714]|0)+((c[h>>2]|0)-1)>>0]|0)!=10);if((c[h>>2]|0)>0){c[e>>2]=c[14714];j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function sO(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+8|0;g=e;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;c[j>>2]=b;if((c[j>>2]|0)!=0?(a[c[j>>2]>>0]|0)!=0:0){if(!(c[13794]|0)){if((c[14715]|0)!=(c[13793]|0)){if(c[14717]|0){O4(c[c[14717]>>2]|0);O4(c[14717]|0);c[14717]=0}c[14715]=c[13793];if((c[14715]|0)!=0?(a[c[14715]>>0]|0)!=0:0)c[14717]=XO(c[14715]|0,58864)|0}if((c[14717]|0)!=0?(a[c[j>>2]>>0]|0)!=(a[145579]|0):0){c[h>>2]=YO(c[14717]|0,c[14716]|0,c[j>>2]|0)|0;m=c[h>>2]|0;i=e;return m|0}else{c[h>>2]=c[j>>2];m=c[h>>2]|0;i=e;return m|0}}if((c[13792]|0)!=0?(a[c[13792]>>0]|0)!=0:0){if(!(c[14715]|0)){c[14717]=XO(c[13792]|0,58864)|0;c[14715]=c[13792]}c[k>>2]=c[j>>2];b=S3(c[k>>2]|0,47)|0;c[l>>2]=b;if(b){b=(c[l>>2]|0)+1|0;c[l>>2]=b;c[k>>2]=b}b=S3(c[k>>2]|0,92)|0;c[l>>2]=b;if(b){b=(c[l>>2]|0)+1|0;c[l>>2]=b;c[k>>2]=b}b=S3(c[k>>2]|0,58)|0;c[l>>2]=b;if(b){b=(c[l>>2]|0)+1|0;c[l>>2]=b;c[k>>2]=b}if((d[145300]|0)!=0?(c[k>>2]|0)!=(c[j>>2]|0):0){b=c[13792]|0;c[f>>2]=c[j>>2];c[f+4>>2]=b;$z(0,145426,f)|0;a[145300]=0}c[h>>2]=YO(c[14717]|0,c[14716]|0,c[k>>2]|0)|0;m=c[h>>2]|0;i=e;return m|0}if(a[145300]|0){c[g>>2]=c[13794];$z(0,145301,g)|0;a[145300]=0}c[h>>2]=0;m=c[h>>2]|0;i=e;return m|0}c[h>>2]=0;m=c[h>>2]|0;i=e;return m|0}function tO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[k>>2]=0;while(1){e=c[(c[h>>2]|0)+(c[k>>2]<<2)>>2]|0;c[l>>2]=e;if(!e){m=7;break}if(((c[g>>2]|0)!=0?(a[c[g>>2]>>0]|0)==(a[c[l>>2]>>0]|0):0)?(J3(c[g>>2]|0,c[l>>2]|0)|0)==0:0){m=7;break}c[k>>2]=(c[k>>2]|0)+1}if((m|0)==7){i=f;return c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0}return 0}function uO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+5|0;g=e;h=e+4|0;c[g>>2]=b;a[h>>0]=d;do if((c[g>>2]|0)!=0?(a[c[g>>2]>>0]|0)!=0:0){if(!(F3(c[g>>2]|0,174911)|0)){a[f>>0]=0;break}if(!(F3(c[g>>2]|0,145581)|0)){a[f>>0]=0;break}if(!(F3(c[g>>2]|0,145584)|0)){a[f>>0]=1;break}if(!(F3(c[g>>2]|0,145589)|0)){a[f>>0]=1;break}if(p1(a[c[g>>2]>>0]|0)|0){a[f>>0]=u3(c[g>>2]|0)|0;break}else{a[f>>0]=a[h>>0]|0;break}}else j=3;while(0);if((j|0)==3)a[f>>0]=a[h>>0]|0;i=e;return a[f>>0]|0}function vO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;e=i;i=i+240|0;f=e+236|0;g=e+232|0;j=e+228|0;k=e+224|0;l=e+220|0;m=e+216|0;n=e+208|0;o=e+200|0;p=e+192|0;q=e+184|0;r=e+176|0;s=e+168|0;t=e+160|0;u=e+96|0;v=e+80|0;w=e+32|0;x=e+16|0;y=e;c[f>>2]=b;c[m>>2]=-1;c[l>>2]=-1;h[n>>3]=1.e+38;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;z=w;A=(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*48|0)|0;B=z+48|0;do{c[z>>2]=c[A>>2];z=z+4|0;A=A+4|0}while((z|0)<(B|0));c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[w+4>>2]|0))break;h[x>>3]=+h[(c[w>>2]|0)+(c[j>>2]<<4)>>3];h[x+8>>3]=+h[(c[w>>2]|0)+(c[j>>2]<<4)+8>>3];h[o>>3]=(+h[x>>3]-+h[d>>3])*(+h[x>>3]-+h[d>>3])+(+h[x+8>>3]-+h[d+8>>3])*(+h[x+8>>3]-+h[d+8>>3]);if(!((c[m>>2]|0)!=-1?!(+h[o>>3]<+h[n>>3]):0)){c[l>>2]=c[g>>2];c[m>>2]=c[j>>2];h[n>>3]=+h[o>>3]}c[j>>2]=(c[j>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1}z=w;A=(c[c[f>>2]>>2]|0)+((c[l>>2]|0)*48|0)|0;B=z+48|0;do{c[z>>2]=c[A>>2];z=z+4|0;A=A+4|0}while((z|0)<(B|0));if((c[m>>2]|0)==((c[w+4>>2]|0)-1|0))c[m>>2]=(c[m>>2]|0)+-1;c[j>>2]=((c[m>>2]|0)/3|0)*3;c[k>>2]=0;while(1){if((c[k>>2]|0)>=4)break;h[u+(c[k>>2]<<4)>>3]=+h[(c[w>>2]|0)+((c[j>>2]|0)+(c[k>>2]|0)<<4)>>3];h[u+(c[k>>2]<<4)+8>>3]=+h[(c[w>>2]|0)+((c[j>>2]|0)+(c[k>>2]|0)<<4)+8>>3];c[k>>2]=(c[k>>2]|0)+1}h[r>>3]=0.0;h[s>>3]=1.0;h[p>>3]=(+h[u>>3]-+h[d>>3])*(+h[u>>3]-+h[d>>3])+(+h[u+8>>3]-+h[d+8>>3])*(+h[u+8>>3]-+h[d+8>>3]);h[q>>3]=(+h[u+48>>3]-+h[d>>3])*(+h[u+48>>3]-+h[d>>3])+(+h[u+48+8>>3]-+h[d+8>>3])*(+h[u+48+8>>3]-+h[d+8>>3]);while(1){h[t>>3]=(+h[r>>3]+ +h[s>>3])/2.0;qO(y,u,3,+h[t>>3],0,0);c[v>>2]=c[y>>2];c[v+4>>2]=c[y+4>>2];c[v+8>>2]=c[y+8>>2];c[v+12>>2]=c[y+12>>2];if(+N(+(+h[p>>3]-+h[q>>3]))<1.0){C=21;break}if(+N(+(+h[s>>3]-+h[r>>3]))<1.0e-05){C=21;break}D=+h[t>>3];if(+h[p>>3]<+h[q>>3]){h[s>>3]=D;h[q>>3]=(+h[v>>3]-+h[d>>3])*(+h[v>>3]-+h[d>>3])+(+h[v+8>>3]-+h[d+8>>3])*(+h[v+8>>3]-+h[d+8>>3]);continue}else{h[r>>3]=D;h[p>>3]=(+h[v>>3]-+h[d>>3])*(+h[v>>3]-+h[d>>3])+(+h[v+8>>3]-+h[d+8>>3])*(+h[v+8>>3]-+h[d+8>>3]);continue}}if((C|0)==21){c[a>>2]=c[v>>2];c[a+4>>2]=c[v+4>>2];c[a+8>>2]=c[v+8>>2];c[a+12>>2]=c[v+12>>2];i=e;return}}function wO(){return c[14718]|0}function xO(b){b=b|0;var e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e;j=e+16|0;c[f>>2]=b;k=+fO(c[f>>2]|0,c[13815]|0,.75,.01);h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3]=k;k=+fO(c[f>>2]|0,c[13814]|0,.5,.02);h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3]=k;b=iO(c[f>>2]|0,c[13816]|0,145593)|0;l=gM(b,c[f>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]=l;c[j>>2]=zA(c[f>>2]|0,c[13831]|0)|0;h[g>>3]=+fO(c[f>>2]|0,c[13827]|0,14.0,1.0);c[g+8>>2]=iO(c[f>>2]|0,c[13828]|0,145601)|0;c[g+12>>2]=iO(c[f>>2]|0,c[13829]|0,174917)|0;l=c[f>>2]|0;b=c[j>>2]|0;m=($C(c[j>>2]|0)|0)!=0;n=(dM(c[f>>2]|0)|0)==2;o=SJ(l,b,(m?2:0)|(n?4:0),+h[g>>3],c[g+8>>2]|0,c[g+12>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]=o;if(((c[13832]|0)!=0?(o=zA(c[f>>2]|0,c[13832]|0)|0,c[j>>2]=o,(o|0)!=0):0)?(a[c[j>>2]>>0]|0)!=0:0){o=c[f>>2]|0;n=c[j>>2]|0;m=($C(c[j>>2]|0)|0)!=0;j=SJ(o,n,m?2:0,+h[g>>3],c[g+8>>2]|0,c[g+12>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]=j;j=(c[(qC(c[f>>2]|0)|0)+8>>2]|0)+113|0;a[j>>0]=d[j>>0]|16}j=(eO(c[f>>2]|0,c[13835]|0,0,0)|0)&255;a[(c[(c[f>>2]|0)+8>>2]|0)+144>>0]=j;Bb[c[c[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]>>2]&127](c[f>>2]|0);i=e;return}function yO(b){b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+128|0;f=e+124|0;g=e+120|0;j=e+116|0;k=e+96|0;l=e+80|0;m=e+112|0;n=e+40|0;o=e;c[f>>2]=b;c[j>>2]=0;b=c[f>>2]|0;c[m>>2]=qC(c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0;c[k+8>>2]=0;c[l+8>>2]=0;if(((c[13866]|0)!=0?(b=zA(c[f>>2]|0,c[13866]|0)|0,c[g>>2]=b,(b|0)!=0):0)?(a[c[g>>2]>>0]|0)!=0:0){c[j>>2]=1;ZO(c[f>>2]|0,k);b=c[f>>2]|0;p=c[g>>2]|0;q=($C(c[g>>2]|0)|0)!=0;r=SJ(b,p,q?2:0,+h[k>>3],c[k+8>>2]|0,c[k+12>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]=r;r=(c[(c[m>>2]|0)+8>>2]|0)+113|0;a[r>>0]=d[r>>0]|1;r=kO(hO(c[f>>2]|0,c[13876]|0,174911)|0)|0;a[(c[(c[f>>2]|0)+8>>2]|0)+114>>0]=r}if(((c[13867]|0)!=0?(r=zA(c[f>>2]|0,c[13867]|0)|0,c[g>>2]=r,(r|0)!=0):0)?(a[c[g>>2]>>0]|0)!=0:0){if(!(c[k+8>>2]|0))ZO(c[f>>2]|0,k);r=c[f>>2]|0;q=c[g>>2]|0;p=($C(c[g>>2]|0)|0)!=0;b=SJ(r,q,p?2:0,+h[k>>3],c[k+8>>2]|0,c[k+12>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]=b;b=(c[(c[m>>2]|0)+8>>2]|0)+113|0;a[b>>0]=d[b>>0]|32}if(((c[13881]|0)!=0?(b=zA(c[f>>2]|0,c[13881]|0)|0,c[g>>2]=b,(b|0)!=0):0)?(a[c[g>>2]>>0]|0)!=0:0){_O(c[f>>2]|0,k,l);b=c[f>>2]|0;p=c[g>>2]|0;q=($C(c[g>>2]|0)|0)!=0;r=SJ(b,p,q?2:0,+h[l>>3],c[l+8>>2]|0,c[l+12>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]=r;r=(c[(c[m>>2]|0)+8>>2]|0)+113|0;a[r>>0]=d[r>>0]|2}if(((c[13882]|0)!=0?(r=zA(c[f>>2]|0,c[13882]|0)|0,c[g>>2]=r,(r|0)!=0):0)?(a[c[g>>2]>>0]|0)!=0:0){if(!(c[l+8>>2]|0))_O(c[f>>2]|0,k,l);k=c[f>>2]|0;r=c[g>>2]|0;q=($C(c[g>>2]|0)|0)!=0;p=SJ(k,r,q?2:0,+h[l>>3],c[l+8>>2]|0,c[l+12>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]=p;p=(c[(c[m>>2]|0)+8>>2]|0)+113|0;a[p>>0]=d[p>>0]|4}p=yA(c[f>>2]|0,149070)|0;c[g>>2]=p;c[g>>2]=(c[g>>2]|0)!=0?p:178518;if((c[g>>2]|0)!=0?(a[c[g>>2]>>0]|0)!=0:0){p=c[f>>2]|0;a[(c[(c[((c[c[f>>2]>>2]&3|0)==3?p:p+32|0)+28>>2]|0)+8>>2]|0)+145>>0]=1}p=(c[(c[f>>2]|0)+8>>2]|0)+16|0;m=c[f>>2]|0;l=c[f>>2]|0;$O(n,c[(c[(c[(c[(c[((c[c[f>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+8>>2]|0,c[((c[c[f>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0,c[g>>2]|0);l=p;p=n;n=l+40|0;do{c[l>>2]=c[p>>2];l=l+4|0;p=p+4|0}while((l|0)<(n|0));if((aP(c[f>>2]|0,c[13888]|0)|0)<<24>>24)a[(c[(c[f>>2]|0)+8>>2]|0)+16+30>>0]=0;m=yA(c[f>>2]|0,149061)|0;c[g>>2]=m;c[g>>2]=(c[g>>2]|0)!=0?m:178518;if((c[g>>2]|0)!=0?(a[c[g>>2]>>0]|0)!=0:0){m=c[f>>2]|0;a[(c[(c[((c[c[f>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)+8>>2]|0)+145>>0]=1}m=(c[(c[f>>2]|0)+8>>2]|0)+56|0;q=c[f>>2]|0;r=c[f>>2]|0;$O(o,c[(c[(c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?q:q+-32|0)+28>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+8>>2]|0,c[((c[c[f>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0,c[g>>2]|0);l=m;p=o;n=l+40|0;do{c[l>>2]=c[p>>2];l=l+4|0;p=p+4|0}while((l|0)<(n|0));if(!((aP(c[f>>2]|0,c[13889]|0)|0)<<24>>24)){s=c[j>>2]|0;i=e;return s|0}a[(c[(c[f>>2]|0)+8>>2]|0)+56+30>>0]=0;s=c[j>>2]|0;i=e;return s|0}function zO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;j=d+36|0;k=d+32|0;l=d;c[e>>2]=b;c[g>>2]=c[(c[e>>2]|0)+8>>2];if((c[(c[e>>2]|0)+4>>2]|0)>1)m=c[(c[e>>2]|0)+4>>2]|0;else m=1;c[j>>2]=m;c[k>>2]=(c[(c[e>>2]|0)+44>>2]|0)+((_((c[j>>2]|0)-1|0,c[g>>2]|0)|0)<<4);j=l+16|0;e=c[k>>2]|0;c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[f>>2]=1;while(1){if((c[f>>2]|0)>=(c[g>>2]|0))break;if(+h[l>>3]<+h[(c[k>>2]|0)+(c[f>>2]<<4)>>3])n=+h[l>>3];else n=+h[(c[k>>2]|0)+(c[f>>2]<<4)>>3];h[l>>3]=n;if(+h[l+8>>3]<+h[(c[k>>2]|0)+(c[f>>2]<<4)+8>>3])o=+h[l+8>>3];else o=+h[(c[k>>2]|0)+(c[f>>2]<<4)+8>>3];h[l+8>>3]=o;if(+h[l+16>>3]>+h[(c[k>>2]|0)+(c[f>>2]<<4)>>3])p=+h[l+16>>3];else p=+h[(c[k>>2]|0)+(c[f>>2]<<4)>>3];h[l+16>>3]=p;if(+h[l+16+8>>3]>+h[(c[k>>2]|0)+(c[f>>2]<<4)+8>>3])q=+h[l+16+8>>3];else q=+h[(c[k>>2]|0)+(c[f>>2]<<4)+8>>3];h[l+16+8>>3]=q;c[f>>2]=(c[f>>2]|0)+1}c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];c[a+16>>2]=c[l+16>>2];c[a+20>>2]=c[l+20>>2];c[a+24>>2]=c[l+24>>2];c[a+28>>2]=c[l+28>>2];i=d;return}function AO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+80|0;e=d+32|0;f=d+68|0;g=d+64|0;h=d;c[f>>2]=a;c[g>>2]=b;b=(c[(c[f>>2]|0)+8>>2]|0)+16|0;a=(c[(c[f>>2]|0)+8>>2]|0)+16|0;j=c[g>>2]|0;g=c[(c[(c[f>>2]|0)+8>>2]|0)+116>>2]&1;c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];c[e+16>>2]=c[a+16>>2];c[e+20>>2]=c[a+20>>2];c[e+24>>2]=c[a+24>>2];c[e+28>>2]=c[a+28>>2];bP(h,e,j,g);c[b>>2]=c[h>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];c[b+16>>2]=c[h+16>>2];c[b+20>>2]=c[h+20>>2];c[b+24>>2]=c[h+24>>2];c[b+28>>2]=c[h+28>>2];i=d;return}function BO(a){a=a|0;var b=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0;b=i;i=i+512|0;e=b+448|0;f=b+336|0;g=b+496|0;j=b+492|0;k=b+488|0;l=b+416|0;m=b+384|0;n=b+352|0;o=b+320|0;p=b+304|0;q=b+484|0;r=b+480|0;s=b+288|0;t=b+272|0;u=b+256|0;v=b+240|0;w=b+224|0;x=b+208|0;y=b+192|0;z=b+160|0;A=b+128|0;B=b+96|0;C=b+64|0;D=b+32|0;E=b;c[g>>2]=a;if((kB(c[g>>2]|0)|0)==0?(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0)==0:0){cP(s,0.0,0.0);c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];s=m+16|0;cP(t,0.0,0.0);c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];i=b;return}cP(u,2147483647.0,2147483647.0);c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];c[m+12>>2]=c[u+12>>2];u=m+16|0;cP(v,-2147483647.0,-2147483647.0);c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[j>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;pO(w,c[j>>2]|0);c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];h[p>>3]=(+h[(c[(c[j>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[j>>2]|0)+8>>2]|0)+96>>3])/2.0;h[p+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3]/2.0;c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];c[e+12>>2]=c[p+12>>2];dP(x,f,e);c[l>>2]=c[x>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[l+12>>2]=c[x+12>>2];v=l+16|0;c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];c[e+12>>2]=c[p+12>>2];eP(y,f,e);c[v>>2]=c[y>>2];c[v+4>>2]=c[y+4>>2];c[v+8>>2]=c[y+8>>2];c[v+12>>2]=c[y+12>>2];h[m>>3]=+h[m>>3]<+h[l>>3]?+h[m>>3]:+h[l>>3];h[m+8>>3]=+h[m+8>>3]<+h[l+8>>3]?+h[m+8>>3]:+h[l+8>>3];h[m+16>>3]=+h[m+16>>3]>+h[l+16>>3]?+h[m+16>>3]:+h[l+16>>3];if(+h[m+16+8>>3]>+h[l+16+8>>3])F=+h[m+16+8>>3];else F=+h[l+16+8>>3];h[m+16+8>>3]=F;if((c[(c[(c[j>>2]|0)+8>>2]|0)+108>>2]|0)!=0?(d[(c[(c[(c[j>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0|0)!=0:0){v=c[(c[(c[j>>2]|0)+8>>2]|0)+108>>2]|0;u=c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];c[e+20>>2]=c[m+20>>2];c[e+24>>2]=c[m+24>>2];c[e+28>>2]=c[m+28>>2];bP(z,e,v,u);c[m>>2]=c[z>>2];c[m+4>>2]=c[z+4>>2];c[m+8>>2]=c[z+8>>2];c[m+12>>2]=c[z+12>>2];c[m+16>>2]=c[z+16>>2];c[m+20>>2]=c[z+20>>2];c[m+24>>2]=c[z+24>>2];c[m+28>>2]=c[z+28>>2]}c[k>>2]=OA(c[g>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;if(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0){c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[(c[c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[q>>2]|0)*48|0)+4>>2]|0))break;u=(c[(c[c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[q>>2]|0)*48|0)>>2]|0)+(c[r>>2]<<4)|0;c[o>>2]=c[u>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];h[m>>3]=+h[m>>3]<+h[o>>3]?+h[m>>3]:+h[o>>3];h[m+8>>3]=+h[m+8>>3]<+h[o+8>>3]?+h[m+8>>3]:+h[o+8>>3];h[m+16>>3]=+h[m+16>>3]>+h[o>>3]?+h[m+16>>3]:+h[o>>3];if(+h[m+16+8>>3]>+h[o+8>>3])G=+h[m+16+8>>3];else G=+h[o+8>>3];h[m+16+8>>3]=G;c[r>>2]=(c[r>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+1}if((c[(c[(c[k>>2]|0)+8>>2]|0)+96>>2]|0)!=0?(d[(c[(c[(c[k>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]|0|0)!=0:0){u=c[(c[(c[k>>2]|0)+8>>2]|0)+96>>2]|0;v=c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];c[e+20>>2]=c[m+20>>2];c[e+24>>2]=c[m+24>>2];c[e+28>>2]=c[m+28>>2];bP(A,e,u,v);c[m>>2]=c[A>>2];c[m+4>>2]=c[A+4>>2];c[m+8>>2]=c[A+8>>2];c[m+12>>2]=c[A+12>>2];c[m+16>>2]=c[A+16>>2];c[m+20>>2]=c[A+20>>2];c[m+24>>2]=c[A+24>>2];c[m+28>>2]=c[A+28>>2]}if((c[(c[(c[k>>2]|0)+8>>2]|0)+100>>2]|0)!=0?(d[(c[(c[(c[k>>2]|0)+8>>2]|0)+100>>2]|0)+81>>0]|0|0)!=0:0){v=c[(c[(c[k>>2]|0)+8>>2]|0)+100>>2]|0;u=c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];c[e+20>>2]=c[m+20>>2];c[e+24>>2]=c[m+24>>2];c[e+28>>2]=c[m+28>>2];bP(B,e,v,u);c[m>>2]=c[B>>2];c[m+4>>2]=c[B+4>>2];c[m+8>>2]=c[B+8>>2];c[m+12>>2]=c[B+12>>2];c[m+16>>2]=c[B+16>>2];c[m+20>>2]=c[B+20>>2];c[m+24>>2]=c[B+24>>2];c[m+28>>2]=c[B+28>>2]}if((c[(c[(c[k>>2]|0)+8>>2]|0)+104>>2]|0)!=0?(d[(c[(c[(c[k>>2]|0)+8>>2]|0)+104>>2]|0)+81>>0]|0|0)!=0:0){u=c[(c[(c[k>>2]|0)+8>>2]|0)+104>>2]|0;v=c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];c[e+20>>2]=c[m+20>>2];c[e+24>>2]=c[m+24>>2];c[e+28>>2]=c[m+28>>2];bP(C,e,u,v);c[m>>2]=c[C>>2];c[m+4>>2]=c[C+4>>2];c[m+8>>2]=c[C+8>>2];c[m+12>>2]=c[C+12>>2];c[m+16>>2]=c[C+16>>2];c[m+20>>2]=c[C+20>>2];c[m+24>>2]=c[C+24>>2];c[m+28>>2]=c[C+28>>2]}if((c[(c[(c[k>>2]|0)+8>>2]|0)+108>>2]|0)!=0?(d[(c[(c[(c[k>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0|0)!=0:0){v=c[(c[(c[k>>2]|0)+8>>2]|0)+108>>2]|0;u=c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];c[e+20>>2]=c[m+20>>2];c[e+24>>2]=c[m+24>>2];c[e+28>>2]=c[m+28>>2];bP(D,e,v,u);c[m>>2]=c[D>>2];c[m+4>>2]=c[D+4>>2];c[m+8>>2]=c[D+8>>2];c[m+12>>2]=c[D+12>>2];c[m+16>>2]=c[D+16>>2];c[m+20>>2]=c[D+20>>2];c[m+24>>2]=c[D+24>>2];c[m+28>>2]=c[D+28>>2]}}c[k>>2]=QA(c[g>>2]|0,c[k>>2]|0)|0}c[j>>2]=aC(c[g>>2]|0,c[j>>2]|0)|0}c[q>>2]=1;while(1){if((c[q>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break;h[n>>3]=+h[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[q>>2]<<2)>>2]|0)+8>>2]|0)+16>>3];h[n+8>>3]=+h[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[q>>2]<<2)>>2]|0)+8>>2]|0)+16+8>>3];h[n+16>>3]=+h[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[q>>2]<<2)>>2]|0)+8>>2]|0)+16+16>>3];h[n+16+8>>3]=+h[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[q>>2]<<2)>>2]|0)+8>>2]|0)+16+16+8>>3];h[m>>3]=+h[m>>3]<+h[n>>3]?+h[m>>3]:+h[n>>3];h[m+8>>3]=+h[m+8>>3]<+h[n+8>>3]?+h[m+8>>3]:+h[n+8>>3];h[m+16>>3]=+h[m+16>>3]>+h[n+16>>3]?+h[m+16>>3]:+h[n+16>>3];if(+h[m+16+8>>3]>+h[n+16+8>>3])H=+h[m+16+8>>3];else H=+h[n+16+8>>3];h[m+16+8>>3]=H;c[q>>2]=(c[q>>2]|0)+1}if((c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)!=0?(d[(c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0|0)!=0:0){q=c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0;n=c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];c[e+20>>2]=c[m+20>>2];c[e+24>>2]=c[m+24>>2];c[e+28>>2]=c[m+28>>2];bP(E,e,q,n);c[m>>2]=c[E>>2];c[m+4>>2]=c[E+4>>2];c[m+8>>2]=c[E+8>>2];c[m+12>>2]=c[E+12>>2];c[m+16>>2]=c[E+16>>2];c[m+20>>2]=c[E+20>>2];c[m+24>>2]=c[E+24>>2];c[m+28>>2]=c[E+28>>2]}E=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[E>>2]=c[m>>2];c[E+4>>2]=c[m+4>>2];c[E+8>>2]=c[m+8>>2];c[E+12>>2]=c[m+12>>2];c[E+16>>2]=c[m+16>>2];c[E+20>>2]=c[m+20>>2];c[E+24>>2]=c[m+24>>2];c[E+28>>2]=c[m+28>>2];i=b;return}function CO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)==(c[(c[d>>2]|0)+48>>2]|0)){e=1;f=e&1;i=b;return f|0}e=(O3(wB(c[d>>2]|0)|0,145613,7)|0)!=0^1;f=e&1;i=b;return f|0}function DO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;a:do if(!(c[m>>2]|0))switch(BC(c[j>>2]|0)|0){case 0:{c[m>>2]=qA(c[h>>2]|0,0,c[k>>2]|0,178518)|0;break a;break}case 1:{c[m>>2]=qA(c[h>>2]|0,1,c[k>>2]|0,178518)|0;break a;break}case 2:{c[m>>2]=qA(c[h>>2]|0,2,c[k>>2]|0,178518)|0;break a;break}default:break a}while(0);BA(c[j>>2]|0,c[m>>2]|0,c[l>>2]|0)|0;i=g;return c[m>>2]|0}function EO(d){d=d|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+176|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=d;c[p>>2]=FO(c[g>>2]|0)|0;c[o>>2]=Nz(58876,c[12989]|0)|0;c[m>>2]=FD(c[g>>2]|0,145621,1)|0;MC(c[m>>2]|0,175049,280,1)|0;dA(n,128,f+48|0);c[j>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;a:do if(!(a[(c[(c[j>>2]|0)+8>>2]|0)+118>>0]|0)){c[l>>2]=OA(c[g>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[l>>2]|0))break a;fP(c[l>>2]|0,c[m>>2]|0,n,c[o>>2]|0,c[p>>2]|0);c[l>>2]=QA(c[g>>2]|0,c[l>>2]|0)|0}}while(0);c[j>>2]=aC(c[g>>2]|0,c[j>>2]|0)|0}hA(n);Jz(c[o>>2]|0)|0;c[h>>2]=kB(c[m>>2]|0)|0;c[j>>2]=$B(c[m>>2]|0)|0;while(1){q=c[m>>2]|0;if(!(c[j>>2]|0))break;c[k>>2]=aC(q,c[j>>2]|0)|0;pC(c[g>>2]|0,c[j>>2]|0)|0;c[j>>2]=c[k>>2]}jB(q)|0;if(!(c[h>>2]|0)){r=c[p>>2]|0;Jz(r)|0;s=c[h>>2]|0;i=f;return s|0}q=(c[(c[g>>2]|0)+8>>2]|0)+136|0;b[q>>1]=e[q>>1]|1;r=c[p>>2]|0;Jz(r)|0;s=c[h>>2]|0;i=f;return s|0}function FO(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=Nz(58912,c[12989]|0)|0;gP(c[d>>2]|0,c[e>>2]|0);i=b;return c[e>>2]|0}function GO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[g>>2]=FD(c[d>>2]|0,145621,1)|0;MC(c[g>>2]|0,175049,280,1)|0;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;hP(c[f>>2]|0,c[g>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}c[e>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;pC(c[d>>2]|0,c[e>>2]|0)|0;c[e>>2]=aC(c[g>>2]|0,c[e>>2]|0)|0}jB(c[g>>2]|0)|0;i=b;return}function HO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=qA(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,0)|0;if(c[l>>2]|0){m=c[l>>2]|0;i=f;return m|0}c[l>>2]=qA(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;m=c[l>>2]|0;i=f;return m|0}function IO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+64|0;f=e;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+16|0;m=e+8|0;n=e+4|0;o=e+40|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=H3(c[h>>2]|0,59)|0;if((c[(c[j>>2]|0)+4>>2]|0)>>>0>=(c[(c[j>>2]|0)+8>>2]|0)>>>0)eA(c[j>>2]|0,1)|0;d=(c[j>>2]|0)+4|0;b=c[d>>2]|0;c[d>>2]=b+1;a[b>>0]=38;if(!(c[k>>2]|0)){c[g>>2]=c[h>>2];p=c[g>>2]|0;i=e;return p|0}b=(c[k>>2]|0)-(c[h>>2]|0)|0;c[n>>2]=b;if((b|0)>8|(c[n>>2]|0)<2){c[g>>2]=c[h>>2];p=c[g>>2]|0;i=e;return p|0}Q3(o,c[h>>2]|0,c[n>>2]|0)|0;a[o+(c[n>>2]|0)>>0]=0;c[l>>2]=o;c[m>>2]=v3(l,58948,252,8,96)|0;if(!(c[m>>2]|0)){c[g>>2]=c[h>>2];p=c[g>>2]|0;i=e;return p|0}c[f>>2]=c[(c[m>>2]|0)+4>>2];k3(o,175023,f)|0;if((c[(c[j>>2]|0)+4>>2]|0)>>>0>=(c[(c[j>>2]|0)+8>>2]|0)>>>0)eA(c[j>>2]|0,1)|0;f=(c[j>>2]|0)+4|0;m=c[f>>2]|0;c[f>>2]=m+1;a[m>>0]=35;gA(c[j>>2]|0,o)|0;if((c[(c[j>>2]|0)+4>>2]|0)>>>0>=(c[(c[j>>2]|0)+8>>2]|0)>>>0)eA(c[j>>2]|0,1)|0;o=(c[j>>2]|0)+4|0;j=c[o>>2]|0;c[o>>2]=j+1;a[j>>0]=59;c[g>>2]=(c[k>>2]|0)+1;p=c[g>>2]|0;i=e;return p|0}function JO(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+1088|0;g=f+8|0;h=f;j=f+56|0;k=f+52|0;l=f+48|0;m=f+32|0;n=f+60|0;o=f+28|0;p=f+24|0;q=f+20|0;r=f+16|0;c[j>>2]=b;c[k>>2]=e;if((c[15241]|0)!=(c[k>>2]|0)){c[15241]=c[k>>2];a[145636]=0}dA(m,1024,f+64|0);while(1){e=c[j>>2]|0;c[j>>2]=e+1;b=a[e>>0]|0;a[n>>0]=b;if(!(b<<24>>24))break;do if((d[n>>0]|0)<192)c[q>>2]=0;else{if((d[n>>0]|0)<224){c[q>>2]=1;break}if((d[n>>0]|0)<240){c[q>>2]=2;break}if((d[n>>0]|0)<248){c[q>>2]=3;break}c[q>>2]=-1;if(!(a[145636]|0)){c[h>>2]=wB(c[k>>2]|0)|0;$z(0,145637,h)|0;a[145636]=1}a[n>>0]=jP(a[n>>0]|0,m)|0}while(0);do if((c[q>>2]|0)==0?(d[n>>0]|0)==38:0){c[o>>2]=kP(j)|0;if(c[o>>2]|0){b=c[o>>2]|0;if((c[o>>2]|0)>>>0<127){a[n>>0]=b;break}e=(c[m+4>>2]|0)>>>0>=(c[m+8>>2]|0)>>>0;if(b>>>0<2047){if(e)eA(m,1)|0;b=((c[o>>2]|0)>>>6&255|192)&255;s=m+4|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t>>0]=b;c[p>>2]=b&255;a[n>>0]=c[o>>2]&63|128;break}if(e)eA(m,1)|0;e=((c[o>>2]|0)>>>12&255|224)&255;b=m+4|0;t=c[b>>2]|0;c[b>>2]=t+1;a[t>>0]=e;c[p>>2]=e&255;if((c[m+4>>2]|0)>>>0>=(c[m+8>>2]|0)>>>0)eA(m,1)|0;e=((c[o>>2]|0)>>>6&63|128)&255;t=m+4|0;b=c[t>>2]|0;c[t>>2]=b+1;a[b>>0]=e;c[p>>2]=e&255;a[n>>0]=c[o>>2]&63|128}}else u=30;while(0);a:do if((u|0)==30){u=0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[q>>2]|0))break a;if((a[c[j>>2]>>0]&192|0)!=128)break;if((c[m+4>>2]|0)>>>0>=(c[m+8>>2]|0)>>>0)eA(m,1)|0;e=a[n>>0]|0;b=m+4|0;t=c[b>>2]|0;c[b>>2]=t+1;a[t>>0]=e;c[p>>2]=e&255;e=c[j>>2]|0;c[j>>2]=e+1;a[n>>0]=a[e>>0]|0;c[r>>2]=(c[r>>2]|0)+1}if(!(a[145636]|0)){e=(c[q>>2]|0)+1|0;t=wB(c[k>>2]|0)|0;c[g>>2]=e;c[g+4>>2]=t;$z(0,145758,g)|0;a[145636]=1}a[n>>0]=jP(a[n>>0]|0,m)|0}while(0);if((c[m+4>>2]|0)>>>0>=(c[m+8>>2]|0)>>>0)eA(m,1)|0;t=a[n>>0]|0;e=m+4|0;b=c[e>>2]|0;c[e>>2]=b+1;a[b>>0]=t;c[p>>2]=t&255}if((c[m+4>>2]|0)>>>0<(c[m+8>>2]|0)>>>0){v=m+4|0;w=c[v>>2]|0;x=w+1|0;c[v>>2]=x;a[w>>0]=0;y=c[m>>2]|0;z=m+4|0;c[z>>2]=y;A=M3(y)|0;c[l>>2]=A;hA(m);B=c[l>>2]|0;i=f;return B|0}eA(m,1)|0;v=m+4|0;w=c[v>>2]|0;x=w+1|0;c[v>>2]=x;a[w>>0]=0;y=c[m>>2]|0;z=m+4|0;c[z>>2]=y;A=M3(y)|0;c[l>>2]=A;hA(m);B=c[l>>2]|0;i=f;return B|0}function KO(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+1056|0;f=e+28|0;g=e+24|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;dA(h,1024,e+32|0);while(1){b=c[f>>2]|0;c[f>>2]=b+1;l=d[b>>0]|0;c[j>>2]=l;if(!l)break;if((c[j>>2]|0)==38){l=kP(f)|0;c[j>>2]=l;c[j>>2]=(c[j>>2]|0)!=0?l:38}if((c[j>>2]|0)>>>0<127){if((c[h+4>>2]|0)>>>0>=(c[h+8>>2]|0)>>>0)eA(h,1)|0;l=c[j>>2]&255;b=h+4|0;m=c[b>>2]|0;c[b>>2]=m+1;a[m>>0]=l;c[k>>2]=l&255;continue}l=(c[h+4>>2]|0)>>>0>=(c[h+8>>2]|0)>>>0;if((c[j>>2]|0)>>>0<2047){if(l)eA(h,1)|0;m=((c[j>>2]|0)>>>6&255|192)&255;b=h+4|0;n=c[b>>2]|0;c[b>>2]=n+1;a[n>>0]=m;c[k>>2]=m&255;if((c[h+4>>2]|0)>>>0>=(c[h+8>>2]|0)>>>0)eA(h,1)|0;m=(c[j>>2]&63|128)&255;n=h+4|0;b=c[n>>2]|0;c[n>>2]=b+1;a[b>>0]=m;c[k>>2]=m&255;continue}if(l)eA(h,1)|0;l=((c[j>>2]|0)>>>12&255|224)&255;m=h+4|0;b=c[m>>2]|0;c[m>>2]=b+1;a[b>>0]=l;c[k>>2]=l&255;if((c[h+4>>2]|0)>>>0>=(c[h+8>>2]|0)>>>0)eA(h,1)|0;l=((c[j>>2]|0)>>>6&63|128)&255;b=h+4|0;m=c[b>>2]|0;c[b>>2]=m+1;a[m>>0]=l;c[k>>2]=l&255;if((c[h+4>>2]|0)>>>0>=(c[h+8>>2]|0)>>>0)eA(h,1)|0;l=(c[j>>2]&63|128)&255;m=h+4|0;b=c[m>>2]|0;c[m>>2]=b+1;a[b>>0]=l;c[k>>2]=l&255}if((c[h+4>>2]|0)>>>0<(c[h+8>>2]|0)>>>0){o=h+4|0;p=c[o>>2]|0;q=p+1|0;c[o>>2]=q;a[p>>0]=0;r=c[h>>2]|0;s=h+4|0;c[s>>2]=r;t=M3(r)|0;c[g>>2]=t;hA(h);u=c[g>>2]|0;i=e;return u|0}eA(h,1)|0;o=h+4|0;p=c[o>>2]|0;q=p+1|0;c[o>>2]=q;a[p>>0]=0;r=c[h>>2]|0;s=h+4|0;c[s>>2]=r;t=M3(r)|0;c[g>>2]=t;hA(h);u=c[g>>2]|0;i=e;return u|0}function LO(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+1072|0;f=e+28|0;g=e+24|0;h=e+8|0;j=e+33|0;k=e+32|0;l=e;c[f>>2]=b;dA(h,1024,e+40|0);while(1){b=c[f>>2]|0;c[f>>2]=b+1;m=a[b>>0]|0;a[j>>0]=m;if(!(m<<24>>24))break;if((d[j>>0]|0|0)<127){if((c[h+4>>2]|0)>>>0>=(c[h+8>>2]|0)>>>0)eA(h,1)|0;m=a[j>>0]|0;b=h+4|0;n=c[b>>2]|0;c[b>>2]=n+1;a[n>>0]=m;c[l>>2]=m&255;continue}else{a[k>>0]=((d[j>>0]|0)&3)<<6;m=c[f>>2]|0;c[f>>2]=m+1;a[j>>0]=a[m>>0]|0;a[k>>0]=d[k>>0]|0|(d[j>>0]|0)&63;if((c[h+4>>2]|0)>>>0>=(c[h+8>>2]|0)>>>0)eA(h,1)|0;m=a[k>>0]|0;n=h+4|0;b=c[n>>2]|0;c[n>>2]=b+1;a[b>>0]=m;c[l>>2]=m&255;continue}}if((c[h+4>>2]|0)>>>0<(c[h+8>>2]|0)>>>0){o=h+4|0;p=c[o>>2]|0;q=p+1|0;c[o>>2]=q;a[p>>0]=0;r=c[h>>2]|0;s=h+4|0;c[s>>2]=r;t=M3(r)|0;c[g>>2]=t;hA(h);u=c[g>>2]|0;i=e;return u|0}eA(h,1)|0;o=h+4|0;p=c[o>>2]|0;q=p+1|0;c[o>>2]=q;a[p>>0]=0;r=c[h>>2]|0;s=h+4|0;c[s>>2]=r;t=M3(r)|0;c[g>>2]=t;hA(h);u=c[g>>2]|0;i=e;return u|0}function MO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+96|0;f=e+64|0;g=e+48|0;j=e+92|0;k=e+88|0;l=e+80|0;m=e+32|0;n=e+16|0;o=e;c[k>>2]=b;if(((+h[d+16>>3]>=+h[(c[(c[k>>2]|0)+8>>2]|0)+48>>3]?+h[(c[(c[k>>2]|0)+8>>2]|0)+48+16>>3]>=+h[d>>3]:0)?+h[d+16+8>>3]>=+h[(c[(c[k>>2]|0)+8>>2]|0)+48+8>>3]:0)?+h[(c[(c[k>>2]|0)+8>>2]|0)+48+16+8>>3]>=+h[d+8>>3]:0){b=(c[(c[k>>2]|0)+8>>2]|0)+16|0;p=d+16|0;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];lP(n,g,f);c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];dP(o,g,f);c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];c[m+12>>2]=c[o+12>>2];c[l>>2]=c[k>>2];c[l+4>>2]=0;o=c[(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0;c[f>>2]=c[m>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];a[j>>0]=Ob[o&127](l,f)|0;q=a[j>>0]|0;i=e;return q|0}a[j>>0]=0;q=a[j>>0]|0;i=e;return q|0}function NO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+128|0;e=d+96|0;f=d+80|0;g=d+112|0;j=d+64|0;k=d+32|0;l=d+16|0;m=d;c[g>>2]=a;h[j>>3]=+h[(c[g>>2]|0)+24>>3]/2.0;h[j+8>>3]=+h[(c[g>>2]|0)+24+8>>3]/2.0;a=(c[g>>2]|0)+56|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];dP(l,f,e);c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];l=k+16|0;a=(c[g>>2]|0)+56|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];eP(m,f,e);c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];if(!(+h[b+16>>3]>=+h[k>>3])){n=0;o=n&1;p=o&255;i=d;return p|0}if(!(+h[k+16>>3]>=+h[b>>3])){n=0;o=n&1;p=o&255;i=d;return p|0}if(!(+h[b+16+8>>3]>=+h[k+8>>3])){n=0;o=n&1;p=o&255;i=d;return p|0}n=+h[k+16+8>>3]>=+h[b+8>>3];o=n&1;p=o&255;i=d;return p|0}function OO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+112|0;f=e+48|0;g=e;h=e+96|0;j=e+92|0;k=e+88|0;l=e+84|0;m=e+80|0;c[j>>2]=b;c[l>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2];a:do if((c[l>>2]|0)!=0?(b=(c[l>>2]|0)+8|0,c[g>>2]=c[b>>2],c[g+4>>2]=c[b+4>>2],c[g+8>>2]=c[b+8>>2],c[g+12>>2]=c[b+12>>2],c[g+16>>2]=c[b+16>>2],c[g+20>>2]=c[b+20>>2],c[g+24>>2]=c[b+24>>2],c[g+28>>2]=c[b+28>>2],c[f>>2]=c[d>>2],c[f+4>>2]=c[d+4>>2],c[f+8>>2]=c[d+8>>2],c[f+12>>2]=c[d+12>>2],c[f+16>>2]=c[d+16>>2],c[f+20>>2]=c[d+20>>2],c[f+24>>2]=c[d+24>>2],c[f+28>>2]=c[d+28>>2],(mP(g,f)|0)!=0):0){c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[l>>2]|0)+4>>2]|0))break a;b=g;n=(c[c[l>>2]>>2]|0)+((c[k>>2]|0)*48|0)|0;o=b+48|0;do{c[b>>2]=c[n>>2];b=b+4|0;n=n+4|0}while((b|0)<(o|0));c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[f+16>>2]=c[d+16>>2];c[f+20>>2]=c[d+20>>2];c[f+24>>2]=c[d+24>>2];c[f+28>>2]=c[d+28>>2];if((nP(g,f)|0)<<24>>24)break;c[k>>2]=(c[k>>2]|0)+1}a[h>>0]=1;p=a[h>>0]|0;i=e;return p|0}while(0);c[m>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2];if((c[m>>2]|0)!=0?(j=c[m>>2]|0,c[f>>2]=c[d>>2],c[f+4>>2]=c[d+4>>2],c[f+8>>2]=c[d+8>>2],c[f+12>>2]=c[d+12>>2],c[f+16>>2]=c[d+16>>2],c[f+20>>2]=c[d+20>>2],c[f+24>>2]=c[d+24>>2],c[f+28>>2]=c[d+28>>2],((NO(j,f)|0)&255|0)!=0):0){a[h>>0]=1;p=a[h>>0]|0;i=e;return p|0}a[h>>0]=0;p=a[h>>0]|0;i=e;return p|0}function PO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;c[h>>2]=b;c[j>>2]=d;if((c[h>>2]|0)!=0?(a[c[h>>2]>>0]|0)!=0:0){c[k>>2]=0;a:do switch(a[c[h>>2]>>0]|0){case 48:{c[k>>2]=2;break}case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:{c[k>>2]=10;break}case 67:case 99:{if(!(F3((c[h>>2]|0)+1|0,145867)|0)){c[k>>2]=4;break a}if(!(F3((c[h>>2]|0)+1|0,145873)|0))c[k>>2]=12;break}case 70:case 102:{if(!(F3((c[h>>2]|0)+1|0,145881)|0))c[k>>2]=2;break}case 76:case 108:{if(!(F3((c[h>>2]|0)+1|0,145886)|0))c[k>>2]=2;break}case 78:case 110:{if(!(F3((c[h>>2]|0)+1|0,145890)|0)){c[g>>2]=c[k>>2];l=c[g>>2]|0;i=e;return l|0}if(!(F3((c[h>>2]|0)+1|0,145894)|0)){c[g>>2]=2;l=c[g>>2]|0;i=e;return l|0}break}case 79:case 111:{if(!(F3((c[h>>2]|0)+1|0,145896)|0))c[k>>2]=8;break}case 80:case 112:{if(!(F3((c[h>>2]|0)+1|0,145901)|0))c[k>>2]=6;break}case 83:case 115:{if(!(F3((c[h>>2]|0)+1|0,145909)|0))c[k>>2]=10;break}case 84:case 116:{if(!(F3((c[h>>2]|0)+1|0,145915)|0))c[k>>2]=10;break}case 89:case 121:{if(!(F3((c[h>>2]|0)+1|0,145919)|0))c[k>>2]=10;break}default:{}}while(0);if(!(c[k>>2]|0)){c[f>>2]=c[h>>2];$z(0,145922,f)|0;c[k>>2]=c[j>>2]}c[g>>2]=c[k>>2];l=c[g>>2]|0;i=e;return l|0}c[g>>2]=c[j>>2];l=c[g>>2]|0;i=e;return l|0}function QO(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[h>>2]=d;c[j>>2]=f;c[k>>2]=yA(c[h>>2]|0,145963)|0;do if(c[k>>2]|0)if(!(a[c[k>>2]>>0]|0)){c[l>>2]=0;break}else{c[l>>2]=PO(c[k>>2]|0,c[j>>2]|0)|0;break}else c[l>>2]=c[j>>2];while(0);j=(c[(c[h>>2]|0)+8>>2]|0)+136|0;b[j>>1]=e[j>>1]|c[l>>2];i=g;return}function RO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0;j=i;i=i+144|0;k=j+140|0;l=j+136|0;m=j+132|0;n=j+128|0;o=j+124|0;p=j+120|0;q=j+104|0;r=j+96|0;s=j+80|0;t=j+64|0;u=j+48|0;v=j+116|0;w=j+112|0;x=j+40|0;y=j+32|0;z=j+24|0;A=j+16|0;B=j+8|0;C=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;g[n>>2]=e;c[o>>2]=f;c[v>>2]=c[o>>2]&1;c[w>>2]=c[o>>2]&2;o=c[k>>2]|0;a:do if((c[m>>2]|0)==2){h[q>>3]=+h[o+16>>3]-+h[c[k>>2]>>3];h[r>>3]=+h[(c[k>>2]|0)+16+8>>3]-+h[(c[k>>2]|0)+8>>3];h[s>>3]=+h[c[k>>2]>>3]-+h[q>>3];h[t>>3]=+h[c[k>>2]>>3]+ +h[q>>3];h[s+8>>3]=+h[(c[k>>2]|0)+8>>3]-+h[r>>3];h[t+8>>3]=+h[(c[k>>2]|0)+8>>3]+ +h[r>>3]}else{e=+h[o>>3];h[t>>3]=e;h[s>>3]=e;e=+h[(c[k>>2]|0)+8>>3];h[t+8>>3]=e;h[s+8>>3]=e;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[m>>2]|0))break a;if(+h[(c[k>>2]|0)+(c[p>>2]<<4)>>3]<+h[s>>3])D=+h[(c[k>>2]|0)+(c[p>>2]<<4)>>3];else D=+h[s>>3];h[s>>3]=D;if(+h[(c[k>>2]|0)+(c[p>>2]<<4)+8>>3]<+h[s+8>>3])E=+h[(c[k>>2]|0)+(c[p>>2]<<4)+8>>3];else E=+h[s+8>>3];h[s+8>>3]=E;if(+h[(c[k>>2]|0)+(c[p>>2]<<4)>>3]>+h[t>>3])F=+h[(c[k>>2]|0)+(c[p>>2]<<4)>>3];else F=+h[t>>3];h[t>>3]=F;if(+h[(c[k>>2]|0)+(c[p>>2]<<4)+8>>3]>+h[t+8>>3])G=+h[(c[k>>2]|0)+(c[p>>2]<<4)+8>>3];else G=+h[t+8>>3];h[t+8>>3]=G;c[p>>2]=(c[p>>2]|0)+1}}while(0);h[u>>3]=+h[s>>3]+(+h[t>>3]-+h[s>>3])/2.0;h[u+8>>3]=+h[s+8>>3]+(+h[t+8>>3]-+h[s+8>>3])/2.0;if(c[v>>2]|0){h[y>>3]=+O(+((+h[u>>3]-+h[s>>3])*(+h[u>>3]-+h[s>>3])+(+h[u+8>>3]-+h[s+8>>3])*(+h[u+8>>3]-+h[s+8>>3])));h[x>>3]=+h[y>>3]/4.0;G=+h[u+8>>3];if(c[w>>2]|0)h[(c[l>>2]|0)+8>>3]=G;else h[(c[l>>2]|0)+8>>3]=-G;h[c[l>>2]>>3]=+h[u>>3];h[(c[l>>2]|0)+16>>3]=+h[x>>3];h[(c[l>>2]|0)+16+8>>3]=+h[y>>3];i=j;return}else{h[z>>3]=+h[t>>3]-+h[u>>3];h[A>>3]=+h[t+8>>3]-+h[u+8>>3];h[B>>3]=+R(+(+g[n>>2]));h[C>>3]=+Q(+(+g[n>>2]));G=+h[u+8>>3];if(c[w>>2]|0){h[(c[l>>2]|0)+8>>3]=G-+h[A>>3]*+h[B>>3];h[(c[l>>2]|0)+16+8>>3]=+h[u+8>>3]+ +h[A>>3]*+h[B>>3]}else{F=-G+(+h[t+8>>3]-+h[u+8>>3])*+R(+(+g[n>>2]));h[(c[l>>2]|0)+8>>3]=F;F=-+h[u+8>>3]-(+h[u+8>>3]-+h[s+8>>3])*+R(+(+g[n>>2]));h[(c[l>>2]|0)+16+8>>3]=F}h[c[l>>2]>>3]=+h[u>>3]-+h[z>>3]*+h[C>>3];h[(c[l>>2]|0)+16>>3]=+h[u>>3]+ +h[z>>3]*+h[C>>3];i=j;return}}function SO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)){f=c[d>>2]|0;g=f+8|0;h=c[g>>2]|0;j=h+8|0;c[j>>2]=0;i=b;return}c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;O4(c[(c[c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[e>>2]|0)*48|0)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}O4(c[c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]>>2]|0);O4(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0);f=c[d>>2]|0;g=f+8|0;h=c[g>>2]|0;j=h+8|0;c[j>>2]=0;i=b;return}function TO(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[(c[d>>2]|0)+8>>2]|0)+144>>2]|0);SO(c[d>>2]|0);UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+96>>2]|0);UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+108>>2]|0);UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+100>>2]|0);UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+104>>2]|0);NC(c[d>>2]|0,175319)|0;i=b;return}function UO(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[(c[d>>2]|0)+8>>2]|0)+132>>2]|0)O4(c[(c[(c[d>>2]|0)+8>>2]|0)+132>>2]|0);if(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)Bb[c[(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+4>>2]&127](c[d>>2]|0);UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+104>>2]|0);UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+108>>2]|0);NC(c[d>>2]|0,175026)|0;i=b;return}function VO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0.0;e=i;i=i+16|0;f=e+8|0;g=e+12|0;j=e;c[f>>2]=b;a[g>>0]=d;d=c[(c[f>>2]|0)+8>>2]|0;if(a[g>>0]|0){h[j>>3]=+h[d+40>>3]*72.0;k=+h[j>>3]/2.0;h[(c[(c[f>>2]|0)+8>>2]|0)+96>>3]=k;h[(c[(c[f>>2]|0)+8>>2]|0)+88>>3]=k;h[(c[(c[f>>2]|0)+8>>2]|0)+80>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3]*72.0;i=e;return}else{h[j>>3]=+h[d+32>>3]*72.0;k=+h[j>>3]/2.0;h[(c[(c[f>>2]|0)+8>>2]|0)+96>>3]=k;h[(c[(c[f>>2]|0)+8>>2]|0)+88>>3]=k;h[(c[(c[f>>2]|0)+8>>2]|0)+80>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3]*72.0;i=e;return}}function WO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=Hb[c[c[f>>2]>>2]&63](c[f>>2]|0,c[g>>2]|0,512)|0;if(c[h>>2]|0){c[e>>2]=c[(c[h>>2]|0)+12>>2];j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function XO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;c[h>>2]=M3(c[e>>2]|0)|0;c[k>>2]=0;c[l>>2]=0;c[j>>2]=V3(c[h>>2]|0,148898)|0;while(1){if(!(c[j>>2]|0))break;if(c[k>>2]|0)m=eK(c[k>>2]|0,(c[g>>2]|0)+2<<2)|0;else m=cK((c[g>>2]|0)+2<<2)|0;c[k>>2]=m;h=c[j>>2]|0;e=c[g>>2]|0;c[g>>2]=e+1;c[(c[k>>2]|0)+(e<<2)>>2]=h;h=c[l>>2]|0;if(h>>>0>(N3(c[j>>2]|0)|0)>>>0)n=c[l>>2]|0;else n=N3(c[j>>2]|0)|0;c[l>>2]=n;c[j>>2]=V3(0,148898)|0}c[(c[k>>2]|0)+(c[g>>2]<<2)>>2]=0;c[c[f>>2]>>2]=c[l>>2];i=d;return c[k>>2]|0}function YO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;d=c[15243]|0;b=c[j>>2]|0;c[15243]=Q4(d,b+(N3(c[k>>2]|0)|0)+2|0)|0;c[l>>2]=c[h>>2];while(1){if(!(c[c[l>>2]>>2]|0)){m=6;break}h=c[15243]|0;b=c[k>>2]|0;c[f>>2]=c[c[l>>2]>>2];c[f+4>>2]=145579;c[f+8>>2]=b;k3(h,147672,f)|0;if(!(Z3(c[15243]|0,4)|0)){m=4;break}c[l>>2]=(c[l>>2]|0)+4}if((m|0)==4){c[g>>2]=c[15243];n=c[g>>2]|0;i=e;return n|0}else if((m|0)==6){c[g>>2]=0;n=c[g>>2]|0;i=e;return n|0}return 0}function ZO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;g=+fO(c[e>>2]|0,c[13863]|0,14.0,1.0);h[c[f>>2]>>3]=g;b=iO(c[e>>2]|0,c[13864]|0,145601)|0;c[(c[f>>2]|0)+8>>2]=b;b=iO(c[e>>2]|0,c[13865]|0,174917)|0;c[(c[f>>2]|0)+12>>2]=b;i=d;return}function _O(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0.0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;if(!(c[(c[g>>2]|0)+8>>2]|0))ZO(c[f>>2]|0,c[g>>2]|0);k=+fO(c[f>>2]|0,c[13883]|0,+h[c[g>>2]>>3],1.0);h[c[j>>2]>>3]=k;d=iO(c[f>>2]|0,c[13884]|0,c[(c[g>>2]|0)+8>>2]|0)|0;c[(c[j>>2]|0)+8>>2]=d;d=iO(c[f>>2]|0,c[13885]|0,c[(c[g>>2]|0)+12>>2]|0)|0;c[(c[j>>2]|0)+12>>2]=d;i=e;return}function $O(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+144|0;h=g+132|0;j=g+128|0;k=g+124|0;l=g+80|0;m=g+120|0;n=g+40|0;o=g;c[h>>2]=d;c[j>>2]=e;c[k>>2]=f;c[m>>2]=0;if(c[k>>2]|0)c[m>>2]=H3(c[k>>2]|0,58)|0;if(c[m>>2]|0){a[c[m>>2]>>0]=0;Vb[c[h>>2]&31](n,c[j>>2]|0,c[k>>2]|0,(c[m>>2]|0)+1|0);p=l;q=n;r=p+40|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));a[c[m>>2]>>0]=58;c[l+36>>2]=(c[m>>2]|0)+1;s=c[k>>2]|0;t=l+36|0;c[t>>2]=s;p=b;q=l;r=p+40|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=g;return}else{Vb[c[h>>2]&31](o,c[j>>2]|0,c[k>>2]|0,0);p=l;q=o;r=p+40|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));s=c[k>>2]|0;t=l+36|0;c[t>>2]=s;p=b;q=l;r=p+40|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=g;return}}function aP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[f>>2]=b;c[g>>2]=d;a[j>>0]=0;if(!(c[g>>2]|0)){k=a[j>>0]|0;i=e;return k|0}c[h>>2]=zA(c[f>>2]|0,c[g>>2]|0)|0;if((c[h>>2]|0)!=0?(a[c[h>>2]>>0]|0)!=0:0){a[j>>0]=((kO(c[h>>2]|0)|0)<<24>>24!=0^1)&1;k=a[j>>0]|0;i=e;return k|0}a[j>>0]=0;k=a[j>>0]|0;i=e;return k|0}function bP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;g=i;i=i+64|0;j=g+48|0;k=g+52|0;l=g+40|0;m=g+32|0;n=g+16|0;o=g+8|0;p=g;c[j>>2]=e;a[k>>0]=f;f=(c[j>>2]|0)+56|0;c[n>>2]=c[f>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];q=+h[(c[j>>2]|0)+24>>3];if(a[k>>0]|0){h[m>>3]=q;h[l>>3]=+h[(c[j>>2]|0)+24+8>>3]}else{h[l>>3]=q;h[m>>3]=+h[(c[j>>2]|0)+24+8>>3]}h[o>>3]=+h[n>>3]-+h[l>>3]/2.0;h[p>>3]=+h[n>>3]+ +h[l>>3]/2.0;if(+h[o>>3]<+h[d>>3])h[d>>3]=+h[o>>3];if(+h[p>>3]>+h[d+16>>3])h[d+16>>3]=+h[p>>3];h[o>>3]=+h[n+8>>3]-+h[m>>3]/2.0;h[p>>3]=+h[n+8>>3]+ +h[m>>3]/2.0;if(+h[o>>3]<+h[d+8>>3])h[d+8>>3]=+h[o>>3];if(!(+h[p>>3]>+h[d+16+8>>3])){c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];i=g;return}h[d+16+8>>3]=+h[p>>3];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];i=g;return}function cP(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3];h[j+8>>3]=+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function dP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]-+h[d>>3];h[f+8>>3]=+h[b+8>>3]-+h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function eP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]+ +h[d>>3];h[f+8>>3]=+h[b+8>>3]+ +h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function fP(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+96|0;j=h+32|0;k=h+24|0;l=h+16|0;m=h+8|0;n=h;o=h+88|0;p=h+84|0;q=h+80|0;r=h+76|0;s=h+72|0;t=h+68|0;u=h+64|0;v=h+60|0;w=h+56|0;x=h+52|0;y=h+48|0;z=h+44|0;A=h+40|0;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;g=c[o>>2]|0;c[x>>2]=c[((c[c[o>>2]>>2]&3|0)==3?g:g+32|0)+28>>2];g=c[o>>2]|0;c[y>>2]=c[((c[c[o>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2];if(a[(c[(c[y>>2]|0)+8>>2]|0)+118>>0]|0){i=h;return}if(P3(wB(c[x>>2]|0)|0,145613,7)|0)B=0;else{g=c[s>>2]|0;B=WO(g,wB(c[x>>2]|0)|0)|0}c[t>>2]=B;if(P3(wB(c[y>>2]|0)|0,145613,7)|0)C=0;else{B=c[s>>2]|0;C=WO(B,wB(c[y>>2]|0)|0)|0}c[u>>2]=C;if(!((c[t>>2]|0)!=0|(c[u>>2]|0)!=0)){i=h;return}if((c[t>>2]|0)==(c[u>>2]|0)){C=wB(c[x>>2]|0)|0;B=wB(c[x>>2]|0)|0;c[n>>2]=C;c[n+4>>2]=B;$z(0,147461,n)|0;i=h;return}c[A>>2]=sP(c[r>>2]|0,c[o>>2]|0)|0;if(c[A>>2]|0){qP(c[o>>2]|0,c[(c[A>>2]|0)+16>>2]|0,c[(c[A>>2]|0)+20>>2]|0)|0;i=h;return}A=c[t>>2]|0;if(!(c[u>>2]|0))if(AC(A,c[y>>2]|0)|0){n=wB(c[y>>2]|0)|0;B=wB(c[t>>2]|0)|0;c[j>>2]=n;c[j+4>>2]=B;$z(0,147616,j)|0;i=h;return}else{c[v>>2]=tP(c[x>>2]|0,c[t>>2]|0,c[q>>2]|0,c[p>>2]|0)|0;c[z>>2]=qP(c[o>>2]|0,c[v>>2]|0,c[y>>2]|0)|0;uP(c[r>>2]|0,c[x>>2]|0,c[y>>2]|0,c[z>>2]|0);i=h;return}j=c[u>>2]|0;if(!A)if(AC(j,c[x>>2]|0)|0){A=wB(c[x>>2]|0)|0;B=wB(c[u>>2]|0)|0;c[k>>2]=A;c[k+4>>2]=B;$z(0,147579,k)|0;i=h;return}else{c[v>>2]=tP(c[y>>2]|0,c[u>>2]|0,c[q>>2]|0,c[p>>2]|0)|0;c[z>>2]=qP(c[o>>2]|0,c[x>>2]|0,c[v>>2]|0)|0;uP(c[r>>2]|0,c[x>>2]|0,c[y>>2]|0,c[z>>2]|0);i=h;return}k=(AC(j,c[t>>2]|0)|0)!=0;j=c[t>>2]|0;if(k){k=wB(j)|0;B=wB(c[u>>2]|0)|0;c[m>>2]=k;c[m+4>>2]=B;$z(0,147499,m)|0;i=h;return}if(AC(j,c[u>>2]|0)|0){j=wB(c[u>>2]|0)|0;m=wB(c[t>>2]|0)|0;c[l>>2]=j;c[l+4>>2]=m;$z(0,147539,l)|0;i=h;return}else{c[v>>2]=tP(c[x>>2]|0,c[t>>2]|0,c[q>>2]|0,c[p>>2]|0)|0;c[w>>2]=tP(c[y>>2]|0,c[u>>2]|0,c[q>>2]|0,c[p>>2]|0)|0;c[z>>2]=qP(c[o>>2]|0,c[v>>2]|0,c[w>>2]|0)|0;uP(c[r>>2]|0,c[x>>2]|0,c[y>>2]|0,c[z>>2]|0);i=h;return}}function gP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;c[h>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2];c[k>>2]=wB(c[h>>2]|0)|0;if(Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,c[k>>2]|0,512)|0){c[e>>2]=c[k>>2];$z(0,147409,e)|0}else{c[l>>2]=bK(16)|0;c[(c[l>>2]|0)+8>>2]=c[k>>2];c[(c[l>>2]|0)+12>>2]=c[h>>2];Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,c[l>>2]|0,1)|0}gP(c[h>>2]|0,c[g>>2]|0);c[j>>2]=(c[j>>2]|0)+1}i=d;return}function hP(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;c[h>>2]=c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2];b=c[f>>2]|0;c[j>>2]=c[((c[c[f>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];if((d[(c[(c[h>>2]|0)+8>>2]|0)+118>>0]|0|0)==0?(d[(c[(c[j>>2]|0)+8>>2]|0)+118>>0]|0|0)==0:0){i=e;return}c[k>>2]=pP(c[h>>2]|0,c[g>>2]|0)|0;c[l>>2]=pP(c[j>>2]|0,c[g>>2]|0)|0;qP(c[f>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;i=e;return}function iP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=J3(c[c[e>>2]>>2]|0,c[c[f>>2]>>2]|0)|0;i=d;return b|0}function jP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+18|0;g=e+12|0;h=e+16|0;j=e+8|0;k=e+4|0;l=e;a[f>>0]=b;c[g>>2]=d;a[h>>0]=a[f>>0]|0;a[h+1>>0]=0;d=KO(h)|0;c[j>>2]=d;c[k>>2]=d;c[l>>2]=N3(c[j>>2]|0)|0;while(1){d=c[l>>2]|0;c[l>>2]=d+-1;if((d|0)<=1)break;if((c[(c[g>>2]|0)+4>>2]|0)>>>0>=(c[(c[g>>2]|0)+8>>2]|0)>>>0)eA(c[g>>2]|0,1)|0;d=c[k>>2]|0;c[k>>2]=d+1;h=a[d>>0]|0;d=(c[g>>2]|0)+4|0;b=c[d>>2]|0;c[d>>2]=b+1;a[b>>0]=h}a[f>>0]=a[c[k>>2]>>0]|0;O4(c[j>>2]|0);i=e;return a[f>>0]|0}function kP(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+64|0;f=e+36|0;g=e+32|0;h=e+24|0;j=e+16|0;k=e+40|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[f>>2]=b;c[l>>2]=c[c[f>>2]>>2];c[o>>2]=0;c[m>>2]=d[c[l>>2]>>0];if((c[m>>2]|0)!=35){c[g>>2]=k;c[h>>2]=k;c[n>>2]=0;while(1){if((c[n>>2]|0)>=8){p=26;break}c[m>>2]=d[(c[l>>2]|0)+(c[n>>2]|0)>>0];if(!(c[m>>2]|0)){p=26;break}if((c[m>>2]|0)==59){p=23;break}k=c[m>>2]&255;b=c[g>>2]|0;c[g>>2]=b+1;a[b>>0]=k;c[n>>2]=(c[n>>2]|0)+1}if((p|0)==23){k=c[g>>2]|0;c[g>>2]=k+1;a[k>>0]=0;c[j>>2]=v3(h,58948,252,8,96)|0;if(!(c[j>>2]|0)){q=c[l>>2]|0;r=c[f>>2]|0;c[r>>2]=q;s=c[o>>2]|0;i=e;return s|0}c[o>>2]=c[(c[j>>2]|0)+4>>2];c[l>>2]=(c[l>>2]|0)+((c[n>>2]|0)+1);q=c[l>>2]|0;r=c[f>>2]|0;c[r>>2]=q;s=c[o>>2]|0;i=e;return s|0}else if((p|0)==26){q=c[l>>2]|0;r=c[f>>2]|0;c[r>>2]=q;s=c[o>>2]|0;i=e;return s|0}}c[m>>2]=d[(c[l>>2]|0)+1>>0];a:do if((c[m>>2]|0)==120|(c[m>>2]|0)==88){c[n>>2]=2;while(1){if((c[n>>2]|0)>=8)break a;c[m>>2]=d[(c[l>>2]|0)+(c[n>>2]|0)>>0];p=c[m>>2]|0;do if((c[m>>2]|0)>>>0>=65&(c[m>>2]|0)>>>0<=70)c[m>>2]=p-65+10;else{j=c[m>>2]|0;if(p>>>0>=97&(c[m>>2]|0)>>>0<=102){c[m>>2]=j-97+10;break}if(!(j>>>0>=48&(c[m>>2]|0)>>>0<=57))break a;c[m>>2]=(c[m>>2]|0)-48}while(0);c[o>>2]=(c[o>>2]<<4)+(c[m>>2]|0);c[n>>2]=(c[n>>2]|0)+1}}else{c[n>>2]=1;while(1){if((c[n>>2]|0)>=8)break a;c[m>>2]=d[(c[l>>2]|0)+(c[n>>2]|0)>>0];if(!((c[m>>2]|0)>>>0>=48&(c[m>>2]|0)>>>0<=57))break a;c[o>>2]=((c[o>>2]|0)*10|0)+((c[m>>2]|0)-48);c[n>>2]=(c[n>>2]|0)+1}}while(0);if((c[m>>2]|0)==59){c[l>>2]=(c[l>>2]|0)+((c[n>>2]|0)+1);q=c[l>>2]|0;r=c[f>>2]|0;c[r>>2]=q;s=c[o>>2]|0;i=e;return s|0}else{c[o>>2]=0;q=c[l>>2]|0;r=c[f>>2]|0;c[r>>2]=q;s=c[o>>2]|0;i=e;return s|0}return 0}function lP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=(+h[b>>3]+ +h[d>>3])/2.0;h[f+8>>3]=(+h[b+8>>3]+ +h[d+8>>3])/2.0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function mP(a,b){a=a|0;b=b|0;var c=0,d=0;if(!(+h[a+16>>3]>=+h[b>>3])){c=0;d=c&1;return d|0}if(!(+h[b+16>>3]>=+h[a>>3])){c=0;d=c&1;return d|0}if(!(+h[a+16+8>>3]>=+h[b+8>>3])){c=0;d=c&1;return d|0}c=+h[b+16+8>>3]>=+h[a+8>>3];d=c&1;return d|0}function nP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+112|0;f=e+64|0;g=e+48|0;h=e+32|0;j=e+100|0;k=e+96|0;l=e+16|0;m=e;if(!(c[b+4>>2]|0))La(145971,145265,1629,145979);n=c[b>>2]|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[k>>2]=1;while(1){if((c[k>>2]|0)>=(c[b+4>>2]|0))break;n=(c[b>>2]|0)+(c[k>>2]<<4)|0;c[l>>2]=c[n>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];c[h>>2]=c[l>>2];c[h+4>>2]=c[l+4>>2];c[h+8>>2]=c[l+8>>2];c[h+12>>2]=c[l+12>>2];c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[f+16>>2]=c[d+16>>2];c[f+20>>2]=c[d+20>>2];c[f+24>>2]=c[d+24>>2];c[f+28>>2]=c[d+28>>2];if((CJ(h,g,f)|0)!=-1){o=6;break};c[m>>2]=c[l>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];c[k>>2]=(c[k>>2]|0)+1}if((o|0)==6){a[j>>0]=1;p=a[j>>0]|0;i=e;return p|0}if((c[b+8>>2]|0)!=0?(o=b+16|0,k=c[b>>2]|0,l=c[b+8>>2]|0,c[h>>2]=c[o>>2],c[h+4>>2]=c[o+4>>2],c[h+8>>2]=c[o+8>>2],c[h+12>>2]=c[o+12>>2],c[g>>2]=c[k>>2],c[g+4>>2]=c[k+4>>2],c[g+8>>2]=c[k+8>>2],c[g+12>>2]=c[k+12>>2],c[f>>2]=c[d>>2],c[f+4>>2]=c[d+4>>2],c[f+8>>2]=c[d+8>>2],c[f+12>>2]=c[d+12>>2],c[f+16>>2]=c[d+16>>2],c[f+20>>2]=c[d+20>>2],c[f+24>>2]=c[d+24>>2],c[f+28>>2]=c[d+28>>2],(oP(h,g,1.0,l,f)|0)<<24>>24!=0):0){a[j>>0]=1;p=a[j>>0]|0;i=e;return p|0}if((c[b+12>>2]|0)!=0?(l=b+32|0,k=(c[b>>2]|0)+((c[b+4>>2]|0)-1<<4)|0,o=c[b+12>>2]|0,c[h>>2]=c[l>>2],c[h+4>>2]=c[l+4>>2],c[h+8>>2]=c[l+8>>2],c[h+12>>2]=c[l+12>>2],c[g>>2]=c[k>>2],c[g+4>>2]=c[k+4>>2],c[g+8>>2]=c[k+8>>2],c[g+12>>2]=c[k+12>>2],c[f>>2]=c[d>>2],c[f+4>>2]=c[d+4>>2],c[f+8>>2]=c[d+8>>2],c[f+12>>2]=c[d+12>>2],c[f+16>>2]=c[d+16>>2],c[f+20>>2]=c[d+20>>2],c[f+24>>2]=c[d+24>>2],c[f+28>>2]=c[d+28>>2],(oP(h,g,1.0,o,f)|0)<<24>>24!=0):0){a[j>>0]=1;p=a[j>>0]|0;i=e;return p|0}a[j>>0]=0;p=a[j>>0]|0;i=e;return p|0}function oP(b,d,e,f,g){b=b|0;d=d|0;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0;j=i;i=i+176|0;k=j+152|0;l=j+136|0;m=j+172|0;n=j+128|0;o=j+168|0;p=j+96|0;q=j+64|0;r=j+32|0;s=j;h[n>>3]=e;c[o>>2]=f;e=+h[g+16>>3];t=+h[n>>3];f=c[o>>2]|0;c[l>>2]=c[b>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];gH(p,l,k,t,f);if(((e>=+h[p>>3]?(e=+h[n>>3],p=c[o>>2]|0,c[l>>2]=c[b>>2],c[l+4>>2]=c[b+4>>2],c[l+8>>2]=c[b+8>>2],c[l+12>>2]=c[b+12>>2],c[k>>2]=c[d>>2],c[k+4>>2]=c[d+4>>2],c[k+8>>2]=c[d+8>>2],c[k+12>>2]=c[d+12>>2],gH(q,l,k,e,p),+h[q+16>>3]>=+h[g>>3]):0)?(e=+h[g+16+8>>3],t=+h[n>>3],q=c[o>>2]|0,c[l>>2]=c[b>>2],c[l+4>>2]=c[b+4>>2],c[l+8>>2]=c[b+8>>2],c[l+12>>2]=c[b+12>>2],c[k>>2]=c[d>>2],c[k+4>>2]=c[d+4>>2],c[k+8>>2]=c[d+8>>2],c[k+12>>2]=c[d+12>>2],gH(r,l,k,t,q),e>=+h[r+8>>3]):0)?(e=+h[n>>3],n=c[o>>2]|0,c[l>>2]=c[b>>2],c[l+4>>2]=c[b+4>>2],c[l+8>>2]=c[b+8>>2],c[l+12>>2]=c[b+12>>2],c[k>>2]=c[d>>2],c[k+4>>2]=c[d+4>>2],c[k+8>>2]=c[d+8>>2],c[k+12>>2]=c[d+12>>2],gH(s,l,k,e,n),+h[s+16+8>>3]>=+h[g+8>>3]):0){a[m>>0]=1;u=a[m>>0]|0;i=j;return u|0}a[m>>0]=0;u=a[m>>0]|0;i=j;return u|0}function pP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=b;c[h>>2]=d;c[l>>2]=qC(c[g>>2]|0)|0;if(!(a[(c[(c[g>>2]|0)+8>>2]|0)+118>>0]|0)){c[f>>2]=c[g>>2];n=c[f>>2]|0;i=e;return n|0}eC(c[h>>2]|0,c[g>>2]|0,1)|0;c[k>>2]=H3(wB(c[g>>2]|0)|0,58)|0;if(!(c[k>>2]|0))La(148770,145265,1225,147404);c[k>>2]=(c[k>>2]|0)+1;g=fC(c[l>>2]|0,c[k>>2]|0,0)|0;c[j>>2]=g;if(g){c[f>>2]=c[j>>2];n=c[f>>2]|0;i=e;return n|0}c[j>>2]=fC(c[l>>2]|0,c[k>>2]|0,1)|0;MC(c[j>>2]|0,175026,304,1)|0;c[m>>2]=rA(c[l>>2]|0,1,0)|0;while(1){o=c[j>>2]|0;if(!(c[m>>2]|0))break;k=zA(o,c[m>>2]|0)|0;if((k|0)!=(c[(c[m>>2]|0)+12>>2]|0))BA(c[j>>2]|0,c[m>>2]|0,c[(c[m>>2]|0)+12>>2]|0)|0;c[m>>2]=rA(c[l>>2]|0,1,c[m>>2]|0)|0}c[f>>2]=o;n=c[f>>2]|0;i=e;return n|0}function qP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=qC(c[g>>2]|0)|0;c[k>>2]=VA(c[j>>2]|0,c[g>>2]|0,c[h>>2]|0,0,1)|0;MC(c[k>>2]|0,175319,176,1)|0;DA(c[f>>2]|0,c[k>>2]|0)|0;i=e;return c[k>>2]|0}function rP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function sP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;c[e>>2]=a;c[f>>2]=b;b=c[f>>2]|0;c[g>>2]=c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2];b=c[f>>2]|0;c[g+4>>2]=c[((c[c[f>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];b=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,512)|0;i=d;return b|0}function tP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+128|0;h=g;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g+24|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;gA(c[l>>2]|0,147653)|0;f=c[15242]|0;c[15242]=f+1;c[h>>2]=f;k3(o,175023,h)|0;gA(c[l>>2]|0,o)|0;if((c[(c[l>>2]|0)+4>>2]|0)>>>0>=(c[(c[l>>2]|0)+8>>2]|0)>>>0)eA(c[l>>2]|0,1)|0;o=(c[l>>2]|0)+4|0;h=c[o>>2]|0;c[o>>2]=h+1;a[h>>0]=58;h=c[l>>2]|0;gA(h,wB(c[k>>2]|0)|0)|0;h=rC(c[k>>2]|0)|0;if((c[(c[l>>2]|0)+4>>2]|0)>>>0>=(c[(c[l>>2]|0)+8>>2]|0)>>>0)eA(c[l>>2]|0,1)|0;o=(c[l>>2]|0)+4|0;f=c[o>>2]|0;c[o>>2]=f+1;a[f>>0]=0;f=c[c[l>>2]>>2]|0;c[(c[l>>2]|0)+4>>2]=f;c[n>>2]=fC(h,f,1)|0;MC(c[n>>2]|0,175026,304,1)|0;a[(c[(c[n>>2]|0)+8>>2]|0)+118>>0]=1;eC(c[k>>2]|0,c[n>>2]|0,1)|0;eC(c[m>>2]|0,c[j>>2]|0,1)|0;j=qC(c[n>>2]|0)|0;c[13831]=DO(j,c[n>>2]|0,147656,178518,c[13831]|0)|0;j=qC(c[n>>2]|0)|0;c[13834]=DO(j,c[n>>2]|0,179091,171938,c[13834]|0)|0;j=qC(c[n>>2]|0)|0;c[13816]=DO(j,c[n>>2]|0,147662,147668,c[13816]|0)|0;i=g;return c[n>>2]|0}function uP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l+8>>2]=c[h>>2];c[l+8+4>>2]=c[j>>2];e=c[k>>2]|0;c[l+16>>2]=c[((c[c[k>>2]>>2]&3|0)==3?e:e+32|0)+28>>2];e=c[k>>2]|0;c[l+20>>2]=c[((c[c[k>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2];Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,l,1)|0;c[l+8>>2]=c[j>>2];c[l+8+4>>2]=c[h>>2];h=c[k>>2]|0;c[l+16>>2]=c[((c[c[k>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2];h=c[k>>2]|0;c[l+20>>2]=c[((c[c[k>>2]>>2]&3|0)==3?h:h+32|0)+28>>2];Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,l,1)|0;i=f;return}function vP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=bK(24)|0;c[(c[g>>2]|0)+8>>2]=c[(c[f>>2]|0)+8>>2];c[(c[g>>2]|0)+8+4>>2]=c[(c[f>>2]|0)+8+4>>2];c[(c[g>>2]|0)+16>>2]=c[(c[f>>2]|0)+16>>2];c[(c[g>>2]|0)+20>>2]=c[(c[f>>2]|0)+20>>2];i=e;return c[g>>2]|0}function wP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function xP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;c[f+12>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f>>2]=e;do if((c[c[h>>2]>>2]|0)>>>0>=(c[c[j>>2]>>2]|0)>>>0){if((c[c[h>>2]>>2]|0)>>>0>(c[c[j>>2]>>2]|0)>>>0){c[g>>2]=1;break}if((c[(c[h>>2]|0)+4>>2]|0)>>>0<(c[(c[j>>2]|0)+4>>2]|0)>>>0){c[g>>2]=-1;break}if((c[(c[h>>2]|0)+4>>2]|0)>>>0>(c[(c[j>>2]|0)+4>>2]|0)>>>0){c[g>>2]=1;break}else{c[g>>2]=0;break}}else c[g>>2]=-1;while(0);i=f;return c[g>>2]|0}function yP(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,fa=0,ha=0,ja=0,la=0,ma=0,na=0,oa=0,qa=0,sa=0,ua=0,va=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0;f=i;i=i+16|0;g=f;h=4;j=N4(40)|0;c[j>>2]=0;k=f+8|0;n=0;l=ia(29,b|0)|0;m=n;n=0;if((m|0)!=0&(o|0)!=0){p=Y4(c[m>>2]|0,j|0,h|0)|0;if(!p)Pa(m|0,o|0);C=o}else p=-1;a:do if((p|0)!=1){n=0;m=ia(23,l<<3|0)|0;q=n;n=0;if((q|0)!=0&(o|0)!=0){r=Y4(c[q>>2]|0,j|0,h|0)|0;if(!r)Pa(q|0,o|0);C=o}else r=-1;if((r|0)!=1){if(a[139e3]|0){n=0;q=ta(4)|0;s=n;n=0;if((s|0)!=0&(o|0)!=0){t=Y4(c[s>>2]|0,j|0,h|0)|0;if(!t)Pa(s|0,o|0);C=o}else t=-1;if((t|0)==1){u=e;v=C;w=m;x=0;y=0;z=0;A=0;B=76;break}D=q}else D=0;n=0;q=ra(97,b|0,147679)|0;s=n;n=0;if((s|0)!=0&(o|0)!=0){E=Y4(c[s>>2]|0,j|0,h|0)|0;if(!E)Pa(s|0,o|0);C=o}else E=-1;if((E|0)!=1){c[15244]=0;b:do if((q|0)!=0?(a[q>>0]|0)!=0:0){s=q;c:while(1){F=s+1|0;G=a[s>>0]|0;if(!(G<<24>>24))break b;switch(G<<24>>24|0){case 99:{c[15244]=c[15244]|8;s=F;continue c;break}case 105:{c[15244]=c[15244]|18;s=F;continue c;break}case 109:{c[15244]=c[15244]|1;s=F;continue c;break}case 114:{c[15244]=c[15244]|4;s=F;continue c;break}case 115:{c[15244]=c[15244]|2;s=F;continue c;break}default:{s=F;continue c}}}}while(0);if(e){n=0;ka(25,0,147683,g|0)|0;q=n;n=0;if((q|0)!=0&(o|0)!=0){H=Y4(c[q>>2]|0,j|0,h|0)|0;if(!H)Pa(q|0,o|0);C=o}else H=-1;if((H|0)==1){u=e;v=C;w=m;x=0;y=0;z=D;A=0;B=76;break}I=0}else I=e;n=0;q=ra(98,b|0,I|0)|0;s=n;n=0;if((s|0)!=0&(o|0)!=0){J=Y4(c[s>>2]|0,j|0,h|0)|0;if(!J)Pa(s|0,o|0);C=o}else J=-1;if((J|0)!=1){s=c[q+16>>2]|0;if(c[15244]&2){n=0;ga(21,c[24742]|0,s|0);F=n;n=0;if((F|0)!=0&(o|0)!=0){K=Y4(c[F>>2]|0,j|0,h|0)|0;if(!K)Pa(F|0,o|0);C=o}else K=-1;if((K|0)==1){u=I;v=C;w=m;x=q;y=0;z=D;A=0;B=76;break}}n=0;F=ia(25,b|0)|0;G=n;n=0;if((G|0)!=0&(o|0)!=0){L=Y4(c[G>>2]|0,j|0,h|0)|0;if(!L)Pa(G|0,o|0);C=o}else L=-1;if((L|0)!=1){G=F;F=0;while(1){if(!G)break;n=0;M=ra(99,b|0,G|0)|0;N=n;n=0;if((N|0)!=0&(o|0)!=0){O=Y4(c[N>>2]|0,j|0,h|0)|0;if(!O)Pa(N|0,o|0);C=o}else O=-1;if((O|0)==1){u=I;v=C;w=m;x=q;y=F;z=D;A=0;B=76;break a}N=M;M=F;while(1){if(!N)break;if((c[13795]|0)==2?(c[(c[N+8>>2]|0)+8>>2]|0)!=0:0)P=M;else B=31;d:do if((B|0)==31){B=0;do if(a[139e3]|0){Q=(c[c[((c[N>>2]&3|0)==3?N:N+32|0)+28>>2]>>2]|0)>>>4;R=(c[c[((c[N>>2]&3|0)==2?N:N+-32|0)+28>>2]>>2]|0)>>>4;if((Q|0)<=(R|0)){n=0;S=ka(38,D|0,Q|0,R|0)|0;T=n;n=0;if((T|0)!=0&(o|0)!=0){U=Y4(c[T>>2]|0,j|0,h|0)|0;if(!U)Pa(T|0,o|0);C=o}else U=-1;if((U|0)==1){u=I;v=C;w=m;x=q;y=M;z=D;A=0;B=76;break a}if(S){P=M;break d}n=0;wa(61,D|0,Q|0,R|0);S=n;n=0;if((S|0)!=0&(o|0)!=0){V=Y4(c[S>>2]|0,j|0,h|0)|0;if(!V)Pa(S|0,o|0);C=o}else V=-1;if((V|0)==1){u=I;v=C;w=m;x=q;y=M;z=D;A=0;B=76;break a}break}else{n=0;S=ka(38,D|0,R|0,Q|0)|0;T=n;n=0;if((T|0)!=0&(o|0)!=0){W=Y4(c[T>>2]|0,j|0,h|0)|0;if(!W)Pa(T|0,o|0);C=o}else W=-1;if((W|0)==1){u=I;v=C;w=m;x=q;y=M;z=D;A=0;B=76;break a}if(S){P=M;break d}n=0;wa(61,D|0,R|0,Q|0);Q=n;n=0;if((Q|0)!=0&(o|0)!=0){X=Y4(c[Q>>2]|0,j|0,h|0)|0;if(!X)Pa(Q|0,o|0);C=o}else X=-1;if((X|0)==1){u=I;v=C;w=m;x=q;y=M;z=D;A=0;B=76;break a}break}}while(0);c[m+(M<<3)+4>>2]=N;n=0;Q=ia(30,N|0)|0;R=n;n=0;if((R|0)!=0&(o|0)!=0){Y=Y4(c[R>>2]|0,j|0,h|0)|0;if(!Y)Pa(R|0,o|0);C=o}else Y=-1;if((Y|0)==1){u=I;v=C;w=m;x=q;y=M;z=D;A=0;B=76;break a}c[m+(M<<3)>>2]=Q;P=M+1|0}while(0);n=0;Q=ra(100,b|0,N|0)|0;R=n;n=0;if((R|0)!=0&(o|0)!=0){Z=Y4(c[R>>2]|0,j|0,h|0)|0;if(!Z)Pa(R|0,o|0);C=o}else Z=-1;if((Z|0)==1){u=I;v=C;w=m;x=q;y=P;z=D;A=0;B=76;break a}N=Q;M=P}n=0;N=ra(86,b|0,G|0)|0;Q=n;n=0;if((Q|0)!=0&(o|0)!=0){_=Y4(c[Q>>2]|0,j|0,h|0)|0;if(!_)Pa(Q|0,o|0);C=o}else _=-1;if((_|0)==1){u=I;v=C;w=m;x=q;y=M;z=D;A=0;B=76;break a}G=N;F=M}n=0;G=ia(31,F<<3|0)|0;N=n;n=0;if((N|0)!=0&(o|0)!=0){$=Y4(c[N>>2]|0,j|0,h|0)|0;if(!$)Pa(N|0,o|0);C=o}else $=-1;if(($|0)!=1){n=0;ya(26,m|0,F|0,8,101);N=n;n=0;if((N|0)!=0&(o|0)!=0){aa=Y4(c[N>>2]|0,j|0,h|0)|0;if(!aa)Pa(N|0,o|0);C=o}else aa=-1;if((aa|0)!=1){N=c[s>>2]|0;n=0;ea(102,(c[s>>2]|0)+2|0);Q=n;n=0;if((Q|0)!=0&(o|0)!=0){ba=Y4(c[Q>>2]|0,j|0,h|0)|0;if(!ba)Pa(Q|0,o|0);C=o}else ba=-1;if((ba|0)!=1){Q=(c[s+16>>2]|0)+(N*40|0)|0;R=(c[s+16>>2]|0)+((N+1|0)*40|0)|0;N=0;while(1){if((N|0)>=(F|0))break;if((N|0)>0?(c[15244]&16|0)!=0:0){n=0;ga(21,c[24742]|0,s|0);S=n;n=0;if((S|0)!=0&(o|0)!=0){ca=Y4(c[S>>2]|0,j|0,h|0)|0;if(!ca)Pa(S|0,o|0);C=o}else ca=-1;if((ca|0)==1){u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76;break a}}S=c[m+(N<<3)+4>>2]|0;T=c[(c[(c[((c[S>>2]&3|0)==3?S:S+32|0)+28>>2]|0)+8>>2]|0)+112>>2]|0;fa=c[(c[(c[((c[S>>2]&3|0)==2?S:S+-32|0)+28>>2]|0)+8>>2]|0)+112>>2]|0;if(!(((I|0)!=0?(ha=c[(c[S+8>>2]|0)+96>>2]|0,(ha|0)!=0):0)?(d[ha+81>>0]|0)!=0:0)){if((T|0)==(fa|0)){n=0;ya(27,s|0,T|0,R|0,Q|0);ha=n;n=0;if((ha|0)!=0&(o|0)!=0){ja=Y4(c[ha>>2]|0,j|0,h|0)|0;if(!ja)Pa(ha|0,o|0);C=o}else ja=-1;if((ja|0)==1){u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76;break a}}else{n=0;wa(62,s|0,fa|0,R|0);fa=n;n=0;if((fa|0)!=0&(o|0)!=0){la=Y4(c[fa>>2]|0,j|0,h|0)|0;if(!la)Pa(fa|0,o|0);C=o}else la=-1;if((la|0)==1){u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76;break a}n=0;wa(62,s|0,T|0,Q|0);T=n;n=0;if((T|0)!=0&(o|0)!=0){ma=Y4(c[T>>2]|0,j|0,h|0)|0;if(!ma)Pa(T|0,o|0);C=o}else ma=-1;if((ma|0)==1){u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76;break a}}n=0;T=ka(39,s|0,R|0,Q|0)|0;fa=n;n=0;if((fa|0)!=0&(o|0)!=0){na=Y4(c[fa>>2]|0,j|0,h|0)|0;if(!na)Pa(fa|0,o|0);C=o}else na=-1;if((na|0)==1){u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76;break a}if(T){oa=I;qa=m;sa=q;ua=F;va=D;za=G;break a}}T=G+(N<<3)|0;n=0;ya(28,k|0,s|0,Q|0,R|0);fa=n;n=0;if((fa|0)!=0&(o|0)!=0){Aa=Y4(c[fa>>2]|0,j|0,h|0)|0;if(!Aa)Pa(fa|0,o|0);C=o}else Aa=-1;if((Aa|0)==1){u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76;break a};c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];n=0;ea(103,s|0);T=n;n=0;if((T|0)!=0&(o|0)!=0){Ba=Y4(c[T>>2]|0,j|0,h|0)|0;if(!Ba)Pa(T|0,o|0);C=o}else Ba=-1;if((Ba|0)==1){u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76;break a}N=N+1|0}n=0;xa(6);N=n;n=0;if((N|0)!=0&(o|0)!=0){Ca=Y4(c[N>>2]|0,j|0,h|0)|0;if(!Ca)Pa(N|0,o|0);C=o}else Ca=-1;if((Ca|0)!=1){n=0;N=ia(32,q|0)|0;s=n;n=0;if((s|0)!=0&(o|0)!=0){Da=Y4(c[s>>2]|0,j|0,h|0)|0;if(!Da)Pa(s|0,o|0);C=o}else Da=-1;if((Da|0)!=1){c[q+20>>2]=N;n=0;N=ia(33,q|0)|0;s=n;n=0;if((s|0)!=0&(o|0)!=0){Ea=Y4(c[s>>2]|0,j|0,h|0)|0;if(!Ea)Pa(s|0,o|0);C=o}else Ea=-1;if((Ea|0)!=1){c[q+24>>2]=N;n=0;wa(63,F|0,G|0,q|0);N=n;n=0;if((N|0)!=0&(o|0)!=0){Fa=Y4(c[N>>2]|0,j|0,h|0)|0;if(!Fa)Pa(N|0,o|0);C=o}else Fa=-1;if((Fa|0)!=1){j=W4(60980,1,j|0,h|0)|0;h=C;n=0;N=n;n=0;if((N|0)!=0&(o|0)!=0){Ga=Y4(c[N>>2]|0,j|0,h|0)|0;if(!Ga)Pa(N|0,o|0);C=o}else Ga=-1;if((Ga|0)!=1){u=I;v=0;w=m;x=q;y=F;z=D;A=G;B=76}else{u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76}}else{u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76}}else{u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76}}else{u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76}}else{u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76}}else{u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76}}else{u=I;v=C;w=m;x=q;y=F;z=D;A=G;B=76}}else{u=I;v=C;w=m;x=q;y=F;z=D;A=0;B=76}}else{u=I;v=C;w=m;x=q;y=0;z=D;A=0;B=76}}else{u=I;v=C;w=m;x=0;y=0;z=D;A=0;B=76}}else{u=e;v=C;w=m;x=0;y=0;z=D;A=0;B=76}}else{u=e;v=C;w=0;x=0;y=0;z=0;A=0;B=76}}else{u=e;v=C;w=0;x=0;y=0;z=0;A=0;B=76}while(0);e:while(1){if((B|0)==76){B=0;if(v){oa=u;qa=w;sa=x;ua=y;va=z;za=A;continue}n=0;wa(64,y|0,A|0,x|0);e=n;n=0;if((e|0)!=0&(o|0)!=0){Ha=Y4(c[e>>2]|0,j|0,h|0)|0;if(!Ha)Pa(e|0,o|0);C=o}else Ha=-1;if((Ha|0)==1){Ia=A;Ja=z;Ka=y;La=x;Ma=w;Na=u;v=C;A=Ia;z=Ja;y=Ka;x=La;w=Ma;u=Na;B=76;continue}if(c[15244]&4){n=0;da(17,c[24742]|0,x|0,y|0,A|0,w|0);e=n;n=0;if((e|0)!=0&(o|0)!=0){Oa=Y4(c[e>>2]|0,j|0,h|0)|0;if(!Oa)Pa(e|0,o|0);C=o}else Oa=-1;if((Oa|0)==1){Ia=A;Ja=z;Ka=y;La=x;Ma=w;Na=u;v=C;A=Ia;z=Ja;y=Ka;x=La;w=Ma;u=Na;B=76;continue}}n=0;pa(1,b|0,x|0,y|0,A|0,61136,w|0,u|0);e=n;n=0;if((e|0)!=0&(o|0)!=0){Qa=Y4(c[e>>2]|0,j|0,h|0)|0;if(!Qa)Pa(e|0,o|0);C=o}else Qa=-1;if((Qa|0)==1){Ia=A;Ja=z;Ka=y;La=x;Ma=w;Na=u;v=C;A=Ia;z=Ja;y=Ka;x=La;w=Ma;u=Na;B=76;continue}oa=u;qa=w;sa=x;ua=y;va=z;za=A}if(a[139e3]|0){n=0;ea(104,va|0);e=n;n=0;if((e|0)!=0&(o|0)!=0){Ra=Y4(c[e>>2]|0,j|0,h|0)|0;if(!Ra)Pa(e|0,o|0);C=o}else Ra=-1;if((Ra|0)==1){u=oa;v=C;w=qa;x=sa;y=ua;z=va;A=za;B=76;continue}}e=0;while(1){if((e|0)>=(ua|0))break;n=0;ea(96,c[za+(e<<3)+4>>2]|0);D=n;n=0;if((D|0)!=0&(o|0)!=0){Sa=Y4(c[D>>2]|0,j|0,h|0)|0;if(!Sa)Pa(D|0,o|0);C=o}else Sa=-1;if((Sa|0)==1){u=oa;v=C;w=qa;x=sa;y=ua;z=va;A=za;B=76;continue e}e=e+1|0}n=0;ea(96,za|0);e=n;n=0;if((e|0)!=0&(o|0)!=0){Ta=Y4(c[e>>2]|0,j|0,h|0)|0;if(!Ta)Pa(e|0,o|0);C=o}else Ta=-1;if((Ta|0)==1){u=oa;v=C;w=qa;x=sa;y=ua;z=va;A=za;B=76;continue}n=0;ea(105,sa|0);e=n;n=0;if((e|0)!=0&(o|0)!=0){Ua=Y4(c[e>>2]|0,j|0,h|0)|0;if(!Ua)Pa(e|0,o|0);C=o}else Ua=-1;if((Ua|0)==1){u=oa;v=C;w=qa;x=sa;y=ua;z=va;A=za;B=76;continue}n=0;ea(96,qa|0);e=n;n=0;if((e|0)!=0&(o|0)!=0){Va=Y4(c[e>>2]|0,j|0,h|0)|0;if(!Va)Pa(e|0,o|0);C=o}else Va=-1;if((Va|0)==1){u=oa;v=C;w=qa;x=sa;y=ua;z=va;A=za;B=76}else break}O4(j|0);i=f;return}function zP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;d=i;i=i+96|0;e=d+32|0;f=d+16|0;g=d+88|0;j=d+84|0;k=d+80|0;l=d+76|0;m=d+72|0;n=d+64|0;o=d+56|0;p=d;q=d+48|0;c[g>>2]=a;c[j>>2]=b;_2(148553,c[g>>2]|0)|0;_2(148564,c[g>>2]|0)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[c[j>>2]>>2]|0))break;c[l>>2]=(c[(c[j>>2]|0)+16>>2]|0)+((c[o>>2]|0)*40|0);c[k>>2]=c[(c[l>>2]|0)+20>>2];b=c[k>>2]|0;if((c[k>>2]|0)==(c[(c[l>>2]|0)+20+4>>2]|0)){sQ(p,b);c[n>>2]=~~+h[p>>3];c[n+4>>2]=~~+h[p+8>>3]}else{if(c[b>>2]&1)c[k>>2]=c[(c[l>>2]|0)+20+4>>2];uQ(q,c[k>>2]|0,c[l>>2]|0);c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2]}b=c[g>>2]|0;a=c[n>>2]|0;r=c[n+4>>2]|0;c[f>>2]=c[o>>2];c[f+4>>2]=a;c[f+8>>2]=r;Y2(b,148584,f)|0;c[o>>2]=(c[o>>2]|0)+1}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break;c[m>>2]=(c[(c[j>>2]|0)+20>>2]|0)+((c[o>>2]|0)*24|0);f=c[g>>2]|0;n=c[(c[m>>2]|0)+16>>2]|0;s=+h[c[m>>2]>>3];c[e>>2]=c[(c[m>>2]|0)+12>>2];c[e+4>>2]=n;h[e+8>>3]=s;Y2(f,148604,e)|0;c[o>>2]=(c[o>>2]|0)+1}_2(148626,c[g>>2]|0)|0;i=d;return}function AP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=b+32|0;e=b+16|0;f=b;c[d>>2]=a;a=c[d>>2]|0;g=(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+16|0;c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];g=c[d>>2]|0;a=(c[(c[((c[c[d>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+16|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];i=b;return ~~((+h[e>>3]-+h[f>>3])*(+h[e>>3]-+h[f>>3])+(+h[e+8>>3]-+h[f+8>>3])*(+h[e+8>>3]-+h[f+8>>3]))|0}function BP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;i=d;return (c[c[e>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0}function CP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+96|0;j=g+84|0;k=g+80|0;l=g+76|0;m=g+72|0;n=g+68|0;o=g+64|0;p=g+40|0;q=g+60|0;r=g+24|0;s=g+16|0;t=g+56|0;u=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;sQ(p,c[k>>2]|0);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[k>>2]|0)+32>>2]|0))break;c[t>>2]=c[(c[(c[k>>2]|0)+36>>2]|0)+(c[n>>2]<<2)>>2];do if(!(a[(c[t>>2]|0)+36>>0]|0)){if((c[(c[t>>2]|0)+20>>2]|0)==(c[k>>2]|0)){c[o>>2]=1;c[q>>2]=c[(c[t>>2]|0)+20+4>>2]}else{c[o>>2]=0;c[q>>2]=c[(c[t>>2]|0)+20>>2]}qQ(u,c[t>>2]|0,c[q>>2]|0);c[r>>2]=c[u>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];c[r+12>>2]=c[u+12>>2];f=N(~~(+h[r>>3]-+h[p>>3])|0)|0;h[s>>3]=+(f+(N(~~(+h[r+8>>3]-+h[p+8>>3])|0)|0)|0);f=c[j>>2]|0;if(c[o>>2]|0){LQ(f,c[m>>2]|0,c[t>>2]|0,0.0)|0;break}else{LQ(f,c[l>>2]|0,c[t>>2]|0,0.0)|0;break}}while(0);c[n>>2]=(c[n>>2]|0)+1}n=c[j>>2]|0;c[n>>2]=(c[n>>2]|0)+2;i=g;return}function DP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+80|0;f=e+76|0;g=e+72|0;j=e+68|0;k=e+64|0;l=e+40|0;m=e+60|0;n=e+56|0;o=e+24|0;p=e+16|0;q=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;sQ(l,c[g>>2]|0);c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[g>>2]|0)+32>>2]|0))break;c[m>>2]=c[(c[(c[g>>2]|0)+36>>2]|0)+(c[k>>2]<<2)>>2];d=(c[m>>2]|0)+20|0;if((c[(c[m>>2]|0)+20>>2]|0)==(c[g>>2]|0))c[n>>2]=c[d+4>>2];else c[n>>2]=c[d>>2];qQ(q,c[m>>2]|0,c[n>>2]|0);c[o>>2]=c[q>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[o+12>>2]=c[q+12>>2];d=N(~~(+h[o>>3]-+h[l>>3])|0)|0;h[p>>3]=+(d+(N(~~(+h[o+8>>3]-+h[l+8>>3])|0)|0)|0);LQ(c[f>>2]|0,c[j>>2]|0,c[m>>2]|0,0.0)|0;c[k>>2]=(c[k>>2]|0)+1}k=c[f>>2]|0;c[k>>2]=(c[k>>2]|0)+1;k=c[g>>2]|0;c[(c[j>>2]|0)+20+4>>2]=k;c[(c[j>>2]|0)+20>>2]=k;i=e;return}function EP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=i;i=i+256|0;k=j+248|0;l=j+244|0;m=j+240|0;n=j+232|0;o=j+224|0;p=j+220|0;q=j+216|0;r=j+212|0;s=j+208|0;t=j+204|0;u=j+200|0;v=j+136|0;w=j+128|0;x=j+120|0;y=j+112|0;z=j+196|0;A=j+192|0;B=j+96|0;C=j+80|0;D=j+64|0;E=j+48|0;F=j+32|0;G=j+16|0;H=j;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[s>>2]=0;c[o>>2]=c[l>>2];while(1){if(!(c[o>>2]|0))break;c[s>>2]=(c[s>>2]|0)+1;c[o>>2]=c[(c[o>>2]|0)+8>>2]}c[n>>2]=0;c[n+4>>2]=bK(((c[s>>2]|0)-2|0)*56|0)|0;c[v+52>>2]=0;c[v+48>>2]=0;s=c[(c[l>>2]|0)+8>>2]|0;c[q>>2]=s;c[o>>2]=s;c[p>>2]=c[(c[o>>2]|0)+8>>2];s=(c[o>>2]|0)+20|0;if(c[c[(c[o>>2]|0)+20>>2]>>2]&1)c[t>>2]=c[s+4>>2];else c[t>>2]=c[s>>2];qQ(E,c[o>>2]|0,c[t>>2]|0);c[B>>2]=c[E>>2];c[B+4>>2]=c[E+4>>2];c[B+8>>2]=c[E+8>>2];c[B+12>>2]=c[E+12>>2];while(1){if(!(c[(c[p>>2]|0)+8>>2]|0))break;c[u>>2]=rQ(c[q>>2]|0,c[p>>2]|0)|0;GU(c[k>>2]|0,c[u>>2]|0,c[(c[o>>2]|0)+12>>2]|0);if(!((d[(c[o>>2]|0)+36>>0]|0)==(d[(c[p>>2]|0)+36>>0]|0)?(c[(c[p>>2]|0)+8>>2]|0)!=(c[m>>2]|0):0)){if((d[(c[o>>2]|0)+36>>0]|0)!=(d[(c[p>>2]|0)+36>>0]|0)){sQ(F,c[u>>2]|0);c[C>>2]=c[F>>2];c[C+4>>2]=c[F+4>>2];c[C+8>>2]=c[F+8>>2];c[C+12>>2]=c[F+12>>2]}else{qQ(G,c[p>>2]|0,c[u>>2]|0);c[C>>2]=c[G>>2];c[C+4>>2]=c[G+4>>2];c[C+8>>2]=c[G+8>>2];c[C+12>>2]=c[G+12>>2]}E=(c[o>>2]|0)==(c[(c[l>>2]|0)+8>>2]|0);if(a[(c[o>>2]|0)+36>>0]|0){do if(!E)if(+h[D+8>>3]>+h[B+8>>3]){c[z>>2]=1;break}else{c[z>>2]=3;break}else c[z>>2]=0;while(0);do if((d[(c[o>>2]|0)+36>>0]|0)!=(d[(c[p>>2]|0)+36>>0]|0))if((c[(c[p>>2]|0)+20>>2]|0)==(c[u>>2]|0)){c[A>>2]=1;break}else{c[A>>2]=3;break}else c[A>>2]=0;while(0);h[w>>3]=+h[(c[t>>2]|0)+40+8>>3];h[x>>3]=+h[(c[t>>2]|0)+40>>3];h[y>>3]=+h[(c[u>>2]|0)+40>>3]}else{do if(!E)if(+h[D>>3]>+h[B>>3]){c[z>>2]=4;break}else{c[z>>2]=2;break}else c[z>>2]=0;while(0);do if((d[(c[o>>2]|0)+36>>0]|0)!=(d[(c[p>>2]|0)+36>>0]|0))if((c[(c[p>>2]|0)+20>>2]|0)==(c[u>>2]|0)){c[A>>2]=4;break}else{c[A>>2]=2;break}else c[A>>2]=0;while(0);h[w>>3]=+h[(c[t>>2]|0)+40>>3];h[x>>3]=+h[(c[t>>2]|0)+40+8>>3];h[y>>3]=+h[(c[u>>2]|0)+40+8>>3]}tQ(v,((a[(c[o>>2]|0)+36>>0]|0)!=0^1)&1,+h[w>>3],+h[x>>3],+h[y>>3],c[z>>2]|0,c[A>>2]|0);E=c[n>>2]|0;c[n>>2]=E+1;s=(c[n+4>>2]|0)+(E*56|0)|0;E=v;g=s+56|0;do{c[s>>2]=c[E>>2];s=s+4|0;E=E+4|0}while((s|0)<(g|0));c[t>>2]=c[u>>2];c[D>>2]=c[B>>2];c[D+4>>2]=c[B+4>>2];c[D+8>>2]=c[B+8>>2];c[D+12>>2]=c[B+12>>2];c[B>>2]=c[C>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];if((d[(c[o>>2]|0)+36>>0]|0)!=(d[(c[p>>2]|0)+36>>0]|0)?(c[(c[p>>2]|0)+8>>2]|0)==(c[m>>2]|0):0){qQ(H,c[p>>2]|0,c[u>>2]|0);c[C>>2]=c[H>>2];c[C+4>>2]=c[H+4>>2];c[C+8>>2]=c[H+8>>2];c[C+12>>2]=c[H+12>>2];c[A>>2]=0;if(a[(c[p>>2]|0)+36>>0]|0){if(+h[D+8>>3]>+h[B+8>>3])c[z>>2]=1;else c[z>>2]=3;h[w>>3]=+h[(c[t>>2]|0)+40+8>>3];h[x>>3]=+h[(c[t>>2]|0)+40>>3];h[y>>3]=+h[(c[u>>2]|0)+40>>3]}else{if(+h[D>>3]>+h[B>>3])c[z>>2]=4;else c[z>>2]=2;h[w>>3]=+h[(c[t>>2]|0)+40>>3];h[x>>3]=+h[(c[t>>2]|0)+40+8>>3];h[y>>3]=+h[(c[u>>2]|0)+40+8>>3]}tQ(v,((a[(c[p>>2]|0)+36>>0]|0)!=0^1)&1,+h[w>>3],+h[x>>3],+h[y>>3],c[z>>2]|0,c[A>>2]|0);f=c[n>>2]|0;c[n>>2]=f+1;s=(c[n+4>>2]|0)+(f*56|0)|0;E=v;g=s+56|0;do{c[s>>2]=c[E>>2];s=s+4|0;E=E+4|0}while((s|0)<(g|0))}c[o>>2]=c[p>>2]}c[q>>2]=c[p>>2];c[p>>2]=c[(c[p>>2]|0)+8>>2]}c[n+4>>2]=Q4(c[n+4>>2]|0,(c[n>>2]|0)*56|0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[n>>2]|0))break;if((c[r>>2]|0)>0)c[(c[n+4>>2]|0)+((c[r>>2]|0)*56|0)+48>>2]=(c[n+4>>2]|0)+(((c[r>>2]|0)-1|0)*56|0);if((c[r>>2]|0)<((c[n>>2]|0)-1|0))c[(c[n+4>>2]|0)+((c[r>>2]|0)*56|0)+52>>2]=(c[n+4>>2]|0)+(((c[r>>2]|0)+1|0)*56|0);c[r>>2]=(c[r>>2]|0)+1}c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];i=j;return}function FP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;j=b+8|0;k=b+4|0;l=b;c[d>>2]=a;c[g>>2]=Nz(61156,c[12989]|0)|0;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[c[d>>2]>>2]|0))break;c[k>>2]=(c[(c[d>>2]|0)+8>>2]|0)+((c[e>>2]|0)*72|0);if(!(c[c[k>>2]>>2]&4)){while(1){a=c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0;c[f>>2]=a;if(!a)break;a=c[(c[f>>2]|0)+20>>2]|0;c[l>>2]=a;if(!a)break;if(!((c[c[l>>2]>>2]&1|0)!=0^1))break;c[k>>2]=c[l>>2]}c[j>>2]=bK(40)|0;c[(c[j>>2]|0)+36>>2]=c[k>>2];h[(c[j>>2]|0)+8>>3]=+h[(c[k>>2]|0)+40>>3];a=c[k>>2]|0;c[a>>2]=c[a>>2]|4;while(1){a=c[c[(c[k>>2]|0)+36>>2]>>2]|0;c[f>>2]=a;if(!a)break;a=c[(c[f>>2]|0)+20+4>>2]|0;c[l>>2]=a;if(!a)break;if(!((c[c[l>>2]>>2]&1|0)!=0^1))break;c[k>>2]=c[l>>2];a=c[k>>2]|0;c[a>>2]=c[a>>2]|4}h[(c[j>>2]|0)+8+8>>3]=+h[(c[k>>2]|0)+40+16>>3];lQ(c[g>>2]|0,c[j>>2]|0,+h[(c[(c[j>>2]|0)+36>>2]|0)+40+8>>3])}c[e>>2]=(c[e>>2]|0)+1}i=b;return c[g>>2]|0}function GP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;j=b+8|0;k=b+4|0;l=b;c[d>>2]=a;c[g>>2]=Nz(61156,c[12989]|0)|0;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[c[d>>2]>>2]|0))break;c[k>>2]=(c[(c[d>>2]|0)+8>>2]|0)+((c[e>>2]|0)*72|0);if(!(c[c[k>>2]>>2]&2)){while(1){a=c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0;c[f>>2]=a;if(!a)break;a=c[(c[f>>2]|0)+20>>2]|0;c[l>>2]=a;if(!a)break;if(!((c[c[l>>2]>>2]&1|0)!=0^1))break;c[k>>2]=c[l>>2]}c[j>>2]=bK(40)|0;c[(c[j>>2]|0)+36>>2]=c[k>>2];h[(c[j>>2]|0)+8>>3]=+h[(c[k>>2]|0)+40+8>>3];a=c[k>>2]|0;c[a>>2]=c[a>>2]|2;while(1){a=c[(c[(c[k>>2]|0)+36>>2]|0)+4>>2]|0;c[f>>2]=a;if(!a)break;a=c[(c[f>>2]|0)+20+4>>2]|0;c[l>>2]=a;if(!a)break;if(!((c[c[l>>2]>>2]&1|0)!=0^1))break;c[k>>2]=c[l>>2];a=c[k>>2]|0;c[a>>2]=c[a>>2]|2}h[(c[j>>2]|0)+8+8>>3]=+h[(c[k>>2]|0)+40+16+8>>3];lQ(c[g>>2]|0,c[j>>2]|0,+h[(c[(c[j>>2]|0)+36>>2]|0)+40>>3])}c[e>>2]=(c[e>>2]|0)+1}i=b;return c[g>>2]|0}function HP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+8|0;o=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[g>>2]|0))break;e=(c[h>>2]|0)+(c[l>>2]<<3)|0;c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[n>>2]|0))break;c[o>>2]=(c[n+4>>2]|0)+((c[m>>2]|0)*56|0);e=c[j>>2]|0;if(a[c[o>>2]>>0]|0)c[k>>2]=OP(c[e+24>>2]|0,c[o>>2]|0)|0;else c[k>>2]=OP(c[e+20>>2]|0,c[o>>2]|0)|0;kQ(c[k>>2]|0,c[o>>2]|0);c[m>>2]=(c[m>>2]|0)+1}c[l>>2]=(c[l>>2]|0)+1}i=f;return}function IP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[e+8>>2]=a;c[e+4>>2]=b;c[f>>2]=d;SP(c[(c[f>>2]|0)+20>>2]|0);SP(c[(c[f>>2]|0)+24>>2]|0);TP(c[(c[f>>2]|0)+20>>2]|0);TP(c[(c[f>>2]|0)+24>>2]|0);UP(c[(c[f>>2]|0)+20>>2]|0,c[f>>2]|0);UP(c[(c[f>>2]|0)+24>>2]|0,c[f>>2]|0);VP(c[(c[f>>2]|0)+20>>2]|0);VP(c[(c[f>>2]|0)+24>>2]|0);i=e;return}function JP(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0;g=i;i=i+256|0;j=g+184|0;k=g+176|0;l=g+160|0;m=g+128|0;n=g+96|0;o=g+252|0;p=g+248|0;q=g+244|0;r=g+240|0;s=g+236|0;t=g+232|0;u=g+64|0;v=g+32|0;w=g+216|0;x=g;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;h[v+8>>3]=1797693134862315708145274.0e284;h[v>>3]=1797693134862315708145274.0e284;h[v+16+8>>3]=-1797693134862315708145274.0e284;h[v+16>>3]=-1797693134862315708145274.0e284;f=c[o>>2]|0;c[k>>2]=c[15287];Y2(f,147798,k)|0;f=c[o>>2]|0;c[j>>2]=10;c[j+4>>2]=10;Y2(f,147801,j)|0;_2(175970,c[o>>2]|0)|0;c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[(c[p>>2]|0)+4>>2]|0))break;f=(c[(c[p>>2]|0)+12>>2]|0)+((c[t>>2]|0)*72|0)+40|0;c[u>>2]=c[f>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];c[u+16>>2]=c[f+16>>2];c[u+20>>2]=c[f+20>>2];c[u+24>>2]=c[f+24>>2];c[u+28>>2]=c[f+28>>2];f=c[o>>2]|0;y=+h[u+8>>3];z=+h[u+16>>3];A=+h[u+16+8>>3];h[n>>3]=+h[u>>3];h[n+8>>3]=y;h[n+16>>3]=z;h[n+24>>3]=A;Y2(f,175989,n)|0;c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=0;while(1){B=c[o>>2]|0;if((c[t>>2]|0)>=(c[q>>2]|0))break;n=c[(c[s>>2]|0)+(c[t>>2]<<3)+4>>2]|0;f=(c[r>>2]|0)+(c[t>>2]<<3)|0;e=c[p>>2]|0;d=c[t>>2]|0;c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[j+16>>2]=c[v+16>>2];c[j+20>>2]=c[v+20>>2];c[j+24>>2]=c[v+24>>2];c[j+28>>2]=c[v+28>>2];RP(x,B,n,k,e,d,j);c[v>>2]=c[x>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];c[t>>2]=(c[t>>2]|0)+1}_2(147818,B)|0;c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[c[p>>2]>>2]|0))break;B=(c[(c[p>>2]|0)+8>>2]|0)+((c[t>>2]|0)*72|0)+40|0;c[u>>2]=c[B>>2];c[u+4>>2]=c[B+4>>2];c[u+8>>2]=c[B+8>>2];c[u+12>>2]=c[B+12>>2];c[u+16>>2]=c[B+16>>2];c[u+20>>2]=c[B+20>>2];c[u+24>>2]=c[B+24>>2];c[u+28>>2]=c[B+28>>2];B=c[o>>2]|0;A=+h[u+8>>3];z=+h[u+16>>3];y=+h[u+16+8>>3];h[m>>3]=+h[u>>3];h[m+8>>3]=A;h[m+16>>3]=z;h[m+24>>3]=y;Y2(B,176026,m)|0;h[v>>3]=+h[v>>3]<+h[u>>3]?+h[v>>3]:+h[u>>3];h[v+8>>3]=+h[v+8>>3]<+h[u+8>>3]?+h[v+8>>3]:+h[u+8>>3];h[v+16>>3]=+h[v+16>>3]>+h[u+16>>3]?+h[v+16>>3]:+h[u+16>>3];if(+h[v+16+8>>3]>+h[u+16+8>>3])C=+h[v+16+8>>3];else C=+h[u+16+8>>3];h[v+16+8>>3]=C;c[t>>2]=(c[t>>2]|0)+1}c[w>>2]=~~(+h[v>>3]+10.0);c[w+4>>2]=~~(+h[v+8>>3]+10.0);c[w+8>>2]=~~(+h[v+16>>3]+10.0);c[w+8+4>>2]=~~(+h[v+16+8>>3]+10.0);v=c[o>>2]|0;o=c[15288]|0;t=c[w+4>>2]|0;u=c[w+8>>2]|0;m=c[w+8+4>>2]|0;c[l>>2]=c[w>>2];c[l+4>>2]=t;c[l+8>>2]=u;c[l+12>>2]=m;Y2(v,o,l)|0;i=g;return}function KP(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;m=i;i=i+208|0;n=m+104|0;o=m+88|0;p=m+80|0;q=m+192|0;r=m+188|0;s=m+184|0;t=m+180|0;u=m+176|0;v=m+172|0;w=m+168|0;x=m+164|0;y=m+160|0;z=m+156|0;A=m+152|0;B=m+148|0;C=m+144|0;D=m+64|0;E=m+48|0;F=m+32|0;G=m+136|0;H=m+128|0;I=m+124|0;J=m+120|0;K=m+16|0;L=m;c[q>>2]=b;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;c[x>>2]=0;c[B>>2]=0;c[C>>2]=0;while(1){if((c[x>>2]|0)>=(c[s>>2]|0))break;c[I>>2]=c[(c[v>>2]|0)+(c[x>>2]<<3)+4>>2];l=c[I>>2]|0;k=(c[(c[((c[c[I>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+16|0;l=(c[(c[I>>2]|0)+8>>2]|0)+16|0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];LP(K,o,n);c[E>>2]=c[K>>2];c[E+4>>2]=c[K+4>>2];c[E+8>>2]=c[K+8>>2];c[E+12>>2]=c[K+12>>2];l=c[I>>2]|0;k=(c[(c[((c[c[I>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+16|0;l=(c[(c[I>>2]|0)+8>>2]|0)+56|0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];LP(L,o,n);c[F>>2]=c[L>>2];c[F+4>>2]=c[L+4>>2];c[F+8>>2]=c[L+8>>2];c[F+12>>2]=c[L+12>>2];l=(c[t>>2]|0)+(c[x>>2]<<3)|0;c[G>>2]=c[l>>2];c[G+4>>2]=c[l+4>>2];c[A>>2]=1+((c[G>>2]|0)*3|0);if((c[A>>2]|0)>(c[C>>2]|0)){if(c[B>>2]|0)O4(c[B>>2]|0);c[B>>2]=cK(c[A>>2]<<4)|0;c[C>>2]=c[A>>2]}c[H>>2]=c[G+4>>2];l=c[H>>2]|0;k=c[r>>2]|0;if(a[c[H>>2]>>0]|0){h[D>>3]=+MP(l,k);h[D+8>>3]=+h[E+8>>3]}else{h[D+8>>3]=+(NP(l,k)|0);h[D>>3]=+h[E>>3]}k=c[B>>2]|0;l=(c[B>>2]|0)+16|0;c[l>>2]=c[D>>2];c[l+4>>2]=c[D+4>>2];c[l+8>>2]=c[D+8>>2];c[l+12>>2]=c[D+12>>2];c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[z>>2]=2;c[y>>2]=1;while(1){if((c[y>>2]|0)>=(c[G>>2]|0))break;c[H>>2]=(c[G+4>>2]|0)+((c[y>>2]|0)*56|0);l=c[H>>2]|0;k=c[r>>2]|0;if(a[c[H>>2]>>0]|0)h[D>>3]=+MP(l,k);else h[D+8>>3]=+(NP(l,k)|0);k=(c[B>>2]|0)+((c[z>>2]|0)+2<<4)|0;l=(c[B>>2]|0)+((c[z>>2]|0)+1<<4)|0;j=(c[B>>2]|0)+(c[z>>2]<<4)|0;c[j>>2]=c[D>>2];c[j+4>>2]=c[D+4>>2];c[j+8>>2]=c[D+8>>2];c[j+12>>2]=c[D+12>>2];c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[z>>2]=(c[z>>2]|0)+3;c[y>>2]=(c[y>>2]|0)+1}l=c[H>>2]|0;k=c[r>>2]|0;if(a[c[H>>2]>>0]|0){h[D>>3]=+MP(l,k);h[D+8>>3]=+h[F+8>>3]}else{h[D+8>>3]=+(NP(l,k)|0);h[D>>3]=+h[F>>3]}k=(c[B>>2]|0)+(c[z>>2]<<4)|0;l=(c[B>>2]|0)+((c[z>>2]|0)+1<<4)|0;c[l>>2]=c[D>>2];c[l+4>>2]=c[D+4>>2];c[l+8>>2]=c[D+8>>2];c[l+12>>2]=c[D+12>>2];c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];if((d[138998]|0)>1){l=c[24742]|0;k=c[I>>2]|0;j=wB(c[((c[c[I>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)|0;k=c[I>>2]|0;g=wB(c[((c[c[I>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)|0;c[p>>2]=j;c[p+4>>2]=g;Y2(l,147757,p)|0}l=c[I>>2]|0;jN(c[I>>2]|0,c[((c[c[I>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0,c[B>>2]|0,c[A>>2]|0,c[u>>2]|0);if(((c[w>>2]|0)!=0?(l=c[(c[(c[I>>2]|0)+8>>2]|0)+96>>2]|0,c[J>>2]=l,(l|0)!=0):0)?(a[(c[J>>2]|0)+81>>0]|0)==0:0){l=c[q>>2]|0;g=c[I>>2]|0;c[o>>2]=c[E>>2];c[o+4>>2]=c[E+4>>2];c[o+8>>2]=c[E+8>>2];c[o+12>>2]=c[E+12>>2];c[n>>2]=c[F>>2];c[n+4>>2]=c[F+4>>2];c[n+8>>2]=c[F+8>>2];c[n+12>>2]=c[F+12>>2];sN(l,g,o,n)}c[x>>2]=(c[x>>2]|0)+1}O4(c[B>>2]|0);i=m;return}function LP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;h[b>>3]=+h[b>>3]+ +h[d>>3];e=b+8|0;h[e>>3]=+h[e>>3]+ +h[d+8>>3];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];return}function MP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;j=d+16|0;k=d+8|0;l=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=OP(c[(c[f>>2]|0)+24>>2]|0,c[e>>2]|0)|0;h[j>>3]=+(c[(c[e>>2]|0)+44>>2]|0)/+((c[(c[g>>2]|0)+24>>2]|0)+1|0);h[k>>3]=+h[(c[(c[g>>2]|0)+36>>2]|0)+40>>3];h[l>>3]=+h[(c[(c[g>>2]|0)+36>>2]|0)+40+16>>3];i=d;return +(+h[k>>3]+ +h[j>>3]*(+h[l>>3]-+h[k>>3]))}function NP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;j=d+16|0;k=d+8|0;l=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=OP(c[(c[f>>2]|0)+20>>2]|0,c[e>>2]|0)|0;h[j>>3]=1.0-+(c[(c[e>>2]|0)+44>>2]|0)/+((c[(c[g>>2]|0)+24>>2]|0)+1|0);h[k>>3]=+h[(c[(c[g>>2]|0)+36>>2]|0)+40+8>>3];h[l>>3]=+h[(c[(c[g>>2]|0)+36>>2]|0)+40+16+8>>3];i=d;return ~~(+h[k>>3]+ +h[j>>3]*(+h[l>>3]-+h[k>>3]))|0}function OP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,(c[f>>2]|0)+8|0,512)|0;if(!(c[h>>2]|0))La(147770,147776,425,147784);c[g>>2]=Hb[c[c[(c[h>>2]|0)+16>>2]>>2]&63](c[(c[h>>2]|0)+16>>2]|0,(c[f>>2]|0)+16|0,512)|0;if(c[g>>2]|0){i=d;return c[g>>2]|0}else La(147795,147776,427,147784);return 0}function PP(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return 0}function QP(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return 0}function RP(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+96|0;m=l+48|0;n=l+40|0;o=l+32|0;p=l+84|0;q=l+80|0;r=l+76|0;s=l+68|0;t=l+64|0;u=l+60|0;v=l;w=l+56|0;c[p>>2]=d;c[q>>2]=e;c[r>>2]=g;c[l+72>>2]=j;j=c[q>>2]|0;g=(c[(c[(c[((c[c[q>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+112>>2]|0)+40|0;c[v>>2]=c[g>>2];c[v+4>>2]=c[g+4>>2];c[v+8>>2]=c[g+8>>2];c[v+12>>2]=c[g+12>>2];c[v+16>>2]=c[g+16>>2];c[v+20>>2]=c[g+20>>2];c[v+24>>2]=c[g+24>>2];c[v+28>>2]=c[g+28>>2];c[w>>2]=c[f+4>>2];g=c[w>>2]|0;j=c[r>>2]|0;if(a[c[w>>2]>>0]|0){c[t>>2]=~~+MP(g,j);c[u>>2]=~~((+h[v+16+8>>3]+ +h[v+8>>3])/2.0)}else{c[u>>2]=NP(g,j)|0;c[t>>2]=~~((+h[v+16>>3]+ +h[v>>3])/2.0)}if(+h[k>>3]<+(c[t>>2]|0))x=+h[k>>3];else x=+(c[t>>2]|0);h[k>>3]=x;if(+h[k+8>>3]<+(c[u>>2]|0))y=+h[k+8>>3];else y=+(c[u>>2]|0);h[k+8>>3]=y;if(+h[k+16>>3]>+(c[t>>2]|0))z=+h[k+16>>3];else z=+(c[t>>2]|0);h[k+16>>3]=z;if(+h[k+16+8>>3]>+(c[u>>2]|0))A=+h[k+16+8>>3];else A=+(c[u>>2]|0);h[k+16+8>>3]=A;j=c[p>>2]|0;g=c[u>>2]|0;c[o>>2]=c[t>>2];c[o+4>>2]=g;Y2(j,147894,o)|0;c[s>>2]=1;while(1){if((c[s>>2]|0)>=(c[f>>2]|0))break;c[w>>2]=(c[f+4>>2]|0)+((c[s>>2]|0)*56|0);o=c[w>>2]|0;j=c[r>>2]|0;if(a[c[w>>2]>>0]|0)c[t>>2]=~~+MP(o,j);else c[u>>2]=NP(o,j)|0;if(+h[k>>3]<+(c[t>>2]|0))B=+h[k>>3];else B=+(c[t>>2]|0);h[k>>3]=B;if(+h[k+8>>3]<+(c[u>>2]|0))C=+h[k+8>>3];else C=+(c[u>>2]|0);h[k+8>>3]=C;if(+h[k+16>>3]>+(c[t>>2]|0))D=+h[k+16>>3];else D=+(c[t>>2]|0);h[k+16>>3]=D;if(+h[k+16+8>>3]>+(c[u>>2]|0))E=+h[k+16+8>>3];else E=+(c[u>>2]|0);h[k+16+8>>3]=E;j=c[p>>2]|0;o=c[u>>2]|0;c[n>>2]=c[t>>2];c[n+4>>2]=o;Y2(j,147916,n)|0;c[s>>2]=(c[s>>2]|0)+1}s=c[q>>2]|0;n=(c[(c[(c[((c[c[q>>2]>>2]&3|0)==2?s:s+-32|0)+28>>2]|0)+8>>2]|0)+112>>2]|0)+40|0;c[v>>2]=c[n>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+16>>2]=c[n+16>>2];c[v+20>>2]=c[n+20>>2];c[v+24>>2]=c[n+24>>2];c[v+28>>2]=c[n+28>>2];n=c[w>>2]|0;s=c[r>>2]|0;if(a[c[w>>2]>>0]|0){c[t>>2]=~~+MP(n,s);c[u>>2]=~~((+h[v+16+8>>3]+ +h[v+8>>3])/2.0)}else{c[u>>2]=NP(n,s)|0;c[t>>2]=~~((+h[v>>3]+ +h[v+16>>3])/2.0)}if(+h[k>>3]<+(c[t>>2]|0))F=+h[k>>3];else F=+(c[t>>2]|0);h[k>>3]=F;if(+h[k+8>>3]<+(c[u>>2]|0))G=+h[k+8>>3];else G=+(c[u>>2]|0);h[k+8>>3]=G;if(+h[k+16>>3]>+(c[t>>2]|0))H=+h[k+16>>3];else H=+(c[t>>2]|0);h[k+16>>3]=H;if(+h[k+16+8>>3]>+(c[u>>2]|0)){I=+h[k+16+8>>3];J=k+16|0;K=J+8|0;h[K>>3]=I;L=c[p>>2]|0;M=c[t>>2]|0;N=M;O=c[u>>2]|0;P=O;c[m>>2]=N;Q=m+4|0;c[Q>>2]=P;Y2(L,147930,m)|0;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[b+12>>2]=c[k+12>>2];c[b+16>>2]=c[k+16>>2];c[b+20>>2]=c[k+20>>2];c[b+24>>2]=c[k+24>>2];c[b+28>>2]=c[k+28>>2];i=l;return}else{I=+(c[u>>2]|0);J=k+16|0;K=J+8|0;h[K>>3]=I;L=c[p>>2]|0;M=c[t>>2]|0;N=M;O=c[u>>2]|0;P=O;c[m>>2]=N;Q=m+4|0;c[Q>>2]=P;Y2(L,147930,m)|0;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[b+12>>2]=c[k+12>>2];c[b+16>>2]=c[k+16>>2];c[b+20>>2]=c[k+20>>2];c[b+24>>2]=c[k+24>>2];c[b+28>>2]=c[k+28>>2];i=l;return}}function SP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[f>>2]=Lz(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[e>>2]=c[(c[f>>2]|0)+16>>2];c[g>>2]=Lz(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[h>>2]=c[g>>2];d=vQ(c[(c[h>>2]|0)+24>>2]|0)|0;c[(c[h>>2]|0)+32>>2]=d;c[g>>2]=c[c[g>>2]>>2]}c[f>>2]=c[c[f>>2]>>2]}i=b;return}function TP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[f>>2]=Lz(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[e>>2]=c[(c[f>>2]|0)+16>>2];c[g>>2]=Lz(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[h>>2]=c[g>>2];if(c[(c[h>>2]|0)+24>>2]|0)jQ(c[h>>2]|0);c[g>>2]=c[c[g>>2]>>2]}c[f>>2]=c[c[f>>2]>>2]}i=b;return}function UP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=Lz(c[e>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;c[g>>2]=c[(c[h>>2]|0)+16>>2];c[j>>2]=Lz(c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;ZP(c[j>>2]|0,c[f>>2]|0);c[j>>2]=c[c[j>>2]>>2]}c[h>>2]=c[c[h>>2]>>2]}i=d;return}function VP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;j=b+4|0;k=b;c[d>>2]=a;c[f>>2]=Lz(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[e>>2]=c[(c[f>>2]|0)+16>>2];c[g>>2]=Lz(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[j>>2]=c[g>>2];a:do if(c[(c[j>>2]|0)+24>>2]|0){if(c[15244]&8)WP(c[j>>2]|0,~~+h[(c[f>>2]|0)+8>>3]);AQ(c[(c[j>>2]|0)+32>>2]|0);c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[j>>2]|0)+24>>2]|0))break a;c[(c[(c[(c[j>>2]|0)+28>>2]|0)+(c[k>>2]<<2)>>2]|0)+44>>2]=(c[(c[(c[(c[j>>2]|0)+32>>2]|0)+4>>2]|0)+((c[k>>2]|0)*12|0)+4>>2]|0)+1;c[k>>2]=(c[k>>2]|0)+1}}while(0);c[g>>2]=c[c[g>>2]>>2]}c[f>>2]=c[c[f>>2]>>2]}i=b;return}function WP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0;d=i;i=i+48|0;e=d;f=d+40|0;g=d+36|0;j=d+32|0;k=d+28|0;l=d+24|0;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+24>>2]|0)<2){i=d;return}b=c[24742]|0;m=+h[(c[f>>2]|0)+8>>3];n=+h[(c[f>>2]|0)+8+8>>3];c[e>>2]=c[g>>2];h[e+8>>3]=m;h[e+16>>3]=n;Y2(b,148357,e)|0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+24>>2]|0))break;c[l>>2]=c[(c[(c[(c[f>>2]|0)+32>>2]|0)+4>>2]|0)+((c[j>>2]|0)*12|0)+8>>2];a:do if(Pz(c[l>>2]|0)|0){XP(c[24742]|0,c[(c[(c[f>>2]|0)+28>>2]|0)+(c[j>>2]<<2)>>2]|0);_2(148377,c[24742]|0)|0;c[k>>2]=Hb[c[c[l>>2]>>2]&63](c[l>>2]|0,0,128)|0;while(1){if(!(c[k>>2]|0))break a;_2(148382,c[24742]|0)|0;XP(c[24742]|0,c[(c[(c[f>>2]|0)+28>>2]|0)+(c[c[k>>2]>>2]<<2)>>2]|0);_2(193392,c[24742]|0)|0;c[k>>2]=Hb[c[c[l>>2]>>2]&63](c[l>>2]|0,c[k>>2]|0,8)|0}}while(0);c[j>>2]=(c[j>>2]|0)+1}i=d;return}function XP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0;e=i;i=i+96|0;f=e+40|0;g=e;j=e+84|0;k=e+80|0;c[j>>2]=b;c[k>>2]=d;d=c[j>>2]|0;j=c[k>>2]|0;if(a[c[k>>2]>>0]|0){l=+h[j+8>>3];m=+h[(c[k>>2]|0)+16>>3];n=+h[(c[k>>2]|0)+8>>3];o=+h[(c[k>>2]|0)+16+8>>3];b=YP(c[(c[k>>2]|0)+32>>2]|0)|0;p=YP(c[(c[k>>2]|0)+36>>2]|0)|0;h[g>>3]=l;h[g+8>>3]=m;h[g+16>>3]=n;h[g+24>>3]=o;c[g+32>>2]=b;c[g+36>>2]=p;Y2(d,148388,g)|0;i=e;return}else{o=+h[j+16>>3];n=+h[(c[k>>2]|0)+8>>3];m=+h[(c[k>>2]|0)+16+8>>3];l=+h[(c[k>>2]|0)+8>>3];j=YP(c[(c[k>>2]|0)+32>>2]|0)|0;g=YP(c[(c[k>>2]|0)+36>>2]|0)|0;h[f>>3]=o;h[f+8>>3]=n;h[f+16>>3]=m;h[f+24>>3]=l;c[f+32>>2]=j;c[f+36>>2]=g;Y2(d,148388,f)|0;i=e;return}}function YP(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;switch(c[d>>2]|0){case 0:{c[e>>2]=148412;break}case 1:{c[e>>2]=148419;break}case 2:{c[e>>2]=148424;break}case 3:{c[e>>2]=148431;break}case 4:{c[e>>2]=148438;break}default:{}}i=b;return c[e>>2]|0}function ZP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+80|0;e=d+64|0;f=d+60|0;g=d+56|0;j=d+52|0;k=d+48|0;l=d+40|0;m=d+36|0;n=d+32|0;o=d+24|0;p=d+20|0;q=d+16|0;r=d+8|0;s=d;c[e>>2]=a;c[f>>2]=b;c[p>>2]=c[(c[e>>2]|0)+32>>2];c[q>>2]=c[(c[e>>2]|0)+28>>2];c[g>>2]=0;while(1){if(((c[g>>2]|0)+1|0)>=(c[(c[e>>2]|0)+24>>2]|0))break;c[j>>2]=(c[g>>2]|0)+1;while(1){if((c[j>>2]|0)>=(c[(c[e>>2]|0)+24>>2]|0))break;a:do if(((zQ(c[p>>2]|0,c[g>>2]|0,c[j>>2]|0)|0)==0?(zQ(c[p>>2]|0,c[j>>2]|0,c[g>>2]|0)|0)==0:0)?(_P(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0)|0)!=0:0){b=(c[(c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0)+48>>2]|0)==0;do if(!(c[(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0)+48>>2]|0))if(b){c[k>>2]=0;break}else{c[k>>2]=1;break}else{if(b){c[k>>2]=1;break}if(+h[(c[(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0)+48>>2]|0)+8>>3]==+h[(c[(c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0)+48>>2]|0)+8>>3]){c[k>>2]=0;break}else{c[k>>2]=1;break}}while(0);$P(r,c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,0,c[k>>2]|0);c[o>>2]=c[r>>2];c[o+4>>2]=c[r+4>>2];c[l>>2]=c[o>>2];c[m>>2]=c[o+4>>2];$P(s,c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,1,1-(c[k>>2]|0)|0);c[o>>2]=c[s>>2];c[o+4>>2]=c[s+4>>2];c[l+4>>2]=c[o>>2];c[n>>2]=c[o+4>>2];switch(c[m>>2]|0){case -1:{aQ(c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[k>>2]|0,0,c[l>>2]|0,c[f>>2]|0);aQ(c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,1-(c[k>>2]|0)|0,1,c[l+4>>2]|0,c[f>>2]|0);if((c[n>>2]|0)!=1)break a;bQ(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,1-(c[k>>2]|0)|0,c[f>>2]|0);break a;break}case 0:{switch(c[n>>2]|0){case -1:{aQ(c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[k>>2]|0,0,c[l>>2]|0,c[f>>2]|0);aQ(c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,1-(c[k>>2]|0)|0,1,c[l+4>>2]|0,c[f>>2]|0);break a;break}case 0:{aQ(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,0,c[k>>2]|0,c[l>>2]|0,c[f>>2]|0);aQ(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,1,1-(c[k>>2]|0)|0,c[l+4>>2]|0,c[f>>2]|0);break a;break}case 1:{aQ(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,0,c[k>>2]|0,c[l>>2]|0,c[f>>2]|0);aQ(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,1,1-(c[k>>2]|0)|0,c[l+4>>2]|0,c[f>>2]|0);break a;break}default:break a}break}case 1:{aQ(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,0,c[k>>2]|0,c[l>>2]|0,c[f>>2]|0);aQ(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,1,1-(c[k>>2]|0)|0,c[l+4>>2]|0,c[f>>2]|0);if((c[n>>2]|0)!=-1)break a;bQ(c[(c[q>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0,1-(c[k>>2]|0)|0,c[f>>2]|0);break a;break}default:break a}}while(0);c[j>>2]=(c[j>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1}i=d;return}function _P(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(+h[(c[e>>2]|0)+8>>3]==+h[(c[f>>2]|0)+8>>3]))La(148510,147776,845,148541);if(!(+h[(c[e>>2]|0)+16>>3]==+h[(c[f>>2]|0)+16>>3])){g=0;j=g&1;i=d;return j|0}if(!(+h[(c[e>>2]|0)+16+8>>3]==+h[(c[f>>2]|0)+16+8>>3])){g=0;j=g&1;i=d;return j|0}if((c[(c[e>>2]|0)+32>>2]|0)!=(c[(c[f>>2]|0)+32>>2]|0)){g=0;j=g&1;i=d;return j|0}g=(c[(c[e>>2]|0)+36>>2]|0)==(c[(c[f>>2]|0)+36>>2]|0);j=g&1;i=d;return j|0}function $P(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+8|0;q=g+4|0;r=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[n>>2]=0;while(1){f=cQ(c[h>>2]|0,c[k>>2]|0)|0;c[q>>2]=f;if(!f)break;f=cQ(c[j>>2]|0,c[l>>2]|0)|0;c[r>>2]=f;if(!f)break;if(!(_P(c[q>>2]|0,c[r>>2]|0)|0))break;c[n>>2]=(c[n>>2]|0)+1;c[h>>2]=c[q>>2];c[j>>2]=c[r>>2]}if(!(c[q>>2]|0)){c[m>>2]=0;s=c[n>>2]|0;c[p>>2]=s;t=c[m>>2]|0;u=p+4|0;c[u>>2]=t;c[a>>2]=c[p>>2];c[a+4>>2]=c[p+4>>2];i=g;return}if(!(c[r>>2]|0))La(176099,147776,873,148459);c[o>>2]=dQ(c[q>>2]|0,c[r>>2]|0)|0;c[m>>2]=eQ(c[q>>2]|0,c[o>>2]|0,(c[n>>2]|0)+1|0,1-(c[k>>2]|0)|0)|0;s=c[n>>2]|0;c[p>>2]=s;t=c[m>>2]|0;u=p+4|0;c[u>>2]=t;c[a>>2]=c[p>>2];c[a+4>>2]=c[p+4>>2];i=g;return}function aQ(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;i=i+48|0;l=k+40|0;m=k+36|0;n=k+32|0;o=k+28|0;p=k+24|0;q=k+20|0;r=k+16|0;s=k+12|0;t=k+8|0;u=k+4|0;v=k;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=j;j=c[q>>2]|0;if(a[c[l>>2]>>0]|0)c[s>>2]=OP(c[j+24>>2]|0,c[l>>2]|0)|0;else c[s>>2]=OP(c[j+20>>2]|0,c[l>>2]|0)|0;xQ(c[(c[s>>2]|0)+32>>2]|0,c[(c[l>>2]|0)+40>>2]|0,c[(c[m>>2]|0)+40>>2]|0);c[r>>2]=1;while(1){if((c[r>>2]|0)>(c[p>>2]|0))break;c[u>>2]=cQ(c[l>>2]|0,c[n>>2]|0)|0;c[v>>2]=cQ(c[m>>2]|0,c[o>>2]|0)|0;j=c[q>>2]|0;do if(a[c[l>>2]>>0]|0){c[t>>2]=OP(c[j+20>>2]|0,c[u>>2]|0)|0;g=c[l>>2]|0;if(+h[(c[u>>2]|0)+8>>3]==+h[(c[l>>2]|0)+16>>3]){f=(c[g+32>>2]|0)==2;e=(zQ(c[(c[s>>2]|0)+32>>2]|0,c[(c[l>>2]|0)+40>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0)!=0;d=c[(c[t>>2]|0)+32>>2]|0;if(f)if(e){xQ(d,c[(c[u>>2]|0)+40>>2]|0,c[(c[v>>2]|0)+40>>2]|0);break}else{xQ(d,c[(c[v>>2]|0)+40>>2]|0,c[(c[u>>2]|0)+40>>2]|0);break}else if(e){xQ(d,c[(c[v>>2]|0)+40>>2]|0,c[(c[u>>2]|0)+40>>2]|0);break}else{xQ(d,c[(c[u>>2]|0)+40>>2]|0,c[(c[v>>2]|0)+40>>2]|0);break}}else{d=(c[g+36>>2]|0)==2;g=(zQ(c[(c[s>>2]|0)+32>>2]|0,c[(c[l>>2]|0)+40>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0)!=0;e=c[(c[t>>2]|0)+32>>2]|0;if(d)if(g){xQ(e,c[(c[v>>2]|0)+40>>2]|0,c[(c[u>>2]|0)+40>>2]|0);break}else{xQ(e,c[(c[u>>2]|0)+40>>2]|0,c[(c[v>>2]|0)+40>>2]|0);break}else if(g){xQ(e,c[(c[u>>2]|0)+40>>2]|0,c[(c[v>>2]|0)+40>>2]|0);break}else{xQ(e,c[(c[v>>2]|0)+40>>2]|0,c[(c[u>>2]|0)+40>>2]|0);break}}}else{c[t>>2]=OP(c[j+24>>2]|0,c[u>>2]|0)|0;e=c[l>>2]|0;if(+h[(c[u>>2]|0)+8>>3]==+h[(c[l>>2]|0)+16>>3]){g=(c[e+32>>2]|0)==1;d=(zQ(c[(c[s>>2]|0)+32>>2]|0,c[(c[l>>2]|0)+40>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0)!=0;f=c[(c[t>>2]|0)+32>>2]|0;if(g)if(d){xQ(f,c[(c[v>>2]|0)+40>>2]|0,c[(c[u>>2]|0)+40>>2]|0);break}else{xQ(f,c[(c[u>>2]|0)+40>>2]|0,c[(c[v>>2]|0)+40>>2]|0);break}else if(d){xQ(f,c[(c[u>>2]|0)+40>>2]|0,c[(c[v>>2]|0)+40>>2]|0);break}else{xQ(f,c[(c[v>>2]|0)+40>>2]|0,c[(c[u>>2]|0)+40>>2]|0);break}}else{f=(c[e+36>>2]|0)==1;e=(zQ(c[(c[s>>2]|0)+32>>2]|0,c[(c[l>>2]|0)+40>>2]|0,c[(c[m>>2]|0)+40>>2]|0)|0)!=0;d=c[(c[t>>2]|0)+32>>2]|0;if(f)if(e){xQ(d,c[(c[u>>2]|0)+40>>2]|0,c[(c[v>>2]|0)+40>>2]|0);break}else{xQ(d,c[(c[v>>2]|0)+40>>2]|0,c[(c[u>>2]|0)+40>>2]|0);break}else if(e){xQ(d,c[(c[v>>2]|0)+40>>2]|0,c[(c[u>>2]|0)+40>>2]|0);break}else{xQ(d,c[(c[u>>2]|0)+40>>2]|0,c[(c[v>>2]|0)+40>>2]|0);break}}}while(0);c[s>>2]=c[t>>2];c[l>>2]=c[u>>2];c[m>>2]=c[v>>2];c[r>>2]=(c[r>>2]|0)+1}i=k;return}function bQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=c[h>>2];c[n>>2]=c[j>>2];while(1){j=(_P(c[m>>2]|0,c[n>>2]|0)|0)!=0;p=c[m>>2]|0;if(!j)break;c[m>>2]=cQ(p,1)|0;c[n>>2]=cQ(c[n>>2]|0,c[k>>2]|0)|0}k=c[l>>2]|0;if(a[p>>0]|0)c[o>>2]=OP(c[k+24>>2]|0,c[m>>2]|0)|0;else c[o>>2]=OP(c[k+20>>2]|0,c[m>>2]|0)|0;yQ(c[(c[o>>2]|0)+32>>2]|0,c[(c[m>>2]|0)+40>>2]|0,c[(c[n>>2]|0)+40>>2]|0);i=g;return}function cQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(!(c[f>>2]|0))La(148446,147776,800,148450);b=c[f>>2]|0;if(c[g>>2]|0){c[e>>2]=c[b+52>>2];h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=c[b+48>>2];h=c[e>>2]|0;i=d;return h|0}return 0}function dQ(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f;j=f+12|0;k=f+8|0;l=f+4|0;c[k>>2]=b;c[l>>2]=e;if((d[c[k>>2]>>0]|0)!=(d[c[l>>2]>>0]|0)){$z(1,148472,g)|0;Pa(60980,1)}if(+h[(c[k>>2]|0)+8>>3]!=+h[(c[l>>2]|0)+8>>3]){$z(1,148472,g)|0;Pa(60980,1)}g=c[k>>2]|0;e=c[l>>2]|0;if(a[c[k>>2]>>0]|0){c[j>>2]=fQ(g,e,4,2)|0;m=c[j>>2]|0;i=f;return m|0}else{c[j>>2]=fQ(g,e,3,1)|0;m=c[j>>2]|0;i=f;return m|0}return 0}function eQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[o>>2]=c[k>>2];c[q>>2]=c[j>>2];c[n>>2]=1;while(1){if((c[n>>2]|0)>(c[l>>2]|0))break;c[p>>2]=cQ(c[q>>2]|0,c[m>>2]|0)|0;j=+h[(c[p>>2]|0)+8>>3]==+h[(c[q>>2]|0)+16>>3];k=c[q>>2]|0;do if(a[c[q>>2]>>0]|0)if(j){if((c[k+32>>2]|0)!=4)break;c[o>>2]=_(c[o>>2]|0,-1)|0;break}else{if((c[k+36>>2]|0)!=2)break;c[o>>2]=_(c[o>>2]|0,-1)|0;break}else if(j){if((c[k+32>>2]|0)!=1)break;c[o>>2]=_(c[o>>2]|0,-1)|0;break}else{if((c[k+36>>2]|0)!=3)break;c[o>>2]=_(c[o>>2]|0,-1)|0;break}while(0);c[q>>2]=c[p>>2];c[n>>2]=(c[n>>2]|0)+1}i=g;return c[o>>2]|0}function fQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;f=i;i=i+32|0;g=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;if(!(+h[(c[j>>2]|0)+16+8>>3]<+h[(c[k>>2]|0)+16>>3])?!(+h[(c[j>>2]|0)+16>>3]>+h[(c[k>>2]|0)+16+8>>3]):0){if(+h[(c[j>>2]|0)+16>>3]<+h[(c[k>>2]|0)+16>>3]?+h[(c[k>>2]|0)+16>>3]<+h[(c[j>>2]|0)+16+8>>3]:0){c[g>>2]=gQ(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}if(+h[(c[k>>2]|0)+16>>3]<+h[(c[j>>2]|0)+16>>3]?+h[(c[j>>2]|0)+16>>3]<+h[(c[k>>2]|0)+16+8>>3]:0){c[g>>2]=_(-1,gQ(c[k>>2]|0,c[j>>2]|0,c[l>>2]|0,c[m>>2]|0)|0)|0;n=c[g>>2]|0;i=f;return n|0}o=+h[(c[j>>2]|0)+16+8>>3];e=(c[k>>2]|0)+16|0;if(!(+h[(c[j>>2]|0)+16>>3]==+h[(c[k>>2]|0)+16>>3])){d=c[j>>2]|0;if(o==+h[e>>3]){if((c[d+36>>2]|0)==(c[(c[k>>2]|0)+32>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if((c[(c[j>>2]|0)+36>>2]|0)==(c[m>>2]|0)){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}}else{if((c[d+32>>2]|0)==(c[(c[k>>2]|0)+36>>2]|0)){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if((c[(c[j>>2]|0)+32>>2]|0)==(c[m>>2]|0)){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}}}d=c[j>>2]|0;if(!(o==+h[e+8>>3]))if(+h[d+16+8>>3]<+h[(c[k>>2]|0)+16+8>>3]){e=(c[(c[j>>2]|0)+36>>2]|0)==(c[l>>2]|0);b=iQ(c[(c[k>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+32>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;if(e){c[g>>2]=b;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=_(-1,b)|0;n=c[g>>2]|0;i=f;return n|0}}else{b=(c[(c[k>>2]|0)+36>>2]|0)==(c[m>>2]|0);e=iQ(c[(c[j>>2]|0)+32>>2]|0,c[(c[k>>2]|0)+32>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;if(b){c[g>>2]=e;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=_(-1,e)|0;n=c[g>>2]|0;i=f;return n|0}}if((c[d+32>>2]|0)==(c[(c[k>>2]|0)+32>>2]|0)?(c[(c[j>>2]|0)+36>>2]|0)==(c[(c[k>>2]|0)+36>>2]|0):0){c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}d=(c[(c[k>>2]|0)+32>>2]|0)==(c[l>>2]|0);if((c[(c[k>>2]|0)+32>>2]|0)==(c[(c[k>>2]|0)+36>>2]|0)){if(d){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}if((c[(c[k>>2]|0)+32>>2]|0)==(c[m>>2]|0)){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if((c[(c[j>>2]|0)+32>>2]|0)!=(c[l>>2]|0)?(c[(c[j>>2]|0)+36>>2]|0)!=(c[l>>2]|0):0){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}if((c[(c[j>>2]|0)+32>>2]|0)!=(c[m>>2]|0)?(c[(c[j>>2]|0)+36>>2]|0)!=(c[m>>2]|0):0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if(d?(c[(c[k>>2]|0)+36>>2]|0)==(c[m>>2]|0):0){if((c[(c[j>>2]|0)+32>>2]|0)!=(c[l>>2]|0)?(c[(c[j>>2]|0)+36>>2]|0)==(c[m>>2]|0):0){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}if((c[(c[j>>2]|0)+32>>2]|0)==(c[l>>2]|0)?(c[(c[j>>2]|0)+36>>2]|0)!=(c[m>>2]|0):0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if((c[(c[k>>2]|0)+36>>2]|0)==(c[l>>2]|0)?(c[(c[k>>2]|0)+32>>2]|0)==(c[m>>2]|0):0){if((c[(c[j>>2]|0)+36>>2]|0)!=(c[l>>2]|0)?(c[(c[j>>2]|0)+32>>2]|0)==(c[m>>2]|0):0){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}if((c[(c[j>>2]|0)+36>>2]|0)==(c[l>>2]|0)?(c[(c[j>>2]|0)+32>>2]|0)!=(c[m>>2]|0):0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}if((c[(c[k>>2]|0)+32>>2]|0)==0?(c[(c[k>>2]|0)+36>>2]|0)==(c[l>>2]|0):0){c[g>>2]=hQ(c[(c[j>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+36>>2]|0,c[l>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}if((c[(c[k>>2]|0)+32>>2]|0)==0?(c[(c[k>>2]|0)+36>>2]|0)==(c[m>>2]|0):0){c[g>>2]=_(-1,hQ(c[(c[j>>2]|0)+32>>2]|0,c[(c[j>>2]|0)+36>>2]|0,c[m>>2]|0)|0)|0;n=c[g>>2]|0;i=f;return n|0}if((c[(c[k>>2]|0)+32>>2]|0)==(c[l>>2]|0)?(c[(c[k>>2]|0)+36>>2]|0)==0:0){c[g>>2]=hQ(c[(c[j>>2]|0)+36>>2]|0,c[(c[j>>2]|0)+32>>2]|0,c[l>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=_(-1,hQ(c[(c[j>>2]|0)+36>>2]|0,c[(c[j>>2]|0)+32>>2]|0,c[m>>2]|0)|0)|0;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}function gQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;e=c[j>>2]|0;if(+h[(c[j>>2]|0)+16+8>>3]<+h[(c[k>>2]|0)+16+8>>3]){if((c[e+36>>2]|0)==(c[l>>2]|0)?(c[(c[k>>2]|0)+32>>2]|0)==(c[m>>2]|0):0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if((c[(c[j>>2]|0)+36>>2]|0)==(c[m>>2]|0)?(c[(c[k>>2]|0)+32>>2]|0)==(c[l>>2]|0):0){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}d=(c[(c[k>>2]|0)+32>>2]|0)==(c[m>>2]|0);if(+h[e+16+8>>3]==+h[(c[k>>2]|0)+16+8>>3])if(d){c[g>>2]=iQ(c[(c[j>>2]|0)+36>>2]|0,c[(c[k>>2]|0)+36>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=_(-1,iQ(c[(c[k>>2]|0)+36>>2]|0,c[(c[j>>2]|0)+36>>2]|0,c[l>>2]|0,c[m>>2]|0)|0)|0;n=c[g>>2]|0;i=f;return n|0}if(d?(c[(c[k>>2]|0)+36>>2]|0)==(c[m>>2]|0):0){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}if((c[(c[k>>2]|0)+32>>2]|0)==(c[l>>2]|0)?(c[(c[k>>2]|0)+36>>2]|0)==(c[l>>2]|0):0){c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}function hQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;do if((c[g>>2]|0)==(c[j>>2]|0))if((c[h>>2]|0)==(c[j>>2]|0)){c[f>>2]=-1;break}else{c[f>>2]=0;break}else c[f>>2]=1;while(0);i=e;return c[f>>2]|0}function iQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!((c[h>>2]|0)==(c[l>>2]|0)?(e=(c[l>>2]|0)!=0^1,c[j>>2]=e&1,e):0))m=3;do if((m|0)==3){if((c[h>>2]|0)==0?(c[j>>2]|0)==(c[k>>2]|0):0)break;c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}while(0);c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}function jQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[g>>2]=c[(c[d>>2]|0)+28>>2];c[h>>2]=c[(c[d>>2]|0)+24>>2];c[j>>2]=c[(c[d>>2]|0)+32>>2];c[e>>2]=0;while(1){if(((c[e>>2]|0)+1|0)>=(c[h>>2]|0))break;c[f>>2]=(c[e>>2]|0)+1;while(1){k=c[e>>2]|0;if((c[f>>2]|0)>=(c[h>>2]|0))break;switch(dQ(c[(c[g>>2]|0)+(k<<2)>>2]|0,c[(c[g>>2]|0)+(c[f>>2]<<2)>>2]|0)|0){case 1:{xQ(c[j>>2]|0,c[e>>2]|0,c[f>>2]|0);break}case -1:{xQ(c[j>>2]|0,c[f>>2]|0,c[e>>2]|0);break}default:{}}c[f>>2]=(c[f>>2]|0)+1}c[e>>2]=k+1}i=b;return}function kQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=(c[e>>2]|0)+24|0;a=c[b>>2]|0;c[b>>2]=a+1;c[(c[f>>2]|0)+40>>2]=a;a=c[e>>2]|0;if(c[(c[e>>2]|0)+28>>2]|0)g=eK(c[a+28>>2]|0,c[(c[e>>2]|0)+24>>2]<<2)|0;else g=cK(c[a+24>>2]<<2)|0;c[(c[e>>2]|0)+28>>2]=g;c[(c[(c[e>>2]|0)+28>>2]|0)+((c[(c[e>>2]|0)+24>>2]|0)-1<<2)>>2]=c[f>>2];i=d;return}function lQ(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;j=e;k=e+8|0;c[f>>2]=a;c[g>>2]=b;h[j>>3]=d;c[k>>2]=Hb[c[c[f>>2]>>2]&63](c[f>>2]|0,j,512)|0;if(!(c[k>>2]|0)){c[k>>2]=bK(24)|0;h[(c[k>>2]|0)+8>>3]=+h[j>>3];j=Nz(61192,c[12989]|0)|0;c[(c[k>>2]|0)+16>>2]=j;Hb[c[c[f>>2]>>2]&63](c[f>>2]|0,c[k>>2]|0,1)|0}Hb[c[c[(c[k>>2]|0)+16>>2]>>2]&63](c[(c[k>>2]|0)+16>>2]|0,c[g>>2]|0,1)|0;i=e;return}function mQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;wQ(c[(c[f>>2]|0)+32>>2]|0);O4(c[(c[f>>2]|0)+28>>2]|0);O4(c[f>>2]|0);i=e;return}function nQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;j=f+8|0;k=f+4|0;c[f+12>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f>>2]=e;e=c[j>>2]|0;do if(+h[c[j>>2]>>3]>+h[c[k>>2]>>3])if(+h[e+8>>3]<=+h[(c[k>>2]|0)+8>>3]){c[g>>2]=0;break}else{c[g>>2]=1;break}else{if(!(+h[e>>3]<+h[c[k>>2]>>3])){c[g>>2]=0;break}if(+h[(c[j>>2]|0)+8>>3]>=+h[(c[k>>2]|0)+8>>3]){c[g>>2]=0;break}else{c[g>>2]=-1;break}}while(0);i=f;return c[g>>2]|0}function oQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;Jz(c[(c[f>>2]|0)+16>>2]|0)|0;O4(c[f>>2]|0);i=e;return}function pQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;j=f+8|0;k=f+4|0;c[f+12>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f>>2]=e;do if(!(+h[c[j>>2]>>3]>+h[c[k>>2]>>3]))if(+h[c[j>>2]>>3]<+h[c[k>>2]>>3]){c[g>>2]=-1;break}else{c[g>>2]=0;break}else c[g>>2]=1;while(0);i=f;return c[g>>2]|0}function qQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0.0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f;c[g>>2]=d;c[j>>2]=e;e=(a[(c[g>>2]|0)+36>>0]|0)!=0;d=(c[j>>2]|0)+40|0;do if((c[j>>2]|0)==(c[(c[g>>2]|0)+20+4>>2]|0)){l=+h[d>>3];if(e){h[k>>3]=l;h[k+8>>3]=(+h[(c[j>>2]|0)+40+8>>3]+ +h[(c[j>>2]|0)+40+16+8>>3])/2.0;break}else{h[k>>3]=(l+ +h[(c[j>>2]|0)+40+16>>3])/2.0;h[k+8>>3]=+h[(c[j>>2]|0)+40+8>>3];break}}else if(e){h[k>>3]=+h[d+16>>3];h[k+8>>3]=(+h[(c[j>>2]|0)+40+8>>3]+ +h[(c[j>>2]|0)+40+16+8>>3])/2.0;break}else{h[k>>3]=(+h[d>>3]+ +h[(c[j>>2]|0)+40+16>>3])/2.0;h[k+8>>3]=+h[(c[j>>2]|0)+40+16+8>>3];break}while(0);c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[b+12>>2]=c[k+12>>2];i=f;return}function rQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[f>>2]|0)+20>>2];if((c[h>>2]|0)!=(c[(c[g>>2]|0)+20>>2]|0)?(c[h>>2]|0)!=(c[(c[g>>2]|0)+20+4>>2]|0):0){c[e>>2]=c[(c[f>>2]|0)+20+4>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}function sQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+16|0;f=d;c[e>>2]=b;h[f>>3]=(+h[(c[e>>2]|0)+40>>3]+ +h[(c[e>>2]|0)+40+16>>3])/2.0;h[f+8>>3]=(+h[(c[e>>2]|0)+40+8>>3]+ +h[(c[e>>2]|0)+40+16+8>>3])/2.0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=d;return}function tQ(b,d,e,f,g,j,k){b=b|0;d=d|0;e=+e;f=+f;g=+g;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=i;i=i+48|0;m=l+36|0;n=l+32|0;o=l+16|0;p=l+8|0;q=l;r=l+28|0;s=l+24|0;c[m>>2]=b;c[n>>2]=d;h[o>>3]=e;h[p>>3]=f;h[q>>3]=g;c[r>>2]=j;c[s>>2]=k;a[c[m>>2]>>0]=c[n>>2];h[(c[m>>2]|0)+8>>3]=+h[o>>3];g=+h[p>>3];o=(c[m>>2]|0)+16|0;if(+h[p>>3]<+h[q>>3]){h[o>>3]=g;h[(c[m>>2]|0)+16+8>>3]=+h[q>>3];c[(c[m>>2]|0)+32>>2]=c[r>>2];c[(c[m>>2]|0)+36>>2]=c[s>>2];a[(c[m>>2]|0)+1>>0]=0;i=l;return}else{h[o+8>>3]=g;h[(c[m>>2]|0)+16>>3]=+h[q>>3];c[(c[m>>2]|0)+36>>2]=c[r>>2];c[(c[m>>2]|0)+32>>2]=c[s>>2];a[(c[m>>2]|0)+1>>0]=1;i=l;return}}function uQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;j=e;c[f>>2]=b;c[g>>2]=d;d=c[f>>2]|0;if((c[(c[(c[f>>2]|0)+36>>2]|0)+4>>2]|0)==(c[g>>2]|0)){c[j>>2]=~~((+h[d+40>>3]+ +h[(c[f>>2]|0)+40+16>>3])/2.0);c[j+4>>2]=~~+h[(c[f>>2]|0)+40+16+8>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];i=e;return}b=c[f>>2]|0;if((c[(c[d+36>>2]|0)+12>>2]|0)==(c[g>>2]|0)){c[j>>2]=~~((+h[b+40>>3]+ +h[(c[f>>2]|0)+40+16>>3])/2.0);c[j+4>>2]=~~+h[(c[f>>2]|0)+40+8>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];i=e;return}d=c[f>>2]|0;if((c[(c[b+36>>2]|0)+8>>2]|0)==(c[g>>2]|0)){c[j+4>>2]=~~((+h[d+40+8>>3]+ +h[(c[f>>2]|0)+40+16+8>>3])/2.0);c[j>>2]=~~+h[(c[f>>2]|0)+40>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];i=e;return}if((c[c[d+36>>2]>>2]|0)!=(c[g>>2]|0)){c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];i=e;return}c[j+4>>2]=~~((+h[(c[f>>2]|0)+40+8>>3]+ +h[(c[f>>2]|0)+40+16+8>>3])/2.0);c[j>>2]=~~+h[(c[f>>2]|0)+40+16>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];i=e;return}function vQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=bK(8)|0;c[c[f>>2]>>2]=c[d>>2];a=bK((c[d>>2]|0)*12|0)|0;c[(c[f>>2]|0)+4>>2]=a;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[d>>2]|0))break;a=rU()|0;c[(c[(c[f>>2]|0)+4>>2]|0)+((c[e>>2]|0)*12|0)+8>>2]=a;c[(c[(c[f>>2]|0)+4>>2]|0)+((c[e>>2]|0)*12|0)>>2]=0;c[e>>2]=(c[e>>2]|0)+1}i=b;return c[f>>2]|0}function wQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[c[d>>2]>>2]|0))break;Jz(c[(c[(c[d>>2]|0)+4>>2]|0)+((c[e>>2]|0)*12|0)+8>>2]|0)|0;c[e>>2]=(c[e>>2]|0)+1}O4(c[(c[d>>2]|0)+4>>2]|0);O4(c[d>>2]|0);i=b;return}function xQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[h>>2];Hb[c[c[(c[(c[f>>2]|0)+4>>2]|0)+((c[g>>2]|0)*12|0)+8>>2]>>2]&63](c[(c[(c[f>>2]|0)+4>>2]|0)+((c[g>>2]|0)*12|0)+8>>2]|0,j,1)|0;i=e;return}function yQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[h>>2];Hb[c[c[(c[(c[f>>2]|0)+4>>2]|0)+((c[g>>2]|0)*12|0)+8>>2]>>2]&63](c[(c[(c[f>>2]|0)+4>>2]|0)+((c[g>>2]|0)*12|0)+8>>2]|0,j,2)|0;c[j>>2]=c[g>>2];Hb[c[c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*12|0)+8>>2]>>2]&63](c[(c[(c[f>>2]|0)+4>>2]|0)+((c[h>>2]|0)*12|0)+8>>2]|0,j,2)|0;i=e;return}function zQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=(Hb[c[c[(c[(c[f>>2]|0)+4>>2]|0)+((c[g>>2]|0)*12|0)+8>>2]>>2]&63](c[(c[(c[f>>2]|0)+4>>2]|0)+((c[g>>2]|0)*12|0)+8>>2]|0,h,512)|0)!=0&1;i=e;return d|0}function AQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[g>>2]=0;c[h>>2]=0;if(!(c[c[d>>2]>>2]|0)){i=b;return}if((c[c[d>>2]>>2]|0)==1){c[(c[(c[d>>2]|0)+4>>2]|0)+4>>2]=c[h>>2];i=b;return}c[j>>2]=BQ(c[c[d>>2]>>2]|0)|0;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[c[d>>2]>>2]|0))break;if(!(c[(c[(c[d>>2]|0)+4>>2]|0)+((c[e>>2]|0)*12|0)>>2]|0))c[g>>2]=CQ(c[d>>2]|0,c[e>>2]|0,c[g>>2]|0,c[j>>2]|0)|0;c[e>>2]=(c[e>>2]|0)+1}while(1){e=DQ(c[j>>2]|0)|0;c[f>>2]=e;if((e|0)<0)break;c[(c[(c[d>>2]|0)+4>>2]|0)+((c[f>>2]|0)*12|0)+4>>2]=c[h>>2];c[h>>2]=(c[h>>2]|0)+1}EQ(c[j>>2]|0);i=b;return}function BQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=bK(8)|0;a=bK(c[d>>2]<<2)|0;c[(c[e>>2]|0)+4>>2]=a;c[c[e>>2]>>2]=-1;i=b;return c[e>>2]|0}function CQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[o>>2]=(c[(c[g>>2]|0)+4>>2]|0)+((c[h>>2]|0)*12|0);c[c[o>>2]>>2]=1;c[l>>2]=c[(c[o>>2]|0)+8>>2];c[j>>2]=(c[j>>2]|0)+1;c[m>>2]=Lz(c[l>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;e=c[m>>2]|0;if((c[(c[(c[l>>2]|0)+4>>2]|0)+8>>2]|0)<0)p=c[e+8>>2]|0;else p=e+(0-(c[(c[(c[l>>2]|0)+4>>2]|0)+8>>2]|0))|0;c[n>>2]=c[p>>2];if(!(c[(c[(c[g>>2]|0)+4>>2]|0)+((c[n>>2]|0)*12|0)>>2]|0))c[j>>2]=CQ(c[g>>2]|0,c[n>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;c[m>>2]=c[c[m>>2]>>2]}c[c[o>>2]>>2]=2;FQ(c[k>>2]|0,c[h>>2]|0);i=f;return (c[j>>2]|0)+1|0}function DQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[c[e>>2]>>2]|0)==-1){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}else{c[f>>2]=c[(c[(c[e>>2]|0)+4>>2]|0)+(c[c[e>>2]>>2]<<2)>>2];a=c[e>>2]|0;c[a>>2]=(c[a>>2]|0)+-1;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function EQ(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[d>>2]|0)+4>>2]|0);O4(c[d>>2]|0);i=b;return}function FQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=c[e>>2]|0;c[b>>2]=(c[b>>2]|0)+1;c[(c[(c[e>>2]|0)+4>>2]|0)+(c[c[e>>2]>>2]<<2)>>2]=c[f>>2];i=d;return}function GQ(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[(c[e>>2]|0)+8>>2]=c[c[e>>2]>>2];c[(c[e>>2]|0)+12>>2]=c[(c[e>>2]|0)+4>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[e>>2]>>2]|0))break;b[(c[(c[e>>2]|0)+16>>2]|0)+((c[f>>2]|0)*40|0)+18>>1]=b[(c[(c[e>>2]|0)+16>>2]|0)+((c[f>>2]|0)*40|0)+16>>1]|0;c[f>>2]=(c[f>>2]|0)+1}i=d;return}function HQ(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[c[e>>2]>>2]=c[(c[e>>2]|0)+8>>2];c[(c[e>>2]|0)+4>>2]=c[(c[e>>2]|0)+12>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[e>>2]>>2]|0))break;b[(c[(c[e>>2]|0)+16>>2]|0)+((c[f>>2]|0)*40|0)+16>>1]=b[(c[(c[e>>2]|0)+16>>2]|0)+((c[f>>2]|0)*40|0)+18>>1]|0;c[f>>2]=(c[f>>2]|0)+1}while(1){if((c[f>>2]|0)>=((c[c[e>>2]>>2]|0)+2|0))break;b[(c[(c[e>>2]|0)+16>>2]|0)+((c[f>>2]|0)*40|0)+16>>1]=0;c[f>>2]=(c[f>>2]|0)+1}i=d;return}function IQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=bK(((c[c[e>>2]>>2]|0)*6|0)+(c[f>>2]<<1)<<2)|0;b=bK((((c[c[e>>2]>>2]|0)*3|0)+(c[f>>2]|0)|0)*24|0)|0;c[(c[e>>2]|0)+20>>2]=b;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[c[e>>2]>>2]|0))break;c[(c[(c[e>>2]|0)+16>>2]|0)+((c[g>>2]|0)*40|0)+28>>2]=c[h>>2];c[h>>2]=(c[h>>2]|0)+24;c[g>>2]=(c[g>>2]|0)+1}while(1){if((c[g>>2]|0)>=((c[c[e>>2]>>2]|0)+2|0))break;c[(c[(c[e>>2]|0)+16>>2]|0)+((c[g>>2]|0)*40|0)+28>>2]=c[h>>2];c[h>>2]=(c[h>>2]|0)+(c[f>>2]<<2);c[g>>2]=(c[g>>2]|0)+1}i=d;return}function JQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=bK(24)|0;c[c[e>>2]>>2]=0;a=bK((c[d>>2]|0)*40|0)|0;c[(c[e>>2]|0)+16>>2]=a;i=b;return c[e>>2]|0}function KQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=(c[(c[d>>2]|0)+16>>2]|0)+((c[c[d>>2]>>2]|0)*40|0);c[(c[e>>2]|0)+32>>2]=c[c[d>>2]>>2];a=c[d>>2]|0;c[a>>2]=(c[a>>2]|0)+1;i=b;return c[e>>2]|0}function LQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;j=f+20|0;k=f+16|0;l=f;m=f+12|0;n=f+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=e;d=(c[g>>2]|0)+4|0;b=c[d>>2]|0;c[d>>2]=b+1;c[n>>2]=b;c[m>>2]=(c[(c[g>>2]|0)+20>>2]|0)+((c[n>>2]|0)*24|0);c[(c[m>>2]|0)+12>>2]=c[(c[j>>2]|0)+32>>2];c[(c[m>>2]|0)+16>>2]=c[(c[k>>2]|0)+32>>2];h[c[m>>2]>>3]=+h[l>>3];c[(c[m>>2]|0)+8>>2]=0;OQ(c[j>>2]|0,c[m>>2]|0,c[n>>2]|0);OQ(c[k>>2]|0,c[m>>2]|0,c[n>>2]|0);i=f;return c[m>>2]|0}function MQ(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[(c[d>>2]|0)+16>>2]|0)+28>>2]|0);O4(c[(c[d>>2]|0)+16>>2]|0);O4(c[(c[d>>2]|0)+20>>2]|0);O4(c[d>>2]|0);i=b;return}function NQ(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+48|0;g=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[j>>2]=a;c[k>>2]=d;c[l>>2]=e;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[c[j>>2]>>2]|0))break;c[s>>2]=(c[(c[j>>2]|0)+16>>2]|0)+((c[q>>2]|0)*40|0);c[c[s>>2]>>2]=-2147483648;c[q>>2]=(c[q>>2]|0)+1}zU();if(CU(c[k>>2]|0)|0){c[g>>2]=1;t=c[g>>2]|0;i=f;return t|0}c[(c[k>>2]|0)+8>>2]=0;c[c[k>>2]>>2]=0;a:while(1){k=EU()|0;c[m>>2]=k;if(!k){u=19;break}k=c[m>>2]|0;c[k>>2]=_(c[k>>2]|0,-1)|0;if((c[m>>2]|0)==(c[l>>2]|0)){u=19;break}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(b[(c[m>>2]|0)+16>>1]|0))continue a;c[n>>2]=(c[(c[j>>2]|0)+20>>2]|0)+((c[(c[(c[m>>2]|0)+28>>2]|0)+(c[r>>2]<<2)>>2]|0)*24|0);c[o>>2]=PQ(c[j>>2]|0,c[n>>2]|0,c[m>>2]|0)|0;do if((c[c[o>>2]>>2]|0)<0){c[p>>2]=~~-(+(c[c[m>>2]>>2]|0)+ +h[c[n>>2]>>3]);if((c[c[o>>2]>>2]|0)==-2147483648){c[c[o>>2]>>2]=c[p>>2];if(CU(c[o>>2]|0)|0){u=14;break a}c[(c[o>>2]|0)+8>>2]=c[m>>2];c[(c[o>>2]|0)+12>>2]=c[n>>2];break}else{if((c[c[o>>2]>>2]|0)>=(c[p>>2]|0))break;FU(c[o>>2]|0,c[p>>2]|0);c[(c[o>>2]|0)+8>>2]=c[m>>2];c[(c[o>>2]|0)+12>>2]=c[n>>2];break}}while(0);c[r>>2]=(c[r>>2]|0)+1}}if((u|0)==14){c[g>>2]=1;t=c[g>>2]|0;i=f;return t|0}else if((u|0)==19){c[g>>2]=0;t=c[g>>2]|0;i=f;return t|0}return 0}function OQ(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+8|0;h=f;c[g>>2]=a;c[f+4>>2]=d;c[h>>2]=e;c[(c[(c[g>>2]|0)+28>>2]|0)+(b[(c[g>>2]|0)+16>>1]<<2)>>2]=c[h>>2];h=(c[g>>2]|0)+16|0;b[h>>1]=(b[h>>1]|0)+1<<16>>16;i=f;return}function PQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=c[h>>2]|0;if((c[(c[h>>2]|0)+12>>2]|0)==(c[(c[j>>2]|0)+32>>2]|0)){c[f>>2]=(c[(c[g>>2]|0)+16>>2]|0)+((c[d+16>>2]|0)*40|0);k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=(c[(c[g>>2]|0)+16>>2]|0)+((c[d+12>>2]|0)*40|0);k=c[f>>2]|0;i=e;return k|0}return 0}function QQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[c[f>>2]>>2];yF(c[h>>2]|0,3,c[g>>2]|0)|0;c[j>>2]=c[(c[h>>2]|0)+80+12>>2];if(!(c[j>>2]|0)){c[e>>2]=999;l=c[e>>2]|0;i=d;return l|0}c[k>>2]=c[(c[j>>2]|0)+16>>2];c[(c[f>>2]|0)+76>>2]=c[(c[k>>2]|0)+12>>2];c[(c[f>>2]|0)+76+8>>2]=c[(c[k>>2]|0)+16>>2];c[(c[f>>2]|0)+76+4>>2]=c[c[k>>2]>>2];c[(c[f>>2]|0)+76+12>>2]=c[(c[j>>2]|0)+4>>2];g=(c[f>>2]|0)+152|0;c[g>>2]=c[g>>2]|c[c[(c[f>>2]|0)+76+8>>2]>>2];c[j>>2]=c[(c[h>>2]|0)+80>>2];if(!(c[j>>2]|0)){c[(c[f>>2]|0)+60>>2]=0;c[e>>2]=999;l=c[e>>2]|0;i=d;return l|0}c[k>>2]=c[(c[j>>2]|0)+16>>2];c[(c[f>>2]|0)+60>>2]=c[(c[k>>2]|0)+12>>2];c[(c[f>>2]|0)+60+8>>2]=c[(c[k>>2]|0)+16>>2];c[(c[f>>2]|0)+60+12>>2]=c[(c[j>>2]|0)+4>>2];j=(c[f>>2]|0)+152|0;c[j>>2]=c[j>>2]|c[c[(c[f>>2]|0)+60+8>>2]>>2];if(c[(c[f>>2]|0)+76>>2]|0)c[(c[f>>2]|0)+60+4>>2]=c[c[k>>2]>>2];else c[(c[f>>2]|0)+60+4>>2]=c[(c[f>>2]|0)+76+4>>2];c[e>>2]=300;l=c[e>>2]|0;i=d;return l|0}function RQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+60>>2];if(hF(c[e>>2]|0)|0){c[d>>2]=1;g=c[d>>2]|0;i=b;return g|0}if((c[f>>2]|0)!=0?(c[c[f>>2]>>2]|0)!=0:0)Bb[c[c[f>>2]>>2]&127](c[e>>2]|0);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function SQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+4>>2]|0)!=0:0)Bb[c[(c[e>>2]|0)+4>>2]&127](c[d>>2]|0);c[(c[c[d>>2]>>2]|0)+24>>2]=0;nF(c[d>>2]|0);i=b;return}function TQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+64|0;f=e+48|0;g=e+32|0;j=e+16|0;k=e;c[f>>2]=b;b=(c[f>>2]|0)+504|0;c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];h[k>>3]=+h[(c[f>>2]|0)+352>>3]*+h[(c[f>>2]|0)+520>>3];h[k+8>>3]=+h[(c[f>>2]|0)+352>>3]*+h[(c[f>>2]|0)+520+8>>3];if(c[(c[f>>2]|0)+360>>2]|0){h[g>>3]=-(+h[d+8>>3]+ +h[j+8>>3])*+h[k>>3];h[g+8>>3]=(+h[d>>3]+ +h[j>>3])*+h[k+8>>3];c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=e;return}else{h[g>>3]=(+h[d>>3]+ +h[j>>3])*+h[k>>3];h[g+8>>3]=(+h[d+8>>3]+ +h[j+8>>3])*+h[k+8>>3];c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=e;return}}function UQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+64|0;g=f+56|0;j=f+52|0;k=f+48|0;l=f+44|0;m=f+40|0;n=f+32|0;o=f+16|0;p=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;e=(c[g>>2]|0)+504|0;c[o>>2]=c[e>>2];c[o+4>>2]=c[e+4>>2];c[o+8>>2]=c[e+8>>2];c[o+12>>2]=c[e+12>>2];h[p>>3]=+h[(c[g>>2]|0)+352>>3]*+h[(c[g>>2]|0)+520>>3];h[p+8>>3]=+h[(c[g>>2]|0)+352>>3]*+h[(c[g>>2]|0)+520+8>>3];e=(c[(c[g>>2]|0)+360>>2]|0)!=0;c[m>>2]=0;if(e){while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;h[n>>3]=-(+h[(c[j>>2]|0)+(c[m>>2]<<4)+8>>3]+ +h[o+8>>3])*+h[p>>3];h[(c[k>>2]|0)+(c[m>>2]<<4)+8>>3]=(+h[(c[j>>2]|0)+(c[m>>2]<<4)>>3]+ +h[o>>3])*+h[p+8>>3];h[(c[k>>2]|0)+(c[m>>2]<<4)>>3]=+h[n>>3];c[m>>2]=(c[m>>2]|0)+1}q=c[k>>2]|0;i=f;return q|0}else{while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;h[(c[k>>2]|0)+(c[m>>2]<<4)>>3]=(+h[(c[j>>2]|0)+(c[m>>2]<<4)>>3]+ +h[o>>3])*+h[p>>3];h[(c[k>>2]|0)+(c[m>>2]<<4)+8>>3]=(+h[(c[j>>2]|0)+(c[m>>2]<<4)+8>>3]+ +h[o+8>>3])*+h[p+8>>3];c[m>>2]=(c[m>>2]|0)+1}q=c[k>>2]|0;i=f;return q|0}return 0}function VQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=d;c[e>>2]=a;c[d+4>>2]=b;c[f>>2]=c[(c[e>>2]|0)+60>>2];if(!(c[f>>2]|0)){i=d;return}if(!(c[(c[f>>2]|0)+8>>2]|0)){i=d;return}Bb[c[(c[f>>2]|0)+8>>2]&127](c[e>>2]|0);i=d;return}function WQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+12>>2]|0)!=0:0)Bb[c[(c[e>>2]|0)+12>>2]&127](c[d>>2]|0);mF(c[d>>2]|0);i=b;return}function XQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+24>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+24>>2]&127](c[d>>2]|0);i=b;return}function YQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+28>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+28>>2]&127](c[d>>2]|0);i=b;return}function ZQ(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+16>>2]|0)){i=b;return}Vb[c[(c[e>>2]|0)+16>>2]&31](c[d>>2]|0,c[(c[(c[c[d>>2]>>2]|0)+308>>2]|0)+(c[(c[d>>2]|0)+160>>2]<<2)>>2]|0,c[(c[d>>2]|0)+160>>2]|0,c[(c[d>>2]|0)+156>>2]|0);i=b;return}function _Q(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+20>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+20>>2]&127](c[d>>2]|0);i=b;return}function $Q(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=d;c[e>>2]=a;c[d+4>>2]=b;c[f>>2]=c[(c[e>>2]|0)+60>>2];if(!(c[f>>2]|0)){i=d;return}if(!(c[(c[f>>2]|0)+32>>2]|0)){i=d;return}Bb[c[(c[f>>2]|0)+32>>2]&127](c[e>>2]|0);i=d;return}function aR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=d;c[e>>2]=a;c[d+4>>2]=b;c[f>>2]=c[(c[e>>2]|0)+60>>2];if(!(c[f>>2]|0)){i=d;return}if(!(c[(c[f>>2]|0)+36>>2]|0)){i=d;return}Bb[c[(c[f>>2]|0)+36>>2]&127](c[e>>2]|0);i=d;return}function bR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+40>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+40>>2]&127](c[d>>2]|0);i=b;return}function cR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+44>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+44>>2]&127](c[d>>2]|0);i=b;return}function dR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+48>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+48>>2]&127](c[d>>2]|0);i=b;return}function eR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+52>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+52>>2]&127](c[d>>2]|0);i=b;return}function fR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=d;c[e>>2]=a;c[d+4>>2]=b;c[f>>2]=c[(c[e>>2]|0)+60>>2];if(!(c[f>>2]|0)){i=d;return}if(!(c[(c[f>>2]|0)+56>>2]|0)){i=d;return}Bb[c[(c[f>>2]|0)+56>>2]&127](c[e>>2]|0);i=d;return}function gR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+60>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+60>>2]&127](c[d>>2]|0);i=b;return}function hR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=d;c[e>>2]=a;c[d+4>>2]=b;c[f>>2]=c[(c[e>>2]|0)+60>>2];if(!(c[f>>2]|0)){i=d;return}if(!(c[(c[f>>2]|0)+64>>2]|0)){i=d;return}Bb[c[(c[f>>2]|0)+64>>2]&127](c[e>>2]|0);i=d;return}function iR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+68>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+68>>2]&127](c[d>>2]|0);i=b;return}function jR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[(c[h>>2]|0)+60>>2];if(!(c[n>>2]|0)){i=g;return}if(!(c[(c[n>>2]|0)+72>>2]|0)){i=g;return}Ab[c[(c[n>>2]|0)+72>>2]&31](c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0);i=g;return}function kR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+76>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+76>>2]&127](c[d>>2]|0);i=b;return}function lR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[e>>2]|0)+60>>2];if(!(c[g>>2]|0)){i=d;return}if(!(c[(c[g>>2]|0)+80>>2]|0)){i=d;return}Db[c[(c[g>>2]|0)+80>>2]&31](c[e>>2]|0,c[f>>2]|0);i=d;return}function mR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+60>>2];if(!(c[e>>2]|0)){i=b;return}if(!(c[(c[e>>2]|0)+84>>2]|0)){i=b;return}Bb[c[(c[e>>2]|0)+84>>2]&127](c[d>>2]|0);i=b;return}function nR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+64|0;g=f+32|0;h=f+56|0;j=f+52|0;k=f+48|0;l=f+16|0;m=f;c[h>>2]=b;c[j>>2]=e;c[k>>2]=c[(c[h>>2]|0)+60>>2];if(!(c[c[j>>2]>>2]|0)){i=f;return}if(!(a[c[c[j>>2]>>2]>>0]|0)){i=f;return}if((c[(c[h>>2]|0)+16>>2]|0)!=0?(c[(c[(c[h>>2]|0)+16>>2]|0)+144>>2]|0)==0:0){i=f;return}if(c[(c[h>>2]|0)+152>>2]&8192){c[l>>2]=c[d>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2]}else{e=c[h>>2]|0;c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];TQ(m,e,g);c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2]}if(!(c[k>>2]|0)){i=f;return}if(!(c[(c[k>>2]|0)+88>>2]|0)){i=f;return}m=c[(c[k>>2]|0)+88>>2]|0;k=c[h>>2]|0;h=c[j>>2]|0;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];Tb[m&127](k,g,h);i=f;return}function oR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[(c[f>>2]|0)+60>>2];c[j>>2]=(c[(c[f>>2]|0)+16>>2]|0)+16;c[k>>2]=0;d=U3(c[g>>2]|0,148898)|0;c[k>>2]=d;if(d)a[c[k>>2]>>0]=0;if((c[h>>2]|0)!=0?(AR(c[(c[f>>2]|0)+60+8>>2]|0,c[g>>2]|0,c[j>>2]|0),(c[(c[h>>2]|0)+92>>2]|0)!=0):0)Db[c[(c[h>>2]|0)+92>>2]&31](c[f>>2]|0,c[j>>2]|0);if(!(c[k>>2]|0)){i=e;return}a[c[k>>2]>>0]=58;i=e;return}function pR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[(c[f>>2]|0)+60>>2];c[j>>2]=(c[(c[f>>2]|0)+16>>2]|0)+56;c[k>>2]=0;d=U3(c[g>>2]|0,148898)|0;c[k>>2]=d;if(d)a[c[k>>2]>>0]=0;if((c[h>>2]|0)!=0?(AR(c[(c[f>>2]|0)+60+8>>2]|0,c[g>>2]|0,c[j>>2]|0),(c[(c[h>>2]|0)+92>>2]|0)!=0):0)Db[c[(c[h>>2]|0)+92>>2]&31](c[f>>2]|0,c[j>>2]|0);if(!(c[k>>2]|0)){i=e;return}a[c[k>>2]>>0]=58;i=e;return}function qR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;g[l>>2]=e;c[m>>2]=c[(c[h>>2]|0)+60>>2];c[n>>2]=(c[(c[h>>2]|0)+16>>2]|0)+96;if((c[m>>2]|0)!=0?(AR(c[(c[h>>2]|0)+60+8>>2]|0,c[j>>2]|0,c[n>>2]|0),(c[(c[m>>2]|0)+92>>2]|0)!=0):0)Db[c[(c[m>>2]|0)+92>>2]&31](c[h>>2]|0,c[n>>2]|0);c[(c[(c[h>>2]|0)+16>>2]|0)+136>>2]=c[k>>2];g[(c[(c[h>>2]|0)+16>>2]|0)+140>>2]=+g[l>>2];i=f;return}function rR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[(c[g>>2]|0)+60>>2];c[l>>2]=c[(c[g>>2]|0)+16>>2];c[(c[l>>2]|0)+160>>2]=c[j>>2];if(!((c[k>>2]|0)!=0&(c[j>>2]|0)!=0)){i=e;return}a:while(1){k=c[j>>2]|0;c[j>>2]=k+4;g=c[k>>2]|0;c[m>>2]=g;c[n>>2]=g;if(!g)break;if((a[c[m>>2]>>0]|0)==(a[148629]|0)?(J3(c[m>>2]|0,148629)|0)==0:0){c[(c[l>>2]|0)+144>>2]=3;continue}if((a[c[m>>2]>>0]|0)==(a[175383]|0)?(J3(c[m>>2]|0,175383)|0)==0:0){c[(c[l>>2]|0)+144>>2]=1;continue}if((a[c[m>>2]>>0]|0)==(a[175390]|0)?(J3(c[m>>2]|0,175390)|0)==0:0){c[(c[l>>2]|0)+144>>2]=2;continue}if(!((a[c[m>>2]>>0]|0)==(a[171938]|0)?(J3(c[m>>2]|0,171938)|0)==0:0))o=14;do if((o|0)==14){o=0;if((a[c[m>>2]>>0]|0)==(a[148635]|0)?(J3(c[m>>2]|0,148635)|0)==0:0)break;if((a[c[m>>2]>>0]|0)==(a[148645]|0)?(J3(c[m>>2]|0,148645)|0)==0:0){h[(c[l>>2]|0)+152>>3]=2.0;continue a}if((a[c[m>>2]>>0]|0)==(a[148650]|0)?(J3(c[m>>2]|0,148650)|0)==0:0){do{g=(a[c[n>>2]>>0]|0)!=0;c[n>>2]=(c[n>>2]|0)+1}while(g);p=+t3(c[n>>2]|0);h[(c[l>>2]|0)+152>>3]=p;continue a}if((a[c[m>>2]>>0]|0)==(a[148663]|0)?(J3(c[m>>2]|0,148663)|0)==0:0){c[(c[l>>2]|0)+148>>2]=1;continue a}if((a[c[m>>2]>>0]|0)==(a[148670]|0)?(J3(c[m>>2]|0,148670)|0)==0:0){c[(c[l>>2]|0)+148>>2]=0;continue a}if((a[c[m>>2]>>0]|0)==(a[148679]|0)?(J3(c[m>>2]|0,148679)|0)==0:0)continue a;c[f>>2]=c[m>>2];$z(0,148687,f)|0;continue a}while(0);c[(c[l>>2]|0)+144>>2]=0}i=e;return}function sR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+64|0;g=f+48|0;j=f+44|0;k=f+36|0;l=f+32|0;m=f;c[g>>2]=a;c[j>>2]=b;c[f+40>>2]=d;c[k>>2]=e;c[l>>2]=c[(c[g>>2]|0)+60>>2];if(!(c[l>>2]|0)){i=f;return}if(!(c[(c[l>>2]|0)+96>>2]|0)){i=f;return}if(!(c[(c[(c[g>>2]|0)+16>>2]|0)+144>>2]|0)){i=f;return}h[m>>3]=(+h[c[j>>2]>>3]+ +h[(c[j>>2]|0)+16>>3])/2.0;h[m+8>>3]=(+h[(c[j>>2]|0)+8>>3]+ +h[(c[j>>2]|0)+16+8>>3])/2.0;e=m+16|0;d=(c[j>>2]|0)+16|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];if(!(c[(c[g>>2]|0)+152>>2]&8192))UQ(c[g>>2]|0,m,m,2)|0;Tb[c[(c[l>>2]|0)+96>>2]&127](c[g>>2]|0,m,c[k>>2]|0);i=f;return}function tR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+64|0;g=f+60|0;h=f+56|0;j=f+52|0;k=f+48|0;l=f+44|0;m=f;n=f+40|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=0;c[n>>2]=c[(c[g>>2]|0)+60>>2];if(!(c[n>>2]|0)){i=f;return}if(!(c[(c[n>>2]|0)+100>>2]|0)){i=f;return}if(!(c[(c[(c[g>>2]|0)+16>>2]|0)+144>>2]|0)){i=f;return}if(c[k>>2]&4){c[l>>2]=1;c[k>>2]=c[k>>2]&-5;o=m;p=(c[(c[g>>2]|0)+16>>2]|0)+16|0;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));o=(c[(c[g>>2]|0)+16>>2]|0)+16|0;p=(c[(c[g>>2]|0)+16>>2]|0)+56|0;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0))}if(c[(c[g>>2]|0)+152>>2]&8192)Vb[c[(c[n>>2]|0)+100>>2]&31](c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);else{if((c[15307]|0)<(c[j>>2]|0)){c[15307]=(c[j>>2]|0)+10;c[15308]=eK(c[15308]|0,c[15307]<<4)|0}UQ(c[g>>2]|0,c[h>>2]|0,c[15308]|0,c[j>>2]|0)|0;Vb[c[(c[n>>2]|0)+100>>2]&31](c[g>>2]|0,c[15308]|0,c[j>>2]|0,c[k>>2]|0)}if(!(c[l>>2]|0)){i=f;return}o=(c[(c[g>>2]|0)+16>>2]|0)+16|0;p=m;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));i=f;return}function uR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+80|0;f=e+68|0;g=e+64|0;j=e;c[f>>2]=a;c[g>>2]=d;c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];d=j+32|0;a=b+16|0;c[d>>2]=c[a>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];h[j+16>>3]=+h[j>>3];h[j+16+8>>3]=+h[j+32+8>>3];h[j+48>>3]=+h[j+32>>3];h[j+48+8>>3]=+h[j+8>>3];tR(c[f>>2]|0,j,4,c[g>>2]|0);i=e;return}function vR(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+32|0;l=k+20|0;m=k+16|0;n=k+12|0;o=k+8|0;p=k+4|0;q=k+24|0;r=k;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;a[q>>0]=j;c[r>>2]=c[(c[l>>2]|0)+60>>2];if(!(c[r>>2]|0)){i=k;return}if(!(c[(c[r>>2]|0)+104>>2]|0)){i=k;return}if(!(c[(c[(c[l>>2]|0)+16>>2]|0)+144>>2]|0)){i=k;return}if(c[(c[l>>2]|0)+152>>2]&8192){Ib[c[(c[r>>2]|0)+104>>2]&15](c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,d[q>>0]|0);i=k;return}if((c[15307]|0)<(c[n>>2]|0)){c[15307]=(c[n>>2]|0)+10;c[15308]=eK(c[15308]|0,c[15307]<<4)|0}UQ(c[l>>2]|0,c[m>>2]|0,c[15308]|0,c[n>>2]|0)|0;Ib[c[(c[r>>2]|0)+104>>2]&15](c[l>>2]|0,c[15308]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,d[q>>0]|0);i=k;return}function wR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[(c[f>>2]|0)+60>>2];if(!(c[j>>2]|0)){i=e;return}if(!(c[(c[j>>2]|0)+108>>2]|0)){i=e;return}if(!(c[(c[(c[f>>2]|0)+16>>2]|0)+144>>2]|0)){i=e;return}if(c[(c[f>>2]|0)+152>>2]&8192){Tb[c[(c[j>>2]|0)+108>>2]&127](c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}if((c[15307]|0)<(c[h>>2]|0)){c[15307]=(c[h>>2]|0)+10;c[15308]=eK(c[15308]|0,c[15307]<<4)|0}UQ(c[f>>2]|0,c[g>>2]|0,c[15308]|0,c[h>>2]|0)|0;Tb[c[(c[j>>2]|0)+108>>2]&127](c[f>>2]|0,c[15308]|0,c[h>>2]|0);i=e;return}function xR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[(c[f>>2]|0)+60>>2];if(!(c[g>>2]|0)){i=e;return}if(!((c[h>>2]|0)!=0?(a[c[g>>2]>>0]|0)!=0:0)){i=e;return}if(!(c[(c[h>>2]|0)+112>>2]|0)){i=e;return}Db[c[(c[h>>2]|0)+112>>2]&31](c[f>>2]|0,c[g>>2]|0);i=e;return}function yR(b,e,f,g,j,k){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0;l=i;i=i+224|0;m=l+128|0;n=l+204|0;o=l+200|0;p=l+196|0;q=l+192|0;r=l+208|0;s=l+188|0;t=l+184|0;u=l+180|0;v=l+120|0;w=l+112|0;x=l+104|0;y=l+96|0;z=l+88|0;A=l+80|0;B=l+48|0;C=l+176|0;D=l+168|0;E=l+160|0;F=l+32|0;G=l+16|0;H=l+8|0;I=l;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;a[r>>0]=j;c[s>>2]=k;c[t>>2]=c[(c[n>>2]|0)+60>>2];if(!(c[n>>2]|0))La(148844,148740,698,148751);if(!(c[o>>2]|0))La(148770,148740,699,148751);if(!(a[c[o>>2]>>0]|0))La(148775,148740,700,148751);k=BF(c[o>>2]|0)|0;c[u>>2]=k;if(!k){k=(fM(c[o>>2]|0)|0)!=0;if(!(k&(c[t>>2]|0)!=0)){i=l;return}if(!(c[(c[t>>2]|0)+116>>2]|0)){i=l;return}Ab[c[(c[t>>2]|0)+116>>2]&31](c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,d[r>>0]|0);i=l;return}o=c[u>>2]|0;k=(c[n>>2]|0)+432|0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];c[m+8>>2]=c[k+8>>2];c[m+12>>2]=c[k+12>>2];EF(E,o,m);c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];if((c[D>>2]|0)<=0?(c[D+4>>2]|0)<=0:0){i=l;return}E=B+16|0;o=c[p>>2]|0;c[E>>2]=c[o>>2];c[E+4>>2]=c[o+4>>2];c[E+8>>2]=c[o+8>>2];c[E+12>>2]=c[o+12>>2];c[B>>2]=c[E>>2];c[B+4>>2]=c[E+4>>2];c[B+8>>2]=c[E+8>>2];c[B+12>>2]=c[E+12>>2];c[C>>2]=1;while(1){if((c[C>>2]|0)>=(c[q>>2]|0))break;if(+h[B>>3]<+h[(c[p>>2]|0)+(c[C>>2]<<4)>>3])J=+h[B>>3];else J=+h[(c[p>>2]|0)+(c[C>>2]<<4)>>3];h[B>>3]=J;if(+h[B+8>>3]<+h[(c[p>>2]|0)+(c[C>>2]<<4)+8>>3])K=+h[B+8>>3];else K=+h[(c[p>>2]|0)+(c[C>>2]<<4)+8>>3];h[B+8>>3]=K;if(+h[B+16>>3]>+h[(c[p>>2]|0)+(c[C>>2]<<4)>>3])L=+h[B+16>>3];else L=+h[(c[p>>2]|0)+(c[C>>2]<<4)>>3];h[B+16>>3]=L;if(+h[B+16+8>>3]>+h[(c[p>>2]|0)+(c[C>>2]<<4)+8>>3])M=+h[B+16+8>>3];else M=+h[(c[p>>2]|0)+(c[C>>2]<<4)+8>>3];h[B+16+8>>3]=M;c[C>>2]=(c[C>>2]|0)+1}h[x>>3]=+h[B+16>>3]-+h[B>>3];h[y>>3]=+h[B+16+8>>3]-+h[B+8>>3];h[w>>3]=+(c[D+4>>2]|0);h[v>>3]=+(c[D>>2]|0);h[z>>3]=+h[x>>3]/+h[v>>3];h[A>>3]=+h[y>>3]/+h[w>>3];a:do switch(BR(c[s>>2]|0)|0){case 1:{if(+h[z>>3]<+h[A>>3]){h[v>>3]=+h[v>>3]*+h[z>>3];h[w>>3]=+h[w>>3]*+h[z>>3];break a}else{h[v>>3]=+h[v>>3]*+h[A>>3];h[w>>3]=+h[w>>3]*+h[A>>3];break a}break}case 2:{h[v>>3]=+h[v>>3]*+h[z>>3];break}case 3:{h[w>>3]=+h[w>>3]*+h[A>>3];break}case 4:{h[v>>3]=+h[v>>3]*+h[z>>3];h[w>>3]=+h[w>>3]*+h[A>>3];break}default:{}}while(0);if(+h[v>>3]<+h[x>>3]){h[B>>3]=+h[B>>3]+(+h[x>>3]-+h[v>>3])/2.0;A=B+16|0;h[A>>3]=+h[A>>3]-(+h[x>>3]-+h[v>>3])/2.0}if(+h[w>>3]<+h[y>>3]){v=B+8|0;h[v>>3]=+h[v>>3]+(+h[y>>3]-+h[w>>3])/2.0;v=B+16+8|0;h[v>>3]=+h[v>>3]-(+h[y>>3]-+h[w>>3])/2.0}if(!(c[(c[n>>2]|0)+152>>2]&8192)){w=c[n>>2]|0;c[m>>2]=c[B>>2];c[m+4>>2]=c[B+4>>2];c[m+8>>2]=c[B+8>>2];c[m+12>>2]=c[B+12>>2];TQ(F,w,m);c[B>>2]=c[F>>2];c[B+4>>2]=c[F+4>>2];c[B+8>>2]=c[F+8>>2];c[B+12>>2]=c[F+12>>2];F=B+16|0;w=c[n>>2]|0;y=B+16|0;c[m>>2]=c[y>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];TQ(G,w,m);c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];c[F+12>>2]=c[G+12>>2]}if(+h[B>>3]>+h[B+16>>3]){h[H>>3]=+h[B>>3];h[B>>3]=+h[B+16>>3];h[B+16>>3]=+h[H>>3]}if(+h[B+8>>3]>+h[B+16+8>>3]){h[I>>3]=+h[B+8>>3];h[B+8>>3]=+h[B+16+8>>3];h[B+16+8>>3]=+h[I>>3]}if(!(c[t>>2]|0)){i=l;return}t=c[n>>2]|0;I=c[u>>2]|0;u=a[r>>0]|0;r=c[(c[n>>2]|0)+60+12>>2]|0;c[m>>2]=c[B>>2];c[m+4>>2]=c[B+4>>2];c[m+8>>2]=c[B+8>>2];c[m+12>>2]=c[B+12>>2];c[m+16>>2]=c[B+16>>2];c[m+20>>2]=c[B+20>>2];c[m+24>>2]=c[B+24>>2];c[m+28>>2]=c[B+28>>2];DR(t,I,m,u,r);i=l;return}function zR(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+12|0;f=d;g=d+8|0;c[e>>2]=a;h[f>>3]=b;c[g>>2]=c[(c[e>>2]|0)+60>>2];if(!(c[g>>2]|0)){i=d;return}h[(c[(c[e>>2]|0)+16>>2]|0)+152>>3]=+h[f>>3];i=d;return}function AR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+16|0;g=e+8|0;h=e;j=e+40|0;k=e+36|0;l=e+32|0;m=e+28|0;n=e+24|0;o=e+20|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[c[l>>2]>>2]=c[k>>2];c[(c[l>>2]|0)+32>>2]=5;c[m>>2]=bT(c[k>>2]|0)|0;if((c[(c[j>>2]|0)+16>>2]|0)!=0?(v3(m,c[(c[j>>2]|0)+16>>2]|0,c[(c[j>>2]|0)+20>>2]|0,4,102)|0)!=0:0){i=e;return}c[n>>2]=cT(c[k>>2]|0,c[l>>2]|0,c[(c[j>>2]|0)+24>>2]|0)|0;if(!(c[n>>2]|0)){i=e;return}if((c[n>>2]|0)!=1){$z(1,148823,f)|0;i=e;return}c[o>>2]=cK((N3(c[k>>2]|0)|0)+16|0)|0;f=c[o>>2]|0;c[h>>2]=c[k>>2];k3(f,148788,h)|0;if(GH(c[o>>2]|0)|0){c[g>>2]=c[k>>2];$z(0,148797,g)|0}O4(c[o>>2]|0);i=e;return}function BR(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;do if(a[c[f>>2]>>0]|0){if(!(F3(c[f>>2]|0,179125)|0)){c[e>>2]=2;break}if(!(F3(c[f>>2]|0,179057)|0)){c[e>>2]=3;break}if(!(F3(c[f>>2]|0,148783)|0)){c[e>>2]=4;break}if((kO(c[f>>2]|0)|0)<<24>>24){c[e>>2]=1;break}else{c[e>>2]=0;break}}else c[e>>2]=0;while(0);i=d;return c[e>>2]|0}function CR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=J3(c[c[e>>2]>>2]|0,c[c[f>>2]>>2]|0)|0;i=d;return b|0}function DR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+192|0;j=h+8|0;k=h;l=h+52|0;m=h+48|0;n=h+184|0;o=h+44|0;p=h+40|0;q=h+56|0;c[l>>2]=b;c[m>>2]=d;a[n>>0]=f;c[o>>2]=g;if(!(c[l>>2]|0))La(148844,148848,54,148862);if(!(c[m>>2]|0))La(148874,148848,55,148862);if(!(c[(c[m>>2]|0)+8>>2]|0))La(148877,148848,56,148862);if(!(a[c[(c[m>>2]|0)+8>>2]>>0]|0))La(148886,148848,57,148862);K3(q,c[(c[m>>2]|0)+28>>2]|0)|0;G3(q,148898)|0;G3(q,c[o>>2]|0)|0;if((ER(c[l>>2]|0,q)|0)==999){c[k>>2]=q;$z(0,148900,k)|0}k=c[(c[l>>2]|0)+92>>2]|0;c[p>>2]=k;if(!k){i=h;return}if(!(c[c[p>>2]>>2]|0)){i=h;return}k=c[c[p>>2]>>2]|0;p=c[l>>2]|0;l=c[m>>2]|0;m=a[n>>0]|0;c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[j+16>>2]=c[e+16>>2];c[j+20>>2]=c[e+20>>2];c[j+24>>2]=c[e+24>>2];c[j+28>>2]=c[e+28>>2];Vb[k&31](p,l,j,m);i=h;return}function ER(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=yF(c[c[f>>2]>>2]|0,4,c[g>>2]|0)|0;if(c[h>>2]|0){c[j>>2]=c[(c[h>>2]|0)+16>>2];c[(c[f>>2]|0)+92>>2]=c[(c[j>>2]|0)+12>>2];c[(c[f>>2]|0)+92+4>>2]=c[c[j>>2]>>2];c[e>>2]=300;k=c[e>>2]|0;i=d;return k|0}else{c[e>>2]=999;k=c[e>>2]|0;i=d;return k|0}return 0}function FR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=bK(392)|0;if(!(c[g>>2]|0)){h=c[g>>2]|0;i=d;return h|0}c[c[g>>2]>>2]=61236;c[(c[g>>2]|0)+16>>2]=22;c[(c[g>>2]|0)+32>>2]=c[e>>2];c[(c[g>>2]|0)+36>>2]=c[f>>2];h=c[g>>2]|0;i=d;return h|0}function GR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;do if(c[(c[e>>2]|0)+160>>2]|0){if(!(c[15312]|0)){c[15312]=c[(c[e>>2]|0)+160>>2];break}if(!(c[(c[15312]|0)+4>>2]|0)){b=bK(632)|0;c[(c[15312]|0)+4>>2]=b}c[15312]=c[(c[15312]|0)+4>>2]}else{b=bK(632)|0;c[(c[e>>2]|0)+160>>2]=b;c[(c[e>>2]|0)+164>>2]=b;c[15312]=b}while(0);c[(c[15312]|0)+32>>2]=c[f>>2];c[c[15312]>>2]=c[e>>2];i=d;return}function HR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;do if(c[(c[g>>2]|0)+160>>2]|0){if(!(c[15313]|0)){c[15313]=c[(c[g>>2]|0)+160>>2];break}if(!(c[(c[15313]|0)+4>>2]|0)){d=bK(632)|0;c[(c[15313]|0)+4>>2]=d}c[15313]=c[(c[15313]|0)+4>>2]}else{d=bK(632)|0;c[(c[g>>2]|0)+160>>2]=d;c[(c[g>>2]|0)+164>>2]=d;c[15313]=d}while(0);c[(c[15313]|0)+52>>2]=c[h>>2];c[c[15313]>>2]=c[g>>2];if(yF(c[g>>2]|0,3,c[h>>2]|0)|0){a[f>>0]=1;j=a[f>>0]|0;i=e;return j|0}else{a[f>>0]=0;j=a[f>>0]|0;i=e;return j|0}return 0}function IR(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[(c[d>>2]|0)+160>>2]|0;c[(c[d>>2]|0)+164>>2]=a;i=b;return a|0}function JR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[(c[d>>2]|0)+164>>2]|0)+4>>2];if((c[e>>2]|0)!=0?(c[(c[e>>2]|0)+52>>2]|0)==0:0)c[(c[e>>2]|0)+52>>2]=c[(c[(c[d>>2]|0)+164>>2]|0)+52>>2];a=c[e>>2]|0;c[(c[d>>2]|0)+164>>2]=a;i=b;return a|0}function KR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)>=(c[(c[f>>2]|0)+8>>2]|0)){c[(c[f>>2]|0)+8>>2]=(c[g>>2]|0)+10;d=eK(c[c[f>>2]>>2]|0,c[(c[f>>2]|0)+8>>2]<<2)|0;c[c[f>>2]>>2]=d}c[(c[c[f>>2]>>2]|0)+(c[g>>2]<<2)>>2]=c[h>>2];i=e;return}function LR(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[c[d>>2]>>2]|0)O4(c[c[d>>2]>>2]|0);c[c[d>>2]>>2]=0;c[(c[d>>2]|0)+8>>2]=0;c[(c[d>>2]|0)+4>>2]=0;i=b;return}function MR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+160>>2];while(1){a=c[e>>2]|0;c[f>>2]=a;if(!a)break;c[e>>2]=c[(c[e>>2]|0)+4>>2];LR((c[f>>2]|0)+604|0);LR((c[f>>2]|0)+592|0);if(c[(c[f>>2]|0)+584>>2]|0)O4(c[(c[f>>2]|0)+584>>2]|0);if(c[(c[f>>2]|0)+588>>2]|0)O4(c[(c[f>>2]|0)+588>>2]|0);O4(c[f>>2]|0)}c[15313]=0;c[15312]=0;c[(c[d>>2]|0)+192>>2]=0;c[(c[d>>2]|0)+164>>2]=0;c[(c[d>>2]|0)+160>>2]=0;c[(c[d>>2]|0)+28>>2]=0;i=b;return}function NR(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return 1}function OR(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;a[(c[e>>2]|0)+536>>0]=0;b=(c[e>>2]|0)+336|0;h[b>>3]=+h[b>>3]+10.0/+h[(c[e>>2]|0)+352>>3];a[(c[e>>2]|0)+537>>0]=1;i=d;return 0}function PR(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;a[(c[e>>2]|0)+536>>0]=0;b=(c[e>>2]|0)+336|0;h[b>>3]=+h[b>>3]-10.0/+h[(c[e>>2]|0)+352>>3];a[(c[e>>2]|0)+537>>0]=1;i=d;return 0}function QR(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;a[(c[e>>2]|0)+536>>0]=0;b=(c[e>>2]|0)+336+8|0;h[b>>3]=+h[b>>3]+-(10.0/+h[(c[e>>2]|0)+352>>3]);a[(c[e>>2]|0)+537>>0]=1;i=d;return 0}function RR(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;a[(c[e>>2]|0)+536>>0]=0;b=(c[e>>2]|0)+336+8|0;h[b>>3]=+h[b>>3]+10.0/+h[(c[e>>2]|0)+352>>3];a[(c[e>>2]|0)+537>>0]=1;i=d;return 0}function SR(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;a[(c[e>>2]|0)+536>>0]=0;b=(c[e>>2]|0)+352|0;h[b>>3]=+h[b>>3]*1.1;a[(c[e>>2]|0)+537>>0]=1;i=d;return 0}function TR(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;a[(c[e>>2]|0)+536>>0]=0;b=(c[e>>2]|0)+352|0;h[b>>3]=+h[b>>3]/1.1;a[(c[e>>2]|0)+537>>0]=1;i=d;return 0}function UR(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=b;a[(c[e>>2]|0)+536>>0]=((a[(c[e>>2]|0)+536>>0]|0)!=0^1)&1;if(!(a[(c[e>>2]|0)+536>>0]|0)){i=d;return 0}c[f>>2]=c[(c[e>>2]|0)+448>>2];c[g>>2]=c[(c[e>>2]|0)+452>>2];b=c[e>>2]|0;if(+((c[(c[e>>2]|0)+448>>2]|0)>>>0)/+(c[f>>2]|0)<+((c[(c[e>>2]|0)+452>>2]|0)>>>0)/+(c[g>>2]|0))j=+((c[b+448>>2]|0)>>>0)/+(c[f>>2]|0);else j=+((c[b+452>>2]|0)>>>0)/+(c[g>>2]|0);h[(c[e>>2]|0)+352>>3]=j;h[(c[e>>2]|0)+336>>3]=0.0;h[(c[e>>2]|0)+336+8>>3]=0.0;a[(c[e>>2]|0)+537>>0]=1;i=d;return 0}function VR(b){b=b|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=c[(c[c[f>>2]>>2]|0)+168>>2];if(!(c[(c[f>>2]|0)+580>>2]|0)){c[(c[f>>2]|0)+580>>2]=c[g>>2];b=(c[(c[g>>2]|0)+8>>2]|0)+112|0;a[b>>0]=d[b>>0]|0|2;jS(c[f>>2]|0,c[g>>2]|0)}FH(c[f>>2]|0,c[g>>2]|0);a[(c[f>>2]|0)+540>>0]=1;i=e;return}function WR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;j=f+20|0;k=f+16|0;c[j>>2]=b;c[k>>2]=d;switch(c[k>>2]|0){case 1:{d=c[j>>2]|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];cS(d,g);iS(c[j>>2]|0);a[(c[j>>2]|0)+538>>0]=1;a[(c[j>>2]|0)+541>>0]=c[k>>2];a[(c[j>>2]|0)+537>>0]=1;l=c[j>>2]|0;m=l+560|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];i=f;return}case 2:{a[(c[j>>2]|0)+538>>0]=1;a[(c[j>>2]|0)+541>>0]=c[k>>2];a[(c[j>>2]|0)+537>>0]=1;l=c[j>>2]|0;m=l+560|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];i=f;return}case 3:{d=c[j>>2]|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];cS(d,g);a[(c[j>>2]|0)+538>>0]=1;a[(c[j>>2]|0)+541>>0]=c[k>>2];a[(c[j>>2]|0)+537>>0]=1;l=c[j>>2]|0;m=l+560|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];i=f;return}case 4:{a[(c[j>>2]|0)+536>>0]=0;if(c[(c[j>>2]|0)+360>>2]|0){k=(c[j>>2]|0)+336|0;h[k>>3]=+h[k>>3]-(+h[e+8>>3]-+((c[(c[j>>2]|0)+452>>2]|0)>>>0)/2.0)*.10000000000000009/(+h[(c[j>>2]|0)+352>>3]*+h[(c[j>>2]|0)+520+8>>3]);k=(c[j>>2]|0)+336+8|0;h[k>>3]=+h[k>>3]+(+h[e>>3]-+((c[(c[j>>2]|0)+448>>2]|0)>>>0)/2.0)*.10000000000000009/(+h[(c[j>>2]|0)+352>>3]*+h[(c[j>>2]|0)+520>>3])}else{k=(c[j>>2]|0)+336|0;h[k>>3]=+h[k>>3]+(+h[e>>3]-+((c[(c[j>>2]|0)+448>>2]|0)>>>0)/2.0)*.10000000000000009/(+h[(c[j>>2]|0)+352>>3]*+h[(c[j>>2]|0)+520>>3]);k=(c[j>>2]|0)+336+8|0;h[k>>3]=+h[k>>3]+(+h[e+8>>3]-+((c[(c[j>>2]|0)+452>>2]|0)>>>0)/2.0)*.10000000000000009/(+h[(c[j>>2]|0)+352>>3]*+h[(c[j>>2]|0)+520+8>>3])}k=(c[j>>2]|0)+352|0;h[k>>3]=+h[k>>3]*1.1;a[(c[j>>2]|0)+537>>0]=1;l=c[j>>2]|0;m=l+560|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];i=f;return}case 5:{a[(c[j>>2]|0)+536>>0]=0;k=(c[j>>2]|0)+352|0;h[k>>3]=+h[k>>3]/1.1;if(c[(c[j>>2]|0)+360>>2]|0){k=(c[j>>2]|0)+336|0;h[k>>3]=+h[k>>3]+(+h[e+8>>3]-+((c[(c[j>>2]|0)+452>>2]|0)>>>0)/2.0)*.10000000000000009/(+h[(c[j>>2]|0)+352>>3]*+h[(c[j>>2]|0)+520+8>>3]);k=(c[j>>2]|0)+336+8|0;h[k>>3]=+h[k>>3]-(+h[e>>3]-+((c[(c[j>>2]|0)+448>>2]|0)>>>0)/2.0)*.10000000000000009/(+h[(c[j>>2]|0)+352>>3]*+h[(c[j>>2]|0)+520>>3])}else{k=(c[j>>2]|0)+336|0;h[k>>3]=+h[k>>3]-(+h[e>>3]-+((c[(c[j>>2]|0)+448>>2]|0)>>>0)/2.0)*.10000000000000009/(+h[(c[j>>2]|0)+352>>3]*+h[(c[j>>2]|0)+520>>3]);k=(c[j>>2]|0)+336+8|0;h[k>>3]=+h[k>>3]-(+h[e+8>>3]-+((c[(c[j>>2]|0)+452>>2]|0)>>>0)/2.0)*.10000000000000009/(+h[(c[j>>2]|0)+352>>3]*+h[(c[j>>2]|0)+520+8>>3])}a[(c[j>>2]|0)+537>>0]=1;l=c[j>>2]|0;m=l+560|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];i=f;return}default:{l=c[j>>2]|0;m=l+560|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];i=f;return}}}function XR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;i=i+16|0;f=e+4|0;c[f>>2]=b;c[e>>2]=d;a[(c[f>>2]|0)+538>>0]=0;a[(c[f>>2]|0)+541>>0]=0;i=e;return}function YR(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0;f=i;i=i+48|0;g=f+16|0;j=f+32|0;k=f+8|0;l=f;c[j>>2]=b;h[k>>3]=(+h[e>>3]-+h[(c[j>>2]|0)+560>>3])/+h[(c[j>>2]|0)+520>>3];h[l>>3]=(+h[e+8>>3]-+h[(c[j>>2]|0)+560+8>>3])/+h[(c[j>>2]|0)+520+8>>3];if(+(N(~~+h[k>>3]|0)|0)<.0001?+(N(~~+h[l>>3]|0)|0)<.0001:0){i=f;return}switch(d[(c[j>>2]|0)+541>>0]|0|0){case 0:{b=c[j>>2]|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];cS(b,g);break}case 2:{if(c[(c[j>>2]|0)+360>>2]|0){g=(c[j>>2]|0)+336|0;h[g>>3]=+h[g>>3]-+h[l>>3]/+h[(c[j>>2]|0)+352>>3];g=(c[j>>2]|0)+336+8|0;h[g>>3]=+h[g>>3]+ +h[k>>3]/+h[(c[j>>2]|0)+352>>3]}else{g=(c[j>>2]|0)+336|0;h[g>>3]=+h[g>>3]-+h[k>>3]/+h[(c[j>>2]|0)+352>>3];k=(c[j>>2]|0)+336+8|0;h[k>>3]=+h[k>>3]-+h[l>>3]/+h[(c[j>>2]|0)+352>>3]}a[(c[j>>2]|0)+537>>0]=1;break}default:{}}l=(c[j>>2]|0)+560|0;c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];i=f;return}function ZR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;i=i+16|0;c[e+8>>2]=a;c[e+4>>2]=b;c[e>>2]=d;i=e;return}function _R(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return}function $R(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[n>>2]=0;c[m>>2]=c[c[h>>2]>>2];do if(c[j>>2]|0){c[l>>2]=X2(c[j>>2]|0,176526)|0;if(c[l>>2]|0){c[n>>2]=CE(c[l>>2]|0,0)|0;R2(c[l>>2]|0)|0;break}else{i=f;return}}else{c[g>>2]=c[13065];c[n>>2]=gB(149044,g,0)|0;c[(c[h>>2]|0)+32>>2]=149046}while(0);if(!(c[n>>2]|0)){i=f;return}if(c[(c[m>>2]|0)+168>>2]|0){c[o>>2]=c[(c[m>>2]|0)+172>>2];if((c[o>>2]|0)!=0?(c[(c[o>>2]|0)+4>>2]|0)!=0:0)Bb[c[(c[o>>2]|0)+4>>2]&127](c[(c[m>>2]|0)+168>>2]|0);MJ(c[(c[m>>2]|0)+168>>2]|0);jB(c[(c[m>>2]|0)+168>>2]|0)|0}OC(c[n>>2]|0,0,175049,280,1);OC(c[n>>2]|0,1,175026,304,1);OC(c[n>>2]|0,2,175319,176,1);c[(c[m>>2]|0)+168>>2]=c[n>>2];c[(c[(c[n>>2]|0)+8>>2]|0)+144>>2]=c[m>>2];if((aG(c[m>>2]|0,c[n>>2]|0,c[k>>2]|0)|0)==-1){i=f;return}c[(c[h>>2]|0)+580>>2]=0;c[(c[h>>2]|0)+576>>2]=0;a[(c[h>>2]|0)+537>>0]=1;i=f;return}function aS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;aG(c[c[e>>2]>>2]|0,c[(c[c[e>>2]>>2]|0)+168>>2]|0,c[f>>2]|0)|0;i=d;return}function bS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;bG(c[c[f>>2]>>2]|0,c[(c[c[f>>2]>>2]|0)+168>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;i=e;return}function cS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+112|0;f=e+72|0;g=e+108|0;j=e+104|0;k=e+40|0;l=e+32|0;m=e+16|0;n=e;c[g>>2]=b;b=c[g>>2]|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];dS(n,b,f);c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];h[l>>3]=1.0/+h[(c[g>>2]|0)+352>>3];h[k+16>>3]=+h[m>>3]+ +h[l>>3];h[k+16+8>>3]=+h[m+8>>3]+ +h[l>>3];h[k>>3]=+h[m>>3]-+h[l>>3];h[k+8>>3]=+h[m+8>>3]-+h[l>>3];l=c[(c[c[g>>2]>>2]|0)+168>>2]|0;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[f+16>>2]=c[k+16>>2];c[f+20>>2]=c[k+20>>2];c[f+24>>2]=c[k+24>>2];c[f+28>>2]=c[k+28>>2];c[j>>2]=eS(l,f)|0;if((c[j>>2]|0)==(c[(c[g>>2]|0)+576>>2]|0)){i=e;return}fS(c[g>>2]|0);c[(c[g>>2]|0)+576>>2]=c[j>>2];gS(c[g>>2]|0);a[(c[g>>2]|0)+537>>0]=1;i=e;return}function dS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+16|0;g=e;c[f>>2]=b;if(c[(c[f>>2]|0)+360>>2]|0){h[g>>3]=+h[d+8>>3]/(+h[(c[f>>2]|0)+352>>3]*+h[(c[f>>2]|0)+520+8>>3])-+h[(c[f>>2]|0)+504>>3];h[g+8>>3]=-+h[d>>3]/(+h[(c[f>>2]|0)+352>>3]*+h[(c[f>>2]|0)+520>>3])-+h[(c[f>>2]|0)+504+8>>3];c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=e;return}else{h[g>>3]=+h[d>>3]/(+h[(c[f>>2]|0)+352>>3]*+h[(c[f>>2]|0)+520>>3])-+h[(c[f>>2]|0)+504>>3];h[g+8>>3]=+h[d+8>>3]/(+h[(c[f>>2]|0)+352>>3]*+h[(c[f>>2]|0)+520+8>>3])-+h[(c[f>>2]|0)+504+8>>3];c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=e;return}}function eS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+64|0;e=d;f=d+48|0;g=d+44|0;h=d+40|0;j=d+36|0;k=d+32|0;c[g>>2]=a;c[j>>2]=$B(c[g>>2]|0)|0;a:while(1){l=c[g>>2]|0;if(!(c[j>>2]|0))break;c[k>>2]=OA(l,c[j>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;a=c[k>>2]|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];c[e+24>>2]=c[b+24>>2];c[e+28>>2]=c[b+28>>2];if((OO(a,e)|0)<<24>>24){m=6;break a}c[k>>2]=QA(c[g>>2]|0,c[k>>2]|0)|0}c[j>>2]=aC(c[g>>2]|0,c[j>>2]|0)|0}if((m|0)==6){c[f>>2]=c[k>>2];n=c[f>>2]|0;i=d;return n|0}c[j>>2]=bC(l)|0;while(1){if(!(c[j>>2]|0))break;l=c[j>>2]|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];c[e+24>>2]=c[b+24>>2];c[e+28>>2]=c[b+28>>2];if((MO(l,e)|0)<<24>>24){m=12;break}c[j>>2]=cC(c[g>>2]|0,c[j>>2]|0)|0}if((m|0)==12){c[f>>2]=c[j>>2];n=c[f>>2]|0;i=d;return n|0}j=c[g>>2]|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];c[e+24>>2]=c[b+24>>2];c[e+28>>2]=c[b+28>>2];c[h>>2]=hS(j,e)|0;if(c[h>>2]|0){c[f>>2]=c[h>>2];n=c[f>>2]|0;i=d;return n|0}else{c[f>>2]=c[g>>2];n=c[f>>2]|0;i=d;return n|0}return 0}function fS(b){b=b|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+576>>2];a:do if(c[g>>2]|0)switch(BC(c[g>>2]|0)|0){case 0:{b=(c[(c[g>>2]|0)+8>>2]|0)+112|0;a[b>>0]=(d[b>>0]|0)&-2;break a;break}case 1:{b=(c[(c[g>>2]|0)+8>>2]|0)+117|0;a[b>>0]=(d[b>>0]|0)&-2;break a;break}case 2:{b=(c[(c[g>>2]|0)+8>>2]|0)+115|0;a[b>>0]=(d[b>>0]|0)&-2;break a;break}default:break a}while(0);c[(c[f>>2]|0)+584>>2]=0;i=e;return}function gS(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=b;if(c[(c[f>>2]|0)+584>>2]|0){O4(c[(c[f>>2]|0)+584>>2]|0);c[(c[f>>2]|0)+584>>2]=0}c[g>>2]=c[(c[f>>2]|0)+576>>2];if(!(c[g>>2]|0)){i=e;return}switch(BC(c[g>>2]|0)|0){case 0:{c[h>>2]=c[g>>2];b=(c[(c[h>>2]|0)+8>>2]|0)+112|0;a[b>>0]=d[b>>0]|0|1;c[l>>2]=qA(c[h>>2]|0,0,c[15352]|0,0)|0;if(!(c[l>>2]|0)){i=e;return}b=WJ(zA(c[h>>2]|0,c[l>>2]|0)|0,c[g>>2]|0)|0;c[(c[f>>2]|0)+584>>2]=b;i=e;return}case 1:{c[k>>2]=c[g>>2];b=(c[(c[k>>2]|0)+8>>2]|0)+117|0;a[b>>0]=d[b>>0]|0|1;c[l>>2]=qA(qC(c[k>>2]|0)|0,1,c[15352]|0,0)|0;if(!(c[l>>2]|0)){i=e;return}b=WJ(zA(c[k>>2]|0,c[l>>2]|0)|0,c[g>>2]|0)|0;c[(c[f>>2]|0)+584>>2]=b;i=e;return}case 2:{c[j>>2]=c[g>>2];b=(c[(c[j>>2]|0)+8>>2]|0)+115|0;a[b>>0]=d[b>>0]|0|1;b=c[j>>2]|0;c[l>>2]=qA(qC(c[((c[c[j>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)|0,2,c[15352]|0,0)|0;if(!(c[l>>2]|0)){i=e;return}b=WJ(zA(c[j>>2]|0,c[l>>2]|0)|0,c[g>>2]|0)|0;c[(c[f>>2]|0)+584>>2]=b;i=e;return}default:{i=e;return}}}function hS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+80|0;e=d+32|0;f=d+76|0;g=d+72|0;j=d+68|0;k=d+64|0;l=d;c[g>>2]=a;c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break;a=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2]|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];c[e+24>>2]=c[b+24>>2];c[e+28>>2]=c[b+28>>2];c[k>>2]=hS(a,e)|0;if(c[k>>2]|0){m=4;break}c[j>>2]=(c[j>>2]|0)+1}if((m|0)==4){c[f>>2]=c[k>>2];n=c[f>>2]|0;i=d;return n|0}h[l>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];h[l+8>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];h[l+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16+16>>3];h[l+16+8>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16+16+8>>3];if(((+h[b+16>>3]>=+h[l>>3]?+h[l+16>>3]>=+h[b>>3]:0)?+h[b+16+8>>3]>=+h[l+8>>3]:0)?+h[l+16+8>>3]>=+h[b+8>>3]:0){c[f>>2]=c[g>>2];n=c[f>>2]|0;i=d;return n|0}c[f>>2]=0;n=c[f>>2]|0;i=d;return n|0}function iS(b){b=b|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+580>>2];a:do if(c[g>>2]|0)switch(BC(c[g>>2]|0)|0){case 0:{b=(c[(c[g>>2]|0)+8>>2]|0)+112|0;a[b>>0]=d[b>>0]|0|4;b=(c[(c[g>>2]|0)+8>>2]|0)+112|0;a[b>>0]=(d[b>>0]|0)&-3;break a;break}case 1:{b=(c[(c[g>>2]|0)+8>>2]|0)+117|0;a[b>>0]=d[b>>0]|0|4;b=(c[(c[g>>2]|0)+8>>2]|0)+117|0;a[b>>0]=(d[b>>0]|0)&-3;break a;break}case 2:{b=(c[(c[g>>2]|0)+8>>2]|0)+115|0;a[b>>0]=d[b>>0]|0|4;b=(c[(c[g>>2]|0)+8>>2]|0)+115|0;a[b>>0]=(d[b>>0]|0)&-3;break a;break}default:break a}while(0);if(c[(c[f>>2]|0)+588>>2]|0){O4(c[(c[f>>2]|0)+588>>2]|0);c[(c[f>>2]|0)+588>>2]=0}b=c[(c[f>>2]|0)+576>>2]|0;c[(c[f>>2]|0)+580>>2]=b;c[g>>2]=b;if(!(c[g>>2]|0)){i=e;return}switch(BC(c[g>>2]|0)|0){case 0:{b=(c[(c[g>>2]|0)+8>>2]|0)+112|0;a[b>>0]=d[b>>0]|0|2;jS(c[f>>2]|0,c[g>>2]|0);i=e;return}case 1:{b=(c[(c[g>>2]|0)+8>>2]|0)+117|0;a[b>>0]=d[b>>0]|0|2;kS(c[f>>2]|0,c[g>>2]|0);i=e;return}case 2:{b=(c[(c[g>>2]|0)+8>>2]|0)+115|0;a[b>>0]=d[b>>0]|0|2;lS(c[f>>2]|0,c[g>>2]|0);i=e;return}default:{i=e;return}}}function jS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=(c[e>>2]|0)+592;c[g>>2]=0;b=c[f>>2]|0;do if((b|0)==(rC(c[f>>2]|0)|0)){a=(nB(c[f>>2]|0)|0)!=0;k=c[j>>2]|0;l=c[g>>2]|0;c[g>>2]=l+1;if(a){KR(k,l,c[15360]|0);break}else{KR(k,l,c[15361]|0);break}}else{l=c[j>>2]|0;k=c[g>>2]|0;c[g>>2]=k+1;KR(l,k,c[15362]|0)}while(0);b=c[j>>2]|0;k=c[g>>2]|0;c[g>>2]=k+1;KR(b,k,wB(c[f>>2]|0)|0);c[(c[j>>2]|0)+4>>2]=c[g>>2];c[j>>2]=(c[e>>2]|0)+604;c[h>>2]=0;while(1){k=rA(c[f>>2]|0,0,c[h>>2]|0)|0;c[h>>2]=k;if(!k)break;k=c[j>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;KR(k,b,c[(c[h>>2]|0)+8>>2]|0);b=c[j>>2]|0;k=c[g>>2]|0;c[g>>2]=k+1;KR(b,k,zA(c[f>>2]|0,c[h>>2]|0)|0);k=c[j>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;KR(k,b,0)}c[(c[j>>2]|0)+4>>2]=c[g>>2];c[h>>2]=qA(c[f>>2]|0,0,c[15357]|0,0)|0;if(!(c[h>>2]|0))c[h>>2]=qA(c[f>>2]|0,0,c[15358]|0,0)|0;if(!(c[h>>2]|0)){i=d;return}g=zA(c[f>>2]|0,c[h>>2]|0)|0;h=WJ(g,c[f>>2]|0)|0;c[(c[e>>2]|0)+588>>2]=h;i=d;return}function kS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=(c[e>>2]|0)+592;c[g>>2]=0;b=c[k>>2]|0;a=c[g>>2]|0;c[g>>2]=a+1;KR(b,a,c[15359]|0);a=c[k>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;KR(a,b,wB(c[f>>2]|0)|0);c[(c[k>>2]|0)+4>>2]=c[g>>2];c[k>>2]=(c[e>>2]|0)+604;c[j>>2]=rC(qC(c[f>>2]|0)|0)|0;c[h>>2]=0;while(1){b=rA(c[j>>2]|0,1,c[h>>2]|0)|0;c[h>>2]=b;if(!b)break;b=c[k>>2]|0;a=c[g>>2]|0;c[g>>2]=a+1;KR(b,a,c[(c[h>>2]|0)+8>>2]|0);a=c[k>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;KR(a,b,zA(c[f>>2]|0,c[h>>2]|0)|0)}c[(c[k>>2]|0)+4>>2]=c[g>>2];g=qC(c[f>>2]|0)|0;c[h>>2]=qA(g,1,c[15357]|0,0)|0;if(!(c[h>>2]|0)){g=qC(c[f>>2]|0)|0;c[h>>2]=qA(g,1,c[15358]|0,0)|0}if(!(c[h>>2]|0)){i=d;return}g=zA(c[f>>2]|0,c[h>>2]|0)|0;h=WJ(g,c[f>>2]|0)|0;c[(c[e>>2]|0)+588>>2]=h;i=d;return}function lS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=(c[e>>2]|0)+592;c[g>>2]=0;b=c[k>>2]|0;a=c[g>>2]|0;c[g>>2]=a+1;KR(b,a,c[15353]|0);a=c[k>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;m=c[f>>2]|0;KR(a,b,wB(c[((c[c[f>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)|0);c[g>>2]=(c[g>>2]|0)+1;m=c[k>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;a=c[f>>2]|0;n=(nB(qC(c[((c[c[f>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)|0)|0)!=0;KR(m,b,n?175316:178535);n=c[k>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;m=c[f>>2]|0;KR(n,b,wB(c[((c[c[f>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)|0);c[g>>2]=(c[g>>2]|0)+1;c[g>>2]=(c[g>>2]|0)+1;c[(c[k>>2]|0)+4>>2]=c[g>>2];c[l>>2]=(c[e>>2]|0)+604;m=c[f>>2]|0;c[j>>2]=rC(qC(c[((c[c[f>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)|0)|0;c[h>>2]=0;a:while(1){m=rA(c[j>>2]|0,2,c[h>>2]|0)|0;c[h>>2]=m;if(!m)break;do if(J3(c[(c[h>>2]|0)+8>>2]|0,c[15354]|0)|0){if(!(J3(c[(c[h>>2]|0)+8>>2]|0,c[15355]|0)|0)){m=c[k>>2]|0;KR(m,5,zA(c[f>>2]|0,c[h>>2]|0)|0);break}if(!(J3(c[(c[h>>2]|0)+8>>2]|0,c[15356]|0)|0)){m=c[k>>2]|0;KR(m,6,zA(c[f>>2]|0,c[h>>2]|0)|0);continue a}}else{m=c[k>>2]|0;KR(m,2,zA(c[f>>2]|0,c[h>>2]|0)|0)}while(0);m=c[l>>2]|0;b=c[g>>2]|0;c[g>>2]=b+1;KR(m,b,c[(c[h>>2]|0)+8>>2]|0);b=c[l>>2]|0;m=c[g>>2]|0;c[g>>2]=m+1;KR(b,m,zA(c[f>>2]|0,c[h>>2]|0)|0)}c[(c[l>>2]|0)+4>>2]=c[g>>2];g=c[f>>2]|0;l=qC(c[((c[c[f>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)|0;c[h>>2]=qA(l,2,c[15357]|0,0)|0;if(!(c[h>>2]|0)){l=c[f>>2]|0;g=qC(c[((c[c[f>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)|0;c[h>>2]=qA(g,2,c[15358]|0,0)|0}if(!(c[h>>2]|0)){i=d;return}g=zA(c[f>>2]|0,c[h>>2]|0)|0;h=WJ(g,c[f>>2]|0)|0;c[(c[e>>2]|0)+588>>2]=h;i=d;return}function mS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[l>>2]=oS(c[f>>2]|0,c[g>>2]|0,c[c[h>>2]>>2]|0)|0;c[j>>2]=c[(c[h>>2]|0)+4>>2];while(1){h=c[(c[j>>2]|0)+4>>2]|0;c[k>>2]=h;if(!h)break;c[m>>2]=0;while(1){if(!(c[(c[k>>2]|0)+((c[m>>2]|0)*20|0)+4>>2]|0))break;wF(c[f>>2]|0,c[c[j>>2]>>2]|0,c[(c[k>>2]|0)+((c[m>>2]|0)*20|0)+4>>2]|0,c[(c[k>>2]|0)+((c[m>>2]|0)*20|0)+8>>2]|0,c[l>>2]|0,(c[k>>2]|0)+((c[m>>2]|0)*20|0)|0)|0;c[m>>2]=(c[m>>2]|0)+1}c[j>>2]=(c[j>>2]|0)+8}i=e;return}function nS(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=b;a[e+4>>0]=d;pS(c[f>>2]|0);a[(c[f>>2]|0)+44>>0]=0;qS(c[f>>2]|0)|0;TN(c[f>>2]|0)|0;i=e;return}function oS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=cK(12)|0;if(c[g>>2]|0)k=M3(c[g>>2]|0)|0;else k=0;c[(c[j>>2]|0)+4>>2]=k;k=M3(c[h>>2]|0)|0;c[(c[j>>2]|0)+8>>2]=k;c[c[j>>2]>>2]=c[(c[f>>2]|0)+100>>2];c[(c[f>>2]|0)+100>>2]=c[j>>2];i=e;return c[j>>2]|0}function pS(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=b;if(!(c[(c[e>>2]|0)+32>>2]|0)){i=d;return}c[f>>2]=c[(c[e>>2]|0)+32>>2];while(1){b=c[c[f>>2]>>2]|0;c[g>>2]=b;if(!b)break;if((a[c[g>>2]>>0]|0)==103?(U3(c[g>>2]|0,149112)|0)!=0:0)mS(c[e>>2]|0,0,c[(c[f>>2]|0)+4>>2]|0);c[f>>2]=(c[f>>2]|0)+8}i=d;return}function qS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=yF(c[e>>2]|0,2,149125)|0;if(c[f>>2]|0){c[g>>2]=c[(c[f>>2]|0)+16>>2];c[(c[e>>2]|0)+148>>2]=c[(c[g>>2]|0)+12>>2];c[d>>2]=300;h=c[d>>2]|0;i=b;return h|0}else{c[d>>2]=999;h=c[d>>2]|0;i=b;return h|0}return 0}function rS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[(c[h>>2]|0)+148>>2];if((c[l>>2]|0)!=0?(c[c[l>>2]>>2]|0)!=0:0){a[g>>0]=Ob[c[c[l>>2]>>2]&127](c[j>>2]|0,c[k>>2]|0)|0;m=a[g>>0]|0;i=f;return m|0}a[g>>0]=0;m=a[g>>0]|0;i=f;return m|0}function sS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+128|0;g=f+116|0;h=f+112|0;j=f+108|0;k=f+104|0;l=f+100|0;m=f;n=f+96|0;o=f+92|0;p=f+88|0;q=f+84|0;r=f+80|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;e=c[l>>2]|0;if(!(c[h>>2]|0)){c[g>>2]=e;s=c[g>>2]|0;i=f;return s|0}if(!e){c[l>>2]=P4(1,20)|0;if((c[k>>2]|0)>>>0<=80)c[k>>2]=80;c[(c[l>>2]|0)+4>>2]=c[k>>2]}c[r>>2]=c[c[l>>2]>>2];c[k>>2]=c[(c[l>>2]|0)+4>>2];if(!(c[r>>2]|0)){c[p>>2]=100;c[n>>2]=P4(100,c[k>>2]|0)|0}else{c[n>>2]=c[(c[l>>2]|0)+8>>2];c[p>>2]=(c[r>>2]|0)+100;c[n>>2]=Q4(c[n>>2]|0,_(c[p>>2]|0,c[k>>2]|0)|0)|0;e=(c[n>>2]|0)+(_(c[r>>2]|0,c[k>>2]|0)|0)|0;$4(e|0,0,_((c[p>>2]|0)-(c[r>>2]|0)|0,c[k>>2]|0)|0)|0}while(1){r=xS(m,c[h>>2]|0,c[j>>2]|0,q)|0;c[h>>2]=r;if(!r)break;if((c[c[l>>2]>>2]|0)==(c[p>>2]|0)){c[o>>2]=c[p>>2];c[p>>2]=c[p>>2]<<1;c[n>>2]=Q4(c[n>>2]|0,_(c[p>>2]|0,c[k>>2]|0)|0)|0;r=(c[n>>2]|0)+(_(c[o>>2]|0,c[k>>2]|0)|0)|0;$4(r|0,0,_((c[p>>2]|0)-(c[o>>2]|0)|0,c[k>>2]|0)|0)|0}r=(c[n>>2]|0)+(_(c[c[l>>2]>>2]|0,c[k>>2]|0)|0)|0;e=m;d=r+80|0;do{c[r>>2]=c[e>>2];r=r+4|0;e=e+4|0}while((r|0)<(d|0));e=c[l>>2]|0;c[e>>2]=(c[e>>2]|0)+1}if(c[q>>2]|0){q=(c[l>>2]|0)+16|0;c[q>>2]=c[q>>2]|1}q=c[n>>2]|0;if(c[c[l>>2]>>2]|0){n=Q4(q,_(c[c[l>>2]>>2]|0,c[k>>2]|0)|0)|0;c[(c[l>>2]|0)+8>>2]=n}else{O4(q);O4(c[l>>2]|0);c[l>>2]=0}c[g>>2]=c[l>>2];s=c[g>>2]|0;i=f;return s|0}function tS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=sS(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0)|0;i=e;return d|0}function uS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[h>>2]=c[(c[d>>2]|0)+12>>2];if(!(c[d>>2]|0)){i=b;return}c[g>>2]=c[(c[d>>2]|0)+8>>2];c[e>>2]=0;while(1){j=c[g>>2]|0;if((c[e>>2]|0)>=(c[c[d>>2]>>2]|0))break;c[f>>2]=j+(_(c[e>>2]|0,c[(c[d>>2]|0)+4>>2]|0)|0);if(c[h>>2]|0)Bb[c[h>>2]&127](c[f>>2]|0);yS(c[f>>2]|0);c[e>>2]=(c[e>>2]|0)+1}O4(j);O4(c[d>>2]|0);i=b;return}function vS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[g>>2]=b;c[h>>2]=d;a[j>>0]=a[c[g>>2]>>0]|0;a:do switch(a[j>>0]|0){case 91:{c[f>>2]=zS((c[g>>2]|0)+1|0,c[h>>2]|0)|0;break}case 40:{c[f>>2]=AS((c[g>>2]|0)+1|0,c[h>>2]|0)|0;break}case 47:case 35:{c[c[h>>2]>>2]=0;c[(c[h>>2]|0)+8>>2]=c[g>>2];c[f>>2]=c[g>>2];break}default:if(l1(a[j>>0]|0)|0){c[c[h>>2]>>2]=0;c[(c[h>>2]|0)+8>>2]=c[g>>2];c[f>>2]=c[g>>2];break a}else{c[f>>2]=0;break a}}while(0);i=e;return c[f>>2]|0}function wS(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if((c[c[d>>2]>>2]|0)==1){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+8+32>>2]|0))break;O4(c[(c[(c[d>>2]|0)+8+36>>2]|0)+(c[e>>2]<<3)+4>>2]|0);c[e>>2]=(c[e>>2]|0)+1}O4(c[(c[d>>2]|0)+8+36>>2]|0);i=b;return}if((c[c[d>>2]>>2]|0)!=2){i=b;return}c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+8+48>>2]|0))break;O4(c[(c[(c[d>>2]|0)+8+52>>2]|0)+(c[e>>2]<<3)+4>>2]|0);c[e>>2]=(c[e>>2]|0)+1}O4(c[(c[d>>2]|0)+8+52>>2]|0);i=b;return}function xS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+96|0;h=g+84|0;j=g+80|0;k=g+76|0;l=g+72|0;m=g+68|0;n=g+64|0;o=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[c[m>>2]>>2]=0;do{f=(r1(a[c[k>>2]>>0]|0)|0)!=0;p=c[k>>2]|0;c[k>>2]=p+1}while(f);a:do switch(a[p>>0]|0){case 69:{c[c[j>>2]>>2]=0;c[k>>2]=ES(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[c[l>>2]>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 101:{c[c[j>>2]>>2]=1;c[k>>2]=ES(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[c[l>>2]>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 80:{c[c[j>>2]>>2]=2;c[k>>2]=FS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+4>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 112:{c[c[j>>2]>>2]=3;c[k>>2]=FS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+4>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 98:{c[c[j>>2]>>2]=4;c[k>>2]=FS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+8>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 66:{c[c[j>>2]>>2]=5;c[k>>2]=FS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+8>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 99:{c[k>>2]=DS(c[k>>2]|0,n)|0;if(!(c[k>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[n>>2]=vS(c[n>>2]|0,o)|0;if(!(c[n>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}f=c[j>>2]|0;if(!(c[o>>2]|0)){c[f>>2]=9;c[(c[j>>2]|0)+8>>2]=c[o+8>>2];if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+24>>2];break a}else{c[f>>2]=14;r=(c[j>>2]|0)+8|0;s=o;t=r+64|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+40>>2];break a}break}case 67:{c[k>>2]=DS(c[k>>2]|0,n)|0;if(!(c[k>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[n>>2]=vS(c[n>>2]|0,o)|0;if(!(c[n>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}f=c[j>>2]|0;if(!(c[o>>2]|0)){c[f>>2]=8;c[(c[j>>2]|0)+8>>2]=c[o+8>>2];if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+20>>2];break a}else{c[f>>2]=13;r=(c[j>>2]|0)+8|0;s=o;t=r+64|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+40>>2];break a}break}case 76:{c[c[j>>2]>>2]=6;c[k>>2]=FS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+12>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 84:{c[c[j>>2]>>2]=7;c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(!(c[k>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+8|0)|0;if(!(c[k>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[k>>2]=GS(c[k>>2]|0,(c[j>>2]|0)+8+16|0)|0;if(!(c[k>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+24|0)|0;if(!(c[k>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[k>>2]=DS(c[k>>2]|0,(c[j>>2]|0)+8+32|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+16>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 70:{c[c[j>>2]>>2]=10;c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(!(c[k>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[k>>2]=DS(c[k>>2]|0,(c[j>>2]|0)+8+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+28>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 83:{c[c[j>>2]>>2]=11;c[k>>2]=DS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+32>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 73:{c[c[j>>2]>>2]=12;c[k>>2]=ES(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(!(c[k>>2]|0)){c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[k>>2]=DS(c[k>>2]|0,(c[j>>2]|0)+8+32|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+36>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 116:{c[c[j>>2]>>2]=15;c[k>>2]=HS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(c[k>>2]|0){if(!(c[l>>2]|0))break a;c[(c[j>>2]|0)+72>>2]=c[(c[l>>2]|0)+44>>2];break a}else{c[c[m>>2]>>2]=1;c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}break}case 0:{c[k>>2]=0;break}default:{c[c[m>>2]>>2]=1;c[k>>2]=0}}while(0);c[h>>2]=c[k>>2];q=c[h>>2]|0;i=g;return q|0}function yS(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;switch(c[c[d>>2]>>2]|0){case 3:case 2:{O4(c[(c[d>>2]|0)+8+4>>2]|0);break}case 5:case 4:{O4(c[(c[d>>2]|0)+8+4>>2]|0);break}case 6:{O4(c[(c[d>>2]|0)+8+4>>2]|0);break}case 7:{O4(c[(c[d>>2]|0)+8+32>>2]|0);break}case 9:case 8:{O4(c[(c[d>>2]|0)+8>>2]|0);break}case 14:case 13:{wS((c[d>>2]|0)+8|0);break}case 10:{O4(c[(c[d>>2]|0)+8+8>>2]|0);break}case 11:{O4(c[(c[d>>2]|0)+8>>2]|0);break}case 12:{O4(c[(c[d>>2]|0)+8+32>>2]|0);break}default:{}}i=b;return}function zS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d;n=d+8|0;c[f>>2]=a;c[j>>2]=b;c[k>>2]=c[f>>2];c[n>>2]=0;c[c[j>>2]>>2]=1;c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+8|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+16|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+24|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=CS(c[k>>2]|0,(c[j>>2]|0)+8+32|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[n>>2]=P4(c[(c[j>>2]|0)+8+32>>2]|0,8)|0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[j>>2]|0)+8+32>>2]|0)){p=18;break}c[k>>2]=BS(c[k>>2]|0,m)|0;if(!(c[k>>2]|0)){p=14;break}g[(c[n>>2]|0)+(c[l>>2]<<3)>>2]=+h[m>>3];c[k>>2]=DS(c[k>>2]|0,(c[n>>2]|0)+(c[l>>2]<<3)+4|0)|0;if(!(c[k>>2]|0)){p=16;break}c[l>>2]=(c[l>>2]|0)+1}if((p|0)==14){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}else if((p|0)==16){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}else if((p|0)==18){c[(c[j>>2]|0)+8+36>>2]=c[n>>2];c[e>>2]=c[f>>2];o=c[e>>2]|0;i=d;return o|0}return 0}function AS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d;n=d+8|0;c[f>>2]=a;c[j>>2]=b;c[k>>2]=c[f>>2];c[n>>2]=0;c[c[j>>2]>>2]=2;c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+8|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+16|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+24|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+32|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=BS(c[k>>2]|0,(c[j>>2]|0)+8+40|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[k>>2]=CS(c[k>>2]|0,(c[j>>2]|0)+8+48|0)|0;if(!(c[k>>2]|0)){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[n>>2]=P4(c[(c[j>>2]|0)+8+48>>2]|0,8)|0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[j>>2]|0)+8+48>>2]|0)){p=22;break}c[k>>2]=BS(c[k>>2]|0,m)|0;if(!(c[k>>2]|0)){p=18;break}g[(c[n>>2]|0)+(c[l>>2]<<3)>>2]=+h[m>>3];c[k>>2]=DS(c[k>>2]|0,(c[n>>2]|0)+(c[l>>2]<<3)+4|0)|0;if(!(c[k>>2]|0)){p=20;break}c[l>>2]=(c[l>>2]|0)+1}if((p|0)==18){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}else if((p|0)==20){O4(c[n>>2]|0);c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}else if((p|0)==22){c[(c[j>>2]|0)+8+52>>2]=c[n>>2];c[e>>2]=c[f>>2];o=c[e>>2]|0;i=d;return o|0}return 0}function BS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;j=d+8|0;k=d;c[f>>2]=a;c[g>>2]=b;h[k>>3]=+x3(c[f>>2]|0,j);if((c[j>>2]|0)==(c[f>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{h[c[g>>2]>>3]=+h[k>>3];c[e>>2]=c[j>>2];l=c[e>>2]|0;i=d;return l|0}return 0}function CS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;b=z3(c[f>>2]|0,h,10)|0;c[c[g>>2]>>2]=b;if((c[f>>2]|0)==(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function DS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=b;c[h>>2]=d;c[g>>2]=CS(c[g>>2]|0,j)|0;if((c[g>>2]|0)==0|(c[j>>2]|0)<=0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}while(1){if(a[c[g>>2]>>0]|0)n=(a[c[g>>2]>>0]|0)!=45;else n=0;o=c[g>>2]|0;if(!n)break;c[g>>2]=o+1}if(!(a[o>>0]|0)){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[g>>2]=(c[g>>2]|0)+1;c[k>>2]=P4((c[j>>2]|0)+1|0,1)|0;c[l>>2]=c[k>>2];while(1){if((c[j>>2]|0)<=0)break;if(!(a[c[g>>2]>>0]|0))break;o=c[g>>2]|0;c[g>>2]=o+1;n=a[o>>0]|0;o=c[l>>2]|0;c[l>>2]=o+1;a[o>>0]=n;c[j>>2]=(c[j>>2]|0)+-1}if((c[j>>2]|0)>0){O4(c[k>>2]|0);c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else{a[c[l>>2]>>0]=0;c[c[h>>2]>>2]=c[k>>2];c[f>>2]=c[g>>2];m=c[f>>2]|0;i=e;return m|0}return 0}function ES(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;k=+x3(c[f>>2]|0,j);h[c[g>>2]>>3]=k;if((c[f>>2]|0)==(c[j>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[f>>2]=c[j>>2];k=+x3(c[f>>2]|0,j);h[(c[g>>2]|0)+8>>3]=k;if((c[f>>2]|0)==(c[j>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[f>>2]=c[j>>2];k=+x3(c[f>>2]|0,j);h[(c[g>>2]|0)+16>>3]=k;if((c[f>>2]|0)==(c[j>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[f>>2]=c[j>>2];k=+x3(c[f>>2]|0,j);h[(c[g>>2]|0)+24>>3]=k;if((c[f>>2]|0)==(c[j>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{c[f>>2]=c[j>>2];c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}return 0}function FS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[f>>2]=CS(c[f>>2]|0,j)|0;if(!(c[f>>2]|0)){c[e>>2]=c[f>>2];n=c[e>>2]|0;i=d;return n|0}b=P4(c[j>>2]|0,24)|0;c[l>>2]=b;c[k>>2]=b;c[c[g>>2]>>2]=c[j>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[c[g>>2]>>2]|0)){o=10;break}p=+x3(c[f>>2]|0,m);h[c[l>>2]>>3]=p;if((c[f>>2]|0)==(c[m>>2]|0)){o=6;break}c[f>>2]=c[m>>2];p=+x3(c[f>>2]|0,m);h[(c[l>>2]|0)+8>>3]=p;if((c[f>>2]|0)==(c[m>>2]|0)){o=8;break}c[f>>2]=c[m>>2];h[(c[l>>2]|0)+16>>3]=0.0;c[l>>2]=(c[l>>2]|0)+24;c[j>>2]=(c[j>>2]|0)+1}if((o|0)==6){O4(c[k>>2]|0);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}else if((o|0)==8){O4(c[k>>2]|0);c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}else if((o|0)==10){c[(c[g>>2]|0)+4>>2]=c[k>>2];c[e>>2]=c[f>>2];n=c[e>>2]|0;i=d;return n|0}return 0}function GS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[e>>2]=CS(c[e>>2]|0,g)|0;do if((c[g>>2]|0)>=0){b=c[f>>2]|0;if((c[g>>2]|0)>0){c[b>>2]=2;break}else{c[b>>2]=1;break}}else c[c[f>>2]>>2]=0;while(0);i=d;return c[e>>2]|0}function HS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;b=y3(c[f>>2]|0,h,10)|0;c[c[g>>2]>>2]=b;if((c[f>>2]|0)==(c[h>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function IS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b;c[d>>2]=a;h[e>>3]=+h[(c[(c[d>>2]|0)+16>>2]|0)+16>>3];h[f>>3]=+h[(c[(c[d>>2]|0)+16>>2]|0)+16+8>>3];d=(KS(~~(+h[e>>3]>+h[f>>3]?+h[e>>3]:+h[f>>3])>>>0)|0)+1|0;i=b;return d|0}function JS(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+112|0;l=k+96|0;m=k+92|0;n=k+88|0;o=k+84|0;p=k+80|0;q=k+76|0;r=k+72|0;s=k+68|0;t=k+32|0;u=k+64|0;v=k;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=j;c[u>>2]=LS(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;p=MS(c[u>>2]|0)|0;c[r>>2]=p;if((p|0)<0){c[l>>2]=c[r>>2];w=c[l>>2]|0;i=k;return w|0}c[r>>2]=0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;do if(c[(c[m>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0){NS(v,c[u>>2]|0,(c[m>>2]|0)+((c[s>>2]|0)*40|0)|0);c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[t+12>>2]=c[v+12>>2];c[t+16>>2]=c[v+16>>2];c[t+20>>2]=c[v+20>>2];c[t+24>>2]=c[v+24>>2];c[t+28>>2]=c[v+28>>2];if(!(c[t>>2]|0)){a[(c[(c[m>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0)+36>>0]=1;break}if(+h[t+8>>3]==0.0){h[(c[(c[m>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0)+16>>3]=+h[t+16>>3];h[(c[(c[m>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0)+16+8>>3]=+h[t+16+8>>3];a[(c[(c[m>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0)+36>>0]=1;break}if((d[(c[q>>2]|0)+32>>0]|0|0)==1){h[(c[(c[m>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0)+16>>3]=+h[t+16>>3];h[(c[(c[m>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0)+16+8>>3]=+h[t+16+8>>3];a[(c[(c[m>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0)+36>>0]=1;break}else{c[r>>2]=1;break}}while(0);c[s>>2]=(c[s>>2]|0)+1}OS(c[u>>2]|0);c[l>>2]=c[r>>2];w=c[l>>2]|0;i=k;return w|0}function KS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;if(!(c[e>>2]|0)){c[d>>2]=-1;g=c[d>>2]|0;i=b;return g|0}if((c[e>>2]|0)>>>0>=65536){c[e>>2]=(c[e>>2]|0)>>>16;c[f>>2]=(c[f>>2]|0)+16}if((c[e>>2]|0)>>>0>=256){c[e>>2]=(c[e>>2]|0)>>>8;c[f>>2]=(c[f>>2]|0)+8}if((c[e>>2]|0)>>>0>=16){c[e>>2]=(c[e>>2]|0)>>>4;c[f>>2]=(c[f>>2]|0)+4}if((c[e>>2]|0)>>>0>=4){c[e>>2]=(c[e>>2]|0)>>>2;c[f>>2]=(c[f>>2]|0)+2}if((c[e>>2]|0)>>>0>=2)c[f>>2]=(c[f>>2]|0)+1;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function LS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+8|0;j=g;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=bK(28)|0;f=Nz(61452,c[12990]|0)|0;c[(c[q>>2]|0)+20>>2]=f;do if(f){e=vV()|0;c[(c[q>>2]|0)+24>>2]=e;if(!e){Y2(c[24742]|0,149343,h)|0;break}c[c[q>>2]>>2]=c[l>>2];c[(c[q>>2]|0)+4>>2]=c[m>>2];c[(c[q>>2]|0)+8>>2]=c[n>>2];c[(c[q>>2]|0)+12>>2]=c[o>>2];c[(c[q>>2]|0)+16>>2]=c[p>>2];c[k>>2]=c[q>>2];r=c[k>>2]|0;i=g;return r|0}else Y2(c[24742]|0,149343,j)|0;while(0);if(c[(c[q>>2]|0)+20>>2]|0)Jz(c[(c[q>>2]|0)+20>>2]|0)|0;if(c[(c[q>>2]|0)+24>>2]|0)xV(c[(c[q>>2]|0)+24>>2]|0)|0;O4(c[q>>2]|0);c[k>>2]=0;r=c[k>>2]|0;i=g;return r|0}function MS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=0;a=YS(c[e>>2]|0)|0;c[f>>2]=a;if((a|0)<0){c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}a=ZS(c[e>>2]|0)|0;c[f>>2]=a;if((a|0)<0){c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}else{_S(c[e>>2]|0);c[d>>2]=Jz(c[(c[e>>2]|0)+20>>2]|0)|0;g=c[d>>2]|0;i=b;return g|0}return 0}function NS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+512|0;f=e+508|0;g=e+504|0;j=e+500|0;k=e+456|0;l=e+448|0;m=e+464|0;n=e+416|0;o=e+384|0;p=e+352|0;q=e+320|0;r=e+288|0;s=e+256|0;t=e+224|0;u=e+192|0;v=e+160|0;w=e+128|0;x=e+96|0;y=e+64|0;z=e+32|0;A=e;c[f>>2]=b;c[g>>2]=d;c[j>>2]=c[(c[g>>2]|0)+32>>2];h[k>>3]=(+h[c[j>>2]>>3]*2.0+ +h[(c[g>>2]|0)+16>>3])/8.0;h[l>>3]=(+h[(c[j>>2]|0)+8>>3]*2.0+ +h[(c[g>>2]|0)+16+8>>3])/2.0;if(!(c[(c[g>>2]|0)+32>>2]|0))La(149136,149146,445,149156);d=m;b=d+36|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(b|0));h[(c[j>>2]|0)+16>>3]=+h[c[g>>2]>>3]-+h[c[j>>2]>>3];h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]+ +h[(c[g>>2]|0)+16+8>>3];QS(p,c[f>>2]|0,c[g>>2]|0,m);c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];c[n+16>>2]=c[p+16>>2];c[n+20>>2]=c[p+20>>2];c[n+24>>2]=c[p+24>>2];c[n+28>>2]=c[p+28>>2];if(!(c[n>>2]|0)){c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];c[a+16>>2]=c[n+16>>2];c[a+20>>2]=c[n+20>>2];c[a+24>>2]=c[n+24>>2];c[a+28>>2]=c[n+28>>2];i=e;return}h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3];QS(q,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[q>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[o+12>>2]=c[q+12>>2];c[o+16>>2]=c[q+16>>2];c[o+20>>2]=c[q+20>>2];c[o+24>>2]=c[q+24>>2];c[o+28>>2]=c[q+28>>2];if(!(c[o>>2]|0)){c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3];QS(r,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[r>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2];c[o+16>>2]=c[r+16>>2];c[o+20>>2]=c[r+20>>2];c[o+24>>2]=c[r+24>>2];c[o+28>>2]=c[r+28>>2];if(!(c[o>>2]|0)){c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}h[(c[j>>2]|0)+16>>3]=+h[c[g>>2]>>3];h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]+ +h[(c[g>>2]|0)+16+8>>3];QS(s,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[s>>2];c[o+4>>2]=c[s+4>>2];c[o+8>>2]=c[s+8>>2];c[o+12>>2]=c[s+12>>2];c[o+16>>2]=c[s+16>>2];c[o+20>>2]=c[s+20>>2];c[o+24>>2]=c[s+24>>2];c[o+28>>2]=c[s+28>>2];if(!(c[o>>2]|0)){c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3];QS(t,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[t>>2];c[o+4>>2]=c[t+4>>2];c[o+8>>2]=c[t+8>>2];c[o+12>>2]=c[t+12>>2];c[o+16>>2]=c[t+16>>2];c[o+20>>2]=c[t+20>>2];c[o+24>>2]=c[t+24>>2];c[o+28>>2]=c[t+28>>2];if(!(c[o>>2]|0)){c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}h[(c[j>>2]|0)+16>>3]=+h[c[g>>2]>>3]+ +h[(c[g>>2]|0)+16>>3];h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]+ +h[(c[g>>2]|0)+16+8>>3];QS(u,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[u>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];if(!(c[o>>2]|0)){c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3];QS(v,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[v>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];c[o+16>>2]=c[v+16>>2];c[o+20>>2]=c[v+20>>2];c[o+24>>2]=c[v+24>>2];c[o+28>>2]=c[v+28>>2];if(!(c[o>>2]|0)){c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3];QS(w,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[o+16>>2]=c[w+16>>2];c[o+20>>2]=c[w+20>>2];c[o+24>>2]=c[w+24>>2];c[o+28>>2]=c[w+28>>2];if(!(c[o>>2]|0)){c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}do if(((c[m+24>>2]|0)==0?(c[m+28>>2]|0)==0:0)?(c[m+32>>2]|0)==0:0){if(c[m+12>>2]|0){B=38;break}if(c[m>>2]|0)B=38}else B=38;while(0);a:do if((B|0)==38){b:do if(!(c[m+28>>2]|0)){if(c[m+32>>2]|0)break;h[(c[j>>2]|0)+16>>3]=+h[c[g>>2]>>3]-+h[c[j>>2]>>3];h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]+ +h[(c[g>>2]|0)+16+8>>3];while(1){if(!(+h[(c[j>>2]|0)+16>>3]<=+h[c[g>>2]>>3]+ +h[(c[g>>2]|0)+16>>3]))break b;QS(x,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[x>>2];c[o+4>>2]=c[x+4>>2];c[o+8>>2]=c[x+8>>2];c[o+12>>2]=c[x+12>>2];c[o+16>>2]=c[x+16>>2];c[o+20>>2]=c[x+20>>2];c[o+24>>2]=c[x+24>>2];c[o+28>>2]=c[x+28>>2];if(!(c[o>>2]|0))break;if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}w=(c[j>>2]|0)+16|0;h[w>>3]=+h[w>>3]+ +h[k>>3]}c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}while(0);if(!(c[m+12>>2]|0)){if(c[m>>2]|0)break;h[(c[j>>2]|0)+16>>3]=+h[c[g>>2]>>3]-+h[c[j>>2]>>3];h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]+ +h[(c[g>>2]|0)+16+8>>3];while(1){if(!(+h[(c[j>>2]|0)+16+8>>3]>=+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3]))break a;QS(y,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[y>>2];c[o+4>>2]=c[y+4>>2];c[o+8>>2]=c[y+8>>2];c[o+12>>2]=c[y+12>>2];c[o+16>>2]=c[y+16>>2];c[o+20>>2]=c[y+20>>2];c[o+24>>2]=c[y+24>>2];c[o+28>>2]=c[y+28>>2];if(!(c[o>>2]|0))break;if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}w=(c[j>>2]|0)+16+8|0;h[w>>3]=+h[w>>3]-+h[l>>3]}c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}}while(0);h[(c[j>>2]|0)+16>>3]=+h[c[g>>2]>>3]+ +h[(c[g>>2]|0)+16>>3];h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3];do if((c[m+8>>2]|0)==0?(c[m+4>>2]|0)==0:0){if(c[m>>2]|0){B=61;break}if(c[m+20>>2]|0){B=61;break}if(c[m+32>>2]|0)B=61}else B=61;while(0);c:do if((B|0)==61){d:do if(!(c[m+4>>2]|0)){if(c[m>>2]|0)break;h[(c[j>>2]|0)+16>>3]=+h[c[g>>2]>>3]+ +h[(c[g>>2]|0)+16>>3];h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3];while(1){if(!(+h[(c[j>>2]|0)+16>>3]>=+h[c[g>>2]>>3]-+h[c[j>>2]>>3]))break d;QS(z,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[z>>2];c[o+4>>2]=c[z+4>>2];c[o+8>>2]=c[z+8>>2];c[o+12>>2]=c[z+12>>2];c[o+16>>2]=c[z+16>>2];c[o+20>>2]=c[z+20>>2];c[o+24>>2]=c[z+24>>2];c[o+28>>2]=c[z+28>>2];if(!(c[o>>2]|0))break;if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}y=(c[j>>2]|0)+16|0;h[y>>3]=+h[y>>3]-+h[k>>3]}c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}while(0);if(c[m+20>>2]|0)break;if(c[m+32>>2]|0)break;h[(c[j>>2]|0)+16>>3]=+h[c[g>>2]>>3]+ +h[(c[g>>2]|0)+16>>3];h[(c[j>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3];while(1){if(!(+h[(c[j>>2]|0)+16+8>>3]<=+h[(c[g>>2]|0)+8>>3]+ +h[(c[g>>2]|0)+16+8>>3]))break c;QS(A,c[f>>2]|0,c[g>>2]|0,m);c[o>>2]=c[A>>2];c[o+4>>2]=c[A+4>>2];c[o+8>>2]=c[A+8>>2];c[o+12>>2]=c[A+12>>2];c[o+16>>2]=c[A+16>>2];c[o+20>>2]=c[A+20>>2];c[o+24>>2]=c[A+24>>2];c[o+28>>2]=c[A+28>>2];if(!(c[o>>2]|0))break;if(+h[o+8>>3]<+h[n+8>>3]){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2]}y=(c[j>>2]|0)+16+8|0;h[y>>3]=+h[y>>3]+ +h[l>>3]}c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];i=e;return}while(0);c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];c[a+16>>2]=c[n+16>>2];c[a+20>>2]=c[n+20>>2];c[a+24>>2]=c[n+24>>2];c[a+28>>2]=c[n+28>>2];i=e;return}function OS(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;xV(c[(c[d>>2]|0)+24>>2]|0)|0;O4(c[d>>2]|0);i=b;return}function PS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+4|0;k=f;c[f+20>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f+8>>2]=e;c[j>>2]=c[c[g>>2]>>2];c[k>>2]=c[c[h>>2]>>2];i=f;return (c[j>>2]|0)-(c[k>>2]|0)|0}function QS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g+108|0;k=g+104|0;l=g+100|0;m=g+96|0;n=g+92|0;o=g+88|0;p=g+72|0;q=g+56|0;r=g+16|0;s=g+8|0;t=g;u=g+48|0;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;if(!(c[(c[k>>2]|0)+32>>2]|0))La(149136,149146,382,149165);c[r>>2]=0;h[r+8>>3]=0.0;f=r+16|0;e=(c[(c[k>>2]|0)+32>>2]|0)+16|0;c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[m>>2]=0;while(1){v=c[k>>2]|0;if((c[m>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break;do if((v|0)!=((c[c[j>>2]>>2]|0)+((c[m>>2]|0)*40|0)|0)){if(+h[(c[c[j>>2]>>2]|0)+((c[m>>2]|0)*40|0)+16>>3]>0.0?+h[(c[c[j>>2]>>2]|0)+((c[m>>2]|0)*40|0)+16+8>>3]>0.0:0)break;if(RS(c[k>>2]|0,(c[c[j>>2]>>2]|0)+((c[m>>2]|0)*40|0)|0)|0)c[r>>2]=(c[r>>2]|0)+1}while(0);c[m>>2]=(c[m>>2]|0)+1}SS(v,p);c[o>>2]=yV(c[(c[j>>2]|0)+24>>2]|0,c[c[(c[j>>2]|0)+24>>2]>>2]|0,p)|0;if(!(c[o>>2]|0)){c[b>>2]=c[r>>2];c[b+4>>2]=c[r+4>>2];c[b+8>>2]=c[r+8>>2];c[b+12>>2]=c[r+12>>2];c[b+16>>2]=c[r+16>>2];c[b+20>>2]=c[r+20>>2];c[b+24>>2]=c[r+24>>2];c[b+28>>2]=c[r+28>>2];i=g;return}c[n>>2]=c[o>>2];while(1){if(!(c[n>>2]|0))break;c[u>>2]=c[(c[(c[n>>2]|0)+4>>2]|0)+16>>2];if((c[u>>2]|0)!=(c[k>>2]|0)){TS(c[u>>2]|0,q);h[s>>3]=+US(p,q);if(+h[s>>3]>0.0){h[t>>3]=+VS(c[j>>2]|0,c[k>>2]|0,c[u>>2]|0,p,+h[s>>3],c[l>>2]|0);c[r>>2]=(c[r>>2]|0)+1;v=r+8|0;h[v>>3]=+h[v>>3]+ +h[t>>3]}if(((c[(c[u>>2]|0)+32>>2]|0)!=0?(a[(c[(c[u>>2]|0)+32>>2]|0)+36>>0]|0)!=0:0)?(SS(c[u>>2]|0,q),h[s>>3]=+US(p,q),+h[s>>3]>0.0):0){h[t>>3]=+WS(c[j>>2]|0,c[k>>2]|0,c[u>>2]|0,p,+h[s>>3],c[l>>2]|0);c[r>>2]=(c[r>>2]|0)+1;v=r+8|0;h[v>>3]=+h[v>>3]+ +h[t>>3]}}c[n>>2]=c[c[n>>2]>>2]}uV(c[o>>2]|0);c[b>>2]=c[r>>2];c[b+4>>2]=c[r+4>>2];c[b+8>>2]=c[r+8>>2];c[b+12>>2]=c[r+12>>2];c[b+16>>2]=c[r+16>>2];c[b+20>>2]=c[r+20>>2];c[b+24>>2]=c[r+24>>2];c[b+28>>2]=c[r+28>>2];i=g;return}function RS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[f>>2]|0)+32>>2];if(!(+h[(c[g>>2]|0)+16>>3]==0.0))La(149202,149146,219,149239);if(!(+h[(c[g>>2]|0)+16+8>>3]==0.0))La(149202,149146,219,149239);if(!(c[j>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if((+h[c[g>>2]>>3]>+h[(c[j>>2]|0)+16>>3]?+h[c[g>>2]>>3]<+h[(c[j>>2]|0)+16>>3]+ +h[c[j>>2]>>3]:0)?+h[(c[g>>2]|0)+8>>3]>+h[(c[j>>2]|0)+16+8>>3]:0)l=+h[(c[g>>2]|0)+8>>3]<+h[(c[j>>2]|0)+16+8>>3]+ +h[(c[j>>2]|0)+8>>3];else l=0;c[e>>2]=l&1;k=c[e>>2]|0;i=d;return k|0}function SS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[e>>2]|0)+32>>2];c[c[f>>2]>>2]=~~+h[(c[g>>2]|0)+16>>3];c[(c[f>>2]|0)+4>>2]=~~+h[(c[g>>2]|0)+16+8>>3];c[(c[f>>2]|0)+8>>2]=~~(+h[(c[g>>2]|0)+16>>3]+ +h[c[g>>2]>>3]);c[(c[f>>2]|0)+12>>2]=~~(+h[(c[g>>2]|0)+16+8>>3]+ +h[(c[g>>2]|0)+8>>3]);i=d;return}function TS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[f>>2]>>2]=~~+h[c[e>>2]>>3];c[(c[f>>2]|0)+4>>2]=~~+h[(c[e>>2]|0)+8>>3];c[(c[f>>2]|0)+8>>2]=~~(+h[c[e>>2]>>3]+ +h[(c[e>>2]|0)+16>>3]);c[(c[f>>2]|0)+12>>2]=~~(+h[(c[e>>2]|0)+8>>3]+ +h[(c[e>>2]|0)+16+8>>3]);i=d;return}function US(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;d=i;i=i+48|0;e=d+32|0;f=d+44|0;g=d+40|0;j=d+24|0;k=d+16|0;l=d+8|0;m=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+8>>2]|0)>=(c[c[g>>2]>>2]|0)?(c[c[f>>2]>>2]|0)<=(c[(c[g>>2]|0)+8>>2]|0):0){if((c[(c[f>>2]|0)+12>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[f>>2]|0)+4>>2]|0)<=(c[(c[g>>2]|0)+12>>2]|0):0){if((c[c[f>>2]>>2]|0)>(c[c[g>>2]>>2]|0))n=c[c[f>>2]>>2]|0;else n=c[c[g>>2]>>2]|0;h[j>>3]=+(n|0);if((c[(c[f>>2]|0)+4>>2]|0)>(c[(c[g>>2]|0)+4>>2]|0))o=c[(c[f>>2]|0)+4>>2]|0;else o=c[(c[g>>2]|0)+4>>2]|0;h[k>>3]=+(o|0);if((c[(c[f>>2]|0)+8>>2]|0)<(c[(c[g>>2]|0)+8>>2]|0))p=c[(c[f>>2]|0)+8>>2]|0;else p=c[(c[g>>2]|0)+8>>2]|0;h[l>>3]=+(p|0);if((c[(c[f>>2]|0)+12>>2]|0)<(c[(c[g>>2]|0)+12>>2]|0))q=c[(c[f>>2]|0)+12>>2]|0;else q=c[(c[g>>2]|0)+12>>2]|0;h[m>>3]=+(q|0);h[e>>3]=(+h[l>>3]-+h[j>>3])*(+h[m>>3]-+h[k>>3]);r=+h[e>>3];i=d;return +r}h[e>>3]=0.0;r=+h[e>>3];i=d;return +r}h[e>>3]=0.0;r=+h[e>>3];i=d;return +r}function VS(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;j=i;i=i+80|0;k=j+24|0;l=j+68|0;m=j+64|0;n=j+60|0;o=j+56|0;p=j+16|0;q=j+52|0;r=j+48|0;s=j+8|0;t=j;u=j+32|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;h[p>>3]=f;c[q>>2]=g;g=XS(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;c[r>>2]=g;c[r>>2]=(c[r>>2]|0)<0?5:g;if(!(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)){c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=c[n>>2];h[k>>3]=+h[p>>3];v=+h[k>>3];i=j;return +v}h[t>>3]=0.0;TS(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0,u);h[s>>3]=+US(c[o>>2]|0,u);if(+h[s>>3]>+h[p>>3])h[t>>3]=+h[s>>3];if((c[(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)+32>>2]|0)!=0?(SS(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0,u),h[s>>3]=+US(c[o>>2]|0,u),+h[s>>3]>+h[p>>3]):0)h[t>>3]=+h[s>>3]>+h[t>>3]?+h[s>>3]:+h[t>>3];if(+h[t>>3]>0.0){h[k>>3]=+h[t>>3];v=+h[k>>3];i=j;return +v}else{c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=c[n>>2];h[k>>3]=+h[p>>3];v=+h[k>>3];i=j;return +v}return +(0.0)}function WS(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;j=i;i=i+80|0;k=j+24|0;l=j+68|0;m=j+64|0;n=j+60|0;o=j+56|0;p=j+16|0;q=j+52|0;r=j+48|0;s=j+8|0;t=j;u=j+32|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;h[p>>3]=f;c[q>>2]=g;g=XS(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;c[r>>2]=g;c[r>>2]=(c[r>>2]|0)<0?5:g;if(!(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)){c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=c[n>>2];h[k>>3]=+h[p>>3];v=+h[k>>3];i=j;return +v}h[t>>3]=0.0;TS(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0,u);h[s>>3]=+US(c[o>>2]|0,u);if(+h[s>>3]>+h[p>>3])h[t>>3]=+h[s>>3];if((c[(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)+32>>2]|0)!=0?(SS(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0,u),h[s>>3]=+US(c[o>>2]|0,u),+h[s>>3]>+h[p>>3]):0)h[t>>3]=+h[s>>3]>+h[t>>3]?+h[s>>3]:+h[t>>3];if(+h[t>>3]>0.0){h[k>>3]=+h[t>>3];v=+h[k>>3];i=j;return +v}else{c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=c[n>>2];h[k>>3]=+h[p>>3];v=+h[k>>3];i=j;return +v}return +(0.0)}function XS(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+24|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[f+20>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=-1;c[m>>2]=c[(c[j>>2]|0)+32>>2];c[n>>2]=c[(c[k>>2]|0)+32>>2];if((c[m>>2]|0)==(c[n>>2]|0))La(149181,149146,276,149191);if((d[(c[m>>2]|0)+36>>0]|0|0)!=0?(d[(c[n>>2]|0)+36>>0]|0|0)!=0:0){if(!(+h[c[j>>2]>>3]==0.0?+h[(c[j>>2]|0)+8>>3]==0.0:0))o=8;do if((o|0)==8){if(+h[c[k>>2]>>3]==0.0?+h[(c[k>>2]|0)+8>>3]==0.0:0)break;n=c[k>>2]|0;do if(+h[(c[k>>2]|0)+8>>3]<+h[(c[j>>2]|0)+8>>3]){if(+h[n>>3]<+h[c[j>>2]>>3]){c[l>>2]=0;break}if(+h[c[k>>2]>>3]>+h[c[j>>2]>>3]){c[l>>2]=2;break}else{c[l>>2]=1;break}}else{m=+h[c[k>>2]>>3]<+h[c[j>>2]>>3];if(!(+h[n+8>>3]>+h[(c[j>>2]|0)+8>>3])){if(m){c[l>>2]=3;break}if(!(+h[c[k>>2]>>3]>+h[c[j>>2]>>3]))break;c[l>>2]=5;break}if(m){c[l>>2]=6;break}if(+h[c[k>>2]>>3]>+h[c[j>>2]>>3]){c[l>>2]=8;break}else{c[l>>2]=7;break}}while(0);c[g>>2]=c[l>>2];p=c[g>>2]|0;i=f;return p|0}while(0);c[g>>2]=c[l>>2];p=c[g>>2]|0;i=f;return p|0}c[g>>2]=c[l>>2];p=c[g>>2]|0;i=f;return p|0}function YS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+64|0;d=b+48|0;e=b+40|0;f=b+36|0;g=b+32|0;h=b+28|0;j=b+24|0;k=b+16|0;l=b;c[f>>2]=a;c[h>>2]=IS(c[f>>2]|0)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0)){m=6;break}c[j>>2]=bK(32)|0;c[(c[j>>2]|0)+12+16>>2]=(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*40|0);a=(c[j>>2]|0)+12|0;$S(l,c[f>>2]|0,(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*40|0)|0);c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];c[k>>2]=(c[(c[j>>2]|0)+12>>2]|0)+(((c[(c[j>>2]|0)+12+8>>2]|0)-(c[(c[j>>2]|0)+12>>2]|0)|0)/2|0);c[k+4>>2]=(c[(c[j>>2]|0)+12+4>>2]|0)+(((c[(c[j>>2]|0)+12+12>>2]|0)-(c[(c[j>>2]|0)+12+4>>2]|0)|0)/2|0);a=c[h>>2]|0;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];n=aT(d,a)|0;c[(c[j>>2]|0)+8>>2]=n;if(!(Hb[c[c[(c[f>>2]|0)+20>>2]>>2]&63](c[(c[f>>2]|0)+20>>2]|0,c[j>>2]|0,1)|0)){m=4;break}c[g>>2]=(c[g>>2]|0)+1}if((m|0)==4){c[e>>2]=-1;o=c[e>>2]|0;i=b;return o|0}else if((m|0)==6){c[e>>2]=0;o=c[e>>2]|0;i=b;return o|0}return 0}function ZS(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;c[e>>2]=Hb[c[c[(c[d>>2]|0)+20>>2]>>2]&63](c[(c[d>>2]|0)+20>>2]|0,0,128)|0;while(1){if(!(c[e>>2]|0))break;zV(c[(c[d>>2]|0)+24>>2]|0,(c[e>>2]|0)+12|0,c[(c[e>>2]|0)+12+16>>2]|0,c[(c[d>>2]|0)+24>>2]|0,0)|0;c[e>>2]=Hb[c[c[(c[d>>2]|0)+20>>2]>>2]&63](c[(c[d>>2]|0)+20>>2]|0,c[e>>2]|0,8)|0}i=b;return 0}function _S(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=Pz(c[(c[d>>2]|0)+20>>2]|0)|0;c[f>>2]=0;while(1){if(!(Pz(c[(c[d>>2]|0)+20>>2]|0)|0))break;do if(c[(c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]|0)+4>>2]|0){a=c[(c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]|0)+4>>2]|0;if((c[(c[(c[(c[d>>2]|0)+20>>2]|0)+4>>2]|0)+8>>2]|0)<0){h=c[a+8>>2]|0;break}else{h=a+(0-(c[(c[(c[(c[d>>2]|0)+20>>2]|0)+4>>2]|0)+8>>2]|0))|0;break}}else h=0;while(0);c[g>>2]=h;if(!(c[g>>2]|0)){j=8;break}if(!(c[g>>2]|0))continue;Hb[c[c[(c[d>>2]|0)+20>>2]>>2]&63](c[(c[d>>2]|0)+20>>2]|0,c[g>>2]|0,4096)|0;O4(c[g>>2]|0);c[f>>2]=(c[f>>2]|0)+1}if((j|0)==8)La(149252,149146,616,149255);if((c[e>>2]|0)==(c[f>>2]|0)){i=b;return}else La(149267,149146,623,149255)}function $S(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+48|0;f=e+32|0;g=e+16|0;j=e;c[e+36>>2]=b;c[f>>2]=d;h[j+8>>3]=0.0;h[j>>3]=0.0;if(c[(c[f>>2]|0)+32>>2]|0){d=c[(c[f>>2]|0)+32>>2]|0;c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2]}c[g>>2]=~~+M(+(+h[c[f>>2]>>3]-+h[j>>3]));c[g+4>>2]=~~+M(+(+h[(c[f>>2]|0)+8>>3]-+h[j+8>>3]));c[g+8>>2]=~~+Z(+(+h[c[f>>2]>>3]+ +h[(c[f>>2]|0)+16>>3]+ +h[j>>3]));if((c[g+8>>2]|0)>=2147483647)La(149279,149146,264,149306);c[g+12>>2]=~~+Z(+(+h[(c[f>>2]|0)+8>>3]+ +h[(c[f>>2]|0)+16+8>>3]+ +h[j+8>>3]));if((c[g+12>>2]|0)<2147483647){c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=e;return}else La(149316,149146,266,149306)}function aT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=b;c[g>>2]=c[a>>2];c[h>>2]=c[a+4>>2];c[l>>2]=0;c[f>>2]=(c[e>>2]|0)-1;while(1){if((c[f>>2]|0)<0)break;c[j>>2]=c[g>>2]>>c[f>>2]&1;c[k>>2]=c[h>>2]>>c[f>>2]&1;c[l>>2]=(c[l>>2]<<2)+(c[j>>2]<<1)+(c[j>>2]^c[k>>2]);c[g>>2]=c[g>>2]^c[h>>2];c[h>>2]=c[h>>2]^c[g>>2]&(c[k>>2]|0)-1;c[g>>2]=c[g>>2]^c[h>>2];c[g>>2]=c[g>>2]^0-(c[j>>2]|0)&(c[k>>2]|0)-1;c[h>>2]=c[h>>2]^0-(c[j>>2]|0)&(c[k>>2]|0)-1;c[f>>2]=(c[f>>2]|0)+-1}i=d;return c[l>>2]|0}function bT(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+20|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=b;c[j>>2]=c[g>>2];c[l>>2]=N3(c[g>>2]|0)|0;if((c[l>>2]|0)>=(c[15372]|0)?(c[15372]=(c[l>>2]|0)+1+10,c[15373]=eK(c[15373]|0,c[15372]|0)|0,(c[15373]|0)==0):0){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}c[k>>2]=c[15373];while(1){l=c[j>>2]|0;c[j>>2]=l+1;g=a[l>>0]|0;a[h>>0]=g;if(!(g<<24>>24))break;if(s1(d[h>>0]|0)|0)a[h>>0]=H1(d[h>>0]|0)|0;g=a[h>>0]|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l>>0]=g}a[c[k>>2]>>0]=0;c[f>>2]=c[15373];m=c[f>>2]|0;i=e;return m|0}function cT(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,O=0.0;g=i;i=i+192|0;j=g+104|0;k=g+88|0;l=g+172|0;m=g+168|0;n=g+164|0;o=g+160|0;p=g+156|0;q=g+152|0;r=g+140|0;s=g+176|0;t=g+80|0;u=g+72|0;v=g+64|0;w=g+56|0;x=g+48|0;y=g+40|0;z=g+32|0;A=g+24|0;B=g+16|0;C=g+8|0;D=g;E=g+136|0;F=g+132|0;G=g+128|0;H=g+124|0;I=g+120|0;J=g+116|0;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[(c[n>>2]|0)+32>>2]=c[o>>2];c[J>>2]=0;while(1){K=c[m>>2]|0;if((a[c[m>>2]>>0]|0)!=32)break;c[m>>2]=K+1}c[p>>2]=K;c[H>>2]=255;if((d[c[p>>2]>>0]|0)==35?(K=c[p>>2]|0,c[k>>2]=E,c[k+4>>2]=F,c[k+8>>2]=G,c[k+12>>2]=H,(l3(K,149358,k)|0)>=3):0){switch(c[o>>2]|0){case 0:{h[x>>3]=+((c[E>>2]|0)>>>0)/255.0;h[y>>3]=+((c[F>>2]|0)>>>0)/255.0;h[z>>3]=+((c[G>>2]|0)>>>0)/255.0;h[w>>3]=+((c[H>>2]|0)>>>0)/255.0;eT(+h[x>>3],+h[y>>3],+h[z>>3],t,u,v);h[c[n>>2]>>3]=+h[t>>3];h[(c[n>>2]|0)+8>>3]=+h[u>>3];h[(c[n>>2]|0)+16>>3]=+h[v>>3];h[(c[n>>2]|0)+24>>3]=+h[w>>3];break}case 1:{a[c[n>>2]>>0]=c[E>>2];a[(c[n>>2]|0)+1>>0]=c[F>>2];a[(c[n>>2]|0)+2>>0]=c[G>>2];a[(c[n>>2]|0)+3>>0]=c[H>>2];break}case 3:{h[x>>3]=+((c[E>>2]|0)>>>0)/255.0;h[y>>3]=+((c[F>>2]|0)>>>0)/255.0;h[z>>3]=+((c[G>>2]|0)>>>0)/255.0;fT(+h[x>>3],+h[y>>3],+h[z>>3],A,B,C,D);a[c[n>>2]>>0]=~~+h[A>>3]*255;a[(c[n>>2]|0)+1>>0]=~~+h[B>>3]*255;a[(c[n>>2]|0)+2>>0]=~~+h[C>>3]*255;a[(c[n>>2]|0)+3>>0]=~~+h[D>>3]*255;break}case 2:{c[c[n>>2]>>2]=(((c[E>>2]|0)*65535|0)>>>0)/255|0;c[(c[n>>2]|0)+4>>2]=(((c[F>>2]|0)*65535|0)>>>0)/255|0;c[(c[n>>2]|0)+8>>2]=(((c[G>>2]|0)*65535|0)>>>0)/255|0;c[(c[n>>2]|0)+12>>2]=(((c[H>>2]|0)*65535|0)>>>0)/255|0;break}case 4:{h[c[n>>2]>>3]=+((c[E>>2]|0)>>>0)/255.0;h[(c[n>>2]|0)+8>>3]=+((c[F>>2]|0)>>>0)/255.0;h[(c[n>>2]|0)+16>>3]=+((c[G>>2]|0)>>>0)/255.0;h[(c[n>>2]|0)+24>>3]=+((c[H>>2]|0)>>>0)/255.0;break}default:{}}c[l>>2]=c[J>>2];L=c[l>>2]|0;i=g;return L|0}H=a[c[p>>2]>>0]|0;a[s>>0]=H;if(!((H&255|0)!=46?(p1(d[s>>0]|0)|0)==0:0)){c[I>>2]=N3(c[p>>2]|0)|0;if((c[I>>2]|0)>=(c[15374]|0)?(c[15374]=(c[I>>2]|0)+1+10,c[15375]=eK(c[15375]|0,c[15374]|0)|0,(c[15375]|0)==0):0){c[J>>2]=-1;c[l>>2]=c[J>>2];L=c[l>>2]|0;i=g;return L|0}c[q>>2]=c[15375];while(1){I=c[p>>2]|0;c[p>>2]=I+1;H=a[I>>0]|0;a[s>>0]=H;if(!(H<<24>>24))break;if((d[s>>0]|0)==44)a[s>>0]=32;H=a[s>>0]|0;I=c[q>>2]|0;c[q>>2]=I+1;a[I>>0]=H}a[c[q>>2]>>0]=0;q=c[15375]|0;c[j>>2]=t;c[j+4>>2]=u;c[j+8>>2]=v;if((l3(q,149372,j)|0)==3){if((+h[t>>3]<1.0?+h[t>>3]:1.0)>0.0)M=+h[t>>3]<1.0?+h[t>>3]:1.0;else M=0.0;h[t>>3]=M;if((+h[u>>3]<1.0?+h[u>>3]:1.0)>0.0)N=+h[u>>3]<1.0?+h[u>>3]:1.0;else N=0.0;h[u>>3]=N;if((+h[v>>3]<1.0?+h[v>>3]:1.0)>0.0)O=+h[v>>3]<1.0?+h[v>>3]:1.0;else O=0.0;h[v>>3]=O;switch(c[o>>2]|0){case 0:{h[c[n>>2]>>3]=+h[t>>3];h[(c[n>>2]|0)+8>>3]=+h[u>>3];h[(c[n>>2]|0)+16>>3]=+h[v>>3];h[(c[n>>2]|0)+24>>3]=1.0;break}case 1:{gT(+h[t>>3],+h[u>>3],+h[v>>3],x,y,z);a[c[n>>2]>>0]=~~(+h[x>>3]*255.0);a[(c[n>>2]|0)+1>>0]=~~(+h[y>>3]*255.0);a[(c[n>>2]|0)+2>>0]=~~(+h[z>>3]*255.0);a[(c[n>>2]|0)+3>>0]=-1;break}case 3:{gT(+h[t>>3],+h[u>>3],+h[v>>3],x,y,z);fT(+h[x>>3],+h[y>>3],+h[z>>3],A,B,C,D);a[c[n>>2]>>0]=~~+h[A>>3]*255;a[(c[n>>2]|0)+1>>0]=~~+h[B>>3]*255;a[(c[n>>2]|0)+2>>0]=~~+h[C>>3]*255;a[(c[n>>2]|0)+3>>0]=~~+h[D>>3]*255;break}case 2:{gT(+h[t>>3],+h[u>>3],+h[v>>3],x,y,z);c[c[n>>2]>>2]=~~(+h[x>>3]*65535.0);c[(c[n>>2]|0)+4>>2]=~~(+h[y>>3]*65535.0);c[(c[n>>2]|0)+8>>2]=~~(+h[z>>3]*65535.0);c[(c[n>>2]|0)+12>>2]=65535;break}case 4:{gT(+h[t>>3],+h[u>>3],+h[v>>3],x,y,z);h[c[n>>2]>>3]=+h[x>>3];h[(c[n>>2]|0)+8>>3]=+h[y>>3];h[(c[n>>2]|0)+16>>3]=+h[z>>3];h[(c[n>>2]|0)+24>>3]=1.0;break}default:{}}c[l>>2]=c[J>>2];L=c[l>>2]|0;i=g;return L|0}}c[r>>2]=hT(c[m>>2]|0)|0;if(!(c[r>>2]|0)){c[l>>2]=-1;L=c[l>>2]|0;i=g;return L|0}if(!(((c[15376]|0)!=0?(a[c[c[15376]>>2]>>0]|0)==(a[c[r>>2]>>0]|0):0)?(J3(c[c[15376]>>2]|0,c[r>>2]|0)|0)==0:0))c[15376]=v3(r,61508,2491,12,103)|0;if(c[15376]|0){switch(c[o>>2]|0){case 0:{h[c[n>>2]>>3]=+(d[(c[15376]|0)+4>>0]|0)/255.0;h[(c[n>>2]|0)+8>>3]=+(d[(c[15376]|0)+5>>0]|0)/255.0;h[(c[n>>2]|0)+16>>3]=+(d[(c[15376]|0)+6>>0]|0)/255.0;h[(c[n>>2]|0)+24>>3]=+(d[(c[15376]|0)+10>>0]|0)/255.0;break}case 1:{a[c[n>>2]>>0]=a[(c[15376]|0)+7>>0]|0;a[(c[n>>2]|0)+1>>0]=a[(c[15376]|0)+8>>0]|0;a[(c[n>>2]|0)+2>>0]=a[(c[15376]|0)+9>>0]|0;a[(c[n>>2]|0)+3>>0]=a[(c[15376]|0)+10>>0]|0;break}case 3:{h[x>>3]=+(d[(c[15376]|0)+7>>0]|0)/255.0;h[y>>3]=+(d[(c[15376]|0)+8>>0]|0)/255.0;h[z>>3]=+(d[(c[15376]|0)+9>>0]|0)/255.0;fT(+h[x>>3],+h[y>>3],+h[z>>3],A,B,C,D);a[c[n>>2]>>0]=~~+h[A>>3]*255;a[(c[n>>2]|0)+1>>0]=~~+h[B>>3]*255;a[(c[n>>2]|0)+2>>0]=~~+h[C>>3]*255;a[(c[n>>2]|0)+3>>0]=~~+h[D>>3]*255;break}case 2:{c[c[n>>2]>>2]=((d[(c[15376]|0)+7>>0]|0)*65535|0)/255|0;c[(c[n>>2]|0)+4>>2]=((d[(c[15376]|0)+8>>0]|0)*65535|0)/255|0;c[(c[n>>2]|0)+8>>2]=((d[(c[15376]|0)+9>>0]|0)*65535|0)/255|0;c[(c[n>>2]|0)+12>>2]=((d[(c[15376]|0)+10>>0]|0)*65535|0)/255|0;break}case 4:{h[c[n>>2]>>3]=+(d[(c[15376]|0)+7>>0]|0)/255.0;h[(c[n>>2]|0)+8>>3]=+(d[(c[15376]|0)+8>>0]|0)/255.0;h[(c[n>>2]|0)+16>>3]=+(d[(c[15376]|0)+9>>0]|0)/255.0;h[(c[n>>2]|0)+24>>3]=+(d[(c[15376]|0)+10>>0]|0)/255.0;break}default:{}}c[l>>2]=c[J>>2];L=c[l>>2]|0;i=g;return L|0}else{c[J>>2]=1;switch(c[o>>2]|0){case 0:{h[(c[n>>2]|0)+16>>3]=0.0;h[(c[n>>2]|0)+8>>3]=0.0;h[c[n>>2]>>3]=0.0;h[(c[n>>2]|0)+24>>3]=1.0;break}case 1:{a[(c[n>>2]|0)+2>>0]=0;a[(c[n>>2]|0)+1>>0]=0;a[c[n>>2]>>0]=0;a[(c[n>>2]|0)+3>>0]=-1;break}case 3:{a[(c[n>>2]|0)+3>>0]=0;a[(c[n>>2]|0)+2>>0]=0;a[(c[n>>2]|0)+1>>0]=0;a[c[n>>2]>>0]=0;break}case 2:{c[(c[n>>2]|0)+8>>2]=0;c[(c[n>>2]|0)+4>>2]=0;c[c[n>>2]>>2]=0;c[(c[n>>2]|0)+12>>2]=65535;break}case 4:{h[(c[n>>2]|0)+16>>3]=0.0;h[(c[n>>2]|0)+8>>3]=0.0;h[c[n>>2]>>3]=0.0;h[(c[n>>2]|0)+24>>3]=1.0;break}default:{}}c[l>>2]=c[J>>2];L=c[l>>2]|0;i=g;return L|0}return 0}function dT(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[22850]=c[d>>2];i=b;return}function eT(a,b,d,e,f,g){a=+a;b=+b;d=+d;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0;j=i;i=i+96|0;k=j+72|0;l=j+64|0;m=j+56|0;n=j+88|0;o=j+84|0;p=j+80|0;q=j+48|0;r=j+40|0;s=j+32|0;t=j+24|0;u=j+16|0;v=j+8|0;w=j;h[k>>3]=a;h[l>>3]=b;h[m>>3]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;h[v>>3]=0.0;h[w>>3]=0.0;if(+h[k>>3]<(+h[l>>3]<+h[m>>3]?+h[l>>3]:+h[m>>3]))x=+h[k>>3];else x=+h[l>>3]<+h[m>>3]?+h[l>>3]:+h[m>>3];h[q>>3]=x;if(+h[k>>3]>(+h[l>>3]>+h[m>>3]?+h[l>>3]:+h[m>>3]))y=+h[k>>3];else y=+h[l>>3]>+h[m>>3]?+h[l>>3]:+h[m>>3];h[r>>3]=y;if(+h[r>>3]>0.0)h[w>>3]=(+h[r>>3]-+h[q>>3])/+h[r>>3];if(!(+h[w>>3]>0.0)){z=+h[v>>3];A=z/360.0;B=c[n>>2]|0;h[B>>3]=A;C=+h[r>>3];D=c[p>>2]|0;h[D>>3]=C;E=+h[w>>3];F=c[o>>2]|0;h[F>>3]=E;i=j;return}h[s>>3]=(+h[r>>3]-+h[k>>3])/(+h[r>>3]-+h[q>>3]);h[u>>3]=(+h[r>>3]-+h[l>>3])/(+h[r>>3]-+h[q>>3]);h[t>>3]=(+h[r>>3]-+h[m>>3])/(+h[r>>3]-+h[q>>3]);do if(!(+h[k>>3]==+h[r>>3])){if(+h[l>>3]==+h[r>>3]){h[v>>3]=+h[s>>3]+2.0-+h[t>>3];break}if(+h[m>>3]==+h[r>>3])h[v>>3]=+h[u>>3]+4.0-+h[s>>3]}else h[v>>3]=+h[t>>3]-+h[u>>3];while(0);h[v>>3]=+h[v>>3]*60.0;if(!(+h[v>>3]<0.0)){z=+h[v>>3];A=z/360.0;B=c[n>>2]|0;h[B>>3]=A;C=+h[r>>3];D=c[p>>2]|0;h[D>>3]=C;E=+h[w>>3];F=c[o>>2]|0;h[F>>3]=E;i=j;return}h[v>>3]=+h[v>>3]+360.0;z=+h[v>>3];A=z/360.0;B=c[n>>2]|0;h[B>>3]=A;C=+h[r>>3];D=c[p>>2]|0;h[D>>3]=C;E=+h[w>>3];F=c[o>>2]|0;h[F>>3]=E;i=j;return}function fT(a,b,d,e,f,g,j){a=+a;b=+b;d=+d;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0;k=i;i=i+48|0;l=k+16|0;m=k+8|0;n=k;o=k+36|0;p=k+32|0;q=k+28|0;r=k+24|0;h[l>>3]=a;h[m>>3]=b;h[n>>3]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;h[c[o>>2]>>3]=1.0-+h[l>>3];h[c[p>>2]>>3]=1.0-+h[m>>3];h[c[q>>2]>>3]=1.0-+h[n>>3];if(+h[c[o>>2]>>3]<+h[c[p>>2]>>3])s=+h[c[o>>2]>>3];else s=+h[c[p>>2]>>3];h[c[r>>2]>>3]=s;if(+h[c[q>>2]>>3]<+h[c[r>>2]>>3])t=+h[c[q>>2]>>3];else t=+h[c[r>>2]>>3];h[c[r>>2]>>3]=t;n=c[o>>2]|0;h[n>>3]=+h[n>>3]-+h[c[r>>2]>>3];n=c[p>>2]|0;h[n>>3]=+h[n>>3]-+h[c[r>>2]>>3];n=c[q>>2]|0;h[n>>3]=+h[n>>3]-+h[c[r>>2]>>3];i=k;return}function gT(a,b,d,e,f,g){a=+a;b=+b;d=+d;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+80|0;k=j+48|0;l=j+40|0;m=j+32|0;n=j+68|0;o=j+64|0;p=j+60|0;q=j+56|0;r=j+24|0;s=j+16|0;t=j+8|0;u=j;h[k>>3]=a;h[l>>3]=b;h[m>>3]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if(+h[l>>3]<=0.0){h[c[n>>2]>>3]=+h[m>>3];h[c[o>>2]>>3]=+h[m>>3];h[c[p>>2]>>3]=+h[m>>3];i=j;return}if(+h[k>>3]>=1.0)h[k>>3]=0.0;h[k>>3]=+h[k>>3]*6.0;c[q>>2]=~~+h[k>>3];h[r>>3]=+h[k>>3]-+(c[q>>2]|0);h[s>>3]=+h[m>>3]*(1.0-+h[l>>3]);h[t>>3]=+h[m>>3]*(1.0-+h[l>>3]*+h[r>>3]);h[u>>3]=+h[m>>3]*(1.0-+h[l>>3]*(1.0-+h[r>>3]));switch(c[q>>2]|0){case 0:{h[c[n>>2]>>3]=+h[m>>3];h[c[o>>2]>>3]=+h[u>>3];h[c[p>>2]>>3]=+h[s>>3];i=j;return}case 1:{h[c[n>>2]>>3]=+h[t>>3];h[c[o>>2]>>3]=+h[m>>3];h[c[p>>2]>>3]=+h[s>>3];i=j;return}case 2:{h[c[n>>2]>>3]=+h[s>>3];h[c[o>>2]>>3]=+h[m>>3];h[c[p>>2]>>3]=+h[u>>3];i=j;return}case 3:{h[c[n>>2]>>3]=+h[s>>3];h[c[o>>2]>>3]=+h[t>>3];h[c[p>>2]>>3]=+h[m>>3];i=j;return}case 4:{h[c[n>>2]>>3]=+h[u>>3];h[c[o>>2]>>3]=+h[s>>3];h[c[p>>2]>>3]=+h[m>>3];i=j;return}case 5:{h[c[n>>2]>>3]=+h[m>>3];h[c[o>>2]>>3]=+h[s>>3];h[c[p>>2]>>3]=+h[t>>3];i=j;return}default:{i=j;return}}}function hT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=b;if((a[c[f>>2]>>0]|0)!=98?(P3((c[f>>2]|0)+1|0,174869,4)|0)!=0:0){if((a[c[f>>2]>>0]|0)!=119?(P3((c[f>>2]|0)+1|0,174874,4)|0)!=0:0){if((a[c[f>>2]>>0]|0)!=108?(P3((c[f>>2]|0)+1|0,174879,8)|0)!=0:0){do if((a[c[f>>2]>>0]|0)==47){c[j>>2]=(c[f>>2]|0)+1;b=H3(c[j>>2]|0,47)|0;c[h>>2]=b;k=c[j>>2]|0;if(!b){c[g>>2]=k;break}if((a[k>>0]|0)!=47)if(O3(174888,c[j>>2]|0,4)|0){c[g>>2]=c[f>>2];break}else{c[g>>2]=(c[h>>2]|0)+1;break}if(((c[22850]|0)!=0?(a[c[22850]>>0]|0)!=0:0)?(O3(174888,c[22850]|0,3)|0)!=0:0){c[g>>2]=jT(c[22850]|0,(c[j>>2]|0)+1|0)|0;break}c[g>>2]=(c[j>>2]|0)+1}else{if(((c[22850]|0)!=0?(a[c[22850]>>0]|0)!=0:0)?(O3(174888,c[22850]|0,3)|0)!=0:0){c[g>>2]=jT(c[22850]|0,c[f>>2]|0)|0;break}c[g>>2]=c[f>>2]}while(0);c[e>>2]=bT(c[g>>2]|0)|0;l=c[e>>2]|0;i=d;return l|0}c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}function iT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=F3(c[c[e>>2]>>2]|0,c[c[f>>2]>>2]|0)|0;i=d;return b|0}function jT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;c[f>>2]=a;c[g>>2]=b;b=N3(c[f>>2]|0)|0;c[h>>2]=b+(N3(c[g>>2]|0)|0)+3;if((c[h>>2]|0)>=(c[22851]|0)){c[22851]=(c[h>>2]|0)+10;c[22852]=eK(c[22852]|0,c[22851]|0)|0}h=c[22852]|0;b=c[g>>2]|0;c[e>>2]=c[f>>2];c[e+4>>2]=b;k3(h,174893,e)|0;i=d;return c[22852]|0}function kT(a,b,d,e,f){a=a|0;b=+b;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+240|0;j=g+224|0;k=g+216|0;l=g+208|0;m=g+200|0;n=g;o=g+232|0;h[j>>3]=b;h[k>>3]=d;h[l>>3]=e;h[m>>3]=f;lT(n,+h[a>>3],+h[a+8>>3],+h[j>>3],+h[k>>3],0.0,+h[l>>3],+h[m>>3]);c[o>>2]=mT(n,3,1.0e-05,1)|0;i=g;return c[o>>2]|0}function lT(a,b,d,e,f,g,j,k){a=a|0;b=+b;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;l=i;i=i+64|0;m=l+56|0;n=l+48|0;o=l+40|0;p=l+32|0;q=l+24|0;r=l+16|0;s=l+8|0;t=l;c[m>>2]=a;h[n>>3]=b;h[o>>3]=d;h[p>>3]=e;h[q>>3]=f;h[r>>3]=g;h[s>>3]=j;h[t>>3]=k;h[c[m>>2]>>3]=+h[n>>3];h[(c[m>>2]|0)+8>>3]=+h[o>>3];h[(c[m>>2]|0)+16>>3]=+h[p>>3];h[(c[m>>2]|0)+24>>3]=+h[q>>3];h[(c[m>>2]|0)+32>>3]=+h[r>>3];k=+R(+(+h[s>>3]));j=+Q(+(+h[s>>3]));g=+W(+(k/+h[q>>3]),+(j/+h[p>>3]));h[(c[m>>2]|0)+56>>3]=g;g=+R(+(+h[t>>3]));j=+Q(+(+h[t>>3]));k=+W(+(g/+h[q>>3]),+(j/+h[p>>3]));h[(c[m>>2]|0)+64>>3]=k;k=+Q(+(+h[r>>3]));h[(c[m>>2]|0)+40>>3]=k;k=+R(+(+h[r>>3]));h[(c[m>>2]|0)+48>>3]=k;k=+M(+((+h[(c[m>>2]|0)+64>>3]-+h[(c[m>>2]|0)+56>>3])/6.283185307179586))*6.283185307179586;r=(c[m>>2]|0)+64|0;h[r>>3]=+h[r>>3]-k;if(+h[t>>3]-+h[s>>3]>3.141592653589793?+h[(c[m>>2]|0)+64>>3]-+h[(c[m>>2]|0)+56>>3]<3.141592653589793:0){s=(c[m>>2]|0)+64|0;h[s>>3]=+h[s>>3]+6.283185307179586}sT(c[m>>2]|0);tT(c[m>>2]|0);uT(c[m>>2]|0);h[(c[m>>2]|0)+168>>3]=(+h[(c[m>>2]|0)+16>>3]-+h[(c[m>>2]|0)+24>>3])/+h[(c[m>>2]|0)+16>>3];h[(c[m>>2]|0)+176>>3]=+h[(c[m>>2]|0)+168>>3]*(2.0-+h[(c[m>>2]|0)+168>>3]);h[(c[m>>2]|0)+184>>3]=1.0-+h[(c[m>>2]|0)+168>>3];h[(c[m>>2]|0)+192>>3]=+h[(c[m>>2]|0)+184>>3]*+h[(c[m>>2]|0)+184>>3];i=l;return}function mT(b,e,f,g){b=b|0;e=e|0;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0;j=i;i=i+208|0;k=j+192|0;l=j+188|0;m=j+168|0;n=j+197|0;o=j+160|0;p=j+152|0;q=j+144|0;r=j+136|0;s=j+128|0;t=j+120|0;u=j+112|0;v=j+104|0;w=j+96|0;x=j+88|0;y=j+80|0;z=j+72|0;A=j+64|0;B=j+56|0;C=j+184|0;D=j+196|0;E=j+180|0;F=j+176|0;G=j+48|0;H=j+40|0;I=j+32|0;J=j+24|0;K=j+16|0;L=j+8|0;M=j;c[k>>2]=b;c[l>>2]=e;h[m>>3]=f;a[n>>0]=g;c[C>>2]=bK(8)|0;a[D>>0]=0;c[F>>2]=1;while(1){N=(+h[(c[k>>2]|0)+64>>3]-+h[(c[k>>2]|0)+56>>3])/+(c[F>>2]|0);if(!((a[D>>0]|0)!=0?0:(c[F>>2]|0)<1024))break;h[G>>3]=N;a:do if(+h[G>>3]<=1.5707963267948966){h[H>>3]=+h[(c[k>>2]|0)+56>>3];a[D>>0]=1;c[E>>2]=0;while(1){if(!(d[D>>0]|0))break a;if((c[E>>2]|0)>=(c[F>>2]|0))break a;h[I>>3]=+h[H>>3];h[H>>3]=+h[H>>3]+ +h[G>>3];f=+nT(c[k>>2]|0,c[l>>2]|0,+h[I>>3],+h[H>>3]);a[D>>0]=f<=+h[m>>3];c[E>>2]=(c[E>>2]|0)+1}}while(0);c[F>>2]=c[F>>2]<<1}h[o>>3]=N;h[p>>3]=+h[(c[k>>2]|0)+56>>3];h[q>>3]=+Q(+(+h[p>>3]));h[r>>3]=+R(+(+h[p>>3]));h[s>>3]=+h[(c[k>>2]|0)+16>>3]*+h[q>>3];h[t>>3]=+h[(c[k>>2]|0)+24>>3]*+h[r>>3];h[u>>3]=+h[(c[k>>2]|0)+16>>3]*+h[r>>3];h[v>>3]=+h[(c[k>>2]|0)+24>>3]*+h[q>>3];h[w>>3]=+h[c[k>>2]>>3]+ +h[s>>3]*+h[(c[k>>2]|0)+40>>3]-+h[t>>3]*+h[(c[k>>2]|0)+48>>3];h[x>>3]=+h[(c[k>>2]|0)+8>>3]+ +h[s>>3]*+h[(c[k>>2]|0)+48>>3]+ +h[t>>3]*+h[(c[k>>2]|0)+40>>3];h[y>>3]=-+h[u>>3]*+h[(c[k>>2]|0)+40>>3]-+h[v>>3]*+h[(c[k>>2]|0)+48>>3];h[z>>3]=-+h[u>>3]*+h[(c[k>>2]|0)+48>>3]+ +h[v>>3]*+h[(c[k>>2]|0)+40>>3];m=c[C>>2]|0;if(a[n>>0]|0){oT(m,+h[c[k>>2]>>3],+h[(c[k>>2]|0)+8>>3]);pT(c[C>>2]|0,+h[w>>3],+h[x>>3])}else oT(m,+h[w>>3],+h[x>>3]);h[A>>3]=+S(+(+h[o>>3]*.5));N=+R(+(+h[o>>3]));h[B>>3]=N*(+O(+(+h[A>>3]*3.0*+h[A>>3]+4.0))-1.0)/3.0;c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[F>>2]|0))break;h[J>>3]=+h[w>>3];h[K>>3]=+h[x>>3];h[L>>3]=+h[y>>3];h[M>>3]=+h[z>>3];h[p>>3]=+h[p>>3]+ +h[o>>3];h[q>>3]=+Q(+(+h[p>>3]));h[r>>3]=+R(+(+h[p>>3]));h[s>>3]=+h[(c[k>>2]|0)+16>>3]*+h[q>>3];h[t>>3]=+h[(c[k>>2]|0)+24>>3]*+h[r>>3];h[u>>3]=+h[(c[k>>2]|0)+16>>3]*+h[r>>3];h[v>>3]=+h[(c[k>>2]|0)+24>>3]*+h[q>>3];h[w>>3]=+h[c[k>>2]>>3]+ +h[s>>3]*+h[(c[k>>2]|0)+40>>3]-+h[t>>3]*+h[(c[k>>2]|0)+48>>3];h[x>>3]=+h[(c[k>>2]|0)+8>>3]+ +h[s>>3]*+h[(c[k>>2]|0)+48>>3]+ +h[t>>3]*+h[(c[k>>2]|0)+40>>3];h[y>>3]=-+h[u>>3]*+h[(c[k>>2]|0)+40>>3]-+h[v>>3]*+h[(c[k>>2]|0)+48>>3];h[z>>3]=-+h[u>>3]*+h[(c[k>>2]|0)+48>>3]+ +h[v>>3]*+h[(c[k>>2]|0)+40>>3];A=c[C>>2]|0;if((c[l>>2]|0)==1)pT(A,+h[w>>3],+h[x>>3]);else qT(A,+h[J>>3]+ +h[B>>3]*+h[L>>3],+h[K>>3]+ +h[B>>3]*+h[M>>3],+h[w>>3]-+h[B>>3]*+h[y>>3],+h[x>>3]-+h[B>>3]*+h[z>>3],+h[w>>3],+h[x>>3]);c[E>>2]=(c[E>>2]|0)+1}rT(c[C>>2]|0,a[n>>0]|0);i=j;return c[C>>2]|0}function nT(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0;f=i;i=i+224|0;g=f+192|0;j=f+212|0;k=f+208|0;l=f+184|0;m=f+176|0;n=f+168|0;o=f+160|0;p=f+152|0;q=f+144|0;r=f+136|0;s=f+128|0;t=f+120|0;u=f+112|0;v=f+104|0;w=f+96|0;x=f+88|0;y=f+80|0;z=f+72|0;A=f+64|0;B=f+56|0;C=f+48|0;D=f+40|0;E=f+32|0;F=f+24|0;G=f+16|0;H=f+8|0;I=f;J=f+204|0;K=f+200|0;c[j>>2]=a;c[k>>2]=b;h[l>>3]=d;h[m>>3]=e;h[p>>3]=(+h[l>>3]+ +h[m>>3])*.5;b=c[j>>2]|0;if((c[k>>2]|0)<2){h[q>>3]=+h[b+16>>3]*+Q(+(+h[l>>3]));h[r>>3]=+h[(c[j>>2]|0)+24>>3]*+R(+(+h[l>>3]));h[s>>3]=+h[c[j>>2]>>3]+ +h[q>>3]*+h[(c[j>>2]|0)+40>>3]-+h[r>>3]*+h[(c[j>>2]|0)+48>>3];h[t>>3]=+h[(c[j>>2]|0)+8>>3]+ +h[q>>3]*+h[(c[j>>2]|0)+48>>3]+ +h[r>>3]*+h[(c[j>>2]|0)+40>>3];h[u>>3]=+h[(c[j>>2]|0)+16>>3]*+Q(+(+h[m>>3]));h[v>>3]=+h[(c[j>>2]|0)+24>>3]*+R(+(+h[m>>3]));h[w>>3]=+h[c[j>>2]>>3]+ +h[u>>3]*+h[(c[j>>2]|0)+40>>3]-+h[v>>3]*+h[(c[j>>2]|0)+48>>3];h[x>>3]=+h[(c[j>>2]|0)+8>>3]+ +h[u>>3]*+h[(c[j>>2]|0)+48>>3]+ +h[v>>3]*+h[(c[j>>2]|0)+40>>3];h[y>>3]=+h[(c[j>>2]|0)+16>>3]*+Q(+(+h[p>>3]));h[z>>3]=+h[(c[j>>2]|0)+24>>3]*+R(+(+h[p>>3]));h[A>>3]=+h[c[j>>2]>>3]+ +h[y>>3]*+h[(c[j>>2]|0)+40>>3]-+h[z>>3]*+h[(c[j>>2]|0)+48>>3];h[B>>3]=+h[(c[j>>2]|0)+8>>3]+ +h[y>>3]*+h[(c[j>>2]|0)+48>>3]+ +h[z>>3]*+h[(c[j>>2]|0)+40>>3];h[C>>3]=+h[w>>3]-+h[s>>3];h[D>>3]=+h[x>>3]-+h[t>>3];e=+(N(~~(+h[A>>3]*+h[D>>3]-+h[B>>3]*+h[C>>3]+ +h[w>>3]*+h[t>>3]-+h[s>>3]*+h[x>>3])|0)|0);h[g>>3]=e/+O(+(+h[C>>3]*+h[C>>3]+ +h[D>>3]*+h[D>>3]));L=+h[g>>3];i=f;return +L}h[E>>3]=+h[b+24>>3]/+h[(c[j>>2]|0)+16>>3];h[F>>3]=+h[m>>3]-+h[l>>3];h[G>>3]=+Q(+(+h[p>>3]*2.0));h[H>>3]=+Q(+(+h[p>>3]*4.0));h[I>>3]=+Q(+(+h[p>>3]*6.0));p=+h[E>>3]<.25;if((c[k>>2]|0)==2){c[J>>2]=p?42904:43160;c[K>>2]=43416}else{c[J>>2]=p?43448:43704;c[K>>2]=43960}h[n>>3]=(+h[E>>3]*(+h[E>>3]*+h[c[J>>2]>>3]+ +h[(c[J>>2]|0)+8>>3])+ +h[(c[J>>2]|0)+16>>3])/(+h[E>>3]+ +h[(c[J>>2]|0)+24>>3])+ +h[G>>3]*((+h[E>>3]*(+h[E>>3]*+h[(c[J>>2]|0)+32>>3]+ +h[(c[J>>2]|0)+32+8>>3])+ +h[(c[J>>2]|0)+32+16>>3])/(+h[E>>3]+ +h[(c[J>>2]|0)+32+24>>3]))+ +h[H>>3]*((+h[E>>3]*(+h[E>>3]*+h[(c[J>>2]|0)+64>>3]+ +h[(c[J>>2]|0)+64+8>>3])+ +h[(c[J>>2]|0)+64+16>>3])/(+h[E>>3]+ +h[(c[J>>2]|0)+64+24>>3]))+ +h[I>>3]*((+h[E>>3]*(+h[E>>3]*+h[(c[J>>2]|0)+96>>3]+ +h[(c[J>>2]|0)+96+8>>3])+ +h[(c[J>>2]|0)+96+16>>3])/(+h[E>>3]+ +h[(c[J>>2]|0)+96+24>>3]));h[o>>3]=(+h[E>>3]*(+h[E>>3]*+h[(c[J>>2]|0)+128>>3]+ +h[(c[J>>2]|0)+128+8>>3])+ +h[(c[J>>2]|0)+128+16>>3])/(+h[E>>3]+ +h[(c[J>>2]|0)+128+24>>3])+ +h[G>>3]*((+h[E>>3]*(+h[E>>3]*+h[(c[J>>2]|0)+128+32>>3]+ +h[(c[J>>2]|0)+128+32+8>>3])+ +h[(c[J>>2]|0)+128+32+16>>3])/(+h[E>>3]+ +h[(c[J>>2]|0)+128+32+24>>3]))+ +h[H>>3]*((+h[E>>3]*(+h[E>>3]*+h[(c[J>>2]|0)+128+64>>3]+ +h[(c[J>>2]|0)+128+64+8>>3])+ +h[(c[J>>2]|0)+128+64+16>>3])/(+h[E>>3]+ +h[(c[J>>2]|0)+128+64+24>>3]))+ +h[I>>3]*((+h[E>>3]*(+h[E>>3]*+h[(c[J>>2]|0)+128+96>>3]+ +h[(c[J>>2]|0)+128+96+8>>3])+ +h[(c[J>>2]|0)+128+96+16>>3])/(+h[E>>3]+ +h[(c[J>>2]|0)+128+96+24>>3]));h[g>>3]=(+h[E>>3]*(+h[E>>3]*+h[c[K>>2]>>3]+ +h[(c[K>>2]|0)+8>>3])+ +h[(c[K>>2]|0)+16>>3])/(+h[E>>3]+ +h[(c[K>>2]|0)+24>>3])*+h[(c[j>>2]|0)+16>>3]*+X(+(+h[n>>3]+ +h[o>>3]*+h[F>>3]));L=+h[g>>3];i=f;return +L}function oT(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;j=e;c[f>>2]=a;h[g>>3]=b;h[j>>3]=d;c[22853]=100;a=bK(c[22853]<<4)|0;c[c[f>>2]>>2]=a;h[c[c[f>>2]>>2]>>3]=+h[g>>3];h[(c[c[f>>2]>>2]|0)+8>>3]=+h[j>>3];c[(c[f>>2]|0)+4>>2]=1;i=e;return}function pT(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+48|0;f=e+32|0;g=e+24|0;j=e+16|0;k=e;c[f>>2]=a;h[g>>3]=b;h[j>>3]=d;a=(c[c[f>>2]>>2]|0)+((c[(c[f>>2]|0)+4>>2]|0)-1<<4)|0;c[k>>2]=c[a>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];qT(c[f>>2]|0,+h[k>>3],+h[k+8>>3],+h[g>>3],+h[j>>3],+h[g>>3],+h[j>>3]);i=e;return}function qT(a,b,d,e,f,g,j){a=a|0;b=+b;d=+d;e=+e;f=+f;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+64|0;l=k+48|0;m=k+40|0;n=k+32|0;o=k+24|0;p=k+16|0;q=k+8|0;r=k;c[l>>2]=a;h[m>>3]=b;h[n>>3]=d;h[o>>3]=e;h[p>>3]=f;h[q>>3]=g;h[r>>3]=j;if(((c[(c[l>>2]|0)+4>>2]|0)+3|0)>=(c[22853]|0)){c[22853]=c[22853]<<1;a=Q4(c[c[l>>2]>>2]|0,c[22853]<<4)|0;c[c[l>>2]>>2]=a}h[(c[c[l>>2]>>2]|0)+(c[(c[l>>2]|0)+4>>2]<<4)>>3]=+h[m>>3];j=+h[n>>3];n=(c[l>>2]|0)+4|0;m=c[n>>2]|0;c[n>>2]=m+1;h[(c[c[l>>2]>>2]|0)+(m<<4)+8>>3]=j;h[(c[c[l>>2]>>2]|0)+(c[(c[l>>2]|0)+4>>2]<<4)>>3]=+h[o>>3];j=+h[p>>3];p=(c[l>>2]|0)+4|0;o=c[p>>2]|0;c[p>>2]=o+1;h[(c[c[l>>2]>>2]|0)+(o<<4)+8>>3]=j;h[(c[c[l>>2]>>2]|0)+(c[(c[l>>2]|0)+4>>2]<<4)>>3]=+h[q>>3];j=+h[r>>3];r=(c[l>>2]|0)+4|0;q=c[r>>2]|0;c[r>>2]=q+1;h[(c[c[l>>2]>>2]|0)+(q<<4)+8>>3]=j;i=k;return}function rT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e+20|0;j=e;c[f>>2]=b;a[g>>0]=d;if(a[g>>0]|0){g=c[c[f>>2]>>2]|0;c[j>>2]=c[g>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];pT(c[f>>2]|0,+h[j>>3],+h[j+8>>3])}j=Q4(c[c[f>>2]>>2]|0,c[(c[f>>2]|0)+4>>2]<<4)|0;c[c[f>>2]>>2]=j;c[22853]=0;i=e;return}function sT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+24|0;e=b+16|0;f=b+8|0;g=b;c[d>>2]=a;h[e>>3]=+O(+(+h[(c[d>>2]|0)+16>>3]*+h[(c[d>>2]|0)+16>>3]-+h[(c[d>>2]|0)+24>>3]*+h[(c[d>>2]|0)+24>>3]));h[f>>3]=+h[e>>3]*+h[(c[d>>2]|0)+40>>3];h[g>>3]=+h[e>>3]*+h[(c[d>>2]|0)+48>>3];h[(c[d>>2]|0)+104>>3]=+h[c[d>>2]>>3]-+h[f>>3];h[(c[d>>2]|0)+112>>3]=+h[(c[d>>2]|0)+8>>3]-+h[g>>3];h[(c[d>>2]|0)+120>>3]=+h[c[d>>2]>>3]+ +h[f>>3];h[(c[d>>2]|0)+128>>3]=+h[(c[d>>2]|0)+8>>3]+ +h[g>>3];i=b;return}function tT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+48|0;d=b+32|0;e=b+24|0;f=b+16|0;g=b+8|0;j=b;c[d>>2]=a;h[e>>3]=+h[(c[d>>2]|0)+16>>3]*+Q(+(+h[(c[d>>2]|0)+56>>3]));h[f>>3]=+h[(c[d>>2]|0)+24>>3]*+R(+(+h[(c[d>>2]|0)+56>>3]));h[g>>3]=+h[(c[d>>2]|0)+16>>3]*+Q(+(+h[(c[d>>2]|0)+64>>3]));h[j>>3]=+h[(c[d>>2]|0)+24>>3]*+R(+(+h[(c[d>>2]|0)+64>>3]));h[(c[d>>2]|0)+72>>3]=+h[c[d>>2]>>3]+ +h[e>>3]*+h[(c[d>>2]|0)+40>>3]-+h[f>>3]*+h[(c[d>>2]|0)+48>>3];h[(c[d>>2]|0)+80>>3]=+h[(c[d>>2]|0)+8>>3]+ +h[e>>3]*+h[(c[d>>2]|0)+48>>3]+ +h[f>>3]*+h[(c[d>>2]|0)+40>>3];h[(c[d>>2]|0)+88>>3]=+h[c[d>>2]>>3]+ +h[g>>3]*+h[(c[d>>2]|0)+40>>3]-+h[j>>3]*+h[(c[d>>2]|0)+48>>3];h[(c[d>>2]|0)+96>>3]=+h[(c[d>>2]|0)+8>>3]+ +h[g>>3]*+h[(c[d>>2]|0)+48>>3]+ +h[j>>3]*+h[(c[d>>2]|0)+40>>3];i=b;return}function uT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0,z=0;b=i;i=i+64|0;d=b+56|0;e=b+48|0;f=b+40|0;g=b+32|0;j=b+24|0;k=b+16|0;l=b+8|0;m=b;c[d>>2]=a;h[e>>3]=+h[(c[d>>2]|0)+24>>3]/+h[(c[d>>2]|0)+16>>3];a=+(N(~~+h[(c[d>>2]|0)+48>>3]|0)|0)<.1;n=c[d>>2]|0;do if(a){h[l>>3]=+h[n+48>>3]/+h[(c[d>>2]|0)+40>>3];o=-+V(+(+h[l>>3]*+h[e>>3]));if(+h[(c[d>>2]|0)+40>>3]<0.0){h[f>>3]=o;h[g>>3]=+h[f>>3]+3.141592653589793;h[j>>3]=1.5707963267948966-+V(+(+h[l>>3]/+h[e>>3]));h[k>>3]=+h[j>>3]+3.141592653589793;break}else{h[g>>3]=o;h[f>>3]=+h[g>>3]-3.141592653589793;h[k>>3]=1.5707963267948966-+V(+(+h[l>>3]/+h[e>>3]));h[j>>3]=+h[k>>3]-3.141592653589793;break}}else{h[m>>3]=+h[n+40>>3]/+h[(c[d>>2]|0)+48>>3];o=+V(+(+h[m>>3]/+h[e>>3]))+1.5707963267948966;if(+h[(c[d>>2]|0)+48>>3]<0.0){h[g>>3]=o;h[f>>3]=+h[g>>3]-3.141592653589793;h[j>>3]=+V(+(+h[m>>3]*+h[e>>3]));h[k>>3]=+h[j>>3]+3.141592653589793;break}else{h[f>>3]=o;h[g>>3]=+h[f>>3]+3.141592653589793;h[k>>3]=+V(+(+h[m>>3]*+h[e>>3]));h[j>>3]=+h[k>>3]-3.141592653589793;break}}while(0);o=+M(+((+h[f>>3]-+h[(c[d>>2]|0)+56>>3])/6.283185307179586))*6.283185307179586;h[f>>3]=+h[f>>3]-o;o=+M(+((+h[j>>3]-+h[(c[d>>2]|0)+56>>3])/6.283185307179586))*6.283185307179586;h[j>>3]=+h[j>>3]-o;o=+M(+((+h[g>>3]-+h[(c[d>>2]|0)+56>>3])/6.283185307179586))*6.283185307179586;h[g>>3]=+h[g>>3]-o;o=+M(+((+h[k>>3]-+h[(c[d>>2]|0)+56>>3])/6.283185307179586))*6.283185307179586;h[k>>3]=+h[k>>3]-o;e=c[d>>2]|0;do if(!(+h[f>>3]<=+h[(c[d>>2]|0)+64>>3])){m=c[d>>2]|0;if(+h[e+72>>3]<+h[(c[d>>2]|0)+88>>3]){p=+h[m+72>>3];break}else{p=+h[m+88>>3];break}}else{o=+h[(c[d>>2]|0)+16>>3]*+Q(+(+h[f>>3]));q=+h[(c[d>>2]|0)+24>>3]*+R(+(+h[f>>3]));p=+h[e>>3]+o*+h[(c[d>>2]|0)+40>>3]-q*+h[(c[d>>2]|0)+48>>3]}while(0);h[(c[d>>2]|0)+136>>3]=p;e=c[d>>2]|0;do if(!(+h[j>>3]<=+h[(c[d>>2]|0)+64>>3])){f=c[d>>2]|0;if(+h[e+80>>3]<+h[(c[d>>2]|0)+96>>3]){r=+h[f+80>>3];break}else{r=+h[f+96>>3];break}}else{p=+h[(c[d>>2]|0)+16>>3]*+Q(+(+h[j>>3]));q=+h[(c[d>>2]|0)+24>>3]*+R(+(+h[j>>3]));r=+h[e+8>>3]+p*+h[(c[d>>2]|0)+48>>3]+q*+h[(c[d>>2]|0)+40>>3]}while(0);h[(c[d>>2]|0)+144>>3]=r;e=c[d>>2]|0;do if(!(+h[g>>3]<=+h[(c[d>>2]|0)+64>>3])){j=c[d>>2]|0;if(+h[e+72>>3]>+h[(c[d>>2]|0)+88>>3]){s=+h[j+72>>3];break}else{s=+h[j+88>>3];break}}else{r=+h[(c[d>>2]|0)+16>>3]*+Q(+(+h[g>>3]));q=+h[(c[d>>2]|0)+24>>3]*+R(+(+h[g>>3]));s=+h[e>>3]+r*+h[(c[d>>2]|0)+40>>3]-q*+h[(c[d>>2]|0)+48>>3]}while(0);h[(c[d>>2]|0)+152>>3]=s-+h[(c[d>>2]|0)+136>>3];e=c[d>>2]|0;if(+h[k>>3]<=+h[(c[d>>2]|0)+64>>3]){s=+h[(c[d>>2]|0)+16>>3]*+Q(+(+h[k>>3]));q=+h[(c[d>>2]|0)+24>>3]*+R(+(+h[k>>3]));t=+h[e+8>>3]+s*+h[(c[d>>2]|0)+48>>3]+q*+h[(c[d>>2]|0)+40>>3];u=c[d>>2]|0;v=u+144|0;w=+h[v>>3];x=t-w;y=c[d>>2]|0;z=y+160|0;h[z>>3]=x;i=b;return}k=c[d>>2]|0;if(+h[e+80>>3]>+h[(c[d>>2]|0)+96>>3]){t=+h[k+80>>3];u=c[d>>2]|0;v=u+144|0;w=+h[v>>3];x=t-w;y=c[d>>2]|0;z=y+160|0;h[z>>3]=x;i=b;return}else{t=+h[k+96>>3];u=c[d>>2]|0;v=u+144|0;w=+h[v>>3];x=t-w;y=c[d>>2]|0;z=y+160|0;h[z>>3]=x;i=b;return}}function vT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+112|0;g=f+100|0;j=f+96|0;k=f+92|0;l=f+16|0;m=f;n=f+88|0;c[g>>2]=b;c[j>>2]=d;c[k>>2]=e;IT(c[g>>2]|0);e=(c[k>>2]|0)+56|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];switch(a[(c[k>>2]|0)+80>>0]|0){case 116:{h[m+8>>3]=+h[(c[k>>2]|0)+56+8>>3]+(+h[(c[k>>2]|0)+40+8>>3]-+JT(c[j>>2]|0))/2.0-1.0;break}case 98:{h[m+8>>3]=+h[(c[k>>2]|0)+56+8>>3]-(+h[(c[k>>2]|0)+40+8>>3]-+JT(c[j>>2]|0))/2.0-1.0;break}default:{}}c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[l+16+4>>2]=c[(c[k>>2]|0)+8>>2];c[l+16>>2]=c[(c[k>>2]|0)+4>>2];h[l+16+16>>3]=+h[(c[k>>2]|0)+16>>3];c[l+56>>2]=yA(c[(c[(c[g>>2]|0)+16>>2]|0)+8>>2]|0,174900)|0;c[l+60>>2]=c[(c[(c[g>>2]|0)+16>>2]|0)+212>>2];a[l+64>>0]=0;if(!((c[l+56>>2]|0)!=0?(a[c[l+56>>2]>>0]|0)!=0:0))c[l+56>>2]=174911;if((a[(c[j>>2]|0)+4>>0]|0)==1){c[n>>2]=c[c[j>>2]>>2];rR(c[g>>2]|0,c[(c[c[g>>2]>>2]|0)+336>>2]|0);k=c[g>>2]|0;if(c[(c[n>>2]|0)+24>>2]|0)oR(k,c[(c[n>>2]|0)+24>>2]|0);else oR(k,174917);KT(c[g>>2]|0,c[n>>2]|0,l)}else LT(c[g>>2]|0,c[c[j>>2]>>2]|0,l);if(!(a[l+64>>0]|0)){o=c[g>>2]|0;MT(o);i=f;return}O4(c[l+60>>2]|0);o=c[g>>2]|0;MT(o);i=f;return}function wT(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[d>>2]>>2]|0);O4(c[(c[d>>2]|0)+4>>2]|0);O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[(c[d>>2]|0)+16>>2]|0);O4(c[(c[d>>2]|0)+12>>2]|0);O4(c[(c[d>>2]|0)+20>>2]|0);O4(c[(c[d>>2]|0)+24>>2]|0);i=b;return}function xT(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;if(!(c[e>>2]|0)){i=d;return}c[f>>2]=c[c[e>>2]>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>=(b[(c[e>>2]|0)+4>>1]|0))break;c[g>>2]=c[c[f>>2]>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(b[(c[f>>2]|0)+4>>1]|0))break;if(c[c[g>>2]>>2]|0)O4(c[c[g>>2]>>2]|0);if((c[(c[g>>2]|0)+8>>2]|0)!=0?(c[(c[g>>2]|0)+12>>2]|0)!=0:0)Bb[c[(c[g>>2]|0)+12>>2]&127](c[(c[g>>2]|0)+8>>2]|0);c[g>>2]=(c[g>>2]|0)+56;c[j>>2]=(c[j>>2]|0)+1}c[f>>2]=(c[f>>2]|0)+24;c[h>>2]=(c[h>>2]|0)+1}if(c[c[e>>2]>>2]|0)O4(c[c[e>>2]>>2]|0);O4(c[e>>2]|0);i=d;return}function yT(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[d>>2]|0)+32>>2]|0);O4(c[d>>2]|0);i=b;return}function zT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;d=c[f>>2]|0;do if((a[(c[f>>2]|0)+4>>0]|0)!=1){b=c[f>>2]|0;if((a[d+4>>0]|0)==3){yT(c[b>>2]|0);break}else{xT(c[b>>2]|0);break}}else NT(c[d>>2]|0);while(0);if(!(c[g>>2]|0)){i=e;return}O4(c[f>>2]|0);i=e;return}function AT(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[n>>2]=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+104>>2]|0)+72>>2];c[o>>2]=0;if((a[(c[n>>2]|0)+4>>0]|0)==2){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}c[m>>2]=OT(c[c[n>>2]>>2]|0,c[k>>2]|0)|0;if(c[m>>2]|0){c[o>>2]=(c[m>>2]|0)+48;c[c[l>>2]>>2]=d[(c[m>>2]|0)+35>>0]}c[h>>2]=c[o>>2];p=c[h>>2]|0;i=g;return p|0}function BT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;i=i+32|0;c[g+16>>2]=a;c[g+12>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;i=g;return 0}function CT(b){b=b|0;var d=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0;d=i;i=i+32|0;f=d+28|0;g=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[f>>2]=b;b=bK((c[(c[f>>2]|0)+100>>2]|0)+1<<2)|0;c[(c[f>>2]|0)+92>>2]=b;b=bK((c[(c[f>>2]|0)+104>>2]|0)+1<<2)|0;c[(c[f>>2]|0)+96>>2]=b;c[j>>2]=c[(c[f>>2]|0)+80+4>>2];while(1){if(!(c[c[j>>2]>>2]|0))break;c[g>>2]=c[c[j>>2]>>2];p=+h[(c[g>>2]|0)+48+16+8>>3];if((e[(c[g>>2]|0)+82>>1]|0)==1)c[l>>2]=~~p;else{q=p-+(_((a[(c[f>>2]|0)+32>>0]|0)-1|0,(e[(c[g>>2]|0)+82>>1]|0)-1|0)|0);c[l>>2]=~~(q/+(e[(c[g>>2]|0)+82>>1]|0));c[l>>2]=(c[l>>2]|0)>1?c[l>>2]|0:1}q=+h[(c[g>>2]|0)+48+16>>3];if((e[(c[g>>2]|0)+80>>1]|0)==1)c[k>>2]=~~q;else{p=q-+(_((a[(c[f>>2]|0)+32>>0]|0)-1|0,(e[(c[g>>2]|0)+80>>1]|0)-1|0)|0);c[k>>2]=~~(p/+(e[(c[g>>2]|0)+80>>1]|0));c[k>>2]=(c[k>>2]|0)>1?c[k>>2]|0:1}c[m>>2]=e[(c[g>>2]|0)+86>>1];while(1){if((c[m>>2]|0)>=((e[(c[g>>2]|0)+86>>1]|0)+(e[(c[g>>2]|0)+82>>1]|0)|0))break;c[o>>2]=c[(c[(c[f>>2]|0)+92>>2]|0)+(c[m>>2]<<2)>>2];c[(c[(c[f>>2]|0)+92>>2]|0)+(c[m>>2]<<2)>>2]=(c[o>>2]|0)>(c[l>>2]|0)?c[o>>2]|0:c[l>>2]|0;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=e[(c[g>>2]|0)+84>>1];while(1){if((c[m>>2]|0)>=((e[(c[g>>2]|0)+84>>1]|0)+(e[(c[g>>2]|0)+80>>1]|0)|0))break;c[n>>2]=c[(c[(c[f>>2]|0)+96>>2]|0)+(c[m>>2]<<2)>>2];c[(c[(c[f>>2]|0)+96>>2]|0)+(c[m>>2]<<2)>>2]=(c[n>>2]|0)>(c[k>>2]|0)?c[n>>2]|0:c[k>>2]|0;c[m>>2]=(c[m>>2]|0)+1}c[j>>2]=(c[j>>2]|0)+4}i=d;return}function DT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=b+4|0;c[f>>2]=a;a=c[f>>2]|0;if((c[f>>2]|0)>>>0<21){c[e>>2]=c[91416+(a<<2)>>2];g=c[e>>2]|0;i=b;return g|0}else{c[d>>2]=a;k3(174923,175023,d)|0;c[e>>2]=174923;g=c[e>>2]|0;i=b;return g|0}return 0}function ET(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[o>>2]=0;c[q>>2]=0;while(1){if((c[q>>2]|0)>(c[(c[g>>2]|0)+104>>2]|0))break;d=c[k>>2]|0;c[n>>2]=fC(d,DT(c[q>>2]|0)|0,1)|0;MC(c[n>>2]|0,175026,304,1)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+172+4>>2]=0;d=bK((c[(c[g>>2]|0)+100>>2]|0)+1<<2)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+172>>2]=d;c[(c[(c[n>>2]|0)+8>>2]|0)+180+4>>2]=0;d=bK((c[(c[g>>2]|0)+100>>2]|0)+1<<2)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+180>>2]=d;d=c[n>>2]|0;if(c[o>>2]|0){c[(c[(c[o>>2]|0)+8>>2]|0)+164>>2]=d;c[o>>2]=c[n>>2]}else{c[(c[(c[k>>2]|0)+8>>2]|0)+192>>2]=d;c[o>>2]=d}c[q>>2]=(c[q>>2]|0)+1}c[o>>2]=0;c[q>>2]=0;while(1){if((c[q>>2]|0)>(c[(c[g>>2]|0)+100>>2]|0))break;d=c[j>>2]|0;c[n>>2]=fC(d,DT(c[q>>2]|0)|0,1)|0;MC(c[n>>2]|0,175026,304,1)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+172+4>>2]=0;d=bK((c[(c[g>>2]|0)+104>>2]|0)+1<<2)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+172>>2]=d;c[(c[(c[n>>2]|0)+8>>2]|0)+180+4>>2]=0;d=bK((c[(c[g>>2]|0)+104>>2]|0)+1<<2)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+180>>2]=d;d=c[n>>2]|0;if(c[o>>2]|0){c[(c[(c[o>>2]|0)+8>>2]|0)+164>>2]=d;c[o>>2]=c[n>>2]}else{c[(c[(c[j>>2]|0)+8>>2]|0)+192>>2]=d;c[o>>2]=d}c[q>>2]=(c[q>>2]|0)+1}c[m>>2]=c[(c[g>>2]|0)+80+4>>2];while(1){if(!(c[c[m>>2]>>2]|0))break;c[l>>2]=c[c[m>>2]>>2];g=c[k>>2]|0;c[n>>2]=fC(g,DT(e[(c[l>>2]|0)+84>>1]|0)|0,0)|0;g=c[k>>2]|0;c[p>>2]=fC(g,DT((e[(c[l>>2]|0)+84>>1]|0)+(e[(c[l>>2]|0)+80>>1]|0)|0)|0,0)|0;PT(c[k>>2]|0,c[n>>2]|0,c[p>>2]|0,~~+h[(c[l>>2]|0)+48+16>>3]);g=c[j>>2]|0;c[n>>2]=fC(g,DT(e[(c[l>>2]|0)+86>>1]|0)|0,0)|0;g=c[j>>2]|0;c[p>>2]=fC(g,DT((e[(c[l>>2]|0)+86>>1]|0)+(e[(c[l>>2]|0)+82>>1]|0)|0)|0,0)|0;PT(c[j>>2]|0,c[n>>2]|0,c[p>>2]|0,~~+h[(c[l>>2]|0)+48+16+8>>3]);c[m>>2]=(c[m>>2]|0)+4}QT(c[k>>2]|0);QT(c[j>>2]|0);i=f;return}function FT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[l>>2]=0;c[k>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+192>>2];c[j>>2]=0;c[k>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2];while(1){if(!(c[k>>2]|0))break;c[(c[(c[f>>2]|0)+92>>2]|0)+(c[j>>2]<<2)>>2]=(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0)-(c[l>>2]|0);c[l>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2];c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2]}c[l>>2]=0;c[k>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+192>>2];c[j>>2]=0;c[k>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2];while(1){if(!(c[k>>2]|0))break;c[(c[(c[f>>2]|0)+96>>2]|0)+(c[j>>2]<<2)>>2]=(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0)-(c[l>>2]|0);c[l>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2];c[j>>2]=(c[j>>2]|0)+1;c[k>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2]}i=e;return}function GT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[h>>2]=c[13066];if((c[(c[e>>2]|0)+100>>2]|0)!=1?(c[(c[e>>2]|0)+104>>2]|0)!=1:0){a=bK((c[(c[e>>2]|0)+100>>2]|0)+1<<2)|0;c[(c[e>>2]|0)+92>>2]=a;a=bK((c[(c[e>>2]|0)+104>>2]|0)+1<<2)|0;c[(c[e>>2]|0)+96>>2]=a;c[d>>2]=c[h>>2];c[f>>2]=gB(175039,d,0)|0;c[d>>2]=c[h>>2];c[g>>2]=gB(175044,d,0)|0;MC(c[f>>2]|0,175049,280,1)|0;MC(c[g>>2]|0,175049,280,1)|0;ET(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0);gK(c[f>>2]|0,2,2147483647)|0;gK(c[g>>2]|0,2,2147483647)|0;FT(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0);RT(c[f>>2]|0,c[g>>2]|0);i=b;return}CT(c[e>>2]|0);i=b;return}function HT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+400|0;f=e+184|0;g=e+256|0;j=e+252|0;k=e+248|0;l=e+244|0;m=e+176|0;n=e+168|0;o=e+136|0;p=e+240|0;q=e+236|0;r=e+64|0;s=e+232|0;t=e+216|0;u=e+264|0;v=e+32|0;w=e;c[j>>2]=b;c[k>>2]=d;c[r+48>>2]=c[j>>2];switch(BC(c[j>>2]|0)|0){case 0:{c[r+52>>2]=c[(c[j>>2]|0)+48>>2];break}case 1:{c[r+52>>2]=qC(c[j>>2]|0)|0;break}case 2:{d=c[j>>2]|0;c[r+52>>2]=qC(c[((c[c[j>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)|0;break}default:{}}c[p>>2]=c[(c[r+52>>2]|0)+48>>2];h[r+16+16>>3]=+h[(c[k>>2]|0)+16>>3];c[r+16>>2]=c[(c[k>>2]|0)+4>>2];c[r+16+4>>2]=c[(c[k>>2]|0)+8>>2];d=r+16+24|0;c[d>>2]=c[d>>2]&-128;c[q>>2]=WV(c[c[k>>2]>>2]|0,l,r)|0;if(!(c[q>>2]|0)){dA(t,128,u);a[(c[k>>2]|0)+82>>0]=0;u=M3(ST(c[j>>2]|0,t)|0)|0;c[c[k>>2]>>2]=u;u=c[c[k>>2]>>2]|0;if((c[(c[k>>2]|0)+12>>2]|0)==1)c[s>>2]=KO(u)|0;else c[s>>2]=JO(u,c[r+52>>2]|0)|0;O4(c[c[k>>2]>>2]|0);c[c[k>>2]>>2]=c[s>>2];RJ(c[(c[(c[p>>2]|0)+8>>2]|0)+144>>2]|0,c[k>>2]|0);hA(t);c[g>>2]=c[l>>2];x=c[g>>2]|0;i=e;return x|0}if((a[(c[q>>2]|0)+4>>0]|0)==1){if((c[(c[c[q>>2]>>2]|0)+24>>2]|0)==0?(TT(c[j>>2]|0)|0)!=0:0){t=M3(TT(c[j>>2]|0)|0)|0;c[(c[c[q>>2]>>2]|0)+24>>2]=t}t=UT(c[p>>2]|0,c[c[q>>2]>>2]|0,0,r)|0;c[l>>2]=c[l>>2]|t;h[m>>3]=+h[(c[c[q>>2]>>2]|0)+48+16>>3]/2.0;h[n>>3]=+h[(c[c[q>>2]>>2]|0)+48+16+8>>3]/2.0;VT(v,-+h[m>>3],-+h[n>>3],+h[m>>3],+h[n>>3]);c[o>>2]=c[v>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];c[o+16>>2]=c[v+16>>2];c[o+20>>2]=c[v+20>>2];c[o+24>>2]=c[v+24>>2];c[o+28>>2]=c[v+28>>2];v=c[c[q>>2]>>2]|0;c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[f+16>>2]=c[o+16>>2];c[f+20>>2]=c[o+20>>2];c[f+24>>2]=c[o+24>>2];c[f+28>>2]=c[o+28>>2];WT(v,f,15);h[(c[k>>2]|0)+24>>3]=+h[o+16>>3]-+h[o>>3];h[(c[k>>2]|0)+24+8>>3]=+h[o+16+8>>3]-+h[o+8>>3]}else{f=XT(c[(c[(c[p>>2]|0)+8>>2]|0)+144>>2]|0,c[c[q>>2]>>2]|0,r)|0;c[l>>2]=c[l>>2]|f;h[m>>3]=+h[(c[c[q>>2]>>2]|0)+8+16>>3]/2.0;h[n>>3]=+h[(c[c[q>>2]>>2]|0)+8+16+8>>3]/2.0;VT(w,-+h[m>>3],-+h[n>>3],+h[m>>3],+h[n>>3]);c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[o+16>>2]=c[w+16>>2];c[o+20>>2]=c[w+20>>2];c[o+24>>2]=c[w+24>>2];c[o+28>>2]=c[w+28>>2];w=(c[c[q>>2]>>2]|0)+8|0;c[w>>2]=c[o>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];c[w+24>>2]=c[o+24>>2];c[w+28>>2]=c[o+28>>2];h[(c[k>>2]|0)+24>>3]=+h[o+16>>3]-+h[o>>3];h[(c[k>>2]|0)+24+8>>3]=+h[o+16+8>>3]-+h[o+8>>3]}c[(c[k>>2]|0)+72>>2]=c[q>>2];if((a[(c[q>>2]|0)+4>>0]|0)==1){O4(c[c[k>>2]>>2]|0);q=M3(179620)|0;c[c[k>>2]>>2]=q}c[g>>2]=c[l>>2];x=c[g>>2]|0;i=e;return x|0}function IT(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=wH(c[e>>2]|0)|0;c[g>>2]=c[c[f>>2]>>2];c[(c[f>>2]|0)+4>>2]=c[(c[g>>2]|0)+4>>2];c[(c[f>>2]|0)+12>>2]=c[(c[g>>2]|0)+12>>2];switch(c[(c[f>>2]|0)+4>>2]|0){case 2:{c[(c[f>>2]|0)+8>>2]=c[(c[g>>2]|0)+8>>2];break}case 0:{c[(c[f>>2]|0)+8>>2]=c[(c[g>>2]|0)+8>>2];break}case 1:{c[(c[f>>2]|0)+8>>2]=c[(c[g>>2]|0)+8>>2];break}case 3:{c[(c[f>>2]|0)+8>>2]=c[(c[g>>2]|0)+8>>2];break}default:{}}c[(c[f>>2]|0)+208>>2]=c[(c[g>>2]|0)+208>>2];c[(c[f>>2]|0)+228>>2]=c[(c[g>>2]|0)+228>>2];c[(c[f>>2]|0)+244>>2]=c[(c[g>>2]|0)+244>>2];e=(c[f>>2]|0)+260|0;b[e>>1]=b[e>>1]&-2|(b[(c[g>>2]|0)+260>>1]<<15&65535)<<16>>16>>15&1;i=d;return}function JT(b){b=b|0;var d=0,e=0,f=0,g=0.0;d=i;i=i+16|0;e=d+8|0;f=d;c[e>>2]=b;h[f>>3]=0.0;switch(a[(c[e>>2]|0)+4>>0]|0){case 1:{h[f>>3]=+h[(c[c[e>>2]>>2]|0)+48+16+8>>3]-+h[(c[c[e>>2]>>2]|0)+48+8>>3];g=+h[f>>3];i=d;return +g}case 3:{h[f>>3]=+h[(c[c[e>>2]>>2]|0)+16+8>>3]-+h[(c[c[e>>2]>>2]|0)+8>>3];g=+h[f>>3];i=d;return +g}case 2:{h[f>>3]=+h[(c[c[e>>2]>>2]|0)+8+16+8>>3]-+h[(c[c[e>>2]>>2]|0)+8+8>>3];g=+h[f>>3];i=d;return +g}default:{g=+h[f>>3];i=d;return +g}}return +(0.0)}function KT(b,f,g){b=b|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+224|0;k=j+112|0;l=j+220|0;m=j+216|0;n=j+212|0;o=j+80|0;p=j+64|0;q=j+208|0;r=j+204|0;s=j+168|0;t=j+164|0;u=j+160|0;v=j;w=j+152|0;x=j+144|0;c[l>>2]=b;c[m>>2]=f;c[n>>2]=g;g=(c[m>>2]|0)+48|0;c[o>>2]=c[g>>2];c[o+4>>2]=c[g+4>>2];c[o+8>>2]=c[g+8>>2];c[o+12>>2]=c[g+12>>2];c[o+16>>2]=c[g+16>>2];c[o+20>>2]=c[g+20>>2];c[o+24>>2]=c[g+24>>2];c[o+28>>2]=c[g+28>>2];g=c[n>>2]|0;c[p>>2]=c[g>>2];c[p+4>>2]=c[g+4>>2];c[p+8>>2]=c[g+8>>2];c[p+12>>2]=c[g+12>>2];c[q>>2]=c[(c[m>>2]|0)+80+4>>2];if(c[c[m>>2]>>2]|0)y=1;else y=(c[(c[m>>2]|0)+8>>2]|0)!=0;c[u>>2]=y&1;if(c[(c[m>>2]|0)+108>>2]|0)$T(c[n>>2]|0,c[(c[m>>2]|0)+108>>2]|0,44024);h[o>>3]=+h[o>>3]+ +h[p>>3];y=o+16|0;h[y>>3]=+h[y>>3]+ +h[p>>3];y=o+8|0;h[y>>3]=+h[y>>3]+ +h[p+8>>3];y=o+16+8|0;h[y>>3]=+h[y>>3]+ +h[p+8>>3];if((c[u>>2]|0)!=0?(c[(c[l>>2]|0)+152>>2]&4|0)==0:0){p=c[l>>2]|0;y=c[n>>2]|0;g=c[m>>2]|0;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];c[k+24>>2]=c[o+24>>2];c[k+28>>2]=c[o+28>>2];c[t>>2]=iU(p,y,g,k,s,1)|0}else c[t>>2]=0;if(!(e[(c[m>>2]|0)+42>>1]&32)){if(c[(c[m>>2]|0)+20>>2]|0){c[x>>2]=jU(c[l>>2]|0,c[(c[m>>2]|0)+20>>2]|0,c[(c[m>>2]|0)+28>>2]|0,e[(c[m>>2]|0)+42>>1]|0,w)|0;g=c[l>>2]|0;if(e[(c[m>>2]|0)+42>>1]&4){y=d[(c[m>>2]|0)+33>>0]|0;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];c[k+24>>2]=c[o+24>>2];c[k+28>>2]=c[o+28>>2];p=kU(v,k,y)|0;cM(g,p,4,4,c[x>>2]|0)}else{p=c[x>>2]|0;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];c[k+24>>2]=c[o+24>>2];c[k+28>>2]=c[o+28>>2];uR(g,k,p)}O4(c[w>>2]|0)}while(1){if(!(c[c[q>>2]>>2]|0))break;lU(c[l>>2]|0,c[c[q>>2]>>2]|0,c[n>>2]|0);c[q>>2]=(c[q>>2]|0)+4}c[q>>2]=c[(c[m>>2]|0)+80+4>>2];zR(c[l>>2]|0,1.0);while(1){w=c[q>>2]|0;c[q>>2]=w+4;p=c[w>>2]|0;c[r>>2]=p;if(!p)break;if(!(a[(c[r>>2]|0)+100>>0]|0))continue;mU(c[l>>2]|0,c[r>>2]|0,c[n>>2]|0,c[(c[m>>2]|0)+24>>2]|0,c[c[q>>2]>>2]|0)}if(a[(c[m>>2]|0)+33>>0]|0){q=c[l>>2]|0;r=c[m>>2]|0;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];c[k+24>>2]=c[o+24>>2];c[k+28>>2]=c[o+28>>2];nU(q,r,k)}}if(c[t>>2]|0)oU(c[l>>2]|0,s,1);if(((c[u>>2]|0)!=0?(c[(c[l>>2]|0)+152>>2]&4|0)!=0:0)?(u=c[l>>2]|0,t=c[n>>2]|0,r=c[m>>2]|0,c[k>>2]=c[o>>2],c[k+4>>2]=c[o+4>>2],c[k+8>>2]=c[o+8>>2],c[k+12>>2]=c[o+12>>2],c[k+16>>2]=c[o+16>>2],c[k+20>>2]=c[o+20>>2],c[k+24>>2]=c[o+24>>2],c[k+28>>2]=c[o+28>>2],(iU(u,t,r,k,s,0)|0)!=0):0)oU(c[l>>2]|0,s,0);if(!(c[(c[m>>2]|0)+108>>2]|0)){i=j;return}bU(c[n>>2]|0,44024);i=j;return}function LT(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;g=i;i=i+128|0;j=g+72|0;k=g+40|0;l=g+24|0;m=g+112|0;n=g+108|0;o=g+104|0;p=g+16|0;q=g;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;if((b[(c[n>>2]|0)+4>>1]|0)<1){i=g;return}h[p>>3]=(+h[(c[n>>2]|0)+8+16>>3]-+h[(c[n>>2]|0)+8>>3])/2.0;h[q>>3]=+h[c[o>>2]>>3]+(+h[(c[n>>2]|0)+8+16>>3]+ +h[(c[n>>2]|0)+8>>3])/2.0;h[q+8>>3]=+h[(c[o>>2]|0)+8>>3]+(+h[(c[n>>2]|0)+8+16+8>>3]+ +h[(c[n>>2]|0)+8+8>>3])/2.0;f=c[m>>2]|0;m=b[(c[n>>2]|0)+4>>1]|0;e=c[c[n>>2]>>2]|0;r=+h[p>>3];p=(c[o>>2]|0)+16|0;o=(c[n>>2]|0)+8|0;d=a[(c[n>>2]|0)+6>>0]|0;c[l>>2]=c[q>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];c[k+16>>2]=c[p+16>>2];c[k+20>>2]=c[p+20>>2];c[k+24>>2]=c[p+24>>2];c[k+28>>2]=c[p+28>>2];c[j>>2]=c[o>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];c[j+16>>2]=c[o+16>>2];c[j+20>>2]=c[o+20>>2];c[j+24>>2]=c[o+24>>2];c[j+28>>2]=c[o+28>>2];hU(f,m,e,l,r,k,j,d);i=g;return}function MT(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+16>>2];c[(c[e>>2]|0)+208>>2]=0;c[(c[e>>2]|0)+228>>2]=0;c[(c[e>>2]|0)+244>>2]=0;c[(c[e>>2]|0)+212>>2]=0;xH(c[d>>2]|0);i=b;return}function NT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=(c[d>>2]|0)+80|0;if((c[(c[d>>2]|0)+100>>2]|0)==-1){Jz(c[a+4>>2]|0)|0;f=c[d>>2]|0;wT(f);g=c[d>>2]|0;O4(g);i=b;return}c[e>>2]=c[a+4>>2];O4(c[(c[d>>2]|0)+92>>2]|0);O4(c[(c[d>>2]|0)+96>>2]|0);while(1){if(!(c[c[e>>2]>>2]|0))break;gU(c[c[e>>2]>>2]|0);c[e>>2]=(c[e>>2]|0)+4}O4(c[(c[d>>2]|0)+80+4>>2]|0);f=c[d>>2]|0;wT(f);g=c[d>>2]|0;O4(g);i=b;return}function OT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;if((c[(c[e>>2]|0)+4>>2]|0)!=0?(F3(c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0)|0)==0:0){c[g>>2]=c[e>>2];k=c[g>>2]|0;i=d;return k|0}c[g>>2]=0;c[h>>2]=c[(c[e>>2]|0)+80+4>>2];while(1){e=c[h>>2]|0;c[h>>2]=e+4;b=c[e>>2]|0;c[j>>2]=b;if(!b){l=7;break}b=fU(c[j>>2]|0,c[f>>2]|0)|0;c[g>>2]=b;if(b){l=7;break}}if((l|0)==7){k=c[g>>2]|0;i=d;return k|0}return 0}function PT(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[j>>2]=a;c[k>>2]=d;c[l>>2]=f;c[m>>2]=g;c[n>>2]=VA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,0,0)|0;if(c[n>>2]|0){if((e[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]|0|0)>(c[m>>2]|0))o=e[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]|0;else o=c[m>>2]|0;b[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]=o;i=h;return}c[n>>2]=VA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,0,1)|0;MC(c[n>>2]|0,175319,176,1)|0;b[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]=c[m>>2];m=(c[(c[k>>2]|0)+8>>2]|0)+180|0;if(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0)p=eK(c[m>>2]|0,(c[(c[(c[k>>2]|0)+8>>2]|0)+180+4>>2]|0)+2<<2)|0;else p=cK((c[m+4>>2]|0)+2<<2)|0;c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]=p;p=c[n>>2]|0;m=(c[(c[k>>2]|0)+8>>2]|0)+180+4|0;j=c[m>>2]|0;c[m>>2]=j+1;c[(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0)+(j<<2)>>2]=p;c[(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+180+4>>2]<<2)>>2]=0;k=(c[(c[l>>2]|0)+8>>2]|0)+172|0;if(c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]|0)q=eK(c[k>>2]|0,(c[(c[(c[l>>2]|0)+8>>2]|0)+172+4>>2]|0)+2<<2)|0;else q=cK((c[k+4>>2]|0)+2<<2)|0;c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]=q;q=c[n>>2]|0;n=(c[(c[l>>2]|0)+8>>2]|0)+172+4|0;k=c[n>>2]|0;c[n>>2]=k+1;c[(c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]|0)+(k<<2)>>2]=q;c[(c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]|0)+(c[(c[(c[l>>2]|0)+8>>2]|0)+172+4>>2]<<2)>>2]=0;i=h;return}function QT(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];c[g>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2];while(1){if(!(c[g>>2]|0))break;if(!(VA(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0,0,0)|0)){c[h>>2]=VA(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0,0,1)|0;MC(c[h>>2]|0,175319,176,1)|0;b[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]=0;a=(c[(c[f>>2]|0)+8>>2]|0)+180|0;if(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0)j=eK(c[a>>2]|0,(c[(c[(c[f>>2]|0)+8>>2]|0)+180+4>>2]|0)+2<<2)|0;else j=cK((c[a+4>>2]|0)+2<<2)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]=j;a=c[h>>2]|0;k=(c[(c[f>>2]|0)+8>>2]|0)+180+4|0;l=c[k>>2]|0;c[k>>2]=l+1;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0)+(l<<2)>>2]=a;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+180+4>>2]<<2)>>2]=0;a=(c[(c[g>>2]|0)+8>>2]|0)+172|0;if(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)m=eK(c[a>>2]|0,(c[(c[(c[g>>2]|0)+8>>2]|0)+172+4>>2]|0)+2<<2)|0;else m=cK((c[a+4>>2]|0)+2<<2)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]=m;a=c[h>>2]|0;l=(c[(c[g>>2]|0)+8>>2]|0)+172+4|0;k=c[l>>2]|0;c[l>>2]=k+1;c[(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)+(k<<2)>>2]=a;c[(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)+(c[(c[(c[g>>2]|0)+8>>2]|0)+172+4>>2]<<2)>>2]=0}c[f>>2]=c[g>>2];c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}i=d;return}function RT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;if(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)O4(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0);if(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0)O4(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0);c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}jB(c[e>>2]|0)|0;jB(c[f>>2]|0)|0;i=d;return}function ST(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=d;a:do switch(BC(c[f>>2]|0)|0){case 0:{gA(c[g>>2]|0,wB(c[f>>2]|0)|0)|0;break}case 1:{gA(c[g>>2]|0,wB(c[f>>2]|0)|0)|0;break}case 2:{c[h>>2]=c[f>>2];d=c[h>>2]|0;gA(c[g>>2]|0,wB(c[((c[c[h>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)|0)|0;d=c[h>>2]|0;gA(c[g>>2]|0,wB(c[((c[c[h>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)|0)|0;d=c[h>>2]|0;b=(nB(qC(c[((c[c[h>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)|0)|0)!=0;d=c[g>>2]|0;if(b){gA(d,175316)|0;break a}else{gA(d,178535)|0;break a}break}default:{}}while(0);if((c[(c[g>>2]|0)+4>>2]|0)>>>0<(c[(c[g>>2]|0)+8>>2]|0)>>>0){j=c[g>>2]|0;k=j+4|0;l=c[k>>2]|0;m=l+1|0;c[k>>2]=m;a[l>>0]=0;n=c[g>>2]|0;o=c[n>>2]|0;p=c[g>>2]|0;q=p+4|0;c[q>>2]=o;i=e;return o|0}eA(c[g>>2]|0,1)|0;j=c[g>>2]|0;k=j+4|0;l=c[k>>2]|0;m=l+1|0;c[k>>2]=m;a[l>>0]=0;n=c[g>>2]|0;o=c[n>>2]|0;p=c[g>>2]|0;q=p+4|0;c[q>>2]=o;i=e;return o|0}function TT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;b=yA(c[f>>2]|0,175307)|0;c[g>>2]=b;if((b|0)!=0?(a[c[g>>2]>>0]|0)!=0:0){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}b=yA(c[f>>2]|0,178832)|0;c[g>>2]=b;if((b|0)!=0?(a[c[g>>2]>>0]|0)!=0:0){c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function UT(b,f,g,j){b=b|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+48|0;l=k+8|0;m=k;n=k+40|0;o=k+36|0;p=k+32|0;q=k+28|0;r=k+24|0;s=k+20|0;t=k+16|0;u=k+12|0;c[n>>2]=b;c[o>>2]=f;c[p>>2]=g;c[q>>2]=j;c[u>>2]=0;if(c[(c[o>>2]|0)+108>>2]|0)$T(c[q>>2]|0,c[(c[o>>2]|0)+108>>2]|0,43992);c[(c[o>>2]|0)+80>>2]=c[p>>2];c[u>>2]=aU(c[n>>2]|0,c[o>>2]|0,c[q>>2]|0)|0;if(!(e[(c[o>>2]|0)+36>>1]&128))a[(c[o>>2]|0)+32>>0]=2;if(!(e[(c[o>>2]|0)+36>>1]&32))a[(c[o>>2]|0)+33>>0]=1;GT(c[o>>2]|0);n=_((c[(c[o>>2]|0)+104>>2]|0)+1|0,a[(c[o>>2]|0)+32>>0]|0)|0;c[s>>2]=n+(d[(c[o>>2]|0)+33>>0]<<1);n=_((c[(c[o>>2]|0)+100>>2]|0)+1|0,a[(c[o>>2]|0)+32>>0]|0)|0;c[t>>2]=n+(d[(c[o>>2]|0)+33>>0]<<1);c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[(c[o>>2]|0)+104>>2]|0))break;c[s>>2]=(c[s>>2]|0)+(c[(c[(c[o>>2]|0)+96>>2]|0)+(c[r>>2]<<2)>>2]|0);c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[(c[o>>2]|0)+100>>2]|0))break;c[t>>2]=(c[t>>2]|0)+(c[(c[(c[o>>2]|0)+92>>2]|0)+(c[r>>2]<<2)>>2]|0);c[r>>2]=(c[r>>2]|0)+1}do if(e[(c[o>>2]|0)+36>>1]&1){if((e[(c[o>>2]|0)+38>>1]|0)!=0?(e[(c[o>>2]|0)+40>>1]|0)!=0:0){if(!((e[(c[o>>2]|0)+38>>1]|0)>=(c[s>>2]|0)?(e[(c[o>>2]|0)+40>>1]|0)>=(c[t>>2]|0):0)){$z(0,175107,m)|0;c[u>>2]=1}c[t>>2]=0;c[s>>2]=0;break}$z(0,175141,l)|0;c[u>>2]=1}while(0);if((c[s>>2]|0)>(e[(c[o>>2]|0)+38>>1]|0))v=c[s>>2]|0;else v=e[(c[o>>2]|0)+38>>1]|0;h[(c[o>>2]|0)+48+16>>3]=+(v|0);if((c[t>>2]|0)>(e[(c[o>>2]|0)+40>>1]|0))w=c[t>>2]|0;else w=e[(c[o>>2]|0)+40>>1]|0;h[(c[o>>2]|0)+48+16+8>>3]=+(w|0);if(!(c[(c[o>>2]|0)+108>>2]|0)){x=c[u>>2]|0;i=k;return x|0}bU(c[q>>2]|0,43992);x=c[u>>2]|0;i=k;return x|0}function VT(a,b,d,e,f){a=a|0;b=+b;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+64|0;j=g+56|0;k=g+48|0;l=g+40|0;m=g+32|0;n=g;h[j>>3]=b;h[k>>3]=d;h[l>>3]=e;h[m>>3]=f;h[n>>3]=+h[j>>3];h[n+8>>3]=+h[k>>3];h[n+16>>3]=+h[l>>3];h[n+16+8>>3]=+h[m>>3];c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];c[a+16>>2]=c[n+16>>2];c[a+20>>2]=c[n+20>>2];c[a+24>>2]=c[n+24>>2];c[a+28>>2]=c[n+28>>2];i=g;return}function WT(b,f,g){b=b|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0;j=i;i=i+128|0;k=j+32|0;l=j+112|0;m=j+108|0;n=j+104|0;o=j+100|0;p=j+96|0;q=j+92|0;r=j+88|0;s=j+84|0;t=j+80|0;u=j+76|0;v=j+72|0;w=j+68|0;x=j;y=j+64|0;c[l>>2]=b;c[m>>2]=g;c[v>>2]=c[(c[l>>2]|0)+80+4>>2];if(((c[(c[l>>2]|0)+80>>2]|0)!=0?(c[(c[(c[l>>2]|0)+80>>2]|0)+24>>2]|0)!=0:0)?(c[(c[l>>2]|0)+24>>2]|0)==0:0){g=M3(c[(c[(c[l>>2]|0)+80>>2]|0)+24>>2]|0)|0;c[(c[l>>2]|0)+24>>2]=g}c[r>>2]=~~+h[(c[l>>2]|0)+48+16>>3];c[p>>2]=~~(+h[f+16>>3]-+h[f>>3]-+(c[r>>2]|0));if((c[p>>2]|0)<0)La(175062,175072,1765,175084);c[r>>2]=~~+h[(c[l>>2]|0)+48+16+8>>3];c[q>>2]=~~(+h[f+16+8>>3]-+h[f+8>>3]-+(c[r>>2]|0));if((c[q>>2]|0)<0)La(175097,175072,1768,175084);if(e[(c[l>>2]|0)+36>>1]&1){if((c[p>>2]|0)>0){switch(e[(c[l>>2]|0)+36>>1]&6|0){case 4:{h[f+16>>3]=+h[f>>3]+ +(c[r>>2]|0);break}case 2:{g=f+16|0;h[g>>3]=+h[g>>3]+ +(c[p>>2]|0);h[f>>3]=+h[f>>3]+ +(c[p>>2]|0);break}default:{h[f>>3]=+h[f>>3]+ +((c[p>>2]|0)/2|0|0);g=f+16|0;h[g>>3]=+h[g>>3]-+((c[p>>2]|0)/2|0|0)}}c[p>>2]=0}if((c[q>>2]|0)>0){switch(e[(c[l>>2]|0)+36>>1]&24|0){case 16:{h[f+16+8>>3]=+h[f+8>>3]+ +(c[r>>2]|0);break}case 8:{r=f+16+8|0;h[r>>3]=+h[r>>3]+ +(c[q>>2]|0);r=f+8|0;h[r>>3]=+h[r>>3]+ +(c[q>>2]|0);break}default:{r=f+8|0;h[r>>3]=+h[r>>3]+ +((c[q>>2]|0)/2|0|0);r=f+16+8|0;h[r>>3]=+h[r>>3]-+((c[q>>2]|0)/2|0|0)}}c[q>>2]=0}}c[n>>2]=~~(+h[f>>3]+ +(d[(c[l>>2]|0)+33>>0]|0)+ +(a[(c[l>>2]|0)+32>>0]|0));c[t>>2]=(c[p>>2]|0)/(c[(c[l>>2]|0)+104>>2]|0)|0;r=((c[p>>2]|0)-(_(c[t>>2]|0,c[(c[l>>2]|0)+104>>2]|0)|0)|0)>=0;z=+((c[p>>2]|0)-(_(c[t>>2]|0,c[(c[l>>2]|0)+104>>2]|0)|0)|0);c[u>>2]=~~(r?z+.5:z-.5);c[s>>2]=0;while(1){if((c[s>>2]|0)>(c[(c[l>>2]|0)+104>>2]|0))break;c[p>>2]=(c[(c[(c[l>>2]|0)+96>>2]|0)+(c[s>>2]<<2)>>2]|0)+(c[t>>2]|0)+((c[s>>2]|0)<(c[u>>2]|0)?1:0);c[(c[(c[l>>2]|0)+96>>2]|0)+(c[s>>2]<<2)>>2]=c[n>>2];c[n>>2]=(c[n>>2]|0)+((c[p>>2]|0)+(a[(c[l>>2]|0)+32>>0]|0));c[s>>2]=(c[s>>2]|0)+1}c[o>>2]=~~(+h[f+16+8>>3]-+(d[(c[l>>2]|0)+33>>0]|0)-+(a[(c[l>>2]|0)+32>>0]|0));c[t>>2]=(c[q>>2]|0)/(c[(c[l>>2]|0)+100>>2]|0)|0;p=((c[q>>2]|0)-(_(c[t>>2]|0,c[(c[l>>2]|0)+100>>2]|0)|0)|0)>=0;z=+((c[q>>2]|0)-(_(c[t>>2]|0,c[(c[l>>2]|0)+100>>2]|0)|0)|0);c[u>>2]=~~(p?z+.5:z-.5);c[s>>2]=0;while(1){if((c[s>>2]|0)>(c[(c[l>>2]|0)+100>>2]|0))break;c[q>>2]=(c[(c[(c[l>>2]|0)+92>>2]|0)+(c[s>>2]<<2)>>2]|0)+(c[t>>2]|0)+((c[s>>2]|0)<(c[u>>2]|0)?1:0);c[(c[(c[l>>2]|0)+92>>2]|0)+(c[s>>2]<<2)>>2]=c[o>>2];c[o>>2]=(c[o>>2]|0)-((c[q>>2]|0)+(a[(c[l>>2]|0)+32>>0]|0));c[s>>2]=(c[s>>2]|0)+1}while(1){s=c[v>>2]|0;c[v>>2]=s+4;q=c[s>>2]|0;c[w>>2]=q;if(!q)break;c[y>>2]=0;if(c[m>>2]|0){if(!(e[(c[w>>2]|0)+84>>1]|0))c[y>>2]=c[y>>2]|8;if(!(e[(c[w>>2]|0)+86>>1]|0))c[y>>2]=c[y>>2]|4;if(((e[(c[w>>2]|0)+84>>1]|0)+(e[(c[w>>2]|0)+80>>1]|0)|0)==(c[(c[l>>2]|0)+104>>2]|0))c[y>>2]=c[y>>2]|2;if(((e[(c[w>>2]|0)+86>>1]|0)+(e[(c[w>>2]|0)+82>>1]|0)|0)==(c[(c[l>>2]|0)+100>>2]|0))c[y>>2]=c[y>>2]|1}h[x>>3]=+(c[(c[(c[l>>2]|0)+96>>2]|0)+(e[(c[w>>2]|0)+84>>1]<<2)>>2]|0);h[x+16>>3]=+((c[(c[(c[l>>2]|0)+96>>2]|0)+((e[(c[w>>2]|0)+84>>1]|0)+(e[(c[w>>2]|0)+80>>1]|0)<<2)>>2]|0)-(a[(c[l>>2]|0)+32>>0]|0)|0);h[x+16+8>>3]=+(c[(c[(c[l>>2]|0)+92>>2]|0)+(e[(c[w>>2]|0)+86>>1]<<2)>>2]|0);h[x+8>>3]=+((c[(c[(c[l>>2]|0)+92>>2]|0)+((e[(c[w>>2]|0)+86>>1]|0)+(e[(c[w>>2]|0)+82>>1]|0)<<2)>>2]|0)+(a[(c[l>>2]|0)+32>>0]|0)|0);q=c[w>>2]|0;s=c[m>>2]&c[y>>2];c[k>>2]=c[x>>2];c[k+4>>2]=c[x+4>>2];c[k+8>>2]=c[x+8>>2];c[k+12>>2]=c[x+12>>2];c[k+16>>2]=c[x+16>>2];c[k+20>>2]=c[x+20>>2];c[k+24>>2]=c[x+24>>2];c[k+28>>2]=c[x+28>>2];YT(q,k,s)}a[(c[l>>2]|0)+35>>0]=c[m>>2];m=(c[l>>2]|0)+48|0;c[m>>2]=c[f>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];c[m+16>>2]=c[f+16>>2];c[m+20>>2]=c[f+20>>2];c[m+24>>2]=c[f+24>>2];c[m+28>>2]=c[f+28>>2];i=j;return}function XT(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;g=i;i=i+224|0;j=g+216|0;k=g+212|0;l=g+208|0;m=g+184|0;n=g+176|0;o=g+168|0;p=g+160|0;q=g+152|0;r=g+136|0;s=g+204|0;t=g+200|0;u=g+128|0;v=g+72|0;w=g+40|0;x=g+32|0;y=g+24|0;z=g+196|0;A=g+16|0;B=g+192|0;C=g;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;h[m>>3]=0.0;h[n>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[w+16>>2]=0;c[w+20>>2]=0;c[w+24>>2]=0;c[w+28>>2]=0;c[z>>2]=1;h[A>>3]=-1.0;c[B>>2]=0;c[s>>2]=0;a:while(1){if((c[s>>2]|0)>=(b[(c[k>>2]|0)+4>>1]|0))break;if((b[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)+4>>1]|0)>1){D=4;break}do if(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+4>>2]|0){if(c[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+4>>2]|0)+24>>2]&127){D=7;break a}if(+h[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+4>>2]|0)+16>>3]>0.0)h[w+16>>3]=+h[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+4>>2]|0)+16>>3];else h[w+16>>3]=+h[(c[l>>2]|0)+16+16>>3];if(c[c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+4>>2]>>2]|0){c[w>>2]=c[c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+4>>2]>>2];break}else{c[w>>2]=c[(c[l>>2]|0)+16>>2];break}}else{h[w+16>>3]=+h[(c[l>>2]|0)+16+16>>3];c[w>>2]=c[(c[l>>2]|0)+16>>2]}while(0);E=+h[w+16>>3];if(!(+h[A>>3]==-1.0)){if(E!=+h[A>>3]){D=18;break}}else h[A>>3]=E;f=c[w>>2]|0;if(c[B>>2]|0){if(J3(f,c[B>>2]|0)|0){D=22;break}}else c[B>>2]=f;c[s>>2]=(c[s>>2]|0)+1}if((D|0)==4)c[z>>2]=0;else if((D|0)==7)c[z>>2]=0;else if((D|0)==18)c[z>>2]=0;else if((D|0)==22)c[z>>2]=0;a[(c[k>>2]|0)+6>>0]=c[z>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>=(b[(c[k>>2]|0)+4>>1]|0))break;h[u>>3]=0.0;h[p>>3]=0.0;h[x>>3]=0.0;h[y>>3]=0.0;c[t>>2]=0;while(1){if((c[t>>2]|0)>=(b[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)+4>>1]|0))break;c[v>>2]=WJ(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)>>2]|0,c[(c[l>>2]|0)+48>>2]|0)|0;do if(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]|0){do if(!(c[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]|0)+24>>2]&127))if((c[(c[l>>2]|0)+16+24>>2]&127|0)>0){D=w+24|0;c[D>>2]=c[D>>2]&-128|c[(c[l>>2]|0)+16+24>>2]&127;break}else{D=w+24|0;c[D>>2]=c[D>>2]&-128;break}else{D=w+24|0;c[D>>2]=c[D>>2]&-128|c[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]|0)+24>>2]&127}while(0);if(+h[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]|0)+16>>3]>0.0)h[w+16>>3]=+h[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]|0)+16>>3];else h[w+16>>3]=+h[(c[l>>2]|0)+16+16>>3];if(c[c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]>>2]|0)c[w>>2]=c[c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]>>2];else c[w>>2]=c[(c[l>>2]|0)+16>>2];if(c[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]|0)+4>>2]|0){c[w+4>>2]=c[(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]|0)+4>>2];break}else{c[w+4>>2]=c[(c[l>>2]|0)+16+4>>2];break}}else{h[w+16>>3]=+h[(c[l>>2]|0)+16+16>>3];c[w>>2]=c[(c[l>>2]|0)+16>>2];c[w+4>>2]=c[(c[l>>2]|0)+16+4>>2];D=w+24|0;c[D>>2]=c[D>>2]&-128|c[(c[l>>2]|0)+16+24>>2]&127}while(0);c[v+4>>2]=Hb[c[c[(c[j>>2]|0)+144>>2]>>2]&63](c[(c[j>>2]|0)+144>>2]|0,w,1)|0;SN(C,c[j>>2]|0,v);c[r>>2]=c[C>>2];c[r+4>>2]=c[C+4>>2];c[r+8>>2]=c[C+8>>2];c[r+12>>2]=c[C+12>>2];O4(c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)>>2]|0);c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)>>2]=c[v>>2];h[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+32>>3]=+h[r>>3];h[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+16>>3]=+h[v+16>>3];h[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+24>>3]=+h[v+24>>3];c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+4>>2]=c[v+4>>2];c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+8>>2]=c[v+8>>2];c[(c[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)>>2]|0)+((c[t>>2]|0)*56|0)+12>>2]=c[v+12>>2];h[u>>3]=+h[u>>3]+ +h[r>>3];h[p>>3]=+h[w+16>>3]>+h[p>>3]?+h[w+16>>3]:+h[p>>3];h[y>>3]=+h[r+8>>3]>+h[y>>3]?+h[r+8>>3]:+h[y>>3];h[x>>3]=+h[v+24>>3]>+h[x>>3]?+h[v+24>>3]:+h[x>>3];c[t>>2]=(c[t>>2]|0)+1}h[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)+8>>3]=+h[u>>3];do if(c[z>>2]|0){h[o>>3]=+h[y>>3];if(!(c[s>>2]|0)){h[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)+16>>3]=+h[p>>3];break}else{h[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)+16>>3]=+h[y>>3];break}}else{h[o>>3]=+h[p>>3];E=+h[p>>3];if(!(c[s>>2]|0)){h[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)+16>>3]=E-+h[x>>3];break}else{h[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)+16>>3]=E+ +h[n>>3]-+h[q>>3]-+h[x>>3];break}}while(0);h[q>>3]=+h[q>>3]+ +h[(c[c[k>>2]>>2]|0)+((c[s>>2]|0)*24|0)+16>>3];h[m>>3]=+h[u>>3]>+h[m>>3]?+h[u>>3]:+h[m>>3];h[n>>3]=+h[n>>3]+ +h[o>>3];c[s>>2]=(c[s>>2]|0)+1}h[(c[k>>2]|0)+8+16>>3]=+h[m>>3];if((b[(c[k>>2]|0)+4>>1]|0)==1){h[(c[k>>2]|0)+8+16+8>>3]=+h[y>>3];i=g;return 0}else{h[(c[k>>2]|0)+8+16+8>>3]=+h[n>>3];i=g;return 0}return 0}function YT(b,f,g){b=b|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+112|0;k=j+64|0;l=j+104|0;m=j+100|0;n=j+56|0;o=j+48|0;p=j+32|0;q=j;r=j+108|0;s=j+96|0;c[l>>2]=b;c[m>>2]=g;if((c[(c[l>>2]|0)+24>>2]|0)==0?(c[(c[(c[l>>2]|0)+96>>2]|0)+24>>2]|0)!=0:0){g=M3(c[(c[(c[l>>2]|0)+96>>2]|0)+24>>2]|0)|0;c[(c[l>>2]|0)+24>>2]=g}a:do if(e[(c[l>>2]|0)+36>>1]&1){g=(c[l>>2]|0)+48+16|0;c[p>>2]=c[g>>2];c[p+4>>2]=c[g+4>>2];c[p+8>>2]=c[g+8>>2];c[p+12>>2]=c[g+12>>2];h[n>>3]=+h[f+16>>3]-+h[f>>3]-+h[p>>3];b:do if(+h[n>>3]>0.0)switch(e[(c[l>>2]|0)+36>>1]&6|0){case 4:{h[f+16>>3]=+h[f>>3]+ +h[p>>3];break b;break}case 2:{g=f+16|0;h[g>>3]=+h[g>>3]+ +h[n>>3];h[f>>3]=+h[f>>3]+ +h[n>>3];break b;break}default:{h[f>>3]=+h[f>>3]+ +h[n>>3]/2.0;g=f+16|0;h[g>>3]=+h[g>>3]-+h[n>>3]/2.0;break b}}while(0);h[o>>3]=+h[f+16+8>>3]-+h[f+8>>3]-+h[p+8>>3];if(+h[o>>3]>0.0)switch(e[(c[l>>2]|0)+36>>1]&24|0){case 16:{h[f+16+8>>3]=+h[f+8>>3]+ +h[p+8>>3];break a;break}case 8:{g=f+16+8|0;h[g>>3]=+h[g>>3]+ +h[o>>3];g=f+8|0;h[g>>3]=+h[g>>3]+ +h[o>>3];break a;break}default:{g=f+8|0;h[g>>3]=+h[g>>3]+ +h[o>>3]/2.0;g=f+16+8|0;h[g>>3]=+h[g>>3]-+h[o>>3]/2.0;break a}}}while(0);g=(c[l>>2]|0)+48|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];c[g+16>>2]=c[f+16>>2];c[g+20>>2]=c[f+20>>2];c[g+24>>2]=c[f+24>>2];c[g+28>>2]=c[f+28>>2];a[(c[l>>2]|0)+35>>0]=c[m>>2];h[q>>3]=+h[f>>3]+ +(d[(c[l>>2]|0)+33>>0]|0)+ +(d[(c[l>>2]|0)+34>>0]|0);h[q+8>>3]=+h[f+8>>3]+ +(d[(c[l>>2]|0)+33>>0]|0)+ +(d[(c[l>>2]|0)+34>>0]|0);h[q+16>>3]=+h[f+16>>3]-+(d[(c[l>>2]|0)+33>>0]|0)-+(d[(c[l>>2]|0)+34>>0]|0);h[q+16+8>>3]=+h[f+16+8>>3]-+(d[(c[l>>2]|0)+33>>0]|0)-+(d[(c[l>>2]|0)+34>>0]|0);f=(c[l>>2]|0)+88|0;if((a[(c[l>>2]|0)+88+4>>0]|0)==1){g=c[f>>2]|0;b=c[m>>2]|0;c[k>>2]=c[q>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];c[k+16>>2]=c[q+16>>2];c[k+20>>2]=c[q+20>>2];c[k+24>>2]=c[q+24>>2];c[k+28>>2]=c[q+28>>2];WT(g,k,b);i=j;return}b=(c[l>>2]|0)+88|0;if((a[f+4>>0]|0)==3){f=(c[b>>2]|0)+16|0;c[p>>2]=c[f>>2];c[p+4>>2]=c[f+4>>2];c[p+8>>2]=c[f+8>>2];c[p+12>>2]=c[f+12>>2];h[n>>3]=+h[q+16>>3]-+h[q>>3]-+h[p>>3];c:do if(+h[n>>3]>0.0)switch(e[(c[l>>2]|0)+36>>1]&6|0){case 4:{f=q+16|0;h[f>>3]=+h[f>>3]-+h[n>>3];break c;break}case 2:{h[q>>3]=+h[q>>3]+ +h[n>>3];break c;break}default:break c}while(0);h[o>>3]=+h[q+16+8>>3]-+h[q+8>>3]-+h[p+8>>3];d:do if(+h[o>>3]>0.0)switch(e[(c[l>>2]|0)+36>>1]&24|0){case 16:{f=q+16+8|0;h[f>>3]=+h[f>>3]-+h[o>>3];break d;break}case 8:{f=q+8|0;h[f>>3]=+h[f>>3]+ +h[o>>3];break d;break}default:break d}while(0);f=c[(c[l>>2]|0)+88>>2]|0;c[k>>2]=c[q>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];c[k+16>>2]=c[q+16>>2];c[k+20>>2]=c[q+20>>2];c[k+24>>2]=c[q+24>>2];c[k+28>>2]=c[q+28>>2];ZT(f,k);i=j;return}k=(c[b>>2]|0)+8+16|0;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[p+8>>2]=c[k+8>>2];c[p+12>>2]=c[k+12>>2];h[n>>3]=+h[q+16>>3]-+h[q>>3]-+h[p>>3];e:do if(+h[n>>3]>0.0?(k=e[(c[l>>2]|0)+36>>1]&6,c[s>>2]=k,(k|0)!=6):0)switch(c[s>>2]|0){case 4:{k=q+16|0;h[k>>3]=+h[k>>3]-+h[n>>3];break e;break}case 2:{h[q>>3]=+h[q>>3]+ +h[n>>3];break e;break}default:{h[q>>3]=+h[q>>3]+ +h[n>>3]/2.0;k=q+16|0;h[k>>3]=+h[k>>3]-+h[n>>3]/2.0;break e}}while(0);h[o>>3]=+h[q+16+8>>3]-+h[q+8>>3]-+h[p+8>>3];f:do if(+h[o>>3]>0.0)switch(e[(c[l>>2]|0)+36>>1]&24|0){case 16:{p=q+16+8|0;h[p>>3]=+h[p>>3]-+h[o>>3];break f;break}case 8:{p=q+8|0;h[p>>3]=+h[p>>3]+ +h[o>>3];break f;break}default:{p=q+8|0;h[p>>3]=+h[p>>3]+ +h[o>>3]/2.0;p=q+16+8|0;h[p>>3]=+h[p>>3]-+h[o>>3]/2.0;break f}}while(0);o=(c[(c[l>>2]|0)+88>>2]|0)+8|0;c[o>>2]=c[q>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[o+12>>2]=c[q+12>>2];c[o+16>>2]=c[q+16>>2];c[o+20>>2]=c[q+20>>2];c[o+24>>2]=c[q+24>>2];c[o+28>>2]=c[q+28>>2];switch(e[(c[l>>2]|0)+36>>1]&768|0){case 512:{a[r>>0]=108;break}case 256:{a[r>>0]=114;break}default:a[r>>0]=110}_T(c[(c[l>>2]|0)+88>>2]|0,a[r>>0]|0);i=j;return}function ZT(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=a;a=c[e>>2]|0;c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];i=d;return}function _T(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f+8|0;j=f;c[g>>2]=d;a[h>>0]=e;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(b[(c[g>>2]|0)+4>>1]|0))break;if(!(a[(c[c[g>>2]>>2]|0)+((c[j>>2]|0)*24|0)+6>>0]|0))a[(c[c[g>>2]>>2]|0)+((c[j>>2]|0)*24|0)+6>>0]=a[h>>0]|0;c[j>>2]=(c[j>>2]|0)+1}i=f;return}function $T(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;do if(c[(c[f>>2]|0)+16>>2]|0)if(c[c[g>>2]>>2]|0){c[c[j>>2]>>2]=c[(c[f>>2]|0)+16>>2];c[(c[f>>2]|0)+16>>2]=c[c[g>>2]>>2];break}else{c[c[j>>2]>>2]=0;break}while(0);do if(c[(c[f>>2]|0)+16+4>>2]|0)if(c[(c[g>>2]|0)+4>>2]|0){c[(c[j>>2]|0)+4>>2]=c[(c[f>>2]|0)+16+4>>2];c[(c[f>>2]|0)+16+4>>2]=c[(c[g>>2]|0)+4>>2];break}else{c[(c[j>>2]|0)+4>>2]=0;break}while(0);if(!(+h[(c[f>>2]|0)+16+16>>3]>=0.0)){i=e;return}if(+h[(c[g>>2]|0)+16>>3]>=0.0){h[(c[j>>2]|0)+16>>3]=+h[(c[f>>2]|0)+16+16>>3];h[(c[f>>2]|0)+16+16>>3]=+h[(c[g>>2]|0)+16>>3];i=e;return}else{h[(c[j>>2]|0)+16>>3]=-1.0;i=e;return}}function aU(f,g,h){f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+80|0;k=j+64|0;l=j+60|0;m=j+56|0;n=j+52|0;o=j+48|0;p=j+44|0;q=j+40|0;r=j+36|0;s=j+32|0;t=j+28|0;u=j+24|0;v=j+20|0;w=j+16|0;x=j+12|0;y=j+8|0;z=j+4|0;A=j;c[k>>2]=f;c[l>>2]=g;c[m>>2]=h;c[v>>2]=c[(c[l>>2]|0)+80+4>>2];c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;c[z>>2]=VK()|0;c[A>>2]=rU()|0;c[n>>2]=Lz(c[v>>2]|0)|0;c[s>>2]=0;c[q>>2]=0;while(1){if(!(c[n>>2]|0))break;c[p>>2]=c[(c[n>>2]|0)+8>>2];c[o>>2]=Lz(c[p>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;c[t>>2]=c[(c[o>>2]|0)+8>>2];c[s>>2]=(c[s>>2]|0)+1;c[o>>2]=c[c[o>>2]>>2]}if(a[(c[n>>2]|0)+12>>0]|0)sU(c[A>>2]|0,(c[q>>2]|0)+1|0);c[n>>2]=c[c[n>>2]>>2];c[q>>2]=(c[q>>2]|0)+1}h=bK((c[s>>2]|0)+1<<2)|0;c[(c[l>>2]|0)+80+4>>2]=h;c[u>>2]=h;c[n>>2]=Lz(c[v>>2]|0)|0;c[q>>2]=0;while(1){if(!(c[n>>2]|0))break;c[p>>2]=c[(c[n>>2]|0)+8>>2];c[o>>2]=Lz(c[p>>2]|0)|0;c[r>>2]=0;while(1){if(!(c[o>>2]|0))break;c[t>>2]=c[(c[o>>2]|0)+8>>2];h=c[t>>2]|0;s=c[u>>2]|0;c[u>>2]=s+4;c[s>>2]=h;h=cU(c[k>>2]|0,c[t>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;c[w>>2]=c[w>>2]|h;c[r>>2]=dU(c[z>>2]|0,c[q>>2]|0,c[r>>2]|0,c[t>>2]|0)|0;b[(c[t>>2]|0)+86>>1]=c[q>>2];b[(c[t>>2]|0)+84>>1]=c[r>>2];c[r>>2]=(c[r>>2]|0)+(e[(c[t>>2]|0)+80>>1]|0);c[y>>2]=(c[r>>2]|0)>(c[y>>2]|0)?c[r>>2]|0:c[y>>2]|0;if(((c[q>>2]|0)+(e[(c[t>>2]|0)+82>>1]|0)|0)>(c[x>>2]|0))B=(c[q>>2]|0)+(e[(c[t>>2]|0)+82>>1]|0)|0;else B=c[x>>2]|0;c[x>>2]=B;if(tU(c[A>>2]|0,(c[q>>2]|0)+(e[(c[t>>2]|0)+82>>1]|0)|0)|0){h=(c[t>>2]|0)+100|0;a[h>>0]=d[h>>0]|2}c[o>>2]=c[c[o>>2]>>2]}c[n>>2]=c[c[n>>2]>>2];c[q>>2]=(c[q>>2]|0)+1}c[(c[l>>2]|0)+100>>2]=c[x>>2];c[(c[l>>2]|0)+104>>2]=c[y>>2];Jz(c[v>>2]|0)|0;Jz(c[A>>2]|0)|0;WK(c[z>>2]|0);i=j;return c[w>>2]|0}function bU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(c[c[f>>2]>>2]|0)c[(c[e>>2]|0)+16>>2]=c[c[f>>2]>>2];if(c[(c[f>>2]|0)+4>>2]|0)c[(c[e>>2]|0)+16+4>>2]=c[(c[f>>2]|0)+4>>2];if(!(+h[(c[f>>2]|0)+16>>3]>=0.0)){i=d;return}h[(c[e>>2]|0)+16+16>>3]=+h[(c[f>>2]|0)+16>>3];i=d;return}
function Wb(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+15&-16;return b|0}function Xb(){return i|0}function Yb(a){a=a|0;i=a}function Zb(a,b){a=a|0;b=b|0;i=a;j=b}function _b(a,b){a=a|0;b=b|0;if(!n){n=a;o=b}}function $b(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0]}function ac(b){b=b|0;a[k>>0]=a[b>>0];a[k+1>>0]=a[b+1>>0];a[k+2>>0]=a[b+2>>0];a[k+3>>0]=a[b+3>>0];a[k+4>>0]=a[b+4>>0];a[k+5>>0]=a[b+5>>0];a[k+6>>0]=a[b+6>>0];a[k+7>>0]=a[b+7>>0]}function bc(a){a=a|0;C=a}function cc(){return C|0}function dc(a){a=a|0;yb(0,a|0)|0;return 0}function ec(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;if(!(c[11034]|0)){h=$F()|0;c[11034]=h;dG(h,44140);dG(c[11034]|0,50084);dG(c[11034]|0,50544)}Zz(1)|0;Yz(18)|0;eD(1);h=PB(a)|0;if(!h){j=0;i=e;return j|0}else{k=h;l=0}while(1){if(!l){aG(c[11034]|0,k,d)|0;cG(c[11034]|0,k,b,f,g)|0;gF(c[11034]|0,k)|0}jB(k)|0;k=PB(178518)|0;h=c[f>>2]|0;if(!k){j=h;break}else l=h}i=e;return j|0}function fc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+1072|0;j=g;k=g+24|0;l=g+20|0;m=g+16|0;n=g+32|0;c[k>>2]=b;c[l>>2]=d;a[g+1056>>0]=f;c[m>>2]=c[(c[(c[k>>2]|0)+16>>2]|0)+12>>2];gA(c[44788+(c[m>>2]<<2)>>2]|0,104802)|0;f=c[44788+(c[m>>2]<<2)>>2]|0;c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];gc(f,j);hc(n,+h[e+16>>3]-+h[e>>3]);gA(c[44788+(c[m>>2]<<2)>>2]|0,n)|0;hc(n,+h[e+16+8>>3]-+h[e+8>>3]);gA(c[44788+(c[m>>2]<<2)>>2]|0,n)|0;ic(c[k>>2]|0,178518,c[(c[l>>2]|0)+8>>2]|0);i=g;return}function gc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+1040|0;e=d;f=d+8|0;c[e>>2]=a;hc(f,+h[b>>3]);gA(c[e>>2]|0,f)|0;hc(f,+GK(+h[b+8>>3]));gA(c[e>>2]|0,f)|0;i=d;return}function hc(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+8|0;f=d+16|0;g=d;c[f>>2]=a;h[g>>3]=b;a=c[f>>2]|0;h[e>>3]=+h[g>>3];k3(a,105074,e)|0;xc(c[f>>2]|0,1);i=d;return}function ic(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[(c[(c[f>>2]|0)+16>>2]|0)+12>>2];Cc(c[44788+(c[j>>2]<<2)>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function jc(a){a=a|0;var b=0,d=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[h>>2]=c[(c[(c[d>>2]|0)+16>>2]|0)+8>>2];switch(c[(c[d>>2]|0)+60+4>>2]|0){case 0:{JK(c[h>>2]|0);i=b;return}case 1:{if(!((e[(c[(c[h>>2]|0)+8>>2]|0)+136>>1]|0)&1)){i=b;return}GO(c[h>>2]|0);i=b;return}case 4:case 5:case 6:{IK(c[h>>2]|0,g,f);Ec(c[h>>2]|0,c[g>>2]|0,c[f>>2]|0,c[(c[d>>2]|0)+60+4>>2]|0);i=b;return}default:{i=b;return}}}function kc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=c[(c[(c[d>>2]|0)+16>>2]|0)+8>>2];if(!(c[11225]|0)){c[11225]=c[13099];c[11226]=57;c[11227]=19}c[f>>2]=c[(c[(c[e>>2]|0)+52>>2]|0)+8>>2];c[(c[(c[e>>2]|0)+52>>2]|0)+8>>2]=44900;switch(c[(c[d>>2]|0)+60+4>>2]|0){case 2:{HK(c[d>>2]|0,c[e>>2]|0,c[d>>2]|0,0);break}case 3:{HK(c[d>>2]|0,c[e>>2]|0,c[d>>2]|0,1);break}case 1:case 0:{if(!(c[(c[d>>2]|0)+152>>2]&134217728))VD(c[e>>2]|0,c[d>>2]|0)|0;break}case 6:case 5:case 4:{Dc(c[e>>2]|0);if(!(c[(c[d>>2]|0)+152>>2]&134217728))VD(c[e>>2]|0,c[d>>2]|0)|0;break}default:{}}c[(c[(c[e>>2]|0)+52>>2]|0)+8>>2]=c[f>>2];i=b;return}function lc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=c[(c[(c[e>>2]|0)+16>>2]|0)+8>>2];e=c[f>>2]|0;b=c[c[11209]>>2]|0;if((c[(c[11198]|0)+4>>2]|0)>>>0>=(c[(c[11198]|0)+8>>2]|0)>>>0)eA(c[11198]|0,1)|0;g=(c[11198]|0)+4|0;j=c[g>>2]|0;c[g>>2]=j+1;a[j>>0]=0;j=c[c[11198]>>2]|0;c[(c[11198]|0)+4>>2]=j;BA(e,b,j)|0;if(!(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)){h[24]=1.0;h[28]=1.0;c[11214]=0;c[11218]=0;i=d;return}j=c[f>>2]|0;f=c[(c[11209]|0)+4>>2]|0;if((c[(c[11202]|0)+4>>2]|0)>>>0>=(c[(c[11202]|0)+8>>2]|0)>>>0)eA(c[11202]|0,1)|0;b=(c[11202]|0)+4|0;e=c[b>>2]|0;c[b>>2]=e+1;a[e>>0]=0;e=c[c[11202]>>2]|0;c[(c[11202]|0)+4>>2]=e;BA(j,f,e)|0;h[24]=1.0;h[28]=1.0;c[11214]=0;c[11218]=0;i=d;return}function mc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=c[(c[(c[e>>2]|0)+16>>2]|0)+8>>2];if((c[(c[11205]|0)+4>>2]|0)-(c[c[11205]>>2]|0)|0){e=c[f>>2]|0;b=c[(c[11209]|0)+8>>2]|0;if((c[(c[11205]|0)+4>>2]|0)>>>0>=(c[(c[11205]|0)+8>>2]|0)>>>0)eA(c[11205]|0,1)|0;g=(c[11205]|0)+4|0;j=c[g>>2]|0;c[g>>2]=j+1;a[j>>0]=0;j=c[c[11205]>>2]|0;c[(c[11205]|0)+4>>2]=j;BA(e,b,j)|0}if(!((c[(c[11207]|0)+4>>2]|0)-(c[c[11207]>>2]|0)|0)){h[31]=1.0;h[33]=1.0;c[11221]=0;c[11223]=0;i=d;return}j=c[f>>2]|0;f=c[(c[11209]|0)+12>>2]|0;if((c[(c[11207]|0)+4>>2]|0)>>>0>=(c[(c[11207]|0)+8>>2]|0)>>>0)eA(c[11207]|0,1)|0;b=(c[11207]|0)+4|0;e=c[b>>2]|0;c[b>>2]=e+1;a[e>>0]=0;e=c[c[11207]>>2]|0;c[(c[11207]|0)+4>>2]=e;BA(j,f,e)|0;h[31]=1.0;h[33]=1.0;c[11221]=0;c[11223]=0;i=d;return}function nc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=c[(c[(c[e>>2]|0)+16>>2]|0)+8>>2];if((c[(c[11206]|0)+4>>2]|0)-(c[c[11206]>>2]|0)|0){e=c[f>>2]|0;b=c[(c[11209]|0)+16>>2]|0;if((c[(c[11206]|0)+4>>2]|0)>>>0>=(c[(c[11206]|0)+8>>2]|0)>>>0)eA(c[11206]|0,1)|0;g=(c[11206]|0)+4|0;j=c[g>>2]|0;c[g>>2]=j+1;a[j>>0]=0;j=c[c[11206]>>2]|0;c[(c[11206]|0)+4>>2]=j;BA(e,b,j)|0}if((c[(c[11199]|0)+4>>2]|0)-(c[c[11199]>>2]|0)|0){j=c[f>>2]|0;b=c[(c[11209]|0)+24>>2]|0;if((c[(c[11199]|0)+4>>2]|0)>>>0>=(c[(c[11199]|0)+8>>2]|0)>>>0)eA(c[11199]|0,1)|0;e=(c[11199]|0)+4|0;g=c[e>>2]|0;c[e>>2]=g+1;a[g>>0]=0;g=c[c[11199]>>2]|0;c[(c[11199]|0)+4>>2]=g;BA(j,b,g)|0}if((c[(c[11200]|0)+4>>2]|0)-(c[c[11200]>>2]|0)|0){g=c[f>>2]|0;b=c[(c[11209]|0)+20>>2]|0;if((c[(c[11200]|0)+4>>2]|0)>>>0>=(c[(c[11200]|0)+8>>2]|0)>>>0)eA(c[11200]|0,1)|0;j=(c[11200]|0)+4|0;e=c[j>>2]|0;c[j>>2]=e+1;a[e>>0]=0;e=c[c[11200]>>2]|0;c[(c[11200]|0)+4>>2]=e;BA(g,b,e)|0}if((c[(c[11208]|0)+4>>2]|0)-(c[c[11208]>>2]|0)|0){e=c[f>>2]|0;b=c[(c[11209]|0)+28>>2]|0;if((c[(c[11208]|0)+4>>2]|0)>>>0>=(c[(c[11208]|0)+8>>2]|0)>>>0)eA(c[11208]|0,1)|0;g=(c[11208]|0)+4|0;j=c[g>>2]|0;c[g>>2]=j+1;a[j>>0]=0;j=c[c[11208]>>2]|0;c[(c[11208]|0)+4>>2]=j;BA(e,b,j)|0}if((c[(c[11203]|0)+4>>2]|0)-(c[c[11203]>>2]|0)|0){j=c[f>>2]|0;b=c[(c[11209]|0)+36>>2]|0;if((c[(c[11203]|0)+4>>2]|0)>>>0>=(c[(c[11203]|0)+8>>2]|0)>>>0)eA(c[11203]|0,1)|0;e=(c[11203]|0)+4|0;g=c[e>>2]|0;c[e>>2]=g+1;a[g>>0]=0;g=c[c[11203]>>2]|0;c[(c[11203]|0)+4>>2]=g;BA(j,b,g)|0}if(!((c[(c[11204]|0)+4>>2]|0)-(c[c[11204]>>2]|0)|0)){h[32]=1.0;h[34]=1.0;h[25]=1.0;h[26]=1.0;h[29]=1.0;h[30]=1.0;c[11222]=0;c[11224]=0;c[11215]=0;c[11216]=0;c[11219]=0;c[11220]=0;i=d;return}g=c[f>>2]|0;f=c[(c[11209]|0)+32>>2]|0;if((c[(c[11204]|0)+4>>2]|0)>>>0>=(c[(c[11204]|0)+8>>2]|0)>>>0)eA(c[11204]|0,1)|0;b=(c[11204]|0)+4|0;j=c[b>>2]|0;c[b>>2]=j+1;a[j>>0]=0;j=c[c[11204]>>2]|0;c[(c[11204]|0)+4>>2]=j;BA(g,f,j)|0;h[32]=1.0;h[34]=1.0;h[25]=1.0;h[26]=1.0;h[29]=1.0;h[30]=1.0;c[11222]=0;c[11224]=0;c[11215]=0;c[11216]=0;c[11219]=0;c[11220]=0;i=d;return}function oc(b,d,f){b=b|0;d=d|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+1088|0;j=g+16|0;k=g+8|0;l=g;m=g+56|0;n=g+52|0;o=g+48|0;p=g+44|0;q=g+64|0;r=g+40|0;s=g+36|0;t=g+32|0;c[m>>2]=b;c[n>>2]=f;c[o>>2]=c[(c[(c[m>>2]|0)+16>>2]|0)+12>>2];gA(c[44788+(c[o>>2]<<2)>>2]|0,104969)|0;hc(q,+h[(c[(c[n>>2]|0)+4>>2]|0)+16>>3]);gA(c[44788+(c[o>>2]<<2)>>2]|0,q)|0;ic(c[m>>2]|0,178518,c[c[(c[n>>2]|0)+4>>2]>>2]|0);uc(c[m>>2]|0);switch(a[(c[n>>2]|0)+48>>0]|0){case 108:{c[r>>2]=-1;break}case 114:{c[r>>2]=1;break}default:c[r>>2]=0}if(c[(c[n>>2]|0)+4>>2]|0)c[p>>2]=c[(c[(c[n>>2]|0)+4>>2]|0)+24>>2]&127;else c[p>>2]=0;if((e[(c[11209]|0)+8232>>1]|0)>=15?(c[s>>2]=c[44840+((e[(c[11209]|0)+8232>>1]|0)-15<<2)>>2],c[t>>2]=c[p>>2]&c[s>>2],(c[44852+(c[o>>2]<<2)>>2]|0)!=(c[t>>2]|0)):0){c[l>>2]=c[t>>2];k3(q,104972,l)|0;gA(c[44788+(c[o>>2]<<2)>>2]|0,q)|0;c[44852+(c[o>>2]<<2)>>2]=c[t>>2]}t=d+8|0;h[t>>3]=+h[t>>3]+ +h[(c[n>>2]|0)+24>>3];gA(c[44788+(c[o>>2]<<2)>>2]|0,104978)|0;t=c[44788+(c[o>>2]<<2)>>2]|0;c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];gc(t,j);c[k>>2]=c[r>>2];k3(q,14e4,k)|0;gA(c[44788+(c[o>>2]<<2)>>2]|0,q)|0;hc(q,+h[(c[n>>2]|0)+32>>3]);gA(c[44788+(c[o>>2]<<2)>>2]|0,q)|0;ic(c[m>>2]|0,178518,c[c[n>>2]>>2]|0);i=g;return}function pc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+1056|0;f=e;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+32|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=c[(c[(c[g>>2]|0)+16>>2]|0)+12>>2];tc(c[g>>2]|0);uc(c[g>>2]|0);if(c[k>>2]|0){d=c[g>>2]|0;if((c[k>>2]|0)==2|(c[k>>2]|0)==3)yc(d,c[k>>2]|0,c[j>>2]|0,2);else zc(d);gA(c[44788+(c[l>>2]<<2)>>2]|0,104963)|0}else gA(c[44788+(c[l>>2]<<2)>>2]|0,104966)|0;d=c[44788+(c[l>>2]<<2)>>2]|0;k=c[j>>2]|0;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];gc(d,f);hc(m,+h[(c[j>>2]|0)+16>>3]-+h[c[j>>2]>>3]);gA(c[44788+(c[l>>2]<<2)>>2]|0,m)|0;hc(m,+h[(c[j>>2]|0)+16+8>>3]-+h[(c[j>>2]|0)+8>>3]);gA(c[44788+(c[l>>2]<<2)>>2]|0,m)|0;i=e;return}function qc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;tc(c[g>>2]|0);uc(c[g>>2]|0);if(!(c[k>>2]|0)){vc(c[g>>2]|0,112,c[h>>2]|0,c[j>>2]|0);i=f;return}e=c[g>>2]|0;if((c[k>>2]|0)==2|(c[k>>2]|0)==3)yc(e,c[k>>2]|0,c[h>>2]|0,c[j>>2]|0);else zc(e);vc(c[g>>2]|0,80,c[h>>2]|0,c[j>>2]|0);i=f;return}function rc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[h+8>>2]=e;c[h+4>>2]=f;c[m>>2]=g;tc(c[j>>2]|0);uc(c[j>>2]|0);if(!(c[m>>2]|0)){vc(c[j>>2]|0,66,c[k>>2]|0,c[l>>2]|0);i=h;return}g=c[j>>2]|0;if((c[m>>2]|0)==2|(c[m>>2]|0)==3)yc(g,c[m>>2]|0,c[k>>2]|0,c[l>>2]|0);else zc(g);vc(c[j>>2]|0,98,c[k>>2]|0,c[l>>2]|0);i=h;return}function sc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;tc(c[f>>2]|0);uc(c[f>>2]|0);vc(c[f>>2]|0,76,c[g>>2]|0,c[h>>2]|0);i=e;return}function tc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+1200|0;e=d;f=d+40|0;g=d+48|0;j=d+24|0;k=d+16|0;l=d+12|0;m=d+8|0;c[f>>2]=b;dA(j,1024,d+176|0);if(+h[(c[(c[f>>2]|0)+16>>2]|0)+152>>3]!=+h[184+(c[(c[(c[f>>2]|0)+16>>2]|0)+12>>2]<<3)>>3]){h[184+(c[(c[(c[f>>2]|0)+16>>2]|0)+12>>2]<<3)>>3]=+h[(c[(c[f>>2]|0)+16>>2]|0)+152>>3];gA(j,104928)|0;h[e>>3]=+h[(c[(c[f>>2]|0)+16>>2]|0)+152>>3];k3(g,104942,e)|0;xc(g,0);gA(j,g)|0;if((c[j+4>>2]|0)>>>0>=(c[j+8>>2]|0)>>>0)eA(j,1)|0;g=j+4|0;e=c[g>>2]|0;c[g>>2]=e+1;a[e>>0]=41;e=c[f>>2]|0;if((c[j+4>>2]|0)>>>0>=(c[j+8>>2]|0)>>>0)eA(j,1)|0;g=j+4|0;b=c[g>>2]|0;c[g>>2]=b+1;a[b>>0]=0;b=c[j>>2]|0;c[j+4>>2]=b;ic(e,104947,b)}c[l>>2]=c[(c[(c[f>>2]|0)+16>>2]|0)+160>>2];if(!(c[l>>2]|0)){i=d;return}while(1){b=c[l>>2]|0;c[l>>2]=b+4;e=c[b>>2]|0;c[k>>2]=e;if(!e)break;if((a[c[k>>2]>>0]|0)==(a[148663]|0)?(J3(c[k>>2]|0,148663)|0)==0:0)continue;if((a[c[k>>2]>>0]|0)==(a[148645]|0)?(J3(c[k>>2]|0,148645)|0)==0:0)continue;if((a[c[k>>2]>>0]|0)==(a[148650]|0)?(J3(c[k>>2]|0,148650)|0)==0:0)continue;gA(j,c[k>>2]|0)|0;do{e=(a[c[k>>2]>>0]|0)!=0;c[k>>2]=(c[k>>2]|0)+1}while(e);if(a[c[k>>2]>>0]|0){if((c[j+4>>2]|0)>>>0>=(c[j+8>>2]|0)>>>0)eA(j,1)|0;e=j+4|0;b=c[e>>2]|0;c[e>>2]=b+1;a[b>>0]=40;c[m>>2]=0;while(1){if(!(a[c[k>>2]>>0]|0))break;if(c[m>>2]|0){if((c[j+4>>2]|0)>>>0>=(c[j+8>>2]|0)>>>0)eA(j,1)|0;b=j+4|0;e=c[b>>2]|0;c[b>>2]=e+1;a[e>>0]=44}gA(j,c[k>>2]|0)|0;do{e=(a[c[k>>2]>>0]|0)!=0;c[k>>2]=(c[k>>2]|0)+1}while(e);c[m>>2]=(c[m>>2]|0)+1}if((c[j+4>>2]|0)>>>0>=(c[j+8>>2]|0)>>>0)eA(j,1)|0;e=j+4|0;b=c[e>>2]|0;c[e>>2]=b+1;a[b>>0]=41}b=c[f>>2]|0;if((c[j+4>>2]|0)>>>0>=(c[j+8>>2]|0)>>>0)eA(j,1)|0;e=j+4|0;g=c[e>>2]|0;c[e>>2]=g+1;a[g>>0]=0;g=c[j>>2]|0;c[j+4>>2]=g;ic(b,104947,g)}hA(j);i=d;return}function uc(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[d>>2]|0;ic(a,113060,wc((c[(c[d>>2]|0)+16>>2]|0)+16|0)|0);i=b;return}function vc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+1072|0;h=g;j=g+36|0;k=g+1064|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+40|0;p=g+20|0;c[j>>2]=b;a[k>>0]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[(c[(c[j>>2]|0)+16>>2]|0)+12>>2];if((c[(c[44788+(c[n>>2]<<2)>>2]|0)+4>>2]|0)>>>0>=(c[(c[44788+(c[n>>2]<<2)>>2]|0)+8>>2]|0)>>>0)eA(c[44788+(c[n>>2]<<2)>>2]|0,1)|0;j=a[k>>0]|0;k=(c[44788+(c[n>>2]<<2)>>2]|0)+4|0;f=c[k>>2]|0;c[k>>2]=f+1;a[f>>0]=j;c[g+16>>2]=j&255;c[h>>2]=c[m>>2];k3(o,104895,h)|0;gA(c[44788+(c[n>>2]<<2)>>2]|0,o)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[m>>2]|0))break;o=c[44788+(c[n>>2]<<2)>>2]|0;j=(c[l>>2]|0)+(c[p>>2]<<4)|0;c[h>>2]=c[j>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];gc(o,h);c[p>>2]=(c[p>>2]|0)+1}i=g;return}function wc(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+48|0;e=b+16|0;f=b;g=b+32|0;c[g>>2]=a;a=d[c[g>>2]>>0]|0;h=d[(c[g>>2]|0)+1>>0]|0;j=d[(c[g>>2]|0)+2>>0]|0;if((d[(c[g>>2]|0)+3>>0]|0|0)==255){c[f>>2]=a;c[f+4>>2]=h;c[f+8>>2]=j;k3(104900,112940,f)|0;i=b;return 104900}else{f=d[(c[g>>2]|0)+3>>0]|0;c[e>>2]=a;c[e+4>>2]=h;c[e+8>>2]=j;c[e+12>>2]=f;k3(104900,104910,e)|0;i=b;return 104900}return 0}function xc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=b;c[g>>2]=d;d=H3(c[f>>2]|0,46)|0;c[h>>2]=d;do if(d){c[j>>2]=(c[h>>2]|0)+1;while(1){k=c[j>>2]|0;if(!(a[c[j>>2]>>0]|0))break;c[j>>2]=k+1}c[j>>2]=k+-1;while(1){l=c[j>>2]|0;if((a[c[j>>2]>>0]|0)!=48)break;c[j>>2]=l+-1;a[l>>0]=0}b=c[j>>2]|0;if((a[l>>0]|0)==46){a[b>>0]=0;break}else{c[j>>2]=b+1;break}}else if(c[g>>2]|0){b=c[f>>2]|0;c[j>>2]=b+(N3(c[f>>2]|0)|0)}while(0);if(!(c[g>>2]|0)){i=e;return}g=c[j>>2]|0;c[j>>2]=g+1;a[g>>0]=32;a[c[j>>2]>>0]=0;i=e;return}function yc(b,d,f,j){b=b|0;d=d|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;k=i;i=i+1152|0;l=k+64|0;m=k+124|0;n=k+120|0;o=k+116|0;p=k+112|0;q=k+96|0;r=k+92|0;s=k+88|0;t=k+84|0;u=k+80|0;v=k+32|0;w=k+16|0;x=k;c[m>>2]=b;c[n>>2]=d;c[o>>2]=f;c[p>>2]=j;c[r>>2]=c[(c[m>>2]|0)+16>>2];g[s>>2]=+(c[(c[r>>2]|0)+136>>2]|0)*3.141592653589793/180.0;if((e[(c[11209]|0)+8232>>1]|0|0)<14){zc(c[m>>2]|0);i=k;return}dA(q,1024,k+128|0);j=c[o>>2]|0;o=c[p>>2]|0;if((c[n>>2]|0)==2){RO(j,v,o,+g[s>>2],2);if((c[q+4>>2]|0)>>>0>=(c[q+8>>2]|0)>>>0)eA(q,1)|0;p=q+4|0;f=c[p>>2]|0;c[p>>2]=f+1;a[f>>0]=91;c[l>>2]=c[v>>2];c[l+4>>2]=c[v+4>>2];c[l+8>>2]=c[v+8>>2];c[l+12>>2]=c[v+12>>2];gc(q,l);f=v+16|0;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];gc(q,l)}else{RO(j,v,o,0.0,3);g[t>>2]=+h[v+16>>3];g[u>>2]=+h[v+16+8>>3];y=+h[v>>3];if(+g[s>>2]==0.0){h[w>>3]=y;h[w+8>>3]=+h[v+8>>3]}else{h[w>>3]=y+ +g[u>>2]/4.0*+Q(+(+g[s>>2]));h[w+8>>3]=+h[v+8>>3]+ +g[u>>2]/4.0*+R(+(+g[s>>2]))}h[x>>3]=+h[v>>3];h[x+8>>3]=+h[v+8>>3];g[t>>2]=+g[u>>2]/4.0;if((c[q+4>>2]|0)>>>0>=(c[q+8>>2]|0)>>>0)eA(q,1)|0;v=q+4|0;s=c[v>>2]|0;c[v>>2]=s+1;a[s>>0]=40;c[l>>2]=c[w>>2];c[l+4>>2]=c[w+4>>2];c[l+8>>2]=c[w+8>>2];c[l+12>>2]=c[w+12>>2];gc(q,l);Ac(q,+g[t>>2]);c[l>>2]=c[x>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[l+12>>2]=c[x+12>>2];gc(q,l);Ac(q,+g[u>>2])}gA(q,104953)|0;u=c[r>>2]|0;if(+g[(c[r>>2]|0)+140>>2]>0.0){Bc(q,+g[u+140>>2],(c[r>>2]|0)+56|0);Bc(q,+g[(c[r>>2]|0)+140>>2],(c[r>>2]|0)+96|0)}else{Bc(q,0.0,u+56|0);Bc(q,1.0,(c[r>>2]|0)+96|0)}iA(q)|0;r=(c[q+4>>2]|0)>>>0>=(c[q+8>>2]|0)>>>0;if((c[n>>2]|0)==2){if(r)eA(q,1)|0;n=q+4|0;u=c[n>>2]|0;c[n>>2]=u+1;a[u>>0]=93}else{if(r)eA(q,1)|0;r=q+4|0;u=c[r>>2]|0;c[r>>2]=u+1;a[u>>0]=41}u=c[m>>2]|0;if((c[q+4>>2]|0)>>>0>=(c[q+8>>2]|0)>>>0)eA(q,1)|0;m=q+4|0;r=c[m>>2]|0;c[m>>2]=r+1;a[r>>0]=0;r=c[q>>2]|0;c[q+4>>2]=r;ic(u,104950,r);hA(q);i=k;return}function zc(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[d>>2]|0;ic(a,104950,wc((c[(c[d>>2]|0)+16>>2]|0)+56|0)|0);i=b;return}function Ac(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0;d=i;i=i+1040|0;e=d+8|0;f=d;g=d+16|0;c[e>>2]=a;h[f>>3]=b;hc(g,+h[f>>3]);gA(c[e>>2]|0,g)|0;i=d;return}function Bc(a,b,d){a=a|0;b=+b;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0;e=i;i=i+1056|0;f=e;j=e+16|0;k=e+12|0;l=e+8|0;m=e+24|0;c[j>>2]=a;g[k>>2]=b;c[l>>2]=d;h[f>>3]=+g[k>>2];k3(m,131543,f)|0;xc(m,1);f=c[j>>2]|0;Cc(f,m,wc(c[l>>2]|0)|0);i=e;return}function Cc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+1056|0;g=f;h=f+16|0;j=f+12|0;k=f+8|0;l=f+24|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=c[j>>2]|0;j=N3(c[k>>2]|0)|0;c[g>>2]=e;c[g+4>>2]=j;k3(l,104956,g)|0;gA(c[h>>2]|0,l)|0;gA(c[h>>2]|0,c[k>>2]|0)|0;if((c[(c[h>>2]|0)+4>>2]|0)>>>0<(c[(c[h>>2]|0)+8>>2]|0)>>>0){m=c[h>>2]|0;n=m+4|0;o=c[n>>2]|0;p=o+1|0;c[n>>2]=p;a[o>>0]=32;i=f;return}eA(c[h>>2]|0,1)|0;m=c[h>>2]|0;n=m+4|0;o=c[n>>2]|0;p=o+1|0;c[n>>2]=p;a[o>>0]=32;i=f;return}function Dc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;if((c[(c[11197]|0)+4>>2]|0)-(c[c[11197]>>2]|0)|0){if(!(c[c[11209]>>2]|0)){b=HO(c[e>>2]|0,0,137480,178518)|0;c[c[11209]>>2]=b}b=c[e>>2]|0;g=c[c[11209]>>2]|0;if((c[(c[11197]|0)+4>>2]|0)>>>0>=(c[(c[11197]|0)+8>>2]|0)>>>0)eA(c[11197]|0,1)|0;j=(c[11197]|0)+4|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k>>0]=0;k=c[c[11197]>>2]|0;c[(c[11197]|0)+4>>2]=k;BA(b,g,k)|0}if(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0){k=c[e>>2]|0;g=c[(c[11209]|0)+4>>2]|0;if((c[(c[11201]|0)+4>>2]|0)>>>0>=(c[(c[11201]|0)+8>>2]|0)>>>0)eA(c[11201]|0,1)|0;b=(c[11201]|0)+4|0;j=c[b>>2]|0;c[b>>2]=j+1;a[j>>0]=0;j=c[c[11201]>>2]|0;c[(c[11201]|0)+4>>2]=j;BA(k,g,j)|0}CA(c[e>>2]|0,104981,c[(c[11209]|0)+8236>>2]|0,178518)|0;c[f>>2]=0;while(1){if((c[f>>2]|0)>=8)break;hA(44912+(c[f>>2]<<4)|0);c[f>>2]=(c[f>>2]|0)+1}O4(c[11209]|0);h[23]=1.0;h[27]=1.0;c[11213]=0;c[11217]=0;i=d;return}function Ec(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=h;c[11209]=N4(8240)|0;do if((c[n>>2]|0)==6){b[(c[11209]|0)+8232>>1]=14;c[(c[11209]|0)+8236>>2]=104993}else{if((c[n>>2]|0)==5){b[(c[11209]|0)+8232>>1]=12;c[(c[11209]|0)+8236>>2]=104997;break}h=yA(c[k>>2]|0,104981)|0;c[q>>2]=h;if(((h|0)!=0?(a[c[q>>2]>>0]|0)!=0:0)?(h=(Fc(c[q>>2]|0)|0)&65535,c[p>>2]=h,(h|0)>10):0){b[(c[11209]|0)+8232>>1]=c[p>>2];c[(c[11209]|0)+8236>>2]=c[q>>2];break}h=Fc(105001)|0;b[(c[11209]|0)+8232>>1]=h;c[(c[11209]|0)+8236>>2]=105001}while(0);if(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0){q=HO(c[k>>2]|0,0,137480,178518)|0;c[c[11209]>>2]=q}else c[c[11209]>>2]=0;if(d[(c[(c[k>>2]|0)+8>>2]|0)+113>>0]&8){q=HO(c[k>>2]|0,0,105005,178518)|0;c[(c[11209]|0)+4>>2]=q}else c[(c[11209]|0)+4>>2]=0;q=HO(c[k>>2]|0,1,137480,178518)|0;c[(c[11209]|0)+8>>2]=q;q=HO(c[k>>2]|0,1,105005,178518)|0;c[(c[11209]|0)+12>>2]=q;q=HO(c[k>>2]|0,2,137480,178518)|0;c[(c[11209]|0)+16>>2]=q;if(c[m>>2]|0){m=HO(c[k>>2]|0,2,105013,178518)|0;c[(c[11209]|0)+20>>2]=m}else c[(c[11209]|0)+20>>2]=0;if(c[l>>2]|0){l=HO(c[k>>2]|0,2,105021,178518)|0;c[(c[11209]|0)+24>>2]=l}else c[(c[11209]|0)+24>>2]=0;if(d[(c[(c[k>>2]|0)+8>>2]|0)+113>>0]&33){l=HO(c[k>>2]|0,2,105005,178518)|0;c[(c[11209]|0)+28>>2]=l}else c[(c[11209]|0)+28>>2]=0;if(d[(c[(c[k>>2]|0)+8>>2]|0)+113>>0]&2){l=HO(c[k>>2]|0,2,105029,178518)|0;c[(c[11209]|0)+32>>2]=l}else c[(c[11209]|0)+32>>2]=0;if(d[(c[(c[k>>2]|0)+8>>2]|0)+113>>0]&4){l=HO(c[k>>2]|0,2,105038,178518)|0;c[(c[11209]|0)+36>>2]=l}else c[(c[11209]|0)+36>>2]=0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=8)break;dA(44912+(c[o>>2]<<4)|0,1024,(c[11209]|0)+40+(c[o>>2]<<10)|0);c[o>>2]=(c[o>>2]|0)+1}i=j;return}function Fc(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+1056|0;f=e;g=e+12|0;h=e+1048|0;j=e+24|0;k=e+8|0;l=e+4|0;m=e+16|0;c[g>>2]=d;c[k>>2]=0;c[l>>2]=c[g>>2];while(1){d=c[l>>2]|0;c[l>>2]=d+1;n=a[d>>0]|0;a[h>>0]=n;if(!(n<<24>>24))break;if(!(p1(a[h>>0]|0)|0))continue;if((c[k>>2]|0)>=1023){o=6;break}n=a[h>>0]|0;d=c[k>>2]|0;c[k>>2]=d+1;a[j+d>>0]=n}if((o|0)==6){c[f>>2]=c[g>>2];$z(0,105047,f)|0}a[j+(c[k>>2]|0)>>0]=0;b[m>>1]=u3(j)|0;i=e;return b[m>>1]|0}function Gc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+48|0;d=b+24|0;e=b+16|0;f=b;g=b+32|0;h=b+28|0;c[g>>2]=a;c[h>>2]=c[(c[g>>2]|0)+16>>2];jF(c[g>>2]|0,105410)|0;a=c[g>>2]|0;j=c[(c[c[(c[g>>2]|0)+12>>2]>>2]|0)+4>>2]|0;k=c[(c[c[(c[g>>2]|0)+12>>2]>>2]|0)+8>>2]|0;c[f>>2]=c[c[c[(c[g>>2]|0)+12>>2]>>2]>>2];c[f+4>>2]=j;c[f+8>>2]=k;oF(a,105420,f);f=c[g>>2]|0;c[e>>2]=wB(c[(c[h>>2]|0)+8>>2]|0)|0;oF(f,105455,e);e=c[g>>2]|0;c[d>>2]=_(c[(c[g>>2]|0)+164>>2]|0,c[(c[g>>2]|0)+164+4>>2]|0)|0;oF(e,105468,d);jF(c[g>>2]|0,105481)|0;jF(c[g>>2]|0,105491)|0;jF(c[g>>2]|0,105499)|0;jF(c[g>>2]|0,105507)|0;jF(c[g>>2]|0,105515)|0;jF(c[g>>2]|0,105523)|0;jF(c[g>>2]|0,105531)|0;jF(c[g>>2]|0,105535)|0;jF(c[g>>2]|0,105540)|0;i=b;return}function Hc(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,105391)|0;i=b;return}function Ic(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;c[11318]=2;i=b;return}function Jc(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;c[11318]=1;i=b;return}function Kc(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;c[11318]=2;i=b;return}function Lc(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;c[11318]=0;i=b;return}function Mc(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;c[11318]=2;i=b;return}function Nc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0;f=i;i=i+160|0;g=f+32|0;j=f+152|0;k=f+148|0;l=f+144|0;m=f+140|0;n=f+136|0;o=f+132|0;p=f+128|0;q=f+124|0;r=f+120|0;s=f+116|0;t=f+24|0;u=f+16|0;v=f+112|0;w=f+8|0;x=f;c[j>>2]=b;c[k>>2]=e;c[l>>2]=c[(c[j>>2]|0)+16>>2];c[n>>2]=4;c[o>>2]=0;c[p>>2]=c[(c[l>>2]|0)+16>>2];c[q>>2]=c[11318];c[r>>2]=0;c[s>>2]=-1;h[t>>3]=+h[(c[(c[k>>2]|0)+4>>2]|0)+16>>3]*+h[(c[j>>2]|0)+352>>3];h[u>>3]=(c[(c[j>>2]|0)+360>>2]|0)!=0?1.5707963267948966:0.0;c[v>>2]=6;h[w>>3]=0.0;h[x>>3]=0.0;c[m>>2]=c[(c[(c[k>>2]|0)+4>>2]|0)+8>>2];if(c[m>>2]|0)c[s>>2]=c[(c[m>>2]|0)+20>>2];switch(a[(c[k>>2]|0)+48>>0]|0){case 108:{c[o>>2]=0;break}case 114:{c[o>>2]=2;break}default:c[o>>2]=1}m=c[j>>2]|0;j=c[n>>2]|0;n=c[o>>2]|0;o=c[p>>2]|0;p=c[q>>2]|0;q=c[r>>2]|0;r=c[s>>2]|0;y=+h[t>>3];z=+h[u>>3];u=c[v>>2]|0;A=+h[w>>3];B=+h[x>>3];C=+h[d>>3];x=~~(+h[d>>3]>=0.0?C+.5:C-.5);C=+h[d+8>>3];w=~~(+h[d+8>>3]>=0.0?C+.5:C-.5);d=Xc(c[c[k>>2]>>2]|0)|0;c[g>>2]=j;c[g+4>>2]=n;c[g+8>>2]=o;c[g+12>>2]=p;c[g+16>>2]=q;c[g+20>>2]=r;h[g+24>>3]=y;h[g+32>>3]=z;c[g+40>>2]=u;h[g+48>>3]=A;h[g+56>>3]=B;c[g+64>>2]=x;c[g+68>>2]=w;c[g+72>>2]=d;oF(m,105336,g);i=f;return}function Oc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;c[h>>2]=b;c[j>>2]=e;c[k>>2]=0;switch(c[(c[j>>2]|0)+32>>2]|0){case 5:{c[l>>2]=0;while(1){if(!(c[45276+(c[l>>2]<<2)>>2]|0)){n=12;break}if((a[c[45276+(c[l>>2]<<2)>>2]>>0]|0)==(a[c[c[j>>2]>>2]>>0]|0)?(J3(c[45276+(c[l>>2]<<2)>>2]|0,c[c[j>>2]>>2]|0)|0)==0:0)break;c[l>>2]=(c[l>>2]|0)+1}if((n|0)==12){o=c[j>>2]|0;p=o+32|0;c[p>>2]=6;i=f;return}c[c[j>>2]>>2]=c[l>>2];o=c[j>>2]|0;p=o+32|0;c[p>>2]=6;i=f;return}case 1:{c[l>>2]=32+(Wc(m,d[c[j>>2]>>0]|0,d[(c[j>>2]|0)+1>>0]|0,d[(c[j>>2]|0)+2>>0]|0)|0);if(c[m>>2]|0){m=c[h>>2]|0;h=c[l>>2]|0;n=d[c[j>>2]>>0]|0;e=d[(c[j>>2]|0)+1>>0]|0;b=d[(c[j>>2]|0)+2>>0]|0;c[g>>2]=c[k>>2];c[g+4>>2]=h;c[g+8>>2]=n;c[g+12>>2]=e;c[g+16>>2]=b;oF(m,105297,g)}c[c[j>>2]>>2]=c[l>>2];o=c[j>>2]|0;p=o+32|0;c[p>>2]=6;i=f;return}default:La(176099,105156,165,105318)}}function Pc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0;e=i;i=i+208|0;f=e+16|0;g=e+196|0;j=e+192|0;k=e+188|0;l=e+184|0;m=e+180|0;n=e+176|0;o=e+172|0;p=e+168|0;q=e+164|0;r=e+160|0;s=e+156|0;t=e+152|0;u=e+148|0;v=e+8|0;w=e+144|0;x=e;y=e+140|0;z=e+136|0;A=e+132|0;B=e+128|0;C=e+124|0;D=e+120|0;E=e+116|0;F=e+112|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=c[(c[g>>2]|0)+16>>2];c[m>>2]=1;c[n>>2]=1;c[p>>2]=~~+h[(c[l>>2]|0)+152>>3];c[q>>2]=c[(c[l>>2]|0)+16>>2];c[r>>2]=c[(c[l>>2]|0)+56>>2];c[s>>2]=c[11318];c[t>>2]=0;c[u>>2]=(c[k>>2]|0)!=0?20:-1;c[w>>2]=0;h[x>>3]=0.0;Uc(c[l>>2]|0,o,v);G=+h[c[j>>2]>>3];l=~~(+h[c[j>>2]>>3]>=0.0?G+.5:G-.5);c[y>>2]=l;c[C>>2]=l;G=+h[(c[j>>2]|0)+8>>3];l=~~(+h[(c[j>>2]|0)+8>>3]>=0.0?G+.5:G-.5);c[z>>2]=l;c[D>>2]=l;G=+h[(c[j>>2]|0)+16>>3]-+h[c[j>>2]>>3];c[A>>2]=~~(+h[(c[j>>2]|0)+16>>3]-+h[c[j>>2]>>3]>=0.0?G+.5:G-.5);G=+h[(c[j>>2]|0)+16+8>>3]-+h[(c[j>>2]|0)+8>>3];c[B>>2]=~~(+h[(c[j>>2]|0)+16+8>>3]-+h[(c[j>>2]|0)+8>>3]>=0.0?G+.5:G-.5);G=+h[(c[j>>2]|0)+16>>3];c[E>>2]=~~(+h[(c[j>>2]|0)+16>>3]>=0.0?G+.5:G-.5);G=+h[(c[j>>2]|0)+16+8>>3];c[F>>2]=~~(+h[(c[j>>2]|0)+16+8>>3]>=0.0?G+.5:G-.5);j=c[g>>2]|0;g=c[n>>2]|0;n=c[o>>2]|0;o=c[p>>2]|0;p=c[q>>2]|0;q=c[r>>2]|0;r=c[s>>2]|0;s=c[t>>2]|0;t=c[u>>2]|0;G=+h[v>>3];v=c[w>>2]|0;H=+h[x>>3];x=c[y>>2]|0;y=c[z>>2]|0;z=c[A>>2]|0;A=c[B>>2]|0;B=c[C>>2]|0;C=c[D>>2]|0;D=c[E>>2]|0;E=c[F>>2]|0;c[f>>2]=c[m>>2];c[f+4>>2]=g;c[f+8>>2]=n;c[f+12>>2]=o;c[f+16>>2]=p;c[f+20>>2]=q;c[f+24>>2]=r;c[f+28>>2]=s;c[f+32>>2]=t;h[f+40>>3]=G;c[f+48>>2]=v;h[f+56>>3]=H;c[f+64>>2]=x;c[f+68>>2]=y;c[f+72>>2]=z;c[f+76>>2]=A;c[f+80>>2]=B;c[f+84>>2]=C;c[f+88>>2]=D;c[f+92>>2]=E;oF(j,105232,f);i=e;return}function Qc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0;f=i;i=i+160|0;g=f+8|0;j=f+156|0;k=f+152|0;l=f+148|0;m=f+144|0;n=f+140|0;o=f+136|0;p=f+132|0;q=f+128|0;r=f+124|0;s=f+120|0;t=f+116|0;u=f+112|0;v=f+108|0;w=f+104|0;x=f;y=f+100|0;z=f+96|0;A=f+92|0;B=f+88|0;C=f+84|0;D=f+80|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=c[(c[j>>2]|0)+16>>2];c[o>>2]=2;c[p>>2]=3;c[r>>2]=~~+h[(c[n>>2]|0)+152>>3];c[s>>2]=c[(c[n>>2]|0)+16>>2];c[t>>2]=c[(c[n>>2]|0)+56>>2];c[u>>2]=c[11318];c[v>>2]=0;c[w>>2]=(c[m>>2]|0)!=0?20:-1;c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;c[B>>2]=0;c[C>>2]=0;c[D>>2]=(c[l>>2]|0)+1;Uc(c[n>>2]|0,q,x);n=c[j>>2]|0;m=c[p>>2]|0;p=c[q>>2]|0;q=c[r>>2]|0;r=c[s>>2]|0;s=c[t>>2]|0;t=c[u>>2]|0;u=c[v>>2]|0;v=c[w>>2]|0;E=+h[x>>3];x=c[y>>2]|0;y=c[z>>2]|0;z=c[A>>2]|0;A=c[B>>2]|0;B=c[C>>2]|0;C=c[D>>2]|0;c[g>>2]=c[o>>2];c[g+4>>2]=m;c[g+8>>2]=p;c[g+12>>2]=q;c[g+16>>2]=r;c[g+20>>2]=s;c[g+24>>2]=t;c[g+28>>2]=u;c[g+32>>2]=v;h[g+40>>3]=E;c[g+48>>2]=x;c[g+52>>2]=y;c[g+56>>2]=z;c[g+60>>2]=A;c[g+64>>2]=B;c[g+68>>2]=C;oF(n,105098,g);Vc(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,1);i=f;return}function Rc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0;j=i;i=i+320|0;k=j+192|0;l=j+184|0;m=j+120|0;n=j+112|0;o=j+104|0;p=j+312|0;q=j+308|0;r=j+304|0;s=j+292|0;t=j+288|0;u=j+284|0;v=j+280|0;w=j+276|0;x=j+272|0;y=j+268|0;z=j+264|0;A=j+260|0;B=j+256|0;C=j+252|0;D=j+96|0;E=j+248|0;F=j+244|0;G=j+240|0;H=j+236|0;I=j+232|0;J=j+80|0;K=j+16|0;L=j+224|0;M=j+216|0;N=j+212|0;O=j+208|0;P=j+204|0;Q=j+200|0;R=j+196|0;S=j;c[p>>2]=a;c[q>>2]=b;c[r>>2]=d;c[j+300>>2]=e;c[j+296>>2]=f;c[s>>2]=g;c[t>>2]=c[(c[p>>2]|0)+16>>2];c[u>>2]=3;c[x>>2]=~~+h[(c[t>>2]|0)+152>>3];c[y>>2]=c[(c[t>>2]|0)+16>>2];c[z>>2]=c[(c[t>>2]|0)+56>>2];c[A>>2]=c[11318];c[B>>2]=0;c[E>>2]=0;c[F>>2]=0;c[G>>2]=0;c[H>>2]=c[r>>2];c[O>>2]=0;if((c[r>>2]|0)<4)La(105149,105156,356,105176);c[Q>>2]=N4((((c[H>>2]|0)+1|0)*7|0)*20|0)|0;c[R>>2]=c[Q>>2];Uc(c[t>>2]|0,w,D);if(c[s>>2]|0){c[v>>2]=5;c[C>>2]=20;c[z>>2]=c[(c[(c[p>>2]|0)+16>>2]|0)+56>>2]}else{c[v>>2]=4;c[C>>2]=-1;c[z>>2]=0}h[K+48>>3]=+h[c[q>>2]>>3];h[K+48+8>>3]=+h[(c[q>>2]|0)+8>>3];c[O>>2]=(c[O>>2]|0)+1;T=+h[c[q>>2]>>3];c[L>>2]=~~(+h[c[q>>2]>>3]>=0.0?T+.5:T-.5);T=+h[(c[q>>2]|0)+8>>3];c[L+4>>2]=~~(+h[(c[q>>2]|0)+8>>3]>=0.0?T+.5:T-.5);s=c[R>>2]|0;t=c[L+4>>2]|0;c[o>>2]=c[L>>2];c[o+4>>2]=t;c[P>>2]=k3(s,118296,o)|0;c[R>>2]=(c[R>>2]|0)+(c[P>>2]|0);c[I>>2]=0;while(1){if(((c[I>>2]|0)+3|0)>=(c[r>>2]|0))break;o=K+48|0;c[K>>2]=c[o>>2];c[K+4>>2]=c[o+4>>2];c[K+8>>2]=c[o+8>>2];c[K+12>>2]=c[o+12>>2];c[M>>2]=1;while(1){if((c[M>>2]|0)>3)break;h[K+(c[M>>2]<<4)>>3]=+h[(c[q>>2]|0)+((c[I>>2]|0)+(c[M>>2]|0)<<4)>>3];h[K+(c[M>>2]<<4)+8>>3]=+h[(c[q>>2]|0)+((c[I>>2]|0)+(c[M>>2]|0)<<4)+8>>3];c[M>>2]=(c[M>>2]|0)+1}c[N>>2]=1;while(1){if((c[N>>2]|0)>6)break;c[O>>2]=(c[O>>2]|0)+1;qO(S,K,3,+(c[N>>2]|0)/6.0,0,0);c[J>>2]=c[S>>2];c[J+4>>2]=c[S+4>>2];c[J+8>>2]=c[S+8>>2];c[J+12>>2]=c[S+12>>2];T=+h[J>>3];c[L>>2]=~~(+h[J>>3]>=0.0?T+.5:T-.5);T=+h[J+8>>3];c[L+4>>2]=~~(+h[J+8>>3]>=0.0?T+.5:T-.5);o=c[R>>2]|0;s=c[L+4>>2]|0;c[n>>2]=c[L>>2];c[n+4>>2]=s;c[P>>2]=k3(o,118296,n)|0;c[R>>2]=(c[R>>2]|0)+(c[P>>2]|0);c[N>>2]=(c[N>>2]|0)+1}c[I>>2]=(c[I>>2]|0)+3}N=c[p>>2]|0;P=c[v>>2]|0;v=c[w>>2]|0;w=c[x>>2]|0;x=c[y>>2]|0;y=c[z>>2]|0;z=c[A>>2]|0;A=c[B>>2]|0;B=c[C>>2]|0;T=+h[D>>3];D=c[E>>2]|0;E=c[F>>2]|0;F=c[G>>2]|0;G=c[O>>2]|0;c[m>>2]=c[u>>2];c[m+4>>2]=P;c[m+8>>2]=v;c[m+12>>2]=w;c[m+16>>2]=x;c[m+20>>2]=y;c[m+24>>2]=z;c[m+28>>2]=A;c[m+32>>2]=B;h[m+40>>3]=T;c[m+48>>2]=D;c[m+52>>2]=E;c[m+56>>2]=F;c[m+60>>2]=G;oF(N,105187,m);m=c[p>>2]|0;c[l>>2]=c[Q>>2];oF(m,118303,l);O4(c[Q>>2]|0);c[I>>2]=0;while(1){U=c[p>>2]|0;if((c[I>>2]|0)>=(c[O>>2]|0))break;c[k>>2]=((c[I>>2]|0)%((c[O>>2]|0)-1|0)|0|0)!=0?1:0;oF(U,118308,k);c[I>>2]=(c[I>>2]|0)+1}jF(U,193392)|0;i=j;return}function Sc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;e=i;i=i+160|0;f=e+8|0;g=e+152|0;j=e+148|0;k=e+144|0;l=e+140|0;m=e+136|0;n=e+132|0;o=e+128|0;p=e+124|0;q=e+120|0;r=e+116|0;s=e+112|0;t=e+108|0;u=e+104|0;v=e;w=e+100|0;x=e+96|0;y=e+92|0;z=e+88|0;A=e+84|0;B=e+80|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=c[(c[g>>2]|0)+16>>2];c[m>>2]=2;c[n>>2]=1;c[p>>2]=~~+h[(c[l>>2]|0)+152>>3];c[q>>2]=c[(c[l>>2]|0)+16>>2];c[r>>2]=0;c[s>>2]=c[11318];c[t>>2]=0;c[u>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;c[B>>2]=c[k>>2];Uc(c[l>>2]|0,o,v);l=c[g>>2]|0;d=c[n>>2]|0;n=c[o>>2]|0;o=c[p>>2]|0;p=c[q>>2]|0;q=c[r>>2]|0;r=c[s>>2]|0;s=c[t>>2]|0;t=c[u>>2]|0;C=+h[v>>3];v=c[w>>2]|0;w=c[x>>2]|0;x=c[y>>2]|0;y=c[z>>2]|0;z=c[A>>2]|0;A=c[B>>2]|0;c[f>>2]=c[m>>2];c[f+4>>2]=d;c[f+8>>2]=n;c[f+12>>2]=o;c[f+16>>2]=p;c[f+20>>2]=q;c[f+24>>2]=r;c[f+28>>2]=s;c[f+32>>2]=t;h[f+40>>3]=C;c[f+48>>2]=v;c[f+52>>2]=w;c[f+56>>2]=x;c[f+60>>2]=y;c[f+64>>2]=z;c[f+68>>2]=A;oF(l,105098,f);Vc(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0,0);i=e;return}function Tc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;c[e>>2]=c[g>>2];oF(b,105092,e);i=d;return}function Uc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;switch(c[(c[f>>2]|0)+144>>2]|0){case 1:{c[c[g>>2]>>2]=1;h[c[j>>2]>>3]=10.0;i=e;return}case 2:{c[c[g>>2]>>2]=2;h[c[j>>2]>>3]=10.0;i=e;return}default:{c[c[g>>2]>>2]=0;h[c[j>>2]>>3]=0.0;i=e;return}}}function Vc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0;f=i;i=i+48|0;g=f+8|0;j=f;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+16|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[m>>2]|0))break;q=+h[(c[l>>2]|0)+(c[o>>2]<<4)>>3];c[p>>2]=~~(+h[(c[l>>2]|0)+(c[o>>2]<<4)>>3]>=0.0?q+.5:q-.5);q=+h[(c[l>>2]|0)+(c[o>>2]<<4)+8>>3];c[p+4>>2]=~~(+h[(c[l>>2]|0)+(c[o>>2]<<4)+8>>3]>=0.0?q+.5:q-.5);e=c[k>>2]|0;d=c[p+4>>2]|0;c[j>>2]=c[p>>2];c[j+4>>2]=d;oF(e,118296,j);c[o>>2]=(c[o>>2]|0)+1}if(!(c[n>>2]|0)){r=c[k>>2]|0;jF(r,193392)|0;i=f;return}q=+h[c[l>>2]>>3];c[p>>2]=~~(+h[c[l>>2]>>3]>=0.0?q+.5:q-.5);q=+h[(c[l>>2]|0)+8>>3];c[p+4>>2]=~~(+h[(c[l>>2]|0)+8>>3]>=0.0?q+.5:q-.5);l=c[k>>2]|0;n=c[p+4>>2]|0;c[g>>2]=c[p>>2];c[g+4>>2]=n;oF(l,118296,g);r=c[k>>2]|0;jF(r,193392)|0;i=f;return}function Wc(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;t=g;c[j>>2]=a;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[o>>2]=-1;c[t>>2]=195075;c[c[j>>2]>>2]=0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[11328]|0))break;c[p>>2]=(b[100448+(c[n>>2]<<1)>>1]|0)-(c[k>>2]|0);c[q>>2]=(b[100960+(c[n>>2]<<1)>>1]|0)-(c[l>>2]|0);c[r>>2]=(b[101472+(c[n>>2]<<1)>>1]|0)-(c[m>>2]|0);f=_(c[p>>2]|0,c[p>>2]|0)|0;e=f+(_(c[q>>2]|0,c[q>>2]|0)|0)|0;c[s>>2]=e+(_(c[r>>2]|0,c[r>>2]|0)|0);if((c[s>>2]|0)<(c[t>>2]|0)){if(!(c[s>>2]|0)){u=5;break}c[t>>2]=c[s>>2];c[o>>2]=c[n>>2]}c[n>>2]=(c[n>>2]|0)+1}if((u|0)==5){c[h>>2]=c[n>>2];v=c[h>>2]|0;i=g;return v|0}u=c[11328]|0;c[11328]=u+1;if((u|0)==256){c[h>>2]=c[o>>2];v=c[h>>2]|0;i=g;return v|0}else{b[100448+(c[n>>2]<<1)>>1]=c[k>>2];b[100960+(c[n>>2]<<1)>>1]=c[l>>2];b[101472+(c[n>>2]<<1)>>1]=c[m>>2];c[c[j>>2]>>2]=1;c[h>>2]=c[n>>2];v=c[h>>2]|0;i=g;return v|0}return 0}function Xc(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;k=e+16|0;c[g>>2]=b;c[h>>2]=0;if(!(c[11329]|0)){c[11330]=64;c[11329]=N4(c[11330]|0)|0}c[j>>2]=c[11329];while(1){b=c[g>>2]|0;c[g>>2]=b+1;l=a[b>>0]|0;a[k>>0]=l;if(!(l<<24>>24))break;if((c[h>>2]|0)>((c[11330]|0)-8|0)){c[11330]=c[11330]<<1;c[11329]=Q4(c[11329]|0,c[11330]|0)|0;c[j>>2]=(c[11329]|0)+(c[h>>2]|0)}if(!(n1(d[k>>0]|0)|0)){l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=92;l=c[j>>2]|0;c[f>>2]=d[k>>0];k3(l,118421,f)|0;c[j>>2]=(c[j>>2]|0)+3;c[h>>2]=(c[h>>2]|0)+4;continue}if((d[k>>0]|0|0)==92){l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=92;c[h>>2]=(c[h>>2]|0)+1}l=a[k>>0]|0;b=c[j>>2]|0;c[j>>2]=b+1;a[b>>0]=l;c[h>>2]=(c[h>>2]|0)+1}a[c[j>>2]>>0]=0;i=e;return c[11329]|0}function Yc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=b;c[f>>2]=c[(c[e>>2]|0)+16>>2];switch(c[(c[e>>2]|0)+60+4>>2]|0){case 0:{jF(c[e>>2]|0,105883)|0;if(!(c[(c[f>>2]|0)+208>>2]|0)){i=d;return}if(!(a[c[(c[f>>2]|0)+208>>2]>>0]|0)){i=d;return}jF(c[e>>2]|0,105897)|0;jF(c[e>>2]|0,XJ(c[(c[f>>2]|0)+208>>2]|0)|0)|0;jF(c[e>>2]|0,193392)|0;i=d;return}case 1:{if(!(c[(c[f>>2]|0)+208>>2]|0)){i=d;return}if(!(a[c[(c[f>>2]|0)+208>>2]>>0]|0)){i=d;return}jF(c[e>>2]|0,105897)|0;jF(c[e>>2]|0,XJ(c[(c[f>>2]|0)+208>>2]|0)|0)|0;jF(c[e>>2]|0,140232)|0;jF(c[e>>2]|0,XJ(wB(c[(c[f>>2]|0)+8>>2]|0)|0)|0)|0;jF(c[e>>2]|0,193392)|0;i=d;return}case 3:{c[g>>2]=XJ(wB(c[(c[f>>2]|0)+8>>2]|0)|0)|0;jF(c[e>>2]|0,105906)|0;jF(c[e>>2]|0,c[g>>2]|0)|0;jF(c[e>>2]|0,105916)|0;jF(c[e>>2]|0,c[g>>2]|0)|0;jF(c[e>>2]|0,105871)|0;i=d;return}default:{i=d;return}}}function Zc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+16>>2];switch(c[(c[d>>2]|0)+60+4>>2]|0){case 2:{$c(c[d>>2]|0,c[(c[e>>2]|0)+264>>2]|0,c[(c[e>>2]|0)+272>>2]|0,c[(c[e>>2]|0)+268>>2]|0,c[(c[e>>2]|0)+208>>2]|0,c[(c[e>>2]|0)+228>>2]|0,c[(c[e>>2]|0)+244>>2]|0,c[(c[e>>2]|0)+212>>2]|0);i=b;return}case 3:{$c(c[d>>2]|0,c[(c[e>>2]|0)+264>>2]|0,c[(c[e>>2]|0)+272>>2]|0,c[(c[e>>2]|0)+268>>2]|0,c[(c[e>>2]|0)+208>>2]|0,c[(c[e>>2]|0)+228>>2]|0,c[(c[e>>2]|0)+244>>2]|0,c[(c[e>>2]|0)+212>>2]|0);jF(c[d>>2]|0,105875)|0;i=b;return}default:{i=b;return}}}function _c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[(c[h>>2]|0)+16>>2];$c(c[h>>2]|0,c[(c[n>>2]|0)+264>>2]|0,c[(c[n>>2]|0)+272>>2]|0,c[(c[n>>2]|0)+268>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0);i=g;return}function $c(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0;m=i;i=i+176|0;n=m+120|0;o=m+112|0;p=m+96|0;q=m+80|0;r=m+56|0;s=m+48|0;t=m+40|0;u=m+24|0;v=m;w=m+160|0;x=m+156|0;y=m+152|0;z=m+148|0;A=m+144|0;B=m+140|0;C=m+136|0;D=m+132|0;E=m+128|0;c[w>>2]=b;c[x>>2]=d;c[y>>2]=e;c[z>>2]=f;c[A>>2]=g;c[B>>2]=j;c[C>>2]=k;c[D>>2]=l;if(!((c[y>>2]|0)!=0&(c[z>>2]|0)!=0)){i=m;return}if((c[11406]|0)<(c[z>>2]|0)){c[11406]=(c[z>>2]|0)+10;c[11407]=Q4(c[11407]|0,c[11406]<<3)|0}c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[z>>2]|0))break;F=+h[(c[y>>2]|0)+(c[E>>2]<<4)>>3];c[(c[11407]|0)+(c[E>>2]<<3)>>2]=~~(+h[(c[y>>2]|0)+(c[E>>2]<<4)>>3]>=0.0?F+.5:F-.5);F=+h[(c[y>>2]|0)+(c[E>>2]<<4)+8>>3];c[(c[11407]|0)+(c[E>>2]<<3)+4>>2]=~~(+h[(c[y>>2]|0)+(c[E>>2]<<4)+8>>3]>=0.0?F+.5:F-.5);c[E>>2]=(c[E>>2]|0)+1}if(((c[A>>2]|0)!=0?(c[(c[w>>2]|0)+60+4>>2]|0)==0:0)?(a[c[A>>2]>>0]|0)!=0:0)switch(c[x>>2]|0){case 0:{y=c[w>>2]|0;l=c[c[11407]>>2]|0;k=c[(c[11407]|0)+8+4>>2]|0;j=c[(c[11407]|0)+8>>2]|0;g=c[(c[11407]|0)+4>>2]|0;c[v>>2]=c[A>>2];c[v+4>>2]=l;c[v+8>>2]=k;c[v+12>>2]=j;c[v+16>>2]=g;oF(y,105611,v);i=m;return}case 1:{v=c[w>>2]|0;y=c[c[11407]>>2]|0;g=c[(c[11407]|0)+4>>2]|0;j=(c[(c[11407]|0)+8>>2]|0)-(c[c[11407]>>2]|0)|0;c[u>>2]=c[A>>2];c[u+4>>2]=y;c[u+8>>2]=g;c[u+12>>2]=j;oF(v,105632,u);i=m;return}case 2:{u=c[w>>2]|0;c[t>>2]=c[A>>2];oF(u,105652,t);c[E>>2]=0;while(1){G=c[w>>2]|0;if((c[E>>2]|0)>=(c[z>>2]|0))break;t=c[(c[11407]|0)+(c[E>>2]<<3)+4>>2]|0;c[s>>2]=c[(c[11407]|0)+(c[E>>2]<<3)>>2];c[s+4>>2]=t;oF(G,105660,s);c[E>>2]=(c[E>>2]|0)+1}jF(G,193392)|0;i=m;return}default:La(176099,105667,65,105687)}if(((c[A>>2]|0)!=0?(c[(c[w>>2]|0)+60+4>>2]|0)==1:0)?(a[c[A>>2]>>0]|0)!=0:0){if(c[x>>2]|0)La(176099,105667,77,105687);G=c[w>>2]|0;s=c[(c[11407]|0)+8+4>>2]|0;t=c[(c[11407]|0)+8>>2]|0;u=c[(c[11407]|0)+4>>2]|0;v=c[A>>2]|0;j=c[B>>2]|0;c[r>>2]=c[c[11407]>>2];c[r+4>>2]=s;c[r+8>>2]=t;c[r+12>>2]=u;c[r+16>>2]=v;c[r+20>>2]=j;oF(G,105704,r);i=m;return}if((c[(c[w>>2]|0)+60+4>>2]|0)!=2?(c[(c[w>>2]|0)+60+4>>2]|0)!=3:0){i=m;return}switch(c[x>>2]|0){case 1:{jF(c[w>>2]|0,105737)|0;break}case 0:{jF(c[w>>2]|0,105758)|0;break}case 2:{jF(c[w>>2]|0,105777)|0;break}default:La(176099,105667,93,105687)}if((c[D>>2]|0)!=0?(a[c[D>>2]>>0]|0)!=0:0){jF(c[w>>2]|0,105796)|0;r=c[w>>2]|0;jF(r,ZJ(c[D>>2]|0)|0)|0;jF(c[w>>2]|0,136329)|0}if((c[A>>2]|0)!=0?(a[c[A>>2]>>0]|0)!=0:0){jF(c[w>>2]|0,105802)|0;D=c[w>>2]|0;jF(D,ZJ(c[A>>2]|0)|0)|0;jF(c[w>>2]|0,136329)|0}if((c[C>>2]|0)!=0?(a[c[C>>2]>>0]|0)!=0:0){jF(c[w>>2]|0,111736)|0;A=c[w>>2]|0;jF(A,XJ(c[C>>2]|0)|0)|0;jF(c[w>>2]|0,136329)|0}if((c[B>>2]|0)!=0?(a[c[B>>2]>>0]|0)!=0:0){jF(c[w>>2]|0,105810)|0;C=c[w>>2]|0;jF(C,XJ(c[B>>2]|0)|0)|0;jF(c[w>>2]|0,136329)|0}jF(c[w>>2]|0,105819)|0;jF(c[w>>2]|0,105827)|0;a:do switch(c[x>>2]|0){case 1:{B=c[w>>2]|0;C=c[(c[11407]|0)+4>>2]|0;A=(c[(c[11407]|0)+8>>2]|0)-(c[c[11407]>>2]|0)|0;c[q>>2]=c[c[11407]>>2];c[q+4>>2]=C;c[q+8>>2]=A;oF(B,105837,q);break}case 0:{B=c[w>>2]|0;A=c[(c[11407]|0)+8+4>>2]|0;C=c[(c[11407]|0)+8>>2]|0;D=c[(c[11407]|0)+4>>2]|0;c[p>>2]=c[c[11407]>>2];c[p+4>>2]=A;c[p+8>>2]=C;c[p+12>>2]=D;oF(B,105846,p);break}case 2:{B=c[w>>2]|0;D=c[(c[11407]|0)+4>>2]|0;c[o>>2]=c[c[11407]>>2];c[o+4>>2]=D;oF(B,105858,o);c[E>>2]=1;while(1){if((c[E>>2]|0)>=(c[z>>2]|0))break a;B=c[w>>2]|0;D=c[(c[11407]|0)+(c[E>>2]<<3)+4>>2]|0;c[n>>2]=c[(c[11407]|0)+(c[E>>2]<<3)>>2];c[n+4>>2]=D;oF(B,105864,n);c[E>>2]=(c[E>>2]|0)+1}break}default:{}}while(0);E=c[w>>2]|0;if((c[(c[w>>2]|0)+60+4>>2]|0)==3){jF(E,110674)|0;i=m;return}else{jF(E,105871)|0;i=m;return}}function ad(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+12|0;c[e>>2]=a;jF(c[e>>2]|0,110515)|0;a=c[e>>2]|0;if((c[(c[e>>2]|0)+60+4>>2]|0)==2)jF(a,110530)|0;else jF(a,193392)|0;a=c[e>>2]|0;f=c[(c[c[(c[e>>2]|0)+12>>2]>>2]|0)+4>>2]|0;g=c[(c[c[(c[e>>2]|0)+12>>2]>>2]|0)+8>>2]|0;c[d>>2]=c[c[c[(c[e>>2]|0)+12>>2]>>2]>>2];c[d+4>>2]=f;c[d+8>>2]=g;oF(a,110541,d);i=b;return}function bd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+8|0;e=b;f=b+24|0;c[f>>2]=a;jF(c[f>>2]|0,110469)|0;if((c[(c[f>>2]|0)+60+4>>2]|0)!=2){a=c[f>>2]|0;c[e>>2]=c[(c[(c[f>>2]|0)+12>>2]|0)+28>>2];oF(a,110480,e)}if(c[(c[(c[f>>2]|0)+12>>2]|0)+20>>2]|0){g=c[f>>2]|0;jF(g,110495)|0;h=c[f>>2]|0;jF(h,110508)|0;i=b;return}if((c[(c[f>>2]|0)+60+4>>2]|0)==2){g=c[f>>2]|0;jF(g,110495)|0;h=c[f>>2]|0;jF(h,110508)|0;i=b;return}e=c[f>>2]|0;a=c[(c[f>>2]|0)+472+4>>2]|0;j=c[(c[f>>2]|0)+472+8>>2]|0;k=c[(c[f>>2]|0)+472+8+4>>2]|0;c[d>>2]=c[(c[f>>2]|0)+472>>2];c[d+4>>2]=a;c[d+8>>2]=j;c[d+12>>2]=k;oF(e,106833,d);g=c[f>>2]|0;jF(g,110495)|0;h=c[f>>2]|0;jF(h,110508)|0;i=b;return}function cd(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+24|0;g=e+8|0;h=e;j=e+44|0;k=e+40|0;l=e+32|0;c[j>>2]=b;c[k>>2]=c[(c[j>>2]|0)+16>>2];a[106763]=0;if(!(c[(c[(c[j>>2]|0)+12>>2]|0)+28>>2]|0)){b=c[j>>2]|0;c[h>>2]=wB(c[(c[k>>2]|0)+8>>2]|0)|0;oF(b,106764,h);h=c[j>>2]|0;if((c[(c[j>>2]|0)+60+4>>2]|0)!=2)jF(h,106779)|0;else jF(h,106797)|0;do if(!(c[(c[(c[j>>2]|0)+12>>2]|0)+20>>2]|0)){h=c[j>>2]|0;if((c[(c[j>>2]|0)+60+4>>2]|0)!=2){jF(h,106809)|0;break}else{b=c[(c[j>>2]|0)+456+4>>2]|0;m=c[(c[j>>2]|0)+456+8>>2]|0;n=c[(c[j>>2]|0)+456+8+4>>2]|0;c[g>>2]=c[(c[j>>2]|0)+456>>2];c[g+4>>2]=b;c[g+8>>2]=m;c[g+12>>2]=n;oF(h,106833,g);break}}while(0);jF(c[j>>2]|0,106863)|0;HL(c[j>>2]|0,c[(c[(c[j>>2]|0)+12>>2]|0)+24>>2]|0,45876);JL(c[j>>2]|0);if(c[(c[(c[j>>2]|0)+12>>2]|0)+20>>2]|0){c[l>>2]=c[c[(c[(c[j>>2]|0)+12>>2]|0)+20>>2]>>2];c[l+4>>2]=0;HL(c[j>>2]|0,0,l)}}c[11468]=(d[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+115>>0]|0)==1?1:-1;if(!(a[106763]|0)){jF(c[j>>2]|0,106883)|0;a[106763]=1}if(!(c[(c[k>>2]|0)+208>>2]|0)){i=e;return}l=c[j>>2]|0;c[f>>2]=KL(c[(c[k>>2]|0)+208>>2]|0,c[11468]|0)|0;oF(l,106896,f);i=e;return}function dd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+12|0;k=f+8|0;c[h>>2]=a;c[f+16>>2]=b;c[j>>2]=d;c[k>>2]=e;e=c[h>>2]|0;h=c[k>>2]|0;c[g>>2]=c[j>>2];c[g+4>>2]=h;oF(e,106747,g);i=f;return}function ed(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0;b=i;i=i+176|0;d=b+128|0;e=b+112|0;f=b+72|0;g=b+56|0;j=b+40|0;k=b+32|0;l=b+24|0;m=b+8|0;n=b;o=b+160|0;p=b+144|0;c[o>>2]=a;a=(c[o>>2]|0)+456|0;c[p>>2]=c[a>>2];c[p+4>>2]=c[a+4>>2];c[p+8>>2]=c[a+8>>2];c[p+12>>2]=c[a+12>>2];a=c[o>>2]|0;q=(c[(c[(c[o>>2]|0)+12>>2]|0)+28>>2]|0)+1|0;c[n>>2]=(c[(c[(c[o>>2]|0)+12>>2]|0)+28>>2]|0)+1;c[n+4>>2]=q;oF(a,106374,n);if(!(c[(c[(c[o>>2]|0)+12>>2]|0)+20>>2]|0)){n=c[o>>2]|0;a=c[p+4>>2]|0;q=c[p+8>>2]|0;r=c[p+8+4>>2]|0;c[m>>2]=c[p>>2];c[m+4>>2]=a;c[m+8>>2]=q;c[m+12>>2]=r;oF(n,106391,m)}m=c[o>>2]|0;c[l>>2]=(c[(c[o>>2]|0)+360>>2]|0)!=0?106425:106435;oF(m,106444,l);if((c[(c[o>>2]|0)+60+4>>2]|0)==1){l=c[o>>2]|0;m=c[p+8+4>>2]|0;c[k>>2]=c[p+8>>2];c[k+4>>2]=m;oF(l,106469,k)}k=c[o>>2]|0;l=c[(c[o>>2]|0)+196+4>>2]|0;m=c[(c[o>>2]|0)+204>>2]|0;c[j>>2]=c[(c[o>>2]|0)+196>>2];c[j+4>>2]=l;c[j+8>>2]=m;oF(k,106508,j);if(!(c[(c[(c[o>>2]|0)+12>>2]|0)+20>>2]|0)){j=c[o>>2]|0;k=c[p+4>>2]|0;m=(c[p+8>>2]|0)-(c[p>>2]|0)|0;l=(c[p+8+4>>2]|0)-(c[p+4>>2]|0)|0;c[g>>2]=c[p>>2];c[g+4>>2]=k;c[g+8>>2]=m;c[g+12>>2]=l;oF(j,106528,g)}g=c[o>>2]|0;s=+h[(c[o>>2]|0)+488+8>>3];j=c[(c[o>>2]|0)+360>>2]|0;t=+h[(c[o>>2]|0)+504>>3];u=+h[(c[o>>2]|0)+504+8>>3];h[f>>3]=+h[(c[o>>2]|0)+488>>3];h[f+8>>3]=s;c[f+16>>2]=j;h[f+24>>3]=t;h[f+32>>3]=u;oF(g,106568,f);if((c[(c[o>>2]|0)+60+4>>2]|0)!=1){i=b;return}if(!((c[p+8>>2]|0)<14400?(c[p+8+4>>2]|0)<14400:0)){f=c[(c[(c[o>>2]|0)+12>>2]|0)+16>>2]|0;g=c[p+8+4>>2]|0;c[e>>2]=c[p+8>>2];c[e+4>>2]=g;c[e+8>>2]=14400;Db[f&31](106611,e)}e=c[o>>2]|0;o=c[p+4>>2]|0;f=c[p+8>>2]|0;g=c[p+8+4>>2]|0;c[d>>2]=c[p>>2];c[d+4>>2]=o;c[d+8>>2]=f;c[d+12>>2]=g;oF(e,106706,d);i=b;return}function fd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;if(c[(c[(c[e>>2]|0)+12>>2]|0)+20>>2]|0){jF(c[e>>2]|0,106298)|0;HL(c[e>>2]|0,0,(c[(c[(c[e>>2]|0)+12>>2]|0)+20>>2]|0)+4|0)}jF(c[e>>2]|0,106315)|0;jF(c[e>>2]|0,106342)|0;a=c[e>>2]|0;c[d>>2]=c[(c[(c[e>>2]|0)+12>>2]|0)+28>>2];oF(a,106357,d);i=b;return}function gd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=b+8|0;f=b+4|0;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+16>>2];a=c[e>>2]|0;c[d>>2]=wB(c[(c[f>>2]|0)+8>>2]|0)|0;oF(a,106291,d);jF(c[e>>2]|0,106284)|0;i=b;return}function hd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,121737)|0;i=b;return}function id(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,106284)|0;i=b;return}function jd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,121737)|0;i=b;return}function kd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,106284)|0;i=b;return}function ld(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,121737)|0;i=b;return}function md(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+4|0;c[j>>2]=a;c[k>>2]=b;c[g+16>>2]=d;c[g+12>>2]=e;c[g+8>>2]=f;c[l>>2]=c[(c[j>>2]|0)+16>>2];if(!(c[k>>2]|0)){i=g;return}if(!(c[(c[l>>2]|0)+272>>2]|0)){i=g;return}jF(c[j>>2]|0,106180)|0;rF(c[j>>2]|0,c[(c[l>>2]|0)+272>>2]|0,2);jF(c[j>>2]|0,106191)|0;l=c[j>>2]|0;c[h>>2]=KL(c[k>>2]|0,c[11468]|0)|0;oF(l,106195,h);i=g;return}function nd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+8|0;j=f;k=f+32|0;l=f+28|0;m=f+24|0;c[k>>2]=b;c[l>>2]=e;if(+h[(c[(c[k>>2]|0)+16>>2]|0)+16+24>>3]<.5){i=f;return}ud(c[k>>2]|0,(c[(c[k>>2]|0)+16>>2]|0)+16|0);pF(c[k>>2]|0,+h[(c[(c[l>>2]|0)+4>>2]|0)+16>>3]);e=c[k>>2]|0;c[g>>2]=c[c[(c[l>>2]|0)+4>>2]>>2];oF(e,106139,g);c[m>>2]=KL(c[c[l>>2]>>2]|0,c[11468]|0)|0;switch(a[(c[l>>2]|0)+48>>0]|0){case 114:{h[d>>3]=+h[d>>3]-+h[(c[l>>2]|0)+32>>3];break}case 108:{h[d>>3]=+h[d>>3]-0.0;break}default:h[d>>3]=+h[d>>3]-+h[(c[l>>2]|0)+32>>3]/2.0}e=d+8|0;h[e>>3]=+h[e>>3]+ +h[(c[l>>2]|0)+24>>3];e=c[k>>2]|0;c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];qF(e,g);jF(c[k>>2]|0,106154)|0;pF(c[k>>2]|0,+h[(c[l>>2]|0)+32>>3]);l=c[k>>2]|0;c[j>>2]=c[m>>2];oF(l,106163,j);i=f;return}function od(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;j=e+32|0;k=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;d=c[g>>2]|0;c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];h[k+16>>3]=+h[(c[g>>2]|0)+16>>3]-+h[c[g>>2]>>3];h[k+16+8>>3]=+h[(c[g>>2]|0)+16+8>>3]-+h[(c[g>>2]|0)+8>>3];if((c[j>>2]|0)!=0?+h[(c[(c[f>>2]|0)+16>>2]|0)+56+24>>3]>.5:0){ud(c[f>>2]|0,(c[(c[f>>2]|0)+16>>2]|0)+56|0);rF(c[f>>2]|0,k,2);jF(c[f>>2]|0,106097)|0}if(!(+h[(c[(c[f>>2]|0)+16>>2]|0)+16+24>>3]>.5)){i=e;return}vd(c[f>>2]|0);ud(c[f>>2]|0,(c[(c[f>>2]|0)+16>>2]|0)+16|0);rF(c[f>>2]|0,k,2);jF(c[f>>2]|0,106117)|0;i=e;return}function pd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;if((c[m>>2]|0)!=0?+h[(c[(c[j>>2]|0)+16>>2]|0)+56+24>>3]>.5:0){ud(c[j>>2]|0,(c[(c[j>>2]|0)+16>>2]|0)+56|0);jF(c[j>>2]|0,106018)|0;m=c[j>>2]|0;e=c[k>>2]|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];qF(m,g);jF(c[j>>2]|0,106027)|0;c[n>>2]=1;while(1){o=c[j>>2]|0;if((c[n>>2]|0)>=(c[l>>2]|0))break;m=(c[k>>2]|0)+(c[n>>2]<<4)|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];qF(o,g);jF(c[j>>2]|0,106036)|0;c[n>>2]=(c[n>>2]|0)+1}jF(o,106063)|0}if(!(+h[(c[(c[j>>2]|0)+16>>2]|0)+16+24>>3]>.5)){i=f;return}vd(c[j>>2]|0);ud(c[j>>2]|0,(c[(c[j>>2]|0)+16>>2]|0)+16|0);jF(c[j>>2]|0,106018)|0;o=c[j>>2]|0;m=c[k>>2]|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];qF(o,g);jF(c[j>>2]|0,106027)|0;c[n>>2]=1;while(1){p=c[j>>2]|0;if((c[n>>2]|0)>=(c[l>>2]|0))break;o=(c[k>>2]|0)+(c[n>>2]<<4)|0;c[g>>2]=c[o>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];qF(p,g);jF(c[j>>2]|0,106036)|0;c[n>>2]=(c[n>>2]|0)+1}jF(p,106079)|0;i=f;return}function qd(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+48|0;k=j;l=j+40|0;m=j+36|0;n=j+32|0;o=j+20|0;p=j+16|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[j+28>>2]=e;c[j+24>>2]=f;c[o>>2]=g;if((c[o>>2]|0)!=0?+h[(c[(c[l>>2]|0)+16>>2]|0)+56+24>>3]>.5:0){ud(c[l>>2]|0,(c[(c[l>>2]|0)+16>>2]|0)+56|0);jF(c[l>>2]|0,106018)|0;o=c[l>>2]|0;g=c[m>>2]|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];qF(o,k);jF(c[l>>2]|0,106027)|0;c[p>>2]=1;while(1){q=c[l>>2]|0;if((c[p>>2]|0)>=(c[n>>2]|0))break;rF(q,(c[m>>2]|0)+(c[p>>2]<<4)|0,3);jF(c[l>>2]|0,106053)|0;c[p>>2]=(c[p>>2]|0)+3}jF(q,106063)|0}if(!(+h[(c[(c[l>>2]|0)+16>>2]|0)+16+24>>3]>.5)){i=j;return}vd(c[l>>2]|0);ud(c[l>>2]|0,(c[(c[l>>2]|0)+16>>2]|0)+16|0);jF(c[l>>2]|0,106018)|0;q=c[l>>2]|0;o=c[m>>2]|0;c[k>>2]=c[o>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];qF(q,k);jF(c[l>>2]|0,106027)|0;c[p>>2]=1;while(1){r=c[l>>2]|0;if((c[p>>2]|0)>=(c[n>>2]|0))break;rF(r,(c[m>>2]|0)+(c[p>>2]<<4)|0,3);jF(c[l>>2]|0,106053)|0;c[p>>2]=(c[p>>2]|0)+3}jF(r,106045)|0;i=j;return}function rd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;if(!(+h[(c[(c[g>>2]|0)+16>>2]|0)+16+24>>3]>.5)){i=e;return}vd(c[g>>2]|0);ud(c[g>>2]|0,(c[(c[g>>2]|0)+16>>2]|0)+16|0);jF(c[g>>2]|0,106018)|0;d=c[g>>2]|0;b=c[j>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];qF(d,f);jF(c[g>>2]|0,106027)|0;c[l>>2]=1;while(1){m=c[g>>2]|0;if((c[l>>2]|0)>=(c[k>>2]|0))break;d=(c[j>>2]|0)+(c[l>>2]<<4)|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];qF(m,f);jF(c[g>>2]|0,106036)|0;c[l>>2]=(c[l>>2]|0)+1}jF(m,106045)|0;i=e;return}function sd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;jF(c[e>>2]|0,106015)|0;jF(c[e>>2]|0,c[f>>2]|0)|0;jF(c[e>>2]|0,193392)|0;i=d;return}function td(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+64|0;j=g+16|0;k=g+8|0;l=g;m=g+48|0;n=g+44|0;o=g+40|0;p=g+36|0;q=g+32|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;if((c[q>>2]|0)!=0?+h[(c[(c[m>>2]|0)+16>>2]|0)+56+24>>3]>.5:0){ud(c[m>>2]|0,(c[(c[m>>2]|0)+16>>2]|0)+56|0);jF(c[m>>2]|0,121632)|0;rF(c[m>>2]|0,c[o>>2]|0,c[p>>2]|0);jF(c[m>>2]|0,140232)|0;q=c[m>>2]|0;f=c[o>>2]|0;c[j>>2]=c[f>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];qF(q,j);q=c[m>>2]|0;f=c[n>>2]|0;c[l>>2]=c[p>>2];c[l+4>>2]=f;oF(q,105932,l)}if(!(+h[(c[(c[m>>2]|0)+16>>2]|0)+16+24>>3]>.5)){i=g;return}vd(c[m>>2]|0);ud(c[m>>2]|0,(c[(c[m>>2]|0)+16>>2]|0)+16|0);jF(c[m>>2]|0,121632)|0;rF(c[m>>2]|0,c[o>>2]|0,c[p>>2]|0);jF(c[m>>2]|0,140232)|0;l=c[m>>2]|0;q=c[o>>2]|0;c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];qF(l,j);j=c[m>>2]|0;m=c[n>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=m;oF(j,105948,k);i=g;return}function ud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;i=i+48|0;e=d;f=d+40|0;g=d+36|0;j=d+32|0;c[f>>2]=a;c[g>>2]=b;if(!(c[g>>2]|0)){i=d;return}switch(c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0){case 1:case 0:{c[j>>2]=149098;break}case 2:{c[j>>2]=149084;break}case 3:{c[j>>2]=149079;break}default:c[j>>2]=105984}b=c[f>>2]|0;k=+h[(c[g>>2]|0)+8>>3];l=+h[(c[g>>2]|0)+16>>3];f=c[j>>2]|0;h[e>>3]=+h[c[g>>2]>>3];h[e+8>>3]=k;h[e+16>>3]=l;c[e+24>>2]=f;oF(b,105991,e);i=d;return}function vd(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+48|0;e=d+16|0;f=d+8|0;g=d+32|0;j=d;k=d+28|0;l=d+24|0;m=d+20|0;c[g>>2]=b;h[j>>3]=+h[(c[(c[g>>2]|0)+16>>2]|0)+152>>3];c[m>>2]=c[(c[(c[g>>2]|0)+16>>2]|0)+160>>2];pF(c[g>>2]|0,+h[j>>3]);jF(c[g>>2]|0,105965)|0;while(1){if(!(c[m>>2]|0)){n=12;break}j=c[m>>2]|0;c[m>>2]=j+4;b=c[j>>2]|0;c[l>>2]=b;c[k>>2]=b;if(!b){n=12;break}if(!(J3(c[l>>2]|0,148650)|0))continue;do{b=(a[c[k>>2]>>0]|0)!=0;c[k>>2]=(c[k>>2]|0)+1}while(b);a:while(1){if(!(a[c[k>>2]>>0]|0))break;b=c[g>>2]|0;c[f>>2]=c[k>>2];oF(b,105980,f);while(1){b=(a[c[k>>2]>>0]|0)!=0;c[k>>2]=(c[k>>2]|0)+1;if(!b)continue a}}if(!(J3(c[l>>2]|0,171938)|0))h[(c[(c[g>>2]|0)+16>>2]|0)+152>>3]=0.0;b=c[g>>2]|0;c[e>>2]=c[l>>2];oF(b,134465,e)}if((n|0)==12){i=d;return}}function wd(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;jF(c[e>>2]|0,112090)|0;b=yA(c[(c[c[e>>2]>>2]|0)+168>>2]|0,112146)|0;c[f>>2]=b;if((b|0)!=0?(a[c[f>>2]>>0]|0)!=0:0){jF(c[e>>2]|0,112157)|0;jF(c[e>>2]|0,c[f>>2]|0)|0;jF(c[e>>2]|0,112181)|0}jF(c[e>>2]|0,112202)|0;jF(c[e>>2]|0,112250)|0;jF(c[e>>2]|0,112304)|0;f=c[e>>2]|0;jF(f,XJ(c[c[c[(c[e>>2]|0)+12>>2]>>2]>>2]|0)|0)|0;jF(c[e>>2]|0,115407)|0;f=c[e>>2]|0;jF(f,XJ(c[(c[c[(c[e>>2]|0)+12>>2]>>2]|0)+4>>2]|0)|0)|0;jF(c[e>>2]|0,115417)|0;f=c[e>>2]|0;jF(f,XJ(c[(c[c[(c[e>>2]|0)+12>>2]>>2]|0)+8>>2]|0)|0)|0;jF(c[e>>2]|0,112628)|0;jF(c[e>>2]|0,112731)|0;i=d;return}function xd(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;d=i;i=i+64|0;e=d+16|0;f=d+8|0;g=d;j=d+52|0;k=d+48|0;c[j>>2]=b;c[k>>2]=c[(c[j>>2]|0)+16>>2];jF(c[j>>2]|0,111925)|0;if(a[(wB(c[(c[k>>2]|0)+8>>2]|0)|0)>>0]|0){jF(c[j>>2]|0,112591)|0;b=c[j>>2]|0;jF(b,XJ(wB(c[(c[k>>2]|0)+8>>2]|0)|0)|0)|0}k=c[j>>2]|0;c[g>>2]=_(c[(c[j>>2]|0)+164>>2]|0,c[(c[j>>2]|0)+164+4>>2]|0)|0;oF(k,111930,g);g=c[j>>2]|0;k=c[(c[j>>2]|0)+452>>2]|0;c[f>>2]=c[(c[j>>2]|0)+448>>2];c[f+4>>2]=k;oF(g,111946,f);f=c[j>>2]|0;l=+h[(c[j>>2]|0)+384+8>>3];m=+h[(c[j>>2]|0)+384+16>>3];n=+h[(c[j>>2]|0)+384+16+8>>3];h[e>>3]=+h[(c[j>>2]|0)+384>>3];h[e+8>>3]=l;h[e+16>>3]=m;h[e+24>>3]=n;oF(f,111979,e);jF(c[j>>2]|0,112010)|0;jF(c[j>>2]|0,112046)|0;jF(c[j>>2]|0,113614)|0;i=d;return}function yd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,111917)|0;i=b;return}function zd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;c[g>>2]=a;c[h>>2]=b;c[f+4>>2]=d;c[f>>2]=e;jF(c[g>>2]|0,111746)|0;e=c[g>>2]|0;jF(e,XJ(c[h>>2]|0)|0)|0;jF(c[g>>2]|0,111899)|0;i=f;return}function Ad(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,111690)|0;i=b;return}function Bd(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0.0;d=i;i=i+48|0;e=d;f=d+44|0;g=d+40|0;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+16>>2];jF(c[f>>2]|0,111746)|0;b=c[f>>2]|0;jF(b,XJ(c[(c[g>>2]|0)+212>>2]|0)|0)|0;jF(c[f>>2]|0,111827)|0;b=c[f>>2]|0;j=+h[(c[f>>2]|0)+488+8>>3];k=0-(c[(c[f>>2]|0)+360>>2]|0)|0;l=+h[(c[f>>2]|0)+504>>3];m=-+h[(c[f>>2]|0)+504+8>>3];h[e>>3]=+h[(c[f>>2]|0)+488>>3];h[e+8>>3]=j;c[e+16>>2]=k;h[e+24>>3]=l;h[e+32>>3]=m;oF(b,111843,e);if(!(a[(wB(c[(c[g>>2]|0)+8>>2]|0)|0)>>0]|0)){i=d;return}jF(c[f>>2]|0,111770)|0;e=c[f>>2]|0;jF(e,XJ(wB(c[(c[g>>2]|0)+8>>2]|0)|0)|0)|0;jF(c[f>>2]|0,111778)|0;i=d;return}function Cd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,111690)|0;i=b;return}function Dd(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+16>>2];jF(c[d>>2]|0,111746)|0;a=c[d>>2]|0;jF(a,XJ(c[(c[e>>2]|0)+212>>2]|0)|0)|0;jF(c[d>>2]|0,111808)|0;jF(c[d>>2]|0,111770)|0;a=c[d>>2]|0;jF(a,XJ(wB(c[(c[e>>2]|0)+8>>2]|0)|0)|0)|0;jF(c[d>>2]|0,111778)|0;i=b;return}function Ed(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,111690)|0;i=b;return}function Fd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=b+8|0;f=b+4|0;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+16>>2];jF(c[e>>2]|0,111746)|0;a=c[e>>2]|0;jF(a,XJ(c[(c[f>>2]|0)+212>>2]|0)|0)|0;if((c[(c[e>>2]|0)+160>>2]|0)>1){a=c[e>>2]|0;c[d>>2]=XJ(c[(c[(c[c[e>>2]>>2]|0)+308>>2]|0)+(c[(c[e>>2]|0)+160>>2]<<2)>>2]|0)|0;oF(a,111788,d)}jF(c[e>>2]|0,111792)|0;jF(c[e>>2]|0,111770)|0;d=c[e>>2]|0;jF(d,XJ(wB(c[(c[f>>2]|0)+8>>2]|0)|0)|0)|0;jF(c[e>>2]|0,111778)|0;i=b;return}function Gd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,111690)|0;i=b;return}function Hd(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+16>>2];jF(c[d>>2]|0,111746)|0;a=c[d>>2]|0;jF(a,XJ(c[(c[e>>2]|0)+212>>2]|0)|0)|0;jF(c[d>>2]|0,111754)|0;jF(c[d>>2]|0,111770)|0;c[f>>2]=WJ(139926,c[(c[e>>2]|0)+8>>2]|0)|0;e=c[d>>2]|0;jF(e,XJ(c[f>>2]|0)|0)|0;O4(c[f>>2]|0);jF(c[d>>2]|0,111778)|0;i=b;return}function Id(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,111690)|0;i=b;return}function Jd(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;jF(c[j>>2]|0,111696)|0;if(c[n>>2]|0){jF(c[j>>2]|0,111699)|0;g=c[j>>2]|0;jF(g,XJ(c[n>>2]|0)|0)|0;jF(c[j>>2]|0,136329)|0}jF(c[j>>2]|0,111679)|0;jF(c[j>>2]|0,113575)|0;if((c[k>>2]|0)!=0?(a[c[k>>2]>>0]|0)!=0:0){jF(c[j>>2]|0,111707)|0;jF(c[j>>2]|0,c[k>>2]|0)|0;jF(c[j>>2]|0,136329)|0}if((c[l>>2]|0)!=0?(a[c[l>>2]>>0]|0)!=0:0){jF(c[j>>2]|0,111721)|0;k=c[j>>2]|0;jF(k,XJ(c[l>>2]|0)|0)|0;jF(c[j>>2]|0,136329)|0}if(!(c[m>>2]|0)){o=c[j>>2]|0;jF(o,113614)|0;i=h;return}if(!(a[c[m>>2]>>0]|0)){o=c[j>>2]|0;jF(o,113614)|0;i=h;return}jF(c[j>>2]|0,111736)|0;l=c[j>>2]|0;jF(l,XJ(c[m>>2]|0)|0)|0;jF(c[j>>2]|0,136329)|0;o=c[j>>2]|0;jF(o,113614)|0;i=h;return}function Kd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,113569)|0;jF(c[d>>2]|0,111690)|0;i=b;return}function Ld(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0,S=0;g=i;i=i+208|0;j=g+152|0;k=g+144|0;l=g+136|0;m=g+128|0;n=g+120|0;o=g+112|0;p=g+104|0;q=g+96|0;r=g+88|0;s=g+80|0;t=g+72|0;u=g+64|0;v=g+56|0;w=g+48|0;x=g+40|0;y=g+32|0;z=g+24|0;A=g+16|0;B=g;C=g+200|0;D=g+196|0;E=g+192|0;F=g+188|0;G=g+184|0;H=g+180|0;I=g+176|0;J=g+172|0;K=g+168|0;L=g+164|0;c[C>>2]=b;c[D>>2]=f;c[E>>2]=c[(c[C>>2]|0)+16>>2];c[G>>2]=0;c[H>>2]=0;c[I>>2]=0;c[J>>2]=0;jF(c[C>>2]|0,111307)|0;switch(a[(c[D>>2]|0)+48>>0]|0){case 108:{jF(c[C>>2]|0,111313)|0;break}case 114:{jF(c[C>>2]|0,111334)|0;break}default:jF(c[C>>2]|0,111353)|0}f=e+8|0;h[f>>3]=+h[f>>3]+ +h[(c[D>>2]|0)+24>>3];f=c[C>>2]|0;M=-+h[e+8>>3];h[B>>3]=+h[e>>3];h[B+8>>3]=M;oF(f,111375,B);c[F>>2]=c[(c[(c[D>>2]|0)+4>>2]|0)+8>>2];B=c[C>>2]|0;if(c[F>>2]|0){switch(c[(c[(c[(c[B>>2]|0)+168>>2]|0)+8>>2]|0)+244>>2]|0){case 1:{c[G>>2]=c[c[F>>2]>>2];c[H>>2]=c[(c[F>>2]|0)+8>>2];c[J>>2]=c[(c[F>>2]|0)+16>>2];break}case 2:{c[G>>2]=c[(c[F>>2]|0)+24>>2];c[H>>2]=c[(c[F>>2]|0)+28>>2];c[J>>2]=c[(c[F>>2]|0)+32>>2];break}default:{c[G>>2]=c[(c[F>>2]|0)+4>>2];c[H>>2]=c[(c[F>>2]|0)+8>>2];c[J>>2]=c[(c[F>>2]|0)+16>>2]}}c[I>>2]=c[(c[F>>2]|0)+12>>2];f=c[C>>2]|0;c[A>>2]=c[G>>2];oF(f,111390,A);if(c[(c[F>>2]|0)+24>>2]|0){A=c[C>>2]|0;c[z>>2]=c[(c[F>>2]|0)+24>>2];oF(A,111407,z)}jF(c[C>>2]|0,136329)|0;if(c[H>>2]|0){z=c[C>>2]|0;c[y>>2]=c[H>>2];oF(z,111411,y)}if(c[I>>2]|0){y=c[C>>2]|0;c[x>>2]=c[I>>2];oF(y,111429,x)}if(c[J>>2]|0){x=c[C>>2]|0;c[w>>2]=c[J>>2];oF(x,111448,w)}}else{c[v>>2]=c[c[(c[D>>2]|0)+4>>2]>>2];oF(B,111465,v)}if((c[(c[D>>2]|0)+4>>2]|0)!=0?(v=c[(c[(c[D>>2]|0)+4>>2]|0)+24>>2]&127,c[K>>2]=v,(v|0)!=0):0){if(!((c[K>>2]&1|0)==0|(c[H>>2]|0)!=0))oF(c[C>>2]|0,111483,u);if(!((c[K>>2]&2|0)==0|(c[J>>2]|0)!=0))oF(c[C>>2]|0,111503,t);if(c[K>>2]&100){c[L>>2]=0;oF(c[C>>2]|0,111524,s);if(c[K>>2]&4){oF(c[C>>2]|0,143412,r);c[L>>2]=1}if(c[K>>2]&64){r=c[C>>2]|0;c[q>>2]=(c[L>>2]|0)!=0?138350:178518;oF(r,111543,q);c[L>>2]=1}if(c[K>>2]&32){q=c[C>>2]|0;c[p>>2]=(c[L>>2]|0)!=0?138350:178518;oF(q,111554,p)}oF(c[C>>2]|0,136329,o)}if(c[K>>2]&8)oF(c[C>>2]|0,111569,n);if(c[K>>2]&16)oF(c[C>>2]|0,111593,m)}m=c[C>>2]|0;h[l>>3]=+h[(c[(c[D>>2]|0)+4>>2]|0)+16>>3];oF(m,111615,l);switch(c[(c[E>>2]|0)+16+32>>2]|0){case 5:{if(!(F3(c[(c[E>>2]|0)+16>>2]|0,174917)|0)){N=c[C>>2]|0;jF(N,111679)|0;O=c[C>>2]|0;P=c[D>>2]|0;Q=c[P>>2]|0;R=YJ(Q,1)|0;jF(O,R)|0;S=c[C>>2]|0;jF(S,111681)|0;i=g;return}l=c[C>>2]|0;c[k>>2]=c[(c[E>>2]|0)+16>>2];oF(l,111633,k);N=c[C>>2]|0;jF(N,111679)|0;O=c[C>>2]|0;P=c[D>>2]|0;Q=c[P>>2]|0;R=YJ(Q,1)|0;jF(O,R)|0;S=c[C>>2]|0;jF(S,111681)|0;i=g;return}case 1:{k=c[C>>2]|0;l=d[(c[E>>2]|0)+16+1>>0]|0;m=d[(c[E>>2]|0)+16+2>>0]|0;c[j>>2]=d[(c[E>>2]|0)+16>>0];c[j+4>>2]=l;c[j+8>>2]=m;oF(k,111644,j);N=c[C>>2]|0;jF(N,111679)|0;O=c[C>>2]|0;P=c[D>>2]|0;Q=c[P>>2]|0;R=YJ(Q,1)|0;jF(O,R)|0;S=c[C>>2]|0;jF(S,111681)|0;i=g;return}default:La(176099,110810,440,111666)}}function Md(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0;e=i;i=i+48|0;f=e+16|0;g=e;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=0;if((c[l>>2]|0)!=2){if((c[l>>2]|0)==3)c[m>>2]=Ud(c[j>>2]|0,c[k>>2]|0,2)|0}else c[m>>2]=Td(c[j>>2]|0,c[k>>2]|0,2)|0;jF(c[j>>2]|0,111264)|0;Rd(c[j>>2]|0,c[l>>2]|0,c[m>>2]|0);m=c[j>>2]|0;n=-+h[(c[k>>2]|0)+8>>3];h[g>>3]=+h[c[k>>2]>>3];h[g+8>>3]=n;oF(m,111273,g);g=c[j>>2]|0;n=+h[(c[k>>2]|0)+16+8>>3]-+h[(c[k>>2]|0)+8>>3];h[f>>3]=+h[(c[k>>2]|0)+16>>3]-+h[c[k>>2]>>3];h[f+8>>3]=n;oF(g,111290,f);jF(c[j>>2]|0,122272)|0;i=e;return}function Nd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;f=i;i=i+64|0;g=f+16|0;j=f;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;o=f+36|0;p=f+32|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[p>>2]=0;if((c[n>>2]|0)!=2){if((c[n>>2]|0)==3)c[p>>2]=Ud(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0}else c[p>>2]=Td(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;jF(c[k>>2]|0,111249)|0;Rd(c[k>>2]|0,c[n>>2]|0,c[p>>2]|0);jF(c[k>>2]|0,110657)|0;c[o>>2]=0;while(1){q=c[k>>2]|0;if((c[o>>2]|0)>=(c[m>>2]|0))break;r=-+h[(c[l>>2]|0)+(c[o>>2]<<4)+8>>3];h[j>>3]=+h[(c[l>>2]|0)+(c[o>>2]<<4)>>3];h[j+8>>3]=r;oF(q,110667,j);c[o>>2]=(c[o>>2]|0)+1}r=-+h[(c[l>>2]|0)+8>>3];h[g>>3]=+h[c[l>>2]>>3];h[g+8>>3]=r;oF(q,111258,g);jF(c[k>>2]|0,110674)|0;i=f;return}function Od(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+4|0;n=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[h+12>>2]=e;c[h+8>>2]=f;c[m>>2]=g;c[n>>2]=0;if((c[m>>2]|0)!=2){if((c[m>>2]|0)==3)c[n>>2]=Ud(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0}else c[n>>2]=Td(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;jF(c[j>>2]|0,110846)|0;Rd(c[j>>2]|0,c[m>>2]|0,c[n>>2]|0);jF(c[j>>2]|0,110852)|0;Vd(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);jF(c[j>>2]|0,110674)|0;i=h;return}function Pd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0;e=i;i=i+32|0;f=e;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;jF(c[g>>2]|0,110647)|0;Rd(c[g>>2]|0,0,0);jF(c[g>>2]|0,110657)|0;c[l>>2]=0;while(1){m=c[g>>2]|0;if((c[l>>2]|0)>=(c[k>>2]|0))break;n=-+h[(c[j>>2]|0)+(c[l>>2]<<4)+8>>3];h[f>>3]=+h[(c[j>>2]|0)+(c[l>>2]<<4)>>3];h[f+8>>3]=n;oF(m,110667,f);c[l>>2]=(c[l>>2]|0)+1}jF(m,110674)|0;i=e;return}function Qd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;jF(c[e>>2]|0,110641)|0;b=c[e>>2]|0;jF(b,XJ(c[f>>2]|0)|0)|0;jF(c[e>>2]|0,112731)|0;i=d;return}function Rd(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+112|0;g=f+56|0;j=f+48|0;k=f+40|0;l=f+32|0;m=f+24|0;n=f+16|0;o=f+8|0;p=f;q=f+108|0;r=f+104|0;s=f+100|0;t=f+96|0;c[q>>2]=a;c[r>>2]=b;c[s>>2]=e;c[t>>2]=c[(c[q>>2]|0)+16>>2];jF(c[q>>2]|0,110679)|0;do if((c[r>>2]|0)!=2){if((c[r>>2]|0)==3){e=c[q>>2]|0;c[o>>2]=c[s>>2];oF(e,110698,o);break}e=c[q>>2]|0;if(!(c[r>>2]|0)){jF(e,173312)|0;break}u=g;v=(c[t>>2]|0)+56|0;w=u+40|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));Sd(e,g);if(((c[(c[t>>2]|0)+56+32>>2]|0)==1?(d[(c[t>>2]|0)+56+3>>0]|0|0)>0:0)?(d[(c[t>>2]|0)+56+3>>0]|0|0)<255:0){b=c[q>>2]|0;h[n>>3]=+(d[(c[t>>2]|0)+56+3>>0]|0)/255.0;oF(b,110709,n)}}else{b=c[q>>2]|0;c[p>>2]=c[s>>2];oF(b,110687,p)}while(0);jF(c[q>>2]|0,110728)|0;p=c[q>>2]|0;u=g;v=(c[t>>2]|0)+16|0;w=u+40|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));Sd(p,g);if(+h[(c[t>>2]|0)+152>>3]!=1.0){g=c[q>>2]|0;h[m>>3]=+h[(c[t>>2]|0)+152>>3];oF(g,110739,m)}if((c[(c[t>>2]|0)+144>>2]|0)!=1){if((c[(c[t>>2]|0)+144>>2]|0)==2){m=c[q>>2]|0;c[k>>2]=c[11840];oF(m,110758,k)}}else{k=c[q>>2]|0;c[l>>2]=c[11839];oF(k,110758,l)}if((c[(c[t>>2]|0)+16+32>>2]|0)!=1){x=c[q>>2]|0;jF(x,136329)|0;i=f;return}if((d[(c[t>>2]|0)+16+3>>0]|0|0)<=0){x=c[q>>2]|0;jF(x,136329)|0;i=f;return}if((d[(c[t>>2]|0)+16+3>>0]|0|0)>=255){x=c[q>>2]|0;jF(x,136329)|0;i=f;return}l=c[q>>2]|0;h[j>>3]=+(d[(c[t>>2]|0)+16+3>>0]|0)/255.0;oF(l,110781,j);x=c[q>>2]|0;jF(x,136329)|0;i=f;return}function Sd(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+12|0;c[g>>2]=a;switch(c[b+32>>2]|0){case 5:{jF(c[g>>2]|0,c[b>>2]|0)|0;i=e;return}case 1:{a=c[g>>2]|0;if(!(d[b+3>>0]|0)){jF(a,173312)|0;i=e;return}else{g=d[b+1>>0]|0;h=d[b+2>>0]|0;c[f>>2]=d[b>>0];c[f+4>>2]=g;c[f+8>>2]=h;oF(a,112940,f);i=e;return}break}default:La(176099,110810,83,110830)}}function Td(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0,A=0;f=i;i=i+144|0;j=f+72|0;k=f+64|0;l=f+56|0;m=f+48|0;n=f+40|0;o=f+32|0;p=f+132|0;q=f+128|0;r=f+124|0;s=f;t=f+120|0;u=f+116|0;v=f+112|0;c[p>>2]=a;c[q>>2]=b;c[r>>2]=e;e=c[11842]|0;c[11842]=e+1;c[u>>2]=e;c[v>>2]=c[(c[p>>2]|0)+16>>2];g[t>>2]=+(c[(c[v>>2]|0)+136>>2]|0)*3.141592653589793/180.0;h[s+16+8>>3]=0.0;h[s+16>>3]=0.0;h[s+8>>3]=0.0;h[s>>3]=0.0;RO(c[q>>2]|0,s,c[r>>2]|0,+g[t>>2],0);t=c[p>>2]|0;c[o>>2]=c[u>>2];oF(t,111077,o);o=c[p>>2]|0;w=+h[s+8>>3];x=+h[s+16>>3];y=+h[s+16+8>>3];h[j>>3]=+h[s>>3];h[j+8>>3]=w;h[j+16>>3]=x;h[j+24>>3]=y;oF(o,111142,j);o=c[p>>2]|0;if(+g[(c[v>>2]|0)+140>>2]>0.0){h[n>>3]=+g[(c[v>>2]|0)+140>>2]-.001;oF(o,111177,n)}else jF(o,110949)|0;o=c[p>>2]|0;n=j;s=(c[v>>2]|0)+56|0;t=n+40|0;do{c[n>>2]=c[s>>2];n=n+4|0;s=s+4|0}while((n|0)<(t|0));Sd(o,j);jF(c[p>>2]|0,110985)|0;if(((c[(c[v>>2]|0)+56+32>>2]|0)==1?(d[(c[v>>2]|0)+56+3>>0]|0|0)>0:0)?(d[(c[v>>2]|0)+56+3>>0]|0|0)<255:0){o=c[p>>2]|0;h[m>>3]=+(d[(c[v>>2]|0)+56+3>>0]|0)/255.0;oF(o,136944,m)}else jF(c[p>>2]|0,111e3)|0;jF(c[p>>2]|0,111003)|0;m=c[p>>2]|0;if(+g[(c[v>>2]|0)+140>>2]>0.0){h[l>>3]=+g[(c[v>>2]|0)+140>>2];oF(m,111177,l)}else jF(m,111009)|0;m=c[p>>2]|0;n=j;s=(c[v>>2]|0)+96|0;t=n+40|0;do{c[n>>2]=c[s>>2];n=n+4|0;s=s+4|0}while((n|0)<(t|0));Sd(m,j);jF(c[p>>2]|0,110985)|0;if(((c[(c[v>>2]|0)+96+32>>2]|0)==1?(d[(c[v>>2]|0)+96+3>>0]|0|0)>0:0)?(d[(c[v>>2]|0)+96+3>>0]|0|0)<255:0){j=c[p>>2]|0;h[k>>3]=+(d[(c[v>>2]|0)+96+3>>0]|0)/255.0;oF(j,136944,k);z=c[p>>2]|0;jF(z,111217)|0;A=c[u>>2]|0;i=f;return A|0}jF(c[p>>2]|0,111e3)|0;z=c[p>>2]|0;jF(z,111217)|0;A=c[u>>2]|0;i=f;return A|0}function Ud(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+96|0;j=f+16|0;k=f+8|0;l=f;m=f+84|0;n=f+72|0;o=f+68|0;p=f+64|0;q=f+60|0;r=f+56|0;c[m>>2]=a;c[f+80>>2]=b;c[f+76>>2]=e;e=c[11841]|0;c[11841]=e+1;c[q>>2]=e;c[r>>2]=c[(c[m>>2]|0)+16>>2];g[n>>2]=+(c[(c[r>>2]|0)+136>>2]|0)*3.141592653589793/180.0;if(+g[n>>2]==0.0){c[p>>2]=50;c[o>>2]=50}else{c[o>>2]=~~((+Q(+(+g[n>>2]))+1.0)*50.0);c[p>>2]=~~((1.0-+R(+(+g[n>>2])))*50.0)}n=c[m>>2]|0;e=c[o>>2]|0;o=c[p>>2]|0;c[j>>2]=c[q>>2];c[j+4>>2]=e;c[j+8>>2]=o;oF(n,110865,j);jF(c[m>>2]|0,110949)|0;n=c[m>>2]|0;o=j;e=(c[r>>2]|0)+56|0;p=o+40|0;do{c[o>>2]=c[e>>2];o=o+4|0;e=e+4|0}while((o|0)<(p|0));Sd(n,j);jF(c[m>>2]|0,110985)|0;if(((c[(c[r>>2]|0)+56+32>>2]|0)==1?(d[(c[r>>2]|0)+56+3>>0]|0|0)>0:0)?(d[(c[r>>2]|0)+56+3>>0]|0|0)<255:0){n=c[m>>2]|0;h[l>>3]=+(d[(c[r>>2]|0)+56+3>>0]|0)/255.0;oF(n,136944,l)}else jF(c[m>>2]|0,111e3)|0;jF(c[m>>2]|0,111003)|0;jF(c[m>>2]|0,111009)|0;l=c[m>>2]|0;o=j;e=(c[r>>2]|0)+96|0;p=o+40|0;do{c[o>>2]=c[e>>2];o=o+4|0;e=e+4|0}while((o|0)<(p|0));Sd(l,j);jF(c[m>>2]|0,110985)|0;if(((c[(c[r>>2]|0)+96+32>>2]|0)==1?(d[(c[r>>2]|0)+96+3>>0]|0|0)>0:0)?(d[(c[r>>2]|0)+96+3>>0]|0|0)<255:0){j=c[m>>2]|0;h[k>>3]=+(d[(c[r>>2]|0)+96+3>>0]|0)/255.0;oF(j,136944,k);s=c[m>>2]|0;jF(s,111045)|0;t=c[q>>2]|0;i=f;return t|0}jF(c[m>>2]|0,111e3)|0;s=c[m>>2]|0;jF(s,111045)|0;t=c[q>>2]|0;i=f;return t|0}function Vd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0;f=i;i=i+48|0;g=f;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+40|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;a[n>>0]=77;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;e=c[j>>2]|0;o=+h[(c[k>>2]|0)+(c[m>>2]<<4)>>3];p=-+h[(c[k>>2]|0)+(c[m>>2]<<4)+8>>3];c[g>>2]=a[n>>0];h[g+8>>3]=o;h[g+16>>3]=p;oF(e,110857,g);if(!(c[m>>2]|0))a[n>>0]=67;else a[n>>0]=32;c[m>>2]=(c[m>>2]|0)+1}i=f;return}function Wd(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,112612)|0;a=c[d>>2]|0;jF(a,ee(c[c[c[(c[d>>2]|0)+12>>2]>>2]>>2]|0)|0)|0;jF(c[d>>2]|0,115407)|0;a=c[d>>2]|0;jF(a,ee(c[(c[c[(c[d>>2]|0)+12>>2]>>2]|0)+4>>2]|0)|0)|0;jF(c[d>>2]|0,115417)|0;a=c[d>>2]|0;jF(a,ee(c[(c[c[(c[d>>2]|0)+12>>2]>>2]|0)+8>>2]|0)|0)|0;jF(c[d>>2]|0,112628)|0;i=b;return}function Xd(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+16>>2];jF(c[f>>2]|0,112589)|0;if(a[(wB(c[(c[g>>2]|0)+8>>2]|0)|0)>>0]|0){jF(c[f>>2]|0,112591)|0;b=c[f>>2]|0;jF(b,ee(wB(c[(c[g>>2]|0)+8>>2]|0)|0)|0)|0}g=c[f>>2]|0;c[e>>2]=_(c[(c[f>>2]|0)+164>>2]|0,c[(c[f>>2]|0)+164+4>>2]|0)|0;oF(g,112600,e);i=d;return}function Yd(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;c[11893]=1;i=b;return}function Zd(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;c[11893]=-1;i=b;return}function _d(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+80|0;g=f+8|0;j=f;k=f+68|0;l=f+64|0;m=f+60|0;n=f+56|0;o=f+52|0;p=f+48|0;c[k>>2]=b;c[l>>2]=e;c[m>>2]=c[(c[k>>2]|0)+16>>2];if(!(c[(c[m>>2]|0)+144>>2]|0)){i=f;return}c[p>>2]=~~(+h[(c[(c[l>>2]|0)+4>>2]|0)+16>>3]*+h[(c[k>>2]|0)+352>>3]);if(!(c[p>>2]|0)){i=f;return}fe(c[k>>2]|0);jF(c[k>>2]|0,112528)|0;e=d+8|0;h[e>>3]=+h[e>>3]-+(c[p>>2]|0)*.55;e=c[k>>2]|0;c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];qF(e,g);jF(c[k>>2]|0,112542)|0;jF(c[k>>2]|0,c[c[l>>2]>>2]|0)|0;jF(c[k>>2]|0,112551)|0;jF(c[k>>2]|0,112349)|0;e=c[k>>2]|0;d=g;b=(c[m>>2]|0)+16|0;m=d+40|0;do{c[d>>2]=c[b>>2];d=d+4|0;b=b+4|0}while((d|0)<(m|0));ge(e,g);jF(c[k>>2]|0,112553)|0;c[o>>2]=c[(c[(c[l>>2]|0)+4>>2]|0)+8>>2];if(c[o>>2]|0)c[n>>2]=c[(c[o>>2]|0)+4>>2];else c[n>>2]=c[c[(c[l>>2]|0)+4>>2]>>2];jF(c[k>>2]|0,136329)|0;jF(c[k>>2]|0,c[n>>2]|0)|0;jF(c[k>>2]|0,136329)|0;n=c[k>>2]|0;c[j>>2]=c[p>>2];oF(n,112562,j);switch(a[(c[l>>2]|0)+48>>0]|0){case 108:{jF(c[k>>2]|0,112567)|0;break}case 114:{jF(c[k>>2]|0,112578)|0;break}default:{}}he(c[k>>2]|0);jF(c[k>>2]|0,193392)|0;i=f;return}function $d(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+80|0;f=e+16|0;g=e+68|0;j=e+64|0;k=e+60|0;l=e+56|0;m=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=c[(c[g>>2]|0)+16>>2];if(!(c[(c[l>>2]|0)+144>>2]|0)){i=e;return}h[m>>3]=+h[(c[j>>2]|0)+16>>3]-+h[c[j>>2]>>3];h[m+8>>3]=+h[(c[j>>2]|0)+16+8>>3]-+h[(c[j>>2]|0)+8>>3];d=c[j>>2]|0;h[d>>3]=+h[d>>3]-+h[m>>3];d=(c[j>>2]|0)+8|0;h[d>>3]=+h[d>>3]-+h[m+8>>3];fe(c[g>>2]|0);jF(c[g>>2]|0,112514)|0;rF(c[g>>2]|0,c[j>>2]|0,2);jF(c[g>>2]|0,112349)|0;do if(!(c[k>>2]|0)){j=c[g>>2]|0;if(c[11893]|0){jF(j,174801)|0;break}else{jF(j,134866)|0;break}}else{j=c[g>>2]|0;n=f;o=(c[l>>2]|0)+56|0;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));ge(j,f)}while(0);if((c[11893]|0)==1)c[11893]=0;jF(c[g>>2]|0,112460)|0;pF(c[g>>2]|0,+h[(c[l>>2]|0)+152>>3]);jF(c[g>>2]|0,112503)|0;k=c[g>>2]|0;n=f;o=(c[l>>2]|0)+16|0;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));ge(k,f);if((c[(c[l>>2]|0)+144>>2]|0)==1)jF(c[g>>2]|0,112357)|0;if((c[(c[l>>2]|0)+144>>2]|0)==2)jF(c[g>>2]|0,112366)|0;he(c[g>>2]|0);jF(c[g>>2]|0,193392)|0;i=e;return}function ae(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+64|0;g=f;j=f+56|0;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=c[(c[j>>2]|0)+16>>2];if(!(c[(c[n>>2]|0)+144>>2]|0)){i=f;return}fe(c[j>>2]|0);jF(c[j>>2]|0,112486)|0;rF(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);jF(c[j>>2]|0,112349)|0;do if(!(c[m>>2]|0)){l=c[j>>2]|0;if(c[11893]|0){jF(l,174801)|0;break}else{jF(l,134866)|0;break}}else{l=c[j>>2]|0;o=g;p=(c[n>>2]|0)+56|0;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));ge(l,g)}while(0);if((c[11893]|0)==1)c[11893]=0;jF(c[j>>2]|0,112460)|0;pF(c[j>>2]|0,+h[(c[n>>2]|0)+152>>3]);jF(c[j>>2]|0,112503)|0;m=c[j>>2]|0;o=g;p=(c[n>>2]|0)+16|0;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));ge(m,g);if((c[(c[n>>2]|0)+144>>2]|0)==1)jF(c[j>>2]|0,112357)|0;if((c[(c[n>>2]|0)+144>>2]|0)==2)jF(c[j>>2]|0,112366)|0;he(c[j>>2]|0);jF(c[j>>2]|0,193392)|0;i=f;return}function be(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=j;l=j+64|0;m=j+60|0;n=j+56|0;o=j+40|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[j+52>>2]=e;c[j+48>>2]=f;c[j+44>>2]=g;c[o>>2]=c[(c[l>>2]|0)+16>>2];if(!(c[(c[o>>2]|0)+144>>2]|0)){i=j;return}fe(c[l>>2]|0);jF(c[l>>2]|0,112335)|0;rF(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0);jF(c[l>>2]|0,112349)|0;n=c[l>>2]|0;m=k;g=(c[o>>2]|0)+16|0;f=m+40|0;do{c[m>>2]=c[g>>2];m=m+4|0;g=g+4|0}while((m|0)<(f|0));ge(n,k);jF(c[l>>2]|0,112460)|0;pF(c[l>>2]|0,+h[(c[o>>2]|0)+152>>3]);if((c[(c[o>>2]|0)+144>>2]|0)==1)jF(c[l>>2]|0,112357)|0;if((c[(c[o>>2]|0)+144>>2]|0)==2)jF(c[l>>2]|0,112366)|0;jF(c[l>>2]|0,112469)|0;he(c[l>>2]|0);jF(c[l>>2]|0,193392)|0;i=j;return}function ce(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e;g=e+52|0;h=e+48|0;j=e+44|0;k=e+40|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[(c[g>>2]|0)+16>>2];if(!(c[(c[k>>2]|0)+144>>2]|0)){i=e;return}fe(c[g>>2]|0);jF(c[g>>2]|0,112335)|0;rF(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0);jF(c[g>>2]|0,112349)|0;j=c[g>>2]|0;h=f;d=(c[k>>2]|0)+16|0;b=h+40|0;do{c[h>>2]=c[d>>2];h=h+4|0;d=d+4|0}while((h|0)<(b|0));ge(j,f);if((c[(c[k>>2]|0)+144>>2]|0)==1)jF(c[g>>2]|0,112357)|0;if((c[(c[k>>2]|0)+144>>2]|0)==2)jF(c[g>>2]|0,112366)|0;he(c[g>>2]|0);jF(c[g>>2]|0,193392)|0;i=e;return}function de(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;jF(c[e>>2]|0,112332)|0;b=c[e>>2]|0;jF(b,ee(c[f>>2]|0)|0)|0;jF(c[e>>2]|0,193392)|0;i=d;return}function ee(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[d>>2]|0}function fe(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=c[e>>2]|0;if(a[(c[e>>2]|0)+144>>0]|0){jF(b,c[(c[e>>2]|0)+148>>2]|0)|0;i=d;return}else{jF(b,112457)|0;i=d;return}}function ge(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+12|0;c[g>>2]=a;switch(c[b+32>>2]|0){case 5:{jF(c[g>>2]|0,c[b>>2]|0)|0;i=e;return}case 1:{a=c[g>>2]|0;if(!(d[b+3>>0]|0)){jF(a,134866)|0;i=e;return}else{g=d[b+1>>0]|0;h=d[b+2>>0]|0;c[f>>2]=d[b>>0];c[f+4>>2]=g;c[f+8>>2]=h;oF(a,112940,f);i=e;return}break}default:La(176099,112387,51,112439)}}function he(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b;e=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;c[e>>2]=a;c[h>>2]=c[(c[e>>2]|0)+16>>2];switch(c[(c[h>>2]|0)+12>>2]|0){case 8:{c[f>>2]=149084;c[j>>2]=1;c[g>>2]=(c[c[(c[h>>2]|0)+8>>2]>>2]|0)>>>4;break}case 10:{c[f>>2]=149084;c[j>>2]=0;c[g>>2]=(c[c[(c[h>>2]|0)+8>>2]>>2]|0)>>>4;break}case 3:case 2:case 9:{c[f>>2]=149079;c[j>>2]=1;c[g>>2]=(c[c[(c[h>>2]|0)+8>>2]>>2]|0)>>>4;break}case 7:case 6:case 11:{c[f>>2]=149079;c[j>>2]=0;c[g>>2]=(c[c[(c[h>>2]|0)+8>>2]>>2]|0)>>>4;break}case 0:{c[f>>2]=149098;c[j>>2]=1;c[g>>2]=-1;break}case 4:{c[j>>2]=0;c[f>>2]=112375;c[g>>2]=-1;break}case 1:{c[f>>2]=149098;c[j>>2]=1;c[g>>2]=(c[c[(c[h>>2]|0)+8>>2]>>2]|0)>>>4;break}case 5:{c[f>>2]=149098;c[j>>2]=0;c[g>>2]=(c[c[(c[h>>2]|0)+8>>2]>>2]|0)>>>4;break}default:La(176099,112387,108,112406)}h=c[e>>2]|0;e=c[f>>2]|0;f=c[g>>2]|0;c[d>>2]=c[j>>2];c[d+4>>2]=e;c[d+8>>2]=f;oF(h,112423,d);i=b;return}function ie(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+64|0;f=e;g=e+40|0;h=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e+12|0;p=e+8|0;q=e+48|0;r=e+4|0;s=e+45|0;t=e+44|0;c[g>>2]=b;c[k>>2]=0;c[m>>2]=0;c[p>>2]=0;c[r>>2]=0;if(!(c[11946]|0)){c[11947]=64;c[11946]=cK(c[11947]|0)|0}c[h>>2]=c[11946];a:while(1){if(!(c[g>>2]|0)){u=42;break}if(!(a[c[g>>2]>>0]|0)){u=42;break}if((c[m>>2]|0)>((c[11947]|0)-8|0)){c[11947]=c[11947]<<1;c[11946]=eK(c[11946]|0,c[11947]|0)|0;c[h>>2]=(c[11946]|0)+(c[m>>2]|0)}if((a[c[g>>2]>>0]|0)==38?(je(c[g>>2]|0)|0)==0:0){c[j>>2]=139881;c[l>>2]=5}else u=11;do if((u|0)==11){u=0;if((a[c[g>>2]>>0]|0)==60){c[j>>2]=139887;c[l>>2]=4;break}if((a[c[g>>2]>>0]|0)==62){c[j>>2]=139892;c[l>>2]=4;break}if((a[c[g>>2]>>0]|0)==45){c[j>>2]=139897;c[l>>2]=5;break}if(((c[k>>2]|0)!=0?(a[c[g>>2]>>0]|0)==32:0)?(a[c[k>>2]>>0]|0)==32:0){c[j>>2]=139903;c[l>>2]=6;break}if((a[c[g>>2]>>0]|0)==34){c[j>>2]=139910;c[l>>2]=6;break}if((a[c[g>>2]>>0]|0)==39){c[j>>2]=139917;c[l>>2]=5;break}b=c[g>>2]|0;if((d[c[g>>2]>>0]|0)<=127){c[j>>2]=b;c[l>>2]=1;break}a[s>>0]=a[b>>0]|0;c[o>>2]=0;a[t>>0]=127;while(1){v=c[o>>2]|0;if((d[t>>0]|0)>=(d[s>>0]|0))break;c[o>>2]=v+1;a[s>>0]=d[s>>0]&d[t>>0];a[t>>0]=d[t>>0]>>1}if((v|0)>1){c[r>>2]=d[s>>0];c[p>>2]=(c[o>>2]|0)-1}else{c[r>>2]=c[r>>2]<<6;c[r>>2]=(c[r>>2]|0)+(d[s>>0]|0);c[p>>2]=(c[p>>2]|0)+-1}if((c[p>>2]|0)>0){c[g>>2]=(c[g>>2]|0)+1;continue a}a[q+15>>0]=59;c[j>>2]=q+14;c[l>>2]=3;do{c[n>>2]=((c[r>>2]|0)>>>0)%10|0;b=48+(c[n>>2]|0)&255;w=c[j>>2]|0;c[j>>2]=w+-1;a[w>>0]=b;c[r>>2]=((c[r>>2]|0)>>>0)/10|0;c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)>12){u=35;break a}}while((c[r>>2]|0)>>>0>0);b=c[j>>2]|0;c[j>>2]=b+-1;a[b>>0]=35;a[c[j>>2]>>0]=38}while(0);while(1){b=c[l>>2]|0;c[l>>2]=b+-1;if(!b)break;b=c[j>>2]|0;c[j>>2]=b+1;w=a[b>>0]|0;b=c[h>>2]|0;c[h>>2]=b+1;a[b>>0]=w;c[m>>2]=(c[m>>2]|0)+1}c[k>>2]=c[g>>2];c[g>>2]=(c[g>>2]|0)+1}if((u|0)==35){Y2(c[24742]|0,112631,f)|0;wb(1)}else if((u|0)==42){a[c[h>>2]>>0]=0;i=e;return c[11946]|0}return 0}function je(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;c[f>>2]=(c[f>>2]|0)+1;a:do if((a[c[f>>2]>>0]|0)==35){c[f>>2]=(c[f>>2]|0)+1;if((a[c[f>>2]>>0]|0)!=120?(a[c[f>>2]>>0]|0)!=88:0)while(1){if((a[c[f>>2]>>0]|0)<48)break a;if((a[c[f>>2]>>0]|0)>57)break a;c[f>>2]=(c[f>>2]|0)+1}c[f>>2]=(c[f>>2]|0)+1;while(1){if(!((a[c[f>>2]>>0]|0)>=48?(a[c[f>>2]>>0]|0)<=57:0))g=7;do if((g|0)==7){g=0;if((a[c[f>>2]>>0]|0)>=97?(a[c[f>>2]>>0]|0)<=102:0)break;if((a[c[f>>2]>>0]|0)<65)break a;if((a[c[f>>2]>>0]|0)>70)break a}while(0);c[f>>2]=(c[f>>2]|0)+1}}else while(1){if(!((a[c[f>>2]>>0]|0)>=97?(a[c[f>>2]>>0]|0)<=122:0)){if((a[c[f>>2]>>0]|0)<65)break a;if((a[c[f>>2]>>0]|0)>90)break a}c[f>>2]=(c[f>>2]|0)+1}while(0);if((a[c[f>>2]>>0]|0)==59){c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}return 0}function ke(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,115379)|0;jF(c[d>>2]|0,115387)|0;a=c[d>>2]|0;jF(a,ie(c[c[c[(c[d>>2]|0)+12>>2]>>2]>>2]|0)|0)|0;jF(c[d>>2]|0,115407)|0;a=c[d>>2]|0;jF(a,ie(c[(c[c[(c[d>>2]|0)+12>>2]>>2]|0)+4>>2]|0)|0)|0;jF(c[d>>2]|0,115417)|0;a=c[d>>2]|0;jF(a,ie(c[(c[c[(c[d>>2]|0)+12>>2]>>2]|0)+8>>2]|0)|0)|0;jF(c[d>>2]|0,115420)|0;i=b;return}function le(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+48|0;e=d+24|0;f=d+16|0;g=d+8|0;j=d;k=d+40|0;l=d+36|0;m=d+32|0;c[k>>2]=b;c[l>>2]=c[(c[k>>2]|0)+16>>2];c[11944]=~~(+h[(c[k>>2]|0)+208+16+8>>3]-+h[(c[k>>2]|0)+208+8>>3]);c[11945]=~~(+h[(c[k>>2]|0)+208+16>>3]-+h[(c[k>>2]|0)+208>>3]);jF(c[k>>2]|0,114066)|0;jF(c[k>>2]|0,114073)|0;c[m>>2]=wB(c[(c[l>>2]|0)+8>>2]|0)|0;if(a[c[m>>2]>>0]|0){jF(c[k>>2]|0,114142)|0;l=c[k>>2]|0;jF(l,ie(c[m>>2]|0)|0)|0;jF(c[k>>2]|0,114150)|0}m=c[k>>2]|0;c[j>>2]=_(c[(c[k>>2]|0)+164>>2]|0,c[(c[k>>2]|0)+164+4>>2]|0)|0;oF(m,114159,j);jF(c[k>>2]|0,114179)|0;jF(c[k>>2]|0,114214)|0;jF(c[k>>2]|0,114242)|0;jF(c[k>>2]|0,114248)|0;jF(c[k>>2]|0,114291)|0;jF(c[k>>2]|0,114332)|0;jF(c[k>>2]|0,114351)|0;jF(c[k>>2]|0,114368)|0;jF(c[k>>2]|0,114416)|0;jF(c[k>>2]|0,114469)|0;jF(c[k>>2]|0,114545)|0;jF(c[k>>2]|0,114621)|0;jF(c[k>>2]|0,114630)|0;jF(c[k>>2]|0,114653)|0;jF(c[k>>2]|0,114680)|0;jF(c[k>>2]|0,114733)|0;jF(c[k>>2]|0,114755)|0;jF(c[k>>2]|0,114800)|0;jF(c[k>>2]|0,114812)|0;jF(c[k>>2]|0,114822)|0;jF(c[k>>2]|0,114848)|0;jF(c[k>>2]|0,114733)|0;jF(c[k>>2]|0,114900)|0;jF(c[k>>2]|0,114800)|0;jF(c[k>>2]|0,114812)|0;jF(c[k>>2]|0,114944)|0;jF(c[k>>2]|0,114653)|0;jF(c[k>>2]|0,114680)|0;jF(c[k>>2]|0,114733)|0;jF(c[k>>2]|0,114900)|0;jF(c[k>>2]|0,114800)|0;jF(c[k>>2]|0,114812)|0;jF(c[k>>2]|0,114822)|0;jF(c[k>>2]|0,114848)|0;jF(c[k>>2]|0,114733)|0;jF(c[k>>2]|0,114755)|0;jF(c[k>>2]|0,114800)|0;jF(c[k>>2]|0,114812)|0;jF(c[k>>2]|0,114957)|0;jF(c[k>>2]|0,114965)|0;jF(c[k>>2]|0,114971)|0;jF(c[k>>2]|0,114985)|0;jF(c[k>>2]|0,114993)|0;jF(c[k>>2]|0,115026)|0;j=c[k>>2]|0;m=10+(c[11944]|0)|0;c[g>>2]=c[11945];c[g+4>>2]=m;oF(j,115103,g);jF(c[k>>2]|0,115133)|0;jF(c[k>>2]|0,115142)|0;jF(c[k>>2]|0,115200)|0;jF(c[k>>2]|0,115210)|0;jF(c[k>>2]|0,115275)|0;g=c[k>>2]|0;j=c[11944]|0;c[f>>2]=c[11945];c[f+4>>2]=j;oF(g,115312,f);f=c[k>>2]|0;k=c[11944]|0;c[e>>2]=c[11945];c[e+4>>2]=k;oF(f,115340,e);i=d;return}function me(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,113617)|0;jF(c[d>>2]|0,113629)|0;jF(c[d>>2]|0,113637)|0;jF(c[d>>2]|0,113700)|0;jF(c[d>>2]|0,113629)|0;jF(c[d>>2]|0,113745)|0;jF(c[d>>2]|0,113794)|0;jF(c[d>>2]|0,113848)|0;jF(c[d>>2]|0,113629)|0;jF(c[d>>2]|0,113948)|0;jF(c[d>>2]|0,113997)|0;jF(c[d>>2]|0,113629)|0;jF(c[d>>2]|0,114049)|0;i=b;return}function ne(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=h+16|0;k=h+8|0;l=h;m=h+36|0;n=h+32|0;o=h+28|0;p=h+24|0;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[h+20>>2]=g;jF(c[m>>2]|0,113575)|0;if((c[n>>2]|0)!=0?(a[c[n>>2]>>0]|0)!=0:0){g=c[m>>2]|0;c[l>>2]=ie(c[n>>2]|0)|0;oF(g,113578,l)}if((c[o>>2]|0)!=0?(a[c[o>>2]>>0]|0)!=0:0){l=c[m>>2]|0;c[k>>2]=ie(c[o>>2]|0)|0;oF(l,113589,k)}if(!(c[p>>2]|0)){q=c[m>>2]|0;jF(q,113614)|0;i=h;return}if(!(a[c[p>>2]>>0]|0)){q=c[m>>2]|0;jF(q,113614)|0;i=h;return}k=c[m>>2]|0;c[j>>2]=ie(c[p>>2]|0)|0;oF(k,113601,j);q=c[m>>2]|0;jF(q,113614)|0;i=h;return}function oe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,113569)|0;i=b;return}function pe(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;i=i+160|0;j=g+128|0;k=g+120|0;l=g+112|0;m=g+104|0;n=g+96|0;o=g+88|0;p=g+80|0;q=g+72|0;r=g+56|0;s=g+40|0;t=g+32|0;u=g+152|0;v=g+148|0;w=g+16|0;x=g;y=g+144|0;z=g+140|0;c[u>>2]=b;c[v>>2]=f;c[y>>2]=c[(c[u>>2]|0)+16>>2];switch(a[(c[v>>2]|0)+48>>0]|0){case 108:{h[w>>3]=+h[e>>3];break}case 114:{h[w>>3]=+h[e>>3]-+h[(c[v>>2]|0)+32>>3];break}default:h[w>>3]=+h[e>>3]-+h[(c[v>>2]|0)+32>>3]/2.0}h[x>>3]=+h[w>>3]+ +h[(c[v>>2]|0)+32>>3];if(+h[(c[v>>2]|0)+32+8>>3]<+h[(c[(c[v>>2]|0)+4>>2]|0)+16>>3])h[(c[v>>2]|0)+32+8>>3]=+h[(c[(c[v>>2]|0)+4>>2]|0)+16>>3]*1.1+1.0;h[w>>3]=+h[w>>3]-8.0;h[x>>3]=+h[x>>3]+8.0;h[x+8>>3]=+((c[11944]|0)>>>0)-+h[e+8>>3];h[w+8>>3]=+h[x+8>>3]-+h[(c[v>>2]|0)+32+8>>3];A=+h[(c[(c[v>>2]|0)+4>>2]|0)+16>>3]/5.0;if(+h[(c[(c[v>>2]|0)+4>>2]|0)+16>>3]<12.0){e=w+8|0;h[e>>3]=+h[e>>3]+(1.4+A);e=x+8|0;h[e>>3]=+h[e>>3]+(+h[(c[(c[v>>2]|0)+4>>2]|0)+16>>3]/5.0+1.4)}else{e=w+8|0;h[e>>3]=+h[e>>3]+(2.0+A);e=x+8|0;h[e>>3]=+h[e>>3]+(+h[(c[(c[v>>2]|0)+4>>2]|0)+16>>3]/5.0+2.0)}oF(c[u>>2]|0,113231,t);t=c[u>>2]|0;A=+h[w+8>>3];h[s>>3]=+h[w>>3];h[s+8>>3]=A;oF(t,113168,s);s=c[u>>2]|0;A=+h[x+8>>3]-+h[w+8>>3];h[r>>3]=+h[x>>3]-+h[w>>3];h[r+8>>3]=A;oF(s,113192,r);jF(c[u>>2]|0,113266)|0;jF(c[u>>2]|0,113300)|0;c[z>>2]=c[(c[(c[v>>2]|0)+4>>2]|0)+8>>2];r=c[u>>2]|0;if(c[z>>2]|0){c[q>>2]=c[(c[z>>2]|0)+4>>2];oF(r,113390,q);if(c[(c[z>>2]|0)+8>>2]|0){q=c[u>>2]|0;c[p>>2]=c[(c[z>>2]|0)+8>>2];oF(q,113409,p)}if(c[(c[z>>2]|0)+12>>2]|0){p=c[u>>2]|0;c[o>>2]=c[(c[z>>2]|0)+12>>2];oF(p,113426,o)}if(c[(c[z>>2]|0)+16>>2]|0){o=c[u>>2]|0;c[n>>2]=c[(c[z>>2]|0)+16>>2];oF(o,113444,n)}}else{c[m>>2]=c[c[(c[v>>2]|0)+4>>2]>>2];oF(r,113390,m)}m=c[u>>2]|0;h[l>>3]=+h[(c[(c[v>>2]|0)+4>>2]|0)+16>>3];oF(m,113460,l);switch(c[(c[y>>2]|0)+16+32>>2]|0){case 5:{if(!(F3(c[(c[y>>2]|0)+16>>2]|0,174917)|0)){B=c[u>>2]|0;jF(B,113524)|0;C=c[u>>2]|0;D=c[v>>2]|0;E=c[D>>2]|0;F=ie(E)|0;jF(C,F)|0;G=c[u>>2]|0;jF(G,113535)|0;H=c[u>>2]|0;jF(H,113558)|0;i=g;return}l=c[u>>2]|0;c[k>>2]=c[(c[y>>2]|0)+16>>2];oF(l,113480,k);B=c[u>>2]|0;jF(B,113524)|0;C=c[u>>2]|0;D=c[v>>2]|0;E=c[D>>2]|0;F=ie(E)|0;jF(C,F)|0;G=c[u>>2]|0;jF(G,113535)|0;H=c[u>>2]|0;jF(H,113558)|0;i=g;return}case 1:{k=c[u>>2]|0;l=d[(c[y>>2]|0)+16+1>>0]|0;m=d[(c[y>>2]|0)+16+2>>0]|0;c[j>>2]=d[(c[y>>2]|0)+16>>0];c[j+4>>2]=l;c[j+8>>2]=m;oF(k,113490,j);B=c[u>>2]|0;jF(B,113524)|0;C=c[u>>2]|0;D=c[v>>2]|0;E=c[D>>2]|0;F=ie(E)|0;jF(C,F)|0;G=c[u>>2]|0;jF(G,113535)|0;H=c[u>>2]|0;jF(H,113558)|0;i=g;return}default:La(176099,112954,439,113511)}}function qe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;e=i;i=i+96|0;f=e+64|0;g=e+48|0;j=e+88|0;k=e+84|0;l=e+80|0;m=e+40|0;n=e+32|0;o=e+24|0;p=e+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;jF(c[j>>2]|0,113132)|0;h[m>>3]=+h[(c[k>>2]|0)+16>>3]-+h[c[k>>2]>>3];h[n>>3]=+h[(c[k>>2]|0)+16+8>>3]-+h[(c[k>>2]|0)+8>>3];h[p>>3]=+((c[11944]|0)>>>0)-(+h[(c[k>>2]|0)+8>>3]+ +h[n>>3]);h[e>>3]=+h[p>>3]+ +h[n>>3]+ +h[n>>3];h[o>>3]=+h[c[k>>2]>>3]-+h[m>>3];h[e+16>>3]=+h[(c[k>>2]|0)+16>>3];k=c[j>>2]|0;q=+h[p>>3];h[g>>3]=+h[o>>3];h[g+8>>3]=q;oF(k,113168,g);g=c[j>>2]|0;q=+h[n>>3]*2.0;h[f>>3]=+h[m>>3]*2.0;h[f+8>>3]=q;oF(g,113192,f);xe(c[j>>2]|0,c[l>>2]|0);jF(c[j>>2]|0,113014)|0;ve(c[j>>2]|0,c[l>>2]|0);jF(c[j>>2]|0,113220)|0;i=e;return}function re(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;f=i;i=i+64|0;g=f+24|0;j=f+16|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+44|0;o=f+40|0;p=f+8|0;q=f;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;jF(c[k>>2]|0,112737)|0;e=c[k>>2]|0;d=c[11944]|0;c[j>>2]=c[11945];c[j+4>>2]=d;oF(e,112990,j);xe(c[k>>2]|0,c[n>>2]|0);jF(c[k>>2]|0,113014)|0;ve(c[k>>2]|0,c[n>>2]|0);jF(c[k>>2]|0,113017)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[m>>2]|0))break;h[p>>3]=+h[(c[l>>2]|0)+(c[o>>2]<<4)>>3];h[q>>3]=+((c[11944]|0)>>>0)-+h[(c[l>>2]|0)+(c[o>>2]<<4)+8>>3];if(!(c[o>>2]|0))jF(c[k>>2]|0,113044)|0;n=c[k>>2]|0;r=+h[q>>3];h[g>>3]=+h[p>>3];h[g+8>>3]=r;oF(n,113110,g);if(!(c[o>>2]|0))jF(c[k>>2]|0,113121)|0;if((c[o>>2]|0)==((c[m>>2]|0)-1|0))jF(c[k>>2]|0,113124)|0;c[o>>2]=(c[o>>2]|0)+1}jF(c[k>>2]|0,112853)|0;i=f;return}function se(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+32|0;j=h;k=h+28|0;l=h+24|0;m=h+20|0;n=h+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[h+16>>2]=e;c[h+12>>2]=f;c[n>>2]=g;jF(c[k>>2]|0,112737)|0;g=c[k>>2]|0;f=c[11944]|0;c[j>>2]=c[11945];c[j+4>>2]=f;oF(g,112990,j);xe(c[k>>2]|0,c[n>>2]|0);jF(c[k>>2]|0,113014)|0;ve(c[k>>2]|0,c[n>>2]|0);jF(c[k>>2]|0,113017)|0;ye(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0);jF(c[k>>2]|0,113030)|0;i=h;return}function te(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0;e=i;i=i+48|0;f=e+8|0;g=e;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;jF(c[j>>2]|0,112737)|0;d=c[j>>2]|0;b=c[11944]|0;c[g>>2]=c[11945];c[g+4>>2]=b;oF(d,112774,g);jF(c[j>>2]|0,112814)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;if(!(c[m>>2]|0))jF(c[j>>2]|0,112826)|0;g=c[j>>2]|0;n=+((c[11944]|0)>>>0)-+h[(c[k>>2]|0)+(c[m>>2]<<4)+8>>3];h[f>>3]=+h[(c[k>>2]|0)+(c[m>>2]<<4)>>3];h[f+8>>3]=n;oF(g,112830,f);if(!(c[m>>2]|0))jF(c[j>>2]|0,112841)|0;if((c[m>>2]|0)==((c[l>>2]|0)-1|0))jF(c[j>>2]|0,112845)|0;c[m>>2]=(c[m>>2]|0)+1}jF(c[j>>2]|0,112849)|0;ve(c[j>>2]|0,0);jF(c[j>>2]|0,112853)|0;i=e;return}function ue(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;jF(c[e>>2]|0,112719)|0;b=c[e>>2]|0;jF(b,ie(c[f>>2]|0)|0)|0;jF(c[e>>2]|0,112731)|0;i=d;return}function ve(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+64|0;e=d+8|0;f=d;g=d+56|0;j=d+48|0;c[g>>2]=a;c[d+52>>2]=b;c[j>>2]=c[(c[g>>2]|0)+16>>2];jF(c[g>>2]|0,112865)|0;b=c[g>>2]|0;a=e;k=(c[j>>2]|0)+16|0;l=a+40|0;do{c[a>>2]=c[k>>2];a=a+4|0;k=k+4|0}while((a|0)<(l|0));we(b,e);if(+h[(c[j>>2]|0)+152>>3]!=1.0){e=c[g>>2]|0;h[f>>3]=+h[(c[j>>2]|0)+152>>3];oF(e,112883,f)}if((c[(c[j>>2]|0)+144>>2]|0)==1){jF(c[g>>2]|0,112900)|0;m=c[g>>2]|0;jF(m,112935)|0;i=d;return}if((c[(c[j>>2]|0)+144>>2]|0)!=2){m=c[g>>2]|0;jF(m,112935)|0;i=d;return}jF(c[g>>2]|0,112918)|0;m=c[g>>2]|0;jF(m,112935)|0;i=d;return}function we(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+12|0;c[g>>2]=a;switch(c[b+32>>2]|0){case 5:{jF(c[g>>2]|0,c[b>>2]|0)|0;i=e;return}case 1:{a=c[g>>2]|0;if(!(d[b+3>>0]|0)){jF(a,173312)|0;i=e;return}else{g=d[b+1>>0]|0;h=d[b+2>>0]|0;c[f>>2]=d[b>>0];c[f+4>>2]=g;c[f+8>>2]=h;oF(a,112940,f);i=e;return}break}default:La(176099,112954,95,112974)}}function xe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+64|0;e=d;f=d+48|0;g=d+44|0;h=d+40|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[f>>2]|0)+16>>2];b=c[f>>2]|0;if(c[g>>2]|0){jF(b,113063)|0;g=c[f>>2]|0;a=e;j=(c[h>>2]|0)+56|0;h=a+40|0;do{c[a>>2]=c[j>>2];a=a+4|0;j=j+4|0}while((a|0)<(h|0));we(g,e);jF(c[f>>2]|0,113090)|0;i=d;return}else{jF(b,113093)|0;i=d;return}}function ye(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+48|0;f=e;g=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[m>>2]=113044;c[l>>2]=0;while(1){n=c[g>>2]|0;if((c[l>>2]|0)>=(c[k>>2]|0))break;o=+h[(c[j>>2]|0)+(c[l>>2]<<4)>>3];p=+((c[11944]|0)>>>0)-+h[(c[j>>2]|0)+(c[l>>2]<<4)+8>>3];c[f>>2]=c[m>>2];h[f+8>>3]=o;h[f+16>>3]=p;oF(n,113047,f);if(!(c[l>>2]|0))c[m>>2]=113060;else c[m>>2]=178518;c[l>>2]=(c[l>>2]|0)+1}jF(n,136329)|0;i=e;return}function ze(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+1072|0;f=e;g=e+36|0;h=e+32|0;j=e+40|0;k=e+28|0;l=e+24|0;m=e+8|0;c[g>>2]=a;c[h>>2]=b;c[m>>2]=d;c[k>>2]=q3(j,1024,c[h>>2]|0,m)|0;if((c[k>>2]|0)>>>0<0){b=c[(c[(c[g>>2]|0)+12>>2]|0)+16>>2]|0;c[f>>2]=M1(c[(L1()|0)>>2]|0)|0;Db[b&31](115427,f);c[l>>2]=M3(178518)|0;n=c[l>>2]|0;i=e;return n|0}if((c[k>>2]|0)>>>0>=1024){c[l>>2]=N4((c[k>>2]|0)+1|0)|0;c[m>>2]=d;c[k>>2]=r3(c[l>>2]|0,c[h>>2]|0,m)|0;n=c[l>>2]|0;i=e;return n|0}else{c[l>>2]=M3(j)|0;n=c[l>>2]|0;i=e;return n|0}return 0}function Ae(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+8|0;e=b;f=b+16|0;c[f>>2]=a;jF(c[f>>2]|0,118069)|0;jF(c[f>>2]|0,118084)|0;jF(c[f>>2]|0,118123)|0;jF(c[f>>2]|0,118172)|0;a=c[f>>2]|0;c[e>>2]=174917;c[e+4>>2]=118260;oF(a,118241,e);e=c[f>>2]|0;c[d>>2]=174801;c[d+4>>2]=118266;oF(e,118241,d);i=b;return}function Be(a){a=a|0;var b=0,d=0,e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;b=i;i=i+96|0;d=b+8|0;e=b;f=b+84|0;j=b+80|0;k=b+76|0;l=b+72|0;m=b+68|0;n=b+64|0;c[f>>2]=a;a=c[f>>2]|0;c[e>>2]=wB(c[(c[(c[f>>2]|0)+16>>2]|0)+8>>2]|0)|0;oF(a,117022,e);g[j>>2]=+h[(c[f>>2]|0)+368>>3]/2.0*+h[(c[f>>2]|0)+488>>3];g[k>>2]=+h[(c[f>>2]|0)+368+8>>3]/2.0*+h[(c[f>>2]|0)+488+8>>3];g[l>>2]=-500.0;g[m>>2]=+V(+(+g[j>>2]/+(N(~~+g[l>>2]|0)|0)))*180.0/3.141592653589793*2.0;g[n>>2]=+V(+(+g[k>>2]/+(N(~~+g[l>>2]|0)|0)))*180.0/3.141592653589793*2.0;e=c[f>>2]|0;o=+g[k>>2];p=+g[l>>2];q=+g[j>>2];r=+g[k>>2];s=(+g[m>>2]>+g[n>>2]?+g[m>>2]:+g[n>>2])*1.2;h[d>>3]=+g[j>>2];h[d+8>>3]=o;h[d+16>>3]=p;h[d+24>>3]=q;h[d+32>>3]=r;h[d+40>>3]=0.0;h[d+48>>3]=s;oF(e,117044,d);jF(c[f>>2]|0,117191)|0;jF(c[f>>2]|0,118021)|0;i=b;return}function Ce(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,117005)|0;i=b;return}function De(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;h=f;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;e=c[j>>2]|0;j=c[l>>2]|0;d=c[m>>2]|0;c[h>>2]=c[k>>2];c[h+4>>2]=j;c[h+8>>2]=d;oF(e,116975,h);g[12136]=+(_(c[l>>2]|0,-10)|0);i=f;return}function Ee(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,116958)|0;i=b;return}function Fe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,116940)|0;i=b;return}function Ge(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,116924)|0;i=b;return}function He(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,116903)|0;g[12136]=+g[12136]-2.0;i=b;return}function Ie(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,116884)|0;i=b;return}function Je(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[d>>2]=wB(c[(c[(c[e>>2]|0)+16>>2]|0)+8>>2]|0)|0;oF(a,116862,d);i=b;return}function Ke(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,116846)|0;i=b;return}function Le(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,116828)|0;g[12136]=+g[12136]-5.0;i=b;return}function Me(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;jF(c[d>>2]|0,116812)|0;g[12136]=+g[12136]+5.0;i=b;return}function Ne(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0;f=i;i=i+192|0;j=f+120|0;k=f+72|0;l=f+48|0;m=f+40|0;n=f+16|0;o=f+184|0;p=f+180|0;q=f+8|0;r=f;s=f+176|0;t=f+172|0;u=f+168|0;v=f+164|0;w=f+160|0;c[o>>2]=b;c[p>>2]=e;e=c[o>>2]|0;x=+h[(c[(c[p>>2]|0)+4>>2]|0)+16>>3];b=c[c[(c[p>>2]|0)+4>>2]>>2]|0;c[n>>2]=c[c[p>>2]>>2];h[n+8>>3]=x;c[n+16>>2]=b;oF(e,116658,n);g[12137]=+g[12136]-9.0;switch(a[(c[p>>2]|0)+48>>0]|0){case 108:break;case 114:{h[d>>3]=+h[d>>3]-+h[(c[p>>2]|0)+32>>3];break}default:h[d>>3]=+h[d>>3]-+h[(c[p>>2]|0)+32>>3]/2.0}h[q>>3]=(+h[d>>3]+ +h[(c[o>>2]|0)+504>>3])*+h[(c[o>>2]|0)+488>>3];h[r>>3]=(+h[d+8>>3]+ +h[(c[o>>2]|0)+504+8>>3])*+h[(c[o>>2]|0)+488+8>>3];d=c[o>>2]|0;h[m>>3]=+h[(c[(c[p>>2]|0)+4>>2]|0)+16>>3]*+h[(c[o>>2]|0)+488>>3];c[t>>2]=ze(d,116710,m)|0;m=c[o>>2]|0;x=+(c[(c[o>>2]|0)+360>>2]|0);h[l>>3]=0.0;h[l+8>>3]=0.0;h[l+16>>3]=x;c[u>>2]=ze(m,115949,l)|0;l=c[o>>2]|0;x=+h[r>>3];y=+g[12137];h[j>>3]=+h[q>>3];h[j+8>>3]=x;h[j+16>>3]=y;c[v>>2]=ze(l,115981,j)|0;l=c[o>>2]|0;q=j;r=(c[(c[o>>2]|0)+16>>2]|0)+16|0;m=q+40|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(m|0));c[w>>2]=Te(l,j,0.0)|0;j=c[o>>2]|0;l=c[c[p>>2]>>2]|0;r=c[t>>2]|0;q=c[u>>2]|0;m=c[v>>2]|0;d=c[w>>2]|0;c[k>>2]=c[c[(c[p>>2]|0)+4>>2]>>2];h[k+8>>3]=.25;h[k+16>>3]=0.0;c[k+24>>2]=l;c[k+28>>2]=116797;c[k+32>>2]=r;c[k+36>>2]=q;c[k+40>>2]=m;c[k+44>>2]=d;c[s>>2]=ze(j,116722,k)|0;jF(c[o>>2]|0,c[s>>2]|0)|0;O4(c[s>>2]|0);O4(c[u>>2]|0);O4(c[w>>2]|0);O4(c[v>>2]|0);O4(c[t>>2]|0);i=f;return}function Oe(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0;e=i;i=i+288|0;f=e+192|0;j=e+152|0;k=e+128|0;l=e+104|0;m=e+80|0;n=e+48|0;o=e+24|0;p=e;q=e+280|0;r=e+276|0;s=e+272|0;t=e+268|0;u=e+264|0;v=e+260|0;w=e+256|0;x=e+252|0;y=e+248|0;z=e+244|0;A=e+240|0;B=e+236|0;C=e+232|0;c[q>>2]=a;c[r>>2]=b;c[s>>2]=d;jF(c[q>>2]|0,116535)|0;g[12137]=+g[12136]-6.0;g[y>>2]=(+h[c[r>>2]>>3]+ +h[(c[q>>2]|0)+504>>3])*+h[(c[q>>2]|0)+488>>3];g[z>>2]=(+h[(c[r>>2]|0)+8>>3]+ +h[(c[q>>2]|0)+504+8>>3])*+h[(c[q>>2]|0)+488+8>>3];g[A>>2]=(+h[(c[r>>2]|0)+16>>3]-+h[c[r>>2]>>3])*+h[(c[q>>2]|0)+488>>3];g[B>>2]=(+h[(c[r>>2]|0)+16+8>>3]-+h[(c[r>>2]|0)+8>>3])*+h[(c[q>>2]|0)+488+8>>3];g[C>>2]=+h[(c[(c[q>>2]|0)+16>>2]|0)+152>>3]/(+g[A>>2]+ +g[B>>2])/2.0*5.0;r=c[q>>2]|0;D=(+g[A>>2]+ +g[B>>2])/4.0;E=+g[B>>2];h[p>>3]=+g[A>>2];h[p+8>>3]=D;h[p+16>>3]=E;c[u>>2]=ze(r,115917,p)|0;p=c[q>>2]|0;E=+(c[(c[q>>2]|0)+360>>2]|0);h[o>>3]=90.0;h[o+8>>3]=0.0;h[o+16>>3]=E;c[v>>2]=ze(p,115949,o)|0;o=c[q>>2]|0;E=+g[z>>2];D=+g[12137];h[f>>3]=+g[y>>2];h[f+8>>3]=E;h[f+16>>3]=D;c[w>>2]=ze(o,115981,f)|0;o=c[q>>2]|0;p=f;r=(c[(c[q>>2]|0)+16>>2]|0)+16|0;d=p+40|0;do{c[p>>2]=c[r>>2];p=p+4|0;r=r+4|0}while((p|0)<(d|0));c[x>>2]=Te(o,f,0.0)|0;o=c[q>>2]|0;D=+g[C>>2];C=c[u>>2]|0;b=c[v>>2]|0;a=c[w>>2]|0;F=c[x>>2]|0;h[n>>3]=1.0;h[n+8>>3]=D;c[n+16>>2]=C;c[n+20>>2]=b;c[n+24>>2]=a;c[n+28>>2]=F;c[t>>2]=ze(o,116550,n)|0;jF(c[q>>2]|0,c[t>>2]|0)|0;O4(c[u>>2]|0);O4(c[v>>2]|0);O4(c[w>>2]|0);O4(c[x>>2]|0);O4(c[t>>2]|0);if(!(c[s>>2]|0)){i=e;return}s=c[q>>2]|0;D=+g[B>>2];h[m>>3]=+g[A>>2];h[m+8>>3]=D;h[m+16>>3]=1.0;c[u>>2]=ze(s,115917,m)|0;m=c[q>>2]|0;D=+(c[(c[q>>2]|0)+360>>2]|0);h[l>>3]=0.0;h[l+8>>3]=0.0;h[l+16>>3]=D;c[v>>2]=ze(m,115949,l)|0;l=c[q>>2]|0;D=+g[z>>2];E=+g[12137];h[k>>3]=+g[y>>2];h[k+8>>3]=D;h[k+16>>3]=E;c[w>>2]=ze(l,115981,k)|0;k=c[q>>2]|0;p=f;r=(c[(c[q>>2]|0)+16>>2]|0)+56|0;d=p+40|0;do{c[p>>2]=c[r>>2];p=p+4|0;r=r+4|0}while((p|0)<(d|0));c[x>>2]=Te(k,f,0.0)|0;f=c[q>>2]|0;k=c[u>>2]|0;r=c[v>>2]|0;p=c[w>>2]|0;d=c[x>>2]|0;h[j>>3]=0.0;h[j+8>>3]=0.0;h[j+16>>3]=0.0;c[j+24>>2]=k;c[j+28>>2]=r;c[j+32>>2]=p;c[j+36>>2]=d;c[t>>2]=ze(f,116596,j)|0;jF(c[q>>2]|0,c[t>>2]|0)|0;O4(c[u>>2]|0);O4(c[v>>2]|0);O4(c[w>>2]|0);O4(c[x>>2]|0);O4(c[t>>2]|0);i=e;return}function Pe(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0;f=i;i=i+384|0;j=f+296|0;k=f+288|0;l=f+272|0;m=f+264|0;n=f+240|0;o=f+232|0;p=f+208|0;q=f+184|0;r=f+160|0;s=f+152|0;t=f+136|0;u=f+128|0;v=f+96|0;w=f+88|0;x=f+56|0;y=f+48|0;z=f+24|0;A=f;B=f+380|0;C=f+376|0;D=f+372|0;E=f+368|0;F=f+364|0;G=f+360|0;H=f+356|0;I=f+352|0;J=f+348|0;K=f+344|0;L=f+340|0;M=f+336|0;c[B>>2]=a;c[C>>2]=b;c[D>>2]=d;c[E>>2]=e;jF(c[B>>2]|0,116400)|0;g[12137]=+g[12136]-2.0;e=c[B>>2]|0;N=+h[(c[B>>2]|0)+488+8>>3];h[A>>3]=+h[(c[B>>2]|0)+488>>3];h[A+8>>3]=N;h[A+16>>3]=1.0;c[G>>2]=ze(e,115917,A)|0;A=c[B>>2]|0;N=+(c[(c[B>>2]|0)+360>>2]|0);h[z>>3]=0.0;h[z+8>>3]=0.0;h[z+16>>3]=N;c[H>>2]=ze(A,115949,z)|0;z=c[B>>2]|0;N=+g[12137]-2.0;h[j>>3]=0.0;h[j+8>>3]=0.0;h[j+16>>3]=N;c[I>>2]=ze(z,115981,j)|0;z=c[B>>2]|0;A=j;e=(c[(c[B>>2]|0)+16>>2]|0)+16|0;d=A+40|0;do{c[A>>2]=c[e>>2];A=A+4|0;e=e+4|0}while((A|0)<(d|0));c[J>>2]=Te(z,j,0.0)|0;z=c[B>>2]|0;b=(c[D>>2]|0)+1|0;c[y>>2]=116044;c[y+4>>2]=b;c[F>>2]=ze(z,116013,y)|0;c[M>>2]=0;while(1){O=c[B>>2]|0;if((c[M>>2]|0)>=(c[D>>2]|0))break;N=+h[(c[C>>2]|0)+(c[M>>2]<<4)+8>>3]+ +h[(c[B>>2]|0)+504+8>>3];P=+h[(c[(c[B>>2]|0)+16>>2]|0)+152>>3];h[x>>3]=+h[(c[C>>2]|0)+(c[M>>2]<<4)>>3]+ +h[(c[B>>2]|0)+504>>3];h[x+8>>3]=N;h[x+16>>3]=0.0;h[x+24>>3]=P;c[K>>2]=ze(O,116058,x)|0;y=c[B>>2]|0;z=c[K>>2]|0;c[w>>2]=c[F>>2];c[w+4>>2]=z;c[L>>2]=ze(y,116087,w)|0;O4(c[K>>2]|0);O4(c[F>>2]|0);c[F>>2]=c[L>>2];c[M>>2]=(c[M>>2]|0)+1}P=+h[(c[C>>2]|0)+8>>3]+ +h[(c[B>>2]|0)+504+8>>3];N=+h[(c[(c[B>>2]|0)+16>>2]|0)+152>>3];h[v>>3]=+h[c[C>>2]>>3]+ +h[(c[B>>2]|0)+504>>3];h[v+8>>3]=P;h[v+16>>3]=0.0;h[v+24>>3]=N;c[K>>2]=ze(O,116058,v)|0;v=c[B>>2]|0;O=c[K>>2]|0;c[u>>2]=c[F>>2];c[u+4>>2]=O;c[L>>2]=ze(v,116087,u)|0;O4(c[K>>2]|0);O4(c[F>>2]|0);c[F>>2]=c[L>>2];u=c[B>>2]|0;v=c[H>>2]|0;O=c[I>>2]|0;w=c[J>>2]|0;c[t>>2]=c[G>>2];c[t+4>>2]=v;c[t+8>>2]=O;c[t+12>>2]=w;c[L>>2]=ze(u,116415,t)|0;t=c[B>>2]|0;u=c[L>>2]|0;c[s>>2]=c[F>>2];c[s+4>>2]=u;c[F>>2]=ze(t,116142,s)|0;O4(c[L>>2]|0);jF(c[B>>2]|0,c[F>>2]|0)|0;O4(c[G>>2]|0);O4(c[H>>2]|0);O4(c[I>>2]|0);O4(c[J>>2]|0);O4(c[F>>2]|0);if(!(c[E>>2]|0)){i=f;return}E=c[B>>2]|0;N=+h[(c[B>>2]|0)+488+8>>3];h[r>>3]=+h[(c[B>>2]|0)+488>>3];h[r+8>>3]=N;h[r+16>>3]=1.0;c[G>>2]=ze(E,115917,r)|0;r=c[B>>2]|0;N=+(c[(c[B>>2]|0)+360>>2]|0);h[q>>3]=0.0;h[q+8>>3]=0.0;h[q+16>>3]=N;c[H>>2]=ze(r,115949,q)|0;q=c[B>>2]|0;N=+g[12137]-2.0;h[p>>3]=0.0;h[p+8>>3]=0.0;h[p+16>>3]=N;c[I>>2]=ze(q,115981,p)|0;p=c[B>>2]|0;A=j;e=(c[(c[B>>2]|0)+16>>2]|0)+56|0;d=A+40|0;do{c[A>>2]=c[e>>2];A=A+4|0;e=e+4|0}while((A|0)<(d|0));c[J>>2]=Te(p,j,.25)|0;j=c[B>>2]|0;c[o>>2]=c[D>>2];c[F>>2]=ze(j,116460,o)|0;c[M>>2]=0;while(1){Q=c[B>>2]|0;if((c[M>>2]|0)>=(c[D>>2]|0))break;N=+h[(c[C>>2]|0)+(c[M>>2]<<4)+8>>3]+ +h[(c[B>>2]|0)+504+8>>3];h[n>>3]=+h[(c[C>>2]|0)+(c[M>>2]<<4)>>3]+ +h[(c[B>>2]|0)+504>>3];h[n+8>>3]=N;h[n+16>>3]=0.0;c[K>>2]=ze(Q,116475,n)|0;o=c[B>>2]|0;j=c[K>>2]|0;c[m>>2]=c[F>>2];c[m+4>>2]=j;c[L>>2]=ze(o,116497,m)|0;O4(c[K>>2]|0);O4(c[F>>2]|0);c[F>>2]=c[L>>2];c[M>>2]=(c[M>>2]|0)+1}M=c[H>>2]|0;K=c[I>>2]|0;m=c[J>>2]|0;c[l>>2]=c[G>>2];c[l+4>>2]=M;c[l+8>>2]=K;c[l+12>>2]=m;c[L>>2]=ze(Q,116507,l)|0;l=c[B>>2]|0;Q=c[L>>2]|0;c[k>>2]=c[F>>2];c[k+4>>2]=Q;c[F>>2]=ze(l,116142,k)|0;O4(c[L>>2]|0);jF(c[B>>2]|0,c[F>>2]|0)|0;O4(c[G>>2]|0);O4(c[H>>2]|0);O4(c[I>>2]|0);O4(c[J>>2]|0);O4(c[F>>2]|0);i=f;return}function Qe(a,b,d,e,f,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0;k=i;i=i+256|0;l=k+160|0;m=k+152|0;n=k+136|0;o=k+128|0;p=k+96|0;q=k+88|0;r=k+56|0;s=k+48|0;t=k+24|0;u=k;v=k+252|0;w=k+248|0;x=k+244|0;y=k+228|0;z=k+224|0;A=k+220|0;B=k+216|0;C=k+212|0;D=k+208|0;E=k+204|0;F=k+200|0;c[v>>2]=a;c[w>>2]=b;c[x>>2]=d;c[k+240>>2]=e;c[k+236>>2]=f;c[k+232>>2]=j;jF(c[v>>2]|0,116327)|0;g[12137]=+g[12136]-4.0;j=c[v>>2]|0;G=+h[(c[v>>2]|0)+488+8>>3];h[u>>3]=+h[(c[v>>2]|0)+488>>3];h[u+8>>3]=G;h[u+16>>3]=1.0;c[C>>2]=ze(j,115917,u)|0;u=c[v>>2]|0;G=+(c[(c[v>>2]|0)+360>>2]|0);h[t>>3]=0.0;h[t+8>>3]=0.0;h[t+16>>3]=G;c[D>>2]=ze(u,115949,t)|0;t=c[v>>2]|0;G=+g[12137]-2.0;h[l>>3]=0.0;h[l+8>>3]=0.0;h[l+16>>3]=G;c[E>>2]=ze(t,115981,l)|0;t=c[v>>2]|0;u=l;j=(c[(c[v>>2]|0)+16>>2]|0)+56|0;f=u+40|0;do{c[u>>2]=c[j>>2];u=u+4|0;j=j+4|0}while((u|0)<(f|0));c[F>>2]=Te(t,l,0.0)|0;l=c[v>>2]|0;t=(c[x>>2]|0)+2|0;c[s>>2]=116341;c[s+4>>2]=t;c[B>>2]=ze(l,116013,s)|0;c[y>>2]=0;while(1){H=c[v>>2]|0;if((c[y>>2]|0)>=(c[x>>2]|0))break;G=+h[(c[w>>2]|0)+(c[y>>2]<<4)+8>>3]+ +h[(c[v>>2]|0)+504+8>>3];I=+h[(c[(c[v>>2]|0)+16>>2]|0)+152>>3];h[r>>3]=+h[(c[w>>2]|0)+(c[y>>2]<<4)>>3]+ +h[(c[v>>2]|0)+504>>3];h[r+8>>3]=G;h[r+16>>3]=0.0;h[r+24>>3]=I;c[z>>2]=ze(H,116058,r)|0;s=c[v>>2]|0;l=c[z>>2]|0;c[q>>2]=c[B>>2];c[q+4>>2]=l;c[A>>2]=ze(s,116087,q)|0;O4(c[z>>2]|0);O4(c[B>>2]|0);c[B>>2]=c[A>>2];if(!((c[y>>2]|0)!=0?(c[y>>2]|0)!=((c[x>>2]|0)-1|0):0)){s=c[v>>2]|0;I=+h[(c[w>>2]|0)+(c[y>>2]<<4)+8>>3]+ +h[(c[v>>2]|0)+504+8>>3];G=+h[(c[(c[v>>2]|0)+16>>2]|0)+152>>3];h[p>>3]=+h[(c[w>>2]|0)+(c[y>>2]<<4)>>3]+ +h[(c[v>>2]|0)+504>>3];h[p+8>>3]=I;h[p+16>>3]=0.0;h[p+24>>3]=G;c[z>>2]=ze(s,116058,p)|0;s=c[v>>2]|0;l=c[z>>2]|0;c[o>>2]=c[B>>2];c[o+4>>2]=l;c[A>>2]=ze(s,116087,o)|0;O4(c[z>>2]|0);O4(c[B>>2]|0);c[B>>2]=c[A>>2]}c[y>>2]=(c[y>>2]|0)+1}y=c[D>>2]|0;z=c[E>>2]|0;o=c[F>>2]|0;c[n>>2]=c[C>>2];c[n+4>>2]=y;c[n+8>>2]=z;c[n+12>>2]=o;c[A>>2]=ze(H,116350,n)|0;n=c[v>>2]|0;H=c[A>>2]|0;c[m>>2]=c[B>>2];c[m+4>>2]=H;c[B>>2]=ze(n,116142,m)|0;O4(c[A>>2]|0);jF(c[v>>2]|0,c[B>>2]|0)|0;O4(c[C>>2]|0);O4(c[D>>2]|0);O4(c[E>>2]|0);O4(c[F>>2]|0);O4(c[B>>2]|0);i=k;return}function Re(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0;e=i;i=i+208|0;f=e+120|0;j=e+112|0;k=e+96|0;l=e+88|0;m=e+56|0;n=e+48|0;o=e+24|0;p=e;q=e+200|0;r=e+196|0;s=e+192|0;t=e+188|0;u=e+184|0;v=e+180|0;w=e+176|0;x=e+172|0;y=e+168|0;z=e+164|0;A=e+160|0;c[q>>2]=a;c[r>>2]=b;c[s>>2]=d;jF(c[q>>2]|0,115901)|0;g[12137]=+g[12136]-6.0;d=c[q>>2]|0;B=+h[(c[q>>2]|0)+488+8>>3];h[p>>3]=+h[(c[q>>2]|0)+488>>3];h[p+8>>3]=B;h[p+16>>3]=1.0;c[u>>2]=ze(d,115917,p)|0;p=c[q>>2]|0;B=+(c[(c[q>>2]|0)+360>>2]|0);h[o>>3]=0.0;h[o+8>>3]=0.0;h[o+16>>3]=B;c[v>>2]=ze(p,115949,o)|0;o=c[q>>2]|0;B=+g[12137];h[f>>3]=0.0;h[f+8>>3]=0.0;h[f+16>>3]=B;c[w>>2]=ze(o,115981,f)|0;o=c[q>>2]|0;p=f;d=(c[(c[q>>2]|0)+16>>2]|0)+16|0;b=p+40|0;do{c[p>>2]=c[d>>2];p=p+4|0;d=d+4|0}while((p|0)<(b|0));c[x>>2]=Te(o,f,0.0)|0;f=c[q>>2]|0;o=c[s>>2]|0;c[n>>2]=116044;c[n+4>>2]=o;c[t>>2]=ze(f,116013,n)|0;c[A>>2]=0;while(1){C=c[q>>2]|0;if((c[A>>2]|0)>=(c[s>>2]|0))break;B=+h[(c[r>>2]|0)+(c[A>>2]<<4)+8>>3]+ +h[(c[q>>2]|0)+504+8>>3];D=+h[(c[(c[q>>2]|0)+16>>2]|0)+152>>3];h[m>>3]=+h[(c[r>>2]|0)+(c[A>>2]<<4)>>3]+ +h[(c[q>>2]|0)+504>>3];h[m+8>>3]=B;h[m+16>>3]=0.0;h[m+24>>3]=D;c[y>>2]=ze(C,116058,m)|0;n=c[q>>2]|0;f=c[y>>2]|0;c[l>>2]=c[t>>2];c[l+4>>2]=f;c[z>>2]=ze(n,116087,l)|0;O4(c[y>>2]|0);O4(c[t>>2]|0);c[t>>2]=c[z>>2];c[A>>2]=(c[A>>2]|0)+1}A=c[v>>2]|0;y=c[w>>2]|0;l=c[x>>2]|0;c[k>>2]=c[u>>2];c[k+4>>2]=A;c[k+8>>2]=y;c[k+12>>2]=l;c[z>>2]=ze(C,116096,k)|0;k=c[q>>2]|0;C=c[z>>2]|0;c[j>>2]=c[t>>2];c[j+4>>2]=C;c[t>>2]=ze(k,116142,j)|0;O4(c[z>>2]|0);jF(c[q>>2]|0,c[t>>2]|0)|0;O4(c[u>>2]|0);O4(c[v>>2]|0);O4(c[w>>2]|0);O4(c[x>>2]|0);O4(c[t>>2]|0);i=e;return}function Se(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;c[e>>2]=c[g>>2];oF(b,115882,e);i=d;return}function Te(a,b,e){a=a|0;b=b|0;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0;f=i;i=i+128|0;j=f+104|0;k=f+96|0;l=f+64|0;m=f+48|0;n=f+32|0;o=f+16|0;p=f;q=f+120|0;r=f+116|0;s=f+112|0;t=f+108|0;c[q>>2]=a;g[r>>2]=e;a:do switch(c[b+32>>2]|0){case 5:{if(!(J3(c[b>>2]|0,173905)|0)){a=c[q>>2]|0;e=+g[r>>2];c[p>>2]=116164;h[p+8>>3]=e;c[t>>2]=ze(a,116147,p)|0;break a}if(!(J3(c[b>>2]|0,171035)|0)){a=c[q>>2]|0;e=+g[r>>2];c[o>>2]=116168;h[o+8>>3]=e;c[t>>2]=ze(a,116147,o)|0;break a}a=(J3(c[b>>2]|0,169034)|0)!=0;u=c[q>>2]|0;if(a){e=+g[r>>2];c[m>>2]=c[b>>2];h[m+8>>3]=e;c[t>>2]=ze(u,116147,m)|0;break a}else{e=+g[r>>2];c[n>>2]=116174;h[n+8>>3]=e;c[t>>2]=ze(u,116147,n)|0;break a}break}case 1:{u=c[q>>2]|0;e=+(d[b+1>>0]|0|0)/256.0;v=+(d[b+2>>0]|0|0)/256.0;w=+g[r>>2];h[l>>3]=+(d[b>>0]|0|0)/256.0;h[l+8>>3]=e;h[l+16>>3]=v;h[l+24>>3]=w;c[t>>2]=ze(u,116179,l)|0;break}default:{u=c[24742]|0;a=c[b>>2]|0;c[k>>2]=c[b+32>>2];c[k+4>>2]=a;Y2(u,116218,k)|0;La(176099,116268,438,116288)}}while(0);k=c[q>>2]|0;c[j>>2]=c[t>>2];c[s>>2]=ze(k,116305,j)|0;O4(c[t>>2]|0);i=f;return c[s>>2]|0}function Ue(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;d=b+24|0;e=b+16|0;f=b;g=b+32|0;h=b+28|0;c[g>>2]=a;c[h>>2]=c[(c[g>>2]|0)+16>>2];a=c[g>>2]|0;j=c[c[c[(c[g>>2]|0)+12>>2]>>2]>>2]|0;k=c[(c[c[(c[g>>2]|0)+12>>2]>>2]|0)+4>>2]|0;l=c[(c[c[(c[g>>2]|0)+12>>2]>>2]|0)+8>>2]|0;c[f>>2]=c[12188];c[f+4>>2]=j;c[f+8>>2]=k;c[f+12>>2]=l;oF(a,120901,f);f=c[g>>2]|0;a=c[12188]|0;l=wB(c[(c[h>>2]|0)+8>>2]|0)|0;c[e>>2]=a;c[e+4>>2]=l;oF(f,120933,e);e=c[g>>2]|0;c[d>>2]=c[12188];oF(e,120947,d);i=b;return}function Ve(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[d>>2]=c[12188];oF(a,120849,d);i=b;return}function We(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,Q=0,R=0,S=0,T=0,U=0.0;b=i;i=i+352|0;d=b+320|0;e=b+312|0;f=b+296|0;g=b+288|0;j=b+280|0;k=b+272|0;l=b+264|0;m=b+256|0;n=b+248|0;o=b+240|0;p=b+232|0;q=b+224|0;r=b+216|0;s=b+208|0;t=b+200|0;u=b+192|0;v=b+184|0;w=b+176|0;x=b+168|0;y=b+160|0;z=b+152|0;A=b+144|0;B=b+136|0;C=b+128|0;D=b+120|0;E=b+112|0;F=b+104|0;G=b+96|0;H=b+88|0;I=b+80|0;J=b+72|0;K=b+64|0;L=b+48|0;M=b+40|0;N=b+24|0;O=b+344|0;Q=b+328|0;R=b+16|0;S=b+8|0;T=b;c[O>>2]=a;a=(c[O>>2]|0)+456|0;c[Q>>2]=c[a>>2];c[Q+4>>2]=c[a+4>>2];c[Q+8>>2]=c[a+8>>2];c[Q+12>>2]=c[a+12>>2];if(((c[12261]|0)!=0?(c[(c[O>>2]|0)+360>>2]|0)!=0:0)?(c[(c[O>>2]|0)+360>>2]|0)!=90:0){gf(129372);c[12261]=0}h[R>>3]=(+(c[Q+8+4>>2]|0)-+(c[Q+4>>2]|0))/72.0;h[S>>3]=(+(c[Q+8>>2]|0)-+(c[Q>>2]|0))/72.0;if((c[(c[O>>2]|0)+360>>2]|0)==90){h[T>>3]=+h[S>>3];h[S>>3]=+h[R>>3];h[R>>3]=+h[T>>3]}T=c[O>>2]|0;U=+h[R>>3];h[N>>3]=+h[S>>3];h[N+8>>3]=U;oF(T,118478,N);N=c[O>>2]|0;c[M>>2]=c[12188];oF(N,118493,M);if(+h[S>>3]>0.0){h[137]=+e2(+h[S>>3]);h[137]=+h[137]+(3.0-+(~~+h[137]|0))}else h[137]=3.0;h[137]=+P(10.0,+(+h[137]));M=c[O>>2]|0;U=+h[137];h[L>>3]=+h[137];h[L+8>>3]=U;oF(M,118662,L);L=c[O>>2]|0;c[K>>2]=c[12188];oF(L,118697,K);K=c[O>>2]|0;c[J>>2]=c[12188];oF(K,118755,J);J=c[O>>2]|0;c[I>>2]=c[12188];oF(J,118815,I);I=c[O>>2]|0;c[H>>2]=c[12188];oF(I,118864,H);H=c[O>>2]|0;c[G>>2]=c[12188];oF(H,118903,G);G=c[O>>2]|0;c[F>>2]=c[12188];oF(G,118954,F);F=c[O>>2]|0;c[E>>2]=c[12188];oF(F,119016,E);E=c[O>>2]|0;c[D>>2]=c[12188];oF(E,119126,D);D=c[O>>2]|0;c[C>>2]=c[12188];oF(D,119217,C);C=c[O>>2]|0;c[B>>2]=c[12188];oF(C,119271,B);B=c[O>>2]|0;c[A>>2]=c[12188];oF(B,119340,A);oF(c[O>>2]|0,119376,z);z=c[O>>2]|0;c[y>>2]=c[12188];oF(z,119501,y);y=c[O>>2]|0;c[x>>2]=c[12188];oF(y,119530,x);oF(c[O>>2]|0,119570,w);w=c[O>>2]|0;c[v>>2]=c[12188];oF(w,119663,v);v=c[O>>2]|0;c[u>>2]=c[12188];oF(v,119722,u);u=c[O>>2]|0;c[t>>2]=c[12188];oF(u,119803,t);oF(c[O>>2]|0,119873,s);s=c[O>>2]|0;c[r>>2]=c[12188];oF(s,119962,r);r=c[O>>2]|0;c[q>>2]=c[12188];oF(r,120067,q);q=c[O>>2]|0;c[p>>2]=c[12188];oF(q,120143,p);p=c[O>>2]|0;c[o>>2]=c[12188];oF(p,120182,o);o=c[O>>2]|0;c[n>>2]=c[12188];oF(o,120281,n);n=c[O>>2]|0;c[m>>2]=c[12188];oF(n,120327,m);oF(c[O>>2]|0,120416,l);l=c[O>>2]|0;c[k>>2]=c[12188];oF(l,120457,k);k=c[O>>2]|0;c[j>>2]=c[12188];oF(k,120540,j);j=c[O>>2]|0;c[g>>2]=c[12188];oF(j,120641,g);g=c[O>>2]|0;U=+h[S>>3];h[f>>3]=+h[R>>3];h[f+8>>3]=U;oF(g,120705,f);oF(c[O>>2]|0,120733,e);oF(c[O>>2]|0,120741,d);i=b;return}function Xe(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b+4|0;c[d>>2]=a;oF(c[d>>2]|0,118471,b);i=b;return}function Ye(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0,v=0,w=0,x=0.0;f=i;i=i+64|0;g=f+24|0;j=f+8|0;k=f;l=f+56|0;m=f+52|0;n=f+48|0;c[l>>2]=b;c[m>>2]=e;switch(a[(c[m>>2]|0)+48>>0]|0){case 108:break;case 114:{h[d>>3]=+h[d>>3]-+h[(c[m>>2]|0)+32>>3];break}default:h[d>>3]=+h[d>>3]-+h[(c[m>>2]|0)+32>>3]/2.0}e=d+8|0;h[e>>3]=+h[e>>3]+ +h[(c[(c[m>>2]|0)+4>>2]|0)+16>>3]/216.0;h[d>>3]=+h[d>>3]+ +h[(c[m>>2]|0)+32>>3]/144.0;do if(c[c[(c[m>>2]|0)+4>>2]>>2]|0){if((c[12189]|0)!=0?(J3(c[12189]|0,c[c[(c[m>>2]|0)+4>>2]>>2]|0)|0)==0:0)break;e=c[l>>2]|0;c[k>>2]=ef(c[c[(c[m>>2]|0)+4>>2]>>2]|0)|0;oF(e,118370,k);c[12189]=c[c[(c[m>>2]|0)+4>>2]>>2]}while(0);c[n>>2]=~~+h[(c[(c[m>>2]|0)+4>>2]|0)+16>>3];c[n>>2]=1;if((c[n>>2]|0)==(c[12190]|0)){o=c[l>>2]|0;p=c[m>>2]|0;q=c[p>>2]|0;r=ff(q)|0;s=+h[d>>3];t=d+8|0;u=+h[t>>3];c[g>>2]=r;v=g+8|0;h[v>>3]=s;w=g+16|0;h[w>>3]=u;oF(o,118399,g);i=f;return}k=c[l>>2]|0;x=+h[137];c[j>>2]=c[n>>2];h[j+8>>3]=x;oF(k,118378,j);c[12190]=c[n>>2];o=c[l>>2]|0;p=c[m>>2]|0;q=c[p>>2]|0;r=ff(q)|0;s=+h[d>>3];t=d+8|0;u=+h[t>>3];c[g>>2]=r;v=g+8|0;h[v>>3]=s;w=g+16|0;h[w>>3]=u;oF(o,118399,g);i=f;return}function Ze(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;e=i;i=i+64|0;f=e;g=e+48|0;j=e+44|0;k=e+40|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;d=c[g>>2]|0;g=(c[k>>2]|0)!=0?118312:178518;l=(+h[(c[j>>2]|0)+16>>3]-+h[c[j>>2]>>3])*2.0/72.0;m=(+h[(c[j>>2]|0)+16+8>>3]-+h[(c[j>>2]|0)+8>>3])*2.0/72.0;n=+h[c[j>>2]>>3]/72.0;o=+h[(c[j>>2]|0)+8>>3]/72.0;c[f>>2]=1;c[f+4>>2]=g;h[f+8>>3]=l;h[f+16>>3]=m;h[f+24>>3]=n;h[f+32>>3]=o;oF(d,118318,f);i=e;return}function _e(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+96|0;g=f+80|0;j=f+76|0;k=f+72|0;l=f+68|0;m=f+64|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=c[(c[g>>2]|0)+16>>2];c[f+60>>2]=2;c[f+56>>2]=3;c[f+48>>2]=~~+h[(c[m>>2]|0)+152>>3];c[f+44>>2]=c[(c[m>>2]|0)+16>>2];c[f+40>>2]=c[(c[m>>2]|0)+56>>2];c[f+36>>2]=0;c[f+32>>2]=(c[l>>2]|0)!=0?20:-1;c[f+28>>2]=0;c[f+24>>2]=0;c[f+20>>2]=0;c[f+16>>2]=0;c[f+12>>2]=0;c[f+8>>2]=(c[k>>2]|0)+1;cf(c[m>>2]|0,f+52|0,f);df(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0,1);i=f;return}function $e(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0;j=i;i=i+256|0;k=j+128|0;l=j+120|0;m=j+112|0;n=j+104|0;o=j+244|0;p=j+240|0;q=j+236|0;r=j+224|0;s=j+220|0;t=j+212|0;u=j+196|0;v=j+188|0;w=j+172|0;x=j+168|0;y=j+80|0;z=j+16|0;A=j+160|0;B=j+152|0;C=j+148|0;D=j+144|0;E=j+140|0;F=j+136|0;G=j+132|0;H=j;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[j+232>>2]=e;c[j+228>>2]=f;c[r>>2]=g;c[s>>2]=c[(c[o>>2]|0)+16>>2];c[j+216>>2]=3;c[j+204>>2]=~~+h[(c[s>>2]|0)+152>>3];c[j+200>>2]=c[(c[s>>2]|0)+16>>2];c[u>>2]=c[(c[s>>2]|0)+56>>2];c[j+192>>2]=0;c[j+184>>2]=0;c[j+180>>2]=0;c[j+176>>2]=0;c[w>>2]=c[q>>2];c[D>>2]=0;c[F>>2]=N4((((c[w>>2]|0)+1|0)*7|0)*20|0)|0;c[G>>2]=c[F>>2];cf(c[s>>2]|0,j+208|0,j+96|0);if(c[r>>2]|0){c[t>>2]=5;c[v>>2]=20;c[u>>2]=c[(c[(c[o>>2]|0)+16>>2]|0)+56>>2]}else{c[t>>2]=4;c[v>>2]=-1;c[u>>2]=0}h[z+48>>3]=+h[c[p>>2]>>3];h[z+48+8>>3]=+h[(c[p>>2]|0)+8>>3];c[D>>2]=(c[D>>2]|0)+1;I=+h[c[p>>2]>>3];c[A>>2]=~~(+h[c[p>>2]>>3]>=0.0?I+.5:I-.5);I=+h[(c[p>>2]|0)+8>>3];c[A+4>>2]=~~(+h[(c[p>>2]|0)+8>>3]>=0.0?I+.5:I-.5);u=c[G>>2]|0;v=c[A+4>>2]|0;c[n>>2]=c[A>>2];c[n+4>>2]=v;c[E>>2]=k3(u,118296,n)|0;c[G>>2]=(c[G>>2]|0)+(c[E>>2]|0);c[x>>2]=0;while(1){if(((c[x>>2]|0)+3|0)>=(c[q>>2]|0))break;n=z+48|0;c[z>>2]=c[n>>2];c[z+4>>2]=c[n+4>>2];c[z+8>>2]=c[n+8>>2];c[z+12>>2]=c[n+12>>2];c[B>>2]=1;while(1){if((c[B>>2]|0)>3)break;h[z+(c[B>>2]<<4)>>3]=+h[(c[p>>2]|0)+((c[x>>2]|0)+(c[B>>2]|0)<<4)>>3];h[z+(c[B>>2]<<4)+8>>3]=+h[(c[p>>2]|0)+((c[x>>2]|0)+(c[B>>2]|0)<<4)+8>>3];c[B>>2]=(c[B>>2]|0)+1}c[C>>2]=1;while(1){if((c[C>>2]|0)>6)break;c[D>>2]=(c[D>>2]|0)+1;qO(H,z,3,+(c[C>>2]|0)/6.0,0,0);c[y>>2]=c[H>>2];c[y+4>>2]=c[H+4>>2];c[y+8>>2]=c[H+8>>2];c[y+12>>2]=c[H+12>>2];I=+h[y>>3];c[A>>2]=~~(+h[y>>3]>=0.0?I+.5:I-.5);I=+h[y+8>>3];c[A+4>>2]=~~(+h[y+8>>3]>=0.0?I+.5:I-.5);n=c[G>>2]|0;u=c[A+4>>2]|0;c[m>>2]=c[A>>2];c[m+4>>2]=u;c[E>>2]=k3(n,118296,m)|0;c[G>>2]=(c[G>>2]|0)+(c[E>>2]|0);c[C>>2]=(c[C>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+3}C=c[o>>2]|0;c[l>>2]=c[F>>2];oF(C,118303,l);O4(c[F>>2]|0);c[x>>2]=0;while(1){J=c[o>>2]|0;if((c[x>>2]|0)>=(c[D>>2]|0))break;c[k>>2]=((c[x>>2]|0)%((c[D>>2]|0)-1|0)|0|0)!=0?1:0;oF(J,118308,k);c[x>>2]=(c[x>>2]|0)+1}jF(J,193392)|0;i=j;return}function af(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+80|0;f=e+76|0;g=e+72|0;j=e+68|0;k=e+64|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[(c[f>>2]|0)+16>>2];c[e+60>>2]=2;c[e+56>>2]=1;c[e+48>>2]=~~+h[(c[k>>2]|0)+152>>3];c[e+44>>2]=c[(c[k>>2]|0)+16>>2];c[e+40>>2]=0;c[e+36>>2]=0;c[e+32>>2]=0;c[e+28>>2]=0;c[e+24>>2]=0;c[e+20>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=c[j>>2];cf(c[k>>2]|0,e+52|0,e);df(c[f>>2]|0,c[g>>2]|0,c[j>>2]|0,0);i=e;return}function bf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;f=c[g>>2]|0;c[e>>2]=c[12188];c[e+4>>2]=f;oF(b,118284,e);i=d;return}function cf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;switch(c[(c[f>>2]|0)+144>>2]|0){case 1:{c[c[g>>2]>>2]=1;h[c[j>>2]>>3]=10.0;i=e;return}case 2:{c[c[g>>2]>>2]=2;h[c[j>>2]>>3]=10.0;i=e;return}default:{c[c[g>>2]>>2]=0;h[c[j>>2]>>3]=0.0;i=e;return}}}function df(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0;f=i;i=i+48|0;g=f+8|0;j=f;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+16|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[m>>2]|0))break;q=+h[(c[l>>2]|0)+(c[o>>2]<<4)>>3];c[p>>2]=~~(+h[(c[l>>2]|0)+(c[o>>2]<<4)>>3]>=0.0?q+.5:q-.5);q=+h[(c[l>>2]|0)+(c[o>>2]<<4)+8>>3];c[p+4>>2]=~~(+h[(c[l>>2]|0)+(c[o>>2]<<4)+8>>3]>=0.0?q+.5:q-.5);e=c[k>>2]|0;d=c[p+4>>2]|0;c[j>>2]=c[p>>2];c[j+4>>2]=d;oF(e,118296,j);c[o>>2]=(c[o>>2]|0)+1}if(!(c[n>>2]|0)){r=c[k>>2]|0;jF(r,193392)|0;i=f;return}q=+h[c[l>>2]>>3];c[p>>2]=~~(+h[c[l>>2]>>3]>=0.0?q+.5:q-.5);q=+h[(c[l>>2]|0)+8>>3];c[p+4>>2]=~~(+h[(c[l>>2]|0)+8>>3]>=0.0?q+.5:q-.5);l=c[k>>2]|0;n=c[p+4>>2]|0;c[g>>2]=c[p>>2];c[g+4>>2]=n;oF(l,118296,g);r=c[k>>2]|0;jF(r,193392)|0;i=f;return}function ef(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;c[f>>2]=b;c[h>>2]=48772;while(1){if(!(c[(c[h>>2]|0)+4>>2]|0))break;if(!(J3(c[(c[h>>2]|0)+4>>2]|0,c[f>>2]|0)|0))break;c[h>>2]=(c[h>>2]|0)+8}if(c[(c[h>>2]|0)+4>>2]|0){c[g>>2]=c[h>>2];j=c[g>>2]|0;i=d;return j|0}h=c[f>>2]|0;c[e>>2]=118452;c[e+4>>2]=h;$z(1,118426,e)|0;e=S3(c[f>>2]|0,45)|0;c[g>>2]=e;if(e){a[c[g>>2]>>0]=0;c[g>>2]=ef(c[f>>2]|0)|0;j=c[g>>2]|0;i=d;return j|0}else{c[g>>2]=118469;j=c[g>>2]|0;i=d;return j|0}return 0}function ff(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;k=e+16|0;c[g>>2]=b;c[h>>2]=0;if(!(c[12191]|0)){c[12192]=64;c[12191]=N4(c[12192]|0)|0}c[j>>2]=c[12191];while(1){b=c[g>>2]|0;c[g>>2]=b+1;l=a[b>>0]|0;a[k>>0]=l;if(!(l<<24>>24))break;if((c[h>>2]|0)>((c[12192]|0)-8|0)){c[12192]=c[12192]<<1;c[12191]=Q4(c[12191]|0,c[12192]|0)|0;c[j>>2]=(c[12191]|0)+(c[h>>2]|0)}if(!(n1(d[k>>0]|0)|0)){l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=92;l=c[j>>2]|0;c[f>>2]=d[k>>0];k3(l,118421,f)|0;c[j>>2]=(c[j>>2]|0)+3;c[h>>2]=(c[h>>2]|0)+4;continue}if((d[k>>0]|0|0)==92){l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=92;c[h>>2]=(c[h>>2]|0)+1}l=a[k>>0]|0;b=c[j>>2]|0;c[j>>2]=b+1;a[b>>0]=l;c[h>>2]=(c[h>>2]|0)+1}a[c[j>>2]>>0]=0;i=e;return c[12191]|0}function gf(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+8|0;c[e>>2]=a;a=c[e>>2]|0;c[d>>2]=118452;c[d+4>>2]=a;$z(0,120831,d)|0;i=b;return}function hf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;e=i;i=i+16|0;c[e+4>>2]=b;c[e>>2]=d;a[e+8>>0]=f;i=e;return}function jf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;g=i;i=i+48|0;j=g+8|0;k=g;l=g+36|0;m=g+32|0;c[l>>2]=b;c[m>>2]=d;a[g+40>>0]=f;f=c[l>>2]|0;d=c[(c[m>>2]|0)+8>>2]|0;c[k>>2]=c[(c[m>>2]|0)+8>>2];c[k+4>>2]=d;oF(f,121408,k);k=c[l>>2]|0;n=(+h[e+16>>3]+ +h[e>>3])/2.0;o=(+h[e+16+8>>3]+ +h[e+8>>3])/2.0;c[j>>2]=c[(c[m>>2]|0)+8>>2];h[j+8>>3]=n;h[j+16>>3]=o;oF(k,121450,j);i=g;return}function kf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;g=i;i=i+64|0;j=g;k=g+48|0;l=g+44|0;m=g+40|0;c[k>>2]=b;c[l>>2]=d;a[g+52>>0]=f;c[m>>2]=~~(+h[(c[k>>2]|0)+208+16+8>>3]-+h[(c[k>>2]|0)+208+8>>3]);f=c[k>>2]|0;n=+h[e+16>>3]-+h[e>>3];o=+h[e+16+8>>3]-+h[e+8>>3];p=+h[e>>3];q=+((c[m>>2]|0)>>>0)-+h[e+16+8>>3];c[j>>2]=c[(c[l>>2]|0)+8>>2];h[j+8>>3]=n;h[j+16>>3]=o;h[j+24>>3]=p;h[j+32>>3]=q;oF(f,121495,j);jF(c[k>>2]|0,121587)|0;i=g;return}function lf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;g=i;i=i+192|0;j=g+152|0;k=g+136|0;l=g+120|0;m=g+112|0;n=g+104|0;o=g+88|0;p=g+72|0;q=g+172|0;r=g+168|0;s=g+176|0;t=g+164|0;u=g;c[q>>2]=b;c[r>>2]=d;a[s>>0]=f;if(!(c[q>>2]|0))La(148844,121592,214,121611);if(!(c[r>>2]|0))La(148874,121592,215,121611);if(!(c[(c[r>>2]|0)+8>>2]|0))La(148877,121592,216,121611);f=c[(c[r>>2]|0)+52>>2]|0;c[g+160>>2]=f;if(!f){i=g;return};c[u>>2]=c[e>>2];c[u+4>>2]=c[e+4>>2];c[u+8>>2]=c[e+8>>2];c[u+12>>2]=c[e+12>>2];f=u+32|0;d=e+16|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];h[u+16>>3]=+h[u>>3];h[u+16+8>>3]=+h[u+32+8>>3];h[u+48>>3]=+h[u+32>>3];h[u+48+8>>3]=+h[u+8>>3];if(a[s>>0]|0){oF(c[q>>2]|0,121632,g+64|0);c[t>>2]=0;while(1){v=c[q>>2]|0;if((c[t>>2]|0)>=4)break;w=+h[u+(c[t>>2]<<4)+8>>3];h[p>>3]=+h[u+(c[t>>2]<<4)>>3];h[p+8>>3]=w;oF(v,121635,p);c[t>>2]=(c[t>>2]|0)+1}w=+h[u+8>>3];h[o>>3]=+h[u>>3];h[o+8>>3]=w;oF(v,121635,o);o=c[q>>2]|0;v=c[(c[r>>2]|0)+8>>2]|0;c[n>>2]=4;c[n+4>>2]=v;oF(o,121642,n)}oF(c[q>>2]|0,121632,m);c[t>>2]=0;while(1){x=c[q>>2]|0;if((c[t>>2]|0)>=4)break;w=+h[u+(c[t>>2]<<4)+8>>3];h[l>>3]=+h[u+(c[t>>2]<<4)>>3];h[l+8>>3]=w;oF(x,121635,l);c[t>>2]=(c[t>>2]|0)+1}w=+h[u+8>>3];h[k>>3]=+h[u>>3];h[k+8>>3]=w;oF(x,121635,k);k=c[q>>2]|0;q=c[(c[r>>2]|0)+8>>2]|0;c[j>>2]=4;c[j+4>>2]=q;oF(k,121657,j);i=g;return}function mf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;g=i;i=i+128|0;j=g+24|0;k=g+16|0;l=g;m=g+112|0;n=g+108|0;o=g+104|0;p=g+28|0;c[m>>2]=b;c[n>>2]=d;a[g+116>>0]=f;if(!(c[m>>2]|0))La(148844,121592,155,121673);if(!(c[n>>2]|0))La(148874,121592,156,121673);if(!(c[(c[n>>2]|0)+8>>2]|0))La(148877,121592,157,121673);if((c[(c[n>>2]|0)+52>>2]|0)!=0?(c[(c[n>>2]|0)+60>>2]|0)!=91:0){Bb[c[(c[n>>2]|0)+60>>2]&127](c[n>>2]|0);c[(c[n>>2]|0)+52>>2]=0;c[(c[n>>2]|0)+60>>2]=0;c[(c[n>>2]|0)+56>>2]=0}if(!(c[(c[n>>2]|0)+52>>2]|0)){if(!((CF(c[n>>2]|0)|0)<<24>>24)){i=g;return}c[o>>2]=W2(c[(c[n>>2]|0)+20>>2]|0)|0;if(((c[(c[n>>2]|0)+24>>2]|0)+-6|0)>>>0<2){C2(c[o>>2]|0,p)|0;c[(c[n>>2]|0)+56>>2]=c[p+36>>2];f=j2(0,c[p+36>>2]|0,1,1,c[o>>2]|0,0)|0;c[(c[n>>2]|0)+52>>2]=f;a[(c[n>>2]|0)+16>>0]=1}if(c[(c[n>>2]|0)+52>>2]|0)c[(c[n>>2]|0)+60>>2]=91;DF(c[n>>2]|0)}if(!(c[(c[n>>2]|0)+52>>2]|0)){i=g;return}f=c[m>>2]|0;q=+h[e+8>>3]-+(c[(c[n>>2]|0)+36>>2]|0);h[l>>3]=+h[e>>3]-+(c[(c[n>>2]|0)+32>>2]|0);h[l+8>>3]=q;oF(f,121691,l);l=c[m>>2]|0;f=c[n>>2]|0;if(a[(c[n>>2]|0)+16>>0]|0)IL(l,f);else{c[k>>2]=c[f+12>>2];oF(l,121722,k)}oF(c[m>>2]|0,121737,j);i=g;return}function nf(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;k2(c[(c[d>>2]|0)+52>>2]|0,c[(c[d>>2]|0)+56>>2]|0)|0;i=b;return}function of(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;e=i;i=i+96|0;g=e+48|0;h=e+80|0;j=e+76|0;k=e+72|0;l=e+68|0;c[h>>2]=b;c[j>>2]=d;a[e+84>>0]=f;if(!(c[h>>2]|0))La(148844,121592,123,121747);c[k>>2]=c[(c[h>>2]|0)+16>>2];if(!(c[k>>2]|0))La(137574,121592,125,121747);if(!(c[j>>2]|0))La(148874,121592,126,121747);if(!(c[(c[j>>2]|0)+8>>2]|0))La(148877,121592,127,121747);c[l>>2]=c[(c[(c[h>>2]|0)+16>>2]|0)+8>>2];if(c[l>>2]|0){oF(c[h>>2]|0,121767,e);oF(c[h>>2]|0,121776,e+8|0);oF(c[h>>2]|0,121803,e+16|0);oF(c[h>>2]|0,121828,e+24|0);oF(c[h>>2]|0,121857,e+32|0);oF(c[h>>2]|0,121885,e+40|0);l=c[h>>2]|0;c[g>>2]=c[(c[j>>2]|0)+8>>2];oF(l,121892,g);oF(c[h>>2]|0,121931,e+56|0);oF(c[h>>2]|0,148626,e+64|0);i=e;return}else La(176617,121592,130,121747)}function pf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;g=i;i=i+224|0;j=g+88|0;k=g+8|0;l=g+212|0;m=g+208|0;n=g+204|0;o=g+200|0;p=g+196|0;q=g+192|0;r=g+188|0;s=g+184|0;t=g+180|0;u=g+176|0;v=g+172|0;w=g;x=g+168|0;y=g+164|0;z=g+160|0;A=g+156|0;B=g+152|0;C=g+148|0;D=g+144|0;E=g+128|0;c[l>>2]=b;c[m>>2]=d;a[g+216>>0]=f;c[n>>2]=2;c[o>>2]=5;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=-1;c[t>>2]=1;c[u>>2]=-1;c[v>>2]=0;h[w>>3]=0.0;c[x>>2]=0;c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;c[B>>2]=0;c[C>>2]=5;c[D>>2]=0;if(!(c[l>>2]|0))La(148844,121592,99,121936);if(!(c[m>>2]|0))La(148874,121592,100,121936);if(c[(c[m>>2]|0)+8>>2]|0){F=+h[e>>3];c[E>>2]=~~(+h[e>>3]>=0.0?F+.5:F-.5);F=+h[e+8>>3];c[E+4>>2]=~~(+h[e+8>>3]>=0.0?F+.5:F-.5);F=+h[e+16>>3];c[E+8>>2]=~~(+h[e+16>>3]>=0.0?F+.5:F-.5);F=+h[e+16+8>>3];c[E+8+4>>2]=~~(+h[e+16+8>>3]>=0.0?F+.5:F-.5);e=c[l>>2]|0;f=c[o>>2]|0;o=c[p>>2]|0;p=c[q>>2]|0;q=c[r>>2]|0;r=c[s>>2]|0;s=c[t>>2]|0;t=c[u>>2]|0;u=c[v>>2]|0;F=+h[w>>3];w=c[x>>2]|0;x=c[y>>2]|0;y=c[z>>2]|0;z=c[A>>2]|0;A=c[B>>2]|0;B=c[C>>2]|0;C=c[D>>2]|0;D=c[(c[m>>2]|0)+8>>2]|0;c[k>>2]=c[n>>2];c[k+4>>2]=f;c[k+8>>2]=o;c[k+12>>2]=p;c[k+16>>2]=q;c[k+20>>2]=r;c[k+24>>2]=s;c[k+28>>2]=t;c[k+32>>2]=u;h[k+40>>3]=F;c[k+48>>2]=w;c[k+52>>2]=x;c[k+56>>2]=y;c[k+60>>2]=z;c[k+64>>2]=A;c[k+68>>2]=B;c[k+72>>2]=C;c[k+76>>2]=D;oF(e,121955,k);k=c[l>>2]|0;l=c[E+4>>2]|0;e=c[E>>2]|0;D=c[E+8+4>>2]|0;C=c[E+8>>2]|0;B=c[E+8+4>>2]|0;A=c[E+8>>2]|0;z=c[E+4>>2]|0;y=c[E>>2]|0;x=c[E+4>>2]|0;c[j>>2]=c[E>>2];c[j+4>>2]=l;c[j+8>>2]=e;c[j+12>>2]=D;c[j+16>>2]=C;c[j+20>>2]=B;c[j+24>>2]=A;c[j+28>>2]=z;c[j+32>>2]=y;c[j+36>>2]=x;oF(k,122013,j);i=g;return}else La(148877,121592,101,121936)}function qf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0;g=i;i=i+144|0;j=g+88|0;k=g+64|0;l=g+32|0;m=g+124|0;n=g+120|0;o=g+24|0;p=g+16|0;q=g+8|0;r=g;c[m>>2]=b;c[n>>2]=d;a[g+128>>0]=f;h[o>>3]=+h[e+16>>3]-+h[e>>3];h[p>>3]=+h[e+16+8>>3]-+h[e+8>>3];h[q>>3]=(+h[e+16>>3]+ +h[e>>3]-+h[o>>3])/2.0;h[r>>3]=(+h[e+16+8>>3]+ +h[e+8>>3]+ +h[p>>3])/2.0;if(!(c[m>>2]|0))La(148844,121592,55,122045);if(!(c[n>>2]|0))La(148874,121592,56,122045);if(!(c[(c[n>>2]|0)+8>>2]|0))La(148877,121592,57,122045);jF(c[m>>2]|0,122064)|0;jF(c[m>>2]|0,c[(c[n>>2]|0)+8>>2]|0)|0;n=c[m>>2]|0;if(c[(c[m>>2]|0)+360>>2]|0){s=+h[o>>3];t=+h[q>>3];u=-+h[r>>3];h[l>>3]=+h[p>>3];h[l+8>>3]=s;h[l+16>>3]=t;h[l+24>>3]=u;oF(n,122084,l);l=c[m>>2]|0;u=+h[q>>3];t=-+h[r>>3];c[k>>2]=c[(c[m>>2]|0)+360>>2];h[k+8>>3]=u;h[k+16>>3]=t;oF(l,122163,k);v=c[m>>2]|0;jF(v,122272)|0;i=g;return}else{t=+h[p>>3];u=+h[q>>3];s=-+h[r>>3];h[j>>3]=+h[o>>3];h[j+8>>3]=t;h[j+16>>3]=u;h[j+24>>3]=s;oF(n,122193,j);v=c[m>>2]|0;jF(v,122272)|0;i=g;return}}function rf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;vf(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;wf(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function sf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;xf(c[(c[(c[d>>2]|0)+8>>2]|0)+192>>2]|0);c[e>>2]=$B(c[d>>2]|0)|0;while(1){g=c[d>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=OA(g,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;TO(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}yf(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}zf(g);i=b;return}function tf(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(kB(c[d>>2]|0)|0)Af(c[d>>2]|0);nL(c[d>>2]|0);i=b;return}function uf(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[(c[(rC(c[d>>2]|0)|0)+8>>2]|0)+188>>2]|0;i=b;return a|0}function vf(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;MC(c[d>>2]|0,175026,304,1)|0;xO(c[d>>2]|0);a=c[d>>2]|0;VO(a,c[(c[(qC(c[d>>2]|0)|0)+8>>2]|0)+116>>2]&1);c[(c[(c[d>>2]|0)+8>>2]|0)+172+4>>2]=0;a=bK(20)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]=a;c[(c[(c[d>>2]|0)+8>>2]|0)+180+4>>2]=0;a=bK(20)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]=a;c[(c[(c[d>>2]|0)+8>>2]|0)+196+4>>2]=0;a=bK(12)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+196>>2]=a;c[(c[(c[d>>2]|0)+8>>2]|0)+188+4>>2]=0;a=bK(12)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+188>>2]=a;c[(c[(c[d>>2]|0)+8>>2]|0)+204+4>>2]=0;a=bK(12)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+204>>2]=a;c[(c[(c[d>>2]|0)+8>>2]|0)+216>>2]=1;i=b;return}function wf(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=d;MC(c[f>>2]|0,175319,176,1)|0;yO(c[f>>2]|0)|0;d=eO(c[f>>2]|0,c[13851]|0,1,0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+156>>2]=d;d=c[f>>2]|0;c[g>>2]=hO(c[((c[c[f>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0,c[13845]|0,178518)|0;d=c[f>>2]|0;c[h>>2]=hO(c[((c[c[f>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0,c[13845]|0,178518)|0;b[(c[(c[f>>2]|0)+8>>2]|0)+154>>1]=1;b[(c[(c[f>>2]|0)+8>>2]|0)+168>>1]=1;if((a[c[g>>2]>>0]|0)!=0?(c[g>>2]|0)==(c[h>>2]|0):0){b[(c[(c[f>>2]|0)+8>>2]|0)+154>>1]=1e3;h=(c[(c[f>>2]|0)+8>>2]|0)+156|0;c[h>>2]=(c[h>>2]|0)*100}if(!(hk(c[f>>2]|0)|0)){j=c[f>>2]|0;k=c[13871]|0;l=eO(j,k,0,0)|0;m=l&255;n=c[f>>2]|0;o=n+8|0;p=c[o>>2]|0;q=p+152|0;a[q>>0]=m;r=c[f>>2]|0;s=c[13852]|0;t=eO(r,s,1,0)|0;u=t&65535;v=c[f>>2]|0;w=v+8|0;x=c[w>>2]|0;y=x+170|0;b[y>>1]=u;i=e;return}b[(c[(c[f>>2]|0)+8>>2]|0)+154>>1]=0;c[(c[(c[f>>2]|0)+8>>2]|0)+156>>2]=0;j=c[f>>2]|0;k=c[13871]|0;l=eO(j,k,0,0)|0;m=l&255;n=c[f>>2]|0;o=n+8|0;p=c[o>>2]|0;q=p+152|0;a[q>>0]=m;r=c[f>>2]|0;s=c[13852]|0;t=eO(r,s,1,0)|0;u=t&65535;v=c[f>>2]|0;w=v+8|0;x=c[w>>2]|0;y=x+170|0;b[y>>1]=u;i=e;return}function xf(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2];Jf(c[e>>2]|0);if((a[(c[(c[e>>2]|0)+8>>2]|0)+156>>0]|0)==1){if(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0);if(c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]|0);O4(c[(c[e>>2]|0)+8>>2]|0);O4(c[e>>2]|0)}c[e>>2]=c[f>>2]}i=d;return}function yf(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]|0)O4(c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]|0);if(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0)O4(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0);if(c[(c[(c[d>>2]|0)+8>>2]|0)+188>>2]|0)O4(c[(c[(c[d>>2]|0)+8>>2]|0)+188>>2]|0);if(c[(c[(c[d>>2]|0)+8>>2]|0)+196>>2]|0)O4(c[(c[(c[d>>2]|0)+8>>2]|0)+196>>2]|0);if(c[(c[(c[d>>2]|0)+8>>2]|0)+204>>2]|0)O4(c[(c[(c[d>>2]|0)+8>>2]|0)+204>>2]|0);UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+104>>2]|0);UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+108>>2]|0);if(!(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)){e=c[d>>2]|0;NC(e,175026)|0;i=b;return}Bb[c[(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+4>>2]&127](c[d>>2]|0);e=c[d>>2]|0;NC(e,175026)|0;i=b;return}function zf(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[g>>2]=GD(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;zf(c[g>>2]|0);c[g>>2]=HD(c[g>>2]|0)|0}if(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0);if(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0);if(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0);do if(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0){c[f>>2]=b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[f>>2]|0)>(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0))break;O4(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+12>>2]|0);c[f>>2]=(c[f>>2]|0)+1}g=c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0;if((b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]|0)==-1){O4(g+-64|0);break}else{O4(g);break}}while(0);f=c[e>>2]|0;if((f|0)==(rC(c[e>>2]|0)|0)){i=d;return}NC(c[e>>2]|0,175049)|0;i=d;return}function Af(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+64|0;d=b+56|0;e=b+52|0;f=b+48|0;g=b+44|0;h=b+40|0;j=b+8|0;k=b+4|0;l=b;c[d>>2]=a;c[k>>2]=JG(c[d>>2]|0,-1,8)|0;c[l>>2]=IG(c[d>>2]|0,0,j)|0;GG(c[d>>2]|0,2,8,j)|0;if((c[l>>2]|0)==0&(c[k>>2]|0)<0){Bf(c[d>>2]|0);i=b;return}if(c[l>>2]|0){if((c[k>>2]|0)<0)c[k>>2]=8}else c[j+16>>2]=2;c[j+8>>2]=c[k>>2];c[j+20>>2]=0;c[e>>2]=hG(c[d>>2]|0,g,0)|0;k=c[d>>2]|0;do if((c[g>>2]|0)==1)Bf(k);else{if(c[(c[(c[k+8>>2]|0)+8>>2]|0)+84>>2]|0){Bf(c[d>>2]|0);break}c[j+12>>2]=1;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[g>>2]|0))break;c[f>>2]=c[(c[e>>2]|0)+(c[h>>2]<<2)>>2];Cf(c[f>>2]|0,c[d>>2]|0);Bf(c[f>>2]|0);c[h>>2]=(c[h>>2]|0)+1}Df(c[d>>2]|0);FG(c[g>>2]|0,c[e>>2]|0,c[d>>2]|0,j)|0;Ef(c[d>>2]|0)}while(0);c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[g>>2]|0))break;O4(c[(c[(c[(c[e>>2]|0)+(c[h>>2]<<2)>>2]|0)+8>>2]|0)+8>>2]|0);pC(c[d>>2]|0,c[(c[e>>2]|0)+(c[h>>2]<<2)>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+1}O4(c[e>>2]|0);i=b;return}function Bf(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+64|0;d=b+40|0;f=b+52|0;g=b;h=b+48|0;j=b+44|0;c[f>>2]=a;a=c[f>>2]|0;c[j>>2]=eO(a,qA(c[f>>2]|0,0,122287,0)|0,-1,1)|0;QO(c[f>>2]|0,10);c[h>>2]=Yj(c[f>>2]|0,g)|0;Ff(c[f>>2]|0,c[f>>2]|0);rf(c[f>>2]|0);while(1){Ui(c[f>>2]|0,c[h>>2]|0);if((c[j>>2]|0)==1){k=3;break}if(c[g+32>>2]|0){$z(0,122293,d)|0;c[h>>2]=0;c[g+24>>2]=0}bh(c[f>>2]|0,(c[h>>2]|0)!=0&1);l=c[f>>2]|0;if((c[j>>2]|0)==2){k=7;break}fi(l,c[h>>2]|0);if((c[j>>2]|0)==3){k=9;break}a=g+28|0;c[a>>2]=(c[a>>2]|0)+-1;if(!(c[g+24>>2]|0)){k=12;break}if(!(c[g+28>>2]|0)){k=12;break}}if((k|0)==3){Gf(c[f>>2]|0,1);i=b;return}else if((k|0)==7){Gf(l,2);i=b;return}else if((k|0)==9){Gf(c[f>>2]|0,2);i=b;return}else if((k|0)==12){if((e[(c[(c[f>>2]|0)+8>>2]|0)+136>>1]|0)&16)Hf(c[f>>2]|0);Oj(c[f>>2]|0);Lf(c[f>>2]|0);if(!((kO(yA(c[f>>2]|0,122384)|0)|0)<<24>>24)){i=b;return}Ik(c[f>>2]|0);i=b;return}}function Cf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;MC(c[f>>2]|0,175049,280,1)|0;d=bK(96)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]=d;h[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>3]=+h[c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]>>3];h[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3]=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3];c[(c[(c[f>>2]|0)+8>>2]|0)+144>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+144>>2];a[(c[(c[f>>2]|0)+8>>2]|0)+115>>0]=a[(c[(c[g>>2]|0)+8>>2]|0)+115>>0]|0;c[(c[(c[f>>2]|0)+8>>2]|0)+116>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+248>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+248>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+252>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+252>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+244>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+244>>2];i=e;return}function Df(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=bK((kB(c[d>>2]|0)|0)<<1<<3)|0;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]=c[f>>2];h[c[f>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]/72.0;h[(c[f>>2]|0)+8>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16+8>>3]/72.0;c[f>>2]=(c[f>>2]|0)+16;c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function Ef(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;c[f>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2];c[g>>2]=c[f>>2];c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]=0;h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]=+h[c[g>>2]>>3]*72.0;h[(c[(c[e>>2]|0)+8>>2]|0)+16+8>>3]=+h[(c[g>>2]|0)+8>>3]*72.0;c[g>>2]=(c[g>>2]|0)+16;c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}O4(c[f>>2]|0);i=b;return}function Ff(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;b=c[e>>2]|0;if((b|0)!=(rC(c[e>>2]|0)|0))MC(c[e>>2]|0,175049,280,1)|0;if((c[e>>2]|0)==(c[f>>2]|0)){b=c[f>>2]|0;c[(c[(rC(c[e>>2]|0)|0)+8>>2]|0)+188>>2]=b}c[g>>2]=GD(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;Ff(c[g>>2]|0,c[f>>2]|0);c[g>>2]=HD(c[g>>2]|0)|0}i=d;return}function Gf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+1056|0;e=d+8|0;f=d;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+32|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=qA(c[g>>2]|0,1,124202,178518)|0;c[k>>2]=qA(c[g>>2]|0,1,122427,178518)|0;c[l>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;if((c[h>>2]|0)>=1){c[f>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2];k3(m,175023,f)|0;BA(c[l>>2]|0,c[j>>2]|0,m)|0}if((c[h>>2]|0)>=2){c[e>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+236>>2];k3(m,175023,e)|0;BA(c[l>>2]|0,c[k>>2]|0,m)|0}c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}i=d;return}function Hf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[g>>2]=FD(c[d>>2]|0,123706,0)|0;if(!(c[g>>2]|0)){i=b;return}c[e>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=aC(c[g>>2]|0,c[e>>2]|0)|0;Rg(c[d>>2]|0,c[e>>2]|0);If(c[d>>2]|0,c[e>>2]|0);yf(c[e>>2]|0);hC(c[d>>2]|0,c[e>>2]|0)|0;c[e>>2]=c[f>>2]}JD(c[d>>2]|0,c[g>>2]|0)|0;i=b;return}function If(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;c[g>>2]=c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2];b=(c[g>>2]|0)==(c[f>>2]|0);c[h>>2]=(c[h>>2]|0)+1;if(b){k=4;break}}if((k|0)==4){while(1){k=0;if((c[h>>2]|0)>=(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+((c[h>>2]|0)-1<<2)>>2]=c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2];c[h>>2]=(c[h>>2]|0)+1;k=4}k=(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)|0;c[k>>2]=(c[k>>2]|0)+-1}if((c[g>>2]|0)==(c[f>>2]|0)){i=d;return}else La(122393,122400,243,122410)}function Jf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=(c[(c[(c[d>>2]|0)+8>>2]|0)+172+4>>2]|0)-1;while(1){if((c[f>>2]|0)<0)break;c[e>>2]=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]|0)+(c[f>>2]<<2)>>2];Kg(c[e>>2]|0);O4(c[(c[e>>2]|0)+8>>2]|0);O4(c[e>>2]|0);c[f>>2]=(c[f>>2]|0)+-1}c[f>>2]=(c[(c[(c[d>>2]|0)+8>>2]|0)+180+4>>2]|0)-1;while(1){if((c[f>>2]|0)<0)break;c[e>>2]=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0)+(c[f>>2]<<2)>>2];Kg(c[e>>2]|0);O4(c[(c[e>>2]|0)+8>>2]|0);O4(c[e>>2]|0);c[f>>2]=(c[f>>2]|0)+-1}i=b;return}function Kf(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+16|0;f=e+4|0;g=e;j=d[a+28>>0]|0;if(!(d[b+28>>0]|0)){c[f>>2]=(j|0)!=0?1:0;k=c[f>>2]|0;i=e;return k|0}if(!j){c[f>>2]=-1;k=c[f>>2]|0;i=e;return k|0}c[g>>2]=~~(+h[a>>3]-+h[b>>3]);if(!(c[g>>2]|0))c[g>>2]=~~(+h[a+8>>3]-+h[b+8>>3]);c[f>>2]=c[g>>2];k=c[f>>2]|0;i=e;return k|0}function Lf(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Mf(c[d>>2]|0,1);i=b;return}function Mf(f,g){f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;j=i;i=i+736|0;k=j+408|0;l=j+368|0;m=j+360|0;n=j+716|0;o=j+712|0;p=j+708|0;q=j+704|0;r=j+700|0;s=j+696|0;t=j+692|0;u=j+688|0;v=j+684|0;w=j+680|0;x=j+616|0;y=j+552|0;z=j+544|0;A=j+540|0;B=j+536|0;C=j+532|0;D=j+528|0;E=j+524|0;F=j+520|0;G=j+516|0;H=j+512|0;I=j+492|0;J=j+488|0;K=j+484|0;L=j;M=j+720|0;N=j+480|0;O=j+476|0;P=j+472|0;Q=j+468|0;R=j+464|0;S=j+460|0;T=j+456|0;U=j+452|0;V=j+448|0;c[n>>2]=f;c[o>>2]=g;c[J>>2]=e[(c[(c[n>>2]|0)+8>>2]|0)+136>>1]&14;c[x+8>>2]=j+184;c[y+8>>2]=j+8;if(!(c[J>>2]|0)){i=j;return}a:do if((c[J>>2]|0)!=4){g=c[n>>2]|0;if((c[J>>2]|0)==8){Nf(g);f=c[n>>2]|0;if(d[(c[(c[n>>2]|0)+8>>2]|0)+113>>0]&1){Of(f);yP(c[n>>2]|0,1);break}else{yP(f,0);break}}zk(g);if(PL()|0){i=j;return}c[H>>2]=bK(96)|0;c[I+8>>2]=(c[(c[(c[n>>2]|0)+8>>2]|0)+248>>2]|0)/4|0;c[I+12>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+248>>2];c[G>>2]=bK(512)|0;c[I+4>>2]=0;c[I>>2]=0;c[s>>2]=0;c[t>>2]=0;c[p>>2]=b[(c[(c[n>>2]|0)+8>>2]|0)+236>>1];b:while(1){if((c[p>>2]|0)>(b[(c[(c[n>>2]|0)+8>>2]|0)+238>>1]|0))break;c[s>>2]=(c[s>>2]|0)+(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[p>>2]<<6)>>2]|0);g=c[c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[p>>2]<<6)+4>>2]>>2]|0;c[w>>2]=g;if(g){if(+(c[I>>2]|0)<+h[(c[(c[w>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[w>>2]|0)+8>>2]|0)+88>>3])W=+(c[I>>2]|0);else W=+h[(c[(c[w>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[w>>2]|0)+8>>2]|0)+88>>3];c[I>>2]=~~W}if((c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[p>>2]<<6)>>2]|0)!=0?(g=c[(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[p>>2]<<6)+4>>2]|0)+((c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[p>>2]<<6)>>2]|0)-1<<2)>>2]|0,c[w>>2]=g,(g|0)!=0):0){if(+(c[I+4>>2]|0)>+h[(c[(c[w>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[w>>2]|0)+8>>2]|0)+96>>3])X=+(c[I+4>>2]|0);else X=+h[(c[(c[w>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[w>>2]|0)+8>>2]|0)+96>>3];c[I+4>>2]=~~X}c[I>>2]=(c[I>>2]|0)-16;g=I+4|0;c[g>>2]=(c[g>>2]|0)+16;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[p>>2]<<6)>>2]|0))break;c[w>>2]=c[(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[p>>2]<<6)+4>>2]|0)+(c[q>>2]<<2)>>2];if(c[(c[(c[w>>2]|0)+8>>2]|0)+112>>2]|0){c[K>>2]=c[(c[(c[w>>2]|0)+8>>2]|0)+112>>2];if(!(c[(c[(c[K>>2]|0)+8>>2]|0)+96>>2]|0)){Y=33;break b}g=(c[(c[(c[K>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;f=(c[(c[w>>2]|0)+8>>2]|0)+16|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];a[(c[(c[(c[K>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1}if(!((a[(c[(c[w>>2]|0)+8>>2]|0)+156>>0]|0)!=0?((Fb[c[50164>>2]&63](c[w>>2]|0)|0)&255|0)==0:0))Y=37;c:do if((Y|0)==37){Y=0;c[r>>2]=0;while(1){f=c[(c[(c[(c[w>>2]|0)+8>>2]|0)+180>>2]|0)+(c[r>>2]<<2)>>2]|0;c[z>>2]=f;if(!f)break;if(((a[(c[(c[z>>2]|0)+8>>2]|0)+112>>0]|0)!=4?(a[(c[(c[z>>2]|0)+8>>2]|0)+112>>0]|0)!=6:0)?(Pf(c[z>>2]|0,1,16,64),f=c[z>>2]|0,g=c[t>>2]|0,c[t>>2]=g+1,c[(c[G>>2]|0)+(g<<2)>>2]=f,((c[t>>2]|0)%128|0|0)==0):0){if(c[G>>2]|0)Z=eK(c[G>>2]|0,(c[t>>2]|0)+128<<2)|0;else Z=cK((c[t>>2]|0)+128<<2)|0;c[G>>2]=Z}c[r>>2]=(c[r>>2]|0)+1}d:do if(c[(c[(c[w>>2]|0)+8>>2]|0)+188>>2]|0){c[r>>2]=0;while(1){f=c[(c[(c[(c[w>>2]|0)+8>>2]|0)+188>>2]|0)+(c[r>>2]<<2)>>2]|0;c[z>>2]=f;if(!f)break d;Pf(c[z>>2]|0,2,0,128);f=c[z>>2]|0;g=c[t>>2]|0;c[t>>2]=g+1;c[(c[G>>2]|0)+(g<<2)>>2]=f;if(!((c[t>>2]|0)%128|0)){if(c[G>>2]|0)_=eK(c[G>>2]|0,(c[t>>2]|0)+128<<2)|0;else _=cK((c[t>>2]|0)+128<<2)|0;c[G>>2]=_}c[r>>2]=(c[r>>2]|0)+1}}while(0);if(c[(c[(c[w>>2]|0)+8>>2]|0)+204>>2]|0){if(!(a[(c[(c[w>>2]|0)+8>>2]|0)+156>>0]|0)){h[L>>3]=+h[(c[(c[w>>2]|0)+8>>2]|0)+96>>3];h[(c[(c[w>>2]|0)+8>>2]|0)+96>>3]=+h[(c[(c[w>>2]|0)+8>>2]|0)+240>>3];h[(c[(c[w>>2]|0)+8>>2]|0)+240>>3]=+h[L>>3]}c[r>>2]=0;while(1){f=c[(c[(c[(c[w>>2]|0)+8>>2]|0)+204>>2]|0)+(c[r>>2]<<2)>>2]|0;c[z>>2]=f;if(!f)break c;Pf(c[z>>2]|0,0,0,128);f=c[z>>2]|0;g=c[t>>2]|0;c[t>>2]=g+1;c[(c[G>>2]|0)+(g<<2)>>2]=f;if(!((c[t>>2]|0)%128|0)){if(c[G>>2]|0)$=eK(c[G>>2]|0,(c[t>>2]|0)+128<<2)|0;else $=cK((c[t>>2]|0)+128<<2)|0;c[G>>2]=$}c[r>>2]=(c[r>>2]|0)+1}}}while(0);c[q>>2]=(c[q>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}if((Y|0)==33)La(122501,122514,319,122527);w3(c[G>>2]|0,c[t>>2]|0,4,58);f=bK((c[s>>2]|0)+360<<5)|0;c[(c[H>>2]|0)+84>>2]=f;c[I+16>>2]=bK(c[p>>2]<<5)|0;e:do if((c[J>>2]|0)==2){c[w>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[w>>2]|0))break e;if((a[(c[(c[w>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[w>>2]|0)+8>>2]|0)+104>>2]|0)!=0:0)Rf(c[w>>2]|0);c[w>>2]=c[(c[(c[w>>2]|0)+8>>2]|0)+164>>2]}}while(0);c[p>>2]=0;f:while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break;c[u>>2]=c[p>>2];f=c[p>>2]|0;c[p>>2]=f+1;g=c[(c[G>>2]|0)+(f<<2)>>2]|0;c[A>>2]=g;c[E>>2]=Sf(g)|0;if((d[(c[(c[A>>2]|0)+8>>2]|0)+16+28>>0]|0)==0?(d[(c[(c[A>>2]|0)+8>>2]|0)+56+28>>0]|0)==0:0){a[M>>0]=0;c[C>>2]=c[E>>2]}else{a[M>>0]=1;c[C>>2]=c[A>>2]}if(c[(c[(c[C>>2]|0)+8>>2]|0)+164>>2]&32){c[N>>2]=x;c[O>>2]=c[(c[N>>2]|0)+8>>2];Z4(c[O>>2]|0,c[(c[C>>2]|0)+8>>2]|0,176)|0;g=c[N>>2]|0;f=c[C>>2]|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];c[g+16>>2]=c[f+16>>2];c[g+20>>2]=c[f+20>>2];c[g+24>>2]=c[f+24>>2];c[g+28>>2]=c[f+28>>2];c[(c[N>>2]|0)+8>>2]=c[O>>2];f=c[C>>2]|0;g=c[N>>2]|0;c[((c[c[N>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2];f=c[C>>2]|0;g=c[N>>2]|0;c[((c[c[N>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==3?f:f+32|0)+28>>2];aa=(c[(c[N>>2]|0)+8>>2]|0)+16|0;ba=(c[(c[C>>2]|0)+8>>2]|0)+56|0;ca=aa+40|0;do{c[aa>>2]=c[ba>>2];aa=aa+4|0;ba=ba+4|0}while((aa|0)<(ca|0));aa=(c[(c[N>>2]|0)+8>>2]|0)+56|0;ba=(c[(c[C>>2]|0)+8>>2]|0)+16|0;ca=aa+40|0;do{c[aa>>2]=c[ba>>2];aa=aa+4|0;ba=ba+4|0}while((aa|0)<(ca|0));a[(c[(c[N>>2]|0)+8>>2]|0)+112>>0]=1;c[(c[(c[N>>2]|0)+8>>2]|0)+116>>2]=c[C>>2];c[C>>2]=x}c[v>>2]=1;while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break;f=c[E>>2]|0;g=c[(c[G>>2]|0)+(c[p>>2]<<2)>>2]|0;c[B>>2]=g;da=Sf(g)|0;c[F>>2]=da;if((f|0)!=(da|0))break;if(!(a[(c[(c[A>>2]|0)+8>>2]|0)+113>>0]|0)){if((d[(c[(c[B>>2]|0)+8>>2]|0)+16+28>>0]|0)==0?(d[(c[(c[B>>2]|0)+8>>2]|0)+56+28>>0]|0)==0:0){if(a[M>>0]|0)break;c[D>>2]=c[F>>2]}else{if(!(a[M>>0]|0))break;c[D>>2]=c[B>>2]}if(c[(c[(c[D>>2]|0)+8>>2]|0)+164>>2]&32){c[P>>2]=y;c[Q>>2]=c[(c[P>>2]|0)+8>>2];Z4(c[Q>>2]|0,c[(c[D>>2]|0)+8>>2]|0,176)|0;da=c[P>>2]|0;f=c[D>>2]|0;c[da>>2]=c[f>>2];c[da+4>>2]=c[f+4>>2];c[da+8>>2]=c[f+8>>2];c[da+12>>2]=c[f+12>>2];c[da+16>>2]=c[f+16>>2];c[da+20>>2]=c[f+20>>2];c[da+24>>2]=c[f+24>>2];c[da+28>>2]=c[f+28>>2];c[(c[P>>2]|0)+8>>2]=c[Q>>2];f=c[D>>2]|0;da=c[P>>2]|0;c[((c[c[P>>2]>>2]&3|0)==3?da:da+32|0)+28>>2]=c[((c[c[D>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2];f=c[D>>2]|0;da=c[P>>2]|0;c[((c[c[P>>2]>>2]&3|0)==2?da:da+-32|0)+28>>2]=c[((c[c[D>>2]>>2]&3|0)==3?f:f+32|0)+28>>2];aa=(c[(c[P>>2]|0)+8>>2]|0)+16|0;ba=(c[(c[D>>2]|0)+8>>2]|0)+56|0;ca=aa+40|0;do{c[aa>>2]=c[ba>>2];aa=aa+4|0;ba=ba+4|0}while((aa|0)<(ca|0));aa=(c[(c[P>>2]|0)+8>>2]|0)+56|0;ba=(c[(c[D>>2]|0)+8>>2]|0)+16|0;ca=aa+40|0;do{c[aa>>2]=c[ba>>2];aa=aa+4|0;ba=ba+4|0}while((aa|0)<(ca|0));a[(c[(c[P>>2]|0)+8>>2]|0)+112>>0]=1;c[(c[(c[P>>2]|0)+8>>2]|0)+116>>2]=c[D>>2];c[D>>2]=y}f=(c[(c[D>>2]|0)+8>>2]|0)+16|0;aa=l;ba=(c[(c[C>>2]|0)+8>>2]|0)+16|0;ca=aa+40|0;do{c[aa>>2]=c[ba>>2];aa=aa+4|0;ba=ba+4|0}while((aa|0)<(ca|0));aa=k;ba=f;ca=aa+40|0;do{c[aa>>2]=c[ba>>2];aa=aa+4|0;ba=ba+4|0}while((aa|0)<(ca|0));if(Kf(l,k)|0)break;f=(c[(c[D>>2]|0)+8>>2]|0)+56|0;aa=l;ba=(c[(c[C>>2]|0)+8>>2]|0)+56|0;ca=aa+40|0;do{c[aa>>2]=c[ba>>2];aa=aa+4|0;ba=ba+4|0}while((aa|0)<(ca|0));aa=k;ba=f;ca=aa+40|0;do{c[aa>>2]=c[ba>>2];aa=aa+4|0;ba=ba+4|0}while((aa|0)<(ca|0));if(Kf(l,k)|0)break;if((c[(c[(c[A>>2]|0)+8>>2]|0)+164>>2]&15|0)==2?(c[(c[(c[A>>2]|0)+8>>2]|0)+96>>2]|0)!=(c[(c[(c[B>>2]|0)+8>>2]|0)+96>>2]|0):0)break;if(c[(c[(c[(c[G>>2]|0)+(c[p>>2]<<2)>>2]|0)+8>>2]|0)+164>>2]&64)break}c[v>>2]=(c[v>>2]|0)+1;c[p>>2]=(c[p>>2]|0)+1}f=c[A>>2]|0;da=c[A>>2]|0;g=c[A>>2]|0;ea=c[((c[c[A>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0;if((c[((c[c[A>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)!=(c[((c[c[A>>2]>>2]&3|0)==2?da:da+-32|0)+28>>2]|0)){da=c[A>>2]|0;f=c[n>>2]|0;g=c[H>>2]|0;fa=c[G>>2]|0;ga=c[u>>2]|0;ha=c[v>>2]|0;ia=c[J>>2]|0;if((c[(c[ea+8>>2]|0)+232>>2]|0)==(c[(c[(c[((c[c[A>>2]>>2]&3|0)==2?da:da+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){Tf(f,I,g,fa,ga,ha,ia);continue}else{Uf(f,I,g,fa,ga,ha,ia);continue}}c[w>>2]=ea;c[T>>2]=c[(c[(c[w>>2]|0)+8>>2]|0)+232>>2];ea=c[T>>2]|0;do if((c[T>>2]|0)==(b[(c[(c[n>>2]|0)+8>>2]|0)+238>>1]|0))if((ea|0)>0){c[S>>2]=~~(+h[(c[(c[c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+((c[T>>2]|0)-1<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]);break}else{c[S>>2]=~~+h[(c[(c[w>>2]|0)+8>>2]|0)+80>>3];break}else if((ea|0)==(b[(c[(c[n>>2]|0)+8>>2]|0)+236>>1]|0)){c[S>>2]=~~(+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+((c[T>>2]|0)+1<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]);break}else{c[U>>2]=~~(+h[(c[(c[c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+((c[T>>2]|0)-1<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]);c[V>>2]=~~(+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+((c[T>>2]|0)+1<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]);c[S>>2]=(c[U>>2]|0)<(c[V>>2]|0)?c[U>>2]|0:c[V>>2]|0;break}while(0);oN(c[H>>2]|0,c[G>>2]|0,c[u>>2]|0,c[v>>2]|0,+(c[I+12>>2]|0),+((c[S>>2]|0)/2|0|0),50160);c[R>>2]=0;while(1){if((c[R>>2]|0)>=(c[v>>2]|0))continue f;c[z>>2]=c[(c[G>>2]|0)+((c[u>>2]|0)+(c[R>>2]|0)<<2)>>2];if(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)AO(c[n>>2]|0,c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0);c[R>>2]=(c[R>>2]|0)+1}}c[w>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[w>>2]|0))break;if((a[(c[(c[w>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[w>>2]|0)+8>>2]|0)+104>>2]|0)!=0:0){Rf(c[w>>2]|0);AO(c[n>>2]|0,c[(c[(c[w>>2]|0)+8>>2]|0)+104>>2]|0)}c[w>>2]=c[(c[(c[w>>2]|0)+8>>2]|0)+164>>2]}if(c[o>>2]|0)Vf(c[n>>2]|0)}else{Nf(c[n>>2]|0);if(d[(c[(c[n>>2]|0)+8>>2]|0)+113>>0]&1)$z(0,122433,m)|0;c[w>>2]=$B(c[n>>2]|0)|0;while(1){if(!(c[w>>2]|0))break a;c[z>>2]=OA(c[n>>2]|0,c[w>>2]|0)|0;while(1){ja=c[n>>2]|0;if(!(c[z>>2]|0))break;TL(ja,c[z>>2]|0,c[J>>2]|0,50160);c[z>>2]=QA(c[n>>2]|0,c[z>>2]|0)|0}c[w>>2]=aC(ja,c[w>>2]|0)|0}}while(0);g:do if((c[13881]|0)!=0|(c[13882]|0)!=0?(c[13887]|0)!=0|(c[13886]|0)!=0:0){c[w>>2]=$B(c[n>>2]|0)|0;while(1){if(!(c[w>>2]|0))break g;h:do if(c[13881]|0){c[z>>2]=RA(c[n>>2]|0,c[w>>2]|0)|0;while(1){if(!(c[z>>2]|0))break h;ja=c[z>>2]|0;if(c[(c[((c[c[z>>2]>>2]&3|0)==2?ja:ja+-32|0)+8>>2]|0)+100>>2]|0){ja=c[z>>2]|0;qN((c[c[z>>2]>>2]&3|0)==2?ja:ja+-32|0,1)|0;ja=c[z>>2]|0;AO(c[n>>2]|0,c[(c[((c[c[z>>2]>>2]&3|0)==2?ja:ja+-32|0)+8>>2]|0)+100>>2]|0)}c[z>>2]=SA(c[n>>2]|0,c[z>>2]|0)|0}}while(0);i:do if(c[13882]|0){c[z>>2]=OA(c[n>>2]|0,c[w>>2]|0)|0;while(1){if(!(c[z>>2]|0))break i;if((c[(c[(c[z>>2]|0)+8>>2]|0)+104>>2]|0)!=0?(qN(c[z>>2]|0,0)|0)!=0:0)AO(c[n>>2]|0,c[(c[(c[z>>2]|0)+8>>2]|0)+104>>2]|0);c[z>>2]=QA(c[n>>2]|0,c[z>>2]|0)|0}}while(0);c[w>>2]=aC(c[n>>2]|0,c[w>>2]|0)|0}}while(0);if((c[J>>2]|0)!=8&(c[J>>2]|0)!=4){O4(c[G>>2]|0);O4(c[(c[H>>2]|0)+84>>2]|0);O4(c[H>>2]|0);O4(c[I+16>>2]|0);QL()}c[13800]=1;c[13801]=1;i=j;return}function Nf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;if(c[(c[(c[e>>2]|0)+8>>2]|0)+204>>2]|0){h[f>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+96>>3];h[(c[(c[e>>2]|0)+8>>2]|0)+96>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+240>>3];h[(c[(c[e>>2]|0)+8>>2]|0)+240>>3]=+h[f>>3]}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function Of(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=b;c[f>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[f>>2]|0)){j=13;break}if((a[(c[(c[f>>2]|0)+8>>2]|0)+156>>0]|0)==1){b=c[(c[f>>2]|0)+8>>2]|0;if(!(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)){k=c[b+104>>2]|0;c[g>>2]=k;if(k)Rf(c[f>>2]|0)}else{c[h>>2]=c[b+112>>2];b=c[(c[(c[h>>2]|0)+8>>2]|0)+96>>2]|0;c[g>>2]=b;if(!b){j=6;break}b=(c[g>>2]|0)+56|0;k=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[b+12>>2]=c[k+12>>2];a[(c[g>>2]|0)+81>>0]=1}if(c[g>>2]|0)AO(c[e>>2]|0,c[g>>2]|0)}c[f>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]}if((j|0)==6)La(122578,122514,234,122597);else if((j|0)==13){i=d;return}}function Pf(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;do if(c[j>>2]|0)c[m>>2]=c[j>>2];else{f=c[h>>2]|0;e=c[h>>2]|0;b=c[h>>2]|0;if((c[((c[c[h>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)!=(c[((c[c[h>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)){e=c[h>>2]|0;f=c[h>>2]|0;if((c[(c[(c[((c[b>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){c[m>>2]=2;break}else{c[m>>2]=1;break}}if((d[(c[b+8>>2]|0)+16+28>>0]|0|0)==0?(d[(c[(c[h>>2]|0)+8>>2]|0)+56+28>>0]|0|0)==0:0){c[m>>2]=8;break}c[m>>2]=4}while(0);do if(!(c[k>>2]|0)){if((c[m>>2]|0)==1){j=c[h>>2]|0;b=c[h>>2]|0;c[n>>2]=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)<(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)?16:32;break}if((c[m>>2]|0)==2){b=c[h>>2]|0;j=c[h>>2]|0;c[n>>2]=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)<(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)?16:32;break}else{c[n>>2]=16;break}}else c[n>>2]=c[k>>2];while(0);c[(c[(c[h>>2]|0)+8>>2]|0)+164>>2]=c[m>>2]|c[n>>2]|c[l>>2];i=g;return}function Qf(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;f=i;i=i+656|0;g=f+408|0;j=f+368|0;k=f+648|0;l=f+644|0;m=f+640|0;n=f+576|0;o=f+512|0;p=f+504|0;q=f+500|0;r=f+496|0;s=f+492|0;t=f+488|0;u=f+484|0;v=f+480|0;w=f+476|0;x=f+472|0;y=f+468|0;z=f+464|0;A=f+8|0;B=f;C=f+460|0;D=f+456|0;E=f+452|0;F=f+448|0;c[l>>2]=b;c[m>>2]=e;c[n+8>>2]=f+192;c[o+8>>2]=f+16;c[p>>2]=c[c[l>>2]>>2];c[q>>2]=c[c[m>>2]>>2];c[v>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+164>>2]&15;c[w>>2]=c[(c[(c[q>>2]|0)+8>>2]|0)+164>>2]&15;if((c[v>>2]|0)!=(c[w>>2]|0)){c[k>>2]=(c[w>>2]|0)-(c[v>>2]|0);G=c[k>>2]|0;i=f;return G|0}c[t>>2]=Sf(c[p>>2]|0)|0;c[u>>2]=Sf(c[q>>2]|0)|0;m=c[t>>2]|0;l=c[t>>2]|0;h[A>>3]=+((c[(c[(c[((c[c[t>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[t>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0);l=c[u>>2]|0;m=c[u>>2]|0;h[B>>3]=+((c[(c[(c[((c[c[u>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[u>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0);m=~~+h[A>>3];c[x>>2]=(~~+h[A>>3]|0)>=0?m:0-m|0;m=~~+h[B>>3];c[y>>2]=(~~+h[B>>3]|0)>=0?m:0-m|0;if((c[x>>2]|0)!=(c[y>>2]|0)){c[k>>2]=(c[x>>2]|0)-(c[y>>2]|0);G=c[k>>2]|0;i=f;return G|0}m=c[t>>2]|0;l=c[t>>2]|0;h[A>>3]=+h[(c[(c[((c[c[t>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[((c[c[t>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+16>>3];l=c[u>>2]|0;m=c[u>>2]|0;h[B>>3]=+h[(c[(c[((c[c[u>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[((c[c[u>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)+8>>2]|0)+16>>3];m=~~+h[A>>3];c[x>>2]=(~~+h[A>>3]|0)>=0?m:0-m|0;m=~~+h[B>>3];c[y>>2]=(~~+h[B>>3]|0)>=0?m:0-m|0;if((c[x>>2]|0)!=(c[y>>2]|0)){c[k>>2]=(c[x>>2]|0)-(c[y>>2]|0);G=c[k>>2]|0;i=f;return G|0}if(((c[c[t>>2]>>2]|0)>>>4|0)!=((c[c[u>>2]>>2]|0)>>>4|0)){c[k>>2]=((c[c[t>>2]>>2]|0)>>>4)-((c[c[u>>2]>>2]|0)>>>4);G=c[k>>2]|0;i=f;return G|0}if((d[(c[(c[p>>2]|0)+8>>2]|0)+16+28>>0]|0|0)==0?(d[(c[(c[p>>2]|0)+8>>2]|0)+56+28>>0]|0|0)==0:0)H=c[t>>2]|0;else H=c[p>>2]|0;c[r>>2]=H;if(c[(c[(c[r>>2]|0)+8>>2]|0)+164>>2]&32){c[C>>2]=n;c[D>>2]=c[(c[C>>2]|0)+8>>2];Z4(c[D>>2]|0,c[(c[r>>2]|0)+8>>2]|0,176)|0;H=c[C>>2]|0;t=c[r>>2]|0;c[H>>2]=c[t>>2];c[H+4>>2]=c[t+4>>2];c[H+8>>2]=c[t+8>>2];c[H+12>>2]=c[t+12>>2];c[H+16>>2]=c[t+16>>2];c[H+20>>2]=c[t+20>>2];c[H+24>>2]=c[t+24>>2];c[H+28>>2]=c[t+28>>2];c[(c[C>>2]|0)+8>>2]=c[D>>2];D=c[r>>2]|0;t=c[C>>2]|0;c[((c[c[C>>2]>>2]&3|0)==3?t:t+32|0)+28>>2]=c[((c[c[r>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2];D=c[r>>2]|0;t=c[C>>2]|0;c[((c[c[C>>2]>>2]&3|0)==2?t:t+-32|0)+28>>2]=c[((c[c[r>>2]>>2]&3|0)==3?D:D+32|0)+28>>2];I=(c[(c[C>>2]|0)+8>>2]|0)+16|0;J=(c[(c[r>>2]|0)+8>>2]|0)+56|0;K=I+40|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));I=(c[(c[C>>2]|0)+8>>2]|0)+56|0;J=(c[(c[r>>2]|0)+8>>2]|0)+16|0;K=I+40|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));a[(c[(c[C>>2]|0)+8>>2]|0)+112>>0]=1;c[(c[(c[C>>2]|0)+8>>2]|0)+116>>2]=c[r>>2];c[r>>2]=n}if((d[(c[(c[q>>2]|0)+8>>2]|0)+16+28>>0]|0|0)==0?(d[(c[(c[q>>2]|0)+8>>2]|0)+56+28>>0]|0|0)==0:0)L=c[u>>2]|0;else L=c[q>>2]|0;c[s>>2]=L;if(c[(c[(c[s>>2]|0)+8>>2]|0)+164>>2]&32){c[E>>2]=o;c[F>>2]=c[(c[E>>2]|0)+8>>2];Z4(c[F>>2]|0,c[(c[s>>2]|0)+8>>2]|0,176)|0;L=c[E>>2]|0;u=c[s>>2]|0;c[L>>2]=c[u>>2];c[L+4>>2]=c[u+4>>2];c[L+8>>2]=c[u+8>>2];c[L+12>>2]=c[u+12>>2];c[L+16>>2]=c[u+16>>2];c[L+20>>2]=c[u+20>>2];c[L+24>>2]=c[u+24>>2];c[L+28>>2]=c[u+28>>2];c[(c[E>>2]|0)+8>>2]=c[F>>2];F=c[s>>2]|0;u=c[E>>2]|0;c[((c[c[E>>2]>>2]&3|0)==3?u:u+32|0)+28>>2]=c[((c[c[s>>2]>>2]&3|0)==2?F:F+-32|0)+28>>2];F=c[s>>2]|0;u=c[E>>2]|0;c[((c[c[E>>2]>>2]&3|0)==2?u:u+-32|0)+28>>2]=c[((c[c[s>>2]>>2]&3|0)==3?F:F+32|0)+28>>2];I=(c[(c[E>>2]|0)+8>>2]|0)+16|0;J=(c[(c[s>>2]|0)+8>>2]|0)+56|0;K=I+40|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));I=(c[(c[E>>2]|0)+8>>2]|0)+56|0;J=(c[(c[s>>2]|0)+8>>2]|0)+16|0;K=I+40|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));a[(c[(c[E>>2]|0)+8>>2]|0)+112>>0]=1;c[(c[(c[E>>2]|0)+8>>2]|0)+116>>2]=c[s>>2];c[s>>2]=o}o=(c[(c[s>>2]|0)+8>>2]|0)+16|0;I=j;J=(c[(c[r>>2]|0)+8>>2]|0)+16|0;K=I+40|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));I=g;J=o;K=I+40|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));o=Kf(j,g)|0;c[z>>2]=o;if(o){c[k>>2]=c[z>>2];G=c[k>>2]|0;i=f;return G|0}o=(c[(c[s>>2]|0)+8>>2]|0)+56|0;I=j;J=(c[(c[r>>2]|0)+8>>2]|0)+56|0;K=I+40|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));I=g;J=o;K=I+40|0;do{c[I>>2]=c[J>>2];I=I+4|0;J=J+4|0}while((I|0)<(K|0));J=Kf(j,g)|0;c[z>>2]=J;if(J){c[k>>2]=c[z>>2];G=c[k>>2]|0;i=f;return G|0}c[v>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+164>>2]&192;c[w>>2]=c[(c[(c[q>>2]|0)+8>>2]|0)+164>>2]&192;z=c[v>>2]|0;if((c[v>>2]|0)!=(c[w>>2]|0)){c[k>>2]=z-(c[w>>2]|0);G=c[k>>2]|0;i=f;return G|0}if((z|0)==2?(c[(c[(c[p>>2]|0)+8>>2]|0)+96>>2]|0)!=(c[(c[(c[q>>2]|0)+8>>2]|0)+96>>2]|0):0){c[k>>2]=((c[(c[(c[p>>2]|0)+8>>2]|0)+96>>2]|0)-(c[(c[(c[q>>2]|0)+8>>2]|0)+96>>2]|0)|0)/88|0;G=c[k>>2]|0;i=f;return G|0}c[k>>2]=((c[c[p>>2]>>2]|0)>>>4)-((c[c[q>>2]>>2]|0)>>>4);G=c[k>>2]|0;i=f;return G|0}function Rf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+28|0;f=d+8|0;g=d;j=d+24|0;c[e>>2]=b;if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+172+4>>2]|0)){i=d;return}c[j>>2]=c[c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]>>2];while(1){k=c[(c[j>>2]|0)+8>>2]|0;if(!(a[(c[(c[j>>2]|0)+8>>2]|0)+112>>0]|0))break;c[j>>2]=c[k+116>>2]}b=(c[k+96>>2]|0)+24|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];b=(c[(c[(qC(c[e>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;h[g>>3]=b?+h[f+8>>3]:+h[f>>3];h[(c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0)+56>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]+ +h[g>>3]/2.0;h[(c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0)+56+8>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16+8>>3];a[(c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;i=d;return}function Sf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[d>>2];while(1){if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]|0))break;c[e>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]}while(1){f=c[e>>2]|0;if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+116>>2]|0))break;c[e>>2]=c[(c[f+8>>2]|0)+116>>2]}i=b;return f|0}function Tf(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;m=i;i=i+1824|0;n=m+1624|0;o=m+1808|0;p=m+1804|0;q=m+1800|0;r=m+1796|0;s=m+1792|0;t=m+1788|0;u=m+1784|0;v=m+1780|0;w=m+1776|0;x=m+1712|0;y=m+1704|0;z=m+1700|0;A=m+1696|0;B=m+1692|0;C=m+1688|0;D=m+1440|0;E=m+1432|0;F=m+1424|0;G=m+1684|0;H=m+1680|0;I=m+1676|0;J=m+1672|0;K=m+728|0;L=m+32|0;M=m+1668|0;N=m+1664|0;O=m+1660|0;P=m+1656|0;Q=m;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;c[t>>2]=k;c[u>>2]=l;c[x+8>>2]=m+1448;c[y>>2]=c[(c[r>>2]|0)+(c[s>>2]<<2)>>2];c[C>>2]=a[(c[(c[y>>2]|0)+8>>2]|0)+113>>0];if(c[(c[(c[y>>2]|0)+8>>2]|0)+164>>2]&32){c[M>>2]=x;c[N>>2]=c[(c[M>>2]|0)+8>>2];Z4(c[N>>2]|0,c[(c[y>>2]|0)+8>>2]|0,176)|0;l=c[M>>2]|0;k=c[y>>2]|0;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2];c[l+16>>2]=c[k+16>>2];c[l+20>>2]=c[k+20>>2];c[l+24>>2]=c[k+24>>2];c[l+28>>2]=c[k+28>>2];c[(c[M>>2]|0)+8>>2]=c[N>>2];N=c[y>>2]|0;k=c[M>>2]|0;c[((c[c[M>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]=c[((c[c[y>>2]>>2]&3|0)==2?N:N+-32|0)+28>>2];N=c[y>>2]|0;k=c[M>>2]|0;c[((c[c[M>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]=c[((c[c[y>>2]>>2]&3|0)==3?N:N+32|0)+28>>2];N=(c[(c[M>>2]|0)+8>>2]|0)+16|0;k=(c[(c[y>>2]|0)+8>>2]|0)+56|0;l=N+40|0;do{c[N>>2]=c[k>>2];N=N+4|0;k=k+4|0}while((N|0)<(l|0));N=(c[(c[M>>2]|0)+8>>2]|0)+56|0;k=(c[(c[y>>2]|0)+8>>2]|0)+16|0;l=N+40|0;do{c[N>>2]=c[k>>2];N=N+4|0;k=k+4|0}while((N|0)<(l|0));a[(c[(c[M>>2]|0)+8>>2]|0)+112>>0]=1;c[(c[(c[M>>2]|0)+8>>2]|0)+116>>2]=c[y>>2];c[y>>2]=x}c[A>>2]=1;while(1){if((c[A>>2]|0)>=(c[t>>2]|0))break;if(a[(c[(c[(c[r>>2]|0)+((c[s>>2]|0)+(c[A>>2]|0)<<2)>>2]|0)+8>>2]|0)+113>>0]|0){R=6;break}c[A>>2]=(c[A>>2]|0)+1}if((R|0)==6)c[C>>2]=1;if(c[C>>2]|0){qg(c[o>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[y>>2]|0,c[u>>2]|0);i=m;return}if(c[(c[(c[y>>2]|0)+8>>2]|0)+96>>2]|0){rg(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[y>>2]|0,c[u>>2]|0);i=m;return}C=c[y>>2]|0;if((c[u>>2]|0)==2){x=c[y>>2]|0;M=c[y>>2]|0;sg(c[((c[C>>2]&3|0)==3?x:x+32|0)+28>>2]|0,c[((c[c[y>>2]>>2]&3|0)==2?M:M+-32|0)+28>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0);i=m;return}c[G>>2]=d[(c[C+8>>2]|0)+16+33>>0];c[H>>2]=d[(c[(c[y>>2]|0)+8>>2]|0)+56+33>>0];if(!((c[G>>2]|0)==1&(c[H>>2]|0)!=4)?!((c[H>>2]|0)==1&(c[G>>2]|0)!=4):0){G=c[y>>2]|0;c[v>>2]=c[((c[c[y>>2]>>2]&3|0)==3?G:G+32|0)+28>>2];G=c[y>>2]|0;c[w>>2]=c[((c[c[y>>2]>>2]&3|0)==2?G:G+-32|0)+28>>2];c[B>>2]=c[(c[(c[v>>2]|0)+8>>2]|0)+232>>2];G=c[(c[o>>2]|0)+8>>2]|0;if((c[B>>2]|0)>0){H=c[(c[(c[o>>2]|0)+8>>2]|0)+196>>2]|0;C=c[B>>2]|0;if(d[G+113>>0]&1)c[O>>2]=H+(C-2<<6);else c[O>>2]=H+(C-1<<6);h[F>>3]=+h[(c[(c[c[(c[O>>2]|0)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[O>>2]|0)+16>>3]-+h[(c[(c[v>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+196>>2]|0)+(c[B>>2]<<6)+24>>3]}else h[F>>3]=+(c[G+252>>2]|0);h[D>>3]=+(c[(c[p>>2]|0)+12>>2]|0)/+((c[t>>2]|0)+1|0);h[E>>3]=+h[F>>3]/+((c[t>>2]|0)+1|0);ug(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[v>>2]|0,c[y>>2]|0,K,1);ug(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[w>>2]|0,c[y>>2]|0,L,0);c[A>>2]=0;while(1){if((c[A>>2]|0)>=(c[t>>2]|0)){R=39;break}c[y>>2]=c[(c[r>>2]|0)+((c[s>>2]|0)+(c[A>>2]|0)<<2)>>2];c[P>>2]=0;w=K+56+((c[K+52>>2]|0)-1<<5)|0;c[Q>>2]=c[w>>2];c[Q+4>>2]=c[w+4>>2];c[Q+8>>2]=c[w+8>>2];c[Q+12>>2]=c[w+12>>2];c[Q+16>>2]=c[w+16>>2];c[Q+20>>2]=c[w+20>>2];c[Q+24>>2]=c[w+24>>2];c[Q+28>>2]=c[w+28>>2];h[1104+(c[P>>2]<<5)>>3]=+h[Q>>3];h[1104+(c[P>>2]<<5)+8>>3]=+h[Q+16+8>>3];h[1104+(c[P>>2]<<5)+16>>3]=+h[Q+16>>3]+ +((c[A>>2]|0)+1|0)*+h[D>>3];h[1104+(c[P>>2]<<5)+16+8>>3]=+h[Q+16+8>>3]+ +((c[A>>2]|0)+1|0)*+h[E>>3];c[P>>2]=(c[P>>2]|0)+1;h[1104+(c[P>>2]<<5)>>3]=+h[K+56+((c[K+52>>2]|0)-1<<5)>>3];h[1104+(c[P>>2]<<5)+8>>3]=+h[1104+((c[P>>2]|0)-1<<5)+16+8>>3];h[1104+(c[P>>2]<<5)+16>>3]=+h[L+56+((c[L+52>>2]|0)-1<<5)+16>>3];h[1104+(c[P>>2]<<5)+16+8>>3]=+h[1104+(c[P>>2]<<5)+8>>3]+ +h[E>>3];c[P>>2]=(c[P>>2]|0)+1;w=L+56+((c[L+52>>2]|0)-1<<5)|0;c[Q>>2]=c[w>>2];c[Q+4>>2]=c[w+4>>2];c[Q+8>>2]=c[w+8>>2];c[Q+12>>2]=c[w+12>>2];c[Q+16>>2]=c[w+16>>2];c[Q+20>>2]=c[w+20>>2];c[Q+24>>2]=c[w+24>>2];c[Q+28>>2]=c[w+28>>2];h[1104+(c[P>>2]<<5)+16>>3]=+h[Q+16>>3];h[1104+(c[P>>2]<<5)+8>>3]=+h[Q+16+8>>3];h[1104+(c[P>>2]<<5)>>3]=+h[Q>>3]-+((c[A>>2]|0)+1|0)*+h[D>>3];h[1104+(c[P>>2]<<5)+16+8>>3]=+h[1104+((c[P>>2]|0)-1<<5)+8>>3];c[P>>2]=(c[P>>2]|0)+1;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[K+52>>2]|0))break;w=c[q>>2]|0;v=K+56+(c[z>>2]<<5)|0;c[n>>2]=c[v>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];c[n+12>>2]=c[v+12>>2];c[n+16>>2]=c[v+16>>2];c[n+20>>2]=c[v+20>>2];c[n+24>>2]=c[v+24>>2];c[n+28>>2]=c[v+28>>2];kN(w,n);c[z>>2]=(c[z>>2]|0)+1}c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[P>>2]|0))break;w=c[q>>2]|0;v=1104+(c[z>>2]<<5)|0;c[n>>2]=c[v>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];c[n+12>>2]=c[v+12>>2];c[n+16>>2]=c[v+16>>2];c[n+20>>2]=c[v+20>>2];c[n+24>>2]=c[v+24>>2];c[n+28>>2]=c[v+28>>2];kN(w,n);c[z>>2]=(c[z>>2]|0)+1}c[z>>2]=(c[L+52>>2]|0)-1;while(1){if((c[z>>2]|0)<0)break;w=c[q>>2]|0;v=L+56+(c[z>>2]<<5)|0;c[n>>2]=c[v>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];c[n+12>>2]=c[v+12>>2];c[n+16>>2]=c[v+16>>2];c[n+20>>2]=c[v+20>>2];c[n+24>>2]=c[v+24>>2];c[n+28>>2]=c[v+28>>2];kN(w,n);c[z>>2]=(c[z>>2]|0)+-1}w=c[q>>2]|0;if((c[u>>2]|0)==10)c[J>>2]=RL(w,I)|0;else c[J>>2]=SL(w,I)|0;if(!(c[I>>2]|0)){R=39;break}w=c[y>>2]|0;jN(c[y>>2]|0,c[((c[c[y>>2]>>2]&3|0)==2?w:w+-32|0)+28>>2]|0,c[J>>2]|0,c[I>>2]|0,50160);c[(c[q>>2]|0)+80>>2]=0;c[A>>2]=(c[A>>2]|0)+1}if((R|0)==39){i=m;return}}tg(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[y>>2]|0,(c[u>>2]|0)==10&1);i=m;return}function Uf(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0;m=i;i=i+2672|0;n=m+2304|0;o=m+2656|0;p=m+2652|0;q=m+2648|0;r=m+2644|0;s=m+2640|0;t=m+2636|0;u=m+2632|0;v=m+2628|0;w=m+2624|0;x=m+2128|0;y=m+1952|0;z=m+2560|0;A=m+2496|0;B=m+2432|0;C=m+2424|0;D=m+2420|0;E=m+2416|0;F=m+2412|0;G=m+2408|0;H=m+1080|0;I=m+384|0;J=m+352|0;K=m+2404|0;L=m+2400|0;M=m+2396|0;N=m+2392|0;O=m+2388|0;P=m+2384|0;Q=m+2380|0;R=m+2376|0;S=m+2372|0;T=m+2368|0;U=m+2364|0;V=m+2360|0;W=m+2356|0;X=m+2352|0;Y=m+2348|0;Z=m+2344|0;$=m+320|0;aa=m+288|0;ba=m+256|0;ca=m+224|0;da=m+192|0;ea=m+160|0;fa=m+128|0;ga=m+96|0;ha=m+64|0;ia=m+32|0;ja=m;ka=m+2340|0;la=m+2336|0;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;c[t>>2]=k;c[u>>2]=l;c[z+8>>2]=x;c[A+8>>2]=y;c[B+8>>2]=m+1776;if(!(c[12543]|0)){c[12543]=cK(32e3)|0;c[12544]=cK(32e3)|0;c[12545]=2e3;c[12546]=2e3}c[L>>2]=0;c[C>>2]=c[(c[r>>2]|0)+(c[s>>2]<<2)>>2];c[S>>2]=0;l=c[C>>2]|0;k=c[C>>2]|0;j=c[C>>2]|0;g=c[C>>2]|0;f=(c[(c[(c[((c[c[C>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[C>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0;g=c[C>>2]|0;if(((((c[(c[(c[((c[c[C>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[C>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0)>=0?f:0-f|0)|0)<=1){if(c[(c[g+8>>2]|0)+164>>2]&32){c[X>>2]=z;c[Y>>2]=c[(c[X>>2]|0)+8>>2];Z4(c[Y>>2]|0,c[(c[C>>2]|0)+8>>2]|0,176)|0;f=c[X>>2]|0;k=c[C>>2]|0;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[f+16>>2]=c[k+16>>2];c[f+20>>2]=c[k+20>>2];c[f+24>>2]=c[k+24>>2];c[f+28>>2]=c[k+28>>2];c[(c[X>>2]|0)+8>>2]=c[Y>>2];Y=c[C>>2]|0;k=c[X>>2]|0;c[((c[c[X>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==2?Y:Y+-32|0)+28>>2];Y=c[C>>2]|0;k=c[X>>2]|0;c[((c[c[X>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==3?Y:Y+32|0)+28>>2];ma=(c[(c[X>>2]|0)+8>>2]|0)+16|0;na=(c[(c[C>>2]|0)+8>>2]|0)+56|0;oa=ma+40|0;do{c[ma>>2]=c[na>>2];ma=ma+4|0;na=na+4|0}while((ma|0)<(oa|0));ma=(c[(c[X>>2]|0)+8>>2]|0)+56|0;na=(c[(c[C>>2]|0)+8>>2]|0)+16|0;oa=ma+40|0;do{c[ma>>2]=c[na>>2];ma=ma+4|0;na=na+4|0}while((ma|0)<(oa|0));a[(c[(c[X>>2]|0)+8>>2]|0)+112>>0]=1;c[(c[(c[X>>2]|0)+8>>2]|0)+116>>2]=c[C>>2];c[C>>2]=z}}else{Z4(x|0,c[g+8>>2]|0,176)|0;g=c[C>>2]|0;c[z>>2]=c[g>>2];c[z+4>>2]=c[g+4>>2];c[z+8>>2]=c[g+8>>2];c[z+12>>2]=c[g+12>>2];c[z+16>>2]=c[g+16>>2];c[z+20>>2]=c[g+20>>2];c[z+24>>2]=c[g+24>>2];c[z+28>>2]=c[g+28>>2];c[z+8>>2]=x;if(c[(c[(c[C>>2]|0)+8>>2]|0)+164>>2]&32){c[V>>2]=A;c[W>>2]=c[(c[V>>2]|0)+8>>2];Z4(c[W>>2]|0,c[(c[C>>2]|0)+8>>2]|0,176)|0;x=c[V>>2]|0;g=c[C>>2]|0;c[x>>2]=c[g>>2];c[x+4>>2]=c[g+4>>2];c[x+8>>2]=c[g+8>>2];c[x+12>>2]=c[g+12>>2];c[x+16>>2]=c[g+16>>2];c[x+20>>2]=c[g+20>>2];c[x+24>>2]=c[g+24>>2];c[x+28>>2]=c[g+28>>2];c[(c[V>>2]|0)+8>>2]=c[W>>2];W=c[C>>2]|0;g=c[V>>2]|0;c[((c[c[V>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==2?W:W+-32|0)+28>>2];W=c[C>>2]|0;g=c[V>>2]|0;c[((c[c[V>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==3?W:W+32|0)+28>>2];ma=(c[(c[V>>2]|0)+8>>2]|0)+16|0;na=(c[(c[C>>2]|0)+8>>2]|0)+56|0;oa=ma+40|0;do{c[ma>>2]=c[na>>2];ma=ma+4|0;na=na+4|0}while((ma|0)<(oa|0));ma=(c[(c[V>>2]|0)+8>>2]|0)+56|0;na=(c[(c[C>>2]|0)+8>>2]|0)+16|0;oa=ma+40|0;do{c[ma>>2]=c[na>>2];ma=ma+4|0;na=na+4|0}while((ma|0)<(oa|0));a[(c[(c[V>>2]|0)+8>>2]|0)+112>>0]=1;c[(c[(c[V>>2]|0)+8>>2]|0)+116>>2]=c[C>>2];V=c[C>>2]|0;c[((c[z>>2]&3|0)==3?z:z+32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==2?V:V+-32|0)+28>>2];ma=(c[z+8>>2]|0)+16|0;na=(c[(c[C>>2]|0)+8>>2]|0)+56|0;oa=ma+40|0;do{c[ma>>2]=c[na>>2];ma=ma+4|0;na=na+4|0}while((ma|0)<(oa|0))}else{Z4(y|0,c[(c[C>>2]|0)+8>>2]|0,176)|0;V=c[C>>2]|0;c[A>>2]=c[V>>2];c[A+4>>2]=c[V+4>>2];c[A+8>>2]=c[V+8>>2];c[A+12>>2]=c[V+12>>2];c[A+16>>2]=c[V+16>>2];c[A+20>>2]=c[V+20>>2];c[A+24>>2]=c[V+24>>2];c[A+28>>2]=c[V+28>>2];c[A+8>>2]=y;y=c[C>>2]|0;c[((c[z>>2]&3|0)==3?z:z+32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==3?y:y+32|0)+28>>2]}c[E>>2]=Sf(c[C>>2]|0)|0;while(1){pa=c[E>>2]|0;if(!(c[(c[(c[E>>2]|0)+8>>2]|0)+172>>2]|0))break;c[E>>2]=c[(c[pa+8>>2]|0)+172>>2]}y=c[E>>2]|0;c[((c[z>>2]&3|0)==2?z:z+-32|0)+28>>2]=c[((c[pa>>2]&3|0)==2?y:y+-32|0)+28>>2];a[(c[z+8>>2]|0)+56+28>>0]=0;a[(c[z+8>>2]|0)+112>>0]=1;h[(c[z+8>>2]|0)+56+8>>3]=0.0;h[(c[z+8>>2]|0)+56>>3]=0.0;c[(c[z+8>>2]|0)+116>>2]=c[C>>2];c[C>>2]=z;c[S>>2]=1}c[D>>2]=c[C>>2];if(!((c[u>>2]|0)==2?(z=Yf(c[o>>2]|0,c[D>>2]|0,c[12543]|0,w)|0,c[U>>2]=z,(z|0)!=0):0)){c[Z>>2]=(c[u>>2]|0)==10&1;c[K>>2]=0;c[U>>2]=0;c[F>>2]=c[C>>2];z=c[C>>2]|0;c[v>>2]=c[((c[c[C>>2]>>2]&3|0)==3?z:z+32|0)+28>>2];z=c[C>>2]|0;c[w>>2]=c[((c[c[C>>2]>>2]&3|0)==2?z:z+-32|0)+28>>2];Zf($,c[o>>2]|0,c[p>>2]|0,c[v>>2]|0,0,c[C>>2]|0);c[H>>2]=c[$>>2];c[H+4>>2]=c[$+4>>2];c[H+8>>2]=c[$+8>>2];c[H+12>>2]=c[$+12>>2];c[H+16>>2]=c[$+16>>2];c[H+20>>2]=c[$+20>>2];c[H+24>>2]=c[$+24>>2];c[H+28>>2]=c[$+28>>2];c[J>>2]=c[H>>2];c[J+4>>2]=c[H+4>>2];c[J+8>>2]=c[H+8>>2];c[J+12>>2]=c[H+12>>2];c[J+16>>2]=c[H+16>>2];c[J+20>>2]=c[H+20>>2];c[J+24>>2]=c[H+24>>2];c[J+28>>2]=c[H+28>>2];$=c[q>>2]|0;z=c[C>>2]|0;lN($,z,1,H,_f(c[v>>2]|0)|0);h[J+16+8>>3]=+h[H+56+((c[H+52>>2]|0)-1<<5)+16+8>>3];h[J+8>>3]=+h[H+56+((c[H+52>>2]|0)-1<<5)+8>>3];qa=+h[(c[(c[v>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[v>>2]|0)+8>>2]|0)+232>>2]<<6)+16>>3];c[n>>2]=c[J>>2];c[n+4>>2]=c[J+4>>2];c[n+8>>2]=c[J+8>>2];c[n+12>>2]=c[J+12>>2];c[n+16>>2]=c[J+16>>2];c[n+20>>2]=c[J+20>>2];c[n+24>>2]=c[J+24>>2];c[n+28>>2]=c[J+28>>2];$f(aa,n,1,qa);c[J>>2]=c[aa>>2];c[J+4>>2]=c[aa+4>>2];c[J+8>>2]=c[aa+8>>2];c[J+12>>2]=c[aa+12>>2];c[J+16>>2]=c[aa+16>>2];c[J+20>>2]=c[aa+20>>2];c[J+24>>2]=c[aa+24>>2];c[J+28>>2]=c[aa+28>>2];if(+h[J>>3]<+h[J+16>>3]?+h[J+8>>3]<+h[J+16+8>>3]:0){aa=H+52|0;z=c[aa>>2]|0;c[aa>>2]=z+1;aa=H+56+(z<<5)|0;c[aa>>2]=c[J>>2];c[aa+4>>2]=c[J+4>>2];c[aa+8>>2]=c[J+8>>2];c[aa+12>>2]=c[J+12>>2];c[aa+16>>2]=c[J+16>>2];c[aa+20>>2]=c[J+20>>2];c[aa+24>>2]=c[J+24>>2];c[aa+28>>2]=c[J+28>>2]}c[T>>2]=0;c[N>>2]=0;c[M>>2]=-1;while(1){if((a[(c[(c[w>>2]|0)+8>>2]|0)+156>>0]|0)!=1)break;if(!((Fb[c[50164>>2]&63](c[w>>2]|0)|0)<<24>>24!=0^1))break;c[T>>2]=1;aa=c[K>>2]|0;c[K>>2]=aa+1;z=1104+(aa<<5)|0;ag(ba,c[p>>2]|0,c[o>>2]|0,c[(c[(c[v>>2]|0)+8>>2]|0)+232>>2]|0);c[z>>2]=c[ba>>2];c[z+4>>2]=c[ba+4>>2];c[z+8>>2]=c[ba+8>>2];c[z+12>>2]=c[ba+12>>2];c[z+16>>2]=c[ba+16>>2];c[z+20>>2]=c[ba+20>>2];c[z+24>>2]=c[ba+24>>2];c[z+28>>2]=c[ba+28>>2];if((c[N>>2]|0)==0?(z=bg(c[w>>2]|0)|0,c[L>>2]=z,(z|0)>=(((d[(c[(c[o>>2]|0)+8>>2]|0)+113>>0]&1|0)!=0?5:3)|0)):0){c[N>>2]=1;c[M>>2]=1;c[L>>2]=(c[L>>2]|0)-2}if((c[N>>2]|0)==0|(c[M>>2]|0)>0){c[M>>2]=(c[M>>2]|0)+-1;z=c[K>>2]|0;c[K>>2]=z+1;aa=1104+(z<<5)|0;Zf(ca,c[o>>2]|0,c[p>>2]|0,c[w>>2]|0,c[C>>2]|0,c[c[(c[(c[w>>2]|0)+8>>2]|0)+180>>2]>>2]|0);c[aa>>2]=c[ca>>2];c[aa+4>>2]=c[ca+4>>2];c[aa+8>>2]=c[ca+8>>2];c[aa+12>>2]=c[ca+12>>2];c[aa+16>>2]=c[ca+16>>2];c[aa+20>>2]=c[ca+20>>2];c[aa+24>>2]=c[ca+24>>2];c[aa+28>>2]=c[ca+28>>2];c[C>>2]=c[c[(c[(c[w>>2]|0)+8>>2]|0)+180>>2]>>2];aa=c[C>>2]|0;c[v>>2]=c[((c[c[C>>2]>>2]&3|0)==3?aa:aa+32|0)+28>>2];aa=c[C>>2]|0;c[w>>2]=c[((c[c[C>>2]>>2]&3|0)==2?aa:aa+-32|0)+28>>2];continue}Zf(da,c[o>>2]|0,c[p>>2]|0,c[w>>2]|0,c[C>>2]|0,c[c[(c[(c[w>>2]|0)+8>>2]|0)+180>>2]>>2]|0);c[I>>2]=c[da>>2];c[I+4>>2]=c[da+4>>2];c[I+8>>2]=c[da+8>>2];c[I+12>>2]=c[da+12>>2];c[I+16>>2]=c[da+16>>2];c[I+20>>2]=c[da+20>>2];c[I+24>>2]=c[da+24>>2];c[I+28>>2]=c[da+28>>2];aa=c[q>>2]|0;z=c[C>>2]|0;$=c[C>>2]|0;mN(aa,z,1,I,_f(c[((c[c[C>>2]>>2]&3|0)==2?$:$+-32|0)+28>>2]|0)|0);$=I+56+((c[I+52>>2]|0)-1<<5)|0;qa=+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[(c[o>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[w>>2]|0)+8>>2]|0)+232>>2]<<6)+24>>3];c[n>>2]=c[$>>2];c[n+4>>2]=c[$+4>>2];c[n+8>>2]=c[$+8>>2];c[n+12>>2]=c[$+12>>2];c[n+16>>2]=c[$+16>>2];c[n+20>>2]=c[$+20>>2];c[n+24>>2]=c[$+24>>2];c[n+28>>2]=c[$+28>>2];$f(ea,n,4,qa);c[J>>2]=c[ea>>2];c[J+4>>2]=c[ea+4>>2];c[J+8>>2]=c[ea+8>>2];c[J+12>>2]=c[ea+12>>2];c[J+16>>2]=c[ea+16>>2];c[J+20>>2]=c[ea+20>>2];c[J+24>>2]=c[ea+24>>2];c[J+28>>2]=c[ea+28>>2];if(+h[J>>3]<+h[J+16>>3]?+h[J+8>>3]<+h[J+16+8>>3]:0){$=I+52|0;z=c[$>>2]|0;c[$>>2]=z+1;$=I+56+(z<<5)|0;c[$>>2]=c[J>>2];c[$+4>>2]=c[J+4>>2];c[$+8>>2]=c[J+8>>2];c[$+12>>2]=c[J+12>>2];c[$+16>>2]=c[J+16>>2];c[$+20>>2]=c[J+20>>2];c[$+24>>2]=c[J+24>>2];c[$+28>>2]=c[J+28>>2]}h[(c[q>>2]|0)+40+16>>3]=1.5707963267948966;a[(c[q>>2]|0)+40+29>>0]=1;cg(c[q>>2]|0,c[F>>2]|0,c[C>>2]|0,H,I,1104,c[K>>2]|0,1);$=c[q>>2]|0;if(!(c[Z>>2]|0)){c[G>>2]=SL($,R)|0;if((c[u>>2]|0)==2&(c[R>>2]|0)>4){z=(c[G>>2]|0)+16|0;aa=c[G>>2]|0;c[z>>2]=c[aa>>2];c[z+4>>2]=c[aa+4>>2];c[z+8>>2]=c[aa+8>>2];c[z+12>>2]=c[aa+12>>2];aa=(c[G>>2]|0)+48|0;z=(c[G>>2]|0)+32|0;y=(c[G>>2]|0)+((c[R>>2]|0)-1<<4)|0;c[z>>2]=c[y>>2];c[z+4>>2]=c[y+4>>2];c[z+8>>2]=c[y+8>>2];c[z+12>>2]=c[y+12>>2];c[aa>>2]=c[z>>2];c[aa+4>>2]=c[z+4>>2];c[aa+8>>2]=c[z+8>>2];c[aa+12>>2]=c[z+12>>2];c[R>>2]=4}}else c[G>>2]=RL($,R)|0;if(!(c[R>>2]|0)){ra=82;break}if(((c[U>>2]|0)+(c[R>>2]|0)|0)>(c[12545]|0)){c[12545]=(c[U>>2]|0)+(c[R>>2]|0)<<1;c[12543]=eK(c[12543]|0,c[12545]<<4)|0}c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[R>>2]|0))break;$=c[U>>2]|0;c[U>>2]=$+1;z=(c[12543]|0)+($<<4)|0;$=(c[G>>2]|0)+(c[O>>2]<<4)|0;c[z>>2]=c[$>>2];c[z+4>>2]=c[$+4>>2];c[z+8>>2]=c[$+8>>2];c[z+12>>2]=c[$+12>>2];c[O>>2]=(c[O>>2]|0)+1}c[C>>2]=dg(c[c[(c[(c[w>>2]|0)+8>>2]|0)+180>>2]>>2]|0,c[L>>2]|0,c[12543]|0,U)|0;eg(c[F>>2]|0,c[q>>2]|0);c[F>>2]=c[C>>2];$=c[C>>2]|0;c[v>>2]=c[((c[c[C>>2]>>2]&3|0)==3?$:$+32|0)+28>>2];$=c[C>>2]|0;c[w>>2]=c[((c[c[C>>2]>>2]&3|0)==2?$:$+-32|0)+28>>2];c[K>>2]=0;Zf(fa,c[o>>2]|0,c[p>>2]|0,c[v>>2]|0,c[c[(c[(c[v>>2]|0)+8>>2]|0)+172>>2]>>2]|0,c[C>>2]|0);c[H>>2]=c[fa>>2];c[H+4>>2]=c[fa+4>>2];c[H+8>>2]=c[fa+8>>2];c[H+12>>2]=c[fa+12>>2];c[H+16>>2]=c[fa+16>>2];c[H+20>>2]=c[fa+20>>2];c[H+24>>2]=c[fa+24>>2];c[H+28>>2]=c[fa+28>>2];$=c[q>>2]|0;z=c[C>>2]|0;lN($,z,1,H,_f(c[v>>2]|0)|0);z=H+56+((c[H+52>>2]|0)-1<<5)|0;qa=+h[(c[(c[v>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[v>>2]|0)+8>>2]|0)+232>>2]<<6)+16>>3];c[n>>2]=c[z>>2];c[n+4>>2]=c[z+4>>2];c[n+8>>2]=c[z+8>>2];c[n+12>>2]=c[z+12>>2];c[n+16>>2]=c[z+16>>2];c[n+20>>2]=c[z+20>>2];c[n+24>>2]=c[z+24>>2];c[n+28>>2]=c[z+28>>2];$f(ga,n,1,qa);c[J>>2]=c[ga>>2];c[J+4>>2]=c[ga+4>>2];c[J+8>>2]=c[ga+8>>2];c[J+12>>2]=c[ga+12>>2];c[J+16>>2]=c[ga+16>>2];c[J+20>>2]=c[ga+20>>2];c[J+24>>2]=c[ga+24>>2];c[J+28>>2]=c[ga+28>>2];if(+h[J>>3]<+h[J+16>>3]?+h[J+8>>3]<+h[J+16+8>>3]:0){z=H+52|0;$=c[z>>2]|0;c[z>>2]=$+1;z=H+56+($<<5)|0;c[z>>2]=c[J>>2];c[z+4>>2]=c[J+4>>2];c[z+8>>2]=c[J+8>>2];c[z+12>>2]=c[J+12>>2];c[z+16>>2]=c[J+16>>2];c[z+20>>2]=c[J+20>>2];c[z+24>>2]=c[J+24>>2];c[z+28>>2]=c[J+28>>2]}h[(c[q>>2]|0)+16>>3]=-1.5707963267948966;a[(c[q>>2]|0)+29>>0]=1;c[N>>2]=0}if((ra|0)==82){i=m;return}ra=c[K>>2]|0;c[K>>2]=ra+1;N=1104+(ra<<5)|0;ag(ha,c[p>>2]|0,c[o>>2]|0,c[(c[(c[v>>2]|0)+8>>2]|0)+232>>2]|0);c[N>>2]=c[ha>>2];c[N+4>>2]=c[ha+4>>2];c[N+8>>2]=c[ha+8>>2];c[N+12>>2]=c[ha+12>>2];c[N+16>>2]=c[ha+16>>2];c[N+20>>2]=c[ha+20>>2];c[N+24>>2]=c[ha+24>>2];c[N+28>>2]=c[ha+28>>2];Zf(ia,c[o>>2]|0,c[p>>2]|0,c[w>>2]|0,c[C>>2]|0,0);c[I>>2]=c[ia>>2];c[I+4>>2]=c[ia+4>>2];c[I+8>>2]=c[ia+8>>2];c[I+12>>2]=c[ia+12>>2];c[I+16>>2]=c[ia+16>>2];c[I+20>>2]=c[ia+20>>2];c[I+24>>2]=c[ia+24>>2];c[I+28>>2]=c[ia+28>>2];c[J>>2]=c[I>>2];c[J+4>>2]=c[I+4>>2];c[J+8>>2]=c[I+8>>2];c[J+12>>2]=c[I+12>>2];c[J+16>>2]=c[I+16>>2];c[J+20>>2]=c[I+20>>2];c[J+24>>2]=c[I+24>>2];c[J+28>>2]=c[I+28>>2];ia=c[q>>2]|0;ha=(c[S>>2]|0)!=0?A:c[C>>2]|0;N=c[C>>2]|0;mN(ia,ha,1,I,_f(c[((c[c[C>>2]>>2]&3|0)==2?N:N+-32|0)+28>>2]|0)|0);h[J+16+8>>3]=+h[I+56+((c[I+52>>2]|0)-1<<5)+16+8>>3];h[J+8>>3]=+h[I+56+((c[I+52>>2]|0)-1<<5)+8>>3];qa=+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[(c[o>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[w>>2]|0)+8>>2]|0)+232>>2]<<6)+24>>3];c[n>>2]=c[J>>2];c[n+4>>2]=c[J+4>>2];c[n+8>>2]=c[J+8>>2];c[n+12>>2]=c[J+12>>2];c[n+16>>2]=c[J+16>>2];c[n+20>>2]=c[J+20>>2];c[n+24>>2]=c[J+24>>2];c[n+28>>2]=c[J+28>>2];$f(ja,n,4,qa);c[J>>2]=c[ja>>2];c[J+4>>2]=c[ja+4>>2];c[J+8>>2]=c[ja+8>>2];c[J+12>>2]=c[ja+12>>2];c[J+16>>2]=c[ja+16>>2];c[J+20>>2]=c[ja+20>>2];c[J+24>>2]=c[ja+24>>2];c[J+28>>2]=c[ja+28>>2];if(+h[J>>3]<+h[J+16>>3]?+h[J+8>>3]<+h[J+16+8>>3]:0){ja=I+52|0;n=c[ja>>2]|0;c[ja>>2]=n+1;ja=I+56+(n<<5)|0;c[ja>>2]=c[J>>2];c[ja+4>>2]=c[J+4>>2];c[ja+8>>2]=c[J+8>>2];c[ja+12>>2]=c[J+12>>2];c[ja+16>>2]=c[J+16>>2];c[ja+20>>2]=c[J+20>>2];c[ja+24>>2]=c[J+24>>2];c[ja+28>>2]=c[J+28>>2]}cg(c[q>>2]|0,c[F>>2]|0,c[C>>2]|0,H,I,1104,c[K>>2]|0,c[T>>2]|0);T=c[q>>2]|0;if(c[Z>>2]|0)c[G>>2]=RL(T,R)|0;else c[G>>2]=SL(T,R)|0;if((c[u>>2]|0)==2&(c[R>>2]|0)>4){u=(c[G>>2]|0)+16|0;T=c[G>>2]|0;c[u>>2]=c[T>>2];c[u+4>>2]=c[T+4>>2];c[u+8>>2]=c[T+8>>2];c[u+12>>2]=c[T+12>>2];T=(c[G>>2]|0)+48|0;u=(c[G>>2]|0)+32|0;Z=(c[G>>2]|0)+((c[R>>2]|0)-1<<4)|0;c[u>>2]=c[Z>>2];c[u+4>>2]=c[Z+4>>2];c[u+8>>2]=c[Z+8>>2];c[u+12>>2]=c[Z+12>>2];c[T>>2]=c[u>>2];c[T+4>>2]=c[u+4>>2];c[T+8>>2]=c[u+8>>2];c[T+12>>2]=c[u+12>>2];c[R>>2]=4}if(!(c[R>>2]|0)){i=m;return}if(((c[U>>2]|0)+(c[R>>2]|0)|0)>(c[12545]|0)){c[12545]=(c[U>>2]|0)+(c[R>>2]|0)<<1;c[12543]=eK(c[12543]|0,c[12545]<<4)|0}c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[R>>2]|0))break;u=c[U>>2]|0;c[U>>2]=u+1;T=(c[12543]|0)+(u<<4)|0;u=(c[G>>2]|0)+(c[O>>2]<<4)|0;c[T>>2]=c[u>>2];c[T+4>>2]=c[u+4>>2];c[T+8>>2]=c[u+8>>2];c[T+12>>2]=c[u+12>>2];c[O>>2]=(c[O>>2]|0)+1}eg(c[F>>2]|0,c[q>>2]|0);if(c[S>>2]|0)sa=c[((c[A>>2]&3|0)==2?A:A+-32|0)+28>>2]|0;else{A=c[C>>2]|0;sa=c[((c[c[C>>2]>>2]&3|0)==2?A:A+-32|0)+28>>2]|0}c[w>>2]=sa}if((c[t>>2]|0)==1){jN(c[D>>2]|0,c[w>>2]|0,c[12543]|0,c[U>>2]|0,50160);i=m;return}c[Q>>2]=(_(c[(c[p>>2]|0)+12>>2]|0,(c[t>>2]|0)-1|0)|0)/2|0;c[O>>2]=1;while(1){if((c[O>>2]|0)>=((c[U>>2]|0)-1|0))break;sa=(c[12543]|0)+(c[O>>2]<<4)|0;h[sa>>3]=+h[sa>>3]-+(c[Q>>2]|0);c[O>>2]=(c[O>>2]|0)+1}if((c[12545]|0)>(c[12546]|0)){c[12546]=c[12545];c[12544]=eK(c[12544]|0,c[12546]<<4)|0}c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[U>>2]|0))break;Q=(c[12544]|0)+(c[O>>2]<<4)|0;sa=(c[12543]|0)+(c[O>>2]<<4)|0;c[Q>>2]=c[sa>>2];c[Q+4>>2]=c[sa+4>>2];c[Q+8>>2]=c[sa+8>>2];c[Q+12>>2]=c[sa+12>>2];c[O>>2]=(c[O>>2]|0)+1}jN(c[D>>2]|0,c[w>>2]|0,c[12544]|0,c[U>>2]|0,50160);c[P>>2]=1;while(1){if((c[P>>2]|0)>=(c[t>>2]|0))break;c[C>>2]=c[(c[r>>2]|0)+((c[s>>2]|0)+(c[P>>2]|0)<<2)>>2];if(c[(c[(c[C>>2]|0)+8>>2]|0)+164>>2]&32){c[ka>>2]=B;c[la>>2]=c[(c[ka>>2]|0)+8>>2];Z4(c[la>>2]|0,c[(c[C>>2]|0)+8>>2]|0,176)|0;w=c[ka>>2]|0;D=c[C>>2]|0;c[w>>2]=c[D>>2];c[w+4>>2]=c[D+4>>2];c[w+8>>2]=c[D+8>>2];c[w+12>>2]=c[D+12>>2];c[w+16>>2]=c[D+16>>2];c[w+20>>2]=c[D+20>>2];c[w+24>>2]=c[D+24>>2];c[w+28>>2]=c[D+28>>2];c[(c[ka>>2]|0)+8>>2]=c[la>>2];D=c[C>>2]|0;w=c[ka>>2]|0;c[((c[c[ka>>2]>>2]&3|0)==3?w:w+32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2];D=c[C>>2]|0;w=c[ka>>2]|0;c[((c[c[ka>>2]>>2]&3|0)==2?w:w+-32|0)+28>>2]=c[((c[c[C>>2]>>2]&3|0)==3?D:D+32|0)+28>>2];ma=(c[(c[ka>>2]|0)+8>>2]|0)+16|0;na=(c[(c[C>>2]|0)+8>>2]|0)+56|0;oa=ma+40|0;do{c[ma>>2]=c[na>>2];ma=ma+4|0;na=na+4|0}while((ma|0)<(oa|0));ma=(c[(c[ka>>2]|0)+8>>2]|0)+56|0;na=(c[(c[C>>2]|0)+8>>2]|0)+16|0;oa=ma+40|0;do{c[ma>>2]=c[na>>2];ma=ma+4|0;na=na+4|0}while((ma|0)<(oa|0));a[(c[(c[ka>>2]|0)+8>>2]|0)+112>>0]=1;c[(c[(c[ka>>2]|0)+8>>2]|0)+116>>2]=c[C>>2];c[C>>2]=B}c[O>>2]=1;while(1){if((c[O>>2]|0)>=((c[U>>2]|0)-1|0))break;D=(c[12543]|0)+(c[O>>2]<<4)|0;h[D>>3]=+h[D>>3]+ +(c[(c[p>>2]|0)+12>>2]|0);c[O>>2]=(c[O>>2]|0)+1}c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[U>>2]|0))break;D=(c[12544]|0)+(c[O>>2]<<4)|0;w=(c[12543]|0)+(c[O>>2]<<4)|0;c[D>>2]=c[w>>2];c[D+4>>2]=c[w+4>>2];c[D+8>>2]=c[w+8>>2];c[D+12>>2]=c[w+12>>2];c[O>>2]=(c[O>>2]|0)+1}w=c[C>>2]|0;jN(c[C>>2]|0,c[((c[c[C>>2]>>2]&3|0)==2?w:w+-32|0)+28>>2]|0,c[12544]|0,c[U>>2]|0,50160);c[P>>2]=(c[P>>2]|0)+1}i=m;return}function Vf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[e>>2]=OA(c[d>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;if(((Fb[c[12540]&63](c[e>>2]|0)|0)&255|0)!=0?(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)Wf(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0);c[e>>2]=QA(c[d>>2]|0,c[e>>2]|0)|0}c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}i=b;return}function Wf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[j>>2]=c[(c[d>>2]|0)+4>>2];c[e>>2]=cK((c[j>>2]|0)*48|0)|0;c[f>>2]=c[e>>2];c[g>>2]=(c[c[d>>2]>>2]|0)+(((c[j>>2]|0)-1|0)*48|0);c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[j>>2]|0))break;a=c[g>>2]|0;c[g>>2]=a+-48;k=c[f>>2]|0;c[f>>2]=k+48;Xf(a,k);c[h>>2]=(c[h>>2]|0)+1}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[j>>2]|0))break;O4(c[(c[c[d>>2]>>2]|0)+((c[h>>2]|0)*48|0)>>2]|0);c[h>>2]=(c[h>>2]|0)+1}O4(c[c[d>>2]>>2]|0);c[c[d>>2]>>2]=c[e>>2];i=b;return}function Xf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;c[l>>2]=c[(c[e>>2]|0)+4>>2];c[g>>2]=cK(c[l>>2]<<4)|0;c[h>>2]=c[g>>2];c[j>>2]=(c[c[e>>2]>>2]|0)+((c[l>>2]|0)-1<<4);c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[l>>2]|0))break;b=c[h>>2]|0;c[h>>2]=b+16;a=c[j>>2]|0;c[j>>2]=a+-16;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[k>>2]=(c[k>>2]|0)+1}c[c[f>>2]>>2]=c[g>>2];c[(c[f>>2]|0)+4>>2]=c[l>>2];c[(c[f>>2]|0)+8>>2]=c[(c[e>>2]|0)+12>>2];c[(c[f>>2]|0)+12>>2]=c[(c[e>>2]|0)+8>>2];l=(c[f>>2]|0)+16|0;g=(c[e>>2]|0)+32|0;c[l>>2]=c[g>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];g=(c[f>>2]|0)+32|0;f=(c[e>>2]|0)+16|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];i=d;return}function Yf(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0;j=i;i=i+240|0;k=j+176|0;l=j+160|0;m=j+144|0;n=j+228|0;o=j+224|0;p=j+220|0;q=j+216|0;r=j+212|0;s=j+208|0;t=j+204|0;u=j+200|0;v=j+196|0;w=j+192|0;x=j+128|0;y=j+112|0;z=j+96|0;A=j+80|0;B=j+72|0;C=j+64|0;D=j+48|0;E=j+32|0;F=j+16|0;G=j;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[w>>2]=c[p>>2];while(1){H=c[w>>2]|0;if(!(a[(c[(c[w>>2]|0)+8>>2]|0)+112>>0]|0))break;c[w>>2]=c[(c[H+8>>2]|0)+116>>2]}g=c[w>>2]|0;c[u>>2]=c[((c[H>>2]&3|0)==2?g:g+-32|0)+28>>2];g=c[w>>2]|0;c[v>>2]=c[((c[c[w>>2]>>2]&3|0)==3?g:g+32|0)+28>>2];g=(c[(c[(c[u>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[v>>2]|0)+8>>2]|0)+232>>2]|0)|0;c[s>>2]=((c[(c[(c[u>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[v>>2]|0)+8>>2]|0)+232>>2]|0)|0)>=0?g:0-g|0;do if((c[s>>2]|0)!=1){if((c[s>>2]|0)==2?(d[(c[(c[o>>2]|0)+8>>2]|0)+113>>0]&1|0)!=0:0)break;g=c[p>>2]|0;H=c[w>>2]|0;if((c[((c[c[p>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)==(c[((c[c[w>>2]>>2]&3|0)==3?H:H+32|0)+28>>2]|0)){c[c[r>>2]>>2]=c[u>>2];H=(c[(c[v>>2]|0)+8>>2]|0)+16|0;g=(c[(c[w>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[H>>2];c[l+4>>2]=c[H+4>>2];c[l+8>>2]=c[H+8>>2];c[l+12>>2]=c[H+12>>2];c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];og(D,l,k);c[x>>2]=c[D>>2];c[x+4>>2]=c[D+4>>2];c[x+8>>2]=c[D+8>>2];c[x+12>>2]=c[D+12>>2];g=(c[(c[u>>2]|0)+8>>2]|0)+16|0;H=(c[(c[w>>2]|0)+8>>2]|0)+56|0;c[l>>2]=c[g>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];c[k>>2]=c[H>>2];c[k+4>>2]=c[H+4>>2];c[k+8>>2]=c[H+8>>2];c[k+12>>2]=c[H+12>>2];og(E,l,k);c[y>>2]=c[E>>2];c[y+4>>2]=c[E+4>>2];c[y+8>>2]=c[E+8>>2];c[y+12>>2]=c[E+12>>2]}else{c[c[r>>2]>>2]=c[v>>2];H=(c[(c[u>>2]|0)+8>>2]|0)+16|0;g=(c[(c[w>>2]|0)+8>>2]|0)+56|0;c[l>>2]=c[H>>2];c[l+4>>2]=c[H+4>>2];c[l+8>>2]=c[H+8>>2];c[l+12>>2]=c[H+12>>2];c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];og(F,l,k);c[x>>2]=c[F>>2];c[x+4>>2]=c[F+4>>2];c[x+8>>2]=c[F+8>>2];c[x+12>>2]=c[F+12>>2];g=(c[(c[v>>2]|0)+8>>2]|0)+16|0;H=(c[(c[w>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[g>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];c[k>>2]=c[H>>2];c[k+4>>2]=c[H+4>>2];c[k+8>>2]=c[H+8>>2];c[k+12>>2]=c[H+12>>2];og(G,l,k);c[y>>2]=c[G>>2];c[y+4>>2]=c[G+4>>2];c[y+8>>2]=c[G+8>>2];c[y+12>>2]=c[G+12>>2]}if(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0){H=(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;c[A>>2]=c[H>>2];c[A+4>>2]=c[H+4>>2];c[A+8>>2]=c[H+8>>2];c[A+12>>2]=c[H+12>>2];if(c[(c[(qC(c[u>>2]|0)|0)+8>>2]|0)+116>>2]&1){h[B>>3]=+h[A+8>>3];h[C>>3]=+h[A>>3]}else{h[B>>3]=+h[A>>3];h[C>>3]=+h[A+8>>3]}H=(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;c[z>>2]=c[H>>2];c[z+4>>2]=c[H+4>>2];c[z+8>>2]=c[H+8>>2];c[z+12>>2]=c[H+12>>2];c[m>>2]=c[y>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[l>>2]=c[x>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[l+12>>2]=c[x+12>>2];c[k>>2]=c[z>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[k+12>>2]=c[z+12>>2];H=(pg(m,l,k)|0)!=0;I=+h[B>>3]/2.0;J=+h[z>>3];if(H){h[z>>3]=J+I;H=z+8|0;h[H>>3]=+h[H>>3]-+h[C>>3]/2.0}else{h[z>>3]=J-I;H=z+8|0;h[H>>3]=+h[H>>3]+ +h[C>>3]/2.0}H=(c[q>>2]|0)+16|0;g=c[q>>2]|0;c[g>>2]=c[x>>2];c[g+4>>2]=c[x+4>>2];c[g+8>>2]=c[x+8>>2];c[g+12>>2]=c[x+12>>2];c[H>>2]=c[g>>2];c[H+4>>2]=c[g+4>>2];c[H+8>>2]=c[g+8>>2];c[H+12>>2]=c[g+12>>2];g=(c[q>>2]|0)+32|0;H=(c[q>>2]|0)+48|0;f=(c[q>>2]|0)+64|0;c[f>>2]=c[z>>2];c[f+4>>2]=c[z+4>>2];c[f+8>>2]=c[z+8>>2];c[f+12>>2]=c[z+12>>2];c[H>>2]=c[f>>2];c[H+4>>2]=c[f+4>>2];c[H+8>>2]=c[f+8>>2];c[H+12>>2]=c[f+12>>2];c[g>>2]=c[H>>2];c[g+4>>2]=c[H+4>>2];c[g+8>>2]=c[H+8>>2];c[g+12>>2]=c[H+12>>2];H=(c[q>>2]|0)+80|0;g=(c[q>>2]|0)+96|0;c[g>>2]=c[y>>2];c[g+4>>2]=c[y+4>>2];c[g+8>>2]=c[y+8>>2];c[g+12>>2]=c[y+12>>2];c[H>>2]=c[g>>2];c[H+4>>2]=c[g+4>>2];c[H+8>>2]=c[g+8>>2];c[H+12>>2]=c[g+12>>2];c[t>>2]=7}else{g=(c[q>>2]|0)+16|0;H=c[q>>2]|0;c[H>>2]=c[x>>2];c[H+4>>2]=c[x+4>>2];c[H+8>>2]=c[x+8>>2];c[H+12>>2]=c[x+12>>2];c[g>>2]=c[H>>2];c[g+4>>2]=c[H+4>>2];c[g+8>>2]=c[H+8>>2];c[g+12>>2]=c[H+12>>2];H=(c[q>>2]|0)+48|0;g=(c[q>>2]|0)+32|0;c[g>>2]=c[y>>2];c[g+4>>2]=c[y+4>>2];c[g+8>>2]=c[y+8>>2];c[g+12>>2]=c[y+12>>2];c[H>>2]=c[g>>2];c[H+4>>2]=c[g+4>>2];c[H+8>>2]=c[g+8>>2];c[H+12>>2]=c[g+12>>2];c[t>>2]=4}c[n>>2]=c[t>>2];K=c[n>>2]|0;i=j;return K|0}while(0);c[n>>2]=0;K=c[n>>2]|0;i=j;return K|0}function Zf(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0;k=i;i=i+96|0;l=k+80|0;m=k+76|0;n=k+72|0;o=k+68|0;p=k+64|0;q=k+40|0;r=k+32|0;s=k+60|0;t=k+56|0;u=k+52|0;v=k+48|0;w=k;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=j;c[t>>2]=0;c[s>>2]=0;h[q>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[n>>2]|0)+8>>2]|0)+88>>3]-4.0;j=kg(c[l>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,-1)|0;c[u>>2]=j;if(j){j=lg(c[l>>2]|0,c[n>>2]|0,c[u>>2]|0)|0;c[s>>2]=j;do if(!j){h[r>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+240>>3];if(!(a[(c[(c[u>>2]|0)+8>>2]|0)+156>>0]|0)){h[r>>3]=+h[r>>3]+ +(c[(c[(c[l>>2]|0)+8>>2]|0)+248>>2]|0)/2.0;break}else{h[r>>3]=+h[r>>3]+ +(c[(c[m>>2]|0)+8>>2]|0);break}}else h[r>>3]=+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16>>3]+ +(c[(c[m>>2]|0)+8>>2]|0);while(0);if(+h[r>>3]<+h[q>>3])h[q>>3]=+h[r>>3];x=+h[q>>3];h[w>>3]=+(~~(+h[q>>3]>=0.0?x+.5:x-.5)|0)}else{x=+h[q>>3];if((~~(+h[q>>3]>=0.0?x+.5:x-.5)|0)<(c[c[m>>2]>>2]|0)){x=+h[q>>3];y=~~(+h[q>>3]>=0.0?x+.5:x-.5)}else y=c[c[m>>2]>>2]|0;h[w>>3]=+(y|0)}if((a[(c[(c[n>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[n>>2]|0)+8>>2]|0)+104>>2]|0)!=0:0)h[q>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3]+10.0;else h[q>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[n>>2]|0)+8>>2]|0)+96>>3]+4.0;y=kg(c[l>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,1)|0;c[v>>2]=y;if(y){y=lg(c[l>>2]|0,c[n>>2]|0,c[v>>2]|0)|0;c[t>>2]=y;do if(!y){h[r>>3]=+h[(c[(c[v>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[v>>2]|0)+8>>2]|0)+88>>3];if(!(a[(c[(c[v>>2]|0)+8>>2]|0)+156>>0]|0)){h[r>>3]=+h[r>>3]-+(c[(c[(c[l>>2]|0)+8>>2]|0)+248>>2]|0)/2.0;break}else{h[r>>3]=+h[r>>3]-+(c[(c[m>>2]|0)+8>>2]|0);break}}else h[r>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+16>>3]-+(c[(c[m>>2]|0)+8>>2]|0);while(0);if(+h[r>>3]>+h[q>>3])h[q>>3]=+h[r>>3];x=+h[q>>3];h[w+16>>3]=+(~~(+h[q>>3]>=0.0?x+.5:x-.5)|0)}else{x=+h[q>>3];if((~~(+h[q>>3]>=0.0?x+.5:x-.5)|0)>(c[(c[m>>2]|0)+4>>2]|0)){x=+h[q>>3];z=~~(+h[q>>3]>=0.0?x+.5:x-.5)}else z=c[(c[m>>2]|0)+4>>2]|0;h[w+16>>3]=+(z|0)}if(((a[(c[(c[n>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[n>>2]|0)+8>>2]|0)+104>>2]|0)!=0:0)?(z=w+16|0,h[z>>3]=+h[z>>3]-+h[(c[(c[n>>2]|0)+8>>2]|0)+96>>3],+h[w+16>>3]<+h[w>>3]):0)h[w+16>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3];h[w+8>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[n>>2]|0)+8>>2]|0)+232>>2]<<6)+16>>3];h[w+16+8>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[n>>2]|0)+8>>2]|0)+232>>2]<<6)+24>>3];c[b>>2]=c[w>>2];c[b+4>>2]=c[w+4>>2];c[b+8>>2]=c[w+8>>2];c[b+12>>2]=c[w+12>>2];c[b+16>>2]=c[w+16>>2];c[b+20>>2]=c[w+20>>2];c[b+24>>2]=c[w+24>>2];c[b+28>>2]=c[w+28>>2];i=k;return}function _f(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if((a[(c[(c[e>>2]|0)+8>>2]|0)+156>>0]|0)==1)if((c[(c[(c[e>>2]|0)+8>>2]|0)+172+4>>2]|0)>1)f=1;else f=(c[(c[(c[e>>2]|0)+8>>2]|0)+180+4>>2]|0)>1;else f=0;i=d;return f&1|0}function $f(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+112|0;g=f+104|0;j=f+96|0;k=f+64|0;l=f+32|0;m=f;c[g>>2]=d;h[j>>3]=e;switch(c[g>>2]|0){case 1:{jg(l,+h[b>>3],+h[j>>3],+h[b+16>>3],+h[b+8>>3]);c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];c[k+24>>2]=c[l+24>>2];c[k+28>>2]=c[l+28>>2];break}case 4:{jg(m,+h[b>>3],+h[b+16+8>>3],+h[b+16>>3],+h[j>>3]);c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];c[k+16>>2]=c[m+16>>2];c[k+20>>2]=c[m+20>>2];c[k+24>>2]=c[m+24>>2];c[k+28>>2]=c[m+28>>2];break}default:{}}c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[a+16>>2]=c[k+16>>2];c[a+20>>2]=c[k+20>>2];c[a+24>>2]=c[k+24>>2];c[a+28>>2]=c[k+28>>2];i=f;return}function ag(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+64|0;g=f+48|0;j=f+44|0;k=f+40|0;l=f;m=f+36|0;n=f+32|0;c[g>>2]=b;c[j>>2]=d;c[k>>2]=e;e=(c[(c[g>>2]|0)+16>>2]|0)+(c[k>>2]<<5)|0;c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];c[l+16>>2]=c[e+16>>2];c[l+20>>2]=c[e+20>>2];c[l+24>>2]=c[e+24>>2];c[l+28>>2]=c[e+28>>2];if(!(+h[l>>3]==+h[l+16>>3])){c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];c[a+16>>2]=c[l+16>>2];c[a+20>>2]=c[l+20>>2];c[a+24>>2]=c[l+24>>2];c[a+28>>2]=c[l+28>>2];i=f;return}c[m>>2]=c[c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]>>2];c[n>>2]=c[c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+((c[k>>2]|0)+1<<6)+4>>2]>>2];h[l>>3]=+(c[c[g>>2]>>2]|0);h[l+8>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+((c[k>>2]|0)+1<<6)+24>>3];h[l+16>>3]=+(c[(c[g>>2]|0)+4>>2]|0);h[l+16+8>>3]=+h[(c[(c[m>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+16>>3];j=(c[(c[g>>2]|0)+16>>2]|0)+(c[k>>2]<<5)|0;c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[j+16>>2]=c[l+16>>2];c[j+20>>2]=c[l+20>>2];c[j+24>>2]=c[l+24>>2];c[j+28>>2]=c[l+28>>2];c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];c[a+16>>2]=c[l+16>>2];c[a+20>>2]=c[l+20>>2];c[a+24>>2]=c[l+24>>2];c[a+28>>2]=c[l+28>>2];i=f;return}function bg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=b;c[f>>2]=0;c[g>>2]=c[e>>2];while(1){b=c[c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]>>2]|0;c[g>>2]=c[((c[c[c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];if((a[(c[(c[g>>2]|0)+8>>2]|0)+156>>0]|0)!=1){j=7;break}if((c[(c[(c[g>>2]|0)+8>>2]|0)+180+4>>2]|0)!=1){j=7;break}if((c[(c[(c[g>>2]|0)+8>>2]|0)+172+4>>2]|0)!=1){j=7;break}if(+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3]!=+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]){j=7;break}c[f>>2]=(c[f>>2]|0)+1}if((j|0)==7){i=d;return c[f>>2]|0}return 0}function cg(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;k=i;i=i+112|0;l=k;m=k+100|0;n=k+96|0;o=k+92|0;p=k+88|0;q=k+84|0;r=k+80|0;s=k+76|0;t=k+68|0;u=k+64|0;v=k+60|0;w=k+56|0;x=k+52|0;y=k+48|0;z=k+44|0;A=k+40|0;B=k+36|0;C=k+32|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[k+72>>2]=j;c[z>>2]=-1;c[y>>2]=-1;c[u>>2]=0;c[t>>2]=0;c[t>>2]=gg(c[n>>2]|0,-1)|0;c[u>>2]=gg(c[n>>2]|0,1)|0;do if(c[t>>2]|0){n=tN(c[t>>2]|0)|0;c[A>>2]=n;if(n){c[B>>2]=c[c[c[A>>2]>>2]>>2];c[C>>2]=c[(c[c[A>>2]>>2]|0)+4>>2];break}else{i=k;return}}while(0);do if(c[u>>2]|0){t=tN(c[u>>2]|0)|0;c[A>>2]=t;if(t){c[B>>2]=c[c[c[A>>2]>>2]>>2];c[C>>2]=c[(c[c[A>>2]>>2]|0)+4>>2];break}else{i=k;return}}while(0);c[w>>2]=0;c[v>>2]=0;c[v>>2]=hg(c[o>>2]|0,-1)|0;c[w>>2]=hg(c[o>>2]|0,1)|0;do if(c[v>>2]|0){o=tN(c[v>>2]|0)|0;c[A>>2]=o;if(o){c[B>>2]=c[(c[c[A>>2]>>2]|0)+(((c[(c[A>>2]|0)+4>>2]|0)-1|0)*48|0)>>2];c[C>>2]=c[(c[c[A>>2]>>2]|0)+(((c[(c[A>>2]|0)+4>>2]|0)-1|0)*48|0)+4>>2];break}else{i=k;return}}while(0);do if(c[w>>2]|0){v=tN(c[w>>2]|0)|0;c[A>>2]=v;if(v){c[B>>2]=c[(c[c[A>>2]>>2]|0)+(((c[(c[A>>2]|0)+4>>2]|0)-1|0)*48|0)>>2];c[C>>2]=c[(c[c[A>>2]>>2]|0)+(((c[(c[A>>2]|0)+4>>2]|0)-1|0)*48|0)+4>>2];break}else{i=k;return}}while(0);c[x>>2]=0;while(1){D=c[m>>2]|0;if((c[x>>2]|0)>=(c[(c[p>>2]|0)+52>>2]|0))break;A=(c[p>>2]|0)+56+(c[x>>2]<<5)|0;c[l>>2]=c[A>>2];c[l+4>>2]=c[A+4>>2];c[l+8>>2]=c[A+8>>2];c[l+12>>2]=c[A+12>>2];c[l+16>>2]=c[A+16>>2];c[l+20>>2]=c[A+20>>2];c[l+24>>2]=c[A+24>>2];c[l+28>>2]=c[A+28>>2];kN(D,l);c[x>>2]=(c[x>>2]|0)+1}c[y>>2]=(c[D+80>>2]|0)+1;c[z>>2]=(c[y>>2]|0)+(c[s>>2]|0)-3;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[s>>2]|0))break;D=c[m>>2]|0;p=(c[r>>2]|0)+(c[x>>2]<<5)|0;c[l>>2]=c[p>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[l+12>>2]=c[p+12>>2];c[l+16>>2]=c[p+16>>2];c[l+20>>2]=c[p+20>>2];c[l+24>>2]=c[p+24>>2];c[l+28>>2]=c[p+28>>2];kN(D,l);c[x>>2]=(c[x>>2]|0)+1}c[x>>2]=(c[(c[q>>2]|0)+52>>2]|0)-1;while(1){E=c[m>>2]|0;if((c[x>>2]|0)<0)break;r=(c[q>>2]|0)+56+(c[x>>2]<<5)|0;c[l>>2]=c[r>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[l+12>>2]=c[r+12>>2];c[l+16>>2]=c[r+16>>2];c[l+20>>2]=c[r+20>>2];c[l+24>>2]=c[r+24>>2];c[l+28>>2]=c[r+28>>2];kN(E,l);c[x>>2]=(c[x>>2]|0)+-1}ig(E,c[y>>2]|0,c[z>>2]|0);i=k;return}function dg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[c[k>>2]>>2];c[m>>2]=c[g>>2];while(1){g=c[h>>2]|0;c[h>>2]=g+-1;if(!g)break;g=c[m>>2]|0;c[m>>2]=c[c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2]}h=c[k>>2]|0;g=c[h>>2]|0;c[h>>2]=g+1;h=(c[j>>2]|0)+(g<<4)|0;g=(c[j>>2]|0)+((c[l>>2]|0)-1<<4)|0;c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];c[h+12>>2]=c[g+12>>2];g=c[k>>2]|0;h=c[g>>2]|0;c[g>>2]=h+1;g=(c[j>>2]|0)+(h<<4)|0;h=(c[j>>2]|0)+((c[l>>2]|0)-1<<4)|0;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[g+12>>2]=c[h+12>>2];h=(c[j>>2]|0)+(c[c[k>>2]>>2]<<4)|0;k=c[m>>2]|0;j=(c[(c[((c[c[m>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)+8>>2]|0)+16|0;c[h>>2]=c[j>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];i=f;return c[m>>2]|0}function eg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;c[j>>2]=0;d=c[f>>2]|0;c[k>>2]=c[((c[c[f>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];while(1){if((a[(c[(c[k>>2]|0)+8>>2]|0)+156>>0]|0)!=1){l=14;break}if(!((Fb[c[50164>>2]&63](c[k>>2]|0)|0)<<24>>24!=0^1)){l=14;break}while(1){if((c[j>>2]|0)<(c[(c[g>>2]|0)+80>>2]|0))m=+h[(c[(c[g>>2]|0)+84>>2]|0)+(c[j>>2]<<5)+8>>3]>+h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3];else m=0;n=c[j>>2]|0;if(!m)break;c[j>>2]=n+1}if((n|0)>=(c[(c[g>>2]|0)+80>>2]|0)){l=14;break}do if(!(+h[(c[(c[g>>2]|0)+84>>2]|0)+(c[j>>2]<<5)+16+8>>3]<+h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3])){d=c[k>>2]|0;f=~~+h[(c[(c[g>>2]|0)+84>>2]|0)+(c[j>>2]<<5)>>3];b=(c[(c[g>>2]|0)+84>>2]|0)+(c[j>>2]<<5)|0;if(c[(c[(c[k>>2]|0)+8>>2]|0)+104>>2]|0){fg(d,f,~~+h[b+16>>3],~~(+h[(c[(c[g>>2]|0)+84>>2]|0)+(c[j>>2]<<5)+16>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3]));break}else{fg(d,f,~~((+h[b>>3]+ +h[(c[(c[g>>2]|0)+84>>2]|0)+(c[j>>2]<<5)+16>>3])/2.0),~~+h[(c[(c[g>>2]|0)+84>>2]|0)+(c[j>>2]<<5)+16>>3]);break}}while(0);b=c[c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]>>2]|0;c[k>>2]=c[((c[c[c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]}if((l|0)==14){i=e;return}}function fg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3]=+(c[k>>2]|0);h[(c[(c[g>>2]|0)+8>>2]|0)+88>>3]=+((c[k>>2]|0)-(c[j>>2]|0)|0);h[(c[(c[g>>2]|0)+8>>2]|0)+96>>3]=+((c[l>>2]|0)-(c[k>>2]|0)|0);i=f;return}function gg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=0;c[j>>2]=0;while(1){b=c[e>>2]|0;a=c[(c[(c[(c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+180>>2]|0)+(c[j>>2]<<2)>>2]|0;c[g>>2]=a;if(!a)break;a=c[g>>2]|0;b=c[e>>2]|0;do if((_(c[f>>2]|0,(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[((c[c[e>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)|0)|0)>0){if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)){if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]|0))break;if(!(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]|0)+8>>2]|0)+8>>2]|0))break}if((c[h>>2]|0)!=0?(k=c[h>>2]|0,l=c[g>>2]|0,(_(c[f>>2]|0,(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)|0)|0)<=0):0)break;c[h>>2]=c[g>>2]}while(0);c[j>>2]=(c[j>>2]|0)+1}i=d;return c[h>>2]|0}function hg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=0;c[j>>2]=0;while(1){b=c[e>>2]|0;a=c[(c[(c[(c[((c[c[e>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(c[j>>2]<<2)>>2]|0;c[g>>2]=a;if(!a)break;a=c[g>>2]|0;b=c[e>>2]|0;do if((_(c[f>>2]|0,(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)|0)|0)>0){if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)){if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]|0))break;if(!(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]|0)+8>>2]|0)+8>>2]|0))break}if((c[h>>2]|0)!=0?(k=c[h>>2]|0,l=c[g>>2]|0,(_(c[f>>2]|0,(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)|0)|0)<=0):0)break;c[h>>2]=c[g>>2]}while(0);c[j>>2]=(c[j>>2]|0)+1}i=d;return c[h>>2]|0}function ig(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[m>>2]=(c[g>>2]|0)-1;while(1){if((c[m>>2]|0)>=((c[j>>2]|0)+1|0))break;c[k>>2]=(c[(c[f>>2]|0)+84>>2]|0)+(c[m>>2]<<5);o=+h[c[k>>2]>>3];if(!(((c[m>>2]|0)-(c[g>>2]|0)|0)%2|0)){if(o>=+h[(c[k>>2]|0)+16>>3]){c[n>>2]=~~((+h[c[k>>2]>>3]+ +h[(c[k>>2]|0)+16>>3])/2.0);h[c[k>>2]>>3]=+((c[n>>2]|0)-8|0);h[(c[k>>2]|0)+16>>3]=+((c[n>>2]|0)+8|0)}}else if(o+16.0>+h[(c[k>>2]|0)+16>>3]){c[n>>2]=~~((+h[c[k>>2]>>3]+ +h[(c[k>>2]|0)+16>>3])/2.0);h[c[k>>2]>>3]=+((c[n>>2]|0)-8|0);h[(c[k>>2]|0)+16>>3]=+((c[n>>2]|0)+8|0)}c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=((c[(c[f>>2]|0)+80>>2]|0)-1|0))break;c[k>>2]=(c[(c[f>>2]|0)+84>>2]|0)+(c[m>>2]<<5);c[l>>2]=(c[(c[f>>2]|0)+84>>2]|0)+((c[m>>2]|0)+1<<5);if(((c[m>>2]|0)>=(c[g>>2]|0)?(c[m>>2]|0)<=(c[j>>2]|0):0)?(((c[m>>2]|0)-(c[g>>2]|0)|0)%2|0|0)==0:0){if(+h[c[k>>2]>>3]+16.0>+h[(c[l>>2]|0)+16>>3])h[(c[l>>2]|0)+16>>3]=+h[c[k>>2]>>3]+16.0;if(+h[(c[k>>2]|0)+16>>3]-16.0<+h[c[l>>2]>>3])h[c[l>>2]>>3]=+h[(c[k>>2]|0)+16>>3]-16.0}else p=18;if((((p|0)==18?(p=0,((c[m>>2]|0)+1|0)>=(c[g>>2]|0)):0)?(c[m>>2]|0)<(c[j>>2]|0):0)?(((c[m>>2]|0)+1-(c[g>>2]|0)|0)%2|0|0)==0:0){if(+h[c[k>>2]>>3]+16.0>+h[(c[l>>2]|0)+16>>3])h[c[k>>2]>>3]=+h[(c[l>>2]|0)+16>>3]-16.0;if(+h[(c[k>>2]|0)+16>>3]-16.0<+h[c[l>>2]>>3])h[(c[k>>2]|0)+16>>3]=+h[c[l>>2]>>3]+16.0}c[m>>2]=(c[m>>2]|0)+1}i=e;return}function jg(a,b,d,e,f){a=a|0;b=+b;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+64|0;j=g+56|0;k=g+48|0;l=g+40|0;m=g+32|0;n=g;h[j>>3]=b;h[k>>3]=d;h[l>>3]=e;h[m>>3]=f;h[n>>3]=+h[j>>3];h[n+8>>3]=+h[k>>3];h[n+16>>3]=+h[l>>3];h[n+16+8>>3]=+h[m>>3];c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];c[a+16>>2]=c[n+16>>2];c[a+20>>2]=c[n+20>>2];c[a+24>>2]=c[n+24>>2];c[a+28>>2]=c[n+28>>2];i=g;return}function kg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[q>>2]=0;c[r>>2]=(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]<<6);c[o>>2]=(c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]|0)+(c[n>>2]|0);while(1){if((c[o>>2]|0)<0){s=12;break}if((c[o>>2]|0)>=(c[c[r>>2]>>2]|0)){s=12;break}c[p>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+(c[o>>2]<<2)>>2];if((a[(c[(c[p>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[p>>2]|0)+8>>2]|0)+104>>2]|0)!=0:0){s=6;break}t=c[p>>2]|0;if(!(a[(c[(c[p>>2]|0)+8>>2]|0)+156>>0]|0)){s=8;break}if(!((ng(t,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0)&255)){s=10;break}c[o>>2]=(c[o>>2]|0)+(c[n>>2]|0)}if((s|0)==6){c[q>>2]=c[p>>2];u=c[q>>2]|0;i=h;return u|0}else if((s|0)==8){c[q>>2]=t;u=c[q>>2]|0;i=h;return u|0}else if((s|0)==10){c[q>>2]=c[p>>2];u=c[q>>2]|0;i=h;return u|0}else if((s|0)==12){u=c[q>>2]|0;i=h;return u|0}return 0}function lg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[k>>2]=0;e=c[(c[h>>2]|0)+8>>2]|0;if(!(a[(c[(c[h>>2]|0)+8>>2]|0)+156>>0]|0)){h=c[e+212>>2]|0;c[n>>2]=h;c[m>>2]=h}else{c[o>>2]=c[(c[(c[c[e+180>>2]>>2]|0)+8>>2]|0)+116>>2];e=c[o>>2]|0;c[m>>2]=c[(c[(c[((c[c[o>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+212>>2];e=c[o>>2]|0;c[n>>2]=c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+212>>2]}e=c[(c[j>>2]|0)+8>>2]|0;if(!(a[(c[(c[j>>2]|0)+8>>2]|0)+156>>0]|0)){if((c[e+212>>2]|0)==(c[g>>2]|0))p=0;else p=c[(c[(c[j>>2]|0)+8>>2]|0)+212>>2]|0;c[l>>2]=p;if(!(c[l>>2]|0)){q=c[k>>2]|0;i=f;return q|0}if((c[l>>2]|0)==(c[m>>2]|0)){q=c[k>>2]|0;i=f;return q|0}if((c[l>>2]|0)==(c[n>>2]|0)){q=c[k>>2]|0;i=f;return q|0}c[k>>2]=c[l>>2];q=c[k>>2]|0;i=f;return q|0}c[o>>2]=c[(c[(c[c[e+180>>2]>>2]|0)+8>>2]|0)+116>>2];e=c[o>>2]|0;if((c[(c[(c[((c[c[o>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)==(c[g>>2]|0))r=0;else{e=c[o>>2]|0;r=c[(c[(c[((c[c[o>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0}c[l>>2]=r;if((((c[l>>2]|0)!=0?(c[l>>2]|0)!=(c[m>>2]|0):0)?(c[l>>2]|0)!=(c[n>>2]|0):0)?(mg(c[l>>2]|0,c[j>>2]|0)|0)!=0:0){c[k>>2]=c[l>>2];q=c[k>>2]|0;i=f;return q|0}r=c[o>>2]|0;if((c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)==(c[g>>2]|0))s=0;else{g=c[o>>2]|0;s=c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0}c[l>>2]=s;if(!(c[l>>2]|0)){q=c[k>>2]|0;i=f;return q|0}if((c[l>>2]|0)==(c[m>>2]|0)){q=c[k>>2]|0;i=f;return q|0}if((c[l>>2]|0)==(c[n>>2]|0)){q=c[k>>2]|0;i=f;return q|0}if(!(mg(c[l>>2]|0,c[j>>2]|0)|0)){q=c[k>>2]|0;i=f;return q|0}c[k>>2]=c[l>>2];q=c[k>>2]|0;i=f;return q|0}function mg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]<=+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3])){g=0;j=g&1;i=d;return j|0}if(!(+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]<=+h[(c[(c[e>>2]|0)+8>>2]|0)+16+16>>3])){g=0;j=g&1;i=d;return j|0}if(!(+h[(c[(c[e>>2]|0)+8>>2]|0)+16+8>>3]<=+h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3])){g=0;j=g&1;i=d;return j|0}g=+h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]<=+h[(c[(c[e>>2]|0)+8>>2]|0)+16+16+8>>3];j=g&1;i=d;return j|0}function ng(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+12|0;q=g+8|0;r=g+4|0;s=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[r>>2]=(c[(c[(c[j>>2]|0)+8>>2]|0)+236>>2]|0)>(c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]|0)&1;if((c[(c[(c[j>>2]|0)+8>>2]|0)+180+4>>2]|0)!=1?(c[(c[(c[j>>2]|0)+8>>2]|0)+180+4>>2]|0)!=1:0){a[h>>0]=0;t=a[h>>0]|0;i=g;return t|0}c[o>>2]=c[m>>2];a:do if((c[o>>2]|0)!=0?(c[(c[(c[j>>2]|0)+8>>2]|0)+180+4>>2]|0)==1:0){c[n>>2]=c[c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>=2)break a;m=c[n>>2]|0;k=c[((c[c[n>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0;c[p>>2]=k;m=c[o>>2]|0;f=c[((c[c[o>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0;c[q>>2]=f;if((k|0)==(f|0))break a;if((c[r>>2]|0)!=((c[(c[(c[p>>2]|0)+8>>2]|0)+236>>2]|0)>(c[(c[(c[q>>2]|0)+8>>2]|0)+236>>2]|0)|0))break;if((c[(c[(c[p>>2]|0)+8>>2]|0)+180+4>>2]|0)!=1)break a;if(!(a[(c[(c[p>>2]|0)+8>>2]|0)+156>>0]|0))break a;c[n>>2]=c[c[(c[(c[p>>2]|0)+8>>2]|0)+180>>2]>>2];if((c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]|0)!=1)break a;if(!(a[(c[(c[q>>2]|0)+8>>2]|0)+156>>0]|0))break a;c[o>>2]=c[c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]>>2];c[s>>2]=(c[s>>2]|0)+1}a[h>>0]=1;t=a[h>>0]|0;i=g;return t|0}while(0);c[o>>2]=c[l>>2];b:do if((c[o>>2]|0)!=0?(c[(c[(c[j>>2]|0)+8>>2]|0)+172+4>>2]|0)==1:0){c[n>>2]=c[c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2]>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>=2)break b;l=c[n>>2]|0;f=c[((c[c[n>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0;c[p>>2]=f;l=c[o>>2]|0;k=c[((c[c[o>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0;c[q>>2]=k;if((f|0)==(k|0))break b;if((c[r>>2]|0)!=((c[(c[(c[p>>2]|0)+8>>2]|0)+236>>2]|0)>(c[(c[(c[q>>2]|0)+8>>2]|0)+236>>2]|0)|0))break;if((c[(c[(c[p>>2]|0)+8>>2]|0)+172+4>>2]|0)!=1)break b;if(!(a[(c[(c[p>>2]|0)+8>>2]|0)+156>>0]|0))break b;c[n>>2]=c[c[(c[(c[p>>2]|0)+8>>2]|0)+172>>2]>>2];if((c[(c[(c[q>>2]|0)+8>>2]|0)+172+4>>2]|0)!=1)break b;if(!(a[(c[(c[q>>2]|0)+8>>2]|0)+156>>0]|0))break b;c[o>>2]=c[c[(c[(c[q>>2]|0)+8>>2]|0)+172>>2]>>2];c[s>>2]=(c[s>>2]|0)+1}a[h>>0]=1;t=a[h>>0]|0;i=g;return t|0}while(0);a[h>>0]=0;t=a[h>>0]|0;i=g;return t|0}function og(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]+ +h[d>>3];h[f+8>>3]=+h[b+8>>3]+ +h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function pg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=~~((+h[a+8>>3]-+h[b+8>>3])*(+h[d>>3]-+h[b>>3])-(+h[d+8>>3]-+h[b+8>>3])*(+h[a>>3]-+h[b>>3]));i=e;return (c[f>>2]|0)>0|0}function qg(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0;m=i;i=i+352|0;n=m+208|0;o=m+192|0;p=m+336|0;q=m+328|0;r=m+324|0;s=m+320|0;t=m+316|0;u=m+312|0;v=m+308|0;w=m+304|0;x=m+300|0;y=m+296|0;z=m+292|0;A=m+288|0;B=m+284|0;C=m+280|0;D=m+276|0;E=m+272|0;F=m+268|0;G=m+264|0;H=m+260|0;I=m+256|0;J=m+252|0;K=m+248|0;L=m+244|0;M=m+176|0;N=m+240|0;O=m+236|0;P=m+232|0;Q=m+228|0;R=m+224|0;S=m+160|0;T=m+144|0;U=m+80|0;V=m+64|0;W=m+48|0;X=m+32|0;Y=m+16|0;Z=m;c[p>>2]=b;c[m+332>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;c[t>>2]=k;c[u>>2]=l;c[z>>2]=0;c[A>>2]=0;c[N>>2]=0;l=c[t>>2]|0;c[w>>2]=c[((c[c[t>>2]>>2]&3|0)==3?l:l+32|0)+28>>2];l=c[t>>2]|0;c[x>>2]=c[((c[c[t>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2];c[G>>2]=0;while(1){if((c[G>>2]|0)>=(c[s>>2]|0))break;c[y>>2]=c[(c[q>>2]|0)+((c[r>>2]|0)+(c[G>>2]|0)<<2)>>2];if(c[(c[(c[y>>2]|0)+8>>2]|0)+96>>2]|0)c[z>>2]=(c[z>>2]|0)+1;if(!((d[(c[(c[y>>2]|0)+8>>2]|0)+16+28>>0]|0)==0?(d[(c[(c[y>>2]|0)+8>>2]|0)+56+28>>0]|0)==0:0))c[A>>2]=1;c[G>>2]=(c[G>>2]|0)+1}if(!(c[A>>2]|0)){A=c[w>>2]|0;l=c[x>>2]|0;t=c[q>>2]|0;k=c[r>>2]|0;j=c[s>>2]|0;g=c[u>>2]|0;if(!(c[z>>2]|0)){sg(A,l,t,k,j,g);i=m;return}else{xg(A,l,t,k,j,g,c[z>>2]|0);i=m;return}}c[O>>2]=bK(156)|0;c[B>>2]=yg(c[p>>2]|0,c[O>>2]|0)|0;c[C>>2]=FD(c[B>>2]|0,122540,1)|0;MC(c[C>>2]|0,175049,280,1)|0;AA(c[C>>2]|0,124202,124216)|0;c[L>>2]=~~+h[(c[(c[x>>2]|0)+8>>2]|0)+16>>3];c[K>>2]=~~+h[(c[(c[w>>2]|0)+8>>2]|0)+16>>3];if(c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1){c[P>>2]=c[w>>2];c[w>>2]=c[x>>2];c[x>>2]=c[P>>2]}c[D>>2]=zg(c[C>>2]|0,c[w>>2]|0,c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1)|0;c[E>>2]=zg(c[B>>2]|0,c[x>>2]|0,c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1)|0;c[G>>2]=0;while(1){if((c[G>>2]|0)>=(c[s>>2]|0))break;c[y>>2]=c[(c[q>>2]|0)+((c[r>>2]|0)+(c[G>>2]|0)<<2)>>2];while(1){_=c[y>>2]|0;if(!(a[(c[(c[y>>2]|0)+8>>2]|0)+112>>0]|0))break;c[y>>2]=c[(c[_+8>>2]|0)+116>>2]}C=c[y>>2]|0;P=c[B>>2]|0;if((c[((c[_>>2]&3|0)==3?C:C+32|0)+28>>2]|0)==(c[w>>2]|0))c[F>>2]=Ag(P,c[D>>2]|0,c[E>>2]|0,c[y>>2]|0)|0;else c[F>>2]=Ag(P,c[E>>2]|0,c[D>>2]|0,c[y>>2]|0)|0;c[(c[(c[y>>2]|0)+8>>2]|0)+120>>2]=c[F>>2];if(((c[N>>2]|0)==0?(a[(c[(c[y>>2]|0)+8>>2]|0)+16+28>>0]|0)==0:0)?(a[(c[(c[y>>2]|0)+8>>2]|0)+56+28>>0]|0)==0:0){c[N>>2]=c[F>>2];c[(c[(c[N>>2]|0)+8>>2]|0)+120>>2]=c[y>>2]}c[G>>2]=(c[G>>2]|0)+1}if(!(c[N>>2]|0))c[N>>2]=VA(c[B>>2]|0,c[D>>2]|0,c[E>>2]|0,0,1)|0;BA(c[N>>2]|0,c[13851]|0,122544)|0;c[(c[(c[B>>2]|0)+8>>2]|0)+144>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+144>>2];c[(c[(c[B>>2]|0)+8>>2]|0)+188>>2]=c[B>>2];QO(c[B>>2]|0,c[u>>2]|0);rf(c[B>>2]|0);Ui(c[B>>2]|0,0);bh(c[B>>2]|0,0);fi(c[B>>2]|0,0);c[I>>2]=~~((+h[(c[(c[w>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[w>>2]|0)+8>>2]|0)+96>>3]+ +h[(c[(c[x>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[x>>2]|0)+8>>2]|0)+88>>3])/2.0);c[J>>2]=~~((+h[(c[(c[D>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[E>>2]|0)+8>>2]|0)+16>>3])/2.0);c[v>>2]=c[(c[(c[B>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[v>>2]|0))break;do if((c[v>>2]|0)!=(c[D>>2]|0))if((c[v>>2]|0)==(c[E>>2]|0)){h[(c[(c[v>>2]|0)+8>>2]|0)+16+8>>3]=+(c[K>>2]|0);h[(c[(c[v>>2]|0)+8>>2]|0)+16>>3]=+(c[J>>2]|0);break}else{h[(c[(c[v>>2]|0)+8>>2]|0)+16+8>>3]=+(c[I>>2]|0);break}else{h[(c[(c[v>>2]|0)+8>>2]|0)+16+8>>3]=+(c[L>>2]|0);h[(c[(c[v>>2]|0)+8>>2]|0)+16>>3]=+(c[J>>2]|0)}while(0);c[v>>2]=c[(c[(c[v>>2]|0)+8>>2]|0)+164>>2]}Oj(c[B>>2]|0);Mf(c[B>>2]|0,0);nL(c[B>>2]|0);$=+h[(c[(c[w>>2]|0)+8>>2]|0)+16>>3];v=(c[(c[D>>2]|0)+8>>2]|0)+16|0;if(c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1){h[M>>3]=$-+h[v+8>>3];h[M+8>>3]=+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[D>>2]|0)+8>>2]|0)+16>>3]}else{h[M>>3]=$-+h[v>>3];h[M+8>>3]=+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[D>>2]|0)+8>>2]|0)+16+8>>3]}c[G>>2]=0;while(1){if((c[G>>2]|0)>=(c[s>>2]|0))break;c[y>>2]=c[(c[q>>2]|0)+((c[r>>2]|0)+(c[G>>2]|0)<<2)>>2];while(1){aa=c[(c[y>>2]|0)+8>>2]|0;if(!(a[(c[(c[y>>2]|0)+8>>2]|0)+112>>0]|0))break;c[y>>2]=c[aa+116>>2]}c[F>>2]=c[aa+120>>2];if(!((c[F>>2]|0)==(c[N>>2]|0)&(((c[(c[(c[F>>2]|0)+8>>2]|0)+120>>2]|0)!=0^1)&1))){c[Q>>2]=c[c[(c[(c[F>>2]|0)+8>>2]|0)+8>>2]>>2];c[R>>2]=iN(c[y>>2]|0,c[(c[Q>>2]|0)+4>>2]|0)|0;c[(c[R>>2]|0)+8>>2]=c[(c[Q>>2]|0)+8>>2];D=(c[R>>2]|0)+16|0;w=(c[Q>>2]|0)+16|0;v=c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1;c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[n>>2]=c[M>>2];c[n+4>>2]=c[M+4>>2];c[n+8>>2]=c[M+8>>2];c[n+12>>2]=c[M+12>>2];Bg(S,o,n,v);c[D>>2]=c[S>>2];c[D+4>>2]=c[S+4>>2];c[D+8>>2]=c[S+8>>2];c[D+12>>2]=c[S+12>>2];c[(c[R>>2]|0)+12>>2]=c[(c[Q>>2]|0)+12>>2];D=(c[R>>2]|0)+32|0;v=(c[Q>>2]|0)+32|0;w=c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1;c[o>>2]=c[v>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];c[n>>2]=c[M>>2];c[n+4>>2]=c[M+4>>2];c[n+8>>2]=c[M+8>>2];c[n+12>>2]=c[M+12>>2];Bg(T,o,n,w);c[D>>2]=c[T>>2];c[D+4>>2]=c[T+4>>2];c[D+8>>2]=c[T+8>>2];c[D+12>>2]=c[T+12>>2];c[H>>2]=0;while(1){if((c[H>>2]|0)>=(c[(c[Q>>2]|0)+4>>2]|0))break;D=(c[c[R>>2]>>2]|0)+(c[H>>2]<<4)|0;w=(c[c[Q>>2]>>2]|0)+(c[H>>2]<<4)|0;v=c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1;c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[n>>2]=c[M>>2];c[n+4>>2]=c[M+4>>2];c[n+8>>2]=c[M+8>>2];c[n+12>>2]=c[M+12>>2];Bg(V,o,n,v);c[D>>2]=c[V>>2];c[D+4>>2]=c[V+4>>2];c[D+8>>2]=c[V+8>>2];c[D+12>>2]=c[V+12>>2];c[U>>2]=c[D>>2];c[U+4>>2]=c[D+4>>2];c[U+8>>2]=c[D+8>>2];c[U+12>>2]=c[D+12>>2];c[H>>2]=(c[H>>2]|0)+1;if((c[H>>2]|0)>=(c[(c[Q>>2]|0)+4>>2]|0))break;D=U+16|0;v=(c[c[R>>2]>>2]|0)+(c[H>>2]<<4)|0;w=(c[c[Q>>2]>>2]|0)+(c[H>>2]<<4)|0;J=c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1;c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[n>>2]=c[M>>2];c[n+4>>2]=c[M+4>>2];c[n+8>>2]=c[M+8>>2];c[n+12>>2]=c[M+12>>2];Bg(W,o,n,J);c[v>>2]=c[W>>2];c[v+4>>2]=c[W+4>>2];c[v+8>>2]=c[W+8>>2];c[v+12>>2]=c[W+12>>2];c[D>>2]=c[v>>2];c[D+4>>2]=c[v+4>>2];c[D+8>>2]=c[v+8>>2];c[D+12>>2]=c[v+12>>2];c[H>>2]=(c[H>>2]|0)+1;v=U+32|0;D=(c[c[R>>2]>>2]|0)+(c[H>>2]<<4)|0;J=(c[c[Q>>2]>>2]|0)+(c[H>>2]<<4)|0;w=c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1;c[o>>2]=c[J>>2];c[o+4>>2]=c[J+4>>2];c[o+8>>2]=c[J+8>>2];c[o+12>>2]=c[J+12>>2];c[n>>2]=c[M>>2];c[n+4>>2]=c[M+4>>2];c[n+8>>2]=c[M+8>>2];c[n+12>>2]=c[M+12>>2];Bg(X,o,n,w);c[D>>2]=c[X>>2];c[D+4>>2]=c[X+4>>2];c[D+8>>2]=c[X+8>>2];c[D+12>>2]=c[X+12>>2];c[v>>2]=c[D>>2];c[v+4>>2]=c[D+4>>2];c[v+8>>2]=c[D+8>>2];c[v+12>>2]=c[D+12>>2];c[H>>2]=(c[H>>2]|0)+1;D=U+48|0;v=(c[c[Q>>2]>>2]|0)+(c[H>>2]<<4)|0;w=c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1;c[o>>2]=c[v>>2];c[o+4>>2]=c[v+4>>2];c[o+8>>2]=c[v+8>>2];c[o+12>>2]=c[v+12>>2];c[n>>2]=c[M>>2];c[n+4>>2]=c[M+4>>2];c[n+8>>2]=c[M+8>>2];c[n+12>>2]=c[M+12>>2];Bg(Y,o,n,w);c[D>>2]=c[Y>>2];c[D+4>>2]=c[Y+4>>2];c[D+8>>2]=c[Y+8>>2];c[D+12>>2]=c[Y+12>>2];DH((c[(c[p>>2]|0)+8>>2]|0)+16|0,U)}if(c[(c[(c[y>>2]|0)+8>>2]|0)+96>>2]|0){D=(c[(c[(c[y>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;w=(c[(c[(c[F>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;v=c[(c[(c[p>>2]|0)+8>>2]|0)+116>>2]&1;c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[n>>2]=c[M>>2];c[n+4>>2]=c[M+4>>2];c[n+8>>2]=c[M+8>>2];c[n+12>>2]=c[M+12>>2];Bg(Z,o,n,v);c[D>>2]=c[Z>>2];c[D+4>>2]=c[Z+4>>2];c[D+8>>2]=c[Z+8>>2];c[D+12>>2]=c[Z+12>>2];a[(c[(c[(c[y>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;AO(c[p>>2]|0,c[(c[(c[y>>2]|0)+8>>2]|0)+96>>2]|0)}}c[G>>2]=(c[G>>2]|0)+1}Cg(c[B>>2]|0,c[O>>2]|0);i=m;return}function rg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;j=i;i=i+1728|0;k=j+1632|0;l=j+1616|0;m=j+1716|0;n=j+1712|0;o=j+1708|0;p=j+1704|0;q=j+1700|0;r=j+1696|0;s=j+1692|0;t=j+1688|0;u=j+1684|0;v=j+920|0;w=j+224|0;x=j+192|0;y=j+1680|0;z=j+1676|0;A=j+1672|0;B=j+1668|0;C=j+1664|0;D=j+80|0;E=j+64|0;F=j+48|0;G=j+32|0;H=j+16|0;I=j;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;g=c[p>>2]|0;c[r>>2]=c[((c[c[p>>2]>>2]&3|0)==3?g:g+32|0)+28>>2];g=c[p>>2]|0;c[s>>2]=c[((c[c[p>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2];c[C>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+172>>2];while(1){J=c[C>>2]|0;if(!(c[(c[(c[C>>2]|0)+8>>2]|0)+172>>2]|0))break;c[C>>2]=c[(c[J+8>>2]|0)+172>>2]}g=c[C>>2]|0;c[t>>2]=c[((c[J>>2]&3|0)==3?g:g+32|0)+28>>2];g=(c[(c[(c[p>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;J=(c[(c[t>>2]|0)+8>>2]|0)+16|0;c[g>>2]=c[J>>2];c[g+4>>2]=c[J+4>>2];c[g+8>>2]=c[J+8>>2];c[g+12>>2]=c[J+12>>2];a[(c[(c[(c[p>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;if((c[q>>2]|0)!=2){h[x>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[t>>2]|0)+8>>2]|0)+88>>3];h[x+16>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[t>>2]|0)+8>>2]|0)+96>>3];h[x+16+8>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[t>>2]|0)+8>>2]|0)+80>>3]/2.0;c[B>>2]=~~(+h[(c[(c[t>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[m>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[r>>2]|0)+8>>2]|0)+232>>2]<<6)+16>>3]-+h[(c[(c[r>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[(c[m>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[r>>2]|0)+8>>2]|0)+232>>2]<<6)+24>>3]);c[B>>2]=~~(+(c[B>>2]|0)/6.0);h[x+8>>3]=+h[x+16+8>>3]-(5.0>+(c[B>>2]|0)?5.0:+(c[B>>2]|0));c[y>>2]=0;ug(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[r>>2]|0,c[p>>2]|0,v,1);ug(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[s>>2]|0,c[p>>2]|0,w,0);h[1104+(c[y>>2]<<5)>>3]=+h[v+56+((c[v+52>>2]|0)-1<<5)>>3];h[1104+(c[y>>2]<<5)+8>>3]=+h[v+56+((c[v+52>>2]|0)-1<<5)+16+8>>3];h[1104+(c[y>>2]<<5)+16>>3]=+h[x>>3];h[1104+(c[y>>2]<<5)+16+8>>3]=+h[x+8>>3];c[y>>2]=(c[y>>2]|0)+1;h[1104+(c[y>>2]<<5)>>3]=+h[v+56+((c[v+52>>2]|0)-1<<5)>>3];h[1104+(c[y>>2]<<5)+8>>3]=+h[x+8>>3];h[1104+(c[y>>2]<<5)+16>>3]=+h[w+56+((c[w+52>>2]|0)-1<<5)+16>>3];h[1104+(c[y>>2]<<5)+16+8>>3]=+h[x+16+8>>3];c[y>>2]=(c[y>>2]|0)+1;h[1104+(c[y>>2]<<5)>>3]=+h[x+16>>3];h[1104+(c[y>>2]<<5)+16+8>>3]=+h[x+8>>3];h[1104+(c[y>>2]<<5)+8>>3]=+h[w+56+((c[w+52>>2]|0)-1<<5)+16+8>>3];h[1104+(c[y>>2]<<5)+16>>3]=+h[w+56+((c[w+52>>2]|0)-1<<5)+16>>3];c[y>>2]=(c[y>>2]|0)+1;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[v+52>>2]|0))break;x=c[o>>2]|0;n=v+56+(c[z>>2]<<5)|0;c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];c[k+16>>2]=c[n+16>>2];c[k+20>>2]=c[n+20>>2];c[k+24>>2]=c[n+24>>2];c[k+28>>2]=c[n+28>>2];kN(x,k);c[z>>2]=(c[z>>2]|0)+1}c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[y>>2]|0))break;v=c[o>>2]|0;x=1104+(c[z>>2]<<5)|0;c[k>>2]=c[x>>2];c[k+4>>2]=c[x+4>>2];c[k+8>>2]=c[x+8>>2];c[k+12>>2]=c[x+12>>2];c[k+16>>2]=c[x+16>>2];c[k+20>>2]=c[x+20>>2];c[k+24>>2]=c[x+24>>2];c[k+28>>2]=c[x+28>>2];kN(v,k);c[z>>2]=(c[z>>2]|0)+1}c[z>>2]=(c[w+52>>2]|0)-1;while(1){if((c[z>>2]|0)<0)break;y=c[o>>2]|0;v=w+56+(c[z>>2]<<5)|0;c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[k+12>>2]=c[v+12>>2];c[k+16>>2]=c[v+16>>2];c[k+20>>2]=c[v+20>>2];c[k+24>>2]=c[v+24>>2];c[k+28>>2]=c[v+28>>2];kN(y,k);c[z>>2]=(c[z>>2]|0)+-1}z=c[o>>2]|0;if((c[q>>2]|0)==10)c[u>>2]=RL(z,A)|0;else c[u>>2]=SL(z,A)|0;if(!(c[A>>2]|0)){i=j;return}}else{z=(c[(c[r>>2]|0)+8>>2]|0)+16|0;r=(c[(c[p>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[z>>2];c[l+4>>2]=c[z+4>>2];c[l+8>>2]=c[z+8>>2];c[l+12>>2]=c[z+12>>2];c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];og(H,l,k);c[E>>2]=c[H>>2];c[E+4>>2]=c[H+4>>2];c[E+8>>2]=c[H+8>>2];c[E+12>>2]=c[H+12>>2];H=(c[(c[s>>2]|0)+8>>2]|0)+16|0;s=(c[(c[p>>2]|0)+8>>2]|0)+56|0;c[l>>2]=c[H>>2];c[l+4>>2]=c[H+4>>2];c[l+8>>2]=c[H+8>>2];c[l+12>>2]=c[H+12>>2];c[k>>2]=c[s>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];c[k+12>>2]=c[s+12>>2];og(I,l,k);c[F>>2]=c[I>>2];c[F+4>>2]=c[I+4>>2];c[F+8>>2]=c[I+8>>2];c[F+12>>2]=c[I+12>>2];I=(c[(c[(c[p>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;c[G>>2]=c[I>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];I=G+8|0;h[I>>3]=+h[I>>3]-+h[(c[(c[(c[p>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]/2.0;I=D+16|0;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];c[D+12>>2]=c[E+12>>2];c[I>>2]=c[D>>2];c[I+4>>2]=c[D+4>>2];c[I+8>>2]=c[D+8>>2];c[I+12>>2]=c[D+12>>2];I=D+32|0;E=D+48|0;k=D+64|0;c[k>>2]=c[G>>2];c[k+4>>2]=c[G+4>>2];c[k+8>>2]=c[G+8>>2];c[k+12>>2]=c[G+12>>2];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[E+12>>2]=c[k+12>>2];c[I>>2]=c[E>>2];c[I+4>>2]=c[E+4>>2];c[I+8>>2]=c[E+8>>2];c[I+12>>2]=c[E+12>>2];E=D+80|0;I=D+96|0;c[I>>2]=c[F>>2];c[I+4>>2]=c[F+4>>2];c[I+8>>2]=c[F+8>>2];c[I+12>>2]=c[F+12>>2];c[E>>2]=c[I>>2];c[E+4>>2]=c[I+4>>2];c[E+8>>2]=c[I+8>>2];c[E+12>>2]=c[I+12>>2];c[u>>2]=D;c[A>>2]=7}D=c[p>>2]|0;jN(c[p>>2]|0,c[((c[c[p>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2]|0,c[u>>2]|0,c[A>>2]|0,50160);i=j;return}function sg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0;j=i;i=i+448|0;k=j+384|0;l=j+368|0;m=j+432|0;n=j+428|0;o=j+424|0;p=j+420|0;q=j+416|0;r=j+412|0;s=j+408|0;t=j+208|0;u=j+192|0;v=j+176|0;w=j+404|0;x=j+400|0;y=j+168|0;z=j+160|0;A=j+144|0;B=j+128|0;C=j+112|0;D=j+96|0;E=j+80|0;F=j+64|0;G=j+48|0;H=j+32|0;I=j+16|0;J=j;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=c[(c[o>>2]|0)+(c[p>>2]<<2)>>2];g=(c[(c[m>>2]|0)+8>>2]|0)+16|0;f=(c[(c[s>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[g>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];og(A,l,k);c[u>>2]=c[A>>2];c[u+4>>2]=c[A+4>>2];c[u+8>>2]=c[A+8>>2];c[u+12>>2]=c[A+12>>2];A=(c[(c[n>>2]|0)+8>>2]|0)+16|0;n=(c[(c[s>>2]|0)+8>>2]|0)+56|0;c[l>>2]=c[A>>2];c[l+4>>2]=c[A+4>>2];c[l+8>>2]=c[A+8>>2];c[l+12>>2]=c[A+12>>2];c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];og(B,l,k);c[v>>2]=c[B>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];if((c[q>>2]|0)>1)K=+h[(c[(c[m>>2]|0)+8>>2]|0)+80>>3]/+((c[q>>2]|0)-1|0);else K=0.0;h[y>>3]=K;if((c[q>>2]|0)>1)L=+h[(c[(c[m>>2]|0)+8>>2]|0)+80>>3]/2.0;else L=0.0;h[z>>3]=+h[u+8>>3]-L;c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[q>>2]|0))break;c[s>>2]=c[(c[o>>2]|0)+((c[p>>2]|0)+(c[w>>2]|0)<<2)>>2];c[x>>2]=0;m=(c[r>>2]|0)==10|(c[r>>2]|0)==2;B=c[x>>2]|0;c[x>>2]=B+1;k=t+(B<<4)|0;c[k>>2]=c[u>>2];c[k+4>>2]=c[u+4>>2];c[k+8>>2]=c[u+8>>2];c[k+12>>2]=c[u+12>>2];k=c[x>>2]|0;c[x>>2]=k+1;B=t+(k<<4)|0;if(m){wg(C,(+h[u>>3]*2.0+ +h[v>>3])/3.0,+h[z>>3]);c[B>>2]=c[C>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];c[B+12>>2]=c[C+12>>2];m=c[x>>2]|0;c[x>>2]=m+1;k=t+(m<<4)|0;wg(D,(+h[v>>3]*2.0+ +h[u>>3])/3.0,+h[z>>3]);c[k>>2]=c[D>>2];c[k+4>>2]=c[D+4>>2];c[k+8>>2]=c[D+8>>2];c[k+12>>2]=c[D+12>>2];k=c[x>>2]|0;c[x>>2]=k+1;m=t+(k<<4)|0;c[m>>2]=c[v>>2];c[m+4>>2]=c[v+4>>2];c[m+8>>2]=c[v+8>>2];c[m+12>>2]=c[v+12>>2]}else{c[B>>2]=c[u>>2];c[B+4>>2]=c[u+4>>2];c[B+8>>2]=c[u+8>>2];c[B+12>>2]=c[u+12>>2];B=c[x>>2]|0;c[x>>2]=B+1;m=t+(B<<4)|0;wg(E,(+h[u>>3]*2.0+ +h[v>>3])/3.0,+h[z>>3]);c[m>>2]=c[E>>2];c[m+4>>2]=c[E+4>>2];c[m+8>>2]=c[E+8>>2];c[m+12>>2]=c[E+12>>2];m=c[x>>2]|0;c[x>>2]=m+1;B=t+(m<<4)|0;wg(F,(+h[u>>3]*2.0+ +h[v>>3])/3.0,+h[z>>3]);c[B>>2]=c[F>>2];c[B+4>>2]=c[F+4>>2];c[B+8>>2]=c[F+8>>2];c[B+12>>2]=c[F+12>>2];B=c[x>>2]|0;c[x>>2]=B+1;m=t+(B<<4)|0;wg(G,(+h[u>>3]*2.0+ +h[v>>3])/3.0,+h[z>>3]);c[m>>2]=c[G>>2];c[m+4>>2]=c[G+4>>2];c[m+8>>2]=c[G+8>>2];c[m+12>>2]=c[G+12>>2];m=c[x>>2]|0;c[x>>2]=m+1;B=t+(m<<4)|0;wg(H,(+h[v>>3]*2.0+ +h[u>>3])/3.0,+h[z>>3]);c[B>>2]=c[H>>2];c[B+4>>2]=c[H+4>>2];c[B+8>>2]=c[H+8>>2];c[B+12>>2]=c[H+12>>2];B=c[x>>2]|0;c[x>>2]=B+1;m=t+(B<<4)|0;wg(I,(+h[v>>3]*2.0+ +h[u>>3])/3.0,+h[z>>3]);c[m>>2]=c[I>>2];c[m+4>>2]=c[I+4>>2];c[m+8>>2]=c[I+8>>2];c[m+12>>2]=c[I+12>>2];m=c[x>>2]|0;c[x>>2]=m+1;B=t+(m<<4)|0;wg(J,(+h[v>>3]*2.0+ +h[u>>3])/3.0,+h[z>>3]);c[B>>2]=c[J>>2];c[B+4>>2]=c[J+4>>2];c[B+8>>2]=c[J+8>>2];c[B+12>>2]=c[J+12>>2];B=c[x>>2]|0;c[x>>2]=B+1;m=t+(B<<4)|0;c[m>>2]=c[v>>2];c[m+4>>2]=c[v+4>>2];c[m+8>>2]=c[v+8>>2];c[m+12>>2]=c[v+12>>2];m=c[x>>2]|0;c[x>>2]=m+1;B=t+(m<<4)|0;c[B>>2]=c[v>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2]}h[z>>3]=+h[z>>3]+ +h[y>>3];B=c[s>>2]|0;jN(c[s>>2]|0,c[((c[c[s>>2]>>2]&3|0)==2?B:B+-32|0)+28>>2]|0,t,c[x>>2]|0,50160);c[w>>2]=(c[w>>2]|0)+1}i=j;return}function tg(a,d,e,f,g,j,k,l){a=a|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;m=i;i=i+1552|0;n=m+1448|0;o=m+1544|0;p=m+1540|0;q=m+1536|0;r=m+1532|0;s=m+1528|0;t=m+1524|0;u=m+1520|0;v=m+1516|0;w=m+1512|0;x=m+1508|0;y=m+1504|0;z=m+1500|0;A=m+1496|0;B=m+1440|0;C=m+1432|0;D=m+1424|0;E=m+1492|0;F=m+1488|0;G=m+1484|0;H=m+728|0;I=m+32|0;J=m+1480|0;K=m;c[o>>2]=a;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=j;c[u>>2]=k;c[v>>2]=l;l=c[u>>2]|0;c[w>>2]=c[((c[c[u>>2]>>2]&3|0)==3?l:l+32|0)+28>>2];l=c[u>>2]|0;c[x>>2]=c[((c[c[u>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2];c[A>>2]=c[(c[(c[w>>2]|0)+8>>2]|0)+232>>2];l=c[(c[o>>2]|0)+8>>2]|0;if((c[A>>2]|0)<(b[(c[(c[o>>2]|0)+8>>2]|0)+238>>1]|0)){c[E>>2]=(c[l+196>>2]|0)+((c[A>>2]|0)+1<<6);h[D>>3]=+h[(c[(c[w>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+196>>2]|0)+(c[A>>2]<<6)+32>>3]-(+h[(c[(c[c[(c[E>>2]|0)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[E>>2]|0)+40>>3])}else h[D>>3]=+(c[l+252>>2]|0);h[B>>3]=+(c[(c[p>>2]|0)+12>>2]|0)/+((c[t>>2]|0)+1|0);h[C>>3]=+h[D>>3]/+((c[t>>2]|0)+1|0);vg(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[w>>2]|0,c[u>>2]|0,H,1);vg(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0,c[u>>2]|0,I,0);c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[t>>2]|0)){L=20;break}c[u>>2]=c[(c[r>>2]|0)+((c[s>>2]|0)+(c[z>>2]|0)<<2)>>2];c[J>>2]=0;x=H+56+((c[H+52>>2]|0)-1<<5)|0;c[K>>2]=c[x>>2];c[K+4>>2]=c[x+4>>2];c[K+8>>2]=c[x+8>>2];c[K+12>>2]=c[x+12>>2];c[K+16>>2]=c[x+16>>2];c[K+20>>2]=c[x+20>>2];c[K+24>>2]=c[x+24>>2];c[K+28>>2]=c[x+28>>2];h[1104+(c[J>>2]<<5)>>3]=+h[K>>3];h[1104+(c[J>>2]<<5)+16+8>>3]=+h[K+8>>3];h[1104+(c[J>>2]<<5)+16>>3]=+h[K+16>>3]+ +((c[z>>2]|0)+1|0)*+h[B>>3];h[1104+(c[J>>2]<<5)+8>>3]=+h[K+8>>3]-+((c[z>>2]|0)+1|0)*+h[C>>3];c[J>>2]=(c[J>>2]|0)+1;h[1104+(c[J>>2]<<5)>>3]=+h[H+56+((c[H+52>>2]|0)-1<<5)>>3];h[1104+(c[J>>2]<<5)+16+8>>3]=+h[1104+((c[J>>2]|0)-1<<5)+8>>3];h[1104+(c[J>>2]<<5)+16>>3]=+h[I+56+((c[I+52>>2]|0)-1<<5)+16>>3];h[1104+(c[J>>2]<<5)+8>>3]=+h[1104+(c[J>>2]<<5)+16+8>>3]-+h[C>>3];c[J>>2]=(c[J>>2]|0)+1;x=I+56+((c[I+52>>2]|0)-1<<5)|0;c[K>>2]=c[x>>2];c[K+4>>2]=c[x+4>>2];c[K+8>>2]=c[x+8>>2];c[K+12>>2]=c[x+12>>2];c[K+16>>2]=c[x+16>>2];c[K+20>>2]=c[x+20>>2];c[K+24>>2]=c[x+24>>2];c[K+28>>2]=c[x+28>>2];h[1104+(c[J>>2]<<5)+16>>3]=+h[K+16>>3];h[1104+(c[J>>2]<<5)+16+8>>3]=+h[K+8>>3];h[1104+(c[J>>2]<<5)>>3]=+h[K>>3]-+((c[z>>2]|0)+1|0)*+h[B>>3];h[1104+(c[J>>2]<<5)+8>>3]=+h[1104+((c[J>>2]|0)-1<<5)+16+8>>3];c[J>>2]=(c[J>>2]|0)+1;c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[H+52>>2]|0))break;x=c[q>>2]|0;p=H+56+(c[y>>2]<<5)|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];c[n+16>>2]=c[p+16>>2];c[n+20>>2]=c[p+20>>2];c[n+24>>2]=c[p+24>>2];c[n+28>>2]=c[p+28>>2];kN(x,n);c[y>>2]=(c[y>>2]|0)+1}c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[J>>2]|0))break;x=c[q>>2]|0;p=1104+(c[y>>2]<<5)|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];c[n+16>>2]=c[p+16>>2];c[n+20>>2]=c[p+20>>2];c[n+24>>2]=c[p+24>>2];c[n+28>>2]=c[p+28>>2];kN(x,n);c[y>>2]=(c[y>>2]|0)+1}c[y>>2]=(c[I+52>>2]|0)-1;while(1){if((c[y>>2]|0)<0)break;x=c[q>>2]|0;p=I+56+(c[y>>2]<<5)|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];c[n+16>>2]=c[p+16>>2];c[n+20>>2]=c[p+20>>2];c[n+24>>2]=c[p+24>>2];c[n+28>>2]=c[p+28>>2];kN(x,n);c[y>>2]=(c[y>>2]|0)+-1}x=c[q>>2]|0;if(c[v>>2]|0)c[G>>2]=RL(x,F)|0;else c[G>>2]=SL(x,F)|0;if(!(c[F>>2]|0)){L=20;break}x=c[u>>2]|0;jN(c[u>>2]|0,c[((c[c[u>>2]>>2]&3|0)==2?x:x+-32|0)+28>>2]|0,c[G>>2]|0,c[F>>2]|0,50160);c[(c[q>>2]|0)+80>>2]=0;c[z>>2]=(c[z>>2]|0)+1}if((L|0)==20){i=m;return}}function ug(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0;l=i;i=i+160|0;m=l+96|0;n=l+148|0;o=l+144|0;p=l+140|0;q=l+136|0;r=l+132|0;s=l+128|0;t=l+152|0;u=l+64|0;v=l+32|0;w=l;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;a[t>>0]=k;k=c[s>>2]|0;Zf(v,c[n>>2]|0,c[o>>2]|0,c[q>>2]|0,0,c[r>>2]|0);c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[k+12>>2]=c[v+12>>2];c[k+16>>2]=c[v+16>>2];c[k+20>>2]=c[v+20>>2];c[k+24>>2]=c[v+24>>2];c[k+28>>2]=c[v+28>>2];c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];c[u+8>>2]=c[k+8>>2];c[u+12>>2]=c[k+12>>2];c[u+16>>2]=c[k+16>>2];c[u+20>>2]=c[k+20>>2];c[u+24>>2]=c[k+24>>2];c[u+28>>2]=c[k+28>>2];c[(c[s>>2]|0)+48>>2]=4;k=c[p>>2]|0;p=c[r>>2]|0;r=c[s>>2]|0;if(a[t>>0]|0)lN(k,p,2,r,0);else mN(k,p,2,r,0);h[u+16+8>>3]=+h[(c[s>>2]|0)+56+((c[(c[s>>2]|0)+52>>2]|0)-1<<5)+16+8>>3];h[u+8>>3]=+h[(c[s>>2]|0)+56+((c[(c[s>>2]|0)+52>>2]|0)-1<<5)+8>>3];x=+h[(c[(c[q>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[q>>2]|0)+8>>2]|0)+232>>2]<<6)+24>>3];c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];c[m+12>>2]=c[u+12>>2];c[m+16>>2]=c[u+16>>2];c[m+20>>2]=c[u+20>>2];c[m+24>>2]=c[u+24>>2];c[m+28>>2]=c[u+28>>2];$f(w,m,4,x);c[u>>2]=c[w>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];c[u+16>>2]=c[w+16>>2];c[u+20>>2]=c[w+20>>2];c[u+24>>2]=c[w+24>>2];c[u+28>>2]=c[w+28>>2];if(!(+h[u>>3]<+h[u+16>>3])){i=l;return}if(!(+h[u+8>>3]<+h[u+16+8>>3])){i=l;return}w=(c[s>>2]|0)+52|0;m=c[w>>2]|0;c[w>>2]=m+1;w=(c[s>>2]|0)+56+(m<<5)|0;c[w>>2]=c[u>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[w+12>>2]=c[u+12>>2];c[w+16>>2]=c[u+16>>2];c[w+20>>2]=c[u+20>>2];c[w+24>>2]=c[u+24>>2];c[w+28>>2]=c[u+28>>2];i=l;return}function vg(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0;l=i;i=i+160|0;m=l+96|0;n=l+148|0;o=l+144|0;p=l+140|0;q=l+136|0;r=l+132|0;s=l+128|0;t=l+152|0;u=l+64|0;v=l+32|0;w=l;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;a[t>>0]=k;k=c[s>>2]|0;Zf(v,c[n>>2]|0,c[o>>2]|0,c[q>>2]|0,0,c[r>>2]|0);c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[k+12>>2]=c[v+12>>2];c[k+16>>2]=c[v+16>>2];c[k+20>>2]=c[v+20>>2];c[k+24>>2]=c[v+24>>2];c[k+28>>2]=c[v+28>>2];c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];c[u+8>>2]=c[k+8>>2];c[u+12>>2]=c[k+12>>2];c[u+16>>2]=c[k+16>>2];c[u+20>>2]=c[k+20>>2];c[u+24>>2]=c[k+24>>2];c[u+28>>2]=c[k+28>>2];c[(c[s>>2]|0)+48>>2]=1;k=c[p>>2]|0;p=c[r>>2]|0;r=c[s>>2]|0;if(a[t>>0]|0)lN(k,p,2,r,0);else mN(k,p,2,r,0);h[u+16+8>>3]=+h[(c[s>>2]|0)+56+((c[(c[s>>2]|0)+52>>2]|0)-1<<5)+16+8>>3];h[u+8>>3]=+h[(c[s>>2]|0)+56+((c[(c[s>>2]|0)+52>>2]|0)-1<<5)+8>>3];x=+h[(c[(c[q>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[q>>2]|0)+8>>2]|0)+232>>2]<<6)+24>>3];c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];c[m+12>>2]=c[u+12>>2];c[m+16>>2]=c[u+16>>2];c[m+20>>2]=c[u+20>>2];c[m+24>>2]=c[u+24>>2];c[m+28>>2]=c[u+28>>2];$f(w,m,1,x);c[u>>2]=c[w>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];c[u+16>>2]=c[w+16>>2];c[u+20>>2]=c[w+20>>2];c[u+24>>2]=c[w+24>>2];c[u+28>>2]=c[w+28>>2];if(!(+h[u>>3]<+h[u+16>>3])){i=l;return}if(!(+h[u+8>>3]<+h[u+16+8>>3])){i=l;return}w=(c[s>>2]|0)+52|0;m=c[w>>2]|0;c[w>>2]=m+1;w=(c[s>>2]|0)+56+(m<<5)|0;c[w>>2]=c[u>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[w+12>>2]=c[u+12>>2];c[w+16>>2]=c[u+16>>2];c[w+20>>2]=c[u+20>>2];c[w+24>>2]=c[u+24>>2];c[w+28>>2]=c[u+28>>2];i=l;return}function wg(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3];h[j+8>>3]=+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function xg(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;i=i+416|0;m=l+336|0;n=l+320|0;o=l+304|0;p=l+412|0;q=l+408|0;r=l+404|0;s=l+400|0;t=l+396|0;u=l+392|0;v=l+388|0;w=l+384|0;x=l+376|0;y=l+368|0;z=l+364|0;A=l+144|0;B=l+128|0;C=l+112|0;D=l+360|0;E=l+356|0;F=l+104|0;G=l+96|0;H=l+88|0;I=l+80|0;J=l+72|0;K=l+64|0;L=l+56|0;M=l+48|0;N=l+40|0;O=l+32|0;P=l+352|0;Q=l+16|0;R=l;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=j;c[v>>2]=k;c[z>>2]=c[(c[r>>2]|0)+(c[s>>2]<<2)>>2];c[P>>2]=bK(c[t>>2]<<2)|0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[t>>2]|0))break;c[(c[P>>2]|0)+(c[D>>2]<<2)>>2]=c[(c[r>>2]|0)+((c[s>>2]|0)+(c[D>>2]|0)<<2)>>2];c[D>>2]=(c[D>>2]|0)+1}w3(c[P>>2]|0,c[t>>2]|0,4,59);s=(c[(c[p>>2]|0)+8>>2]|0)+16|0;r=(c[(c[z>>2]|0)+8>>2]|0)+16|0;c[n>>2]=c[s>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];og(Q,n,m);c[B>>2]=c[Q>>2];c[B+4>>2]=c[Q+4>>2];c[B+8>>2]=c[Q+8>>2];c[B+12>>2]=c[Q+12>>2];Q=(c[(c[q>>2]|0)+8>>2]|0)+16|0;r=(c[(c[z>>2]|0)+8>>2]|0)+56|0;c[n>>2]=c[Q>>2];c[n+4>>2]=c[Q+4>>2];c[n+8>>2]=c[Q+8>>2];c[n+12>>2]=c[Q+12>>2];c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];og(R,n,m);c[C>>2]=c[R>>2];c[C+4>>2]=c[R+4>>2];c[C+8>>2]=c[R+8>>2];c[C+12>>2]=c[R+12>>2];h[F>>3]=+h[B>>3]+ +h[(c[(c[p>>2]|0)+8>>2]|0)+96>>3];h[G>>3]=+h[C>>3]-+h[(c[(c[q>>2]|0)+8>>2]|0)+88>>3];h[H>>3]=(+h[F>>3]+ +h[G>>3])/2.0;c[z>>2]=c[c[P>>2]>>2];c[E>>2]=0;q=c[E>>2]|0;c[E>>2]=q+1;p=A+(q<<4)|0;c[p>>2]=c[B>>2];c[p+4>>2]=c[B+4>>2];c[p+8>>2]=c[B+8>>2];c[p+12>>2]=c[B+12>>2];p=c[E>>2]|0;c[E>>2]=p+1;q=A+(p<<4)|0;c[q>>2]=c[B>>2];c[q+4>>2]=c[B+4>>2];c[q+8>>2]=c[B+8>>2];c[q+12>>2]=c[B+12>>2];q=c[E>>2]|0;c[E>>2]=q+1;p=A+(q<<4)|0;c[p>>2]=c[C>>2];c[p+4>>2]=c[C+4>>2];c[p+8>>2]=c[C+8>>2];c[p+12>>2]=c[C+12>>2];p=c[E>>2]|0;c[E>>2]=p+1;q=A+(p<<4)|0;c[q>>2]=c[C>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];c[q+12>>2]=c[C+12>>2];q=c[z>>2]|0;jN(c[z>>2]|0,c[((c[c[z>>2]>>2]&3|0)==2?q:q+-32|0)+28>>2]|0,A,c[E>>2]|0,50160);h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+56>>3]=+h[H>>3];h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+56+8>>3]=+h[B+8>>3]+(+h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]+6.0)/2.0;a[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;h[J>>3]=+h[B+8>>3]+3.0;h[K>>3]=+h[J>>3]+ +h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3];h[L>>3]=+h[H>>3]-+h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24>>3]/2.0;h[M>>3]=+h[H>>3]+ +h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24>>3]/2.0;c[D>>2]=1;while(1){if((c[D>>2]|0)>=(c[v>>2]|0))break;c[z>>2]=c[(c[P>>2]|0)+(c[D>>2]<<2)>>2];if((c[D>>2]|0)%2|0){if((c[D>>2]|0)==1){h[N>>3]=+h[H>>3]-+h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24>>3]/2.0;h[O>>3]=+h[H>>3]+ +h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24>>3]/2.0}h[J>>3]=+h[J>>3]-(+h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]+6.0);c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];c[A+12>>2]=c[B+12>>2];h[A+16>>3]=+h[B>>3];h[A+16+8>>3]=+h[J>>3]-6.0;h[A+32>>3]=+h[C>>3];h[A+32+8>>3]=+h[A+16+8>>3];E=A+48|0;c[E>>2]=c[C>>2];c[E+4>>2]=c[C+4>>2];c[E+8>>2]=c[C+8>>2];c[E+12>>2]=c[C+12>>2];h[A+64>>3]=+h[O>>3];h[A+64+8>>3]=+h[C+8>>3];h[A+80>>3]=+h[O>>3];h[A+80+8>>3]=+h[J>>3];h[A+96>>3]=+h[N>>3];h[A+96+8>>3]=+h[J>>3];h[A+112>>3]=+h[N>>3];h[A+112+8>>3]=+h[B+8>>3];h[I>>3]=+h[J>>3]+ +h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]/2.0}else{c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];c[A+12>>2]=c[B+12>>2];h[A+16>>3]=+h[L>>3];h[A+16+8>>3]=+h[B+8>>3];h[A+32>>3]=+h[L>>3];h[A+32+8>>3]=+h[K>>3];h[A+48>>3]=+h[M>>3];h[A+48+8>>3]=+h[K>>3];h[A+64>>3]=+h[M>>3];h[A+64+8>>3]=+h[C+8>>3];h[A+80>>3]=+h[C>>3];h[A+80+8>>3]=+h[C+8>>3];h[A+96>>3]=+h[C>>3];h[A+96+8>>3]=+h[K>>3]+6.0;h[A+112>>3]=+h[B>>3];h[A+112+8>>3]=+h[K>>3]+6.0;h[I>>3]=+h[K>>3]+ +h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]/2.0+6.0;h[K>>3]=+h[K>>3]+(+h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]+6.0)}c[x+4>>2]=8;c[x>>2]=A;E=(c[u>>2]|0)==6&1;c[o>>2]=c[B>>2];c[o+4>>2]=c[B+4>>2];c[o+8>>2]=c[B+8>>2];c[o+12>>2]=c[B+12>>2];c[n>>2]=c[C>>2];c[n+4>>2]=c[C+4>>2];c[n+8>>2]=c[C+8>>2];c[n+12>>2]=c[C+12>>2];c[m>>2]=c[x>>2];c[m+4>>2]=c[x+4>>2];c[w>>2]=OL(o,n,m,y,E)|0;if(!(c[y>>2]|0)){S=22;break}h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+56>>3]=+h[H>>3];h[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+56+8>>3]=+h[I>>3];a[(c[(c[(c[z>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;E=c[z>>2]|0;jN(c[z>>2]|0,c[((c[c[z>>2]>>2]&3|0)==2?E:E+-32|0)+28>>2]|0,c[w>>2]|0,c[y>>2]|0,50160);c[D>>2]=(c[D>>2]|0)+1}if((S|0)==22){i=l;return}while(1){if((c[D>>2]|0)>=(c[t>>2]|0))break;c[z>>2]=c[(c[P>>2]|0)+(c[D>>2]<<2)>>2];if((c[D>>2]|0)%2|0){if((c[D>>2]|0)==1){h[N>>3]=(+h[F>>3]*2.0+ +h[G>>3])/3.0;h[O>>3]=(+h[F>>3]+ +h[G>>3]*2.0)/3.0}h[J>>3]=+h[J>>3]-6.0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];c[A+12>>2]=c[B+12>>2];h[A+16>>3]=+h[B>>3];h[A+16+8>>3]=+h[J>>3]-6.0;h[A+32>>3]=+h[C>>3];h[A+32+8>>3]=+h[A+16+8>>3];I=A+48|0;c[I>>2]=c[C>>2];c[I+4>>2]=c[C+4>>2];c[I+8>>2]=c[C+8>>2];c[I+12>>2]=c[C+12>>2];h[A+64>>3]=+h[O>>3];h[A+64+8>>3]=+h[C+8>>3];h[A+80>>3]=+h[O>>3];h[A+80+8>>3]=+h[J>>3];h[A+96>>3]=+h[N>>3];h[A+96+8>>3]=+h[J>>3];h[A+112>>3]=+h[N>>3];h[A+112+8>>3]=+h[B+8>>3]}else{c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];c[A+12>>2]=c[B+12>>2];h[A+16>>3]=+h[L>>3];h[A+16+8>>3]=+h[B+8>>3];h[A+32>>3]=+h[L>>3];h[A+32+8>>3]=+h[K>>3];h[A+48>>3]=+h[M>>3];h[A+48+8>>3]=+h[K>>3];h[A+64>>3]=+h[M>>3];h[A+64+8>>3]=+h[C+8>>3];h[A+80>>3]=+h[C>>3];h[A+80+8>>3]=+h[C+8>>3];h[A+96>>3]=+h[C>>3];h[A+96+8>>3]=+h[K>>3]+6.0;h[A+112>>3]=+h[B>>3];h[A+112+8>>3]=+h[K>>3]+6.0;h[K>>3]=+h[K>>3]+6.0}c[x+4>>2]=8;c[x>>2]=A;I=(c[u>>2]|0)==6&1;c[o>>2]=c[B>>2];c[o+4>>2]=c[B+4>>2];c[o+8>>2]=c[B+8>>2];c[o+12>>2]=c[B+12>>2];c[n>>2]=c[C>>2];c[n+4>>2]=c[C+4>>2];c[n+8>>2]=c[C+8>>2];c[n+12>>2]=c[C+12>>2];c[m>>2]=c[x>>2];c[m+4>>2]=c[x+4>>2];c[w>>2]=OL(o,n,m,y,I)|0;if(!(c[y>>2]|0)){S=22;break}I=c[z>>2]|0;jN(c[z>>2]|0,c[((c[c[z>>2]>>2]&3|0)==2?I:I+-32|0)+28>>2]|0,c[w>>2]|0,c[y>>2]|0,50160);c[D>>2]=(c[D>>2]|0)+1}if((S|0)==22){i=l;return}O4(c[P>>2]|0);i=l;return}function yg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=b;c[j>>2]=d;if(nB(c[g>>2]|0)|0){c[f>>2]=c[13065];c[l>>2]=gB(122555,f,0)|0}else{c[f>>2]=c[13067];c[l>>2]=gB(122555,f,0)|0}MC(c[l>>2]|0,175049,280,1)|0;qA(c[l>>2]|0,0,124202,178518)|0;f=bK(96)|0;c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]=f;h[c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]>>3]=+h[c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]>>3];h[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3]=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3];a[(c[(c[l>>2]|0)+8>>2]|0)+115>>0]=a[(c[(c[g>>2]|0)+8>>2]|0)+115>>0]|0;f=(c[(c[l>>2]|0)+8>>2]|0)+116|0;if(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1)c[f>>2]=0;else c[f>>2]=1;c[(c[(c[l>>2]|0)+8>>2]|0)+248>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+248>>2];c[(c[(c[l>>2]|0)+8>>2]|0)+252>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+252>>2];c[k>>2]=rA(rC(c[g>>2]|0)|0,1,0)|0;while(1){if(!(c[k>>2]|0))break;qA(c[l>>2]|0,1,c[(c[k>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0;f=rC(c[g>>2]|0)|0;c[k>>2]=rA(f,1,c[k>>2]|0)|0}c[k>>2]=rA(rC(c[g>>2]|0)|0,2,0)|0;while(1){m=c[l>>2]|0;if(!(c[k>>2]|0))break;qA(m,2,c[(c[k>>2]|0)+8>>2]|0,c[(c[k>>2]|0)+12>>2]|0)|0;f=rC(c[g>>2]|0)|0;c[k>>2]=rA(f,2,c[k>>2]|0)|0}if(!(qA(m,2,149061,0)|0))qA(c[l>>2]|0,2,149061,178518)|0;if(qA(c[l>>2]|0,2,149070,0)|0){n=c[l>>2]|0;o=c[j>>2]|0;Dg(n,o);p=c[l>>2]|0;i=e;return p|0}qA(c[l>>2]|0,2,149070,178518)|0;n=c[l>>2]|0;o=c[j>>2]|0;Dg(n,o);p=c[l>>2]|0;i=e;return p|0}function zg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;g=e+24|0;h=e+20|0;j=e+12|0;k=e+8|0;l=e+4|0;c[g>>2]=a;c[h>>2]=b;c[e+16>>2]=d;d=c[g>>2]|0;c[j>>2]=fC(d,wB(c[h>>2]|0)|0,1)|0;MC(c[j>>2]|0,175026,304,1)|0;DA(c[h>>2]|0,c[j>>2]|0)|0;if((dM(c[h>>2]|0)|0)!=2){m=c[j>>2]|0;i=e;return m|0}c[k>>2]=N3(c[c[(c[(c[h>>2]|0)+8>>2]|0)+104>>2]>>2]|0)|0;c[l>>2]=cK((c[k>>2]|0)+3|0)|0;k=c[l>>2]|0;c[f>>2]=c[c[(c[(c[h>>2]|0)+8>>2]|0)+104>>2]>>2];k3(k,122550,f)|0;AA(c[j>>2]|0,147656,c[l>>2]|0)|0;m=c[j>>2]|0;i=e;return m|0}function Ag(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=VA(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,0,1)|0;MC(c[l>>2]|0,175319,176,1)|0;DA(c[k>>2]|0,c[l>>2]|0)|0;i=f;return c[l>>2]|0}function Bg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0;f=i;i=i+48|0;g=f+24|0;j=f+8|0;k=f+40|0;l=f;c[k>>2]=e;if(c[k>>2]|0){h[l>>3]=+h[b>>3];h[b>>3]=+h[b+8>>3];h[b+8>>3]=-+h[l>>3]};c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];og(a,j,g);i=f;return}function Cg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[13873]=c[c[f>>2]>>2];c[13877]=c[(c[f>>2]|0)+4>>2];c[13878]=c[(c[f>>2]|0)+8>>2];c[13851]=c[(c[f>>2]|0)+12>>2];c[13852]=c[(c[f>>2]|0)+16>>2];c[13865]=c[(c[f>>2]|0)+20>>2];c[13864]=c[(c[f>>2]|0)+24>>2];c[13863]=c[(c[f>>2]|0)+28>>2];c[13889]=c[(c[f>>2]|0)+32>>2];c[13881]=c[(c[f>>2]|0)+36>>2];c[13866]=c[(c[f>>2]|0)+40>>2];c[13876]=c[(c[f>>2]|0)+44>>2];c[13885]=c[(c[f>>2]|0)+48>>2];c[13884]=c[(c[f>>2]|0)+52>>2];c[13883]=c[(c[f>>2]|0)+56>>2];c[13888]=c[(c[f>>2]|0)+60>>2];c[13882]=c[(c[f>>2]|0)+64>>2];c[13867]=c[(c[f>>2]|0)+68>>2];c[13814]=c[(c[f>>2]|0)+72>>2];c[13815]=c[(c[f>>2]|0)+76>>2];c[13816]=c[(c[f>>2]|0)+80>>2];c[13834]=c[(c[f>>2]|0)+84>>2];c[13827]=c[(c[f>>2]|0)+88>>2];c[13828]=c[(c[f>>2]|0)+92>>2];c[13829]=c[(c[f>>2]|0)+96>>2];c[13831]=c[(c[f>>2]|0)+100>>2];c[13832]=c[(c[f>>2]|0)+104>>2];c[13835]=c[(c[f>>2]|0)+108>>2];c[13838]=c[(c[f>>2]|0)+112>>2];c[13836]=c[(c[f>>2]|0)+116>>2];c[13837]=c[(c[f>>2]|0)+120>>2];c[13840]=c[(c[f>>2]|0)+124>>2];c[13839]=c[(c[f>>2]|0)+128>>2];c[13841]=c[(c[f>>2]|0)+132>>2];c[13842]=c[(c[f>>2]|0)+136>>2];c[13833]=c[(c[f>>2]|0)+140>>2];c[13845]=c[(c[f>>2]|0)+144>>2];c[13809]=c[(c[f>>2]|0)+148>>2];c[13800]=c[(c[f>>2]|0)+152>>2];O4(c[f>>2]|0);sf(c[e>>2]|0);jB(c[e>>2]|0)|0;i=d;return}function Dg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[f>>2]>>2]=c[13873];c[(c[f>>2]|0)+4>>2]=c[13877];c[(c[f>>2]|0)+8>>2]=c[13878];c[(c[f>>2]|0)+12>>2]=c[13851];c[(c[f>>2]|0)+16>>2]=c[13852];c[(c[f>>2]|0)+20>>2]=c[13865];c[(c[f>>2]|0)+24>>2]=c[13864];c[(c[f>>2]|0)+28>>2]=c[13863];c[(c[f>>2]|0)+32>>2]=c[13889];c[(c[f>>2]|0)+36>>2]=c[13881];c[(c[f>>2]|0)+40>>2]=c[13866];c[(c[f>>2]|0)+44>>2]=c[13876];c[(c[f>>2]|0)+48>>2]=c[13885];c[(c[f>>2]|0)+52>>2]=c[13884];c[(c[f>>2]|0)+56>>2]=c[13883];c[(c[f>>2]|0)+60>>2]=c[13888];c[(c[f>>2]|0)+64>>2]=c[13882];c[(c[f>>2]|0)+68>>2]=c[13867];c[(c[f>>2]|0)+72>>2]=c[13814];c[(c[f>>2]|0)+76>>2]=c[13815];c[(c[f>>2]|0)+80>>2]=c[13816];c[(c[f>>2]|0)+84>>2]=c[13834];c[(c[f>>2]|0)+88>>2]=c[13827];c[(c[f>>2]|0)+92>>2]=c[13828];c[(c[f>>2]|0)+96>>2]=c[13829];c[(c[f>>2]|0)+100>>2]=c[13831];c[(c[f>>2]|0)+104>>2]=c[13832];c[(c[f>>2]|0)+108>>2]=c[13835];c[(c[f>>2]|0)+112>>2]=c[13838];c[(c[f>>2]|0)+116>>2]=c[13836];c[(c[f>>2]|0)+120>>2]=c[13837];c[(c[f>>2]|0)+124>>2]=c[13840];c[(c[f>>2]|0)+128>>2]=c[13839];c[(c[f>>2]|0)+132>>2]=c[13841];c[(c[f>>2]|0)+136>>2]=c[13842];c[(c[f>>2]|0)+140>>2]=c[13833];c[(c[f>>2]|0)+144>>2]=c[13845];c[(c[f>>2]|0)+152>>2]=c[13800];c[(c[f>>2]|0)+148>>2]=c[13809];c[13873]=0;c[13877]=qA(c[e>>2]|0,2,124443,0)|0;c[13878]=qA(c[e>>2]|0,2,124452,0)|0;c[13851]=qA(c[e>>2]|0,2,139333,0)|0;if(!(c[13851]|0))c[13851]=qA(c[e>>2]|0,2,139333,178518)|0;c[13852]=0;c[13865]=0;c[13864]=qA(c[e>>2]|0,2,139229,0)|0;c[13863]=qA(c[e>>2]|0,2,139220,0)|0;c[13889]=qA(c[e>>2]|0,2,139509,0)|0;c[13881]=0;c[13866]=qA(c[e>>2]|0,2,147656,0)|0;c[13876]=qA(c[e>>2]|0,2,122560,0)|0;c[13885]=0;c[13884]=qA(c[e>>2]|0,2,139409,0)|0;c[13883]=qA(c[e>>2]|0,2,139395,0)|0;c[13888]=qA(c[e>>2]|0,2,139500,0)|0;c[13882]=0;c[13867]=0;c[13814]=qA(c[e>>2]|0,1,179057,0)|0;c[13815]=qA(c[e>>2]|0,1,179125,0)|0;c[13816]=qA(c[e>>2]|0,1,147662,0)|0;c[13834]=0;c[13827]=qA(c[e>>2]|0,1,139220,0)|0;c[13828]=qA(c[e>>2]|0,1,139229,0)|0;c[13829]=0;c[13831]=qA(c[e>>2]|0,1,147656,0)|0;c[13832]=0;c[13835]=0;c[13838]=qA(c[e>>2]|0,1,139201,0)|0;c[13836]=qA(c[e>>2]|0,1,179085,0)|0;c[13837]=qA(c[e>>2]|0,1,139264,0)|0;c[13840]=qA(c[e>>2]|0,1,139276,0)|0;c[13839]=qA(c[e>>2]|0,1,139140,0)|0;c[13841]=qA(c[e>>2]|0,1,139281,0)|0;c[13842]=qA(c[e>>2]|0,1,122572,0)|0;c[13833]=0;c[13845]=0;c[13809]=qA(c[e>>2]|0,0,139201,0)|0;i=d;return}function Eg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;j=d+36|0;k=d+32|0;l=d+16|0;m=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[c[f>>2]>>2];c[k>>2]=c[c[g>>2]>>2];g=(c[(c[(c[k>>2]|0)+8>>2]|0)+96>>2]|0)!=0;do if(c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0){if(!g){c[e>>2]=-1;break}f=(c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];f=(c[(c[(c[k>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;c[m>>2]=c[f>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];if(+h[l>>3]>+h[m>>3]){c[e>>2]=-1;break}if(+h[l>>3]<+h[m>>3]){c[e>>2]=1;break}if(+h[l+8>>3]>+h[m+8>>3]){c[e>>2]=-1;break}if(+h[l+8>>3]<+h[m+8>>3]){c[e>>2]=1;break}else{c[e>>2]=0;break}}else if(g){c[e>>2]=1;break}else{c[e>>2]=0;break}while(0);i=d;return c[e>>2]|0}function Fg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;while(1){g=c[f>>2]|0;if(!(c[(c[(c[f>>2]|0)+8>>2]|0)+116>>2]|0))break;c[f>>2]=c[(c[g+8>>2]|0)+116>>2]}b=c[f>>2]|0;h=c[f>>2]|0;if((c[(c[(c[((c[g>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[(c[(c[((c[c[f>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){a[e>>0]=0;j=a[e>>0]|0;i=d;return j|0}h=c[f>>2]|0;b=c[f>>2]|0;if((c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)<(c[(c[(c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){a[e>>0]=1;j=a[e>>0]|0;i=d;return j|0}b=c[f>>2]|0;h=c[f>>2]|0;if((c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)>=(c[(c[(c[((c[c[f>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)){a[e>>0]=0;j=a[e>>0]|0;i=d;return j|0}else{a[e>>0]=1;j=a[e>>0]|0;i=d;return j|0}return 0}function Gg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d+4|0;h=d;c[g>>2]=a;c[h>>2]=b;b=c[g>>2]|0;a=(c[(c[g>>2]|0)+8>>2]|0)+180|0;g=c[h>>2]|0;j=(c[(c[h>>2]|0)+8>>2]|0)+172|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];j=Xg(b,f,g,e)|0;i=d;return j|0}function Hg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d+4|0;h=d;c[g>>2]=a;c[h>>2]=b;b=c[g>>2]|0;a=(c[(c[g>>2]|0)+8>>2]|0)+188|0;g=c[h>>2]|0;j=(c[(c[h>>2]|0)+8>>2]|0)+196|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];j=Xg(b,f,g,e)|0;i=d;return j|0}function Ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[d>>2]|0;e=(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+180|0;if(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?c[d>>2]|0:(c[d>>2]|0)+32|0)+28>>2]|0)+8>>2]|0)+180>>2]|0){a=c[d>>2]|0;f=eK(c[e>>2]|0,(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+180+4>>2]|0)+2<<2)|0}else f=cK((c[e+4>>2]|0)+2<<2)|0;e=c[d>>2]|0;c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+180>>2]=f;f=c[d>>2]|0;e=c[d>>2]|0;a=(c[(c[((c[c[d>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+180+4|0;e=c[a>>2]|0;c[a>>2]=e+1;a=c[d>>2]|0;c[(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+180>>2]|0)+(e<<2)>>2]=f;f=c[d>>2]|0;e=c[d>>2]|0;c[(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+180>>2]|0)+(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+180+4>>2]<<2)>>2]=0;f=c[d>>2]|0;e=(c[(c[((c[c[d>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+172|0;if(c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?c[d>>2]|0:(c[d>>2]|0)+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0){f=c[d>>2]|0;g=eK(c[e>>2]|0,(c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]|0)+2<<2)|0}else g=cK((c[e+4>>2]|0)+2<<2)|0;e=c[d>>2]|0;c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]=g;g=c[d>>2]|0;e=c[d>>2]|0;f=(c[(c[((c[c[d>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+172+4|0;e=c[f>>2]|0;c[f>>2]=e+1;f=c[d>>2]|0;c[(c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(e<<2)>>2]=g;g=c[d>>2]|0;e=c[d>>2]|0;c[(c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]<<2)>>2]=0;i=b;return c[d>>2]|0}function Jg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[e>>2]|0)+4>>2]|0)){h=6;break}if((c[(c[c[e>>2]>>2]|0)+(c[g>>2]<<2)>>2]|0)==(c[f>>2]|0))break;c[g>>2]=(c[g>>2]|0)+1}if((h|0)==6){i=d;return}h=(c[e>>2]|0)+4|0;c[h>>2]=(c[h>>2]|0)+-1;c[(c[c[e>>2]>>2]|0)+(c[g>>2]<<2)>>2]=c[(c[c[e>>2]>>2]|0)+(c[(c[e>>2]|0)+4>>2]<<2)>>2];c[(c[c[e>>2]>>2]|0)+(c[(c[e>>2]|0)+4>>2]<<2)>>2]=0;i=d;return}function Kg(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[d>>2]|0){a=c[d>>2]|0;Jg((c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+180|0,c[d>>2]|0);a=c[d>>2]|0;Jg((c[(c[((c[c[d>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+172|0,c[d>>2]|0);i=b;return}else La(122613,122623,117,122632)}function Lg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[d>>2]|0;e=(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+204|0;if(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?c[d>>2]|0:(c[d>>2]|0)+32|0)+28>>2]|0)+8>>2]|0)+204>>2]|0){a=c[d>>2]|0;f=eK(c[e>>2]|0,(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+204+4>>2]|0)+2<<2)|0}else f=cK((c[e+4>>2]|0)+2<<2)|0;e=c[d>>2]|0;c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+204>>2]=f;f=c[d>>2]|0;e=c[d>>2]|0;a=(c[(c[((c[c[d>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+204+4|0;e=c[a>>2]|0;c[a>>2]=e+1;a=c[d>>2]|0;c[(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+204>>2]|0)+(e<<2)>>2]=f;f=c[d>>2]|0;e=c[d>>2]|0;c[(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+204>>2]|0)+(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+204+4>>2]<<2)>>2]=0;i=b;return}function Mg(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[d>>2]|0;Yg(c[d>>2]|0,(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+204|0);i=b;return}function Ng(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=d;c[j>>2]=e;c[k>>2]=f;c[m>>2]=bK(64)|0;f=(c[m>>2]|0)+32|0;c[f>>2]=c[f>>2]&-4|3;f=c[m>>2]|0;c[f>>2]=c[f>>2]&-4|2;f=bK(176)|0;c[(c[m>>2]|0)+8>>2]=f;c[l>>2]=c[m>>2];f=c[l>>2]|0;c[((c[c[l>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]=c[h>>2];h=c[l>>2]|0;c[((c[c[l>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]=c[j>>2];a[(c[(c[l>>2]|0)+8>>2]|0)+112>>0]=1;if(!(c[k>>2]|0)){c[(c[(c[l>>2]|0)+8>>2]|0)+156>>2]=1;b[(c[(c[l>>2]|0)+8>>2]|0)+154>>1]=1;b[(c[(c[l>>2]|0)+8>>2]|0)+168>>1]=1;b[(c[(c[l>>2]|0)+8>>2]|0)+170>>1]=1;n=c[l>>2]|0;i=g;return n|0}j=c[l>>2]|0;c[j>>2]=c[j>>2]&15|((c[c[k>>2]>>2]|0)>>>4&268435455)<<4;j=(c[m>>2]|0)+32|0;c[j>>2]=c[j>>2]&15|((c[c[k>>2]>>2]|0)>>>4&268435455)<<4;b[(c[(c[l>>2]|0)+8>>2]|0)+168>>1]=b[(c[(c[k>>2]|0)+8>>2]|0)+168>>1]|0;b[(c[(c[l>>2]|0)+8>>2]|0)+154>>1]=b[(c[(c[k>>2]|0)+8>>2]|0)+154>>1]|0;c[(c[(c[l>>2]|0)+8>>2]|0)+156>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+156>>2];b[(c[(c[l>>2]|0)+8>>2]|0)+170>>1]=b[(c[(c[k>>2]|0)+8>>2]|0)+170>>1]|0;j=c[l>>2]|0;m=c[k>>2]|0;h=c[l>>2]|0;if((c[((c[c[l>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)!=(c[((c[c[k>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)){m=c[l>>2]|0;j=c[k>>2]|0;if((c[((c[h>>2]&3|0)==3?m:m+32|0)+28>>2]|0)==(c[((c[c[k>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)){o=(c[(c[l>>2]|0)+8>>2]|0)+16|0;p=(c[(c[k>>2]|0)+8>>2]|0)+56|0;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0))}}else{o=(c[h+8>>2]|0)+16|0;p=(c[(c[k>>2]|0)+8>>2]|0)+16|0;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0))}h=c[l>>2]|0;j=c[k>>2]|0;m=c[l>>2]|0;if((c[((c[c[l>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)!=(c[((c[c[k>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)){j=c[l>>2]|0;h=c[k>>2]|0;if((c[((c[m>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)==(c[((c[c[k>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)){o=(c[(c[l>>2]|0)+8>>2]|0)+56|0;p=(c[(c[k>>2]|0)+8>>2]|0)+16|0;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0))}}else{o=(c[m+8>>2]|0)+56|0;p=(c[(c[k>>2]|0)+8>>2]|0)+56|0;q=o+40|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0))}if(!(c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]|0))c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]=c[l>>2];c[(c[(c[l>>2]|0)+8>>2]|0)+116>>2]=c[k>>2];n=c[l>>2]|0;i=g;return n|0}function Og(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=Ig(Ng(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)|0)|0;i=e;return d|0}function Pg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];if(c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0)c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0)+8>>2]|0)+168>>2]=c[f>>2];c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]=c[f>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+168>>2]=0;if((c[f>>2]|0)!=(c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0)){i=d;return}else La(122649,122623,215,122665)}function Qg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[e>>2]|0)==(c[f>>2]|0))La(122675,122623,220,122682);if(c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0)La(122695,122623,221,122682);c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2];if(c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]|0)c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]|0)+8>>2]|0)+168>>2]=c[f>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+168>>2]=c[e>>2];c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]=c[f>>2];i=d;return}function Rg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(Zg(c[e>>2]|0,c[f>>2]|0)|0))La(122714,122623,231,122735);if(c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0)c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0)+8>>2]|0)+168>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+168>>2];b=c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0;if(c[(c[(c[f>>2]|0)+8>>2]|0)+168>>2]|0){c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+168>>2]|0)+8>>2]|0)+164>>2]=b;i=d;return}else{c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]=b;i=d;return}}function Sg(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=bK(52)|0;b=c[f>>2]|0;c[b>>2]=c[b>>2]&-4|1;b=bK(304)|0;c[(c[f>>2]|0)+8>>2]=b;b=rC(c[e>>2]|0)|0;c[(c[f>>2]|0)+12>>2]=b;a[(c[(c[f>>2]|0)+8>>2]|0)+156>>0]=1;h[(c[(c[f>>2]|0)+8>>2]|0)+96>>3]=1.0;h[(c[(c[f>>2]|0)+8>>2]|0)+88>>3]=1.0;h[(c[(c[f>>2]|0)+8>>2]|0)+80>>3]=1.0;c[(c[(c[f>>2]|0)+8>>2]|0)+216>>2]=1;c[(c[(c[f>>2]|0)+8>>2]|0)+172+4>>2]=0;b=bK(20)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]=b;c[(c[(c[f>>2]|0)+8>>2]|0)+180+4>>2]=0;b=bK(20)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]=b;Pg(c[e>>2]|0,c[f>>2]|0);b=(c[(c[e>>2]|0)+8>>2]|0)+232|0;c[b>>2]=(c[b>>2]|0)+1;i=d;return c[f>>2]|0}function Tg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;d=c[g>>2]|0;b=(c[(c[((c[c[g>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+188|0;if(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?c[g>>2]|0:(c[g>>2]|0)+32|0)+28>>2]|0)+8>>2]|0)+188>>2]|0){d=c[g>>2]|0;h=eK(c[b>>2]|0,(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+188+4>>2]|0)+2<<2)|0}else h=cK((c[b+4>>2]|0)+2<<2)|0;b=c[g>>2]|0;c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+188>>2]=h;h=c[g>>2]|0;b=c[g>>2]|0;d=(c[(c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+188+4|0;b=c[d>>2]|0;c[d>>2]=b+1;d=c[g>>2]|0;c[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+188>>2]|0)+(b<<2)>>2]=h;h=c[g>>2]|0;b=c[g>>2]|0;c[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+188>>2]|0)+(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)+8>>2]|0)+188+4>>2]<<2)>>2]=0;h=c[g>>2]|0;b=(c[(c[((c[c[g>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)+8>>2]|0)+196|0;if(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?c[g>>2]|0:(c[g>>2]|0)+-32|0)+28>>2]|0)+8>>2]|0)+196>>2]|0){h=c[g>>2]|0;j=eK(c[b>>2]|0,(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)+8>>2]|0)+196+4>>2]|0)+2<<2)|0}else j=cK((c[b+4>>2]|0)+2<<2)|0;b=c[g>>2]|0;c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+196>>2]=j;j=c[g>>2]|0;b=c[g>>2]|0;h=(c[(c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+196+4|0;b=c[h>>2]|0;c[h>>2]=b+1;h=c[g>>2]|0;c[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)+8>>2]|0)+196>>2]|0)+(b<<2)>>2]=j;j=c[g>>2]|0;b=c[g>>2]|0;c[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)+8>>2]|0)+196+4>>2]<<2)>>2]=0;a[(c[(c[f>>2]|0)+8>>2]|0)+240>>0]=1;a[(c[(uf(c[f>>2]|0)|0)+8>>2]|0)+240>>0]=1;i=e;return}function Ug(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0))La(122613,122623,269,122752);if((c[(c[(c[d>>2]|0)+8>>2]|0)+116>>2]|0)!=0?(c[(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+116>>2]|0)+8>>2]|0)+172>>2]|0)==(c[d>>2]|0):0)c[(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+116>>2]|0)+8>>2]|0)+172>>2]=0;a=c[d>>2]|0;Jg((c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+188|0,c[d>>2]|0);a=c[d>>2]|0;Jg((c[(c[((c[c[d>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+196|0,c[d>>2]|0);i=b;return}function Vg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;c[e>>2]=a;c[f>>2]=b;if((c[f>>2]|0)==(c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]|0)){$z(0,122769,d)|0;i=d;return}if(c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]|0)La(124624,122623,340,122790);c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]=c[f>>2];_g(c[e>>2]|0,c[f>>2]|0);i=d;return}function Wg(d){d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=d;c[g>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2];while(1){if(!(c[g>>2]|0))break;$g(c[g>>2]|0,c[f>>2]|0);c[h>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2];if(!(b[(c[(c[g>>2]|0)+8>>2]|0)+168>>1]|0))ah(c[g>>2]|0);while(1){if((a[(c[(c[g>>2]|0)+8>>2]|0)+112>>0]|0)!=1)break;d=c[g>>2]|0;if((a[(c[(c[((c[c[g>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+156>>0]|0)!=1)break;d=c[g>>2]|0;if((c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+180+4>>2]|0)!=1)break;d=c[g>>2]|0;c[g>>2]=c[c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2];$g(c[g>>2]|0,c[f>>2]|0)}c[g>>2]=c[h>>2]}c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]=0;i=e;return}function Xg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=d;if((c[b+4>>2]|0)>0?(c[e+4>>2]|0)>0:0){d=(c[b+4>>2]|0)<(c[e+4>>2]|0);c[j>>2]=0;if(d){while(1){d=c[(c[b>>2]|0)+(c[j>>2]<<2)>>2]|0;c[k>>2]=d;if(!d){l=11;break}d=c[k>>2]|0;if((c[((c[c[k>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)==(c[h>>2]|0)){l=11;break}c[j>>2]=(c[j>>2]|0)+1}if((l|0)==11){m=c[k>>2]|0;i=f;return m|0}}else{while(1){h=c[(c[e>>2]|0)+(c[j>>2]<<2)>>2]|0;c[k>>2]=h;if(!h){l=11;break}h=c[k>>2]|0;if((c[((c[c[k>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)==(c[g>>2]|0)){l=11;break}c[j>>2]=(c[j>>2]|0)+1}if((l|0)==11){m=c[k>>2]|0;i=f;return m|0}}}c[k>>2]=0;m=c[k>>2]|0;i=f;return m|0}function Yg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;if((c[e>>2]|0)==(c[(c[c[f>>2]>>2]|0)+(c[g>>2]<<2)>>2]|0)){h=9;break}c[g>>2]=(c[g>>2]|0)+1}if((h|0)==9){i=d;return}h=c[f>>2]|0;if(c[c[f>>2]>>2]|0)j=eK(c[h>>2]|0,(c[(c[f>>2]|0)+4>>2]|0)+2<<2)|0;else j=cK((c[h+4>>2]|0)+2<<2)|0;c[c[f>>2]>>2]=j;j=c[e>>2]|0;e=(c[f>>2]|0)+4|0;h=c[e>>2]|0;c[e>>2]=h+1;c[(c[c[f>>2]>>2]|0)+(h<<2)>>2]=j;c[(c[c[f>>2]>>2]|0)+(c[(c[f>>2]|0)+4>>2]<<2)>>2]=0;i=d;return}function Zg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0)){h=5;break}if((c[g>>2]|0)==(c[f>>2]|0)){h=5;break}c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}if((h|0)==5){i=d;return c[g>>2]|0}return 0}function _g(a,d){a=a|0;d=d|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[g>>2]=a;c[h>>2]=d;if((e[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]|0)<(e[(c[(c[g>>2]|0)+8>>2]|0)+170>>1]|0))b[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]=b[(c[(c[g>>2]|0)+8>>2]|0)+170>>1]|0;while(1){if(!(c[h>>2]|0))break;d=(c[(c[h>>2]|0)+8>>2]|0)+168|0;b[d>>1]=(b[d>>1]|0)+(b[(c[(c[g>>2]|0)+8>>2]|0)+168>>1]|0);d=(c[(c[h>>2]|0)+8>>2]|0)+154|0;b[d>>1]=(b[d>>1]|0)+(b[(c[(c[g>>2]|0)+8>>2]|0)+154>>1]|0);d=(c[(c[h>>2]|0)+8>>2]|0)+156|0;c[d>>2]=(c[d>>2]|0)+(c[(c[(c[g>>2]|0)+8>>2]|0)+156>>2]|0);c[h>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]}i=f;return}function $g(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=a;c[g>>2]=d;d=(c[(c[f>>2]|0)+8>>2]|0)+168|0;b[d>>1]=(b[d>>1]|0)-(b[(c[(c[g>>2]|0)+8>>2]|0)+168>>1]|0);d=(c[(c[f>>2]|0)+8>>2]|0)+154|0;b[d>>1]=(b[d>>1]|0)-(b[(c[(c[g>>2]|0)+8>>2]|0)+154>>1]|0);d=(c[(c[f>>2]|0)+8>>2]|0)+156|0;c[d>>2]=(c[d>>2]|0)-(c[(c[(c[g>>2]|0)+8>>2]|0)+156>>2]|0);i=e;return}function ah(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0))La(122613,122623,128,122803);c[e>>2]=0;while(1){a=c[d>>2]|0;g=c[(c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+180>>2]|0)+(c[e>>2]<<2)>>2]|0;c[f>>2]=g;if(!g)break;if((c[f>>2]|0)==(c[d>>2]|0)){g=c[d>>2]|0;Jg((c[(c[((c[c[d>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)+8>>2]|0)+180|0,c[d>>2]|0)}c[e>>2]=(c[e>>2]|0)+1}c[e>>2]=0;while(1){g=c[d>>2]|0;a=c[(c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(c[e>>2]<<2)>>2]|0;c[f>>2]=a;if(!a)break;if((c[f>>2]|0)==(c[d>>2]|0)){a=c[d>>2]|0;Jg((c[(c[((c[c[d>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+172|0,c[d>>2]|0)}c[e>>2]=(c[e>>2]|0)+1}i=b;return}function bh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;mh(c[f>>2]|0);c[h>>2]=0;c[j>>2]=0;while(1){l=c[f>>2]|0;if((c[h>>2]|0)>=(c[(c[(c[f>>2]|0)+8>>2]|0)+216+4>>2]|0))break;nh(l,c[h>>2]|0);d=oh(c[f>>2]|0,0,2,c[g>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+d;c[h>>2]=(c[h>>2]|0)+1}ph(l);c[h>>2]=1;while(1){m=c[f>>2]|0;if((c[h>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;l=qh(m,c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[h>>2]<<2)>>2]|0,c[g>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+l;c[h>>2]=(c[h>>2]|0)+1}if((c[(c[m+8>>2]|0)+180>>2]|0)<=0){n=c[f>>2]|0;o=c[j>>2]|0;rh(n,o);i=e;return}m=yA(c[f>>2]|0,122825)|0;c[k>>2]=m;if((m|0)!=0?((kO(c[k>>2]|0)|0)&255|0)==0:0){n=c[f>>2]|0;o=c[j>>2]|0;rh(n,o);i=e;return}zk(c[f>>2]|0);a[122836]=1;c[j>>2]=oh(c[f>>2]|0,2,2,c[g>>2]|0)|0;n=c[f>>2]|0;o=c[j>>2]|0;rh(n,o);i=e;return}function ch(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)){i=d;return}c[f>>2]=b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[f>>2]|0)>(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0))break;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)+(c[f>>2]<<2)>>2]=c[c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+4>>2]>>2];c[f>>2]=(c[f>>2]|0)+1}i=d;return}function dh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;ch(c[d>>2]|0);c[e>>2]=1;while(1){if((c[e>>2]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0))break;dh(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+184>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}i=b;return}function eh(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[g>>2]=1;while(1){if((c[g>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;eh(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)){i=d;return}c[f>>2]=b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[f>>2]|0)>(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0))break;c[j>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)+(c[f>>2]<<2)>>2];c[h>>2]=sh(c[e>>2]|0,c[j>>2]|0,-1)|0;c[k>>2]=sh(c[e>>2]|0,c[j>>2]|0,1)|0;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)+(c[f>>2]<<2)>>2]=c[h>>2];g=c[f>>2]|0;a=c[(c[(c[(uf(c[e>>2]|0)|0)+8>>2]|0)+196>>2]|0)+(g<<6)+4>>2]|0;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+4>>2]=a+(c[(c[(c[h>>2]|0)+8>>2]|0)+236>>2]<<2);c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)>>2]=(c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[h>>2]|0)+8>>2]|0)+236>>2]|0)+1;c[f>>2]=(c[f>>2]|0)+1}i=d;return}function fh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=b;c[g>>2]=d;d=c[g>>2]|0;a:do if(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+188>>2]|0){c[h>>2]=0;while(1){b=c[g>>2]|0;k=c[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+188>>2]|0)+(c[h>>2]<<2)>>2]|0;c[j>>2]=k;if(!k)break a;k=c[j>>2]|0;b=c[g>>2]|0;if((c[((c[c[j>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)==(c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0))break a;c[h>>2]=(c[h>>2]|0)+1}}else c[j>>2]=0;while(0);h=c[g>>2]|0;if(!(c[j>>2]|0)){d=c[g>>2]|0;b=c[g>>2]|0;c[j>>2]=Ng(c[((c[h>>2]&3|0)==2?d:d+-32|0)+28>>2]|0,c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0,c[g>>2]|0)|0;b=(c[(c[j>>2]|0)+8>>2]|0)+112|0;if((a[(c[(c[g>>2]|0)+8>>2]|0)+112>>0]|0)==4)a[b>>0]=4;else a[b>>0]=3;c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+96>>2];Tg(c[f>>2]|0,c[j>>2]|0);i=e;return}Vg(h,c[j>>2]|0);if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0))c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]=c[j>>2];if((a[(c[(c[j>>2]|0)+8>>2]|0)+112>>0]|0)==4?(c[(c[(c[j>>2]|0)+8>>2]|0)+116>>2]|0)==0:0)c[(c[(c[j>>2]|0)+8>>2]|0)+116>>2]=c[g>>2];j=c[g>>2]|0;h=c[g>>2]|0;f=(c[(c[((c[c[g>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)+8>>2]|0)+204|0;if(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+204>>2]|0){j=c[g>>2]|0;l=eK(c[f>>2]|0,(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+204+4>>2]|0)+2<<2)|0}else l=cK((c[f+4>>2]|0)+2<<2)|0;f=c[g>>2]|0;c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+204>>2]=l;l=c[g>>2]|0;f=c[g>>2]|0;j=(c[(c[((c[c[g>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+204+4|0;f=c[j>>2]|0;c[j>>2]=f+1;j=c[g>>2]|0;c[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+204>>2]|0)+(f<<2)>>2]=l;l=c[g>>2]|0;f=c[g>>2]|0;c[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+204>>2]|0)+(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+204+4>>2]<<2)>>2]=0;i=e;return}function gh(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[e>>2]=a;c[j>>2]=bK((b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0)+2<<2)|0;c[k>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;a=(c[j>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]<<2)|0;c[a>>2]=(c[a>>2]|0)+1;c[l>>2]=OA(c[e>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;a=c[l>>2]|0;c[g>>2]=c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+232>>2];a=c[l>>2]|0;c[h>>2]=c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+232>>2];if((c[g>>2]|0)>(c[h>>2]|0)){c[m>>2]=c[g>>2];c[g>>2]=c[h>>2];c[h>>2]=c[m>>2]}c[f>>2]=(c[g>>2]|0)+1;while(1){if((c[f>>2]|0)>=(c[h>>2]|0))break;a=(c[j>>2]|0)+(c[f>>2]<<2)|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=(c[f>>2]|0)+1}c[l>>2]=QA(c[e>>2]|0,c[l>>2]|0)|0}c[k>>2]=aC(c[e>>2]|0,c[k>>2]|0)|0}k=bK((b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0)+2<<6)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]=k;c[f>>2]=b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[f>>2]|0)>(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0))break;k=c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)>>2]=k;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+8>>2]=k;k=bK((c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0)+1<<2)|0;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+4>>2]=k;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+12>>2]=k;c[f>>2]=(c[f>>2]|0)+1}O4(c[j>>2]|0);i=d;return}function hh(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+112|0;f=e+64|0;g=e+48|0;h=e+24|0;j=e;k=e+104|0;l=e+100|0;m=e+96|0;n=e+92|0;c[k>>2]=a;c[l>>2]=d;c[n>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2];c[m>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)>>2];if((c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+8>>2]|0)<=0){d=wB(c[k>>2]|0)|0;a=wB(c[l>>2]|0)|0;o=c[n>>2]|0;p=c[m>>2]|0;c[j>>2]=1070;c[j+4>>2]=d;c[j+8>>2]=a;c[j+12>>2]=o;c[j+16>>2]=p;$z(1,122837,j)|0;i=e;return}c[(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+4>>2]|0)+(c[m>>2]<<2)>>2]=c[l>>2];c[(c[(c[l>>2]|0)+8>>2]|0)+236>>2]=c[m>>2];m=(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)|0;c[m>>2]=(c[m>>2]|0)+1;if((c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)>>2]|0)>(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+8>>2]|0))La(122892,122928,1077,122939);if((c[(c[(c[l>>2]|0)+8>>2]|0)+236>>2]|0)>(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+8>>2]|0)){m=wB(c[l>>2]|0)|0;j=c[(c[(c[l>>2]|0)+8>>2]|0)+236>>2]|0;p=c[n>>2]|0;o=c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+8>>2]|0;c[h>>2]=1090;c[h+4>>2]=m;c[h+8>>2]=j;c[h+12>>2]=p;c[h+16>>2]=o;$z(1,122955,h)|0;i=e;return}if((c[n>>2]|0)>=(b[(c[(c[k>>2]|0)+8>>2]|0)+236>>1]|0)?(c[n>>2]|0)<=(b[(c[(c[k>>2]|0)+8>>2]|0)+238>>1]|0):0){if(((c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+4>>2]|0)+(c[(c[(c[l>>2]|0)+8>>2]|0)+236>>2]<<2)|0)>>>0<=((c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+12>>2]|0)+(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+8>>2]<<2)|0)>>>0){i=e;return}h=c[n>>2]|0;o=wB(c[l>>2]|0)|0;p=(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+4>>2]|0)+(c[(c[(c[l>>2]|0)+8>>2]|0)+236>>2]<<2)|0;l=c[n>>2]|0;j=c[n>>2]|0;m=(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+12>>2]|0)+(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+8>>2]<<2)|0;c[f>>2]=1101;c[f+4>>2]=h;c[f+8>>2]=o;c[f+12>>2]=p;c[f+16>>2]=l;c[f+20>>2]=j;c[f+24>>2]=m;$z(1,123089,f)|0;i=e;return}f=c[n>>2]|0;n=b[(c[(c[k>>2]|0)+8>>2]|0)+236>>1]|0;m=b[(c[(c[k>>2]|0)+8>>2]|0)+238>>1]|0;c[g>>2]=1095;c[g+4>>2]=f;c[g+8>>2]=n;c[g+12>>2]=m;$z(1,123028,g)|0;i=e;return}function ih(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+48|0;g=f;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;c[h>>2]=d;c[j>>2]=e;c[p>>2]=aO(c[(c[(c[h>>2]|0)+8>>2]|0)+232>>2]|0)|0;c[m>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[m>>2]|0))break;a[(c[(c[m>>2]|0)+8>>2]|0)+157>>0]=0;c[m>>2]=c[(c[(c[m>>2]|0)+8>>2]|0)+164>>2]}c[k>>2]=b[(c[(c[h>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[k>>2]|0)>(b[(c[(c[h>>2]|0)+8>>2]|0)+238>>1]|0))break;c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]=0;c[k>>2]=(c[k>>2]|0)+1}c[m>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[m>>2]|0))break;e=c[(c[m>>2]|0)+8>>2]|0;if(!(c[j>>2]|0))t=c[e+172>>2]|0;else t=c[e+180>>2]|0;c[o>>2]=t;a:do if((c[c[o>>2]>>2]|0)==0?(a[(c[(c[m>>2]|0)+8>>2]|0)+157>>0]|0)==0:0){a[(c[(c[m>>2]|0)+8>>2]|0)+157>>0]=1;cO(c[p>>2]|0,c[m>>2]|0);while(1){e=dO(c[p>>2]|0)|0;c[n>>2]=e;if(!e)break a;e=c[h>>2]|0;d=c[n>>2]|0;if((a[(c[(c[n>>2]|0)+8>>2]|0)+159>>0]|0)!=7){hh(e,d);jh(c[p>>2]|0,c[n>>2]|0,c[j>>2]|0);continue}else{yk(e,d,c[j>>2]|0,c[p>>2]|0);continue}}}while(0);c[m>>2]=c[(c[(c[m>>2]|0)+8>>2]|0)+164>>2]}if(dO(c[p>>2]|0)|0)$z(1,123201,g)|0;c[k>>2]=b[(c[(c[h>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[k>>2]|0)>(b[(c[(c[h>>2]|0)+8>>2]|0)+238>>1]|0))break;a[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+49>>0]=0;b:do if((c[(c[(c[h>>2]|0)+8>>2]|0)+116>>2]&1|0)!=0?(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0)>0:0){c[s>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2];c[q>>2]=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0)-1;c[r>>2]=(c[q>>2]|0)/2|0;c[l>>2]=0;while(1){if((c[l>>2]|0)>(c[r>>2]|0))break b;th(c[(c[s>>2]|0)+(c[l>>2]<<2)>>2]|0,c[(c[s>>2]|0)+((c[q>>2]|0)-(c[l>>2]|0)<<2)>>2]|0);c[l>>2]=(c[l>>2]|0)+1}}while(0);c[k>>2]=(c[k>>2]|0)+1}k=c[h>>2]|0;if((k|0)!=(uf(c[h>>2]|0)|0)){u=c[p>>2]|0;bO(u);i=f;return}if((kh(c[h>>2]|0)|0)<=0){u=c[p>>2]|0;bO(u);i=f;return}uh(c[h>>2]|0,0);u=c[p>>2]|0;bO(u);i=f;return}function jh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;e=(c[j>>2]|0)==0;c[k>>2]=0;if(e){while(1){if((c[k>>2]|0)>=(c[(c[(c[h>>2]|0)+8>>2]|0)+180+4>>2]|0))break;c[l>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+180>>2]|0)+(c[k>>2]<<2)>>2];e=c[l>>2]|0;if(!(a[(c[(c[((c[c[l>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0)){e=c[l>>2]|0;a[(c[(c[((c[c[l>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+157>>0]=1;e=c[l>>2]|0;cO(c[g>>2]|0,c[((c[c[l>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)}c[k>>2]=(c[k>>2]|0)+1}i=f;return}else{while(1){if((c[k>>2]|0)>=(c[(c[(c[h>>2]|0)+8>>2]|0)+172+4>>2]|0))break;c[l>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]|0)+(c[k>>2]<<2)>>2];e=c[l>>2]|0;if(!(a[(c[(c[((c[c[l>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0)){e=c[l>>2]|0;a[(c[(c[((c[c[l>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+157>>0]=1;e=c[l>>2]|0;cO(c[g>>2]|0,c[((c[c[l>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)}c[k>>2]=(c[k>>2]|0)+1}i=f;return}}function kh(d){d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=d;c[f>>2]=c[12547];c[h>>2]=0;c[g>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[g>>2]|0)>=(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;if(a[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)+49>>0]|0)c[h>>2]=(c[h>>2]|0)+(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)+52>>2]|0);else{d=vh(c[f>>2]|0,c[g>>2]|0)|0;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)+52>>2]=d;c[j>>2]=d;c[h>>2]=(c[h>>2]|0)+(c[j>>2]|0);a[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)+49>>0]=1}c[g>>2]=(c[g>>2]|0)+1}i=e;return c[h>>2]|0}function lh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=c[d>>2]|0;f=wh(c[((c[c[d>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)|0;a=c[d>>2]|0;c[e>>2]=c[50192+((wh(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)|0)*12|0)+(f<<2)>>2];f=(c[(c[d>>2]|0)+8>>2]|0)+156|0;c[f>>2]=_(c[f>>2]|0,c[e>>2]|0)|0;i=b;return}function mh(d){d=d|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+4|0;h=f;c[g>>2]=d;if(a[138998]|0)_N();a[122836]=0;c[12547]=c[g>>2];c[h>>2]=(lB(uf(c[g>>2]|0)|0)|0)+1;c[12560]=bK(c[h>>2]<<2)|0;c[12559]=bK(c[h>>2]<<2)|0;ci(c[g>>2]|0);if(e[(c[(c[g>>2]|0)+8>>2]|0)+136>>1]&16)di(c[g>>2]|0);mk(c[g>>2]|0);bl(c[g>>2]|0,1);gh(c[g>>2]|0);Gh(c[g>>2]|0);c[12561]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];c[12562]=b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1];i=f;return}function nh(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=d;c[(c[(c[f>>2]|0)+8>>2]|0)+192>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+216>>2]|0)+(c[g>>2]<<2)>>2];if((c[g>>2]|0)<=0){i=e;return}c[h>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[h>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)+4>>2]=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)+4>>2]|0)+(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]<<2);c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]=0;c[h>>2]=(c[h>>2]|0)+1}i=e;return}function oh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+64|0;j=g;k=g+56|0;l=g+52|0;m=g+48|0;n=g+44|0;o=g+40|0;p=g+36|0;q=g+32|0;r=g+28|0;s=g+24|0;t=g+20|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if((c[l>>2]|0)>1){f=kh(c[k>>2]|0)|0;c[t>>2]=f;c[s>>2]=f;Uh(c[k>>2]|0)}else{c[t>>2]=2147483647;c[s>>2]=2147483647}c[r>>2]=c[l>>2];while(1){if((c[r>>2]|0)>(c[m>>2]|0))break;l=c[13798]|0;if((c[r>>2]|0)<=1){c[o>>2]=4<(l|0)?4:c[13798]|0;f=c[k>>2]|0;if((f|0)==(uf(c[k>>2]|0)|0))ih(c[k>>2]|0,c[r>>2]|0);if(!(c[r>>2]|0))Hh(c[k>>2]|0);Ih(c[k>>2]|0);f=kh(c[k>>2]|0)|0;c[s>>2]=f;if((f|0)<=(c[t>>2]|0)){Uh(c[k>>2]|0);c[t>>2]=c[s>>2]}c[q>>2]=0}else{c[o>>2]=l;if((c[s>>2]|0)>(c[t>>2]|0))Vh(c[k>>2]|0);c[s>>2]=c[t>>2]}c[q>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[o>>2]|0))break;if(a[138998]|0){l=c[24742]|0;f=c[p>>2]|0;e=c[q>>2]|0;d=c[s>>2]|0;b=c[t>>2]|0;c[j>>2]=c[r>>2];c[j+4>>2]=f;c[j+8>>2]=e;c[j+12>>2]=d;c[j+16>>2]=b;Y2(l,123634,j)|0}l=c[q>>2]|0;c[q>>2]=l+1;if((l|0)>=(c[12563]|0)|(c[s>>2]|0)==0)break;Wh(c[k>>2]|0,c[p>>2]|0);l=kh(c[k>>2]|0)|0;c[s>>2]=l;if((l|0)<=(c[t>>2]|0)){Uh(c[k>>2]|0);if(+(c[s>>2]|0)<+h[4138]*+(c[t>>2]|0))c[q>>2]=0;c[t>>2]=c[s>>2]}c[p>>2]=(c[p>>2]|0)+1}if(!(c[s>>2]|0))break;c[r>>2]=(c[r>>2]|0)+1}if((c[s>>2]|0)>(c[t>>2]|0))Vh(c[k>>2]|0);if((c[t>>2]|0)>0){uh(c[k>>2]|0,0);c[t>>2]=kh(c[k>>2]|0)|0}if(!(c[n>>2]|0)){u=c[t>>2]|0;i=g;return u|0}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[o>>2]|0))break;Xh(c[k>>2]|0)|0;c[p>>2]=(c[p>>2]|0)+1}u=c[t>>2]|0;i=g;return u|0}function ph(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;c[g>>2]=d;Th(c[g>>2]|0);c[j>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0))break;c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+8>>2];c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+12>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;c[k>>2]=c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2];if(!(c[k>>2]|0)){l=6;break}c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]=c[h>>2];c[h>>2]=(c[h>>2]|0)+1}if((l|0)==6){l=0;if(a[138998]|0){d=c[24742]|0;m=wB(c[g>>2]|0)|0;n=c[j>>2]|0;o=c[h>>2]|0;p=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0;c[f>>2]=m;c[f+4>>2]=n;c[f+8>>2]=o;c[f+12>>2]=p;Y2(d,123584,f)|0}c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]=c[h>>2]}c[j>>2]=(c[j>>2]|0)+1}i=e;return}
function Pp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+64|0;k=j+52|0;l=j+48|0;m=j+44|0;n=j+40|0;o=j+36|0;p=j+32|0;q=j+28|0;r=j+24|0;s=j+20|0;t=j+16|0;u=j+12|0;v=j+8|0;w=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[v>>2]=0;c[q>>2]=cK(c[c[l>>2]>>2]<<2)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[c[l>>2]>>2]|0))break;c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=1;c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;if((c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0)>=0?(c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0)<(c[c[l>>2]>>2]|0):0)c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]<<2)>>2]=-1;c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[c[l>>2]>>2]|0))break;if((c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)>=0){g=c[v>>2]|0;c[v>>2]=g+1;c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=g}c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[c[l>>2]>>2]|0))break;a:do if((c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)>=0){c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[k>>2]|0))break a;v=_(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0,c[k>>2]|0)|0;g=_(c[r>>2]|0,c[k>>2]|0)|0;h[(c[o>>2]|0)+(g+(c[u>>2]|0)<<3)>>3]=+h[(c[p>>2]|0)+(v+(c[u>>2]|0)<<3)>>3];c[u>>2]=(c[u>>2]|0)+1}}while(0);c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;c[s>>2]=c[(c[n>>2]|0)+(c[r>>2]<<2)>>2];h[w>>3]=+((c[(c[(c[l>>2]|0)+20>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0)-(c[(c[(c[l>>2]|0)+20>>2]|0)+(c[s>>2]<<2)>>2]|0)|0);c[u>>2]=0;while(1){x=c[s>>2]|0;if((c[u>>2]|0)>=(c[k>>2]|0))break;p=_(x,c[k>>2]|0)|0;h[(c[o>>2]|0)+(p+(c[u>>2]|0)<<3)>>3]=0.0;c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=c[(c[(c[l>>2]|0)+20>>2]|0)+(x<<2)>>2];while(1){p=(c[t>>2]|0)<(c[(c[(c[l>>2]|0)+20>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0);c[u>>2]=0;if(!p)break;while(1){y=c[t>>2]|0;if((c[u>>2]|0)>=(c[k>>2]|0))break;p=_(c[(c[(c[l>>2]|0)+24>>2]|0)+(y<<2)>>2]|0,c[k>>2]|0)|0;v=_(c[s>>2]|0,c[k>>2]|0)|0;g=(c[o>>2]|0)+(v+(c[u>>2]|0)<<3)|0;h[g>>3]=+h[g>>3]+ +h[(c[o>>2]|0)+(p+(c[u>>2]|0)<<3)>>3];c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=y+1}while(1){if((c[u>>2]|0)>=(c[k>>2]|0))break;p=_(c[s>>2]|0,c[k>>2]|0)|0;g=(c[o>>2]|0)+(p+(c[u>>2]|0)<<3)|0;h[g>>3]=+h[g>>3]/+h[w>>3];c[u>>2]=(c[u>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}O4(c[q>>2]|0);i=j;return}function Qp(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=+k;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;l=i;i=i+64|0;m=l+56|0;n=l+52|0;o=l+48|0;p=l+44|0;q=l+40|0;r=l+36|0;s=l+32|0;t=l;u=l+28|0;v=l+24|0;w=l+20|0;x=l+16|0;y=l+12|0;z=l+8|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;h[t>>3]=k;Wv(c[o>>2]|0,0,c[q>>2]|0,0,r,0,c[m>>2]|0);if(!((c[s>>2]|0)>0&(c[s>>2]|0)<7)){i=l;return}Fp(c[m>>2]|0,c[n>>2]|0,c[r>>2]|0);c[u>>2]=c[c[p>>2]>>2];c[v>>2]=c[(c[p>>2]|0)+20>>2];c[w>>2]=c[(c[p>>2]|0)+24>>2];c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[u>>2]|0))break;c[y>>2]=(c[(c[v>>2]|0)+(c[x>>2]<<2)>>2]|0)+1;while(1){if((c[y>>2]|0)>=(c[(c[v>>2]|0)+((c[x>>2]|0)+1<<2)>>2]|0))break;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[m>>2]|0))break;k=+h[t>>3];A=k*(+rw()-.5);p=_(c[(c[w>>2]|0)+(c[y>>2]<<2)>>2]|0,c[m>>2]|0)|0;n=(c[r>>2]|0)+(p+(c[z>>2]|0)<<3)|0;h[n>>3]=+h[n>>3]+A;c[z>>2]=(c[z>>2]|0)+1}c[y>>2]=(c[y>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+1}i=l;return}function Rp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+96|0;g=f+80|0;j=f+76|0;k=f+72|0;l=f+56|0;m=f+68|0;n=f+64|0;o=f+40|0;p=f+24|0;q=f+16|0;r=f+8|0;s=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=e;h[s>>3]=.017453277777777776;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;h[p+(c[m>>2]<<3)>>3]=0.0;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;c[n>>2]=0;while(1){t=c[m>>2]|0;if((c[n>>2]|0)>=(c[j>>2]|0))break;d=_(t,c[j>>2]|0)|0;b=p+(c[n>>2]<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[k>>2]|0)+(d+(c[n>>2]|0)<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=t+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;t=p+(c[m>>2]<<3)|0;h[t>>3]=+h[t>>3]/+(c[g>>2]|0);c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[j>>2]|0))break;t=_(c[j>>2]|0,c[m>>2]|0)|0;d=_(c[j>>2]|0,c[m>>2]|0)|0;h[(c[k>>2]|0)+(d+(c[n>>2]|0)<<3)>>3]=+h[(c[k>>2]|0)+(t+(c[n>>2]|0)<<3)>>3]-+h[p+(c[n>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}h[o>>3]=+Q(+(-+h[l>>3]*+h[s>>3]));h[o+8>>3]=+R(+(-+h[l>>3]*+h[s>>3]));c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;s=_(c[j>>2]|0,c[m>>2]|0)|0;l=(_(c[j>>2]|0,c[m>>2]|0)|0)+1|0;h[q>>3]=+h[(c[k>>2]|0)+(s<<3)>>3]*+h[o>>3]+ +h[(c[k>>2]|0)+(l<<3)>>3]*+h[o+8>>3];l=_(c[j>>2]|0,c[m>>2]|0)|0;s=(_(c[j>>2]|0,c[m>>2]|0)|0)+1|0;h[r>>3]=-+h[(c[k>>2]|0)+(l<<3)>>3]*+h[o+8>>3]+ +h[(c[k>>2]|0)+(s<<3)>>3]*+h[o>>3];s=_(c[j>>2]|0,c[m>>2]|0)|0;h[(c[k>>2]|0)+(s<<3)>>3]=+h[q>>3];s=(_(c[j>>2]|0,c[m>>2]|0)|0)+1|0;h[(c[k>>2]|0)+(s<<3)>>3]=+h[r>>3];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function Sp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;w3(c[f>>2]|0,c[e>>2]|0,8,68);i=d;return}function Tp(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+32|0;k=j+28|0;l=j+24|0;m=j+8|0;n=j;o=j+20|0;p=j+16|0;c[k>>2]=a;c[l>>2]=b;h[m>>3]=d;h[n>>3]=e;c[o>>2]=f;c[p>>2]=g;e=+Q(+(+h[n>>3]));g=_(c[l>>2]|0,c[o>>2]|0)|0;f=_(c[l>>2]|0,c[p>>2]|0)|0;h[(c[k>>2]|0)+(f<<3)>>3]=e*+h[m>>3]+ +h[(c[k>>2]|0)+(g<<3)>>3];e=+R(+(+h[n>>3]));n=(_(c[l>>2]|0,c[o>>2]|0)|0)+1|0;o=(_(c[l>>2]|0,c[p>>2]|0)|0)+1|0;h[(c[k>>2]|0)+(o<<3)>>3]=e*+h[m>>3]+ +h[(c[k>>2]|0)+(n<<3)>>3];i=j;return}function Up(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=i;i=i+64|0;l=k+52|0;m=k+48|0;n=k+44|0;o=k+40|0;p=k+36|0;q=k+8|0;r=k+32|0;s=k+28|0;t=k+24|0;u=k;v=k+20|0;w=k+16|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;h[q>>3]=g;c[r>>2]=j;h[u>>3]=0.0;c[w>>2]=c[m>>2];if(!((Ov(c[w>>2]|0,0)|0)!=0?(c[(c[w>>2]|0)+16>>2]|0)==1:0))x=3;do if((x|0)==3){j=c[w>>2]|0;if((c[(c[w>>2]|0)+16>>2]|0)==1){c[w>>2]=Mv(j,0)|0;c[w>>2]=Sv(c[w>>2]|0)|0;break}else{c[w>>2]=bw(j)|0;break}}while(0);c[w>>2]=Sv(c[w>>2]|0)|0;c[c[r>>2]>>2]=0;c[s>>2]=c[c[w>>2]>>2];a:do if(!(c[n>>2]|0)){x=cK(_(c[s>>2]<<3,c[l>>2]|0)|0)|0;c[c[n>>2]>>2]=x;s2(123);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(_(c[l>>2]|0,c[s>>2]|0)|0))break a;g=+rw();h[(c[c[n>>2]>>2]|0)+(c[v>>2]<<3)>>3]=g;c[v>>2]=(c[v>>2]|0)+1}}while(0);x=c[w>>2]|0;j=c[l>>2]|0;g=+h[u>>3];u=c[c[n>>2]>>2]|0;if(c[o>>2]|0)c[t>>2]=ix(x,j,g,u,2,1)|0;else c[t>>2]=ix(x,j,g,u,0,1)|0;if(c[t>>2]|0){h[(c[t>>2]|0)+40>>3]=.1;c[(c[t>>2]|0)+24>>2]=5;+kx(c[t>>2]|0,c[l>>2]|0,c[c[n>>2]>>2]|0,c[p>>2]|0,+h[q>>3]);c[v>>2]=0;while(1){q=(c[v>>2]|0)<(_(c[l>>2]|0,c[s>>2]|0)|0);y=c[t>>2]|0;if(!q)break;q=(c[c[n>>2]>>2]|0)+(c[v>>2]<<3)|0;h[q>>3]=+h[q>>3]/+h[y+32>>3];c[v>>2]=(c[v>>2]|0)+1}jx(y)}else c[c[r>>2]>>2]=-1;if((c[w>>2]|0)==(c[m>>2]|0)){i=k;return}Lv(c[w>>2]|0);i=k;return}function Vp(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;l=i;i=i+48|0;m=l+32|0;n=l+24|0;o=l+20|0;p=l+16|0;q=l+12|0;r=l;s=l+8|0;c[m>>2]=a;c[l+28>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;h[r>>3]=j;c[s>>2]=k;Up(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,+h[r>>3],c[s>>2]|0);i=l;return}function Wp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0;j=i;i=i+128|0;k=j+124|0;l=j+116|0;m=j+40|0;n=j+32|0;o=j+104|0;p=j+100|0;q=j+96|0;r=j+92|0;s=j+88|0;t=j+84|0;u=j+80|0;v=j+76|0;w=j+72|0;x=j+68|0;y=j+64|0;z=j+60|0;A=j+56|0;B=j+52|0;C=j+48|0;D=j+24|0;E=j+16|0;F=j+8|0;G=j;c[j+120>>2]=a;c[l>>2]=b;c[j+112>>2]=d;h[m>>3]=e;h[n>>3]=f;c[j+108>>2]=g;c[s>>2]=c[c[l>>2]>>2];c[t>>2]=c[(c[l>>2]|0)+20>>2];c[u>>2]=c[(c[l>>2]|0)+24>>2];c[C>>2]=c[(c[l>>2]|0)+28>>2];h[G>>3]=.01;if(!(Ov(c[l>>2]|0,0)|0))La(133286,129831,37,129848);c[o>>2]=cK(56)|0;c[(c[o>>2]|0)+20>>2]=0;c[(c[o>>2]|0)+24>>2]=2;c[(c[o>>2]|0)+12>>2]=0;g=cK(16)|0;c[(c[o>>2]|0)+20>>2]=g;h[c[(c[o>>2]|0)+20>>2]>>3]=+h[m>>3];h[(c[(c[o>>2]|0)+20>>2]|0)+8>>3]=+h[n>>3];c[(c[o>>2]|0)+16>>2]=96;h[(c[o>>2]|0)+40>>3]=.01;n=~~+O(+(+(c[c[l>>2]>>2]|0)));c[(c[o>>2]|0)+48>>2]=n;n=Nv(c[s>>2]|0,c[s>>2]|0,(c[(c[l>>2]|0)+8>>2]|0)+(c[s>>2]|0)|0,1,1)|0;c[(c[o>>2]|0)+4>>2]=n;n=Nv(c[s>>2]|0,c[s>>2]|0,(c[(c[l>>2]|0)+8>>2]|0)+(c[s>>2]|0)|0,1,1)|0;c[(c[o>>2]|0)+8>>2]=n;c[v>>2]=c[(c[(c[o>>2]|0)+4>>2]|0)+20>>2];c[w>>2]=c[(c[(c[o>>2]|0)+4>>2]|0)+24>>2];c[x>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+20>>2];c[y>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+24>>2];c[B>>2]=c[(c[(c[o>>2]|0)+4>>2]|0)+28>>2];c[A>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+28>>2];if((c[(c[o>>2]|0)+4>>2]|0)!=0?(c[(c[o>>2]|0)+8>>2]|0)!=0:0){c[v>>2]=c[(c[(c[o>>2]|0)+4>>2]|0)+20>>2];c[w>>2]=c[(c[(c[o>>2]|0)+4>>2]|0)+24>>2];c[x>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+20>>2];c[y>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+24>>2];c[B>>2]=c[(c[(c[o>>2]|0)+4>>2]|0)+28>>2];c[A>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+28>>2];c[c[x>>2]>>2]=0;c[c[v>>2]>>2]=0;c[z>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[s>>2]|0))break;h[E>>3]=0.0;h[D>>3]=0.0;c[q>>2]=c[(c[t>>2]|0)+(c[p>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[t>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;c[r>>2]=c[(c[u>>2]|0)+(c[q>>2]<<2)>>2];if((c[r>>2]|0)!=(c[p>>2]|0)){f=+h[(c[C>>2]|0)+(c[q>>2]<<3)>>3];if((+h[(c[C>>2]|0)+(c[q>>2]<<3)>>3]>=0.0?f:-f)>+h[G>>3]){f=+h[(c[C>>2]|0)+(c[q>>2]<<3)>>3];H=+h[(c[C>>2]|0)+(c[q>>2]<<3)>>3]>=0.0?f:-f}else H=+h[G>>3];h[F>>3]=H;n=c[r>>2]|0;c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]=n;c[(c[y>>2]|0)+(c[z>>2]<<2)>>2]=n;h[(c[B>>2]|0)+(c[z>>2]<<3)>>3]=-1.0/(+h[F>>3]*+h[F>>3]);h[(c[B>>2]|0)+(c[z>>2]<<3)>>3]=-1.0;h[(c[A>>2]|0)+(c[z>>2]<<3)>>3]=+h[(c[B>>2]|0)+(c[z>>2]<<3)>>3]*+h[F>>3];h[E>>3]=+h[E>>3]+ +h[(c[B>>2]|0)+(c[z>>2]<<3)>>3];h[D>>3]=+h[D>>3]+ +h[(c[A>>2]|0)+(c[z>>2]<<3)>>3];c[z>>2]=(c[z>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+1}n=c[p>>2]|0;c[(c[w>>2]|0)+(c[z>>2]<<2)>>2]=n;c[(c[y>>2]|0)+(c[z>>2]<<2)>>2]=n;h[(c[B>>2]|0)+(c[z>>2]<<3)>>3]=-+h[E>>3];h[(c[A>>2]|0)+(c[z>>2]<<3)>>3]=-+h[D>>3];c[z>>2]=(c[z>>2]|0)+1;c[(c[v>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[z>>2];c[(c[x>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[z>>2];c[p>>2]=(c[p>>2]|0)+1}c[(c[(c[o>>2]|0)+4>>2]|0)+8>>2]=c[z>>2];c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]=c[z>>2];c[k>>2]=c[o>>2];I=c[k>>2]|0;i=j;return I|0}hx(c[o>>2]|0);c[k>>2]=0;I=c[k>>2]|0;i=j;return I|0}function Xp(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;hx(c[d>>2]|0);i=b;return}function Yp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0.0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;l=+lx(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,.001);i=f;return +l}function Zp(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d;g=d+16|0;j=d+12|0;k=d+8|0;c[e>>2]=a;h[f>>3]=b;a=c[e>>2]|0;if((c[(c[e>>2]|0)+16>>2]|0)==1)c[g>>2]=Mv(a,0)|0;else c[g>>2]=bw(a)|0;c[j>>2]=c[(c[g>>2]|0)+28>>2];if(!(+h[f>>3]!=1.0)){l=c[g>>2]|0;i=d;return l|0}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[g>>2]|0)+8>>2]|0))break;a=(c[j>>2]|0)+(c[k>>2]<<3)|0;h[a>>3]=+h[a>>3]*+h[f>>3];c[k>>2]=(c[k>>2]|0)+1}l=c[g>>2]|0;i=d;return l|0}function _p(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0;f=i;i=i+80|0;g=f+64|0;j=f+60|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+16|0;o=f+8|0;p=f;q=f+44|0;r=f+40|0;s=f+36|0;t=f+32|0;u=f+28|0;v=f+24|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;h[n>>3]=10.1;h[o>>3]=100.0;h[p>>3]=1.0;c[q>>2]=300;c[r>>2]=1;c[u>>2]=c[c[j>>2]>>2];c[v>>2]=0;c[c[l>>2]>>2]=0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(_(c[g>>2]|0,c[u>>2]|0)|0))break;w=+h[o>>3];x=w*+rw();h[(c[k>>2]|0)+(c[s>>2]<<3)>>3]=x;c[s>>2]=(c[s>>2]|0)+1}c[s>>2]=1;while(1){if((c[s>>2]|0)>=(c[u>>2]|0))break;c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[g>>2]|0))break;e=_(c[s>>2]|0,c[g>>2]|0)|0;d=_(c[s>>2]|0,c[g>>2]|0)|0;x=+h[(c[k>>2]|0)+(0+(c[t>>2]|0)<<3)>>3]-+h[(c[k>>2]|0)+(d+(c[t>>2]|0)<<3)>>3];if((+h[(c[k>>2]|0)+(0+(c[t>>2]|0)<<3)>>3]-+h[(c[k>>2]|0)+(e+(c[t>>2]|0)<<3)>>3]>=0.0?x:-x)>1.0e-16){y=9;break}c[t>>2]=(c[t>>2]|0)+1}if((y|0)==9){y=0;c[r>>2]=0;c[s>>2]=c[u>>2]}c[s>>2]=(c[s>>2]|0)+1}a:do if(c[r>>2]|0){s2(1);c[s>>2]=0;while(1){if((c[s>>2]|0)>=(_(c[g>>2]|0,c[u>>2]|0)|0))break a;x=+h[o>>3];w=x*+rw();h[(c[k>>2]|0)+(c[s>>2]<<3)>>3]=w;c[s>>2]=(c[s>>2]|0)+1}}while(0);c[v>>2]=Zp(c[j>>2]|0,+h[p>>3])|0;if(Ov(c[v>>2]|0,0)|0){c[m>>2]=Wp(c[g>>2]|0,c[v>>2]|0,c[k>>2]|0,+h[n>>3]*1.0e6,+h[o>>3],c[l>>2]|0)|0;+Yp(c[m>>2]|0,c[g>>2]|0,c[k>>2]|0,c[q>>2]|0);Xp(c[m>>2]|0);c[m>>2]=Wp(c[g>>2]|0,c[v>>2]|0,c[k>>2]|0,+h[n>>3]*1.0e4,+h[o>>3],c[l>>2]|0)|0;+Yp(c[m>>2]|0,c[g>>2]|0,c[k>>2]|0,c[q>>2]|0);Xp(c[m>>2]|0);c[m>>2]=Wp(c[g>>2]|0,c[v>>2]|0,c[k>>2]|0,+h[n>>3]*100.0,+h[o>>3],c[l>>2]|0)|0;+Yp(c[m>>2]|0,c[g>>2]|0,c[k>>2]|0,c[q>>2]|0);Xp(c[m>>2]|0);c[m>>2]=Wp(c[g>>2]|0,c[v>>2]|0,c[k>>2]|0,+h[n>>3],+h[o>>3],c[l>>2]|0)|0;+Yp(c[m>>2]|0,c[g>>2]|0,c[k>>2]|0,c[q>>2]|0);Xp(c[m>>2]|0);Bw(0.0,0.0,490.0,700.0,c[c[j>>2]>>2]|0,c[g>>2]|0,c[k>>2]|0);Lv(c[v>>2]|0);i=f;return}else La(129874,129831,164,129910)}function $p(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+32|0;g=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=a;c[j>>2]=d;c[k>>2]=e;c[m>>2]=cK((kB(c[g>>2]|0)|0)<<1<<3)|0;c[l>>2]=$B(c[g>>2]|0)|0;while(1){q=(c[k>>2]|0)!=0;if(!(c[l>>2]|0))break;if(q?(P3(wB(c[l>>2]|0)|0,129925,11)|0)==0:0)c[o>>2]=(c[o>>2]|0)+1;c[n>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+120>>2];h[(c[m>>2]|0)+(c[n>>2]<<1<<3)>>3]=+h[(c[(c[l>>2]|0)+8>>2]|0)+32>>3]*.5+ +h[b>>3];h[(c[m>>2]|0)+((c[n>>2]<<1)+1<<3)>>3]=+h[(c[(c[l>>2]|0)+8>>2]|0)+40>>3]*.5+ +h[b+8>>3];c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}if(!(q&(c[o>>2]|0)!=0)){r=c[m>>2]|0;i=f;return r|0}c[p>>2]=cK(c[o>>2]<<2)|0;c[o>>2]=0;c[l>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;if(!(P3(wB(c[l>>2]|0)|0,129925,11)|0)){q=c[(c[(c[l>>2]|0)+8>>2]|0)+120>>2]|0;b=c[o>>2]|0;c[o>>2]=b+1;c[(c[p>>2]|0)+(b<<2)>>2]=q}c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}c[c[k>>2]>>2]=c[p>>2];c[c[j>>2]>>2]=c[o>>2];r=c[m>>2]|0;i=f;return r|0}function aq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+96|0;f=e+16|0;g=e+8|0;j=e+88|0;k=e+84|0;l=e+76|0;m=e+72|0;n=e+68|0;o=e+64|0;p=e+60|0;q=e+56|0;r=e+52|0;s=e+48|0;t=e+44|0;u=e+40|0;v=e+36|0;w=e+32|0;x=e;y=e+28|0;z=e+24|0;A=e+20|0;c[k>>2]=a;c[e+80>>2]=b;c[l>>2]=d;c[m>>2]=0;c[y>>2]=1;c[z>>2]=0;c[A>>2]=0;if(!(c[k>>2]|0)){c[j>>2]=0;B=c[j>>2]|0;i=e;return B|0}c[q>>2]=kB(c[k>>2]|0)|0;c[r>>2]=lB(c[k>>2]|0)|0;c[s>>2]=0;c[n>>2]=$B(c[k>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;d=c[s>>2]|0;c[s>>2]=d+1;c[(c[(c[n>>2]|0)+8>>2]|0)+120>>2]=d;c[n>>2]=aC(c[k>>2]|0,c[n>>2]|0)|0}c[u>>2]=cK(c[r>>2]<<2)|0;c[v>>2]=cK(c[r>>2]<<2)|0;c[w>>2]=cK(c[r>>2]<<3)|0;c[p>>2]=qA(c[k>>2]|0,2,139333,0)|0;if(c[l>>2]|0){c[z>>2]=qA(c[k>>2]|0,2,129937,0)|0;c[A>>2]=bK(c[r>>2]<<3)|0}c[s>>2]=0;c[n>>2]=$B(c[k>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;c[t>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+120>>2];c[o>>2]=OA(c[k>>2]|0,c[n>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;c[(c[u>>2]|0)+(c[s>>2]<<2)>>2]=c[t>>2];d=c[o>>2]|0;c[(c[v>>2]|0)+(c[s>>2]<<2)>>2]=c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+120>>2];if(!((c[p>>2]|0)!=0?(d=zA(c[o>>2]|0,c[p>>2]|0)|0,c[g>>2]=x,(l3(d,139001,g)|0)==1):0))h[x>>3]=1.0;h[(c[w>>2]|0)+(c[s>>2]<<3)>>3]=+h[x>>3];if(c[z>>2]|0){d=zA(c[o>>2]|0,c[z>>2]|0)|0;c[f>>2]=x;if((l3(d,139001,f)|0)!=1)h[x>>3]=1.0;h[(c[A>>2]|0)+(c[s>>2]<<3)>>3]=+h[x>>3]}c[s>>2]=(c[s>>2]|0)+1;c[o>>2]=QA(c[k>>2]|0,c[o>>2]|0)|0}c[n>>2]=aC(c[k>>2]|0,c[n>>2]|0)|0}c[m>>2]=Vv(c[r>>2]|0,c[q>>2]|0,c[q>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[y>>2]|0,8)|0;if(c[l>>2]|0){n=Vv(c[r>>2]|0,c[q>>2]|0,c[q>>2]|0,c[u>>2]|0,c[v>>2]|0,c[A>>2]|0,c[y>>2]|0,8)|0;c[c[l>>2]>>2]=n}O4(c[u>>2]|0);O4(c[v>>2]|0);O4(c[w>>2]|0);if(c[A>>2]|0)O4(c[A>>2]|0);c[j>>2]=c[m>>2];B=c[j>>2]|0;i=e;return B|0}function bq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0;b=i;i=i+80|0;d=b+72|0;e=b+68|0;f=b+64|0;g=b+60|0;j=b+48|0;k=b+40|0;l=b+32|0;m=b+16|0;n=b;o=b+56|0;c[e>>2]=a;if(!(iq(c[e>>2]|0,j)|0)){c[d>>2]=0;p=c[d>>2]|0;i=b;return p|0}c[f>>2]=$B(c[e>>2]|0)|0;h[m>>3]=+h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3];h[m+8>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];c[f>>2]=$B(c[e>>2]|0)|0;while(1){q=+h[m>>3];if(!(c[f>>2]|0))break;a=c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0;h[a>>3]=+h[a>>3]-q;a=(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[a>>3]=+h[a>>3]-+h[m+8>>3];c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}if(!(q!=0.0)?!(+h[m+8>>3]!=0.0):0)c[o>>2]=0;else c[o>>2]=1;c[g>>2]=0;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;a=OA(c[e>>2]|0,c[f>>2]|0)|0;c[g>>2]=a;if(a)break;c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}if(!(c[g>>2]|0)){c[d>>2]=c[o>>2];p=c[d>>2]|0;i=b;return p|0}a=c[g>>2]|0;r=c[g>>2]|0;s=c[g>>2]|0;t=c[g>>2]|0;q=+W(+(+h[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?r:r+32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]),+(+h[c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?s:s+-32|0)+28>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?t:t+32|0)+28>>2]|0)+8>>2]|0)+132>>2]>>3]));h[j>>3]=+h[j>>3]-q;if(!(+h[j>>3]!=0.0)){c[d>>2]=c[o>>2];p=c[d>>2]|0;i=b;return p|0}o=c[g>>2]|0;h[n>>3]=+h[c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?o:o+32|0)+28>>2]|0)+8>>2]|0)+132>>2]>>3];o=c[g>>2]|0;h[n+8>>3]=+h[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?o:o+32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];h[k>>3]=+Q(+(+h[j>>3]));h[l>>3]=+R(+(+h[j>>3]));c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;h[m>>3]=+h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[n>>3];h[m+8>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[n+8>>3];h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[m>>3]*+h[k>>3]-+h[m+8>>3]*+h[l>>3]+ +h[n>>3];h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[m>>3]*+h[l>>3]+ +h[m+8>>3]*+h[k>>3]+ +h[n+8>>3];c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[d>>2]=1;p=c[d>>2]|0;i=b;return p|0}function cq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=yA(c[f>>2]|0,129941)|0;d=c[f>>2]|0;if(c[j>>2]|0){k=c[j>>2]|0;l=c[g>>2]|0;m=jq(d,k,l)|0;i=e;return m|0}else{k=(c[h>>2]|0)!=0?c[h>>2]|0:178518;l=c[g>>2]|0;m=jq(d,k,l)|0;i=e;return m|0}return 0}function dq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+8|0;g=e;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;c[j>>2]=b;c[k>>2]=d;if((kB(c[j>>2]|0)|0)<2){c[h>>2]=0;n=c[h>>2]|0;i=e;return n|0}c[m>>2]=bq(c[j>>2]|0)|0;d=kq(c[j>>2]|0)|0;c[m>>2]=(c[m>>2]|0)+d;if(!(c[c[k>>2]>>2]|0)){c[h>>2]=c[m>>2];n=c[h>>2]|0;i=e;return n|0}if(a[138998]|0){d=c[24742]|0;b=wB(c[j>>2]|0)|0;o=c[(c[k>>2]|0)+4>>2]|0;c[g>>2]=b;c[g+4>>2]=o;Y2(d,129949,g)|0}if((c[c[k>>2]>>2]|0)>>>0>2){switch(c[c[k>>2]>>2]|0){case 3:{c[l>>2]=Wq(c[j>>2]|0,1)|0;break}case 4:{c[l>>2]=Wq(c[j>>2]|0,0)|0;break}case 6:case 5:break;case 10:case 9:case 7:case 8:case 14:case 13:case 11:case 12:{Vq(c[j>>2]|0,c[c[k>>2]>>2]|0)|0;break}case 15:{c[l>>2]=Wq(c[j>>2]|0,-1)|0;break}default:if((c[c[k>>2]>>2]|0)!=1?(c[c[k>>2]>>2]|0)!=2:0){c[f>>2]=c[(c[k>>2]|0)+4>>2];$z(0,129972,f)|0}}c[h>>2]=(c[m>>2]|0)+(c[l>>2]|0);n=c[h>>2]|0;i=e;return n|0}else{if(lq(c[j>>2]|0)|0){mq();O4(c[12779]|0);c[12779]=0;c[h>>2]=c[m>>2];n=c[h>>2]|0;i=e;return n|0}nq(c[j>>2]|0);if((c[c[k>>2]>>2]|0)==2)c[l>>2]=oq()|0;else c[l>>2]=pq()|0;if(c[l>>2]|0)qq(c[j>>2]|0);mq();O4(c[12779]|0);c[12779]=0;c[h>>2]=(c[l>>2]|0)+(c[m>>2]|0);n=c[h>>2]|0;i=e;return n|0}return 0}function eq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d;c[f>>2]=a;c[g>>2]=b;if((kB(c[f>>2]|0)|0)<2){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{jq(c[f>>2]|0,c[g>>2]|0,h)|0;c[e>>2]=dq(c[f>>2]|0,h)|0;j=c[e>>2]|0;i=d;return j|0}return 0}function fq(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[d>>2]|0;e=eq(a,yA(c[d>>2]|0,129941)|0)|0;i=b;return e|0}function gq(b,e){b=b|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0;f=i;i=i+48|0;j=f;k=f+40|0;l=f+28|0;m=f+24|0;c[k>>2]=e;e=yA(c[k>>2]|0,13e4)|0;c[m>>2]=e;if(!((e|0)!=0?(rq(c[m>>2]|0,l,1.0)|0)!=0:0))n=3;do if((n|0)==3){e=yA(c[k>>2]|0,130004)|0;c[m>>2]=e;if((e|0)!=0?(rq(c[m>>2]|0,l,.800000011920929)|0)!=0:0)break;g[l+4>>2]=4.0;g[l>>2]=4.0;a[l+8>>0]=1}while(0);if(!(a[138998]|0)){c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];i=f;return}m=c[24742]|0;o=+g[l>>2];p=+g[l+4>>2];c[j>>2]=d[l+8>>0];h[j+8>>3]=o;h[j+16>>3]=p;Y2(m,130009,j)|0;c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];i=f;return}function hq(b,e){b=b|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0;f=i;i=i+48|0;j=f;k=f+40|0;l=f+28|0;m=f+24|0;c[k>>2]=e;e=yA(c[k>>2]|0,130004)|0;c[m>>2]=e;if(!((e|0)!=0?(rq(c[m>>2]|0,l,1.0)|0)!=0:0))n=3;do if((n|0)==3){e=yA(c[k>>2]|0,13e4)|0;c[m>>2]=e;if((e|0)!=0?(rq(c[m>>2]|0,l,1.25)|0)!=0:0)break;g[l+4>>2]=3.200000047683716;g[l>>2]=3.200000047683716;a[l+8>>0]=1}while(0);if(!(a[138998]|0)){c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];i=f;return}m=c[24742]|0;o=+g[l>>2];p=+g[l+4>>2];c[j>>2]=d[l+8>>0];h[j+8>>3]=o;h[j+16>>3]=p;Y2(m,130042,j)|0;c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];i=f;return}function iq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+16|0;k=e;l=e+12|0;m=e+8|0;c[g>>2]=b;c[j>>2]=d;c[m>>2]=yA(c[g>>2]|0,130614)|0;if((c[m>>2]|0)!=0?(a[c[m>>2]>>0]|0)!=0:0){h[k>>3]=+x3(c[m>>2]|0,l);do if((c[l>>2]|0)==(c[m>>2]|0)){if((kO(c[m>>2]|0)|0)<<24>>24){h[k>>3]=0.0;break}c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}while(0);while(1){if(!(+h[k>>3]>180.0))break;h[k>>3]=+h[k>>3]-360.0}while(1){o=+h[k>>3];if(!(+h[k>>3]<=-180.0))break;h[k>>3]=o+360.0}h[c[j>>2]>>3]=o/180.0*3.141592653589793;c[f>>2]=1;n=c[f>>2]|0;i=e;return n|0}c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}function jq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+8|0;h=f;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=51156;if((c[k>>2]|0)!=0?(a[c[k>>2]>>0]|0)!=0:0){while(1){if(!(c[(c[m>>2]|0)+4>>2]|0))break;e=(O3(c[k>>2]|0,c[(c[m>>2]|0)+4>>2]|0,c[(c[m>>2]|0)+8>>2]|0)|0)!=0;o=c[m>>2]|0;if(!e){p=6;break}c[m>>2]=o+16}if((p|0)==6){if(!(c[o+12>>2]|0)){c[h>>2]=c[(c[m>>2]|0)+4>>2];$z(0,130188,h)|0;c[m>>2]=51156}c[c[l>>2]>>2]=c[c[m>>2]>>2];c[(c[l>>2]|0)+4>>2]=c[(c[m>>2]|0)+12>>2];if((c[c[m>>2]>>2]|0)==18)Hq(c[j>>2]|0,(c[k>>2]|0)+(c[(c[m>>2]|0)+8>>2]|0)|0,c[l>>2]|0)}if(c[(c[m>>2]|0)+4>>2]|0){q=c[l>>2]|0;i=f;return q|0}c[n>>2]=(uO(c[k>>2]|0,63)|0)&255;if((c[n>>2]|0)==63){c[g>>2]=c[k>>2];$z(0,130230,g)|0;c[n>>2]=0}if(c[n>>2]|0){c[c[l>>2]>>2]=c[12785];c[(c[l>>2]|0)+4>>2]=c[12788]}else{c[c[l>>2]>>2]=c[12789];c[(c[l>>2]|0)+4>>2]=c[12792]}if((c[c[l>>2]>>2]|0)!=18){q=c[l>>2]|0;i=f;return q|0}Hq(c[j>>2]|0,178518,c[l>>2]|0);q=c[l>>2]|0;i=f;return q|0}c[c[l>>2]>>2]=c[12785];c[(c[l>>2]|0)+4>>2]=c[12788];q=c[l>>2]|0;i=f;return q|0}function kq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;d=i;i=i+64|0;e=d+24|0;f=d+16|0;g=d+56|0;j=d+52|0;k=d;l=d+48|0;m=d+44|0;n=d+40|0;c[j>>2]=b;b=yA(c[j>>2]|0,178751)|0;c[n>>2]=b;if((b|0)!=0?(b=c[n>>2]|0,c[f>>2]=k,c[f+4>>2]=k+8,n=l3(b,143965,f)|0,c[m>>2]=n,(n|0)!=0):0){if(+N(+(+h[k>>3]))<1.0e-09){c[g>>2]=0;o=c[g>>2]|0;i=d;return o|0}if((c[m>>2]|0)!=1){if(+N(+(+h[k+8>>3]))<1.0e-09){c[g>>2]=0;o=c[g>>2]|0;i=d;return o|0}}else h[k+8>>3]=+h[k>>3];if(+h[k+8>>3]==1.0?+h[k>>3]==1.0:0){c[g>>2]=0;o=c[g>>2]|0;i=d;return o|0}if(a[138998]|0){m=c[24742]|0;p=+h[k+8>>3];h[e>>3]=+h[k>>3];h[e+8>>3]=p;Y2(m,130165,e)|0}c[l>>2]=$B(c[j>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;e=c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0;h[e>>3]=+h[e>>3]*+h[k>>3];e=(c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[e>>3]=+h[e>>3]*+h[k+8>>3];c[l>>2]=aC(c[j>>2]|0,c[l>>2]|0)|0}c[g>>2]=1;o=c[g>>2]|0;i=d;return o|0}c[g>>2]=0;o=c[g>>2]|0;i=d;return o|0}function lq(b){b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+44|0;f=d+40|0;j=d+36|0;k=d+32|0;l=d+28|0;m=d+16|0;n=d+12|0;o=d;c[f>>2]=b;c[12875]=kB(c[f>>2]|0)|0;Or();c[12890]=cK((c[12875]|0)*96|0)|0;c[j>>2]=$B(c[f>>2]|0)|0;c[l>>2]=c[12890];gq(o,c[f>>2]|0);c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];if(a[m+8>>0]|0){c[n>>2]=1;g[m>>2]=+g[m>>2]/72.0;g[m+4>>2]=+g[m+4>>2]/72.0}else c[n>>2]=2;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[12875]|0)){p=9;break}h[(c[l>>2]|0)+8>>3]=+h[c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]>>3];h[(c[l>>2]|0)+8+8>>3]=+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];if(Cb[c[n>>2]&3]((c[l>>2]|0)+40|0,c[j>>2]|0,+g[m>>2],+g[m+4>>2])|0){p=7;break}c[(c[l>>2]|0)+8+16>>2]=c[k>>2];c[(c[l>>2]|0)+8+20>>2]=1;c[c[l>>2]>>2]=c[j>>2];c[(c[l>>2]|0)+88>>2]=0;c[j>>2]=aC(c[f>>2]|0,c[j>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+96;c[k>>2]=(c[k>>2]|0)+1}if((p|0)==7){O4(c[12890]|0);c[12890]=0;c[e>>2]=1;q=c[e>>2]|0;i=d;return q|0}else if((p|0)==9){c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}return 0}function mq(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[12890];c[b>>2]=0;while(1){if((c[b>>2]|0)>=(c[12875]|0))break;Kt((c[d>>2]|0)+40|0);c[d>>2]=(c[d>>2]|0)+96;c[b>>2]=(c[b>>2]|0)+1}Jt();os();O4(c[12890]|0);i=a;return}function nq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+160|0;e=d+144|0;f=d+140|0;g=d+112|0;j=d+96|0;k=d+136|0;l=d+88|0;m=d+80|0;n=d+72|0;o=d+64|0;p=d+56|0;q=d+48|0;r=d+40|0;s=d+32|0;t=d+24|0;u=d+16|0;v=d+8|0;w=d;x=d+132|0;y=d+128|0;c[e>>2]=b;c[x>>2]=c[12890];c[y>>2]=(c[x>>2]|0)+40;h[l>>3]=+h[(c[x>>2]|0)+8>>3];h[m>>3]=+h[(c[x>>2]|0)+8+8>>3];h[n>>3]=+h[c[y>>2]>>3]+ +h[l>>3];h[p>>3]=+h[(c[y>>2]|0)+8>>3]+ +h[m>>3];h[o>>3]=+h[(c[y>>2]|0)+16>>3]+ +h[l>>3];h[q>>3]=+h[(c[y>>2]|0)+16+8>>3]+ +h[m>>3];c[k>>2]=1;while(1){if((c[k>>2]|0)>=(c[12875]|0))break;c[x>>2]=(c[x>>2]|0)+96;c[y>>2]=(c[x>>2]|0)+40;h[l>>3]=+h[(c[x>>2]|0)+8>>3];h[m>>3]=+h[(c[x>>2]|0)+8+8>>3];h[r>>3]=+h[c[y>>2]>>3]+ +h[l>>3];h[t>>3]=+h[(c[y>>2]|0)+8>>3]+ +h[m>>3];h[s>>3]=+h[(c[y>>2]|0)+16>>3]+ +h[l>>3];h[u>>3]=+h[(c[y>>2]|0)+16+8>>3]+ +h[m>>3];if(+h[r>>3]<+h[n>>3])h[n>>3]=+h[r>>3];if(+h[t>>3]<+h[p>>3])h[p>>3]=+h[t>>3];if(+h[s>>3]>+h[o>>3])h[o>>3]=+h[s>>3];if(+h[u>>3]>+h[q>>3])h[q>>3]=+h[u>>3];c[k>>2]=(c[k>>2]|0)+1}c[f>>2]=yA(c[e>>2]|0,130153)|0;if((c[f>>2]|0)!=0?(a[c[f>>2]>>0]|0)!=0:0)h[4197]=+t3(c[f>>2]|0);h[v>>3]=+h[4197]*(+h[q>>3]-+h[p>>3]);h[w>>3]=+h[4197]*(+h[o>>3]-+h[n>>3]);h[g>>3]=+h[n>>3]-+h[w>>3];h[g+8>>3]=+h[p>>3]-+h[v>>3];h[j>>3]=+h[o>>3]+ +h[w>>3];h[j+8>>3]=+h[q>>3]+ +h[v>>3];zq(g,j);i=d;return}function oq(){var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;b=i;i=i+64|0;d=b+24|0;e=b+16|0;f=b+52|0;g=b+48|0;j=b+44|0;k=b+40|0;l=b;c[g>>2]=0;c[j>>2]=0;if((c[12780]|0)==0|(c[12781]|0)>0)c[j>>2]=sq(c[g>>2]|0)|0;if((c[j>>2]|0)==0|(c[12781]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=b;return m|0}tq();h[l>>3]=(+h[4201]+ +h[4200])/2.0;h[l+8>>3]=(+h[4199]+ +h[4198])/2.0;do{c[d>>2]=c[l>>2];c[d+4>>2]=c[l+4>>2];c[d+8>>2]=c[l+8>>2];c[d+12>>2]=c[l+12>>2];+Gq(d);c[g>>2]=(c[g>>2]|0)+1;if((c[12780]|0)!=0?(c[g>>2]|0)==(c[12781]|0):0)break;c[k>>2]=sq(c[g>>2]|0)|0}while((c[k>>2]|0)!=0);if(a[138998]|0){k=c[24742]|0;c[e>>2]=c[g>>2];Y2(k,130081,e)|0}c[f>>2]=1;m=c[f>>2]|0;i=b;return m|0}function pq(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+48|0;d=b+8|0;e=b;f=b+32|0;g=b+28|0;h=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;c[g>>2]=0;c[h>>2]=0;c[j>>2]=0;c[k>>2]=0;if((c[12780]|0)==0|(c[12781]|0)>0)c[h>>2]=sq(c[g>>2]|0)|0;if((c[h>>2]|0)==0|(c[12781]|0)==0){c[f>>2]=0;m=c[f>>2]|0;i=b;return m|0}tq();uq(0);ru(0,1);while(1){wq();c[g>>2]=(c[g>>2]|0)+1;if((c[12780]|0)!=0?(c[g>>2]|0)==(c[12781]|0):0)break;c[l>>2]=sq(c[g>>2]|0)|0;if(!(c[l>>2]|0))break;if((c[l>>2]|0)>=(c[h>>2]|0))c[j>>2]=(c[j>>2]|0)+1;else c[j>>2]=0;c[h>>2]=c[l>>2];n=(c[j>>2]|0)==0;c[12782]=1;if(!n){c[k>>2]=(c[k>>2]|0)+1;xq()}uq(1);ru(0,1)}if(a[138998]|0){j=c[24742]|0;c[e>>2]=c[g>>2];Y2(j,130081,e)|0;e=c[24742]|0;c[d>>2]=c[k>>2];Y2(e,130108,d)|0}yq();c[f>>2]=1;m=c[f>>2]|0;i=b;return m|0}function qq(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[b+8>>2]=a;c[e>>2]=c[12890];c[d>>2]=0;while(1){if((c[d>>2]|0)>=(c[12875]|0))break;h[c[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[(c[e>>2]|0)+8>>3];h[(c[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[(c[e>>2]|0)+8+8>>3];c[e>>2]=(c[e>>2]|0)+96;c[d>>2]=(c[d>>2]|0)+1}i=b;return}function rq(b,d,e){b=b|0;d=d|0;e=+e;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;h=f;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;c[k>>2]=b;c[l>>2]=d;g[m>>2]=e;while(1){d=(r1(a[c[k>>2]>>0]|0)|0)!=0;q=c[k>>2]|0;if(!d)break;c[k>>2]=q+1}if((a[q>>0]|0)==43){c[k>>2]=(c[k>>2]|0)+1;a[(c[l>>2]|0)+8>>0]=1}else a[(c[l>>2]|0)+8>>0]=0;q=c[k>>2]|0;c[h>>2]=o;c[h+4>>2]=p;k=l3(q,130075,h)|0;c[n>>2]=k;if(!k){c[j>>2]=0;r=c[j>>2]|0;i=f;return r|0}if((c[n>>2]|0)==1)g[p>>2]=+g[o>>2];e=+g[o>>2]/+g[m>>2];if(a[(c[l>>2]|0)+8>>0]|0){g[c[l>>2]>>2]=e;g[(c[l>>2]|0)+4>>2]=+g[p>>2]/+g[m>>2]}else{g[c[l>>2]>>2]=1.0+e;g[(c[l>>2]|0)+4>>2]=+g[p>>2]/+g[m>>2]+1.0}c[j>>2]=1;r=c[j>>2]|0;i=f;return r|0}function sq(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;b=i;i=i+64|0;e=b+24|0;f=b+8|0;g=b;h=b+60|0;j=b+56|0;k=b+52|0;l=b+48|0;m=b+44|0;n=b+40|0;c[h>>2]=a;c[j>>2]=0;c[m>>2]=c[12890];c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[12875]|0))break;c[(c[12890]|0)+((c[k>>2]|0)*96|0)+32>>2]=0;c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=((c[12875]|0)-1|0))break;c[n>>2]=(c[m>>2]|0)+96;c[l>>2]=(c[k>>2]|0)+1;while(1){o=c[m>>2]|0;if((c[l>>2]|0)>=(c[12875]|0))break;a=o+8|0;p=(c[m>>2]|0)+40|0;q=(c[n>>2]|0)+8|0;r=(c[n>>2]|0)+40|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];c[e+12>>2]=c[q+12>>2];if(Nt(f,p,e,r)|0){c[j>>2]=(c[j>>2]|0)+1;c[(c[m>>2]|0)+32>>2]=1;c[(c[n>>2]|0)+32>>2]=1}c[n>>2]=(c[n>>2]|0)+96;c[l>>2]=(c[l>>2]|0)+1}c[m>>2]=o+96;c[k>>2]=(c[k>>2]|0)+1}if((d[138998]|0|0)<=1){s=c[j>>2]|0;i=b;return s|0}k=c[24742]|0;o=c[j>>2]|0;c[g>>2]=c[h>>2];c[g+4>>2]=o;Y2(k,130134,g)|0;s=c[j>>2]|0;i=b;return s|0}function tq(){var a=0,b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;a=i;i=i+32|0;b=a+28|0;d=a+24|0;e=a+20|0;f=a+16|0;g=a+12|0;j=a;k=a+8|0;Eq();c[e>>2]=c[12779];while(1){if((c[e>>2]|0)>>>0>=(c[12784]|0)>>>0)break;c[f>>2]=(c[e>>2]|0)+4;if(((c[f>>2]|0)>>>0<(c[12784]|0)>>>0?!(+h[c[c[f>>2]>>2]>>3]!=+h[c[c[e>>2]>>2]>>3]):0)?!(+h[(c[c[f>>2]>>2]|0)+8>>3]!=+h[(c[c[e>>2]>>2]|0)+8>>3]):0){c[d>>2]=2;c[g>>2]=(c[f>>2]|0)+4;while(1){if((c[g>>2]|0)>>>0>=(c[12784]|0)>>>0)break;if(!(+h[c[c[g>>2]>>2]>>3]==+h[c[c[e>>2]>>2]>>3]))break;if(!(+h[(c[c[g>>2]>>2]|0)+8>>3]==+h[(c[c[e>>2]>>2]|0)+8>>3]))break;c[d>>2]=(c[d>>2]|0)+1;c[f>>2]=c[g>>2];c[g>>2]=(c[f>>2]|0)+4}a:do if((c[g>>2]|0)>>>0<(c[12784]|0)>>>0?+h[(c[c[g>>2]>>2]|0)+8>>3]==+h[(c[c[e>>2]>>2]|0)+8>>3]:0){h[j>>3]=(+h[c[c[g>>2]>>2]>>3]-+h[c[c[e>>2]>>2]>>3])/+(c[d>>2]|0);c[b>>2]=1;c[f>>2]=(c[e>>2]|0)+4;while(1){if((c[f>>2]|0)>>>0>=(c[g>>2]|0)>>>0)break a;l=c[c[f>>2]>>2]|0;h[l>>3]=+h[l>>3]+ +(c[b>>2]|0)*+h[j>>3];c[b>>2]=(c[b>>2]|0)+1;c[f>>2]=(c[f>>2]|0)+4}}else m=17;while(0);b:do if((m|0)==17){m=0;c[f>>2]=(c[e>>2]|0)+4;while(1){if((c[f>>2]|0)>>>0>=(c[g>>2]|0)>>>0)break b;c[k>>2]=(c[12890]|0)+((c[(c[c[e>>2]>>2]|0)+16>>2]|0)*96|0);h[j>>3]=+h[(c[k>>2]|0)+40+16>>3]-+h[(c[k>>2]|0)+40>>3];c[k>>2]=(c[12890]|0)+((c[(c[c[f>>2]>>2]|0)+16>>2]|0)*96|0);h[j>>3]=+h[j>>3]+(+h[(c[k>>2]|0)+40+16>>3]-+h[(c[k>>2]|0)+40>>3]);h[c[c[f>>2]>>2]>>3]=+h[c[c[e>>2]>>2]>>3]+ +h[j>>3]/2.0;c[e>>2]=(c[e>>2]|0)+4;c[f>>2]=(c[f>>2]|0)+4}}while(0);c[e>>2]=c[g>>2];continue}c[e>>2]=c[f>>2]}i=a;return}function uq(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(c[d>>2]|0)Eq();h[4204]=+h[c[c[12779]>>2]>>3];h[4205]=+h[c[c[12779]>>2]>>3];c[e>>2]=1;while(1){if((c[e>>2]|0)>=(c[12875]|0))break;if(+h[c[(c[12779]|0)+(c[e>>2]<<2)>>2]>>3]<+h[4204])h[4204]=+h[c[(c[12779]|0)+(c[e>>2]<<2)>>2]>>3];if(+h[c[(c[12779]|0)+(c[e>>2]<<2)>>2]>>3]>+h[4205])h[4205]=+h[c[(c[12779]|0)+(c[e>>2]<<2)>>2]>>3];c[e>>2]=(c[e>>2]|0)+1}h[4206]=+h[(c[c[12779]>>2]|0)+8>>3];h[4207]=+h[(c[(c[12779]|0)+((c[12875]|0)-1<<2)>>2]|0)+8>>3];h[4209]=+h[4207]-+h[4206];h[4208]=+h[4205]-+h[4204];i=b;return}function vq(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a+4|0;d=a;if((c[12783]|0)>>>0<(c[12784]|0)>>>0){e=c[12783]|0;c[12783]=e+4;c[d>>2]=c[e>>2];c[b>>2]=c[d>>2];f=c[b>>2]|0;i=a;return f|0}else{c[b>>2]=0;f=c[b>>2]|0;i=a;return f|0}return 0}function wq(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=c[12890];Aq();c[b>>2]=0;while(1){if((c[b>>2]|0)>=(c[12875]|0))break;if(!((c[12782]|0)==0?(c[(c[d>>2]|0)+32>>2]|0)==0:0))Bq(c[d>>2]|0);c[d>>2]=(c[d>>2]|0)+96;c[b>>2]=(c[b>>2]|0)+1}i=a;return}function xq(){var a=0,b=0,c=0,d=0,e=0,f=0;a=i;i=i+48|0;b=a+40|0;c=a+32|0;d=a+16|0;e=a;h[e>>3]=+h[4200];h[e+8>>3]=+h[4198];h[d>>3]=+h[4201];h[d+8>>3]=+h[4199];h[b>>3]=+h[4188]*(+h[e+8>>3]-+h[d+8>>3]);h[c>>3]=+h[4188]*(+h[e>>3]-+h[d>>3]);h[e>>3]=+h[e>>3]+ +h[c>>3];f=e+8|0;h[f>>3]=+h[f>>3]+ +h[b>>3];h[d>>3]=+h[d>>3]-+h[c>>3];c=d+8|0;h[c>>3]=+h[c>>3]-+h[b>>3];zq(d,e);i=a;return}function yq(){_r();bs();du();Hr();return}function zq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;h[4201]=+h[c[e>>2]>>3];h[4200]=+h[c[f>>2]>>3];h[4199]=+h[(c[e>>2]|0)+8>>3];h[4198]=+h[(c[f>>2]|0)+8>>3];g=+h[4201];h[4189]=g;h[4191]=g;g=+h[4200];h[4193]=g;h[4195]=g;g=+h[4198];h[4196]=g;h[4192]=g;g=+h[4199];h[4194]=g;h[4190]=g;i=d;return}function Aq(){var a=0,b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;i=i+64|0;b=a+60|0;d=a+56|0;e=a+52|0;f=a+48|0;g=a+44|0;j=a+32|0;k=a+24|0;l=a+16|0;m=a+8|0;n=a;o=a+40|0;c[b>>2]=c[12890];c[d>>2]=c[b>>2];c[e>>2]=c[b>>2];c[f>>2]=c[b>>2];c[g>>2]=c[b>>2];h[j>>3]=+Pr((c[b>>2]|0)+8|0,33512);h[k>>3]=+Pr((c[b>>2]|0)+8|0,33528);h[l>>3]=+Pr((c[b>>2]|0)+8|0,33544);h[m>>3]=+Pr((c[b>>2]|0)+8|0,33560);c[b>>2]=(c[b>>2]|0)+96;c[o>>2]=1;while(1){if((c[o>>2]|0)>=(c[12875]|0))break;h[n>>3]=+Pr((c[b>>2]|0)+8|0,33512);if(+h[n>>3]<+h[j>>3]){h[j>>3]=+h[n>>3];c[d>>2]=c[b>>2]}h[n>>3]=+Pr((c[b>>2]|0)+8|0,33544);if(+h[n>>3]<+h[l>>3]){h[l>>3]=+h[n>>3];c[f>>2]=c[b>>2]}h[n>>3]=+Pr((c[b>>2]|0)+8|0,33528);if(+h[n>>3]<+h[k>>3]){h[k>>3]=+h[n>>3];c[e>>2]=c[b>>2]}h[n>>3]=+Pr((c[b>>2]|0)+8|0,33560);if(+h[n>>3]<+h[m>>3]){h[m>>3]=+h[n>>3];c[g>>2]=c[b>>2]}c[b>>2]=(c[b>>2]|0)+96;c[o>>2]=(c[o>>2]|0)+1}ps((c[d>>2]|0)+8|0,+h[4189],+h[4190]);ps((c[f>>2]|0)+8|0,+h[4193],+h[4194]);ps((c[e>>2]|0)+8|0,+h[4191],+h[4192]);ps((c[g>>2]|0)+8|0,+h[4195],+h[4196]);i=a;return}function Bq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+112|0;d=b+80|0;e=b+64|0;f=b+48|0;g=b+108|0;j=b+104|0;k=b+100|0;l=b+96|0;m=b+40|0;n=b+32|0;o=b+24|0;p=b+16|0;q=b+8|0;r=b;c[g>>2]=a;c[j>>2]=c[(c[g>>2]|0)+88>>2];h[m>>3]=0.0;h[n>>3]=0.0;h[o>>3]=0.0;c[k>>2]=c[c[j>>2]>>2];c[l>>2]=c[c[k>>2]>>2];while(1){if(!(c[l>>2]|0))break;a=(c[j>>2]|0)+8|0;s=(c[k>>2]|0)+8|0;t=(c[l>>2]|0)+8|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[e>>2]=c[s>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];c[e+12>>2]=c[s+12>>2];c[d>>2]=c[t>>2];c[d+4>>2]=c[t+4>>2];c[d+8>>2]=c[t+8>>2];c[d+12>>2]=c[t+12>>2];h[r>>3]=+Cq(f,e,d);t=(c[j>>2]|0)+8|0;s=(c[k>>2]|0)+8|0;a=(c[l>>2]|0)+8|0;c[f>>2]=c[t>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];c[e>>2]=c[s>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];c[e+12>>2]=c[s+12>>2];c[d>>2]=c[a>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];Dq(f,e,d,p,q);h[n>>3]=+h[n>>3]+ +h[r>>3]*+h[p>>3];h[o>>3]=+h[o>>3]+ +h[r>>3]*+h[q>>3];h[m>>3]=+h[m>>3]+ +h[r>>3];c[k>>2]=c[l>>2];c[l>>2]=c[c[l>>2]>>2]}h[(c[g>>2]|0)+8>>3]=+h[n>>3]/+h[m>>3];h[(c[g>>2]|0)+8+8>>3]=+h[o>>3]/+h[m>>3];i=b;return}function Cq(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+16|0;e=d;h[e>>3]=+N(+(+h[a>>3]*(+h[b+8>>3]-+h[c+8>>3])+ +h[b>>3]*(+h[c+8>>3]-+h[a+8>>3])+ +h[c>>3]*(+h[a+8>>3]-+h[b+8>>3])))/2.0;i=d;return +(+h[e>>3])}function Dq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0;g=i;i=i+16|0;j=g+4|0;k=g;c[j>>2]=e;c[k>>2]=f;h[c[j>>2]>>3]=(+h[a>>3]+ +h[b>>3]+ +h[d>>3])/3.0;h[c[k>>2]>>3]=(+h[a+8>>3]+ +h[b+8>>3]+ +h[d+8>>3])/3.0;i=g;return}function Eq(){var a=0,b=0,d=0,e=0,f=0,g=0;a=i;i=i+16|0;b=a+8|0;d=a+4|0;e=a;if(!(c[12779]|0)){c[12779]=cK(c[12875]<<2)|0;c[12784]=(c[12779]|0)+(c[12875]<<2)}c[d>>2]=c[12779];c[e>>2]=c[12890];os();c[b>>2]=0;while(1){if((c[b>>2]|0)>=(c[12875]|0))break;f=(c[e>>2]|0)+8|0;g=c[d>>2]|0;c[d>>2]=g+4;c[g>>2]=f;c[(c[e>>2]|0)+88>>2]=0;c[(c[e>>2]|0)+8+20>>2]=1;c[e>>2]=(c[e>>2]|0)+96;c[b>>2]=(c[b>>2]|0)+1}w3(c[12779]|0,c[12875]|0,4,69);c[12783]=c[12779];i=a;return}function Fq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[c[f>>2]>>2];c[k>>2]=c[c[g>>2]>>2];do if(!(+h[(c[j>>2]|0)+8>>3]<+h[(c[k>>2]|0)+8>>3])){if(+h[(c[j>>2]|0)+8>>3]>+h[(c[k>>2]|0)+8>>3]){c[e>>2]=1;break}if(+h[c[j>>2]>>3]<+h[c[k>>2]>>3]){c[e>>2]=-1;break}if(+h[c[j>>2]>>3]>+h[c[k>>2]>>3]){c[e>>2]=1;break}else{c[e>>2]=0;break}}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function Gq(a){a=a|0;var b=0,d=0,e=0,f=0.0;a=i;i=i+16|0;b=a+12|0;d=a+8|0;e=a;c[d>>2]=c[12890];h[e>>3]=+h[4188]+1.0;c[b>>2]=0;while(1){f=+h[e>>3];if((c[b>>2]|0)>=(c[12875]|0))break;h[(c[d>>2]|0)+8>>3]=f*+h[(c[d>>2]|0)+8>>3];h[(c[d>>2]|0)+8+8>>3]=+h[e>>3]*+h[(c[d>>2]|0)+8+8>>3];c[d>>2]=(c[d>>2]|0)+96;c[b>>2]=(c[b>>2]|0)+1}i=a;return +f}function Hq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0;e=i;i=i+32|0;f=e;g=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;d=c[j>>2]|0;c[f>>2]=l;j=(l3(d,175023,f)|0)>0;if(j&(c[l>>2]|0)>=0)c[(c[k>>2]|0)+8>>2]=c[l>>2];else c[(c[k>>2]|0)+8>>2]=1e3;l=c[g>>2]|0;m=+fO(l,qA(c[g>>2]|0,0,130277,0)|0,-4.0,-1.0e10);h[(c[k>>2]|0)+16>>3]=m;i=e;return}function Iq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[r>>2]=2147483647;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[l>>2]|0))break;c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]=-1;c[o>>2]=(c[o>>2]|0)+1}c[(c[m>>2]|0)+(c[j>>2]<<2)>>2]=0;Jq(c[n>>2]|0,c[j>>2]|0);a:do if(!(c[(c[k>>2]|0)+8>>2]|0))b:while(1){if(!((Kq(c[n>>2]|0,p)|0)<<24>>24))break a;c[r>>2]=c[(c[m>>2]|0)+(c[p>>2]<<2)>>2];c[o>>2]=1;while(1){if((c[o>>2]|0)>=(c[(c[k>>2]|0)+((c[p>>2]|0)*20|0)>>2]|0))continue b;c[q>>2]=c[(c[(c[k>>2]|0)+((c[p>>2]|0)*20|0)+4>>2]|0)+(c[o>>2]<<2)>>2];if(+(c[(c[m>>2]|0)+(c[q>>2]<<2)>>2]|0)<-.5){c[(c[m>>2]|0)+(c[q>>2]<<2)>>2]=(c[r>>2]|0)+1;Lq(c[n>>2]|0,c[q>>2]|0)|0}c[o>>2]=(c[o>>2]|0)+1}}else c:while(1){if(!((Kq(c[n>>2]|0,p)|0)<<24>>24))break a;c[r>>2]=c[(c[m>>2]|0)+(c[p>>2]<<2)>>2];c[o>>2]=1;while(1){if((c[o>>2]|0)>=(c[(c[k>>2]|0)+((c[p>>2]|0)*20|0)>>2]|0))continue c;c[q>>2]=c[(c[(c[k>>2]|0)+((c[p>>2]|0)*20|0)+4>>2]|0)+(c[o>>2]<<2)>>2];if(+(c[(c[m>>2]|0)+(c[q>>2]<<2)>>2]|0)<-.5){c[(c[m>>2]|0)+(c[q>>2]<<2)>>2]=(c[r>>2]|0)+~~+g[(c[(c[k>>2]|0)+((c[p>>2]|0)*20|0)+8>>2]|0)+(c[o>>2]<<2)>>2];Lq(c[n>>2]|0,c[q>>2]|0)|0}c[o>>2]=(c[o>>2]|0)+1}}while(0);c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[l>>2]|0))break;if(+(c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]|0)<-.5)c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]=(c[r>>2]|0)+10;c[o>>2]=(c[o>>2]|0)+1}i=h;return}function Jq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[c[e>>2]>>2]>>2]=c[f>>2];c[(c[e>>2]|0)+12>>2]=0;c[(c[e>>2]|0)+8>>2]=1;i=d;return}function Kq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;if((c[(c[g>>2]|0)+12>>2]|0)>=(c[(c[g>>2]|0)+8>>2]|0)){a[f>>0]=0;j=a[f>>0]|0;i=e;return j|0}else{d=(c[g>>2]|0)+12|0;b=c[d>>2]|0;c[d>>2]=b+1;c[c[h>>2]>>2]=c[(c[c[g>>2]>>2]|0)+(b<<2)>>2];a[f>>0]=1;j=a[f>>0]|0;i=e;return j|0}return 0}function Lq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;if((c[(c[g>>2]|0)+8>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0)){a[f>>0]=0;j=a[f>>0]|0;i=e;return j|0}else{d=c[h>>2]|0;h=(c[g>>2]|0)+8|0;b=c[h>>2]|0;c[h>>2]=b+1;c[(c[c[g>>2]>>2]|0)+(b<<2)>>2]=d;a[f>>0]=1;j=a[f>>0]|0;i=e;return j|0}return 0}function Mq(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+48|0;k=j+44|0;l=j+40|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;t=j+4|0;u=j;c[k>>2]=a;c[l>>2]=b;c[j+36>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;c[(c[m>>2]|0)+(c[k>>2]<<2)>>2]=0;Jq(c[n>>2]|0,c[k>>2]|0);c[r>>2]=0;a:while(1){if(!((Kq(c[n>>2]|0,s)|0)<<24>>24))break;c[u>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];v=c[s>>2]|0;if((c[u>>2]|0)>(c[o>>2]|0)){w=4;break}h=c[r>>2]|0;c[r>>2]=h+1;c[(c[p>>2]|0)+(h<<2)>>2]=v;c[q>>2]=1;while(1){if((c[q>>2]|0)>=(c[(c[l>>2]|0)+((c[s>>2]|0)*20|0)>>2]|0))continue a;c[t>>2]=c[(c[(c[l>>2]|0)+((c[s>>2]|0)*20|0)+4>>2]|0)+(c[q>>2]<<2)>>2];if(+(c[(c[m>>2]|0)+(c[t>>2]<<2)>>2]|0)<-.5){c[(c[m>>2]|0)+(c[t>>2]<<2)>>2]=(c[u>>2]|0)+1;Lq(c[n>>2]|0,c[t>>2]|0)|0}c[q>>2]=(c[q>>2]|0)+1}}if((w|0)==4)c[(c[m>>2]|0)+(v<<2)>>2]=-1;while(1){if(!((Kq(c[n>>2]|0,s)|0)<<24>>24))break;c[(c[m>>2]|0)+(c[s>>2]<<2)>>2]=-1}c[(c[m>>2]|0)+(c[k>>2]<<2)>>2]=-1;i=j;return c[r>>2]|0}function Nq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=cK(c[f>>2]<<2)|0;c[c[e>>2]>>2]=b;c[(c[e>>2]|0)+4>>2]=c[f>>2];c[(c[e>>2]|0)+8>>2]=0;c[(c[e>>2]|0)+12>>2]=0;i=d;return}function Oq(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[d>>2]>>2]|0);i=b;return}function Pq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+28|0;j=f+24|0;k=f+20|0;l=f;m=f+16|0;n=f+12|0;c[g>>2]=b;c[j>>2]=d;c[k>>2]=e;if(a[138998]|0)Y2(c[24742]|0,130624,f+8|0)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;h[l>>3]=0.0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[g>>2]|0))break;if((c[m>>2]|0)!=(c[n>>2]|0))h[l>>3]=+h[l>>3]+ +h[(c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}h[(c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]=-+h[l>>3];c[m>>2]=(c[m>>2]|0)+1}m=Rs(c[j>>2]|0,c[k>>2]|0,(c[g>>2]|0)-1|0)|0;i=f;return m|0}function Qq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=Mm(c[f>>2]|0,c[f>>2]|0,0.0)|0;c[j>>2]=Mm(c[f>>2]|0,c[f>>2]|0,0.0)|0;c[n>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;c[o>>2]=TA(c[e>>2]|0,c[n>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;b=c[o>>2]|0;c[l>>2]=(c[c[((c[c[o>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]>>2]|0)>>>4;b=c[o>>2]|0;c[m>>2]=(c[c[((c[c[o>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]>>2]|0)>>>4;if((c[l>>2]|0)!=(c[m>>2]|0)){p=-1.0/+h[(c[(c[o>>2]|0)+8>>2]|0)+136>>3];h[(c[(c[g>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]=p;h[(c[(c[g>>2]|0)+(c[l>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]=p}c[o>>2]=UA(c[e>>2]|0,c[o>>2]|0,c[n>>2]|0)|0}c[n>>2]=aC(c[e>>2]|0,c[n>>2]|0)|0}c[k>>2]=Pq(c[f>>2]|0,c[g>>2]|0,c[j>>2]|0)|0;if(!(c[k>>2]|0)){q=c[g>>2]|0;Nm(q);r=c[j>>2]|0;Nm(r);s=c[k>>2]|0;i=d;return s|0}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[f>>2]|0))break;c[m>>2]=0;while(1){t=c[l>>2]|0;if((c[m>>2]|0)>=(c[f>>2]|0))break;h[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)+(c[l>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]=+h[(c[(c[j>>2]|0)+(c[l>>2]<<2)>>2]|0)+(t<<3)>>3]+ +h[(c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]-+h[(c[(c[j>>2]|0)+(c[l>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]*2.0;c[m>>2]=(c[m>>2]|0)+1}c[l>>2]=t+1}q=c[g>>2]|0;Nm(q);r=c[j>>2]|0;Nm(r);s=c[k>>2]|0;i=d;return s|0}function Rq(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;j=i;i=i+112|0;k=j+48|0;l=j+100|0;m=j+96|0;n=j+92|0;o=j+88|0;p=j+40|0;q=j+84|0;r=j+80|0;s=j+76|0;t=j+32|0;u=j+24|0;v=j+16|0;w=j+8|0;x=j;y=j+72|0;z=j+68|0;A=j+64|0;B=j+60|0;C=j+56|0;D=j+52|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;h[p>>3]=f;c[q>>2]=g;c[s>>2]=0;c[y>>2]=cK(c[o>>2]<<3)|0;c[z>>2]=cK(c[o>>2]<<3)|0;c[A>>2]=cK(c[o>>2]<<3)|0;c[B>>2]=cK(c[o>>2]<<3)|0;c[C>>2]=cK(c[o>>2]<<3)|0;c[D>>2]=cK(c[o>>2]<<3)|0;ht(c[o>>2]|0,c[n>>2]|0,c[D>>2]|0);at(c[o>>2]|0,c[D>>2]|0);at(c[o>>2]|0,c[m>>2]|0);ct(c[l>>2]|0,c[o>>2]|0,c[m>>2]|0,c[B>>2]|0);et(c[o>>2]|0,c[D>>2]|0,c[B>>2]|0,c[y>>2]|0);ht(c[o>>2]|0,c[y>>2]|0,c[z>>2]|0);h[v>>3]=+it(c[o>>2]|0,c[y>>2]|0,c[y>>2]|0);c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[q>>2]|0))break;f=+jt(c[o>>2]|0,c[y>>2]|0);if(!(f>+h[p>>3]))break;ct(c[l>>2]|0,c[o>>2]|0,c[z>>2]|0,c[A>>2]|0);h[x>>3]=+it(c[o>>2]|0,c[z>>2]|0,c[A>>2]|0);if(+h[x>>3]==0.0)break;h[t>>3]=+h[v>>3]/+h[x>>3];gt(c[o>>2]|0,c[z>>2]|0,+h[t>>3],c[C>>2]|0);ft(c[o>>2]|0,c[m>>2]|0,c[C>>2]|0,c[m>>2]|0);if((c[r>>2]|0)<((c[q>>2]|0)-1|0)){gt(c[o>>2]|0,c[A>>2]|0,+h[t>>3],c[A>>2]|0);et(c[o>>2]|0,c[y>>2]|0,c[A>>2]|0,c[y>>2]|0);h[w>>3]=+it(c[o>>2]|0,c[y>>2]|0,c[y>>2]|0);if(+h[v>>3]==0.0){E=7;break}h[u>>3]=+h[w>>3]/+h[v>>3];h[v>>3]=+h[w>>3];gt(c[o>>2]|0,c[z>>2]|0,+h[u>>3],c[z>>2]|0);ft(c[o>>2]|0,c[y>>2]|0,c[z>>2]|0,c[z>>2]|0)}c[r>>2]=(c[r>>2]|0)+1}if((E|0)==7){$z(1,130650,k)|0;c[s>>2]=1}O4(c[y>>2]|0);O4(c[z>>2]|0);O4(c[A>>2]|0);O4(c[B>>2]|0);O4(c[C>>2]|0);O4(c[D>>2]|0);i=j;return c[s>>2]|0}function Sq(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;l=i;i=i+112|0;m=l+48|0;n=l+100|0;o=l+96|0;p=l+92|0;q=l+88|0;r=l+40|0;s=l+84|0;t=l+104|0;u=l+80|0;v=l+76|0;w=l+32|0;x=l+24|0;y=l+16|0;z=l+8|0;A=l;B=l+72|0;C=l+68|0;D=l+64|0;E=l+60|0;F=l+56|0;G=l+52|0;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;h[r>>3]=g;c[s>>2]=j;a[t>>0]=k;c[v>>2]=0;c[B>>2]=cK(c[q>>2]<<3)|0;c[C>>2]=cK(c[q>>2]<<3)|0;c[D>>2]=cK(c[q>>2]<<3)|0;c[E>>2]=cK(c[q>>2]<<3)|0;c[F>>2]=cK(c[q>>2]<<3)|0;c[G>>2]=cK(c[q>>2]<<3)|0;ht(c[q>>2]|0,c[p>>2]|0,c[G>>2]|0);if(a[t>>0]|0){at(c[q>>2]|0,c[G>>2]|0);at(c[q>>2]|0,c[o>>2]|0)}dt(c[n>>2]|0,c[q>>2]|0,c[o>>2]|0,c[E>>2]|0);et(c[q>>2]|0,c[G>>2]|0,c[E>>2]|0,c[B>>2]|0);ht(c[q>>2]|0,c[B>>2]|0,c[C>>2]|0);h[y>>3]=+it(c[q>>2]|0,c[B>>2]|0,c[B>>2]|0);c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[s>>2]|0))break;g=+jt(c[q>>2]|0,c[B>>2]|0);if(!(g>+h[r>>3]))break;dt(c[n>>2]|0,c[q>>2]|0,c[C>>2]|0,c[D>>2]|0);h[A>>3]=+it(c[q>>2]|0,c[C>>2]|0,c[D>>2]|0);if(+h[A>>3]==0.0)break;h[w>>3]=+h[y>>3]/+h[A>>3];gt(c[q>>2]|0,c[C>>2]|0,+h[w>>3],c[F>>2]|0);ft(c[q>>2]|0,c[o>>2]|0,c[F>>2]|0,c[o>>2]|0);if((c[u>>2]|0)<((c[s>>2]|0)-1|0)){gt(c[q>>2]|0,c[D>>2]|0,+h[w>>3],c[D>>2]|0);et(c[q>>2]|0,c[B>>2]|0,c[D>>2]|0,c[B>>2]|0);h[z>>3]=+it(c[q>>2]|0,c[B>>2]|0,c[B>>2]|0);if(+h[y>>3]==0.0){H=9;break}h[x>>3]=+h[z>>3]/+h[y>>3];h[y>>3]=+h[z>>3];gt(c[q>>2]|0,c[C>>2]|0,+h[x>>3],c[C>>2]|0);ft(c[q>>2]|0,c[B>>2]|0,c[C>>2]|0,c[C>>2]|0)}c[u>>2]=(c[u>>2]|0)+1}if((H|0)==9){c[v>>2]=1;$z(1,130650,m)|0}O4(c[B>>2]|0);O4(c[C>>2]|0);O4(c[D>>2]|0);O4(c[E>>2]|0);O4(c[F>>2]|0);O4(c[G>>2]|0);i=l;return c[v>>2]|0}function Tq(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;j=i;i=i+96|0;k=j+48|0;l=j+92|0;m=j+88|0;n=j+84|0;o=j+80|0;p=j+40|0;q=j+76|0;r=j+72|0;s=j+68|0;t=j+32|0;u=j+24|0;v=j+16|0;w=j+8|0;x=j;y=j+64|0;z=j+60|0;A=j+56|0;B=j+52|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;h[p>>3]=f;c[q>>2]=g;c[s>>2]=0;c[y>>2]=bK(c[o>>2]<<2)|0;c[z>>2]=bK(c[o>>2]<<2)|0;c[A>>2]=bK(c[o>>2]<<2)|0;c[B>>2]=bK(c[o>>2]<<2)|0;lt(c[o>>2]|0,c[m>>2]|0);lt(c[o>>2]|0,c[n>>2]|0);mt(c[l>>2]|0,c[o>>2]|0,c[m>>2]|0,c[B>>2]|0);lt(c[o>>2]|0,c[B>>2]|0);nt(c[o>>2]|0,c[n>>2]|0,c[B>>2]|0,c[y>>2]|0);rt(c[o>>2]|0,c[y>>2]|0,c[z>>2]|0);h[v>>3]=+st(c[o>>2]|0,c[y>>2]|0,c[y>>2]|0);c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[q>>2]|0)){C=10;break}f=+vt(c[o>>2]|0,c[y>>2]|0);if(!(f>+h[p>>3])){C=10;break}lt(c[o>>2]|0,c[z>>2]|0);lt(c[o>>2]|0,c[m>>2]|0);lt(c[o>>2]|0,c[y>>2]|0);mt(c[l>>2]|0,c[o>>2]|0,c[z>>2]|0,c[A>>2]|0);lt(c[o>>2]|0,c[A>>2]|0);h[x>>3]=+st(c[o>>2]|0,c[z>>2]|0,c[A>>2]|0);if(+h[x>>3]==0.0){C=10;break}h[t>>3]=+h[v>>3]/+h[x>>3];pt(c[o>>2]|0,c[m>>2]|0,+h[t>>3],c[z>>2]|0);if((c[r>>2]|0)<((c[q>>2]|0)-1|0)){pt(c[o>>2]|0,c[y>>2]|0,-+h[t>>3],c[A>>2]|0);h[w>>3]=+st(c[o>>2]|0,c[y>>2]|0,c[y>>2]|0);if(+h[v>>3]==0.0){C=7;break}h[u>>3]=+h[w>>3]/+h[v>>3];h[v>>3]=+h[w>>3];qt(c[o>>2]|0,c[z>>2]|0,+h[u>>3],c[z>>2]|0);ot(c[o>>2]|0,c[y>>2]|0,c[z>>2]|0,c[z>>2]|0)}c[r>>2]=(c[r>>2]|0)+1}if((C|0)==7){c[s>>2]=1;$z(1,130650,k)|0;D=c[y>>2]|0;O4(D);E=c[z>>2]|0;O4(E);F=c[A>>2]|0;O4(F);G=c[B>>2]|0;O4(G);H=c[s>>2]|0;i=j;return H|0}else if((C|0)==10){D=c[y>>2]|0;O4(D);E=c[z>>2]|0;O4(E);F=c[A>>2]|0;O4(F);G=c[B>>2]|0;O4(G);H=c[s>>2]|0;i=j;return H|0}return 0}function Uq(b,e,f,j,k,l,m,n,o,p){b=b|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=+p;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0.0,Ia=0,Ja=0,Ka=0,La=0,Ma=0;q=i;i=i+352|0;r=q+160|0;s=q+152|0;t=q+144|0;u=q+136|0;v=q+128|0;w=q+120|0;x=q+112|0;y=q+104|0;z=q+336|0;A=q+332|0;B=q+328|0;C=q+324|0;D=q+320|0;E=q+316|0;F=q+312|0;G=q+308|0;H=q+304|0;I=q+300|0;J=q+96|0;K=q+296|0;L=q+292|0;M=q+288|0;O=q+284|0;P=q+341|0;Q=q+280|0;R=q+276|0;S=q+272|0;T=q+268|0;U=q+264|0;V=q+260|0;W=q+256|0;X=q+252|0;Y=q+248|0;Z=q+88|0;$=q+244|0;aa=q+240|0;ba=q+80|0;ca=q+236|0;da=q+232|0;ea=q+228|0;fa=q+224|0;ga=q+72|0;ha=q+64|0;ia=q+220|0;ja=q+216|0;ka=q+212|0;la=q+208|0;ma=q+56|0;na=q+204|0;oa=q+200|0;pa=q+48|0;qa=q+40|0;ra=q+340|0;sa=q+196|0;ta=q+192|0;ua=q+188|0;va=q+184|0;wa=q+180|0;xa=q+32|0;ya=q+176|0;za=q+24|0;Aa=q+172|0;Ba=q+16|0;Ca=q+8|0;Da=q;Ea=q+168|0;c[A>>2]=b;c[B>>2]=e;c[C>>2]=f;c[D>>2]=j;c[E>>2]=k;c[F>>2]=l;c[G>>2]=m;c[H>>2]=n;c[I>>2]=o;h[J>>3]=p;c[K>>2]=0;a[P>>0]=0;c[Q>>2]=0;c[R>>2]=0;c[S>>2]=0;c[T>>2]=0;c[U>>2]=0;c[V>>2]=0;c[X>>2]=0;c[Y>>2]=0;h[Z>>3]=.001;c[$>>2]=0;c[aa>>2]=0;c[da>>2]=c[G>>2]&4;c[fa>>2]=0;h[ga>>3]=.01;h[ha>>3]=.1;c[ia>>2]=0;c[ja>>2]=0;a:do if(c[(c[A>>2]|0)+16>>2]|0){c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[B>>2]|0))break a;c[M>>2]=1;while(1){if((c[M>>2]|0)>=(c[(c[A>>2]|0)+((c[L>>2]|0)*20|0)>>2]|0))break;if(d[P>>0]|0)Fa=1;else Fa=+g[(c[(c[A>>2]|0)+((c[L>>2]|0)*20|0)+16>>2]|0)+(c[M>>2]<<2)>>2]!=0.0;a[P>>0]=Fa&1;c[M>>2]=(c[M>>2]|0)+1}c[L>>2]=(c[L>>2]|0)+1}}while(0);if(!(a[P>>0]|0)){c[z>>2]=Fm(c[A>>2]|0,c[B>>2]|0,c[C>>2]|0,c[D>>2]|0,c[E>>2]|0,c[F>>2]|0,c[G>>2]|0,c[H>>2]|0,c[I>>2]|0)|0;Ga=c[z>>2]|0;i=q;return Ga|0}do if(c[da>>2]|0){b:do if((c[F>>2]|0)>2){if((Fm(c[A>>2]|0,c[B>>2]|0,c[C>>2]|0,(c[D>>2]|0)+4|0,c[E>>2]|0,(c[F>>2]|0)-1|0,c[G>>2]|0,c[H>>2]|0,15)|0)<0){c[z>>2]=-1;Ga=c[z>>2]|0;i=q;return Ga|0}c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[B>>2]|0))break b;h[(c[(c[D>>2]|0)+((c[F>>2]|0)-1<<2)>>2]|0)+(c[L>>2]<<3)>>3]=+h[(c[(c[D>>2]|0)+4>>2]|0)+(c[L>>2]<<3)>>3];c[L>>2]=(c[L>>2]|0)+1}}while(0);c[va>>2]=c[c[D>>2]>>2];c[wa>>2]=c[(c[D>>2]|0)+4>>2];if(Et(c[A>>2]|0,c[B>>2]|0,c[wa>>2]|0,c[B>>2]|0)|0){c[K>>2]=-1;break}if(Xx(c[A>>2]|0,c[B>>2]|0,+h[ga>>3],+h[ha>>3],c[wa>>2]|0,ia,ja,ta)|0){c[K>>2]=-1;break}if((c[ta>>2]|0)<1){c[z>>2]=Fm(c[A>>2]|0,c[B>>2]|0,c[C>>2]|0,c[D>>2]|0,c[E>>2]|0,c[F>>2]|0,c[G>>2]|0,c[H>>2]|0,c[I>>2]|0)|0;Ga=c[z>>2]|0;i=q;return Ga|0}c:do if(+h[J>>3]>0.0){h[xa>>3]=0.0;c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[ta>>2]|0))break c;if(0.0>+h[J>>3]-(+h[(c[wa>>2]|0)+(c[(c[ia>>2]|0)+(c[(c[ja>>2]|0)+(c[L>>2]<<2)>>2]<<2)>>2]<<3)>>3]+ +h[xa>>3]-+h[(c[wa>>2]|0)+(c[(c[ia>>2]|0)+((c[(c[ja>>2]|0)+(c[L>>2]<<2)>>2]|0)-1<<2)>>2]<<3)>>3]))Ha=0.0;else Ha=+h[J>>3]-(+h[(c[wa>>2]|0)+(c[(c[ia>>2]|0)+(c[(c[ja>>2]|0)+(c[L>>2]<<2)>>2]<<2)>>2]<<3)>>3]+ +h[xa>>3]-+h[(c[wa>>2]|0)+(c[(c[ia>>2]|0)+((c[(c[ja>>2]|0)+(c[L>>2]<<2)>>2]|0)-1<<2)>>2]<<3)>>3]);h[xa>>3]=+h[xa>>3]+Ha;if((c[L>>2]|0)<((c[ta>>2]|0)-1|0))Ia=c[(c[ja>>2]|0)+((c[L>>2]|0)+1<<2)>>2]|0;else Ia=c[B>>2]|0;c[ya>>2]=Ia;c[M>>2]=c[(c[ja>>2]|0)+(c[L>>2]<<2)>>2];while(1){if((c[M>>2]|0)>=(c[ya>>2]|0))break;P=(c[wa>>2]|0)+(c[(c[ia>>2]|0)+(c[M>>2]<<2)>>2]<<3)|0;h[P>>3]=+h[P>>3]+ +h[xa>>3];c[M>>2]=(c[M>>2]|0)+1}c[L>>2]=(c[L>>2]|0)+1}}while(0);if((c[F>>2]|0)==2?(ju(c[A>>2]|0,c[B>>2]|0,c[wa>>2]|0,c[va>>2]|0,+h[4247])|0)!=0:0)c[K>>2]=-1;else Ja=42}else{Am(c[A>>2]|0,c[B>>2]|0,c[F>>2]|0,c[D>>2]|0,c[E>>2]|0)|0;if(Xx(c[A>>2]|0,c[B>>2]|0,+h[ga>>3],+h[ha>>3],0,ia,ja,ta)|0)c[K>>2]=-1;else Ja=42}while(0);do if((Ja|0)==42){if((c[B>>2]|0)==1){c[z>>2]=0;Ga=c[z>>2]|0;i=q;return Ga|0}c[ua>>2]=cK(c[ta>>2]<<2)|0;if(!(c[I>>2]|0)){c[z>>2]=c[K>>2];Ga=c[z>>2]|0;i=q;return Ga|0}if(a[138998]|0)_N();do if((c[H>>2]|0)!=2){if((c[H>>2]|0)==1){c[fa>>2]=Bm(c[A>>2]|0,c[B>>2]|0)|0;if(c[fa>>2]|0)break;$z(0,130723,x)|0;$z(3,130772,w)|0;break}if((c[H>>2]|0)==3){if(a[138998]|0)Y2(c[24742]|0,130825,v)|0;c[fa>>2]=Cm(c[A>>2]|0,c[B>>2]|0)|0}}else{if(a[138998]|0)Y2(c[24742]|0,130698,y)|0;c[fa>>2]=Em(c[A>>2]|0,c[B>>2]|0)|0}while(0);if(!(c[fa>>2]|0)){if(a[138998]|0)Y2(c[24742]|0,130847,u)|0;c[fa>>2]=Dm(c[A>>2]|0,c[B>>2]|0)|0}if(a[138998]|0){ha=c[24742]|0;h[t>>3]=+$N();Y2(ha,130874,t)|0;Y2(c[24742]|0,130886,s)|0;_N()}c[ea>>2]=-1;c[ca>>2]=(c[B>>2]|0)+((_(c[B>>2]|0,(c[B>>2]|0)-1|0)|0)/2|0);c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[ca>>2]|0))break;if(+g[(c[fa>>2]|0)+(c[L>>2]<<2)>>2]>+(c[ea>>2]|0))c[ea>>2]=~~+g[(c[fa>>2]|0)+(c[L>>2]<<2)>>2];c[L>>2]=(c[L>>2]|0)+1}d:do if(!(c[da>>2]|0)){h[za>>3]=1.0;c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[F>>2]|0))break;c[M>>2]=0;while(1){if((c[M>>2]|0)>=(c[B>>2]|0))break;Ha=+N(+(+h[(c[(c[D>>2]|0)+(c[L>>2]<<2)>>2]|0)+(c[M>>2]<<3)>>3]));if(Ha>+h[za>>3])h[za>>3]=+N(+(+h[(c[(c[D>>2]|0)+(c[L>>2]<<2)>>2]|0)+(c[M>>2]<<3)>>3]));c[M>>2]=(c[M>>2]|0)+1}c[L>>2]=(c[L>>2]|0)+1}c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[F>>2]|0))break d;c[M>>2]=0;while(1){if((c[M>>2]|0)>=(c[B>>2]|0))break;ha=(c[(c[D>>2]|0)+(c[L>>2]<<2)>>2]|0)+(c[M>>2]<<3)|0;h[ha>>3]=+h[ha>>3]*(10.0/+h[za>>3]);c[M>>2]=(c[M>>2]|0)+1}c[L>>2]=(c[L>>2]|0)+1}}while(0);e:do if(+h[J>>3]>0.0){c[Aa>>2]=(c[B>>2]|0)+((_(c[B>>2]|0,(c[B>>2]|0)-1|0)|0)/2|0);h[Ba>>3]=+((_(c[B>>2]|0,(c[B>>2]|0)-1|0)|0)/2|0|0);h[Ca>>3]=0.0;c[Ea>>2]=0;c[L>>2]=0;while(1){if((c[L>>2]|0)>=((c[B>>2]|0)-1|0))break;c[Ea>>2]=(c[Ea>>2]|0)+1;c[M>>2]=(c[L>>2]|0)+1;while(1){if((c[M>>2]|0)>=(c[B>>2]|0))break;Ha=+ys(c[D>>2]|0,c[F>>2]|0,c[L>>2]|0,c[M>>2]|0);h[Ca>>3]=+h[Ca>>3]+Ha/+g[(c[fa>>2]|0)+(c[Ea>>2]<<2)>>2];c[M>>2]=(c[M>>2]|0)+1;c[Ea>>2]=(c[Ea>>2]|0)+1}c[L>>2]=(c[L>>2]|0)+1}h[Da>>3]=+h[Ca>>3]/+h[Ba>>3];c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[Aa>>2]|0))break e;ha=(c[fa>>2]|0)+(c[L>>2]<<2)|0;g[ha>>2]=+g[ha>>2]*+h[Da>>3];c[L>>2]=(c[L>>2]|0)+1}}while(0);c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[F>>2]|0))break;at(c[B>>2]|0,c[(c[D>>2]|0)+(c[L>>2]<<2)>>2]|0);c[L>>2]=(c[L>>2]|0)+1}h[ba>>3]=+h[c[(c[D>>2]|0)+4>>2]>>3];c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[B>>2]|0))break;ha=(c[(c[D>>2]|0)+4>>2]|0)+(c[L>>2]<<3)|0;h[ha>>3]=+h[ha>>3]-+h[ba>>3];c[L>>2]=(c[L>>2]|0)+1}c[Y>>2]=cK(c[F>>2]<<2)|0;c[X>>2]=cK((_(c[F>>2]|0,c[B>>2]|0)|0)<<2)|0;c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[F>>2]|0))break;ha=(c[X>>2]|0)+((_(c[L>>2]|0,c[B>>2]|0)|0)<<2)|0;c[(c[Y>>2]|0)+(c[L>>2]<<2)>>2]=ha;c[M>>2]=0;while(1){if((c[M>>2]|0)>=(c[B>>2]|0))break;g[(c[(c[Y>>2]|0)+(c[L>>2]<<2)>>2]|0)+(c[M>>2]<<2)>>2]=+h[(c[(c[D>>2]|0)+(c[L>>2]<<2)>>2]|0)+(c[M>>2]<<3)>>3];c[M>>2]=(c[M>>2]|0)+1}c[L>>2]=(c[L>>2]|0)+1}g[ka>>2]=+((_(c[B>>2]|0,(c[B>>2]|0)-1|0)|0)/2|0|0);if(a[138998]|0){ha=c[24742]|0;h[r>>3]=+$N();Y2(ha,130912,r)|0}c[V>>2]=c[fa>>2];c[W>>2]=(c[B>>2]|0)+((_(c[B>>2]|0,(c[B>>2]|0)-1|0)|0)/2|0);wt(c[W>>2]|0,c[V>>2]|0);xt(c[W>>2]|0,c[V>>2]|0);c[la>>2]=0;c[U>>2]=cK(c[B>>2]<<3)|0;tt(c[B>>2]|0,0.0,c[U>>2]|0);c[L>>2]=0;while(1){if((c[L>>2]|0)>=((c[B>>2]|0)-1|0))break;h[ma>>3]=0.0;c[la>>2]=(c[la>>2]|0)+1;c[M>>2]=1;while(1){if((c[M>>2]|0)>=((c[B>>2]|0)-(c[L>>2]|0)|0))break;g[oa>>2]=+g[(c[V>>2]|0)+(c[la>>2]<<2)>>2];h[ma>>3]=+h[ma>>3]+ +g[oa>>2];ha=(c[U>>2]|0)+((c[L>>2]|0)+(c[M>>2]|0)<<3)|0;h[ha>>3]=+h[ha>>3]-+g[oa>>2];c[M>>2]=(c[M>>2]|0)+1;c[la>>2]=(c[la>>2]|0)+1}ha=(c[U>>2]|0)+(c[L>>2]<<3)|0;h[ha>>3]=+h[ha>>3]-+h[ma>>3];c[L>>2]=(c[L>>2]|0)+1}c[na>>2]=c[B>>2];c[la>>2]=0;c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[B>>2]|0))break;g[(c[V>>2]|0)+(c[la>>2]<<2)>>2]=+h[(c[U>>2]|0)+(c[L>>2]<<3)>>3];c[L>>2]=(c[L>>2]|0)+1;c[la>>2]=(c[la>>2]|0)+(c[na>>2]|0);c[na>>2]=(c[na>>2]|0)+-1}c[T>>2]=cK(c[F>>2]<<2)|0;ha=cK((_(c[F>>2]|0,c[B>>2]|0)|0)<<2)|0;c[c[T>>2]>>2]=ha;c[O>>2]=1;while(1){if((c[O>>2]|0)>=(c[F>>2]|0))break;ha=(c[c[T>>2]>>2]|0)+((_(c[O>>2]|0,c[B>>2]|0)|0)<<2)|0;c[(c[T>>2]|0)+(c[O>>2]<<2)>>2]=ha;c[O>>2]=(c[O>>2]|0)+1}c[S>>2]=cK(c[B>>2]<<2)|0;c[R>>2]=cK(c[B>>2]<<2)|0;c[Q>>2]=cK(c[W>>2]<<2)|0;h[pa>>3]=1797693134862315708145274.0e284;c[$>>2]=Zt(c[V>>2]|0,c[B>>2]|0)|0;c[aa>>2]=au(c[V>>2]|0,c[B>>2]|0,c[ia>>2]|0,c[ja>>2]|0,c[ta>>2]|0)|0;a[ra>>0]=0;c[K>>2]=0;f:while(1){if((c[K>>2]|0)>=(c[I>>2]|0))break;if(!((a[ra>>0]|0)!=0^1))break;tt(c[B>>2]|0,0.0,c[U>>2]|0);yt(c[W>>2]|0,c[V>>2]|0,c[Q>>2]|0);c[la>>2]=0;c[L>>2]=0;while(1){Ka=c[B>>2]|0;if((c[L>>2]|0)>=((c[B>>2]|0)-1|0))break;c[sa>>2]=Ka-(c[L>>2]|0)-1;ut(c[B>>2]|0,0.0,c[R>>2]|0);c[O>>2]=0;while(1){La=c[sa>>2]|0;if((c[O>>2]|0)>=(c[F>>2]|0))break;ut(La,+g[(c[(c[Y>>2]|0)+(c[O>>2]<<2)>>2]|0)+(c[L>>2]<<2)>>2],c[S>>2]|0);pt(c[sa>>2]|0,c[S>>2]|0,-1.0,(c[(c[Y>>2]|0)+(c[O>>2]<<2)>>2]|0)+(c[L>>2]<<2)+4|0);wt(c[sa>>2]|0,c[S>>2]|0);ot(c[sa>>2]|0,c[S>>2]|0,c[R>>2]|0,c[R>>2]|0);c[O>>2]=(c[O>>2]|0)+1}zt(La,c[R>>2]|0);c[M>>2]=0;while(1){if((c[M>>2]|0)>=(c[sa>>2]|0))break;if(!(!(+g[(c[R>>2]|0)+(c[M>>2]<<2)>>2]>=3402823466385288598117041.0e14)?!(+g[(c[R>>2]|0)+(c[M>>2]<<2)>>2]<0.0):0))g[(c[R>>2]|0)+(c[M>>2]<<2)>>2]=0.0;c[M>>2]=(c[M>>2]|0)+1}c[la>>2]=(c[la>>2]|0)+1;h[ma>>3]=0.0;c[M>>2]=0;while(1){if((c[M>>2]|0)>=(c[sa>>2]|0))break;ha=(c[Q>>2]|0)+(c[la>>2]<<2)|0;Ha=+g[ha>>2]*+g[(c[R>>2]|0)+(c[M>>2]<<2)>>2];g[ha>>2]=Ha;g[oa>>2]=Ha;h[ma>>3]=+h[ma>>3]+ +g[oa>>2];ha=(c[U>>2]|0)+((c[L>>2]|0)+(c[M>>2]|0)+1<<3)|0;h[ha>>3]=+h[ha>>3]-+g[oa>>2];c[M>>2]=(c[M>>2]|0)+1;c[la>>2]=(c[la>>2]|0)+1}ha=(c[U>>2]|0)+(c[L>>2]<<3)|0;h[ha>>3]=+h[ha>>3]-+h[ma>>3];c[L>>2]=(c[L>>2]|0)+1}c[na>>2]=Ka;c[la>>2]=0;c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[B>>2]|0))break;g[(c[Q>>2]|0)+(c[la>>2]<<2)>>2]=+h[(c[U>>2]|0)+(c[L>>2]<<3)>>3];c[L>>2]=(c[L>>2]|0)+1;c[la>>2]=(c[la>>2]|0)+(c[na>>2]|0);c[na>>2]=(c[na>>2]|0)+-1}c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[F>>2]|0))break;mt(c[Q>>2]|0,c[B>>2]|0,c[(c[Y>>2]|0)+(c[O>>2]<<2)>>2]|0,c[(c[T>>2]|0)+(c[O>>2]<<2)>>2]|0);c[O>>2]=(c[O>>2]|0)+1}h[qa>>3]=0.0;c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[F>>2]|0))break;Ha=+st(c[B>>2]|0,c[(c[Y>>2]|0)+(c[O>>2]<<2)>>2]|0,c[(c[T>>2]|0)+(c[O>>2]<<2)>>2]|0);h[qa>>3]=+h[qa>>3]+Ha;c[O>>2]=(c[O>>2]|0)+1}h[qa>>3]=+h[qa>>3]*2.0;h[qa>>3]=+h[qa>>3]+ +g[ka>>2];c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[F>>2]|0))break;mt(c[V>>2]|0,c[B>>2]|0,c[(c[Y>>2]|0)+(c[O>>2]<<2)>>2]|0,c[S>>2]|0);Ha=+st(c[B>>2]|0,c[(c[Y>>2]|0)+(c[O>>2]<<2)>>2]|0,c[S>>2]|0);h[qa>>3]=+h[qa>>3]-Ha;c[O>>2]=(c[O>>2]|0)+1}Ha=+N(+(+h[qa>>3]-+h[pa>>3]));p=Ha/+N(+(+h[pa>>3]+1.0e-10));a[ra>>0]=p<+h[4247];if(!(d[ra>>0]|0))if((c[K>>2]|0)>1)Ma=+h[qa>>3]>+h[pa>>3];else Ma=0;else Ma=1;a[ra>>0]=Ma&1;h[pa>>3]=+h[qa>>3];c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[F>>2]|0))break;if((c[O>>2]|0)!=1){if(Tq(c[V>>2]|0,c[(c[Y>>2]|0)+(c[O>>2]<<2)>>2]|0,c[(c[T>>2]|0)+(c[O>>2]<<2)>>2]|0,c[B>>2]|0,+h[Z>>3],c[B>>2]|0)|0){Ja=159;break f}}else _t(c[aa>>2]|0,c[(c[T>>2]|0)+(c[O>>2]<<2)>>2]|0,c[Y>>2]|0,c[F>>2]|0,c[O>>2]|0,15,c[ua>>2]|0,+h[J>>3])|0;c[O>>2]=(c[O>>2]|0)+1}c[K>>2]=(c[K>>2]|0)+1}if((Ja|0)==159){c[K>>2]=-1;break}O4(c[ua>>2]|0);$t(c[aa>>2]|0);if(c[Y>>2]|0){c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[F>>2]|0))break;c[M>>2]=0;while(1){if((c[M>>2]|0)>=(c[B>>2]|0))break;h[(c[(c[D>>2]|0)+(c[L>>2]<<2)>>2]|0)+(c[M>>2]<<3)>>3]=+g[(c[(c[Y>>2]|0)+(c[L>>2]<<2)>>2]|0)+(c[M>>2]<<2)>>2];c[M>>2]=(c[M>>2]|0)+1}c[L>>2]=(c[L>>2]|0)+1}O4(c[c[Y>>2]>>2]|0);O4(c[Y>>2]|0)}if(c[T>>2]|0){O4(c[c[T>>2]>>2]|0);O4(c[T>>2]|0)}O4(c[S>>2]|0);O4(c[R>>2]|0);O4(c[U>>2]|0);O4(c[V>>2]|0);O4(c[Q>>2]|0)}while(0);O4(c[ia>>2]|0);O4(c[ja>>2]|0);if(c[$>>2]|0){O4(c[c[$>>2]>>2]|0);O4(c[$>>2]|0)}c[z>>2]=c[K>>2];Ga=c[z>>2]|0;i=q;return Ga|0}function Vq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+80|0;e=d+64|0;f=d+60|0;g=d+56|0;j=d+44|0;k=d+40|0;l=d+36|0;m=d+32|0;n=d+28|0;o=d+24|0;p=d+20|0;q=d+8|0;r=d;c[f>>2]=a;c[g>>2]=b;c[m>>2]=kB(c[f>>2]|0)|0;c[n>>2]=cK((c[m>>2]|0)*48|0)|0;c[o>>2]=c[n>>2];gq(q,c[f>>2]|0);c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[p>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;q=c[p>>2]|0;b=c[o>>2]|0;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];Xq(q,b,e);c[o>>2]=(c[o>>2]|0)+48;c[p>>2]=aC(c[f>>2]|0,c[p>>2]|0)|0}if(!(Yq(c[n>>2]|0,c[m>>2]|0)|0)){c[k>>2]=0;s=c[n>>2]|0;O4(s);t=c[k>>2]|0;i=d;return t|0}switch(c[g>>2]|0){case 9:{_q(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,70,1);ar(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,71,1);break}case 10:{ar(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,71,1);_q(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,70,1);break}case 7:{_q(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,72,1);ar(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,71,1);u=9;break}case 8:{u=9;break}case 13:{u=10;break}case 14:{ar(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,71,0);_q(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,70,0);break}case 12:{ar(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,73,0);_q(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,70,0);break}default:{_q(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,72,0);ar(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,71,0)}}if((u|0)==9){ar(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,73,1);_q(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,70,1);u=10}if((u|0)==10){_q(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,70,0);ar(c[f>>2]|0,c[n>>2]|0,c[m>>2]|0,71,0)}c[o>>2]=c[n>>2];c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[m>>2]|0))break;c[p>>2]=c[(c[o>>2]|0)+20>>2];f=(c[o>>2]|0)+12|0;c[r>>2]=c[f>>2];c[r+4>>2]=c[f+4>>2];h[c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]>>3]=+(c[r>>2]|0)/72.0/10.0;h[(c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+(c[r+4>>2]|0)/72.0/10.0;c[o>>2]=(c[o>>2]|0)+48;c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=1;s=c[n>>2]|0;O4(s);t=c[k>>2]|0;i=d;return t|0}function Wq(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0;e=i;i=i+144|0;f=e+56|0;j=e+48|0;k=e+132|0;l=e+128|0;m=e+124|0;n=e+120|0;o=e+116|0;p=e+112|0;q=e+108|0;r=e+32|0;s=e+104|0;t=e+92|0;u=e+88|0;v=e+84|0;w=e+72|0;x=e+24|0;y=e+16|0;z=e;c[l>>2]=b;c[m>>2]=d;c[n>>2]=kB(c[l>>2]|0)|0;c[o>>2]=cK((c[n>>2]|0)*72|0)|0;c[p>>2]=c[o>>2];gq(w,c[l>>2]|0);c[t>>2]=c[w>>2];c[t+4>>2]=c[w+4>>2];c[t+8>>2]=c[w+8>>2];if(a[t+8>>0]|0){g[t>>2]=+g[t>>2]/72.0;g[t+4>>2]=+g[t+4>>2]/72.0}c[q>>2]=$B(c[l>>2]|0)|0;while(1){if(!(c[q>>2]|0))break;if(a[t+8>>0]|0){h[x>>3]=+h[(c[(c[q>>2]|0)+8>>2]|0)+32>>3]/2.0+ +g[t>>2];h[y>>3]=+h[(c[(c[q>>2]|0)+8>>2]|0)+40>>3]/2.0+ +g[t+4>>2]}else{h[x>>3]=+g[t>>2]*+h[(c[(c[q>>2]|0)+8>>2]|0)+32>>3]/2.0;h[y>>3]=+g[t+4>>2]*+h[(c[(c[q>>2]|0)+8>>2]|0)+40>>3]/2.0}h[c[p>>2]>>3]=+h[c[(c[(c[q>>2]|0)+8>>2]|0)+132>>2]>>3];h[(c[p>>2]|0)+8>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];h[(c[p>>2]|0)+16>>3]=+h[c[p>>2]>>3]-+h[x>>3];h[(c[p>>2]|0)+16+8>>3]=+h[(c[p>>2]|0)+8>>3]-+h[y>>3];h[(c[p>>2]|0)+16+16>>3]=+h[c[p>>2]>>3]+ +h[x>>3];h[(c[p>>2]|0)+16+16+8>>3]=+h[(c[p>>2]|0)+8>>3]+ +h[y>>3];h[(c[p>>2]|0)+48>>3]=+h[x>>3];h[(c[p>>2]|0)+56>>3]=+h[y>>3];c[(c[p>>2]|0)+64>>2]=c[q>>2];c[p>>2]=(c[p>>2]|0)+72;c[q>>2]=aC(c[l>>2]|0,c[q>>2]|0)|0}q=c[o>>2]|0;l=c[n>>2]|0;do if((c[m>>2]|0)<0){A=+dr(q,l);h[r+8>>3]=A;h[r>>3]=A;if(+h[r>>3]==0.0){O4(c[o>>2]|0);c[k>>2]=0;B=c[k>>2]|0;i=e;return B|0}else{if(!(a[138998]|0))break;y=c[24742]|0;h[j>>3]=+h[r>>3];Y2(y,130923,j)|0;break}}else{c[u>>2]=er(q,l,v)|0;if(!(c[v>>2]|0)){O4(c[u>>2]|0);O4(c[o>>2]|0);c[k>>2]=0;B=c[k>>2]|0;i=e;return B|0}y=c[u>>2]|0;x=c[v>>2]|0;if(c[m>>2]|0){A=+fr(y,x);h[r+8>>3]=A;h[r>>3]=A}else{gr(z,y,x);c[r>>2]=c[z>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];c[r+12>>2]=c[z+12>>2]}O4(c[u>>2]|0);if(a[138998]|0){x=c[24742]|0;A=+h[r+8>>3];h[f>>3]=+h[r>>3];h[f+8>>3]=A;Y2(x,130937,f)|0}}while(0);c[p>>2]=c[o>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;h[c[(c[(c[(c[p>>2]|0)+64>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[r>>3]*+h[c[p>>2]>>3];h[(c[(c[(c[(c[p>>2]|0)+64>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[r+8>>3]*+h[(c[p>>2]|0)+8>>3];c[p>>2]=(c[p>>2]|0)+72;c[s>>2]=(c[s>>2]|0)+1}O4(c[o>>2]|0);c[k>>2]=1;B=c[k>>2]|0;i=e;return B|0}function Xq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;f=i;i=i+48|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f;c[j>>2]=b;c[k>>2]=d;q=+h[c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]>>3]*10.0*72.0;c[l>>2]=~~(+h[c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]>>3]*10.0*72.0>=0.0?q+.5:q-.5);q=+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]*10.0*72.0;c[m>>2]=~~(+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]*10.0*72.0>=0.0?q+.5:q-.5);if(a[e+8>>0]|0){q=+h[(c[(c[j>>2]|0)+8>>2]|0)+32>>3]/2.0*72.0;c[n>>2]=~~((+(~~(+h[(c[(c[j>>2]|0)+8>>2]|0)+32>>3]/2.0*72.0>=0.0?q+.5:q-.5)|0)+ +g[e>>2])*10.0);q=+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3]/2.0*72.0;c[o>>2]=~~((+(~~(+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3]/2.0*72.0>=0.0?q+.5:q-.5)|0)+ +g[e+4>>2])*10.0)}else{q=+g[e>>2]*5.0*+h[(c[(c[j>>2]|0)+8>>2]|0)+32>>3]*72.0;c[n>>2]=~~(+g[e>>2]*5.0*+h[(c[(c[j>>2]|0)+8>>2]|0)+32>>3]*72.0>=0.0?q+.5:q-.5);q=+g[e+4>>2]*5.0*+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3]*72.0;c[o>>2]=~~(+g[e+4>>2]*5.0*+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3]*72.0>=0.0?q+.5:q-.5)}c[p>>2]=(c[l>>2]|0)-(c[n>>2]|0);c[p+4>>2]=(c[m>>2]|0)-(c[o>>2]|0);c[p+8>>2]=(c[l>>2]|0)+(c[n>>2]|0);c[p+8+4>>2]=(c[m>>2]|0)+(c[o>>2]|0);c[(c[k>>2]|0)+12>>2]=c[l>>2];c[(c[k>>2]|0)+12+4>>2]=c[m>>2];c[(c[k>>2]|0)+20>>2]=c[j>>2];j=(c[k>>2]|0)+32|0;c[j>>2]=c[p>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];i=f;return}function Yq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=c[f>>2];c[h>>2]=0;a:while(1){if((c[h>>2]|0)>=((c[g>>2]|0)-1|0)){m=12;break}c[l>>2]=(c[k>>2]|0)+48;c[j>>2]=(c[h>>2]|0)+1;while(1){n=c[k>>2]|0;if((c[j>>2]|0)>=(c[g>>2]|0))break;if((((c[n+32>>2]|0)<=(c[(c[l>>2]|0)+32+8>>2]|0)?(c[(c[l>>2]|0)+32>>2]|0)<=(c[(c[k>>2]|0)+32+8>>2]|0):0)?(c[(c[k>>2]|0)+32+4>>2]|0)<=(c[(c[l>>2]|0)+32+8+4>>2]|0):0)?(c[(c[l>>2]|0)+32+4>>2]|0)<=(c[(c[k>>2]|0)+32+8+4>>2]|0):0){m=9;break a}c[l>>2]=(c[l>>2]|0)+48;c[j>>2]=(c[j>>2]|0)+1}c[k>>2]=n+48;c[h>>2]=(c[h>>2]|0)+1}if((m|0)==9){c[e>>2]=1;o=c[e>>2]|0;i=d;return o|0}else if((m|0)==12){c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}return 0}function Zq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[(c[e>>2]|0)+32+4>>2]|0)>(c[(c[f>>2]|0)+32+8+4>>2]|0)){g=0;h=g&1;i=d;return h|0}g=(c[(c[f>>2]|0)+32+4>>2]|0)<=(c[(c[e>>2]|0)+32+8+4>>2]|0);h=g&1;i=d;return h|0}function _q(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;t=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=Nz(51428,c[12990]|0)|0;c[o>>2]=c[j>>2];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[(c[o>>2]|0)+8>>2]=c[(c[o>>2]|0)+12>>2];Hb[c[c[n>>2]>>2]&63](c[n>>2]|0,c[o>>2]|0,1)|0;c[o>>2]=(c[o>>2]|0)+48;c[q>>2]=(c[q>>2]|0)+1}f=c[h>>2]|0;h=c[n>>2]|0;e=c[l>>2]|0;if(c[m>>2]|0)c[p>>2]=kr(f,h,e,74)|0;else c[p>>2]=lr(f,h,e,74)|0;gK(c[p>>2]|0,2,2147483647)|0;c[o>>2]=c[j>>2];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[s>>2]=c[(c[o>>2]|0)+12>>2];c[r>>2]=c[(c[(c[(c[o>>2]|0)+24>>2]|0)+8>>2]|0)+232>>2];c[t>>2]=(c[r>>2]|0)-(c[s>>2]|0);c[(c[o>>2]|0)+12>>2]=c[r>>2];j=(c[o>>2]|0)+32|0;c[j>>2]=(c[j>>2]|0)+(c[t>>2]|0);j=(c[o>>2]|0)+32+8|0;c[j>>2]=(c[j>>2]|0)+(c[t>>2]|0);c[o>>2]=(c[o>>2]|0)+48;c[q>>2]=(c[q>>2]|0)+1}mr(c[p>>2]|0);Jz(c[n>>2]|0)|0;i=g;return}function $q(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if((c[(c[e>>2]|0)+32>>2]|0)>(c[(c[f>>2]|0)+32+8>>2]|0)){g=0;h=g&1;i=d;return h|0}g=(c[(c[f>>2]|0)+32>>2]|0)<=(c[(c[e>>2]|0)+32+8>>2]|0);h=g&1;i=d;return h|0}function ar(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+48|0;h=g+44|0;j=g+40|0;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+20|0;p=g+16|0;q=g+12|0;r=g+8|0;s=g+4|0;t=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=Nz(51428,c[12990]|0)|0;c[o>>2]=c[j>>2];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[(c[o>>2]|0)+8>>2]=c[(c[o>>2]|0)+12+4>>2];Hb[c[c[n>>2]>>2]&63](c[n>>2]|0,c[o>>2]|0,1)|0;c[o>>2]=(c[o>>2]|0)+48;c[q>>2]=(c[q>>2]|0)+1}f=c[h>>2]|0;h=c[n>>2]|0;e=c[l>>2]|0;if(c[m>>2]|0)c[p>>2]=kr(f,h,e,75)|0;else c[p>>2]=lr(f,h,e,75)|0;gK(c[p>>2]|0,2,2147483647)|0;c[o>>2]=c[j>>2];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[s>>2]=c[(c[o>>2]|0)+12+4>>2];c[r>>2]=c[(c[(c[(c[o>>2]|0)+24>>2]|0)+8>>2]|0)+232>>2];c[t>>2]=(c[r>>2]|0)-(c[s>>2]|0);c[(c[o>>2]|0)+12+4>>2]=c[r>>2];j=(c[o>>2]|0)+32+4|0;c[j>>2]=(c[j>>2]|0)+(c[t>>2]|0);j=(c[o>>2]|0)+32+8+4|0;c[j>>2]=(c[j>>2]|0)+(c[t>>2]|0);c[o>>2]=(c[o>>2]|0)+48;c[q>>2]=(c[q>>2]|0)+1}mr(c[p>>2]|0);Jz(c[n>>2]|0)|0;i=g;return}function br(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+32+4>>2]|0)<=(c[(c[g>>2]|0)+32+8+4>>2]|0))l=(c[(c[g>>2]|0)+32+4>>2]|0)<=(c[(c[f>>2]|0)+32+8+4>>2]|0);else l=0;c[k>>2]=l&1;if(!(c[k>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if((c[(c[f>>2]|0)+32+8>>2]|0)<(c[(c[g>>2]|0)+32>>2]|0)){c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}k=jr((c[f>>2]|0)+32|0,(c[g>>2]|0)+32|0)|0;c[h>>2]=k-((c[(c[g>>2]|0)+12>>2]|0)-(c[(c[f>>2]|0)+12>>2]|0));k=(c[(c[g>>2]|0)+12+4>>2]|0)>=(c[(c[f>>2]|0)+12+4>>2]|0);l=ir((c[f>>2]|0)+32|0,(c[g>>2]|0)+32|0)|0;if(k)c[j>>2]=l-((c[(c[g>>2]|0)+12+4>>2]|0)-(c[(c[f>>2]|0)+12+4>>2]|0));else c[j>>2]=l-((c[(c[f>>2]|0)+12+4>>2]|0)-(c[(c[g>>2]|0)+12+4>>2]|0));c[e>>2]=(c[h>>2]|0)<=(c[j>>2]|0)&1;m=c[e>>2]|0;i=d;return m|0}function cr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[f>>2]|0)+32>>2]|0)<=(c[(c[g>>2]|0)+32+8>>2]|0))l=(c[(c[g>>2]|0)+32>>2]|0)<=(c[(c[f>>2]|0)+32+8>>2]|0);else l=0;c[k>>2]=l&1;if(!(c[k>>2]|0)){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}if((c[(c[f>>2]|0)+32+8+4>>2]|0)<(c[(c[g>>2]|0)+32+4>>2]|0)){c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}k=ir((c[f>>2]|0)+32|0,(c[g>>2]|0)+32|0)|0;c[j>>2]=k-((c[(c[g>>2]|0)+12+4>>2]|0)-(c[(c[f>>2]|0)+12+4>>2]|0));k=(c[(c[g>>2]|0)+12>>2]|0)>=(c[(c[f>>2]|0)+12>>2]|0);l=jr((c[f>>2]|0)+32|0,(c[g>>2]|0)+32|0)|0;if(k)c[h>>2]=l-((c[(c[g>>2]|0)+12>>2]|0)-(c[(c[f>>2]|0)+12>>2]|0));else c[h>>2]=l-((c[(c[f>>2]|0)+12>>2]|0)-(c[(c[g>>2]|0)+12>>2]|0));c[e>>2]=(c[j>>2]|0)<=(c[h>>2]|0)&1;m=c[e>>2]|0;i=d;return m|0}function dr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,t=0.0;d=i;i=i+64|0;e=d+32|0;f=d+60|0;g=d+56|0;j=d+52|0;k=d+48|0;l=d+44|0;m=d+40|0;n=d+24|0;o=d+16|0;p=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[f>>2];h[o>>3]=0.0;c[l>>2]=0;a:while(1){if((c[l>>2]|0)>=(c[g>>2]|0)){q=23;break}c[k>>2]=(c[j>>2]|0)+72;c[m>>2]=(c[l>>2]|0)+1;while(1){r=c[j>>2]|0;if((c[m>>2]|0)>=(c[g>>2]|0))break;if(((+h[r+16>>3]<=+h[(c[k>>2]|0)+16+16>>3]?+h[(c[k>>2]|0)+16>>3]<=+h[(c[j>>2]|0)+16+16>>3]:0)?+h[(c[j>>2]|0)+16+8>>3]<=+h[(c[k>>2]|0)+16+16+8>>3]:0)?+h[(c[k>>2]|0)+16+8>>3]<=+h[(c[j>>2]|0)+16+16+8>>3]:0){q=9;break a}if(+h[c[j>>2]>>3]==+h[c[k>>2]>>3])h[p>>3]=s;else h[p>>3]=(+h[(c[j>>2]|0)+48>>3]+ +h[(c[k>>2]|0)+48>>3])/+N(+(+h[c[j>>2]>>3]-+h[c[k>>2]>>3]));if(+h[(c[j>>2]|0)+8>>3]==+h[(c[k>>2]|0)+8>>3])h[p+8>>3]=s;else h[p+8>>3]=(+h[(c[j>>2]|0)+56>>3]+ +h[(c[k>>2]|0)+56>>3])/+N(+(+h[(c[j>>2]|0)+8>>3]-+h[(c[k>>2]|0)+8>>3]));if(+h[p+8>>3]<+h[p>>3])h[n>>3]=+h[p+8>>3];else h[n>>3]=+h[p>>3];if(+h[n>>3]>+h[o>>3])h[o>>3]=+h[n>>3];c[k>>2]=(c[k>>2]|0)+72;c[m>>2]=(c[m>>2]|0)+1}c[j>>2]=r+72;c[l>>2]=(c[l>>2]|0)+1}if((q|0)==9){h[e>>3]=0.0;t=+h[e>>3];i=d;return +t}else if((q|0)==23){h[e>>3]=+h[o>>3];t=+h[e>>3];i=d;return +t}return +(0.0)}function er(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,t=0;e=i;i=i+64|0;f=e+52|0;g=e+48|0;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e+20|0;q=e+16|0;r=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[f>>2];c[m>>2]=c[g>>2];c[n>>2]=cK((c[m>>2]|0)+1<<4)|0;c[q>>2]=0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[g>>2]|0))break;c[l>>2]=(c[k>>2]|0)+72;c[p>>2]=(c[o>>2]|0)+1;while(1){t=c[k>>2]|0;if((c[p>>2]|0)>=(c[g>>2]|0))break;if(((+h[t+16>>3]<=+h[(c[l>>2]|0)+16+16>>3]?+h[(c[l>>2]|0)+16>>3]<=+h[(c[k>>2]|0)+16+16>>3]:0)?+h[(c[k>>2]|0)+16+8>>3]<=+h[(c[l>>2]|0)+16+16+8>>3]:0)?+h[(c[l>>2]|0)+16+8>>3]<=+h[(c[k>>2]|0)+16+16+8>>3]:0){if((c[q>>2]|0)==(c[m>>2]|0)){c[m>>2]=(c[m>>2]|0)+(c[g>>2]|0);c[n>>2]=eK(c[n>>2]|0,(c[m>>2]|0)+1<<4)|0}if(!(+h[c[k>>2]>>3]==+h[c[l>>2]>>3])){h[r>>3]=(+h[(c[k>>2]|0)+48>>3]+ +h[(c[l>>2]|0)+48>>3])/+N(+(+h[c[k>>2]>>3]-+h[c[l>>2]>>3]));if(+h[r>>3]<1.0)h[r>>3]=1.0}else h[r>>3]=s;if(!(+h[(c[k>>2]|0)+8>>3]==+h[(c[l>>2]|0)+8>>3])){h[r+8>>3]=(+h[(c[k>>2]|0)+56>>3]+ +h[(c[l>>2]|0)+56>>3])/+N(+(+h[(c[k>>2]|0)+8>>3]-+h[(c[l>>2]|0)+8>>3]));if(+h[r+8>>3]<1.0)h[r+8>>3]=1.0}else h[r+8>>3]=s;f=(c[q>>2]|0)+1|0;c[q>>2]=f;d=(c[n>>2]|0)+(f<<4)|0;c[d>>2]=c[r>>2];c[d+4>>2]=c[r+4>>2];c[d+8>>2]=c[r+8>>2];c[d+12>>2]=c[r+12>>2]}c[l>>2]=(c[l>>2]|0)+72;c[p>>2]=(c[p>>2]|0)+1}c[k>>2]=t+72;c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=eK(c[n>>2]|0,(c[q>>2]|0)+1<<4)|0;c[c[j>>2]>>2]=c[q>>2];i=e;return c[n>>2]|0}function fr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+32|0;j=d+24|0;k=d+16|0;l=d;c[e>>2]=a;c[f>>2]=b;h[j>>3]=0.0;c[e>>2]=(c[e>>2]|0)+16;c[g>>2]=1;while(1){if((c[g>>2]|0)>(c[f>>2]|0))break;b=c[e>>2]|0;c[e>>2]=b+16;c[l>>2]=c[b>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];h[k>>3]=+h[l>>3]<+h[l+8>>3]?+h[l>>3]:+h[l+8>>3];if(+h[k>>3]>+h[j>>3])h[j>>3]=+h[k>>3];c[g>>2]=(c[g>>2]|0)+1}i=d;return +(+h[j>>3])}function gr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;j=e+40|0;k=e+24|0;l=e+16|0;m=e+36|0;n=e+32|0;o=e;c[f>>2]=b;c[g>>2]=d;c[n>>2]=0;h[c[f>>2]>>3]=1.0;h[(c[f>>2]|0)+8>>3]=s;w3((c[f>>2]|0)+16|0,c[g>>2]|0,16,76);c[j>>2]=cK((c[g>>2]|0)+1<<4)|0;h[(c[j>>2]|0)+(c[g>>2]<<4)>>3]=+h[(c[f>>2]|0)+(c[g>>2]<<4)>>3];h[(c[j>>2]|0)+(c[g>>2]<<4)+8>>3]=1.0;c[m>>2]=(c[g>>2]|0)-1;while(1){if((c[m>>2]|0)<0)break;h[(c[j>>2]|0)+(c[m>>2]<<4)>>3]=+h[(c[f>>2]|0)+(c[m>>2]<<4)>>3];d=(c[m>>2]|0)+1|0;if(+h[(c[f>>2]|0)+((c[m>>2]|0)+1<<4)+8>>3]>+h[(c[j>>2]|0)+((c[m>>2]|0)+1<<4)+8>>3])p=+h[(c[f>>2]|0)+(d<<4)+8>>3];else p=+h[(c[j>>2]|0)+(d<<4)+8>>3];h[(c[j>>2]|0)+(c[m>>2]<<4)+8>>3]=p;c[m>>2]=(c[m>>2]|0)+-1}h[l>>3]=s;c[m>>2]=0;while(1){if((c[m>>2]|0)>(c[g>>2]|0))break;h[k>>3]=+h[(c[j>>2]|0)+(c[m>>2]<<4)>>3]*+h[(c[j>>2]|0)+(c[m>>2]<<4)+8>>3];if(+h[k>>3]<+h[l>>3]){h[l>>3]=+h[k>>3];c[n>>2]=c[m>>2]}c[m>>2]=(c[m>>2]|0)+1}if(+h[l>>3]<s){h[o>>3]=+h[(c[j>>2]|0)+(c[n>>2]<<4)>>3];h[o+8>>3]=+h[(c[j>>2]|0)+(c[n>>2]<<4)+8>>3];c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];i=e;return}else La(130954,130974,834,130987)}function hr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;do if(!(+h[c[f>>2]>>3]<+h[c[g>>2]>>3])){if(+h[c[f>>2]>>3]>+h[c[g>>2]>>3]){c[e>>2]=1;break}if(+h[(c[f>>2]|0)+8>>3]<+h[(c[g>>2]|0)+8>>3]){c[e>>2]=-1;break}if(+h[(c[f>>2]|0)+8>>3]>+h[(c[g>>2]|0)+8>>3]){c[e>>2]=1;break}else{c[e>>2]=0;break}}else c[e>>2]=-1;while(0);i=d;return c[e>>2]|0}function ir(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;i=d;return ((c[(c[e>>2]|0)+8+4>>2]|0)-(c[(c[e>>2]|0)+4>>2]|0)+((c[(c[f>>2]|0)+8+4>>2]|0)-(c[(c[f>>2]|0)+4>>2]|0))|0)/2|0|0}function jr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;i=d;return ((c[(c[e>>2]|0)+8>>2]|0)-(c[c[e>>2]>>2]|0)+((c[(c[f>>2]|0)+8>>2]|0)-(c[c[f>>2]>>2]|0))|0)/2|0|0}function kr(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+80|0;h=g+68|0;j=g+60|0;k=g+56|0;l=g+52|0;m=g+48|0;n=g+44|0;o=g+40|0;p=g+36|0;q=g+32|0;r=g+28|0;s=g+24|0;t=g+20|0;u=g+16|0;v=g+12|0;w=g+8|0;x=g+4|0;y=g;c[g+64>>2]=a;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[n>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;c[w>>2]=-2147483647;c[x>>2]=0;c[h>>2]=c[13066];c[y>>2]=gB(131002,h,0)|0;MC(c[y>>2]|0,175049,280,1)|0;c[v>>2]=0;c[m>>2]=Lz(c[j>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;if((c[w>>2]|0)!=(c[(c[m>>2]|0)+8>>2]|0)){c[w>>2]=c[(c[m>>2]|0)+8>>2];c[v>>2]=(c[v>>2]|0)+1}c[m>>2]=c[c[m>>2]>>2]}c[w>>2]=-2147483647;c[u>>2]=0;c[m>>2]=Lz(c[j>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;if((c[w>>2]|0)!=(c[(c[m>>2]|0)+8>>2]|0)){c[w>>2]=c[(c[m>>2]|0)+8>>2];f=c[y>>2]|0;c[s>>2]=fC(f,wB(c[(c[m>>2]|0)+20>>2]|0)|0,1)|0;MC(c[s>>2]|0,175026,304,1)|0;c[(c[(c[s>>2]|0)+8>>2]|0)+112>>2]=c[m>>2];f=c[s>>2]|0;if(c[r>>2]|0){c[(c[(c[x>>2]|0)+8>>2]|0)+164>>2]=f;c[x>>2]=c[s>>2]}else{c[r>>2]=f;f=c[s>>2]|0;c[(c[(c[y>>2]|0)+8>>2]|0)+192>>2]=f;c[x>>2]=f}c[(c[(c[s>>2]|0)+8>>2]|0)+172+4>>2]=0;f=bK((c[u>>2]|0)+1<<2)|0;c[(c[(c[s>>2]|0)+8>>2]|0)+172>>2]=f;if(c[q>>2]|0){f=(c[q>>2]|0)==(c[r>>2]|0);c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]=0;e=c[v>>2]|0;if(f){f=bK((e-1<<1)+1<<2)|0;c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]=f}else{f=bK(e-(c[u>>2]|0)-1+1<<2)|0;c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]=f}c[t>>2]=VA(c[y>>2]|0,c[q>>2]|0,c[s>>2]|0,0,1)|0;MC(c[t>>2]|0,175319,176,1)|0;b[(c[(c[t>>2]|0)+8>>2]|0)+170>>1]=10;c[(c[(c[t>>2]|0)+8>>2]|0)+156>>2]=1;f=(c[(c[q>>2]|0)+8>>2]|0)+180|0;if(c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]|0)z=eK(c[f>>2]|0,(c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]|0)+2<<2)|0;else z=cK((c[f+4>>2]|0)+2<<2)|0;c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]=z;f=c[t>>2]|0;e=(c[(c[q>>2]|0)+8>>2]|0)+180+4|0;d=c[e>>2]|0;c[e>>2]=d+1;c[(c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]|0)+(d<<2)>>2]=f;c[(c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]|0)+(c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]<<2)>>2]=0;f=(c[(c[s>>2]|0)+8>>2]|0)+172|0;if(c[(c[(c[s>>2]|0)+8>>2]|0)+172>>2]|0)A=eK(c[f>>2]|0,(c[(c[(c[s>>2]|0)+8>>2]|0)+172+4>>2]|0)+2<<2)|0;else A=cK((c[f+4>>2]|0)+2<<2)|0;c[(c[(c[s>>2]|0)+8>>2]|0)+172>>2]=A;f=c[t>>2]|0;d=(c[(c[s>>2]|0)+8>>2]|0)+172+4|0;e=c[d>>2]|0;c[d>>2]=e+1;c[(c[(c[(c[s>>2]|0)+8>>2]|0)+172>>2]|0)+(e<<2)>>2]=f;c[(c[(c[(c[s>>2]|0)+8>>2]|0)+172>>2]|0)+(c[(c[(c[s>>2]|0)+8>>2]|0)+172+4>>2]<<2)>>2]=0}c[u>>2]=(c[u>>2]|0)+1;c[q>>2]=c[s>>2]}c[(c[m>>2]|0)+24>>2]=c[s>>2];c[m>>2]=c[c[m>>2]>>2]}c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]=0;u=bK(4)|0;c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]=u;c[h>>2]=c[13066];c[p>>2]=gB(131036,h,0)|0;c[m>>2]=Lz(c[j>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;h=c[p>>2]|0;c[s>>2]=fC(h,wB(c[(c[m>>2]|0)+20>>2]|0)|0,1)|0;MC(c[s>>2]|0,175026,304,1)|0;c[(c[m>>2]|0)+28>>2]=c[s>>2];c[(c[(c[s>>2]|0)+8>>2]|0)+112>>2]=c[m>>2];c[m>>2]=c[c[m>>2]>>2]}c[w>>2]=-2147483647;c[m>>2]=Lz(c[j>>2]|0)|0;while(1){if(!(c[m>>2]|0)){B=42;break}if((c[w>>2]|0)!=(c[(c[m>>2]|0)+8>>2]|0)){c[w>>2]=c[(c[m>>2]|0)+8>>2];c[n>>2]=c[c[m>>2]>>2];while(1){if(!(c[n>>2]|0))break;if((c[(c[n>>2]|0)+8>>2]|0)!=(c[w>>2]|0))break;c[n>>2]=c[c[n>>2]>>2]}if(!(c[n>>2]|0)){B=42;break}}c[o>>2]=c[n>>2];while(1){if(!(c[o>>2]|0))break;if(Ob[c[k>>2]&127](c[m>>2]|0,c[o>>2]|0)|0)VA(c[p>>2]|0,c[(c[m>>2]|0)+28>>2]|0,c[(c[o>>2]|0)+28>>2]|0,0,1)|0;c[o>>2]=c[c[o>>2]>>2]}c[m>>2]=c[c[m>>2]>>2]}if((B|0)==42){nr(c[p>>2]|0,c[y>>2]|0,c[l>>2]|0);jB(c[p>>2]|0)|0;i=g;return c[y>>2]|0}return 0}function lr(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+64|0;j=g+48|0;k=g+44|0;l=g+40|0;m=g+36|0;n=g+32|0;o=g+28|0;p=g+24|0;q=g+20|0;r=g+16|0;s=g+12|0;t=g+8|0;u=g;c[k>>2]=a;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[s>>2]=0;c[j>>2]=c[13066];c[t>>2]=gB(131002,j,0)|0;MC(c[t>>2]|0,175049,280,1)|0;c[o>>2]=Lz(c[l>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;j=c[t>>2]|0;c[q>>2]=fC(j,wB(c[(c[o>>2]|0)+20>>2]|0)|0,1)|0;MC(c[q>>2]|0,175026,304,1)|0;c[(c[(c[q>>2]|0)+8>>2]|0)+112>>2]=c[o>>2];c[(c[o>>2]|0)+24>>2]=c[q>>2];c[(c[(c[q>>2]|0)+8>>2]|0)+172+4>>2]=0;j=bK(4)|0;c[(c[(c[q>>2]|0)+8>>2]|0)+172>>2]=j;c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]=0;j=bK(4)|0;c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]=j;j=c[q>>2]|0;if(c[s>>2]|0){c[(c[(c[s>>2]|0)+8>>2]|0)+164>>2]=j;c[s>>2]=c[q>>2]}else{c[(c[(c[t>>2]|0)+8>>2]|0)+192>>2]=j;c[s>>2]=j}c[o>>2]=c[c[o>>2]>>2]}c[o>>2]=Lz(c[l>>2]|0)|0;a:while(1){if(!(c[o>>2]|0))break;c[p>>2]=c[c[o>>2]>>2];while(1){if(!(c[p>>2]|0))break;c[r>>2]=0;if(Ob[c[m>>2]&127](c[o>>2]|0,c[p>>2]|0)|0){h[u>>3]=+(Ob[c[n>>2]&127]((c[o>>2]|0)+32|0,(c[p>>2]|0)+32|0)|0);c[r>>2]=VA(c[t>>2]|0,c[(c[o>>2]|0)+24>>2]|0,c[(c[p>>2]|0)+24>>2]|0,0,1)|0;MC(c[r>>2]|0,175319,176,1)|0;if(!(+h[u>>3]<=65535.0)){v=13;break a}b[(c[(c[r>>2]|0)+8>>2]|0)+170>>1]=~~+h[u>>3];c[(c[(c[r>>2]|0)+8>>2]|0)+156>>2]=1}if((c[r>>2]|0)!=0?(VA(c[k>>2]|0,c[(c[o>>2]|0)+20>>2]|0,c[(c[p>>2]|0)+20>>2]|0,0,0)|0)!=0:0)c[(c[(c[r>>2]|0)+8>>2]|0)+156>>2]=100;c[p>>2]=c[c[p>>2]>>2]}c[o>>2]=c[c[o>>2]>>2]}if((v|0)==13)La(131005,130974,256,131021);c[o>>2]=Lz(c[l>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;c[q>>2]=c[(c[o>>2]|0)+24>>2];c[r>>2]=OA(c[t>>2]|0,c[q>>2]|0)|0;while(1){if(!(c[r>>2]|0))break;l=(c[(c[q>>2]|0)+8>>2]|0)+180|0;if(c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]|0)w=eK(c[l>>2]|0,(c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]|0)+2<<2)|0;else w=cK((c[l+4>>2]|0)+2<<2)|0;c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]=w;l=c[r>>2]|0;v=(c[(c[q>>2]|0)+8>>2]|0)+180+4|0;p=c[v>>2]|0;c[v>>2]=p+1;c[(c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]|0)+(p<<2)>>2]=l;c[(c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]|0)+(c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]<<2)>>2]=0;l=c[r>>2]|0;p=(c[(c[((c[c[r>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+172|0;if(c[(c[(c[((c[c[r>>2]>>2]&3|0)==2?c[r>>2]|0:(c[r>>2]|0)+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0){l=c[r>>2]|0;x=eK(c[p>>2]|0,(c[(c[(c[((c[c[r>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]|0)+2<<2)|0}else x=cK((c[p+4>>2]|0)+2<<2)|0;p=c[r>>2]|0;c[(c[(c[((c[c[r>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]=x;p=c[r>>2]|0;l=c[r>>2]|0;v=(c[(c[((c[c[r>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+172+4|0;l=c[v>>2]|0;c[v>>2]=l+1;v=c[r>>2]|0;c[(c[(c[(c[((c[c[r>>2]>>2]&3|0)==2?v:v+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(l<<2)>>2]=p;p=c[r>>2]|0;l=c[r>>2]|0;c[(c[(c[(c[((c[c[r>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(c[(c[(c[((c[c[r>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]<<2)>>2]=0;c[r>>2]=QA(c[t>>2]|0,c[r>>2]|0)|0}c[o>>2]=c[c[o>>2]>>2]}i=g;return c[t>>2]|0}function mr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;if(c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]|0);if(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}jB(c[d>>2]|0)|0;i=b;return}function nr(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+12|0;q=g+8|0;r=g+4|0;s=g;c[h>>2]=a;c[j>>2]=d;c[k>>2]=f;c[l>>2]=$B(c[h>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;c[q>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2];c[o>>2]=c[(c[q>>2]|0)+24>>2];c[m>>2]=OA(c[h>>2]|0,c[l>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;f=c[m>>2]|0;c[r>>2]=c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+112>>2];c[s>>2]=Ob[c[k>>2]&127]((c[q>>2]|0)+32|0,(c[r>>2]|0)+32|0)|0;c[p>>2]=c[(c[r>>2]|0)+24>>2];c[n>>2]=VA(c[j>>2]|0,c[o>>2]|0,c[p>>2]|0,0,1)|0;MC(c[n>>2]|0,175319,176,1)|0;c[(c[(c[n>>2]|0)+8>>2]|0)+156>>2]=1;if((e[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]|0|0)<(c[s>>2]|0)){if(+(e[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]|0|0)==0.0){f=(c[(c[o>>2]|0)+8>>2]|0)+180|0;if(c[(c[(c[o>>2]|0)+8>>2]|0)+180>>2]|0)t=eK(c[f>>2]|0,(c[(c[(c[o>>2]|0)+8>>2]|0)+180+4>>2]|0)+2<<2)|0;else t=cK((c[f+4>>2]|0)+2<<2)|0;c[(c[(c[o>>2]|0)+8>>2]|0)+180>>2]=t;f=c[n>>2]|0;d=(c[(c[o>>2]|0)+8>>2]|0)+180+4|0;a=c[d>>2]|0;c[d>>2]=a+1;c[(c[(c[(c[o>>2]|0)+8>>2]|0)+180>>2]|0)+(a<<2)>>2]=f;c[(c[(c[(c[o>>2]|0)+8>>2]|0)+180>>2]|0)+(c[(c[(c[o>>2]|0)+8>>2]|0)+180+4>>2]<<2)>>2]=0;f=(c[(c[p>>2]|0)+8>>2]|0)+172|0;if(c[(c[(c[p>>2]|0)+8>>2]|0)+172>>2]|0)u=eK(c[f>>2]|0,(c[(c[(c[p>>2]|0)+8>>2]|0)+172+4>>2]|0)+2<<2)|0;else u=cK((c[f+4>>2]|0)+2<<2)|0;c[(c[(c[p>>2]|0)+8>>2]|0)+172>>2]=u;f=c[n>>2]|0;a=(c[(c[p>>2]|0)+8>>2]|0)+172+4|0;d=c[a>>2]|0;c[a>>2]=d+1;c[(c[(c[(c[p>>2]|0)+8>>2]|0)+172>>2]|0)+(d<<2)>>2]=f;c[(c[(c[(c[p>>2]|0)+8>>2]|0)+172>>2]|0)+(c[(c[(c[p>>2]|0)+8>>2]|0)+172+4>>2]<<2)>>2]=0}b[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]=c[s>>2]}c[m>>2]=QA(c[h>>2]|0,c[m>>2]|0)|0}c[l>>2]=aC(c[h>>2]|0,c[l>>2]|0)|0}i=g;return}function or(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;c[f+12>>2]=a;c[g>>2]=b;c[h>>2]=d;c[f>>2]=e;i=f;return (c[c[g>>2]>>2]|0)-(c[c[h>>2]>>2]|0)|0}function pr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[e+12>>2]=a;c[e+8>>2]=b;c[e+4>>2]=d;c[f>>2]=c[12866];$z(1,131039,f)|0;i=e;return 0}function qr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+32|0;g=f;c[f+16>>2]=a;c[f+12>>2]=b;c[f+8>>2]=d;c[f+4>>2]=e;c[g>>2]=c[12866];$z(1,131067,g)|0;i=f;return 0}function rr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=i;i=i+112|0;g=f+108|0;j=f+104|0;k=f+100|0;l=f+96|0;m=f+92|0;n=f+88|0;o=f+84|0;p=f+48|0;q=f+40|0;r=f+32|0;s=f+24|0;t=f+16|0;u=f+8|0;v=f;w=f+80|0;x=f+76|0;y=f+72|0;z=f+68|0;A=f+64|0;B=f+60|0;C=f+56|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;if((c[l>>2]|0)==2){c[B>>2]=cK(16)|0;c[n>>2]=cK((c[l>>2]|0)*12|0)|0;c[(c[n>>2]|0)+8>>2]=0;c[(c[n>>2]|0)+4>>2]=c[B>>2];c[c[n>>2]>>2]=2;c[c[(c[n>>2]|0)+4>>2]>>2]=0;c[(c[(c[n>>2]|0)+4>>2]|0)+4>>2]=1;c[(c[n>>2]|0)+12+4>>2]=(c[B>>2]|0)+8;c[(c[n>>2]|0)+12+8>>2]=0;c[(c[n>>2]|0)+12>>2]=2;c[c[(c[n>>2]|0)+12+4>>2]>>2]=1;c[(c[(c[n>>2]|0)+12+4>>2]|0)+4>>2]=0;c[g>>2]=c[n>>2];D=c[g>>2]|0;i=f;return D|0}if((c[l>>2]|0)==1){c[C>>2]=cK(4)|0;c[n>>2]=cK((c[l>>2]|0)*12|0)|0;c[(c[n>>2]|0)+8>>2]=0;c[(c[n>>2]|0)+4>>2]=c[C>>2];c[c[n>>2]>>2]=1;c[c[(c[n>>2]|0)+4>>2]>>2]=0;c[g>>2]=c[n>>2];D=c[g>>2]|0;i=f;return D|0}c[n>>2]=pr(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;C=(c[m>>2]|0)!=0;c[o>>2]=0;a:do if(C)while(1){if((c[o>>2]|0)>=(c[l>>2]|0))break a;h[s>>3]=+h[(c[j>>2]|0)+(c[o>>2]<<3)>>3];h[t>>3]=+h[(c[k>>2]|0)+(c[o>>2]<<3)>>3];c[w>>2]=1;while(1){if((c[w>>2]|0)>=(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)>>2]|0))break;c[y>>2]=c[(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)+4>>2]|0)+(c[w>>2]<<2)>>2];if((c[y>>2]|0)<(c[o>>2]|0)){c[w>>2]=(c[w>>2]|0)+1;continue}h[u>>3]=+h[(c[j>>2]|0)+(c[y>>2]<<3)>>3];h[v>>3]=+h[(c[k>>2]|0)+(c[y>>2]<<3)>>3];h[p>>3]=(+h[u>>3]-+h[s>>3])*(+h[u>>3]-+h[s>>3])+(+h[v>>3]-+h[t>>3])*(+h[v>>3]-+h[t>>3]);c[A>>2]=0;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break;if(!((c[A>>2]|0)!=0^1))break;h[q>>3]=(+h[(c[j>>2]|0)+(c[x>>2]<<3)>>3]-+h[s>>3])*(+h[(c[j>>2]|0)+(c[x>>2]<<3)>>3]-+h[s>>3])+(+h[(c[k>>2]|0)+(c[x>>2]<<3)>>3]-+h[t>>3])*(+h[(c[k>>2]|0)+(c[x>>2]<<3)>>3]-+h[t>>3]);if(+h[q>>3]<+h[p>>3]?(h[r>>3]=(+h[(c[j>>2]|0)+(c[x>>2]<<3)>>3]-+h[u>>3])*(+h[(c[j>>2]|0)+(c[x>>2]<<3)>>3]-+h[u>>3])+(+h[(c[k>>2]|0)+(c[x>>2]<<3)>>3]-+h[v>>3])*(+h[(c[k>>2]|0)+(c[x>>2]<<3)>>3]-+h[v>>3]),+h[r>>3]<+h[p>>3]):0){m=(c[n>>2]|0)+((c[o>>2]|0)*12|0)|0;B=(c[m>>2]|0)+-1|0;c[m>>2]=B;c[(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)+4>>2]|0)+(c[w>>2]<<2)>>2]=c[(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)+4>>2]|0)+(B<<2)>>2];ur(c[n>>2]|0,c[y>>2]|0,c[o>>2]|0);c[A>>2]=1}c[x>>2]=(c[x>>2]|0)+1}if(c[A>>2]|0)continue;c[w>>2]=(c[w>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}else while(1){if((c[o>>2]|0)>=(c[l>>2]|0))break a;h[s>>3]=+h[(c[j>>2]|0)+(c[o>>2]<<3)>>3];h[t>>3]=+h[(c[k>>2]|0)+(c[o>>2]<<3)>>3];c[w>>2]=1;while(1){if((c[w>>2]|0)>=(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)>>2]|0))break;c[y>>2]=c[(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)+4>>2]|0)+(c[w>>2]<<2)>>2];h[u>>3]=+h[(c[j>>2]|0)+(c[y>>2]<<3)>>3];h[v>>3]=+h[(c[k>>2]|0)+(c[y>>2]<<3)>>3];h[p>>3]=(+h[u>>3]-+h[s>>3])*(+h[u>>3]-+h[s>>3])+(+h[v>>3]-+h[t>>3])*(+h[v>>3]-+h[t>>3]);c[A>>2]=0;c[x>>2]=1;while(1){if((c[x>>2]|0)>=(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)>>2]|0))break;if(!((c[A>>2]|0)!=0^1))break;c[z>>2]=c[(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)+4>>2]|0)+(c[x>>2]<<2)>>2];h[q>>3]=(+h[(c[j>>2]|0)+(c[z>>2]<<3)>>3]-+h[s>>3])*(+h[(c[j>>2]|0)+(c[z>>2]<<3)>>3]-+h[s>>3])+(+h[(c[k>>2]|0)+(c[z>>2]<<3)>>3]-+h[t>>3])*(+h[(c[k>>2]|0)+(c[z>>2]<<3)>>3]-+h[t>>3]);if(+h[q>>3]<+h[p>>3]?(h[r>>3]=(+h[(c[j>>2]|0)+(c[z>>2]<<3)>>3]-+h[u>>3])*(+h[(c[j>>2]|0)+(c[z>>2]<<3)>>3]-+h[u>>3])+(+h[(c[k>>2]|0)+(c[z>>2]<<3)>>3]-+h[v>>3])*(+h[(c[k>>2]|0)+(c[z>>2]<<3)>>3]-+h[v>>3]),+h[r>>3]<+h[p>>3]):0){B=(c[n>>2]|0)+((c[o>>2]|0)*12|0)|0;m=(c[B>>2]|0)+-1|0;c[B>>2]=m;c[(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)+4>>2]|0)+(c[w>>2]<<2)>>2]=c[(c[(c[n>>2]|0)+((c[o>>2]|0)*12|0)+4>>2]|0)+(m<<2)>>2];ur(c[n>>2]|0,c[y>>2]|0,c[o>>2]|0);c[A>>2]=1}c[x>>2]=(c[x>>2]|0)+1}if(c[A>>2]|0)continue;c[w>>2]=(c[w>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}while(0);c[g>>2]=c[n>>2];D=c[g>>2]|0;i=f;return D|0}function sr(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)O4(c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[d>>2]|0);i=b;return}function tr(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)O4(c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)O4(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+16>>2]|0)O4(c[(c[d>>2]|0)+16>>2]|0);O4(c[d>>2]|0);i=b;return}function ur(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=1;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+((c[g>>2]|0)*12|0)>>2]|0)){k=6;break}if((c[(c[(c[f>>2]|0)+((c[g>>2]|0)*12|0)+4>>2]|0)+(c[j>>2]<<2)>>2]|0)==(c[h>>2]|0))break;c[j>>2]=(c[j>>2]|0)+1}if((k|0)==6){i=e;return}k=(c[f>>2]|0)+((c[g>>2]|0)*12|0)|0;h=(c[k>>2]|0)+-1|0;c[k>>2]=h;c[(c[(c[f>>2]|0)+((c[g>>2]|0)*12|0)+4>>2]|0)+(c[j>>2]<<2)>>2]=c[(c[(c[f>>2]|0)+((c[g>>2]|0)*12|0)+4>>2]|0)+(h<<2)>>2];i=e;return}function vr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[r>>2]=2147483647;c[12867]=Q4(c[12867]|0,c[k>>2]<<2)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[k>>2]|0))break;c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=2147483647;c[m>>2]=(c[m>>2]|0)+1}c[(c[l>>2]|0)+(c[h>>2]<<2)>>2]=0;c[m>>2]=1;while(1){if((c[m>>2]|0)>=(c[(c[j>>2]|0)+((c[h>>2]|0)*20|0)>>2]|0))break;c[(c[l>>2]|0)+(c[(c[(c[j>>2]|0)+((c[h>>2]|0)*20|0)+4>>2]|0)+(c[m>>2]<<2)>>2]<<2)>>2]=~~+g[(c[(c[j>>2]|0)+((c[h>>2]|0)*20|0)+8>>2]|0)+(c[m>>2]<<2)>>2];c[m>>2]=(c[m>>2]|0)+1}yr(n,c[h>>2]|0,c[12867]|0,c[l>>2]|0,c[k>>2]|0);while(1){if(!((zr(n,o,c[12867]|0,c[l>>2]|0)|0)<<24>>24))break;c[q>>2]=c[(c[l>>2]|0)+(c[o>>2]<<2)>>2];if(+(c[q>>2]|0)==2147483647.0)break;c[m>>2]=1;while(1){if((c[m>>2]|0)>=(c[(c[j>>2]|0)+((c[o>>2]|0)*20|0)>>2]|0))break;c[p>>2]=c[(c[(c[j>>2]|0)+((c[o>>2]|0)*20|0)+4>>2]|0)+(c[m>>2]<<2)>>2];Ar(n,c[p>>2]|0,(c[q>>2]|0)+~~+g[(c[(c[j>>2]|0)+((c[o>>2]|0)*20|0)+8>>2]|0)+(c[m>>2]<<2)>>2]|0,c[12867]|0,c[l>>2]|0);c[m>>2]=(c[m>>2]|0)+1}c[r>>2]=c[q>>2]}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[k>>2]|0))break;if(+(c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]|0)==2147483647.0)c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=(c[r>>2]|0)+10;c[m>>2]=(c[m>>2]|0)+1}Br(n);i=f;return}function wr(b,d,e,f,h,j){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=i;i=i+80|0;l=k+68|0;m=k+64|0;n=k+60|0;o=k+56|0;p=k+52|0;q=k+48|0;r=k+44|0;s=k+40|0;t=k+24|0;u=k+16|0;v=k+12|0;w=k+8|0;x=k+4|0;y=k;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=h;c[q>>2]=j;c[y>>2]=0;Nq(t,c[n>>2]|0);c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;c[(c[o>>2]|0)+(c[s>>2]<<2)>>2]=-1;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=Mq(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,t,c[p>>2]|0,c[q>>2]|0)|0;if((c[12868]|0)<(c[n>>2]|0)){c[12869]=Q4(c[12869]|0,c[n>>2]|0)|0;c[s>>2]=c[12868];while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;a[(c[12869]|0)+(c[s>>2]|0)>>0]=0;c[s>>2]=(c[s>>2]|0)+1}c[12868]=c[n>>2]}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[r>>2]|0))break;a[(c[12869]|0)+(c[(c[q>>2]|0)+(c[s>>2]<<2)>>2]|0)>>0]=1;c[s>>2]=(c[s>>2]|0)+1}c[12870]=Q4(c[12870]|0,c[n>>2]<<2)|0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;c[(c[o>>2]|0)+(c[s>>2]<<2)>>2]=2147483647;c[s>>2]=(c[s>>2]|0)+1}c[(c[o>>2]|0)+(c[l>>2]<<2)>>2]=0;c[s>>2]=1;while(1){if((c[s>>2]|0)>=(c[(c[m>>2]|0)+((c[l>>2]|0)*20|0)>>2]|0))break;c[(c[o>>2]|0)+(c[(c[(c[m>>2]|0)+((c[l>>2]|0)*20|0)+4>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]=~~+g[(c[(c[m>>2]|0)+((c[l>>2]|0)*20|0)+8>>2]|0)+(c[s>>2]<<2)>>2];c[s>>2]=(c[s>>2]|0)+1}yr(u,c[l>>2]|0,c[12870]|0,c[o>>2]|0,c[n>>2]|0);a:while(1){if((c[y>>2]|0)>=(c[r>>2]|0))break;if(!((zr(u,v,c[12870]|0,c[o>>2]|0)|0)&255))break;if(a[(c[12869]|0)+(c[v>>2]|0)>>0]|0)c[y>>2]=(c[y>>2]|0)+1;c[x>>2]=c[(c[o>>2]|0)+(c[v>>2]<<2)>>2];if(+(c[x>>2]|0)==2147483647.0)break;c[s>>2]=1;while(1){if((c[s>>2]|0)>=(c[(c[m>>2]|0)+((c[v>>2]|0)*20|0)>>2]|0))continue a;c[w>>2]=c[(c[(c[m>>2]|0)+((c[v>>2]|0)*20|0)+4>>2]|0)+(c[s>>2]<<2)>>2];Ar(u,c[w>>2]|0,(c[x>>2]|0)+~~+g[(c[(c[m>>2]|0)+((c[v>>2]|0)*20|0)+8>>2]|0)+(c[s>>2]<<2)>>2]|0,c[12870]|0,c[o>>2]|0);c[s>>2]=(c[s>>2]|0)+1}}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[r>>2]|0))break;a[(c[12869]|0)+(c[(c[q>>2]|0)+(c[s>>2]<<2)>>2]|0)>>0]=0;c[s>>2]=(c[s>>2]|0)+1}Br(u);Oq(t);i=k;return c[r>>2]|0}function xr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[o>>2]=0;c[r>>2]=cK(c[k>>2]<<2)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[k>>2]|0))break;g[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=3402823466385288598117041.0e14;c[m>>2]=(c[m>>2]|0)+1}g[(c[l>>2]|0)+(c[h>>2]<<2)>>2]=0.0;c[m>>2]=1;while(1){if((c[m>>2]|0)>=(c[(c[j>>2]|0)+((c[h>>2]|0)*20|0)>>2]|0))break;g[(c[l>>2]|0)+(c[(c[(c[j>>2]|0)+((c[h>>2]|0)*20|0)+4>>2]|0)+(c[m>>2]<<2)>>2]<<2)>>2]=+g[(c[(c[j>>2]|0)+((c[h>>2]|0)*20|0)+8>>2]|0)+(c[m>>2]<<2)>>2];c[m>>2]=(c[m>>2]|0)+1}Cr(n,c[h>>2]|0,c[r>>2]|0,c[l>>2]|0,c[k>>2]|0);a:while(1){if(!((Dr(n,o,c[r>>2]|0,c[l>>2]|0)|0)<<24>>24)){s=13;break}g[q>>2]=+g[(c[l>>2]|0)+(c[o>>2]<<2)>>2];if(+g[q>>2]==3402823466385288598117041.0e14){s=13;break}c[m>>2]=1;while(1){if((c[m>>2]|0)>=(c[(c[j>>2]|0)+((c[o>>2]|0)*20|0)>>2]|0))continue a;c[p>>2]=c[(c[(c[j>>2]|0)+((c[o>>2]|0)*20|0)+4>>2]|0)+(c[m>>2]<<2)>>2];Er(n,c[p>>2]|0,+g[q>>2]+ +g[(c[(c[j>>2]|0)+((c[o>>2]|0)*20|0)+8>>2]|0)+(c[m>>2]<<2)>>2],c[r>>2]|0,c[l>>2]|0);c[m>>2]=(c[m>>2]|0)+1}}if((s|0)==13){Br(n);O4(c[r>>2]|0);i=f;return}}function yr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if((c[m>>2]|0)==1)c[c[h>>2]>>2]=0;else{f=cK((c[m>>2]|0)-1<<2)|0;c[c[h>>2]>>2]=f}c[(c[h>>2]|0)+4>>2]=(c[m>>2]|0)-1;c[o>>2]=0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[m>>2]|0))break;if((c[n>>2]|0)!=(c[j>>2]|0)){c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2]=c[n>>2];c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]=c[o>>2];c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+1}c[p>>2]=((c[m>>2]|0)-1|0)/2|0;while(1){if((c[p>>2]|0)<0)break;Gr(c[h>>2]|0,c[p>>2]|0,c[k>>2]|0,c[l>>2]|0);c[p>>2]=(c[p>>2]|0)+-1}i=g;return}function zr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!(c[(c[j>>2]|0)+4>>2]|0)){a[h>>0]=0;n=a[h>>0]|0;i=g;return n|0}else{c[c[k>>2]>>2]=c[c[c[j>>2]>>2]>>2];c[c[c[j>>2]>>2]>>2]=c[(c[c[j>>2]>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)-1<<2)>>2];c[(c[l>>2]|0)+(c[c[c[j>>2]>>2]>>2]<<2)>>2]=0;k=(c[j>>2]|0)+4|0;c[k>>2]=(c[k>>2]|0)+-1;Gr(c[j>>2]|0,0,c[l>>2]|0,c[m>>2]|0);a[h>>0]=1;n=a[h>>0]|0;i=g;return n|0}return 0}function Ar(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if((c[(c[m>>2]|0)+(c[j>>2]<<2)>>2]|0)<=(c[k>>2]|0)){i=g;return}c[n>>2]=c[(c[l>>2]|0)+(c[j>>2]<<2)>>2];c[(c[m>>2]|0)+(c[j>>2]<<2)>>2]=c[k>>2];c[o>>2]=c[n>>2];while(1){if((c[o>>2]|0)<=0)break;if((c[(c[m>>2]|0)+(c[(c[c[h>>2]>>2]|0)+(((c[o>>2]|0)/2|0)<<2)>>2]<<2)>>2]|0)<=(c[k>>2]|0))break;c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2]=c[(c[c[h>>2]>>2]|0)+(((c[o>>2]|0)/2|0)<<2)>>2];c[(c[l>>2]|0)+(c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]=c[o>>2];c[o>>2]=(c[o>>2]|0)/2|0}c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2]=c[j>>2];c[(c[l>>2]|0)+(c[j>>2]<<2)>>2]=c[o>>2];i=g;return}function Br(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[c[d>>2]>>2]|0)){i=b;return}O4(c[c[d>>2]>>2]|0);i=b;return}function Cr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;f=cK((c[m>>2]|0)-1<<2)|0;c[c[h>>2]>>2]=f;c[(c[h>>2]|0)+4>>2]=(c[m>>2]|0)-1;c[o>>2]=0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[m>>2]|0))break;if((c[n>>2]|0)!=(c[j>>2]|0)){c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2]=c[n>>2];c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]=c[o>>2];c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+1}c[p>>2]=((c[m>>2]|0)-1|0)/2|0;while(1){if((c[p>>2]|0)<0)break;Fr(c[h>>2]|0,c[p>>2]|0,c[k>>2]|0,c[l>>2]|0);c[p>>2]=(c[p>>2]|0)+-1}i=g;return}function Dr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!(c[(c[j>>2]|0)+4>>2]|0)){a[h>>0]=0;n=a[h>>0]|0;i=g;return n|0}else{c[c[k>>2]>>2]=c[c[c[j>>2]>>2]>>2];c[c[c[j>>2]>>2]>>2]=c[(c[c[j>>2]>>2]|0)+((c[(c[j>>2]|0)+4>>2]|0)-1<<2)>>2];c[(c[l>>2]|0)+(c[c[c[j>>2]>>2]>>2]<<2)>>2]=0;k=(c[j>>2]|0)+4|0;c[k>>2]=(c[k>>2]|0)+-1;Fr(c[j>>2]|0,0,c[l>>2]|0,c[m>>2]|0);a[h>>0]=1;n=a[h>>0]|0;i=g;return n|0}return 0}function Er(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;g[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(+g[(c[n>>2]|0)+(c[k>>2]<<2)>>2]<=+g[l>>2]){i=h;return}c[o>>2]=c[(c[m>>2]|0)+(c[k>>2]<<2)>>2];g[(c[n>>2]|0)+(c[k>>2]<<2)>>2]=+g[l>>2];c[p>>2]=c[o>>2];while(1){if((c[p>>2]|0)<=0)break;if(!(+g[(c[n>>2]|0)+(c[(c[c[j>>2]>>2]|0)+(((c[p>>2]|0)/2|0)<<2)>>2]<<2)>>2]>+g[l>>2]))break;c[(c[c[j>>2]>>2]|0)+(c[p>>2]<<2)>>2]=c[(c[c[j>>2]>>2]|0)+(((c[p>>2]|0)/2|0)<<2)>>2];c[(c[m>>2]|0)+(c[(c[c[j>>2]>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2]=c[p>>2];c[p>>2]=(c[p>>2]|0)/2|0}c[(c[c[j>>2]>>2]|0)+(c[p>>2]<<2)>>2]=c[k>>2];c[(c[m>>2]|0)+(c[k>>2]<<2)>>2]=c[p>>2];i=h;return}function Fr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;while(1){c[m>>2]=c[j>>2]<<1;c[n>>2]=(c[j>>2]<<1)+1;if((c[m>>2]|0)<(c[(c[h>>2]|0)+4>>2]|0)?+g[(c[l>>2]|0)+(c[(c[c[h>>2]>>2]|0)+(c[m>>2]<<2)>>2]<<2)>>2]<+g[(c[l>>2]|0)+(c[(c[c[h>>2]>>2]|0)+(c[j>>2]<<2)>>2]<<2)>>2]:0)c[o>>2]=c[m>>2];else c[o>>2]=c[j>>2];if((c[n>>2]|0)<(c[(c[h>>2]|0)+4>>2]|0)?+g[(c[l>>2]|0)+(c[(c[c[h>>2]>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]<+g[(c[l>>2]|0)+(c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]:0)c[o>>2]=c[n>>2];if((c[o>>2]|0)==(c[j>>2]|0))break;c[p>>2]=c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2];c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2]=c[(c[c[h>>2]>>2]|0)+(c[j>>2]<<2)>>2];c[(c[c[h>>2]>>2]|0)+(c[j>>2]<<2)>>2]=c[p>>2];c[(c[k>>2]|0)+(c[(c[c[h>>2]>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]=c[o>>2];c[(c[k>>2]|0)+(c[(c[c[h>>2]>>2]|0)+(c[j>>2]<<2)>>2]<<2)>>2]=c[j>>2];c[j>>2]=c[o>>2]}i=f;return}function Gr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;while(1){c[l>>2]=c[h>>2]<<1;c[m>>2]=(c[h>>2]<<1)+1;if((c[l>>2]|0)<(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[k>>2]|0)+(c[(c[c[g>>2]>>2]|0)+(c[l>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[k>>2]|0)+(c[(c[c[g>>2]>>2]|0)+(c[h>>2]<<2)>>2]<<2)>>2]|0):0)c[n>>2]=c[l>>2];else c[n>>2]=c[h>>2];if((c[m>>2]|0)<(c[(c[g>>2]|0)+4>>2]|0)?(c[(c[k>>2]|0)+(c[(c[c[g>>2]>>2]|0)+(c[m>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[k>>2]|0)+(c[(c[c[g>>2]>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]|0):0)c[n>>2]=c[m>>2];if((c[n>>2]|0)==(c[h>>2]|0))break;c[o>>2]=c[(c[c[g>>2]>>2]|0)+(c[n>>2]<<2)>>2];c[(c[c[g>>2]>>2]|0)+(c[n>>2]<<2)>>2]=c[(c[c[g>>2]>>2]|0)+(c[h>>2]<<2)>>2];c[(c[c[g>>2]>>2]|0)+(c[h>>2]<<2)>>2]=c[o>>2];c[(c[j>>2]|0)+(c[(c[c[g>>2]>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]=c[n>>2];c[(c[j>>2]|0)+(c[(c[c[g>>2]>>2]|0)+(c[h>>2]<<2)>>2]<<2)>>2]=c[h>>2];c[h>>2]=c[n>>2]}i=f;return}function Hr(){At(51484,48);c[12874]=0;return}function Ir(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+24|0;j=d+16|0;k=d+8|0;l=d;m=d+32|0;c[e>>2]=a;c[f>>2]=b;c[m>>2]=Bt(51484)|0;c[(c[m>>2]|0)+32>>2]=c[e>>2];c[(c[m>>2]|0)+32+4>>2]=c[f>>2];iu(c[e>>2]|0);iu(c[f>>2]|0);c[(c[m>>2]|0)+24>>2]=0;c[(c[m>>2]|0)+24+4>>2]=0;h[g>>3]=+h[c[f>>2]>>3]-+h[c[e>>2]>>3];h[j>>3]=+h[(c[f>>2]|0)+8>>3]-+h[(c[e>>2]|0)+8>>3];n=+h[g>>3];h[k>>3]=+h[g>>3]>0.0?n:-n;n=+h[j>>3];h[l>>3]=+h[j>>3]>0.0?n:-n;h[(c[m>>2]|0)+16>>3]=+h[c[e>>2]>>3]*+h[g>>3]+ +h[(c[e>>2]|0)+8>>3]*+h[j>>3]+(+h[g>>3]*+h[g>>3]+ +h[j>>3]*+h[j>>3])*.5;e=c[m>>2]|0;if(+h[k>>3]>+h[l>>3]){h[e>>3]=1.0;h[(c[m>>2]|0)+8>>3]=+h[j>>3]/+h[g>>3];l=(c[m>>2]|0)+16|0;h[l>>3]=+h[l>>3]/+h[g>>3];o=c[12874]|0;p=c[m>>2]|0;q=p+40|0;c[q>>2]=o;r=c[12874]|0;s=r+1|0;c[12874]=s;t=c[m>>2]|0;i=d;return t|0}else{h[e+8>>3]=1.0;h[c[m>>2]>>3]=+h[g>>3]/+h[j>>3];g=(c[m>>2]|0)+16|0;h[g>>3]=+h[g>>3]/+h[j>>3];o=c[12874]|0;p=c[m>>2]|0;q=p+40|0;c[q>>2]=o;r=c[12874]|0;s=r+1|0;c[12874]=s;t=c[m>>2]|0;i=d;return t|0}return 0}function Jr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0;b=i;i=i+48|0;d=b+40|0;e=b+36|0;f=b+32|0;g=b+24|0;j=b+16|0;k=b+8|0;l=b;c[d>>2]=a;if(+h[c[d>>2]>>3]==1.0?+h[(c[d>>2]|0)+8>>3]>=0.0:0){c[e>>2]=c[(c[d>>2]|0)+24+4>>2];c[f>>2]=c[(c[d>>2]|0)+24>>2]}else{c[e>>2]=c[(c[d>>2]|0)+24>>2];c[f>>2]=c[(c[d>>2]|0)+24+4>>2]}a=(c[e>>2]|0)!=0;if(+h[c[d>>2]>>3]==1.0){do if(a){h[k>>3]=+h[(c[e>>2]|0)+8>>3];if(+h[k>>3]>+h[4198]){i=b;return}if(+h[k>>3]>=+h[4199]){h[g>>3]=+h[c[e>>2]>>3];break}else{h[k>>3]=+h[4199];h[g>>3]=+h[(c[d>>2]|0)+16>>3]-+h[(c[d>>2]|0)+8>>3]*+h[k>>3];break}}else{h[k>>3]=+h[4199];h[g>>3]=+h[(c[d>>2]|0)+16>>3]-+h[(c[d>>2]|0)+8>>3]*+h[k>>3]}while(0);do if(c[f>>2]|0){h[l>>3]=+h[(c[f>>2]|0)+8>>3];if(+h[l>>3]<+h[4199]){i=b;return}if(+h[l>>3]<=+h[4198]){h[j>>3]=+h[c[f>>2]>>3];break}else{h[l>>3]=+h[4198];h[j>>3]=+h[(c[d>>2]|0)+16>>3]-+h[(c[d>>2]|0)+8>>3]*+h[l>>3];break}}else{h[l>>3]=+h[4198];h[j>>3]=+h[(c[d>>2]|0)+16>>3]-+h[(c[d>>2]|0)+8>>3]*+h[l>>3]}while(0);if((+h[g>>3]>+h[4200]?+h[j>>3]>+h[4200]:0)|(+h[g>>3]<+h[4201]?+h[j>>3]<+h[4201]:0)){i=b;return}if(+h[g>>3]>+h[4200]){h[g>>3]=+h[4200];h[k>>3]=(+h[(c[d>>2]|0)+16>>3]-+h[g>>3])/+h[(c[d>>2]|0)+8>>3]}if(+h[g>>3]<+h[4201]){h[g>>3]=+h[4201];h[k>>3]=(+h[(c[d>>2]|0)+16>>3]-+h[g>>3])/+h[(c[d>>2]|0)+8>>3]}if(+h[j>>3]>+h[4200]){h[j>>3]=+h[4200];h[l>>3]=(+h[(c[d>>2]|0)+16>>3]-+h[j>>3])/+h[(c[d>>2]|0)+8>>3]}if(+h[j>>3]<+h[4201]){h[j>>3]=+h[4201];h[l>>3]=(+h[(c[d>>2]|0)+16>>3]-+h[j>>3])/+h[(c[d>>2]|0)+8>>3]}}else{do if(a){h[g>>3]=+h[c[e>>2]>>3];if(+h[g>>3]>+h[4200]){i=b;return}if(+h[g>>3]>=+h[4201]){h[k>>3]=+h[(c[e>>2]|0)+8>>3];break}else{h[g>>3]=+h[4201];h[k>>3]=+h[(c[d>>2]|0)+16>>3]-+h[c[d>>2]>>3]*+h[g>>3];break}}else{h[g>>3]=+h[4201];h[k>>3]=+h[(c[d>>2]|0)+16>>3]-+h[c[d>>2]>>3]*+h[g>>3]}while(0);do if(c[f>>2]|0){h[j>>3]=+h[c[f>>2]>>3];if(+h[j>>3]<+h[4201]){i=b;return}if(+h[j>>3]<=+h[4200]){h[l>>3]=+h[(c[f>>2]|0)+8>>3];break}else{h[j>>3]=+h[4200];h[l>>3]=+h[(c[d>>2]|0)+16>>3]-+h[c[d>>2]>>3]*+h[j>>3];break}}else{h[j>>3]=+h[4200];h[l>>3]=+h[(c[d>>2]|0)+16>>3]-+h[c[d>>2]>>3]*+h[j>>3]}while(0);if((+h[k>>3]>+h[4198]?+h[l>>3]>+h[4198]:0)|(+h[k>>3]<+h[4199]?+h[l>>3]<+h[4199]:0)){i=b;return}if(+h[k>>3]>+h[4198]){h[k>>3]=+h[4198];h[g>>3]=(+h[(c[d>>2]|0)+16>>3]-+h[k>>3])/+h[c[d>>2]>>3]}if(+h[k>>3]<+h[4199]){h[k>>3]=+h[4199];h[g>>3]=(+h[(c[d>>2]|0)+16>>3]-+h[k>>3])/+h[c[d>>2]>>3]}if(+h[l>>3]>+h[4198]){h[l>>3]=+h[4198];h[j>>3]=(+h[(c[d>>2]|0)+16>>3]-+h[l>>3])/+h[c[d>>2]>>3]}if(+h[l>>3]<+h[4199]){h[l>>3]=+h[4199];h[j>>3]=(+h[(c[d>>2]|0)+16>>3]-+h[l>>3])/+h[c[d>>2]>>3]}}Lr(c[d>>2]|0,+h[g>>3],+h[k>>3],+h[j>>3],+h[l>>3]);i=b;return}function Kr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[(c[f>>2]|0)+24+(c[g>>2]<<2)>>2]=c[h>>2];iu(c[h>>2]|0);if(!(c[(c[f>>2]|0)+24+(1-(c[g>>2]|0)<<2)>>2]|0)){i=e;return}Jr(c[f>>2]|0);hu(c[(c[f>>2]|0)+32>>2]|0);hu(c[(c[f>>2]|0)+32+4>>2]|0);Ct(c[f>>2]|0,51484);i=e;return}function Lr(a,b,d,e,f){a=a|0;b=+b;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;c[j>>2]=a;h[k>>3]=b;h[l>>3]=d;h[m>>3]=e;h[n>>3]=f;ps(c[(c[j>>2]|0)+32>>2]|0,+h[k>>3],+h[l>>3]);ps(c[(c[j>>2]|0)+32>>2]|0,+h[m>>3],+h[n>>3]);ps(c[(c[j>>2]|0)+32+4>>2]|0,+h[k>>3],+h[l>>3]);ps(c[(c[j>>2]|0)+32+4>>2]|0,+h[m>>3],+h[n>>3]);i=g;return}function Mr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+80|0;h=g+68|0;j=g+64|0;k=g+60|0;l=g+56|0;m=g+52|0;n=g+48|0;o=g+44|0;p=g+40|0;q=g+36|0;r=g+32|0;s=g+28|0;t=g+24|0;u=g+8|0;v=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[q>>2]=cK((_(c[j>>2]|0,c[k>>2]|0)|0)<<2)|0;c[r>>2]=c[c[l>>2]>>2];c[s>>2]=cK(c[j>>2]<<2)|0;c[t>>2]=c[(c[h>>2]|0)+8>>2];c[v>>2]=0;if(c[r>>2]|0){O4(c[c[r>>2]>>2]|0);O4(c[r>>2]|0)}f=cK(c[k>>2]<<2)|0;c[r>>2]=f;c[c[l>>2]>>2]=f;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;f=(c[q>>2]|0)+((_(c[n>>2]|0,c[j>>2]|0)|0)<<2)|0;c[(c[r>>2]|0)+(c[n>>2]<<2)>>2]=f;c[n>>2]=(c[n>>2]|0)+1}if(c[m>>2]|0)ws(c[h>>2]|0,c[j>>2]|0);q=t2()|0;c[p>>2]=(q|0)%(c[j>>2]|0)|0;Nq(u,c[j>>2]|0);q=c[p>>2]|0;f=c[h>>2]|0;l=c[j>>2]|0;e=c[c[r>>2]>>2]|0;if(c[m>>2]|0)vr(q,f,l,e);else Iq(q,f,l,e,u);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[j>>2]|0))break;c[(c[s>>2]|0)+(c[n>>2]<<2)>>2]=c[(c[c[r>>2]>>2]|0)+(c[n>>2]<<2)>>2];if((c[(c[s>>2]|0)+(c[n>>2]<<2)>>2]|0)>(c[v>>2]|0)){c[p>>2]=c[n>>2];c[v>>2]=c[(c[s>>2]|0)+(c[n>>2]<<2)>>2]}c[n>>2]=(c[n>>2]|0)+1}c[n>>2]=1;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;e=c[p>>2]|0;l=c[h>>2]|0;f=c[j>>2]|0;q=c[(c[r>>2]|0)+(c[n>>2]<<2)>>2]|0;if(c[m>>2]|0)vr(e,l,f,q);else Iq(e,l,f,q,u);c[v>>2]=0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[j>>2]|0))break;q=c[o>>2]|0;if((c[(c[s>>2]|0)+(c[o>>2]<<2)>>2]|0)<(c[(c[(c[r>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[o>>2]<<2)>>2]|0))w=c[(c[s>>2]|0)+(q<<2)>>2]|0;else w=c[(c[(c[r>>2]|0)+(c[n>>2]<<2)>>2]|0)+(q<<2)>>2]|0;c[(c[s>>2]|0)+(c[o>>2]<<2)>>2]=w;if((c[(c[s>>2]|0)+(c[o>>2]<<2)>>2]|0)>(c[v>>2]|0)){c[p>>2]=c[o>>2];c[v>>2]=c[(c[s>>2]|0)+(c[o>>2]<<2)>>2]}c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+1}O4(c[s>>2]|0);if(!(c[m>>2]|0)){i=g;return}xs(c[h>>2]|0,c[j>>2]|0,c[t>>2]|0);i=g;return}function Nr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+8|0;n=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0))break;h[m>>3]=0.0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[g>>2]|0))break;h[m>>3]=+h[m>>3]+ +(c[(c[(c[f>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<2)>>2]|0);c[l>>2]=(c[l>>2]|0)+1}h[n>>3]=+h[m>>3]/+(c[g>>2]|0);c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[g>>2]|0))break;d=(c[(c[f>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<2)|0;c[d>>2]=(c[d>>2]|0)-~~+h[n>>3];c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}i=e;return}function Or(){var a=0,b=0;a=i;i=i+16|0;b=a;h[b>>3]=+((c[12875]|0)+4|0);c[12876]=~~+O(+(+h[b>>3]));i=a;return}function Pr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+8|0;j=d;c[e>>2]=a;c[f>>2]=b;h[g>>3]=+h[c[e>>2]>>3]-+h[c[f>>2]>>3];h[j>>3]=+h[(c[e>>2]|0)+8>>3]-+h[(c[f>>2]|0)+8>>3];i=d;return +(+h[g>>3]*+h[g>>3]+ +h[j>>3]*+h[j>>3])}function Qr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=a;h[c[f>>2]>>3]=+h[b>>3]-+h[d>>3];h[(c[f>>2]|0)+8>>3]=+h[b+8>>3]-+h[d+8>>3];i=e;return}function Rr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=a;h[c[f>>2]>>3]=+h[b>>3]+ +h[d>>3];h[(c[f>>2]|0)+8>>3]=+h[b+8>>3]+ +h[d+8>>3];i=e;return}function Sr(a,b,c){a=a|0;b=b|0;c=c|0;return +((+h[a+8>>3]-+h[b+8>>3])*(+h[c>>3]-+h[b>>3])-(+h[c+8>>3]-+h[b+8>>3])*(+h[a>>3]-+h[b>>3]))}function Tr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+48|0;f=e+32|0;g=e+16|0;h=e;c[h>>2]=c[a>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];d=+Sr(h,g,f)>0.0&1;i=e;return d|0}function Ur(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;j=g+28|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;c[k>>2]=f;h[n>>3]=+h[a>>3]*(+h[e+8>>3]-+h[d+8>>3])+ +h[b>>3]*(+h[d+8>>3]-+h[e+8>>3])+ +h[e>>3]*(+h[b+8>>3]-+h[a+8>>3])+ +h[d>>3]*(+h[a+8>>3]-+h[b+8>>3]);if(+h[n>>3]==0.0){c[j>>2]=0;o=c[j>>2]|0;i=g;return o|0}h[l>>3]=(+h[a>>3]*(+h[e+8>>3]-+h[d+8>>3])+ +h[d>>3]*(+h[a+8>>3]-+h[e+8>>3])+ +h[e>>3]*(+h[d+8>>3]-+h[a+8>>3]))/+h[n>>3];h[m>>3]=-(+h[a>>3]*(+h[d+8>>3]-+h[b+8>>3])+ +h[b>>3]*(+h[a+8>>3]-+h[d+8>>3])+ +h[d>>3]*(+h[b+8>>3]-+h[a+8>>3]))/+h[n>>3];h[c[k>>2]>>3]=+h[a>>3]+ +h[l>>3]*(+h[b>>3]-+h[a>>3]);h[(c[k>>2]|0)+8>>3]=+h[a+8>>3]+ +h[l>>3]*(+h[b+8>>3]-+h[a+8>>3]);if(0.0<=+h[l>>3]&+h[l>>3]<=1.0&0.0<=+h[m>>3]&+h[m>>3]<=1.0){c[j>>2]=1;o=c[j>>2]|0;i=g;return o|0}else{c[j>>2]=0;o=c[j>>2]|0;i=g;return o|0}return 0}function Vr(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e;k=e+12|0;l=e+8|0;c[f>>2]=a;c[g>>2]=b;h[j>>3]=d;c[(c[f>>2]|0)+20>>2]=c[g>>2];iu(c[g>>2]|0);h[(c[f>>2]|0)+24>>3]=+h[(c[g>>2]|0)+8>>3]+ +h[j>>3];j=as(c[f>>2]|0)|0;c[k>>2]=(c[12877]|0)+(j*40|0);while(1){j=c[(c[k>>2]|0)+32>>2]|0;c[l>>2]=j;if(!j)break;if(!(+h[(c[f>>2]|0)+24>>3]>+h[(c[l>>2]|0)+24>>3])){if(!(+h[(c[f>>2]|0)+24>>3]==+h[(c[l>>2]|0)+24>>3]))break;if(!(+h[c[g>>2]>>3]>+h[c[(c[l>>2]|0)+20>>2]>>3]))break}c[k>>2]=c[l>>2]}c[(c[f>>2]|0)+32>>2]=c[(c[k>>2]|0)+32>>2];c[(c[k>>2]|0)+32>>2]=c[f>>2];c[12878]=(c[12878]|0)+1;i=e;return}function Wr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[(c[d>>2]|0)+20>>2]|0)){i=b;return}a=as(c[d>>2]|0)|0;c[e>>2]=(c[12877]|0)+(a*40|0);while(1){if((c[(c[e>>2]|0)+32>>2]|0)==(c[d>>2]|0))break;c[e>>2]=c[(c[e>>2]|0)+32>>2]}c[(c[e>>2]|0)+32>>2]=c[(c[d>>2]|0)+32>>2];c[12878]=(c[12878]|0)-1;hu(c[(c[d>>2]|0)+20>>2]|0);c[(c[d>>2]|0)+20>>2]=0;i=b;return}function Xr(){return (c[12878]|0)==0|0}function Yr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;while(1){e=c[12879]|0;if(c[(c[12877]|0)+((c[12879]|0)*40|0)+32>>2]|0)break;c[12879]=e+1}h[d>>3]=+h[c[(c[(c[12877]|0)+(e*40|0)+32>>2]|0)+20>>2]>>3];h[d+8>>3]=+h[(c[(c[12877]|0)+((c[12879]|0)*40|0)+32>>2]|0)+24>>3];c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];i=b;return}function Zr(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=c[(c[12877]|0)+((c[12879]|0)*40|0)+32>>2];c[(c[12877]|0)+((c[12879]|0)*40|0)+32>>2]=c[(c[b>>2]|0)+32>>2];c[12878]=(c[12878]|0)-1;i=a;return c[b>>2]|0}function _r(){O4(c[12877]|0);c[12877]=0;return}function $r(){var a=0,b=0;a=i;i=i+16|0;b=a;c[12878]=0;c[12879]=0;c[12880]=c[12876]<<2;if(!(c[12877]|0))c[12877]=cK((c[12880]|0)*40|0)|0;c[b>>2]=0;while(1){if((c[b>>2]|0)>=(c[12880]|0))break;c[(c[12877]|0)+((c[b>>2]|0)*40|0)+32>>2]=0;c[b>>2]=(c[b>>2]|0)+1}i=a;return}function as(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b;c[d>>2]=a;h[f>>3]=(+h[(c[d>>2]|0)+24>>3]-+h[4206])/+h[4209]*+(c[12880]|0);do if(!(+h[f>>3]<0.0))if(+h[f>>3]>=+(c[12880]|0)){c[e>>2]=(c[12880]|0)-1;break}else{c[e>>2]=~~+h[f>>3];break}else c[e>>2]=0;while(0);if((c[e>>2]|0)>=(c[12879]|0)){g=c[e>>2]|0;i=b;return g|0}c[12879]=c[e>>2];g=c[e>>2]|0;i=b;return g|0}function bs(){At(51532,40);O4(c[12886]|0);c[12886]=0;return}function cs(){var a=0,b=0;a=i;i=i+16|0;b=a;At(51532,40);c[12887]=c[12876]<<1;if(!(c[12886]|0))c[12886]=cK(c[12887]<<2)|0;c[b>>2]=0;while(1){if((c[b>>2]|0)>=(c[12887]|0))break;c[(c[12886]|0)+(c[b>>2]<<2)>>2]=0;c[b>>2]=(c[b>>2]|0)+1}c[12881]=ds(0,0)|0;c[12882]=ds(0,0)|0;c[c[12881]>>2]=0;c[(c[12881]|0)+4>>2]=c[12882];c[c[12882]>>2]=c[12881];c[(c[12882]|0)+4>>2]=0;c[c[12886]>>2]=c[12881];c[(c[12886]|0)+((c[12887]|0)-1<<2)>>2]=c[12882];i=a;return}function ds(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e+8|0;h=e;c[f>>2]=b;a[g>>0]=d;c[h>>2]=Bt(51532)|0;c[(c[h>>2]|0)+8>>2]=c[f>>2];a[(c[h>>2]|0)+16>>0]=a[g>>0]|0;c[(c[h>>2]|0)+32>>2]=0;c[(c[h>>2]|0)+20>>2]=0;c[(c[h>>2]|0)+12>>2]=0;i=e;return c[h>>2]|0}function es(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;j=e+48|0;k=e+44|0;l=e+40|0;m=e+36|0;n=e+32|0;o=e+16|0;p=e+8|0;q=e;r=e+28|0;s=e+24|0;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[(c[g>>2]|0)+8>>2];c[l>>2]=c[(c[j>>2]|0)+8>>2];if((c[k>>2]|0)==0|(c[l>>2]|0)==0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}if((c[(c[k>>2]|0)+32+4>>2]|0)==(c[(c[l>>2]|0)+32+4>>2]|0)){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}h[o>>3]=+h[c[k>>2]>>3]*+h[(c[l>>2]|0)+8>>3]-+h[(c[k>>2]|0)+8>>3]*+h[c[l>>2]>>3];if(-1.0e-10<+h[o>>3]&+h[o>>3]<1.0e-10){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}h[p>>3]=(+h[(c[k>>2]|0)+16>>3]*+h[(c[l>>2]|0)+8>>3]-+h[(c[l>>2]|0)+16>>3]*+h[(c[k>>2]|0)+8>>3])/+h[o>>3];h[q>>3]=(+h[(c[l>>2]|0)+16>>3]*+h[c[k>>2]>>3]-+h[(c[k>>2]|0)+16>>3]*+h[c[l>>2]>>3])/+h[o>>3];do if(+h[(c[(c[k>>2]|0)+32+4>>2]|0)+8>>3]<+h[(c[(c[l>>2]|0)+32+4>>2]|0)+8>>3])u=10;else{if(+h[(c[(c[k>>2]|0)+32+4>>2]|0)+8>>3]==+h[(c[(c[l>>2]|0)+32+4>>2]|0)+8>>3]?+h[c[(c[k>>2]|0)+32+4>>2]>>3]<+h[c[(c[l>>2]|0)+32+4>>2]>>3]:0){u=10;break}c[n>>2]=c[j>>2];c[m>>2]=c[l>>2]}while(0);if((u|0)==10){c[n>>2]=c[g>>2];c[m>>2]=c[k>>2]}c[r>>2]=+h[p>>3]>=+h[c[(c[m>>2]|0)+32+4>>2]>>3]&1;if(!((c[r>>2]|0)!=0?(a[(c[n>>2]|0)+16>>0]|0)==0:0))u=14;do if((u|0)==14){if((c[r>>2]|0)==0?(a[(c[n>>2]|0)+16>>0]|0)==1:0)break;c[s>>2]=eu()|0;c[(c[s>>2]|0)+20>>2]=0;h[c[s>>2]>>3]=+h[p>>3];h[(c[s>>2]|0)+8>>3]=+h[q>>3];c[f>>2]=c[s>>2];t=c[f>>2]|0;i=e;return t|0}while(0);c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}function fs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+96|0;f=e+84|0;g=e+80|0;j=e+76|0;k=e+72|0;l=e+68|0;m=e+64|0;n=e+60|0;o=e+56|0;p=e+48|0;q=e+40|0;r=e+32|0;s=e+24|0;t=e+16|0;u=e+8|0;v=e;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[(c[g>>2]|0)+8>>2];c[l>>2]=c[(c[k>>2]|0)+32+4>>2];c[m>>2]=+h[c[j>>2]>>3]>+h[c[l>>2]>>3]&1;if((c[m>>2]|0)!=0?(a[(c[g>>2]|0)+16>>0]|0)==0:0){c[f>>2]=1;w=c[f>>2]|0;i=e;return w|0}if((c[m>>2]|0)==0?(a[(c[g>>2]|0)+16>>0]|0)==1:0){c[f>>2]=0;w=c[f>>2]|0;i=e;return w|0}if(+h[c[k>>2]>>3]==1.0){h[q>>3]=+h[(c[j>>2]|0)+8>>3]-+h[(c[l>>2]|0)+8>>3];h[p>>3]=+h[c[j>>2]>>3]-+h[c[l>>2]>>3];c[o>>2]=0;if(!(((c[m>>2]|0)!=0^1)&1&+h[(c[k>>2]|0)+8>>3]<0.0|c[m>>2]&+h[(c[k>>2]|0)+8>>3]>=0.0)){c[n>>2]=+h[c[j>>2]>>3]+ +h[(c[j>>2]|0)+8>>3]*+h[(c[k>>2]|0)+8>>3]>+h[(c[k>>2]|0)+16>>3]&1;if(+h[(c[k>>2]|0)+8>>3]<0.0)c[n>>2]=((c[n>>2]|0)!=0^1)&1;if(!(c[n>>2]|0))c[o>>2]=1}else{c[n>>2]=+h[q>>3]>=+h[(c[k>>2]|0)+8>>3]*+h[p>>3]&1;c[o>>2]=c[n>>2]}if((c[o>>2]|0)==0?(h[r>>3]=+h[c[l>>2]>>3]-+h[c[(c[k>>2]|0)+32>>2]>>3],c[n>>2]=+h[(c[k>>2]|0)+8>>3]*(+h[p>>3]*+h[p>>3]-+h[q>>3]*+h[q>>3])<+h[r>>3]*+h[q>>3]*(+h[p>>3]*2.0/+h[r>>3]+1.0+ +h[(c[k>>2]|0)+8>>3]*+h[(c[k>>2]|0)+8>>3])&1,+h[(c[k>>2]|0)+8>>3]<0.0):0)c[n>>2]=((c[n>>2]|0)!=0^1)&1}else{h[v>>3]=+h[(c[k>>2]|0)+16>>3]-+h[c[k>>2]>>3]*+h[c[j>>2]>>3];h[s>>3]=+h[(c[j>>2]|0)+8>>3]-+h[v>>3];h[t>>3]=+h[c[j>>2]>>3]-+h[c[l>>2]>>3];h[u>>3]=+h[v>>3]-+h[(c[l>>2]|0)+8>>3];c[n>>2]=+h[s>>3]*+h[s>>3]>+h[t>>3]*+h[t>>3]+ +h[u>>3]*+h[u>>3]&1}u=c[n>>2]|0;if(!(a[(c[g>>2]|0)+16>>0]|0))x=u;else x=((u|0)!=0^1)&1;c[f>>2]=x;w=c[f>>2]|0;i=e;return w|0}function gs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[f>>2]>>2]=c[e>>2];c[(c[f>>2]|0)+4>>2]=c[(c[e>>2]|0)+4>>2];c[c[(c[e>>2]|0)+4>>2]>>2]=c[f>>2];c[(c[e>>2]|0)+4>>2]=c[f>>2];i=d;return}function hs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;a=~~((+h[c[d>>2]>>3]-+h[4204])/+h[4208]*+(c[12887]|0));c[f>>2]=a;c[f>>2]=(c[f>>2]|0)<0?0:a;if((c[f>>2]|0)>=(c[12887]|0))c[f>>2]=(c[12887]|0)-1;c[g>>2]=ns(c[f>>2]|0)|0;if(!(c[g>>2]|0)){c[e>>2]=1;while(1){a=ns((c[f>>2]|0)-(c[e>>2]|0)|0)|0;c[g>>2]=a;if(a)break;a=ns((c[f>>2]|0)+(c[e>>2]|0)|0)|0;c[g>>2]=a;if(a)break;c[e>>2]=(c[e>>2]|0)+1}c[12888]=(c[12888]|0)+(c[e>>2]|0)}c[12889]=(c[12889]|0)+1;a:do if((c[g>>2]|0)==(c[12881]|0))j=12;else{if((c[g>>2]|0)!=(c[12882]|0)?(fs(c[g>>2]|0,c[d>>2]|0)|0)!=0:0){j=12;break}do{c[g>>2]=c[c[g>>2]>>2];if((c[g>>2]|0)==(c[12881]|0))break a}while((fs(c[g>>2]|0,c[d>>2]|0)|0)!=0^1)}while(0);if((j|0)==12){while(1){j=0;c[g>>2]=c[(c[g>>2]|0)+4>>2];if((c[g>>2]|0)==(c[12882]|0))break;if(fs(c[g>>2]|0,c[d>>2]|0)|0)j=12;else break}c[g>>2]=c[c[g>>2]>>2]}if((c[f>>2]|0)<=0){k=c[g>>2]|0;i=b;return k|0}if((c[f>>2]|0)>=((c[12887]|0)-1|0)){k=c[g>>2]|0;i=b;return k|0}if(c[(c[12886]|0)+(c[f>>2]<<2)>>2]|0){j=(c[(c[12886]|0)+(c[f>>2]<<2)>>2]|0)+12|0;c[j>>2]=(c[j>>2]|0)-1}c[(c[12886]|0)+(c[f>>2]<<2)>>2]=c[g>>2];j=(c[(c[12886]|0)+(c[f>>2]<<2)>>2]|0)+12|0;c[j>>2]=(c[j>>2]|0)+1;k=c[g>>2]|0;i=b;return k|0}function is(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[(c[c[d>>2]>>2]|0)+4>>2]=c[(c[d>>2]|0)+4>>2];c[c[(c[d>>2]|0)+4>>2]>>2]=c[c[d>>2]>>2];c[(c[d>>2]|0)+8>>2]=-2;i=b;return}function js(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[(c[d>>2]|0)+4>>2]|0}function ks(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[c[d>>2]>>2]|0}function ls(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;if(!(c[(c[f>>2]|0)+8>>2]|0)){c[e>>2]=c[12940];g=c[e>>2]|0;i=d;return g|0}b=(c[(c[f>>2]|0)+8>>2]|0)+32|0;if(!(a[(c[f>>2]|0)+16>>0]|0))h=c[b>>2]|0;else h=c[b+4>>2]|0;c[e>>2]=h;g=c[e>>2]|0;i=d;return g|0}function ms(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;if(!(c[(c[f>>2]|0)+8>>2]|0)){c[e>>2]=c[12940];g=c[e>>2]|0;i=d;return g|0}b=(c[(c[f>>2]|0)+8>>2]|0)+32|0;if(!(a[(c[f>>2]|0)+16>>0]|0))h=c[b+4>>2]|0;else h=c[b>>2]|0;c[e>>2]=h;g=c[e>>2]|0;i=d;return g|0}function ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if((c[e>>2]|0)>=0?(c[e>>2]|0)<(c[12887]|0):0){c[f>>2]=c[(c[12886]|0)+(c[e>>2]<<2)>>2];if((c[f>>2]|0)!=0?(c[(c[f>>2]|0)+8>>2]|0)==(-2|0):0){c[(c[12886]|0)+(c[e>>2]<<2)>>2]=0;e=(c[f>>2]|0)+12|0;a=(c[e>>2]|0)-1|0;c[e>>2]=a;if(!a)Ct(c[f>>2]|0,51532);c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}function os(){At(51564,24);return}function ps(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+80|0;f=e+64|0;g=e+32|0;j=e+24|0;k=e+60|0;l=e+56|0;m=e+52|0;n=e+48|0;o=e+44|0;p=e;q=e+40|0;c[f>>2]=a;h[g>>3]=b;h[j>>3]=d;c[o>>2]=c[f>>2];c[k>>2]=(c[12890]|0)+((c[(c[f>>2]|0)+16>>2]|0)*96|0);c[m>>2]=c[(c[k>>2]|0)+88>>2];h[p+8>>3]=+h[g>>3];h[p+8+8>>3]=+h[j>>3];c[q>>2]=qs(c[o>>2]|0,p,c[m>>2]|0)|0;if(!(c[q>>2]|0)){i=e;return}if((c[q>>2]|0)<0){c[l>>2]=Bt(51564)|0;h[(c[l>>2]|0)+8>>3]=+h[g>>3];h[(c[l>>2]|0)+8+8>>3]=+h[j>>3];c[c[l>>2]>>2]=c[m>>2];c[(c[k>>2]|0)+88>>2]=c[l>>2];i=e;return}c[n>>2]=c[m>>2];c[m>>2]=c[c[m>>2]>>2];while(1){k=qs(c[o>>2]|0,p,c[m>>2]|0)|0;c[q>>2]=k;if((k|0)<=0)break;c[n>>2]=c[m>>2];c[m>>2]=c[c[m>>2]>>2]}if(!(c[q>>2]|0)){i=e;return}c[l>>2]=Bt(51564)|0;h[(c[l>>2]|0)+8>>3]=+h[g>>3];h[(c[l>>2]|0)+8+8>>3]=+h[j>>3];c[c[n>>2]>>2]=c[l>>2];c[c[l>>2]>>2]=c[m>>2];i=e;return}function qs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;e=i;i=i+64|0;f=e+60|0;g=e+56|0;j=e+52|0;k=e+48|0;l=e+40|0;m=e+32|0;n=e+24|0;o=e+16|0;p=e+8|0;q=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;do if(c[k>>2]|0){if(+h[(c[j>>2]|0)+8>>3]==+h[(c[k>>2]|0)+8>>3]?+h[(c[j>>2]|0)+8+8>>3]==+h[(c[k>>2]|0)+8+8>>3]:0){c[f>>2]=0;break}h[l>>3]=+h[(c[j>>2]|0)+8>>3]-+h[c[g>>2]>>3];h[m>>3]=+h[(c[j>>2]|0)+8+8>>3]-+h[(c[g>>2]|0)+8>>3];h[n>>3]=+h[(c[k>>2]|0)+8>>3]-+h[c[g>>2]>>3];h[o>>3]=+h[(c[k>>2]|0)+8+8>>3]-+h[(c[g>>2]|0)+8>>3];r=+h[n>>3];if(!(+h[l>>3]>=0.0)){if(r>=0.0){c[f>>2]=1;break}h[p>>3]=+h[o>>3]/+h[n>>3];h[q>>3]=+h[m>>3]/+h[l>>3];if(+h[q>>3]<+h[p>>3]){c[f>>2]=-1;break}if(+h[q>>3]>+h[p>>3]){c[f>>2]=1;break}if(+h[l>>3]>+h[n>>3]){c[f>>2]=-1;break}else{c[f>>2]=1;break}}if(r<0.0){c[f>>2]=-1;break}d=+h[n>>3]>0.0;if(+h[l>>3]>0.0){r=+h[o>>3];if(!d)if(r>0.0){c[f>>2]=-1;break}else{c[f>>2]=1;break}h[p>>3]=r/+h[n>>3];h[q>>3]=+h[m>>3]/+h[l>>3];if(+h[q>>3]<+h[p>>3]){c[f>>2]=-1;break}if(+h[q>>3]>+h[p>>3]){c[f>>2]=1;break}if(+h[l>>3]<+h[n>>3]){c[f>>2]=-1;break}else{c[f>>2]=1;break}}else{r=+h[m>>3];if(d)if(r<=0.0){c[f>>2]=-1;break}else{c[f>>2]=1;break}if(r<+h[o>>3])if(+h[o>>3]<=0.0){c[f>>2]=1;break}else{c[f>>2]=-1;break}else if(+h[m>>3]<=0.0){c[f>>2]=-1;break}else{c[f>>2]=1;break}}}else c[f>>2]=-1;while(0);i=e;return c[f>>2]|0}function rs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+24|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[f+20>>2]=b;c[h>>2]=d;c[j>>2]=e;c[l>>2]=0;c[m>>2]=1;while(1){if((c[m>>2]|0)>=(c[(c[g>>2]|0)+((c[h>>2]|0)*20|0)>>2]|0))break;c[k>>2]=c[(c[(c[g>>2]|0)+((c[h>>2]|0)*20|0)+4>>2]|0)+(c[m>>2]<<2)>>2];if((c[(c[j>>2]|0)+(c[k>>2]<<2)>>2]|0)>0)c[l>>2]=(c[l>>2]|0)+1;c[m>>2]=(c[m>>2]|0)+1}i=f;return c[l>>2]|0}function ss(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=1;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+((c[g>>2]|0)*20|0)>>2]|0))break;c[(c[h>>2]|0)+(c[(c[(c[f>>2]|0)+((c[g>>2]|0)*20|0)+4>>2]|0)+(c[j>>2]<<2)>>2]<<2)>>2]=1;c[j>>2]=(c[j>>2]|0)+1}i=e;return}function ts(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=1;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+((c[g>>2]|0)*20|0)>>2]|0))break;c[(c[h>>2]|0)+(c[(c[(c[f>>2]|0)+((c[g>>2]|0)*20|0)+4>>2]|0)+(c[j>>2]<<2)>>2]<<2)>>2]=0;c[j>>2]=(c[j>>2]|0)+1}i=e;return}function us(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;a=c[g>>2]|0;if(c[(c[f>>2]|0)+8>>2]|0){c[e>>2]=Bs(b,a)|0;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=Cs(b,a)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function vs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=c[(c[e>>2]|0)+8>>2];ws(c[e>>2]|0,c[f>>2]|0);c[g>>2]=Bs(c[e>>2]|0,c[f>>2]|0)|0;xs(c[e>>2]|0,c[f>>2]|0,c[h>>2]|0);i=d;return c[g>>2]|0}function ws(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;o=d+4|0;p=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=0;c[m>>2]=cK(c[f>>2]<<2)|0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[f>>2]|0))break;c[k>>2]=(c[k>>2]|0)+(c[(c[e>>2]|0)+((c[h>>2]|0)*20|0)>>2]|0);c[h>>2]=(c[h>>2]|0)+1}c[l>>2]=cK(c[k>>2]<<2)|0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[f>>2]|0))break;c[(c[m>>2]|0)+(c[h>>2]<<2)>>2]=0;c[h>>2]=(c[h>>2]|0)+1}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[f>>2]|0))break;c[(c[e>>2]|0)+((c[h>>2]|0)*20|0)+8>>2]=c[l>>2];ss(c[e>>2]|0,c[h>>2]|0,c[m>>2]|0);c[n>>2]=(c[(c[e>>2]|0)+((c[h>>2]|0)*20|0)>>2]|0)-1;c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[n>>2]|0))break;c[p>>2]=c[(c[(c[e>>2]|0)+((c[h>>2]|0)*20|0)+4>>2]|0)+(c[j>>2]<<2)>>2];c[o>>2]=(c[(c[e>>2]|0)+((c[p>>2]|0)*20|0)>>2]|0)-1;k=(c[n>>2]|0)+(c[o>>2]|0)|0;q=+(k-((rs(c[e>>2]|0,c[h>>2]|0,c[p>>2]|0,c[m>>2]|0)|0)<<1)|0);g[(c[l>>2]|0)+(c[j>>2]<<2)>>2]=q;c[j>>2]=(c[j>>2]|0)+1}ts(c[e>>2]|0,c[h>>2]|0,c[m>>2]|0);c[l>>2]=(c[l>>2]|0)+(c[(c[e>>2]|0)+((c[h>>2]|0)*20|0)>>2]<<2);c[h>>2]=(c[h>>2]|0)+1}O4(c[m>>2]|0);i=d;return}function xs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;O4(c[(c[f>>2]|0)+8>>2]|0);c[(c[f>>2]|0)+8>>2]=0;if(!(c[h>>2]|0)){i=e;return}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[g>>2]|0))break;c[(c[f>>2]|0)+((c[j>>2]|0)*20|0)+8>>2]=c[h>>2];c[h>>2]=(c[h>>2]|0)+(c[(c[f>>2]|0)+((c[j>>2]|0)*20|0)>>2]<<2);c[j>>2]=(c[j>>2]|0)+1}i=e;return}function ys(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;f=i;i=i+32|0;g=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f;n=f+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;h[m>>3]=0.0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[j>>2]|0))break;h[m>>3]=+h[m>>3]+(+h[(c[(c[g>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]-+h[(c[(c[g>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3])*(+h[(c[(c[g>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]-+h[(c[(c[g>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]);c[n>>2]=(c[n>>2]|0)+1}o=+O(+(+h[m>>3]));i=f;return +o}function zs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[j>>2]|0)>=(c[k>>2]|0)){i=f;return}c[12894]=c[g>>2];w3((c[h>>2]|0)+(c[j>>2]<<2)|0,(c[k>>2]|0)-(c[j>>2]|0)+1|0,4,77);i=f;return}function As(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[j>>2]|0)>=(c[k>>2]|0)){i=f;return}Es(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,l);As(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,(c[l>>2]|0)-1|0);As(c[g>>2]|0,c[h>>2]|0,(c[l>>2]|0)+1|0,c[k>>2]|0);if(!(Fs(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,(c[l>>2]|0)-1|0)|0))As(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,(c[l>>2]|0)-1|0);if(Fs(c[g>>2]|0,c[h>>2]|0,(c[l>>2]|0)+1|0,c[k>>2]|0)|0){i=f;return}As(c[g>>2]|0,c[h>>2]|0,(c[l>>2]|0)+1|0,c[k>>2]|0);i=f;return}function Bs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=cK((_(c[f>>2]|0,c[f>>2]|0)|0)<<2)|0;c[j>>2]=cK(c[f>>2]<<2)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;b=(c[h>>2]|0)+((_(c[g>>2]|0,c[f>>2]|0)|0)<<2)|0;c[(c[j>>2]|0)+(c[g>>2]<<2)>>2]=b;c[g>>2]=(c[g>>2]|0)+1}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;vr(c[g>>2]|0,c[e>>2]|0,c[f>>2]|0,c[(c[j>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}i=d;return c[j>>2]|0}function Cs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=cK((_(c[f>>2]|0,c[f>>2]|0)|0)<<2)|0;c[j>>2]=cK(c[f>>2]<<2)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;b=(c[h>>2]|0)+((_(c[g>>2]|0,c[f>>2]|0)|0)<<2)|0;c[(c[j>>2]|0)+(c[g>>2]<<2)>>2]=b;c[g>>2]=(c[g>>2]|0)+1}Nq(k,c[f>>2]|0);c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;Iq(c[g>>2]|0,c[e>>2]|0,c[f>>2]|0,c[(c[j>>2]|0)+(c[g>>2]<<2)>>2]|0,k);c[g>>2]=(c[g>>2]|0)+1}Oq(k);i=d;return c[j>>2]|0}function Ds(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[h>>2]=b;g[j>>2]=+g[(c[12894]|0)+(c[c[f>>2]>>2]<<2)>>2];g[k>>2]=+g[(c[12894]|0)+(c[c[h>>2]>>2]<<2)>>2];if(+g[j>>2]<+g[k>>2]){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}if(+g[j>>2]>+g[k>>2]){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}return 0}function Es(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=i;i=i+48|0;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g;r=g+16|0;s=g+12|0;t=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;f=t2()|0;e=f|(t2()|0)<<16;c[o>>2]=((e>>>0)%(((c[m>>2]|0)-(c[l>>2]|0)+1|0)>>>0)|0)+(c[l>>2]|0);c[r>>2]=(c[l>>2]|0)+1;c[s>>2]=c[m>>2];c[p>>2]=c[(c[k>>2]|0)+(c[o>>2]<<2)>>2];c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=c[(c[k>>2]|0)+(c[l>>2]<<2)>>2];c[(c[k>>2]|0)+(c[l>>2]<<2)>>2]=c[p>>2];h[q>>3]=+h[(c[j>>2]|0)+(c[p>>2]<<3)>>3];while(1){if((c[r>>2]|0)>=(c[s>>2]|0))break;while(1){if((c[r>>2]|0)>=(c[s>>2]|0))break;if(!(+h[(c[j>>2]|0)+(c[(c[k>>2]|0)+(c[r>>2]<<2)>>2]<<3)>>3]<=+h[q>>3]))break;c[r>>2]=(c[r>>2]|0)+1}while(1){if((c[r>>2]|0)>=(c[s>>2]|0))break;if(!(+h[(c[j>>2]|0)+(c[(c[k>>2]|0)+(c[s>>2]<<2)>>2]<<3)>>3]>+h[q>>3]))break;c[s>>2]=(c[s>>2]|0)+-1}if((c[r>>2]|0)>=(c[s>>2]|0))continue;c[t>>2]=c[(c[k>>2]|0)+(c[r>>2]<<2)>>2];c[(c[k>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[k>>2]|0)+(c[s>>2]<<2)>>2];c[(c[k>>2]|0)+(c[s>>2]<<2)>>2]=c[t>>2];c[r>>2]=(c[r>>2]|0)+1;c[s>>2]=(c[s>>2]|0)+-1}if(!(+h[(c[j>>2]|0)+(c[(c[k>>2]|0)+(c[r>>2]<<2)>>2]<<3)>>3]>+h[q>>3])){u=c[r>>2]|0;v=c[n>>2]|0;c[v>>2]=u;w=c[r>>2]|0;x=c[k>>2]|0;y=x+(w<<2)|0;z=c[y>>2]|0;A=c[l>>2]|0;B=c[k>>2]|0;C=B+(A<<2)|0;c[C>>2]=z;D=c[p>>2]|0;E=c[r>>2]|0;F=c[k>>2]|0;G=F+(E<<2)|0;c[G>>2]=D;i=g;return}c[r>>2]=(c[r>>2]|0)-1;u=c[r>>2]|0;v=c[n>>2]|0;c[v>>2]=u;w=c[r>>2]|0;x=c[k>>2]|0;y=x+(w<<2)|0;z=c[y>>2]|0;A=c[l>>2]|0;B=c[k>>2]|0;C=B+(A<<2)|0;c[C>>2]=z;D=c[p>>2]|0;E=c[r>>2]|0;F=c[k>>2]|0;G=F+(E<<2)|0;c[G>>2]=D;i=g;return}function Fs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=1;c[m>>2]=(c[k>>2]|0)+1;while(1){if(!((c[m>>2]|0)<=(c[l>>2]|0)?(c[n>>2]|0)!=0:0))break;if(+h[(c[g>>2]|0)+(c[(c[j>>2]|0)+((c[m>>2]|0)-1<<2)>>2]<<3)>>3]>+h[(c[g>>2]|0)+(c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]<<3)>>3])c[n>>2]=0;c[m>>2]=(c[m>>2]|0)+1}i=f;return c[n>>2]|0}function Gs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;i=i+240048|0;e=4;f=N4(40)|0;c[f>>2]=0;g=d+240032|0;j=d+32|0;k=d;n=0;l=ia(23,b*40|0)|0;m=n;n=0;if((m|0)!=0&(o|0)!=0){p=Y4(c[m>>2]|0,f|0,e|0)|0;if(!p)Pa(m|0,o|0);C=o}else p=-1;if((p|0)!=1){p=0;m=0;while(1){if((p|0)>=(b|0))break;q=m+(c[(c[a+(p<<2)>>2]|0)+4>>2]|0)|0;p=p+1|0;m=q}n=0;p=ia(23,m*24|0)|0;q=n;n=0;if((q|0)!=0&(o|0)!=0){r=Y4(c[q>>2]|0,f|0,e|0)|0;if(!r)Pa(q|0,o|0);C=o}else r=-1;if((r|0)!=1){r=0;q=0;while(1){if((r|0)>=(b|0))break;c[l+(r*40|0)>>2]=p+(q*24|0);h[k+8>>3]=1797693134862315708145274.0e284;h[k>>3]=1797693134862315708145274.0e284;h[k+16+8>>3]=-1797693134862315708145274.0e284;h[k+16>>3]=-1797693134862315708145274.0e284;s=0;t=q;while(1){if((s|0)>=(c[(c[a+(r<<2)>>2]|0)+4>>2]|0))break;u=+h[(c[c[a+(r<<2)>>2]>>2]|0)+(s<<4)>>3];v=+h[(c[c[a+(r<<2)>>2]>>2]|0)+(s<<4)+8>>3];h[k>>3]=+h[k>>3]<u?+h[k>>3]:u;h[k+8>>3]=+h[k+8>>3]<v?+h[k+8>>3]:v;h[k+16>>3]=+h[k+16>>3]>u?+h[k+16>>3]:u;if(+h[k+16+8>>3]>v)w=+h[k+16+8>>3];else w=v;h[k+16+8>>3]=w;h[p+(t*24|0)>>3]=u;h[p+(t*24|0)+8>>3]=v;c[p+(t*24|0)+16>>2]=l+(r*40|0);c[p+(t*24|0)+20>>2]=0;s=s+1|0;t=t+1|0}c[l+(r*40|0)+4>>2]=p+((t-1|0)*24|0);s=l+(r*40|0)+8|0;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];c[s+12>>2]=c[k+12>>2];c[s+16>>2]=c[k+16>>2];c[s+20>>2]=c[k+20>>2];c[s+24>>2]=c[k+24>>2];c[s+28>>2]=c[k+28>>2];r=r+1|0;q=t}c[g>>2]=m;c[g+4>>2]=b;f=W4(51580,1,f|0,e|0)|0;e=C;n=0;m=n;n=0;if((m|0)!=0&(o|0)!=0){x=Y4(c[m>>2]|0,f|0,e|0)|0;if(!x)Pa(m|0,o|0);C=o}else x=-1;if((x|0)==1){y=C;z=l;A=p}else{y=0;z=l;A=p}}else{y=C;z=l;A=0}}else{y=C;z=0;A=0}while(1){if(y){n=0;ea(96,z|0);l=n;n=0;if((l|0)!=0&(o|0)!=0){B=Y4(c[l>>2]|0,f|0,e|0)|0;if(!B)Pa(l|0,o|0);C=o}else B=-1;if((B|0)==1){D=A;E=z;y=C;A=D;z=E;continue}n=0;ea(96,A|0);l=n;n=0;if((l|0)!=0&(o|0)!=0){F=Y4(c[l>>2]|0,f|0,e|0)|0;if(!F)Pa(l|0,o|0);C=o}else F=-1;if((F|0)==1){D=A;E=z;y=C;A=D;z=E;continue}else{G=20;break}}n=0;l=va(50,A|0,z|0,g|0,j|0)|0;p=n;n=0;if((p|0)!=0&(o|0)!=0){H=Y4(c[p>>2]|0,f|0,e|0)|0;if(!H)Pa(p|0,o|0);C=o}else H=-1;if((H|0)==1){D=A;E=z;y=C;A=D;z=E;continue}if(l)I=l;else{n=0;l=ka(29,a|0,b|0,z|0)|0;p=n;n=0;if((p|0)!=0&(o|0)!=0){J=Y4(c[p>>2]|0,f|0,e|0)|0;if(!J)Pa(p|0,o|0);C=o}else J=-1;if((J|0)==1){D=A;E=z;y=C;A=D;z=E;continue}I=l}n=0;ea(96,z|0);l=n;n=0;if((l|0)!=0&(o|0)!=0){K=Y4(c[l>>2]|0,f|0,e|0)|0;if(!K)Pa(l|0,o|0);C=o}else K=-1;if((K|0)==1){D=A;E=z;y=C;A=D;z=E;continue}n=0;ea(96,A|0);l=n;n=0;if((l|0)!=0&(o|0)!=0){L=Y4(c[l>>2]|0,f|0,e|0)|0;if(!L)Pa(l|0,o|0);C=o}else L=-1;if((L|0)==1){D=A;E=z;y=C;A=D;z=E}else{G=27;break}}if((G|0)==20){M=0;O4(f|0);i=d;return M|0}else if((G|0)==27){M=((I|0)!=0^1)&1;O4(f|0);i=d;return M|0}return 0}function Hs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+80|0;g=f;h=f+68|0;j=f+60|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+44|0;o=f+40|0;p=f+28|0;q=f+24|0;r=f+20|0;s=f+16|0;t=f+12|0;u=f+8|0;v=f+4|0;c[h>>2]=a;c[f+64>>2]=b;c[j>>2]=d;c[k>>2]=e;c[o>>2]=0;c[(c[j>>2]|0)+8>>2]=0;c[p+4>>2]=0;c[p>>2]=0;c[p+8>>2]=0;c[v>>2]=cK(c[c[j>>2]>>2]<<2)|0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[c[j>>2]>>2]|0))break;c[(c[v>>2]|0)+(c[l>>2]<<2)>>2]=(c[h>>2]|0)+((c[l>>2]|0)*24|0);c[l>>2]=(c[l>>2]|0)+1}w3(c[v>>2]|0,c[c[j>>2]>>2]|0,4,78);c[l>>2]=0;a:while(1){if((c[l>>2]|0)>=(c[c[j>>2]>>2]|0))break;c[s>>2]=c[(c[v>>2]|0)+(c[l>>2]<<2)>>2];h=c[(c[v>>2]|0)+(c[l>>2]<<2)>>2]|0;if((c[(c[v>>2]|0)+(c[l>>2]<<2)>>2]|0)==(c[c[(c[(c[v>>2]|0)+(c[l>>2]<<2)>>2]|0)+16>>2]>>2]|0))w=c[(c[h+16>>2]|0)+4>>2]|0;else w=h+-24|0;c[t>>2]=w;c[u>>2]=w;c[n>>2]=0;while(1){if((c[n>>2]|0)>=2)break;switch(Js(s,t)|0){case -1:{c[r>>2]=c[p>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[p+8>>2]|0))break;c[o>>2]=Ks(c[c[r>>2]>>2]|0,c[u>>2]|0,c[k>>2]|0,c[j>>2]|0)|0;if(c[o>>2]|0)break a;c[m>>2]=(c[m>>2]|0)+1;c[r>>2]=c[(c[r>>2]|0)+4>>2]}c[q>>2]=cK(12)|0;h=c[q>>2]|0;if(!(c[p+8>>2]|0)){c[p>>2]=h;c[(c[q>>2]|0)+8>>2]=0}else{c[(c[p+4>>2]|0)+4>>2]=h;c[(c[q>>2]|0)+8>>2]=c[p+4>>2]}c[c[q>>2]>>2]=c[u>>2];c[(c[q>>2]|0)+4>>2]=0;c[(c[u>>2]|0)+20>>2]=c[q>>2];c[p+4>>2]=c[q>>2];h=p+8|0;c[h>>2]=(c[h>>2]|0)+1;break}case 1:{h=c[(c[u>>2]|0)+20>>2]|0;c[r>>2]=h;if(!h){x=21;break a}do if((c[p+8>>2]|0)!=1){if((c[r>>2]|0)==(c[p>>2]|0)){c[p>>2]=c[(c[p>>2]|0)+4>>2];c[(c[p>>2]|0)+8>>2]=0;break}if((c[r>>2]|0)==(c[p+4>>2]|0)){c[p+4>>2]=c[(c[p+4>>2]|0)+8>>2];c[(c[p+4>>2]|0)+4>>2]=0;break}else{c[(c[(c[r>>2]|0)+8>>2]|0)+4>>2]=c[(c[r>>2]|0)+4>>2];c[(c[(c[r>>2]|0)+4>>2]|0)+8>>2]=c[(c[r>>2]|0)+8>>2];break}}else{c[p>>2]=0;c[p+4>>2]=0}while(0);O4(c[r>>2]|0);h=p+8|0;c[h>>2]=(c[h>>2]|0)+-1;c[(c[u>>2]|0)+20>>2]=0;break}default:{}}h=c[(c[v>>2]|0)+(c[l>>2]<<2)>>2]|0;if((c[(c[v>>2]|0)+(c[l>>2]<<2)>>2]|0)==(c[(c[(c[(c[v>>2]|0)+(c[l>>2]<<2)>>2]|0)+16>>2]|0)+4>>2]|0))y=c[c[h+16>>2]>>2]|0;else y=h+24|0;c[t>>2]=y;c[u>>2]=c[(c[v>>2]|0)+(c[l>>2]<<2)>>2];c[n>>2]=(c[n>>2]|0)+1}c[l>>2]=(c[l>>2]|0)+1}if((x|0)==21){$z(1,131135,g)|0;Pa(51580,1)}c[r>>2]=c[p>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[p+8>>2]|0))break;c[q>>2]=c[(c[r>>2]|0)+4>>2];O4(c[r>>2]|0);c[m>>2]=(c[m>>2]|0)+1;c[r>>2]=c[q>>2]}O4(c[v>>2]|0);i=f;return c[o>>2]|0}function Is(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+80|0;f=e+16|0;g=e+64|0;j=e+60|0;k=e+56|0;l=e+52|0;m=e+48|0;n=e+44|0;o=e+40|0;p=e;q=e+36|0;r=e+32|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=0;a:while(1){if((c[n>>2]|0)>=(c[l>>2]|0)){s=27;break}c[q>>2]=c[(c[k>>2]|0)+(c[n>>2]<<2)>>2];d=c[c[q>>2]>>2]|0;c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];c[o>>2]=(c[n>>2]|0)+1;while(1){if((c[o>>2]|0)>=(c[l>>2]|0))break;c[r>>2]=c[(c[k>>2]|0)+(c[o>>2]<<2)>>2];if(((((((+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8>>3]<=+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+16>>3]?+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8>>3]>=+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8>>3]:0)?+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+8>>3]<=+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+16+8>>3]:0)?+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+8>>3]>=+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+8>>3]:0)?+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+16>>3]<=+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+16>>3]:0)?+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+16>>3]>=+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8>>3]:0)?+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+16+8>>3]<=+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+16+8>>3]:0)?+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+16+8>>3]>=+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+8>>3]:0){d=c[r>>2]|0;c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];if(qX(g,f)|0){s=14;break a}}else s=15;if((((((((((s|0)==15?(s=0,+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8>>3]<=+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+16>>3]):0)?+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8>>3]>=+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8>>3]:0)?+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+8>>3]<=+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+16+8>>3]:0)?+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+8>>3]>=+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+8>>3]:0)?+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+16>>3]<=+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+16>>3]:0)?+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+16>>3]>=+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8>>3]:0)?+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+16+8>>3]<=+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+16+8>>3]:0)?+h[(c[m>>2]|0)+((c[o>>2]|0)*40|0)+8+16+8>>3]>=+h[(c[m>>2]|0)+((c[n>>2]|0)*40|0)+8+8>>3]:0)?(d=c[q>>2]|0,b=c[c[r>>2]>>2]|0,c[g>>2]=c[d>>2],c[g+4>>2]=c[d+4>>2],c[f>>2]=c[b>>2],c[f+4>>2]=c[b+4>>2],c[f+8>>2]=c[b+8>>2],c[f+12>>2]=c[b+12>>2],(qX(g,f)|0)!=0):0){s=24;break a}c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+1}if((s|0)==14){c[j>>2]=1;t=c[j>>2]|0;i=e;return t|0}else if((s|0)==24){c[j>>2]=1;t=c[j>>2]|0;i=e;return t|0}else if((s|0)==27){c[j>>2]=0;t=c[j>>2]|0;i=e;return t|0}return 0}function Js(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d;c[f>>2]=a;c[g>>2]=b;k=+h[c[c[f>>2]>>2]>>3]-+h[c[c[g>>2]>>2]>>3];h[j>>3]=k;if(k!=0.0){c[e>>2]=+h[j>>3]>0.0?1:-1;l=c[e>>2]|0;i=d;return l|0}k=+h[(c[c[f>>2]>>2]|0)+8>>3]-+h[(c[c[g>>2]>>2]|0)+8>>3];h[j>>3]=k;if(k==0.0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=+h[j>>3]>0.0?1:-1;l=c[e>>2]|0;i=d;return l|0}return 0}function Ks(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+80|0;g=f+32|0;j=f+76|0;k=f+72|0;l=f+68|0;m=f+24|0;n=f+16|0;o=f;p=f+48|0;c[k>>2]=a;c[l>>2]=b;c[f+64>>2]=d;c[f+60>>2]=e;Ls(c[k>>2]|0,c[l>>2]|0,p);if((c[p+8>>2]|0)>0){c[j>>2]=0;q=c[j>>2]|0;i=f;return q|0}if((c[p+8>>2]|0)<0){Ls(c[l>>2]|0,c[k>>2]|0,p);if((c[p+8>>2]|0)>0){c[j>>2]=0;q=c[j>>2]|0;i=f;return q|0}e=c[k>>2]|0;d=c[l>>2]|0;if((c[p+8>>2]|0)<0)r=3;else{b=c[p>>2]|0;r=Ms(c[l>>2]|0,c[k>>2]|0,(c[p>>2]|0)>=0?b:0-b|0)|0}if(!(Ns(e,d,m,n,r)|0)){c[j>>2]=0;q=c[j>>2]|0;i=f;return q|0}}else{r=c[k>>2]|0;d=c[l>>2]|0;e=c[k>>2]|0;b=c[l>>2]|0;if((c[p>>2]|0)==(c[p+4>>2]|0)){a=Ms(e,b,0)|0;s=(a|0)>(Ms(c[k>>2]|0,c[l>>2]|0,1)|0);a=c[k>>2]|0;t=c[l>>2]|0;if(s)u=Ms(a,t,0)|0;else u=Ms(a,t,1)|0;v=u<<1}else{u=c[p>>2]|0;v=Ms(e,b,(c[p>>2]|0)>=0?u:0-u|0)|0}if(!(Ns(r,d,m,n,v)|0)){c[j>>2]=0;q=c[j>>2]|0;i=f;return q|0}}h[o>>3]=+h[m>>3];h[o+8>>3]=+h[n>>3];n=c[k>>2]|0;k=c[l>>2]|0;c[g>>2]=c[o>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];c[j>>2]=Os(n,k,g)|0;q=c[j>>2]|0;i=f;return q|0}function Ls(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+96|0;f=e+80|0;g=e+76|0;j=e+72|0;k=e+64|0;l=e+56|0;m=e+48|0;n=e+40|0;o=e+32|0;p=e+24|0;q=e+16|0;r=e+8|0;s=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;h[k>>3]=+h[c[f>>2]>>3];h[l>>3]=+h[(c[f>>2]|0)+8>>3];d=c[f>>2]|0;if((c[f>>2]|0)==(c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0))t=c[c[d+16>>2]>>2]|0;else t=d+24|0;h[m>>3]=+h[t>>3]-+h[k>>3];t=c[f>>2]|0;if((c[f>>2]|0)==(c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0))u=c[c[t+16>>2]>>2]|0;else u=t+24|0;h[n>>3]=+h[u+8>>3]-+h[l>>3];h[o>>3]=+h[c[g>>2]>>3]-+h[k>>3];h[p>>3]=+h[(c[g>>2]|0)+8>>3]-+h[l>>3];u=c[g>>2]|0;if((c[g>>2]|0)==(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0))v=c[c[u+16>>2]>>2]|0;else v=u+24|0;h[q>>3]=+h[v>>3]-+h[k>>3];k=c[g>>2]|0;if((c[g>>2]|0)==(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0))w=c[c[k+16>>2]>>2]|0;else w=k+24|0;h[r>>3]=+h[w+8>>3]-+h[l>>3];h[s>>3]=+h[m>>3]*+h[p>>3]-+h[n>>3]*+h[o>>3];if(+h[s>>3]==0.0)x=0;else x=+h[s>>3]>0.0?1:-1;c[c[j>>2]>>2]=x;h[s>>3]=+h[m>>3]*+h[r>>3]-+h[n>>3]*+h[q>>3];if(+h[s>>3]==0.0){y=0;z=c[j>>2]|0;A=z+4|0;c[A>>2]=y;B=c[j>>2]|0;C=c[B>>2]|0;D=c[j>>2]|0;E=D+4|0;F=c[E>>2]|0;G=_(C,F)|0;H=c[j>>2]|0;I=H+8|0;c[I>>2]=G;i=e;return}y=+h[s>>3]>0.0?1:-1;z=c[j>>2]|0;A=z+4|0;c[A>>2]=y;B=c[j>>2]|0;C=c[B>>2]|0;D=c[j>>2]|0;E=D+4|0;F=c[E>>2]|0;G=_(C,F)|0;H=c[j>>2]|0;I=H+8|0;c[I>>2]=G;i=e;return}function Ms(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;j=e+48|0;k=e+32|0;l=e+16|0;m=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;d=c[f>>2]|0;c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];d=c[f>>2]|0;if((c[f>>2]|0)==(c[(c[(c[f>>2]|0)+16>>2]|0)+4>>2]|0))n=c[c[d+16>>2]>>2]|0;else n=d+24|0;c[l>>2]=c[n>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];n=c[g>>2]|0;if(!(c[j>>2]|0)){c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2]}else{j=c[g>>2]|0;if((n|0)==(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0))o=c[c[j+16>>2]>>2]|0;else o=j+24|0;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];c[m+12>>2]=c[o+12>>2]}p=+h[k>>3];q=+h[m>>3];if(!(+h[k>>3]==+h[l>>3])){r=Qs(p,q,+h[l>>3])|0;i=e;return r|0}if(p==q)s=-1!=(Qs(+h[k+8>>3],+h[m+8>>3],+h[l+8>>3])|0);else s=0;r=s&1;i=e;return r|0}function Ns(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+160|0;j=g+148|0;k=g+144|0;l=g+140|0;m=g+136|0;n=g+132|0;o=g+128|0;p=g+112|0;q=g+96|0;r=g+80|0;s=g+64|0;t=g+48|0;u=g+32|0;v=g+24|0;w=g+16|0;x=g+8|0;y=g;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;if((c[o>>2]|0)<=0){c[j>>2]=0;z=c[j>>2]|0;i=g;return z|0}f=c[k>>2]|0;c[p>>2]=c[f>>2];c[p+4>>2]=c[f+4>>2];c[p+8>>2]=c[f+8>>2];c[p+12>>2]=c[f+12>>2];f=c[k>>2]|0;if((c[k>>2]|0)==(c[(c[(c[k>>2]|0)+16>>2]|0)+4>>2]|0))A=c[c[f+16>>2]>>2]|0;else A=f+24|0;c[q>>2]=c[A>>2];c[q+4>>2]=c[A+4>>2];c[q+8>>2]=c[A+8>>2];c[q+12>>2]=c[A+12>>2];A=c[l>>2]|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];A=c[l>>2]|0;if((c[l>>2]|0)==(c[(c[(c[l>>2]|0)+16>>2]|0)+4>>2]|0))B=c[c[A+16>>2]>>2]|0;else B=A+24|0;c[s>>2]=c[B>>2];c[s+4>>2]=c[B+4>>2];c[s+8>>2]=c[B+8>>2];c[s+12>>2]=c[B+12>>2];a:do switch(c[o>>2]|0){case 3:{if(+h[p>>3]==+h[q>>3]){h[c[m>>2]>>3]=+h[p>>3];h[c[n>>2]>>3]=+h[s+8>>3]+(+h[r+8>>3]-+h[s+8>>3])/(+h[r>>3]-+h[s>>3])*(+h[c[m>>2]>>3]-+h[s>>3]);break a}if(+h[r>>3]==+h[s>>3]){h[c[m>>2]>>3]=+h[r>>3];h[c[n>>2]>>3]=+h[q+8>>3]+(+h[p+8>>3]-+h[q+8>>3])/(+h[p>>3]-+h[q>>3])*(+h[c[m>>2]>>3]-+h[q>>3]);break a}else{h[v>>3]=(+h[r+8>>3]-+h[s+8>>3])/(+h[r>>3]-+h[s>>3]);h[w>>3]=(+h[p+8>>3]-+h[q+8>>3])/(+h[p>>3]-+h[q>>3]);h[x>>3]=+h[r+8>>3]-+h[v>>3]*+h[r>>3];h[y>>3]=+h[p+8>>3]-+h[w>>3]*+h[p>>3];h[c[m>>2]>>3]=(+h[y>>3]-+h[x>>3])/(+h[v>>3]-+h[w>>3]);h[c[n>>2]>>3]=(+h[v>>3]*+h[y>>3]-+h[x>>3]*+h[w>>3])/(+h[v>>3]-+h[w>>3]);break a}break}case 2:{do if((Ms(c[k>>2]|0,c[l>>2]|0,0)|0)==-1){c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];c[t+12>>2]=c[r+12>>2];if((Ms(c[l>>2]|0,c[k>>2]|0,1)|0)!=-1){c[u>>2]=c[s>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];c[u+12>>2]=c[s+12>>2];break}if((Ms(c[l>>2]|0,c[k>>2]|0,0)|0)==-1){c[u>>2]=c[q>>2];c[u+4>>2]=c[q+4>>2];c[u+8>>2]=c[q+8>>2];c[u+12>>2]=c[q+12>>2];break}else{c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];c[u+12>>2]=c[p+12>>2];break}}else{if((Ms(c[k>>2]|0,c[l>>2]|0,1)|0)!=-1){if((Ms(c[l>>2]|0,c[k>>2]|0,0)|0)==-1){c[t>>2]=c[p>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];c[u>>2]=c[q>>2];c[u+4>>2]=c[q+4>>2];c[u+8>>2]=c[q+8>>2];c[u+12>>2]=c[q+12>>2];break}c[j>>2]=0;z=c[j>>2]|0;i=g;return z|0};c[t>>2]=c[s>>2];c[t+4>>2]=c[s+4>>2];c[t+8>>2]=c[s+8>>2];c[t+12>>2]=c[s+12>>2];if((Ms(c[k>>2]|0,c[l>>2]|0,0)|0)!=-1){c[u>>2]=c[r>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];break}if((Ms(c[l>>2]|0,c[k>>2]|0,0)|0)==-1){c[u>>2]=c[q>>2];c[u+4>>2]=c[q+4>>2];c[u+8>>2]=c[q+8>>2];c[u+12>>2]=c[q+12>>2];break}else{c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];c[u+12>>2]=c[p+12>>2];break}}while(0);h[c[m>>2]>>3]=(+h[t>>3]+ +h[u>>3])/2.0;h[c[n>>2]>>3]=(+h[t+8>>3]+ +h[u+8>>3])/2.0;break}case 1:{if((+h[p>>3]-+h[q>>3])*(+h[r+8>>3]-+h[p+8>>3])==(+h[p+8>>3]-+h[q+8>>3])*(+h[r>>3]-+h[p>>3])){h[c[m>>2]>>3]=+h[r>>3];h[c[n>>2]>>3]=+h[r+8>>3];break a}else{h[c[m>>2]>>3]=+h[s>>3];h[c[n>>2]>>3]=+h[s+8>>3];break a}break}default:{}}while(0);c[j>>2]=1;z=c[j>>2]|0;i=g;return z|0}function Os(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0;f=i;i=i+96|0;g=f+64|0;j=f+88|0;k=f+84|0;l=f+80|0;m=f+48|0;n=f+32|0;o=f+16|0;p=f;c[k>>2]=a;c[l>>2]=b;b=c[k>>2]|0;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];b=c[k>>2]|0;if((c[k>>2]|0)==(c[(c[(c[k>>2]|0)+16>>2]|0)+4>>2]|0))q=c[c[b+16>>2]>>2]|0;else q=b+24|0;c[o>>2]=c[q>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[o+12>>2]=c[q+12>>2];q=c[l>>2]|0;c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];q=c[l>>2]|0;if((c[l>>2]|0)==(c[(c[(c[l>>2]|0)+16>>2]|0)+4>>2]|0))r=c[c[q+16>>2]>>2]|0;else r=q+24|0;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2];if(!(+h[m>>3]!=+h[o>>3]?+h[n>>3]!=+h[p>>3]:0))s=9;a:do if((s|0)==9){do if(+h[m>>3]==+h[o>>3]){if(+h[m>>3]==+h[e>>3]?+h[m+8>>3]==+h[e+8>>3]:0)break;if(!(+h[o>>3]==+h[e>>3]))break a;if(!(+h[o+8>>3]==+h[e+8>>3]))break a}while(0);do if(+h[n>>3]==+h[p>>3]){if(+h[n>>3]==+h[e>>3]?+h[n+8>>3]==+h[e+8>>3]:0)break;if(!(+h[p>>3]==+h[e>>3]))break a;if(!(+h[p+8>>3]==+h[e+8>>3]))break a}while(0);c[j>>2]=0;t=c[j>>2]|0;i=f;return t|0}while(0);if((d[138998]|0|0)>1){p=c[24742]|0;u=+h[e+8>>3];h[g>>3]=+h[e>>3];h[g+8>>3]=u;Y2(p,131164,g)|0;Ps(1,c[k>>2]|0);Ps(2,c[l>>2]|0)}c[j>>2]=1;t=c[j>>2]|0;i=f;return t|0}function Ps(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0.0;d=i;i=i+48|0;e=d;f=d+44|0;g=d+40|0;c[f>>2]=a;c[g>>2]=b;b=c[24742]|0;j=+h[c[g>>2]>>3];k=+h[(c[g>>2]|0)+8>>3];a=c[g>>2]|0;if((c[g>>2]|0)==(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0))l=c[c[a+16>>2]>>2]|0;else l=a+24|0;m=+h[l>>3];l=c[g>>2]|0;if((c[g>>2]|0)==(c[(c[(c[g>>2]|0)+16>>2]|0)+4>>2]|0))n=c[c[l+16>>2]>>2]|0;else n=l+24|0;o=+h[n+8>>3];c[e>>2]=c[f>>2];h[e+8>>3]=j;h[e+16>>3]=k;h[e+24>>3]=m;h[e+32>>3]=o;Y2(b,131192,e)|0;i=d;return}function Qs(a,b,d){a=+a;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e+8|0;k=e;h[g>>3]=a;h[j>>3]=b;h[k>>3]=d;if(!(+h[g>>3]==+h[j>>3])?!(+h[j>>3]==+h[k>>3]):0){if(+h[g>>3]<+h[j>>3])l=+h[j>>3]<+h[k>>3];else l=+h[k>>3]<+h[j>>3];c[f>>2]=l?1:-1;m=c[f>>2]|0;i=e;return m|0}c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}function Rs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;if(!(Yx(c[g>>2]|0,c[k>>2]|0)|0)){c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}c[n>>2]=bK(c[k>>2]<<3)|0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[k>>2]|0))break;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[k>>2]|0))break;h[(c[n>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[m>>2]=(c[m>>2]|0)+1}h[(c[n>>2]|0)+(c[l>>2]<<3)>>3]=1.0;Zx(c[(c[j>>2]|0)+(c[l>>2]<<2)>>2]|0,c[n>>2]|0,c[k>>2]|0);c[l>>2]=(c[l>>2]|0)+1}O4(c[n>>2]|0);c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[k>>2]|0))break;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;h[o>>3]=+h[(c[(c[j>>2]|0)+(c[l>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3];h[(c[(c[j>>2]|0)+(c[l>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]=+h[(c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3];h[(c[(c[j>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]=+h[o>>3];c[m>>2]=(c[m>>2]|0)+1}c[l>>2]=(c[l>>2]|0)+1}c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}function Ss(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;j=i;i=i+96|0;k=j+92|0;l=j+88|0;m=j+84|0;n=j+80|0;o=j+76|0;p=j+72|0;q=j+68|0;r=j+64|0;s=j+60|0;t=j+56|0;u=j+52|0;v=j+32|0;w=j+24|0;x=j+16|0;y=j+48|0;z=j+44|0;A=j+8|0;B=j+40|0;C=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[s>>2]=cK(c[l>>2]<<3)|0;c[t>>2]=cK(c[l>>2]<<3)|0;c[y>>2]=0;c[B>>2]=(c[l>>2]|0)*30;h[C>>3]=1.0-+h[4210];if((c[m>>2]|0)>=(c[l>>2]|0))c[m>>2]=c[l>>2];c[q>>2]=0;a:while(1){if((c[q>>2]|0)>=(c[m>>2]|0))break;c[u>>2]=c[(c[n>>2]|0)+(c[q>>2]<<2)>>2];do{b:do if(c[p>>2]|0){c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[l>>2]|0))break b;D=+((t2()|0)%100|0|0);h[(c[u>>2]|0)+(c[r>>2]<<3)>>3]=D;c[r>>2]=(c[r>>2]|0)+1}}while(0);c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[q>>2]|0))break;h[x>>3]=-+Ts(c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0,0,(c[l>>2]|0)-1|0,c[u>>2]|0);Us(c[u>>2]|0,0,(c[l>>2]|0)-1|0,+h[x>>3],c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0);c[r>>2]=(c[r>>2]|0)+1}h[v>>3]=+Vs(c[u>>2]|0,0,(c[l>>2]|0)-1|0)}while(+h[v>>3]<1.0e-10);Ws(c[u>>2]|0,0,(c[l>>2]|0)-1|0,1.0/+h[v>>3],c[u>>2]|0);c[y>>2]=0;do{c[y>>2]=(c[y>>2]|0)+1;Xs(c[t>>2]|0,0,(c[l>>2]|0)-1|0,c[u>>2]|0);Ys(c[k>>2]|0,c[l>>2]|0,c[l>>2]|0,c[u>>2]|0,c[s>>2]|0);Xs(c[u>>2]|0,0,(c[l>>2]|0)-1|0,c[s>>2]|0);c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[q>>2]|0))break;h[x>>3]=-+Ts(c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0,0,(c[l>>2]|0)-1|0,c[u>>2]|0);Us(c[u>>2]|0,0,(c[l>>2]|0)-1|0,+h[x>>3],c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0);c[r>>2]=(c[r>>2]|0)+1}h[v>>3]=+Vs(c[u>>2]|0,0,(c[l>>2]|0)-1|0);if(+h[v>>3]<1.0e-10)break a;if((c[y>>2]|0)>(c[B>>2]|0))break a;Ws(c[u>>2]|0,0,(c[l>>2]|0)-1|0,1.0/+h[v>>3],c[u>>2]|0);h[w>>3]=+Ts(c[u>>2]|0,0,(c[l>>2]|0)-1|0,c[t>>2]|0);D=+N(+(+h[w>>3]))}while(D<+h[C>>3]);h[(c[o>>2]|0)+(c[q>>2]<<3)>>3]=+h[w>>3]*+h[v>>3];c[q>>2]=(c[q>>2]|0)+1}while(1){if((c[q>>2]|0)>=(c[m>>2]|0))break;c[u>>2]=c[(c[n>>2]|0)+(c[q>>2]<<2)>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[l>>2]|0))break;D=+((t2()|0)%100|0|0);h[(c[u>>2]|0)+(c[r>>2]<<3)>>3]=D;c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[q>>2]|0))break;h[x>>3]=-+Ts(c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0,0,(c[l>>2]|0)-1|0,c[u>>2]|0);Us(c[u>>2]|0,0,(c[l>>2]|0)-1|0,+h[x>>3],c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0);c[r>>2]=(c[r>>2]|0)+1}h[v>>3]=+Vs(c[u>>2]|0,0,(c[l>>2]|0)-1|0);Ws(c[u>>2]|0,0,(c[l>>2]|0)-1|0,1.0/+h[v>>3],c[u>>2]|0);h[(c[o>>2]|0)+(c[q>>2]<<3)>>3]=0.0;c[q>>2]=(c[q>>2]|0)+1}c[q>>2]=0;while(1){if((c[q>>2]|0)>=((c[m>>2]|0)-1|0))break;c[z>>2]=c[q>>2];h[A>>3]=+h[(c[o>>2]|0)+(c[z>>2]<<3)>>3];c[r>>2]=(c[q>>2]|0)+1;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;if(+h[A>>3]<+h[(c[o>>2]|0)+(c[r>>2]<<3)>>3]){c[z>>2]=c[r>>2];h[A>>3]=+h[(c[o>>2]|0)+(c[z>>2]<<3)>>3]}c[r>>2]=(c[r>>2]|0)+1}if((c[z>>2]|0)!=(c[q>>2]|0)){Xs(c[s>>2]|0,0,(c[l>>2]|0)-1|0,c[(c[n>>2]|0)+(c[q>>2]<<2)>>2]|0);Xs(c[(c[n>>2]|0)+(c[q>>2]<<2)>>2]|0,0,(c[l>>2]|0)-1|0,c[(c[n>>2]|0)+(c[z>>2]<<2)>>2]|0);Xs(c[(c[n>>2]|0)+(c[z>>2]<<2)>>2]|0,0,(c[l>>2]|0)-1|0,c[s>>2]|0);h[(c[o>>2]|0)+(c[z>>2]<<3)>>3]=+h[(c[o>>2]|0)+(c[q>>2]<<3)>>3];h[(c[o>>2]|0)+(c[q>>2]<<3)>>3]=+h[A>>3]}c[q>>2]=(c[q>>2]|0)+1}O4(c[s>>2]|0);O4(c[t>>2]|0);i=j;return (c[y>>2]|0)<=(c[B>>2]|0)|0}function Ts(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;f=i;i=i+32|0;g=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;h[n>>3]=0.0;c[g>>2]=(c[g>>2]|0)+(c[j>>2]<<3);c[l>>2]=(c[l>>2]|0)+(c[j>>2]<<3);c[m>>2]=(c[k>>2]|0)-(c[j>>2]|0)+1;while(1){if(!(c[m>>2]|0))break;j=c[g>>2]|0;c[g>>2]=j+8;o=+h[j>>3];j=c[l>>2]|0;c[l>>2]=j+8;h[n>>3]=+h[n>>3]+o*+h[j>>3];c[m>>2]=(c[m>>2]|0)+-1}i=f;return +(+h[n>>3])}function Us(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;g=i;i=i+32|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g;n=g+12|0;o=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;h[m>>3]=e;c[n>>2]=f;c[j>>2]=(c[j>>2]|0)+(c[k>>2]<<3);c[n>>2]=(c[n>>2]|0)+(c[k>>2]<<3);c[o>>2]=(c[l>>2]|0)-(c[k>>2]|0)+1;while(1){if(!(c[o>>2]|0))break;e=+h[m>>3];k=c[n>>2]|0;c[n>>2]=k+8;p=e*+h[k>>3];k=c[j>>2]|0;c[j>>2]=k+8;h[k>>3]=+h[k>>3]+p;c[o>>2]=(c[o>>2]|0)+-1}i=g;return}function Vs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0.0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;j=+O(+(+Ts(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,c[f>>2]|0)));i=e;return +j}function Ws(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;g=i;i=i+32|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g;n=g+12|0;o=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;h[m>>3]=e;c[n>>2]=f;c[j>>2]=(c[j>>2]|0)+(c[k>>2]<<3);c[n>>2]=(c[n>>2]|0)+(c[k>>2]<<3);c[o>>2]=(c[l>>2]|0)-(c[k>>2]|0)+1;while(1){if(!(c[o>>2]|0))break;e=+h[m>>3];k=c[n>>2]|0;c[n>>2]=k+8;p=e*+h[k>>3];k=c[j>>2]|0;c[j>>2]=k+8;h[k>>3]=p;c[o>>2]=(c[o>>2]|0)+-1}i=g;return}function Xs(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0;f=i;i=i+32|0;g=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[g>>2]=(c[g>>2]|0)+(c[j>>2]<<3);c[l>>2]=(c[l>>2]|0)+(c[j>>2]<<3);c[m>>2]=(c[k>>2]|0)-(c[j>>2]|0)+1;while(1){if(!(c[m>>2]|0))break;j=c[l>>2]|0;c[l>>2]=j+8;n=+h[j>>3];j=c[g>>2]|0;c[g>>2]=j+8;h[j>>3]=n;c[m>>2]=(c[m>>2]|0)+-1}i=f;return}function Ys(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+48|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[k>>2]|0))break;h[q>>3]=0.0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[l>>2]|0))break;h[q>>3]=+h[q>>3]+ +h[(c[(c[j>>2]|0)+(c[o>>2]<<2)>>2]|0)+(c[p>>2]<<3)>>3]*+h[(c[m>>2]|0)+(c[p>>2]<<3)>>3];c[p>>2]=(c[p>>2]|0)+1}h[(c[n>>2]|0)+(c[o>>2]<<3)>>3]=+h[q>>3];c[o>>2]=(c[o>>2]|0)+1}i=g;return}function Zs(a,b,d,e,f,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+64|0;l=k+48|0;m=k+44|0;n=k+40|0;o=k+36|0;p=k+32|0;q=k+28|0;r=k;s=k+24|0;t=k+20|0;u=k+16|0;v=k+12|0;w=k+8|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=j;c[w>>2]=c[c[q>>2]>>2];if(c[w>>2]|0){c[v>>2]=Q4(c[c[w>>2]>>2]|0,(_(c[n>>2]|0,c[p>>2]|0)|0)<<2)|0;j=Q4(c[w>>2]|0,c[n>>2]<<2)|0;c[w>>2]=j;c[c[q>>2]>>2]=j}else{c[v>>2]=N4((_(c[n>>2]|0,c[p>>2]|0)|0)<<2)|0;j=N4(c[n>>2]<<2)|0;c[w>>2]=j;c[c[q>>2]>>2]=j}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;c[(c[w>>2]|0)+(c[s>>2]<<2)>>2]=c[v>>2];c[v>>2]=(c[v>>2]|0)+(c[p>>2]<<2);c[s>>2]=(c[s>>2]|0)+1}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[p>>2]|0))break;h[r>>3]=0.0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[o>>2]|0))break;h[r>>3]=+h[r>>3]+ +h[(c[(c[l>>2]|0)+(c[s>>2]<<2)>>2]|0)+(c[u>>2]<<3)>>3]*+g[(c[(c[m>>2]|0)+(c[u>>2]<<2)>>2]|0)+(c[t>>2]<<2)>>2];c[u>>2]=(c[u>>2]|0)+1}g[(c[(c[w>>2]|0)+(c[s>>2]<<2)>>2]|0)+(c[t>>2]<<2)>>2]=+h[r>>3];c[t>>2]=(c[t>>2]|0)+1}c[s>>2]=(c[s>>2]|0)+1}i=k;return}function _s(a,b,d,e,f,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+64|0;l=k+48|0;m=k+44|0;n=k+40|0;o=k+36|0;p=k+32|0;q=k+28|0;r=k+24|0;s=k+20|0;t=k+16|0;u=k+12|0;v=k+8|0;w=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=j;c[r>>2]=c[c[q>>2]>>2];if(c[r>>2]|0){c[s>>2]=Q4(c[c[r>>2]>>2]|0,(_(c[n>>2]|0,c[p>>2]|0)|0)<<3)|0;j=Q4(c[r>>2]|0,c[n>>2]<<2)|0;c[r>>2]=j;c[c[q>>2]>>2]=j}else{c[s>>2]=N4((_(c[n>>2]|0,c[p>>2]|0)|0)<<3)|0;j=N4(c[n>>2]<<2)|0;c[r>>2]=j;c[c[q>>2]>>2]=j}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[n>>2]|0))break;c[(c[r>>2]|0)+(c[t>>2]<<2)>>2]=c[s>>2];c[s>>2]=(c[s>>2]|0)+(c[p>>2]<<3);c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[n>>2]|0))break;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[p>>2]|0))break;h[w>>3]=0.0;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[o>>2]|0))break;h[w>>3]=+h[w>>3]+ +h[(c[(c[l>>2]|0)+(c[t>>2]<<2)>>2]|0)+(c[v>>2]<<3)>>3]*+g[(c[(c[m>>2]|0)+(c[v>>2]<<2)>>2]|0)+(c[u>>2]<<2)>>2];c[v>>2]=(c[v>>2]|0)+1}h[(c[(c[r>>2]|0)+(c[t>>2]<<2)>>2]|0)+(c[u>>2]<<3)>>3]=+h[w>>3];c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}i=k;return}function $s(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+64|0;k=j+56|0;l=j+52|0;m=j+48|0;n=j+44|0;o=j+40|0;p=j+36|0;q=j+32|0;r=j+28|0;s=j+24|0;t=j;u=j+20|0;v=j+16|0;w=j+12|0;x=j+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[x>>2]=c[c[o>>2]>>2];if(c[x>>2]|0){c[p>>2]=Q4(c[c[x>>2]>>2]|0,(_(c[m>>2]|0,c[n>>2]|0)|0)*20|0)|0;f=Q4(c[x>>2]|0,c[m>>2]<<2)|0;c[x>>2]=f;c[c[o>>2]>>2]=f}else{c[p>>2]=N4((_(c[m>>2]|0,c[n>>2]|0)|0)*20|0)|0;f=N4(c[m>>2]<<2)|0;c[x>>2]=f;c[c[o>>2]>>2]=f}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[m>>2]|0))break;c[(c[x>>2]|0)+(c[q>>2]<<2)>>2]=c[p>>2];c[p>>2]=(c[p>>2]|0)+(c[n>>2]<<2);c[q>>2]=(c[q>>2]|0)+1}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[m>>2]|0))break;c[v>>2]=c[(c[k>>2]|0)+((c[q>>2]|0)*20|0)+4>>2];c[u>>2]=c[(c[k>>2]|0)+((c[q>>2]|0)*20|0)+8>>2];c[w>>2]=c[(c[k>>2]|0)+((c[q>>2]|0)*20|0)>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[n>>2]|0))break;h[t>>3]=0.0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[w>>2]|0))break;h[t>>3]=+h[t>>3]+ +g[(c[u>>2]|0)+(c[s>>2]<<2)>>2]*+h[(c[(c[l>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[(c[v>>2]|0)+(c[s>>2]<<2)>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}g[(c[(c[x>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[r>>2]<<2)>>2]=+h[t>>3];c[r>>2]=(c[r>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+1}i=j;return}function at(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;j=d+8|0;k=d;c[e>>2]=a;c[f>>2]=b;h[k>>3]=0.0;c[j>>2]=c[f>>2];c[g>>2]=c[e>>2];while(1){if(!(c[g>>2]|0))break;b=c[j>>2]|0;c[j>>2]=b+8;h[k>>3]=+h[k>>3]+ +h[b>>3];c[g>>2]=(c[g>>2]|0)+-1}h[k>>3]=+h[k>>3]/+(c[e>>2]|0);c[j>>2]=c[f>>2];c[g>>2]=c[e>>2];while(1){if(!(c[g>>2]|0))break;l=+h[k>>3];e=c[j>>2]|0;c[j>>2]=e+8;h[e>>3]=+h[e>>3]-l;c[g>>2]=(c[g>>2]|0)+-1}i=d;return}function bt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0.0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[e>>2]|0))break;j=+((t2()|0)%500|0|0);h[(c[f>>2]|0)+(c[g>>2]<<3)>>3]=j;c[g>>2]=(c[g>>2]|0)+1}at(c[e>>2]|0,c[f>>2]|0);i=d;return}function ct(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;h[p>>3]=0.0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)>>2]|0))break;h[p>>3]=+h[p>>3]+ +g[(c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)+8>>2]|0)+(c[o>>2]<<2)>>2]*+h[(c[l>>2]|0)+(c[(c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)+4>>2]|0)+(c[o>>2]<<2)>>2]<<3)>>3];c[o>>2]=(c[o>>2]|0)+1}h[(c[m>>2]|0)+(c[n>>2]<<3)>>3]=+h[p>>3];c[n>>2]=(c[n>>2]|0)+1}i=f;return}function dt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;h[p>>3]=0.0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[k>>2]|0))break;h[p>>3]=+h[p>>3]+ +g[(c[(c[j>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[o>>2]<<2)>>2]*+h[(c[l>>2]|0)+(c[o>>2]<<3)>>3];c[o>>2]=(c[o>>2]|0)+1}h[(c[m>>2]|0)+(c[n>>2]<<3)>>3]=+h[p>>3];c[n>>2]=(c[n>>2]|0)+1}i=f;return}function et(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;h[(c[l>>2]|0)+(c[m>>2]<<3)>>3]=+h[(c[j>>2]|0)+(c[m>>2]<<3)>>3]-+h[(c[k>>2]|0)+(c[m>>2]<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function ft(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;h[(c[l>>2]|0)+(c[m>>2]<<3)>>3]=+h[(c[j>>2]|0)+(c[m>>2]<<3)>>3]+ +h[(c[k>>2]|0)+(c[m>>2]<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function gt(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f;l=f+12|0;m=f+8|0;c[g>>2]=a;c[j>>2]=b;h[k>>3]=d;c[l>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;h[(c[l>>2]|0)+(c[m>>2]<<3)>>3]=+h[(c[j>>2]|0)+(c[m>>2]<<3)>>3]*+h[k>>3];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function ht(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;h[(c[j>>2]|0)+(c[k>>2]<<3)>>3]=+h[(c[g>>2]|0)+(c[k>>2]<<3)>>3];c[k>>2]=(c[k>>2]|0)+1}i=e;return}function it(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+12|0;k=e+8|0;l=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;h[l>>3]=0.0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;h[l>>3]=+h[l>>3]+ +h[(c[g>>2]|0)+(c[k>>2]<<3)>>3]*+h[(c[j>>2]|0)+(c[k>>2]<<3)>>3];c[k>>2]=(c[k>>2]|0)+1}i=e;return +(+h[l>>3])}function jt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d;j=d+8|0;c[e>>2]=a;c[f>>2]=b;h[g>>3]=-1.e+50;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[e>>2]|0))break;k=+N(+(+h[(c[f>>2]|0)+(c[j>>2]<<3)>>3]));if(k>+h[g>>3])h[g>>3]=+N(+(+h[(c[f>>2]|0)+(c[j>>2]<<3)>>3]));c[j>>2]=(c[j>>2]|0)+1}i=d;return +(+h[g>>3])}function kt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+48|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[k>>2]|0))break;h[q>>3]=0.0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[l>>2]|0))break;h[q>>3]=+h[q>>3]+ +h[(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)+(c[o>>2]<<3)>>3]*+h[(c[m>>2]|0)+(c[p>>2]<<3)>>3];c[p>>2]=(c[p>>2]|0)+1}h[(c[n>>2]|0)+(c[o>>2]<<3)>>3]=+h[q>>3];c[o>>2]=(c[o>>2]|0)+1}i=g;return}function lt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0.0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;g[k>>2]=0.0;c[j>>2]=c[f>>2];c[h>>2]=c[e>>2];while(1){if(!(c[h>>2]|0))break;b=c[j>>2]|0;c[j>>2]=b+4;g[k>>2]=+g[k>>2]+ +g[b>>2];c[h>>2]=(c[h>>2]|0)+-1}g[k>>2]=+g[k>>2]/+(c[e>>2]|0);c[j>>2]=c[f>>2];c[h>>2]=c[e>>2];while(1){if(!(c[h>>2]|0))break;l=+g[k>>2];e=c[j>>2]|0;c[j>>2]=e+4;g[e>>2]=+g[e>>2]-l;c[h>>2]=(c[h>>2]|0)+-1}i=d;return}function mt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;g[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=0.0;c[m>>2]=(c[m>>2]|0)+1}c[o>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;g[q>>2]=0.0;g[p>>2]=+g[(c[k>>2]|0)+(c[m>>2]<<2)>>2];e=c[o>>2]|0;c[o>>2]=e+1;g[q>>2]=+g[q>>2]+ +g[(c[h>>2]|0)+(e<<2)>>2]*+g[p>>2];c[n>>2]=(c[m>>2]|0)+1;while(1){if((c[n>>2]|0)>=(c[j>>2]|0))break;g[q>>2]=+g[q>>2]+ +g[(c[h>>2]|0)+(c[o>>2]<<2)>>2]*+g[(c[k>>2]|0)+(c[n>>2]<<2)>>2];e=(c[l>>2]|0)+(c[n>>2]<<2)|0;g[e>>2]=+g[e>>2]+ +g[(c[h>>2]|0)+(c[o>>2]<<2)>>2]*+g[p>>2];c[n>>2]=(c[n>>2]|0)+1;c[o>>2]=(c[o>>2]|0)+1}e=(c[l>>2]|0)+(c[m>>2]<<2)|0;g[e>>2]=+g[e>>2]+ +g[q>>2];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function nt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[h>>2]|0))break;g[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=+g[(c[j>>2]|0)+(c[m>>2]<<2)>>2]-+g[(c[k>>2]|0)+(c[m>>2]<<2)>>2];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function ot(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[h>>2]|0))break;g[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=+g[(c[j>>2]|0)+(c[m>>2]<<2)>>2]+ +g[(c[k>>2]|0)+(c[m>>2]<<2)>>2];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function pt(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;g[k>>2]=d;c[l>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[h>>2]|0))break;g[(c[j>>2]|0)+(c[m>>2]<<2)>>2]=+g[(c[j>>2]|0)+(c[m>>2]<<2)>>2]+ +g[k>>2]*+g[(c[l>>2]|0)+(c[m>>2]<<2)>>2];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function qt(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;g[k>>2]=d;c[l>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[h>>2]|0))break;g[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=+g[(c[j>>2]|0)+(c[m>>2]<<2)>>2]*+g[k>>2];c[m>>2]=(c[m>>2]|0)+1}i=f;return}function rt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;g[(c[j>>2]|0)+(c[k>>2]<<2)>>2]=+g[(c[h>>2]|0)+(c[k>>2]<<2)>>2];c[k>>2]=(c[k>>2]|0)+1}i=e;return}function st(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e;c[f>>2]=a;c[j>>2]=b;c[k>>2]=d;h[m>>3]=0.0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[f>>2]|0))break;h[m>>3]=+h[m>>3]+ +g[(c[j>>2]|0)+(c[l>>2]<<2)>>2]*+g[(c[k>>2]|0)+(c[l>>2]<<2)>>2];c[l>>2]=(c[l>>2]|0)+1}i=e;return +(+h[m>>3])}function tt(a,b,d){a=a|0;b=+b;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e;j=e+12|0;k=e+8|0;c[f>>2]=a;h[g>>3]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;h[(c[j>>2]|0)+(c[k>>2]<<3)>>3]=+h[g>>3];c[k>>2]=(c[k>>2]|0)+1}i=e;return}function ut(a,b,d){a=a|0;b=+b;d=d|0;var e=0,f=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;g[h>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;g[(c[j>>2]|0)+(c[k>>2]<<2)>>2]=+g[h>>2];c[k>>2]=(c[k>>2]|0)+1}i=e;return}function vt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0.0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;g[j>>2]=-1000000015047466219876688.0e6;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[e>>2]|0))break;k=+N(+(+g[(c[f>>2]|0)+(c[h>>2]<<2)>>2]));if(k>+g[j>>2])g[j>>2]=+N(+(+g[(c[f>>2]|0)+(c[h>>2]<<2)>>2]));c[h>>2]=(c[h>>2]|0)+1}i=d;return +(+g[j>>2])}function wt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[e>>2]|0))break;b=(c[f>>2]|0)+(c[h>>2]<<2)|0;g[b>>2]=+g[b>>2]*+g[(c[f>>2]|0)+(c[h>>2]<<2)>>2];c[h>>2]=(c[h>>2]|0)+1}i=d;return}function xt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0.0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[e>>2]|0))break;k=+g[(c[f>>2]|0)+(c[h>>2]<<2)>>2];g[j>>2]=k;if(k!=0.0)g[(c[f>>2]|0)+(c[h>>2]<<2)>>2]=1.0/+g[j>>2];c[h>>2]=(c[h>>2]|0)+1}i=d;return}function yt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0.0;e=i;i=i+32|0;f=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e;n=e+8|0;c[f>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[f>>2]|0))break;o=+g[(c[j>>2]|0)+(c[l>>2]<<2)>>2];g[n>>2]=o;if(o>=0.0){h[m>>3]=+O(+(+g[n>>2]));g[(c[k>>2]|0)+(c[l>>2]<<2)>>2]=+h[m>>3]}c[l>>2]=(c[l>>2]|0)+1}i=e;return}function zt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0,m=0.0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;j=d+12|0;k=d;l=d+8|0;c[e>>2]=a;c[f>>2]=b;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[e>>2]|0))break;m=+g[(c[f>>2]|0)+(c[j>>2]<<2)>>2];g[l>>2]=m;if(m>0.0){h[k>>3]=1.0/+O(+(+g[l>>2]));g[(c[f>>2]|0)+(c[j>>2]<<2)>>2]=+h[k>>3]}c[j>>2]=(c[j>>2]|0)+1}i=d;return}function At(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[c[e>>2]>>2]=0;b=c[f>>2]|0;if(((c[f>>2]|0)>>>0)%4|0)if(!(4%(b>>>0)|0))j=4;else{a=c[f>>2]|0;j=_(a,4/((Dt(c[f>>2]|0,4)|0)>>>0)|0)|0}else j=b;c[(c[e>>2]|0)+8>>2]=j;if(!(c[(c[e>>2]|0)+4>>2]|0)){k=c[e>>2]|0;l=k+4|0;c[l>>2]=0;i=d;return}c[g>>2]=c[(c[e>>2]|0)+4>>2];while(1){if(!(c[g>>2]|0))break;c[h>>2]=c[c[g>>2]>>2];O4(c[(c[g>>2]|0)+4>>2]|0);O4(c[g>>2]|0);c[g>>2]=c[h>>2]}k=c[e>>2]|0;l=k+4|0;c[l>>2]=0;i=d;return}function Bt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;if(c[c[d>>2]>>2]|0){k=c[d>>2]|0;l=c[k>>2]|0;c[f>>2]=l;m=c[f>>2]|0;n=c[m>>2]|0;o=c[d>>2]|0;c[o>>2]=n;p=c[f>>2]|0;i=b;return p|0}c[h>>2]=c[(c[d>>2]|0)+8>>2];c[g>>2]=cK(8)|0;a=cK(_(c[12876]|0,c[h>>2]|0)|0)|0;c[(c[g>>2]|0)+4>>2]=a;c[j>>2]=c[(c[g>>2]|0)+4>>2];c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[12876]|0))break;a=(c[j>>2]|0)+(_(c[e>>2]|0,c[h>>2]|0)|0)|0;Ct(a,c[d>>2]|0);c[e>>2]=(c[e>>2]|0)+1}c[c[g>>2]>>2]=c[(c[d>>2]|0)+4>>2];c[(c[d>>2]|0)+4>>2]=c[g>>2];k=c[d>>2]|0;l=c[k>>2]|0;c[f>>2]=l;m=c[f>>2]|0;n=c[m>>2]|0;o=c[d>>2]|0;c[o>>2]=n;p=c[f>>2]|0;i=b;return p|0}function Ct(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[e>>2]>>2]=c[c[f>>2]>>2];c[c[f>>2]>>2]=c[e>>2];i=d;return}function Dt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){if((c[f>>2]|0)==(c[e>>2]|0))break;if((c[e>>2]|0)<(c[f>>2]|0)){c[f>>2]=(c[f>>2]|0)-(c[e>>2]|0);continue}else{c[e>>2]=(c[e>>2]|0)-(c[f>>2]|0);continue}}i=d;return c[f>>2]|0}function Et(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+64|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f+20|0;r=f;s=f+16|0;t=f+12|0;u=f+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[p>>2]=0;c[q>>2]=bK(c[k>>2]<<3)|0;h[r>>3]=.001;c[s>>2]=0;c[u>>2]=c[(c[j>>2]|0)+8>>2];Ft(c[j>>2]|0,c[k>>2]|0,c[q>>2]|0);bt(c[k>>2]|0,c[l>>2]|0);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;c[s>>2]=(c[s>>2]|0)+(c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)>>2]|0);c[n>>2]=(c[n>>2]|0)+1}c[t>>2]=cK(c[s>>2]<<2)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)+8>>2]=c[t>>2];g[c[t>>2]>>2]=+(0-((c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)>>2]|0)-1)|0);c[o>>2]=1;while(1){if((c[o>>2]|0)>=(c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)>>2]|0))break;g[(c[t>>2]|0)+(c[o>>2]<<2)>>2]=1.0;c[o>>2]=(c[o>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+(c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)>>2]<<2);c[n>>2]=(c[n>>2]|0)+1}if((Rq(c[j>>2]|0,c[l>>2]|0,c[q>>2]|0,c[k>>2]|0,+h[r>>3],c[m>>2]|0)|0)<0)c[p>>2]=1;O4(c[(c[j>>2]|0)+8>>2]|0);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)+8>>2]=c[u>>2];c[u>>2]=(c[u>>2]|0)+(c[(c[j>>2]|0)+((c[n>>2]|0)*20|0)>>2]<<2);c[n>>2]=(c[n>>2]|0)+1}O4(c[q>>2]|0);i=f;return c[p>>2]|0}function Ft(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e;c[f>>2]=a;c[j>>2]=b;c[k>>2]=d;h[n>>3]=0.0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[j>>2]|0))break;h[n>>3]=0.0;if(c[(c[f>>2]|0)+16>>2]|0){c[m>>2]=1;while(1){if((c[m>>2]|0)>=(c[(c[f>>2]|0)+((c[l>>2]|0)*20|0)>>2]|0))break;h[n>>3]=+h[n>>3]+ +g[(c[(c[f>>2]|0)+((c[l>>2]|0)*20|0)+8>>2]|0)+(c[m>>2]<<2)>>2]*+g[(c[(c[f>>2]|0)+((c[l>>2]|0)*20|0)+16>>2]|0)+(c[m>>2]<<2)>>2];c[m>>2]=(c[m>>2]|0)+1}h[(c[k>>2]|0)+(c[l>>2]<<3)>>3]=+h[n>>3]}c[l>>2]=(c[l>>2]|0)+1}i=e;return}function Gt(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;k=k|0;l=l|0;var m=0;m=i;i=i+48|0;c[m+40>>2]=a;c[m+36>>2]=b;c[m+32>>2]=d;c[m+28>>2]=e;c[m+24>>2]=f;c[m+20>>2]=g;h[m>>3]=j;c[m+16>>2]=k;c[m+12>>2]=l;if(c[12934]|0){i=m;return}c[12934]=1;$z(1,131228,m+8|0)|0;i=m;return}function Ht(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;g=i;i=i+64|0;j=g+52|0;k=g+48|0;l=g+44|0;m=g+40|0;n=g+36|0;o=g+32|0;p=g;q=g+28|0;r=g+24|0;s=g+20|0;t=g+16|0;u=g+12|0;v=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=0;c[t>>2]=0;c[u>>2]=0;c[t>>2]=cK(c[n>>2]<<2)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[n>>2]|0))break;f=cK(c[k>>2]<<3)|0;c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]=f;c[q>>2]=(c[q>>2]|0)+1}c[u>>2]=cK(c[n>>2]<<3)|0;c[o>>2]=cK(c[k>>2]<<2)|0;c[v>>2]=cK((_(c[k>>2]|0,c[k>>2]|0)|0)<<3)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[(c[o>>2]|0)+(c[q>>2]<<2)>>2]=c[v>>2];c[v>>2]=(c[v>>2]|0)+(c[k>>2]<<3);c[q>>2]=(c[q>>2]|0)+1}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[r>>2]=0;while(1){if((c[r>>2]|0)>(c[q>>2]|0))break;h[p>>3]=0.0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[l>>2]|0))break;w=+(_(c[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0,c[(c[(c[j>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0)|0);h[p>>3]=+h[p>>3]+w;c[s>>2]=(c[s>>2]|0)+1}w=+h[p>>3];h[(c[(c[o>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[q>>2]<<3)>>3]=w;h[(c[(c[o>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[r>>2]<<3)>>3]=w;c[r>>2]=(c[r>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+1}Ss(c[o>>2]|0,c[k>>2]|0,c[n>>2]|0,c[t>>2]|0,c[u>>2]|0,1)|0;c[r>>2]=0;while(1){v=(c[r>>2]|0)<(c[n>>2]|0);c[q>>2]=0;if(!v)break;while(1){if((c[q>>2]|0)>=(c[l>>2]|0))break;h[p>>3]=0.0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[k>>2]|0))break;h[p>>3]=+h[p>>3]+ +(c[(c[(c[j>>2]|0)+(c[s>>2]<<2)>>2]|0)+(c[q>>2]<<2)>>2]|0)*+h[(c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}h[(c[(c[m>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[q>>2]<<3)>>3]=+h[p>>3];c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}while(1){if((c[q>>2]|0)>=(c[n>>2]|0))break;O4(c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]|0);c[q>>2]=(c[q>>2]|0)+1}O4(c[t>>2]|0);O4(c[u>>2]|0);O4(c[c[o>>2]>>2]|0);O4(c[o>>2]|0);i=g;return}function It(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=0;c[n>>2]=0;Mx(c[c[g>>2]>>2]|0,c[j>>2]|0,_(c[12935]|0,c[j>>2]|0)|0,l);$s(c[l>>2]|0,c[g>>2]|0,c[j>>2]|0,c[h>>2]|0,m);_s(c[g>>2]|0,c[m>>2]|0,c[h>>2]|0,c[j>>2]|0,c[h>>2]|0,n);O4(c[c[m>>2]>>2]|0);O4(c[m>>2]|0);m=(Ss(c[n>>2]|0,c[h>>2]|0,1,k,f,1)|0)&255;i=f;return m|0}function Jt(){c[12936]=0;O4(c[12937]|0);O4(c[12938]|0);O4(c[12939]|0);c[12937]=0;c[12938]=0;c[12939]=0;return}function Kt(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[d>>2]|0)+36>>2]|0);i=b;return}function Lt(b,d,e,f){b=b|0;d=d|0;e=+e;f=+f;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+160|0;k=j+120|0;l=j+156|0;m=j+152|0;n=j+148|0;o=j+144|0;p=j+140|0;q=j+136|0;r=j+132|0;s=j+128|0;t=j+124|0;u=j+88|0;v=j+72|0;w=j+64|0;x=j+48|0;y=j+32|0;z=j+16|0;A=j;c[m>>2]=b;c[n>>2]=d;g[o>>2]=e;g[p>>2]=f;a:do if(c[(c[(c[n>>2]|0)+8>>2]|0)+212>>2]|0){c[r>>2]=4;h[v>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+32>>3]/2.0+ +g[o>>2];h[v+8>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+40>>3]/2.0+ +g[p>>2];c[(c[m>>2]|0)+40>>2]=1;c[s>>2]=cK(c[r>>2]<<4)|0;h[c[s>>2]>>3]=+h[v>>3];h[(c[s>>2]|0)+8>>3]=+h[v+8>>3];h[(c[s>>2]|0)+16>>3]=-+h[v>>3];h[(c[s>>2]|0)+16+8>>3]=+h[v+8>>3];h[(c[s>>2]|0)+32>>3]=-+h[v>>3];h[(c[s>>2]|0)+32+8>>3]=-+h[v+8>>3];h[(c[s>>2]|0)+48>>3]=+h[v>>3];h[(c[s>>2]|0)+48+8>>3]=-+h[v+8>>3]}else switch(dM(c[n>>2]|0)|0){case 1:{c[t>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2];c[r>>2]=c[(c[t>>2]|0)+8>>2];if((a[c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]>>0]|0)==(a[147668]|0)?(J3(c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]|0,147668)|0)==0:0)c[(c[m>>2]|0)+40>>2]=1;else B=7;do if((B|0)==7){if(((a[c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]>>0]|0)==(a[143162]|0)?(J3(c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]|0,143162)|0)==0:0)?(Ot(c[(c[t>>2]|0)+44>>2]|0,c[r>>2]|0)|0)!=0:0){c[(c[m>>2]|0)+40>>2]=1;break}if((c[(c[t>>2]|0)+8>>2]|0)<3?(c[c[t>>2]>>2]|0)!=0:0){c[(c[m>>2]|0)+40>>2]=2;break}c[(c[m>>2]|0)+40>>2]=0}while(0);if((c[r>>2]|0)<3){c[s>>2]=Pt(c[n>>2]|0,r,+g[o>>2],+g[p>>2])|0;break a}c[s>>2]=cK(c[r>>2]<<4)|0;if((c[(c[m>>2]|0)+40>>2]|0)==1){h[c[s>>2]>>3]=+h[c[(c[t>>2]|0)+44>>2]>>3]/72.0+ +g[o>>2];h[(c[s>>2]|0)+8>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+8>>3]/72.0+ +g[p>>2];h[(c[s>>2]|0)+16>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+16>>3]/72.0-+g[o>>2];h[(c[s>>2]|0)+16+8>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+16+8>>3]/72.0+ +g[p>>2];h[(c[s>>2]|0)+32>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+32>>3]/72.0-+g[o>>2];h[(c[s>>2]|0)+32+8>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+32+8>>3]/72.0-+g[p>>2];h[(c[s>>2]|0)+48>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+48>>3]/72.0+ +g[o>>2];h[(c[s>>2]|0)+48+8>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+48+8>>3]/72.0-+g[p>>2];break a}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[r>>2]|0))break a;h[w>>3]=+O(+(+h[(c[(c[t>>2]|0)+44>>2]|0)+(c[q>>2]<<4)>>3]*+h[(c[(c[t>>2]|0)+44>>2]|0)+(c[q>>2]<<4)>>3]+ +h[(c[(c[t>>2]|0)+44>>2]|0)+(c[q>>2]<<4)+8>>3]*+h[(c[(c[t>>2]|0)+44>>2]|0)+(c[q>>2]<<4)+8>>3]));h[(c[s>>2]|0)+(c[q>>2]<<4)>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+(c[q>>2]<<4)>>3]*(+g[o>>2]/+h[w>>3]+1.0);h[(c[s>>2]|0)+(c[q>>2]<<4)+8>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+(c[q>>2]<<4)+8>>3]*(+g[p>>2]/+h[w>>3]+1.0);h[(c[s>>2]|0)+(c[q>>2]<<4)>>3]=+h[(c[s>>2]|0)+(c[q>>2]<<4)>>3]/72.0;h[(c[s>>2]|0)+(c[q>>2]<<4)+8>>3]=+h[(c[s>>2]|0)+(c[q>>2]<<4)+8>>3]/72.0;c[q>>2]=(c[q>>2]|0)+1}break}case 2:{c[r>>2]=4;c[s>>2]=cK(c[r>>2]<<4)|0;d=(c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0)+16|0;c[u>>2]=c[d>>2];c[u+4>>2]=c[d+4>>2];c[u+8>>2]=c[d+8>>2];c[u+12>>2]=c[d+12>>2];c[u+16>>2]=c[d+16>>2];c[u+20>>2]=c[d+20>>2];c[u+24>>2]=c[d+24>>2];c[u+28>>2]=c[d+28>>2];d=c[s>>2]|0;Qt(x,~~+h[u>>3],~~+h[u+8>>3],-+g[o>>2],-+g[p>>2]);c[d>>2]=c[x>>2];c[d+4>>2]=c[x+4>>2];c[d+8>>2]=c[x+8>>2];c[d+12>>2]=c[x+12>>2];d=(c[s>>2]|0)+16|0;Qt(y,~~+h[u+16>>3],~~+h[u+8>>3],+g[o>>2],-+g[p>>2]);c[d>>2]=c[y>>2];c[d+4>>2]=c[y+4>>2];c[d+8>>2]=c[y+8>>2];c[d+12>>2]=c[y+12>>2];d=(c[s>>2]|0)+32|0;Qt(z,~~+h[u+16>>3],~~+h[u+16+8>>3],+g[o>>2],+g[p>>2]);c[d>>2]=c[z>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[d+12>>2]=c[z+12>>2];d=(c[s>>2]|0)+48|0;Qt(A,~~+h[u>>3],~~+h[u+16+8>>3],-+g[o>>2],+g[p>>2]);c[d>>2]=c[A>>2];c[d+4>>2]=c[A+4>>2];c[d+8>>2]=c[A+8>>2];c[d+12>>2]=c[A+12>>2];c[(c[m>>2]|0)+40>>2]=1;break a;break}case 3:{c[(c[m>>2]|0)+40>>2]=2;c[s>>2]=Pt(c[n>>2]|0,r,+g[o>>2],+g[p>>2])|0;break a;break}default:{c[k>>2]=c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2];$z(1,131291,k)|0;c[l>>2]=1;C=c[l>>2]|0;i=j;return C|0}}while(0);c[(c[m>>2]|0)+36>>2]=c[s>>2];c[(c[m>>2]|0)+32>>2]=c[r>>2];Rt(c[s>>2]|0,c[r>>2]|0,c[m>>2]|0,(c[m>>2]|0)+16|0);if((c[r>>2]|0)>(c[12936]|0))c[12936]=c[r>>2];c[l>>2]=0;C=c[l>>2]|0;i=j;return C|0}function Mt(b,d,e,f){b=b|0;d=d|0;e=+e;f=+f;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=i;i=i+160|0;k=j+112|0;l=j+148|0;m=j+144|0;n=j+140|0;o=j+136|0;p=j+132|0;q=j+128|0;r=j+124|0;s=j+120|0;t=j+116|0;u=j+80|0;v=j+64|0;w=j+48|0;x=j+32|0;y=j+16|0;z=j;c[m>>2]=b;c[n>>2]=d;g[o>>2]=e;g[p>>2]=f;a:do if(c[(c[(c[n>>2]|0)+8>>2]|0)+212>>2]|0){c[r>>2]=4;h[v>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+32>>3]/2.0;h[v+8>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+40>>3]/2.0;c[(c[m>>2]|0)+40>>2]=1;c[s>>2]=cK(c[r>>2]<<4)|0;h[c[s>>2]>>3]=+h[v>>3];h[(c[s>>2]|0)+8>>3]=+h[v+8>>3];h[(c[s>>2]|0)+16>>3]=-+h[v>>3];h[(c[s>>2]|0)+16+8>>3]=+h[v+8>>3];h[(c[s>>2]|0)+32>>3]=-+h[v>>3];h[(c[s>>2]|0)+32+8>>3]=-+h[v+8>>3];h[(c[s>>2]|0)+48>>3]=+h[v>>3];h[(c[s>>2]|0)+48+8>>3]=-+h[v+8>>3]}else switch(dM(c[n>>2]|0)|0){case 1:{c[t>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2];c[r>>2]=c[(c[t>>2]|0)+8>>2];b:do if((c[r>>2]|0)>=3){c[s>>2]=cK(c[r>>2]<<4)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[r>>2]|0))break b;h[(c[s>>2]|0)+(c[q>>2]<<4)>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+(c[q>>2]<<4)>>3]/72.0;h[(c[s>>2]|0)+(c[q>>2]<<4)+8>>3]=+h[(c[(c[t>>2]|0)+44>>2]|0)+(c[q>>2]<<4)+8>>3]/72.0;c[q>>2]=(c[q>>2]|0)+1}}else c[s>>2]=Pt(c[n>>2]|0,r,0.0,0.0)|0;while(0);if((a[c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]>>0]|0)==(a[147668]|0)?(J3(c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]|0,147668)|0)==0:0){c[(c[m>>2]|0)+40>>2]=1;break a}if(((a[c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]>>0]|0)==(a[143162]|0)?(J3(c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2]|0,143162)|0)==0:0)?(Ot(c[s>>2]|0,c[r>>2]|0)|0)!=0:0){c[(c[m>>2]|0)+40>>2]=1;break a}if((c[(c[t>>2]|0)+8>>2]|0)<3?(c[c[t>>2]>>2]|0)!=0:0){c[(c[m>>2]|0)+40>>2]=2;break a}c[(c[m>>2]|0)+40>>2]=0;break a;break}case 2:{c[r>>2]=4;c[s>>2]=cK(c[r>>2]<<4)|0;d=(c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0)+16|0;c[u>>2]=c[d>>2];c[u+4>>2]=c[d+4>>2];c[u+8>>2]=c[d+8>>2];c[u+12>>2]=c[d+12>>2];c[u+16>>2]=c[d+16>>2];c[u+20>>2]=c[d+20>>2];c[u+24>>2]=c[d+24>>2];c[u+28>>2]=c[d+28>>2];d=c[s>>2]|0;St(w,+h[u>>3],+h[u+8>>3]);c[d>>2]=c[w>>2];c[d+4>>2]=c[w+4>>2];c[d+8>>2]=c[w+8>>2];c[d+12>>2]=c[w+12>>2];d=(c[s>>2]|0)+16|0;St(x,+h[u+16>>3],+h[u+8>>3]);c[d>>2]=c[x>>2];c[d+4>>2]=c[x+4>>2];c[d+8>>2]=c[x+8>>2];c[d+12>>2]=c[x+12>>2];d=(c[s>>2]|0)+32|0;St(y,+h[u+16>>3],+h[u+16+8>>3]);c[d>>2]=c[y>>2];c[d+4>>2]=c[y+4>>2];c[d+8>>2]=c[y+8>>2];c[d+12>>2]=c[y+12>>2];d=(c[s>>2]|0)+48|0;St(z,+h[u>>3],+h[u+16+8>>3]);c[d>>2]=c[z>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[d+12>>2]=c[z+12>>2];c[(c[m>>2]|0)+40>>2]=1;break a;break}case 3:{c[(c[m>>2]|0)+40>>2]=2;c[s>>2]=Pt(c[n>>2]|0,r,0.0,0.0)|0;break a;break}default:{c[k>>2]=c[c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]>>2];$z(1,131327,k)|0;c[l>>2]=1;A=c[l>>2]|0;i=j;return A|0}}while(0);if(!(!(+g[o>>2]!=1.0)?!(+g[p>>2]!=1.0):0))Tt(c[s>>2]|0,c[r>>2]|0,+g[o>>2],+g[p>>2]);c[(c[m>>2]|0)+36>>2]=c[s>>2];c[(c[m>>2]|0)+32>>2]=c[r>>2];Rt(c[s>>2]|0,c[r>>2]|0,c[m>>2]|0,(c[m>>2]|0)+16|0);if((c[r>>2]|0)>(c[12936]|0))c[12936]=c[r>>2];c[l>>2]=0;A=c[l>>2]|0;i=j;return A|0}function Nt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+176|0;g=f+136|0;j=f+120|0;k=f+104|0;l=f;m=f+160|0;n=f+156|0;o=f+152|0;p=f+88|0;q=f+72|0;r=f+56|0;s=f+40|0;t=f+32|0;u=f+24|0;v=f+16|0;c[n>>2]=b;c[o>>2]=e;e=c[n>>2]|0;c[j>>2]=c[a>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];Rr(p,j,g);e=(c[n>>2]|0)+16|0;c[j>>2]=c[a>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];Rr(q,j,g);e=c[o>>2]|0;c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];Rr(r,j,g);e=(c[o>>2]|0)+16|0;c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];Rr(s,j,g);c[l>>2]=c[p>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[l+12>>2]=c[p+12>>2];c[k>>2]=c[q>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];c[j>>2]=c[r>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];c[j+12>>2]=c[r+12>>2];c[g>>2]=c[s>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];if(!(Ut(l,k,j,g)|0)){c[m>>2]=0;w=c[m>>2]|0;i=f;return w|0}if((c[(c[n>>2]|0)+40>>2]&1|0)!=0?(c[(c[o>>2]|0)+40>>2]&1|0)!=0:0){c[m>>2]=1;w=c[m>>2]|0;i=f;return w|0}if((c[(c[n>>2]|0)+40>>2]&2|0)!=0?(c[(c[o>>2]|0)+40>>2]&2|0)!=0:0){h[t>>3]=+h[(c[n>>2]|0)+16>>3]-+h[c[n>>2]>>3]+ +h[(c[o>>2]|0)+16>>3]-+h[c[o>>2]>>3];h[u>>3]=+h[a>>3]-+h[d>>3];h[v>>3]=+h[a+8>>3]-+h[d+8>>3];if(+h[u>>3]*+h[u>>3]+ +h[v>>3]*+h[v>>3]>+h[t>>3]*+h[t>>3]/4.0){c[m>>2]=0;w=c[m>>2]|0;i=f;return w|0}else{c[m>>2]=1;w=c[m>>2]|0;i=f;return w|0}}if(!(c[12937]|0)){c[12937]=cK(c[12936]<<4)|0;c[12938]=cK(c[12936]<<4)|0}t=c[(c[n>>2]|0)+36>>2]|0;v=c[(c[n>>2]|0)+32>>2]|0;u=c[12937]|0;c[g>>2]=c[a>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];Vt(t,v,g,u);u=c[(c[o>>2]|0)+36>>2]|0;v=c[(c[o>>2]|0)+32>>2]|0;t=c[12938]|0;c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];Vt(u,v,g,t);do if(!(Wt(c[12937]|0,c[12938]|0,c[(c[n>>2]|0)+32>>2]|0,c[(c[o>>2]|0)+32>>2]|0)|0)){t=c[12937]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];c[k+12>>2]=c[t+12>>2];c[j>>2]=c[r>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];c[j+12>>2]=c[r+12>>2];c[g>>2]=c[s>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];if((Xt(k,j,g)|0)!=0?(t=c[12938]|0,v=c[(c[o>>2]|0)+32>>2]|0,u=c[12937]|0,c[g>>2]=c[u>>2],c[g+4>>2]=c[u+4>>2],c[g+8>>2]=c[u+8>>2],c[g+12>>2]=c[u+12>>2],(Yt(t,v,g)|0)!=0):0){x=1;break}v=c[12938]|0;c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[k+12>>2]=c[v+12>>2];c[j>>2]=c[p>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];c[g+12>>2]=c[q+12>>2];if(Xt(k,j,g)|0){v=c[12937]|0;t=c[(c[n>>2]|0)+32>>2]|0;u=c[12938]|0;c[g>>2]=c[u>>2];c[g+4>>2]=c[u+4>>2];c[g+8>>2]=c[u+8>>2];c[g+12>>2]=c[u+12>>2];x=(Yt(v,t,g)|0)!=0}else x=0}else x=1;while(0);c[m>>2]=x&1;w=c[m>>2]|0;i=f;return w|0}function Ot(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)!=4){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}g=c[f>>2]|0;if(+h[(c[f>>2]|0)+8>>3]==+h[(c[f>>2]|0)+16+8>>3]){if(+h[g+32+8>>3]==+h[(c[f>>2]|0)+48+8>>3]?+h[c[f>>2]>>3]==+h[(c[f>>2]|0)+48>>3]:0)k=+h[(c[f>>2]|0)+16>>3]==+h[(c[f>>2]|0)+32>>3];else k=0;c[e>>2]=k&1;j=c[e>>2]|0;i=d;return j|0}if((+h[g>>3]==+h[(c[f>>2]|0)+16>>3]?+h[(c[f>>2]|0)+32>>3]==+h[(c[f>>2]|0)+48>>3]:0)?+h[(c[f>>2]|0)+8>>3]==+h[(c[f>>2]|0)+48+8>>3]:0)l=+h[(c[f>>2]|0)+16+8>>3]==+h[(c[f>>2]|0)+32+8>>3];else l=0;c[e>>2]=l&1;j=c[e>>2]|0;i=d;return j|0}function Pt(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[j>>2]=a;c[k>>2]=b;g[l>>2]=d;g[m>>2]=e;c[n>>2]=0;c[p>>2]=yA(c[j>>2]|0,140333)|0;if(c[p>>2]|0)c[n>>2]=u3(c[p>>2]|0)|0;if((c[n>>2]|0)<3)c[n>>2]=20;c[o>>2]=cK(c[n>>2]<<4)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[n>>2]|0))break;e=(+h[(c[(c[j>>2]|0)+8>>2]|0)+32>>3]/2.0+ +g[l>>2])*+Q(+(+(c[q>>2]|0)/+(c[n>>2]|0)*3.141592653589793*2.0));h[(c[o>>2]|0)+(c[q>>2]<<4)>>3]=e;e=(+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3]/2.0+ +g[m>>2])*+R(+(+(c[q>>2]|0)/+(c[n>>2]|0)*3.141592653589793*2.0));h[(c[o>>2]|0)+(c[q>>2]<<4)+8>>3]=e;c[q>>2]=(c[q>>2]|0)+1}c[c[k>>2]>>2]=c[n>>2];i=f;return c[o>>2]|0}function Qt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=+e;f=+f;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+32|0;k=j+28|0;l=j+24|0;m=j+20|0;n=j+16|0;o=j;c[k>>2]=b;c[l>>2]=d;g[m>>2]=e;g[n>>2]=f;h[o>>3]=+(c[k>>2]|0)/72.0+ +g[m>>2];h[o+8>>3]=+(c[l>>2]|0)/72.0+ +g[n>>2];c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];i=j;return}function Rt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;f=i;i=i+64|0;g=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+24|0;n=f+16|0;o=f+8|0;p=f;q=f+32|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;r=+h[c[g>>2]>>3];h[o>>3]=r;h[m>>3]=r;r=+h[(c[g>>2]|0)+8>>3];h[p>>3]=r;h[n>>3]=r;c[q>>2]=1;while(1){if((c[q>>2]|0)>=(c[j>>2]|0))break;c[g>>2]=(c[g>>2]|0)+16;if(+h[c[g>>2]>>3]<+h[m>>3])h[m>>3]=+h[c[g>>2]>>3];if(+h[(c[g>>2]|0)+8>>3]<+h[n>>3])h[n>>3]=+h[(c[g>>2]|0)+8>>3];if(+h[c[g>>2]>>3]>+h[o>>3])h[o>>3]=+h[c[g>>2]>>3];if(+h[(c[g>>2]|0)+8>>3]>+h[p>>3])h[p>>3]=+h[(c[g>>2]|0)+8>>3];c[q>>2]=(c[q>>2]|0)+1}h[c[k>>2]>>3]=+h[m>>3];h[(c[k>>2]|0)+8>>3]=+h[n>>3];h[c[l>>2]>>3]=+h[o>>3];h[(c[l>>2]|0)+8>>3]=+h[p>>3];i=f;return}function St(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3]/72.0;h[j+8>>3]=+h[g>>3]/72.0;c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function Tt(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[j>>2]=a;c[k>>2]=b;g[l>>2]=d;g[m>>2]=e;c[o>>2]=c[j>>2];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;j=c[o>>2]|0;h[j>>3]=+h[j>>3]*+g[l>>2];j=(c[o>>2]|0)+8|0;h[j>>3]=+h[j>>3]*+g[m>>2];c[o>>2]=(c[o>>2]|0)+16;c[n>>2]=(c[n>>2]|0)+1}i=f;return}function Ut(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;if((+h[a>>3]<=+h[d>>3]?+h[c>>3]<=+h[b>>3]:0)?+h[a+8>>3]<=+h[d+8>>3]:0)e=+h[c+8>>3]<=+h[b+8>>3];else e=0;return e&1|0}function Vt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[j>>2]|0))break;h[c[k>>2]>>3]=+h[c[g>>2]>>3]+ +h[d>>3];h[(c[k>>2]|0)+8>>3]=+h[(c[g>>2]|0)+8>>3]+ +h[d+8>>3];c[g>>2]=(c[g>>2]|0)+16;c[k>>2]=(c[k>>2]|0)+16;c[l>>2]=(c[l>>2]|0)+1}i=f;return}function Wt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+176|0;g=f+104|0;j=f+88|0;k=f+72|0;l=f+56|0;m=f+172|0;n=f+168|0;o=f+164|0;p=f+160|0;q=f+156|0;r=f+152|0;s=f+148|0;t=f+144|0;u=f+140|0;v=f+136|0;w=f+132|0;x=f+40|0;y=f+24|0;z=f+16|0;A=f+128|0;B=f+124|0;C=f;D=f+120|0;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[D>>2]=0;while(1){c[v>>2]=((c[r>>2]|0)+(c[p>>2]|0)-1|0)%(c[p>>2]|0)|0;c[w>>2]=((c[s>>2]|0)+(c[q>>2]|0)-1|0)%(c[q>>2]|0)|0;e=(c[n>>2]|0)+(c[r>>2]<<4)|0;d=(c[n>>2]|0)+(c[v>>2]<<4)|0;c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];Qr(x,j,g);d=(c[o>>2]|0)+(c[s>>2]<<4)|0;e=(c[o>>2]|0)+(c[w>>2]<<4)|0;c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];Qr(y,j,g);c[k>>2]=c[8404];c[k+4>>2]=c[8405];c[k+8>>2]=c[8406];c[k+12>>2]=c[8407];c[j>>2]=c[x>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];c[g>>2]=c[y>>2];c[g+4>>2]=c[y+4>>2];c[g+8>>2]=c[y+8>>2];c[g+12>>2]=c[y+12>>2];h[z>>3]=+Sr(k,j,g);e=(c[n>>2]|0)+(c[v>>2]<<4)|0;d=(c[n>>2]|0)+(c[r>>2]<<4)|0;b=(c[o>>2]|0)+(c[s>>2]<<4)|0;c[k>>2]=c[e>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[A>>2]=Tr(k,j,g)|0;b=(c[o>>2]|0)+(c[w>>2]<<4)|0;d=(c[o>>2]|0)+(c[s>>2]<<4)|0;e=(c[n>>2]|0)+(c[r>>2]<<4)|0;c[k>>2]=c[b>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[B>>2]=Tr(k,j,g)|0;e=(c[n>>2]|0)+(c[v>>2]<<4)|0;d=(c[n>>2]|0)+(c[r>>2]<<4)|0;b=(c[o>>2]|0)+(c[w>>2]<<4)|0;a=(c[o>>2]|0)+(c[s>>2]<<4)|0;c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[g>>2]=c[a>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];if(Ur(l,k,j,g,C)|0){E=3;break}do if(+h[z>>3]!=0.0|(c[A>>2]|0)!=0|(c[B>>2]|0)!=0)if(+h[z>>3]>=0.0)if(c[A>>2]|0){c[t>>2]=(c[t>>2]|0)+1;c[r>>2]=((c[r>>2]|0)+1|0)%(c[p>>2]|0)|0;break}else{c[u>>2]=(c[u>>2]|0)+1;c[s>>2]=((c[s>>2]|0)+1|0)%(c[q>>2]|0)|0;break}else if(c[B>>2]|0){c[u>>2]=(c[u>>2]|0)+1;c[s>>2]=((c[s>>2]|0)+1|0)%(c[q>>2]|0)|0;break}else{c[t>>2]=(c[t>>2]|0)+1;c[r>>2]=((c[r>>2]|0)+1|0)%(c[p>>2]|0)|0;break}else if((c[D>>2]|0)==1){c[u>>2]=(c[u>>2]|0)+1;c[s>>2]=((c[s>>2]|0)+1|0)%(c[q>>2]|0)|0;break}else{c[t>>2]=(c[t>>2]|0)+1;c[r>>2]=((c[r>>2]|0)+1|0)%(c[p>>2]|0)|0;break}while(0);if((c[t>>2]|0)>=(c[p>>2]|0)?(c[u>>2]|0)>=(c[q>>2]|0):0){E=19;break}if((c[t>>2]|0)>=(c[p>>2]<<1|0)){E=19;break}if((c[u>>2]|0)>=(c[q>>2]<<1|0)){E=19;break}}if((E|0)==3){c[m>>2]=1;F=c[m>>2]|0;i=f;return F|0}else if((E|0)==19){c[m>>2]=0;F=c[m>>2]|0;i=f;return F|0}return 0}function Xt(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;if((+h[a>>3]<=+h[c>>3]?+h[a>>3]>=+h[b>>3]:0)?+h[a+8>>3]<=+h[c+8>>3]:0)d=+h[a+8>>3]>=+h[b+8>>3];else d=0;return d&1|0}function Yt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+8|0;n=e;c[g>>2]=a;c[j>>2]=b;h[n>>3]=0.0;if(!(c[12939]|0))c[12939]=cK(c[12936]<<4)|0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0))break;h[(c[12939]|0)+(c[k>>2]<<4)>>3]=+h[(c[g>>2]|0)+(c[k>>2]<<4)>>3]-+h[d>>3];h[(c[12939]|0)+(c[k>>2]<<4)+8>>3]=+h[(c[g>>2]|0)+(c[k>>2]<<4)+8>>3]-+h[d+8>>3];c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;a:while(1){if((c[k>>2]|0)>=(c[j>>2]|0)){o=24;break}c[l>>2]=((c[k>>2]|0)+(c[j>>2]|0)-1|0)%(c[j>>2]|0)|0;if(+h[(c[12939]|0)+(c[k>>2]<<4)+8>>3]==0.0?+h[(c[12939]|0)+(c[l>>2]<<4)+8>>3]==0.0:0){if(+h[(c[12939]|0)+(c[k>>2]<<4)>>3]*+h[(c[12939]|0)+(c[l>>2]<<4)>>3]<0.0){o=11;break}}else o=12;do if((o|0)==12){o=0;if(!(+h[(c[12939]|0)+(c[k>>2]<<4)+8>>3]>=0.0?+h[(c[12939]|0)+(c[l>>2]<<4)+8>>3]<=0.0:0)){if(!(+h[(c[12939]|0)+(c[l>>2]<<4)+8>>3]>=0.0))break;if(!(+h[(c[12939]|0)+(c[k>>2]<<4)+8>>3]<=0.0))break}h[m>>3]=(+h[(c[12939]|0)+(c[k>>2]<<4)>>3]*+h[(c[12939]|0)+(c[l>>2]<<4)+8>>3]-+h[(c[12939]|0)+(c[l>>2]<<4)>>3]*+h[(c[12939]|0)+(c[k>>2]<<4)+8>>3])/(+h[(c[12939]|0)+(c[l>>2]<<4)+8>>3]-+h[(c[12939]|0)+(c[k>>2]<<4)+8>>3]);if(+h[m>>3]==0.0){o=17;break a}if(+h[m>>3]>0.0){if(!(+h[(c[12939]|0)+(c[k>>2]<<4)+8>>3]==0.0)?!(+h[(c[12939]|0)+(c[l>>2]<<4)+8>>3]==0.0):0){h[n>>3]=+h[n>>3]+1.0;break}h[n>>3]=+h[n>>3]+.5}}while(0);c[k>>2]=(c[k>>2]|0)+1}if((o|0)==11){c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}else if((o|0)==17){c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}else if((o|0)==24)if(((~~+h[n>>3]|0)%2|0|0)==1){c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}else{c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}return 0}function Zt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0.0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=cK(c[f>>2]<<2)|0;b=cK((_(c[f>>2]|0,c[f>>2]|0)|0)<<2)|0;c[c[h>>2]>>2]=b;b=_(c[f>>2]|0,c[f>>2]|0)|0;ut(b,0.0,c[c[h>>2]>>2]|0);c[j>>2]=1;while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;b=(c[c[h>>2]>>2]|0)+((_(c[j>>2]|0,c[f>>2]|0)|0)<<2)|0;c[(c[h>>2]|0)+(c[j>>2]<<2)>>2]=b;c[j>>2]=(c[j>>2]|0)+1}c[j>>2]=0;c[l>>2]=0;while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;c[k>>2]=c[j>>2];while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;m=+g[(c[e>>2]|0)+(c[l>>2]<<2)>>2];g[(c[(c[h>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<2)>>2]=m;g[(c[(c[h>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2]=m;c[k>>2]=(c[k>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1}c[j>>2]=(c[j>>2]|0)+1}i=d;return c[h>>2]|0}function _t(b,e,f,j,k,l,m,n){b=b|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=+n;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0.0,la=0.0,ma=0;o=i;i=i+208|0;p=o+188|0;q=o+184|0;r=o+180|0;s=o+176|0;t=o+168|0;u=o+164|0;v=o+160|0;w=o+156|0;x=o+152|0;y=o+148|0;z=o+144|0;A=o+140|0;B=o+136|0;C=o+132|0;D=o+128|0;E=o+124|0;F=o+120|0;G=o+192|0;H=o+116|0;I=o+112|0;J=o+108|0;K=o+104|0;L=o+100|0;M=o+96|0;O=o+92|0;P=o+88|0;Q=o+84|0;R=o+80|0;S=o+76|0;T=o+72|0;U=o+68|0;V=o+64|0;W=o+60|0;X=o+56|0;Y=o+52|0;Z=o+48|0;_=o+44|0;$=o+40|0;aa=o+36|0;ba=o+32|0;ca=o+28|0;da=o+24|0;ea=o+8|0;fa=o;ga=o+20|0;ha=o+16|0;c[q>>2]=b;c[r>>2]=e;c[s>>2]=f;c[o+172>>2]=j;c[t>>2]=k;c[u>>2]=l;c[v>>2]=m;g[w>>2]=n;c[x>>2]=c[(c[s>>2]|0)+(c[t>>2]<<2)>>2];c[A>>2]=c[(c[q>>2]|0)+4>>2];c[B>>2]=c[c[q>>2]>>2];c[C>>2]=c[(c[q>>2]|0)+48>>2];c[D>>2]=c[(c[q>>2]|0)+52>>2];c[E>>2]=c[(c[q>>2]|0)+56>>2];a[G>>0]=0;c[Z>>2]=-1;c[_>>2]=0;if((c[u>>2]|0)<=0){c[p>>2]=0;ia=c[p>>2]|0;i=o;return ia|0}cu(c[x>>2]|0,c[A>>2]|0,c[C>>2]|0,c[D>>2]|0,c[E>>2]|0,+g[w>>2]);c[S>>2]=c[(c[q>>2]|0)+28>>2];c[T>>2]=c[(c[q>>2]|0)+32>>2];c[U>>2]=c[(c[q>>2]|0)+36>>2];c[V>>2]=c[(c[q>>2]|0)+12>>2];c[Y>>2]=c[(c[q>>2]|0)+16>>2];c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[A>>2]|0))break;do if((c[y>>2]|0)>=(c[_>>2]|0)){c[Z>>2]=(c[Z>>2]|0)+1;if((c[Z>>2]|0)==(c[E>>2]|0)){c[_>>2]=c[A>>2];break}else{c[_>>2]=c[(c[D>>2]|0)+(c[Z>>2]<<2)>>2];break}}while(0);c[J>>2]=c[(c[C>>2]|0)+(c[y>>2]<<2)>>2];c[(c[Y>>2]|0)+(c[J>>2]<<2)>>2]=c[Z>>2];c[y>>2]=(c[y>>2]|0)+1}c[aa>>2]=c[(c[q>>2]|0)+40>>2];c[$>>2]=0;while(1){if((c[$>>2]|0)>=(c[u>>2]|0))break;if(!((a[G>>0]|0)!=0^1))break;a[G>>0]=1;g[I>>2]=-1.0e9;c[K>>2]=0;while(1){if((c[K>>2]|0)>=(c[A>>2]|0))break;g[M>>2]=+g[(c[x>>2]|0)+(c[(c[C>>2]|0)+(c[K>>2]<<2)>>2]<<2)>>2];g[ba>>2]=0.0;g[ca>>2]=+g[M>>2];g[(c[aa>>2]|0)+(c[(c[C>>2]|0)+(c[K>>2]<<2)>>2]<<2)>>2]=0.0;c[L>>2]=(c[K>>2]|0)+1;while(1){if((c[L>>2]|0)>=(c[A>>2]|0))break;if((c[(c[Y>>2]|0)+(c[L>>2]<<2)>>2]|0)>(c[(c[Y>>2]|0)+((c[L>>2]|0)-1<<2)>>2]|0)){g[ca>>2]=+g[ca>>2]+ +g[w>>2];g[ba>>2]=+g[ba>>2]+ +g[w>>2]}c[J>>2]=c[(c[C>>2]|0)+(c[L>>2]<<2)>>2];if(+N(+(+g[(c[x>>2]|0)+(c[J>>2]<<2)>>2]-+g[ca>>2]))>1.0e-09)break;g[(c[aa>>2]|0)+(c[J>>2]<<2)>>2]=+g[(c[x>>2]|0)+(c[J>>2]<<2)>>2]-+g[M>>2];c[L>>2]=(c[L>>2]|0)+1}c[y>>2]=c[K>>2];while(1){if((c[y>>2]|0)>=(c[L>>2]|0))break;c[J>>2]=c[(c[C>>2]|0)+(c[y>>2]<<2)>>2];g[F>>2]=-+g[(c[r>>2]|0)+(c[J>>2]<<2)>>2];c[R>>2]=c[(c[B>>2]|0)+(c[J>>2]<<2)>>2];c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[A>>2]|0))break;if((c[z>>2]|0)!=(c[J>>2]|0))g[F>>2]=+g[F>>2]+ +g[(c[R>>2]|0)+(c[z>>2]<<2)>>2]*+g[(c[x>>2]|0)+(c[z>>2]<<2)>>2];c[z>>2]=(c[z>>2]|0)+1}g[(c[S>>2]|0)+(c[J>>2]<<2)>>2]=+g[F>>2]/-+g[(c[R>>2]|0)+(c[J>>2]<<2)>>2]-+g[(c[aa>>2]|0)+(c[J>>2]<<2)>>2];c[y>>2]=(c[y>>2]|0)+1}c[W>>2]=0;c[X>>2]=0;c[y>>2]=c[K>>2];while(1){if((c[y>>2]|0)>=(c[L>>2]|0))break;c[Z>>2]=c[(c[Y>>2]|0)+(c[(c[C>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2];q=c[L>>2]|0;if((c[Z>>2]|0)==(c[E>>2]|0))c[X>>2]=q;else{if((q|0)<(c[(c[D>>2]|0)+(c[Z>>2]<<2)>>2]|0))ja=c[L>>2]|0;else ja=c[(c[D>>2]|0)+(c[Z>>2]<<2)>>2]|0;c[X>>2]=ja}c[z>>2]=c[y>>2];while(1){if((c[z>>2]|0)>=(c[X>>2]|0))break;c[J>>2]=c[(c[C>>2]|0)+(c[z>>2]<<2)>>2];if(+g[(c[S>>2]|0)+(c[J>>2]<<2)>>2]<+g[M>>2]){q=c[J>>2]|0;_=c[W>>2]|0;c[W>>2]=_+1;c[(c[V>>2]|0)+(_<<2)>>2]=q}c[z>>2]=(c[z>>2]|0)+1}c[z>>2]=c[y>>2];while(1){if((c[z>>2]|0)>=(c[X>>2]|0))break;c[J>>2]=c[(c[C>>2]|0)+(c[z>>2]<<2)>>2];if(+g[(c[S>>2]|0)+(c[J>>2]<<2)>>2]==+g[M>>2]){q=c[J>>2]|0;_=c[W>>2]|0;c[W>>2]=_+1;c[(c[V>>2]|0)+(_<<2)>>2]=q}c[z>>2]=(c[z>>2]|0)+1}c[z>>2]=c[y>>2];while(1){if((c[z>>2]|0)>=(c[X>>2]|0))break;c[J>>2]=c[(c[C>>2]|0)+(c[z>>2]<<2)>>2];if(+g[(c[S>>2]|0)+(c[J>>2]<<2)>>2]>+g[M>>2]){q=c[J>>2]|0;_=c[W>>2]|0;c[W>>2]=_+1;c[(c[V>>2]|0)+(_<<2)>>2]=q}c[z>>2]=(c[z>>2]|0)+1}c[y>>2]=c[X>>2]}g[O>>2]=0.0;g[P>>2]=0.0;c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[W>>2]|0))break;c[J>>2]=c[(c[V>>2]|0)+(c[y>>2]<<2)>>2];g[Q>>2]=0.0;c[R>>2]=c[(c[B>>2]|0)+(c[J>>2]<<2)>>2];c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[y>>2]|0))break;g[Q>>2]=+g[Q>>2]-+g[(c[R>>2]|0)+(c[(c[V>>2]|0)+(c[z>>2]<<2)>>2]<<2)>>2];c[z>>2]=(c[z>>2]|0)+1}g[Q>>2]=+g[Q>>2]*2.0;g[O>>2]=(+g[P>>2]*+g[O>>2]+-+g[(c[R>>2]|0)+(c[J>>2]<<2)>>2]*+g[(c[S>>2]|0)+(c[J>>2]<<2)>>2]+ +g[Q>>2]*+g[M>>2])/(+g[P>>2]-+g[(c[R>>2]|0)+(c[J>>2]<<2)>>2]+ +g[Q>>2]);g[(c[T>>2]|0)+(c[y>>2]<<2)>>2]=+g[O>>2];g[P>>2]=+g[P>>2]+(+g[Q>>2]-+g[(c[R>>2]|0)+(c[J>>2]<<2)>>2]);c[y>>2]=(c[y>>2]|0)+1}if((c[W>>2]|0)==(c[A>>2]|0))g[(c[T>>2]|0)+((c[A>>2]|0)-1<<2)>>2]=+g[M>>2];g[O>>2]=0.0;g[P>>2]=0.0;c[y>>2]=(c[W>>2]|0)-1;while(1){if((c[y>>2]|0)<0)break;c[J>>2]=c[(c[V>>2]|0)+(c[y>>2]<<2)>>2];g[Q>>2]=0.0;c[R>>2]=c[(c[B>>2]|0)+(c[J>>2]<<2)>>2];c[z>>2]=(c[y>>2]|0)+1;while(1){if((c[z>>2]|0)>=(c[W>>2]|0))break;g[Q>>2]=+g[Q>>2]-+g[(c[R>>2]|0)+(c[(c[V>>2]|0)+(c[z>>2]<<2)>>2]<<2)>>2];c[z>>2]=(c[z>>2]|0)+1}g[Q>>2]=+g[Q>>2]*2.0;g[O>>2]=(+g[P>>2]*+g[O>>2]+-+g[(c[R>>2]|0)+(c[J>>2]<<2)>>2]*+g[(c[S>>2]|0)+(c[J>>2]<<2)>>2]+ +g[Q>>2]*+g[M>>2])/(+g[P>>2]-+g[(c[R>>2]|0)+(c[J>>2]<<2)>>2]+ +g[Q>>2]);g[(c[U>>2]|0)+(c[y>>2]<<2)>>2]=+g[O>>2];g[P>>2]=+g[P>>2]+(+g[Q>>2]-+g[(c[R>>2]|0)+(c[J>>2]<<2)>>2]);c[y>>2]=(c[y>>2]|0)+-1}if((c[W>>2]|0)==(c[A>>2]|0))g[c[U>>2]>>2]=+g[M>>2];c[da>>2]=-1;h[ea>>3]=0.0;c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[W>>2]|0))break;g[ha>>2]=+g[(c[U>>2]|0)+(c[y>>2]<<2)>>2];if((c[y>>2]|0)>0)ka=+g[(c[T>>2]|0)+((c[y>>2]|0)-1<<2)>>2];else ka=+g[ha>>2];g[ga>>2]=ka;do if(+g[ha>>2]<+g[ga>>2]){q=+g[ga>>2]>+g[M>>2];if(!(+g[ha>>2]<+g[M>>2])){if(!q)break;g[ga>>2]=+g[ha>>2];break}if(q)g[ga>>2]=+g[M>>2];g[ha>>2]=+g[ga>>2]}while(0);n=+((c[W>>2]|0)-(c[y>>2]|0)|0)*+N(+(+g[ha>>2]-+g[M>>2]));h[fa>>3]=n+ +(c[y>>2]|0)*+N(+(+g[ga>>2]-+g[M>>2]));if(+h[fa>>3]>+h[ea>>3]){h[ea>>3]=+h[fa>>3];c[da>>2]=c[y>>2]}c[y>>2]=(c[y>>2]|0)+1}do if((c[da>>2]|0)>=0){g[ha>>2]=+g[(c[U>>2]|0)+(c[da>>2]<<2)>>2];if((c[da>>2]|0)>0)la=+g[(c[T>>2]|0)+((c[da>>2]|0)-1<<2)>>2];else la=+g[ha>>2];g[ga>>2]=la;do if((c[L>>2]|0)<(c[A>>2]|0)){n=+g[(c[x>>2]|0)+(c[(c[C>>2]|0)+(c[L>>2]<<2)>>2]<<2)>>2];if((c[(c[Y>>2]|0)+(c[(c[C>>2]|0)+(c[L>>2]<<2)>>2]<<2)>>2]|0)>(c[(c[Y>>2]|0)+(c[(c[C>>2]|0)+((c[L>>2]|0)-1<<2)>>2]<<2)>>2]|0)){g[H>>2]=n-+g[w>>2]-+g[(c[aa>>2]|0)+(c[(c[V>>2]|0)+((c[W>>2]|0)-1<<2)>>2]<<2)>>2];break}else{g[H>>2]=n-+g[(c[aa>>2]|0)+(c[(c[V>>2]|0)+((c[W>>2]|0)-1<<2)>>2]<<2)>>2];break}}else g[H>>2]=1.0e9;while(0);g[ha>>2]=+g[ha>>2]<+g[H>>2]?+g[ha>>2]:+g[H>>2];g[ga>>2]=+g[ga>>2]>+g[I>>2]?+g[ga>>2]:+g[I>>2];do if(+g[ha>>2]<+g[ga>>2]){q=+g[ga>>2]>+g[M>>2];if(!(+g[ha>>2]<+g[M>>2])){if(!q)break;g[ga>>2]=+g[ha>>2];break}if(q)g[ga>>2]=+g[M>>2];g[ha>>2]=+g[ga>>2]}while(0);c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[da>>2]|0))break;g[(c[x>>2]|0)+(c[(c[V>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]=+g[ga>>2]+ +g[(c[aa>>2]|0)+(c[(c[V>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2];c[y>>2]=(c[y>>2]|0)+1}c[y>>2]=c[da>>2];while(1){if((c[y>>2]|0)>=(c[W>>2]|0))break;g[(c[x>>2]|0)+(c[(c[V>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]=+g[ha>>2]+ +g[(c[aa>>2]|0)+(c[(c[V>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2];c[y>>2]=(c[y>>2]|0)+1}if((c[L>>2]|0)<(c[A>>2]|0)?(c[(c[Y>>2]|0)+(c[(c[C>>2]|0)+(c[L>>2]<<2)>>2]<<2)>>2]|0)>(c[(c[Y>>2]|0)+(c[(c[C>>2]|0)+((c[L>>2]|0)-1<<2)>>2]<<2)>>2]|0):0)g[I>>2]=+g[(c[x>>2]|0)+(c[(c[V>>2]|0)+((c[W>>2]|0)-1<<2)>>2]<<2)>>2]+ +g[w>>2];else g[I>>2]=+g[(c[x>>2]|0)+(c[(c[V>>2]|0)+((c[W>>2]|0)-1<<2)>>2]<<2)>>2];c[y>>2]=c[K>>2];while(1){if((c[y>>2]|0)>=(c[L>>2]|0))break;c[(c[C>>2]|0)+(c[y>>2]<<2)>>2]=c[(c[V>>2]|0)+((c[y>>2]|0)-(c[K>>2]|0)<<2)>>2];c[y>>2]=(c[y>>2]|0)+1}if((d[G>>0]|0)!=0?+N(+(+g[ga>>2]-+g[M>>2]))<.01:0)ma=+N(+(+g[ha>>2]-+g[M>>2]))<.01;else ma=0;a[G>>0]=ma&1}else{if((c[L>>2]|0)<(c[A>>2]|0)?(c[(c[Y>>2]|0)+(c[(c[C>>2]|0)+(c[L>>2]<<2)>>2]<<2)>>2]|0)>(c[(c[Y>>2]|0)+(c[(c[C>>2]|0)+((c[L>>2]|0)-1<<2)>>2]<<2)>>2]|0):0){g[I>>2]=+g[(c[x>>2]|0)+(c[(c[V>>2]|0)+((c[W>>2]|0)-1<<2)>>2]<<2)>>2]+ +g[w>>2];break}g[I>>2]=+g[(c[x>>2]|0)+(c[(c[V>>2]|0)+((c[W>>2]|0)-1<<2)>>2]<<2)>>2]}while(0);c[K>>2]=c[L>>2]}lt(c[A>>2]|0,c[x>>2]|0);bu(c[x>>2]|0,c[A>>2]|0,c[C>>2]|0,c[D>>2]|0,c[E>>2]|0,c[v>>2]|0);c[$>>2]=(c[$>>2]|0)+1}c[p>>2]=c[$>>2];ia=c[p>>2]|0;i=o;return ia|0}function $t(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[c[d>>2]>>2]>>2]|0);O4(c[c[d>>2]>>2]|0);O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[(c[d>>2]|0)+28>>2]|0);O4(c[(c[d>>2]|0)+32>>2]|0);O4(c[(c[d>>2]|0)+36>>2]|0);O4(c[(c[d>>2]|0)+40>>2]|0);O4(c[(c[d>>2]|0)+12>>2]|0);O4(c[(c[d>>2]|0)+16>>2]|0);O4(c[(c[d>>2]|0)+20>>2]|0);O4(c[(c[d>>2]|0)+24>>2]|0);O4(c[d>>2]|0);i=b;return}function au(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[o>>2]=-1;c[p>>2]=0;c[q>>2]=cK(60)|0;c[c[q>>2]>>2]=0;c[(c[q>>2]|0)+4>>2]=c[j>>2];c[(c[q>>2]|0)+48>>2]=c[k>>2];c[(c[q>>2]|0)+52>>2]=c[l>>2];c[(c[q>>2]|0)+56>>2]=c[m>>2];f=Zt(c[h>>2]|0,c[j>>2]|0)|0;c[c[q>>2]>>2]=f;f=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+8>>2]=f;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[q>>2]|0)+4>>2]|0))break;if((c[n>>2]|0)>=(c[p>>2]|0)){c[o>>2]=(c[o>>2]|0)+1;if((c[o>>2]|0)==(c[m>>2]|0))r=c[(c[q>>2]|0)+4>>2]|0;else r=c[(c[l>>2]|0)+(c[o>>2]<<2)>>2]|0;c[p>>2]=r}c[(c[(c[q>>2]|0)+8>>2]|0)+(c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]=c[o>>2];c[n>>2]=(c[n>>2]|0)+1}n=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+28>>2]=n;n=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+32>>2]=n;n=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+36>>2]=n;n=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+40>>2]=n;n=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+12>>2]=n;n=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+16>>2]=n;n=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+20>>2]=n;n=cK(c[j>>2]<<2)|0;c[(c[q>>2]|0)+24>>2]=n;i=g;return c[q>>2]|0}function bu(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+32|0;k=j+24|0;l=j+16|0;m=j+12|0;n=j+8|0;o=j+4|0;p=j;c[k>>2]=a;c[j+20>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=h;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[n>>2]|0))break;g[(c[o>>2]|0)+(c[p>>2]<<2)>>2]=+g[(c[k>>2]|0)+(c[(c[l>>2]|0)+((c[(c[m>>2]|0)+(c[p>>2]<<2)>>2]|0)-1<<2)>>2]<<2)>>2];c[p>>2]=(c[p>>2]|0)+1}i=j;return}function cu(a,b,d,e,f,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=+h;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;j=i;i=i+48|0;k=j+40|0;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;t=j+4|0;u=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;g[p>>2]=h;g[u>>2]=-1.0e9;c[s>>2]=-1;c[t>>2]=0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[l>>2]|0))break;if((c[q>>2]|0)>=(c[t>>2]|0)){c[s>>2]=(c[s>>2]|0)+1;if((c[s>>2]|0)==(c[o>>2]|0))c[t>>2]=c[l>>2];else c[t>>2]=c[(c[n>>2]|0)+(c[s>>2]<<2)>>2];if((c[q>>2]|0)>0)v=+g[(c[k>>2]|0)+(c[(c[m>>2]|0)+((c[q>>2]|0)-1<<2)>>2]<<2)>>2]+ +g[p>>2];else v=-1.0e9;g[u>>2]=v;zs(c[k>>2]|0,c[m>>2]|0,c[q>>2]|0,(c[t>>2]|0)-1|0)}c[r>>2]=c[(c[m>>2]|0)+(c[q>>2]<<2)>>2];if(+g[(c[k>>2]|0)+(c[r>>2]<<2)>>2]<+g[u>>2])g[(c[k>>2]|0)+(c[r>>2]<<2)>>2]=+g[u>>2];c[q>>2]=(c[q>>2]|0)+1}i=j;return}function du(){At(51764,24);c[12944]=0;return}function eu(){return Bt(51764)|0}function fu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+16|0;j=d+8|0;k=d;c[e>>2]=a;c[f>>2]=b;h[j>>3]=+h[c[e>>2]>>3]-+h[c[f>>2]>>3];h[k>>3]=+h[(c[e>>2]|0)+8>>3]-+h[(c[f>>2]|0)+8>>3];h[g>>3]=+O(+(+h[j>>3]*+h[j>>3]+ +h[k>>3]*+h[k>>3]));i=d;return +(+h[g>>3])}function gu(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[(c[d>>2]|0)+16>>2]=c[12944];c[12944]=(c[12944]|0)+1;i=b;return}function hu(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=(c[d>>2]|0)+20|0;c[a>>2]=(c[a>>2]|0)-1;if(c[(c[d>>2]|0)+20>>2]|0){i=b;return}Ct(c[d>>2]|0,51764);i=b;return}function iu(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=(c[d>>2]|0)+20|0;c[a>>2]=(c[a>>2]|0)+1;i=b;return}function ju(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;k=i;i=i+128|0;l=k+116|0;m=k+112|0;n=k+108|0;o=k+104|0;p=k+48|0;q=k+100|0;r=k+96|0;s=k+92|0;t=k+88|0;u=k+84|0;v=k+80|0;w=k+76|0;x=k+40|0;y=k+72|0;z=k+68|0;A=k+64|0;B=k+60|0;C=k+32|0;D=k+56|0;E=k+24|0;F=k+120|0;G=k+16|0;H=k+8|0;I=k;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;h[p>>3]=j;c[t>>2]=0;c[v>>2]=0;c[w>>2]=c[n>>2];c[y>>2]=0;c[z>>2]=c[o>>2];c[A>>2]=cK(c[m>>2]<<2)|0;c[D>>2]=cK(c[m>>2]<<3)|0;c[u>>2]=us(c[l>>2]|0,c[m>>2]|0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[m>>2]|0))break;o=(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)|0;c[o>>2]=c[o>>2]<<8;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}if(!(c[w>>2]|0))La(131360,131368,283,131382);c[y>>2]=cK(c[m>>2]<<3)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;h[(c[y>>2]|0)+(c[r>>2]<<3)>>3]=+h[(c[w>>2]|0)+(c[r>>2]<<3)>>3];c[r>>2]=(c[r>>2]|0)+1}ku(c[y>>2]|0,c[m>>2]|0);h[H>>3]=0.0;h[G>>3]=0.0;c[r>>2]=1;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[r>>2]|0))break;j=1.0/+(c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0)*+N(+(+h[(c[w>>2]|0)+(c[r>>2]<<3)>>3]-+h[(c[w>>2]|0)+(c[s>>2]<<3)>>3]));h[G>>3]=+h[G>>3]+j;j=1.0/+(_(c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0,c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0)|0);J=j*+N(+(+h[(c[w>>2]|0)+(c[r>>2]<<3)>>3]-+h[(c[w>>2]|0)+(c[s>>2]<<3)>>3]));j=J*+N(+(+h[(c[w>>2]|0)+(c[r>>2]<<3)>>3]-+h[(c[w>>2]|0)+(c[s>>2]<<3)>>3]));h[H>>3]=+h[H>>3]+j;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}h[x>>3]=+h[G>>3]/+h[H>>3];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;H=(c[w>>2]|0)+(c[r>>2]<<3)|0;h[H>>3]=+h[H>>3]*+h[x>>3];c[r>>2]=(c[r>>2]|0)+1}lu(c[l>>2]|0,c[m>>2]|0,1,z,+h[p>>3],c[w>>2]|0,c[u>>2]|0);c[v>>2]=cK((_(c[m>>2]|0,c[m>>2]|0)|0)<<2)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;l=(c[v>>2]|0)+((_(c[r>>2]|0,c[m>>2]|0)|0)<<2)|0;c[(c[A>>2]|0)+(c[r>>2]<<2)>>2]=l;g[B>>2]=0.0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[m>>2]|0))break;if((c[s>>2]|0)!=(c[r>>2]|0)){j=-1.0/(+(c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0)*+(c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0));g[(c[(c[A>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]=j;g[B>>2]=+g[B>>2]-j}c[s>>2]=(c[s>>2]|0)+1}g[(c[(c[A>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[r>>2]<<2)>>2]=+g[B>>2];c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=1;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;h[C>>3]=+h[(c[w>>2]|0)+(c[r>>2]<<3)>>3];c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[r>>2]|0))break;h[I>>3]=+(c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0)*+(c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0)-(+h[C>>3]-+h[(c[w>>2]|0)+(c[s>>2]<<3)>>3])*(+h[C>>3]-+h[(c[w>>2]|0)+(c[s>>2]<<3)>>3]);if(+h[I>>3]>0.0)K=~~+O(+(+h[I>>3]));else K=0;c[(c[(c[u>>2]|0)+(c[s>>2]<<2)>>2]|0)+(c[r>>2]<<2)>>2]=K;c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]=K;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;h[C>>3]=+h[(c[z>>2]|0)+(c[r>>2]<<3)>>3];h[(c[D>>2]|0)+(c[r>>2]<<3)>>3]=0.0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[m>>2]|0))break;do if((c[s>>2]|0)!=(c[r>>2]|0)){j=+(c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0)*-+g[(c[(c[A>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2];K=(c[D>>2]|0)+(c[r>>2]<<3)|0;J=+h[K>>3];if(+h[C>>3]>=+h[(c[z>>2]|0)+(c[s>>2]<<3)>>3]){h[K>>3]=J+j;break}else{h[K>>3]=J-j;break}}while(0);c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}a[F>>0]=0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=200)break;if(!((a[F>>0]|0)!=0^1))break;if((Sq(c[A>>2]|0,c[z>>2]|0,c[D>>2]|0,c[m>>2]|0,+h[p>>3],c[m>>2]|0,1)|0)<0){L=51;break}a[F>>0]=1;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;h[C>>3]=+h[(c[z>>2]|0)+(c[r>>2]<<3)>>3];h[E>>3]=0.0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[m>>2]|0))break;do if((c[s>>2]|0)!=(c[r>>2]|0)){j=+(c[(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]|0)*-+g[(c[(c[A>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2];J=+h[E>>3];if(+h[C>>3]>=+h[(c[z>>2]|0)+(c[s>>2]<<3)>>3]){h[E>>3]=J+j;break}else{h[E>>3]=J-j;break}}while(0);c[s>>2]=(c[s>>2]|0)+1}if(+h[E>>3]!=+h[(c[D>>2]|0)+(c[r>>2]<<3)>>3]?+N(+(1.0-+h[E>>3]/+h[(c[D>>2]|0)+(c[r>>2]<<3)>>3]))>1.0e-05:0){a[F>>0]=0;h[(c[D>>2]|0)+(c[r>>2]<<3)>>3]=+h[E>>3]}c[r>>2]=(c[r>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+1}if((L|0)==51){c[t>>2]=1;M=c[u>>2]|0;P=c[M>>2]|0;O4(P);Q=c[u>>2]|0;O4(Q);R=c[A>>2]|0;S=c[R>>2]|0;O4(S);T=c[A>>2]|0;O4(T);U=c[y>>2]|0;O4(U);V=c[D>>2]|0;O4(V);W=c[t>>2]|0;i=k;return W|0}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;L=(c[w>>2]|0)+(c[r>>2]<<3)|0;h[L>>3]=+h[L>>3]/+h[x>>3];L=(c[z>>2]|0)+(c[r>>2]<<3)|0;h[L>>3]=+h[L>>3]/+h[x>>3];c[r>>2]=(c[r>>2]|0)+1}M=c[u>>2]|0;P=c[M>>2]|0;O4(P);Q=c[u>>2]|0;O4(Q);R=c[A>>2]|0;S=c[R>>2]|0;O4(S);T=c[A>>2]|0;O4(T);U=c[y>>2]|0;O4(U);V=c[D>>2]|0;O4(V);W=c[t>>2]|0;i=k;return W|0}function ku(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+8|0;j=d;k=d+16|0;c[e>>2]=a;c[f>>2]=b;h[j>>3]=0.0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;h[j>>3]=+h[j>>3]+ +h[(c[e>>2]|0)+(c[k>>2]<<3)>>3];c[k>>2]=(c[k>>2]|0)+1}h[j>>3]=+h[j>>3]/+(c[f>>2]|0);c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;b=(c[e>>2]|0)+(c[k>>2]<<3)|0;h[b>>3]=+h[b>>3]-+h[j>>3];c[k>>2]=(c[k>>2]|0)+1}h[g>>3]=+Vs(c[e>>2]|0,0,(c[f>>2]|0)-1|0);Ws(c[e>>2]|0,0,(c[f>>2]|0)-1|0,1.0/+h[g>>3],c[e>>2]|0);i=d;return}function lu(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+64|0;l=k+44|0;m=k+40|0;n=k+36|0;o=k;p=k+32|0;q=k+28|0;r=k+24|0;s=k+20|0;t=k+16|0;u=k+12|0;v=k+8|0;c[k+48>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;h[o>>3]=f;c[p>>2]=g;c[q>>2]=j;c[t>>2]=mu(c[q>>2]|0,c[l>>2]|0)|0;c[u>>2]=cK(c[m>>2]<<3)|0;c[v>>2]=0;if(c[p>>2]|0){c[v>>2]=cK(c[l>>2]<<3)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[l>>2]|0))break;h[(c[v>>2]|0)+(c[r>>2]<<3)>>3]=+h[(c[p>>2]|0)+(c[r>>2]<<3)>>3];c[r>>2]=(c[r>>2]|0)+1}ku(c[v>>2]|0,c[l>>2]|0)}nu(c[t>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[u>>2]|0,c[v>>2]|0,+h[o>>3]);c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;c[s>>2]=0;while(1){w=c[r>>2]|0;if((c[s>>2]|0)>=(c[l>>2]|0))break;f=+O(+(+N(+(+h[(c[u>>2]|0)+(w<<3)>>3]))));o=(c[(c[n>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<3)|0;h[o>>3]=+h[o>>3]*f;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=w+1}O4(c[c[t>>2]>>2]|0);O4(c[t>>2]|0);O4(c[u>>2]|0);O4(c[v>>2]|0);i=k;return}function mu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=cK((_(c[f>>2]|0,c[f>>2]|0)|0)<<2)|0;c[l>>2]=cK(c[f>>2]<<2)|0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[f>>2]|0))break;b=(c[k>>2]|0)+((_(c[h>>2]|0,c[f>>2]|0)|0)<<2)|0;c[(c[l>>2]|0)+(c[h>>2]<<2)>>2]=b;c[h>>2]=(c[h>>2]|0)+1}c[m>>2]=pu(c[e>>2]|0,c[f>>2]|0,n)|0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[f>>2]|0))break;c[j>>2]=0;while(1){if((c[j>>2]|0)>(c[h>>2]|0))break;g[(c[(c[l>>2]|0)+(c[h>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2]=-+(c[(c[(c[e>>2]|0)+(c[h>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2]|0)*+(c[(c[(c[e>>2]|0)+(c[h>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2]|0)+ +g[(c[m>>2]|0)+(c[h>>2]<<2)>>2]+ +g[(c[m>>2]|0)+(c[j>>2]<<2)>>2]-+g[n>>2];g[(c[(c[l>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[h>>2]<<2)>>2]=+g[(c[(c[l>>2]|0)+(c[h>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2];c[j>>2]=(c[j>>2]|0)+1}c[h>>2]=(c[h>>2]|0)+1}O4(c[m>>2]|0);i=d;return c[l>>2]|0}function nu(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=i;i=i+112|0;l=k+96|0;m=k+92|0;n=k+88|0;o=k+84|0;p=k+80|0;q=k+76|0;r=k+40|0;s=k+72|0;t=k+68|0;u=k+64|0;v=k+60|0;w=k+56|0;x=k+32|0;y=k+24|0;z=k+16|0;A=k+52|0;B=k+48|0;C=k+8|0;D=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;h[r>>3]=j;c[u>>2]=cK(c[m>>2]<<3)|0;c[v>>2]=cK(c[m>>2]<<3)|0;h[D>>3]=1.0-+h[r>>3];if((c[n>>2]|0)>=(c[m>>2]|0))c[n>>2]=c[m>>2];c[s>>2]=0;a:while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;c[w>>2]=c[(c[o>>2]|0)+(c[s>>2]<<2)>>2];do{c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[m>>2]|0))break;j=+((t2()|0)%100|0|0);h[(c[w>>2]|0)+(c[t>>2]<<3)>>3]=j;c[t>>2]=(c[t>>2]|0)+1}if(c[q>>2]|0){h[z>>3]=-+Ts(c[q>>2]|0,0,(c[m>>2]|0)-1|0,c[w>>2]|0);Us(c[w>>2]|0,0,(c[m>>2]|0)-1|0,+h[z>>3],c[q>>2]|0)}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[s>>2]|0))break;h[z>>3]=-+Ts(c[(c[o>>2]|0)+(c[t>>2]<<2)>>2]|0,0,(c[m>>2]|0)-1|0,c[w>>2]|0);Us(c[w>>2]|0,0,(c[m>>2]|0)-1|0,+h[z>>3],c[(c[o>>2]|0)+(c[t>>2]<<2)>>2]|0);c[t>>2]=(c[t>>2]|0)+1}h[x>>3]=+Vs(c[w>>2]|0,0,(c[m>>2]|0)-1|0)}while(+h[x>>3]<1.0e-10);Ws(c[w>>2]|0,0,(c[m>>2]|0)-1|0,1.0/+h[x>>3],c[w>>2]|0);c[A>>2]=0;do{c[A>>2]=(c[A>>2]|0)+1;Xs(c[v>>2]|0,0,(c[m>>2]|0)-1|0,c[w>>2]|0);ou(c[l>>2]|0,c[m>>2]|0,c[m>>2]|0,c[w>>2]|0,c[u>>2]|0,c[q>>2]|0);Xs(c[w>>2]|0,0,(c[m>>2]|0)-1|0,c[u>>2]|0);c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[s>>2]|0))break;h[z>>3]=-+Ts(c[(c[o>>2]|0)+(c[t>>2]<<2)>>2]|0,0,(c[m>>2]|0)-1|0,c[w>>2]|0);Us(c[w>>2]|0,0,(c[m>>2]|0)-1|0,+h[z>>3],c[(c[o>>2]|0)+(c[t>>2]<<2)>>2]|0);c[t>>2]=(c[t>>2]|0)+1}h[x>>3]=+Vs(c[w>>2]|0,0,(c[m>>2]|0)-1|0);if(+h[x>>3]<1.0e-10)break a;Ws(c[w>>2]|0,0,(c[m>>2]|0)-1|0,1.0/+h[x>>3],c[w>>2]|0);h[y>>3]=+Ts(c[w>>2]|0,0,(c[m>>2]|0)-1|0,c[v>>2]|0);j=+N(+(+h[y>>3]))}while(j<+h[D>>3]);h[(c[p>>2]|0)+(c[s>>2]<<3)>>3]=+h[y>>3]*+h[x>>3];c[s>>2]=(c[s>>2]|0)+1}while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;c[w>>2]=c[(c[o>>2]|0)+(c[s>>2]<<2)>>2];c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[m>>2]|0))break;j=+((t2()|0)%100|0|0);h[(c[w>>2]|0)+(c[t>>2]<<3)>>3]=j;c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[s>>2]|0))break;h[z>>3]=-+Ts(c[(c[o>>2]|0)+(c[t>>2]<<2)>>2]|0,0,(c[m>>2]|0)-1|0,c[w>>2]|0);Us(c[w>>2]|0,0,(c[m>>2]|0)-1|0,+h[z>>3],c[(c[o>>2]|0)+(c[t>>2]<<2)>>2]|0);c[t>>2]=(c[t>>2]|0)+1}h[x>>3]=+Vs(c[w>>2]|0,0,(c[m>>2]|0)-1|0);Ws(c[w>>2]|0,0,(c[m>>2]|0)-1|0,1.0/+h[x>>3],c[w>>2]|0);h[(c[p>>2]|0)+(c[s>>2]<<3)>>3]=0.0;c[s>>2]=(c[s>>2]|0)+1}c[s>>2]=0;while(1){if((c[s>>2]|0)>=((c[n>>2]|0)-1|0))break;c[B>>2]=c[s>>2];h[C>>3]=+h[(c[p>>2]|0)+(c[B>>2]<<3)>>3];c[t>>2]=(c[s>>2]|0)+1;while(1){if((c[t>>2]|0)>=(c[n>>2]|0))break;if(+h[C>>3]<+h[(c[p>>2]|0)+(c[t>>2]<<3)>>3]){c[B>>2]=c[t>>2];h[C>>3]=+h[(c[p>>2]|0)+(c[B>>2]<<3)>>3]}c[t>>2]=(c[t>>2]|0)+1}if((c[B>>2]|0)!=(c[s>>2]|0)){Xs(c[u>>2]|0,0,(c[m>>2]|0)-1|0,c[(c[o>>2]|0)+(c[s>>2]<<2)>>2]|0);Xs(c[(c[o>>2]|0)+(c[s>>2]<<2)>>2]|0,0,(c[m>>2]|0)-1|0,c[(c[o>>2]|0)+(c[B>>2]<<2)>>2]|0);Xs(c[(c[o>>2]|0)+(c[B>>2]<<2)>>2]|0,0,(c[m>>2]|0)-1|0,c[u>>2]|0);h[(c[p>>2]|0)+(c[B>>2]<<3)>>3]=+h[(c[p>>2]|0)+(c[s>>2]<<3)>>3];h[(c[p>>2]|0)+(c[s>>2]<<3)>>3]=+h[C>>3]}c[s>>2]=(c[s>>2]|0)+1}O4(c[u>>2]|0);O4(c[v>>2]|0);i=k;return}function ou(a,b,d,e,f,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+48|0;l=k+44|0;m=k+40|0;n=k+36|0;o=k+32|0;p=k+28|0;q=k+24|0;r=k+20|0;s=k+16|0;t=k+8|0;u=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=j;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;h[t>>3]=0.0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[n>>2]|0))break;h[t>>3]=+h[t>>3]+ +g[(c[(c[l>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]*+h[(c[o>>2]|0)+(c[s>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}h[(c[p>>2]|0)+(c[r>>2]<<3)>>3]=+h[t>>3];c[r>>2]=(c[r>>2]|0)+1}if(!(c[q>>2]|0)){i=k;return}h[u>>3]=-+Ts(c[p>>2]|0,0,(c[m>>2]|0)-1|0,c[q>>2]|0);Us(c[p>>2]|0,0,(c[m>>2]|0)-1|0,+h[u>>3],c[q>>2]|0);i=k;return}function pu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;e=i;i=i+48|0;f=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e+8|0;p=e;c[f>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=cK(c[j>>2]<<2)|0;h[o>>3]=0.0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;h[p>>3]=0.0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[j>>2]|0))break;h[o>>3]=+h[o>>3]+ +(c[(c[(c[f>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<2)>>2]|0)*+(c[(c[(c[f>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<2)>>2]|0);h[p>>3]=+h[p>>3]+ +(c[(c[(c[f>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<2)>>2]|0)*+(c[(c[(c[f>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<2)>>2]|0);c[n>>2]=(c[n>>2]|0)+1}g[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=+h[p>>3]/+(c[j>>2]|0);c[m>>2]=(c[m>>2]|0)+1}q=+h[o>>3]/+(_(c[j>>2]|0,c[j>>2]|0)|0);g[c[k>>2]>>2]=q;i=e;return c[l>>2]|0}function qu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0;f=i;i=i+96|0;g=f+24|0;j=f+92|0;k=f+88|0;l=f+84|0;m=f+80|0;n=f+76|0;o=f+72|0;p=f+16|0;q=f+8|0;r=f;s=f+68|0;t=f+64|0;u=f+60|0;v=f+56|0;w=f+52|0;x=f+48|0;y=f+44|0;z=f+40|0;A=f+36|0;B=f+32|0;C=f+28|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[y>>2]=0;c[B>>2]=_(c[m>>2]|0,c[m>>2]|0)|0;c[n>>2]=cK(c[B>>2]<<3)|0;c[o>>2]=cK(c[m>>2]<<3)|0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[m>>2]|0))break;h[(c[o>>2]|0)+(c[s>>2]<<3)>>3]=+h[(c[l>>2]|0)+(c[s>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[B>>2]|0))break;h[(c[n>>2]|0)+(c[s>>2]<<3)>>3]=+h[(c[j>>2]|0)+(c[s>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}c[A>>2]=(c[m>>2]|0)-1;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[A>>2]|0)){D=25;break}h[p>>3]=0.0;c[t>>2]=c[s>>2];while(1){if((c[t>>2]|0)>=(c[m>>2]|0))break;e=_(c[t>>2]|0,c[m>>2]|0)|0;h[q>>3]=+N(+(+h[(c[j>>2]|0)+(e+(c[s>>2]|0)<<3)>>3]));if(!(+h[q>>3]<+h[p>>3])){c[y>>2]=c[t>>2];h[p>>3]=+h[q>>3]}c[t>>2]=(c[t>>2]|0)+1}if(+h[p>>3]<1.0e-10)break;c[u>>2]=c[s>>2];while(1){E=c[y>>2]|0;if((c[u>>2]|0)>=(c[m>>2]|0))break;e=_(E,c[m>>2]|0)|0;c[C>>2]=e+(c[u>>2]|0);h[q>>3]=+h[(c[j>>2]|0)+(c[C>>2]<<3)>>3];e=_(c[s>>2]|0,c[m>>2]|0)|0;h[(c[j>>2]|0)+(c[C>>2]<<3)>>3]=+h[(c[j>>2]|0)+(e+(c[u>>2]|0)<<3)>>3];e=_(c[s>>2]|0,c[m>>2]|0)|0;h[(c[j>>2]|0)+(e+(c[u>>2]|0)<<3)>>3]=+h[q>>3];c[u>>2]=(c[u>>2]|0)+1}h[q>>3]=+h[(c[l>>2]|0)+(E<<3)>>3];h[(c[l>>2]|0)+(c[y>>2]<<3)>>3]=+h[(c[l>>2]|0)+(c[s>>2]<<3)>>3];h[(c[l>>2]|0)+(c[s>>2]<<3)>>3]=+h[q>>3];c[z>>2]=(c[s>>2]|0)+1;c[t>>2]=c[z>>2];while(1){if((c[t>>2]|0)>=(c[m>>2]|0))break;e=_(c[t>>2]|0,c[m>>2]|0)|0;d=_(c[s>>2]|0,c[m>>2]|0)|0;h[r>>3]=+h[(c[j>>2]|0)+(e+(c[s>>2]|0)<<3)>>3]/+h[(c[j>>2]|0)+(d+(c[s>>2]|0)<<3)>>3];h[(c[l>>2]|0)+(c[t>>2]<<3)>>3]=+h[(c[l>>2]|0)+(c[t>>2]<<3)>>3]-+h[r>>3]*+h[(c[l>>2]|0)+(c[s>>2]<<3)>>3];c[u>>2]=0;while(1){F=c[t>>2]|0;if((c[u>>2]|0)>=(c[m>>2]|0))break;d=_(F,c[m>>2]|0)|0;e=_(c[s>>2]|0,c[m>>2]|0)|0;b=_(c[t>>2]|0,c[m>>2]|0)|0;h[(c[j>>2]|0)+(b+(c[u>>2]|0)<<3)>>3]=+h[(c[j>>2]|0)+(d+(c[u>>2]|0)<<3)>>3]-+h[r>>3]*+h[(c[j>>2]|0)+(e+(c[u>>2]|0)<<3)>>3];c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=F+1}c[s>>2]=(c[s>>2]|0)+1}if((D|0)==25?(D=(_(c[m>>2]|0,c[m>>2]|0)|0)-1|0,!(+N(+(+h[(c[j>>2]|0)+(D<<3)>>3]))<1.0e-10)):0){D=(_(c[m>>2]|0,c[m>>2]|0)|0)-1|0;h[(c[k>>2]|0)+((c[m>>2]|0)-1<<3)>>3]=+h[(c[l>>2]|0)+((c[m>>2]|0)-1<<3)>>3]/+h[(c[j>>2]|0)+(D<<3)>>3];c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[A>>2]|0))break;c[w>>2]=(c[m>>2]|0)-(c[v>>2]|0)-2;h[(c[k>>2]|0)+(c[w>>2]<<3)>>3]=+h[(c[l>>2]|0)+(c[w>>2]<<3)>>3];c[x>>2]=(c[w>>2]|0)+1;c[u>>2]=c[x>>2];while(1){G=+h[(c[k>>2]|0)+(c[w>>2]<<3)>>3];H=_(c[w>>2]|0,c[m>>2]|0)|0;if((c[u>>2]|0)>=(c[m>>2]|0))break;h[(c[k>>2]|0)+(c[w>>2]<<3)>>3]=G-+h[(c[j>>2]|0)+(H+(c[u>>2]|0)<<3)>>3]*+h[(c[k>>2]|0)+(c[u>>2]<<3)>>3];c[u>>2]=(c[u>>2]|0)+1}h[(c[k>>2]|0)+(c[w>>2]<<3)>>3]=G/+h[(c[j>>2]|0)+(H+(c[w>>2]|0)<<3)>>3];c[v>>2]=(c[v>>2]|0)+1}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[m>>2]|0))break;h[(c[l>>2]|0)+(c[s>>2]<<3)>>3]=+h[(c[o>>2]|0)+(c[s>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[B>>2]|0))break;h[(c[j>>2]|0)+(c[s>>2]<<3)>>3]=+h[(c[n>>2]|0)+(c[s>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}O4(c[n>>2]|0);O4(c[o>>2]|0);i=f;return}i3(131397,g)|0;O4(c[n>>2]|0);O4(c[o>>2]|0);i=f;return}function ru(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+96|0;f=e+80|0;g=e+76|0;j=e+72|0;k=e+68|0;l=e+64|0;m=e+60|0;n=e+56|0;o=e+16|0;p=e+88|0;q=e+52|0;r=e+48|0;s=e+44|0;t=e+40|0;u=e+36|0;v=e+32|0;w=e;c[e+84>>2]=b;c[f>>2]=d;Hr();du();$r();c[12940]=Qb[c[f>>2]&7]()|0;cs();c[g>>2]=Qb[c[f>>2]&7]()|0;a:while(1){if(!(Xr()|0)){Yr(w);c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2]}do if(c[g>>2]|0){if((Xr()|0)==0?!(+h[(c[g>>2]|0)+8>>3]<+h[o+8>>3]):0){if(!(+h[(c[g>>2]|0)+8>>3]==+h[o+8>>3]))break;if(!(+h[c[g>>2]>>3]<+h[o>>3]))break}c[q>>2]=hs(c[g>>2]|0)|0;c[r>>2]=js(c[q>>2]|0)|0;c[j>>2]=ms(c[q>>2]|0)|0;c[v>>2]=Ir(c[j>>2]|0,c[g>>2]|0)|0;c[u>>2]=ds(c[v>>2]|0,0)|0;gs(c[q>>2]|0,c[u>>2]|0);d=es(c[q>>2]|0,c[u>>2]|0)|0;c[m>>2]=d;if(d){Wr(c[q>>2]|0);d=c[q>>2]|0;b=c[m>>2]|0;Vr(d,b,+fu(c[m>>2]|0,c[g>>2]|0))}c[q>>2]=c[u>>2];c[u>>2]=ds(c[v>>2]|0,1)|0;gs(c[q>>2]|0,c[u>>2]|0);b=es(c[u>>2]|0,c[r>>2]|0)|0;c[m>>2]=b;if(b){b=c[u>>2]|0;d=c[m>>2]|0;Vr(b,d,+fu(c[m>>2]|0,c[g>>2]|0))}c[g>>2]=Qb[c[f>>2]&7]()|0;continue a}while(0);if(Xr()|0)break;c[q>>2]=Zr()|0;c[s>>2]=ks(c[q>>2]|0)|0;c[r>>2]=js(c[q>>2]|0)|0;c[t>>2]=js(c[r>>2]|0)|0;c[j>>2]=ls(c[q>>2]|0)|0;c[k>>2]=ms(c[r>>2]|0)|0;c[n>>2]=c[(c[q>>2]|0)+20>>2];gu(c[n>>2]|0);Kr(c[(c[q>>2]|0)+8>>2]|0,a[(c[q>>2]|0)+16>>0]|0,c[n>>2]|0);Kr(c[(c[r>>2]|0)+8>>2]|0,a[(c[r>>2]|0)+16>>0]|0,c[n>>2]|0);is(c[q>>2]|0);Wr(c[r>>2]|0);is(c[r>>2]|0);a[p>>0]=0;if(+h[(c[j>>2]|0)+8>>3]>+h[(c[k>>2]|0)+8>>3]){c[l>>2]=c[j>>2];c[j>>2]=c[k>>2];c[k>>2]=c[l>>2];a[p>>0]=1}c[v>>2]=Ir(c[j>>2]|0,c[k>>2]|0)|0;c[u>>2]=ds(c[v>>2]|0,a[p>>0]|0)|0;gs(c[s>>2]|0,c[u>>2]|0);Kr(c[v>>2]|0,1-(a[p>>0]|0)|0,c[n>>2]|0);hu(c[n>>2]|0);d=es(c[s>>2]|0,c[u>>2]|0)|0;c[m>>2]=d;if(d){Wr(c[s>>2]|0);d=c[s>>2]|0;b=c[m>>2]|0;Vr(d,b,+fu(c[m>>2]|0,c[j>>2]|0))}b=es(c[u>>2]|0,c[t>>2]|0)|0;c[m>>2]=b;if(!b)continue;b=c[u>>2]|0;d=c[m>>2]|0;Vr(b,d,+fu(c[m>>2]|0,c[j>>2]|0))}c[q>>2]=js(c[12881]|0)|0;while(1){if((c[q>>2]|0)==(c[12882]|0))break;c[v>>2]=c[(c[q>>2]|0)+8>>2];Jr(c[v>>2]|0);c[q>>2]=js(c[q>>2]|0)|0}i=e;return}function su(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;c[j>>2]=b;c[k>>2]=d;d=(kB(c[j>>2]|0)|0)==1;b=c[j>>2]|0;if(d){c[m>>2]=$B(b)|0;h[c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]>>3]=0.0;h[(c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=0.0;c[g>>2]=c[k>>2];n=c[g>>2]|0;i=e;return n|0}tu(b);if(!(c[k>>2]|0))c[k>>2]=uu(c[j>>2]|0)|0;if(a[138998]|0){b=c[24742]|0;c[f>>2]=wB(c[k>>2]|0)|0;Y2(b,133871,f)|0}c[l>>2]=vu(c[j>>2]|0,c[k>>2]|0)|0;if((c[l>>2]|0)<0){$z(1,131414,e+8|0)|0;c[g>>2]=c[k>>2];n=c[g>>2]|0;i=e;return n|0}else{wu(c[j>>2]|0);xu(c[j>>2]|0,c[k>>2]|0);yu(c[j>>2]|0,c[k>>2]|0);zu(c[j>>2]|0,c[l>>2]|0);c[g>>2]=c[k>>2];n=c[g>>2]|0;i=e;return n|0}return 0}function tu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[f>>2]=kB(c[d>>2]|0)|0;c[g>>2]=_(c[f>>2]|0,c[f>>2]|0)|0;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]=c[g>>2];h[(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0)+32>>3]=10.0;if(Hu(c[d>>2]|0,c[e>>2]|0)|0)c[c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]>>2]=0;else c[c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]>>2]=c[g>>2];c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function uu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[g>>2]=0;c[h>>2]=0;a=(kB(c[e>>2]|0)|0)<=2;j=$B(c[e>>2]|0)|0;if(a){c[d>>2]=j;k=c[d>>2]|0;i=b;return k|0}c[f>>2]=j;while(1){if(!(c[f>>2]|0))break;if(!(c[c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]>>2]|0))Gu(c[e>>2]|0,c[f>>2]|0,0);c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;if((c[c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]>>2]|0)>>>0>(c[h>>2]|0)>>>0){c[h>>2]=c[c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]>>2];c[g>>2]=c[f>>2]}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[d>>2]=c[g>>2];k=c[d>>2]|0;i=b;return k|0}function vu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[k>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2];c[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]=0;c[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]=0;Du(c[f>>2]|0,c[g>>2]|0);c[h>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[h>>2]|0)){l=8;break}if((c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)==(c[k>>2]|0)){l=4;break}if((c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)>>>0>(c[j>>2]|0)>>>0)c[j>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2];c[h>>2]=aC(c[f>>2]|0,c[h>>2]|0)|0}if((l|0)==4){c[e>>2]=-1;m=c[e>>2]|0;i=d;return m|0}else if((l|0)==8){c[e>>2]=c[j>>2];m=c[e>>2]|0;i=d;return m|0}return 0}function wu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;a:do if((c[(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0)>>>0<=0){a=(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2];while(1){if(!(c[f>>2]|0))break a;a=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;c[f>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]}}while(0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function xu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;h[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+24>>3]=6.283185307179586;Cu(c[e>>2]|0,c[f>>2]|0);i=d;return}function yu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;h[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+32>>3]=0.0;Bu(c[e>>2]|0,c[f>>2]|0);i=d;return}function zu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;e=i;i=i+48|0;f=e+8|0;g=e+32|0;j=e+28|0;k=e+24|0;l=e;m=e+20|0;n=e+16|0;c[g>>2]=b;c[j>>2]=d;c[m>>2]=Au(c[g>>2]|0,c[j>>2]|0)|0;if(a[138998]|0){_2(131470,c[24742]|0)|0;c[n>>2]=0;while(1){o=c[24742]|0;if((c[n>>2]|0)>(c[j>>2]|0))break;h[f>>3]=+h[(c[m>>2]|0)+(c[n>>2]<<3)>>3];Y2(o,131489,f)|0;c[n>>2]=(c[n>>2]|0)+1}_2(193392,o)|0}c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;h[l>>3]=+h[(c[m>>2]|0)+(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]<<3)>>3];p=+h[l>>3]*+Q(+(+h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+32>>3]));h[c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]>>3]=p;p=+h[l>>3]*+R(+(+h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+32>>3]));h[(c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=p;c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}O4(c[m>>2]|0);i=e;return}function Au(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;j=e+40|0;k=e+36|0;l=e+52|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e+16|0;q=e+8|0;r=e;c[f>>2]=b;c[g>>2]=d;c[n>>2]=1;c[o>>2]=bK((c[g>>2]|0)+1<<3)|0;h[p>>3]=0.0;d=c[f>>2]|0;b=hO(d,qA(c[(c[f>>2]|0)+48>>2]|0,0,139080,0)|0,0)|0;c[j>>2]=b;a:do if(b)b:while(1){if((c[n>>2]|0)>(c[g>>2]|0))break a;s=+x3(c[j>>2]|0,k);h[r>>3]=s;if(!(s>0.0))break a;h[q>>3]=+h[r>>3]>.02?+h[r>>3]:.02;h[p>>3]=+h[p>>3]+ +h[q>>3];s=+h[p>>3];f=c[n>>2]|0;c[n>>2]=f+1;h[(c[o>>2]|0)+(f<<3)>>3]=s;c[j>>2]=c[k>>2];while(1){f=a[c[j>>2]>>0]|0;a[l>>0]=f;if(!(f<<24>>24))continue b;if((r1(a[l>>0]|0)|0)==0?(a[l>>0]|0)!=58:0)continue b;c[j>>2]=(c[j>>2]|0)+1}}else h[q>>3]=1.0;while(0);c[m>>2]=c[n>>2];while(1){if((c[m>>2]|0)>(c[g>>2]|0))break;h[p>>3]=+h[p>>3]+ +h[q>>3];h[(c[o>>2]|0)+(c[m>>2]<<3)>>3]=+h[p>>3];c[m>>2]=(c[m>>2]|0)+1}i=e;return c[o>>2]|0}function Bu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;j=d+8|0;k=d;c[e>>2]=a;c[f>>2]=b;if(!(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]|0))h[k>>3]=0.0;else h[k>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+32>>3]-+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+24>>3]/2.0;c[j>>2]=TA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;b=c[j>>2]|0;a=c[((c[c[j>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0;c[g>>2]=a;if((a|0)==(c[f>>2]|0)){a=c[j>>2]|0;c[g>>2]=c[((c[c[j>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]}if(((c[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]|0)==(c[f>>2]|0)?!(+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+32>>3]!=10.0):0)?(h[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+32>>3]=+h[k>>3]+ +h[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+24>>3]/2.0,h[k>>3]=+h[k>>3]+ +h[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+24>>3],(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0)>>>0>0):0)Bu(c[e>>2]|0,c[g>>2]|0);c[j>>2]=UA(c[e>>2]|0,c[j>>2]|0,c[f>>2]|0)|0}i=d;return}function Cu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;j=d+8|0;k=d;c[e>>2]=a;c[f>>2]=b;h[k>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+24>>3]/+((c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]|0)>>>0);c[g>>2]=TA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;b=c[g>>2]|0;a=c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0;c[j>>2]=a;if((a|0)==(c[f>>2]|0)){a=c[g>>2]|0;c[j>>2]=c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]}if(((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]|0)==(c[f>>2]|0)?!(+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+24>>3]!=0.0):0)?(h[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+24>>3]=+h[k>>3]*+((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]|0)>>>0),(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0)>>>0>0):0)Cu(c[e>>2]|0,c[j>>2]|0);c[g>>2]=UA(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0)|0}i=d;return}function Du(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=b;c[g>>2]=d;c[k>>2]=qA(c[f>>2]|0,2,139333,0)|0;c[m>>2]=l;c[l+4>>2]=0;c[l>>2]=0;Eu(c[m>>2]|0,c[g>>2]|0);a:while(1){l=Fu(c[m>>2]|0)|0;c[g>>2]=l;if(!l)break;c[n>>2]=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)+1;c[j>>2]=TA(c[f>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))continue a;if(!(((c[k>>2]|0)!=0?(l=a[(zA(c[j>>2]|0,c[k>>2]|0)|0)>>0]|0,(l|0)==(a[176099]|0)):0)?(J3(zA(c[j>>2]|0,c[k>>2]|0)|0,176099)|0)==0:0)){l=c[j>>2]|0;d=c[((c[c[j>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0;c[h>>2]=d;if((d|0)==(c[g>>2]|0)){d=c[j>>2]|0;c[h>>2]=c[((c[c[j>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]}if((c[n>>2]|0)>>>0<(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)>>>0){c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]=c[n>>2];c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]=c[g>>2];d=(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+8|0;c[d>>2]=(c[d>>2]|0)+1;Eu(c[m>>2]|0,c[h>>2]|0)}}c[j>>2]=UA(c[f>>2]|0,c[j>>2]|0,c[g>>2]|0)|0}}i=e;return}function Eu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=bK(8)|0;c[c[g>>2]>>2]=c[f>>2];f=c[g>>2]|0;b=c[e>>2]|0;if(c[(c[e>>2]|0)+4>>2]|0){c[(c[b+4>>2]|0)+4>>2]=f;c[(c[e>>2]|0)+4>>2]=c[g>>2];i=d;return}else{c[b>>2]=f;c[(c[e>>2]|0)+4>>2]=f;i=d;return}}function Fu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;a=c[c[e>>2]>>2]|0;c[f>>2]=a;if(!a){c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}c[g>>2]=c[c[f>>2]>>2];c[c[e>>2]>>2]=c[(c[f>>2]|0)+4>>2];O4(c[f>>2]|0);if(!(c[c[e>>2]>>2]|0))c[(c[e>>2]|0)+4>>2]=0;c[d>>2]=c[g>>2];h=c[d>>2]|0;i=b;return h|0}function Gu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[l>>2]=(c[c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]>>2]|0)+1;c[k>>2]=TA(c[f>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;d=c[k>>2]|0;b=c[((c[c[k>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0;c[j>>2]=b;if((b|0)==(c[g>>2]|0)){b=c[k>>2]|0;c[j>>2]=c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]}if((c[h>>2]|0)!=(c[j>>2]|0)?(c[l>>2]|0)>>>0<(c[c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]>>2]|0)>>>0:0){c[c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]>>2]=c[l>>2];Gu(c[f>>2]|0,c[j>>2]|0,c[g>>2]|0)}c[k>>2]=UA(c[f>>2]|0,c[k>>2]|0,c[g>>2]|0)|0}i=e;return}function Hu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=0;c[h>>2]=TA(c[f>>2]|0,c[g>>2]|0)|0;a:while(1){if(!(c[h>>2]|0)){l=11;break}b=c[h>>2]|0;a=c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0;c[k>>2]=a;if((a|0)==(c[g>>2]|0)){a=c[h>>2]|0;c[k>>2]=c[((c[c[h>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]}do if((c[g>>2]|0)!=(c[k>>2]|0))if(c[j>>2]|0)if((c[j>>2]|0)!=(c[k>>2]|0)){l=8;break a}else break;else{c[j>>2]=c[k>>2];break}while(0);c[h>>2]=UA(c[f>>2]|0,c[h>>2]|0,c[g>>2]|0)|0}if((l|0)==8){c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}else if((l|0)==11){c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}return 0}function Iu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0;b=i;i=i+64|0;d=b+56|0;e=b+52|0;f=b+48|0;g=b+44|0;j=b+40|0;k=b+32|0;l=b;c[d>>2]=a;c[f>>2]=qA(c[d>>2]|0,1,131497,0)|0;c[g>>2]=qA(c[d>>2]|0,0,131497,0)|0;c[j>>2]=qA(c[d>>2]|0,0,131502,0)|0;c[e>>2]=Ju(c[d>>2]|0,c[g>>2]|0,c[f>>2]|0,c[j>>2]|0)|0;h[k>>3]=+h[c[e>>2]>>3];j=(c[e>>2]|0)+16|0;m=+O(+(+h[k>>3]+.1));Tu(l,0.0,0.0,m,+O(+(+h[k>>3]+.1)));c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[j+16>>2]=c[l+16>>2];c[j+20>>2]=c[l+20>>2];c[j+24>>2]=c[l+24>>2];c[j+28>>2]=c[l+28>>2];Ku(c[e>>2]|0);Lu(c[e>>2]|0);Mu(c[e>>2]|0);i=b;return}function Ju(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0;f=i;i=i+64|0;g=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f+20|0;r=f+16|0;s=f+12|0;t=f+8|0;u=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=bK(72)|0;c[q>>2]=0;c[r>>2]=0;c[t>>2]=0;h[u>>3]=0.0;c[(c[m>>2]|0)+60>>2]=0;c[(c[m>>2]|0)+56>>2]=c[g>>2];c[s>>2]=1;while(1){if((c[s>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break;c[n>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[s>>2]<<2)>>2];c[p>>2]=Ju(c[n>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;c[t>>2]=(c[t>>2]|0)+1;h[u>>3]=+h[u>>3]+ +h[c[p>>2]>>3];if(!(c[q>>2]|0))c[q>>2]=c[p>>2];if(c[r>>2]|0)c[(c[r>>2]|0)+52>>2]=c[p>>2];c[r>>2]=c[p>>2];c[s>>2]=(c[s>>2]|0)+1}c[o>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;if(!(c[c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]>>2]|0)){c[p>>2]=Pu(c[o>>2]|0,c[k>>2]|0)|0;c[t>>2]=(c[t>>2]|0)+1;h[u>>3]=+h[u>>3]+ +h[c[p>>2]>>3];if(!(c[q>>2]|0))c[q>>2]=c[p>>2];if(c[r>>2]|0)c[(c[r>>2]|0)+52>>2]=c[p>>2];c[r>>2]=c[p>>2];c[c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]>>2]=c[g>>2]}c[o>>2]=aC(c[g>>2]|0,c[o>>2]|0)|0}c[(c[m>>2]|0)+64>>2]=c[t>>2];if(c[t>>2]|0){h[(c[m>>2]|0)+8>>3]=+h[u>>3];v=+Qu(c[m>>2]|0,c[l>>2]|0);h[c[m>>2]>>3]=v;w=c[q>>2]|0;x=c[m>>2]|0;y=x+48|0;c[y>>2]=w;z=c[m>>2]|0;i=f;return z|0}else{v=+Ru(c[g>>2]|0,c[j>>2]|0);h[c[m>>2]>>3]=v;w=c[q>>2]|0;x=c[m>>2]|0;y=x+48|0;c[y>>2]=w;z=c[m>>2]|0;i=f;return z|0}return 0}function Ku(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;d=i;i=i+256|0;e=d+184|0;f=d+104|0;g=d+72|0;j=d+240|0;k=d+236|0;l=d+232|0;m=d+228|0;n=d+224|0;o=d+220|0;p=d+216|0;q=d+40|0;r=d+32|0;s=d+24|0;t=d+16|0;u=d+8|0;v=d;c[j>>2]=b;if(!(c[(c[j>>2]|0)+64>>2]|0)){i=d;return}c[o>>2]=c[(c[j>>2]|0)+64>>2];c[l>>2]=bK(c[o>>2]<<2)|0;c[p>>2]=c[(c[j>>2]|0)+48>>2];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[o>>2]|0))break;c[(c[l>>2]|0)+(c[n>>2]<<2)>>2]=c[p>>2];c[p>>2]=c[(c[p>>2]|0)+52>>2];c[n>>2]=(c[n>>2]|0)+1}w3(c[l>>2]|0,c[o>>2]|0,4,79);c[m>>2]=bK(c[o>>2]<<3)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[o>>2]|0))break;h[(c[m>>2]|0)+(c[n>>2]<<3)>>3]=+h[c[(c[l>>2]|0)+(c[n>>2]<<2)>>2]>>3];c[n>>2]=(c[n>>2]|0)+1}if(+h[c[j>>2]>>3]==+h[(c[j>>2]|0)+8>>3]){b=c[o>>2]|0;w=c[m>>2]|0;x=(c[j>>2]|0)+16|0;c[e>>2]=c[x>>2];c[e+4>>2]=c[x+4>>2];c[e+8>>2]=c[x+8>>2];c[e+12>>2]=c[x+12>>2];c[e+16>>2]=c[x+16>>2];c[e+20>>2]=c[x+20>>2];c[e+24>>2]=c[x+24>>2];c[e+28>>2]=c[x+28>>2];c[k>>2]=Su(b,w,e)|0}else{h[u>>3]=+h[(c[j>>2]|0)+16+16+8>>3];h[v>>3]=+h[(c[j>>2]|0)+16+16>>3];h[q>>3]=+h[(c[j>>2]|0)+16>>3];h[q+8>>3]=+h[(c[j>>2]|0)+16+8>>3];h[s>>3]=+h[u>>3]-+h[v>>3];h[r>>3]=+O(+(+h[s>>3]*+h[s>>3]+ +h[(c[j>>2]|0)+8>>3]*4.0));h[t>>3]=(+h[u>>3]+ +h[v>>3]-+h[r>>3])/2.0;h[q+16>>3]=+h[v>>3]-+h[t>>3];h[q+16+8>>3]=+h[u>>3]-+h[t>>3];t=c[o>>2]|0;u=c[m>>2]|0;c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];c[e+12>>2]=c[q+12>>2];c[e+16>>2]=c[q+16>>2];c[e+20>>2]=c[q+20>>2];c[e+24>>2]=c[q+24>>2];c[e+28>>2]=c[q+28>>2];c[k>>2]=Su(t,u,e)|0}if(a[138998]|0){e=c[24742]|0;y=+h[(c[j>>2]|0)+16+8>>3];z=+h[(c[j>>2]|0)+16+16>>3];A=+h[(c[j>>2]|0)+16+16+8>>3];h[g>>3]=+h[(c[j>>2]|0)+16>>3];h[g+8>>3]=y;h[g+16>>3]=z;h[g+24>>3]=A;Y2(e,131549,g)|0}c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[o>>2]|0))break;g=(c[(c[l>>2]|0)+(c[n>>2]<<2)>>2]|0)+16|0;e=(c[k>>2]|0)+(c[n>>2]<<5)|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];if(a[138998]|0){e=c[24742]|0;A=+h[(c[k>>2]|0)+(c[n>>2]<<5)>>3]-+h[(c[k>>2]|0)+(c[n>>2]<<5)+16>>3]*.5;z=+h[(c[k>>2]|0)+(c[n>>2]<<5)+8>>3]-+h[(c[k>>2]|0)+(c[n>>2]<<5)+16+8>>3]*.5;y=+h[(c[k>>2]|0)+(c[n>>2]<<5)>>3]+ +h[(c[k>>2]|0)+(c[n>>2]<<5)+16>>3]*.5;B=+h[(c[k>>2]|0)+(c[n>>2]<<5)+8>>3]+ +h[(c[k>>2]|0)+(c[n>>2]<<5)+16+8>>3]*.5;C=+h[(c[k>>2]|0)+(c[n>>2]<<5)+16>>3]*+h[(c[k>>2]|0)+(c[n>>2]<<5)+16+8>>3];D=+h[(c[k>>2]|0)+(c[n>>2]<<5)>>3];E=+h[(c[k>>2]|0)+(c[n>>2]<<5)+8>>3];F=+h[(c[k>>2]|0)+(c[n>>2]<<5)+16>>3];G=+h[(c[k>>2]|0)+(c[n>>2]<<5)+16+8>>3];h[f>>3]=+h[(c[m>>2]|0)+(c[n>>2]<<3)>>3];h[f+8>>3]=A;h[f+16>>3]=z;h[f+24>>3]=y;h[f+32>>3]=B;h[f+40>>3]=C;h[f+48>>3]=D;h[f+56>>3]=E;h[f+64>>3]=F;h[f+72>>3]=G;Y2(e,131566,f)|0}c[n>>2]=(c[n>>2]|0)+1}O4(c[l>>2]|0);O4(c[m>>2]|0);O4(c[k>>2]|0);c[p>>2]=c[(c[j>>2]|0)+48>>2];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[o>>2]|0))break;if(!(c[(c[p>>2]|0)+60>>2]|0))Ku(c[p>>2]|0);c[p>>2]=c[(c[p>>2]|0)+52>>2];c[n>>2]=(c[n>>2]|0)+1}i=d;return}function Lu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0;d=i;i=i+176|0;e=d+112|0;f=d+160|0;g=d+156|0;j=d+152|0;k=d+96|0;l=d+64|0;m=d+32|0;n=d+24|0;o=d+16|0;p=d+8|0;q=d;c[f>>2]=b;b=c[f>>2]|0;if(c[(c[f>>2]|0)+60>>2]|0){r=b+16|0;c[l>>2]=c[r>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[l+12>>2]=c[r+12>>2];c[l+16>>2]=c[r+16>>2];c[l+20>>2]=c[r+20>>2];c[l+24>>2]=c[r+24>>2];c[l+28>>2]=c[r+28>>2];h[k>>3]=+h[l>>3];h[k+8>>3]=+h[l+8>>3];c[j>>2]=c[(c[f>>2]|0)+56>>2];r=(c[(c[j>>2]|0)+8>>2]|0)+16|0;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];c[r+12>>2]=c[k+12>>2];h[(c[(c[j>>2]|0)+8>>2]|0)+32>>3]=+h[l+16>>3]/72.0;h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3]=+h[l+16+8>>3]/72.0;l=c[j>>2]|0;VO(l,c[(c[(qC(c[j>>2]|0)|0)+8>>2]|0)+116>>2]&1);Nu(c[j>>2]|0);if(!(a[138998]|0)){i=d;return}l=c[24742]|0;k=wB(c[j>>2]|0)|0;s=+h[(c[(c[j>>2]|0)+8>>2]|0)+16>>3];t=+h[(c[(c[j>>2]|0)+8>>2]|0)+16+8>>3];u=+h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3];v=+h[(c[(c[j>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[j>>2]|0)+8>>2]|0)+96>>3];c[e>>2]=k;h[e+8>>3]=s;h[e+16>>3]=t;h[e+24>>3]=u;h[e+32>>3]=v;Y2(l,131508,e)|0;i=d;return}c[g>>2]=c[b+48>>2];while(1){if(!(c[g>>2]|0))break;Lu(c[g>>2]|0);c[g>>2]=c[(c[g>>2]|0)+52>>2]}h[n>>3]=+h[(c[f>>2]|0)+16>>3];h[o>>3]=+h[(c[f>>2]|0)+16+8>>3];h[p>>3]=+h[(c[f>>2]|0)+16+16>>3];h[q>>3]=+h[(c[f>>2]|0)+16+16+8>>3];h[m>>3]=+h[n>>3]-+h[p>>3]/2.0;h[m+8>>3]=+h[o>>3]-+h[q>>3]/2.0;h[m+16>>3]=+h[m>>3]+ +h[p>>3];h[m+16+8>>3]=+h[m+8>>3]+ +h[q>>3];q=(c[(c[(c[f>>2]|0)+56>>2]|0)+8>>2]|0)+16|0;c[q>>2]=c[m>>2];c[q+4>>2]=c[m+4>>2];c[q+8>>2]=c[m+8>>2];c[q+12>>2]=c[m+12>>2];c[q+16>>2]=c[m+16>>2];c[q+20>>2]=c[m+20>>2];c[q+24>>2]=c[m+24>>2];c[q+28>>2]=c[m+28>>2];i=d;return}function Mu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+48>>2];c[g>>2]=c[(c[d>>2]|0)+64>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[g>>2]|0))break;Mu(c[e>>2]|0);c[e>>2]=c[(c[e>>2]|0)+52>>2];c[f>>2]=(c[f>>2]|0)+1}O4(c[d>>2]|0);i=b;return}function Nu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+64|0;e=d;f=d+12|0;g=d+16|0;j=d+8|0;c[f>>2]=b;if((c[13827]|0)!=0?(c[j>>2]=zA(c[f>>2]|0,c[13827]|0)|0,(a[c[j>>2]>>0]|0)==0):0){h[e>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+80>>3]*.7;k3(g,131543,e)|0;BA(c[f>>2]|0,c[13827]|0,g)|0}xO(c[f>>2]|0);i=d;return}function Ou(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d;c[f>>2]=a;c[g>>2]=b;h[j>>3]=+h[c[c[f>>2]>>2]>>3]-+h[c[c[g>>2]>>2]>>3];do if(!(+h[j>>3]<0.0))if(+h[j>>3]>0.0){c[e>>2]=-1;break}else{c[e>>2]=0;break}else c[e>>2]=1;while(0);i=d;return c[e>>2]|0}function Pu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0.0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=bK(72)|0;j=+Ru(c[e>>2]|0,c[f>>2]|0);h[c[g>>2]>>3]=j;c[(c[g>>2]|0)+60>>2]=1;c[(c[g>>2]|0)+56>>2]=c[e>>2];i=d;return c[g>>2]|0}function Qu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;d=i;i=i+32|0;e=d+16|0;f=d+28|0;g=d+24|0;j=d+8|0;k=d;c[f>>2]=a;c[g>>2]=b;h[j>>3]=+fO(c[(c[f>>2]|0)+56>>2]|0,c[g>>2]|0,0.0,0.0);if(+h[j>>3]==0.0){h[e>>3]=+h[(c[f>>2]|0)+8>>3];l=+h[e>>3];i=d;return +l}else{h[k>>3]=+h[j>>3]*2.0+ +O(+(+h[(c[f>>2]|0)+8>>3]));h[e>>3]=+h[k>>3]*+h[k>>3];l=+h[e>>3];i=d;return +l}return +(0.0)}function Ru(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d;c[e>>2]=a;c[f>>2]=b;h[g>>3]=+fO(c[e>>2]|0,c[f>>2]|0,1.0,0.0);if(+h[g>>3]==0.0)h[g>>3]=1.0;h[g>>3]=+h[g>>3]*1.0e3;i=d;return +(+h[g>>3])}function Su(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0;e=i;i=i+96|0;f=e+40|0;g=e+92|0;j=e+88|0;k=e+84|0;l=e+80|0;m=e+76|0;n=e+32|0;o=e+24|0;p=e+16|0;q=e+8|0;r=e;s=e+72|0;c[j>>2]=a;c[k>>2]=b;h[n>>3]=0.0;h[o>>3]=1.0;h[p>>3]=0.0;h[q>>3]=1.0;h[r>>3]=0.0;c[s>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;h[n>>3]=+h[n>>3]+ +h[(c[k>>2]|0)+(c[m>>2]<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}if(+h[n>>3]>+h[d+16>>3]*+h[d+16+8>>3]+.001){c[g>>2]=0;t=c[g>>2]|0;i=e;return t|0}else{c[l>>2]=bK(c[j>>2]<<5)|0;n=c[j>>2]|0;j=c[k>>2]|0;k=c[l>>2]|0;m=c[s>>2]|0;u=+h[p>>3];v=+h[o>>3];w=+h[r>>3];x=+h[q>>3];c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[f+16>>2]=c[d+16>>2];c[f+20>>2]=c[d+20>>2];c[f+24>>2]=c[d+24>>2];c[f+28>>2]=c[d+28>>2];Uu(n,j,k,m,u,v,w,x,f);c[g>>2]=c[l>>2];t=c[g>>2]|0;i=e;return t|0}return 0}function Tu(a,b,d,e,f){a=a|0;b=+b;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+64|0;j=g+56|0;k=g+48|0;l=g+40|0;m=g+32|0;n=g;h[j>>3]=b;h[k>>3]=d;h[l>>3]=e;h[m>>3]=f;h[n>>3]=+h[j>>3];h[n+8>>3]=+h[k>>3];h[n+16>>3]=+h[l>>3];h[n+16+8>>3]=+h[m>>3];c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];c[a+16>>2]=c[n+16>>2];c[a+20>>2]=c[n+20>>2];c[a+24>>2]=c[n+24>>2];c[a+28>>2]=c[n+28>>2];i=g;return}function Uu(b,d,e,f,g,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;k=+k;l=+l;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0;n=i;i=i+256|0;o=n+200|0;p=n+168|0;q=n+160|0;r=n+128|0;s=n+248|0;t=n+244|0;u=n+240|0;v=n+236|0;w=n+120|0;x=n+112|0;y=n+104|0;z=n+96|0;A=n+88|0;B=n+232|0;C=n+80|0;D=n+72|0;E=n+64|0;F=n+56|0;G=n+48|0;H=n+40|0;I=n+32|0;J=n+24|0;K=n+16|0;L=n+8|0;M=n;c[s>>2]=b;c[t>>2]=d;c[u>>2]=e;c[v>>2]=f;h[w>>3]=g;h[x>>3]=j;h[y>>3]=k;h[z>>3]=l;f=m+16|0;h[A>>3]=+h[m+16>>3]<+h[m+16+8>>3]?+h[f>>3]:+h[f+8>>3];if((c[s>>2]|0)<=0){i=n;return}if(a[138998]|0){f=c[24742]|0;l=+h[m+16>>3];k=+h[m+8>>3];j=+h[m+16+8>>3];h[r>>3]=+h[m>>3];h[r+8>>3]=l;h[r+16>>3]=k;h[r+24>>3]=j;Y2(f,131603,r)|0;r=c[24742]|0;c[q>>2]=c[v>>2];Y2(r,131649,q)|0}if(!(c[v>>2]|0)){c[v>>2]=1;j=+h[c[t>>2]>>3];h[x>>3]=j;h[w>>3]=j;if(+h[c[t>>2]>>3]/(+h[A>>3]*+h[A>>3])>+h[A>>3]*+h[A>>3]/+h[c[t>>2]>>3])N=+h[c[t>>2]>>3]/(+h[A>>3]*+h[A>>3]);else N=+h[A>>3]*+h[A>>3]/+h[c[t>>2]>>3];h[z>>3]=N;h[y>>3]=+h[c[t>>2]>>3];q=c[s>>2]|0;r=c[t>>2]|0;f=c[u>>2]|0;e=c[v>>2]|0;N=+h[w>>3];j=+h[x>>3];k=+h[y>>3];l=+h[z>>3];c[o>>2]=c[m>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2];c[o+16>>2]=c[m+16>>2];c[o+20>>2]=c[m+20>>2];c[o+24>>2]=c[m+24>>2];c[o+28>>2]=c[m+28>>2];Uu(q,r,f,e,N,j,k,l,o);i=n;return}if((c[v>>2]|0)<(c[s>>2]|0)){if(+h[w>>3]>+h[(c[t>>2]|0)+(c[v>>2]<<3)>>3])O=+h[w>>3];else O=+h[(c[t>>2]|0)+(c[v>>2]<<3)>>3];h[C>>3]=O;if(+h[x>>3]<+h[(c[t>>2]|0)+(c[v>>2]<<3)>>3])P=+h[x>>3];else P=+h[(c[t>>2]|0)+(c[v>>2]<<3)>>3];h[D>>3]=P;h[E>>3]=+h[y>>3]+ +h[(c[t>>2]|0)+(c[v>>2]<<3)>>3];h[F>>3]=+h[E>>3]/+h[A>>3];h[G>>3]=+h[C>>3]/+h[F>>3];h[H>>3]=+h[D>>3]/+h[F>>3];if(+h[F>>3]/+h[H>>3]>+h[G>>3]/+h[F>>3])Q=+h[F>>3]/+h[H>>3];else Q=+h[G>>3]/+h[F>>3];h[I>>3]=Q}if((c[v>>2]|0)<(c[s>>2]|0)?+h[I>>3]<=+h[z>>3]:0){z=c[s>>2]|0;F=c[t>>2]|0;G=c[u>>2]|0;H=(c[v>>2]|0)+1|0;c[v>>2]=H;Q=+h[C>>3];P=+h[D>>3];O=+h[E>>3];l=+h[I>>3];c[o>>2]=c[m>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2];c[o+16>>2]=c[m+16>>2];c[o+20>>2]=c[m+20>>2];c[o+24>>2]=c[m+24>>2];c[o+28>>2]=c[m+28>>2];Uu(z,F,G,H,Q,P,O,l,o);i=n;return}if(a[138998]|0){H=c[24742]|0;l=+h[y>>3];O=+h[A>>3];P=+h[y>>3]/+h[A>>3];c[p>>2]=c[v>>2];h[p+8>>3]=l;h[p+16>>3]=O;h[p+24>>3]=P;Y2(H,131674,p)|0}P=+h[y>>3]/+h[A>>3];if(+h[A>>3]==+h[m+16>>3]){h[J>>3]=P;h[L>>3]=+h[m>>3]-+h[m+16>>3]/2.0;c[B>>2]=0;while(1){R=+h[J>>3];if((c[B>>2]|0)>=(c[v>>2]|0))break;h[(c[u>>2]|0)+(c[B>>2]<<5)+16+8>>3]=R;h[K>>3]=+h[(c[t>>2]|0)+(c[B>>2]<<3)>>3]/+h[J>>3];h[(c[u>>2]|0)+(c[B>>2]<<5)+16>>3]=+h[K>>3];h[(c[u>>2]|0)+(c[B>>2]<<5)+8>>3]=+h[m+8>>3]+ +h[m+16+8>>3]*.5-+h[J>>3]/2.0;h[(c[u>>2]|0)+(c[B>>2]<<5)>>3]=+h[L>>3]+ +h[K>>3]/2.0;h[L>>3]=+h[L>>3]+ +h[K>>3];c[B>>2]=(c[B>>2]|0)+1}L=m+8|0;h[L>>3]=+h[L>>3]-R/2.0;L=m+16+8|0;h[L>>3]=+h[L>>3]-+h[J>>3]}else{h[K>>3]=P;h[M>>3]=+h[m+8>>3]+ +h[m+16+8>>3]/2.0;c[B>>2]=0;while(1){S=+h[K>>3];if((c[B>>2]|0)>=(c[v>>2]|0))break;h[(c[u>>2]|0)+(c[B>>2]<<5)+16>>3]=S;h[J>>3]=+h[(c[t>>2]|0)+(c[B>>2]<<3)>>3]/+h[K>>3];h[(c[u>>2]|0)+(c[B>>2]<<5)+16+8>>3]=+h[J>>3];h[(c[u>>2]|0)+(c[B>>2]<<5)>>3]=+h[m>>3]-+h[m+16>>3]*.5+ +h[K>>3]/2.0;h[(c[u>>2]|0)+(c[B>>2]<<5)+8>>3]=+h[M>>3]-+h[J>>3]/2.0;h[M>>3]=+h[M>>3]-+h[J>>3];c[B>>2]=(c[B>>2]|0)+1}h[m>>3]=+h[m>>3]+S/2.0;B=m+16|0;h[B>>3]=+h[B>>3]-+h[K>>3]}K=(c[s>>2]|0)-(c[v>>2]|0)|0;s=(c[t>>2]|0)+(c[v>>2]<<3)|0;t=(c[u>>2]|0)+(c[v>>2]<<5)|0;c[o>>2]=c[m>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2];c[o+16>>2]=c[m+16>>2];c[o+20>>2]=c[m+20>>2];c[o+24>>2]=c[m+24>>2];c[o+28>>2]=c[m+28>>2];Uu(K,s,t,0,0.0,0.0,0.0,1.0,o);i=n;return}function Vu(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+80|0;h=g+8|0;j=g;k=g+64|0;l=g+60|0;m=g+52|0;n=g+48|0;o=g+44|0;p=g+40|0;q=g+36|0;r=g+32|0;s=g+28|0;t=g+24|0;u=g+16|0;c[k>>2]=d;c[l>>2]=e;c[g+56>>2]=f;c[q>>2]=0;c[r>>2]=0;c[t>>2]=0;c[m>>2]=$B(c[k>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;c[o>>2]=OA(c[k>>2]|0,c[m>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;f=c[o>>2]|0;c[n>>2]=c[((c[c[o>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2];if((c[m>>2]|0)==(c[n>>2]|0)?(b[(c[(c[o>>2]|0)+8>>2]|0)+168>>1]|0)!=0:0){if(!(c[r>>2]|0)){c[r>>2]=bK(96)|0;f=bK((kB(c[k>>2]|0)|0)+360<<5)|0;c[(c[r>>2]|0)+84>>2]=f}_l(c[r>>2]|0,c[o>>2]|0,c[(c[(c[k>>2]|0)+8>>2]|0)+248>>2]|0)}else v=10;do if((v|0)==10?(v=0,(b[(c[(c[o>>2]|0)+8>>2]|0)+168>>1]|0)!=0):0){c[q>>2]=Wu(c[o>>2]|0,c[l>>2]|0)|0;if(!(Gs(c[(c[q>>2]|0)+8>>2]|0,c[c[q>>2]>>2]|0)|0)){if(a[138998]|0)Y2(c[24742]|0,131811,h)|0;c[t>>2]=1;break}c[s>>2]=mX(c[(c[q>>2]|0)+8>>2]|0,c[c[q>>2]>>2]|0)|0;if(!(c[s>>2]|0)){$z(0,131727,j)|0;c[t>>2]=1;break}c[p>>2]=c[o>>2];while(1){if(!(c[p>>2]|0))break;f=(c[(c[p>>2]|0)+8>>2]|0)+144|0;am(u,c[p>>2]|0,c[s>>2]|0,0,c[(c[q>>2]|0)+8>>2]|0,c[c[q>>2]>>2]|0);c[f>>2]=c[u>>2];c[f+4>>2]=c[u+4>>2];bm(c[k>>2]|0,c[p>>2]|0,c[(c[q>>2]|0)+8>>2]|0,c[c[q>>2]>>2]|0,0);c[p>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+172>>2]}Xu(c[q>>2]|0)}while(0);c[o>>2]=QA(c[k>>2]|0,c[o>>2]|0)|0}c[m>>2]=aC(c[k>>2]|0,c[m>>2]|0)|0}Yu(c[q>>2]|0);if(!(c[r>>2]|0)){w=c[t>>2]|0;i=g;return w|0}O4(c[(c[r>>2]|0)+84>>2]|0);O4(c[r>>2]|0);w=c[t>>2]|0;i=g;return w|0}function Wu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[f>>2]=b;c[g>>2]=d;d=c[f>>2]|0;c[h>>2]=c[((c[c[f>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];d=c[f>>2]|0;c[j>>2]=c[((c[c[f>>2]>>2]&3|0)==3?d:d+32|0)+28>>2];c[k>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+212>>2];c[l>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+212>>2];c[q>>2]=bK(12)|0;if(a[(c[(c[h>>2]|0)+8>>2]|0)+118>>0]|0){c[o>>2]=c[k>>2];c[k>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2]}else c[o>>2]=c[h>>2];if(a[(c[(c[j>>2]|0)+8>>2]|0)+118>>0]|0){c[p>>2]=c[l>>2];c[l>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2]}else c[p>>2]=c[j>>2];c[m>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+140>>2]|0)+44>>2];c[n>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+140>>2]|0)+44>>2];if((c[m>>2]|0)<=(c[n>>2]|0)){if((c[n>>2]|0)>(c[m>>2]|0)){Zu(c[q>>2]|0,c[n>>2]|0,c[p>>2]|0,c[m>>2]|0,l,c[g>>2]|0);c[p>>2]=c[l>>2];c[l>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2]}}else{Zu(c[q>>2]|0,c[m>>2]|0,c[o>>2]|0,c[n>>2]|0,k,c[g>>2]|0);c[o>>2]=c[k>>2];c[k>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2]}while(1){r=c[q>>2]|0;if((c[k>>2]|0)==(c[l>>2]|0))break;_u(r,c[k>>2]|0,0,c[o>>2]|0,c[g>>2]|0);_u(c[q>>2]|0,c[l>>2]|0,c[p>>2]|0,0,c[g>>2]|0);c[o>>2]=c[k>>2];c[k>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2];c[p>>2]=c[l>>2];c[l>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2]}_u(r,c[l>>2]|0,c[p>>2]|0,c[o>>2]|0,c[g>>2]|0);i=e;return c[q>>2]|0}function Xu(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[c[d>>2]>>2]=0;i=b;return}function Yu(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[d>>2]|0);i=b;return}function Zu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=c[c[n>>2]>>2];c[q>>2]=c[k>>2];while(1){if((c[q>>2]|0)<=(c[m>>2]|0))break;_u(c[j>>2]|0,c[p>>2]|0,c[l>>2]|0,0,c[o>>2]|0);c[l>>2]=c[p>>2];c[p>>2]=c[(c[(c[(c[p>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2];c[q>>2]=(c[q>>2]|0)+-1}c[c[n>>2]>>2]=c[l>>2];i=h;return}function _u(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+28|0;k=h+24|0;l=h+20|0;m=h+16|0;n=h+12|0;o=h+8|0;p=h+4|0;q=h;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=$B(c[k>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;if((((c[(c[(c[o>>2]|0)+8>>2]|0)+212>>2]|0)==(c[k>>2]|0)?(c[o>>2]|0)!=(c[l>>2]|0):0)?(c[o>>2]|0)!=(c[m>>2]|0):0)?(a[(c[(c[o>>2]|0)+8>>2]|0)+118>>0]|0)==0:0){g=c[j>>2]|0;$u(g,$l(c[o>>2]|0,c[n>>2]|0,0)|0)}c[o>>2]=aC(c[k>>2]|0,c[o>>2]|0)|0}c[q>>2]=1;while(1){if((c[q>>2]|0)>(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0))break;c[p>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+184>>2]|0)+(c[q>>2]<<2)>>2];if((c[p>>2]|0)!=(c[l>>2]|0)?(c[p>>2]|0)!=(c[m>>2]|0):0){o=c[j>>2]|0;$u(o,av(c[p>>2]|0,c[n>>2]|0)|0)}c[q>>2]=(c[q>>2]|0)+1}i=h;return}function $u(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;do if((c[(c[e>>2]|0)+4>>2]|0)==(c[c[e>>2]>>2]|0))if(c[(c[e>>2]|0)+8>>2]|0){b=(c[e>>2]|0)+4|0;c[b>>2]=c[b>>2]<<1;b=eK(c[(c[e>>2]|0)+8>>2]|0,c[(c[e>>2]|0)+4>>2]<<2)|0;c[(c[e>>2]|0)+8>>2]=b;break}else{b=cK(400)|0;c[(c[e>>2]|0)+8>>2]=b;c[(c[e>>2]|0)+4>>2]=100;break}while(0);b=c[f>>2]|0;f=c[e>>2]|0;a=c[f>>2]|0;c[f>>2]=a+1;c[(c[(c[e>>2]|0)+8>>2]|0)+(a<<2)>>2]=b;i=d;return}function av(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+112|0;f=e+104|0;j=e+100|0;k=e+96|0;l=e+64|0;m=e+32|0;n=e+16|0;o=e+8|0;p=e;c[f>>2]=b;c[j>>2]=d;c[k>>2]=bK(8)|0;d=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[d>>2];c[l+4>>2]=c[d+4>>2];c[l+8>>2]=c[d+8>>2];c[l+12>>2]=c[d+12>>2];c[l+16>>2]=c[d+16>>2];c[l+20>>2]=c[d+20>>2];c[l+24>>2]=c[d+24>>2];c[l+28>>2]=c[d+28>>2];c[(c[k>>2]|0)+4>>2]=4;d=bK(64)|0;c[c[k>>2]>>2]=d;h[n>>3]=(+h[l+16>>3]+ +h[l>>3])/2.0;h[n+8>>3]=(+h[l+16+8>>3]+ +h[l+8>>3])/2.0;if(a[(c[j>>2]|0)+8>>0]|0){h[m+16>>3]=+h[l+16>>3]+ +g[c[j>>2]>>2];h[m+16+8>>3]=+h[l+16+8>>3]+ +g[(c[j>>2]|0)+4>>2];h[m>>3]=+h[l>>3]-+g[c[j>>2]>>2];h[m+8>>3]=+h[l+8>>3]-+g[(c[j>>2]|0)+4>>2]}else{h[o>>3]=+g[c[j>>2]>>2]-1.0;h[p>>3]=+g[(c[j>>2]|0)+4>>2]-1.0;h[m+16>>3]=+g[c[j>>2]>>2]*+h[l+16>>3]-+h[o>>3]*+h[n>>3];h[m+16+8>>3]=+g[(c[j>>2]|0)+4>>2]*+h[l+16+8>>3]-+h[p>>3]*+h[n+8>>3];h[m>>3]=+g[c[j>>2]>>2]*+h[l>>3]-+h[o>>3]*+h[n>>3];h[m+8>>3]=+g[(c[j>>2]|0)+4>>2]*+h[l+8>>3]-+h[p>>3]*+h[n+8>>3]}h[c[c[k>>2]>>2]>>3]=+h[m>>3];h[(c[c[k>>2]>>2]|0)+8>>3]=+h[m+8>>3];h[(c[c[k>>2]>>2]|0)+16>>3]=+h[m>>3];h[(c[c[k>>2]>>2]|0)+16+8>>3]=+h[m+16+8>>3];h[(c[c[k>>2]>>2]|0)+32>>3]=+h[m+16>>3];h[(c[c[k>>2]>>2]|0)+32+8>>3]=+h[m+16+8>>3];h[(c[c[k>>2]>>2]|0)+48>>3]=+h[m+16>>3];h[(c[c[k>>2]>>2]|0)+48+8>>3]=+h[m+8>>3];i=e;return c[k>>2]|0}function bv(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+208|0;h=g+16|0;j=g+8|0;k=g;l=g+64|0;m=g+60|0;n=g+56|0;o=g+52|0;p=g+48|0;q=g+72|0;r=g+44|0;s=g+40|0;t=g+36|0;u=g+32|0;v=g+28|0;w=g+24|0;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[r>>2]=0;c[w>>2]=0;c[s>>2]=bK(kB(c[l>>2]|0)|0)|0;c[p>>2]=0;f=c[c[(c[(c[l>>2]|0)+8>>2]|0)+140>>2]>>2]|0;c[t>>2]=f;a:do if(f){e=wB(c[l>>2]|0)|0;b=c[r>>2]|0;c[r>>2]=b+1;x=b+(c[12945]|0)|0;c[k>>2]=e;c[k+4>>2]=x;k3(q,131862,k)|0;c[p>>2]=FD(c[l>>2]|0,q,1)|0;MC(c[p>>2]|0,175049,280,1)|0;x=bK(56)|0;c[(c[(c[p>>2]|0)+8>>2]|0)+140>>2]=x;c[c[(c[(c[p>>2]|0)+8>>2]|0)+140>>2]>>2]=c[t>>2];c[(c[(c[(c[p>>2]|0)+8>>2]|0)+140>>2]|0)+4>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+140>>2]|0)+4>>2];while(1){if(!(c[(c[t>>2]|0)+4>>2]|0))break a;if(!(a[(c[s>>2]|0)+(c[(c[(c[(c[t>>2]|0)+4>>2]|0)+8>>2]|0)+120>>2]|0)>>0]|0))cv(c[l>>2]|0,c[(c[t>>2]|0)+4>>2]|0,c[p>>2]|0,c[s>>2]|0);c[t>>2]=(c[t>>2]|0)+16}}while(0);c[o>>2]=$B(c[l>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;if((a[(c[s>>2]|0)+(c[(c[(c[o>>2]|0)+8>>2]|0)+120>>2]|0)>>0]|0)==0?(d[(c[(c[o>>2]|0)+8>>2]|0)+119>>0]|0)==3:0){if(!(c[p>>2]|0)){t=wB(c[l>>2]|0)|0;k=c[r>>2]|0;c[r>>2]=k+1;f=k+(c[12945]|0)|0;c[j>>2]=t;c[j+4>>2]=f;k3(q,131862,j)|0;c[p>>2]=FD(c[l>>2]|0,q,1)|0;MC(c[p>>2]|0,175049,280,1)|0;f=bK(56)|0;c[(c[(c[p>>2]|0)+8>>2]|0)+140>>2]=f}c[w>>2]=1;cv(c[l>>2]|0,c[o>>2]|0,c[p>>2]|0,c[s>>2]|0)}c[o>>2]=aC(c[l>>2]|0,c[o>>2]|0)|0}if(c[p>>2]|0)iG(c[p>>2]|0)|0;c[o>>2]=$B(c[l>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;if(!(a[(c[s>>2]|0)+(c[(c[(c[o>>2]|0)+8>>2]|0)+120>>2]|0)>>0]|0)){j=wB(c[l>>2]|0)|0;f=c[r>>2]|0;c[r>>2]=f+1;t=f+(c[12945]|0)|0;c[h>>2]=j;c[h+4>>2]=t;k3(q,131870,h)|0;c[p>>2]=FD(c[l>>2]|0,q,1)|0;MC(c[p>>2]|0,175049,280,1)|0;t=bK(56)|0;c[(c[(c[p>>2]|0)+8>>2]|0)+140>>2]=t;cv(c[l>>2]|0,c[o>>2]|0,c[p>>2]|0,c[s>>2]|0);iG(c[p>>2]|0)|0}c[o>>2]=aC(c[l>>2]|0,c[o>>2]|0)|0}O4(c[s>>2]|0);c[12945]=(c[12945]|0)+(c[r>>2]|0);if(c[m>>2]|0)c[c[m>>2]>>2]=c[r>>2];if(c[n>>2]|0)c[c[n>>2]>>2]=c[w>>2];w=bK((c[r>>2]|0)+1<<2)|0;c[v>>2]=w;c[u>>2]=w;c[p>>2]=GD(c[l>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;l=c[p>>2]|0;w=c[v>>2]|0;c[v>>2]=w+4;c[w>>2]=l;c[r>>2]=(c[r>>2]|0)+-1;c[p>>2]=HD(c[p>>2]|0)|0}if(!(c[r>>2]|0)){c[c[v>>2]>>2]=0;i=g;return c[u>>2]|0}else La(131878,131889,134,131896);return 0}function cv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;a[(c[l>>2]|0)+(c[(c[(c[j>>2]|0)+8>>2]|0)+120>>2]|0)>>0]=1;eC(c[k>>2]|0,c[j>>2]|0,1)|0;c[m>>2]=TA(c[h>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;f=c[m>>2]|0;e=c[((c[c[m>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0;c[n>>2]=e;if((e|0)==(c[j>>2]|0)){e=c[m>>2]|0;c[n>>2]=c[((c[c[m>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]}if(!(a[(c[l>>2]|0)+(c[(c[(c[n>>2]|0)+8>>2]|0)+120>>2]|0)>>0]|0))cv(c[h>>2]|0,c[n>>2]|0,c[k>>2]|0,c[l>>2]|0);c[m>>2]=UA(c[h>>2]|0,c[m>>2]|0,c[j>>2]|0)|0}i=g;return}function dv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=cK(24)|0;c[12946]=c[e>>2];a=Nz(51788,c[12989]|0)|0;c[c[e>>2]>>2]=a;c[(c[e>>2]|0)+16>>2]=0;c[(c[e>>2]|0)+12>>2]=0;a=kv(c[d>>2]|0)|0;c[(c[e>>2]|0)+4>>2]=a;i=b;return c[e>>2]|0}function ev(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if((c[f>>2]|0)<=(c[(c[e>>2]|0)+12>>2]|0)){i=d;return}if((c[f>>2]|0)>(c[(c[e>>2]|0)+12>>2]<<1|0))h=c[f>>2]|0;else h=c[(c[e>>2]|0)+12>>2]<<1;c[g>>2]=h;if(c[(c[e>>2]|0)+16>>2]|0)O4(c[(c[e>>2]|0)+16>>2]|0);h=cK(c[g>>2]<<3)|0;c[(c[e>>2]|0)+16>>2]=h;c[(c[e>>2]|0)+12>>2]=c[g>>2];i=d;return}function fv(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Hb[c[c[c[d>>2]>>2]>>2]&63](c[c[d>>2]>>2]|0,0,64)|0;c[(c[d>>2]|0)+20>>2]=c[(c[d>>2]|0)+16>>2];c[(c[d>>2]|0)+8>>2]=c[(c[d>>2]|0)+4>>2];c[(c[(c[d>>2]|0)+8>>2]|0)+4>>2]=c[c[(c[d>>2]|0)+8>>2]>>2];i=b;return}function gv(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Jz(c[c[d>>2]>>2]|0)|0;lv(c[(c[d>>2]|0)+4>>2]|0);O4(c[(c[d>>2]|0)+16>>2]|0);O4(c[d>>2]|0);i=b;return}function hv(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+64|0;h=g;j=g+48|0;k=g+44|0;l=g+40|0;m=g+36|0;n=g+32|0;o=g+12|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[o>>2]=c[k>>2];c[o+4>>2]=c[l>>2];c[n>>2]=Hb[c[c[c[j>>2]>>2]>>2]&63](c[c[j>>2]>>2]|0,o,1)|0;o=mv(c[j>>2]|0,c[m>>2]|0,c[(c[n>>2]|0)+8>>2]|0)|0;c[(c[n>>2]|0)+8>>2]=o;if((d[138998]|0|0)<3){i=g;return}o=c[24742]|0;n=c[k>>2]|0;k=c[l>>2]|0;l=wB(c[m>>2]|0)|0;c[h>>2]=n;c[h+4>>2]=k;c[h+8>>2]=l;Y2(o,131906,h)|0;i=g;return}function iv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;Uz(c[c[e>>2]>>2]|0,c[f>>2]|0,c[e>>2]|0)|0;i=d;return}function jv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[g>>2];c[j+4>>2]=c[h>>2];h=Hb[c[c[c[f>>2]>>2]>>2]&63](c[c[f>>2]>>2]|0,j,4)|0;i=e;return h|0}function kv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=cK(16)|0;c[(c[e>>2]|0)+12>>2]=0;a=cK((c[d>>2]|0)*20|0)|0;c[c[e>>2]>>2]=a;c[(c[e>>2]|0)+8>>2]=(c[c[e>>2]>>2]|0)+((c[d>>2]|0)*20|0);c[(c[e>>2]|0)+4>>2]=c[c[e>>2]>>2];i=b;return c[e>>2]|0}function lv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[e>>2]=c[(c[d>>2]|0)+12>>2];O4(c[c[d>>2]>>2]|0);O4(c[d>>2]|0);lv(c[e>>2]|0);i=b;return}function mv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=(c[f>>2]|0)+20|0;f=c[d>>2]|0;c[d>>2]=f+8;c[j>>2]=f;c[c[j>>2]>>2]=c[g>>2];c[(c[j>>2]|0)+4>>2]=c[h>>2];i=e;return c[j>>2]|0}function nv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e+12|0;g=e+4|0;h=e;c[e+16>>2]=a;c[f>>2]=b;c[e+8>>2]=d;c[g>>2]=c[f>>2];c[h>>2]=pv(c[12946]|0)|0;c[c[h>>2]>>2]=c[c[g>>2]>>2];c[(c[h>>2]|0)+4>>2]=c[(c[g>>2]|0)+4>>2];c[(c[h>>2]|0)+8>>2]=0;i=e;return c[h>>2]|0}function ov(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;h=f+12|0;j=f+8|0;k=f;c[f+16>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f+4>>2]=e;e=(c[c[h>>2]>>2]|0)-(c[c[j>>2]>>2]|0)|0;c[k>>2]=e;if(e){c[g>>2]=c[k>>2];l=c[g>>2]|0;i=f;return l|0}else{c[g>>2]=(c[(c[h>>2]|0)+4>>2]|0)-(c[(c[j>>2]|0)+4>>2]|0);l=c[g>>2]|0;i=f;return l|0}return 0}function pv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=c[(c[d>>2]|0)+8>>2];if((c[(c[f>>2]|0)+4>>2]|0)!=(c[(c[f>>2]|0)+8>>2]|0)){g=c[f>>2]|0;h=g+4|0;j=c[h>>2]|0;k=j+20|0;c[h>>2]=k;c[e>>2]=j;l=c[e>>2]|0;i=b;return l|0}if(!(c[(c[f>>2]|0)+12>>2]|0)){a=kv((((c[(c[f>>2]|0)+8>>2]|0)-(c[c[f>>2]>>2]|0)|0)/20|0)<<1)|0;c[(c[f>>2]|0)+12>>2]=a}a=c[(c[f>>2]|0)+12>>2]|0;c[(c[d>>2]|0)+8>>2]=a;c[f>>2]=a;c[(c[f>>2]|0)+4>>2]=c[c[f>>2]>>2];g=c[f>>2]|0;h=g+4|0;j=c[h>>2]|0;k=j+20|0;c[h>>2]=k;c[e>>2]=j;l=c[e>>2]|0;i=b;return l|0}function qv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[d>>2];O4(c[(c[e>>2]|0)+8>>2]|0);O4(c[e>>2]|0);i=b;return}function rv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[d>>2];i=b;return +(+h[c[e>>2]>>3])}function sv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[d>>2];i=b;return c[(c[e>>2]|0)+8>>2]|0}function tv(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[d>>2];i=b;return ~~+h[(c[e>>2]|0)+16>>3]|0}function uv(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;if((c[c[k>>2]>>2]|0)<(c[c[l>>2]>>2]|0)){i=h;return}if(10>0)p=10;else p=0;c[c[l>>2]>>2]=(c[c[k>>2]>>2]|0)+p;p=eK(c[c[m>>2]>>2]|0,_(c[c[l>>2]>>2]<<3,c[j>>2]|0)|0)|0;c[c[m>>2]>>2]=p;p=eK(c[c[n>>2]>>2]|0,c[c[l>>2]>>2]<<3)|0;c[c[n>>2]>>2]=p;p=eK(c[c[o>>2]>>2]|0,c[c[l>>2]>>2]<<3)|0;c[c[o>>2]>>2]=p;i=h;return}function vv(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;o=i;i=i+80|0;p=o+68|0;q=o+8|0;r=o+64|0;s=o+60|0;t=o+56|0;u=o+52|0;v=o+48|0;w=o+44|0;x=o+40|0;y=o+36|0;z=o+32|0;A=o+28|0;B=o+24|0;C=o;D=o+20|0;E=o+16|0;c[p>>2]=a;h[q>>3]=b;c[r>>2]=d;c[s>>2]=e;c[t>>2]=f;c[u>>2]=g;c[v>>2]=j;c[w>>2]=k;c[x>>2]=l;c[y>>2]=m;c[z>>2]=n;n=c[y>>2]|0;h[n>>3]=+h[n>>3]+1.0;if(!(c[p>>2]|0)){i=o;return}c[D>>2]=c[(c[p>>2]|0)+16>>2];c[A>>2]=c[(c[p>>2]|0)+40>>2];if((c[A>>2]|0)!=0&(c[A>>2]|0)!=0)do{uv(c[D>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0);n=tv(ry(c[A>>2]|0)|0)|0;if((n|0)!=(c[s>>2]|0)){c[B>>2]=sv(ry(c[A>>2]|0)|0)|0;c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[D>>2]|0))break;n=_(c[D>>2]|0,c[c[t>>2]>>2]|0)|0;h[(c[c[v>>2]>>2]|0)+(n+(c[E>>2]|0)<<3)>>3]=+h[(c[B>>2]|0)+(c[E>>2]<<3)>>3];c[E>>2]=(c[E>>2]|0)+1}b=+rv(ry(c[A>>2]|0)|0);h[(c[c[w>>2]>>2]|0)+(c[c[t>>2]>>2]<<3)>>3]=b;b=+Aw(c[r>>2]|0,c[B>>2]|0,c[D>>2]|0);h[(c[c[x>>2]>>2]|0)+(c[c[t>>2]>>2]<<3)>>3]=b;n=c[t>>2]|0;c[n>>2]=(c[n>>2]|0)+1}c[A>>2]=sy(c[A>>2]|0)|0}while((c[A>>2]|0)!=0);if(!(c[(c[p>>2]|0)+36>>2]|0)){i=o;return}h[C>>3]=+Aw(c[(c[p>>2]|0)+20>>2]|0,c[r>>2]|0,c[D>>2]|0);if(!(+h[(c[p>>2]|0)+24>>3]<+h[q>>3]*+h[C>>3])){c[E>>2]=0;while(1){if((c[E>>2]|0)>=(1<<c[D>>2]|0))break;vv(c[(c[(c[p>>2]|0)+36>>2]|0)+(c[E>>2]<<2)>>2]|0,+h[q>>3],c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0,c[y>>2]|0,c[z>>2]|0);c[E>>2]=(c[E>>2]|0)+1}i=o;return}uv(c[D>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0);c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[D>>2]|0))break;u=_(c[D>>2]|0,c[c[t>>2]>>2]|0)|0;h[(c[c[v>>2]>>2]|0)+(u+(c[E>>2]|0)<<3)>>3]=+h[(c[(c[p>>2]|0)+32>>2]|0)+(c[E>>2]<<3)>>3];c[E>>2]=(c[E>>2]|0)+1}h[(c[c[w>>2]>>2]|0)+(c[c[t>>2]>>2]<<3)>>3]=+h[(c[p>>2]|0)+8>>3];b=+Aw(c[(c[p>>2]|0)+32>>2]|0,c[r>>2]|0,c[D>>2]|0);h[(c[c[x>>2]>>2]|0)+(c[c[t>>2]>>2]<<3)>>3]=b;x=c[t>>2]|0;c[x>>2]=(c[x>>2]|0)+1;i=o;return}function wv(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;o=i;i=i+64|0;p=o+48|0;q=o;r=o+44|0;s=o+40|0;t=o+36|0;u=o+32|0;v=o+28|0;w=o+24|0;x=o+20|0;y=o+16|0;z=o+12|0;A=o+8|0;c[p>>2]=a;h[q>>3]=b;c[r>>2]=d;c[s>>2]=e;c[t>>2]=f;c[u>>2]=g;c[v>>2]=j;c[w>>2]=k;c[x>>2]=l;c[y>>2]=m;c[z>>2]=n;c[A>>2]=c[(c[p>>2]|0)+16>>2];h[c[y>>2]>>3]=0.0;c[c[t>>2]>>2]=0;c[c[z>>2]>>2]=0;c[c[u>>2]>>2]=10;if(!(c[c[v>>2]>>2]|0)){n=cK(_(c[c[u>>2]>>2]<<3,c[A>>2]|0)|0)|0;c[c[v>>2]>>2]=n}if(!(c[c[w>>2]>>2]|0)){n=cK(c[c[u>>2]>>2]<<3)|0;c[c[w>>2]>>2]=n}if(!(c[c[x>>2]>>2]|0)){n=cK(c[c[u>>2]>>2]<<3)|0;c[c[x>>2]>>2]=n}vv(c[p>>2]|0,+h[q>>3],c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0,c[y>>2]|0,c[z>>2]|0);i=o;return}function xv(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+64|0;m=l+52|0;n=l+48|0;o=l+44|0;p=l+16|0;q=l+8|0;r=l;s=l+40|0;t=l+36|0;u=l+32|0;v=l+28|0;w=l+24|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;h[p>>3]=e;h[q>>3]=f;h[r>>3]=g;c[s>>2]=j;c[t>>2]=k;c[u>>2]=c[c[m>>2]>>2];c[v>>2]=c[(c[m>>2]|0)+16>>2];c[w>>2]=0;while(1){if((c[w>>2]|0)>=4)break;h[(c[s>>2]|0)+(c[w>>2]<<3)>>3]=0.0;c[w>>2]=(c[w>>2]|0)+1}c[c[t>>2]>>2]=0;c[w>>2]=0;while(1){if((c[w>>2]|0)>=(_(c[v>>2]|0,c[u>>2]|0)|0))break;h[(c[n>>2]|0)+(c[w>>2]<<3)>>3]=0.0;c[w>>2]=(c[w>>2]|0)+1}Dv(c[m>>2]|0,c[m>>2]|0,c[o>>2]|0,c[n>>2]|0,+h[p>>3],+h[q>>3],+h[r>>3],c[s>>2]|0);Ev(c[m>>2]|0,c[n>>2]|0,c[s>>2]|0);c[w>>2]=0;while(1){if((c[w>>2]|0)>=4)break;n=(c[s>>2]|0)+(c[w>>2]<<3)|0;h[n>>3]=+h[n>>3]/+(c[u>>2]|0);c[w>>2]=(c[w>>2]|0)+1}i=l;return}function yv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0;g=i;i=i+64|0;j=g+52|0;k=g+48|0;l=g+44|0;m=g+40|0;n=g+36|0;o=g+32|0;p=g+28|0;q=g+24|0;r=g+20|0;s=g;t=g+16|0;u=g+12|0;v=g+8|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[t>>2]=0;c[p>>2]=cK(c[k>>2]<<3)|0;c[q>>2]=cK(c[k>>2]<<3)|0;c[r>>2]=cK(c[k>>2]<<3)|0;if(!((c[p>>2]|0)!=0&(c[q>>2]|0)!=0&(c[r>>2]|0)!=0)){c[j>>2]=0;w=c[j>>2]|0;i=g;return w|0}c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[k>>2]|0))break;h[(c[p>>2]|0)+(c[u>>2]<<3)>>3]=+h[(c[n>>2]|0)+(c[u>>2]<<3)>>3];c[u>>2]=(c[u>>2]|0)+1}c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[k>>2]|0))break;h[(c[q>>2]|0)+(c[u>>2]<<3)>>3]=+h[(c[n>>2]|0)+(c[u>>2]<<3)>>3];c[u>>2]=(c[u>>2]|0)+1}c[u>>2]=1;while(1){if((c[u>>2]|0)>=(c[l>>2]|0))break;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;f=_(c[u>>2]|0,c[k>>2]|0)|0;if(+h[(c[p>>2]|0)+(c[v>>2]<<3)>>3]<+h[(c[n>>2]|0)+(f+(c[v>>2]|0)<<3)>>3])x=+h[(c[p>>2]|0)+(c[v>>2]<<3)>>3];else{f=_(c[u>>2]|0,c[k>>2]|0)|0;x=+h[(c[n>>2]|0)+(f+(c[v>>2]|0)<<3)>>3]}h[(c[p>>2]|0)+(c[v>>2]<<3)>>3]=x;f=_(c[u>>2]|0,c[k>>2]|0)|0;if(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]>+h[(c[n>>2]|0)+(f+(c[v>>2]|0)<<3)>>3])y=+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3];else{f=_(c[u>>2]|0,c[k>>2]|0)|0;y=+h[(c[n>>2]|0)+(f+(c[v>>2]|0)<<3)>>3]}h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]=y;c[v>>2]=(c[v>>2]|0)+1}c[u>>2]=(c[u>>2]|0)+1}h[s>>3]=+h[c[q>>2]>>3]-+h[c[p>>2]>>3];c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[k>>2]|0))break;h[(c[r>>2]|0)+(c[u>>2]<<3)>>3]=(+h[(c[p>>2]|0)+(c[u>>2]<<3)>>3]+ +h[(c[q>>2]|0)+(c[u>>2]<<3)>>3])*.5;if(+h[s>>3]>+h[(c[q>>2]|0)+(c[u>>2]<<3)>>3]-+h[(c[p>>2]|0)+(c[u>>2]<<3)>>3])z=+h[s>>3];else z=+h[(c[q>>2]|0)+(c[u>>2]<<3)>>3]-+h[(c[p>>2]|0)+(c[u>>2]<<3)>>3];h[s>>3]=z;c[u>>2]=(c[u>>2]|0)+1}if(+h[s>>3]==0.0)h[s>>3]=1.0e-05;h[s>>3]=+h[s>>3]*.52;c[t>>2]=zv(c[k>>2]|0,c[r>>2]|0,+h[s>>3],c[m>>2]|0)|0;m=(c[o>>2]|0)!=0;c[u>>2]=0;a:do if(m)while(1){if((c[u>>2]|0)>=(c[l>>2]|0))break a;s=_(c[u>>2]|0,c[k>>2]|0)|0;c[t>>2]=Av(c[t>>2]|0,(c[n>>2]|0)+(s<<3)|0,+h[(c[o>>2]|0)+(c[u>>2]<<3)>>3],c[u>>2]|0)|0;c[u>>2]=(c[u>>2]|0)+1}else while(1){if((c[u>>2]|0)>=(c[l>>2]|0))break a;s=_(c[u>>2]|0,c[k>>2]|0)|0;c[t>>2]=Av(c[t>>2]|0,(c[n>>2]|0)+(s<<3)|0,1.0,c[u>>2]|0)|0;c[u>>2]=(c[u>>2]|0)+1}while(0);O4(c[p>>2]|0);O4(c[q>>2]|0);O4(c[r>>2]|0);c[j>>2]=c[t>>2];w=c[j>>2]|0;i=g;return w|0}function zv(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;j=f+20|0;k=f;l=f+16|0;m=f+12|0;n=f+8|0;c[g>>2]=a;c[j>>2]=b;h[k>>3]=d;c[l>>2]=e;c[m>>2]=cK(56)|0;c[(c[m>>2]|0)+16>>2]=c[g>>2];c[c[m>>2]>>2]=0;e=cK(c[g>>2]<<3)|0;c[(c[m>>2]|0)+20>>2]=e;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[g>>2]|0))break;h[(c[(c[m>>2]|0)+20>>2]|0)+(c[n>>2]<<3)>>3]=+h[(c[j>>2]|0)+(c[n>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}if(+h[k>>3]>0.0){h[(c[m>>2]|0)+24>>3]=+h[k>>3];h[(c[m>>2]|0)+8>>3]=0.0;c[(c[m>>2]|0)+32>>2]=0;c[(c[m>>2]|0)+36>>2]=0;c[(c[m>>2]|0)+40>>2]=0;c[(c[m>>2]|0)+44>>2]=c[l>>2];c[(c[m>>2]|0)+48>>2]=0;i=f;return c[m>>2]|0}else La(131923,131933,405,131944);return 0}function Av(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f+12|0;l=f;m=f+8|0;c[j>>2]=a;c[k>>2]=b;h[l>>3]=d;c[m>>2]=e;e=c[j>>2]|0;if(c[j>>2]|0){c[g>>2]=Fv(e,c[k>>2]|0,+h[l>>3],c[m>>2]|0,0)|0;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=e;n=c[g>>2]|0;i=f;return n|0}return 0}function Bv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[f>>2]=c[(c[d>>2]|0)+16>>2];O4(c[(c[d>>2]|0)+20>>2]|0);O4(c[(c[d>>2]|0)+32>>2]|0);if(c[(c[d>>2]|0)+48>>2]|0)O4(c[(c[d>>2]|0)+48>>2]|0);if(c[(c[d>>2]|0)+36>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(1<<c[f>>2]|0))break;Bv(c[(c[(c[d>>2]|0)+36>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}O4(c[(c[d>>2]|0)+36>>2]|0)}py(c[(c[d>>2]|0)+40>>2]|0,97);O4(c[d>>2]|0);i=b;return}
function eH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+112|0;k=j+108|0;l=j+104|0;m=j+100|0;n=j+96|0;o=j+92|0;p=j+88|0;q=j+80|0;r=j+16|0;s=j+8|0;t=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;h[s>>3]=+cH(c[k>>2]|0,c[p>>2]|0);h[t>>3]=+h[s>>3]*+h[s>>3];c[(c[o>>2]|0)+8>>2]=c[p>>2];p=(c[o>>2]|0)+16|0;s=(c[l>>2]|0)+(c[m>>2]<<4)|0;c[p>>2]=c[s>>2];c[p+4>>2]=c[s+4>>2];c[p+8>>2]=c[s+8>>2];c[p+12>>2]=c[s+12>>2];if((c[n>>2]|0)>(c[m>>2]|0)?(+h[(c[l>>2]|0)+(c[m>>2]<<4)>>3]-+h[(c[l>>2]|0)+((c[m>>2]|0)+3<<4)>>3])*(+h[(c[l>>2]|0)+(c[m>>2]<<4)>>3]-+h[(c[l>>2]|0)+((c[m>>2]|0)+3<<4)>>3])+(+h[(c[l>>2]|0)+(c[m>>2]<<4)+8>>3]-+h[(c[l>>2]|0)+((c[m>>2]|0)+3<<4)+8>>3])*(+h[(c[l>>2]|0)+(c[m>>2]<<4)+8>>3]-+h[(c[l>>2]|0)+((c[m>>2]|0)+3<<4)+8>>3])<+h[t>>3]:0)c[m>>2]=(c[m>>2]|0)+3;n=(c[l>>2]|0)+((c[m>>2]|0)+3<<4)|0;c[r>>2]=c[n>>2];c[r+4>>2]=c[n+4>>2];c[r+8>>2]=c[n+8>>2];c[r+12>>2]=c[n+12>>2];n=r+16|0;s=(c[l>>2]|0)+((c[m>>2]|0)+2<<4)|0;c[n>>2]=c[s>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];s=r+32|0;n=(c[l>>2]|0)+((c[m>>2]|0)+1<<4)|0;c[s>>2]=c[n>>2];c[s+4>>2]=c[n+4>>2];c[s+8>>2]=c[n+8>>2];c[s+12>>2]=c[n+12>>2];n=r+48|0;s=(c[o>>2]|0)+16|0;c[n>>2]=c[s>>2];c[n+4>>2]=c[s+4>>2];c[n+8>>2]=c[s+8>>2];c[n+12>>2]=c[s+12>>2];c[q>>2]=r+48;c[q+4>>2]=t;gN(q,92,r,0);q=(c[l>>2]|0)+(c[m>>2]<<4)|0;t=r+48|0;c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];c[q+12>>2]=c[t+12>>2];t=(c[l>>2]|0)+((c[m>>2]|0)+1<<4)|0;q=r+32|0;c[t>>2]=c[q>>2];c[t+4>>2]=c[q+4>>2];c[t+8>>2]=c[q+8>>2];c[t+12>>2]=c[q+12>>2];q=(c[l>>2]|0)+((c[m>>2]|0)+2<<4)|0;t=r+16|0;c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];c[q+12>>2]=c[t+12>>2];t=(c[l>>2]|0)+((c[m>>2]|0)+3<<4)|0;c[t>>2]=c[r>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];c[t+12>>2]=c[r+12>>2];i=j;return c[m>>2]|0}function fH(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0;k=i;i=i+144|0;l=k+136|0;m=k+132|0;n=k+128|0;o=k+124|0;p=k+120|0;q=k+116|0;r=k+112|0;s=k+96|0;t=k+80|0;u=k+64|0;v=k+48|0;w=k+32|0;x=k+24|0;y=k+16|0;z=k+8|0;A=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;if((c[q>>2]|0)!=0&(c[r>>2]|0)!=0?(c[o>>2]|0)==(c[n>>2]|0):0){j=(c[m>>2]|0)+(c[o>>2]<<4)|0;c[s>>2]=c[j>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];j=(c[m>>2]|0)+((c[o>>2]|0)+3<<4)|0;c[t>>2]=c[j>>2];c[t+4>>2]=c[j+4>>2];c[t+8>>2]=c[j+8>>2];c[t+12>>2]=c[j+12>>2];h[y>>3]=+cH(c[l>>2]|0,c[q>>2]|0);h[z>>3]=+cH(c[l>>2]|0,c[r>>2]|0);h[x>>3]=+O(+((+h[s>>3]-+h[t>>3])*(+h[s>>3]-+h[t>>3])+(+h[s+8>>3]-+h[t+8>>3])*(+h[s+8>>3]-+h[t+8>>3])));if(+h[z>>3]+ +h[y>>3]>=+h[x>>3]){B=+h[x>>3]/3.0;h[y>>3]=B;h[z>>3]=B}do if(+h[s+8>>3]==+h[t+8>>3]){B=+h[s+8>>3];h[w+8>>3]=B;h[v+8>>3]=B;B=+h[t>>3];C=+h[z>>3];if(+h[s>>3]<+h[t>>3]){h[w>>3]=B-C;h[v>>3]=+h[s>>3]+ +h[y>>3];break}else{h[w>>3]=B+C;h[v>>3]=+h[s>>3]-+h[y>>3];break}}else{C=+h[s>>3];h[w>>3]=C;h[v>>3]=C;C=+h[t+8>>3];B=+h[z>>3];if(+h[s+8>>3]<+h[t+8>>3]){h[w+8>>3]=C-B;h[v+8>>3]=+h[s+8>>3]+ +h[y>>3];break}else{h[w+8>>3]=C+B;h[v+8>>3]=+h[s+8>>3]-+h[y>>3];break}}while(0);j=(c[m>>2]|0)+(c[o>>2]<<4)|0;g=(c[m>>2]|0)+((c[o>>2]|0)+1<<4)|0;c[g>>2]=c[v>>2];c[g+4>>2]=c[v+4>>2];c[g+8>>2]=c[v+8>>2];c[g+12>>2]=c[v+12>>2];c[j>>2]=c[g>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];g=(c[m>>2]|0)+((c[o>>2]|0)+2<<4)|0;j=(c[m>>2]|0)+((c[o>>2]|0)+3<<4)|0;c[j>>2]=c[w>>2];c[j+4>>2]=c[w+4>>2];c[j+8>>2]=c[w+8>>2];c[j+12>>2]=c[w+12>>2];c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[(c[p>>2]|0)+12>>2]=c[r>>2];j=(c[p>>2]|0)+32|0;c[j>>2]=c[s>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[j+12>>2]=c[s+12>>2];c[(c[p>>2]|0)+8>>2]=c[q>>2];j=(c[p>>2]|0)+16|0;c[j>>2]=c[t>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[j+12>>2]=c[t+12>>2];i=k;return}if(c[r>>2]|0){h[z>>3]=+cH(c[l>>2]|0,c[r>>2]|0);j=(c[m>>2]|0)+(c[o>>2]<<4)|0;c[s>>2]=c[j>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];j=(c[m>>2]|0)+((c[o>>2]|0)+3<<4)|0;c[t>>2]=c[j>>2];c[t+4>>2]=c[j+4>>2];c[t+8>>2]=c[j+8>>2];c[t+12>>2]=c[j+12>>2];h[x>>3]=+O(+((+h[s>>3]-+h[t>>3])*(+h[s>>3]-+h[t>>3])+(+h[s+8>>3]-+h[t+8>>3])*(+h[s+8>>3]-+h[t+8>>3])));h[A>>3]=+h[x>>3]*.9;if(+h[z>>3]>=+h[A>>3])h[z>>3]=+h[A>>3];do if(+h[s+8>>3]==+h[t+8>>3]){h[u+8>>3]=+h[s+8>>3];B=+h[t>>3];C=+h[z>>3];if(+h[s>>3]<+h[t>>3]){h[u>>3]=B-C;break}else{h[u>>3]=B+C;break}}else{h[u>>3]=+h[s>>3];C=+h[t+8>>3];B=+h[z>>3];if(+h[s+8>>3]<+h[t+8>>3]){h[u+8>>3]=C-B;break}else{h[u+8>>3]=C+B;break}}while(0);z=(c[m>>2]|0)+((c[o>>2]|0)+1<<4)|0;c[z>>2]=c[s>>2];c[z+4>>2]=c[s+4>>2];c[z+8>>2]=c[s+8>>2];c[z+12>>2]=c[s+12>>2];z=(c[m>>2]|0)+((c[o>>2]|0)+2<<4)|0;j=(c[m>>2]|0)+((c[o>>2]|0)+3<<4)|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];c[z>>2]=c[j>>2];c[z+4>>2]=c[j+4>>2];c[z+8>>2]=c[j+8>>2];c[z+12>>2]=c[j+12>>2];c[(c[p>>2]|0)+12>>2]=c[r>>2];r=(c[p>>2]|0)+32|0;c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2]}if(!(c[q>>2]|0)){i=k;return}h[y>>3]=+cH(c[l>>2]|0,c[q>>2]|0);l=(c[m>>2]|0)+(c[n>>2]<<4)|0;c[s>>2]=c[l>>2];c[s+4>>2]=c[l+4>>2];c[s+8>>2]=c[l+8>>2];c[s+12>>2]=c[l+12>>2];l=(c[m>>2]|0)+((c[n>>2]|0)+3<<4)|0;c[t>>2]=c[l>>2];c[t+4>>2]=c[l+4>>2];c[t+8>>2]=c[l+8>>2];c[t+12>>2]=c[l+12>>2];h[x>>3]=+O(+((+h[s>>3]-+h[t>>3])*(+h[s>>3]-+h[t>>3])+(+h[s+8>>3]-+h[t+8>>3])*(+h[s+8>>3]-+h[t+8>>3])));h[A>>3]=+h[x>>3]*.9;if(+h[y>>3]>=+h[A>>3])h[y>>3]=+h[A>>3];do if(+h[s+8>>3]==+h[t+8>>3]){h[u+8>>3]=+h[s+8>>3];B=+h[s>>3];C=+h[y>>3];if(+h[s>>3]<+h[t>>3]){h[u>>3]=B+C;break}else{h[u>>3]=B-C;break}}else{h[u>>3]=+h[s>>3];C=+h[s+8>>3];B=+h[y>>3];if(+h[s+8>>3]<+h[t+8>>3]){h[u+8>>3]=C+B;break}else{h[u+8>>3]=C-B;break}}while(0);y=(c[m>>2]|0)+(c[n>>2]<<4)|0;A=(c[m>>2]|0)+((c[n>>2]|0)+1<<4)|0;c[A>>2]=c[u>>2];c[A+4>>2]=c[u+4>>2];c[A+8>>2]=c[u+8>>2];c[A+12>>2]=c[u+12>>2];c[y>>2]=c[A>>2];c[y+4>>2]=c[A+4>>2];c[y+8>>2]=c[A+8>>2];c[y+12>>2]=c[A+12>>2];A=(c[m>>2]|0)+((c[n>>2]|0)+2<<4)|0;c[A>>2]=c[t>>2];c[A+4>>2]=c[t+4>>2];c[A+8>>2]=c[t+8>>2];c[A+12>>2]=c[t+12>>2];c[(c[p>>2]|0)+8>>2]=c[q>>2];q=(c[p>>2]|0)+16|0;c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];c[q+12>>2]=c[s+12>>2];i=k;return}function gH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0;g=i;i=i+144|0;j=g+120|0;k=g+112|0;l=g+80|0;m=g+72|0;n=g+64|0;o=g+56|0;p=g+48|0;q=g+40|0;r=g+32|0;s=g+24|0;t=g+16|0;u=g+8|0;v=g;h[j>>3]=e;c[g+128>>2]=f;h[d>>3]=+h[d>>3]-+h[b>>3];f=d+8|0;h[f>>3]=+h[f>>3]-+h[b+8>>3];h[k>>3]=+h[j>>3]*10.0/(+O(+(+h[d>>3]*+h[d>>3]+ +h[d+8>>3]*+h[d+8>>3]))+.0001);h[d>>3]=+h[d>>3]+(+h[d>>3]>=0.0?.0001:-.0001);j=d+8|0;h[j>>3]=+h[j>>3]+(+h[d+8>>3]>=0.0?.0001:-.0001);h[d>>3]=+h[d>>3]*+h[k>>3];j=d+8|0;h[j>>3]=+h[j>>3]*+h[k>>3];h[u>>3]=+h[d>>3]/2.0;h[v>>3]=+h[d+8>>3]/2.0;h[m>>3]=+h[b>>3]-+h[v>>3];h[n>>3]=+h[b+8>>3]-+h[u>>3];h[o>>3]=+h[b>>3]+ +h[v>>3];h[p>>3]=+h[b+8>>3]+ +h[u>>3];h[q>>3]=+h[m>>3]+ +h[d>>3];h[r>>3]=+h[n>>3]+ +h[d+8>>3];h[s>>3]=+h[o>>3]+ +h[d>>3];h[t>>3]=+h[p>>3]+ +h[d+8>>3];if(+h[o>>3]>(+h[q>>3]>+h[s>>3]?+h[q>>3]:+h[s>>3]))w=+h[o>>3];else w=+h[q>>3]>+h[s>>3]?+h[q>>3]:+h[s>>3];do if(!(+h[m>>3]>w))if(+h[o>>3]>(+h[q>>3]>+h[s>>3]?+h[q>>3]:+h[s>>3])){x=+h[o>>3];break}else{x=+h[q>>3]>+h[s>>3]?+h[q>>3]:+h[s>>3];break}else x=+h[m>>3];while(0);h[l+16>>3]=x;if(+h[p>>3]>(+h[r>>3]>+h[t>>3]?+h[r>>3]:+h[t>>3]))y=+h[p>>3];else y=+h[r>>3]>+h[t>>3]?+h[r>>3]:+h[t>>3];do if(!(+h[n>>3]>y))if(+h[p>>3]>(+h[r>>3]>+h[t>>3]?+h[r>>3]:+h[t>>3])){z=+h[p>>3];break}else{z=+h[r>>3]>+h[t>>3]?+h[r>>3]:+h[t>>3];break}else z=+h[n>>3];while(0);h[l+16+8>>3]=z;if(+h[o>>3]<(+h[q>>3]<+h[s>>3]?+h[q>>3]:+h[s>>3]))A=+h[o>>3];else A=+h[q>>3]<+h[s>>3]?+h[q>>3]:+h[s>>3];do if(!(+h[m>>3]<A))if(+h[o>>3]<(+h[q>>3]<+h[s>>3]?+h[q>>3]:+h[s>>3])){B=+h[o>>3];break}else{B=+h[q>>3]<+h[s>>3]?+h[q>>3]:+h[s>>3];break}else B=+h[m>>3];while(0);h[l>>3]=B;if(+h[p>>3]<(+h[r>>3]<+h[t>>3]?+h[r>>3]:+h[t>>3]))C=+h[p>>3];else C=+h[r>>3]<+h[t>>3]?+h[r>>3]:+h[t>>3];if(+h[n>>3]<C){D=+h[n>>3];E=l+8|0;h[E>>3]=D;c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];c[a+16>>2]=c[l+16>>2];c[a+20>>2]=c[l+20>>2];c[a+24>>2]=c[l+24>>2];c[a+28>>2]=c[l+28>>2];i=g;return}if(+h[p>>3]<(+h[r>>3]<+h[t>>3]?+h[r>>3]:+h[t>>3])){D=+h[p>>3];E=l+8|0;h[E>>3]=D;c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];c[a+16>>2]=c[l+16>>2];c[a+20>>2]=c[l+20>>2];c[a+24>>2]=c[l+24>>2];c[a+28>>2]=c[l+28>>2];i=g;return}else{D=+h[r>>3]<+h[t>>3]?+h[r>>3]:+h[t>>3];E=l+8|0;h[E>>3]=D;c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];c[a+16>>2]=c[l+16>>2];c[a+20>>2]=c[l+20>>2];c[a+24>>2]=c[l+24>>2];c[a+28>>2]=c[l+28>>2];i=g;return}}function hH(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;k=i;i=i+112|0;l=k+56|0;m=k+40|0;n=k+96|0;o=k+92|0;p=k+32|0;q=k+24|0;r=k+88|0;s=k+84|0;t=k+16|0;u=k+80|0;v=k+76|0;w=k+72|0;x=k;c[n>>2]=a;c[o>>2]=b;h[p>>3]=f;h[q>>3]=g;c[r>>2]=j;c[s>>2]=c[(c[n>>2]|0)+16>>2];c[w>>2]=c[(c[s>>2]|0)+12>>2];c[(c[s>>2]|0)+12>>2]=c[o>>2];rR(c[n>>2]|0,c[(c[c[n>>2]>>2]|0)+336>>2]|0);zR(c[n>>2]|0,+h[q>>3]);h[e>>3]=+h[e>>3]-+h[d>>3];o=e+8|0;h[o>>3]=+h[o>>3]-+h[d+8>>3];h[t>>3]=10.0/(+O(+(+h[e>>3]*+h[e>>3]+ +h[e+8>>3]*+h[e+8>>3]))+.0001);h[e>>3]=+h[e>>3]+(+h[e>>3]>=0.0?.0001:-.0001);o=e+8|0;h[o>>3]=+h[o>>3]+(+h[e+8>>3]>=0.0?.0001:-.0001);h[e>>3]=+h[e>>3]*+h[t>>3];o=e+8|0;h[o>>3]=+h[o>>3]*+h[t>>3];c[u>>2]=0;while(1){if((c[u>>2]|0)>=4){y=5;break}c[v>>2]=c[r>>2]>>(c[u>>2]<<3)&255;if(!(c[v>>2]|0)){y=5;break}t=c[n>>2]|0;g=+h[p>>3];f=+h[q>>3];o=c[v>>2]|0;c[m>>2]=c[d>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];kH(x,t,m,l,g,f,o);c[d>>2]=c[x>>2];c[d+4>>2]=c[x+4>>2];c[d+8>>2]=c[x+8>>2];c[d+12>>2]=c[x+12>>2];c[u>>2]=(c[u>>2]|0)+1}if((y|0)==5){c[(c[s>>2]|0)+12>>2]=c[w>>2];i=k;return}}function iH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[g>>2];c[c[h>>2]>>2]=0;c[l>>2]=0;while(1){if(!((a[c[j>>2]>>0]|0)!=0?(c[l>>2]|0)<4:0)){n=12;break}c[m>>2]=0;c[k>>2]=c[j>>2];c[j>>2]=tH(c[k>>2]|0,m)|0;if(!(c[m>>2]|0))break;if((c[m>>2]|0)==8&(c[l>>2]|0)==3)c[m>>2]=0;if((c[m>>2]|0)==8&(c[l>>2]|0)==0?(a[c[j>>2]>>0]|0)==0:0)c[m>>2]=0;if(!(c[m>>2]|0))continue;g=c[m>>2]|0;d=c[l>>2]|0;c[l>>2]=d+1;b=c[h>>2]|0;c[b>>2]=c[b>>2]|g<<(d<<3)}if((n|0)==12){i=e;return}c[f>>2]=c[k>>2];$z(0,137373,f)|0;i=e;return}function jH(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=a;i=d;return (+h[b>>3]-+h[c[c[e>>2]>>2]>>3])*(+h[b>>3]-+h[c[c[e>>2]>>2]>>3])+(+h[b+8>>3]-+h[(c[c[e>>2]>>2]|0)+8>>3])*(+h[b+8>>3]-+h[(c[c[e>>2]>>2]|0)+8>>3])<=+h[c[(c[e>>2]|0)+4>>2]>>3]&255|0}function kH(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+64|0;l=k+32|0;m=k+16|0;n=k+60|0;o=k+8|0;p=k;q=k+56|0;r=k+52|0;s=k+48|0;c[n>>2]=b;h[o>>3]=f;h[p>>3]=g;c[q>>2]=j;c[r>>2]=c[q>>2]&15;c[s>>2]=33736;while(1){if(!(c[c[s>>2]>>2]|0)){t=6;break}u=c[s>>2]|0;if((c[r>>2]|0)==(c[c[s>>2]>>2]|0))break;c[s>>2]=u+24}if((t|0)==6){c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];i=k;return}h[e>>3]=+h[e>>3]*(+h[u+8>>3]*+h[o>>3]);u=e+8|0;h[u>>3]=+h[u>>3]*(+h[(c[s>>2]|0)+8>>3]*+h[o>>3]);u=c[(c[s>>2]|0)+16>>2]|0;s=c[n>>2]|0;g=+h[o>>3];f=+h[p>>3];p=c[q>>2]|0;c[m>>2]=c[d>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];Rb[u&15](s,m,l,g,f,p);h[d>>3]=+h[d>>3]+ +h[e>>3];h[d+8>>3]=+h[d+8>>3]+ +h[e+8>>3];c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];i=k;return}function lH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+144|0;k=j+140|0;l=j+120|0;m=j+136|0;n=j+104|0;o=j+88|0;p=j+8|0;q=j;c[k>>2]=a;h[j+128>>3]=e;h[l>>3]=f;c[m>>2]=g;h[q>>3]=.35;if(+h[l>>3]>4.0)h[q>>3]=+h[q>>3]*(+h[l>>3]/4.0);h[o>>3]=-+h[d+8>>3]*+h[q>>3];h[o+8>>3]=+h[d>>3]*+h[q>>3];h[n>>3]=+h[b>>3]+ +h[d>>3];h[n+8>>3]=+h[b+8>>3]+ +h[d+8>>3];d=p+64|0;if(c[m>>2]&32){c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];h[p+16>>3]=+h[b>>3]-+h[o>>3];h[p+16+8>>3]=+h[b+8>>3]-+h[o+8>>3];q=p+32|0;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];h[p+48>>3]=+h[b>>3]+ +h[o>>3];h[p+48+8>>3]=+h[b+8>>3]+ +h[o+8>>3]}else{c[d>>2]=c[n>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];c[d+12>>2]=c[n+12>>2];c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];h[p+16>>3]=+h[n>>3]-+h[o>>3];h[p+16+8>>3]=+h[n+8>>3]-+h[o+8>>3];d=p+32|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];h[p+48>>3]=+h[n>>3]+ +h[o>>3];h[p+48+8>>3]=+h[n+8>>3]+ +h[o+8>>3]}if(c[m>>2]&64){tR(c[k>>2]|0,p,3,((c[m>>2]&16|0)!=0^1)&1);i=j;return}o=c[k>>2]|0;if(c[m>>2]&128){tR(o,p+32|0,3,((c[m>>2]&16|0)!=0^1)&1);i=j;return}else{tR(o,p+16|0,3,((c[m>>2]&16|0)!=0^1)&1);i=j;return}}function mH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+256|0;k=j+244|0;l=j+232|0;m=j+224|0;n=j+240|0;o=j+208|0;p=j+192|0;q=j+176|0;r=j+160|0;s=j+16|0;t=j+8|0;u=j;c[k>>2]=a;h[l>>3]=e;h[m>>3]=f;c[n>>2]=g;h[t>>3]=.45;if(+h[m>>3]>+h[l>>3]*4.0?(c[n>>2]&32|0)!=0:0)h[t>>3]=+h[t>>3]*(+h[m>>3]/(+h[l>>3]*4.0));h[u>>3]=0.0;if(+h[m>>3]>1.0?(c[n>>2]&32|0)!=0:0)h[u>>3]=(+h[m>>3]-1.0)*.05/+h[l>>3];h[q>>3]=-+h[d+8>>3]*+h[t>>3];h[q+8>>3]=+h[d>>3]*+h[t>>3];h[r>>3]=-+h[d+8>>3]*+h[u>>3];h[r+8>>3]=+h[d>>3]*+h[u>>3];h[p>>3]=+h[b>>3]+ +h[d>>3];h[p+8>>3]=+h[b+8>>3]+ +h[d+8>>3];h[o>>3]=+h[b>>3]+ +h[d>>3]*.5;h[o+8>>3]=+h[b+8>>3]+ +h[d+8>>3]*.5;d=s+128|0;if(c[n>>2]&32){c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[s>>2]=c[d>>2];c[s+4>>2]=c[d+4>>2];c[s+8>>2]=c[d+8>>2];c[s+12>>2]=c[d+12>>2];h[s+16>>3]=+h[p>>3]-+h[q>>3];h[s+16+8>>3]=+h[p+8>>3]-+h[q+8>>3];h[s+32>>3]=+h[o>>3]-+h[r>>3];h[s+32+8>>3]=+h[o+8>>3]-+h[r+8>>3];h[s+48>>3]=+h[p>>3]-+h[r>>3];h[s+48+8>>3]=+h[p+8>>3]-+h[r+8>>3];u=s+64|0;c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];c[u+12>>2]=c[p+12>>2];h[s+80>>3]=+h[p>>3]+ +h[r>>3];h[s+80+8>>3]=+h[p+8>>3]+ +h[r+8>>3];h[s+96>>3]=+h[o>>3]+ +h[r>>3];h[s+96+8>>3]=+h[o+8>>3]+ +h[r+8>>3];h[s+112>>3]=+h[p>>3]+ +h[q>>3];h[s+112+8>>3]=+h[p+8>>3]+ +h[q+8>>3]}else{c[d>>2]=c[p>>2];c[d+4>>2]=c[p+4>>2];c[d+8>>2]=c[p+8>>2];c[d+12>>2]=c[p+12>>2];c[s>>2]=c[d>>2];c[s+4>>2]=c[d+4>>2];c[s+8>>2]=c[d+8>>2];c[s+12>>2]=c[d+12>>2];h[s+16>>3]=+h[b>>3]-+h[q>>3];h[s+16+8>>3]=+h[b+8>>3]-+h[q+8>>3];h[s+32>>3]=+h[o>>3]-+h[r>>3];h[s+32+8>>3]=+h[o+8>>3]-+h[r+8>>3];h[s+48>>3]=+h[b>>3];h[s+48+8>>3]=+h[b+8>>3];d=s+64|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];h[s+80>>3]=+h[b>>3];h[s+80+8>>3]=+h[b+8>>3];h[s+96>>3]=+h[o>>3]+ +h[r>>3];h[s+96+8>>3]=+h[o+8>>3]+ +h[r+8>>3];h[s+112>>3]=+h[b>>3]+ +h[q>>3];h[s+112+8>>3]=+h[b+8>>3]+ +h[q+8>>3]}if(c[n>>2]&64){tR(c[k>>2]|0,s,6,1);i=j;return}q=c[k>>2]|0;if(c[n>>2]&128){tR(q,s+48|0,6,1);i=j;return}else{tR(q,s,9,1);i=j;return}}function nH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+160|0;k=j+148|0;l=j+144|0;m=j+112|0;n=j+96|0;o=j+80|0;p=j+64|0;q=j;c[k>>2]=a;h[j+136>>3]=e;h[j+128>>3]=f;c[l>>2]=g;h[p>>3]=-+h[d+8>>3];h[p+8>>3]=+h[d>>3];h[o>>3]=+h[b>>3]+ +h[d>>3];h[o+8>>3]=+h[b+8>>3]+ +h[d+8>>3];h[m>>3]=+h[b>>3]+ +h[d>>3]*.2;h[m+8>>3]=+h[b+8>>3]+ +h[d+8>>3]*.2;h[n>>3]=+h[b>>3]+ +h[d>>3]*.6;h[n+8>>3]=+h[b+8>>3]+ +h[d+8>>3]*.6;h[q>>3]=+h[m>>3]+ +h[p>>3];h[q+8>>3]=+h[m+8>>3]+ +h[p+8>>3];h[q+16>>3]=+h[m>>3]-+h[p>>3];h[q+16+8>>3]=+h[m+8>>3]-+h[p+8>>3];h[q+32>>3]=+h[n>>3]-+h[p>>3];h[q+32+8>>3]=+h[n+8>>3]-+h[p+8>>3];h[q+48>>3]=+h[n>>3]+ +h[p>>3];h[q+48+8>>3]=+h[n+8>>3]+ +h[p+8>>3];if(!(c[l>>2]&64)){if(c[l>>2]&128){l=q+16|0;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];l=q+32|0;c[l>>2]=c[n>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2]}}else{c[q>>2]=c[m>>2];c[q+4>>2]=c[m+4>>2];c[q+8>>2]=c[m+8>>2];c[q+12>>2]=c[m+12>>2];m=q+48|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2]}tR(c[k>>2]|0,q,4,1);c[q>>2]=c[b>>2];c[q+4>>2]=c[b+4>>2];c[q+8>>2]=c[b+8>>2];c[q+12>>2]=c[b+12>>2];b=q+16|0;c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];c[b+12>>2]=c[o+12>>2];wR(c[k>>2]|0,q,2);i=j;return}function oH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+144|0;k=j+132|0;l=j+128|0;m=j+96|0;n=j+80|0;o=j+64|0;p=j;c[k>>2]=a;h[j+120>>3]=e;h[j+112>>3]=f;c[l>>2]=g;h[o>>3]=-+h[d+8>>3]*.4;h[o+8>>3]=+h[d>>3]*.4;h[m>>3]=+h[b>>3]+ +h[d>>3]*.8;h[m+8>>3]=+h[b+8>>3]+ +h[d+8>>3]*.8;h[n>>3]=+h[b>>3]+ +h[d>>3];h[n+8>>3]=+h[b+8>>3]+ +h[d+8>>3];h[p>>3]=+h[b>>3]+ +h[o>>3];h[p+8>>3]=+h[b+8>>3]+ +h[o+8>>3];h[p+16>>3]=+h[b>>3]-+h[o>>3];h[p+16+8>>3]=+h[b+8>>3]-+h[o+8>>3];h[p+32>>3]=+h[m>>3]-+h[o>>3];h[p+32+8>>3]=+h[m+8>>3]-+h[o+8>>3];h[p+48>>3]=+h[m>>3]+ +h[o>>3];h[p+48+8>>3]=+h[m+8>>3]+ +h[o+8>>3];if(!(c[l>>2]&64)){if(c[l>>2]&128){o=p+16|0;c[o>>2]=c[b>>2];c[o+4>>2]=c[b+4>>2];c[o+8>>2]=c[b+8>>2];c[o+12>>2]=c[b+12>>2];o=p+32|0;c[o>>2]=c[m>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2]}}else{c[p>>2]=c[b>>2];c[p+4>>2]=c[b+4>>2];c[p+8>>2]=c[b+8>>2];c[p+12>>2]=c[b+12>>2];b=p+48|0;c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];c[b+12>>2]=c[m+12>>2]}tR(c[k>>2]|0,p,4,((c[l>>2]&16|0)!=0^1)&1);c[p>>2]=c[m>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2];c[p+12>>2]=c[m+12>>2];m=p+16|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];wR(c[k>>2]|0,p,2);i=j;return}function pH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+160|0;k=j+148|0;l=j+144|0;m=j+112|0;n=j+96|0;o=j+80|0;p=j;c[k>>2]=a;h[j+136>>3]=e;h[j+128>>3]=f;c[l>>2]=g;h[o>>3]=-+h[d+8>>3]/3.0;h[o+8>>3]=+h[d>>3]/3.0;h[n>>3]=+h[b>>3]+ +h[d>>3]/2.0;h[n+8>>3]=+h[b+8>>3]+ +h[d+8>>3]/2.0;h[m>>3]=+h[b>>3]+ +h[d>>3];h[m+8>>3]=+h[b+8>>3]+ +h[d+8>>3];d=p+64|0;c[d>>2]=c[m>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];h[p+16>>3]=+h[n>>3]+ +h[o>>3];h[p+16+8>>3]=+h[n+8>>3]+ +h[o+8>>3];d=p+32|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];h[p+48>>3]=+h[n>>3]-+h[o>>3];h[p+48+8>>3]=+h[n+8>>3]-+h[o+8>>3];if(c[l>>2]&64){tR(c[k>>2]|0,p+32|0,3,((c[l>>2]&16|0)!=0^1)&1);i=j;return}o=c[k>>2]|0;k=((c[l>>2]&16|0)!=0^1)&1;if(c[l>>2]&128){tR(o,p,3,k);i=j;return}else{tR(o,p,4,k);i=j;return}}function qH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+64|0;k=j+60|0;l=j+56|0;m=j+32|0;n=j;c[k>>2]=a;h[j+48>>3]=e;h[j+40>>3]=f;c[l>>2]=g;h[m>>3]=+O(+(+h[d>>3]*+h[d>>3]+ +h[d+8>>3]*+h[d+8>>3]))/2.0;h[n>>3]=+h[b>>3]+ +h[d>>3]/2.0-+h[m>>3];h[n+8>>3]=+h[b+8>>3]+ +h[d+8>>3]/2.0-+h[m>>3];h[n+16>>3]=+h[b>>3]+ +h[d>>3]/2.0+ +h[m>>3];h[n+16+8>>3]=+h[b+8>>3]+ +h[d+8>>3]/2.0+ +h[m>>3];sR(c[k>>2]|0,n,2,((c[l>>2]&16|0)!=0^1)&1);i=j;return}function rH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0;j=i;i=i+208|0;k=j+204|0;l=j+184|0;m=j+200|0;n=j+176|0;o=j+160|0;p=j+144|0;q=j+128|0;r=j+64|0;s=j+32|0;c[k>>2]=a;h[j+192>>3]=e;h[l>>3]=f;c[m>>2]=g;if(+h[l>>3]>4.0)t=+h[l>>3]*.5/4.0;else t=.5;h[n>>3]=t;h[o>>3]=+h[b>>3]+ +h[d>>3];h[o+8>>3]=+h[b+8>>3]+ +h[d+8>>3];h[p>>3]=-+h[d+8>>3]*+h[n>>3];h[p+8>>3]=+h[d>>3]*+h[n>>3];h[q>>3]=+h[p+8>>3];h[q+8>>3]=-+h[p>>3];c[s>>2]=c[b>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2];c[s+12>>2]=c[b+12>>2];n=s+16|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];h[r>>3]=+h[b>>3]+ +h[p>>3]+ +h[q>>3];h[r+8>>3]=+h[b+8>>3]+ +h[p+8>>3]+ +h[q+8>>3];h[r+48>>3]=+h[b>>3]-+h[p>>3]+ +h[q>>3];h[r+48+8>>3]=+h[b+8>>3]-+h[p+8>>3]+ +h[q+8>>3];h[r+16>>3]=+h[b>>3]+ +h[p>>3]*.95+ +h[q>>3]-+h[q>>3]*4.0/3.0;h[r+16+8>>3]=+h[r+8>>3]-+h[q+8>>3]*4.0/3.0;h[r+32>>3]=+h[b>>3]-+h[p>>3]*.95+ +h[q>>3]-+h[q>>3]*4.0/3.0;h[r+32+8>>3]=+h[r+48+8>>3]-+h[q+8>>3]*4.0/3.0;wR(c[k>>2]|0,s,2);if(c[m>>2]&64){qO(j+16|0,r,3,.5,0,r);u=c[k>>2]|0;vR(u,r,4,0,0,0);i=j;return}if(!(c[m>>2]&128)){u=c[k>>2]|0;vR(u,r,4,0,0,0);i=j;return}qO(j,r,3,.5,r,0);u=c[k>>2]|0;vR(u,r,4,0,0,0);i=j;return}function sH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0;j=i;i=i+80|0;k=j+68|0;l=j+32|0;m=j;c[k>>2]=a;h[j+56>>3]=e;h[j+48>>3]=f;c[j+64>>2]=g;h[l>>3]=+h[b>>3]+ +h[d>>3];h[l+8>>3]=+h[b+8>>3]+ +h[d+8>>3];c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];b=m+16|0;c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];wR(c[k>>2]|0,m,2);i=j;return}function tH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=0;c[h>>2]=uH(c[e>>2]|0,54640,j)|0;if((c[h>>2]|0)==(c[e>>2]|0)){do{c[g>>2]=c[h>>2];c[h>>2]=uH(c[g>>2]|0,54656,j)|0}while((c[g>>2]|0)!=(c[h>>2]|0));c[h>>2]=uH(c[h>>2]|0,54704,j)|0}if((c[j>>2]|0)!=0?(c[j>>2]&15|0)==0:0)c[j>>2]=c[j>>2]|1;g=c[f>>2]|0;c[g>>2]=c[g>>2]|c[j>>2];i=d;return c[h>>2]|0}function uH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[k>>2]=0;c[l>>2]=c[f>>2];c[j>>2]=c[g>>2];while(1){if(!(c[c[j>>2]>>2]|0)){m=6;break}c[k>>2]=N3(c[c[j>>2]>>2]|0)|0;g=(P3(c[f>>2]|0,c[c[j>>2]>>2]|0,c[k>>2]|0)|0)==0;n=c[j>>2]|0;if(g)break;c[j>>2]=n+8}if((m|0)==6){o=c[l>>2]|0;i=e;return o|0}m=c[h>>2]|0;c[m>>2]=c[m>>2]|c[n+4>>2];c[l>>2]=(c[l>>2]|0)+(c[k>>2]|0);o=c[l>>2]|0;i=e;return o|0}function vH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+8|0;f=d;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;c[h>>2]=b;c[k>>2]=0;b=yA(c[h>>2]|0,137468)|0;c[j>>2]=b;if(!((b|0)!=0?(a[c[j>>2]>>0]|0)!=0:0))l=3;do if((l|0)==3){b=yA(c[h>>2]|0,137480)|0;c[j>>2]=b;if((b|0)!=0?(a[c[j>>2]>>0]|0)!=0:0)break;c[g>>2]=0;m=c[g>>2]|0;i=d;return m|0}while(0);c[k>>2]=tS(c[j>>2]|0,0,120)|0;if(!(c[k>>2]|0)){c[f>>2]=wB(c[h>>2]|0)|0;$z(0,137487,f)|0;c[e>>2]=c[j>>2];$z(3,137540,e)|0}c[g>>2]=c[k>>2];m=c[g>>2]|0;i=d;return m|0}function wH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;c[d>>2]=a;a=bK(304)|0;c[e>>2]=a;if(!a)$z(1,137548,b)|0;a=c[(c[d>>2]|0)+16>>2]|0;c[c[e>>2]>>2]=a;c[f>>2]=a;c[(c[d>>2]|0)+16>>2]=c[e>>2];d=c[e>>2]|0;if(c[f>>2]|0){a=d+16|0;g=(c[f>>2]|0)+16|0;j=a+40|0;do{c[a>>2]=c[g>>2];a=a+4|0;g=g+4|0}while((a|0)<(j|0));a=(c[e>>2]|0)+56|0;g=(c[f>>2]|0)+56|0;j=a+40|0;do{c[a>>2]=c[g>>2];a=a+4|0;g=g+4|0}while((a|0)<(j|0));c[(c[e>>2]|0)+144>>2]=c[(c[f>>2]|0)+144>>2];c[(c[e>>2]|0)+148>>2]=c[(c[f>>2]|0)+148>>2];h[(c[e>>2]|0)+152>>3]=+h[(c[f>>2]|0)+152>>3];c[(c[e>>2]|0)+136>>2]=c[(c[f>>2]|0)+136>>2];a=(c[e>>2]|0)+96|0;g=(c[f>>2]|0)+96|0;j=a+40|0;do{c[a>>2]=c[g>>2];a=a+4|0;g=g+4|0}while((a|0)<(j|0));k=c[e>>2]|0;i=b;return k|0}else{c[d+144>>2]=3;c[(c[e>>2]|0)+148>>2]=0;h[(c[e>>2]|0)+152>>3]=1.0;k=c[e>>2]|0;i=b;return k|0}return 0}function xH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+16>>2];if(c[e>>2]|0){O4(c[(c[e>>2]|0)+212>>2]|0);O4(c[(c[e>>2]|0)+208>>2]|0);O4(c[(c[e>>2]|0)+216>>2]|0);O4(c[(c[e>>2]|0)+220>>2]|0);O4(c[(c[e>>2]|0)+224>>2]|0);O4(c[(c[e>>2]|0)+228>>2]|0);O4(c[(c[e>>2]|0)+232>>2]|0);O4(c[(c[e>>2]|0)+236>>2]|0);O4(c[(c[e>>2]|0)+240>>2]|0);O4(c[(c[e>>2]|0)+244>>2]|0);O4(c[(c[e>>2]|0)+248>>2]|0);O4(c[(c[e>>2]|0)+252>>2]|0);O4(c[(c[e>>2]|0)+256>>2]|0);O4(c[(c[e>>2]|0)+272>>2]|0);O4(c[(c[e>>2]|0)+284>>2]|0);O4(c[(c[e>>2]|0)+280>>2]|0);c[(c[d>>2]|0)+16>>2]=c[c[e>>2]>>2];O4(c[e>>2]|0);i=b;return}else La(137574,137578,119,137585)}function yH(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+48|0;m=l+36|0;n=l+32|0;o=l+28|0;p=l+24|0;q=l+20|0;r=l+16|0;s=l+12|0;t=l+8|0;u=l+4|0;v=l;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=j;c[s>>2]=k;c[t>>2]=c[(c[m>>2]|0)+16>>2];c[u>>2]=c[(c[m>>2]|0)+152>>2];c[v>>2]=0;if((c[u>>2]&32768|0)!=0&(c[n>>2]|0)!=0)c[(c[t>>2]|0)+192>>2]=c[n>>2];if(((c[u>>2]&65536|0)!=0?(n=WJ(c[r>>2]|0,c[s>>2]|0)|0,c[(c[t>>2]|0)+212>>2]=n,(c[o>>2]|0)!=0):0)?(a[c[o>>2]>>0]|0)!=0:0){n=WJ(c[o>>2]|0,c[s>>2]|0)|0;c[(c[t>>2]|0)+208>>2]=n;c[v>>2]=1}do if(c[u>>2]&4194304){if((c[p>>2]|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){n=WJ(c[p>>2]|0,c[s>>2]|0)|0;c[(c[t>>2]|0)+228>>2]=n;n=(c[t>>2]|0)+260|0;b[n>>1]=b[n>>1]&-2|1;c[v>>2]=1;break}if(c[(c[t>>2]|0)+192>>2]|0){n=M3(c[(c[t>>2]|0)+192>>2]|0)|0;c[(c[t>>2]|0)+228>>2]=n;c[v>>2]=1}}while(0);if(!((c[u>>2]&8388608|0)!=0&(c[q>>2]|0)!=0)){w=c[v>>2]|0;i=l;return w|0}if(!(a[c[q>>2]>>0]|0)){w=c[v>>2]|0;i=l;return w|0}u=WJ(c[q>>2]|0,c[s>>2]|0)|0;c[(c[t>>2]|0)+244>>2]=u;c[v>>2]=1;w=c[v>>2]|0;i=l;return w|0}function zH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+112|0;g=f;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f+40|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=c[(c[c[j>>2]>>2]|0)+168>>2];c[o>>2]=c[(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)+92>>2];MH(c[j>>2]|0,c[l>>2]|0);c[m>>2]=yA(c[k>>2]|0,179069)|0;if((c[m>>2]|0)!=0?(a[c[m>>2]>>0]|0)!=0:0){gA(c[l>>2]|0,c[m>>2]|0)|0;if((c[(c[l>>2]|0)+4>>2]|0)>>>0>=(c[(c[l>>2]|0)+8>>2]|0)>>>0)eA(c[l>>2]|0,1)|0;m=(c[l>>2]|0)+4|0;j=c[m>>2]|0;c[m>>2]=j+1;a[j>>0]=0;j=c[c[l>>2]>>2]|0;c[(c[l>>2]|0)+4>>2]=j;c[h>>2]=j;s=c[h>>2]|0;i=f;return s|0}if((c[o>>2]|0)!=0?(c[k>>2]|0)!=(c[n>>2]|0):0){gA(c[l>>2]|0,c[o>>2]|0)|0;if((c[(c[l>>2]|0)+4>>2]|0)>>>0>=(c[(c[l>>2]|0)+8>>2]|0)>>>0)eA(c[l>>2]|0,1)|0;o=(c[l>>2]|0)+4|0;j=c[o>>2]|0;c[o>>2]=j+1;a[j>>0]=95}a:do switch(BC(c[k>>2]|0)|0){case 0:{c[p>>2]=(c[c[k>>2]>>2]|0)>>>4;if((c[n>>2]|0)==(c[k>>2]|0)){c[q>>2]=149098;break a}else{c[q>>2]=137599;break a}break}case 1:{c[p>>2]=(c[c[k>>2]>>2]|0)>>>4;c[q>>2]=149084;break}case 2:{c[p>>2]=(c[c[k>>2]>>2]|0)>>>4;c[q>>2]=149079;break}default:{}}while(0);gA(c[l>>2]|0,c[q>>2]|0)|0;c[g>>2]=c[p>>2];k3(r,137605,g)|0;gA(c[l>>2]|0,r)|0;if((c[(c[l>>2]|0)+4>>2]|0)>>>0>=(c[(c[l>>2]|0)+8>>2]|0)>>>0)eA(c[l>>2]|0,1)|0;r=(c[l>>2]|0)+4|0;g=c[r>>2]|0;c[r>>2]=g+1;a[g>>0]=0;g=c[c[l>>2]>>2]|0;c[(c[l>>2]|0)+4>>2]=g;c[h>>2]=g;s=c[h>>2]|0;i=f;return s|0}function AH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0;e=i;i=i+112|0;f=e+56|0;j=e+100|0;k=e+96|0;l=e+92|0;m=e+88|0;n=e+84|0;o=e+80|0;p=e+76|0;q=e+48|0;r=e+32|0;s=e+16|0;t=e+72|0;u=e+8|0;v=e;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;h[q>>3]=+h[(c[(c[k>>2]|0)+16>>2]|0)+152>>3];c[p>>2]=NH(c[m>>2]|0,0,n)|0;if((c[p>>2]|0)==1|(c[p>>2]|0)==2){c[j>>2]=c[p>>2];w=c[j>>2]|0;i=e;return w|0}h[r>>3]=(+h[c[l>>2]>>3]+ +h[(c[l>>2]|0)+16>>3])/2.0;h[r+8>>3]=(+h[(c[l>>2]|0)+8>>3]+ +h[(c[l>>2]|0)+16+8>>3])/2.0;h[s>>3]=+h[(c[l>>2]|0)+16>>3]-+h[r>>3];h[s+8>>3]=+h[(c[l>>2]|0)+16+8>>3]-+h[r+8>>3];if(+h[q>>3]>.5)zR(c[k>>2]|0,.5);h[u>>3]=0.0;c[o>>2]=c[(c[n>>2]|0)+8>>2];while(1){if(!(c[c[o>>2]>>2]|0))break;if(!(+g[(c[o>>2]|0)+4>>2]==0.0)){if(c[c[o>>2]>>2]|0)x=c[c[o>>2]>>2]|0;else x=174917;pR(c[k>>2]|0,x);if(!(c[(c[o>>2]|0)+12>>2]|0))h[v>>3]=6.283185307179586;else h[v>>3]=+h[u>>3]+ +g[(c[o>>2]|0)+4>>2]*6.283185307179586;y=+h[s>>3];z=+h[s+8>>3];A=+h[u>>3];B=+h[v>>3];c[f>>2]=c[r>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[t>>2]=kT(f,y,z,A,B)|0;vR(c[k>>2]|0,c[c[t>>2]>>2]|0,c[(c[t>>2]|0)+4>>2]|0,0,0,1);h[u>>3]=+h[v>>3];hY(c[t>>2]|0)}c[o>>2]=(c[o>>2]|0)+12}if(+h[q>>3]>.5)zR(c[k>>2]|0,+h[q>>3]);OH(c[n>>2]|0);c[j>>2]=c[p>>2];w=c[j>>2]|0;i=e;return w|0}function BH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+128|0;j=f+116|0;k=f+112|0;l=f+108|0;m=f+104|0;n=f+100|0;o=f+96|0;p=f+92|0;q=f+88|0;r=f+80|0;s=f+16|0;t=f+8|0;u=f;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;h[u>>3]=+h[(c[(c[k>>2]|0)+16>>2]|0)+152>>3];c[q>>2]=NH(c[m>>2]|0,0,o)|0;if((c[q>>2]|0)==1|(c[q>>2]|0)==2){c[j>>2]=c[q>>2];v=c[j>>2]|0;i=f;return v|0}m=c[l>>2]|0;if(c[n>>2]|0){n=m+32|0;c[s>>2]=c[n>>2];c[s+4>>2]=c[n+4>>2];c[s+8>>2]=c[n+8>>2];c[s+12>>2]=c[n+12>>2];n=s+16|0;e=(c[l>>2]|0)+48|0;c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];e=s+32|0;n=c[l>>2]|0;c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];c[e+12>>2]=c[n+12>>2];n=s+48|0;e=(c[l>>2]|0)+16|0;c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2]}else{c[s>>2]=c[m>>2];c[s+4>>2]=c[m+4>>2];c[s+8>>2]=c[m+8>>2];c[s+12>>2]=c[m+12>>2];m=s+16|0;e=(c[l>>2]|0)+16|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];e=s+32|0;m=(c[l>>2]|0)+32|0;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];m=s+48|0;e=(c[l>>2]|0)+48|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2]}h[t>>3]=+h[s+16>>3];h[r>>3]=+h[s+16>>3]-+h[s>>3];w=+h[s>>3];h[s+32>>3]=w;h[s+16>>3]=w;if(+h[u>>3]>.5)zR(c[k>>2]|0,.5);c[p>>2]=c[(c[o>>2]|0)+8>>2];while(1){if(!(c[c[p>>2]>>2]|0))break;if(!(+g[(c[p>>2]|0)+4>>2]==0.0)){if(c[c[p>>2]>>2]|0)x=c[c[p>>2]>>2]|0;else x=174917;pR(c[k>>2]|0,x);if(!(c[(c[p>>2]|0)+12>>2]|0)){w=+h[t>>3];h[s+32>>3]=w;h[s+16>>3]=w}else{w=+h[s>>3]+ +h[r>>3]*+g[(c[p>>2]|0)+4>>2];h[s+32>>3]=w;h[s+16>>3]=w}tR(c[k>>2]|0,s,4,1);w=+h[s+16>>3];h[s+48>>3]=w;h[s>>3]=w}c[p>>2]=(c[p>>2]|0)+12}if(+h[u>>3]>.5)zR(c[k>>2]|0,+h[u>>3]);OH(c[o>>2]|0);c[j>>2]=c[q>>2];v=c[j>>2]|0;i=f;return v|0}function CH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+16>>2];c[g>>2]=c[(c[e>>2]|0)+152>>2];if(!(c[g>>2]&4259840)){i=d;return}a=(c[f>>2]|0)+264|0;if(c[g>>2]&131072){c[a>>2]=0;c[(c[f>>2]|0)+268>>2]=2}else{c[a>>2]=2;c[(c[f>>2]|0)+268>>2]=4}O4(c[(c[f>>2]|0)+272>>2]|0);a=bK(c[(c[f>>2]|0)+268>>2]<<4)|0;c[h>>2]=a;c[(c[f>>2]|0)+272>>2]=a;a=c[h>>2]|0;c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];a=(c[h>>2]|0)+16|0;f=b+16|0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];if(!(c[g>>2]&8192))UQ(c[e>>2]|0,c[h>>2]|0,c[h>>2]|0,2)|0;if(c[g>>2]&131072){i=d;return}DJ(c[h>>2]|0);i=d;return}function DH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0;d=i;i=i+160|0;e=d+152|0;f=d+148|0;g=d+144|0;j=d+80|0;k=d+16|0;l=d;c[e>>2]=a;c[f>>2]=b;if(((((((((((((((!(+h[c[f>>2]>>3]>+h[(c[e>>2]|0)+16>>3])?!(+h[c[f>>2]>>3]<+h[c[e>>2]>>3]):0)?!(+h[(c[f>>2]|0)+8>>3]>+h[(c[e>>2]|0)+16+8>>3]):0)?!(+h[(c[f>>2]|0)+8>>3]<+h[(c[e>>2]|0)+8>>3]):0)?!(+h[(c[f>>2]|0)+16>>3]>+h[(c[e>>2]|0)+16>>3]):0)?!(+h[(c[f>>2]|0)+16>>3]<+h[c[e>>2]>>3]):0)?!(+h[(c[f>>2]|0)+16+8>>3]>+h[(c[e>>2]|0)+16+8>>3]):0)?!(+h[(c[f>>2]|0)+16+8>>3]<+h[(c[e>>2]|0)+8>>3]):0)?!(+h[(c[f>>2]|0)+32>>3]>+h[(c[e>>2]|0)+16>>3]):0)?!(+h[(c[f>>2]|0)+32>>3]<+h[c[e>>2]>>3]):0)?!(+h[(c[f>>2]|0)+32+8>>3]>+h[(c[e>>2]|0)+16+8>>3]):0)?!(+h[(c[f>>2]|0)+32+8>>3]<+h[(c[e>>2]|0)+8>>3]):0)?!(+h[(c[f>>2]|0)+48>>3]>+h[(c[e>>2]|0)+16>>3]):0)?!(+h[(c[f>>2]|0)+48>>3]<+h[c[e>>2]>>3]):0)?!(+h[(c[f>>2]|0)+48+8>>3]>+h[(c[e>>2]|0)+16+8>>3]):0)?!(+h[(c[f>>2]|0)+48+8>>3]<+h[(c[e>>2]|0)+8>>3]):0){i=d;return}if(!(PH(c[f>>2]|0)|0)){qO(l,c[f>>2]|0,3,.5,j,k);DH(c[e>>2]|0,j);DH(c[e>>2]|0,k);i=d;return}c[g>>2]=0;while(1){if((c[g>>2]|0)>=4)break;m=+h[(c[f>>2]|0)+(c[g>>2]<<4)>>3];k=c[e>>2]|0;if(!(+h[(c[f>>2]|0)+(c[g>>2]<<4)>>3]>+h[(c[e>>2]|0)+16>>3])){if(m<+h[k>>3])h[c[e>>2]>>3]=+h[(c[f>>2]|0)+(c[g>>2]<<4)>>3]}else h[k+16>>3]=m;m=+h[(c[f>>2]|0)+(c[g>>2]<<4)+8>>3];k=c[e>>2]|0;if(!(+h[(c[f>>2]|0)+(c[g>>2]<<4)+8>>3]>+h[(c[e>>2]|0)+16+8>>3])){if(m<+h[k+8>>3])h[(c[e>>2]|0)+8>>3]=+h[(c[f>>2]|0)+(c[g>>2]<<4)+8>>3]}else h[k+16+8>>3]=m;c[g>>2]=(c[g>>2]|0)+1}i=d;return}function EH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+384|0;f=e+328|0;g=e+368|0;j=e+364|0;k=e+360|0;l=e+356|0;m=e+320|0;n=e+352|0;o=e+288|0;p=e+272|0;q=e+240|0;r=e+208|0;s=e+348|0;t=e+176|0;u=e+144|0;v=e+344|0;w=e+112|0;x=e+80|0;y=e+48|0;z=e+32|0;A=e;c[g>>2]=d;c[j>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+144>>2];h[m>>3]=0.0;c[n>>2]=0;d=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[r>>2]=c[d>>2];c[r+4>>2]=c[d+4>>2];c[r+8>>2]=c[d+8>>2];c[r+12>>2]=c[d+12>>2];c[r+16>>2]=c[d+16>>2];c[r+20>>2]=c[d+20>>2];c[r+24>>2]=c[d+24>>2];c[r+28>>2]=c[d+28>>2];c[s>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+88>>2];c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;c[u+20>>2]=0;c[u+24>>2]=0;c[u+28>>2]=0;if(!(c[s>>2]|0)){c[b>>2]=c[r>>2];c[b+4>>2]=c[r+4>>2];c[b+8>>2]=c[r+8>>2];c[b+12>>2]=c[r+12>>2];c[b+16>>2]=c[r+16>>2];c[b+20>>2]=c[r+20>>2];c[b+24>>2]=c[r+24>>2];c[b+28>>2]=c[r+28>>2];i=e;return}if(+h[r>>3]==+h[r+16>>3]?+h[r+8>>3]==+h[r+16+8>>3]:0){h[r+8>>3]=1797693134862315708145274.0e284;h[r>>3]=1797693134862315708145274.0e284;h[r+16+8>>3]=-1797693134862315708145274.0e284;h[r+16>>3]=-1797693134862315708145274.0e284}c[k>>2]=c[(c[s>>2]|0)+8>>2];c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[c[s>>2]>>2]|0))break;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];c[t+24>>2]=c[u+24>>2];c[t+28>>2]=c[u+28>>2];switch(c[c[k>>2]>>2]|0){case 1:case 0:{h[o>>3]=+h[(c[k>>2]|0)+8>>3]-+h[(c[k>>2]|0)+8+16>>3];h[o+8>>3]=+h[(c[k>>2]|0)+8+8>>3]-+h[(c[k>>2]|0)+8+24>>3];h[o+16>>3]=+h[(c[k>>2]|0)+8>>3]+ +h[(c[k>>2]|0)+8+16>>3];h[o+16+8>>3]=+h[(c[k>>2]|0)+8+8>>3]+ +h[(c[k>>2]|0)+8+24>>3];g=(c[k>>2]|0)+80|0;c[g>>2]=c[o>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];g=(c[k>>2]|0)+80+16|0;d=o+16|0;c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];QH(r,f);d=o+16|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];QH(r,f);break}case 3:case 2:{d=(c[k>>2]|0)+80|0;RH(w,c[(c[k>>2]|0)+8+4>>2]|0,c[(c[k>>2]|0)+8>>2]|0,r);c[d>>2]=c[w>>2];c[d+4>>2]=c[w+4>>2];c[d+8>>2]=c[w+8>>2];c[d+12>>2]=c[w+12>>2];c[d+16>>2]=c[w+16>>2];c[d+20>>2]=c[w+20>>2];c[d+24>>2]=c[w+24>>2];c[d+28>>2]=c[w+28>>2];break}case 5:case 4:{d=(c[k>>2]|0)+80|0;RH(x,c[(c[k>>2]|0)+8+4>>2]|0,c[(c[k>>2]|0)+8>>2]|0,r);c[d>>2]=c[x>>2];c[d+4>>2]=c[x+4>>2];c[d+8>>2]=c[x+8>>2];c[d+12>>2]=c[x+12>>2];c[d+16>>2]=c[x+16>>2];c[d+20>>2]=c[x+20>>2];c[d+24>>2]=c[x+24>>2];c[d+28>>2]=c[x+28>>2];break}case 6:{d=(c[k>>2]|0)+80|0;RH(y,c[(c[k>>2]|0)+8+4>>2]|0,c[(c[k>>2]|0)+8>>2]|0,r);c[d>>2]=c[y>>2];c[d+4>>2]=c[y+4>>2];c[d+8>>2]=c[y+8>>2];c[d+12>>2]=c[y+12>>2];c[d+16>>2]=c[y+16>>2];c[d+20>>2]=c[y+20>>2];c[d+24>>2]=c[y+24>>2];c[d+28>>2]=c[y+28>>2];break}case 7:{d=bK(56)|0;c[(c[k>>2]|0)+112>>2]=d;d=M3(c[(c[k>>2]|0)+8+32>>2]|0)|0;c[c[(c[k>>2]|0)+112>>2]>>2]=d;a[(c[(c[k>>2]|0)+112>>2]|0)+48>>0]=a[137609+(c[(c[k>>2]|0)+8+16>>2]|0)>>0]|0;c[t>>2]=c[n>>2];h[t+16>>3]=+h[m>>3];d=t+24|0;c[d>>2]=c[d>>2]&-128|c[v>>2]&127;d=Hb[c[c[(c[j>>2]|0)+144>>2]>>2]&63](c[(c[j>>2]|0)+144>>2]|0,t,1)|0;c[(c[(c[k>>2]|0)+112>>2]|0)+4>>2]=d;SN(z,c[j>>2]|0,c[(c[k>>2]|0)+112>>2]|0);c[p>>2]=c[z>>2];c[p+4>>2]=c[z+4>>2];c[p+8>>2]=c[z+8>>2];c[p+12>>2]=c[z+12>>2];SH(A,+h[(c[k>>2]|0)+8>>3],+h[(c[k>>2]|0)+8+8>>3],c[(c[k>>2]|0)+112>>2]|0);c[q>>2]=c[A>>2];c[q+4>>2]=c[A+4>>2];c[q+8>>2]=c[A+8>>2];c[q+12>>2]=c[A+12>>2];c[q+16>>2]=c[A+16>>2];c[q+20>>2]=c[A+20>>2];c[q+24>>2]=c[A+24>>2];c[q+28>>2]=c[A+28>>2];d=(c[k>>2]|0)+80|0;c[d>>2]=c[q>>2];c[d+4>>2]=c[q+4>>2];c[d+8>>2]=c[q+8>>2];c[d+12>>2]=c[q+12>>2];c[d+16>>2]=c[q+16>>2];c[d+20>>2]=c[q+20>>2];c[d+24>>2]=c[q+24>>2];c[d+28>>2]=c[q+28>>2];c[f>>2]=c[q>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];QH(r,f);d=q+16|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];QH(r,f);if(!(c[(c[s>>2]|0)+12>>2]|0))c[(c[s>>2]|0)+12>>2]=100;break}case 10:{h[m>>3]=+h[(c[k>>2]|0)+8>>3];c[n>>2]=c[(c[k>>2]|0)+8+8>>2];break}case 15:{c[v>>2]=c[(c[k>>2]|0)+8>>2];break}default:{}}c[k>>2]=(c[k>>2]|0)+120;c[l>>2]=(c[l>>2]|0)+1}c[b>>2]=c[r>>2];c[b+4>>2]=c[r+4>>2];c[b+8>>2]=c[r+8>>2];c[b+12>>2]=c[r+12>>2];c[b+16>>2]=c[r+16>>2];c[b+20>>2]=c[r+20>>2];c[b+24>>2]=c[r+24>>2];c[b+28>>2]=c[r+28>>2];i=e;return}function FH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=b;c[g>>2]=d;c[l>>2]=c[(c[f>>2]|0)+152>>2];h[(c[f>>2]|0)+488>>3]=+h[(c[f>>2]|0)+352>>3]*+h[(c[f>>2]|0)+432>>3]/72.0;h[(c[f>>2]|0)+488+8>>3]=+h[(c[f>>2]|0)+352>>3]*+h[(c[f>>2]|0)+432+8>>3]/72.0;h[(c[f>>2]|0)+520>>3]=+h[(c[f>>2]|0)+432>>3]/72.0;h[(c[f>>2]|0)+520+8>>3]=+h[(c[f>>2]|0)+432+8>>3]/72.0;if((c[13802]|0)!=0?1:(c[(c[f>>2]|0)+152>>2]&4096|0)!=0){d=(c[f>>2]|0)+520+8|0;h[d>>3]=+h[d>>3]*-1.0}n=+((c[(c[f>>2]|0)+448>>2]|0)>>>0);d=(c[f>>2]|0)+488|0;if(c[(c[f>>2]|0)+360>>2]|0){h[(c[f>>2]|0)+368+8>>3]=n/+h[d+8>>3];h[(c[f>>2]|0)+368>>3]=+((c[(c[f>>2]|0)+452>>2]|0)>>>0)/+h[(c[f>>2]|0)+488>>3]}else{h[(c[f>>2]|0)+368>>3]=n/+h[d>>3];h[(c[f>>2]|0)+368+8>>3]=+((c[(c[f>>2]|0)+452>>2]|0)>>>0)/+h[(c[f>>2]|0)+488+8>>3]}d=c[g>>2]|0;c[k>>2]=hO(d,qA(c[g>>2]|0,0,139314,0)|0,178518)|0;xR(c[f>>2]|0,c[k>>2]|0);c[(c[f>>2]|0)+160>>2]=0;UH(c[f>>2]|0,c[g>>2]|0);if(c[l>>2]&2)VH(c[f>>2]|0,c[g>>2]|0);c[j>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;a[(c[(c[j>>2]|0)+8>>2]|0)+116>>0]=0;c[j>>2]=aC(c[g>>2]|0,c[j>>2]|0)|0}WH(c[f>>2]|0,m);while(1){j=(XH(c[f>>2]|0)|0)<<24>>24!=0;o=c[f>>2]|0;if(!j)break;if((YH(o)|0)>1)ZQ(c[f>>2]|0);ZH(c[f>>2]|0);while(1){j=(_H(c[f>>2]|0)|0)<<24>>24!=0;p=c[f>>2]|0;if(!j)break;$H(p,c[g>>2]|0);aI(c[f>>2]|0)}if((YH(p)|0)>1)_Q(c[f>>2]|0);bI(c[f>>2]|0,m)}cI(o,c[g>>2]|0);i=e;return}function GH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[13702]|0))c[13702]=Nz(54812,c[12989]|0)|0;if(Hb[c[c[13702]>>2]&63](c[13702]|0,c[e>>2]|0,4)|0){c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}else{a=c[c[13702]>>2]|0;g=c[13702]|0;h=M3(c[e>>2]|0)|0;Hb[a&63](g,h,1)|0;c[d>>2]=1;f=c[d>>2]|0;i=b;return f|0}return 0}function HH(e,f,j){e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;k=i;i=i+208|0;l=k+80|0;m=k+72|0;n=k+196|0;o=k+192|0;p=k+188|0;q=k+184|0;r=k+180|0;s=k+176|0;t=k+172|0;u=k+8|0;v=k+168|0;w=k+164|0;x=k+160|0;y=k+156|0;z=k+152|0;A=k+148|0;B=k+144|0;C=k+140|0;D=k+136|0;E=k+132|0;F=k+128|0;G=k;H=k+120|0;I=k+116|0;J=k+112|0;c[n>>2]=e;c[o>>2]=f;c[p>>2]=j;c[r>>2]=1;while(1){if((c[r>>2]|0)>(c[(c[(c[o>>2]|0)+8>>2]|0)+180>>2]|0))break;c[A>>2]=c[(c[(c[(c[o>>2]|0)+8>>2]|0)+184>>2]|0)+(c[r>>2]<<2)>>2];if((dI(c[n>>2]|0,c[A>>2]|0)|0)&255){if(c[p>>2]&4)HH(c[n>>2]|0,c[A>>2]|0,c[p>>2]|0);eI(c[n>>2]|0,c[A>>2]|0);c[D>>2]=c[(c[n>>2]|0)+16>>2];if(c[(c[D>>2]|0)+208>>2]|0)K=1;else K=((b[(c[D>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)!=0;c[F>>2]=K&1;dT(yA(c[A>>2]|0,137612)|0);if((c[F>>2]|0)!=0?(c[p>>2]&4|0)==0:0){j=c[n>>2]|0;f=(c[(c[A>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[l+16>>2]=c[f+16>>2];c[l+20>>2]=c[f+20>>2];c[l+24>>2]=c[f+24>>2];c[l+28>>2]=c[f+28>>2];CH(j,l);jR(c[n>>2]|0,c[(c[D>>2]|0)+208>>2]|0,c[(c[D>>2]|0)+228>>2]|0,c[(c[D>>2]|0)+244>>2]|0,c[(c[D>>2]|0)+212>>2]|0)}c[t>>2]=0;c[s>>2]=0;j=fI(c[A>>2]|0,s)|0;c[y>>2]=j;if((j|0)!=0?(rR(c[n>>2]|0,c[y>>2]|0),(c[s>>2]&1|0)!=0):0)c[t>>2]=1;c[x>>2]=0;c[w>>2]=0;j=c[A>>2]|0;do if(!(d[(c[(c[A>>2]|0)+8>>2]|0)+112>>0]&1)){f=c[A>>2]|0;if(d[(c[j+8>>2]|0)+112>>0]&2){c[x>>2]=iO(f,c[13803]|0,143682)|0;c[w>>2]=iO(c[A>>2]|0,c[13804]|0,143690)|0;c[t>>2]=1;break}e=c[A>>2]|0;if(d[(c[f+8>>2]|0)+112>>0]&8){c[x>>2]=iO(e,c[13807]|0,143698)|0;c[w>>2]=iO(c[A>>2]|0,c[13808]|0,143706)|0;c[t>>2]=1;break}f=c[A>>2]|0;if(d[(c[e+8>>2]|0)+112>>0]&4){c[x>>2]=iO(f,c[13805]|0,143714)|0;c[w>>2]=iO(c[A>>2]|0,c[13806]|0,143722)|0;c[t>>2]=1;break}e=yA(f,178832)|0;c[v>>2]=e;if((e|0)!=0?(a[c[v>>2]>>0]|0)!=0:0){e=c[v>>2]|0;c[x>>2]=e;c[w>>2]=e}e=yA(c[A>>2]|0,175307)|0;c[v>>2]=e;if((e|0)!=0?(a[c[v>>2]>>0]|0)!=0:0)c[x>>2]=c[v>>2];e=yA(c[A>>2]|0,139210)|0;c[v>>2]=e;if((e|0)!=0?(a[c[v>>2]>>0]|0)!=0:0)c[w>>2]=c[v>>2];if((!((c[t>>2]|0)!=0&(c[w>>2]|0)!=0)?(e=yA(c[A>>2]|0,178986)|0,c[v>>2]=e,(e|0)!=0):0)?(a[c[v>>2]>>0]|0)!=0:0){c[w>>2]=c[v>>2];c[t>>2]=1}}else{c[x>>2]=iO(j,c[13803]|0,143666)|0;c[w>>2]=iO(c[A>>2]|0,c[13804]|0,143674)|0;c[t>>2]=1}while(0);if(!(c[x>>2]|0))c[x>>2]=174917;if(!(c[w>>2]|0))c[w>>2]=172403;c[H>>2]=0;do if(c[t>>2]|0){j=(IH(c[w>>2]|0,H,I)|0)<<24>>24!=0;e=c[n>>2]|0;if(!j){pR(e,c[w>>2]|0);break}pR(e,c[H>>2]|0);e=c[n>>2]|0;if(c[H+4>>2]|0){j=c[H+4>>2]|0;f=eO(c[A>>2]|0,c[13812]|0,0,0)|0;qR(e,j,f,+g[I>>2])}else{f=eO(c[A>>2]|0,c[13812]|0,0,0)|0;qR(e,174917,f,+g[I>>2])}if(c[s>>2]&2){c[t>>2]=3;break}else{c[t>>2]=2;break}}while(0);if(((c[13811]|0)!=0?(f=zA(c[A>>2]|0,c[13811]|0)|0,c[z>>2]=f,(f|0)!=0):0)?(a[c[z>>2]>>0]|0)!=0:0){h[G>>3]=+fO(c[A>>2]|0,c[13811]|0,1.0,0.0);zR(c[n>>2]|0,+h[G>>3])}do if(c[s>>2]&4){f=eO(c[A>>2]|0,c[13810]|0,1,0)|0;c[q>>2]=f;if((f|0)!=0|(c[t>>2]|0)!=0){f=(c[(c[A>>2]|0)+8>>2]|0)+16|0;c[u>>2]=c[f>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];f=u+32|0;e=(c[(c[A>>2]|0)+8>>2]|0)+16+16|0;c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];h[u+16>>3]=+h[u+32>>3];h[u+16+8>>3]=+h[u+8>>3];h[u+48>>3]=+h[u>>3];h[u+48+8>>3]=+h[u+32+8>>3];e=c[n>>2]|0;if(c[q>>2]|0)oR(e,c[x>>2]|0);else oR(e,175430);cM(c[n>>2]|0,u,4,c[s>>2]|0,c[t>>2]|0)}}else{if(!(c[s>>2]&64)){if(eO(c[A>>2]|0,c[13810]|0,1,0)|0){oR(c[n>>2]|0,c[x>>2]|0);e=c[n>>2]|0;f=(c[(c[A>>2]|0)+8>>2]|0)+16|0;j=c[t>>2]|0;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[l+16>>2]=c[f+16>>2];c[l+20>>2]=c[f+20>>2];c[l+24>>2]=c[f+24>>2];c[l+28>>2]=c[f+28>>2];uR(e,l,j);break}if(!(c[t>>2]|0))break;oR(c[n>>2]|0,175430);j=c[n>>2]|0;e=(c[(c[A>>2]|0)+8>>2]|0)+16|0;f=c[t>>2]|0;c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];c[l+16>>2]=c[e+16>>2];c[l+20>>2]=c[e+20>>2];c[l+24>>2]=c[e+24>>2];c[l+28>>2]=c[e+28>>2];uR(j,l,f);break}f=(c[(c[A>>2]|0)+8>>2]|0)+16|0;c[u>>2]=c[f>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];f=u+32|0;j=(c[(c[A>>2]|0)+8>>2]|0)+16+16|0;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];h[u+16>>3]=+h[u+32>>3];h[u+16+8>>3]=+h[u+8>>3];h[u+48>>3]=+h[u>>3];h[u+48+8>>3]=+h[u+32+8>>3];j=(eO(c[A>>2]|0,c[13810]|0,1,0)|0)==0;f=c[n>>2]|0;if(j)oR(f,175430);else oR(f,c[x>>2]|0);c[J>>2]=BH(c[n>>2]|0,u,c[w>>2]|0,0)|0;if((c[J>>2]|0)>1){c[m>>2]=wB(c[A>>2]|0)|0;$z(3,137624,m)|0}f=c[n>>2]|0;j=(c[(c[A>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];uR(f,l,0)}while(0);O4(c[H>>2]|0);f=c[(c[(c[A>>2]|0)+8>>2]|0)+12>>2]|0;c[E>>2]=f;if(f)VJ(c[n>>2]|0,5,c[E>>2]|0);if(c[F>>2]|0){if(c[p>>2]&4){f=c[n>>2]|0;j=(c[(c[A>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[j>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];CH(f,l);jR(c[n>>2]|0,c[(c[D>>2]|0)+208>>2]|0,c[(c[D>>2]|0)+228>>2]|0,c[(c[D>>2]|0)+244>>2]|0,c[(c[D>>2]|0)+212>>2]|0)}kR(c[n>>2]|0)}a:do if(c[p>>2]&8){c[B>>2]=$B(c[A>>2]|0)|0;while(1){if(!(c[B>>2]|0))break a;gI(c[n>>2]|0,c[B>>2]|0);c[C>>2]=OA(c[A>>2]|0,c[B>>2]|0)|0;while(1){if(!(c[C>>2]|0))break;hI(c[n>>2]|0,c[C>>2]|0);c[C>>2]=QA(c[A>>2]|0,c[C>>2]|0)|0}c[B>>2]=aC(c[A>>2]|0,c[B>>2]|0)|0}}while(0);iI(c[n>>2]|0,c[o>>2]|0);if(!(c[p>>2]&4))HH(c[n>>2]|0,c[A>>2]|0,c[p>>2]|0)}c[r>>2]=(c[r>>2]|0)+1}i=k;return}function IH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;h=f;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[o>>2]=NH(c[k>>2]|0,0,n)|0;if(((c[o>>2]|0)==0?(c[c[n>>2]>>2]|0)>=2:0)?(c[c[(c[n>>2]|0)+8>>2]>>2]|0)!=0:0){if((c[c[n>>2]>>2]|0)>2)$z(0,137639,h)|0;h=cK((N3(c[k>>2]|0)|0)+1|0)|0;c[c[l>>2]>>2]=h;K3(c[c[l>>2]>>2]|0,c[c[(c[n>>2]|0)+8>>2]>>2]|0)|0;h=c[l>>2]|0;if(c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0){k=c[h>>2]|0;o=k+((N3(c[c[l>>2]>>2]|0)|0)+1)|0;c[(c[l>>2]|0)+4>>2]=o;K3(c[(c[l>>2]|0)+4>>2]|0,c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2]|0)|0}else c[h+4>>2]=0;h=c[(c[n>>2]|0)+8>>2]|0;do if(!(a[(c[(c[n>>2]|0)+8>>2]|0)+8>>0]|0))if(a[h+12+8>>0]|0){g[c[m>>2]>>2]=1.0-+g[(c[(c[n>>2]|0)+8>>2]|0)+12+4>>2];break}else{g[c[m>>2]>>2]=0.0;break}else g[c[m>>2]>>2]=+g[h+4>>2];while(0);OH(c[n>>2]|0);a[j>>0]=1;p=a[j>>0]|0;i=f;return p|0}c[c[l>>2]>>2]=0;a[j>>0]=0;p=a[j>>0]|0;i=f;return p|0}function JH(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+208|0;f=e+24|0;g=e+16|0;h=e+8|0;j=e;k=e+64|0;l=e+60|0;m=e+56|0;n=e+200|0;o=e+52|0;p=e+48|0;q=e+32|0;c[l>>2]=b;c[m>>2]=0;a[n>>0]=0;if(a[137705]|0){dA(54848,128,137706);a[137705]=0}dA(q,128,e+72|0);c[o>>2]=c[l>>2];a:while(1){b=jI(o,q)|0;c[p>>2]=b;if(!b){r=23;break}switch(c[p>>2]|0){case 40:{if(a[n>>0]|0){r=7;break a}a[n>>0]=1;continue a;break}case 41:{if(!(d[n>>0]|0)){r=10;break a}a[n>>0]=0;continue a;break}default:{if(!(d[n>>0]|0)){if((c[m>>2]|0)==63){r=14;break a}if((c[13713]|0)>>>0>=(c[13714]|0)>>>0)eA(54848,1)|0;b=c[13713]|0;c[13713]=b+1;a[b>>0]=0;b=c[13713]|0;s=c[m>>2]|0;c[m>>2]=s+1;c[54864+(s<<2)>>2]=b}if((c[q+4>>2]|0)>>>0>=(c[q+8>>2]|0)>>>0)eA(q,1)|0;b=q+4|0;s=c[b>>2]|0;c[b>>2]=s+1;a[s>>0]=0;s=c[q>>2]|0;c[q+4>>2]=s;gA(54848,s)|0;if((c[13713]|0)>>>0>=(c[13714]|0)>>>0)eA(54848,1)|0;s=c[13713]|0;c[13713]=s+1;a[s>>0]=0;continue a}}}if((r|0)==7){c[j>>2]=c[l>>2];$z(1,137834,j)|0;c[13716]=0;hA(q);c[k>>2]=54864;t=c[k>>2]|0;i=e;return t|0}else if((r|0)==10){c[h>>2]=c[l>>2];$z(1,137868,h)|0;c[13716]=0;hA(q);c[k>>2]=54864;t=c[k>>2]|0;i=e;return t|0}else if((r|0)==14){c[g>>2]=c[l>>2];$z(0,137896,g)|0;c[54864+(c[m>>2]<<2)>>2]=0;hA(q);c[k>>2]=54864;t=c[k>>2]|0;i=e;return t|0}else if((r|0)==23){if(a[n>>0]|0){c[f>>2]=c[l>>2];$z(1,137919,f)|0;c[13716]=0;hA(q);c[k>>2]=54864;t=c[k>>2]|0;i=e;return t|0}c[54864+(c[m>>2]<<2)>>2]=0;hA(q);if((c[13713]|0)>>>0>=(c[13714]|0)>>>0)eA(54848,1)|0;q=c[13713]|0;c[13713]=q+1;a[q>>0]=0;c[13713]=c[13712];c[k>>2]=54864;t=c[k>>2]|0;i=e;return t|0}return 0}function KH(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[13780]|0;if(c[d>>2]|0){c[13780]=a+1;if((c[13780]|0)==1)c[13781]=M3(T1(1,0)|0)|0}else if((a|0)>0?(c[13780]=(c[13780]|0)+-1,(c[13780]|0)==0):0)O4(c[13781]|0);i=b;return}function LH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0;e=i;i=i+112|0;f=e+72|0;g=e+56|0;j=e+48|0;k=e+32|0;l=e+24|0;m=e+8|0;n=e;o=e+104|0;p=e+100|0;q=e+96|0;r=e+92|0;s=e+88|0;c[p>>2]=b;c[q>>2]=d;if(a[138998]|0)_N();if((MC(c[q>>2]|0,175049,0,1)|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){kI(c[q>>2]|0);lI(c[p>>2]|0,c[q>>2]|0);mI(c[p>>2]|0,c[q>>2]|0);KH(1);c[r>>2]=IR(c[p>>2]|0)|0;while(1){if(!(c[r>>2]|0)){t=38;break}if(c[(c[p>>2]|0)+56>>2]|0){c[(c[r>>2]|0)+20>>2]=c[(c[(c[p>>2]|0)+56>>2]|0)+8>>2];c[(c[r>>2]|0)+24>>2]=c[(c[(c[p>>2]|0)+56>>2]|0)+12>>2]}else{c[(c[r>>2]|0)+20>>2]=0;c[(c[r>>2]|0)+24>>2]=0}c[(c[r>>2]|0)+12>>2]=c[p>>2];c[(c[r>>2]|0)+28>>2]=c[(c[p>>2]|0)+172+12>>2];c[(c[r>>2]|0)+620>>2]=61256;c[(c[r>>2]|0)+624>>2]=c[15342];if(!(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)){t=14;break}d=QQ(c[r>>2]|0,c[(c[r>>2]|0)+52>>2]|0)|0;c[(c[r>>2]|0)+56>>2]=d;u=c[r>>2]|0;if((c[(c[r>>2]|0)+56>>2]|0)==999){t=18;break}switch(c[u+56>>2]|0){case 21:{d=(c[r>>2]|0)+152|0;c[d>>2]=c[d>>2]|1;break}case 24:{d=(c[r>>2]|0)+152|0;c[d>>2]=c[d>>2]|520;break}default:{d=nI(c[q>>2]|0)|0;b=(c[r>>2]|0)+152|0;c[b>>2]=c[b>>2]|d}}c[s>>2]=c[(c[p>>2]|0)+192>>2];do if(c[s>>2]|0){if((c[(c[s>>2]|0)+152>>2]&32|0)!=0?(J3(c[(c[r>>2]|0)+52>>2]|0,c[(c[s>>2]|0)+52>>2]|0)|0)==0:0)break;SQ(c[s>>2]|0);c[(c[p>>2]|0)+192>>2]=0;c[(c[p>>2]|0)+28>>2]=0;c[13782]=0}else c[13782]=0;while(0);d=c[r>>2]|0;if(!(c[13782]|0)){if(!(RQ(d)|0)){c[(c[p>>2]|0)+192>>2]=c[r>>2];t=34}}else{c[(c[13782]|0)+8>>2]=d;c[(c[r>>2]|0)+36>>2]=c[(c[13782]|0)+36>>2];t=34}if((t|0)==34){t=0;c[(c[r>>2]|0)+8>>2]=0;c[(c[r>>2]|0)+104>>2]=61372;oI(c[r>>2]|0);pI(c[r>>2]|0);qI(c[r>>2]|0,c[q>>2]|0);rI(c[r>>2]|0,c[q>>2]|0);sI(c[r>>2]|0,c[q>>2]|0);if(!(c[(c[r>>2]|0)+152>>2]&128))FH(c[r>>2]|0,c[q>>2]|0);c[13782]=c[r>>2]}c[r>>2]=JR(c[p>>2]|0)|0}if((t|0)==14){$z(1,138026,l)|0;KH(0);if(a[138998]|0){l=c[24742]|0;p=wB(c[q>>2]|0)|0;v=+$N();c[k>>2]=p;h[k+8>>3]=v;Y2(l,137997,k)|0}c[o>>2]=-1;w=c[o>>2]|0;i=e;return w|0}else if((t|0)==18){c[j>>2]=c[u+52>>2];$z(1,138047,j)|0;KH(0);if(a[138998]|0){j=c[24742]|0;u=wB(c[q>>2]|0)|0;v=+$N();c[g>>2]=u;h[g+8>>3]=v;Y2(j,137997,g)|0}c[o>>2]=-1;w=c[o>>2]|0;i=e;return w|0}else if((t|0)==38){KH(0);if(a[138998]|0){t=c[24742]|0;g=wB(c[q>>2]|0)|0;v=+$N();c[f>>2]=g;h[f+8>>3]=v;Y2(t,137997,f)|0}c[o>>2]=0;w=c[o>>2]|0;i=e;return w|0}}$z(1,137949,n)|0;if(a[138998]|0){n=c[24742]|0;f=wB(c[q>>2]|0)|0;v=+$N();c[m>>2]=f;h[m+8>>3]=v;Y2(n,137997,m)|0}c[o>>2]=-1;w=c[o>>2]|0;i=e;return w|0}function MH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+144|0;f=e;g=e+12|0;h=e+8|0;j=e+16|0;c[g>>2]=b;c[h>>2]=d;if((c[(c[g>>2]|0)+160>>2]|0)>1?(c[(c[g>>2]|0)+152>>2]&64|0)!=0:0){gA(c[h>>2]|0,c[(c[(c[c[g>>2]>>2]|0)+308>>2]|0)+(c[(c[g>>2]|0)+160>>2]<<2)>>2]|0)|0;if((c[(c[h>>2]|0)+4>>2]|0)>>>0>=(c[(c[h>>2]|0)+8>>2]|0)>>>0)eA(c[h>>2]|0,1)|0;d=(c[h>>2]|0)+4|0;b=c[d>>2]|0;c[d>>2]=b+1;a[b>>0]=95}if((c[(c[g>>2]|0)+196>>2]|0)<=0?(c[(c[g>>2]|0)+196>>2]|0)<=0:0){i=e;return}b=c[(c[g>>2]|0)+196+4>>2]|0;c[f>>2]=c[(c[g>>2]|0)+196>>2];c[f+4>>2]=b;k3(j,138987,f)|0;gA(c[h>>2]|0,j)|0;i=e;return}function NH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0;f=i;i=i+96|0;j=f+40|0;k=f+32|0;l=f+88|0;m=f+84|0;n=f+80|0;o=f+76|0;p=f+72|0;q=f+68|0;r=f+64|0;s=f+60|0;t=f+56|0;u=f+24|0;v=f+16|0;w=f+52|0;x=f+48|0;y=f+44|0;z=f+8|0;A=f;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=bK(12)|0;c[r>>2]=M3(c[m>>2]|0)|0;c[t>>2]=0;h[v>>3]=1.0;c[x>>2]=0;a:do if(!(c[n>>2]|0)){c[n>>2]=1;c[y>>2]=c[r>>2];while(1){if(!(a[c[y>>2]>>0]|0))break a;if((a[c[y>>2]>>0]|0)==58)c[n>>2]=(c[n>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1}}while(0);c[(c[p>>2]|0)+4>>2]=c[r>>2];y=bK(((c[n>>2]|0)+1|0)*12|0)|0;c[q>>2]=y;c[(c[p>>2]|0)+8>>2]=y;c[s>>2]=V3(c[r>>2]|0,148898)|0;while(1){if(!(c[s>>2]|0))break;B=+BJ(c[s>>2]|0);h[u>>3]=B;if(!(B>=0.0)){C=20;break}h[z>>3]=+h[u>>3]-+h[v>>3];if(+h[z>>3]>0.0){if((c[13788]|0)!=0?!(+h[z>>3]<1.0e-05&+h[z>>3]>-1.0e-05):0){c[k>>2]=c[m>>2];$z(0,138906,k)|0;c[13788]=0;c[x>>2]=3}h[u>>3]=+h[v>>3]}h[v>>3]=+h[v>>3]-+h[u>>3];if(+h[u>>3]>0.0)a[(c[q>>2]|0)+((c[t>>2]|0)*12|0)+8>>0]=1;if(a[c[s>>2]>>0]|0)c[(c[q>>2]|0)+((c[t>>2]|0)*12|0)>>2]=c[s>>2];B=+h[u>>3];r=c[t>>2]|0;c[t>>2]=r+1;g[(c[q>>2]|0)+(r*12|0)+4>>2]=B;if(+h[v>>3]<1.0e-05&+h[v>>3]>-1.0e-05){C=24;break}c[s>>2]=V3(0,148898)|0}if((C|0)==20){if(c[13788]|0){c[j>>2]=c[m>>2];$z(1,138941,j)|0;c[13788]=0;c[x>>2]=2}else c[x>>2]=1;OH(c[p>>2]|0);c[l>>2]=c[x>>2];D=c[l>>2]|0;i=f;return D|0}else if((C|0)==24)h[v>>3]=0.0;b:do if(+h[v>>3]>0.0){c[n>>2]=0;c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[t>>2]|0))break;if(+g[(c[q>>2]|0)+((c[w>>2]|0)*12|0)+4>>2]==0.0)c[n>>2]=(c[n>>2]|0)+1;c[w>>2]=(c[w>>2]|0)+1}B=+h[v>>3];if((c[n>>2]|0)<=0){C=(c[q>>2]|0)+(((c[t>>2]|0)-1|0)*12|0)+4|0;g[C>>2]=+g[C>>2]+B;break}h[A>>3]=B/+(c[n>>2]|0);c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[t>>2]|0))break b;if(+g[(c[q>>2]|0)+((c[w>>2]|0)*12|0)+4>>2]==0.0)g[(c[q>>2]|0)+((c[w>>2]|0)*12|0)+4>>2]=+h[A>>3];c[w>>2]=(c[w>>2]|0)+1}}while(0);c[n>>2]=0;c[w>>2]=(c[t>>2]|0)-1;while(1){if((c[w>>2]|0)<0)break;if(+g[(c[q>>2]|0)+((c[w>>2]|0)*12|0)+4>>2]>0.0)break;c[w>>2]=(c[w>>2]|0)+-1}c[(c[q>>2]|0)+(((c[w>>2]|0)+1|0)*12|0)>>2]=0;c[c[p>>2]>>2]=(c[w>>2]|0)+1;c[c[o>>2]>>2]=c[p>>2];c[l>>2]=c[x>>2];D=c[l>>2]|0;i=f;return D|0}function OH(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[d>>2]|0)+4>>2]|0);O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[d>>2]|0);i=b;return}function PH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+80|0;d=b+48|0;e=b+32|0;f=b+16|0;g=b+68|0;j=b+64|0;k=b+8|0;l=b;c[j>>2]=a;a=c[j>>2]|0;m=(c[j>>2]|0)+48|0;n=(c[j>>2]|0)+16|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[d>>2]=c[n>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];c[d+12>>2]=c[n+12>>2];h[k>>3]=+HJ(f,e,d);n=c[j>>2]|0;m=(c[j>>2]|0)+48|0;a=(c[j>>2]|0)+32|0;c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[d>>2]=c[a>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];h[l>>3]=+HJ(f,e,d);if(+h[k>>3]<4.0&+h[l>>3]<4.0){c[g>>2]=1;o=c[g>>2]|0;i=b;return o|0}else{c[g>>2]=0;o=c[g>>2]|0;i=b;return o|0}return 0}function QH(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=a;if(+h[b>>3]>+h[(c[e>>2]|0)+16>>3])h[(c[e>>2]|0)+16>>3]=+h[b>>3];if(+h[b>>3]<+h[c[e>>2]>>3])h[c[e>>2]>>3]=+h[b>>3];if(+h[b+8>>3]>+h[(c[e>>2]|0)+16+8>>3])h[(c[e>>2]|0)+16+8>>3]=+h[b+8>>3];if(!(+h[b+8>>3]<+h[(c[e>>2]|0)+8>>3])){i=d;return}h[(c[e>>2]|0)+8>>3]=+h[b+8>>3];i=d;return}function RH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;f=i;i=i+64|0;g=f+32|0;j=f+60|0;k=f+56|0;l=f+52|0;m=f;n=f+48|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;o=+h[c[j>>2]>>3];h[m+16>>3]=o;h[m>>3]=o;o=+h[(c[j>>2]|0)+8>>3];h[m+16+8>>3]=o;h[m+8>>3]=o;c[n>>2]=1;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;c[j>>2]=(c[j>>2]|0)+24;o=+h[c[j>>2]>>3];if(!(+h[c[j>>2]>>3]<+h[m>>3])){if(o>+h[m+16>>3])h[m+16>>3]=+h[c[j>>2]>>3]}else h[m>>3]=o;o=+h[(c[j>>2]|0)+8>>3];if(!(+h[(c[j>>2]|0)+8>>3]<+h[m+8>>3])){if(o>+h[m+16+8>>3])h[m+16+8>>3]=+h[(c[j>>2]|0)+8>>3]}else h[m+8>>3]=o;c[n>>2]=(c[n>>2]|0)+1}n=c[l>>2]|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];QH(n,g);n=c[l>>2]|0;l=m+16|0;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];QH(n,g);c[a>>2]=c[m>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];i=f;return}function SH(b,d,e,f){b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+80|0;j=g+56|0;k=g+48|0;l=g+64|0;m=g+16|0;n=g;h[j>>3]=d;h[k>>3]=e;c[l>>2]=f;f=(c[l>>2]|0)+32|0;c[n>>2]=c[f>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];switch(a[(c[l>>2]|0)+48>>0]|0){case 108:{h[m>>3]=+h[j>>3];h[m+16>>3]=+h[m>>3]+ +h[n>>3];break}case 110:{h[m>>3]=+h[j>>3]-+h[n>>3]/2.0;h[m+16>>3]=+h[j>>3]+ +h[n>>3]/2.0;break}case 114:{h[m+16>>3]=+h[j>>3];h[m>>3]=+h[m+16>>3]-+h[n>>3];break}default:{}}h[m+16+8>>3]=+h[k>>3]+ +h[(c[l>>2]|0)+16>>3];h[m+8>>3]=+h[m+16+8>>3]-+h[n+8>>3];c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];c[b+12>>2]=c[m+12>>2];c[b+16>>2]=c[m+16>>2];c[b+20>>2]=c[m+20>>2];c[b+24>>2]=c[m+24>>2];c[b+28>>2]=c[m+28>>2];i=g;return}function TH(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[c[d>>2]>>2]|0)!=7){i=b;return}TJ(c[(c[d>>2]|0)+112>>2]|0,1);i=b;return}function UH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=wH(c[e>>2]|0)|0;c[(c[g>>2]|0)+4>>2]=0;c[(c[g>>2]|0)+8>>2]=c[f>>2];c[(c[g>>2]|0)+12>>2]=0;nJ(c[e>>2]|0,c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0,c[f>>2]|0);VQ(c[e>>2]|0,c[f>>2]|0);i=d;return}function VH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=b;c[g>>2]=d;pR(c[f>>2]|0,172403);d=yA(c[g>>2]|0,178986)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)pR(c[f>>2]|0,c[k>>2]|0);d=yA(c[g>>2]|0,139238)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)oR(c[f>>2]|0,c[k>>2]|0);AJ(c[f>>2]|0,c[g>>2]|0);c[h>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;d=yA(c[h>>2]|0,178832)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)oR(c[f>>2]|0,c[k>>2]|0);d=yA(c[h>>2]|0,175307)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)pR(c[f>>2]|0,c[k>>2]|0);d=yA(c[h>>2]|0,139210)|0;c[k>>2]=d;do if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0){if(!(H3(c[k>>2]|0,58)|0)){oR(c[f>>2]|0,c[k>>2]|0);break}c[l>>2]=M3(c[k>>2]|0)|0;c[k>>2]=V3(c[l>>2]|0,148898)|0;while(1){if(!(c[k>>2]|0))break;if(a[c[k>>2]>>0]|0)oR(c[f>>2]|0,c[k>>2]|0);c[k>>2]=V3(0,148898)|0}O4(c[l>>2]|0)}while(0);d=yA(c[h>>2]|0,139238)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)oR(c[f>>2]|0,c[k>>2]|0);c[j>>2]=OA(c[g>>2]|0,c[h>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;d=yA(c[j>>2]|0,178832)|0;c[k>>2]=d;do if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0){if(!(H3(c[k>>2]|0,58)|0)){oR(c[f>>2]|0,c[k>>2]|0);break}c[l>>2]=M3(c[k>>2]|0)|0;c[k>>2]=V3(c[l>>2]|0,148898)|0;while(1){if(!(c[k>>2]|0))break;if(a[c[k>>2]>>0]|0)oR(c[f>>2]|0,c[k>>2]|0);c[k>>2]=V3(0,148898)|0}O4(c[l>>2]|0)}while(0);d=yA(c[j>>2]|0,139238)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)oR(c[f>>2]|0,c[k>>2]|0);c[j>>2]=QA(c[g>>2]|0,c[j>>2]|0)|0}c[h>>2]=aC(c[g>>2]|0,c[h>>2]|0)|0}i=e;return}function WH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+8|0;f=d;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;c[g>>2]=a;c[h>>2]=b;c[(c[g>>2]|0)+156>>2]=c[(c[c[g>>2]>>2]|0)+312>>2];b=c[g>>2]|0;if(c[(c[c[g>>2]>>2]|0)+316>>2]|0){c[j>>2]=c[(c[b>>2]|0)+316>>2];a=c[j>>2]|0;c[j>>2]=a+4;c[k>>2]=c[a>>2];if((c[k>>2]|0)>1?(c[(c[g>>2]|0)+152>>2]&64|0)==0:0){c[f>>2]=c[(c[g>>2]|0)+52>>2];$z(0,138871,f)|0;c[(c[j>>2]|0)+4>>2]=(c[(c[g>>2]|0)+156>>2]|0)+1}f=c[j>>2]|0;c[j>>2]=f+4;c[(c[g>>2]|0)+160>>2]=c[f>>2];c[c[h>>2]>>2]=c[j>>2];i=d;return}else{if((c[b+156>>2]|0)>1?(c[(c[g>>2]|0)+152>>2]&64|0)==0:0){c[e>>2]=c[(c[g>>2]|0)+52>>2];$z(0,138871,e)|0;c[(c[g>>2]|0)+156>>2]=1}c[(c[g>>2]|0)+160>>2]=1;c[c[h>>2]>>2]=0;i=d;return}}function XH(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return (c[(c[d>>2]|0)+160>>2]|0)<=(c[(c[d>>2]|0)+156>>2]|0)&255|0}function YH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;a=c[e>>2]|0;if(c[(c[c[e>>2]>>2]|0)+316>>2]|0){c[d>>2]=c[c[(c[a>>2]|0)+316>>2]>>2];f=c[d>>2]|0;i=b;return f|0}else{c[d>>2]=c[a+156>>2];f=c[d>>2]|0;i=b;return f|0}return 0}function ZH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=(c[d>>2]|0)+196|0;e=(c[d>>2]|0)+172|0;c[a>>2]=c[e>>2];c[a+4>>2]=c[e+4>>2];i=b;return}function _H(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(((c[(c[d>>2]|0)+196>>2]|0)>=0?(c[(c[d>>2]|0)+196>>2]|0)<(c[(c[d>>2]|0)+164>>2]|0):0)?(c[(c[d>>2]|0)+196+4>>2]|0)>=0:0)e=(c[(c[d>>2]|0)+196+4>>2]|0)<(c[(c[d>>2]|0)+164+4>>2]|0);else e=0;i=b;return e&1|0}function $H(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+208|0;g=f;h=f+76|0;j=f+72|0;k=f+68|0;l=f+64|0;m=f+60|0;n=f+56|0;o=f+52|0;p=f+48|0;q=f+80|0;r=f+32|0;c[h>>2]=d;c[j>>2]=e;c[k>>2]=c[(c[h>>2]|0)+16>>2];c[l>>2]=0;c[m>>2]=c[(c[h>>2]|0)+152>>2];c[o>>2]=0;if(((c[(c[h>>2]|0)+160>>2]|0)<=1?(c[(c[h>>2]|0)+196>>2]|0)<=0:0)?(c[(c[h>>2]|0)+196>>2]|0)<=0:0)c[p>>2]=0;else{dA(r,128,q);c[p>>2]=c[(c[k>>2]|0)+212>>2];MH(c[h>>2]|0,r);gA(r,c[p>>2]|0)|0;if((c[r+4>>2]|0)>>>0>=(c[r+8>>2]|0)>>>0)eA(r,1)|0;q=r+4|0;e=c[q>>2]|0;c[q>>2]=e+1;a[e>>0]=0;e=c[r>>2]|0;c[r+4>>2]=e;c[(c[k>>2]|0)+212>>2]=e}dT(yA(c[j>>2]|0,137612)|0);tJ(c[h>>2]|0,c[j>>2]|0);XQ(c[h>>2]|0);oR(c[h>>2]|0,174917);pR(c[h>>2]|0,172403);do if(c[m>>2]&4259840){if((c[(c[k>>2]|0)+208>>2]|0)==0?((b[(c[k>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0)break;if(c[m>>2]&655360){e=(c[k>>2]|0)+264|0;if(c[m>>2]&131072){c[e>>2]=0;c[l>>2]=2}else{c[e>>2]=2;c[l>>2]=4}c[o>>2]=bK(c[l>>2]<<4)|0;e=c[o>>2]|0;q=(c[h>>2]|0)+288|0;c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];c[e+12>>2]=c[q+12>>2];q=(c[o>>2]|0)+16|0;e=(c[h>>2]|0)+288+16|0;c[q>>2]=c[e>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];if(!(c[m>>2]&131072))DJ(c[o>>2]|0)}if(!(c[m>>2]&8192))UQ(c[h>>2]|0,c[o>>2]|0,c[o>>2]|0,c[l>>2]|0)|0;c[(c[k>>2]|0)+272>>2]=c[o>>2];c[(c[k>>2]|0)+268>>2]=c[l>>2]}while(0);if((c[m>>2]&32768|0)!=0?(l=c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2]|0,c[n>>2]=l,(l|0)!=0):0)c[(c[k>>2]|0)+192>>2]=c[c[n>>2]>>2];do if(!(c[m>>2]&4)){if((c[(c[k>>2]|0)+208>>2]|0)==0?((b[(c[k>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0)break;n=c[h>>2]|0;l=(c[h>>2]|0)+256|0;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[g+16>>2]=c[l+16>>2];c[g+20>>2]=c[l+20>>2];c[g+24>>2]=c[l+24>>2];c[g+28>>2]=c[l+28>>2];CH(n,g);jR(c[h>>2]|0,c[(c[k>>2]|0)+208>>2]|0,c[(c[k>>2]|0)+228>>2]|0,c[(c[k>>2]|0)+244>>2]|0,c[(c[k>>2]|0)+212>>2]|0)}while(0);uJ(c[h>>2]|0,c[j>>2]|0);if(c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2]|0)VJ(c[h>>2]|0,4,c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2]|0);do if(!(c[m>>2]&4)){if((c[(c[k>>2]|0)+208>>2]|0)==0?((b[(c[k>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0)break;kR(c[h>>2]|0)}while(0);vJ(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0);YQ(c[h>>2]|0);if(!(c[p>>2]|0)){i=f;return}hA(r);c[(c[k>>2]|0)+212>>2]=c[p>>2];i=f;return}function aI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+48|0;d=b+32|0;e=b+24|0;f=b+16|0;g=b+8|0;h=b;c[f>>2]=a;a=(c[f>>2]|0)+196|0;j=(c[f>>2]|0)+196|0;k=(c[f>>2]|0)+188|0;c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];sJ(g,e,d);c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];if((_H(c[f>>2]|0)|0)&255){i=b;return}g=(c[f>>2]|0)+172|0;if(c[(c[f>>2]|0)+180+4>>2]|0)c[(c[f>>2]|0)+196>>2]=c[g>>2];else c[(c[f>>2]|0)+196+4>>2]=c[g+4>>2];g=(c[f>>2]|0)+196|0;a=(c[f>>2]|0)+196|0;k=(c[f>>2]|0)+180|0;c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];sJ(h,e,d);c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];i=b;return}function bI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[c[f>>2]>>2];if(c[g>>2]|0){b=c[g>>2]|0;c[g>>2]=b+4;c[(c[e>>2]|0)+160>>2]=c[b>>2];c[c[f>>2]>>2]=c[g>>2];i=d;return}else{g=(c[e>>2]|0)+160|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}}function cI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+4|0;c[e>>2]=a;c[d>>2]=b;WQ(c[e>>2]|0);xH(c[e>>2]|0);i=d;return}function dI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;do if((c[(c[g>>2]|0)+156>>2]|0)>1){d=c[h>>2]|0;c[j>>2]=hO(d,qA(c[h>>2]|0,0,139302,0)|0,178518)|0;if((hJ(c[g>>2]|0,c[j>>2]|0)|0)<<24>>24){a[f>>0]=1;break}if(a[c[j>>2]>>0]|0){a[f>>0]=0;break}c[k>>2]=$B(c[h>>2]|0)|0;while(1){if(!(c[k>>2]|0)){l=12;break}if((jJ(c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0)<<24>>24){l=10;break}c[k>>2]=aC(c[h>>2]|0,c[k>>2]|0)|0}if((l|0)==10){a[f>>0]=1;break}else if((l|0)==12){a[f>>0]=0;break}}else a[f>>0]=1;while(0);i=e;return a[f>>0]|0}function eI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=wH(c[e>>2]|0)|0;c[(c[g>>2]|0)+4>>2]=1;c[(c[g>>2]|0)+8>>2]=c[f>>2];c[(c[g>>2]|0)+12>>2]=1;nJ(c[e>>2]|0,c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0,c[f>>2]|0);$Q(c[e>>2]|0,c[f>>2]|0);i=d;return}function fI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=b;c[g>>2]=d;c[j>>2]=0;c[k>>2]=0;d=yA(c[f>>2]|0,179091)|0;c[h>>2]=d;if(!d){o=c[k>>2]|0;p=c[g>>2]|0;c[p>>2]=o;q=c[j>>2]|0;i=e;return q|0}if(!(a[c[h>>2]>>0]|0)){o=c[k>>2]|0;p=c[g>>2]|0;c[p>>2]=o;q=c[j>>2]|0;i=e;return q|0}d=JH(c[h>>2]|0)|0;c[j>>2]=d;c[l>>2]=d;a:while(1){d=c[c[l>>2]>>2]|0;c[n>>2]=d;if(!d)break;if(!(J3(c[n>>2]|0,148663)|0)){c[k>>2]=c[k>>2]|1;c[l>>2]=(c[l>>2]|0)+4;continue}if(!(J3(c[n>>2]|0,143760)|0)){c[k>>2]=c[k>>2]|3;c[m>>2]=c[l>>2];while(1){c[m>>2]=(c[m>>2]|0)+4;c[(c[m>>2]|0)+-4>>2]=c[c[m>>2]>>2];if(!(c[c[m>>2]>>2]|0))continue a}}if(!(J3(c[n>>2]|0,143767)|0)){c[k>>2]=c[k>>2]|64;c[m>>2]=c[l>>2];while(1){c[m>>2]=(c[m>>2]|0)+4;c[(c[m>>2]|0)+-4>>2]=c[c[m>>2]>>2];if(!(c[c[m>>2]>>2]|0))continue a}}if(J3(c[n>>2]|0,143742)|0){c[l>>2]=(c[l>>2]|0)+4;continue}c[k>>2]=c[k>>2]|4;c[m>>2]=c[l>>2];while(1){c[m>>2]=(c[m>>2]|0)+4;c[(c[m>>2]|0)+-4>>2]=c[c[m>>2]>>2];if(!(c[c[m>>2]>>2]|0))continue a}}o=c[k>>2]|0;p=c[g>>2]|0;c[p>>2]=o;q=c[j>>2]|0;i=e;return q|0}function gI(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+64|0;g=f;h=f+60|0;j=f+56|0;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;o=f+36|0;p=f+32|0;c[h>>2]=b;c[j>>2]=e;c[k>>2]=c[c[h>>2]>>2];c[n>>2]=0;if(!(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0)){i=f;return}e=c[h>>2]|0;b=qC(c[j>>2]|0)|0;if(!((jJ(e,b,c[j>>2]|0)|0)&255)){i=f;return}b=c[j>>2]|0;e=(c[h>>2]|0)+256|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];if(!((kJ(b,g)|0)&255)){i=f;return}if((a[(c[(c[j>>2]|0)+8>>2]|0)+116>>0]|0)==(c[(c[k>>2]|0)+28>>2]|0)){i=f;return}a[(c[(c[j>>2]|0)+8>>2]|0)+116>>0]=c[(c[k>>2]|0)+28>>2];k=c[h>>2]|0;xR(k,wB(c[j>>2]|0)|0);c[l>>2]=hO(c[j>>2]|0,c[13846]|0,178518)|0;if(a[c[l>>2]>>0]|0)xR(c[h>>2]|0,c[l>>2]|0);c[m>>2]=hO(c[j>>2]|0,c[13834]|0,178518)|0;a:do if(a[c[m>>2]>>0]|0){c[n>>2]=JH(c[m>>2]|0)|0;c[o>>2]=c[n>>2];while(1){l=c[o>>2]|0;c[o>>2]=l+4;k=c[l>>2]|0;c[p>>2]=k;if(!k)break a;if((a[c[p>>2]>>0]|0)!=(a[171938]|0))continue;if(!(J3(c[p>>2]|0,171938)|0))break}i=f;return}while(0);lJ(c[h>>2]|0,c[j>>2]|0);Db[c[(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+20>>2]&31](c[h>>2]|0,c[j>>2]|0);if((c[(c[(c[j>>2]|0)+8>>2]|0)+108>>2]|0)!=0?(d[(c[(c[(c[j>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0)!=0:0)VJ(c[h>>2]|0,10,c[(c[(c[j>>2]|0)+8>>2]|0)+108>>2]|0);mJ(c[h>>2]|0);i=f;return}function hI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+64|0;f=e;g=e+56|0;h=e+52|0;j=e+48|0;k=e+44|0;l=e+40|0;m=e+36|0;n=e+32|0;c[g>>2]=b;c[h>>2]=d;c[l>>2]=0;d=c[h>>2]|0;b=(c[g>>2]|0)+256|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];if(!((GI(d,f)|0)&255)){i=e;return}f=c[g>>2]|0;d=c[h>>2]|0;b=qC(c[((c[c[h>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)|0;if(!((HI(f,b,c[h>>2]|0)|0)&255)){i=e;return}b=c[h>>2]|0;f=(N3(wB(c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0)|0)+2|0;b=c[h>>2]|0;c[j>>2]=N4(f+(N3(wB(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)|0)|0)+1|0)|0;b=c[j>>2]|0;f=c[h>>2]|0;K3(b,wB(c[((c[c[h>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)|0)|0;f=c[h>>2]|0;b=(nB(qC(c[((c[c[h>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)|0)|0)!=0;f=c[j>>2]|0;if(b)G3(f,175316)|0;else G3(f,178535)|0;f=c[j>>2]|0;b=c[h>>2]|0;G3(f,wB(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)|0)|0;xR(c[g>>2]|0,c[j>>2]|0);O4(c[j>>2]|0);c[j>>2]=hO(c[h>>2]|0,c[13875]|0,178518)|0;if(a[c[j>>2]>>0]|0)xR(c[g>>2]|0,c[j>>2]|0);c[k>>2]=hO(c[h>>2]|0,c[13869]|0,178518)|0;a:do if(a[c[k>>2]>>0]|0){c[l>>2]=JH(c[k>>2]|0)|0;c[m>>2]=c[l>>2];while(1){j=c[m>>2]|0;c[m>>2]=j+4;b=c[j>>2]|0;c[n>>2]=b;if(!b)break a;if((a[c[n>>2]>>0]|0)!=(a[171938]|0))continue;if(!(J3(c[n>>2]|0,171938)|0))break}i=e;return}while(0);II(c[g>>2]|0,c[h>>2]|0,c[l>>2]|0);JI(c[g>>2]|0,c[h>>2]|0,c[l>>2]|0);KI(c[g>>2]|0);i=e;return}function iI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;aR(c[e>>2]|0,c[f>>2]|0);xH(c[e>>2]|0);i=d;return}function jI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;l=e+20|0;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[c[f>>2]>>2];while(1){if(a[c[h>>2]>>0]|0)if(r1(a[c[h>>2]>>0]|0)|0)m=1;else m=(a[c[h>>2]>>0]|0)==44;else m=0;n=c[h>>2]|0;if(!m)break;c[h>>2]=n+1}switch(a[n>>0]|0){case 0:{c[j>>2]=0;o=c[h>>2]|0;p=c[f>>2]|0;c[p>>2]=o;q=c[j>>2]|0;i=e;return q|0}case 41:case 40:{n=c[h>>2]|0;c[h>>2]=n+1;c[j>>2]=a[n>>0];o=c[h>>2]|0;p=c[f>>2]|0;c[p>>2]=o;q=c[j>>2]|0;i=e;return q|0}default:{c[j>>2]=1;while(1){n=a[c[h>>2]>>0]|0;a[l>>0]=n;if(!((FI(n<<24>>24)|0)<<24>>24!=0^1))break;if((c[(c[g>>2]|0)+4>>2]|0)>>>0>=(c[(c[g>>2]|0)+8>>2]|0)>>>0)eA(c[g>>2]|0,1)|0;n=a[l>>0]|0;m=(c[g>>2]|0)+4|0;d=c[m>>2]|0;c[m>>2]=d+1;a[d>>0]=n;c[k>>2]=n&255;c[h>>2]=(c[h>>2]|0)+1}o=c[h>>2]|0;p=c[f>>2]|0;c[p>>2]=o;q=c[j>>2]|0;i=e;return q|0}}return 0}function kI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;BI(c[d>>2]|0,c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function lI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;e=i;i=i+48|0;f=e+24|0;g=e+16|0;j=e+44|0;k=e+40|0;l=e+8|0;m=e;n=e+36|0;o=e+32|0;c[j>>2]=b;c[k>>2]=d;c[(c[j>>2]|0)+168>>2]=c[k>>2];a[(c[j>>2]|0)+293>>0]=0;d=yA(c[k>>2]|0,143958)|0;c[n>>2]=d;if((d|0)!=0?(d=c[n>>2]|0,c[g>>2]=l,c[g+4>>2]=m,c[o>>2]=l3(d,143965,g)|0,(c[o>>2]|0)>0):0){p=+h[l>>3]*72.0;h[(c[j>>2]|0)+200+8>>3]=p;h[(c[j>>2]|0)+200>>3]=p;if((c[o>>2]|0)>1)h[(c[j>>2]|0)+200+8>>3]=+h[m>>3]*72.0;a[(c[j>>2]|0)+293>>0]=1}a[(c[j>>2]|0)+292>>0]=0;g=yA(c[k>>2]|0,138453)|0;c[n>>2]=g;if((g|0)!=0?(g=c[n>>2]|0,c[f>>2]=l,c[f+4>>2]=m,c[o>>2]=l3(g,143965,f)|0,(c[o>>2]|0)>0):0){p=+h[l>>3]*72.0;h[(c[j>>2]|0)+216+8>>3]=p;h[(c[j>>2]|0)+216>>3]=p;if((c[o>>2]|0)>1)h[(c[j>>2]|0)+216+8>>3]=+h[m>>3]*72.0;a[(c[j>>2]|0)+292>>0]=1}a[(c[j>>2]|0)+294>>0]=0;m=(c[j>>2]|0)+232|0;o=(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+48|0;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];c[m+12>>2]=c[o+12>>2];if(+h[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+48>>3]>.001?+h[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+48+8>>3]>.001:0)a[(c[j>>2]|0)+294>>0]=1;o=(c[j>>2]|0)+288|0;if(a[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+81>>0]|0)c[o>>2]=90;else c[o>>2]=0;c[(c[j>>2]|0)+196>>2]=138457;o=yA(c[k>>2]|0,138460)|0;c[n>>2]=o;if((o|0)!=0?(a[c[n>>2]>>0]|0)!=0:0)c[(c[j>>2]|0)+196>>2]=c[n>>2];n=(c[j>>2]|0)+256|0;o=(c[(c[k>>2]|0)+8>>2]|0)+16|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[n+16>>2]=c[o+16>>2];c[n+20>>2]=c[o+20>>2];c[n+24>>2]=c[o+24>>2];c[n+28>>2]=c[o+28>>2];c[13810]=qA(c[k>>2]|0,0,139264,0)|0;c[13811]=qA(c[k>>2]|0,0,139255,0)|0;o=iO(0,c[13828]|0,145601)|0;c[(c[j>>2]|0)+320>>2]=o;p=+fO(0,c[13827]|0,14.0,1.0);h[(c[j>>2]|0)+328>>3]=p;c[(c[j>>2]|0)+336>>2]=55132;o=wB(c[k>>2]|0)|0;c[(c[j>>2]|0)+188>>2]=o;i=e;return}function mI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=d;if(c[(c[f>>2]|0)+304>>2]|0){O4(c[(c[f>>2]|0)+304>>2]|0);c[(c[f>>2]|0)+304>>2]=0}if(c[(c[f>>2]|0)+308>>2]|0){O4(c[(c[f>>2]|0)+308>>2]|0);c[(c[f>>2]|0)+308>>2]=0}if(c[(c[f>>2]|0)+316>>2]|0){O4(c[(c[f>>2]|0)+316>>2]|0);c[(c[f>>2]|0)+316>>2]=0}d=yA(c[g>>2]|0,138200)|0;c[h>>2]=d;b=c[f>>2]|0;if(!d){c[b+308>>2]=0;c[(c[f>>2]|0)+312>>2]=1;i=e;return}d=wI(b,c[g>>2]|0,c[h>>2]|0)|0;c[(c[f>>2]|0)+312>>2]=d;d=yA(c[g>>2]|0,138207)|0;c[h>>2]=d;if(!d){i=e;return}if(!(a[c[h>>2]>>0]|0)){i=e;return}d=xI(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;c[(c[f>>2]|0)+316>>2]=d;i=e;return}function nI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;h=d+12|0;c[f>>2]=b;c[g>>2]=yA(c[f>>2]|0,138168)|0;if(c[g>>2]|0){a[h>>0]=a[c[g>>2]>>0]|0;if((a[h>>0]|0)==110?(J3((c[g>>2]|0)+1|0,138180)|0)==0:0){c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}if((a[h>>0]|0)==101?(J3((c[g>>2]|0)+1|0,138190)|0)==0:0){c[e>>2]=16;j=c[e>>2]|0;i=d;return j|0}}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function oI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=c[c[e>>2]>>2];b=c[e>>2]|0;if(a[(c[f>>2]|0)+292>>0]|0){g=b+240|0;j=(c[f>>2]|0)+216|0;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=d;return}j=c[e>>2]|0;if((c[b+56>>2]|0)==300){k=+h[(c[j+60+8>>2]|0)+8>>3];h[(c[e>>2]|0)+240+8>>3]=k;h[(c[e>>2]|0)+240>>3]=k;i=d;return}else{h[j+240+8>>3]=4.0;h[(c[e>>2]|0)+240>>3]=4.0;i=d;return}}function pI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=c[c[e>>2]>>2];b=c[e>>2]|0;if(a[(c[f>>2]|0)+293>>0]|0){g=b+416|0;j=(c[f>>2]|0)+200|0;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=d;return}switch(c[b+56>>2]|0){case 300:{b=(c[e>>2]|0)+416|0;j=(c[(c[e>>2]|0)+76+8>>2]|0)+8|0;c[b>>2]=c[j>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];i=d;return}case 30:case 21:case 22:case 4:case 3:case 2:{h[(c[e>>2]|0)+416+8>>3]=36.0;h[(c[e>>2]|0)+416>>3]=36.0;i=d;return}default:{h[(c[e>>2]|0)+416+8>>3]=0.0;h[(c[e>>2]|0)+416>>3]=0.0;i=d;return}}}function qI(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0.0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[c[f>>2]>>2]|0)+192>>2];if(+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3]!=0.0){k=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3];h[(c[f>>2]|0)+432+8>>3]=k;h[(c[f>>2]|0)+432>>3]=k;i=e;return}if((c[j>>2]|0)!=0?(d[(c[j>>2]|0)+128>>0]|0|0)!=0:0){g=(c[f>>2]|0)+432|0;b=(c[j>>2]|0)+112|0;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];i=e;return}b=(c[f>>2]|0)+432|0;if((c[(c[f>>2]|0)+56>>2]|0)==300){g=(c[(c[f>>2]|0)+76+8>>2]|0)+40|0;c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];i=e;return}else{h[b+8>>3]=96.0;h[(c[f>>2]|0)+432>>3]=96.0;i=e;return}}function rI(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0;e=i;i=i+208|0;f=e+144|0;g=e+120|0;j=e+104|0;k=e+192|0;l=e+188|0;m=e+184|0;n=e+88|0;o=e+72|0;p=e+56|0;q=e+40|0;r=e+32|0;s=e+24|0;t=e+16|0;u=e+8|0;v=e;w=e+180|0;x=e+176|0;y=e+172|0;z=e+168|0;A=e+164|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=c[c[k>>2]>>2];c[z>>2]=0;c[A>>2]=0;b=(c[m>>2]|0)+256+16|0;c[o>>2]=c[b>>2];c[o+4>>2]=c[b+4>>2];c[o+8>>2]=c[b+8>>2];c[o+12>>2]=c[b+12>>2];b=(c[m>>2]|0)+256|0;c[n>>2]=c[b>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];h[(c[k>>2]|0)+208>>3]=+h[n>>3]-+h[(c[k>>2]|0)+240>>3];h[(c[k>>2]|0)+208+8>>3]=+h[n+8>>3]-+h[(c[k>>2]|0)+240+8>>3];h[(c[k>>2]|0)+208+16>>3]=+h[o>>3]+ +h[(c[k>>2]|0)+240>>3];h[(c[k>>2]|0)+208+16+8>>3]=+h[o+8>>3]+ +h[(c[k>>2]|0)+240+8>>3];h[q>>3]=+h[(c[k>>2]|0)+208+16>>3]-+h[(c[k>>2]|0)+208>>3];h[q+8>>3]=+h[(c[k>>2]|0)+208+16+8>>3]-+h[(c[k>>2]|0)+208+8>>3];h[t>>3]=1.0;do if(+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+64>>3]>.001?+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+64+8>>3]>.001:0){b=(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+64|0;c[p>>2]=c[b>>2];c[p+4>>2]=c[b+4>>2];c[p+8>>2]=c[b+8>>2];c[p+12>>2]=c[b+12>>2];if(+h[q>>3]==0.0)h[q>>3]=+h[p>>3];if(+h[q+8>>3]==0.0)h[q+8>>3]=+h[p+8>>3];if(!(+h[p>>3]<+h[q>>3])?!(+h[p+8>>3]<+h[q+8>>3]):0){if(!(d[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+80>>0]|0))break;if(!(+h[p>>3]>+h[q>>3]))break;if(!(+h[p+8>>3]>+h[q+8>>3]))break}if(+h[p>>3]/+h[q>>3]<+h[p+8>>3]/+h[q+8>>3])B=+h[p>>3]/+h[q>>3];else B=+h[p+8>>3]/+h[q+8>>3];h[t>>3]=B}while(0);h[u>>3]=(+h[n>>3]+ +h[o>>3])/2.0;h[v>>3]=(+h[n+8>>3]+ +h[o+8>>3])/2.0;c[(c[k>>2]|0)+360>>2]=c[(c[c[k>>2]>>2]|0)+288>>2];h[r>>3]=+h[q>>3]*+h[t>>3];h[s>>3]=+h[q+8>>3]*+h[t>>3];q=yA(c[l>>2]|0,138099)|0;c[y>>2]=q;if(!q){C=+h[r>>3];D=c[k>>2]|0;E=D+368|0;h[E>>3]=C;F=+h[s>>3];G=c[k>>2]|0;H=G+368|0;I=H+8|0;h[I>>3]=F;J=+h[t>>3];K=c[k>>2]|0;L=K+352|0;h[L>>3]=J;M=+h[u>>3];N=c[k>>2]|0;O=N+336|0;h[O>>3]=M;P=+h[v>>3];Q=c[k>>2]|0;R=Q+336|0;S=R+8|0;h[S>>3]=P;i=e;return}c[z>>2]=N4((N3(c[y>>2]|0)|0)+1|0)|0;c[A>>2]=N4((N3(c[y>>2]|0)|0)+1|0)|0;q=c[y>>2]|0;o=c[z>>2]|0;c[j>>2]=r;c[j+4>>2]=s;c[j+8>>2]=t;c[j+12>>2]=o;c[w>>2]=l3(q,138108,j)|0;do if((c[w>>2]|0)==4){c[x>>2]=fC(c[(c[l>>2]|0)+48>>2]|0,c[z>>2]|0,0)|0;if(c[x>>2]|0){h[u>>3]=+h[(c[(c[x>>2]|0)+8>>2]|0)+16>>3];h[v>>3]=+h[(c[(c[x>>2]|0)+8>>2]|0)+16+8>>3]}}else{j=c[y>>2]|0;q=c[z>>2]|0;o=c[A>>2]|0;c[g>>2]=r;c[g+4>>2]=s;c[g+8>>2]=t;c[g+12>>2]=q;c[g+16>>2]=o;c[w>>2]=l3(j,138128,g)|0;if((c[w>>2]|0)!=4){j=c[y>>2]|0;c[f>>2]=r;c[f+4>>2]=s;c[f+8>>2]=t;c[f+12>>2]=u;c[f+16>>2]=v;c[w>>2]=l3(j,138148,f)|0;break}c[x>>2]=fC(c[(c[l>>2]|0)+48>>2]|0,c[z>>2]|0,0)|0;if(c[x>>2]|0){h[u>>3]=+h[(c[(c[x>>2]|0)+8>>2]|0)+16>>3];h[v>>3]=+h[(c[(c[x>>2]|0)+8>>2]|0)+16+8>>3]}}while(0);O4(c[z>>2]|0);O4(c[A>>2]|0);C=+h[r>>3];D=c[k>>2]|0;E=D+368|0;h[E>>3]=C;F=+h[s>>3];G=c[k>>2]|0;H=G+368|0;I=H+8|0;h[I>>3]=F;J=+h[t>>3];K=c[k>>2]|0;L=K+352|0;h[L>>3]=J;M=+h[u>>3];N=c[k>>2]|0;O=N+336|0;h[O>>3]=M;P=+h[v>>3];Q=c[k>>2]|0;R=Q+336|0;S=R+8|0;h[S>>3]=P;i=e;return}function sI(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;f=i;i=i+240|0;g=f+152|0;j=f+112|0;k=f+224|0;l=f+220|0;m=f+216|0;n=f+136|0;o=f+120|0;p=f+96|0;q=f+80|0;r=f+64|0;s=f+208|0;t=f+200|0;u=f+192|0;v=f+184|0;w=f+48|0;x=f+32|0;y=f+16|0;z=f;A=f+176|0;B=f+168|0;c[k>>2]=b;c[l>>2]=e;c[m>>2]=c[c[k>>2]>>2];c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[q+12>>2]=0;e=(c[k>>2]|0)+368|0;c[o>>2]=c[e>>2];c[o+4>>2]=c[e+4>>2];c[o+8>>2]=c[e+8>>2];c[o+12>>2]=c[e+12>>2];if(c[(c[k>>2]|0)+360>>2]|0){c[g>>2]=c[o>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];tI(r,g);c[o>>2]=c[r>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2]}r=(c[k>>2]|0)+416|0;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2];if((d[(c[m>>2]|0)+294>>0]|0)!=0?(c[(c[k>>2]|0)+152>>2]&32|0)!=0:0){h[n>>3]=+h[(c[m>>2]|0)+232>>3]-+h[p>>3]*2.0;h[n+8>>3]=+h[(c[m>>2]|0)+232+8>>3]-+h[p+8>>3]*2.0;if(!(+h[n>>3]<.0001)){c[(c[k>>2]|0)+164>>2]=~~(+h[o>>3]/+h[n>>3]);if(+h[o>>3]-+(c[(c[k>>2]|0)+164>>2]|0)*+h[n>>3]>.0001){r=(c[k>>2]|0)+164|0;c[r>>2]=(c[r>>2]|0)+1}}else c[(c[k>>2]|0)+164>>2]=1;if(!(+h[n+8>>3]<.0001)){c[(c[k>>2]|0)+164+4>>2]=~~(+h[o+8>>3]/+h[n+8>>3]);if(+h[o+8>>3]-+(c[(c[k>>2]|0)+164+4>>2]|0)*+h[n+8>>3]>.0001){r=(c[k>>2]|0)+164+4|0;c[r>>2]=(c[r>>2]|0)+1}}else c[(c[k>>2]|0)+164+4>>2]=1;r=_(c[(c[k>>2]|0)+164>>2]|0,c[(c[k>>2]|0)+164+4>>2]|0)|0;c[(c[k>>2]|0)+204>>2]=r;h[o>>3]=+h[o>>3]<+h[n>>3]?+h[o>>3]:+h[n>>3];h[o+8>>3]=+h[o+8>>3]<+h[n+8>>3]?+h[o+8>>3]:+h[n+8>>3]}else{if(c[(c[k>>2]|0)+60+8>>2]|0){h[n>>3]=+h[(c[(c[k>>2]|0)+76+8>>2]|0)+24>>3]-+h[p>>3]*2.0;if(+h[n>>3]<0.0)h[n>>3]=0.0;h[n+8>>3]=+h[(c[(c[k>>2]|0)+76+8>>2]|0)+24+8>>3]-+h[p+8>>3]*2.0;if(+h[n+8>>3]<0.0)h[n+8>>3]=0.0}else{h[n+8>>3]=0.0;h[n>>3]=0.0}c[(c[k>>2]|0)+204>>2]=1;c[(c[k>>2]|0)+164+4>>2]=1;c[(c[k>>2]|0)+164>>2]=1;if(+h[n>>3]<+h[o>>3])h[n>>3]=+h[o>>3];if(+h[n+8>>3]<+h[o+8>>3])h[n+8>>3]=+h[o+8>>3]}C=(+h[n>>3]+ +h[p>>3]*2.0)*+h[(c[k>>2]|0)+432>>3]/72.0;c[(c[k>>2]|0)+448>>2]=~~((+h[n>>3]+ +h[p>>3]*2.0)*+h[(c[k>>2]|0)+432>>3]/72.0>=0.0?C+.5:C-.5);C=(+h[n+8>>3]+ +h[p+8>>3]*2.0)*+h[(c[k>>2]|0)+432+8>>3]/72.0;c[(c[k>>2]|0)+452>>2]=~~((+h[n+8>>3]+ +h[p+8>>3]*2.0)*+h[(c[k>>2]|0)+432+8>>3]/72.0>=0.0?C+.5:C-.5);c[(c[k>>2]|0)+188+4>>2]=0;c[(c[k>>2]|0)+188>>2]=0;c[(c[k>>2]|0)+180+4>>2]=0;c[(c[k>>2]|0)+180>>2]=0;c[(c[k>>2]|0)+172+4>>2]=0;c[(c[k>>2]|0)+172>>2]=0;r=(c[k>>2]|0)+180|0;uI(s,c[k>>2]|0,a[c[(c[m>>2]|0)+196>>2]>>0]|0);c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];s=(c[k>>2]|0)+188|0;uI(t,c[k>>2]|0,a[(c[(c[m>>2]|0)+196>>2]|0)+1>>0]|0);c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];if(!((N((c[(c[k>>2]|0)+180>>2]|0)+(c[(c[k>>2]|0)+188>>2]|0)|0)|0)==1?(N((c[(c[k>>2]|0)+180+4>>2]|0)+(c[(c[k>>2]|0)+188+4>>2]|0)|0)|0)==1:0)){t=(c[k>>2]|0)+180|0;uI(u,c[k>>2]|0,66);c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];u=(c[k>>2]|0)+188|0;uI(v,c[k>>2]|0,76);c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[j>>2]=c[(c[m>>2]|0)+196>>2];$z(0,138079,j)|0}if(a[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+82>>0]|0){if(+h[n>>3]>+h[o>>3])h[q>>3]=(+h[n>>3]-+h[o>>3])/2.0;if(+h[n+8>>3]>+h[o+8>>3])h[q+8>>3]=(+h[n+8>>3]-+h[o+8>>3])/2.0}if(c[(c[k>>2]|0)+360>>2]|0){c[g>>2]=c[o>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];tI(w,g);c[o>>2]=c[w>>2];c[o+4>>2]=c[w+4>>2];c[o+8>>2]=c[w+8>>2];c[o+12>>2]=c[w+12>>2];c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];tI(x,g);c[n>>2]=c[x>>2];c[n+4>>2]=c[x+4>>2];c[n+8>>2]=c[x+8>>2];c[n+12>>2]=c[x+12>>2];c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];tI(y,g);c[p>>2]=c[y>>2];c[p+4>>2]=c[y+4>>2];c[p+8>>2]=c[y+8>>2];c[p+12>>2]=c[y+12>>2];c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];c[g+12>>2]=c[q+12>>2];tI(z,g);c[q>>2]=c[z>>2];c[q+4>>2]=c[z+4>>2];c[q+8>>2]=c[z+8>>2];c[q+12>>2]=c[z+12>>2]}h[(c[k>>2]|0)+384>>3]=+h[p>>3]+ +h[q>>3];h[(c[k>>2]|0)+384+8>>3]=+h[p+8>>3]+ +h[q+8>>3];h[(c[k>>2]|0)+384+16>>3]=+h[p>>3]+ +h[q>>3]+ +h[o>>3];h[(c[k>>2]|0)+384+16+8>>3]=+h[p+8>>3]+ +h[q+8>>3]+ +h[o+8>>3];h[(c[k>>2]|0)+320>>3]=+h[o>>3]/+h[(c[k>>2]|0)+352>>3];h[(c[k>>2]|0)+320+8>>3]=+h[o+8>>3]/+h[(c[k>>2]|0)+352>>3];C=+h[(c[k>>2]|0)+384>>3]*+h[(c[k>>2]|0)+432>>3]/72.0;c[(c[k>>2]|0)+456>>2]=~~(+h[(c[k>>2]|0)+384>>3]*+h[(c[k>>2]|0)+432>>3]/72.0>=0.0?C+.5:C-.5);C=+h[(c[k>>2]|0)+384+8>>3]*+h[(c[k>>2]|0)+432+8>>3]/72.0;c[(c[k>>2]|0)+456+4>>2]=~~(+h[(c[k>>2]|0)+384+8>>3]*+h[(c[k>>2]|0)+432+8>>3]/72.0>=0.0?C+.5:C-.5);C=+h[(c[k>>2]|0)+384+16>>3]*+h[(c[k>>2]|0)+432>>3]/72.0;c[(c[k>>2]|0)+456+8>>2]=~~(+h[(c[k>>2]|0)+384+16>>3]*+h[(c[k>>2]|0)+432>>3]/72.0>=0.0?C+.5:C-.5);C=+h[(c[k>>2]|0)+384+16+8>>3]*+h[(c[k>>2]|0)+432+8>>3]/72.0;c[(c[k>>2]|0)+456+8+4>>2]=~~(+h[(c[k>>2]|0)+384+16+8>>3]*+h[(c[k>>2]|0)+432+8>>3]/72.0>=0.0?C+.5:C-.5);if(!(c[(c[k>>2]|0)+360>>2]|0)){i=f;return}o=(c[k>>2]|0)+456|0;q=(c[k>>2]|0)+456|0;c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];vI(A,g);c[o>>2]=c[A>>2];c[o+4>>2]=c[A+4>>2];A=(c[k>>2]|0)+456+8|0;o=(c[k>>2]|0)+456+8|0;c[g>>2]=c[o>>2];c[g+4>>2]=c[o+4>>2];vI(B,g);c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];i=f;return}function tI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;h[e>>3]=+h[b+8>>3];h[e+8>>3]=+h[b>>3];c[a>>2]=c[e>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];i=d;return}function uI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+8|0;h=f+12|0;j=f;c[g>>2]=d;a[h>>0]=e;c[j+4>>2]=0;c[j>>2]=0;switch(a[h>>0]|0){case 84:{c[(c[g>>2]|0)+172+4>>2]=(c[(c[g>>2]|0)+164+4>>2]|0)-1;c[j+4>>2]=-1;break}case 66:{c[j+4>>2]=1;break}case 76:{c[j>>2]=1;break}case 82:{c[(c[g>>2]|0)+172>>2]=(c[(c[g>>2]|0)+164>>2]|0)-1;c[j>>2]=-1;break}default:{}}c[b>>2]=c[j>>2];c[b+4>>2]=c[j+4>>2];i=f;return}function vI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=c[b+4>>2];c[e+4>>2]=c[b>>2];c[a>>2]=c[e>>2];c[a+4>>2]=c[e+4>>2];i=d;return}function wI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=yA(c[j>>2]|0,138324)|0;c[(c[h>>2]|0)+296>>2]=e;if(!(c[(c[h>>2]|0)+296>>2]|0))c[(c[h>>2]|0)+296>>2]=138333;e=yA(c[j>>2]|0,138337)|0;c[(c[h>>2]|0)+300>>2]=e;if(!(c[(c[h>>2]|0)+300>>2]|0))c[(c[h>>2]|0)+300>>2]=138350;e=R3(c[(c[h>>2]|0)+296>>2]|0,c[(c[h>>2]|0)+300>>2]|0)|0;c[m>>2]=e;if(e){c[g>>2]=a[c[m>>2]>>0];$z(0,138352,g)|0;c[(c[h>>2]|0)+300>>2]=178518}c[l>>2]=0;c[n>>2]=0;g=M3(c[k>>2]|0)|0;c[(c[h>>2]|0)+304>>2]=g;c[m>>2]=V3(c[(c[h>>2]|0)+304>>2]|0,c[(c[h>>2]|0)+296>>2]|0)|0;while(1){o=c[l>>2]|0;if(!(c[m>>2]|0))break;c[l>>2]=o+1;if((c[l>>2]|0)>(c[n>>2]|0)){c[n>>2]=(c[n>>2]|0)+128;if(c[(c[h>>2]|0)+308>>2]|0)p=eK(c[(c[h>>2]|0)+308>>2]|0,c[n>>2]<<2)|0;else p=cK(c[n>>2]<<2)|0;c[(c[h>>2]|0)+308>>2]=p}c[(c[(c[h>>2]|0)+308>>2]|0)+(c[l>>2]<<2)>>2]=c[m>>2];c[m>>2]=V3(0,c[(c[h>>2]|0)+296>>2]|0)|0}if(!o){q=c[l>>2]|0;i=f;return q|0}o=eK(c[(c[h>>2]|0)+308>>2]|0,(c[l>>2]|0)+2<<2)|0;c[(c[h>>2]|0)+308>>2]=o;c[c[(c[h>>2]|0)+308>>2]>>2]=0;c[(c[(c[h>>2]|0)+308>>2]|0)+((c[l>>2]|0)+1<<2)>>2]=0;q=c[l>>2]|0;i=f;return q|0}function xI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;g=e+24|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;c[g>>2]=a;c[e+20>>2]=b;c[h>>2]=d;c[j>>2]=cK((c[(c[g>>2]|0)+312>>2]|0)+2<<2)|0;c[l>>2]=0;c[k>>2]=1;while(1){if((c[k>>2]|0)>(c[(c[g>>2]|0)+312>>2]|0))break;if((yI(c[g>>2]|0,c[k>>2]|0,c[(c[g>>2]|0)+312>>2]|0,c[h>>2]|0)|0)<<24>>24){d=c[k>>2]|0;b=(c[l>>2]|0)+1|0;c[l>>2]=b;c[(c[j>>2]|0)+(b<<2)>>2]=d}c[k>>2]=(c[k>>2]|0)+1}if(c[l>>2]|0){c[c[j>>2]>>2]=c[l>>2];c[(c[j>>2]|0)+((c[l>>2]|0)+1<<2)>>2]=(c[(c[g>>2]|0)+312>>2]|0)+1;m=c[j>>2]|0;i=e;return m|0}else{c[f>>2]=c[h>>2];$z(0,138219,f)|0;c[c[j>>2]>>2]=c[l>>2];O4(c[j>>2]|0);c[j>>2]=0;m=c[j>>2]|0;i=e;return m|0}return 0}function yI(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;h=i;i=i+208|0;j=h+68|0;k=h+64|0;l=h+60|0;m=h+56|0;n=h+52|0;o=h+48|0;p=h+44|0;q=h+40|0;r=h+36|0;s=h+32|0;t=h+28|0;u=h+24|0;v=h+8|0;w=h+72|0;x=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[r>>2]=0;c[s>>2]=0;a[w>>0]=0;dA(v,128,h+80|0);gA(v,c[m>>2]|0)|0;if((c[v+4>>2]|0)>>>0>=(c[v+8>>2]|0)>>>0)eA(v,1)|0;m=v+4|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g>>0]=0;g=c[v>>2]|0;c[v+4>>2]=g;c[u>>2]=g;while(1){if(d[w>>0]|0){y=18;break}g=W3(c[u>>2]|0,c[(c[j>>2]|0)+300>>2]|0,r)|0;c[t>>2]=g;if(!g){y=18;break}g=W3(c[t>>2]|0,c[(c[j>>2]|0)+296>>2]|0,s)|0;c[p>>2]=g;c[q>>2]=g;if(c[p>>2]|0)c[q>>2]=W3(0,c[(c[j>>2]|0)+296>>2]|0,s)|0;switch(((c[p>>2]|0)!=0&1)+((c[q>>2]|0)!=0&1)|0){case 0:{a[w>>0]=0;break}case 1:{c[n>>2]=zI(c[j>>2]|0,c[p>>2]|0,c[k>>2]|0)|0;a[w>>0]=(c[n>>2]|0)==(c[k>>2]|0);break}case 2:{c[n>>2]=zI(c[j>>2]|0,c[p>>2]|0,0)|0;c[o>>2]=zI(c[j>>2]|0,c[q>>2]|0,c[l>>2]|0)|0;if((c[n>>2]|0)>=0|(c[o>>2]|0)>=0){if((c[n>>2]|0)>(c[o>>2]|0)){c[x>>2]=c[n>>2];c[n>>2]=c[o>>2];c[o>>2]=c[x>>2]}if((c[n>>2]|0)<=(c[k>>2]|0))z=(c[k>>2]|0)<=(c[o>>2]|0);else z=0;a[w>>0]=z&1}break}default:{}}c[u>>2]=0}if((y|0)==18){hA(v);i=h;return a[w>>0]|0}return 0}function zI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((a[c[j>>2]>>0]|0)==(a[138320]|0)?(J3(c[j>>2]|0,138320)|0)==0:0){c[g>>2]=c[k>>2];m=c[g>>2]|0;i=f;return m|0}if((AI(c[j>>2]|0)|0)<<24>>24){c[g>>2]=u3(c[j>>2]|0)|0;m=c[g>>2]|0;i=f;return m|0}a:do if(c[(c[h>>2]|0)+308>>2]|0){c[l>>2]=1;while(1){if((c[l>>2]|0)>(c[(c[h>>2]|0)+312>>2]|0))break a;if((a[c[j>>2]>>0]|0)==(a[c[(c[(c[h>>2]|0)+308>>2]|0)+(c[l>>2]<<2)>>2]>>0]|0)?(J3(c[j>>2]|0,c[(c[(c[h>>2]|0)+308>>2]|0)+(c[l>>2]<<2)>>2]|0)|0)==0:0)break;c[l>>2]=(c[l>>2]|0)+1}c[g>>2]=c[l>>2];m=c[g>>2]|0;i=f;return m|0}while(0);c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}function AI(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=c[g>>2];while(1){if(!(a[c[h>>2]>>0]|0)){j=5;break}g=c[h>>2]|0;c[h>>2]=g+1;if(!(p1(d[g>>0]|0)|0)){j=4;break}}if((j|0)==4){a[f>>0]=0;k=a[f>>0]|0;i=e;return k|0}else if((j|0)==5){a[f>>0]=1;k=a[f>>0]|0;i=e;return k|0}return 0}function BI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;h[(c[(c[f>>2]|0)+8>>2]|0)+48>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[f>>2]|0)+8>>2]|0)+88>>3];h[(c[(c[f>>2]|0)+8>>2]|0)+48+8>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[f>>2]|0)+8>>2]|0)+80>>3]/2.0;h[(c[(c[f>>2]|0)+8>>2]|0)+48+16>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[f>>2]|0)+8>>2]|0)+96>>3];h[(c[(c[f>>2]|0)+8>>2]|0)+48+16+8>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[f>>2]|0)+8>>2]|0)+80>>3]/2.0;c[g>>2]=OA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;CI(c[g>>2]|0);c[g>>2]=QA(c[e>>2]|0,c[g>>2]|0)|0}i=d;return}function CI(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2];if(!(c[e>>2]|0)){i=b;return}DI(c[e>>2]|0);i=b;return}function DI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0;b=i;i=i+320|0;d=b+256|0;e=b+240|0;f=b+308|0;g=b+304|0;j=b+192|0;k=b+160|0;l=b+128|0;m=b+96|0;n=b+64|0;o=b+32|0;p=b;c[f>>2]=a;if((c[(c[f>>2]|0)+4>>2]|0)<=0)La(138491,137578,3899,138505);a=j;q=c[c[f>>2]>>2]|0;r=a+48|0;do{c[a>>2]=c[q>>2];a=a+4|0;q=q+4|0}while((a|0)<(r|0));a=d;q=j;r=a+48|0;do{c[a>>2]=c[q>>2];a=a+4|0;q=q+4|0}while((a|0)<(r|0));EI(m,d);c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];c[k+16>>2]=c[m+16>>2];c[k+20>>2]=c[m+20>>2];c[k+24>>2]=c[m+24>>2];c[k+28>>2]=c[m+28>>2];c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;if((c[g>>2]|0)>0){a=j;q=(c[c[f>>2]>>2]|0)+((c[g>>2]|0)*48|0)|0;r=a+48|0;do{c[a>>2]=c[q>>2];a=a+4|0;q=q+4|0}while((a|0)<(r|0));a=d;q=j;r=a+48|0;do{c[a>>2]=c[q>>2];a=a+4|0;q=q+4|0}while((a|0)<(r|0));EI(n,d);c[l>>2]=c[n>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];c[l+16>>2]=c[n+16>>2];c[l+20>>2]=c[n+20>>2];c[l+24>>2]=c[n+24>>2];c[l+28>>2]=c[n+28>>2];h[k>>3]=+h[k>>3]<+h[l>>3]?+h[k>>3]:+h[l>>3];h[k+8>>3]=+h[k+8>>3]<+h[l+8>>3]?+h[k+8>>3]:+h[l+8>>3];h[k+16>>3]=+h[k+16>>3]>+h[l+16>>3]?+h[k+16>>3]:+h[l+16>>3];if(+h[k+16+8>>3]>+h[l+16+8>>3])s=+h[k+16+8>>3];else s=+h[l+16+8>>3];h[k+16+8>>3]=s}if(c[j+8>>2]|0){m=j+16|0;t=c[j>>2]|0;u=c[j+8>>2]|0;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[d>>2]=c[t>>2];c[d+4>>2]=c[t+4>>2];c[d+8>>2]=c[t+8>>2];c[d+12>>2]=c[t+12>>2];gH(o,e,d,1.0,u);c[l>>2]=c[o>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];c[l+24>>2]=c[o+24>>2];c[l+28>>2]=c[o+28>>2];h[k>>3]=+h[k>>3]<+h[l>>3]?+h[k>>3]:+h[l>>3];h[k+8>>3]=+h[k+8>>3]<+h[l+8>>3]?+h[k+8>>3]:+h[l+8>>3];h[k+16>>3]=+h[k+16>>3]>+h[l+16>>3]?+h[k+16>>3]:+h[l+16>>3];if(+h[k+16+8>>3]>+h[l+16+8>>3])v=+h[k+16+8>>3];else v=+h[l+16+8>>3];h[k+16+8>>3]=v}if(c[j+12>>2]|0){u=j+32|0;t=(c[j>>2]|0)+((c[j+4>>2]|0)-1<<4)|0;m=c[j+12>>2]|0;c[e>>2]=c[u>>2];c[e+4>>2]=c[u+4>>2];c[e+8>>2]=c[u+8>>2];c[e+12>>2]=c[u+12>>2];c[d>>2]=c[t>>2];c[d+4>>2]=c[t+4>>2];c[d+8>>2]=c[t+8>>2];c[d+12>>2]=c[t+12>>2];gH(p,e,d,1.0,m);c[l>>2]=c[p>>2];c[l+4>>2]=c[p+4>>2];c[l+8>>2]=c[p+8>>2];c[l+12>>2]=c[p+12>>2];c[l+16>>2]=c[p+16>>2];c[l+20>>2]=c[p+20>>2];c[l+24>>2]=c[p+24>>2];c[l+28>>2]=c[p+28>>2];h[k>>3]=+h[k>>3]<+h[l>>3]?+h[k>>3]:+h[l>>3];h[k+8>>3]=+h[k+8>>3]<+h[l+8>>3]?+h[k+8>>3]:+h[l+8>>3];h[k+16>>3]=+h[k+16>>3]>+h[l+16>>3]?+h[k+16>>3]:+h[l+16>>3];if(+h[k+16+8>>3]>+h[l+16+8>>3])w=+h[k+16+8>>3];else w=+h[l+16+8>>3];h[k+16+8>>3]=w}c[g>>2]=(c[g>>2]|0)+1}g=(c[f>>2]|0)+8|0;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];c[g+24>>2]=c[k+24>>2];c[g+28>>2]=c[k+28>>2];i=b;return}function EI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;d=i;i=i+96|0;e=d+80|0;f=d+64|0;g=d+48|0;j=d+32|0;k=d;if((c[b+4>>2]|0)<=0)La(138521,137578,3873,138533);if(((c[b+4>>2]|0)%3|0|0)!=1)La(138543,137578,3874,138533);l=k+16|0;m=c[b>>2]|0;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[k>>2]=c[l>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[e>>2]=1;while(1){if((c[e>>2]|0)>=(c[b+4>>2]|0))break;l=(c[b>>2]|0)+(c[e>>2]<<4)|0;c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[e>>2]=(c[e>>2]|0)+1;l=(c[b>>2]|0)+(c[e>>2]<<4)|0;c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[e>>2]=(c[e>>2]|0)+1;h[f>>3]=(+h[g>>3]+ +h[j>>3])/2.0;h[f+8>>3]=(+h[g+8>>3]+ +h[j+8>>3])/2.0;h[k>>3]=+h[k>>3]<+h[f>>3]?+h[k>>3]:+h[f>>3];h[k+8>>3]=+h[k+8>>3]<+h[f+8>>3]?+h[k+8>>3]:+h[f+8>>3];h[k+16>>3]=+h[k+16>>3]>+h[f>>3]?+h[k+16>>3]:+h[f>>3];if(+h[k+16+8>>3]>+h[f+8>>3])n=+h[k+16+8>>3];else n=+h[f+8>>3];h[k+16+8>>3]=n;l=(c[b>>2]|0)+(c[e>>2]<<4)|0;c[f>>2]=c[l>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];h[k>>3]=+h[k>>3]<+h[f>>3]?+h[k>>3]:+h[f>>3];h[k+8>>3]=+h[k+8>>3]<+h[f+8>>3]?+h[k+8>>3]:+h[f+8>>3];h[k+16>>3]=+h[k+16>>3]>+h[f>>3]?+h[k+16>>3]:+h[f>>3];if(+h[k+16+8>>3]>+h[f+8>>3])o=+h[k+16+8>>3];else o=+h[f+8>>3];h[k+16+8>>3]=o;c[e>>2]=(c[e>>2]|0)+1}c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];c[a+16>>2]=c[k+16>>2];c[a+20>>2]=c[k+20>>2];c[a+24>>2]=c[k+24>>2];c[a+28>>2]=c[k+28>>2];i=d;return}function FI(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;switch(c[f>>2]|0){case 0:case 44:case 41:case 40:{a[e>>0]=1;break}default:a[e>>0]=0}i=d;return a[e>>0]|0}function GI(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+80|0;g=f+32|0;h=f;j=f+76|0;k=f+72|0;l=f+68|0;m=f+64|0;c[k>>2]=b;c[l>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2];if((c[l>>2]|0)!=0?(b=(c[l>>2]|0)+8|0,c[h>>2]=c[b>>2],c[h+4>>2]=c[b+4>>2],c[h+8>>2]=c[b+8>>2],c[h+12>>2]=c[b+12>>2],c[h+16>>2]=c[b+16>>2],c[h+20>>2]=c[b+20>>2],c[h+24>>2]=c[b+24>>2],c[h+28>>2]=c[b+28>>2],c[g>>2]=c[e>>2],c[g+4>>2]=c[e+4>>2],c[g+8>>2]=c[e+8>>2],c[g+12>>2]=c[e+12>>2],c[g+16>>2]=c[e+16>>2],c[g+20>>2]=c[e+20>>2],c[g+24>>2]=c[e+24>>2],c[g+28>>2]=c[e+28>>2],(iJ(h,g)|0)!=0):0){a[j>>0]=1;n=a[j>>0]|0;i=f;return n|0}c[m>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+96>>2];if((c[m>>2]|0)!=0?(h=c[m>>2]|0,c[g>>2]=c[e>>2],c[g+4>>2]=c[e+4>>2],c[g+8>>2]=c[e+8>>2],c[g+12>>2]=c[e+12>>2],c[g+16>>2]=c[e+16>>2],c[g+20>>2]=c[e+20>>2],c[g+24>>2]=c[e+24>>2],c[g+28>>2]=c[e+28>>2],((NO(h,g)|0)&255|0)!=0):0){a[j>>0]=1;n=a[j>>0]|0;i=f;return n|0}c[m>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+108>>2];if(((c[m>>2]|0)!=0?(d[(c[m>>2]|0)+81>>0]|0|0)!=0:0)?(k=c[m>>2]|0,c[g>>2]=c[e>>2],c[g+4>>2]=c[e+4>>2],c[g+8>>2]=c[e+8>>2],c[g+12>>2]=c[e+12>>2],c[g+16>>2]=c[e+16>>2],c[g+20>>2]=c[e+20>>2],c[g+24>>2]=c[e+24>>2],c[g+28>>2]=c[e+28>>2],((NO(k,g)|0)&255|0)!=0):0){a[j>>0]=1;n=a[j>>0]|0;i=f;return n|0}a[j>>0]=0;n=a[j>>0]|0;i=f;return n|0}function HI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=b;c[f+16>>2]=d;c[j>>2]=e;if((c[(c[h>>2]|0)+156>>2]|0)<=1){a[g>>0]=1;n=a[g>>0]|0;i=f;return n|0}c[k>>2]=hO(c[j>>2]|0,c[13874]|0,178518)|0;if((hJ(c[h>>2]|0,c[k>>2]|0)|0)<<24>>24){a[g>>0]=1;n=a[g>>0]|0;i=f;return n|0}if(a[c[k>>2]>>0]|0){a[g>>0]=0;n=a[g>>0]|0;i=f;return n|0}c[m>>2]=0;while(1){if((c[m>>2]|0)>=2){o=16;break}k=c[c[j>>2]>>2]&3;if((c[m>>2]|0)<1){e=c[j>>2]|0;p=c[((k|0)==3?e:e+32|0)+28>>2]|0}else{e=c[j>>2]|0;p=c[((k|0)==2?e:e+-32|0)+28>>2]|0}c[l>>2]=hO(p,c[13844]|0,178518)|0;if(!(a[c[l>>2]>>0]|0)){o=14;break}if((hJ(c[h>>2]|0,c[l>>2]|0)|0)&255){o=14;break}c[m>>2]=(c[m>>2]|0)+1}if((o|0)==14){a[g>>0]=1;n=a[g>>0]|0;i=f;return n|0}else if((o|0)==16){a[g>>0]=0;n=a[g>>0]|0;i=f;return n|0}return 0}function II(d,f,g){d=d|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0;j=i;i=i+240|0;k=j+100|0;l=j+96|0;m=j+92|0;n=j+88|0;o=j+84|0;p=j+80|0;q=j+76|0;r=j+72|0;s=j+68|0;t=j+64|0;u=j+60|0;v=j+56|0;w=j+52|0;x=j+48|0;y=j+44|0;z=j+40|0;A=j+8|0;B=j+24|0;C=j+104|0;D=j+20|0;E=j+16|0;F=j;c[k>>2]=d;c[l>>2]=f;c[m>>2]=g;c[o>>2]=c[(c[k>>2]|0)+152>>2];c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;c[z>>2]=0;c[n>>2]=wH(c[k>>2]|0)|0;c[(c[n>>2]|0)+4>>2]=3;c[(c[n>>2]|0)+8>>2]=c[l>>2];c[(c[n>>2]|0)+12>>2]=9;if((c[m>>2]|0)!=0?(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)rR(c[k>>2]|0,c[m>>2]|0);if(((c[13890]|0)!=0?(m=zA(c[l>>2]|0,c[13890]|0)|0,c[p>>2]=m,(m|0)!=0):0)?(a[c[p>>2]>>0]|0)!=0:0){h[A>>3]=+fO(c[l>>2]|0,c[13890]|0,1.0,0.0);zR(c[k>>2]|0,+h[A>>3])}do if(c[o>>2]&16777216){A=c[l>>2]|0;if((e[(c[(qC(c[((c[c[l>>2]>>2]&3|0)==3?A:A+32|0)+28>>2]|0)|0)+8>>2]|0)+178>>1]|0)>=3){A=c[l>>2]|0;m=c[l>>2]|0;G=+h[(c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+16>>3]*72.0;h[(c[n>>2]|0)+176>>3]=+(~~(+h[(c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?A:A+32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+16>>3]*72.0>=0.0?G+.5:G-.5)|0);A=c[l>>2]|0;m=c[l>>2]|0;G=+h[(c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+16>>3]*72.0;h[(c[n>>2]|0)+184>>3]=+(~~(+h[(c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?A:A+-32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+16>>3]*72.0>=0.0?G+.5:G-.5)|0);break}else{h[(c[n>>2]|0)+184>>3]=0.0;h[(c[n>>2]|0)+176>>3]=0.0;break}}while(0);if(c[o>>2]&32768){A=c[(c[(c[l>>2]|0)+8>>2]|0)+96>>2]|0;c[q>>2]=A;if(A)c[(c[n>>2]|0)+192>>2]=c[c[q>>2]>>2];q=c[(c[n>>2]|0)+192>>2]|0;c[(c[n>>2]|0)+196>>2]=q;c[(c[n>>2]|0)+204>>2]=q;c[(c[n>>2]|0)+200>>2]=q;q=c[(c[(c[l>>2]|0)+8>>2]|0)+108>>2]|0;c[r>>2]=q;if(q)c[(c[n>>2]|0)+196>>2]=c[c[r>>2]>>2];q=c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0;c[r>>2]=q;if(q)c[(c[n>>2]|0)+200>>2]=c[c[r>>2]>>2];r=c[(c[(c[l>>2]|0)+8>>2]|0)+100>>2]|0;c[s>>2]=r;if(r)c[(c[n>>2]|0)+204>>2]=c[c[s>>2]>>2]}a:do if(c[o>>2]&65536){dA(B,128,C);c[p>>2]=zH(c[k>>2]|0,c[l>>2]|0,B)|0;s=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+212>>2]=s;hA(B);s=yA(c[l>>2]|0,179064)|0;c[p>>2]=s;if((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0)H=26;else H=24;if(((H|0)==24?(s=yA(c[l>>2]|0,149053)|0,c[p>>2]=s,(s|0)!=0):0)?(a[c[p>>2]>>0]|0)!=0:0)H=26;if((H|0)==26)c[y>>2]=WJ(c[p>>2]|0,c[l>>2]|0)|0;s=yA(c[l>>2]|0,138621)|0;c[p>>2]=s;if((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0)H=31;else H=29;do if((H|0)==29){s=yA(c[l>>2]|0,138630)|0;c[p>>2]=s;if((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){H=31;break}if(c[y>>2]|0){s=M3(c[y>>2]|0)|0;c[(c[n>>2]|0)+208>>2]=s}}while(0);if((H|0)==31){s=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+208>>2]=s}s=yA(c[l>>2]|0,138638)|0;c[p>>2]=s;if((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0)H=38;else H=36;do if((H|0)==36){s=yA(c[l>>2]|0,138648)|0;c[p>>2]=s;if((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){H=38;break}if(c[y>>2]|0){s=M3(c[y>>2]|0)|0;c[(c[n>>2]|0)+216>>2]=s}}while(0);if((H|0)==38){s=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+216>>2]=s}s=yA(c[l>>2]|0,138657)|0;c[p>>2]=s;if((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0)H=45;else H=43;do if((H|0)==43){s=yA(c[l>>2]|0,138666)|0;c[p>>2]=s;if((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){H=45;break}if(c[y>>2]|0){s=M3(c[y>>2]|0)|0;c[(c[n>>2]|0)+220>>2]=s}}while(0);if((H|0)==45){s=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+220>>2]=s;s=(c[n>>2]|0)+260|0;b[s>>1]=b[s>>1]&-129|128}s=yA(c[l>>2]|0,138674)|0;c[p>>2]=s;if(!((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0))H=50;do if((H|0)==50){s=yA(c[l>>2]|0,138683)|0;c[p>>2]=s;if((s|0)!=0?(a[c[p>>2]>>0]|0)!=0:0)break;if(!(c[y>>2]|0))break a;s=M3(c[y>>2]|0)|0;c[(c[n>>2]|0)+224>>2]=s;break a}while(0);s=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+224>>2]=s;s=(c[n>>2]|0)+260|0;b[s>>1]=b[s>>1]&-257|256}while(0);do if(c[o>>2]&8388608){B=yA(c[l>>2]|0,179097)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0)c[z>>2]=WJ(c[p>>2]|0,c[l>>2]|0)|0;B=yA(c[l>>2]|0,138691)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){B=(c[n>>2]|0)+260|0;b[B>>1]=b[B>>1]&-65|64;B=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+244>>2]=B}else H=62;if((H|0)==62?(c[z>>2]|0)!=0:0){B=M3(c[z>>2]|0)|0;c[(c[n>>2]|0)+244>>2]=B}B=yA(c[l>>2]|0,138702)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){B=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+248>>2]=B}else H=67;if((H|0)==67?(c[z>>2]|0)!=0:0){B=M3(c[z>>2]|0)|0;c[(c[n>>2]|0)+248>>2]=B}B=yA(c[l>>2]|0,138714)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){B=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+252>>2]=B;B=(c[n>>2]|0)+260|0;b[B>>1]=b[B>>1]&-17|16}else H=72;if((H|0)==72?(c[z>>2]|0)!=0:0){B=M3(c[z>>2]|0)|0;c[(c[n>>2]|0)+252>>2]=B}B=yA(c[l>>2]|0,138725)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){B=(c[n>>2]|0)+260|0;b[B>>1]=b[B>>1]&-33|32;B=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+256>>2]=B;break}if(c[z>>2]|0){B=M3(c[z>>2]|0)|0;c[(c[n>>2]|0)+256>>2]=B}}while(0);do if(c[o>>2]&4194304){B=yA(c[l>>2]|0,179110)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0)H=84;else H=82;do if((H|0)==82){B=yA(c[l>>2]|0,138736)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){H=84;break}if(c[(c[n>>2]|0)+192>>2]|0){B=M3(c[(c[n>>2]|0)+192>>2]|0)|0;c[(c[n>>2]|0)+228>>2]=B}}while(0);if((H|0)==84){B=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+228>>2]=B;B=(c[n>>2]|0)+260|0;b[B>>1]=b[B>>1]&-2|1}B=yA(c[l>>2]|0,138748)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){B=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+232>>2]=B;B=(c[n>>2]|0)+260|0;b[B>>1]=b[B>>1]&-9|8}else H=90;if((H|0)==90?(c[(c[n>>2]|0)+192>>2]|0)!=0:0){B=M3(c[(c[n>>2]|0)+192>>2]|0)|0;c[(c[n>>2]|0)+232>>2]=B}B=yA(c[l>>2]|0,138761)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){B=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+236>>2]=B;B=(c[n>>2]|0)+260|0;b[B>>1]=b[B>>1]&-3|2}else H=95;if((H|0)==95?(c[(c[n>>2]|0)+200>>2]|0)!=0:0){B=M3(c[(c[n>>2]|0)+200>>2]|0)|0;c[(c[n>>2]|0)+236>>2]=B}B=yA(c[l>>2]|0,138773)|0;c[p>>2]=B;if((B|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){B=WJ(c[p>>2]|0,c[l>>2]|0)|0;c[(c[n>>2]|0)+240>>2]=B;B=(c[n>>2]|0)+260|0;b[B>>1]=b[B>>1]&-5|4;break}if(c[(c[n>>2]|0)+204>>2]|0){B=M3(c[(c[n>>2]|0)+204>>2]|0)|0;c[(c[n>>2]|0)+240>>2]=B}}while(0);O4(c[y>>2]|0);O4(c[z>>2]|0);do if((c[o>>2]&4259840|0)!=0?(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){if((c[(c[n>>2]|0)+208>>2]|0)==0?(c[(c[n>>2]|0)+228>>2]|0)==0:0)break;if(c[o>>2]&524288){if(+h[(c[(c[k>>2]|0)+16>>2]|0)+152>>3]/2.0>2.0)I=+h[(c[(c[k>>2]|0)+16>>2]|0)+152>>3]/2.0;else I=2.0;h[F>>3]=I;c[E>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2];c[D>>2]=c[(c[E>>2]|0)+4>>2];c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[D>>2]|0))break;bJ(t,w,x,(c[c[E>>2]>>2]|0)+((c[u>>2]|0)*48|0)|0,+h[F>>3]);c[u>>2]=(c[u>>2]|0)+1}c[(c[n>>2]|0)+276>>2]=c[x>>2];c[(c[n>>2]|0)+280>>2]=c[w>>2];if(!(c[o>>2]&8192)){c[v>>2]=0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[x>>2]|0))break;c[v>>2]=(c[v>>2]|0)+(c[(c[w>>2]|0)+(c[u>>2]<<2)>>2]|0);c[u>>2]=(c[u>>2]|0)+1}UQ(c[k>>2]|0,c[t>>2]|0,c[t>>2]|0,c[v>>2]|0)|0}c[(c[n>>2]|0)+284>>2]=c[t>>2];c[(c[n>>2]|0)+264>>2]=2;c[(c[n>>2]|0)+272>>2]=c[t>>2];c[(c[n>>2]|0)+268>>2]=c[c[w>>2]>>2]}}while(0);hR(c[k>>2]|0,c[l>>2]|0);if((c[(c[n>>2]|0)+208>>2]|0)==0?((b[(c[n>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0){i=j;return}jR(c[k>>2]|0,c[(c[n>>2]|0)+208>>2]|0,c[(c[n>>2]|0)+228>>2]|0,c[(c[n>>2]|0)+244>>2]|0,c[(c[n>>2]|0)+212>>2]|0);i=j;return}function JI(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0.0,_=0.0;g=i;i=i+432|0;j=g+328|0;k=g+312|0;l=g+296|0;m=g+280|0;n=g+420|0;o=g+416|0;p=g+412|0;q=g+408|0;r=g+404|0;s=g+400|0;t=g+396|0;u=g+392|0;v=g+388|0;w=g+384|0;x=g+380|0;y=g+376|0;z=g+372|0;A=g+368|0;B=g+364|0;C=g+232|0;D=g+192|0;E=g+152|0;F=g+136|0;G=g+120|0;H=g+104|0;I=g+88|0;J=g+360|0;K=g+356|0;L=g+80|0;M=g+72|0;N=g+64|0;O=g+352|0;P=g+424|0;Q=g+348|0;R=g+344|0;S=g+48|0;T=g+32|0;U=g+16|0;V=g;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[t>>2]=0;c[u>>2]=0;c[B>>2]=0;c[H>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;c[H+12>>2]=0;h[N>>3]=+h[(c[(c[n>>2]|0)+16>>2]|0)+152>>3];a[P>>0]=0;dT(yA(c[o>>2]|0,137612)|0);if(!(c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]|0)){i=g;return}h[L>>3]=+fO(c[o>>2]|0,c[13872]|0,1.0,0.0);c[v>>2]=hO(c[o>>2]|0,c[13853]|0,178518)|0;a:do if(c[p>>2]|0){c[Q>>2]=c[p>>2];while(1){f=c[Q>>2]|0;c[Q>>2]=f+4;e=c[f>>2]|0;c[O>>2]=e;if(!e)break a;if((a[c[O>>2]>>0]|0)!=(a[148679]|0))continue;if(!(J3(c[O>>2]|0,148679)|0))break}a[P>>0]=1}while(0);c[O>>2]=c[v>>2];while(1){if(!(a[c[O>>2]>>0]|0))break;if((a[c[O>>2]>>0]|0)!=58){if((a[c[O>>2]>>0]|0)==59)c[u>>2]=(c[u>>2]|0)+1}else c[t>>2]=(c[t>>2]|0)+1;c[O>>2]=(c[O>>2]|0)+1}do if((c[u>>2]|0)!=0&(c[t>>2]|0)!=0)if(RI(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[v>>2]|0,(c[t>>2]|0)+1|0,+h[L>>3],+h[N>>3])|0){c[v>>2]=174917;break}else{i=g;return}while(0);u=c[v>>2]|0;c[w>>2]=u;c[x>>2]=u;u=c[o>>2]|0;do if(!(d[(c[(c[o>>2]|0)+8>>2]|0)+115>>0]&1)){O=c[o>>2]|0;if(d[(c[u+8>>2]|0)+115>>0]&2){Q=c[13857]|0;c[w>>2]=iO(O,Q,SI(c[w>>2]|0,143682)|0)|0;c[x>>2]=iO(c[o>>2]|0,c[13858]|0,143690)|0;break}Q=c[o>>2]|0;if(d[(c[O+8>>2]|0)+115>>0]&8){O=c[13861]|0;c[w>>2]=iO(Q,O,SI(c[w>>2]|0,143698)|0)|0;c[x>>2]=iO(c[o>>2]|0,c[13862]|0,143706)|0;break}O=c[o>>2]|0;if(d[(c[Q+8>>2]|0)+115>>0]&4){Q=c[13859]|0;c[w>>2]=iO(O,Q,SI(c[w>>2]|0,143714)|0)|0;c[x>>2]=iO(c[o>>2]|0,c[13860]|0,143722)|0;break}else{c[x>>2]=iO(O,c[13854]|0,c[v>>2]|0)|0;break}}else{O=c[13855]|0;c[w>>2]=iO(u,O,SI(c[w>>2]|0,143666)|0)|0;c[x>>2]=iO(c[o>>2]|0,c[13856]|0,143674)|0}while(0);if((c[w>>2]|0)!=(c[v>>2]|0))oR(c[n>>2]|0,c[w>>2]|0);if((c[x>>2]|0)!=(c[v>>2]|0))pR(c[n>>2]|0,c[x>>2]|0);c[v>>2]=c[w>>2];if(a[P>>0]|0){if(!(a[c[v>>2]>>0]|0))c[v>>2]=174917;if(!(a[c[x>>2]>>0]|0))c[x>>2]=174917;oR(c[n>>2]|0,175430);pR(c[n>>2]|0,c[v>>2]|0);W=C;X=c[c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]>>2]|0;Y=W+48|0;do{c[W>>2]=c[X>>2];W=W+4|0;X=X+4|0}while((W|0)<(Y|0));P=TI(c[o>>2]|0)|0;c[R>>2]=GN(C,P,+h[N>>3],0,0)|0;tR(c[n>>2]|0,c[(c[R>>2]|0)+8>>2]|0,c[c[R>>2]>>2]|0,1);UI(c[R>>2]|0);oR(c[n>>2]|0,c[v>>2]|0);if((c[x>>2]|0)!=(c[v>>2]|0))pR(c[n>>2]|0,c[x>>2]|0);if(c[C+8>>2]|0){R=c[n>>2]|0;P=C+16|0;w=c[C>>2]|0;Z=+h[L>>3];_=+h[N>>3];u=c[C+8>>2]|0;c[k>>2]=c[P>>2];c[k+4>>2]=c[P+4>>2];c[k+8>>2]=c[P+8>>2];c[k+12>>2]=c[P+12>>2];c[j>>2]=c[w>>2];c[j+4>>2]=c[w+4>>2];c[j+8>>2]=c[w+8>>2];c[j+12>>2]=c[w+12>>2];hH(R,2,k,j,Z,_,u)}if(!(c[C+12>>2]|0)){i=g;return}u=c[n>>2]|0;R=C+32|0;w=(c[C>>2]|0)+((c[C+4>>2]|0)-1<<4)|0;_=+h[L>>3];Z=+h[N>>3];P=c[C+12>>2]|0;c[k>>2]=c[R>>2];c[k+4>>2]=c[R+4>>2];c[k+8>>2]=c[R+8>>2];c[k+12>>2]=c[R+12>>2];c[j>>2]=c[w>>2];c[j+4>>2]=c[w+4>>2];c[j+8>>2]=c[w+8>>2];c[j+12>>2]=c[w+12>>2];hH(u,3,k,j,_,Z,P);i=g;return}P=c[(c[o>>2]|0)+8>>2]|0;if(!(c[t>>2]|0)){do if(!(d[P+115>>0]&3)){u=c[n>>2]|0;if(a[c[v>>2]>>0]|0){oR(u,c[v>>2]|0);pR(c[n>>2]|0,c[x>>2]|0);break}oR(u,174917);u=c[n>>2]|0;if(a[c[x>>2]>>0]|0){pR(u,c[x>>2]|0);break}else{pR(u,174917);break}}while(0);c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[(c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;W=C;X=(c[c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[q>>2]|0)*48|0)|0;Y=W+48|0;do{c[W>>2]=c[X>>2];W=W+4|0;X=X+4|0}while((W|0)<(Y|0));x=c[n>>2]|0;u=c[C>>2]|0;w=c[C+4>>2]|0;do if(!(c[(c[n>>2]|0)+152>>2]&16384)){vR(x,u,w,0,0,0);if(c[C+8>>2]|0){R=c[n>>2]|0;O=C+16|0;Q=c[C>>2]|0;Z=+h[L>>3];_=+h[N>>3];e=c[C+8>>2]|0;c[k>>2]=c[O>>2];c[k+4>>2]=c[O+4>>2];c[k+8>>2]=c[O+8>>2];c[k+12>>2]=c[O+12>>2];c[j>>2]=c[Q>>2];c[j+4>>2]=c[Q+4>>2];c[j+8>>2]=c[Q+8>>2];c[j+12>>2]=c[Q+12>>2];hH(R,2,k,j,Z,_,e)}if(c[C+12>>2]|0){e=c[n>>2]|0;R=C+32|0;Q=(c[C>>2]|0)+((c[C+4>>2]|0)-1<<4)|0;_=+h[L>>3];Z=+h[N>>3];O=c[C+12>>2]|0;c[k>>2]=c[R>>2];c[k+4>>2]=c[R+4>>2];c[k+8>>2]=c[R+8>>2];c[k+12>>2]=c[R+12>>2];c[j>>2]=c[Q>>2];c[j+4>>2]=c[Q+4>>2];c[j+8>>2]=c[Q+8>>2];c[j+12>>2]=c[Q+12>>2];hH(e,3,k,j,_,Z,O)}if((c[(c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)>1){if(c[C+8>>2]|0){if(!(c[p>>2]|0))break}else if(!((c[C+12>>2]|0)!=0&(c[p>>2]|0)!=0))break;rR(c[n>>2]|0,c[p>>2]|0)}}else vR(x,u,w,c[C+8>>2]|0,c[C+12>>2]|0,0);while(0);c[q>>2]=(c[q>>2]|0)+1}i=g;return}p=c[(c[P+8>>2]|0)+4>>2]|0;c[D+4>>2]=p;c[E+4>>2]=p;c[D>>2]=N4((c[D+4>>2]|0)*48|0)|0;c[E>>2]=N4((c[E+4>>2]|0)*48|0)|0;h[M>>3]=+(2+(c[t>>2]|0)|0)/2.0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[D+4>>2]|0))break;W=C;X=(c[c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[q>>2]|0)*48|0)|0;Y=W+48|0;do{c[W>>2]=c[X>>2];W=W+4|0;X=X+4|0}while((W|0)<(Y|0));t=c[C+4>>2]|0;c[(c[D>>2]|0)+((c[q>>2]|0)*48|0)+4>>2]=t;c[(c[E>>2]|0)+((c[q>>2]|0)*48|0)+4>>2]=t;t=N4(c[C+4>>2]<<4)|0;c[(c[D>>2]|0)+((c[q>>2]|0)*48|0)>>2]=t;c[J>>2]=t;t=N4(c[C+4>>2]<<4)|0;c[(c[E>>2]|0)+((c[q>>2]|0)*48|0)>>2]=t;c[K>>2]=t;t=c[C>>2]|0;c[I>>2]=c[t>>2];c[I+4>>2]=c[t+4>>2];c[I+8>>2]=c[t+8>>2];c[I+12>>2]=c[t+12>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=((c[C+4>>2]|0)-1|0))break;c[F>>2]=c[I>>2];c[F+4>>2]=c[I+4>>2];c[F+8>>2]=c[I+8>>2];c[F+12>>2]=c[I+12>>2];t=(c[C>>2]|0)+((c[r>>2]|0)+1<<4)|0;c[G>>2]=c[t>>2];c[G+4>>2]=c[t+4>>2];c[G+8>>2]=c[t+8>>2];c[G+12>>2]=c[t+12>>2];t=(c[J>>2]|0)+(c[r>>2]<<4)|0;if(!(c[r>>2]|0)){c[k>>2]=c[F>>2];c[k+4>>2]=c[F+4>>2];c[k+8>>2]=c[F+8>>2];c[k+12>>2]=c[F+12>>2];c[j>>2]=c[G>>2];c[j+4>>2]=c[G+4>>2];c[j+8>>2]=c[G+8>>2];c[j+12>>2]=c[G+12>>2];VI(S,k,j,2.0);c[t>>2]=c[S>>2];c[t+4>>2]=c[S+4>>2];c[t+8>>2]=c[S+8>>2];c[t+12>>2]=c[S+12>>2]}else{c[k>>2]=c[H>>2];c[k+4>>2]=c[H+4>>2];c[k+8>>2]=c[H+8>>2];c[k+12>>2]=c[H+12>>2];c[j>>2]=c[G>>2];c[j+4>>2]=c[G+4>>2];c[j+8>>2]=c[G+8>>2];c[j+12>>2]=c[G+12>>2];VI(T,k,j,2.0);c[t>>2]=c[T>>2];c[t+4>>2]=c[T+4>>2];c[t+8>>2]=c[T+8>>2];c[t+12>>2]=c[T+12>>2]}t=(c[C>>2]|0)+((c[r>>2]|0)+2<<4)|0;c[H>>2]=c[t>>2];c[H+4>>2]=c[t+4>>2];c[H+8>>2]=c[t+8>>2];c[H+12>>2]=c[t+12>>2];t=(c[C>>2]|0)+((c[r>>2]|0)+3<<4)|0;c[I>>2]=c[t>>2];c[I+4>>2]=c[t+4>>2];c[I+8>>2]=c[t+8>>2];c[I+12>>2]=c[t+12>>2];t=(c[J>>2]|0)+((c[r>>2]|0)+1<<4)|0;p=(c[J>>2]|0)+((c[r>>2]|0)+2<<4)|0;c[m>>2]=c[F>>2];c[m+4>>2]=c[F+4>>2];c[m+8>>2]=c[F+8>>2];c[m+12>>2]=c[F+12>>2];c[l>>2]=c[G>>2];c[l+4>>2]=c[G+4>>2];c[l+8>>2]=c[G+8>>2];c[l+12>>2]=c[G+12>>2];c[k>>2]=c[H>>2];c[k+4>>2]=c[H+4>>2];c[k+8>>2]=c[H+8>>2];c[k+12>>2]=c[H+12>>2];c[j>>2]=c[I>>2];c[j+4>>2]=c[I+4>>2];c[j+8>>2]=c[I+8>>2];c[j+12>>2]=c[I+12>>2];WI(U,m,l,k,j,2.0);c[p>>2]=c[U>>2];c[p+4>>2]=c[U+4>>2];c[p+8>>2]=c[U+8>>2];c[p+12>>2]=c[U+12>>2];c[t>>2]=c[p>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];h[(c[K>>2]|0)+(c[r>>2]<<4)>>3]=+h[F>>3]-+h[M>>3]*+h[(c[J>>2]|0)+(c[r>>2]<<4)>>3];h[(c[K>>2]|0)+(c[r>>2]<<4)+8>>3]=+h[F+8>>3]-+h[M>>3]*+h[(c[J>>2]|0)+(c[r>>2]<<4)+8>>3];h[(c[K>>2]|0)+((c[r>>2]|0)+1<<4)>>3]=+h[G>>3]-+h[M>>3]*+h[(c[J>>2]|0)+((c[r>>2]|0)+1<<4)>>3];h[(c[K>>2]|0)+((c[r>>2]|0)+1<<4)+8>>3]=+h[G+8>>3]-+h[M>>3]*+h[(c[J>>2]|0)+((c[r>>2]|0)+1<<4)+8>>3];h[(c[K>>2]|0)+((c[r>>2]|0)+2<<4)>>3]=+h[H>>3]-+h[M>>3]*+h[(c[J>>2]|0)+((c[r>>2]|0)+2<<4)>>3];h[(c[K>>2]|0)+((c[r>>2]|0)+2<<4)+8>>3]=+h[H+8>>3]-+h[M>>3]*+h[(c[J>>2]|0)+((c[r>>2]|0)+2<<4)+8>>3];c[r>>2]=(c[r>>2]|0)+3}p=(c[J>>2]|0)+(c[r>>2]<<4)|0;c[k>>2]=c[H>>2];c[k+4>>2]=c[H+4>>2];c[k+8>>2]=c[H+8>>2];c[k+12>>2]=c[H+12>>2];c[j>>2]=c[I>>2];c[j+4>>2]=c[I+4>>2];c[j+8>>2]=c[I+8>>2];c[j+12>>2]=c[I+12>>2];VI(V,k,j,2.0);c[p>>2]=c[V>>2];c[p+4>>2]=c[V+4>>2];c[p+8>>2]=c[V+8>>2];c[p+12>>2]=c[V+12>>2];h[(c[K>>2]|0)+(c[r>>2]<<4)>>3]=+h[I>>3]-+h[M>>3]*+h[(c[J>>2]|0)+(c[r>>2]<<4)>>3];h[(c[K>>2]|0)+(c[r>>2]<<4)+8>>3]=+h[I+8>>3]-+h[M>>3]*+h[(c[J>>2]|0)+(c[r>>2]<<4)+8>>3];c[q>>2]=(c[q>>2]|0)+1}M=c[v>>2]|0;c[z>>2]=M;c[y>>2]=M;c[A>>2]=M;c[B>>2]=M3(c[v>>2]|0)|0;c[s>>2]=0;c[v>>2]=V3(c[B>>2]|0,148898)|0;while(1){if(!(c[v>>2]|0))break;if(!(a[c[v>>2]>>0]|0))c[v>>2]=174917;if((c[v>>2]|0)!=(c[A>>2]|0)){if(!(d[(c[(c[o>>2]|0)+8>>2]|0)+115>>0]&3)){oR(c[n>>2]|0,c[v>>2]|0);pR(c[n>>2]|0,c[v>>2]|0)}c[A>>2]=c[v>>2]}if(!(c[s>>2]|0)){M=c[v>>2]|0;c[z>>2]=M;c[y>>2]=M}if((c[s>>2]|0)==1)c[z>>2]=c[v>>2];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[E+4>>2]|0))break;c[K>>2]=c[(c[E>>2]|0)+((c[q>>2]|0)*48|0)>>2];c[J>>2]=c[(c[D>>2]|0)+((c[q>>2]|0)*48|0)>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[(c[E>>2]|0)+((c[q>>2]|0)*48|0)+4>>2]|0))break;M=(c[K>>2]|0)+(c[r>>2]<<4)|0;h[M>>3]=+h[M>>3]+ +h[(c[J>>2]|0)+(c[r>>2]<<4)>>3];M=(c[K>>2]|0)+(c[r>>2]<<4)+8|0;h[M>>3]=+h[M>>3]+ +h[(c[J>>2]|0)+(c[r>>2]<<4)+8>>3];c[r>>2]=(c[r>>2]|0)+1}vR(c[n>>2]|0,c[K>>2]|0,c[(c[E>>2]|0)+((c[q>>2]|0)*48|0)+4>>2]|0,0,0,0);c[q>>2]=(c[q>>2]|0)+1}c[s>>2]=(c[s>>2]|0)+1;c[v>>2]=V3(0,148898)|0}if(c[C+8>>2]|0){if((c[v>>2]|0)!=(c[z>>2]|0)?(c[v>>2]=c[z>>2],(d[(c[(c[o>>2]|0)+8>>2]|0)+115>>0]&3|0)==0):0){oR(c[n>>2]|0,c[v>>2]|0);pR(c[n>>2]|0,c[v>>2]|0)}z=c[n>>2]|0;s=C+16|0;K=c[C>>2]|0;Z=+h[L>>3];_=+h[N>>3];r=c[C+8>>2]|0;c[k>>2]=c[s>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];c[k+12>>2]=c[s+12>>2];c[j>>2]=c[K>>2];c[j+4>>2]=c[K+4>>2];c[j+8>>2]=c[K+8>>2];c[j+12>>2]=c[K+12>>2];hH(z,2,k,j,Z,_,r)}if(c[C+12>>2]|0){if((c[v>>2]|0)!=(c[y>>2]|0)?(c[v>>2]=c[y>>2],(d[(c[(c[o>>2]|0)+8>>2]|0)+115>>0]&3|0)==0):0){oR(c[n>>2]|0,c[v>>2]|0);pR(c[n>>2]|0,c[v>>2]|0)}v=c[n>>2]|0;n=C+32|0;o=(c[C>>2]|0)+((c[C+4>>2]|0)-1<<4)|0;_=+h[L>>3];Z=+h[N>>3];N=c[C+12>>2]|0;c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];c[j>>2]=c[o>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];hH(v,3,k,j,_,Z,N)}O4(c[B>>2]|0);c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[D+4>>2]|0))break;O4(c[(c[D>>2]|0)+((c[q>>2]|0)*48|0)>>2]|0);O4(c[(c[E>>2]|0)+((c[q>>2]|0)*48|0)>>2]|0);c[q>>2]=(c[q>>2]|0)+1}O4(c[D>>2]|0);O4(c[E>>2]|0);i=g;return}function KI(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+112|0;e=d+64|0;f=d+96|0;g=d+92|0;h=d+88|0;j=d+84|0;k=d+80|0;l=d+48|0;m=d;c[f>>2]=a;c[g>>2]=c[(c[f>>2]|0)+16>>2];c[h>>2]=c[(c[g>>2]|0)+8>>2];if(!((c[(c[g>>2]|0)+208>>2]|0)==0?((b[(c[g>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0))n=3;a:do if((n|0)==3?(kR(c[f>>2]|0),(c[(c[g>>2]|0)+276>>2]|0)!=0):0){c[k>>2]=c[c[(c[g>>2]|0)+280>>2]>>2];c[j>>2]=1;while(1){if((c[j>>2]|0)>=(c[(c[g>>2]|0)+276>>2]|0))break a;c[(c[g>>2]|0)+268>>2]=c[(c[(c[g>>2]|0)+280>>2]|0)+(c[j>>2]<<2)>>2];c[(c[g>>2]|0)+272>>2]=(c[(c[g>>2]|0)+284>>2]|0)+(c[k>>2]<<4);jR(c[f>>2]|0,c[(c[g>>2]|0)+208>>2]|0,c[(c[g>>2]|0)+228>>2]|0,c[(c[g>>2]|0)+244>>2]|0,c[(c[g>>2]|0)+212>>2]|0);kR(c[f>>2]|0);c[k>>2]=(c[k>>2]|0)+(c[(c[(c[g>>2]|0)+280>>2]|0)+(c[j>>2]<<2)>>2]|0);c[j>>2]=(c[j>>2]|0)+1}}while(0);c[(c[g>>2]|0)+268>>2]=0;c[(c[g>>2]|0)+272>>2]=0;if(c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0){j=m;k=c[c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]>>2]|0;n=j+48|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(n|0));if(c[m+8>>2]|0){a=m+16|0;c[l>>2]=c[a>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2]}else{a=c[m>>2]|0;c[l>>2]=c[a>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2]}a=c[f>>2]|0;o=(b[(c[g>>2]|0)+260>>1]<<8&65535)<<16>>16>>15&255;p=c[(c[g>>2]|0)+220>>2]|0;q=(b[(c[g>>2]|0)+260>>1]<<14&65535)<<16>>16>>15&255;r=c[(c[g>>2]|0)+236>>2]|0;s=(b[(c[g>>2]|0)+260>>1]<<11&65535)<<16>>16>>15&255;t=c[(c[g>>2]|0)+252>>2]|0;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];LI(a,e,o,p,q,r,s,t);j=m;k=(c[c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+(((c[(c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)-1|0)*48|0)|0;n=j+48|0;do{c[j>>2]=c[k>>2];j=j+4|0;k=k+4|0}while((j|0)<(n|0));if(c[m+12>>2]|0){k=m+32|0;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2]}else{k=(c[m>>2]|0)+((c[m+4>>2]|0)-1<<4)|0;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2]}k=c[f>>2]|0;m=(b[(c[g>>2]|0)+260>>1]<<7&65535)<<16>>16>>15&255;j=c[(c[g>>2]|0)+224>>2]|0;n=(b[(c[g>>2]|0)+260>>1]<<13&65535)<<16>>16>>15&255;t=c[(c[g>>2]|0)+240>>2]|0;s=(b[(c[g>>2]|0)+260>>1]<<10&65535)<<16>>16>>15&255;r=c[(c[g>>2]|0)+256>>2]|0;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];LI(k,e,m,j,n,t,s,r)}r=c[f>>2]|0;s=c[(c[(c[h>>2]|0)+8>>2]|0)+96>>2]|0;t=(b[(c[g>>2]|0)+260>>1]<<12&65535)<<16>>16>>15<<16>>16;n=c[(c[g>>2]|0)+216>>2]|0;j=c[(c[g>>2]|0)+232>>2]|0;m=c[(c[g>>2]|0)+248>>2]|0;e=c[(c[g>>2]|0)+212>>2]|0;if(((kO(hO(c[h>>2]|0,c[13870]|0,174911)|0)|0)&255|0)!=0?(c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)u=c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0;else u=0;MI(r,s,11,t,n,j,m,e,u);u=c[f>>2]|0;e=c[(c[(c[h>>2]|0)+8>>2]|0)+108>>2]|0;m=(b[(c[g>>2]|0)+260>>1]<<12&65535)<<16>>16>>15<<16>>16;j=c[(c[g>>2]|0)+216>>2]|0;n=c[(c[g>>2]|0)+232>>2]|0;t=c[(c[g>>2]|0)+248>>2]|0;s=c[(c[g>>2]|0)+212>>2]|0;if(((kO(hO(c[h>>2]|0,c[13870]|0,174911)|0)|0)&255|0)!=0?(c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)v=c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0;else v=0;MI(u,e,11,m,j,n,t,s,v);MI(c[f>>2]|0,c[(c[(c[h>>2]|0)+8>>2]|0)+100>>2]|0,7,(b[(c[g>>2]|0)+260>>1]<<13&65535)<<16>>16>>15<<16>>16,c[(c[g>>2]|0)+224>>2]|0,c[(c[g>>2]|0)+240>>2]|0,c[(c[g>>2]|0)+256>>2]|0,c[(c[g>>2]|0)+212>>2]|0,0);MI(c[f>>2]|0,c[(c[(c[h>>2]|0)+8>>2]|0)+104>>2]|0,6,(b[(c[g>>2]|0)+260>>1]<<14&65535)<<16>>16>>15<<16>>16,c[(c[g>>2]|0)+220>>2]|0,c[(c[g>>2]|0)+236>>2]|0,c[(c[g>>2]|0)+252>>2]|0,c[(c[g>>2]|0)+212>>2]|0,0);iR(c[f>>2]|0);xH(c[f>>2]|0);i=d;return}function LI(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;i=i+64|0;o=n;p=n+44|0;q=n+51|0;r=n+40|0;s=n+50|0;t=n+36|0;u=n+49|0;v=n+32|0;w=n+28|0;x=n+24|0;y=n+20|0;z=n+16|0;A=n+48|0;c[p>>2]=e;a[q>>0]=g;c[r>>2]=h;a[s>>0]=j;c[t>>2]=k;a[u>>0]=l;c[v>>2]=m;c[w>>2]=c[(c[p>>2]|0)+16>>2];if(a[q>>0]|0)c[x>>2]=c[r>>2];else c[x>>2]=c[(c[w>>2]|0)+208>>2];do if(!(a[s>>0]|0))if((b[(c[w>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16){c[y>>2]=c[(c[w>>2]|0)+228>>2];a[A>>0]=1;break}else{a[A>>0]=0;c[y>>2]=c[t>>2];break}else{c[y>>2]=c[t>>2];a[A>>0]=1}while(0);do if(!(a[u>>0]|0))if((b[(c[w>>2]|0)+260>>1]<<9&65535)<<16>>16>>15<<16>>16){c[z>>2]=c[(c[w>>2]|0)+244>>2];break}else{c[z>>2]=c[v>>2];break}else c[z>>2]=c[v>>2];while(0);if((c[x>>2]|0)==0?(d[A>>0]|0)==0:0){i=n;return}A=c[p>>2]|0;c[o>>2]=c[f>>2];c[o+4>>2]=c[f+4>>2];c[o+8>>2]=c[f+8>>2];c[o+12>>2]=c[f+12>>2];QI(A,o);i=n;return}function MI(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;i=i+64|0;n=m;o=m+56|0;p=m+52|0;q=m+48|0;r=m+44|0;s=m+40|0;t=m+36|0;u=m+32|0;v=m+28|0;w=m+24|0;x=m+20|0;y=m+16|0;z=m+12|0;A=m+8|0;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;c[x>>2]=c[(c[o>>2]|0)+152>>2];if(!(c[p>>2]|0)){i=m;return}if(!(a[(c[p>>2]|0)+81>>0]|0)){i=m;return}if(c[v>>2]|0){c[z>>2]=bK((N3(c[v>>2]|0)|0)+11|0)|0;switch(c[q>>2]|0){case 11:{c[A>>2]=147656;break}case 7:{c[A>>2]=139375;break}case 6:{c[A>>2]=139385;break}default:La(176099,137578,2645,138560)}l=c[z>>2]|0;k=c[A>>2]|0;c[n>>2]=c[v>>2];c[n+4>>2]=k;k3(l,138576,n)|0}else c[z>>2]=0;c[y>>2]=c[(c[(c[o>>2]|0)+16>>2]|0)+12>>2];c[(c[(c[o>>2]|0)+16>>2]|0)+12>>2]=c[q>>2];if((c[s>>2]|0)!=0|(c[r>>2]|0)!=0?(c[x>>2]&4|0)==0:0){NI(c[o>>2]|0,c[p>>2]|0);jR(c[o>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[z>>2]|0)}VJ(c[o>>2]|0,c[q>>2]|0,c[p>>2]|0);if(c[w>>2]|0)OI(c[o>>2]|0,c[p>>2]|0,c[w>>2]|0);if((c[s>>2]|0)!=0|(c[r>>2]|0)!=0){if(c[x>>2]&4){NI(c[o>>2]|0,c[p>>2]|0);jR(c[o>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[z>>2]|0)}kR(c[o>>2]|0)}if(c[z>>2]|0)O4(c[z>>2]|0);c[(c[(c[o>>2]|0)+16>>2]|0)+12>>2]=c[y>>2];i=m;return}function NI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[e>>2]|0)+16>>2];c[j>>2]=c[(c[e>>2]|0)+152>>2];if(!(c[j>>2]&4259840)){i=d;return}b=(c[g>>2]|0)+264|0;if(c[j>>2]&131072){c[b>>2]=0;c[(c[g>>2]|0)+268>>2]=2}else{c[b>>2]=2;c[(c[g>>2]|0)+268>>2]=4}O4(c[(c[g>>2]|0)+272>>2]|0);b=bK(c[(c[g>>2]|0)+268>>2]<<4)|0;c[k>>2]=b;c[(c[g>>2]|0)+272>>2]=b;h[c[k>>2]>>3]=+h[(c[f>>2]|0)+56>>3]-+h[(c[f>>2]|0)+24>>3]/2.0;h[(c[k>>2]|0)+8>>3]=+h[(c[f>>2]|0)+56+8>>3]-+h[(c[f>>2]|0)+24+8>>3]/2.0;h[(c[k>>2]|0)+16>>3]=+h[(c[f>>2]|0)+56>>3]+ +h[(c[f>>2]|0)+24>>3]/2.0;h[(c[k>>2]|0)+16+8>>3]=+h[(c[f>>2]|0)+56+8>>3]+ +h[(c[f>>2]|0)+24+8>>3]/2.0;if(!(c[j>>2]&8192))UQ(c[e>>2]|0,c[k>>2]|0,c[k>>2]|0,2)|0;if(c[j>>2]&131072){i=d;return}DJ(c[k>>2]|0);i=d;return}function OI(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+144|0;j=g+112|0;k=g+140|0;l=g+136|0;m=g+132|0;n=g+96|0;o=g+48|0;p=g+128|0;q=g+32|0;r=g+16|0;s=g;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[p>>2]=c[c[l>>2]>>2];while(1){if(!(a[c[p>>2]>>0]|0))break;if(!(r1(d[c[p>>2]>>0]|0)|0))break;c[p>>2]=(c[p>>2]|0)+1}if(!(d[c[p>>2]>>0]|0)){i=g;return}p=(c[l>>2]|0)+24|0;c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];PI(q,+h[(c[l>>2]|0)+56>>3]+ +h[n>>3]/2.0,+h[(c[l>>2]|0)+56+8>>3]-+h[n+8>>3]/2.0);c[o>>2]=c[q>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[o+12>>2]=c[q+12>>2];q=o+16|0;PI(r,+h[o>>3]-+h[n>>3],+h[o+8>>3]);c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];r=o+32|0;q=c[m>>2]|0;m=(c[l>>2]|0)+56|0;c[j>>2]=c[m>>2];c[j+4>>2]=c[m+4>>2];c[j+8>>2]=c[m+8>>2];c[j+12>>2]=c[m+12>>2];vO(s,q,j);c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];rR(c[k>>2]|0,c[(c[c[k>>2]>>2]|0)+336>>2]|0);oR(c[k>>2]|0,c[(c[l>>2]|0)+8>>2]|0);wR(c[k>>2]|0,o,3);i=g;return}function PI(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3];h[j+8>>3]=+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function QI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+16>>2];c[g>>2]=c[(c[e>>2]|0)+152>>2];if(!(c[g>>2]&4259840)){i=d;return}a=(c[f>>2]|0)+264|0;if(c[g>>2]&131072){c[a>>2]=0;c[(c[f>>2]|0)+268>>2]=2}else{c[a>>2]=2;c[(c[f>>2]|0)+268>>2]=4}O4(c[(c[f>>2]|0)+272>>2]|0);a=bK(c[(c[f>>2]|0)+268>>2]<<4)|0;c[j>>2]=a;c[(c[f>>2]|0)+272>>2]=a;h[c[j>>2]>>3]=+h[b>>3]-3.0;h[(c[j>>2]|0)+8>>3]=+h[b+8>>3]-3.0;h[(c[j>>2]|0)+16>>3]=+h[b>>3]+3.0;h[(c[j>>2]|0)+16+8>>3]=+h[b+8>>3]+3.0;if(!(c[g>>2]&8192))UQ(c[e>>2]|0,c[j>>2]|0,c[j>>2]|0,2)|0;if(c[g>>2]&131072){i=d;return}DJ(c[j>>2]|0);i=d;return}function RI(a,b,d,e,f,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;j=+j;k=+k;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+320|0;m=l+248|0;n=l+232|0;o=l+216|0;p=l+312|0;q=l+308|0;r=l+304|0;s=l+300|0;t=l+296|0;u=l+292|0;v=l+208|0;w=l+200|0;x=l+152|0;y=l+104|0;z=l+56|0;A=l+8|0;B=l+288|0;C=l+284|0;D=l+280|0;E=l+276|0;F=l+272|0;G=l;H=l+268|0;I=l+264|0;c[q>>2]=a;c[r>>2]=b;c[s>>2]=d;c[t>>2]=e;c[u>>2]=f;h[v>>3]=j;h[w>>3]=k;c[C>>2]=NH(c[t>>2]|0,c[u>>2]|0,D)|0;if((c[C>>2]|0)>1){u=c[r>>2]|0;c[I>>2]=qC(c[((c[c[r>>2]>>2]&3|0)==3?u:u+32|0)+28>>2]|0)|0;u=c[r>>2]|0;t=wB(c[((c[c[r>>2]>>2]&3|0)==3?u:u+32|0)+28>>2]|0)|0;u=(nB(c[I>>2]|0)|0)!=0;I=c[r>>2]|0;f=wB(c[((c[c[r>>2]>>2]&3|0)==2?I:I+-32|0)+28>>2]|0)|0;c[o>>2]=t;c[o+4>>2]=u?138595:138600;c[o+8>>2]=f;$z(3,138605,o)|0;if((c[C>>2]|0)==2){c[p>>2]=1;J=c[p>>2]|0;i=l;return J|0}}else if((c[C>>2]|0)==1){c[p>>2]=1;J=c[p>>2]|0;i=l;return J|0}c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[(c[(c[(c[r>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;h[G>>3]=1.0;C=x;o=(c[c[(c[(c[r>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[B>>2]|0)*48|0)|0;f=C+48|0;do{c[C>>2]=c[o>>2];C=C+4|0;o=o+4|0}while((C|0)<(f|0));c[H>>2]=1;c[E>>2]=c[(c[D>>2]|0)+8>>2];a:while(1){if(!(c[c[E>>2]>>2]|0))break;if(!(+g[(c[E>>2]|0)+4>>2]<1.0e-05?+g[(c[E>>2]|0)+4>>2]>-1.0e-05:0))K=12;do if((K|0)==12){K=0;oR(c[q>>2]|0,c[c[E>>2]>>2]|0);h[G>>3]=+h[G>>3]-+g[(c[E>>2]|0)+4>>2];c[F>>2]=c[c[E>>2]>>2];if(c[H>>2]|0){c[H>>2]=0;$I(x,+g[(c[E>>2]|0)+4>>2],z,A);vR(c[q>>2]|0,c[z>>2]|0,c[z+4>>2]|0,0,0,0);O4(c[z>>2]|0);if(+h[G>>3]<1.0e-05&+h[G>>3]>-1.0e-05){K=14;break a}else break}if(+h[G>>3]<1.0e-05&+h[G>>3]>-1.0e-05){K=16;break a}C=y;o=A;f=C+48|0;do{c[C>>2]=c[o>>2];C=C+4|0;o=o+4|0}while((C|0)<(f|0));$I(y,+g[(c[E>>2]|0)+4>>2]/(+h[G>>3]+ +g[(c[E>>2]|0)+4>>2]),z,A);O4(c[y>>2]|0);vR(c[q>>2]|0,c[z>>2]|0,c[z+4>>2]|0,0,0,0);O4(c[z>>2]|0)}while(0);c[E>>2]=(c[E>>2]|0)+12}if((K|0)==14){K=0;O4(c[A>>2]|0)}else if((K|0)==16){K=0;vR(c[q>>2]|0,c[A>>2]|0,c[A+4>>2]|0,0,0,0);O4(c[A>>2]|0)}if(c[x+8>>2]|0){oR(c[q>>2]|0,c[c[(c[D>>2]|0)+8>>2]>>2]|0);pR(c[q>>2]|0,c[c[(c[D>>2]|0)+8>>2]>>2]|0);o=c[q>>2]|0;C=x+16|0;f=c[x>>2]|0;k=+h[v>>3];j=+h[w>>3];u=c[x+8>>2]|0;c[n>>2]=c[C>>2];c[n+4>>2]=c[C+4>>2];c[n+8>>2]=c[C+8>>2];c[n+12>>2]=c[C+12>>2];c[m>>2]=c[f>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];hH(o,2,n,m,k,j,u)}if(c[x+12>>2]|0){oR(c[q>>2]|0,c[F>>2]|0);pR(c[q>>2]|0,c[F>>2]|0);u=c[q>>2]|0;o=x+32|0;f=(c[x>>2]|0)+((c[x+4>>2]|0)-1<<4)|0;j=+h[v>>3];k=+h[w>>3];C=c[x+12>>2]|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[m>>2]=c[f>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];hH(u,3,n,m,j,k,C)}do if((c[(c[(c[(c[r>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)>1){if(c[x+8>>2]|0){if(!(c[s>>2]|0))break}else if(!((c[x+12>>2]|0)!=0&(c[s>>2]|0)!=0))break;rR(c[q>>2]|0,c[s>>2]|0)}while(0);c[B>>2]=(c[B>>2]|0)+1}O4(c[D>>2]|0);c[p>>2]=0;J=c[p>>2]|0;i=l;return J|0}function SI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;c[k>>2]=1;c[h>>2]=c[f>>2];while(1){if(!(a[c[h>>2]>>0]|0))break;if((a[c[h>>2]>>0]|0)==58)c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=(c[h>>2]|0)+1}h=c[k>>2]|0;c[j>>2]=_(h,(N3(c[g>>2]|0)|0)+1|0)|0;if((c[13786]|0)<(c[j>>2]|0)){c[13786]=(c[j>>2]|0)+10;c[13787]=Q4(c[13787]|0,c[13786]|0)|0}K3(c[13787]|0,c[g>>2]|0)|0;while(1){j=(c[k>>2]|0)+-1|0;c[k>>2]=j;l=c[13787]|0;if(!j)break;G3(l,148898)|0;G3(c[13787]|0,c[g>>2]|0)|0}i=e;return l|0}function TI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;if((c[13868]|0)!=0?(b=zA(c[f>>2]|0,c[13868]|0)|0,c[g>>2]=b,(a[b>>0]|0)!=0):0){if((a[c[g>>2]>>0]|0)==(a[138582]|0)?(J3(c[g>>2]|0,138582)|0)==0:0){c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}if((a[c[g>>2]>>0]|0)==(a[138590]|0)?(J3(c[g>>2]|0,138590)|0)==0:0){c[e>>2]=2;h=c[e>>2]|0;i=d;return h|0}if((a[c[g>>2]>>0]|0)==(a[148783]|0)?(J3(c[g>>2]|0,148783)|0)==0:0){c[e>>2]=3;h=c[e>>2]|0;i=d;return h|0}if((a[c[g>>2]>>0]|0)==(a[173312]|0)?(J3(c[g>>2]|0,173312)|0)==0:0){c[e>>2]=4;h=c[e>>2]|0;i=d;return h|0}}g=c[f>>2]|0;b=(nB(qC(c[((c[c[f>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)|0)|0)!=0;c[e>>2]=b?1:4;h=c[e>>2]|0;i=d;return h|0}function UI(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[d>>2]|0);i=b;return}function VI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0;f=i;i=i+48|0;g=f+32|0;j=f+16|0;k=f+8|0;l=f;h[g>>3]=e;h[k>>3]=+h[b>>3]-+h[d>>3];h[l>>3]=+h[b+8>>3]-+h[d+8>>3];e=+O(+(+h[k>>3]*+h[k>>3]+ +h[l>>3]*+h[l>>3]+.0001));h[g>>3]=+h[g>>3]/e;h[j>>3]=+h[l>>3]*+h[g>>3];h[j+8>>3]=-+h[k>>3]*+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=f;return}function WI(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+48|0;k=j+40|0;l=j+24|0;m=j+16|0;n=j+8|0;o=j;h[k>>3]=g;h[n>>3]=+h[d>>3]-+h[e>>3];h[o>>3]=+h[d+8>>3]-+h[e+8>>3];h[m>>3]=+O(+(+h[n>>3]*+h[n>>3]+ +h[o>>3]*+h[o>>3]));if(+h[m>>3]<.0001){h[n>>3]=+h[b>>3]-+h[f>>3];h[o>>3]=+h[b+8>>3]-+h[f+8>>3];h[m>>3]=+O(+(+h[n>>3]*+h[n>>3]+ +h[o>>3]*+h[o>>3]+.0001))}h[k>>3]=+h[k>>3]/+h[m>>3];h[l>>3]=+h[o>>3]*+h[k>>3];h[l+8>>3]=-+h[n>>3]*+h[k>>3];c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];i=j;return}function XI(a,b,c){a=+a;b=+b;c=+c;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d;h[e>>3]=a;h[f>>3]=b;h[g>>3]=c;i=d;return +((1.0-+h[e>>3]/+h[f>>3])*+h[g>>3]/2.0)}function YI(a,b,c){a=+a;b=+b;c=+c;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d;h[e>>3]=a;h[f>>3]=b;h[g>>3]=c;i=d;return +(+h[e>>3]/+h[f>>3]*+h[g>>3]/2.0)}function ZI(a,b,c){a=+a;b=+b;c=+c;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;d=i;i=i+48|0;e=d+32|0;f=d+24|0;g=d+16|0;j=d+8|0;k=d;h[f>>3]=a;h[g>>3]=b;h[j>>3]=c;h[k>>3]=+h[f>>3]/+h[g>>3];c=+h[k>>3];if(+h[k>>3]<=.5){h[e>>3]=c*+h[j>>3];l=+h[e>>3];i=d;return +l}else{h[e>>3]=(1.0-c)*+h[j>>3];l=+h[e>>3];i=d;return +l}return +(0.0)}function _I(a,b,c){a=+a;b=+b;c=+c;var d=0,e=0;d=i;i=i+32|0;e=d;h[d+16>>3]=a;h[d+8>>3]=b;h[e>>3]=c;i=d;return +(+h[e>>3]/2.0)}function $I(a,b,d,e){a=a|0;b=+b;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+112|0;j=f+96|0;k=f+92|0;l=f+88|0;m=f+84|0;n=f+80|0;o=f+76|0;p=f+72|0;q=f+68|0;r=f+64|0;s=f+48|0;t=f+40|0;u=f+32|0;v=f+60|0;w=f+56|0;x=f;c[j>>2]=a;g[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[q>>2]=((c[(c[j>>2]|0)+4>>2]|0)-1|0)/3|0;if((c[q>>2]|0)==1){c[(c[l>>2]|0)+4>>2]=4;e=bK(64)|0;c[c[l>>2]>>2]=e;c[(c[m>>2]|0)+4>>2]=4;e=bK(64)|0;c[c[m>>2]>>2]=e;qO(f+16|0,c[c[j>>2]>>2]|0,3,+g[k>>2],c[c[l>>2]>>2]|0,c[c[m>>2]>>2]|0);i=f;return}c[r>>2]=bK(c[q>>2]<<3)|0;h[u>>3]=0.0;c[v>>2]=c[c[j>>2]>>2];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[q>>2]|0))break;b=+aJ(c[v>>2]|0);h[(c[r>>2]|0)+(c[n>>2]<<3)>>3]=b;h[u>>3]=+h[u>>3]+ +h[(c[r>>2]|0)+(c[n>>2]<<3)>>3];c[v>>2]=(c[v>>2]|0)+48;c[n>>2]=(c[n>>2]|0)+1}h[t>>3]=+g[k>>2]*+h[u>>3];h[u>>3]=0.0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[q>>2]|0))break;h[u>>3]=+h[u>>3]+ +h[(c[r>>2]|0)+(c[n>>2]<<3)>>3];if(+h[u>>3]>=+h[t>>3])break;c[n>>2]=(c[n>>2]|0)+1}c[(c[l>>2]|0)+4>>2]=(((c[n>>2]|0)+1|0)*3|0)+1;k=bK(c[(c[l>>2]|0)+4>>2]<<4)|0;c[c[l>>2]>>2]=k;c[(c[m>>2]|0)+4>>2]=(((c[q>>2]|0)-(c[n>>2]|0)|0)*3|0)+1;q=bK(c[(c[m>>2]|0)+4>>2]<<4)|0;c[c[m>>2]>>2]=q;c[o>>2]=0;while(1){y=c[o>>2]|0;if((c[o>>2]|0)>=(c[(c[l>>2]|0)+4>>2]|0))break;q=(c[c[l>>2]>>2]|0)+(y<<4)|0;k=(c[c[j>>2]>>2]|0)+(c[o>>2]<<4)|0;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];c[q+12>>2]=c[k+12>>2];c[o>>2]=(c[o>>2]|0)+1}c[p>>2]=y-4;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[m>>2]|0)+4>>2]|0))break;y=(c[c[m>>2]>>2]|0)+(c[o>>2]<<4)|0;k=c[p>>2]|0;c[p>>2]=k+1;q=(c[c[j>>2]>>2]|0)+(k<<4)|0;c[y>>2]=c[q>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[o>>2]=(c[o>>2]|0)+1}h[s>>3]=+h[(c[r>>2]|0)+(c[n>>2]<<3)>>3];g[w>>2]=(+h[t>>3]-(+h[u>>3]-+h[s>>3]))/+h[s>>3];qO(x,(c[c[j>>2]>>2]|0)+((c[n>>2]|0)*3<<4)|0,3,+g[w>>2],(c[c[l>>2]>>2]|0)+((c[n>>2]|0)*3<<4)|0,c[c[m>>2]>>2]|0);O4(c[r>>2]|0);i=f;return}function aJ(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;i=i+16|0;d=b+8|0;e=b;c[d>>2]=a;h[e>>3]=+O(+((+h[c[d>>2]>>3]-+h[(c[d>>2]|0)+16>>3])*(+h[c[d>>2]>>3]-+h[(c[d>>2]|0)+16>>3])+(+h[(c[d>>2]|0)+8>>3]-+h[(c[d>>2]|0)+16+8>>3])*(+h[(c[d>>2]|0)+8>>3]-+h[(c[d>>2]|0)+16+8>>3])));f=+O(+((+h[(c[d>>2]|0)+16>>3]-+h[(c[d>>2]|0)+32>>3])*(+h[(c[d>>2]|0)+16>>3]-+h[(c[d>>2]|0)+32>>3])+(+h[(c[d>>2]|0)+16+8>>3]-+h[(c[d>>2]|0)+32+8>>3])*(+h[(c[d>>2]|0)+16+8>>3]-+h[(c[d>>2]|0)+32+8>>3])));h[e>>3]=+h[e>>3]+f;f=+O(+((+h[(c[d>>2]|0)+32>>3]-+h[(c[d>>2]|0)+48>>3])*(+h[(c[d>>2]|0)+32>>3]-+h[(c[d>>2]|0)+48>>3])+(+h[(c[d>>2]|0)+32+8>>3]-+h[(c[d>>2]|0)+48+8>>3])*(+h[(c[d>>2]|0)+32+8>>3]-+h[(c[d>>2]|0)+48+8>>3])));h[e>>3]=+h[e>>3]+f;i=b;return +(+h[e>>3])}function bJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+1728|0;j=g+1716|0;k=g+1712|0;l=g+1708|0;m=g+1704|0;n=g+1664|0;o=g+1700|0;p=g+1696|0;q=g+1692|0;r=g+1688|0;s=g+1684|0;t=g+1680|0;u=g+1676|0;v=g+1672|0;w=g+1600|0;x=g+800|0;y=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;h[n>>3]=f;c[o>>2]=cK(24)|0;c[p>>2]=c[o>>2];c[(c[o>>2]|0)+16>>2]=1;c[s>>2]=((c[(c[m>>2]|0)+4>>2]|0)-1|0)/3|0;c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[s>>2]|0))break;c[u>>2]=0;while(1){if((c[u>>2]|0)>=4)break;e=w+(c[u>>2]<<4)|0;d=(c[c[m>>2]>>2]|0)+(((c[t>>2]|0)*3|0)+(c[u>>2]|0)<<4)|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[u>>2]=(c[u>>2]|0)+1}c[p>>2]=cJ(w,c[p>>2]|0)|0;c[t>>2]=(c[t>>2]|0)+1}c[p>>2]=c[o>>2];c[q>>2]=0;c[v>>2]=0;while(1){if(!(c[p>>2]|0))break;c[r>>2]=c[(c[p>>2]|0)+16>>2];dJ(c[q>>2]|0,c[p>>2]|0,c[r>>2]|0,x+(c[v>>2]<<4)|0,y+(c[v>>2]<<4)|0,+h[n>>3]);c[v>>2]=(c[v>>2]|0)+1;if((c[r>>2]|0)==0|(c[v>>2]|0)==50){eJ(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[v>>2]|0,x,y);t=x+((c[v>>2]|0)-1<<4)|0;c[x>>2]=c[t>>2];c[x+4>>2]=c[t+4>>2];c[x+8>>2]=c[t+8>>2];c[x+12>>2]=c[t+12>>2];t=y+((c[v>>2]|0)-1<<4)|0;c[y>>2]=c[t>>2];c[y+4>>2]=c[t+4>>2];c[y+8>>2]=c[t+8>>2];c[y+12>>2]=c[t+12>>2];c[v>>2]=1}c[q>>2]=c[p>>2];c[p>>2]=c[r>>2]}while(1){if(!(c[o>>2]|0))break;c[p>>2]=c[(c[o>>2]|0)+16>>2];O4(c[o>>2]|0);c[o>>2]=c[p>>2]}i=g;return}function cJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+176|0;e=d+144|0;f=d+164|0;g=d+160|0;h=d+80|0;j=d+16|0;c[f>>2]=a;c[g>>2]=b;if(!(PH(c[f>>2]|0)|0)){qO(d,c[f>>2]|0,3,.5,h,j);c[g>>2]=cJ(h,c[g>>2]|0)|0;c[g>>2]=cJ(j,c[g>>2]|0)|0;k=c[g>>2]|0;i=d;return k|0}if((c[(c[g>>2]|0)+16>>2]|0)==1){c[(c[g>>2]|0)+16>>2]=0;j=c[g>>2]|0;h=c[f>>2]|0;c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2]}h=(c[f>>2]|0)+48|0;f=c[g>>2]|0;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[g>>2]=gJ(e,f)|0;k=c[g>>2]|0;i=d;return k|0}function dJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+176|0;k=j+128|0;l=j+112|0;m=j+96|0;n=j+160|0;o=j+156|0;p=j+152|0;q=j+148|0;r=j+144|0;s=j+88|0;t=j+72|0;u=j+56|0;v=j+40|0;w=j+32|0;x=j+24|0;y=j+16|0;z=j;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;h[s>>3]=g;f=c[o>>2]|0;c[t>>2]=c[f>>2];c[t+4>>2]=c[f+4>>2];c[t+8>>2]=c[f+8>>2];c[t+12>>2]=c[f+12>>2];do if(c[n>>2]|0){f=c[n>>2]|0;c[u>>2]=c[f>>2];c[u+4>>2]=c[f+4>>2];c[u+8>>2]=c[f+8>>2];c[u+12>>2]=c[f+12>>2];if(c[p>>2]|0){f=c[p>>2]|0;c[v>>2]=c[f>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];break}else{h[v>>3]=+h[t>>3]*2.0-+h[u>>3];h[v+8>>3]=+h[t+8>>3]*2.0-+h[u+8>>3];break}}else{f=c[p>>2]|0;c[v>>2]=c[f>>2];c[v+4>>2]=c[f+4>>2];c[v+8>>2]=c[f+8>>2];c[v+12>>2]=c[f+12>>2];h[u>>3]=+h[t>>3]*2.0-+h[v>>3];h[u+8>>3]=+h[t+8>>3]*2.0-+h[v+8>>3]}while(0);c[m>>2]=c[u>>2];c[m+4>>2]=c[u+4>>2];c[m+8>>2]=c[u+8>>2];c[m+12>>2]=c[u+12>>2];c[l>>2]=c[t>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[l+12>>2]=c[t+12>>2];c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];c[k+12>>2]=c[v+12>>2];h[w>>3]=+fJ(m,l,k);h[x>>3]=+h[s>>3]*+Q(+(+h[w>>3]));h[y>>3]=+h[s>>3]*+R(+(+h[w>>3]));h[z>>3]=+h[t>>3]+ +h[x>>3];h[z+8>>3]=+h[t+8>>3]+ +h[y>>3];w=c[q>>2]|0;c[w>>2]=c[z>>2];c[w+4>>2]=c[z+4>>2];c[w+8>>2]=c[z+8>>2];c[w+12>>2]=c[z+12>>2];h[z>>3]=+h[t>>3]-+h[x>>3];h[z+8>>3]=+h[t+8>>3]-+h[y>>3];y=c[r>>2]|0;c[y>>2]=c[z>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];i=j;return}function eJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=0;c[q>>2]=0;c[r>>2]=(c[m>>2]<<1)-1;while(1){if((c[p>>2]|0)>=(c[c[l>>2]>>2]|0))break;c[q>>2]=(c[q>>2]|0)+(c[(c[c[k>>2]>>2]|0)+(c[p>>2]<<2)>>2]|0);c[p>>2]=(c[p>>2]|0)+1}g=c[l>>2]|0;c[g>>2]=(c[g>>2]|0)+1;g=eK(c[c[k>>2]>>2]|0,c[c[l>>2]>>2]<<2)|0;c[c[k>>2]>>2]=g;c[(c[c[k>>2]>>2]|0)+(c[p>>2]<<2)>>2]=c[m>>2]<<1;k=eK(c[c[j>>2]>>2]|0,(c[q>>2]|0)+(c[m>>2]<<1)<<4)|0;c[c[j>>2]>>2]=k;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[m>>2]|0))break;k=(c[c[j>>2]>>2]|0)+((c[q>>2]|0)+(c[p>>2]|0)<<4)|0;g=(c[n>>2]|0)+(c[p>>2]<<4)|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];g=(c[c[j>>2]>>2]|0)+((c[q>>2]|0)+(c[r>>2]|0)-(c[p>>2]|0)<<4)|0;k=(c[o>>2]|0)+(c[p>>2]<<4)|0;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[p>>2]=(c[p>>2]|0)+1}i=h;return}function fJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0;d=i;i=i+32|0;e=d+16|0;f=d+8|0;g=d;h[f>>3]=+W(+(+h[c+8>>3]-+h[b+8>>3]),+(+h[c>>3]-+h[b>>3]));h[g>>3]=+W(+(+h[a+8>>3]-+h[b+8>>3]),+(+h[a>>3]-+h[b>>3]));h[e>>3]=+h[f>>3]-+h[g>>3];if(!(+h[e>>3]>0.0)){j=+h[g>>3];k=+h[e>>3];l=k/2.0;m=j+l;i=d;return +m}h[e>>3]=+h[e>>3]-6.283185307179586;j=+h[g>>3];k=+h[e>>3];l=k/2.0;m=j+l;i=d;return +m}function gJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=cK(24)|0;c[(c[f>>2]|0)+16>>2]=0;b=c[f>>2]|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[(c[e>>2]|0)+16>>2]=c[f>>2];i=d;return c[f>>2]|0}function hJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=yI(c[c[e>>2]>>2]|0,c[(c[e>>2]|0)+160>>2]|0,c[(c[e>>2]|0)+156>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function iJ(a,b){a=a|0;b=b|0;var c=0,d=0;if(!(+h[a+16>>3]>=+h[b>>3])){c=0;d=c&1;return d|0}if(!(+h[b+16>>3]>=+h[a>>3])){c=0;d=c&1;return d|0}if(!(+h[a+16+8>>3]>=+h[b+8>>3])){c=0;d=c&1;return d|0}c=+h[b+16+8>>3]>=+h[a+8>>3];d=c&1;return d|0}function jJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[(c[h>>2]|0)+156>>2]|0)<=1){a[g>>0]=1;o=a[g>>0]|0;i=f;return o|0}c[l>>2]=hO(c[k>>2]|0,c[13844]|0,178518)|0;if((hJ(c[h>>2]|0,c[l>>2]|0)|0)<<24>>24){a[g>>0]=1;o=a[g>>0]|0;i=f;return o|0}if(a[c[l>>2]>>0]|0){a[g>>0]=0;o=a[g>>0]|0;i=f;return o|0}l=TA(c[j>>2]|0,c[k>>2]|0)|0;c[n>>2]=l;if(!l){a[g>>0]=1;o=a[g>>0]|0;i=f;return o|0}c[n>>2]=TA(c[j>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[n>>2]|0)){p=15;break}c[m>>2]=hO(c[n>>2]|0,c[13874]|0,178518)|0;if(!(a[c[m>>2]>>0]|0)){p=13;break}if((hJ(c[h>>2]|0,c[m>>2]|0)|0)&255){p=13;break}c[n>>2]=UA(c[j>>2]|0,c[n>>2]|0,c[k>>2]|0)|0}if((p|0)==13){a[g>>0]=1;o=a[g>>0]|0;i=f;return o|0}else if((p|0)==15){a[g>>0]=0;o=a[g>>0]|0;i=f;return o|0}return 0}function kJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+80|0;e=d+32|0;f=d;g=d+64|0;c[g>>2]=a;a=(c[(c[g>>2]|0)+8>>2]|0)+48|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];c[e+24>>2]=c[b+24>>2];c[e+28>>2]=c[b+28>>2];b=(iJ(f,e)|0)&255;i=d;return b|0}function lJ(a,d){a=a|0;d=d|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+96|0;g=f+84|0;j=f+80|0;k=f+76|0;l=f+72|0;m=f+68|0;n=f+64|0;o=f+60|0;p=f+56|0;q=f+52|0;r=f+48|0;s=f+44|0;t=f+40|0;u=f+36|0;v=f+32|0;w=f+28|0;x=f;y=f+24|0;z=f+20|0;A=f+16|0;c[g>>2]=a;c[j>>2]=d;c[l>>2]=c[(c[g>>2]|0)+152>>2];c[q>>2]=0;c[r>>2]=0;c[t>>2]=0;c[u>>2]=0;c[w>>2]=0;c[k>>2]=wH(c[g>>2]|0)|0;c[(c[k>>2]|0)+4>>2]=2;c[(c[k>>2]|0)+8>>2]=c[j>>2];c[(c[k>>2]|0)+12>>2]=8;do if(c[l>>2]&16777216)if((e[(c[(qC(c[j>>2]|0)|0)+8>>2]|0)+178>>1]|0|0)>=3){B=+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]|0)+16>>3]*72.0;h[(c[k>>2]|0)+168>>3]=+(~~(+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]|0)+16>>3]*72.0>=0.0?B+.5:B-.5)|0);break}else{h[(c[k>>2]|0)+168>>3]=0.0;break}while(0);nJ(c[g>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+104>>2]|0,c[j>>2]|0);if(!(c[l>>2]&4259840)){C=c[j>>2]|0;D=yA(C,137612)|0;dT(D);E=c[g>>2]|0;F=c[j>>2]|0;fR(E,F);i=f;return}if((c[(c[k>>2]|0)+208>>2]|0)==0?((b[(c[k>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0){C=c[j>>2]|0;D=yA(C,137612)|0;dT(D);E=c[g>>2]|0;F=c[j>>2]|0;fR(E,F);i=f;return}c[s>>2]=dM(c[j>>2]|0)|0;d=(c[(c[j>>2]|0)+8>>2]|0)+16|0;c[x>>2]=c[d>>2];c[x+4>>2]=c[d+4>>2];c[x+8>>2]=c[d+8>>2];c[x+12>>2]=c[d+12>>2];c[q>>2]=oJ(c[j>>2]|0)|0;if(((c[s>>2]|0)==1|(c[s>>2]|0)==3?(c[u>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2],((pJ(c[u>>2]|0)|0)&255|0)!=0):0)?((c[q>>2]|0)!=0?1:(c[(c[u>>2]|0)+4>>2]|0)!=0):0)c[r>>2]=1;a:do if(!((c[u>>2]|0)==0|(c[r>>2]|0)!=0)?(c[l>>2]&524288|0)!=0:0){if((c[(c[u>>2]|0)+8>>2]|0)<3)c[m>>2]=1;else c[m>>2]=c[(c[u>>2]|0)+8>>2];if((c[(c[u>>2]|0)+4>>2]|0)<2)c[n>>2]=1;else c[n>>2]=c[(c[u>>2]|0)+4>>2];c[v>>2]=c[(c[u>>2]|0)+44>>2];s=yA(c[j>>2]|0,140333)|0;c[y>>2]=s;if(s)c[t>>2]=u3(c[y>>2]|0)|0;if((c[t>>2]|0)<4|(c[t>>2]|0)>60)c[t>>2]=20;if(!((c[q>>2]|0)!=0?1:(c[(c[u>>2]|0)+4>>2]|0)!=0)){c[(c[k>>2]|0)+264>>2]=0;c[t>>2]=2;c[w>>2]=bK(c[t>>2]<<4)|0;h[c[w>>2]>>3]=+h[x>>3]-+h[(c[(c[j>>2]|0)+8>>2]|0)+88>>3];h[(c[w>>2]|0)+8>>3]=+h[x+8>>3]-+h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3]/2.0;h[(c[w>>2]|0)+16>>3]=+h[x>>3]+ +h[(c[(c[j>>2]|0)+8>>2]|0)+88>>3];h[(c[w>>2]|0)+16+8>>3]=+h[x+8>>3]+ +h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3]/2.0;break}if(((c[(c[u>>2]|0)+8>>2]|0)<3?+h[(c[u>>2]|0)+32>>3]==0.0:0)?+h[(c[u>>2]|0)+24>>3]==0.0:0){s=(c[k>>2]|0)+264|0;if(c[c[u>>2]>>2]|0){c[s>>2]=1;c[t>>2]=2;c[w>>2]=bK(c[t>>2]<<4)|0;h[c[w>>2]>>3]=+h[x>>3];h[(c[w>>2]|0)+8>>3]=+h[x+8>>3];h[(c[w>>2]|0)+16>>3]=+h[x>>3]+ +h[(c[v>>2]|0)+((c[n>>2]<<1)-1<<4)>>3];h[(c[w>>2]|0)+16+8>>3]=+h[x+8>>3]+ +h[(c[v>>2]|0)+((c[n>>2]<<1)-1<<4)+8>>3];break}c[s>>2]=2;c[w>>2]=qJ(+h[(c[v>>2]|0)+((c[n>>2]<<1)-1<<4)>>3],+h[(c[v>>2]|0)+((c[n>>2]<<1)-1<<4)+8>>3],c[t>>2]|0)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break a;s=(c[w>>2]|0)+(c[o>>2]<<4)|0;h[s>>3]=+h[s>>3]+ +h[x>>3];s=(c[w>>2]|0)+(c[o>>2]<<4)+8|0;h[s>>3]=+h[s>>3]+ +h[x+8>>3];c[o>>2]=(c[o>>2]|0)+1}}c[z>>2]=_((c[n>>2]|0)-1|0,c[(c[u>>2]|0)+8>>2]|0)|0;c[(c[k>>2]|0)+264>>2]=2;if((c[(c[u>>2]|0)+8>>2]|0)>=(c[t>>2]|0)){c[A>>2]=(c[(c[u>>2]|0)+8>>2]|0)/(c[t>>2]|0)|0;c[w>>2]=bK(c[t>>2]<<4)|0;c[o>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break a;h[(c[w>>2]|0)+(c[p>>2]<<4)>>3]=+h[x>>3]+ +h[(c[v>>2]|0)+((c[o>>2]|0)+(c[z>>2]|0)<<4)>>3];h[(c[w>>2]|0)+(c[p>>2]<<4)+8>>3]=+h[x+8>>3]+ +h[(c[v>>2]|0)+((c[o>>2]|0)+(c[z>>2]|0)<<4)+8>>3];c[o>>2]=(c[o>>2]|0)+(c[A>>2]|0);c[p>>2]=(c[p>>2]|0)+1}}else{c[t>>2]=c[m>>2];c[w>>2]=bK(c[t>>2]<<4)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break a;h[(c[w>>2]|0)+(c[o>>2]<<4)>>3]=+h[x>>3]+ +h[(c[v>>2]|0)+((c[o>>2]|0)+(c[z>>2]|0)<<4)>>3];h[(c[w>>2]|0)+(c[o>>2]<<4)+8>>3]=+h[x+8>>3]+ +h[(c[v>>2]|0)+((c[o>>2]|0)+(c[z>>2]|0)<<4)+8>>3];c[o>>2]=(c[o>>2]|0)+1}}}else G=41;while(0);if((G|0)==41){c[(c[k>>2]|0)+264>>2]=0;c[t>>2]=2;c[w>>2]=bK(c[t>>2]<<4)|0;h[c[w>>2]>>3]=+h[x>>3]-+h[(c[(c[j>>2]|0)+8>>2]|0)+88>>3];h[(c[w>>2]|0)+8>>3]=+h[x+8>>3]-+h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3]/2.0;h[(c[w>>2]|0)+16>>3]=+h[x>>3]+ +h[(c[(c[j>>2]|0)+8>>2]|0)+96>>3];h[(c[w>>2]|0)+16+8>>3]=+h[x+8>>3]+ +h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3]/2.0}if(!(c[l>>2]&8192))UQ(c[g>>2]|0,c[w>>2]|0,c[w>>2]|0,c[t>>2]|0)|0;c[(c[k>>2]|0)+272>>2]=c[w>>2];c[(c[k>>2]|0)+268>>2]=c[t>>2];C=c[j>>2]|0;D=yA(C,137612)|0;dT(D);E=c[g>>2]|0;F=c[j>>2]|0;fR(E,F);i=f;return}function mJ(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;gR(c[d>>2]|0);xH(c[d>>2]|0);i=b;return}function nJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+176|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[l>>2]=yA(c[j>>2]|0,179064)|0;c[m>>2]=yA(c[j>>2]|0,179110)|0;c[n>>2]=yA(c[j>>2]|0,179097)|0;dA(p,128,f+48|0);if(c[h>>2]|0)c[k>>2]=c[c[h>>2]>>2];else c[k>>2]=0;if(!((c[l>>2]|0)!=0?(a[c[l>>2]>>0]|0)!=0:0))c[l>>2]=yA(c[j>>2]|0,149053)|0;c[o>>2]=zH(c[g>>2]|0,c[j>>2]|0,p)|0;yH(c[g>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[j>>2]|0)|0;hA(p);i=f;return}function oJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[j>>2]=0;c[f>>2]=iO(c[e>>2]|0,c[13834]|0,178518)|0;if(!(a[c[f>>2]>>0]|0)){k=c[j>>2]|0;i=d;return k|0}c[h>>2]=JH(c[f>>2]|0)|0;while(1){f=c[c[h>>2]>>2]|0;c[g>>2]=f;if(!f)break;if(!(J3(c[g>>2]|0,148663)|0))c[j>>2]=1;c[h>>2]=(c[h>>2]|0)+4}k=c[j>>2]|0;i=d;return k|0}function pJ(a){a=a|0;var b=0,d=0,e=0.0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(((c[(c[d>>2]|0)+8>>2]|0)==4?(e=+h[(c[d>>2]|0)+16>>3],((~~(+h[(c[d>>2]|0)+16>>3]>=0.0?e+.5:e-.5)|0)%90|0|0)==0):0)?+h[(c[d>>2]|0)+24>>3]==0.0:0)f=+h[(c[d>>2]|0)+32>>3]==0.0;else f=0;i=b;return f&1|0}function qJ(a,b,d){a=+a;b=+b;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+24|0;g=e+16|0;j=e+40|0;k=e+8|0;l=e;m=e+36|0;n=e+32|0;h[f>>3]=a;h[g>>3]=b;c[j>>2]=d;h[k>>3]=0.0;h[l>>3]=6.283185307179586/+(c[j>>2]|0);c[n>>2]=bK(c[j>>2]<<4)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;b=+h[f>>3]*+Q(+(+h[k>>3]));h[(c[n>>2]|0)+(c[m>>2]<<4)>>3]=b;b=+h[g>>3]*+R(+(+h[k>>3]));h[(c[n>>2]|0)+(c[m>>2]<<4)+8>>3]=b;h[k>>3]=+h[k>>3]+ +h[l>>3];c[m>>2]=(c[m>>2]|0)+1}i=e;return c[n>>2]|0}function rJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function sJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=(c[b>>2]|0)+(c[d>>2]|0);c[f+4>>2]=(c[b+4>>2]|0)+(c[d+4>>2]|0);c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];i=e;return}function tJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+24|0;j=d+16|0;k=d+8|0;l=d;c[f>>2]=a;c[d+32>>2]=b;b=(c[f>>2]|0)+196|0;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];b=(c[f>>2]|0)+164|0;c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];if(c[(c[f>>2]|0)+360>>2]|0){c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];vI(k,e);c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];vI(l,e);c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2]}h[(c[f>>2]|0)+288>>3]=+(c[g>>2]|0)*+h[(c[f>>2]|0)+320>>3]-+h[(c[f>>2]|0)+240>>3];h[(c[f>>2]|0)+288+8>>3]=+(c[g+4>>2]|0)*+h[(c[f>>2]|0)+320+8>>3]-+h[(c[f>>2]|0)+240+8>>3];h[(c[f>>2]|0)+288+16>>3]=+h[(c[f>>2]|0)+288>>3]+ +h[(c[f>>2]|0)+320>>3];h[(c[f>>2]|0)+288+16+8>>3]=+h[(c[f>>2]|0)+288+8>>3]+ +h[(c[f>>2]|0)+320+8>>3];l=(c[f>>2]|0)+472|0;if(!(c[(c[(c[f>>2]|0)+12>>2]|0)+28>>2]|0)){e=(c[f>>2]|0)+456|0;c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2]}else{e=c[f>>2]|0;if((c[l>>2]|0)<(c[(c[f>>2]|0)+456>>2]|0))m=c[e+472>>2]|0;else m=c[e+456>>2]|0;c[(c[f>>2]|0)+472>>2]=m;m=c[f>>2]|0;if((c[(c[f>>2]|0)+472+4>>2]|0)<(c[(c[f>>2]|0)+456+4>>2]|0))n=c[m+472+4>>2]|0;else n=c[m+456+4>>2]|0;c[(c[f>>2]|0)+472+4>>2]=n;n=c[f>>2]|0;if((c[(c[f>>2]|0)+472+8>>2]|0)>(c[(c[f>>2]|0)+456+8>>2]|0))o=c[n+472+8>>2]|0;else o=c[n+456+8>>2]|0;c[(c[f>>2]|0)+472+8>>2]=o;o=c[f>>2]|0;if((c[(c[f>>2]|0)+472+8+4>>2]|0)>(c[(c[f>>2]|0)+456+8+4>>2]|0))p=c[o+472+8+4>>2]|0;else p=c[o+456+8+4>>2]|0;c[(c[f>>2]|0)+472+8+4>>2]=p}q=+h[(c[f>>2]|0)+336>>3];p=c[f>>2]|0;if(c[(c[f>>2]|0)+152>>2]&128){h[(c[f>>2]|0)+256>>3]=q-+h[p+368>>3]/2.0;h[(c[f>>2]|0)+256+8>>3]=+h[(c[f>>2]|0)+336+8>>3]-+h[(c[f>>2]|0)+368+8>>3]/2.0;h[(c[f>>2]|0)+256+16>>3]=+h[(c[f>>2]|0)+336>>3]+ +h[(c[f>>2]|0)+368>>3]/2.0;h[(c[f>>2]|0)+256+16+8>>3]=+h[(c[f>>2]|0)+336+8>>3]+ +h[(c[f>>2]|0)+368+8>>3]/2.0}else{h[(c[f>>2]|0)+256>>3]=q+ +h[p+320>>3]*(+(c[g>>2]|0)-+(c[j>>2]|0)/2.0);h[(c[f>>2]|0)+256+8>>3]=+h[(c[f>>2]|0)+336+8>>3]+ +h[(c[f>>2]|0)+320+8>>3]*(+(c[g+4>>2]|0)-+(c[j+4>>2]|0)/2.0);h[(c[f>>2]|0)+256+16>>3]=+h[(c[f>>2]|0)+256>>3]+ +h[(c[f>>2]|0)+320>>3];h[(c[f>>2]|0)+256+16+8>>3]=+h[(c[f>>2]|0)+256+8>>3]+ +h[(c[f>>2]|0)+320+8>>3]}j=(c[f>>2]|0)+256|0;if(c[(c[f>>2]|0)+360>>2]|0){h[(c[f>>2]|0)+504+8>>3]=-+h[j+16+8>>3]-+h[(c[f>>2]|0)+384+8>>3]/+h[(c[f>>2]|0)+352>>3];g=(c[f>>2]|0)+256|0;if((c[13802]|0)!=0?1:(c[(c[f>>2]|0)+152>>2]&4096|0)!=0){h[(c[f>>2]|0)+504>>3]=-+h[g+16>>3]-+h[(c[f>>2]|0)+384>>3]/+h[(c[f>>2]|0)+352>>3];i=d;return}else{h[(c[f>>2]|0)+504>>3]=-+h[g>>3]+ +h[(c[f>>2]|0)+384>>3]/+h[(c[f>>2]|0)+352>>3];i=d;return}}else{h[(c[f>>2]|0)+504>>3]=-+h[j>>3]+ +h[(c[f>>2]|0)+384>>3]/+h[(c[f>>2]|0)+352>>3];j=(c[f>>2]|0)+256|0;if((c[13802]|0)!=0?1:(c[(c[f>>2]|0)+152>>2]&4096|0)!=0){h[(c[f>>2]|0)+504+8>>3]=-+h[j+16+8>>3]-+h[(c[f>>2]|0)+384+8>>3]/+h[(c[f>>2]|0)+352>>3];i=d;return}else{h[(c[f>>2]|0)+504+8>>3]=-+h[j+8>>3]+ +h[(c[f>>2]|0)+384+8>>3]/+h[(c[f>>2]|0)+352>>3];i=d;return}}}function uJ(b,d){b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+80|0;f=e;h=e+72|0;j=e+68|0;k=e+64|0;l=e+60|0;m=e+56|0;n=e+48|0;o=e+40|0;p=e+36|0;q=e+32|0;c[h>>2]=b;c[j>>2]=d;d=yA(c[j>>2]|0,178986)|0;c[l>>2]=d;if((d|0)!=0?(a[c[l>>2]>>0]|0)!=0:0)c[m>>2]=0;else{c[l>>2]=174801;c[m>>2]=1}if(((c[(c[h>>2]|0)+152>>2]&256|0)==0?(a[c[l>>2]>>0]|0)==(a[175430]|0):0)?(J3(c[l>>2]|0,175430)|0)==0:0){c[l>>2]=174801;c[m>>2]=1}if(!(((c[(c[h>>2]|0)+152>>2]&256|0)!=0?(a[c[l>>2]>>0]|0)==(a[175430]|0):0)?(J3(c[l>>2]|0,175430)|0)==0:0))r=12;do if((r|0)==12?!((c[m>>2]|0)!=0?(c[(c[h>>2]|0)+152>>2]&33554432|0)!=0:0):0){if(!((IH(c[l>>2]|0,n,o)|0)<<24>>24)){pR(c[h>>2]|0,c[l>>2]|0);oR(c[h>>2]|0,175430);d=c[h>>2]|0;b=(c[h>>2]|0)+256|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];uR(d,f,1);break}c[q>>2]=0;pR(c[h>>2]|0,c[n>>2]|0);oR(c[h>>2]|0,175430);fI(c[j>>2]|0,q)|0;d=c[h>>2]|0;if(c[n+4>>2]|0){b=c[n+4>>2]|0;s=eO(c[j>>2]|0,c[13812]|0,0,0)|0;qR(d,b,s,+g[o>>2])}else{s=eO(c[j>>2]|0,c[13812]|0,0,0)|0;qR(d,174917,s,+g[o>>2])}if(c[q>>2]&2)c[p>>2]=3;else c[p>>2]=2;s=c[h>>2]|0;d=(c[h>>2]|0)+256|0;b=c[p>>2]|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[f+16>>2]=c[d+16>>2];c[f+20>>2]=c[d+20>>2];c[f+24>>2]=c[d+24>>2];c[f+28>>2]=c[d+28>>2];uR(s,f,b);O4(c[n>>2]|0)}while(0);n=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0)+88>>2]|0;c[k>>2]=n;if(!n){i=e;return}yJ(c[h>>2]|0,c[k>>2]|0);i=e;return}function vJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[f>>2]>>2];d=(c[j>>2]|0)+28|0;c[d>>2]=(c[d>>2]|0)+1;if(!(c[h>>2]&4))HH(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);a:do if(c[h>>2]&1){bR(c[f>>2]|0);c[k>>2]=$B(c[g>>2]|0)|0;while(1){m=c[f>>2]|0;if(!(c[k>>2]|0))break;gI(m,c[k>>2]|0);c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}cR(m);dR(c[f>>2]|0);c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[l>>2]=OA(c[g>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;hI(c[f>>2]|0,c[l>>2]|0);c[l>>2]=QA(c[g>>2]|0,c[l>>2]|0)|0}c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}eR(c[f>>2]|0)}else{if(c[h>>2]&16){dR(c[f>>2]|0);c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[l>>2]=OA(c[g>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;hI(c[f>>2]|0,c[l>>2]|0);c[l>>2]=QA(c[g>>2]|0,c[l>>2]|0)|0}c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}eR(c[f>>2]|0);bR(c[f>>2]|0);c[k>>2]=$B(c[g>>2]|0)|0;while(1){n=c[f>>2]|0;if(!(c[k>>2]|0))break;gI(n,c[k>>2]|0);c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}cR(n);break}if(!(c[h>>2]&8)){c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break a;gI(c[f>>2]|0,c[k>>2]|0);c[l>>2]=OA(c[g>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;d=c[l>>2]|0;gI(c[f>>2]|0,c[((c[c[l>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0);hI(c[f>>2]|0,c[l>>2]|0);c[l>>2]=QA(c[g>>2]|0,c[l>>2]|0)|0}c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}}bR(c[f>>2]|0);c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;if((wJ(c[g>>2]|0,c[k>>2]|0)|0)<<24>>24)gI(c[f>>2]|0,c[k>>2]|0);c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}cR(c[f>>2]|0);dR(c[f>>2]|0);c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[l>>2]=OA(c[g>>2]|0,c[k>>2]|0)|0;while(1){o=c[g>>2]|0;if(!(c[l>>2]|0))break;if((xJ(o,c[l>>2]|0)|0)<<24>>24)hI(c[f>>2]|0,c[l>>2]|0);c[l>>2]=QA(c[g>>2]|0,c[l>>2]|0)|0}c[k>>2]=aC(o,c[k>>2]|0)|0}eR(c[f>>2]|0)}while(0);if(!(c[h>>2]&4)){i=e;return}HH(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);i=e;return}function wJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[k>>2]=1;while(1){if((c[k>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0)){l=6;break}c[j>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[k>>2]<<2)>>2];if(AC(c[j>>2]|0,c[h>>2]|0)|0){l=4;break}c[k>>2]=(c[k>>2]|0)+1}if((l|0)==4){a[f>>0]=0;m=a[f>>0]|0;i=e;return m|0}else if((l|0)==6){a[f>>0]=1;m=a[f>>0]|0;i=e;return m|0}return 0}function xJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[k>>2]=1;while(1){if((c[k>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0)){l=6;break}c[j>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[k>>2]<<2)>>2];if(AC(c[j>>2]|0,c[h>>2]|0)|0){l=4;break}c[k>>2]=(c[k>>2]|0)+1}if((l|0)==4){a[f>>0]=0;m=a[f>>0]|0;i=e;return m|0}else if((l|0)==6){a[f>>0]=1;m=a[f>>0]|0;i=e;return m|0}return 0}function yJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+144|0;e=d+48|0;f=d+16|0;j=d+8|0;k=d;l=d+136|0;m=d+132|0;n=d+128|0;o=d+124|0;p=d+120|0;q=d+116|0;r=d+112|0;s=d+108|0;t=d+104|0;u=d+100|0;v=d+96|0;w=d+92|0;x=d+88|0;y=d+84|0;z=d+80|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=1;c[o>>2]=1e3;c[p>>2]=cK(16e3)|0;c[t>>2]=0;c[u>>2]=1;c[q>>2]=c[(c[m>>2]|0)+8>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[c[m>>2]>>2]|0))break;a:do switch(c[c[q>>2]>>2]|0){case 1:case 0:{b=(c[q>>2]|0)+80|0;a=(c[l>>2]|0)+256|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];c[e+16>>2]=c[a+16>>2];c[e+20>>2]=c[a+20>>2];c[e+24>>2]=c[a+24>>2];c[e+28>>2]=c[a+28>>2];if(iJ(f,e)|0){h[c[p>>2]>>3]=+h[(c[q>>2]|0)+8>>3]-+h[(c[q>>2]|0)+8+16>>3];h[(c[p>>2]|0)+8>>3]=+h[(c[q>>2]|0)+8+8>>3]-+h[(c[q>>2]|0)+8+24>>3];h[(c[p>>2]|0)+16>>3]=+h[(c[q>>2]|0)+8+16>>3];h[(c[p>>2]|0)+16+8>>3]=+h[(c[q>>2]|0)+8+24>>3];sR(c[l>>2]|0,c[p>>2]|0,2,(c[c[q>>2]>>2]|0)==0?c[u>>2]|0:0)}break}case 3:case 2:{a=(c[q>>2]|0)+80|0;b=(c[l>>2]|0)+256|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];c[e+24>>2]=c[b+24>>2];c[e+28>>2]=c[b+28>>2];if(iJ(f,e)|0){c[p>>2]=zJ(c[p>>2]|0,o,c[(c[q>>2]|0)+8+4>>2]|0,c[(c[q>>2]|0)+8>>2]|0)|0;tR(c[l>>2]|0,c[p>>2]|0,c[(c[q>>2]|0)+8>>2]|0,(c[c[q>>2]>>2]|0)==2?c[u>>2]|0:0)}break}case 5:case 4:{b=(c[q>>2]|0)+80|0;a=(c[l>>2]|0)+256|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];c[e+16>>2]=c[a+16>>2];c[e+20>>2]=c[a+20>>2];c[e+24>>2]=c[a+24>>2];c[e+28>>2]=c[a+28>>2];if(iJ(f,e)|0){c[p>>2]=zJ(c[p>>2]|0,o,c[(c[q>>2]|0)+8+4>>2]|0,c[(c[q>>2]|0)+8>>2]|0)|0;vR(c[l>>2]|0,c[p>>2]|0,c[(c[q>>2]|0)+8>>2]|0,0,0,((c[c[q>>2]>>2]|0)==4?c[u>>2]|0:0)&255)}break}case 6:{a=(c[q>>2]|0)+80|0;b=(c[l>>2]|0)+256|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];c[e+16>>2]=c[b+16>>2];c[e+20>>2]=c[b+20>>2];c[e+24>>2]=c[b+24>>2];c[e+28>>2]=c[b+28>>2];if(iJ(f,e)|0){c[p>>2]=zJ(c[p>>2]|0,o,c[(c[q>>2]|0)+8+4>>2]|0,c[(c[q>>2]|0)+8>>2]|0)|0;wR(c[l>>2]|0,c[p>>2]|0,c[(c[q>>2]|0)+8>>2]|0)}break}case 7:{b=(c[q>>2]|0)+80|0;a=(c[l>>2]|0)+256|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];c[e+16>>2]=c[a+16>>2];c[e+20>>2]=c[a+20>>2];c[e+24>>2]=c[a+24>>2];c[e+28>>2]=c[a+28>>2];if(iJ(f,e)|0){h[c[p>>2]>>3]=+h[(c[q>>2]|0)+8>>3];h[(c[p>>2]|0)+8>>3]=+h[(c[q>>2]|0)+8+8>>3];a=c[l>>2]|0;b=c[p>>2]|0;A=c[(c[q>>2]|0)+112>>2]|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];nR(a,e,A)}break}case 8:{pR(c[l>>2]|0,c[(c[q>>2]|0)+8>>2]|0);c[u>>2]=1;break}case 9:{oR(c[l>>2]|0,c[(c[q>>2]|0)+8>>2]|0);c[u>>2]=1;break}case 13:{A=(c[q>>2]|0)+8+8|0;if((c[(c[q>>2]|0)+8>>2]|0)!=2){c[z>>2]=A;c[v>>2]=c[(c[(c[z>>2]|0)+36>>2]|0)+4>>2];c[w>>2]=c[(c[(c[z>>2]|0)+36>>2]|0)+8+4>>2];g[x>>2]=+g[(c[(c[z>>2]|0)+36>>2]|0)+8>>2];c[s>>2]=~~(+W(+(+h[(c[z>>2]|0)+24>>3]-+h[(c[z>>2]|0)+8>>3]),+(+h[(c[z>>2]|0)+16>>3]-+h[c[z>>2]>>3]))*180.0/3.141592653589793);pR(c[l>>2]|0,c[v>>2]|0);qR(c[l>>2]|0,c[w>>2]|0,c[s>>2]|0,+g[x>>2]);c[u>>2]=2;break a}c[y>>2]=A;c[v>>2]=c[(c[(c[y>>2]|0)+52>>2]|0)+4>>2];c[w>>2]=c[(c[(c[y>>2]|0)+52>>2]|0)+8+4>>2];g[x>>2]=+g[(c[(c[y>>2]|0)+52>>2]|0)+8>>2];if(+h[(c[y>>2]|0)+24>>3]==+h[c[y>>2]>>3]?+h[(c[y>>2]|0)+32>>3]==+h[(c[y>>2]|0)+8>>3]:0)c[s>>2]=0;else c[s>>2]=~~(+T(+((+h[c[y>>2]>>3]-+h[(c[y>>2]|0)+24>>3])/+h[(c[y>>2]|0)+16>>3]))*180.0/3.141592653589793);pR(c[l>>2]|0,c[v>>2]|0);qR(c[l>>2]|0,c[w>>2]|0,c[s>>2]|0,+g[x>>2]);c[u>>2]=3;break}case 14:{$z(0,138785,k)|0;break}case 12:{if(c[n>>2]|0){$z(0,138825,j)|0;c[n>>2]=0}break}case 11:{c[t>>2]=JH(c[(c[q>>2]|0)+8>>2]|0)|0;rR(c[l>>2]|0,c[t>>2]|0);break}default:{}}while(0);c[q>>2]=(c[q>>2]|0)+120;c[r>>2]=(c[r>>2]|0)+1}if(!(c[t>>2]|0)){B=c[p>>2]|0;O4(B);i=d;return}rR(c[l>>2]|0,c[(c[c[l>>2]>>2]|0)+336>>2]|0);B=c[p>>2]|0;O4(B);i=d;return}function zJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[n>>2]=c[c[j>>2]>>2];if((c[l>>2]|0)>(c[n>>2]|0)){c[n>>2]=(c[n>>2]<<1|0)>(c[l>>2]|0)?c[n>>2]<<1:c[l>>2]|0;c[g>>2]=eK(c[g>>2]|0,c[n>>2]<<4)|0;c[c[j>>2]>>2]=c[n>>2]}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;h[(c[g>>2]|0)+(c[m>>2]<<4)>>3]=+h[(c[k>>2]|0)+((c[m>>2]|0)*24|0)>>3];h[(c[g>>2]|0)+(c[m>>2]<<4)+8>>3]=+h[(c[k>>2]|0)+((c[m>>2]|0)*24|0)+8>>3];c[m>>2]=(c[m>>2]|0)+1}i=f;return c[g>>2]|0}function AJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break;c[h>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2];AJ(c[f>>2]|0,c[h>>2]|0);d=yA(c[h>>2]|0,178832)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)oR(c[f>>2]|0,c[k>>2]|0);d=yA(c[h>>2]|0,175307)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)oR(c[f>>2]|0,c[k>>2]|0);d=yA(c[h>>2]|0,178986)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)oR(c[f>>2]|0,c[k>>2]|0);d=yA(c[h>>2]|0,139210)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)pR(c[f>>2]|0,c[k>>2]|0);d=yA(c[h>>2]|0,139238)|0;c[k>>2]=d;if((d|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)oR(c[f>>2]|0,c[k>>2]|0);c[j>>2]=(c[j>>2]|0)+1}i=e;return}function BJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;d=i;i=i+32|0;e=d+8|0;f=d+24|0;g=d+20|0;j=d+16|0;k=d;c[f>>2]=b;c[g>>2]=H3(c[f>>2]|0,59)|0;if(!(c[g>>2]|0)){h[e>>3]=0.0;l=+h[e>>3];i=d;return +l}f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=0;h[k>>3]=+x3(c[g>>2]|0,j);if(+h[k>>3]>=0.0?(c[j>>2]|0)!=(c[g>>2]|0):0){h[e>>3]=+h[k>>3];l=+h[e>>3];i=d;return +l}else{h[e>>3]=-1.0;l=+h[e>>3];i=d;return +l}return +(0.0)}function CJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;j=e+40|0;k=e+32|0;l=e+24|0;m=e+16|0;n=e+8|0;o=e;if((+h[a>>3]>=+h[d>>3]?+h[a>>3]<=+h[d+16>>3]:0)?+h[a+8>>3]>=+h[d+8>>3]:0)p=+h[a+8>>3]<=+h[d+16+8>>3];else p=0;c[g>>2]=p&1;if((+h[b>>3]>=+h[d>>3]?+h[b>>3]<=+h[d+16>>3]:0)?+h[b+8>>3]>=+h[d+8>>3]:0)q=+h[b+8>>3]<=+h[d+16+8>>3];else q=0;c[j>>2]=q&1;if((c[g>>2]|0)!=(c[j>>2]|0)){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if(c[g>>2]&c[j>>2]){c[f>>2]=1;r=c[f>>2]|0;i=e;return r|0}s=+h[a+8>>3];do if(+h[a>>3]==+h[b>>3]){if(((s>=+h[d+8>>3]^+h[b+8>>3]>=+h[d+8>>3]|0)!=0?+h[a>>3]>=+h[d>>3]:0)?+h[a>>3]<=+h[d+16>>3]:0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}}else{if(s==+h[b+8>>3]){if(!(+h[a>>3]>=+h[d>>3]^+h[b>>3]>=+h[d>>3]))break;if(!(+h[a+8>>3]>=+h[d+8>>3]))break;if(!(+h[a+8>>3]<=+h[d+16+8>>3]))break;c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}h[k>>3]=(+h[b+8>>3]-+h[a+8>>3])/(+h[b>>3]-+h[a>>3]);if(+h[a>>3]<+h[b>>3]){h[n>>3]=+h[a>>3];h[o>>3]=+h[b>>3]}else{h[n>>3]=+h[b>>3];h[o>>3]=+h[a>>3]}h[m>>3]=+h[a+8>>3]+(+h[d>>3]-+h[a>>3])*+h[k>>3];if(((+h[d>>3]>=+h[n>>3]?+h[d>>3]<=+h[o>>3]:0)?+h[m>>3]>=+h[d+8>>3]:0)?+h[m>>3]<=+h[d+16+8>>3]:0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}h[m>>3]=+h[m>>3]+(+h[d+16>>3]-+h[d>>3])*+h[k>>3];if(((+h[m>>3]>=+h[d+8>>3]?+h[m>>3]<=+h[d+16+8>>3]:0)?+h[d+16>>3]>=+h[n>>3]:0)?+h[d+16>>3]<=+h[o>>3]:0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}if(+h[a+8>>3]<+h[b+8>>3]){h[n>>3]=+h[a+8>>3];h[o>>3]=+h[b+8>>3]}else{h[n>>3]=+h[b+8>>3];h[o>>3]=+h[a+8>>3]}h[l>>3]=+h[a>>3]+(+h[d+8>>3]-+h[a+8>>3])/+h[k>>3];if(((+h[l>>3]>=+h[d>>3]?+h[l>>3]<=+h[d+16>>3]:0)?+h[d+8>>3]>=+h[n>>3]:0)?+h[d+8>>3]<=+h[o>>3]:0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}h[l>>3]=+h[l>>3]+(+h[d+16+8>>3]-+h[d+8>>3])/+h[k>>3];if(((+h[l>>3]>=+h[d>>3]?+h[l>>3]<=+h[d+16>>3]:0)?+h[d+16+8>>3]>=+h[n>>3]:0)?+h[d+16+8>>3]<=+h[o>>3]:0){c[f>>2]=0;r=c[f>>2]|0;i=e;return r|0}}while(0);c[f>>2]=-1;r=c[f>>2]|0;i=e;return r|0}function DJ(a){a=a|0;var b=0,d=0,e=0.0;b=i;i=i+16|0;d=b;c[d>>2]=a;e=+h[(c[d>>2]|0)+16>>3];h[(c[d>>2]|0)+32>>3]=e;h[(c[d>>2]|0)+48>>3]=e;h[(c[d>>2]|0)+32+8>>3]=+h[(c[d>>2]|0)+16+8>>3];h[(c[d>>2]|0)+48+8>>3]=+h[(c[d>>2]|0)+8>>3];h[(c[d>>2]|0)+16>>3]=+h[c[d>>2]>>3];i=b;return}function EJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+48|0;f=e+16|0;g=e+32|0;j=e+8|0;k=e;c[g>>2]=d;h[j>>3]=+h[b>>3];h[k>>3]=+h[b+8>>3];switch(c[g>>2]|0){case 0:break;case 90:{h[b>>3]=+h[k>>3];h[b+8>>3]=-+h[j>>3];break}case 180:{h[b>>3]=+h[j>>3];h[b+8>>3]=-+h[k>>3];break}case 270:{h[b>>3]=+h[k>>3];h[b+8>>3]=+h[j>>3];break}default:{j=c[g>>2]|0;if((c[g>>2]|0)<0){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];FJ(a,f,0-j|0);i=e;return}k=c[g>>2]|0;if((j|0)>360){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];EJ(a,f,(k|0)%360|0);i=e;return}else{c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];IJ(a,f,k);i=e;return}}}c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];i=e;return}function FJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+48|0;f=e+16|0;g=e+32|0;j=e+8|0;k=e;c[g>>2]=d;h[j>>3]=+h[b>>3];h[k>>3]=+h[b+8>>3];switch(c[g>>2]|0){case 0:break;case 90:{h[b>>3]=-+h[k>>3];h[b+8>>3]=+h[j>>3];break}case 180:{h[b>>3]=+h[j>>3];h[b+8>>3]=-+h[k>>3];break}case 270:{h[b>>3]=+h[k>>3];h[b+8>>3]=+h[j>>3];break}default:{j=c[g>>2]|0;if((c[g>>2]|0)<0){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];EJ(a,f,0-j|0);i=e;return}k=c[g>>2]|0;if((j|0)>360){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];FJ(a,f,(k|0)%360|0);i=e;return}else{c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];IJ(a,f,360-k|0);i=e;return}}}c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];i=e;return}function GJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=e;h[f+16>>3]=+h[b+16+8>>3];h[f+16+8>>3]=+h[b+16>>3];h[f>>3]=+h[b+8>>3];h[f+8>>3]=+h[b>>3];h[f>>3]=+h[f>>3]+ +h[d>>3];b=f+8|0;h[b>>3]=+h[b>>3]+ +h[d+8>>3];b=f+16|0;h[b>>3]=+h[b>>3]+ +h[d>>3];b=f+16+8|0;h[b>>3]=+h[b>>3]+ +h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];c[a+16>>2]=c[f+16>>2];c[a+20>>2]=c[f+20>>2];c[a+24>>2]=c[f+24>>2];c[a+28>>2]=c[f+28>>2];i=e;return}function HJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0,g=0,j=0,k=0.0;d=i;i=i+32|0;e=d+24|0;f=d+16|0;g=d+8|0;j=d;h[f>>3]=+h[b>>3]-+h[a>>3];h[g>>3]=+h[b+8>>3]-+h[a+8>>3];h[j>>3]=(+h[c+8>>3]-+h[a+8>>3])*+h[f>>3]-(+h[c>>3]-+h[a>>3])*+h[g>>3];h[j>>3]=+h[j>>3]*+h[j>>3];if(+h[j>>3]<1.0e-10){h[e>>3]=0.0;k=+h[e>>3];i=d;return +k}else{h[e>>3]=+h[j>>3]/(+h[f>>3]*+h[f>>3]+ +h[g>>3]*+h[g>>3]);k=+h[e>>3];i=d;return +k}return +(0.0)}function IJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+32|0;f=e+16|0;g=e;c[f>>2]=d;if((c[f>>2]|0)!=(c[13789]|0)){i2(+(c[f>>2]|0)/6.283185307179586,33952,33960);c[13789]=c[f>>2]}h[g>>3]=+h[b>>3]*+h[4245]-+h[b+8>>3]*+h[4244];h[g+8>>3]=+h[b+8>>3]*+h[4245]+ +h[b>>3]*+h[4244];c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=e;return}function JJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+8|0;g=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;d=yA(c[g>>2]|0,c[j>>2]|0)|0;c[l>>2]=d;if(!d){i=e;return}d=c[l>>2]|0;c[f>>2]=m;if((l3(d,139001,f)|0)<1){i=e;return}h[c[k>>2]>>3]=+h[m>>3];i=e;return}function KJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0;e=i;i=i+32|0;f=e+8|0;g=e+20|0;j=e+24|0;k=e+16|0;l=e;m=e+12|0;c[g>>2]=b;a[j>>0]=d;d=bK(96)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]=d;d=yA(c[g>>2]|0,139005)|0;c[k>>2]=d;if(!((d|0)==0?(d=eb(139014)|0,c[k>>2]=d,(d|0)==0):0))rb(139026,c[k>>2]|0,1)|0;d=(OJ(c[g>>2]|0)|0)&255;a[(c[(c[g>>2]|0)+8>>2]|0)+115>>0]=d;if((c[13794]|0)==0?(c[13793]=yA(c[g>>2]|0,139037)|0,(c[13793]|0)==0):0)c[13793]=c[13792];d=c[g>>2]|0;n=+fO(d,qA(c[g>>2]|0,0,139047,0)|0,0.0,0.0);h[c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]>>3]=n;c[m>>2]=0;d=yA(c[g>>2]|0,139055)|0;c[k>>2]=d;do if(d){if((a[c[k>>2]>>0]|0)==(a[139063]|0)?(J3(c[k>>2]|0,139063)|0)==0:0){c[m>>2]=1;break}if((a[c[k>>2]>>0]|0)==(a[139066]|0)?(J3(c[k>>2]|0,139066)|0)==0:0){c[m>>2]=2;break}if((a[c[k>>2]>>0]|0)==(a[139069]|0)?(J3(c[k>>2]|0,139069)|0)==0:0)c[m>>2]=3}while(0);d=c[m>>2]<<2;if(a[j>>0]|0)c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]=d|c[m>>2];else c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]=d;d=c[g>>2]|0;h[l>>3]=+fO(d,qA(c[g>>2]|0,0,139072,0)|0,.25,.02);n=+h[l>>3]*72.0;c[(c[(c[g>>2]|0)+8>>2]|0)+248>>2]=~~(+h[l>>3]*72.0>=0.0?n+.5:n-.5);d=c[g>>2]|0;c[k>>2]=hO(d,qA(c[g>>2]|0,0,139080,0)|0,0)|0;if(c[k>>2]|0){d=c[k>>2]|0;c[f>>2]=l;if(l3(d,139001,f)|0){if(+h[l>>3]<.02)h[l>>3]=.02}else h[l>>3]=.5;if(U3(c[k>>2]|0,139088)|0)a[(c[(c[g>>2]|0)+8>>2]|0)+276>>0]=1}else h[l>>3]=.5;n=+h[l>>3]*72.0;c[(c[(c[g>>2]|0)+8>>2]|0)+252>>2]=~~(+h[l>>3]*72.0>=0.0?n+.5:n-.5);l=c[g>>2]|0;f=(eO(l,qA(c[g>>2]|0,0,139096,0)|0,0,0)|0)&255;a[(c[(c[g>>2]|0)+8>>2]|0)+243>>0]=f;f=c[g>>2]|0;c[k>>2]=hO(f,qA(c[g>>2]|0,0,139106,0)|0,0)|0;f=tO(c[k>>2]|0,55564,55580)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+244>>2]=f;PJ(c[g>>2]|0);f=QJ(c[g>>2]|0,139116,(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+64|0)|0;a[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+80>>0]=f;QJ(c[g>>2]|0,139121,(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+48|0)|0;f=kO(yA(c[g>>2]|0,139126)|0)|0;a[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+82>>0]=f;f=yA(c[g>>2]|0,139133)|0;c[k>>2]=f;do if(f){l=(u3(c[k>>2]|0)|0)==90&255;a[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+81>>0]=l}else{l=yA(c[g>>2]|0,139140)|0;c[k>>2]=l;if(!l){l=yA(c[g>>2]|0,139152)|0;c[k>>2]=l;if(!l)break;l=kO(c[k>>2]|0)|0;a[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+81>>0]=l;break}if((a[c[k>>2]>>0]|0)==108)o=1;else o=(a[c[k>>2]>>0]|0)==76;a[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+81>>0]=o&1}while(0);c[k>>2]=yA(c[g>>2]|0,139162)|0;c[13797]=tO(c[k>>2]|0,55596,55612)|0;c[k>>2]=yA(c[g>>2]|0,139174)|0;a[139e3]=kO(c[k>>2]|0)|0;c[13800]=0;c[13801]=0;h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3]=0.0;o=yA(c[g>>2]|0,139186)|0;c[k>>2]=o;if((o|0)!=0?(a[c[k>>2]>>0]|0)!=0:0)p=40;else p=38;if(((p|0)==38?(o=yA(c[g>>2]|0,139190)|0,c[k>>2]=o,(o|0)!=0):0)?(a[c[k>>2]>>0]|0)!=0:0)p=40;if((p|0)==40){n=+t3(c[k>>2]|0);h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3]=n}LJ(c[g>>2]|0);h[4248]=1.e+37;c[13809]=qA(c[g>>2]|0,0,139201,0)|0;c[13812]=qA(c[g>>2]|0,0,179043,0)|0;c[13813]=qA(c[g>>2]|0,0,143958,0)|0;c[13814]=qA(c[g>>2]|0,1,179057,0)|0;c[13815]=qA(c[g>>2]|0,1,179125,0)|0;c[13816]=qA(c[g>>2]|0,1,147662,0)|0;c[13817]=qA(c[g>>2]|0,1,178832,0)|0;c[13818]=qA(c[g>>2]|0,1,139210,0)|0;c[13834]=qA(c[g>>2]|0,1,179091,0)|0;c[13827]=qA(c[g>>2]|0,1,139220,0)|0;c[13828]=qA(c[g>>2]|0,1,139229,0)|0;c[13829]=qA(c[g>>2]|0,1,139238,0)|0;c[13831]=qA(c[g>>2]|0,1,147656,0)|0;if(!(c[13831]|0))c[13831]=qA(c[g>>2]|0,1,147656,143955)|0;c[13832]=qA(c[g>>2]|0,1,139248,0)|0;c[13835]=qA(c[g>>2]|0,1,139096,0)|0;c[13849]=qA(c[g>>2]|0,1,139255,0)|0;c[13838]=qA(c[g>>2]|0,1,139201,0)|0;c[13830]=qA(c[g>>2]|0,1,143958,0)|0;c[13836]=qA(c[g>>2]|0,1,179085,0)|0;c[13837]=qA(c[g>>2]|0,1,139264,0)|0;c[13840]=qA(c[g>>2]|0,1,139276,0)|0;c[13839]=qA(c[g>>2]|0,1,139140,0)|0;c[13841]=qA(c[g>>2]|0,1,139281,0)|0;c[13842]=qA(c[g>>2]|0,1,179033,0)|0;c[13843]=qA(c[g>>2]|0,1,174900,0)|0;c[13833]=qA(c[g>>2]|0,1,139292,0)|0;c[13844]=qA(c[g>>2]|0,1,139302,0)|0;c[13845]=qA(c[g>>2]|0,1,139308,0)|0;c[13846]=qA(c[g>>2]|0,1,139314,0)|0;c[13847]=qA(c[g>>2]|0,1,139322,0)|0;c[13848]=qA(c[g>>2]|0,1,139331,0)|0;c[13850]=qA(c[g>>2]|0,1,179043,0)|0;c[13851]=qA(c[g>>2]|0,2,139333,0)|0;c[13853]=qA(c[g>>2]|0,2,178832,0)|0;c[13854]=qA(c[g>>2]|0,2,139210,0)|0;c[13863]=qA(c[g>>2]|0,2,139220,0)|0;c[13864]=qA(c[g>>2]|0,2,139229,0)|0;c[13865]=qA(c[g>>2]|0,2,139238,0)|0;c[13866]=qA(c[g>>2]|0,2,147656,0)|0;c[13867]=qA(c[g>>2]|0,2,139248,0)|0;c[13876]=qA(c[g>>2]|0,2,139340,0)|0;c[13868]=qA(c[g>>2]|0,2,139351,0)|0;c[13879]=qA(c[g>>2]|0,2,139355,0)|0;c[13880]=qA(c[g>>2]|0,2,139365,0)|0;c[13881]=qA(c[g>>2]|0,2,139375,0)|0;c[13882]=qA(c[g>>2]|0,2,139385,0)|0;c[13883]=qA(c[g>>2]|0,2,139395,0)|0;c[13884]=qA(c[g>>2]|0,2,139409,0)|0;c[13885]=qA(c[g>>2]|0,2,139423,0)|0;c[13886]=qA(c[g>>2]|0,2,139438,0)|0;c[13887]=qA(c[g>>2]|0,2,139452,0)|0;c[13852]=qA(c[g>>2]|0,2,139463,0)|0;c[13871]=qA(c[g>>2]|0,2,139096,0)|0;c[13869]=qA(c[g>>2]|0,2,179091,0)|0;c[13870]=qA(c[g>>2]|0,2,139470,0)|0;c[13872]=qA(c[g>>2]|0,2,139479,0)|0;c[13873]=qA(c[g>>2]|0,2,139489,0)|0;c[13874]=qA(c[g>>2]|0,2,139302,0)|0;c[13875]=qA(c[g>>2]|0,2,139314,0)|0;c[13888]=qA(c[g>>2]|0,2,139500,0)|0;c[13889]=qA(c[g>>2]|0,2,139509,0)|0;c[13890]=qA(c[g>>2]|0,2,139255,0)|0;p=vH(c[g>>2]|0)|0;c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+88>>2]=p;p=yA(c[g>>2]|0,179069)|0;c[k>>2]=p;if(!p){i=e;return}if(!(a[c[k>>2]>>0]|0)){i=e;return}p=WJ(c[k>>2]|0,c[g>>2]|0)|0;c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+92>>2]=p;i=e;return}function LJ(b){b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+36|0;n=e;c[f>>2]=b;b=yA(c[f>>2]|0,147656)|0;c[g>>2]=b;if(!b){i=e;return}if(!(a[c[g>>2]>>0]|0)){i=e;return}b=(c[(c[(c[f>>2]|0)+48>>2]|0)+8>>2]|0)+113|0;a[b>>0]=d[b>>0]|8;b=c[f>>2]|0;o=c[g>>2]|0;p=($C(c[g>>2]|0)|0)!=0;g=c[f>>2]|0;q=+fO(g,qA(c[f>>2]|0,0,139220,0)|0,14.0,1.0);g=c[f>>2]|0;r=iO(g,qA(c[f>>2]|0,0,139229,0)|0,145601)|0;g=c[f>>2]|0;s=SJ(b,o,p?2:0,q,r,iO(g,qA(c[f>>2]|0,0,139238,0)|0,174917)|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]=s;c[j>>2]=yA(c[f>>2]|0,144073)|0;s=c[f>>2]|0;g=(s|0)!=(rC(c[f>>2]|0)|0);s=(c[j>>2]|0)!=0;do if(g){if(s?(a[c[j>>2]>>0]|0)==98:0){a[m>>0]=0;break}a[m>>0]=1}else{if(s?(a[c[j>>2]>>0]|0)==116:0){a[m>>0]=1;break}a[m>>0]=0}while(0);c[k>>2]=yA(c[f>>2]|0,139518)|0;do if(c[k>>2]|0){if((a[c[k>>2]>>0]|0)==108){a[m>>0]=a[m>>0]|2;break}if((a[c[k>>2]>>0]|0)==114)a[m>>0]=a[m>>0]|4}while(0);a[(c[(c[f>>2]|0)+8>>2]|0)+275>>0]=a[m>>0]|0;m=c[f>>2]|0;if((m|0)==(rC(c[f>>2]|0)|0)){i=e;return}m=(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)+24|0;c[n>>2]=c[m>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];c[n+12>>2]=c[m+12>>2];h[n>>3]=+h[n>>3]+16.0;m=n+8|0;h[m>>3]=+h[m>>3]+8.0;m=(c[(c[(rC(c[f>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;k=(a[(c[(c[f>>2]|0)+8>>2]|0)+275>>0]&1|0)!=0;if(m){if(k)c[l>>2]=1;else c[l>>2]=3;h[(c[(c[f>>2]|0)+8>>2]|0)+48+(c[l>>2]<<4)>>3]=+h[n+8>>3];h[(c[(c[f>>2]|0)+8>>2]|0)+48+(c[l>>2]<<4)+8>>3]=+h[n>>3];i=e;return}else{if(k)c[l>>2]=2;else c[l>>2]=0;k=(c[(c[f>>2]|0)+8>>2]|0)+48+(c[l>>2]<<4)|0;c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];i=e;return}}function MJ(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)!=0?(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+88>>2]|0)!=0:0)uS(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+88>>2]|0);if((c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)!=0?(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+92>>2]|0)!=0:0)O4(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+92>>2]|0);O4(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0);c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]=0;UJ(c[(c[(c[d>>2]|0)+8>>2]|0)+12>>2]|0);PC(c[d>>2]|0,0,175049);i=b;return}function NJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=b+8|0;f=b+4|0;c[e>>2]=a;switch(c[e>>2]|0){case 0:{c[f>>2]=139528;break}case 1:{c[f>>2]=139534;break}case 2:{c[f>>2]=139545;break}default:{c[d>>2]=c[e>>2];$z(1,139551,d)|0;c[f>>2]=139528}}i=b;return c[f>>2]|0}function OJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=b+12|0;f=b+8|0;g=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[g>>2]=iO(a,qA(c[e>>2]|0,0,139652,0)|0,139660)|0;if(((((((F3(c[g>>2]|0,139666)|0)!=0?(F3(c[g>>2]|0,139674)|0)!=0:0)?(F3(c[g>>2]|0,139681)|0)!=0:0)?(F3(c[g>>2]|0,139534)|0)!=0:0)?(F3(c[g>>2]|0,139684)|0)!=0:0)?(F3(c[g>>2]|0,139695)|0)!=0:0)?(F3(c[g>>2]|0,139705)|0)!=0:0){if((F3(c[g>>2]|0,139716)|0)!=0?(F3(c[g>>2]|0,139722)|0)!=0:0){if((F3(c[g>>2]|0,139660)|0)!=0?(F3(c[g>>2]|0,139727)|0)!=0:0){c[d>>2]=c[g>>2];$z(0,139732,d)|0;c[f>>2]=0;h=c[f>>2]|0;i=b;return h|0}c[f>>2]=0;h=c[f>>2]|0;i=b;return h|0}c[f>>2]=2;h=c[f>>2]|0;i=b;return h|0}c[f>>2]=1;h=c[f>>2]|0;i=b;return h|0}function PJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+12|0;f=d+8|0;g=d+16|0;j=d;c[e>>2]=b;b=yA(c[e>>2]|0,139610)|0;c[f>>2]=b;if(!b){i=d;return}b=a[c[f>>2]>>0]|0;a[g>>0]=b;if(!(b<<24>>24)){i=d;return}switch(a[g>>0]|0){case 97:{if((a[c[f>>2]>>0]|0)!=(a[139616]|0)){i=d;return}if(J3(c[f>>2]|0,139616)|0){i=d;return}c[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]=4;i=d;return}case 99:{if((a[c[f>>2]>>0]|0)!=(a[139621]|0)){i=d;return}if(J3(c[f>>2]|0,139621)|0){i=d;return}c[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]=3;i=d;return}case 101:{if((a[c[f>>2]>>0]|0)!=(a[139630]|0)){i=d;return}if(J3(c[f>>2]|0,139630)|0){i=d;return}c[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]=5;i=d;return}case 102:{if((a[c[f>>2]>>0]|0)!=(a[139637]|0)){i=d;return}if(J3(c[f>>2]|0,139637)|0){i=d;return}c[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]=2;i=d;return}default:{h[j>>3]=+t3(c[f>>2]|0);if(!(+h[j>>3]>0.0)){i=d;return}c[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]=1;h[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+16>>3]=+h[j>>3];i=d;return}}}function QJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0;f=i;i=i+64|0;g=f+32|0;j=f+16|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+44|0;o=f+40|0;p=f+8|0;q=f;r=f+61|0;s=f+60|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;a[r>>0]=0;a[s>>0]=0;e=yA(c[k>>2]|0,c[l>>2]|0)|0;c[n>>2]=e;if(!e){t=a[s>>0]|0;i=f;return t|0}e=c[n>>2]|0;c[j>>2]=p;c[j+4>>2]=q;c[j+8>>2]=r;c[o>>2]=l3(e,139594,j)|0;if((c[o>>2]|0)>1&+h[p>>3]>0.0&+h[q>>3]>0.0){u=+h[p>>3]*72.0;h[c[m>>2]>>3]=+(~~(+h[p>>3]*72.0>=0.0?u+.5:u-.5)|0);u=+h[q>>3]*72.0;h[(c[m>>2]|0)+8>>3]=+(~~(+h[q>>3]*72.0>=0.0?u+.5:u-.5)|0);if((a[r>>0]|0)!=33){t=a[s>>0]|0;i=f;return t|0}a[s>>0]=1;t=a[s>>0]|0;i=f;return t|0}a[r>>0]=0;q=c[n>>2]|0;c[g>>2]=p;c[g+4>>2]=r;c[o>>2]=l3(q,139604,g)|0;if(!((c[o>>2]|0)>0&+h[p>>3]>0.0)){t=a[s>>0]|0;i=f;return t|0}u=+h[p>>3]*72.0;v=+(~~(+h[p>>3]*72.0>=0.0?u+.5:u-.5)|0);h[c[m>>2]>>3]=v;h[(c[m>>2]|0)+8>>3]=v;if((a[r>>0]|0)!=33){t=a[s>>0]|0;i=f;return t|0}a[s>>0]=1;t=a[s>>0]|0;i=f;return t|0}function RJ(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f+25|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;p=f+24|0;c[g>>2]=b;c[j>>2]=e;c[o>>2]=c[c[j>>2]>>2];a[p>>0]=0;h[(c[j>>2]|0)+24+8>>3]=0.0;h[(c[j>>2]|0)+24>>3]=0.0;if(!(a[c[o>>2]>>0]|0)){i=f;return}c[n>>2]=0;c[m>>2]=0;c[l>>2]=c[o>>2];o=cK((N3(c[l>>2]|0)|0)+1|0)|0;c[n>>2]=o;c[m>>2]=o;a[c[m>>2]>>0]=0;while(1){o=c[l>>2]|0;c[l>>2]=o+1;e=a[o>>0]|0;a[k>>0]=e;if(!(e<<24>>24))break;a[p>>0]=a[k>>0]|0;if(((c[(c[j>>2]|0)+12>>2]|0)==2?161<=(d[p>>0]|0):0)?(d[p>>0]|0)<=254:0){e=a[k>>0]|0;o=c[n>>2]|0;c[n>>2]=o+1;a[o>>0]=e;e=c[l>>2]|0;c[l>>2]=e+1;a[k>>0]=a[e>>0]|0;e=a[k>>0]|0;o=c[n>>2]|0;c[n>>2]=o+1;a[o>>0]=e;if(a[k>>0]|0)continue;else break}if((a[k>>0]|0)!=92)if((a[k>>0]|0)==10){e=c[n>>2]|0;c[n>>2]=e+1;a[e>>0]=0;_J(c[g>>2]|0,c[j>>2]|0,c[m>>2]|0,110);c[m>>2]=c[n>>2];continue}else{e=a[k>>0]|0;o=c[n>>2]|0;c[n>>2]=o+1;a[o>>0]=e;continue}switch(a[c[l>>2]>>0]|0){case 114:case 108:case 110:{e=c[n>>2]|0;c[n>>2]=e+1;a[e>>0]=0;_J(c[g>>2]|0,c[j>>2]|0,c[m>>2]|0,a[c[l>>2]>>0]|0);c[m>>2]=c[n>>2];break}default:{e=a[c[l>>2]>>0]|0;o=c[n>>2]|0;c[n>>2]=o+1;a[o>>0]=e}}if(!(a[c[l>>2]>>0]|0))continue;c[l>>2]=(c[l>>2]|0)+1}if((c[m>>2]|0)!=(c[n>>2]|0)){l=c[n>>2]|0;c[n>>2]=l+1;a[l>>0]=0;_J(c[g>>2]|0,c[j>>2]|0,c[m>>2]|0,110)}m=(c[j>>2]|0)+40|0;g=(c[j>>2]|0)+24|0;c[m>>2]=c[g>>2];c[m+4>>2]=c[g+4>>2];c[m+8>>2]=c[g+8>>2];c[m+12>>2]=c[g+12>>2];i=f;return}function SJ(b,e,f,g,j,k){b=b|0;e=e|0;f=f|0;g=+g;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;l=i;i=i+80|0;m=l+24|0;n=l+16|0;o=l+8|0;p=l+76|0;q=l+72|0;r=l+68|0;s=l;t=l+64|0;u=l+60|0;v=l+56|0;w=l+52|0;x=l+48|0;y=l+44|0;z=l+40|0;A=l+36|0;c[p>>2]=b;c[q>>2]=e;c[r>>2]=f;h[s>>3]=g;c[t>>2]=j;c[u>>2]=k;c[v>>2]=bK(88)|0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;c[z>>2]=0;switch(BC(c[p>>2]|0)|0){case 0:{c[x>>2]=c[p>>2];c[w>>2]=c[(c[x>>2]|0)+48>>2];break}case 1:{c[y>>2]=c[p>>2];c[w>>2]=rC(qC(c[y>>2]|0)|0)|0;break}case 2:{c[z>>2]=c[p>>2];k=c[z>>2]|0;c[w>>2]=rC(qC(c[((c[c[z>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)|0)|0;break}default:{}}c[(c[v>>2]|0)+4>>2]=c[t>>2];c[(c[v>>2]|0)+8>>2]=c[u>>2];h[(c[v>>2]|0)+16>>3]=+h[s>>3];c[(c[v>>2]|0)+12>>2]=d[(c[(c[w>>2]|0)+8>>2]|0)+115>>0];if(c[r>>2]&4){s=M3(c[q>>2]|0)|0;c[c[v>>2]>>2]=s;if(!(c[r>>2]&2)){B=c[v>>2]|0;i=l;return B|0}a[(c[v>>2]|0)+82>>0]=1;B=c[v>>2]|0;i=l;return B|0}if((c[r>>2]|0)!=2){if(c[r>>2]|0)La(139845,139861,166,139870);r=$J(c[q>>2]|0,c[p>>2]|0,0)|0;c[c[v>>2]>>2]=r;r=c[c[v>>2]>>2]|0;if((c[(c[v>>2]|0)+12>>2]|0)==1)c[A>>2]=KO(r)|0;else c[A>>2]=JO(r,c[w>>2]|0)|0;O4(c[c[v>>2]>>2]|0);c[c[v>>2]>>2]=c[A>>2];RJ(c[(c[(c[w>>2]|0)+8>>2]|0)+144>>2]|0,c[v>>2]|0);B=c[v>>2]|0;i=l;return B|0}A=M3(c[q>>2]|0)|0;c[c[v>>2]>>2]=A;a[(c[v>>2]|0)+82>>0]=1;if(!(HT(c[p>>2]|0,c[v>>2]|0)|0)){B=c[v>>2]|0;i=l;return B|0}switch(BC(c[p>>2]|0)|0){case 0:{c[o>>2]=wB(c[x>>2]|0)|0;$z(3,139775,o)|0;B=c[v>>2]|0;i=l;return B|0}case 1:{c[n>>2]=wB(c[y>>2]|0)|0;$z(3,139797,n)|0;B=c[v>>2]|0;i=l;return B|0}case 2:{n=c[z>>2]|0;y=wB(c[((c[c[z>>2]>>2]&3|0)==3?n:n+32|0)+28>>2]|0)|0;n=(nB(c[w>>2]|0)|0)!=0;w=c[z>>2]|0;o=wB(c[((c[c[z>>2]>>2]&3|0)==2?w:w+-32|0)+28>>2]|0)|0;c[m>>2]=y;c[m+4>>2]=n?175316:178535;c[m+8>>2]=o;$z(3,139818,m)|0;B=c[v>>2]|0;i=l;return B|0}default:{B=c[v>>2]|0;i=l;return B|0}}return 0}function TJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=c[e>>2];if(!(c[e>>2]|0)){i=d;return}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;if((c[g>>2]|0)==0?(c[c[h>>2]>>2]|0)!=0:0)O4(c[c[h>>2]>>2]|0);if((c[(c[h>>2]|0)+8>>2]|0)!=0?(c[(c[h>>2]|0)+12>>2]|0)!=0:0)Bb[c[(c[h>>2]|0)+12>>2]&127](c[(c[h>>2]|0)+8>>2]|0);c[h>>2]=(c[h>>2]|0)+56;c[g>>2]=(c[g>>2]|0)+1}O4(c[e>>2]|0);i=d;return}function UJ(d){d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;if(!(c[f>>2]|0)){i=e;return}O4(c[c[f>>2]>>2]|0);d=(c[f>>2]|0)+72|0;if(a[(c[f>>2]|0)+82>>0]|0){if(c[d>>2]|0)zT(c[(c[f>>2]|0)+72>>2]|0,1)}else TJ(c[d>>2]|0,b[(c[f>>2]|0)+72+4>>1]|0);O4(c[f>>2]|0);i=e;return}function VJ(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+64|0;j=g+16|0;k=g+52|0;l=g+48|0;m=g+44|0;n=g+40|0;o=g+36|0;p=g;q=g+32|0;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[(c[k>>2]|0)+16>>2];c[q>>2]=c[(c[n>>2]|0)+12>>2];c[(c[n>>2]|0)+12>>2]=c[l>>2];if(a[(c[m>>2]|0)+82>>0]|0){vT(c[k>>2]|0,c[(c[m>>2]|0)+72>>2]|0,c[m>>2]|0);c[(c[n>>2]|0)+12>>2]=c[q>>2];i=g;return}if((b[(c[m>>2]|0)+72+4>>1]|0)<1){i=g;return}lR(c[k>>2]|0,0);oR(c[k>>2]|0,c[(c[m>>2]|0)+8>>2]|0);switch(a[(c[m>>2]|0)+80>>0]|0){case 116:{h[p+8>>3]=+h[(c[m>>2]|0)+56+8>>3]+ +h[(c[m>>2]|0)+40+8>>3]/2.0-+h[(c[m>>2]|0)+16>>3];break}case 98:{h[p+8>>3]=+h[(c[m>>2]|0)+56+8>>3]-+h[(c[m>>2]|0)+40+8>>3]/2.0+ +h[(c[m>>2]|0)+24+8>>3]-+h[(c[m>>2]|0)+16>>3];break}default:h[p+8>>3]=+h[(c[m>>2]|0)+56+8>>3]+ +h[(c[m>>2]|0)+24+8>>3]/2.0-+h[(c[m>>2]|0)+16>>3]}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(b[(c[m>>2]|0)+72+4>>1]|0))break;switch(a[(c[(c[m>>2]|0)+72>>2]|0)+((c[o>>2]|0)*56|0)+48>>0]|0){case 108:{h[p>>3]=+h[(c[m>>2]|0)+56>>3]-+h[(c[m>>2]|0)+40>>3]/2.0;break}case 114:{h[p>>3]=+h[(c[m>>2]|0)+56>>3]+ +h[(c[m>>2]|0)+40>>3]/2.0;break}default:h[p>>3]=+h[(c[m>>2]|0)+56>>3]}l=c[k>>2]|0;f=(c[(c[m>>2]|0)+72>>2]|0)+((c[o>>2]|0)*56|0)|0;c[j>>2]=c[p>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];nR(l,j,f);f=p+8|0;h[f>>3]=+h[f>>3]-+h[(c[(c[m>>2]|0)+72>>2]|0)+((c[o>>2]|0)*56|0)+32+8>>3];c[o>>2]=(c[o>>2]|0)+1}mR(c[k>>2]|0);c[(c[n>>2]|0)+12>>2]=c[q>>2];i=g;return}function WJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=$J(c[e>>2]|0,c[f>>2]|0,1)|0;i=d;return b|0}function XJ(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=YJ(c[d>>2]|0,0)|0;i=b;return a|0}function YJ(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+24|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=b;a[h>>0]=e;c[l>>2]=0;c[n>>2]=0;if(!(c[13907]|0)){c[13908]=64;c[13907]=cK(c[13908]|0)|0}c[j>>2]=c[13907];while(1){if(!(c[g>>2]|0)){o=29;break}if(!(a[c[g>>2]>>0]|0)){o=29;break}if((c[n>>2]|0)>((c[13908]|0)-8|0)){c[13908]=c[13908]<<1;c[13907]=eK(c[13907]|0,c[13908]|0)|0;c[j>>2]=(c[13907]|0)+(c[n>>2]|0)}do if((a[c[g>>2]>>0]|0)==38){if((d[h>>0]|0)==0?(aK(c[g>>2]|0)|0)!=0:0){o=12;break}c[k>>2]=139881;c[m>>2]=5}else o=12;while(0);do if((o|0)==12){o=0;if((a[c[g>>2]>>0]|0)==60){c[k>>2]=139887;c[m>>2]=4;break}if((a[c[g>>2]>>0]|0)==62){c[k>>2]=139892;c[m>>2]=4;break}if((a[c[g>>2]>>0]|0)==45){c[k>>2]=139897;c[m>>2]=5;break}if(((c[l>>2]|0)!=0?(a[c[g>>2]>>0]|0)==32:0)?(a[c[l>>2]>>0]|0)==32:0){c[k>>2]=139903;c[m>>2]=6;break}if((a[c[g>>2]>>0]|0)==34){c[k>>2]=139910;c[m>>2]=6;break}if((a[c[g>>2]>>0]|0)==39){c[k>>2]=139917;c[m>>2]=5;break}else{c[k>>2]=c[g>>2];c[m>>2]=1;break}}while(0);while(1){e=c[m>>2]|0;c[m>>2]=e+-1;if(!e)break;e=c[k>>2]|0;c[k>>2]=e+1;b=a[e>>0]|0;e=c[j>>2]|0;c[j>>2]=e+1;a[e>>0]=b;c[n>>2]=(c[n>>2]|0)+1}c[l>>2]=c[g>>2];c[g>>2]=(c[g>>2]|0)+1}if((o|0)==29){a[c[j>>2]>>0]=0;i=f;return c[13907]|0}return 0}function ZJ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[j>>2]=0;if(!(c[13909]|0)){c[13910]=64;c[13909]=cK(c[13910]|0)|0}c[f>>2]=c[13909];while(1){if(!(c[e>>2]|0)){k=23;break}if(!(a[c[e>>2]>>0]|0)){k=23;break}if((c[j>>2]|0)>((c[13910]|0)-8|0)){c[13910]=c[13910]<<1;c[13909]=eK(c[13909]|0,c[13910]|0)|0;c[f>>2]=(c[13909]|0)+(c[j>>2]|0)}if((a[c[e>>2]>>0]|0)==38?(aK(c[e>>2]|0)|0)==0:0){c[g>>2]=139881;c[h>>2]=5}else k=11;do if((k|0)==11){k=0;if((a[c[e>>2]>>0]|0)==60){c[g>>2]=139887;c[h>>2]=4;break}if((a[c[e>>2]>>0]|0)==62){c[g>>2]=139892;c[h>>2]=4;break}if((a[c[e>>2]>>0]|0)==34){c[g>>2]=139910;c[h>>2]=6;break}if((a[c[e>>2]>>0]|0)==39){c[g>>2]=139917;c[h>>2]=5;break}else{c[g>>2]=c[e>>2];c[h>>2]=1;break}}while(0);while(1){b=c[h>>2]|0;c[h>>2]=b+-1;if(!b)break;b=c[g>>2]|0;c[g>>2]=b+1;l=a[b>>0]|0;b=c[f>>2]|0;c[f>>2]=b+1;a[b>>0]=l;c[j>>2]=(c[j>>2]|0)+1}c[e>>2]=(c[e>>2]|0)+1}if((k|0)==23){a[c[f>>2]>>0]=0;i=d;return c[13909]|0}return 0}function _J(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0,D=0.0;j=i;i=i+64|0;k=j+48|0;l=j+44|0;m=j+40|0;n=j+52|0;o=j+16|0;p=j+36|0;q=j+32|0;r=j;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;a[n>>0]=g;c[q>>2]=(b[(c[l>>2]|0)+72+4>>1]|0)+1;if(c[(c[l>>2]|0)+72>>2]|0)s=dK(c[(c[l>>2]|0)+72>>2]|0,(c[q>>2]|0)+1|0,56,c[q>>2]|0)|0;else s=bK(((c[q>>2]|0)+1|0)*56|0)|0;c[(c[l>>2]|0)+72>>2]=s;c[p>>2]=(c[(c[l>>2]|0)+72>>2]|0)+((b[(c[l>>2]|0)+72+4>>1]|0)*56|0);c[c[p>>2]>>2]=c[m>>2];a[(c[p>>2]|0)+48>>0]=a[n>>0]|0;if((c[m>>2]|0)!=0?(a[c[m>>2]>>0]|0)!=0:0){c[8512]=c[(c[l>>2]|0)+4>>2];h[4258]=+h[(c[l>>2]|0)+16>>3];m=Hb[c[c[(c[k>>2]|0)+144>>2]>>2]&63](c[(c[k>>2]|0)+144>>2]|0,34048,1)|0;c[(c[p>>2]|0)+4>>2]=m;SN(r,c[k>>2]|0,c[p>>2]|0);c[o>>2]=c[r>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2]}else{h[o>>3]=0.0;t=+(~~(+h[(c[l>>2]|0)+16>>3]*1.2)|0);h[o+8>>3]=t;h[(c[p>>2]|0)+32+8>>3]=t}p=(c[l>>2]|0)+72+4|0;b[p>>1]=(b[p>>1]|0)+1<<16>>16;if(+h[(c[l>>2]|0)+24>>3]>+h[o>>3]){u=+h[(c[l>>2]|0)+24>>3];v=c[l>>2]|0;w=v+24|0;h[w>>3]=u;x=o+8|0;y=+h[x>>3];z=c[l>>2]|0;A=z+24|0;B=A+8|0;C=+h[B>>3];D=C+y;h[B>>3]=D;i=j;return}else{u=+h[o>>3];v=c[l>>2]|0;w=v+24|0;h[w>>3]=u;x=o+8|0;y=+h[x>>3];z=c[l>>2]|0;A=z+24|0;B=A+8|0;C=+h[B>>3];D=C+y;h[B>>3]=D;i=j;return}}function $J(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;f=i;i=i+160|0;g=f+140|0;h=f+136|0;j=f+132|0;k=f+144|0;l=f+128|0;m=f+124|0;n=f+120|0;o=f+116|0;p=f+112|0;q=f+108|0;r=f+104|0;s=f+100|0;t=f+96|0;u=f+92|0;v=f+88|0;w=f+84|0;x=f+80|0;y=f+76|0;z=f+72|0;A=f+68|0;B=f+64|0;C=f+60|0;D=f+56|0;E=f+52|0;F=f+48|0;G=f+44|0;H=f+40|0;I=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[p>>2]=178518;c[q>>2]=178518;c[r>>2]=139923;c[s>>2]=143955;c[t>>2]=139926;c[u>>2]=139929;c[v>>2]=139932;c[w>>2]=139935;c[x>>2]=2;c[y>>2]=2;c[z>>2]=2;c[A>>2]=2;c[B>>2]=2;c[C>>2]=2;c[D>>2]=0;c[E>>2]=0;c[F>>2]=0;c[G>>2]=0;switch(BC(c[h>>2]|0)|0){case 0:{c[r>>2]=wB(c[h>>2]|0)|0;c[x>>2]=N3(c[r>>2]|0)|0;c[H>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+12>>2];if((c[H>>2]|0)!=0?(c[w>>2]=c[c[H>>2]>>2],(c[g>>2]|0)!=0):0)c[C>>2]=N3(c[w>>2]|0)|0;break}case 1:{c[r>>2]=wB(qC(c[h>>2]|0)|0)|0;c[x>>2]=N3(c[r>>2]|0)|0;c[s>>2]=wB(c[h>>2]|0)|0;c[y>>2]=N3(c[s>>2]|0)|0;c[H>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+104>>2];if((c[H>>2]|0)!=0?(c[w>>2]=c[c[H>>2]>>2],(c[g>>2]|0)!=0):0)c[C>>2]=N3(c[w>>2]|0)|0;break}case 2:{c[G>>2]=1;e=c[h>>2]|0;c[r>>2]=wB(rC(qC(c[((c[c[h>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)|0)|0)|0;c[x>>2]=N3(c[r>>2]|0)|0;e=c[h>>2]|0;c[v>>2]=wB(c[((c[c[h>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)|0;c[B>>2]=N3(c[v>>2]|0)|0;e=I;d=(c[(c[h>>2]|0)+8>>2]|0)+16|0;b=e+40|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(b|0));J=c[I+36>>2]|0;c[p>>2]=J;if(J)c[D>>2]=N3(c[p>>2]|0)|0;J=c[h>>2]|0;c[u>>2]=wB(c[((c[c[h>>2]>>2]&3|0)==2?J:J+-32|0)+28>>2]|0)|0;c[A>>2]=N3(c[u>>2]|0)|0;e=I;d=(c[(c[h>>2]|0)+8>>2]|0)+56|0;b=e+40|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(b|0));d=c[I+36>>2]|0;c[q>>2]=d;if(d)c[E>>2]=N3(c[q>>2]|0)|0;c[A>>2]=N3(c[u>>2]|0)|0;c[H>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+96>>2];if((c[H>>2]|0)!=0?(c[w>>2]=c[c[H>>2]>>2],(c[g>>2]|0)!=0):0)c[C>>2]=N3(c[w>>2]|0)|0;H=c[h>>2]|0;if(nB(rC(qC(c[((c[c[h>>2]>>2]&3|0)==3?H:H+32|0)+28>>2]|0)|0)|0)|0)c[t>>2]=175316;else c[t>>2]=178535;c[z>>2]=(c[B>>2]|0)+((c[D>>2]|0)!=0?(c[D>>2]|0)+1|0:0)+2+(c[A>>2]|0)+((c[E>>2]|0)!=0?(c[E>>2]|0)+1|0:0);break}default:{}}c[l>>2]=c[g>>2];a:while(1){H=c[l>>2]|0;c[l>>2]=H+1;h=a[H>>0]|0;a[k>>0]=h;if(!(h<<24>>24))break;if((a[k>>0]|0)!=92){c[F>>2]=(c[F>>2]|0)+1;continue}h=c[l>>2]|0;c[l>>2]=h+1;H=a[h>>0]|0;a[k>>0]=H;switch(H<<24>>24|0){case 71:{c[F>>2]=(c[F>>2]|0)+(c[x>>2]|0);continue a;break}case 78:{c[F>>2]=(c[F>>2]|0)+(c[y>>2]|0);continue a;break}case 69:{c[F>>2]=(c[F>>2]|0)+(c[z>>2]|0);continue a;break}case 72:{c[F>>2]=(c[F>>2]|0)+(c[A>>2]|0);continue a;break}case 84:{c[F>>2]=(c[F>>2]|0)+(c[B>>2]|0);continue a;break}case 76:{c[F>>2]=(c[F>>2]|0)+(c[C>>2]|0);continue a;break}case 92:{if(c[j>>2]|0){c[F>>2]=(c[F>>2]|0)+1;continue a}break}default:{}}c[F>>2]=(c[F>>2]|0)+2}c[o>>2]=cK((c[F>>2]|0)+1|0)|0;c[l>>2]=c[g>>2];c[m>>2]=c[o>>2];b:while(1){g=c[l>>2]|0;c[l>>2]=g+1;F=a[g>>0]|0;a[k>>0]=F;if(!(F<<24>>24))break;if((a[k>>0]|0)!=92){F=a[k>>0]|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g>>0]=F;continue}F=c[l>>2]|0;c[l>>2]=F+1;g=a[F>>0]|0;a[k>>0]=g;switch(g<<24>>24|0){case 71:{c[n>>2]=c[r>>2];while(1){g=c[n>>2]|0;c[n>>2]=g+1;F=a[g>>0]|0;a[c[m>>2]>>0]=F;if(!(F<<24>>24))continue b;c[m>>2]=(c[m>>2]|0)+1}break}case 78:{c[n>>2]=c[s>>2];while(1){F=c[n>>2]|0;c[n>>2]=F+1;g=a[F>>0]|0;a[c[m>>2]>>0]=g;if(!(g<<24>>24))continue b;c[m>>2]=(c[m>>2]|0)+1}break}case 69:{if(!(c[G>>2]|0))continue b;c[n>>2]=c[v>>2];while(1){g=c[n>>2]|0;c[n>>2]=g+1;F=a[g>>0]|0;a[c[m>>2]>>0]=F;if(!(F<<24>>24))break;c[m>>2]=(c[m>>2]|0)+1}c:do if(c[D>>2]|0){F=c[m>>2]|0;c[m>>2]=F+1;a[F>>0]=58;c[n>>2]=c[p>>2];while(1){F=c[n>>2]|0;c[n>>2]=F+1;g=a[F>>0]|0;a[c[m>>2]>>0]=g;if(!(g<<24>>24))break c;c[m>>2]=(c[m>>2]|0)+1}}while(0);c[n>>2]=c[t>>2];while(1){g=c[n>>2]|0;c[n>>2]=g+1;F=a[g>>0]|0;a[c[m>>2]>>0]=F;if(!(F<<24>>24))break;c[m>>2]=(c[m>>2]|0)+1}c[n>>2]=c[u>>2];while(1){F=c[n>>2]|0;c[n>>2]=F+1;g=a[F>>0]|0;a[c[m>>2]>>0]=g;if(!(g<<24>>24))break;c[m>>2]=(c[m>>2]|0)+1}if(!(c[E>>2]|0))continue b;g=c[m>>2]|0;c[m>>2]=g+1;a[g>>0]=58;c[n>>2]=c[q>>2];while(1){g=c[n>>2]|0;c[n>>2]=g+1;F=a[g>>0]|0;a[c[m>>2]>>0]=F;if(!(F<<24>>24))continue b;c[m>>2]=(c[m>>2]|0)+1}break}case 84:{c[n>>2]=c[v>>2];while(1){F=c[n>>2]|0;c[n>>2]=F+1;g=a[F>>0]|0;a[c[m>>2]>>0]=g;if(!(g<<24>>24))continue b;c[m>>2]=(c[m>>2]|0)+1}break}case 72:{c[n>>2]=c[u>>2];while(1){g=c[n>>2]|0;c[n>>2]=g+1;F=a[g>>0]|0;a[c[m>>2]>>0]=F;if(!(F<<24>>24))continue b;c[m>>2]=(c[m>>2]|0)+1}break}case 76:{c[n>>2]=c[w>>2];while(1){F=c[n>>2]|0;c[n>>2]=F+1;g=a[F>>0]|0;a[c[m>>2]>>0]=g;if(!(g<<24>>24))continue b;c[m>>2]=(c[m>>2]|0)+1}break}case 92:{if(c[j>>2]|0){g=c[m>>2]|0;c[m>>2]=g+1;a[g>>0]=92;continue b}break}default:{}}g=c[m>>2]|0;c[m>>2]=g+1;a[g>>0]=92;g=a[k>>0]|0;F=c[m>>2]|0;c[m>>2]=F+1;a[F>>0]=g}k=c[m>>2]|0;c[m>>2]=k+1;a[k>>0]=0;i=f;return c[o>>2]|0}function aK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;c[f>>2]=(c[f>>2]|0)+1;a:do if((a[c[f>>2]>>0]|0)==35){c[f>>2]=(c[f>>2]|0)+1;if((a[c[f>>2]>>0]|0)!=120?(a[c[f>>2]>>0]|0)!=88:0)while(1){if((a[c[f>>2]>>0]|0)<48)break a;if((a[c[f>>2]>>0]|0)>57)break a;c[f>>2]=(c[f>>2]|0)+1}c[f>>2]=(c[f>>2]|0)+1;while(1){if(!((a[c[f>>2]>>0]|0)>=48?(a[c[f>>2]>>0]|0)<=57:0))g=7;do if((g|0)==7){g=0;if((a[c[f>>2]>>0]|0)>=97?(a[c[f>>2]>>0]|0)<=102:0)break;if((a[c[f>>2]>>0]|0)<65)break a;if((a[c[f>>2]>>0]|0)>70)break a}while(0);c[f>>2]=(c[f>>2]|0)+1}}else while(1){if(!((a[c[f>>2]>>0]|0)>=97?(a[c[f>>2]>>0]|0)<=122:0)){if((a[c[f>>2]>>0]|0)<65)break a;if((a[c[f>>2]>>0]|0)>90)break a}c[f>>2]=(c[f>>2]|0)+1}while(0);if((a[c[f>>2]>>0]|0)==59){c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}return 0}function bK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}else{c[f>>2]=cK(c[e>>2]|0)|0;$4(c[f>>2]|0,0,c[e>>2]|0)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}return 0}function cK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=N4(c[e>>2]|0)|0;if(!(c[f>>2]|0))Y2(c[24742]|0,149343,b)|0;c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function dK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=Q4(c[h>>2]|0,_(c[j>>2]|0,c[k>>2]|0)|0)|0;if((c[m>>2]|0)==0&(c[j>>2]|0)!=0){Y2(c[24742]|0,149343,f)|0;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}if((c[l>>2]|0)>>>0<(c[j>>2]|0)>>>0){h=(c[m>>2]|0)+(_(c[l>>2]|0,c[k>>2]|0)|0)|0;$4(h|0,0,_((c[j>>2]|0)-(c[l>>2]|0)|0,c[k>>2]|0)|0)|0}c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}function eK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;c[e>>2]=a;c[f>>2]=b;c[g>>2]=Q4(c[e>>2]|0,c[f>>2]|0)|0;if(!((c[g>>2]|0)==0&(c[f>>2]|0)!=0)){h=c[g>>2]|0;i=d;return h|0}Y2(c[24742]|0,149343,d)|0;h=c[g>>2]|0;i=d;return h|0}function fK(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0;j=i;i=i+64|0;k=j+32|0;l=j+24|0;m=j;p=4;q=N4(40)|0;c[q>>2]=0;r=j+60|0;s=j+56|0;if(a[138998]|0){n=0;wa(59,b|0,r|0,s|0);t=n;n=0;if((t|0)!=0&(o|0)!=0){u=Y4(c[t>>2]|0,q|0,p|0)|0;if(!u)Pa(t|0,o|0);C=o}else u=-1;if((u|0)!=1){u=c[24742]|0;t=c[r>>2]|0;r=c[s>>2]|0;n=0;c[m>>2]=139938;c[m+4>>2]=t;c[m+8>>2]=r;c[m+12>>2]=f;c[m+16>>2]=e;ka(36,u|0,139956,m|0)|0;m=n;n=0;if((m|0)!=0&(o|0)!=0){v=Y4(c[m>>2]|0,q|0,p|0)|0;if(!v)Pa(m|0,o|0);C=o}else v=-1;if((v|0)!=1){n=0;xa(1);v=n;n=0;if((v|0)!=0&(o|0)!=0){w=Y4(c[v>>2]|0,q|0,p|0)|0;if(!w)Pa(v|0,o|0);C=o}else w=-1;if((w|0)!=1)x=6;else{y=C;z=0}}else{y=C;z=0}}else{y=C;z=0}}else x=6;do if((x|0)==6){n=0;w=ia(27,b|0)|0;v=n;n=0;if((v|0)!=0&(o|0)!=0){A=Y4(c[v>>2]|0,q|0,p|0)|0;if(!A)Pa(v|0,o|0);C=o}else A=-1;if((A|0)!=1){if(!w){n=0;xa(2);w=n;n=0;if((w|0)!=0&(o|0)!=0){B=Y4(c[w>>2]|0,q|0,p|0)|0;if(!B)Pa(w|0,o|0);C=o}else B=-1;if((B|0)==1){y=C;z=0;break}}if((f|0)<=0){n=0;ea(101,b|0);w=n;n=0;if((w|0)!=0&(o|0)!=0){D=Y4(c[w>>2]|0,q|0,p|0)|0;if(!D)Pa(w|0,o|0);C=o}else D=-1;if((D|0)==1){y=C;z=0;break}E=0;O4(q|0);i=j;return E|0}if((g|0)>=0)c[13911]=g;else c[13911]=30;q=W4(55648,1,q|0,p|0)|0;p=C;n=0;w=n;n=0;if((w|0)!=0&(o|0)!=0){F=Y4(c[w>>2]|0,q|0,p|0)|0;if(!F)Pa(w|0,o|0);C=o}else F=-1;if((F|0)!=1){y=0;z=0}else{y=C;z=0}}else{y=C;z=0}}while(0);a:while(1){if(y){x=19;break}n=0;F=ta(2)|0;g=n;n=0;if((g|0)!=0&(o|0)!=0){G=Y4(c[g>>2]|0,q|0,p|0)|0;if(!G)Pa(g|0,o|0);C=o}else G=-1;if((G|0)==1){H=z;y=C;z=H;continue}if(F){n=0;ea(101,b|0);F=n;n=0;if((F|0)!=0&(o|0)!=0){I=Y4(c[F>>2]|0,q|0,p|0)|0;if(!I)Pa(F|0,o|0);C=o}else I=-1;if((I|0)==1){H=z;y=C;z=H;continue}else{x=23;break}}else J=z;while(1){n=0;F=ta(3)|0;g=n;n=0;if((g|0)!=0&(o|0)!=0){K=Y4(c[g>>2]|0,q|0,p|0)|0;if(!K)Pa(g|0,o|0);C=o}else K=-1;if((K|0)==1){y=C;z=J;continue a}if(!F){L=J;break}n=0;g=ia(28,F|0)|0;D=n;n=0;if((D|0)!=0&(o|0)!=0){M=Y4(c[D>>2]|0,q|0,p|0)|0;if(!M)Pa(D|0,o|0);C=o}else M=-1;if((M|0)==1){y=C;z=J;continue a}n=0;ga(20,F|0,g|0);g=n;n=0;if((g|0)!=0&(o|0)!=0){N=Y4(c[g>>2]|0,q|0,p|0)|0;if(!N)Pa(g|0,o|0);C=o}else N=-1;if((N|0)==1){y=C;z=J;continue a}g=J+1|0;if((d[138998]|0)!=0?((g|0)%100|0|0)==0:0){if(((g|0)%1e3|0|0)==100){n=0;ra(93,139938,c[24742]|0)|0;F=n;n=0;if((F|0)!=0&(o|0)!=0){O=Y4(c[F>>2]|0,q|0,p|0)|0;if(!O)Pa(F|0,o|0);C=o}else O=-1;if((O|0)==1){y=C;z=g;continue a}}F=c[24742]|0;n=0;c[l>>2]=g;ka(36,F|0,14e4,l|0)|0;F=n;n=0;if((F|0)!=0&(o|0)!=0){P=Y4(c[F>>2]|0,q|0,p|0)|0;if(!P)Pa(F|0,o|0);C=o}else P=-1;if((P|0)==1){y=C;z=g;continue a}if(!((g|0)%1e3|0)){n=0;ra(94,10,c[24742]|0)|0;F=n;n=0;if((F|0)!=0&(o|0)!=0){Q=Y4(c[F>>2]|0,q|0,p|0)|0;if(!Q)Pa(F|0,o|0);C=o}else Q=-1;if((Q|0)==1){y=C;z=g;continue a}}}if((g|0)>=(f|0)){L=g;break}else J=g}switch(e|0){case 1:{n=0;xa(3);g=n;n=0;if((g|0)!=0&(o|0)!=0){R=Y4(c[g>>2]|0,q|0,p|0)|0;if(!R)Pa(g|0,o|0);C=o}else R=-1;if((R|0)==1){y=C;z=L;continue a}break}case 2:{n=0;xa(4);g=n;n=0;if((g|0)!=0&(o|0)!=0){S=Y4(c[g>>2]|0,q|0,p|0)|0;if(!S)Pa(g|0,o|0);C=o}else S=-1;if((S|0)==1){y=C;z=L;continue a}break}default:{n=0;xa(5);g=n;n=0;if((g|0)!=0&(o|0)!=0){T=Y4(c[g>>2]|0,q|0,p|0)|0;if(!T)Pa(g|0,o|0);C=o}else T=-1;if((T|0)==1){y=C;z=L;continue a}n=0;ea(101,c[13951]|0);g=n;n=0;if((g|0)!=0&(o|0)!=0){U=Y4(c[g>>2]|0,q|0,p|0)|0;if(!U)Pa(g|0,o|0);C=o}else U=-1;if((U|0)==1){y=C;z=L;continue a}}}if(!(a[138998]|0))break;if((L|0)>=100){n=0;ra(94,10,c[24742]|0)|0;g=n;n=0;if((g|0)!=0&(o|0)!=0){V=Y4(c[g>>2]|0,q|0,p|0)|0;if(!V)Pa(g|0,o|0);C=o}else V=-1;if((V|0)==1){y=C;z=L;continue}}g=c[24742]|0;F=c[13952]|0;D=c[13953]|0;n=0;W=+sa(1);B=n;n=0;if((B|0)!=0&(o|0)!=0){X=Y4(c[B>>2]|0,q|0,p|0)|0;if(!X)Pa(B|0,o|0);C=o}else X=-1;if((X|0)==1){y=C;z=L;continue}n=0;c[k>>2]=139938;c[k+4>>2]=F;c[k+8>>2]=D;c[k+12>>2]=L;h[k+16>>3]=W;ka(36,g|0,140004,k|0)|0;g=n;n=0;if((g|0)!=0&(o|0)!=0){Y=Y4(c[g>>2]|0,q|0,p|0)|0;if(!Y)Pa(g|0,o|0);C=o}else Y=-1;if((Y|0)==1){y=C;z=L}else{x=52;break}}if((x|0)==19){E=2;O4(q|0);i=j;return E|0}else if((x|0)==23){E=1;O4(q|0);i=j;return E|0}E=0;O4(q|0);i=j;return E|0}function gK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=yA(c[f>>2]|0,140042)|0;c[j>>2]=d;if(d)c[k>>2]=u3(c[j>>2]|0)|0;else c[k>>2]=30;j=fK(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;i=e;return j|0}function hK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[l>>2]=0;c[k>>2]=0;c[m>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+192>>2];while(1){o=c[k>>2]|0;if(!(c[m>>2]|0))break;c[k>>2]=o+1;c[j>>2]=0;while(1){f=c[(c[(c[(c[m>>2]|0)+8>>2]|0)+180>>2]|0)+(c[j>>2]<<2)>>2]|0;c[n>>2]=f;if(!f)break;c[l>>2]=(c[l>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1}c[m>>2]=c[(c[(c[m>>2]|0)+8>>2]|0)+164>>2]}c[c[g>>2]>>2]=o;c[c[h>>2]>>2]=c[l>>2];i=e;return}function iK(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=b;c[13951]=c[f>>2];c[13962]=0;c[13953]=0;c[13952]=0;c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[j>>2]|0))break;a[(c[(c[j>>2]|0)+8>>2]|0)+157>>0]=0;c[13952]=(c[13952]|0)+1;c[g>>2]=0;while(1){b=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]|0)+(c[g>>2]<<2)>>2]|0;c[k>>2]=b;if(!b)break;c[13953]=(c[13953]|0)+1;c[g>>2]=(c[g>>2]|0)+1}c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+164>>2]}if(c[13963]|0)l=eK(c[13963]|0,c[13952]<<2)|0;else l=cK(c[13952]<<2)|0;c[13963]=l;c[13964]=0;if(c[13956]|0)m=eK(c[13956]|0,c[13952]<<2)|0;else m=cK(c[13952]<<2)|0;c[13956]=m;c[13957]=0;c[h>>2]=1;c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[j>>2]|0))break;c[(c[(c[j>>2]|0)+8>>2]|0)+292>>2]=0;c[g>>2]=0;while(1){f=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2]|0)+(c[g>>2]<<2)>>2]|0;c[k>>2]=f;if(!f)break;f=(c[(c[j>>2]|0)+8>>2]|0)+292|0;c[f>>2]=(c[f>>2]|0)+1;c[(c[(c[k>>2]|0)+8>>2]|0)+160>>2]=0;c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2]=-1;if((c[h>>2]|0)!=0?(f=c[k>>2]|0,m=c[k>>2]|0,((c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[k>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0)<(e[(c[(c[k>>2]|0)+8>>2]|0)+170>>1]|0|0)):0)c[h>>2]=0;c[g>>2]=(c[g>>2]|0)+1}m=bK((c[g>>2]|0)+1<<2)|0;c[(c[(c[j>>2]|0)+8>>2]|0)+264>>2]=m;c[(c[(c[j>>2]|0)+8>>2]|0)+264+4>>2]=0;c[g>>2]=0;while(1){m=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]|0)+(c[g>>2]<<2)>>2]|0;c[k>>2]=m;n=(c[g>>2]|0)+1|0;if(!m)break;c[g>>2]=n}m=bK(n<<2)|0;c[(c[(c[j>>2]|0)+8>>2]|0)+272>>2]=m;c[(c[(c[j>>2]|0)+8>>2]|0)+272+4>>2]=0;c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+164>>2]}i=d;return c[h>>2]|0}function jK(){var a=0,b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;a=i;i=i+48|0;b=a+8|0;d=a;f=a+32|0;g=a+28|0;h=a+24|0;j=a+20|0;k=a+16|0;c[h>>2]=aO(c[13952]|0)|0;c[g>>2]=0;c[j>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!(c[j>>2]|0))break;if(!(c[(c[(c[j>>2]|0)+8>>2]|0)+292>>2]|0))cO(c[h>>2]|0,c[j>>2]|0);c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+164>>2]}a:while(1){l=dO(c[h>>2]|0)|0;c[j>>2]=l;if(!l)break;c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]=0;c[g>>2]=(c[g>>2]|0)+1;c[f>>2]=0;while(1){l=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2]|0)+(c[f>>2]<<2)>>2]|0;c[k>>2]=l;if(!l)break;l=c[k>>2]|0;if((c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0)>((c[(c[(c[((c[c[k>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)+(e[(c[(c[k>>2]|0)+8>>2]|0)+170>>1]|0)|0))m=c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0;else{l=c[k>>2]|0;m=(c[(c[(c[((c[c[k>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)+(e[(c[(c[k>>2]|0)+8>>2]|0)+170>>1]|0)|0}c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]=m;c[f>>2]=(c[f>>2]|0)+1}c[f>>2]=0;while(1){l=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]|0)+(c[f>>2]<<2)>>2]|0;c[k>>2]=l;if(!l)continue a;l=c[k>>2]|0;n=(c[(c[((c[c[k>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+292|0;l=(c[n>>2]|0)+-1|0;c[n>>2]=l;if((l|0)<=0){l=c[k>>2]|0;cO(c[h>>2]|0,c[((c[c[k>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)}c[f>>2]=(c[f>>2]|0)+1}}if((c[g>>2]|0)==(c[13952]|0)){o=c[h>>2]|0;bO(o);i=a;return}$z(1,140195,d)|0;c[j>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!(c[j>>2]|0))break;if(c[(c[(c[j>>2]|0)+8>>2]|0)+292>>2]|0){d=wB(c[j>>2]|0)|0;g=c[(c[(c[j>>2]|0)+8>>2]|0)+292>>2]|0;c[b>>2]=d;c[b+4>>2]=g;$z(3,140217,b)|0}c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+164>>2]}o=c[h>>2]|0;bO(o);i=a;return}function kK(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[d+4>>2]=b;c[e>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!(c[e>>2]|0))break;if(c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]|0);if(c[(c[(c[e>>2]|0)+8>>2]|0)+272>>2]|0)O4(c[(c[(c[e>>2]|0)+8>>2]|0)+272>>2]|0);a[(c[(c[e>>2]|0)+8>>2]|0)+157>>0]=0;c[e>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]}i=d;return}function lK(){var a=0,b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;a=i;i=i+32|0;b=a+20|0;d=a+16|0;f=a+12|0;g=a+8|0;h=a+4|0;j=a;if((c[13952]|0)<=1){c[b>>2]=0;k=c[b>>2]|0;i=a;return k|0}a:while(1){l=yK()|0;if((l|0)>=(c[13952]|0)){m=23;break}c[h>>2]=0;c[g>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;c[d>>2]=0;while(1){l=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0)+(c[d>>2]<<2)>>2]|0;c[j>>2]=l;if(!l)break;do if(((c[(c[(c[j>>2]|0)+8>>2]|0)+164>>2]|0)>=0|0)==0?(zK(c[j>>2]|0)|0)!=0:0){if((c[h>>2]|0)!=0?(l=c[j>>2]|0,n=c[j>>2]|0,o=c[h>>2]|0,p=c[h>>2]|0,((c[(c[(c[((c[c[j>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[j>>2]>>2]&3|0)==3?n:n+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[j>>2]|0)+8>>2]|0)+170>>1]|0)|0)>=((c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?o:o+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?p:p+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]|0)|0)):0)break;c[h>>2]=c[j>>2]}while(0);c[d>>2]=(c[d>>2]|0)+1}c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}if(!(c[h>>2]|0)){m=22;break}p=c[h>>2]|0;o=c[h>>2]|0;c[f>>2]=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?o:o+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]|0);if(!(c[f>>2]|0))continue;o=zK(c[h>>2]|0)|0;p=c[h>>2]|0;if((o|0)==(c[((c[c[h>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0))c[f>>2]=0-(c[f>>2]|0);c[d>>2]=0;while(1){if((c[d>>2]|0)>=(c[13964]|0))continue a;p=(c[(c[(c[13963]|0)+(c[d>>2]<<2)>>2]|0)+8>>2]|0)+232|0;c[p>>2]=(c[p>>2]|0)+(c[f>>2]|0);c[d>>2]=(c[d>>2]|0)+1}}if((m|0)==22){c[b>>2]=1;k=c[b>>2]|0;i=a;return k|0}else if((m|0)==23){AK();c[b>>2]=0;k=c[b>>2]|0;i=a;return k|0}return 0}function mK(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+32|0;b=a+16|0;d=a+12|0;e=a+8|0;f=a+4|0;g=a;c[e>>2]=0;c[g>>2]=0;c[f>>2]=c[13962];while(1){if((c[13962]|0)>=(c[13957]|0))break;h=c[(c[13956]|0)+(c[13962]<<2)>>2]|0;c[d>>2]=h;if((c[(c[h+8>>2]|0)+160>>2]|0)<0){if(c[e>>2]|0){if((c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+160>>2]|0))c[e>>2]=c[d>>2]}else c[e>>2]=c[(c[13956]|0)+(c[13962]<<2)>>2];h=(c[g>>2]|0)+1|0;c[g>>2]=h;if((h|0)>=(c[13911]|0)){j=9;break}}c[13962]=(c[13962]|0)+1}if((j|0)==9){c[b>>2]=c[e>>2];k=c[b>>2]|0;i=a;return k|0}a:do if((c[f>>2]|0)>0){c[13962]=0;while(1){if((c[13962]|0)>=(c[f>>2]|0))break a;j=c[(c[13956]|0)+(c[13962]<<2)>>2]|0;c[d>>2]=j;if((c[(c[j+8>>2]|0)+160>>2]|0)<0){if(c[e>>2]|0){if((c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+160>>2]|0))c[e>>2]=c[d>>2]}else c[e>>2]=c[(c[13956]|0)+(c[13962]<<2)>>2];j=(c[g>>2]|0)+1|0;c[g>>2]=j;if((j|0)>=(c[13911]|0))break}c[13962]=(c[13962]|0)+1}c[b>>2]=c[e>>2];k=c[b>>2]|0;i=a;return k|0}while(0);c[b>>2]=c[e>>2];k=c[b>>2]|0;i=a;return k|0}function nK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;a=c[d>>2]|0;g=c[d>>2]|0;h=c[c[d>>2]>>2]&3;if((c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<(c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)){g=c[d>>2]|0;c[e>>2]=c[((h|0)==3?g:g+32|0)+28>>2];c[f>>2]=0}else{g=c[d>>2]|0;c[e>>2]=c[((h|0)==2?g:g+-32|0)+28>>2];c[f>>2]=1}c[13958]=0;c[13959]=2147483647;c[13960]=c[(c[(c[e>>2]|0)+8>>2]|0)+284>>2];c[13961]=c[(c[(c[e>>2]|0)+8>>2]|0)+288>>2];g=c[e>>2]|0;if(c[f>>2]|0){wK(g);j=c[13958]|0;i=b;return j|0}else{xK(g);j=c[13958]|0;i=b;return j|0}return 0}function oK(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;f=d;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;c[g>>2]=a;c[h>>2]=b;b=c[h>>2]|0;a=c[h>>2]|0;c[k>>2]=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]|0);do if((c[k>>2]|0)>0){a=c[g>>2]|0;b=c[g>>2]|0;c[m>>2]=(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+264+4>>2]|0)+(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+272+4>>2]|0);b=c[c[g>>2]>>2]&3;if((c[m>>2]|0)==1){a=c[g>>2]|0;sK(c[((b|0)==3?a:a+32|0)+28>>2]|0,c[k>>2]|0);break}a=c[g>>2]|0;n=c[g>>2]|0;c[m>>2]=(c[(c[(c[((b|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+264+4>>2]|0)+(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0)+8>>2]|0)+272+4>>2]|0);n=c[c[g>>2]>>2]&3;if((c[m>>2]|0)==1){a=c[g>>2]|0;sK(c[((n|0)==2?a:a+-32|0)+28>>2]|0,0-(c[k>>2]|0)|0);break}a=c[g>>2]|0;b=c[g>>2]|0;o=c[c[g>>2]>>2]&3;if((c[(c[(c[((n|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)){b=c[g>>2]|0;sK(c[((o|0)==3?b:b+32|0)+28>>2]|0,c[k>>2]|0);break}else{b=c[g>>2]|0;sK(c[((o|0)==2?b:b+-32|0)+28>>2]|0,0-(c[k>>2]|0)|0);break}}while(0);c[j>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+160>>2];k=c[h>>2]|0;m=c[h>>2]|0;c[l>>2]=tK(c[((c[c[h>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0,c[((c[c[h>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0,c[j>>2]|0,1)|0;m=c[h>>2]|0;k=c[h>>2]|0;b=tK(c[((c[c[h>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0,c[((c[c[h>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0,c[j>>2]|0,0)|0;if((b|0)!=(c[l>>2]|0)){$z(1,140053,f)|0;Pa(55648,1)}else{c[(c[(c[h>>2]|0)+8>>2]|0)+160>>2]=0-(c[j>>2]|0);c[(c[(c[g>>2]|0)+8>>2]|0)+160>>2]=0;uK(c[g>>2]|0,c[h>>2]|0);vK(c[l>>2]|0,c[(c[(c[l>>2]|0)+8>>2]|0)+280>>2]|0,c[(c[(c[l>>2]|0)+8>>2]|0)+284>>2]|0)|0;i=d;return}}function pK(){var b=0,d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+48|0;d=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;rK();c[l>>2]=bK((c[13955]|0)+1<<2)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>(c[13955]|0))break;c[(c[l>>2]|0)+(c[g>>2]<<2)>>2]=0;c[g>>2]=(c[g>>2]|0)+1}c[d>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!(c[d>>2]|0))break;if(!(a[(c[(c[d>>2]|0)+8>>2]|0)+156>>0]|0)){o=(c[l>>2]|0)+(c[(c[(c[d>>2]|0)+8>>2]|0)+232>>2]<<2)|0;c[o>>2]=(c[o>>2]|0)+1}c[d>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+164>>2]}c[d>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!(c[d>>2]|0))break;if(!(a[(c[(c[d>>2]|0)+8>>2]|0)+156>>0]|0)){c[n>>2]=0;c[m>>2]=0;c[h>>2]=0;c[j>>2]=c[13955];c[g>>2]=0;while(1){o=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]|0)+(c[g>>2]<<2)>>2]|0;c[f>>2]=o;if(!o)break;c[m>>2]=(c[m>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+156>>2]|0);o=c[f>>2]|0;if((c[h>>2]|0)>((c[(c[(c[((c[c[f>>2]>>2]&3|0)==3?o:o+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)+(e[(c[(c[f>>2]|0)+8>>2]|0)+170>>1]|0)|0))p=c[h>>2]|0;else{o=c[f>>2]|0;p=(c[(c[(c[((c[c[f>>2]>>2]&3|0)==3?o:o+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)+(e[(c[(c[f>>2]|0)+8>>2]|0)+170>>1]|0)|0}c[h>>2]=p;c[g>>2]=(c[g>>2]|0)+1}c[g>>2]=0;while(1){o=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0)+(c[g>>2]<<2)>>2]|0;c[f>>2]=o;if(!o)break;c[n>>2]=(c[n>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+156>>2]|0);o=c[f>>2]|0;if((c[j>>2]|0)<((c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?o:o+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[f>>2]|0)+8>>2]|0)+170>>1]|0)|0))q=c[j>>2]|0;else{o=c[f>>2]|0;q=(c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?o:o+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[f>>2]|0)+8>>2]|0)+170>>1]|0)|0}c[j>>2]=q;c[g>>2]=(c[g>>2]|0)+1}if((c[h>>2]|0)<0)c[h>>2]=0;if((c[m>>2]|0)==(c[n>>2]|0)){c[k>>2]=c[h>>2];c[g>>2]=(c[h>>2]|0)+1;while(1){if((c[g>>2]|0)>(c[j>>2]|0))break;if((c[(c[l>>2]|0)+(c[g>>2]<<2)>>2]|0)<(c[(c[l>>2]|0)+(c[k>>2]<<2)>>2]|0))c[k>>2]=c[g>>2];c[g>>2]=(c[g>>2]|0)+1}o=(c[l>>2]|0)+(c[(c[(c[d>>2]|0)+8>>2]|0)+232>>2]<<2)|0;c[o>>2]=(c[o>>2]|0)+-1;o=(c[l>>2]|0)+(c[k>>2]<<2)|0;c[o>>2]=(c[o>>2]|0)+1;c[(c[(c[d>>2]|0)+8>>2]|0)+232>>2]=c[k>>2]}if(c[(c[(c[d>>2]|0)+8>>2]|0)+264>>2]|0)O4(c[(c[(c[d>>2]|0)+8>>2]|0)+264>>2]|0);if(c[(c[(c[d>>2]|0)+8>>2]|0)+272>>2]|0)O4(c[(c[(c[d>>2]|0)+8>>2]|0)+272>>2]|0);a[(c[(c[d>>2]|0)+8>>2]|0)+157>>0]=0}c[d>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+164>>2]}O4(c[l>>2]|0);i=b;return}function qK(){var a=0,b=0,d=0,f=0,g=0,h=0,j=0,k=0;a=i;i=i+16|0;b=a+12|0;d=a+8|0;f=a+4|0;g=a;c[b>>2]=0;while(1){if((c[b>>2]|0)>=(c[13957]|0))break;c[f>>2]=c[(c[13956]|0)+(c[b>>2]<<2)>>2];do if(((c[(c[(c[f>>2]|0)+8>>2]|0)+160>>2]|0)==0?(c[g>>2]=nK(c[f>>2]|0)|0,(c[g>>2]|0)!=0):0)?(h=c[g>>2]|0,j=c[g>>2]|0,c[d>>2]=(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[g>>2]|0)+8>>2]|0)+170>>1]|0),(c[d>>2]|0)>1):0){j=c[f>>2]|0;h=c[f>>2]|0;k=c[c[f>>2]>>2]&3;if((c[(c[(c[((c[c[f>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<(c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)){h=c[f>>2]|0;sK(c[((k|0)==3?h:h+32|0)+28>>2]|0,(c[d>>2]|0)/2|0);break}else{h=c[f>>2]|0;sK(c[((k|0)==2?h:h+-32|0)+28>>2]|0,(0-(c[d>>2]|0)|0)/2|0);break}}while(0);c[b>>2]=(c[b>>2]|0)+1}kK(c[13951]|0);i=a;return}function rK(){var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;c[13954]=2147483647;c[13955]=-2147483647;c[d>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!(c[d>>2]|0))break;if(!(a[(c[(c[d>>2]|0)+8>>2]|0)+156>>0]|0)){if((c[13954]|0)<(c[(c[(c[d>>2]|0)+8>>2]|0)+232>>2]|0))e=c[13954]|0;else e=c[(c[(c[d>>2]|0)+8>>2]|0)+232>>2]|0;c[13954]=e;if((c[13955]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+232>>2]|0))f=c[13955]|0;else f=c[(c[(c[d>>2]|0)+8>>2]|0)+232>>2]|0;c[13955]=f}c[d>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+164>>2]}if(!(c[13954]|0)){i=b;return}c[d>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){g=c[13954]|0;if(!(c[d>>2]|0))break;f=(c[(c[d>>2]|0)+8>>2]|0)+232|0;c[f>>2]=(c[f>>2]|0)-g;c[d>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+164>>2]}c[13955]=(c[13955]|0)-g;c[13954]=0;i=b;return}function sK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;b=(c[(c[e>>2]|0)+8>>2]|0)+232|0;c[b>>2]=(c[b>>2]|0)-(c[f>>2]|0);c[g>>2]=0;while(1){b=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+272>>2]|0)+(c[g>>2]<<2)>>2]|0;c[h>>2]=b;if(!b)break;if((c[h>>2]|0)!=(c[(c[(c[e>>2]|0)+8>>2]|0)+280>>2]|0)){b=c[h>>2]|0;sK(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,c[f>>2]|0)}c[g>>2]=(c[g>>2]|0)+1}c[g>>2]=0;while(1){b=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]|0)+(c[g>>2]<<2)>>2]|0;c[h>>2]=b;if(!b)break;if((c[h>>2]|0)!=(c[(c[(c[e>>2]|0)+8>>2]|0)+280>>2]|0)){b=c[h>>2]|0;sK(c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0,c[f>>2]|0)}c[g>>2]=(c[g>>2]|0)+1}i=d;return}function tK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;while(1){if((c[(c[(c[g>>2]|0)+8>>2]|0)+284>>2]|0)<=(c[(c[(c[h>>2]|0)+8>>2]|0)+288>>2]|0))n=(c[(c[(c[h>>2]|0)+8>>2]|0)+288>>2]|0)<=(c[(c[(c[g>>2]|0)+8>>2]|0)+288>>2]|0);else n=0;o=c[g>>2]|0;if(!(n^1))break;c[l>>2]=c[(c[o+8>>2]|0)+280>>2];e=c[l>>2]|0;d=c[k>>2]|0;if((c[g>>2]|0)==(c[((c[c[l>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0))c[m>>2]=d;else c[m>>2]=((d|0)!=0^1)&1;d=c[j>>2]|0;e=(c[(c[l>>2]|0)+8>>2]|0)+160|0;b=c[e>>2]|0;if(c[m>>2]|0)c[e>>2]=b+d;else c[e>>2]=b-d;d=c[l>>2]|0;b=c[l>>2]|0;e=c[c[l>>2]>>2]&3;if((c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)>(c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)){b=c[l>>2]|0;c[g>>2]=c[((e|0)==3?b:b+32|0)+28>>2];continue}else{b=c[l>>2]|0;c[g>>2]=c[((e|0)==2?b:b+-32|0)+28>>2];continue}}i=f;return o|0}function uK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2];c[(c[13956]|0)+(c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]<<2)>>2]=c[f>>2];c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]=-1;b=c[e>>2]|0;c[j>>2]=c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2];b=(c[(c[j>>2]|0)+8>>2]|0)+272+4|0;a=(c[b>>2]|0)+-1|0;c[b>>2]=a;c[g>>2]=a;c[h>>2]=0;while(1){if((c[h>>2]|0)>(c[g>>2]|0))break;if((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+272>>2]|0)+(c[h>>2]<<2)>>2]|0)==(c[e>>2]|0))break;c[h>>2]=(c[h>>2]|0)+1}c[(c[(c[(c[j>>2]|0)+8>>2]|0)+272>>2]|0)+(c[h>>2]<<2)>>2]=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+272>>2]|0)+(c[g>>2]<<2)>>2];c[(c[(c[(c[j>>2]|0)+8>>2]|0)+272>>2]|0)+(c[g>>2]<<2)>>2]=0;a=c[e>>2]|0;c[j>>2]=c[((c[c[e>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2];a=(c[(c[j>>2]|0)+8>>2]|0)+264+4|0;b=(c[a>>2]|0)+-1|0;c[a>>2]=b;c[g>>2]=b;c[h>>2]=0;while(1){if((c[h>>2]|0)>(c[g>>2]|0))break;if((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+264>>2]|0)+(c[h>>2]<<2)>>2]|0)==(c[e>>2]|0))break;c[h>>2]=(c[h>>2]|0)+1}c[(c[(c[(c[j>>2]|0)+8>>2]|0)+264>>2]|0)+(c[h>>2]<<2)>>2]=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+264>>2]|0)+(c[g>>2]<<2)>>2];c[(c[(c[(c[j>>2]|0)+8>>2]|0)+264>>2]|0)+(c[g>>2]<<2)>>2]=0;g=c[f>>2]|0;c[j>>2]=c[((c[c[f>>2]>>2]&3|0)==3?g:g+32|0)+28>>2];g=c[f>>2]|0;h=(c[(c[j>>2]|0)+8>>2]|0)+272+4|0;e=c[h>>2]|0;c[h>>2]=e+1;c[(c[(c[(c[j>>2]|0)+8>>2]|0)+272>>2]|0)+(e<<2)>>2]=g;c[(c[(c[(c[j>>2]|0)+8>>2]|0)+272>>2]|0)+(c[(c[(c[j>>2]|0)+8>>2]|0)+272+4>>2]<<2)>>2]=0;g=c[f>>2]|0;c[j>>2]=c[((c[c[f>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2];g=c[f>>2]|0;f=(c[(c[j>>2]|0)+8>>2]|0)+264+4|0;e=c[f>>2]|0;c[f>>2]=e+1;c[(c[(c[(c[j>>2]|0)+8>>2]|0)+264>>2]|0)+(e<<2)>>2]=g;c[(c[(c[(c[j>>2]|0)+8>>2]|0)+264>>2]|0)+(c[(c[(c[j>>2]|0)+8>>2]|0)+264+4>>2]<<2)>>2]=0;i=d;return}function vK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[l>>2]=c[h>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+280>>2]=c[g>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+284>>2]=c[h>>2];c[k>>2]=0;while(1){h=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+272>>2]|0)+(c[k>>2]<<2)>>2]|0;c[j>>2]=h;if(!h)break;if((c[j>>2]|0)!=(c[g>>2]|0)){h=c[j>>2]|0;c[l>>2]=vK(c[((c[c[j>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0,c[j>>2]|0,c[l>>2]|0)|0}c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){h=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+264>>2]|0)+(c[k>>2]<<2)>>2]|0;c[j>>2]=h;if(!h)break;if((c[j>>2]|0)!=(c[g>>2]|0)){h=c[j>>2]|0;c[l>>2]=vK(c[((c[c[j>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0,c[j>>2]|0,c[l>>2]|0)|0}c[k>>2]=(c[k>>2]|0)+1}c[(c[(c[f>>2]|0)+8>>2]|0)+288>>2]=c[l>>2];i=e;return (c[l>>2]|0)+1|0}function wK(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[f>>2]=0;while(1){a=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0)+(c[f>>2]<<2)>>2]|0;c[h>>2]=a;if(!a)break;do if(!((c[(c[(c[h>>2]|0)+8>>2]|0)+164>>2]|0)>=0|0)){a=c[h>>2]|0;if((c[13960]|0)<=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)?(a=c[h>>2]|0,(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<=(c[13961]|0)):0)break;a=c[h>>2]|0;j=c[h>>2]|0;c[g>>2]=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]|0);if((c[13958]|0)==0?1:(c[g>>2]|0)<(c[13959]|0)){c[13958]=c[h>>2];c[13959]=c[g>>2]}}else{j=c[h>>2]|0;if((c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<(c[(c[(c[d>>2]|0)+8>>2]|0)+288>>2]|0)){j=c[h>>2]|0;wK(c[((c[c[h>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)}}while(0);c[f>>2]=(c[f>>2]|0)+1}c[f>>2]=0;while(1){g=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+264>>2]|0)+(c[f>>2]<<2)>>2]|0;c[h>>2]=g;if(!((g|0)!=0?(c[13959]|0)>0:0))break;g=c[h>>2]|0;if((c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<(c[(c[(c[d>>2]|0)+8>>2]|0)+288>>2]|0)){g=c[h>>2]|0;wK(c[((c[c[h>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)}c[f>>2]=(c[f>>2]|0)+1}i=b;return}function xK(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[f>>2]=0;while(1){a=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]|0)+(c[f>>2]<<2)>>2]|0;c[h>>2]=a;if(!a)break;do if(!((c[(c[(c[h>>2]|0)+8>>2]|0)+164>>2]|0)>=0|0)){a=c[h>>2]|0;if((c[13960]|0)<=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)?(a=c[h>>2]|0,(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<=(c[13961]|0)):0)break;a=c[h>>2]|0;j=c[h>>2]|0;c[g>>2]=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]|0);if((c[13958]|0)==0?1:(c[g>>2]|0)<(c[13959]|0)){c[13958]=c[h>>2];c[13959]=c[g>>2]}}else{j=c[h>>2]|0;if((c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<(c[(c[(c[d>>2]|0)+8>>2]|0)+288>>2]|0)){j=c[h>>2]|0;xK(c[((c[c[h>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)}}while(0);c[f>>2]=(c[f>>2]|0)+1}c[f>>2]=0;while(1){g=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+272>>2]|0)+(c[f>>2]<<2)>>2]|0;c[h>>2]=g;if(!((g|0)!=0?(c[13959]|0)>0:0))break;g=c[h>>2]|0;if((c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+288>>2]|0)<(c[(c[(c[d>>2]|0)+8>>2]|0)+288>>2]|0)){g=c[h>>2]|0;xK(c[((c[c[h>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)}c[f>>2]=(c[f>>2]|0)+1}i=b;return}function yK(){var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!(c[e>>2]|0))break;a[(c[(c[e>>2]|0)+8>>2]|0)+157>>0]=0;c[c[(c[(c[e>>2]|0)+8>>2]|0)+272>>2]>>2]=0;c[c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]>>2]=0;c[(c[(c[e>>2]|0)+8>>2]|0)+272+4>>2]=0;c[(c[(c[e>>2]|0)+8>>2]|0)+264+4>>2]=0;c[e>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]}c[d>>2]=0;while(1){if((c[d>>2]|0)>=(c[13957]|0))break;c[(c[(c[(c[13956]|0)+(c[d>>2]<<2)>>2]|0)+8>>2]|0)+164>>2]=-1;c[d>>2]=(c[d>>2]|0)+1}c[13957]=0;c[13964]=0;c[e>>2]=c[(c[(c[13951]|0)+8>>2]|0)+192>>2];while(1){if(!((c[e>>2]|0)!=0?(c[13957]|0)==0:0))break;EK(c[e>>2]|0)|0;c[e>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]}i=b;return c[13964]|0}function zK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;b=c[f>>2]|0;g=c[f>>2]|0;h=a[(c[(c[((c[c[f>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0;if(a[(c[(c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0){if(!(h<<24>>24)){b=c[f>>2]|0;c[e>>2]=c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2];j=c[e>>2]|0;i=d;return j|0}}else if(h<<24>>24){h=c[f>>2]|0;c[e>>2]=c[((c[c[f>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2];j=c[e>>2]|0;i=d;return j|0}c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}function AK(){vK(c[(c[(c[13951]|0)+8>>2]|0)+192>>2]|0,0,1)|0;BK(c[(c[(c[13951]|0)+8>>2]|0)+192>>2]|0,0);return}function BK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;while(1){b=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+272>>2]|0)+(c[g>>2]<<2)>>2]|0;c[h>>2]=b;if(!b)break;if((c[h>>2]|0)!=(c[f>>2]|0)){b=c[h>>2]|0;BK(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,c[h>>2]|0)}c[g>>2]=(c[g>>2]|0)+1}c[g>>2]=0;while(1){b=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]|0)+(c[g>>2]<<2)>>2]|0;c[h>>2]=b;if(!b)break;if((c[h>>2]|0)!=(c[f>>2]|0)){b=c[h>>2]|0;BK(c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0,c[h>>2]|0)}c[g>>2]=(c[g>>2]|0)+1}if(!(c[f>>2]|0)){i=d;return}CK(c[f>>2]|0);i=d;return}function CK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;a=c[d>>2]|0;k=c[c[d>>2]>>2]&3;if((c[(c[(c[((c[c[d>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+280>>2]|0)==(c[d>>2]|0)){a=c[d>>2]|0;c[e>>2]=c[((k|0)==3?a:a+32|0)+28>>2];c[j>>2]=1}else{a=c[d>>2]|0;c[e>>2]=c[((k|0)==2?a:a+-32|0)+28>>2];c[j>>2]=-1}c[h>>2]=0;c[g>>2]=0;while(1){a=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)+(c[g>>2]<<2)>>2]|0;c[f>>2]=a;if(!a)break;a=DK(c[f>>2]|0,c[e>>2]|0,c[j>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+a;c[g>>2]=(c[g>>2]|0)+1}c[g>>2]=0;while(1){a=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]|0)+(c[g>>2]<<2)>>2]|0;c[f>>2]=a;if(!a)break;a=DK(c[f>>2]|0,c[e>>2]|0,c[j>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+a;c[g>>2]=(c[g>>2]|0)+1}c[(c[(c[d>>2]|0)+8>>2]|0)+160>>2]=c[h>>2];i=b;return}function DK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=c[f>>2]|0;b=c[c[f>>2]>>2]&3;if((c[((c[c[f>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)==(c[g>>2]|0)){d=c[f>>2]|0;c[j>>2]=c[((b|0)==2?d:d+-32|0)+28>>2]}else{d=c[f>>2]|0;c[j>>2]=c[((b|0)==3?d:d+32|0)+28>>2]}if((c[(c[(c[g>>2]|0)+8>>2]|0)+284>>2]|0)<=(c[(c[(c[j>>2]|0)+8>>2]|0)+288>>2]|0)?(c[(c[(c[j>>2]|0)+8>>2]|0)+288>>2]|0)<=(c[(c[(c[g>>2]|0)+8>>2]|0)+288>>2]|0):0){c[m>>2]=0;if((c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0)>=0)c[l>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+160>>2];else c[l>>2]=0;c[l>>2]=(c[l>>2]|0)-(c[(c[(c[f>>2]|0)+8>>2]|0)+156>>2]|0)}else{c[m>>2]=1;c[l>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+156>>2]}j=c[c[f>>2]>>2]&3;do if((c[h>>2]|0)>0){d=c[f>>2]|0;if((c[((j|0)==2?d:d+-32|0)+28>>2]|0)==(c[g>>2]|0)){c[k>>2]=1;break}else{c[k>>2]=-1;break}}else{d=c[f>>2]|0;if((c[((j|0)==3?d:d+32|0)+28>>2]|0)==(c[g>>2]|0)){c[k>>2]=1;break}else{c[k>>2]=-1;break}}while(0);if(c[m>>2]|0)c[k>>2]=0-(c[k>>2]|0);if((c[k>>2]|0)>=0){n=c[l>>2]|0;i=e;return n|0}c[l>>2]=0-(c[l>>2]|0);n=c[l>>2]|0;i=e;return n|0}function EK(b){b=b|0;var d=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[g>>2]=b;c[h>>2]=0;while(1){b=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0)+(c[h>>2]<<2)>>2]|0;c[j>>2]=b;if(!b)break;b=c[j>>2]|0;if((a[(c[(c[((c[c[j>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0)==0?(b=c[j>>2]|0,k=c[j>>2]|0,((c[(c[(c[((c[c[j>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[j>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[j>>2]|0)+8>>2]|0)+170>>1]|0)|0)==0):0){FK(c[j>>2]|0);if((c[13957]|0)==((c[13952]|0)-1|0)){l=7;break}k=c[j>>2]|0;if(EK(c[((c[c[j>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)|0){l=7;break}}c[h>>2]=(c[h>>2]|0)+1}if((l|0)==7){c[f>>2]=1;m=c[f>>2]|0;i=d;return m|0}c[h>>2]=0;while(1){k=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)+(c[h>>2]<<2)>>2]|0;c[j>>2]=k;if(!k){l=17;break}k=c[j>>2]|0;if((a[(c[(c[((c[c[j>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0)==0?(k=c[j>>2]|0,b=c[j>>2]|0,((c[(c[(c[((c[c[j>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[j>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(e[(c[(c[j>>2]|0)+8>>2]|0)+170>>1]|0)|0)==0):0){FK(c[j>>2]|0);if((c[13957]|0)==((c[13952]|0)-1|0)){l=15;break}b=c[j>>2]|0;if(EK(c[((c[c[j>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0){l=15;break}}c[h>>2]=(c[h>>2]|0)+1}if((l|0)==15){c[f>>2]=1;m=c[f>>2]|0;i=d;return m|0}else if((l|0)==17){c[f>>2]=0;m=c[f>>2]|0;i=d;return m|0}return 0}function FK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;c[e>>2]=b;if((c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]|0)>=0){$z(1,140092,d)|0;Pa(55648,1)}c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]=c[13957];b=c[e>>2]|0;g=c[13957]|0;c[13957]=g+1;c[(c[13956]|0)+(g<<2)>>2]=b;b=c[e>>2]|0;if(!(a[(c[(c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0)){b=c[e>>2]|0;g=c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0;b=c[13964]|0;c[13964]=b+1;c[(c[13963]|0)+(b<<2)>>2]=g}g=c[e>>2]|0;if(!(a[(c[(c[((c[c[e>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0)){g=c[e>>2]|0;b=c[((c[c[e>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0;g=c[13964]|0;c[13964]=g+1;c[(c[13963]|0)+(g<<2)>>2]=b}b=c[e>>2]|0;c[f>>2]=c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2];a[(c[(c[f>>2]|0)+8>>2]|0)+157>>0]=1;b=c[e>>2]|0;g=(c[(c[f>>2]|0)+8>>2]|0)+272+4|0;h=c[g>>2]|0;c[g>>2]=h+1;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+272>>2]|0)+(h<<2)>>2]=b;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+272>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+272+4>>2]<<2)>>2]=0;if(!(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+272+4>>2]|0)-1<<2)>>2]|0)){$z(1,140126,d+8|0)|0;Pa(55648,1)}b=c[e>>2]|0;c[f>>2]=c[((c[c[e>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];a[(c[(c[f>>2]|0)+8>>2]|0)+157>>0]=1;b=c[e>>2]|0;e=(c[(c[f>>2]|0)+8>>2]|0)+264+4|0;h=c[e>>2]|0;c[e>>2]=h+1;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+264>>2]|0)+(h<<2)>>2]=b;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+264>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+264+4>>2]<<2)>>2]=0;if(!(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+264+4>>2]|0)-1<<2)>>2]|0)){$z(1,140161,d+16|0)|0;Pa(55648,1)}else{i=d;return}}function GK(a){a=+a;var b=0,d=0,e=0.0;b=i;i=i+16|0;d=b;h[d>>3]=a;if(c[13802]|0){e=+h[4260]-+h[d>>3];i=b;return +e}else{e=+h[d>>3];i=b;return +e}return +(0.0)}function HK(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+144|0;j=g+64|0;k=g+124|0;l=g+120|0;m=g+116|0;n=g+128|0;o=g+112|0;p=g+108|0;q=g+104|0;r=g+100|0;s=g+96|0;t=g+92|0;u=g+88|0;v=g+16|0;w=g;x=g+84|0;y=g+80|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;a[n>>0]=f;c[13965]=c[(c[(c[(c[l>>2]|0)+52>>2]|0)+8>>2]|0)+4>>2];KK(c[l>>2]|0);f=(c[(c[l>>2]|0)+8>>2]|0)+16+16|0;c[w>>2]=c[f>>2];c[w+4>>2]=c[f+4>>2];c[w+8>>2]=c[f+8>>2];c[w+12>>2]=c[f+12>>2];LK(c[m>>2]|0,140225,+h[(c[k>>2]|0)+352>>3]);LK(c[m>>2]|0,140232,+h[w>>3]/72.0);LK(c[m>>2]|0,140232,+h[w+8>>3]/72.0);MK(10,c[m>>2]|0);c[t>>2]=$B(c[l>>2]|0)|0;while(1){if(!(c[t>>2]|0))break;if(!(a[(c[(c[t>>2]|0)+8>>2]|0)+118>>0]|0)){w=c[m>>2]|0;NK(w,140234,TD(wB(c[t>>2]|0)|0)|0);w=c[m>>2]|0;k=(c[(c[t>>2]|0)+8>>2]|0)+16|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];OK(w,j);w=c[t>>2]|0;if(a[(c[(c[(c[t>>2]|0)+8>>2]|0)+104>>2]|0)+82>>0]|0)c[x>>2]=TD(zA(w,c[13831]|0)|0)|0;else{k=qC(w)|0;c[x>>2]=PK(k,c[c[(c[(c[t>>2]|0)+8>>2]|0)+104>>2]>>2]|0)|0}LK(c[m>>2]|0,140232,+h[(c[(c[t>>2]|0)+8>>2]|0)+32>>3]);LK(c[m>>2]|0,140232,+h[(c[(c[t>>2]|0)+8>>2]|0)+40>>3]);NK(c[m>>2]|0,140232,c[x>>2]|0);k=c[m>>2]|0;NK(k,140232,iO(c[t>>2]|0,c[13834]|0,148629)|0);NK(c[m>>2]|0,140232,c[c[(c[(c[t>>2]|0)+8>>2]|0)+8>>2]>>2]|0);k=c[m>>2]|0;NK(k,140232,iO(c[t>>2]|0,c[13817]|0,174917)|0);c[y>>2]=iO(c[t>>2]|0,c[13818]|0,178518)|0;if(!(a[c[y>>2]>>0]|0))c[y>>2]=iO(c[t>>2]|0,c[13817]|0,172403)|0;NK(c[m>>2]|0,140232,c[y>>2]|0);MK(10,c[m>>2]|0)}c[t>>2]=aC(c[l>>2]|0,c[t>>2]|0)|0}c[t>>2]=$B(c[l>>2]|0)|0;while(1){if(!(c[t>>2]|0))break;c[u>>2]=OA(c[l>>2]|0,c[t>>2]|0)|0;while(1){if(!(c[u>>2]|0))break;if(a[n>>0]|0){y=yA(c[u>>2]|0,149070)|0;c[r>>2]=y;c[r>>2]=(y|0)!=0?y:178518;y=yA(c[u>>2]|0,149061)|0;c[s>>2]=y;c[s>>2]=(y|0)!=0?y:178518}else{c[s>>2]=178518;c[r>>2]=178518}a:do if(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0){c[q>>2]=0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;z=v;A=(c[c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[o>>2]|0)*48|0)|0;B=z+48|0;do{c[z>>2]=c[A>>2];z=z+4|0;A=A+4|0}while((z|0)<(B|0));c[q>>2]=(c[q>>2]|0)+(c[v+4>>2]|0);c[o>>2]=(c[o>>2]|0)+1}NK(c[m>>2]|0,0,149079);y=c[u>>2]|0;QK(c[m>>2]|0,c[((c[c[u>>2]>>2]&3|0)==3?y:y+32|0)+28>>2]|0,c[r>>2]|0);y=c[u>>2]|0;QK(c[m>>2]|0,c[((c[c[u>>2]>>2]&3|0)==2?y:y+-32|0)+28>>2]|0,c[s>>2]|0);RK(c[m>>2]|0,140232,c[q>>2]|0);c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break a;z=v;A=(c[c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[o>>2]|0)*48|0)|0;B=z+48|0;do{c[z>>2]=c[A>>2];z=z+4|0;A=A+4|0}while((z|0)<(B|0));c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[v+4>>2]|0))break;y=c[m>>2]|0;x=(c[v>>2]|0)+(c[p>>2]<<4)|0;c[j>>2]=c[x>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];OK(y,j);c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}}while(0);if(c[(c[(c[u>>2]|0)+8>>2]|0)+96>>2]|0){y=c[m>>2]|0;x=c[u>>2]|0;k=qC(c[((c[c[u>>2]>>2]&3|0)==3?x:x+32|0)+28>>2]|0)|0;NK(y,140232,PK(k,c[c[(c[(c[u>>2]|0)+8>>2]|0)+96>>2]>>2]|0)|0);k=c[m>>2]|0;y=(c[(c[(c[u>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;c[j>>2]=c[y>>2];c[j+4>>2]=c[y+4>>2];c[j+8>>2]=c[y+8>>2];c[j+12>>2]=c[y+12>>2];OK(k,j)}k=c[m>>2]|0;NK(k,140232,iO(c[u>>2]|0,c[13869]|0,148629)|0);k=c[m>>2]|0;NK(k,140232,iO(c[u>>2]|0,c[13853]|0,174917)|0);MK(10,c[m>>2]|0);c[u>>2]=QA(c[l>>2]|0,c[u>>2]|0)|0}c[t>>2]=aC(c[l>>2]|0,c[t>>2]|0)|0}SK(140240,c[m>>2]|0);i=g;return}function IK(b,f,g){b=b|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0;j=i;i=i+2384|0;k=j+224|0;l=j+208|0;m=j+192|0;n=j+176|0;o=j+160|0;p=j+144|0;q=j+128|0;r=j+112|0;s=j+96|0;t=j+80|0;u=j+72|0;v=j+64|0;w=j+48|0;x=j+40|0;y=j+16|0;z=j+332|0;A=j+328|0;B=j+324|0;C=j+320|0;D=j+316|0;E=j+312|0;F=j+308|0;G=j+304|0;H=j+1360|0;I=j+288|0;J=j+280|0;K=j+276|0;L=j;M=j+272|0;N=j+268|0;O=j+264|0;P=j+260|0;S=j+256|0;T=j+252|0;U=j+248|0;V=j+244|0;W=j+240|0;c[z>>2]=b;c[A>>2]=f;c[B>>2]=g;c[M>>2]=(e[(c[(c[z>>2]|0)+8>>2]|0)+178>>1]|0)>=3&1;KH(1);c[D>>2]=0;c[C>>2]=0;KK(c[z>>2]|0);dA(I,1024,j+336|0);HO(c[z>>2]|0,1,140246,178518)|0;HO(c[z>>2]|0,1,140250,178518)|0;c[13815]=HO(c[z>>2]|0,1,179125,178518)|0;c[13814]=HO(c[z>>2]|0,1,179057,178518)|0;HO(c[z>>2]|0,2,140246,178518)|0;if(d[(c[(c[z>>2]|0)+8>>2]|0)+113>>0]&16)HO(c[z>>2]|0,1,140256,178518)|0;if(d[(c[(c[z>>2]|0)+8>>2]|0)+113>>0]&1)HO(c[z>>2]|0,2,140260,178518)|0;if(d[(c[(c[z>>2]|0)+8>>2]|0)+113>>0]&32)HO(c[z>>2]|0,2,140256,178518)|0;if(d[(c[(c[z>>2]|0)+8>>2]|0)+113>>0]&2)HO(c[z>>2]|0,2,140263,178518)|0;if(d[(c[(c[z>>2]|0)+8>>2]|0)+113>>0]&4)HO(c[z>>2]|0,2,140271,178518)|0;if(d[(c[(c[z>>2]|0)+8>>2]|0)+113>>0]&8){c[O>>2]=HO(c[z>>2]|0,0,140260,178518)|0;c[P>>2]=HO(c[z>>2]|0,0,140279,178518)|0;c[S>>2]=HO(c[z>>2]|0,0,140286,178518)|0}c[N>>2]=HO(c[z>>2]|0,0,140294,178518)|0;c[J>>2]=$B(c[z>>2]|0)|0;while(1){if(!(c[J>>2]|0))break;X=+h[(c[(c[J>>2]|0)+8>>2]|0)+16>>3];g=(c[13802]|0)!=0;if(c[M>>2]|0){if(g)Y=+h[4260]-+h[(c[(c[J>>2]|0)+8>>2]|0)+16+8>>3];else Y=+h[(c[(c[J>>2]|0)+8>>2]|0)+16+8>>3];Z=+h[(c[(c[(c[J>>2]|0)+8>>2]|0)+132>>2]|0)+16>>3]*72.0;h[y>>3]=X;h[y+8>>3]=Y;h[y+16>>3]=Z;k3(H,140297,y)|0;gA(I,H)|0;c[T>>2]=3;while(1){if((c[T>>2]|0)>=(e[(c[(c[z>>2]|0)+8>>2]|0)+178>>1]|0))break;h[x>>3]=+h[(c[(c[(c[J>>2]|0)+8>>2]|0)+132>>2]|0)+(c[T>>2]<<3)>>3]*72.0;k3(H,140312,x)|0;gA(I,H)|0;c[T>>2]=(c[T>>2]|0)+1}f=c[J>>2]|0;if((c[I+4>>2]|0)>>>0>=(c[I+8>>2]|0)>>>0)eA(I,1)|0;b=I+4|0;_=c[b>>2]|0;c[b>>2]=_+1;a[_>>0]=0;_=c[I>>2]|0;c[I+4>>2]=_;AA(f,140246,_)|0}else{if(g)$=+h[4260]-+h[(c[(c[J>>2]|0)+8>>2]|0)+16+8>>3];else $=+h[(c[(c[J>>2]|0)+8>>2]|0)+16+8>>3];h[w>>3]=X;h[w+8>>3]=$;k3(H,140318,w)|0;AA(c[J>>2]|0,140246,H)|0}h[v>>3]=+h[(c[(c[J>>2]|0)+8>>2]|0)+80>>3]/72.0;k3(H,140328,v)|0;BA(c[J>>2]|0,c[13814]|0,H)|0;h[u>>3]=(+h[(c[(c[J>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[J>>2]|0)+8>>2]|0)+96>>3])/72.0;k3(H,140328,u)|0;BA(c[J>>2]|0,c[13815]|0,H)|0;if((c[(c[(c[J>>2]|0)+8>>2]|0)+108>>2]|0)!=0?(d[(c[(c[(c[J>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0)!=0:0){_=(c[(c[(c[J>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;c[L>>2]=c[_>>2];c[L+4>>2]=c[_+4>>2];c[L+8>>2]=c[_+8>>2];c[L+12>>2]=c[_+12>>2];if(c[13802]|0)aa=+h[4260]-+h[L+8>>3];else aa=+h[L+8>>3];h[t>>3]=+h[L>>3];h[t+8>>3]=aa;k3(H,140318,t)|0;AA(c[J>>2]|0,140256,H)|0}if(J3(c[c[(c[(c[J>>2]|0)+8>>2]|0)+8>>2]>>2]|0,143646)|0){if((c[13847]|0)!=0?((eM(c[J>>2]|0)|0)&255|0)!=0:0){c[U>>2]=c[(c[(c[J>>2]|0)+8>>2]|0)+12>>2];c[G>>2]=c[(c[U>>2]|0)+8>>2];if((c[G>>2]|0)<3){c[W>>2]=yA(c[J>>2]|0,140333)|0;if(c[W>>2]|0)c[G>>2]=u3(c[W>>2]|0)|0;else c[G>>2]=8;if((c[G>>2]|0)<3)c[G>>2]=8}c[V>>2]=0;while(1){if((c[V>>2]|0)>=(c[G>>2]|0))break;if((c[V>>2]|0)>0){if((c[I+4>>2]|0)>>>0>=(c[I+8>>2]|0)>>>0)eA(I,1)|0;_=I+4|0;f=c[_>>2]|0;c[_>>2]=f+1;a[f>>0]=32}if((c[(c[U>>2]|0)+8>>2]|0)>=3){if(c[13802]|0)ba=+h[4261]-+h[(c[(c[U>>2]|0)+44>>2]|0)+(c[V>>2]<<4)+8>>3]/72.0;else ba=+h[(c[(c[U>>2]|0)+44>>2]|0)+(c[V>>2]<<4)+8>>3]/72.0;h[s>>3]=+h[(c[(c[U>>2]|0)+44>>2]|0)+(c[V>>2]<<4)>>3]/72.0;h[s+8>>3]=ba;k3(H,140346,s)|0}else{Z=+h[(c[(c[J>>2]|0)+8>>2]|0)+32>>3]/2.0*+Q(+(+(c[V>>2]|0)/+(c[G>>2]|0)*3.141592653589793*2.0));if(c[13802]|0)ca=+h[4261]-+h[(c[(c[J>>2]|0)+8>>2]|0)+40>>3]/2.0*+R(+(+(c[V>>2]|0)/+(c[G>>2]|0)*3.141592653589793*2.0));else ca=+h[(c[(c[J>>2]|0)+8>>2]|0)+40>>3]/2.0*+R(+(+(c[V>>2]|0)/+(c[G>>2]|0)*3.141592653589793*2.0));h[r>>3]=Z;h[r+8>>3]=ca;k3(H,140346,r)|0}gA(I,H)|0;c[V>>2]=(c[V>>2]|0)+1}g=c[J>>2]|0;f=c[13847]|0;if((c[I+4>>2]|0)>>>0>=(c[I+8>>2]|0)>>>0)eA(I,1)|0;_=I+4|0;b=c[_>>2]|0;c[_>>2]=b+1;a[b>>0]=0;b=c[I>>2]|0;c[I+4>>2]=b;BA(g,f,b)|0}}else{TK(c[J>>2]|0,c[(c[(c[J>>2]|0)+8>>2]|0)+12>>2]|0,I);iA(I)|0;b=c[J>>2]|0;if((c[I+4>>2]|0)>>>0>=(c[I+8>>2]|0)>>>0)eA(I,1)|0;f=I+4|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=0;g=c[I>>2]|0;c[I+4>>2]=g;AA(b,140250,g)|0}a:do if((c[13800]|0)>=1){c[K>>2]=OA(c[z>>2]|0,c[J>>2]|0)|0;while(1){if(!(c[K>>2]|0))break a;do if((a[(c[(c[K>>2]|0)+8>>2]|0)+112>>0]|0)!=6?(c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[(c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;if((c[E>>2]|0)>0){if((c[I+4>>2]|0)>>>0>=(c[I+8>>2]|0)>>>0)eA(I,1)|0;g=I+4|0;b=c[g>>2]|0;c[g>>2]=b+1;a[b>>0]=59}if(c[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+8>>2]|0){c[D>>2]=1;if(c[13802]|0)da=+h[4260]-+h[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+16+8>>3];else da=+h[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+16+8>>3];h[q>>3]=+h[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+16>>3];h[q+8>>3]=da;k3(H,140356,q)|0;gA(I,H)|0}if(c[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+12>>2]|0){c[C>>2]=1;if(c[13802]|0)ea=+h[4260]-+h[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+32+8>>3];else ea=+h[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+32+8>>3];h[p>>3]=+h[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+32>>3];h[p+8>>3]=ea;k3(H,140369,p)|0;gA(I,H)|0}c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)+4>>2]|0))break;if((c[F>>2]|0)>0){if((c[I+4>>2]|0)>>>0>=(c[I+8>>2]|0)>>>0)eA(I,1)|0;b=I+4|0;g=c[b>>2]|0;c[b>>2]=g+1;a[g>>0]=32}g=(c[(c[c[(c[(c[K>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[E>>2]|0)*48|0)>>2]|0)+(c[F>>2]<<4)|0;c[L>>2]=c[g>>2];c[L+4>>2]=c[g+4>>2];c[L+8>>2]=c[g+8>>2];c[L+12>>2]=c[g+12>>2];if(c[13802]|0)fa=+h[4260]-+h[L+8>>3];else fa=+h[L+8>>3];h[o>>3]=+h[L>>3];h[o+8>>3]=fa;k3(H,140318,o)|0;gA(I,H)|0;c[F>>2]=(c[F>>2]|0)+1}c[E>>2]=(c[E>>2]|0)+1}g=c[K>>2]|0;if((c[I+4>>2]|0)>>>0>=(c[I+8>>2]|0)>>>0)eA(I,1)|0;b=I+4|0;f=c[b>>2]|0;c[b>>2]=f+1;a[f>>0]=0;f=c[I>>2]|0;c[I+4>>2]=f;AA(g,140246,f)|0;if(c[(c[(c[K>>2]|0)+8>>2]|0)+96>>2]|0){f=(c[(c[(c[K>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;c[L>>2]=c[f>>2];c[L+4>>2]=c[f+4>>2];c[L+8>>2]=c[f+8>>2];c[L+12>>2]=c[f+12>>2];if(c[13802]|0)ga=+h[4260]-+h[L+8>>3];else ga=+h[L+8>>3];h[n>>3]=+h[L>>3];h[n+8>>3]=ga;k3(H,140318,n)|0;AA(c[K>>2]|0,140260,H)|0}do if(c[(c[(c[K>>2]|0)+8>>2]|0)+108>>2]|0){if(!(d[(c[(c[(c[K>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0))break;f=(c[(c[(c[K>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;c[L>>2]=c[f>>2];c[L+4>>2]=c[f+4>>2];c[L+8>>2]=c[f+8>>2];c[L+12>>2]=c[f+12>>2];if(c[13802]|0)ha=+h[4260]-+h[L+8>>3];else ha=+h[L+8>>3];h[m>>3]=+h[L>>3];h[m+8>>3]=ha;k3(H,140318,m)|0;AA(c[K>>2]|0,140256,H)|0}while(0);if(c[(c[(c[K>>2]|0)+8>>2]|0)+100>>2]|0){f=(c[(c[(c[K>>2]|0)+8>>2]|0)+100>>2]|0)+56|0;c[L>>2]=c[f>>2];c[L+4>>2]=c[f+4>>2];c[L+8>>2]=c[f+8>>2];c[L+12>>2]=c[f+12>>2];if(c[13802]|0)ia=+h[4260]-+h[L+8>>3];else ia=+h[L+8>>3];h[l>>3]=+h[L>>3];h[l+8>>3]=ia;k3(H,140318,l)|0;AA(c[K>>2]|0,140263,H)|0}if(!(c[(c[(c[K>>2]|0)+8>>2]|0)+104>>2]|0))break;f=(c[(c[(c[K>>2]|0)+8>>2]|0)+104>>2]|0)+56|0;c[L>>2]=c[f>>2];c[L+4>>2]=c[f+4>>2];c[L+8>>2]=c[f+8>>2];c[L+12>>2]=c[f+12>>2];if(c[13802]|0)ja=+h[4260]-+h[L+8>>3];else ja=+h[L+8>>3];h[k>>3]=+h[L>>3];h[k+8>>3]=ja;k3(H,140318,k)|0;AA(c[K>>2]|0,140271,H)|0}while(0);c[K>>2]=QA(c[z>>2]|0,c[K>>2]|0)|0}}while(0);c[J>>2]=aC(c[z>>2]|0,c[J>>2]|0)|0}UK(c[z>>2]|0,c[N>>2]|0,c[O>>2]|0,c[P>>2]|0,c[S>>2]|0);hA(I);if(!(e[(c[(c[z>>2]|0)+8>>2]|0)+136>>1]&1)){ka=c[D>>2]|0;la=c[A>>2]|0;c[la>>2]=ka;ma=c[C>>2]|0;na=c[B>>2]|0;c[na>>2]=ma;KH(0);i=j;return}GO(c[z>>2]|0);ka=c[D>>2]|0;la=c[A>>2]|0;c[la>>2]=ka;ma=c[C>>2]|0;na=c[B>>2]|0;c[na>>2]=ma;KH(0);i=j;return}function JK(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b+8|0;c[d>>2]=a;IK(c[d>>2]|0,b,b+4|0);i=b;return}function KK(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[13802]|0)){i=b;return}h[4260]=+h[(c[(c[d>>2]|0)+8>>2]|0)+16+16+8>>3]+ +h[(c[(c[d>>2]|0)+8>>2]|0)+16+8>>3];h[4261]=+h[4260]/72.0;i=b;return}function LK(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+1056|0;f=e+8|0;g=e+20|0;j=e+16|0;k=e;l=e+24|0;c[g>>2]=a;c[j>>2]=b;h[k>>3]=d;if(c[j>>2]|0)SK(c[j>>2]|0,c[g>>2]|0);h[f>>3]=+h[k>>3];k3(l,140328,f)|0;SK(l,c[g>>2]|0);i=e;return}function MK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;a[140428]=c[f>>2];Ob[c[13965]&127](c[g>>2]|0,140428)|0;i=e;return}function NK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(c[g>>2]|0)SK(c[g>>2]|0,c[f>>2]|0);SK(c[h>>2]|0,c[f>>2]|0);i=e;return}function OK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0;d=i;i=i+16|0;e=d;c[e>>2]=a;LK(c[e>>2]|0,140232,+h[b>>3]/72.0);a=c[e>>2]|0;if(c[13802]|0){f=+h[4260]-+h[b+8>>3];g=f/72.0;LK(a,140232,g);i=d;return}else{f=+h[b+8>>3];g=f/72.0;LK(a,140232,g);i=d;return}}function PK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=YC(c[e>>2]|0,c[f>>2]|0)|0;c[h>>2]=TD(c[g>>2]|0)|0;_C(c[e>>2]|0,c[g>>2]|0)|0;i=d;return c[h>>2]|0}function QK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;e=c[h>>2]|0;if(a[(c[(c[h>>2]|0)+8>>2]|0)+118>>0]|0){d=qC(e)|0;c[k>>2]=PK(d,(H3(wB(c[h>>2]|0)|0,58)|0)+1|0)|0}else c[k>>2]=TD(wB(e)|0)|0;NK(c[g>>2]|0,140232,c[k>>2]|0);if(!(c[j>>2]|0)){i=f;return}if(!(a[c[j>>2]>>0]|0)){i=f;return}k=c[g>>2]|0;NK(k,148898,TD(c[j>>2]|0)|0);i=f;return}function RK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1040|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;k=e+16|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[h>>2]|0)SK(c[h>>2]|0,c[g>>2]|0);c[f>>2]=c[j>>2];k3(k,175023,f)|0;SK(k,c[g>>2]|0);i=e;return}function SK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;Ob[c[13965]&127](c[f>>2]|0,c[e>>2]|0)|0;i=d;return}function TK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+1072|0;f=e;g=e+44|0;j=e+40|0;k=e+36|0;l=e+32|0;m=e+48|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;if(!(c[(c[j>>2]|0)+48>>2]|0)){if(c[13802]|0)n=+h[4260]-(+h[(c[j>>2]|0)+16+8>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3]);else n=+h[(c[j>>2]|0)+16+8>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];o=+h[(c[j>>2]|0)+16+16>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];if(c[13802]|0)p=+h[4260]-(+h[(c[j>>2]|0)+16+16+8>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3]);else p=+h[(c[j>>2]|0)+16+16+8>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];h[f>>3]=+h[(c[j>>2]|0)+16>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];h[f+8>>3]=n;h[f+16>>3]=o;h[f+24>>3]=p;k3(m,140407,f)|0;gA(c[k>>2]|0,m)|0}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[j>>2]|0)+48>>2]|0))break;TK(c[g>>2]|0,c[(c[(c[j>>2]|0)+56>>2]|0)+(c[l>>2]<<2)>>2]|0,c[k>>2]|0);c[l>>2]=(c[l>>2]|0)+1}i=e;return}function UK(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0;j=i;i=i+1136|0;k=j+72|0;l=j+64|0;m=j+48|0;n=j+16|0;o=j+100|0;p=j+96|0;q=j+92|0;r=j+88|0;s=j+84|0;t=j+80|0;u=j+104|0;v=j;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;if(c[13802]|0)w=+h[4260]-+h[(c[(c[o>>2]|0)+8>>2]|0)+16+8>>3];else w=+h[(c[(c[o>>2]|0)+8>>2]|0)+16+8>>3];x=+h[(c[(c[o>>2]|0)+8>>2]|0)+16+16>>3];if(c[13802]|0)y=+h[4260]-+h[(c[(c[o>>2]|0)+8>>2]|0)+16+16+8>>3];else y=+h[(c[(c[o>>2]|0)+8>>2]|0)+16+16+8>>3];h[n>>3]=+h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3];h[n+8>>3]=w;h[n+16>>3]=x;h[n+24>>3]=y;k3(u,140382,n)|0;BA(c[o>>2]|0,c[p>>2]|0,u)|0;if((c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]|0)!=0?(a[c[c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]>>2]>>0]|0)!=0:0){n=(c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;c[v>>2]=c[n>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];if(c[13802]|0)z=+h[4260]-+h[v+8>>3];else z=+h[v+8>>3];h[m>>3]=+h[v>>3];h[m+8>>3]=z;k3(u,140318,m)|0;BA(c[o>>2]|0,c[q>>2]|0,u)|0;m=(c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]|0)+24|0;c[v>>2]=c[m>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];c[v+12>>2]=c[m+12>>2];h[l>>3]=+h[v>>3]/72.0;k3(u,140402,l)|0;BA(c[o>>2]|0,c[r>>2]|0,u)|0;h[k>>3]=+h[v+8>>3]/72.0;k3(u,140402,k)|0;BA(c[o>>2]|0,c[s>>2]|0,u)|0}c[t>>2]=1;while(1){if((c[t>>2]|0)>(c[(c[(c[o>>2]|0)+8>>2]|0)+180>>2]|0))break;UK(c[(c[(c[(c[o>>2]|0)+8>>2]|0)+184>>2]|0)+(c[t>>2]<<2)>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0);c[t>>2]=(c[t>>2]|0)+1}i=j;return}function VK(){return Nz(55864,c[12989]|0)|0}function WK(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Jz(c[d>>2]|0)|0;i=b;return}function XK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d;c[f>>2]=a;a=c[c[f>>2]>>2]|0;g=c[f>>2]|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];b=fL(e)|0;Hb[a&63](g,b,1)|0;i=d;return}function YK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=c[h>>2];c[k+4>>2]=c[j>>2];j=c[c[g>>2]>>2]|0;h=c[g>>2]|0;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];k=fL(f)|0;Hb[j&63](h,k,1)|0;i=e;return}function ZK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+16|0;f=d;c[e>>2]=a;a=f+8|0;c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];b=(Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,f,4)|0)!=0;i=d;return (b?1:0)|0}function _K(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j+8>>2]=c[g>>2];c[j+8+4>>2]=c[h>>2];h=(Hb[c[c[f>>2]>>2]&63](c[f>>2]|0,j,4)|0)!=0;i=e;return (h?1:0)|0}function $K(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=Pz(c[d>>2]|0)|0;i=b;return a|0}function aL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[e>>2]=Pz(c[d>>2]|0)|0;c[f>>2]=bK(c[e>>2]<<3)|0;c[h>>2]=c[f>>2];c[g>>2]=Lz(c[d>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;d=c[h>>2]|0;c[h>>2]=d+8;e=(c[g>>2]|0)+8|0;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[g>>2]=c[c[g>>2]>>2]}i=b;return c[f>>2]|0}function bL(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a;c[b>>2]=cK(40)|0;d=c[b>>2]|0;e=55900;f=d+36|0;do{c[d>>2]=c[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(f|0));c[(c[b>>2]|0)+36>>2]=0;e=Nz(c[b>>2]|0,c[12989]|0)|0;i=a;return e|0}function cL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Hb[c[c[d>>2]>>2]&63](c[d>>2]|0,0,64)|0;i=b;return}function dL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+4>>2];Jz(c[d>>2]|0)|0;c[f>>2]=c[(c[e>>2]|0)+36>>2];while(1){if(!(c[f>>2]|0))break;c[g>>2]=c[c[f>>2]>>2];O4(c[f>>2]|0);c[f>>2]=c[g>>2]}O4(c[e>>2]|0);i=b;return}function eL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m+8>>2]=c[h>>2];c[m+8+4>>2]=c[j>>2];c[m+16>>2]=c[k>>2];c[l>>2]=Hb[c[c[g>>2]>>2]&63](c[g>>2]|0,m,1)|0;i=f;return c[(c[l>>2]|0)+16>>2]|0}function fL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=bK(16)|0;e=(c[d>>2]|0)+8|0;c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];i=b;return c[d>>2]|0}function gL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[e+12>>2]=a;c[f>>2]=b;c[g>>2]=d;if(c[(c[g>>2]|0)+36>>2]|0){c[h>>2]=c[(c[g>>2]|0)+36>>2];c[(c[g>>2]|0)+36>>2]=c[c[h>>2]>>2]}else c[h>>2]=cK(20)|0;g=(c[h>>2]|0)+8|0;d=(c[f>>2]|0)+8|0;c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[(c[h>>2]|0)+16>>2]=c[(c[f>>2]|0)+16>>2];i=e;return c[h>>2]|0}function hL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[e+8>>2]=a;c[f>>2]=b;c[g>>2]=d;c[c[f>>2]>>2]=c[(c[g>>2]|0)+36>>2];c[(c[g>>2]|0)+36>>2]=c[f>>2];i=e;return}function iL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;c[f+12>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f>>2]=e;do if((c[c[h>>2]>>2]|0)<=(c[c[j>>2]>>2]|0)){if((c[c[h>>2]>>2]|0)<(c[c[j>>2]>>2]|0)){c[g>>2]=-1;break}if((c[(c[h>>2]|0)+4>>2]|0)>(c[(c[j>>2]|0)+4>>2]|0)){c[g>>2]=1;break}if((c[(c[h>>2]|0)+4>>2]|0)<(c[(c[j>>2]|0)+4>>2]|0)){c[g>>2]=-1;break}else{c[g>>2]=0;break}}else c[g>>2]=1;while(0);i=f;return c[g>>2]|0}function jL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function kL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;d=i;i=i+240|0;e=d+208|0;f=d+232|0;g=d+228|0;j=d+224|0;k=d+176|0;l=d+144|0;m=d+128|0;n=d+112|0;o=d+96|0;p=d+80|0;q=d+64|0;r=d+48|0;s=d+32|0;t=d+16|0;u=d;c[f>>2]=a;c[g>>2]=b;b=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[k>>2]=c[b>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[k+16>>2]=c[b+16>>2];c[k+20>>2]=c[b+20>>2];c[k+24>>2]=c[b+24>>2];c[k+28>>2]=c[b+28>>2];v=+h[k>>3];if((c[g>>2]|0)==1|(c[g>>2]|0)==2){oL(m,v,+h[k+16+8>>3]);c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];pL(n,e);c[l>>2]=c[n>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];n=l+16|0;oL(o,+h[k+16>>3],+h[k+8>>3]);c[e>>2]=c[o>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2];c[e+12>>2]=c[o+12>>2];pL(p,e);c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2]}else{oL(q,v,+h[k+8>>3]);c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];c[e+12>>2]=c[q+12>>2];pL(r,e);c[l>>2]=c[r>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[l+12>>2]=c[r+12>>2];r=l+16|0;oL(s,+h[k+16>>3],+h[k+16+8>>3]);c[e>>2]=c[s>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];c[e+12>>2]=c[s+12>>2];pL(t,e);c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2]}t=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[t>>2]=c[l>>2];c[t+4>>2]=c[l+4>>2];c[t+8>>2]=c[l+8>>2];c[t+12>>2]=c[l+12>>2];c[t+16>>2]=c[l+16>>2];c[t+20>>2]=c[l+20>>2];c[t+24>>2]=c[l+24>>2];c[t+28>>2]=c[l+28>>2];if(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0){l=(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;t=(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[e+12>>2]=c[t+12>>2];pL(u,e);c[l>>2]=c[u>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];c[l+12>>2]=c[u+12>>2]}c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;kL(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2]|0,c[g>>2]|0);c[j>>2]=(c[j>>2]|0)+1}i=d;return}function lL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;e=i;i=i+1200|0;f=e+152|0;g=e+104|0;j=e+72|0;k=e+172|0;l=e+168|0;m=e+64|0;n=e+48|0;o=e+32|0;p=e+16|0;q=e;r=e+176|0;c[k>>2]=b;c[l>>2]=d;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;c[13984]=c[(c[(c[k>>2]|0)+8>>2]|0)+116>>2]&3;a[140430]=c[(c[(c[k>>2]|0)+8>>2]|0)+116>>2]&1;d=c[k>>2]|0;if(a[140430]|0)qL(d);else mL(d);rL(c[k>>2]|0);do if((c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2]|0)!=0?(a[(c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0)==0:0){d=(c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2]|0)+24|0;c[n>>2]=c[d>>2];c[n+4>>2]=c[d+4>>2];c[n+8>>2]=c[d+8>>2];c[n+12>>2]=c[d+12>>2];h[n>>3]=+h[n>>3]+16.0;d=n+8|0;h[d>>3]=+h[d>>3]+8.0;d=(a[(c[(c[k>>2]|0)+8>>2]|0)+275>>0]&1|0)!=0;if(a[140430]|0){s=+h[n+8>>3];b=(c[(c[k>>2]|0)+8>>2]|0)+16|0;if(d){t=b+16|0;h[t>>3]=+h[t>>3]+s}else h[b>>3]=+h[b>>3]-s;if(!(+h[n>>3]>+h[(c[(c[k>>2]|0)+8>>2]|0)+16+16+8>>3]-+h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3]))break;h[m>>3]=+h[n>>3]-(+h[(c[(c[k>>2]|0)+8>>2]|0)+16+16+8>>3]-+h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3]);h[m>>3]=+h[m>>3]/2.0;b=(c[(c[k>>2]|0)+8>>2]|0)+16+8|0;h[b>>3]=+h[b>>3]-+h[m>>3];b=(c[(c[k>>2]|0)+8>>2]|0)+16+16+8|0;h[b>>3]=+h[b>>3]+ +h[m>>3];break}b=(c[13984]|0)==0;s=+h[n+8>>3];t=(c[(c[k>>2]|0)+8>>2]|0)+16|0;do if(d)if(b){u=t+16+8|0;h[u>>3]=+h[u>>3]+s;break}else{u=t+8|0;h[u>>3]=+h[u>>3]-s;break}else if(b){u=t+8|0;h[u>>3]=+h[u>>3]-s;break}else{u=t+16+8|0;h[u>>3]=+h[u>>3]+s;break}while(0);if(+h[n>>3]>+h[(c[(c[k>>2]|0)+8>>2]|0)+16+16>>3]-+h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3]){h[m>>3]=+h[n>>3]-(+h[(c[(c[k>>2]|0)+8>>2]|0)+16+16>>3]-+h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3]);h[m>>3]=+h[m>>3]/2.0;t=(c[(c[k>>2]|0)+8>>2]|0)+16|0;h[t>>3]=+h[t>>3]-+h[m>>3];t=(c[(c[k>>2]|0)+8>>2]|0)+16+16|0;h[t>>3]=+h[t>>3]+ +h[m>>3]}}while(0);if(c[l>>2]|0){switch(c[13984]|0){case 0:{l=(c[(c[k>>2]|0)+8>>2]|0)+16|0;c[8524]=c[l>>2];c[8525]=c[l+4>>2];c[8526]=c[l+8>>2];c[8527]=c[l+12>>2];break}case 1:{oL(o,-+h[(c[(c[k>>2]|0)+8>>2]|0)+16+16+8>>3],+h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3]);c[8524]=c[o>>2];c[8525]=c[o+4>>2];c[8526]=c[o+8>>2];c[8527]=c[o+12>>2];break}case 2:{oL(p,+h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3],-+h[(c[(c[k>>2]|0)+8>>2]|0)+16+16+8>>3]);c[8524]=c[p>>2];c[8525]=c[p+4>>2];c[8526]=c[p+8>>2];c[8527]=c[p+12>>2];break}case 3:{oL(q,+h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3],+h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3]);c[8524]=c[q>>2];c[8525]=c[q+4>>2];c[8526]=c[q+8>>2];c[8527]=c[q+12>>2];break}default:{}}sL(c[k>>2]|0)}if((c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2]|0)!=0?(a[(c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0)==0:0){q=c[k>>2]|0;c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];tL(q,f)}if(!(c[13796]|0)){i=e;return}if(a[140430]|0){s=+h[4263];v=+h[4262];w=+h[4263];h[j>>3]=+h[4262];h[j+8>>3]=s;h[j+16>>3]=v;h[j+24>>3]=w;k3(r,140431,j)|0}else{w=+h[4262];v=+h[4263];s=+h[4262];x=-+h[4262];y=-+h[4263];h[g>>3]=+h[4263];h[g+8>>3]=w;h[g+16>>3]=v;h[g+24>>3]=s;h[g+32>>3]=x;h[g+40>>3]=y;k3(r,140646,g)|0}g=M3(r)|0;c[c[13796]>>2]=g;i=e;return}function mL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+16|0;j=d;c[e>>2]=b;b=c[e>>2]|0;if(((b|0)!=(rC(c[e>>2]|0)|0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0)?(a[(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0)==0:0){b=(c[(c[e>>2]|0)+8>>2]|0)+48|0;if(a[(c[(c[e>>2]|0)+8>>2]|0)+275>>0]&1){k=b+32|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];h[g+8>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16+16+8>>3]-+h[j+8>>3]/2.0}else{c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];h[g+8>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16+8>>3]+ +h[j+8>>3]/2.0}b=c[(c[e>>2]|0)+8>>2]|0;do if(!(a[(c[(c[e>>2]|0)+8>>2]|0)+275>>0]&4)){l=+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3];if(a[b+275>>0]&2){h[g>>3]=l+ +h[j>>3]/2.0;break}else{h[g>>3]=(l+ +h[(c[(c[e>>2]|0)+8>>2]|0)+16+16>>3])/2.0;break}}else h[g>>3]=+h[b+16+16>>3]-+h[j>>3]/2.0;while(0);j=(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;c[j>>2]=c[g>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];a[(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]=1}c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;mL(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2]|0);c[f>>2]=(c[f>>2]|0)+1}i=d;return}function nL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;lL(c[d>>2]|0,1);i=b;return}function oL(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3];h[j+8>>3]=+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function pL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+16|0;f=d;g=(c[13984]|0)*90|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];FJ(f,e,g);c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];h[b>>3]=+h[b>>3]-+h[4262];f=b+8|0;h[f>>3]=+h[f>>3]-+h[4263];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];i=d;return}function qL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+16|0;j=d;c[e>>2]=b;b=c[e>>2]|0;if(((b|0)!=(rC(c[e>>2]|0)|0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0)?(a[(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0)==0:0){b=(c[(c[e>>2]|0)+8>>2]|0)+48|0;if(a[(c[(c[e>>2]|0)+8>>2]|0)+275>>0]&1){k=b+16|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];h[g>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16+16>>3]-+h[j>>3]/2.0}else{k=b+48|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];h[g>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]+ +h[j>>3]/2.0}k=c[(c[e>>2]|0)+8>>2]|0;do if(!(a[(c[(c[e>>2]|0)+8>>2]|0)+275>>0]&4)){b=(c[(c[e>>2]|0)+8>>2]|0)+16|0;if(a[k+275>>0]&2){h[g+8>>3]=+h[b+16+8>>3]-+h[j+8>>3]/2.0;break}else{h[g+8>>3]=(+h[b+8>>3]+ +h[(c[(c[e>>2]|0)+8>>2]|0)+16+16+8>>3])/2.0;break}}else h[g+8>>3]=+h[k+16+8>>3]+ +h[j+8>>3]/2.0;while(0);j=(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;c[j>>2]=c[g>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];a[(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]=1}c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;qL(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2]|0);c[f>>2]=(c[f>>2]|0)+1}i=d;return}function rL(b){b=b|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;f=i;i=i+640|0;g=f+520|0;h=f+512|0;j=f+504|0;k=f+496|0;l=f+488|0;m=f+480|0;n=f+472|0;o=f+628|0;p=f+624|0;q=f+620|0;r=f+616|0;s=f+612|0;t=f+608|0;u=f+604|0;v=f+600|0;w=f+596|0;x=f+592|0;y=f+588|0;z=f+440|0;A=f+424|0;B=f+584|0;C=f+384|0;D=f+580|0;E=f+576|0;F=f+572|0;G=f+568|0;H=f+564|0;I=f+560|0;J=f+368|0;K=f+352|0;L=f+320|0;M=f+288|0;N=f+256|0;O=f+240|0;P=f+208|0;Q=f+192|0;R=f+160|0;S=f+144|0;T=f+112|0;U=f+96|0;V=f+56|0;W=f+16|0;X=f;c[o>>2]=b;c[v>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;c[I>>2]=e[(c[(c[o>>2]|0)+8>>2]|0)+136>>1]&14;if(((((d[(c[(c[o>>2]|0)+8>>2]|0)+113>>0]&16|0)==0?(d[(c[(c[o>>2]|0)+8>>2]|0)+113>>0]&32|0)==0:0)?(d[(c[(c[o>>2]|0)+8>>2]|0)+113>>0]&4|0)==0:0)?(d[(c[(c[o>>2]|0)+8>>2]|0)+113>>0]&2|0)==0:0)?((c[13801]|0)!=0?1:(d[(c[(c[o>>2]|0)+8>>2]|0)+113>>0]&1|0)==0):0){i=f;return}c[p>>2]=$B(c[o>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;do if(c[(c[(c[p>>2]|0)+8>>2]|0)+108>>2]|0)if(a[(c[(c[(c[p>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0){c[x>>2]=(c[x>>2]|0)+1;break}else{c[v>>2]=(c[v>>2]|0)+1;break}while(0);c[q>>2]=OA(c[o>>2]|0,c[p>>2]|0)|0;while(1){if(!(c[q>>2]|0))break;do if(c[(c[(c[q>>2]|0)+8>>2]|0)+108>>2]|0){if(a[(c[(c[(c[q>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0){c[x>>2]=(c[x>>2]|0)+1;break}if((c[I>>2]|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)c[w>>2]=(c[w>>2]|0)+1}while(0);do if(c[(c[(c[q>>2]|0)+8>>2]|0)+100>>2]|0){if(a[(c[(c[(c[q>>2]|0)+8>>2]|0)+100>>2]|0)+81>>0]|0){c[x>>2]=(c[x>>2]|0)+1;break}if((c[I>>2]|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)c[w>>2]=(c[w>>2]|0)+1}while(0);do if(c[(c[(c[q>>2]|0)+8>>2]|0)+104>>2]|0){if(a[(c[(c[(c[q>>2]|0)+8>>2]|0)+104>>2]|0)+81>>0]|0){c[x>>2]=(c[x>>2]|0)+1;break}if((c[I>>2]|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)c[w>>2]=(c[w>>2]|0)+1}while(0);do if(c[(c[(c[q>>2]|0)+8>>2]|0)+96>>2]|0){if(a[(c[(c[(c[q>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]|0){c[x>>2]=(c[x>>2]|0)+1;break}if((c[I>>2]|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)c[w>>2]=(c[w>>2]|0)+1}while(0);c[q>>2]=QA(c[o>>2]|0,c[q>>2]|0)|0}c[p>>2]=aC(c[o>>2]|0,c[p>>2]|0)|0}if(d[(c[(c[o>>2]|0)+8>>2]|0)+113>>0]&8)c[y>>2]=vL(c[o>>2]|0)|0;c[u>>2]=(c[v>>2]|0)+(c[w>>2]|0);if(!(c[u>>2]|0)){i=f;return}v=kB(c[o>>2]|0)|0;c[t>>2]=v+(c[x>>2]|0)+(c[y>>2]|0)+(c[w>>2]|0);w=bK((c[t>>2]|0)*40|0)|0;c[D>>2]=w;c[F>>2]=w;w=bK((c[u>>2]|0)*40|0)|0;c[E>>2]=w;c[G>>2]=w;oL(J,2147483647.0,2147483647.0);c[z>>2]=c[J>>2];c[z+4>>2]=c[J+4>>2];c[z+8>>2]=c[J+8>>2];c[z+12>>2]=c[J+12>>2];J=z+16|0;oL(K,-2147483647.0,-2147483647.0);c[J>>2]=c[K>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];c[J+12>>2]=c[K+12>>2];c[p>>2]=$B(c[o>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;K=c[p>>2]|0;J=c[F>>2]|0;c[g>>2]=c[z>>2];c[g+4>>2]=c[z+4>>2];c[g+8>>2]=c[z+8>>2];c[g+12>>2]=c[z+12>>2];c[g+16>>2]=c[z+16>>2];c[g+20>>2]=c[z+20>>2];c[g+24>>2]=c[z+24>>2];c[g+28>>2]=c[z+28>>2];wL(L,K,J,g);c[z>>2]=c[L>>2];c[z+4>>2]=c[L+4>>2];c[z+8>>2]=c[L+8>>2];c[z+12>>2]=c[L+12>>2];c[z+16>>2]=c[L+16>>2];c[z+20>>2]=c[L+20>>2];c[z+24>>2]=c[L+24>>2];c[z+28>>2]=c[L+28>>2];J=c[(c[(c[p>>2]|0)+8>>2]|0)+108>>2]|0;c[B>>2]=J;do if(J)if(a[(c[B>>2]|0)+81>>0]|0){c[F>>2]=(c[F>>2]|0)+40;K=c[B>>2]|0;w=c[F>>2]|0;c[g>>2]=c[z>>2];c[g+4>>2]=c[z+4>>2];c[g+8>>2]=c[z+8>>2];c[g+12>>2]=c[z+12>>2];c[g+16>>2]=c[z+16>>2];c[g+20>>2]=c[z+20>>2];c[g+24>>2]=c[z+24>>2];c[g+28>>2]=c[z+28>>2];xL(M,K,w,g);c[z>>2]=c[M>>2];c[z+4>>2]=c[M+4>>2];c[z+8>>2]=c[M+8>>2];c[z+12>>2]=c[M+12>>2];c[z+16>>2]=c[M+16>>2];c[z+20>>2]=c[M+20>>2];c[z+24>>2]=c[M+24>>2];c[z+28>>2]=c[M+28>>2];break}else{w=c[B>>2]|0;K=c[F>>2]|0;x=c[G>>2]|0;c[g>>2]=c[A>>2];c[g+4>>2]=c[A+4>>2];c[g+8>>2]=c[A+8>>2];c[g+12>>2]=c[A+12>>2];yL(w,K,x,0,g);c[G>>2]=(c[G>>2]|0)+40;break}while(0);c[F>>2]=(c[F>>2]|0)+40;c[q>>2]=OA(c[o>>2]|0,c[p>>2]|0)|0;while(1){if(!(c[q>>2]|0))break;J=c[(c[(c[q>>2]|0)+8>>2]|0)+96>>2]|0;c[B>>2]=J;a:do if(J){do if(a[(c[B>>2]|0)+81>>0]|0){x=c[B>>2]|0;K=c[F>>2]|0;c[g>>2]=c[z>>2];c[g+4>>2]=c[z+4>>2];c[g+8>>2]=c[z+8>>2];c[g+12>>2]=c[z+12>>2];c[g+16>>2]=c[z+16>>2];c[g+20>>2]=c[z+20>>2];c[g+24>>2]=c[z+24>>2];c[g+28>>2]=c[z+28>>2];xL(N,x,K,g);c[z>>2]=c[N>>2];c[z+4>>2]=c[N+4>>2];c[z+8>>2]=c[N+8>>2];c[z+12>>2]=c[N+12>>2];c[z+16>>2]=c[N+16>>2];c[z+20>>2]=c[N+20>>2];c[z+24>>2]=c[N+24>>2];c[z+28>>2]=c[N+28>>2]}else{if((c[I>>2]|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){K=c[B>>2]|0;x=c[F>>2]|0;w=c[G>>2]|0;rN(O,c[o>>2]|0,c[q>>2]|0);c[g>>2]=c[O>>2];c[g+4>>2]=c[O+4>>2];c[g+8>>2]=c[O+8>>2];c[g+12>>2]=c[O+12>>2];yL(K,x,w,1,g);c[G>>2]=(c[G>>2]|0)+40;break}c[n>>2]=c[c[(c[(c[q>>2]|0)+8>>2]|0)+96>>2]>>2];$z(0,141458,n)|0;break a}while(0);c[F>>2]=(c[F>>2]|0)+40;Y=59}else Y=59;while(0);b:do if((Y|0)==59){Y=0;J=c[(c[(c[q>>2]|0)+8>>2]|0)+104>>2]|0;c[B>>2]=J;if(J){do if(a[(c[B>>2]|0)+81>>0]|0){J=c[B>>2]|0;w=c[F>>2]|0;c[g>>2]=c[z>>2];c[g+4>>2]=c[z+4>>2];c[g+8>>2]=c[z+8>>2];c[g+12>>2]=c[z+12>>2];c[g+16>>2]=c[z+16>>2];c[g+20>>2]=c[z+20>>2];c[g+24>>2]=c[z+24>>2];c[g+28>>2]=c[z+28>>2];xL(P,J,w,g);c[z>>2]=c[P>>2];c[z+4>>2]=c[P+4>>2];c[z+8>>2]=c[P+8>>2];c[z+12>>2]=c[P+12>>2];c[z+16>>2]=c[P+16>>2];c[z+20>>2]=c[P+20>>2];c[z+24>>2]=c[P+24>>2];c[z+28>>2]=c[P+28>>2]}else{if((c[I>>2]|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){w=c[B>>2]|0;J=c[F>>2]|0;x=c[G>>2]|0;zL(Q,c[q>>2]|0);c[g>>2]=c[Q>>2];c[g+4>>2]=c[Q+4>>2];c[g+8>>2]=c[Q+8>>2];c[g+12>>2]=c[Q+12>>2];yL(w,J,x,1,g);c[G>>2]=(c[G>>2]|0)+40;break}c[m>>2]=c[c[(c[(c[q>>2]|0)+8>>2]|0)+104>>2]>>2];$z(0,141493,m)|0;break b}while(0);c[F>>2]=(c[F>>2]|0)+40}x=c[(c[(c[q>>2]|0)+8>>2]|0)+100>>2]|0;c[B>>2]=x;if(x){do if(a[(c[B>>2]|0)+81>>0]|0){x=c[B>>2]|0;J=c[F>>2]|0;c[g>>2]=c[z>>2];c[g+4>>2]=c[z+4>>2];c[g+8>>2]=c[z+8>>2];c[g+12>>2]=c[z+12>>2];c[g+16>>2]=c[z+16>>2];c[g+20>>2]=c[z+20>>2];c[g+24>>2]=c[z+24>>2];c[g+28>>2]=c[z+28>>2];xL(R,x,J,g);c[z>>2]=c[R>>2];c[z+4>>2]=c[R+4>>2];c[z+8>>2]=c[R+8>>2];c[z+12>>2]=c[R+12>>2];c[z+16>>2]=c[R+16>>2];c[z+20>>2]=c[R+20>>2];c[z+24>>2]=c[R+24>>2];c[z+28>>2]=c[R+28>>2]}else{if((c[I>>2]|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){J=c[B>>2]|0;x=c[F>>2]|0;w=c[G>>2]|0;AL(S,c[q>>2]|0);c[g>>2]=c[S>>2];c[g+4>>2]=c[S+4>>2];c[g+8>>2]=c[S+8>>2];c[g+12>>2]=c[S+12>>2];yL(J,x,w,1,g);c[G>>2]=(c[G>>2]|0)+40;break}c[l>>2]=c[c[(c[(c[q>>2]|0)+8>>2]|0)+100>>2]>>2];$z(0,141533,l)|0;break b}while(0);c[F>>2]=(c[F>>2]|0)+40}w=c[(c[(c[q>>2]|0)+8>>2]|0)+108>>2]|0;c[B>>2]=w;if(w){do if(a[(c[B>>2]|0)+81>>0]|0){w=c[B>>2]|0;x=c[F>>2]|0;c[g>>2]=c[z>>2];c[g+4>>2]=c[z+4>>2];c[g+8>>2]=c[z+8>>2];c[g+12>>2]=c[z+12>>2];c[g+16>>2]=c[z+16>>2];c[g+20>>2]=c[z+20>>2];c[g+24>>2]=c[z+24>>2];c[g+28>>2]=c[z+28>>2];xL(T,w,x,g);c[z>>2]=c[T>>2];c[z+4>>2]=c[T+4>>2];c[z+8>>2]=c[T+8>>2];c[z+12>>2]=c[T+12>>2];c[z+16>>2]=c[T+16>>2];c[z+20>>2]=c[T+20>>2];c[z+24>>2]=c[T+24>>2];c[z+28>>2]=c[T+28>>2]}else{if((c[I>>2]|0)!=0?(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){x=c[B>>2]|0;w=c[F>>2]|0;J=c[G>>2]|0;rN(U,c[o>>2]|0,c[q>>2]|0);c[g>>2]=c[U>>2];c[g+4>>2]=c[U+4>>2];c[g+8>>2]=c[U+8>>2];c[g+12>>2]=c[U+12>>2];yL(x,w,J,1,g);c[G>>2]=(c[G>>2]|0)+40;break}c[k>>2]=c[c[(c[(c[q>>2]|0)+8>>2]|0)+108>>2]>>2];$z(0,141573,k)|0;break b}while(0);c[F>>2]=(c[F>>2]|0)+40}}while(0);c[q>>2]=QA(c[o>>2]|0,c[q>>2]|0)|0}c[p>>2]=aC(c[o>>2]|0,c[p>>2]|0)|0}if(c[y>>2]|0){c[V>>2]=c[z>>2];c[V+4>>2]=c[z+4>>2];c[V+8>>2]=c[z+8>>2];c[V+12>>2]=c[z+12>>2];c[V+16>>2]=c[z+16>>2];c[V+20>>2]=c[z+20>>2];c[V+24>>2]=c[z+24>>2];c[V+28>>2]=c[z+28>>2];c[V+32>>2]=c[F>>2];F=c[o>>2]|0;y=g;p=V;q=y+40|0;do{c[y>>2]=c[p>>2];y=y+4|0;p=p+4|0}while((y|0)<(q|0));BL(W,F,g);y=V;p=W;q=y+40|0;do{c[y>>2]=c[p>>2];y=y+4|0;p=p+4|0}while((y|0)<(q|0));c[z>>2]=c[V>>2];c[z+4>>2]=c[V+4>>2];c[z+8>>2]=c[V+8>>2];c[z+12>>2]=c[V+12>>2];c[z+16>>2]=c[V+16>>2];c[z+20>>2]=c[V+20>>2];c[z+24>>2]=c[V+24>>2];c[z+28>>2]=c[V+28>>2]}c[H>>2]=qA(c[o>>2]|0,0,141609,0)|0;a[C+32>>0]=jO(c[o>>2]|0,c[H>>2]|0,1)|0;c[C>>2]=c[z>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];c[C+16>>2]=c[z+16>>2];c[C+20>>2]=c[z+20>>2];c[C+24>>2]=c[z+24>>2];c[C+28>>2]=c[z+28>>2];JS(c[D>>2]|0,c[t>>2]|0,c[E>>2]|0,c[u>>2]|0,C)|0;if(a[138998]|0)CL(c[D>>2]|0,c[t>>2]|0,c[E>>2]|0,c[u>>2]|0,C)|0;c[G>>2]=c[E>>2];c[r>>2]=0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[u>>2]|0))break;if(a[(c[G>>2]|0)+36>>0]|0){c[r>>2]=(c[r>>2]|0)+1;c[B>>2]=c[(c[G>>2]|0)+32>>2];a[(c[B>>2]|0)+81>>0]=1;C=(c[B>>2]|0)+56|0;DL(X,c[G>>2]|0);c[C>>2]=c[X>>2];c[C+4>>2]=c[X+4>>2];c[C+8>>2]=c[X+8>>2];c[C+12>>2]=c[X+12>>2];AO(c[o>>2]|0,c[B>>2]|0)}c[G>>2]=(c[G>>2]|0)+40;c[s>>2]=(c[s>>2]|0)+1}if(!(a[138998]|0)){if((c[r>>2]|0)!=(c[u>>2]|0)){s=c[u>>2]|0;c[h>>2]=c[r>>2];c[h+4>>2]=s;$z(0,141654,h)|0}}else{h=c[24742]|0;s=c[u>>2]|0;c[j>>2]=c[r>>2];c[j+4>>2]=s;Y2(h,141621,j)|0}O4(c[D>>2]|0);O4(c[E>>2]|0);i=f;return}function sL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0;b=i;i=i+64|0;d=b+32|0;e=b+60|0;f=b+56|0;g=b+52|0;j=b+48|0;k=b+16|0;l=b;c[e>>2]=a;c[j>>2]=(+h[4262]!=0.0?1:+h[4263]!=0.0)&1;if(!((c[j>>2]|0)!=0|(c[13984]|0)!=0)){i=b;return}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;if(c[13984]|0)VO(c[f>>2]|0,0);j=(c[(c[f>>2]|0)+8>>2]|0)+16|0;a=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[d>>2]=c[a>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];pL(k,d);c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];if(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0){j=(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;a=(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;c[d>>2]=c[a>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];pL(l,d);c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2]}a:do if((c[13800]|0)==1){c[g>>2]=OA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break a;uL(c[g>>2]|0);c[g>>2]=QA(c[e>>2]|0,c[g>>2]|0)|0}}while(0);c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}kL(c[e>>2]|0,c[(c[(c[e>>2]|0)+8>>2]|0)+116>>2]&3);i=b;return}function tL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0;e=i;i=i+32|0;f=e+16|0;g=e;c[f>>2]=b;b=c[(c[f>>2]|0)+8>>2]|0;do if(!(a[(c[(c[f>>2]|0)+8>>2]|0)+275>>0]&4)){j=+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3];if(a[b+275>>0]&2){h[g>>3]=j+ +h[d>>3]/2.0;break}else{h[g>>3]=(j+ +h[(c[(c[f>>2]|0)+8>>2]|0)+16+16>>3])/2.0;break}}else h[g>>3]=+h[b+16+16>>3]-+h[d>>3]/2.0;while(0);b=(c[(c[f>>2]|0)+8>>2]|0)+16|0;if(a[(c[(c[f>>2]|0)+8>>2]|0)+275>>0]&1)h[g+8>>3]=+h[b+16+8>>3]-+h[d+8>>3]/2.0;else h[g+8>>3]=+h[b+8>>3]+ +h[d+8>>3]/2.0;d=(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];a[(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]=1;i=e;return}function uL(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+208|0;f=e+168|0;g=e+80|0;h=e+192|0;j=e+188|0;k=e+184|0;l=e+120|0;m=e+104|0;n=e+88|0;o=e+64|0;p=e+48|0;q=e+32|0;r=e+16|0;s=e;c[h>>2]=b;if(!(c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0)){if(d[139e3]|0){i=e;return}if((a[(c[(c[h>>2]|0)+8>>2]|0)+112>>0]|0)==6){i=e;return}b=c[h>>2]|0;t=wB(c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0;b=c[h>>2]|0;u=wB(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)|0;c[g>>2]=t;c[g+4>>2]=u;$z(1,141441,g)|0;i=e;return}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;g=l;u=(c[c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[j>>2]|0)*48|0)|0;t=g+48|0;do{c[g>>2]=c[u>>2];g=g+4|0;u=u+4|0}while((g|0)<(t|0));c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[l+4>>2]|0))break;u=(c[l>>2]|0)+(c[k>>2]<<4)|0;g=(c[l>>2]|0)+(c[k>>2]<<4)|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];pL(m,f);c[u>>2]=c[m>>2];c[u+4>>2]=c[m+4>>2];c[u+8>>2]=c[m+8>>2];c[u+12>>2]=c[m+12>>2];c[k>>2]=(c[k>>2]|0)+1}if(c[l+8>>2]|0){u=(c[c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[j>>2]|0)*48|0)+16|0;g=(c[c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[j>>2]|0)*48|0)+16|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];pL(n,f);c[u>>2]=c[n>>2];c[u+4>>2]=c[n+4>>2];c[u+8>>2]=c[n+8>>2];c[u+12>>2]=c[n+12>>2]}if(c[l+12>>2]|0){u=(c[c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[j>>2]|0)*48|0)+32|0;g=(c[c[(c[(c[h>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+((c[j>>2]|0)*48|0)+32|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];pL(o,f);c[u>>2]=c[o>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2]}c[j>>2]=(c[j>>2]|0)+1}if(c[(c[(c[h>>2]|0)+8>>2]|0)+96>>2]|0){j=(c[(c[(c[h>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;o=(c[(c[(c[h>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];pL(p,f);c[j>>2]=c[p>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2]}if(c[(c[(c[h>>2]|0)+8>>2]|0)+108>>2]|0){p=(c[(c[(c[h>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;j=(c[(c[(c[h>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];pL(q,f);c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2]}if(c[(c[(c[h>>2]|0)+8>>2]|0)+100>>2]|0){q=(c[(c[(c[h>>2]|0)+8>>2]|0)+100>>2]|0)+56|0;p=(c[(c[(c[h>>2]|0)+8>>2]|0)+100>>2]|0)+56|0;c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];pL(r,f);c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2]}if(!(c[(c[(c[h>>2]|0)+8>>2]|0)+104>>2]|0)){i=e;return}r=(c[(c[(c[h>>2]|0)+8>>2]|0)+104>>2]|0)+56|0;q=(c[(c[(c[h>>2]|0)+8>>2]|0)+104>>2]|0)+56|0;c[f>>2]=c[q>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];c[f+12>>2]=c[q+12>>2];pL(s,f);c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];i=e;return}function vL(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[g>>2]=0;a=c[e>>2]|0;if(((a|0)!=(rC(c[e>>2]|0)|0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0)?(d[(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0|0)!=0:0)c[g>>2]=(c[g>>2]|0)+1;c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;a=vL(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2]|0)|0;c[g>>2]=(c[g>>2]|0)+a;c[f>>2]=(c[f>>2]|0)+1}i=b;return c[g>>2]|0}function wL(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+48|0;j=g;k=g+36|0;l=g+32|0;c[k>>2]=d;c[l>>2]=e;e=c[(c[k>>2]|0)+8>>2]|0;if(a[140430]|0){h[(c[l>>2]|0)+16>>3]=+h[e+40>>3]*72.0;h[(c[l>>2]|0)+16+8>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+32>>3]*72.0}else{h[(c[l>>2]|0)+16>>3]=+h[e+32>>3]*72.0;h[(c[l>>2]|0)+16+8>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+40>>3]*72.0}e=c[l>>2]|0;d=(c[(c[k>>2]|0)+8>>2]|0)+16|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=c[l>>2]|0;h[d>>3]=+h[d>>3]-+h[(c[l>>2]|0)+16>>3]/2.0;d=(c[l>>2]|0)+8|0;h[d>>3]=+h[d>>3]-+h[(c[l>>2]|0)+16+8>>3]/2.0;d=c[l>>2]|0;c[j>>2]=c[f>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];c[j+24>>2]=c[f+24>>2];c[j+28>>2]=c[f+28>>2];EL(b,d,j);i=g;return}function xL(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+48|0;j=g;k=g+36|0;l=g+32|0;c[k>>2]=d;c[l>>2]=e;e=(c[k>>2]|0)+24|0;if(a[140430]|0){h[(c[l>>2]|0)+16>>3]=+h[e+8>>3];h[(c[l>>2]|0)+16+8>>3]=+h[(c[k>>2]|0)+24>>3]}else{h[(c[l>>2]|0)+16>>3]=+h[e>>3];h[(c[l>>2]|0)+16+8>>3]=+h[(c[k>>2]|0)+24+8>>3]}e=c[l>>2]|0;d=(c[k>>2]|0)+56|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];d=c[l>>2]|0;h[d>>3]=+h[d>>3]-+h[(c[l>>2]|0)+16>>3]/2.0;d=(c[l>>2]|0)+8|0;h[d>>3]=+h[d>>3]-+h[(c[l>>2]|0)+16+8>>3]/2.0;d=c[l>>2]|0;c[j>>2]=c[f>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[j+16>>2]=c[f+16>>2];c[j+20>>2]=c[f+20>>2];c[j+24>>2]=c[f+24>>2];c[j+28>>2]=c[f+28>>2];EL(b,d,j);i=g;return}function yL(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+16|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if(c[n>>2]|0){h[(c[l>>2]|0)+16>>3]=0.0;h[(c[l>>2]|0)+16+8>>3]=0.0;n=c[l>>2]|0;c[n>>2]=c[g>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];c[n+12>>2]=c[g+12>>2]}if(a[140430]|0){h[c[m>>2]>>3]=+h[(c[k>>2]|0)+24+8>>3];h[(c[m>>2]|0)+8>>3]=+h[(c[k>>2]|0)+24>>3]}else{g=c[m>>2]|0;n=(c[k>>2]|0)+24|0;c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2]}c[(c[m>>2]|0)+32>>2]=c[k>>2];a[(c[m>>2]|0)+36>>0]=0;c[(c[l>>2]|0)+32>>2]=c[m>>2];i=j;return}function zL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;j=d;c[e>>2]=b;b=tN(c[e>>2]|0)|0;c[f>>2]=b;if(!b){h[j+8>>3]=0.0;h[j>>3]=0.0;c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=d;return}c[g>>2]=c[c[f>>2]>>2];f=c[g>>2]|0;if(c[(c[g>>2]|0)+8>>2]|0){g=f+16|0;c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=d;return}else{g=c[f>>2]|0;c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];i=d;return}}function AL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;j=d;c[e>>2]=b;b=tN(c[e>>2]|0)|0;c[f>>2]=b;if(!b){h[j+8>>3]=0.0;h[j>>3]=0.0;c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=d;return}c[g>>2]=(c[c[f>>2]>>2]|0)+(((c[(c[f>>2]|0)+4>>2]|0)-1|0)*48|0);f=c[g>>2]|0;if(c[(c[g>>2]|0)+12>>2]|0){j=f+32|0;c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=d;return}else{j=(c[c[g>>2]>>2]|0)+((c[f+4>>2]|0)-1<<4)|0;c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=d;return}}function BL(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+128|0;g=f+72|0;h=f+120|0;j=f+116|0;k=f+32|0;l=f+112|0;m=f;c[h>>2]=b;c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[h>>2]|0)+8>>2]|0)+180>>2]|0))break;b=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2]|0;n=g;o=e;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));BL(k,b,g);n=e;o=k;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));c[j>>2]=(c[j>>2]|0)+1}j=c[h>>2]|0;if((j|0)==(rC(c[h>>2]|0)|0)){n=a;o=e;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));i=f;return}if(!(c[(c[(c[h>>2]|0)+8>>2]|0)+12>>2]|0)){n=a;o=e;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));i=f;return}if(!(d[(c[(c[(c[h>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0)){n=a;o=e;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));i=f;return}c[l>>2]=c[e+32>>2];j=c[(c[(c[h>>2]|0)+8>>2]|0)+12>>2]|0;h=c[l>>2]|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];xL(m,j,h,g);c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];c[e+20>>2]=c[m+20>>2];c[e+24>>2]=c[m+24>>2];c[e+28>>2]=c[m+28>>2];m=e+32|0;c[m>>2]=(c[m>>2]|0)+40;n=a;o=e;p=n+40|0;do{c[n>>2]=c[o>>2];n=n+4|0;o=o+4|0}while((n|0)<(p|0));i=f;return}
function _Y(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;m=i;i=i+176|0;n=m+160|0;o=m+156|0;p=m+152|0;q=m+148|0;r=m+144|0;s=m+140|0;t=m+136|0;u=m+132|0;v=m+168|0;w=m+128|0;x=m+124|0;y=m+120|0;z=m+116|0;A=m+112|0;B=m+167|0;C=m+108|0;D=m+104|0;E=m+100|0;F=m+96|0;G=m+166|0;H=m+92|0;I=m+165|0;J=m+88|0;K=m+84|0;L=m+80|0;M=m+76|0;N=m+72|0;O=m+68|0;P=m+64|0;Q=m+60|0;R=m+56|0;S=m+52|0;T=m+48|0;U=m+44|0;V=m+40|0;W=m+36|0;X=m+32|0;Y=m+28|0;Z=m+164|0;_=m+24|0;$=m+20|0;aa=m+16|0;ba=m+12|0;ca=m+8|0;da=m+4|0;ea=m;c[o>>2]=b;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=h;c[t>>2]=j;c[u>>2]=k;a[v>>0]=l;c[w>>2]=c[(c[o>>2]|0)+356>>2];l=c[o>>2]|0;if((c[p>>2]|0)==(c[(c[o>>2]|0)+144>>2]|0)){c[x>>2]=l+288;c[y>>2]=(c[o>>2]|0)+292}else{c[x>>2]=c[l+300>>2];c[y>>2]=(c[(c[o>>2]|0)+300>>2]|0)+4}a:while(1){a[B>>0]=1;c[c[x>>2]>>2]=c[q>>2];c[c[y>>2]>>2]=c[t>>2];b:do if((c[s>>2]|0)<=0){if((d[v>>0]|0)!=0&(c[s>>2]|0)!=0){fa=6;break a}switch(c[s>>2]|0){case 0:{fa=8;break a;break}case -1:{fa=9;break a;break}case -2:{fa=10;break a;break}case -4:{fa=12;break a;break}case -15:{c[s>>2]=0-(c[s>>2]|0);break b;break}default:{c[s>>2]=0-(c[s>>2]|0);c[t>>2]=c[r>>2];break b}}}while(0);c[A>>2]=Gb[c[(c[o>>2]|0)+256>>2]&63]((c[o>>2]|0)+256|0,c[s>>2]|0,c[q>>2]|0,c[t>>2]|0,c[p>>2]|0)|0;c:do switch(c[A>>2]|0){case 2:{fa=74;break a;break}case -1:{fa=231;break a;break}case 1:{c[C>>2]=$Y(c[o>>2]|0,0,c[q>>2]|0,c[t>>2]|0)|0;if(c[C>>2]|0){fa=24;break a}c[p>>2]=c[(c[o>>2]|0)+144>>2];a[B>>0]=0;break}case 4:{if(c[(c[o>>2]|0)+84>>2]|0){l=aZ((c[o>>2]|0)+416|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0;c[(c[o>>2]|0)+320>>2]=l;if(!(c[(c[o>>2]|0)+320>>2]|0)){fa=28;break a}c[(c[o>>2]|0)+416+16>>2]=c[(c[o>>2]|0)+416+12>>2];c[(c[o>>2]|0)+328>>2]=0;a[B>>0]=0}c[(c[o>>2]|0)+324>>2]=0;break}case 7:{if(c[(c[o>>2]|0)+84>>2]|0){Ab[c[(c[o>>2]|0)+84>>2]&31](c[(c[o>>2]|0)+4>>2]|0,c[(c[o>>2]|0)+320>>2]|0,c[(c[o>>2]|0)+324>>2]|0,c[(c[o>>2]|0)+328>>2]|0,1);c[(c[o>>2]|0)+320>>2]=0;KY((c[o>>2]|0)+416|0);a[B>>0]=0}break}case 57:{c[D>>2]=$Y(c[o>>2]|0,1,c[q>>2]|0,c[t>>2]|0)|0;if(c[D>>2]|0){fa=34;break a}c[p>>2]=c[(c[o>>2]|0)+144>>2];a[B>>0]=0;break}case 6:{a[(c[o>>2]|0)+489>>0]=0;l=bZ(c[o>>2]|0,(c[w>>2]|0)+132|0,112589,36)|0;c[(c[o>>2]|0)+316>>2]=l;if(!(c[(c[o>>2]|0)+316>>2]|0)){fa=37;break a}a[(c[w>>2]|0)+129>>0]=1;if(c[(c[o>>2]|0)+84>>2]|0){if(!(Sb[c[(c[p>>2]|0)+56>>2]&127](c[p>>2]|0,c[q>>2]|0,c[t>>2]|0,c[x>>2]|0)|0)){fa=40;break a}c[E>>2]=aZ((c[o>>2]|0)+416|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;if(!(c[E>>2]|0)){fa=42;break a}cZ(c[E>>2]|0);c[(c[o>>2]|0)+416+16>>2]=c[(c[o>>2]|0)+416+12>>2];c[(c[o>>2]|0)+328>>2]=c[E>>2];a[B>>0]=0;fa=46}else fa=44;break}case 14:{fa=44;break}case 8:{if(c[(c[o>>2]|0)+320>>2]|0){Ab[c[(c[o>>2]|0)+84>>2]&31](c[(c[o>>2]|0)+4>>2]|0,c[(c[o>>2]|0)+320>>2]|0,c[(c[o>>2]|0)+324>>2]|0,c[(c[o>>2]|0)+328>>2]|0,0);KY((c[o>>2]|0)+416|0);a[B>>0]=0}if(!((c[(c[o>>2]|0)+324>>2]|0)==0?(d[(c[o>>2]|0)+489>>0]|0)==0:0)){a[G>>0]=a[(c[w>>2]|0)+129>>0]|0;a[(c[w>>2]|0)+129>>0]=1;do if((c[(c[o>>2]|0)+492>>2]|0)!=0?(c[(c[o>>2]|0)+112>>2]|0)!=0:0){c[H>>2]=bZ(c[o>>2]|0,(c[w>>2]|0)+132|0,112589,36)|0;if(!(c[H>>2]|0)){fa=59;break a}if(a[(c[o>>2]|0)+489>>0]|0)c[(c[H>>2]|0)+20>>2]=c[(c[o>>2]|0)+360>>2];a[(c[w>>2]|0)+131>>0]=0;if(!(Gb[c[(c[o>>2]|0)+112>>2]&63](c[(c[o>>2]|0)+116>>2]|0,0,c[(c[H>>2]|0)+20>>2]|0,c[(c[H>>2]|0)+16>>2]|0,c[(c[H>>2]|0)+24>>2]|0)|0)){fa=63;break a}if(!(a[(c[w>>2]|0)+131>>0]|0)){if(c[(c[o>>2]|0)+324>>2]|0)break;a[(c[w>>2]|0)+129>>0]=a[G>>0]|0;break}if(((a[(c[w>>2]|0)+130>>0]|0)==0?(c[(c[o>>2]|0)+108>>2]|0)!=0:0)?(Fb[c[(c[o>>2]|0)+108>>2]&63](c[(c[o>>2]|0)+4>>2]|0)|0)==0:0){fa=68;break a}}while(0);a[(c[o>>2]|0)+489>>0]=0}if(c[(c[o>>2]|0)+88>>2]|0){Bb[c[(c[o>>2]|0)+88>>2]&127](c[(c[o>>2]|0)+4>>2]|0);a[B>>0]=0}break}case 34:{l=eZ(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0;c[(c[o>>2]|0)+344>>2]=l;if(c[(c[o>>2]|0)+344>>2]|0)fa=101;else{fa=89;break a}break}case 22:{l=fZ(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0;c[(c[o>>2]|0)+348>>2]=l;if(!(c[(c[o>>2]|0)+348>>2]|0)){fa=91;break a}a[(c[o>>2]|0)+352>>0]=0;c[(c[o>>2]|0)+332>>2]=0;a[(c[o>>2]|0)+353>>0]=0;fa=101;break}case 23:{a[(c[o>>2]|0)+352>>0]=1;c[(c[o>>2]|0)+332>>2]=181442;fa=101;break}case 24:{a[(c[o>>2]|0)+353>>0]=1;c[(c[o>>2]|0)+332>>2]=181448;fa=101;break}case 25:{c[(c[o>>2]|0)+332>>2]=181451;fa=101;break}case 26:{c[(c[o>>2]|0)+332>>2]=181457;fa=101;break}case 27:{c[(c[o>>2]|0)+332>>2]=181464;fa=101;break}case 28:{c[(c[o>>2]|0)+332>>2]=181471;fa=101;break}case 29:{c[(c[o>>2]|0)+332>>2]=181480;fa=101;break}case 30:{c[(c[o>>2]|0)+332>>2]=181488;fa=101;break}case 32:case 31:{if((d[(c[w>>2]|0)+128>>0]|0)!=0?(c[(c[o>>2]|0)+132>>2]|0)!=0:0){if(c[(c[o>>2]|0)+332>>2]|0)c[K>>2]=181497;else c[K>>2]=(c[A>>2]|0)==32?181499:181509;if(!(gZ((c[o>>2]|0)+416|0,c[K>>2]|0)|0)){fa=110;break a}if(!(hZ((c[o>>2]|0)+416|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0)){fa=112;break a}c[(c[o>>2]|0)+332>>2]=c[(c[o>>2]|0)+416+16>>2];a[B>>0]=0}break}case 36:case 35:{if(a[(c[w>>2]|0)+128>>0]|0){if(!(iZ(c[(c[o>>2]|0)+344>>2]|0,c[(c[o>>2]|0)+348>>2]|0,a[(c[o>>2]|0)+352>>0]|0,a[(c[o>>2]|0)+353>>0]|0,0,c[o>>2]|0)|0)){fa=116;break a}if((c[(c[o>>2]|0)+132>>2]|0)!=0?(c[(c[o>>2]|0)+332>>2]|0)!=0:0){if((a[c[(c[o>>2]|0)+332>>2]>>0]|0)!=40){if((a[c[(c[o>>2]|0)+332>>2]>>0]|0)==78?(a[(c[(c[o>>2]|0)+332>>2]|0)+1>>0]|0)==79:0)fa=122}else fa=122;if((fa|0)==122){fa=0;if((c[(c[o>>2]|0)+416+12>>2]|0)==(c[(c[o>>2]|0)+416+8>>2]|0)?(jZ((c[o>>2]|0)+416|0)|0)<<24>>24==0:0){fa=127;break a}l=(c[o>>2]|0)+416+12|0;k=c[l>>2]|0;c[l>>2]=k+1;a[k>>0]=41;if((c[(c[o>>2]|0)+416+12>>2]|0)==(c[(c[o>>2]|0)+416+8>>2]|0)?(jZ((c[o>>2]|0)+416|0)|0)<<24>>24==0:0){fa=127;break a}k=(c[o>>2]|0)+416+12|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l>>0]=0;c[(c[o>>2]|0)+332>>2]=c[(c[o>>2]|0)+416+16>>2];c[(c[o>>2]|0)+416+16>>2]=c[(c[o>>2]|0)+416+12>>2]}c[c[y>>2]>>2]=c[q>>2];Ib[c[(c[o>>2]|0)+132>>2]&15](c[(c[o>>2]|0)+4>>2]|0,c[c[(c[o>>2]|0)+344>>2]>>2]|0,c[c[(c[o>>2]|0)+348>>2]>>2]|0,c[(c[o>>2]|0)+332>>2]|0,0,(c[A>>2]|0)==36&1);KY((c[o>>2]|0)+416|0);a[B>>0]=0}}break}case 38:case 37:{if(a[(c[w>>2]|0)+128>>0]|0){c[M>>2]=kZ(c[o>>2]|0,c[p>>2]|0,a[(c[o>>2]|0)+352>>0]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0,(c[w>>2]|0)+80|0)|0;if(c[M>>2]|0){fa=131;break a}c[L>>2]=c[(c[w>>2]|0)+80+16>>2];c[(c[w>>2]|0)+80+16>>2]=c[(c[w>>2]|0)+80+12>>2];if(!(iZ(c[(c[o>>2]|0)+344>>2]|0,c[(c[o>>2]|0)+348>>2]|0,a[(c[o>>2]|0)+352>>0]|0,0,c[L>>2]|0,c[o>>2]|0)|0)){fa=133;break a}if((c[(c[o>>2]|0)+132>>2]|0)!=0?(c[(c[o>>2]|0)+332>>2]|0)!=0:0){if((a[c[(c[o>>2]|0)+332>>2]>>0]|0)!=40){if((a[c[(c[o>>2]|0)+332>>2]>>0]|0)==78?(a[(c[(c[o>>2]|0)+332>>2]|0)+1>>0]|0)==79:0)fa=139}else fa=139;if((fa|0)==139){fa=0;if((c[(c[o>>2]|0)+416+12>>2]|0)==(c[(c[o>>2]|0)+416+8>>2]|0)?(jZ((c[o>>2]|0)+416|0)|0)<<24>>24==0:0){fa=144;break a}l=(c[o>>2]|0)+416+12|0;k=c[l>>2]|0;c[l>>2]=k+1;a[k>>0]=41;if((c[(c[o>>2]|0)+416+12>>2]|0)==(c[(c[o>>2]|0)+416+8>>2]|0)?(jZ((c[o>>2]|0)+416|0)|0)<<24>>24==0:0){fa=144;break a}k=(c[o>>2]|0)+416+12|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l>>0]=0;c[(c[o>>2]|0)+332>>2]=c[(c[o>>2]|0)+416+16>>2];c[(c[o>>2]|0)+416+16>>2]=c[(c[o>>2]|0)+416+12>>2]}c[c[y>>2]>>2]=c[q>>2];Ib[c[(c[o>>2]|0)+132>>2]&15](c[(c[o>>2]|0)+4>>2]|0,c[c[(c[o>>2]|0)+344>>2]>>2]|0,c[c[(c[o>>2]|0)+348>>2]>>2]|0,c[(c[o>>2]|0)+332>>2]|0,c[L>>2]|0,(c[A>>2]|0)==38&1);KY((c[o>>2]|0)+416|0);a[B>>0]=0}}break}case 12:{if(a[(c[w>>2]|0)+128>>0]|0){c[N>>2]=lZ(c[o>>2]|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;l=c[(c[w>>2]|0)+104+16>>2]|0;if(c[(c[o>>2]|0)+316>>2]|0){c[(c[(c[o>>2]|0)+316>>2]|0)+4>>2]=l;c[(c[(c[o>>2]|0)+316>>2]|0)+8>>2]=(c[(c[w>>2]|0)+104+12>>2]|0)-(c[(c[w>>2]|0)+104+16>>2]|0);c[(c[w>>2]|0)+104+16>>2]=c[(c[w>>2]|0)+104+12>>2];if(c[(c[o>>2]|0)+136>>2]|0){c[c[y>>2]>>2]=c[q>>2];Nb[c[(c[o>>2]|0)+136>>2]&0](c[(c[o>>2]|0)+4>>2]|0,c[c[(c[o>>2]|0)+316>>2]>>2]|0,d[(c[(c[o>>2]|0)+316>>2]|0)+33>>0]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+4>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+8>>2]|0,c[(c[o>>2]|0)+360>>2]|0,0,0,0);a[B>>0]=0}}else c[(c[w>>2]|0)+104+12>>2]=l;if(c[N>>2]|0){fa=152;break a}}break}case 5:{a[(c[o>>2]|0)+489>>0]=0;a[(c[w>>2]|0)+129>>0]=1;l=c[o>>2]|0;if(c[(c[o>>2]|0)+84>>2]|0){k=aZ(l+416|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;c[(c[o>>2]|0)+324>>2]=k;if(!(c[(c[o>>2]|0)+324>>2]|0)){fa=155;break a}c[(c[o>>2]|0)+416+16>>2]=c[(c[o>>2]|0)+416+12>>2];a[B>>0]=0}else c[l+324>>2]=112589;if((((a[(c[w>>2]|0)+130>>0]|0)==0?(c[(c[o>>2]|0)+492>>2]|0)==0:0)?(c[(c[o>>2]|0)+108>>2]|0)!=0:0)?(Fb[c[(c[o>>2]|0)+108>>2]&63](c[(c[o>>2]|0)+4>>2]|0)|0)==0:0){fa=162;break a}if(c[(c[o>>2]|0)+316>>2]|0)fa=167;else{l=bZ(c[o>>2]|0,(c[w>>2]|0)+132|0,112589,36)|0;c[(c[o>>2]|0)+316>>2]=l;if(!(c[(c[o>>2]|0)+316>>2]|0)){fa=165;break a}c[(c[(c[o>>2]|0)+316>>2]|0)+24>>2]=0;fa=167}break}case 13:{fa=167;break}case 15:{if(((d[(c[w>>2]|0)+128>>0]|0)!=0?(c[(c[o>>2]|0)+316>>2]|0)!=0:0)?(c[(c[o>>2]|0)+136>>2]|0)!=0:0){c[c[y>>2]>>2]=c[q>>2];Nb[c[(c[o>>2]|0)+136>>2]&0](c[(c[o>>2]|0)+4>>2]|0,c[c[(c[o>>2]|0)+316>>2]>>2]|0,d[(c[(c[o>>2]|0)+316>>2]|0)+33>>0]|0,0,0,c[(c[(c[o>>2]|0)+316>>2]|0)+20>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+16>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+24>>2]|0,0);a[B>>0]=0}break}case 16:{if((d[(c[w>>2]|0)+128>>0]|0)!=0?(c[(c[o>>2]|0)+316>>2]|0)!=0:0){l=aZ((c[w>>2]|0)+80|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0;c[(c[(c[o>>2]|0)+316>>2]|0)+28>>2]=l;if(!(c[(c[(c[o>>2]|0)+316>>2]|0)+28>>2]|0)){fa=180;break a}c[(c[w>>2]|0)+80+16>>2]=c[(c[w>>2]|0)+80+12>>2];if(c[(c[o>>2]|0)+92>>2]|0){c[c[y>>2]>>2]=c[q>>2];Ib[c[(c[o>>2]|0)+92>>2]&15](c[(c[o>>2]|0)+4>>2]|0,c[c[(c[o>>2]|0)+316>>2]>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+20>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+16>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+24>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+28>>2]|0);a[B>>0]=0;break c}if(c[(c[o>>2]|0)+136>>2]|0){c[c[y>>2]>>2]=c[q>>2];Nb[c[(c[o>>2]|0)+136>>2]&0](c[(c[o>>2]|0)+4>>2]|0,c[c[(c[o>>2]|0)+316>>2]>>2]|0,0,0,0,c[(c[(c[o>>2]|0)+316>>2]|0)+20>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+16>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+24>>2]|0,c[(c[(c[o>>2]|0)+316>>2]|0)+28>>2]|0);a[B>>0]=0}}break}case 9:{if(Hb[c[(c[p>>2]|0)+48>>2]&63](c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0){c[(c[o>>2]|0)+316>>2]=0;break c}l=(c[w>>2]|0)+80|0;if(!(a[(c[w>>2]|0)+128>>0]|0)){c[(c[w>>2]|0)+80+12>>2]=c[l+16>>2];c[(c[o>>2]|0)+316>>2]=0;break c}c[O>>2]=aZ(l,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0;if(!(c[O>>2]|0)){fa=189;break a}l=bZ(c[o>>2]|0,c[w>>2]|0,c[O>>2]|0,36)|0;c[(c[o>>2]|0)+316>>2]=l;if(!(c[(c[o>>2]|0)+316>>2]|0)){fa=191;break a}l=(c[w>>2]|0)+80|0;if((c[c[(c[o>>2]|0)+316>>2]>>2]|0)!=(c[O>>2]|0)){c[(c[w>>2]|0)+80+12>>2]=c[l+16>>2];c[(c[o>>2]|0)+316>>2]=0;break c}c[(c[w>>2]|0)+80+16>>2]=c[l+12>>2];c[(c[(c[o>>2]|0)+316>>2]|0)+24>>2]=0;a[(c[(c[o>>2]|0)+316>>2]|0)+33>>0]=0;if(c[(c[o>>2]|0)+476>>2]|0)ga=1;else ga=(c[(c[o>>2]|0)+300>>2]|0)!=0;a[(c[(c[o>>2]|0)+316>>2]|0)+34>>0]=(ga^1)&1;if(c[(c[o>>2]|0)+136>>2]|0)a[B>>0]=0;break}case 10:{l=(c[w>>2]|0)+80|0;if(!(a[(c[w>>2]|0)+128>>0]|0)){c[(c[w>>2]|0)+80+12>>2]=c[l+16>>2];c[(c[o>>2]|0)+316>>2]=0;break c}c[P>>2]=aZ(l,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0;if(!(c[P>>2]|0)){fa=201;break a}l=bZ(c[o>>2]|0,(c[w>>2]|0)+132|0,c[P>>2]|0,36)|0;c[(c[o>>2]|0)+316>>2]=l;if(!(c[(c[o>>2]|0)+316>>2]|0)){fa=203;break a}l=(c[w>>2]|0)+80|0;if((c[c[(c[o>>2]|0)+316>>2]>>2]|0)!=(c[P>>2]|0)){c[(c[w>>2]|0)+80+12>>2]=c[l+16>>2];c[(c[o>>2]|0)+316>>2]=0;break c}c[(c[w>>2]|0)+80+16>>2]=c[l+12>>2];c[(c[(c[o>>2]|0)+316>>2]|0)+24>>2]=0;a[(c[(c[o>>2]|0)+316>>2]|0)+33>>0]=1;if(c[(c[o>>2]|0)+476>>2]|0)ha=1;else ha=(c[(c[o>>2]|0)+300>>2]|0)!=0;a[(c[(c[o>>2]|0)+316>>2]|0)+34>>0]=(ha^1)&1;if(c[(c[o>>2]|0)+136>>2]|0)a[B>>0]=0;break}case 18:{c[(c[o>>2]|0)+340>>2]=0;c[(c[o>>2]|0)+336>>2]=0;if(c[(c[o>>2]|0)+96>>2]|0){l=aZ((c[o>>2]|0)+416|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0;c[(c[o>>2]|0)+336>>2]=l;if(!(c[(c[o>>2]|0)+336>>2]|0)){fa=213;break a}c[(c[o>>2]|0)+416+16>>2]=c[(c[o>>2]|0)+416+12>>2];a[B>>0]=0}break}case 21:{if(!(Sb[c[(c[p>>2]|0)+56>>2]&127](c[p>>2]|0,c[q>>2]|0,c[t>>2]|0,c[x>>2]|0)|0)){fa=216;break a}if(c[(c[o>>2]|0)+336>>2]|0){c[Q>>2]=aZ((c[o>>2]|0)+416|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;if(!(c[Q>>2]|0)){fa=219;break a}cZ(c[Q>>2]|0);c[(c[o>>2]|0)+340>>2]=c[Q>>2];c[(c[o>>2]|0)+416+16>>2]=c[(c[o>>2]|0)+416+12>>2];a[B>>0]=0}break}case 19:{if((c[(c[o>>2]|0)+336>>2]|0)!=0?(c[(c[o>>2]|0)+96>>2]|0)!=0:0){c[R>>2]=aZ((c[o>>2]|0)+416|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;if(!(c[R>>2]|0)){fa=224;break a}c[c[y>>2]>>2]=c[q>>2];Ab[c[(c[o>>2]|0)+96>>2]&31](c[(c[o>>2]|0)+4>>2]|0,c[(c[o>>2]|0)+336>>2]|0,c[(c[o>>2]|0)+360>>2]|0,c[R>>2]|0,c[(c[o>>2]|0)+340>>2]|0);a[B>>0]=0}KY((c[o>>2]|0)+416|0);break}case 20:{if((c[(c[o>>2]|0)+340>>2]|0)!=0?(c[(c[o>>2]|0)+96>>2]|0)!=0:0){c[c[y>>2]>>2]=c[q>>2];Ab[c[(c[o>>2]|0)+96>>2]&31](c[(c[o>>2]|0)+4>>2]|0,c[(c[o>>2]|0)+336>>2]|0,c[(c[o>>2]|0)+360>>2]|0,0,c[(c[o>>2]|0)+340>>2]|0);a[B>>0]=0}KY((c[o>>2]|0)+416|0);break}case 58:{if(c[(c[o>>2]|0)+80>>2]|0)TY(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0);a[B>>0]=0;c[S>>2]=mZ(c[o>>2]|0,c[p>>2]|0,t,c[r>>2]|0,c[u>>2]|0,a[v>>0]|0)|0;if(c[S>>2]|0){fa=238;break a}if(!(c[t>>2]|0)){fa=240;break a}break}case 44:{do if((c[(c[o>>2]|0)+256+4>>2]|0)>>>0>=(c[(c[o>>2]|0)+468>>2]|0)>>>0){l=(c[o>>2]|0)+12|0;if(!(c[(c[o>>2]|0)+468>>2]|0)){k=c[l>>2]|0;c[(c[o>>2]|0)+468>>2]=32;j=Fb[k&63](32)|0;c[(c[o>>2]|0)+464>>2]=j;if(c[(c[o>>2]|0)+464>>2]|0)break;else{fa=250;break a}}j=c[l+4>>2]|0;l=c[(c[o>>2]|0)+464>>2]|0;k=(c[o>>2]|0)+468|0;h=c[k>>2]<<1;c[k>>2]=h;c[T>>2]=Ob[j&127](l,h)|0;if(!(c[T>>2]|0)){fa=244;break a}c[(c[o>>2]|0)+464>>2]=c[T>>2];if(c[(c[w>>2]|0)+184>>2]|0){c[U>>2]=Ob[c[(c[o>>2]|0)+12+4>>2]&127](c[(c[w>>2]|0)+184>>2]|0,c[(c[o>>2]|0)+468>>2]<<2)|0;if(!(c[U>>2]|0)){fa=247;break a}c[(c[w>>2]|0)+184>>2]=c[U>>2]}}while(0);a[(c[(c[o>>2]|0)+464>>2]|0)+(c[(c[o>>2]|0)+256+4>>2]|0)>>0]=0;if(a[(c[w>>2]|0)+160>>0]|0){c[V>>2]=oZ(c[o>>2]|0)|0;if((c[V>>2]|0)<0){fa=253;break a}c[(c[(c[w>>2]|0)+184>>2]|0)+(c[(c[w>>2]|0)+180>>2]<<2)>>2]=c[V>>2];h=(c[w>>2]|0)+180|0;c[h>>2]=(c[h>>2]|0)+1;c[(c[(c[w>>2]|0)+164>>2]|0)+((c[V>>2]|0)*28|0)>>2]=6;if(c[(c[o>>2]|0)+128>>2]|0)a[B>>0]=0}break}case 50:{if((a[(c[(c[o>>2]|0)+464>>2]|0)+(c[(c[o>>2]|0)+256+4>>2]|0)>>0]|0)==124){fa=257;break a}a[(c[(c[o>>2]|0)+464>>2]|0)+(c[(c[o>>2]|0)+256+4>>2]|0)>>0]=44;if((d[(c[w>>2]|0)+160>>0]|0)!=0?(c[(c[o>>2]|0)+128>>2]|0)!=0:0)a[B>>0]=0;break}case 49:{if((a[(c[(c[o>>2]|0)+464>>2]|0)+(c[(c[o>>2]|0)+256+4>>2]|0)>>0]|0)==44){fa=262;break a}if((((d[(c[w>>2]|0)+160>>0]|0)!=0?(a[(c[(c[o>>2]|0)+464>>2]|0)+(c[(c[o>>2]|0)+256+4>>2]|0)>>0]|0)==0:0)?(c[(c[(c[w>>2]|0)+164>>2]|0)+((c[(c[(c[w>>2]|0)+184>>2]|0)+((c[(c[w>>2]|0)+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)!=3:0)?(c[(c[(c[w>>2]|0)+164>>2]|0)+((c[(c[(c[w>>2]|0)+184>>2]|0)+((c[(c[w>>2]|0)+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5,(c[(c[o>>2]|0)+128>>2]|0)!=0):0)a[B>>0]=0;a[(c[(c[o>>2]|0)+464>>2]|0)+(c[(c[o>>2]|0)+256+4>>2]|0)>>0]=124;break}case 59:case 60:{a[(c[w>>2]|0)+129>>0]=1;h=c[w>>2]|0;if(c[(c[o>>2]|0)+492>>2]|0){c[W>>2]=aZ(h+80|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;if(!(c[W>>2]|0)){fa=272;break a}c[X>>2]=bZ(c[o>>2]|0,(c[w>>2]|0)+132|0,c[W>>2]|0,0)|0;c[(c[w>>2]|0)+80+12>>2]=c[(c[w>>2]|0)+80+16>>2];do if(c[(c[o>>2]|0)+256+16>>2]|0){if(d[(c[w>>2]|0)+130>>0]|0){if(c[(c[o>>2]|0)+300>>2]|0){fa=281;break}}else if(a[(c[w>>2]|0)+129>>0]|0){fa=281;break}if(!(c[X>>2]|0)){fa=278;break a}if(!(a[(c[X>>2]|0)+34>>0]|0)){fa=280;break a}}else fa=281;while(0);if((fa|0)==281?(fa=0,(c[X>>2]|0)==0):0){a[(c[w>>2]|0)+128>>0]=a[(c[w>>2]|0)+130>>0]|0;if((c[A>>2]|0)!=60)break c;if(!(c[(c[o>>2]|0)+120>>2]|0))break c;Tb[c[(c[o>>2]|0)+120>>2]&127](c[(c[o>>2]|0)+4>>2]|0,c[W>>2]|0,1);a[B>>0]=0;break c}if(a[(c[X>>2]|0)+32>>0]|0){fa=286;break a}if(c[(c[X>>2]|0)+4>>2]|0){a[Z>>0]=(c[A>>2]|0)==60?1:0;c[Y>>2]=pZ(c[o>>2]|0,c[X>>2]|0,a[Z>>0]|0)|0;if(c[Y>>2]|0){fa=289;break a}a[B>>0]=0;break c}l=c[w>>2]|0;if(!(c[(c[o>>2]|0)+112>>2]|0)){a[(c[w>>2]|0)+128>>0]=a[l+130>>0]|0;break c}a[l+131>>0]=0;a[(c[X>>2]|0)+32>>0]=1;l=(Gb[c[(c[o>>2]|0)+112>>2]&63](c[(c[o>>2]|0)+116>>2]|0,0,c[(c[X>>2]|0)+20>>2]|0,c[(c[X>>2]|0)+16>>2]|0,c[(c[X>>2]|0)+24>>2]|0)|0)!=0;a[(c[X>>2]|0)+32>>0]=0;if(!l){fa=293;break a}a[B>>0]=0;if(!(a[(c[w>>2]|0)+131>>0]|0)){a[(c[w>>2]|0)+128>>0]=a[(c[w>>2]|0)+130>>0]|0;break c}}else a[(c[w>>2]|0)+128>>0]=a[h+130>>0]|0;if(((a[(c[w>>2]|0)+130>>0]|0)==0?(c[(c[o>>2]|0)+108>>2]|0)!=0:0)?(Fb[c[(c[o>>2]|0)+108>>2]&63](c[(c[o>>2]|0)+4>>2]|0)|0)==0:0){fa=300;break a}break}case 40:{if(c[(c[o>>2]|0)+128>>2]|0){l=eZ(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0;c[(c[o>>2]|0)+344>>2]=l;if(!(c[(c[o>>2]|0)+344>>2]|0)){fa=303;break a}c[(c[w>>2]|0)+180>>2]=0;c[(c[w>>2]|0)+176>>2]=0;a[(c[w>>2]|0)+160>>0]=1;a[B>>0]=0}break}case 42:case 41:{if(a[(c[w>>2]|0)+160>>0]|0){if(c[(c[o>>2]|0)+128>>2]|0){c[_>>2]=Fb[c[(c[o>>2]|0)+12>>2]&63](20)|0;if(!(c[_>>2]|0)){fa=308;break a}c[(c[_>>2]|0)+4>>2]=0;c[(c[_>>2]|0)+8>>2]=0;c[(c[_>>2]|0)+12>>2]=0;c[(c[_>>2]|0)+16>>2]=0;c[c[_>>2]>>2]=(c[A>>2]|0)==41?2:1;c[c[y>>2]>>2]=c[q>>2];Tb[c[(c[o>>2]|0)+128>>2]&127](c[(c[o>>2]|0)+4>>2]|0,c[c[(c[o>>2]|0)+344>>2]>>2]|0,c[_>>2]|0);a[B>>0]=0}a[(c[w>>2]|0)+160>>0]=0}break}case 43:{if((a[(c[w>>2]|0)+160>>0]|0)!=0?(c[(c[(c[w>>2]|0)+164>>2]|0)+((c[(c[(c[w>>2]|0)+184>>2]|0)+((c[(c[w>>2]|0)+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3,(c[(c[o>>2]|0)+128>>2]|0)!=0):0)a[B>>0]=0;break}case 51:{c[z>>2]=0;fa=318;break}case 53:{c[z>>2]=1;fa=318;break}case 52:{c[z>>2]=2;fa=318;break}case 54:{c[z>>2]=3;fa=318;break}case 45:{c[z>>2]=0;fa=333;break}case 47:{c[z>>2]=1;fa=333;break}case 46:{c[z>>2]=2;fa=333;break}case 48:{c[z>>2]=3;fa=333;break}case 55:{if(!(rZ(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0)){fa=343;break a}a[B>>0]=0;break}case 56:{if(!(sZ(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0)|0)){fa=346;break a}a[B>>0]=0;break}case 0:{if((c[s>>2]|0)==14)a[B>>0]=0;break}case 3:{if(c[(c[o>>2]|0)+84>>2]|0)a[B>>0]=0;break}case 11:{if((d[(c[w>>2]|0)+128>>0]|0)!=0?(c[(c[o>>2]|0)+136>>2]|0)!=0:0)a[B>>0]=0;break}case 17:{if(c[(c[o>>2]|0)+96>>2]|0)a[B>>0]=0;break}case 33:{if((d[(c[w>>2]|0)+128>>0]|0)!=0?(c[(c[o>>2]|0)+132>>2]|0)!=0:0)a[B>>0]=0;break}case 39:{if(c[(c[o>>2]|0)+128>>2]|0)a[B>>0]=0;break}default:{}}while(0);if((fa|0)==44){fa=0;if(Sb[c[(c[p>>2]|0)+56>>2]&127](c[p>>2]|0,c[q>>2]|0,c[t>>2]|0,c[x>>2]|0)|0)fa=46;else{fa=45;break}}else if((fa|0)==101){fa=0;if((d[(c[w>>2]|0)+128>>0]|0)!=0?(c[(c[o>>2]|0)+132>>2]|0)!=0:0)a[B>>0]=0}else if((fa|0)==167){fa=0;if((d[(c[w>>2]|0)+128>>0]|0)!=0?(c[(c[o>>2]|0)+316>>2]|0)!=0:0){l=aZ((c[w>>2]|0)+80|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;c[(c[(c[o>>2]|0)+316>>2]|0)+16>>2]=l;if(!(c[(c[(c[o>>2]|0)+316>>2]|0)+16>>2]|0)){fa=170;break}c[(c[(c[o>>2]|0)+316>>2]|0)+20>>2]=c[(c[o>>2]|0)+360>>2];c[(c[w>>2]|0)+80+16>>2]=c[(c[w>>2]|0)+80+12>>2];if(c[(c[o>>2]|0)+136>>2]|0)a[B>>0]=0}}else if((fa|0)==318){fa=0;if(a[(c[w>>2]|0)+160>>0]|0){l=c[t>>2]|0;if(!(c[z>>2]|0))ia=l;else ia=l+(0-(c[(c[p>>2]|0)+68>>2]|0))|0;c[ca>>2]=ia;c[da>>2]=oZ(c[o>>2]|0)|0;if((c[da>>2]|0)<0){fa=322;break}c[(c[(c[w>>2]|0)+164>>2]|0)+((c[da>>2]|0)*28|0)>>2]=4;c[(c[(c[w>>2]|0)+164>>2]|0)+((c[da>>2]|0)*28|0)+4>>2]=c[z>>2];c[$>>2]=eZ(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[ca>>2]|0)|0;if(!(c[$>>2]|0)){fa=324;break}c[aa>>2]=c[c[$>>2]>>2];c[(c[(c[w>>2]|0)+164>>2]|0)+((c[da>>2]|0)*28|0)+8>>2]=c[aa>>2];c[ba>>2]=0;do{l=c[ba>>2]|0;c[ba>>2]=l+1}while((a[(c[aa>>2]|0)+l>>0]|0)!=0);l=(c[w>>2]|0)+168|0;c[l>>2]=(c[l>>2]|0)+(c[ba>>2]|0);if(c[(c[o>>2]|0)+128>>2]|0)a[B>>0]=0}}else if((fa|0)==333?(fa=0,(a[(c[w>>2]|0)+160>>0]|0)!=0):0){if(c[(c[o>>2]|0)+128>>2]|0)a[B>>0]=0;l=(c[w>>2]|0)+180|0;c[l>>2]=(c[l>>2]|0)+-1;c[(c[(c[w>>2]|0)+164>>2]|0)+((c[(c[(c[w>>2]|0)+184>>2]|0)+(c[(c[w>>2]|0)+180>>2]<<2)>>2]|0)*28|0)+4>>2]=c[z>>2];if(!(c[(c[w>>2]|0)+180>>2]|0)){if(!(a[B>>0]|0)){c[ea>>2]=qZ(c[o>>2]|0)|0;if(!(c[ea>>2]|0)){fa=339;break}c[c[y>>2]>>2]=c[q>>2];Tb[c[(c[o>>2]|0)+128>>2]&127](c[(c[o>>2]|0)+4>>2]|0,c[c[(c[o>>2]|0)+344>>2]>>2]|0,c[ea>>2]|0)}a[(c[w>>2]|0)+160>>0]=0;c[(c[w>>2]|0)+168>>2]=0}}if(((fa|0)==46?(fa=0,(d[(c[w>>2]|0)+128>>0]|0)!=0):0)?(c[(c[o>>2]|0)+316>>2]|0)!=0:0){c[F>>2]=aZ((c[w>>2]|0)+80|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;if(!(c[F>>2]|0)){fa=49;break}cZ(c[F>>2]|0);c[(c[(c[o>>2]|0)+316>>2]|0)+24>>2]=c[F>>2];c[(c[w>>2]|0)+80+16>>2]=c[(c[w>>2]|0)+80+12>>2];if(c[(c[o>>2]|0)+136>>2]|0)a[B>>0]=0}if((d[B>>0]|0)!=0?(c[(c[o>>2]|0)+80>>2]|0)!=0:0)TY(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[t>>2]|0);switch(c[(c[o>>2]|0)+480>>2]|0){case 3:{fa=366;break a;break}case 2:{fa=367;break a;break}default:{}}c[q>>2]=c[t>>2];c[s>>2]=Sb[c[c[p>>2]>>2]&127](c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,t)|0}switch(fa|0){case 6:{c[c[u>>2]>>2]=c[q>>2];c[n>>2]=0;ja=c[n>>2]|0;i=m;return ja|0}case 8:{c[c[x>>2]>>2]=c[t>>2];c[n>>2]=4;ja=c[n>>2]|0;i=m;return ja|0}case 9:{c[n>>2]=5;ja=c[n>>2]|0;i=m;return ja|0}case 10:{c[n>>2]=6;ja=c[n>>2]|0;i=m;return ja|0}case 12:{if((c[p>>2]|0)!=(c[(c[o>>2]|0)+144>>2]|0)?(a[(c[(c[o>>2]|0)+300>>2]|0)+20>>0]|0)==0:0){c[c[u>>2]>>2]=c[q>>2];c[n>>2]=0;ja=c[n>>2]|0;i=m;return ja|0}if((d[(c[o>>2]|0)+488>>0]|0)==0?(c[p>>2]|0)==(c[(c[o>>2]|0)+144>>2]|0):0){c[n>>2]=3;ja=c[n>>2]|0;i=m;return ja|0}if((Gb[c[(c[o>>2]|0)+256>>2]&63]((c[o>>2]|0)+256|0,-4,c[r>>2]|0,c[r>>2]|0,c[p>>2]|0)|0)==-1){c[n>>2]=29;ja=c[n>>2]|0;i=m;return ja|0}else{c[c[u>>2]>>2]=c[q>>2];c[n>>2]=0;ja=c[n>>2]|0;i=m;return ja|0}break}case 24:{c[n>>2]=c[C>>2];ja=c[n>>2]|0;i=m;return ja|0}case 28:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 34:{c[n>>2]=c[D>>2];ja=c[n>>2]|0;i=m;return ja|0}case 37:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 40:{c[n>>2]=32;ja=c[n>>2]|0;i=m;return ja|0}case 42:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 45:{c[n>>2]=32;ja=c[n>>2]|0;i=m;return ja|0}case 49:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 59:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 63:{c[n>>2]=21;ja=c[n>>2]|0;i=m;return ja|0}case 68:{c[n>>2]=22;ja=c[n>>2]|0;i=m;return ja|0}case 74:{do if(((a[(c[o>>2]|0)+489>>0]|0)!=0?(a[I>>0]=a[(c[w>>2]|0)+129>>0]|0,a[(c[w>>2]|0)+129>>0]=1,(c[(c[o>>2]|0)+492>>2]|0)!=0):0)?(c[(c[o>>2]|0)+112>>2]|0)!=0:0){c[J>>2]=bZ(c[o>>2]|0,(c[w>>2]|0)+132|0,112589,36)|0;if(!(c[J>>2]|0)){c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}c[(c[J>>2]|0)+20>>2]=c[(c[o>>2]|0)+360>>2];a[(c[w>>2]|0)+131>>0]=0;if(!(Gb[c[(c[o>>2]|0)+112>>2]&63](c[(c[o>>2]|0)+116>>2]|0,0,c[(c[J>>2]|0)+20>>2]|0,c[(c[J>>2]|0)+16>>2]|0,c[(c[J>>2]|0)+24>>2]|0)|0)){c[n>>2]=21;ja=c[n>>2]|0;i=m;return ja|0}if(!(a[(c[w>>2]|0)+131>>0]|0)){a[(c[w>>2]|0)+129>>0]=a[I>>0]|0;break}if(((a[(c[w>>2]|0)+130>>0]|0)==0?(c[(c[o>>2]|0)+108>>2]|0)!=0:0)?(Fb[c[(c[o>>2]|0)+108>>2]&63](c[(c[o>>2]|0)+4>>2]|0)|0)==0:0){c[n>>2]=22;ja=c[n>>2]|0;i=m;return ja|0}}while(0);c[(c[o>>2]|0)+280>>2]=58;c[n>>2]=dZ(c[o>>2]|0,c[q>>2]|0,c[r>>2]|0,c[u>>2]|0)|0;ja=c[n>>2]|0;i=m;return ja|0}case 89:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 91:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 110:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 112:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 116:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 127:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 131:{c[n>>2]=c[M>>2];ja=c[n>>2]|0;i=m;return ja|0}case 133:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 144:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 152:{c[n>>2]=c[N>>2];ja=c[n>>2]|0;i=m;return ja|0}case 155:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 162:{c[n>>2]=22;ja=c[n>>2]|0;i=m;return ja|0}case 165:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 170:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 180:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 189:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 191:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 201:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 203:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 213:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 216:{c[n>>2]=32;ja=c[n>>2]|0;i=m;return ja|0}case 219:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 224:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 231:{switch(c[s>>2]|0){case 28:{c[n>>2]=10;ja=c[n>>2]|0;i=m;return ja|0}case 12:{c[n>>2]=17;ja=c[n>>2]|0;i=m;return ja|0}default:{c[n>>2]=2;ja=c[n>>2]|0;i=m;return ja|0}}break}case 238:{c[n>>2]=c[S>>2];ja=c[n>>2]|0;i=m;return ja|0}case 240:{c[(c[o>>2]|0)+280>>2]=59;c[n>>2]=c[S>>2];ja=c[n>>2]|0;i=m;return ja|0}case 244:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 247:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 250:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 253:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 257:{c[n>>2]=2;ja=c[n>>2]|0;i=m;return ja|0}case 262:{c[n>>2]=2;ja=c[n>>2]|0;i=m;return ja|0}case 272:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 278:{c[n>>2]=11;ja=c[n>>2]|0;i=m;return ja|0}case 280:{c[n>>2]=24;ja=c[n>>2]|0;i=m;return ja|0}case 286:{c[n>>2]=12;ja=c[n>>2]|0;i=m;return ja|0}case 289:{c[n>>2]=c[Y>>2];ja=c[n>>2]|0;i=m;return ja|0}case 293:{c[n>>2]=21;ja=c[n>>2]|0;i=m;return ja|0}case 300:{c[n>>2]=22;ja=c[n>>2]|0;i=m;return ja|0}case 303:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 308:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 322:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 324:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 339:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 343:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 346:{c[n>>2]=1;ja=c[n>>2]|0;i=m;return ja|0}case 366:{c[c[u>>2]>>2]=c[t>>2];c[n>>2]=0;ja=c[n>>2]|0;i=m;return ja|0}case 367:{c[n>>2]=35;ja=c[n>>2]|0;i=m;return ja|0}}return 0}function $Y(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+64|0;h=g+48|0;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g+16|0;r=g+12|0;s=g+8|0;t=g+4|0;u=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;c[o>>2]=0;c[p>>2]=0;c[q>>2]=0;c[s>>2]=0;c[t>>2]=-1;f=(Eb[((a[(c[j>>2]|0)+236>>0]&255|0)!=0?1:2)&3](c[k>>2]|0,c[(c[j>>2]|0)+144>>2]|0,c[l>>2]|0,c[m>>2]|0,(c[j>>2]|0)+288|0,q,r,n,p,t)|0)!=0;e=(c[k>>2]|0)!=0;if(!f)if(e){c[h>>2]=31;v=c[h>>2]|0;i=g;return v|0}else{c[h>>2]=30;v=c[h>>2]|0;i=g;return v|0}if((e^1)&(c[t>>2]|0)==1?(a[(c[(c[j>>2]|0)+356>>2]|0)+130>>0]=1,(c[(c[j>>2]|0)+492>>2]|0)==1):0)c[(c[j>>2]|0)+492>>2]=0;if(!(c[(c[j>>2]|0)+140>>2]|0)){if(c[(c[j>>2]|0)+80>>2]|0)TY(c[j>>2]|0,c[(c[j>>2]|0)+144>>2]|0,c[l>>2]|0,c[m>>2]|0)}else{do if(c[n>>2]|0){m=(c[j>>2]|0)+440|0;l=c[(c[j>>2]|0)+144>>2]|0;e=c[n>>2]|0;f=c[n>>2]|0;c[o>>2]=aZ(m,l,e,f+(Ob[c[(c[(c[j>>2]|0)+144>>2]|0)+32>>2]&127](c[(c[j>>2]|0)+144>>2]|0,c[n>>2]|0)|0)|0)|0;if(c[o>>2]|0){c[(c[j>>2]|0)+440+16>>2]=c[(c[j>>2]|0)+440+12>>2];break}c[h>>2]=1;v=c[h>>2]|0;i=g;return v|0}while(0);if((c[q>>2]|0)!=0?(c[s>>2]=aZ((c[j>>2]|0)+440|0,c[(c[j>>2]|0)+144>>2]|0,c[q>>2]|0,(c[r>>2]|0)+(0-(c[(c[(c[j>>2]|0)+144>>2]|0)+68>>2]|0))|0)|0,(c[s>>2]|0)==0):0){c[h>>2]=1;v=c[h>>2]|0;i=g;return v|0}Vb[c[(c[j>>2]|0)+140>>2]&31](c[(c[j>>2]|0)+4>>2]|0,c[s>>2]|0,c[o>>2]|0,c[t>>2]|0)}do if(!(c[(c[j>>2]|0)+232>>2]|0)){if(c[p>>2]|0){if((c[(c[p>>2]|0)+68>>2]|0)==(c[(c[(c[j>>2]|0)+144>>2]|0)+68>>2]|0)){c[(c[j>>2]|0)+144>>2]=c[p>>2];break}c[(c[j>>2]|0)+288>>2]=c[n>>2];c[h>>2]=19;v=c[h>>2]|0;i=g;return v|0}if(c[n>>2]|0){if((c[o>>2]|0)==0?(t=(c[j>>2]|0)+440|0,r=c[(c[j>>2]|0)+144>>2]|0,q=c[n>>2]|0,f=c[n>>2]|0,c[o>>2]=aZ(t,r,q,f+(Ob[c[(c[(c[j>>2]|0)+144>>2]|0)+32>>2]&127](c[(c[j>>2]|0)+144>>2]|0,c[n>>2]|0)|0)|0)|0,(c[o>>2]|0)==0):0){c[h>>2]=1;v=c[h>>2]|0;i=g;return v|0}c[u>>2]=JZ(c[j>>2]|0,c[o>>2]|0)|0;KY((c[j>>2]|0)+440|0);if((c[u>>2]|0)==18)c[(c[j>>2]|0)+288>>2]=c[n>>2];c[h>>2]=c[u>>2];v=c[h>>2]|0;i=g;return v|0}}while(0);if((c[o>>2]|0)!=0|(c[s>>2]|0)!=0)KY((c[j>>2]|0)+440|0);c[h>>2]=0;v=c[h>>2]|0;i=g;return v|0}function aZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(!(hZ(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0)){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}if((c[(c[j>>2]|0)+12>>2]|0)==(c[(c[j>>2]|0)+8>>2]|0)?(jZ(c[j>>2]|0)|0)<<24>>24==0:0){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}m=(c[j>>2]|0)+12|0;l=c[m>>2]|0;c[m>>2]=l+1;a[l>>0]=0;c[h>>2]=c[(c[j>>2]|0)+16>>2];n=c[h>>2]|0;i=g;return n|0}function bZ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;h=i;i=i+64|0;j=h+56|0;k=h+52|0;l=h+48|0;m=h+44|0;n=h+40|0;o=h+36|0;p=h+32|0;q=h+28|0;r=h+24|0;s=h+61|0;t=h+60|0;u=h+20|0;v=h+16|0;w=h+12|0;x=h+8|0;y=h+4|0;z=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if(c[(c[l>>2]|0)+8>>2]|0){c[q>>2]=HZ(c[k>>2]|0,c[m>>2]|0)|0;c[r>>2]=(c[(c[l>>2]|0)+8>>2]|0)-1;a[s>>0]=0;c[o>>2]=c[q>>2]&c[r>>2];while(1){if(!(c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]|0))break;if((IZ(c[m>>2]|0,c[c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]>>2]|0)|0)<<24>>24){A=10;break}if(!(a[s>>0]|0))a[s>>0]=(c[q>>2]&~c[r>>2])>>>((d[(c[l>>2]|0)+4>>0]|0)-1|0)&(c[r>>2]|0)>>>2|1;if((c[o>>2]|0)>>>0<(d[s>>0]|0)>>>0){c[o>>2]=(c[o>>2]|0)+((c[(c[l>>2]|0)+8>>2]|0)-(d[s>>0]|0));continue}else{c[o>>2]=(c[o>>2]|0)-(d[s>>0]|0);continue}}if((A|0)==10){c[j>>2]=c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2];B=c[j>>2]|0;i=h;return B|0}if(!(c[n>>2]|0)){c[j>>2]=0;B=c[j>>2]|0;i=h;return B|0}if((c[(c[l>>2]|0)+12>>2]|0)>>>((d[(c[l>>2]|0)+4>>0]|0)-1|0)){a[t>>0]=(d[(c[l>>2]|0)+4>>0]|0)+1;c[u>>2]=1<<d[t>>0];c[v>>2]=(c[u>>2]|0)-1;c[w>>2]=c[u>>2]<<2;c[x>>2]=Fb[c[c[(c[l>>2]|0)+16>>2]>>2]&63](c[w>>2]|0)|0;if(!(c[x>>2]|0)){c[j>>2]=0;B=c[j>>2]|0;i=h;return B|0}$4(c[x>>2]|0,0,c[w>>2]|0)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>>>0>=(c[(c[l>>2]|0)+8>>2]|0)>>>0)break;if(c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]|0){c[y>>2]=HZ(c[k>>2]|0,c[c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]>>2]|0)|0;c[z>>2]=c[y>>2]&c[v>>2];a[s>>0]=0;while(1){if(!(c[(c[x>>2]|0)+(c[z>>2]<<2)>>2]|0))break;if(!(a[s>>0]|0))a[s>>0]=(c[y>>2]&~c[v>>2])>>>((d[t>>0]|0)-1|0)&(c[v>>2]|0)>>>2|1;if((c[z>>2]|0)>>>0<(d[s>>0]|0)>>>0){c[z>>2]=(c[z>>2]|0)+((c[u>>2]|0)-(d[s>>0]|0));continue}else{c[z>>2]=(c[z>>2]|0)-(d[s>>0]|0);continue}}c[(c[x>>2]|0)+(c[z>>2]<<2)>>2]=c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]}c[o>>2]=(c[o>>2]|0)+1}Bb[c[(c[(c[l>>2]|0)+16>>2]|0)+8>>2]&127](c[c[l>>2]>>2]|0);c[c[l>>2]>>2]=c[x>>2];a[(c[l>>2]|0)+4>>0]=a[t>>0]|0;c[(c[l>>2]|0)+8>>2]=c[u>>2];c[o>>2]=c[q>>2]&c[v>>2];a[s>>0]=0;while(1){if(!(c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]|0))break a;if(!(a[s>>0]|0))a[s>>0]=(c[q>>2]&~c[v>>2])>>>((d[t>>0]|0)-1|0)&(c[v>>2]|0)>>>2|1;if((c[o>>2]|0)>>>0<(d[s>>0]|0)>>>0){c[o>>2]=(c[o>>2]|0)+((c[u>>2]|0)-(d[s>>0]|0));continue}else{c[o>>2]=(c[o>>2]|0)-(d[s>>0]|0);continue}}}}else{if(!(c[n>>2]|0)){c[j>>2]=0;B=c[j>>2]|0;i=h;return B|0}a[(c[l>>2]|0)+4>>0]=6;c[(c[l>>2]|0)+8>>2]=64;c[p>>2]=c[(c[l>>2]|0)+8>>2]<<2;g=Fb[c[c[(c[l>>2]|0)+16>>2]>>2]&63](c[p>>2]|0)|0;c[c[l>>2]>>2]=g;g=c[l>>2]|0;if(c[c[l>>2]>>2]|0){$4(c[g>>2]|0,0,c[p>>2]|0)|0;f=HZ(c[k>>2]|0,c[m>>2]|0)|0;c[o>>2]=f&(c[(c[l>>2]|0)+8>>2]|0)-1;break}c[g+8>>2]=0;c[j>>2]=0;B=c[j>>2]|0;i=h;return B|0}while(0);k=Fb[c[c[(c[l>>2]|0)+16>>2]>>2]&63](c[n>>2]|0)|0;c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]=k;if(c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]|0){$4(c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]|0,0,c[n>>2]|0)|0;c[c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2]>>2]=c[m>>2];m=(c[l>>2]|0)+12|0;c[m>>2]=(c[m>>2]|0)+1;c[j>>2]=c[(c[c[l>>2]>>2]|0)+(c[o>>2]<<2)>>2];B=c[j>>2]|0;i=h;return B|0}else{c[j>>2]=0;B=c[j>>2]|0;i=h;return B|0}return 0}function cZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=b;c[f>>2]=c[e>>2];c[g>>2]=c[e>>2];while(1){if(!(a[c[g>>2]>>0]|0))break;switch(a[c[g>>2]>>0]|0){case 10:case 13:case 32:{if((c[f>>2]|0)!=(c[e>>2]|0)?(a[(c[f>>2]|0)+-1>>0]|0)!=32:0){b=c[f>>2]|0;c[f>>2]=b+1;a[b>>0]=32}break}default:{b=a[c[g>>2]>>0]|0;h=c[f>>2]|0;c[f>>2]=h+1;a[h>>0]=b}}c[g>>2]=(c[g>>2]|0)+1}if((c[f>>2]|0)==(c[e>>2]|0)){j=c[f>>2]|0;a[j>>0]=0;i=d;return}if((a[(c[f>>2]|0)+-1>>0]|0)!=32){j=c[f>>2]|0;a[j>>0]=0;i=d;return}c[f>>2]=(c[f>>2]|0)+-1;j=c[f>>2]|0;a[j>>0]=0;i=d;return}function dZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=vZ(c[j>>2]|0,0,c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,((a[(c[j>>2]|0)+480+4>>0]|0)!=0^1)&1)|0;if((c[n>>2]|0)==0?(DZ(c[j>>2]|0)|0)<<24>>24==0:0){c[h>>2]=1;o=c[h>>2]|0;i=g;return o|0}c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}function eZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=c[(c[h>>2]|0)+356>>2];c[n>>2]=aZ((c[m>>2]|0)+80|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(!(c[n>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[o>>2]=bZ(c[h>>2]|0,(c[m>>2]|0)+20|0,c[n>>2]|0,24)|0;if(!(c[o>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}l=(c[m>>2]|0)+80|0;if((c[c[o>>2]>>2]|0)==(c[n>>2]|0)){c[(c[m>>2]|0)+80+16>>2]=c[l+12>>2];if(!(EZ(c[h>>2]|0,c[o>>2]|0)|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}}else c[(c[m>>2]|0)+80+12>>2]=c[l+16>>2];c[g>>2]=c[o>>2];p=c[g>>2]|0;i=f;return p|0}function fZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=c[(c[j>>2]|0)+356>>2];if((c[(c[n>>2]|0)+80+12>>2]|0)==(c[(c[n>>2]|0)+80+8>>2]|0)?(jZ((c[n>>2]|0)+80|0)|0)<<24>>24==0:0){c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}f=(c[n>>2]|0)+80+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e>>0]=0;c[p>>2]=aZ((c[n>>2]|0)+80|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;if(!(c[p>>2]|0)){c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}c[p>>2]=(c[p>>2]|0)+1;c[o>>2]=bZ(c[j>>2]|0,(c[n>>2]|0)+40|0,c[p>>2]|0,12)|0;if(!(c[o>>2]|0)){c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}m=(c[n>>2]|0)+80|0;a:do if((c[c[o>>2]>>2]|0)==(c[p>>2]|0)){c[(c[n>>2]|0)+80+16>>2]=c[m+12>>2];if(a[(c[j>>2]|0)+236>>0]|0){do if(((((a[c[p>>2]>>0]|0)==120?(a[(c[p>>2]|0)+1>>0]|0)==109:0)?(a[(c[p>>2]|0)+2>>0]|0)==108:0)?(a[(c[p>>2]|0)+3>>0]|0)==110:0)?(a[(c[p>>2]|0)+4>>0]|0)==115:0){if((a[(c[p>>2]|0)+5>>0]|0)!=0?(a[(c[p>>2]|0)+5>>0]|0)!=58:0)break;if(!(a[(c[p>>2]|0)+5>>0]|0))c[(c[o>>2]|0)+4>>2]=(c[n>>2]|0)+152;else{l=bZ(c[j>>2]|0,(c[n>>2]|0)+60|0,(c[p>>2]|0)+6|0,8)|0;c[(c[o>>2]|0)+4>>2]=l}a[(c[o>>2]|0)+9>>0]=1;break a}while(0);c[q>>2]=0;while(1){if(!(a[(c[p>>2]|0)+(c[q>>2]|0)>>0]|0))break a;if((a[(c[p>>2]|0)+(c[q>>2]|0)>>0]|0)==58)break;c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=0;while(1){t=(c[(c[n>>2]|0)+80+12>>2]|0)==(c[(c[n>>2]|0)+80+8>>2]|0);if((c[r>>2]|0)>=(c[q>>2]|0))break;if(t?(jZ((c[n>>2]|0)+80|0)|0)<<24>>24==0:0){u=30;break}l=a[(c[p>>2]|0)+(c[r>>2]|0)>>0]|0;k=(c[n>>2]|0)+80+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e>>0]=l;c[r>>2]=(c[r>>2]|0)+1}if((u|0)==30){c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}if(t?(jZ((c[n>>2]|0)+80|0)|0)<<24>>24==0:0){c[h>>2]=0;s=c[h>>2]|0;i=g;return s|0}l=(c[n>>2]|0)+80+12|0;e=c[l>>2]|0;c[l>>2]=e+1;a[e>>0]=0;e=bZ(c[j>>2]|0,(c[n>>2]|0)+60|0,c[(c[n>>2]|0)+80+16>>2]|0,8)|0;c[(c[o>>2]|0)+4>>2]=e;e=(c[n>>2]|0)+80|0;if((c[c[(c[o>>2]|0)+4>>2]>>2]|0)==(c[(c[n>>2]|0)+80+16>>2]|0)){c[(c[n>>2]|0)+80+16>>2]=c[e+12>>2];break}else{c[(c[n>>2]|0)+80+12>>2]=c[e+16>>2];break}}}else c[(c[n>>2]|0)+80+12>>2]=c[m+16>>2];while(0);c[h>>2]=c[o>>2];s=c[h>>2]|0;i=g;return s|0}function gZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;while(1){j=c[g>>2]|0;if(!(a[c[h>>2]>>0]|0)){k=7;break}if((c[j+12>>2]|0)==(c[(c[g>>2]|0)+8>>2]|0)?(jZ(c[g>>2]|0)|0)<<24>>24==0:0){k=6;break}d=a[c[h>>2]>>0]|0;b=(c[g>>2]|0)+12|0;l=c[b>>2]|0;c[b>>2]=l+1;a[l>>0]=d;c[h>>2]=(c[h>>2]|0)+1}if((k|0)==6){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else if((k|0)==7){c[f>>2]=c[j+16>>2];m=c[f>>2]|0;i=e;return m|0}return 0}function hZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[(c[h>>2]|0)+12>>2]|0)==0?(jZ(c[h>>2]|0)|0)<<24>>24==0:0){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}while(1){Ab[c[(c[j>>2]|0)+60>>2]&31](c[j>>2]|0,k,c[l>>2]|0,(c[h>>2]|0)+12|0,c[(c[h>>2]|0)+8>>2]|0);n=c[h>>2]|0;if((c[k>>2]|0)==(c[l>>2]|0)){o=7;break}if(!((jZ(n)|0)<<24>>24)){o=6;break}}if((o|0)==6){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}else if((o|0)==7){c[g>>2]=c[n+16>>2];m=c[g>>2]|0;i=f;return m|0}return 0}function iZ(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+48|0;l=k+32|0;m=k+28|0;n=k+24|0;o=k+37|0;p=k+36|0;q=k+20|0;r=k+16|0;s=k+12|0;t=k+8|0;u=k+4|0;v=k;c[m>>2]=b;c[n>>2]=e;a[o>>0]=f;a[p>>0]=g;c[q>>2]=h;c[r>>2]=j;if(!((c[q>>2]|0)==0?(d[p>>0]|0)==0:0)){c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+12>>2]|0))break;if((c[n>>2]|0)==(c[(c[(c[m>>2]|0)+20>>2]|0)+((c[t>>2]|0)*12|0)>>2]|0)){w=6;break}c[t>>2]=(c[t>>2]|0)+1}if((w|0)==6){c[l>>2]=1;x=c[l>>2]|0;i=k;return x|0}if(((d[p>>0]|0)!=0?(c[(c[m>>2]|0)+8>>2]|0)==0:0)?(a[(c[n>>2]|0)+9>>0]|0)==0:0)c[(c[m>>2]|0)+8>>2]=c[n>>2]}do if((c[(c[m>>2]|0)+12>>2]|0)==(c[(c[m>>2]|0)+16>>2]|0)){p=(c[m>>2]|0)+16|0;if(!(c[(c[m>>2]|0)+16>>2]|0)){c[p>>2]=8;w=Fb[c[(c[r>>2]|0)+12>>2]&63]((c[(c[m>>2]|0)+16>>2]|0)*12|0)|0;c[(c[m>>2]|0)+20>>2]=w;if(c[(c[m>>2]|0)+20>>2]|0)break;c[l>>2]=0;x=c[l>>2]|0;i=k;return x|0}c[v>>2]=c[p>>2]<<1;c[u>>2]=Ob[c[(c[r>>2]|0)+12+4>>2]&127](c[(c[m>>2]|0)+20>>2]|0,(c[v>>2]|0)*12|0)|0;if(c[u>>2]|0){c[(c[m>>2]|0)+16>>2]=c[v>>2];c[(c[m>>2]|0)+20>>2]=c[u>>2];break}c[l>>2]=0;x=c[l>>2]|0;i=k;return x|0}while(0);c[s>>2]=(c[(c[m>>2]|0)+20>>2]|0)+((c[(c[m>>2]|0)+12>>2]|0)*12|0);c[c[s>>2]>>2]=c[n>>2];c[(c[s>>2]|0)+8>>2]=c[q>>2];a[(c[s>>2]|0)+4>>0]=a[o>>0]|0;if(!(a[o>>0]|0))a[(c[n>>2]|0)+8>>0]=1;n=(c[m>>2]|0)+12|0;c[n>>2]=(c[n>>2]|0)+1;c[l>>2]=1;x=c[l>>2]|0;i=k;return x|0}function jZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=b;if(c[(c[f>>2]|0)+4>>2]|0){b=c[f>>2]|0;if(!(c[(c[f>>2]|0)+16>>2]|0)){c[c[f>>2]>>2]=c[b+4>>2];c[(c[f>>2]|0)+4>>2]=c[c[(c[f>>2]|0)+4>>2]>>2];c[c[c[f>>2]>>2]>>2]=0;c[(c[f>>2]|0)+16>>2]=(c[c[f>>2]>>2]|0)+8;c[(c[f>>2]|0)+8>>2]=(c[(c[f>>2]|0)+16>>2]|0)+(c[(c[c[f>>2]>>2]|0)+4>>2]|0);c[(c[f>>2]|0)+12>>2]=c[(c[f>>2]|0)+16>>2];a[e>>0]=1;m=a[e>>0]|0;i=d;return m|0}if(((c[b+8>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0)|0)<(c[(c[(c[f>>2]|0)+4>>2]|0)+4>>2]|0)){c[g>>2]=c[c[(c[f>>2]|0)+4>>2]>>2];c[c[(c[f>>2]|0)+4>>2]>>2]=c[c[f>>2]>>2];c[c[f>>2]>>2]=c[(c[f>>2]|0)+4>>2];c[(c[f>>2]|0)+4>>2]=c[g>>2];Z4((c[c[f>>2]>>2]|0)+8|0,c[(c[f>>2]|0)+16>>2]|0,(c[(c[f>>2]|0)+8>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0)|0)|0;c[(c[f>>2]|0)+12>>2]=(c[c[f>>2]>>2]|0)+8+((c[(c[f>>2]|0)+12>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0));c[(c[f>>2]|0)+16>>2]=(c[c[f>>2]>>2]|0)+8;c[(c[f>>2]|0)+8>>2]=(c[(c[f>>2]|0)+16>>2]|0)+(c[(c[c[f>>2]>>2]|0)+4>>2]|0);a[e>>0]=1;m=a[e>>0]|0;i=d;return m|0}}do if((c[c[f>>2]>>2]|0)!=0?(c[(c[f>>2]|0)+16>>2]|0)==((c[c[f>>2]>>2]|0)+8|0):0){c[h>>2]=(c[(c[f>>2]|0)+8>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0)<<1;c[j>>2]=Ob[c[(c[(c[f>>2]|0)+20>>2]|0)+4>>2]&127](c[c[f>>2]>>2]|0,8+(c[h>>2]|0)|0)|0;if(c[j>>2]|0){c[c[f>>2]>>2]=c[j>>2];c[(c[c[f>>2]>>2]|0)+4>>2]=c[h>>2];c[(c[f>>2]|0)+12>>2]=(c[c[f>>2]>>2]|0)+8+((c[(c[f>>2]|0)+12>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0));c[(c[f>>2]|0)+16>>2]=(c[c[f>>2]>>2]|0)+8;c[(c[f>>2]|0)+8>>2]=(c[(c[f>>2]|0)+16>>2]|0)+(c[h>>2]|0);break}a[e>>0]=0;m=a[e>>0]|0;i=d;return m|0}else n=11;while(0);if((n|0)==11){c[l>>2]=(c[(c[f>>2]|0)+8>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0);if((c[l>>2]|0)<1024)c[l>>2]=1024;else c[l>>2]=c[l>>2]<<1;c[k>>2]=Fb[c[c[(c[f>>2]|0)+20>>2]>>2]&63](8+(c[l>>2]|0)|0)|0;if(!(c[k>>2]|0)){a[e>>0]=0;m=a[e>>0]|0;i=d;return m|0}c[(c[k>>2]|0)+4>>2]=c[l>>2];c[c[k>>2]>>2]=c[c[f>>2]>>2];c[c[f>>2]>>2]=c[k>>2];if((c[(c[f>>2]|0)+12>>2]|0)!=(c[(c[f>>2]|0)+16>>2]|0))Z4((c[k>>2]|0)+8|0,c[(c[f>>2]|0)+16>>2]|0,(c[(c[f>>2]|0)+12>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0)|0)|0;c[(c[f>>2]|0)+12>>2]=(c[k>>2]|0)+8+((c[(c[f>>2]|0)+12>>2]|0)-(c[(c[f>>2]|0)+16>>2]|0));c[(c[f>>2]|0)+16>>2]=(c[k>>2]|0)+8;c[(c[f>>2]|0)+8>>2]=(c[k>>2]|0)+8+(c[l>>2]|0)}a[e>>0]=1;m=a[e>>0]|0;i=d;return m|0}function kZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+28|0;o=j+12|0;p=j+8|0;q=j+4|0;r=j;c[l>>2]=b;c[m>>2]=d;a[n>>0]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=GZ(c[l>>2]|0,c[m>>2]|0,a[n>>0]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;if(c[r>>2]|0){c[k>>2]=c[r>>2];s=c[k>>2]|0;i=j;return s|0}if(((a[n>>0]|0)==0?((c[(c[q>>2]|0)+12>>2]|0)-(c[(c[q>>2]|0)+16>>2]|0)|0)!=0:0)?(a[(c[(c[q>>2]|0)+12>>2]|0)+-1>>0]|0)==32:0){n=(c[q>>2]|0)+12|0;c[n>>2]=(c[n>>2]|0)+-1}if((c[(c[q>>2]|0)+12>>2]|0)==(c[(c[q>>2]|0)+8>>2]|0)?(jZ(c[q>>2]|0)|0)<<24>>24==0:0){c[k>>2]=1;s=c[k>>2]|0;i=j;return s|0}n=(c[q>>2]|0)+12|0;q=c[n>>2]|0;c[n>>2]=q+1;a[q>>0]=0;c[k>>2]=0;s=c[k>>2]|0;i=j;return s|0}function lZ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+64|0;j=h+56|0;k=h+52|0;l=h+48|0;m=h+44|0;n=h+40|0;o=h+36|0;p=h+32|0;q=h+28|0;r=h+24|0;s=h+20|0;t=h+16|0;u=h+12|0;v=h+8|0;w=h+60|0;x=h+4|0;y=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=c[(c[k>>2]|0)+356>>2];c[p>>2]=(c[o>>2]|0)+104;c[q>>2]=0;c[r>>2]=c[(c[k>>2]|0)+256+20>>2];c[(c[k>>2]|0)+256+20>>2]=1;if((c[c[p>>2]>>2]|0)==0?(jZ(c[p>>2]|0)|0)<<24>>24==0:0){c[j>>2]=1;z=c[j>>2]|0;i=h;return z|0}a:while(1){c[t>>2]=Sb[c[(c[l>>2]|0)+16+4>>2]&127](c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,s)|0;b:do switch(c[t>>2]|0){case -4:{A=24;break a;break}case -1:{A=46;break a;break}case 0:{A=49;break a;break}case 28:{if((d[(c[k>>2]|0)+488>>0]|0)==0?(c[l>>2]|0)==(c[(c[k>>2]|0)+144>>2]|0):0){A=23;break a}c[u>>2]=aZ((c[k>>2]|0)+416|0,c[l>>2]|0,(c[m>>2]|0)+(c[(c[l>>2]|0)+68>>2]|0)|0,(c[s>>2]|0)+(0-(c[(c[l>>2]|0)+68>>2]|0))|0)|0;if(!(c[u>>2]|0)){A=8;break a}c[v>>2]=bZ(c[k>>2]|0,(c[o>>2]|0)+132|0,c[u>>2]|0,0)|0;c[(c[k>>2]|0)+416+12>>2]=c[(c[k>>2]|0)+416+16>>2];if(!(c[v>>2]|0)){A=10;break a}if(a[(c[v>>2]|0)+32>>0]|0){A=12;break a}if(!(c[(c[v>>2]|0)+16>>2]|0)){a[(c[v>>2]|0)+32>>0]=1;c[q>>2]=lZ(c[k>>2]|0,c[(c[k>>2]|0)+228>>2]|0,c[(c[v>>2]|0)+4>>2]|0,(c[(c[v>>2]|0)+4>>2]|0)+(c[(c[v>>2]|0)+8>>2]|0)|0)|0;a[(c[v>>2]|0)+32>>0]=0;if(c[q>>2]|0)break a;else break b}g=c[o>>2]|0;if(!(c[(c[k>>2]|0)+112>>2]|0)){a[(c[o>>2]|0)+128>>0]=a[g+130>>0]|0;break b}a[g+131>>0]=0;a[(c[v>>2]|0)+32>>0]=1;g=(Gb[c[(c[k>>2]|0)+112>>2]&63](c[(c[k>>2]|0)+116>>2]|0,0,c[(c[v>>2]|0)+20>>2]|0,c[(c[v>>2]|0)+16>>2]|0,c[(c[v>>2]|0)+24>>2]|0)|0)!=0;a[(c[v>>2]|0)+32>>0]=0;if(!g){A=18;break a}if(!(a[(c[o>>2]|0)+131>>0]|0))a[(c[o>>2]|0)+128>>0]=a[(c[o>>2]|0)+130>>0]|0;break}case 6:case 9:{if(!(hZ(c[p>>2]|0,c[l>>2]|0,c[m>>2]|0,c[s>>2]|0)|0)){A=26;break a}break}case -3:{c[s>>2]=(c[m>>2]|0)+(c[(c[l>>2]|0)+68>>2]|0);A=28;break}case 7:{A=28;break}case 10:{c[y>>2]=Ob[c[(c[l>>2]|0)+44>>2]&127](c[l>>2]|0,c[m>>2]|0)|0;if((c[y>>2]|0)<0){A=33;break a}c[y>>2]=OZ(c[y>>2]|0,w)|0;if(!(c[y>>2]|0)){A=37;break a}c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[y>>2]|0))break b;if((c[(c[p>>2]|0)+8>>2]|0)==(c[(c[p>>2]|0)+12>>2]|0)?(jZ(c[p>>2]|0)|0)<<24>>24==0:0){A=44;break a}g=a[w+(c[x>>2]|0)>>0]|0;f=(c[p>>2]|0)+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e>>0]=g;c[x>>2]=(c[x>>2]|0)+1}break}default:{A=52;break a}}while(0);if((A|0)==28){A=0;if((c[(c[p>>2]|0)+8>>2]|0)==(c[(c[p>>2]|0)+12>>2]|0)?(jZ(c[p>>2]|0)|0)<<24>>24==0:0){A=30;break}g=(c[p>>2]|0)+12|0;e=c[g>>2]|0;c[g>>2]=e+1;a[e>>0]=10}c[m>>2]=c[s>>2]}switch(A|0){case 8:{c[q>>2]=1;break}case 10:{a[(c[o>>2]|0)+128>>0]=a[(c[o>>2]|0)+130>>0]|0;break}case 12:{if((c[l>>2]|0)==(c[(c[k>>2]|0)+144>>2]|0))c[(c[k>>2]|0)+288>>2]=c[m>>2];c[q>>2]=12;break}case 18:{c[q>>2]=21;break}case 23:{c[(c[k>>2]|0)+288>>2]=c[m>>2];c[q>>2]=10;break}case 24:{c[q>>2]=0;break}case 26:{c[q>>2]=1;break}case 30:{c[q>>2]=1;break}case 33:{if((c[l>>2]|0)==(c[(c[k>>2]|0)+144>>2]|0))c[(c[k>>2]|0)+288>>2]=c[m>>2];c[q>>2]=14;break}case 37:{if((c[l>>2]|0)==(c[(c[k>>2]|0)+144>>2]|0))c[(c[k>>2]|0)+288>>2]=c[m>>2];c[q>>2]=14;break}case 44:{c[q>>2]=1;break}case 46:{if((c[l>>2]|0)==(c[(c[k>>2]|0)+144>>2]|0))c[(c[k>>2]|0)+288>>2]=c[m>>2];c[q>>2]=4;break}case 49:{if((c[l>>2]|0)==(c[(c[k>>2]|0)+144>>2]|0))c[(c[k>>2]|0)+288>>2]=c[s>>2];c[q>>2]=4;break}case 52:{if((c[l>>2]|0)==(c[(c[k>>2]|0)+144>>2]|0))c[(c[k>>2]|0)+288>>2]=c[m>>2];c[q>>2]=23;break}}c[(c[k>>2]|0)+256+20>>2]=c[r>>2];c[j>>2]=c[q>>2];z=c[j>>2]|0;i=h;return z|0}function mZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+48|0;k=j+40|0;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+44|0;r=j+16|0;s=j+12|0;t=j+8|0;u=j+4|0;v=j;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;a[q>>0]=h;c[t>>2]=c[c[n>>2]>>2];h=c[l>>2]|0;if((c[m>>2]|0)==(c[(c[l>>2]|0)+144>>2]|0)){c[u>>2]=h+288;c[c[u>>2]>>2]=c[t>>2];c[v>>2]=(c[l>>2]|0)+292}else{c[u>>2]=c[h+300>>2];c[v>>2]=(c[(c[l>>2]|0)+300>>2]|0)+4}c[c[u>>2]>>2]=c[t>>2];c[c[n>>2]>>2]=0;c[s>>2]=Sb[c[(c[m>>2]|0)+12>>2]&127](c[m>>2]|0,c[t>>2]|0,c[o>>2]|0,r)|0;c[c[v>>2]>>2]=c[r>>2];switch(c[s>>2]|0){case 42:{if(c[(c[l>>2]|0)+80>>2]|0)TY(c[l>>2]|0,c[m>>2]|0,c[t>>2]|0,c[r>>2]|0);c[c[n>>2]>>2]=c[r>>2];c[c[p>>2]>>2]=c[r>>2];if((c[(c[l>>2]|0)+480>>2]|0)==2){c[k>>2]=35;w=c[k>>2]|0;i=j;return w|0}else{c[k>>2]=0;w=c[k>>2]|0;i=j;return w|0}break}case 0:{c[c[u>>2]>>2]=c[r>>2];c[k>>2]=4;w=c[k>>2]|0;i=j;return w|0}case -2:{if(a[q>>0]|0){c[c[p>>2]>>2]=c[t>>2];c[k>>2]=0;w=c[k>>2]|0;i=j;return w|0}else{c[k>>2]=6;w=c[k>>2]|0;i=j;return w|0}break}case -4:case -1:{if(a[q>>0]|0){c[c[p>>2]>>2]=c[t>>2];c[k>>2]=0;w=c[k>>2]|0;i=j;return w|0}else{c[k>>2]=2;w=c[k>>2]|0;i=j;return w|0}break}default:{c[c[u>>2]>>2]=c[r>>2];c[k>>2]=23;w=c[k>>2]|0;i=j;return w|0}}return 0}function nZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=mZ(c[j>>2]|0,c[(c[j>>2]|0)+144>>2]|0,k,c[l>>2]|0,c[m>>2]|0,((a[(c[j>>2]|0)+480+4>>0]|0)!=0^1)&1)|0;if(c[n>>2]|0){c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}if(c[k>>2]|0){c[(c[j>>2]|0)+280>>2]=60;c[h>>2]=ZY(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}else{c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}return 0}function oZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+356>>2];do if(!(c[(c[f>>2]|0)+184>>2]|0)){a=Fb[c[(c[e>>2]|0)+12>>2]&63](c[(c[e>>2]|0)+468>>2]<<2)|0;c[(c[f>>2]|0)+184>>2]=a;if(c[(c[f>>2]|0)+184>>2]|0){c[c[(c[f>>2]|0)+184>>2]>>2]=0;break}c[d>>2]=-1;l=c[d>>2]|0;i=b;return l|0}while(0);if((c[(c[f>>2]|0)+176>>2]|0)>>>0>=(c[(c[f>>2]|0)+172>>2]|0)>>>0){a=(c[e>>2]|0)+12|0;do if(c[(c[f>>2]|0)+164>>2]|0){c[j>>2]=Ob[c[a+4>>2]&127](c[(c[f>>2]|0)+164>>2]|0,(c[(c[f>>2]|0)+172>>2]<<1)*28|0)|0;if(c[j>>2]|0){e=(c[f>>2]|0)+172|0;c[e>>2]=c[e>>2]<<1;break}c[d>>2]=-1;l=c[d>>2]|0;i=b;return l|0}else{c[j>>2]=Fb[c[a>>2]&63](896)|0;if(c[j>>2]|0){c[(c[f>>2]|0)+172>>2]=32;break}c[d>>2]=-1;l=c[d>>2]|0;i=b;return l|0}while(0);c[(c[f>>2]|0)+164>>2]=c[j>>2]}j=(c[f>>2]|0)+176|0;a=c[j>>2]|0;c[j>>2]=a+1;c[h>>2]=a;c[g>>2]=(c[(c[f>>2]|0)+164>>2]|0)+((c[h>>2]|0)*28|0);if(c[(c[f>>2]|0)+180>>2]|0){c[k>>2]=(c[(c[f>>2]|0)+164>>2]|0)+((c[(c[(c[f>>2]|0)+184>>2]|0)+((c[(c[f>>2]|0)+180>>2]|0)-1<<2)>>2]|0)*28|0);if(c[(c[k>>2]|0)+16>>2]|0)c[(c[(c[f>>2]|0)+164>>2]|0)+((c[(c[k>>2]|0)+16>>2]|0)*28|0)+24>>2]=c[h>>2];if(!(c[(c[k>>2]|0)+20>>2]|0))c[(c[k>>2]|0)+12>>2]=c[h>>2];c[(c[k>>2]|0)+16>>2]=c[h>>2];f=(c[k>>2]|0)+20|0;c[f>>2]=(c[f>>2]|0)+1}c[(c[g>>2]|0)+24>>2]=0;c[(c[g>>2]|0)+20>>2]=0;c[(c[g>>2]|0)+16>>2]=0;c[(c[g>>2]|0)+12>>2]=0;c[d>>2]=c[h>>2];l=c[d>>2]|0;i=b;return l|0}function pZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+36|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[h>>2]=b;c[j>>2]=d;a[k>>0]=e;e=c[h>>2]|0;if(!(c[(c[h>>2]|0)+304>>2]|0)){c[p>>2]=Fb[c[e+12>>2]&63](24)|0;if(!(c[p>>2]|0)){c[g>>2]=1;r=c[g>>2]|0;i=f;return r|0}}else{c[p>>2]=c[e+304>>2];c[(c[h>>2]|0)+304>>2]=c[(c[p>>2]|0)+8>>2]}a[(c[j>>2]|0)+32>>0]=1;c[(c[j>>2]|0)+12>>2]=0;c[(c[p>>2]|0)+8>>2]=c[(c[h>>2]|0)+300>>2];c[(c[h>>2]|0)+300>>2]=c[p>>2];c[(c[p>>2]|0)+12>>2]=c[j>>2];c[(c[p>>2]|0)+16>>2]=c[(c[h>>2]|0)+312>>2];a[(c[p>>2]|0)+20>>0]=a[k>>0]|0;c[c[p>>2]>>2]=0;c[(c[p>>2]|0)+4>>2]=0;c[l>>2]=c[(c[j>>2]|0)+4>>2];c[m>>2]=(c[(c[j>>2]|0)+4>>2]|0)+(c[(c[j>>2]|0)+8>>2]|0);k=c[h>>2]|0;if(a[(c[j>>2]|0)+33>>0]|0){c[q>>2]=Sb[c[c[k+228>>2]>>2]&127](c[(c[h>>2]|0)+228>>2]|0,c[l>>2]|0,c[m>>2]|0,n)|0;c[o>>2]=_Y(c[h>>2]|0,c[(c[h>>2]|0)+228>>2]|0,c[l>>2]|0,c[m>>2]|0,c[q>>2]|0,c[n>>2]|0,n,0)|0}else c[o>>2]=vZ(k,c[(c[h>>2]|0)+312>>2]|0,c[(c[h>>2]|0)+228>>2]|0,c[l>>2]|0,c[m>>2]|0,n,0)|0;do if(!(c[o>>2]|0)){if((c[m>>2]|0)!=(c[n>>2]|0)?(c[(c[h>>2]|0)+480>>2]|0)==3:0){c[(c[j>>2]|0)+12>>2]=(c[n>>2]|0)-(c[l>>2]|0);c[(c[h>>2]|0)+280>>2]=61;break}a[(c[j>>2]|0)+32>>0]=0;c[(c[h>>2]|0)+300>>2]=c[(c[p>>2]|0)+8>>2];c[(c[p>>2]|0)+8>>2]=c[(c[h>>2]|0)+304>>2];c[(c[h>>2]|0)+304>>2]=c[p>>2]}while(0);c[g>>2]=c[o>>2];r=c[g>>2]|0;i=f;return r|0}function qZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+356>>2];c[k>>2]=((c[(c[f>>2]|0)+176>>2]|0)*20|0)+(c[(c[f>>2]|0)+168>>2]|0);c[g>>2]=Fb[c[(c[e>>2]|0)+12>>2]&63](c[k>>2]|0)|0;if(c[g>>2]|0){c[j>>2]=(c[g>>2]|0)+((c[(c[f>>2]|0)+176>>2]|0)*20|0);c[h>>2]=(c[g>>2]|0)+20;uZ(c[e>>2]|0,0,c[g>>2]|0,h,j);c[d>>2]=c[g>>2];l=c[d>>2]|0;i=b;return l|0}else{c[d>>2]=0;l=c[d>>2]|0;i=b;return l|0}return 0}function rZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[(c[h>>2]|0)+64>>2]|0)){if(c[(c[h>>2]|0)+80>>2]|0)TY(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}c[k>>2]=(c[k>>2]|0)+(c[(c[j>>2]|0)+68>>2]<<1);e=c[k>>2]|0;c[o>>2]=e+(Ob[c[(c[j>>2]|0)+32>>2]&127](c[j>>2]|0,c[k>>2]|0)|0);c[m>>2]=aZ((c[h>>2]|0)+416|0,c[j>>2]|0,c[k>>2]|0,c[o>>2]|0)|0;if(!(c[m>>2]|0)){c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}c[(c[h>>2]|0)+416+16>>2]=c[(c[h>>2]|0)+416+12>>2];k=(c[h>>2]|0)+416|0;e=c[j>>2]|0;d=Ob[c[(c[j>>2]|0)+36>>2]&127](c[j>>2]|0,c[o>>2]|0)|0;c[n>>2]=aZ(k,e,d,(c[l>>2]|0)+(0-(c[(c[j>>2]|0)+68>>2]<<1))|0)|0;if(c[n>>2]|0){tZ(c[n>>2]|0);Tb[c[(c[h>>2]|0)+64>>2]&127](c[(c[h>>2]|0)+4>>2]|0,c[m>>2]|0,c[n>>2]|0);KY((c[h>>2]|0)+416|0);c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}else{c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}return 0}function sZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;e=c[h>>2]|0;if(!(c[(c[h>>2]|0)+68>>2]|0)){if(c[e+80>>2]|0)TY(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}c[m>>2]=aZ(e+416|0,c[j>>2]|0,(c[k>>2]|0)+(c[(c[j>>2]|0)+68>>2]<<2)|0,(c[l>>2]|0)+(0-((c[(c[j>>2]|0)+68>>2]|0)*3|0))|0)|0;if(c[m>>2]|0){tZ(c[m>>2]|0);Db[c[(c[h>>2]|0)+68>>2]&31](c[(c[h>>2]|0)+4>>2]|0,c[m>>2]|0);KY((c[h>>2]|0)+416|0);c[g>>2]=1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}return 0}function tZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;while(1){if(!(a[c[e>>2]>>0]|0)){g=12;break}h=c[e>>2]|0;if((a[c[e>>2]>>0]|0)==13)break;c[e>>2]=h+1}if((g|0)==12){i=d;return}c[f>>2]=h;do if((a[c[e>>2]>>0]|0)==13){h=c[f>>2]|0;c[f>>2]=h+1;a[h>>0]=10;h=(c[e>>2]|0)+1|0;c[e>>2]=h;if((a[h>>0]|0)==10)c[e>>2]=(c[e>>2]|0)+1}else{h=c[e>>2]|0;c[e>>2]=h+1;g=a[h>>0]|0;h=c[f>>2]|0;c[f>>2]=h+1;a[h>>0]=g}while((a[c[e>>2]>>0]|0)!=0);a[c[f>>2]>>0]=0;i=d;return}function uZ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=c[(c[j>>2]|0)+356>>2];c[c[l>>2]>>2]=c[(c[(c[o>>2]|0)+164>>2]|0)+((c[k>>2]|0)*28|0)>>2];c[(c[l>>2]|0)+4>>2]=c[(c[(c[o>>2]|0)+164>>2]|0)+((c[k>>2]|0)*28|0)+4>>2];if((c[c[l>>2]>>2]|0)==4){c[(c[l>>2]|0)+8>>2]=c[c[n>>2]>>2];c[p>>2]=c[(c[(c[o>>2]|0)+164>>2]|0)+((c[k>>2]|0)*28|0)+8>>2];while(1){g=a[c[p>>2]>>0]|0;f=c[n>>2]|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e>>0]=g;if(!(a[c[p>>2]>>0]|0))break;c[p>>2]=(c[p>>2]|0)+1}c[(c[l>>2]|0)+12>>2]=0;c[(c[l>>2]|0)+16>>2]=0;i=h;return}else{c[(c[l>>2]|0)+12>>2]=c[(c[(c[o>>2]|0)+164>>2]|0)+((c[k>>2]|0)*28|0)+20>>2];c[(c[l>>2]|0)+16>>2]=c[c[m>>2]>>2];p=c[m>>2]|0;c[p>>2]=(c[p>>2]|0)+((c[(c[l>>2]|0)+12>>2]|0)*20|0);c[q>>2]=0;c[r>>2]=c[(c[(c[o>>2]|0)+164>>2]|0)+((c[k>>2]|0)*28|0)+12>>2];while(1){if((c[q>>2]|0)>>>0>=(c[(c[l>>2]|0)+12>>2]|0)>>>0)break;uZ(c[j>>2]|0,c[r>>2]|0,(c[(c[l>>2]|0)+16>>2]|0)+((c[q>>2]|0)*20|0)|0,c[m>>2]|0,c[n>>2]|0);c[q>>2]=(c[q>>2]|0)+1;c[r>>2]=c[(c[(c[o>>2]|0)+164>>2]|0)+((c[r>>2]|0)*28|0)+24>>2]}c[(c[l>>2]|0)+8>>2]=0;i=h;return}}function vZ(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;l=i;i=i+208|0;m=l+184|0;n=l+180|0;o=l+176|0;p=l+172|0;q=l+168|0;r=l+164|0;s=l+160|0;t=l+199|0;u=l+156|0;v=l+152|0;w=l+148|0;x=l+144|0;y=l+140|0;z=l+198|0;A=l+136|0;B=l+132|0;C=l+197|0;D=l+128|0;E=l+124|0;F=l+120|0;G=l+116|0;H=l+112|0;I=l+108|0;J=l+104|0;K=l+100|0;L=l+96|0;M=l+92|0;N=l+88|0;O=l+84|0;P=l+80|0;Q=l+196|0;R=l+56|0;S=l+48|0;T=l+44|0;U=l+40|0;V=l+36|0;W=l+32|0;X=l+28|0;Y=l+24|0;Z=l+20|0;_=l+16|0;$=l+192|0;aa=l+188|0;ba=l+12|0;ca=l+8|0;da=l+4|0;ea=l;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;a[t>>0]=k;c[u>>2]=c[(c[n>>2]|0)+356>>2];k=c[n>>2]|0;if((c[p>>2]|0)==(c[(c[n>>2]|0)+144>>2]|0)){c[v>>2]=k+288;c[w>>2]=(c[n>>2]|0)+292}else{c[v>>2]=c[k+300>>2];c[w>>2]=(c[(c[n>>2]|0)+300>>2]|0)+4}c[c[v>>2]>>2]=c[q>>2];a:while(1){c[x>>2]=c[q>>2];c[y>>2]=Sb[c[(c[p>>2]|0)+4>>2]&127](c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,x)|0;c[c[w>>2]>>2]=c[x>>2];b:do switch(c[y>>2]|0){case -3:{fa=6;break a;break}case -4:{fa=17;break a;break}case 0:{fa=24;break a;break}case -1:{fa=25;break a;break}case -2:{fa=28;break a;break}case 12:{fa=138;break a;break}case -5:{fa=151;break a;break}case 9:{a[C>>0]=Hb[c[(c[p>>2]|0)+48>>2]&63](c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[x>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;if(a[C>>0]|0){k=c[n>>2]|0;if(c[(c[n>>2]|0)+60>>2]|0){Tb[c[k+60>>2]&127](c[(c[n>>2]|0)+4>>2]|0,C,1);break b}if(!(c[k+80>>2]|0))break b;TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0);break b}c[A>>2]=aZ((c[u>>2]|0)+80|0,c[p>>2]|0,(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0)|0,(c[x>>2]|0)+(0-(c[(c[p>>2]|0)+68>>2]|0))|0)|0;if(!(c[A>>2]|0)){fa=37;break a}c[B>>2]=bZ(c[n>>2]|0,c[u>>2]|0,c[A>>2]|0,0)|0;c[(c[u>>2]|0)+80+12>>2]=c[(c[u>>2]|0)+80+16>>2];if((a[(c[u>>2]|0)+129>>0]|0)!=0?(d[(c[u>>2]|0)+130>>0]|0)==0:0){if(!(c[B>>2]|0)){k=c[n>>2]|0;if(c[(c[n>>2]|0)+120>>2]|0){Tb[c[k+120>>2]&127](c[(c[n>>2]|0)+4>>2]|0,c[A>>2]|0,0);break b}if(!(c[k+80>>2]|0))break b;TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0);break b}}else{if(!(c[B>>2]|0)){fa=41;break a}if(!(a[(c[B>>2]|0)+34>>0]|0)){fa=43;break a}}if(a[(c[B>>2]|0)+32>>0]|0){fa=50;break a}if(c[(c[B>>2]|0)+28>>2]|0){fa=52;break a}k=c[n>>2]|0;if(c[(c[B>>2]|0)+4>>2]|0){j=c[n>>2]|0;if(a[k+308>>0]|0){c[D>>2]=pZ(j,c[B>>2]|0,0)|0;if(c[D>>2]|0){fa=60;break a}else break b}h=c[n>>2]|0;if(c[j+120>>2]|0){Tb[c[h+120>>2]&127](c[(c[n>>2]|0)+4>>2]|0,c[c[B>>2]>>2]|0,0);break b}if(!(c[h+80>>2]|0))break b;TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0);break b}else{if(!(c[k+112>>2]|0)){if(!(c[(c[n>>2]|0)+80>>2]|0))break b;TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0);break b}a[(c[B>>2]|0)+32>>0]=1;c[E>>2]=xZ(c[n>>2]|0)|0;a[(c[B>>2]|0)+32>>0]=0;if(!(c[E>>2]|0)){fa=63;break a}if(!(Gb[c[(c[n>>2]|0)+112>>2]&63](c[(c[n>>2]|0)+116>>2]|0,c[E>>2]|0,c[(c[B>>2]|0)+20>>2]|0,c[(c[B>>2]|0)+16>>2]|0,c[(c[B>>2]|0)+24>>2]|0)|0)){fa=65;break a}c[(c[n>>2]|0)+416+12>>2]=c[(c[n>>2]|0)+416+16>>2];break b}break}case 1:case 2:{k=c[n>>2]|0;if(c[(c[n>>2]|0)+368>>2]|0){c[F>>2]=c[k+368>>2];c[(c[n>>2]|0)+368>>2]=c[c[(c[n>>2]|0)+368>>2]>>2]}else{c[F>>2]=Fb[c[k+12>>2]&63](48)|0;if(!(c[F>>2]|0)){fa=72;break a}k=Fb[c[(c[n>>2]|0)+12>>2]&63](32)|0;c[(c[F>>2]|0)+36>>2]=k;if(!(c[(c[F>>2]|0)+36>>2]|0)){fa=74;break a}c[(c[F>>2]|0)+40>>2]=(c[(c[F>>2]|0)+36>>2]|0)+32}c[(c[F>>2]|0)+44>>2]=0;c[c[F>>2]>>2]=c[(c[n>>2]|0)+364>>2];c[(c[n>>2]|0)+364>>2]=c[F>>2];c[(c[F>>2]|0)+12+4>>2]=0;c[(c[F>>2]|0)+12+8>>2]=0;c[(c[F>>2]|0)+4>>2]=(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0);k=Ob[c[(c[p>>2]|0)+32>>2]&127](c[p>>2]|0,c[(c[F>>2]|0)+4>>2]|0)|0;c[(c[F>>2]|0)+8>>2]=k;k=(c[n>>2]|0)+312|0;c[k>>2]=(c[k>>2]|0)+1;c[I>>2]=(c[(c[F>>2]|0)+4>>2]|0)+(c[(c[F>>2]|0)+8>>2]|0);c[J>>2]=c[(c[F>>2]|0)+4>>2];c[H>>2]=c[(c[F>>2]|0)+36>>2];while(1){Ab[c[(c[p>>2]|0)+60>>2]&31](c[p>>2]|0,J,c[I>>2]|0,H,(c[(c[F>>2]|0)+40>>2]|0)+-1|0);c[L>>2]=(c[H>>2]|0)-(c[(c[F>>2]|0)+36>>2]|0);if((c[J>>2]|0)==(c[I>>2]|0))break;c[K>>2]=(c[(c[F>>2]|0)+40>>2]|0)-(c[(c[F>>2]|0)+36>>2]|0)<<1;c[M>>2]=Ob[c[(c[n>>2]|0)+12+4>>2]&127](c[(c[F>>2]|0)+36>>2]|0,c[K>>2]|0)|0;if(!(c[M>>2]|0)){fa=80;break a}c[(c[F>>2]|0)+36>>2]=c[M>>2];c[(c[F>>2]|0)+40>>2]=(c[M>>2]|0)+(c[K>>2]|0);c[H>>2]=(c[M>>2]|0)+(c[L>>2]|0)}c[(c[F>>2]|0)+12+12>>2]=c[L>>2];c[(c[F>>2]|0)+12>>2]=c[(c[F>>2]|0)+36>>2];a[c[H>>2]>>0]=0;c[G>>2]=yZ(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,(c[F>>2]|0)+12|0,(c[F>>2]|0)+44|0)|0;if(c[G>>2]|0){fa=82;break a}k=c[n>>2]|0;if(!(c[(c[n>>2]|0)+52>>2]|0)){if(c[k+80>>2]|0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0)}else Tb[c[k+52>>2]&127](c[(c[n>>2]|0)+4>>2]|0,c[(c[F>>2]|0)+12>>2]|0,c[(c[n>>2]|0)+392>>2]|0);KY((c[n>>2]|0)+416|0);break}case 3:case 4:{c[N>>2]=(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]|0);c[P>>2]=0;a[Q>>0]=1;k=(c[n>>2]|0)+416|0;h=c[p>>2]|0;j=c[N>>2]|0;g=c[N>>2]|0;c[R>>2]=aZ(k,h,j,g+(Ob[c[(c[p>>2]|0)+32>>2]&127](c[p>>2]|0,c[N>>2]|0)|0)|0)|0;if(!(c[R>>2]|0)){fa=89;break a}c[(c[n>>2]|0)+416+16>>2]=c[(c[n>>2]|0)+416+12>>2];c[O>>2]=yZ(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,R,P)|0;if(c[O>>2]|0){fa=91;break a}c[(c[n>>2]|0)+416+16>>2]=c[(c[n>>2]|0)+416+12>>2];if(c[(c[n>>2]|0)+52>>2]|0){Tb[c[(c[n>>2]|0)+52>>2]&127](c[(c[n>>2]|0)+4>>2]|0,c[R>>2]|0,c[(c[n>>2]|0)+392>>2]|0);a[Q>>0]=0}if(c[(c[n>>2]|0)+56>>2]|0){if(c[(c[n>>2]|0)+52>>2]|0)c[c[v>>2]>>2]=c[c[w>>2]>>2];Db[c[(c[n>>2]|0)+56>>2]&31](c[(c[n>>2]|0)+4>>2]|0,c[R>>2]|0);a[Q>>0]=0}if((d[Q>>0]|0)!=0?(c[(c[n>>2]|0)+80>>2]|0)!=0:0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0);KY((c[n>>2]|0)+416|0);while(1){if(!(c[P>>2]|0))break;c[S>>2]=c[P>>2];if(c[(c[n>>2]|0)+104>>2]|0)Db[c[(c[n>>2]|0)+104>>2]&31](c[(c[n>>2]|0)+4>>2]|0,c[c[c[S>>2]>>2]>>2]|0);c[P>>2]=c[(c[P>>2]|0)+4>>2];c[(c[S>>2]|0)+4>>2]=c[(c[n>>2]|0)+376>>2];c[(c[n>>2]|0)+376>>2]=c[S>>2];c[(c[c[S>>2]>>2]|0)+4>>2]=c[(c[S>>2]|0)+8>>2]}if(!(c[(c[n>>2]|0)+312>>2]|0)){fa=107;break a}break}case 5:{if((c[(c[n>>2]|0)+312>>2]|0)==(c[o>>2]|0)){fa=109;break a}c[V>>2]=c[(c[n>>2]|0)+364>>2];c[(c[n>>2]|0)+364>>2]=c[c[V>>2]>>2];c[c[V>>2]>>2]=c[(c[n>>2]|0)+368>>2];c[(c[n>>2]|0)+368>>2]=c[V>>2];c[U>>2]=(c[q>>2]|0)+(c[(c[p>>2]|0)+68>>2]<<1);c[T>>2]=Ob[c[(c[p>>2]|0)+32>>2]&127](c[p>>2]|0,c[U>>2]|0)|0;if((c[T>>2]|0)!=(c[(c[V>>2]|0)+8>>2]|0)){fa=112;break a}if(B3(c[(c[V>>2]|0)+4>>2]|0,c[U>>2]|0,c[T>>2]|0)|0){fa=112;break a}g=(c[n>>2]|0)+312|0;c[g>>2]=(c[g>>2]|0)+-1;if(!(c[(c[n>>2]|0)+56>>2]|0)){if(c[(c[n>>2]|0)+80>>2]|0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0)}else{c[W>>2]=c[(c[V>>2]|0)+12+4>>2];if((c[W>>2]|0)!=0?(d[(c[n>>2]|0)+236>>0]|0)!=0:0){c[Y>>2]=(c[(c[V>>2]|0)+12>>2]|0)+(c[(c[V>>2]|0)+12+16>>2]|0);while(1){if(!(a[c[W>>2]>>0]|0))break;g=c[W>>2]|0;c[W>>2]=g+1;j=a[g>>0]|0;g=c[Y>>2]|0;c[Y>>2]=g+1;a[g>>0]=j}c[X>>2]=c[(c[V>>2]|0)+12+8>>2];c:do if((c[X>>2]|0)!=0?(d[(c[n>>2]|0)+237>>0]|0)!=0:0){j=a[(c[n>>2]|0)+472>>0]|0;g=c[Y>>2]|0;c[Y>>2]=g+1;a[g>>0]=j;while(1){if(!(a[c[X>>2]>>0]|0))break c;j=c[X>>2]|0;c[X>>2]=j+1;g=a[j>>0]|0;j=c[Y>>2]|0;c[Y>>2]=j+1;a[j>>0]=g}}while(0);a[c[Y>>2]>>0]=0}Db[c[(c[n>>2]|0)+56>>2]&31](c[(c[n>>2]|0)+4>>2]|0,c[(c[V>>2]|0)+12>>2]|0)}while(1){if(!(c[(c[V>>2]|0)+44>>2]|0))break;c[Z>>2]=c[(c[V>>2]|0)+44>>2];if(c[(c[n>>2]|0)+104>>2]|0)Db[c[(c[n>>2]|0)+104>>2]&31](c[(c[n>>2]|0)+4>>2]|0,c[c[c[Z>>2]>>2]>>2]|0);c[(c[V>>2]|0)+44>>2]=c[(c[(c[V>>2]|0)+44>>2]|0)+4>>2];c[(c[Z>>2]|0)+4>>2]=c[(c[n>>2]|0)+376>>2];c[(c[n>>2]|0)+376>>2]=c[Z>>2];c[(c[c[Z>>2]>>2]|0)+4>>2]=c[(c[Z>>2]|0)+8>>2]}if(!(c[(c[n>>2]|0)+312>>2]|0)){fa=131;break a}break}case 10:{c[_>>2]=Ob[c[(c[p>>2]|0)+44>>2]&127](c[p>>2]|0,c[q>>2]|0)|0;if((c[_>>2]|0)<0){fa=133;break a}g=c[n>>2]|0;if(c[(c[n>>2]|0)+60>>2]|0){j=c[g+60>>2]|0;h=c[(c[n>>2]|0)+4>>2]|0;k=OZ(c[_>>2]|0,$)|0;Tb[j&127](h,$,k);break b}if(c[g+80>>2]|0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0);break}case 7:{if(c[(c[n>>2]|0)+60>>2]|0){a[aa>>0]=10;Tb[c[(c[n>>2]|0)+60>>2]&127](c[(c[n>>2]|0)+4>>2]|0,aa,1);break b}if(c[(c[n>>2]|0)+80>>2]|0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0);break}case 8:{g=c[n>>2]|0;if(!(c[(c[n>>2]|0)+72>>2]|0)){if(c[g+80>>2]|0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0)}else Bb[c[g+72>>2]&127](c[(c[n>>2]|0)+4>>2]|0);c[ba>>2]=AZ(c[n>>2]|0,c[p>>2]|0,x,c[r>>2]|0,c[s>>2]|0,a[t>>0]|0)|0;if(c[ba>>2]|0){fa=148;break a}if(!(c[x>>2]|0)){fa=150;break a}break}case 6:{c[da>>2]=c[(c[n>>2]|0)+60>>2];if(!(c[da>>2]|0)){if(!(c[(c[n>>2]|0)+80>>2]|0))break b;TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0);break b}if(a[(c[p>>2]|0)+72>>0]|0){Tb[c[da>>2]&127](c[(c[n>>2]|0)+4>>2]|0,c[q>>2]|0,(c[x>>2]|0)-(c[q>>2]|0)|0);break b}while(1){c[ea>>2]=c[(c[n>>2]|0)+44>>2];Ab[c[(c[p>>2]|0)+60>>2]&31](c[p>>2]|0,q,c[x>>2]|0,ea,c[(c[n>>2]|0)+48>>2]|0);c[c[w>>2]>>2]=c[q>>2];Tb[c[da>>2]&127](c[(c[n>>2]|0)+4>>2]|0,c[(c[n>>2]|0)+44>>2]|0,(c[ea>>2]|0)-(c[(c[n>>2]|0)+44>>2]|0)|0);if((c[q>>2]|0)==(c[x>>2]|0))break b;c[c[v>>2]>>2]=c[q>>2]}break}case 11:{if(!(rZ(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0)|0)){fa=172;break a}break}case 13:{if(!(sZ(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0)|0)){fa=174;break a}break}default:if(c[(c[n>>2]|0)+80>>2]|0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[x>>2]|0)}while(0);g=c[x>>2]|0;c[q>>2]=g;c[c[v>>2]>>2]=g;switch(c[(c[n>>2]|0)+480>>2]|0){case 3:{fa=178;break a;break}case 2:{fa=179;break a;break}default:{}}}switch(fa|0){case 6:{if(a[t>>0]|0){c[c[s>>2]>>2]=c[q>>2];c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}c[c[w>>2]>>2]=c[r>>2];if(!(c[(c[n>>2]|0)+60>>2]|0)){if(c[(c[n>>2]|0)+80>>2]|0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0)}else{a[z>>0]=10;Tb[c[(c[n>>2]|0)+60>>2]&127](c[(c[n>>2]|0)+4>>2]|0,z,1)}if(!(c[o>>2]|0)){c[m>>2]=3;ga=c[m>>2]|0;i=l;return ga|0}if((c[(c[n>>2]|0)+312>>2]|0)!=(c[o>>2]|0)){c[m>>2]=13;ga=c[m>>2]|0;i=l;return ga|0}else{c[c[s>>2]>>2]=c[r>>2];c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}break}case 17:{if(a[t>>0]|0){c[c[s>>2]>>2]=c[q>>2];c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}if((c[o>>2]|0)<=0){c[m>>2]=3;ga=c[m>>2]|0;i=l;return ga|0}if((c[(c[n>>2]|0)+312>>2]|0)!=(c[o>>2]|0)){c[m>>2]=13;ga=c[m>>2]|0;i=l;return ga|0}else{c[c[s>>2]>>2]=c[q>>2];c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}break}case 24:{c[c[v>>2]>>2]=c[x>>2];c[m>>2]=4;ga=c[m>>2]|0;i=l;return ga|0}case 25:{if(a[t>>0]|0){c[c[s>>2]>>2]=c[q>>2];c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}else{c[m>>2]=5;ga=c[m>>2]|0;i=l;return ga|0}break}case 28:{if(a[t>>0]|0){c[c[s>>2]>>2]=c[q>>2];c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}else{c[m>>2]=6;ga=c[m>>2]|0;i=l;return ga|0}break}case 37:{c[m>>2]=1;ga=c[m>>2]|0;i=l;return ga|0}case 41:{c[m>>2]=11;ga=c[m>>2]|0;i=l;return ga|0}case 43:{c[m>>2]=24;ga=c[m>>2]|0;i=l;return ga|0}case 50:{c[m>>2]=12;ga=c[m>>2]|0;i=l;return ga|0}case 52:{c[m>>2]=15;ga=c[m>>2]|0;i=l;return ga|0}case 60:{c[m>>2]=c[D>>2];ga=c[m>>2]|0;i=l;return ga|0}case 63:{c[m>>2]=1;ga=c[m>>2]|0;i=l;return ga|0}case 65:{c[m>>2]=21;ga=c[m>>2]|0;i=l;return ga|0}case 72:{c[m>>2]=1;ga=c[m>>2]|0;i=l;return ga|0}case 74:{Bb[c[(c[n>>2]|0)+12+8>>2]&127](c[F>>2]|0);c[m>>2]=1;ga=c[m>>2]|0;i=l;return ga|0}case 80:{c[m>>2]=1;ga=c[m>>2]|0;i=l;return ga|0}case 82:{c[m>>2]=c[G>>2];ga=c[m>>2]|0;i=l;return ga|0}case 89:{c[m>>2]=1;ga=c[m>>2]|0;i=l;return ga|0}case 91:{c[m>>2]=c[O>>2];ga=c[m>>2]|0;i=l;return ga|0}case 107:{c[m>>2]=zZ(c[n>>2]|0,c[x>>2]|0,c[r>>2]|0,c[s>>2]|0)|0;ga=c[m>>2]|0;i=l;return ga|0}case 109:{c[m>>2]=13;ga=c[m>>2]|0;i=l;return ga|0}case 112:{c[c[v>>2]>>2]=c[U>>2];c[m>>2]=7;ga=c[m>>2]|0;i=l;return ga|0}case 131:{c[m>>2]=zZ(c[n>>2]|0,c[x>>2]|0,c[r>>2]|0,c[s>>2]|0)|0;ga=c[m>>2]|0;i=l;return ga|0}case 133:{c[m>>2]=14;ga=c[m>>2]|0;i=l;return ga|0}case 138:{c[m>>2]=17;ga=c[m>>2]|0;i=l;return ga|0}case 148:{c[m>>2]=c[ba>>2];ga=c[m>>2]|0;i=l;return ga|0}case 150:{c[(c[n>>2]|0)+280>>2]=62;c[m>>2]=c[ba>>2];ga=c[m>>2]|0;i=l;return ga|0}case 151:{if(a[t>>0]|0){c[c[s>>2]>>2]=c[q>>2];c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}do if(c[(c[n>>2]|0)+60>>2]|0){t=c[n>>2]|0;if(a[(c[p>>2]|0)+72>>0]|0){Tb[c[t+60>>2]&127](c[(c[n>>2]|0)+4>>2]|0,c[q>>2]|0,(c[r>>2]|0)-(c[q>>2]|0)|0);break}else{c[ca>>2]=c[t+44>>2];Ab[c[(c[p>>2]|0)+60>>2]&31](c[p>>2]|0,q,c[r>>2]|0,ca,c[(c[n>>2]|0)+48>>2]|0);Tb[c[(c[n>>2]|0)+60>>2]&127](c[(c[n>>2]|0)+4>>2]|0,c[(c[n>>2]|0)+44>>2]|0,(c[ca>>2]|0)-(c[(c[n>>2]|0)+44>>2]|0)|0);break}}else if(c[(c[n>>2]|0)+80>>2]|0)TY(c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0);while(0);if(!(c[o>>2]|0)){c[c[v>>2]>>2]=c[r>>2];c[m>>2]=3;ga=c[m>>2]|0;i=l;return ga|0}q=c[r>>2]|0;if((c[(c[n>>2]|0)+312>>2]|0)!=(c[o>>2]|0)){c[c[v>>2]>>2]=q;c[m>>2]=13;ga=c[m>>2]|0;i=l;return ga|0}else{c[c[s>>2]>>2]=q;c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}break}case 172:{c[m>>2]=1;ga=c[m>>2]|0;i=l;return ga|0}case 174:{c[m>>2]=1;ga=c[m>>2]|0;i=l;return ga|0}case 178:{c[c[s>>2]>>2]=c[x>>2];c[m>>2]=0;ga=c[m>>2]|0;i=l;return ga|0}case 179:{c[m>>2]=35;ga=c[m>>2]|0;i=l;return ga|0}}return 0}function wZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+64|0;h=g+48|0;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g+16|0;r=g+12|0;s=g+8|0;t=g+4|0;u=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[s>>2]=c[(c[j>>2]|0)+300>>2];if(!(c[s>>2]|0)){c[h>>2]=23;v=c[h>>2]|0;i=g;return v|0}c[n>>2]=c[(c[s>>2]|0)+12>>2];c[o>>2]=(c[(c[n>>2]|0)+4>>2]|0)+(c[(c[n>>2]|0)+12>>2]|0);c[p>>2]=(c[(c[n>>2]|0)+4>>2]|0)+(c[(c[n>>2]|0)+8>>2]|0);f=c[j>>2]|0;if(a[(c[n>>2]|0)+33>>0]|0){c[t>>2]=Sb[c[c[f+228>>2]>>2]&127](c[(c[j>>2]|0)+228>>2]|0,c[o>>2]|0,c[p>>2]|0,q)|0;c[r>>2]=_Y(c[j>>2]|0,c[(c[j>>2]|0)+228>>2]|0,c[o>>2]|0,c[p>>2]|0,c[t>>2]|0,c[q>>2]|0,q,0)|0}else c[r>>2]=vZ(f,c[(c[s>>2]|0)+16>>2]|0,c[(c[j>>2]|0)+228>>2]|0,c[o>>2]|0,c[p>>2]|0,q,0)|0;if(c[r>>2]|0){c[h>>2]=c[r>>2];v=c[h>>2]|0;i=g;return v|0}if((c[p>>2]|0)!=(c[q>>2]|0)?(c[(c[j>>2]|0)+480>>2]|0)==3:0){c[(c[n>>2]|0)+12>>2]=(c[q>>2]|0)-(c[(c[n>>2]|0)+4>>2]|0);c[h>>2]=c[r>>2];v=c[h>>2]|0;i=g;return v|0}a[(c[n>>2]|0)+32>>0]=0;c[(c[j>>2]|0)+300>>2]=c[(c[s>>2]|0)+8>>2];c[(c[s>>2]|0)+8>>2]=c[(c[j>>2]|0)+304>>2];c[(c[j>>2]|0)+304>>2]=c[s>>2];s=(c[j>>2]|0)+280|0;if(a[(c[n>>2]|0)+33>>0]|0){c[s>>2]=60;c[u>>2]=Sb[c[c[(c[j>>2]|0)+144>>2]>>2]&127](c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[l>>2]|0,q)|0;c[h>>2]=_Y(c[j>>2]|0,c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[l>>2]|0,c[u>>2]|0,c[q>>2]|0,c[m>>2]|0,((a[(c[j>>2]|0)+480+4>>0]|0)!=0^1)&1)|0;v=c[h>>2]|0;i=g;return v|0}else{c[s>>2]=58;c[h>>2]=vZ(c[j>>2]|0,(c[(c[j>>2]|0)+476>>2]|0)!=0?1:0,c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,((a[(c[j>>2]|0)+480+4>>0]|0)!=0^1)&1)|0;v=c[h>>2]|0;i=g;return v|0}return 0}function xZ(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;h=e+40|0;j=e+32|0;k=e+52|0;l=e+28|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e+4|0;s=e;c[g>>2]=b;c[h>>2]=c[(c[g>>2]|0)+356>>2];a[k>>0]=0;do if(c[(c[h>>2]|0)+152+4>>2]|0){if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}b=(c[g>>2]|0)+416+12|0;u=c[b>>2]|0;c[b>>2]=u+1;a[u>>0]=61;c[m>>2]=c[(c[(c[h>>2]|0)+152+4>>2]|0)+20>>2];if(a[(c[g>>2]|0)+472>>0]|0)c[m>>2]=(c[m>>2]|0)+-1;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[m>>2]|0)){v=13;break}if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0)break;u=a[(c[(c[(c[h>>2]|0)+152+4>>2]|0)+16>>2]|0)+(c[l>>2]|0)>>0]|0;b=(c[g>>2]|0)+416+12|0;w=c[b>>2]|0;c[b>>2]=w+1;a[w>>0]=u;c[l>>2]=(c[l>>2]|0)+1}if((v|0)==13){a[k>>0]=1;break}c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}while(0);VY(j,(c[h>>2]|0)+60|0);a:while(1){c[q>>2]=WY(j)|0;if(!(c[q>>2]|0)){v=40;break}if(!(c[(c[q>>2]|0)+4>>2]|0))continue;if(d[k>>0]|0){if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){v=21;break}l=(c[g>>2]|0)+416+12|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m>>0]=12}c[p>>2]=c[c[q>>2]>>2];while(1){x=(c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0);if(!(a[c[p>>2]>>0]|0))break;if(x?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){v=27;break a}m=a[c[p>>2]>>0]|0;l=(c[g>>2]|0)+416+12|0;u=c[l>>2]|0;c[l>>2]=u+1;a[u>>0]=m;c[p>>2]=(c[p>>2]|0)+1}if(x?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){v=31;break}m=(c[g>>2]|0)+416+12|0;u=c[m>>2]|0;c[m>>2]=u+1;a[u>>0]=61;c[o>>2]=c[(c[(c[q>>2]|0)+4>>2]|0)+20>>2];if(a[(c[g>>2]|0)+472>>0]|0)c[o>>2]=(c[o>>2]|0)+-1;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[o>>2]|0))break;if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){v=38;break a}u=a[(c[(c[(c[q>>2]|0)+4>>2]|0)+16>>2]|0)+(c[n>>2]|0)>>0]|0;m=(c[g>>2]|0)+416+12|0;l=c[m>>2]|0;c[m>>2]=l+1;a[l>>0]=u;c[n>>2]=(c[n>>2]|0)+1}a[k>>0]=1}if((v|0)==21){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else if((v|0)==27){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else if((v|0)==31){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else if((v|0)==38){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else if((v|0)==40){VY(j,c[h>>2]|0);b:while(1){c[s>>2]=WY(j)|0;if(!(c[s>>2]|0)){v=55;break}if(!(a[(c[s>>2]|0)+32>>0]|0))continue;if(d[k>>0]|0){if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){v=47;break}h=(c[g>>2]|0)+416+12|0;n=c[h>>2]|0;c[h>>2]=n+1;a[n>>0]=12}c[r>>2]=c[c[s>>2]>>2];while(1){if(!(a[c[r>>2]>>0]|0))break;if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){v=53;break b}n=a[c[r>>2]>>0]|0;h=(c[g>>2]|0)+416+12|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=n;c[r>>2]=(c[r>>2]|0)+1}a[k>>0]=1}if((v|0)==47){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else if((v|0)==53){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}else if((v|0)==55){if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}v=(c[g>>2]|0)+416+12|0;k=c[v>>2]|0;c[v>>2]=k+1;a[k>>0]=0;c[f>>2]=c[(c[g>>2]|0)+416+16>>2];t=c[f>>2]|0;i=e;return t|0}}return 0}function yZ(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;j=i;i=i+176|0;k=j+156|0;l=j+152|0;m=j+148|0;n=j+144|0;o=j+140|0;p=j+136|0;q=j+132|0;r=j+128|0;s=j+124|0;t=j+120|0;u=j+116|0;v=j+112|0;w=j+108|0;x=j+104|0;y=j+100|0;z=j+96|0;A=j+92|0;B=j+88|0;C=j+84|0;D=j+80|0;E=j+76|0;F=j+72|0;G=j+68|0;H=j+64|0;I=j+163|0;J=j+60|0;K=j+56|0;L=j+52|0;M=j+48|0;N=j+44|0;O=j+40|0;P=j+36|0;Q=j+32|0;R=j+28|0;S=j+24|0;T=j+20|0;U=j+16|0;V=j+162|0;W=j+161|0;X=j+160|0;Y=j+12|0;Z=j+8|0;_=j+4|0;$=j;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;c[q>>2]=c[(c[l>>2]|0)+356>>2];c[u>>2]=0;c[z>>2]=0;c[r>>2]=bZ(c[l>>2]|0,(c[q>>2]|0)+20|0,c[c[o>>2]>>2]|0,0)|0;if(!(c[r>>2]|0)){c[C>>2]=MY((c[q>>2]|0)+80|0,c[c[o>>2]>>2]|0)|0;if(!(c[C>>2]|0)){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}c[r>>2]=bZ(c[l>>2]|0,(c[q>>2]|0)+20|0,c[C>>2]|0,24)|0;if(!(c[r>>2]|0)){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}if((d[(c[l>>2]|0)+236>>0]|0)!=0?(EZ(c[l>>2]|0,c[r>>2]|0)|0)==0:0){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}}c[s>>2]=c[(c[r>>2]|0)+12>>2];c[x>>2]=Sb[c[(c[m>>2]|0)+40>>2]&127](c[m>>2]|0,c[n>>2]|0,c[(c[l>>2]|0)+380>>2]|0,c[(c[l>>2]|0)+392>>2]|0)|0;do if(((c[x>>2]|0)+(c[s>>2]|0)|0)>(c[(c[l>>2]|0)+380>>2]|0)){c[D>>2]=c[(c[l>>2]|0)+380>>2];c[(c[l>>2]|0)+380>>2]=(c[x>>2]|0)+(c[s>>2]|0)+16;c[E>>2]=Ob[c[(c[l>>2]|0)+12+4>>2]&127](c[(c[l>>2]|0)+392>>2]|0,c[(c[l>>2]|0)+380>>2]<<4)|0;if(!(c[E>>2]|0)){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}else{c[(c[l>>2]|0)+392>>2]=c[E>>2];if((c[x>>2]|0)<=(c[D>>2]|0))break;Sb[c[(c[m>>2]|0)+40>>2]&127](c[m>>2]|0,c[n>>2]|0,c[x>>2]|0,c[(c[l>>2]|0)+392>>2]|0)|0;break}}while(0);c[t>>2]=c[(c[l>>2]|0)+392>>2];c[w>>2]=0;a:while(1){if((c[w>>2]|0)>=(c[x>>2]|0)){ba=43;break}c[F>>2]=(c[(c[l>>2]|0)+392>>2]|0)+(c[w>>2]<<4);n=c[l>>2]|0;D=c[m>>2]|0;E=c[c[F>>2]>>2]|0;C=c[c[F>>2]>>2]|0;c[G>>2]=fZ(n,D,E,C+(Ob[c[(c[m>>2]|0)+32>>2]&127](c[m>>2]|0,c[c[F>>2]>>2]|0)|0)|0)|0;if(!(c[G>>2]|0)){ba=17;break}if(a[(c[c[G>>2]>>2]|0)+-1>>0]|0){ba=19;break}a[(c[c[G>>2]>>2]|0)+-1>>0]=1;C=c[c[G>>2]>>2]|0;E=c[u>>2]|0;c[u>>2]=E+1;c[(c[t>>2]|0)+(E<<2)>>2]=C;if(a[(c[(c[l>>2]|0)+392>>2]|0)+(c[w>>2]<<4)+12>>0]|0){C=aZ((c[l>>2]|0)+416|0,c[m>>2]|0,c[(c[(c[l>>2]|0)+392>>2]|0)+(c[w>>2]<<4)+4>>2]|0,c[(c[(c[l>>2]|0)+392>>2]|0)+(c[w>>2]<<4)+8>>2]|0)|0;c[(c[t>>2]|0)+(c[u>>2]<<2)>>2]=C;if(!(c[(c[t>>2]|0)+(c[u>>2]<<2)>>2]|0)){ba=33;break}c[(c[l>>2]|0)+416+16>>2]=c[(c[l>>2]|0)+416+12>>2]}else{a[I>>0]=1;b:do if(a[(c[G>>2]|0)+8>>0]|0){c[J>>2]=0;while(1){if((c[J>>2]|0)>=(c[s>>2]|0))break b;ca=c[J>>2]|0;if((c[G>>2]|0)==(c[(c[(c[r>>2]|0)+20>>2]|0)+((c[J>>2]|0)*12|0)>>2]|0))break;c[J>>2]=ca+1}a[I>>0]=a[(c[(c[r>>2]|0)+20>>2]|0)+(ca*12|0)+4>>0]|0}while(0);c[H>>2]=kZ(c[l>>2]|0,c[m>>2]|0,a[I>>0]|0,c[(c[(c[l>>2]|0)+392>>2]|0)+(c[w>>2]<<4)+4>>2]|0,c[(c[(c[l>>2]|0)+392>>2]|0)+(c[w>>2]<<4)+8>>2]|0,(c[l>>2]|0)+416|0)|0;if(c[H>>2]|0){ba=30;break}c[(c[t>>2]|0)+(c[u>>2]<<2)>>2]=c[(c[l>>2]|0)+416+16>>2];c[(c[l>>2]|0)+416+16>>2]=c[(c[l>>2]|0)+416+12>>2]}do if(c[(c[G>>2]|0)+4>>2]|0){if(!(a[(c[G>>2]|0)+9>>0]|0)){c[u>>2]=(c[u>>2]|0)+1;c[z>>2]=(c[z>>2]|0)+1;a[(c[c[G>>2]>>2]|0)+-1>>0]=2;break}c[K>>2]=FZ(c[l>>2]|0,c[(c[G>>2]|0)+4>>2]|0,c[G>>2]|0,c[(c[t>>2]|0)+(c[u>>2]<<2)>>2]|0,c[p>>2]|0)|0;if(c[K>>2]|0){ba=38;break a}c[u>>2]=(c[u>>2]|0)+-1}else c[u>>2]=(c[u>>2]|0)+1;while(0);c[w>>2]=(c[w>>2]|0)+1}if((ba|0)==17){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==19){if((c[m>>2]|0)==(c[(c[l>>2]|0)+144>>2]|0))c[(c[l>>2]|0)+288>>2]=c[(c[(c[l>>2]|0)+392>>2]|0)+(c[w>>2]<<4)>>2];c[k>>2]=8;aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==30){c[k>>2]=c[H>>2];aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==33){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==38){c[k>>2]=c[K>>2];aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==43){c[(c[l>>2]|0)+384>>2]=c[u>>2];c:do if((c[(c[r>>2]|0)+8>>2]|0)!=0?(a[(c[c[(c[r>>2]|0)+8>>2]>>2]|0)+-1>>0]|0)!=0:0){c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break c;da=c[w>>2]|0;if((c[(c[t>>2]|0)+(c[w>>2]<<2)>>2]|0)==(c[c[(c[r>>2]|0)+8>>2]>>2]|0))break;c[w>>2]=da+2}c[(c[l>>2]|0)+388>>2]=da}else ba=50;while(0);if((ba|0)==50)c[(c[l>>2]|0)+388>>2]=-1;c[w>>2]=0;d:while(1){if((c[w>>2]|0)>=(c[s>>2]|0))break;c[L>>2]=(c[(c[r>>2]|0)+20>>2]|0)+((c[w>>2]|0)*12|0);do if((a[(c[c[c[L>>2]>>2]>>2]|0)+-1>>0]|0)==0?(c[(c[L>>2]|0)+8>>2]|0)!=0:0){da=c[c[L>>2]>>2]|0;if(!(c[(c[c[L>>2]>>2]|0)+4>>2]|0)){a[(c[da>>2]|0)+-1>>0]=1;K=c[c[c[L>>2]>>2]>>2]|0;H=c[u>>2]|0;c[u>>2]=H+1;c[(c[t>>2]|0)+(H<<2)>>2]=K;K=c[(c[L>>2]|0)+8>>2]|0;H=c[u>>2]|0;c[u>>2]=H+1;c[(c[t>>2]|0)+(H<<2)>>2]=K;break}if(a[da+9>>0]|0){c[M>>2]=FZ(c[l>>2]|0,c[(c[c[L>>2]>>2]|0)+4>>2]|0,c[c[L>>2]>>2]|0,c[(c[L>>2]|0)+8>>2]|0,c[p>>2]|0)|0;if(c[M>>2]|0){ba=58;break d}else break}else{a[(c[c[c[L>>2]>>2]>>2]|0)+-1>>0]=2;c[z>>2]=(c[z>>2]|0)+1;da=c[c[c[L>>2]>>2]>>2]|0;K=c[u>>2]|0;c[u>>2]=K+1;c[(c[t>>2]|0)+(K<<2)>>2]=da;da=c[(c[L>>2]|0)+8>>2]|0;K=c[u>>2]|0;c[u>>2]=K+1;c[(c[t>>2]|0)+(K<<2)>>2]=da;break}}while(0);c[w>>2]=(c[w>>2]|0)+1}if((ba|0)==58){c[k>>2]=c[M>>2];aa=c[k>>2]|0;i=j;return aa|0}c[(c[t>>2]|0)+(c[u>>2]<<2)>>2]=0;c[w>>2]=0;e:do if(c[z>>2]|0){c[O>>2]=c[(c[l>>2]|0)+400>>2];c[P>>2]=1<<d[(c[l>>2]|0)+404>>0];do if(c[z>>2]<<1>>d[(c[l>>2]|0)+404>>0]){do{M=c[z>>2]|0;L=(c[l>>2]|0)+404|0;s=a[L>>0]|0;a[L>>0]=s+1<<24>>24}while((M>>(s&255)|0)!=0);if((d[(c[l>>2]|0)+404>>0]|0)<3)a[(c[l>>2]|0)+404>>0]=3;c[P>>2]=1<<d[(c[l>>2]|0)+404>>0];c[Q>>2]=Ob[c[(c[l>>2]|0)+12+4>>2]&127](c[(c[l>>2]|0)+396>>2]|0,(c[P>>2]|0)*12|0)|0;if(c[Q>>2]|0){c[(c[l>>2]|0)+396>>2]=c[Q>>2];c[O>>2]=0;break}c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}while(0);f:do if(!(c[O>>2]|0)){c[O>>2]=-1;c[N>>2]=c[P>>2];while(1){if(!(c[N>>2]|0))break f;s=c[O>>2]|0;M=(c[N>>2]|0)+-1|0;c[N>>2]=M;c[(c[(c[l>>2]|0)+396>>2]|0)+(M*12|0)>>2]=s}}while(0);s=(c[O>>2]|0)+-1|0;c[O>>2]=s;c[(c[l>>2]|0)+400>>2]=s;g:while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break e;c[R>>2]=c[(c[t>>2]|0)+(c[w>>2]<<2)>>2];if((a[(c[R>>2]|0)+-1>>0]|0)==2){c[U>>2]=c[(c[l>>2]|0)+496>>2];a[(c[R>>2]|0)+-1>>0]=0;c[S>>2]=bZ(c[l>>2]|0,(c[q>>2]|0)+40|0,c[R>>2]|0,0)|0;c[T>>2]=c[(c[(c[S>>2]|0)+4>>2]|0)+4>>2];if(!(c[T>>2]|0)){ba=78;break}c[N>>2]=0;while(1){if((c[N>>2]|0)>=(c[(c[T>>2]|0)+20>>2]|0))break;a[V>>0]=a[(c[(c[T>>2]|0)+16>>2]|0)+(c[N>>2]|0)>>0]|0;if((c[(c[l>>2]|0)+416+12>>2]|0)==(c[(c[l>>2]|0)+416+8>>2]|0)?(jZ((c[l>>2]|0)+416|0)|0)<<24>>24==0:0){ba=84;break g}s=a[V>>0]|0;M=(c[l>>2]|0)+416+12|0;L=c[M>>2]|0;c[M>>2]=L+1;a[L>>0]=s;c[U>>2]=(c[U>>2]|0)*1000003^d[V>>0];c[N>>2]=(c[N>>2]|0)+1}do{s=c[R>>2]|0;c[R>>2]=s+1}while((a[s>>0]|0)!=58);do{a[W>>0]=a[c[R>>2]>>0]|0;if((c[(c[l>>2]|0)+416+12>>2]|0)==(c[(c[l>>2]|0)+416+8>>2]|0)?(jZ((c[l>>2]|0)+416|0)|0)<<24>>24==0:0){ba=89;break g}s=a[c[R>>2]>>0]|0;L=(c[l>>2]|0)+416+12|0;M=c[L>>2]|0;c[L>>2]=M+1;a[M>>0]=s;c[U>>2]=(c[U>>2]|0)*1000003^d[W>>0];s=c[R>>2]|0;c[R>>2]=s+1}while((a[s>>0]|0)!=0);a[X>>0]=0;c[Y>>2]=(c[P>>2]|0)-1;c[N>>2]=c[U>>2]&c[Y>>2];while(1){if((c[(c[(c[l>>2]|0)+396>>2]|0)+((c[N>>2]|0)*12|0)>>2]|0)!=(c[O>>2]|0))break;if((c[U>>2]|0)==(c[(c[(c[l>>2]|0)+396>>2]|0)+((c[N>>2]|0)*12|0)+4>>2]|0)){c[Z>>2]=c[(c[l>>2]|0)+416+16>>2];c[_>>2]=c[(c[(c[l>>2]|0)+396>>2]|0)+((c[N>>2]|0)*12|0)+8>>2];while(1){if((a[c[Z>>2]>>0]|0)!=(a[c[_>>2]>>0]|0))break;if(!(a[c[Z>>2]>>0]|0))break;c[Z>>2]=(c[Z>>2]|0)+1;c[_>>2]=(c[_>>2]|0)+1}if(!(a[c[Z>>2]>>0]|0)){ba=98;break g}}if(!(a[X>>0]|0))a[X>>0]=(c[U>>2]&~c[Y>>2])>>>((d[(c[l>>2]|0)+404>>0]|0)-1|0)&(c[Y>>2]|0)>>>2|1;if((c[N>>2]|0)<(d[X>>0]|0)){c[N>>2]=(c[N>>2]|0)+((c[P>>2]|0)-(d[X>>0]|0));continue}else{c[N>>2]=(c[N>>2]|0)-(d[X>>0]|0);continue}}if(a[(c[l>>2]|0)+237>>0]|0){a[(c[(c[l>>2]|0)+416+12>>2]|0)+-1>>0]=a[(c[l>>2]|0)+472>>0]|0;c[R>>2]=c[c[c[T>>2]>>2]>>2];do{if((c[(c[l>>2]|0)+416+12>>2]|0)==(c[(c[l>>2]|0)+416+8>>2]|0)?(jZ((c[l>>2]|0)+416|0)|0)<<24>>24==0:0){ba=109;break g}s=a[c[R>>2]>>0]|0;M=(c[l>>2]|0)+416+12|0;L=c[M>>2]|0;c[M>>2]=L+1;a[L>>0]=s;s=c[R>>2]|0;c[R>>2]=s+1}while((a[s>>0]|0)!=0)}c[R>>2]=c[(c[l>>2]|0)+416+16>>2];c[(c[l>>2]|0)+416+16>>2]=c[(c[l>>2]|0)+416+12>>2];c[(c[t>>2]|0)+(c[w>>2]<<2)>>2]=c[R>>2];c[(c[(c[l>>2]|0)+396>>2]|0)+((c[N>>2]|0)*12|0)>>2]=c[O>>2];c[(c[(c[l>>2]|0)+396>>2]|0)+((c[N>>2]|0)*12|0)+4>>2]=c[U>>2];c[(c[(c[l>>2]|0)+396>>2]|0)+((c[N>>2]|0)*12|0)+8>>2]=c[R>>2];s=(c[z>>2]|0)+-1|0;c[z>>2]=s;if(!s){ba=111;break}}else a[(c[R>>2]|0)+-1>>0]=0;c[w>>2]=(c[w>>2]|0)+2}if((ba|0)==78){c[k>>2]=27;aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==84){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==89){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==98){c[k>>2]=8;aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==109){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}else if((ba|0)==111){c[w>>2]=(c[w>>2]|0)+2;break}}while(0);while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break;a[(c[(c[t>>2]|0)+(c[w>>2]<<2)>>2]|0)+-1>>0]=0;c[w>>2]=(c[w>>2]|0)+2}c[A>>2]=c[c[p>>2]>>2];while(1){if(!(c[A>>2]|0))break;a[(c[c[(c[A>>2]|0)+12>>2]>>2]|0)+-1>>0]=0;c[A>>2]=c[(c[A>>2]|0)+4>>2]}if(!(a[(c[l>>2]|0)+236>>0]|0)){c[k>>2]=0;aa=c[k>>2]|0;i=j;return aa|0}do if(c[(c[r>>2]|0)+4>>2]|0){c[A>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+4>>2];if(c[A>>2]|0){c[B>>2]=c[c[o>>2]>>2];do{p=c[B>>2]|0;c[B>>2]=p+1}while((a[p>>0]|0)!=58)}else{c[k>>2]=27;aa=c[k>>2]|0;i=j;return aa|0}}else{if(c[(c[q>>2]|0)+152+4>>2]|0){c[A>>2]=c[(c[q>>2]|0)+152+4>>2];c[B>>2]=c[c[o>>2]>>2];break}c[k>>2]=0;aa=c[k>>2]|0;i=j;return aa|0}while(0);c[v>>2]=0;if((d[(c[l>>2]|0)+237>>0]|0)!=0?(c[c[c[A>>2]>>2]>>2]|0)!=0:0)do{q=c[v>>2]|0;c[v>>2]=q+1}while((a[(c[c[c[A>>2]>>2]>>2]|0)+q>>0]|0)!=0);c[(c[o>>2]|0)+4>>2]=c[B>>2];c[(c[o>>2]|0)+16>>2]=c[(c[A>>2]|0)+20>>2];c[(c[o>>2]|0)+8>>2]=c[c[c[A>>2]>>2]>>2];c[(c[o>>2]|0)+20>>2]=c[v>>2];c[w>>2]=0;do{q=c[w>>2]|0;c[w>>2]=q+1}while((a[(c[B>>2]|0)+q>>0]|0)!=0);c[x>>2]=(c[w>>2]|0)+(c[(c[A>>2]|0)+20>>2]|0)+(c[v>>2]|0);if((c[x>>2]|0)>(c[(c[A>>2]|0)+24>>2]|0)){c[y>>2]=Fb[c[(c[l>>2]|0)+12>>2]&63]((c[x>>2]|0)+24|0)|0;if(!(c[y>>2]|0)){c[k>>2]=1;aa=c[k>>2]|0;i=j;return aa|0}c[(c[A>>2]|0)+24>>2]=(c[x>>2]|0)+24;Z4(c[y>>2]|0,c[(c[A>>2]|0)+16>>2]|0,c[(c[A>>2]|0)+20>>2]|0)|0;c[$>>2]=c[(c[l>>2]|0)+364>>2];while(1){if(!(c[$>>2]|0))break;if((c[(c[$>>2]|0)+12>>2]|0)==(c[(c[A>>2]|0)+16>>2]|0))c[(c[$>>2]|0)+12>>2]=c[y>>2];c[$>>2]=c[c[$>>2]>>2]}Bb[c[(c[l>>2]|0)+12+8>>2]&127](c[(c[A>>2]|0)+16>>2]|0);c[(c[A>>2]|0)+16>>2]=c[y>>2]}c[y>>2]=(c[(c[A>>2]|0)+16>>2]|0)+(c[(c[A>>2]|0)+20>>2]|0);Z4(c[y>>2]|0,c[B>>2]|0,c[w>>2]|0)|0;if(c[v>>2]|0){c[y>>2]=(c[y>>2]|0)+((c[w>>2]|0)-1);a[c[y>>2]>>0]=a[(c[l>>2]|0)+472>>0]|0;Z4((c[y>>2]|0)+1|0,c[c[c[A>>2]>>2]>>2]|0,c[v>>2]|0)|0}c[c[o>>2]>>2]=c[(c[A>>2]|0)+16>>2];c[k>>2]=0;aa=c[k>>2]|0;i=j;return aa|0}return 0}function zZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[(c[j>>2]|0)+280>>2]=63;c[(c[j>>2]|0)+288>>2]=c[k>>2];a:while(1){c[n>>2]=0;c[o>>2]=Sb[c[c[(c[j>>2]|0)+144>>2]>>2]&127](c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[l>>2]|0,n)|0;c[(c[j>>2]|0)+292>>2]=c[n>>2];switch(c[o>>2]|0){case -15:{p=3;break a;break}case -4:{p=7;break a;break}case 0:{p=14;break a;break}case -1:{p=15;break a;break}case -2:{p=18;break a;break}case 15:{if(c[(c[j>>2]|0)+80>>2]|0)TY(c[j>>2]|0,c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[n>>2]|0);break}case 11:{if(!(rZ(c[j>>2]|0,c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[n>>2]|0)|0)){p=11;break a}break}case 13:{if(!(sZ(c[j>>2]|0,c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[n>>2]|0)|0)){p=13;break a}break}default:{p=21;break a}}f=c[n>>2]|0;c[k>>2]=f;c[(c[j>>2]|0)+288>>2]=f;switch(c[(c[j>>2]|0)+480>>2]|0){case 3:{p=23;break a;break}case 2:{p=24;break a;break}default:{}}}switch(p|0){case 3:{if((c[(c[j>>2]|0)+80>>2]|0)!=0?(TY(c[j>>2]|0,c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[n>>2]|0),(c[(c[j>>2]|0)+480>>2]|0)==2):0){c[h>>2]=35;break}c[c[m>>2]>>2]=c[n>>2];c[h>>2]=0;break}case 7:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break}case 11:{c[h>>2]=1;break}case 13:{c[h>>2]=1;break}case 14:{c[(c[j>>2]|0)+288>>2]=c[n>>2];c[h>>2]=4;break}case 15:{if(a[(c[j>>2]|0)+480+4>>0]|0){c[h>>2]=5;break}else{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break}break}case 18:{if(a[(c[j>>2]|0)+480+4>>0]|0){c[h>>2]=6;break}else{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break}break}case 21:{c[h>>2]=9;break}case 23:{c[c[m>>2]>>2]=c[n>>2];c[h>>2]=0;break}case 24:{c[h>>2]=35;break}}i=g;return c[h>>2]|0}function AZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=i;i=i+64|0;k=j+48|0;l=j+44|0;m=j+40|0;n=j+36|0;o=j+32|0;p=j+28|0;q=j+53|0;r=j+24|0;s=j+20|0;t=j+16|0;u=j+12|0;v=j+8|0;w=j+52|0;x=j+4|0;y=j;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;a[q>>0]=h;c[r>>2]=c[c[n>>2]>>2];h=c[l>>2]|0;if((c[m>>2]|0)==(c[(c[l>>2]|0)+144>>2]|0)){c[s>>2]=h+288;c[c[s>>2]>>2]=c[r>>2];c[t>>2]=(c[l>>2]|0)+292}else{c[s>>2]=c[h+300>>2];c[t>>2]=(c[(c[l>>2]|0)+300>>2]|0)+4}c[c[s>>2]>>2]=c[r>>2];c[c[n>>2]>>2]=0;a:while(1){c[v>>2]=Sb[c[(c[m>>2]|0)+8>>2]&127](c[m>>2]|0,c[r>>2]|0,c[o>>2]|0,u)|0;c[c[t>>2]>>2]=c[u>>2];b:do switch(c[v>>2]|0){case 40:{z=6;break a;break}case 0:{z=24;break a;break}case -2:{z=25;break a;break}case -4:case -1:{z=28;break a;break}case 7:{if(c[(c[l>>2]|0)+60>>2]|0){a[w>>0]=10;Tb[c[(c[l>>2]|0)+60>>2]&127](c[(c[l>>2]|0)+4>>2]|0,w,1);break b}if(c[(c[l>>2]|0)+80>>2]|0)TY(c[l>>2]|0,c[m>>2]|0,c[r>>2]|0,c[u>>2]|0);break}case 6:{c[x>>2]=c[(c[l>>2]|0)+60>>2];if(!(c[x>>2]|0)){if(!(c[(c[l>>2]|0)+80>>2]|0))break b;TY(c[l>>2]|0,c[m>>2]|0,c[r>>2]|0,c[u>>2]|0);break b}if(a[(c[m>>2]|0)+72>>0]|0){Tb[c[x>>2]&127](c[(c[l>>2]|0)+4>>2]|0,c[r>>2]|0,(c[u>>2]|0)-(c[r>>2]|0)|0);break b}while(1){c[y>>2]=c[(c[l>>2]|0)+44>>2];Ab[c[(c[m>>2]|0)+60>>2]&31](c[m>>2]|0,r,c[u>>2]|0,y,c[(c[l>>2]|0)+48>>2]|0);c[c[t>>2]>>2]=c[u>>2];Tb[c[x>>2]&127](c[(c[l>>2]|0)+4>>2]|0,c[(c[l>>2]|0)+44>>2]|0,(c[y>>2]|0)-(c[(c[l>>2]|0)+44>>2]|0)|0);if((c[r>>2]|0)==(c[u>>2]|0))break b;c[c[s>>2]>>2]=c[r>>2]}break}default:{z=31;break a}}while(0);h=c[u>>2]|0;c[r>>2]=h;c[c[s>>2]>>2]=h;switch(c[(c[l>>2]|0)+480>>2]|0){case 3:{z=33;break a;break}case 2:{z=34;break a;break}default:{}}}if((z|0)==6){y=c[l>>2]|0;if(!(c[(c[l>>2]|0)+76>>2]|0)){if(c[y+80>>2]|0)TY(c[l>>2]|0,c[m>>2]|0,c[r>>2]|0,c[u>>2]|0)}else Bb[c[y+76>>2]&127](c[(c[l>>2]|0)+4>>2]|0);c[c[n>>2]>>2]=c[u>>2];c[c[p>>2]>>2]=c[u>>2];if((c[(c[l>>2]|0)+480>>2]|0)==2){c[k>>2]=35;A=c[k>>2]|0;i=j;return A|0}else{c[k>>2]=0;A=c[k>>2]|0;i=j;return A|0}}else if((z|0)==24){c[c[s>>2]>>2]=c[u>>2];c[k>>2]=4;A=c[k>>2]|0;i=j;return A|0}else if((z|0)==25)if(a[q>>0]|0){c[c[p>>2]>>2]=c[r>>2];c[k>>2]=0;A=c[k>>2]|0;i=j;return A|0}else{c[k>>2]=6;A=c[k>>2]|0;i=j;return A|0}else if((z|0)==28)if(a[q>>0]|0){c[c[p>>2]>>2]=c[r>>2];c[k>>2]=0;A=c[k>>2]|0;i=j;return A|0}else{c[k>>2]=20;A=c[k>>2]|0;i=j;return A|0}else if((z|0)==31){c[c[s>>2]>>2]=c[u>>2];c[k>>2]=23;A=c[k>>2]|0;i=j;return A|0}else if((z|0)==33){c[c[p>>2]>>2]=c[u>>2];c[k>>2]=0;A=c[k>>2]|0;i=j;return A|0}else if((z|0)==34){c[k>>2]=35;A=c[k>>2]|0;i=j;return A|0}return 0}function BZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=AZ(c[j>>2]|0,c[(c[j>>2]|0)+144>>2]|0,k,c[l>>2]|0,c[m>>2]|0,((a[(c[j>>2]|0)+480+4>>0]|0)!=0^1)&1)|0;if(c[n>>2]|0){c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}if(!(c[k>>2]|0)){c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}n=(c[j>>2]|0)+280|0;if(c[(c[j>>2]|0)+476>>2]|0){c[n>>2]=64;c[h>>2]=CZ(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}else{c[n>>2]=58;c[h>>2]=dZ(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}return 0}function CZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=vZ(c[j>>2]|0,1,c[(c[j>>2]|0)+144>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,((a[(c[j>>2]|0)+480+4>>0]|0)!=0^1)&1)|0;if((c[n>>2]|0)==0?(DZ(c[j>>2]|0)|0)<<24>>24==0:0){c[h>>2]=1;o=c[h>>2]|0;i=g;return o|0}c[h>>2]=c[n>>2];o=c[h>>2]|0;i=g;return o|0}function DZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+364>>2];while(1){if(!(c[g>>2]|0)){m=13;break}c[j>>2]=(c[(c[g>>2]|0)+12+12>>2]|0)+1;c[k>>2]=(c[(c[g>>2]|0)+36>>2]|0)+(c[j>>2]|0);if((c[(c[g>>2]|0)+4>>2]|0)==(c[k>>2]|0)){m=13;break}c[h>>2]=(c[j>>2]|0)+((c[(c[g>>2]|0)+8>>2]|0)+0);if((c[h>>2]|0)>((c[(c[g>>2]|0)+40>>2]|0)-(c[(c[g>>2]|0)+36>>2]|0)|0)){c[l>>2]=Ob[c[(c[f>>2]|0)+12+4>>2]&127](c[(c[g>>2]|0)+36>>2]|0,c[h>>2]|0)|0;if(!(c[l>>2]|0)){m=6;break}if((c[(c[g>>2]|0)+12>>2]|0)==(c[(c[g>>2]|0)+36>>2]|0))c[(c[g>>2]|0)+12>>2]=c[l>>2];if(c[(c[g>>2]|0)+12+4>>2]|0)c[(c[g>>2]|0)+12+4>>2]=(c[l>>2]|0)+((c[(c[g>>2]|0)+12+4>>2]|0)-(c[(c[g>>2]|0)+36>>2]|0));c[(c[g>>2]|0)+36>>2]=c[l>>2];c[(c[g>>2]|0)+40>>2]=(c[l>>2]|0)+(c[h>>2]|0);c[k>>2]=(c[l>>2]|0)+(c[j>>2]|0)}Z4(c[k>>2]|0,c[(c[g>>2]|0)+4>>2]|0,c[(c[g>>2]|0)+8>>2]|0)|0;c[(c[g>>2]|0)+4>>2]=c[k>>2];c[g>>2]=c[c[g>>2]>>2]}if((m|0)==6){a[e>>0]=0;n=a[e>>0]|0;i=d;return n|0}else if((m|0)==13){a[e>>0]=1;n=a[e>>0]|0;i=d;return n|0}return 0}function EZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[(c[g>>2]|0)+356>>2];c[k>>2]=c[c[h>>2]>>2];a:while(1){if(!(a[c[k>>2]>>0]|0)){n=20;break}if((a[c[k>>2]>>0]|0)==58){c[m>>2]=c[c[h>>2]>>2];while(1){o=(c[(c[j>>2]|0)+80+12>>2]|0)==(c[(c[j>>2]|0)+80+8>>2]|0);if((c[m>>2]|0)==(c[k>>2]|0))break;if(o?(jZ((c[j>>2]|0)+80|0)|0)<<24>>24==0:0){n=9;break a}d=a[c[m>>2]>>0]|0;b=(c[j>>2]|0)+80+12|0;p=c[b>>2]|0;c[b>>2]=p+1;a[p>>0]=d;c[m>>2]=(c[m>>2]|0)+1}if(o?(jZ((c[j>>2]|0)+80|0)|0)<<24>>24==0:0){n=13;break}d=(c[j>>2]|0)+80+12|0;p=c[d>>2]|0;c[d>>2]=p+1;a[p>>0]=0;c[l>>2]=bZ(c[g>>2]|0,(c[j>>2]|0)+60|0,c[(c[j>>2]|0)+80+16>>2]|0,8)|0;if(!(c[l>>2]|0)){n=14;break}p=(c[j>>2]|0)+80|0;if((c[c[l>>2]>>2]|0)==(c[(c[j>>2]|0)+80+16>>2]|0))c[(c[j>>2]|0)+80+16>>2]=c[p+12>>2];else c[(c[j>>2]|0)+80+12>>2]=c[p+16>>2];c[(c[h>>2]|0)+4>>2]=c[l>>2]}c[k>>2]=(c[k>>2]|0)+1}if((n|0)==9){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else if((n|0)==13){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else if((n|0)==14){c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}else if((n|0)==20){c[f>>2]=1;q=c[f>>2]|0;i=e;return q|0}return 0}function FZ(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+38|0;r=j+37|0;s=j+36|0;t=j+8|0;u=j+4|0;v=j;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;a[q>>0]=0;a[r>>0]=1;a[s>>0]=1;if((a[c[o>>2]>>0]|0)==0?(c[c[m>>2]>>2]|0)!=0:0){c[k>>2]=28;w=c[k>>2]|0;i=j;return w|0}if((((c[c[m>>2]>>2]|0)!=0?(a[c[c[m>>2]>>2]>>0]|0)==120:0)?(a[(c[c[m>>2]>>2]|0)+1>>0]|0)==109:0)?(a[(c[c[m>>2]>>2]|0)+2>>0]|0)==108:0){if(((a[(c[c[m>>2]>>2]|0)+3>>0]|0)==110?(a[(c[c[m>>2]>>2]|0)+4>>0]|0)==115:0)?(a[(c[c[m>>2]>>2]|0)+5>>0]|0)==0:0){c[k>>2]=39;w=c[k>>2]|0;i=j;return w|0}if(!(a[(c[c[m>>2]>>2]|0)+3>>0]|0))a[q>>0]=1}c[u>>2]=0;while(1){x=(d[r>>0]|0)!=0;if(!(a[(c[o>>2]|0)+(c[u>>2]|0)>>0]|0))break;do if(x){if((c[u>>2]|0)<=36?(a[(c[o>>2]|0)+(c[u>>2]|0)>>0]|0)==(a[181511+(c[u>>2]|0)>>0]|0):0)break;a[r>>0]=0}while(0);do if((a[q>>0]|0)==0?(d[s>>0]|0)!=0:0){if((c[u>>2]|0)<=29?(a[(c[o>>2]|0)+(c[u>>2]|0)>>0]|0)==(a[181548+(c[u>>2]|0)>>0]|0):0)break;a[s>>0]=0}while(0);c[u>>2]=(c[u>>2]|0)+1}a[r>>0]=(x?(c[u>>2]|0)==36:0)&1;a[s>>0]=((d[s>>0]|0)!=0?(c[u>>2]|0)==29:0)&1;if((d[q>>0]|0)!=(d[r>>0]|0)){c[k>>2]=(d[q>>0]|0)!=0?38:40;w=c[k>>2]|0;i=j;return w|0}if(a[s>>0]|0){c[k>>2]=40;w=c[k>>2]|0;i=j;return w|0}if(a[(c[l>>2]|0)+472>>0]|0)c[u>>2]=(c[u>>2]|0)+1;s=c[l>>2]|0;do if(c[(c[l>>2]|0)+376>>2]|0){c[t>>2]=c[s+376>>2];do if((c[u>>2]|0)>(c[(c[t>>2]|0)+24>>2]|0)){c[v>>2]=Ob[c[(c[l>>2]|0)+12+4>>2]&127](c[(c[t>>2]|0)+16>>2]|0,(c[u>>2]|0)+24|0)|0;if(c[v>>2]|0){c[(c[t>>2]|0)+16>>2]=c[v>>2];c[(c[t>>2]|0)+24>>2]=(c[u>>2]|0)+24;break}c[k>>2]=1;w=c[k>>2]|0;i=j;return w|0}while(0);c[(c[l>>2]|0)+376>>2]=c[(c[t>>2]|0)+4>>2]}else{c[t>>2]=Fb[c[s+12>>2]&63](28)|0;if(!(c[t>>2]|0)){c[k>>2]=1;w=c[k>>2]|0;i=j;return w|0}q=Fb[c[(c[l>>2]|0)+12>>2]&63]((c[u>>2]|0)+24|0)|0;c[(c[t>>2]|0)+16>>2]=q;if(c[(c[t>>2]|0)+16>>2]|0){c[(c[t>>2]|0)+24>>2]=(c[u>>2]|0)+24;break}Bb[c[(c[l>>2]|0)+12+8>>2]&127](c[t>>2]|0);c[k>>2]=1;w=c[k>>2]|0;i=j;return w|0}while(0);c[(c[t>>2]|0)+20>>2]=c[u>>2];Z4(c[(c[t>>2]|0)+16>>2]|0,c[o>>2]|0,c[u>>2]|0)|0;if(a[(c[l>>2]|0)+472>>0]|0)a[(c[(c[t>>2]|0)+16>>2]|0)+((c[u>>2]|0)-1)>>0]=a[(c[l>>2]|0)+472>>0]|0;c[c[t>>2]>>2]=c[m>>2];c[(c[t>>2]|0)+12>>2]=c[n>>2];c[(c[t>>2]|0)+8>>2]=c[(c[m>>2]|0)+4>>2];if((a[c[o>>2]>>0]|0)==0?(c[m>>2]|0)==((c[(c[l>>2]|0)+356>>2]|0)+152|0):0)c[(c[m>>2]|0)+4>>2]=0;else c[(c[m>>2]|0)+4>>2]=c[t>>2];c[(c[t>>2]|0)+4>>2]=c[c[p>>2]>>2];c[c[p>>2]>>2]=c[t>>2];if((c[n>>2]|0)!=0?(c[(c[l>>2]|0)+100>>2]|0)!=0:0)Tb[c[(c[l>>2]|0)+100>>2]&127](c[(c[l>>2]|0)+4>>2]|0,c[c[m>>2]>>2]|0,(c[(c[m>>2]|0)+4>>2]|0)!=0?c[o>>2]|0:0);c[k>>2]=0;w=c[k>>2]|0;i=j;return w|0}function GZ(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+80|0;l=k+56|0;m=k+52|0;n=k+48|0;o=k+68|0;p=k+44|0;q=k+40|0;r=k+36|0;s=k+32|0;t=k+28|0;u=k+24|0;v=k+64|0;w=k+20|0;x=k+16|0;y=k+12|0;z=k+8|0;A=k+61|0;B=k+60|0;C=k+4|0;D=k;c[m>>2]=b;c[n>>2]=e;a[o>>0]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=j;c[s>>2]=c[(c[m>>2]|0)+356>>2];a:while(1){c[u>>2]=Sb[c[(c[n>>2]|0)+16>>2]&127](c[n>>2]|0,c[p>>2]|0,c[q>>2]|0,t)|0;b:do switch(c[u>>2]|0){case -4:{E=3;break a;break}case 0:{E=4;break a;break}case -1:{E=7;break a;break}case 10:{c[x>>2]=Ob[c[(c[n>>2]|0)+44>>2]&127](c[n>>2]|0,c[p>>2]|0)|0;if((c[x>>2]|0)<0){E=11;break a}if((a[o>>0]|0)==0&(c[x>>2]|0)==32){if(!((c[(c[r>>2]|0)+12>>2]|0)-(c[(c[r>>2]|0)+16>>2]|0)|0))break b;if((a[(c[(c[r>>2]|0)+12>>2]|0)+-1>>0]|0)==32)break b}c[x>>2]=OZ(c[x>>2]|0,v)|0;if(!(c[x>>2]|0)){E=18;break a}c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[x>>2]|0))break b;if((c[(c[r>>2]|0)+12>>2]|0)==(c[(c[r>>2]|0)+8>>2]|0)?(jZ(c[r>>2]|0)|0)<<24>>24==0:0){E=26;break a}j=a[v+(c[w>>2]|0)>>0]|0;h=(c[r>>2]|0)+12|0;g=c[h>>2]|0;c[h>>2]=g+1;a[g>>0]=j;c[w>>2]=(c[w>>2]|0)+1}break}case 6:{if(!(hZ(c[r>>2]|0,c[n>>2]|0,c[p>>2]|0,c[t>>2]|0)|0)){E=28;break a}break}case -3:{c[t>>2]=(c[p>>2]|0)+(c[(c[n>>2]|0)+68>>2]|0);E=30;break}case 7:case 39:{E=30;break}case 9:{a[B>>0]=Hb[c[(c[n>>2]|0)+48>>2]&63](c[n>>2]|0,(c[p>>2]|0)+(c[(c[n>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[n>>2]|0)+68>>2]|0))|0)|0;if(a[B>>0]|0){if((c[(c[r>>2]|0)+12>>2]|0)==(c[(c[r>>2]|0)+8>>2]|0)?(jZ(c[r>>2]|0)|0)<<24>>24==0:0){E=41;break a}j=a[B>>0]|0;g=(c[r>>2]|0)+12|0;h=c[g>>2]|0;c[g>>2]=h+1;a[h>>0]=j;break b}c[y>>2]=aZ((c[m>>2]|0)+440|0,c[n>>2]|0,(c[p>>2]|0)+(c[(c[n>>2]|0)+68>>2]|0)|0,(c[t>>2]|0)+(0-(c[(c[n>>2]|0)+68>>2]|0))|0)|0;if(!(c[y>>2]|0)){E=43;break a}c[z>>2]=bZ(c[m>>2]|0,c[s>>2]|0,c[y>>2]|0,0)|0;c[(c[m>>2]|0)+440+12>>2]=c[(c[m>>2]|0)+440+16>>2];if((c[r>>2]|0)==((c[s>>2]|0)+80|0)){if(c[(c[m>>2]|0)+256+16>>2]|0){if(d[(c[s>>2]|0)+130>>0]|0)F=(c[(c[m>>2]|0)+300>>2]|0)!=0;else F=(a[(c[s>>2]|0)+129>>0]|0)!=0;G=((F^1)&1|0)!=0}else G=0;a[A>>0]=G&1}else{if(a[(c[s>>2]|0)+129>>0]|0)H=(d[(c[s>>2]|0)+130>>0]|0)!=0;else H=1;a[A>>0]=H&1}j=(c[z>>2]|0)!=0;if(a[A>>0]|0){if(!j){E=56;break a}if(!(a[(c[z>>2]|0)+34>>0]|0)){E=58;break a}}else if(!j)break b;if(a[(c[z>>2]|0)+32>>0]|0){E=61;break a}if(c[(c[z>>2]|0)+28>>2]|0){E=65;break a}if(!(c[(c[z>>2]|0)+4>>2]|0)){E=69;break a}c[D>>2]=(c[(c[z>>2]|0)+4>>2]|0)+(c[(c[z>>2]|0)+8>>2]|0);a[(c[z>>2]|0)+32>>0]=1;c[C>>2]=GZ(c[m>>2]|0,c[(c[m>>2]|0)+228>>2]|0,a[o>>0]|0,c[(c[z>>2]|0)+4>>2]|0,c[D>>2]|0,c[r>>2]|0)|0;a[(c[z>>2]|0)+32>>0]=0;if(c[C>>2]|0){E=73;break a}break}default:{E=74;break a}}while(0);do if((E|0)==30){E=0;if(!(a[o>>0]|0)){if(!((c[(c[r>>2]|0)+12>>2]|0)-(c[(c[r>>2]|0)+16>>2]|0)|0))break;if((a[(c[(c[r>>2]|0)+12>>2]|0)+-1>>0]|0)==32)break}if((c[(c[r>>2]|0)+12>>2]|0)==(c[(c[r>>2]|0)+8>>2]|0)?(jZ(c[r>>2]|0)|0)<<24>>24==0:0){E=36;break a}j=(c[r>>2]|0)+12|0;h=c[j>>2]|0;c[j>>2]=h+1;a[h>>0]=32}while(0);c[p>>2]=c[t>>2]}switch(E|0){case 3:{c[l>>2]=0;I=c[l>>2]|0;i=k;return I|0}case 4:{if((c[n>>2]|0)==(c[(c[m>>2]|0)+144>>2]|0))c[(c[m>>2]|0)+288>>2]=c[t>>2];c[l>>2]=4;I=c[l>>2]|0;i=k;return I|0}case 7:{if((c[n>>2]|0)==(c[(c[m>>2]|0)+144>>2]|0))c[(c[m>>2]|0)+288>>2]=c[p>>2];c[l>>2]=4;I=c[l>>2]|0;i=k;return I|0}case 11:{if((c[n>>2]|0)==(c[(c[m>>2]|0)+144>>2]|0))c[(c[m>>2]|0)+288>>2]=c[p>>2];c[l>>2]=14;I=c[l>>2]|0;i=k;return I|0}case 18:{if((c[n>>2]|0)==(c[(c[m>>2]|0)+144>>2]|0))c[(c[m>>2]|0)+288>>2]=c[p>>2];c[l>>2]=14;I=c[l>>2]|0;i=k;return I|0}case 26:{c[l>>2]=1;I=c[l>>2]|0;i=k;return I|0}case 28:{c[l>>2]=1;I=c[l>>2]|0;i=k;return I|0}case 36:{c[l>>2]=1;I=c[l>>2]|0;i=k;return I|0}case 41:{c[l>>2]=1;I=c[l>>2]|0;i=k;return I|0}case 43:{c[l>>2]=1;I=c[l>>2]|0;i=k;return I|0}case 56:{c[l>>2]=11;I=c[l>>2]|0;i=k;return I|0}case 58:{c[l>>2]=24;I=c[l>>2]|0;i=k;return I|0}case 61:{if((c[n>>2]|0)==(c[(c[m>>2]|0)+144>>2]|0))c[(c[m>>2]|0)+288>>2]=c[p>>2];c[l>>2]=12;I=c[l>>2]|0;i=k;return I|0}case 65:{if((c[n>>2]|0)==(c[(c[m>>2]|0)+144>>2]|0))c[(c[m>>2]|0)+288>>2]=c[p>>2];c[l>>2]=15;I=c[l>>2]|0;i=k;return I|0}case 69:{if((c[n>>2]|0)==(c[(c[m>>2]|0)+144>>2]|0))c[(c[m>>2]|0)+288>>2]=c[p>>2];c[l>>2]=16;I=c[l>>2]|0;i=k;return I|0}case 73:{c[l>>2]=c[C>>2];I=c[l>>2]|0;i=k;return I|0}case 74:{if((c[n>>2]|0)==(c[(c[m>>2]|0)+144>>2]|0))c[(c[m>>2]|0)+288>>2]=c[p>>2];c[l>>2]=23;I=c[l>>2]|0;i=k;return I|0}}return 0}function HZ(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[g>>2]=b;c[h>>2]=e;c[j>>2]=c[(c[g>>2]|0)+496>>2];while(1){k=c[j>>2]|0;if(!(a[c[h>>2]>>0]|0))break;g=c[h>>2]|0;c[h>>2]=g+1;c[j>>2]=k*1000003^d[g>>0]}i=f;return k|0}function IZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;while(1){if((a[c[g>>2]>>0]|0)!=(a[c[h>>2]>>0]|0)){j=6;break}if(!(a[c[g>>2]>>0]|0)){j=4;break}c[g>>2]=(c[g>>2]|0)+1;c[h>>2]=(c[h>>2]|0)+1}if((j|0)==4){a[f>>0]=1;k=a[f>>0]|0;i=e;return k|0}else if((j|0)==6){a[f>>0]=0;k=a[f>>0]|0;i=e;return k|0}return 0}function JZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+1056|0;f=e+1052|0;g=e+1048|0;h=e+1044|0;j=e+8|0;k=e+4|0;l=e;c[g>>2]=b;c[h>>2]=d;if(c[(c[g>>2]|0)+124>>2]|0){c[k>>2]=0;while(1){if((c[k>>2]|0)>=256)break;c[j+(c[k>>2]<<2)>>2]=-1;c[k>>2]=(c[k>>2]|0)+1}c[j+1028>>2]=0;c[j+1024>>2]=0;c[j+1032>>2]=0;do if(Hb[c[(c[g>>2]|0)+124>>2]&63](c[(c[g>>2]|0)+248>>2]|0,c[h>>2]|0,j)|0){k=c[(c[g>>2]|0)+12>>2]|0;d=PZ()|0;b=Fb[k&63](d)|0;c[(c[g>>2]|0)+240>>2]=b;if(c[(c[g>>2]|0)+240>>2]|0){c[l>>2]=Sb[((a[(c[g>>2]|0)+236>>0]&255|0)!=0?65:66)&127](c[(c[g>>2]|0)+240>>2]|0,j,c[j+1028>>2]|0,c[j+1024>>2]|0)|0;if(!(c[l>>2]|0))break;c[(c[g>>2]|0)+244>>2]=c[j+1024>>2];c[(c[g>>2]|0)+252>>2]=c[j+1032>>2];c[(c[g>>2]|0)+144>>2]=c[l>>2];c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}if(c[j+1032>>2]|0)Bb[c[j+1032>>2]&127](c[j+1024>>2]|0);c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}while(0);if(c[j+1032>>2]|0)Bb[c[j+1032>>2]&127](c[j+1024>>2]|0)}c[f>>2]=18;m=c[f>>2]|0;i=e;return m|0}function KZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=YY(c[h>>2]|0)|0;if(c[m>>2]|0){c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}else{c[(c[h>>2]|0)+280>>2]=60;c[g>>2]=ZY(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;n=c[g>>2]|0;i=f;return n|0}return 0}function LZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;c[g>>2]=Fb[c[c[f>>2]>>2]&63](188)|0;b=c[g>>2]|0;if(!(c[g>>2]|0)){c[e>>2]=b;h=c[e>>2]|0;i=d;return h|0}else{MZ(b+80|0,c[f>>2]|0);MZ((c[g>>2]|0)+104|0,c[f>>2]|0);NZ(c[g>>2]|0,c[f>>2]|0);NZ((c[g>>2]|0)+20|0,c[f>>2]|0);NZ((c[g>>2]|0)+40|0,c[f>>2]|0);NZ((c[g>>2]|0)+60|0,c[f>>2]|0);a[(c[g>>2]|0)+131>>0]=0;NZ((c[g>>2]|0)+132|0,c[f>>2]|0);c[(c[g>>2]|0)+152>>2]=0;c[(c[g>>2]|0)+152+4>>2]=0;a[(c[g>>2]|0)+160>>0]=0;c[(c[g>>2]|0)+184>>2]=0;c[(c[g>>2]|0)+164>>2]=0;c[(c[g>>2]|0)+180>>2]=0;c[(c[g>>2]|0)+172>>2]=0;c[(c[g>>2]|0)+176>>2]=0;c[(c[g>>2]|0)+168>>2]=0;a[(c[g>>2]|0)+128>>0]=1;a[(c[g>>2]|0)+129>>0]=0;a[(c[g>>2]|0)+130>>0]=0;c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}return 0}function MZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[e>>2]>>2]=0;c[(c[e>>2]|0)+4>>2]=0;c[(c[e>>2]|0)+16>>2]=0;c[(c[e>>2]|0)+12>>2]=0;c[(c[e>>2]|0)+8>>2]=0;c[(c[e>>2]|0)+20>>2]=c[f>>2];i=d;return}function NZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;a[(c[f>>2]|0)+4>>0]=0;c[(c[f>>2]|0)+8>>2]=0;c[(c[f>>2]|0)+12>>2]=0;c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+16>>2]=c[g>>2];i=e;return}function OZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)<0){c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}d=c[g>>2]|0;if((c[g>>2]|0)<128){a[c[h>>2]>>0]=d;c[f>>2]=1;j=c[f>>2]|0;i=e;return j|0}b=c[g>>2]|0;if((d|0)<2048){a[c[h>>2]>>0]=b>>6|192;a[(c[h>>2]|0)+1>>0]=c[g>>2]&63|128;c[f>>2]=2;j=c[f>>2]|0;i=e;return j|0}d=c[g>>2]|0;if((b|0)<65536){a[c[h>>2]>>0]=d>>12|224;a[(c[h>>2]|0)+1>>0]=c[g>>2]>>6&63|128;a[(c[h>>2]|0)+2>>0]=c[g>>2]&63|128;c[f>>2]=3;j=c[f>>2]|0;i=e;return j|0}if((d|0)<1114112){a[c[h>>2]>>0]=c[g>>2]>>18|240;a[(c[h>>2]|0)+1>>0]=c[g>>2]>>12&63|128;a[(c[h>>2]|0)+2>>0]=c[g>>2]>>6&63|128;a[(c[h>>2]|0)+3>>0]=c[g>>2]&63|128;c[f>>2]=4;j=c[f>>2]|0;i=e;return j|0}else{c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}return 0}function PZ(){return 1912}function QZ(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+32|0;k=j+28|0;l=j+24|0;m=j+20|0;n=j+16|0;o=j+12|0;p=j+8|0;q=j+4|0;r=j;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;c[q>>2]=c[l>>2];c[p>>2]=0;while(1){if((c[p>>2]|0)>=368)break;a[(c[l>>2]|0)+(c[p>>2]|0)>>0]=a[92912+(c[p>>2]|0)>>0]|0;c[p>>2]=(c[p>>2]|0)+1}c[p>>2]=0;while(1){if((c[p>>2]|0)>=128)break;if(((d[92988+(c[p>>2]|0)>>0]|0|0)!=28?(d[92988+(c[p>>2]|0)>>0]|0|0)!=0:0)?(c[(c[m>>2]|0)+(c[p>>2]<<2)>>2]|0)!=(c[p>>2]|0):0){s=9;break}c[p>>2]=(c[p>>2]|0)+1}if((s|0)==9){c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}c[p>>2]=0;a:while(1){if((c[p>>2]|0)>=256){s=36;break}c[r>>2]=c[(c[m>>2]|0)+(c[p>>2]<<2)>>2];do if((c[r>>2]|0)==-1){a[(c[q>>2]|0)+76+(c[p>>2]|0)>>0]=1;b[(c[q>>2]|0)+376+(c[p>>2]<<1)>>1]=-1;a[(c[q>>2]|0)+888+(c[p>>2]<<2)>>0]=1;a[(c[q>>2]|0)+888+(c[p>>2]<<2)+1>>0]=0}else{l=c[r>>2]|0;if((c[r>>2]|0)<0){if((l|0)<-4){s=17;break a}a[(c[q>>2]|0)+76+(c[p>>2]|0)>>0]=5-((c[r>>2]|0)+2);a[(c[q>>2]|0)+888+(c[p>>2]<<2)>>0]=0;b[(c[q>>2]|0)+376+(c[p>>2]<<1)>>1]=0;break}h=c[r>>2]|0;if((l|0)<128){if(((d[92988+h>>0]|0|0)!=28?(d[92988+(c[r>>2]|0)>>0]|0|0)!=0:0)?(c[r>>2]|0)!=(c[p>>2]|0):0){s=23;break a}a[(c[q>>2]|0)+76+(c[p>>2]|0)>>0]=a[92988+(c[r>>2]|0)>>0]|0;a[(c[q>>2]|0)+888+(c[p>>2]<<2)>>0]=1;a[(c[q>>2]|0)+888+(c[p>>2]<<2)+1>>0]=c[r>>2];b[(c[q>>2]|0)+376+(c[p>>2]<<1)>>1]=(c[r>>2]|0)==0?65535:c[r>>2]|0;break}if((YZ(h)|0)<0){a[(c[q>>2]|0)+76+(c[p>>2]|0)>>0]=0;b[(c[q>>2]|0)+376+(c[p>>2]<<1)>>1]=-1;a[(c[q>>2]|0)+888+(c[p>>2]<<2)>>0]=1;a[(c[q>>2]|0)+888+(c[p>>2]<<2)+1>>0]=0;break}if((c[r>>2]|0)>65535){s=28;break a}do if(!(c[93280+(((d[181578+(c[r>>2]>>8)>>0]|0)<<3)+((c[r>>2]&255)>>5)<<2)>>2]&1<<(c[r>>2]&31))){h=(c[q>>2]|0)+76+(c[p>>2]|0)|0;if(c[93280+(((d[181834+(c[r>>2]>>8)>>0]|0)<<3)+((c[r>>2]&255)>>5)<<2)>>2]&1<<(c[r>>2]&31)){a[h>>0]=26;break}else{a[h>>0]=28;break}}else a[(c[q>>2]|0)+76+(c[p>>2]|0)>>0]=22;while(0);h=(OZ(c[r>>2]|0,(c[q>>2]|0)+888+(c[p>>2]<<2)+1|0)|0)&255;a[(c[q>>2]|0)+888+(c[p>>2]<<2)>>0]=h;b[(c[q>>2]|0)+376+(c[p>>2]<<1)>>1]=c[r>>2]}while(0);c[p>>2]=(c[p>>2]|0)+1}if((s|0)==17){c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}else if((s|0)==23){c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}else if((s|0)==28){c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}else if((s|0)==36){c[(c[q>>2]|0)+372>>2]=c[o>>2];c[(c[q>>2]|0)+368>>2]=c[n>>2];if(c[n>>2]|0){c[(c[q>>2]|0)+332>>2]=108;c[(c[q>>2]|0)+336>>2]=108;c[(c[q>>2]|0)+340>>2]=108;c[(c[q>>2]|0)+344>>2]=109;c[(c[q>>2]|0)+348>>2]=109;c[(c[q>>2]|0)+352>>2]=109;c[(c[q>>2]|0)+356>>2]=110;c[(c[q>>2]|0)+360>>2]=110;c[(c[q>>2]|0)+364>>2]=110}c[(c[q>>2]|0)+60>>2]=18;c[(c[q>>2]|0)+64>>2]=19;c[k>>2]=c[q>>2];t=c[k>>2]|0;i=j;return t|0}return 0}function RZ(){return 94560}function SZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c_(c[k>>2]|0)|0;if((c[l>>2]|0)==-1){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}else{a[(c[h>>2]|0)+73>>0]=c[l>>2];c[c[h>>2]>>2]=67;c[(c[h>>2]|0)+4>>2]=68;c[(c[h>>2]|0)+52>>2]=29;c[(c[h>>2]|0)+76>>2]=c[j>>2];c[c[j>>2]>>2]=c[h>>2];c[g>>2]=1;m=c[g>>2]|0;i=f;return m|0}return 0}function TZ(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;i=i+48|0;n=m+36|0;o=m+32|0;p=m+28|0;q=m+24|0;r=m+20|0;s=m+16|0;t=m+12|0;u=m+8|0;v=m+4|0;w=m;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;l=h_(43,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0)|0;i=m;return l|0}function UZ(){return 94928}function VZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c_(c[k>>2]|0)|0;if((c[l>>2]|0)==-1){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}else{a[(c[h>>2]|0)+73>>0]=c[l>>2];c[c[h>>2]>>2]=69;c[(c[h>>2]|0)+4>>2]=70;c[(c[h>>2]|0)+52>>2]=29;c[(c[h>>2]|0)+76>>2]=c[j>>2];c[c[j>>2]>>2]=c[h>>2];c[g>>2]=1;m=c[g>>2]|0;i=f;return m|0}return 0}function WZ(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;i=i+48|0;n=m+36|0;o=m+32|0;p=m+28|0;q=m+24|0;r=m+20|0;s=m+16|0;t=m+12|0;u=m+8|0;v=m+4|0;w=m;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;l=h_(44,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0)|0;i=m;return l|0}function XZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=QZ(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;if(!(c[m>>2]|0)){n=c[m>>2]|0;i=g;return n|0}a[(c[m>>2]|0)+76+58>>0]=23;n=c[m>>2]|0;i=g;return n|0}function YZ(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;c[f>>2]=a;switch(c[f>>2]>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{c[e>>2]=-1;break}case 0:{if(!(d[92988+(c[f>>2]|0)>>0]|0))c[e>>2]=-1;else g=7;break}case 255:{if((c[f>>2]|0)==65534|(c[f>>2]|0)==65535)c[e>>2]=-1;else g=7;break}default:g=7}if((g|0)==7)c[e>>2]=c[f>>2];i=b;return c[e>>2]|0}function ZZ(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];c[k>>2]=Ob[c[(c[j>>2]|0)+368>>2]&127](c[(c[j>>2]|0)+372>>2]|0,c[h>>2]|0)|0;if(c[k>>2]&-65536){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=c[93280+(((d[181834+(c[k>>2]>>8)>>0]|0)<<3)+((c[k>>2]&255)>>5)<<2)>>2]&1<<(c[k>>2]&31);l=c[f>>2]|0;i=e;return l|0}return 0}function _Z(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[g>>2];c[k>>2]=Ob[c[(c[j>>2]|0)+368>>2]&127](c[(c[j>>2]|0)+372>>2]|0,c[h>>2]|0)|0;if(c[k>>2]&-65536){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=c[93280+(((d[181578+(c[k>>2]>>8)>>0]|0)<<3)+((c[k>>2]&255)>>5)<<2)>>2]&1<<(c[k>>2]&31);l=c[f>>2]|0;i=e;return l|0}return 0}function $Z(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];c[h>>2]=Ob[c[(c[g>>2]|0)+368>>2]&127](c[(c[g>>2]|0)+372>>2]|0,c[f>>2]|0)|0;if(c[h>>2]&-65536){j=1;k=j&1;i=d;return k|0}j=(YZ(c[h>>2]|0)|0)<0;k=j&1;i=d;return k|0}function a_(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+36|0;r=j+8|0;s=j+4|0;t=j;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;c[p>>2]=c[k>>2];a:while(1){if((c[c[l>>2]>>2]|0)==(c[m>>2]|0)){u=9;break}c[r>>2]=(c[p>>2]|0)+888+(d[c[c[l>>2]>>2]>>0]<<2);h=c[r>>2]|0;c[r>>2]=h+1;c[s>>2]=a[h>>0];if(!(c[s>>2]|0)){c[t>>2]=Ob[c[(c[p>>2]|0)+368>>2]&127](c[(c[p>>2]|0)+372>>2]|0,c[c[l>>2]>>2]|0)|0;c[s>>2]=OZ(c[t>>2]|0,q)|0;if((c[s>>2]|0)>((c[o>>2]|0)-(c[c[n>>2]>>2]|0)|0)){u=9;break}c[r>>2]=q;h=c[l>>2]|0;c[h>>2]=(c[h>>2]|0)+((d[(c[k>>2]|0)+76+(d[c[c[l>>2]>>2]>>0]|0)>>0]|0)-3)}else{if((c[s>>2]|0)>((c[o>>2]|0)-(c[c[n>>2]>>2]|0)|0)){u=9;break}h=c[l>>2]|0;c[h>>2]=(c[h>>2]|0)+1}while(1){h=c[r>>2]|0;c[r>>2]=h+1;g=a[h>>0]|0;h=c[n>>2]|0;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=g;g=(c[s>>2]|0)+-1|0;c[s>>2]=g;if(!g)continue a}}if((u|0)==9){i=j;return}}function b_(a,f,g,h,j){a=a|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k+20|0;m=k+16|0;n=k+12|0;o=k+8|0;p=k+4|0;q=k;r=k+24|0;c[l>>2]=a;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;c[p>>2]=j;c[q>>2]=c[l>>2];while(1){if((c[c[m>>2]>>2]|0)==(c[n>>2]|0)){s=8;break}if((c[c[o>>2]>>2]|0)==(c[p>>2]|0)){s=8;break}b[r>>1]=b[(c[q>>2]|0)+376+((d[c[c[m>>2]>>2]>>0]|0)<<1)>>1]|0;if(!(e[r>>1]|0)){b[r>>1]=Ob[c[(c[q>>2]|0)+368>>2]&127](c[(c[q>>2]|0)+372>>2]|0,c[c[m>>2]>>2]|0)|0;j=c[m>>2]|0;c[j>>2]=(c[j>>2]|0)+((d[(c[l>>2]|0)+76+(d[c[c[m>>2]>>2]>>0]|0)>>0]|0)-3)}else{j=c[m>>2]|0;c[j>>2]=(c[j>>2]|0)+1}j=b[r>>1]|0;h=c[o>>2]|0;g=c[h>>2]|0;c[h>>2]=g+2;b[g>>1]=j}if((s|0)==8){i=k;return}}function c_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;do if(c[e>>2]|0){c[f>>2]=0;while(1){if((c[f>>2]|0)>=6){g=8;break}a=(l_(c[e>>2]|0,c[98664+(c[f>>2]<<2)>>2]|0)|0)!=0;h=c[f>>2]|0;if(a){g=6;break}c[f>>2]=h+1}if((g|0)==6){c[d>>2]=h;break}else if((g|0)==8){c[d>>2]=-1;break}}else c[d>>2]=6;while(0);i=b;return c[d>>2]|0}function d_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=j0(97164,c[g>>2]|0,0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;i=f;return e|0}function e_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=j0(97164,c[g>>2]|0,1,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;i=f;return e|0}function f_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[f+12>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;I$(97560,c[g>>2]|0,c[h>>2]|0,c[j>>2]|0);i=f;return}function g_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+160|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+24|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=l;Ab[c[(c[h>>2]|0)+60>>2]&31](c[h>>2]|0,j,c[k>>2]|0,m,(c[m>>2]|0)+128+-1|0);if((c[j>>2]|0)!=(c[k>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}a[c[m>>2]>>0]=0;if((l_(l,182090)|0)!=0?(c[(c[h>>2]|0)+68>>2]|0)==2:0){c[g>>2]=c[h>>2];o=c[g>>2]|0;i=f;return o|0}c[n>>2]=c_(l)|0;if((c[n>>2]|0)==-1){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}else{c[g>>2]=c[97164+(c[n>>2]<<2)>>2];o=c[g>>2]|0;i=f;return o|0}return 0}function h_(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;n=i;i=i+64|0;o=n+60|0;p=n+56|0;q=n+52|0;r=n+48|0;s=n+44|0;t=n+40|0;u=n+36|0;v=n+32|0;w=n+28|0;x=n+24|0;y=n+20|0;z=n+16|0;A=n+12|0;B=n+8|0;C=n+4|0;D=n;c[p>>2]=a;c[q>>2]=b;c[r>>2]=d;c[s>>2]=e;c[t>>2]=f;c[u>>2]=g;c[v>>2]=h;c[w>>2]=j;c[x>>2]=k;c[y>>2]=l;c[z>>2]=m;c[A>>2]=0;c[B>>2]=0;c[C>>2]=0;c[s>>2]=(c[s>>2]|0)+((c[(c[r>>2]|0)+68>>2]|0)*5|0);c[t>>2]=(c[t>>2]|0)+(0-(c[(c[r>>2]|0)+68>>2]<<1));m=(k0(c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,B,C,A,s)|0)!=0;if(!(m&(c[B>>2]|0)!=0)){c[c[u>>2]>>2]=c[s>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}if(Sb[c[(c[r>>2]|0)+28>>2]&127](c[r>>2]|0,c[B>>2]|0,c[C>>2]|0,182115)|0){if(c[v>>2]|0)c[c[v>>2]>>2]=c[A>>2];if(c[w>>2]|0)c[c[w>>2]>>2]=c[s>>2];if(!(k0(c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,B,C,A,s)|0)){c[c[u>>2]>>2]=c[s>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}if(!(c[B>>2]|0))if(c[q>>2]|0){c[c[u>>2]>>2]=c[s>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}else{c[o>>2]=1;E=c[o>>2]|0;i=n;return E|0}}else if(!(c[q>>2]|0)){c[c[u>>2]>>2]=c[B>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}if(Sb[c[(c[r>>2]|0)+28>>2]&127](c[r>>2]|0,c[B>>2]|0,c[C>>2]|0,182123)|0){c[D>>2]=l0(c[r>>2]|0,c[A>>2]|0,c[t>>2]|0)|0;if(!(97<=(c[D>>2]|0)&(c[D>>2]|0)<=122)?!(65<=(c[D>>2]|0)&(c[D>>2]|0)<=90):0){c[c[u>>2]>>2]=c[A>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}if(c[x>>2]|0)c[c[x>>2]>>2]=c[A>>2];if(c[y>>2]|0){x=Hb[c[p>>2]&63](c[r>>2]|0,c[A>>2]|0,(c[s>>2]|0)+(0-(c[(c[r>>2]|0)+68>>2]|0))|0)|0;c[c[y>>2]>>2]=x}if(!(k0(c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,B,C,A,s)|0)){c[c[u>>2]>>2]=c[s>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}if(!(c[B>>2]|0)){c[o>>2]=1;E=c[o>>2]|0;i=n;return E|0}}x=(Sb[c[(c[r>>2]|0)+28>>2]&127](c[r>>2]|0,c[B>>2]|0,c[C>>2]|0,182132)|0)==0;if(x|(c[q>>2]|0)!=0){c[c[u>>2]>>2]=c[B>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}do if(Sb[c[(c[r>>2]|0)+28>>2]&127](c[r>>2]|0,c[A>>2]|0,(c[s>>2]|0)+(0-(c[(c[r>>2]|0)+68>>2]|0))|0,145589)|0){if(c[z>>2]|0)c[c[z>>2]>>2]=1}else if(Sb[c[(c[r>>2]|0)+28>>2]&127](c[r>>2]|0,c[A>>2]|0,(c[s>>2]|0)+(0-(c[(c[r>>2]|0)+68>>2]|0))|0,145581)|0){if(!(c[z>>2]|0))break;c[c[z>>2]>>2]=0;break}else{c[c[u>>2]>>2]=c[A>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}while(0);while(1){if(!(m0(l0(c[r>>2]|0,c[s>>2]|0,c[t>>2]|0)|0)|0))break;c[s>>2]=(c[s>>2]|0)+(c[(c[r>>2]|0)+68>>2]|0)}if((c[s>>2]|0)!=(c[t>>2]|0)){c[c[u>>2]>>2]=c[s>>2];c[o>>2]=0;E=c[o>>2]|0;i=n;return E|0}else{c[o>>2]=1;E=c[o>>2]|0;i=n;return E|0}return 0}function i_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=j0(95296,c[g>>2]|0,0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;i=f;return e|0}function j_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;e=j0(95296,c[g>>2]|0,1,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;i=f;return e|0}function k_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+160|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+24|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=l;Ab[c[(c[h>>2]|0)+60>>2]&31](c[h>>2]|0,j,c[k>>2]|0,m,(c[m>>2]|0)+128+-1|0);if((c[j>>2]|0)!=(c[k>>2]|0)){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}a[c[m>>2]>>0]=0;if((l_(l,182090)|0)!=0?(c[(c[h>>2]|0)+68>>2]|0)==2:0){c[g>>2]=c[h>>2];o=c[g>>2]|0;i=f;return o|0}c[n>>2]=c_(l)|0;if((c[n>>2]|0)==-1){c[g>>2]=0;o=c[g>>2]|0;i=f;return o|0}else{c[g>>2]=c[95296+(c[n>>2]<<2)>>2];o=c[g>>2]|0;i=f;return o|0}return 0}function l_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=e+13|0;k=e+12|0;c[g>>2]=b;c[h>>2]=d;while(1){d=c[g>>2]|0;c[g>>2]=d+1;a[j>>0]=a[d>>0]|0;d=c[h>>2]|0;c[h>>2]=d+1;a[k>>0]=a[d>>0]|0;if(97<=(a[j>>0]|0)?(a[j>>0]|0)<=122:0)a[j>>0]=(a[j>>0]|0)+-32;if(97<=(a[k>>0]|0)?(a[k>>0]|0)<=122:0)a[k>>0]=(a[k>>0]|0)+-32;if((a[j>>0]|0)!=(a[k>>0]|0)){l=9;break}if(!(a[j>>0]|0)){l=11;break}}if((l|0)==9){c[f>>2]=0;m=c[f>>2]|0;i=e;return m|0}else if((l|0)==11){c[f>>2]=1;m=c[f>>2]|0;i=e;return m|0}return 0}function m_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){c[p>>2]=(c[m>>2]|0)-(c[l>>2]|0);do if(c[p>>2]&1){c[p>>2]=c[p>>2]&-2;if(!(c[p>>2]|0)){c[j>>2]=-1;break a}else{c[m>>2]=(c[l>>2]|0)+(c[p>>2]|0);break}}while(0);g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;b:do switch(q|0){case 12:{c[j>>2]=P_(12,c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 13:{c[j>>2]=P_(13,c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 2:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))r=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else r=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(r|0){case 16:{c[j>>2]=Q_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 15:{c[j>>2]=L_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 7:case 6:case 5:case 29:case 24:case 22:{c[c[n>>2]>>2]=(c[l>>2]|0)+-2;c[j>>2]=29;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 9:{if(((c[l>>2]|0)+2|0)==(c[m>>2]|0)){c[c[n>>2]>>2]=c[m>>2];c[j>>2]=-15;break a}else s=25;break}case 10:case 21:{s=25;break}case 30:{c[j>>2]=F_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 35:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=38;break a;break}case 20:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=25;break a;break}case 4:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-26;break a}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==93:0){if(((c[l>>2]|0)+2|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}if((a[(c[l>>2]|0)+2+1>>0]|0)==0?(a[(c[l>>2]|0)+2>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+4;c[j>>2]=34;break a}}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=26;break a;break}case 31:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=23;break a;break}case 32:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-24;break a}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))t=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else t=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(t|0){case 33:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=36;break a;break}case 15:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=35;break a;break}case 34:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=37;break a;break}case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=24;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 36:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=21;break a;break}case 11:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=17;break a;break}case 19:{c[j>>2]=R_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:{c[o>>2]=18;c[l>>2]=(c[l>>2]|0)+2;s=77;break}case 23:case 27:case 26:case 25:{c[o>>2]=19;c[l>>2]=(c[l>>2]|0)+2;s=77;break}case 29:{g=c[l>>2]|0;if(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31)){c[l>>2]=g+2;c[o>>2]=18;s=77;break b}if(c[93280+((d[181834+(d[g+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31)){c[l>>2]=(c[l>>2]|0)+2;c[o>>2]=19;s=77}else s=76;break}default:s=76}while(0);if((s|0)==25){c:while(1){s=0;c[l>>2]=(c[l>>2]|0)+2;u=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){s=32;break}g=c[l>>2]|0;if(!(a[u+1>>0]|0))v=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else v=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(v|0){case 10:case 21:{s=25;continue c;break}case 9:break;default:{s=31;break c}}if(((c[l>>2]|0)+2|0)!=(c[m>>2]|0))s=25;else{s=31;break}}if((s|0)==31){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=15;break}else if((s|0)==32){c[c[n>>2]>>2]=u;c[j>>2]=15;break}}else if((s|0)==76){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((s|0)==77){d:while(1){s=0;if((c[l>>2]|0)==(c[m>>2]|0)){s=126;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))w=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else w=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(w|0){case 5:{s=85;break d;break}case 6:{s=88;break d;break}case 7:{s=91;break d;break}case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{s=94;break d;break}case 34:{s=116;break d;break}case 33:{s=119;break d;break}case 15:{s=122;break d;break}case 29:{if(!(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){s=83;break d}break}case 27:case 26:case 25:case 24:case 22:break;case 23:{c[l>>2]=(c[l>>2]|0)+2;switch(c[o>>2]|0){case 18:break;case 41:{c[o>>2]=19;s=77;continue d;break}default:{s=77;continue d}}if((c[l>>2]|0)==(c[m>>2]|0)){s=97;break d}c[o>>2]=41;g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))x=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else x=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(x|0){case 5:{s=105;break d;break}case 6:{s=108;break d;break}case 7:{s=111;break d;break}case 29:{if(!(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){s=103;break d}break}case 27:case 26:case 25:case 24:case 22:break;default:{c[o>>2]=19;s=77;continue d}}c[l>>2]=(c[l>>2]|0)+2;s=77;continue d;break}default:{s=125;break d}}c[l>>2]=(c[l>>2]|0)+2;s=77}switch(s|0){case 83:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 85:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 88:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 91:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 94:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=c[o>>2];break a;break}case 97:{c[j>>2]=-1;break a;break}case 103:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 105:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 108:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 111:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 116:{g=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=g;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=g+2;c[j>>2]=32;break a}break}case 119:{g=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=g;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=g+2;c[j>>2]=31;break a}break}case 122:{g=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=g;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=g+2;c[j>>2]=30;break a}break}case 125:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 126:{c[j>>2]=0-(c[o>>2]|0);break a;break}}}}else c[j>>2]=-4;while(0);i=h;return c[j>>2]|0}function n_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-4;p=c[j>>2]|0;i=h;return p|0}c[o>>2]=(c[m>>2]|0)-(c[l>>2]|0);do if(c[o>>2]&1){c[o>>2]=c[o>>2]&-2;if(c[o>>2]|0){c[m>>2]=(c[l>>2]|0)+(c[o>>2]|0);break}c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}while(0);o=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[o>>0]|0)>>0]|0;else q=D_(a[o+1>>0]|0,a[c[l>>2]>>0]|0)|0;a:do switch(q|0){case 2:{c[j>>2]=I_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;p=c[j>>2]|0;i=h;return p|0}case 3:{c[j>>2]=E_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;p=c[j>>2]|0;i=h;return p|0}case 9:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-3;p=c[j>>2]|0;i=h;return p|0}o=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))r=d[(c[k>>2]|0)+76+(d[o>>0]|0)>>0]|0;else r=D_(a[o+1>>0]|0,a[c[l>>2]>>0]|0)|0;if((r|0)==10)c[l>>2]=(c[l>>2]|0)+2;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;p=c[j>>2]|0;i=h;return p|0}case 10:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=7;p=c[j>>2]|0;i=h;return p|0}case 4:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-5;p=c[j>>2]|0;i=h;return p|0}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==93:0){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-5;p=c[j>>2]|0;i=h;return p|0}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==62:0){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}c[l>>2]=(c[l>>2]|0)+-2}break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=2){c[l>>2]=(c[l>>2]|0)+2;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=3){c[l>>2]=(c[l>>2]|0)+3;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=4){c[l>>2]=(c[l>>2]|0)+4;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 8:case 1:case 0:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}default:c[l>>2]=(c[l>>2]|0)+2}while(0);b:while(1){s=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){t=68;break}r=c[l>>2]|0;if(!(a[s+1>>0]|0))u=d[(c[k>>2]|0)+76+(d[r>>0]|0)>>0]|0;else u=D_(a[r+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(u|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{t=66;break b;break}case 5:{v=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=49;break b}c[l>>2]=v+2;continue b;break}case 6:{w=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=52;break b}c[l>>2]=w+3;continue b;break}case 7:{x=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=55;break b}c[l>>2]=x+4;continue b;break}case 4:{if(((c[l>>2]|0)+2|0)==(c[m>>2]|0)){t=66;break b}if((a[(c[l>>2]|0)+2+1>>0]|0)==0?(a[(c[l>>2]|0)+2>>0]|0)==93:0){if(((c[l>>2]|0)+4|0)==(c[m>>2]|0)){t=66;break b}if((a[(c[l>>2]|0)+4+1>>0]|0)==0?(a[(c[l>>2]|0)+4>>0]|0)==62:0){t=65;break b}c[l>>2]=(c[l>>2]|0)+2;continue b}c[l>>2]=(c[l>>2]|0)+2;continue b;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue b}}}if((t|0)==49){c[c[n>>2]>>2]=v;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==52){c[c[n>>2]>>2]=w;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==55){c[c[n>>2]>>2]=x;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==65){c[c[n>>2]>>2]=(c[l>>2]|0)+4;c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==66){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==68){c[c[n>>2]>>2]=s;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}return 0}function o_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-4;p=c[j>>2]|0;i=h;return p|0}c[o>>2]=(c[m>>2]|0)-(c[l>>2]|0);do if(c[o>>2]&1){c[o>>2]=c[o>>2]&-2;if(c[o>>2]|0){c[m>>2]=(c[l>>2]|0)+(c[o>>2]|0);break}c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}while(0);o=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[o>>0]|0)>>0]|0;else q=D_(a[o+1>>0]|0,a[c[l>>2]>>0]|0)|0;a:do switch(q|0){case 4:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==93:0){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=40;p=c[j>>2]|0;i=h;return p|0}c[l>>2]=(c[l>>2]|0)+-2}break}case 9:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}o=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))r=d[(c[k>>2]|0)+76+(d[o>>0]|0)>>0]|0;else r=D_(a[o+1>>0]|0,a[c[l>>2]>>0]|0)|0;if((r|0)==10)c[l>>2]=(c[l>>2]|0)+2;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;p=c[j>>2]|0;i=h;return p|0}case 10:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=7;p=c[j>>2]|0;i=h;return p|0}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=2){c[l>>2]=(c[l>>2]|0)+2;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=3){c[l>>2]=(c[l>>2]|0)+3;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=4){c[l>>2]=(c[l>>2]|0)+4;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 8:case 1:case 0:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}default:c[l>>2]=(c[l>>2]|0)+2}while(0);b:while(1){s=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){t=57;break}r=c[l>>2]|0;if(!(a[s+1>>0]|0))u=d[(c[k>>2]|0)+76+(d[r>>0]|0)>>0]|0;else u=D_(a[r+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(u|0){case 4:case 10:case 9:case 8:case 1:case 0:{t=55;break b;break}case 5:{v=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=47;break b}c[l>>2]=v+2;continue b;break}case 6:{w=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=50;break b}c[l>>2]=w+3;continue b;break}case 7:{x=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=53;break b}c[l>>2]=x+4;continue b;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue b}}}if((t|0)==47){c[c[n>>2]>>2]=v;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==50){c[c[n>>2]>>2]=w;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==53){c[c[n>>2]>>2]=x;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==55){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==57){c[c[n>>2]>>2]=s;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}return 0}function p_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=0;c[p>>2]=(c[m>>2]|0)-(c[l>>2]|0);if(c[p>>2]&1){c[p>>2]=c[p>>2]&-2;c[m>>2]=(c[l>>2]|0)+(c[p>>2]|0)}a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){q=39;break}p=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))r=d[(c[k>>2]|0)+76+(d[p>>0]|0)>>0]|0;else r=D_(a[p+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(r|0){case 8:case 1:case 0:{q=17;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){q=9;break a}c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){q=12;break a}c[l>>2]=(c[l>>2]|0)+3;continue a;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){q=15;break a}c[l>>2]=(c[l>>2]|0)+4;continue a;break}case 2:{p=(c[l>>2]|0)+2|0;c[l>>2]=p;if((p|0)==(c[m>>2]|0)){q=19;break a}if(a[(c[l>>2]|0)+1>>0]|0)continue a;if((a[c[l>>2]>>0]|0)!=33)continue a;p=(c[l>>2]|0)+2|0;c[l>>2]=p;if((p|0)==(c[m>>2]|0)){q=23;break a}if(a[(c[l>>2]|0)+1>>0]|0)continue a;if((a[c[l>>2]>>0]|0)!=91)continue a;c[o>>2]=(c[o>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 4:{p=(c[l>>2]|0)+2|0;c[l>>2]=p;if((p|0)==(c[m>>2]|0)){q=28;break a}if(a[(c[l>>2]|0)+1>>0]|0)continue a;if((a[c[l>>2]>>0]|0)!=93)continue a;p=(c[l>>2]|0)+2|0;c[l>>2]=p;if((p|0)==(c[m>>2]|0)){q=32;break a}if(a[(c[l>>2]|0)+1>>0]|0)continue a;if((a[c[l>>2]>>0]|0)!=62)continue a;c[l>>2]=(c[l>>2]|0)+2;if(!(c[o>>2]|0)){q=36;break a}c[o>>2]=(c[o>>2]|0)+-1;continue a;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue a}}}switch(q|0){case 9:{c[j>>2]=-2;s=c[j>>2]|0;i=h;return s|0}case 12:{c[j>>2]=-2;s=c[j>>2]|0;i=h;return s|0}case 15:{c[j>>2]=-2;s=c[j>>2]|0;i=h;return s|0}case 17:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}case 19:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}case 23:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}case 28:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}case 32:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}case 36:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=42;s=c[j>>2]|0;i=h;return s|0}case 39:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}}return 0}function q_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;do if((c[l>>2]|0)!=(c[m>>2]|0)){c[o>>2]=c[l>>2];a:while(1){p=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){q=33;break}g=c[l>>2]|0;if(!(a[p+1>>0]|0))r=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else r=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(r|0){case 3:{q=12;break a;break}case 2:{q=15;break a;break}case 10:{q=16;break a;break}case 9:{q=19;break a;break}case 21:{q=29;break a;break}case 5:{c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 6:{c[l>>2]=(c[l>>2]|0)+3;continue a;break}case 7:{c[l>>2]=(c[l>>2]|0)+4;continue a;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue a}}}if((q|0)==12)if((c[l>>2]|0)==(c[o>>2]|0)){c[j>>2]=E_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;break}else if((q|0)==15){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((q|0)==16){g=c[l>>2]|0;if((c[l>>2]|0)==(c[o>>2]|0)){c[c[n>>2]>>2]=g+2;c[j>>2]=7;break}else{c[c[n>>2]>>2]=g;c[j>>2]=6;break}}else if((q|0)==19){g=c[l>>2]|0;if((c[l>>2]|0)!=(c[o>>2]|0)){c[c[n>>2]>>2]=g;c[j>>2]=6;break}c[l>>2]=g+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-3;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))s=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else s=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;if((s|0)==10)c[l>>2]=(c[l>>2]|0)+2;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;break}else if((q|0)==29){g=c[l>>2]|0;if((c[l>>2]|0)==(c[o>>2]|0)){c[c[n>>2]>>2]=g+2;c[j>>2]=39;break}else{c[c[n>>2]>>2]=g;c[j>>2]=6;break}}else if((q|0)==33){c[c[n>>2]>>2]=p;c[j>>2]=6;break}}else c[j>>2]=-4;while(0);i=h;return c[j>>2]|0}function r_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-4;q=c[j>>2]|0;i=h;return q|0}c[o>>2]=c[l>>2];a:while(1){r=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){s=32;break}g=c[l>>2]|0;if(!(a[r+1>>0]|0))t=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else t=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(t|0){case 3:{s=12;break a;break}case 30:{s=15;break a;break}case 10:{s=18;break a;break}case 9:{s=21;break a;break}case 5:{c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 6:{c[l>>2]=(c[l>>2]|0)+3;continue a;break}case 7:{c[l>>2]=(c[l>>2]|0)+4;continue a;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue a}}}if((s|0)==12)if((c[l>>2]|0)==(c[o>>2]|0)){c[j>>2]=E_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;q=c[j>>2]|0;i=h;return q|0}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}else if((s|0)==15)if((c[l>>2]|0)==(c[o>>2]|0)){c[p>>2]=F_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;c[j>>2]=(c[p>>2]|0)==22?0:c[p>>2]|0;q=c[j>>2]|0;i=h;return q|0}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}else if((s|0)==18){p=c[l>>2]|0;if((c[l>>2]|0)==(c[o>>2]|0)){c[c[n>>2]>>2]=p+2;c[j>>2]=7;q=c[j>>2]|0;i=h;return q|0}else{c[c[n>>2]>>2]=p;c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}}else if((s|0)==21){p=c[l>>2]|0;if((c[l>>2]|0)!=(c[o>>2]|0)){c[c[n>>2]>>2]=p;c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}c[l>>2]=p+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-3;q=c[j>>2]|0;i=h;return q|0}m=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))u=d[(c[k>>2]|0)+76+(d[m>>0]|0)>>0]|0;else u=D_(a[m+1>>0]|0,a[c[l>>2]>>0]|0)|0;if((u|0)==10)c[l>>2]=(c[l>>2]|0)+2;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;q=c[j>>2]|0;i=h;return q|0}else if((s|0)==32){c[c[n>>2]>>2]=r;c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}return 0}function s_(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;a:while(1){f=c[k>>2]|0;if(!(a[(c[k>>2]|0)+1>>0]|0))m=d[(c[j>>2]|0)+76+(d[f>>0]|0)>>0]|0;else m=D_(a[f+1>>0]|0,a[c[k>>2]>>0]|0)|0;switch(m|0){case 7:{f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=7;break a}else n=8;break}case 6:{n=8;break}case 5:break;case 27:case 26:case 25:case 24:case 23:case 22:case 29:{f=c[l>>2]|0;c[l>>2]=f+1;e=a[f>>0]|0;f=c[k>>2]|0;c[k>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=15;break a}f=c[l>>2]|0;c[l>>2]=f+1;e=a[f>>0]|0;f=c[k>>2]|0;c[k>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=17;break a}else continue a;break}default:{n=18;break a}}if((n|0)==8?(n=0,f=c[k>>2]|0,c[k>>2]=f+1,e=a[f>>0]|0,f=c[l>>2]|0,c[l>>2]=f+1,(e|0)!=(a[f>>0]|0)):0){n=9;break}f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=11;break}f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=13;break}}if((n|0)==7){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==9){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==11){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==13){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==15){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==17){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==18){n=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))p=d[(c[j>>2]|0)+76+(d[n>>0]|0)>>0]|0;else p=D_(a[n+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(p|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}default:{c[h>>2]=1;o=c[h>>2]|0;i=g;return o|0}}}return 0}function t_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+16|0;j=g+8|0;k=g+4|0;l=g;c[g+12>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;while(1){m=(c[j>>2]|0)==(c[k>>2]|0);if(!(a[c[l>>2]>>0]|0)){n=9;break}if(m){n=4;break}if(a[(c[j>>2]|0)+1>>0]|0){n=7;break}if((a[c[j>>2]>>0]|0)!=(a[c[l>>2]>>0]|0)){n=7;break}c[j>>2]=(c[j>>2]|0)+2;c[l>>2]=(c[l>>2]|0)+1}if((n|0)==4){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==7){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==9){c[h>>2]=m&1;o=c[h>>2]|0;i=g;return o|0}return 0}function u_(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[g>>2]=b;c[h>>2]=e;c[j>>2]=c[h>>2];a:while(1){e=c[h>>2]|0;if(!(a[(c[h>>2]|0)+1>>0]|0))k=d[(c[g>>2]|0)+76+(d[e>>0]|0)>>0]|0;else k=D_(a[e+1>>0]|0,a[c[h>>2]>>0]|0)|0;switch(k|0){case 5:{c[h>>2]=(c[h>>2]|0)+2;continue a;break}case 6:{c[h>>2]=(c[h>>2]|0)+3;continue a;break}case 7:{c[h>>2]=(c[h>>2]|0)+4;continue a;break}case 27:case 26:case 25:case 24:case 23:case 22:case 29:{c[h>>2]=(c[h>>2]|0)+2;continue a;break}default:break a}}i=f;return (c[h>>2]|0)-(c[j>>2]|0)|0}function v_(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f;c[g>>2]=b;c[h>>2]=e;a:while(1){e=c[h>>2]|0;if(!(a[(c[h>>2]|0)+1>>0]|0))j=d[(c[g>>2]|0)+76+(d[e>>0]|0)>>0]|0;else j=D_(a[e+1>>0]|0,a[c[h>>2]>>0]|0)|0;switch(j|0){case 21:case 9:case 10:break;default:break a}c[h>>2]=(c[h>>2]|0)+2}i=f;return c[h>>2]|0}function w_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=1;c[o>>2]=0;c[p>>2]=0;c[k>>2]=(c[k>>2]|0)+2;a:while(1){g=c[k>>2]|0;if(!(a[(c[k>>2]|0)+1>>0]|0))q=d[(c[j>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[k>>2]>>0]|0)|0;b:do switch(q|0){case 5:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=c[k>>2];break}case 6:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=(c[k>>2]|0)+1;break}case 7:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=(c[k>>2]|0)+2;break}case 24:case 22:case 29:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}break}case 12:{if((c[n>>2]|0)!=2){if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]=(c[k>>2]|0)+2;c[n>>2]=2;c[p>>2]=12;break b}if((c[p>>2]|0)==12){c[n>>2]=0;if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+8>>2]=c[k>>2];c[o>>2]=(c[o>>2]|0)+1}break}case 13:{if((c[n>>2]|0)!=2){if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]=(c[k>>2]|0)+2;c[n>>2]=2;c[p>>2]=13;break b}if((c[p>>2]|0)==13){c[n>>2]=0;if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+8>>2]=c[k>>2];c[o>>2]=(c[o>>2]|0)+1}break}case 3:{if((c[o>>2]|0)<(c[l>>2]|0))a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0;break}case 21:{if((c[n>>2]|0)==1){c[n>>2]=0;break b}if(((c[n>>2]|0)==2?(c[o>>2]|0)<(c[l>>2]|0):0)?(a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]|0)!=0:0){if((c[k>>2]|0)!=(c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]|0)){if(!(a[(c[k>>2]|0)+1>>0]|0))r=a[c[k>>2]>>0]|0;else r=-1;if((r|0)==32){if(!(a[(c[k>>2]|0)+2+1>>0]|0))s=a[(c[k>>2]|0)+2>>0]|0;else s=-1;if((s|0)!=32){g=(c[k>>2]|0)+2|0;if(!(a[(c[k>>2]|0)+2+1>>0]|0))t=d[(c[j>>2]|0)+76+(d[g>>0]|0)>>0]|0;else t=D_(a[g+1>>0]|0,a[(c[k>>2]|0)+2>>0]|0)|0;if((t|0)!=(c[p>>2]|0))break b}}}a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0}break}case 10:case 9:{if((c[n>>2]|0)==1){c[n>>2]=0;break b}if((c[n>>2]|0)==2?(c[o>>2]|0)<(c[l>>2]|0):0)a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0;break}case 17:case 11:{if((c[n>>2]|0)!=2)break a;break}default:{}}while(0);c[k>>2]=(c[k>>2]|0)+2}i=h;return c[o>>2]|0}function x_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+20|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[e+16>>2]=b;c[g>>2]=d;c[h>>2]=0;c[g>>2]=(c[g>>2]|0)+4;a:do if((a[(c[g>>2]|0)+1>>0]|0)==0?(a[c[g>>2]>>0]|0)==120:0){c[g>>2]=(c[g>>2]|0)+2;while(1){if(!(a[(c[g>>2]|0)+1>>0]|0))l=(a[c[g>>2]>>0]|0)==59;else l=0;if(!(l^1))break a;if(!(a[(c[g>>2]|0)+1>>0]|0))m=a[c[g>>2]>>0]|0;else m=-1;c[j>>2]=m;switch(c[j>>2]|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c[h>>2]=c[h>>2]<<4;c[h>>2]=c[h>>2]|(c[j>>2]|0)-48;break}case 70:case 69:case 68:case 67:case 66:case 65:{c[h>>2]=c[h>>2]<<4;c[h>>2]=(c[h>>2]|0)+(10+((c[j>>2]|0)-65));break}case 102:case 101:case 100:case 99:case 98:case 97:{c[h>>2]=c[h>>2]<<4;c[h>>2]=(c[h>>2]|0)+(10+((c[j>>2]|0)-97));break}default:{}}if((c[h>>2]|0)>=1114112)break;c[g>>2]=(c[g>>2]|0)+2}c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}else o=16;while(0);b:do if((o|0)==16){while(1){o=0;if(!(a[(c[g>>2]|0)+1>>0]|0))p=(a[c[g>>2]>>0]|0)==59;else p=0;if(!(p^1))break b;if(!(a[(c[g>>2]|0)+1>>0]|0))q=a[c[g>>2]>>0]|0;else q=-1;c[k>>2]=q;c[h>>2]=(c[h>>2]|0)*10;c[h>>2]=(c[h>>2]|0)+((c[k>>2]|0)-48);if((c[h>>2]|0)>=1114112)break;c[g>>2]=(c[g>>2]|0)+2;o=16}c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}while(0);c[f>>2]=YZ(c[h>>2]|0)|0;n=c[f>>2]|0;i=e;return n|0}function y_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+12|0;h=f+4|0;j=f;c[f+8>>2]=b;c[h>>2]=d;c[j>>2]=e;a:do switch(((c[j>>2]|0)-(c[h>>2]|0)|0)/2|0|0){case 2:{if((a[(c[h>>2]|0)+2+1>>0]|0)==0?(a[(c[h>>2]|0)+2>>0]|0)==116:0){if(!(a[(c[h>>2]|0)+1>>0]|0))k=a[c[h>>2]>>0]|0;else k=-1;switch(k|0){case 108:{c[g>>2]=60;l=c[g>>2]|0;i=f;return l|0}case 103:{c[g>>2]=62;l=c[g>>2]|0;i=f;return l|0}default:break a}}break}case 3:{if((((((a[(c[h>>2]|0)+1>>0]|0)==0?(a[c[h>>2]>>0]|0)==97:0)?(c[h>>2]=(c[h>>2]|0)+2,(a[(c[h>>2]|0)+1>>0]|0)==0):0)?(a[c[h>>2]>>0]|0)==109:0)?(c[h>>2]=(c[h>>2]|0)+2,(a[(c[h>>2]|0)+1>>0]|0)==0):0)?(a[c[h>>2]>>0]|0)==112:0){c[g>>2]=38;l=c[g>>2]|0;i=f;return l|0}break}case 4:{if(!(a[(c[h>>2]|0)+1>>0]|0))m=a[c[h>>2]>>0]|0;else m=-1;switch(m|0){case 113:{c[h>>2]=(c[h>>2]|0)+2;if(a[(c[h>>2]|0)+1>>0]|0)break a;if((a[c[h>>2]>>0]|0)!=117)break a;c[h>>2]=(c[h>>2]|0)+2;if(a[(c[h>>2]|0)+1>>0]|0)break a;if((a[c[h>>2]>>0]|0)!=111)break a;c[h>>2]=(c[h>>2]|0)+2;if(a[(c[h>>2]|0)+1>>0]|0)break a;if((a[c[h>>2]>>0]|0)!=116)break a;c[g>>2]=34;l=c[g>>2]|0;i=f;return l|0}case 97:{c[h>>2]=(c[h>>2]|0)+2;if(a[(c[h>>2]|0)+1>>0]|0)break a;if((a[c[h>>2]>>0]|0)!=112)break a;c[h>>2]=(c[h>>2]|0)+2;if(a[(c[h>>2]|0)+1>>0]|0)break a;if((a[c[h>>2]>>0]|0)!=111)break a;c[h>>2]=(c[h>>2]|0)+2;if(a[(c[h>>2]|0)+1>>0]|0)break a;if((a[c[h>>2]>>0]|0)!=115)break a;c[g>>2]=39;l=c[g>>2]|0;i=f;return l|0}default:break a}break}default:{}}while(0);c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}function z_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+16|0;j=h+12|0;k=h+8|0;l=h+4|0;m=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;while(1){if((c[k>>2]|0)>>>0>=(c[l>>2]|0)>>>0)break;g=c[k>>2]|0;if(!(a[(c[k>>2]|0)+1>>0]|0))n=d[(c[j>>2]|0)+76+(d[g>>0]|0)>>0]|0;else n=D_(a[g+1>>0]|0,a[c[k>>2]>>0]|0)|0;switch(n|0){case 5:{c[k>>2]=(c[k>>2]|0)+2;break}case 6:{c[k>>2]=(c[k>>2]|0)+3;break}case 7:{c[k>>2]=(c[k>>2]|0)+4;break}case 10:{c[(c[m>>2]|0)+4>>2]=-1;g=c[m>>2]|0;c[g>>2]=(c[g>>2]|0)+1;c[k>>2]=(c[k>>2]|0)+2;break}case 9:{g=c[m>>2]|0;c[g>>2]=(c[g>>2]|0)+1;c[k>>2]=(c[k>>2]|0)+2;if((c[k>>2]|0)!=(c[l>>2]|0)){g=c[k>>2]|0;if(!(a[(c[k>>2]|0)+1>>0]|0))o=d[(c[j>>2]|0)+76+(d[g>>0]|0)>>0]|0;else o=D_(a[g+1>>0]|0,a[c[k>>2]>>0]|0)|0;if((o|0)==10)c[k>>2]=(c[k>>2]|0)+2}c[(c[m>>2]|0)+4>>2]=-1;break}default:c[k>>2]=(c[k>>2]|0)+2}g=(c[m>>2]|0)+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function A_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[l>>2]=(c[l>>2]|0)+2;c[m>>2]=(c[m>>2]|0)+-2;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){o=18;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))p=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else p=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(p|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:break;case 21:{if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==9:0){o=9;break a}break}case 22:case 26:{if(!(a[(c[l>>2]|0)+1>>0]|0))q=a[c[l>>2]>>0]|0;else q=-1;if(q&-128)o=13;break}default:o=13}if((o|0)==13){o=0;if(!(a[(c[l>>2]|0)+1>>0]|0))r=a[c[l>>2]>>0]|0;else r=-1;switch(r|0){case 64:case 36:break;default:{o=16;break a}}}c[l>>2]=(c[l>>2]|0)+2}if((o|0)==9){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}else if((o|0)==16){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}else if((o|0)==18){c[j>>2]=1;s=c[j>>2]|0;i=h;return s|0}return 0}function B_(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+32|0;k=j+20|0;l=j+16|0;m=j+12|0;n=j+8|0;o=j+4|0;p=j;q=j+30|0;r=j+29|0;s=j+28|0;c[j+24>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=h;c[o>>2]=c[c[k>>2]>>2];a:while(1){t=c[o>>2]|0;if((c[o>>2]|0)==(c[l>>2]|0)){u=18;break}a[r>>0]=a[t>>0]|0;a[s>>0]=a[(c[o>>2]|0)+1>>0]|0;switch(d[s>>0]|0|0){case 0:{if((d[r>>0]|0|0)<128){if((c[c[m>>2]>>2]|0)==(c[n>>2]|0)){u=6;break a}h=a[r>>0]|0;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h}else u=8;break}case 7:case 6:case 5:case 4:case 3:case 2:case 1:{u=8;break}case 219:case 218:case 217:case 216:{if(((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)<4){u=15;break a}c[p>>2]=(((d[s>>0]|0)&3)<<2|(d[r>>0]|0)>>6&3)+1;h=(c[p>>2]>>2|240)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h;h=((d[r>>0]|0)>>2&15|(c[p>>2]&3)<<4|128)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;c[o>>2]=(c[o>>2]|0)+2;a[q>>0]=a[c[o>>2]>>0]|0;h=(((d[r>>0]|0)&3)<<4|((d[(c[o>>2]|0)+1>>0]|0)&3)<<2|(d[q>>0]|0)>>6|128)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h;h=((d[q>>0]|0)&63|128)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;break}default:{if(((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)<3){u=12;break a}h=((d[s>>0]|0)>>4|224)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h;h=(((d[s>>0]|0)&15)<<2|(d[r>>0]|0)>>6|128)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;h=((d[r>>0]|0)&63|128)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h}}if((u|0)==8){u=0;if(((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)<2){u=9;break}h=((d[r>>0]|0)>>6|(d[s>>0]|0)<<2|192)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;h=((d[r>>0]|0)&63|128)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h}c[o>>2]=(c[o>>2]|0)+2}if((u|0)==6){c[c[k>>2]>>2]=c[o>>2];i=j;return}else if((u|0)==9){c[c[k>>2]>>2]=c[o>>2];i=j;return}else if((u|0)==12){c[c[k>>2]>>2]=c[o>>2];i=j;return}else if((u|0)==15){c[c[k>>2]>>2]=c[o>>2];i=j;return}else if((u|0)==18){c[c[k>>2]>>2]=t;i=j;return}}function C_(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+32|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[j+16>>2]=a;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=h;if(((c[l>>2]|0)-(c[c[k>>2]>>2]|0)|0)>((((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)/2|0)<<1|0)?((d[(c[l>>2]|0)+-2+1>>0]|0)&248|0)==216:0)c[l>>2]=(c[l>>2]|0)+-2;while(1){if((c[c[k>>2]>>2]|0)==(c[l>>2]|0)){o=7;break}if((c[c[m>>2]>>2]|0)==(c[n>>2]|0)){o=7;break}h=((d[(c[c[k>>2]>>2]|0)+1>>0]|0)<<8|(d[c[c[k>>2]>>2]>>0]|0))&65535;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+2;b[f>>1]=h;h=c[k>>2]|0;c[h>>2]=(c[h>>2]|0)+2}if((o|0)==7){i=j;return}}function D_(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f;h=f+5|0;j=f+4|0;a[h>>0]=b;a[j>>0]=e;switch(d[h>>0]|0|0){case 219:case 218:case 217:case 216:{c[g>>2]=7;break}case 223:case 222:case 221:case 220:{c[g>>2]=8;break}case 255:{if(((d[j>>0]|0)+-254|0)>>>0<2)c[g>>2]=0;else k=6;break}default:k=6}if((k|0)==6)c[g>>2]=29;i=f;return c[g>>2]|0}function E_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))o=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else o=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(o|0){case 29:{if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 19:{c[j>>2]=G_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=40;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(q|0){case 5:{p=29;break b;break}case 6:{p=32;break b;break}case 7:{p=35;break b;break}case 18:{p=38;break b;break}case 29:{if(!(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){p=27;break b}break}case 27:case 26:case 25:case 24:case 22:break;default:{p=39;break b}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==27){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==29)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==32)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==35)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==38){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=9;break}else if((p|0)==39){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==40){c[j>>2]=-1;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function F_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))o=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else o=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(o|0){case 29:{if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 30:case 9:case 10:case 21:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=22;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=40;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(q|0){case 5:{p=29;break b;break}case 6:{p=32;break b;break}case 7:{p=35;break b;break}case 18:{p=38;break b;break}case 29:{if(!(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){p=27;break b}break}case 27:case 26:case 25:case 24:case 22:break;default:{p=39;break b}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==27){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==29)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==32)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==35)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==38){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=28;break}else if((p|0)==39){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==40){c[j>>2]=-1;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function G_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==120:0){c[j>>2]=H_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;o=c[j>>2]|0;i=h;return o|0}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))p=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else p=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;g=c[l>>2]|0;if((p|0)!=25){c[c[n>>2]>>2]=g;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}c[l>>2]=g+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0))break a;g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(q|0){case 18:{r=16;break b;break}case 25:break;default:{r=17;break b}}c[l>>2]=(c[l>>2]|0)+2}if((r|0)==16){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=10;o=c[j>>2]|0;i=h;return o|0}else if((r|0)==17){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}}while(0);c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}function H_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))o=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else o=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;g=c[l>>2]|0;if((o+-24|0)>>>0>=2){c[c[n>>2]>>2]=g;c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}c[l>>2]=g+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0))break a;g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(q|0){case 18:{r=13;break b;break}case 24:case 25:break;default:{r=14;break b}}c[l>>2]=(c[l>>2]|0)+2}if((r|0)==13){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=10;p=c[j>>2]|0;i=h;return p|0}else if((r|0)==14){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}}while(0);c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}function I_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)==(c[m>>2]|0))c[j>>2]=-1;else{g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))p=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else p=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(p|0){case 29:{if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 16:{g=(c[l>>2]|0)+2|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(q|0){case 27:{c[j>>2]=J_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 20:{c[j>>2]=K_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 15:{c[j>>2]=L_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 17:{c[j>>2]=M_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;c[o>>2]=0;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){r=98;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))s=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else s=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(s|0){case 5:{r=39;break b;break}case 6:{r=42;break b;break}case 7:{r=45;break b;break}case 10:case 9:case 21:{r=69;break b;break}case 11:{r=90;break b;break}case 17:{break b;break}case 29:{if(!(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){r=37;break b}break}case 27:case 26:case 25:case 24:case 22:break;case 23:{if(c[o>>2]|0){r=49;break b}c[o>>2]=1;c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){r=51;break b}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))t=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else t=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(t|0){case 5:{r=59;break b;break}case 6:{r=62;break b;break}case 7:{r=65;break b;break}case 29:{if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){r=57;break b}break}case 24:case 22:break;default:{r=68;break b}}c[l>>2]=(c[l>>2]|0)+2;continue b;break}default:{r=97;break b}}c[l>>2]=(c[l>>2]|0)+2}c:switch(r|0){case 37:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 39:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 42:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 45:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 49:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 51:{c[j>>2]=-1;break a;break}case 57:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 59:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 62:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 65:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 68:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 69:{c[l>>2]=(c[l>>2]|0)+2;d:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){r=89;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))u=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else u=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(u|0){case 11:{r=90;break c;break}case 17:{break c;break}case 29:{r=75;break d;break}case 24:case 22:{break d;break}case 5:{r=78;break d;break}case 6:{r=81;break d;break}case 7:{r=84;break d;break}case 10:case 9:case 21:break;default:{r=88;break d}}c[l>>2]=(c[l>>2]|0)+2}if((r|0)==75){if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}else if((r|0)==78)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((r|0)==81)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((r|0)==84)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((r|0)==88){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((r|0)==89){c[j>>2]=-1;break a}c[l>>2]=(c[l>>2]|0)+2;c[j>>2]=N_(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 97:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 98:{c[j>>2]=-1;break a;break}}if((r|0)==90){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=2;break}c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=4;break}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0}while(0);i=h;return c[j>>2]|0}function J_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==45:0){c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0))break a;g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))o=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else o=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(o|0){case 8:case 1:case 0:{p=20;break b;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){p=12;break b}c[l>>2]=(c[l>>2]|0)+2;continue b;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){p=15;break b}c[l>>2]=(c[l>>2]|0)+3;continue b;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){p=18;break b}c[l>>2]=(c[l>>2]|0)+4;continue b;break}case 27:{g=(c[l>>2]|0)+2|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){p=22;break b}if(a[(c[l>>2]|0)+1>>0]|0)continue b;if((a[c[l>>2]>>0]|0)==45){p=25;break b}else continue b;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue b}}}if((p|0)==12){c[j>>2]=-2;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==15){c[j>>2]=-2;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==18){c[j>>2]=-2;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==20){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==22){c[j>>2]=-1;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==25){g=(c[l>>2]|0)+2|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){c[j>>2]=-1;q=c[j>>2]|0;i=h;return q|0}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=13;q=c[j>>2]|0;i=h;return q|0}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;q=c[j>>2]|0;i=h;return q|0}}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;q=c[j>>2]|0;i=h;return q|0}while(0);c[j>>2]=-1;q=c[j>>2]|0;i=h;return q|0}function K_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+20|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[g+16>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;if(((c[k>>2]|0)-(c[j>>2]|0)|0)<12){c[h>>2]=-1;n=c[h>>2]|0;i=g;return n|0}c[m>>2]=0;while(1){o=c[j>>2]|0;if((c[m>>2]|0)>=6){p=9;break}if(a[o+1>>0]|0){p=7;break}if((a[c[j>>2]>>0]|0)!=(a[182097+(c[m>>2]|0)>>0]|0)){p=7;break}c[m>>2]=(c[m>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+2}if((p|0)==7){c[c[l>>2]>>2]=c[j>>2];c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else if((p|0)==9){c[c[l>>2]>>2]=o;c[h>>2]=8;n=c[h>>2]|0;i=g;return n|0}return 0}function L_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[p>>2]=c[l>>2];a:do if((c[l>>2]|0)==(c[m>>2]|0))c[j>>2]=-1;else{g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(q|0){case 29:{if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){r=70;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))s=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else s=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(s|0){case 5:{r=28;break b;break}case 6:{r=31;break b;break}case 7:{r=34;break b;break}case 10:case 9:case 21:{r=37;break b;break}case 15:{r=62;break b;break}case 29:{if(!(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){r=26;break b}break}case 27:case 26:case 25:case 24:case 22:break;default:break b}c[l>>2]=(c[l>>2]|0)+2}if((r|0)==26){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==28)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==31)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==34)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==37){g=(O_(c[k>>2]|0,c[p>>2]|0,c[l>>2]|0,o)|0)!=0;f=c[l>>2]|0;if(!g){c[c[n>>2]>>2]=f;c[j>>2]=0;break}c[l>>2]=f+2;c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){r=61;break}f=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))t=d[(c[k>>2]|0)+76+(d[f>>0]|0)>>0]|0;else t=D_(a[f+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(t|0){case 8:case 1:case 0:{r=54;break c;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){r=46;break c}c[l>>2]=(c[l>>2]|0)+2;continue c;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){r=49;break c}c[l>>2]=(c[l>>2]|0)+3;continue c;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){r=52;break c}c[l>>2]=(c[l>>2]|0)+4;continue c;break}case 15:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){r=56;break c}if(a[(c[l>>2]|0)+1>>0]|0)continue c;if((a[c[l>>2]>>0]|0)==62){r=59;break c}else continue c;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue c}}}if((r|0)==46){c[j>>2]=-2;break}else if((r|0)==49){c[j>>2]=-2;break}else if((r|0)==52){c[j>>2]=-2;break}else if((r|0)==54){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==56){c[j>>2]=-1;break}else if((r|0)==59){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=c[o>>2];break}else if((r|0)==61){c[j>>2]=-1;break}}else if((r|0)==62){f=(O_(c[k>>2]|0,c[p>>2]|0,c[l>>2]|0,o)|0)!=0;g=c[l>>2]|0;if(!f){c[c[n>>2]>>2]=g;c[j>>2]=0;break}c[l>>2]=g+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=c[o>>2];break}}else if((r|0)==70){c[j>>2]=-1;break}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0}while(0);i=h;return c[j>>2]|0}function M_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))o=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else o=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(o|0){case 29:{if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=50;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(q|0){case 5:{p=28;break b;break}case 6:{p=31;break b;break}case 7:{p=34;break b;break}case 10:case 9:case 21:{p=37;break b;break}case 11:{p=48;break b;break}case 29:{if(!(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){p=26;break b}break}case 27:case 26:case 25:case 24:case 22:break;case 23:{c[l>>2]=(c[l>>2]|0)+2;continue b;break}default:{p=49;break b}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==26){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==28)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==31)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==34)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==37){c[l>>2]=(c[l>>2]|0)+2;c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=46;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))r=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else r=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(r|0){case 11:{p=43;break c;break}case 10:case 9:case 21:break;default:{p=44;break c}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==43){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=5;break}else if((p|0)==44){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==46){c[j>>2]=-1;break}}else if((p|0)==48){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=5;break}else if((p|0)==49){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==50){c[j>>2]=-1;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function N_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=0;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){t=115;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))u=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else u=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;b:do switch(u|0){case 5:{t=10;break a;break}case 6:{t=13;break a;break}case 7:{t=16;break a;break}case 29:{if(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))t=9;else{t=8;break a}break}case 27:case 26:case 25:case 24:case 22:{t=9;break}case 23:{if(c[o>>2]|0){t=20;break a}c[o>>2]=1;c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=22;break a}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))v=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else v=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(v|0){case 5:{t=30;break a;break}case 6:{t=33;break a;break}case 7:{t=36;break a;break}case 29:{if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){t=28;break a}break}case 24:case 22:break;default:{t=39;break a}}c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 10:case 9:case 21:{while(1){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=41;break a}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))w=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else w=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;c[p>>2]=w;if((c[p>>2]|0)==14)break b;switch(c[p>>2]|0){case 9:case 10:case 21:break;default:{t=47;break a}}}break}case 14:break;default:{t=114;break a}}while(0);if((t|0)==9){t=0;c[l>>2]=(c[l>>2]|0)+2;continue}c[o>>2]=0;while(1){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=50;break a}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))x=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else x=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;c[q>>2]=x;if((c[q>>2]|0)==12|(c[q>>2]|0)==13)break;switch(c[q>>2]|0){case 9:case 10:case 21:break;default:{t=56;break a}}}c[l>>2]=(c[l>>2]|0)+2;c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){t=59;break a}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))y=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else y=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;c[r>>2]=y;if((c[r>>2]|0)==(c[q>>2]|0))break;switch(c[r>>2]|0){case 8:case 1:case 0:{t=74;break a;break}case 2:{t=79;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=66;break a}c[l>>2]=(c[l>>2]|0)+2;continue c;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=69;break a}c[l>>2]=(c[l>>2]|0)+3;continue c;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=72;break a}c[l>>2]=(c[l>>2]|0)+4;continue c;break}case 3:{c[s>>2]=E_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,l)|0;if((c[s>>2]|0)<=0){t=76;break a}else continue c;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue c}}}c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=82;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))z=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else z=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(z|0){case 11:{t=106;break a;break}case 17:{t=107;break a;break}case 10:case 9:case 21:break;default:{t=87;break a}}d:while(1){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=89;break a}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))A=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else A=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(A|0){case 5:{t=97;break a;break}case 6:{t=100;break a;break}case 7:{t=103;break a;break}case 11:{t=106;break a;break}case 17:{t=107;break a;break}case 10:case 9:case 21:break;case 29:{t=94;break d;break}case 24:case 22:{break d;break}default:{t=113;break a}}}if((t|0)==94?(t=0,(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31)|0)==0):0){t=95;break}c[l>>2]=(c[l>>2]|0)+2}switch(t|0){case 8:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 10:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 13:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 16:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 20:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 22:{c[j>>2]=-1;break}case 28:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 30:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 33:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 36:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 39:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 41:{c[j>>2]=-1;break}case 47:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 50:{c[j>>2]=-1;break}case 56:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 59:{c[j>>2]=-1;break}case 66:{c[j>>2]=-2;break}case 69:{c[j>>2]=-2;break}case 72:{c[j>>2]=-2;break}case 74:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 76:{if(!(c[s>>2]|0))c[c[n>>2]>>2]=c[l>>2];c[j>>2]=c[s>>2];break}case 79:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 82:{c[j>>2]=-1;break}case 87:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 89:{c[j>>2]=-1;break}case 95:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 97:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 100:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 103:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 106:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=1;break}case 107:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break}if((a[(c[l>>2]|0)+1>>0]|0)==0?(a[c[l>>2]>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=3;break}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 113:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 114:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 115:{c[j>>2]=-1;break}}i=h;return c[j>>2]|0}function O_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+20|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[g+16>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=0;c[c[l>>2]>>2]=11;if(((c[k>>2]|0)-(c[j>>2]|0)|0)!=6){c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}if(!(a[(c[j>>2]|0)+1>>0]|0))o=a[c[j>>2]>>0]|0;else o=-1;switch(o|0){case 120:break;case 88:{c[m>>2]=1;break}default:{c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}}c[j>>2]=(c[j>>2]|0)+2;if(!(a[(c[j>>2]|0)+1>>0]|0))p=a[c[j>>2]>>0]|0;else p=-1;switch(p|0){case 109:break;case 77:{c[m>>2]=1;break}default:{c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}}c[j>>2]=(c[j>>2]|0)+2;if(!(a[(c[j>>2]|0)+1>>0]|0))q=a[c[j>>2]>>0]|0;else q=-1;switch(q|0){case 108:break;case 76:{c[m>>2]=1;break}default:{c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}}if(c[m>>2]|0){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else{c[c[l>>2]>>2]=12;c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}return 0}function P_(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;a:while(1){if((c[n>>2]|0)==(c[o>>2]|0)){r=27;break}h=c[n>>2]|0;if(!(a[(c[n>>2]|0)+1>>0]|0))s=d[(c[m>>2]|0)+76+(d[h>>0]|0)>>0]|0;else s=D_(a[h+1>>0]|0,a[c[n>>2]>>0]|0)|0;c[q>>2]=s;switch(c[q>>2]|0){case 8:case 1:case 0:{r=16;break a;break}case 5:{if(((c[o>>2]|0)-(c[n>>2]|0)|0)<2){r=8;break a}c[n>>2]=(c[n>>2]|0)+2;continue a;break}case 6:{if(((c[o>>2]|0)-(c[n>>2]|0)|0)<3){r=11;break a}c[n>>2]=(c[n>>2]|0)+3;continue a;break}case 7:{if(((c[o>>2]|0)-(c[n>>2]|0)|0)<4){r=14;break a}c[n>>2]=(c[n>>2]|0)+4;continue a;break}case 13:case 12:{c[n>>2]=(c[n>>2]|0)+2;if((c[q>>2]|0)!=(c[l>>2]|0))continue a;else{r=18;break a}break}default:{c[n>>2]=(c[n>>2]|0)+2;continue a}}}if((r|0)==8){c[k>>2]=-2;t=c[k>>2]|0;i=j;return t|0}else if((r|0)==11){c[k>>2]=-2;t=c[k>>2]|0;i=j;return t|0}else if((r|0)==14){c[k>>2]=-2;t=c[k>>2]|0;i=j;return t|0}else if((r|0)==16){c[c[p>>2]>>2]=c[n>>2];c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}else if((r|0)==18){if((c[n>>2]|0)==(c[o>>2]|0)){c[k>>2]=-27;t=c[k>>2]|0;i=j;return t|0}c[c[p>>2]>>2]=c[n>>2];p=c[n>>2]|0;if(!(a[(c[n>>2]|0)+1>>0]|0))u=d[(c[m>>2]|0)+76+(d[p>>0]|0)>>0]|0;else u=D_(a[p+1>>0]|0,a[c[n>>2]>>0]|0)|0;switch(u|0){case 20:case 30:case 11:case 10:case 9:case 21:{c[k>>2]=27;t=c[k>>2]|0;i=j;return t|0}default:{c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}}}else if((r|0)==27){c[k>>2]=-1;t=c[k>>2]|0;i=j;return t|0}return 0}function Q_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))p=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else p=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(p|0){case 27:{c[j>>2]=J_(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;o=c[j>>2]|0;i=h;return o|0}case 20:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=33;o=c[j>>2]|0;i=h;return o|0}case 24:case 22:{c[l>>2]=(c[l>>2]|0)+2;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){q=26;break}p=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))r=d[(c[k>>2]|0)+76+(d[p>>0]|0)>>0]|0;else r=D_(a[p+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(r|0){case 30:{q=16;break a;break}case 10:case 9:case 21:{break a;break}case 24:case 22:break;default:{q=25;break a}}c[l>>2]=(c[l>>2]|0)+2}b:do if((q|0)==16){if(((c[l>>2]|0)+2|0)==(c[m>>2]|0)){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}r=(c[l>>2]|0)+2|0;if(!(a[(c[l>>2]|0)+2+1>>0]|0))s=d[(c[k>>2]|0)+76+(d[r>>0]|0)>>0]|0;else s=D_(a[r+1>>0]|0,a[(c[l>>2]|0)+2>>0]|0)|0;switch(s|0){case 30:case 10:case 9:case 21:break;default:break b}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==25){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==26){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}while(0);c[c[n>>2]>>2]=c[l>>2];c[j>>2]=16;o=c[j>>2]|0;i=h;return o|0}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}}return 0}function R_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))o=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else o=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(o|0){case 29:{if(!(c[93280+((d[181578+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=39;break}g=c[l>>2]|0;if(!(a[(c[l>>2]|0)+1>>0]|0))q=d[(c[k>>2]|0)+76+(d[g>>0]|0)>>0]|0;else q=D_(a[g+1>>0]|0,a[c[l>>2]>>0]|0)|0;switch(q|0){case 5:{p=28;break b;break}case 6:{p=31;break b;break}case 7:{p=34;break b;break}case 36:case 30:case 11:case 32:case 21:case 10:case 9:{p=37;break b;break}case 29:{if(!(c[93280+((d[181834+(d[(c[l>>2]|0)+1>>0]|0)>>0]<<3)+(d[c[l>>2]>>0]>>5)<<2)>>2]&1<<(d[c[l>>2]>>0]&31))){p=26;break b}break}case 27:case 26:case 25:case 24:case 22:break;default:{p=38;break b}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==26){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==28)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==31)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==34)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==37){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=20;break}else if((p|0)==38){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==39){c[j>>2]=-20;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function S_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){c[p>>2]=(c[m>>2]|0)-(c[l>>2]|0);do if(c[p>>2]&1){c[p>>2]=c[p>>2]&-2;if(!(c[p>>2]|0)){c[j>>2]=-1;break a}else{c[m>>2]=(c[l>>2]|0)+(c[p>>2]|0);break}}while(0);g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;b:do switch(q|0){case 12:{c[j>>2]=s$(12,c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 13:{c[j>>2]=s$(13,c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 2:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))r=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else r=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(r|0){case 16:{c[j>>2]=t$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 15:{c[j>>2]=o$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 7:case 6:case 5:case 29:case 24:case 22:{c[c[n>>2]>>2]=(c[l>>2]|0)+-2;c[j>>2]=29;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 9:{if(((c[l>>2]|0)+2|0)==(c[m>>2]|0)){c[c[n>>2]>>2]=c[m>>2];c[j>>2]=-15;break a}else s=25;break}case 10:case 21:{s=25;break}case 30:{c[j>>2]=i$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 35:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=38;break a;break}case 20:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=25;break a;break}case 4:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-26;break a}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==93:0){if(((c[l>>2]|0)+2|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}if((a[(c[l>>2]|0)+2>>0]|0)==0?(a[(c[l>>2]|0)+2+1>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+4;c[j>>2]=34;break a}}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=26;break a;break}case 31:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=23;break a;break}case 32:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-24;break a}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))t=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else t=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(t|0){case 33:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=36;break a;break}case 15:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=35;break a;break}case 34:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=37;break a;break}case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=24;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 36:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=21;break a;break}case 11:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=17;break a;break}case 19:{c[j>>2]=u$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:{c[o>>2]=18;c[l>>2]=(c[l>>2]|0)+2;s=77;break}case 23:case 27:case 26:case 25:{c[o>>2]=19;c[l>>2]=(c[l>>2]|0)+2;s=77;break}case 29:{g=c[l>>2]|0;if(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31)){c[l>>2]=g+2;c[o>>2]=18;s=77;break b}if(c[93280+((d[181834+(d[g>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31)){c[l>>2]=(c[l>>2]|0)+2;c[o>>2]=19;s=77}else s=76;break}default:s=76}while(0);if((s|0)==25){c:while(1){s=0;c[l>>2]=(c[l>>2]|0)+2;u=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){s=32;break}g=c[l>>2]|0;if(!(a[u>>0]|0))v=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else v=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(v|0){case 10:case 21:{s=25;continue c;break}case 9:break;default:{s=31;break c}}if(((c[l>>2]|0)+2|0)!=(c[m>>2]|0))s=25;else{s=31;break}}if((s|0)==31){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=15;break}else if((s|0)==32){c[c[n>>2]>>2]=u;c[j>>2]=15;break}}else if((s|0)==76){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((s|0)==77){d:while(1){s=0;if((c[l>>2]|0)==(c[m>>2]|0)){s=126;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))w=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else w=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(w|0){case 5:{s=85;break d;break}case 6:{s=88;break d;break}case 7:{s=91;break d;break}case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{s=94;break d;break}case 34:{s=116;break d;break}case 33:{s=119;break d;break}case 15:{s=122;break d;break}case 29:{if(!(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){s=83;break d}break}case 27:case 26:case 25:case 24:case 22:break;case 23:{c[l>>2]=(c[l>>2]|0)+2;switch(c[o>>2]|0){case 18:break;case 41:{c[o>>2]=19;s=77;continue d;break}default:{s=77;continue d}}if((c[l>>2]|0)==(c[m>>2]|0)){s=97;break d}c[o>>2]=41;g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))x=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else x=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(x|0){case 5:{s=105;break d;break}case 6:{s=108;break d;break}case 7:{s=111;break d;break}case 29:{if(!(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){s=103;break d}break}case 27:case 26:case 25:case 24:case 22:break;default:{c[o>>2]=19;s=77;continue d}}c[l>>2]=(c[l>>2]|0)+2;s=77;continue d;break}default:{s=125;break d}}c[l>>2]=(c[l>>2]|0)+2;s=77}switch(s|0){case 83:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 85:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 88:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 91:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 94:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=c[o>>2];break a;break}case 97:{c[j>>2]=-1;break a;break}case 103:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 105:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 108:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 111:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 116:{g=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=g;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=g+2;c[j>>2]=32;break a}break}case 119:{g=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=g;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=g+2;c[j>>2]=31;break a}break}case 122:{g=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=g;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=g+2;c[j>>2]=30;break a}break}case 125:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 126:{c[j>>2]=0-(c[o>>2]|0);break a;break}}}}else c[j>>2]=-4;while(0);i=h;return c[j>>2]|0}function T_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-4;p=c[j>>2]|0;i=h;return p|0}c[o>>2]=(c[m>>2]|0)-(c[l>>2]|0);do if(c[o>>2]&1){c[o>>2]=c[o>>2]&-2;if(c[o>>2]|0){c[m>>2]=(c[l>>2]|0)+(c[o>>2]|0);break}c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}while(0);o=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[o+1>>0]|0)>>0]|0;else q=D_(a[o>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;a:do switch(q|0){case 2:{c[j>>2]=l$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;p=c[j>>2]|0;i=h;return p|0}case 3:{c[j>>2]=h$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;p=c[j>>2]|0;i=h;return p|0}case 9:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-3;p=c[j>>2]|0;i=h;return p|0}o=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))r=d[(c[k>>2]|0)+76+(d[o+1>>0]|0)>>0]|0;else r=D_(a[o>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;if((r|0)==10)c[l>>2]=(c[l>>2]|0)+2;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;p=c[j>>2]|0;i=h;return p|0}case 10:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=7;p=c[j>>2]|0;i=h;return p|0}case 4:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-5;p=c[j>>2]|0;i=h;return p|0}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==93:0){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-5;p=c[j>>2]|0;i=h;return p|0}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==62:0){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}c[l>>2]=(c[l>>2]|0)+-2}break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=2){c[l>>2]=(c[l>>2]|0)+2;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=3){c[l>>2]=(c[l>>2]|0)+3;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=4){c[l>>2]=(c[l>>2]|0)+4;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 8:case 1:case 0:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}default:c[l>>2]=(c[l>>2]|0)+2}while(0);b:while(1){s=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){t=68;break}r=c[l>>2]|0;if(!(a[s>>0]|0))u=d[(c[k>>2]|0)+76+(d[r+1>>0]|0)>>0]|0;else u=D_(a[r>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(u|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{t=66;break b;break}case 5:{v=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=49;break b}c[l>>2]=v+2;continue b;break}case 6:{w=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=52;break b}c[l>>2]=w+3;continue b;break}case 7:{x=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=55;break b}c[l>>2]=x+4;continue b;break}case 4:{if(((c[l>>2]|0)+2|0)==(c[m>>2]|0)){t=66;break b}if((a[(c[l>>2]|0)+2>>0]|0)==0?(a[(c[l>>2]|0)+2+1>>0]|0)==93:0){if(((c[l>>2]|0)+4|0)==(c[m>>2]|0)){t=66;break b}if((a[(c[l>>2]|0)+4>>0]|0)==0?(a[(c[l>>2]|0)+4+1>>0]|0)==62:0){t=65;break b}c[l>>2]=(c[l>>2]|0)+2;continue b}c[l>>2]=(c[l>>2]|0)+2;continue b;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue b}}}if((t|0)==49){c[c[n>>2]>>2]=v;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==52){c[c[n>>2]>>2]=w;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==55){c[c[n>>2]>>2]=x;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==65){c[c[n>>2]>>2]=(c[l>>2]|0)+4;c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==66){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==68){c[c[n>>2]>>2]=s;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}return 0}function U_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-4;p=c[j>>2]|0;i=h;return p|0}c[o>>2]=(c[m>>2]|0)-(c[l>>2]|0);do if(c[o>>2]&1){c[o>>2]=c[o>>2]&-2;if(c[o>>2]|0){c[m>>2]=(c[l>>2]|0)+(c[o>>2]|0);break}c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}while(0);o=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[o+1>>0]|0)>>0]|0;else q=D_(a[o>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;a:do switch(q|0){case 4:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==93:0){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=40;p=c[j>>2]|0;i=h;return p|0}c[l>>2]=(c[l>>2]|0)+-2}break}case 9:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}o=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))r=d[(c[k>>2]|0)+76+(d[o+1>>0]|0)>>0]|0;else r=D_(a[o>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;if((r|0)==10)c[l>>2]=(c[l>>2]|0)+2;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;p=c[j>>2]|0;i=h;return p|0}case 10:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=7;p=c[j>>2]|0;i=h;return p|0}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=2){c[l>>2]=(c[l>>2]|0)+2;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=3){c[l>>2]=(c[l>>2]|0)+3;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)>=4){c[l>>2]=(c[l>>2]|0)+4;break a}c[j>>2]=-2;p=c[j>>2]|0;i=h;return p|0}case 8:case 1:case 0:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}default:c[l>>2]=(c[l>>2]|0)+2}while(0);b:while(1){s=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){t=57;break}r=c[l>>2]|0;if(!(a[s>>0]|0))u=d[(c[k>>2]|0)+76+(d[r+1>>0]|0)>>0]|0;else u=D_(a[r>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(u|0){case 4:case 10:case 9:case 8:case 1:case 0:{t=55;break b;break}case 5:{v=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=47;break b}c[l>>2]=v+2;continue b;break}case 6:{w=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=50;break b}c[l>>2]=w+3;continue b;break}case 7:{x=c[l>>2]|0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=53;break b}c[l>>2]=x+4;continue b;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue b}}}if((t|0)==47){c[c[n>>2]>>2]=v;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==50){c[c[n>>2]>>2]=w;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==53){c[c[n>>2]>>2]=x;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==55){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}else if((t|0)==57){c[c[n>>2]>>2]=s;c[j>>2]=6;p=c[j>>2]|0;i=h;return p|0}return 0}function V_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=0;c[p>>2]=(c[m>>2]|0)-(c[l>>2]|0);if(c[p>>2]&1){c[p>>2]=c[p>>2]&-2;c[m>>2]=(c[l>>2]|0)+(c[p>>2]|0)}a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){q=39;break}p=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))r=d[(c[k>>2]|0)+76+(d[p+1>>0]|0)>>0]|0;else r=D_(a[p>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(r|0){case 8:case 1:case 0:{q=17;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){q=9;break a}c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){q=12;break a}c[l>>2]=(c[l>>2]|0)+3;continue a;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){q=15;break a}c[l>>2]=(c[l>>2]|0)+4;continue a;break}case 2:{p=(c[l>>2]|0)+2|0;c[l>>2]=p;if((p|0)==(c[m>>2]|0)){q=19;break a}if(a[c[l>>2]>>0]|0)continue a;if((a[(c[l>>2]|0)+1>>0]|0)!=33)continue a;p=(c[l>>2]|0)+2|0;c[l>>2]=p;if((p|0)==(c[m>>2]|0)){q=23;break a}if(a[c[l>>2]>>0]|0)continue a;if((a[(c[l>>2]|0)+1>>0]|0)!=91)continue a;c[o>>2]=(c[o>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 4:{p=(c[l>>2]|0)+2|0;c[l>>2]=p;if((p|0)==(c[m>>2]|0)){q=28;break a}if(a[c[l>>2]>>0]|0)continue a;if((a[(c[l>>2]|0)+1>>0]|0)!=93)continue a;p=(c[l>>2]|0)+2|0;c[l>>2]=p;if((p|0)==(c[m>>2]|0)){q=32;break a}if(a[c[l>>2]>>0]|0)continue a;if((a[(c[l>>2]|0)+1>>0]|0)!=62)continue a;c[l>>2]=(c[l>>2]|0)+2;if(!(c[o>>2]|0)){q=36;break a}c[o>>2]=(c[o>>2]|0)+-1;continue a;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue a}}}switch(q|0){case 9:{c[j>>2]=-2;s=c[j>>2]|0;i=h;return s|0}case 12:{c[j>>2]=-2;s=c[j>>2]|0;i=h;return s|0}case 15:{c[j>>2]=-2;s=c[j>>2]|0;i=h;return s|0}case 17:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}case 19:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}case 23:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}case 28:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}case 32:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}case 36:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=42;s=c[j>>2]|0;i=h;return s|0}case 39:{c[j>>2]=-1;s=c[j>>2]|0;i=h;return s|0}}return 0}function W_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;do if((c[l>>2]|0)!=(c[m>>2]|0)){c[o>>2]=c[l>>2];a:while(1){p=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){q=33;break}g=c[l>>2]|0;if(!(a[p>>0]|0))r=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else r=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(r|0){case 3:{q=12;break a;break}case 2:{q=15;break a;break}case 10:{q=16;break a;break}case 9:{q=19;break a;break}case 21:{q=29;break a;break}case 5:{c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 6:{c[l>>2]=(c[l>>2]|0)+3;continue a;break}case 7:{c[l>>2]=(c[l>>2]|0)+4;continue a;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue a}}}if((q|0)==12)if((c[l>>2]|0)==(c[o>>2]|0)){c[j>>2]=h$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;break}else if((q|0)==15){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((q|0)==16){g=c[l>>2]|0;if((c[l>>2]|0)==(c[o>>2]|0)){c[c[n>>2]>>2]=g+2;c[j>>2]=7;break}else{c[c[n>>2]>>2]=g;c[j>>2]=6;break}}else if((q|0)==19){g=c[l>>2]|0;if((c[l>>2]|0)!=(c[o>>2]|0)){c[c[n>>2]>>2]=g;c[j>>2]=6;break}c[l>>2]=g+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-3;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))s=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else s=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;if((s|0)==10)c[l>>2]=(c[l>>2]|0)+2;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;break}else if((q|0)==29){g=c[l>>2]|0;if((c[l>>2]|0)==(c[o>>2]|0)){c[c[n>>2]>>2]=g+2;c[j>>2]=39;break}else{c[c[n>>2]>>2]=g;c[j>>2]=6;break}}else if((q|0)==33){c[c[n>>2]>>2]=p;c[j>>2]=6;break}}else c[j>>2]=-4;while(0);i=h;return c[j>>2]|0}function X_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-4;q=c[j>>2]|0;i=h;return q|0}c[o>>2]=c[l>>2];a:while(1){r=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){s=32;break}g=c[l>>2]|0;if(!(a[r>>0]|0))t=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else t=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(t|0){case 3:{s=12;break a;break}case 30:{s=15;break a;break}case 10:{s=18;break a;break}case 9:{s=21;break a;break}case 5:{c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 6:{c[l>>2]=(c[l>>2]|0)+3;continue a;break}case 7:{c[l>>2]=(c[l>>2]|0)+4;continue a;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue a}}}if((s|0)==12)if((c[l>>2]|0)==(c[o>>2]|0)){c[j>>2]=h$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;q=c[j>>2]|0;i=h;return q|0}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}else if((s|0)==15)if((c[l>>2]|0)==(c[o>>2]|0)){c[p>>2]=i$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;c[j>>2]=(c[p>>2]|0)==22?0:c[p>>2]|0;q=c[j>>2]|0;i=h;return q|0}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}else if((s|0)==18){p=c[l>>2]|0;if((c[l>>2]|0)==(c[o>>2]|0)){c[c[n>>2]>>2]=p+2;c[j>>2]=7;q=c[j>>2]|0;i=h;return q|0}else{c[c[n>>2]>>2]=p;c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}}else if((s|0)==21){p=c[l>>2]|0;if((c[l>>2]|0)!=(c[o>>2]|0)){c[c[n>>2]>>2]=p;c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}c[l>>2]=p+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-3;q=c[j>>2]|0;i=h;return q|0}m=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))u=d[(c[k>>2]|0)+76+(d[m+1>>0]|0)>>0]|0;else u=D_(a[m>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;if((u|0)==10)c[l>>2]=(c[l>>2]|0)+2;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;q=c[j>>2]|0;i=h;return q|0}else if((s|0)==32){c[c[n>>2]>>2]=r;c[j>>2]=6;q=c[j>>2]|0;i=h;return q|0}return 0}function Y_(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;a:while(1){f=c[k>>2]|0;if(!(a[c[k>>2]>>0]|0))m=d[(c[j>>2]|0)+76+(d[f+1>>0]|0)>>0]|0;else m=D_(a[f>>0]|0,a[(c[k>>2]|0)+1>>0]|0)|0;switch(m|0){case 7:{f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=7;break a}else n=8;break}case 6:{n=8;break}case 5:break;case 27:case 26:case 25:case 24:case 23:case 22:case 29:{f=c[l>>2]|0;c[l>>2]=f+1;e=a[f>>0]|0;f=c[k>>2]|0;c[k>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=15;break a}f=c[l>>2]|0;c[l>>2]=f+1;e=a[f>>0]|0;f=c[k>>2]|0;c[k>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=17;break a}else continue a;break}default:{n=18;break a}}if((n|0)==8?(n=0,f=c[k>>2]|0,c[k>>2]=f+1,e=a[f>>0]|0,f=c[l>>2]|0,c[l>>2]=f+1,(e|0)!=(a[f>>0]|0)):0){n=9;break}f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=11;break}f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){n=13;break}}if((n|0)==7){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==9){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==11){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==13){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==15){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==17){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==18){n=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))p=d[(c[j>>2]|0)+76+(d[n+1>>0]|0)>>0]|0;else p=D_(a[n>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(p|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}default:{c[h>>2]=1;o=c[h>>2]|0;i=g;return o|0}}}return 0}function Z_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+16|0;j=g+8|0;k=g+4|0;l=g;c[g+12>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;while(1){m=(c[j>>2]|0)==(c[k>>2]|0);if(!(a[c[l>>2]>>0]|0)){n=9;break}if(m){n=4;break}if(a[c[j>>2]>>0]|0){n=7;break}if((a[(c[j>>2]|0)+1>>0]|0)!=(a[c[l>>2]>>0]|0)){n=7;break}c[j>>2]=(c[j>>2]|0)+2;c[l>>2]=(c[l>>2]|0)+1}if((n|0)==4){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==7){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==9){c[h>>2]=m&1;o=c[h>>2]|0;i=g;return o|0}return 0}function __(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[g>>2]=b;c[h>>2]=e;c[j>>2]=c[h>>2];a:while(1){e=c[h>>2]|0;if(!(a[c[h>>2]>>0]|0))k=d[(c[g>>2]|0)+76+(d[e+1>>0]|0)>>0]|0;else k=D_(a[e>>0]|0,a[(c[h>>2]|0)+1>>0]|0)|0;switch(k|0){case 5:{c[h>>2]=(c[h>>2]|0)+2;continue a;break}case 6:{c[h>>2]=(c[h>>2]|0)+3;continue a;break}case 7:{c[h>>2]=(c[h>>2]|0)+4;continue a;break}case 27:case 26:case 25:case 24:case 23:case 22:case 29:{c[h>>2]=(c[h>>2]|0)+2;continue a;break}default:break a}}i=f;return (c[h>>2]|0)-(c[j>>2]|0)|0}function $_(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f;c[g>>2]=b;c[h>>2]=e;a:while(1){e=c[h>>2]|0;if(!(a[c[h>>2]>>0]|0))j=d[(c[g>>2]|0)+76+(d[e+1>>0]|0)>>0]|0;else j=D_(a[e>>0]|0,a[(c[h>>2]|0)+1>>0]|0)|0;switch(j|0){case 21:case 9:case 10:break;default:break a}c[h>>2]=(c[h>>2]|0)+2}i=f;return c[h>>2]|0}function a$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=1;c[o>>2]=0;c[p>>2]=0;c[k>>2]=(c[k>>2]|0)+2;a:while(1){g=c[k>>2]|0;if(!(a[c[k>>2]>>0]|0))q=d[(c[j>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[k>>2]|0)+1>>0]|0)|0;b:do switch(q|0){case 5:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=c[k>>2];break}case 6:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=(c[k>>2]|0)+1;break}case 7:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=(c[k>>2]|0)+2;break}case 24:case 22:case 29:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}break}case 12:{if((c[n>>2]|0)!=2){if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]=(c[k>>2]|0)+2;c[n>>2]=2;c[p>>2]=12;break b}if((c[p>>2]|0)==12){c[n>>2]=0;if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+8>>2]=c[k>>2];c[o>>2]=(c[o>>2]|0)+1}break}case 13:{if((c[n>>2]|0)!=2){if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]=(c[k>>2]|0)+2;c[n>>2]=2;c[p>>2]=13;break b}if((c[p>>2]|0)==13){c[n>>2]=0;if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+8>>2]=c[k>>2];c[o>>2]=(c[o>>2]|0)+1}break}case 3:{if((c[o>>2]|0)<(c[l>>2]|0))a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0;break}case 21:{if((c[n>>2]|0)==1){c[n>>2]=0;break b}if(((c[n>>2]|0)==2?(c[o>>2]|0)<(c[l>>2]|0):0)?(a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]|0)!=0:0){if((c[k>>2]|0)!=(c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]|0)){if(!(a[c[k>>2]>>0]|0))r=a[(c[k>>2]|0)+1>>0]|0;else r=-1;if((r|0)==32){if(!(a[(c[k>>2]|0)+2>>0]|0))s=a[(c[k>>2]|0)+2+1>>0]|0;else s=-1;if((s|0)!=32){g=(c[k>>2]|0)+2|0;if(!(a[(c[k>>2]|0)+2>>0]|0))t=d[(c[j>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else t=D_(a[g>>0]|0,a[(c[k>>2]|0)+2+1>>0]|0)|0;if((t|0)!=(c[p>>2]|0))break b}}}a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0}break}case 10:case 9:{if((c[n>>2]|0)==1){c[n>>2]=0;break b}if((c[n>>2]|0)==2?(c[o>>2]|0)<(c[l>>2]|0):0)a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0;break}case 17:case 11:{if((c[n>>2]|0)!=2)break a;break}default:{}}while(0);c[k>>2]=(c[k>>2]|0)+2}i=h;return c[o>>2]|0}function b$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+20|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[e+16>>2]=b;c[g>>2]=d;c[h>>2]=0;c[g>>2]=(c[g>>2]|0)+4;a:do if((a[c[g>>2]>>0]|0)==0?(a[(c[g>>2]|0)+1>>0]|0)==120:0){c[g>>2]=(c[g>>2]|0)+2;while(1){if(!(a[c[g>>2]>>0]|0))l=(a[(c[g>>2]|0)+1>>0]|0)==59;else l=0;if(!(l^1))break a;if(!(a[c[g>>2]>>0]|0))m=a[(c[g>>2]|0)+1>>0]|0;else m=-1;c[j>>2]=m;switch(c[j>>2]|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c[h>>2]=c[h>>2]<<4;c[h>>2]=c[h>>2]|(c[j>>2]|0)-48;break}case 70:case 69:case 68:case 67:case 66:case 65:{c[h>>2]=c[h>>2]<<4;c[h>>2]=(c[h>>2]|0)+(10+((c[j>>2]|0)-65));break}case 102:case 101:case 100:case 99:case 98:case 97:{c[h>>2]=c[h>>2]<<4;c[h>>2]=(c[h>>2]|0)+(10+((c[j>>2]|0)-97));break}default:{}}if((c[h>>2]|0)>=1114112)break;c[g>>2]=(c[g>>2]|0)+2}c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}else o=16;while(0);b:do if((o|0)==16){while(1){o=0;if(!(a[c[g>>2]>>0]|0))p=(a[(c[g>>2]|0)+1>>0]|0)==59;else p=0;if(!(p^1))break b;if(!(a[c[g>>2]>>0]|0))q=a[(c[g>>2]|0)+1>>0]|0;else q=-1;c[k>>2]=q;c[h>>2]=(c[h>>2]|0)*10;c[h>>2]=(c[h>>2]|0)+((c[k>>2]|0)-48);if((c[h>>2]|0)>=1114112)break;c[g>>2]=(c[g>>2]|0)+2;o=16}c[f>>2]=-1;n=c[f>>2]|0;i=e;return n|0}while(0);c[f>>2]=YZ(c[h>>2]|0)|0;n=c[f>>2]|0;i=e;return n|0}function c$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f+12|0;h=f+4|0;j=f;c[f+8>>2]=b;c[h>>2]=d;c[j>>2]=e;a:do switch(((c[j>>2]|0)-(c[h>>2]|0)|0)/2|0|0){case 2:{if((a[(c[h>>2]|0)+2>>0]|0)==0?(a[(c[h>>2]|0)+2+1>>0]|0)==116:0){if(!(a[c[h>>2]>>0]|0))k=a[(c[h>>2]|0)+1>>0]|0;else k=-1;switch(k|0){case 108:{c[g>>2]=60;l=c[g>>2]|0;i=f;return l|0}case 103:{c[g>>2]=62;l=c[g>>2]|0;i=f;return l|0}default:break a}}break}case 3:{if((((((a[c[h>>2]>>0]|0)==0?(a[(c[h>>2]|0)+1>>0]|0)==97:0)?(c[h>>2]=(c[h>>2]|0)+2,(a[c[h>>2]>>0]|0)==0):0)?(a[(c[h>>2]|0)+1>>0]|0)==109:0)?(c[h>>2]=(c[h>>2]|0)+2,(a[c[h>>2]>>0]|0)==0):0)?(a[(c[h>>2]|0)+1>>0]|0)==112:0){c[g>>2]=38;l=c[g>>2]|0;i=f;return l|0}break}case 4:{if(!(a[c[h>>2]>>0]|0))m=a[(c[h>>2]|0)+1>>0]|0;else m=-1;switch(m|0){case 113:{c[h>>2]=(c[h>>2]|0)+2;if(a[c[h>>2]>>0]|0)break a;if((a[(c[h>>2]|0)+1>>0]|0)!=117)break a;c[h>>2]=(c[h>>2]|0)+2;if(a[c[h>>2]>>0]|0)break a;if((a[(c[h>>2]|0)+1>>0]|0)!=111)break a;c[h>>2]=(c[h>>2]|0)+2;if(a[c[h>>2]>>0]|0)break a;if((a[(c[h>>2]|0)+1>>0]|0)!=116)break a;c[g>>2]=34;l=c[g>>2]|0;i=f;return l|0}case 97:{c[h>>2]=(c[h>>2]|0)+2;if(a[c[h>>2]>>0]|0)break a;if((a[(c[h>>2]|0)+1>>0]|0)!=112)break a;c[h>>2]=(c[h>>2]|0)+2;if(a[c[h>>2]>>0]|0)break a;if((a[(c[h>>2]|0)+1>>0]|0)!=111)break a;c[h>>2]=(c[h>>2]|0)+2;if(a[c[h>>2]>>0]|0)break a;if((a[(c[h>>2]|0)+1>>0]|0)!=115)break a;c[g>>2]=39;l=c[g>>2]|0;i=f;return l|0}default:break a}break}default:{}}while(0);c[g>>2]=0;l=c[g>>2]|0;i=f;return l|0}function d$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+16|0;j=h+12|0;k=h+8|0;l=h+4|0;m=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;while(1){if((c[k>>2]|0)>>>0>=(c[l>>2]|0)>>>0)break;g=c[k>>2]|0;if(!(a[c[k>>2]>>0]|0))n=d[(c[j>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else n=D_(a[g>>0]|0,a[(c[k>>2]|0)+1>>0]|0)|0;switch(n|0){case 5:{c[k>>2]=(c[k>>2]|0)+2;break}case 6:{c[k>>2]=(c[k>>2]|0)+3;break}case 7:{c[k>>2]=(c[k>>2]|0)+4;break}case 10:{c[(c[m>>2]|0)+4>>2]=-1;g=c[m>>2]|0;c[g>>2]=(c[g>>2]|0)+1;c[k>>2]=(c[k>>2]|0)+2;break}case 9:{g=c[m>>2]|0;c[g>>2]=(c[g>>2]|0)+1;c[k>>2]=(c[k>>2]|0)+2;if((c[k>>2]|0)!=(c[l>>2]|0)){g=c[k>>2]|0;if(!(a[c[k>>2]>>0]|0))o=d[(c[j>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else o=D_(a[g>>0]|0,a[(c[k>>2]|0)+1>>0]|0)|0;if((o|0)==10)c[k>>2]=(c[k>>2]|0)+2}c[(c[m>>2]|0)+4>>2]=-1;break}default:c[k>>2]=(c[k>>2]|0)+2}g=(c[m>>2]|0)+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function e$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[l>>2]=(c[l>>2]|0)+2;c[m>>2]=(c[m>>2]|0)+-2;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){o=18;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))p=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else p=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(p|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:break;case 21:{if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==9:0){o=9;break a}break}case 22:case 26:{if(!(a[c[l>>2]>>0]|0))q=a[(c[l>>2]|0)+1>>0]|0;else q=-1;if(q&-128)o=13;break}default:o=13}if((o|0)==13){o=0;if(!(a[c[l>>2]>>0]|0))r=a[(c[l>>2]|0)+1>>0]|0;else r=-1;switch(r|0){case 64:case 36:break;default:{o=16;break a}}}c[l>>2]=(c[l>>2]|0)+2}if((o|0)==9){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}else if((o|0)==16){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;s=c[j>>2]|0;i=h;return s|0}else if((o|0)==18){c[j>>2]=1;s=c[j>>2]|0;i=h;return s|0}return 0}function f$(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+32|0;k=j+20|0;l=j+16|0;m=j+12|0;n=j+8|0;o=j+4|0;p=j;q=j+30|0;r=j+29|0;s=j+28|0;c[j+24>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=h;c[o>>2]=c[c[k>>2]>>2];a:while(1){t=c[o>>2]|0;if((c[o>>2]|0)==(c[l>>2]|0)){u=18;break}a[r>>0]=a[t+1>>0]|0;a[s>>0]=a[c[o>>2]>>0]|0;switch(d[s>>0]|0|0){case 0:{if((d[r>>0]|0|0)<128){if((c[c[m>>2]>>2]|0)==(c[n>>2]|0)){u=6;break a}h=a[r>>0]|0;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h}else u=8;break}case 7:case 6:case 5:case 4:case 3:case 2:case 1:{u=8;break}case 219:case 218:case 217:case 216:{if(((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)<4){u=15;break a}c[p>>2]=(((d[s>>0]|0)&3)<<2|(d[r>>0]|0)>>6&3)+1;h=(c[p>>2]>>2|240)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h;h=((d[r>>0]|0)>>2&15|(c[p>>2]&3)<<4|128)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;c[o>>2]=(c[o>>2]|0)+2;a[q>>0]=a[(c[o>>2]|0)+1>>0]|0;h=(((d[r>>0]|0)&3)<<4|((d[c[o>>2]>>0]|0)&3)<<2|(d[q>>0]|0)>>6|128)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h;h=((d[q>>0]|0)&63|128)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;break}default:{if(((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)<3){u=12;break a}h=((d[s>>0]|0)>>4|224)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h;h=(((d[s>>0]|0)&15)<<2|(d[r>>0]|0)>>6|128)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;h=((d[r>>0]|0)&63|128)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h}}if((u|0)==8){u=0;if(((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)<2){u=9;break}h=((d[r>>0]|0)>>6|(d[s>>0]|0)<<2|192)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;h=((d[r>>0]|0)&63|128)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h}c[o>>2]=(c[o>>2]|0)+2}if((u|0)==6){c[c[k>>2]>>2]=c[o>>2];i=j;return}else if((u|0)==9){c[c[k>>2]>>2]=c[o>>2];i=j;return}else if((u|0)==12){c[c[k>>2]>>2]=c[o>>2];i=j;return}else if((u|0)==15){c[c[k>>2]>>2]=c[o>>2];i=j;return}else if((u|0)==18){c[c[k>>2]>>2]=t;i=j;return}}function g$(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+32|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[j+16>>2]=a;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=h;if(((c[l>>2]|0)-(c[c[k>>2]>>2]|0)|0)>((((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)/2|0)<<1|0)?((d[(c[l>>2]|0)+-2>>0]|0)&248|0)==216:0)c[l>>2]=(c[l>>2]|0)+-2;while(1){if((c[c[k>>2]>>2]|0)==(c[l>>2]|0)){o=7;break}if((c[c[m>>2]>>2]|0)==(c[n>>2]|0)){o=7;break}h=((d[c[c[k>>2]>>2]>>0]|0)<<8|(d[(c[c[k>>2]>>2]|0)+1>>0]|0))&65535;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+2;b[f>>1]=h;h=c[k>>2]|0;c[h>>2]=(c[h>>2]|0)+2}if((o|0)==7){i=j;return}}function h$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))o=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else o=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(o|0){case 29:{if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 19:{c[j>>2]=j$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=40;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(q|0){case 5:{p=29;break b;break}case 6:{p=32;break b;break}case 7:{p=35;break b;break}case 18:{p=38;break b;break}case 29:{if(!(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){p=27;break b}break}case 27:case 26:case 25:case 24:case 22:break;default:{p=39;break b}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==27){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==29)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==32)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==35)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==38){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=9;break}else if((p|0)==39){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==40){c[j>>2]=-1;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function i$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))o=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else o=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(o|0){case 29:{if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 30:case 9:case 10:case 21:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=22;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=40;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(q|0){case 5:{p=29;break b;break}case 6:{p=32;break b;break}case 7:{p=35;break b;break}case 18:{p=38;break b;break}case 29:{if(!(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){p=27;break b}break}case 27:case 26:case 25:case 24:case 22:break;default:{p=39;break b}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==27){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==29)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==32)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==35)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==38){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=28;break}else if((p|0)==39){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==40){c[j>>2]=-1;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function j$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==120:0){c[j>>2]=k$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;o=c[j>>2]|0;i=h;return o|0}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))p=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else p=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;g=c[l>>2]|0;if((p|0)!=25){c[c[n>>2]>>2]=g;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}c[l>>2]=g+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0))break a;g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(q|0){case 18:{r=16;break b;break}case 25:break;default:{r=17;break b}}c[l>>2]=(c[l>>2]|0)+2}if((r|0)==16){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=10;o=c[j>>2]|0;i=h;return o|0}else if((r|0)==17){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}}while(0);c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}function k$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))o=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else o=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;g=c[l>>2]|0;if((o+-24|0)>>>0>=2){c[c[n>>2]>>2]=g;c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}c[l>>2]=g+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0))break a;g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(q|0){case 18:{r=13;break b;break}case 24:case 25:break;default:{r=14;break b}}c[l>>2]=(c[l>>2]|0)+2}if((r|0)==13){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=10;p=c[j>>2]|0;i=h;return p|0}else if((r|0)==14){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}}while(0);c[j>>2]=-1;p=c[j>>2]|0;i=h;return p|0}function l$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)==(c[m>>2]|0))c[j>>2]=-1;else{g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))p=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else p=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(p|0){case 29:{if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 16:{g=(c[l>>2]|0)+2|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(q|0){case 27:{c[j>>2]=m$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 20:{c[j>>2]=n$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 15:{c[j>>2]=o$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 17:{c[j>>2]=p$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;c[o>>2]=0;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){r=98;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))s=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else s=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(s|0){case 5:{r=39;break b;break}case 6:{r=42;break b;break}case 7:{r=45;break b;break}case 10:case 9:case 21:{r=69;break b;break}case 11:{r=90;break b;break}case 17:{break b;break}case 29:{if(!(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){r=37;break b}break}case 27:case 26:case 25:case 24:case 22:break;case 23:{if(c[o>>2]|0){r=49;break b}c[o>>2]=1;c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){r=51;break b}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))t=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else t=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(t|0){case 5:{r=59;break b;break}case 6:{r=62;break b;break}case 7:{r=65;break b;break}case 29:{if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){r=57;break b}break}case 24:case 22:break;default:{r=68;break b}}c[l>>2]=(c[l>>2]|0)+2;continue b;break}default:{r=97;break b}}c[l>>2]=(c[l>>2]|0)+2}c:switch(r|0){case 37:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 39:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 42:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 45:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 49:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 51:{c[j>>2]=-1;break a;break}case 57:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 59:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 62:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 65:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 68:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 69:{c[l>>2]=(c[l>>2]|0)+2;d:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){r=89;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))u=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else u=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(u|0){case 11:{r=90;break c;break}case 17:{break c;break}case 29:{r=75;break d;break}case 24:case 22:{break d;break}case 5:{r=78;break d;break}case 6:{r=81;break d;break}case 7:{r=84;break d;break}case 10:case 9:case 21:break;default:{r=88;break d}}c[l>>2]=(c[l>>2]|0)+2}if((r|0)==75){if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}else if((r|0)==78)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((r|0)==81)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((r|0)==84)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((r|0)==88){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((r|0)==89){c[j>>2]=-1;break a}c[l>>2]=(c[l>>2]|0)+2;c[j>>2]=q$(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 97:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 98:{c[j>>2]=-1;break a;break}}if((r|0)==90){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=2;break}c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=4;break}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0}while(0);i=h;return c[j>>2]|0}function m$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==45:0){c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0))break a;g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))o=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else o=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(o|0){case 8:case 1:case 0:{p=20;break b;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){p=12;break b}c[l>>2]=(c[l>>2]|0)+2;continue b;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){p=15;break b}c[l>>2]=(c[l>>2]|0)+3;continue b;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){p=18;break b}c[l>>2]=(c[l>>2]|0)+4;continue b;break}case 27:{g=(c[l>>2]|0)+2|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){p=22;break b}if(a[c[l>>2]>>0]|0)continue b;if((a[(c[l>>2]|0)+1>>0]|0)==45){p=25;break b}else continue b;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue b}}}if((p|0)==12){c[j>>2]=-2;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==15){c[j>>2]=-2;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==18){c[j>>2]=-2;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==20){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==22){c[j>>2]=-1;q=c[j>>2]|0;i=h;return q|0}else if((p|0)==25){g=(c[l>>2]|0)+2|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){c[j>>2]=-1;q=c[j>>2]|0;i=h;return q|0}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=13;q=c[j>>2]|0;i=h;return q|0}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;q=c[j>>2]|0;i=h;return q|0}}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;q=c[j>>2]|0;i=h;return q|0}while(0);c[j>>2]=-1;q=c[j>>2]|0;i=h;return q|0}function n$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+20|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[g+16>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;if(((c[k>>2]|0)-(c[j>>2]|0)|0)<12){c[h>>2]=-1;n=c[h>>2]|0;i=g;return n|0}c[m>>2]=0;while(1){o=c[j>>2]|0;if((c[m>>2]|0)>=6){p=9;break}if(a[o>>0]|0){p=7;break}if((a[(c[j>>2]|0)+1>>0]|0)!=(a[182103+(c[m>>2]|0)>>0]|0)){p=7;break}c[m>>2]=(c[m>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+2}if((p|0)==7){c[c[l>>2]>>2]=c[j>>2];c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else if((p|0)==9){c[c[l>>2]>>2]=o;c[h>>2]=8;n=c[h>>2]|0;i=g;return n|0}return 0}function o$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[p>>2]=c[l>>2];a:do if((c[l>>2]|0)==(c[m>>2]|0))c[j>>2]=-1;else{g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(q|0){case 29:{if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){r=70;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))s=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else s=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(s|0){case 5:{r=28;break b;break}case 6:{r=31;break b;break}case 7:{r=34;break b;break}case 10:case 9:case 21:{r=37;break b;break}case 15:{r=62;break b;break}case 29:{if(!(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){r=26;break b}break}case 27:case 26:case 25:case 24:case 22:break;default:break b}c[l>>2]=(c[l>>2]|0)+2}if((r|0)==26){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==28)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==31)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==34)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==37){g=(r$(c[k>>2]|0,c[p>>2]|0,c[l>>2]|0,o)|0)!=0;f=c[l>>2]|0;if(!g){c[c[n>>2]>>2]=f;c[j>>2]=0;break}c[l>>2]=f+2;c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){r=61;break}f=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))t=d[(c[k>>2]|0)+76+(d[f+1>>0]|0)>>0]|0;else t=D_(a[f>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(t|0){case 8:case 1:case 0:{r=54;break c;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){r=46;break c}c[l>>2]=(c[l>>2]|0)+2;continue c;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){r=49;break c}c[l>>2]=(c[l>>2]|0)+3;continue c;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){r=52;break c}c[l>>2]=(c[l>>2]|0)+4;continue c;break}case 15:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){r=56;break c}if(a[c[l>>2]>>0]|0)continue c;if((a[(c[l>>2]|0)+1>>0]|0)==62){r=59;break c}else continue c;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue c}}}if((r|0)==46){c[j>>2]=-2;break}else if((r|0)==49){c[j>>2]=-2;break}else if((r|0)==52){c[j>>2]=-2;break}else if((r|0)==54){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((r|0)==56){c[j>>2]=-1;break}else if((r|0)==59){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=c[o>>2];break}else if((r|0)==61){c[j>>2]=-1;break}}else if((r|0)==62){f=(r$(c[k>>2]|0,c[p>>2]|0,c[l>>2]|0,o)|0)!=0;g=c[l>>2]|0;if(!f){c[c[n>>2]>>2]=g;c[j>>2]=0;break}c[l>>2]=g+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=c[o>>2];break}}else if((r|0)==70){c[j>>2]=-1;break}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0}while(0);i=h;return c[j>>2]|0}function p$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))o=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else o=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(o|0){case 29:{if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=50;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(q|0){case 5:{p=28;break b;break}case 6:{p=31;break b;break}case 7:{p=34;break b;break}case 10:case 9:case 21:{p=37;break b;break}case 11:{p=48;break b;break}case 29:{if(!(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){p=26;break b}break}case 27:case 26:case 25:case 24:case 22:break;case 23:{c[l>>2]=(c[l>>2]|0)+2;continue b;break}default:{p=49;break b}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==26){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==28)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==31)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==34)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==37){c[l>>2]=(c[l>>2]|0)+2;c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=46;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))r=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else r=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(r|0){case 11:{p=43;break c;break}case 10:case 9:case 21:break;default:{p=44;break c}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==43){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=5;break}else if((p|0)==44){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==46){c[j>>2]=-1;break}}else if((p|0)==48){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=5;break}else if((p|0)==49){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==50){c[j>>2]=-1;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function q$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=0;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){t=115;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))u=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else u=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;b:do switch(u|0){case 5:{t=10;break a;break}case 6:{t=13;break a;break}case 7:{t=16;break a;break}case 29:{if(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))t=9;else{t=8;break a}break}case 27:case 26:case 25:case 24:case 22:{t=9;break}case 23:{if(c[o>>2]|0){t=20;break a}c[o>>2]=1;c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=22;break a}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))v=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else v=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(v|0){case 5:{t=30;break a;break}case 6:{t=33;break a;break}case 7:{t=36;break a;break}case 29:{if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){t=28;break a}break}case 24:case 22:break;default:{t=39;break a}}c[l>>2]=(c[l>>2]|0)+2;continue a;break}case 10:case 9:case 21:{while(1){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=41;break a}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))w=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else w=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;c[p>>2]=w;if((c[p>>2]|0)==14)break b;switch(c[p>>2]|0){case 9:case 10:case 21:break;default:{t=47;break a}}}break}case 14:break;default:{t=114;break a}}while(0);if((t|0)==9){t=0;c[l>>2]=(c[l>>2]|0)+2;continue}c[o>>2]=0;while(1){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=50;break a}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))x=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else x=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;c[q>>2]=x;if((c[q>>2]|0)==12|(c[q>>2]|0)==13)break;switch(c[q>>2]|0){case 9:case 10:case 21:break;default:{t=56;break a}}}c[l>>2]=(c[l>>2]|0)+2;c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){t=59;break a}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))y=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else y=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;c[r>>2]=y;if((c[r>>2]|0)==(c[q>>2]|0))break;switch(c[r>>2]|0){case 8:case 1:case 0:{t=74;break a;break}case 2:{t=79;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=66;break a}c[l>>2]=(c[l>>2]|0)+2;continue c;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=69;break a}c[l>>2]=(c[l>>2]|0)+3;continue c;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=72;break a}c[l>>2]=(c[l>>2]|0)+4;continue c;break}case 3:{c[s>>2]=h$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,l)|0;if((c[s>>2]|0)<=0){t=76;break a}else continue c;break}default:{c[l>>2]=(c[l>>2]|0)+2;continue c}}}c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=82;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))z=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else z=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(z|0){case 11:{t=106;break a;break}case 17:{t=107;break a;break}case 10:case 9:case 21:break;default:{t=87;break a}}d:while(1){c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){t=89;break a}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))A=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else A=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(A|0){case 5:{t=97;break a;break}case 6:{t=100;break a;break}case 7:{t=103;break a;break}case 11:{t=106;break a;break}case 17:{t=107;break a;break}case 10:case 9:case 21:break;case 29:{t=94;break d;break}case 24:case 22:{break d;break}default:{t=113;break a}}}if((t|0)==94?(t=0,(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31)|0)==0):0){t=95;break}c[l>>2]=(c[l>>2]|0)+2}switch(t|0){case 8:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 10:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 13:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 16:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 20:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 22:{c[j>>2]=-1;break}case 28:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 30:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 33:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 36:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 39:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 41:{c[j>>2]=-1;break}case 47:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 50:{c[j>>2]=-1;break}case 56:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 59:{c[j>>2]=-1;break}case 66:{c[j>>2]=-2;break}case 69:{c[j>>2]=-2;break}case 72:{c[j>>2]=-2;break}case 74:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 76:{if(!(c[s>>2]|0))c[c[n>>2]>>2]=c[l>>2];c[j>>2]=c[s>>2];break}case 79:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 82:{c[j>>2]=-1;break}case 87:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 89:{c[j>>2]=-1;break}case 95:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 97:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 100:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 103:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}break}case 106:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=1;break}case 107:{c[l>>2]=(c[l>>2]|0)+2;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break}if((a[c[l>>2]>>0]|0)==0?(a[(c[l>>2]|0)+1>>0]|0)==62:0){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=3;break}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 113:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 114:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 115:{c[j>>2]=-1;break}}i=h;return c[j>>2]|0}function r$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+20|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[g+16>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=0;c[c[l>>2]>>2]=11;if(((c[k>>2]|0)-(c[j>>2]|0)|0)!=6){c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}if(!(a[c[j>>2]>>0]|0))o=a[(c[j>>2]|0)+1>>0]|0;else o=-1;switch(o|0){case 120:break;case 88:{c[m>>2]=1;break}default:{c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}}c[j>>2]=(c[j>>2]|0)+2;if(!(a[c[j>>2]>>0]|0))p=a[(c[j>>2]|0)+1>>0]|0;else p=-1;switch(p|0){case 109:break;case 77:{c[m>>2]=1;break}default:{c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}}c[j>>2]=(c[j>>2]|0)+2;if(!(a[c[j>>2]>>0]|0))q=a[(c[j>>2]|0)+1>>0]|0;else q=-1;switch(q|0){case 108:break;case 76:{c[m>>2]=1;break}default:{c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}}if(c[m>>2]|0){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else{c[c[l>>2]>>2]=12;c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}return 0}function s$(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=h;a:while(1){if((c[n>>2]|0)==(c[o>>2]|0)){r=27;break}h=c[n>>2]|0;if(!(a[c[n>>2]>>0]|0))s=d[(c[m>>2]|0)+76+(d[h+1>>0]|0)>>0]|0;else s=D_(a[h>>0]|0,a[(c[n>>2]|0)+1>>0]|0)|0;c[q>>2]=s;switch(c[q>>2]|0){case 8:case 1:case 0:{r=16;break a;break}case 5:{if(((c[o>>2]|0)-(c[n>>2]|0)|0)<2){r=8;break a}c[n>>2]=(c[n>>2]|0)+2;continue a;break}case 6:{if(((c[o>>2]|0)-(c[n>>2]|0)|0)<3){r=11;break a}c[n>>2]=(c[n>>2]|0)+3;continue a;break}case 7:{if(((c[o>>2]|0)-(c[n>>2]|0)|0)<4){r=14;break a}c[n>>2]=(c[n>>2]|0)+4;continue a;break}case 13:case 12:{c[n>>2]=(c[n>>2]|0)+2;if((c[q>>2]|0)!=(c[l>>2]|0))continue a;else{r=18;break a}break}default:{c[n>>2]=(c[n>>2]|0)+2;continue a}}}if((r|0)==8){c[k>>2]=-2;t=c[k>>2]|0;i=j;return t|0}else if((r|0)==11){c[k>>2]=-2;t=c[k>>2]|0;i=j;return t|0}else if((r|0)==14){c[k>>2]=-2;t=c[k>>2]|0;i=j;return t|0}else if((r|0)==16){c[c[p>>2]>>2]=c[n>>2];c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}else if((r|0)==18){if((c[n>>2]|0)==(c[o>>2]|0)){c[k>>2]=-27;t=c[k>>2]|0;i=j;return t|0}c[c[p>>2]>>2]=c[n>>2];p=c[n>>2]|0;if(!(a[c[n>>2]>>0]|0))u=d[(c[m>>2]|0)+76+(d[p+1>>0]|0)>>0]|0;else u=D_(a[p>>0]|0,a[(c[n>>2]|0)+1>>0]|0)|0;switch(u|0){case 20:case 30:case 11:case 10:case 9:case 21:{c[k>>2]=27;t=c[k>>2]|0;i=j;return t|0}default:{c[k>>2]=0;t=c[k>>2]|0;i=j;return t|0}}}else if((r|0)==27){c[k>>2]=-1;t=c[k>>2]|0;i=j;return t|0}return 0}function t$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))p=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else p=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(p|0){case 27:{c[j>>2]=m$(c[k>>2]|0,(c[l>>2]|0)+2|0,c[m>>2]|0,c[n>>2]|0)|0;o=c[j>>2]|0;i=h;return o|0}case 20:{c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=33;o=c[j>>2]|0;i=h;return o|0}case 24:case 22:{c[l>>2]=(c[l>>2]|0)+2;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){q=26;break}p=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))r=d[(c[k>>2]|0)+76+(d[p+1>>0]|0)>>0]|0;else r=D_(a[p>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(r|0){case 30:{q=16;break a;break}case 10:case 9:case 21:{break a;break}case 24:case 22:break;default:{q=25;break a}}c[l>>2]=(c[l>>2]|0)+2}b:do if((q|0)==16){if(((c[l>>2]|0)+2|0)==(c[m>>2]|0)){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}r=(c[l>>2]|0)+2|0;if(!(a[(c[l>>2]|0)+2>>0]|0))s=d[(c[k>>2]|0)+76+(d[r+1>>0]|0)>>0]|0;else s=D_(a[r>>0]|0,a[(c[l>>2]|0)+2+1>>0]|0)|0;switch(s|0){case 30:case 10:case 9:case 21:break;default:break b}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==25){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==26){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}while(0);c[c[n>>2]>>2]=c[l>>2];c[j>>2]=16;o=c[j>>2]|0;i=h;return o|0}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}}return 0}function u$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))o=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else o=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(o|0){case 29:{if(!(c[93280+((d[181578+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 24:case 22:break;case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}c[l>>2]=(c[l>>2]|0)+2;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=39;break}g=c[l>>2]|0;if(!(a[c[l>>2]>>0]|0))q=d[(c[k>>2]|0)+76+(d[g+1>>0]|0)>>0]|0;else q=D_(a[g>>0]|0,a[(c[l>>2]|0)+1>>0]|0)|0;switch(q|0){case 5:{p=28;break b;break}case 6:{p=31;break b;break}case 7:{p=34;break b;break}case 36:case 30:case 11:case 32:case 21:case 10:case 9:{p=37;break b;break}case 29:{if(!(c[93280+((d[181834+(d[c[l>>2]>>0]|0)>>0]<<3)+(d[(c[l>>2]|0)+1>>0]>>5)<<2)>>2]&1<<(d[(c[l>>2]|0)+1>>0]&31))){p=26;break b}break}case 27:case 26:case 25:case 24:case 22:break;default:{p=38;break b}}c[l>>2]=(c[l>>2]|0)+2}if((p|0)==26){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==28)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==31)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==34)if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break}else{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==37){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=20;break}else if((p|0)==38){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((p|0)==39){c[j>>2]=-20;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function v$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)==(c[m>>2]|0))c[j>>2]=-4;else{b:do switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 12:{c[j>>2]=d0(12,c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 13:{c[j>>2]=d0(13,c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 2:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 16:{c[j>>2]=e0(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 15:{c[j>>2]=$$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 7:case 6:case 5:case 29:case 24:case 22:{c[c[n>>2]>>2]=(c[l>>2]|0)+-1;c[j>>2]=29;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 9:{if(((c[l>>2]|0)+1|0)==(c[m>>2]|0)){c[c[n>>2]>>2]=c[m>>2];c[j>>2]=-15;break a}else p=15;break}case 10:case 21:{p=15;break}case 30:{c[j>>2]=V$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 35:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=38;break a;break}case 20:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=25;break a;break}case 4:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-26;break a}if((a[c[l>>2]>>0]|0)==93){if(((c[l>>2]|0)+1|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}if((a[(c[l>>2]|0)+1>>0]|0)==62){c[c[n>>2]>>2]=(c[l>>2]|0)+2;c[j>>2]=34;break a}}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=26;break a;break}case 31:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=23;break a;break}case 32:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-24;break a}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 33:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=36;break a;break}case 15:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=35;break a;break}case 34:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=37;break a;break}case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=24;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 36:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=21;break a;break}case 11:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=17;break a;break}case 19:{c[j>>2]=f0(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}if(Ob[c[(c[k>>2]|0)+344>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){c[l>>2]=(c[l>>2]|0)+2;c[o>>2]=18;break b}g=(Ob[c[(c[k>>2]|0)+332>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(g){c[l>>2]=f+2;c[o>>2]=19;break b}else{c[c[n>>2]>>2]=f;c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}if(Ob[c[(c[k>>2]|0)+348>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){c[l>>2]=(c[l>>2]|0)+3;c[o>>2]=18;break b}f=(Ob[c[(c[k>>2]|0)+336>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;g=c[l>>2]|0;if(f){c[l>>2]=g+3;c[o>>2]=19;break b}else{c[c[n>>2]>>2]=g;c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}if(Ob[c[(c[k>>2]|0)+352>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){c[l>>2]=(c[l>>2]|0)+4;c[o>>2]=18;break b}g=(Ob[c[(c[k>>2]|0)+340>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(g){c[l>>2]=f+4;c[o>>2]=19;break b}else{c[c[n>>2]>>2]=f;c[j>>2]=0;break a}break}case 24:case 22:{c[o>>2]=18;c[l>>2]=(c[l>>2]|0)+1;break}case 23:case 27:case 26:case 25:{c[o>>2]=19;c[l>>2]=(c[l>>2]|0)+1;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}while(0);if((p|0)==15){c:while(1){p=0;c[l>>2]=(c[l>>2]|0)+1;q=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){p=19;break}switch(d[(c[k>>2]|0)+76+(d[q>>0]|0)>>0]|0){case 10:case 21:{p=15;continue c;break}case 9:break;default:{p=18;break c}}if(((c[l>>2]|0)+1|0)!=(c[m>>2]|0))p=15;else{p=18;break}}if((p|0)==18){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=15;break}else if((p|0)==19){c[c[n>>2]>>2]=q;c[j>>2]=15;break}}d:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=120;break}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{p=69;break d;break}case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=86;break d;break}case 34:{p=110;break d;break}case 33:{p=113;break d;break}case 15:{p=116;break d;break}case 27:case 26:case 25:case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;continue d;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){p=72;break d}f=(Ob[c[(c[k>>2]|0)+332>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;r=c[l>>2]|0;if(!f){p=74;break d}c[l>>2]=r+2;continue d;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){p=77;break d}f=(Ob[c[(c[k>>2]|0)+336>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;s=c[l>>2]|0;if(!f){p=79;break d}c[l>>2]=s+3;continue d;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){p=82;break d}f=(Ob[c[(c[k>>2]|0)+340>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;t=c[l>>2]|0;if(!f){p=84;break d}c[l>>2]=t+4;continue d;break}case 23:{c[l>>2]=(c[l>>2]|0)+1;switch(c[o>>2]|0){case 18:break;case 41:{c[o>>2]=19;continue d;break}default:continue d}if((c[l>>2]|0)==(c[m>>2]|0)){p=89;break d}c[o>>2]=41;switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{p=91;break d;break}case 27:case 26:case 25:case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;continue d;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){p=94;break d}f=(Ob[c[(c[k>>2]|0)+332>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;u=c[l>>2]|0;if(!f){p=96;break d}c[l>>2]=u+2;continue d;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){p=99;break d}f=(Ob[c[(c[k>>2]|0)+336>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;v=c[l>>2]|0;if(!f){p=101;break d}c[l>>2]=v+3;continue d;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){p=104;break d}f=(Ob[c[(c[k>>2]|0)+340>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;w=c[l>>2]|0;if(!f){p=106;break d}c[l>>2]=w+4;continue d;break}default:{c[o>>2]=19;continue d}}break}default:{p=119;break d}}}switch(p|0){case 69:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 72:{c[j>>2]=-2;break a;break}case 74:{c[c[n>>2]>>2]=r;c[j>>2]=0;break a;break}case 77:{c[j>>2]=-2;break a;break}case 79:{c[c[n>>2]>>2]=s;c[j>>2]=0;break a;break}case 82:{c[j>>2]=-2;break a;break}case 84:{c[c[n>>2]>>2]=t;c[j>>2]=0;break a;break}case 86:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=c[o>>2];break a;break}case 89:{c[j>>2]=-1;break a;break}case 91:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 94:{c[j>>2]=-2;break a;break}case 96:{c[c[n>>2]>>2]=u;c[j>>2]=0;break a;break}case 99:{c[j>>2]=-2;break a;break}case 101:{c[c[n>>2]>>2]=v;c[j>>2]=0;break a;break}case 104:{c[j>>2]=-2;break a;break}case 106:{c[c[n>>2]>>2]=w;c[j>>2]=0;break a;break}case 110:{f=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=f;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=f+1;c[j>>2]=32;break a}break}case 113:{f=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=f;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=f+1;c[j>>2]=31;break a}break}case 116:{f=c[l>>2]|0;if((c[o>>2]|0)==19){c[c[n>>2]>>2]=f;c[j>>2]=0;break a}else{c[c[n>>2]>>2]=f+1;c[j>>2]=30;break a}break}case 119:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 120:{c[j>>2]=0-(c[o>>2]|0);break a;break}}}while(0);i=h;return c[j>>2]|0}function w$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-4;o=c[j>>2]|0;i=h;return o|0}a:do switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 2:{c[j>>2]=Y$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;o=c[j>>2]|0;i=h;return o|0}case 3:{c[j>>2]=U$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;o=c[j>>2]|0;i=h;return o|0}case 9:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-3;o=c[j>>2]|0;i=h;return o|0}if((d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0)==10)c[l>>2]=(c[l>>2]|0)+1;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;o=c[j>>2]|0;i=h;return o|0}case 10:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=7;o=c[j>>2]|0;i=h;return o|0}case 4:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-5;o=c[j>>2]|0;i=h;return o|0}if((a[c[l>>2]>>0]|0)==93){c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-5;o=c[j>>2]|0;i=h;return o|0}g=c[l>>2]|0;if((a[c[l>>2]>>0]|0)!=62){c[l>>2]=g+-1;break a}c[c[n>>2]>>2]=g;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;o=c[j>>2]|0;i=h;return o|0}g=(Ob[c[(c[k>>2]|0)+356>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(!g){c[l>>2]=f+2;break a}c[c[n>>2]>>2]=f;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;o=c[j>>2]|0;i=h;return o|0}f=(Ob[c[(c[k>>2]|0)+360>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;g=c[l>>2]|0;if(!f){c[l>>2]=g+3;break a}c[c[n>>2]>>2]=g;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;o=c[j>>2]|0;i=h;return o|0}g=(Ob[c[(c[k>>2]|0)+364>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(!g){c[l>>2]=f+4;break a}c[c[n>>2]>>2]=f;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}case 8:case 1:case 0:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}default:c[l>>2]=(c[l>>2]|0)+1}while(0);b:while(1){p=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){q=60;break}switch(d[(c[k>>2]|0)+76+(d[p>>0]|0)>>0]|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{q=58;break b;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){q=41;break b}if(Ob[c[(c[k>>2]|0)+356>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){q=41;break b}c[l>>2]=(c[l>>2]|0)+2;continue b;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){q=45;break b}if(Ob[c[(c[k>>2]|0)+360>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){q=45;break b}c[l>>2]=(c[l>>2]|0)+3;continue b;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){q=49;break b}if(Ob[c[(c[k>>2]|0)+364>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){q=49;break b}c[l>>2]=(c[l>>2]|0)+4;continue b;break}case 4:{if(((c[l>>2]|0)+1|0)==(c[m>>2]|0)){q=58;break b}f=c[l>>2]|0;if((a[(c[l>>2]|0)+1>>0]|0)!=93){c[l>>2]=f+1;continue b}if((f+2|0)==(c[m>>2]|0)){q=58;break b}r=c[l>>2]|0;if((a[(c[l>>2]|0)+2>>0]|0)==62){q=57;break b}c[l>>2]=r+1;continue b;break}default:{c[l>>2]=(c[l>>2]|0)+1;continue b}}}if((q|0)==41){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==45){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==49){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==57){c[c[n>>2]>>2]=r+2;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==58){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==60){c[c[n>>2]>>2]=p;c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}return 0}function x$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-4;o=c[j>>2]|0;i=h;return o|0}a:do switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 4:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}if((a[c[l>>2]>>0]|0)==93){c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}g=c[l>>2]|0;if((a[c[l>>2]>>0]|0)!=62){c[l>>2]=g+-1;break a}c[c[n>>2]>>2]=g+1;c[j>>2]=40;o=c[j>>2]|0;i=h;return o|0}break}case 9:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}if((d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0)==10)c[l>>2]=(c[l>>2]|0)+1;c[c[n>>2]>>2]=c[l>>2];c[j>>2]=7;o=c[j>>2]|0;i=h;return o|0}case 10:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=7;o=c[j>>2]|0;i=h;return o|0}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;o=c[j>>2]|0;i=h;return o|0}g=(Ob[c[(c[k>>2]|0)+356>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(!g){c[l>>2]=f+2;break a}c[c[n>>2]>>2]=f;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;o=c[j>>2]|0;i=h;return o|0}f=(Ob[c[(c[k>>2]|0)+360>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;g=c[l>>2]|0;if(!f){c[l>>2]=g+3;break a}c[c[n>>2]>>2]=g;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;o=c[j>>2]|0;i=h;return o|0}g=(Ob[c[(c[k>>2]|0)+364>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(!g){c[l>>2]=f+4;break a}c[c[n>>2]>>2]=f;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}case 8:case 1:case 0:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}default:c[l>>2]=(c[l>>2]|0)+1}while(0);b:while(1){p=c[l>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0)){q=51;break}switch(d[(c[k>>2]|0)+76+(d[p>>0]|0)>>0]|0){case 4:case 10:case 9:case 8:case 1:case 0:{q=49;break b;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){q=39;break b}if(Ob[c[(c[k>>2]|0)+356>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){q=39;break b}c[l>>2]=(c[l>>2]|0)+2;continue b;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){q=43;break b}if(Ob[c[(c[k>>2]|0)+360>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){q=43;break b}c[l>>2]=(c[l>>2]|0)+3;continue b;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){q=47;break b}if(Ob[c[(c[k>>2]|0)+364>>2]&127](c[k>>2]|0,c[l>>2]|0)|0){q=47;break b}c[l>>2]=(c[l>>2]|0)+4;continue b;break}default:{c[l>>2]=(c[l>>2]|0)+1;continue b}}}if((q|0)==39){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==43){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==47){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==49){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}else if((q|0)==51){c[c[n>>2]>>2]=p;c[j>>2]=6;o=c[j>>2]|0;i=h;return o|0}return 0}function y$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=0;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=37;break}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 8:case 1:case 0:{p=19;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){p=5;break a}g=(Ob[c[(c[k>>2]|0)+356>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;q=c[l>>2]|0;if(g){p=7;break a}c[l>>2]=q+2;continue a;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){p=10;break a}g=(Ob[c[(c[k>>2]|0)+360>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;r=c[l>>2]|0;if(g){p=12;break a}c[l>>2]=r+3;continue a;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){p=15;break a}g=(Ob[c[(c[k>>2]|0)+364>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;s=c[l>>2]|0;if(g){p=17;break a}c[l>>2]=s+4;continue a;break}case 2:{g=(c[l>>2]|0)+1|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){p=21;break a}if((a[c[l>>2]>>0]|0)!=33)continue a;g=(c[l>>2]|0)+1|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){p=24;break a}if((a[c[l>>2]>>0]|0)!=91)continue a;c[o>>2]=(c[o>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1;continue a;break}case 4:{g=(c[l>>2]|0)+1|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){p=28;break a}if((a[c[l>>2]>>0]|0)!=93)continue a;g=(c[l>>2]|0)+1|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){p=31;break a}if((a[c[l>>2]>>0]|0)!=62)continue a;c[l>>2]=(c[l>>2]|0)+1;if(!(c[o>>2]|0)){p=34;break a}c[o>>2]=(c[o>>2]|0)+-1;continue a;break}default:{c[l>>2]=(c[l>>2]|0)+1;continue a}}}switch(p|0){case 5:{c[j>>2]=-2;t=c[j>>2]|0;i=h;return t|0}case 7:{c[c[n>>2]>>2]=q;c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}case 10:{c[j>>2]=-2;t=c[j>>2]|0;i=h;return t|0}case 12:{c[c[n>>2]>>2]=r;c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}case 15:{c[j>>2]=-2;t=c[j>>2]|0;i=h;return t|0}case 17:{c[c[n>>2]>>2]=s;c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}case 19:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;t=c[j>>2]|0;i=h;return t|0}case 21:{c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}case 24:{c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}case 28:{c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}case 31:{c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}case 34:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=42;t=c[j>>2]|0;i=h;return t|0}case 37:{c[j>>2]=-1;t=c[j>>2]|0;i=h;return t|0}}return 0}function z$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;do if((c[k>>2]|0)!=(c[l>>2]|0)){c[n>>2]=c[k>>2];a:while(1){o=c[k>>2]|0;if((c[k>>2]|0)==(c[l>>2]|0)){p=27;break}switch(d[(c[j>>2]|0)+76+(d[o>>0]|0)>>0]|0|0){case 3:{p=9;break a;break}case 2:{p=12;break a;break}case 10:{p=13;break a;break}case 9:{p=16;break a;break}case 21:{p=23;break a;break}case 5:{c[k>>2]=(c[k>>2]|0)+2;continue a;break}case 6:{c[k>>2]=(c[k>>2]|0)+3;continue a;break}case 7:{c[k>>2]=(c[k>>2]|0)+4;continue a;break}default:{c[k>>2]=(c[k>>2]|0)+1;continue a}}}if((p|0)==9)if((c[k>>2]|0)==(c[n>>2]|0)){c[h>>2]=U$(c[j>>2]|0,(c[k>>2]|0)+1|0,c[l>>2]|0,c[m>>2]|0)|0;break}else{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=6;break}else if((p|0)==12){c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break}else if((p|0)==13){f=c[k>>2]|0;if((c[k>>2]|0)==(c[n>>2]|0)){c[c[m>>2]>>2]=f+1;c[h>>2]=7;break}else{c[c[m>>2]>>2]=f;c[h>>2]=6;break}}else if((p|0)==16){f=c[k>>2]|0;if((c[k>>2]|0)!=(c[n>>2]|0)){c[c[m>>2]>>2]=f;c[h>>2]=6;break}c[k>>2]=f+1;if((c[k>>2]|0)==(c[l>>2]|0)){c[h>>2]=-3;break}if((d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0)==10)c[k>>2]=(c[k>>2]|0)+1;c[c[m>>2]>>2]=c[k>>2];c[h>>2]=7;break}else if((p|0)==23){f=c[k>>2]|0;if((c[k>>2]|0)==(c[n>>2]|0)){c[c[m>>2]>>2]=f+1;c[h>>2]=39;break}else{c[c[m>>2]>>2]=f;c[h>>2]=6;break}}else if((p|0)==27){c[c[m>>2]>>2]=o;c[h>>2]=6;break}}else c[h>>2]=-4;while(0);i=g;return c[h>>2]|0}
function Ul(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;i=i+176|0;f=e+104|0;g=e+88|0;j=e+80|0;k=e+64|0;l=e+48|0;m=e+172|0;n=e+168|0;o=e+164|0;p=e+160|0;q=e+156|0;r=e+152|0;s=e+148|0;t=e+144|0;u=e+140|0;v=e+136|0;w=e+40|0;x=e+32|0;y=e+132|0;z=e+128|0;A=e+16|0;B=e;C=e+124|0;D=e+120|0;E=e+116|0;F=e+112|0;c[n>>2]=b;c[o>>2]=d;c[u>>2]=0;c[y>>2]=0;c[z>>2]=0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[D>>2]=1;c[p>>2]=zA(c[o>>2]|0,c[n>>2]|0)|0;if(!(a[c[p>>2]>>0]|0)){c[m>>2]=0;G=c[m>>2]|0;i=e;return G|0}bH(c[o>>2]|0,E,F);a:while(1){n=c[p>>2]|0;c[l>>2]=w;c[l+4>>2]=x;c[l+8>>2]=t;c[q>>2]=l3(n,126501,l)|0;if((c[q>>2]|0)==2){c[y>>2]=1;c[p>>2]=(c[p>>2]|0)+(c[t>>2]|0);h[A>>3]=+h[w>>3];h[A+8>>3]=+h[x>>3]}n=c[p>>2]|0;c[k>>2]=w;c[k+4>>2]=x;c[k+8>>2]=t;c[q>>2]=l3(n,126513,k)|0;if((c[q>>2]|0)==2){c[z>>2]=1;c[p>>2]=(c[p>>2]|0)+(c[t>>2]|0);h[B>>3]=+h[w>>3];h[B+8>>3]=+h[x>>3]}c[s>>2]=Vl(c[p>>2]|0)|0;c[r>>2]=c[s>>2];if((c[r>>2]|0)<4){H=10;break}if(((c[r>>2]|0)%3|0|0)!=1){H=10;break}c[u>>2]=cK(c[r>>2]<<4)|0;c[v>>2]=c[u>>2];while(1){if(!(c[r>>2]|0))break;n=c[p>>2]|0;c[g>>2]=w;c[g+4>>2]=x;c[g+8>>2]=t;c[q>>2]=l3(n,126584,g)|0;if((c[q>>2]|0)<2){H=16;break a}c[p>>2]=(c[p>>2]|0)+(c[t>>2]|0);h[c[v>>2]>>3]=+h[w>>3];h[(c[v>>2]|0)+8>>3]=+h[x>>3];c[v>>2]=(c[v>>2]|0)+16;c[r>>2]=(c[r>>2]|0)+-1}while(1){n=(r1(a[c[p>>2]>>0]|0)|0)!=0;I=c[p>>2]|0;if(!n)break;c[p>>2]=I+1}if(!(a[I>>0]|0))c[D>>2]=0;else c[p>>2]=(c[p>>2]|0)+1;c[C>>2]=iN(c[o>>2]|0,c[s>>2]|0)|0;if(c[y>>2]|0){c[(c[C>>2]|0)+8>>2]=c[E>>2];n=(c[C>>2]|0)+16|0;c[n>>2]=c[A>>2];c[n+4>>2]=c[A+4>>2];c[n+8>>2]=c[A+8>>2];c[n+12>>2]=c[A+12>>2]}if(c[z>>2]|0){c[(c[C>>2]|0)+12>>2]=c[F>>2];n=(c[C>>2]|0)+32|0;c[n>>2]=c[B>>2];c[n+4>>2]=c[B+4>>2];c[n+8>>2]=c[B+8>>2];c[n+12>>2]=c[B+12>>2]}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[s>>2]|0))break;n=(c[c[C>>2]>>2]|0)+(c[q>>2]<<4)|0;d=(c[u>>2]|0)+(c[q>>2]<<4)|0;c[n>>2]=c[d>>2];c[n+4>>2]=c[d+4>>2];c[n+8>>2]=c[d+8>>2];c[n+12>>2]=c[d+12>>2];c[q>>2]=(c[q>>2]|0)+1}O4(c[u>>2]|0);if(!(c[D>>2]|0)){H=33;break}}if((H|0)==10){SO(c[o>>2]|0);if(!(a[126526]|0)){a[126526]=1;D=c[o>>2]|0;q=wB(c[((c[c[o>>2]>>2]&3|0)==3?D:D+32|0)+28>>2]|0)|0;D=c[o>>2]|0;C=wB(c[((c[c[o>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2]|0)|0;c[j>>2]=q;c[j+4>>2]=C;$z(0,126527,j)|0}c[m>>2]=0;G=c[m>>2]|0;i=e;return G|0}else if((H|0)==16){if(!(a[126526]|0)){a[126526]=1;j=c[o>>2]|0;C=wB(c[((c[c[o>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)|0;j=c[o>>2]|0;q=wB(c[((c[c[o>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)|0;c[f>>2]=C;c[f+4>>2]=q;$z(0,126594,f)|0}O4(c[u>>2]|0);SO(c[o>>2]|0);c[m>>2]=0;G=c[m>>2]|0;i=e;return G|0}else if((H|0)==33){if(c[(c[(c[o>>2]|0)+8>>2]|0)+96>>2]|0)yl(c[o>>2]|0,c[(c[(c[o>>2]|0)+8>>2]|0)+96>>2]|0,140260);if(c[(c[(c[o>>2]|0)+8>>2]|0)+108>>2]|0)yl(c[o>>2]|0,c[(c[(c[o>>2]|0)+8>>2]|0)+108>>2]|0,140256);if(c[(c[(c[o>>2]|0)+8>>2]|0)+100>>2]|0)yl(c[o>>2]|0,c[(c[(c[o>>2]|0)+8>>2]|0)+100>>2]|0,140263);if(c[(c[(c[o>>2]|0)+8>>2]|0)+104>>2]|0)yl(c[o>>2]|0,c[(c[(c[o>>2]|0)+8>>2]|0)+104>>2]|0,140271);c[m>>2]=1;G=c[m>>2]|0;i=e;return G|0}return 0}function Vl(b){b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;h=e+8|0;c[f>>2]=b;c[g>>2]=0;while(1){b=(r1(d[c[f>>2]>>0]|0)|0)!=0;j=c[f>>2]|0;if(b){c[f>>2]=j+1;continue}b=a[j>>0]|0;a[h>>0]=b;a:do if(b<<24>>24){c[g>>2]=(c[g>>2]|0)+1;while(1){j=a[c[f>>2]>>0]|0;a[h>>0]=j;if(!(j&255))break a;if(r1(d[h>>0]|0)|0)break a;if((d[h>>0]|0|0)==59)break a;c[f>>2]=(c[f>>2]|0)+1}}while(0);if(!(r1(d[h>>0]|0)|0))break}i=e;return c[g>>2]|0}function Wl(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3];h[j+8>>3]=+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function Xl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+64|0;g=f+48|0;h=f+44|0;j=f+40|0;k=f+36|0;l=f;m=f+32|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((P3(wB(c[g>>2]|0)|0,145613,7)|0)==0?(Yl(c[g>>2]|0,c[k>>2]|0,l)|0)!=0:0){MC(c[g>>2]|0,175049,280,1)|0;e=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];c[e+16>>2]=c[l+16>>2];c[e+20>>2]=c[l+20>>2];c[e+24>>2]=c[l+24>>2];c[e+28>>2]=c[l+28>>2];Zl(c[h>>2]|0,c[g>>2]|0);zl(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}c[m>>2]=GD(c[g>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;Xl(c[m>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);c[m>>2]=HD(c[m>>2]|0)|0}i=f;return}function Yl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+80|0;f=e+40|0;g=e+72|0;j=e+68|0;k=e+64|0;l=e+60|0;m=e+56|0;n=e+8|0;o=e;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=zA(c[j>>2]|0,c[k>>2]|0)|0;k=c[m>>2]|0;c[f>>2]=n;c[f+4>>2]=n+8;c[f+8>>2]=n+16;c[f+12>>2]=n+16+8;if((l3(k,126642,f)|0)!=4){c[g>>2]=0;p=c[g>>2]|0;i=e;return p|0}if(+h[n+8>>3]>+h[n+16+8>>3]){h[o>>3]=+h[n+8>>3];h[n+8>>3]=+h[n+16+8>>3];h[n+16+8>>3]=+h[o>>3]}o=c[l>>2]|0;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];c[o+12>>2]=c[n+12>>2];c[o+16>>2]=c[n+16>>2];c[o+20>>2]=c[n+20>>2];c[o+24>>2]=c[n+24>>2];c[o+28>>2]=c[n+28>>2];c[g>>2]=1;p=c[g>>2]|0;i=e;return p|0}function Zl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;b=(c[(c[e>>2]|0)+8>>2]|0)+180|0;a=(c[b>>2]|0)+1|0;c[b>>2]=a;c[g>>2]=a;if(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)h=dK(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0,(c[g>>2]|0)+1|0,4,c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)|0;else h=bK((c[g>>2]|0)+1<<2)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]=h;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[g>>2]<<2)>>2]=c[f>>2];LJ(c[f>>2]|0);i=d;return}function _l(a,e,f){a=a|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=a;c[j>>2]=e;c[k>>2]=f;c[l>>2]=b[(c[(c[j>>2]|0)+8>>2]|0)+168>>1];if((c[l>>2]|0)!=1?(d[139e3]|0)==0:0){c[o>>2]=cK(c[l>>2]<<2)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[l>>2]|0))break;c[(c[o>>2]|0)+(c[n>>2]<<2)>>2]=c[j>>2];c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2];c[n>>2]=(c[n>>2]|0)+1}oN(c[h>>2]|0,c[o>>2]|0,0,c[l>>2]|0,+(c[k>>2]|0),+(c[k>>2]|0),50912);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[l>>2]|0))break;c[j>>2]=c[(c[o>>2]|0)+(c[n>>2]<<2)>>2];if(c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0){f=c[j>>2]|0;e=qC(c[((c[c[j>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)|0;AO(e,c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0)}pN(c[j>>2]|0);c[n>>2]=(c[n>>2]|0)+1}O4(c[o>>2]|0);i=g;return}c[m>>2]=c[j>>2];oN(c[h>>2]|0,m,0,1,+(c[k>>2]|0),+(c[k>>2]|0),50912);if(c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0){k=c[j>>2]|0;m=qC(c[((c[c[j>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)|0;AO(m,c[(c[(c[j>>2]|0)+8>>2]|0)+96>>2]|0)}pN(c[j>>2]|0);i=g;return}function $l(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0;f=i;i=i+560|0;j=f+496|0;k=f+548|0;l=f+544|0;m=f+552|0;n=f+540|0;o=f+536|0;p=f+488|0;q=f+532|0;r=f+528|0;s=f+472|0;t=f+440|0;u=f+424|0;v=f+524|0;w=f+520|0;x=f+516|0;y=f+512|0;z=f+360|0;A=f+344|0;B=f+328|0;C=f+296|0;D=f+288|0;E=f+280|0;F=f+272|0;G=f+264|0;H=f+256|0;I=f+240|0;J=f+224|0;K=f+208|0;L=f+192|0;M=f+176|0;N=f+160|0;P=f+144|0;S=f+128|0;T=f+112|0;U=f+96|0;V=f+80|0;W=f+64|0;X=f+48|0;Y=f+32|0;Z=f+16|0;_=f;c[k>>2]=b;c[l>>2]=d;a[m>>0]=e;h[p>>3]=0.0;switch(dM(c[k>>2]|0)|0){case 3:case 1:{c[n>>2]=bK(8)|0;c[o>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2];do if(a[m>>0]|0){c[x>>2]=1;c[r>>2]=4;c[y>>2]=z;h[B+8>>3]=0.0;h[B>>3]=0.0;if(c[(c[o>>2]|0)+40>>2]&2048){zO(C,c[o>>2]|0);c[t>>2]=c[C>>2];c[t+4>>2]=c[C+4>>2];c[t+8>>2]=c[C+8>>2];c[t+12>>2]=c[C+12>>2];c[t+16>>2]=c[C+16>>2];c[t+20>>2]=c[C+20>>2];c[t+24>>2]=c[C+24>>2];c[t+28>>2]=c[C+28>>2];c[z>>2]=c[t>>2];c[z+4>>2]=c[t+4>>2];c[z+8>>2]=c[t+8>>2];c[z+12>>2]=c[t+12>>2];h[z+16>>3]=+h[t+16>>3];h[z+16+8>>3]=+h[t+8>>3];e=z+32|0;d=t+16|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];h[z+48>>3]=+h[t>>3];h[z+48+8>>3]=+h[t+16+8>>3];break}else{h[A>>3]=-+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];h[A+8>>3]=-+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]/2.0;c[z>>2]=c[A>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];h[A>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];d=z+16|0;c[d>>2]=c[A>>2];c[d+4>>2]=c[A+4>>2];c[d+8>>2]=c[A+8>>2];c[d+12>>2]=c[A+12>>2];h[A+8>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]/2.0;d=z+32|0;c[d>>2]=c[A>>2];c[d+4>>2]=c[A+4>>2];c[d+8>>2]=c[A+8>>2];c[d+12>>2]=c[A+12>>2];h[A>>3]=-+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];d=z+48|0;c[d>>2]=c[A>>2];c[d+4>>2]=c[A+4>>2];c[d+8>>2]=c[A+8>>2];c[d+12>>2]=c[A+12>>2];break}}else if((c[(c[o>>2]|0)+8>>2]|0)>=3){c[x>>2]=1;c[r>>2]=c[(c[o>>2]|0)+8>>2];c[y>>2]=c[(c[o>>2]|0)+44>>2];h[B>>3]=+g[c[l>>2]>>2];h[B+8>>3]=+g[(c[l>>2]|0)+4>>2];break}else{c[x>>2]=0;c[r>>2]=8;h[p>>3]=+r2()*.01;break}while(0);c[(c[n>>2]|0)+4>>2]=c[r>>2];o=bK(c[r>>2]<<4)|0;c[c[n>>2]>>2]=o;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[r>>2]|0))break;h[D>>3]=0.0;h[E>>3]=0.0;do if(!(c[x>>2]|0)){h[G>>3]=+Q(+(+(c[q>>2]|0)*6.283185307179586/+(c[r>>2]|0)+ +h[p>>3]));h[H>>3]=+R(+(+(c[q>>2]|0)*6.283185307179586/+(c[r>>2]|0)+ +h[p>>3]));if(a[(c[l>>2]|0)+8>>0]|0){h[s>>3]=+h[G>>3]*(+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3]+ +g[c[l>>2]>>2])/2.0;h[s+8>>3]=+h[H>>3]*(+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]+ +g[(c[l>>2]|0)+4>>2])/2.0;break}else{h[s>>3]=+g[c[l>>2]>>2]*+h[G>>3]*(+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3])/2.0;h[s+8>>3]=+g[(c[l>>2]|0)+4>>2]*+h[H>>3]*+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]/2.0;break}}else{if(!(a[(c[l>>2]|0)+8>>0]|0)){h[s>>3]=+h[(c[y>>2]|0)+(c[q>>2]<<4)>>3]*+h[B>>3];h[s+8>>3]=+h[(c[y>>2]|0)+(c[q>>2]<<4)+8>>3]*+h[B+8>>3];break}o=c[q>>2]|0;if((c[r>>2]|0)!=4){h[F>>3]=+O(+(+h[(c[y>>2]|0)+(o<<4)>>3]*+h[(c[y>>2]|0)+(c[q>>2]<<4)>>3]+ +h[(c[y>>2]|0)+(c[q>>2]<<4)+8>>3]*+h[(c[y>>2]|0)+(c[q>>2]<<4)+8>>3]));h[s>>3]=+h[(c[y>>2]|0)+(c[q>>2]<<4)>>3]*(+h[B>>3]/+h[F>>3]+1.0);h[s+8>>3]=+h[(c[y>>2]|0)+(c[q>>2]<<4)+8>>3]*(+h[B+8>>3]/+h[F>>3]+1.0);break}switch(o|0){case 0:{h[D>>3]=+h[B>>3];h[E>>3]=+h[B+8>>3];break}case 1:{h[D>>3]=-+h[B>>3];h[E>>3]=+h[B+8>>3];break}case 2:{h[D>>3]=-+h[B>>3];h[E>>3]=-+h[B+8>>3];break}case 3:{h[D>>3]=+h[B>>3];h[E>>3]=-+h[B+8>>3];break}default:{}}h[s>>3]=+h[(c[y>>2]|0)+(c[q>>2]<<4)>>3]+ +h[D>>3];h[s+8>>3]=+h[(c[y>>2]|0)+(c[q>>2]<<4)+8>>3]+ +h[E>>3]}while(0);h[(c[c[n>>2]>>2]|0)+((c[r>>2]|0)-(c[q>>2]|0)-1<<4)>>3]=+h[s>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3];h[(c[c[n>>2]>>2]|0)+((c[r>>2]|0)-(c[q>>2]|0)-1<<4)+8>>3]=+h[s+8>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3];c[q>>2]=(c[q>>2]|0)+1}$=c[n>>2]|0;i=f;return $|0}case 2:{c[v>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2];q=(c[v>>2]|0)+16|0;c[t>>2]=c[q>>2];c[t+4>>2]=c[q+4>>2];c[t+8>>2]=c[q+8>>2];c[t+12>>2]=c[q+12>>2];c[t+16>>2]=c[q+16>>2];c[t+20>>2]=c[q+20>>2];c[t+24>>2]=c[q+24>>2];c[t+28>>2]=c[q+28>>2];c[n>>2]=bK(8)|0;c[(c[n>>2]|0)+4>>2]=4;q=bK(64)|0;c[c[n>>2]>>2]=q;q=(c[(c[k>>2]|0)+8>>2]|0)+16|0;c[u>>2]=c[q>>2];c[u+4>>2]=c[q+4>>2];c[u+8>>2]=c[q+8>>2];c[u+12>>2]=c[q+12>>2];q=c[c[n>>2]>>2]|0;aa=+h[t>>3];if(a[(c[l>>2]|0)+8>>0]|0){ba=aa-+g[c[l>>2]>>2];ca=+h[t+8>>3]-+g[(c[l>>2]|0)+4>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];hm(I,ba,ca,j);c[q>>2]=c[I>>2];c[q+4>>2]=c[I+4>>2];c[q+8>>2]=c[I+8>>2];c[q+12>>2]=c[I+12>>2];I=(c[c[n>>2]>>2]|0)+16|0;ca=+h[t>>3]-+g[c[l>>2]>>2];ba=+h[t+16+8>>3]+ +g[(c[l>>2]|0)+4>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];hm(J,ca,ba,j);c[I>>2]=c[J>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];J=(c[c[n>>2]>>2]|0)+32|0;ba=+h[t+16>>3]+ +g[c[l>>2]>>2];ca=+h[t+16+8>>3]+ +g[(c[l>>2]|0)+4>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];hm(K,ba,ca,j);c[J>>2]=c[K>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];c[J+12>>2]=c[K+12>>2];K=(c[c[n>>2]>>2]|0)+48|0;ca=+h[t+16>>3]+ +g[c[l>>2]>>2];ba=+h[t+8>>3]-+g[(c[l>>2]|0)+4>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];hm(L,ca,ba,j);c[K>>2]=c[L>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];$=c[n>>2]|0;i=f;return $|0}else{ba=+h[t+8>>3];L=c[l>>2]|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];im(M,aa,ba,j,L);c[q>>2]=c[M>>2];c[q+4>>2]=c[M+4>>2];c[q+8>>2]=c[M+8>>2];c[q+12>>2]=c[M+12>>2];M=(c[c[n>>2]>>2]|0)+16|0;ba=+h[t>>3];aa=+h[t+16+8>>3];q=c[l>>2]|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];im(N,ba,aa,j,q);c[M>>2]=c[N>>2];c[M+4>>2]=c[N+4>>2];c[M+8>>2]=c[N+8>>2];c[M+12>>2]=c[N+12>>2];N=(c[c[n>>2]>>2]|0)+32|0;aa=+h[t+16>>3];ba=+h[t+16+8>>3];M=c[l>>2]|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];im(P,aa,ba,j,M);c[N>>2]=c[P>>2];c[N+4>>2]=c[P+4>>2];c[N+8>>2]=c[P+8>>2];c[N+12>>2]=c[P+12>>2];P=(c[c[n>>2]>>2]|0)+48|0;ba=+h[t+16>>3];aa=+h[t+8>>3];t=c[l>>2]|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];im(S,ba,aa,j,t);c[P>>2]=c[S>>2];c[P+4>>2]=c[S+4>>2];c[P+8>>2]=c[S+8>>2];c[P+12>>2]=c[S+12>>2];$=c[n>>2]|0;i=f;return $|0}break}case 4:{c[w>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2];c[n>>2]=bK(8)|0;c[(c[n>>2]|0)+4>>2]=4;w=bK(64)|0;c[c[n>>2]>>2]=w;w=(c[(c[k>>2]|0)+8>>2]|0)+16|0;c[u>>2]=c[w>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=c[c[n>>2]>>2]|0;aa=-+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];if(a[(c[l>>2]|0)+8>>0]|0){ba=aa-+g[c[l>>2]>>2];ca=-+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]-+g[(c[l>>2]|0)+4>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];hm(T,ba,ca,j);c[w>>2]=c[T>>2];c[w+4>>2]=c[T+4>>2];c[w+8>>2]=c[T+8>>2];c[w+12>>2]=c[T+12>>2];T=(c[c[n>>2]>>2]|0)+16|0;ca=-+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3]-+g[c[l>>2]>>2];ba=+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]+ +g[(c[l>>2]|0)+4>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];hm(U,ca,ba,j);c[T>>2]=c[U>>2];c[T+4>>2]=c[U+4>>2];c[T+8>>2]=c[U+8>>2];c[T+12>>2]=c[U+12>>2];U=(c[c[n>>2]>>2]|0)+32|0;ba=+h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3]+ +g[c[l>>2]>>2];ca=+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]+ +g[(c[l>>2]|0)+4>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];hm(V,ba,ca,j);c[U>>2]=c[V>>2];c[U+4>>2]=c[V+4>>2];c[U+8>>2]=c[V+8>>2];c[U+12>>2]=c[V+12>>2];V=(c[c[n>>2]>>2]|0)+48|0;ca=+h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3]+ +g[c[l>>2]>>2];ba=-+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]-+g[(c[l>>2]|0)+4>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];hm(W,ca,ba,j);c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];c[V+12>>2]=c[W+12>>2];$=c[n>>2]|0;i=f;return $|0}else{ba=-+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3];W=c[l>>2]|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];im(X,aa,ba,j,W);c[w>>2]=c[X>>2];c[w+4>>2]=c[X+4>>2];c[w+8>>2]=c[X+8>>2];c[w+12>>2]=c[X+12>>2];X=(c[c[n>>2]>>2]|0)+16|0;ba=-+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];aa=+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3];w=c[l>>2]|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];im(Y,ba,aa,j,w);c[X>>2]=c[Y>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];c[X+12>>2]=c[Y+12>>2];Y=(c[c[n>>2]>>2]|0)+32|0;aa=+h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3];ba=+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3];X=c[l>>2]|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];im(Z,aa,ba,j,X);c[Y>>2]=c[Z>>2];c[Y+4>>2]=c[Z+4>>2];c[Y+8>>2]=c[Z+8>>2];c[Y+12>>2]=c[Z+12>>2];Z=(c[c[n>>2]>>2]|0)+48|0;ba=+h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3];aa=-+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3];k=c[l>>2]|0;c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];im(_,ba,aa,j,k);c[Z>>2]=c[_>>2];c[Z+4>>2]=c[_+4>>2];c[Z+8>>2]=c[_+8>>2];c[Z+12>>2]=c[_+12>>2];$=c[n>>2]|0;i=f;return $|0}break}default:{c[n>>2]=0;$=c[n>>2]|0;i=f;return $|0}}return 0}function am(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+144|0;j=h+80|0;k=h+64|0;l=h+128|0;m=h+124|0;n=h+120|0;o=h+104|0;p=h+100|0;q=h+96|0;r=h+48|0;s=h+32|0;t=h+16|0;u=h;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[h+116>>2]=f;c[h+112>>2]=g;g=c[l>>2]|0;f=(c[(c[((c[c[l>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)+8>>2]|0)+16|0;g=(c[(c[l>>2]|0)+8>>2]|0)+16|0;c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];c[j>>2]=c[g>>2];c[j+4>>2]=c[g+4>>2];c[j+8>>2]=c[g+8>>2];c[j+12>>2]=c[g+12>>2];jm(t,k,j);c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];t=c[l>>2]|0;g=(c[(c[((c[c[l>>2]>>2]&3|0)==2?t:t+-32|0)+28>>2]|0)+8>>2]|0)+16|0;t=(c[(c[l>>2]|0)+8>>2]|0)+56|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[j>>2]=c[t>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];c[j+12>>2]=c[t+12>>2];jm(u,k,j);c[s>>2]=c[u>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[q>>2]=-1111;c[p>>2]=-1111;if(!(c[n>>2]|0)){v=c[m>>2]|0;w=c[p>>2]|0;x=c[q>>2]|0;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];c[j>>2]=c[s>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[j+12>>2]=c[s+12>>2];oX(v,k,w,j,x,o)|0;c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];i=h;return}n=c[l>>2]|0;c[p>>2]=c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?n:n+32|0)+28>>2]|0)+8>>2]|0)+288>>2];n=c[l>>2]|0;c[q>>2]=c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0)+8>>2]|0)+288>>2];v=c[m>>2]|0;w=c[p>>2]|0;x=c[q>>2]|0;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];c[j>>2]=c[s>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[j+12>>2]=c[s+12>>2];oX(v,k,w,j,x,o)|0;c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];i=h;return}function bm(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;k=i;i=i+176|0;l=k+96|0;m=k+80|0;n=k+72|0;o=k+64|0;p=k+164|0;q=k+160|0;r=k+156|0;s=k+152|0;t=k+168|0;u=k+144|0;v=k+136|0;w=k+32|0;x=k+128|0;y=k+124|0;z=k+120|0;A=k+116|0;B=k+16|0;C=k;D=k+112|0;c[p>>2]=b;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;a[t>>0]=j;j=(c[(c[q>>2]|0)+8>>2]|0)+144|0;c[u>>2]=c[j>>2];c[u+4>>2]=c[j+4>>2];j=c[u>>2]|0;c[B>>2]=c[j>>2];c[B+4>>2]=c[j+4>>2];c[B+8>>2]=c[j+8>>2];c[B+12>>2]=c[j+12>>2];j=(c[u>>2]|0)+((c[u+4>>2]|0)-1<<4)|0;c[C>>2]=c[j>>2];c[C+4>>2]=c[j+4>>2];c[C+8>>2]=c[j+8>>2];c[C+12>>2]=c[j+12>>2];c[A>>2]=-1111;c[z>>2]=-1111;a:do if(a[t>>0]|0){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[s>>2]|0))break a;if((c[z>>2]|0)==-1111?(j=c[(c[r>>2]|0)+(c[x>>2]<<2)>>2]|0,c[m>>2]=c[j>>2],c[m+4>>2]=c[j+4>>2],c[l>>2]=c[B>>2],c[l+4>>2]=c[B+4>>2],c[l+8>>2]=c[B+8>>2],c[l+12>>2]=c[B+12>>2],(qX(m,l)|0)!=0):0)c[z>>2]=c[x>>2];if((c[A>>2]|0)==-1111?(j=c[(c[r>>2]|0)+(c[x>>2]<<2)>>2]|0,c[m>>2]=c[j>>2],c[m+4>>2]=c[j+4>>2],c[l>>2]=c[C>>2],c[l+4>>2]=c[C+4>>2],c[l+8>>2]=c[C+8>>2],c[l+12>>2]=c[C+12>>2],(qX(m,l)|0)!=0):0)c[A>>2]=c[x>>2];c[x>>2]=(c[x>>2]|0)+1}}while(0);km(c[r>>2]|0,c[s>>2]|0,c[z>>2]|0,c[A>>2]|0,D,y);h[w+8>>3]=0.0;h[w>>3]=0.0;h[w+16+8>>3]=0.0;h[w+16>>3]=0.0;A=c[D>>2]|0;z=c[y>>2]|0;c[l>>2]=c[u>>2];c[l+4>>2]=c[u+4>>2];if((rX(A,z,l,w,v)|0)<0){w=c[q>>2]|0;z=wB(c[((c[c[q>>2]>>2]&3|0)==3?w:w+32|0)+28>>2]|0)|0;w=c[q>>2]|0;A=wB(c[((c[c[q>>2]>>2]&3|0)==2?w:w+-32|0)+28>>2]|0)|0;c[o>>2]=z;c[o+4>>2]=A;$z(1,126658,o)|0;i=k;return}if((d[138998]|0)>1){o=c[24742]|0;A=c[q>>2]|0;z=wB(c[((c[c[q>>2]>>2]&3|0)==3?A:A+32|0)+28>>2]|0)|0;A=c[q>>2]|0;w=wB(c[((c[c[q>>2]>>2]&3|0)==2?A:A+-32|0)+28>>2]|0)|0;c[n>>2]=z;c[n+4>>2]=w;Y2(o,126706,n)|0}n=c[q>>2]|0;jN(c[q>>2]|0,c[((c[c[q>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0,c[v>>2]|0,c[v+4>>2]|0,50912);O4(c[D>>2]|0);D=c[p>>2]|0;p=c[q>>2]|0;c[m>>2]=c[B>>2];c[m+4>>2]=c[B+4>>2];c[m+8>>2]=c[B+8>>2];c[m+12>>2]=c[B+12>>2];c[l>>2]=c[C>>2];c[l+4>>2]=c[C+4>>2];c[l+8>>2]=c[C+8>>2];c[l+12>>2]=c[C+12>>2];sN(D,p,m,l);i=k;return}function cm(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+64|0;g=f+52|0;h=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+20|0;o=f+16|0;p=f+4|0;q=f;c[h>>2]=a;c[j>>2]=d;c[k>>2]=e;hq(p,c[h>>2]|0);c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[l>>2]=$B(c[h>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;c[m>>2]=OA(c[h>>2]|0,c[l>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;iM(c[m>>2]|0);c[m>>2]=QA(c[h>>2]|0,c[m>>2]|0)|0}c[l>>2]=aC(c[h>>2]|0,c[l>>2]|0)|0}c[o>>2]=Nz(50876,c[12989]|0)|0;c[l>>2]=$B(c[h>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;c[m>>2]=OA(c[h>>2]|0,c[l>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;if((c[13795]|0)>1?(c[(c[(c[m>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){p=(c[(c[m>>2]|0)+8>>2]|0)+168|0;b[p>>1]=(b[p>>1]|0)+1<<16>>16}else r=14;if((r|0)==14?(r=0,c[q>>2]=lm(c[o>>2]|0,c[m>>2]|0)|0,(c[q>>2]|0)!=(c[m>>2]|0)):0){p=(c[(c[q>>2]|0)+8>>2]|0)+168|0;b[p>>1]=(b[p>>1]|0)+1<<16>>16;c[(c[(c[m>>2]|0)+8>>2]|0)+172>>2]=c[(c[(c[q>>2]|0)+8>>2]|0)+172>>2];c[(c[(c[q>>2]|0)+8>>2]|0)+172>>2]=c[m>>2]}c[m>>2]=QA(c[h>>2]|0,c[m>>2]|0)|0}c[l>>2]=aC(c[h>>2]|0,c[l>>2]|0)|0}Jz(c[o>>2]|0)|0;if(Hb[c[j>>2]&63](c[h>>2]|0,n,c[k>>2]|0)|0){c[g>>2]=1;s=c[g>>2]|0;i=f;return s|0}else{c[13800]=1;c[g>>2]=0;s=c[g>>2]|0;i=f;return s|0}return 0}function dm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=cm(c[e>>2]|0,26,c[f>>2]|0)|0;i=d;return b|0}function em(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f+4|0;h=f+8|0;j=f;c[g>>2]=b;a[h>>0]=d;c[j>>2]=e[(c[(c[g>>2]|0)+8>>2]|0)+136>>1]&14;if(a[h>>0]|0)fm(c[g>>2]|0)|0;if(!(c[j>>2]|0)){i=f;return}dm(c[g>>2]|0,c[j>>2]|0)|0;i=f;return}function fm(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;g=d+8|0;c[e>>2]=b;a[g>>0]=0;a[g>>0]=nm(c[e>>2]|0)|0;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]=+h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3]*72.0;h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]*72.0;c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}i=d;return a[g>>0]|0}function gm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=b+16|0;e=b+36|0;f=b+32|0;g=b;c[e>>2]=a;BO(c[e>>2]|0);h[g>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]/72.0;h[g+8>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+16+8>>3]/72.0;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;a=c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0;h[a>>3]=+h[a>>3]-+h[g>>3];a=(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[a>>3]=+h[a>>3]-+h[g+8>>3];c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}f=c[e>>2]|0;g=(c[(c[e>>2]|0)+8>>2]|0)+16|0;c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];om(f,d);em(c[e>>2]|0,1);i=b;return}function hm(a,b,d,e){a=a|0;b=+b;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+32|0;g=f+24|0;j=f+16|0;k=f;h[g>>3]=b;h[j>>3]=d;h[k>>3]=+h[g>>3]+ +h[e>>3];h[k+8>>3]=+h[j>>3]+ +h[e+8>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];i=f;return}function im(a,b,d,e,f){a=a|0;b=+b;d=+d;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+48|0;k=j+24|0;l=j+16|0;m=j+32|0;n=j;h[k>>3]=b;h[l>>3]=d;c[m>>2]=f;h[n>>3]=+h[k>>3]*+g[c[m>>2]>>2]+ +h[e>>3];h[n+8>>3]=+h[l>>3]*+g[(c[m>>2]|0)+4>>2]+ +h[e+8>>3];c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];i=j;return}function jm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]+ +h[d>>3];h[f+8>>3]=+h[b+8>>3]+ +h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function km(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h+44|0;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;t=h+4|0;u=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[s>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[k>>2]|0))break;if((c[p>>2]|0)!=(c[l>>2]|0)?(c[p>>2]|0)!=(c[m>>2]|0):0)c[s>>2]=(c[s>>2]|0)+(c[(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)+4>>2]|0);c[p>>2]=(c[p>>2]|0)+1}c[u>>2]=cK(c[s>>2]<<5)|0;c[t>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[k>>2]|0))break;a:do if((c[p>>2]|0)!=(c[l>>2]|0)?(c[p>>2]|0)!=(c[m>>2]|0):0){c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)+4>>2]|0))break a;c[r>>2]=(c[q>>2]|0)+1;if((c[r>>2]|0)>=(c[(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)+4>>2]|0))c[r>>2]=0;g=(c[u>>2]|0)+(c[t>>2]<<5)|0;f=(c[c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]>>2]|0)+(c[q>>2]<<4)|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];f=(c[u>>2]|0)+(c[t>>2]<<5)+16|0;g=(c[c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]>>2]|0)+(c[r>>2]<<4)|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[t>>2]=(c[t>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1}}while(0);c[p>>2]=(c[p>>2]|0)+1}if((c[t>>2]|0)==(c[s>>2]|0)){c[c[n>>2]>>2]=c[u>>2];c[c[o>>2]>>2]=c[s>>2];i=h;return}else La(126962,126969,79,126984)}function lm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+160|0;e=d+152|0;f=d+148|0;g=d+96|0;j=d+32|0;k=d+144|0;l=d+16|0;m=d;c[e>>2]=a;c[f>>2]=b;b=c[f>>2]|0;a=c[f>>2]|0;n=c[f>>2]|0;o=c[((c[c[f>>2]>>2]&3|0)==3?n:n+32|0)+28>>2]|0;if((c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)>>>0<(c[((c[c[f>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)>>>0){c[g>>2]=o;a=g+8|0;b=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];b=c[f>>2]|0;c[g+24>>2]=c[((c[c[f>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];b=g+32|0;a=(c[(c[f>>2]|0)+8>>2]|0)+56|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];p=j+8|0;q=p;r=g;s=q+48|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));t=c[f>>2]|0;u=j+56|0;c[u>>2]=t;v=c[e>>2]|0;w=c[v>>2]|0;x=c[e>>2]|0;y=Hb[w&63](x,j,1)|0;c[k>>2]=y;z=c[k>>2]|0;A=z+56|0;B=c[A>>2]|0;i=d;return B|0}a=c[f>>2]|0;b=c[f>>2]|0;if(o>>>0>(c[((c[c[f>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)>>>0){a=c[f>>2]|0;c[g+24>>2]=c[((c[b>>2]&3|0)==3?a:a+32|0)+28>>2];a=g+32|0;o=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];o=c[f>>2]|0;c[g>>2]=c[((c[c[f>>2]>>2]&3|0)==2?o:o+-32|0)+28>>2];o=g+8|0;a=(c[(c[f>>2]|0)+8>>2]|0)+56|0;c[o>>2]=c[a>>2];c[o+4>>2]=c[a+4>>2];c[o+8>>2]=c[a+8>>2];c[o+12>>2]=c[a+12>>2];p=j+8|0;q=p;r=g;s=q+48|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));t=c[f>>2]|0;u=j+56|0;c[u>>2]=t;v=c[e>>2]|0;w=c[v>>2]|0;x=c[e>>2]|0;y=Hb[w&63](x,j,1)|0;c[k>>2]=y;z=c[k>>2]|0;A=z+56|0;B=c[A>>2]|0;i=d;return B|0}a=(c[b+8>>2]|0)+56|0;c[l>>2]=c[a>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];a=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[m>>2]=c[a>>2];c[m+4>>2]=c[a+4>>2];c[m+8>>2]=c[a+8>>2];c[m+12>>2]=c[a+12>>2];do if(!(+h[m>>3]<+h[l>>3])){if(+h[m>>3]>+h[l>>3]){a=g+8|0;c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];a=g+32|0;c[a>>2]=c[m>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];break}if(+h[m+8>>3]<+h[l+8>>3]){a=g+8|0;c[a>>2]=c[m>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];a=g+32|0;c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];break}a=g+8|0;if(+h[m+8>>3]>+h[l+8>>3]){c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];b=g+32|0;c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];c[b+12>>2]=c[m+12>>2];break}else{b=g+32|0;c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];c[b+12>>2]=c[m+12>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];break}}else{b=g+8|0;c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];c[b+12>>2]=c[m+12>>2];b=g+32|0;c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2]}while(0);l=c[f>>2]|0;m=c[((c[c[f>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0;c[g>>2]=m;c[g+24>>2]=m;p=j+8|0;q=p;r=g;s=q+48|0;do{c[q>>2]=c[r>>2];q=q+4|0;r=r+4|0}while((q|0)<(s|0));t=c[f>>2]|0;u=j+56|0;c[u>>2]=t;v=c[e>>2]|0;w=c[v>>2]|0;x=c[e>>2]|0;y=Hb[w&63](x,j,1)|0;c[k>>2]=y;z=c[k>>2]|0;A=z+56|0;B=c[A>>2]|0;i=d;return B|0}function mm(d,e,f){d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0;j=i;i=i+176|0;k=j+80|0;l=j+64|0;m=j+56|0;n=j+40|0;o=j+32|0;p=j+172|0;q=j+168|0;r=j+164|0;s=j+160|0;t=j+156|0;u=j+152|0;v=j+148|0;w=j+144|0;x=j+140|0;y=j+136|0;z=j+132|0;A=j+128|0;B=j+124|0;C=j+120|0;D=j+112|0;E=j+104|0;F=j+96|0;G=j+16|0;H=j;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[v>>2]=0;c[y>>2]=0;c[A>>2]=0;c[B>>2]=0;c[C>>2]=(c[13795]|0)>1&1;c[j+116>>2]=0;c[D>>2]=0;a:do if((c[r>>2]|0)>=6){c[v>>2]=bK((kB(c[p>>2]|0)|0)<<2)|0;c[s>>2]=$B(c[p>>2]|0)|0;while(1){if(!(c[s>>2]|0))break a;c[w>>2]=$l(c[s>>2]|0,c[q>>2]|0,(c[r>>2]|0)==8&255)|0;if(c[w>>2]|0){c[(c[(c[s>>2]|0)+8>>2]|0)+288>>2]=c[y>>2];f=c[w>>2]|0;e=c[y>>2]|0;c[y>>2]=e+1;c[(c[v>>2]|0)+(e<<2)>>2]=f}else c[(c[(c[s>>2]|0)+8>>2]|0)+288>>2]=-1111;c[s>>2]=aC(c[p>>2]|0,c[s>>2]|0)|0}}else c[v>>2]=0;while(0);c[z>>2]=c[y>>2];do if(c[v>>2]|0){w=Gs(c[v>>2]|0,c[z>>2]|0)|0;c[D>>2]=w;f=c[r>>2]|0;if(w){if((f|0)==8)break;c[A>>2]=mX(c[v>>2]|0,c[z>>2]|0)|0;break}if((f|0)==8){$z(0,126720,o)|0;break}else{I=+g[(c[q>>2]|0)+4>>2];h[n>>3]=+g[c[q>>2]>>2];h[n+8>>3]=I;$z(0,126798,n)|0;break}}while(0);if(a[138998]|0){n=c[24742]|0;if(!((c[D>>2]|0)!=0&(c[r>>2]|0)==8))if(c[A>>2]|0)J=(c[r>>2]|0)==10?145963:126880;else J=126890;else J=126904;c[m>>2]=J;Y2(n,126921,m)|0}b:do if(!(c[A>>2]|0)){if((c[D>>2]|0)!=0&(c[r>>2]|0)==8){yP(c[p>>2]|0,0);c[C>>2]=1}}else{c[s>>2]=$B(c[p>>2]|0)|0;while(1){if(!(c[s>>2]|0))break b;c[t>>2]=OA(c[p>>2]|0,c[s>>2]|0)|0;while(1){if(!(c[t>>2]|0))break;m=(c[(c[t>>2]|0)+8>>2]|0)+144|0;am(E,c[t>>2]|0,c[A>>2]|0,1,c[v>>2]|0,c[z>>2]|0);c[m>>2]=c[E>>2];c[m+4>>2]=c[E+4>>2];c[t>>2]=QA(c[p>>2]|0,c[t>>2]|0)|0}c[s>>2]=aC(c[p>>2]|0,c[s>>2]|0)|0}}while(0);c[s>>2]=$B(c[p>>2]|0)|0;while(1){if(!(c[s>>2]|0))break;c[t>>2]=OA(c[p>>2]|0,c[s>>2]|0)|0;while(1){if(!(c[t>>2]|0))break;E=c[t>>2]|0;c[F>>2]=c[((c[c[t>>2]>>2]&3|0)==2?E:E+-32|0)+28>>2];if((c[C>>2]|0)!=0?(c[(c[(c[t>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0){E=c[p>>2]|0;D=c[t>>2]|0;m=(c[(c[s>>2]|0)+8>>2]|0)+16|0;n=(c[(c[t>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[m>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];c[k+12>>2]=c[n+12>>2];jm(G,l,k);n=(c[(c[F>>2]|0)+8>>2]|0)+16|0;m=(c[(c[t>>2]|0)+8>>2]|0)+56|0;c[l>>2]=c[n>>2];c[l+4>>2]=c[n+4>>2];c[l+8>>2]=c[n+8>>2];c[l+12>>2]=c[n+12>>2];c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];jm(H,l,k);c[l>>2]=c[G>>2];c[l+4>>2]=c[G+4>>2];c[l+8>>2]=c[G+8>>2];c[l+12>>2]=c[G+12>>2];c[k>>2]=c[H>>2];c[k+4>>2]=c[H+4>>2];c[k+8>>2]=c[H+8>>2];c[k+12>>2]=c[H+12>>2];sN(E,D,l,k)}else K=37;c:do if((K|0)==37?(K=0,(b[(c[(c[t>>2]|0)+8>>2]|0)+168>>1]|0)!=0):0){if((c[s>>2]|0)==(c[F>>2]|0)){if(!(c[B>>2]|0)){c[B>>2]=bK(96)|0;D=bK((kB(c[p>>2]|0)|0)+360<<5)|0;c[(c[B>>2]|0)+84>>2]=D}_l(c[B>>2]|0,c[t>>2]|0,c[(c[(c[(c[p>>2]|0)+48>>2]|0)+8>>2]|0)+248>>2]|0);break}if(!(c[A>>2]|0)){TL(c[p>>2]|0,c[t>>2]|0,c[r>>2]|0,50912);break}D=b[(c[(c[t>>2]|0)+8>>2]|0)+168>>1]|0;c[x>>2]=D;c[x>>2]=(a[139e3]|0)!=0?1:D;c[u>>2]=c[t>>2];c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[x>>2]|0))break c;D=c[p>>2]|0;E=c[u>>2]|0;if((c[r>>2]|0)==10)bm(D,E,c[v>>2]|0,c[z>>2]|0,1);else xm(D,E);c[u>>2]=c[(c[(c[u>>2]|0)+8>>2]|0)+172>>2];c[y>>2]=(c[y>>2]|0)+1}}while(0);c[t>>2]=QA(c[p>>2]|0,c[t>>2]|0)|0}c[s>>2]=aC(c[p>>2]|0,c[s>>2]|0)|0}if(c[A>>2]|0)nX(c[A>>2]|0);if(c[B>>2]|0){O4(c[(c[B>>2]|0)+84>>2]|0);O4(c[B>>2]|0)}if(!(c[v>>2]|0)){i=j;return 0}c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[z>>2]|0))break;O4(c[(c[v>>2]|0)+(c[y>>2]<<2)>>2]|0);c[y>>2]=(c[y>>2]|0)+1}O4(c[v>>2]|0);i=j;return 0}function nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;d=i;i=i+80|0;e=d+68|0;f=d+64|0;g=d+48|0;j=d+40|0;k=d+32|0;l=d+24|0;m=d+60|0;n=d+16|0;o=d+8|0;p=d;q=d+56|0;c[f>>2]=b;if((c[(c[f>>2]|0)+48>>2]|0)!=(c[f>>2]|0)){a[e>>0]=0;r=a[e>>0]|0;i=d;return r|0}if(!(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]|0)){a[e>>0]=0;r=a[e>>0]|0;i=d;return r|0}b=(N(~~+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]|0)|0)>=0;s=+(N(~~+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]|0)|0);if(b)if(~~(s+.5))t=10;else t=7;else if(~~(s-.5))t=10;else t=7;do if((t|0)==7){b=(N(~~+h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]|0)|0)>=0;s=+(N(~~+h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]|0)|0);if(b)if(~~(s+.5)){t=10;break}else break;else if(~~(s-.5)){t=10;break}else break}while(0);if((t|0)==10)sm(c[f>>2]|0);if(c[(c[(c[f>>2]|0)+8>>2]|0)+116>>2]&1){h[n>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16+16>>3];h[(c[(c[f>>2]|0)+8>>2]|0)+16+16>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16+16+8>>3];h[(c[(c[f>>2]|0)+8>>2]|0)+16+16+8>>3]=+h[n>>3]}n=c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0;do if((c[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]|0)==2){if(+h[n+64>>3]<=0.0){a[e>>0]=0;r=a[e>>0]|0;i=d;return r|0}h[g>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+64>>3]/+h[(c[(c[f>>2]|0)+8>>2]|0)+16+16>>3];h[j>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+64+8>>3]/+h[(c[(c[f>>2]|0)+8>>2]|0)+16+16+8>>3];if(+h[g>>3]<1.0|+h[j>>3]<1.0)if(+h[g>>3]<+h[j>>3]){h[j>>3]=+h[j>>3]/+h[g>>3];h[g>>3]=1.0;break}else{h[g>>3]=+h[g>>3]/+h[j>>3];h[j>>3]=1.0;break}}else{t=c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0;if((c[n+84>>2]|0)!=5){if((c[t+84>>2]|0)!=1){a[e>>0]=0;r=a[e>>0]|0;i=d;return r|0}h[l>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+16>>3];h[k>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16+16+8>>3]/+h[(c[(c[f>>2]|0)+8>>2]|0)+16+16>>3];if(+h[k>>3]<+h[l>>3]){h[j>>3]=+h[l>>3]/+h[k>>3];h[g>>3]=1.0;break}else{h[g>>3]=+h[k>>3]/+h[l>>3];h[j>>3]=1.0;break}}if(+h[t+64>>3]<=0.0){a[e>>0]=0;r=a[e>>0]|0;i=d;return r|0}h[g>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+64>>3]/+h[(c[(c[f>>2]|0)+8>>2]|0)+16+16>>3];h[j>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+64+8>>3]/+h[(c[(c[f>>2]|0)+8>>2]|0)+16+16+8>>3];if(+h[g>>3]>1.0&+h[j>>3]>1.0){h[o>>3]=+h[g>>3]<+h[j>>3]?+h[g>>3]:+h[j>>3];s=+h[o>>3];h[j>>3]=s;h[g>>3]=s;break}a[e>>0]=0;r=a[e>>0]|0;i=d;return r|0}while(0);if(c[(c[(c[f>>2]|0)+8>>2]|0)+116>>2]&1){h[p>>3]=+h[g>>3];h[g>>3]=+h[j>>3];h[j>>3]=+h[p>>3]}a:do if((c[13795]|0)>1){c[m>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[m>>2]|0))break a;c[q>>2]=OA(c[f>>2]|0,c[m>>2]|0)|0;while(1){if(!(c[q>>2]|0))break;if(c[(c[(c[q>>2]|0)+8>>2]|0)+8>>2]|0)tm(c[q>>2]|0,+h[g>>3],+h[j>>3]);c[q>>2]=QA(c[f>>2]|0,c[q>>2]|0)|0}c[m>>2]=aC(c[f>>2]|0,c[m>>2]|0)|0}}while(0);c[m>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;h[c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]>>3]*+h[g>>3];h[(c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[(c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]*+h[j>>3];c[m>>2]=aC(c[f>>2]|0,c[m>>2]|0)|0}um(c[f>>2]|0,+h[g>>3],+h[j>>3]);a[e>>0]=1;r=a[e>>0]|0;i=d;return r|0}function om(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;c[f>>2]=a;c[g>>2]=1;while(1){if((c[g>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;a=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[g>>2]<<2)>>2]|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];om(a,e);c[g>>2]=(c[g>>2]|0)+1}g=(c[(c[f>>2]|0)+8>>2]|0)+16+16|0;h[g>>3]=+h[g>>3]-+h[b>>3];g=(c[(c[f>>2]|0)+8>>2]|0)+16+16+8|0;h[g>>3]=+h[g>>3]-+h[b+8>>3];g=(c[(c[f>>2]|0)+8>>2]|0)+16|0;h[g>>3]=+h[g>>3]-+h[b>>3];g=(c[(c[f>>2]|0)+8>>2]|0)+16+8|0;h[g>>3]=+h[g>>3]-+h[b+8>>3];i=d;return}function pm(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+16|0;g=f+8|0;h=f;c[f+12>>2]=a;c[g>>2]=d;c[f+4>>2]=e;c[h>>2]=bK(64)|0;e=(c[h>>2]|0)+8|0;d=(c[g>>2]|0)+8|0;a=e+48|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(a|0));c[(c[h>>2]|0)+56>>2]=c[(c[g>>2]|0)+56>>2];b[(c[(c[(c[h>>2]|0)+56>>2]|0)+8>>2]|0)+168>>1]=1;i=f;return c[h>>2]|0}function qm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function rm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;j=f+12|0;k=f+8|0;l=f;c[f+16>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f+4>>2]=e;if((c[c[j>>2]>>2]|0)>>>0>(c[c[k>>2]>>2]|0)>>>0){c[g>>2]=1;m=c[g>>2]|0;i=f;return m|0}if((c[c[j>>2]>>2]|0)>>>0<(c[c[k>>2]>>2]|0)>>>0){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}if((c[(c[j>>2]|0)+24>>2]|0)>>>0>(c[(c[k>>2]|0)+24>>2]|0)>>>0){c[g>>2]=1;m=c[g>>2]|0;i=f;return m|0}if((c[(c[j>>2]|0)+24>>2]|0)>>>0<(c[(c[k>>2]|0)+24>>2]|0)>>>0){c[g>>2]=-1;m=c[g>>2]|0;i=f;return m|0}e=~~(+h[(c[j>>2]|0)+8>>3]-+h[(c[k>>2]|0)+8>>3]);c[l>>2]=e;if(e){c[g>>2]=c[l>>2];m=c[g>>2]|0;i=f;return m|0}e=~~(+h[(c[j>>2]|0)+8+8>>3]-+h[(c[k>>2]|0)+8+8>>3]);c[l>>2]=e;if(e){c[g>>2]=c[l>>2];m=c[g>>2]|0;i=f;return m|0}e=~~(+h[(c[j>>2]|0)+32>>3]-+h[(c[k>>2]|0)+32>>3]);c[l>>2]=e;if(e){c[g>>2]=c[l>>2];m=c[g>>2]|0;i=f;return m|0}else{c[g>>2]=~~(+h[(c[j>>2]|0)+32+8>>3]-+h[(c[k>>2]|0)+32+8>>3]);m=c[g>>2]|0;i=f;return m|0}return 0}function sm(a){a=a|0;var b=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;b=i;i=i+64|0;e=b+32|0;f=b+56|0;g=b+52|0;j=b+48|0;k=b+16|0;l=b;c[f>>2]=a;a=(c[(c[f>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[a>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];h[k>>3]=+h[l>>3]/72.0;h[k+8>>3]=+h[l+8>>3]/72.0;c[g>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;a=c[(c[(c[g>>2]|0)+8>>2]|0)+132>>2]|0;h[a>>3]=+h[a>>3]-+h[k>>3];a=(c[(c[(c[g>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[a>>3]=+h[a>>3]-+h[k+8>>3];if((c[(c[(c[g>>2]|0)+8>>2]|0)+108>>2]|0)!=0?(d[(c[(c[(c[g>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0|0)!=0:0){a=(c[(c[(c[g>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;h[a>>3]=+h[a>>3]-+h[l>>3];a=(c[(c[(c[g>>2]|0)+8>>2]|0)+108>>2]|0)+56+8|0;h[a>>3]=+h[a>>3]-+h[l+8>>3]}c[g>>2]=aC(c[f>>2]|0,c[g>>2]|0)|0}c[g>>2]=$B(c[f>>2]|0)|0;while(1){m=c[f>>2]|0;if(!(c[g>>2]|0))break;c[j>>2]=OA(m,c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;if(c[(c[(c[j>>2]|0)+8>>2]|0)+8>>2]|0){k=c[j>>2]|0;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];vm(k,e)}c[j>>2]=QA(c[f>>2]|0,c[j>>2]|0)|0}c[g>>2]=aC(c[f>>2]|0,c[g>>2]|0)|0}c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];wm(m,e);i=b;return}function tm(a,b,e){a=a|0;b=+b;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f+64|0;j=f+40|0;k=f+32|0;l=f+60|0;m=f+56|0;n=f+52|0;o=f+48|0;p=f+16|0;q=f;c[g>>2]=a;h[j>>3]=b;h[k>>3]=e;a=c[g>>2]|0;h[p>>3]=+h[c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+132>>2]>>3]*(+h[j>>3]-1.0)*72.0;a=c[g>>2]|0;h[p+8>>3]=+h[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]*(+h[k>>3]-1.0)*72.0;a=c[g>>2]|0;h[q>>3]=+h[c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+132>>2]>>3]*(+h[j>>3]-1.0)*72.0;a=c[g>>2]|0;h[q+8>>3]=+h[(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]*(+h[k>>3]-1.0)*72.0;c[o>>2]=c[c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]>>2];c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;c[n>>2]=c[c[o>>2]>>2];c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[(c[o>>2]|0)+4>>2]|0))break;do if((c[l>>2]|0)==0&(c[m>>2]|0)==0){a=c[n>>2]|0;h[a>>3]=+h[a>>3]+ +h[q>>3];a=(c[n>>2]|0)+8|0;h[a>>3]=+h[a>>3]+ +h[q+8>>3]}else{if((c[l>>2]|0)==((c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)-1|0)?(c[m>>2]|0)==((c[(c[o>>2]|0)+4>>2]|0)-1|0):0){a=c[n>>2]|0;h[a>>3]=+h[a>>3]+ +h[p>>3];a=(c[n>>2]|0)+8|0;h[a>>3]=+h[a>>3]+ +h[p+8>>3];break}a=c[n>>2]|0;h[a>>3]=+h[a>>3]*+h[j>>3];a=(c[n>>2]|0)+8|0;h[a>>3]=+h[a>>3]*+h[k>>3]}while(0);c[n>>2]=(c[n>>2]|0)+16;c[m>>2]=(c[m>>2]|0)+1}if(c[(c[o>>2]|0)+8>>2]|0){a=(c[o>>2]|0)+16|0;h[a>>3]=+h[a>>3]+ +h[q>>3];a=(c[o>>2]|0)+16+8|0;h[a>>3]=+h[a>>3]+ +h[q+8>>3]}if(c[(c[o>>2]|0)+12>>2]|0){a=(c[o>>2]|0)+32|0;h[a>>3]=+h[a>>3]+ +h[p>>3];a=(c[o>>2]|0)+32+8|0;h[a>>3]=+h[a>>3]+ +h[p+8>>3]}c[o>>2]=(c[o>>2]|0)+48;c[l>>2]=(c[l>>2]|0)+1}if((c[(c[(c[g>>2]|0)+8>>2]|0)+96>>2]|0)!=0?(d[(c[(c[(c[g>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]|0|0)!=0:0){l=(c[(c[(c[g>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;h[l>>3]=+h[l>>3]*+h[j>>3];j=(c[(c[(c[g>>2]|0)+8>>2]|0)+96>>2]|0)+56+8|0;h[j>>3]=+h[j>>3]*+h[k>>3]}if((c[(c[(c[g>>2]|0)+8>>2]|0)+100>>2]|0)!=0?(d[(c[(c[(c[g>>2]|0)+8>>2]|0)+100>>2]|0)+81>>0]|0|0)!=0:0){k=(c[(c[(c[g>>2]|0)+8>>2]|0)+100>>2]|0)+56|0;h[k>>3]=+h[k>>3]+ +h[p>>3];k=(c[(c[(c[g>>2]|0)+8>>2]|0)+100>>2]|0)+56+8|0;h[k>>3]=+h[k>>3]+ +h[p+8>>3]}if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+104>>2]|0)){i=f;return}if(!(d[(c[(c[(c[g>>2]|0)+8>>2]|0)+104>>2]|0)+81>>0]|0)){i=f;return}p=(c[(c[(c[g>>2]|0)+8>>2]|0)+104>>2]|0)+56|0;h[p>>3]=+h[p>>3]+ +h[q>>3];p=(c[(c[(c[g>>2]|0)+8>>2]|0)+104>>2]|0)+56+8|0;h[p>>3]=+h[p>>3]+ +h[q+8>>3];i=f;return}function um(a,b,e){a=a|0;b=+b;e=+e;var f=0,g=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+20|0;j=f+8|0;k=f;l=f+16|0;c[g>>2]=a;h[j>>3]=b;h[k>>3]=e;a=(c[(c[g>>2]|0)+8>>2]|0)+16+16|0;h[a>>3]=+h[a>>3]*+h[j>>3];a=(c[(c[g>>2]|0)+8>>2]|0)+16+16+8|0;h[a>>3]=+h[a>>3]*+h[k>>3];a=(c[(c[g>>2]|0)+8>>2]|0)+16|0;h[a>>3]=+h[a>>3]*+h[j>>3];a=(c[(c[g>>2]|0)+8>>2]|0)+16+8|0;h[a>>3]=+h[a>>3]*+h[k>>3];if((c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)!=0?(d[(c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0|0)!=0:0){a=(c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;h[a>>3]=+h[a>>3]*+h[j>>3];a=(c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)+56+8|0;h[a>>3]=+h[a>>3]*+h[k>>3]}c[l>>2]=1;while(1){if((c[l>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break;um(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[l>>2]<<2)>>2]|0,+h[j>>3],+h[k>>3]);c[l>>2]=(c[l>>2]|0)+1}i=f;return}function vm(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[l>>2]=c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2];c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0))break;c[k>>2]=c[c[l>>2]>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[l>>2]|0)+4>>2]|0))break;a=c[k>>2]|0;h[a>>3]=+h[a>>3]-+h[b>>3];a=(c[k>>2]|0)+8|0;h[a>>3]=+h[a>>3]-+h[b+8>>3];c[k>>2]=(c[k>>2]|0)+16;c[j>>2]=(c[j>>2]|0)+1}if(c[(c[l>>2]|0)+8>>2]|0){a=(c[l>>2]|0)+16|0;h[a>>3]=+h[a>>3]-+h[b>>3];a=(c[l>>2]|0)+16+8|0;h[a>>3]=+h[a>>3]-+h[b+8>>3]}if(c[(c[l>>2]|0)+12>>2]|0){a=(c[l>>2]|0)+32|0;h[a>>3]=+h[a>>3]-+h[b>>3];a=(c[l>>2]|0)+32+8|0;h[a>>3]=+h[a>>3]-+h[b+8>>3]}c[l>>2]=(c[l>>2]|0)+48;c[g>>2]=(c[g>>2]|0)+1}if((c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0)!=0?(d[(c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]|0|0)!=0:0){g=(c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0)+56|0;h[g>>3]=+h[g>>3]-+h[b>>3];g=(c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0)+56+8|0;h[g>>3]=+h[g>>3]-+h[b+8>>3]}if((c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0)!=0?(d[(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0)+81>>0]|0|0)!=0:0){g=(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0)+56|0;h[g>>3]=+h[g>>3]-+h[b>>3];g=(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0)+56+8|0;h[g>>3]=+h[g>>3]-+h[b+8>>3]}if((c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]|0)!=0?(d[(c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]|0)+81>>0]|0|0)!=0:0){g=(c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]|0)+56|0;h[g>>3]=+h[g>>3]-+h[b>>3];g=(c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]|0)+56+8|0;h[g>>3]=+h[g>>3]-+h[b+8>>3]}if(!(c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]|0)){i=e;return}if(!(d[(c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]|0)+81>>0]|0)){i=e;return}g=(c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]|0)+56|0;h[g>>3]=+h[g>>3]-+h[b>>3];g=(c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]|0)+56+8|0;h[g>>3]=+h[g>>3]-+h[b+8>>3];i=e;return}function wm(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e;g=e+20|0;j=e+16|0;c[g>>2]=a;a=(c[(c[g>>2]|0)+8>>2]|0)+16+16|0;h[a>>3]=+h[a>>3]-+h[b>>3];a=(c[(c[g>>2]|0)+8>>2]|0)+16+16+8|0;h[a>>3]=+h[a>>3]-+h[b+8>>3];a=(c[(c[g>>2]|0)+8>>2]|0)+16|0;h[a>>3]=+h[a>>3]-+h[b>>3];a=(c[(c[g>>2]|0)+8>>2]|0)+16+8|0;h[a>>3]=+h[a>>3]-+h[b+8>>3];if((c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)!=0?(d[(c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]|0|0)!=0:0){a=(c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;h[a>>3]=+h[a>>3]-+h[b>>3];a=(c[(c[(c[g>>2]|0)+8>>2]|0)+12>>2]|0)+56+8|0;h[a>>3]=+h[a>>3]-+h[b+8>>3]}c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break;a=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];wm(a,f);c[j>>2]=(c[j>>2]|0)+1}i=e;return}function xm(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+96|0;f=e+56|0;g=e+40|0;h=e+32|0;j=e+92|0;k=e+88|0;l=e+80|0;m=e+72|0;n=e+16|0;o=e;c[j>>2]=a;c[k>>2]=b;b=(c[(c[k>>2]|0)+8>>2]|0)+144|0;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];b=c[m>>2]|0;c[n>>2]=c[b>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];b=(c[m>>2]|0)+((c[m+4>>2]|0)-1<<4)|0;c[o>>2]=c[b>>2];c[o+4>>2]=c[b+4>>2];c[o+8>>2]=c[b+8>>2];c[o+12>>2]=c[b+12>>2];c[f>>2]=c[m>>2];c[f+4>>2]=c[m+4>>2];iY(f,l);if((d[138998]|0|0)>1){m=c[24742]|0;b=c[k>>2]|0;a=wB(c[((c[c[k>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0;b=c[k>>2]|0;p=wB(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)|0;c[h>>2]=a;c[h+4>>2]=p;Y2(m,126946,h)|0}h=c[k>>2]|0;jN(c[k>>2]|0,c[((c[c[k>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0,c[l>>2]|0,c[l+4>>2]|0,50912);l=c[j>>2]|0;j=c[k>>2]|0;c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];sN(l,j,g,f);i=e;return}function ym(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return 0}function zm(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return 0}function Am(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;j=i;i=i+48|0;k=j+40|0;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;t=j+4|0;u=j;c[j+44>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[u>>2]=0;c[p>>2]=c[c[m>>2]>>2];c[q>>2]=c[(c[m>>2]|0)+4>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[k>>2]|0))break;c[o>>2]=c[(c[n>>2]|0)+(c[s>>2]<<2)>>2];a:do if((d[(c[(c[o>>2]|0)+8>>2]|0)+119>>0]|0|0)>0){c[r>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2];g=c[r>>2]|0;c[r>>2]=g+8;v=+h[g>>3];g=c[p>>2]|0;c[p>>2]=g+8;h[g>>3]=v;g=c[r>>2]|0;c[r>>2]=g+8;v=+h[g>>3];g=c[q>>2]|0;c[q>>2]=g+8;h[g>>3]=v;b:do if((c[l>>2]|0)>2){c[t>>2]=2;while(1){if((c[t>>2]|0)>=(c[l>>2]|0))break b;g=c[r>>2]|0;c[r>>2]=g+8;h[(c[(c[m>>2]|0)+(c[t>>2]<<2)>>2]|0)+(c[s>>2]<<3)>>3]=+h[g>>3];c[t>>2]=(c[t>>2]|0)+1}}while(0);if((d[(c[(c[o>>2]|0)+8>>2]|0)+119>>0]|0|0)>1)c[u>>2]=1}else{v=+r2();g=c[p>>2]|0;c[p>>2]=g+8;h[g>>3]=v;v=+r2();g=c[q>>2]|0;c[q>>2]=g+8;h[g>>3]=v;if((c[l>>2]|0)>2){c[t>>2]=2;while(1){if((c[t>>2]|0)>=(c[l>>2]|0))break a;v=+r2();h[(c[(c[m>>2]|0)+(c[t>>2]<<2)>>2]|0)+(c[s>>2]<<3)>>3]=v;c[t>>2]=(c[t>>2]|0)+1}}}while(0);c[s>>2]=(c[s>>2]|0)+1}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[l>>2]|0))break;at(c[k>>2]|0,c[(c[m>>2]|0)+(c[t>>2]<<2)>>2]|0);c[t>>2]=(c[t>>2]|0)+1}i=j;return c[u>>2]|0}function Bm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;j=d+32|0;k=d+28|0;l=d+24|0;m=d+20|0;n=d+16|0;o=d+12|0;p=d+8|0;q=d+4|0;r=d;c[e>>2]=a;c[f>>2]=b;c[o>>2]=bK(((_(c[f>>2]|0,(c[f>>2]|0)+1|0)|0)/2|0)<<2)|0;c[p>>2]=Mm(c[f>>2]|0,c[f>>2]|0,0.0)|0;c[q>>2]=Mm(c[f>>2]|0,c[f>>2]|0,0.0)|0;b=(c[(c[e>>2]|0)+8>>2]|0)!=0;c[j>>2]=0;a:do if(b)while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break a;c[l>>2]=1;while(1){if((c[l>>2]|0)>=(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)>>2]|0))break;c[k>>2]=c[(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+4>>2]|0)+(c[l>>2]<<2)>>2];s=-1.0/+g[(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+8>>2]|0)+(c[l>>2]<<2)>>2];h[(c[(c[p>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[j>>2]<<3)>>3]=s;h[(c[(c[p>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]=s;c[l>>2]=(c[l>>2]|0)+1}c[j>>2]=(c[j>>2]|0)+1}else while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break a;c[l>>2]=1;while(1){if((c[l>>2]|0)>=(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)>>2]|0))break;c[k>>2]=c[(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+4>>2]|0)+(c[l>>2]<<2)>>2];h[(c[(c[p>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[j>>2]<<3)>>3]=-1.0;h[(c[(c[p>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]=-1.0;c[l>>2]=(c[l>>2]|0)+1}c[j>>2]=(c[j>>2]|0)+1}while(0);c[m>>2]=Pq(c[f>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;if(!(c[m>>2]|0)){O4(c[o>>2]|0);c[o>>2]=0;t=c[p>>2]|0;Nm(t);u=c[q>>2]|0;Nm(u);v=c[o>>2]|0;i=d;return v|0}c[n>>2]=0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;c[k>>2]=c[j>>2];while(1){w=c[j>>2]|0;if((c[k>>2]|0)>=(c[f>>2]|0))break;if((w|0)==(c[k>>2]|0))g[r>>2]=0.0;else g[r>>2]=+h[(c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[j>>2]<<3)>>3]+ +h[(c[(c[q>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]-+h[(c[(c[q>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]*2.0;s=+g[r>>2];m=c[n>>2]|0;c[n>>2]=m+1;g[(c[o>>2]|0)+(m<<2)>>2]=s;c[k>>2]=(c[k>>2]|0)+1}c[j>>2]=w+1}t=c[p>>2]|0;Nm(t);u=c[q>>2]|0;Nm(u);v=c[o>>2]|0;i=d;return v|0}function Cm(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0;e=i;i=i+48|0;f=e+8|0;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e+20|0;q=e+16|0;r=e;c[k>>2]=b;c[l>>2]=d;c[q>>2]=0;if(!(c[(c[k>>2]|0)+8>>2]|0)){c[j>>2]=0;s=c[j>>2]|0;i=e;return s|0}c[p>>2]=Gm(c[k>>2]|0,c[l>>2]|0)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[q>>2]=(c[q>>2]|0)+(c[m>>2]|0);c[o>>2]=1;while(1){if((c[o>>2]|0)>=(c[(c[k>>2]|0)+((c[m>>2]|0)*20|0)>>2]|0))break;c[n>>2]=c[(c[(c[k>>2]|0)+((c[m>>2]|0)*20|0)+4>>2]|0)+(c[o>>2]<<2)>>2];if((c[n>>2]|0)>=(c[m>>2]|0)){d=_(c[m>>2]|0,c[l>>2]|0)|0;t=+(N(~~(+g[(c[p>>2]|0)+(d+(c[n>>2]|0)-(c[q>>2]|0)<<2)>>2]-+g[(c[(c[k>>2]|0)+((c[m>>2]|0)*20|0)+8>>2]|0)+(c[o>>2]<<2)>>2])|0)|0);h[r>>3]=+h[r>>3]+t;d=_(c[m>>2]|0,c[l>>2]|0)|0;g[(c[p>>2]|0)+(d+(c[n>>2]|0)-(c[q>>2]|0)<<2)>>2]=+g[(c[(c[k>>2]|0)+((c[m>>2]|0)*20|0)+8>>2]|0)+(c[o>>2]<<2)>>2]}c[o>>2]=(c[o>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}if(a[138998]|0){m=c[24742]|0;h[f>>3]=+h[r>>3];Y2(m,126998,f)|0}c[j>>2]=c[p>>2];s=c[j>>2]|0;i=e;return s|0}function Dm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0.0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;h=d+32|0;j=d+28|0;k=d+24|0;l=d+20|0;m=d+16|0;n=d;c[e>>2]=a;c[f>>2]=b;c[l>>2]=bK(((_(c[f>>2]|0,(c[f>>2]|0)+1|0)|0)/2|0)<<2)|0;c[m>>2]=bK(c[f>>2]<<2)|0;Nq(n,c[f>>2]|0);c[k>>2]=0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[f>>2]|0))break;Iq(c[h>>2]|0,c[e>>2]|0,c[f>>2]|0,c[m>>2]|0,n);c[j>>2]=c[h>>2];while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;o=+(c[(c[m>>2]|0)+(c[j>>2]<<2)>>2]|0);b=c[k>>2]|0;c[k>>2]=b+1;g[(c[l>>2]|0)+(b<<2)>>2]=o;c[j>>2]=(c[j>>2]|0)+1}c[h>>2]=(c[h>>2]|0)+1}O4(c[m>>2]|0);Oq(n);i=d;return c[l>>2]|0}function Em(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;d=i;i=i+48|0;e=d+44|0;f=d+40|0;h=d+36|0;j=d+32|0;k=d+28|0;l=d+24|0;m=d+20|0;n=d+16|0;o=d+12|0;p=d+8|0;q=d+4|0;r=d;c[e>>2]=a;c[f>>2]=b;c[l>>2]=c[(c[e>>2]|0)+8>>2];c[m>>2]=0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;c[m>>2]=(c[m>>2]|0)+(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)>>2]|0);c[j>>2]=(c[j>>2]|0)+1}c[n>>2]=bK(c[m>>2]<<2)|0;c[o>>2]=bK(c[f>>2]<<2)|0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;c[(c[o>>2]|0)+(c[j>>2]<<2)>>2]=0;c[j>>2]=(c[j>>2]|0)+1}m=(c[(c[e>>2]|0)+8>>2]|0)!=0;c[j>>2]=0;if(m){while(1){s=c[e>>2]|0;if((c[j>>2]|0)>=(c[f>>2]|0))break;ss(s,c[j>>2]|0,c[o>>2]|0);c[p>>2]=(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)>>2]|0)-1;c[k>>2]=1;while(1){if((c[k>>2]|0)>(c[p>>2]|0))break;c[r>>2]=c[(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+4>>2]|0)+(c[k>>2]<<2)>>2];c[q>>2]=(c[(c[e>>2]|0)+((c[r>>2]|0)*20|0)>>2]|0)-1;m=(c[p>>2]|0)+(c[q>>2]|0)|0;t=+(m-((rs(c[e>>2]|0,c[j>>2]|0,c[r>>2]|0,c[o>>2]|0)|0)<<1)|0);if(t>+g[(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+8>>2]|0)+(c[k>>2]<<2)>>2]){m=(c[p>>2]|0)+(c[q>>2]|0)|0;u=+(m-((rs(c[e>>2]|0,c[j>>2]|0,c[r>>2]|0,c[o>>2]|0)|0)<<1)|0)}else u=+g[(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+8>>2]|0)+(c[k>>2]<<2)>>2];g[(c[n>>2]|0)+(c[k>>2]<<2)>>2]=u;c[k>>2]=(c[k>>2]|0)+1}ts(c[e>>2]|0,c[j>>2]|0,c[o>>2]|0);c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+8>>2]=c[n>>2];c[n>>2]=(c[n>>2]|0)+(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)>>2]<<2);c[j>>2]=(c[j>>2]|0)+1}c[h>>2]=Gm(s,c[f>>2]|0)|0}else{while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+8>>2]=c[n>>2];ss(c[e>>2]|0,c[j>>2]|0,c[o>>2]|0);c[p>>2]=(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)>>2]|0)-1;c[k>>2]=1;while(1){if((c[k>>2]|0)>(c[p>>2]|0))break;c[r>>2]=c[(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+4>>2]|0)+(c[k>>2]<<2)>>2];c[q>>2]=(c[(c[e>>2]|0)+((c[r>>2]|0)*20|0)>>2]|0)-1;u=+(c[p>>2]|0)+ +(c[q>>2]|0);t=u-+((rs(c[e>>2]|0,c[j>>2]|0,c[r>>2]|0,c[o>>2]|0)|0)<<1|0);g[(c[n>>2]|0)+(c[k>>2]<<2)>>2]=t;c[k>>2]=(c[k>>2]|0)+1}ts(c[e>>2]|0,c[j>>2]|0,c[o>>2]|0);c[n>>2]=(c[n>>2]|0)+(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)>>2]<<2);c[j>>2]=(c[j>>2]|0)+1}c[h>>2]=Dm(c[e>>2]|0,c[f>>2]|0)|0}O4(c[o>>2]|0);O4(c[(c[e>>2]|0)+8>>2]|0);c[(c[e>>2]|0)+8>>2]=0;if(!(c[l>>2]|0)){v=c[h>>2]|0;i=d;return v|0}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)+8>>2]=c[l>>2];c[l>>2]=(c[l>>2]|0)+(c[(c[e>>2]|0)+((c[j>>2]|0)*20|0)>>2]<<2);c[j>>2]=(c[j>>2]|0)+1}v=c[h>>2]|0;i=d;return v|0}function Fm(b,e,f,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0.0,xa=0,ya=0,za=0,Aa=0.0;p=i;i=i+336|0;q=p+168|0;r=p+160|0;s=p+152|0;t=p+144|0;u=p+136|0;v=p+128|0;w=p+120|0;x=p+112|0;y=p+104|0;z=p+96|0;A=p+88|0;B=p+80|0;C=p+72|0;D=p+64|0;E=p+56|0;F=p+320|0;G=p+316|0;H=p+312|0;I=p+308|0;J=p+304|0;K=p+300|0;L=p+296|0;M=p+292|0;O=p+288|0;P=p+284|0;Q=p+280|0;R=p+48|0;S=p+276|0;T=p+272|0;U=p+268|0;V=p+264|0;W=p+260|0;X=p+256|0;Y=p+252|0;Z=p+248|0;$=p+40|0;aa=p+244|0;ba=p+240|0;ca=p+236|0;da=p+232|0;ea=p+228|0;fa=p+32|0;ga=p+24|0;ha=p+324|0;ia=p+224|0;ja=p+220|0;ka=p+216|0;la=p+212|0;ma=p+208|0;na=p+204|0;oa=p+200|0;pa=p+196|0;qa=p+16|0;ra=p+8|0;sa=p;ta=p+192|0;c[G>>2]=b;c[H>>2]=e;c[I>>2]=f;c[J>>2]=j;c[K>>2]=k;c[L>>2]=l;c[M>>2]=m;c[O>>2]=n;c[P>>2]=o;h[R>>3]=.001;c[S>>2]=0;c[W>>2]=0;c[X>>2]=0;c[ba>>2]=0;c[ca>>2]=0;c[ia>>2]=0;c[ja>>2]=0;c[ka>>2]=0;c[la>>2]=0;c[ma>>2]=c[M>>2]&4;c[na>>2]=c[M>>2]&3;if((c[P>>2]|0)<0){c[F>>2]=0;ua=c[F>>2]|0;i=p;return ua|0}if(a[138998]|0)_N();do if((c[O>>2]|0)!=2){if((c[O>>2]|0)==1){c[S>>2]=Bm(c[G>>2]|0,c[H>>2]|0)|0;if(c[S>>2]|0)break;$z(0,130723,D)|0;$z(3,130772,C)|0;break}if((c[O>>2]|0)==3){if(a[138998]|0)Y2(c[24742]|0,130825,B)|0;c[S>>2]=Cm(c[G>>2]|0,c[H>>2]|0)|0}}else{if(a[138998]|0)Y2(c[24742]|0,130698,E)|0;c[S>>2]=Em(c[G>>2]|0,c[H>>2]|0)|0}while(0);do if(!(c[S>>2]|0)){if(a[138998]|0)Y2(c[24742]|0,130847,A)|0;E=c[G>>2]|0;B=c[H>>2]|0;if(c[(c[G>>2]|0)+8>>2]|0){c[S>>2]=Gm(E,B)|0;break}else{c[S>>2]=Dm(E,B)|0;break}}while(0);if(a[138998]|0){A=c[24742]|0;h[z>>3]=+$N();Y2(A,130874,z)|0;Y2(c[24742]|0,130886,y)|0;_N()}a:do if((c[ma>>2]|0)!=0&(c[H>>2]|0)>1){c[pa>>2]=0;if((Hm(c[G>>2]|0,c[H>>2]|0,c[I>>2]|0,c[J>>2]|0,c[L>>2]|0,c[ma>>2]|0,c[na>>2]|0,(c[O>>2]|0)==2&1,50,0,40)|0)<0){c[Q>>2]=-1;break}c[T>>2]=0;while(1){if((c[T>>2]|0)>=(c[L>>2]|0)){va=42;break a}h[qa>>3]=1.0;c[U>>2]=0;while(1){if((c[U>>2]|0)>=(c[H>>2]|0))break;wa=+N(+(+h[(c[(c[J>>2]|0)+(c[T>>2]<<2)>>2]|0)+(c[U>>2]<<3)>>3]));if(wa>+h[qa>>3])h[qa>>3]=+N(+(+h[(c[(c[J>>2]|0)+(c[T>>2]<<2)>>2]|0)+(c[U>>2]<<3)>>3]));c[U>>2]=(c[U>>2]|0)+1}c[U>>2]=0;while(1){if((c[U>>2]|0)>=(c[H>>2]|0))break;y=(c[(c[J>>2]|0)+(c[T>>2]<<2)>>2]|0)+(c[U>>2]<<3)|0;h[y>>3]=+h[y>>3]/+h[qa>>3];c[U>>2]=(c[U>>2]|0)+1}c[U>>2]=0;while(1){if((c[U>>2]|0)>=(c[H>>2]|0))break;wa=(+r2()-.5)*1.0e-06;y=(c[(c[J>>2]|0)+(c[T>>2]<<2)>>2]|0)+(c[U>>2]<<3)|0;h[y>>3]=+h[y>>3]+wa;c[U>>2]=(c[U>>2]|0)+1}at(c[H>>2]|0,c[(c[J>>2]|0)+(c[T>>2]<<2)>>2]|0);c[T>>2]=(c[T>>2]|0)+1}}else{c[pa>>2]=Am(c[G>>2]|0,c[H>>2]|0,c[L>>2]|0,c[J>>2]|0,c[K>>2]|0)|0;va=42}while(0);b:do if((va|0)==42){if(a[138998]|0){G=c[24742]|0;h[x>>3]=+$N();Y2(G,130912,x)|0}if((c[H>>2]|0)==1|(c[P>>2]|0)==0){c[F>>2]=0;ua=c[F>>2]|0;i=p;return ua|0}if(a[138998]|0){G=c[24742]|0;h[w>>3]=+$N();Y2(G,130874,w)|0;Y2(c[24742]|0,127020,v)|0;_N()}c[W>>2]=bK(c[L>>2]<<2)|0;c[X>>2]=bK((_(c[L>>2]|0,c[H>>2]|0)|0)<<2)|0;c[T>>2]=0;while(1){if((c[T>>2]|0)>=(c[L>>2]|0))break;G=(c[X>>2]|0)+((_(c[T>>2]|0,c[H>>2]|0)|0)<<2)|0;c[(c[W>>2]|0)+(c[T>>2]<<2)>>2]=G;c[U>>2]=0;while(1){if((c[U>>2]|0)>=(c[H>>2]|0))break;g[(c[(c[W>>2]|0)+(c[T>>2]<<2)>>2]|0)+(c[U>>2]<<2)>>2]=+h[(c[(c[J>>2]|0)+(c[T>>2]<<2)>>2]|0)+(c[U>>2]<<3)>>3];c[U>>2]=(c[U>>2]|0)+1}c[T>>2]=(c[T>>2]|0)+1}c:do if(c[na>>2]|0)g[Y>>2]=+(c[H>>2]|0)*+((c[H>>2]|0)-1|0)/2.0;else{g[Y>>2]=0.0;c[Z>>2]=0;c[T>>2]=0;while(1){if((c[T>>2]|0)>=((c[H>>2]|0)-1|0))break c;c[Z>>2]=(c[Z>>2]|0)+1;c[U>>2]=1;while(1){if((c[U>>2]|0)>=((c[H>>2]|0)-(c[T>>2]|0)|0))break;g[Y>>2]=+g[Y>>2]+ +g[(c[S>>2]|0)+(c[Z>>2]<<2)>>2];c[U>>2]=(c[U>>2]|0)+1;c[Z>>2]=(c[Z>>2]|0)+1}c[T>>2]=(c[T>>2]|0)+1}}while(0);c[aa>>2]=(_(c[H>>2]|0,(c[H>>2]|0)+1|0)|0)/2|0;c[ba>>2]=c[S>>2];if((c[na>>2]|0)==2)wt(c[aa>>2]|0,c[ba>>2]|0);xt(c[aa>>2]|0,c[ba>>2]|0);c[Z>>2]=0;c[ca>>2]=bK(c[H>>2]<<3)|0;$4(c[ca>>2]|0,0,c[H>>2]<<3|0)|0;c[T>>2]=0;while(1){if((c[T>>2]|0)>=((c[H>>2]|0)-1|0))break;h[$>>3]=0.0;c[Z>>2]=(c[Z>>2]|0)+1;c[U>>2]=1;while(1){if((c[U>>2]|0)>=((c[H>>2]|0)-(c[T>>2]|0)|0))break;g[ea>>2]=+g[(c[ba>>2]|0)+(c[Z>>2]<<2)>>2];h[$>>3]=+h[$>>3]+ +g[ea>>2];G=(c[ca>>2]|0)+((c[T>>2]|0)+(c[U>>2]|0)<<3)|0;h[G>>3]=+h[G>>3]-+g[ea>>2];c[U>>2]=(c[U>>2]|0)+1;c[Z>>2]=(c[Z>>2]|0)+1}G=(c[ca>>2]|0)+(c[T>>2]<<3)|0;h[G>>3]=+h[G>>3]-+h[$>>3];c[T>>2]=(c[T>>2]|0)+1}c[da>>2]=c[H>>2];c[Z>>2]=0;c[T>>2]=0;while(1){if((c[T>>2]|0)>=(c[H>>2]|0))break;g[(c[ba>>2]|0)+(c[Z>>2]<<2)>>2]=+h[(c[ca>>2]|0)+(c[T>>2]<<3)>>3];c[T>>2]=(c[T>>2]|0)+1;c[Z>>2]=(c[Z>>2]|0)+(c[da>>2]|0);c[da>>2]=(c[da>>2]|0)+-1}c[ia>>2]=bK(c[L>>2]<<2)|0;G=bK((_(c[L>>2]|0,c[H>>2]|0)|0)<<2)|0;c[c[ia>>2]>>2]=G;c[V>>2]=1;while(1){if((c[V>>2]|0)>=(c[L>>2]|0))break;G=(c[c[ia>>2]>>2]|0)+((_(c[V>>2]|0,c[H>>2]|0)|0)<<2)|0;c[(c[ia>>2]|0)+(c[V>>2]<<2)>>2]=G;c[V>>2]=(c[V>>2]|0)+1}c[ja>>2]=bK(c[H>>2]<<2)|0;c[ka>>2]=bK(c[H>>2]<<2)|0;c[la>>2]=0;c[la>>2]=bK(c[aa>>2]<<2)|0;h[fa>>3]=1797693134862315708145274.0e284;if(a[138998]|0){G=c[24742]|0;h[u>>3]=+$N();Y2(G,130874,u)|0;Y2(c[24742]|0,127047,t)|0;_N()}a[ha>>0]=0;c[Q>>2]=0;d:while(1){if((c[Q>>2]|0)>=(c[P>>2]|0)){va=132;break}if(!((a[ha>>0]|0)!=0^1)){va=132;break}$4(c[ca>>2]|0,0,c[H>>2]<<3|0)|0;if((c[na>>2]|0)==2)yt(c[aa>>2]|0,c[ba>>2]|0,c[la>>2]|0);c[Z>>2]=0;c[T>>2]=0;while(1){xa=c[H>>2]|0;if((c[T>>2]|0)>=((c[H>>2]|0)-1|0))break;c[oa>>2]=xa-(c[T>>2]|0)-1;ut(c[oa>>2]|0,0.0,c[ka>>2]|0);c[V>>2]=0;while(1){ya=c[oa>>2]|0;if((c[V>>2]|0)>=(c[L>>2]|0))break;ut(ya,+g[(c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0)+(c[T>>2]<<2)>>2],c[ja>>2]|0);pt(c[oa>>2]|0,c[ja>>2]|0,-1.0,(c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0)+(c[T>>2]<<2)+4|0);wt(c[oa>>2]|0,c[ja>>2]|0);ot(c[oa>>2]|0,c[ja>>2]|0,c[ka>>2]|0,c[ka>>2]|0);c[V>>2]=(c[V>>2]|0)+1}zt(ya,c[ka>>2]|0);c[U>>2]=0;while(1){if((c[U>>2]|0)>=(c[oa>>2]|0))break;if(!(!(+g[(c[ka>>2]|0)+(c[U>>2]<<2)>>2]>=3402823466385288598117041.0e14)?!(+g[(c[ka>>2]|0)+(c[U>>2]<<2)>>2]<0.0):0))g[(c[ka>>2]|0)+(c[U>>2]<<2)>>2]=0.0;c[U>>2]=(c[U>>2]|0)+1}c[Z>>2]=(c[Z>>2]|0)+1;h[$>>3]=0.0;G=(c[na>>2]|0)==2;c[U>>2]=0;e:do if(G)while(1){if((c[U>>2]|0)>=(c[oa>>2]|0))break e;qa=(c[la>>2]|0)+(c[Z>>2]<<2)|0;wa=+g[qa>>2]*+g[(c[ka>>2]|0)+(c[U>>2]<<2)>>2];g[qa>>2]=wa;g[ea>>2]=wa;h[$>>3]=+h[$>>3]+ +g[ea>>2];qa=(c[ca>>2]|0)+((c[T>>2]|0)+(c[U>>2]|0)+1<<3)|0;h[qa>>3]=+h[qa>>3]-+g[ea>>2];c[U>>2]=(c[U>>2]|0)+1;c[Z>>2]=(c[Z>>2]|0)+1}else while(1){if((c[U>>2]|0)>=(c[oa>>2]|0))break e;wa=+g[(c[ka>>2]|0)+(c[U>>2]<<2)>>2];g[(c[la>>2]|0)+(c[Z>>2]<<2)>>2]=wa;g[ea>>2]=wa;h[$>>3]=+h[$>>3]+ +g[ea>>2];qa=(c[ca>>2]|0)+((c[T>>2]|0)+(c[U>>2]|0)+1<<3)|0;h[qa>>3]=+h[qa>>3]-+g[ea>>2];c[U>>2]=(c[U>>2]|0)+1;c[Z>>2]=(c[Z>>2]|0)+1}while(0);G=(c[ca>>2]|0)+(c[T>>2]<<3)|0;h[G>>3]=+h[G>>3]-+h[$>>3];c[T>>2]=(c[T>>2]|0)+1}c[da>>2]=xa;c[Z>>2]=0;c[T>>2]=0;while(1){if((c[T>>2]|0)>=(c[H>>2]|0))break;g[(c[la>>2]|0)+(c[Z>>2]<<2)>>2]=+h[(c[ca>>2]|0)+(c[T>>2]<<3)>>3];c[T>>2]=(c[T>>2]|0)+1;c[Z>>2]=(c[Z>>2]|0)+(c[da>>2]|0);c[da>>2]=(c[da>>2]|0)+-1}c[V>>2]=0;while(1){if((c[V>>2]|0)>=(c[L>>2]|0))break;mt(c[la>>2]|0,c[H>>2]|0,c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0,c[(c[ia>>2]|0)+(c[V>>2]<<2)>>2]|0);c[V>>2]=(c[V>>2]|0)+1}h[ga>>3]=0.0;c[V>>2]=0;while(1){if((c[V>>2]|0)>=(c[L>>2]|0))break;wa=+st(c[H>>2]|0,c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0,c[(c[ia>>2]|0)+(c[V>>2]<<2)>>2]|0);h[ga>>3]=+h[ga>>3]+wa;c[V>>2]=(c[V>>2]|0)+1}h[ga>>3]=+h[ga>>3]*2.0;h[ga>>3]=+h[ga>>3]+ +g[Y>>2];c[V>>2]=0;while(1){if((c[V>>2]|0)>=(c[L>>2]|0))break;mt(c[ba>>2]|0,c[H>>2]|0,c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0,c[ja>>2]|0);wa=+st(c[H>>2]|0,c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0,c[ja>>2]|0);h[ga>>3]=+h[ga>>3]-wa;c[V>>2]=(c[V>>2]|0)+1}h[ra>>3]=+h[fa>>3]-+h[ga>>3];wa=+h[ra>>3];h[sa>>3]=+h[ra>>3]>=0.0?wa:-wa;if(+h[sa>>3]/+h[fa>>3]<+h[4247])za=1;else za=+h[ga>>3]<+h[4247];a[ha>>0]=za&1;h[fa>>3]=+h[ga>>3];c[V>>2]=0;while(1){if((c[V>>2]|0)>=(c[L>>2]|0))break;f:do if(!(c[pa>>2]|0)){if((Tq(c[ba>>2]|0,c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0,c[(c[ia>>2]|0)+(c[V>>2]<<2)>>2]|0,c[H>>2]|0,+h[R>>3],c[H>>2]|0)|0)<0){va=125;break d}}else{rt(c[H>>2]|0,c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0,c[ja>>2]|0);if((Tq(c[ba>>2]|0,c[ja>>2]|0,c[(c[ia>>2]|0)+(c[V>>2]<<2)>>2]|0,c[H>>2]|0,+h[R>>3],c[H>>2]|0)|0)<0){va=118;break d}c[T>>2]=0;while(1){if((c[T>>2]|0)>=(c[H>>2]|0))break f;c[ta>>2]=c[(c[K>>2]|0)+(c[T>>2]<<2)>>2];if((d[(c[(c[ta>>2]|0)+8>>2]|0)+119>>0]|0)<=1)g[(c[(c[W>>2]|0)+(c[V>>2]<<2)>>2]|0)+(c[T>>2]<<2)>>2]=+g[(c[ja>>2]|0)+(c[T>>2]<<2)>>2];c[T>>2]=(c[T>>2]|0)+1}}while(0);c[V>>2]=(c[V>>2]|0)+1}do if(d[138998]|0){if((c[Q>>2]|0)%5|0)break;G=c[24742]|0;h[s>>3]=+h[ga>>3];Y2(G,127347,s)|0;if(((c[Q>>2]|0)+5|0)%50|0)break;Y2(c[24742]|0,193392,r)|0}while(0);c[Q>>2]=(c[Q>>2]|0)+1}if((va|0)==118){c[Q>>2]=-1;break}else if((va|0)==125){c[Q>>2]=-1;break}else if((va|0)==132){if(a[138998]|0){G=c[24742]|0;wa=+Im(c[W>>2]|0,c[ba>>2]|0,c[L>>2]|0,c[H>>2]|0,c[na>>2]|0);qa=c[Q>>2]|0;Aa=+$N();h[q>>3]=wa;c[q+8>>2]=qa;h[q+16>>3]=Aa;Y2(G,127063,q)|0}c[T>>2]=0;while(1){if((c[T>>2]|0)>=(c[L>>2]|0))break b;c[U>>2]=0;while(1){if((c[U>>2]|0)>=(c[H>>2]|0))break;h[(c[(c[J>>2]|0)+(c[T>>2]<<2)>>2]|0)+(c[U>>2]<<3)>>3]=+g[(c[(c[W>>2]|0)+(c[T>>2]<<2)>>2]|0)+(c[U>>2]<<2)>>2];c[U>>2]=(c[U>>2]|0)+1}c[T>>2]=(c[T>>2]|0)+1}}}while(0);O4(c[X>>2]|0);O4(c[W>>2]|0);O4(c[ba>>2]|0);if(c[ia>>2]|0){O4(c[c[ia>>2]>>2]|0);O4(c[ia>>2]|0)}O4(c[ja>>2]|0);O4(c[ka>>2]|0);O4(c[ca>>2]|0);O4(c[la>>2]|0);c[F>>2]=c[Q>>2];ua=c[F>>2]|0;i=p;return ua|0}function Gm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0.0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;h=d+32|0;j=d+28|0;k=d+24|0;l=d+20|0;m=d+16|0;n=d;c[e>>2]=a;c[f>>2]=b;c[l>>2]=bK(((_(c[f>>2]|0,(c[f>>2]|0)+1|0)|0)/2|0)<<2)|0;c[m>>2]=bK(c[f>>2]<<2)|0;Nq(n,c[f>>2]|0);c[k>>2]=0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[f>>2]|0))break;xr(c[h>>2]|0,c[e>>2]|0,c[f>>2]|0,c[m>>2]|0);c[j>>2]=c[h>>2];while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;o=+g[(c[m>>2]|0)+(c[j>>2]<<2)>>2];b=c[k>>2]|0;c[k>>2]=b+1;g[(c[l>>2]|0)+(b<<2)>>2]=o;c[j>>2]=(c[j>>2]|0)+1}c[h>>2]=(c[h>>2]|0)+1}O4(c[m>>2]|0);Oq(n);i=d;return c[l>>2]|0}function Hm(b,d,e,f,j,k,l,m,n,o,p){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0;q=i;i=i+256|0;r=q+248|0;s=q+244|0;t=q+236|0;u=q+232|0;v=q+228|0;w=q+224|0;x=q+220|0;y=q+216|0;z=q+212|0;A=q+208|0;B=q+204|0;C=q+40|0;D=q+200|0;E=q+196|0;F=q+192|0;G=q+188|0;H=q+184|0;I=q+180|0;J=q+176|0;K=q+172|0;L=q+168|0;M=q+164|0;O=q+160|0;P=q+144|0;Q=q+136|0;R=q+132|0;S=q+128|0;T=q+124|0;U=q+120|0;V=q+116|0;W=q+112|0;X=q+108|0;Y=q+104|0;Z=q+100|0;$=q+96|0;aa=q+92|0;ba=q+88|0;ca=q+84|0;da=q+80|0;ea=q+76|0;fa=q+72|0;ga=q+68|0;ha=q+32|0;ia=q+64|0;ja=q+60|0;ka=q+56|0;la=q+24|0;ma=q+52|0;na=q+48|0;oa=q+16|0;pa=q+8|0;qa=q;ra=q+252|0;c[r>>2]=b;c[s>>2]=d;c[q+240>>2]=e;c[t>>2]=f;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;c[x>>2]=m;c[y>>2]=n;c[z>>2]=o;c[A>>2]=p;h[C>>3]=.001;c[H>>2]=50<(c[s>>2]|0)?50:c[s>>2]|0;c[I>>2]=cK(c[H>>2]<<2)|0;c[J>>2]=cK((_(c[H>>2]|0,c[s>>2]|0)|0)<<3)|0;c[Y>>2]=0;c[Z>>2]=0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[H>>2]|0))break;p=(c[J>>2]|0)+((_(c[D>>2]|0,c[s>>2]|0)|0)<<3)|0;c[(c[I>>2]|0)+(c[D>>2]<<2)>>2]=p;c[D>>2]=(c[D>>2]|0)+1}if((c[s>>2]|0)<(((c[H>>2]<<1|0)>50?c[H>>2]<<1:50)|0))sa=c[s>>2]|0;else sa=(c[H>>2]<<1|0)>50?c[H>>2]<<1:50;c[K>>2]=sa;c[L>>2]=0;Mr(c[r>>2]|0,c[s>>2]|0,c[K>>2]|0,L,c[x>>2]|0);Nr(c[L>>2]|0,c[s>>2]|0,c[K>>2]|0);Ht(c[L>>2]|0,c[K>>2]|0,c[s>>2]|0,c[I>>2]|0,c[H>>2]|0);O4(c[c[L>>2]>>2]|0);O4(c[L>>2]|0);c[M>>2]=cK(c[s>>2]<<2)|0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[s>>2]|0))break;c[(c[M>>2]|0)+(c[D>>2]<<2)>>2]=-1;c[D>>2]=(c[D>>2]|0)+1}c[O>>2]=0;Nq(P,c[s>>2]|0);c[Q>>2]=c[(c[r>>2]|0)+8>>2];if(c[x>>2]|0)ws(c[r>>2]|0,c[s>>2]|0);c[R>>2]=0;c[S>>2]=cK(c[s>>2]<<2)|0;a:do if(c[A>>2]|0){c[O>>2]=cK(c[A>>2]<<2)|0;c[U>>2]=cK((_(c[s>>2]|0,c[A>>2]|0)|0)<<2)|0;c[R>>2]=cK(c[A>>2]<<2)|0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[A>>2]|0))break;L=(c[U>>2]|0)+((_(c[D>>2]|0,c[s>>2]|0)|0)<<2)|0;c[(c[R>>2]|0)+(c[D>>2]<<2)>>2]=L;c[D>>2]=(c[D>>2]|0)+1}L=t2()|0;c[G>>2]=(L|0)%(c[s>>2]|0)|0;c[(c[M>>2]|0)+(c[G>>2]<<2)>>2]=0;c[c[O>>2]>>2]=c[G>>2];L=c[G>>2]|0;K=c[r>>2]|0;sa=c[s>>2]|0;J=c[c[R>>2]>>2]|0;if(c[x>>2]|0)vr(L,K,sa,J);else Iq(L,K,sa,J,P);c[T>>2]=0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[s>>2]|0))break;c[(c[S>>2]|0)+(c[D>>2]<<2)>>2]=c[(c[c[R>>2]>>2]|0)+(c[D>>2]<<2)>>2];if((c[(c[S>>2]|0)+(c[D>>2]<<2)>>2]|0)>(c[T>>2]|0)){c[G>>2]=c[D>>2];c[T>>2]=c[(c[S>>2]|0)+(c[D>>2]<<2)>>2]}c[D>>2]=(c[D>>2]|0)+1}c[D>>2]=1;while(1){if((c[D>>2]|0)>=(c[A>>2]|0))break a;c[(c[M>>2]|0)+(c[G>>2]<<2)>>2]=c[D>>2];c[(c[O>>2]|0)+(c[D>>2]<<2)>>2]=c[G>>2];J=c[G>>2]|0;sa=c[r>>2]|0;K=c[s>>2]|0;L=c[(c[R>>2]|0)+(c[D>>2]<<2)>>2]|0;if(c[x>>2]|0)vr(J,sa,K,L);else Iq(J,sa,K,L,P);c[T>>2]=0;c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[s>>2]|0))break;L=c[E>>2]|0;if((c[(c[S>>2]|0)+(c[E>>2]<<2)>>2]|0)<(c[(c[(c[R>>2]|0)+(c[D>>2]<<2)>>2]|0)+(c[E>>2]<<2)>>2]|0))ta=c[(c[S>>2]|0)+(L<<2)>>2]|0;else ta=c[(c[(c[R>>2]|0)+(c[D>>2]<<2)>>2]|0)+(L<<2)>>2]|0;c[(c[S>>2]|0)+(c[E>>2]<<2)>>2]=ta;if((c[(c[S>>2]|0)+(c[E>>2]<<2)>>2]|0)<=(c[T>>2]|0)){if((c[(c[S>>2]|0)+(c[E>>2]<<2)>>2]|0)==(c[T>>2]|0)?(L=t2()|0,((L|0)%((c[E>>2]|0)+1|0)|0|0)==0):0)ua=37}else ua=37;if((ua|0)==37){ua=0;c[G>>2]=c[E>>2];c[T>>2]=c[(c[S>>2]|0)+(c[E>>2]<<2)>>2]}c[E>>2]=(c[E>>2]|0)+1}c[D>>2]=(c[D>>2]|0)+1}}while(0);c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[s>>2]|0))break;c[(c[S>>2]|0)+(c[D>>2]<<2)>>2]=-1;c[D>>2]=(c[D>>2]|0)+1}c[V>>2]=cK(c[s>>2]<<2)|0;c[W>>2]=cK(c[s>>2]<<4)|0;c[X>>2]=0;c[ca>>2]=0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[s>>2]|0))break;b:do if((c[(c[M>>2]|0)+(c[D>>2]<<2)>>2]|0)>=0){T=cK((c[s>>2]|0)-1<<2)|0;c[(c[W>>2]|0)+(c[D>>2]<<4)+4>>2]=T;T=cK((c[s>>2]|0)-1<<2)|0;c[(c[W>>2]|0)+(c[D>>2]<<4)+8>>2]=T;c[(c[W>>2]|0)+(c[D>>2]<<4)>>2]=(c[s>>2]|0)-1;c[ca>>2]=(c[ca>>2]|0)+((c[s>>2]|0)-1);a[(c[W>>2]|0)+(c[D>>2]<<4)+12>>0]=1;c[ba>>2]=c[(c[M>>2]|0)+(c[D>>2]<<2)>>2];c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[D>>2]|0))break;c[(c[(c[W>>2]|0)+(c[D>>2]<<4)+4>>2]|0)+(c[E>>2]<<2)>>2]=c[E>>2];c[(c[(c[W>>2]|0)+(c[D>>2]<<4)+8>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[(c[R>>2]|0)+(c[ba>>2]<<2)>>2]|0)+(c[E>>2]<<2)>>2];c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=(c[D>>2]|0)+1;while(1){if((c[E>>2]|0)>=(c[s>>2]|0))break b;c[(c[(c[W>>2]|0)+(c[D>>2]<<4)+4>>2]|0)+((c[E>>2]|0)-1<<2)>>2]=c[E>>2];c[(c[(c[W>>2]|0)+(c[D>>2]<<4)+8>>2]|0)+((c[E>>2]|0)-1<<2)>>2]=c[(c[(c[R>>2]|0)+(c[ba>>2]<<2)>>2]|0)+(c[E>>2]<<2)>>2];c[E>>2]=(c[E>>2]|0)+1}}else{c:do if((c[z>>2]|0)>0){T=c[D>>2]|0;ta=c[r>>2]|0;U=c[s>>2]|0;L=c[S>>2]|0;K=c[z>>2]|0;sa=c[V>>2]|0;if(c[x>>2]|0)c[$>>2]=wr(T,ta,U,L,K,sa)|0;else c[$>>2]=Mq(T,ta,U,L,P,K,sa)|0;c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[$>>2]|0))break c;if((c[(c[M>>2]|0)+(c[(c[V>>2]|0)+(c[E>>2]<<2)>>2]<<2)>>2]|0)<0?(c[(c[V>>2]|0)+(c[E>>2]<<2)>>2]|0)!=(c[D>>2]|0):0){c[E>>2]=(c[E>>2]|0)+1;continue}c[(c[S>>2]|0)+(c[(c[V>>2]|0)+(c[E>>2]<<2)>>2]<<2)>>2]=-1;sa=(c[$>>2]|0)+-1|0;c[$>>2]=sa;c[(c[V>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[V>>2]|0)+(sa<<2)>>2]}}else c[$>>2]=0;while(0);c[aa>>2]=(c[$>>2]|0)+(c[A>>2]|0);if((c[aa>>2]|0)>(c[X>>2]|0)){c[X>>2]=_((c[z>>2]|0)+1|0,c[s>>2]|0)|0;c[Y>>2]=cK(c[X>>2]<<2)|0;c[Z>>2]=cK(c[X>>2]<<2)|0;a[(c[W>>2]|0)+(c[D>>2]<<4)+12>>0]=1}else a[(c[W>>2]|0)+(c[D>>2]<<4)+12>>0]=0;c[(c[W>>2]|0)+(c[D>>2]<<4)+4>>2]=c[Y>>2];c[(c[W>>2]|0)+(c[D>>2]<<4)+8>>2]=c[Z>>2];c[(c[W>>2]|0)+(c[D>>2]<<4)>>2]=c[aa>>2];c[ca>>2]=(c[ca>>2]|0)+(c[aa>>2]|0);c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[$>>2]|0))break;c[(c[Y>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[V>>2]|0)+(c[E>>2]<<2)>>2];c[(c[Z>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[S>>2]|0)+(c[(c[V>>2]|0)+(c[E>>2]<<2)>>2]<<2)>>2];c[(c[S>>2]|0)+(c[(c[V>>2]|0)+(c[E>>2]<<2)>>2]<<2)>>2]=-1;c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=c[$>>2];while(1){if((c[E>>2]|0)>=(c[aa>>2]|0))break;c[ba>>2]=(c[E>>2]|0)-(c[$>>2]|0);c[(c[Y>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[O>>2]|0)+(c[ba>>2]<<2)>>2];c[(c[Z>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[(c[R>>2]|0)+(c[ba>>2]<<2)>>2]|0)+(c[D>>2]<<2)>>2];c[E>>2]=(c[E>>2]|0)+1}c[Y>>2]=(c[Y>>2]|0)+(c[aa>>2]<<2);c[Z>>2]=(c[Z>>2]|0)+(c[aa>>2]<<2);c[X>>2]=(c[X>>2]|0)-(c[aa>>2]|0)}while(0);c[D>>2]=(c[D>>2]|0)+1}O4(c[S>>2]|0);O4(c[V>>2]|0);if(c[R>>2]|0){O4(c[c[R>>2]>>2]|0);O4(c[R>>2]|0)}c[ea>>2]=cK((c[s>>2]|0)*20|0)|0;c[fa>>2]=cK((c[ca>>2]|0)+(c[s>>2]|0)<<2)|0;c[ga>>2]=cK((c[ca>>2]|0)+(c[s>>2]|0)<<2)|0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[s>>2]|0))break;c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)+4>>2]=c[fa>>2];c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)+8>>2]=c[ga>>2];c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)>>2]=(c[(c[W>>2]|0)+(c[D>>2]<<4)>>2]|0)+1;c[da>>2]=(c[(c[W>>2]|0)+(c[D>>2]<<4)+8>>2]|0)+-4;h[ha>>3]=0.0;ca=(c[w>>2]|0)==2;c[E>>2]=1;d:do if(ca)while(1){if((c[E>>2]|0)>=(c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)>>2]|0))break d;c[(c[fa>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[(c[W>>2]|0)+(c[D>>2]<<4)+4>>2]|0)+((c[E>>2]|0)-1<<2)>>2];g[(c[ga>>2]|0)+(c[E>>2]<<2)>>2]=-1.0/(+(c[(c[da>>2]|0)+(c[E>>2]<<2)>>2]|0)*+(c[(c[da>>2]|0)+(c[E>>2]<<2)>>2]|0));h[ha>>3]=+h[ha>>3]-+g[(c[ga>>2]|0)+(c[E>>2]<<2)>>2];c[E>>2]=(c[E>>2]|0)+1}else while(1){if((c[E>>2]|0)>=(c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)>>2]|0))break d;c[(c[fa>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[(c[W>>2]|0)+(c[D>>2]<<4)+4>>2]|0)+((c[E>>2]|0)-1<<2)>>2];g[(c[ga>>2]|0)+(c[E>>2]<<2)>>2]=-1.0/+(c[(c[da>>2]|0)+(c[E>>2]<<2)>>2]|0);h[ha>>3]=+h[ha>>3]-+g[(c[ga>>2]|0)+(c[E>>2]<<2)>>2];c[E>>2]=(c[E>>2]|0)+1}while(0);c[c[fa>>2]>>2]=c[D>>2];g[c[ga>>2]>>2]=+h[ha>>3];c[fa>>2]=(c[fa>>2]|0)+(c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)>>2]<<2);c[ga>>2]=(c[ga>>2]|0)+(c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)>>2]<<2);c[D>>2]=(c[D>>2]|0)+1}c[ia>>2]=cK(c[u>>2]<<2)|0;ca=cK((_(c[u>>2]|0,c[H>>2]|0)|0)<<3)|0;c[c[ia>>2]>>2]=ca;c[D>>2]=1;while(1){if((c[D>>2]|0)>=(c[u>>2]|0))break;ca=(c[c[ia>>2]>>2]|0)+((_(c[D>>2]|0,c[H>>2]|0)|0)<<3)|0;c[(c[ia>>2]|0)+(c[D>>2]<<2)>>2]=ca;c[D>>2]=(c[D>>2]|0)+1}ca=(c[v>>2]|0)!=0;c[F>>2]=0;e:do if(ca){while(1){if((c[F>>2]|0)>=(c[u>>2]|0))break;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[H>>2]|0))break;h[(c[(c[ia>>2]|0)+(c[F>>2]<<2)>>2]|0)+(c[D>>2]<<3)>>3]=0.0;c[D>>2]=(c[D>>2]|0)+1}c[F>>2]=(c[F>>2]|0)+1}if((c[u>>2]|0)!=2){c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[u>>2]|0))break e;h[(c[(c[ia>>2]|0)+(c[F>>2]<<2)>>2]|0)+(c[F>>2]<<3)>>3]=1.0;c[F>>2]=(c[F>>2]|0)+1}}h[c[c[ia>>2]>>2]>>3]=1.0;if(!((It(c[I>>2]|0,c[H>>2]|0,c[s>>2]|0,c[(c[ia>>2]|0)+4>>2]|0)|0)<<24>>24)){c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[H>>2]|0))break;h[(c[(c[ia>>2]|0)+4>>2]|0)+(c[F>>2]<<3)>>3]=0.0;c[F>>2]=(c[F>>2]|0)+1}h[(c[(c[ia>>2]|0)+4>>2]|0)+8>>3]=1.0}}else while(1){if((c[F>>2]|0)>=(c[u>>2]|0))break e;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[H>>2]|0))break;va=+(t2()|0)/2147483647.0;h[(c[(c[ia>>2]|0)+(c[F>>2]<<2)>>2]|0)+(c[D>>2]<<3)>>3]=va;c[D>>2]=(c[D>>2]|0)+1}c[F>>2]=(c[F>>2]|0)+1}while(0);c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[u>>2]|0))break;kt(c[I>>2]|0,c[s>>2]|0,c[H>>2]|0,c[(c[ia>>2]|0)+(c[F>>2]<<2)>>2]|0,c[(c[t>>2]|0)+(c[F>>2]<<2)>>2]|0);c[F>>2]=(c[F>>2]|0)+1}c[ja>>2]=0;c[ka>>2]=0;$s(c[ea>>2]|0,c[I>>2]|0,c[s>>2]|0,c[H>>2]|0,ja);Zs(c[I>>2]|0,c[ja>>2]|0,c[H>>2]|0,c[s>>2]|0,c[H>>2]|0,ka);O4(c[c[ja>>2]>>2]|0);O4(c[ja>>2]|0);c[ma>>2]=cK(c[s>>2]<<3)|0;c[na>>2]=cK(c[H>>2]<<3)|0;h[pa>>3]=+Jm(c[t>>2]|0,c[W>>2]|0,c[u>>2]|0,c[s>>2]|0,c[w>>2]|0);a[ra>>0]=0;c[B>>2]=0;f:while(1){if((c[B>>2]|0)>=(c[y>>2]|0))break;if(!((a[ra>>0]|0)!=0^1))break;c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[u>>2]|0))break;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[s>>2]|0))break;h[ha>>3]=0.0;h[(c[ma>>2]|0)+(c[D>>2]<<3)>>3]=0.0;c[da>>2]=(c[(c[W>>2]|0)+(c[D>>2]<<4)+8>>2]|0)+-4;c[fa>>2]=c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)+4>>2];c[ga>>2]=c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)+8>>2];c[E>>2]=1;while(1){if((c[E>>2]|0)>=(c[(c[ea>>2]|0)+((c[D>>2]|0)*20|0)>>2]|0))break;c[G>>2]=c[(c[fa>>2]|0)+(c[E>>2]<<2)>>2];h[la>>3]=+ys(c[t>>2]|0,c[u>>2]|0,c[D>>2]|0,c[G>>2]|0);if(+h[la>>3]>1.0e-30){h[oa>>3]=-+g[(c[ga>>2]|0)+(c[E>>2]<<2)>>2]*+(c[(c[da>>2]|0)+(c[E>>2]<<2)>>2]|0)/+h[la>>3];h[ha>>3]=+h[ha>>3]-+h[oa>>3];ja=(c[ma>>2]|0)+(c[D>>2]<<3)|0;h[ja>>3]=+h[ja>>3]+ +h[oa>>3]*+h[(c[(c[t>>2]|0)+(c[F>>2]<<2)>>2]|0)+(c[G>>2]<<3)>>3]}c[E>>2]=(c[E>>2]|0)+1}ja=(c[ma>>2]|0)+(c[D>>2]<<3)|0;h[ja>>3]=+h[ja>>3]+ +h[ha>>3]*+h[(c[(c[t>>2]|0)+(c[F>>2]<<2)>>2]|0)+(c[D>>2]<<3)>>3];c[D>>2]=(c[D>>2]|0)+1}Ys(c[I>>2]|0,c[H>>2]|0,c[s>>2]|0,c[ma>>2]|0,c[na>>2]|0);if(Sq(c[ka>>2]|0,c[(c[ia>>2]|0)+(c[F>>2]<<2)>>2]|0,c[na>>2]|0,c[H>>2]|0,+h[C>>3],c[H>>2]|0,0)|0){ua=124;break f}kt(c[I>>2]|0,c[s>>2]|0,c[H>>2]|0,c[(c[ia>>2]|0)+(c[F>>2]<<2)>>2]|0,c[(c[t>>2]|0)+(c[F>>2]<<2)>>2]|0);c[F>>2]=(c[F>>2]|0)+1}ja=((c[B>>2]|0)%2|0|0)==0&255;a[ra>>0]=ja;if(ja<<24>>24){h[qa>>3]=+Jm(c[t>>2]|0,c[W>>2]|0,c[u>>2]|0,c[s>>2]|0,c[w>>2]|0);va=+N(+(+h[qa>>3]-+h[pa>>3]));a[ra>>0]=va/(+h[qa>>3]+1.0e-10)<+h[4247];h[pa>>3]=+h[qa>>3]}c[B>>2]=(c[B>>2]|0)+1}if((ua|0)==124)c[B>>2]=-1;O4(c[na>>2]|0);O4(c[ma>>2]|0);if(c[x>>2]|0)xs(c[r>>2]|0,c[s>>2]|0,c[Q>>2]|0);c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[s>>2]|0))break;if(a[(c[W>>2]|0)+(c[D>>2]<<4)+12>>0]|0){O4(c[(c[W>>2]|0)+(c[D>>2]<<4)+4>>2]|0);O4(c[(c[W>>2]|0)+(c[D>>2]<<4)+8>>2]|0)}c[D>>2]=(c[D>>2]|0)+1}O4(c[W>>2]|0);O4(c[(c[ea>>2]|0)+4>>2]|0);O4(c[(c[ea>>2]|0)+8>>2]|0);O4(c[ea>>2]|0);O4(c[M>>2]|0);O4(c[O>>2]|0);O4(c[c[ia>>2]>>2]|0);O4(c[ia>>2]|0);if(!(c[ka>>2]|0)){wa=c[I>>2]|0;xa=c[wa>>2]|0;O4(xa);ya=c[I>>2]|0;O4(ya);Oq(P);za=c[B>>2]|0;i=q;return za|0}O4(c[c[ka>>2]>>2]|0);O4(c[ka>>2]|0);wa=c[I>>2]|0;xa=c[wa>>2]|0;O4(xa);ya=c[I>>2]|0;O4(ya);Oq(P);za=c[B>>2]|0;i=q;return za|0}function Im(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0;j=i;i=i+64|0;k=j+60|0;l=j+56|0;m=j+52|0;n=j+48|0;o=j+44|0;p=j+40|0;q=j+36|0;r=j+32|0;s=j+28|0;t=j+24|0;u=j+16|0;v=j+8|0;w=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;h[u>>3]=0.0;c[t>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=((c[n>>2]|0)-1|0))break;c[t>>2]=(c[t>>2]|0)+1;c[q>>2]=1;while(1){if((c[q>>2]|0)>=((c[n>>2]|0)-(c[p>>2]|0)|0))break;h[v>>3]=0.0;c[s>>2]=(c[p>>2]|0)+(c[q>>2]|0);c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;h[v>>3]=+h[v>>3]+(+g[(c[(c[k>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[p>>2]<<2)>>2]-+g[(c[(c[k>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2])*(+g[(c[(c[k>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[p>>2]<<2)>>2]-+g[(c[(c[k>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[s>>2]<<2)>>2]);c[r>>2]=(c[r>>2]|0)+1}h[v>>3]=+O(+(+h[v>>3]));x=+g[(c[l>>2]|0)+(c[t>>2]<<2)>>2];if((c[o>>2]|0)==2){h[w>>3]=1.0/+O(+x);h[u>>3]=+h[u>>3]+(+h[w>>3]-+h[v>>3])*(+h[w>>3]-+h[v>>3])*+g[(c[l>>2]|0)+(c[t>>2]<<2)>>2]}else{h[w>>3]=1.0/x;h[u>>3]=+h[u>>3]+(+h[w>>3]-+h[v>>3])*(+h[w>>3]-+h[v>>3])*+g[(c[l>>2]|0)+(c[t>>2]<<2)>>2]}c[q>>2]=(c[q>>2]|0)+1;c[t>>2]=(c[t>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}i=j;return +(+h[u>>3])}function Jm(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;g=i;i=i+64|0;j=g+56|0;k=g+52|0;l=g+48|0;m=g+44|0;n=g+40|0;o=g+36|0;p=g+32|0;q=g+28|0;r=g+24|0;s=g+16|0;t=g+8|0;u=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;h[s>>3]=0.0;f=(c[n>>2]|0)==2;c[o>>2]=0;if(f){while(1){if((c[o>>2]|0)>=(c[m>>2]|0))break;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[(c[k>>2]|0)+(c[o>>2]<<4)>>2]|0))break;c[r>>2]=c[(c[(c[k>>2]|0)+(c[o>>2]<<4)+4>>2]|0)+(c[p>>2]<<2)>>2];if((c[r>>2]|0)>(c[o>>2]|0)){h[t>>3]=0.0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[l>>2]|0))break;h[t>>3]=+h[t>>3]+(+h[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[o>>2]<<3)>>3]-+h[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[r>>2]<<3)>>3])*(+h[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[o>>2]<<3)>>3]-+h[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[r>>2]<<3)>>3]);c[q>>2]=(c[q>>2]|0)+1}h[t>>3]=+O(+(+h[t>>3]));h[u>>3]=+(c[(c[(c[k>>2]|0)+(c[o>>2]<<4)+8>>2]|0)+(c[p>>2]<<2)>>2]|0);h[s>>3]=+h[s>>3]+(+h[u>>3]-+h[t>>3])*(+h[u>>3]-+h[t>>3])/(+h[u>>3]*+h[u>>3])}c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}v=+h[s>>3];i=g;return +v}else{while(1){if((c[o>>2]|0)>=(c[m>>2]|0))break;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[(c[k>>2]|0)+(c[o>>2]<<4)>>2]|0))break;c[r>>2]=c[(c[(c[k>>2]|0)+(c[o>>2]<<4)+4>>2]|0)+(c[p>>2]<<2)>>2];if((c[r>>2]|0)>(c[o>>2]|0)){h[t>>3]=0.0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[l>>2]|0))break;h[t>>3]=+h[t>>3]+(+h[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[o>>2]<<3)>>3]-+h[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[r>>2]<<3)>>3])*(+h[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[o>>2]<<3)>>3]-+h[(c[(c[j>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[r>>2]<<3)>>3]);c[q>>2]=(c[q>>2]|0)+1}h[t>>3]=+O(+(+h[t>>3]));h[u>>3]=+(c[(c[(c[k>>2]|0)+(c[o>>2]<<4)+8>>2]|0)+(c[p>>2]<<2)>>2]|0);h[s>>3]=+h[s>>3]+(+h[u>>3]-+h[t>>3])*(+h[u>>3]-+h[t>>3])/+h[u>>3]}c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}v=+h[s>>3];i=g;return +v}return +(0.0)}function Km(a){a=+a;var b=0,c=0;b=i;i=i+16|0;c=b;h[c>>3]=a;h[c>>3]=+O(+(+h[c>>3]));i=b;return +(+h[c>>3]*+h[c>>3]*+h[c>>3])}function Lm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+12|0;k=e+8|0;l=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;h[l>>3]=0.0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[13799]|0))break;h[(c[j>>2]|0)+(c[k>>2]<<3)>>3]=+h[(c[f>>2]|0)+(c[k>>2]<<3)>>3]-+h[(c[g>>2]|0)+(c[k>>2]<<3)>>3];h[l>>3]=+h[l>>3]+ +h[(c[j>>2]|0)+(c[k>>2]<<3)>>3]*+h[(c[j>>2]|0)+(c[k>>2]<<3)>>3];c[k>>2]=(c[k>>2]|0)+1}h[l>>3]=+O(+(+h[l>>3]));i=e;return +(+h[l>>3])}function Mm(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;j=e;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;c[f>>2]=a;c[g>>2]=b;h[j>>3]=d;c[k>>2]=bK(c[f>>2]<<2)|0;c[l>>2]=bK((_(c[f>>2]|0,c[g>>2]|0)|0)<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[f>>2]|0))break;c[(c[k>>2]|0)+(c[m>>2]<<2)>>2]=c[l>>2];c[l>>2]=(c[l>>2]|0)+(c[g>>2]<<3);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[g>>2]|0))break;h[(c[(c[k>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<3)>>3]=+h[j>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}i=e;return c[k>>2]|0}function Nm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}O4(c[c[d>>2]>>2]|0);O4(c[d>>2]|0);i=b;return}function Om(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0;e=i;i=i+80|0;f=e+16|0;g=e+64|0;j=e+60|0;k=e+56|0;l=e+52|0;m=e+48|0;n=e+44|0;o=e+40|0;p=e+36|0;q=e+32|0;r=e+28|0;s=e+8|0;t=e;u=e+24|0;c[g>>2]=b;c[j>>2]=d;h[s>>3]=0.0;h[t>>3]=1.0;if(a[138998]|0){d=c[24742]|0;b=wB(c[g>>2]|0)|0;v=kB(c[g>>2]|0)|0;c[f>>2]=b;c[f+4>>2]=v;Y2(d,127101,f)|0}a:do if(a[138999]|0){c[p>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[p>>2]|0))break a;c[q>>2]=aC(c[g>>2]|0,c[p>>2]|0)|0;c[n>>2]=gn(c[g>>2]|0,c[p>>2]|0,r)|0;if(c[n>>2]|0){if((c[n>>2]|0)==1){pC(c[(c[g>>2]|0)+48>>2]|0,c[p>>2]|0)|0;c[q>>2]=hn(c[g>>2]|0,c[r>>2]|0,c[q>>2]|0)|0}}else pC(c[(c[g>>2]|0)+48>>2]|0,c[p>>2]|0)|0;c[p>>2]=c[q>>2]}}while(0);c[l>>2]=kB(c[g>>2]|0)|0;c[m>>2]=lB(c[g>>2]|0)|0;c[u>>2]=qA(c[g>>2]|0,2,129937,0)|0;b:do if(!(c[j>>2]|0)){h[4247]=+(c[l>>2]|0)*.0001;JJ(c[g>>2]|0,146583,33976);q=yA(c[(c[g>>2]|0)+48>>2]|0,127130)|0;c[o>>2]=q;if(q)h[4249]=+t3(c[o>>2]|0);else h[4249]=.99;q=bK((c[l>>2]|0)+1<<2)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]=q;c[k>>2]=0;c[p>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[p>>2]|0))break b;c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[k>>2]<<2)>>2]=c[p>>2];q=c[k>>2]|0;c[k>>2]=q+1;c[(c[(c[p>>2]|0)+8>>2]|0)+120>>2]=q;c[(c[(c[p>>2]|0)+8>>2]|0)+124>>2]=-1;w=+jn(c[g>>2]|0,c[p>>2]|0,c[u>>2]|0,+h[t>>3]);h[s>>3]=+h[s>>3]+w;c[p>>2]=aC(c[g>>2]|0,c[p>>2]|0)|0}}else{h[4247]=.0001;JJ(c[g>>2]|0,146583,33976);c[k>>2]=0;c[p>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[p>>2]|0))break b;q=c[k>>2]|0;c[k>>2]=q+1;c[(c[(c[p>>2]|0)+8>>2]|0)+120>>2]=q;w=+jn(c[g>>2]|0,c[p>>2]|0,c[u>>2]|0,+h[t>>3]);h[s>>3]=+h[s>>3]+w;c[p>>2]=aC(c[g>>2]|0,c[p>>2]|0)|0}}while(0);c[o>>2]=yA(c[g>>2]|0,127138)|0;if((c[o>>2]|0)!=0?(a[c[o>>2]>>0]|0)!=0:0){w=+h[4247];if(w>+t3(c[o>>2]|0))x=+h[4247];else x=+t3(c[o>>2]|0);h[4248]=x}else h[4248]=+h[s>>3]/+(((c[m>>2]|0)>0?c[m>>2]|0:1)|0)*+O(+(+(c[l>>2]|0)))+1.0;if(!((c[13795]|0)==0&(c[j>>2]|0)==0)){y=c[l>>2]|0;i=e;return y|0}j=Mm(c[l>>2]|0,c[l>>2]|0,+h[4248])|0;c[(c[(c[g>>2]|0)+8>>2]|0)+160>>2]=j;j=Mm(c[l>>2]|0,c[l>>2]|0,1.0)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]=j;j=Mm(c[l>>2]|0,c[13799]|0,1.0)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+168>>2]=j;j=kn(c[l>>2]|0,c[l>>2]|0,c[13799]|0,0.0)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]=j;y=c[l>>2]|0;i=e;return y|0}function Pm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=Om(c[d>>2]|0,0)|0;i=b;return a|0}function Qm(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0);if(c[13795]|0){i=b;return}Nm(c[(c[(c[d>>2]|0)+8>>2]|0)+160>>2]|0);Nm(c[(c[(c[d>>2]|0)+8>>2]|0)+164>>2]|0);Nm(c[(c[(c[d>>2]|0)+8>>2]|0)+168>>2]|0);ln(c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]|0);c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]=0;i=b;return}function Rm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[j>>2];while(1){if((c[k>>2]|0)>=(c[13799]|0))break;l=+(c[g>>2]|0);m=l*+r2();h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+(c[k>>2]<<3)>>3]=m;c[k>>2]=(c[k>>2]|0)+1}i=e;return}function Sm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;Rm(c[e>>2]|0,c[f>>2]|0,2);i=d;return}function Tm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;g=+(c[f>>2]|0);j=g*+r2();h[c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]>>3]=j;j=+(c[f>>2]|0);g=j*+r2();h[(c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=g;if((c[13799]|0)<=2){i=d;return}Sm(c[e>>2]|0,c[f>>2]|0);i=d;return}function Um(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;c[g>>2]=b;c[h>>2]=e;if(a[138998]|0)Y2(c[24742]|0,127150,f)|0;c[j>>2]=vl(c[g>>2]|0,c[h>>2]|0,2)|0;if((c[j>>2]|0)==1){i=f;return}if((c[j>>2]|0)==0&(c[12731]|0)==0){$z(0,127177,f+8|0)|0;c[12731]=1}c[k>>2]=0;while(1){j=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[k>>2]<<2)>>2]|0;c[l>>2]=j;if(!j)break;if((d[(c[(c[l>>2]|0)+8>>2]|0)+119>>0]|0)<=0)Tm(c[l>>2]|0,1);c[k>>2]=(c[k>>2]|0)+1}i=f;return}function Vm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0;e=i;i=i+160|0;f=e+104|0;g=e+148|0;j=e+144|0;k=e+140|0;l=e+136|0;m=e+132|0;n=e+88|0;o=e+128|0;p=e+124|0;q=e+8|0;r=e;s=e+120|0;t=e+116|0;u=e+112|0;c[g>>2]=b;c[j>>2]=d;if(a[138998]|0){Y2(c[24742]|0,127226,e+96|0)|0;_N()}c[p>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2];c[o>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+160>>2];c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0))break;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[k>>2]|0))break;h[r>>3]=1.0/(+h[(c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]*+h[(c[(c[o>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]);d=VA(c[g>>2]|0,c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[k>>2]<<2)>>2]|0,c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[l>>2]<<2)>>2]|0,0,0)|0;c[u>>2]=d;if(d)h[r>>3]=+h[r>>3]*+h[(c[(c[u>>2]|0)+8>>2]|0)+128>>3];v=+h[r>>3];h[(c[(c[p>>2]|0)+(c[l>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]=v;h[(c[(c[p>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]=v;c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0))break;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[13799]|0))break;h[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+168>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[m>>2]=(c[m>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){p=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[k>>2]<<2)>>2]|0;c[s>>2]=p;if(!p)break;c[l>>2]=0;while(1){w=c[k>>2]|0;if((c[l>>2]|0)>=(c[j>>2]|0))break;a:do if((w|0)!=(c[l>>2]|0)){c[t>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[l>>2]<<2)>>2];h[n>>3]=+Lm(c[(c[(c[s>>2]|0)+8>>2]|0)+132>>2]|0,c[(c[(c[t>>2]|0)+8>>2]|0)+132>>2]|0,q);c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[13799]|0))break a;h[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]=+h[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]*(+h[q+(c[m>>2]<<3)>>3]-+h[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+160>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]*+h[q+(c[m>>2]<<3)>>3]/+h[n>>3]);p=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+168>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[m>>2]<<3)|0;h[p>>3]=+h[p>>3]+ +h[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}}while(0);c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=w+1}if(!(a[138998]|0)){i=e;return}w=c[24742]|0;h[f>>3]=+$N();Y2(w,127252,f)|0;i=e;return}function Wm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0;e=i;i=i+48|0;f=e+24|0;g=e+8|0;j=e;k=e+40|0;l=e+36|0;m=e+32|0;c[k>>2]=b;c[l>>2]=d;h[4139]=+h[4247]*+h[4247];while(1){d=Xm(c[k>>2]|0,c[l>>2]|0)|0;c[m>>2]=d;if(!d)break;Ym(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)}if(a[138998]|0){m=c[24742]|0;h[j>>3]=+mn(c[k>>2]|0,c[l>>2]|0);Y2(m,127262,j)|0;j=c[24742]|0;m=c[(c[(c[k>>2]|0)+8>>2]|0)+156>>2]|0;l=(c[(c[(c[k>>2]|0)+8>>2]|0)+156>>2]|0)==(c[13798]|0)?127276:178518;n=+$N();c[g>>2]=m;c[g+4>>2]=l;h[g+8>>3]=n;Y2(j,127278,g)|0}if((c[(c[(c[k>>2]|0)+8>>2]|0)+156>>2]|0)!=(c[13798]|0)){i=e;return}g=c[13798]|0;j=wB(c[k>>2]|0)|0;c[f>>2]=g;c[f+4>>2]=j;$z(0,127305,f)|0;i=e;return}function Xm(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+64|0;f=e+24|0;g=e+16|0;j=e+52|0;k=e+48|0;l=e+44|0;m=e+40|0;n=e+36|0;o=e+8|0;p=e;q=e+32|0;r=e+28|0;c[k>>2]=a;c[l>>2]=b;c[12732]=(c[12732]|0)+1;if((c[(c[(c[k>>2]|0)+8>>2]|0)+156>>2]|0)>=(c[13798]|0)){c[j>>2]=0;s=c[j>>2]|0;i=e;return s|0}h[p>>3]=0.0;c[q>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[l>>2]|0))break;c[r>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+152>>2]|0)+(c[m>>2]<<2)>>2];if((d[(c[(c[r>>2]|0)+8>>2]|0)+119>>0]|0|0)<=1){h[o>>3]=0.0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[13799]|0))break;h[o>>3]=+h[o>>3]+ +h[(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+168>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<3)>>3]*+h[(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+168>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}if(+h[o>>3]>+h[p>>3]){c[q>>2]=c[r>>2];h[p>>3]=+h[o>>3]}}c[m>>2]=(c[m>>2]|0)+1}if(!(+h[p>>3]<+h[4139])){if(((d[138998]|0|0)!=0?((c[12732]|0)%100|0|0)==0:0)?(m=c[24742]|0,h[g>>3]=+O(+(+h[p>>3])),Y2(m,127347,g)|0,((c[12732]|0)%1e3|0|0)==0):0)Y2(c[24742]|0,193392,f)|0}else c[q>>2]=0;c[j>>2]=c[q>>2];s=c[j>>2]|0;i=e;return s|0}function Ym(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0;e=i;i=i+48|0;f=e+8|0;g=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;n=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[m>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+120>>2];if(c[12733]|0)o=eK(c[12733]|0,(_(c[13799]|0,c[13799]|0)|0)<<3)|0;else o=cK((_(c[13799]|0,c[13799]|0)|0)<<3)|0;c[12733]=o;_m(c[g>>2]|0,c[j>>2]|0,c[m>>2]|0,c[12733]|0);c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[13799]|0))break;h[33120+(c[l>>2]<<3)>>3]=-+h[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+168>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}qu(c[12733]|0,33200,33120,c[13799]|0);c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[13799]|0))break;p=+h[4249];q=(1.0-+h[4249])*2.0;r=p+q*+r2();h[33200+(c[l>>2]<<3)>>3]=r*+h[33200+(c[l>>2]<<3)>>3];o=(c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0)+(c[l>>2]<<3)|0;h[o>>3]=+h[o>>3]+ +h[33200+(c[l>>2]<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}o=(c[(c[g>>2]|0)+8>>2]|0)+156|0;c[o>>2]=(c[o>>2]|0)+1;Zm(c[g>>2]|0,c[j>>2]|0,c[m>>2]|0);if(!(wO()|0)){i=e;return}h[n>>3]=0.0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[13799]|0))break;r=+N(+(+h[33200+(c[l>>2]<<3)>>3]));h[n>>3]=+h[n>>3]+r;c[l>>2]=(c[l>>2]|0)+1}h[n>>3]=+O(+(+h[n>>3]));l=c[24742]|0;m=wB(c[k>>2]|0)|0;r=+h[n>>3];c[f>>2]=m;h[f+8>>3]=r;Y2(l,127353,f)|0;i=e;return}function Zm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+128|0;f=e+120|0;g=e+116|0;j=e+112|0;k=e+108|0;l=e+104|0;m=e+16|0;n=e+8|0;o=e;p=e+100|0;q=e+96|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[p>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+152>>2]|0)+(c[j>>2]<<2)>>2];c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[13799]|0))break;h[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+168>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]=0.0;c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[g>>2]|0))break;a:do if((c[j>>2]|0)!=(c[k>>2]|0)){c[q>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+152>>2]|0)+(c[k>>2]<<2)>>2];h[n>>3]=+Lm(c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]|0,c[(c[(c[q>>2]|0)+8>>2]|0)+132>>2]|0,m);c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[13799]|0))break a;h[o>>3]=+h[(c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3];h[(c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]=+h[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]*(+h[m+(c[l>>2]<<3)>>3]-+h[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+160>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]*+h[m+(c[l>>2]<<3)>>3]/+h[n>>3]);d=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+168>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[l>>2]<<3)|0;h[d>>3]=+h[d>>3]+ +h[(c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3];h[o>>3]=+h[(c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3];h[(c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]=-+h[(c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3];d=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+168>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[l>>2]<<3)|0;h[d>>3]=+h[d>>3]+(+h[(c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]-+h[o>>3]);c[l>>2]=(c[l>>2]|0)+1}}while(0);c[k>>2]=(c[k>>2]|0)+1}i=e;return}function _m(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0;f=i;i=i+144|0;g=f+136|0;j=f+132|0;k=f+128|0;l=f+124|0;m=f+120|0;n=f+116|0;o=f+112|0;p=f+108|0;q=f+104|0;r=f+88|0;s=f+80|0;t=f;u=f+100|0;v=f+96|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[u>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2];c[v>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+160>>2];c[q>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[k>>2]<<2)>>2];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[13799]|0))break;c[o>>2]=0;while(1){w=c[n>>2]|0;if((c[o>>2]|0)>=(c[13799]|0))break;e=_(w,c[13799]|0)|0;h[(c[l>>2]|0)+(e+(c[o>>2]|0)<<3)>>3]=0.0;c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=w+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;a:do if((c[k>>2]|0)!=(c[m>>2]|0)){c[p>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[m>>2]<<2)>>2];h[s>>3]=0.0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[13799]|0))break;h[t+(c[o>>2]<<3)>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+132>>2]|0)+(c[o>>2]<<3)>>3]-+h[(c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]|0)+(c[o>>2]<<3)>>3];h[s>>3]=+h[s>>3]+ +h[t+(c[o>>2]<<3)>>3]*+h[t+(c[o>>2]<<3)>>3];c[o>>2]=(c[o>>2]|0)+1}h[r>>3]=1.0/+Km(+h[s>>3]);c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[13799]|0))break a;c[n>>2]=0;while(1){x=+h[(c[(c[u>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3];y=+h[(c[(c[v>>2]|0)+(c[k>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3];if((c[n>>2]|0)>=(c[o>>2]|0))break;w=_(c[n>>2]|0,c[13799]|0)|0;e=(c[l>>2]|0)+(w+(c[o>>2]|0)<<3)|0;h[e>>3]=+h[e>>3]+x*y*+h[t+(c[o>>2]<<3)>>3]*+h[t+(c[n>>2]<<3)>>3]*+h[r>>3];c[n>>2]=(c[n>>2]|0)+1}e=_(c[o>>2]|0,c[13799]|0)|0;w=(c[l>>2]|0)+(e+(c[o>>2]|0)<<3)|0;h[w>>3]=+h[w>>3]+x*(1.0-y*(+h[s>>3]-+h[t+(c[o>>2]<<3)>>3]*+h[t+(c[o>>2]<<3)>>3])*+h[r>>3]);c[o>>2]=(c[o>>2]|0)+1}}while(0);c[m>>2]=(c[m>>2]|0)+1}c[o>>2]=1;while(1){if((c[o>>2]|0)>=(c[13799]|0))break;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[o>>2]|0))break;m=_(c[n>>2]|0,c[13799]|0)|0;r=_(c[o>>2]|0,c[13799]|0)|0;h[(c[l>>2]|0)+(r+(c[n>>2]|0)<<3)>>3]=+h[(c[l>>2]|0)+(m+(c[o>>2]|0)<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}i=f;return}function $m(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+124>>2];while(1){if((c[e>>2]|0)<=0){j=5;break}c[f>>2]=((c[e>>2]|0)-1|0)/2|0;c[g>>2]=c[(c[12734]|0)+(c[f>>2]<<2)>>2];if(+h[(c[(c[g>>2]|0)+8>>2]|0)+136>>3]<=+h[(c[(c[d>>2]|0)+8>>2]|0)+136>>3]){j=5;break}c[(c[12734]|0)+(c[f>>2]<<2)>>2]=c[d>>2];c[(c[(c[d>>2]|0)+8>>2]|0)+124>>2]=c[f>>2];c[(c[12734]|0)+(c[e>>2]<<2)>>2]=c[g>>2];c[(c[(c[g>>2]|0)+8>>2]|0)+124>>2]=c[e>>2];c[e>>2]=c[f>>2]}if((j|0)==5){i=b;return}}function an(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;j=b+4|0;k=b;c[d>>2]=a;c[e>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+124>>2];while(1){a=(c[e>>2]<<1)+1|0;c[f>>2]=a;if((a|0)>=(c[12735]|0)){l=9;break}c[g>>2]=(c[f>>2]|0)+1;if((c[g>>2]|0)<(c[12735]|0)?+h[(c[(c[(c[12734]|0)+(c[g>>2]<<2)>>2]|0)+8>>2]|0)+136>>3]<+h[(c[(c[(c[12734]|0)+(c[f>>2]<<2)>>2]|0)+8>>2]|0)+136>>3]:0)c[j>>2]=c[g>>2];else c[j>>2]=c[f>>2];c[k>>2]=c[(c[12734]|0)+(c[j>>2]<<2)>>2];if(+h[(c[(c[d>>2]|0)+8>>2]|0)+136>>3]<=+h[(c[(c[k>>2]|0)+8>>2]|0)+136>>3]){l=9;break}c[(c[12734]|0)+(c[j>>2]<<2)>>2]=c[d>>2];c[(c[(c[d>>2]|0)+8>>2]|0)+124>>2]=c[j>>2];c[(c[12734]|0)+(c[e>>2]<<2)>>2]=c[k>>2];c[(c[(c[k>>2]|0)+8>>2]|0)+124>>2]=c[e>>2];c[e>>2]=c[j>>2]}if((l|0)==9){i=b;return}}function bn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if((c[(c[(c[d>>2]|0)+8>>2]|0)+124>>2]|0)>=0)La(127362,127382,645,127390);a=c[12735]|0;c[12735]=a+1;c[e>>2]=a;c[(c[(c[d>>2]|0)+8>>2]|0)+124>>2]=c[e>>2];c[(c[12734]|0)+(c[e>>2]<<2)>>2]=c[d>>2];if((c[e>>2]|0)<=0){i=b;return}$m(c[d>>2]|0);i=b;return}function cn(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;a=i;i=i+16|0;b=a+12|0;d=a+8|0;e=a+4|0;f=a;if(!(c[12735]|0)){c[b>>2]=0;g=c[b>>2]|0;i=a;return g|0}c[e>>2]=c[c[12734]>>2];h=(c[12735]|0)+-1|0;c[12735]=h;c[d>>2]=h;c[f>>2]=c[(c[12734]|0)+(c[d>>2]<<2)>>2];c[c[12734]>>2]=c[f>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+124>>2]=0;if((c[d>>2]|0)>1)an(c[f>>2]|0);c[(c[(c[e>>2]|0)+8>>2]|0)+124>>2]=-1;c[b>>2]=c[e>>2];g=c[b>>2]|0;i=a;return g|0}function dn(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+8|0;g=e+24|0;j=e+20|0;k=e+16|0;c[g>>2]=b;c[j>>2]=d;c[12734]=bK((c[j>>2]|0)+1<<2)|0;if(a[138998]|0){Y2(c[24742]|0,127404,e)|0;_N()}c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;en(c[g>>2]|0,c[k>>2]|0);c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}if(!(a[138998]|0)){l=c[12734]|0;O4(l);i=e;return}k=c[24742]|0;h[f>>3]=+$N();Y2(k,127252,f)|0;l=c[12734]|0;O4(l);i=e;return}function en(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d;c[e>>2]=a;c[f>>2]=b;c[l>>2]=0;while(1){b=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+152>>2]|0)+(c[l>>2]<<2)>>2]|0;c[g>>2]=b;if(!b)break;h[(c[(c[g>>2]|0)+8>>2]|0)+136>>3]=+h[4248];c[l>>2]=(c[l>>2]|0)+1}c[12736]=c[f>>2];h[(c[(c[12736]|0)+8>>2]|0)+136>>3]=0.0;c[(c[(c[12736]|0)+8>>2]|0)+128>>2]=0;bn(c[12736]|0);a:while(1){f=cn()|0;c[g>>2]=f;if(!f)break;if((c[g>>2]|0)!=(c[12736]|0))fn(c[e>>2]|0,c[12736]|0,c[g>>2]|0,+h[(c[(c[g>>2]|0)+8>>2]|0)+136>>3]);c[k>>2]=TA(c[e>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))continue a;f=c[k>>2]|0;l=c[((c[c[k>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0;c[j>>2]=l;if((l|0)==(c[g>>2]|0)){l=c[k>>2]|0;c[j>>2]=c[((c[c[k>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]}h[m>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+136>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+136>>3];do if(+h[(c[(c[j>>2]|0)+8>>2]|0)+136>>3]>+h[m>>3]){h[(c[(c[j>>2]|0)+8>>2]|0)+136>>3]=+h[m>>3];if((c[(c[(c[j>>2]|0)+8>>2]|0)+124>>2]|0)>=0){$m(c[j>>2]|0);break}else{c[(c[(c[j>>2]|0)+8>>2]|0)+128>>2]=(c[(c[(c[g>>2]|0)+8>>2]|0)+128>>2]|0)+1;bn(c[j>>2]|0);break}}while(0);c[k>>2]=UA(c[e>>2]|0,c[k>>2]|0,c[g>>2]|0)|0}}i=d;return}function fn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;j=f+20|0;k=f+16|0;l=f;m=f+12|0;n=f+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=e;c[m>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+120>>2];c[n>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+120>>2];e=+h[l>>3];h[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+160>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[m>>2]<<3)>>3]=e;h[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+160>>2]|0)+(c[m>>2]<<2)>>2]|0)+(c[n>>2]<<3)>>3]=e;i=f;return}function gn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[l>>2]=0;c[m>>2]=0;c[k>>2]=TA(c[g>>2]|0,c[h>>2]|0)|0;a:while(1){if(!(c[k>>2]|0)){n=15;break}d=c[k>>2]|0;b=c[k>>2]|0;do if((c[((c[c[k>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)!=(c[((c[c[k>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)){a=c[k>>2]|0;o=(c[((c[c[k>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)==(c[h>>2]|0);if((c[l>>2]|0)==1){if(o?(a=c[k>>2]|0,(c[((c[c[k>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)==(c[m>>2]|0)):0)break;a=c[k>>2]|0;if((c[((c[c[k>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)!=(c[m>>2]|0)){n=9;break a}a=c[k>>2]|0;if((c[((c[c[k>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)==(c[h>>2]|0))break;else{n=9;break a}}else{a=c[c[k>>2]>>2]&3;if(o){o=c[k>>2]|0;c[m>>2]=c[((a|0)==2?o:o+-32|0)+28>>2]}else{o=c[k>>2]|0;c[m>>2]=c[((a|0)==3?o:o+32|0)+28>>2]}c[c[j>>2]>>2]=c[m>>2];c[l>>2]=(c[l>>2]|0)+1;break}}while(0);c[k>>2]=UA(c[g>>2]|0,c[k>>2]|0,c[h>>2]|0)|0}if((n|0)==9){c[f>>2]=2;p=c[f>>2]|0;i=e;return p|0}else if((n|0)==15){c[f>>2]=c[l>>2];p=c[f>>2]|0;i=e;return p|0}return 0}function hn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;while(1){if(!(c[g>>2]|0))break;c[k>>2]=gn(c[f>>2]|0,c[g>>2]|0,j)|0;if(!(c[k>>2]|0)){if((c[h>>2]|0)==(c[g>>2]|0))c[h>>2]=aC(c[f>>2]|0,c[g>>2]|0)|0;pC(c[(c[f>>2]|0)+48>>2]|0,c[g>>2]|0)|0;c[g>>2]=0;continue}if((c[k>>2]|0)!=1){c[g>>2]=0;continue}if((c[h>>2]|0)==(c[g>>2]|0))c[h>>2]=aC(c[f>>2]|0,c[g>>2]|0)|0;pC(c[(c[f>>2]|0)+48>>2]|0,c[g>>2]|0)|0;c[g>>2]=c[j>>2]}i=e;return c[h>>2]|0}function jn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+64|0;g=f+24|0;j=f+56|0;k=f+52|0;l=f+48|0;m=f+16|0;n=f+44|0;o=f+8|0;p=f;q=f+40|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;h[m>>3]=e;h[o>>3]=0.0;c[n>>2]=OA(c[j>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;k=nn(c[n>>2]|0,c[l>>2]|0,p)|0;c[q>>2]=k;if(k){if((c[q>>2]|0)==2){k=wB(c[j>>2]|0)|0;e=+h[m>>3];c[g>>2]=k;h[g+8>>3]=e;$z(3,127433,g)|0}h[p>>3]=+h[m>>3]}h[(c[(c[n>>2]|0)+8>>2]|0)+136>>3]=+h[p>>3];h[o>>3]=+h[o>>3]+ +h[p>>3];c[n>>2]=QA(c[j>>2]|0,c[n>>2]|0)|0}i=f;return +(+h[o>>3])}function kn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f+32|0;j=f+28|0;k=f+24|0;l=f;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=e;c[m>>2]=bK((c[g>>2]|0)+1<<2)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[g>>2]|0))break;d=bK((c[j>>2]|0)+1<<2)|0;c[(c[m>>2]|0)+(c[n>>2]<<2)>>2]=d;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[j>>2]|0))break;d=bK(c[k>>2]<<3)|0;c[(c[(c[m>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[o>>2]<<2)>>2]=d;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[k>>2]|0))break;h[(c[(c[(c[m>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[o>>2]<<2)>>2]|0)+(c[p>>2]<<3)>>3]=+h[l>>3];c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}c[(c[(c[m>>2]|0)+(c[n>>2]<<2)>>2]|0)+(c[o>>2]<<2)>>2]=0;c[n>>2]=(c[n>>2]|0)+1}c[(c[m>>2]|0)+(c[n>>2]<<2)>>2]=0;i=f;return c[m>>2]|0}function ln(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[e>>2]=0;while(1){if(!(c[(c[d>>2]|0)+(c[e>>2]<<2)>>2]|0))break;c[f>>2]=0;while(1){if(!(c[(c[(c[d>>2]|0)+(c[e>>2]<<2)>>2]|0)+(c[f>>2]<<2)>>2]|0))break;O4(c[(c[(c[d>>2]|0)+(c[e>>2]<<2)>>2]|0)+(c[f>>2]<<2)>>2]|0);c[f>>2]=(c[f>>2]|0)+1}O4(c[(c[d>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}O4(c[d>>2]|0);i=b;return}function mn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;j=d+36|0;k=d+32|0;l=d+16|0;m=d+8|0;n=d;o=d+28|0;p=d+24|0;c[e>>2]=a;c[f>>2]=b;h[l>>3]=0.0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=((c[f>>2]|0)-1|0))break;c[o>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+152>>2]|0)+(c[g>>2]<<2)>>2];c[j>>2]=(c[g>>2]|0)+1;while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;c[p>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+152>>2]|0)+(c[j>>2]<<2)>>2];h[m>>3]=0.0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[13799]|0))break;h[n>>3]=+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0)+(c[k>>2]<<3)>>3]-+h[(c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]|0)+(c[k>>2]<<3)>>3];h[m>>3]=+h[m>>3]+ +h[n>>3]*+h[n>>3];c[k>>2]=(c[k>>2]|0)+1}h[l>>3]=+h[l>>3]+ +h[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]|0)+(c[g>>2]<<2)>>2]|0)+(c[j>>2]<<3)>>3]*(+h[m>>3]+ +h[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)+(c[g>>2]<<2)>>2]|0)+(c[j>>2]<<3)>>3]*+h[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)+(c[g>>2]<<2)>>2]|0)+(c[j>>2]<<3)>>3]-+h[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)+(c[g>>2]<<2)>>2]|0)+(c[j>>2]<<3)>>3]*2.0*+O(+(+h[m>>3])));c[j>>2]=(c[j>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1}i=d;return +(+h[l>>3])}function nn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+8|0;j=f;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;if(!(c[m>>2]|0)){c[k>>2]=1;p=c[k>>2]|0;i=f;return p|0}c[o>>2]=zA(c[l>>2]|0,c[m>>2]|0)|0;if(!(a[c[o>>2]>>0]|0)){c[k>>2]=1;p=c[k>>2]|0;i=f;return p|0}m=c[o>>2]|0;c[j>>2]=c[n>>2];if(((l3(m,139001,j)|0)>=1?!(+h[c[n>>2]>>3]<0.0):0)?((c[13795]|0)!=0?1:+h[c[n>>2]>>3]!=0.0):0){c[k>>2]=0;p=c[k>>2]|0;i=f;return p|0}c[g>>2]=c[o>>2];$z(0,127460,g)|0;c[k>>2]=2;p=c[k>>2]|0;i=f;return p|0}function on(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=a;QO(c[e>>2]|0,2);b[(c[(c[e>>2]|0)+8>>2]|0)+176>>1]=2;c[13799]=2;rn(c[e>>2]|0);i=d;return}function pn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+128|0;e=d+32|0;f=d+24|0;g=d+16|0;j=d+116|0;k=d+112|0;l=d+108|0;m=d+104|0;n=d;o=d+100|0;p=d+96|0;q=d+92|0;r=d+88|0;s=d+84|0;t=d+80|0;u=d+76|0;v=d+72|0;w=d+40|0;c[j>>2]=b;c[k>>2]=0;c[m>>2]=0;c[o>>2]=0;if(!(kB(c[j>>2]|0)|0)){i=d;return}on(c[j>>2]|0);c[l>>2]=yA(c[j>>2]|0,133229)|0;b=yA(c[j>>2]|0,133229)|0;c[l>>2]=b;do if(b){if(!(a[c[l>>2]>>0]|0)){c[m>>2]=1;break}c[k>>2]=fC(c[j>>2]|0,c[l>>2]|0,0)|0;if(!(c[k>>2]|0)){c[g>>2]=c[l>>2];$z(0,127478,g)|0;$z(3,127518,f)|0;c[m>>2]=1}}while(0);f=yA(c[j>>2]|0,178751)|0;c[l>>2]=f;if(((f|0)!=0?(a[c[l>>2]>>0]|0)!=0:0)?(f=c[l>>2]|0,c[e>>2]=n,c[e+4>>2]=n+8,l=l3(f,143965,e)|0,c[p>>2]=l,(l|0)!=0):0){if((c[p>>2]|0)==1)h[n+8>>3]=+h[n>>3];c[o>>2]=1}if(kB(c[j>>2]|0)|0){c[s>>2]=0;c[q>>2]=fG(c[j>>2]|0,u,0)|0;o=c[j>>2]|0;if((c[u>>2]|0)==1){c[s>>2]=su(o,c[k>>2]|0)|0;if(!((c[m>>2]|0)==0|(c[k>>2]|0)!=0))c[k>>2]=c[s>>2];c[t>>2]=$B(c[j>>2]|0)|0;O4(c[(c[(c[t>>2]|0)+8>>2]|0)+112>>2]|0);c[(c[(c[t>>2]|0)+8>>2]|0)+112>>2]=0;fq(c[j>>2]|0)|0;gm(c[j>>2]|0)}else{GG(o,2,8,w)|0;c[w+12>>2]=0;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[u>>2]|0))break;c[r>>2]=c[(c[q>>2]|0)+(c[v>>2]<<2)>>2];if((c[k>>2]|0)!=0?(AC(c[r>>2]|0,c[k>>2]|0)|0)!=0:0)c[s>>2]=c[k>>2];else c[s>>2]=0;iG(c[r>>2]|0)|0;c[s>>2]=su(c[r>>2]|0,c[s>>2]|0)|0;if(!((c[m>>2]|0)==0|(c[k>>2]|0)!=0))c[k>>2]=c[s>>2];fq(c[r>>2]|0)|0;c[v>>2]=(c[v>>2]|0)+1}c[t>>2]=$B(c[j>>2]|0)|0;O4(c[(c[(c[t>>2]|0)+8>>2]|0)+112>>2]|0);c[(c[(c[t>>2]|0)+8>>2]|0)+112>>2]=0;FG(c[u>>2]|0,c[q>>2]|0,c[j>>2]|0,w)|0;gm(c[j>>2]|0)}c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[u>>2]|0))break;pC(c[j>>2]|0,c[(c[q>>2]|0)+(c[v>>2]<<2)>>2]|0)|0;c[v>>2]=(c[v>>2]|0)+1}O4(c[q>>2]|0)}if(c[m>>2]|0){m=c[j>>2]|0;AA(m,133229,wB(c[k>>2]|0)|0)|0}nL(c[j>>2]|0);i=d;return}function qn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;if(!(c[e>>2]|0)){i=b;return}while(1){g=c[d>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=OA(g,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;TO(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}UO(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}sn(g);i=b;return}function rn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[g>>2]=0;c[h>>2]=kB(c[d>>2]|0)|0;c[j>>2]=bK((c[h>>2]|0)*40|0)|0;a=bK((c[h>>2]|0)+1<<2)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;ql(c[e>>2]|0);c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]=(c[j>>2]|0)+((c[g>>2]|0)*40|0);a=c[e>>2]|0;h=c[g>>2]|0;c[g>>2]=h+1;c[(c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0)+(h<<2)>>2]=a;c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;tn(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function sn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0);a=c[d>>2]|0;if((a|0)==(rC(c[d>>2]|0)|0)){i=b;return}PC(c[d>>2]|0,0,175049);i=b;return}function tn(a){a=a|0;var b=0,d=0,e=0.0;b=i;i=i+16|0;d=b;c[d>>2]=a;MC(c[d>>2]|0,175319,176,1)|0;yO(c[d>>2]|0)|0;e=+fO(c[d>>2]|0,c[13851]|0,1.0,0.0);h[(c[(c[d>>2]|0)+8>>2]|0)+128>>3]=e;i=b;return}function un(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;wn(c[d>>2]|0);if((kB(c[d>>2]|0)|0)==0?(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0)==0:0){i=b;return}Iu(c[d>>2]|0);nL(c[d>>2]|0);i=b;return}function vn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;if(!(c[e>>2]|0)){i=b;return}O4(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0);while(1){g=c[d>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=OA(g,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;TO(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}UO(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}xn(g);i=b;return}function wn(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=a;c[13816]=qA(c[e>>2]|0,1,147662,147668)|0;QO(c[e>>2]|0,2);b[(c[(c[e>>2]|0)+8>>2]|0)+176>>1]=2;c[13799]=2;yn(c[e>>2]|0,0,c[e>>2]|0);zn(c[e>>2]|0);i=d;return}function xn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0);a=c[d>>2]|0;if((a|0)==(rC(c[d>>2]|0)|0)){i=b;return}PC(c[d>>2]|0,0,175049);i=b;return}function yn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[g>>2]|0)){c[l>>2]=k;Cn(c[l>>2]|0)}else c[l>>2]=c[g>>2];c[j>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;d=(P3(wB(c[j>>2]|0)|0,145613,7)|0)!=0;b=c[j>>2]|0;if(d)yn(b,c[l>>2]|0,c[h>>2]|0);else{MC(b,175049,280,1)|0;Dn(c[l>>2]|0,c[j>>2]|0);yn(c[j>>2]|0,0,c[j>>2]|0)}c[j>>2]=HD(c[j>>2]|0)|0}if(c[g>>2]|0){i=e;return}c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]=c[k+8>>2];if(!(c[k+8>>2]|0)){i=e;return}g=eK(c[k>>2]|0,(c[k+8>>2]|0)+1<<2)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]=g;i=e;return}function zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[g>>2]=0;c[h>>2]=bK((kB(c[d>>2]|0)|0)<<2)|0;a=bK((kB(c[d>>2]|0)|0)+1<<2)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;MC(c[e>>2]|0,175026,304,1)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]=(c[h>>2]|0)+(c[g>>2]<<2);a=c[e>>2]|0;j=c[g>>2]|0;c[g>>2]=j+1;c[(c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0)+(j<<2)>>2]=a;An(c[e>>2]|0);c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;Bn(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function An(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;AA(c[d>>2]|0,147662,147668)|0;i=b;return}function Bn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;MC(c[d>>2]|0,175319,304,1)|0;i=b;return}function Cn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[c[d>>2]>>2]=0;c[(c[d>>2]|0)+4>>2]=0;c[(c[d>>2]|0)+8>>2]=0;i=b;return}function Dn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=(c[e>>2]|0)+8|0;c[b>>2]=(c[b>>2]|0)+1;if((c[(c[e>>2]|0)+8>>2]|0)>=(c[(c[e>>2]|0)+4>>2]|0)){b=(c[e>>2]|0)+4|0;c[b>>2]=(c[b>>2]|0)+10;b=eK(c[c[e>>2]>>2]|0,c[(c[e>>2]|0)+4>>2]<<2)|0;c[c[e>>2]>>2]=b}c[(c[c[e>>2]>>2]|0)+(c[(c[e>>2]|0)+8>>2]<<2)>>2]=c[f>>2];i=d;return}function En(a){a=a|0;var b=0,d=0,f=0,g=0,j=0;b=i;i=i+16|0;d=b+8|0;f=b+4|0;g=b;c[d>>2]=a;Gn(c[d>>2]|0);Hn(c[d>>2]|0,0,c[d>>2]|0);In(c[d>>2]|0,0);Jn(c[d>>2]|0,0);a=c[d>>2]|0;if(!(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]|0)){c[g>>2]=(e[(c[a+8>>2]|0)+136>>1]|0)&14;if(!(c[g>>2]|0)){j=c[d>>2]|0;nL(j);i=b;return}dm(c[d>>2]|0,c[g>>2]|0)|0;j=c[d>>2]|0;nL(j);i=b;return}c[f>>2]=$B(a)|0;while(1){if(!(c[f>>2]|0))break;h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]/72.0;h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]/72.0;c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}em(c[d>>2]|0,1);j=c[d>>2]|0;nL(j);i=b;return}function Fn(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;UO(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}Kn(c[d>>2]|0);i=b;return}function Gn(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;QO(c[e>>2]|0,2);b[(c[(c[e>>2]|0)+8>>2]|0)+176>>1]=2;c[13799]=2;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;ql(c[f>>2]|0);c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[g>>2]=OA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;MC(c[g>>2]|0,175319,176,1)|0;yO(c[g>>2]|0)|0;c[g>>2]=QA(c[e>>2]|0,c[g>>2]|0)|0}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}i=d;return}function Hn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[g>>2]|0)){c[l>>2]=k;Pn(c[l>>2]|0)}else c[l>>2]=c[g>>2];c[j>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;d=(P3(wB(c[j>>2]|0)|0,145613,7)|0)!=0;b=c[j>>2]|0;if(d)Hn(b,c[l>>2]|0,c[h>>2]|0);else{MC(b,175049,280,1)|0;LJ(c[j>>2]|0);Qn(c[l>>2]|0,c[j>>2]|0);Hn(c[j>>2]|0,0,c[j>>2]|0)}c[j>>2]=HD(c[j>>2]|0)|0}if(c[g>>2]|0){i=e;return}c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]=c[k+8>>2];if(!(c[k+8>>2]|0)){i=e;return}g=eK(c[k>>2]|0,(c[k+8>>2]|0)+1<<2)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]=g;i=e;return}function In(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0;e=i;i=i+608|0;f=e+480|0;g=e+464|0;j=e+424|0;k=e+400|0;l=e+360|0;m=e+320|0;n=e+296|0;o=e+256|0;p=e+248|0;q=e+240|0;r=e+592|0;s=e+588|0;t=e+584|0;u=e+580|0;v=e+576|0;w=e+572|0;x=e+568|0;y=e+564|0;z=e+560|0;A=e+556|0;B=e+552|0;C=e+208|0;D=e+176|0;E=e+160|0;F=e+520|0;G=e+512|0;H=e+152|0;I=e+508|0;J=e+504|0;K=e+500|0;L=e+496|0;M=e+136|0;N=e+120|0;O=e+104|0;P=e+88|0;Q=e+80|0;R=e+64|0;S=e+48|0;T=e+32|0;U=e+16|0;V=e;c[r>>2]=a;c[s>>2]=b;c[x>>2]=0;c[J>>2]=0;c[K>>2]=0;c[L>>2]=c[(c[r>>2]|0)+48>>2];if((d[138998]|0|0)>1){Ln(c[s>>2]|0);b=c[24742]|0;c[q>>2]=wB(c[r>>2]|0)|0;Y2(b,127816,q)|0}c[t>>2]=1;while(1){if((c[t>>2]|0)>(c[(c[(c[r>>2]|0)+8>>2]|0)+180>>2]|0))break;c[z>>2]=c[(c[(c[(c[r>>2]|0)+8>>2]|0)+184>>2]|0)+(c[t>>2]<<2)>>2];In(c[z>>2]|0,(c[s>>2]|0)+1|0);q=kB(c[z>>2]|0)|0;c[x>>2]=(c[x>>2]|0)+q;c[t>>2]=(c[t>>2]|0)+1}c[w>>2]=kB(c[r>>2]|0)|0;c[v>>2]=(c[w>>2]|0)-(c[x>>2]|0)+(c[(c[(c[r>>2]|0)+8>>2]|0)+180>>2]|0);if((c[v>>2]|0)==0?(c[(c[(c[r>>2]|0)+8>>2]|0)+12>>2]|0)==0:0){h[(c[(c[r>>2]|0)+8>>2]|0)+16+8>>3]=0.0;h[(c[(c[r>>2]|0)+8>>2]|0)+16>>3]=0.0;h[(c[(c[r>>2]|0)+8>>2]|0)+16+16+8>>3]=18.0;h[(c[(c[r>>2]|0)+8>>2]|0)+16+16>>3]=18.0;i=e;return}c[G>>2]=GG(c[r>>2]|0,4,4,F)|0;if((c[G>>2]|0)>>>0<3)c[F+16>>2]=3;do if((c[F+16>>2]|0)==4?(c[F+28>>2]&2|0)!=0:0){c[J>>2]=qA(c[L>>2]|0,0,136869,0)|0;c[K>>2]=qA(c[L>>2]|0,1,136869,0)|0;if((c[J>>2]|0)!=0|(c[K>>2]|0)!=0){c[F+24>>2]=bK(c[v>>2]|0)|0;break}else{c[p>>2]=wB(c[r>>2]|0)|0;$z(0,127607,p)|0;break}}while(0);c[A>>2]=bK(c[v>>2]<<5)|0;c[I>>2]=bK(c[v>>2]<<2)|0;c[u>>2]=0;c[t>>2]=1;while(1){if((c[t>>2]|0)>(c[(c[(c[r>>2]|0)+8>>2]|0)+180>>2]|0))break;c[z>>2]=c[(c[(c[(c[r>>2]|0)+8>>2]|0)+184>>2]|0)+(c[t>>2]<<2)>>2];p=(c[A>>2]|0)+(c[u>>2]<<5)|0;L=(c[(c[z>>2]|0)+8>>2]|0)+16|0;c[p>>2]=c[L>>2];c[p+4>>2]=c[L+4>>2];c[p+8>>2]=c[L+8>>2];c[p+12>>2]=c[L+12>>2];c[p+16>>2]=c[L+16>>2];c[p+20>>2]=c[L+20>>2];c[p+24>>2]=c[L+24>>2];c[p+28>>2]=c[L+28>>2];if((c[F+24>>2]|0)!=0&(c[J>>2]|0)!=0){L=eO(c[z>>2]|0,c[J>>2]|0,0,0)|0;c[(c[F+24>>2]|0)+(c[u>>2]<<2)>>2]=L}L=c[z>>2]|0;p=c[u>>2]|0;c[u>>2]=p+1;c[(c[I>>2]|0)+(p<<2)>>2]=L;c[t>>2]=(c[t>>2]|0)+1}a:do if(((c[w>>2]|0)-(c[x>>2]|0)|0)>0){c[y>>2]=$B(c[r>>2]|0)|0;while(1){if(!(c[y>>2]|0))break a;if(!(c[(c[(c[y>>2]|0)+8>>2]|0)+112>>2]|0)){c[(c[(c[y>>2]|0)+8>>2]|0)+112>>2]=c[r>>2];h[C>>3]=0.0;h[C+8>>3]=0.0;h[C+16>>3]=+h[(c[(c[y>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[y>>2]|0)+8>>2]|0)+96>>3];h[C+16+8>>3]=+h[(c[(c[y>>2]|0)+8>>2]|0)+80>>3];t=(c[A>>2]|0)+(c[u>>2]<<5)|0;c[t>>2]=c[C>>2];c[t+4>>2]=c[C+4>>2];c[t+8>>2]=c[C+8>>2];c[t+12>>2]=c[C+12>>2];c[t+16>>2]=c[C+16>>2];c[t+20>>2]=c[C+20>>2];c[t+24>>2]=c[C+24>>2];c[t+28>>2]=c[C+28>>2];if((c[F+24>>2]|0)!=0&(c[K>>2]|0)!=0){t=eO(c[y>>2]|0,c[K>>2]|0,0,0)|0;c[(c[F+24>>2]|0)+(c[u>>2]<<2)>>2]=t}t=c[y>>2]|0;J=c[u>>2]|0;c[u>>2]=J+1;c[(c[I>>2]|0)+(J<<2)>>2]=t}c[y>>2]=aC(c[r>>2]|0,c[y>>2]|0)|0}}while(0);c[B>>2]=CG(c[v>>2]|0,c[A>>2]|0,F)|0;if(c[F+24>>2]|0)O4(c[F+24>>2]|0);Mn(M,2147483647.0,2147483647.0);c[D>>2]=c[M>>2];c[D+4>>2]=c[M+4>>2];c[D+8>>2]=c[M+8>>2];c[D+12>>2]=c[M+12>>2];M=D+16|0;Mn(N,-2147483647.0,-2147483647.0);c[M>>2]=c[N>>2];c[M+4>>2]=c[N+4>>2];c[M+8>>2]=c[N+8>>2];c[M+12>>2]=c[N+12>>2];c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[v>>2]|0))break;h[E>>3]=+(c[(c[B>>2]|0)+(c[u>>2]<<3)>>2]|0);h[E+8>>3]=+(c[(c[B>>2]|0)+(c[u>>2]<<3)+4>>2]|0);N=(c[A>>2]|0)+(c[u>>2]<<5)|0;c[C>>2]=c[N>>2];c[C+4>>2]=c[N+4>>2];c[C+8>>2]=c[N+8>>2];c[C+12>>2]=c[N+12>>2];c[C+16>>2]=c[N+16>>2];c[C+20>>2]=c[N+20>>2];c[C+24>>2]=c[N+24>>2];c[C+28>>2]=c[N+28>>2];h[C>>3]=+h[C>>3]+ +h[E>>3];N=C+16|0;h[N>>3]=+h[N>>3]+ +h[E>>3];N=C+8|0;h[N>>3]=+h[N>>3]+ +h[E+8>>3];N=C+16+8|0;h[N>>3]=+h[N>>3]+ +h[E+8>>3];h[D>>3]=+h[D>>3]<+h[C>>3]?+h[D>>3]:+h[C>>3];h[D+8>>3]=+h[D+8>>3]<+h[C+8>>3]?+h[D+8>>3]:+h[C+8>>3];h[D+16>>3]=+h[D+16>>3]>+h[C+16>>3]?+h[D+16>>3]:+h[C+16>>3];if(+h[D+16+8>>3]>+h[C+16+8>>3])W=+h[D+16+8>>3];else W=+h[C+16+8>>3];h[D+16+8>>3]=W;N=c[(c[I>>2]|0)+(c[u>>2]<<2)>>2]|0;if((c[u>>2]|0)<(c[(c[(c[r>>2]|0)+8>>2]|0)+180>>2]|0)){c[z>>2]=N;M=(c[(c[z>>2]|0)+8>>2]|0)+16|0;c[M>>2]=c[C>>2];c[M+4>>2]=c[C+4>>2];c[M+8>>2]=c[C+8>>2];c[M+12>>2]=c[C+12>>2];c[M+16>>2]=c[C+16>>2];c[M+20>>2]=c[C+20>>2];c[M+24>>2]=c[C+24>>2];c[M+28>>2]=c[C+28>>2];if((d[138998]|0|0)>1){Ln(c[s>>2]|0);M=c[24742]|0;K=wB(c[z>>2]|0)|0;X=+h[C>>3];Y=+h[C+8>>3];Z=+h[C+16>>3];_=+h[C+16+8>>3];c[o>>2]=K;h[o+8>>3]=X;h[o+16>>3]=Y;h[o+24>>3]=Z;h[o+32>>3]=_;Y2(M,127586,o)|0}}else{c[y>>2]=N;N=(c[(c[y>>2]|0)+8>>2]|0)+16|0;M=C+16|0;c[g>>2]=c[C>>2];c[g+4>>2]=c[C+4>>2];c[g+8>>2]=c[C+8>>2];c[g+12>>2]=c[C+12>>2];c[f>>2]=c[M>>2];c[f+4>>2]=c[M+4>>2];c[f+8>>2]=c[M+8>>2];c[f+12>>2]=c[M+12>>2];Nn(O,g,f);c[N>>2]=c[O>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];c[N+12>>2]=c[O+12>>2];if((d[138998]|0|0)>1){Ln(c[s>>2]|0);N=c[24742]|0;M=wB(c[y>>2]|0)|0;_=+h[(c[(c[y>>2]|0)+8>>2]|0)+16>>3];Z=+h[(c[(c[y>>2]|0)+8>>2]|0)+16+8>>3];c[n>>2]=M;h[n+8>>3]=_;h[n+16>>3]=Z;Y2(N,127574,n)|0}}c[u>>2]=(c[u>>2]|0)+1}if(c[(c[(c[r>>2]|0)+8>>2]|0)+12>>2]|0){n=(c[(c[(c[r>>2]|0)+8>>2]|0)+12>>2]|0)+24|0;c[P>>2]=c[n>>2];c[P+4>>2]=c[n+4>>2];c[P+8>>2]=c[n+8>>2];c[P+12>>2]=c[n+12>>2];if(!(c[v>>2]|0)){h[D>>3]=0.0;h[D+8>>3]=0.0;h[D+16>>3]=+h[P>>3];h[D+16+8>>3]=+h[P+8>>3]}h[Q>>3]=+h[P>>3]-(+h[D+16>>3]-+h[D>>3]);if(+h[Q>>3]>0.0){h[Q>>3]=+h[Q>>3]/2.0;h[D>>3]=+h[D>>3]-+h[Q>>3];P=D+16|0;h[P>>3]=+h[P>>3]+ +h[Q>>3]}}if((c[s>>2]|0)>0)h[H>>3]=+((c[F+8>>2]|0)>>>0)/2.0;else h[H>>3]=0.0;h[D>>3]=+h[D>>3]-+h[H>>3];F=D+16|0;h[F>>3]=+h[F>>3]+ +h[H>>3];F=D+8|0;h[F>>3]=+h[F>>3]-(+h[H>>3]+ +h[(c[(c[r>>2]|0)+8>>2]|0)+48+8>>3]);F=D+16+8|0;h[F>>3]=+h[F>>3]+(+h[H>>3]+ +h[(c[(c[r>>2]|0)+8>>2]|0)+48+32+8>>3]);if((d[138998]|0|0)>1){Ln(c[s>>2]|0);H=c[24742]|0;F=wB(c[r>>2]|0)|0;W=+h[D>>3];Z=+h[D+8>>3];_=+h[D+16>>3];Y=+h[D+16+8>>3];c[m>>2]=F;h[m+8>>3]=W;h[m+16>>3]=Z;h[m+24>>3]=_;h[m+32>>3]=Y;Y2(H,127586,m)|0}c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[v>>2]|0))break;m=c[(c[I>>2]|0)+(c[u>>2]<<2)>>2]|0;if((c[u>>2]|0)<(c[(c[(c[r>>2]|0)+8>>2]|0)+180>>2]|0)){c[z>>2]=m;H=(c[(c[z>>2]|0)+8>>2]|0)+16|0;c[C>>2]=c[H>>2];c[C+4>>2]=c[H+4>>2];c[C+8>>2]=c[H+8>>2];c[C+12>>2]=c[H+12>>2];c[C+16>>2]=c[H+16>>2];c[C+20>>2]=c[H+20>>2];c[C+24>>2]=c[H+24>>2];c[C+28>>2]=c[H+28>>2];c[g>>2]=c[C>>2];c[g+4>>2]=c[C+4>>2];c[g+8>>2]=c[C+8>>2];c[g+12>>2]=c[C+12>>2];c[f>>2]=c[D>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];On(R,g,f);c[C>>2]=c[R>>2];c[C+4>>2]=c[R+4>>2];c[C+8>>2]=c[R+8>>2];c[C+12>>2]=c[R+12>>2];H=C+16|0;F=C+16|0;c[g>>2]=c[F>>2];c[g+4>>2]=c[F+4>>2];c[g+8>>2]=c[F+8>>2];c[g+12>>2]=c[F+12>>2];c[f>>2]=c[D>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];On(S,g,f);c[H>>2]=c[S>>2];c[H+4>>2]=c[S+4>>2];c[H+8>>2]=c[S+8>>2];c[H+12>>2]=c[S+12>>2];H=(c[(c[z>>2]|0)+8>>2]|0)+16|0;c[H>>2]=c[C>>2];c[H+4>>2]=c[C+4>>2];c[H+8>>2]=c[C+8>>2];c[H+12>>2]=c[C+12>>2];c[H+16>>2]=c[C+16>>2];c[H+20>>2]=c[C+20>>2];c[H+24>>2]=c[C+24>>2];c[H+28>>2]=c[C+28>>2];if((d[138998]|0|0)>1){Ln(c[s>>2]|0);H=c[24742]|0;F=wB(c[z>>2]|0)|0;Y=+h[C>>3];_=+h[C+8>>3];Z=+h[C+16>>3];W=+h[C+16+8>>3];c[l>>2]=F;h[l+8>>3]=Y;h[l+16>>3]=_;h[l+24>>3]=Z;h[l+32>>3]=W;Y2(H,127586,l)|0}}else{c[y>>2]=m;m=(c[(c[y>>2]|0)+8>>2]|0)+16|0;H=(c[(c[y>>2]|0)+8>>2]|0)+16|0;c[g>>2]=c[H>>2];c[g+4>>2]=c[H+4>>2];c[g+8>>2]=c[H+8>>2];c[g+12>>2]=c[H+12>>2];c[f>>2]=c[D>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];On(T,g,f);c[m>>2]=c[T>>2];c[m+4>>2]=c[T+4>>2];c[m+8>>2]=c[T+8>>2];c[m+12>>2]=c[T+12>>2];if((d[138998]|0|0)>1){Ln(c[s>>2]|0);m=c[24742]|0;H=wB(c[y>>2]|0)|0;W=+h[(c[(c[y>>2]|0)+8>>2]|0)+16>>3];Z=+h[(c[(c[y>>2]|0)+8>>2]|0)+16+8>>3];c[k>>2]=H;h[k+8>>3]=W;h[k+16>>3]=Z;Y2(m,127574,k)|0}}c[u>>2]=(c[u>>2]|0)+1}u=D+16|0;k=D+16|0;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[f>>2]=c[D>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];On(U,g,f);c[u>>2]=c[U>>2];c[u+4>>2]=c[U+4>>2];c[u+8>>2]=c[U+8>>2];c[u+12>>2]=c[U+12>>2];c[g>>2]=c[D>>2];c[g+4>>2]=c[D+4>>2];c[g+8>>2]=c[D+8>>2];c[g+12>>2]=c[D+12>>2];c[f>>2]=c[D>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];On(V,g,f);c[D>>2]=c[V>>2];c[D+4>>2]=c[V+4>>2];c[D+8>>2]=c[V+8>>2];c[D+12>>2]=c[V+12>>2];V=(c[(c[r>>2]|0)+8>>2]|0)+16|0;c[V>>2]=c[D>>2];c[V+4>>2]=c[D+4>>2];c[V+8>>2]=c[D+8>>2];c[V+12>>2]=c[D+12>>2];c[V+16>>2]=c[D+16>>2];c[V+20>>2]=c[D+20>>2];c[V+24>>2]=c[D+24>>2];c[V+28>>2]=c[D+28>>2];if((d[138998]|0|0)>1){Ln(c[s>>2]|0);s=c[24742]|0;V=wB(c[r>>2]|0)|0;Z=+h[D>>3];W=+h[D+8>>3];_=+h[D+16>>3];Y=+h[D+16+8>>3];c[j>>2]=V;h[j+8>>3]=Z;h[j+16>>3]=W;h[j+24>>3]=_;h[j+32>>3]=Y;Y2(s,127586,j)|0}O4(c[A>>2]|0);O4(c[I>>2]|0);O4(c[B>>2]|0);i=e;return}function Jn(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0;e=i;i=i+160|0;f=e+96|0;g=e+72|0;j=e+64|0;k=e+152|0;l=e+148|0;m=e+32|0;n=e;o=e+144|0;p=e+140|0;q=e+136|0;c[k>>2]=a;c[l>>2]=b;b=(c[(c[k>>2]|0)+8>>2]|0)+16|0;c[n>>2]=c[b>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];c[n+16>>2]=c[b+16>>2];c[n+20>>2]=c[b+20>>2];c[n+24>>2]=c[b+24>>2];c[n+28>>2]=c[b+28>>2];if((d[138998]|0|0)>1){Ln(c[l>>2]|0);b=c[24742]|0;c[j>>2]=wB(c[k>>2]|0)|0;Y2(b,127559,j)|0}a:do if(c[l>>2]|0){c[o>>2]=$B(c[k>>2]|0)|0;while(1){if(!(c[o>>2]|0))break a;if((c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]|0)==(c[k>>2]|0)?(j=(c[(c[o>>2]|0)+8>>2]|0)+16|0,h[j>>3]=+h[j>>3]+ +h[n>>3],j=(c[(c[o>>2]|0)+8>>2]|0)+16+8|0,h[j>>3]=+h[j>>3]+ +h[n+8>>3],(d[138998]|0|0)>1):0){Ln(c[l>>2]|0);j=c[24742]|0;b=wB(c[o>>2]|0)|0;r=+h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3];s=+h[(c[(c[o>>2]|0)+8>>2]|0)+16+8>>3];c[g>>2]=b;h[g+8>>3]=r;h[g+16>>3]=s;Y2(j,127574,g)|0}c[o>>2]=aC(c[k>>2]|0,c[o>>2]|0)|0}}while(0);c[q>>2]=1;while(1){if((c[q>>2]|0)>(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0))break;c[p>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+184>>2]|0)+(c[q>>2]<<2)>>2];if(c[l>>2]|0){o=(c[(c[p>>2]|0)+8>>2]|0)+16|0;c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];c[m+12>>2]=c[o+12>>2];c[m+16>>2]=c[o+16>>2];c[m+20>>2]=c[o+20>>2];c[m+24>>2]=c[o+24>>2];c[m+28>>2]=c[o+28>>2];h[m>>3]=+h[m>>3]+ +h[n>>3];o=m+8|0;h[o>>3]=+h[o>>3]+ +h[n+8>>3];o=m+16|0;h[o>>3]=+h[o>>3]+ +h[n>>3];o=m+16+8|0;h[o>>3]=+h[o>>3]+ +h[n+8>>3];if((d[138998]|0|0)>1){Ln(c[l>>2]|0);o=c[24742]|0;g=wB(c[p>>2]|0)|0;s=+h[m>>3];r=+h[m+8>>3];t=+h[m+16>>3];u=+h[m+16+8>>3];c[f>>2]=g;h[f+8>>3]=s;h[f+16>>3]=r;h[f+24>>3]=t;h[f+32>>3]=u;Y2(o,127586,f)|0}o=(c[(c[p>>2]|0)+8>>2]|0)+16|0;c[o>>2]=c[m>>2];c[o+4>>2]=c[m+4>>2];c[o+8>>2]=c[m+8>>2];c[o+12>>2]=c[m+12>>2];c[o+16>>2]=c[m+16>>2];c[o+20>>2]=c[m+20>>2];c[o+24>>2]=c[m+24>>2];c[o+28>>2]=c[m+28>>2]}Jn(c[p>>2]|0,(c[l>>2]|0)+1|0);c[q>>2]=(c[q>>2]|0)+1}i=e;return}function Kn(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0))break;c[e>>2]=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2];UJ(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0);Kn(c[e>>2]|0);c[f>>2]=(c[f>>2]|0)+1}O4(c[(c[(c[d>>2]|0)+8>>2]|0)+184>>2]|0);i=b;return}function Ln(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;while(1){if((c[d>>2]|0)<=0)break;_2(127604,c[24742]|0)|0;c[d>>2]=(c[d>>2]|0)+-1}i=b;return}function Mn(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3];h[j+8>>3]=+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function Nn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=(+h[b>>3]+ +h[d>>3])/2.0;h[f+8>>3]=(+h[b+8>>3]+ +h[d+8>>3])/2.0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function On(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]-+h[d>>3];h[f+8>>3]=+h[b+8>>3]-+h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function Pn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[c[d>>2]>>2]=0;c[(c[d>>2]|0)+4>>2]=0;c[(c[d>>2]|0)+8>>2]=0;i=b;return}function Qn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=(c[e>>2]|0)+8|0;c[b>>2]=(c[b>>2]|0)+1;if((c[(c[e>>2]|0)+8>>2]|0)>=(c[(c[e>>2]|0)+4>>2]|0)){b=(c[e>>2]|0)+4|0;c[b>>2]=(c[b>>2]|0)+10;b=eK(c[c[e>>2]>>2]|0,c[(c[e>>2]|0)+4>>2]<<2)|0;c[c[e>>2]>>2]=b}c[(c[c[e>>2]>>2]|0)+(c[(c[e>>2]|0)+8>>2]<<2)>>2]=c[f>>2];i=d;return}function Rn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;OC(c[d>>2]|0,1,175026,304,1);EO(c[d>>2]|0)|0;c[h>>2]=kB(c[d>>2]|0)|0;a=bK((c[h>>2]|0)+1<<2)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]=a;c[j>>2]=0;c[f>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;Tn(c[f>>2]|0);c[(c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0)+(c[j>>2]<<2)>>2]=c[f>>2];a=c[j>>2]|0;c[j>>2]=a+1;c[(c[(c[f>>2]|0)+8>>2]|0)+120>>2]=a;c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=qA(c[d>>2]|0,2,129937,0)|0;c[f>>2]=$B(c[d>>2]|0)|0;while(1){k=c[d>>2]|0;if(!(c[f>>2]|0))break;c[g>>2]=OA(k,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;Un(c[g>>2]|0,c[e>>2]|0);c[g>>2]=QA(c[d>>2]|0,c[g>>2]|0)|0}c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}Vn(k);i=b;return}function Sn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){g=c[d>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=OA(g,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;TO(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}UO(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}Wn(g);i=b;return}function Tn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;xO(c[d>>2]|0);a=bK((e[(c[(qC(c[d>>2]|0)|0)+8>>2]|0)+176>>1]|0)<<3)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+132>>2]=a;a=c[d>>2]|0;VO(a,c[(c[(qC(c[d>>2]|0)|0)+8>>2]|0)+116>>2]&1);i=b;return}function Un(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;MC(c[e>>2]|0,175319,176,1)|0;g=+fO(c[e>>2]|0,c[13851]|0,1.0,0.0);h[(c[(c[e>>2]|0)+8>>2]|0)+128>>3]=g;g=+fO(c[e>>2]|0,c[f>>2]|0,+h[(c[13790]|0)+32>>3],0.0);h[(c[(c[e>>2]|0)+8>>2]|0)+136>>3]=g;yO(c[e>>2]|0)|0;i=d;return}function Vn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+64|0;e=d+16|0;f=d;g=d+52|0;j=d+48|0;k=d+44|0;l=d+40|0;m=d+36|0;n=d+32|0;o=d+28|0;p=d+56|0;q=d+24|0;c[g>>2]=b;c[l>>2]=qA(c[g>>2]|0,1,140246,0)|0;if(!(c[l>>2]|0)){i=d;return}c[m>>2]=qA(c[g>>2]|0,1,127690,0)|0;c[j>>2]=0;while(1){b=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+152>>2]|0)+(c[j>>2]<<2)>>2]|0;c[k>>2]=b;if(!b)break;c[o>>2]=zA(c[k>>2]|0,c[l>>2]|0)|0;do if(a[c[o>>2]>>0]|0){c[n>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2];a[p>>0]=0;b=c[o>>2]|0;r=(c[n>>2]|0)+8|0;c[f>>2]=c[n>>2];c[f+4>>2]=r;c[f+8>>2]=p;if((l3(b,139594,f)|0)<2){b=c[24742]|0;r=wB(c[k>>2]|0)|0;s=c[o>>2]|0;c[e>>2]=r;c[e+4>>2]=s;Y2(b,127694,e)|0;break}a:do if(+h[4246]>0.0){c[q>>2]=0;while(1){if((c[q>>2]|0)>=2)break a;h[(c[n>>2]|0)+(c[q>>2]<<3)>>3]=+h[(c[n>>2]|0)+(c[q>>2]<<3)>>3]/+h[4246];c[q>>2]=(c[q>>2]|0)+1}}while(0);a[(c[(c[k>>2]|0)+8>>2]|0)+119>>0]=1;if((a[p>>0]|0)!=33){if(!(c[m>>2]|0))break;if(!((kO(zA(c[k>>2]|0,c[m>>2]|0)|0)|0)&255))break}a[(c[(c[k>>2]|0)+8>>2]|0)+119>>0]=3}while(0);c[j>>2]=(c[j>>2]|0)+1}i=d;return}function Wn(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Xn(c[d>>2]|0);O4(c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0);O4(c[(c[(c[d>>2]|0)+8>>2]|0)+140>>2]|0);i=b;return}function Xn(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0))break;c[e>>2]=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2];UJ(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0);if(c[(c[(c[e>>2]|0)+8>>2]|0)+140>>2]|0){O4(c[c[(c[(c[e>>2]|0)+8>>2]|0)+140>>2]>>2]|0);O4(c[(c[(c[e>>2]|0)+8>>2]|0)+140>>2]|0)}Xn(c[e>>2]|0);c[f>>2]=(c[f>>2]|0)+1}O4(c[(c[(c[d>>2]|0)+8>>2]|0)+184>>2]|0);f=c[d>>2]|0;if((f|0)==(rC(c[d>>2]|0)|0)){i=b;return}NC(c[d>>2]|0,175049)|0;i=b;return}function Yn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=qA(c[e>>2]|0,0,127746,0)|0;c[(c[f>>2]|0)+4>>2]=b;b=qA(c[e>>2]|0,0,179125,0)|0;c[(c[f>>2]|0)+8>>2]=b;b=qA(c[e>>2]|0,0,179057,0)|0;c[(c[f>>2]|0)+12>>2]=b;c[c[f>>2]>>2]=c[e>>2];c[(c[f>>2]|0)+16>>2]=0;b=GG(c[e>>2]|0,2,4,(c[f>>2]|0)+20|0)|0;c[(c[f>>2]|0)+20+16>>2]=b;i=d;return}function Zn(a){a=a|0;var d=0,f=0,g=0,h=0;d=i;i=i+16|0;f=d;c[f>>2]=a;QO(c[f>>2]|0,2);a=bK(56)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+140>>2]=a;a=c[f>>2]|0;g=(eO(a,qA(c[f>>2]|0,0,129477,0)|0,2,2)|0)&65535;b[(c[(c[f>>2]|0)+8>>2]|0)+176>>1]=g;if((e[(c[(c[f>>2]|0)+8>>2]|0)+176>>1]|0|0)<10)h=e[(c[(c[f>>2]|0)+8>>2]|0)+176>>1]|0;else h=10;g=h&65535;b[(c[(c[f>>2]|0)+8>>2]|0)+176>>1]=g;c[13799]=g&65535;ao(c[f>>2]|0,0,c[f>>2]|0);xo(c[f>>2]|0);Rn(c[f>>2]|0);i=d;return}function _n(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+64|0;d=b+52|0;e=b;c[d>>2]=a;Yn(c[d>>2]|0,e);bo(c[d>>2]|0,e);co(c[d>>2]|0);eo(c[d>>2]|0,c[d>>2]|0);fo(c[d>>2]|0);i=b;return}function $n(a){a=a|0;var b=0,d=0,f=0.0,g=0.0,i=0,j=0,k=0,l=0,m=0,p=0,q=0,r=0,s=0,t=0;b=4;d=N4(40)|0;c[d>>2]=0;f=+h[4246];n=0;g=+ma(1,a|0);i=n;n=0;if((i|0)!=0&(o|0)!=0){j=Y4(c[i>>2]|0,d|0,b|0)|0;if(!j)Pa(i|0,o|0);C=o}else j=-1;if((j|0)!=1){h[4246]=g;n=0;ea(93,a|0);j=n;n=0;if((j|0)!=0&(o|0)!=0){k=Y4(c[j>>2]|0,d|0,b|0)|0;if(!k)Pa(j|0,o|0);C=o}else k=-1;if((k|0)!=1){d=W4(50948,1,d|0,b|0)|0;b=C;n=0;k=n;n=0;if((k|0)!=0&(o|0)!=0){l=Y4(c[k>>2]|0,d|0,b|0)|0;if(!l)Pa(k|0,o|0);C=o}else l=-1;if((l|0)!=1)m=0;else m=C}else m=C}else m=C;while(1){if(m){p=13;break}n=0;ea(94,a|0);l=n;n=0;if((l|0)!=0&(o|0)!=0){q=Y4(c[l>>2]|0,d|0,b|0)|0;if(!q)Pa(l|0,o|0);C=o}else q=-1;if((q|0)==1){m=C;continue}n=0;ia(22,a|0)|0;l=n;n=0;if((l|0)!=0&(o|0)!=0){r=Y4(c[l>>2]|0,d|0,b|0)|0;if(!r)Pa(l|0,o|0);C=o}else r=-1;if((r|0)==1){m=C;continue}if((e[(c[a+8>>2]|0)+136>>1]|0)&14){n=0;ea(95,a|0);l=n;n=0;if((l|0)!=0&(o|0)!=0){s=Y4(c[l>>2]|0,d|0,b|0)|0;if(!s)Pa(l|0,o|0);C=o}else s=-1;if((s|0)==1){m=C;continue}}n=0;ga(18,a|0,0);l=n;n=0;if((l|0)!=0&(o|0)!=0){t=Y4(c[l>>2]|0,d|0,b|0)|0;if(!t)Pa(l|0,o|0);C=o}else t=-1;if((t|0)==1)m=C;else break}if((p|0)==13){O4(d|0);return}h[4246]=f;O4(d|0);return}function ao(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+4|0;m=f;c[g>>2]=a;c[h>>2]=d;c[j>>2]=e;if(!(c[h>>2]|0)){c[m>>2]=l;vo(c[m>>2]|0)}else c[m>>2]=c[h>>2];c[k>>2]=GD(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;e=(P3(wB(c[k>>2]|0)|0,145613,7)|0)!=0;d=c[k>>2]|0;if(e)ao(d,c[m>>2]|0,c[j>>2]|0);else{MC(d,175049,280,1)|0;d=bK(56)|0;c[(c[(c[k>>2]|0)+8>>2]|0)+140>>2]=d;b[(c[(c[k>>2]|0)+8>>2]|0)+176>>1]=b[(c[(c[j>>2]|0)+8>>2]|0)+176>>1]|0;c[(c[(c[(c[k>>2]|0)+8>>2]|0)+140>>2]|0)+44>>2]=(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+140>>2]|0)+44>>2]|0)+1;c[(c[(c[(c[k>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2]=c[j>>2];wo(c[m>>2]|0,c[k>>2]|0);ao(c[k>>2]|0,0,c[k>>2]|0)}c[k>>2]=HD(c[k>>2]|0)|0}if(c[h>>2]|0){i=f;return}c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]=c[l+8>>2];if(!(c[l+8>>2]|0)){i=f;return}h=eK(c[l>>2]|0,(c[l+8>>2]|0)+1<<2)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]=h;i=f;return}function bo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;e=i;i=i+128|0;f=e+64|0;g=e+56|0;j=e+116|0;k=e+112|0;l=e+108|0;m=e+104|0;n=e+100|0;o=e+96|0;p=e+92|0;q=e+88|0;r=e+84|0;s=e+80|0;t=e+76|0;u=e+72|0;v=e+16|0;w=e;x=e+68|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=0;if(a[138998]|0){d=c[24742]|0;c[g>>2]=wB(c[j>>2]|0)|0;Y2(d,127816,g)|0}c[o>>2]=$B(c[j>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;c[(c[(c[o>>2]|0)+8>>2]|0)+164>>2]=0;c[o>>2]=aC(c[j>>2]|0,c[o>>2]|0)|0}c[m>>2]=ho(c[j>>2]|0,c[k>>2]|0)|0;g=bv(c[m>>2]|0,t,u)|0;c[s>>2]=g;c[r>>2]=g;while(1){g=c[s>>2]|0;c[s>>2]=g+4;d=c[g>>2]|0;c[p>>2]=d;if(!d)break;yo(c[p>>2]|0,v);c[o>>2]=$B(c[p>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;d=c[o>>2]|0;if(!(c[(c[(c[o>>2]|0)+8>>2]|0)+212>>2]|0)){if((c[(c[(c[d+8>>2]|0)+112>>2]|0)+8>>2]|0)==0?(c[(c[(c[o>>2]|0)+8>>2]|0)+212>>2]|0)==0:0)pC(c[p>>2]|0,c[o>>2]|0)|0}else{c[q>>2]=io(d,c[p>>2]|0)|0;bo(c[q>>2]|0,c[k>>2]|0);h[(c[(c[o>>2]|0)+8>>2]|0)+32>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8+16>>3];h[(c[(c[o>>2]|0)+8>>2]|0)+40>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8+16+8>>3];h[w>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8+16>>3]*72.0;h[w+8>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8+16+8>>3]*72.0;y=+h[w>>3]/2.0;h[(c[(c[o>>2]|0)+8>>2]|0)+88>>3]=y;h[(c[(c[o>>2]|0)+8>>2]|0)+96>>3]=y;h[(c[(c[o>>2]|0)+8>>2]|0)+80>>3]=+h[w+8>>3]}c[o>>2]=aC(c[p>>2]|0,c[o>>2]|0)|0}if((kB(c[p>>2]|0)|0)<2)continue;if((c[j>>2]|0)==(c[c[k>>2]>>2]|0))bq(c[p>>2]|0)|0;Lo(c[p>>2]|0,v)}if((c[t>>2]|0)>1){if(c[u>>2]|0){c[x>>2]=bK(c[t>>2]|0)|0;a[c[x>>2]>>0]=1}else c[x>>2]=0;c[(c[k>>2]|0)+20+20>>2]=c[x>>2];c[l>>2]=BG(c[t>>2]|0,c[r>>2]|0,0,(c[k>>2]|0)+20|0)|0;if(c[x>>2]|0)O4(c[x>>2]|0)}else{c[l>>2]=0;if((c[t>>2]|0)==1)BO(c[c[r>>2]>>2]|0)}jo(c[m>>2]|0,c[t>>2]|0,c[r>>2]|0,c[l>>2]|0,c[j>>2]|0,c[k>>2]|0);O4(c[l>>2]|0);c[n>>2]=$B(c[m>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;l=c[(c[(c[n>>2]|0)+8>>2]|0)+212>>2]|0;c[q>>2]=l;k=c[(c[n>>2]|0)+8>>2]|0;if(!l){l=c[(c[k+112>>2]|0)+8>>2]|0;c[o>>2]=l;if(l){h[c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3];h[(c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]}}else{h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8>>3]=+h[c[k+132>>2]>>3]-+h[(c[(c[n>>2]|0)+8>>2]|0)+32>>3]/2.0;h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8+8>>3]=+h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[n>>2]|0)+8>>2]|0)+40>>3]/2.0;h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8+16>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8>>3]+ +h[(c[(c[n>>2]|0)+8>>2]|0)+32>>3];h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8+16+8>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+140>>2]|0)+8+8>>3]+ +h[(c[(c[n>>2]|0)+8>>2]|0)+40>>3]}c[n>>2]=aC(c[m>>2]|0,c[n>>2]|0)|0}n=(c[(c[(c[j>>2]|0)+8>>2]|0)+140>>2]|0)+8|0;q=(c[(c[(c[m>>2]|0)+8>>2]|0)+140>>2]|0)+8|0;c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];c[n+24>>2]=c[q+24>>2];c[n+28>>2]=c[q+28>>2];ko(c[m>>2]|0,c[r>>2]|0);O4(c[r>>2]|0);if(!(a[138998]|0)){i=e;return}r=c[24742]|0;c[f>>2]=wB(c[j>>2]|0)|0;Y2(r,127827,f)|0;i=e;return}function co(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;d=i;i=i+112|0;e=d+100|0;f=d+56|0;g=d+96|0;j=d+40|0;k=d+92|0;l=d+32|0;m=d+24|0;n=d+16|0;o=d+8|0;p=d;q=d+88|0;c[e>>2]=b;c[k>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;if(a[(c[(c[k>>2]|0)+8>>2]|0)+118>>0]|0){c[g>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2];b=(c[(c[(c[g>>2]|0)+8>>2]|0)+140>>2]|0)+8|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];h[l>>3]=+h[f+16>>3]-+h[f>>3];h[m>>3]=+h[f+16+8>>3]-+h[f+8>>3];h[j>>3]=+h[l>>3]/2.0;h[j+8>>3]=+h[m>>3]/2.0;h[p>>3]=+h[l>>3]/2.0*72.0;h[o>>3]=+h[m>>3]/2.0*72.0;h[n>>3]=+h[m>>3]*72.0;h[c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[j>>3];h[(c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[j+8>>3];h[(c[(c[k>>2]|0)+8>>2]|0)+32>>3]=+h[l>>3];h[(c[(c[k>>2]|0)+8>>2]|0)+40>>3]=+h[m>>3];r=+h[p>>3];h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3]=r;h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3]=r;h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]=+h[n>>3];c[q>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2]|0)+44>>2];h[c[q>>2]>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3];h[(c[q>>2]|0)+8>>3]=+h[o>>3];h[(c[q>>2]|0)+16>>3]=-+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];h[(c[q>>2]|0)+16+8>>3]=+h[o>>3];h[(c[q>>2]|0)+32>>3]=-+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];h[(c[q>>2]|0)+32+8>>3]=-+h[o>>3];h[(c[q>>2]|0)+48>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3];h[(c[q>>2]|0)+48+8>>3]=-+h[o>>3]}c[k>>2]=aC(c[e>>2]|0,c[k>>2]|0)|0}i=d;return}function eo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+96|0;e=d+80|0;f=d+76|0;g=d+72|0;j=d+68|0;k=d+64|0;l=d+32|0;m=d;c[e>>2]=a;c[f>>2]=b;b=(c[(c[(c[e>>2]|0)+8>>2]|0)+140>>2]|0)+8|0;c[l>>2]=c[b>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];c[l+16>>2]=c[b+16>>2];c[l+20>>2]=c[b+20>>2];c[l+24>>2]=c[b+24>>2];c[l+28>>2]=c[b+28>>2];a:do if((c[e>>2]|0)!=(c[f>>2]|0)){c[k>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[k>>2]|0))break a;if((c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]|0)==(c[e>>2]|0)){b=c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0;h[b>>3]=+h[b>>3]+ +h[l>>3];b=(c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[b>>3]=+h[b>>3]+ +h[l+8>>3]}c[k>>2]=aC(c[e>>2]|0,c[k>>2]|0)|0}}while(0);c[g>>2]=1;while(1){if((c[g>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;c[j>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[g>>2]<<2)>>2];if((c[e>>2]|0)!=(c[f>>2]|0)){k=(c[(c[(c[j>>2]|0)+8>>2]|0)+140>>2]|0)+8|0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];c[m+8>>2]=c[k+8>>2];c[m+12>>2]=c[k+12>>2];c[m+16>>2]=c[k+16>>2];c[m+20>>2]=c[k+20>>2];c[m+24>>2]=c[k+24>>2];c[m+28>>2]=c[k+28>>2];h[m>>3]=+h[m>>3]+ +h[l>>3];k=m+8|0;h[k>>3]=+h[k>>3]+ +h[l+8>>3];k=m+16|0;h[k>>3]=+h[k>>3]+ +h[l>>3];k=m+16+8|0;h[k>>3]=+h[k>>3]+ +h[l+8>>3];k=(c[(c[(c[j>>2]|0)+8>>2]|0)+140>>2]|0)+8|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];c[k+16>>2]=c[m+16>>2];c[k+20>>2]=c[m+20>>2];c[k+24>>2]=c[m+24>>2];c[k+28>>2]=c[m+28>>2]}eo(c[j>>2]|0,c[f>>2]|0);c[g>>2]=(c[g>>2]|0)+1}i=d;return}function fo(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+48|0;d=b+36|0;e=b+32|0;f=b;c[d>>2]=a;h[f>>3]=+h[(c[(c[(c[d>>2]|0)+8>>2]|0)+140>>2]|0)+8>>3]*72.0;h[f+8>>3]=+h[(c[(c[(c[d>>2]|0)+8>>2]|0)+140>>2]|0)+8+8>>3]*72.0;h[f+16>>3]=+h[(c[(c[(c[d>>2]|0)+8>>2]|0)+140>>2]|0)+8+16>>3]*72.0;h[f+16+8>>3]=+h[(c[(c[(c[d>>2]|0)+8>>2]|0)+140>>2]|0)+8+16+8>>3]*72.0;a=(c[(c[d>>2]|0)+8>>2]|0)+16|0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];c[a+16>>2]=c[f+16>>2];c[a+20>>2]=c[f+20>>2];c[a+24>>2]=c[f+24>>2];c[a+28>>2]=c[f+28>>2];c[e>>2]=1;while(1){if((c[e>>2]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0))break;fo(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+184>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}i=b;return}function go(a){a=a|0;var b=0,d=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;f=b+12|0;g=b+8|0;h=b+4|0;c[f>>2]=a;c[g>>2]=0;c[h>>2]=(e[(c[(c[f>>2]|0)+8>>2]|0)+136>>1]|0)&14;if((c[h>>2]|0)!=2){if((c[h>>2]|0)==12?(c[g>>2]=cm(c[f>>2]|0,27,10)|0,(c[g>>2]|0)!=0):0)c[13795]=2;do if((c[g>>2]|0)!=0|(c[h>>2]|0)!=12)if((e[(c[(c[f>>2]|0)+8>>2]|0)+136>>1]|0)&1){$z(0,127753,d)|0;break}else{dm(c[f>>2]|0,c[h>>2]|0)|0;break}while(0);c[13795]=0}if((c[13800]|0)>=1){i=b;return}dm(c[f>>2]|0,2)|0;i=b;return}function ho(e,f){e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;g=i;i=i+224|0;j=g+56|0;k=g+40|0;l=g+32|0;m=g+120|0;n=g+116|0;o=g+112|0;p=g+108|0;q=g+104|0;r=g+124|0;s=g+100|0;t=g+96|0;u=g+92|0;v=g+88|0;w=g+84|0;x=g;y=g+80|0;z=g+76|0;A=g+72|0;B=g+68|0;C=g+64|0;D=g+60|0;c[m>>2]=e;c[n>>2]=f;c[w>>2]=0;f=(c[n>>2]|0)+16|0;e=c[f>>2]|0;c[f>>2]=e+1;c[j>>2]=e;k3(r,127889,j)|0;if((d[138998]|0)>=2){e=c[24742]|0;f=wB(c[m>>2]|0)|0;c[l>>2]=r;c[l+4>>2]=f;Y2(e,127896,l)|0};c[j>>2]=c[13066];c[o>>2]=gB(129187,j,0)|0;MC(c[o>>2]|0,175049,280,1)|0;j=bK(56)|0;c[(c[(c[o>>2]|0)+8>>2]|0)+140>>2]=j;b[(c[(c[o>>2]|0)+8>>2]|0)+176>>1]=b[(c[(c[m>>2]|0)+8>>2]|0)+176>>1]|0;qo(c[m>>2]|0,c[o>>2]|0,129941);qo(c[m>>2]|0,c[o>>2]|0,13e4);qo(c[m>>2]|0,c[o>>2]|0,129305);c[v>>2]=1;while(1){if((c[v>>2]|0)>(c[(c[(c[m>>2]|0)+8>>2]|0)+180>>2]|0))break;c[x>>2]=c[8320];c[x+4>>2]=c[8321];c[x+8>>2]=c[8322];c[x+12>>2]=c[8323];c[x+16>>2]=c[8324];c[x+20>>2]=c[8325];c[x+24>>2]=c[8326];c[x+28>>2]=c[8327];c[q>>2]=c[(c[(c[(c[m>>2]|0)+8>>2]|0)+184>>2]|0)+(c[v>>2]<<2)>>2];LJ(c[q>>2]|0);j=c[o>>2]|0;c[p>>2]=ro(j,wB(c[q>>2]|0)|0)|0;c[(c[(c[p>>2]|0)+8>>2]|0)+212>>2]=c[q>>2];j=c[w>>2]|0;c[w>>2]=j+1;c[(c[(c[p>>2]|0)+8>>2]|0)+120>>2]=j;if(c[(c[n>>2]|0)+4>>2]|0)so(c[q>>2]|0,c[p>>2]|0,c[n>>2]|0,x);c[t>>2]=$B(c[q>>2]|0)|0;while(1){E=c[p>>2]|0;if(!(c[t>>2]|0))break;c[(c[(c[t>>2]|0)+8>>2]|0)+164>>2]=E;c[t>>2]=aC(c[q>>2]|0,c[t>>2]|0)|0}if(a[(c[E+8>>2]|0)+119>>0]|0){h[c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]>>3]=(+h[x>>3]+ +h[x+16>>3])/2.0;h[(c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=(+h[x+8>>3]+ +h[x+16+8>>3])/2.0}c[v>>2]=(c[v>>2]|0)+1}c[t>>2]=$B(c[m>>2]|0)|0;while(1){if(!(c[t>>2]|0))break;if(!(c[(c[(c[t>>2]|0)+8>>2]|0)+164>>2]|0)){if((c[(c[(c[t>>2]|0)+8>>2]|0)+212>>2]|0)!=0?(c[(c[(c[t>>2]|0)+8>>2]|0)+212>>2]|0)!=(c[(c[(c[(c[m>>2]|0)+8>>2]|0)+140>>2]|0)+48>>2]|0):0){F=18;break}c[(c[(c[t>>2]|0)+8>>2]|0)+212>>2]=c[m>>2];if(!(a[(c[(c[t>>2]|0)+8>>2]|0)+118>>0]|0)){v=c[o>>2]|0;c[p>>2]=ro(v,wB(c[t>>2]|0)|0)|0;c[(c[(c[t>>2]|0)+8>>2]|0)+164>>2]=c[p>>2];v=c[w>>2]|0;c[w>>2]=v+1;c[(c[(c[p>>2]|0)+8>>2]|0)+120>>2]=v;h[(c[(c[p>>2]|0)+8>>2]|0)+32>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+32>>3];h[(c[(c[p>>2]|0)+8>>2]|0)+40>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+40>>3];h[(c[(c[p>>2]|0)+8>>2]|0)+88>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+88>>3];h[(c[(c[p>>2]|0)+8>>2]|0)+96>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+96>>3];h[(c[(c[p>>2]|0)+8>>2]|0)+80>>3]=+h[(c[(c[t>>2]|0)+8>>2]|0)+80>>3];c[(c[(c[p>>2]|0)+8>>2]|0)+8>>2]=c[(c[(c[t>>2]|0)+8>>2]|0)+8>>2];c[(c[(c[p>>2]|0)+8>>2]|0)+12>>2]=c[(c[(c[t>>2]|0)+8>>2]|0)+12>>2];if(a[(c[(c[t>>2]|0)+8>>2]|0)+119>>0]|0){h[c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[c[(c[(c[t>>2]|0)+8>>2]|0)+132>>2]>>3];h[(c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[(c[(c[(c[t>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];a[(c[(c[p>>2]|0)+8>>2]|0)+119>>0]=a[(c[(c[t>>2]|0)+8>>2]|0)+119>>0]|0}c[(c[(c[(c[p>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]=c[t>>2]}}c[t>>2]=aC(c[m>>2]|0,c[t>>2]|0)|0}if((F|0)==18){F=wB(c[t>>2]|0)|0;v=wB(c[m>>2]|0)|0;x=wB(c[(c[(c[t>>2]|0)+8>>2]|0)+212>>2]|0)|0;c[k>>2]=F;c[k+4>>2]=v;c[k+8>>2]=x;$z(1,127919,k)|0;Pa(50948,1)}c[t>>2]=$B(c[m>>2]|0)|0;while(1){if(!(c[t>>2]|0))break;c[A>>2]=c[(c[(c[t>>2]|0)+8>>2]|0)+164>>2];c[y>>2]=OA(c[m>>2]|0,c[t>>2]|0)|0;while(1){if(!(c[y>>2]|0))break;k=c[y>>2]|0;c[z>>2]=c[(c[(c[((c[c[y>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)+8>>2]|0)+164>>2];if((c[z>>2]|0)!=(c[A>>2]|0)){k=c[o>>2]|0;if((c[z>>2]|0)>>>0>(c[A>>2]|0)>>>0)c[u>>2]=VA(k,c[A>>2]|0,c[z>>2]|0,0,1)|0;else c[u>>2]=VA(k,c[z>>2]|0,c[A>>2]|0,0,1)|0;MC(c[u>>2]|0,175319,176,1)|0;h[(c[(c[u>>2]|0)+8>>2]|0)+136>>3]=+h[(c[(c[y>>2]|0)+8>>2]|0)+136>>3];h[(c[(c[u>>2]|0)+8>>2]|0)+128>>3]=+h[(c[(c[y>>2]|0)+8>>2]|0)+128>>3];k=(c[(c[(c[z>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[k>>2]=(c[k>>2]|0)+1;k=(c[(c[(c[A>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[k>>2]=(c[k>>2]|0)+1;if(!(c[(c[(c[u>>2]|0)+8>>2]|0)+172>>2]|0)){k=c[(c[(c[z>>2]|0)+8>>2]|0)+112>>2]|0;c[k>>2]=(c[k>>2]|0)+1;k=c[(c[(c[A>>2]|0)+8>>2]|0)+112>>2]|0;c[k>>2]=(c[k>>2]|0)+1}to(c[u>>2]|0,c[y>>2]|0)}c[y>>2]=QA(c[m>>2]|0,c[y>>2]|0)|0}c[t>>2]=aC(c[m>>2]|0,c[t>>2]|0)|0}t=c[c[(c[(c[m>>2]|0)+8>>2]|0)+140>>2]>>2]|0;c[s>>2]=t;if(!t){G=c[o>>2]|0;i=g;return G|0}c[D>>2]=c[(c[(c[(c[m>>2]|0)+8>>2]|0)+140>>2]|0)+4>>2];t=bK((c[D>>2]|0)+1<<4)|0;c[B>>2]=t;c[c[(c[(c[o>>2]|0)+8>>2]|0)+140>>2]>>2]=t;c[D>>2]=0;while(1){if(!(c[c[s>>2]>>2]|0))break;c[C>>2]=c[(c[(c[(c[s>>2]|0)+4>>2]|0)+8>>2]|0)+164>>2];if(c[C>>2]|0){t=c[o>>2]|0;c[p>>2]=ro(t,uo(c[m>>2]|0,c[s>>2]|0)|0)|0;c[D>>2]=(c[D>>2]|0)+1;t=c[w>>2]|0;c[w>>2]=t+1;c[(c[(c[p>>2]|0)+8>>2]|0)+120>>2]=t;t=c[o>>2]|0;if((c[p>>2]|0)>>>0>(c[C>>2]|0)>>>0)c[u>>2]=VA(t,c[C>>2]|0,c[p>>2]|0,0,1)|0;else c[u>>2]=VA(t,c[p>>2]|0,c[C>>2]|0,0,1)|0;MC(c[u>>2]|0,175319,176,1)|0;h[(c[(c[u>>2]|0)+8>>2]|0)+136>>3]=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+136>>3];h[(c[(c[u>>2]|0)+8>>2]|0)+128>>3]=+h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+128>>3];to(c[u>>2]|0,c[c[s>>2]>>2]|0);t=(c[(c[(c[p>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[t>>2]=(c[t>>2]|0)+1;t=(c[(c[(c[C>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[t>>2]=(c[t>>2]|0)+1;t=c[(c[(c[p>>2]|0)+8>>2]|0)+112>>2]|0;c[t>>2]=(c[t>>2]|0)+1;t=c[(c[(c[C>>2]|0)+8>>2]|0)+112>>2]|0;c[t>>2]=(c[t>>2]|0)+1;c[(c[B>>2]|0)+4>>2]=c[p>>2];h[(c[B>>2]|0)+8>>3]=+h[(c[s>>2]|0)+8>>3];c[c[B>>2]>>2]=c[u>>2];c[B>>2]=(c[B>>2]|0)+16}c[s>>2]=(c[s>>2]|0)+16}c[(c[(c[(c[o>>2]|0)+8>>2]|0)+140>>2]|0)+4>>2]=c[D>>2];G=c[o>>2]|0;i=g;return G|0}function io(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+32|0;j=d+28|0;k=d+24|0;l=d+20|0;m=d+16|0;n=d+12|0;o=d+8|0;p=d;c[e>>2]=a;c[f>>2]=b;c[l>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+212>>2];c[n>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2];c[o>>2]=0;if(!(c[n>>2]|0)){q=c[l>>2]|0;i=d;return q|0}c[m>>2]=bK((c[n>>2]|0)+1<<4)|0;b=no(c[e>>2]|0,c[f>>2]|0)|0;c[j>>2]=b;c[g>>2]=b;while(1){if(!(c[c[j>>2]>>2]|0))break;c[k>>2]=(c[j>>2]|0)+24;if(c[c[k>>2]>>2]|0)h[p>>3]=+h[(c[k>>2]|0)+8>>3];else h[p>>3]=+h[(c[g>>2]|0)+8>>3]+6.283185307179586;c[o>>2]=oo(c[e>>2]|0,c[j>>2]|0,c[m>>2]|0,c[o>>2]|0,+h[p>>3])|0;c[j>>2]=c[k>>2]}if((c[o>>2]|0)!=(c[n>>2]|0))La(127835,127845,767,127854);c[c[(c[(c[l>>2]|0)+8>>2]|0)+140>>2]>>2]=c[m>>2];c[(c[(c[(c[l>>2]|0)+8>>2]|0)+140>>2]|0)+4>>2]=c[n>>2];O4(c[g>>2]|0);q=c[l>>2]|0;i=d;return q|0}function jo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0,W=0,X=0,Y=0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;j=i;i=i+192|0;k=j+176|0;l=j+172|0;m=j+168|0;n=j+164|0;o=j+160|0;p=j+156|0;q=j+152|0;r=j+148|0;s=j+144|0;t=j+128|0;u=j+112|0;v=j+16|0;w=j+104|0;x=j+96|0;y=j+92|0;z=j+88|0;A=j+84|0;B=j+80|0;C=j+72|0;D=j+64|0;E=j+56|0;F=j+48|0;G=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=c[(c[p>>2]|0)+8>>2];c[r>>2]=c[(c[p>>2]|0)+12>>2];c[y>>2]=c[m>>2];c[z>>2]=c[n>>2];c[A>>2]=(c[o>>2]|0)==(c[c[p>>2]>>2]|0)&1;c[B>>2]=0;a:do if(c[l>>2]|0){p=c[y>>2]|0;c[y>>2]=p+4;c[s>>2]=c[p>>2];H=+h[(c[(c[s>>2]|0)+8>>2]|0)+16>>3];c[u>>2]=~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+16>>3]>=0.0?H+.5:H-.5);H=+h[(c[(c[s>>2]|0)+8>>2]|0)+16+8>>3];c[u+4>>2]=~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+16+8>>3]>=0.0?H+.5:H-.5);H=+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16>>3];c[u+8>>2]=~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16>>3]>=0.0?H+.5:H-.5);H=+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16+8>>3];c[u+8+4>>2]=~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16+8>>3]>=0.0?H+.5:H-.5);if((c[l>>2]|0)>1){p=c[z>>2]|0;c[z>>2]=p+8;c[w>>2]=c[p>>2];c[w+4>>2]=c[p+4>>2];c[u>>2]=(c[u>>2]|0)+(c[w>>2]|0);p=u+4|0;c[p>>2]=(c[p>>2]|0)+(c[w+4>>2]|0);p=u+8|0;c[p>>2]=(c[p>>2]|0)+(c[w>>2]|0);p=u+8+4|0;c[p>>2]=(c[p>>2]|0)+(c[w+4>>2]|0);while(1){p=c[y>>2]|0;c[y>>2]=p+4;g=c[p>>2]|0;c[s>>2]=g;if(!g)break a;H=+h[(c[(c[s>>2]|0)+8>>2]|0)+16>>3];c[t>>2]=~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+16>>3]>=0.0?H+.5:H-.5);H=+h[(c[(c[s>>2]|0)+8>>2]|0)+16+8>>3];c[t+4>>2]=~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+16+8>>3]>=0.0?H+.5:H-.5);H=+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16>>3];c[t+8>>2]=~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16>>3]>=0.0?H+.5:H-.5);H=+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16+8>>3];c[t+8+4>>2]=~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+16+16+8>>3]>=0.0?H+.5:H-.5);g=c[z>>2]|0;c[z>>2]=g+8;c[w>>2]=c[g>>2];c[w+4>>2]=c[g+4>>2];c[t>>2]=(c[t>>2]|0)+(c[w>>2]|0);g=t+4|0;c[g>>2]=(c[g>>2]|0)+(c[w+4>>2]|0);g=t+8|0;c[g>>2]=(c[g>>2]|0)+(c[w>>2]|0);g=t+8+4|0;c[g>>2]=(c[g>>2]|0)+(c[w+4>>2]|0);c[u>>2]=(c[u>>2]|0)<(c[t>>2]|0)?c[u>>2]|0:c[t>>2]|0;c[u+4>>2]=(c[u+4>>2]|0)<(c[t+4>>2]|0)?c[u+4>>2]|0:c[t+4>>2]|0;c[u+8>>2]=(c[u+8>>2]|0)>(c[t+8>>2]|0)?c[u+8>>2]|0:c[t+8>>2]|0;if((c[u+8+4>>2]|0)>(c[t+8+4>>2]|0))I=c[u+8+4>>2]|0;else I=c[t+8+4>>2]|0;c[u+8+4>>2]=I}}}else{c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=eO(c[o>>2]|0,c[q>>2]|0,54,3)|0;c[u+8+4>>2]=eO(c[o>>2]|0,c[r>>2]|0,36,3)|0;c[B>>2]=1}while(0);if((c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]|0)!=0?(c[B>>2]=0,H=+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]|0)+24>>3],c[C>>2]=~~(+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]|0)+24>>3]>=0.0?H+.5:H-.5),H=+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]|0)+24+8>>3],c[C+4>>2]=~~(+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2]|0)+24+8>>3]>=0.0?H+.5:H-.5),c[D>>2]=(c[C>>2]|0)-((c[u+8>>2]|0)-(c[u>>2]|0)),(c[D>>2]|0)>0):0){c[D>>2]=(c[D>>2]|0)/2|0;c[u>>2]=(c[u>>2]|0)-(c[D>>2]|0);C=u+8|0;c[C>>2]=(c[C>>2]|0)+(c[D>>2]|0)}if((c[A>>2]|0)!=0|(c[B>>2]|0)!=0)c[x>>2]=0;else c[x>>2]=eO(c[k>>2]|0,c[13813]|0,8,0)|0;c[w>>2]=0-(c[u>>2]|0)+(c[x>>2]|0);c[w+4>>2]=~~(+(0-(c[u+4>>2]|0)+(c[x>>2]|0)|0)+ +h[(c[(c[o>>2]|0)+8>>2]|0)+48+8>>3]);c[u>>2]=0;c[u+4>>2]=0;B=u+8|0;c[B>>2]=(c[B>>2]|0)+((c[w>>2]|0)+(c[x>>2]|0));B=u+8+4|0;c[B>>2]=~~(+(c[B>>2]|0)+(+((c[w+4>>2]|0)+(c[x>>2]|0)|0)+ +h[(c[(c[o>>2]|0)+8>>2]|0)+48+32+8>>3]));if(!(c[l>>2]|0)){J=c[u>>2]|0;K=+(J|0);L=K/72.0;h[v>>3]=L;M=u+4|0;N=c[M>>2]|0;O=+(N|0);P=O/72.0;Q=v+8|0;h[Q>>3]=P;R=u+8|0;S=c[R>>2]|0;T=+(S|0);U=T/72.0;V=v+16|0;h[V>>3]=U;W=u+8|0;X=W+4|0;Y=c[X>>2]|0;Z=+(Y|0);_=Z/72.0;$=v+16|0;aa=$+8|0;h[aa>>3]=_;ba=c[k>>2]|0;ca=ba+8|0;da=c[ca>>2]|0;ea=da+140|0;fa=c[ea>>2]|0;ga=fa+8|0;c[ga>>2]=c[v>>2];c[ga+4>>2]=c[v+4>>2];c[ga+8>>2]=c[v+8>>2];c[ga+12>>2]=c[v+12>>2];c[ga+16>>2]=c[v+16>>2];c[ga+20>>2]=c[v+20>>2];c[ga+24>>2]=c[v+24>>2];c[ga+28>>2]=c[v+28>>2];i=j;return}c[y>>2]=c[m>>2];c[z>>2]=c[n>>2];b:while(1){n=c[y>>2]|0;c[y>>2]=n+4;m=c[n>>2]|0;c[s>>2]=m;if(!m)break;if(c[z>>2]|0){m=c[z>>2]|0;c[z>>2]=m+8;c[E>>2]=c[m>>2];c[E+4>>2]=c[m+4>>2];c[E>>2]=(c[E>>2]|0)+(c[w>>2]|0);m=E+4|0;c[m>>2]=(c[m>>2]|0)+(c[w+4>>2]|0)}else{c[E>>2]=c[w>>2];c[E+4>>2]=c[w+4>>2]}h[G>>3]=+(c[E>>2]|0)/72.0;h[G+8>>3]=+(c[E+4>>2]|0)/72.0;c[F>>2]=$B(c[s>>2]|0)|0;while(1){if(!(c[F>>2]|0))continue b;m=c[(c[(c[F>>2]|0)+8>>2]|0)+132>>2]|0;h[m>>3]=+h[m>>3]+ +h[G>>3];m=(c[(c[(c[F>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[m>>3]=+h[m>>3]+ +h[G+8>>3];c[F>>2]=aC(c[s>>2]|0,c[F>>2]|0)|0}}J=c[u>>2]|0;K=+(J|0);L=K/72.0;h[v>>3]=L;M=u+4|0;N=c[M>>2]|0;O=+(N|0);P=O/72.0;Q=v+8|0;h[Q>>3]=P;R=u+8|0;S=c[R>>2]|0;T=+(S|0);U=T/72.0;V=v+16|0;h[V>>3]=U;W=u+8|0;X=W+4|0;Y=c[X>>2]|0;Z=+(Y|0);_=Z/72.0;$=v+16|0;aa=$+8|0;h[aa>>3]=_;ba=c[k>>2]|0;ca=ba+8|0;da=c[ca>>2]|0;ea=da+140|0;fa=c[ea>>2]|0;ga=fa+8|0;c[ga>>2]=c[v>>2];c[ga+4>>2]=c[v+4>>2];c[ga+8>>2]=c[v+8>>2];c[ga+12>>2]=c[v+12>>2];c[ga+16>>2]=c[v+16>>2];c[ga+20>>2]=c[v+20>>2];c[ga+24>>2]=c[v+24>>2];c[ga+28>>2]=c[v+28>>2];i=j;return}function ko(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;while(1){b=c[f>>2]|0;c[f>>2]=b+4;a=c[b>>2]|0;c[g>>2]=a;if(!a)break;lo(c[g>>2]|0);NC(c[g>>2]|0,175049)|0}if(c[c[(c[(c[e>>2]|0)+8>>2]|0)+140>>2]>>2]|0)O4(c[c[(c[(c[e>>2]|0)+8>>2]|0)+140>>2]>>2]|0);lo(c[e>>2]|0);NC(c[e>>2]|0,175049)|0;c[h>>2]=$B(c[e>>2]|0)|0;while(1){l=c[e>>2]|0;if(!(c[h>>2]|0))break;c[j>>2]=aC(l,c[h>>2]|0)|0;c[k>>2]=OA(c[e>>2]|0,c[h>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;O4(c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]|0);NC(c[k>>2]|0,175319)|0;c[k>>2]=QA(c[e>>2]|0,c[k>>2]|0)|0}mo(c[h>>2]|0);c[h>>2]=c[j>>2]}jB(l)|0;i=d;return}function lo(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[(c[d>>2]|0)+8>>2]|0)+140>>2]|0);i=b;return}function mo(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[(c[d>>2]|0)+8>>2]|0)+112>>2]|0);O4(c[(c[(c[d>>2]|0)+8>>2]|0)+132>>2]|0);NC(c[d>>2]|0,175026)|0;i=b;return}function no(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0;d=i;i=i+80|0;e=d+76|0;f=d+72|0;g=d+68|0;j=d+64|0;k=d+60|0;l=d+40|0;m=d+32|0;n=d+56|0;o=d+52|0;p=d+48|0;q=d+24|0;r=d+16|0;s=d+8|0;t=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=c[c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]>>2];c[g>>2]=bK(((c[j>>2]|0)+1|0)*24|0)|0;c[k>>2]=0;c[n>>2]=TA(c[f>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;b=c[n>>2]|0;a=c[c[n>>2]>>2]&3;if((c[((c[c[n>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)==(c[e>>2]|0)){b=c[n>>2]|0;c[o>>2]=c[((a|0)==3?b:b+32|0)+28>>2]}else{b=c[n>>2]|0;c[o>>2]=c[((a|0)==2?b:b+-32|0)+28>>2]}h[l>>3]=+h[c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]>>3];h[m>>3]=+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];c[(c[g>>2]|0)+((c[k>>2]|0)*24|0)>>2]=c[n>>2];u=+W(+(+h[m>>3]),+(+h[l>>3]));h[(c[g>>2]|0)+((c[k>>2]|0)*24|0)+8>>3]=u;h[(c[g>>2]|0)+((c[k>>2]|0)*24|0)+16>>3]=+h[l>>3]*+h[l>>3]+ +h[m>>3]*+h[m>>3];c[k>>2]=(c[k>>2]|0)+1;c[n>>2]=UA(c[f>>2]|0,c[n>>2]|0,c[e>>2]|0)|0}if((c[k>>2]|0)!=(c[j>>2]|0))La(127868,127845,643,127877);w3(c[g>>2]|0,c[j>>2]|0,24,67);if((c[j>>2]|0)<2){v=c[g>>2]|0;i=d;return v|0}c[k>>2]=0;a:while(1){if((c[k>>2]|0)>=((c[j>>2]|0)-1|0))break;h[q>>3]=+h[(c[g>>2]|0)+((c[k>>2]|0)*24|0)+8>>3];c[p>>2]=(c[k>>2]|0)+1;while(1){if((c[p>>2]|0)<(c[j>>2]|0))w=+h[(c[g>>2]|0)+((c[p>>2]|0)*24|0)+8>>3]==+h[q>>3];else w=0;x=c[p>>2]|0;if(!w)break;c[p>>2]=x+1}e=c[p>>2]|0;if((x|0)==((c[k>>2]|0)+1|0)){c[k>>2]=e;continue}if((e|0)==(c[j>>2]|0))h[t>>3]=3.141592653589793;else h[t>>3]=+h[(c[g>>2]|0)+((c[p>>2]|0)*24|0)+8>>3];h[s>>3]=(+h[t>>3]-+h[q>>3])/+((c[p>>2]|0)-(c[k>>2]|0)|0);if(+h[s>>3]>.03490658503988659)h[s>>3]=.03490658503988659;h[r>>3]=0.0;while(1){if((c[k>>2]|0)>=(c[p>>2]|0))continue a;e=(c[g>>2]|0)+((c[k>>2]|0)*24|0)+8|0;h[e>>3]=+h[e>>3]+ +h[r>>3];h[r>>3]=+h[r>>3]+ +h[s>>3];c[k>>2]=(c[k>>2]|0)+1}}v=c[g>>2]|0;i=d;return v|0}function oo(a,d,e,f,g){a=a|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+80|0;k=j+68|0;l=j+64|0;m=j+60|0;n=j+56|0;o=j+16|0;p=j+52|0;q=j+48|0;r=j+44|0;s=j+40|0;t=j+36|0;u=j+8|0;v=j;w=j+32|0;x=j+28|0;y=j+24|0;c[k>>2]=a;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;h[o>>3]=g;c[r>>2]=c[c[l>>2]>>2];c[q>>2]=b[(c[(c[r>>2]|0)+8>>2]|0)+168>>1];f=c[r>>2]|0;e=c[c[r>>2]>>2]&3;if((c[((c[c[r>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)==(c[k>>2]|0)){f=c[r>>2]|0;c[p>>2]=c[((e|0)==3?f:f+32|0)+28>>2]}else{f=c[r>>2]|0;c[p>>2]=c[((e|0)==2?f:f+-32|0)+28>>2]}h[v>>3]=(+h[o>>3]-+h[(c[l>>2]|0)+8>>3])/+(c[q>>2]|0);h[u>>3]=+h[(c[l>>2]|0)+8>>3];if(+h[v>>3]>.03490658503988659)h[v>>3]=.03490658503988659;l=c[n>>2]|0;if((c[k>>2]|0)>>>0<(c[p>>2]|0)>>>0){c[w>>2]=l;c[y>>2]=1}else{c[w>>2]=l+(c[q>>2]|0)-1;c[y>>2]=-1;h[u>>3]=+h[u>>3]+ +h[v>>3]*+((c[q>>2]|0)-1|0);h[v>>3]=-+h[v>>3]}l=c[(c[(c[r>>2]|0)+8>>2]|0)+172>>2]|0;c[s>>2]=l;c[t>>2]=l;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(b[(c[(c[r>>2]|0)+8>>2]|0)+168>>1]|0))break;c[s>>2]=c[c[t>>2]>>2];c[(c[m>>2]|0)+(c[w>>2]<<4)>>2]=c[s>>2];l=c[s>>2]|0;p=c[c[s>>2]>>2]&3;if((c[(c[(c[((c[c[s>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+164>>2]|0)==(c[k>>2]|0)){l=c[s>>2]|0;z=c[((p|0)==3?l:l+32|0)+28>>2]|0}else{l=c[s>>2]|0;z=c[((p|0)==2?l:l+-32|0)+28>>2]|0}c[(c[m>>2]|0)+(c[w>>2]<<4)+4>>2]=z;h[(c[m>>2]|0)+(c[w>>2]<<4)+8>>3]=+h[u>>3];c[w>>2]=(c[w>>2]|0)+(c[y>>2]|0);h[u>>3]=+h[u>>3]+ +h[v>>3];c[x>>2]=(c[x>>2]|0)+1;c[t>>2]=(c[t>>2]|0)+4}i=j;return (c[n>>2]|0)+(c[q>>2]|0)|0}function po(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[f>>2];c[k>>2]=c[g>>2];do if(!(+h[(c[j>>2]|0)+8>>3]>+h[(c[k>>2]|0)+8>>3])){if(+h[(c[j>>2]|0)+8>>3]<+h[(c[k>>2]|0)+8>>3]){c[e>>2]=-1;break}if(+h[(c[j>>2]|0)+16>>3]>+h[(c[k>>2]|0)+16>>3]){c[e>>2]=1;break}if(+h[(c[j>>2]|0)+16>>3]<+h[(c[k>>2]|0)+16>>3]){c[e>>2]=-1;break}else{c[e>>2]=0;break}}else c[e>>2]=1;while(0);i=d;return c[e>>2]|0}function qo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=qA(c[f>>2]|0,0,c[h>>2]|0,0)|0;c[k>>2]=d;if(!d){i=e;return}c[j>>2]=zA(c[f>>2]|0,c[k>>2]|0)|0;c[k>>2]=qA(c[g>>2]|0,0,c[h>>2]|0,0)|0;f=c[g>>2]|0;if(c[k>>2]|0){BA(f,c[k>>2]|0,c[j>>2]|0)|0;i=e;return}else{qA(f,0,c[h>>2]|0,c[j>>2]|0)|0;i=e;return}}function ro(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0;d=i;i=i+16|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=fC(c[f>>2]|0,c[g>>2]|0,1)|0;MC(c[h>>2]|0,175026,304,1)|0;g=bK(32)|0;c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]=g;g=cK((e[(c[(c[f>>2]|0)+8>>2]|0)+176>>1]|0)<<3)|0;c[(c[(c[h>>2]|0)+8>>2]|0)+132>>2]=g;i=d;return c[h>>2]|0}function so(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+112|0;j=g+56|0;k=g+32|0;l=g+92|0;m=g+88|0;n=g+84|0;o=g+80|0;p=g+76|0;q=g+72|0;r=g;s=g+96|0;t=g+68|0;u=g+64|0;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[u>>2]=c[(c[n>>2]|0)+4>>2];c[p>>2]=zA(c[l>>2]|0,c[u>>2]|0)|0;if(!(a[c[p>>2]>>0]|0)){i=g;return}if((c[l>>2]|0)!=(c[c[n>>2]>>2]|0)){c[t>>2]=ID(c[l>>2]|0)|0;c[q>>2]=zA(c[t>>2]|0,c[u>>2]|0)|0;if((c[q>>2]|0)==(c[p>>2]|0)){i=g;return}if(!(J3(c[p>>2]|0,c[q>>2]|0)|0)){i=g;return}}a[s>>0]=0;q=c[p>>2]|0;c[k>>2]=r;c[k+4>>2]=r+8;c[k+8>>2]=r+16;c[k+12>>2]=r+16+8;c[k+16>>2]=s;if((l3(q,129031,k)|0)<4){k=wB(c[l>>2]|0)|0;l=c[p>>2]|0;c[j>>2]=k;c[j+4>>2]=l;$z(0,129049,j)|0;i=g;return}if(+h[4246]>0.0){h[r>>3]=+h[r>>3]/+h[4246];j=r+8|0;h[j>>3]=+h[j>>3]/+h[4246];j=r+16|0;h[j>>3]=+h[j>>3]/+h[4246];j=r+16+8|0;h[j>>3]=+h[j>>3]/+h[4246]}do if((a[s>>0]|0)!=33){j=(c[(c[m>>2]|0)+8>>2]|0)+119|0;if((a[s>>0]|0)==63){a[j>>0]=2;break}else{a[j>>0]=1;break}}else a[(c[(c[m>>2]|0)+8>>2]|0)+119>>0]=3;while(0);m=c[o>>2]|0;c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];c[m+16>>2]=c[r+16>>2];c[m+20>>2]=c[r+20>>2];c[m+24>>2]=c[r+24>>2];c[m+28>>2]=c[r+28>>2];i=g;return}function to(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e+12|0;j=e;c[f>>2]=a;c[g>>2]=d;b[h>>1]=b[(c[(c[f>>2]|0)+8>>2]|0)+168>>1]|0;c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2];if(c[j>>2]|0)k=eK(c[j>>2]|0,(b[h>>1]|0)+1<<2)|0;else k=cK((b[h>>1]|0)+1<<2)|0;c[j>>2]=k;c[(c[j>>2]|0)+(b[h>>1]<<2)>>2]=c[g>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2]=c[j>>2];j=(c[(c[f>>2]|0)+8>>2]|0)+168|0;b[j>>1]=(b[j>>1]|0)+1<<16>>16;i=e;return}function uo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+64|0;e=d+16|0;f=d;g=d+52|0;h=d+48|0;j=d+44|0;k=d+40|0;l=d+36|0;m=d+32|0;c[g>>2]=a;c[h>>2]=b;c[j>>2]=c[c[h>>2]>>2];h=c[j>>2]|0;c[k>>2]=c[((c[c[j>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2];h=c[j>>2]|0;c[l>>2]=c[((c[c[j>>2]>>2]&3|0)==3?h:h+32|0)+28>>2];c[m>>2]=8;h=N3(wB(c[g>>2]|0)|0)|0;b=h+(N3(wB(c[k>>2]|0)|0)|0)|0;h=b+(N3(wB(c[l>>2]|0)|0)|0)|0;c[m>>2]=(c[m>>2]|0)+h;h=(c[m>>2]|0)>=1e3;m=wB(c[g>>2]|0)|0;g=c[l>>2]|0;if(h){h=wB(g)|0;l=wB(c[k>>2]|0)|0;b=(c[c[j>>2]>>2]|0)>>>4;c[f>>2]=m;c[f+4>>2]=h;c[f+8>>2]=l;c[f+12>>2]=b;k3(127988,128989,f)|0;i=d;return 127988}else{f=c[(c[g+8>>2]|0)+120>>2]|0;g=c[(c[(c[k>>2]|0)+8>>2]|0)+120>>2]|0;k=(c[c[j>>2]>>2]|0)>>>4;c[e>>2]=m;c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=k;k3(127988,129008,e)|0;i=d;return 127988}return 0}function vo(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[c[d>>2]>>2]=0;c[(c[d>>2]|0)+4>>2]=0;c[(c[d>>2]|0)+8>>2]=0;i=b;return}function wo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=(c[e>>2]|0)+8|0;c[b>>2]=(c[b>>2]|0)+1;if((c[(c[e>>2]|0)+8>>2]|0)>=(c[(c[e>>2]|0)+4>>2]|0)){b=(c[e>>2]|0)+4|0;c[b>>2]=(c[b>>2]|0)+10;b=eK(c[c[e>>2]>>2]|0,c[(c[e>>2]|0)+4>>2]<<2)|0;c[c[e>>2]>>2]=b}c[(c[c[e>>2]>>2]|0)+(c[(c[e>>2]|0)+8>>2]<<2)>>2]=c[f>>2];i=d;return}function xo(a){a=a|0;var b=0,d=0,e=0.0;b=i;i=i+16|0;d=b+4|0;c[d>>2]=a;c[8328]=c[c[13790]>>2];c[8329]=c[(c[13790]|0)+4>>2];c[8331]=c[(c[13790]|0)+8>>2];c[8333]=c[(c[13790]|0)+12>>2];h[4172]=0.0;h[4167]=+h[(c[13790]|0)+16>>3];h[4168]=+h[(c[13790]|0)+24>>3];a=c[d>>2]|0;c[8332]=eO(a,qA(c[d>>2]|0,0,129092,0)|0,600,0)|0;a=c[d>>2]|0;e=+fO(a,qA(c[d>>2]|0,0,129305,0)|0,.3,0.0);h[4169]=e;h[(c[13790]|0)+32>>3]=e;if(+h[(c[13790]|0)+40>>3]==-1.0){a=c[d>>2]|0;h[4170]=+fO(a,qA(c[d>>2]|0,0,129100,0)|0,-1.0,0.0)}else h[4170]=+h[(c[13790]|0)+40>>3];c[8330]=1;c[8342]=ul(c[d>>2]|0,2,33320)|0;if(!(c[8342]|0)){$z(0,129103,b)|0;c[8330]=2}c[8358]=(_(c[8333]|0,c[8332]|0)|0)/100|0;h[4174]=+h[4169]*+h[4169];if(!(c[8328]|0)){i=b;return}if(+h[4172]<=0.0)h[4172]=+h[4169]*3.0;h[4173]=+h[4172]*+h[4172];i=b;return}function yo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+80|0;e=d+64|0;f=d+60|0;g=d+56|0;j=d+52|0;k=d+48|0;l=d+32|0;m=d+44|0;n=d+16|0;o=d+40|0;p=d;c[e>>2]=a;c[f>>2]=b;c[k>>2]=c[c[(c[(c[e>>2]|0)+8>>2]|0)+140>>2]>>2];c[j>>2]=zo(c[e>>2]|0,c[f>>2]|0)|0;h[l>>3]=+h[4170];Ao(p,c[e>>2]|0,c[k>>2]|0);c[n>>2]=c[p>>2];c[n+4>>2]=c[p+4>>2];c[n+8>>2]=c[p+8>>2];c[n+12>>2]=c[p+12>>2];a:do if(c[8328]|0){c[m>>2]=dv(kB(c[e>>2]|0)|0)|0;p=c[m>>2]|0;ev(p,kB(c[e>>2]|0)|0);c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[8359]|0))break;h[l>>3]=+Bo(+h[l>>3],c[g>>2]|0);Co(c[e>>2]|0,+h[l>>3],c[k>>2]|0,c[m>>2]|0);c[g>>2]=(c[g>>2]|0)+1}gv(c[m>>2]|0)}else{c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[8359]|0))break a;h[l>>3]=+Bo(+h[l>>3],c[g>>2]|0);Do(c[e>>2]|0,+h[l>>3],c[k>>2]|0);c[g>>2]=(c[g>>2]|0)+1}}while(0);if(!(!(+h[n>>3]!=0.0)?!(+h[n+8>>3]!=0.0):0))q=11;b:do if((q|0)==11){c[o>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[o>>2]|0))break b;g=c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0;h[g>>3]=+h[g>>3]+ +h[n>>3];g=(c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[g>>3]=+h[g>>3]+ +h[n+8>>3];c[o>>2]=aC(c[e>>2]|0,c[o>>2]|0)|0}}while(0);if(!(c[j>>2]|0)){i=d;return}Eo();i=d;return}function zo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;if(+h[4170]==-1.0){c[j>>2]=kB(c[e>>2]|0)|0;h[4170]=+h[4168]*+h[4169]*+O(+(+(c[j>>2]|0)))/5.0;c[g>>2]=1}k=+Bo(+h[4170],c[8358]|0);h[(c[f>>2]|0)+8>>3]=k;h[(c[f>>2]|0)+16>>3]=+h[4169];h[(c[f>>2]|0)+24>>3]=+h[4167];c[c[f>>2]>>2]=(c[8332]|0)-(c[8358]|0);if((c[8331]|0)<0){c[8359]=c[8358];c[(c[f>>2]|0)+32>>2]=c[c[f>>2]>>2];l=c[g>>2]|0;i=d;return l|0}j=c[8331]|0;if((c[8331]|0)<=(c[8358]|0)){c[8359]=j;c[(c[f>>2]|0)+32>>2]=0;l=c[g>>2]|0;i=d;return l|0}if((j|0)>(c[8332]|0)){l=c[g>>2]|0;i=d;return l|0}c[8359]=c[8358];c[(c[f>>2]|0)+32>>2]=(c[8331]|0)-(c[8358]|0);l=c[g>>2]|0;i=d;return l|0}function Ao(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0;g=i;i=i+160|0;j=g+152|0;k=g+148|0;l=g+144|0;m=g+96|0;n=g+140|0;o=g+136|0;p=g+120|0;q=g+80|0;r=g+116|0;s=g+72|0;t=g+64|0;u=g+56|0;v=g+48|0;w=g+40|0;x=g+32|0;y=g+16|0;z=g+112|0;A=g+108|0;B=g+104|0;C=g+8|0;D=g;c[j>>2]=e;c[k>>2]=f;f=kB(c[j>>2]|0)|0;c[l>>2]=f-(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+140>>2]|0)+4>>2]|0);c[o>>2]=0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;h[s>>3]=6.283185307179586;c[n>>2]=$B(c[j>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;if(a[(c[(c[n>>2]|0)+8>>2]|0)+119>>0]|0){E=+h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3];if(c[o>>2]|0){if(E<+(c[p>>2]|0))F=+h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3];else F=+(c[p>>2]|0);c[p>>2]=~~F;if(+h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]<+(c[p+4>>2]|0))G=+h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];else G=+(c[p+4>>2]|0);c[p+4>>2]=~~G;if(+h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3]>+(c[p+8>>2]|0))H=+h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3];else H=+(c[p+8>>2]|0);c[p+8>>2]=~~H;if(+h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]>+(c[p+8+4>>2]|0))I=+h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];else I=+(c[p+8+4>>2]|0);c[p+8+4>>2]=~~I}else{f=~~E;c[p>>2]=f;c[p+8>>2]=f;f=~~+h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];c[p+4>>2]=f;c[p+8+4>>2]=f}c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=aC(c[j>>2]|0,c[n>>2]|0)|0}h[m>>3]=+h[4169]*(+O(+(+(c[l>>2]|0)))+1.0);I=+h[m>>3]/2.0*1.2;h[4176]=I;h[4175]=I;do if((c[o>>2]|0)==1){h[q>>3]=+(c[p>>2]|0);h[q+8>>3]=+(c[p+4>>2]|0)}else{if((c[o>>2]|0)<=1){h[q+8>>3]=0.0;h[q>>3]=0.0;break}h[q>>3]=+((c[p>>2]|0)+(c[p+8>>2]|0)|0)/2.0;h[q+8>>3]=+((c[p+4>>2]|0)+(c[p+8+4>>2]|0)|0)/2.0;h[v>>3]=+((c[p+8>>2]|0)-(c[p>>2]|0)|0)*1.2;h[w>>3]=+((c[p+8+4>>2]|0)-(c[p+4>>2]|0)|0)*1.2;h[u>>3]=+h[4175]*4.0*+h[4176];h[x>>3]=+h[v>>3]*+h[w>>3]/+h[u>>3];do if(!(+h[x>>3]>=1.0)){if(+h[x>>3]>0.0){h[x>>3]=+O(+(+h[x>>3]))*2.0;h[4175]=+h[v>>3]/+h[x>>3];h[4176]=+h[w>>3]/+h[x>>3];break}if(+h[v>>3]>0.0){h[w>>3]=+h[u>>3]/+h[v>>3];h[4175]=+h[v>>3]/2.0;h[4176]=+h[w>>3]/2.0;break}if(+h[w>>3]>0.0){h[v>>3]=+h[u>>3]/+h[w>>3];h[4175]=+h[v>>3]/2.0;h[4176]=+h[w>>3]/2.0}}else{h[4175]=+h[v>>3]/2.0;h[4176]=+h[w>>3]/2.0}while(0);h[t>>3]=+W(+(+h[4176]),+(+h[4175]));h[4175]=+h[4175]/+Q(+(+h[t>>3]));h[4176]=+h[4176]/+R(+(+h[t>>3]))}while(0);h[4177]=+h[4175]*+h[4175];h[4178]=+h[4176]*+h[4176];if((c[8342]|0)==2)c[r>>2]=c[8330];else{t=_3()|0;c[r>>2]=t^(sb(0)|0)}v2(c[r>>2]|0);if(!(c[k>>2]|0)){r=(c[o>>2]|0)!=0;c[n>>2]=$B(c[j>>2]|0)|0;if(!r){while(1){if(!(c[n>>2]|0))break;I=+h[4175];H=I*(+r2()*2.0-1.0);h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3]=H;H=+h[4176];I=H*(+r2()*2.0-1.0);h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=I;c[n>>2]=aC(c[j>>2]|0,c[n>>2]|0)|0}c[b>>2]=c[q>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];c[b+12>>2]=c[q+12>>2];i=g;return}while(1){if(!(c[n>>2]|0))break;if(a[(c[(c[n>>2]|0)+8>>2]|0)+119>>0]|0){r=c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0;h[r>>3]=+h[r>>3]-+h[q>>3];r=(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[r>>3]=+h[r>>3]-+h[q+8>>3]}else{I=+h[4175];H=I*(+r2()*2.0-1.0);h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3]=H;H=+h[4176];I=H*(+r2()*2.0-1.0);h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=I}c[n>>2]=aC(c[j>>2]|0,c[n>>2]|0)|0}c[b>>2]=c[q>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];c[b+12>>2]=c[q+12>>2];i=g;return}while(1){if(!(c[c[k>>2]>>2]|0))break;c[n>>2]=c[(c[k>>2]|0)+4>>2];I=+h[4175]*+Q(+(+h[(c[k>>2]|0)+8>>3]));h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3]=I+ +h[q>>3];I=+h[4176]*+R(+(+h[(c[k>>2]|0)+8>>3]));h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=I+ +h[q+8>>3];a[(c[(c[n>>2]|0)+8>>2]|0)+119>>0]=1;c[k>>2]=(c[k>>2]|0)+16}c[n>>2]=$B(c[j>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;if(!((c[(c[(c[(c[n>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0)==0?(c[(c[(c[n>>2]|0)+8>>2]|0)+212>>2]|0)==0:0))J=44;do if((J|0)==44){J=0;if(a[(c[(c[n>>2]|0)+8>>2]|0)+119>>0]|0){k=c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0;h[k>>3]=+h[k>>3]-+h[q>>3];k=(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[k>>3]=+h[k>>3]-+h[q+8>>3];break};c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;c[y+12>>2]=0;c[z>>2]=0;c[B>>2]=TA(c[j>>2]|0,c[n>>2]|0)|0;while(1){if(!(c[B>>2]|0))break;k=c[B>>2]|0;r=c[B>>2]|0;if((c[((c[c[B>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)!=(c[((c[c[B>>2]>>2]&3|0)==3?r:r+32|0)+28>>2]|0)){r=c[B>>2]|0;k=c[c[B>>2]>>2]&3;if((c[((c[c[B>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)==(c[n>>2]|0)){r=c[B>>2]|0;K=c[((k|0)==3?r:r+32|0)+28>>2]|0}else{r=c[B>>2]|0;K=c[((k|0)==2?r:r+-32|0)+28>>2]|0}c[A>>2]=K;if((d[(c[(c[A>>2]|0)+8>>2]|0)+119>>0]|0)>0){if(c[z>>2]|0){h[y>>3]=(+h[y>>3]*+(c[z>>2]|0)+ +h[c[(c[(c[A>>2]|0)+8>>2]|0)+132>>2]>>3])/+((c[z>>2]|0)+1|0);h[y+8>>3]=(+h[y+8>>3]*+(c[z>>2]|0)+ +h[(c[(c[(c[A>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3])/+((c[z>>2]|0)+1|0)}else{h[y>>3]=+h[c[(c[(c[A>>2]|0)+8>>2]|0)+132>>2]>>3];h[y+8>>3]=+h[(c[(c[(c[A>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]}c[z>>2]=(c[z>>2]|0)+1}}c[B>>2]=UA(c[j>>2]|0,c[B>>2]|0,c[n>>2]|0)|0}do if((c[z>>2]|0)<=1)if((c[z>>2]|0)==1){h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[y>>3]*.98+ +h[q>>3]*.1;h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[y+8>>3]*.9+ +h[q+8>>3]*.1;break}else{I=+h[s>>3];h[C>>3]=I*+r2();h[D>>3]=+r2()*.9;I=+h[D>>3]*+h[4175]*+Q(+(+h[C>>3]));h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3]=I;I=+h[D>>3]*+h[4176]*+R(+(+h[C>>3]));h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=I;break}else{h[c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[y>>3];h[(c[(c[(c[n>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[y+8>>3]}while(0);a[(c[(c[n>>2]|0)+8>>2]|0)+119>>0]=1}while(0);c[n>>2]=aC(c[j>>2]|0,c[n>>2]|0)|0}c[b>>2]=c[q>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];c[b+12>>2]=c[q+12>>2];i=g;return}function Bo(a,b){a=+a;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+8|0;h[d>>3]=a;c[e>>2]=b;i=d;return +(+h[4170]*+((c[8332]|0)-(c[e>>2]|0)|0)/+(c[8332]|0))}function Co(a,b,d,e){a=a|0;b=+b;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;j=f;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;c[g>>2]=a;h[j>>3]=b;c[k>>2]=d;c[l>>2]=e;if(+h[j>>3]<=0.0){i=f;return}fv(c[l>>2]|0);c[m>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;h[(c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>3]=0.0;h[(c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]|0)+16>>3]=0.0;e=~~+M(+(+h[c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]>>3]/+h[4172]));d=~~+M(+(+h[(c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]/+h[4172]));hv(c[l>>2]|0,e,d,c[m>>2]|0);c[m>>2]=aC(c[g>>2]|0,c[m>>2]|0)|0}c[m>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;c[n>>2]=OA(c[g>>2]|0,c[m>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;d=c[n>>2]|0;if((c[m>>2]|0)!=(c[((c[c[n>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)){d=c[n>>2]|0;Go(c[m>>2]|0,c[((c[c[n>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0,c[n>>2]|0)}c[n>>2]=QA(c[g>>2]|0,c[n>>2]|0)|0}c[m>>2]=aC(c[g>>2]|0,c[m>>2]|0)|0}iv(c[l>>2]|0,28);Ho(c[g>>2]|0,+h[j>>3],c[k>>2]|0);i=f;return}function Do(a,b,d){a=a|0;b=+b;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;c[f>>2]=a;h[g>>3]=b;c[j>>2]=d;if(+h[g>>3]<=0.0){i=e;return}c[k>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>3]=0.0;h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16>>3]=0.0;c[k>>2]=aC(c[f>>2]|0,c[k>>2]|0)|0}c[k>>2]=$B(c[f>>2]|0)|0;while(1){n=c[f>>2]|0;if(!(c[k>>2]|0))break;c[l>>2]=aC(n,c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;Fo(c[k>>2]|0,c[l>>2]|0);c[l>>2]=aC(c[f>>2]|0,c[l>>2]|0)|0}c[m>>2]=OA(c[f>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;d=c[m>>2]|0;if((c[k>>2]|0)!=(c[((c[c[m>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)){d=c[m>>2]|0;Go(c[k>>2]|0,c[((c[c[m>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0,c[m>>2]|0)}c[m>>2]=QA(c[f>>2]|0,c[m>>2]|0)|0}c[k>>2]=aC(c[f>>2]|0,c[k>>2]|0)|0}Ho(n,+h[g>>3],c[j>>2]|0);i=e;return}function Eo(){h[4170]=-1.0;return}function Fo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+8|0;j=d;c[e>>2]=a;c[f>>2]=b;h[g>>3]=+h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]>>3];h[j>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];Io(c[e>>2]|0,c[f>>2]|0,+h[g>>3],+h[j>>3],+h[g>>3]*+h[g>>3]+ +h[j>>3]*+h[j>>3]);i=d;return}function Go(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0;e=i;i=i+64|0;f=e+48|0;g=e+44|0;j=e+40|0;k=e+32|0;l=e+24|0;m=e+16|0;n=e+8|0;o=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;h[k>>3]=+h[c[(c[(c[g>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3];h[l>>3]=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];h[o>>3]=+h[k>>3]*+h[k>>3]+ +h[l>>3]*+h[l>>3];while(1){if(!(+h[o>>3]==0.0))break;h[k>>3]=+(5-((t2()|0)%10|0)|0);h[l>>3]=+(5-((t2()|0)%10|0)|0);h[o>>3]=+h[k>>3]*+h[k>>3]+ +h[l>>3]*+h[l>>3]}h[n>>3]=+O(+(+h[o>>3]));p=+h[(c[(c[j>>2]|0)+8>>2]|0)+128>>3];q=+h[n>>3];if(c[8329]|0)h[m>>3]=p*(q-+h[(c[(c[j>>2]|0)+8>>2]|0)+136>>3])/+h[n>>3];else h[m>>3]=p*q/+h[(c[(c[j>>2]|0)+8>>2]|0)+136>>3];j=(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+16|0;h[j>>3]=+h[j>>3]-+h[k>>3]*+h[m>>3];j=(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+16+8|0;h[j>>3]=+h[j>>3]-+h[l>>3]*+h[m>>3];j=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16|0;h[j>>3]=+h[j>>3]+ +h[k>>3]*+h[m>>3];k=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16+8|0;h[k>>3]=+h[k>>3]+ +h[l>>3]*+h[m>>3];i=e;return}function Ho(a,b,e){a=a|0;b=+b;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+96|0;g=f+80|0;j=f+64|0;k=f+76|0;l=f+72|0;m=f+56|0;n=f+48|0;o=f+40|0;p=f+32|0;q=f+24|0;r=f+16|0;s=f+8|0;t=f;c[g>>2]=a;h[j>>3]=b;c[k>>2]=e;h[m>>3]=+h[j>>3]*+h[j>>3];c[l>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;do if(!((d[(c[(c[l>>2]|0)+8>>2]|0)+119>>0]|0)&2)){h[r>>3]=+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16>>3];h[s>>3]=+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>3];h[n>>3]=+h[r>>3]*+h[r>>3]+ +h[s>>3]*+h[s>>3];if(+h[n>>3]<+h[m>>3]){h[o>>3]=+h[c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]>>3]+ +h[r>>3];h[p>>3]=+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]+ +h[s>>3]}else{h[t>>3]=+h[j>>3]/+O(+(+h[n>>3]));h[o>>3]=+h[c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]>>3]+ +h[r>>3]*+h[t>>3];h[p>>3]=+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]+ +h[s>>3]*+h[t>>3]}b=+h[o>>3];if(!(c[k>>2]|0)){h[c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]>>3]=b;h[(c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[p>>3];break}h[q>>3]=+O(+(b*+h[o>>3]/+h[4177]+ +h[p>>3]*+h[p>>3]/+h[4178]));if((c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0)==0?(c[(c[(c[l>>2]|0)+8>>2]|0)+212>>2]|0)==0:0){h[c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[o>>3]/+h[q>>3];h[(c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[p>>3]/+h[q>>3];break}b=+h[o>>3];if(+h[q>>3]>=1.0){h[c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]>>3]=.95*b/+h[q>>3];h[(c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[p>>3]*.95/+h[q>>3];break}else{h[c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]>>3]=b;h[(c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[p>>3];break}}while(0);c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}i=f;return}function Io(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+48|0;j=g+44|0;k=g+40|0;l=g+32|0;m=g+24|0;n=g+16|0;o=g+8|0;p=g;c[j>>2]=a;c[k>>2]=b;h[l>>3]=d;h[m>>3]=e;h[n>>3]=f;while(1){if(!(+h[n>>3]==0.0))break;h[l>>3]=+(5-((t2()|0)%10|0)|0);h[m>>3]=+(5-((t2()|0)%10|0)|0);h[n>>3]=+h[l>>3]*+h[l>>3]+ +h[m>>3]*+h[m>>3]}if(c[8329]|0){h[p>>3]=+O(+(+h[n>>3]));h[o>>3]=+h[4174]/(+h[p>>3]*+h[n>>3])}else h[o>>3]=+h[4174]/+h[n>>3];if((((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0)==0?(c[(c[(c[j>>2]|0)+8>>2]|0)+212>>2]|0)==0:0)?(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0)==0:0)?(c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]|0)==0:0)h[o>>3]=+h[o>>3]*10.0;n=(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16|0;h[n>>3]=+h[n>>3]+ +h[l>>3]*+h[o>>3];n=(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16+8|0;h[n>>3]=+h[n>>3]+ +h[m>>3]*+h[o>>3];n=(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16|0;h[n>>3]=+h[n>>3]-+h[l>>3]*+h[o>>3];l=(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8|0;h[l>>3]=+h[l>>3]-+h[m>>3]*+h[o>>3];i=g;return}function Jo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[e+28>>2]=a;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[(c[f>>2]|0)+8>>2];c[j>>2]=c[c[f>>2]>>2];c[k>>2]=c[(c[f>>2]|0)+4>>2];c[l>>2]=c[h>>2];while(1){if(!(c[l>>2]|0))break;c[m>>2]=c[h>>2];while(1){n=c[l>>2]|0;if(!(c[m>>2]|0))break;if((n|0)!=(c[m>>2]|0))Fo(c[c[l>>2]>>2]|0,c[c[m>>2]>>2]|0);c[m>>2]=c[(c[m>>2]|0)+4>>2]}c[l>>2]=c[n+4>>2]}Ko(c[g>>2]|0,(c[j>>2]|0)-1|0,(c[k>>2]|0)-1|0,c[h>>2]|0);Ko(c[g>>2]|0,(c[j>>2]|0)-1|0,c[k>>2]|0,c[h>>2]|0);Ko(c[g>>2]|0,(c[j>>2]|0)-1|0,(c[k>>2]|0)+1|0,c[h>>2]|0);Ko(c[g>>2]|0,c[j>>2]|0,(c[k>>2]|0)-1|0,c[h>>2]|0);Ko(c[g>>2]|0,c[j>>2]|0,(c[k>>2]|0)+1|0,c[h>>2]|0);Ko(c[g>>2]|0,(c[j>>2]|0)+1|0,(c[k>>2]|0)-1|0,c[h>>2]|0);Ko(c[g>>2]|0,(c[j>>2]|0)+1|0,c[k>>2]|0,c[h>>2]|0);Ko(c[g>>2]|0,(c[j>>2]|0)+1|0,(c[k>>2]|0)+1|0,c[h>>2]|0);i=e;return 0}function Ko(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+64|0;g=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f+16|0;r=f+8|0;s=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=jv(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;if(!((c[m>>2]|0)!=0&(c[l>>2]|0)!=0)){i=f;return}do{c[o>>2]=c[c[l>>2]>>2];c[n>>2]=c[(c[m>>2]|0)+8>>2];while(1){if(!(c[n>>2]|0))break;c[p>>2]=c[c[n>>2]>>2];h[q>>3]=+h[c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]>>3];h[r>>3]=+h[(c[(c[(c[p>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];h[s>>3]=+h[q>>3]*+h[q>>3]+ +h[r>>3]*+h[r>>3];if(+h[s>>3]<+h[4173])Io(c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],+h[s>>3]);c[n>>2]=c[(c[n>>2]|0)+4>>2]}c[l>>2]=c[(c[l>>2]|0)+4>>2]}while((c[l>>2]|0)!=0);i=f;return}function Lo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+48|0;f=e+8|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;c[g>>2]=b;c[h>>2]=d;c[k>>2]=yA(c[g>>2]|0,129941)|0;if(a[138998]|0)Y2(c[24742]|0,129147,e)|0;if(!((c[k>>2]|0)!=0?(a[c[k>>2]>>0]|0)!=0:0))c[k>>2]=129156;d=H3(c[k>>2]|0,58)|0;c[l>>2]=d;do if(d){if((c[l>>2]|0)!=(c[k>>2]|0)?(p1(a[c[k>>2]>>0]|0)|0)==0:0){n=10;break}c[l>>2]=(c[l>>2]|0)+1;c[m>>2]=c[l>>2];b=u3(c[k>>2]|0)|0;c[j>>2]=b;c[j>>2]=(c[j>>2]|0)<0?0:b}else n=10;while(0);if((n|0)==10){c[j>>2]=0;c[m>>2]=c[k>>2]}if(a[138998]|0){k=c[24742]|0;n=c[m>>2]|0;c[f>>2]=c[j>>2];c[f+4>>2]=n;Y2(k,129164,f)|0}if((c[j>>2]|0)!=0?(Mo(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)==0:0){i=e;return}eq(c[g>>2]|0,c[m>>2]|0)|0;i=e;return}function Mo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+112|0;j=f+100|0;k=f+96|0;l=f+92|0;m=f+88|0;n=f+84|0;o=f+80|0;p=f+76|0;q=f+48|0;r=f+72|0;s=f+68|0;t=f+40|0;u=f;v=f+56|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[r>>2]=kB(c[k>>2]|0)|0;c[s>>2]=lB(c[k>>2]|0)|0;gq(v,c[k>>2]|0);c[12776]=c[v>>2];c[12777]=c[v+4>>2];c[12778]=c[v+8>>2];if(a[51112]|0){g[12776]=+g[12776]/72.0;g[12777]=+g[12777]/72.0}c[p>>2]=No(c[k>>2]|0)|0;if(!(c[p>>2]|0)){c[j>>2]=0;w=c[j>>2]|0;i=f;return w|0}c[o>>2]=0;v=u;e=c[l>>2]|0;l=v+40|0;do{c[v>>2]=c[e>>2];v=v+4|0;e=e+4|0}while((v|0)<(l|0));h[t>>3]=+h[u+16>>3];while(1){if(!(c[p>>2]|0))break;if((c[o>>2]|0)>=(c[m>>2]|0))break;Oo(c[k>>2]|0,c[r>>2]|0,u);h[4186]=+h[4183]*+h[4185];h[4187]=+(c[s>>2]|0)*+h[4186]*2.0/+(_(c[r>>2]|0,(c[r>>2]|0)-1|0)|0);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[8368]|0))break;h[q>>3]=+Po(c[n>>2]|0);if(+h[q>>3]<=0.0)break;c[p>>2]=Qo(c[k>>2]|0,+h[q>>3])|0;if(!(c[p>>2]|0))break;c[n>>2]=(c[n>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1;e=u+16|0;h[e>>3]=+h[e>>3]+ +h[t>>3]}c[j>>2]=c[p>>2];w=c[j>>2]|0;i=f;return w|0}function No(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[g>>2]=0;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;a=To(c[e>>2]|0,c[f>>2]|0)|0;c[g>>2]=(c[g>>2]|0)+a;c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return c[g>>2]|0}function Oo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[e+8>>2]=a;c[f>>2]=b;c[g>>2]=d;h[4182]=+h[(c[g>>2]|0)+16>>3];c[8360]=c[c[g>>2]>>2];h[4181]=+h[(c[g>>2]|0)+8>>3];c[8368]=c[(c[g>>2]|0)+32>>2];if(+h[(c[g>>2]|0)+24>>3]>0.0)h[4183]=+h[(c[g>>2]|0)+24>>3];h[4185]=+h[4182]*+h[4182];if(!(+h[4181]==0.0)){i=e;return}h[4181]=+h[4182]*+O(+(+(c[f>>2]|0)))/5.0;i=e;return}function Po(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return +(+h[4181]*+((c[8360]|0)-(c[d>>2]|0)|0)/+(c[8360]|0))}function Qo(a,b){a=a|0;b=+b;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+80|0;f=e+72|0;g=e+68|0;j=e+40|0;k=e+64|0;l=e+60|0;m=e+56|0;n=e+32|0;o=e+24|0;p=e+16|0;q=e;r=e+52|0;s=e+48|0;c[g>>2]=a;h[j>>3]=b;c[r>>2]=0;c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>3]=0.0;h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16>>3]=0.0;c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[l>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;c[s>>2]=Ro(c[k>>2]|0,c[l>>2]|0)|0;c[r>>2]=(c[r>>2]|0)+(c[s>>2]|0);c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}c[m>>2]=OA(c[g>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;a=c[m>>2]|0;So(c[k>>2]|0,c[((c[c[m>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0);c[m>>2]=QA(c[g>>2]|0,c[m>>2]|0)|0}c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}if(!(c[r>>2]|0)){c[f>>2]=0;t=c[f>>2]|0;i=e;return t|0}h[n>>3]=+h[j>>3]*+h[j>>3];c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;do if((d[(c[(c[k>>2]|0)+8>>2]|0)+119>>0]|0|0)!=3){h[q>>3]=+h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16>>3];h[q+8>>3]=+h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>3];h[p>>3]=+h[q>>3]*+h[q>>3]+ +h[q+8>>3]*+h[q+8>>3];if(+h[p>>3]<+h[n>>3]){m=c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0;h[m>>3]=+h[m>>3]+ +h[q>>3];m=(c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[m>>3]=+h[m>>3]+ +h[q+8>>3];break}else{h[o>>3]=+O(+(+h[p>>3]));m=c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0;h[m>>3]=+h[m>>3]+ +h[q>>3]*+h[j>>3]/+h[o>>3];m=(c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0)+8|0;h[m>>3]=+h[m>>3]+ +h[q+8>>3]*+h[j>>3]/+h[o>>3];break}}while(0);c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}c[f>>2]=c[r>>2];t=c[f>>2]|0;i=e;return t|0}function Ro(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+8|0;j=d;c[e>>2]=a;c[f>>2]=b;h[g>>3]=+h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]>>3];h[j>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];b=Vo(c[e>>2]|0,c[f>>2]|0,+h[g>>3],+h[j>>3],+h[g>>3]*+h[g>>3]+ +h[j>>3]*+h[j>>3])|0;i=d;return b|0}function So(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;d=i;i=i+64|0;e=d+52|0;f=d+48|0;g=d+40|0;j=d+32|0;k=d+24|0;l=d+16|0;m=d+8|0;n=d;c[e>>2]=a;c[f>>2]=b;if(To(c[e>>2]|0,c[f>>2]|0)|0){i=d;return}h[g>>3]=+h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]>>3];h[j>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];h[l>>3]=+O(+(+h[g>>3]*+h[g>>3]+ +h[j>>3]*+h[j>>3]));o=+Uo(c[e>>2]|0);h[n>>3]=o+ +Uo(c[f>>2]|0);h[m>>3]=+h[l>>3]-+h[n>>3];h[k>>3]=+h[m>>3]*+h[m>>3]/((+h[4182]+ +h[n>>3])*+h[l>>3]);l=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16|0;h[l>>3]=+h[l>>3]-+h[g>>3]*+h[k>>3];l=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16+8|0;h[l>>3]=+h[l>>3]-+h[j>>3]*+h[k>>3];l=(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0)+16|0;h[l>>3]=+h[l>>3]+ +h[g>>3]*+h[k>>3];g=(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0)+16+8|0;h[g>>3]=+h[g>>3]+ +h[j>>3]*+h[k>>3];i=d;return}function To(a,b){a=a|0;b=b|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0.0,u=0.0;e=i;i=i+32|0;f=e+24|0;j=e+20|0;k=e+8|0;l=e;m=e+16|0;c[f>>2]=a;c[j>>2]=b;h[k>>3]=+h[c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]>>3]-+h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3];if(+h[k>>3]<0.0)h[k>>3]=-+h[k>>3];h[l>>3]=+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]-+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];if(+h[l>>3]<0.0)h[l>>3]=-+h[l>>3];n=+h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3];if(d[51112]|0)o=n/2.0+ +g[12776];else o=n*+g[12776]/2.0;n=+h[(c[(c[j>>2]|0)+8>>2]|0)+32>>3];if(d[51112]|0)p=n/2.0+ +g[12776];else p=n*+g[12776]/2.0;if(!(+h[k>>3]<=o+p)){q=0;r=q&1;c[m>>2]=r;s=c[m>>2]|0;i=e;return s|0}p=+h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3];if(d[51112]|0)t=p/2.0+ +g[12777];else t=p*+g[12777]/2.0;p=+h[(c[(c[j>>2]|0)+8>>2]|0)+40>>3];if(d[51112]|0)u=p/2.0+ +g[12777];else u=p*+g[12777]/2.0;q=+h[l>>3]<=t+u;r=q&1;c[m>>2]=r;s=c[m>>2]|0;i=e;return s|0}function Uo(a){a=a|0;var b=0,e=0,f=0,j=0,k=0.0,l=0.0,m=0.0;b=i;i=i+32|0;e=b+16|0;f=b+8|0;j=b;c[e>>2]=a;k=+h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];if(d[51112]|0)l=k/2.0+ +g[12776];else l=k*+g[12776]/2.0;h[f>>3]=l;l=+h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3];if(d[51112]|0)m=l/2.0+ +g[12777];else m=l*+g[12777]/2.0;h[j>>3]=m;m=+O(+(+h[f>>3]*+h[f>>3]+ +h[j>>3]*+h[j>>3]));i=b;return +m}function Vo(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+48|0;j=g+40|0;k=g+36|0;l=g+24|0;m=g+16|0;n=g+8|0;o=g+32|0;p=g;c[j>>2]=a;c[k>>2]=b;h[l>>3]=d;h[m>>3]=e;h[n>>3]=f;while(1){if(!(+h[n>>3]==0.0))break;h[l>>3]=+(5-((t2()|0)%10|0)|0);h[m>>3]=+(5-((t2()|0)%10|0)|0);h[n>>3]=+h[l>>3]*+h[l>>3]+ +h[m>>3]*+h[m>>3]}b=To(c[j>>2]|0,c[k>>2]|0)|0;c[o>>2]=b;if(b)h[p>>3]=+h[4186]/+h[n>>3];else h[p>>3]=+h[4187]/+h[n>>3];n=(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16|0;h[n>>3]=+h[n>>3]+ +h[l>>3]*+h[p>>3];n=(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16+8|0;h[n>>3]=+h[n>>3]+ +h[m>>3]*+h[p>>3];n=(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16|0;h[n>>3]=+h[n>>3]-+h[l>>3]*+h[p>>3];l=(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8|0;h[l>>3]=+h[l>>3]-+h[m>>3]*+h[p>>3];i=g;return c[o>>2]|0}function Wo(a){a=a|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=a;QO(c[e>>2]|0,2);b[(c[(c[e>>2]|0)+8>>2]|0)+176>>1]=2;c[13799]=2;$o(c[e>>2]|0);i=d;return}function Xo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+64|0;e=d+56|0;f=d+52|0;g=d+48|0;h=d+44|0;j=d+40|0;k=d+36|0;l=d+32|0;m=d+28|0;n=d+24|0;o=d+20|0;p=d+16|0;q=d+12|0;r=d+8|0;s=d+4|0;t=d;c[f>>2]=a;c[g>>2]=b;c[e>>2]=c[13068];c[k>>2]=gB(129187,e,0)|0;MC(c[k>>2]|0,129195,280,1)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+140>>2]=c[k>>2];c[m>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;if(!(c[c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]>>2]|0)){e=c[k>>2]|0;b=wB(c[m>>2]|0)|0;c[l>>2]=ap(e,b,1,c[m>>2]|0)|0;c[c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]>>2]=c[l>>2]}c[m>>2]=aC(c[f>>2]|0,c[m>>2]|0)|0}c[m>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;c[p>>2]=OA(c[f>>2]|0,c[m>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;b=c[p>>2]|0;c[n>>2]=c[c[(c[(c[((c[c[p>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+112>>2]>>2];b=c[p>>2]|0;c[o>>2]=c[c[(c[(c[((c[c[p>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+112>>2]>>2];if((c[n>>2]|0)!=(c[o>>2]|0))MC(VA(c[k>>2]|0,c[n>>2]|0,c[o>>2]|0,0,1)|0,175319,176,1)|0;c[p>>2]=QA(c[f>>2]|0,c[p>>2]|0)|0}c[m>>2]=aC(c[f>>2]|0,c[m>>2]|0)|0}c[j>>2]=fG(c[k>>2]|0,h,0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[h>>2]|0))break;c[q>>2]=c[(c[j>>2]|0)+(c[r>>2]<<2)>>2];c[l>>2]=$B(c[q>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;c[t>>2]=c[c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]>>2];c[p>>2]=OA(c[f>>2]|0,c[t>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;m=c[p>>2]|0;c[o>>2]=c[c[(c[(c[((c[c[p>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)+8>>2]|0)+112>>2]>>2];if((c[l>>2]|0)!=(c[o>>2]|0)){c[s>>2]=VA(c[k>>2]|0,c[l>>2]|0,c[o>>2]|0,0,1)|0;MC(c[s>>2]|0,175319,176,1)|0;YA(c[q>>2]|0,c[s>>2]|0,1)|0}c[p>>2]=QA(c[f>>2]|0,c[p>>2]|0)|0}c[l>>2]=aC(c[q>>2]|0,c[l>>2]|0)|0}c[r>>2]=(c[r>>2]|0)+1}c[l>>2]=$B(c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;c[p>>2]=OA(c[k>>2]|0,c[l>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;r=bK(8)|0;c[(c[(c[p>>2]|0)+8>>2]|0)+120>>2]=r;c[p>>2]=QA(c[k>>2]|0,c[p>>2]|0)|0}c[l>>2]=aC(c[k>>2]|0,c[l>>2]|0)|0}c[c[g>>2]>>2]=c[h>>2];i=d;return c[j>>2]|0}function Yo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+64|0;d=b+52|0;e=b+48|0;f=b+44|0;g=b+40|0;h=b+36|0;j=b+32|0;k=b;c[d>>2]=a;if(!(kB(c[d>>2]|0)|0)){i=b;return}c[e>>2]=Xo(c[d>>2]|0,g)|0;a=c[c[e>>2]>>2]|0;a:do if((c[g>>2]|0)==1){Cw(a,c[d>>2]|0);bp(c[c[e>>2]>>2]|0);fq(c[d>>2]|0)|0}else{c[j>>2]=c[a+48>>2];GG(c[d>>2]|0,2,8,k)|0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[g>>2]|0))break;c[f>>2]=c[(c[e>>2]|0)+(c[h>>2]<<2)>>2];Cw(c[f>>2]|0,c[d>>2]|0);fq(c[f>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+1}FG(c[g>>2]|0,c[e>>2]|0,c[j>>2]|0,k)|0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[g>>2]|0))break a;bp(c[(c[e>>2]|0)+(c[h>>2]<<2)>>2]|0);c[h>>2]=(c[h>>2]|0)+1}}while(0);O4(c[e>>2]|0);i=b;return}function Zo(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(kB(c[d>>2]|0)|0)){i=b;return}Wo(c[d>>2]|0);Yo(c[d>>2]|0);O4(c[(c[($B(c[d>>2]|0)|0)+8>>2]|0)+112>>2]|0);gm(c[d>>2]|0);nL(c[d>>2]|0);i=b;return}function _o(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;if(!(c[e>>2]|0)){i=b;return}cp(c[(c[(c[d>>2]|0)+8>>2]|0)+140>>2]|0);while(1){g=c[d>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=OA(g,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;TO(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}UO(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}O4(c[(c[g+8>>2]|0)+152>>2]|0);g=c[d>>2]|0;if((g|0)==(rC(c[d>>2]|0)|0)){i=b;return}PC(c[d>>2]|0,0,175049);i=b;return}function $o(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[g>>2]=0;c[h>>2]=bK((kB(c[d>>2]|0)|0)<<2)|0;a=bK((kB(c[d>>2]|0)|0)+1<<2)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;ql(c[e>>2]|0);c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]=(c[h>>2]|0)+(c[g>>2]<<2);a=c[e>>2]|0;j=c[g>>2]|0;c[g>>2]=j+1;c[(c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0)+(j<<2)>>2]=a;c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;dp(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function ap(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=fC(c[g>>2]|0,c[j>>2]|0,1)|0;MC(c[m>>2]|0,175026,304,1)|0;j=bK(40)|0;c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]=j;if(c[k>>2]|0){k=bK(c[13799]<<3)|0;c[(c[(c[m>>2]|0)+8>>2]|0)+132>>2]=k;h[(c[(c[m>>2]|0)+8>>2]|0)+88>>3]=+h[(c[(c[l>>2]|0)+8>>2]|0)+88>>3];h[(c[(c[m>>2]|0)+8>>2]|0)+96>>3]=+h[(c[(c[l>>2]|0)+8>>2]|0)+96>>3];h[(c[(c[m>>2]|0)+8>>2]|0)+80>>3]=+h[(c[(c[l>>2]|0)+8>>2]|0)+80>>3];c[c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]>>2]=c[l>>2];n=c[m>>2]|0;i=f;return n|0}else{c[c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]>>2]=c[l>>2];n=c[m>>2]|0;i=f;return n|0}return 0}function bp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]>>2];h[c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]>>3];h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[(c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){g=c[d>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=OA(g,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;O4(c[(c[(c[f>>2]|0)+8>>2]|0)+120>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}O4(c[(c[(c[e>>2]|0)+8>>2]|0)+112>>2]|0);O4(c[(c[(c[e>>2]|0)+8>>2]|0)+132>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}jB(g)|0;i=b;return}function dp(a){a=a|0;var b=0,d=0,e=0.0;b=i;i=i+16|0;d=b;c[d>>2]=a;MC(c[d>>2]|0,175319,176,1)|0;yO(c[d>>2]|0)|0;e=+fO(c[d>>2]|0,c[13851]|0,1.0,0.0);h[(c[(c[d>>2]|0)+8>>2]|0)+128>>3]=e;i=b;return}function ep(b){b=b|0;var d=0,e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;d=i;i=i+144|0;e=d+40|0;f=d+140|0;j=d+136|0;k=d+16|0;l=d+132|0;m=d+128|0;n=d+124|0;o=d+120|0;p=d+116|0;q=d+104|0;r=d;s=d+100|0;t=d+88|0;u=d+56|0;c[f>>2]=b;c[l>>2]=-1;gp(c[f>>2]|0);c[j>>2]=(c[13799]|0)==2&1;if(!(kB(c[f>>2]|0)|0)){v=c[f>>2]|0;nL(v);i=d;return}c[s>>2]=pp()|0;hp(c[f>>2]|0,c[s>>2]|0);cq(c[f>>2]|0,k,0)|0;do if((c[k>>2]|0)==18&(c[j>>2]|0)!=0){c[j>>2]=0;c[(c[s>>2]|0)+124>>2]=c[k+8>>2];h[(c[s>>2]|0)+144>>3]=+h[k+16>>3];gq(t,c[f>>2]|0);c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];if(a[q+8>>0]|0){h[r>>3]=+g[q>>2]/72.0;h[r+8>>3]=+g[q+4>>2]/72.0;break}else{h[r>>3]=.05555555555555555;h[r+8>>3]=.05555555555555555;break}}else c[(c[s>>2]|0)+124>>2]=-1;while(0);c[m>>2]=fG(c[f>>2]|0,o,0)|0;q=c[f>>2]|0;if((c[o>>2]|0)==1){t=c[s>>2]|0;b=c[l>>2]|0;c[e>>2]=c[r>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];c[e+12>>2]=c[r+12>>2];ip(q,t,b,e);if(c[j>>2]|0)dq(c[f>>2]|0,k)|0;gm(c[f>>2]|0)}else{GG(q,2,8,u)|0;c[u+12>>2]=1;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[o>>2]|0))break;c[n>>2]=c[(c[m>>2]|0)+(c[p>>2]<<2)>>2];iG(c[n>>2]|0)|0;q=c[n>>2]|0;b=c[s>>2]|0;t=c[l>>2]|0;c[e>>2]=c[r>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];c[e+12>>2]=c[r+12>>2];ip(q,b,t,e);if(c[j>>2]|0)dq(c[n>>2]|0,k)|0;QO(c[n>>2]|0,2);gm(c[n>>2]|0);c[p>>2]=(c[p>>2]|0)+1}FG(c[o>>2]|0,c[m>>2]|0,c[f>>2]|0,u)|0}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[o>>2]|0))break;pC(c[f>>2]|0,c[(c[m>>2]|0)+(c[p>>2]<<2)>>2]|0)|0;c[p>>2]=(c[p>>2]|0)+1}O4(c[m>>2]|0);qp(c[s>>2]|0);v=c[f>>2]|0;nL(v);i=d;return}function fp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){g=c[d>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=OA(g,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;TO(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}UO(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}jp(g);i=b;return}function gp(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;f=d+4|0;g=d;c[f>>2]=a;QO(c[f>>2]|0,2);a=c[f>>2]|0;c[g>>2]=eO(a,qA(c[f>>2]|0,0,129471,0)|0,2,2)|0;a=c[f>>2]|0;h=qA(c[f>>2]|0,0,129477,0)|0;j=(eO(a,h,c[g>>2]|0,2)|0)&65535;b[(c[(rC(c[f>>2]|0)|0)+8>>2]|0)+176>>1]=j;if((e[(c[(rC(c[f>>2]|0)|0)+8>>2]|0)+176>>1]|0|0)<10)k=e[(c[(rC(c[f>>2]|0)|0)+8>>2]|0)+176>>1]|0;else k=10;j=k&65535;b[(c[(rC(c[f>>2]|0)|0)+8>>2]|0)+176>>1]=j;c[13799]=j&65535;j=((c[g>>2]|0)<(c[13799]|0)?c[g>>2]|0:c[13799]|0)&65535;b[(c[(rC(c[f>>2]|0)|0)+8>>2]|0)+178>>1]=j;np(c[f>>2]|0);i=d;return}function hp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;d=i;i=i+32|0;e=d+8|0;f=d+24|0;g=d+20|0;j=d+16|0;k=d+12|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[g>>2]|0)+108>>2];c[k>>2]=ul(c[f>>2]|0,2,j)|0;if((c[k>>2]|0)!=2)$z(0,129272,d)|0;c[(c[g>>2]|0)+108>>2]=c[j>>2];j=c[f>>2]|0;l=+fO(j,qA(c[f>>2]|0,0,129305,0)|0,-1.0,0.0);h[(c[g>>2]|0)+24>>3]=l;j=c[f>>2]|0;l=+fO(j,qA(c[f>>2]|0,0,129307,0)|0,1.0001234,0.0)*-1.0;h[c[g>>2]>>3]=l;j=c[f>>2]|0;k=eO(j,qA(c[f>>2]|0,0,129322,0)|0,2147483647,0)|0;c[(c[g>>2]|0)+40>>2]=k;k=c[f>>2]|0;j=lp(k,qA(c[f>>2]|0,0,129329,0)|0,0)|0;c[(c[g>>2]|0)+120>>2]=j;j=c[f>>2]|0;k=mp(j,qA(c[f>>2]|0,0,129339,0)|0,1)|0;c[(c[g>>2]|0)+132>>2]=k;c[(c[g>>2]|0)+136>>2]=0;k=(uO(yA(c[f>>2]|0,129348)|0,0)|0)&255;c[(c[g>>2]|0)+112>>2]=k;k=(uO(yA(c[f>>2]|0,129357)|0,1)|0)&255;c[(c[g>>2]|0)+128>>2]=k;k=c[f>>2]|0;l=+fO(k,qA(c[f>>2]|0,0,129372,0)|0,0.0,-1797693134862315708145274.0e284);h[(c[g>>2]|0)+152>>3]=l;k=c[f>>2]|0;j=eO(k,qA(c[f>>2]|0,0,129381,0)|0,0,0)|0;c[(c[g>>2]|0)+160>>2]=j;if((c[(c[g>>2]|0)+160>>2]|0)<=4){i=d;return}c[e>>2]=c[(c[g>>2]|0)+160>>2];$z(0,129394,e)|0;c[(c[g>>2]|0)+160>>2]=0;i=d;return}function ip(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;i=i+112|0;j=g+24|0;k=g+8|0;l=g+100|0;m=g+96|0;n=g+92|0;o=g+88|0;p=g+84|0;q=g+80|0;r=g+76|0;s=g+72|0;t=g+68|0;u=g+64|0;v=g+60|0;w=g+56|0;x=g+52|0;y=g;z=g+48|0;A=g+44|0;B=g+40|0;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;e=c[l>>2]|0;d=c[13799]|0;if((c[(c[m>>2]|0)+136>>2]|0)==1)c[w>>2]=aq(e,d,v)|0;else c[w>>2]=aq(e,d,0)|0;do if((c[(c[m>>2]|0)+124>>2]|0)>=0){d=c[l>>2]|0;if((c[(c[m>>2]|0)+160>>2]|0)>0){c[j>>2]=c[f>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[o>>2]=$p(d,j,t,u)|0;break}else{c[j>>2]=c[f>>2];c[j+4>>2]=c[f+4>>2];c[j+8>>2]=c[f+8>>2];c[j+12>>2]=c[f+12>>2];c[o>>2]=$p(d,j,0,0)|0;break}}else c[o>>2]=0;while(0);c[p>>2]=kp(c[l>>2]|0,c[m>>2]|0)|0;switch(c[(c[m>>2]|0)+136>>2]|0){case 1:case 0:{Ip(c[13799]|0,c[w>>2]|0,c[v>>2]|0,c[m>>2]|0,0,c[o>>2]|0,c[p>>2]|0,c[t>>2]|0,c[u>>2]|0,r);break}case 5:{_p(c[13799]|0,c[w>>2]|0,c[p>>2]|0,r);break}case 4:{c[x>>2]=200;h[y>>3]=.001;c[z>>2]=1;if(c[v>>2]|0){c[v>>2]=Rv(c[v>>2]|0,0)|0;c[z>>2]=1}else{c[v>>2]=bw(c[w>>2]|0)|0;c[z>>2]=0}if((c[n>>2]|0)>0){c[A>>2]=fw(c[n>>2]|0,c[v>>2]|0,c[z>>2]|0)|0;if(a[138998]|0){z=c[24742]|0;t=(c[(c[A>>2]|0)+8>>2]|0)/2|0;m=(c[(c[v>>2]|0)+8>>2]|0)/2|0;c[k>>2]=c[n>>2];c[k+4>>2]=t;c[k+8>>2]=m;Y2(z,129200,k)|0}Lv(c[v>>2]|0);c[v>>2]=c[A>>2]}Vp(c[13799]|0,c[w>>2]|0,c[v>>2]|0,p,1,c[x>>2]|0,+h[y>>3],r);break}default:{}}c[q>>2]=$B(c[l>>2]|0)|0;while(1){if(!(c[q>>2]|0))break;c[B>>2]=(c[p>>2]|0)+((_(c[13799]|0,c[(c[(c[q>>2]|0)+8>>2]|0)+120>>2]|0)|0)<<3);c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[13799]|0))break;h[(c[(c[(c[q>>2]|0)+8>>2]|0)+132>>2]|0)+(c[s>>2]<<3)>>3]=+h[(c[B>>2]|0)+(c[s>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}c[q>>2]=aC(c[l>>2]|0,c[q>>2]|0)|0}O4(c[o>>2]|0);O4(c[p>>2]|0);Lv(c[w>>2]|0);if(c[v>>2]|0)Lv(c[v>>2]|0);if(!(c[u>>2]|0)){i=g;return}O4(c[u>>2]|0);i=g;return}function jp(a){a=a|0;var b=0;b=i;i=i+16|0;c[b>>2]=a;i=b;return}function kp(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[e+16>>2]=b;b=c[13799]|0;c[k>>2]=bK((_(b,kB(c[g>>2]|0)|0)|0)<<3)|0;if(!(qA(c[g>>2]|0,1,140246,0)|0)){c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}c[j>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;c[m>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+120>>2];a:do if((d[(c[(c[j>>2]|0)+8>>2]|0)+119>>0]|0|0)>0){c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[13799]|0))break a;b=_(c[m>>2]|0,c[13799]|0)|0;h[(c[k>>2]|0)+(b+(c[l>>2]|0)<<3)>>3]=+h[(c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]|0)+(c[l>>2]<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}}while(0);c[j>>2]=aC(c[g>>2]|0,c[j>>2]|0)|0}c[f>>2]=c[k>>2];n=c[f>>2]|0;i=e;return n|0}function lp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[j>>2]|0)){c[g>>2]=c[k>>2];o=c[g>>2]|0;i=f;return o|0}c[l>>2]=zA(c[h>>2]|0,c[j>>2]|0)|0;j=(p1(a[c[l>>2]>>0]|0)|0)!=0;h=c[l>>2]|0;do if(j){e=u3(h)|0;c[m>>2]=e;if((e|0)<=4){c[n>>2]=c[m>>2];break}else{c[n>>2]=c[k>>2];break}}else{if(!(m1(a[h>>0]|0)|0)){c[n>>2]=c[k>>2];break}if(!(F3(c[l>>2]|0,129433)|0)){c[n>>2]=2;break}if(!(F3(c[l>>2]|0,129442)|0)){c[n>>2]=1;break}if(!(F3(c[l>>2]|0,173312)|0)){c[n>>2]=0;break}if(!(F3(c[l>>2]|0,129453)|0)){c[n>>2]=3;break}if(F3(c[l>>2]|0,129464)|0){c[n>>2]=c[k>>2];break}else{c[n>>2]=4;break}}while(0);c[g>>2]=c[n>>2];o=c[g>>2]|0;i=f;return o|0}function mp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[j>>2]|0)){c[g>>2]=c[k>>2];o=c[g>>2]|0;i=f;return o|0}c[l>>2]=zA(c[h>>2]|0,c[j>>2]|0)|0;j=(p1(a[c[l>>2]>>0]|0)|0)!=0;h=c[l>>2]|0;do if(j){e=u3(h)|0;c[m>>2]=e;if((e|0)<=2&(c[m>>2]|0)>=0){c[n>>2]=c[m>>2];break}else{c[n>>2]=c[k>>2];break}}else{if(!(m1(a[h>>0]|0)|0)){c[n>>2]=c[k>>2];break}if((F3(c[l>>2]|0,173312)|0)!=0?(F3(c[l>>2]|0,174911)|0)!=0:0){if(((F3(c[l>>2]|0,137409)|0)!=0?(F3(c[l>>2]|0,145584)|0)!=0:0)?(F3(c[l>>2]|0,145589)|0)!=0:0)if(F3(c[l>>2]|0,129428)|0){c[n>>2]=c[k>>2];break}else{c[n>>2]=2;break}c[n>>2]=1;break}c[n>>2]=0}while(0);c[g>>2]=c[n>>2];o=c[g>>2]|0;i=f;return o|0}function np(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;ql(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;op(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function op(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;MC(c[d>>2]|0,175319,176,1)|0;yO(c[d>>2]|0)|0;i=b;return}function pp(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=cK(168)|0;h[c[b>>2]>>3]=-1.0001234;h[(c[b>>2]|0)+8>>3]=1.0;c[(c[b>>2]|0)+16>>2]=1;h[(c[b>>2]|0)+24>>3]=-1.0;h[(c[b>>2]|0)+32>>3]=.2;c[(c[b>>2]|0)+40>>2]=0;c[(c[b>>2]|0)+44>>2]=4;c[(c[b>>2]|0)+48>>2]=1;c[(c[b>>2]|0)+52>>2]=45;c[(c[b>>2]|0)+56>>2]=10;h[(c[b>>2]|0)+64>>3]=.6;h[(c[b>>2]|0)+72>>3]=.001;c[(c[b>>2]|0)+80>>2]=500;h[(c[b>>2]|0)+88>>3]=.9;h[(c[b>>2]|0)+96>>3]=.1;c[(c[b>>2]|0)+104>>2]=1;c[(c[b>>2]|0)+108>>2]=123;c[(c[b>>2]|0)+112>>2]=0;c[(c[b>>2]|0)+116>>2]=0;c[(c[b>>2]|0)+120>>2]=0;c[(c[b>>2]|0)+124>>2]=0;c[(c[b>>2]|0)+128>>2]=1;c[(c[b>>2]|0)+132>>2]=3;c[(c[b>>2]|0)+136>>2]=0;h[(c[b>>2]|0)+144>>3]=-4.0;h[(c[b>>2]|0)+152>>3]=0.0;c[(c[b>>2]|0)+160>>2]=0;i=a;return c[b>>2]|0}function qp(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[d>>2]|0);i=b;return}function rp(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[d>>2]|0);i=b;return}function sp(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=cK(184)|0;c[c[e>>2]>>2]=c[d>>2];c[(c[e>>2]|0)+176>>2]=0;i=b;return c[e>>2]|0}function tp(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d+12|0;f=d;g=d+8|0;c[e>>2]=a;h[f>>3]=b;c[g>>2]=c[c[e>>2]>>2];h[(c[e>>2]|0)+8+(c[g>>2]<<3)>>3]=+h[f>>3];f=c[e>>2]|0;if(!(c[(c[e>>2]|0)+176>>2]|0)){a=(c[e>>2]|0)+176|0;if((c[f>>2]|0)==20){c[a>>2]=-1;c[c[e>>2]>>2]=(c[c[e>>2]>>2]|0)-1;i=d;return}c[a>>2]=1;if(20<((c[c[e>>2]>>2]|0)+1|0))j=20;else j=(c[c[e>>2]>>2]|0)+1|0;c[c[e>>2]>>2]=j;i=d;return}b=+h[(c[e>>2]|0)+8+(c[g>>2]<<3)>>3];j=c[g>>2]|0;if((c[f+176>>2]|0)==1){if(b<+h[(c[e>>2]|0)+8+(j-1<<3)>>3]?(c[c[e>>2]>>2]|0)<20:0){if(20<((c[c[e>>2]>>2]|0)+1|0))k=20;else k=(c[c[e>>2]>>2]|0)+1|0;c[c[e>>2]>>2]=k;i=d;return}k=c[e>>2]|0;c[k>>2]=(c[k>>2]|0)+-1;c[(c[e>>2]|0)+176>>2]=-1;i=d;return}else{if(b<+h[(c[e>>2]|0)+8+(j+1<<3)>>3]?(c[c[e>>2]>>2]|0)>0:0){if(0>((c[c[e>>2]>>2]|0)-1|0))l=0;else l=(c[c[e>>2]>>2]|0)-1|0;c[c[e>>2]>>2]=l;i=d;return}l=c[e>>2]|0;c[l>>2]=(c[l>>2]|0)+1;c[(c[e>>2]|0)+176>>2]=1;i=d;return}}function up(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[c[d>>2]>>2]|0}function vp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0;e=i;i=i+64|0;f=e+16|0;g=e+52|0;j=e+48|0;k=e+44|0;l=e+8|0;m=e;n=e+40|0;o=e+36|0;p=e+32|0;q=e+28|0;r=e+24|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=0.0;c[n>>2]=c[(c[g>>2]|0)+20>>2];c[o>>2]=c[(c[g>>2]|0)+24>>2];if(!(c[(c[n>>2]|0)+(c[c[g>>2]>>2]<<2)>>2]|0)){h[f>>3]=1.0;s=+h[f>>3];i=e;return +s}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[c[g>>2]>>2]|0))break;c[q>>2]=c[(c[n>>2]|0)+(c[p>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[n>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;h[m>>3]=0.0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[j>>2]|0))break;d=_(c[j>>2]|0,c[p>>2]|0)|0;b=_(c[j>>2]|0,c[(c[o>>2]|0)+(c[q>>2]<<2)>>2]|0)|0;a=_(c[j>>2]|0,c[p>>2]|0)|0;t=_(c[j>>2]|0,c[(c[o>>2]|0)+(c[q>>2]<<2)>>2]|0)|0;h[m>>3]=+h[m>>3]+(+h[(c[k>>2]|0)+(d+(c[r>>2]|0)<<3)>>3]-+h[(c[k>>2]|0)+(b<<3)>>3])*(+h[(c[k>>2]|0)+(a+(c[r>>2]|0)<<3)>>3]-+h[(c[k>>2]|0)+(t<<3)>>3]);c[r>>2]=(c[r>>2]|0)+1}u=+O(+(+h[m>>3]));h[l>>3]=+h[l>>3]+u;c[q>>2]=(c[q>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}h[f>>3]=+h[l>>3]/+(c[(c[n>>2]|0)+(c[c[g>>2]>>2]<<2)>>2]|0);s=+h[f>>3];i=e;return +s}function wp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)<(c[c[h>>2]>>2]|0)){i=e;return}c[c[h>>2]>>2]=(c[g>>2]|0)+(0>10?0:10);g=eK(c[c[f>>2]>>2]|0,c[c[h>>2]>>2]<<3)|0;c[c[f>>2]>>2]=g;i=e;return}function xp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[g>>2]|0)<(c[c[h>>2]>>2]|0)){i=e;return}c[c[h>>2]>>2]=(c[g>>2]|0)+(0>10?0:10);g=eK(c[c[f>>2]>>2]|0,c[c[h>>2]>>2]<<2)|0;c[c[f>>2]>>2]=g;i=e;return}function yp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0;f=i;i=i+64|0;g=f+32|0;j=f+56|0;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;o=f+16|0;p=f+8|0;q=f;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;h[q>>3]=1.0e-05;c[n>>2]=0;while(1){if((c[n>>2]|0)>=2)break;e=_(c[m>>2]|0,c[k>>2]|0)|0;d=_(c[l>>2]|0,c[k>>2]|0)|0;h[o+(c[n>>2]<<3)>>3]=+h[(c[j>>2]|0)+(e+(c[n>>2]|0)<<3)>>3]-+h[(c[j>>2]|0)+(d+(c[n>>2]|0)<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}r=+h[o>>3];s=+h[o+8>>3];t=+h[o+8>>3];if((+h[o>>3]>=0.0?r:-r)<=(+h[o+8>>3]>=0.0?s:-s)*+h[q>>3])if(t>0.0){h[g>>3]=1.5707963267948966;u=+h[g>>3];i=f;return +u}else{h[g>>3]=4.71238898038469;u=+h[g>>3];i=f;return +u}h[p>>3]=+V(+(t/+h[o>>3]));if(+h[o>>3]>0.0){if(+h[o+8>>3]<0.0)h[p>>3]=+h[p>>3]+6.283185307179586}else if(+h[o>>3]<0.0)h[p>>3]=+h[p>>3]+3.141592653589793;h[g>>3]=+h[p>>3];u=+h[g>>3];i=f;return +u}function zp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[f>>2];c[k>>2]=c[g>>2];do if(!(+h[c[j>>2]>>3]>+h[c[k>>2]>>3]))if(+h[c[j>>2]>>3]<+h[c[k>>2]>>3]){c[e>>2]=-1;break}else{c[e>>2]=0;break}else c[e>>2]=1;while(0);i=d;return c[e>>2]|0}function Ap(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0.0,Z=0.0,$=0.0;k=i;i=i+272|0;l=k+136|0;m=k+260|0;n=k+256|0;o=k+252|0;p=k+248|0;q=k+244|0;r=k+240|0;s=k+236|0;t=k+232|0;u=k+228|0;v=k+224|0;w=k+220|0;x=k+216|0;y=k+128|0;z=k+120|0;A=k+112|0;B=k+104|0;C=k+96|0;D=k+88|0;E=k+80|0;F=k+72|0;G=k+64|0;H=k+212|0;I=k+208|0;J=k+204|0;K=k+200|0;L=k+56|0;M=k+48|0;N=k+40|0;Q=k+32|0;R=k+196|0;S=k+192|0;T=k+188|0;U=k;V=k+184|0;W=k+180|0;X=k+176|0;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;c[s>>2]=c[n>>2];h[y>>3]=+h[c[o>>2]>>3];h[z>>3]=+h[(c[o>>2]|0)+24>>3];h[A>>3]=+h[(c[o>>2]|0)+32>>3];h[C>>3]=+h[(c[o>>2]|0)+72>>3];h[D>>3]=+(c[(c[o>>2]|0)+80>>2]|0);h[E>>3]=+h[(c[o>>2]|0)+88>>3];h[F>>3]=+h[(c[o>>2]|0)+96>>3];c[H>>2]=0;c[I>>2]=0;c[J>>2]=0;c[K>>2]=0;h[N>>3]=0.0;c[R>>2]=0;c[S>>2]=c[(c[o>>2]|0)+104>>2];c[T>>2]=0;c[V>>2]=0;c[W>>2]=c[(c[o>>2]|0)+56>>2];c[X>>2]=0;if((c[s>>2]|0)==0|+h[D>>3]<=0.0){i=k;return}c[t>>2]=c[c[s>>2]>>2];c[u>>2]=c[(c[s>>2]|0)+4>>2];if((c[u>>2]|0)<=0|(c[m>>2]|0)<=0){i=k;return}c[X>>2]=sp(c[W>>2]|0)|0;c[c[r>>2]>>2]=0;if((c[t>>2]|0)==(c[u>>2]|0)){c[s>>2]=Mv(c[s>>2]|0,1)|0;c[H>>2]=c[(c[s>>2]|0)+20>>2];c[I>>2]=c[(c[s>>2]|0)+24>>2];a:do if(c[(c[o>>2]|0)+16>>2]|0){s2(c[(c[o>>2]|0)+108>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(_(c[m>>2]|0,c[u>>2]|0)|0))break a;Y=+rw();h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]=Y;c[v>>2]=(c[v>>2]|0)+1}}while(0);if(+h[z>>3]<0.0){Y=+vp(c[s>>2]|0,c[m>>2]|0,c[q>>2]|0);h[z>>3]=Y;h[(c[o>>2]|0)+24>>3]=Y}if(+h[A>>3]<0.0){h[A>>3]=.2;h[(c[o>>2]|0)+32>>3]=.2}if(+h[y>>3]>=0.0){h[y>>3]=-1.0;h[c[o>>2]>>3]=-1.0}h[G>>3]=+P(+(+h[z>>3]),+(1.0-+h[y>>3]));Y=+P(+(+h[A>>3]),+((2.0-+h[y>>3])/3.0));h[B>>3]=Y/+h[z>>3];c[J>>2]=cK(_(c[m>>2]<<3,c[u>>2]|0)|0)|0;c[V>>2]=cK(_(c[m>>2]<<3,c[u>>2]|0)|0)|0;do{c[R>>2]=(c[R>>2]|0)+1;A=c[J>>2]|0;Z4(A|0,c[q>>2]|0,_(c[m>>2]<<3,c[u>>2]|0)|0)|0;c[J>>2]=A;h[Q>>3]=+h[N>>3];h[N>>3]=0.0;c[W>>2]=up(c[X>>2]|0)|0;A=c[m>>2]|0;t=c[u>>2]|0;j=c[W>>2]|0;g=c[q>>2]|0;if(c[(c[o>>2]|0)+116>>2]|0)c[T>>2]=yv(A,t,j,g,c[p>>2]|0)|0;else c[T>>2]=yv(A,t,j,g,0)|0;xv(c[T>>2]|0,c[V>>2]|0,c[q>>2]|0,+h[(c[o>>2]|0)+64>>3],+h[y>>3],+h[G>>3],U,c[r>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[u>>2]|0))break;g=_(c[v>>2]|0,c[m>>2]|0)|0;c[K>>2]=(c[V>>2]|0)+(g<<3);c[w>>2]=c[(c[H>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[w>>2]|0)>=(c[(c[H>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;b:do if((c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0)!=(c[v>>2]|0)){h[L>>3]=+zw(c[q>>2]|0,c[m>>2]|0,c[v>>2]|0,c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break b;g=_(c[v>>2]|0,c[m>>2]|0)|0;j=_(c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0,c[m>>2]|0)|0;t=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[t>>3]=+h[t>>3]-+h[B>>3]*(+h[(c[q>>2]|0)+(g+(c[x>>2]|0)<<3)>>3]-+h[(c[q>>2]|0)+(j+(c[x>>2]|0)<<3)>>3])*+h[L>>3];c[x>>2]=(c[x>>2]|0)+1}}while(0);c[w>>2]=(c[w>>2]|0)+1}c[v>>2]=(c[v>>2]|0)+1}c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[u>>2]|0))break;j=_(c[v>>2]|0,c[m>>2]|0)|0;c[K>>2]=(c[V>>2]|0)+(j<<3);h[M>>3]=0.0;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break;h[M>>3]=+h[M>>3]+ +h[(c[K>>2]|0)+(c[x>>2]<<3)>>3]*+h[(c[K>>2]|0)+(c[x>>2]<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}h[M>>3]=+O(+(+h[M>>3]));h[N>>3]=+h[N>>3]+ +h[M>>3];c:do if(+h[M>>3]>0.0){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break c;j=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[j>>3]=+h[j>>3]/+h[M>>3];c[x>>2]=(c[x>>2]|0)+1}}while(0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break;j=_(c[v>>2]|0,c[m>>2]|0)|0;g=(c[q>>2]|0)+(j+(c[x>>2]|0)<<3)|0;h[g>>3]=+h[g>>3]+ +h[F>>3]*+h[(c[K>>2]|0)+(c[x>>2]<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}c[v>>2]=(c[v>>2]|0)+1}if(!(c[T>>2]|0)){if(a[138998]|0){g=c[24742]|0;Y=+h[F>>3];Z=+h[N>>3];j=c[(c[s>>2]|0)+8>>2]|0;$=+h[z>>3];c[l>>2]=c[R>>2];h[l+8>>3]=Y;h[l+16>>3]=Z;c[l+24>>2]=j;h[l+32>>3]=$;Y2(g,129481,l)|0}}else{Bv(c[T>>2]|0);tp(c[X>>2]|0,+h[U>>3]+ +h[U+8>>3]*.85+ +h[U+16>>3]*3.3)}h[F>>3]=+Jp(c[S>>2]|0,+h[F>>3],+h[N>>3],+h[Q>>3],+h[E>>3]);if(!(+h[F>>3]>+h[C>>3]))break}while(+(c[R>>2]|0)<+h[D>>3]);if(c[(c[o>>2]|0)+112>>2]|0)Kp(c[m>>2]|0,c[s>>2]|0,c[q>>2]|0)}else c[c[r>>2]>>2]=-100;rp(c[X>>2]|0);c[(c[o>>2]|0)+56>>2]=c[W>>2];if(c[J>>2]|0)O4(c[J>>2]|0);if((c[s>>2]|0)!=(c[n>>2]|0))Lv(c[s>>2]|0);if(!(c[V>>2]|0)){i=k;return}O4(c[V>>2]|0);i=k;return}function Bp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,fa=0.0,ga=0.0;j=i;i=i+256|0;k=j+240|0;l=j+236|0;m=j+232|0;n=j+228|0;o=j+224|0;p=j+220|0;q=j+216|0;r=j+212|0;s=j+208|0;t=j+204|0;u=j+200|0;v=j+196|0;w=j+120|0;x=j+112|0;y=j+104|0;z=j+96|0;A=j+88|0;B=j+80|0;C=j+72|0;D=j+64|0;E=j+56|0;F=j+192|0;G=j+188|0;H=j+184|0;I=j+180|0;J=j+48|0;K=j+40|0;L=j+32|0;M=j+24|0;N=j+176|0;Q=j+172|0;R=j+168|0;S=j+164|0;T=j+160|0;U=j+156|0;V=j+152|0;W=j+148|0;X=j+144|0;Y=j+16|0;Z=j+8|0;$=j;aa=j+140|0;ba=j+136|0;ca=j+132|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=c[l>>2];h[w>>3]=+h[c[m>>2]>>3];h[x>>3]=+h[(c[m>>2]|0)+24>>3];h[y>>3]=+h[(c[m>>2]|0)+32>>3];h[A>>3]=+h[(c[m>>2]|0)+72>>3];h[B>>3]=+(c[(c[m>>2]|0)+80>>2]|0);h[C>>3]=+h[(c[m>>2]|0)+88>>3];h[D>>3]=+h[(c[m>>2]|0)+96>>3];c[F>>2]=0;c[G>>2]=0;c[H>>2]=0;c[I>>2]=0;h[L>>3]=0.0;c[N>>2]=0;c[Q>>2]=c[(c[m>>2]|0)+104>>2];c[R>>2]=0;c[S>>2]=0;c[T>>2]=0;c[U>>2]=10;c[V>>2]=0;c[W>>2]=0;c[X>>2]=0;h[Z>>3]=0.0;h[$>>3]=0.0;c[ba>>2]=c[(c[m>>2]|0)+56>>2];c[ca>>2]=0;Y2(c[24742]|0,129580,j+128|0)|0;if((c[q>>2]|0)==0|+h[B>>3]<=0.0){i=j;return}c[r>>2]=c[c[q>>2]>>2];c[s>>2]=c[(c[q>>2]|0)+4>>2];if((c[s>>2]|0)<=0|(c[k>>2]|0)<=0){i=j;return}c[aa>>2]=cK(_(c[s>>2]<<3,c[k>>2]|0)|0)|0;if((c[s>>2]|0)>=(c[(c[m>>2]|0)+52>>2]|0)){c[S>>2]=1;c[ca>>2]=sp(c[ba>>2]|0)|0;c[V>>2]=cK(_(c[U>>2]<<3,c[k>>2]|0)|0)|0;c[W>>2]=cK(c[U>>2]<<3)|0;c[X>>2]=cK(c[U>>2]<<3)|0}c[S>>2]=0;c[c[p>>2]>>2]=0;a:do if((c[r>>2]|0)==(c[s>>2]|0)){c[q>>2]=Mv(c[q>>2]|0,1)|0;c[F>>2]=c[(c[q>>2]|0)+20>>2];c[G>>2]=c[(c[q>>2]|0)+24>>2];b:do if(c[(c[m>>2]|0)+16>>2]|0){s2(c[(c[m>>2]|0)+108>>2]|0);c[t>>2]=0;while(1){if((c[t>>2]|0)>=(_(c[k>>2]|0,c[s>>2]|0)|0))break b;da=+rw();h[(c[o>>2]|0)+(c[t>>2]<<3)>>3]=da;c[t>>2]=(c[t>>2]|0)+1}}while(0);if(+h[x>>3]<0.0){da=+vp(c[q>>2]|0,c[k>>2]|0,c[o>>2]|0);h[x>>3]=da;h[(c[m>>2]|0)+24>>3]=da}if(+h[y>>3]<0.0){h[y>>3]=.2;h[(c[m>>2]|0)+32>>3]=.2}if(+h[w>>3]>=0.0){h[w>>3]=-1.0;h[c[m>>2]>>3]=-1.0}h[E>>3]=+P(+(+h[x>>3]),+(1.0-+h[w>>3]));da=+P(+(+h[y>>3]),+((2.0-+h[w>>3])/3.0));h[z>>3]=da/+h[x>>3];c[I>>2]=cK(c[k>>2]<<3)|0;c[H>>2]=cK(_(c[k>>2]<<3,c[s>>2]|0)|0)|0;do{c[t>>2]=0;while(1){if((c[t>>2]|0)>=(_(c[k>>2]|0,c[s>>2]|0)|0))break;h[(c[aa>>2]|0)+(c[t>>2]<<3)>>3]=0.0;c[t>>2]=(c[t>>2]|0)+1}c[N>>2]=(c[N>>2]|0)+1;g=c[H>>2]|0;Z4(g|0,c[o>>2]|0,_(c[k>>2]<<3,c[s>>2]|0)|0)|0;c[H>>2]=g;h[M>>3]=+h[L>>3];h[L>>3]=0.0;h[Y>>3]=0.0;do if(c[S>>2]|0){c[ba>>2]=up(c[ca>>2]|0)|0;g=c[k>>2]|0;f=c[s>>2]|0;e=c[ba>>2]|0;d=c[o>>2]|0;if(c[(c[m>>2]|0)+116>>2]|0){c[R>>2]=yv(g,f,e,d,c[n>>2]|0)|0;break}else{c[R>>2]=yv(g,f,e,d,0)|0;break}}while(0);c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[s>>2]|0))break;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;h[(c[I>>2]|0)+(c[v>>2]<<3)>>3]=0.0;c[v>>2]=(c[v>>2]|0)+1}c:do if(!(c[S>>2]|0)){d=(c[n>>2]|0)!=0?(c[(c[m>>2]|0)+116>>2]|0)!=0:0;c[u>>2]=0;if(d)while(1){if((c[u>>2]|0)>=(c[s>>2]|0))break c;d:do if((c[u>>2]|0)!=(c[t>>2]|0)){h[J>>3]=+yw(c[o>>2]|0,c[k>>2]|0,c[t>>2]|0,c[u>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break d;d=_(c[t>>2]|0,c[k>>2]|0)|0;e=_(c[u>>2]|0,c[k>>2]|0)|0;da=+h[(c[n>>2]|0)+(c[u>>2]<<3)>>3]*+h[E>>3]*(+h[(c[o>>2]|0)+(d+(c[v>>2]|0)<<3)>>3]-+h[(c[o>>2]|0)+(e+(c[v>>2]|0)<<3)>>3]);ea=+h[J>>3];if(+h[w>>3]==-1.0){e=(c[I>>2]|0)+(c[v>>2]<<3)|0;h[e>>3]=+h[e>>3]+da/(ea*+h[J>>3])}else{fa=da/+P(+ea,+(1.0-+h[w>>3]));e=(c[I>>2]|0)+(c[v>>2]<<3)|0;h[e>>3]=+h[e>>3]+fa}c[v>>2]=(c[v>>2]|0)+1}}while(0);c[u>>2]=(c[u>>2]|0)+1}else while(1){if((c[u>>2]|0)>=(c[s>>2]|0))break c;e:do if((c[u>>2]|0)!=(c[t>>2]|0)){h[J>>3]=+yw(c[o>>2]|0,c[k>>2]|0,c[t>>2]|0,c[u>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break e;e=_(c[t>>2]|0,c[k>>2]|0)|0;d=_(c[u>>2]|0,c[k>>2]|0)|0;fa=+h[E>>3]*(+h[(c[o>>2]|0)+(e+(c[v>>2]|0)<<3)>>3]-+h[(c[o>>2]|0)+(d+(c[v>>2]|0)<<3)>>3]);ea=+h[J>>3];if(+h[w>>3]==-1.0){d=(c[I>>2]|0)+(c[v>>2]<<3)|0;h[d>>3]=+h[d>>3]+fa/(ea*+h[J>>3])}else{da=fa/+P(+ea,+(1.0-+h[w>>3]));d=(c[I>>2]|0)+(c[v>>2]<<3)|0;h[d>>3]=+h[d>>3]+da}c[v>>2]=(c[v>>2]|0)+1}}while(0);c[u>>2]=(c[u>>2]|0)+1}}else{d=_(c[k>>2]|0,c[t>>2]|0)|0;wv(c[R>>2]|0,+h[(c[m>>2]|0)+64>>3],(c[o>>2]|0)+(d<<3)|0,c[t>>2]|0,T,U,V,W,X,Z,c[p>>2]|0);h[$>>3]=+h[$>>3]+ +h[Z>>3];h[Y>>3]=+h[Y>>3]+ +(c[T>>2]|0);if(c[c[p>>2]>>2]|0)break a;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[T>>2]|0))break c;if(+h[(c[X>>2]|0)+(c[u>>2]<<3)>>3]>1.0e-15)ga=+h[(c[X>>2]|0)+(c[u>>2]<<3)>>3];else ga=1.0e-15;h[J>>3]=ga;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;d=_(c[t>>2]|0,c[k>>2]|0)|0;e=_(c[u>>2]|0,c[k>>2]|0)|0;da=+h[(c[W>>2]|0)+(c[u>>2]<<3)>>3]*+h[E>>3]*(+h[(c[o>>2]|0)+(d+(c[v>>2]|0)<<3)>>3]-+h[(c[V>>2]|0)+(e+(c[v>>2]|0)<<3)>>3]);ea=+h[J>>3];if(+h[w>>3]==-1.0){e=(c[I>>2]|0)+(c[v>>2]<<3)|0;h[e>>3]=+h[e>>3]+da/(ea*+h[J>>3])}else{fa=da/+P(+ea,+(1.0-+h[w>>3]));e=(c[I>>2]|0)+(c[v>>2]<<3)|0;h[e>>3]=+h[e>>3]+fa}c[v>>2]=(c[v>>2]|0)+1}c[u>>2]=(c[u>>2]|0)+1}}while(0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;e=_(c[t>>2]|0,c[k>>2]|0)|0;d=(c[aa>>2]|0)+(e+(c[v>>2]|0)<<3)|0;h[d>>3]=+h[d>>3]+ +h[(c[I>>2]|0)+(c[v>>2]<<3)>>3];c[v>>2]=(c[v>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[s>>2]|0))break;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;h[(c[I>>2]|0)+(c[v>>2]<<3)>>3]=0.0;c[v>>2]=(c[v>>2]|0)+1}c[u>>2]=c[(c[F>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[F>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;f:do if((c[(c[G>>2]|0)+(c[u>>2]<<2)>>2]|0)!=(c[t>>2]|0)){h[J>>3]=+zw(c[o>>2]|0,c[k>>2]|0,c[t>>2]|0,c[(c[G>>2]|0)+(c[u>>2]<<2)>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break f;d=_(c[t>>2]|0,c[k>>2]|0)|0;e=_(c[(c[G>>2]|0)+(c[u>>2]<<2)>>2]|0,c[k>>2]|0)|0;f=(c[I>>2]|0)+(c[v>>2]<<3)|0;h[f>>3]=+h[f>>3]-+h[z>>3]*(+h[(c[o>>2]|0)+(d+(c[v>>2]|0)<<3)>>3]-+h[(c[o>>2]|0)+(e+(c[v>>2]|0)<<3)>>3])*+h[J>>3];c[v>>2]=(c[v>>2]|0)+1}}while(0);c[u>>2]=(c[u>>2]|0)+1}c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;e=_(c[t>>2]|0,c[k>>2]|0)|0;d=(c[aa>>2]|0)+(e+(c[v>>2]|0)<<3)|0;h[d>>3]=+h[d>>3]+ +h[(c[I>>2]|0)+(c[v>>2]<<3)>>3];c[v>>2]=(c[v>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[s>>2]|0))break;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;d=_(c[t>>2]|0,c[k>>2]|0)|0;h[(c[I>>2]|0)+(c[v>>2]<<3)>>3]=+h[(c[aa>>2]|0)+(d+(c[v>>2]|0)<<3)>>3];c[v>>2]=(c[v>>2]|0)+1}h[K>>3]=0.0;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;h[K>>3]=+h[K>>3]+ +h[(c[I>>2]|0)+(c[v>>2]<<3)>>3]*+h[(c[I>>2]|0)+(c[v>>2]<<3)>>3];c[v>>2]=(c[v>>2]|0)+1}h[K>>3]=+O(+(+h[K>>3]));h[L>>3]=+h[L>>3]+ +h[K>>3];g:do if(+h[K>>3]>0.0){c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break g;d=(c[I>>2]|0)+(c[v>>2]<<3)|0;h[d>>3]=+h[d>>3]/+h[K>>3];c[v>>2]=(c[v>>2]|0)+1}}while(0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[k>>2]|0))break;d=_(c[t>>2]|0,c[k>>2]|0)|0;e=(c[o>>2]|0)+(d+(c[v>>2]|0)<<3)|0;h[e>>3]=+h[e>>3]+ +h[D>>3]*+h[(c[I>>2]|0)+(c[v>>2]<<3)>>3];c[v>>2]=(c[v>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}if(c[R>>2]|0){Bv(c[R>>2]|0);h[Y>>3]=+h[Y>>3]/+(c[s>>2]|0);h[$>>3]=+h[$>>3]/+(c[s>>2]|0);tp(c[ca>>2]|0,+h[Y>>3]*5.0+ +h[$>>3])}h[D>>3]=+Jp(c[Q>>2]|0,+h[D>>3],+h[L>>3],+h[M>>3],+h[C>>3]);if(!(+h[D>>3]>+h[A>>3]))break}while(+(c[N>>2]|0)<+h[B>>3]);if(c[(c[m>>2]|0)+112>>2]|0)Kp(c[k>>2]|0,c[q>>2]|0,c[o>>2]|0)}else c[c[p>>2]>>2]=-100;while(0);if(c[S>>2]|0){rp(c[ca>>2]|0);c[(c[m>>2]|0)+56>>2]=c[ba>>2]}if(c[H>>2]|0)O4(c[H>>2]|0);if((c[q>>2]|0)!=(c[l>>2]|0))Lv(c[q>>2]|0);if(c[I>>2]|0)O4(c[I>>2]|0);if(c[V>>2]|0)O4(c[V>>2]|0);if(c[W>>2]|0)O4(c[W>>2]|0);if(c[X>>2]|0)O4(c[X>>2]|0);O4(c[aa>>2]|0);i=j;return}function Cp(a,b,e,f,g,j){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0.0,ga=0.0,ha=0.0;k=i;i=i+272|0;l=k+128|0;m=k+256|0;n=k+252|0;o=k+248|0;p=k+244|0;q=k+240|0;r=k+236|0;s=k+232|0;t=k+228|0;u=k+224|0;v=k+220|0;w=k+216|0;x=k+212|0;y=k+120|0;z=k+112|0;A=k+104|0;B=k+96|0;C=k+88|0;D=k+80|0;E=k+72|0;F=k+64|0;G=k+56|0;H=k+208|0;I=k+204|0;J=k+200|0;K=k+196|0;L=k+48|0;M=k+40|0;N=k+32|0;Q=k+24|0;R=k+192|0;S=k+188|0;T=k+184|0;U=k+180|0;V=k+176|0;W=k+172|0;X=k+168|0;Y=k+164|0;Z=k+160|0;$=k+16|0;aa=k+8|0;ba=k;ca=k+156|0;da=k+152|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;c[s>>2]=c[n>>2];h[y>>3]=+h[c[o>>2]>>3];h[z>>3]=+h[(c[o>>2]|0)+24>>3];h[A>>3]=+h[(c[o>>2]|0)+32>>3];h[C>>3]=+h[(c[o>>2]|0)+72>>3];h[D>>3]=+(c[(c[o>>2]|0)+80>>2]|0);h[E>>3]=+h[(c[o>>2]|0)+88>>3];h[F>>3]=+h[(c[o>>2]|0)+96>>3];c[H>>2]=0;c[I>>2]=0;c[J>>2]=0;c[K>>2]=0;h[N>>3]=0.0;c[R>>2]=0;c[S>>2]=c[(c[o>>2]|0)+104>>2];c[T>>2]=0;c[U>>2]=0;c[V>>2]=0;c[W>>2]=10;c[X>>2]=0;c[Y>>2]=0;c[Z>>2]=0;h[aa>>3]=0.0;h[ba>>3]=0.0;c[ca>>2]=c[(c[o>>2]|0)+56>>2];c[da>>2]=0;if((c[s>>2]|0)==0|+h[D>>3]<=0.0){i=k;return}c[t>>2]=c[c[s>>2]>>2];c[u>>2]=c[(c[s>>2]|0)+4>>2];if((c[u>>2]|0)<=0|(c[m>>2]|0)<=0){i=k;return}if((c[u>>2]|0)>=(c[(c[o>>2]|0)+52>>2]|0)){c[U>>2]=1;c[da>>2]=sp(c[ca>>2]|0)|0;c[X>>2]=cK(_(c[W>>2]<<3,c[m>>2]|0)|0)|0;c[Y>>2]=cK(c[W>>2]<<3)|0;c[Z>>2]=cK(c[W>>2]<<3)|0}c[c[r>>2]>>2]=0;a:do if((c[t>>2]|0)==(c[u>>2]|0)){c[s>>2]=Mv(c[s>>2]|0,1)|0;c[H>>2]=c[(c[s>>2]|0)+20>>2];c[I>>2]=c[(c[s>>2]|0)+24>>2];b:do if(c[(c[o>>2]|0)+16>>2]|0){s2(c[(c[o>>2]|0)+108>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(_(c[m>>2]|0,c[u>>2]|0)|0))break b;ea=+rw();h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]=ea;c[v>>2]=(c[v>>2]|0)+1}}while(0);if(+h[z>>3]<0.0){ea=+vp(c[s>>2]|0,c[m>>2]|0,c[q>>2]|0);h[z>>3]=ea;h[(c[o>>2]|0)+24>>3]=ea}if(+h[A>>3]<0.0){h[A>>3]=.2;h[(c[o>>2]|0)+32>>3]=.2}if(+h[y>>3]>=0.0){h[y>>3]=-1.0;h[c[o>>2]>>3]=-1.0}h[G>>3]=+P(+(+h[z>>3]),+(1.0-+h[y>>3]));ea=+P(+(+h[A>>3]),+((2.0-+h[y>>3])/3.0));h[B>>3]=ea/+h[z>>3];c[K>>2]=cK(c[m>>2]<<3)|0;c[J>>2]=cK(_(c[m>>2]<<3,c[u>>2]|0)|0)|0;do{c[R>>2]=(c[R>>2]|0)+1;j=c[J>>2]|0;Z4(j|0,c[q>>2]|0,_(c[m>>2]<<3,c[u>>2]|0)|0)|0;c[J>>2]=j;h[Q>>3]=+h[N>>3];h[N>>3]=0.0;h[$>>3]=0.0;h[ba>>3]=0.0;do if(c[U>>2]|0){c[ca>>2]=up(c[da>>2]|0)|0;j=c[m>>2]|0;g=c[u>>2]|0;f=c[ca>>2]|0;e=c[q>>2]|0;if(c[(c[o>>2]|0)+116>>2]|0){c[T>>2]=yv(j,g,f,e,c[p>>2]|0)|0;break}else{c[T>>2]=yv(j,g,f,e,0)|0;break}}while(0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[u>>2]|0))break;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break;h[(c[K>>2]|0)+(c[x>>2]<<3)>>3]=0.0;c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=c[(c[H>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[w>>2]|0)>=(c[(c[H>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;c:do if((c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0)!=(c[v>>2]|0)){h[L>>3]=+zw(c[q>>2]|0,c[m>>2]|0,c[v>>2]|0,c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break c;e=_(c[v>>2]|0,c[m>>2]|0)|0;f=_(c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0,c[m>>2]|0)|0;g=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[g>>3]=+h[g>>3]-+h[B>>3]*(+h[(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)>>3]-+h[(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)>>3])*+h[L>>3];c[x>>2]=(c[x>>2]|0)+1}}while(0);c[w>>2]=(c[w>>2]|0)+1}d:do if(!(c[U>>2]|0)){f=(c[p>>2]|0)!=0?(c[(c[o>>2]|0)+116>>2]|0)!=0:0;c[w>>2]=0;if(f)while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break d;e:do if((c[w>>2]|0)!=(c[v>>2]|0)){h[L>>3]=+yw(c[q>>2]|0,c[m>>2]|0,c[v>>2]|0,c[w>>2]|0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break e;f=_(c[v>>2]|0,c[m>>2]|0)|0;e=_(c[w>>2]|0,c[m>>2]|0)|0;ea=+h[(c[p>>2]|0)+(c[w>>2]<<3)>>3]*+h[G>>3]*(+h[(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)>>3]-+h[(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)>>3]);fa=+h[L>>3];if(+h[y>>3]==-1.0){e=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[e>>3]=+h[e>>3]+ea/(fa*+h[L>>3])}else{ga=ea/+P(+fa,+(1.0-+h[y>>3]));e=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[e>>3]=+h[e>>3]+ga}c[x>>2]=(c[x>>2]|0)+1}}while(0);c[w>>2]=(c[w>>2]|0)+1}else while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break d;f:do if((c[w>>2]|0)!=(c[v>>2]|0)){h[L>>3]=+yw(c[q>>2]|0,c[m>>2]|0,c[v>>2]|0,c[w>>2]|0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break f;e=_(c[v>>2]|0,c[m>>2]|0)|0;f=_(c[w>>2]|0,c[m>>2]|0)|0;ga=+h[G>>3]*(+h[(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)>>3]-+h[(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)>>3]);fa=+h[L>>3];if(+h[y>>3]==-1.0){f=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[f>>3]=+h[f>>3]+ga/(fa*+h[L>>3])}else{ea=ga/+P(+fa,+(1.0-+h[y>>3]));f=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[f>>3]=+h[f>>3]+ea}c[x>>2]=(c[x>>2]|0)+1}}while(0);c[w>>2]=(c[w>>2]|0)+1}}else{f=_(c[m>>2]|0,c[v>>2]|0)|0;wv(c[T>>2]|0,+h[(c[o>>2]|0)+64>>3],(c[q>>2]|0)+(f<<3)|0,c[v>>2]|0,V,W,X,Y,Z,aa,c[r>>2]|0);h[ba>>3]=+h[ba>>3]+ +h[aa>>3];h[$>>3]=+h[$>>3]+ +(c[V>>2]|0);if(c[c[r>>2]>>2]|0)break a;c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[V>>2]|0))break d;if(+h[(c[Z>>2]|0)+(c[w>>2]<<3)>>3]>1.0e-15)ha=+h[(c[Z>>2]|0)+(c[w>>2]<<3)>>3];else ha=1.0e-15;h[L>>3]=ha;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break;f=_(c[v>>2]|0,c[m>>2]|0)|0;e=_(c[w>>2]|0,c[m>>2]|0)|0;ea=+h[(c[Y>>2]|0)+(c[w>>2]<<3)>>3]*+h[G>>3]*(+h[(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)>>3]-+h[(c[X>>2]|0)+(e+(c[x>>2]|0)<<3)>>3]);fa=+h[L>>3];if(+h[y>>3]==-1.0){e=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[e>>3]=+h[e>>3]+ea/(fa*+h[L>>3])}else{ga=ea/+P(+fa,+(1.0-+h[y>>3]));e=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[e>>3]=+h[e>>3]+ga}c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=(c[w>>2]|0)+1}}while(0);h[M>>3]=0.0;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break;h[M>>3]=+h[M>>3]+ +h[(c[K>>2]|0)+(c[x>>2]<<3)>>3]*+h[(c[K>>2]|0)+(c[x>>2]<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}h[M>>3]=+O(+(+h[M>>3]));h[N>>3]=+h[N>>3]+ +h[M>>3];g:do if(+h[M>>3]>0.0){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break g;e=(c[K>>2]|0)+(c[x>>2]<<3)|0;h[e>>3]=+h[e>>3]/+h[M>>3];c[x>>2]=(c[x>>2]|0)+1}}while(0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[m>>2]|0))break;e=_(c[v>>2]|0,c[m>>2]|0)|0;f=(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)|0;h[f>>3]=+h[f>>3]+ +h[F>>3]*+h[(c[K>>2]|0)+(c[x>>2]<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}c[v>>2]=(c[v>>2]|0)+1}if(c[T>>2]|0){Bv(c[T>>2]|0);h[$>>3]=+h[$>>3]/+(c[u>>2]|0);h[ba>>3]=+h[ba>>3]/+(c[u>>2]|0);if((d[138998]|0)&0){f=c[24742]|0;ga=+h[ba>>3];fa=+h[$>>3]*2.0+ +h[ba>>3];h[l>>3]=+h[$>>3];h[l+8>>3]=ga;h[l+16>>3]=fa;Y2(f,129613,l)|0}tp(c[da>>2]|0,+h[$>>3]*5.0+ +h[ba>>3])}h[F>>3]=+Jp(c[S>>2]|0,+h[F>>3],+h[N>>3],+h[Q>>3],+h[E>>3]);if(!(+h[F>>3]>+h[C>>3]))break}while(+(c[R>>2]|0)<+h[D>>3]);if(c[(c[o>>2]|0)+112>>2]|0)Kp(c[m>>2]|0,c[s>>2]|0,c[q>>2]|0)}else c[c[r>>2]>>2]=-100;while(0);if(c[U>>2]|0){rp(c[da>>2]|0);c[(c[o>>2]|0)+56>>2]=c[ca>>2]}if(c[J>>2]|0)O4(c[J>>2]|0);if((c[s>>2]|0)!=(c[n>>2]|0))Lv(c[s>>2]|0);if(c[K>>2]|0)O4(c[K>>2]|0);if(c[X>>2]|0)O4(c[X>>2]|0);if(c[Y>>2]|0)O4(c[Y>>2]|0);if(!(c[Z>>2]|0)){i=k;return}O4(c[Z>>2]|0);i=k;return}function Dp(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0.0,ka=0.0,la=0.0;l=i;i=i+272|0;m=l+144|0;n=l+128|0;o=l+264|0;p=l+260|0;q=l+256|0;r=l+252|0;s=l+248|0;t=l+244|0;u=l+120|0;v=l+240|0;w=l+236|0;x=l+232|0;y=l+228|0;z=l+224|0;A=l+220|0;B=l+216|0;C=l+112|0;D=l+104|0;E=l+96|0;F=l+88|0;G=l+80|0;H=l+72|0;I=l+64|0;J=l+56|0;K=l+212|0;L=l+208|0;M=l+204|0;N=l+200|0;Q=l+196|0;R=l+48|0;S=l+192|0;T=l+188|0;U=l+40|0;V=l+32|0;W=l+24|0;X=l+16|0;Y=l+184|0;Z=l+180|0;$=l+176|0;aa=l+172|0;ba=l+168|0;ca=l+164|0;da=l+160|0;ea=l+156|0;fa=l+152|0;ga=l+8|0;ha=l;ia=l+148|0;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;h[u>>3]=j;c[v>>2]=k;c[w>>2]=c[p>>2];h[C>>3]=+h[c[r>>2]>>3];h[D>>3]=+h[(c[r>>2]|0)+32>>3];h[E>>3]=+h[(c[r>>2]|0)+72>>3];h[F>>3]=+(c[(c[r>>2]|0)+80>>2]|0);h[G>>3]=+h[(c[r>>2]|0)+88>>3];h[H>>3]=+h[(c[r>>2]|0)+96>>3];h[J>>3]=1.0;c[K>>2]=0;c[L>>2]=0;c[M>>2]=0;c[N>>2]=0;c[S>>2]=0;c[T>>2]=0;h[W>>3]=0.0;c[Y>>2]=0;c[Z>>2]=c[(c[r>>2]|0)+104>>2];c[$>>2]=0;c[aa>>2]=0;c[ba>>2]=0;c[ca>>2]=10;c[da>>2]=0;c[ea>>2]=0;c[fa>>2]=0;h[ha>>3]=0.0;c[ia>>2]=10;if((c[w>>2]|0)==0|+h[F>>3]<=0.0){i=l;return}c[x>>2]=c[c[w>>2]>>2];c[y>>2]=c[(c[w>>2]|0)+4>>2];if((c[y>>2]|0)<=0|(c[o>>2]|0)<=0){i=l;return}if((c[(c[r>>2]|0)+132>>2]|0)!=0?(c[y>>2]|0)>=(c[(c[r>>2]|0)+52>>2]|0):0){c[aa>>2]=1;c[da>>2]=cK(_(c[ca>>2]<<3,c[o>>2]|0)|0)|0;c[ea>>2]=cK(c[ca>>2]<<3)|0;c[fa>>2]=cK(c[ca>>2]<<3)|0}c[c[v>>2]>>2]=0;a:do if((c[x>>2]|0)==(c[y>>2]|0)){c[w>>2]=Mv(c[w>>2]|0,1)|0;c[K>>2]=c[(c[w>>2]|0)+20>>2];c[L>>2]=c[(c[w>>2]|0)+24>>2];if(c[q>>2]|0){c[M>>2]=c[(c[q>>2]|0)+20>>2];c[N>>2]=c[(c[q>>2]|0)+24>>2];c[Q>>2]=c[(c[q>>2]|0)+28>>2]}else{c[M>>2]=c[K>>2];c[N>>2]=c[L>>2];c[Q>>2]=0}if(+h[u>>3]<0.0){h[R>>3]=+Lp(c[y>>2]|0,c[M>>2]|0,c[N>>2]|0,c[Q>>2]|0);h[u>>3]=+h[u>>3]*(+(c[(c[M>>2]|0)+(c[y>>2]<<2)>>2]|0)/(+(c[y>>2]|0)*+(c[y>>2]|0)-+(c[(c[M>>2]|0)+(c[y>>2]<<2)>>2]|0)))/+P(+(+h[R>>3]),+(+h[C>>3]+1.0));k=c[24742]|0;j=+h[u>>3];h[n>>3]=+h[R>>3];h[n+8>>3]=j;Y2(k,129664,n)|0}b:do if(c[(c[r>>2]|0)+16>>2]|0){Y2(c[24742]|0,129686,m)|0;s2(c[(c[r>>2]|0)+108>>2]|0);c[z>>2]=0;while(1){if((c[z>>2]|0)>=(_(c[o>>2]|0,c[y>>2]|0)|0))break b;j=+rw();h[(c[t>>2]|0)+(c[z>>2]<<3)>>3]=j;c[z>>2]=(c[z>>2]|0)+1}}while(0);Mp(c[y>>2]|0,c[o>>2]|0,c[t>>2]|0,c[M>>2]|0,c[N>>2]|0,c[Q>>2]|0,+h[J>>3]);if(+h[D>>3]<0.0){h[D>>3]=.2;h[(c[r>>2]|0)+32>>3]=.2}if(+h[C>>3]>=0.0){h[C>>3]=-1.0;h[c[r>>2]>>3]=-1.0}c[T>>2]=cK(c[o>>2]<<3)|0;c[S>>2]=cK(_(c[o>>2]<<3,c[y>>2]|0)|0)|0;do{c[Y>>2]=(c[Y>>2]|0)+1;k=c[S>>2]|0;Z4(k|0,c[t>>2]|0,_(c[o>>2]<<3,c[y>>2]|0)|0)|0;c[S>>2]=k;h[X>>3]=+h[W>>3];h[W>>3]=0.0;h[ga>>3]=0.0;do if(c[aa>>2]|0){k=c[o>>2]|0;g=c[y>>2]|0;f=c[ia>>2]|0;e=c[t>>2]|0;if(c[(c[r>>2]|0)+116>>2]|0){c[$>>2]=yv(k,g,f,e,c[s>>2]|0)|0;break}else{c[$>>2]=yv(k,g,f,e,0)|0;break}}while(0);c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[y>>2]|0))break;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break;h[(c[T>>2]|0)+(c[B>>2]<<3)>>3]=0.0;c[B>>2]=(c[B>>2]|0)+1}c[A>>2]=c[(c[M>>2]|0)+(c[z>>2]<<2)>>2];while(1){if((c[A>>2]|0)>=(c[(c[M>>2]|0)+((c[z>>2]|0)+1<<2)>>2]|0))break;c:do if((c[(c[N>>2]|0)+(c[A>>2]<<2)>>2]|0)!=(c[z>>2]|0)){h[U>>3]=+yw(c[t>>2]|0,c[o>>2]|0,c[z>>2]|0,c[(c[N>>2]|0)+(c[A>>2]<<2)>>2]|0);if(c[Q>>2]|0)h[J>>3]=+h[(c[Q>>2]|0)+(c[A>>2]<<3)>>3];d:do if(!(+h[(c[r>>2]|0)+8>>3]==2.0)){j=+h[J>>3];if(+h[(c[r>>2]|0)+8>>3]==1.0){h[I>>3]=1.0/(j*+h[J>>3]);c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break d;e=_(c[z>>2]|0,c[o>>2]|0)|0;f=_(c[(c[N>>2]|0)+(c[A>>2]<<2)>>2]|0,c[o>>2]|0)|0;g=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[g>>3]=+h[g>>3]+-+h[I>>3]*(+h[(c[t>>2]|0)+(e+(c[B>>2]|0)<<3)>>3]-+h[(c[t>>2]|0)+(f+(c[B>>2]|0)<<3)>>3])*(+h[U>>3]-+h[J>>3])/+h[U>>3];c[B>>2]=(c[B>>2]|0)+1}}else{h[I>>3]=1.0/+P(+j,+(+h[(c[r>>2]|0)+8>>3]+1.0));c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break d;f=_(c[z>>2]|0,c[o>>2]|0)|0;e=_(c[(c[N>>2]|0)+(c[A>>2]<<2)>>2]|0,c[o>>2]|0)|0;ja=-+h[I>>3]*(+h[(c[t>>2]|0)+(f+(c[B>>2]|0)<<3)>>3]-+h[(c[t>>2]|0)+(e+(c[B>>2]|0)<<3)>>3])*+P(+(+h[U>>3]-+h[J>>3]),+(+h[(c[r>>2]|0)+8>>3]));e=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[e>>3]=+h[e>>3]+ja/+h[U>>3];c[B>>2]=(c[B>>2]|0)+1}}}else{h[I>>3]=1.0/(+h[J>>3]*+h[J>>3]*+h[J>>3]);c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break d;e=_(c[z>>2]|0,c[o>>2]|0)|0;f=_(c[(c[N>>2]|0)+(c[A>>2]<<2)>>2]|0,c[o>>2]|0)|0;g=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[g>>3]=+h[g>>3]+-+h[I>>3]*(+h[(c[t>>2]|0)+(e+(c[B>>2]|0)<<3)>>3]-+h[(c[t>>2]|0)+(f+(c[B>>2]|0)<<3)>>3])*(+h[U>>3]-+h[J>>3])*(+h[U>>3]-+h[J>>3])/+h[U>>3];c[B>>2]=(c[B>>2]|0)+1}}while(0);f=(c[s>>2]|0)!=0?(c[(c[r>>2]|0)+116>>2]|0)!=0:0;c[B>>2]=0;if(f)while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break c;f=_(c[z>>2]|0,c[o>>2]|0)|0;e=_(c[(c[N>>2]|0)+(c[A>>2]<<2)>>2]|0,c[o>>2]|0)|0;j=+h[u>>3]*+h[(c[s>>2]|0)+(c[A>>2]<<3)>>3]*(+h[(c[t>>2]|0)+(f+(c[B>>2]|0)<<3)>>3]-+h[(c[t>>2]|0)+(e+(c[B>>2]|0)<<3)>>3]);ja=+h[U>>3];if(+h[C>>3]==-1.0){e=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[e>>3]=+h[e>>3]-j/(ja*+h[U>>3])}else{ka=j/+P(+ja,+(1.0-+h[C>>3]));e=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[e>>3]=+h[e>>3]-ka}c[B>>2]=(c[B>>2]|0)+1}else while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break c;e=_(c[z>>2]|0,c[o>>2]|0)|0;f=_(c[(c[N>>2]|0)+(c[A>>2]<<2)>>2]|0,c[o>>2]|0)|0;ka=+h[u>>3]*(+h[(c[t>>2]|0)+(e+(c[B>>2]|0)<<3)>>3]-+h[(c[t>>2]|0)+(f+(c[B>>2]|0)<<3)>>3]);ja=+h[U>>3];if(+h[C>>3]==-1.0){f=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[f>>3]=+h[f>>3]-ka/(ja*+h[U>>3])}else{j=ka/+P(+ja,+(1.0-+h[C>>3]));f=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[f>>3]=+h[f>>3]-j}c[B>>2]=(c[B>>2]|0)+1}}while(0);c[A>>2]=(c[A>>2]|0)+1}e:do if(!(c[aa>>2]|0)){f=(c[s>>2]|0)!=0?(c[(c[r>>2]|0)+116>>2]|0)!=0:0;c[A>>2]=0;if(f)while(1){if((c[A>>2]|0)>=(c[y>>2]|0))break e;f:do if((c[A>>2]|0)!=(c[z>>2]|0)){h[U>>3]=+yw(c[t>>2]|0,c[o>>2]|0,c[z>>2]|0,c[A>>2]|0);c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break f;f=_(c[z>>2]|0,c[o>>2]|0)|0;e=_(c[A>>2]|0,c[o>>2]|0)|0;j=+h[u>>3]*+h[(c[s>>2]|0)+(c[A>>2]<<3)>>3]*(+h[(c[t>>2]|0)+(f+(c[B>>2]|0)<<3)>>3]-+h[(c[t>>2]|0)+(e+(c[B>>2]|0)<<3)>>3]);ja=+h[U>>3];if(+h[C>>3]==-1.0){e=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[e>>3]=+h[e>>3]+j/(ja*+h[U>>3])}else{ka=j/+P(+ja,+(1.0-+h[C>>3]));e=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[e>>3]=+h[e>>3]+ka}c[B>>2]=(c[B>>2]|0)+1}}while(0);c[A>>2]=(c[A>>2]|0)+1}else while(1){if((c[A>>2]|0)>=(c[y>>2]|0))break e;g:do if((c[A>>2]|0)!=(c[z>>2]|0)){h[U>>3]=+yw(c[t>>2]|0,c[o>>2]|0,c[z>>2]|0,c[A>>2]|0);c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break g;e=_(c[z>>2]|0,c[o>>2]|0)|0;f=_(c[A>>2]|0,c[o>>2]|0)|0;ka=+h[u>>3]*(+h[(c[t>>2]|0)+(e+(c[B>>2]|0)<<3)>>3]-+h[(c[t>>2]|0)+(f+(c[B>>2]|0)<<3)>>3]);ja=+h[U>>3];if(+h[C>>3]==-1.0){f=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[f>>3]=+h[f>>3]+ka/(ja*+h[U>>3])}else{j=ka/+P(+ja,+(1.0-+h[C>>3]));f=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[f>>3]=+h[f>>3]+j}c[B>>2]=(c[B>>2]|0)+1}}while(0);c[A>>2]=(c[A>>2]|0)+1}}else{f=_(c[o>>2]|0,c[z>>2]|0)|0;wv(c[$>>2]|0,+h[(c[r>>2]|0)+64>>3],(c[t>>2]|0)+(f<<3)|0,c[z>>2]|0,ba,ca,da,ea,fa,ha,c[v>>2]|0);h[ga>>3]=+h[ga>>3]+ +(c[ba>>2]|0);if(c[c[v>>2]>>2]|0)break a;c[A>>2]=0;while(1){if((c[A>>2]|0)>=(c[ba>>2]|0))break e;if(+h[(c[fa>>2]|0)+(c[A>>2]<<3)>>3]>1.0e-15)la=+h[(c[fa>>2]|0)+(c[A>>2]<<3)>>3];else la=1.0e-15;h[U>>3]=la;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break;f=_(c[z>>2]|0,c[o>>2]|0)|0;e=_(c[A>>2]|0,c[o>>2]|0)|0;j=+h[u>>3]*+h[(c[ea>>2]|0)+(c[A>>2]<<3)>>3]*(+h[(c[t>>2]|0)+(f+(c[B>>2]|0)<<3)>>3]-+h[(c[da>>2]|0)+(e+(c[B>>2]|0)<<3)>>3]);ja=+h[U>>3];if(+h[C>>3]==-1.0){e=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[e>>3]=+h[e>>3]+j/(ja*+h[U>>3])}else{ka=j/+P(+ja,+(1.0-+h[C>>3]));e=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[e>>3]=+h[e>>3]+ka}c[B>>2]=(c[B>>2]|0)+1}c[A>>2]=(c[A>>2]|0)+1}}while(0);h[V>>3]=0.0;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break;h[V>>3]=+h[V>>3]+ +h[(c[T>>2]|0)+(c[B>>2]<<3)>>3]*+h[(c[T>>2]|0)+(c[B>>2]<<3)>>3];c[B>>2]=(c[B>>2]|0)+1}h[V>>3]=+O(+(+h[V>>3]));h[W>>3]=+h[W>>3]+ +h[V>>3];h:do if(+h[V>>3]>0.0){c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break h;e=(c[T>>2]|0)+(c[B>>2]<<3)|0;h[e>>3]=+h[e>>3]/+h[V>>3];c[B>>2]=(c[B>>2]|0)+1}}while(0);c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[o>>2]|0))break;e=_(c[z>>2]|0,c[o>>2]|0)|0;f=(c[t>>2]|0)+(e+(c[B>>2]|0)<<3)|0;h[f>>3]=+h[f>>3]+ +h[H>>3]*+h[(c[T>>2]|0)+(c[B>>2]<<3)>>3];c[B>>2]=(c[B>>2]|0)+1}c[z>>2]=(c[z>>2]|0)+1}if(c[$>>2]|0)Bv(c[$>>2]|0);h[ga>>3]=+h[ga>>3]/+(c[y>>2]|0);h[H>>3]=+Jp(c[Z>>2]|0,+h[H>>3],+h[W>>3],+h[X>>3],+h[G>>3]);if(!(+h[H>>3]>+h[E>>3]))break}while(+(c[Y>>2]|0)<+h[F>>3]);if(c[(c[r>>2]|0)+112>>2]|0)Kp(c[o>>2]|0,c[w>>2]|0,c[t>>2]|0)}else c[c[v>>2]>>2]=-100;while(0);if(c[S>>2]|0)O4(c[S>>2]|0);if((c[w>>2]|0)!=(c[p>>2]|0))Lv(c[w>>2]|0);if(c[T>>2]|0)O4(c[T>>2]|0);if(c[da>>2]|0)O4(c[da>>2]|0);if(c[ea>>2]|0)O4(c[ea>>2]|0);if(!(c[fa>>2]|0)){i=l;return}O4(c[fa>>2]|0);i=l;return}function Ep(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0;k=i;i=i+240|0;l=k+236|0;m=k+232|0;n=k+228|0;o=k+224|0;p=k+220|0;q=k+216|0;r=k+212|0;s=k+208|0;t=k+204|0;u=k+200|0;v=k+196|0;w=k+192|0;x=k+188|0;y=k+112|0;z=k+104|0;A=k+96|0;B=k+88|0;C=k+80|0;D=k+72|0;E=k+64|0;F=k+56|0;G=k+48|0;H=k+184|0;I=k+180|0;J=k+176|0;K=k+172|0;L=k+168|0;M=k+164|0;N=k+160|0;Q=k+40|0;R=k+32|0;S=k+24|0;T=k+16|0;U=k+156|0;V=k+152|0;W=k+148|0;X=k+144|0;Y=k+140|0;Z=k+136|0;$=k+132|0;aa=k+128|0;ba=k+124|0;ca=k+8|0;da=k;ea=k+120|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;c[s>>2]=c[m>>2];h[y>>3]=+h[c[o>>2]>>3];h[z>>3]=+h[(c[o>>2]|0)+24>>3];h[A>>3]=+h[(c[o>>2]|0)+32>>3];h[C>>3]=+h[(c[o>>2]|0)+72>>3];h[D>>3]=+(c[(c[o>>2]|0)+80>>2]|0);h[E>>3]=+h[(c[o>>2]|0)+88>>3];h[F>>3]=+h[(c[o>>2]|0)+96>>3];c[H>>2]=0;c[I>>2]=0;c[J>>2]=0;c[K>>2]=0;c[M>>2]=0;c[N>>2]=0;h[S>>3]=0.0;c[U>>2]=0;c[V>>2]=c[(c[o>>2]|0)+104>>2];c[W>>2]=0;c[X>>2]=0;c[Y>>2]=0;c[Z>>2]=10;c[$>>2]=0;c[aa>>2]=0;c[ba>>2]=0;h[da>>3]=0.0;c[ea>>2]=10;if((c[s>>2]|0)==0|+h[D>>3]<=0.0){i=k;return}c[t>>2]=c[c[s>>2]>>2];c[u>>2]=c[(c[s>>2]|0)+4>>2];if((c[u>>2]|0)<=0|(c[l>>2]|0)<=0){i=k;return}if((c[u>>2]|0)>=(c[(c[o>>2]|0)+52>>2]|0)){c[X>>2]=1;c[$>>2]=cK(_(c[Z>>2]<<3,c[l>>2]|0)|0)|0;c[aa>>2]=cK(c[Z>>2]<<3)|0;c[ba>>2]=cK(c[Z>>2]<<3)|0}c[c[r>>2]>>2]=0;a:do if((c[t>>2]|0)==(c[u>>2]|0)){c[s>>2]=Mv(c[s>>2]|0,1)|0;c[H>>2]=c[(c[s>>2]|0)+20>>2];c[I>>2]=c[(c[s>>2]|0)+24>>2];c[J>>2]=c[(c[n>>2]|0)+20>>2];c[K>>2]=c[(c[n>>2]|0)+24>>2];c[L>>2]=c[(c[n>>2]|0)+28>>2];b:do if(c[(c[o>>2]|0)+16>>2]|0){s2(c[(c[o>>2]|0)+108>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(_(c[l>>2]|0,c[u>>2]|0)|0))break b;fa=+rw();h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]=fa;c[v>>2]=(c[v>>2]|0)+1}}while(0);if(+h[z>>3]<0.0){fa=+vp(c[s>>2]|0,c[l>>2]|0,c[q>>2]|0);h[z>>3]=fa;h[(c[o>>2]|0)+24>>3]=fa}if(+h[A>>3]<0.0){h[A>>3]=.2;h[(c[o>>2]|0)+32>>3]=.2}if(+h[y>>3]>=0.0){h[y>>3]=-1.0;h[c[o>>2]>>3]=-1.0}h[G>>3]=+P(+(+h[z>>3]),+(1.0-+h[y>>3]));fa=+P(+(+h[A>>3]),+((2.0-+h[y>>3])/3.0));h[B>>3]=fa/+h[z>>3];c[N>>2]=cK(c[l>>2]<<3)|0;c[M>>2]=cK(_(c[l>>2]<<3,c[u>>2]|0)|0)|0;do{c[U>>2]=(c[U>>2]|0)+1;j=c[M>>2]|0;Z4(j|0,c[q>>2]|0,_(c[l>>2]<<3,c[u>>2]|0)|0)|0;c[M>>2]=j;h[T>>3]=+h[S>>3];h[S>>3]=0.0;h[ca>>3]=0.0;do if(c[X>>2]|0){j=c[l>>2]|0;g=c[u>>2]|0;f=c[ea>>2]|0;e=c[q>>2]|0;if(c[(c[o>>2]|0)+116>>2]|0){c[W>>2]=yv(j,g,f,e,c[p>>2]|0)|0;break}else{c[W>>2]=yv(j,g,f,e,0)|0;break}}while(0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[u>>2]|0))break;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break;h[(c[N>>2]|0)+(c[x>>2]<<3)>>3]=0.0;c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=c[(c[H>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[w>>2]|0)>=(c[(c[H>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;c:do if((c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0)!=(c[v>>2]|0)){h[Q>>3]=+zw(c[q>>2]|0,c[l>>2]|0,c[v>>2]|0,c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break c;e=_(c[v>>2]|0,c[l>>2]|0)|0;f=_(c[(c[I>>2]|0)+(c[w>>2]<<2)>>2]|0,c[l>>2]|0)|0;g=(c[N>>2]|0)+(c[x>>2]<<3)|0;h[g>>3]=+h[g>>3]-+h[B>>3]*(+h[(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)>>3]-+h[(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)>>3])*+h[Q>>3];c[x>>2]=(c[x>>2]|0)+1}}while(0);c[w>>2]=(c[w>>2]|0)+1}c[w>>2]=c[(c[J>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[w>>2]|0)>=(c[(c[J>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;d:do if((c[(c[K>>2]|0)+(c[w>>2]<<2)>>2]|0)!=(c[v>>2]|0)){h[Q>>3]=+yw(c[q>>2]|0,c[l>>2]|0,c[v>>2]|0,c[(c[K>>2]|0)+(c[w>>2]<<2)>>2]|0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break d;f=_(c[v>>2]|0,c[l>>2]|0)|0;e=_(c[(c[K>>2]|0)+(c[w>>2]<<2)>>2]|0,c[l>>2]|0)|0;fa=+h[B>>3]*.2*(+h[(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)>>3]-+h[(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)>>3])*(+h[Q>>3]-+h[(c[L>>2]|0)+(c[w>>2]<<3)>>3])*(+h[Q>>3]-+h[(c[L>>2]|0)+(c[w>>2]<<3)>>3])/+h[Q>>3];e=(c[N>>2]|0)+(c[x>>2]<<3)|0;ga=+h[e>>3];if(+h[Q>>3]<+h[(c[L>>2]|0)+(c[w>>2]<<3)>>3])h[e>>3]=ga+fa;else h[e>>3]=ga-fa;c[x>>2]=(c[x>>2]|0)+1}}while(0);c[w>>2]=(c[w>>2]|0)+1}e:do if(!(c[X>>2]|0)){e=(c[p>>2]|0)!=0?(c[(c[o>>2]|0)+116>>2]|0)!=0:0;c[w>>2]=0;if(e)while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break e;f:do if((c[w>>2]|0)!=(c[v>>2]|0)){h[Q>>3]=+yw(c[q>>2]|0,c[l>>2]|0,c[v>>2]|0,c[w>>2]|0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break f;e=_(c[v>>2]|0,c[l>>2]|0)|0;f=_(c[w>>2]|0,c[l>>2]|0)|0;fa=+h[(c[p>>2]|0)+(c[w>>2]<<3)>>3]*+h[G>>3]*(+h[(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)>>3]-+h[(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)>>3]);ga=+h[Q>>3];if(+h[y>>3]==-1.0){f=(c[N>>2]|0)+(c[x>>2]<<3)|0;h[f>>3]=+h[f>>3]+fa/(ga*+h[Q>>3])}else{ha=fa/+P(+ga,+(1.0-+h[y>>3]));f=(c[N>>2]|0)+(c[x>>2]<<3)|0;h[f>>3]=+h[f>>3]+ha}c[x>>2]=(c[x>>2]|0)+1}}while(0);c[w>>2]=(c[w>>2]|0)+1}else while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break e;g:do if((c[w>>2]|0)!=(c[v>>2]|0)){h[Q>>3]=+yw(c[q>>2]|0,c[l>>2]|0,c[v>>2]|0,c[w>>2]|0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break g;f=_(c[v>>2]|0,c[l>>2]|0)|0;e=_(c[w>>2]|0,c[l>>2]|0)|0;ha=+h[G>>3]*(+h[(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)>>3]-+h[(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)>>3]);ga=+h[Q>>3];if(+h[y>>3]==-1.0){e=(c[N>>2]|0)+(c[x>>2]<<3)|0;h[e>>3]=+h[e>>3]+ha/(ga*+h[Q>>3])}else{fa=ha/+P(+ga,+(1.0-+h[y>>3]));e=(c[N>>2]|0)+(c[x>>2]<<3)|0;h[e>>3]=+h[e>>3]+fa}c[x>>2]=(c[x>>2]|0)+1}}while(0);c[w>>2]=(c[w>>2]|0)+1}}else{e=_(c[l>>2]|0,c[v>>2]|0)|0;wv(c[W>>2]|0,+h[(c[o>>2]|0)+64>>3],(c[q>>2]|0)+(e<<3)|0,c[v>>2]|0,Y,Z,$,aa,ba,da,c[r>>2]|0);h[ca>>3]=+h[ca>>3]+ +(c[Y>>2]|0);if(c[c[r>>2]>>2]|0)break a;c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[Y>>2]|0))break e;if(+h[(c[ba>>2]|0)+(c[w>>2]<<3)>>3]>1.0e-15)ia=+h[(c[ba>>2]|0)+(c[w>>2]<<3)>>3];else ia=1.0e-15;h[Q>>3]=ia;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break;e=_(c[v>>2]|0,c[l>>2]|0)|0;f=_(c[w>>2]|0,c[l>>2]|0)|0;fa=+h[(c[aa>>2]|0)+(c[w>>2]<<3)>>3]*+h[G>>3]*(+h[(c[q>>2]|0)+(e+(c[x>>2]|0)<<3)>>3]-+h[(c[$>>2]|0)+(f+(c[x>>2]|0)<<3)>>3]);ga=+h[Q>>3];if(+h[y>>3]==-1.0){f=(c[N>>2]|0)+(c[x>>2]<<3)|0;h[f>>3]=+h[f>>3]+fa/(ga*+h[Q>>3])}else{ha=fa/+P(+ga,+(1.0-+h[y>>3]));f=(c[N>>2]|0)+(c[x>>2]<<3)|0;h[f>>3]=+h[f>>3]+ha}c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=(c[w>>2]|0)+1}}while(0);h[R>>3]=0.0;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break;h[R>>3]=+h[R>>3]+ +h[(c[N>>2]|0)+(c[x>>2]<<3)>>3]*+h[(c[N>>2]|0)+(c[x>>2]<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}h[R>>3]=+O(+(+h[R>>3]));h[S>>3]=+h[S>>3]+ +h[R>>3];h:do if(+h[R>>3]>0.0){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break h;f=(c[N>>2]|0)+(c[x>>2]<<3)|0;h[f>>3]=+h[f>>3]/+h[R>>3];c[x>>2]=(c[x>>2]|0)+1}}while(0);c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[l>>2]|0))break;f=_(c[v>>2]|0,c[l>>2]|0)|0;e=(c[q>>2]|0)+(f+(c[x>>2]|0)<<3)|0;h[e>>3]=+h[e>>3]+ +h[F>>3]*+h[(c[N>>2]|0)+(c[x>>2]<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}c[v>>2]=(c[v>>2]|0)+1}if(c[W>>2]|0)Bv(c[W>>2]|0);h[ca>>3]=+h[ca>>3]/+(c[u>>2]|0);h[F>>3]=+Jp(c[V>>2]|0,+h[F>>3],+h[S>>3],+h[T>>3],+h[E>>3]);if(!(+h[F>>3]>+h[C>>3]))break}while(+(c[U>>2]|0)<+h[D>>3]);if(c[(c[o>>2]|0)+112>>2]|0)Kp(c[l>>2]|0,c[s>>2]|0,c[q>>2]|0)}else c[c[r>>2]>>2]=-100;while(0);if(c[M>>2]|0)O4(c[M>>2]|0);if((c[s>>2]|0)!=(c[m>>2]|0))Lv(c[s>>2]|0);if(c[N>>2]|0)O4(c[N>>2]|0);if(c[$>>2]|0)O4(c[$>>2]|0);if(c[aa>>2]|0)O4(c[aa>>2]|0);if(!(c[ba>>2]|0)){i=k;return}O4(c[ba>>2]|0);i=k;return}function Fp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+64|0;f=e+52|0;g=e+48|0;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e+20|0;q=e+8|0;r=e;s=e+16|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[n>>2]=c[(c[g>>2]|0)+20>>2];c[o>>2]=c[(c[g>>2]|0)+24>>2];h[q>>3]=.5;c[s>>2]=cK(c[f>>2]<<3)|0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[c[g>>2]>>2]|0))break;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[f>>2]|0))break;h[(c[s>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[m>>2]=(c[m>>2]|0)+1}c[p>>2]=0;c[l>>2]=c[(c[n>>2]|0)+(c[k>>2]<<2)>>2];while(1){if((c[l>>2]|0)>=(c[(c[n>>2]|0)+((c[k>>2]|0)+1<<2)>>2]|0))break;a:do if((c[(c[o>>2]|0)+(c[l>>2]<<2)>>2]|0)!=(c[k>>2]|0)){c[p>>2]=(c[p>>2]|0)+1;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[f>>2]|0))break a;d=_(c[(c[o>>2]|0)+(c[l>>2]<<2)>>2]|0,c[f>>2]|0)|0;b=(c[s>>2]|0)+(c[m>>2]<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[j>>2]|0)+(d+(c[m>>2]|0)<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}}while(0);c[l>>2]=(c[l>>2]|0)+1}b:do if((c[p>>2]|0)>0){h[r>>3]=(1.0-+h[q>>3])/+(c[p>>2]|0);c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[f>>2]|0))break b;d=_(c[k>>2]|0,c[f>>2]|0)|0;b=_(c[k>>2]|0,c[f>>2]|0)|0;h[(c[j>>2]|0)+(b+(c[m>>2]|0)<<3)>>3]=+h[q>>3]*+h[(c[j>>2]|0)+(d+(c[m>>2]|0)<<3)>>3]+ +h[r>>3]*+h[(c[s>>2]|0)+(c[m>>2]<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}}while(0);c[k>>2]=(c[k>>2]|0)+1}O4(c[s>>2]|0);i=e;return}function Gp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+48|0;d=b+36|0;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[d>>2]=a;c[g>>2]=0;c[j>>2]=c[(c[d>>2]|0)+20>>2];c[k>>2]=c[(c[d>>2]|0)+24>>2];c[n>>2]=0;c[f>>2]=c[c[d>>2]>>2];c[e>>2]=cK((c[f>>2]|0)+1<<2)|0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=((c[f>>2]|0)+1|0))break;c[(c[e>>2]|0)+(c[h>>2]<<2)>>2]=0;c[h>>2]=(c[h>>2]|0)+1}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[f>>2]|0))break;c[m>>2]=0;c[l>>2]=c[(c[j>>2]|0)+(c[h>>2]<<2)>>2];while(1){if((c[l>>2]|0)>=(c[(c[j>>2]|0)+((c[h>>2]|0)+1<<2)>>2]|0))break;if((c[h>>2]|0)!=(c[(c[k>>2]|0)+(c[l>>2]<<2)>>2]|0))c[m>>2]=(c[m>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1}d=(c[e>>2]|0)+(c[m>>2]<<2)|0;c[d>>2]=(c[d>>2]|0)+1;if((c[g>>2]|0)>(c[(c[e>>2]|0)+(c[m>>2]<<2)>>2]|0))o=c[g>>2]|0;else o=c[(c[e>>2]|0)+(c[m>>2]<<2)>>2]|0;c[g>>2]=o;c[h>>2]=(c[h>>2]|0)+1}if(!(+(c[(c[e>>2]|0)+4>>2]|0)>+(c[g>>2]|0)*.8)){p=c[e>>2]|0;O4(p);q=c[n>>2]|0;i=b;return q|0}if(!(+(c[(c[e>>2]|0)+4>>2]|0)>+(c[f>>2]|0)*.3)){p=c[e>>2]|0;O4(p);q=c[n>>2]|0;i=b;return q|0}c[n>>2]=1;p=c[e>>2]|0;O4(p);q=c[n>>2]|0;i=b;return q|0}function Hp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0;e=i;i=i+112|0;f=e+108|0;g=e+104|0;j=e+100|0;k=e+96|0;l=e+92|0;m=e+88|0;n=e+56|0;o=e+40|0;p=e+24|0;q=e+16|0;r=e+8|0;s=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(_(c[g>>2]|0,c[g>>2]|0)|0))break;h[n+(c[k>>2]<<3)>>3]=0.0;c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[g>>2]|0))break;h[p+(c[k>>2]<<3)>>3]=0.0;c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;c[l>>2]=0;while(1){t=c[k>>2]|0;if((c[l>>2]|0)>=(c[g>>2]|0))break;d=_(t,c[g>>2]|0)|0;b=p+(c[l>>2]<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[j>>2]|0)+(d+(c[l>>2]|0)<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=t+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[g>>2]|0))break;t=p+(c[k>>2]<<3)|0;h[t>>3]=+h[t>>3]/+(c[f>>2]|0);c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[g>>2]|0))break;t=_(c[g>>2]|0,c[k>>2]|0)|0;d=_(c[g>>2]|0,c[k>>2]|0)|0;h[(c[j>>2]|0)+(d+(c[l>>2]|0)<<3)>>3]=+h[(c[j>>2]|0)+(t+(c[l>>2]|0)<<3)>>3]-+h[p+(c[l>>2]<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[g>>2]|0))break;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;p=_(c[k>>2]|0,c[g>>2]|0)|0;t=_(c[k>>2]|0,c[g>>2]|0)|0;d=_(c[g>>2]|0,c[l>>2]|0)|0;b=n+(d+(c[m>>2]|0)<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[j>>2]|0)+(p+(c[l>>2]|0)<<3)>>3]*+h[(c[j>>2]|0)+(t+(c[m>>2]|0)<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}if(+h[n+8>>3]==0.0){h[o>>3]=0.0;h[o+8>>3]=1.0}else{u=-(-+h[n>>3]+ +h[n+24>>3]-+O(+(+h[n>>3]*+h[n>>3]+ +h[n+8>>3]*4.0*+h[n+8>>3]-+h[n>>3]*2.0*+h[n+24>>3]+ +h[n+24>>3]*+h[n+24>>3])));h[o>>3]=u/(+h[n+8>>3]*2.0);h[o+8>>3]=1.0}h[q>>3]=+O(+(+h[o>>3]*+h[o>>3]+1.0));h[o>>3]=+h[o>>3]/+h[q>>3];h[o+8>>3]=+h[o+8>>3]/+h[q>>3];c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;q=_(c[g>>2]|0,c[k>>2]|0)|0;n=(_(c[g>>2]|0,c[k>>2]|0)|0)+1|0;h[r>>3]=+h[(c[j>>2]|0)+(q<<3)>>3]*+h[o>>3]+ +h[(c[j>>2]|0)+(n<<3)>>3]*+h[o+8>>3];n=_(c[g>>2]|0,c[k>>2]|0)|0;q=(_(c[g>>2]|0,c[k>>2]|0)|0)+1|0;h[s>>3]=-+h[(c[j>>2]|0)+(n<<3)>>3]*+h[o+8>>3]+ +h[(c[j>>2]|0)+(q<<3)>>3]*+h[o>>3];q=_(c[g>>2]|0,c[k>>2]|0)|0;h[(c[j>>2]|0)+(q<<3)>>3]=+h[r>>3];q=(_(c[g>>2]|0,c[k>>2]|0)|0)+1|0;h[(c[j>>2]|0)+(q<<3)>>3]=+h[s>>3];c[k>>2]=(c[k>>2]|0)+1}i=e;return}function Ip(a,b,d,e,f,g,h,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;i=i+48|0;n=m+36|0;o=m+32|0;p=m+28|0;q=m+24|0;r=m+20|0;s=m+16|0;t=m+12|0;u=m+8|0;v=m+4|0;w=m;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;c[t>>2]=h;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;Np(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0);i=m;return}function Jp(a,b,d,e,f){a=a|0;b=+b;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;g=i;i=i+48|0;j=g+32|0;k=g+40|0;l=g+24|0;m=g+16|0;n=g+8|0;o=g;c[k>>2]=a;h[l>>3]=b;h[m>>3]=d;h[n>>3]=e;h[o>>3]=f;if(!(c[k>>2]|0)){h[j>>3]=+h[o>>3]*+h[l>>3];p=+h[j>>3];i=g;return +p}if(!(+h[m>>3]>=+h[n>>3])){if(!(+h[m>>3]>+h[n>>3]*.95))h[l>>3]=+h[l>>3]*.99/+h[o>>3]}else h[l>>3]=+h[o>>3]*+h[l>>3];h[j>>3]=+h[l>>3];p=+h[j>>3];i=g;return +p}function Kp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0;e=i;i=i+128|0;f=e+112|0;g=e+108|0;j=e+104|0;k=e+100|0;l=e+96|0;m=e+92|0;n=e+88|0;o=e+84|0;p=e+80|0;q=e+76|0;r=e+72|0;s=e+40|0;t=e+68|0;u=e+64|0;v=e+60|0;w=e+32|0;x=e+24|0;y=e+16|0;z=e+8|0;A=e;B=e+56|0;C=e+52|0;D=e+48|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[c[g>>2]>>2];c[n>>2]=c[(c[g>>2]|0)+20>>2];c[o>>2]=c[(c[g>>2]|0)+24>>2];c[u>>2]=10;h[x>>3]=0.0;h[y>>3]=0.0;c[C>>2]=10;c[q>>2]=cK(c[k>>2]<<2)|0;c[v>>2]=cK(c[C>>2]<<3)|0;c[B>>2]=cK(c[u>>2]<<2)|0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[k>>2]|0))break;c[(c[q>>2]|0)+(c[l>>2]<<2)>>2]=0;c[l>>2]=(c[l>>2]|0)+1}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[k>>2]|0))break;a:do if((((c[(c[n>>2]|0)+((c[l>>2]|0)+1<<2)>>2]|0)-(c[(c[n>>2]|0)+(c[l>>2]<<2)>>2]|0)|0)==1?(c[(c[q>>2]|0)+(c[l>>2]<<2)>>2]|0)==0:0)?(c[r>>2]=c[(c[o>>2]|0)+(c[(c[n>>2]|0)+(c[l>>2]<<2)>>2]<<2)>>2],(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0)==0):0){c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=1;h[s>>3]=0.0;c[t>>2]=0;c[D>>2]=0;c[m>>2]=c[(c[n>>2]|0)+(c[r>>2]<<2)>>2];while(1){if((c[m>>2]|0)>=(c[(c[n>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;if(((c[(c[n>>2]|0)+((c[(c[o>>2]|0)+(c[m>>2]<<2)>>2]|0)+1<<2)>>2]|0)-(c[(c[n>>2]|0)+(c[(c[o>>2]|0)+(c[m>>2]<<2)>>2]<<2)>>2]|0)|0)==1){c[(c[q>>2]|0)+(c[(c[o>>2]|0)+(c[m>>2]<<2)>>2]<<2)>>2]=1;xp(B,c[t>>2]|0,u);E=+zw(c[j>>2]|0,c[f>>2]|0,c[r>>2]|0,c[(c[o>>2]|0)+(c[m>>2]<<2)>>2]|0);h[s>>3]=+h[s>>3]+E;c[(c[B>>2]|0)+(c[t>>2]<<2)>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];c[t>>2]=(c[t>>2]|0)+1}else{wp(v,c[D>>2]|0,C);E=+yp(c[j>>2]|0,c[f>>2]|0,c[r>>2]|0,c[(c[o>>2]|0)+(c[m>>2]<<2)>>2]|0);g=c[D>>2]|0;c[D>>2]=g+1;h[(c[v>>2]|0)+(g<<3)>>3]=E}c[m>>2]=(c[m>>2]|0)+1}h[s>>3]=+h[s>>3]/+(c[t>>2]|0);if((c[D>>2]|0)>0){Sp(c[D>>2]|0,c[v>>2]|0);h[w>>3]=0.0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=((c[D>>2]|0)-1|0))break;if(+h[(c[v>>2]|0)+((c[p>>2]|0)+1<<3)>>3]-+h[(c[v>>2]|0)+(c[p>>2]<<3)>>3]>+h[w>>3]){h[w>>3]=+h[(c[v>>2]|0)+((c[p>>2]|0)+1<<3)>>3]-+h[(c[v>>2]|0)+(c[p>>2]<<3)>>3];h[x>>3]=+h[(c[v>>2]|0)+(c[p>>2]<<3)>>3];h[y>>3]=+h[(c[v>>2]|0)+((c[p>>2]|0)+1<<3)>>3]}c[p>>2]=(c[p>>2]|0)+1}if(+h[c[v>>2]>>3]+6.283185307179586-+h[(c[v>>2]|0)+((c[D>>2]|0)-1<<3)>>3]>+h[w>>3]){h[w>>3]=+h[c[v>>2]>>3]+6.283185307179586-+h[(c[v>>2]|0)+((c[D>>2]|0)-1<<3)>>3];h[x>>3]=+h[(c[v>>2]|0)+((c[D>>2]|0)-1<<3)>>3];h[y>>3]=+h[c[v>>2]>>3]+6.283185307179586}}else{h[x>>3]=0.0;h[y>>3]=6.283185307179586;h[w>>3]=6.283185307179586}if(+h[w>>3]-+((c[t>>2]|0)-1|0)*.52359982279585>0.0)F=+h[w>>3]-+((c[t>>2]|0)-1|0)*.52359982279585;else F=0.0;h[z>>3]=F*.5;h[x>>3]=+h[x>>3]+ +h[z>>3]*.95;h[y>>3]=+h[y>>3]-+h[z>>3]*.95;h[x>>3]=0.0;h[y>>3]=6.283185307179586;h[w>>3]=6.283185307179586;h[A>>3]=0.0;if((c[t>>2]|0)>1)h[A>>3]=(+h[y>>3]-+h[x>>3])/+((c[t>>2]|0)-1|0);c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[t>>2]|0))break a;Tp(c[j>>2]|0,c[f>>2]|0,+h[s>>3],+h[x>>3],c[r>>2]|0,c[(c[B>>2]|0)+(c[l>>2]<<2)>>2]|0);h[x>>3]=+h[x>>3]+ +h[A>>3];c[l>>2]=(c[l>>2]|0)+1}}while(0);c[l>>2]=(c[l>>2]|0)+1}O4(c[q>>2]|0);O4(c[v>>2]|0);O4(c[B>>2]|0);i=e;return}function Lp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;f=i;i=i+48|0;g=f+8|0;j=f+36|0;k=f+32|0;l=f+24|0;m=f;n=f+20|0;o=f+16|0;c[j>>2]=a;c[k>>2]=b;c[f+28>>2]=d;c[l>>2]=e;h[m>>3]=0.0;if(!(c[l>>2]|0)){h[g>>3]=1.0;p=+h[g>>3];i=f;return +p}c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[j>>2]|0))break;c[o>>2]=c[(c[k>>2]|0)+(c[n>>2]<<2)>>2];while(1){if((c[o>>2]|0)>=(c[(c[k>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0))break;h[m>>3]=+h[m>>3]+ +h[(c[l>>2]|0)+(c[o>>2]<<3)>>3];c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+1}h[g>>3]=+h[m>>3]/+(c[(c[k>>2]|0)+(c[j>>2]<<2)>>2]|0);p=+h[g>>3];i=f;return +p}function Mp(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;k=i;i=i+112|0;l=k+56|0;m=k+96|0;n=k+92|0;o=k+88|0;p=k+84|0;q=k+80|0;r=k+76|0;s=k+48|0;t=k+72|0;u=k+68|0;v=k+64|0;w=k+40|0;x=k+32|0;y=k+24|0;z=k+16|0;A=k+8|0;B=k;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;h[s>>3]=j;h[y>>3]=0.0;h[z>>3]=0.0;h[A>>3]=0.0;h[B>>3]=0.0;if(+h[s>>3]==0.0){i=k;return}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[m>>2]|0))break;c[u>>2]=c[(c[p>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[p>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;if((c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]|0)!=(c[t>>2]|0)){h[x>>3]=+yw(c[o>>2]|0,c[n>>2]|0,c[t>>2]|0,c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]|0);if(c[r>>2]|0)h[s>>3]=+h[(c[r>>2]|0)+(c[u>>2]<<3)>>3];h[w>>3]=1.0/(+h[s>>3]*+h[s>>3]);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break;h[z>>3]=+h[z>>3]+ +h[w>>3]*+h[s>>3]*+h[x>>3];h[A>>3]=+h[A>>3]+ +h[w>>3]*+h[x>>3]*+h[x>>3];c[v>>2]=(c[v>>2]|0)+1}h[y>>3]=+h[y>>3]+ +h[x>>3];h[B>>3]=+h[B>>3]+1.0}c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}h[y>>3]=+h[z>>3]/+h[A>>3];c[t>>2]=0;while(1){if((c[t>>2]|0)>=(_(c[m>>2]|0,c[n>>2]|0)|0))break;A=(c[o>>2]|0)+(c[t>>2]<<3)|0;h[A>>3]=+h[A>>3]*+h[y>>3];c[t>>2]=(c[t>>2]|0)+1}t=c[24742]|0;h[l>>3]=+h[y>>3];Y2(t,129810,l)|0;i=k;return}function Np(b,e,f,g,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;p=i;i=i+288|0;q=p+184|0;r=p+176|0;s=p+276|0;t=p+272|0;u=p+268|0;v=p+264|0;w=p+260|0;x=p+256|0;y=p+252|0;z=p+248|0;A=p+244|0;B=p+240|0;C=p+236|0;D=p+232|0;E=p+228|0;F=p+224|0;G=p+220|0;H=p+216|0;I=p+212|0;J=p+208|0;K=p+204|0;L=p+200|0;M=p+196|0;N=p+8|0;O=p+192|0;P=p+188|0;Q=p;c[s>>2]=b;c[t>>2]=e;c[u>>2]=f;c[v>>2]=g;c[w>>2]=j;c[x>>2]=k;c[y>>2]=l;c[z>>2]=m;c[A>>2]=n;c[B>>2]=o;c[C>>2]=0;c[G>>2]=c[t>>2];c[H>>2]=c[u>>2];c[I>>2]=0;c[L>>2]=0;c[M>>2]=0;Z4(N|0,c[v>>2]|0,168)|0;c[c[B>>2]>>2]=0;if(!(c[G>>2]|0)){i=p;return}c[D>>2]=c[(c[G>>2]|0)+4>>2];if((c[D>>2]|0)<=0|(c[s>>2]|0)<=0){i=p;return}if((Ov(c[G>>2]|0,0)|0)!=0?(c[(c[G>>2]|0)+16>>2]|0)==1:0){if((c[(c[v>>2]|0)+136>>2]|0)==1)c[H>>2]=Sv(c[H>>2]|0)|0;c[G>>2]=Sv(c[G>>2]|0)|0}else R=5;do if((R|0)==5){o=c[G>>2]|0;if((c[(c[v>>2]|0)+136>>2]|0)==1){c[G>>2]=Rv(o,0)|0;c[H>>2]=Rv(c[H>>2]|0,0)|0;break}else{c[G>>2]=bw(o)|0;break}}while(0);if((c[(c[v>>2]|0)+160>>2]|0)==3){if((c[z>>2]|0)>0)R=14}else if((c[z>>2]|0)>0?(c[(c[v>>2]|0)+160>>2]|0)==4:0)R=14;if((R|0)==14){c[P>>2]=cK(_(c[c[G>>2]>>2]<<3,c[s>>2]|0)|0)|0;c[O>>2]=Op(c[G>>2]|0,c[z>>2]|0,c[A>>2]|0)|0;Ip(c[s>>2]|0,c[O>>2]|0,0,c[v>>2]|0,0,0,c[P>>2]|0,0,0,c[B>>2]|0);Pp(c[s>>2]|0,c[G>>2]|0,c[z>>2]|0,c[A>>2]|0,c[y>>2]|0,c[P>>2]|0);Gt(c[s>>2]|0,c[G>>2]|0,c[y>>2]|0,c[x>>2]|0,c[(c[v>>2]|0)+124>>2]|0,+h[(c[v>>2]|0)+144>>3],c[(c[v>>2]|0)+160>>2]|0,c[z>>2]|0,c[A>>2]|0);Lv(c[O>>2]|0);O4(c[P>>2]|0);if((c[G>>2]|0)==(c[t>>2]|0)){i=p;return}Lv(c[G>>2]|0);i=p;return}c[C>>2]=Gw(c[(c[v>>2]|0)+44>>2]|0,c[(c[v>>2]|0)+48>>2]|0)|0;c[(c[C>>2]|0)+16>>2]=c[(c[v>>2]|0)+40>>2];c[K>>2]=Nw(c[G>>2]|0,c[H>>2]|0,c[w>>2]|0,c[C>>2]|0)|0;c[J>>2]=Ow(c[K>>2]|0)|0;if(c[(c[J>>2]|0)+32>>2]|0)c[L>>2]=cK(_(c[(c[J>>2]|0)+4>>2]<<3,c[s>>2]|0)|0)|0;else c[L>>2]=c[y>>2];c[E>>2]=Gp(c[G>>2]|0)|0;if(+h[c[v>>2]>>3]==-1.0001234?(h[c[v>>2]>>3]=-1.0,(c[E>>2]|0)!=0):0)h[c[v>>2]>>3]=-1.8;while(1){E=c[v>>2]|0;a:do if(c[(c[v>>2]|0)+136>>2]|0){if((c[E+136>>2]|0)==1){h[Q>>3]=.05;h[(c[v>>2]|0)+96>>3]=1.0;c[(c[v>>2]|0)+104>>2]=1;P=(c[v>>2]|0)+80|0;if(c[(c[J>>2]|0)+28>>2]|0)c[P>>2]=100;else{c[P>>2]=500;h[Q>>3]=.5}P=(c[(c[J>>2]|0)+32>>2]|0)!=0;Dp(c[s>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[(c[J>>2]|0)+12>>2]|0,c[v>>2]|0,c[(c[J>>2]|0)+24>>2]|0,c[L>>2]|0,+h[Q>>3],c[B>>2]|0);if(!P){c[(c[v>>2]|0)+16>>2]=0;h[(c[v>>2]|0)+96>>3]=.05;c[(c[v>>2]|0)+104>>2]=0;Dp(c[s>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[(c[J>>2]|0)+12>>2]|0,c[v>>2]|0,c[(c[J>>2]|0)+24>>2]|0,c[L>>2]|0,+h[Q>>3]/2.0,c[B>>2]|0);Dp(c[s>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[(c[J>>2]|0)+12>>2]|0,c[v>>2]|0,c[(c[J>>2]|0)+24>>2]|0,c[L>>2]|0,+h[Q>>3]/8.0,c[B>>2]|0);Dp(c[s>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[(c[J>>2]|0)+12>>2]|0,c[v>>2]|0,c[(c[J>>2]|0)+24>>2]|0,c[L>>2]|0,+h[Q>>3]/32.0,c[B>>2]|0)}}}else{if(!(c[E+132>>2]|0)){Bp(c[s>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[v>>2]|0,c[(c[J>>2]|0)+24>>2]|0,c[L>>2]|0,c[B>>2]|0);break}do if((c[(c[v>>2]|0)+132>>2]|0)!=2){if((c[(c[v>>2]|0)+132>>2]|0)==3?(c[c[(c[J>>2]|0)+8>>2]>>2]|0)>1e4:0)break;Cp(c[s>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[v>>2]|0,c[(c[J>>2]|0)+24>>2]|0,c[L>>2]|0,c[B>>2]|0);break a}while(0);if(((c[(c[v>>2]|0)+132>>2]|0)==3?(c[c[(c[J>>2]|0)+8>>2]>>2]|0)>10:0)?(d[138998]|0)!=0:0){P=c[24742]|0;c[r>>2]=1e4;Y2(P,129711,r)|0}Ap(c[s>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[v>>2]|0,c[(c[J>>2]|0)+24>>2]|0,c[L>>2]|0,c[B>>2]|0)}while(0);if(!(c[(c[J>>2]|0)+32>>2]|0)){R=51;break}if(c[c[B>>2]>>2]|0){R=42;break}c[I>>2]=c[(c[J>>2]|0)+16>>2];c[F>>2]=c[(c[J>>2]|0)+40>>2];c[J>>2]=c[(c[J>>2]|0)+32>>2];if(c[(c[J>>2]|0)+32>>2]|0)c[M>>2]=cK(_(c[(c[J>>2]|0)+4>>2]<<3,c[s>>2]|0)|0)|0;else c[M>>2]=c[y>>2];Qp(c[s>>2]|0,c[(c[J>>2]|0)+8>>2]|0,c[I>>2]|0,c[(c[J>>2]|0)+20>>2]|0,c[L>>2]|0,c[M>>2]|0,c[F>>2]|0,+h[(c[v>>2]|0)+24>>3]*.001);O4(c[L>>2]|0);c[L>>2]=c[M>>2];c[(c[v>>2]|0)+16>>2]=0;h[(c[v>>2]|0)+24>>3]=+h[(c[v>>2]|0)+24>>3]*.75;c[(c[v>>2]|0)+104>>2]=0;if((c[(c[(c[J>>2]|0)+28>>2]|0)+40>>2]|0)>8?(c[(c[(c[J>>2]|0)+28>>2]|0)+40>>2]|0)<11:0)h[(c[v>>2]|0)+96>>3]=1.0;else h[(c[v>>2]|0)+96>>3]=.1;if(!(c[J>>2]|0)){R=51;break}}if((R|0)==42)O4(c[L>>2]|0);else if((R|0)==51){sx(c[s>>2]|0,c[G>>2]|0,c[v>>2]|0,c[w>>2]|0,c[y>>2]|0,c[B>>2]|0);if(a[138998]|0){B=c[24742]|0;c[q>>2]=c[(c[v>>2]|0)+124>>2];Y2(B,129774,q)|0}if((c[s>>2]|0)==2)Hp(c[D>>2]|0,c[s>>2]|0,c[y>>2]|0);if(+h[(c[v>>2]|0)+152>>3]!=0.0)Rp(c[D>>2]|0,c[s>>2]|0,c[y>>2]|0,+h[(c[v>>2]|0)+152>>3]);Gt(c[s>>2]|0,c[G>>2]|0,c[y>>2]|0,c[x>>2]|0,c[(c[v>>2]|0)+124>>2]|0,+h[(c[v>>2]|0)+144>>3],c[(c[v>>2]|0)+160>>2]|0,c[z>>2]|0,c[A>>2]|0)}Z4(c[v>>2]|0,N|0,168)|0;if((c[G>>2]|0)!=(c[t>>2]|0))Lv(c[G>>2]|0);if((c[H>>2]|0)!=0?(c[H>>2]|0)!=(c[u>>2]|0):0)Lv(c[H>>2]|0);Hw(c[C>>2]|0);Iw(c[K>>2]|0);i=p;return}function Op(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+80|0;f=e+8|0;g=e;h=e+72|0;j=e+68|0;k=e+64|0;l=e+60|0;m=e+56|0;n=e+52|0;o=e+48|0;p=e+44|0;q=e+40|0;r=e+36|0;s=e+32|0;t=e+28|0;u=e+24|0;v=e+20|0;w=e+16|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[n>>2]=0;c[s>>2]=c[(c[h>>2]|0)+20>>2];c[t>>2]=c[(c[h>>2]|0)+24>>2];c[u>>2]=0;c[v>>2]=0;c[l>>2]=cK(c[c[h>>2]>>2]<<2)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[h>>2]>>2]|0))break;c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=1;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;c[(c[l>>2]|0)+(c[(c[k>>2]|0)+(c[m>>2]<<2)>>2]<<2)>>2]=-1;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[h>>2]>>2]|0))break;if((c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]|0)>0){k=c[n>>2]|0;c[n>>2]=k+1;c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=k}c[m>>2]=(c[m>>2]|0)+1}c[o>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[h>>2]>>2]|0))break;a:do if((c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]|0)>=0){c[p>>2]=c[(c[s>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[s>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break a;b:do if((c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2]|0)>=0)c[o>>2]=(c[o>>2]|0)+1;else{c[r>>2]=c[(c[t>>2]|0)+(c[p>>2]<<2)>>2];c[q>>2]=c[(c[s>>2]|0)+(c[r>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[s>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break b;if((c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]|0)!=(c[m>>2]|0)?(c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)>=0:0)c[o>>2]=(c[o>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1}}while(0);c[p>>2]=(c[p>>2]|0)+1}}while(0);c[m>>2]=(c[m>>2]|0)+1}if((c[o>>2]|0)>0){c[u>>2]=cK(c[o>>2]<<2)|0;c[v>>2]=cK(c[o>>2]<<2)|0}c[o>>2]=0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[c[h>>2]>>2]|0))break;c:do if((c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]|0)>=0){c[p>>2]=c[(c[s>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[s>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break c;d:do if((c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2]|0)>=0){c[(c[u>>2]|0)+(c[o>>2]<<2)>>2]=c[(c[l>>2]|0)+(c[m>>2]<<2)>>2];k=c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2]|0;j=c[o>>2]|0;c[o>>2]=j+1;c[(c[v>>2]|0)+(j<<2)>>2]=k;if((c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]|0)!=68?(c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2]|0)!=68:0)break;k=c[24742]|0;j=c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2]|0;c[g>>2]=c[(c[l>>2]|0)+(c[m>>2]<<2)>>2];c[g+4>>2]=j;Y2(k,129792,g)|0;c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]}else{c[r>>2]=c[(c[t>>2]|0)+(c[p>>2]<<2)>>2];c[q>>2]=c[(c[s>>2]|0)+(c[r>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[s>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break d;do if((c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]|0)!=(c[m>>2]|0)?(c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)>=0:0){c[(c[u>>2]|0)+(c[o>>2]<<2)>>2]=c[(c[l>>2]|0)+(c[m>>2]<<2)>>2];k=c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0;j=c[o>>2]|0;c[o>>2]=j+1;c[(c[v>>2]|0)+(j<<2)>>2]=k;if((c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]|0)!=68?(c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)!=68:0)break;k=c[24742]|0;j=c[(c[l>>2]|0)+(c[(c[t>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0;c[f>>2]=c[(c[l>>2]|0)+(c[m>>2]<<2)>>2];c[f+4>>2]=j;Y2(k,129803,f)|0;c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]=c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]}while(0);c[q>>2]=(c[q>>2]|0)+1}}while(0);c[p>>2]=(c[p>>2]|0)+1}}while(0);c[m>>2]=(c[m>>2]|0)+1}c[w>>2]=Vv(c[o>>2]|0,c[n>>2]|0,c[n>>2]|0,c[u>>2]|0,c[v>>2]|0,0,8,8)|0;O4(c[u>>2]|0);O4(c[v>>2]|0);O4(c[l>>2]|0);i=e;return c[w>>2]|0}
function Cv(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;g=i;i=i+32|0;j=g+28|0;k=g+24|0;l=g;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;c[j>>2]=a;c[k>>2]=b;h[l>>3]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=zv(c[j>>2]|0,c[k>>2]|0,+h[l>>3],c[m>>2]|0)|0;c[k>>2]=c[(c[o>>2]|0)+20>>2];c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[j>>2]|0))break;d=+h[l>>3];m=(c[k>>2]|0)+(c[p>>2]<<3)|0;q=+h[m>>3];if(!((c[n>>2]|0)%2|0))h[m>>3]=q-d;else h[m>>3]=q+d;c[n>>2]=((c[n>>2]|0)-((c[n>>2]|0)%2|0)|0)/2|0;c[p>>2]=(c[p>>2]|0)+1}i=g;return c[o>>2]|0}function Dv(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;l=i;i=i+160|0;m=l+144|0;n=l+140|0;o=l+136|0;p=l+132|0;q=l+64|0;r=l+56|0;s=l+48|0;t=l+128|0;u=l+124|0;v=l+120|0;w=l+116|0;x=l+112|0;y=l+40|0;z=l+32|0;A=l+24|0;B=l+16|0;C=l+108|0;D=l+104|0;E=l+8|0;F=l;G=l+100|0;H=l+96|0;I=l+92|0;J=l+88|0;K=l+84|0;L=l+80|0;M=l+76|0;N=l+72|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;h[q>>3]=f;h[r>>3]=g;h[s>>3]=j;c[t>>2]=k;if(!((c[m>>2]|0)!=0&(c[n>>2]|0)!=0)){i=l;return}if((c[c[m>>2]>>2]|0)<=0)La(132101,131933,175,132126);if((c[c[n>>2]>>2]|0)<=0)La(132101,131933,175,132126);c[G>>2]=c[(c[m>>2]|0)+16>>2];c[u>>2]=c[(c[m>>2]|0)+40>>2];c[v>>2]=c[(c[n>>2]|0)+40>>2];h[y>>3]=+Aw(c[(c[m>>2]|0)+32>>2]|0,c[(c[n>>2]|0)+32>>2]|0,c[G>>2]|0);if(+h[(c[m>>2]|0)+24>>3]+ +h[(c[n>>2]|0)+24>>3]<+h[q>>3]*+h[y>>3]){k=c[t>>2]|0;h[k>>3]=+h[k>>3]+1.0;c[w>>2]=c[(c[m>>2]|0)+32>>2];h[E>>3]=+h[(c[m>>2]|0)+8>>3];c[C>>2]=Iv(c[m>>2]|0,c[G>>2]|0)|0;c[x>>2]=c[(c[n>>2]|0)+32>>2];h[F>>3]=+h[(c[n>>2]|0)+8>>3];c[D>>2]=Iv(c[n>>2]|0,c[G>>2]|0)|0;if(!(+h[y>>3]>0.0))La(132160,131933,191,132126);c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[G>>2]|0))break;j=+h[E>>3]*+h[F>>3]*+h[s>>3]*(+h[(c[w>>2]|0)+(c[L>>2]<<3)>>3]-+h[(c[x>>2]|0)+(c[L>>2]<<3)>>3]);g=+h[y>>3];if(+h[r>>3]==-1.0)h[B>>3]=j/(g*+h[y>>3]);else h[B>>3]=j/+P(+g,+(1.0-+h[r>>3]));k=(c[C>>2]|0)+(c[L>>2]<<3)|0;h[k>>3]=+h[k>>3]+ +h[B>>3];k=(c[D>>2]|0)+(c[L>>2]<<3)|0;h[k>>3]=+h[k>>3]-+h[B>>3];c[L>>2]=(c[L>>2]|0)+1}i=l;return}if((c[u>>2]|0)!=0&(c[v>>2]|0)!=0){while(1){if(!(c[u>>2]|0))break;c[w>>2]=sv(ry(c[u>>2]|0)|0)|0;h[z>>3]=+rv(ry(c[u>>2]|0)|0);c[J>>2]=tv(ry(c[u>>2]|0)|0)|0;c[C>>2]=Jv(c[p>>2]|0,c[J>>2]|0,c[u>>2]|0,c[G>>2]|0)|0;c[v>>2]=c[(c[n>>2]|0)+40>>2];while(1){if(!(c[v>>2]|0))break;c[x>>2]=sv(ry(c[v>>2]|0)|0)|0;h[A>>3]=+rv(ry(c[v>>2]|0)|0);c[K>>2]=tv(ry(c[v>>2]|0)|0)|0;c[D>>2]=Jv(c[p>>2]|0,c[K>>2]|0,c[v>>2]|0,c[G>>2]|0)|0;if(!((c[m>>2]|0)==(c[n>>2]|0)?(c[K>>2]|0)<(c[J>>2]|0):0))O=20;if((O|0)==20?(O=0,(c[J>>2]|0)!=(c[K>>2]|0)):0){F=(c[t>>2]|0)+8|0;h[F>>3]=+h[F>>3]+1.0;h[y>>3]=+yw(c[o>>2]|0,c[G>>2]|0,c[J>>2]|0,c[K>>2]|0);c[L>>2]=0;while(1){if((c[L>>2]|0)>=(c[G>>2]|0))break;g=+h[z>>3]*+h[A>>3]*+h[s>>3]*(+h[(c[w>>2]|0)+(c[L>>2]<<3)>>3]-+h[(c[x>>2]|0)+(c[L>>2]<<3)>>3]);j=+h[y>>3];if(+h[r>>3]==-1.0)h[B>>3]=g/(j*+h[y>>3]);else h[B>>3]=g/+P(+j,+(1.0-+h[r>>3]));F=(c[C>>2]|0)+(c[L>>2]<<3)|0;h[F>>3]=+h[F>>3]+ +h[B>>3];F=(c[D>>2]|0)+(c[L>>2]<<3)|0;h[F>>3]=+h[F>>3]-+h[B>>3];c[L>>2]=(c[L>>2]|0)+1}c[v>>2]=sy(c[v>>2]|0)|0;continue}c[v>>2]=sy(c[v>>2]|0)|0}c[u>>2]=sy(c[u>>2]|0)|0}i=l;return}if((c[m>>2]|0)==(c[n>>2]|0)){c[H>>2]=0;while(1){if((c[H>>2]|0)>=(1<<c[G>>2]|0))break;c[M>>2]=c[(c[(c[m>>2]|0)+36>>2]|0)+(c[H>>2]<<2)>>2];c[I>>2]=c[H>>2];while(1){if((c[I>>2]|0)>=(1<<c[G>>2]|0))break;c[N>>2]=c[(c[(c[m>>2]|0)+36>>2]|0)+(c[I>>2]<<2)>>2];Dv(c[M>>2]|0,c[N>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],+h[s>>3],c[t>>2]|0);c[I>>2]=(c[I>>2]|0)+1}c[H>>2]=(c[H>>2]|0)+1}i=l;return}if(!((c[u>>2]|0)!=0?1:!(+h[(c[m>>2]|0)+24>>3]>+h[(c[n>>2]|0)+24>>3]))){c[H>>2]=0;while(1){if((c[H>>2]|0)>=(1<<c[G>>2]|0))break;c[M>>2]=c[(c[(c[m>>2]|0)+36>>2]|0)+(c[H>>2]<<2)>>2];Dv(c[M>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],+h[s>>3],c[t>>2]|0);c[H>>2]=(c[H>>2]|0)+1}i=l;return}if(!((c[v>>2]|0)!=0?1:!(+h[(c[n>>2]|0)+24>>3]>+h[(c[m>>2]|0)+24>>3]))){c[H>>2]=0;while(1){if((c[H>>2]|0)>=(1<<c[G>>2]|0))break;c[M>>2]=c[(c[(c[n>>2]|0)+36>>2]|0)+(c[H>>2]<<2)>>2];Dv(c[M>>2]|0,c[m>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],+h[s>>3],c[t>>2]|0);c[H>>2]=(c[H>>2]|0)+1}i=l;return}if(!(c[u>>2]|0)){c[H>>2]=0;while(1){if((c[H>>2]|0)>=(1<<c[G>>2]|0))break;c[M>>2]=c[(c[(c[m>>2]|0)+36>>2]|0)+(c[H>>2]<<2)>>2];Dv(c[M>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],+h[s>>3],c[t>>2]|0);c[H>>2]=(c[H>>2]|0)+1}i=l;return}if(c[v>>2]|0)La(176099,131933,273,132126);c[H>>2]=0;while(1){if((c[H>>2]|0)>=(1<<c[G>>2]|0))break;c[M>>2]=c[(c[(c[n>>2]|0)+36>>2]|0)+(c[H>>2]<<2)>>2];Dv(c[M>>2]|0,c[m>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],+h[s>>3],c[t>>2]|0);c[H>>2]=(c[H>>2]|0)+1}i=l;return}function Ev(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+64|0;f=e+52|0;g=e+48|0;j=e+44|0;k=e+8|0;l=e;m=e+40|0;n=e+36|0;o=e+32|0;p=e+28|0;q=e+24|0;r=e+20|0;s=e+16|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[o>>2]=c[(c[f>>2]|0)+40>>2];c[r>>2]=c[(c[f>>2]|0)+16>>2];h[k>>3]=+h[(c[f>>2]|0)+8>>3];c[m>>2]=Iv(c[f>>2]|0,c[r>>2]|0)|0;if(!(+h[k>>3]>0.0))La(132046,131933,289,132054);d=(c[j>>2]|0)+16|0;h[d>>3]=+h[d>>3]+1.0;if(c[o>>2]|0){while(1){if(!(c[o>>2]|0))break;c[p>>2]=tv(ry(c[o>>2]|0)|0)|0;c[n>>2]=Jv(c[g>>2]|0,c[p>>2]|0,c[o>>2]|0,c[r>>2]|0)|0;h[l>>3]=+rv(ry(c[o>>2]|0)|0);h[l>>3]=+h[l>>3]/+h[k>>3];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[r>>2]|0))break;d=(c[n>>2]|0)+(c[q>>2]<<3)|0;h[d>>3]=+h[d>>3]+ +h[l>>3]*+h[(c[m>>2]|0)+(c[q>>2]<<3)>>3];c[q>>2]=(c[q>>2]|0)+1}c[o>>2]=sy(c[o>>2]|0)|0}i=e;return}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(1<<c[r>>2]|0)){t=19;break}c[s>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+(c[p>>2]<<2)>>2];if(c[s>>2]|0){if((c[c[s>>2]>>2]|0)<=0){t=13;break}c[n>>2]=Iv(c[s>>2]|0,c[r>>2]|0)|0;h[l>>3]=+h[(c[s>>2]|0)+8>>3];h[l>>3]=+h[l>>3]/+h[k>>3];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[r>>2]|0))break;o=(c[n>>2]|0)+(c[q>>2]<<3)|0;h[o>>3]=+h[o>>3]+ +h[l>>3]*+h[(c[m>>2]|0)+(c[q>>2]<<3)>>3];c[q>>2]=(c[q>>2]|0)+1}Ev(c[s>>2]|0,c[g>>2]|0,c[j>>2]|0)}c[p>>2]=(c[p>>2]|0)+1}if((t|0)==13)La(132090,131933,307,132054);else if((t|0)==19){i=e;return}}function Fv(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;j=g+44|0;k=g+40|0;l=g;m=g+36|0;n=g+32|0;o=g+28|0;p=g+24|0;q=g+20|0;r=g+16|0;s=g+12|0;t=g+8|0;c[j>>2]=a;c[k>>2]=b;h[l>>3]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=c[(c[j>>2]|0)+16>>2];c[r>>2]=0;c[s>>2]=c[(c[j>>2]|0)+44>>2];c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[j>>2]|0)+16>>2]|0))break;c[o>>2]=(c[o>>2]|0)+1}if(!(c[c[j>>2]>>2]|0)){c[c[j>>2]>>2]=1;h[(c[j>>2]|0)+8>>3]=+h[l>>3];f=cK(c[p>>2]<<3)|0;c[(c[j>>2]|0)+32>>2]=f;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[j>>2]|0)+16>>2]|0))break;h[(c[(c[j>>2]|0)+32>>2]|0)+(c[o>>2]<<3)>>3]=+h[(c[k>>2]|0)+(c[o>>2]<<3)>>3];c[o>>2]=(c[o>>2]|0)+1}c[r>>2]=Gv(c[(c[j>>2]|0)+16>>2]|0,+h[l>>3],c[k>>2]|0,c[m>>2]|0)|0;if(c[(c[j>>2]|0)+40>>2]|0)La(131957,131933,497,131965);f=oy(c[r>>2]|0)|0;c[(c[j>>2]|0)+40>>2]=f;u=c[j>>2]|0;i=g;return u|0}if((c[n>>2]|0)>=(c[s>>2]|0)){if(c[(c[j>>2]|0)+36>>2]|0)La(132031,131933,536,131965);f=c[j>>2]|0;c[f>>2]=(c[f>>2]|0)+1;f=(c[j>>2]|0)+8|0;h[f>>3]=+h[f>>3]+ +h[l>>3];c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[j>>2]|0)+16>>2]|0))break;h[(c[(c[j>>2]|0)+32>>2]|0)+(c[o>>2]<<3)>>3]=(+h[(c[(c[j>>2]|0)+32>>2]|0)+(c[o>>2]<<3)>>3]*+(c[c[j>>2]>>2]|0)+ +h[(c[k>>2]|0)+(c[o>>2]<<3)>>3])/+((c[c[j>>2]>>2]|0)+1|0);c[o>>2]=(c[o>>2]|0)+1}c[r>>2]=Gv(c[(c[j>>2]|0)+16>>2]|0,+h[l>>3],c[k>>2]|0,c[m>>2]|0)|0;if(!(c[(c[j>>2]|0)+40>>2]|0))La(132041,131933,542,131965);f=qy(c[(c[j>>2]|0)+40>>2]|0,c[r>>2]|0)|0;c[(c[j>>2]|0)+40>>2]=f;u=c[j>>2]|0;i=g;return u|0}f=(c[j>>2]|0)+8|0;h[f>>3]=+h[f>>3]+ +h[l>>3];c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[j>>2]|0)+16>>2]|0))break;h[(c[(c[j>>2]|0)+32>>2]|0)+(c[o>>2]<<3)>>3]=(+h[(c[(c[j>>2]|0)+32>>2]|0)+(c[o>>2]<<3)>>3]*+(c[c[j>>2]>>2]|0)+ +h[(c[k>>2]|0)+(c[o>>2]<<3)>>3])/+((c[c[j>>2]>>2]|0)+1|0);c[o>>2]=(c[o>>2]|0)+1}a:do if(!(c[(c[j>>2]|0)+36>>2]|0)){f=cK(1<<c[p>>2]<<2)|0;c[(c[j>>2]|0)+36>>2]=f;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(1<<c[p>>2]|0))break a;c[(c[(c[j>>2]|0)+36>>2]|0)+(c[o>>2]<<2)>>2]=0;c[o>>2]=(c[o>>2]|0)+1}}while(0);c[q>>2]=Hv(c[p>>2]|0,c[(c[j>>2]|0)+20>>2]|0,c[k>>2]|0)|0;if(!((c[q>>2]|0)>=0?(c[q>>2]|0)<(1<<c[p>>2]|0):0))La(131987,131933,510,131965);if(!(c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]|0)){o=Cv(c[(c[j>>2]|0)+16>>2]|0,c[(c[j>>2]|0)+20>>2]|0,+h[(c[j>>2]|0)+24>>3]/2.0,c[s>>2]|0,c[q>>2]|0)|0;c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]=o}o=Fv(c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]|0,c[k>>2]|0,+h[l>>3],c[m>>2]|0,(c[n>>2]|0)+1|0)|0;c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]=o;if(!(c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]|0))La(132010,131933,514,131965);do if(c[(c[j>>2]|0)+40>>2]|0){c[t>>2]=tv(ry(c[(c[j>>2]|0)+40>>2]|0)|0)|0;if((c[c[j>>2]>>2]|0)!=1)La(132021,131933,518,131965);c[k>>2]=sv(ry(c[(c[j>>2]|0)+40>>2]|0)|0)|0;h[l>>3]=+rv(ry(c[(c[j>>2]|0)+40>>2]|0)|0);c[q>>2]=Hv(c[p>>2]|0,c[(c[j>>2]|0)+20>>2]|0,c[k>>2]|0)|0;if(!((c[q>>2]|0)>=0?(c[q>>2]|0)<(1<<c[p>>2]|0):0))La(131987,131933,522,131965);if(!(c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]|0)){o=Cv(c[(c[j>>2]|0)+16>>2]|0,c[(c[j>>2]|0)+20>>2]|0,+h[(c[j>>2]|0)+24>>3]/2.0,c[s>>2]|0,c[q>>2]|0)|0;c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]=o}o=Fv(c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]|0,c[k>>2]|0,+h[l>>3],c[t>>2]|0,(c[n>>2]|0)+1|0)|0;c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]=o;if(c[(c[(c[j>>2]|0)+36>>2]|0)+(c[q>>2]<<2)>>2]|0){py(c[(c[j>>2]|0)+40>>2]|0,97);c[(c[j>>2]|0)+40>>2]=0;break}else La(132010,131933,527,131965)}while(0);q=c[j>>2]|0;c[q>>2]=(c[q>>2]|0)+1;u=c[j>>2]|0;i=g;return u|0}function Gv(a,b,d,e){a=a|0;b=+b;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;j=f;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;c[g>>2]=a;h[j>>3]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=cK(32)|0;h[c[m>>2]>>3]=+h[j>>3];j=cK(c[g>>2]<<3)|0;c[(c[m>>2]|0)+8>>2]=j;h[(c[m>>2]|0)+16>>3]=+(c[l>>2]|0);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[g>>2]|0))break;h[(c[(c[m>>2]|0)+8>>2]|0)+(c[n>>2]<<3)>>3]=+h[(c[k>>2]|0)+(c[n>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[(c[m>>2]|0)+24>>2]=0;i=f;return c[m>>2]|0}function Hv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=0;c[l>>2]=(c[f>>2]|0)-1;while(1){if((c[l>>2]|0)<0)break;f=c[k>>2]<<1;if(+h[(c[j>>2]|0)+(c[l>>2]<<3)>>3]-+h[(c[g>>2]|0)+(c[l>>2]<<3)>>3]<0.0)c[k>>2]=f;else c[k>>2]=f+1;c[l>>2]=(c[l>>2]|0)+-1}i=e;return c[k>>2]|0}function Iv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=c[(c[e>>2]|0)+48>>2];if(c[j>>2]|0){k=c[j>>2]|0;i=d;return k|0}b=cK(c[f>>2]<<3)|0;c[(c[e>>2]|0)+48>>2]=b;c[j>>2]=c[(c[e>>2]|0)+48>>2];c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;h[(c[j>>2]|0)+(c[g>>2]<<3)>>3]=0.0;c[g>>2]=(c[g>>2]|0)+1}k=c[j>>2]|0;i=d;return k|0}function Jv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[(ry(c[j>>2]|0)|0)+24>>2];if(c[l>>2]|0){m=c[l>>2]|0;i=f;return m|0}e=_(c[h>>2]|0,c[k>>2]|0)|0;k=(c[g>>2]|0)+(e<<3)|0;c[(ry(c[j>>2]|0)|0)+24>>2]=k;c[l>>2]=c[(ry(c[j>>2]|0)|0)+24>>2];m=c[l>>2]|0;i=f;return m|0}function Kv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;b=i;i=i+80|0;d=b+76|0;e=b+72|0;f=b+68|0;g=b+64|0;j=b+60|0;k=b+56|0;l=b+52|0;m=b+48|0;n=b+44|0;o=b+40|0;p=b+36|0;q=b+32|0;r=b+28|0;s=b+24|0;t=b+20|0;u=b+16|0;v=b+12|0;w=b+8|0;x=b+4|0;y=b;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+20>>2];c[g>>2]=c[(c[e>>2]|0)+24>>2];c[l>>2]=c[(c[e>>2]|0)+8>>2];c[m>>2]=c[c[e>>2]>>2];c[n>>2]=c[(c[e>>2]|0)+4>>2];c[o>>2]=c[(c[e>>2]|0)+16>>2];c[p>>2]=c[(c[e>>2]|0)+32>>2];if(!(c[e>>2]|0)){c[d>>2]=0;z=c[d>>2]|0;i=b;return z|0}if((c[(c[e>>2]|0)+32>>2]|0)!=1)La(132169,132193,75,132208);c[q>>2]=Nv(c[n>>2]|0,c[m>>2]|0,c[l>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;c[(c[q>>2]|0)+8>>2]=c[l>>2];c[j>>2]=c[(c[q>>2]|0)+20>>2];c[k>>2]=c[(c[q>>2]|0)+24>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>(c[n>>2]|0))break;c[(c[j>>2]|0)+(c[r>>2]<<2)>>2]=0;c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;c[s>>2]=c[(c[f>>2]|0)+(c[r>>2]<<2)>>2];while(1){if((c[s>>2]|0)>=(c[(c[f>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;l=(c[j>>2]|0)+((c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]|0)+1<<2)|0;c[l>>2]=(c[l>>2]|0)+1;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[n>>2]|0))break;l=(c[j>>2]|0)+((c[r>>2]|0)+1<<2)|0;c[l>>2]=(c[l>>2]|0)+(c[(c[j>>2]|0)+(c[r>>2]<<2)>>2]|0);c[r>>2]=(c[r>>2]|0)+1}a:do switch(c[(c[e>>2]|0)+16>>2]|0){case 1:{c[t>>2]=c[(c[e>>2]|0)+28>>2];c[u>>2]=c[(c[q>>2]|0)+28>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break a;c[s>>2]=c[(c[f>>2]|0)+(c[r>>2]<<2)>>2];while(1){A=c[r>>2]|0;if((c[s>>2]|0)>=(c[(c[f>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;c[(c[k>>2]|0)+(c[(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]<<2)>>2]=A;B=+h[(c[t>>2]|0)+(c[s>>2]<<3)>>3];l=(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)|0;p=c[l>>2]|0;c[l>>2]=p+1;h[(c[u>>2]|0)+(p<<3)>>3]=B;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=A+1}break}case 2:{c[v>>2]=c[(c[e>>2]|0)+28>>2];c[w>>2]=c[(c[q>>2]|0)+28>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break a;c[s>>2]=c[(c[f>>2]|0)+(c[r>>2]<<2)>>2];while(1){C=c[r>>2]|0;if((c[s>>2]|0)>=(c[(c[f>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;c[(c[k>>2]|0)+(c[(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]<<2)>>2]=C;h[(c[w>>2]|0)+(c[(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]<<1<<3)>>3]=+h[(c[v>>2]|0)+(c[s>>2]<<1<<3)>>3];h[(c[w>>2]|0)+((c[(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)>>3]=+h[(c[v>>2]|0)+((c[s>>2]<<1)+1<<3)>>3];p=(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)|0;c[p>>2]=(c[p>>2]|0)+1;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=C+1}break}case 4:{c[x>>2]=c[(c[e>>2]|0)+28>>2];c[y>>2]=c[(c[q>>2]|0)+28>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break a;c[s>>2]=c[(c[f>>2]|0)+(c[r>>2]<<2)>>2];while(1){D=c[r>>2]|0;if((c[s>>2]|0)>=(c[(c[f>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;c[(c[k>>2]|0)+(c[(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]<<2)>>2]=D;p=c[(c[x>>2]|0)+(c[s>>2]<<2)>>2]|0;l=(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)|0;o=c[l>>2]|0;c[l>>2]=o+1;c[(c[y>>2]|0)+(o<<2)>>2]=p;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=D+1}break}case 8:{c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break a;c[s>>2]=c[(c[f>>2]|0)+(c[r>>2]<<2)>>2];while(1){E=c[r>>2]|0;if((c[s>>2]|0)>=(c[(c[f>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;p=(c[j>>2]|0)+(c[(c[g>>2]|0)+(c[s>>2]<<2)>>2]<<2)|0;o=c[p>>2]|0;c[p>>2]=o+1;c[(c[k>>2]|0)+(o<<2)>>2]=E;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=E+1}break}case 16:{Lv(c[q>>2]|0);c[d>>2]=0;z=c[d>>2]|0;i=b;return z|0}default:{Lv(c[q>>2]|0);c[d>>2]=0;z=c[d>>2]|0;i=b;return z|0}}while(0);c[r>>2]=(c[n>>2]|0)-1;while(1){if((c[r>>2]|0)<0)break;c[(c[j>>2]|0)+((c[r>>2]|0)+1<<2)>>2]=c[(c[j>>2]|0)+(c[r>>2]<<2)>>2];c[r>>2]=(c[r>>2]|0)+-1}c[c[j>>2]>>2]=0;c[d>>2]=c[q>>2];z=c[d>>2]|0;i=b;return z|0}function Lv(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+20>>2]|0)O4(c[(c[d>>2]|0)+20>>2]|0);if(c[(c[d>>2]|0)+24>>2]|0)O4(c[(c[d>>2]|0)+24>>2]|0);if(c[(c[d>>2]|0)+28>>2]|0)O4(c[(c[d>>2]|0)+28>>2]|0);O4(c[d>>2]|0);i=b;return}function Mv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;b=(Ov(c[f>>2]|0,c[g>>2]|0)|0)!=0;g=c[f>>2]|0;if(b){c[e>>2]=Pv(g)|0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Kv(g)|0;if(c[h>>2]|0){c[f>>2]=Qv(c[f>>2]|0,c[h>>2]|0)|0;Lv(c[h>>2]|0);c[(c[f>>2]|0)+36>>2]=c[(c[f>>2]|0)+36>>2]|2;c[(c[f>>2]|0)+36>>2]=c[(c[f>>2]|0)+36>>2]|1;c[e>>2]=c[f>>2];j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function Nv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[o>>2]=gw(c[l>>2]|0)|0;c[n>>2]=hw(c[h>>2]|0,c[j>>2]|0,c[l>>2]|0,c[o>>2]|0,c[m>>2]|0)|0;if((c[k>>2]|0)<=0){p=c[n>>2]|0;i=g;return p|0}c[n>>2]=iw(c[n>>2]|0,c[k>>2]|0)|0;p=c[n>>2]|0;i=g;return p|0}function Ov(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0;d=i;i=i+80|0;e=d+76|0;f=d+72|0;g=d+68|0;j=d+64|0;k=d+60|0;l=d+56|0;m=d+52|0;n=d+48|0;o=d+44|0;p=d+40|0;q=d+36|0;r=d+32|0;s=d+28|0;t=d+24|0;u=d+20|0;v=d+16|0;w=d+12|0;x=d+8|0;y=d+4|0;z=d;c[f>>2]=a;c[g>>2]=b;c[r>>2]=0;if((c[(c[f>>2]|0)+32>>2]|0)!=1)La(132169,132193,184,132231);if(!(c[f>>2]|0)){c[e>>2]=0;A=c[e>>2]|0;i=d;return A|0}if(c[(c[f>>2]|0)+36>>2]&2){c[e>>2]=1;A=c[e>>2]|0;i=d;return A|0}if((c[g>>2]|0)!=0?(c[(c[f>>2]|0)+36>>2]&1|0)!=0:0){c[e>>2]=1;A=c[e>>2]|0;i=d;return A|0}if((c[c[f>>2]>>2]|0)!=(c[(c[f>>2]|0)+4>>2]|0)){c[e>>2]=0;A=c[e>>2]|0;i=d;return A|0}c[j>>2]=Kv(c[f>>2]|0)|0;if(!(c[j>>2]|0)){c[e>>2]=0;A=c[e>>2]|0;i=d;return A|0}c[k>>2]=c[(c[f>>2]|0)+20>>2];c[l>>2]=c[(c[f>>2]|0)+24>>2];c[m>>2]=c[(c[j>>2]|0)+20>>2];c[n>>2]=c[(c[j>>2]|0)+24>>2];c[p>>2]=c[c[f>>2]>>2];c[q>>2]=cK(c[p>>2]<<2)|0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[p>>2]|0))break;c[(c[q>>2]|0)+(c[s>>2]<<2)>>2]=-1;c[s>>2]=(c[s>>2]|0)+1}b=c[(c[f>>2]|0)+16>>2]|0;c[o>>2]=b;c[o>>2]=(c[g>>2]|0)!=0?8:b;a:do switch(c[o>>2]|0){case 1:{c[u>>2]=c[(c[f>>2]|0)+28>>2];c[v>>2]=c[(c[j>>2]|0)+28>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>(c[p>>2]|0))break;if((c[(c[k>>2]|0)+(c[s>>2]<<2)>>2]|0)!=(c[(c[m>>2]|0)+(c[s>>2]<<2)>>2]|0))break a;c[s>>2]=(c[s>>2]|0)+1}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[p>>2]|0))break;c[t>>2]=c[(c[k>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[k>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[(c[q>>2]|0)+(c[(c[l>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]=c[t>>2];c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;if((c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[k>>2]|0)+(c[s>>2]<<2)>>2]|0))break a;c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;B=+h[(c[v>>2]|0)+(c[t>>2]<<3)>>3]-+h[(c[u>>2]|0)+(c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]<<3)>>3];if((+h[(c[v>>2]|0)+(c[t>>2]<<3)>>3]-+h[(c[u>>2]|0)+(c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]<<3)>>3]>=0.0?B:-B)>1.0e-07)break a;c[t>>2]=(c[t>>2]|0)+1}c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=1;C=83;break}case 2:{c[w>>2]=c[(c[f>>2]|0)+28>>2];c[x>>2]=c[(c[j>>2]|0)+28>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>(c[p>>2]|0))break;if((c[(c[k>>2]|0)+(c[s>>2]<<2)>>2]|0)!=(c[(c[m>>2]|0)+(c[s>>2]<<2)>>2]|0))break a;c[s>>2]=(c[s>>2]|0)+1}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[p>>2]|0))break;c[t>>2]=c[(c[k>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[k>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[(c[q>>2]|0)+(c[(c[l>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]=c[t>>2];c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;if((c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[k>>2]|0)+(c[s>>2]<<2)>>2]|0))break a;c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;B=+h[(c[x>>2]|0)+(c[t>>2]<<1<<3)>>3]-+h[(c[w>>2]|0)+(c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]<<1<<3)>>3];if((+h[(c[x>>2]|0)+(c[t>>2]<<1<<3)>>3]-+h[(c[w>>2]|0)+(c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]<<1<<3)>>3]>=0.0?B:-B)>1.0e-07)break a;B=+h[(c[x>>2]|0)+((c[t>>2]<<1)+1<<3)>>3]-+h[(c[w>>2]|0)+((c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)>>3];if((+h[(c[x>>2]|0)+((c[t>>2]<<1)+1<<3)>>3]-+h[(c[w>>2]|0)+((c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)>>3]>=0.0?B:-B)>1.0e-07)break a;c[t>>2]=(c[t>>2]|0)+1}c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=1;C=83;break}case 4:{c[y>>2]=c[(c[f>>2]|0)+28>>2];c[z>>2]=c[(c[j>>2]|0)+28>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[p>>2]|0))break;c[t>>2]=c[(c[k>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[k>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[(c[q>>2]|0)+(c[(c[l>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]=c[t>>2];c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;if((c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[k>>2]|0)+(c[s>>2]<<2)>>2]|0))break a;c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;if((c[(c[z>>2]|0)+(c[t>>2]<<2)>>2]|0)!=(c[(c[y>>2]|0)+(c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0))break a;c[t>>2]=(c[t>>2]|0)+1}c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=1;C=83;break}case 8:{c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[p>>2]|0))break;c[t>>2]=c[(c[k>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[k>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[(c[q>>2]|0)+(c[(c[l>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]=c[t>>2];c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;if((c[(c[q>>2]|0)+(c[(c[n>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[k>>2]|0)+(c[s>>2]<<2)>>2]|0))break a;c[t>>2]=(c[t>>2]|0)+1}c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=1;C=83;break}default:{}}while(0);do if((C|0)==83){s=c[(c[f>>2]|0)+36>>2]|0;if(c[g>>2]|0){c[(c[f>>2]|0)+36>>2]=s|1;break}else{c[(c[f>>2]|0)+36>>2]=s|2;c[(c[f>>2]|0)+36>>2]=c[(c[f>>2]|0)+36>>2]|1;break}}while(0);O4(c[q>>2]|0);Lv(c[j>>2]|0);c[e>>2]=c[r>>2];A=c[e>>2]|0;i=d;return A|0}function Pv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;a=c[e>>2]|0;if(!(c[e>>2]|0)){c[d>>2]=a;g=c[d>>2]|0;i=b;return g|0}c[f>>2]=Nv(c[a>>2]|0,c[(c[e>>2]|0)+4>>2]|0,c[(c[e>>2]|0)+8>>2]|0,c[(c[e>>2]|0)+16>>2]|0,c[(c[e>>2]|0)+32>>2]|0)|0;Z4(c[(c[f>>2]|0)+20>>2]|0,c[(c[e>>2]|0)+20>>2]|0,(c[c[e>>2]>>2]|0)+1<<2|0)|0;Z4(c[(c[f>>2]|0)+24>>2]|0,c[(c[e>>2]|0)+24>>2]|0,c[(c[(c[e>>2]|0)+20>>2]|0)+(c[c[e>>2]>>2]<<2)>>2]<<2|0)|0;if(c[(c[e>>2]|0)+28>>2]|0)Z4(c[(c[f>>2]|0)+28>>2]|0,c[(c[e>>2]|0)+28>>2]|0,_(c[(c[e>>2]|0)+40>>2]|0,c[(c[e>>2]|0)+8>>2]|0)|0)|0;c[(c[f>>2]|0)+36>>2]=c[(c[e>>2]|0)+36>>2];c[(c[f>>2]|0)+8>>2]=c[(c[e>>2]|0)+8>>2];c[d>>2]=c[f>>2];g=c[d>>2]|0;i=b;return g|0}function Qv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0;d=i;i=i+112|0;e=d+100|0;f=d+96|0;g=d+92|0;j=d+88|0;k=d+84|0;l=d+80|0;m=d+76|0;n=d+72|0;o=d+68|0;p=d+64|0;q=d+60|0;r=d+56|0;s=d+52|0;t=d+48|0;u=d+44|0;v=d+40|0;w=d+36|0;x=d+32|0;y=d+28|0;z=d+24|0;A=d+20|0;B=d+16|0;C=d+12|0;D=d+8|0;E=d+4|0;F=d;c[f>>2]=a;c[g>>2]=b;c[l>>2]=0;c[m>>2]=0;c[n>>2]=c[(c[f>>2]|0)+20>>2];c[o>>2]=c[(c[f>>2]|0)+24>>2];c[p>>2]=c[(c[g>>2]|0)+20>>2];c[q>>2]=c[(c[g>>2]|0)+24>>2];if(!((c[f>>2]|0)!=0&(c[g>>2]|0)!=0))La(132257,132193,972,132264);if((c[(c[f>>2]|0)+32>>2]|0)!=(c[(c[g>>2]|0)+32>>2]|0))La(132281,132193,973,132264);if((c[(c[f>>2]|0)+32>>2]|0)!=1)La(132281,132193,973,132264);if((c[(c[f>>2]|0)+16>>2]|0)!=(c[(c[g>>2]|0)+16>>2]|0))La(132331,132193,974,132264);c[j>>2]=c[c[f>>2]>>2];c[k>>2]=c[(c[f>>2]|0)+4>>2];if((c[j>>2]|0)==(c[c[g>>2]>>2]|0)?(c[k>>2]|0)==(c[(c[g>>2]|0)+4>>2]|0):0){c[w>>2]=(c[(c[f>>2]|0)+8>>2]|0)+(c[(c[g>>2]|0)+8>>2]|0);c[l>>2]=Nv(c[j>>2]|0,c[k>>2]|0,c[w>>2]|0,c[(c[f>>2]|0)+16>>2]|0,1)|0;if(c[l>>2]|0){c[r>>2]=c[(c[l>>2]|0)+20>>2];c[s>>2]=c[(c[l>>2]|0)+24>>2];c[m>>2]=cK(c[k>>2]<<2)|0;c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[k>>2]|0))break;c[(c[m>>2]|0)+(c[t>>2]<<2)>>2]=-1;c[t>>2]=(c[t>>2]|0)+1}c[v>>2]=0;c[c[r>>2]>>2]=0;a:do switch(c[(c[f>>2]|0)+16>>2]|0){case 1:{c[x>>2]=c[(c[f>>2]|0)+28>>2];c[y>>2]=c[(c[g>>2]|0)+28>>2];c[z>>2]=c[(c[l>>2]|0)+28>>2];c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[j>>2]|0))break a;c[u>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[n>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;c[(c[m>>2]|0)+(c[(c[o>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=c[v>>2];c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[o>>2]|0)+(c[u>>2]<<2)>>2];h[(c[z>>2]|0)+(c[v>>2]<<3)>>3]=+h[(c[x>>2]|0)+(c[u>>2]<<3)>>3];c[v>>2]=(c[v>>2]|0)+1;c[u>>2]=(c[u>>2]|0)+1}c[u>>2]=c[(c[p>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[p>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;k=c[u>>2]|0;if((c[(c[m>>2]|0)+(c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[r>>2]|0)+(c[t>>2]<<2)>>2]|0)){c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[q>>2]|0)+(k<<2)>>2];G=+h[(c[y>>2]|0)+(c[u>>2]<<3)>>3];w=c[v>>2]|0;c[v>>2]=w+1;h[(c[z>>2]|0)+(w<<3)>>3]=G}else{w=(c[z>>2]|0)+(c[(c[m>>2]|0)+(c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<3)|0;h[w>>3]=+h[w>>3]+ +h[(c[y>>2]|0)+(k<<3)>>3]}c[u>>2]=(c[u>>2]|0)+1}c[(c[r>>2]|0)+((c[t>>2]|0)+1<<2)>>2]=c[v>>2];c[t>>2]=(c[t>>2]|0)+1}break}case 2:{c[A>>2]=c[(c[f>>2]|0)+28>>2];c[B>>2]=c[(c[g>>2]|0)+28>>2];c[C>>2]=c[(c[l>>2]|0)+28>>2];c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[j>>2]|0))break a;c[u>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[n>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;c[(c[m>>2]|0)+(c[(c[o>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=c[v>>2];c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[o>>2]|0)+(c[u>>2]<<2)>>2];h[(c[C>>2]|0)+(c[v>>2]<<1<<3)>>3]=+h[(c[A>>2]|0)+(c[u>>2]<<1<<3)>>3];h[(c[C>>2]|0)+((c[v>>2]<<1)+1<<3)>>3]=+h[(c[A>>2]|0)+((c[u>>2]<<1)+1<<3)>>3];c[v>>2]=(c[v>>2]|0)+1;c[u>>2]=(c[u>>2]|0)+1}c[u>>2]=c[(c[p>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[p>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;k=c[u>>2]|0;if((c[(c[m>>2]|0)+(c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[r>>2]|0)+(c[t>>2]<<2)>>2]|0)){c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[q>>2]|0)+(k<<2)>>2];h[(c[C>>2]|0)+(c[v>>2]<<1<<3)>>3]=+h[(c[B>>2]|0)+(c[u>>2]<<1<<3)>>3];h[(c[C>>2]|0)+((c[v>>2]<<1)+1<<3)>>3]=+h[(c[B>>2]|0)+((c[u>>2]<<1)+1<<3)>>3];c[v>>2]=(c[v>>2]|0)+1}else{w=(c[C>>2]|0)+(c[(c[m>>2]|0)+(c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<1<<3)|0;h[w>>3]=+h[w>>3]+ +h[(c[B>>2]|0)+(k<<1<<3)>>3];k=(c[C>>2]|0)+((c[(c[m>>2]|0)+(c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)|0;h[k>>3]=+h[k>>3]+ +h[(c[B>>2]|0)+((c[u>>2]<<1)+1<<3)>>3]}c[u>>2]=(c[u>>2]|0)+1}c[(c[r>>2]|0)+((c[t>>2]|0)+1<<2)>>2]=c[v>>2];c[t>>2]=(c[t>>2]|0)+1}break}case 4:{c[D>>2]=c[(c[f>>2]|0)+28>>2];c[E>>2]=c[(c[g>>2]|0)+28>>2];c[F>>2]=c[(c[l>>2]|0)+28>>2];c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[j>>2]|0))break a;c[u>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[n>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;c[(c[m>>2]|0)+(c[(c[o>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=c[v>>2];c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[o>>2]|0)+(c[u>>2]<<2)>>2];c[(c[F>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[D>>2]|0)+(c[u>>2]<<2)>>2];c[v>>2]=(c[v>>2]|0)+1;c[u>>2]=(c[u>>2]|0)+1}c[u>>2]=c[(c[p>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[p>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;k=c[u>>2]|0;if((c[(c[m>>2]|0)+(c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[r>>2]|0)+(c[t>>2]<<2)>>2]|0)){c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[q>>2]|0)+(k<<2)>>2];c[(c[F>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[E>>2]|0)+(c[u>>2]<<2)>>2];c[v>>2]=(c[v>>2]|0)+1}else{w=(c[F>>2]|0)+(c[(c[m>>2]|0)+(c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<2)|0;c[w>>2]=(c[w>>2]|0)+(c[(c[E>>2]|0)+(k<<2)>>2]|0)}c[u>>2]=(c[u>>2]|0)+1}c[(c[r>>2]|0)+((c[t>>2]|0)+1<<2)>>2]=c[v>>2];c[t>>2]=(c[t>>2]|0)+1}break}case 8:{c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[j>>2]|0))break a;c[u>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[n>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;c[(c[m>>2]|0)+(c[(c[o>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=c[v>>2];c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[o>>2]|0)+(c[u>>2]<<2)>>2];c[v>>2]=(c[v>>2]|0)+1;c[u>>2]=(c[u>>2]|0)+1}c[u>>2]=c[(c[p>>2]|0)+(c[t>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[p>>2]|0)+((c[t>>2]|0)+1<<2)>>2]|0))break;if((c[(c[m>>2]|0)+(c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[r>>2]|0)+(c[t>>2]<<2)>>2]|0)){c[(c[s>>2]|0)+(c[v>>2]<<2)>>2]=c[(c[q>>2]|0)+(c[u>>2]<<2)>>2];c[v>>2]=(c[v>>2]|0)+1}c[u>>2]=(c[u>>2]|0)+1}c[(c[r>>2]|0)+((c[t>>2]|0)+1<<2)>>2]=c[v>>2];c[t>>2]=(c[t>>2]|0)+1}break}default:{}}while(0);c[(c[l>>2]|0)+8>>2]=c[v>>2]}if(c[m>>2]|0)O4(c[m>>2]|0);c[e>>2]=c[l>>2];H=c[e>>2]|0;i=d;return H|0}c[e>>2]=0;H=c[e>>2]|0;i=d;return H|0}function Rv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;b=(Ov(c[f>>2]|0,c[g>>2]|0)|0)!=0;g=c[f>>2]|0;if(b){c[h>>2]=Pv(g)|0;c[e>>2]=Sv(c[h>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=Kv(g)|0;if(c[h>>2]|0){c[f>>2]=Qv(c[f>>2]|0,c[h>>2]|0)|0;Lv(c[h>>2]|0);c[(c[f>>2]|0)+36>>2]=c[(c[f>>2]|0)+36>>2]|2;c[(c[f>>2]|0)+36>>2]=c[(c[f>>2]|0)+36>>2]|1;c[e>>2]=Sv(c[f>>2]|0)|0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function Sv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;b=i;i=i+48|0;d=b+40|0;e=b+36|0;f=b+32|0;g=b+28|0;j=b+24|0;k=b+20|0;l=b+16|0;m=b+12|0;n=b+8|0;o=b+4|0;p=b;c[e>>2]=a;if(!(c[e>>2]|0)){c[d>>2]=c[e>>2];q=c[d>>2]|0;i=b;return q|0}c[l>>2]=0;c[j>>2]=c[(c[e>>2]|0)+20>>2];c[k>>2]=c[(c[e>>2]|0)+24>>2];c[m>>2]=c[c[j>>2]>>2];switch(c[(c[e>>2]|0)+16>>2]|0){case 1:{c[n>>2]=c[(c[e>>2]|0)+28>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[e>>2]>>2]|0))break;c[g>>2]=c[m>>2];while(1){if((c[g>>2]|0)>=(c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]|0))break;if((c[(c[k>>2]|0)+(c[g>>2]<<2)>>2]|0)!=(c[f>>2]|0)){c[(c[k>>2]|0)+(c[l>>2]<<2)>>2]=c[(c[k>>2]|0)+(c[g>>2]<<2)>>2];r=+h[(c[n>>2]|0)+(c[g>>2]<<3)>>3];a=c[l>>2]|0;c[l>>2]=a+1;h[(c[n>>2]|0)+(a<<3)>>3]=r}c[g>>2]=(c[g>>2]|0)+1}c[m>>2]=c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]=c[l>>2];c[f>>2]=(c[f>>2]|0)+1}c[(c[e>>2]|0)+8>>2]=c[l>>2];break}case 2:{c[o>>2]=c[(c[e>>2]|0)+28>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[e>>2]>>2]|0))break;c[g>>2]=c[m>>2];while(1){if((c[g>>2]|0)>=(c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]|0))break;if((c[(c[k>>2]|0)+(c[g>>2]<<2)>>2]|0)!=(c[f>>2]|0)){c[(c[k>>2]|0)+(c[l>>2]<<2)>>2]=c[(c[k>>2]|0)+(c[g>>2]<<2)>>2];h[(c[o>>2]|0)+(c[l>>2]<<1<<3)>>3]=+h[(c[o>>2]|0)+(c[g>>2]<<1<<3)>>3];h[(c[o>>2]|0)+((c[l>>2]<<1)+1<<3)>>3]=+h[(c[o>>2]|0)+((c[g>>2]<<1)+1<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1}c[m>>2]=c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]=c[l>>2];c[f>>2]=(c[f>>2]|0)+1}c[(c[e>>2]|0)+8>>2]=c[l>>2];break}case 4:{c[p>>2]=c[(c[e>>2]|0)+28>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[e>>2]>>2]|0))break;c[g>>2]=c[m>>2];while(1){if((c[g>>2]|0)>=(c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]|0))break;if((c[(c[k>>2]|0)+(c[g>>2]<<2)>>2]|0)!=(c[f>>2]|0)){c[(c[k>>2]|0)+(c[l>>2]<<2)>>2]=c[(c[k>>2]|0)+(c[g>>2]<<2)>>2];o=c[(c[p>>2]|0)+(c[g>>2]<<2)>>2]|0;n=c[l>>2]|0;c[l>>2]=n+1;c[(c[p>>2]|0)+(n<<2)>>2]=o}c[g>>2]=(c[g>>2]|0)+1}c[m>>2]=c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]=c[l>>2];c[f>>2]=(c[f>>2]|0)+1}c[(c[e>>2]|0)+8>>2]=c[l>>2];break}case 8:{c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[e>>2]>>2]|0))break;c[g>>2]=c[m>>2];while(1){if((c[g>>2]|0)>=(c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]|0))break;if((c[(c[k>>2]|0)+(c[g>>2]<<2)>>2]|0)!=(c[f>>2]|0)){p=c[(c[k>>2]|0)+(c[g>>2]<<2)>>2]|0;o=c[l>>2]|0;c[l>>2]=o+1;c[(c[k>>2]|0)+(o<<2)>>2]=p}c[g>>2]=(c[g>>2]|0)+1}c[m>>2]=c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]=c[l>>2];c[f>>2]=(c[f>>2]|0)+1}c[(c[e>>2]|0)+8>>2]=c[l>>2];break}case 16:{c[d>>2]=0;q=c[d>>2]|0;i=b;return q|0}default:{c[d>>2]=0;q=c[d>>2]|0;i=b;return q|0}}c[d>>2]=c[e>>2];q=c[d>>2]|0;i=b;return q|0}function Tv(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=hw(c[j>>2]|0,c[k>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;if((c[l>>2]|0)<=0){q=c[p>>2]|0;i=h;return q|0}c[p>>2]=iw(c[p>>2]|0,c[l>>2]|0)|0;q=c[p>>2]|0;i=h;return q|0}function Uv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[h>>2]=c[(c[e>>2]|0)+28>>2];if((c[(c[e>>2]|0)+32>>2]|0)!=2)La(132350,132193,802,132376);if((c[(c[e>>2]|0)+32>>2]|0)!=2){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}else{c[f>>2]=c[(c[e>>2]|0)+20>>2];c[g>>2]=c[(c[e>>2]|0)+24>>2];c[d>>2]=Vv(c[(c[e>>2]|0)+8>>2]|0,c[c[e>>2]>>2]|0,c[(c[e>>2]|0)+4>>2]|0,c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,c[(c[e>>2]|0)+16>>2]|0,c[(c[e>>2]|0)+40>>2]|0)|0;j=c[d>>2]|0;i=b;return j|0}return 0}function Vv(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k+28|0;m=k+24|0;n=k+20|0;o=k+16|0;p=k+12|0;q=k+8|0;r=k+4|0;s=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;j=jw(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,1)|0;i=k;return j|0}function Wv(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;h=c[k>>2]|0;k=c[m>>2]|0;m=c[o>>2]|0;o=c[q>>2]|0;q=c[l>>2]|0;l=c[p>>2]|0;if(c[n>>2]|0){lw(h,k,m,o,q,l);i=j;return}else{kw(h,k,m,o,q,l);i=j;return}}function Xv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+64|0;g=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+20|0;q=f+16|0;r=f+12|0;s=f+8|0;t=f+4|0;u=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[t>>2]=0;if((c[(c[g>>2]|0)+32>>2]|0)!=1)La(132169,132193,1221,132412);if((c[(c[g>>2]|0)+16>>2]|0)!=1?(c[(c[g>>2]|0)+16>>2]|0)!=4:0)La(132441,132193,1222,132412);c[o>>2]=c[(c[g>>2]|0)+20>>2];c[p>>2]=c[(c[g>>2]|0)+24>>2];c[r>>2]=c[c[g>>2]>>2];c[q>>2]=c[(c[g>>2]|0)+4>>2];c[t>>2]=c[c[k>>2]>>2];switch(c[(c[g>>2]|0)+16>>2]|0){case 1:{c[s>>2]=c[(c[g>>2]|0)+28>>2];e=(c[l>>2]|0)!=0;d=(c[t>>2]|0)!=0;if(c[j>>2]|0){if(!e){if(!d)c[t>>2]=cK(c[r>>2]<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;h[(c[t>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[n>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;b=(c[t>>2]|0)+(c[m>>2]<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[s>>2]|0)+(c[n>>2]<<3)>>3]*+h[(c[j>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}v=c[t>>2]|0;w=c[k>>2]|0;c[w>>2]=v;i=f;return}if(!d)c[t>>2]=cK(c[q>>2]<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[q>>2]|0))break;h[(c[t>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;c[n>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;b=(c[t>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[s>>2]|0)+(c[n>>2]<<3)>>3]*+h[(c[j>>2]|0)+(c[m>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}v=c[t>>2]|0;w=c[k>>2]|0;c[w>>2]=v;i=f;return}else{if(!e){if(!d)c[t>>2]=cK(c[r>>2]<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;h[(c[t>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[n>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;e=(c[t>>2]|0)+(c[m>>2]<<3)|0;h[e>>3]=+h[e>>3]+ +h[(c[s>>2]|0)+(c[n>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}v=c[t>>2]|0;w=c[k>>2]|0;c[w>>2]=v;i=f;return}if(!d)c[t>>2]=cK(c[q>>2]<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[q>>2]|0))break;h[(c[t>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;c[n>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;d=(c[t>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<3)|0;h[d>>3]=+h[d>>3]+ +h[(c[s>>2]|0)+(c[n>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}v=c[t>>2]|0;w=c[k>>2]|0;c[w>>2]=v;i=f;return}break}case 4:{c[u>>2]=c[(c[g>>2]|0)+28>>2];g=(c[l>>2]|0)!=0;l=(c[t>>2]|0)!=0;if(c[j>>2]|0){if(!g){if(!l)c[t>>2]=cK(c[r>>2]<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;h[(c[t>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[n>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;s=(c[t>>2]|0)+(c[m>>2]<<3)|0;h[s>>3]=+h[s>>3]+ +(c[(c[u>>2]|0)+(c[n>>2]<<2)>>2]|0)*+h[(c[j>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}v=c[t>>2]|0;w=c[k>>2]|0;c[w>>2]=v;i=f;return}if(!l)c[t>>2]=cK(c[q>>2]<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[q>>2]|0))break;h[(c[t>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;c[n>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;s=(c[t>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<3)|0;h[s>>3]=+h[s>>3]+ +(c[(c[u>>2]|0)+(c[n>>2]<<2)>>2]|0)*+h[(c[j>>2]|0)+(c[m>>2]<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}v=c[t>>2]|0;w=c[k>>2]|0;c[w>>2]=v;i=f;return}else{if(!g){if(!l)c[t>>2]=cK(c[r>>2]<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;h[(c[t>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[n>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;g=(c[t>>2]|0)+(c[m>>2]<<3)|0;h[g>>3]=+h[g>>3]+ +(c[(c[u>>2]|0)+(c[n>>2]<<2)>>2]|0);c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}v=c[t>>2]|0;w=c[k>>2]|0;c[w>>2]=v;i=f;return}if(!l)c[t>>2]=cK(c[q>>2]<<3)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[q>>2]|0))break;h[(c[t>>2]|0)+(c[m>>2]<<3)>>3]=0.0;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;c[n>>2]=c[(c[o>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;q=(c[t>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<3)|0;h[q>>3]=+h[q>>3]+ +(c[(c[u>>2]|0)+(c[n>>2]<<2)>>2]|0);c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}v=c[t>>2]|0;w=c[k>>2]|0;c[w>>2]=v;i=f;return}break}default:La(176099,132193,1314,132412)}}function Yv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+112|0;e=d+104|0;f=d+100|0;g=d+96|0;j=d+92|0;k=d+88|0;l=d+84|0;m=d+80|0;n=d+76|0;o=d+72|0;p=d+68|0;q=d+64|0;r=d+60|0;s=d+56|0;t=d+52|0;u=d+48|0;v=d+44|0;w=d+40|0;x=d+36|0;y=d+32|0;z=d+28|0;A=d+24|0;B=d+20|0;C=d+16|0;D=d+12|0;E=d+8|0;F=d+4|0;G=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;c[l>>2]=0;c[m>>2]=c[(c[f>>2]|0)+20>>2];c[n>>2]=c[(c[f>>2]|0)+24>>2];c[o>>2]=c[(c[g>>2]|0)+20>>2];c[p>>2]=c[(c[g>>2]|0)+24>>2];if((c[(c[f>>2]|0)+32>>2]|0)!=(c[(c[g>>2]|0)+32>>2]|0))La(132281,132193,1407,132531);if((c[(c[f>>2]|0)+32>>2]|0)!=1)La(132281,132193,1407,132531);c[j>>2]=c[c[f>>2]>>2];if((c[(c[f>>2]|0)+4>>2]|0)!=(c[c[g>>2]>>2]|0)){c[e>>2]=0;H=c[e>>2]|0;i=d;return H|0}if((c[(c[f>>2]|0)+16>>2]|0)!=(c[(c[g>>2]|0)+16>>2]|0)){c[e>>2]=0;H=c[e>>2]|0;i=d;return H|0}c[w>>2]=c[(c[f>>2]|0)+16>>2];c[l>>2]=cK(c[(c[g>>2]|0)+4>>2]<<2)|0;if(!(c[l>>2]|0)){c[e>>2]=0;H=c[e>>2]|0;i=d;return H|0}c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0))break;c[(c[l>>2]|0)+(c[s>>2]<<2)>>2]=-1;c[s>>2]=(c[s>>2]|0)+1}c[x>>2]=0;c[s>>2]=0;a:while(1){if((c[s>>2]|0)>=(c[j>>2]|0))break;c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[v>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];c[u>>2]=c[(c[o>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[o>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;if((c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)!=(0-(c[s>>2]|0)-2|0)){if(((c[x>>2]|0)+1|0)<=(c[x>>2]|0)){I=21;break a}c[x>>2]=(c[x>>2]|0)+1;c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=0-(c[s>>2]|0)-2}c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[s>>2]=(c[s>>2]|0)+1}if((I|0)==21){c[e>>2]=0;H=c[e>>2]|0;i=d;return H|0}c[k>>2]=Nv(c[j>>2]|0,c[(c[g>>2]|0)+4>>2]|0,c[x>>2]|0,c[w>>2]|0,1)|0;b:do if(c[k>>2]|0){c[q>>2]=c[(c[k>>2]|0)+20>>2];c[r>>2]=c[(c[k>>2]|0)+24>>2];c[x>>2]=0;c:do switch(c[w>>2]|0){case 1:{c[y>>2]=c[(c[f>>2]|0)+28>>2];c[z>>2]=c[(c[g>>2]|0)+28>>2];c[A>>2]=c[(c[k>>2]|0)+28>>2];c[c[q>>2]>>2]=0;c[s>>2]=0;d:while(1){if((c[s>>2]|0)>=(c[j>>2]|0))break c;c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[v>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];c[u>>2]=c[(c[o>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[o>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;if((c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[q>>2]|0)+(c[s>>2]<<2)>>2]|0)){c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=c[x>>2];c[(c[r>>2]|0)+(c[x>>2]<<2)>>2]=c[(c[p>>2]|0)+(c[u>>2]<<2)>>2];h[(c[A>>2]|0)+(c[x>>2]<<3)>>3]=+h[(c[y>>2]|0)+(c[t>>2]<<3)>>3]*+h[(c[z>>2]|0)+(c[u>>2]<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}else{if((c[(c[r>>2]|0)+(c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]|0))break d;I=(c[A>>2]|0)+(c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<3)|0;h[I>>3]=+h[I>>3]+ +h[(c[y>>2]|0)+(c[t>>2]<<3)>>3]*+h[(c[z>>2]|0)+(c[u>>2]<<3)>>3]}c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[(c[q>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[x>>2];c[s>>2]=(c[s>>2]|0)+1}La(132553,132193,1467,132531);break}case 2:{c[B>>2]=c[(c[f>>2]|0)+28>>2];c[C>>2]=c[(c[g>>2]|0)+28>>2];c[D>>2]=c[(c[k>>2]|0)+28>>2];c[B>>2]=c[(c[f>>2]|0)+28>>2];c[C>>2]=c[(c[g>>2]|0)+28>>2];c[D>>2]=c[(c[k>>2]|0)+28>>2];c[c[q>>2]>>2]=0;c[s>>2]=0;e:while(1){if((c[s>>2]|0)>=(c[j>>2]|0))break c;c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[v>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];c[u>>2]=c[(c[o>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[o>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;if((c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[q>>2]|0)+(c[s>>2]<<2)>>2]|0)){c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=c[x>>2];c[(c[r>>2]|0)+(c[x>>2]<<2)>>2]=c[(c[p>>2]|0)+(c[u>>2]<<2)>>2];h[(c[D>>2]|0)+(c[x>>2]<<1<<3)>>3]=+h[(c[B>>2]|0)+(c[t>>2]<<1<<3)>>3]*+h[(c[C>>2]|0)+(c[u>>2]<<1<<3)>>3]-+h[(c[B>>2]|0)+((c[t>>2]<<1)+1<<3)>>3]*+h[(c[C>>2]|0)+((c[u>>2]<<1)+1<<3)>>3];h[(c[D>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]=+h[(c[B>>2]|0)+(c[t>>2]<<1<<3)>>3]*+h[(c[C>>2]|0)+((c[u>>2]<<1)+1<<3)>>3]+ +h[(c[B>>2]|0)+((c[t>>2]<<1)+1<<3)>>3]*+h[(c[C>>2]|0)+(c[u>>2]<<1<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}else{if((c[(c[r>>2]|0)+(c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]|0))break e;I=(c[D>>2]|0)+(c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<1<<3)|0;h[I>>3]=+h[I>>3]+(+h[(c[B>>2]|0)+(c[t>>2]<<1<<3)>>3]*+h[(c[C>>2]|0)+(c[u>>2]<<1<<3)>>3]-+h[(c[B>>2]|0)+((c[t>>2]<<1)+1<<3)>>3]*+h[(c[C>>2]|0)+((c[u>>2]<<1)+1<<3)>>3]);I=(c[D>>2]|0)+((c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)|0;h[I>>3]=+h[I>>3]+(+h[(c[B>>2]|0)+(c[t>>2]<<1<<3)>>3]*+h[(c[C>>2]|0)+((c[u>>2]<<1)+1<<3)>>3]+ +h[(c[B>>2]|0)+((c[t>>2]<<1)+1<<3)>>3]*+h[(c[C>>2]|0)+(c[u>>2]<<1<<3)>>3])}c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[(c[q>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[x>>2];c[s>>2]=(c[s>>2]|0)+1}La(132553,132193,1496,132531);break}case 4:{c[E>>2]=c[(c[f>>2]|0)+28>>2];c[F>>2]=c[(c[g>>2]|0)+28>>2];c[G>>2]=c[(c[k>>2]|0)+28>>2];c[c[q>>2]>>2]=0;c[s>>2]=0;f:while(1){if((c[s>>2]|0)>=(c[j>>2]|0))break c;c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[v>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];c[u>>2]=c[(c[o>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[o>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;if((c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[q>>2]|0)+(c[s>>2]<<2)>>2]|0)){c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=c[x>>2];c[(c[r>>2]|0)+(c[x>>2]<<2)>>2]=c[(c[p>>2]|0)+(c[u>>2]<<2)>>2];I=_(c[(c[E>>2]|0)+(c[t>>2]<<2)>>2]|0,c[(c[F>>2]|0)+(c[u>>2]<<2)>>2]|0)|0;c[(c[G>>2]|0)+(c[x>>2]<<2)>>2]=I;c[x>>2]=(c[x>>2]|0)+1}else{if((c[(c[r>>2]|0)+(c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]|0))break f;I=_(c[(c[E>>2]|0)+(c[t>>2]<<2)>>2]|0,c[(c[F>>2]|0)+(c[u>>2]<<2)>>2]|0)|0;b=(c[G>>2]|0)+(c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<2)|0;c[b>>2]=(c[b>>2]|0)+I}c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[(c[q>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[x>>2];c[s>>2]=(c[s>>2]|0)+1}La(132553,132193,1522,132531);break}case 8:{c[c[q>>2]>>2]=0;c[s>>2]=0;g:while(1){if((c[s>>2]|0)>=(c[j>>2]|0))break c;c[t>>2]=c[(c[m>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[m>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[v>>2]=c[(c[n>>2]|0)+(c[t>>2]<<2)>>2];c[u>>2]=c[(c[o>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[o>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;if((c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)>=(c[(c[q>>2]|0)+(c[s>>2]<<2)>>2]|0)){if((c[(c[r>>2]|0)+(c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]|0))break g}else{c[(c[l>>2]|0)+(c[(c[p>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=c[x>>2];c[(c[r>>2]|0)+(c[x>>2]<<2)>>2]=c[(c[p>>2]|0)+(c[u>>2]<<2)>>2];c[x>>2]=(c[x>>2]|0)+1}c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[(c[q>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[x>>2];c[s>>2]=(c[s>>2]|0)+1}La(132553,132193,1542,132531);break}default:{Lv(c[k>>2]|0);c[k>>2]=0;break b}}while(0);c[(c[k>>2]|0)+8>>2]=c[x>>2]}while(0);O4(c[l>>2]|0);c[e>>2]=c[k>>2];H=c[e>>2]|0;i=d;return H|0}function Zv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;e=i;i=i+144|0;f=e+136|0;g=e+132|0;j=e+128|0;k=e+124|0;l=e+120|0;m=e+116|0;n=e+112|0;o=e+108|0;p=e+104|0;q=e+100|0;r=e+96|0;s=e+92|0;t=e+88|0;u=e+84|0;v=e+80|0;w=e+76|0;x=e+72|0;y=e+68|0;z=e+64|0;A=e+60|0;B=e+56|0;C=e+52|0;D=e+48|0;E=e+44|0;F=e+40|0;G=e+36|0;H=e+32|0;I=e+28|0;J=e+24|0;K=e+20|0;L=e+16|0;M=e+12|0;N=e+8|0;O=e+4|0;P=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[m>>2]=0;c[n>>2]=0;c[o>>2]=c[(c[g>>2]|0)+20>>2];c[p>>2]=c[(c[g>>2]|0)+24>>2];c[q>>2]=c[(c[j>>2]|0)+20>>2];c[r>>2]=c[(c[j>>2]|0)+24>>2];c[s>>2]=c[(c[k>>2]|0)+20>>2];c[t>>2]=c[(c[k>>2]|0)+24>>2];if((c[(c[g>>2]|0)+32>>2]|0)!=(c[(c[j>>2]|0)+32>>2]|0))La(132281,132193,1573,132578);if((c[(c[g>>2]|0)+32>>2]|0)!=1)La(132281,132193,1573,132578);c[l>>2]=c[c[g>>2]>>2];if((c[(c[g>>2]|0)+4>>2]|0)!=(c[c[j>>2]>>2]|0)){c[f>>2]=0;Q=c[f>>2]|0;i=e;return Q|0}if((c[(c[j>>2]|0)+4>>2]|0)!=(c[c[k>>2]>>2]|0)){c[f>>2]=0;Q=c[f>>2]|0;i=e;return Q|0}if((c[(c[g>>2]|0)+16>>2]|0)==(c[(c[j>>2]|0)+16>>2]|0)?(c[(c[j>>2]|0)+16>>2]|0)==(c[(c[k>>2]|0)+16>>2]|0):0){c[C>>2]=c[(c[g>>2]|0)+16>>2];c[n>>2]=cK(c[(c[k>>2]|0)+4>>2]<<2)|0;if(!(c[n>>2]|0)){c[f>>2]=0;Q=c[f>>2]|0;i=e;return Q|0}c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[(c[k>>2]|0)+4>>2]|0))break;c[(c[n>>2]|0)+(c[w>>2]<<2)>>2]=-1;c[w>>2]=(c[w>>2]|0)+1}c[D>>2]=0;c[w>>2]=0;a:while(1){if((c[w>>2]|0)>=(c[l>>2]|0))break;c[x>>2]=c[(c[o>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[x>>2]|0)>=(c[(c[o>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[B>>2]=c[(c[p>>2]|0)+(c[x>>2]<<2)>>2];c[z>>2]=c[(c[q>>2]|0)+(c[B>>2]<<2)>>2];while(1){if((c[z>>2]|0)>=(c[(c[q>>2]|0)+((c[B>>2]|0)+1<<2)>>2]|0))break;c[A>>2]=c[(c[r>>2]|0)+(c[z>>2]<<2)>>2];c[y>>2]=c[(c[s>>2]|0)+(c[A>>2]<<2)>>2];while(1){if((c[y>>2]|0)>=(c[(c[s>>2]|0)+((c[A>>2]|0)+1<<2)>>2]|0))break;if((c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]|0)!=(0-(c[w>>2]|0)-2|0)){if(((c[D>>2]|0)+1|0)<=(c[D>>2]|0)){R=26;break a}c[D>>2]=(c[D>>2]|0)+1;c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]=0-(c[w>>2]|0)-2}c[y>>2]=(c[y>>2]|0)+1}c[z>>2]=(c[z>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=(c[w>>2]|0)+1}if((R|0)==26){c[f>>2]=0;Q=c[f>>2]|0;i=e;return Q|0}c[m>>2]=Nv(c[l>>2]|0,c[(c[k>>2]|0)+4>>2]|0,c[D>>2]|0,c[C>>2]|0,1)|0;b:do if(c[m>>2]|0){c[u>>2]=c[(c[m>>2]|0)+20>>2];c[v>>2]=c[(c[m>>2]|0)+24>>2];c[D>>2]=0;c:do switch(c[C>>2]|0){case 1:{c[E>>2]=c[(c[g>>2]|0)+28>>2];c[F>>2]=c[(c[j>>2]|0)+28>>2];c[G>>2]=c[(c[k>>2]|0)+28>>2];c[H>>2]=c[(c[m>>2]|0)+28>>2];c[c[u>>2]>>2]=0;c[w>>2]=0;d:while(1){if((c[w>>2]|0)>=(c[l>>2]|0))break c;c[x>>2]=c[(c[o>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[x>>2]|0)>=(c[(c[o>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[B>>2]=c[(c[p>>2]|0)+(c[x>>2]<<2)>>2];c[z>>2]=c[(c[q>>2]|0)+(c[B>>2]<<2)>>2];while(1){if((c[z>>2]|0)>=(c[(c[q>>2]|0)+((c[B>>2]|0)+1<<2)>>2]|0))break;c[A>>2]=c[(c[r>>2]|0)+(c[z>>2]<<2)>>2];c[y>>2]=c[(c[s>>2]|0)+(c[A>>2]<<2)>>2];while(1){if((c[y>>2]|0)>=(c[(c[s>>2]|0)+((c[A>>2]|0)+1<<2)>>2]|0))break;if((c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)){c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]=c[D>>2];c[(c[v>>2]|0)+(c[D>>2]<<2)>>2]=c[(c[t>>2]|0)+(c[y>>2]<<2)>>2];h[(c[H>>2]|0)+(c[D>>2]<<3)>>3]=+h[(c[E>>2]|0)+(c[x>>2]<<3)>>3]*+h[(c[F>>2]|0)+(c[z>>2]<<3)>>3]*+h[(c[G>>2]|0)+(c[y>>2]<<3)>>3];c[D>>2]=(c[D>>2]|0)+1}else{if((c[(c[v>>2]|0)+(c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0))break d;R=(c[H>>2]|0)+(c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]<<3)|0;h[R>>3]=+h[R>>3]+ +h[(c[E>>2]|0)+(c[x>>2]<<3)>>3]*+h[(c[F>>2]|0)+(c[z>>2]<<3)>>3]*+h[(c[G>>2]|0)+(c[y>>2]<<3)>>3]}c[y>>2]=(c[y>>2]|0)+1}c[z>>2]=(c[z>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+1}c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]=c[D>>2];c[w>>2]=(c[w>>2]|0)+1}La(132601,132193,1641,132578);break}case 2:{c[I>>2]=c[(c[g>>2]|0)+28>>2];c[J>>2]=c[(c[j>>2]|0)+28>>2];c[K>>2]=c[(c[k>>2]|0)+28>>2];c[L>>2]=c[(c[m>>2]|0)+28>>2];c[c[u>>2]>>2]=0;c[w>>2]=0;e:while(1){if((c[w>>2]|0)>=(c[l>>2]|0))break c;c[x>>2]=c[(c[o>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[x>>2]|0)>=(c[(c[o>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[B>>2]=c[(c[p>>2]|0)+(c[x>>2]<<2)>>2];c[z>>2]=c[(c[q>>2]|0)+(c[B>>2]<<2)>>2];while(1){if((c[z>>2]|0)>=(c[(c[q>>2]|0)+((c[B>>2]|0)+1<<2)>>2]|0))break;c[A>>2]=c[(c[r>>2]|0)+(c[z>>2]<<2)>>2];c[y>>2]=c[(c[s>>2]|0)+(c[A>>2]<<2)>>2];while(1){if((c[y>>2]|0)>=(c[(c[s>>2]|0)+((c[A>>2]|0)+1<<2)>>2]|0))break;if((c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)){c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]=c[D>>2];c[(c[v>>2]|0)+(c[D>>2]<<2)>>2]=c[(c[t>>2]|0)+(c[y>>2]<<2)>>2];h[(c[L>>2]|0)+(c[D>>2]<<1<<3)>>3]=(+h[(c[I>>2]|0)+(c[x>>2]<<1<<3)>>3]*+h[(c[J>>2]|0)+(c[z>>2]<<1<<3)>>3]-+h[(c[I>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]*+h[(c[J>>2]|0)+((c[z>>2]<<1)+1<<3)>>3])*+h[(c[K>>2]|0)+(c[y>>2]<<1<<3)>>3]-(+h[(c[I>>2]|0)+(c[x>>2]<<1<<3)>>3]*+h[(c[J>>2]|0)+((c[z>>2]<<1)+1<<3)>>3]+ +h[(c[I>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]*+h[(c[J>>2]|0)+(c[z>>2]<<1<<3)>>3])*+h[(c[K>>2]|0)+((c[y>>2]<<1)+1<<3)>>3];h[(c[L>>2]|0)+((c[D>>2]<<1)+1<<3)>>3]=(+h[(c[I>>2]|0)+(c[x>>2]<<1<<3)>>3]*+h[(c[J>>2]|0)+((c[z>>2]<<1)+1<<3)>>3]+ +h[(c[I>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]*+h[(c[J>>2]|0)+(c[z>>2]<<1<<3)>>3])*+h[(c[K>>2]|0)+(c[y>>2]<<1<<3)>>3]+(+h[(c[I>>2]|0)+(c[x>>2]<<1<<3)>>3]*+h[(c[J>>2]|0)+(c[z>>2]<<1<<3)>>3]-+h[(c[I>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]*+h[(c[J>>2]|0)+((c[z>>2]<<1)+1<<3)>>3])*+h[(c[K>>2]|0)+((c[y>>2]<<1)+1<<3)>>3];c[D>>2]=(c[D>>2]|0)+1}else{if((c[(c[v>>2]|0)+(c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0))break e;R=(c[L>>2]|0)+(c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]<<1<<3)|0;h[R>>3]=+h[R>>3]+((+h[(c[I>>2]|0)+(c[x>>2]<<1<<3)>>3]*+h[(c[J>>2]|0)+(c[z>>2]<<1<<3)>>3]-+h[(c[I>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]*+h[(c[J>>2]|0)+((c[z>>2]<<1)+1<<3)>>3])*+h[(c[K>>2]|0)+(c[y>>2]<<1<<3)>>3]-(+h[(c[I>>2]|0)+(c[x>>2]<<1<<3)>>3]*+h[(c[J>>2]|0)+((c[z>>2]<<1)+1<<3)>>3]+ +h[(c[I>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]*+h[(c[J>>2]|0)+(c[z>>2]<<1<<3)>>3])*+h[(c[K>>2]|0)+((c[y>>2]<<1)+1<<3)>>3]);R=(c[L>>2]|0)+((c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)|0;h[R>>3]=+h[R>>3]+((+h[(c[I>>2]|0)+(c[x>>2]<<1<<3)>>3]*+h[(c[J>>2]|0)+((c[z>>2]<<1)+1<<3)>>3]+ +h[(c[I>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]*+h[(c[J>>2]|0)+(c[z>>2]<<1<<3)>>3])*+h[(c[K>>2]|0)+(c[y>>2]<<1<<3)>>3]+(+h[(c[I>>2]|0)+(c[x>>2]<<1<<3)>>3]*+h[(c[J>>2]|0)+(c[z>>2]<<1<<3)>>3]-+h[(c[I>>2]|0)+((c[x>>2]<<1)+1<<3)>>3]*+h[(c[J>>2]|0)+((c[z>>2]<<1)+1<<3)>>3])*+h[(c[K>>2]|0)+((c[y>>2]<<1)+1<<3)>>3])}c[y>>2]=(c[y>>2]|0)+1}c[z>>2]=(c[z>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+1}c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]=c[D>>2];c[w>>2]=(c[w>>2]|0)+1}La(132601,132193,1673,132578);break}case 4:{c[M>>2]=c[(c[g>>2]|0)+28>>2];c[N>>2]=c[(c[j>>2]|0)+28>>2];c[O>>2]=c[(c[k>>2]|0)+28>>2];c[P>>2]=c[(c[m>>2]|0)+28>>2];c[c[u>>2]>>2]=0;c[w>>2]=0;f:while(1){if((c[w>>2]|0)>=(c[l>>2]|0))break c;c[x>>2]=c[(c[o>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[x>>2]|0)>=(c[(c[o>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[B>>2]=c[(c[p>>2]|0)+(c[x>>2]<<2)>>2];c[z>>2]=c[(c[q>>2]|0)+(c[B>>2]<<2)>>2];while(1){if((c[z>>2]|0)>=(c[(c[q>>2]|0)+((c[B>>2]|0)+1<<2)>>2]|0))break;c[A>>2]=c[(c[r>>2]|0)+(c[z>>2]<<2)>>2];c[y>>2]=c[(c[s>>2]|0)+(c[A>>2]<<2)>>2];while(1){if((c[y>>2]|0)>=(c[(c[s>>2]|0)+((c[A>>2]|0)+1<<2)>>2]|0))break;if((c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)){c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]=c[D>>2];c[(c[v>>2]|0)+(c[D>>2]<<2)>>2]=c[(c[t>>2]|0)+(c[y>>2]<<2)>>2];R=_(c[(c[M>>2]|0)+(c[x>>2]<<2)>>2]|0,c[(c[N>>2]|0)+(c[z>>2]<<2)>>2]|0)|0;d=_(R,c[(c[O>>2]|0)+(c[y>>2]<<2)>>2]|0)|0;R=(c[P>>2]|0)+(c[D>>2]<<2)|0;c[R>>2]=(c[R>>2]|0)+d;c[D>>2]=(c[D>>2]|0)+1}else{if((c[(c[v>>2]|0)+(c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0))break f;d=_(c[(c[M>>2]|0)+(c[x>>2]<<2)>>2]|0,c[(c[N>>2]|0)+(c[z>>2]<<2)>>2]|0)|0;R=_(d,c[(c[O>>2]|0)+(c[y>>2]<<2)>>2]|0)|0;d=(c[P>>2]|0)+(c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]<<2)|0;c[d>>2]=(c[d>>2]|0)+R}c[y>>2]=(c[y>>2]|0)+1}c[z>>2]=(c[z>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+1}c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]=c[D>>2];c[w>>2]=(c[w>>2]|0)+1}La(132601,132193,1705,132578);break}case 8:{c[c[u>>2]>>2]=0;c[w>>2]=0;g:while(1){if((c[w>>2]|0)>=(c[l>>2]|0))break c;c[x>>2]=c[(c[o>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[x>>2]|0)>=(c[(c[o>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[B>>2]=c[(c[p>>2]|0)+(c[x>>2]<<2)>>2];c[z>>2]=c[(c[q>>2]|0)+(c[B>>2]<<2)>>2];while(1){if((c[z>>2]|0)>=(c[(c[q>>2]|0)+((c[B>>2]|0)+1<<2)>>2]|0))break;c[A>>2]=c[(c[r>>2]|0)+(c[z>>2]<<2)>>2];c[y>>2]=c[(c[s>>2]|0)+(c[A>>2]<<2)>>2];while(1){if((c[y>>2]|0)>=(c[(c[s>>2]|0)+((c[A>>2]|0)+1<<2)>>2]|0))break;if((c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]|0)>=(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)){if((c[(c[v>>2]|0)+(c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]|0))break g}else{c[(c[n>>2]|0)+(c[(c[t>>2]|0)+(c[y>>2]<<2)>>2]<<2)>>2]=c[D>>2];c[(c[v>>2]|0)+(c[D>>2]<<2)>>2]=c[(c[t>>2]|0)+(c[y>>2]<<2)>>2];c[D>>2]=(c[D>>2]|0)+1}c[y>>2]=(c[y>>2]|0)+1}c[z>>2]=(c[z>>2]|0)+1}c[x>>2]=(c[x>>2]|0)+1}c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]=c[D>>2];c[w>>2]=(c[w>>2]|0)+1}La(132601,132193,1728,132578);break}default:{Lv(c[m>>2]|0);c[m>>2]=0;break b}}while(0);c[(c[m>>2]|0)+8>>2]=c[D>>2]}while(0);O4(c[n>>2]|0);c[f>>2]=c[m>>2];Q=c[f>>2]|0;i=e;return Q|0}c[f>>2]=0;Q=c[f>>2]|0;i=e;return Q|0}function _v(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+96|0;e=d+80|0;f=d+76|0;g=d+72|0;j=d+68|0;k=d+64|0;l=d+60|0;m=d+56|0;n=d+52|0;o=d+48|0;p=d+44|0;q=d+40|0;r=d+36|0;s=d+32|0;t=d+28|0;u=d+24|0;v=d+20|0;w=d+16|0;x=d+12|0;y=d+8|0;z=d+4|0;A=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[f>>2]|0)+20>>2];c[k>>2]=c[(c[f>>2]|0)+24>>2];c[l>>2]=c[(c[f>>2]|0)+16>>2];c[m>>2]=c[(c[f>>2]|0)+4>>2];c[n>>2]=0;c[o>>2]=0;if(!(c[g>>2]|0)){c[e>>2]=c[f>>2];B=c[e>>2]|0;i=d;return B|0}c[n>>2]=cK(c[m>>2]<<2)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[m>>2]|0))break;c[(c[n>>2]|0)+(c[p>>2]<<2)>>2]=-1;c[p>>2]=(c[p>>2]|0)+1}a:do switch(c[l>>2]|0){case 1:{c[s>>2]=c[(c[f>>2]|0)+28>>2];c[o>>2]=0;c[r>>2]=c[c[j>>2]>>2];c[p>>2]=0;b:while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break a;c[q>>2]=c[r>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;b=c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0;if((c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)){c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=b;h[(c[s>>2]|0)+(c[o>>2]<<3)>>3]=+h[(c[s>>2]|0)+(c[q>>2]<<3)>>3];a=c[o>>2]|0;c[o>>2]=a+1;c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]=a}else{if((c[(c[k>>2]|0)+(c[(c[n>>2]|0)+(b<<2)>>2]<<2)>>2]|0)!=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0))break b;b=(c[s>>2]|0)+(c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[s>>2]|0)+(c[q>>2]<<3)>>3]}c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[o>>2];c[p>>2]=(c[p>>2]|0)+1}La(132626,132193,1791,132651);break}case 2:{c[t>>2]=c[(c[f>>2]|0)+28>>2];if((c[g>>2]|0)==1){c[o>>2]=0;c[r>>2]=c[c[j>>2]>>2];c[p>>2]=0;c:while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break a;c[q>>2]=c[r>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;b=c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0;if((c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)){c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=b;h[(c[t>>2]|0)+(c[o>>2]<<1<<3)>>3]=+h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3];h[(c[t>>2]|0)+((c[o>>2]<<1)+1<<3)>>3]=+h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3];a=c[o>>2]|0;c[o>>2]=a+1;c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]=a}else{if((c[(c[k>>2]|0)+(c[(c[n>>2]|0)+(b<<2)>>2]<<2)>>2]|0)!=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0))break c;b=(c[t>>2]|0)+(c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]<<1<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3];b=(c[t>>2]|0)+((c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3]}c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[o>>2];c[p>>2]=(c[p>>2]|0)+1}La(132626,132193,1814,132651)}if((c[g>>2]|0)==4){c[o>>2]=0;c[r>>2]=c[c[j>>2]>>2];c[p>>2]=0;d:while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break a;c[q>>2]=c[r>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;b=c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0;if((c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)){c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=b;h[(c[t>>2]|0)+(c[o>>2]<<1<<3)>>3]=+h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3];h[(c[t>>2]|0)+((c[o>>2]<<1)+1<<3)>>3]=+h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3];a=c[o>>2]|0;c[o>>2]=a+1;c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]=a}else{if((c[(c[k>>2]|0)+(c[(c[n>>2]|0)+(b<<2)>>2]<<2)>>2]|0)!=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0))break d;b=(c[t>>2]|0)+(c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]<<1<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3];h[(c[t>>2]|0)+((c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)>>3]=+h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3]}c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[o>>2];c[p>>2]=(c[p>>2]|0)+1}La(132626,132193,1834,132651)}if((c[g>>2]|0)!=2){if((c[g>>2]|0)!=3)break a;b=~~+h[(c[t>>2]|0)+8>>3];c[x>>2]=b;c[y>>2]=b;c[o>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break;c[q>>2]=c[(c[j>>2]|0)+(c[p>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;if((c[y>>2]|0)>(~~+h[(c[t>>2]|0)+(c[o>>2]<<1<<3)>>3]|0))C=c[y>>2]|0;else C=~~+h[(c[t>>2]|0)+(c[o>>2]<<1<<3)>>3];c[y>>2]=C;if((c[x>>2]|0)>(~~+h[(c[t>>2]|0)+(c[o>>2]<<1<<3)>>3]|0))D=c[x>>2]|0;else D=~~+h[(c[t>>2]|0)+(c[o>>2]<<1<<3)>>3];c[x>>2]=D;c[o>>2]=(c[o>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}O4(c[n>>2]|0);c[n>>2]=cK(_(c[m>>2]<<2,(c[y>>2]|0)-(c[x>>2]|0)+1|0)|0)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(_(c[m>>2]|0,(c[y>>2]|0)-(c[x>>2]|0)+1|0)|0))break;c[(c[n>>2]|0)+(c[p>>2]<<2)>>2]=-1;c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=0;c[r>>2]=c[c[j>>2]>>2];c[p>>2]=0;e:while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break a;c[q>>2]=c[r>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;c[z>>2]=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0)+(_(~~+h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3]-(c[x>>2]|0)|0,c[m>>2]|0)|0);if((c[(c[n>>2]|0)+(c[z>>2]<<2)>>2]|0)<(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)){c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=c[(c[k>>2]|0)+(c[q>>2]<<2)>>2];h[(c[t>>2]|0)+(c[o>>2]<<1<<3)>>3]=+h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3];h[(c[t>>2]|0)+((c[o>>2]<<1)+1<<3)>>3]=+h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3];b=c[o>>2]|0;c[o>>2]=b+1;c[(c[n>>2]|0)+(c[z>>2]<<2)>>2]=b}else{if((c[(c[k>>2]|0)+(c[(c[n>>2]|0)+(c[z>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0))break e;h[(c[t>>2]|0)+(c[(c[n>>2]|0)+(c[z>>2]<<2)>>2]<<1<<3)>>3]=+h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3];b=(c[t>>2]|0)+((c[(c[n>>2]|0)+(c[z>>2]<<2)>>2]<<1)+1<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3]}c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[o>>2];c[p>>2]=(c[p>>2]|0)+1}La(132704,132193,1904,132651)}b=~~+h[(c[t>>2]|0)+8>>3];c[u>>2]=b;c[v>>2]=b;c[o>>2]=0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break;c[q>>2]=c[(c[j>>2]|0)+(c[p>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;if((c[v>>2]|0)>(~~+h[(c[t>>2]|0)+((c[o>>2]<<1)+1<<3)>>3]|0))E=c[v>>2]|0;else E=~~+h[(c[t>>2]|0)+((c[o>>2]<<1)+1<<3)>>3];c[v>>2]=E;if((c[u>>2]|0)<(~~+h[(c[t>>2]|0)+((c[o>>2]<<1)+1<<3)>>3]|0))F=c[u>>2]|0;else F=~~+h[(c[t>>2]|0)+((c[o>>2]<<1)+1<<3)>>3];c[u>>2]=F;c[o>>2]=(c[o>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}O4(c[n>>2]|0);c[n>>2]=cK(_(c[m>>2]<<2,(c[v>>2]|0)-(c[u>>2]|0)+1|0)|0)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(_(c[m>>2]|0,(c[v>>2]|0)-(c[u>>2]|0)+1|0)|0))break;c[(c[n>>2]|0)+(c[p>>2]<<2)>>2]=-1;c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=0;c[r>>2]=c[c[j>>2]>>2];c[p>>2]=0;f:while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break a;c[q>>2]=c[r>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;c[w>>2]=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0)+(_(~~+h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3]-(c[u>>2]|0)|0,c[m>>2]|0)|0);if((c[(c[n>>2]|0)+(c[w>>2]<<2)>>2]|0)<(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)){c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=c[(c[k>>2]|0)+(c[q>>2]<<2)>>2];h[(c[t>>2]|0)+(c[o>>2]<<1<<3)>>3]=+h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3];h[(c[t>>2]|0)+((c[o>>2]<<1)+1<<3)>>3]=+h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3];b=c[o>>2]|0;c[o>>2]=b+1;c[(c[n>>2]|0)+(c[w>>2]<<2)>>2]=b}else{if((c[w>>2]|0)>=(_(c[m>>2]|0,(c[v>>2]|0)-(c[u>>2]|0)+1|0)|0)){G=65;break f}if((c[(c[k>>2]|0)+(c[(c[n>>2]|0)+(c[w>>2]<<2)>>2]<<2)>>2]|0)!=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0)){G=67;break f}b=(c[t>>2]|0)+(c[(c[n>>2]|0)+(c[w>>2]<<2)>>2]<<1<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[t>>2]|0)+(c[q>>2]<<1<<3)>>3];h[(c[t>>2]|0)+((c[(c[n>>2]|0)+(c[w>>2]<<2)>>2]<<1)+1<<3)>>3]=+h[(c[t>>2]|0)+((c[q>>2]<<1)+1<<3)>>3]}c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[o>>2];c[p>>2]=(c[p>>2]|0)+1}if((G|0)==65)La(132683,132193,1868,132651);else if((G|0)==67)La(132704,132193,1869,132651);break}case 4:{c[A>>2]=c[(c[f>>2]|0)+28>>2];c[o>>2]=0;c[r>>2]=c[c[j>>2]>>2];c[p>>2]=0;g:while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break a;c[q>>2]=c[r>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;b=c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0;if((c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)<(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)){c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=b;c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]=c[(c[A>>2]|0)+(c[q>>2]<<2)>>2];a=c[o>>2]|0;c[o>>2]=a+1;c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]=a}else{if((c[(c[k>>2]|0)+(c[(c[n>>2]|0)+(b<<2)>>2]<<2)>>2]|0)!=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0))break g;b=(c[A>>2]|0)+(c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]<<2)|0;c[b>>2]=(c[b>>2]|0)+(c[(c[A>>2]|0)+(c[q>>2]<<2)>>2]|0)}c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[o>>2];c[p>>2]=(c[p>>2]|0)+1}La(132626,132193,1928,132651);break}case 8:{c[o>>2]=0;c[r>>2]=c[c[j>>2]>>2];c[p>>2]=0;h:while(1){if((c[p>>2]|0)>=(c[c[f>>2]>>2]|0))break a;c[q>>2]=c[r>>2];while(1){if((c[q>>2]|0)>=(c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;b=c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0;if((c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)>=(c[(c[j>>2]|0)+(c[p>>2]<<2)>>2]|0)){if((c[(c[k>>2]|0)+(c[(c[n>>2]|0)+(b<<2)>>2]<<2)>>2]|0)!=(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]|0))break h}else{c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]=b;b=c[o>>2]|0;c[o>>2]=b+1;c[(c[n>>2]|0)+(c[(c[k>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]=b}c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2];c[(c[j>>2]|0)+((c[p>>2]|0)+1<<2)>>2]=c[o>>2];c[p>>2]=(c[p>>2]|0)+1}La(132626,132193,1947,132651);break}case 16:{c[e>>2]=0;B=c[e>>2]|0;i=d;return B|0}default:{c[e>>2]=0;B=c[e>>2]|0;i=d;return B|0}}while(0);c[(c[f>>2]|0)+8>>2]=c[o>>2];O4(c[n>>2]|0);c[e>>2]=c[f>>2];B=c[e>>2]|0;i=d;return B|0}function $v(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;if((c[(c[j>>2]|0)+32>>2]|0)!=2)La(132350,132193,1970,132726);f=c[j>>2]|0;if((c[k>>2]|0)<=0){c[h>>2]=f;r=c[h>>2]|0;i=g;return r|0}c[o>>2]=c[f+8>>2];c[p>>2]=c[(c[j>>2]|0)+12>>2];if(((c[o>>2]|0)+(c[k>>2]|0)|0)>=(c[(c[j>>2]|0)+12>>2]|0)){c[p>>2]=(c[o>>2]|0)+(c[k>>2]|0);c[p>>2]=(10>0?10:0)+(c[p>>2]|0);c[j>>2]=mw(c[j>>2]|0,c[p>>2]|0)|0}Z4((c[(c[j>>2]|0)+20>>2]|0)+((c[o>>2]<<2>>>0)/1|0)|0,c[l>>2]|0,c[k>>2]<<2|0)|0;Z4((c[(c[j>>2]|0)+24>>2]|0)+((c[o>>2]<<2>>>0)/1|0)|0,c[m>>2]|0,c[k>>2]<<2|0)|0;if(c[(c[j>>2]|0)+40>>2]|0){p=(c[(c[j>>2]|0)+28>>2]|0)+(((_(c[o>>2]|0,c[(c[j>>2]|0)+40>>2]|0)|0)>>>0)/1|0)|0;Z4(p|0,c[n>>2]|0,_(c[(c[j>>2]|0)+40>>2]|0,c[k>>2]|0)|0)|0}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;if((c[(c[l>>2]|0)+(c[q>>2]<<2)>>2]|0)>=(c[c[j>>2]>>2]|0))c[c[j>>2]>>2]=(c[(c[l>>2]|0)+(c[q>>2]<<2)>>2]|0)+1;if((c[(c[m>>2]|0)+(c[q>>2]<<2)>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))c[(c[j>>2]|0)+4>>2]=(c[(c[m>>2]|0)+(c[q>>2]<<2)>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1}q=(c[j>>2]|0)+8|0;c[q>>2]=(c[q>>2]|0)+(c[k>>2]|0);c[h>>2]=c[j>>2];r=c[h>>2]|0;i=g;return r|0}function aw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+48|0;d=b+36|0;e=b+32|0;f=b+28|0;g=b+24|0;j=b+20|0;k=b+16|0;l=b;m=b+12|0;n=b+8|0;c[e>>2]=a;a=c[e>>2]|0;if(!(c[e>>2]|0)){c[d>>2]=a;o=c[d>>2]|0;i=b;return o|0}c[j>>2]=c[a+20>>2];c[k>>2]=c[(c[e>>2]|0)+24>>2];a:do switch(c[(c[e>>2]|0)+16>>2]|0){case 1:{c[m>>2]=c[(c[e>>2]|0)+28>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[e>>2]>>2]|0))break a;h[l>>3]=+((c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]|0)-(c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0)|0);c[g>>2]=c[(c[j>>2]|0)+(c[f>>2]<<2)>>2];while(1){if((c[g>>2]|0)>=(c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]|0))break;h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]/+h[l>>3];c[g>>2]=(c[g>>2]|0)+1}c[f>>2]=(c[f>>2]|0)+1}break}case 2:{c[n>>2]=c[(c[e>>2]|0)+28>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[c[e>>2]>>2]|0))break a;h[l>>3]=+((c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]|0)-(c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0)|0);c[g>>2]=c[(c[j>>2]|0)+(c[f>>2]<<2)>>2];while(1){if((c[g>>2]|0)>=(c[(c[j>>2]|0)+((c[f>>2]|0)+1<<2)>>2]|0))break;if((c[(c[k>>2]|0)+(c[g>>2]<<2)>>2]|0)!=(c[f>>2]|0)){h[(c[n>>2]|0)+(c[g>>2]<<1<<3)>>3]=+h[(c[n>>2]|0)+(c[g>>2]<<1<<3)>>3]/+h[l>>3];h[(c[n>>2]|0)+((c[g>>2]<<1)+1<<3)>>3]=+h[(c[n>>2]|0)+((c[g>>2]<<1)+1<<3)>>3]/+h[l>>3]}c[g>>2]=(c[g>>2]|0)+1}c[f>>2]=(c[f>>2]|0)+1}break}case 4:{La(176099,132193,2191,132767);break}case 8:break;case 16:{c[d>>2]=0;o=c[d>>2]|0;i=b;return o|0}default:{c[d>>2]=0;o=c[d>>2]|0;i=b;return o|0}}while(0);c[d>>2]=c[e>>2];o=c[d>>2]|0;i=b;return o|0}function bw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+48|0;d=b+36|0;e=b+32|0;f=b+28|0;g=b+24|0;j=b+20|0;k=b+16|0;l=b+12|0;m=b+8|0;n=b+4|0;o=b;c[e>>2]=a;a=c[e>>2]|0;if(!(c[e>>2]|0)){c[d>>2]=a;p=c[d>>2]|0;i=b;return p|0}c[k>>2]=c[a+8>>2];c[g>>2]=c[(c[e>>2]|0)+20>>2];c[j>>2]=c[(c[e>>2]|0)+24>>2];c[m>>2]=c[(c[e>>2]|0)+4>>2];c[l>>2]=c[c[e>>2]>>2];if((c[m>>2]|0)!=(c[l>>2]|0)){c[d>>2]=0;p=c[d>>2]|0;i=b;return p|0}c[o>>2]=Nv(c[l>>2]|0,c[m>>2]|0,c[k>>2]|0,8,1)|0;Z4(c[(c[o>>2]|0)+20>>2]|0,c[g>>2]|0,(c[l>>2]|0)+1<<2|0)|0;Z4(c[(c[o>>2]|0)+24>>2]|0,c[j>>2]|0,c[k>>2]<<2|0)|0;c[(c[o>>2]|0)+8>>2]=c[(c[e>>2]|0)+8>>2];c[e>>2]=Mv(c[o>>2]|0,1)|0;Lv(c[o>>2]|0);c[e>>2]=Sv(c[e>>2]|0)|0;o=cK(c[(c[e>>2]|0)+8>>2]<<3)|0;c[(c[e>>2]|0)+28>>2]=o;c[n>>2]=c[(c[e>>2]|0)+28>>2];c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[e>>2]|0)+8>>2]|0))break;h[(c[n>>2]|0)+(c[f>>2]<<3)>>3]=1.0;c[f>>2]=(c[f>>2]|0)+1}c[(c[e>>2]|0)+16>>2]=1;c[(c[e>>2]|0)+40>>2]=8;c[d>>2]=c[e>>2];p=c[d>>2]|0;i=b;return p|0}function cw(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;k=i;i=i+80|0;l=k+64|0;m=k+60|0;n=k+56|0;o=k+52|0;p=k+48|0;q=k+44|0;r=k+40|0;s=k+36|0;t=k+32|0;u=k+28|0;v=k+24|0;w=k+20|0;x=k+16|0;y=k+12|0;z=k+8|0;A=k+4|0;B=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;c[v>>2]=0;c[w>>2]=1;c[z>>2]=c[c[m>>2]>>2];c[A>>2]=c[(c[m>>2]|0)+20>>2];c[B>>2]=c[(c[m>>2]|0)+24>>2];if(!(c[c[p>>2]>>2]|0)){m=cK((c[z>>2]|0)+2<<2)|0;c[c[p>>2]>>2]=m}if(!(c[c[q>>2]>>2]|0)){m=cK(c[z>>2]<<2)|0;c[c[q>>2]>>2]=m}a:do if(!(c[c[r>>2]>>2]|0)){m=N4(c[z>>2]<<2)|0;c[c[r>>2]>>2]=m;c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[z>>2]|0))break a;c[(c[c[r>>2]>>2]|0)+(c[t>>2]<<2)>>2]=-10;c[t>>2]=(c[t>>2]|0)+1}}while(0);c[c[o>>2]>>2]=0;if((c[n>>2]|0)<0)La(132801,132193,2515,132823);if((c[n>>2]|0)>=(c[z>>2]|0))La(132801,132193,2515,132823);c[c[c[p>>2]>>2]>>2]=0;c[(c[c[p>>2]>>2]|0)+4>>2]=1;c[c[c[q>>2]>>2]>>2]=c[n>>2];c[(c[c[r>>2]>>2]|0)+(c[n>>2]<<2)>>2]=1;c[c[o>>2]>>2]=1;c[x>>2]=1;c[v>>2]=0;c[w>>2]=1;while(1){if((c[w>>2]|0)<=(c[v>>2]|0))break;if((c[l>>2]|0)>=0?(c[c[o>>2]>>2]|0)>(c[l>>2]|0):0)break;c[t>>2]=c[v>>2];while(1){if((c[t>>2]|0)>=(c[w>>2]|0))break;c[y>>2]=c[(c[c[q>>2]>>2]|0)+(c[t>>2]<<2)>>2];c[u>>2]=c[(c[A>>2]|0)+(c[y>>2]<<2)>>2];while(1){if((c[u>>2]|0)>=(c[(c[A>>2]|0)+((c[y>>2]|0)+1<<2)>>2]|0))break;if((c[y>>2]|0)!=(c[(c[B>>2]|0)+(c[u>>2]<<2)>>2]|0)?(c[(c[c[r>>2]>>2]|0)+(c[(c[B>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]|0)<0:0){n=c[(c[B>>2]|0)+(c[u>>2]<<2)>>2]|0;z=c[x>>2]|0;c[x>>2]=z+1;c[(c[c[q>>2]>>2]|0)+(z<<2)>>2]=n;c[(c[c[r>>2]>>2]|0)+(c[(c[B>>2]|0)+(c[u>>2]<<2)>>2]<<2)>>2]=(c[c[o>>2]>>2]|0)+1}c[u>>2]=(c[u>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}n=c[x>>2]|0;z=c[o>>2]|0;m=(c[z>>2]|0)+1|0;c[z>>2]=m;c[(c[c[p>>2]>>2]|0)+(m<<2)>>2]=n;c[v>>2]=c[w>>2];c[w>>2]=c[x>>2]}if(!((c[l>>2]|0)>=0?(c[c[o>>2]>>2]|0)>(c[l>>2]|0):0)){l=c[o>>2]|0;c[l>>2]=(c[l>>2]|0)+-1}if(!(c[s>>2]|0)){i=k;return}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[(c[c[p>>2]>>2]|0)+(c[c[o>>2]>>2]<<2)>>2]|0))break;c[(c[c[r>>2]>>2]|0)+(c[(c[c[q>>2]>>2]|0)+(c[t>>2]<<2)>>2]<<2)>>2]=-10;c[t>>2]=(c[t>>2]|0)+1}i=k;return}function dw(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;k=i;i=i+32|0;l=k+28|0;m=k+24|0;n=k+20|0;o=k+16|0;p=k+12|0;q=k+8|0;r=k+4|0;s=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;cw(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0);i=k;return}function ew(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+64|0;g=f+60|0;h=f+56|0;j=f+52|0;k=f+48|0;l=f+44|0;m=f+40|0;n=f+36|0;o=f+32|0;p=f+28|0;q=f+24|0;r=f+20|0;s=f+16|0;t=f+12|0;u=f+8|0;v=f+4|0;w=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[(c[g>>2]|0)+20>>2];c[m>>2]=c[(c[g>>2]|0)+24>>2];c[n>>2]=c[(c[g>>2]|0)+4>>2];c[o>>2]=c[c[g>>2]>>2];c[p>>2]=0;c[q>>2]=0;c[t>>2]=0;c[p>>2]=cK(c[n>>2]<<2)|0;c[q>>2]=cK((c[n>>2]|0)+1<<2)|0;c[t>>2]=cK(c[n>>2]<<2)|0;c[v>>2]=cK(c[n>>2]<<2)|0;c[q>>2]=(c[q>>2]|0)+4;c[u>>2]=0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[n>>2]|0))break;c[(c[p>>2]|0)+(c[r>>2]<<2)>>2]=c[u>>2];c[r>>2]=(c[r>>2]|0)+1}c[c[q>>2]>>2]=c[n>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[n>>2]|0))break;c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]=-1;c[r>>2]=(c[r>>2]|0)+1}c[u>>2]=(c[u>>2]|0)+1;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[o>>2]|0))break;c[s>>2]=c[(c[l>>2]|0)+(c[r>>2]<<2)>>2];while(1){if((c[s>>2]|0)>=(c[(c[l>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;c[w>>2]=c[(c[p>>2]|0)+(c[(c[m>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2];g=(c[q>>2]|0)+(c[w>>2]<<2)|0;c[g>>2]=(c[g>>2]|0)+-1;c[s>>2]=(c[s>>2]|0)+1}c[s>>2]=c[(c[l>>2]|0)+(c[r>>2]<<2)>>2];while(1){if((c[s>>2]|0)>=(c[(c[l>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;c[w>>2]=c[(c[p>>2]|0)+(c[(c[m>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2];do if((c[(c[t>>2]|0)+(c[w>>2]<<2)>>2]|0)<(c[r>>2]|0)){c[(c[t>>2]|0)+(c[w>>2]<<2)>>2]=c[r>>2];if(!(c[(c[q>>2]|0)+(c[w>>2]<<2)>>2]|0)){c[(c[q>>2]|0)+(c[w>>2]<<2)>>2]=1;c[(c[v>>2]|0)+(c[w>>2]<<2)>>2]=c[w>>2];break}else{c[(c[v>>2]|0)+(c[w>>2]<<2)>>2]=c[u>>2];c[(c[q>>2]|0)+(c[u>>2]<<2)>>2]=1;g=c[u>>2]|0;c[u>>2]=g+1;c[(c[p>>2]|0)+(c[(c[m>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]=g;break}}else{c[(c[p>>2]|0)+(c[(c[m>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]=c[(c[v>>2]|0)+(c[w>>2]<<2)>>2];g=(c[q>>2]|0)+(c[(c[v>>2]|0)+(c[w>>2]<<2)>>2]<<2)|0;c[g>>2]=(c[g>>2]|0)+1}while(0);c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+-4;c[c[q>>2]>>2]=0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[u>>2]|0))break;s=(c[q>>2]|0)+((c[r>>2]|0)+1<<2)|0;c[s>>2]=(c[s>>2]|0)+(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]|0);c[r>>2]=(c[r>>2]|0)+1}c[c[j>>2]>>2]=c[v>>2];c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[n>>2]|0))break;c[w>>2]=c[(c[p>>2]|0)+(c[r>>2]<<2)>>2];v=c[r>>2]|0;s=(c[q>>2]|0)+(c[w>>2]<<2)|0;m=c[s>>2]|0;c[s>>2]=m+1;c[(c[c[j>>2]>>2]|0)+(m<<2)>>2]=v;c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=c[u>>2];while(1){if((c[r>>2]|0)<=0)break;c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=c[(c[q>>2]|0)+((c[r>>2]|0)-1<<2)>>2];c[r>>2]=(c[r>>2]|0)+-1}c[c[q>>2]>>2]=0;c[c[k>>2]>>2]=c[q>>2];c[c[h>>2]>>2]=c[u>>2];O4(c[t>>2]|0);O4(c[p>>2]|0);i=f;return}function fw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+96|0;f=e+92|0;g=e+88|0;j=e+84|0;k=e+80|0;l=e+76|0;m=e+72|0;n=e+68|0;o=e+64|0;p=e+60|0;q=e+56|0;r=e+52|0;s=e+48|0;t=e+44|0;u=e+40|0;v=e+36|0;w=e+32|0;x=e+28|0;y=e+24|0;z=e+20|0;A=e+16|0;B=e+8|0;C=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[g>>2];c[n>>2]=c[c[k>>2]>>2];c[o>>2]=c[(c[k>>2]|0)+4>>2];c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;c[u>>2]=0;c[v>>2]=0;if(!(Ov(c[k>>2]|0,0)|0))c[k>>2]=Mv(c[k>>2]|0,0)|0;if((c[n>>2]|0)!=(c[o>>2]|0))La(132901,132193,3768,132908);c[l>>2]=Nv(c[o>>2]|0,c[o>>2]|0,1,1,2)|0;a:do if(c[j>>2]|0){c[u>>2]=cK(c[o>>2]<<2)|0;c[s>>2]=cK(c[o>>2]<<3)|0;c[y>>2]=0;b:while(1){if((c[y>>2]|0)>=(c[o>>2]|0))break a;dw(c[f>>2]|0,c[k>>2]|0,c[y>>2]|0,A,p,q,r,0);if(((c[A>>2]|0)-1|0)>(c[f>>2]|0)){D=20;break}c[v>>2]=nw(c[k>>2]|0,c[y>>2]|0,c[s>>2]|0,t,c[u>>2]|0,B,c[r>>2]|0)|0;if(c[v>>2]|0){D=22;break}c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[A>>2]|0))break;c[x>>2]=c[(c[p>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[x>>2]|0)>=(c[(c[p>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;if((c[(c[r>>2]|0)+(c[(c[q>>2]|0)+(c[x>>2]<<2)>>2]<<2)>>2]|0)!=((c[w>>2]|0)+1|0)){D=28;break b}c[(c[r>>2]|0)+(c[(c[q>>2]|0)+(c[x>>2]<<2)>>2]<<2)>>2]=-1;c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=(c[w>>2]|0)+1}c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[t>>2]|0))break;c[z>>2]=c[(c[u>>2]|0)+(c[x>>2]<<2)>>2];h[C>>3]=+h[(c[s>>2]|0)+(c[z>>2]<<3)>>3];if((c[y>>2]|0)!=(c[z>>2]|0))c[l>>2]=$v(c[l>>2]|0,1,y,z,C)|0;c[x>>2]=(c[x>>2]|0)+1}c[y>>2]=(c[y>>2]|0)+1}if((D|0)==20)La(132943,132193,3802,132908);else if((D|0)==22)La(133636,132193,3804,132908);else if((D|0)==28)La(132961,132193,3807,132908)}else{c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[o>>2]|0))break a;dw(c[f>>2]|0,c[k>>2]|0,c[y>>2]|0,A,p,q,r,1);c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[A>>2]|0))break;c[x>>2]=c[(c[p>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[x>>2]|0)>=(c[(c[p>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[z>>2]=c[(c[q>>2]|0)+(c[x>>2]<<2)>>2];h[C>>3]=+(c[w>>2]|0);if((c[y>>2]|0)!=(c[z>>2]|0))c[l>>2]=$v(c[l>>2]|0,1,y,z,C)|0;c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=(c[w>>2]|0)+1}c[y>>2]=(c[y>>2]|0)+1}}while(0);c[m>>2]=Uv(c[l>>2]|0)|0;Lv(c[l>>2]|0);if(c[p>>2]|0)O4(c[p>>2]|0);if(c[q>>2]|0)O4(c[q>>2]|0);if(c[r>>2]|0)O4(c[r>>2]|0);if(c[s>>2]|0)O4(c[s>>2]|0);if((c[k>>2]|0)!=(c[g>>2]|0))Lv(c[k>>2]|0);if(!(c[u>>2]|0)){E=c[m>>2]|0;F=Mv(E,0)|0;c[k>>2]=F;G=c[m>>2]|0;Lv(G);H=c[k>>2]|0;i=e;return H|0}O4(c[u>>2]|0);E=c[m>>2]|0;F=Mv(E,0)|0;c[k>>2]=F;G=c[m>>2]|0;Lv(G);H=c[k>>2]|0;i=e;return H|0}function gw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;switch(c[d>>2]|0){case 1:{c[e>>2]=8;break}case 2:{c[e>>2]=16;break}case 4:{c[e>>2]=4;break}case 8:{c[e>>2]=0;break}case 16:{c[e>>2]=0;break}default:c[e>>2]=0}i=b;return c[e>>2]|0}function hw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=cK(44)|0;c[c[n>>2]>>2]=c[h>>2];c[(c[n>>2]|0)+4>>2]=c[j>>2];c[(c[n>>2]|0)+8>>2]=0;c[(c[n>>2]|0)+12>>2]=0;c[(c[n>>2]|0)+16>>2]=c[k>>2];c[(c[n>>2]|0)+40>>2]=c[l>>2];if((c[m>>2]|0)==2)c[(c[n>>2]|0)+20>>2]=0;else{l=cK((c[h>>2]|0)+1<<2)|0;c[(c[n>>2]|0)+20>>2]=l}c[(c[n>>2]|0)+24>>2]=0;c[(c[n>>2]|0)+28>>2]=0;c[(c[n>>2]|0)+32>>2]=c[m>>2];c[(c[n>>2]|0)+36>>2]=0;m=(c[n>>2]|0)+36|0;c[m>>2]=c[m>>2]&-2;m=(c[n>>2]|0)+36|0;c[m>>2]=c[m>>2]&-3;m=(c[n>>2]|0)+36|0;c[m>>2]=c[m>>2]&-5;m=(c[n>>2]|0)+36|0;c[m>>2]=c[m>>2]&-9;i=g;return c[n>>2]|0}function iw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[e>>2]|0)+32>>2];c[h>>2]=c[f>>2];c[(c[e>>2]|0)+28>>2]=0;b=(c[g>>2]|0)==2;g=cK(c[h>>2]<<2)|0;a=c[e>>2]|0;if(!b){c[a+24>>2]=g;if((c[h>>2]|0)>>>0>0?(c[(c[e>>2]|0)+40>>2]|0)>0:0){b=cK(_(c[(c[e>>2]|0)+40>>2]|0,c[h>>2]|0)|0)|0;c[(c[e>>2]|0)+28>>2]=b}}else{c[a+20>>2]=g;g=cK(c[h>>2]<<2)|0;c[(c[e>>2]|0)+24>>2]=g;g=cK(_(c[(c[e>>2]|0)+40>>2]|0,c[h>>2]|0)|0)|0;c[(c[e>>2]|0)+28>>2]=g}c[(c[e>>2]|0)+12>>2]=c[f>>2];i=d;return c[e>>2]|0}function jw(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;m=i;i=i+80|0;n=m+68|0;o=m+64|0;p=m+60|0;q=m+56|0;r=m+52|0;s=m+48|0;t=m+44|0;u=m+40|0;v=m+36|0;w=m+32|0;x=m+28|0;y=m+24|0;z=m+20|0;A=m+16|0;B=m+12|0;C=m+8|0;D=m+4|0;E=m;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;c[x>>2]=0;if(!((c[p>>2]|0)>0&(c[q>>2]|0)>0&(c[o>>2]|0)>=0))La(133100,132193,842,133126);if((c[p>>2]|0)<=0|(c[q>>2]|0)<=0|(c[o>>2]|0)<0){c[n>>2]=0;F=c[n>>2]|0;i=m;return F|0}c[x>>2]=Tv(c[p>>2]|0,c[q>>2]|0,c[o>>2]|0,c[u>>2]|0,c[v>>2]|0,1)|0;if(!(c[x>>2]|0))La(133171,132193,846,133126);if(!(c[x>>2]|0)){c[n>>2]=0;F=c[n>>2]|0;i=m;return F|0}c[y>>2]=c[(c[x>>2]|0)+20>>2];c[z>>2]=c[(c[x>>2]|0)+24>>2];c[E>>2]=0;while(1){if((c[E>>2]|0)>(c[p>>2]|0))break;c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]=0;c[E>>2]=(c[E>>2]|0)+1}a:do switch(c[u>>2]|0){case 1:{c[B>>2]=c[t>>2];c[A>>2]=c[(c[x>>2]|0)+28>>2];c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0)){G=21;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=19;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[p>>2]|0)){G=19;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=19;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[q>>2]|0)){G=19;break}v=(c[y>>2]|0)+((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+1;c[E>>2]=(c[E>>2]|0)+1}if((G|0)==19)La(176099,132193,861,133126);else if((G|0)==21){c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[p>>2]|0))break;v=(c[y>>2]|0)+((c[E>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+(c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]|0);c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0))break;h[(c[A>>2]|0)+(c[(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)>>2]<<3)>>3]=+h[(c[B>>2]|0)+(c[E>>2]<<3)>>3];v=c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0;l=(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)|0;k=c[l>>2]|0;c[l>>2]=k+1;c[(c[z>>2]|0)+(k<<2)>>2]=v;c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=c[p>>2];while(1){if((c[E>>2]|0)<=0)break;c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[y>>2]|0)+((c[E>>2]|0)-1<<2)>>2];c[E>>2]=(c[E>>2]|0)+-1}c[c[y>>2]>>2]=0;break a}break}case 2:{c[B>>2]=c[t>>2];c[A>>2]=c[(c[x>>2]|0)+28>>2];c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0)){G=39;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=37;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[p>>2]|0)){G=37;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=37;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[q>>2]|0)){G=37;break}v=(c[y>>2]|0)+((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+1;c[E>>2]=(c[E>>2]|0)+1}if((G|0)==37)La(176099,132193,879,133126);else if((G|0)==39){c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[p>>2]|0))break;v=(c[y>>2]|0)+((c[E>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+(c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]|0);c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0))break;v=c[B>>2]|0;c[B>>2]=v+8;h[(c[A>>2]|0)+(c[(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)>>2]<<1<<3)>>3]=+h[v>>3];v=c[B>>2]|0;c[B>>2]=v+8;h[(c[A>>2]|0)+((c[(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)>>2]<<1)+1<<3)>>3]=+h[v>>3];v=c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0;k=(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)|0;l=c[k>>2]|0;c[k>>2]=l+1;c[(c[z>>2]|0)+(l<<2)>>2]=v;c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=c[p>>2];while(1){if((c[E>>2]|0)<=0)break;c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[y>>2]|0)+((c[E>>2]|0)-1<<2)>>2];c[E>>2]=(c[E>>2]|0)+-1}c[c[y>>2]>>2]=0;break a}break}case 4:{c[D>>2]=c[t>>2];c[C>>2]=c[(c[x>>2]|0)+28>>2];c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0)){G=57;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=55;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[p>>2]|0)){G=55;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=55;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[q>>2]|0)){G=55;break}v=(c[y>>2]|0)+((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+1;c[E>>2]=(c[E>>2]|0)+1}if((G|0)==55)La(176099,132193,898,133126);else if((G|0)==57){c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[p>>2]|0))break;v=(c[y>>2]|0)+((c[E>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+(c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]|0);c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0))break;c[(c[C>>2]|0)+(c[(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)>>2]<<2)>>2]=c[(c[D>>2]|0)+(c[E>>2]<<2)>>2];v=c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0;l=(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)|0;k=c[l>>2]|0;c[l>>2]=k+1;c[(c[z>>2]|0)+(k<<2)>>2]=v;c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=c[p>>2];while(1){if((c[E>>2]|0)<=0)break;c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[y>>2]|0)+((c[E>>2]|0)-1<<2)>>2];c[E>>2]=(c[E>>2]|0)+-1}c[c[y>>2]>>2]=0;break a}break}case 8:{c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0)){G=75;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=73;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[p>>2]|0)){G=73;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=73;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[q>>2]|0)){G=73;break}v=(c[y>>2]|0)+((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+1;c[E>>2]=(c[E>>2]|0)+1}if((G|0)==73)La(176099,132193,914,133126);else if((G|0)==75){c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[p>>2]|0))break;v=(c[y>>2]|0)+((c[E>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+(c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]|0);c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0))break;v=c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0;k=(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)|0;l=c[k>>2]|0;c[k>>2]=l+1;c[(c[z>>2]|0)+(l<<2)>>2]=v;c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=c[p>>2];while(1){if((c[E>>2]|0)<=0)break;c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[y>>2]|0)+((c[E>>2]|0)-1<<2)>>2];c[E>>2]=(c[E>>2]|0)+-1}c[c[y>>2]>>2]=0;break a}break}case 16:{c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0)){G=93;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=91;break}if((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[p>>2]|0)){G=91;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)<0){G=91;break}if((c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0)>=(c[q>>2]|0)){G=91;break}v=(c[y>>2]|0)+((c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+1;c[E>>2]=(c[E>>2]|0)+1}if((G|0)==91)La(176099,132193,929,133126);else if((G|0)==93){c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[p>>2]|0))break;v=(c[y>>2]|0)+((c[E>>2]|0)+1<<2)|0;c[v>>2]=(c[v>>2]|0)+(c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]|0);c[E>>2]=(c[E>>2]|0)+1}Z4(c[(c[x>>2]|0)+28>>2]|0,c[t>>2]|0,_(c[(c[x>>2]|0)+40>>2]|0,c[o>>2]|0)|0)|0;c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[o>>2]|0))break;v=c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]|0;l=(c[y>>2]|0)+(c[(c[r>>2]|0)+(c[E>>2]<<2)>>2]<<2)|0;k=c[l>>2]|0;c[l>>2]=k+1;c[(c[z>>2]|0)+(k<<2)>>2]=v;c[E>>2]=(c[E>>2]|0)+1}c[E>>2]=c[p>>2];while(1){if((c[E>>2]|0)<=0)break;c[(c[y>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[y>>2]|0)+((c[E>>2]|0)-1<<2)>>2];c[E>>2]=(c[E>>2]|0)+-1}c[c[y>>2]>>2]=0;break a}break}default:La(176099,132193,943,133126)}while(0);c[(c[x>>2]|0)+8>>2]=c[o>>2];if(c[w>>2]|0)c[x>>2]=_v(c[x>>2]|0,c[w>>2]|0)|0;c[n>>2]=c[x>>2];F=c[n>>2]|0;i=m;return F|0}function kw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;j=i;i=i+64|0;k=j+56|0;l=j+52|0;m=j+48|0;n=j+44|0;o=j+40|0;p=j+36|0;q=j+32|0;r=j+28|0;s=j+24|0;t=j+20|0;u=j+16|0;v=j+12|0;w=j+8|0;x=j+4|0;y=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;if((c[(c[k>>2]|0)+32>>2]|0)!=1)La(132169,132193,1120,133071);if((c[(c[k>>2]|0)+16>>2]|0)!=1)La(132503,132193,1121,133071);c[x>>2]=c[(c[k>>2]|0)+28>>2];c[t>>2]=c[(c[k>>2]|0)+20>>2];c[u>>2]=c[(c[k>>2]|0)+24>>2];c[w>>2]=c[c[k>>2]>>2];c[v>>2]=c[(c[k>>2]|0)+4>>2];c[y>>2]=c[c[m>>2]>>2];k=(c[y>>2]|0)!=0;if(c[o>>2]|0){if(!k)c[y>>2]=cK(_(c[v>>2]<<3,c[n>>2]|0)|0)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(_(c[v>>2]|0,c[n>>2]|0)|0))break;h[(c[y>>2]|0)+(c[q>>2]<<3)>>3]=0.0;c[q>>2]=(c[q>>2]|0)+1}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[w>>2]|0))break;c[r>>2]=c[(c[t>>2]|0)+(c[q>>2]<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[t>>2]|0)+((c[q>>2]|0)+1<<2)>>2]|0))break;c[s>>2]=0;while(1){z=c[r>>2]|0;if((c[s>>2]|0)>=(c[n>>2]|0))break;o=_(c[q>>2]|0,c[n>>2]|0)|0;g=_(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0,c[n>>2]|0)|0;f=(c[y>>2]|0)+(g+(c[s>>2]|0)<<3)|0;h[f>>3]=+h[f>>3]+ +h[(c[x>>2]|0)+(z<<3)>>3]*+h[(c[l>>2]|0)+(o+(c[s>>2]|0)<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=z+1}c[q>>2]=(c[q>>2]|0)+1}if(!(c[p>>2]|0)){A=c[y>>2]|0;B=c[m>>2]|0;c[B>>2]=A;i=j;return}qw(c[y>>2]|0,c[v>>2]|0,c[n>>2]|0);A=c[y>>2]|0;B=c[m>>2]|0;c[B>>2]=A;i=j;return}else{if(!k)c[y>>2]=cK(_(c[w>>2]<<3,c[n>>2]|0)|0)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[w>>2]|0))break;c[s>>2]=0;while(1){C=c[q>>2]|0;if((c[s>>2]|0)>=(c[n>>2]|0))break;k=_(C,c[n>>2]|0)|0;h[(c[y>>2]|0)+(k+(c[s>>2]|0)<<3)>>3]=0.0;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=c[(c[t>>2]|0)+(C<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[t>>2]|0)+((c[q>>2]|0)+1<<2)>>2]|0))break;c[s>>2]=0;while(1){D=c[r>>2]|0;if((c[s>>2]|0)>=(c[n>>2]|0))break;k=_(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0,c[n>>2]|0)|0;v=_(c[q>>2]|0,c[n>>2]|0)|0;z=(c[y>>2]|0)+(v+(c[s>>2]|0)<<3)|0;h[z>>3]=+h[z>>3]+ +h[(c[x>>2]|0)+(D<<3)>>3]*+h[(c[l>>2]|0)+(k+(c[s>>2]|0)<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=D+1}c[q>>2]=(c[q>>2]|0)+1}if(!(c[p>>2]|0)){A=c[y>>2]|0;B=c[m>>2]|0;c[B>>2]=A;i=j;return}qw(c[y>>2]|0,c[w>>2]|0,c[n>>2]|0);A=c[y>>2]|0;B=c[m>>2]|0;c[B>>2]=A;i=j;return}}function lw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h+40|0;k=h+36|0;l=h+32|0;m=h+28|0;n=h+24|0;o=h+20|0;p=h+16|0;q=h+12|0;r=h+8|0;s=h+4|0;t=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;if((c[(c[j>>2]|0)+32>>2]|0)!=1)La(132169,132193,1162,133042);if((c[(c[j>>2]|0)+16>>2]|0)!=1)La(132503,132193,1163,133042);c[p>>2]=c[c[l>>2]>>2];c[s>>2]=c[c[j>>2]>>2];c[t>>2]=c[(c[j>>2]|0)+4>>2];g=(c[p>>2]|0)!=0;if(c[n>>2]|0){if(!g)c[p>>2]=cK(_(c[t>>2]<<3,c[m>>2]|0)|0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;f=_(c[t>>2]|0,c[r>>2]|0)|0;c[q>>2]=(c[p>>2]|0)+(f<<3);f=_(c[s>>2]|0,c[r>>2]|0)|0;Xv(c[j>>2]|0,(c[k>>2]|0)+(f<<3)|0,q,c[n>>2]|0);c[r>>2]=(c[r>>2]|0)+1}if(c[o>>2]|0){u=c[p>>2]|0;v=c[l>>2]|0;c[v>>2]=u;i=h;return}qw(c[p>>2]|0,c[m>>2]|0,c[t>>2]|0);u=c[p>>2]|0;v=c[l>>2]|0;c[v>>2]=u;i=h;return}else{if(!g)c[p>>2]=cK(_(c[s>>2]<<3,c[m>>2]|0)|0)|0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[m>>2]|0))break;g=_(c[s>>2]|0,c[r>>2]|0)|0;c[q>>2]=(c[p>>2]|0)+(g<<3);g=_(c[t>>2]|0,c[r>>2]|0)|0;Xv(c[j>>2]|0,(c[k>>2]|0)+(g<<3)|0,q,c[n>>2]|0);c[r>>2]=(c[r>>2]|0)+1}if(c[o>>2]|0){u=c[p>>2]|0;v=c[l>>2]|0;c[v>>2]=u;i=h;return}qw(c[p>>2]|0,c[m>>2]|0,c[s>>2]|0);u=c[p>>2]|0;v=c[l>>2]|0;c[v>>2]=u;i=h;return}}function mw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[e>>2]|0)+32>>2];c[h>>2]=c[f>>2];b=c[e>>2]|0;do if((c[g>>2]|0)==2){a=eK(c[b+20>>2]|0,c[h>>2]<<2)|0;c[(c[e>>2]|0)+20>>2]=a;a=eK(c[(c[e>>2]|0)+24>>2]|0,c[h>>2]<<2)|0;c[(c[e>>2]|0)+24>>2]=a;if((c[(c[e>>2]|0)+40>>2]|0)>0){a=c[e>>2]|0;if(c[(c[e>>2]|0)+28>>2]|0){j=eK(c[a+28>>2]|0,_(c[(c[e>>2]|0)+40>>2]|0,c[h>>2]|0)|0)|0;c[(c[e>>2]|0)+28>>2]=j;break}else{j=cK(_(c[a+40>>2]|0,c[h>>2]|0)|0)|0;c[(c[e>>2]|0)+28>>2]=j;break}}}else{j=eK(c[b+24>>2]|0,c[h>>2]<<2)|0;c[(c[e>>2]|0)+24>>2]=j;if((c[(c[e>>2]|0)+40>>2]|0)>0){j=c[e>>2]|0;if(c[(c[e>>2]|0)+28>>2]|0){a=eK(c[j+28>>2]|0,_(c[(c[e>>2]|0)+40>>2]|0,c[h>>2]|0)|0)|0;c[(c[e>>2]|0)+28>>2]=a;break}else{a=cK(_(c[j+40>>2]|0,c[h>>2]|0)|0)|0;c[(c[e>>2]|0)+28>>2]=a;break}}}while(0);c[(c[e>>2]|0)+12>>2]=c[f>>2];i=d;return c[e>>2]|0}function nw(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+32|0;k=j+24|0;l=j+20|0;m=j+16|0;n=j+12|0;o=j+8|0;p=j+4|0;q=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;h=ow(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0)|0;i=j;return h|0}function ow(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0;k=i;i=i+96|0;l=k+88|0;m=k+84|0;n=k+80|0;o=k+76|0;p=k+72|0;q=k+68|0;r=k+64|0;s=k+60|0;t=k+56|0;u=k+52|0;v=k+48|0;w=k+44|0;x=k+40|0;y=k+36|0;z=k+32|0;A=k+28|0;B=k+24|0;C=k+20|0;D=k+16|0;E=k+12|0;F=k+8|0;G=k+4|0;H=k;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;c[t>>2]=c[c[m>>2]>>2];c[x>>2]=c[(c[m>>2]|0)+20>>2];c[y>>2]=c[(c[m>>2]|0)+24>>2];c[B>>2]=0;c[H>>2]=0;if(!(Ov(c[m>>2]|0,1)|0))La(132866,132193,2633,132986);if((c[t>>2]|0)!=(c[(c[m>>2]|0)+4>>2]|0))La(132856,132193,2635,132986);a:do switch(c[(c[m>>2]|0)+16>>2]|0){case 2:{c[C>>2]=c[(c[m>>2]|0)+28>>2];c[B>>2]=cK(c[(c[m>>2]|0)+8>>2]<<3)|0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[(c[m>>2]|0)+8>>2]|0))break a;h[(c[B>>2]|0)+(c[u>>2]<<3)>>3]=+h[(c[C>>2]|0)+(c[u>>2]<<1<<3)>>3];c[u>>2]=(c[u>>2]|0)+1}break}case 1:{c[B>>2]=c[(c[m>>2]|0)+28>>2];break}case 4:{c[D>>2]=c[(c[m>>2]|0)+28>>2];c[B>>2]=cK(c[(c[m>>2]|0)+8>>2]<<3)|0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[(c[m>>2]|0)+8>>2]|0))break a;h[(c[B>>2]|0)+(c[u>>2]<<3)>>3]=+(c[(c[D>>2]|0)+(c[u>>2]<<2)>>2]|0);c[u>>2]=(c[u>>2]|0)+1}break}case 8:{c[B>>2]=cK(c[(c[m>>2]|0)+8>>2]<<3)|0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[(c[m>>2]|0)+8>>2]|0))break a;h[(c[B>>2]|0)+(c[u>>2]<<3)>>3]=1.0;c[u>>2]=(c[u>>2]|0)+1}break}default:La(176099,132193,2656,132986)}while(0);c[G>>2]=cK(c[t>>2]<<2)|0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[t>>2]|0))break;h[(c[o>>2]|0)+(c[u>>2]<<3)>>3]=-1.0;c[(c[G>>2]|0)+(c[u>>2]<<2)>>2]=-2;c[u>>2]=(c[u>>2]|0)+1}c[A>>2]=_x(80)|0;if(!(c[A>>2]|0))La(133004,132193,2666,132986);c[E>>2]=cK(16)|0;h[c[E>>2]>>3]=0.0;c[(c[E>>2]|0)+8>>2]=c[n>>2];D=ay(c[A>>2]|0,c[E>>2]|0)|0;c[(c[G>>2]|0)+(c[n>>2]<<2)>>2]=D;if((c[(c[G>>2]|0)+(c[n>>2]<<2)>>2]|0)<0)La(133006,132193,2674,132986);b:while(1){n=by(c[A>>2]|0)|0;c[F>>2]=n;if(!n)break;c[u>>2]=c[(c[F>>2]|0)+8>>2];h[(c[o>>2]|0)+(c[u>>2]<<3)>>3]=+h[c[F>>2]>>3];n=c[u>>2]|0;D=c[H>>2]|0;c[H>>2]=D+1;c[(c[q>>2]|0)+(D<<2)>>2]=n;c[(c[G>>2]|0)+(c[u>>2]<<2)>>2]=-1;c[v>>2]=c[(c[x>>2]|0)+(c[u>>2]<<2)>>2];while(1){if((c[v>>2]|0)>=(c[(c[x>>2]|0)+((c[u>>2]|0)+1<<2)>>2]|0))break;c[w>>2]=c[(c[y>>2]|0)+(c[v>>2]<<2)>>2];c[z>>2]=c[(c[G>>2]|0)+(c[w>>2]<<2)>>2];do if(!((c[z>>2]|0)==-1?1:(c[w>>2]|0)==(c[u>>2]|0))){if((c[s>>2]|0)!=0?(c[(c[s>>2]|0)+(c[w>>2]<<2)>>2]|0)<0:0)break;if((c[z>>2]|0)==-2){c[E>>2]=cK(16)|0;I=+h[(c[B>>2]|0)+(c[v>>2]<<3)>>3];h[c[E>>2]>>3]=(+h[(c[B>>2]|0)+(c[v>>2]<<3)>>3]>=0.0?I:-I)+ +h[c[F>>2]>>3];c[(c[E>>2]|0)+8>>2]=c[w>>2];n=ay(c[A>>2]|0,c[E>>2]|0)|0;c[(c[G>>2]|0)+(c[w>>2]<<2)>>2]=n;break}c[E>>2]=ey(c[A>>2]|0,c[z>>2]|0)|0;I=+h[(c[B>>2]|0)+(c[v>>2]<<3)>>3];if(+h[c[E>>2]>>3]<(+h[(c[B>>2]|0)+(c[v>>2]<<3)>>3]>=0.0?I:-I)+ +h[c[F>>2]>>3])J=+h[c[E>>2]>>3];else{I=+h[(c[B>>2]|0)+(c[v>>2]<<3)>>3];J=(+h[(c[B>>2]|0)+(c[v>>2]<<3)>>3]>=0.0?I:-I)+ +h[c[F>>2]>>3]}h[c[E>>2]>>3]=J;if((c[(c[E>>2]|0)+8>>2]|0)!=(c[w>>2]|0)){K=37;break b}dy(c[A>>2]|0,c[z>>2]|0,c[E>>2]|0)|0}while(0);c[v>>2]=(c[v>>2]|0)+1}O4(c[F>>2]|0)}if((K|0)==37)La(133026,132193,2698,132986);c[c[p>>2]>>2]=c[H>>2];h[c[r>>2]>>3]=+h[(c[o>>2]|0)+(c[u>>2]<<3)>>3];$x(c[A>>2]|0,96);O4(c[G>>2]|0);if((c[B>>2]|0)!=0?(c[B>>2]|0)!=(c[(c[m>>2]|0)+28>>2]|0):0)O4(c[B>>2]|0);if((c[s>>2]|0)!=0?1:(c[H>>2]|0)==(c[t>>2]|0)){c[l>>2]=0;L=c[l>>2]|0;i=k;return L|0}else{c[l>>2]=-1;L=c[l>>2]|0;i=k;return L|0}return 0}function pw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[f>>2];c[k>>2]=c[g>>2];do if(!(+h[c[j>>2]>>3]>+h[c[k>>2]>>3]))if(+h[c[j>>2]>>3]==+h[c[k>>2]>>3]){c[e>>2]=0;break}else{c[e>>2]=-1;break}else c[e>>2]=1;while(0);i=d;return c[e>>2]|0}function qw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[m>>2]=cK(_(c[g>>2]<<3,c[j>>2]|0)|0)|0;Z4(c[m>>2]|0,c[f>>2]|0,_(c[g>>2]<<3,c[j>>2]|0)|0)|0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[g>>2]|0))break;c[l>>2]=0;while(1){n=c[k>>2]|0;if((c[l>>2]|0)>=(c[j>>2]|0))break;d=_(n,c[j>>2]|0)|0;b=_(c[l>>2]|0,c[g>>2]|0)|0;h[(c[f>>2]|0)+(b+(c[k>>2]|0)<<3)>>3]=+h[(c[m>>2]|0)+(d+(c[l>>2]|0)<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=n+1}O4(c[m>>2]|0);i=e;return}function rw(){return +(+(t2()|0)/2147483647.0)}function sw(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[d>>2]|0)>1){a=t2()|0;i=b;return (a|0)%(c[d>>2]|0)|0|0}else La(133173,133179,58,133189);return 0}function tw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[e>>2]=a;if((c[e>>2]|0)<=0){c[d>>2]=0;l=c[d>>2]|0;i=b;return l|0}c[f>>2]=cK(c[e>>2]<<2)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[e>>2]|0))break;c[(c[f>>2]|0)+(c[g>>2]<<2)>>2]=c[g>>2];c[g>>2]=(c[g>>2]|0)+1}c[k>>2]=c[e>>2];while(1){if((c[k>>2]|0)<=1)break;c[h>>2]=sw(c[k>>2]|0)|0;c[j>>2]=c[(c[f>>2]|0)+((c[k>>2]|0)-1<<2)>>2];c[(c[f>>2]|0)+((c[k>>2]|0)-1<<2)>>2]=c[(c[f>>2]|0)+(c[h>>2]<<2)>>2];c[(c[f>>2]|0)+(c[h>>2]<<2)>>2]=c[j>>2];c[k>>2]=(c[k>>2]|0)+-1}c[d>>2]=c[f>>2];l=c[d>>2]|0;i=b;return l|0}function uw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;h[(c[j>>2]|0)+(c[k>>2]<<3)>>3]=+h[(c[g>>2]|0)+(c[k>>2]<<3)>>3]-+h[(c[j>>2]|0)+(c[k>>2]<<3)>>3];c[k>>2]=(c[k>>2]|0)+1}i=e;return c[j>>2]|0}function vw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+12|0;k=e;l=e+8|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;h[k>>3]=0.0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[f>>2]|0))break;h[k>>3]=+h[k>>3]+ +h[(c[g>>2]|0)+(c[l>>2]<<3)>>3]*+h[(c[j>>2]|0)+(c[l>>2]<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}i=e;return +(+h[k>>3])}function ww(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f+12|0;l=f;m=f+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;h[(c[k>>2]|0)+(c[m>>2]<<3)>>3]=+h[(c[j>>2]|0)+(c[m>>2]<<3)>>3]+ +h[l>>3]*+h[(c[k>>2]|0)+(c[m>>2]<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}i=f;return c[k>>2]|0}function xw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f+12|0;l=f;m=f+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[g>>2]|0))break;h[(c[j>>2]|0)+(c[m>>2]<<3)>>3]=+h[(c[j>>2]|0)+(c[m>>2]<<3)>>3]+ +h[l>>3]*+h[(c[k>>2]|0)+(c[m>>2]<<3)>>3];c[m>>2]=(c[m>>2]|0)+1}i=f;return c[j>>2]|0}function yw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;h[n>>3]=0.0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;e=_(c[k>>2]|0,c[j>>2]|0)|0;d=_(c[l>>2]|0,c[j>>2]|0)|0;b=_(c[k>>2]|0,c[j>>2]|0)|0;a=_(c[l>>2]|0,c[j>>2]|0)|0;h[n>>3]=+h[n>>3]+(+h[(c[g>>2]|0)+(e+(c[m>>2]|0)<<3)>>3]-+h[(c[g>>2]|0)+(d+(c[m>>2]|0)<<3)>>3])*(+h[(c[g>>2]|0)+(b+(c[m>>2]|0)<<3)>>3]-+h[(c[g>>2]|0)+(a+(c[m>>2]|0)<<3)>>3]);c[m>>2]=(c[m>>2]|0)+1}h[n>>3]=+O(+(+h[n>>3]));i=f;return +(+h[n>>3]>1.0e-15?+h[n>>3]:1.0e-15)}function zw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;h[n>>3]=0.0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;e=_(c[k>>2]|0,c[j>>2]|0)|0;d=_(c[l>>2]|0,c[j>>2]|0)|0;b=_(c[k>>2]|0,c[j>>2]|0)|0;a=_(c[l>>2]|0,c[j>>2]|0)|0;h[n>>3]=+h[n>>3]+(+h[(c[g>>2]|0)+(e+(c[m>>2]|0)<<3)>>3]-+h[(c[g>>2]|0)+(d+(c[m>>2]|0)<<3)>>3])*(+h[(c[g>>2]|0)+(b+(c[m>>2]|0)<<3)>>3]-+h[(c[g>>2]|0)+(a+(c[m>>2]|0)<<3)>>3]);c[m>>2]=(c[m>>2]|0)+1}h[n>>3]=+O(+(+h[n>>3]));i=f;return +(+h[n>>3])}function Aw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+12|0;k=e+8|0;l=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;h[l>>3]=0.0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0))break;h[l>>3]=+h[l>>3]+(+h[(c[f>>2]|0)+(c[k>>2]<<3)>>3]-+h[(c[g>>2]|0)+(c[k>>2]<<3)>>3])*(+h[(c[f>>2]|0)+(c[k>>2]<<3)>>3]-+h[(c[g>>2]|0)+(c[k>>2]<<3)>>3]);c[k>>2]=(c[k>>2]|0)+1}m=+O(+(+h[l>>3]));i=e;return +m}function Bw(a,b,d,e,f,g,j){a=+a;b=+b;d=+d;e=+e;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0;k=i;i=i+144|0;l=k+104|0;m=k+96|0;n=k+88|0;o=k+80|0;p=k+128|0;q=k+124|0;r=k+120|0;s=k+56|0;t=k+32|0;u=k+8|0;v=k;w=k+116|0;x=k+112|0;h[l>>3]=a;h[m>>3]=b;h[n>>3]=d;h[o>>3]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;h[v>>3]=1.0;c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[q>>2]|0))break;h[s+(c[w>>2]<<3)>>3]=+h[(c[r>>2]|0)+(c[w>>2]<<3)>>3];h[t+(c[w>>2]<<3)>>3]=+h[(c[r>>2]|0)+(c[w>>2]<<3)>>3];c[w>>2]=(c[w>>2]|0)+1}c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[p>>2]|0))break;c[x>>2]=0;while(1){y=c[w>>2]|0;if((c[x>>2]|0)>=(c[q>>2]|0))break;j=_(y,c[q>>2]|0)|0;if(+h[(c[r>>2]|0)+(j+(c[x>>2]|0)<<3)>>3]<+h[s+(c[x>>2]<<3)>>3]){j=_(c[w>>2]|0,c[q>>2]|0)|0;z=+h[(c[r>>2]|0)+(j+(c[x>>2]|0)<<3)>>3]}else z=+h[s+(c[x>>2]<<3)>>3];h[s+(c[x>>2]<<3)>>3]=z;j=_(c[w>>2]|0,c[q>>2]|0)|0;if(+h[(c[r>>2]|0)+(j+(c[x>>2]|0)<<3)>>3]>+h[t+(c[x>>2]<<3)>>3]){j=_(c[w>>2]|0,c[q>>2]|0)|0;A=+h[(c[r>>2]|0)+(j+(c[x>>2]|0)<<3)>>3]}else A=+h[t+(c[x>>2]<<3)>>3];h[t+(c[x>>2]<<3)>>3]=A;c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=y+1}if(+h[t>>3]-+h[s>>3]!=0.0)h[v>>3]=(+h[n>>3]-+h[l>>3])/(+h[t>>3]-+h[s>>3]);if(+h[t+8>>3]-+h[s+8>>3]!=0.0){if(+h[v>>3]<(+h[o>>3]-+h[m>>3])/(+h[t+8>>3]-+h[s+8>>3]))B=+h[v>>3];else B=(+h[o>>3]-+h[m>>3])/(+h[t+8>>3]-+h[s+8>>3]);h[v>>3]=B}h[u>>3]=+h[l>>3];h[u+8>>3]=+h[m>>3];h[u+16>>3]=0.0;c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[p>>2]|0))break;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[q>>2]|0))break;m=_(c[w>>2]|0,c[q>>2]|0)|0;l=_(c[w>>2]|0,c[q>>2]|0)|0;h[(c[r>>2]|0)+(l+(c[x>>2]|0)<<3)>>3]=+h[u+(c[x>>2]<<3)>>3]+(+h[(c[r>>2]|0)+(m+(c[x>>2]|0)<<3)>>3]-+h[s+(c[x>>2]<<3)>>3])*+h[v>>3];c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=(c[w>>2]|0)+1}i=k;return}function Cw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;b=(kB(c[e>>2]|0)|0)==1;a=c[e>>2]|0;if(b){c[j>>2]=$B(a)|0;h[c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]>>3]=0.0;h[(c[(c[(c[j>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=0.0;i=d;return}Dw(a,33688);a=(kO(yA(c[f>>2]|0,133195)|0)|0)<<24>>24!=0;f=c[e>>2]|0;if(a)c[g>>2]=Ew(f,33688)|0;else c[g>>2]=Ey(f,33688)|0;Ny(c[e>>2]|0,c[g>>2]|0,33688);Fw(c[g>>2]|0,33688);i=d;return}function Dw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=$B(c[e>>2]|0)|0;c[g>>2]=qC(c[c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]>>2]|0)|0;if((c[g>>2]|0)!=(c[12956]|0)){c[(c[f>>2]|0)+12>>2]=0;c[12956]=c[g>>2];c[12957]=qA(c[12956]|0,0,133204,0)|0;c[12958]=qA(c[12956]|0,1,133212,0)|0;c[12959]=qA(c[12956]|0,1,133229,0)|0}c[12960]=yA(c[12956]|0,133229)|0;yy(c[f>>2]|0);c[(c[f>>2]|0)+8>>2]=1;k=+fO(c[12956]|0,c[12957]|0,1.0,0.0);h[(c[f>>2]|0)+32>>3]=k;c[(c[f>>2]|0)+16>>2]=c[12958];c[(c[f>>2]|0)+20>>2]=c[12959];c[(c[f>>2]|0)+24>>2]=c[12960];i=d;return}function Ew(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+160|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+24|0;k=d+8|0;l=d+4|0;c[f>>2]=a;c[g>>2]=b;b=(c[g>>2]|0)+12|0;g=c[b>>2]|0;c[b>>2]=g+1;c[e>>2]=g;k3(j,133882,e)|0;c[h>>2]=FD(c[f>>2]|0,j,1)|0;c[k>>2]=zy(c[h>>2]|0)|0;c[l>>2]=$B(c[f>>2]|0)|0;while(1){m=c[k>>2]|0;if(!(c[l>>2]|0))break;eC(c[m+8>>2]|0,c[l>>2]|0,1)|0;c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]=c[k>>2];c[l>>2]=aC(c[f>>2]|0,c[l>>2]|0)|0}i=d;return m|0}function Fw(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+4|0;c[e>>2]=a;c[d>>2]=b;Fy(c[e>>2]|0);i=d;return}function Gw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=cK(32)|0;c[c[g>>2]>>2]=4;h[(c[g>>2]|0)+8>>3]=.75;c[(c[g>>2]|0)+16>>2]=1073741824;c[(c[g>>2]|0)+20>>2]=1;c[(c[g>>2]|0)+24>>2]=c[e>>2];c[(c[g>>2]|0)+28>>2]=c[f>>2];i=d;return c[g>>2]|0}function Hw(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[d>>2]|0);i=b;return}function Iw(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}do if(c[(c[d>>2]|0)+8>>2]|0){a=c[d>>2]|0;if(c[c[d>>2]>>2]|0){Lv(c[a+8>>2]|0);if(!(c[(c[d>>2]|0)+12>>2]|0))break;Lv(c[(c[d>>2]|0)+12>>2]|0);break}if((c[a+36>>2]|0)!=0?(Lv(c[(c[d>>2]|0)+8>>2]|0),(c[(c[d>>2]|0)+12>>2]|0)!=0):0)Lv(c[(c[d>>2]|0)+12>>2]|0)}while(0);Lv(c[(c[d>>2]|0)+16>>2]|0);Lv(c[(c[d>>2]|0)+20>>2]|0);if((c[(c[d>>2]|0)+24>>2]|0)!=0?(c[c[d>>2]>>2]|0)>0:0)O4(c[(c[d>>2]|0)+24>>2]|0);Iw(c[(c[d>>2]|0)+28>>2]|0);O4(c[d>>2]|0);i=b;return}function Jw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;h=i;i=i+32|0;c[h+20>>2]=a;c[h+16>>2]=b;c[h+12>>2]=d;c[h+8>>2]=e;c[h+4>>2]=f;c[h>>2]=g;i=h;return 0}function Kw(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+8|0;c[d+4>>2]=a;c[d>>2]=b;c[e>>2]=0;i=d;return c[e>>2]|0}function Lw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+32|0;g=f+16|0;c[f+12>>2]=a;c[f+8>>2]=b;c[f+4>>2]=d;c[f>>2]=e;c[g>>2]=0;i=f;return c[g>>2]|0}function Mw(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;n=i;i=i+80|0;o=n+68|0;p=n+64|0;q=n+60|0;r=n+56|0;s=n+52|0;t=n+48|0;u=n+44|0;v=n+40|0;w=n+36|0;x=n+32|0;y=n+28|0;z=n+24|0;A=n+20|0;B=n+16|0;C=n+12|0;D=n+8|0;E=n+4|0;F=n;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;c[x>>2]=m;c[y>>2]=c[o>>2];c[z>>2]=0;c[A>>2]=0;c[B>>2]=0;c[D>>2]=0;c[E>>2]=0;c[c[u>>2]>>2]=0;c[c[v>>2]>>2]=0;c[c[p>>2]>>2]=0;c[c[t>>2]>>2]=0;c[c[r>>2]>>2]=0;c[F>>2]=c[(c[o>>2]|0)+4>>2];while(1){c[s>>2]=c[D>>2];Pw(c[o>>2]|0,y,c[q>>2]|0,z,c[s>>2]|0,D,A,B,c[w>>2]|0,c[x>>2]|0);if(!(c[y>>2]|0)){G=14;break}c[E>>2]=c[(c[y>>2]|0)+4>>2];if(c[c[u>>2]>>2]|0){c[C>>2]=Yv(c[c[u>>2]>>2]|0,c[A>>2]|0)|0;Lv(c[c[u>>2]>>2]|0);Lv(c[A>>2]|0);c[c[u>>2]>>2]=c[C>>2];c[C>>2]=Yv(c[B>>2]|0,c[c[v>>2]>>2]|0)|0;Lv(c[c[v>>2]>>2]|0);Lv(c[B>>2]|0);c[c[v>>2]>>2]=c[C>>2]}else{c[c[u>>2]>>2]=c[A>>2];c[c[v>>2]>>2]=c[B>>2]}if(c[c[p>>2]>>2]|0)Lv(c[c[p>>2]>>2]|0);c[c[p>>2]>>2]=c[y>>2];if(c[c[r>>2]>>2]|0)Lv(c[c[r>>2]>>2]|0);c[c[r>>2]>>2]=c[z>>2];if(c[c[t>>2]>>2]|0)O4(c[c[t>>2]>>2]|0);c[c[t>>2]>>2]=c[D>>2];c[o>>2]=c[y>>2];c[q>>2]=c[z>>2];c[s>>2]=c[D>>2];c[D>>2]=0;if(!(+(c[E>>2]|0)>+h[(c[w>>2]|0)+8>>3]*+(c[F>>2]|0))){G=14;break}if((c[(c[w>>2]|0)+28>>2]|0)!=1){G=14;break}}if((G|0)==14){i=n;return}}function Nw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=c[g>>2];c[n>>2]=c[h>>2];if(!((Ov(c[m>>2]|0,0)|0)!=0?(c[(c[m>>2]|0)+16>>2]|0)==1:0))c[m>>2]=bw(c[m>>2]|0)|0;do if(c[n>>2]|0){if((Ov(c[n>>2]|0,0)|0)!=0?(c[(c[n>>2]|0)+16>>2]|0)==1:0)break;c[n>>2]=Rv(c[n>>2]|0,0)|0}while(0);c[l>>2]=Qw(c[m>>2]|0,c[n>>2]|0,c[j>>2]|0)|0;c[l>>2]=Rw(c[l>>2]|0,c[k>>2]|0)|0;if((c[m>>2]|0)==(c[g>>2]|0)){o=c[l>>2]|0;i=f;return o|0}c[(c[l>>2]|0)+36>>2]=1;o=c[l>>2]|0;i=f;return o|0}function Ow(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;while(1){e=c[d>>2]|0;if(!(c[(c[d>>2]|0)+28>>2]|0))break;c[d>>2]=c[e+28>>2]}i=b;return e|0}function Pw(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0;n=i;i=i+128|0;o=n+112|0;p=n+108|0;q=n+104|0;r=n+100|0;s=n+96|0;t=n+92|0;u=n+88|0;v=n+84|0;w=n+80|0;x=n+76|0;y=n+72|0;z=n+68|0;A=n+64|0;B=n+60|0;C=n+56|0;D=n+52|0;E=n+48|0;F=n+44|0;G=n+40|0;H=n+36|0;I=n+32|0;J=n+28|0;K=n+24|0;L=n+20|0;M=n+16|0;N=n+12|0;O=n+8|0;P=n+4|0;Q=n;c[o>>2]=a;c[p>>2]=b;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=j;c[v>>2]=k;c[w>>2]=l;c[x>>2]=m;c[y>>2]=0;c[z>>2]=0;c[E>>2]=0;c[F>>2]=0;c[G>>2]=0;c[H>>2]=0;c[I>>2]=0;c[J>>2]=0;c[K>>2]=0;c[O>>2]=0;c[P>>2]=0;c[c[p>>2]>>2]=0;c[c[r>>2]>>2]=0;c[c[u>>2]>>2]=0;c[c[v>>2]>>2]=0;c[C>>2]=c[c[o>>2]>>2];c[c[x>>2]>>2]=c[(c[w>>2]|0)+24>>2];a:do switch(c[(c[w>>2]|0)+24>>2]|0){case 12:{c[(c[w>>2]|0)+24>>2]=3;c[c[x>>2]>>2]=3;Pw(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0);if(!(c[c[p>>2]>>2]|0)){c[(c[w>>2]|0)+24>>2]=4;c[c[x>>2]>>2]=4;Pw(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0)}if(!(c[c[p>>2]>>2]|0)){c[(c[w>>2]|0)+24>>2]=6;c[c[x>>2]>>2]=6;Pw(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0)}if(!(c[c[p>>2]>>2]|0)){c[(c[w>>2]|0)+24>>2]=9;c[c[x>>2]>>2]=9;Pw(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0)}if(!(c[c[p>>2]>>2]|0)){c[(c[w>>2]|0)+24>>2]=2;c[c[x>>2]>>2]=2;Pw(c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0)}c[(c[w>>2]|0)+24>>2]=12;break}case 3:case 6:case 4:{do if((c[(c[w>>2]|0)+24>>2]|0)!=3){m=c[o>>2]|0;l=c[(c[w>>2]|0)+20>>2]|0;if((c[(c[w>>2]|0)+24>>2]|0)==4){Tw(m,l,O,P,Q);break}else{Uw(m,4,l,O,P,Q);break}}else Sw(c[o>>2]|0,c[(c[w>>2]|0)+20>>2]|0,O,P,Q);while(0);c[A>>2]=c[Q>>2];if((c[(c[w>>2]|0)+28>>2]|0)==0?+(c[A>>2]|0)>+h[(c[w>>2]|0)+8>>3]*+(c[C>>2]|0):0)break a;if((c[A>>2]|0)!=(c[C>>2]|0)?(c[A>>2]|0)>=(c[c[w>>2]>>2]|0):0){c[E>>2]=cK(c[C>>2]<<2)|0;c[F>>2]=cK(c[C>>2]<<2)|0;c[I>>2]=cK(c[C>>2]<<3)|0;c[B>>2]=0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[Q>>2]|0))break;c[N>>2]=c[(c[P>>2]|0)+(c[D>>2]<<2)>>2];while(1){if((c[N>>2]|0)>=(c[(c[P>>2]|0)+((c[D>>2]|0)+1<<2)>>2]|0))break;c[(c[E>>2]|0)+(c[B>>2]<<2)>>2]=c[(c[O>>2]|0)+(c[N>>2]<<2)>>2];c[(c[F>>2]|0)+(c[B>>2]<<2)>>2]=c[D>>2];l=c[B>>2]|0;c[B>>2]=l+1;h[(c[I>>2]|0)+(l<<3)>>3]=1.0;c[N>>2]=(c[N>>2]|0)+1}c[D>>2]=(c[D>>2]|0)+1}l=Vv(c[B>>2]|0,c[C>>2]|0,c[A>>2]|0,c[E>>2]|0,c[F>>2]|0,c[I>>2]|0,1,8)|0;c[c[u>>2]>>2]=l;l=Kv(c[c[u>>2]>>2]|0)|0;c[c[v>>2]>>2]=l;l=Jw(c[Q>>2]|0,c[P>>2]|0,c[O>>2]|0,c[c[u>>2]>>2]|0,c[c[v>>2]>>2]|0,c[q>>2]|0)|0;c[c[r>>2]>>2]=l;l=Zv(c[c[v>>2]>>2]|0,c[o>>2]|0,c[c[u>>2]>>2]|0)|0;c[c[p>>2]>>2]=l;if(c[c[p>>2]>>2]|0){Xv(c[c[v>>2]>>2]|0,c[s>>2]|0,c[t>>2]|0,0);l=aw(c[c[v>>2]>>2]|0)|0;c[c[v>>2]>>2]=l;c[(c[c[p>>2]>>2]|0)+36>>2]=c[(c[c[p>>2]>>2]|0)+36>>2]|2;c[(c[c[p>>2]>>2]|0)+36>>2]=c[(c[c[p>>2]>>2]|0)+36>>2]|1;l=Sv(c[c[p>>2]>>2]|0)|0;c[c[p>>2]>>2]=l}}break}case 1:{Vw(c[o>>2]|0,c[(c[w>>2]|0)+20>>2]|0,y,z);R=29;break}case 2:{R=29;break}case 5:{R=31;break}case 10:case 9:{l=c[o>>2]|0;m=c[(c[w>>2]|0)+20>>2]|0;if((c[(c[w>>2]|0)+24>>2]|0)==9)Yw(l,m,K,L,B);else Zw(l,m,K,L,B);c[G>>2]=c[(c[o>>2]|0)+20>>2];c[H>>2]=c[(c[o>>2]|0)+24>>2];c[A>>2]=c[L>>2];if((c[(c[w>>2]|0)+28>>2]|0)==0?+(c[A>>2]|0)>+h[(c[w>>2]|0)+8>>3]*+(c[C>>2]|0):0)break a;if((c[A>>2]|0)!=(c[C>>2]|0)?(c[A>>2]|0)>=(c[c[w>>2]>>2]|0):0){c[E>>2]=cK(c[B>>2]<<2)|0;c[F>>2]=cK(c[B>>2]<<2)|0;c[I>>2]=cK(c[B>>2]<<3)|0;c[B>>2]=0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[C>>2]|0))break;b:do if((c[(c[K>>2]|0)+(c[D>>2]<<2)>>2]|0)==-1){c[M>>2]=0;c[N>>2]=c[(c[G>>2]|0)+(c[D>>2]<<2)>>2];while(1){if((c[N>>2]|0)>=(c[(c[G>>2]|0)+((c[D>>2]|0)+1<<2)>>2]|0))break;if((c[(c[K>>2]|0)+(c[(c[H>>2]|0)+(c[N>>2]<<2)>>2]<<2)>>2]|0)>=0)c[M>>2]=(c[M>>2]|0)+1;c[N>>2]=(c[N>>2]|0)+1}c[N>>2]=c[(c[G>>2]|0)+(c[D>>2]<<2)>>2];while(1){if((c[N>>2]|0)>=(c[(c[G>>2]|0)+((c[D>>2]|0)+1<<2)>>2]|0))break b;if((c[(c[K>>2]|0)+(c[(c[H>>2]|0)+(c[N>>2]<<2)>>2]<<2)>>2]|0)>=0){c[(c[E>>2]|0)+(c[B>>2]<<2)>>2]=c[D>>2];c[(c[F>>2]|0)+(c[B>>2]<<2)>>2]=c[(c[K>>2]|0)+(c[(c[H>>2]|0)+(c[N>>2]<<2)>>2]<<2)>>2];S=1.0/+(c[M>>2]|0);m=c[B>>2]|0;c[B>>2]=m+1;h[(c[I>>2]|0)+(m<<3)>>3]=S}c[N>>2]=(c[N>>2]|0)+1}}else{c[(c[E>>2]|0)+(c[B>>2]<<2)>>2]=c[D>>2];c[(c[F>>2]|0)+(c[B>>2]<<2)>>2]=c[(c[K>>2]|0)+(c[D>>2]<<2)>>2];m=c[B>>2]|0;c[B>>2]=m+1;h[(c[I>>2]|0)+(m<<3)>>3]=1.0}while(0);c[D>>2]=(c[D>>2]|0)+1}m=Vv(c[B>>2]|0,c[C>>2]|0,c[A>>2]|0,c[E>>2]|0,c[F>>2]|0,c[I>>2]|0,1,8)|0;c[c[u>>2]>>2]=m;m=Kv(c[c[u>>2]>>2]|0)|0;c[c[v>>2]>>2]=m;m=Zv(c[c[v>>2]>>2]|0,c[o>>2]|0,c[c[u>>2]>>2]|0)|0;c[c[p>>2]>>2]=m;if(c[c[p>>2]>>2]|0){Xv(c[c[v>>2]>>2]|0,c[s>>2]|0,c[t>>2]|0,0);c[(c[c[p>>2]>>2]|0)+36>>2]=c[(c[c[p>>2]>>2]|0)+36>>2]|2;c[(c[c[p>>2]>>2]|0)+36>>2]=c[(c[c[p>>2]>>2]|0)+36>>2]|1;m=Sv(c[c[p>>2]>>2]|0)|0;c[c[p>>2]>>2]=m;m=Lw(c[K>>2]|0,0,-1,c[q>>2]|0)|0;c[c[r>>2]>>2]=m}}break}default:{}}while(0);if((R|0)==29)if((c[(c[w>>2]|0)+24>>2]|0)==2){Ww(c[o>>2]|0,c[(c[w>>2]|0)+20>>2]|0,y,z);R=31}else R=31;do if((R|0)==31){if((c[(c[w>>2]|0)+24>>2]|0)==5)Xw(c[o>>2]|0,c[(c[w>>2]|0)+20>>2]|0,y,z);c[A>>2]=c[z>>2];if((c[(c[w>>2]|0)+28>>2]|0)==0?+(c[A>>2]|0)>+h[(c[w>>2]|0)+8>>3]*+(c[C>>2]|0):0)break;if((c[A>>2]|0)!=(c[C>>2]|0)?(c[A>>2]|0)>=(c[c[w>>2]>>2]|0):0){c[E>>2]=cK(c[C>>2]<<2)|0;c[F>>2]=cK(c[C>>2]<<2)|0;c[I>>2]=cK(c[C>>2]<<3)|0;c[B>>2]=0;c[A>>2]=0;c[D>>2]=0;while(1){if((c[D>>2]|0)>=(c[C>>2]|0))break;if((c[(c[y>>2]|0)+(c[D>>2]<<2)>>2]|0)>=0){N=(c[(c[y>>2]|0)+(c[D>>2]<<2)>>2]|0)==(c[D>>2]|0);c[(c[E>>2]|0)+(c[B>>2]<<2)>>2]=c[D>>2];c[(c[F>>2]|0)+(c[B>>2]<<2)>>2]=c[A>>2];M=c[B>>2]|0;c[B>>2]=M+1;h[(c[I>>2]|0)+(M<<3)>>3]=1.0;if(!N){c[(c[E>>2]|0)+(c[B>>2]<<2)>>2]=c[(c[y>>2]|0)+(c[D>>2]<<2)>>2];c[(c[F>>2]|0)+(c[B>>2]<<2)>>2]=c[A>>2];N=c[B>>2]|0;c[B>>2]=N+1;h[(c[I>>2]|0)+(N<<3)>>3]=1.0;c[(c[y>>2]|0)+(c[(c[y>>2]|0)+(c[D>>2]<<2)>>2]<<2)>>2]=-1}c[A>>2]=(c[A>>2]|0)+1;c[(c[y>>2]|0)+(c[D>>2]<<2)>>2]=-1}c[D>>2]=(c[D>>2]|0)+1}N=Vv(c[B>>2]|0,c[C>>2]|0,c[A>>2]|0,c[E>>2]|0,c[F>>2]|0,c[I>>2]|0,1,8)|0;c[c[u>>2]>>2]=N;N=Kv(c[c[u>>2]>>2]|0)|0;c[c[v>>2]>>2]=N;N=Zv(c[c[v>>2]>>2]|0,c[o>>2]|0,c[c[u>>2]>>2]|0)|0;c[c[p>>2]>>2]=N;if(c[c[p>>2]>>2]|0){Xv(c[c[v>>2]>>2]|0,c[s>>2]|0,c[t>>2]|0,0);N=aw(c[c[v>>2]>>2]|0)|0;c[c[v>>2]>>2]=N;c[(c[c[p>>2]>>2]|0)+36>>2]=c[(c[c[p>>2]>>2]|0)+36>>2]|2;c[(c[c[p>>2]>>2]|0)+36>>2]=c[(c[c[p>>2]>>2]|0)+36>>2]|1;N=Sv(c[c[p>>2]>>2]|0)|0;c[c[p>>2]>>2]=N;N=Kw(c[y>>2]|0,c[q>>2]|0)|0;c[c[r>>2]>>2]=N;c[c[r>>2]>>2]=0}}}while(0);if(c[y>>2]|0)O4(c[y>>2]|0);if(c[K>>2]|0)O4(c[K>>2]|0);if(c[E>>2]|0)O4(c[E>>2]|0);if(c[F>>2]|0)O4(c[F>>2]|0);if(c[I>>2]|0)O4(c[I>>2]|0);if(c[J>>2]|0)Lv(c[J>>2]|0);if(c[O>>2]|0)O4(c[O>>2]|0);if(!(c[P>>2]|0)){i=n;return}O4(c[P>>2]|0);i=n;return}function Qw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(c[g>>2]|0){c[k>>2]=cK(44)|0;c[c[k>>2]>>2]=0;c[(c[k>>2]|0)+4>>2]=c[(c[g>>2]|0)+4>>2];c[(c[k>>2]|0)+8>>2]=c[g>>2];c[(c[k>>2]|0)+12>>2]=c[h>>2];c[(c[k>>2]|0)+16>>2]=0;c[(c[k>>2]|0)+20>>2]=0;c[(c[k>>2]|0)+24>>2]=c[j>>2];c[(c[k>>2]|0)+28>>2]=0;c[(c[k>>2]|0)+32>>2]=0;c[(c[k>>2]|0)+36>>2]=0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}else{c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}return 0}function Rw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+48|0;e=d+44|0;f=d+40|0;g=d+36|0;h=d+32|0;j=d+28|0;k=d+24|0;l=d+20|0;m=d+16|0;n=d+12|0;o=d+8|0;p=d+4|0;q=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=0;c[n>>2]=c[(c[f>>2]|0)+8>>2];c[p>>2]=c[(c[f>>2]|0)+12>>2];if((c[c[f>>2]>>2]|0)>=((c[(c[g>>2]|0)+16>>2]|0)-1|0)){c[e>>2]=c[f>>2];r=c[e>>2]|0;i=d;return r|0}Mw(c[n>>2]|0,o,c[p>>2]|0,q,c[(c[f>>2]|0)+24>>2]|0,k,l,m,c[g>>2]|0,j);if(c[o>>2]|0){c[h>>2]=Qw(c[o>>2]|0,c[q>>2]|0,c[k>>2]|0)|0;c[(c[f>>2]|0)+28>>2]=c[h>>2];c[(c[h>>2]|0)+40>>2]=c[j>>2];c[c[h>>2]>>2]=(c[c[f>>2]>>2]|0)+1;c[(c[h>>2]|0)+4>>2]=c[c[o>>2]>>2];c[(c[h>>2]|0)+8>>2]=c[o>>2];c[(c[h>>2]|0)+12>>2]=c[q>>2];c[(c[h>>2]|0)+16>>2]=c[l>>2];c[(c[f>>2]|0)+20>>2]=c[m>>2];c[(c[h>>2]|0)+32>>2]=c[f>>2];c[h>>2]=Rw(c[h>>2]|0,c[g>>2]|0)|0;c[e>>2]=c[f>>2];r=c[e>>2]|0;i=d;return r|0}else{c[e>>2]=c[f>>2];r=c[e>>2]|0;i=d;return r|0}return 0}function Sw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0;g=i;i=i+112|0;j=g+96|0;k=g+92|0;l=g+88|0;m=g+84|0;n=g+80|0;o=g+76|0;p=g+72|0;q=g+68|0;r=g+64|0;s=g+60|0;t=g+56|0;u=g+48|0;v=g+44|0;w=g+40|0;x=g;y=g+36|0;z=g+32|0;A=g+28|0;B=g+24|0;C=g+20|0;D=g+16|0;E=g+12|0;F=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[u>>2]=0;h[x>>3]=0.0;c[y>>2]=1;c[z>>2]=0;c[C>>2]=0;c[r>>2]=c[(c[j>>2]|0)+20>>2];c[s>>2]=c[(c[j>>2]|0)+24>>2];c[t>>2]=c[c[j>>2]>>2];c[g+52>>2]=c[(c[j>>2]|0)+4>>2];f=cK(c[t>>2]<<2)|0;c[c[l>>2]>>2]=f;f=cK((c[t>>2]|0)+1<<2)|0;c[c[m>>2]>>2]=f;c[A>>2]=cK(c[t>>2]<<2)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]=c[o>>2];c[o>>2]=(c[o>>2]|0)+1}c[c[n>>2]>>2]=0;c[c[c[m>>2]>>2]>>2]=0;c[B>>2]=0;c[w>>2]=c[(c[j>>2]|0)+28>>2];if(!(c[k>>2]|0)){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;a:do if((c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1?((c[(c[r>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0)-(c[(c[r>>2]|0)+(c[o>>2]<<2)>>2]|0)|0)==1:0){c[v>>2]=c[(c[s>>2]|0)+(c[(c[r>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2];c[(c[A>>2]|0)+(c[v>>2]<<2)>>2]=-1;k=c[v>>2]|0;j=c[B>>2]|0;c[B>>2]=j+1;c[(c[c[l>>2]>>2]|0)+(j<<2)>>2]=k;c[q>>2]=c[(c[r>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[r>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;if((c[v>>2]|0)!=(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0)?((c[(c[r>>2]|0)+((c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0)+1<<2)>>2]|0)-(c[(c[r>>2]|0)+(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)|0)==1:0){c[(c[A>>2]|0)+(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]=-1;k=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0;j=c[B>>2]|0;c[B>>2]=j+1;c[(c[c[l>>2]>>2]|0)+(j<<2)>>2]=k}c[q>>2]=(c[q>>2]|0)+1}if((c[C>>2]|0)>((c[B>>2]|0)-(c[(c[c[m>>2]>>2]|0)+(c[c[n>>2]>>2]<<2)>>2]|0)|0))G=c[C>>2]|0;else G=(c[B>>2]|0)-(c[(c[c[m>>2]>>2]|0)+(c[c[n>>2]>>2]<<2)>>2]|0)|0;c[C>>2]=G;c[D>>2]=c[(c[c[m>>2]>>2]|0)+(c[c[n>>2]>>2]<<2)>>2];if(((c[B>>2]|0)-(c[D>>2]|0)|0)<=4){k=c[B>>2]|0;j=c[n>>2]|0;f=(c[j>>2]|0)+1|0;c[j>>2]=f;c[(c[c[m>>2]>>2]|0)+(f<<2)>>2]=k;break}k=(c[D>>2]|0)+1|0;c[D>>2]=k;f=c[n>>2]|0;j=(c[f>>2]|0)+1|0;c[f>>2]=j;c[(c[c[m>>2]>>2]|0)+(j<<2)>>2]=k;c[E>>2]=c[D>>2];c[F>>2]=c[D>>2];while(1){if((c[F>>2]|0)>=(c[B>>2]|0))break a;if((c[E>>2]|0)>=(c[B>>2]|0))break a;c[E>>2]=(c[E>>2]|0)+3;c[E>>2]=(c[B>>2]|0)<(c[E>>2]|0)?c[B>>2]|0:c[E>>2]|0;k=c[E>>2]|0;j=c[n>>2]|0;f=(c[j>>2]|0)+1|0;c[j>>2]=f;c[(c[c[m>>2]>>2]|0)+(f<<2)>>2]=k;c[F>>2]=(c[F>>2]|0)+1}}while(0);c[o>>2]=(c[o>>2]|0)+1}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;c[y>>2]=1;if((c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1){c[q>>2]=c[(c[r>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[r>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;do if(((c[o>>2]|0)!=(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0)?(c[(c[A>>2]|0)+(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)!=-1:0)?(c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1:0){H=+h[(c[w>>2]|0)+(c[q>>2]<<3)>>3];if(c[y>>2]|0){h[x>>3]=H;c[z>>2]=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2];c[y>>2]=0;break}if(H>+h[x>>3]){h[x>>3]=+h[(c[w>>2]|0)+(c[q>>2]<<3)>>3];c[z>>2]=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]}}while(0);c[q>>2]=(c[q>>2]|0)+1}if(!(c[y>>2]|0)){c[(c[A>>2]|0)+(c[z>>2]<<2)>>2]=-1;c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]=-1;G=c[o>>2]|0;k=c[B>>2]|0;c[B>>2]=k+1;c[(c[c[l>>2]>>2]|0)+(k<<2)>>2]=G;G=c[z>>2]|0;k=c[B>>2]|0;c[B>>2]=k+1;c[(c[c[l>>2]>>2]|0)+(k<<2)>>2]=G;G=c[B>>2]|0;k=c[n>>2]|0;f=(c[k>>2]|0)+1|0;c[k>>2]=f;c[(c[c[m>>2]>>2]|0)+(f<<2)>>2]=G}}c[o>>2]=(c[o>>2]|0)+1}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;if((c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]|0)==(c[o>>2]|0)){G=c[o>>2]|0;f=c[B>>2]|0;c[B>>2]=f+1;c[(c[c[l>>2]>>2]|0)+(f<<2)>>2]=G;G=c[B>>2]|0;f=c[n>>2]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;c[(c[c[m>>2]>>2]|0)+(k<<2)>>2]=G}c[o>>2]=(c[o>>2]|0)+1}I=c[A>>2]|0;O4(I);i=g;return}c[u>>2]=tw(c[t>>2]|0)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break;c[o>>2]=c[(c[u>>2]|0)+(c[p>>2]<<2)>>2];b:do if((c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1?((c[(c[r>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0)-(c[(c[r>>2]|0)+(c[o>>2]<<2)>>2]|0)|0)==1:0){c[v>>2]=c[(c[s>>2]|0)+(c[(c[r>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2];c[(c[A>>2]|0)+(c[v>>2]<<2)>>2]=-1;G=c[v>>2]|0;k=c[B>>2]|0;c[B>>2]=k+1;c[(c[c[l>>2]>>2]|0)+(k<<2)>>2]=G;c[q>>2]=c[(c[r>>2]|0)+(c[v>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[r>>2]|0)+((c[v>>2]|0)+1<<2)>>2]|0))break;if((c[v>>2]|0)!=(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0)?((c[(c[r>>2]|0)+((c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0)+1<<2)>>2]|0)-(c[(c[r>>2]|0)+(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)|0)==1:0){c[(c[A>>2]|0)+(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]=-1;G=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0;k=c[B>>2]|0;c[B>>2]=k+1;c[(c[c[l>>2]>>2]|0)+(k<<2)>>2]=G}c[q>>2]=(c[q>>2]|0)+1}if((c[C>>2]|0)>((c[B>>2]|0)-(c[(c[c[m>>2]>>2]|0)+(c[c[n>>2]>>2]<<2)>>2]|0)|0))J=c[C>>2]|0;else J=(c[B>>2]|0)-(c[(c[c[m>>2]>>2]|0)+(c[c[n>>2]>>2]<<2)>>2]|0)|0;c[C>>2]=J;c[D>>2]=c[(c[c[m>>2]>>2]|0)+(c[c[n>>2]>>2]<<2)>>2];if(((c[B>>2]|0)-(c[D>>2]|0)|0)<=4){G=c[B>>2]|0;k=c[n>>2]|0;f=(c[k>>2]|0)+1|0;c[k>>2]=f;c[(c[c[m>>2]>>2]|0)+(f<<2)>>2]=G;break}G=(c[D>>2]|0)+1|0;c[D>>2]=G;f=c[n>>2]|0;k=(c[f>>2]|0)+1|0;c[f>>2]=k;c[(c[c[m>>2]>>2]|0)+(k<<2)>>2]=G;c[E>>2]=c[D>>2];c[F>>2]=c[D>>2];while(1){if((c[F>>2]|0)>=(c[B>>2]|0))break b;if((c[E>>2]|0)>=(c[B>>2]|0))break b;c[E>>2]=(c[E>>2]|0)+3;c[E>>2]=(c[B>>2]|0)<(c[E>>2]|0)?c[B>>2]|0:c[E>>2]|0;G=c[E>>2]|0;k=c[n>>2]|0;f=(c[k>>2]|0)+1|0;c[k>>2]=f;c[(c[c[m>>2]>>2]|0)+(f<<2)>>2]=G;c[F>>2]=(c[F>>2]|0)+1}}while(0);c[p>>2]=(c[p>>2]|0)+1}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break;c[o>>2]=c[(c[u>>2]|0)+(c[p>>2]<<2)>>2];c[y>>2]=1;if((c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1){c[q>>2]=c[(c[r>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[r>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;do if(((c[o>>2]|0)!=(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0)?(c[(c[A>>2]|0)+(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)!=-1:0)?(c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1:0){H=+h[(c[w>>2]|0)+(c[q>>2]<<3)>>3];if(c[y>>2]|0){h[x>>3]=H;c[z>>2]=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2];c[y>>2]=0;break}if(H>+h[x>>3]){h[x>>3]=+h[(c[w>>2]|0)+(c[q>>2]<<3)>>3];c[z>>2]=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]}}while(0);c[q>>2]=(c[q>>2]|0)+1}if(!(c[y>>2]|0)){c[(c[A>>2]|0)+(c[z>>2]<<2)>>2]=-1;c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]=-1;F=c[o>>2]|0;E=c[B>>2]|0;c[B>>2]=E+1;c[(c[c[l>>2]>>2]|0)+(E<<2)>>2]=F;F=c[z>>2]|0;E=c[B>>2]|0;c[B>>2]=E+1;c[(c[c[l>>2]>>2]|0)+(E<<2)>>2]=F;F=c[B>>2]|0;E=c[n>>2]|0;D=(c[E>>2]|0)+1|0;c[E>>2]=D;c[(c[c[m>>2]>>2]|0)+(D<<2)>>2]=F}}c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;if((c[(c[A>>2]|0)+(c[o>>2]<<2)>>2]|0)==(c[o>>2]|0)){p=c[o>>2]|0;z=c[B>>2]|0;c[B>>2]=z+1;c[(c[c[l>>2]>>2]|0)+(z<<2)>>2]=p;p=c[B>>2]|0;z=c[n>>2]|0;y=(c[z>>2]|0)+1|0;c[z>>2]=y;c[(c[c[m>>2]>>2]|0)+(y<<2)>>2]=p}c[o>>2]=(c[o>>2]|0)+1}O4(c[u>>2]|0);I=c[A>>2]|0;O4(I);i=g;return}function Tw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0;g=i;i=i+96|0;j=g+92|0;k=g+88|0;l=g+84|0;m=g+80|0;n=g+76|0;o=g+72|0;p=g+68|0;q=g+64|0;r=g+60|0;s=g+56|0;t=g+52|0;u=g+44|0;v=g+40|0;w=g;x=g+36|0;y=g+32|0;z=g+28|0;A=g+24|0;B=g+20|0;C=g+16|0;D=g+12|0;E=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[u>>2]=0;h[w>>3]=0.0;c[x>>2]=1;c[y>>2]=0;c[D>>2]=0;c[E>>2]=0;c[r>>2]=c[(c[j>>2]|0)+20>>2];c[s>>2]=c[(c[j>>2]|0)+24>>2];c[t>>2]=c[c[j>>2]>>2];c[g+48>>2]=c[(c[j>>2]|0)+4>>2];f=cK(c[t>>2]<<2)|0;c[c[l>>2]>>2]=f;f=cK((c[t>>2]|0)+1<<2)|0;c[c[m>>2]>>2]=f;c[z>>2]=cK(c[t>>2]<<2)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]=c[o>>2];c[o>>2]=(c[o>>2]|0)+1}ew(c[j>>2]|0,C,D,E);c[c[n>>2]>>2]=0;c[c[c[m>>2]>>2]>>2]=0;c[A>>2]=0;c[v>>2]=c[(c[j>>2]|0)+28>>2];c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[C>>2]|0))break;if(((c[(c[E>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0)-(c[(c[E>>2]|0)+(c[o>>2]<<2)>>2]|0)|0)>1){c[B>>2]=c[(c[c[m>>2]>>2]|0)+(c[c[n>>2]>>2]<<2)>>2];c[q>>2]=c[(c[E>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[E>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;c[(c[z>>2]|0)+(c[(c[D>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]=-1;j=c[(c[D>>2]|0)+(c[q>>2]<<2)>>2]|0;f=c[A>>2]|0;c[A>>2]=f+1;c[(c[c[l>>2]>>2]|0)+(f<<2)>>2]=j;if(((c[A>>2]|0)-(c[B>>2]|0)|0)>=4){j=c[A>>2]|0;f=c[n>>2]|0;e=(c[f>>2]|0)+1|0;c[f>>2]=e;c[(c[c[m>>2]>>2]|0)+(e<<2)>>2]=j;c[B>>2]=c[A>>2]}c[q>>2]=(c[q>>2]|0)+1}if((c[A>>2]|0)>(c[B>>2]|0)){j=c[A>>2]|0;e=c[n>>2]|0;f=(c[e>>2]|0)+1|0;c[e>>2]=f;c[(c[c[m>>2]>>2]|0)+(f<<2)>>2]=j}}c[o>>2]=(c[o>>2]|0)+1}if(!(c[k>>2]|0)){c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;c[x>>2]=1;if((c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1){c[q>>2]=c[(c[r>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[r>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;do if(((c[o>>2]|0)!=(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0)?(c[(c[z>>2]|0)+(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)!=-1:0)?(c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1:0){F=+h[(c[v>>2]|0)+(c[q>>2]<<3)>>3];if(c[x>>2]|0){h[w>>3]=F;c[y>>2]=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2];c[x>>2]=0;break}if(F>+h[w>>3]){h[w>>3]=+h[(c[v>>2]|0)+(c[q>>2]<<3)>>3];c[y>>2]=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]}}while(0);c[q>>2]=(c[q>>2]|0)+1}if(!(c[x>>2]|0)){c[(c[z>>2]|0)+(c[y>>2]<<2)>>2]=-1;c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]=-1;k=c[o>>2]|0;B=c[A>>2]|0;c[A>>2]=B+1;c[(c[c[l>>2]>>2]|0)+(B<<2)>>2]=k;k=c[y>>2]|0;B=c[A>>2]|0;c[A>>2]=B+1;c[(c[c[l>>2]>>2]|0)+(B<<2)>>2]=k;k=c[A>>2]|0;B=c[n>>2]|0;C=(c[B>>2]|0)+1|0;c[B>>2]=C;c[(c[c[m>>2]>>2]|0)+(C<<2)>>2]=k}}c[o>>2]=(c[o>>2]|0)+1}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;if((c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]|0)==(c[o>>2]|0)){k=c[o>>2]|0;C=c[A>>2]|0;c[A>>2]=C+1;c[(c[c[l>>2]>>2]|0)+(C<<2)>>2]=k;k=c[A>>2]|0;C=c[n>>2]|0;B=(c[C>>2]|0)+1|0;c[C>>2]=B;c[(c[c[m>>2]>>2]|0)+(B<<2)>>2]=k}c[o>>2]=(c[o>>2]|0)+1}G=c[D>>2]|0;O4(G);H=c[E>>2]|0;O4(H);I=c[z>>2]|0;O4(I);i=g;return}c[u>>2]=tw(c[t>>2]|0)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[t>>2]|0))break;c[o>>2]=c[(c[u>>2]|0)+(c[p>>2]<<2)>>2];c[x>>2]=1;if((c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1){c[q>>2]=c[(c[r>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[r>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;do if(((c[o>>2]|0)!=(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]|0)?(c[(c[z>>2]|0)+(c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)!=-1:0)?(c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]|0)!=-1:0){F=+h[(c[v>>2]|0)+(c[q>>2]<<3)>>3];if(c[x>>2]|0){h[w>>3]=F;c[y>>2]=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2];c[x>>2]=0;break}if(F>+h[w>>3]){h[w>>3]=+h[(c[v>>2]|0)+(c[q>>2]<<3)>>3];c[y>>2]=c[(c[s>>2]|0)+(c[q>>2]<<2)>>2]}}while(0);c[q>>2]=(c[q>>2]|0)+1}if(!(c[x>>2]|0)){c[(c[z>>2]|0)+(c[y>>2]<<2)>>2]=-1;c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]=-1;k=c[o>>2]|0;B=c[A>>2]|0;c[A>>2]=B+1;c[(c[c[l>>2]>>2]|0)+(B<<2)>>2]=k;k=c[y>>2]|0;B=c[A>>2]|0;c[A>>2]=B+1;c[(c[c[l>>2]>>2]|0)+(B<<2)>>2]=k;k=c[A>>2]|0;B=c[n>>2]|0;C=(c[B>>2]|0)+1|0;c[B>>2]=C;c[(c[c[m>>2]>>2]|0)+(C<<2)>>2]=k}}c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[t>>2]|0))break;if((c[(c[z>>2]|0)+(c[o>>2]<<2)>>2]|0)==(c[o>>2]|0)){p=c[o>>2]|0;y=c[A>>2]|0;c[A>>2]=y+1;c[(c[c[l>>2]>>2]|0)+(y<<2)>>2]=p;p=c[A>>2]|0;y=c[n>>2]|0;x=(c[y>>2]|0)+1|0;c[y>>2]=x;c[(c[c[m>>2]>>2]|0)+(x<<2)>>2]=p}c[o>>2]=(c[o>>2]|0)+1}O4(c[u>>2]|0);G=c[D>>2]|0;O4(G);H=c[E>>2]|0;O4(H);I=c[z>>2]|0;O4(I);i=g;return}function Uw(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+96|0;k=j+92|0;l=j+88|0;m=j+80|0;n=j+76|0;o=j+72|0;p=j+68|0;q=j+64|0;r=j+60|0;s=j+56|0;t=j+52|0;u=j+48|0;v=j+40|0;w=j+36|0;x=j+32|0;y=j+28|0;z=j+24|0;A=j+20|0;B=j+16|0;C=j+12|0;D=j+8|0;E=j+4|0;F=j;c[k>>2]=a;c[l>>2]=b;c[j+84>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[v>>2]=0;c[s>>2]=c[(c[k>>2]|0)+20>>2];c[t>>2]=c[(c[k>>2]|0)+24>>2];c[u>>2]=c[c[k>>2]>>2];c[j+44>>2]=c[(c[k>>2]|0)+4>>2];g=cK(c[u>>2]<<2)|0;c[c[m>>2]>>2]=g;g=cK((c[u>>2]|0)+1<<2)|0;c[c[n>>2]>>2]=g;c[z>>2]=cK(c[u>>2]<<2)|0;c[F>>2]=cK(c[u>>2]<<1<<3)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[u>>2]|0))break;c[(c[z>>2]|0)+(c[p>>2]<<2)>>2]=c[p>>2];c[p>>2]=(c[p>>2]|0)+1}c[c[o>>2]>>2]=0;c[c[c[n>>2]>>2]>>2]=0;c[A>>2]=0;c[y>>2]=c[(c[k>>2]|0)+28>>2];c[v>>2]=tw(c[u>>2]|0)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[u>>2]|0))break;c[p>>2]=c[(c[v>>2]|0)+(c[q>>2]<<2)>>2];a:do if((c[(c[z>>2]|0)+(c[p>>2]<<2)>>2]|0)!=-1?((c[(c[s>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0)-(c[(c[s>>2]|0)+(c[p>>2]<<2)>>2]|0)|0)==1:0){c[w>>2]=c[(c[t>>2]|0)+(c[(c[s>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2];c[(c[z>>2]|0)+(c[w>>2]<<2)>>2]=-1;k=c[w>>2]|0;g=c[A>>2]|0;c[A>>2]=g+1;c[(c[c[m>>2]>>2]|0)+(g<<2)>>2]=k;c[r>>2]=c[(c[s>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[s>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;if((c[w>>2]|0)!=(c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]|0)?((c[(c[s>>2]|0)+((c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]|0)+1<<2)>>2]|0)-(c[(c[s>>2]|0)+(c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]<<2)>>2]|0)|0)==1:0){c[(c[z>>2]|0)+(c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]<<2)>>2]=-1;k=c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]|0;g=c[A>>2]|0;c[A>>2]=g+1;c[(c[c[m>>2]>>2]|0)+(g<<2)>>2]=k}c[r>>2]=(c[r>>2]|0)+1}c[B>>2]=c[(c[c[n>>2]>>2]|0)+(c[c[o>>2]>>2]<<2)>>2];if(((c[A>>2]|0)-(c[B>>2]|0)|0)<=4){k=c[A>>2]|0;g=c[o>>2]|0;f=(c[g>>2]|0)+1|0;c[g>>2]=f;c[(c[c[n>>2]>>2]|0)+(f<<2)>>2]=k;break}k=(c[B>>2]|0)+1|0;c[B>>2]=k;f=c[o>>2]|0;g=(c[f>>2]|0)+1|0;c[f>>2]=g;c[(c[c[n>>2]>>2]|0)+(g<<2)>>2]=k;c[C>>2]=c[B>>2];c[D>>2]=c[B>>2];while(1){if((c[D>>2]|0)>=(c[A>>2]|0))break a;if((c[C>>2]|0)>=(c[A>>2]|0))break a;c[C>>2]=(c[C>>2]|0)+3;c[C>>2]=(c[A>>2]|0)<(c[C>>2]|0)?c[A>>2]|0:c[C>>2]|0;k=c[C>>2]|0;g=c[o>>2]|0;f=(c[g>>2]|0)+1|0;c[g>>2]=f;c[(c[c[n>>2]>>2]|0)+(f<<2)>>2]=k;c[D>>2]=(c[D>>2]|0)+1}}while(0);c[q>>2]=(c[q>>2]|0)+1}c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[u>>2]|0))break;c[p>>2]=c[(c[v>>2]|0)+(c[q>>2]<<2)>>2];if((c[(c[z>>2]|0)+(c[p>>2]<<2)>>2]|0)!=-1){c[E>>2]=0;c[r>>2]=c[(c[s>>2]|0)+(c[p>>2]<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[s>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;if(((c[p>>2]|0)!=(c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]|0)?(c[(c[z>>2]|0)+(c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]<<2)>>2]|0)!=-1:0)?(c[(c[z>>2]|0)+(c[p>>2]<<2)>>2]|0)!=-1:0){h[(c[F>>2]|0)+(c[E>>2]<<1<<3)>>3]=+(c[(c[t>>2]|0)+(c[r>>2]<<2)>>2]|0);h[(c[F>>2]|0)+((c[E>>2]<<1)+1<<3)>>3]=+h[(c[y>>2]|0)+(c[r>>2]<<3)>>3];c[E>>2]=(c[E>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}if((c[E>>2]|0)>0){w3(c[F>>2]|0,c[E>>2]|0,16,81);c[r>>2]=0;while(1){if((c[r>>2]|0)>=((((c[l>>2]|0)-1|0)<(c[E>>2]|0)?(c[l>>2]|0)-1|0:c[E>>2]|0)|0))break;c[x>>2]=~~+h[(c[F>>2]|0)+(c[r>>2]<<1<<3)>>3];c[(c[z>>2]|0)+(c[x>>2]<<2)>>2]=-1;D=c[x>>2]|0;C=c[A>>2]|0;c[A>>2]=C+1;c[(c[c[m>>2]>>2]|0)+(C<<2)>>2]=D;c[r>>2]=(c[r>>2]|0)+1}c[(c[z>>2]|0)+(c[p>>2]<<2)>>2]=-1;D=c[p>>2]|0;C=c[A>>2]|0;c[A>>2]=C+1;c[(c[c[m>>2]>>2]|0)+(C<<2)>>2]=D;D=c[A>>2]|0;C=c[o>>2]|0;B=(c[C>>2]|0)+1|0;c[C>>2]=B;c[(c[c[n>>2]>>2]|0)+(B<<2)>>2]=D}}c[q>>2]=(c[q>>2]|0)+1}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[u>>2]|0))break;if((c[(c[z>>2]|0)+(c[p>>2]<<2)>>2]|0)==(c[p>>2]|0)){q=c[p>>2]|0;r=c[A>>2]|0;c[A>>2]=r+1;c[(c[c[m>>2]>>2]|0)+(r<<2)>>2]=q;q=c[A>>2]|0;r=c[o>>2]|0;x=(c[r>>2]|0)+1|0;c[r>>2]=x;c[(c[c[n>>2]>>2]|0)+(x<<2)>>2]=q}c[p>>2]=(c[p>>2]|0)+1}O4(c[v>>2]|0);O4(c[z>>2]|0);i=j;return}function Vw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+44|0;h=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[s>>2]=0;c[o>>2]=c[(c[g>>2]|0)+20>>2];c[p>>2]=c[(c[g>>2]|0)+24>>2];c[q>>2]=c[c[g>>2]>>2];c[r>>2]=c[(c[g>>2]|0)+4>>2];g=cK(c[q>>2]<<2)|0;c[c[j>>2]>>2]=g;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[q>>2]|0))break;c[(c[c[j>>2]>>2]|0)+(c[l>>2]<<2)>>2]=c[l>>2];c[l>>2]=(c[l>>2]|0)+1}c[c[k>>2]>>2]=c[r>>2];if(!(c[h>>2]|0)){c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[q>>2]|0))break;c[n>>2]=c[(c[o>>2]|0)+(c[l>>2]<<2)>>2];while(1){t=c[l>>2]|0;if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[l>>2]|0)+1<<2)>>2]|0))break;if(((t|0)!=(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]|0)?(c[(c[c[j>>2]>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]|0)==(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]|0):0)?(c[(c[c[j>>2]>>2]|0)+(c[l>>2]<<2)>>2]|0)==(c[l>>2]|0):0){c[(c[c[j>>2]>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]=c[l>>2];c[(c[c[j>>2]>>2]|0)+(c[l>>2]<<2)>>2]=c[(c[p>>2]|0)+(c[n>>2]<<2)>>2];h=c[k>>2]|0;c[h>>2]=(c[h>>2]|0)+-1}c[n>>2]=(c[n>>2]|0)+1}c[l>>2]=t+1}i=f;return}c[s>>2]=tw(c[q>>2]|0)|0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[q>>2]|0))break;c[l>>2]=c[(c[s>>2]|0)+(c[m>>2]<<2)>>2];c[n>>2]=c[(c[o>>2]|0)+(c[l>>2]<<2)>>2];while(1){if((c[n>>2]|0)>=(c[(c[o>>2]|0)+((c[l>>2]|0)+1<<2)>>2]|0))break;if(((c[l>>2]|0)!=(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]|0)?(c[(c[c[j>>2]>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]|0)==(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]|0):0)?(c[(c[c[j>>2]>>2]|0)+(c[l>>2]<<2)>>2]|0)==(c[l>>2]|0):0){c[(c[c[j>>2]>>2]|0)+(c[(c[p>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]=c[l>>2];c[(c[c[j>>2]>>2]|0)+(c[l>>2]<<2)>>2]=c[(c[p>>2]|0)+(c[n>>2]<<2)>>2];t=c[k>>2]|0;c[t>>2]=(c[t>>2]|0)+-1}c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=(c[m>>2]|0)+1}O4(c[s>>2]|0);i=f;return}function Ww(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;f=i;i=i+80|0;g=f+64|0;j=f+60|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+44|0;o=f+40|0;p=f+36|0;q=f+32|0;r=f+28|0;s=f+24|0;t=f+20|0;u=f+16|0;v=f;w=f+12|0;x=f+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[t>>2]=0;h[v>>3]=0.0;c[w>>2]=1;c[x>>2]=0;c[p>>2]=c[(c[g>>2]|0)+20>>2];c[q>>2]=c[(c[g>>2]|0)+24>>2];c[r>>2]=c[c[g>>2]>>2];c[s>>2]=c[(c[g>>2]|0)+4>>2];e=cK(c[r>>2]<<2)|0;c[c[k>>2]>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]=c[m>>2];c[m>>2]=(c[m>>2]|0)+1}c[c[l>>2]>>2]=c[s>>2];c[u>>2]=c[(c[g>>2]|0)+28>>2];if(!(c[j>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;c[w>>2]=1;c[o>>2]=c[(c[p>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[o>>2]|0)>=(c[(c[p>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;do if(((c[m>>2]|0)!=(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0)?(c[(c[c[k>>2]>>2]|0)+(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]|0)==(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0):0)?(c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]|0)==(c[m>>2]|0):0){y=+h[(c[u>>2]|0)+(c[o>>2]<<3)>>3];if(c[w>>2]|0){h[v>>3]=y;c[x>>2]=c[(c[q>>2]|0)+(c[o>>2]<<2)>>2];c[w>>2]=0;break}if(y>+h[v>>3]){h[v>>3]=+h[(c[u>>2]|0)+(c[o>>2]<<3)>>3];c[x>>2]=c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]}}while(0);c[o>>2]=(c[o>>2]|0)+1}if(!(c[w>>2]|0)){c[(c[c[k>>2]>>2]|0)+(c[x>>2]<<2)>>2]=c[m>>2];c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]=c[x>>2];j=c[l>>2]|0;c[j>>2]=(c[j>>2]|0)+-1}c[m>>2]=(c[m>>2]|0)+1}i=f;return}c[t>>2]=tw(c[r>>2]|0)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[r>>2]|0))break;c[m>>2]=c[(c[t>>2]|0)+(c[n>>2]<<2)>>2];if((c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]|0)==(c[m>>2]|0)){c[w>>2]=1;c[o>>2]=c[(c[p>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[o>>2]|0)>=(c[(c[p>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;do if(((c[m>>2]|0)!=(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0)?(c[(c[c[k>>2]>>2]|0)+(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]|0)==(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0):0)?(c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]|0)==(c[m>>2]|0):0){y=+h[(c[u>>2]|0)+(c[o>>2]<<3)>>3];if(c[w>>2]|0){h[v>>3]=y;c[x>>2]=c[(c[q>>2]|0)+(c[o>>2]<<2)>>2];c[w>>2]=0;break}if(y>+h[v>>3]){h[v>>3]=+h[(c[u>>2]|0)+(c[o>>2]<<3)>>3];c[x>>2]=c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]}}while(0);c[o>>2]=(c[o>>2]|0)+1}if(!(c[w>>2]|0)){c[(c[c[k>>2]>>2]|0)+(c[x>>2]<<2)>>2]=c[m>>2];c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]=c[x>>2];j=c[l>>2]|0;c[j>>2]=(c[j>>2]|0)+-1}}c[n>>2]=(c[n>>2]|0)+1}O4(c[t>>2]|0);i=f;return}function Xw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;f=i;i=i+80|0;g=f+64|0;j=f+60|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+44|0;o=f+40|0;p=f+36|0;q=f+32|0;r=f+28|0;s=f+24|0;t=f+20|0;u=f+16|0;v=f;w=f+12|0;x=f+8|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[t>>2]=0;h[v>>3]=0.0;c[w>>2]=1;c[x>>2]=0;c[p>>2]=c[(c[g>>2]|0)+20>>2];c[q>>2]=c[(c[g>>2]|0)+24>>2];c[r>>2]=c[c[g>>2]>>2];c[s>>2]=c[(c[g>>2]|0)+4>>2];e=cK(c[r>>2]<<2)|0;c[c[k>>2]>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]=c[m>>2];c[m>>2]=(c[m>>2]|0)+1}c[c[l>>2]>>2]=c[s>>2];c[u>>2]=c[(c[g>>2]|0)+28>>2];if(!(c[j>>2]|0)){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[r>>2]|0))break;c[w>>2]=1;c[o>>2]=c[(c[p>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[o>>2]|0)>=(c[(c[p>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;do if(((c[m>>2]|0)!=(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0)?(c[(c[c[k>>2]>>2]|0)+(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]|0)==(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0):0)?(c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]|0)==(c[m>>2]|0):0){y=+h[(c[u>>2]|0)+(c[o>>2]<<3)>>3]/+((c[(c[p>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0)-(c[(c[p>>2]|0)+(c[m>>2]<<2)>>2]|0)|0)/+((c[(c[p>>2]|0)+((c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0)+1<<2)>>2]|0)-(c[(c[p>>2]|0)+(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]|0)|0);if(c[w>>2]|0){h[v>>3]=y;c[x>>2]=c[(c[q>>2]|0)+(c[o>>2]<<2)>>2];c[w>>2]=0;break}if(y>+h[v>>3]){h[v>>3]=+h[(c[u>>2]|0)+(c[o>>2]<<3)>>3]/+((c[(c[p>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0)-(c[(c[p>>2]|0)+(c[m>>2]<<2)>>2]|0)|0)/+((c[(c[p>>2]|0)+((c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0)+1<<2)>>2]|0)-(c[(c[p>>2]|0)+(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]|0)|0);c[x>>2]=c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]}}while(0);c[o>>2]=(c[o>>2]|0)+1}if(!(c[w>>2]|0)){c[(c[c[k>>2]>>2]|0)+(c[x>>2]<<2)>>2]=c[m>>2];c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]=c[x>>2];j=c[l>>2]|0;c[j>>2]=(c[j>>2]|0)+-1}c[m>>2]=(c[m>>2]|0)+1}i=f;return}c[t>>2]=tw(c[r>>2]|0)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[r>>2]|0))break;c[m>>2]=c[(c[t>>2]|0)+(c[n>>2]<<2)>>2];if((c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]|0)==(c[m>>2]|0)){c[w>>2]=1;c[o>>2]=c[(c[p>>2]|0)+(c[m>>2]<<2)>>2];while(1){if((c[o>>2]|0)>=(c[(c[p>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0))break;do if(((c[m>>2]|0)!=(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0)?(c[(c[c[k>>2]>>2]|0)+(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]|0)==(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0):0)?(c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]|0)==(c[m>>2]|0):0){y=+h[(c[u>>2]|0)+(c[o>>2]<<3)>>3]/+((c[(c[p>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0)-(c[(c[p>>2]|0)+(c[m>>2]<<2)>>2]|0)|0)/+((c[(c[p>>2]|0)+((c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0)+1<<2)>>2]|0)-(c[(c[p>>2]|0)+(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]|0)|0);if(c[w>>2]|0){h[v>>3]=y;c[x>>2]=c[(c[q>>2]|0)+(c[o>>2]<<2)>>2];c[w>>2]=0;break}if(y>+h[v>>3]){h[v>>3]=+h[(c[u>>2]|0)+(c[o>>2]<<3)>>3]/+((c[(c[p>>2]|0)+((c[m>>2]|0)+1<<2)>>2]|0)-(c[(c[p>>2]|0)+(c[m>>2]<<2)>>2]|0)|0)/+((c[(c[p>>2]|0)+((c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]|0)+1<<2)>>2]|0)-(c[(c[p>>2]|0)+(c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]|0)|0);c[x>>2]=c[(c[q>>2]|0)+(c[o>>2]<<2)>>2]}}while(0);c[o>>2]=(c[o>>2]|0)+1}if(!(c[w>>2]|0)){c[(c[c[k>>2]>>2]|0)+(c[x>>2]<<2)>>2]=c[m>>2];c[(c[c[k>>2]>>2]|0)+(c[m>>2]<<2)>>2]=c[x>>2];j=c[l>>2]|0;c[j>>2]=(c[j>>2]|0)+-1}}c[n>>2]=(c[n>>2]|0)+1}O4(c[t>>2]|0);i=f;return}function Yw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+64|0;h=g+48|0;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g+16|0;r=g+12|0;s=g+8|0;t=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[t>>2]=0;c[q>>2]=c[(c[h>>2]|0)+20>>2];c[r>>2]=c[(c[h>>2]|0)+24>>2];c[s>>2]=c[c[h>>2]>>2];c[g+4>>2]=c[(c[h>>2]|0)+4>>2];h=cK(c[s>>2]<<2)|0;c[c[k>>2]>>2]=h;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[s>>2]|0))break;c[(c[c[k>>2]>>2]|0)+(c[n>>2]<<2)>>2]=-100;c[n>>2]=(c[n>>2]|0)+1}c[c[l>>2]>>2]=0;c[c[m>>2]>>2]=0;if(!(c[j>>2]|0)){c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[s>>2]|0))break;a:do if((c[(c[c[k>>2]>>2]|0)+(c[n>>2]<<2)>>2]|0)==-100){j=c[l>>2]|0;h=c[j>>2]|0;c[j>>2]=h+1;c[(c[c[k>>2]>>2]|0)+(c[n>>2]<<2)>>2]=h;c[p>>2]=c[(c[q>>2]|0)+(c[n>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[q>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0))break a;if((c[n>>2]|0)!=(c[(c[r>>2]|0)+(c[p>>2]<<2)>>2]|0)){c[(c[c[k>>2]>>2]|0)+(c[(c[r>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2]=-1;h=c[m>>2]|0;c[h>>2]=(c[h>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}}while(0);c[n>>2]=(c[n>>2]|0)+1}u=c[l>>2]|0;v=c[u>>2]|0;w=c[m>>2]|0;x=c[w>>2]|0;y=x+v|0;c[w>>2]=y;i=g;return}c[t>>2]=tw(c[s>>2]|0)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[s>>2]|0))break;c[n>>2]=c[(c[t>>2]|0)+(c[o>>2]<<2)>>2];b:do if((c[(c[c[k>>2]>>2]|0)+(c[n>>2]<<2)>>2]|0)==-100){h=c[l>>2]|0;j=c[h>>2]|0;c[h>>2]=j+1;c[(c[c[k>>2]>>2]|0)+(c[n>>2]<<2)>>2]=j;c[p>>2]=c[(c[q>>2]|0)+(c[n>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[q>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0))break b;if((c[n>>2]|0)!=(c[(c[r>>2]|0)+(c[p>>2]<<2)>>2]|0)){c[(c[c[k>>2]>>2]|0)+(c[(c[r>>2]|0)+(c[p>>2]<<2)>>2]<<2)>>2]=-1;j=c[m>>2]|0;c[j>>2]=(c[j>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}}while(0);c[o>>2]=(c[o>>2]|0)+1}O4(c[t>>2]|0);u=c[l>>2]|0;v=c[u>>2]|0;w=c[m>>2]|0;x=c[w>>2]|0;y=x+v|0;c[w>>2]=y;i=g;return}function Zw(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+80|0;h=g+72|0;j=g+68|0;k=g+64|0;l=g+60|0;m=g+56|0;n=g+52|0;o=g+48|0;p=g+44|0;q=g+40|0;r=g+36|0;s=g+32|0;t=g+28|0;u=g+24|0;v=g+20|0;w=g+12|0;x=g+8|0;y=g+4|0;z=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[q>>2]=0;c[y>>2]=0;c[t>>2]=c[(c[h>>2]|0)+20>>2];c[u>>2]=c[(c[h>>2]|0)+24>>2];c[v>>2]=c[c[h>>2]>>2];c[g+16>>2]=c[(c[h>>2]|0)+4>>2];h=cK(c[v>>2]<<2)|0;c[c[k>>2]>>2]=h;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[v>>2]|0))break;c[(c[c[k>>2]>>2]|0)+(c[n>>2]<<2)>>2]=-100;c[n>>2]=(c[n>>2]|0)+1}c[c[l>>2]>>2]=0;c[c[m>>2]>>2]=0;c[z>>2]=$w(c[v>>2]|0,(c[v>>2]|0)-1<<1)|0;a:do if(c[j>>2]|0){c[q>>2]=tw(c[v>>2]|0)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[v>>2]|0))break;c[n>>2]=c[(c[q>>2]|0)+(c[p>>2]<<2)>>2];bx(c[z>>2]|0,c[n>>2]|0,(c[(c[t>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0)-(c[(c[t>>2]|0)+(c[n>>2]<<2)>>2]|0)|0)|0;c[p>>2]=(c[p>>2]|0)+1}O4(c[q>>2]|0)}else{c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[v>>2]|0))break a;bx(c[z>>2]|0,c[n>>2]|0,(c[(c[t>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0)-(c[(c[t>>2]|0)+(c[n>>2]<<2)>>2]|0)|0)|0;c[n>>2]=(c[n>>2]|0)+1}}while(0);b:while(1){v=(cx(c[z>>2]|0,n,w)|0)!=0;q=c[l>>2]|0;A=c[q>>2]|0;if(!v)break;c[q>>2]=A+1;c[(c[c[k>>2]>>2]|0)+(c[n>>2]<<2)>>2]=A;c[r>>2]=c[(c[t>>2]|0)+(c[n>>2]<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[t>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0))continue b;c[o>>2]=c[(c[u>>2]|0)+(c[r>>2]<<2)>>2];if((c[n>>2]|0)!=(c[o>>2]|0)){c:do if((c[(c[c[k>>2]>>2]|0)+(c[o>>2]<<2)>>2]|0)==-100){c[x>>2]=ex(c[z>>2]|0,c[o>>2]|0)|0;c[(c[c[k>>2]>>2]|0)+(c[o>>2]<<2)>>2]=-1;c[y>>2]=(c[y>>2]|0)+1;c[s>>2]=c[(c[t>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[s>>2]|0)>=(c[(c[t>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break c;if((c[o>>2]|0)!=(c[(c[u>>2]|0)+(c[s>>2]<<2)>>2]|0)?(c[(c[c[k>>2]>>2]|0)+(c[(c[u>>2]|0)+(c[s>>2]<<2)>>2]<<2)>>2]|0)==-100:0){c[w>>2]=dx(c[z>>2]|0,c[(c[u>>2]|0)+(c[s>>2]<<2)>>2]|0)|0;bx(c[z>>2]|0,c[(c[u>>2]|0)+(c[s>>2]<<2)>>2]|0,(c[w>>2]|0)+1|0)|0}c[s>>2]=(c[s>>2]|0)+1}}while(0);q=c[m>>2]|0;c[q>>2]=(c[q>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}}r=c[m>>2]|0;c[r>>2]=(c[r>>2]|0)+A;ax(c[z>>2]|0);i=g;return}function _w(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[f>>2];c[k>>2]=c[g>>2];if(+h[(c[j>>2]|0)+8>>3]>+h[(c[k>>2]|0)+8>>3]){c[e>>2]=-1;l=c[e>>2]|0;i=d;return l|0}if(+h[(c[j>>2]|0)+8>>3]<+h[(c[k>>2]|0)+8>>3]){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}else{c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}return 0}function $w(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=cK(28)|0;c[c[g>>2]>>2]=0;c[(c[g>>2]|0)+4>>2]=c[e>>2];c[(c[g>>2]|0)+8>>2]=c[f>>2];c[(c[g>>2]|0)+12>>2]=-1;b=cK((c[f>>2]|0)+1<<2)|0;c[(c[g>>2]|0)+16>>2]=b;c[h>>2]=0;while(1){if((c[h>>2]|0)>=((c[f>>2]|0)+1|0))break;c[(c[(c[g>>2]|0)+16>>2]|0)+(c[h>>2]<<2)>>2]=0;c[h>>2]=(c[h>>2]|0)+1}f=cK((c[e>>2]|0)+1<<2)|0;c[(c[g>>2]|0)+20>>2]=f;c[h>>2]=0;while(1){if((c[h>>2]|0)>=((c[e>>2]|0)+1|0))break;c[(c[(c[g>>2]|0)+20>>2]|0)+(c[h>>2]<<2)>>2]=0;c[h>>2]=(c[h>>2]|0)+1}f=cK((c[e>>2]|0)+1<<2)|0;c[(c[g>>2]|0)+24>>2]=f;c[h>>2]=0;while(1){if((c[h>>2]|0)>=((c[e>>2]|0)+1|0))break;c[(c[(c[g>>2]|0)+24>>2]|0)+(c[h>>2]<<2)>>2]=-999;c[h>>2]=(c[h>>2]|0)+1}i=d;return c[g>>2]|0}function ax(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+16>>2]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=((c[(c[d>>2]|0)+8>>2]|0)+1|0))break;uy(c[(c[(c[d>>2]|0)+16>>2]|0)+(c[e>>2]<<2)>>2]|0,96);c[e>>2]=(c[e>>2]|0)+1}O4(c[(c[d>>2]|0)+16>>2]|0)}if(c[(c[d>>2]|0)+20>>2]|0)O4(c[(c[d>>2]|0)+20>>2]|0);O4(c[(c[d>>2]|0)+24>>2]|0);O4(c[d>>2]|0);i=b;return}function bx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if(!(c[g>>2]|0))La(176691,133234,69,133250);if((c[j>>2]|0)>(c[(c[g>>2]|0)+8>>2]|0))La(133269,133234,70,133250);if(c[(c[(c[g>>2]|0)+20>>2]|0)+(c[h>>2]<<2)>>2]|0){c[k>>2]=c[(c[(c[g>>2]|0)+20>>2]|0)+(c[h>>2]<<2)>>2];c[m>>2]=c[(c[(c[g>>2]|0)+24>>2]|0)+(c[h>>2]<<2)>>2];c[(c[(c[g>>2]|0)+20>>2]|0)+(c[h>>2]<<2)>>2]=0;d=c[g>>2]|0;c[d>>2]=(c[d>>2]|0)+-1;xy(c[k>>2]|0,96,(c[(c[g>>2]|0)+16>>2]|0)+(c[m>>2]<<2)|0);c[f>>2]=bx(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0)|0;n=c[f>>2]|0;i=e;return n|0}m=c[g>>2]|0;c[m>>2]=(c[m>>2]|0)+1;if((c[j>>2]|0)>(c[(c[g>>2]|0)+12>>2]|0))c[(c[g>>2]|0)+12>>2]=c[j>>2];c[(c[(c[g>>2]|0)+24>>2]|0)+(c[h>>2]<<2)>>2]=c[j>>2];c[l>>2]=cK(4)|0;c[c[l>>2]>>2]=c[h>>2];m=c[(c[(c[g>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]|0;c[k>>2]=m;if(m){m=vy(c[k>>2]|0,c[l>>2]|0)|0;c[(c[(c[g>>2]|0)+20>>2]|0)+(c[h>>2]<<2)>>2]=m;c[(c[(c[g>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]=m}else{m=ty(c[l>>2]|0)|0;c[(c[(c[g>>2]|0)+20>>2]|0)+(c[h>>2]<<2)>>2]=m;c[(c[(c[g>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]=m}c[f>>2]=c[g>>2];n=c[f>>2]|0;i=e;return n|0}function cx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[g>>2]|0)!=0?(c[c[g>>2]>>2]|0)>0:0){d=c[(c[g>>2]|0)+12>>2]|0;c[k>>2]=d;c[c[j>>2]>>2]=d;d=c[g>>2]|0;c[d>>2]=(c[d>>2]|0)+-1;c[l>>2]=c[(c[(c[g>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2];c[m>>2]=wy(c[l>>2]|0)|0;c[c[h>>2]>>2]=c[c[m>>2]>>2];xy(c[l>>2]|0,96,(c[(c[g>>2]|0)+16>>2]|0)+(c[k>>2]<<2)|0);if(!(c[(c[(c[g>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)){while(1){if((c[k>>2]|0)>=0)n=(c[(c[(c[g>>2]|0)+16>>2]|0)+(c[k>>2]<<2)>>2]|0)!=0^1;else n=0;o=c[k>>2]|0;if(!n)break;c[k>>2]=o+-1}c[(c[g>>2]|0)+12>>2]=o}c[(c[(c[g>>2]|0)+20>>2]|0)+(c[c[h>>2]>>2]<<2)>>2]=0;c[(c[(c[g>>2]|0)+24>>2]|0)+(c[c[h>>2]>>2]<<2)>>2]=-999;c[f>>2]=1;p=c[f>>2]|0;i=e;return p|0}c[f>>2]=0;p=c[f>>2]|0;i=e;return p|0}function dx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;i=d;return c[(c[(c[e>>2]|0)+24>>2]|0)+(c[f>>2]<<2)>>2]|0}function ex(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)!=0?(c[c[f>>2]>>2]|0)>0:0){c[h>>2]=c[(c[(c[f>>2]|0)+24>>2]|0)+(c[g>>2]<<2)>>2];b=c[f>>2]|0;c[b>>2]=(c[b>>2]|0)+-1;c[k>>2]=c[(c[(c[f>>2]|0)+20>>2]|0)+(c[g>>2]<<2)>>2];xy(c[k>>2]|0,96,(c[(c[f>>2]|0)+16>>2]|0)+(c[h>>2]<<2)|0);k=c[h>>2]|0;h=c[(c[f>>2]|0)+12>>2]|0;c[j>>2]=h;if((k|0)==(h|0)?(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]|0)==0:0){while(1){if((c[j>>2]|0)>=0)l=(c[(c[(c[f>>2]|0)+16>>2]|0)+(c[j>>2]<<2)>>2]|0)!=0^1;else l=0;m=c[j>>2]|0;if(!l)break;c[j>>2]=m+-1}c[(c[f>>2]|0)+12>>2]=m}c[(c[(c[f>>2]|0)+20>>2]|0)+(c[g>>2]<<2)>>2]=0;c[(c[(c[f>>2]|0)+24>>2]|0)+(c[g>>2]<<2)>>2]=-999;c[e>>2]=1;n=c[e>>2]|0;i=d;return n|0}c[e>>2]=0;n=c[e>>2]|0;i=d;return n|0}function fx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0;e=i;i=i+96|0;f=e+80|0;g=e+76|0;j=e+72|0;k=e+68|0;l=e+64|0;m=e+60|0;n=e+56|0;o=e+52|0;p=e+48|0;q=e+44|0;r=e+40|0;s=e+36|0;t=e+32|0;u=e+24|0;v=e+16|0;w=e+8|0;x=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[t>>2]=0;if(!(Ov(c[f>>2]|0,0)|0))La(133286,133322,262,133337);c[k>>2]=Pv(c[f>>2]|0)|0;c[l>>2]=c[(c[k>>2]|0)+20>>2];c[m>>2]=c[(c[k>>2]|0)+24>>2];if((c[(c[k>>2]|0)+16>>2]|0)!=1){O4(c[(c[k>>2]|0)+28>>2]|0);c[(c[k>>2]|0)+16>>2]=1;f=cK(c[(c[k>>2]|0)+8>>2]<<3)|0;c[(c[k>>2]|0)+28>>2]=f}c[s>>2]=c[(c[k>>2]|0)+28>>2];c[t>>2]=cK(c[c[k>>2]>>2]<<2)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[c[k>>2]>>2]|0))break;c[(c[t>>2]|0)+(c[n>>2]<<2)>>2]=-1;c[n>>2]=(c[n>>2]|0)+1}c[n>>2]=0;a:while(1){if((c[n>>2]|0)>=(c[c[k>>2]>>2]|0))break;h[v>>3]=+((c[(c[l>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0)-(c[(c[l>>2]|0)+(c[n>>2]<<2)>>2]|0)|0);c[(c[t>>2]|0)+(c[n>>2]<<2)>>2]=c[n>>2];c[o>>2]=c[(c[l>>2]|0)+(c[n>>2]<<2)>>2];while(1){y=c[n>>2]|0;if((c[o>>2]|0)>=(c[(c[l>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0))break;if((y|0)!=(c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]|0))c[(c[t>>2]|0)+(c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]<<2)>>2]=c[n>>2];c[o>>2]=(c[o>>2]|0)+1}c[o>>2]=c[(c[l>>2]|0)+(y<<2)>>2];while(1){if((c[o>>2]|0)>=(c[(c[l>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0))break;c[p>>2]=c[(c[m>>2]|0)+(c[o>>2]<<2)>>2];if((c[n>>2]|0)!=(c[p>>2]|0)){h[u>>3]=+h[v>>3]+ +((c[(c[l>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0)-(c[(c[l>>2]|0)+(c[p>>2]<<2)>>2]|0)|0);c[q>>2]=c[(c[l>>2]|0)+(c[p>>2]<<2)>>2];while(1){if((c[q>>2]|0)>=(c[(c[l>>2]|0)+((c[p>>2]|0)+1<<2)>>2]|0))break;if((c[(c[t>>2]|0)+(c[(c[m>>2]|0)+(c[q>>2]<<2)>>2]<<2)>>2]|0)==(c[n>>2]|0))h[u>>3]=+h[u>>3]+-1.0;c[q>>2]=(c[q>>2]|0)+1}h[(c[s>>2]|0)+(c[o>>2]<<3)>>3]=+h[u>>3];if(!(+h[u>>3]>0.0)){z=24;break a}}c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+1}if((z|0)==24)La(133359,133322,292,133337);h[w>>3]=0.0;h[x>>3]=0.0;c[r>>2]=0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[c[k>>2]>>2]|0))break;c[o>>2]=c[(c[l>>2]|0)+(c[n>>2]<<2)>>2];while(1){A=c[n>>2]|0;if((c[o>>2]|0)>=(c[(c[l>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0))break;if((A|0)!=(c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]|0)){c[r>>2]=(c[r>>2]|0)+1;B=+zw(c[j>>2]|0,c[g>>2]|0,c[n>>2]|0,c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]|0);h[w>>3]=+h[w>>3]+B;h[x>>3]=+h[x>>3]+ +h[(c[s>>2]|0)+(c[o>>2]<<3)>>3]}c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=A+1}h[w>>3]=+h[w>>3]/+(c[r>>2]|0);h[x>>3]=+h[x>>3]/+(c[r>>2]|0);h[w>>3]=+h[w>>3]/+h[x>>3];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[c[k>>2]>>2]|0))break;c[o>>2]=c[(c[l>>2]|0)+(c[n>>2]<<2)>>2];while(1){C=c[n>>2]|0;if((c[o>>2]|0)>=(c[(c[l>>2]|0)+((c[n>>2]|0)+1<<2)>>2]|0))break;if((C|0)!=(c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]|0))h[(c[s>>2]|0)+(c[o>>2]<<3)>>3]=+h[w>>3]*+h[(c[s>>2]|0)+(c[o>>2]<<3)>>3];c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=C+1}i=e;return c[k>>2]|0}function gx(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,Q=0,R=0,S=0,T=0.0,U=0.0,V=0;g=i;i=i+176|0;j=g+64|0;k=g+56|0;l=g+160|0;m=g+156|0;n=g+152|0;o=g+48|0;p=g+148|0;q=g+144|0;r=g+140|0;s=g+136|0;t=g+132|0;u=g+128|0;v=g+124|0;w=g+120|0;x=g+116|0;y=g+112|0;z=g+108|0;A=g+104|0;B=g+100|0;C=g+96|0;D=g+92|0;E=g+88|0;F=g+84|0;G=g+80|0;H=g+76|0;I=g+72|0;J=g+40|0;K=g+32|0;L=g+24|0;M=g+16|0;N=g+8|0;Q=g;R=g+68|0;c[m>>2]=a;c[n>>2]=b;h[o>>3]=d;c[p>>2]=e;c[q>>2]=f;c[w>>2]=c[c[m>>2]>>2];c[x>>2]=c[(c[m>>2]|0)+20>>2];c[y>>2]=c[(c[m>>2]|0)+24>>2];h[M>>3]=0.0;h[N>>3]=0.0;h[Q>>3]=0.0;if(!(Ov(c[m>>2]|0,0)|0))La(133286,133322,335,133367);c[R>>2]=fx(c[m>>2]|0,c[n>>2]|0,c[p>>2]|0)|0;c[r>>2]=cK(56)|0;h[(c[r>>2]|0)+32>>3]=1.0;c[(c[r>>2]|0)+20>>2]=0;c[(c[r>>2]|0)+24>>2]=0;h[(c[r>>2]|0)+40>>3]=.01;f=~~+O(+(+(c[c[m>>2]>>2]|0)));c[(c[r>>2]|0)+48>>2]=f;f=cK(c[w>>2]<<3)|0;c[(c[r>>2]|0)+12>>2]=f;c[H>>2]=f;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[w>>2]|0))break;h[(c[(c[r>>2]|0)+12>>2]|0)+(c[s>>2]<<3)>>3]=+h[o>>3];c[s>>2]=(c[s>>2]|0)+1}c[D>>2]=cK(c[w>>2]<<2)|0;c[I>>2]=cK(c[w>>2]<<3)|0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[w>>2]|0))break;h[(c[I>>2]|0)+(c[s>>2]<<3)>>3]=0.0;c[E>>2]=0;c[t>>2]=c[(c[x>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[x>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;if((c[s>>2]|0)!=(c[(c[y>>2]|0)+(c[t>>2]<<2)>>2]|0)){d=+zw(c[p>>2]|0,c[n>>2]|0,c[s>>2]|0,c[(c[y>>2]|0)+(c[t>>2]<<2)>>2]|0);o=(c[I>>2]|0)+(c[s>>2]<<3)|0;h[o>>3]=+h[o>>3]+d;c[E>>2]=(c[E>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}if((c[E>>2]|0)<=0){S=14;break}o=(c[I>>2]|0)+(c[s>>2]<<3)|0;h[o>>3]=+h[o>>3]/+(c[E>>2]|0);c[s>>2]=(c[s>>2]|0)+1}if((S|0)==14)La(133399,133322,360,133367);c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[w>>2]|0))break;c[(c[D>>2]|0)+(c[s>>2]<<2)>>2]=-1;c[s>>2]=(c[s>>2]|0)+1}c[E>>2]=0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[w>>2]|0))break;c[(c[D>>2]|0)+(c[s>>2]<<2)>>2]=c[s>>2];c[t>>2]=c[(c[x>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[x>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[u>>2]=c[(c[y>>2]|0)+(c[t>>2]<<2)>>2];if((c[(c[D>>2]|0)+(c[u>>2]<<2)>>2]|0)!=(c[s>>2]|0)){c[(c[D>>2]|0)+(c[u>>2]<<2)>>2]=c[s>>2];c[E>>2]=(c[E>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[x>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[x>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[u>>2]=c[(c[y>>2]|0)+(c[t>>2]<<2)>>2];c[v>>2]=c[(c[x>>2]|0)+(c[u>>2]<<2)>>2];while(1){if((c[v>>2]|0)>=(c[(c[x>>2]|0)+((c[u>>2]|0)+1<<2)>>2]|0))break;if((c[(c[D>>2]|0)+(c[(c[y>>2]|0)+(c[v>>2]<<2)>>2]<<2)>>2]|0)!=(c[s>>2]|0)){c[(c[D>>2]|0)+(c[(c[y>>2]|0)+(c[v>>2]<<2)>>2]<<2)>>2]=c[s>>2];c[E>>2]=(c[E>>2]|0)+1}c[v>>2]=(c[v>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[s>>2]=(c[s>>2]|0)+1}o=Nv(c[w>>2]|0,c[w>>2]|0,(c[E>>2]|0)+(c[w>>2]|0)|0,1,1)|0;c[(c[r>>2]|0)+4>>2]=o;o=Nv(c[w>>2]|0,c[w>>2]|0,(c[E>>2]|0)+(c[w>>2]|0)|0,1,1)|0;c[(c[r>>2]|0)+8>>2]=o;if((c[(c[r>>2]|0)+4>>2]|0)!=0?(c[(c[r>>2]|0)+8>>2]|0)!=0:0){c[z>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+20>>2];c[A>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+24>>2];c[G>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+28>>2];c[F>>2]=c[(c[(c[r>>2]|0)+8>>2]|0)+28>>2];c[B>>2]=c[(c[(c[r>>2]|0)+8>>2]|0)+20>>2];c[C>>2]=c[(c[(c[r>>2]|0)+8>>2]|0)+24>>2];c[c[B>>2]>>2]=0;c[c[z>>2]>>2]=0;c[E>>2]=0;c[s>>2]=0;a:while(1){if((c[s>>2]|0)>=(c[w>>2]|0)){S=68;break}c[(c[D>>2]|0)+(c[s>>2]<<2)>>2]=(c[s>>2]|0)+(c[w>>2]|0);h[K>>3]=0.0;h[J>>3]=0.0;c[t>>2]=c[(c[x>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[x>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[u>>2]=c[(c[y>>2]|0)+(c[t>>2]<<2)>>2];if((c[(c[D>>2]|0)+(c[u>>2]<<2)>>2]|0)!=((c[s>>2]|0)+(c[w>>2]|0)|0)){c[(c[D>>2]|0)+(c[u>>2]<<2)>>2]=(c[s>>2]|0)+(c[w>>2]|0);c[(c[A>>2]|0)+(c[E>>2]<<2)>>2]=c[u>>2];do if(!(c[q>>2]|0))h[L>>3]=1.0;else{if((c[q>>2]|0)==1){h[L>>3]=(+h[(c[I>>2]|0)+(c[s>>2]<<3)>>3]+ +h[(c[I>>2]|0)+(c[u>>2]<<3)>>3])*.5;break}if((c[q>>2]|0)!=2){S=49;break a}h[L>>3]=+P(+(+yw(c[p>>2]|0,c[n>>2]|0,c[s>>2]|0,c[u>>2]|0)),.4)}while(0);h[(c[G>>2]|0)+(c[E>>2]<<3)>>3]=-1.0/(+h[L>>3]*+h[L>>3]);h[K>>3]=+h[K>>3]+ +h[(c[G>>2]|0)+(c[E>>2]<<3)>>3];c[(c[C>>2]|0)+(c[E>>2]<<2)>>2]=c[u>>2];h[(c[F>>2]|0)+(c[E>>2]<<3)>>3]=+h[(c[G>>2]|0)+(c[E>>2]<<3)>>3]*+h[L>>3];d=+h[(c[F>>2]|0)+(c[E>>2]<<3)>>3];T=d*+zw(c[p>>2]|0,c[n>>2]|0,c[s>>2]|0,c[u>>2]|0);h[N>>3]=+h[N>>3]+T;h[Q>>3]=+h[Q>>3]+ +h[(c[F>>2]|0)+(c[E>>2]<<3)>>3]*+h[L>>3];h[J>>3]=+h[J>>3]+ +h[(c[F>>2]|0)+(c[E>>2]<<3)>>3];c[E>>2]=(c[E>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[t>>2]=c[(c[x>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[x>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[u>>2]=c[(c[y>>2]|0)+(c[t>>2]<<2)>>2];c[v>>2]=c[(c[x>>2]|0)+(c[u>>2]<<2)>>2];while(1){if((c[v>>2]|0)>=(c[(c[x>>2]|0)+((c[u>>2]|0)+1<<2)>>2]|0))break;if((c[(c[D>>2]|0)+(c[(c[y>>2]|0)+(c[v>>2]<<2)>>2]<<2)>>2]|0)!=((c[s>>2]|0)+(c[w>>2]|0)|0)){c[(c[D>>2]|0)+(c[(c[y>>2]|0)+(c[v>>2]<<2)>>2]<<2)>>2]=(c[s>>2]|0)+(c[w>>2]|0);do if(!(c[q>>2]|0))h[L>>3]=2.0;else{if((c[q>>2]|0)==1){h[L>>3]=(+h[(c[I>>2]|0)+(c[s>>2]<<3)>>3]+ +h[(c[I>>2]|0)+(c[u>>2]<<3)>>3]*2.0+ +h[(c[I>>2]|0)+(c[(c[y>>2]|0)+(c[v>>2]<<2)>>2]<<3)>>3])*.5;break}if((c[q>>2]|0)!=2){S=63;break a}h[L>>3]=+P(+(+yw(c[p>>2]|0,c[n>>2]|0,c[s>>2]|0,c[(c[y>>2]|0)+(c[v>>2]<<2)>>2]|0)),.4)}while(0);c[(c[A>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[y>>2]|0)+(c[v>>2]<<2)>>2];h[(c[G>>2]|0)+(c[E>>2]<<3)>>3]=-1.0/(+h[L>>3]*+h[L>>3]);h[K>>3]=+h[K>>3]+ +h[(c[G>>2]|0)+(c[E>>2]<<3)>>3];c[(c[C>>2]|0)+(c[E>>2]<<2)>>2]=c[(c[y>>2]|0)+(c[v>>2]<<2)>>2];h[(c[F>>2]|0)+(c[E>>2]<<3)>>3]=+h[(c[G>>2]|0)+(c[E>>2]<<3)>>3]*+h[L>>3];T=+h[(c[F>>2]|0)+(c[E>>2]<<3)>>3];d=T*+zw(c[p>>2]|0,c[n>>2]|0,c[(c[y>>2]|0)+(c[v>>2]<<2)>>2]|0,c[u>>2]|0);h[N>>3]=+h[N>>3]+d;h[Q>>3]=+h[Q>>3]+ +h[(c[F>>2]|0)+(c[E>>2]<<3)>>3]*+h[L>>3];h[J>>3]=+h[J>>3]+ +h[(c[F>>2]|0)+(c[E>>2]<<3)>>3];c[E>>2]=(c[E>>2]|0)+1}c[v>>2]=(c[v>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[(c[A>>2]|0)+(c[E>>2]<<2)>>2]=c[s>>2];o=(c[H>>2]|0)+(c[s>>2]<<3)|0;h[o>>3]=+h[o>>3]*-+h[K>>3];h[(c[G>>2]|0)+(c[E>>2]<<3)>>3]=-+h[K>>3]+ +h[(c[H>>2]|0)+(c[s>>2]<<3)>>3];c[(c[C>>2]|0)+(c[E>>2]<<2)>>2]=c[s>>2];h[(c[F>>2]|0)+(c[E>>2]<<3)>>3]=-+h[J>>3];c[E>>2]=(c[E>>2]|0)+1;c[(c[z>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[E>>2];c[(c[B>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[E>>2];c[s>>2]=(c[s>>2]|0)+1}if((S|0)==49){Y2(c[24742]|0,133406,k)|0;La(176099,133322,420,133367)}else if((S|0)==63){Y2(c[24742]|0,133406,j)|0;La(176099,133322,462,133367)}else if((S|0)==68){h[M>>3]=+h[N>>3]/+h[Q>>3];c[s>>2]=0;while(1){U=+h[M>>3];if((c[s>>2]|0)>=(c[E>>2]|0))break;Q=(c[F>>2]|0)+(c[s>>2]<<3)|0;h[Q>>3]=+h[Q>>3]*U;c[s>>2]=(c[s>>2]|0)+1}h[(c[r>>2]|0)+32>>3]=U;c[(c[(c[r>>2]|0)+4>>2]|0)+8>>2]=c[E>>2];c[(c[(c[r>>2]|0)+8>>2]|0)+8>>2]=c[E>>2];O4(c[D>>2]|0);O4(c[I>>2]|0);Lv(c[R>>2]|0);c[l>>2]=c[r>>2];V=c[l>>2]|0;i=g;return V|0}}hx(c[r>>2]|0);c[l>>2]=0;V=c[l>>2]|0;i=g;return V|0}function hx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[(c[d>>2]|0)+4>>2]|0)Lv(c[(c[d>>2]|0)+4>>2]|0);if(c[(c[d>>2]|0)+8>>2]|0)Lv(c[(c[d>>2]|0)+8>>2]|0);if(c[(c[d>>2]|0)+12>>2]|0)O4(c[(c[d>>2]|0)+12>>2]|0);if(c[(c[d>>2]|0)+20>>2]|0)Bb[c[(c[d>>2]|0)+16>>2]&127](c[(c[d>>2]|0)+20>>2]|0);O4(c[d>>2]|0);i=b;return}function ix(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,Q=0.0,R=0,S=0.0;j=i;i=i+160|0;k=j+148|0;l=j+144|0;m=j+140|0;n=j+56|0;o=j+136|0;p=j+132|0;q=j+128|0;r=j+124|0;s=j+120|0;t=j+116|0;u=j+112|0;v=j+108|0;w=j+104|0;x=j+100|0;y=j+96|0;z=j+92|0;A=j+88|0;B=j+84|0;C=j+80|0;D=j+76|0;E=j+72|0;F=j+68|0;G=j+48|0;H=j+40|0;I=j+64|0;J=j+32|0;K=j+24|0;L=j+16|0;M=j+8|0;N=j;c[l>>2]=a;c[m>>2]=b;h[n>>3]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[v>>2]=c[c[l>>2]>>2];h[K>>3]=0.0;h[L>>3]=0.0;h[M>>3]=0.0;h[N>>3]=0.0;if(!(Ov(c[l>>2]|0,0)|0))La(133436,133322,527,133503);if((c[(c[l>>2]|0)+16>>2]|0)!=1)La(133436,133322,527,133503);c[s>>2]=0;while(1){if((c[s>>2]|0)>=(_(c[v>>2]|0,c[m>>2]|0)|0))break;h[N>>3]=+h[N>>3]+ +h[(c[o>>2]|0)+(c[s>>2]<<3)>>3]*+h[(c[o>>2]|0)+(c[s>>2]<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}a:do if(+h[N>>3]==0.0){c[s>>2]=0;while(1){if((c[s>>2]|0)>=(_(c[v>>2]|0,c[m>>2]|0)|0))break a;d=+rw()*72.0;h[(c[o>>2]|0)+(c[s>>2]<<3)>>3]=d;c[s>>2]=(c[s>>2]|0)+1}}while(0);c[w>>2]=c[(c[l>>2]|0)+20>>2];c[x>>2]=c[(c[l>>2]|0)+24>>2];c[I>>2]=c[(c[l>>2]|0)+28>>2];c[r>>2]=cK(56)|0;h[(c[r>>2]|0)+32>>3]=1.0;c[(c[r>>2]|0)+20>>2]=0;c[(c[r>>2]|0)+24>>2]=0;c[c[r>>2]>>2]=c[l>>2];h[(c[r>>2]|0)+40>>3]=.01;N=~~+O(+(+(c[c[l>>2]>>2]|0)));c[(c[r>>2]|0)+48>>2]=N;N=cK(c[v>>2]<<3)|0;c[(c[r>>2]|0)+12>>2]=N;c[F>>2]=N;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[v>>2]|0))break;h[(c[(c[r>>2]|0)+12>>2]|0)+(c[s>>2]<<3)>>3]=+h[n>>3];c[s>>2]=(c[s>>2]|0)+1}c[C>>2]=c[(c[l>>2]|0)+8>>2];l=Nv(c[v>>2]|0,c[v>>2]|0,(c[C>>2]|0)+(c[v>>2]|0)|0,1,1)|0;c[(c[r>>2]|0)+4>>2]=l;l=Nv(c[v>>2]|0,c[v>>2]|0,(c[C>>2]|0)+(c[v>>2]|0)|0,1,1)|0;c[(c[r>>2]|0)+8>>2]=l;if((c[(c[r>>2]|0)+4>>2]|0)!=0?(c[(c[r>>2]|0)+8>>2]|0)!=0:0){c[y>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+20>>2];c[z>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+24>>2];c[A>>2]=c[(c[(c[r>>2]|0)+8>>2]|0)+20>>2];c[B>>2]=c[(c[(c[r>>2]|0)+8>>2]|0)+24>>2];c[E>>2]=c[(c[(c[r>>2]|0)+4>>2]|0)+28>>2];c[D>>2]=c[(c[(c[r>>2]|0)+8>>2]|0)+28>>2];c[c[A>>2]>>2]=0;c[c[y>>2]>>2]=0;c[C>>2]=0;c[s>>2]=0;b:while(1){if((c[s>>2]|0)>=(c[v>>2]|0))break;h[H>>3]=0.0;h[G>>3]=0.0;c[t>>2]=c[(c[w>>2]|0)+(c[s>>2]<<2)>>2];while(1){if((c[t>>2]|0)>=(c[(c[w>>2]|0)+((c[s>>2]|0)+1<<2)>>2]|0))break;c[u>>2]=c[(c[x>>2]|0)+(c[t>>2]<<2)>>2];if((c[u>>2]|0)!=(c[s>>2]|0)){c[(c[z>>2]|0)+(c[C>>2]<<2)>>2]=c[u>>2];h[J>>3]=+h[(c[I>>2]|0)+(c[t>>2]<<3)>>3];c:do switch(c[p>>2]|0){case 2:{if(+h[J>>3]*+h[J>>3]==0.0){h[(c[E>>2]|0)+(c[C>>2]<<3)>>3]=-1.0e5;break c}else{h[(c[E>>2]|0)+(c[C>>2]<<3)>>3]=-1.0/(+h[J>>3]*+h[J>>3]);break c}break}case 1:{if(+h[J>>3]*+h[J>>3]==0.0){h[(c[E>>2]|0)+(c[C>>2]<<3)>>3]=-1.0e5;break c}else{h[(c[E>>2]|0)+(c[C>>2]<<3)>>3]=-1.0/+h[J>>3];break c}break}case 0:{h[(c[E>>2]|0)+(c[C>>2]<<3)>>3]=-1.0;break}default:{P=30;break b}}while(0);h[H>>3]=+h[H>>3]+ +h[(c[E>>2]|0)+(c[C>>2]<<3)>>3];c[(c[B>>2]|0)+(c[C>>2]<<2)>>2]=c[u>>2];h[(c[D>>2]|0)+(c[C>>2]<<3)>>3]=+h[(c[E>>2]|0)+(c[C>>2]<<3)>>3]*+h[J>>3];d=+h[(c[D>>2]|0)+(c[C>>2]<<3)>>3];Q=d*+zw(c[o>>2]|0,c[m>>2]|0,c[s>>2]|0,c[u>>2]|0);h[L>>3]=+h[L>>3]+Q;h[M>>3]=+h[M>>3]+ +h[(c[D>>2]|0)+(c[C>>2]<<3)>>3]*+h[J>>3];h[G>>3]=+h[G>>3]+ +h[(c[D>>2]|0)+(c[C>>2]<<3)>>3];c[C>>2]=(c[C>>2]|0)+1}c[t>>2]=(c[t>>2]|0)+1}c[(c[z>>2]|0)+(c[C>>2]<<2)>>2]=c[s>>2];l=(c[F>>2]|0)+(c[s>>2]<<3)|0;h[l>>3]=+h[l>>3]*-+h[H>>3];h[(c[E>>2]|0)+(c[C>>2]<<3)>>3]=-+h[H>>3]+ +h[(c[F>>2]|0)+(c[s>>2]<<3)>>3];c[(c[B>>2]|0)+(c[C>>2]<<2)>>2]=c[s>>2];h[(c[D>>2]|0)+(c[C>>2]<<3)>>3]=-+h[G>>3];c[C>>2]=(c[C>>2]|0)+1;c[(c[y>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[C>>2];c[(c[A>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[C>>2];c[s>>2]=(c[s>>2]|0)+1}if((P|0)==30)La(176099,133322,593,133503);if(c[q>>2]|0)h[K>>3]=+h[L>>3]/+h[M>>3];else h[K>>3]=1.0;if(+h[K>>3]==0.0){c[k>>2]=0;R=c[k>>2]|0;i=j;return R|0}c[s>>2]=0;while(1){S=+h[K>>3];if((c[s>>2]|0)>=(c[C>>2]|0))break;M=(c[D>>2]|0)+(c[s>>2]<<3)|0;h[M>>3]=+h[M>>3]*S;c[s>>2]=(c[s>>2]|0)+1}h[(c[r>>2]|0)+32>>3]=S;c[(c[(c[r>>2]|0)+4>>2]|0)+8>>2]=c[C>>2];c[(c[(c[r>>2]|0)+8>>2]|0)+8>>2]=c[C>>2];c[k>>2]=c[r>>2];R=c[k>>2]|0;i=j;return R|0}hx(c[r>>2]|0);c[k>>2]=0;R=c[k>>2]|0;i=j;return R|0}function jx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;hx(c[d>>2]|0);i=b;return}function kx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;h[n>>3]=f;f=+lx(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,+h[n>>3]);i=g;return +f}function lx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0.0;g=i;i=i+176|0;j=g+164|0;k=g+160|0;l=g+156|0;m=g+152|0;n=g+56|0;o=g+148|0;p=g+144|0;q=g+140|0;r=g+136|0;s=g+132|0;t=g+128|0;u=g+124|0;v=g+120|0;w=g+116|0;x=g+112|0;y=g+108|0;z=g+104|0;A=g+100|0;B=g+96|0;C=g+92|0;D=g+88|0;E=g+84|0;F=g+80|0;G=g+76|0;H=g+72|0;I=g+48|0;J=g+40|0;K=g+68|0;L=g+32|0;M=g+24|0;N=g+16|0;P=g+64|0;Q=g+8|0;R=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;h[n>>3]=f;c[o>>2]=c[(c[j>>2]|0)+4>>2];c[p>>2]=c[(c[j>>2]|0)+8>>2];c[q>>2]=0;c[A>>2]=0;c[B>>2]=0;c[F>>2]=0;c[G>>2]=0;c[H>>2]=0;h[J>>3]=1.0;c[K>>2]=c[(c[j>>2]|0)+12>>2];h[M>>3]=0.0;h[N>>3]=0.0;c[P>>2]=0;c[q>>2]=Pv(c[p>>2]|0)|0;c[u>>2]=c[c[o>>2]>>2];c[G>>2]=cK((_(c[k>>2]|0,c[u>>2]|0)|0)<<3)|0;a:do if((c[G>>2]|0)!=0?(e=c[G>>2]|0,Z4(e|0,c[l>>2]|0,_(c[k>>2]<<3,c[u>>2]|0)|0)|0,c[G>>2]=e,c[F>>2]=cK((_(c[k>>2]|0,c[u>>2]|0)|0)<<3)|0,(c[F>>2]|0)!=0):0){c[v>>2]=c[(c[p>>2]|0)+20>>2];c[w>>2]=c[(c[p>>2]|0)+24>>2];c[E>>2]=c[(c[p>>2]|0)+28>>2];c[D>>2]=c[(c[q>>2]|0)+28>>2];c[C>>2]=c[(c[o>>2]|0)+28>>2];c[x>>2]=c[(c[o>>2]|0)+20>>2];c[y>>2]=c[(c[o>>2]|0)+24>>2];e=c[j>>2]|0;if((c[(c[j>>2]|0)+24>>2]|0)==1){tx(c[e+20>>2]|0,c[u>>2]|0,c[k>>2]|0,c[l>>2]|0,P,H);if(c[P>>2]|0)c[o>>2]=Qv(c[o>>2]|0,c[P>>2]|0)|0}else if((c[e+24>>2]|0)==2){h[M>>3]=+h[c[(c[j>>2]|0)+20>>2]>>3];h[N>>3]=+h[(c[(c[j>>2]|0)+20>>2]|0)+8>>3]}b:while(1){e=c[B>>2]|0;c[B>>2]=e+1;if((e|0)>=(c[m>>2]|0))break a;if(!(+h[J>>3]>+h[n>>3]))break a;e=(c[(c[j>>2]|0)+24>>2]|0)!=4;c[r>>2]=0;c:do if(e){while(1){if((c[r>>2]|0)>=(c[u>>2]|0))break;c[z>>2]=-1;h[I>>3]=0.0;c[s>>2]=c[(c[v>>2]|0)+(c[r>>2]<<2)>>2];while(1){if((c[s>>2]|0)>=(c[(c[v>>2]|0)+((c[r>>2]|0)+1<<2)>>2]|0))break;if((c[r>>2]|0)==(c[(c[w>>2]|0)+(c[s>>2]<<2)>>2]|0))c[z>>2]=c[s>>2];else{h[R>>3]=+zw(c[l>>2]|0,c[k>>2]|0,c[r>>2]|0,c[(c[w>>2]|0)+(c[s>>2]<<2)>>2]|0);if(+h[(c[E>>2]|0)+(c[s>>2]<<3)>>3]==0.0)h[(c[D>>2]|0)+(c[s>>2]<<3)>>3]=0.0;else{if(+h[R>>3]==0.0){h[Q>>3]=+h[(c[E>>2]|0)+(c[s>>2]<<3)>>3]/+h[(c[C>>2]|0)+(c[s>>2]<<3)>>3];c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[k>>2]|0))break;f=(+rw()+.0001)*.0001;d=_(c[(c[w>>2]|0)+(c[s>>2]<<2)>>2]|0,c[k>>2]|0)|0;b=(c[l>>2]|0)+(d+(c[t>>2]|0)<<3)|0;h[b>>3]=+h[b>>3]+f*+h[Q>>3];c[t>>2]=(c[t>>2]|0)+1}h[R>>3]=+zw(c[l>>2]|0,c[k>>2]|0,c[r>>2]|0,c[(c[w>>2]|0)+(c[s>>2]<<2)>>2]|0)}h[(c[D>>2]|0)+(c[s>>2]<<3)>>3]=+h[(c[E>>2]|0)+(c[s>>2]<<3)>>3]/+h[R>>3]}h[I>>3]=+h[I>>3]+ +h[(c[D>>2]|0)+(c[s>>2]<<3)>>3]}c[s>>2]=(c[s>>2]|0)+1}if((c[z>>2]|0)<0)break b;h[(c[D>>2]|0)+(c[z>>2]<<3)>>3]=-+h[I>>3];c[r>>2]=(c[r>>2]|0)+1}Wv(c[q>>2]|0,0,c[l>>2]|0,0,F,0,c[k>>2]|0)}else while(1){if((c[r>>2]|0)>=(c[u>>2]|0))break c;c[s>>2]=0;while(1){S=c[r>>2]|0;if((c[s>>2]|0)>=(c[k>>2]|0))break;b=_(S,c[k>>2]|0)|0;h[(c[F>>2]|0)+(b+(c[s>>2]|0)<<3)>>3]=0.0;c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=S+1}while(0);d:do if(c[K>>2]|0){c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[u>>2]|0))break d;c[s>>2]=0;while(1){T=c[r>>2]|0;if((c[s>>2]|0)>=(c[k>>2]|0))break;e=_(c[r>>2]|0,c[k>>2]|0)|0;b=_(c[r>>2]|0,c[k>>2]|0)|0;d=(c[F>>2]|0)+(b+(c[s>>2]|0)<<3)|0;h[d>>3]=+h[d>>3]+ +h[(c[K>>2]|0)+(T<<3)>>3]*+h[(c[G>>2]|0)+(e+(c[s>>2]|0)<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=T+1}}while(0);e:do switch(c[(c[j>>2]|0)+24>>2]|0){case 1:{c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[u>>2]|0))break e;c[s>>2]=0;while(1){U=c[r>>2]|0;if((c[s>>2]|0)>=(c[k>>2]|0))break;e=_(U,c[k>>2]|0)|0;d=_(c[r>>2]|0,c[k>>2]|0)|0;b=(c[F>>2]|0)+(d+(c[s>>2]|0)<<3)|0;h[b>>3]=+h[b>>3]+ +h[(c[H>>2]|0)+(e+(c[s>>2]|0)<<3)>>3];c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=U+1}break}case 2:{ux(c[u>>2]|0,c[k>>2]|0,c[l>>2]|0,c[F>>2]|0,+h[M>>3],+h[N>>3]);break}default:{}}while(0);e=c[o>>2]|0;if((c[(c[j>>2]|0)+24>>2]|0)==2)h[L>>3]=+vx(e,+h[M>>3],c[k>>2]|0,c[l>>2]|0,c[F>>2]|0,+h[(c[j>>2]|0)+40>>3],c[(c[j>>2]|0)+48>>2]|0,A);else h[L>>3]=+Ix(e,c[k>>2]|0,c[l>>2]|0,c[F>>2]|0,+h[(c[j>>2]|0)+40>>3],c[(c[j>>2]|0)+48>>2]|0,0,A);if(c[A>>2]|0)break a;f=+wx(c[u>>2]|0,c[k>>2]|0,c[l>>2]|0,c[F>>2]|0);e=_(c[u>>2]|0,c[k>>2]|0)|0;h[J>>3]=f/+O(+(+vw(e,c[l>>2]|0,c[l>>2]|0)));Z4(c[l>>2]|0,c[F>>2]|0,_(c[u>>2]<<3,c[k>>2]|0)|0)|0}La(133540,133322,897,133551)}while(0);Lv(c[q>>2]|0);if(c[P>>2]|0){Lv(c[P>>2]|0);Lv(c[o>>2]|0)}if(c[G>>2]|0)O4(c[G>>2]|0);if(c[F>>2]|0)O4(c[F>>2]|0);if(!(c[H>>2]|0)){V=+h[J>>3];i=g;return +V}O4(c[H>>2]|0);V=+h[J>>3];i=g;return +V}function mx(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0.0,Q=0;g=i;i=i+144|0;j=g+136|0;k=g+132|0;l=g+128|0;m=g+48|0;n=g+124|0;o=g+120|0;p=g+116|0;q=g+112|0;r=g+108|0;s=g+104|0;t=g+100|0;u=g+96|0;v=g+92|0;w=g+88|0;x=g+84|0;y=g+80|0;z=g+76|0;A=g+72|0;B=g+68|0;C=g+64|0;D=g+60|0;E=g+56|0;F=g+40|0;G=g+32|0;H=g+24|0;I=g+16|0;J=g+8|0;K=g;c[k>>2]=a;c[l>>2]=b;h[m>>3]=d;c[n>>2]=e;c[o>>2]=f;c[t>>2]=c[c[k>>2]>>2];c[u>>2]=c[(c[k>>2]|0)+20>>2];c[v>>2]=c[(c[k>>2]|0)+24>>2];h[I>>3]=0.0;h[J>>3]=0.0;h[K>>3]=0.0;if(!(Ov(c[k>>2]|0,0)|0))La(133286,133322,1036,133585);c[B>>2]=cK(c[t>>2]<<3)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[t>>2]|0))break;h[(c[B>>2]|0)+(c[q>>2]<<3)>>3]=0.0;c[z>>2]=0;c[r>>2]=c[(c[u>>2]|0)+(c[q>>2]<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[u>>2]|0)+((c[q>>2]|0)+1<<2)>>2]|0))break;if((c[q>>2]|0)!=(c[(c[v>>2]|0)+(c[r>>2]<<2)>>2]|0)){d=+zw(c[n>>2]|0,c[l>>2]|0,c[q>>2]|0,c[(c[v>>2]|0)+(c[r>>2]<<2)>>2]|0);f=(c[B>>2]|0)+(c[q>>2]<<3)|0;h[f>>3]=+h[f>>3]+d;c[z>>2]=(c[z>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}if((c[z>>2]|0)<=0){L=11;break}f=(c[B>>2]|0)+(c[q>>2]<<3)|0;h[f>>3]=+h[f>>3]/+(c[z>>2]|0);c[q>>2]=(c[q>>2]|0)+1}if((L|0)==11)La(133399,133322,1048,133585);c[p>>2]=cK(56)|0;h[(c[p>>2]|0)+32>>3]=1.0;c[(c[p>>2]|0)+20>>2]=0;c[(c[p>>2]|0)+24>>2]=0;h[(c[p>>2]|0)+40>>3]=.01;z=~~+O(+(+(c[c[k>>2]>>2]|0)));c[(c[p>>2]|0)+48>>2]=z;z=cK(c[t>>2]<<3)|0;c[(c[p>>2]|0)+12>>2]=z;c[C>>2]=z;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[t>>2]|0))break;h[(c[(c[p>>2]|0)+12>>2]|0)+(c[q>>2]<<3)>>3]=+h[m>>3];c[q>>2]=(c[q>>2]|0)+1}do if((c[t>>2]|0)>2){m=c[t>>2]|0;z=c[l>>2]|0;v=c[n>>2]|0;if(c[o>>2]|0){c[A>>2]=Kx(m,z,v)|0;break}else{c[A>>2]=Lx(m,z,v)|0;break}}else c[A>>2]=Pv(c[k>>2]|0)|0;while(0);o=Qv(c[k>>2]|0,c[A>>2]|0)|0;c[(c[p>>2]|0)+4>>2]=o;Lv(c[A>>2]|0);A=Pv(c[(c[p>>2]|0)+4>>2]|0)|0;c[(c[p>>2]|0)+8>>2]=A;if((c[(c[p>>2]|0)+4>>2]|0)!=0?(c[(c[p>>2]|0)+8>>2]|0)!=0:0){c[w>>2]=c[(c[(c[p>>2]|0)+4>>2]|0)+20>>2];c[x>>2]=c[(c[(c[p>>2]|0)+4>>2]|0)+24>>2];c[E>>2]=c[(c[(c[p>>2]|0)+4>>2]|0)+28>>2];c[D>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+28>>2];c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[t>>2]|0))break;h[G>>3]=0.0;h[F>>3]=0.0;c[y>>2]=-1;c[r>>2]=c[(c[w>>2]|0)+(c[q>>2]<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[w>>2]|0)+((c[q>>2]|0)+1<<2)>>2]|0))break;c[s>>2]=c[(c[x>>2]|0)+(c[r>>2]<<2)>>2];if((c[s>>2]|0)==(c[q>>2]|0))c[y>>2]=c[r>>2];else{h[H>>3]=+P(+(+yw(c[n>>2]|0,c[l>>2]|0,c[q>>2]|0,c[s>>2]|0)),.6);h[(c[E>>2]|0)+(c[r>>2]<<3)>>3]=1.0/(+h[H>>3]*+h[H>>3]);h[G>>3]=+h[G>>3]+ +h[(c[E>>2]|0)+(c[r>>2]<<3)>>3];h[(c[D>>2]|0)+(c[r>>2]<<3)>>3]=+h[(c[E>>2]|0)+(c[r>>2]<<3)>>3]*+h[H>>3];d=+h[(c[D>>2]|0)+(c[r>>2]<<3)>>3];M=d*+zw(c[n>>2]|0,c[l>>2]|0,c[q>>2]|0,c[s>>2]|0);h[J>>3]=+h[J>>3]+M;h[K>>3]=+h[K>>3]+ +h[(c[D>>2]|0)+(c[r>>2]<<3)>>3]*+h[H>>3];h[F>>3]=+h[F>>3]+ +h[(c[D>>2]|0)+(c[r>>2]<<3)>>3]}c[r>>2]=(c[r>>2]|0)+1}A=(c[C>>2]|0)+(c[q>>2]<<3)|0;h[A>>3]=+h[A>>3]*-+h[G>>3];if((c[y>>2]|0)<0){L=33;break}h[(c[E>>2]|0)+(c[y>>2]<<3)>>3]=-+h[G>>3]+ +h[(c[C>>2]|0)+(c[q>>2]<<3)>>3];h[(c[D>>2]|0)+(c[y>>2]<<3)>>3]=-+h[F>>3];c[q>>2]=(c[q>>2]|0)+1}if((L|0)==33)La(133606,133322,1114,133585);h[I>>3]=+h[J>>3]/+h[K>>3];c[q>>2]=0;while(1){N=+h[I>>3];if((c[q>>2]|0)>=(c[(c[w>>2]|0)+(c[t>>2]<<2)>>2]|0))break;K=(c[D>>2]|0)+(c[q>>2]<<3)|0;h[K>>3]=+h[K>>3]*N;c[q>>2]=(c[q>>2]|0)+1}h[(c[p>>2]|0)+32>>3]=N;O4(c[B>>2]|0);c[j>>2]=c[p>>2];Q=c[j>>2]|0;i=g;return Q|0}nx(c[p>>2]|0);c[j>>2]=0;Q=c[j>>2]|0;i=g;return Q|0}function nx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;hx(c[d>>2]|0);i=b;return}function ox(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;+lx(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,50,.001);i=e;return}function px(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0;f=i;i=i+96|0;g=f+80|0;j=f+76|0;k=f+72|0;l=f+68|0;m=f+64|0;n=f+60|0;o=f+56|0;p=f+52|0;q=f+48|0;r=f+44|0;s=f+40|0;t=f+36|0;u=f+32|0;v=f+28|0;w=f+24|0;x=f+20|0;y=f+16|0;z=f+12|0;A=f+8|0;B=f+4|0;C=f;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[s>>2]=c[c[j>>2]>>2];c[t>>2]=c[(c[j>>2]|0)+20>>2];c[u>>2]=c[(c[j>>2]|0)+24>>2];c[C>>2]=0;if(!(Ov(c[j>>2]|0,0)|0))La(133286,133322,1151,133617);c[C>>2]=fx(c[j>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;c[A>>2]=c[(c[C>>2]|0)+28>>2];c[n>>2]=cK(8)|0;c[x>>2]=cK(c[s>>2]<<2)|0;c[B>>2]=cK(c[s>>2]<<3)|0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[s>>2]|0))break;h[(c[B>>2]|0)+(c[o>>2]<<3)>>3]=0.0;c[y>>2]=0;c[p>>2]=c[(c[t>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[t>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;if((c[o>>2]|0)!=(c[(c[u>>2]|0)+(c[p>>2]<<2)>>2]|0)){D=+zw(c[m>>2]|0,c[k>>2]|0,c[o>>2]|0,c[(c[u>>2]|0)+(c[p>>2]<<2)>>2]|0);j=(c[B>>2]|0)+(c[o>>2]<<3)|0;h[j>>3]=+h[j>>3]+D;c[y>>2]=(c[y>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}if((c[y>>2]|0)<=0){E=11;break}j=(c[B>>2]|0)+(c[o>>2]<<3)|0;h[j>>3]=+h[j>>3]/+(c[y>>2]|0);c[o>>2]=(c[o>>2]|0)+1}if((E|0)==11)La(133399,133322,1169,133617);c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[s>>2]|0))break;c[(c[x>>2]|0)+(c[o>>2]<<2)>>2]=-1;c[o>>2]=(c[o>>2]|0)+1}c[y>>2]=0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[s>>2]|0))break;c[(c[x>>2]|0)+(c[o>>2]<<2)>>2]=c[o>>2];c[p>>2]=c[(c[t>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[t>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;c[q>>2]=c[(c[u>>2]|0)+(c[p>>2]<<2)>>2];if((c[(c[x>>2]|0)+(c[q>>2]<<2)>>2]|0)!=(c[o>>2]|0)){c[(c[x>>2]|0)+(c[q>>2]<<2)>>2]=c[o>>2];c[y>>2]=(c[y>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}c[p>>2]=c[(c[t>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[t>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;c[q>>2]=c[(c[u>>2]|0)+(c[p>>2]<<2)>>2];c[r>>2]=c[(c[t>>2]|0)+(c[q>>2]<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[t>>2]|0)+((c[q>>2]|0)+1<<2)>>2]|0))break;if((c[(c[x>>2]|0)+(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]<<2)>>2]|0)!=(c[o>>2]|0)){c[(c[x>>2]|0)+(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]<<2)>>2]=c[o>>2];c[y>>2]=(c[y>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}E=Nv(c[s>>2]|0,c[s>>2]|0,c[y>>2]|0,1,1)|0;c[c[n>>2]>>2]=E;E=c[n>>2]|0;if(!(c[c[n>>2]>>2]|0)){qx(E);c[g>>2]=0;F=c[g>>2]|0;i=f;return F|0}c[v>>2]=c[(c[E>>2]|0)+20>>2];c[w>>2]=c[(c[c[n>>2]>>2]|0)+24>>2];c[z>>2]=c[(c[c[n>>2]>>2]|0)+28>>2];c[c[v>>2]>>2]=0;c[y>>2]=0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[s>>2]|0))break;c[(c[x>>2]|0)+(c[o>>2]<<2)>>2]=(c[o>>2]|0)+(c[s>>2]|0);c[p>>2]=c[(c[t>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[t>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;c[q>>2]=c[(c[u>>2]|0)+(c[p>>2]<<2)>>2];if((c[(c[x>>2]|0)+(c[q>>2]<<2)>>2]|0)!=((c[o>>2]|0)+(c[s>>2]|0)|0)){c[(c[x>>2]|0)+(c[q>>2]<<2)>>2]=(c[o>>2]|0)+(c[s>>2]|0);c[(c[w>>2]|0)+(c[y>>2]<<2)>>2]=c[q>>2];h[(c[z>>2]|0)+(c[y>>2]<<3)>>3]=(+h[(c[B>>2]|0)+(c[o>>2]<<3)>>3]+ +h[(c[B>>2]|0)+(c[q>>2]<<3)>>3])*.5;h[(c[z>>2]|0)+(c[y>>2]<<3)>>3]=+h[(c[A>>2]|0)+(c[p>>2]<<3)>>3];c[y>>2]=(c[y>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}c[p>>2]=c[(c[t>>2]|0)+(c[o>>2]<<2)>>2];while(1){if((c[p>>2]|0)>=(c[(c[t>>2]|0)+((c[o>>2]|0)+1<<2)>>2]|0))break;c[q>>2]=c[(c[u>>2]|0)+(c[p>>2]<<2)>>2];c[r>>2]=c[(c[t>>2]|0)+(c[q>>2]<<2)>>2];while(1){if((c[r>>2]|0)>=(c[(c[t>>2]|0)+((c[q>>2]|0)+1<<2)>>2]|0))break;if((c[(c[x>>2]|0)+(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]<<2)>>2]|0)!=((c[o>>2]|0)+(c[s>>2]|0)|0)){c[(c[x>>2]|0)+(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]<<2)>>2]=(c[o>>2]|0)+(c[s>>2]|0);c[(c[w>>2]|0)+(c[y>>2]<<2)>>2]=c[(c[u>>2]|0)+(c[r>>2]<<2)>>2];h[(c[z>>2]|0)+(c[y>>2]<<3)>>3]=(+h[(c[B>>2]|0)+(c[o>>2]<<3)>>3]+ +h[(c[B>>2]|0)+(c[q>>2]<<3)>>3]*2.0+ +h[(c[B>>2]|0)+(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]<<3)>>3])*.5;h[(c[z>>2]|0)+(c[y>>2]<<3)>>3]=+h[(c[A>>2]|0)+(c[p>>2]<<3)>>3]+ +h[(c[A>>2]|0)+(c[r>>2]<<3)>>3];c[y>>2]=(c[y>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}c[(c[v>>2]|0)+((c[o>>2]|0)+1<<2)>>2]=c[y>>2];c[o>>2]=(c[o>>2]|0)+1}c[(c[c[n>>2]>>2]|0)+8>>2]=c[y>>2];y=pp()|0;c[(c[n>>2]|0)+4>>2]=y;Z4(c[(c[n>>2]|0)+4>>2]|0,c[l>>2]|0,168)|0;c[(c[(c[n>>2]|0)+4>>2]|0)+16>>2]=0;c[(c[(c[n>>2]|0)+4>>2]|0)+40>>2]=1;l=(c[(c[n>>2]|0)+4>>2]|0)+96|0;h[l>>3]=+h[l>>3]/2.0;c[(c[(c[n>>2]|0)+4>>2]|0)+80>>2]=20;O4(c[x>>2]|0);O4(c[B>>2]|0);Lv(c[C>>2]|0);c[g>>2]=c[n>>2];F=c[g>>2]|0;i=f;return F|0}function qx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}if(c[c[d>>2]>>2]|0)Lv(c[c[d>>2]>>2]|0);if(!(c[(c[d>>2]|0)+4>>2]|0)){i=b;return}qp(c[(c[d>>2]|0)+4>>2]|0);i=b;return}function rx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;Ep(c[l>>2]|0,c[j>>2]|0,c[c[h>>2]>>2]|0,c[(c[h>>2]|0)+4>>2]|0,c[k>>2]|0,c[m>>2]|0,n);if(c[n>>2]|0)La(133636,133322,1264,133642);else{i=g;return}}function sx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h+44|0;k=h+40|0;l=h+36|0;m=h+32|0;n=h+28|0;o=h+24|0;p=h+20|0;q=h+16|0;r=h+12|0;s=h+8|0;t=h+4|0;u=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[c[o>>2]>>2]=0;switch(c[(c[l>>2]|0)+120>>2]|0){case 5:case 6:{o=c[k>>2]|0;g=c[j>>2]|0;f=c[n>>2]|0;if((c[(c[l>>2]|0)+120>>2]|0)==6)c[p>>2]=mx(o,g,0.0,f,0)|0;else c[p>>2]=mx(o,g,0.0,f,1)|0;ox(c[p>>2]|0,c[j>>2]|0,c[n>>2]|0);nx(c[p>>2]|0);i=h;return}case 2:case 3:case 1:{c[s>>2]=1;do if((c[(c[l>>2]|0)+120>>2]|0)!=1){if((c[(c[l>>2]|0)+120>>2]|0)==2){c[s>>2]=1;break}if((c[(c[l>>2]|0)+120>>2]|0)==3)c[s>>2]=2}else c[s>>2]=0;while(0);c[r>>2]=0;while(1){if((c[r>>2]|0)>=1)break;c[q>>2]=gx(c[k>>2]|0,c[j>>2]|0,.05,c[n>>2]|0,c[s>>2]|0)|0;+lx(c[q>>2]|0,c[j>>2]|0,c[n>>2]|0,50,.001);hx(c[q>>2]|0);c[r>>2]=(c[r>>2]|0)+1}i=h;return}case 4:{c[u>>2]=0;while(1){if((c[u>>2]|0)>=1)break;c[t>>2]=px(c[k>>2]|0,c[j>>2]|0,c[l>>2]|0,c[n>>2]|0)|0;rx(c[t>>2]|0,c[k>>2]|0,c[m>>2]|0,c[j>>2]|0,c[n>>2]|0);qx(c[t>>2]|0);c[u>>2]=(c[u>>2]|0)+1}i=h;return}default:{i=h;return}}}function tx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0,R=0;j=i;i=i+128|0;k=j+124|0;l=j+120|0;m=j+116|0;n=j+112|0;o=j+108|0;p=j+104|0;q=j+100|0;r=j+96|0;s=j+92|0;t=j+88|0;u=j+84|0;v=j+80|0;w=j+76|0;x=j+72|0;y=j+68|0;z=j+64|0;A=j+60|0;B=j+56|0;C=j+52|0;D=j+48|0;E=j+44|0;F=j+40|0;G=j+24|0;H=j+16|0;I=j+8|0;J=j+36|0;K=j+32|0;L=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=c[(c[k>>2]|0)+8>>2];c[r>>2]=c[(c[k>>2]|0)+12>>2];c[s>>2]=c[(c[k>>2]|0)+16>>2];c[t>>2]=c[(c[k>>2]|0)+32>>2];c[u>>2]=c[(c[t>>2]|0)+20>>2];c[v>>2]=c[(c[t>>2]|0)+24>>2];c[D>>2]=c[(c[k>>2]|0)+20>>2];c[E>>2]=c[(c[k>>2]|0)+24>>2];c[F>>2]=c[(c[k>>2]|0)+28>>2];c[J>>2]=0;c[K>>2]=0;h[L>>3]=+h[c[k>>2]>>3];if((c[q>>2]|0)==1|(c[q>>2]|0)==3){if(!(c[D>>2]|0)){if((c[E>>2]|0)!=0|(c[F>>2]|0)!=0)La(133664,133322,694,133681);c[y>>2]=0;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[r>>2]|0))break;c[w>>2]=c[(c[s>>2]|0)+(c[B>>2]<<2)>>2];h[I>>3]=+((c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0)-(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)|0);c[y>>2]=(c[y>>2]|0)+~~((+h[I>>3]+1.0)*(+h[I>>3]+1.0));c[B>>2]=(c[B>>2]|0)+1}t=cK(c[y>>2]<<2)|0;c[(c[k>>2]|0)+20>>2]=t;c[D>>2]=t;t=cK(c[y>>2]<<2)|0;c[(c[k>>2]|0)+24>>2]=t;c[E>>2]=t;t=cK(c[y>>2]<<3)|0;c[(c[k>>2]|0)+28>>2]=t;c[F>>2]=t}c[y>>2]=0;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[r>>2]|0))break;c[w>>2]=c[(c[s>>2]|0)+(c[B>>2]<<2)>>2];c[x>>2]=c[(c[v>>2]|0)+(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]<<2)>>2];c[A>>2]=c[(c[v>>2]|0)+((c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)+1<<2)>>2];a:do if((c[x>>2]|0)!=(c[A>>2]|0)){h[G>>3]=+yw(c[n>>2]|0,c[m>>2]|0,c[x>>2]|0,c[A>>2]|0);h[G>>3]=+h[G>>3]*+h[G>>3];h[I>>3]=+((c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0)-(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)|0);h[H>>3]=+h[I>>3]*+h[I>>3];c[(c[D>>2]|0)+(c[y>>2]<<2)>>2]=c[w>>2];c[(c[E>>2]|0)+(c[y>>2]<<2)>>2]=c[w>>2];M=+h[L>>3]/+h[G>>3];t=c[y>>2]|0;c[y>>2]=t+1;h[(c[F>>2]|0)+(t<<3)>>3]=M;h[I>>3]=+h[L>>3]/(+h[I>>3]*+h[G>>3]);h[H>>3]=+h[L>>3]/(+h[H>>3]*+h[G>>3]);c[C>>2]=c[(c[u>>2]|0)+(c[w>>2]<<2)>>2];while(1){N=c[w>>2]|0;if((c[C>>2]|0)>=(c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[(c[D>>2]|0)+(c[y>>2]<<2)>>2]=N;c[(c[E>>2]|0)+(c[y>>2]<<2)>>2]=c[(c[v>>2]|0)+(c[C>>2]<<2)>>2];M=-+h[I>>3];t=c[y>>2]|0;c[y>>2]=t+1;h[(c[F>>2]|0)+(t<<3)>>3]=M;c[C>>2]=(c[C>>2]|0)+1}c[C>>2]=c[(c[u>>2]|0)+(N<<2)>>2];while(1){if((c[C>>2]|0)>=(c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break a;c[x>>2]=c[(c[v>>2]|0)+(c[C>>2]<<2)>>2];c[(c[D>>2]|0)+(c[y>>2]<<2)>>2]=c[x>>2];c[(c[E>>2]|0)+(c[y>>2]<<2)>>2]=c[w>>2];M=-+h[I>>3];t=c[y>>2]|0;c[y>>2]=t+1;h[(c[F>>2]|0)+(t<<3)>>3]=M;c[z>>2]=c[(c[u>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[z>>2]|0)>=(c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[A>>2]=c[(c[v>>2]|0)+(c[z>>2]<<2)>>2];c[(c[D>>2]|0)+(c[y>>2]<<2)>>2]=c[x>>2];c[(c[E>>2]|0)+(c[y>>2]<<2)>>2]=c[A>>2];M=+h[H>>3];t=c[y>>2]|0;c[y>>2]=t+1;h[(c[F>>2]|0)+(t<<3)>>3]=M;c[z>>2]=(c[z>>2]|0)+1}c[C>>2]=(c[C>>2]|0)+1}}while(0);c[B>>2]=(c[B>>2]|0)+1}c[K>>2]=Vv(c[y>>2]|0,c[l>>2]|0,c[l>>2]|0,c[D>>2]|0,c[E>>2]|0,c[F>>2]|0,1,8)|0;O=c[K>>2]|0;P=c[o>>2]|0;c[P>>2]=O;Q=c[J>>2]|0;R=c[p>>2]|0;c[R>>2]=Q;i=j;return}if(!((c[q>>2]|0)==2|(c[q>>2]|0)==4)){O=c[K>>2]|0;P=c[o>>2]|0;c[P>>2]=O;Q=c[J>>2]|0;R=c[p>>2]|0;c[R>>2]=Q;i=j;return}do if(!(c[D>>2]|0))if((c[E>>2]|0)!=0|(c[F>>2]|0)!=0)La(133664,133322,736,133681);else{c[y>>2]=c[r>>2];q=cK(c[y>>2]<<2)|0;c[(c[k>>2]|0)+20>>2]=q;c[D>>2]=q;q=cK(c[y>>2]<<2)|0;c[(c[k>>2]|0)+24>>2]=q;c[E>>2]=q;q=cK(c[y>>2]<<3)|0;c[(c[k>>2]|0)+28>>2]=q;c[F>>2]=q;break}while(0);c[J>>2]=cK(_(c[l>>2]<<3,c[m>>2]|0)|0)|0;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(_(c[l>>2]|0,c[m>>2]|0)|0))break;h[(c[J>>2]|0)+(c[B>>2]<<3)>>3]=0.0;c[B>>2]=(c[B>>2]|0)+1}c[y>>2]=0;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[r>>2]|0))break;c[w>>2]=c[(c[s>>2]|0)+(c[B>>2]<<2)>>2];c[x>>2]=c[(c[v>>2]|0)+(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]<<2)>>2];c[A>>2]=c[(c[v>>2]|0)+((c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)+1<<2)>>2];h[G>>3]=+yw(c[n>>2]|0,c[m>>2]|0,c[x>>2]|0,c[A>>2]|0);c[(c[D>>2]|0)+(c[y>>2]<<2)>>2]=c[w>>2];c[(c[E>>2]|0)+(c[y>>2]<<2)>>2]=c[w>>2];M=+h[L>>3]/+h[G>>3];k=c[y>>2]|0;c[y>>2]=k+1;h[(c[F>>2]|0)+(k<<3)>>3]=M;c[C>>2]=c[(c[u>>2]|0)+(c[w>>2]<<2)>>2];while(1){if((c[C>>2]|0)>=(c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0))break;c[x>>2]=c[(c[v>>2]|0)+(c[C>>2]<<2)>>2];c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[m>>2]|0))break;k=_(c[x>>2]|0,c[m>>2]|0)|0;q=_(c[w>>2]|0,c[m>>2]|0)|0;H=(c[J>>2]|0)+(q+(c[z>>2]|0)<<3)|0;h[H>>3]=+h[H>>3]+ +h[(c[n>>2]|0)+(k+(c[z>>2]|0)<<3)>>3];c[z>>2]=(c[z>>2]|0)+1}c[C>>2]=(c[C>>2]|0)+1}c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[m>>2]|0))break;k=_(c[w>>2]|0,c[m>>2]|0)|0;H=(c[J>>2]|0)+(k+(c[z>>2]|0)<<3)|0;h[H>>3]=+h[H>>3]*(+h[L>>3]/+h[G>>3]/+((c[(c[u>>2]|0)+((c[w>>2]|0)+1<<2)>>2]|0)-(c[(c[u>>2]|0)+(c[w>>2]<<2)>>2]|0)|0));c[z>>2]=(c[z>>2]|0)+1}c[B>>2]=(c[B>>2]|0)+1}c[K>>2]=Vv(c[y>>2]|0,c[l>>2]|0,c[l>>2]|0,c[D>>2]|0,c[E>>2]|0,c[F>>2]|0,1,8)|0;O=c[K>>2]|0;P=c[o>>2]|0;c[P>>2]=O;Q=c[J>>2]|0;R=c[p>>2]|0;c[R>>2]=Q;i=j;return}function ux(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+64|0;k=j+56|0;l=j+52|0;m=j+48|0;n=j+44|0;o=j+24|0;p=j+16|0;q=j+40|0;r=j+36|0;s=j+32|0;t=j+8|0;u=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;h[o>>3]=f;h[p>>3]=g;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[r>>2]=(c[q>>2]|0)+1;while(1){if((c[r>>2]|0)>=(c[k>>2]|0))break;h[t>>3]=+yw(c[m>>2]|0,c[l>>2]|0,c[q>>2]|0,c[r>>2]|0);c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[l>>2]|0))break;e=_(c[q>>2]|0,c[l>>2]|0)|0;d=_(c[r>>2]|0,c[l>>2]|0)|0;h[u>>3]=(+h[(c[m>>2]|0)+(e+(c[s>>2]|0)<<3)>>3]-+h[(c[m>>2]|0)+(d+(c[s>>2]|0)<<3)>>3])/+h[t>>3];d=_(c[q>>2]|0,c[l>>2]|0)|0;e=(c[n>>2]|0)+(d+(c[s>>2]|0)<<3)|0;h[e>>3]=+h[e>>3]+ +h[o>>3]*+h[p>>3]*+h[u>>3];e=_(c[r>>2]|0,c[l>>2]|0)|0;d=(c[n>>2]|0)+(e+(c[s>>2]|0)<<3)|0;h[d>>3]=+h[d>>3]+ +h[o>>3]*+h[p>>3]*-+h[u>>3];c[s>>2]=(c[s>>2]|0)+1}c[r>>2]=(c[r>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+1}i=j;return}function vx(a,b,d,e,f,g,j,k){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;l=i;i=i+48|0;m=l+44|0;n=l+8|0;o=l+40|0;p=l+36|0;q=l+32|0;r=l;s=l+28|0;t=l+24|0;u=l+20|0;v=l+16|0;c[m>>2]=a;h[n>>3]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;h[r>>3]=g;c[s>>2]=j;c[t>>2]=k;c[u>>2]=yx(c[m>>2]|0,+h[n>>3])|0;c[v>>2]=Dx(c[m>>2]|0,+h[n>>3])|0;g=+Gx(c[u>>2]|0,c[v>>2]|0,c[c[m>>2]>>2]|0,c[o>>2]|0,c[p>>2]|0,c[q>>2]|0,+h[r>>3],c[s>>2]|0,c[t>>2]|0);i=l;return +g}function wx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;f=i;i=i+48|0;g=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+8|0;n=f;o=f+20|0;p=f+16|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;h[m>>3]=0.0;h[n>>3]=0.0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[g>>2]|0))break;h[n>>3]=0.0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[j>>2]|0))break;e=_(c[o>>2]|0,c[j>>2]|0)|0;d=_(c[o>>2]|0,c[j>>2]|0)|0;b=_(c[o>>2]|0,c[j>>2]|0)|0;a=_(c[o>>2]|0,c[j>>2]|0)|0;h[n>>3]=+h[n>>3]+(+h[(c[l>>2]|0)+(e+(c[p>>2]|0)<<3)>>3]-+h[(c[k>>2]|0)+(d+(c[p>>2]|0)<<3)>>3])*(+h[(c[l>>2]|0)+(b+(c[p>>2]|0)<<3)>>3]-+h[(c[k>>2]|0)+(a+(c[p>>2]|0)<<3)>>3]);c[p>>2]=(c[p>>2]|0)+1}q=+O(+(+h[n>>3]));h[m>>3]=+h[m>>3]+q;c[o>>2]=(c[o>>2]|0)+1}i=f;return +(+h[m>>3])}function xx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;j=e+32|0;k=e+28|0;l=e+24|0;m=e+8|0;n=e;o=e+20|0;p=e+16|0;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=c[c[f>>2]>>2];c[l>>2]=c[(c[k>>2]|0)+8>>2];h[m>>3]=+h[c[k>>2]>>3];h[n>>3]=0.0;c[o>>2]=c[c[l>>2]>>2];Xv(c[l>>2]|0,c[g>>2]|0,j,0);c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[o>>2]|0))break;h[n>>3]=+h[n>>3]+ +h[(c[g>>2]|0)+(c[p>>2]<<3)>>3];c[p>>2]=(c[p>>2]|0)+1}c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[o>>2]|0))break;l=(c[j>>2]|0)+(c[p>>2]<<3)|0;h[l>>3]=+h[l>>3]+ +h[m>>3]*(+(c[o>>2]|0)*+h[(c[g>>2]|0)+(c[p>>2]<<3)>>3]-+h[n>>3]);c[p>>2]=(c[p>>2]|0)+1}i=e;return c[j>>2]|0}function yx(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d;g=d+12|0;j=d+8|0;c[e>>2]=a;h[f>>3]=b;c[g>>2]=cK(8)|0;a=cK(16)|0;c[j>>2]=a;c[c[g>>2]>>2]=a;h[c[j>>2]>>3]=+h[f>>3];c[(c[j>>2]|0)+8>>2]=c[e>>2];c[(c[g>>2]|0)+4>>2]=30;i=d;return c[g>>2]|0}function zx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[c[f>>2]>>2];Xv(c[j>>2]|0,c[g>>2]|0,h,0);i=e;return c[h>>2]|0}function Ax(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=cK(8)|0;c[c[e>>2]>>2]=c[d>>2];c[(c[e>>2]|0)+4>>2]=31;i=b;return c[e>>2]|0}function Bx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}O4(c[d>>2]|0);i=b;return}function Cx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[m>>2]=c[c[f>>2]>>2];c[l>>2]=~~+h[c[m>>2]>>3];c[m>>2]=(c[m>>2]|0)+8;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[l>>2]|0))break;h[(c[j>>2]|0)+(c[k>>2]<<3)>>3]=+h[(c[g>>2]|0)+(c[k>>2]<<3)>>3]*+h[(c[m>>2]|0)+(c[k>>2]<<3)>>3];c[k>>2]=(c[k>>2]|0)+1}i=e;return c[j>>2]|0}function Dx(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d+40|0;f=d;g=d+36|0;j=d+32|0;k=d+28|0;l=d+24|0;m=d+20|0;n=d+16|0;o=d+12|0;p=d+8|0;c[e>>2]=a;h[f>>3]=b;c[m>>2]=c[c[e>>2]>>2];c[n>>2]=c[(c[e>>2]|0)+20>>2];c[o>>2]=c[(c[e>>2]|0)+24>>2];c[p>>2]=c[(c[e>>2]|0)+28>>2];c[g>>2]=cK(8)|0;e=cK((c[m>>2]|0)+1<<3)|0;c[c[g>>2]>>2]=e;c[j>>2]=c[c[g>>2]>>2];h[c[j>>2]>>3]=+(c[m>>2]|0);c[j>>2]=(c[j>>2]|0)+8;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[m>>2]|0))break;h[(c[j>>2]|0)+(c[k>>2]<<3)>>3]=1.0/+((c[m>>2]|0)-1|0);c[l>>2]=c[(c[n>>2]|0)+(c[k>>2]<<2)>>2];while(1){q=c[k>>2]|0;if((c[l>>2]|0)>=(c[(c[n>>2]|0)+((c[k>>2]|0)+1<<2)>>2]|0))break;if((q|0)==(c[(c[o>>2]|0)+(c[l>>2]<<2)>>2]|0)?(b=+h[(c[p>>2]|0)+(c[l>>2]<<3)>>3],(+h[(c[p>>2]|0)+(c[l>>2]<<3)>>3]>=0.0?b:-b)>0.0):0)h[(c[j>>2]|0)+(c[k>>2]<<3)>>3]=1.0/(+((c[m>>2]|0)-1|0)*+h[f>>3]+ +h[(c[p>>2]|0)+(c[l>>2]<<3)>>3]);c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=q+1}c[(c[g>>2]|0)+4>>2]=32;i=d;return c[g>>2]|0}function Ex(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+48|0;d=b+32|0;e=b+28|0;f=b+24|0;g=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[d>>2]=a;c[k>>2]=c[c[d>>2]>>2];c[l>>2]=c[(c[d>>2]|0)+20>>2];c[m>>2]=c[(c[d>>2]|0)+24>>2];c[n>>2]=c[(c[d>>2]|0)+28>>2];c[e>>2]=cK(8)|0;a=cK((c[c[d>>2]>>2]|0)+1<<3)|0;c[c[e>>2]>>2]=a;c[f>>2]=c[c[e>>2]>>2];h[c[f>>2]>>3]=+(c[k>>2]|0);c[f>>2]=(c[f>>2]|0)+8;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[k>>2]|0))break;h[(c[f>>2]|0)+(c[g>>2]<<3)>>3]=1.0;c[j>>2]=c[(c[l>>2]|0)+(c[g>>2]<<2)>>2];while(1){o=c[g>>2]|0;if((c[j>>2]|0)>=(c[(c[l>>2]|0)+((c[g>>2]|0)+1<<2)>>2]|0))break;if((o|0)==(c[(c[m>>2]|0)+(c[j>>2]<<2)>>2]|0)?(p=+h[(c[n>>2]|0)+(c[j>>2]<<3)>>3],(+h[(c[n>>2]|0)+(c[j>>2]<<3)>>3]>=0.0?p:-p)>0.0):0)h[(c[f>>2]|0)+(c[g>>2]<<3)>>3]=1.0/+h[(c[n>>2]|0)+(c[j>>2]<<3)>>3];c[j>>2]=(c[j>>2]|0)+1}c[g>>2]=o+1}c[(c[e>>2]|0)+4>>2]=32;i=b;return c[e>>2]|0}function Fx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[c[d>>2]>>2]|0)O4(c[c[d>>2]>>2]|0);if(!(c[d>>2]|0)){i=b;return}O4(c[d>>2]|0);i=b;return}function Gx(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;i=i+64|0;n=m+60|0;o=m+56|0;p=m+52|0;q=m+48|0;r=m+44|0;s=m+40|0;t=m+8|0;u=m+36|0;v=m+32|0;w=m+28|0;x=m+24|0;y=m;z=m+20|0;A=m+16|0;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;c[s>>2]=g;h[t>>3]=j;c[u>>2]=k;c[v>>2]=l;h[y>>3]=0.0;c[w>>2]=cK(c[p>>2]<<3)|0;c[x>>2]=cK(c[p>>2]<<3)|0;c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[q>>2]|0))break;c[A>>2]=0;while(1){if((c[A>>2]|0)>=(c[p>>2]|0))break;l=_(c[A>>2]|0,c[q>>2]|0)|0;h[(c[w>>2]|0)+(c[A>>2]<<3)>>3]=+h[(c[r>>2]|0)+(l+(c[z>>2]|0)<<3)>>3];l=_(c[A>>2]|0,c[q>>2]|0)|0;h[(c[x>>2]|0)+(c[A>>2]<<3)>>3]=+h[(c[s>>2]|0)+(l+(c[z>>2]|0)<<3)>>3];c[A>>2]=(c[A>>2]|0)+1}j=+Jx(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[w>>2]|0,c[x>>2]|0,+h[t>>3],c[u>>2]|0,c[v>>2]|0);h[y>>3]=+h[y>>3]+j;c[A>>2]=0;while(1){if((c[A>>2]|0)>=(c[p>>2]|0))break;l=_(c[A>>2]|0,c[q>>2]|0)|0;h[(c[s>>2]|0)+(l+(c[z>>2]|0)<<3)>>3]=+h[(c[w>>2]|0)+(c[A>>2]<<3)>>3];c[A>>2]=(c[A>>2]|0)+1}c[z>>2]=(c[z>>2]|0)+1}O4(c[w>>2]|0);O4(c[x>>2]|0);i=m;return +(+h[y>>3])}function Hx(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0;j=i;i=i+96|0;k=j+16|0;l=j+84|0;m=j+80|0;n=j+76|0;o=j+72|0;p=j+68|0;q=j+60|0;r=j+56|0;s=j+52|0;t=j+8|0;u=j;v=j+48|0;w=j+44|0;x=j+40|0;y=j+36|0;z=j+32|0;A=j+28|0;B=j+24|0;C=j+20|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[j+64>>2]=g;c[z>>2]=c[(c[l>>2]|0)+4>>2];c[q>>2]=cK(c[z>>2]<<3)|0;c[r>>2]=cK(c[z>>2]<<3)|0;c[s>>2]=cK(c[z>>2]<<3)|0;c[A>>2]=c[(c[l>>2]|0)+20>>2];c[B>>2]=c[(c[l>>2]|0)+24>>2];c[v>>2]=c[(c[l>>2]|0)+28>>2];c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[m>>2]|0))break;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[z>>2]|0))break;l=_(c[x>>2]|0,c[m>>2]|0)|0;h[(c[q>>2]|0)+(c[x>>2]<<3)>>3]=+h[(c[n>>2]|0)+(l+(c[w>>2]|0)<<3)>>3];l=_(c[x>>2]|0,c[m>>2]|0)|0;h[(c[s>>2]|0)+(c[x>>2]<<3)>>3]=+h[(c[o>>2]|0)+(l+(c[w>>2]|0)<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}c[C>>2]=0;while(1){l=(c[C>>2]|0)<(c[p>>2]|0);c[x>>2]=0;if(!l)break;while(1){if((c[x>>2]|0)>=(c[z>>2]|0))break;h[t>>3]=0.0;h[u>>3]=0.0;c[y>>2]=c[(c[A>>2]|0)+(c[x>>2]<<2)>>2];while(1){if((c[y>>2]|0)>=(c[(c[A>>2]|0)+((c[x>>2]|0)+1<<2)>>2]|0))break;D=+h[(c[v>>2]|0)+(c[y>>2]<<3)>>3];if((c[(c[B>>2]|0)+(c[y>>2]<<2)>>2]|0)!=(c[x>>2]|0))h[t>>3]=+h[t>>3]+D*+h[(c[q>>2]|0)+(c[(c[B>>2]|0)+(c[y>>2]<<2)>>2]<<3)>>3];else h[u>>3]=D;c[y>>2]=(c[y>>2]|0)+1}if(+h[t>>3]==0.0){l=c[24742]|0;c[k>>2]=(c[(c[A>>2]|0)+((c[x>>2]|0)+1<<2)>>2]|0)-(c[(c[A>>2]|0)+(c[x>>2]<<2)>>2]|0);Y2(l,133703,k)|0}h[(c[r>>2]|0)+(c[x>>2]<<3)>>3]=(+h[(c[s>>2]|0)+(c[x>>2]<<3)>>3]-+h[t>>3])/+h[u>>3];c[x>>2]=(c[x>>2]|0)+1}Z4(c[q>>2]|0,c[r>>2]|0,c[z>>2]<<3|0)|0;c[C>>2]=(c[C>>2]|0)+1}while(1){if((c[x>>2]|0)>=(c[z>>2]|0))break;l=_(c[x>>2]|0,c[m>>2]|0)|0;h[(c[o>>2]|0)+(l+(c[w>>2]|0)<<3)>>3]=+h[(c[q>>2]|0)+(c[x>>2]<<3)>>3];c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=(c[w>>2]|0)+1}O4(c[q>>2]|0);O4(c[r>>2]|0);O4(c[s>>2]|0);i=j;return c[o>>2]|0}function Ix(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;l=i;i=i+64|0;m=l+52|0;n=l+48|0;o=l+44|0;p=l+40|0;q=l+8|0;r=l+36|0;s=l+32|0;t=l+28|0;u=l+24|0;v=l+20|0;w=l+16|0;x=l;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;h[q>>3]=f;c[r>>2]=g;c[s>>2]=j;c[t>>2]=k;c[w>>2]=c[c[m>>2]>>2];h[x>>3]=0.0;c[c[t>>2]>>2]=0;switch(c[s>>2]|0){case 0:{c[u>>2]=Ax(c[m>>2]|0)|0;c[v>>2]=Ex(c[m>>2]|0)|0;h[x>>3]=+Gx(c[u>>2]|0,c[v>>2]|0,c[w>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],c[r>>2]|0,c[t>>2]|0);Bx(c[u>>2]|0);Fx(c[v>>2]|0);y=+h[x>>3];i=l;return +y}case 1:{Hx(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,c[r>>2]|0,c[t>>2]|0)|0;y=+h[x>>3];i=l;return +y}default:{y=+h[x>>3];i=l;return +y}}return +(0.0)}function Jx(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0;l=i;i=i+112|0;m=l+108|0;n=l+104|0;o=l+100|0;p=l+96|0;q=l+92|0;r=l+48|0;s=l+88|0;t=l+80|0;u=l+76|0;v=l+72|0;w=l+68|0;x=l+40|0;y=l+32|0;z=l+24|0;A=l+16|0;B=l+8|0;C=l;D=l+64|0;E=l+60|0;F=l+56|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;h[r>>3]=g;c[s>>2]=j;c[l+84>>2]=k;h[x>>3]=+h[r>>3]*10.0;h[z>>3]=1.0e20;h[A>>3]=1.0;c[D>>2]=c[(c[m>>2]|0)+4>>2];c[E>>2]=c[(c[n>>2]|0)+4>>2];c[F>>2]=0;c[t>>2]=cK(c[o>>2]<<3)|0;c[u>>2]=cK(c[o>>2]<<3)|0;c[v>>2]=cK(c[o>>2]<<3)|0;c[w>>2]=cK(c[o>>2]<<3)|0;c[u>>2]=Hb[c[D>>2]&63](c[m>>2]|0,c[p>>2]|0,c[u>>2]|0)|0;c[u>>2]=uw(c[o>>2]|0,c[q>>2]|0,c[u>>2]|0)|0;g=+O(+(+vw(c[o>>2]|0,c[u>>2]|0,c[u>>2]|0)));G=g/+(c[o>>2]|0);h[x>>3]=G;h[B>>3]=G;while(1){q=c[F>>2]|0;c[F>>2]=q+1;if((q|0)>=(c[s>>2]|0)){H=8;break}if(!(+h[x>>3]>+h[r>>3]*+h[B>>3])){H=8;break}c[t>>2]=Hb[c[E>>2]&63](c[n>>2]|0,c[u>>2]|0,c[t>>2]|0)|0;h[z>>3]=+vw(c[o>>2]|0,c[u>>2]|0,c[t>>2]|0);if((c[F>>2]|0)>1){h[C>>3]=+h[z>>3]/+h[A>>3];c[v>>2]=ww(c[o>>2]|0,c[t>>2]|0,c[v>>2]|0,+h[C>>3])|0}else Z4(c[v>>2]|0,c[t>>2]|0,c[o>>2]<<3|0)|0;c[w>>2]=Hb[c[D>>2]&63](c[m>>2]|0,c[v>>2]|0,c[w>>2]|0)|0;G=+h[z>>3];h[y>>3]=G/+vw(c[o>>2]|0,c[v>>2]|0,c[w>>2]|0);c[p>>2]=xw(c[o>>2]|0,c[p>>2]|0,c[v>>2]|0,+h[y>>3])|0;c[u>>2]=xw(c[o>>2]|0,c[u>>2]|0,c[w>>2]|0,-+h[y>>3])|0;G=+O(+(+vw(c[o>>2]|0,c[u>>2]|0,c[u>>2]|0)));h[x>>3]=G/+(c[o>>2]|0);h[A>>3]=+h[z>>3]}if((H|0)==8){O4(c[t>>2]|0);O4(c[u>>2]|0);O4(c[v>>2]|0);O4(c[w>>2]|0);i=l;return +(+h[x>>3])}return +(0.0)}function Kx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+64|0;f=e+52|0;g=e+44|0;j=e;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e+20|0;q=e+16|0;r=e+12|0;s=e+8|0;c[f>>2]=a;c[e+48>>2]=b;c[g>>2]=d;h[j>>3]=1.0;c[p>>2]=0;c[q>>2]=cK(c[f>>2]<<3)|0;c[r>>2]=cK(c[f>>2]<<3)|0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;h[(c[q>>2]|0)+(c[k>>2]<<3)>>3]=+h[(c[g>>2]|0)+(c[k>>2]<<1<<3)>>3];h[(c[r>>2]|0)+(c[k>>2]<<3)>>3]=+h[(c[g>>2]|0)+((c[k>>2]<<1)+1<<3)>>3];c[k>>2]=(c[k>>2]|0)+1}if((c[f>>2]|0)>2)c[p>>2]=qr(c[q>>2]|0,c[r>>2]|0,c[f>>2]|0,s)|0;else c[s>>2]=0;c[n>>2]=Nv(c[f>>2]|0,c[f>>2]|0,1,1,2)|0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[s>>2]|0))break;c[l>>2]=c[(c[p>>2]|0)+(c[k>>2]<<1<<2)>>2];c[m>>2]=c[(c[p>>2]|0)+((c[k>>2]<<1)+1<<2)>>2];$v(c[n>>2]|0,1,l,m,j)|0;c[k>>2]=(c[k>>2]|0)+1}if((c[f>>2]|0)==2){c[l>>2]=0;c[m>>2]=1;$v(c[n>>2]|0,1,l,m,j)|0}c[k>>2]=0;while(1){t=c[n>>2]|0;if((c[k>>2]|0)>=(c[f>>2]|0))break;$v(t,1,k,k,j)|0;c[k>>2]=(c[k>>2]|0)+1}c[o>>2]=Uv(t)|0;Lv(c[n>>2]|0);c[n>>2]=Mv(c[o>>2]|0,0)|0;Lv(c[o>>2]|0);c[o>>2]=c[n>>2];O4(c[p>>2]|0);O4(c[q>>2]|0);O4(c[r>>2]|0);i=e;return c[o>>2]|0}function Lx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+48|0;f=e+44|0;g=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;n=e+20|0;o=e+16|0;p=e+12|0;q=e+8|0;r=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;h[r>>3]=1.0;c[k>>2]=cK(c[f>>2]<<3)|0;c[l>>2]=cK(c[f>>2]<<3)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[f>>2]|0))break;d=_(c[g>>2]|0,c[n>>2]|0)|0;h[(c[k>>2]|0)+(c[n>>2]<<3)>>3]=+h[(c[j>>2]|0)+(d<<3)>>3];d=(_(c[g>>2]|0,c[n>>2]|0)|0)+1|0;h[(c[l>>2]|0)+(c[n>>2]<<3)>>3]=+h[(c[j>>2]|0)+(d<<3)>>3];c[n>>2]=(c[n>>2]|0)+1}c[m>>2]=rr(c[k>>2]|0,c[l>>2]|0,c[f>>2]|0,0)|0;c[p>>2]=Nv(c[f>>2]|0,c[f>>2]|0,1,1,2)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[f>>2]|0))break;c[o>>2]=1;while(1){if((c[o>>2]|0)>=(c[(c[m>>2]|0)+((c[n>>2]|0)*12|0)>>2]|0))break;$v(c[p>>2]|0,1,n,(c[(c[m>>2]|0)+((c[n>>2]|0)*12|0)+4>>2]|0)+(c[o>>2]<<2)|0,r)|0;c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+1}c[n>>2]=0;while(1){s=c[p>>2]|0;if((c[n>>2]|0)>=(c[f>>2]|0))break;$v(s,1,n,n,r)|0;c[n>>2]=(c[n>>2]|0)+1}c[q>>2]=Uv(s)|0;c[q>>2]=Mv(c[q>>2]|0,0)|0;Lv(c[p>>2]|0);O4(c[k>>2]|0);O4(c[l>>2]|0);sr(c[m>>2]|0);i=e;return c[q>>2]|0}function Mx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;Nx(l,c[j>>2]|0);Ox(c[g>>2]|0,c[h>>2]|0,c[j>>2]|0,l);Px(c[h>>2]|0,l,c[k>>2]|0);Qx(l);i=f;return}function Nx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=cK(c[f>>2]<<4)|0;c[c[e>>2]>>2]=b;c[(c[e>>2]|0)+4>>2]=c[f>>2];c[(c[e>>2]|0)+8>>2]=0;i=d;return}function Ox(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+112|0;g=f+32|0;j=f+104|0;k=f+100|0;l=f+96|0;m=f+92|0;n=f+88|0;o=f+76|0;p=f+72|0;q=f+68|0;r=f+16|0;s=f;t=f+64|0;u=f+60|0;v=f+56|0;w=f+52|0;x=f+48|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[p>>2]=cK(c[k>>2]<<2)|0;c[q>>2]=cK(c[k>>2]<<2)|0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[r+12>>2]=0;c[t>>2]=cK(c[k>>2]<<2)|0;c[u>>2]=cK(c[k>>2]<<2)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;c[(c[t>>2]|0)+(c[n>>2]<<2)>>2]=c[n>>2];c[n>>2]=(c[n>>2]|0)+1}As(c[j>>2]|0,c[t>>2]|0,0,(c[k>>2]|0)-1|0);c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;c[(c[u>>2]|0)+(c[(c[t>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]=c[n>>2];c[n>>2]=(c[n>>2]|0)+1}Sx(o,c[j>>2]|0,c[t>>2]|0,c[k>>2]|0);c[n>>2]=1;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;c[(c[p>>2]|0)+(c[(c[t>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]=c[(c[t>>2]|0)+((c[n>>2]|0)-1<<2)>>2];c[n>>2]=(c[n>>2]|0)+1}c[n>>2]=0;while(1){if((c[n>>2]|0)>=((c[k>>2]|0)-1|0))break;c[(c[q>>2]|0)+(c[(c[t>>2]|0)+(c[n>>2]<<2)>>2]<<2)>>2]=c[(c[t>>2]|0)+((c[n>>2]|0)+1<<2)>>2];c[n>>2]=(c[n>>2]|0)+1}c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[l>>2]|0)){y=25;break}if(!((Tx(o,r)|0)<<24>>24)){y=25;break}if((c[(c[m>>2]|0)+8>>2]|0)>=(c[(c[m>>2]|0)+4>>2]|0)){e=(c[m>>2]|0)+4|0;c[e>>2]=c[e>>2]<<1;e=Q4(c[c[m>>2]>>2]|0,c[(c[m>>2]|0)+4>>2]<<4)|0;c[c[m>>2]>>2]=e}e=(c[m>>2]|0)+8|0;d=c[e>>2]|0;c[e>>2]=d+1;e=(c[c[m>>2]>>2]|0)+(d<<4)|0;c[e>>2]=c[r>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];c[e+12>>2]=c[r+12>>2];c[v>>2]=c[(c[u>>2]|0)+(c[r>>2]<<2)>>2];c[w>>2]=c[(c[u>>2]|0)+(c[r+4>>2]<<2)>>2];if((c[v>>2]|0)>0?(c[x>>2]=c[(c[t>>2]|0)+((c[v>>2]|0)-1<<2)>>2],(c[(c[u>>2]|0)+(c[(c[q>>2]|0)+(c[x>>2]<<2)>>2]<<2)>>2]|0)<(c[w>>2]|0)):0){c[s>>2]=c[x>>2];c[s+4>>2]=c[r+4>>2];h[s+8>>3]=+h[(c[j>>2]|0)+(c[r+4>>2]<<3)>>3]-+h[(c[j>>2]|0)+(c[x>>2]<<3)>>3];c[g>>2]=c[s>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];Ux(o,g);c[(c[q>>2]|0)+(c[x>>2]<<2)>>2]=c[r+4>>2];c[(c[p>>2]|0)+(c[r+4>>2]<<2)>>2]=c[x>>2]}if((c[w>>2]|0)<((c[k>>2]|0)-1|0)?(c[x>>2]=c[(c[t>>2]|0)+((c[w>>2]|0)+1<<2)>>2],(c[(c[u>>2]|0)+(c[(c[p>>2]|0)+(c[x>>2]<<2)>>2]<<2)>>2]|0)>(c[v>>2]|0)):0){c[s>>2]=c[r>>2];c[s+4>>2]=c[x>>2];h[s+8>>3]=+h[(c[j>>2]|0)+(c[x>>2]<<3)>>3]-+h[(c[j>>2]|0)+(c[r>>2]<<3)>>3];c[g>>2]=c[s>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];Ux(o,g);c[(c[p>>2]|0)+(c[x>>2]<<2)>>2]=c[r>>2];c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]=c[x>>2]}c[n>>2]=(c[n>>2]|0)+1}if((y|0)==25){O4(c[p>>2]|0);O4(c[q>>2]|0);O4(c[t>>2]|0);O4(c[u>>2]|0);Vx(o);i=f;return}}function Px(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+64|0;f=e+52|0;h=e+48|0;j=e+44|0;k=e+40|0;l=e+36|0;m=e+32|0;n=e+28|0;o=e+24|0;p=e;q=e+20|0;r=e+16|0;c[f>>2]=a;c[h>>2]=b;c[j>>2]=d;c[m>>2]=cK(c[f>>2]<<2)|0;c[n>>2]=c[(c[h>>2]|0)+8>>2];c[o>>2]=(c[n>>2]<<1)+(c[f>>2]|0);c[q>>2]=cK(c[o>>2]<<2)|0;c[r>>2]=cK(c[o>>2]<<2)|0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;c[(c[m>>2]|0)+(c[k>>2]<<2)>>2]=1;c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[n>>2]|0))break;d=(c[c[h>>2]>>2]|0)+(c[k>>2]<<4)|0;c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];d=(c[m>>2]|0)+(c[p>>2]<<2)|0;c[d>>2]=(c[d>>2]|0)+1;d=(c[m>>2]|0)+(c[p+4>>2]<<2)|0;c[d>>2]=(c[d>>2]|0)+1;c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[o>>2]|0))break;g[(c[r>>2]|0)+(c[k>>2]<<2)>>2]=1.0;c[k>>2]=(c[k>>2]|0)+1}o=cK((c[f>>2]|0)*20|0)|0;c[l>>2]=o;c[c[j>>2]>>2]=o;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[f>>2]|0))break;c[(c[l>>2]|0)+((c[k>>2]|0)*20|0)>>2]=1;c[(c[l>>2]|0)+((c[k>>2]|0)*20|0)+8>>2]=c[r>>2];c[(c[l>>2]|0)+((c[k>>2]|0)*20|0)+4>>2]=c[q>>2];c[c[q>>2]>>2]=c[k>>2];g[c[r>>2]>>2]=0.0;c[r>>2]=(c[r>>2]|0)+(c[(c[m>>2]|0)+(c[k>>2]<<2)>>2]<<2);c[q>>2]=(c[q>>2]|0)+(c[(c[m>>2]|0)+(c[k>>2]<<2)>>2]<<2);c[k>>2]=(c[k>>2]|0)+1}O4(c[m>>2]|0);while(1){if(!(c[(c[h>>2]|0)+8>>2]|0))s=0;else{m=(c[h>>2]|0)+8|0;c[m>>2]=(c[m>>2]|0)+-1;m=(c[c[h>>2]>>2]|0)+(c[(c[h>>2]|0)+8>>2]<<4)|0;c[p>>2]=c[m>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2];c[p+12>>2]=c[m+12>>2];s=1}if(!s)break;Rx(c[l>>2]|0,c[p>>2]|0,c[p+4>>2]|0)}i=e;return}function Qx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[d>>2]>>2]|0);i=b;return}function Rx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[f>>2]|0)+((c[h>>2]|0)*20|0)>>2]|0))break;if((c[(c[(c[f>>2]|0)+((c[h>>2]|0)*20|0)+4>>2]|0)+(c[k>>2]<<2)>>2]|0)==(c[j>>2]|0)){l=7;break}c[k>>2]=(c[k>>2]|0)+1}if((l|0)==7){i=e;return}l=c[j>>2]|0;k=(c[f>>2]|0)+((c[h>>2]|0)*20|0)|0;d=c[k>>2]|0;c[k>>2]=d+1;c[(c[(c[f>>2]|0)+((c[h>>2]|0)*20|0)+4>>2]|0)+(d<<2)>>2]=l;l=c[h>>2]|0;d=(c[f>>2]|0)+((c[j>>2]|0)*20|0)|0;k=c[d>>2]|0;c[d>>2]=k+1;c[(c[(c[f>>2]|0)+((c[j>>2]|0)*20|0)+4>>2]|0)+(k<<2)>>2]=l;if(!(c[(c[f>>2]|0)+8>>2]|0)){i=e;return}l=c[(c[f>>2]|0)+((c[h>>2]|0)*20|0)+8>>2]|0;g[l>>2]=+g[l>>2]+-1.0;l=c[(c[f>>2]|0)+((c[j>>2]|0)*20|0)+8>>2]|0;g[l>>2]=+g[l>>2]+-1.0;i=e;return}function Sx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+48|0;g=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f;o=f+16|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[(c[g>>2]|0)+4>>2]=(c[l>>2]|0)-1;c[(c[g>>2]|0)+8>>2]=c[(c[g>>2]|0)+4>>2];e=cK(c[(c[g>>2]|0)+8>>2]<<4)|0;c[c[g>>2]>>2]=e;c[m>>2]=0;while(1){if((c[m>>2]|0)>=((c[l>>2]|0)-1|0))break;c[n>>2]=c[(c[k>>2]|0)+(c[m>>2]<<2)>>2];c[n+4>>2]=c[(c[k>>2]|0)+((c[m>>2]|0)+1<<2)>>2];h[n+8>>3]=+h[(c[j>>2]|0)+(c[(c[k>>2]|0)+((c[m>>2]|0)+1<<2)>>2]<<3)>>3]-+h[(c[j>>2]|0)+(c[(c[k>>2]|0)+(c[m>>2]<<2)>>2]<<3)>>3];e=(c[c[g>>2]>>2]|0)+(c[m>>2]<<4)|0;c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];c[e+12>>2]=c[n+12>>2];c[m>>2]=(c[m>>2]|0)+1}c[o>>2]=((c[l>>2]|0)-1|0)/2|0;while(1){if((c[o>>2]|0)<0)break;Wx(c[g>>2]|0,c[o>>2]|0);c[o>>2]=(c[o>>2]|0)+-1}i=f;return}function Tx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;if(!(c[(c[g>>2]|0)+4>>2]|0)){a[f>>0]=0;j=a[f>>0]|0;i=e;return j|0}else{d=c[h>>2]|0;h=c[c[g>>2]>>2]|0;c[d>>2]=c[h>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];h=c[c[g>>2]>>2]|0;d=(c[c[g>>2]>>2]|0)+((c[(c[g>>2]|0)+4>>2]|0)-1<<4)|0;c[h>>2]=c[d>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];d=(c[g>>2]|0)+4|0;c[d>>2]=(c[d>>2]|0)+-1;Wx(c[g>>2]|0,0);a[f>>0]=1;j=a[f>>0]|0;i=e;return j|0}return 0}function Ux(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+4>>2];if((c[(c[e>>2]|0)+4>>2]|0)==(c[(c[e>>2]|0)+8>>2]|0)){a=(c[e>>2]|0)+8|0;c[a>>2]=c[a>>2]<<1;a=Q4(c[c[e>>2]>>2]|0,c[(c[e>>2]|0)+8>>2]<<4)|0;c[c[e>>2]>>2]=a}a=(c[e>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)+1;a=(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)|0;c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];while(1){if((c[f>>2]|0)<=0){j=9;break}if(!(+h[(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)+8>>3]<+h[(c[c[e>>2]>>2]|0)+(((c[f>>2]|0)/2|0)<<4)+8>>3])){if(!(+h[(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)+8>>3]==+h[(c[c[e>>2]>>2]|0)+(((c[f>>2]|0)/2|0)<<4)+8>>3])){j=9;break}if(!((t2()|0)%2|0)){j=9;break}}b=(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)|0;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];b=(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)|0;a=(c[c[e>>2]>>2]|0)+(((c[f>>2]|0)/2|0)<<4)|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];a=(c[c[e>>2]>>2]|0)+(((c[f>>2]|0)/2|0)<<4)|0;c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];c[f>>2]=(c[f>>2]|0)/2|0}if((j|0)==9){i=d;return}}function Vx(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[d>>2]>>2]|0);i=b;return}function Wx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;j=d+20|0;k=d+16|0;l=d;c[e>>2]=a;c[f>>2]=b;while(1){c[g>>2]=c[f>>2]<<1;c[j>>2]=(c[f>>2]<<1)+1;do if((c[g>>2]|0)<(c[(c[e>>2]|0)+4>>2]|0)){if(!(+h[(c[c[e>>2]>>2]|0)+(c[g>>2]<<4)+8>>3]<+h[(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)+8>>3])){if(!(+h[(c[c[e>>2]>>2]|0)+(c[g>>2]<<4)+8>>3]==+h[(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)+8>>3])){m=7;break}if(!((t2()|0)%2|0)){m=7;break}}c[k>>2]=c[g>>2]}else m=7;while(0);if((m|0)==7){m=0;c[k>>2]=c[f>>2]}do if((c[j>>2]|0)<(c[(c[e>>2]|0)+4>>2]|0)){if(!(+h[(c[c[e>>2]>>2]|0)+(c[j>>2]<<4)+8>>3]<+h[(c[c[e>>2]>>2]|0)+(c[k>>2]<<4)+8>>3])){if(!(+h[(c[c[e>>2]>>2]|0)+(c[j>>2]<<4)+8>>3]==+h[(c[c[e>>2]>>2]|0)+(c[k>>2]<<4)+8>>3]))break;if(!((t2()|0)%2|0))break}c[k>>2]=c[j>>2]}while(0);if((c[k>>2]|0)==(c[f>>2]|0))break;b=(c[c[e>>2]>>2]|0)+(c[k>>2]<<4)|0;c[l>>2]=c[b>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];b=(c[c[e>>2]>>2]|0)+(c[k>>2]<<4)|0;a=(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];a=(c[c[e>>2]>>2]|0)+(c[f>>2]<<4)|0;c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];c[f>>2]=c[k>>2]}i=d;return}function Xx(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0;l=i;i=i+96|0;m=l+92|0;n=l+88|0;o=l+32|0;p=l+24|0;q=l+84|0;r=l+80|0;s=l+76|0;t=l+72|0;u=l+68|0;v=l+64|0;w=l+60|0;x=l+16|0;y=l+56|0;z=l+52|0;A=l+48|0;B=l+8|0;C=l;D=l+44|0;E=l+40|0;c[m>>2]=a;c[n>>2]=b;h[o>>3]=d;h[p>>3]=e;c[q>>2]=f;c[r>>2]=g;c[s>>2]=j;c[t>>2]=k;c[w>>2]=0;c[y>>2]=0;if(!(c[q>>2]|0)){c[u>>2]=cK(c[n>>2]<<3)|0;if(Et(c[m>>2]|0,c[n>>2]|0,c[u>>2]|0,c[n>>2]|0)|0)c[w>>2]=1;else F=5}else{c[u>>2]=c[q>>2];F=5}a:do if((F|0)==5){m=bK(c[n>>2]<<2)|0;c[z>>2]=m;c[c[r>>2]>>2]=m;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break;c[(c[z>>2]|0)+(c[v>>2]<<2)>>2]=c[v>>2];c[v>>2]=(c[v>>2]|0)+1}As(c[u>>2]|0,c[z>>2]|0,0,(c[n>>2]|0)-1|0);h[x>>3]=+h[(c[u>>2]|0)+(c[(c[z>>2]|0)+((c[n>>2]|0)-1<<2)>>2]<<3)>>3]-+h[(c[u>>2]|0)+(c[c[z>>2]>>2]<<3)>>3];b:do if(c[12961]|0){c[y>>2]=1;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break b;if(c[y>>2]|0)G=(c[(c[12961]|0)+(c[v>>2]<<2)>>2]|0)>=0;else G=0;c[y>>2]=G&1;c[v>>2]=(c[v>>2]|0)+1}}while(0);if(c[y>>2]|0){c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break;h[(c[u>>2]|0)+(c[v>>2]<<3)>>3]=+(c[(c[12961]|0)+(c[v>>2]<<2)>>2]|0);c[(c[z>>2]|0)+(c[v>>2]<<2)>>2]=c[v>>2];c[v>>2]=(c[v>>2]|0)+1}As(c[u>>2]|0,c[z>>2]|0,0,(c[n>>2]|0)-1|0)}h[C>>3]=+h[(c[u>>2]|0)+(c[(c[z>>2]|0)+((c[n>>2]|0)-1<<2)>>2]<<3)>>3]-+h[(c[u>>2]|0)+(c[c[z>>2]>>2]<<3)>>3];if(+h[o>>3]>+h[p>>3]*+h[C>>3]/+((c[n>>2]|0)-1|0))H=+h[o>>3];else H=+h[p>>3]*+h[C>>3]/+((c[n>>2]|0)-1|0);h[B>>3]=H;c[D>>2]=0;c[v>>2]=1;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break;if(+h[(c[u>>2]|0)+(c[(c[z>>2]|0)+(c[v>>2]<<2)>>2]<<3)>>3]-+h[(c[u>>2]|0)+(c[(c[z>>2]|0)+((c[v>>2]|0)-1<<2)>>2]<<3)>>3]>+h[B>>3])c[D>>2]=(c[D>>2]|0)+1;c[v>>2]=(c[v>>2]|0)+1}c[c[t>>2]>>2]=c[D>>2];if(!(c[D>>2]|0)){m=cK(4)|0;c[A>>2]=m;c[c[s>>2]>>2]=m;c[c[A>>2]>>2]=c[n>>2];break}c[E>>2]=0;m=cK(c[D>>2]<<2)|0;c[A>>2]=m;c[c[s>>2]>>2]=m;c[v>>2]=1;while(1){if((c[v>>2]|0)>=(c[n>>2]|0))break a;if(+h[(c[u>>2]|0)+(c[(c[z>>2]|0)+(c[v>>2]<<2)>>2]<<3)>>3]-+h[(c[u>>2]|0)+(c[(c[z>>2]|0)+((c[v>>2]|0)-1<<2)>>2]<<3)>>3]>+h[B>>3]){m=c[v>>2]|0;k=c[E>>2]|0;c[E>>2]=k+1;c[(c[A>>2]|0)+(k<<2)>>2]=m}c[v>>2]=(c[v>>2]|0)+1}}while(0);if(c[q>>2]|0){I=c[w>>2]|0;i=l;return I|0}O4(c[u>>2]|0);I=c[w>>2]|0;i=l;return I|0}function Yx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0;d=i;i=i+64|0;e=d+56|0;f=d+52|0;g=d+48|0;j=d+44|0;k=d+40|0;l=d+36|0;m=d+32|0;n=d+24|0;o=d+16|0;p=d+8|0;q=d;c[f>>2]=a;c[g>>2]=b;c[m>>2]=0;if(c[12962]|0)Nm(c[12962]|0);c[12962]=Mm(c[g>>2]|0,c[g>>2]|0,0.0)|0;if(c[12963]|0)O4(c[12963]|0);c[12963]=bK(c[g>>2]<<2)|0;if(c[12964]|0)O4(c[12964]|0);c[12964]=bK(c[g>>2]<<3)|0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[g>>2]|0))break;h[o>>3]=0.0;c[k>>2]=0;while(1){r=+h[o>>3];if((c[k>>2]|0)>=(c[g>>2]|0))break;s=+h[(c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3];h[(c[(c[12962]|0)+(c[j>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3]=s;t=+N(+s);h[q>>3]=t;if(r<t)h[o>>3]=+h[q>>3];c[k>>2]=(c[k>>2]|0)+1}if(!(r!=0.0)){u=16;break}h[(c[12964]|0)+(c[j>>2]<<3)>>3]=1.0/+h[o>>3];c[(c[12963]|0)+(c[j>>2]<<2)>>2]=c[j>>2];c[j>>2]=(c[j>>2]|0)+1}if((u|0)==16){h[(c[12964]|0)+(c[j>>2]<<3)>>3]=0.0;c[e>>2]=0;v=c[e>>2]|0;i=d;return v|0}c[l>>2]=0;while(1){if((c[l>>2]|0)>=((c[g>>2]|0)-1|0))break;h[o>>3]=0.0;c[j>>2]=c[l>>2];while(1){w=+h[o>>3];if((c[j>>2]|0)>=(c[g>>2]|0))break;r=+N(+(+h[(c[(c[12962]|0)+(c[(c[12963]|0)+(c[j>>2]<<2)>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]));t=r*+h[(c[12964]|0)+(c[(c[12963]|0)+(c[j>>2]<<2)>>2]<<3)>>3];h[q>>3]=t;if(w<t){h[o>>3]=+h[q>>3];c[m>>2]=c[j>>2]}c[j>>2]=(c[j>>2]|0)+1}if(w==0.0){u=25;break}if((c[m>>2]|0)!=(c[l>>2]|0)){c[k>>2]=c[(c[12963]|0)+(c[l>>2]<<2)>>2];c[(c[12963]|0)+(c[l>>2]<<2)>>2]=c[(c[12963]|0)+(c[m>>2]<<2)>>2];c[(c[12963]|0)+(c[m>>2]<<2)>>2]=c[k>>2]}h[n>>3]=+h[(c[(c[12962]|0)+(c[(c[12963]|0)+(c[l>>2]<<2)>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3];c[j>>2]=(c[l>>2]|0)+1;while(1){x=c[l>>2]|0;if((c[j>>2]|0)>=(c[g>>2]|0))break;t=+h[(c[(c[12962]|0)+(c[(c[12963]|0)+(c[j>>2]<<2)>>2]<<2)>>2]|0)+(x<<3)>>3]/+h[n>>3];h[p>>3]=t;h[(c[(c[12962]|0)+(c[(c[12963]|0)+(c[j>>2]<<2)>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]=t;a:do if(+h[p>>3]!=0.0){c[k>>2]=(c[l>>2]|0)+1;while(1){if((c[k>>2]|0)>=(c[g>>2]|0))break a;f=(c[(c[12962]|0)+(c[(c[12963]|0)+(c[j>>2]<<2)>>2]<<2)>>2]|0)+(c[k>>2]<<3)|0;h[f>>3]=+h[f>>3]-+h[p>>3]*+h[(c[(c[12962]|0)+(c[(c[12963]|0)+(c[l>>2]<<2)>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3];c[k>>2]=(c[k>>2]|0)+1}}while(0);c[j>>2]=(c[j>>2]|0)+1}c[l>>2]=x+1}if((u|0)==25){c[e>>2]=0;v=c[e>>2]|0;i=d;return v|0}if(+h[(c[(c[12962]|0)+(c[(c[12963]|0)+((c[g>>2]|0)-1<<2)>>2]<<2)>>2]|0)+((c[g>>2]|0)-1<<3)>>3]==0.0){c[e>>2]=0;v=c[e>>2]|0;i=d;return v|0}else{c[e>>2]=1;v=c[e>>2]|0;i=d;return v|0}return 0}function Zx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[j>>2]|0))break;h[m>>3]=0.0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[k>>2]|0))break;h[m>>3]=+h[m>>3]+ +h[(c[(c[12962]|0)+(c[(c[12963]|0)+(c[k>>2]<<2)>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]*+h[(c[f>>2]|0)+(c[l>>2]<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}h[(c[f>>2]|0)+(c[k>>2]<<3)>>3]=+h[(c[g>>2]|0)+(c[(c[12963]|0)+(c[k>>2]<<2)>>2]<<3)>>3]-+h[m>>3];c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=(c[j>>2]|0)-1;while(1){if((c[k>>2]|0)<0)break;h[m>>3]=0.0;c[l>>2]=(c[k>>2]|0)+1;while(1){if((c[l>>2]|0)>=(c[j>>2]|0))break;h[m>>3]=+h[m>>3]+ +h[(c[(c[12962]|0)+(c[(c[12963]|0)+(c[k>>2]<<2)>>2]<<2)>>2]|0)+(c[l>>2]<<3)>>3]*+h[(c[f>>2]|0)+(c[l>>2]<<3)>>3];c[l>>2]=(c[l>>2]|0)+1}h[(c[f>>2]|0)+(c[k>>2]<<3)>>3]=(+h[(c[f>>2]|0)+(c[k>>2]<<3)>>3]-+h[m>>3])/+h[(c[(c[12962]|0)+(c[(c[12963]|0)+(c[k>>2]<<2)>>2]<<2)>>2]|0)+(c[k>>2]<<3)>>3];c[k>>2]=(c[k>>2]|0)+-1}i=e;return}function _x(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[f>>2]=256;c[e>>2]=cK(28)|0;c[c[e>>2]>>2]=c[f>>2];c[(c[e>>2]|0)+4>>2]=0;a=cK(c[f>>2]<<2)|0;c[(c[e>>2]|0)+8>>2]=a;a=cK(c[f>>2]<<2)|0;c[(c[e>>2]|0)+12>>2]=a;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;c[(c[(c[e>>2]|0)+12>>2]|0)+(c[g>>2]<<2)>>2]=-1;c[g>>2]=(c[g>>2]|0)+1}g=cK(c[f>>2]<<2)|0;c[(c[e>>2]|0)+16>>2]=g;g=jy()|0;c[(c[e>>2]|0)+20>>2]=g;c[(c[e>>2]|0)+24>>2]=c[d>>2];i=b;return c[e>>2]|0}function $x(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}O4(c[(c[e>>2]|0)+12>>2]|0);O4(c[(c[e>>2]|0)+16>>2]|0);ky(c[(c[e>>2]|0)+20>>2]|0);a:do if(c[f>>2]|0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[e>>2]|0)+4>>2]|0))break a;Bb[c[f>>2]&127](c[(c[(c[e>>2]|0)+8>>2]|0)+(c[g>>2]<<2)>>2]|0);c[g>>2]=(c[g>>2]|0)+1}}while(0);O4(c[(c[e>>2]|0)+8>>2]|0);O4(c[e>>2]|0);i=d;return}function ay(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[(c[f>>2]|0)+4>>2];c[j>>2]=c[h>>2];if((c[h>>2]|0)>((c[c[f>>2]>>2]|0)-1|0)?(fy(c[f>>2]|0)|0)==0:0){c[e>>2]=-10;m=c[e>>2]|0;i=d;return m|0}c[j>>2]=my(c[(c[f>>2]|0)+20>>2]|0,k)|0;if(c[k>>2]|0)c[j>>2]=c[h>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2]=c[g>>2];c[(c[(c[f>>2]|0)+12>>2]|0)+(c[j>>2]<<2)>>2]=c[h>>2];c[(c[(c[f>>2]|0)+16>>2]|0)+(c[h>>2]<<2)>>2]=c[j>>2];g=(c[f>>2]|0)+4|0;c[g>>2]=(c[g>>2]|0)+1;c[l>>2]=gy(c[f>>2]|0,c[h>>2]|0)|0;if((c[(c[(c[f>>2]|0)+12>>2]|0)+(c[j>>2]<<2)>>2]|0)!=(c[l>>2]|0))La(133714,133738,156,133751);if((c[(c[(c[f>>2]|0)+16>>2]|0)+(c[l>>2]<<2)>>2]|0)!=(c[j>>2]|0))La(133769,133738,157,133751);c[e>>2]=c[j>>2];m=c[e>>2]|0;i=d;return m|0}function by(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if(!(c[(c[e>>2]|0)+4>>2]|0)){c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}else{c[d>>2]=cy(c[e>>2]|0,c[c[(c[e>>2]|0)+16>>2]>>2]|0)|0;f=c[d>>2]|0;i=b;return f|0}return 0}function cy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[f>>2]|0)+12>>2];if((c[g>>2]|0)>=(c[c[f>>2]>>2]|0)){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}c[k>>2]=c[(c[j>>2]|0)+(c[g>>2]<<2)>>2];if((c[k>>2]|0)<0){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}if((c[k>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))La(133793,133738,187,133806);c[h>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2];ly(c[(c[f>>2]|0)+20>>2]|0,c[g>>2]|0)|0;j=c[f>>2]|0;if((c[k>>2]|0)<((c[(c[f>>2]|0)+4>>2]|0)-1|0)){hy(j,c[k>>2]|0,(c[(c[f>>2]|0)+4>>2]|0)-1|0);b=(c[f>>2]|0)+4|0;c[b>>2]=(c[b>>2]|0)+-1;c[k>>2]=gy(c[f>>2]|0,c[k>>2]|0)|0;c[k>>2]=iy(c[f>>2]|0,c[k>>2]|0)|0}else{k=j+4|0;c[k>>2]=(c[k>>2]|0)+-1}c[(c[(c[f>>2]|0)+12>>2]|0)+(c[g>>2]<<2)>>2]=-1;c[e>>2]=c[h>>2];l=c[e>>2]|0;i=d;return l|0}function dy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;if((c[h>>2]|0)>=(c[c[g>>2]>>2]|0)){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}c[k>>2]=c[(c[(c[g>>2]|0)+12>>2]|0)+(c[h>>2]<<2)>>2];if((c[k>>2]|0)<0){c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{c[(c[(c[g>>2]|0)+8>>2]|0)+(c[k>>2]<<2)>>2]=c[j>>2];c[k>>2]=gy(c[g>>2]|0,c[k>>2]|0)|0;c[k>>2]=iy(c[g>>2]|0,c[k>>2]|0)|0;c[f>>2]=c[k>>2];l=c[f>>2]|0;i=e;return l|0}return 0}function ey(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)>=(c[c[f>>2]>>2]|0)){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=c[(c[(c[f>>2]|0)+12>>2]|0)+(c[g>>2]<<2)>>2];if((c[h>>2]|0)<0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+(c[h>>2]<<2)>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function fy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0.0,k=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;c[f>>2]=c[c[e>>2]>>2];c[g>>2]=c[c[e>>2]>>2];if(+(c[g>>2]|0)*.2>10.0)j=+(c[g>>2]|0)*.2;else j=10.0;c[g>>2]=~~(+(c[g>>2]|0)+j);c[c[e>>2]>>2]=c[g>>2];a=eK(c[(c[e>>2]|0)+8>>2]|0,c[g>>2]<<2)|0;c[(c[e>>2]|0)+8>>2]=a;if(!(c[(c[e>>2]|0)+8>>2]|0)){c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}a=eK(c[(c[e>>2]|0)+12>>2]|0,c[g>>2]<<2)|0;c[(c[e>>2]|0)+12>>2]=a;if(!(c[(c[e>>2]|0)+12>>2]|0)){c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}a=eK(c[(c[e>>2]|0)+16>>2]|0,c[g>>2]<<2)|0;c[(c[e>>2]|0)+16>>2]=a;if(!(c[(c[e>>2]|0)+16>>2]|0)){c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}c[h>>2]=c[f>>2];while(1){if((c[h>>2]|0)>=(c[g>>2]|0))break;c[(c[(c[e>>2]|0)+12>>2]|0)+(c[h>>2]<<2)>>2]=-1;c[h>>2]=(c[h>>2]|0)+1}c[d>>2]=c[e>>2];k=c[d>>2]|0;i=b;return k|0}function gy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=c[(c[e>>2]|0)+8>>2];if(!(c[f>>2]|0)){j=c[f>>2]|0;i=d;return j|0}c[g>>2]=((c[f>>2]|0)-1|0)/2|0;if((Ob[c[(c[e>>2]|0)+24>>2]&127](c[(c[h>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[h>>2]|0)+(c[f>>2]<<2)>>2]|0)|0)!=1){j=c[f>>2]|0;i=d;return j|0}hy(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0);c[f>>2]=gy(c[e>>2]|0,c[g>>2]|0)|0;j=c[f>>2]|0;i=d;return j|0}function hy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[m>>2]=c[(c[f>>2]|0)+8>>2];c[n>>2]=c[(c[f>>2]|0)+12>>2];c[o>>2]=c[(c[f>>2]|0)+16>>2];if((c[g>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))La(133830,133738,74,133849);if((c[h>>2]|0)<(c[(c[f>>2]|0)+4>>2]|0)){c[j>>2]=c[(c[o>>2]|0)+(c[g>>2]<<2)>>2];c[k>>2]=c[(c[o>>2]|0)+(c[h>>2]<<2)>>2];c[l>>2]=c[(c[m>>2]|0)+(c[g>>2]<<2)>>2];c[(c[m>>2]|0)+(c[g>>2]<<2)>>2]=c[(c[m>>2]|0)+(c[h>>2]<<2)>>2];c[(c[m>>2]|0)+(c[h>>2]<<2)>>2]=c[l>>2];c[(c[o>>2]|0)+(c[g>>2]<<2)>>2]=c[k>>2];c[(c[n>>2]|0)+(c[k>>2]<<2)>>2]=c[g>>2];c[(c[o>>2]|0)+(c[h>>2]<<2)>>2]=c[j>>2];c[(c[n>>2]|0)+(c[j>>2]<<2)>>2]=c[h>>2];i=e;return}else La(133854,133738,75,133849)}function iy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[f>>2]=a;c[g>>2]=b;c[l>>2]=c[(c[f>>2]|0)+8>>2];c[j>>2]=(c[g>>2]<<1)+1;c[k>>2]=(c[g>>2]<<1)+2;if((c[j>>2]|0)>((c[(c[f>>2]|0)+4>>2]|0)-1|0)){c[e>>2]=c[g>>2];m=c[e>>2]|0;i=d;return m|0}do if((c[j>>2]|0)!=((c[(c[f>>2]|0)+4>>2]|0)-1|0))if((Ob[c[(c[f>>2]|0)+24>>2]&127](c[(c[l>>2]|0)+(c[j>>2]<<2)>>2]|0,c[(c[l>>2]|0)+(c[k>>2]<<2)>>2]|0)|0)==1){c[h>>2]=c[k>>2];break}else{c[h>>2]=c[j>>2];break}else c[h>>2]=c[j>>2];while(0);if((Ob[c[(c[f>>2]|0)+24>>2]&127](c[(c[l>>2]|0)+(c[g>>2]<<2)>>2]|0,c[(c[l>>2]|0)+(c[h>>2]<<2)>>2]|0)|0)==1){hy(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0);c[g>>2]=iy(c[f>>2]|0,c[h>>2]|0)|0}c[e>>2]=c[g>>2];m=c[e>>2]|0;i=d;return m|0}function jy(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;c[d>>2]=32;c[b>>2]=cK(12)|0;c[(c[b>>2]|0)+4>>2]=c[d>>2];c[c[b>>2]>>2]=-1;e=cK(c[d>>2]<<2)|0;c[(c[b>>2]|0)+8>>2]=e;i=a;return c[b>>2]|0}function ky(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[d>>2]|0);i=b;return}function ly(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[c[f>>2]>>2]|0)>=((c[(c[f>>2]|0)+4>>2]|0)-1|0)?(ny(c[f>>2]|0)|0)==0:0){c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}b=c[g>>2]|0;g=c[f>>2]|0;a=(c[g>>2]|0)+1|0;c[g>>2]=a;c[(c[(c[f>>2]|0)+8>>2]|0)+(a<<2)>>2]=b;c[e>>2]=c[c[f>>2]>>2];h=c[e>>2]|0;i=d;return h|0}function my(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;c[c[g>>2]>>2]=0;if((c[c[f>>2]>>2]|0)<0){c[c[g>>2]>>2]=-1;c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}else{g=c[f>>2]|0;b=c[g>>2]|0;c[g>>2]=b+-1;c[e>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+(b<<2)>>2];h=c[e>>2]|0;i=d;return h|0}return 0}function ny(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,h=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[(c[e>>2]|0)+4>>2];if(10.0>+(c[f>>2]|0)*.2)g=10.0;else g=+(c[f>>2]|0)*.2;c[f>>2]=~~(+(c[f>>2]|0)+g);c[(c[e>>2]|0)+4>>2]=c[f>>2];a=eK(c[(c[e>>2]|0)+8>>2]|0,c[f>>2]<<2)|0;c[(c[e>>2]|0)+8>>2]=a;if(c[(c[e>>2]|0)+8>>2]|0){c[d>>2]=c[e>>2];h=c[d>>2]|0;i=b;return h|0}else{c[d>>2]=0;h=c[d>>2]|0;i=b;return h|0}return 0}function oy(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=cK(8)|0;c[c[e>>2]>>2]=c[d>>2];c[(c[e>>2]|0)+4>>2]=0;i=b;return c[e>>2]|0}function py(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}do{c[g>>2]=c[(c[e>>2]|0)+4>>2];if(c[c[e>>2]>>2]|0)Bb[c[f>>2]&127](c[c[e>>2]>>2]|0);if(c[e>>2]|0)O4(c[e>>2]|0);c[e>>2]=c[g>>2]}while((c[e>>2]|0)!=0);i=d;return}function qy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=oy(c[f>>2]|0)|0;c[(c[g>>2]|0)+4>>2]=c[e>>2];i=d;return c[g>>2]|0}function ry(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[c[d>>2]>>2]|0}function sy(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[(c[d>>2]|0)+4>>2]|0}function ty(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=cK(12)|0;c[c[e>>2]>>2]=c[d>>2];c[(c[e>>2]|0)+4>>2]=0;c[(c[e>>2]|0)+8>>2]=0;i=b;return c[e>>2]|0}function uy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;if(!(c[e>>2]|0)){i=d;return}do{c[g>>2]=c[(c[e>>2]|0)+4>>2];if(c[c[e>>2]>>2]|0)Bb[c[f>>2]&127](c[c[e>>2]>>2]|0);if(c[e>>2]|0)O4(c[e>>2]|0);c[e>>2]=c[g>>2]}while((c[e>>2]|0)!=0);i=d;return}function vy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=ty(c[f>>2]|0)|0;if(!(c[e>>2]|0)){h=c[g>>2]|0;i=d;return h|0}c[(c[g>>2]|0)+4>>2]=c[e>>2];c[(c[e>>2]|0)+8>>2]=c[g>>2];h=c[g>>2]|0;i=d;return h|0}function wy(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[c[d>>2]>>2]|0}function xy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[f>>2]|0)){i=e;return}c[j>>2]=c[(c[f>>2]|0)+4>>2];c[k>>2]=c[(c[f>>2]|0)+8>>2];if(c[c[f>>2]>>2]|0)Bb[c[g>>2]&127](c[c[f>>2]>>2]|0);O4(c[f>>2]|0);c[f>>2]=0;if(c[j>>2]|0)c[(c[j>>2]|0)+8>>2]=c[k>>2];if(c[k>>2]|0)c[(c[k>>2]|0)+4>>2]=c[j>>2];if(c[k>>2]|0){i=e;return}c[c[h>>2]>>2]=c[j>>2];i=e;return}function yy(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[c[d>>2]>>2]=0;c[(c[d>>2]|0)+4>>2]=0;i=b;return}function zy(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=bK(64)|0;yy((c[e>>2]|0)+36|0);c[(c[e>>2]|0)+8>>2]=c[d>>2];i=b;return c[e>>2]|0}function Ay(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}Wy(c[(c[d>>2]|0)+32>>2]|0);O4(c[d>>2]|0);i=b;return}function By(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=kB(c[(c[d>>2]|0)+8>>2]|0)|0;i=b;return a|0}function Cy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[(c[f>>2]|0)+4>>2]=0;b=c[f>>2]|0;a=c[e>>2]|0;if(c[(c[e>>2]|0)+4>>2]|0){c[(c[a+4>>2]|0)+4>>2]=b;c[(c[e>>2]|0)+4>>2]=c[f>>2];i=d;return}else{c[a>>2]=b;c[(c[e>>2]|0)+4>>2]=c[f>>2];i=d;return}}function Dy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(c[c[e>>2]>>2]|0){c[(c[f>>2]|0)+4>>2]=c[c[e>>2]>>2];c[c[e>>2]>>2]=c[f>>2];i=d;return}else{c[c[e>>2]>>2]=c[f>>2];c[(c[e>>2]|0)+4>>2]=c[f>>2];i=d;return}}function Ey(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[e>>2]=a;c[f>>2]=b;Gy(c[e>>2]|0,c[f>>2]|0);c[g>>2]=c[c[f>>2]>>2];c[j>>2]=c[g>>2];c[g>>2]=c[(c[g>>2]|0)+4>>2];while(1){if(!(c[g>>2]|0))break;c[o>>2]=c[(c[g>>2]|0)+8>>2];e=$B(c[o>>2]|0)|0;c[l>>2]=e;c[n>>2]=e;c[k>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2];c[m>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2];c[l>>2]=aC(c[o>>2]|0,c[l>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;if((c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]|0)<(c[k>>2]|0)){c[n>>2]=c[l>>2];c[k>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2];c[m>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]}c[l>>2]=aC(c[o>>2]|0,c[l>>2]|0)|0}e=(c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[e>>2]=c[e>>2]|8;c[c[g>>2]>>2]=c[n>>2];c[h>>2]=c[(c[g>>2]|0)+4>>2];Cy((c[(c[(c[(c[m>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)+36|0,c[g>>2]|0);c[g>>2]=c[h>>2]}yy(c[f>>2]|0);i=d;return c[j>>2]|0}function Fy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+36>>2];while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[(c[e>>2]|0)+4>>2];Fy(c[e>>2]|0);c[e>>2]=c[f>>2]}Ay(c[d>>2]|0);i=b;return}function Gy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+8|0;c[g>>2]=b;c[h>>2]=d;c[k>>2]=0;if(c[(c[h>>2]|0)+24>>2]|0)c[k>>2]=fC(c[g>>2]|0,c[(c[h>>2]|0)+24>>2]|0,0)|0;a:do if((c[k>>2]|0)==0?(c[(c[h>>2]|0)+20>>2]|0)!=0:0){c[j>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break a;if((jO(c[c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]>>2]|0,c[(c[h>>2]|0)+20>>2]|0,0)|0)<<24>>24)break;c[j>>2]=aC(c[g>>2]|0,c[j>>2]|0)|0}c[k>>2]=c[j>>2]}while(0);if(!(c[k>>2]|0))c[k>>2]=$B(c[g>>2]|0)|0;if(!(a[138998]|0)){m=l+4|0;c[m>>2]=0;c[l>>2]=0;n=c[g>>2]|0;o=c[k>>2]|0;p=c[h>>2]|0;Hy(n,o,p,1,l);i=e;return}j=c[24742]|0;c[f>>2]=wB(c[k>>2]|0)|0;Y2(j,133871,f)|0;m=l+4|0;c[m>>2]=0;c[l>>2]=0;n=c[g>>2]|0;o=c[k>>2]|0;p=c[h>>2]|0;Hy(n,o,p,1,l);i=e;return}function Hy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+48|0;h=g+40|0;j=g+36|0;k=g+32|0;l=g+28|0;m=g+24|0;n=g+20|0;o=g+16|0;p=g+12|0;q=g+8|0;r=g+4|0;s=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;f=(c[k>>2]|0)+8|0;e=c[f>>2]|0;c[f>>2]=e+1;c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]=e;c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]=e;c[n>>2]=TA(c[h>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;e=c[n>>2]|0;c[o>>2]=c[((c[c[n>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2];e=c[n>>2]|0;if((c[o>>2]|0)==(c[j>>2]|0)){f=c[n>>2]|0;c[o>>2]=c[((c[e>>2]&3|0)==3?f:f+32|0)+28>>2];if(!(c[c[(c[(c[n>>2]|0)+8>>2]|0)+120>>2]>>2]|0))c[c[(c[(c[n>>2]|0)+8>>2]|0)+120>>2]>>2]=-1}else if(!(c[c[(c[e+8>>2]|0)+120>>2]>>2]|0))c[c[(c[(c[n>>2]|0)+8>>2]|0)+120>>2]>>2]=1;e=c[j>>2]|0;do if(!(c[(c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]|0)){c[(c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]=e;Iy(c[m>>2]|0,c[n>>2]|0);Hy(c[h>>2]|0,c[o>>2]|0,c[k>>2]|0,0,c[m>>2]|0);if((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]|0)<(c[(c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]|0))t=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]|0;else t=c[(c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]|0;c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]=t;if((c[(c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]|0)>=(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]|0)){c[p>>2]=0;do{c[r>>2]=Jy(c[m>>2]|0)|0;f=c[c[r>>2]>>2]&3;if((c[c[(c[(c[r>>2]|0)+8>>2]|0)+120>>2]>>2]|0)==1){d=c[r>>2]|0;c[q>>2]=c[((f|0)==2?d:d+-32|0)+28>>2]}else{d=c[r>>2]|0;c[q>>2]=c[((f|0)==3?d:d+32|0)+28>>2]}if(!(c[(c[(c[(c[q>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)){if(!(c[p>>2]|0))c[p>>2]=Ky(c[h>>2]|0,c[k>>2]|0)|0;Ly(c[p>>2]|0,c[q>>2]|0)}}while((c[r>>2]|0)!=(c[n>>2]|0));if(c[p>>2]|0){if((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)==0?(By(c[p>>2]|0)|0)>1:0)Ly(c[p>>2]|0,c[j>>2]|0);if((c[l>>2]|0)!=0?(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)==(c[p>>2]|0):0){Dy(c[k>>2]|0,c[p>>2]|0);break}Cy(c[k>>2]|0,c[p>>2]|0)}}}else if((c[(c[(c[e+8>>2]|0)+112>>2]|0)+8>>2]|0)!=(c[o>>2]|0)){if((c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]|0)<(c[(c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]|0))u=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]|0;else u=c[(c[(c[(c[o>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]|0;c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]=u}while(0);c[n>>2]=UA(c[h>>2]|0,c[n>>2]|0,c[j>>2]|0)|0}if(!(c[l>>2]|0)){i=g;return}if(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0){i=g;return}c[s>>2]=Ky(c[h>>2]|0,c[k>>2]|0)|0;Ly(c[s>>2]|0,c[j>>2]|0);Dy(c[k>>2]|0,c[s>>2]|0);i=g;return}function Iy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+120>>2]|0)+4>>2]=c[c[e>>2]>>2];c[c[e>>2]>>2]=c[f>>2];f=(c[e>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)+1;i=d;return}function Jy(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[c[d>>2]>>2];if(!(c[e>>2]|0))La(176099,133902,65,133914);if((c[(c[d>>2]|0)+4>>2]|0)>0){c[c[d>>2]>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+120>>2]|0)+4>>2];a=(c[d>>2]|0)+4|0;c[a>>2]=(c[a>>2]|0)-1;i=b;return c[e>>2]|0}else La(133892,133902,61,133914);return 0}function Ky(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=My(c[e>>2]|0,c[f>>2]|0)|0;c[h>>2]=zy(c[g>>2]|0)|0;i=d;return c[h>>2]|0}function Ly(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;eC(c[(c[e>>2]|0)+8>>2]|0,c[f>>2]|0,1)|0;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]=c[e>>2];i=d;return}function My(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+144|0;e=d;f=d+12|0;g=d+8|0;h=d+16|0;j=d+4|0;c[f>>2]=a;c[g>>2]=b;b=(c[g>>2]|0)+12|0;g=c[b>>2]|0;c[b>>2]=g+1;c[e>>2]=g;k3(h,133882,e)|0;c[j>>2]=FD(c[f>>2]|0,h,1)|0;MC(c[j>>2]|0,175049,280,1)|0;i=d;return c[j>>2]|0}function Ny(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;Oy(c[f>>2]|0,c[g>>2]|0,+h[(c[j>>2]|0)+32>>3]);i=e;return}function Oy(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;j=e+8|0;k=e+28|0;l=e+24|0;m=e+20|0;n=e+16|0;o=e;c[f>>2]=a;c[g>>2]=b;h[j>>3]=d;h[o>>3]=3.141592653589793;c[m>>2]=0;c[k>>2]=c[(c[g>>2]|0)+36>>2];while(1){p=c[f>>2]|0;if(!(c[k>>2]|0))break;Oy(p,c[k>>2]|0,+h[j>>3]);c[m>>2]=(c[m>>2]|0)+1;c[k>>2]=c[(c[k>>2]|0)+4>>2]}c[l>>2]=ez(p,c[g>>2]|0,+h[j>>3])|0;c[(c[g>>2]|0)+32>>2]=c[l>>2];c[n>>2]=az(c[l>>2]|0)|0;if((c[m>>2]|0)>0)h[o>>3]=+Py(c[f>>2]|0,c[m>>2]|0,c[n>>2]|0,c[l>>2]|0,c[g>>2]|0,+h[j>>3]);if((c[n>>2]|0)!=1){i=e;return}if(!(c[c[g>>2]>>2]|0)){i=e;return}if(!(c[(c[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0)){i=e;return}h[(c[g>>2]|0)+48>>3]=+h[o>>3];if(!(+h[(c[g>>2]|0)+48>>3]<0.0)){i=e;return}o=(c[g>>2]|0)+48|0;h[o>>3]=+h[o>>3]+6.283185307179586;i=e;return}function Py(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;j=i;i=i+144|0;k=j+136|0;l=j+132|0;m=j+128|0;n=j+124|0;o=j+120|0;p=j+80|0;q=j+116|0;r=j+112|0;s=j+32|0;t=j+108|0;u=j+104|0;v=j+24|0;w=j+16|0;x=j+8|0;y=j+100|0;z=j+96|0;A=j+92|0;B=j+88|0;C=j;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;h[p>>3]=g;c[u>>2]=0;h[v>>3]=0.0;h[x>>3]=0.0;c[y>>2]=bK((c[l>>2]|0)*56|0)|0;c[z>>2]=0;c[s+40>>2]=c[(c[o>>2]|0)+36>>2];h[s+8>>3]=+h[(c[o>>2]|0)+16>>3];h[s>>3]=+h[(c[o>>2]|0)+16>>3];c[s+44>>2]=c[c[o>>2]>>2];h[s+16>>3]=6.283185307179586/+(c[m>>2]|0);h[s+24>>3]=-1.0;h[s+32>>3]=-1.0;c[q>>2]=c[c[n>>2]>>2];while(1){if(!(c[q>>2]|0))break;c[r>>2]=c[c[q>>2]>>2];h[x>>3]=+(c[u>>2]|0)*+h[s+16>>3];c[u>>2]=(c[u>>2]|0)+1;if(c[(c[(c[(c[r>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]&8){c[(c[y>>2]|0)+((c[z>>2]|0)*56|0)>>2]=c[r>>2];h[(c[y>>2]|0)+((c[z>>2]|0)*56|0)+8>>3]=+h[x>>3];h[v>>3]=+Qy((c[y>>2]|0)+((c[z>>2]|0)*56|0)|0,s,+h[p>>3]);c[z>>2]=(c[z>>2]|0)+1}c[q>>2]=c[(c[q>>2]|0)+4>>2]}a:do if((c[z>>2]|0)==1)h[(c[y>>2]|0)+40>>3]=1.0;else{q=(c[z>>2]|0)==2;c[B>>2]=c[y>>2];if(q){c[A>>2]=(c[y>>2]|0)+56;h[C>>3]=+h[(c[A>>2]|0)+8>>3]-+h[(c[B>>2]|0)+8>>3];if(+h[C>>3]>3.141592653589793)h[C>>3]=6.283185307179586-+h[C>>3];Ry(c[B>>2]|0,c[A>>2]|0,+h[C>>3]);break}c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[z>>2]|0))break a;if(((c[t>>2]|0)+1|0)==(c[z>>2]|0)){c[A>>2]=c[y>>2];h[C>>3]=+h[(c[A>>2]|0)+8>>3]-+h[(c[B>>2]|0)+8>>3]+6.283185307179586}else{c[A>>2]=(c[B>>2]|0)+56;h[C>>3]=+h[(c[A>>2]|0)+8>>3]-+h[(c[B>>2]|0)+8>>3]}Ry(c[B>>2]|0,c[A>>2]|0,+h[C>>3]);c[B>>2]=(c[B>>2]|0)+56;c[t>>2]=(c[t>>2]|0)+1}}while(0);c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[z>>2]|0))break;Sy(c[k>>2]|0,(c[y>>2]|0)+((c[t>>2]|0)*56|0)|0,s,c[m>>2]|0,+h[p>>3]);c[t>>2]=(c[t>>2]|0)+1}O4(c[y>>2]|0);if((c[l>>2]|0)==1){Ty(c[o>>2]|0,-(+h[v>>3]+ +h[p>>3]/2.0),0.0,0.0);l=(c[o>>2]|0)+16|0;h[l>>3]=+h[l>>3]+(+h[p>>3]/2.0+ +h[v>>3]);v=(c[o>>2]|0)+56|0;c[v>>2]=c[v>>2]|1;D=s+24|0;E=+h[D>>3];F=s+32|0;G=+h[F>>3];H=E+G;I=H/2.0;J=I-3.141592653589793;h[w>>3]=J;K=+h[w>>3];i=j;return +K}else{h[(c[o>>2]|0)+16>>3]=+h[s+8>>3];D=s+24|0;E=+h[D>>3];F=s+32|0;G=+h[F>>3];H=E+G;I=H/2.0;J=I-3.141592653589793;h[w>>3]=J;K=+h[w>>3];i=j;return +K}return +(0.0)}function Qy(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;j=e+16|0;k=e+28|0;l=e+8|0;m=e;n=e+24|0;c[f>>2]=a;c[g>>2]=b;h[j>>3]=d;h[l>>3]=0.0;h[m>>3]=0.0;c[n>>2]=0;c[k>>2]=c[(c[g>>2]|0)+40>>2];while(1){if(!(c[k>>2]|0))break;if(c[c[k>>2]>>2]|0)o=c[(c[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0;else o=0;if((o|0)==(c[c[f>>2]>>2]|0)){c[n>>2]=(c[n>>2]|0)+1;if(+h[l>>3]<+h[(c[k>>2]|0)+16>>3])h[l>>3]=+h[(c[k>>2]|0)+16>>3];h[m>>3]=+h[m>>3]+(+h[(c[k>>2]|0)+16>>3]*2.0+ +h[j>>3])}c[k>>2]=c[(c[k>>2]|0)+4>>2]}h[(c[f>>2]|0)+32>>3]=+h[m>>3];c[(c[f>>2]|0)+48>>2]=c[n>>2];h[(c[f>>2]|0)+16>>3]=+h[c[g>>2]>>3]+ +h[j>>3]+ +h[l>>3];h[(c[f>>2]|0)+24>>3]=+h[l>>3];i=e;return +(+h[l>>3])}function Ry(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+8|0;k=e;c[f>>2]=a;c[g>>2]=b;h[j>>3]=d;h[k>>3]=+h[(c[f>>2]|0)+32>>3]*+h[(c[g>>2]|0)+16>>3]+ +h[(c[g>>2]|0)+32>>3]*+h[(c[f>>2]|0)+16>>3];h[k>>3]=+h[k>>3]/(+h[j>>3]*2.0*+h[(c[f>>2]|0)+16>>3]*+h[(c[g>>2]|0)+16>>3]);if(+h[k>>3]<1.0)h[k>>3]=1.0;if(+h[k>>3]>+h[(c[f>>2]|0)+40>>3])h[(c[f>>2]|0)+40>>3]=+h[k>>3];if(!(+h[k>>3]>+h[(c[g>>2]|0)+40>>3])){i=e;return}h[(c[g>>2]|0)+40>>3]=+h[k>>3];i=e;return}function Sy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0,I=0.0,J=0,K=0,L=0.0,M=0,N=0;g=i;i=i+144|0;j=g+128|0;k=g+124|0;l=g+120|0;m=g+116|0;n=g+96|0;o=g+112|0;p=g+88|0;q=g+80|0;r=g+72|0;s=g+64|0;t=g+56|0;u=g+48|0;v=g+108|0;w=g+104|0;x=g+40|0;y=g+32|0;z=g+24|0;A=g+16|0;B=g+8|0;C=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;h[n>>3]=f;c[w>>2]=0;h[x>>3]=+h[(c[l>>2]|0)+8>>3];h[y>>3]=+h[(c[l>>2]|0)+24>>3];h[z>>3]=+h[(c[l>>2]|0)+32>>3];h[q>>3]=+h[(c[k>>2]|0)+40>>3]*+h[(c[k>>2]|0)+16>>3];if((c[m>>2]|0)==1){h[p>>3]=0.0;h[A>>3]=+h[(c[k>>2]|0)+32>>3]/6.283185307179586;h[q>>3]=+h[q>>3]>+h[A>>3]?+h[q>>3]:+h[A>>3];h[A>>3]=+h[q>>3]*6.283185307179586-+h[(c[k>>2]|0)+32>>3];if(+h[A>>3]>0.0)h[n>>3]=+h[n>>3]+ +h[A>>3]/+(c[(c[k>>2]|0)+48>>2]|0)}else h[p>>3]=+h[(c[k>>2]|0)+8>>3]-+h[(c[k>>2]|0)+32>>3]/(+h[q>>3]*2.0);if(+h[q>>3]+ +h[(c[k>>2]|0)+24>>3]>+h[x>>3])h[x>>3]=+h[q>>3]+ +h[(c[k>>2]|0)+24>>3];h[s>>3]=+h[n>>3]/+h[q>>3];c[v>>2]=((c[(c[k>>2]|0)+48>>2]|0)+1|0)/2|0;c[o>>2]=c[(c[l>>2]|0)+40>>2];while(1){if(!(c[o>>2]|0))break;if(c[c[o>>2]>>2]|0)D=c[(c[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+112>>2]|0)+8>>2]|0;else D=0;if((D|0)==(c[c[k>>2]>>2]|0)?(az(c[(c[o>>2]|0)+32>>2]|0)|0)>0:0){h[r>>3]=+h[(c[o>>2]|0)+16>>3]/+h[q>>3];do if((c[m>>2]|0)!=1)if((c[(c[k>>2]|0)+48>>2]|0)==1){h[p>>3]=+h[(c[k>>2]|0)+8>>3];break}else{h[p>>3]=+h[p>>3]+(+h[r>>3]+ +h[s>>3]/2.0);break}else{do if(+h[p>>3]!=0.0)if((c[(c[k>>2]|0)+48>>2]|0)==2){h[p>>3]=3.141592653589793;break}else{h[p>>3]=+h[p>>3]+ +h[r>>3];break}while(0);if(+h[y>>3]<0.0)h[y>>3]=+h[p>>3];h[z>>3]=+h[p>>3]}while(0);h[B>>3]=+h[q>>3]*+Q(+(+h[p>>3]));h[C>>3]=+h[q>>3]*+R(+(+h[p>>3]));h[t>>3]=+Uy(c[o>>2]|0,c[j>>2]|0,+h[B>>3],+h[C>>3],+h[p>>3]);Ty(c[o>>2]|0,+h[B>>3],+h[C>>3],+h[t>>3]);f=+h[r>>3];E=+h[s>>3];if((c[m>>2]|0)==1)h[p>>3]=+h[p>>3]+(f+E);else h[p>>3]=+h[p>>3]+(f+E/2.0);c[w>>2]=(c[w>>2]|0)+1;if((c[w>>2]|0)==(c[v>>2]|0))h[u>>3]=+h[p>>3]}c[o>>2]=c[(c[o>>2]|0)+4>>2]}if((c[m>>2]|0)<=1){F=+h[x>>3];G=c[l>>2]|0;H=G+8|0;h[H>>3]=F;I=+h[y>>3];J=c[l>>2]|0;K=J+24|0;h[K>>3]=I;L=+h[z>>3];M=c[l>>2]|0;N=M+32|0;h[N>>3]=L;i=g;return}if((c[c[k>>2]>>2]|0)!=(c[(c[l>>2]|0)+44>>2]|0)){F=+h[x>>3];G=c[l>>2]|0;H=G+8|0;h[H>>3]=F;I=+h[y>>3];J=c[l>>2]|0;K=J+24|0;h[K>>3]=I;L=+h[z>>3];M=c[l>>2]|0;N=M+32|0;h[N>>3]=L;i=g;return}h[(c[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>3]=+h[u>>3];F=+h[x>>3];G=c[l>>2]|0;H=G+8|0;h[H>>3]=F;I=+h[y>>3];J=c[l>>2]|0;K=J+24|0;h[K>>3]=I;L=+h[z>>3];M=c[l>>2]|0;N=M+32|0;h[N>>3]=L;i=g;return}function Ty(a,b,d,e){a=a|0;b=+b;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+96|0;g=f+84|0;j=f+64|0;k=f+56|0;l=f+48|0;m=f+80|0;n=f+76|0;o=f+72|0;p=f+40|0;q=f+32|0;r=f+24|0;s=f+16|0;t=f+8|0;u=f;c[g>>2]=a;h[j>>3]=b;h[k>>3]=d;h[l>>3]=e;c[n>>2]=c[(c[g>>2]|0)+8>>2];c[o>>2]=$B(c[n>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;e=+h[c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]>>3];if(+h[l>>3]!=0.0){h[r>>3]=e;h[s>>3]=+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];h[t>>3]=+Q(+(+h[l>>3]));h[u>>3]=+R(+(+h[l>>3]));h[p>>3]=+h[r>>3]*+h[t>>3]-+h[s>>3]*+h[u>>3];h[q>>3]=+h[r>>3]*+h[u>>3]+ +h[s>>3]*+h[t>>3]}else{h[p>>3]=e;h[q>>3]=+h[(c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]}h[c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]>>3]=+h[p>>3]+ +h[j>>3];h[(c[(c[(c[o>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=+h[q>>3]+ +h[k>>3];c[o>>2]=aC(c[n>>2]|0,c[o>>2]|0)|0}c[m>>2]=c[(c[g>>2]|0)+36>>2];while(1){if(!(c[m>>2]|0))break;Ty(c[m>>2]|0,+h[j>>3],+h[k>>3],+h[l>>3]);c[m>>2]=c[(c[m>>2]|0)+4>>2]}i=f;return}function Uy(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+160|0;j=g+120|0;k=g+156|0;l=g+112|0;m=g+104|0;n=g+96|0;o=g+88|0;p=g+148|0;q=g+144|0;r=g+140|0;s=g+136|0;t=g+132|0;u=g+80|0;v=g+72|0;w=g+64|0;x=g+128|0;y=g+56|0;z=g+48|0;A=g+40|0;B=g+32|0;C=g+24|0;D=g+16|0;E=g+8|0;F=g;c[k>>2]=a;c[g+152>>2]=b;h[l>>3]=d;h[m>>3]=e;h[n>>3]=f;c[p>>2]=c[(c[k>>2]|0)+8>>2];c[t>>2]=c[(c[k>>2]|0)+32>>2];if(+h[(c[k>>2]|0)+48>>3]>=0.0){h[n>>3]=+h[n>>3]+(3.141592653589793-+h[(c[k>>2]|0)+48>>3]);if(+h[n>>3]<0.0)h[n>>3]=+h[n>>3]+6.283185307179586;h[j>>3]=+h[n>>3];G=+h[j>>3];i=g;return +G}c[x>>2]=az(c[t>>2]|0)|0;if((c[x>>2]|0)==2){h[j>>3]=+h[n>>3]-1.5707963267948966;G=+h[j>>3];i=g;return +G}c[s>>2]=c[c[k>>2]>>2];h[v>>3]=+h[c[(c[(c[s>>2]|0)+8>>2]|0)+132>>2]>>3]+ +h[l>>3];h[w>>3]=+h[(c[(c[(c[s>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]+ +h[m>>3];h[o>>3]=+h[v>>3]*+h[v>>3]+ +h[w>>3]*+h[w>>3];c[r>>2]=c[s>>2];c[q>>2]=$B(c[p>>2]|0)|0;while(1){if(!(c[q>>2]|0))break;if((c[q>>2]|0)!=(c[s>>2]|0)?(h[v>>3]=+h[c[(c[(c[q>>2]|0)+8>>2]|0)+132>>2]>>3]+ +h[l>>3],h[w>>3]=+h[(c[(c[(c[q>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]+ +h[m>>3],h[u>>3]=+h[v>>3]*+h[v>>3]+ +h[w>>3]*+h[w>>3],+h[u>>3]<+h[o>>3]):0){h[o>>3]=+h[u>>3];c[r>>2]=c[q>>2]}c[q>>2]=aC(c[p>>2]|0,c[q>>2]|0)|0}do if((c[s>>2]|0)!=(c[r>>2]|0)){h[y>>3]=+h[(c[k>>2]|0)+24>>3];h[z>>3]=+h[(c[k>>2]|0)+16>>3]-+h[y>>3];h[A>>3]=+h[c[(c[(c[s>>2]|0)+8>>2]|0)+132>>2]>>3];if((c[(c[k>>2]|0)+56>>2]&1|0)!=0?-+h[z>>3]<+h[A>>3]:0){h[B>>3]=+O(+(+h[l>>3]*+h[l>>3]+ +h[m>>3]*+h[m>>3]));h[C>>3]=+h[(c[(c[(c[s>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3];h[D>>3]=+W(+(+h[C>>3]),+(+h[A>>3]+ +h[z>>3]));h[E>>3]=+h[z>>3]-+h[y>>3]/+Q(+(+h[D>>3]));f=1.5707963267948966-+h[D>>3]-+U(+(+h[E>>3]/+h[B>>3]*+Q(+(+h[D>>3]))));h[n>>3]=+h[n>>3]+f;break}h[F>>3]=+W(+(+h[(c[(c[(c[s>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]),+(+h[c[(c[(c[s>>2]|0)+8>>2]|0)+132>>2]>>3]));h[n>>3]=+h[n>>3]+(3.141592653589793-+h[F>>3]-+h[(c[(c[(c[s>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>3]);if(+h[n>>3]>6.283185307179586)h[n>>3]=+h[n>>3]-6.283185307179586}else h[n>>3]=0.0;while(0);h[j>>3]=+h[n>>3];G=+h[j>>3];i=g;return +G}function Vy(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=bK(12)|0;i=a;return c[b>>2]|0}function Wy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}c[e>>2]=c[c[d>>2]>>2];while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[(c[e>>2]|0)+4>>2];O4(c[e>>2]|0);c[e>>2]=c[f>>2]}O4(c[d>>2]|0);i=b;return}function Xy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=cz(c[h>>2]|0)|0;h=(c[f>>2]|0)+8|0;c[h>>2]=(c[h>>2]|0)+1;if(!(c[g>>2]|0))c[g>>2]=c[(c[f>>2]|0)+4>>2];h=c[g>>2]|0;if((c[g>>2]|0)!=(c[(c[f>>2]|0)+4>>2]|0)){c[k>>2]=c[h+4>>2];c[(c[g>>2]|0)+4>>2]=c[j>>2];c[(c[j>>2]|0)+8>>2]=c[g>>2];c[(c[k>>2]|0)+8>>2]=c[j>>2];c[(c[j>>2]|0)+4>>2]=c[k>>2];i=e;return}k=c[j>>2]|0;if(h)c[(c[g>>2]|0)+4>>2]=k;else c[c[f>>2]>>2]=k;c[(c[j>>2]|0)+8>>2]=c[g>>2];c[(c[j>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+4>>2]=c[j>>2];i=e;return}function Yy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=c[c[d>>2]>>2];while(1){if(!(c[f>>2]|0))break;c[e>>2]=c[(c[f>>2]|0)+4>>2];c[(c[f>>2]|0)+4>>2]=c[(c[f>>2]|0)+8>>2];c[(c[f>>2]|0)+8>>2]=c[e>>2];c[f>>2]=c[(c[f>>2]|0)+8>>2]}c[e>>2]=c[(c[d>>2]|0)+4>>2];c[(c[d>>2]|0)+4>>2]=c[c[d>>2]>>2];c[c[d>>2]>>2]=c[e>>2];i=b;return c[d>>2]|0}function Zy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;if((c[f>>2]|0)==(c[c[e>>2]>>2]|0)){i=d;return}c[g>>2]=c[c[e>>2]>>2];c[h>>2]=c[(c[f>>2]|0)+8>>2];c[c[e>>2]>>2]=c[f>>2];c[(c[f>>2]|0)+8>>2]=0;c[(c[(c[e>>2]|0)+4>>2]|0)+4>>2]=c[g>>2];c[(c[g>>2]|0)+8>>2]=c[(c[e>>2]|0)+4>>2];c[(c[e>>2]|0)+4>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=0;i=d;return}function _y(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=Vy()|0;c[g>>2]=0;c[f>>2]=c[c[d>>2]>>2];while(1){h=c[e>>2]|0;if(!(c[f>>2]|0))break;Xy(h,c[g>>2]|0,c[c[f>>2]>>2]|0);c[g>>2]=c[(c[e>>2]|0)+4>>2];c[f>>2]=c[(c[f>>2]|0)+4>>2]}i=b;return h|0}function $y(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[o>>2]=0;c[l>>2]=c[c[g>>2]>>2];while(1){if(!(c[l>>2]|0))break;p=c[l>>2]|0;if((c[c[l>>2]>>2]|0)==(c[h>>2]|0)){q=4;break}c[l>>2]=c[p+4>>2]}do if((q|0)==4){c[o>>2]=p;c[m>>2]=c[(c[o>>2]|0)+8>>2];c[n>>2]=c[(c[o>>2]|0)+4>>2];h=c[n>>2]|0;if(c[m>>2]|0)c[(c[m>>2]|0)+4>>2]=h;else c[c[g>>2]>>2]=h;h=c[m>>2]|0;if(c[n>>2]|0){c[(c[n>>2]|0)+8>>2]=h;break}else{c[(c[g>>2]|0)+4>>2]=h;break}}while(0);if(!(c[o>>2]|0))La(133918,133925,217,133936);c[m>>2]=0;c[l>>2]=c[c[g>>2]>>2];while(1){if(!(c[l>>2]|0)){q=24;break}if((c[c[l>>2]>>2]|0)==(c[j>>2]|0))break;c[m>>2]=c[l>>2];c[l>>2]=c[(c[l>>2]|0)+4>>2]}if((q|0)==24){i=f;return}q=c[l>>2]|0;j=c[g>>2]|0;if(!(c[k>>2]|0)){k=c[o>>2]|0;if((q|0)==(c[j>>2]|0)){c[c[g>>2]>>2]=k;c[(c[o>>2]|0)+4>>2]=c[l>>2];c[(c[o>>2]|0)+8>>2]=0;c[(c[l>>2]|0)+8>>2]=c[o>>2];i=f;return}else{c[(c[m>>2]|0)+4>>2]=k;c[(c[o>>2]|0)+8>>2]=c[m>>2];c[(c[o>>2]|0)+4>>2]=c[l>>2];c[(c[l>>2]|0)+8>>2]=c[o>>2];i=f;return}}else if((q|0)==(c[j+4>>2]|0)){c[(c[g>>2]|0)+4>>2]=c[o>>2];c[(c[o>>2]|0)+4>>2]=0;c[(c[o>>2]|0)+8>>2]=c[l>>2];c[(c[l>>2]|0)+4>>2]=c[o>>2];i=f;return}else{c[(c[o>>2]|0)+8>>2]=c[l>>2];c[(c[o>>2]|0)+4>>2]=c[(c[l>>2]|0)+4>>2];c[(c[(c[l>>2]|0)+4>>2]|0)+8>>2]=c[o>>2];c[(c[l>>2]|0)+4>>2]=c[o>>2];i=f;return}}function az(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[(c[d>>2]|0)+8>>2]|0}function bz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[f>>2]=Yy(c[f>>2]|0)|0;dz(c[e>>2]|0,c[f>>2]|0);O4(c[f>>2]|0);i=d;return}function cz(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=bK(12)|0;c[c[e>>2]>>2]=c[d>>2];i=b;return c[e>>2]|0}function dz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!(c[c[f>>2]>>2]|0)){i=d;return}if(c[c[f>>2]>>2]|0){c[(c[(c[e>>2]|0)+4>>2]|0)+4>>2]=c[c[f>>2]>>2];c[(c[c[f>>2]>>2]|0)+8>>2]=c[(c[e>>2]|0)+4>>2];c[(c[e>>2]|0)+4>>2]=c[(c[f>>2]|0)+4>>2];b=(c[e>>2]|0)+8|0;c[b>>2]=(c[b>>2]|0)+(c[(c[f>>2]|0)+8>>2]|0);i=d;return}else{b=c[e>>2]|0;e=c[f>>2]|0;c[b>>2]=c[e>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];i=d;return}}function ez(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+80|0;f=e+68|0;g=e+64|0;j=e+24|0;k=e+60|0;l=e+56|0;m=e+52|0;n=e+48|0;o=e+44|0;p=e+40|0;q=e+36|0;r=e+32|0;s=e+16|0;t=e+8|0;u=e;c[f>>2]=a;c[g>>2]=b;h[j>>3]=d;h[u>>3]=0.0;c[n>>2]=c[(c[g>>2]|0)+8>>2];fz(c[f>>2]|0,c[g>>2]|0);c[l>>2]=gz(c[n>>2]|0)|0;c[m>>2]=hz(c[l>>2]|0)|0;c[o>>2]=iz(c[m>>2]|0)|0;jz(c[n>>2]|0,c[o>>2]|0);c[o>>2]=kz(c[o>>2]|0,c[n>>2]|0)|0;c[q>>2]=az(c[o>>2]|0)|0;h[u>>3]=+lz(c[o>>2]|0);if((c[q>>2]|0)==1)h[t>>3]=0.0;else h[t>>3]=+(c[q>>2]|0)*(+h[j>>3]+ +h[u>>3])/6.283185307179586;c[p>>2]=c[c[o>>2]>>2];while(1){if(!(c[p>>2]|0))break;c[k>>2]=c[c[p>>2]>>2];if(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]&8){v=7;break}c[p>>2]=c[(c[p>>2]|0)+4>>2]}if((v|0)==7)Zy(c[o>>2]|0,c[p>>2]|0);c[r>>2]=0;c[p>>2]=c[c[o>>2]>>2];while(1){if(!(c[p>>2]|0))break;c[k>>2]=c[c[p>>2]>>2];c[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]=c[r>>2];h[(c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>3]=0.0;h[s>>3]=+(c[r>>2]|0)*(6.283185307179586/+(c[q>>2]|0));d=+h[t>>3]*+Q(+(+h[s>>3]));h[c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]>>3]=d;d=+h[t>>3]*+R(+(+h[s>>3]));h[(c[(c[(c[k>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=d;c[r>>2]=(c[r>>2]|0)+1;c[p>>2]=c[(c[p>>2]|0)+4>>2]}if((c[q>>2]|0)==1){h[(c[g>>2]|0)+16>>3]=+h[u>>3]/2.0;w=c[g>>2]|0;x=w+16|0;y=+h[x>>3];z=c[g>>2]|0;A=z+24|0;h[A>>3]=y;B=c[g>>2]|0;C=B+48|0;h[C>>3]=-1.0;D=c[l>>2]|0;jB(D)|0;E=c[o>>2]|0;i=e;return E|0}else{h[(c[g>>2]|0)+16>>3]=+h[t>>3];w=c[g>>2]|0;x=w+16|0;y=+h[x>>3];z=c[g>>2]|0;A=z+24|0;h[A>>3]=y;B=c[g>>2]|0;C=B+48|0;h[C>>3]=-1.0;D=c[l>>2]|0;jB(D)|0;E=c[o>>2]|0;i=e;return E|0}return 0}function fz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=c[(c[f>>2]|0)+8>>2];c[g>>2]=$B(c[j>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[h>>2]=OA(c[e>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;b=c[h>>2]|0;if((c[(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+112>>2]|0)+12>>2]|0)==(c[f>>2]|0))YA(c[j>>2]|0,c[h>>2]|0,1)|0;c[h>>2]=QA(c[e>>2]|0,c[h>>2]|0)|0}c[g>>2]=aC(c[j>>2]|0,c[g>>2]|0)|0}i=d;return}function gz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=b+32|0;e=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;k=b+8|0;l=b+4|0;m=b;c[d>>2]=a;c[e>>2]=0;c[g>>2]=rz(c[d>>2]|0,h)|0;c[f>>2]=kB(c[h>>2]|0)|0;c[j>>2]=sz(c[h>>2]|0)|0;while(1){if((c[e>>2]|0)>=((c[f>>2]|0)-3|0))break;c[k>>2]=yz(c[j>>2]|0)|0;c[m>>2]=TA(c[h>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;d=c[m>>2]|0;c[l>>2]=c[((c[c[m>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];if((c[k>>2]|0)==(c[l>>2]|0)){d=c[m>>2]|0;c[l>>2]=c[((c[c[m>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]}xz(c[j>>2]|0,c[l>>2]|0);c[m>>2]=UA(c[h>>2]|0,c[m>>2]|0,c[k>>2]|0)|0}tz(c[h>>2]|0,c[k>>2]|0,c[g>>2]|0);c[m>>2]=TA(c[h>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;d=c[m>>2]|0;c[l>>2]=c[((c[c[m>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];if((c[k>>2]|0)==(c[l>>2]|0)){d=c[m>>2]|0;c[l>>2]=c[((c[c[m>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]}d=(c[(c[l>>2]|0)+8>>2]|0)+236|0;c[d>>2]=(c[d>>2]|0)+-1;wz(c[j>>2]|0,c[l>>2]|0);c[m>>2]=UA(c[h>>2]|0,c[m>>2]|0,c[k>>2]|0)|0}pC(c[h>>2]|0,c[k>>2]|0)|0;c[e>>2]=(c[e>>2]|0)+1}jB(c[h>>2]|0)|0;vz(c[j>>2]|0);i=b;return c[g>>2]|0}function hz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+144|0;d=b;e=b+12|0;f=b+8|0;g=b+4|0;h=b+16|0;c[e>>2]=a;a=c[12965]|0;c[12965]=a+1;c[d>>2]=a;k3(h,133951,d)|0;c[g>>2]=FD(c[e>>2]|0,h,1)|0;MC(c[g>>2]|0,175049,280,1)|0;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;eC(c[g>>2]|0,c[f>>2]|0,1)|0;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16+12>>2]=0;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16+16>>2]=0;h=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[h>>2]=c[h>>2]&-2;c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;if(!(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]&1)){c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]=0;qz(c[e>>2]|0,c[f>>2]|0,c[g>>2]|0)}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}i=b;return c[g>>2]|0}function iz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+48|0;d=b+36|0;e=b+32|0;f=b+28|0;g=b+24|0;h=b+20|0;j=b+16|0;k=b+12|0;l=b+8|0;m=b+4|0;n=b;c[e>>2]=a;c[h>>2]=0;c[l>>2]=0;if((kB(c[e>>2]|0)|0)==1){c[j>>2]=Vy()|0;c[f>>2]=$B(c[e>>2]|0)|0;Xy(c[j>>2]|0,0,c[f>>2]|0);a=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[a>>2]=c[a>>2]|16;c[d>>2]=c[j>>2];o=c[d>>2]|0;i=b;return o|0}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[n>>2]=0;c[g>>2]=TA(c[e>>2]|0,c[f>>2]|0)|0;while(1){p=c[n>>2]|0;if(!(c[g>>2]|0))break;c[n>>2]=p+1;c[g>>2]=UA(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0)|0}if((p|0)==1)pz(c[f>>2]|0,c[f>>2]|0,0,0);c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[m>>2]=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16+12>>2]|0)+(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16+16>>2]|0);if((c[m>>2]|0)>(c[l>>2]|0)){c[h>>2]=c[f>>2];c[l>>2]=c[m>>2]}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[j>>2]=Vy()|0;c[f>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2];while(1){q=c[j>>2]|0;if((c[f>>2]|0)==(c[h>>2]|0))break;Xy(q,0,c[f>>2]|0);e=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[e>>2]=c[e>>2]|16;c[f>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]}Xy(q,0,c[h>>2]|0);q=(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[q>>2]=c[q>>2]|16;if(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+16+16>>2]|0){c[k>>2]=Vy()|0;c[f>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2];while(1){if((c[f>>2]|0)==(c[h>>2]|0))break;Xy(c[k>>2]|0,0,c[f>>2]|0);q=(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[q>>2]=c[q>>2]|16;c[f>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2]}bz(c[j>>2]|0,c[k>>2]|0)}c[d>>2]=c[j>>2];o=c[d>>2]|0;i=b;return o|0}function jz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;if(!(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]&16))oz(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0);c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}i=d;return}function kz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=mz(c[f>>2]|0,c[g>>2]|0)|0;if(!(c[j>>2]|0)){c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}c[h>>2]=0;while(1){if((c[h>>2]|0)>=10){m=8;break}c[k>>2]=c[j>>2];c[f>>2]=nz(c[f>>2]|0,c[g>>2]|0,j)|0;if((c[j>>2]|0)==0?1:(c[k>>2]|0)==(c[j>>2]|0)){m=6;break}c[h>>2]=(c[h>>2]|0)+1}if((m|0)==6){c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}else if((m|0)==8){c[e>>2]=c[f>>2];l=c[e>>2]|0;i=d;return l|0}return 0}function lz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b;c[d>>2]=a;h[g>>3]=0.0;c[f>>2]=c[c[d>>2]>>2];while(1){if(!(c[f>>2]|0))break;c[e>>2]=c[c[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+112>>2]>>2];if(+h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3]>+h[g>>3])h[g>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];if(+h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3]>+h[g>>3])h[g>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3];c[f>>2]=c[(c[f>>2]|0)+4>>2]}i=b;return +(+h[g>>3])}function mz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=Cz()|0;c[l>>2]=0;c[m>>2]=1;c[j>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;c[k>>2]=OA(c[f>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[c[(c[(c[k>>2]|0)+8>>2]|0)+120>>2]>>2]=0;c[k>>2]=QA(c[f>>2]|0,c[k>>2]|0)|0}c[j>>2]=aC(c[f>>2]|0,c[j>>2]|0)|0}c[g>>2]=c[c[e>>2]>>2];while(1){if(!(c[g>>2]|0))break;c[j>>2]=c[c[g>>2]>>2];c[k>>2]=TA(c[f>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;if((c[c[(c[(c[k>>2]|0)+8>>2]|0)+120>>2]>>2]|0)>0){c[n>>2]=Hb[c[c[h>>2]>>2]&63](c[h>>2]|0,0,128)|0;while(1){if(!(c[n>>2]|0))break;c[o>>2]=c[(c[n>>2]|0)+8>>2];if(((c[c[(c[(c[o>>2]|0)+8>>2]|0)+120>>2]>>2]|0)>(c[c[(c[(c[k>>2]|0)+8>>2]|0)+120>>2]>>2]|0)?(e=c[o>>2]|0,(c[((c[c[o>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)!=(c[j>>2]|0)):0)?(e=c[o>>2]|0,(c[((c[c[o>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)!=(c[j>>2]|0)):0)c[l>>2]=(c[l>>2]|0)+1;c[n>>2]=Hb[c[c[h>>2]>>2]&63](c[h>>2]|0,c[n>>2]|0,8)|0}Fz(c[h>>2]|0,c[k>>2]|0)}c[k>>2]=UA(c[f>>2]|0,c[k>>2]|0,c[j>>2]|0)|0}c[k>>2]=TA(c[f>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;if(!(c[c[(c[(c[k>>2]|0)+8>>2]|0)+120>>2]>>2]|0)){c[c[(c[(c[k>>2]|0)+8>>2]|0)+120>>2]>>2]=c[m>>2];Ez(c[h>>2]|0,c[k>>2]|0)}c[k>>2]=UA(c[f>>2]|0,c[k>>2]|0,c[j>>2]|0)|0}c[m>>2]=(c[m>>2]|0)+1;c[g>>2]=c[(c[g>>2]|0)+4>>2]}Dz(c[h>>2]|0);i=d;return c[l>>2]|0}function nz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+48|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e+12|0;o=e+8|0;p=e+4|0;q=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[o>>2]=c[c[j>>2]>>2];c[k>>2]=$B(c[h>>2]|0)|0;a:while(1){if(!(c[k>>2]|0)){r=16;break}c[l>>2]=TA(c[h>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;d=c[l>>2]|0;c[m>>2]=c[((c[c[l>>2]>>2]&3|0)==3?d:d+32|0)+28>>2];if((c[m>>2]|0)==(c[k>>2]|0)){d=c[l>>2]|0;c[m>>2]=c[((c[c[l>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]}c[p>>2]=0;while(1){if((c[p>>2]|0)>=2)break;c[n>>2]=_y(c[g>>2]|0)|0;$y(c[g>>2]|0,c[k>>2]|0,c[m>>2]|0,c[p>>2]|0);c[q>>2]=mz(c[g>>2]|0,c[h>>2]|0)|0;if((c[q>>2]|0)<(c[o>>2]|0)){c[o>>2]=c[q>>2];Wy(c[n>>2]|0);if(!(c[o>>2]|0)){r=11;break a}}else{Wy(c[g>>2]|0);c[g>>2]=c[n>>2]}c[p>>2]=(c[p>>2]|0)+1}c[l>>2]=UA(c[h>>2]|0,c[l>>2]|0,c[k>>2]|0)|0}c[k>>2]=aC(c[h>>2]|0,c[k>>2]|0)|0}if((r|0)==11){c[c[j>>2]>>2]=0;c[f>>2]=c[g>>2];s=c[f>>2]|0;i=e;return s|0}else if((r|0)==16){c[c[j>>2]>>2]=c[o>>2];c[f>>2]=c[g>>2];s=c[f>>2]|0;i=e;return s|0}return 0}function oz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[k>>2]=0;c[l>>2]=Vy()|0;c[j>>2]=OA(c[f>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;d=c[j>>2]|0;Xy(c[l>>2]|0,0,c[((c[c[j>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0);d=c[j>>2]|0;b=(c[(c[(c[((c[c[j>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[b>>2]=c[b>>2]|32;c[j>>2]=QA(c[f>>2]|0,c[j>>2]|0)|0}c[j>>2]=RA(c[f>>2]|0,c[g>>2]|0)|0;while(1){o=c[l>>2]|0;if(!(c[j>>2]|0))break;b=c[j>>2]|0;Xy(o,0,c[((c[c[j>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0);b=c[j>>2]|0;d=(c[(c[(c[((c[c[j>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[d>>2]=c[d>>2]|32;c[j>>2]=SA(c[f>>2]|0,c[j>>2]|0)|0}a:do if((az(o)|0)>=2){c[m>>2]=c[c[h>>2]>>2];while(1){if(!(c[m>>2]|0))break a;if((c[m>>2]|0)==(c[(c[h>>2]|0)+4>>2]|0))c[n>>2]=c[c[h>>2]>>2];else c[n>>2]=c[(c[m>>2]|0)+4>>2];if((c[(c[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]&32|0)!=0?(c[(c[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]&32|0)!=0:0)break;c[m>>2]=c[(c[m>>2]|0)+4>>2]}Xy(c[h>>2]|0,c[m>>2]|0,c[g>>2]|0);c[k>>2]=1}while(0);b:do if((c[k>>2]|0)==0?(az(c[l>>2]|0)|0)>0:0){c[m>>2]=c[c[h>>2]>>2];while(1){if(!(c[m>>2]|0))break b;if(c[(c[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+112>>2]|0)+4>>2]&32)break;c[m>>2]=c[(c[m>>2]|0)+4>>2]}Xy(c[h>>2]|0,c[m>>2]|0,c[g>>2]|0);c[k>>2]=1}while(0);if(!(c[k>>2]|0))Xy(c[h>>2]|0,0,c[g>>2]|0);c[m>>2]=c[c[l>>2]>>2];while(1){if(!(c[m>>2]|0))break;g=(c[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+112>>2]|0)+4|0;c[g>>2]=c[g>>2]&-33;c[m>>2]=c[(c[m>>2]|0)+4>>2]}Wy(c[l>>2]|0);i=e;return}function pz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+112>>2]|0)+16>>2];if(!(c[l>>2]|0)){i=f;return}c[j>>2]=(c[j>>2]|0)+1;if(!(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+12>>2]|0)){c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]=c[g>>2];c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+12>>2]=c[j>>2]}else{if((c[j>>2]|0)<=(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+12>>2]|0)){if((c[j>>2]|0)<=(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+16>>2]|0)){i=f;return}c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]=c[g>>2];c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+16>>2]=c[j>>2];i=f;return}if((c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]|0)!=(c[k>>2]|0)){if(!((c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+16>>2]|0)!=0?(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]|0)==(c[k>>2]|0):0))c[k>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2];c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+8>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2];c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+16>>2]=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+12>>2]}c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+4>>2]=c[g>>2];c[(c[(c[(c[l>>2]|0)+8>>2]|0)+112>>2]|0)+16+12>>2]=c[j>>2]}pz(c[g>>2]|0,c[l>>2]|0,c[j>>2]|0,c[k>>2]|0);i=f;return}
function cU(b,f,g,j){b=b|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0;k=i;i=i+80|0;l=k+40|0;m=k+32|0;n=k+64|0;o=k+60|0;p=k+56|0;q=k+52|0;r=k+48|0;s=k+16|0;t=k;u=k+44|0;c[n>>2]=b;c[o>>2]=f;c[p>>2]=g;c[q>>2]=j;c[(c[o>>2]|0)+96>>2]=c[p>>2];do if(!(e[(c[o>>2]|0)+36>>1]&64))if(e[(c[p>>2]|0)+36>>1]&64){a[(c[o>>2]|0)+34>>0]=a[(c[p>>2]|0)+34>>0]|0;break}else{a[(c[o>>2]|0)+34>>0]=2;break}while(0);do if(!(e[(c[o>>2]|0)+36>>1]&32)){j=c[p>>2]|0;if((a[(c[p>>2]|0)+88>>0]|0)>=0){a[(c[o>>2]|0)+33>>0]=a[j+88>>0]|0;break}if(e[j+36>>1]&32){a[(c[o>>2]|0)+33>>0]=a[(c[p>>2]|0)+33>>0]|0;break}else{a[(c[o>>2]|0)+33>>0]=1;break}}while(0);do if((a[(c[o>>2]|0)+88+4>>0]|0)!=1)if((a[(c[o>>2]|0)+88+4>>0]|0)==3){c[r>>2]=eU(c[(c[o>>2]|0)+88>>2]|0,c[q>>2]|0)|0;p=(c[(c[o>>2]|0)+88>>2]|0)+16|0;c[t>>2]=c[p>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];break}else{c[r>>2]=XT(c[(c[(c[n>>2]|0)+8>>2]|0)+144>>2]|0,c[(c[o>>2]|0)+88>>2]|0,c[q>>2]|0)|0;p=(c[(c[o>>2]|0)+88>>2]|0)+8+16|0;c[t>>2]=c[p>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];break}else{c[r>>2]=UT(c[n>>2]|0,c[(c[o>>2]|0)+88>>2]|0,c[o>>2]|0,c[q>>2]|0)|0;p=(c[(c[o>>2]|0)+88>>2]|0)+48+16|0;c[t>>2]=c[p>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2]}while(0);c[u>>2]=(d[(c[o>>2]|0)+34>>0]|0)+(d[(c[o>>2]|0)+33>>0]|0)<<1;h[s>>3]=+h[t>>3]+ +(c[u>>2]|0);h[s+8>>3]=+h[t+8>>3]+ +(c[u>>2]|0);do if(e[(c[o>>2]|0)+36>>1]&1){if((e[(c[o>>2]|0)+38>>1]|0)!=0?(e[(c[o>>2]|0)+40>>1]|0)!=0:0){if(!(!(+(e[(c[o>>2]|0)+38>>1]|0)<+h[s>>3])?!(+(e[(c[o>>2]|0)+40>>1]|0)<+h[s+8>>3]):0))v=21;if((v|0)==21?(a[(c[o>>2]|0)+88+4>>0]|0)!=3:0){$z(0,175192,m)|0;c[r>>2]=1}h[s+8>>3]=0.0;h[s>>3]=0.0;break}$z(0,175225,l)|0;c[r>>2]=1}while(0);if(+h[s>>3]>+(e[(c[o>>2]|0)+38>>1]|0))w=+h[s>>3];else w=+(e[(c[o>>2]|0)+38>>1]|0);h[(c[o>>2]|0)+48+16>>3]=w;if(+h[s+8>>3]>+(e[(c[o>>2]|0)+40>>1]|0)){x=+h[s+8>>3];y=c[o>>2]|0;z=y+48|0;A=z+16|0;B=A+8|0;h[B>>3]=x;C=c[r>>2]|0;i=k;return C|0}else{x=+(e[(c[o>>2]|0)+40>>1]|0);y=c[o>>2]|0;z=y+48|0;A=z+16|0;B=A+8|0;h[B>>3]=x;C=c[r>>2]|0;i=k;return C|0}return 0}function dU(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=f;c[m>>2]=1;c[r>>2]=(e[(c[l>>2]|0)+80>>1]|0)-1;while(1){s=c[k>>2]|0;if(!(c[m>>2]|0))break;c[n>>2]=s+(c[r>>2]|0);c[q>>2]=c[n>>2];while(1){if((c[q>>2]|0)<(c[k>>2]|0))break;if(_K(c[h>>2]|0,c[q>>2]|0,c[j>>2]|0)|0)break;c[q>>2]=(c[q>>2]|0)+-1}if((c[q>>2]|0)>=(c[k>>2]|0)){c[k>>2]=(c[q>>2]|0)+1;continue}else{c[m>>2]=0;continue}}c[p>>2]=s;while(1){if((c[p>>2]|0)>=((c[k>>2]|0)+(e[(c[l>>2]|0)+80>>1]|0)|0))break;c[o>>2]=c[j>>2];while(1){if((c[o>>2]|0)>=((c[j>>2]|0)+(e[(c[l>>2]|0)+82>>1]|0)|0))break;YK(c[h>>2]|0,c[p>>2]|0,c[o>>2]|0);c[o>>2]=(c[o>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}i=g;return c[k>>2]|0}function eU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+48|0;f=e;g=e+44|0;j=e+40|0;k=e+24|0;l=e+16|0;m=e+8|0;c[g>>2]=b;c[j>>2]=d;c[k+4>>2]=0;c[k>>2]=0;d=k+8|0;FF(m,c[(c[j>>2]|0)+52>>2]|0,c[(c[g>>2]|0)+32>>2]|0);c[d>>2]=c[m>>2];c[d+4>>2]=c[m+4>>2];if((c[k+8>>2]|0)==-1?(c[k+8+4>>2]|0)==-1:0){c[l>>2]=1;c[k+8+4>>2]=0;c[k+8>>2]=0;c[f>>2]=c[(c[g>>2]|0)+32>>2];$z(1,175275,f)|0}else{c[l>>2]=0;a[(c[(c[(c[j>>2]|0)+52>>2]|0)+8>>2]|0)+114>>0]=1}h[c[g>>2]>>3]=+(c[k>>2]|0);h[(c[g>>2]|0)+8>>3]=+(c[k+4>>2]|0);h[(c[g>>2]|0)+16>>3]=+(c[k+8>>2]|0);h[(c[g>>2]|0)+16+8>>3]=+(c[k+8+4>>2]|0);i=e;return c[l>>2]|0}function fU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=d;if((c[(c[f>>2]|0)+4>>2]|0)!=0?(F3(c[(c[f>>2]|0)+4>>2]|0,c[g>>2]|0)|0)==0:0){c[h>>2]=c[f>>2];j=c[h>>2]|0;i=e;return j|0}if((a[(c[f>>2]|0)+88+4>>0]|0)==1){c[h>>2]=OT(c[(c[f>>2]|0)+88>>2]|0,c[g>>2]|0)|0;j=c[h>>2]|0;i=e;return j|0}else{c[h>>2]=0;j=c[h>>2]|0;i=e;return j|0}return 0}function gU(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;zT((c[d>>2]|0)+88|0,0);wT(c[d>>2]|0);O4(c[d>>2]|0);i=b;return}function hU(d,e,f,g,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;j=+j;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;n=i;i=i+192|0;o=n+136|0;p=n+176|0;q=n+172|0;r=n+168|0;s=n+128|0;t=n+164|0;u=n+160|0;v=n+156|0;w=n+120|0;x=n+112|0;y=n+104|0;z=n+48|0;A=n+16|0;B=n;C=n+152|0;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;h[s>>3]=j;c[t>>2]=m;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;h[w>>3]=+h[g>>3];h[x>>3]=+h[w>>3]-+h[s>>3];h[y>>3]=+h[w>>3]+ +h[s>>3];h[B+8>>3]=+h[g+8>>3]+(+h[l+16+8>>3]-+h[l+8>>3])/2.0;lR(c[p>>2]|0,1);c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[q>>2]|0))break;switch(a[(c[r>>2]|0)+((c[u>>2]|0)*24|0)+6>>0]|0){case 108:{h[g>>3]=+h[x>>3];break}case 114:{h[g>>3]=+h[y>>3]-+h[(c[r>>2]|0)+((c[u>>2]|0)*24|0)+8>>3];break}default:h[g>>3]=+h[w>>3]-+h[(c[r>>2]|0)+((c[u>>2]|0)*24|0)+8>>3]/2.0}l=B+8|0;h[l>>3]=+h[l>>3]-+h[(c[r>>2]|0)+((c[u>>2]|0)*24|0)+16>>3];c[C>>2]=c[(c[r>>2]|0)+((c[u>>2]|0)*24|0)>>2];c[v>>2]=0;while(1){if((c[v>>2]|0)>=(b[(c[r>>2]|0)+((c[u>>2]|0)*24|0)+4>>1]|0))break;if((c[(c[C>>2]|0)+4>>2]|0)!=0?+h[(c[(c[C>>2]|0)+4>>2]|0)+16>>3]>0.0:0)h[A+16>>3]=+h[(c[(c[C>>2]|0)+4>>2]|0)+16>>3];else h[A+16>>3]=+h[k+16>>3];if((c[(c[C>>2]|0)+4>>2]|0)!=0?(c[c[(c[C>>2]|0)+4>>2]>>2]|0)!=0:0)c[A>>2]=c[c[(c[C>>2]|0)+4>>2]>>2];else c[A>>2]=c[k>>2];if((c[(c[C>>2]|0)+4>>2]|0)!=0?(c[(c[(c[C>>2]|0)+4>>2]|0)+4>>2]|0)!=0:0)c[A+4>>2]=c[(c[(c[C>>2]|0)+4>>2]|0)+4>>2];else c[A+4>>2]=c[k+4>>2];if((c[(c[C>>2]|0)+4>>2]|0)!=0?(c[(c[(c[C>>2]|0)+4>>2]|0)+24>>2]&127|0)!=0:0){l=A+24|0;c[l>>2]=c[l>>2]&-128|c[(c[(c[C>>2]|0)+4>>2]|0)+24>>2]&127}else{l=A+24|0;c[l>>2]=c[l>>2]&-128}oR(c[p>>2]|0,c[A+4>>2]|0);c[z>>2]=c[c[C>>2]>>2];c[z+4>>2]=A;h[z+16>>3]=+h[(c[C>>2]|0)+16>>3];if(c[t>>2]|0)h[z+24>>3]=+h[(c[C>>2]|0)+24>>3];else h[z+24>>3]=1.0;c[(c[z+4>>2]|0)+8>>2]=c[(c[(c[C>>2]|0)+4>>2]|0)+8>>2];c[z+8>>2]=c[(c[C>>2]|0)+8>>2];h[z+32>>3]=+h[(c[C>>2]|0)+32>>3];h[z+32+8>>3]=+h[(c[r>>2]|0)+((c[u>>2]|0)*24|0)+16>>3];a[z+48>>0]=108;h[B>>3]=+h[g>>3];l=c[p>>2]|0;c[o>>2]=c[B>>2];c[o+4>>2]=c[B+4>>2];c[o+8>>2]=c[B+8>>2];c[o+12>>2]=c[B+12>>2];nR(l,o,z);h[g>>3]=+h[g>>3]+ +h[(c[C>>2]|0)+32>>3];c[C>>2]=(c[C>>2]|0)+56;c[v>>2]=(c[v>>2]|0)+1}c[u>>2]=(c[u>>2]|0)+1}mR(c[p>>2]|0);i=n;return}function iU(e,f,g,h,j,k){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;l=i;i=i+256|0;m=l+8|0;n=l;o=l+88|0;p=l+84|0;q=l+80|0;r=l+76|0;s=l+72|0;t=l+68|0;u=l+64|0;v=l+60|0;w=l+56|0;x=l+40|0;y=l+224|0;z=l+96|0;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;c[s>>2]=k;c[t>>2]=c[(c[o>>2]|0)+16>>2];c[w>>2]=0;c[c[r>>2]>>2]=c[(c[t>>2]|0)+208>>2];c[(c[r>>2]|0)+4>>2]=c[(c[t>>2]|0)+228>>2];c[(c[r>>2]|0)+8>>2]=c[(c[t>>2]|0)+244>>2];c[(c[r>>2]|0)+12>>2]=c[(c[t>>2]|0)+212>>2];a[(c[r>>2]|0)+16>>0]=(b[(c[t>>2]|0)+260>>1]<<15&65535)<<16>>16>>15;c[v>>2]=c[(c[q>>2]|0)+16>>2];if(!((c[v>>2]|0)!=0?(a[c[v>>2]>>0]|0)!=0:0)){dA(x,128,z);if(!(c[(c[p>>2]|0)+60>>2]|0)){z=M3(zH(c[o>>2]|0,c[(c[t>>2]|0)+8>>2]|0,x)|0)|0;c[(c[p>>2]|0)+60>>2]=z;a[(c[p>>2]|0)+64>>0]=1}gA(x,c[(c[p>>2]|0)+60>>2]|0)|0;p=c[22875]|0;c[22875]=p+1;c[n>>2]=p;k3(y,175442,n)|0;gA(x,y)|0;if((c[x+4>>2]|0)>>>0>=(c[x+8>>2]|0)>>>0)eA(x,1)|0;y=x+4|0;n=c[y>>2]|0;c[y>>2]=n+1;a[n>>0]=0;n=c[x>>2]|0;c[x+4>>2]=n;c[v>>2]=n;c[w>>2]=1}c[u>>2]=yH(c[o>>2]|0,0,c[c[q>>2]>>2]|0,c[(c[q>>2]|0)+12>>2]|0,c[(c[q>>2]|0)+8>>2]|0,c[v>>2]|0,c[(c[t>>2]|0)+8>>2]|0)|0;if(c[w>>2]|0)hA(x);if(!(c[u>>2]|0)){A=c[u>>2]|0;i=l;return A|0}do if(c[s>>2]|0){if((c[c[r>>2]>>2]|0)==0?(d[(c[r>>2]|0)+16>>0]|0)==0:0)break;kR(c[o>>2]|0)}while(0);if((c[(c[t>>2]|0)+208>>2]|0)==0?((b[(c[t>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0){A=c[u>>2]|0;i=l;return A|0}r=c[o>>2]|0;c[m>>2]=c[h>>2];c[m+4>>2]=c[h+4>>2];c[m+8>>2]=c[h+8>>2];c[m+12>>2]=c[h+12>>2];c[m+16>>2]=c[h+16>>2];c[m+20>>2]=c[h+20>>2];c[m+24>>2]=c[h+24>>2];c[m+28>>2]=c[h+28>>2];CH(r,m);jR(c[o>>2]|0,c[(c[t>>2]|0)+208>>2]|0,c[(c[t>>2]|0)+228>>2]|0,c[(c[t>>2]|0)+244>>2]|0,c[(c[t>>2]|0)+212>>2]|0);A=c[u>>2]|0;i=l;return A|0}function jU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;f=(IH(c[k>>2]|0,c[n>>2]|0,p)|0)<<24>>24!=0;e=c[j>>2]|0;do if(f){pR(e,c[c[n>>2]>>2]|0);d=c[j>>2]|0;if(c[(c[n>>2]|0)+4>>2]|0)qR(d,c[(c[n>>2]|0)+4>>2]|0,c[l>>2]|0,+g[p>>2]);else qR(d,174917,c[l>>2]|0,+g[p>>2]);if(c[m>>2]&2){c[o>>2]=3;break}else{c[o>>2]=2;break}}else{pR(e,c[k>>2]|0);c[o>>2]=1}while(0);oR(c[j>>2]|0,175430);i=h;return c[o>>2]|0}function kU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;j=e;c[f>>2]=a;c[g>>2]=d;d=c[f>>2]|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];d=(c[f>>2]|0)+32|0;a=b+16|0;c[d>>2]=c[a>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];if((c[g>>2]|0)>1){h[j>>3]=+(c[g>>2]|0)/2.0;g=c[f>>2]|0;h[g>>3]=+h[g>>3]+ +h[j>>3];g=(c[f>>2]|0)+8|0;h[g>>3]=+h[g>>3]+ +h[j>>3];g=(c[f>>2]|0)+32|0;h[g>>3]=+h[g>>3]-+h[j>>3];g=(c[f>>2]|0)+32+8|0;h[g>>3]=+h[g>>3]-+h[j>>3]}h[(c[f>>2]|0)+16>>3]=+h[(c[f>>2]|0)+32>>3];h[(c[f>>2]|0)+16+8>>3]=+h[(c[f>>2]|0)+8>>3];h[(c[f>>2]|0)+48>>3]=+h[c[f>>2]>>3];h[(c[f>>2]|0)+48+8>>3]=+h[(c[f>>2]|0)+32+8>>3];i=e;return c[f>>2]|0}function lU(b,f,g){b=b|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;j=i;i=i+224|0;k=j+112|0;l=j+212|0;m=j+208|0;n=j+204|0;o=j+168|0;p=j+80|0;q=j+64|0;r=j+164|0;s=j+160|0;t=j;u=j+152|0;v=j+144|0;c[l>>2]=b;c[m>>2]=f;c[n>>2]=g;g=(c[m>>2]|0)+48|0;c[p>>2]=c[g>>2];c[p+4>>2]=c[g+4>>2];c[p+8>>2]=c[g+8>>2];c[p+12>>2]=c[g+12>>2];c[p+16>>2]=c[g+16>>2];c[p+20>>2]=c[g+20>>2];c[p+24>>2]=c[g+24>>2];c[p+28>>2]=c[g+28>>2];g=c[n>>2]|0;c[q>>2]=c[g>>2];c[q+4>>2]=c[g+4>>2];c[q+8>>2]=c[g+8>>2];c[q+12>>2]=c[g+12>>2];if(c[c[m>>2]>>2]|0)w=1;else w=(c[(c[m>>2]|0)+8>>2]|0)!=0;c[s>>2]=w&1;h[p>>3]=+h[p>>3]+ +h[q>>3];w=p+16|0;h[w>>3]=+h[w>>3]+ +h[q>>3];w=p+8|0;h[w>>3]=+h[w>>3]+ +h[q+8>>3];w=p+16+8|0;h[w>>3]=+h[w>>3]+ +h[q+8>>3];if((c[s>>2]|0)!=0?(c[(c[l>>2]|0)+152>>2]&4|0)==0:0){q=c[l>>2]|0;w=c[n>>2]|0;g=c[m>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];c[k+16>>2]=c[p+16>>2];c[k+20>>2]=c[p+20>>2];c[k+24>>2]=c[p+24>>2];c[k+28>>2]=c[p+28>>2];c[r>>2]=iU(q,w,g,k,o,1)|0}else c[r>>2]=0;do if(!(e[(c[m>>2]|0)+42>>1]&32)){if(c[(c[m>>2]|0)+20>>2]|0){c[v>>2]=jU(c[l>>2]|0,c[(c[m>>2]|0)+20>>2]|0,c[(c[m>>2]|0)+28>>2]|0,e[(c[m>>2]|0)+42>>1]|0,u)|0;g=c[l>>2]|0;if(e[(c[m>>2]|0)+42>>1]&4){w=d[(c[m>>2]|0)+33>>0]|0;c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];c[k+16>>2]=c[p+16>>2];c[k+20>>2]=c[p+20>>2];c[k+24>>2]=c[p+24>>2];c[k+28>>2]=c[p+28>>2];q=kU(t,k,w)|0;cM(g,q,4,4,c[v>>2]|0)}else{q=c[v>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];c[k+16>>2]=c[p+16>>2];c[k+20>>2]=c[p+20>>2];c[k+24>>2]=c[p+24>>2];c[k+28>>2]=c[p+28>>2];uR(g,k,q)}O4(c[u>>2]|0)}if(a[(c[m>>2]|0)+33>>0]|0){q=c[l>>2]|0;g=c[m>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];c[k+16>>2]=c[p+16>>2];c[k+20>>2]=c[p+20>>2];c[k+24>>2]=c[p+24>>2];c[k+28>>2]=c[p+28>>2];nU(q,g,k)}if((a[(c[m>>2]|0)+88+4>>0]|0)==1){KT(c[l>>2]|0,c[(c[m>>2]|0)+88>>2]|0,c[n>>2]|0);break}g=c[l>>2]|0;q=(c[m>>2]|0)+88|0;if((a[(c[m>>2]|0)+88+4>>0]|0)==3){qU(g,c[q>>2]|0,c[n>>2]|0);break}else{LT(g,c[q>>2]|0,c[n>>2]|0);break}}while(0);if(c[r>>2]|0)oU(c[l>>2]|0,o,1);if(!(c[s>>2]|0)){i=j;return}if(!(c[(c[l>>2]|0)+152>>2]&4)){i=j;return}s=c[l>>2]|0;r=c[n>>2]|0;n=c[m>>2]|0;c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];c[k+16>>2]=c[p+16>>2];c[k+20>>2]=c[p+20>>2];c[k+24>>2]=c[p+24>>2];c[k+28>>2]=c[p+28>>2];if(!(iU(s,r,n,k,o,0)|0)){i=j;return}oU(c[l>>2]|0,o,0);i=j;return}function mU(b,f,g,j,k){b=b|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0;l=i;i=i+112|0;m=l+72|0;n=l+104|0;o=l+100|0;p=l+96|0;q=l+92|0;r=l+88|0;s=l+56|0;t=l+48|0;u=l+108|0;v=l+16|0;w=l;c[n>>2]=b;c[o>>2]=f;c[p>>2]=g;c[q>>2]=j;c[r>>2]=k;k=(c[o>>2]|0)+48|0;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[v+8>>2]=c[k+8>>2];c[v+12>>2]=c[k+12>>2];c[v+16>>2]=c[k+16>>2];c[v+20>>2]=c[k+20>>2];c[v+24>>2]=c[k+24>>2];c[v+28>>2]=c[k+28>>2];k=c[p>>2]|0;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[w+12>>2]=c[k+12>>2];if(!(c[q>>2]|0))c[q>>2]=174917;pR(c[n>>2]|0,c[q>>2]|0);oR(c[n>>2]|0,c[q>>2]|0);q=(c[o>>2]|0)+48|0;c[v>>2]=c[q>>2];c[v+4>>2]=c[q+4>>2];c[v+8>>2]=c[q+8>>2];c[v+12>>2]=c[q+12>>2];c[v+16>>2]=c[q+16>>2];c[v+20>>2]=c[q+20>>2];c[v+24>>2]=c[q+24>>2];c[v+28>>2]=c[q+28>>2];h[v>>3]=+h[v>>3]+ +h[w>>3];q=v+16|0;h[q>>3]=+h[q>>3]+ +h[w>>3];q=v+8|0;h[q>>3]=+h[q>>3]+ +h[w+8>>3];q=v+16+8|0;h[q>>3]=+h[q>>3]+ +h[w+8>>3];if((d[(c[o>>2]|0)+100>>0]&1|0)!=0?((e[(c[o>>2]|0)+84>>1]|0)+(e[(c[o>>2]|0)+80>>1]|0)|0)<(c[(c[(c[o>>2]|0)+96>>2]|0)+104>>2]|0):0){q=c[o>>2]|0;do if(e[(c[o>>2]|0)+86>>1]|0)if(((e[q+86>>1]|0)+(e[(c[o>>2]|0)+82>>1]|0)|0)==(c[(c[(c[o>>2]|0)+96>>2]|0)+100>>2]|0)){a[u>>0]=(d[(c[(c[o>>2]|0)+96>>2]|0)+33>>0]|0)+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0);h[s+8>>3]=+h[v+8>>3]-+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0)-+(d[u>>0]|0);break}else{a[u>>0]=0;h[s+8>>3]=+h[v+8>>3]-+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0);break}else{a[u>>0]=(d[(c[q+96>>2]|0)+33>>0]|0)+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0);h[s+8>>3]=+h[v+8>>3]-+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0)}while(0);h[s>>3]=+h[v+16>>3]+ +((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0);h[t>>3]=+(d[u>>0]|0)+ +h[v+16+8>>3]-+h[v+8>>3]+ +(a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0);q=c[n>>2]|0;x=+h[t>>3];c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];pU(q,m,0.0,x)}if(!(d[(c[o>>2]|0)+100>>0]&2)){i=l;return}if(((e[(c[o>>2]|0)+86>>1]|0)+(e[(c[o>>2]|0)+82>>1]|0)|0)>=(c[(c[(c[o>>2]|0)+96>>2]|0)+100>>2]|0)){i=l;return}q=c[o>>2]|0;do if(!(e[(c[o>>2]|0)+84>>1]|0)){a[u>>0]=(d[(c[q+96>>2]|0)+33>>0]|0)+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0);h[s>>3]=+h[v>>3]-+(d[u>>0]|0)-+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0);if(((e[(c[o>>2]|0)+84>>1]|0)+(e[(c[o>>2]|0)+80>>1]|0)|0)==(c[(c[(c[o>>2]|0)+96>>2]|0)+104>>2]|0)){a[u>>0]=d[u>>0]<<1;break}if((c[r>>2]|0)!=0?(e[(c[r>>2]|0)+86>>1]|0)!=(e[(c[o>>2]|0)+86>>1]|0):0)a[u>>0]=~~(+(d[u>>0]|0)+(+h[(c[(c[o>>2]|0)+96>>2]|0)+48+16>>3]+ +h[w>>3]-(+h[v+16>>3]+ +((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0))))}else{if(((e[q+84>>1]|0)+(e[(c[o>>2]|0)+80>>1]|0)|0)==(c[(c[(c[o>>2]|0)+96>>2]|0)+104>>2]|0)){a[u>>0]=(d[(c[(c[o>>2]|0)+96>>2]|0)+33>>0]|0)+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0);h[s>>3]=+h[v>>3]-+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0);break}a[u>>0]=0;h[s>>3]=+h[v>>3]-+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0);if((c[r>>2]|0)!=0?(e[(c[r>>2]|0)+86>>1]|0)!=(e[(c[o>>2]|0)+86>>1]|0):0)a[u>>0]=~~(+(d[u>>0]|0)+(+h[(c[(c[o>>2]|0)+96>>2]|0)+48+16>>3]+ +h[w>>3]-(+h[v+16>>3]+ +((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0))))}while(0);h[s+8>>3]=+h[v+8>>3]-+((a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0)/2|0|0);h[t>>3]=+(d[u>>0]|0)+ +h[v+16>>3]-+h[v>>3]+ +(a[(c[(c[o>>2]|0)+96>>2]|0)+32>>0]|0);o=c[n>>2]|0;x=+h[t>>3];c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];pU(o,m,x,0.0);i=l;return}function nU(a,f,g){a=a|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+176|0;k=j+104|0;l=j+156|0;m=j+152|0;n=j+8|0;o=j+144|0;p=j+136|0;q=j+160|0;r=j;c[l>>2]=a;c[m>>2]=f;if(c[(c[m>>2]|0)+24>>2]|0)s=c[(c[m>>2]|0)+24>>2]|0;else s=174917;c[p>>2]=s;oR(c[l>>2]|0,c[p>>2]|0);if((e[(c[m>>2]|0)+42>>1]|0)&384){c[o+4>>2]=0;c[o>>2]=0;if(!((e[(c[m>>2]|0)+42>>1]|0)&256)){if((e[(c[m>>2]|0)+42>>1]|0)&128)c[o>>2]=175390}else c[o>>2]=175383;rR(c[l>>2]|0,o)}else rR(c[l>>2]|0,c[(c[c[l>>2]>>2]|0)+336>>2]|0);zR(c[l>>2]|0,+(d[(c[m>>2]|0)+33>>0]|0));if((e[(c[m>>2]|0)+42>>1]|0)&4){o=c[l>>2]|0;p=d[(c[m>>2]|0)+33>>0]|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];c[k+28>>2]=c[g+28>>2];cM(o,kU(n,k,p)|0,4,4,0);i=j;return}p=(e[(c[m>>2]|0)+36>>1]|0)&15360;b[q>>1]=p;if(!(p<<16>>16)){if((d[(c[m>>2]|0)+33>>0]|0|0)>1){h[r>>3]=+(d[(c[m>>2]|0)+33>>0]|0)/2.0;h[g>>3]=+h[g>>3]+ +h[r>>3];p=g+8|0;h[p>>3]=+h[p>>3]+ +h[r>>3];p=g+16|0;h[p>>3]=+h[p>>3]-+h[r>>3];p=g+16+8|0;h[p>>3]=+h[p>>3]-+h[r>>3]}r=c[l>>2]|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];c[k+28>>2]=c[g+28>>2];uR(r,k,0);i=j;return}r=d[(c[m>>2]|0)+33>>0]|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2];c[k+24>>2]=c[g+24>>2];c[k+28>>2]=c[g+28>>2];kU(n+16|0,k,r)|0;r=e[q>>1]|0;if((r|0)<8192)switch(r|0){case 4096:{wR(c[l>>2]|0,n+32|0,2);i=j;return}case 2048:{wR(c[l>>2]|0,n+48|0,2);i=j;return}case 1024:{q=n+64|0;c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];wR(c[l>>2]|0,n,2);i=j;return}case 6144:{wR(c[l>>2]|0,n+32|0,3);i=j;return}case 3072:{q=n+80|0;k=n+16|0;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];c[q+8>>2]=c[k+8>>2];c[q+12>>2]=c[k+12>>2];wR(c[l>>2]|0,n+48|0,3);i=j;return}case 7168:{k=n+80|0;q=n+16|0;c[k>>2]=c[q>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];wR(c[l>>2]|0,n+32|0,4);i=j;return}case 5120:{q=n+64|0;c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];i=j;return}default:{i=j;return}}else switch(r|0){case 8192:{wR(c[l>>2]|0,n+16|0,2);i=j;return}case 12288:{wR(c[l>>2]|0,n+16|0,3);i=j;return}case 9216:{r=n+64|0;c[n>>2]=c[r>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];wR(c[l>>2]|0,n,3);i=j;return}case 14336:{wR(c[l>>2]|0,n+16|0,4);i=j;return}case 11264:{r=n+80|0;q=n+16|0;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=n+96|0;r=n+32|0;c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];wR(c[l>>2]|0,n+48|0,4);i=j;return}case 13312:{r=n+64|0;c[n>>2]=c[r>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];wR(c[l>>2]|0,n,4);i=j;return}case 10240:{wR(c[l>>2]|0,n+16|0,2);wR(c[l>>2]|0,n+48|0,2);i=j;return}default:{i=j;return}}}function oU(a,e,f){a=a|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[h>>2]=a;c[j>>2]=e;c[k>>2]=f;c[l>>2]=c[(c[h>>2]|0)+16>>2];if(!((c[(c[l>>2]|0)+208>>2]|0)==0?((b[(c[l>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0))kR(c[h>>2]|0);if((c[(c[l>>2]|0)+208>>2]|0)!=(c[c[j>>2]>>2]|0)){O4(c[(c[l>>2]|0)+208>>2]|0);c[(c[l>>2]|0)+208>>2]=c[c[j>>2]>>2]}if((c[(c[l>>2]|0)+228>>2]|0)!=(c[(c[j>>2]|0)+4>>2]|0)){O4(c[(c[l>>2]|0)+228>>2]|0);c[(c[l>>2]|0)+228>>2]=c[(c[j>>2]|0)+4>>2]}if((c[(c[l>>2]|0)+244>>2]|0)!=(c[(c[j>>2]|0)+8>>2]|0)){O4(c[(c[l>>2]|0)+244>>2]|0);c[(c[l>>2]|0)+244>>2]=c[(c[j>>2]|0)+8>>2]}if((c[(c[l>>2]|0)+212>>2]|0)!=(c[(c[j>>2]|0)+12>>2]|0)){O4(c[(c[l>>2]|0)+212>>2]|0);c[(c[l>>2]|0)+212>>2]=c[(c[j>>2]|0)+12>>2]}f=(c[l>>2]|0)+260|0;b[f>>1]=b[f>>1]&-2|(d[(c[j>>2]|0)+16>>0]|0)&1;if(!(c[k>>2]|0)){i=g;return}if((c[(c[l>>2]|0)+208>>2]|0)==0?((b[(c[l>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)==0:0){i=g;return}jR(c[h>>2]|0,c[(c[l>>2]|0)+208>>2]|0,c[(c[l>>2]|0)+228>>2]|0,c[(c[l>>2]|0)+244>>2]|0,c[(c[l>>2]|0)+212>>2]|0);i=g;return}function pU(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+96|0;g=f+48|0;j=f+80|0;k=f+40|0;l=f+32|0;m=f;c[j>>2]=a;h[k>>3]=d;h[l>>3]=e;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];h[m+16>>3]=+h[b>>3]+ +h[k>>3];h[m+16+8>>3]=+h[b+8>>3]+ +h[l>>3];l=c[j>>2]|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];c[g+16>>2]=c[m+16>>2];c[g+20>>2]=c[m+20>>2];c[g+24>>2]=c[m+24>>2];c[g+28>>2]=c[m+28>>2];uR(l,g,1);i=f;return}function qU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+112|0;g=f+108|0;j=f+104|0;k=f+100|0;l=f+32|0;m=f;n=f+96|0;c[g>>2]=b;c[j>>2]=d;c[k>>2]=e;e=c[j>>2]|0;c[m>>2]=c[e>>2];c[m+4>>2]=c[e+4>>2];c[m+8>>2]=c[e+8>>2];c[m+12>>2]=c[e+12>>2];c[m+16>>2]=c[e+16>>2];c[m+20>>2]=c[e+20>>2];c[m+24>>2]=c[e+24>>2];c[m+28>>2]=c[e+28>>2];h[m>>3]=+h[m>>3]+ +h[c[k>>2]>>3];e=m+8|0;h[e>>3]=+h[e>>3]+ +h[(c[k>>2]|0)+8>>3];e=m+16|0;h[e>>3]=+h[e>>3]+ +h[c[k>>2]>>3];e=m+16+8|0;h[e>>3]=+h[e>>3]+ +h[(c[k>>2]|0)+8>>3];e=m+16|0;c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];e=l+32|0;c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];h[l+16>>3]=+h[l+32>>3];h[l+16+8>>3]=+h[l+8>>3];h[l+48>>3]=+h[l>>3];h[l+48+8>>3]=+h[l+32+8>>3];if(c[(c[j>>2]|0)+36>>2]|0)c[n>>2]=c[(c[j>>2]|0)+36>>2];else c[n>>2]=c[(c[k>>2]|0)+56>>2];if(!(c[(c[j>>2]|0)+32>>2]|0))La(175397,175072,627,175405);if(a[c[(c[j>>2]|0)+32>>2]>>0]|0){yR(c[g>>2]|0,c[(c[j>>2]|0)+32>>2]|0,l,4,1,c[n>>2]|0);i=f;return}else La(175419,175072,628,175405)}function rU(){return Nz(91504,c[12989]|0)|0}function sU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[f>>2];Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,g,1)|0;i=d;return}function tU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=(Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,f,512)|0)!=0&1;i=d;return b|0}function uU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=e;c[e+12>>2]=a;c[f>>2]=b;c[e+4>>2]=d;c[g>>2]=bK(12)|0;c[c[g>>2]>>2]=c[c[f>>2]>>2];i=e;return c[g>>2]|0}function vU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function wU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+32|0;g=f+16|0;h=f+8|0;j=f+4|0;c[f+12>>2]=a;c[h>>2]=b;c[j>>2]=d;c[f>>2]=e;do if((c[c[h>>2]>>2]|0)<=(c[c[j>>2]>>2]|0))if((c[c[h>>2]>>2]|0)<(c[c[j>>2]>>2]|0)){c[g>>2]=-1;break}else{c[g>>2]=0;break}else c[g>>2]=1;while(0);i=f;return c[g>>2]|0}function xU(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(c[22885]|0){c[22897]=0;i=b;return}c[22885]=bK((c[d>>2]|0)+1<<2)|0;c[c[22885]>>2]=91544;c[22896]=c[d>>2];c[22897]=0;i=b;return}function yU(){O4(c[22885]|0);c[22885]=0;c[22897]=0;return}function zU(){c[22897]=0;return}function AU(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a;c[b>>2]=1;while(1){if((c[b>>2]|0)>(c[22897]|0)){d=6;break}if((c[(c[(c[22885]|0)+(c[b>>2]<<2)>>2]|0)+4>>2]|0)!=(c[b>>2]|0)){d=4;break}c[b>>2]=(c[b>>2]|0)+1}if((d|0)==4)La(176099,175446,61,175452);else if((d|0)==6){i=a;return}}function BU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[e>>2]=c[(c[22885]|0)+(c[d>>2]<<2)>>2];c[f>>2]=c[c[e>>2]>>2];c[g>>2]=(c[d>>2]|0)/2|0;while(1){a=c[(c[22885]|0)+(c[g>>2]<<2)>>2]|0;c[h>>2]=a;if((c[a>>2]|0)>=(c[f>>2]|0))break;c[(c[22885]|0)+(c[d>>2]<<2)>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=c[d>>2];c[d>>2]=c[g>>2];c[g>>2]=(c[g>>2]|0)/2|0}c[(c[22885]|0)+(c[d>>2]<<2)>>2]=c[e>>2];c[(c[e>>2]|0)+4>>2]=c[d>>2];i=b;return}function CU(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;c[e>>2]=a;if((c[22897]|0)==(c[22896]|0)){$z(1,175460,b)|0;c[d>>2]=1;f=c[d>>2]|0;i=b;return f|0}else{c[22897]=(c[22897]|0)+1;c[(c[22885]|0)+(c[22897]<<2)>>2]=c[e>>2];BU(c[22897]|0);AU();c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}return 0}function DU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[e>>2]=c[(c[22885]|0)+(c[d>>2]<<2)>>2];c[f>>2]=c[c[e>>2]>>2];c[g>>2]=(c[22897]|0)/2|0;while(1){if((c[d>>2]|0)>(c[g>>2]|0)){k=8;break}c[j>>2]=(c[d>>2]|0)+(c[d>>2]|0);c[h>>2]=c[(c[22885]|0)+(c[j>>2]<<2)>>2];if((c[j>>2]|0)<(c[22897]|0)?(c[c[h>>2]>>2]|0)<(c[c[(c[22885]|0)+((c[j>>2]|0)+1<<2)>>2]>>2]|0):0){c[j>>2]=(c[j>>2]|0)+1;c[h>>2]=c[(c[22885]|0)+(c[j>>2]<<2)>>2]}if((c[f>>2]|0)>=(c[c[h>>2]>>2]|0)){k=8;break}c[(c[22885]|0)+(c[d>>2]<<2)>>2]=c[h>>2];c[(c[h>>2]|0)+4>>2]=c[d>>2];c[d>>2]=c[j>>2]}if((k|0)==8){c[(c[22885]|0)+(c[d>>2]<<2)>>2]=c[e>>2];c[(c[e>>2]|0)+4>>2]=c[d>>2];i=b;return}}function EU(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;if(!(c[22897]|0)){c[b>>2]=0;e=c[b>>2]|0;i=a;return e|0}c[d>>2]=c[(c[22885]|0)+4>>2];c[(c[22885]|0)+4>>2]=c[(c[22885]|0)+(c[22897]<<2)>>2];c[22897]=(c[22897]|0)+-1;if(c[22897]|0)DU(1);AU();c[b>>2]=c[d>>2];e=c[b>>2]|0;i=a;return e|0}function FU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[e>>2]>>2]=c[f>>2];BU(c[(c[e>>2]|0)+4>>2]|0);AU();i=d;return}function GU(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+48|0;g=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=e;c[n>>2]=(d[(c[(c[g>>2]|0)+16>>2]|0)+((c[(c[k>>2]|0)+12>>2]|0)*40|0)+36>>0]|0|0)!=(d[(c[(c[g>>2]|0)+16>>2]|0)+((c[(c[k>>2]|0)+16>>2]|0)*40|0)+36>>0]|0|0)&1;c[o>>2]=~~((+h[(c[j>>2]|0)+40+16+8>>3]-+h[(c[j>>2]|0)+40+8>>3]-3.0)/2.0);c[p>>2]=~~((+h[(c[j>>2]|0)+40+16>>3]-+h[(c[j>>2]|0)+40>>3]-3.0)/2.0);c[q>>2]=(c[o>>2]|0)<(c[p>>2]|0)?c[o>>2]|0:c[p>>2]|0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break;c[m>>2]=c[(c[j>>2]|0)+8+(c[l>>2]<<2)>>2];if((d[(c[(c[g>>2]|0)+16>>2]|0)+((c[(c[m>>2]|0)+12>>2]|0)*40|0)+36>>0]|0|0)==(d[(c[(c[g>>2]|0)+16>>2]|0)+((c[(c[m>>2]|0)+16>>2]|0)*40|0)+36>>0]|0|0))break;JU(c[j>>2]|0,c[m>>2]|0,c[q>>2]|0);c[l>>2]=(c[l>>2]|0)+1}while(1){if((c[l>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break;c[m>>2]=c[(c[j>>2]|0)+8+(c[l>>2]<<2)>>2];if(!((c[n>>2]|0)==0?(c[m>>2]|0)!=(c[k>>2]|0):0))JU(c[j>>2]|0,c[m>>2]|0,(d[(c[(c[g>>2]|0)+16>>2]|0)+((c[(c[m>>2]|0)+12>>2]|0)*40|0)+36>>0]|0|0)!=0?c[o>>2]|0:c[p>>2]|0);c[l>>2]=(c[l>>2]|0)+1}i=f;return}function HU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;d=i;i=i+144|0;e=d+80|0;f=d+140|0;g=d+132|0;j=d+128|0;k=d+124|0;l=d+120|0;m=d+116|0;n=d+112|0;o=d+72|0;p=d+64|0;q=d+32|0;r=d;c[f>>2]=a;c[d+136>>2]=b;c[j>>2]=bK(28)|0;b=kB(c[f>>2]|0)|0;c[(c[j>>2]|0)+4>>2]=b;b=bK((c[(c[j>>2]|0)+4>>2]|0)*72|0)|0;c[(c[j>>2]|0)+12>>2]=b;c[n>>2]=b;h[r+8>>3]=1797693134862315708145274.0e284;h[r>>3]=1797693134862315708145274.0e284;h[r+16+8>>3]=-1797693134862315708145274.0e284;h[r+16>>3]=-1797693134862315708145274.0e284;c[g>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;h[o>>3]=(+h[(c[(c[g>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+96>>3])/2.0;if(+h[o>>3]<1.0)h[o>>3]=1.0;h[p>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+80>>3]/2.0;if(+h[p>>3]<1.0)h[p>>3]=1.0;h[q>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3]-+h[o>>3];h[q+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3]+ +h[o>>3];h[q+8>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3]-+h[p>>3];h[q+16+8>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3]+ +h[p>>3];h[r>>3]=+h[r>>3]<+h[q>>3]?+h[r>>3]:+h[q>>3];h[r+8>>3]=+h[r+8>>3]<+h[q+8>>3]?+h[r+8>>3]:+h[q+8>>3];h[r+16>>3]=+h[r+16>>3]>+h[q+16>>3]?+h[r+16>>3]:+h[q+16>>3];if(+h[r+16+8>>3]>+h[q+16+8>>3])s=+h[r+16+8>>3];else s=+h[q+16+8>>3];h[r+16+8>>3]=s;b=(c[n>>2]|0)+40|0;c[b>>2]=c[q>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];c[b+12>>2]=c[q+12>>2];c[b+16>>2]=c[q+16>>2];c[b+20>>2]=c[q+20>>2];c[b+24>>2]=c[q+24>>2];c[b+28>>2]=c[q+28>>2];b=c[n>>2]|0;c[b>>2]=c[b>>2]|1;c[(c[(c[g>>2]|0)+8>>2]|0)+112>>2]=c[n>>2];c[n>>2]=(c[n>>2]|0)+72;c[g>>2]=aC(c[f>>2]|0,c[g>>2]|0)|0}h[r>>3]=+h[r>>3]-36.0;g=r+8|0;h[g>>3]=+h[g>>3]-36.0;g=r+16|0;h[g>>3]=+h[g>>3]+36.0;g=r+16+8|0;h[g>>3]=+h[g>>3]+36.0;g=c[(c[j>>2]|0)+12>>2]|0;f=c[(c[j>>2]|0)+4>>2]|0;c[e>>2]=c[r>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];c[e+12>>2]=c[r+12>>2];c[e+16>>2]=c[r+16>>2];c[e+20>>2]=c[r+20>>2];c[e+24>>2]=c[r+24>>2];c[e+28>>2]=c[r+28>>2];c[k>>2]=SU(g,f,m,e)|0;if(c[15244]&1){f=c[(c[j>>2]|0)+12>>2]|0;g=c[(c[j>>2]|0)+4>>2]|0;n=c[k>>2]|0;q=c[m>>2]|0;c[e>>2]=c[r>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];c[e+12>>2]=c[r+12>>2];c[e+16>>2]=c[r+16>>2];c[e+20>>2]=c[r+20>>2];c[e+24>>2]=c[r+24>>2];c[e+28>>2]=c[r+28>>2];KU(f,g,e,n,q)}q=bK((c[m>>2]|0)*72|0)|0;c[(c[j>>2]|0)+8>>2]=q;c[c[j>>2]>>2]=c[m>>2];c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[m>>2]|0))break;q=(c[(c[j>>2]|0)+8>>2]|0)+((c[l>>2]|0)*72|0)+40|0;n=(c[k>>2]|0)+(c[l>>2]<<5)|0;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[q+16>>2]=c[n+16>>2];c[q+20>>2]=c[n+20>>2];c[q+24>>2]=c[n+24>>2];c[q+28>>2]=c[n+28>>2];c[l>>2]=(c[l>>2]|0)+1}O4(c[k>>2]|0);k=c[j>>2]|0;c[e>>2]=c[r>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];c[e+12>>2]=c[r+12>>2];c[e+16>>2]=c[r+16>>2];c[e+20>>2]=c[r+20>>2];c[e+24>>2]=c[r+24>>2];c[e+28>>2]=c[r+28>>2];r=LU(k,e)|0;c[(c[j>>2]|0)+16>>2]=r;i=d;return c[j>>2]|0}function IU(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[(c[d>>2]|0)+8>>2]|0)+36>>2]|0);O4(c[(c[(c[d>>2]|0)+12>>2]|0)+36>>2]|0);O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[(c[d>>2]|0)+12>>2]|0);MQ(c[(c[d>>2]|0)+16>>2]|0);Jz(c[(c[d>>2]|0)+20>>2]|0)|0;Jz(c[(c[d>>2]|0)+24>>2]|0)|0;O4(c[d>>2]|0);i=b;return}function JU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[e+8>>2]=a;c[f>>2]=b;c[g>>2]=d;d=(c[f>>2]|0)+8|0;c[d>>2]=(c[d>>2]|0)+1;if((c[(c[f>>2]|0)+8>>2]|0)<=(c[g>>2]|0)){i=e;return}c[(c[f>>2]|0)+8>>2]=0;g=c[f>>2]|0;h[g>>3]=+h[g>>3]+16384.0;i=e;return}function KU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0;g=i;i=i+208|0;j=g+128|0;k=g+96|0;l=g+64|0;m=g+48|0;n=g+32|0;o=g+192|0;p=g+188|0;q=g+184|0;r=g+180|0;s=g+176|0;t=g;u=g+160|0;c[o>>2]=a;c[p>>2]=b;c[q>>2]=e;c[r>>2]=f;c[u>>2]=10;c[u+4>>2]=10;c[u+8>>2]=~~(+(c[u>>2]|0)+ +h[d+16>>3]-+h[d>>3]);c[u+8+4>>2]=~~(+(c[u+4>>2]|0)+ +h[d+16+8>>3]-+h[d+8>>3]);_2(c[22898]|0,c[24742]|0)|0;f=c[24742]|0;e=c[u+4>>2]|0;b=c[u+8>>2]|0;a=c[u+8+4>>2]|0;c[n>>2]=c[u>>2];c[n+4>>2]=e;c[n+8>>2]=b;c[n+12>>2]=a;Y2(f,175905,n)|0;n=c[24742]|0;v=10.0-+h[d+8>>3];h[m>>3]=10.0-+h[d>>3];h[m+8>>3]=v;Y2(n,175953,m)|0;_2(175970,c[24742]|0)|0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[p>>2]|0))break;m=(c[o>>2]|0)+((c[s>>2]|0)*72|0)+40|0;c[t>>2]=c[m>>2];c[t+4>>2]=c[m+4>>2];c[t+8>>2]=c[m+8>>2];c[t+12>>2]=c[m+12>>2];c[t+16>>2]=c[m+16>>2];c[t+20>>2]=c[m+20>>2];c[t+24>>2]=c[m+24>>2];c[t+28>>2]=c[m+28>>2];m=c[24742]|0;v=+h[t+8>>3];w=+h[t+16>>3];x=+h[t+16+8>>3];h[l>>3]=+h[t>>3];h[l+8>>3]=v;h[l+16>>3]=w;h[l+24>>3]=x;Y2(m,175989,l)|0;c[s>>2]=(c[s>>2]|0)+1}_2(176007,c[24742]|0)|0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[r>>2]|0))break;l=(c[q>>2]|0)+(c[s>>2]<<5)|0;c[t>>2]=c[l>>2];c[t+4>>2]=c[l+4>>2];c[t+8>>2]=c[l+8>>2];c[t+12>>2]=c[l+12>>2];c[t+16>>2]=c[l+16>>2];c[t+20>>2]=c[l+20>>2];c[t+24>>2]=c[l+24>>2];c[t+28>>2]=c[l+28>>2];l=c[24742]|0;x=+h[t+8>>3];w=+h[t+16>>3];v=+h[t+16+8>>3];h[k>>3]=+h[t>>3];h[k+8>>3]=x;h[k+16>>3]=w;h[k+24>>3]=v;Y2(l,176026,k)|0;c[s>>2]=(c[s>>2]|0)+1}_2(176044,c[24742]|0)|0;s=c[24742]|0;v=+h[d+8>>3];w=+h[d+16>>3];x=+h[d+16+8>>3];h[j>>3]=+h[d>>3];h[j+8>>3]=v;h[j+16>>3]=w;h[j+24>>3]=x;Y2(s,176026,j)|0;_2(c[22899]|0,c[24742]|0)|0;i=g;return}function LU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+128|0;e=d+32|0;f=d+112|0;g=d+108|0;j=d+104|0;k=d+96|0;l=d+92|0;m=d+88|0;n=d+84|0;o=d+80|0;p=d+76|0;q=d+72|0;r=d+68|0;s=d+64|0;t=d+16|0;u=d+60|0;v=d;w=d+56|0;x=d+52|0;y=d+48|0;c[f>>2]=a;c[l>>2]=c[c[f>>2]>>2]<<2;c[m>>2]=JQ((c[l>>2]|0)+2|0)|0;c[n>>2]=Nz(91600,c[12989]|0)|0;c[o>>2]=Nz(91636,c[12989]|0)|0;c[p>>2]=bK(c[l>>2]<<5)|0;c[q>>2]=bK(c[c[f>>2]>>2]<<2<<2)|0;c[d+100>>2]=0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[c[f>>2]>>2]|0))break;c[r>>2]=(c[(c[f>>2]|0)+8>>2]|0)+((c[j>>2]|0)*72|0);c[(c[r>>2]|0)+32>>2]=4;c[(c[r>>2]|0)+36>>2]=(c[q>>2]|0)+(c[j>>2]<<2<<2);if(+h[(c[r>>2]|0)+40+16>>3]<+h[b+16>>3]){h[t>>3]=+h[(c[r>>2]|0)+40+16>>3];h[t+8>>3]=+h[(c[r>>2]|0)+40+8>>3];l=c[m>>2]|0;a=c[n>>2]|0;z=c[p>>2]|0;c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[e+12>>2]=c[t+12>>2];c[s>>2]=MU(l,a,e,z,1)|0;c[(c[s>>2]|0)+20>>2]=c[r>>2];c[c[(c[r>>2]|0)+36>>2]>>2]=c[s>>2]}if(+h[(c[r>>2]|0)+40+16+8>>3]<+h[b+16+8>>3]){h[t>>3]=+h[(c[r>>2]|0)+40>>3];h[t+8>>3]=+h[(c[r>>2]|0)+40+16+8>>3];z=c[m>>2]|0;a=c[o>>2]|0;l=c[p>>2]|0;c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[e+12>>2]=c[t+12>>2];c[s>>2]=MU(z,a,e,l,0)|0;c[(c[s>>2]|0)+20>>2]=c[r>>2];c[(c[(c[r>>2]|0)+36>>2]|0)+4>>2]=c[s>>2]}if(+h[(c[r>>2]|0)+40>>3]>+h[b>>3]){l=c[m>>2]|0;a=c[n>>2]|0;z=(c[r>>2]|0)+40|0;A=c[p>>2]|0;c[e>>2]=c[z>>2];c[e+4>>2]=c[z+4>>2];c[e+8>>2]=c[z+8>>2];c[e+12>>2]=c[z+12>>2];c[s>>2]=MU(l,a,e,A,1)|0;c[(c[s>>2]|0)+20+4>>2]=c[r>>2];c[(c[(c[r>>2]|0)+36>>2]|0)+8>>2]=c[s>>2]}if(+h[(c[r>>2]|0)+40+8>>3]>+h[b+8>>3]){A=c[m>>2]|0;a=c[o>>2]|0;l=(c[r>>2]|0)+40|0;z=c[p>>2]|0;c[e>>2]=c[l>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[e+12>>2]=c[l+12>>2];c[s>>2]=MU(A,a,e,z,0)|0;c[(c[s>>2]|0)+20+4>>2]=c[r>>2];c[(c[(c[r>>2]|0)+36>>2]|0)+12>>2]=c[s>>2]}c[j>>2]=(c[j>>2]|0)+1}c[k>>2]=0;c[q>>2]=bK(c[c[m>>2]>>2]<<2)|0;c[g>>2]=0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;c[u>>2]=(c[(c[f>>2]|0)+12>>2]|0)+((c[j>>2]|0)*72|0);c[(c[u>>2]|0)+36>>2]=(c[q>>2]|0)+(c[g>>2]<<2);s=(c[u>>2]|0)+40|0;c[v>>2]=c[s>>2];c[v+4>>2]=c[s+4>>2];c[v+8>>2]=c[s+8>>2];c[v+12>>2]=c[s+12>>2];c[w>>2]=Hb[c[c[o>>2]>>2]&63](c[o>>2]|0,v,512)|0;while(1){if(!(c[w>>2]|0))break;if(!(+h[(c[w>>2]|0)+8>>3]<+h[(c[u>>2]|0)+40+16>>3]))break;s=c[c[w>>2]>>2]|0;r=(c[u>>2]|0)+32|0;e=c[r>>2]|0;c[r>>2]=e+1;c[(c[(c[u>>2]|0)+36>>2]|0)+(e<<2)>>2]=s;c[(c[c[w>>2]>>2]|0)+20+4>>2]=c[u>>2];c[w>>2]=Hb[c[c[o>>2]>>2]&63](c[o>>2]|0,c[w>>2]|0,8)|0}c[w>>2]=Hb[c[c[n>>2]>>2]&63](c[n>>2]|0,v,512)|0;while(1){if(!(c[w>>2]|0))break;if(!(+h[(c[w>>2]|0)+8+8>>3]<+h[(c[u>>2]|0)+40+16+8>>3]))break;s=c[c[w>>2]>>2]|0;e=(c[u>>2]|0)+32|0;r=c[e>>2]|0;c[e>>2]=r+1;c[(c[(c[u>>2]|0)+36>>2]|0)+(r<<2)>>2]=s;c[(c[c[w>>2]>>2]|0)+20+4>>2]=c[u>>2];c[w>>2]=Hb[c[c[n>>2]>>2]&63](c[n>>2]|0,c[w>>2]|0,8)|0}h[v+8>>3]=+h[(c[u>>2]|0)+40+16+8>>3];c[w>>2]=Hb[c[c[o>>2]>>2]&63](c[o>>2]|0,v,512)|0;while(1){if(!(c[w>>2]|0))break;if(!(+h[(c[w>>2]|0)+8>>3]<+h[(c[u>>2]|0)+40+16>>3]))break;s=c[c[w>>2]>>2]|0;r=(c[u>>2]|0)+32|0;e=c[r>>2]|0;c[r>>2]=e+1;c[(c[(c[u>>2]|0)+36>>2]|0)+(e<<2)>>2]=s;c[(c[c[w>>2]>>2]|0)+20>>2]=c[u>>2];c[w>>2]=Hb[c[c[o>>2]>>2]&63](c[o>>2]|0,c[w>>2]|0,8)|0}h[v>>3]=+h[(c[u>>2]|0)+40+16>>3];h[v+8>>3]=+h[(c[u>>2]|0)+40+8>>3];c[w>>2]=Hb[c[c[n>>2]>>2]&63](c[n>>2]|0,v,512)|0;while(1){if(!(c[w>>2]|0))break;if(!(+h[(c[w>>2]|0)+8+8>>3]<+h[(c[u>>2]|0)+40+16+8>>3]))break;s=c[c[w>>2]>>2]|0;e=(c[u>>2]|0)+32|0;r=c[e>>2]|0;c[e>>2]=r+1;c[(c[(c[u>>2]|0)+36>>2]|0)+(r<<2)>>2]=s;c[(c[c[w>>2]>>2]|0)+20>>2]=c[u>>2];c[w>>2]=Hb[c[c[n>>2]>>2]&63](c[n>>2]|0,c[w>>2]|0,8)|0}c[g>>2]=(c[g>>2]|0)+(c[(c[u>>2]|0)+32>>2]|0);if((c[(c[u>>2]|0)+32>>2]|0)>(c[k>>2]|0))c[k>>2]=c[(c[u>>2]|0)+32>>2];c[j>>2]=(c[j>>2]|0)+1}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0))break;c[x>>2]=(c[(c[f>>2]|0)+12>>2]|0)+((c[j>>2]|0)*72|0);NU(c[x>>2]|0,c[m>>2]|0);c[j>>2]=(c[j>>2]|0)+1}c[(c[(c[m>>2]|0)+16>>2]|0)+((c[c[m>>2]>>2]|0)*40|0)+32>>2]=c[c[m>>2]>>2];c[(c[(c[m>>2]|0)+16>>2]|0)+(((c[c[m>>2]>>2]|0)+1|0)*40|0)+32>>2]=(c[c[m>>2]>>2]|0)+1;IQ(c[m>>2]|0,c[k>>2]|0);c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[c[f>>2]>>2]|0))break;c[y>>2]=(c[(c[f>>2]|0)+8>>2]|0)+((c[j>>2]|0)*72|0);OU(c[y>>2]|0,c[m>>2]|0);c[j>>2]=(c[j>>2]|0)+1}Jz(c[n>>2]|0)|0;Jz(c[o>>2]|0)|0;O4(c[p>>2]|0);PU(c[m>>2]|0);GQ(c[m>>2]|0);i=d;return c[m>>2]|0}function MU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+20|0;n=h+4|0;o=h;c[j>>2]=b;c[k>>2]=d;c[l>>2]=f;a[m>>0]=g;c[n>>2]=Hb[c[c[k>>2]>>2]&63](c[k>>2]|0,e,512)|0;if(c[n>>2]|0){p=c[n>>2]|0;q=c[p>>2]|0;i=h;return q|0}c[o>>2]=KQ(c[j>>2]|0)|0;if(!(c[l>>2]|0))La(175888,175836,293,175895);c[n>>2]=(c[l>>2]|0)+(c[(c[o>>2]|0)+32>>2]<<5);l=(c[n>>2]|0)+8|0;c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];c[c[n>>2]>>2]=c[o>>2];a[(c[o>>2]|0)+36>>0]=a[m>>0]|0;Hb[c[c[k>>2]>>2]&63](c[k>>2]|0,c[n>>2]|0,1)|0;p=c[n>>2]|0;q=c[p>>2]|0;i=h;return q|0}function NU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[e+12>>2]=d;a:do if((+h[(c[f>>2]|0)+40+16+8>>3]-+h[(c[f>>2]|0)+40+8>>3]-3.0)/2.0<2.0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+32>>2]|0))break a;c[j>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+(c[g>>2]<<2)>>2];b:do if(a[(c[j>>2]|0)+36>>0]|0){d=(c[j>>2]|0)+20|0;if((c[(c[j>>2]|0)+20>>2]|0)==(c[f>>2]|0)){c[k>>2]=c[d+4>>2];b=c[k>>2]|0;c[b>>2]=c[b>>2]|8;while(1){b=c[c[(c[k>>2]|0)+36>>2]>>2]|0;c[j>>2]=b;if(!b)break b;if(!((c[c[(c[j>>2]|0)+20+4>>2]>>2]&1|0)!=0^1))break b;c[k>>2]=c[(c[j>>2]|0)+20+4>>2];b=c[k>>2]|0;c[b>>2]=c[b>>2]|8}}else{c[k>>2]=c[d>>2];b=c[k>>2]|0;c[b>>2]=c[b>>2]|8;while(1){b=c[(c[(c[k>>2]|0)+36>>2]|0)+8>>2]|0;c[j>>2]=b;if(!b)break b;if(!((c[c[(c[j>>2]|0)+20>>2]>>2]&1|0)!=0^1))break b;c[k>>2]=c[(c[j>>2]|0)+20>>2];b=c[k>>2]|0;c[b>>2]=c[b>>2]|8}}}while(0);c[g>>2]=(c[g>>2]|0)+1}}while(0);if(!((+h[(c[f>>2]|0)+40+16>>3]-+h[(c[f>>2]|0)+40>>3]-3.0)/2.0<2.0)){i=e;return}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[f>>2]|0)+32>>2]|0))break;c[j>>2]=c[(c[(c[f>>2]|0)+36>>2]|0)+(c[g>>2]<<2)>>2];c:do if(!(a[(c[j>>2]|0)+36>>0]|0)){d=(c[j>>2]|0)+20|0;if((c[(c[j>>2]|0)+20>>2]|0)==(c[f>>2]|0)){c[k>>2]=c[d+4>>2];b=c[k>>2]|0;c[b>>2]=c[b>>2]|16;while(1){b=c[(c[(c[k>>2]|0)+36>>2]|0)+4>>2]|0;c[j>>2]=b;if(!b)break c;if(!((c[c[(c[j>>2]|0)+20+4>>2]>>2]&1|0)!=0^1))break c;c[k>>2]=c[(c[j>>2]|0)+20+4>>2];b=c[k>>2]|0;c[b>>2]=c[b>>2]|16}}else{c[k>>2]=c[d>>2];b=c[k>>2]|0;c[b>>2]=c[b>>2]|16;while(1){b=c[(c[(c[k>>2]|0)+36>>2]|0)+12>>2]|0;c[j>>2]=b;if(!b)break c;if(!((c[c[(c[j>>2]|0)+20>>2]>>2]&1|0)!=0^1))break c;c[k>>2]=c[(c[j>>2]|0)+20>>2];b=c[k>>2]|0;c[b>>2]=c[b>>2]|16}}}while(0);c[g>>2]=(c[g>>2]|0)+1}i=e;return}function OU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+64|0;e=d+60|0;f=d+56|0;g=d+24|0;j=d+16|0;k=d+8|0;l=d;c[e>>2]=a;c[f>>2]=b;b=(c[e>>2]|0)+40|0;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];c[g+24>>2]=c[b+24>>2];c[g+28>>2]=c[b+28>>2];h[j>>3]=(+h[g+16>>3]-+h[g>>3])*1.0;h[k>>3]=(+h[g+16+8>>3]-+h[g+8>>3])*1.0;h[l>>3]=(+h[j>>3]+ +h[k>>3])/2.0+500.0;if((+h[g+16+8>>3]-+h[g+8>>3]-3.0)/2.0<2.0?(c[c[e>>2]>>2]&8|0)==0:0){h[j>>3]=16384.0;h[l>>3]=16384.0}if((+h[g+16>>3]-+h[g>>3]-3.0)/2.0<2.0?(c[c[e>>2]>>2]&16|0)==0:0){h[k>>3]=16384.0;h[l>>3]=16384.0}if((c[(c[(c[e>>2]|0)+36>>2]|0)+8>>2]|0)!=0?(c[(c[(c[e>>2]|0)+36>>2]|0)+4>>2]|0)!=0:0){g=LQ(c[f>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+8>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+4>>2]|0,+h[l>>3])|0;b=(c[e>>2]|0)+4|0;a=c[b>>2]|0;c[b>>2]=a+1;c[(c[e>>2]|0)+8+(a<<2)>>2]=g}if((c[(c[(c[e>>2]|0)+36>>2]|0)+4>>2]|0)!=0?(c[c[(c[e>>2]|0)+36>>2]>>2]|0)!=0:0){g=LQ(c[f>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+4>>2]|0,c[c[(c[e>>2]|0)+36>>2]>>2]|0,+h[l>>3])|0;a=(c[e>>2]|0)+4|0;b=c[a>>2]|0;c[a>>2]=b+1;c[(c[e>>2]|0)+8+(b<<2)>>2]=g}if((c[(c[(c[e>>2]|0)+36>>2]|0)+8>>2]|0)!=0?(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){g=LQ(c[f>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+8>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0,+h[l>>3])|0;b=(c[e>>2]|0)+4|0;a=c[b>>2]|0;c[b>>2]=a+1;c[(c[e>>2]|0)+8+(a<<2)>>2]=g}if((c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0)!=0?(c[c[(c[e>>2]|0)+36>>2]>>2]|0)!=0:0){g=LQ(c[f>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0,c[c[(c[e>>2]|0)+36>>2]>>2]|0,+h[l>>3])|0;l=(c[e>>2]|0)+4|0;a=c[l>>2]|0;c[l>>2]=a+1;c[(c[e>>2]|0)+8+(a<<2)>>2]=g}if((c[(c[(c[e>>2]|0)+36>>2]|0)+4>>2]|0)!=0?(c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0)!=0:0){g=LQ(c[f>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+4>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+12>>2]|0,+h[k>>3])|0;k=(c[e>>2]|0)+4|0;a=c[k>>2]|0;c[k>>2]=a+1;c[(c[e>>2]|0)+8+(a<<2)>>2]=g}if(!(c[(c[(c[e>>2]|0)+36>>2]|0)+8>>2]|0)){i=d;return}if(!(c[c[(c[e>>2]|0)+36>>2]>>2]|0)){i=d;return}g=LQ(c[f>>2]|0,c[(c[(c[e>>2]|0)+36>>2]|0)+8>>2]|0,c[c[(c[e>>2]|0)+36>>2]>>2]|0,+h[j>>3])|0;j=(c[e>>2]|0)+4|0;f=c[j>>2]|0;c[j>>2]=f+1;c[(c[e>>2]|0)+8+(f<<2)>>2]=g;i=d;return}function PU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+8|0;e=b;f=b+20|0;g=b+16|0;h=b+12|0;c[f>>2]=a;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[c[f>>2]>>2]|0)){j=12;break}c[h>>2]=(c[(c[f>>2]|0)+16>>2]|0)+((c[g>>2]|0)*40|0);if(!(c[(c[h>>2]|0)+20>>2]|0)){a=c[24742]|0;c[e>>2]=c[g>>2];Y2(a,175801,e)|0}if(!(c[(c[h>>2]|0)+20>>2]|0)){j=6;break}if(!(c[(c[h>>2]|0)+20+4>>2]|0)){a=c[24742]|0;c[d>>2]=c[g>>2];Y2(a,175853,d)|0}if(!(c[(c[h>>2]|0)+20+4>>2]|0)){j=10;break}c[g>>2]=(c[g>>2]|0)+1}if((j|0)==6)La(175823,175836,313,175843);else if((j|0)==10)La(175875,175836,315,175843);else if((j|0)==12){i=b;return}}function QU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;j=f+8|0;k=f+4|0;c[f+12>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f>>2]=e;do if(!(+h[(c[j>>2]|0)+8>>3]>+h[(c[k>>2]|0)+8>>3])){if(+h[(c[j>>2]|0)+8>>3]<+h[(c[k>>2]|0)+8>>3]){c[g>>2]=-1;break}if(+h[c[j>>2]>>3]>+h[c[k>>2]>>3]){c[g>>2]=1;break}if(+h[c[j>>2]>>3]<+h[c[k>>2]>>3]){c[g>>2]=-1;break}else{c[g>>2]=0;break}}else c[g>>2]=1;while(0);i=f;return c[g>>2]|0}function RU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+32|0;g=f+16|0;j=f+8|0;k=f+4|0;c[f+12>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f>>2]=e;do if(!(+h[c[j>>2]>>3]>+h[c[k>>2]>>3])){if(+h[c[j>>2]>>3]<+h[c[k>>2]>>3]){c[g>>2]=-1;break}if(+h[(c[j>>2]|0)+8>>3]>+h[(c[k>>2]|0)+8>>3]){c[g>>2]=1;break}if(+h[(c[j>>2]|0)+8>>3]<+h[(c[k>>2]|0)+8>>3]){c[g>>2]=-1;break}else{c[g>>2]=0;break}}else c[g>>2]=1;while(0);i=f;return c[g>>2]|0}function SU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+112|0;g=f;h=f+96|0;j=f+92|0;k=f+88|0;l=f+84|0;m=f+80|0;n=f+76|0;o=f+72|0;p=f+68|0;q=f+64|0;r=f+60|0;s=f+56|0;t=f+52|0;u=f+48|0;v=f+44|0;w=f+40|0;x=f+36|0;y=f+32|0;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=(c[j>>2]|0)+1<<2;c[m>>2]=cK(((c[l>>2]|0)+1|0)*56|0)|0;c[n>>2]=bK((c[l>>2]|0)+1<<2)|0;c[s>>2]=0;c[u>>2]=((c[l>>2]|0)*5|0)+1;c[v>>2]=cK((c[u>>2]|0)*72|0)|0;c[w>>2]=bK(c[u>>2]<<5)|0;c[x>>2]=bK(c[u>>2]<<5)|0;d=c[h>>2]|0;b=c[j>>2]|0;a=c[m>>2]|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];TU(d,b,g,a,0);v2(173);UU(c[l>>2]|0,c[n>>2]|0);c[y>>2]=cV(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[u>>2]|0,c[v>>2]|0)|0;c[o>>2]=VU(c[l>>2]|0,c[m>>2]|0,c[v>>2]|0,0,c[w>>2]|0)|0;a=c[h>>2]|0;h=c[j>>2]|0;j=c[m>>2]|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];TU(a,h,g,j,1);UU(c[l>>2]|0,c[n>>2]|0);c[y>>2]=cV(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[u>>2]|0,c[v>>2]|0)|0;c[p>>2]=VU(c[l>>2]|0,c[m>>2]|0,c[v>>2]|0,1,c[x>>2]|0)|0;c[t>>2]=bK((_(c[o>>2]|0,c[p>>2]|0)|0)<<5)|0;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[p>>2]|0))break;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[o>>2]|0))break;if(WU((c[t>>2]|0)+(c[s>>2]<<5)|0,(c[x>>2]|0)+(c[q>>2]<<5)|0,(c[w>>2]|0)+(c[r>>2]<<5)|0)|0)c[s>>2]=(c[s>>2]|0)+1;c[r>>2]=(c[r>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+1}c[t>>2]=eK(c[t>>2]|0,c[s>>2]<<5)|0;O4(c[m>>2]|0);O4(c[n>>2]|0);O4(c[v>>2]|0);O4(c[w>>2]|0);O4(c[x>>2]|0);c[c[k>>2]>>2]=c[s>>2];i=f;return c[t>>2]|0}function TU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+128|0;h=g+64|0;j=g+116|0;k=g+112|0;l=g+108|0;m=g+104|0;n=g+100|0;o=g+96|0;p=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=0;c[o>>2]=1;f=c[m>>2]|0;c[h>>2]=c[d>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[h+24>>2]=c[d+24>>2];c[h+28>>2]=c[d+28>>2];aV(h,f,1,p);c[o>>2]=bV(c[l>>2]|0,c[o>>2]|0,p)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[k>>2]|0))break;f=(c[j>>2]|0)+((c[n>>2]|0)*72|0)+40|0;d=c[m>>2]|0;c[h>>2]=c[f>>2];c[h+4>>2]=c[f+4>>2];c[h+8>>2]=c[f+8>>2];c[h+12>>2]=c[f+12>>2];c[h+16>>2]=c[f+16>>2];c[h+20>>2]=c[f+20>>2];c[h+24>>2]=c[f+24>>2];c[h+28>>2]=c[f+28>>2];aV(h,d,0,p);c[o>>2]=bV(c[l>>2]|0,c[o>>2]|0,p)|0;c[n>>2]=(c[n>>2]|0)+1}i=g;return}function UU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0.0,l=0.0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;while(1){if((c[g>>2]|0)>(c[e>>2]|0))break;c[(c[f>>2]|0)+(c[g>>2]<<2)>>2]=c[g>>2];c[g>>2]=(c[g>>2]|0)+1}c[g>>2]=1;while(1){if((c[g>>2]|0)>(c[e>>2]|0))break;k=+(c[g>>2]|0);l=+r2();c[h>>2]=~~(k+l*+((c[e>>2]|0)+1-(c[g>>2]|0)|0));if((c[h>>2]|0)!=(c[g>>2]|0)){c[j>>2]=c[(c[f>>2]|0)+(c[g>>2]<<2)>>2];c[(c[f>>2]|0)+(c[g>>2]<<2)>>2]=c[(c[f>>2]|0)+(c[h>>2]<<2)>>2];c[(c[f>>2]|0)+(c[h>>2]<<2)>>2]=c[j>>2]}c[g>>2]=(c[g>>2]|0)+1}i=d;return}function VU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[q>>2]=((c[h>>2]|0)*5|0)+1;c[r>>2]=bK(c[q>>2]<<2)|0;c[22918]=bK(c[q>>2]<<4)|0;c[22919]=bK(((c[h>>2]|0)+1|0)*56|0)|0;c[22920]=bK(c[h>>2]<<2)|0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(((c[h>>2]|0)*5|0)+1|0))break;if(XU((c[k>>2]|0)+((c[n>>2]|0)*72|0)|0,c[j>>2]|0)|0)break;c[n>>2]=(c[n>>2]|0)+1}c[p>>2]=c[n>>2];c[n>>2]=1;while(1){if((c[n>>2]|0)>(c[h>>2]|0))break;c[(c[22918]|0)+(c[n>>2]<<4)+8>>2]=c[(c[j>>2]|0)+((c[n>>2]|0)*56|0)+48>>2];c[(c[22918]|0)+(c[n>>2]<<4)+4>>2]=c[(c[j>>2]|0)+((c[n>>2]|0)*56|0)+44>>2];c[(c[22918]|0)+(c[n>>2]<<4)>>2]=c[n>>2];q=(c[22919]|0)+((c[n>>2]|0)*56|0)|0;f=(c[j>>2]|0)+((c[n>>2]|0)*56|0)|0;c[q>>2]=c[f>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];c[q+12>>2]=c[f+12>>2];c[(c[22919]|0)+((c[n>>2]|0)*56|0)+16>>2]=c[(c[j>>2]|0)+((c[n>>2]|0)*56|0)+44>>2];c[(c[22919]|0)+((c[n>>2]|0)*56|0)+32>>2]=c[n>>2];c[(c[22919]|0)+((c[n>>2]|0)*56|0)+48>>2]=1;c[n>>2]=(c[n>>2]|0)+1}c[22921]=c[h>>2];c[22922]=0;c[c[22920]>>2]=1;if((c[(c[k>>2]|0)+((c[p>>2]|0)*72|0)+40>>2]|0)>0){c[o>>2]=YU(c[r>>2]|0,c[m>>2]|0,0,c[j>>2]|0,c[k>>2]|0,0,c[p>>2]|0,c[(c[k>>2]|0)+((c[p>>2]|0)*72|0)+40>>2]|0,c[l>>2]|0,1)|0;s=c[r>>2]|0;O4(s);t=c[22918]|0;O4(t);u=c[22919]|0;O4(u);v=c[22920]|0;O4(v);w=c[o>>2]|0;i=g;return w|0}if((c[(c[k>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0)<=0){s=c[r>>2]|0;O4(s);t=c[22918]|0;O4(t);u=c[22919]|0;O4(u);v=c[22920]|0;O4(v);w=c[o>>2]|0;i=g;return w|0}c[o>>2]=YU(c[r>>2]|0,c[m>>2]|0,0,c[j>>2]|0,c[k>>2]|0,0,c[p>>2]|0,c[(c[k>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0,c[l>>2]|0,2)|0;s=c[r>>2]|0;O4(s);t=c[22918]|0;O4(t);u=c[22919]|0;O4(u);v=c[22920]|0;O4(v);w=c[o>>2]|0;i=g;return w|0}function WU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;j=e+12|0;k=e+8|0;l=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;if(+h[c[j>>2]>>3]>+h[c[k>>2]>>3])m=+h[c[j>>2]>>3];else m=+h[c[k>>2]>>3];h[l>>3]=m;if(+h[(c[j>>2]|0)+16>>3]<+h[(c[k>>2]|0)+16>>3])n=+h[(c[j>>2]|0)+16>>3];else n=+h[(c[k>>2]|0)+16>>3];h[(c[g>>2]|0)+16>>3]=n;h[c[g>>2]>>3]=+h[l>>3];if(+h[(c[j>>2]|0)+8>>3]>+h[(c[k>>2]|0)+8>>3])o=+h[(c[j>>2]|0)+8>>3];else o=+h[(c[k>>2]|0)+8>>3];h[l>>3]=o;if(+h[(c[j>>2]|0)+16+8>>3]<+h[(c[k>>2]|0)+16+8>>3])p=+h[(c[j>>2]|0)+16+8>>3];else p=+h[(c[k>>2]|0)+16+8>>3];h[(c[g>>2]|0)+16+8>>3]=p;h[(c[g>>2]|0)+8>>3]=+h[l>>3];if(!(+h[c[g>>2]>>3]>=+h[(c[g>>2]|0)+16>>3])?!(+h[(c[g>>2]|0)+8>>3]>=+h[(c[g>>2]|0)+16+8>>3]):0){c[f>>2]=1;q=c[f>>2]|0;i=e;return q|0}c[f>>2]=0;q=c[f>>2]|0;i=e;return q|0}function XU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;c[j>>2]=c[(c[f>>2]|0)+4>>2];if((c[(c[f>>2]|0)+68>>2]|0)==2){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}if((c[c[f>>2]>>2]|0)>0?(c[(c[f>>2]|0)+4>>2]|0)>0:0){if(!((c[(c[f>>2]|0)+40>>2]|0)<=0?(c[(c[f>>2]|0)+44>>2]|0)<=0:0))l=8;do if((l|0)==8){if((c[(c[f>>2]|0)+48>>2]|0)<=0?(c[(c[f>>2]|0)+52>>2]|0)<=0:0)break;c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}while(0);if(!(+h[(c[g>>2]|0)+((c[j>>2]|0)*56|0)+16+8>>3]>+h[(c[g>>2]|0)+((c[j>>2]|0)*56|0)+8>>3]+1.0e-07))if(+h[(c[g>>2]|0)+((c[j>>2]|0)*56|0)+16+8>>3]<+h[(c[g>>2]|0)+((c[j>>2]|0)*56|0)+8>>3]-1.0e-07)m=0;else m=+h[(c[g>>2]|0)+((c[j>>2]|0)*56|0)+16>>3]>+h[(c[g>>2]|0)+((c[j>>2]|0)*56|0)>>3]&1;else m=1;c[e>>2]=m;k=c[e>>2]|0;i=d;return k|0}c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}function YU(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;n=i;i=i+80|0;o=n+64|0;p=n+60|0;q=n+56|0;r=n+52|0;s=n+48|0;t=n+44|0;u=n+40|0;v=n+36|0;w=n+32|0;x=n+28|0;y=n+24|0;z=n+20|0;A=n+16|0;B=n+12|0;C=n+8|0;D=n+4|0;E=n;c[p>>2]=a;c[q>>2]=b;c[r>>2]=d;c[s>>2]=e;c[t>>2]=f;c[u>>2]=g;c[v>>2]=j;c[w>>2]=k;c[x>>2]=l;c[y>>2]=m;c[z>>2]=(c[t>>2]|0)+((c[v>>2]|0)*72|0);c[E>>2]=0;if((c[v>>2]|0)>0?(c[(c[p>>2]|0)+(c[v>>2]<<2)>>2]|0)==0:0){c[(c[p>>2]|0)+(c[v>>2]<<2)>>2]=1;if((+h[(c[z>>2]|0)+8+8>>3]>+h[(c[z>>2]|0)+24+8>>3]?+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)>>3]==+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+16>>3]:0)?+h[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)>>3]==+h[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)+16>>3]:0){m=c[z>>2]|0;if(c[x>>2]|0){h[(c[q>>2]|0)+(c[r>>2]<<5)>>3]=+h[m+24+8>>3];h[(c[q>>2]|0)+(c[r>>2]<<5)+8>>3]=-+h[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)>>3];h[(c[q>>2]|0)+(c[r>>2]<<5)+16>>3]=+h[(c[z>>2]|0)+8+8>>3];h[(c[q>>2]|0)+(c[r>>2]<<5)+16+8>>3]=-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)>>3]}else{h[(c[q>>2]|0)+(c[r>>2]<<5)>>3]=+h[(c[s>>2]|0)+((c[m>>2]|0)*56|0)>>3];h[(c[q>>2]|0)+(c[r>>2]<<5)+8>>3]=+h[(c[z>>2]|0)+24+8>>3];h[(c[q>>2]|0)+(c[r>>2]<<5)+16>>3]=+h[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)>>3];h[(c[q>>2]|0)+(c[r>>2]<<5)+16+8>>3]=+h[(c[z>>2]|0)+8+8>>3]}c[r>>2]=(c[r>>2]|0)+1}do if((c[(c[z>>2]|0)+40>>2]|0)<=0?(c[(c[z>>2]|0)+44>>2]|0)<=0:0){if((c[(c[z>>2]|0)+48>>2]|0)>0?(c[(c[z>>2]|0)+52>>2]|0)>0:0){c[B>>2]=c[(c[t>>2]|0)+((c[(c[z>>2]|0)+52>>2]|0)*72|0)>>2];c[C>>2]=c[c[z>>2]>>2];if((c[w>>2]|0)==(c[(c[z>>2]|0)+52>>2]|0)){c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}else{c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}}c[D>>2]=-1;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0}else F=19;while(0);a:do if((F|0)==19){if((c[(c[z>>2]|0)+48>>2]|0)<=0?(c[(c[z>>2]|0)+52>>2]|0)<=0:0){if((c[(c[z>>2]|0)+40>>2]|0)>0?(c[(c[z>>2]|0)+44>>2]|0)>0:0){c[B>>2]=c[(c[z>>2]|0)+4>>2];c[C>>2]=c[(c[t>>2]|0)+((c[(c[z>>2]|0)+40>>2]|0)*72|0)+4>>2];if((c[w>>2]|0)==(c[(c[z>>2]|0)+44>>2]|0)){c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;break}else{c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;break}}c[D>>2]=-1;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}if((c[(c[z>>2]|0)+40>>2]|0)>0?(c[(c[z>>2]|0)+44>>2]|0)>0:0){if((c[(c[z>>2]|0)+48>>2]|0)>0?(c[(c[z>>2]|0)+52>>2]|0)>0:0){c[B>>2]=c[(c[t>>2]|0)+((c[(c[z>>2]|0)+52>>2]|0)*72|0)>>2];c[C>>2]=c[(c[t>>2]|0)+((c[(c[z>>2]|0)+40>>2]|0)*72|0)+4>>2];c[D>>2]=3;if(!((c[y>>2]|0)==2?(c[(c[z>>2]|0)+52>>2]|0)==(c[w>>2]|0):0))F=33;do if((F|0)==33){if((c[y>>2]|0)==1?(c[(c[z>>2]|0)+44>>2]|0)==(c[w>>2]|0):0)break;c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break a}while(0);c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}if(+N(+(+h[(c[z>>2]|0)+24+8>>3]-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+16+8>>3]))<=1.0e-07?+N(+(+h[(c[z>>2]|0)+24>>3]-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+16>>3]))<=1.0e-07:0){c[B>>2]=c[(c[t>>2]|0)+((c[(c[z>>2]|0)+40>>2]|0)*72|0)+4>>2];c[C>>2]=c[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+44>>2];c[D>>2]=4;if((c[y>>2]|0)==1?(c[(c[z>>2]|0)+40>>2]|0)==(c[w>>2]|0):0){c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;break}c[B>>2]=c[(c[z>>2]|0)+4>>2];c[C>>2]=c[(c[t>>2]|0)+((c[(c[z>>2]|0)+40>>2]|0)*72|0)+4>>2];c[D>>2]=5;if((c[y>>2]|0)==1?(c[(c[z>>2]|0)+44>>2]|0)==(c[w>>2]|0):0){c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;break}c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;break}if((c[(c[z>>2]|0)+40>>2]|0)<=0?(c[(c[z>>2]|0)+44>>2]|0)<=0:0)break;if((c[(c[z>>2]|0)+48>>2]|0)>0?(c[(c[z>>2]|0)+52>>2]|0)>0:0){if(+N(+(+h[(c[z>>2]|0)+8+8>>3]-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+8>>3]))<=1.0e-07?+N(+(+h[(c[z>>2]|0)+8>>3]-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)>>3]))<=1.0e-07:0){c[B>>2]=c[(c[t>>2]|0)+((c[(c[z>>2]|0)+52>>2]|0)*72|0)>>2];c[C>>2]=c[c[z>>2]>>2];c[D>>2]=6;if((c[y>>2]|0)==2?(c[(c[z>>2]|0)+48>>2]|0)==(c[w>>2]|0):0){c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}c[B>>2]=c[(c[t>>2]|0)+((c[(c[z>>2]|0)+52>>2]|0)*72|0)>>2];c[C>>2]=c[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)+44>>2];c[D>>2]=7;if((c[y>>2]|0)==2?(c[(c[z>>2]|0)+52>>2]|0)==(c[w>>2]|0):0){c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}if(((+N(+(+h[(c[z>>2]|0)+8+8>>3]-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+8>>3]))<=1.0e-07?+N(+(+h[(c[z>>2]|0)+8>>3]-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)>>3]))<=1.0e-07:0)?+N(+(+h[(c[z>>2]|0)+24+8>>3]-+h[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)+8>>3]))<=1.0e-07:0)?+N(+(+h[(c[z>>2]|0)+24>>3]-+h[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)>>3]))<=1.0e-07:0){c[B>>2]=c[(c[z>>2]|0)+4>>2];c[C>>2]=c[c[z>>2]>>2];c[D>>2]=2;if((c[y>>2]|0)==1){c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}else{c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;break}}if(((+N(+(+h[(c[z>>2]|0)+8+8>>3]-+h[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)+16+8>>3]))<=1.0e-07?+N(+(+h[(c[z>>2]|0)+8>>3]-+h[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)+16>>3]))<=1.0e-07:0)?+N(+(+h[(c[z>>2]|0)+24+8>>3]-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+16+8>>3]))<=1.0e-07:0)?+N(+(+h[(c[z>>2]|0)+24>>3]-+h[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+16>>3]))<=1.0e-07:0){c[B>>2]=c[(c[s>>2]|0)+((c[(c[z>>2]|0)+4>>2]|0)*56|0)+44>>2];c[C>>2]=c[(c[s>>2]|0)+((c[c[z>>2]>>2]|0)*56|0)+44>>2];c[D>>2]=1;if((c[y>>2]|0)==1){c[E>>2]=1;c[A>>2]=ZU(c[u>>2]|0,c[C>>2]|0,c[B>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;break}else{c[A>>2]=ZU(c[u>>2]|0,c[B>>2]|0,c[C>>2]|0)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[A>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;break}}c[D>>2]=-1;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+40>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+48>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+44>>2]|0,c[v>>2]|0,c[x>>2]|0,2)|0;c[r>>2]=YU(c[p>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[(c[z>>2]|0)+52>>2]|0,c[v>>2]|0,c[x>>2]|0,1)|0}while(0);c[o>>2]=c[r>>2];G=c[o>>2]|0;i=n;return G|0}c[o>>2]=c[r>>2];G=c[o>>2]|0;i=n;return G|0}function ZU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+64|0;f=e+52|0;g=e+48|0;h=e+44|0;j=e+40|0;k=e+36|0;l=e+32|0;m=e+28|0;n=e+24|0;o=e+20|0;p=e+16|0;q=e+12|0;r=e+8|0;s=e+4|0;t=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=(c[22922]|0)+1|0;c[22922]=d;c[n>>2]=d;c[s>>2]=(c[22919]|0)+((c[g>>2]|0)*56|0);c[t>>2]=(c[22919]|0)+((c[h>>2]|0)*56|0);_U(c[g>>2]|0,c[h>>2]|0,l,m)|0;c[j>>2]=c[(c[s>>2]|0)+32+(c[l>>2]<<2)>>2];c[k>>2]=c[(c[t>>2]|0)+32+(c[m>>2]<<2)>>2];m=(c[22921]|0)+1|0;c[22921]=m;c[o>>2]=m;m=(c[22921]|0)+1|0;c[22921]=m;c[p>>2]=m;c[(c[22918]|0)+(c[o>>2]<<4)>>2]=c[g>>2];c[(c[22918]|0)+(c[p>>2]<<4)>>2]=c[h>>2];c[(c[22918]|0)+(c[o>>2]<<4)+4>>2]=c[(c[22918]|0)+(c[j>>2]<<4)+4>>2];c[(c[22918]|0)+(c[(c[22918]|0)+(c[j>>2]<<4)+4>>2]<<4)+8>>2]=c[o>>2];c[(c[22918]|0)+(c[o>>2]<<4)+8>>2]=c[p>>2];c[(c[22918]|0)+(c[p>>2]<<4)+4>>2]=c[o>>2];c[(c[22918]|0)+(c[p>>2]<<4)+8>>2]=c[(c[22918]|0)+(c[k>>2]<<4)+8>>2];c[(c[22918]|0)+(c[(c[22918]|0)+(c[k>>2]<<4)+8>>2]<<4)+4>>2]=c[p>>2];c[(c[22918]|0)+(c[j>>2]<<4)+4>>2]=c[k>>2];c[(c[22918]|0)+(c[k>>2]<<4)+8>>2]=c[j>>2];c[q>>2]=c[(c[s>>2]|0)+48>>2];c[r>>2]=c[(c[t>>2]|0)+48>>2];c[(c[s>>2]|0)+16+(c[l>>2]<<2)>>2]=c[h>>2];c[(c[s>>2]|0)+32+(c[q>>2]<<2)>>2]=c[o>>2];c[(c[s>>2]|0)+16+(c[q>>2]<<2)>>2]=c[(c[22918]|0)+(c[(c[22918]|0)+(c[o>>2]<<4)+4>>2]<<4)>>2];c[(c[t>>2]|0)+32+(c[r>>2]<<2)>>2]=c[p>>2];c[(c[t>>2]|0)+16+(c[r>>2]<<2)>>2]=c[g>>2];g=(c[s>>2]|0)+48|0;c[g>>2]=(c[g>>2]|0)+1;g=(c[t>>2]|0)+48|0;c[g>>2]=(c[g>>2]|0)+1;c[(c[22920]|0)+(c[f>>2]<<2)>>2]=c[j>>2];c[(c[22920]|0)+(c[n>>2]<<2)>>2]=c[o>>2];i=e;return c[n>>2]|0}function _U(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0;f=i;i=i+64|0;g=f+48|0;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+8|0;q=f;r=f+20|0;s=f+16|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=(c[22919]|0)+((c[g>>2]|0)*56|0);c[n>>2]=(c[22919]|0)+((c[j>>2]|0)*56|0);h[p>>3]=-4.0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=4)break;if((c[(c[m>>2]|0)+16+(c[o>>2]<<2)>>2]|0)>0?(t=+$U(c[m>>2]|0,(c[22919]|0)+((c[(c[m>>2]|0)+16+(c[o>>2]<<2)>>2]|0)*56|0)|0,c[n>>2]|0),h[q>>3]=t,t>+h[p>>3]):0){h[p>>3]=+h[q>>3];c[r>>2]=c[o>>2]}c[o>>2]=(c[o>>2]|0)+1}c[c[k>>2]>>2]=c[r>>2];h[p>>3]=-4.0;c[o>>2]=0;while(1){if((c[o>>2]|0)>=4)break;if((c[(c[n>>2]|0)+16+(c[o>>2]<<2)>>2]|0)>0?(t=+$U(c[n>>2]|0,(c[22919]|0)+((c[(c[n>>2]|0)+16+(c[o>>2]<<2)>>2]|0)*56|0)|0,c[m>>2]|0),h[q>>3]=t,t>+h[p>>3]):0){h[p>>3]=+h[q>>3];c[s>>2]=c[o>>2]}c[o>>2]=(c[o>>2]|0)+1}c[c[l>>2]>>2]=c[s>>2];i=f;return 0}function $U(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+64|0;f=e+32|0;g=e+48|0;j=e+44|0;k=e+40|0;l=e+16|0;m=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=+h[c[j>>2]>>3]-+h[c[g>>2]>>3];h[l+8>>3]=+h[(c[j>>2]|0)+8>>3]-+h[(c[g>>2]|0)+8>>3];h[m>>3]=+h[c[k>>2]>>3]-+h[c[g>>2]>>3];h[m+8>>3]=+h[(c[k>>2]|0)+8>>3]-+h[(c[g>>2]|0)+8>>3];n=+h[l>>3]*+h[m>>3]+ +h[l+8>>3]*+h[m+8>>3];if(+h[l>>3]*+h[m+8>>3]-+h[m>>3]*+h[l+8>>3]>=0.0){o=n/+O(+(+h[l>>3]*+h[l>>3]+ +h[l+8>>3]*+h[l+8>>3]));h[f>>3]=o/+O(+(+h[m>>3]*+h[m>>3]+ +h[m+8>>3]*+h[m+8>>3]));p=+h[f>>3];i=e;return +p}else{o=-1.0*n/+O(+(+h[l>>3]*+h[l>>3]+ +h[l+8>>3]*+h[l+8>>3]));h[f>>3]=o/+O(+(+h[m>>3]*+h[m>>3]+ +h[m+8>>3]*+h[m+8>>3]))-2.0;p=+h[f>>3];i=e;return +p}return +(0.0)}function aV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f;c[g>>2]=b;c[j>>2]=d;c[k>>2]=e;e=c[k>>2]|0;c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];e=(c[k>>2]|0)+32|0;d=a+16|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];if(c[j>>2]|0){h[(c[k>>2]|0)+16>>3]=+h[a+16>>3];h[(c[k>>2]|0)+16+8>>3]=+h[a+8>>3];h[(c[k>>2]|0)+48>>3]=+h[a>>3];h[(c[k>>2]|0)+48+8>>3]=+h[a+16+8>>3]}else{h[(c[k>>2]|0)+16>>3]=+h[a>>3];h[(c[k>>2]|0)+16+8>>3]=+h[a+16+8>>3];h[(c[k>>2]|0)+48>>3]=+h[a+16>>3];h[(c[k>>2]|0)+48+8>>3]=+h[a+8>>3]}if(!(c[g>>2]|0)){i=f;return}c[l>>2]=0;while(1){if((c[l>>2]|0)>=4)break;h[m>>3]=+h[(c[k>>2]|0)+(c[l>>2]<<4)+8>>3];h[(c[k>>2]|0)+(c[l>>2]<<4)+8>>3]=+h[(c[k>>2]|0)+(c[l>>2]<<4)>>3];h[(c[k>>2]|0)+(c[l>>2]<<4)>>3]=-+h[m>>3];c[l>>2]=(c[l>>2]|0)+1}i=f;return}function bV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[k>>2]=(c[g>>2]|0)+4-1;c[l>>2]=0;c[j>>2]=c[g>>2];while(1){if((c[j>>2]|0)>(c[k>>2]|0))break;do if((c[j>>2]|0)!=(c[g>>2]|0))if((c[j>>2]|0)==(c[k>>2]|0)){c[(c[f>>2]|0)+((c[j>>2]|0)*56|0)+44>>2]=c[g>>2];c[(c[f>>2]|0)+((c[j>>2]|0)*56|0)+48>>2]=(c[k>>2]|0)-1;break}else{c[(c[f>>2]|0)+((c[j>>2]|0)*56|0)+44>>2]=(c[j>>2]|0)+1;c[(c[f>>2]|0)+((c[j>>2]|0)*56|0)+48>>2]=(c[j>>2]|0)-1;break}else{c[(c[f>>2]|0)+((c[j>>2]|0)*56|0)+44>>2]=(c[g>>2]|0)+1;c[(c[f>>2]|0)+((c[j>>2]|0)*56|0)+48>>2]=c[k>>2]}while(0);c[(c[f>>2]|0)+((c[j>>2]|0)*56|0)+32>>2]=0;d=(c[f>>2]|0)+((c[(c[f>>2]|0)+((c[j>>2]|0)*56|0)+48>>2]|0)*56|0)+16|0;b=(c[f>>2]|0)+((c[j>>2]|0)*56|0)|0;a=(c[h>>2]|0)+(c[l>>2]<<4)|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[j>>2]=(c[j>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1}i=e;return (c[k>>2]|0)+1|0}function cV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;h=g+36|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[q>>2]=1;c[22923]=c[l>>2]<<1;c[22924]=c[l>>2];c[r>>2]=bK((c[l>>2]<<1)*40|0)|0;c[22925]=1;c[22926]=1;$4(c[m>>2]|0,0,(c[l>>2]|0)*72|0)|0;l=c[q>>2]|0;c[q>>2]=l+1;c[o>>2]=dV(c[(c[k>>2]|0)+(l<<2)>>2]|0,c[j>>2]|0,c[m>>2]|0,c[r>>2]|0)|0;c[n>>2]=1;while(1){if((c[n>>2]|0)>(c[h>>2]|0))break;l=c[o>>2]|0;c[(c[j>>2]|0)+((c[n>>2]|0)*56|0)+40>>2]=l;c[(c[j>>2]|0)+((c[n>>2]|0)*56|0)+36>>2]=l;c[n>>2]=(c[n>>2]|0)+1}c[p>>2]=1;while(1){o=c[p>>2]|0;l=(o|0)<=(eV(c[h>>2]|0)|0);s=c[h>>2]|0;if(!l)break;c[n>>2]=(fV(s,(c[p>>2]|0)-1|0)|0)+1;while(1){l=c[n>>2]|0;if((l|0)>(fV(c[h>>2]|0,c[p>>2]|0)|0))break;l=c[q>>2]|0;c[q>>2]=l+1;gV(c[(c[k>>2]|0)+(l<<2)>>2]|0,c[j>>2]|0,c[m>>2]|0,c[r>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+1}c[n>>2]=1;while(1){if((c[n>>2]|0)>(c[h>>2]|0))break;hV(c[n>>2]|0,c[j>>2]|0,c[m>>2]|0,c[r>>2]|0);c[n>>2]=(c[n>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}c[n>>2]=(fV(s,eV(c[h>>2]|0)|0)|0)+1;while(1){if((c[n>>2]|0)>(c[h>>2]|0))break;s=c[q>>2]|0;c[q>>2]=s+1;gV(c[(c[k>>2]|0)+(s<<2)>>2]|0,c[j>>2]|0,c[m>>2]|0,c[r>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+1}O4(c[r>>2]|0);i=g;return c[22925]|0}function dV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+80|0;g=f+64|0;j=f+60|0;k=f+56|0;l=f+52|0;m=f+48|0;n=f+44|0;o=f+40|0;p=f+36|0;q=f+32|0;r=f+28|0;s=f+24|0;t=f+20|0;u=f+16|0;v=f+12|0;w=f+8|0;x=f+4|0;y=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[y>>2]=(c[j>>2]|0)+((c[g>>2]|0)*56|0);c[m>>2]=mV()|0;c[(c[l>>2]|0)+((c[m>>2]|0)*40|0)>>2]=2;qV((c[l>>2]|0)+((c[m>>2]|0)*40|0)+8|0,c[y>>2]|0,(c[y>>2]|0)+16|0)|0;c[t>>2]=c[m>>2];j=mV()|0;c[n>>2]=j;c[(c[l>>2]|0)+((c[m>>2]|0)*40|0)+36>>2]=j;c[(c[l>>2]|0)+((c[n>>2]|0)*40|0)>>2]=3;c[(c[l>>2]|0)+((c[n>>2]|0)*40|0)+28>>2]=c[m>>2];j=mV()|0;c[o>>2]=j;c[(c[l>>2]|0)+((c[m>>2]|0)*40|0)+32>>2]=j;c[(c[l>>2]|0)+((c[o>>2]|0)*40|0)>>2]=2;rV((c[l>>2]|0)+((c[o>>2]|0)*40|0)+8|0,c[y>>2]|0,(c[y>>2]|0)+16|0)|0;c[(c[l>>2]|0)+((c[o>>2]|0)*40|0)+28>>2]=c[m>>2];j=mV()|0;c[p>>2]=j;c[(c[l>>2]|0)+((c[o>>2]|0)*40|0)+32>>2]=j;c[(c[l>>2]|0)+((c[p>>2]|0)*40|0)>>2]=3;c[(c[l>>2]|0)+((c[p>>2]|0)*40|0)+28>>2]=c[o>>2];j=mV()|0;c[q>>2]=j;c[(c[l>>2]|0)+((c[o>>2]|0)*40|0)+36>>2]=j;c[(c[l>>2]|0)+((c[q>>2]|0)*40|0)>>2]=1;c[(c[l>>2]|0)+((c[q>>2]|0)*40|0)+4>>2]=c[g>>2];c[(c[l>>2]|0)+((c[q>>2]|0)*40|0)+28>>2]=c[o>>2];j=mV()|0;c[r>>2]=j;c[(c[l>>2]|0)+((c[q>>2]|0)*40|0)+32>>2]=j;c[(c[l>>2]|0)+((c[r>>2]|0)*40|0)>>2]=3;c[(c[l>>2]|0)+((c[r>>2]|0)*40|0)+28>>2]=c[q>>2];j=mV()|0;c[s>>2]=j;c[(c[l>>2]|0)+((c[q>>2]|0)*40|0)+36>>2]=j;c[(c[l>>2]|0)+((c[s>>2]|0)*40|0)>>2]=3;c[(c[l>>2]|0)+((c[s>>2]|0)*40|0)+28>>2]=c[q>>2];c[u>>2]=lV(c[k>>2]|0)|0;c[v>>2]=lV(c[k>>2]|0)|0;c[w>>2]=lV(c[k>>2]|0)|0;c[x>>2]=lV(c[k>>2]|0)|0;q=(c[k>>2]|0)+((c[u>>2]|0)*72|0)+8|0;j=(c[k>>2]|0)+((c[v>>2]|0)*72|0)+8|0;e=(c[k>>2]|0)+((c[x>>2]|0)*72|0)+24|0;d=(c[l>>2]|0)+((c[m>>2]|0)*40|0)+8|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[q>>2]=c[j>>2];c[q+4>>2]=c[j+4>>2];c[q+8>>2]=c[j+8>>2];c[q+12>>2]=c[j+12>>2];j=(c[k>>2]|0)+((c[u>>2]|0)*72|0)+24|0;q=(c[k>>2]|0)+((c[v>>2]|0)*72|0)+24|0;e=(c[k>>2]|0)+((c[w>>2]|0)*72|0)+8|0;d=(c[l>>2]|0)+((c[o>>2]|0)*40|0)+8|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[q>>2]=c[e>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];h[(c[k>>2]|0)+((c[x>>2]|0)*72|0)+8+8>>3]=1073741824.0;h[(c[k>>2]|0)+((c[x>>2]|0)*72|0)+8>>3]=1073741824.0;h[(c[k>>2]|0)+((c[w>>2]|0)*72|0)+24+8>>3]=-1073741824.0;h[(c[k>>2]|0)+((c[w>>2]|0)*72|0)+24>>3]=-1073741824.0;q=c[g>>2]|0;c[(c[k>>2]|0)+((c[v>>2]|0)*72|0)>>2]=q;c[(c[k>>2]|0)+((c[u>>2]|0)*72|0)+4>>2]=q;q=c[x>>2]|0;c[(c[k>>2]|0)+((c[v>>2]|0)*72|0)+40>>2]=q;c[(c[k>>2]|0)+((c[u>>2]|0)*72|0)+40>>2]=q;q=c[w>>2]|0;c[(c[k>>2]|0)+((c[v>>2]|0)*72|0)+48>>2]=q;c[(c[k>>2]|0)+((c[u>>2]|0)*72|0)+48>>2]=q;q=c[u>>2]|0;c[(c[k>>2]|0)+((c[w>>2]|0)*72|0)+40>>2]=q;c[(c[k>>2]|0)+((c[x>>2]|0)*72|0)+48>>2]=q;q=c[v>>2]|0;c[(c[k>>2]|0)+((c[w>>2]|0)*72|0)+44>>2]=q;c[(c[k>>2]|0)+((c[x>>2]|0)*72|0)+52>>2]=q;c[(c[k>>2]|0)+((c[u>>2]|0)*72|0)+56>>2]=c[r>>2];c[(c[k>>2]|0)+((c[v>>2]|0)*72|0)+56>>2]=c[s>>2];c[(c[k>>2]|0)+((c[w>>2]|0)*72|0)+56>>2]=c[p>>2];c[(c[k>>2]|0)+((c[x>>2]|0)*72|0)+56>>2]=c[n>>2];c[(c[k>>2]|0)+((c[v>>2]|0)*72|0)+68>>2]=1;c[(c[k>>2]|0)+((c[u>>2]|0)*72|0)+68>>2]=1;c[(c[k>>2]|0)+((c[x>>2]|0)*72|0)+68>>2]=1;c[(c[k>>2]|0)+((c[w>>2]|0)*72|0)+68>>2]=1;c[(c[l>>2]|0)+((c[n>>2]|0)*40|0)+24>>2]=c[x>>2];c[(c[l>>2]|0)+((c[p>>2]|0)*40|0)+24>>2]=c[w>>2];c[(c[l>>2]|0)+((c[r>>2]|0)*40|0)+24>>2]=c[u>>2];c[(c[l>>2]|0)+((c[s>>2]|0)*40|0)+24>>2]=c[v>>2];c[(c[y>>2]|0)+32>>2]=1;i=f;return c[t>>2]|0}function eV(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b;c[d>>2]=a;c[e>>2]=0;h[f>>3]=+(c[d>>2]|0);while(1){if(!(+h[f>>3]>=1.0))break;h[f>>3]=+f2(+h[f>>3]);c[e>>2]=(c[e>>2]|0)+1}i=b;return (c[e>>2]|0)-1|0}function fV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;h[j>>3]=+(c[e>>2]|0);while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;h[j>>3]=+f2(+h[j>>3]);c[g>>2]=(c[g>>2]|0)+1}g=~~+Z(+(+(c[e>>2]|0)*1.0/+h[j>>3]));i=d;return g|0}function gV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;f=i;i=i+272|0;g=f+104|0;j=f+256|0;k=f+252|0;l=f+248|0;m=f+244|0;n=f+48|0;o=f+240|0;p=f+236|0;q=f+232|0;r=f+228|0;s=f+224|0;t=f+220|0;u=f+216|0;v=f+212|0;w=f+208|0;x=f+204|0;y=f+200|0;z=f+196|0;A=f+192|0;B=f+32|0;C=f+188|0;D=f+184|0;E=f+180|0;F=f+176|0;G=f+172|0;H=f+168|0;I=f+164|0;J=f+160|0;K=f+156|0;L=f+152|0;M=f+148|0;O=f+144|0;P=f+140|0;Q=f+136|0;R=f+132|0;S=f+24|0;T=f+16|0;U=f;V=f+128|0;W=f+124|0;X=f+120|0;Y=f+116|0;Z=f+112|0;_=f+108|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[C>>2]=0;c[D>>2]=0;e=n;d=(c[k>>2]|0)+((c[j>>2]|0)*56|0)|0;b=e+56|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(b|0));do if(+h[n+16+8>>3]>+h[n+8>>3]+1.0e-07)$=4;else{if(!(+h[n+16+8>>3]<+h[n+8>>3]-1.0e-07)?+h[n+16>>3]>+h[n>>3]:0){$=4;break}c[E>>2]=0}while(0);if(($|0)==4){c[B>>2]=c[n>>2];c[B+4>>2]=c[n+4>>2];c[B+8>>2]=c[n+8>>2];c[B+12>>2]=c[n+12>>2];a=n+16|0;c[n>>2]=c[a>>2];c[n+4>>2]=c[a+4>>2];c[n+8>>2]=c[a+8>>2];c[n+12>>2]=c[a+12>>2];a=n+16|0;c[a>>2]=c[B>>2];c[a+4>>2]=c[B+4>>2];c[a+8>>2]=c[B+8>>2];c[a+12>>2]=c[B+12>>2];c[G>>2]=c[n+36>>2];c[n+36>>2]=c[n+40>>2];c[n+40>>2]=c[G>>2];c[E>>2]=1}G=c[j>>2]|0;B=c[k>>2]|0;if(c[E>>2]|0)if(kV(G,B,2)|0)$=22;else $=9;else if(kV(G,B,1)|0)$=22;else $=9;if(($|0)==9){c[o>>2]=iV(n,n+16|0,c[n+36>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;c[p>>2]=lV(c[l>>2]|0)|0;c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+68>>2]=1;e=(c[l>>2]|0)+((c[p>>2]|0)*72|0)|0;d=(c[l>>2]|0)+((c[o>>2]|0)*72|0)|0;b=e+72|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(b|0));aa=+h[n+8>>3];h[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+8+8>>3]=aa;h[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+24+8>>3]=aa;aa=+h[n>>3];h[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+8>>3]=aa;h[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+24>>3]=aa;c[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+48>>2]=c[p>>2];c[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+52>>2]=0;c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+40>>2]=c[o>>2];c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+44>>2]=0;B=c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0;c[H>>2]=B;if((B|0)>0?(c[(c[l>>2]|0)+((c[H>>2]|0)*72|0)+40>>2]|0)==(c[o>>2]|0):0)c[(c[l>>2]|0)+((c[H>>2]|0)*72|0)+40>>2]=c[p>>2];B=c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0;c[H>>2]=B;if((B|0)>0?(c[(c[l>>2]|0)+((c[H>>2]|0)*72|0)+44>>2]|0)==(c[o>>2]|0):0)c[(c[l>>2]|0)+((c[H>>2]|0)*72|0)+44>>2]=c[p>>2];B=c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0;c[H>>2]=B;if((B|0)>0?(c[(c[l>>2]|0)+((c[H>>2]|0)*72|0)+40>>2]|0)==(c[o>>2]|0):0)c[(c[l>>2]|0)+((c[H>>2]|0)*72|0)+40>>2]=c[p>>2];B=c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0;c[H>>2]=B;if((B|0)>0?(c[(c[l>>2]|0)+((c[H>>2]|0)*72|0)+44>>2]|0)==(c[o>>2]|0):0)c[(c[l>>2]|0)+((c[H>>2]|0)*72|0)+44>>2]=c[p>>2];c[x>>2]=mV()|0;c[y>>2]=mV()|0;c[q>>2]=c[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+56>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)>>2]=2;H=(c[m>>2]|0)+((c[q>>2]|0)*40|0)+8|0;c[H>>2]=c[n>>2];c[H+4>>2]=c[n+4>>2];c[H+8>>2]=c[n+8>>2];c[H+12>>2]=c[n+12>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+4>>2]=c[j>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+32>>2]=c[y>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+36>>2]=c[x>>2];c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)>>2]=3;c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)+24>>2]=c[o>>2];c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)+28>>2]=c[q>>2];c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)>>2]=3;c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)+24>>2]=c[p>>2];c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)+28>>2]=c[q>>2];c[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+56>>2]=c[x>>2];c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+56>>2]=c[y>>2];c[r>>2]=c[p>>2]}else if(($|0)==22){c[r>>2]=iV(n,n+16|0,c[n+36>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;c[C>>2]=1}C=c[j>>2]|0;H=c[k>>2]|0;if(c[E>>2]|0)if(kV(C,H,1)|0)$=39;else $=26;else if(kV(C,H,2)|0)$=39;else $=26;if(($|0)==26){c[o>>2]=iV(n+16|0,n,c[n+40>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;c[p>>2]=lV(c[l>>2]|0)|0;c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+68>>2]=1;e=(c[l>>2]|0)+((c[p>>2]|0)*72|0)|0;d=(c[l>>2]|0)+((c[o>>2]|0)*72|0)|0;b=e+72|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(b|0));aa=+h[n+16+8>>3];h[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+8+8>>3]=aa;h[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+24+8>>3]=aa;aa=+h[n+16>>3];h[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+8>>3]=aa;h[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+24>>3]=aa;c[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+48>>2]=c[p>>2];c[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+52>>2]=0;c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+40>>2]=c[o>>2];c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+44>>2]=0;H=c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0;c[I>>2]=H;if((H|0)>0?(c[(c[l>>2]|0)+((c[I>>2]|0)*72|0)+40>>2]|0)==(c[o>>2]|0):0)c[(c[l>>2]|0)+((c[I>>2]|0)*72|0)+40>>2]=c[p>>2];H=c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0;c[I>>2]=H;if((H|0)>0?(c[(c[l>>2]|0)+((c[I>>2]|0)*72|0)+44>>2]|0)==(c[o>>2]|0):0)c[(c[l>>2]|0)+((c[I>>2]|0)*72|0)+44>>2]=c[p>>2];H=c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0;c[I>>2]=H;if((H|0)>0?(c[(c[l>>2]|0)+((c[I>>2]|0)*72|0)+40>>2]|0)==(c[o>>2]|0):0)c[(c[l>>2]|0)+((c[I>>2]|0)*72|0)+40>>2]=c[p>>2];H=c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0;c[I>>2]=H;if((H|0)>0?(c[(c[l>>2]|0)+((c[I>>2]|0)*72|0)+44>>2]|0)==(c[o>>2]|0):0)c[(c[l>>2]|0)+((c[I>>2]|0)*72|0)+44>>2]=c[p>>2];c[x>>2]=mV()|0;c[y>>2]=mV()|0;c[q>>2]=c[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+56>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)>>2]=2;I=(c[m>>2]|0)+((c[q>>2]|0)*40|0)+8|0;H=n+16|0;c[I>>2]=c[H>>2];c[I+4>>2]=c[H+4>>2];c[I+8>>2]=c[H+8>>2];c[I+12>>2]=c[H+12>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+4>>2]=c[j>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+32>>2]=c[y>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+36>>2]=c[x>>2];c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)>>2]=3;c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)+24>>2]=c[o>>2];c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)+28>>2]=c[q>>2];c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)>>2]=3;c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)+24>>2]=c[p>>2];c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)+28>>2]=c[q>>2];c[(c[l>>2]|0)+((c[o>>2]|0)*72|0)+56>>2]=c[x>>2];c[(c[l>>2]|0)+((c[p>>2]|0)*72|0)+56>>2]=c[y>>2];c[s>>2]=c[o>>2]}else if(($|0)==39){c[s>>2]=iV(n+16|0,n,c[n+40>>2]|0,c[k>>2]|0,c[m>>2]|0)|0;c[D>>2]=1}c[z>>2]=c[r>>2];while(1){if((c[z>>2]|0)<=0){$=147;break}if(!(nV((c[l>>2]|0)+((c[z>>2]|0)*72|0)+24|0,(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24|0)|0)){$=147;break}c[q>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+56>>2];c[x>>2]=mV()|0;c[y>>2]=mV()|0;c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)>>2]=1;c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+4>>2]=c[j>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+32>>2]=c[x>>2];c[(c[m>>2]|0)+((c[q>>2]|0)*40|0)+36>>2]=c[y>>2];c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)>>2]=3;c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)+24>>2]=c[z>>2];c[(c[m>>2]|0)+((c[x>>2]|0)*40|0)+28>>2]=c[q>>2];c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)>>2]=3;o=lV(c[l>>2]|0)|0;c[A>>2]=o;c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)+24>>2]=o;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+68>>2]=1;c[(c[m>>2]|0)+((c[y>>2]|0)*40|0)+28>>2]=c[q>>2];if((c[z>>2]|0)==(c[r>>2]|0))c[t>>2]=c[A>>2];if(+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24+8>>3]-+h[(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24+8>>3]))<=1.0e-07?+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24>>3]-+h[(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24>>3]))<=1.0e-07:0)c[u>>2]=c[A>>2];e=(c[l>>2]|0)+((c[A>>2]|0)*72|0)|0;d=(c[l>>2]|0)+((c[z>>2]|0)*72|0)|0;b=e+72|0;do{c[e>>2]=c[d>>2];e=e+4|0;d=d+4|0}while((e|0)<(b|0));c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+56>>2]=c[x>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+56>>2]=c[y>>2];c[J>>2]=c[z>>2];c[K>>2]=c[A>>2];if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)<=0?(c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)<=0:0){$=50;break}if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)>0?(c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)<=0:0){do if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)>0?(c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]|0)>0:0){o=(c[l>>2]|0)+((c[z>>2]|0)*72|0)|0;if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2]|0)<=0){c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[o+44>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2];break}if((c[o+64>>2]|0)==1){c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]|0)*72|0)+48>>2]=c[A>>2]}else{c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2]}c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+60>>2]=0;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2]=0}else $=61;while(0);do if(($|0)==61){$=0;c[L>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2];o=c[(c[l>>2]|0)+((c[L>>2]|0)*72|0)+48>>2]|0;c[M>>2]=o;if((o|0)>0?(o=c[(c[l>>2]|0)+((c[L>>2]|0)*72|0)+52>>2]|0,c[O>>2]=o,(o|0)>0):0){if((c[(c[l>>2]|0)+((c[M>>2]|0)*72|0)+4>>2]|0)>0?(jV(c[(c[l>>2]|0)+((c[M>>2]|0)*72|0)+4>>2]|0,c[k>>2]|0,n+16|0)|0)==0:0){c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+52>>2]=c[A>>2];break}c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];break}c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+52>>2]=c[A>>2]}while(0);do if(+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24+8>>3]-+h[(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24+8>>3]))<=1.0e-07?(o=+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24>>3]-+h[(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24>>3]))<=1.0e-07,o&(c[D>>2]|0)!=0):0){o=(c[k>>2]|0)+((c[j>>2]|0)*56|0)|0;if(c[E>>2]|0)c[F>>2]=c[o+48>>2];else c[F>>2]=c[o+44>>2];if((c[F>>2]|0)>0?(jV(c[F>>2]|0,c[k>>2]|0,n)|0)!=0:0){c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+40>>2]=c[z>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+52>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+48>>2]=-1;break}c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+48>>2]|0)*72|0)+44>>2]=c[A>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]=-1}else $=77;while(0);if(($|0)==77){$=0;do if((c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+40>>2]|0)>0?(c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+44>>2]|0)>0:0){o=(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)|0;if((c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+40>>2]|0)==(c[z>>2]|0)){c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+60>>2]=c[o+44>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+64>>2]=1;break}else{c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+60>>2]=c[o+40>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+64>>2]=2;break}}while(0);c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+40>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+44>>2]=c[A>>2]}c[z>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]}else $=84;do if(($|0)==84){$=0;if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)<=0?(c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)>0:0){do if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)>0?(c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]|0)>0:0){o=(c[l>>2]|0)+((c[z>>2]|0)*72|0)|0;if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2]|0)<=0){c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[o+44>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2];break}if((c[o+64>>2]|0)==1){c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]|0)*72|0)+48>>2]=c[A>>2]}else{c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2]}c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+60>>2]=0;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2]=0}else $=94;while(0);a:do if(($|0)==94){$=0;c[P>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2];o=c[(c[l>>2]|0)+((c[P>>2]|0)*72|0)+48>>2]|0;c[Q>>2]=o;if((o|0)>0?(o=c[(c[l>>2]|0)+((c[P>>2]|0)*72|0)+52>>2]|0,c[R>>2]=o,(o|0)>0):0){do if((c[(c[l>>2]|0)+((c[Q>>2]|0)*72|0)+4>>2]|0)>0){if(jV(c[(c[l>>2]|0)+((c[Q>>2]|0)*72|0)+4>>2]|0,c[k>>2]|0,n+16|0)|0)break;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+52>>2]=c[A>>2];break a}while(0);c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];break}c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+52>>2]=c[A>>2]}while(0);b:do if(+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24+8>>3]-+h[(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24+8>>3]))<=1.0e-07?(o=+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24>>3]-+h[(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24>>3]))<=1.0e-07,o&(c[D>>2]|0)!=0):0){o=(c[k>>2]|0)+((c[j>>2]|0)*56|0)|0;if(c[E>>2]|0)c[F>>2]=c[o+48>>2];else c[F>>2]=c[o+44>>2];do if((c[F>>2]|0)>0){if(!(jV(c[F>>2]|0,c[k>>2]|0,n)|0))break;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]=c[z>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+52>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+48>>2]=-1;break b}while(0);c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+52>>2]|0)*72|0)+44>>2]=c[A>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]=-1}else $=110;while(0);if(($|0)==110){$=0;do if((c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]|0)>0?(c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+44>>2]|0)>0:0){o=(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)|0;if((c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]|0)==(c[z>>2]|0)){c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+60>>2]=c[o+44>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+64>>2]=1;break}else{c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+60>>2]=c[o+40>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+64>>2]=2;break}}while(0);c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+44>>2]=c[A>>2]}c[z>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2];break}c[X>>2]=0;c[W>>2]=0;o=+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24+8>>3]-+h[n+8>>3]))<=1.0e-07;p=(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24|0;do if(o)if(+h[p>>3]>+h[n>>3]){c[W>>2]=1;break}else{c[X>>2]=1;break}else{aa=+h[p+8>>3];h[S>>3]=aa;h[U+8>>3]=aa;h[T>>3]=(+h[S>>3]-+h[n+8>>3])/(+h[n+16+8>>3]-+h[n+8>>3]);h[U>>3]=+h[n>>3]+ +h[T>>3]*(+h[n+16>>3]-+h[n>>3]);if(oV(U,(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24|0)|0){c[W>>2]=1;break}else{c[X>>2]=1;break}}while(0);do if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)>0?(c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]|0)>0:0){p=(c[l>>2]|0)+((c[z>>2]|0)*72|0)|0;if((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2]|0)<=0){c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[p+44>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2];break}if((c[p+64>>2]|0)==1){c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]|0)*72|0)+48>>2]=c[A>>2]}else{c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2];c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[A>>2]}c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+60>>2]=0;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+60>>2]=0}else $=132;while(0);c:do if(($|0)==132){$=0;c[Y>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2];p=c[(c[l>>2]|0)+((c[Y>>2]|0)*72|0)+48>>2]|0;c[Z>>2]=p;if((p|0)>0?(p=c[(c[l>>2]|0)+((c[Y>>2]|0)*72|0)+52>>2]|0,c[_>>2]=p,(p|0)>0):0){do if((c[(c[l>>2]|0)+((c[Z>>2]|0)*72|0)+4>>2]|0)>0){if(jV(c[(c[l>>2]|0)+((c[Z>>2]|0)*72|0)+4>>2]|0,c[k>>2]|0,n+16|0)|0)break;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]|0)*72|0)+52>>2]=c[A>>2];break c}while(0);c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+40>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];break}c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+48>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+40>>2]|0)*72|0)+52>>2]=c[A>>2]}while(0);if(+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24+8>>3]-+h[(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24+8>>3]))<=1.0e-07?(p=+N(+(+h[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+24>>3]-+h[(c[l>>2]|0)+((c[s>>2]|0)*72|0)+24>>3]))<=1.0e-07,p&(c[D>>2]|0)!=0):0){c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+40>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]=c[A>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+48>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+52>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]=-1;c[V>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]}else $=142;do if(($|0)==142){$=0;p=(c[W>>2]|0)!=0;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+40>>2]=c[z>>2];if(p){c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+44>>2]=c[A>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]=c[A>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]=-1;c[V>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2];break}else{c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+48>>2]|0)*72|0)+44>>2]=-1;c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]=c[z>>2];c[(c[l>>2]|0)+((c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2]|0)*72|0)+44>>2]=c[A>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+48>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2];c[(c[l>>2]|0)+((c[A>>2]|0)*72|0)+52>>2]=-1;c[V>>2]=c[(c[l>>2]|0)+((c[z>>2]|0)*72|0)+52>>2];break}}while(0);c[z>>2]=c[V>>2]}while(0);p=c[j>>2]|0;c[(c[l>>2]|0)+((c[K>>2]|0)*72|0)>>2]=p;c[(c[l>>2]|0)+((c[J>>2]|0)*72|0)+4>>2]=p}if(($|0)==50){Y2(c[24742]|0,176129,g)|0;ba=c[r>>2]|0;c[v>>2]=ba;ca=c[s>>2]|0;c[w>>2]=ca;da=c[j>>2]|0;ea=c[v>>2]|0;fa=c[w>>2]|0;ga=c[l>>2]|0;ha=c[m>>2]|0;pV(da,ea,fa,1,ga,ha);ia=c[j>>2]|0;ja=c[t>>2]|0;ka=c[u>>2]|0;la=c[l>>2]|0;ma=c[m>>2]|0;pV(ia,ja,ka,2,la,ma);na=c[j>>2]|0;oa=c[k>>2]|0;pa=oa+(na*56|0)|0;qa=pa+32|0;c[qa>>2]=1;i=f;return 0}else if(($|0)==147){ba=c[r>>2]|0;c[v>>2]=ba;ca=c[s>>2]|0;c[w>>2]=ca;da=c[j>>2]|0;ea=c[v>>2]|0;fa=c[w>>2]|0;ga=c[l>>2]|0;ha=c[m>>2]|0;pV(da,ea,fa,1,ga,ha);ia=c[j>>2]|0;ja=c[t>>2]|0;ka=c[u>>2]|0;la=c[l>>2]|0;ma=c[m>>2]|0;pV(ia,ja,ka,2,la,ma);na=c[j>>2]|0;oa=c[k>>2]|0;pa=oa+(na*56|0)|0;qa=pa+32|0;c[qa>>2]=1;i=f;return 0}return 0}function hV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=(c[h>>2]|0)+((c[g>>2]|0)*56|0);if(c[(c[l>>2]|0)+32>>2]|0){i=f;return}g=iV(c[l>>2]|0,(c[l>>2]|0)+16|0,c[(c[l>>2]|0)+36>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;c[(c[l>>2]|0)+36>>2]=g;c[(c[l>>2]|0)+36>>2]=c[(c[j>>2]|0)+((c[(c[l>>2]|0)+36>>2]|0)*72|0)+56>>2];g=iV((c[l>>2]|0)+16|0,c[l>>2]|0,c[(c[l>>2]|0)+40>>2]|0,c[h>>2]|0,c[k>>2]|0)|0;c[(c[l>>2]|0)+40>>2]=g;c[(c[l>>2]|0)+40>>2]=c[(c[j>>2]|0)+((c[(c[l>>2]|0)+40>>2]|0)*72|0)+56>>2];i=f;return}function iV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+32|0;j=g;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=(c[p>>2]|0)+((c[n>>2]|0)*40|0);switch(c[c[q>>2]>>2]|0){case 3:{c[k>>2]=c[(c[q>>2]|0)+24>>2];r=c[k>>2]|0;i=g;return r|0}case 2:{do if(!(+h[(c[l>>2]|0)+8>>3]>+h[(c[q>>2]|0)+8+8>>3]+1.0e-07)){if(!(+h[(c[l>>2]|0)+8>>3]<+h[(c[q>>2]|0)+8+8>>3]-1.0e-07)?+h[c[l>>2]>>3]>+h[(c[q>>2]|0)+8>>3]:0)break;if(+N(+(+h[(c[l>>2]|0)+8>>3]-+h[(c[q>>2]|0)+8+8>>3]))<=1.0e-07?+N(+(+h[c[l>>2]>>3]-+h[(c[q>>2]|0)+8>>3]))<=1.0e-07:0){do if(!(+h[(c[m>>2]|0)+8>>3]>+h[(c[q>>2]|0)+8+8>>3]+1.0e-07)){if(!(+h[(c[m>>2]|0)+8>>3]<+h[(c[q>>2]|0)+8+8>>3]-1.0e-07)?+h[c[m>>2]>>3]>+h[(c[q>>2]|0)+8>>3]:0)break;c[k>>2]=iV(c[l>>2]|0,c[m>>2]|0,c[(c[q>>2]|0)+32>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}while(0);c[k>>2]=iV(c[l>>2]|0,c[m>>2]|0,c[(c[q>>2]|0)+36>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}c[k>>2]=iV(c[l>>2]|0,c[m>>2]|0,c[(c[q>>2]|0)+32>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}while(0);c[k>>2]=iV(c[l>>2]|0,c[m>>2]|0,c[(c[q>>2]|0)+36>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}case 1:{if(!(+N(+(+h[(c[l>>2]|0)+8>>3]-+h[(c[o>>2]|0)+((c[(c[q>>2]|0)+4>>2]|0)*56|0)+8>>3]))<=1.0e-07?+N(+(+h[c[l>>2]>>3]-+h[(c[o>>2]|0)+((c[(c[q>>2]|0)+4>>2]|0)*56|0)>>3]))<=1.0e-07:0))s=17;do if((s|0)==17){if(+N(+(+h[(c[l>>2]|0)+8>>3]-+h[(c[o>>2]|0)+((c[(c[q>>2]|0)+4>>2]|0)*56|0)+16+8>>3]))<=1.0e-07?+N(+(+h[c[l>>2]>>3]-+h[(c[o>>2]|0)+((c[(c[q>>2]|0)+4>>2]|0)*56|0)+16>>3]))<=1.0e-07:0)break;n=(jV(c[(c[q>>2]|0)+4>>2]|0,c[o>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;e=c[m>>2]|0;d=c[q>>2]|0;if(n){c[k>>2]=iV(f,e,c[d+32>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}else{c[k>>2]=iV(f,e,c[d+36>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}}while(0);if(+N(+(+h[(c[l>>2]|0)+8>>3]-+h[(c[m>>2]|0)+8>>3]))<=1.0e-07){s=c[l>>2]|0;d=c[m>>2]|0;e=c[q>>2]|0;if(+h[c[m>>2]>>3]<+h[c[l>>2]>>3]){c[k>>2]=iV(s,d,c[e+32>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}else{c[k>>2]=iV(s,d,c[e+36>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}}else{e=(jV(c[(c[q>>2]|0)+4>>2]|0,c[o>>2]|0,c[m>>2]|0)|0)!=0;d=c[l>>2]|0;l=c[m>>2]|0;m=c[q>>2]|0;if(e){c[k>>2]=iV(d,l,c[m+32>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}else{c[k>>2]=iV(d,l,c[m+36>>2]|0,c[o>>2]|0,c[p>>2]|0)|0;r=c[k>>2]|0;i=g;return r|0}}break}default:{Y2(c[24742]|0,176063,j)|0;La(176099,176101,349,176113)}}return 0}function jV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=(c[j>>2]|0)+((c[g>>2]|0)*56|0);do if(!(+h[(c[l>>2]|0)+16+8>>3]>+h[(c[l>>2]|0)+8>>3]+1.0e-07)){if(!(+h[(c[l>>2]|0)+16+8>>3]<+h[(c[l>>2]|0)+8>>3]-1.0e-07)?+h[(c[l>>2]|0)+16>>3]>+h[c[l>>2]>>3]:0){n=4;break}if(+N(+(+h[(c[l>>2]|0)+16+8>>3]-+h[(c[k>>2]|0)+8>>3]))<=1.0e-07)if(+h[c[k>>2]>>3]<+h[(c[l>>2]|0)+16>>3]){h[m>>3]=1.0;break}else{h[m>>3]=-1.0;break}if(!(+N(+(+h[(c[l>>2]|0)+8>>3]-+h[(c[k>>2]|0)+8>>3]))<=1.0e-07)){h[m>>3]=(+h[c[l>>2]>>3]-+h[(c[l>>2]|0)+16>>3])*(+h[(c[k>>2]|0)+8>>3]-+h[(c[l>>2]|0)+16+8>>3])-(+h[(c[l>>2]|0)+8>>3]-+h[(c[l>>2]|0)+16+8>>3])*(+h[c[k>>2]>>3]-+h[(c[l>>2]|0)+16>>3]);break}if(+h[c[k>>2]>>3]<+h[c[l>>2]>>3]){h[m>>3]=1.0;break}else{h[m>>3]=-1.0;break}}else n=4;while(0);do if((n|0)==4){if(+N(+(+h[(c[l>>2]|0)+16+8>>3]-+h[(c[k>>2]|0)+8>>3]))<=1.0e-07)if(+h[c[k>>2]>>3]<+h[(c[l>>2]|0)+16>>3]){h[m>>3]=1.0;break}else{h[m>>3]=-1.0;break}if(!(+N(+(+h[(c[l>>2]|0)+8>>3]-+h[(c[k>>2]|0)+8>>3]))<=1.0e-07)){h[m>>3]=(+h[(c[l>>2]|0)+16>>3]-+h[c[l>>2]>>3])*(+h[(c[k>>2]|0)+8>>3]-+h[(c[l>>2]|0)+8>>3])-(+h[(c[l>>2]|0)+16+8>>3]-+h[(c[l>>2]|0)+8>>3])*(+h[c[k>>2]>>3]-+h[c[l>>2]>>3]);break}if(+h[c[k>>2]>>3]<+h[c[l>>2]>>3]){h[m>>3]=1.0;break}else{h[m>>3]=-1.0;break}}while(0);if(+h[m>>3]>0.0){c[f>>2]=1;o=c[f>>2]|0;i=e;return o|0}else{c[f>>2]=0;o=c[f>>2]|0;i=e;return o|0}return 0}function kV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;d=(c[h>>2]|0)+((c[g>>2]|0)*56|0)|0;if((c[j>>2]|0)==1){c[f>>2]=c[(c[h>>2]|0)+((c[d+48>>2]|0)*56|0)+32>>2];k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=c[(c[h>>2]|0)+((c[d+44>>2]|0)*56|0)+32>>2];k=c[f>>2]|0;i=e;return k|0}return 0}function lV(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;e=b+4|0;c[e>>2]=a;if((c[22925]|0)<(c[22924]|0)){c[(c[e>>2]|0)+((c[22925]|0)*72|0)>>2]=-1;c[(c[e>>2]|0)+((c[22925]|0)*72|0)+4>>2]=-1;c[(c[e>>2]|0)+((c[22925]|0)*72|0)+68>>2]=1;e=c[22925]|0;c[22925]=e+1;i=b;return e|0}else{e=c[24742]|0;c[d>>2]=c[22925];Y2(e,176188,d)|0;La(176099,176101,88,176226)}return 0}function mV(){var a=0,b=0;a=i;i=i+16|0;if((c[22926]|0)<(c[22923]|0)){b=c[22926]|0;c[22926]=b+1;i=a;return b|0}else{Y2(c[24742]|0,176149,a)|0;La(176099,176101,72,176180)}return 0}function nV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(+h[(c[f>>2]|0)+8>>3]>+h[(c[g>>2]|0)+8>>3]+1.0e-07){c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}if(+h[(c[f>>2]|0)+8>>3]<+h[(c[g>>2]|0)+8>>3]-1.0e-07){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=+h[c[f>>2]>>3]>=+h[c[g>>2]>>3]&1;j=c[e>>2]|0;i=d;return j|0}return 0}function oV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(+h[(c[f>>2]|0)+8>>3]<+h[(c[g>>2]|0)+8>>3]-1.0e-07){c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}if(+h[(c[f>>2]|0)+8>>3]>+h[(c[g>>2]|0)+8>>3]+1.0e-07){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=+h[c[f>>2]>>3]<+h[c[g>>2]>>3]&1;j=c[e>>2]|0;i=d;return j|0}return 0}function pV(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[p>>2]=c[k>>2];while(1){if((c[p>>2]|0)<=0){t=34;break}if(!(nV((c[n>>2]|0)+((c[p>>2]|0)*72|0)+24|0,(c[n>>2]|0)+((c[l>>2]|0)*72|0)+24|0)|0)){t=34;break}k=(c[m>>2]|0)==1;g=c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0;c[q>>2]=g;f=(g|0)>0;if(k){if(f?(c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)+4>>2]|0)==(c[j>>2]|0):0)u=1;else{k=c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0;c[q>>2]=k;if((k|0)>0)u=(c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)+4>>2]|0)==(c[j>>2]|0);else u=0}c[r>>2]=u&1}else{if(f?(c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)>>2]|0)==(c[j>>2]|0):0)v=1;else{f=c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0;c[q>>2]=f;if((f|0)>0)v=(c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)>>2]|0)==(c[j>>2]|0);else v=0}c[r>>2]=v&1}if(!(c[r>>2]|0)){c[p>>2]=c[q>>2];continue}if((c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)>>2]|0)==(c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)>>2]|0)?(c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+4>>2]|0)==(c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)+4>>2]|0):0){c[s>>2]=c[(c[o>>2]|0)+((c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)+56>>2]|0)*40|0)+28>>2];f=c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+56>>2]|0;k=(c[o>>2]|0)+((c[s>>2]|0)*40|0)|0;if((c[(c[o>>2]|0)+((c[s>>2]|0)*40|0)+32>>2]|0)==(c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)+56>>2]|0))c[k+32>>2]=f;else c[k+36>>2]=f;f=c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)+48>>2]|0;c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]=f;do if((f|0)>0){k=c[p>>2]|0;if((c[(c[n>>2]|0)+((c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0)*72|0)+40>>2]|0)==(c[q>>2]|0)){c[(c[n>>2]|0)+((c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0)*72|0)+40>>2]=k;break}if((c[(c[n>>2]|0)+((c[(c[n>>2]|0)+(k*72|0)+48>>2]|0)*72|0)+44>>2]|0)==(c[q>>2]|0))c[(c[n>>2]|0)+((c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+48>>2]|0)*72|0)+44>>2]=c[p>>2]}while(0);f=c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)+52>>2]|0;c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]=f;do if((f|0)>0){k=c[p>>2]|0;if((c[(c[n>>2]|0)+((c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]|0)==(c[q>>2]|0)){c[(c[n>>2]|0)+((c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0)*72|0)+40>>2]=k;break}if((c[(c[n>>2]|0)+((c[(c[n>>2]|0)+(k*72|0)+52>>2]|0)*72|0)+44>>2]|0)==(c[q>>2]|0))c[(c[n>>2]|0)+((c[(c[n>>2]|0)+((c[p>>2]|0)*72|0)+52>>2]|0)*72|0)+44>>2]=c[p>>2]}while(0);f=(c[n>>2]|0)+((c[p>>2]|0)*72|0)+24|0;k=(c[n>>2]|0)+((c[q>>2]|0)*72|0)+24|0;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[f+8>>2]=c[k+8>>2];c[f+12>>2]=c[k+12>>2];c[(c[n>>2]|0)+((c[q>>2]|0)*72|0)+68>>2]=2;continue}c[p>>2]=c[q>>2]}if((t|0)==34){i=h;return}}function qV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;if(+h[(c[g>>2]|0)+8>>3]>+h[(c[j>>2]|0)+8>>3]+1.0e-07){d=c[f>>2]|0;b=c[g>>2]|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];i=e;return 0}if(!(+N(+(+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3]))<=1.0e-07)){b=c[f>>2]|0;d=c[j>>2]|0;c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];i=e;return 0}d=c[f>>2]|0;if(+h[c[g>>2]>>3]>+h[c[j>>2]>>3]+1.0e-07){f=c[g>>2]|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];i=e;return 0}else{f=c[j>>2]|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];i=e;return 0}return 0}function rV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;if(+h[(c[g>>2]|0)+8>>3]<+h[(c[j>>2]|0)+8>>3]-1.0e-07){d=c[f>>2]|0;b=c[g>>2]|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];i=e;return 0}if(!(+N(+(+h[(c[g>>2]|0)+8>>3]-+h[(c[j>>2]|0)+8>>3]))<=1.0e-07)){b=c[f>>2]|0;d=c[j>>2]|0;c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];i=e;return 0}d=c[f>>2]|0;if(+h[c[g>>2]>>3]<+h[c[j>>2]>>3]){f=c[g>>2]|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];i=e;return 0}else{f=c[j>>2]|0;c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];i=e;return 0}return 0}function sV(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=bK(8)|0;c[e>>2]=a;if(!a){f=c[e>>2]|0;i=b;return f|0}c[(c[e>>2]|0)+4>>2]=c[d>>2];c[c[e>>2]>>2]=0;f=c[e>>2]|0;i=b;return f|0}function tV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(c[g>>2]|0){c[h>>2]=sV(c[g>>2]|0)|0;c[c[h>>2]>>2]=c[f>>2];c[e>>2]=c[h>>2];j=c[e>>2]|0;i=d;return j|0}else{c[e>>2]=c[f>>2];j=c[e>>2]|0;i=d;return j|0}return 0}function uV(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;while(1){f=c[d>>2]|0;if(!(c[c[d>>2]>>2]|0))break;c[e>>2]=c[f>>2];O4(c[d>>2]|0);c[d>>2]=c[e>>2]}O4(f);i=b;return}function vV(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a;d=bK(1992)|0;c[b>>2]=d;if(d){d=wV(c[b>>2]|0)|0;c[c[b>>2]>>2]=d}i=a;return c[b>>2]|0}function wV(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=CV(c[d>>2]|0)|0;c[(c[e>>2]|0)+4>>2]=0;a=(c[d>>2]|0)+1972|0;c[a>>2]=(c[a>>2]|0)+1;i=b;return c[e>>2]|0}function xV(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;AV(c[d>>2]|0,c[c[d>>2]>>2]|0)|0;O4(c[c[d>>2]>>2]|0);O4(c[d>>2]|0);i=b;return 0}function yV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[k>>2]=0;if(!(c[g>>2]|0))La(176617,176234,194,176242);if((c[(c[g>>2]|0)+4>>2]|0)<0)La(176254,176234,195,176242);if(!(c[h>>2]|0))La(176526,176234,196,176242);d=(c[f>>2]|0)+1952|0;c[d>>2]=(c[d>>2]|0)+1;d=(c[(c[g>>2]|0)+4>>2]|0)>0;c[j>>2]=0;if(!d){while(1){if((c[j>>2]|0)>=64)break;if((c[(c[g>>2]|0)+8+((c[j>>2]|0)*20|0)+16>>2]|0)!=0?(NV(c[h>>2]|0,(c[g>>2]|0)+8+((c[j>>2]|0)*20|0)|0)|0)!=0:0)c[k>>2]=tV(c[k>>2]|0,(c[g>>2]|0)+8+((c[j>>2]|0)*20|0)|0)|0;c[j>>2]=(c[j>>2]|0)+1}n=c[k>>2]|0;i=e;return n|0}while(1){if((c[j>>2]|0)>=64)break;do if((c[(c[g>>2]|0)+8+((c[j>>2]|0)*20|0)+16>>2]|0)!=0?(NV(c[h>>2]|0,(c[g>>2]|0)+8+((c[j>>2]|0)*20|0)|0)|0)!=0:0){c[l>>2]=yV(c[f>>2]|0,c[(c[g>>2]|0)+8+((c[j>>2]|0)*20|0)+16>>2]|0,c[h>>2]|0)|0;if(!(c[k>>2]|0)){c[k>>2]=c[l>>2];break}c[m>>2]=c[k>>2];while(1){if(!(c[c[m>>2]>>2]|0))break;c[m>>2]=c[c[m>>2]>>2]}c[c[m>>2]>>2]=c[l>>2]}while(0);c[j>>2]=(c[j>>2]|0)+1}n=c[k>>2]|0;i=e;return n|0}function zV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+96|0;h=g+84|0;j=g+80|0;k=g+76|0;l=g+72|0;m=g+68|0;n=g+64|0;o=g+60|0;p=g+56|0;q=g+36|0;r=g+32|0;s=g+16|0;t=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[p>>2]=0;c[r>>2]=0;if(!((c[j>>2]|0)!=0&(c[l>>2]|0)!=0))La(176440,176234,247,176268);if((c[m>>2]|0)<0)La(176280,176234,248,176268);if((c[m>>2]|0)>(c[(c[c[l>>2]>>2]|0)+4>>2]|0))La(176280,176234,248,176268);c[n>>2]=0;while(1){if((c[n>>2]|0)>=2)break;if((c[(c[j>>2]|0)+(c[n>>2]<<2)>>2]|0)>(c[(c[j>>2]|0)+(2+(c[n>>2]|0)<<2)>>2]|0)){u=9;break}c[n>>2]=(c[n>>2]|0)+1}if((u|0)==9)La(176315,176234,250,176268);do if(c[(c[h>>2]|0)+1912>>2]|0){u=c[h>>2]|0;if(c[(c[h>>2]|0)+1908>>2]|0){n=u+1924|0;c[n>>2]=(c[n>>2]|0)+1;break}else{n=u+1916|0;c[n>>2]=(c[n>>2]|0)+1;break}}while(0);if(!(c[(c[h>>2]|0)+1908>>2]|0)){n=(c[h>>2]|0)+1964|0;c[n>>2]=(c[n>>2]|0)+1}if(!(BV(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,c[c[l>>2]>>2]|0,p,c[m>>2]|0)|0)){v=c[r>>2]|0;i=g;return v|0}do if(c[(c[h>>2]|0)+1912>>2]|0){m=c[h>>2]|0;if(c[(c[h>>2]|0)+1908>>2]|0){k=m+1948|0;c[k>>2]=(c[k>>2]|0)+1;break}else{k=m+1944|0;c[k>>2]=(c[k>>2]|0)+1;break}}while(0);c[o>>2]=CV(c[h>>2]|0)|0;k=(c[h>>2]|0)+1976|0;c[k>>2]=(c[k>>2]|0)+1;c[(c[o>>2]|0)+4>>2]=(c[(c[c[l>>2]>>2]|0)+4>>2]|0)+1;FV(s,c[c[l>>2]>>2]|0);c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];c[q+12>>2]=c[s+12>>2];c[q+16>>2]=c[c[l>>2]>>2];HV(c[h>>2]|0,q,c[o>>2]|0,0)|0;FV(t,c[p>>2]|0);c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];c[q+12>>2]=c[t+12>>2];c[q+16>>2]=c[p>>2];HV(c[h>>2]|0,q,c[o>>2]|0,0)|0;c[c[l>>2]>>2]=c[o>>2];o=(c[h>>2]|0)+1980|0;c[o>>2]=(c[o>>2]|0)+2;c[r>>2]=1;v=c[r>>2]|0;i=g;return v|0}function AV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;b=(c[(c[f>>2]|0)+4>>2]|0)>0;c[g>>2]=0;if(!b){while(1){if((c[g>>2]|0)>=64)break;if((c[(c[f>>2]|0)+8+((c[g>>2]|0)*20|0)+16>>2]|0)!=0?(IV(c[f>>2]|0,c[g>>2]|0),b=(c[e>>2]|0)+1980|0,c[b>>2]=(c[b>>2]|0)+-1,(c[(c[e>>2]|0)+1912>>2]|0)!=0):0){b=(c[e>>2]|0)+1936|0;c[b>>2]=(c[b>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1}i=d;return 0}while(1){if((c[g>>2]|0)>=64)break;if(((c[(c[f>>2]|0)+8+((c[g>>2]|0)*20|0)+16>>2]|0)!=0?(AV(c[e>>2]|0,c[(c[f>>2]|0)+8+((c[g>>2]|0)*20|0)+16>>2]|0)|0)==0:0)?(O4(c[(c[f>>2]|0)+8+((c[g>>2]|0)*20|0)+16>>2]|0),IV(c[f>>2]|0,c[g>>2]|0),b=(c[e>>2]|0)+1980|0,c[b>>2]=(c[b>>2]|0)+-1,(c[(c[e>>2]|0)+1912>>2]|0)!=0):0){b=(c[e>>2]|0)+1936|0;c[b>>2]=(c[b>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1}i=d;return 0}function BV(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+112|0;j=h+100|0;k=h+96|0;l=h+92|0;m=h+88|0;n=h+84|0;o=h+80|0;p=h+76|0;q=h+72|0;r=h+52|0;s=h+48|0;t=h+32|0;u=h+16|0;v=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=0;c[s>>2]=0;if(!((c[l>>2]|0)!=0&(c[n>>2]|0)!=0&(c[o>>2]|0)!=0))La(176358,176234,311,176372);if((c[p>>2]|0)<0)La(176385,176234,312,176372);if((c[p>>2]|0)>(c[(c[n>>2]|0)+4>>2]|0))La(176385,176234,312,176372);do if(c[(c[k>>2]|0)+1912>>2]|0){g=c[k>>2]|0;if(c[(c[k>>2]|0)+1908>>2]|0){f=g+1948|0;c[f>>2]=(c[f>>2]|0)+1;break}else{f=g+1944|0;c[f>>2]=(c[f>>2]|0)+1;break}}while(0);if((c[(c[n>>2]|0)+4>>2]|0)<=(c[p>>2]|0)){if((c[(c[n>>2]|0)+4>>2]|0)!=(c[p>>2]|0))La(176417,176234,341,176372);f=c[l>>2]|0;c[r>>2]=c[f>>2];c[r+4>>2]=c[f+4>>2];c[r+8>>2]=c[f+8>>2];c[r+12>>2]=c[f+12>>2];c[r+16>>2]=c[m>>2];f=(c[k>>2]|0)+1980|0;c[f>>2]=(c[f>>2]|0)+1;c[j>>2]=HV(c[k>>2]|0,r,c[n>>2]|0,c[o>>2]|0)|0;w=c[j>>2]|0;i=h;return w|0}c[q>>2]=GV(c[l>>2]|0,c[n>>2]|0)|0;f=(BV(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[(c[n>>2]|0)+8+((c[q>>2]|0)*20|0)+16>>2]|0,s,c[p>>2]|0)|0)!=0;p=(c[n>>2]|0)+8+((c[q>>2]|0)*20|0)|0;if(f){FV(u,c[(c[n>>2]|0)+8+((c[q>>2]|0)*20|0)+16>>2]|0);c[p>>2]=c[u>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];c[r+16>>2]=c[s>>2];FV(v,c[s>>2]|0);c[r>>2]=c[v>>2];c[r+4>>2]=c[v+4>>2];c[r+8>>2]=c[v+8>>2];c[r+12>>2]=c[v+12>>2];v=(c[k>>2]|0)+1980|0;c[v>>2]=(c[v>>2]|0)+1;c[j>>2]=HV(c[k>>2]|0,r,c[n>>2]|0,c[o>>2]|0)|0;w=c[j>>2]|0;i=h;return w|0}else{MV(t,c[l>>2]|0,(c[n>>2]|0)+8+((c[q>>2]|0)*20|0)|0);c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];c[p+12>>2]=c[t+12>>2];c[j>>2]=0;w=c[j>>2]|0;i=h;return w|0}return 0}function CV(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=(c[d>>2]|0)+1968|0;c[a>>2]=(c[a>>2]|0)+1;c[e>>2]=N4(1288)|0;DV(c[e>>2]|0);i=b;return c[e>>2]|0}function DV(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[c[d>>2]>>2]=0;c[(c[d>>2]|0)+4>>2]=-1;c[e>>2]=0;while(1){if((c[e>>2]|0)>=64)break;EV((c[d>>2]|0)+8+((c[e>>2]|0)*20|0)|0);c[e>>2]=(c[e>>2]|0)+1}i=b;return}function EV(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;JV(c[d>>2]|0);c[(c[d>>2]|0)+16>>2]=0;i=b;return}function FV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+40|0;f=d+36|0;g=d+32|0;h=d+16|0;j=d;c[e>>2]=b;if(!(c[e>>2]|0))La(176617,176423,99,176430);JV(h);c[g>>2]=1;c[f>>2]=0;while(1){if((c[f>>2]|0)>=64)break;do if(c[(c[e>>2]|0)+8+((c[f>>2]|0)*20|0)+16>>2]|0){b=(c[e>>2]|0)+8+((c[f>>2]|0)*20|0)|0;if(c[g>>2]|0){c[h>>2]=c[b>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[g>>2]=0;break}else{MV(j,h,b);c[h>>2]=c[j>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];break}}while(0);c[f>>2]=(c[f>>2]|0)+1}c[a>>2]=c[h>>2];c[a+4>>2]=c[h+4>>2];c[a+8>>2]=c[h+8>>2];c[a+12>>2]=c[h+12>>2];i=d;return}function GV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+80|0;e=d+68|0;f=d+64|0;g=d+60|0;h=d+56|0;j=d+52|0;k=d+48|0;l=d+44|0;m=d+40|0;n=d+36|0;o=d+32|0;p=d+16|0;q=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;c[h>>2]=0;c[j>>2]=1;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;c[n>>2]=0;c[o>>2]=0;if(!((c[e>>2]|0)!=0&(c[f>>2]|0)!=0))La(176440,176423,125,176447);c[h>>2]=0;while(1){if((c[h>>2]|0)>=64)break;do if(c[(c[f>>2]|0)+8+((c[h>>2]|0)*20|0)+16>>2]|0){c[g>>2]=(c[f>>2]|0)+8+((c[h>>2]|0)*20|0);c[m>>2]=LV(c[g>>2]|0)|0;MV(q,c[e>>2]|0,c[g>>2]|0);c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2];b=LV(p)|0;c[k>>2]=b-(c[m>>2]|0);if((c[j>>2]|0)!=0?1:(c[k>>2]|0)<(c[l>>2]|0)){c[o>>2]=c[h>>2];c[n>>2]=c[m>>2];c[l>>2]=c[k>>2];c[j>>2]=0;break}if((c[k>>2]|0)==(c[l>>2]|0)?(c[m>>2]|0)<(c[n>>2]|0):0){c[o>>2]=c[h>>2];c[n>>2]=c[m>>2];c[l>>2]=c[k>>2]}}while(0);c[h>>2]=(c[h>>2]|0)+1}i=d;return c[o>>2]|0}function HV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[j>>2]|0))La(176639,176423,167,176458);if(!(c[k>>2]|0))La(176617,176423,168,176458);if((c[c[k>>2]>>2]|0)<64){c[m>>2]=0;while(1){if((c[m>>2]|0)>=64)break;n=c[m>>2]|0;if(!(c[(c[k>>2]|0)+8+((c[m>>2]|0)*20|0)+16>>2]|0)){o=9;break}c[m>>2]=n+1}if((o|0)==9){o=(c[k>>2]|0)+8+(n*20|0)|0;n=c[j>>2]|0;c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];c[o+12>>2]=c[n+12>>2];c[o+16>>2]=c[n+16>>2];n=c[k>>2]|0;c[n>>2]=(c[n>>2]|0)+1}if((c[m>>2]|0)>=64)La(176468,176423,178,176458);c[g>>2]=0;p=c[g>>2]|0;i=f;return p|0}do if(c[(c[h>>2]|0)+1912>>2]|0){m=c[h>>2]|0;if(c[(c[h>>2]|0)+1908>>2]|0){n=m+1948|0;c[n>>2]=(c[n>>2]|0)+1;break}else{n=m+1944|0;c[n>>2]=(c[n>>2]|0)+1;break}}while(0);if(!(c[l>>2]|0))La(176481,176423,187,176458);OV(c[h>>2]|0,c[k>>2]|0,c[j>>2]|0,c[l>>2]|0);l=c[h>>2]|0;if(!(c[(c[k>>2]|0)+4>>2]|0)){k=l+1972|0;c[k>>2]=(c[k>>2]|0)+1}else{k=l+1976|0;c[k>>2]=(c[k>>2]|0)+1}c[g>>2]=1;p=c[g>>2]|0;i=f;return p|0}function IV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(!((c[e>>2]|0)!=0&(c[f>>2]|0)>=0&(c[f>>2]|0)<64))La(176485,176423,201,176513);if(c[(c[e>>2]|0)+8+((c[f>>2]|0)*20|0)+16>>2]|0){EV((c[e>>2]|0)+8+((c[f>>2]|0)*20|0)|0);f=c[e>>2]|0;c[f>>2]=(c[f>>2]|0)+-1;i=d;return}else La(177040,176423,202,176513)}function JV(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;while(1){if((c[e>>2]|0)>=4)break;c[(c[d>>2]|0)+(c[e>>2]<<2)>>2]=0;c[e>>2]=(c[e>>2]|0)+1}i=b;return}function KV(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+8|0;e=b;c[d>>2]=1;c[d+8>>2]=-1;c[e>>2]=1;while(1){if((c[e>>2]|0)>=2)break;c[d+((c[e>>2]|0)+2<<2)>>2]=0;c[d+(c[e>>2]<<2)>>2]=0;c[e>>2]=(c[e>>2]|0)+1}c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];i=b;return}function LV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+32|0;d=b+8|0;e=b+24|0;f=b+20|0;g=b+16|0;h=b+12|0;j=b;c[f>>2]=a;if(!(c[f>>2]|0))La(176526,176528,130,176540);if((c[c[f>>2]>>2]|0)>(c[(c[f>>2]|0)+8>>2]|0)){c[e>>2]=0;k=c[e>>2]|0;i=b;return k|0}c[h>>2]=1;c[g>>2]=0;while(1){l=c[h>>2]|0;if((c[g>>2]|0)>=2){m=10;break}a=_(l,c[(c[f>>2]|0)+((c[g>>2]|0)+2<<2)>>2]|0)|0;n=j;c[n>>2]=a-(c[(c[f>>2]|0)+(c[g>>2]<<2)>>2]|0);c[n+4>>2]=0;n=j;a=c[n+4>>2]|0;if((a|0)>0|(a|0)==0&(c[n>>2]|0)>>>0>4294967295){m=8;break}c[h>>2]=c[j>>2];c[g>>2]=(c[g>>2]|0)+1}if((m|0)==8){$z(1,176549,d)|0;c[e>>2]=-1;k=c[e>>2]|0;i=b;return k|0}else if((m|0)==10){c[e>>2]=l;k=c[e>>2]|0;i=b;return k|0}return 0}function MV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e;c[f>>2]=b;c[g>>2]=d;if(!((c[f>>2]|0)!=0&(c[g>>2]|0)!=0))La(176582,176528,197,176590);d=c[g>>2]|0;if((c[c[f>>2]>>2]|0)>(c[(c[f>>2]|0)+8>>2]|0)){c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];i=e;return}if((c[d>>2]|0)>(c[(c[g>>2]|0)+8>>2]|0)){d=c[f>>2]|0;c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];i=e;return}c[h>>2]=0;while(1){if((c[h>>2]|0)>=2)break;d=c[h>>2]|0;if((c[(c[f>>2]|0)+(c[h>>2]<<2)>>2]|0)<(c[(c[g>>2]|0)+(c[h>>2]<<2)>>2]|0))l=c[(c[f>>2]|0)+(d<<2)>>2]|0;else l=c[(c[g>>2]|0)+(d<<2)>>2]|0;c[k+(c[h>>2]<<2)>>2]=l;c[j>>2]=(c[h>>2]|0)+2;d=c[j>>2]|0;if((c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]|0)>(c[(c[g>>2]|0)+(c[j>>2]<<2)>>2]|0))m=c[(c[f>>2]|0)+(d<<2)>>2]|0;else m=c[(c[g>>2]|0)+(d<<2)>>2]|0;c[k+(c[j>>2]<<2)>>2]=m;c[h>>2]=(c[h>>2]|0)+1}c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];c[a+12>>2]=c[k+12>>2];i=e;return}function NV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(!((c[f>>2]|0)!=0&(c[g>>2]|0)!=0))La(176602,176528,218,176609);c[h>>2]=0;while(1){if((c[h>>2]|0)>=2){k=9;break}c[j>>2]=(c[h>>2]|0)+2;if((c[(c[f>>2]|0)+(c[h>>2]<<2)>>2]|0)>(c[(c[g>>2]|0)+(c[j>>2]<<2)>>2]|0)){k=7;break}if((c[(c[g>>2]|0)+(c[h>>2]<<2)>>2]|0)>(c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]|0)){k=7;break}c[h>>2]=(c[h>>2]|0)+1}if((k|0)==7){c[e>>2]=0;l=c[e>>2]|0;i=d;return l|0}else if((k|0)==9){c[e>>2]=1;l=c[e>>2]|0;i=d;return l|0}return 0}function OV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(!(c[j>>2]|0))La(176617,176619,40,176629);if(!(c[k>>2]|0))La(176639,176619,41,176629);do if(c[(c[h>>2]|0)+1912>>2]|0){e=c[h>>2]|0;if(c[(c[h>>2]|0)+1908>>2]|0){d=e+1932|0;c[d>>2]=(c[d>>2]|0)+1;break}else{d=e+1928|0;c[d>>2]=(c[d>>2]|0)+1;break}}while(0);c[n>>2]=c[(c[j>>2]|0)+4>>2];PV(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);c[m>>2]=(c[h>>2]|0)+4+1320;QV(c[h>>2]|0);k=LV((c[m>>2]|0)+528|0)|0;c[o>>2]=k+(LV((c[m>>2]|0)+528+16|0)|0);if((c[(c[h>>2]|0)+1912>>2]|0)!=0?((c[o>>2]|0)!=0?(c[(c[h>>2]|0)+1908>>2]|0)==0:0):0){k=(c[h>>2]|0)+1960|0;g[k>>2]=+g[k>>2]+ +((c[(c[h>>2]|0)+4+1316>>2]|0)>>>0)/+(c[o>>2]|0)}o=CV(c[h>>2]|0)|0;c[c[l>>2]>>2]=o;o=c[n>>2]|0;c[(c[j>>2]|0)+4>>2]=o;c[(c[c[l>>2]>>2]|0)+4>>2]=o;RV(c[h>>2]|0,c[j>>2]|0,c[c[l>>2]>>2]|0,c[m>>2]|0);if(((c[c[j>>2]>>2]|0)+(c[c[c[l>>2]>>2]>>2]|0)|0)==65){i=f;return}else La(176641,176619,86,176629)}function PV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(!(c[g>>2]|0))La(176617,176619,106,177028);if(!(c[h>>2]|0))La(176639,176619,107,177028);c[j>>2]=0;while(1){if((c[j>>2]|0)>=64)break;if(!(c[(c[g>>2]|0)+8+((c[j>>2]|0)*20|0)+16>>2]|0)){l=8;break}d=(c[f>>2]|0)+4+((c[j>>2]|0)*20|0)|0;b=(c[g>>2]|0)+8+((c[j>>2]|0)*20|0)|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];c[d+16>>2]=c[b+16>>2];c[j>>2]=(c[j>>2]|0)+1}if((l|0)==8)La(177040,176619,111,177028);l=(c[f>>2]|0)+4+1280|0;b=c[h>>2]|0;c[l>>2]=c[b>>2];c[l+4>>2]=c[b+4>>2];c[l+8>>2]=c[b+8>>2];c[l+12>>2]=c[b+12>>2];c[l+16>>2]=c[b+16>>2];b=(c[f>>2]|0)+4+1300|0;l=(c[f>>2]|0)+4|0;c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];c[b+8>>2]=c[l+8>>2];c[b+12>>2]=c[l+12>>2];c[j>>2]=1;while(1){m=(c[f>>2]|0)+4+1300|0;if((c[j>>2]|0)>=65)break;MV(k,(c[f>>2]|0)+4+1300|0,(c[f>>2]|0)+4+((c[j>>2]|0)*20|0)|0);c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];c[m+8>>2]=c[k+8>>2];c[m+12>>2]=c[k+12>>2];c[j>>2]=(c[j>>2]|0)+1}j=LV(m)|0;c[(c[f>>2]|0)+4+1316>>2]=j;DV(c[g>>2]|0);i=e;return}function QV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+96|0;d=b+84|0;e=b+80|0;f=b+76|0;g=b+72|0;h=b+68|0;j=b+64|0;k=b+60|0;l=b+56|0;m=b+52|0;n=b+48|0;o=b+32|0;p=b+16|0;q=b;c[d>>2]=a;SV(c[d>>2]|0);TV(c[d>>2]|0);while(1){if(((c[(c[d>>2]|0)+4+1320+520>>2]|0)+(c[(c[d>>2]|0)+4+1320+520+4>>2]|0)|0)>=65)break;if((c[(c[d>>2]|0)+4+1320+520>>2]|0)>=(65-(c[(c[d>>2]|0)+1892>>2]|0)|0))break;if((c[(c[d>>2]|0)+4+1320+520+4>>2]|0)>=(65-(c[(c[d>>2]|0)+1892>>2]|0)|0))break;c[k>>2]=-1;c[f>>2]=0;while(1){if((c[f>>2]|0)>=65)break;do if(!(c[(c[d>>2]|0)+4+1320+260+(c[f>>2]<<2)>>2]|0)){c[e>>2]=(c[d>>2]|0)+4+((c[f>>2]|0)*20|0);MV(p,c[e>>2]|0,(c[d>>2]|0)+4+1320+528|0);c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];a=LV(o)|0;c[g>>2]=a-(c[(c[d>>2]|0)+4+1320+560>>2]|0);MV(q,c[e>>2]|0,(c[d>>2]|0)+4+1320+528+16|0);c[o>>2]=c[q>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];c[o+12>>2]=c[q+12>>2];a=LV(o)|0;c[h>>2]=a-(c[(c[d>>2]|0)+4+1320+560+4>>2]|0);c[j>>2]=(c[h>>2]|0)-(c[g>>2]|0);if((c[j>>2]|0)>=0)c[l>>2]=0;else{c[l>>2]=1;c[j>>2]=0-(c[j>>2]|0)}a=c[j>>2]|0;if((c[j>>2]|0)>(c[k>>2]|0)){c[k>>2]=a;c[m>>2]=c[f>>2];c[n>>2]=c[l>>2];break}if((a|0)==(c[k>>2]|0)?(c[(c[d>>2]|0)+4+1320+520+(c[l>>2]<<2)>>2]|0)<(c[(c[d>>2]|0)+4+1320+520+(c[n>>2]<<2)>>2]|0):0){c[m>>2]=c[f>>2];c[n>>2]=c[l>>2]}}while(0);c[f>>2]=(c[f>>2]|0)+1}UV(c[d>>2]|0,c[m>>2]|0,c[n>>2]|0)}a:do if(((c[(c[d>>2]|0)+4+1320+520>>2]|0)+(c[(c[d>>2]|0)+4+1320+520+4>>2]|0)|0)<65){c[l>>2]=0;if((c[(c[d>>2]|0)+4+1320+520>>2]|0)>=(65-(c[(c[d>>2]|0)+1892>>2]|0)|0))c[l>>2]=1;c[f>>2]=0;while(1){if((c[f>>2]|0)>=65)break a;if(!(c[(c[d>>2]|0)+4+1320+260+(c[f>>2]<<2)>>2]|0))UV(c[d>>2]|0,c[f>>2]|0,c[l>>2]|0);c[f>>2]=(c[f>>2]|0)+1}}while(0);if(((c[(c[d>>2]|0)+4+1320+520>>2]|0)+(c[(c[d>>2]|0)+4+1320+520+4>>2]|0)|0)!=65)La(176784,176619,210,176870);if((c[(c[d>>2]|0)+4+1320+520>>2]|0)<(c[(c[d>>2]|0)+1892>>2]|0))La(176881,176619,212,176870);if((c[(c[d>>2]|0)+4+1320+520+4>>2]|0)>=(c[(c[d>>2]|0)+1892>>2]|0)){i=b;return}else La(176881,176619,212,176870)}function RV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if(!(c[h>>2]|0))La(176617,176619,297,176681);if(!(c[j>>2]|0))La(176691,176619,298,176681);if(!(c[k>>2]|0))La(176693,176619,299,176681);c[l>>2]=0;while(1){if((c[l>>2]|0)>=65){m=17;break}if((c[(c[g>>2]|0)+4+1320+(c[l>>2]<<2)>>2]|0)!=0?(c[(c[g>>2]|0)+4+1320+(c[l>>2]<<2)>>2]|0)!=1:0){m=11;break}if(c[(c[g>>2]|0)+4+1320+(c[l>>2]<<2)>>2]|0){if((c[(c[g>>2]|0)+4+1320+(c[l>>2]<<2)>>2]|0)==1)HV(c[g>>2]|0,(c[g>>2]|0)+4+((c[l>>2]|0)*20|0)|0,c[j>>2]|0,0)|0}else HV(c[g>>2]|0,(c[g>>2]|0)+4+((c[l>>2]|0)*20|0)|0,c[h>>2]|0,0)|0;c[l>>2]=(c[l>>2]|0)+1}if((m|0)==11)La(176695,176619,303,176681);else if((m|0)==17){i=f;return}}function SV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b;c[d>>2]=a;c[(c[d>>2]|0)+4+1320+520+4>>2]=0;c[(c[d>>2]|0)+4+1320+520>>2]=0;a=(c[d>>2]|0)+4+1320+528|0;g=(c[d>>2]|0)+4+1320+528+16|0;KV(f);c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];c[(c[d>>2]|0)+4+1320+560+4>>2]=0;c[(c[d>>2]|0)+4+1320+560>>2]=0;c[e>>2]=0;while(1){if((c[e>>2]|0)>=65)break;c[(c[d>>2]|0)+4+1320+260+(c[e>>2]<<2)>>2]=0;c[(c[d>>2]|0)+4+1320+(c[e>>2]<<2)>>2]=-1;c[e>>2]=(c[e>>2]|0)+1}i=b;return}function TV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+320|0;d=b+316|0;e=b+312|0;f=b+308|0;g=b+304|0;h=b+300|0;j=b+296|0;k=b+292|0;l=b+32|0;m=b+16|0;n=b;c[d>>2]=a;c[e>>2]=0;while(1){if((c[e>>2]|0)>=65)break;a=LV((c[d>>2]|0)+4+((c[e>>2]|0)*20|0)|0)|0;c[l+(c[e>>2]<<2)>>2]=a;c[e>>2]=(c[e>>2]|0)+1}c[h>>2]=0;c[e>>2]=0;while(1){if((c[e>>2]|0)>=64)break;c[f>>2]=(c[e>>2]|0)+1;while(1){o=c[e>>2]|0;if((c[f>>2]|0)>=65)break;MV(n,(c[d>>2]|0)+4+(o*20|0)|0,(c[d>>2]|0)+4+((c[f>>2]|0)*20|0)|0);c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];a=LV(m)|0;c[g>>2]=a-(c[l+(c[e>>2]<<2)>>2]|0)-(c[l+(c[f>>2]<<2)>>2]|0);if((c[g>>2]|0)>>>0>(c[h>>2]|0)>>>0){c[h>>2]=c[g>>2];c[j>>2]=c[e>>2];c[k>>2]=c[f>>2]}c[f>>2]=(c[f>>2]|0)+1}c[e>>2]=o+1}UV(c[d>>2]|0,c[j>>2]|0,0);UV(c[d>>2]|0,c[k>>2]|0,1);i=b;return}function UV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(c[(c[f>>2]|0)+4+1320+260+(c[g>>2]<<2)>>2]|0)La(176984,176619,257,177019);c[(c[f>>2]|0)+4+1320+(c[g>>2]<<2)>>2]=c[h>>2];c[(c[f>>2]|0)+4+1320+260+(c[g>>2]<<2)>>2]=1;d=(c[f>>2]|0)+4+1320+528+(c[h>>2]<<4)|0;b=(c[f>>2]|0)+4+((c[g>>2]|0)*20|0)|0;if(!(c[(c[f>>2]|0)+4+1320+520+(c[h>>2]<<2)>>2]|0)){c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2]}else{MV(j,b,(c[f>>2]|0)+4+1320+528+(c[h>>2]<<4)|0);c[d>>2]=c[j>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2]}j=LV((c[f>>2]|0)+4+1320+528+(c[h>>2]<<4)|0)|0;c[(c[f>>2]|0)+4+1320+560+(c[h>>2]<<2)>>2]=j;j=(c[f>>2]|0)+4+1320+520+(c[h>>2]<<2)|0;c[j>>2]=(c[j>>2]|0)+1;i=e;return}function VV(){var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;e=i;i=i+1280|0;f=e+868|0;g=e+864|0;h=e+872|0;j=e+860|0;k=e+856|0;l=e+48|0;m=e+44|0;n=e+40|0;o=e+36|0;p=e+32|0;q=e+28|0;r=e+24|0;s=e+20|0;t=e+16|0;u=e+12|0;v=e+8|0;w=e+4|0;x=e;c[s>>2]=0;c[q>>2]=0;c[j>>2]=h;c[l>>2]=e+56;c[n>>2]=200;c[f>>2]=0;c[g>>2]=0;c[22927]=0;c[22928]=-2;c[k>>2]=c[j>>2];c[m>>2]=c[l>>2];a:while(1){b[c[k>>2]>>1]=c[f>>2];if(((c[j>>2]|0)+(c[n>>2]<<1)+-2|0)>>>0<=(c[k>>2]|0)>>>0){c[t>>2]=(((c[k>>2]|0)-(c[j>>2]|0)|0)/2|0)+1;if(1e4<=(c[n>>2]|0)>>>0){y=108;break}z=c[n>>2]<<1;c[n>>2]=z;c[n>>2]=1e4<(c[n>>2]|0)>>>0?1e4:z;c[u>>2]=c[j>>2];c[v>>2]=N4(((c[n>>2]|0)*6|0)+3|0)|0;if(!(c[v>>2]|0)){y=108;break}Z4(c[v>>2]|0,c[j>>2]|0,c[t>>2]<<1|0)|0;c[j>>2]=c[v>>2];c[w>>2]=(c[n>>2]<<1)+3;c[v>>2]=(c[v>>2]|0)+((((c[w>>2]|0)>>>0)/4|0)<<2);Z4(c[v>>2]|0,c[l>>2]|0,c[t>>2]<<2|0)|0;c[l>>2]=c[v>>2];c[x>>2]=(c[n>>2]<<2)+3;c[v>>2]=(c[v>>2]|0)+((((c[x>>2]|0)>>>0)/4|0)<<2);if((c[u>>2]|0)!=(h|0))O4(c[u>>2]|0);c[k>>2]=(c[j>>2]|0)+(c[t>>2]<<1)+-2;c[m>>2]=(c[l>>2]|0)+(c[t>>2]<<2)+-4;if(((c[j>>2]|0)+(c[n>>2]<<1)+-2|0)>>>0<=(c[k>>2]|0)>>>0){y=107;break}}if((c[f>>2]|0)==31){y=106;break}c[o>>2]=b[103706+(c[f>>2]<<1)>>1];do if((c[o>>2]|0)!=-82){if((c[22928]|0)==-2)c[22928]=tW()|0;if((c[22928]|0)<=0){c[q>>2]=0;c[22928]=0}else{if((c[22928]|0)>>>0<=295)A=d[177059+(c[22928]|0)>>0]|0;else A=2;c[q>>2]=A}c[o>>2]=(c[o>>2]|0)+(c[q>>2]|0);if(!((c[o>>2]|0)<0|271<(c[o>>2]|0))?(a[177355+(c[o>>2]|0)>>0]|0)==(c[q>>2]|0):0){c[o>>2]=a[177627+(c[o>>2]|0)>>0];if((c[o>>2]|0)<=0){c[o>>2]=0-(c[o>>2]|0);y=26;break}if(c[g>>2]|0)c[g>>2]=(c[g>>2]|0)+-1;c[22928]=-2;c[f>>2]=c[o>>2];z=(c[m>>2]|0)+4|0;c[m>>2]=z;c[z>>2]=c[22929]}else y=25}else y=25;while(0);if((y|0)==25){y=0;c[o>>2]=d[177899+(c[f>>2]|0)>>0];if(!(c[o>>2]|0)){if((c[22928]|0)!=-2)if((c[22928]|0)>>>0<=295)B=d[177059+(c[22928]|0)>>0]|0;else B=2;else B=-2;c[q>>2]=B;if(!(c[g>>2]|0)){c[22927]=(c[22927]|0)+1;pW(180146)}do if((c[g>>2]|0)==3)if((c[22928]|0)<=0)if(!(c[22928]|0)){y=107;break a}else break;else{gW(178296,c[q>>2]|0,91716);c[22928]=-2;break}while(0);c[g>>2]=3;while(1){c[o>>2]=b[103706+(c[f>>2]<<1)>>1];if((((c[o>>2]|0)!=-82?(c[o>>2]=(c[o>>2]|0)+1,0<=(c[o>>2]|0)&(c[o>>2]|0)<=271):0)?(a[177355+(c[o>>2]|0)>>0]|0)==1:0)?(c[o>>2]=a[177627+(c[o>>2]|0)>>0],0<(c[o>>2]|0)):0)break;if((c[k>>2]|0)==(c[j>>2]|0)){y=107;break a}gW(178430,d[178314+(c[f>>2]|0)>>0]|0,c[m>>2]|0);c[m>>2]=(c[m>>2]|0)+-4;c[k>>2]=(c[k>>2]|0)+-2;c[f>>2]=b[c[k>>2]>>1]}z=(c[m>>2]|0)+4|0;c[m>>2]=z;c[z>>2]=c[22929];c[f>>2]=c[o>>2]}else y=26}do if((y|0)==26){y=0;c[s>>2]=d[178015+(c[o>>2]|0)>>0];c[r>>2]=c[(c[m>>2]|0)+(1-(c[s>>2]|0)<<2)>>2];do switch(c[o>>2]|0){case 4:{y=29;break a;break}case 2:{c[22930]=XV(c[(c[m>>2]|0)+-4>>2]|0,2)|0;break}case 3:{c[22930]=XV(c[(c[m>>2]|0)+-4>>2]|0,1)|0;break}case 5:{c[r>>2]=ZV()|0;break}case 8:{_V(c[22934]|0);break}case 9:{$V(c[c[m>>2]>>2]|0);break}case 18:{aW(c[c[m>>2]>>2]|0);break}case 19:{bW();break}case 20:{aW(c[c[m>>2]>>2]|0);break}case 21:{bW();break}case 22:{aW(c[c[m>>2]>>2]|0);break}case 23:{bW();break}case 24:{aW(c[c[m>>2]>>2]|0);break}case 25:{bW();break}case 26:{aW(c[c[m>>2]>>2]|0);break}case 27:{bW();break}case 28:{aW(c[c[m>>2]>>2]|0);break}case 29:{bW();break}case 30:{aW(c[c[m>>2]>>2]|0);break}case 31:{bW();break}case 32:{aW(c[c[m>>2]>>2]|0);break}case 33:{bW();break}case 34:{c[r>>2]=c[(c[m>>2]|0)+-4>>2];break}case 35:{c[r>>2]=c[c[m>>2]>>2];break}case 38:{if((c[(c[22934]|0)+4>>2]|0)>>>0>=(c[(c[22934]|0)+8>>2]|0)>>>0)eA(c[22934]|0,1)|0;z=(c[22934]|0)+4|0;C=c[z>>2]|0;c[z>>2]=C+1;a[C>>0]=0;C=c[c[22934]>>2]|0;c[(c[22934]|0)+4>>2]=C;if(cW(C)|0){y=54;break a}c[(c[c[m>>2]>>2]|0)+80>>2]=c[22931];C=Nz(91748,c[12987]|0)|0;c[(c[c[m>>2]>>2]|0)+80+4>>2]=C;c[22931]=c[c[m>>2]>>2];c[(c[c[m>>2]>>2]|0)+108>>2]=c[c[22935]>>2];c[r>>2]=c[c[m>>2]>>2];break}case 39:{if((c[(c[22934]|0)+4>>2]|0)>>>0>=(c[(c[22934]|0)+8>>2]|0)>>>0)eA(c[22934]|0,1)|0;C=(c[22934]|0)+4|0;z=c[C>>2]|0;c[C>>2]=z+1;a[z>>0]=0;z=c[c[22934]>>2]|0;c[(c[22934]|0)+4>>2]=z;if(cW(z)|0){y=59;break a}c[r>>2]=c[22931];c[22931]=c[(c[22931]|0)+80>>2];break}case 40:{c[r>>2]=c[c[m>>2]>>2];break}case 41:{c[r>>2]=c[(c[m>>2]|0)+-4>>2];break}case 42:{c[r>>2]=c[(c[m>>2]|0)+-4>>2];break}case 43:{c[r>>2]=c[(c[m>>2]|0)+-4>>2];break}case 44:{c[r>>2]=c[(c[m>>2]|0)+-4>>2];break}case 45:{c[r>>2]=c[(c[m>>2]|0)+-4>>2];break}case 48:{c[r>>2]=c[c[m>>2]>>2];break}case 49:{c[r>>2]=c[c[m>>2]>>2];break}case 50:{a[(c[(c[m>>2]|0)+-8>>2]|0)+12>>0]=1;c[r>>2]=c[c[m>>2]>>2];break}case 51:{dW()|0;break}case 52:{c[r>>2]=eW()|0;break}case 53:{c[r>>2]=c[c[m>>2]>>2];break}case 54:{c[r>>2]=c[c[m>>2]>>2];break}case 55:{z=(c[(c[m>>2]|0)+-8>>2]|0)+100|0;a[z>>0]=d[z>>0]|1;c[r>>2]=c[c[m>>2]>>2];break}case 56:{fW(c[(c[m>>2]|0)+-4>>2]|0,c[c[m>>2]>>2]|0,1);break}case 57:{c[r>>2]=c[(c[m>>2]|0)+-12>>2];break}case 58:{fW(c[(c[m>>2]|0)+-4>>2]|0,c[c[m>>2]>>2]|0,2);break}case 59:{c[r>>2]=c[(c[m>>2]|0)+-12>>2];break}case 60:{fW(c[(c[m>>2]|0)+-4>>2]|0,c[c[m>>2]>>2]|0,3);break}case 61:{c[r>>2]=c[(c[m>>2]|0)+-12>>2];break}case 62:{fW(c[c[m>>2]>>2]|0,ZV()|0,2);break}case 63:{c[r>>2]=c[(c[m>>2]|0)+-8>>2];break}case 64:{c[r>>2]=c[(c[m>>2]|0)+-4>>2];break}case 65:{c[r>>2]=c[c[m>>2]>>2];break}default:{}}while(0);c[m>>2]=(c[m>>2]|0)+(0-(c[s>>2]|0)<<2);c[k>>2]=(c[k>>2]|0)+(0-(c[s>>2]|0)<<1);c[s>>2]=0;z=(c[m>>2]|0)+4|0;c[m>>2]=z;c[z>>2]=c[r>>2];c[o>>2]=d[178187+(c[o>>2]|0)>>0];c[f>>2]=(b[103938+((c[o>>2]|0)-41<<1)>>1]|0)+(b[c[k>>2]>>1]|0);if(0<=(c[f>>2]|0)&(c[f>>2]|0)<=271?(a[177355+(c[f>>2]|0)>>0]|0)==(b[c[k>>2]>>1]|0):0){c[f>>2]=a[177627+(c[f>>2]|0)>>0];break}c[f>>2]=a[178257+((c[o>>2]|0)-41)>>0]}while(0);c[k>>2]=(c[k>>2]|0)+2}if((y|0)==29){YV();y=107}else if((y|0)==54){pW(178085);YV();y=107}else if((y|0)==59){pW(178136);YV();y=107}else if((y|0)==106)c[p>>2]=0;else if((y|0)==108){pW(178445);c[p>>2]=2}if((y|0)==107)c[p>>2]=1;if((c[22928]|0)!=-2){if((c[22928]|0)>>>0<=295)D=d[177059+(c[22928]|0)>>0]|0;else D=2;c[q>>2]=D;gW(178462,c[q>>2]|0,91716)}c[m>>2]=(c[m>>2]|0)+(0-(c[s>>2]|0)<<2);c[k>>2]=(c[k>>2]|0)+(0-(c[s>>2]|0)<<1);while(1){if((c[k>>2]|0)==(c[j>>2]|0))break;gW(178492,d[178314+(b[c[k>>2]>>1]|0)>>0]|0,c[m>>2]|0);c[m>>2]=(c[m>>2]|0)+-4;c[k>>2]=(c[k>>2]|0)+-2}if((c[j>>2]|0)==(h|0)){E=c[p>>2]|0;i=e;return E|0}O4(c[j>>2]|0);E=c[p>>2]|0;i=e;return E|0}function WV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+176|0;f=e+40|0;g=e+36|0;h=e+32|0;j=e+16|0;k=e+8|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[l>>2]=0;c[l+4>>2]=0;c[22935]=l;c[22931]=0;c[22930]=0;c[22936]=c[(c[(c[(c[h>>2]|0)+52>>2]|0)+8>>2]|0)+144>>2];c[22932]=Nz(91784,c[12987]|0)|0;c[22933]=Nz(91820,c[12987]|0)|0;dA(j,128,e+48|0);c[22934]=j;if(rW(c[f>>2]|0,j,c[h>>2]|0)|0){c[c[g>>2]>>2]=2;c[k>>2]=0;m=c[22932]|0;Jz(m)|0;n=c[22933]|0;Jz(n)|0;c[22932]=0;c[22933]=0;c[22935]=0;hA(j);o=c[k>>2]|0;i=e;return o|0}else{VV()|0;h=sW()|0;c[c[g>>2]>>2]=h;c[k>>2]=c[22930];m=c[22932]|0;Jz(m)|0;n=c[22933]|0;Jz(n)|0;c[22932]=0;c[22933]=0;c[22935]=0;hA(j);o=c[k>>2]|0;i=e;return o|0}return 0}function XV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=bK(8)|0;a[(c[h>>2]|0)+4>>0]=c[g>>2];d=c[f>>2]|0;if((c[g>>2]|0)==2){c[c[h>>2]>>2]=d;j=c[h>>2]|0;i=e;return j|0}else{c[c[h>>2]>>2]=d;j=c[h>>2]|0;i=e;return j|0}return 0}function YV(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[b>>2]=c[22931];if(c[22930]|0){zT(c[22930]|0,1);c[22930]=0}c[22968]=65;while(1){if(!(c[b>>2]|0))break;c[d>>2]=c[(c[b>>2]|0)+80>>2];kW(c[b>>2]|0);c[b>>2]=c[d>>2]}c[22968]=53;c[22950]=66;Hb[c[c[91728>>2]>>2]&63](c[22932]|0,0,64)|0;c[22950]=53;c[22959]=67;Hb[c[c[91732>>2]>>2]&63](c[22933]|0,0,64)|0;c[22959]=53;nW();i=a;return}function ZV(){var a=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;i=i+32|0;d=a+16|0;e=a+12|0;f=a+8|0;g=a+4|0;h=a;c[e>>2]=c[22933];c[g>>2]=bK(40)|0;if(Pz(c[22932]|0)|0)$V(0);c[d>>2]=Pz(c[e>>2]|0)|0;b[(c[g>>2]|0)+4>>1]=c[d>>2];if(!(c[d>>2]|0)){j=c[e>>2]|0;k=c[j>>2]|0;l=c[e>>2]|0;Hb[k&63](l,0,64)|0;m=c[g>>2]|0;i=a;return m|0}c[h>>2]=0;n=bK((c[d>>2]|0)*24|0)|0;c[c[g>>2]>>2]=n;c[f>>2]=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,0,128)|0;while(1){if(!(c[f>>2]|0))break;n=(c[c[g>>2]>>2]|0)+((c[h>>2]|0)*24|0)|0;d=(c[f>>2]|0)+8|0;c[n>>2]=c[d>>2];c[n+4>>2]=c[d+4>>2];c[n+8>>2]=c[d+8>>2];c[n+12>>2]=c[d+12>>2];c[n+16>>2]=c[d+16>>2];c[n+20>>2]=c[d+20>>2];c[h>>2]=(c[h>>2]|0)+1;c[f>>2]=Hb[c[c[e>>2]>>2]&63](c[e>>2]|0,c[f>>2]|0,8)|0}j=c[e>>2]|0;k=c[j>>2]|0;l=c[e>>2]|0;Hb[k&63](l,0,64)|0;m=c[g>>2]|0;i=a;return m|0}function _V(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=bK(64)|0;if((c[(c[e>>2]|0)+4>>2]|0)>>>0>=(c[(c[e>>2]|0)+8>>2]|0)>>>0)eA(c[e>>2]|0,1)|0;b=(c[e>>2]|0)+4|0;g=c[b>>2]|0;c[b>>2]=g+1;a[g>>0]=0;g=c[c[e>>2]>>2]|0;c[(c[e>>2]|0)+4>>2]=g;e=M3(g)|0;c[(c[f>>2]|0)+8>>2]=e;c[(c[f>>2]|0)+8+4>>2]=c[c[22935]>>2];Hb[c[c[91728>>2]>>2]&63](c[22932]|0,c[f>>2]|0,1)|0;i=d;return}function $V(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=d;c[h>>2]=bK(32)|0;c[k>>2]=c[22932];c[g>>2]=Pz(c[k>>2]|0)|0;a[(c[h>>2]|0)+8+6>>0]=c[f>>2];if(!(c[g>>2]|0)){f=bK(56)|0;c[(c[h>>2]|0)+8>>2]=f;b[(c[h>>2]|0)+8+4>>1]=1;f=M3(178518)|0;c[c[(c[h>>2]|0)+8>>2]>>2]=f;c[(c[(c[h>>2]|0)+8>>2]|0)+4>>2]=c[c[22935]>>2];m=c[k>>2]|0;n=c[m>>2]|0;o=c[k>>2]|0;Hb[n&63](o,0,64)|0;p=c[22933]|0;q=c[p>>2]|0;r=c[22933]|0;s=c[h>>2]|0;Hb[q&63](r,s,1)|0;i=e;return}c[l>>2]=0;b[(c[h>>2]|0)+8+4>>1]=c[g>>2];f=bK((c[g>>2]|0)*56|0)|0;c[(c[h>>2]|0)+8>>2]=f;c[j>>2]=Lz(c[k>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;f=(c[(c[h>>2]|0)+8>>2]|0)+((c[l>>2]|0)*56|0)|0;g=(c[j>>2]|0)+8|0;d=f+56|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(d|0));c[l>>2]=(c[l>>2]|0)+1;c[j>>2]=c[c[j>>2]>>2]}m=c[k>>2]|0;n=c[m>>2]|0;o=c[k>>2]|0;Hb[n&63](o,0,64)|0;p=c[22933]|0;q=c[p>>2]|0;r=c[22933]|0;s=c[h>>2]|0;Hb[q&63](r,s,1)|0;i=e;return}function aW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=b+40|0;e=b+36|0;f=b+32|0;g=b;c[d>>2]=a;c[e>>2]=bK(8)|0;c[f>>2]=c[c[22935]>>2];a=c[d>>2]|0;c[g>>2]=c[a>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];if(c[f>>2]|0){if((c[g+4>>2]|0)==0?(c[(c[f>>2]|0)+4>>2]|0)!=0:0)c[g+4>>2]=c[(c[f>>2]|0)+4>>2];if(+h[g+16>>3]<0.0?+h[(c[f>>2]|0)+16>>3]>=0.0:0)h[g+16>>3]=+h[(c[f>>2]|0)+16>>3];if((c[g>>2]|0)==0?(c[c[f>>2]>>2]|0)!=0:0)c[g>>2]=c[c[f>>2]>>2];if(c[(c[f>>2]|0)+24>>2]&127){a=g+24|0;c[a>>2]=c[a>>2]&-128|(c[a>>2]&127|c[(c[f>>2]|0)+24>>2]&127)&127}}f=Hb[c[c[(c[91744>>2]|0)+144>>2]>>2]&63](c[(c[22936]|0)+144>>2]|0,g,1)|0;c[c[e>>2]>>2]=f;c[(c[e>>2]|0)+4>>2]=c[22935];c[22935]=c[e>>2];i=b;return}function bW(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[b>>2]=c[22935];c[d>>2]=c[(c[b>>2]|0)+4>>2];O4(c[b>>2]|0);c[22935]=c[d>>2];i=a;return}function cW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+4|0;f=d;g=d+8|0;c[f>>2]=b;while(1){b=c[f>>2]|0;c[f>>2]=b+1;h=a[b>>0]|0;a[g>>0]=h;if(!(h<<24>>24)){j=5;break}if((a[g>>0]|0)!=32){j=4;break}}if((j|0)==4){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}else if((j|0)==5){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function dW(){var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=Nz(91856,c[12987]|0)|0;c[f>>2]=c[22931];c[g>>2]=bK(16)|0;c[(c[g>>2]|0)+8>>2]=c[e>>2];if((d[(c[f>>2]|0)+112>>0]|0)&2)a[(c[g>>2]|0)+12>>0]=1;Hb[c[c[(c[f>>2]|0)+80+4>>2]>>2]&63](c[(c[f>>2]|0)+80+4>>2]|0,c[g>>2]|0,1)|0;i=b;return c[g>>2]|0}function eW(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a+4|0;d=a;c[b>>2]=c[22931];c[d>>2]=Hb[c[c[(c[b>>2]|0)+80+4>>2]>>2]&63](c[(c[b>>2]|0)+80+4>>2]|0,0,256)|0;i=a;return c[d>>2]|0}function fW(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=b;c[j>>2]=e;c[k>>2]=f;c[l>>2]=bK(16)|0;c[m>>2]=c[22931];c[n>>2]=Hb[c[c[(c[m>>2]|0)+80+4>>2]>>2]&63](c[(c[m>>2]|0)+80+4>>2]|0,0,256)|0;c[o>>2]=c[(c[n>>2]|0)+8>>2];c[(c[l>>2]|0)+8>>2]=c[h>>2];Hb[c[c[o>>2]>>2]&63](c[o>>2]|0,c[l>>2]|0,1)|0;a[(c[h>>2]|0)+88+4>>0]=c[k>>2];if((d[(c[m>>2]|0)+112>>0]|0)&1)a[(c[h>>2]|0)+100>>0]=1;if((c[k>>2]|0)==2){c[(c[h>>2]|0)+88>>2]=c[j>>2];i=g;return}m=c[j>>2]|0;if((c[k>>2]|0)==3){c[(c[h>>2]|0)+88>>2]=m;i=g;return}else{c[(c[h>>2]|0)+88>>2]=m;i=g;return}}function gW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+8|0;c[f>>2]=a;c[e+4>>2]=b;c[e>>2]=d;if(c[f>>2]|0){i=e;return}c[f>>2]=178509;i=e;return}function hW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[f>>2]|0);i=e;return}function iW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;Jz(c[(c[f>>2]|0)+8>>2]|0)|0;O4(c[f>>2]|0);i=e;return}function jW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;oW(c[(c[f>>2]|0)+8>>2]|0);O4(c[f>>2]|0);i=e;return}function kW(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;Jz(c[(c[d>>2]|0)+80+4>>2]|0)|0;wT(c[d>>2]|0);O4(c[d>>2]|0);i=b;return}function lW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;if(!(c[(c[f>>2]|0)+8>>2]|0)){g=c[f>>2]|0;O4(g);i=e;return}O4(c[(c[f>>2]|0)+8>>2]|0);g=c[f>>2]|0;O4(g);i=e;return}function mW(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+32|0;g=f+12|0;h=f+4|0;j=f;c[f+16>>2]=a;c[g>>2]=d;c[f+8>>2]=e;if(!(b[(c[g>>2]|0)+8+4>>1]|0)){k=c[g>>2]|0;O4(k);i=f;return}c[h>>2]=c[(c[g>>2]|0)+8>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(b[(c[g>>2]|0)+8+4>>1]|0))break;if(c[c[h>>2]>>2]|0)O4(c[c[h>>2]>>2]|0);c[h>>2]=(c[h>>2]|0)+56;c[j>>2]=(c[j>>2]|0)+1}O4(c[(c[g>>2]|0)+8>>2]|0);k=c[g>>2]|0;O4(k);i=f;return}function nW(){var a=0,b=0,d=0,e=0;a=i;i=i+16|0;b=a+4|0;d=a;c[b>>2]=c[22935];while(1){e=c[(c[b>>2]|0)+4>>2]|0;c[d>>2]=e;if(!e)break;O4(c[b>>2]|0);c[b>>2]=c[d>>2]}i=a;return}function oW(b){b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=(c[e>>2]|0)+88|0;if((a[(c[e>>2]|0)+88+4>>0]|0)!=1){if((a[b+4>>0]|0)==2)xT(c[(c[e>>2]|0)+88>>2]|0)}else kW(c[b>>2]|0);wT(c[e>>2]|0);O4(c[e>>2]|0);i=d;return}function pW(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=d+8|0;c[f>>2]=b;if(a[91925]|0){i=d;return}a[91925]=1;b=c[f>>2]|0;f=qW()|0;c[e>>2]=b;c[e+4>>2]=f;$z(1,178519,e)|0;uW();i=d;return}function qW(){return HY(c[22973]|0)|0}function rW(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;c[h>>2]=b;c[j>>2]=e;c[k>>2]=f;c[22976]=c[j>>2];dA(91908,128,0);c[22974]=c[h>>2];a[91927]=0;a[91924]=0;a[91925]=0;c[22984]=0;c[22985]=0;a[91926]=1;c[22973]=xY(NJ(d[(c[(c[(c[k>>2]|0)+52>>2]|0)+8>>2]|0)+115>>0]|0)|0)|0;AY(c[22973]|0,c[(c[(c[(c[k>>2]|0)+52>>2]|0)+8>>2]|0)+144>>2]|0);BY(c[22973]|0,68,23);CY(c[22973]|0,69);i=g;return 0}function sW(){var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a[91924]|a[91925];zY(c[22973]|0);hA(91908);i=b;return c[d>>2]|0}function tW(){var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;d=b;e=b+28|0;f=b+24|0;g=b+20|0;h=b+16|0;j=b+12|0;k=b+8|0;c[g>>2]=0;c[22975]=0;while(1){if((a[91927]|0)==2){l=3;break}do if(a[91927]|0){c[f>>2]=c[22974];if(!(a[c[f>>2]>>0]|0)){a[91927]=2;c[f>>2]=c[22987];c[h>>2]=N3(c[f>>2]|0)|0;break}else{c[g>>2]=yW(c[f>>2]|0,91908)|0;c[h>>2]=(c[g>>2]|0)-(c[f>>2]|0);break}}else{a[91927]=1;c[f>>2]=c[22986];c[h>>2]=N3(c[f>>2]|0)|0;c[g>>2]=0}while(0);c[22983]=c[22982];c[22985]=c[22984];c[22982]=c[f>>2];c[22984]=c[h>>2];m=(c[22978]|0)-(c[22977]|0)|0;c[j>>2]=m;n=c[22973]|0;if(m){if((c[22978]|0)>>>0>=(c[22979]|0)>>>0)eA(91908,1)|0;m=c[22978]|0;c[22978]=m+1;a[m>>0]=0;m=c[22977]|0;c[22978]=m;c[k>>2]=DY(n,m,c[j>>2]|0,0)|0}else c[k>>2]=DY(n,c[f>>2]|0,c[h>>2]|0,(c[h>>2]|0)!=0?0:1)|0;if(!((c[k>>2]|0)!=0|(a[91925]|0)!=0)){n=IY(GY(c[22973]|0)|0)|0;m=qW()|0;c[d>>2]=n;c[d+4>>2]=m;$z(1,178519,d)|0;uW();a[91925]=1;c[22975]=268}if(c[g>>2]|0)c[22974]=c[g>>2];if(c[22975]|0){l=19;break}}if((l|0)==3){c[e>>2]=-1;o=c[e>>2]|0;i=b;return o|0}else if((l|0)==19){c[e>>2]=c[22975];o=c[e>>2]|0;i=b;return o|0}return 0}function uW(){var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[(c[22976]|0)+4>>2]=c[c[22976]>>2];if((c[22985]|0)>0)fA(c[22976]|0,c[22983]|0,c[22985]|0)|0;fA(c[22976]|0,c[22982]|0,c[22984]|0)|0;if((c[(c[22976]|0)+4>>2]|0)>>>0>=(c[(c[22976]|0)+8>>2]|0)>>>0)eA(c[22976]|0,1)|0;e=(c[22976]|0)+4|0;f=c[e>>2]|0;c[e>>2]=f+1;a[f>>0]=0;f=c[c[22976]>>2]|0;c[(c[22976]|0)+4>>2]=f;c[d>>2]=f;$z(3,179741,d)|0;i=b;return}function vW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[k>>2]=c[g>>2];if(!(F3(c[h>>2]|0,178612)|0)){c[22929]=BW(c[j>>2]|0)|0;a[91926]=0;c[22975]=286;i=f;return}if((F3(c[h>>2]|0,178618)|0)!=0?(F3(c[h>>2]|0,178621)|0)!=0:0){if(!(F3(c[h>>2]|0,178624)|0)){a[91926]=1;c[22929]=CW(c[j>>2]|0)|0;c[22975]=287;i=f;return}if(!(F3(c[h>>2]|0,178632)|0)){c[22929]=DW(c[k>>2]|0,c[j>>2]|0,0,0)|0;c[22975]=288;i=f;return}if(!(F3(c[h>>2]|0,178637)|0)){c[22929]=DW(c[k>>2]|0,0,1,0)|0;c[22975]=290;i=f;return}if(!(F3(c[h>>2]|0,178653)|0)){c[22929]=DW(c[k>>2]|0,0,32,0)|0;c[22975]=295;i=f;return}if(!(F3(c[h>>2]|0,178639)|0)){c[22929]=DW(c[k>>2]|0,0,4,1)|0;c[22975]=291;i=f;return}if(!(F3(c[h>>2]|0,178641)|0)){c[22929]=DW(c[k>>2]|0,0,64,1)|0;c[22975]=292;i=f;return}if(!(F3(c[h>>2]|0,178643)|0)){c[22929]=DW(c[k>>2]|0,0,2,0)|0;c[22975]=289;i=f;return}if(!(F3(c[h>>2]|0,178645)|0)){c[22929]=DW(c[k>>2]|0,0,8,0)|0;c[22975]=293;i=f;return}if(!(F3(c[h>>2]|0,178649)|0)){c[22929]=DW(c[k>>2]|0,0,16,0)|0;c[22975]=294;i=f;return}if(!(F3(c[h>>2]|0,178655)|0)){EW(c[j>>2]|0);c[22975]=283;i=f;return}if(!(F3(c[h>>2]|0,178658)|0)){c[22975]=277;i=f;return}if(!(F3(c[h>>2]|0,178661)|0)){c[22975]=280;i=f;return}if(!(F3(c[h>>2]|0,178664)|0)){c[22929]=FW(c[j>>2]|0)|0;c[22975]=285;i=f;return}if(!(F3(c[h>>2]|0,178627)|0)){c[22975]=262;i=f;return}else{AW(c[h>>2]|0);i=f;return}}a[91926]=0;c[22975]=260;i=f;return}function wW(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[e+4>>2]=b;c[f>>2]=d;if(!(F3(c[f>>2]|0,178612)|0)){c[22975]=264;a[91926]=1;i=e;return}if((F3(c[f>>2]|0,178618)|0)!=0?(F3(c[f>>2]|0,178621)|0)!=0:0){if(!(F3(c[f>>2]|0,178624)|0)){c[22975]=265;a[91926]=0;i=e;return}if(!(F3(c[f>>2]|0,178627)|0)){c[22975]=263;i=e;return}if(!(F3(c[f>>2]|0,178632)|0)){c[22975]=266;i=e;return}if(!(F3(c[f>>2]|0,178637)|0)){c[22975]=270;i=e;return}if(!(F3(c[f>>2]|0,178639)|0)){c[22975]=271;i=e;return}if(!(F3(c[f>>2]|0,178641)|0)){c[22975]=272;i=e;return}if(!(F3(c[f>>2]|0,178643)|0)){c[22975]=269;i=e;return}if(!(F3(c[f>>2]|0,178645)|0)){c[22975]=273;i=e;return}if(!(F3(c[f>>2]|0,178649)|0)){c[22975]=274;i=e;return}if(!(F3(c[f>>2]|0,178653)|0)){c[22975]=275;i=e;return}if(!(F3(c[f>>2]|0,178655)|0))if((c[22975]|0)==283){c[22975]=282;i=e;return}else{c[22975]=258;i=e;return}if(!(F3(c[f>>2]|0,178658)|0))if((c[22975]|0)==277){c[22975]=276;i=e;return}else{c[22975]=278;i=e;return}if(!(F3(c[f>>2]|0,178661)|0))if((c[22975]|0)==280){c[22975]=279;i=e;return}else{c[22975]=281;i=e;return}if(F3(c[f>>2]|0,178664)|0){AW(c[f>>2]|0);i=e;return}if((c[22975]|0)==285){c[22975]=284;i=e;return}else{c[22975]=259;i=e;return}}c[22975]=261;i=e;return}function xW(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;n=g+24|0;c[g+20>>2]=b;c[h>>2]=e;c[j>>2]=f;c[m>>2]=0;if(!(a[91926]|0)){i=g;return}c[k>>2]=c[j>>2];while(1){if(!(c[k>>2]|0))break;j=c[h>>2]|0;c[h>>2]=j+1;a[n>>0]=a[j>>0]|0;if((d[n>>0]|0)>=32){c[m>>2]=(c[m>>2]|0)+1;if((c[(c[22976]|0)+4>>2]|0)>>>0>=(c[(c[22976]|0)+8>>2]|0)>>>0)eA(c[22976]|0,1)|0;j=a[n>>0]|0;f=(c[22976]|0)+4|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e>>0]=j;c[l>>2]=j&255}c[k>>2]=(c[k>>2]|0)+-1}if(!(c[m>>2]|0)){i=g;return}c[22975]=267;i=g;return}function yW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e;g=e+16|0;h=e+12|0;j=e+8|0;k=e+20|0;l=e+4|0;c[g>>2]=b;c[h>>2]=d;c[j>>2]=(c[g>>2]|0)+1;if((a[c[g>>2]>>0]|0)==60){if((a[c[j>>2]>>0]|0)==33?(P3((c[j>>2]|0)+1|0,178535,2)|0)==0:0)c[j>>2]=zW((c[j>>2]|0)+3|0)|0;else m=5;a:do if((m|0)==5)while(1){m=0;if(!(a[c[j>>2]>>0]|0))break a;if((a[c[j>>2]>>0]|0)==62)break a;c[j>>2]=(c[j>>2]|0)+1;m=5}while(0);if((a[c[j>>2]>>0]|0)!=62){$z(0,178538,f)|0;a[91924]=1;n=c[j>>2]|0;i=e;return n|0}else{c[j>>2]=(c[j>>2]|0)+1;n=c[j>>2]|0;i=e;return n|0}}else{c[j>>2]=c[g>>2];while(1){g=a[c[j>>2]>>0]|0;a[k>>0]=g;if(!(g<<24>>24)){m=20;break}if((a[k>>0]|0)==60){m=20;break}if((a[k>>0]|0)==38?(a[(c[j>>2]|0)+1>>0]|0)!=35:0){c[j>>2]=IO((c[j>>2]|0)+1|0,c[h>>2]|0)|0;continue}if((c[(c[h>>2]|0)+4>>2]|0)>>>0>=(c[(c[h>>2]|0)+8>>2]|0)>>>0)eA(c[h>>2]|0,1)|0;g=a[k>>0]|0;f=(c[h>>2]|0)+4|0;d=c[f>>2]|0;c[f>>2]=d+1;a[d>>0]=g;c[l>>2]=g&255;c[j>>2]=(c[j>>2]|0)+1}if((m|0)==20){n=c[j>>2]|0;i=e;return n|0}}return 0}function zW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;j=d+20|0;k=d+4|0;c[f>>2]=b;c[g>>2]=1;c[h>>2]=c[f>>2];while(1){if(!(c[g>>2]|0))break;b=c[h>>2]|0;c[h>>2]=b+1;l=a[b>>0]|0;a[j>>0]=l;if(!(l<<24>>24))break;if((a[j>>0]|0)==60){c[g>>2]=(c[g>>2]|0)+1;continue}if((a[j>>0]|0)!=62)continue;c[g>>2]=(c[g>>2]|0)+-1}c[h>>2]=(c[h>>2]|0)+-1;if(!(a[c[h>>2]>>0]|0)){m=c[h>>2]|0;i=d;return m|0}c[k>>2]=(c[h>>2]|0)+-2;if((c[k>>2]|0)>>>0>=(c[f>>2]|0)>>>0?(P3(c[k>>2]|0,178535,2)|0)==0:0){m=c[h>>2]|0;i=d;return m|0}$z(0,178579,e)|0;a[91924]=1;m=c[h>>2]|0;i=d;return m|0}function AW(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=d+8|0;c[f>>2]=b;c[22975]=268;a[91925]=1;b=c[f>>2]|0;f=qW()|0;c[e>>2]=b;c[e+4>>2]=f;$z(1,178668,e)|0;i=d;return}function BW(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=bK(120)|0;c[(c[f>>2]|0)+100>>2]=-1;a[(c[f>>2]|0)+88>>0]=-1;GW(c[f>>2]|0,92176,22,c[e>>2]|0,179620);i=d;return c[f>>2]|0}function CW(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=bK(104)|0;b[(c[f>>2]|0)+80>>1]=1;b[(c[f>>2]|0)+82>>1]=1;GW(c[f>>2]|0,92e3,22,c[e>>2]|0,178974);i=d;return c[f>>2]|0}function DW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0;f=i;i=i+48|0;g=f+44|0;j=f+40|0;k=f+36|0;l=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[f+32>>2]=e;c[l>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;c[l+28>>2]=0;h[l+16>>3]=-1.0;e=l+24|0;c[e>>2]=c[e>>2]&-128|c[k>>2]&127;if(c[j>>2]|0)GW(l,91976,3,c[j>>2]|0,178825);j=Hb[c[c[(c[g>>2]|0)+144>>2]>>2]&63](c[(c[g>>2]|0)+144>>2]|0,l,1)|0;i=f;return j|0}function EW(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[22929]=0;GW(91716,91968,1,c[d>>2]|0,178761);i=b;return}function FW(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=bK(40)|0;GW(c[e>>2]|0,91952,2,c[d>>2]|0,178707);i=b;return c[e>>2]|0}function GW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=h;k=h+44|0;l=h+40|0;m=h+36|0;n=h+32|0;o=h+28|0;p=h+24|0;q=h+20|0;r=h+16|0;s=h+8|0;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;while(1){g=c[n>>2]|0;c[n>>2]=g+4;f=c[g>>2]|0;c[p>>2]=f;if(!f)break;f=c[n>>2]|0;c[n>>2]=f+4;c[q>>2]=c[f>>2];c[s>>2]=c[p>>2];c[r>>2]=v3(s,c[l>>2]|0,c[m>>2]|0,8,104)|0;if(c[r>>2]|0){f=Ob[c[(c[r>>2]|0)+4>>2]&127](c[k>>2]|0,c[q>>2]|0)|0;a[91924]=a[91924]|f;continue}else{f=c[o>>2]|0;c[j>>2]=c[p>>2];c[j+4>>2]=f;$z(0,178713,j)|0;a[91924]=1;continue}}i=h;return}function HW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=F3(c[c[e>>2]>>2]|0,c[c[f>>2]>>2]|0)|0;i=d;return b|0}function IW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[(c[e>>2]|0)+36>>2]=b;i=d;return 0}function JW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[(c[e>>2]|0)+32>>2]=b;i=d;return 0}function KW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e;g=e+12|0;h=e+8|0;j=e+4|0;k=e+16|0;c[g>>2]=b;c[h>>2]=d;c[j>>2]=0;a[k>>0]=I1(a[c[h>>2]>>0]|0)|0;if((a[k>>0]|0)==82?(F3((c[h>>2]|0)+1|0,178772)|0)==0:0){c[c[g>>2]>>2]=114;l=c[j>>2]|0;i=e;return l|0}if((a[k>>0]|0)!=76?(F3((c[h>>2]|0)+1|0,178777)|0)!=0:0){if((a[k>>0]|0)!=67?(F3((c[h>>2]|0)+1|0,178781)|0)==0:0){c[f>>2]=c[h>>2];$z(0,178787,f)|0;c[j>>2]=1;l=c[j>>2]|0;i=e;return l|0}c[c[g>>2]>>2]=110;l=c[j>>2]|0;i=e;return l|0}c[c[g>>2]>>2]=108;l=c[j>>2]|0;i=e;return l|0}function LW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[(c[e>>2]|0)+4>>2]=c[f>>2];i=d;return 0}function MW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[e>>2]>>2]=c[f>>2];i=d;return 0}function NW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if(OW(c[g>>2]|0,178854,0,255,j)|0){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}else{h[(c[f>>2]|0)+16>>3]=+(c[j>>2]|0);c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function OW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+80|0;h=g+24|0;j=g+8|0;k=g;l=g+64|0;m=g+60|0;n=g+56|0;o=g+52|0;p=g+48|0;q=g+44|0;r=g+40|0;s=g+36|0;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=0;c[s>>2]=z3(c[l>>2]|0,r,10)|0;if((c[r>>2]|0)==(c[l>>2]|0)){r=c[l>>2]|0;c[k>>2]=c[m>>2];c[k+4>>2]=r;$z(0,178865,k)|0;c[q>>2]=1;t=c[q>>2]|0;i=g;return t|0}if((c[s>>2]|0)>(c[o>>2]|0)){k=c[l>>2]|0;r=c[o>>2]|0;c[j>>2]=c[m>>2];c[j+4>>2]=k;c[j+8>>2]=r;$z(0,178896,j)|0;c[q>>2]=1;t=c[q>>2]|0;i=g;return t|0}if((c[s>>2]|0)<(c[n>>2]|0)){j=c[l>>2]|0;l=c[n>>2]|0;c[h>>2]=c[m>>2];c[h+4>>2]=j;c[h+8>>2]=l;$z(0,178935,h)|0;c[q>>2]=1;t=c[q>>2]|0;i=g;return t|0}else{c[c[p>>2]>>2]=c[s>>2];t=c[q>>2]|0;i=g;return t|0}return 0}function PW(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g;j=g+12|0;k=g+8|0;l=g+4|0;m=g+16|0;c[j>>2]=d;c[k>>2]=f;c[l>>2]=0;a[m>>0]=I1(a[c[k>>2]>>0]|0)|0;if((a[m>>0]|0)==76?(F3((c[k>>2]|0)+1|0,178777)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|4}else n=4;do if((n|0)==4){if((a[m>>0]|0)==82?(F3((c[k>>2]|0)+1|0,178772)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|2;break}if((a[m>>0]|0)==84?(F3((c[k>>2]|0)+1|0,179572)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|6;break}if((a[m>>0]|0)==67?(F3((c[k>>2]|0)+1|0,178781)|0)==0:0)break;c[l>>2]=1}while(0);if(!(c[l>>2]|0)){o=c[l>>2]|0;i=g;return o|0}c[h>>2]=c[k>>2];$z(0,179576,h)|0;o=c[l>>2]|0;i=g;return o|0}function QW(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g;j=g+12|0;k=g+8|0;l=g+4|0;m=g+16|0;c[j>>2]=d;c[k>>2]=f;c[l>>2]=0;a[m>>0]=I1(a[c[k>>2]>>0]|0)|0;if((a[m>>0]|0)==76?(F3((c[k>>2]|0)+1|0,178777)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|512}else n=4;do if((n|0)==4){if((a[m>>0]|0)==82?(F3((c[k>>2]|0)+1|0,178772)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|256;break}if((a[m>>0]|0)==67?(F3((c[k>>2]|0)+1|0,178781)|0)==0:0)break;c[l>>2]=1}while(0);if(!(c[l>>2]|0)){o=c[l>>2]|0;i=g;return o|0}c[h>>2]=c[k>>2];$z(0,179527,h)|0;o=c[l>>2]|0;i=g;return o|0}function RW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[(c[e>>2]|0)+20>>2]=b;i=d;return 0}function SW(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[j>>2]=d;c[k>>2]=f;if(OW(c[k>>2]|0,179520,0,255,l)|0){c[h>>2]=1;m=c[h>>2]|0;i=g;return m|0}else{a[(c[j>>2]|0)+33>>0]=c[l>>2];l=(c[j>>2]|0)+36|0;b[l>>1]=e[l>>1]|0|32;c[h>>2]=0;m=c[h>>2]|0;i=g;return m|0}return 0}function TW(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[j>>2]=d;c[k>>2]=f;if(OW(c[k>>2]|0,179508,0,255,l)|0){c[h>>2]=1;m=c[h>>2]|0;i=g;return m|0}else{a[(c[j>>2]|0)+34>>0]=c[l>>2];l=(c[j>>2]|0)+36|0;b[l>>1]=e[l>>1]|0|64;c[h>>2]=0;m=c[h>>2]|0;i=g;return m|0}return 0}function UW(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[j>>2]=d;c[k>>2]=f;if(OW(c[k>>2]|0,179496,-128,127,l)|0){c[h>>2]=1;m=c[h>>2]|0;i=g;return m|0}else{a[(c[j>>2]|0)+32>>0]=c[l>>2];l=(c[j>>2]|0)+36|0;b[l>>1]=e[l>>1]|0|128;c[h>>2]=0;m=c[h>>2]|0;i=g;return m|0}return 0}function VW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[(c[e>>2]|0)+24>>2]=b;i=d;return 0}function WW(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;c[h>>2]=a;c[j>>2]=d;do if(!(OW(c[j>>2]|0,179451,0,65535,k)|0))if(!(c[k>>2]|0)){$z(0,179459,f)|0;c[g>>2]=1;break}else{b[(c[h>>2]|0)+80>>1]=c[k>>2];c[g>>2]=0;break}else c[g>>2]=1;while(0);i=e;return c[g>>2]|0}function XW(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h;k=h+12|0;l=h+8|0;m=h+4|0;n=h+16|0;c[k>>2]=f;c[l>>2]=g;c[m>>2]=0;a[n>>0]=I1(d[c[l>>2]>>0]|0)|0;if((a[n>>0]|0)==84?(F3((c[l>>2]|0)+1|0,179400)|0)==0:0){g=(c[k>>2]|0)+36|0;b[g>>1]=e[g>>1]|1;o=c[m>>2]|0;i=h;return o|0}if((a[n>>0]|0)==70?(F3((c[l>>2]|0)+1|0,179404)|0)==0:0){o=c[m>>2]|0;i=h;return o|0}c[j>>2]=c[l>>2];$z(0,179409,j)|0;c[m>>2]=1;o=c[m>>2]|0;i=h;return o|0}function YW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(OW(c[g>>2]|0,179386,0,360,h)|0){c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}else{c[(c[f>>2]|0)+28>>2]=c[h>>2]&65535;c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function ZW(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=d;if(OW(c[h>>2]|0,179379,0,65535,j)|0){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}else{b[(c[g>>2]|0)+40>>1]=c[j>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}return 0}function _W(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[c[e>>2]>>2]=b;i=d;return 0}function $W(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[(c[e>>2]|0)+16>>2]=b;i=d;return 0}function aX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[(c[e>>2]|0)+4>>2]=b;i=d;return 0}function bX(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;c[h>>2]=a;c[j>>2]=d;do if(!(OW(c[j>>2]|0,179334,0,65535,k)|0))if(!(c[k>>2]|0)){$z(0,179342,f)|0;c[g>>2]=1;break}else{b[(c[h>>2]|0)+82>>1]=c[k>>2];c[g>>2]=0;break}else c[g>>2]=1;while(0);i=e;return c[g>>2]|0}function cX(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g;j=g+12|0;k=g+8|0;l=g+16|0;m=g+18|0;c[j>>2]=d;c[k>>2]=f;b[l>>1]=0;a:while(1){f=c[k>>2]|0;c[k>>2]=f+1;d=a[f>>0]|0;a[m>>0]=d;if(!(d<<24>>24))break;switch(H1(a[m>>0]|0)|0){case 108:{b[l>>1]=e[l>>1]|1024;continue a;break}case 116:{b[l>>1]=e[l>>1]|2048;continue a;break}case 114:{b[l>>1]=e[l>>1]|4096;continue a;break}case 98:{b[l>>1]=e[l>>1]|8192;continue a;break}default:{d=a[m>>0]|0;c[h>>2]=a[m>>0];c[h+4>>2]=d;$z(0,179281,h)|0;continue a}}}if((e[l>>1]|0)==15360){i=g;return 0}h=(c[j>>2]|0)+36|0;b[h>>1]=e[h>>1]|e[l>>1];i=g;return 0}function dX(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+48|0;h=g+8|0;j=g;k=g+28|0;l=g+24|0;m=g+20|0;n=g+32|0;o=g+16|0;p=g+12|0;c[k>>2]=d;c[l>>2]=f;c[m>>2]=0;c[p>>2]=M3(c[l>>2]|0)|0;c[o>>2]=V3(c[p>>2]|0,179191)|0;while(1){if(!(c[o>>2]|0))break;a[n>>0]=I1(a[c[o>>2]>>0]|0)|0;l=c[o>>2]|0;do if((a[n>>0]|0)==82){if(!(F3(l+1|0,179194)|0)){f=(c[k>>2]|0)+42|0;b[f>>1]=e[f>>1]|4;break}if(F3((c[o>>2]|0)+1|0,179201)|0){c[j>>2]=c[o>>2];$z(0,179207,j)|0;c[m>>2]=1;break}else{f=(c[k>>2]|0)+42|0;b[f>>1]=e[f>>1]|2;break}}else{if(!(F3(l,179245)|0)){f=(c[k>>2]|0)+42|0;b[f>>1]=e[f>>1]&-385;break}if((F3(c[o>>2]|0,179251)|0)!=0?(F3(c[o>>2]|0,179261)|0)!=0:0){if(!(F3(c[o>>2]|0,179267)|0)){f=(c[k>>2]|0)+42|0;b[f>>1]=e[f>>1]|128;break}if(F3(c[o>>2]|0,179274)|0){c[h>>2]=c[o>>2];$z(0,179207,h)|0;c[m>>2]=1;break}else{f=(c[k>>2]|0)+42|0;b[f>>1]=e[f>>1]|256;break}}f=(c[k>>2]|0)+42|0;b[f>>1]=e[f>>1]|32}while(0);c[o>>2]=V3(0,179191)|0}O4(c[p>>2]|0);i=g;return c[m>>2]|0}function eX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[(c[e>>2]|0)+8>>2]=b;i=d;return 0}function fX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=M3(c[f>>2]|0)|0;c[(c[e>>2]|0)+12>>2]=b;i=d;return 0}function gX(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+12|0;k=g+8|0;l=g+4|0;m=g+16|0;c[j>>2]=d;c[k>>2]=f;c[l>>2]=0;a[m>>0]=I1(a[c[k>>2]>>0]|0)|0;if((a[m>>0]|0)==66?(F3((c[k>>2]|0)+1|0,179137)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|16;n=c[l>>2]|0;i=g;return n|0}if((a[m>>0]|0)==84?(F3((c[k>>2]|0)+1|0,179143)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|8;n=c[l>>2]|0;i=g;return n|0}if((a[m>>0]|0)==77?(F3((c[k>>2]|0)+1|0,179146)|0)==0:0){n=c[l>>2]|0;i=g;return n|0}c[h>>2]=c[k>>2];$z(0,179152,h)|0;c[l>>2]=1;n=c[l>>2]|0;i=g;return n|0}function hX(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=a;c[h>>2]=d;if(OW(c[h>>2]|0,179131,0,65535,j)|0){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}else{b[(c[g>>2]|0)+38>>1]=c[j>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}return 0}function iX(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+12|0;k=g+8|0;l=g+4|0;m=g+16|0;c[j>>2]=d;c[k>>2]=f;c[l>>2]=0;a[m>>0]=I1(a[c[k>>2]>>0]|0)|0;if((a[m>>0]|0)==76?(F3((c[k>>2]|0)+1|0,178777)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|4;n=c[l>>2]|0;i=g;return n|0}if((a[m>>0]|0)==82?(F3((c[k>>2]|0)+1|0,178772)|0)==0:0){f=(c[j>>2]|0)+36|0;b[f>>1]=e[f>>1]|2;n=c[l>>2]|0;i=g;return n|0}if((a[m>>0]|0)==67?(F3((c[k>>2]|0)+1|0,178781)|0)==0:0){n=c[l>>2]|0;i=g;return n|0}c[h>>2]=c[k>>2];$z(0,178787,h)|0;c[l>>2]=1;n=c[l>>2]|0;i=g;return n|0}function jX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if(OW(c[h>>2]|0,179729,0,127,j)|0){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}else{a[(c[g>>2]|0)+88>>0]=c[j>>2];c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}return 0}function kX(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=f+12|0;j=f+8|0;k=f+4|0;c[j>>2]=b;c[k>>2]=e;if((a[c[k>>2]>>0]|0)!=42){c[g>>2]=c[k>>2];$z(0,179689,g)|0;c[h>>2]=1;l=c[h>>2]|0;i=f;return l|0}else{g=(c[j>>2]|0)+112|0;a[g>>0]=d[g>>0]|1;c[h>>2]=0;l=c[h>>2]|0;i=f;return l|0}return 0}function lX(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+16|0;g=f;h=f+12|0;j=f+8|0;k=f+4|0;c[j>>2]=b;c[k>>2]=e;if((a[c[k>>2]>>0]|0)!=42){c[g>>2]=c[k>>2];$z(0,179652,g)|0;c[h>>2]=1;l=c[h>>2]|0;i=f;return l|0}else{g=(c[j>>2]|0)+112|0;a[g>>0]=d[g>>0]|2;c[h>>2]=0;l=c[h>>2]|0;i=f;return l|0}return 0}function mX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+28|0;h=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=N4(28)|0;if(!(c[h>>2]|0)){c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}c[m>>2]=0;c[j>>2]=0;while(1){q=c[m>>2]|0;if((c[j>>2]|0)>=(c[g>>2]|0))break;c[m>>2]=q+(c[(c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]|0)+4>>2]|0);c[j>>2]=(c[j>>2]|0)+1}b=pX(q<<4)|0;c[(c[h>>2]|0)+8>>2]=b;b=pX((c[g>>2]|0)+1<<2)|0;c[(c[h>>2]|0)+12>>2]=b;b=pX(c[m>>2]<<2)|0;c[(c[h>>2]|0)+16>>2]=b;b=pX(c[m>>2]<<2)|0;c[(c[h>>2]|0)+20>>2]=b;c[(c[h>>2]|0)+4>>2]=c[m>>2];c[c[h>>2]>>2]=c[g>>2];c[l>>2]=0;c[j>>2]=0;while(1){r=c[l>>2]|0;if((c[j>>2]|0)>=(c[g>>2]|0))break;c[n>>2]=r;c[(c[(c[h>>2]|0)+12>>2]|0)+(c[j>>2]<<2)>>2]=c[n>>2];c[o>>2]=(c[n>>2]|0)+(c[(c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]|0)+4>>2]|0)-1;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]|0)+4>>2]|0))break;m=(c[(c[h>>2]|0)+8>>2]|0)+(c[l>>2]<<4)|0;b=(c[c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]>>2]|0)+(c[k>>2]<<4)|0;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];c[(c[(c[h>>2]|0)+16>>2]|0)+(c[l>>2]<<2)>>2]=(c[l>>2]|0)+1;c[(c[(c[h>>2]|0)+20>>2]|0)+(c[l>>2]<<2)>>2]=(c[l>>2]|0)-1;c[l>>2]=(c[l>>2]|0)+1;c[k>>2]=(c[k>>2]|0)+1}c[(c[(c[h>>2]|0)+16>>2]|0)+(c[o>>2]<<2)>>2]=c[n>>2];c[(c[(c[h>>2]|0)+20>>2]|0)+(c[n>>2]<<2)>>2]=c[o>>2];c[j>>2]=(c[j>>2]|0)+1}c[(c[(c[h>>2]|0)+12>>2]|0)+(c[j>>2]<<2)>>2]=r;nY(c[h>>2]|0);c[e>>2]=c[h>>2];p=c[e>>2]|0;i=d;return p|0}function nX(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[(c[d>>2]|0)+12>>2]|0);O4(c[(c[d>>2]|0)+16>>2]|0);O4(c[(c[d>>2]|0)+20>>2]|0);if(!(c[(c[d>>2]|0)+24>>2]|0)){e=c[d>>2]|0;O4(e);i=b;return}O4(c[c[(c[d>>2]|0)+24>>2]>>2]|0);O4(c[(c[d>>2]|0)+24>>2]|0);e=c[d>>2]|0;O4(e);i=b;return}function oX(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=h;l=h+72|0;m=h+68|0;n=h+64|0;o=h+60|0;p=h+56|0;q=h+52|0;r=h+48|0;s=h+44|0;t=h+40|0;u=h+36|0;v=h+32|0;c[l>>2]=a;c[m>>2]=d;c[n>>2]=f;c[o>>2]=g;g=c[l>>2]|0;f=c[m>>2]|0;c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[u>>2]=oY(g,f,j)|0;f=c[l>>2]|0;g=c[n>>2]|0;c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[v>>2]=oY(f,g,j)|0;g=c[m>>2]|0;m=c[u>>2]|0;f=c[n>>2]|0;n=c[v>>2]|0;d=c[l>>2]|0;c[k>>2]=c[b>>2];c[k+4>>2]=c[b+4>>2];c[k+8>>2]=c[b+8>>2];c[k+12>>2]=c[b+12>>2];c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[r>>2]=dY(k,g,m,j,f,n,d)|0;c[s>>2]=1;c[p>>2]=c[(c[r>>2]|0)+(c[(c[l>>2]|0)+4>>2]<<2)>>2];while(1){d=(c[p>>2]|0)!=((c[(c[l>>2]|0)+4>>2]|0)+1|0);c[s>>2]=(c[s>>2]|0)+1;if(!d)break;c[p>>2]=c[(c[r>>2]|0)+(c[p>>2]<<2)>>2]}c[t>>2]=N4(c[s>>2]<<4)|0;c[q>>2]=(c[s>>2]|0)-1;d=c[q>>2]|0;c[q>>2]=d+-1;n=(c[t>>2]|0)+(d<<4)|0;c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];c[p>>2]=c[(c[r>>2]|0)+(c[(c[l>>2]|0)+4>>2]<<2)>>2];while(1){w=c[q>>2]|0;if((c[p>>2]|0)==((c[(c[l>>2]|0)+4>>2]|0)+1|0))break;c[q>>2]=w+-1;e=(c[t>>2]|0)+(w<<4)|0;n=(c[(c[l>>2]|0)+8>>2]|0)+(c[p>>2]<<4)|0;c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];c[e+12>>2]=c[n+12>>2];c[p>>2]=c[(c[r>>2]|0)+(c[p>>2]<<2)>>2]}p=(c[t>>2]|0)+(w<<4)|0;c[p>>2]=c[b>>2];c[p+4>>2]=c[b+4>>2];c[p+8>>2]=c[b+8>>2];c[p+12>>2]=c[b+12>>2];if(c[q>>2]|0)La(179753,179760,148,179766);if(c[u>>2]|0)O4(c[u>>2]|0);if(!(c[v>>2]|0)){x=c[s>>2]|0;y=c[o>>2]|0;z=y+4|0;c[z>>2]=x;A=c[t>>2]|0;B=c[o>>2]|0;c[B>>2]=A;C=c[r>>2]|0;O4(C);i=h;return 1}O4(c[v>>2]|0);x=c[s>>2]|0;y=c[o>>2]|0;z=y+4|0;c[z>>2]=x;A=c[t>>2]|0;B=c[o>>2]|0;c[B>>2]=A;C=c[r>>2]|0;O4(C);i=h;return 1}function pX(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;if((c[d>>2]|0)>>>0>0)c[e>>2]=N4(c[d>>2]|0)|0;else c[e>>2]=0;i=b;return c[e>>2]|0}function qX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+80|0;e=d+32|0;f=d+16|0;g=d;h=d+64|0;j=d+60|0;k=d+56|0;l=d+52|0;m=d+48|0;c[m>>2]=c[a>>2];c[l>>2]=c[a+4>>2];c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[l>>2]|0)){n=6;break}c[k>>2]=((c[j>>2]|0)+(c[l>>2]|0)-1|0)%(c[l>>2]|0)|0;a=(c[m>>2]|0)+(c[k>>2]<<4)|0;o=(c[m>>2]|0)+(c[j>>2]<<4)|0;c[g>>2]=c[a>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[f>>2]=c[o>>2];c[f+4>>2]=c[o+4>>2];c[f+8>>2]=c[o+8>>2];c[f+12>>2]=c[o+12>>2];c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];if((jY(g,f,e)|0)==1){n=4;break}c[j>>2]=(c[j>>2]|0)+1}if((n|0)==4){c[h>>2]=0;p=c[h>>2]|0;i=d;return p|0}else if((n|0)==6){c[h>>2]=1;p=c[h>>2]|0;i=d;return p|0}return 0}function rX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+64|0;h=g+48|0;j=g+32|0;k=4;l=N4(40)|0;c[l>>2]=0;m=g+16|0;p=g;q=c[d>>2]|0;r=c[d+4>>2]|0;l=W4(92352,1,l|0,k|0)|0;k=C;n=0;d=n;n=0;if((d|0)!=0&(o|0)!=0){s=Y4(c[d>>2]|0,l|0,k|0)|0;if(!s)Pa(d|0,o|0);C=o}else s=-1;if((s|0)==1)t=C;else t=0;while(1){if(t){u=4;break}n=0;c[h>>2]=c[e>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];ga(24,m|0,h|0);s=n;n=0;if((s|0)!=0&(o|0)!=0){v=Y4(c[s>>2]|0,l|0,k|0)|0;if(!v)Pa(s|0,o|0);C=o}else v=-1;if((v|0)==1){t=C;continue};c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];s=e+16|0;d=e+16|0;n=0;c[h>>2]=c[d>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];ga(24,p|0,h|0);d=n;n=0;if((d|0)!=0&(o|0)!=0){w=Y4(c[d>>2]|0,l|0,k|0)|0;if(!w)Pa(d|0,o|0);C=o}else w=-1;if((w|0)==1){t=C;continue};c[s>>2]=c[p>>2];c[s+4>>2]=c[p+4>>2];c[s+8>>2]=c[p+8>>2];c[s+12>>2]=c[p+12>>2];c[23127]=0;n=0;ea(106,4);s=n;n=0;if((s|0)!=0&(o|0)!=0){x=Y4(c[s>>2]|0,l|0,k|0)|0;if(!x)Pa(s|0,o|0);C=o}else x=-1;if((x|0)==1){t=C;continue}s=c[23127]|0;c[23127]=s+1;d=(c[23128]|0)+(s<<4)|0;c[d>>2]=c[q>>2];c[d+4>>2]=c[q+4>>2];c[d+8>>2]=c[q+8>>2];c[d+12>>2]=c[q+12>>2];d=e+16|0;n=0;c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[h>>2]=c[d>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];y=na(1,a|0,b|0,q|0,r|0,j|0,h|0)|0;d=n;n=0;if((d|0)!=0&(o|0)!=0){z=Y4(c[d>>2]|0,l|0,k|0)|0;if(!z)Pa(d|0,o|0);C=o}else z=-1;if((z|0)==1)t=C;else break}if((u|0)==4){A=-1;O4(l|0);i=g;return A|0}if((y|0)==-1){A=-1;O4(l|0);i=g;return A|0}else{c[f+4>>2]=c[23127];c[f>>2]=c[23128];A=0;O4(l|0);i=g;return A|0}return 0}function sX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;h[e>>3]=+h[b>>3]*+h[b>>3]+ +h[b+8>>3]*+h[b+8>>3];if(+h[e>>3]>1.0e-06){h[e>>3]=+O(+(+h[e>>3]));h[b>>3]=+h[b>>3]/+h[e>>3];f=b+8|0;h[f>>3]=+h[f>>3]/+h[e>>3]};c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];i=d;return}function tX(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+16|0;e=b;f=b+28|0;c[f>>2]=a;if((c[f>>2]|0)<=(c[23131]|0)){i=b;return}if(c[23128]|0){a=Q4(c[23128]|0,c[f>>2]<<4)|0;c[23128]=a;if(!a){a=c[24742]|0;c[d>>2]=179775;c[d+4>>2]=537;c[d+8>>2]=179928;Y2(a,179783,d)|0;Pa(92352,1)}}else{d=N4(c[f>>2]<<4)|0;c[23128]=d;if(!d){d=c[24742]|0;c[e>>2]=179775;c[e+4>>2]=531;c[e+8>>2]=179910;Y2(d,179783,e)|0;Pa(92352,1)}}c[23131]=c[f>>2];i=b;return}function uX(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0.0,Y=0.0;j=i;i=i+480|0;k=j+424|0;l=j+408|0;m=j+208|0;n=j+192|0;o=j+468|0;p=j+464|0;q=j+460|0;r=j+456|0;s=j+452|0;t=j+392|0;u=j+376|0;v=j+360|0;w=j+344|0;x=j+328|0;y=j+312|0;z=j+296|0;A=j+280|0;B=j+264|0;C=j+248|0;D=j+240|0;E=j+232|0;F=j+224|0;G=j+448|0;H=j+444|0;I=j+440|0;J=j+176|0;K=j+160|0;L=j+144|0;M=j+128|0;N=j+112|0;O=j+96|0;P=j+80|0;Q=j+64|0;R=j+48|0;S=j+32|0;T=j+16|0;U=j;c[p>>2]=a;c[q>>2]=b;c[r>>2]=d;c[s>>2]=e;if((c[23129]|0)<(c[s>>2]|0)){if(c[23130]|0){e=Q4(c[23130]|0,(c[s>>2]|0)*40|0)|0;c[23130]=e;if(!e){c[o>>2]=-1;V=c[o>>2]|0;i=j;return V|0}}else{e=N4((c[s>>2]|0)*40|0)|0;c[23130]=e;if(!e){c[o>>2]=-1;V=c[o>>2]|0;i=j;return V|0}}c[23129]=c[s>>2]}h[c[23130]>>3]=0.0;c[H>>2]=1;while(1){if((c[H>>2]|0)>=(c[s>>2]|0))break;W=+h[(c[23130]|0)+(((c[H>>2]|0)-1|0)*40|0)>>3];e=(c[r>>2]|0)+(c[H>>2]<<4)|0;d=(c[r>>2]|0)+((c[H>>2]|0)-1<<4)|0;c[l>>2]=c[e>>2];c[l+4>>2]=c[e+4>>2];c[l+8>>2]=c[e+8>>2];c[l+12>>2]=c[e+12>>2];c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];X=W+ +vX(l,k);h[(c[23130]|0)+((c[H>>2]|0)*40|0)>>3]=X;c[H>>2]=(c[H>>2]|0)+1}c[H>>2]=1;while(1){if((c[H>>2]|0)>=(c[s>>2]|0))break;d=(c[23130]|0)+((c[H>>2]|0)*40|0)|0;h[d>>3]=+h[d>>3]/+h[(c[23130]|0)+(((c[s>>2]|0)-1|0)*40|0)>>3];c[H>>2]=(c[H>>2]|0)+1}c[H>>2]=0;while(1){if((c[H>>2]|0)>=(c[s>>2]|0))break;d=(c[23130]|0)+((c[H>>2]|0)*40|0)+8|0;X=+wX(+h[(c[23130]|0)+((c[H>>2]|0)*40|0)>>3]);c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];xX(J,k,X);c[d>>2]=c[J>>2];c[d+4>>2]=c[J+4>>2];c[d+8>>2]=c[J+8>>2];c[d+12>>2]=c[J+12>>2];d=(c[23130]|0)+((c[H>>2]|0)*40|0)+8+16|0;X=+yX(+h[(c[23130]|0)+((c[H>>2]|0)*40|0)>>3]);c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];xX(K,k,X);c[d>>2]=c[K>>2];c[d+4>>2]=c[K+4>>2];c[d+8>>2]=c[K+8>>2];c[d+12>>2]=c[K+12>>2];c[H>>2]=(c[H>>2]|0)+1}K=c[r>>2]|0;J=c[s>>2]|0;d=c[23130]|0;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];if((zX(K,J,d,l,k,t,y,u,z)|0)==-1){c[o>>2]=-1;V=c[o>>2]|0;i=j;return V|0}d=c[p>>2]|0;J=c[q>>2]|0;K=c[r>>2]|0;e=c[s>>2]|0;c[n>>2]=c[t>>2];c[n+4>>2]=c[t+4>>2];c[n+8>>2]=c[t+8>>2];c[n+12>>2]=c[t+12>>2];c[m>>2]=c[y>>2];c[m+4>>2]=c[y+4>>2];c[m+8>>2]=c[y+8>>2];c[m+12>>2]=c[y+12>>2];c[l>>2]=c[u>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];c[l+12>>2]=c[u+12>>2];c[k>>2]=c[z>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[k+12>>2]=c[z+12>>2];if(AX(d,J,n,m,l,k,K,e)|0){c[o>>2]=0;V=c[o>>2]|0;i=j;return V|0};c[k>>2]=c[y>>2];c[k+4>>2]=c[y+4>>2];c[k+8>>2]=c[y+8>>2];c[k+12>>2]=c[y+12>>2];xX(L,k,.3333333333333333);c[l>>2]=c[t>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[l+12>>2]=c[t+12>>2];c[k>>2]=c[L>>2];c[k+4>>2]=c[L+4>>2];c[k+8>>2]=c[L+8>>2];c[k+12>>2]=c[L+12>>2];BX(M,l,k);c[v>>2]=c[M>>2];c[v+4>>2]=c[M+4>>2];c[v+8>>2]=c[M+8>>2];c[v+12>>2]=c[M+12>>2];c[k>>2]=c[z>>2];c[k+4>>2]=c[z+4>>2];c[k+8>>2]=c[z+8>>2];c[k+12>>2]=c[z+12>>2];xX(N,k,.3333333333333333);c[l>>2]=c[u>>2];c[l+4>>2]=c[u+4>>2];c[l+8>>2]=c[u+8>>2];c[l+12>>2]=c[u+12>>2];c[k>>2]=c[N>>2];c[k+4>>2]=c[N+4>>2];c[k+8>>2]=c[N+8>>2];c[k+12>>2]=c[N+12>>2];CX(O,l,k);c[w>>2]=c[O>>2];c[w+4>>2]=c[O+4>>2];c[w+8>>2]=c[O+8>>2];c[w+12>>2]=c[O+12>>2];h[D>>3]=-1.0;c[G>>2]=-1;c[H>>2]=1;while(1){if((c[H>>2]|0)>=((c[s>>2]|0)-1|0))break;h[F>>3]=+h[(c[23130]|0)+((c[H>>2]|0)*40|0)>>3];X=+DX(+h[F>>3]);W=X*+h[t>>3];X=+wX(+h[F>>3]);Y=W+X*+h[v>>3];X=+yX(+h[F>>3]);W=Y+X*+h[w>>3];X=+EX(+h[F>>3]);h[x>>3]=W+X*+h[u>>3];X=+DX(+h[F>>3]);W=X*+h[t+8>>3];X=+wX(+h[F>>3]);Y=W+X*+h[v+8>>3];X=+yX(+h[F>>3]);W=Y+X*+h[w+8>>3];X=+EX(+h[F>>3]);h[x+8>>3]=W+X*+h[u+8>>3];O=(c[r>>2]|0)+(c[H>>2]<<4)|0;c[l>>2]=c[x>>2];c[l+4>>2]=c[x+4>>2];c[l+8>>2]=c[x+8>>2];c[l+12>>2]=c[x+12>>2];c[k>>2]=c[O>>2];c[k+4>>2]=c[O+4>>2];c[k+8>>2]=c[O+8>>2];c[k+12>>2]=c[O+12>>2];X=+vX(l,k);h[E>>3]=X;if(X>+h[D>>3]){h[D>>3]=+h[E>>3];c[G>>2]=c[H>>2]}c[H>>2]=(c[H>>2]|0)+1}c[I>>2]=c[G>>2];G=(c[r>>2]|0)+(c[I>>2]<<4)|0;H=(c[r>>2]|0)+((c[I>>2]|0)-1<<4)|0;c[l>>2]=c[G>>2];c[l+4>>2]=c[G+4>>2];c[l+8>>2]=c[G+8>>2];c[l+12>>2]=c[G+12>>2];c[k>>2]=c[H>>2];c[k+4>>2]=c[H+4>>2];c[k+8>>2]=c[H+8>>2];c[k+12>>2]=c[H+12>>2];CX(P,l,k);c[k>>2]=c[P>>2];c[k+4>>2]=c[P+4>>2];c[k+8>>2]=c[P+8>>2];c[k+12>>2]=c[P+12>>2];sX(Q,k);c[B>>2]=c[Q>>2];c[B+4>>2]=c[Q+4>>2];c[B+8>>2]=c[Q+8>>2];c[B+12>>2]=c[Q+12>>2];Q=(c[r>>2]|0)+((c[I>>2]|0)+1<<4)|0;P=(c[r>>2]|0)+(c[I>>2]<<4)|0;c[l>>2]=c[Q>>2];c[l+4>>2]=c[Q+4>>2];c[l+8>>2]=c[Q+8>>2];c[l+12>>2]=c[Q+12>>2];c[k>>2]=c[P>>2];c[k+4>>2]=c[P+4>>2];c[k+8>>2]=c[P+8>>2];c[k+12>>2]=c[P+12>>2];CX(R,l,k);c[k>>2]=c[R>>2];c[k+4>>2]=c[R+4>>2];c[k+8>>2]=c[R+8>>2];c[k+12>>2]=c[R+12>>2];sX(S,k);c[C>>2]=c[S>>2];c[C+4>>2]=c[S+4>>2];c[C+8>>2]=c[S+8>>2];c[C+12>>2]=c[S+12>>2];c[l>>2]=c[B>>2];c[l+4>>2]=c[B+4>>2];c[l+8>>2]=c[B+8>>2];c[l+12>>2]=c[B+12>>2];c[k>>2]=c[C>>2];c[k+4>>2]=c[C+4>>2];c[k+8>>2]=c[C+8>>2];c[k+12>>2]=c[C+12>>2];BX(T,l,k);c[k>>2]=c[T>>2];c[k+4>>2]=c[T+4>>2];c[k+8>>2]=c[T+8>>2];c[k+12>>2]=c[T+12>>2];sX(U,k);c[A>>2]=c[U>>2];c[A+4>>2]=c[U+4>>2];c[A+8>>2]=c[U+8>>2];c[A+12>>2]=c[U+12>>2];U=c[p>>2]|0;T=c[q>>2]|0;C=c[r>>2]|0;B=(c[I>>2]|0)+1|0;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[k>>2]=c[A>>2];c[k+4>>2]=c[A+4>>2];c[k+8>>2]=c[A+8>>2];c[k+12>>2]=c[A+12>>2];uX(U,T,C,B,l,k)|0;B=c[p>>2]|0;p=c[q>>2]|0;q=(c[r>>2]|0)+(c[I>>2]<<4)|0;r=(c[s>>2]|0)-(c[I>>2]|0)|0;c[l>>2]=c[A>>2];c[l+4>>2]=c[A+4>>2];c[l+8>>2]=c[A+8>>2];c[l+12>>2]=c[A+12>>2];c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];uX(B,p,q,r,l,k)|0;c[o>>2]=0;V=c[o>>2]|0;i=j;return V|0}function vX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0.0;c=i;i=i+16|0;d=c+8|0;e=c;h[d>>3]=+h[b>>3]-+h[a>>3];h[e>>3]=+h[b+8>>3]-+h[a+8>>3];f=+O(+(+h[d>>3]*+h[d>>3]+ +h[e>>3]*+h[e>>3]));i=c;return +f}function wX(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b+8|0;d=b;h[c>>3]=a;h[d>>3]=1.0-+h[c>>3];i=b;return +(+h[c>>3]*3.0*+h[d>>3]*+h[d>>3])}function xX(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;h[f>>3]=d;h[b>>3]=+h[b>>3]*+h[f>>3];g=b+8|0;h[g>>3]=+h[g>>3]*+h[f>>3];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];i=e;return}function yX(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b+8|0;d=b;h[c>>3]=a;h[d>>3]=1.0-+h[c>>3];i=b;return +(+h[c>>3]*3.0*+h[c>>3]*+h[d>>3])}function zX(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0.0,N=0,O=0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0;m=i;i=i+272|0;n=m+224|0;o=m+208|0;p=m+268|0;q=m+264|0;r=m+260|0;s=m+256|0;t=m+252|0;u=m+248|0;v=m+244|0;w=m+192|0;x=m+160|0;y=m+144|0;z=m+136|0;A=m+128|0;B=m+120|0;C=m+112|0;D=m+104|0;E=m+96|0;F=m+240|0;G=m+80|0;H=m+64|0;I=m+48|0;J=m+32|0;K=m+16|0;L=m;c[p>>2]=a;c[q>>2]=b;c[r>>2]=d;c[s>>2]=g;c[t>>2]=j;c[u>>2]=k;c[v>>2]=l;h[E>>3]=0.0;h[D>>3]=0.0;h[x+16+8>>3]=0.0;h[x+16>>3]=0.0;h[x+8>>3]=0.0;h[x>>3]=0.0;h[y+8>>3]=0.0;h[y>>3]=0.0;c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[q>>2]|0))break;l=(c[r>>2]|0)+((c[F>>2]|0)*40|0)+8|0;k=(c[r>>2]|0)+((c[F>>2]|0)*40|0)+8|0;c[o>>2]=c[l>>2];c[o+4>>2]=c[l+4>>2];c[o+8>>2]=c[l+8>>2];c[o+12>>2]=c[l+12>>2];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[n+8>>2]=c[k+8>>2];c[n+12>>2]=c[k+12>>2];M=+KX(o,n);h[x>>3]=+h[x>>3]+M;k=(c[r>>2]|0)+((c[F>>2]|0)*40|0)+8|0;l=(c[r>>2]|0)+((c[F>>2]|0)*40|0)+8+16|0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];M=+KX(o,n);l=x+8|0;h[l>>3]=+h[l>>3]+M;h[x+16>>3]=+h[x+8>>3];l=(c[r>>2]|0)+((c[F>>2]|0)*40|0)+8+16|0;k=(c[r>>2]|0)+((c[F>>2]|0)*40|0)+8+16|0;c[o>>2]=c[l>>2];c[o+4>>2]=c[l+4>>2];c[o+8>>2]=c[l+8>>2];c[o+12>>2]=c[l+12>>2];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[n+8>>2]=c[k+8>>2];c[n+12>>2]=c[k+12>>2];M=+KX(o,n);k=x+16+8|0;h[k>>3]=+h[k>>3]+M;k=(c[p>>2]|0)+(c[F>>2]<<4)|0;l=c[p>>2]|0;M=+LX(+h[(c[r>>2]|0)+((c[F>>2]|0)*40|0)>>3]);c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];xX(H,n,M);l=(c[p>>2]|0)+((c[q>>2]|0)-1<<4)|0;M=+MX(+h[(c[r>>2]|0)+((c[F>>2]|0)*40|0)>>3]);c[n>>2]=c[l>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];c[n+12>>2]=c[l+12>>2];xX(I,n,M);c[o>>2]=c[H>>2];c[o+4>>2]=c[H+4>>2];c[o+8>>2]=c[H+8>>2];c[o+12>>2]=c[H+12>>2];c[n>>2]=c[I>>2];c[n+4>>2]=c[I+4>>2];c[n+8>>2]=c[I+8>>2];c[n+12>>2]=c[I+12>>2];BX(G,o,n);c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];c[n>>2]=c[G>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];c[n+12>>2]=c[G+12>>2];CX(J,o,n);c[w>>2]=c[J>>2];c[w+4>>2]=c[J+4>>2];c[w+8>>2]=c[J+8>>2];c[w+12>>2]=c[J+12>>2];k=(c[r>>2]|0)+((c[F>>2]|0)*40|0)+8|0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];c[n>>2]=c[w>>2];c[n+4>>2]=c[w+4>>2];c[n+8>>2]=c[w+8>>2];c[n+12>>2]=c[w+12>>2];M=+KX(o,n);h[y>>3]=+h[y>>3]+M;k=(c[r>>2]|0)+((c[F>>2]|0)*40|0)+8+16|0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];c[n>>2]=c[w>>2];c[n+4>>2]=c[w+4>>2];c[n+8>>2]=c[w+8>>2];c[n+12>>2]=c[w+12>>2];M=+KX(o,n);k=y+8|0;h[k>>3]=+h[k>>3]+M;c[F>>2]=(c[F>>2]|0)+1}h[z>>3]=+h[x>>3]*+h[x+16+8>>3]-+h[x+16>>3]*+h[x+8>>3];h[A>>3]=+h[x>>3]*+h[y+8>>3]-+h[x+8>>3]*+h[y>>3];h[B>>3]=+h[y>>3]*+h[x+16+8>>3]-+h[y+8>>3]*+h[x+8>>3];M=+h[z>>3];if((+h[z>>3]>=0.0?M:-M)>=1.0e-06){h[D>>3]=+h[B>>3]/+h[z>>3];h[E>>3]=+h[A>>3]/+h[z>>3]}M=+h[z>>3];if(!((+h[D>>3]<=0.0?1:(+h[z>>3]>=0.0?M:-M)<1.0e-06)|+h[E>>3]<=0.0)){N=c[s>>2]|0;O=c[p>>2]|0;c[N>>2]=c[O>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];c[N+12>>2]=c[O+12>>2];P=c[t>>2]|0;Q=+h[D>>3];c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];xX(K,n,Q);c[P>>2]=c[K>>2];c[P+4>>2]=c[K+4>>2];c[P+8>>2]=c[K+8>>2];c[P+12>>2]=c[K+12>>2];R=c[u>>2]|0;S=c[q>>2]|0;T=S-1|0;U=c[p>>2]|0;V=U+(T<<4)|0;c[R>>2]=c[V>>2];c[R+4>>2]=c[V+4>>2];c[R+8>>2]=c[V+8>>2];c[R+12>>2]=c[V+12>>2];W=c[v>>2]|0;X=+h[E>>3];c[n>>2]=c[f>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];xX(L,n,X);c[W>>2]=c[L>>2];c[W+4>>2]=c[L+4>>2];c[W+8>>2]=c[L+8>>2];c[W+12>>2]=c[L+12>>2];i=m;return 0}z=c[p>>2]|0;A=(c[p>>2]|0)+((c[q>>2]|0)-1<<4)|0;c[o>>2]=c[z>>2];c[o+4>>2]=c[z+4>>2];c[o+8>>2]=c[z+8>>2];c[o+12>>2]=c[z+12>>2];c[n>>2]=c[A>>2];c[n+4>>2]=c[A+4>>2];c[n+8>>2]=c[A+8>>2];c[n+12>>2]=c[A+12>>2];h[C>>3]=+vX(o,n)/3.0;h[D>>3]=+h[C>>3];h[E>>3]=+h[C>>3];N=c[s>>2]|0;O=c[p>>2]|0;c[N>>2]=c[O>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];c[N+12>>2]=c[O+12>>2];P=c[t>>2]|0;Q=+h[D>>3];c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];xX(K,n,Q);c[P>>2]=c[K>>2];c[P+4>>2]=c[K+4>>2];c[P+8>>2]=c[K+8>>2];c[P+12>>2]=c[K+12>>2];R=c[u>>2]|0;S=c[q>>2]|0;T=S-1|0;U=c[p>>2]|0;V=U+(T<<4)|0;c[R>>2]=c[V>>2];c[R+4>>2]=c[V+4>>2];c[R+8>>2]=c[V+8>>2];c[R+12>>2]=c[V+12>>2];W=c[v>>2]|0;X=+h[E>>3];c[n>>2]=c[f>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];xX(L,n,X);c[W>>2]=c[L>>2];c[W+4>>2]=c[L+4>>2];c[W+8>>2]=c[L+8>>2];c[W+12>>2]=c[L+12>>2];i=m;return 0}function AX(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0;l=i;i=i+112|0;m=l+108|0;n=l+104|0;o=l+100|0;p=l+96|0;q=l+92|0;r=l+16|0;s=l+8|0;t=l;u=l+88|0;v=l+84|0;w=l+80|0;c[n>>2]=a;c[o>>2]=b;c[p>>2]=j;c[q>>2]=k;c[w>>2]=1;c[v>>2]=(c[q>>2]|0)==2?1:0;h[t>>3]=4.0;h[s>>3]=4.0;while(1){h[r>>3]=+h[d>>3];h[r+8>>3]=+h[d+8>>3];h[r+16>>3]=+h[d>>3]+ +h[s>>3]*+h[e>>3]/3.0;h[r+16+8>>3]=+h[d+8>>3]+ +h[s>>3]*+h[e+8>>3]/3.0;h[r+32>>3]=+h[f>>3]-+h[t>>3]*+h[g>>3]/3.0;h[r+32+8>>3]=+h[f+8>>3]-+h[t>>3]*+h[g+8>>3]/3.0;h[r+48>>3]=+h[f>>3];h[r+48+8>>3]=+h[f+8>>3];if((c[w>>2]|0)!=0?(x=+FX(r,4),x<+FX(c[p>>2]|0,c[q>>2]|0)-.001):0){y=4;break}c[w>>2]=0;if(GX(c[n>>2]|0,c[o>>2]|0,r)|0){y=6;break}if(+h[s>>3]==0.0&+h[t>>3]==0.0){y=11;break}if(+h[s>>3]>.01){h[s>>3]=+h[s>>3]/2.0;h[t>>3]=+h[t>>3]/2.0;continue}else{h[t>>3]=0.0;h[s>>3]=0.0;continue}}if((y|0)==4){c[m>>2]=0;z=c[m>>2]|0;i=l;return z|0}else if((y|0)==6){tX((c[23127]|0)+4|0);c[u>>2]=1;while(1){if((c[u>>2]|0)>=4)break;h[(c[23128]|0)+(c[23127]<<4)>>3]=+h[r+(c[u>>2]<<4)>>3];x=+h[r+(c[u>>2]<<4)+8>>3];s=c[23127]|0;c[23127]=s+1;h[(c[23128]|0)+(s<<4)+8>>3]=x;c[u>>2]=(c[u>>2]|0)+1}c[m>>2]=1;z=c[m>>2]|0;i=l;return z|0}else if((y|0)==11){if(!(c[v>>2]|0)){c[m>>2]=0;z=c[m>>2]|0;i=l;return z|0}tX((c[23127]|0)+4|0);c[u>>2]=1;while(1){if((c[u>>2]|0)>=4)break;h[(c[23128]|0)+(c[23127]<<4)>>3]=+h[r+(c[u>>2]<<4)>>3];x=+h[r+(c[u>>2]<<4)+8>>3];v=c[23127]|0;c[23127]=v+1;h[(c[23128]|0)+(v<<4)+8>>3]=x;c[u>>2]=(c[u>>2]|0)+1}c[m>>2]=1;z=c[m>>2]|0;i=l;return z|0}return 0}function BX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;h[b>>3]=+h[b>>3]+ +h[d>>3];e=b+8|0;h[e>>3]=+h[e>>3]+ +h[d+8>>3];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];return}function CX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;h[b>>3]=+h[b>>3]-+h[d>>3];e=b+8|0;h[e>>3]=+h[e>>3]-+h[d+8>>3];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];return}function DX(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b+8|0;d=b;h[c>>3]=a;h[d>>3]=1.0-+h[c>>3];i=b;return +(+h[d>>3]*+h[d>>3]*+h[d>>3])}function EX(a){a=+a;var b=0,c=0;b=i;i=i+16|0;c=b;h[c>>3]=a;i=b;return +(+h[c>>3]*+h[c>>3]*+h[c>>3])}function FX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d;c[e>>2]=a;c[f>>2]=b;h[j>>3]=0.0;c[g>>2]=1;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;k=+O(+((+h[(c[e>>2]|0)+(c[g>>2]<<4)>>3]-+h[(c[e>>2]|0)+((c[g>>2]|0)-1<<4)>>3])*(+h[(c[e>>2]|0)+(c[g>>2]<<4)>>3]-+h[(c[e>>2]|0)+((c[g>>2]|0)-1<<4)>>3])+(+h[(c[e>>2]|0)+(c[g>>2]<<4)+8>>3]-+h[(c[e>>2]|0)+((c[g>>2]|0)-1<<4)+8>>3])*(+h[(c[e>>2]|0)+(c[g>>2]<<4)+8>>3]-+h[(c[e>>2]|0)+((c[g>>2]|0)-1<<4)+8>>3])));h[j>>3]=+h[j>>3]+k;c[g>>2]=(c[g>>2]|0)+1}i=d;return +(+h[j>>3])}function GX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=i;i=i+160|0;f=e+144|0;g=e+140|0;j=e+136|0;k=e+132|0;l=e+88|0;m=e+128|0;n=e+124|0;o=e+120|0;p=e+56|0;q=e+40|0;r=e+32|0;s=e+24|0;t=e+16|0;u=e+8|0;v=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[o>>2]=0;a:while(1){if((c[o>>2]|0)>=(c[j>>2]|0)){w=13;break}d=(c[g>>2]|0)+(c[o>>2]<<5)|0;c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];d=p+16|0;b=(c[g>>2]|0)+(c[o>>2]<<5)+16|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[d+12>>2]=c[b+12>>2];b=HX(c[k>>2]|0,p,l)|0;c[n>>2]=b;b:do if((b|0)!=4){c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[n>>2]|0))break b;if(((!(+h[l+(c[m>>2]<<3)>>3]<1.0e-06)?!(+h[l+(c[m>>2]<<3)>>3]>.999999):0)?(h[r>>3]=+h[l+(c[m>>2]<<3)>>3],h[v>>3]=+h[r>>3]*+h[r>>3]*+h[r>>3],h[u>>3]=+h[r>>3]*3.0*+h[r>>3]*(1.0-+h[r>>3]),h[t>>3]=+h[r>>3]*3.0*(1.0-+h[r>>3])*(1.0-+h[r>>3]),h[s>>3]=(1.0-+h[r>>3])*(1.0-+h[r>>3])*(1.0-+h[r>>3]),h[q>>3]=+h[s>>3]*+h[c[k>>2]>>3]+ +h[t>>3]*+h[(c[k>>2]|0)+16>>3]+ +h[u>>3]*+h[(c[k>>2]|0)+32>>3]+ +h[v>>3]*+h[(c[k>>2]|0)+48>>3],h[q+8>>3]=+h[s>>3]*+h[(c[k>>2]|0)+8>>3]+ +h[t>>3]*+h[(c[k>>2]|0)+16+8>>3]+ +h[u>>3]*+h[(c[k>>2]|0)+32+8>>3]+ +h[v>>3]*+h[(c[k>>2]|0)+48+8>>3],!((+h[q>>3]-+h[p>>3])*(+h[q>>3]-+h[p>>3])+(+h[q+8>>3]-+h[p+8>>3])*(+h[q+8>>3]-+h[p+8>>3])<.001)):0)?!((+h[q>>3]-+h[p+16>>3])*(+h[q>>3]-+h[p+16>>3])+(+h[q+8>>3]-+h[p+16+8>>3])*(+h[q+8>>3]-+h[p+16+8>>3])<.001):0){w=10;break a}c[m>>2]=(c[m>>2]|0)+1}}while(0);c[o>>2]=(c[o>>2]|0)+1}if((w|0)==10){c[f>>2]=0;x=c[f>>2]|0;i=e;return x|0}else if((w|0)==13){c[f>>2]=1;x=c[f>>2]|0;i=e;return x|0}return 0}function HX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0;e=i;i=i+176|0;f=e+168|0;g=e+164|0;j=e+160|0;k=e+156|0;l=e+104|0;m=e+88|0;n=e+72|0;o=e+48|0;p=e+24|0;q=e+16|0;r=e+8|0;s=e;t=e+152|0;u=e+148|0;v=e+144|0;w=e+140|0;x=e+136|0;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[m>>3]=+h[c[j>>2]>>3];h[m+8>>3]=+h[(c[j>>2]|0)+16>>3]-+h[c[j>>2]>>3];h[n>>3]=+h[(c[j>>2]|0)+8>>3];h[n+8>>3]=+h[(c[j>>2]|0)+16+8>>3]-+h[(c[j>>2]|0)+8>>3];c[t>>2]=0;y=+h[n+8>>3];if(!(+h[m+8>>3]==0.0)){h[s>>3]=y/+h[m+8>>3];IX(+h[(c[g>>2]|0)+8>>3]-+h[s>>3]*+h[c[g>>2]>>3],+h[(c[g>>2]|0)+16+8>>3]-+h[s>>3]*+h[(c[g>>2]|0)+16>>3],+h[(c[g>>2]|0)+32+8>>3]-+h[s>>3]*+h[(c[g>>2]|0)+32>>3],+h[(c[g>>2]|0)+48+8>>3]-+h[s>>3]*+h[(c[g>>2]|0)+48>>3],l);h[l>>3]=+h[l>>3]+(+h[s>>3]*+h[m>>3]-+h[n>>3]);c[u>>2]=eY(l,o)|0;if((c[u>>2]|0)==4){c[f>>2]=4;z=c[f>>2]|0;i=e;return z|0}c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break;h[q>>3]=+h[o+(c[w>>2]<<3)>>3];if(+h[q>>3]>=0.0&+h[q>>3]<=1.0?(IX(+h[c[g>>2]>>3],+h[(c[g>>2]|0)+16>>3],+h[(c[g>>2]|0)+32>>3],+h[(c[g>>2]|0)+48>>3],l),h[r>>3]=+h[l>>3]+ +h[q>>3]*(+h[l+8>>3]+ +h[q>>3]*(+h[l+16>>3]+ +h[q>>3]*+h[l+24>>3])),h[r>>3]=(+h[r>>3]-+h[m>>3])/+h[m+8>>3],0.0<=+h[r>>3]&+h[r>>3]<=1.0):0)JX(+h[q>>3],c[k>>2]|0,t);c[w>>2]=(c[w>>2]|0)+1}c[f>>2]=c[t>>2];z=c[f>>2]|0;i=e;return z|0}IX(+h[c[g>>2]>>3],+h[(c[g>>2]|0)+16>>3],+h[(c[g>>2]|0)+32>>3],+h[(c[g>>2]|0)+48>>3],l);h[l>>3]=+h[l>>3]-+h[m>>3];c[u>>2]=eY(l,o)|0;if(!(y==0.0)){if((c[u>>2]|0)==4){c[f>>2]=4;z=c[f>>2]|0;i=e;return z|0}c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break;h[q>>3]=+h[o+(c[w>>2]<<3)>>3];if(+h[q>>3]>=0.0&+h[q>>3]<=1.0?(IX(+h[(c[g>>2]|0)+8>>3],+h[(c[g>>2]|0)+16+8>>3],+h[(c[g>>2]|0)+32+8>>3],+h[(c[g>>2]|0)+48+8>>3],l),h[r>>3]=+h[l>>3]+ +h[q>>3]*(+h[l+8>>3]+ +h[q>>3]*(+h[l+16>>3]+ +h[q>>3]*+h[l+24>>3])),h[r>>3]=(+h[r>>3]-+h[n>>3])/+h[n+8>>3],0.0<=+h[r>>3]&+h[r>>3]<=1.0):0)JX(+h[q>>3],c[k>>2]|0,t);c[w>>2]=(c[w>>2]|0)+1}c[f>>2]=c[t>>2];z=c[f>>2]|0;i=e;return z|0}IX(+h[(c[g>>2]|0)+8>>3],+h[(c[g>>2]|0)+16+8>>3],+h[(c[g>>2]|0)+32+8>>3],+h[(c[g>>2]|0)+48+8>>3],l);h[l>>3]=+h[l>>3]-+h[n>>3];c[v>>2]=eY(l,p)|0;l=(c[v>>2]|0)==4;a:do if((c[u>>2]|0)==4){if(l){c[f>>2]=4;z=c[f>>2]|0;i=e;return z|0}c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[v>>2]|0))break a;JX(+h[p+(c[x>>2]<<3)>>3],c[k>>2]|0,t);c[x>>2]=(c[x>>2]|0)+1}}else{c[w>>2]=0;if(l)while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break a;JX(+h[o+(c[w>>2]<<3)>>3],c[k>>2]|0,t);c[w>>2]=(c[w>>2]|0)+1}while(1){if((c[w>>2]|0)>=(c[u>>2]|0))break a;c[x>>2]=0;while(1){A=c[w>>2]|0;if((c[x>>2]|0)>=(c[v>>2]|0))break;if(+h[o+(A<<3)>>3]==+h[p+(c[x>>2]<<3)>>3])JX(+h[o+(c[w>>2]<<3)>>3],c[k>>2]|0,t);c[x>>2]=(c[x>>2]|0)+1}c[w>>2]=A+1}}while(0);c[f>>2]=c[t>>2];z=c[f>>2]|0;i=e;return z|0}function IX(a,b,d,e,f){a=+a;b=+b;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;j=g+24|0;k=g+16|0;l=g+8|0;m=g;n=g+32|0;h[j>>3]=a;h[k>>3]=b;h[l>>3]=d;h[m>>3]=e;c[n>>2]=f;h[(c[n>>2]|0)+24>>3]=+h[m>>3]+ +h[k>>3]*3.0-(+h[j>>3]+ +h[l>>3]*3.0);h[(c[n>>2]|0)+16>>3]=+h[j>>3]*3.0+ +h[l>>3]*3.0-+h[k>>3]*6.0;h[(c[n>>2]|0)+8>>3]=(+h[k>>3]-+h[j>>3])*3.0;h[c[n>>2]>>3]=+h[j>>3];i=g;return}function JX(a,b,d){a=+a;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e;g=e+12|0;j=e+8|0;h[f>>3]=a;c[g>>2]=b;c[j>>2]=d;if(!(+h[f>>3]>=0.0&+h[f>>3]<=1.0)){i=e;return}h[(c[g>>2]|0)+(c[c[j>>2]>>2]<<3)>>3]=+h[f>>3];f=c[j>>2]|0;c[f>>2]=(c[f>>2]|0)+1;i=e;return}function KX(a,b){a=a|0;b=b|0;return +(+h[a>>3]*+h[b>>3]+ +h[a+8>>3]*+h[b+8>>3])}function LX(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b+8|0;d=b;h[c>>3]=a;h[d>>3]=1.0-+h[c>>3];i=b;return +(+h[d>>3]*+h[d>>3]*(+h[d>>3]+ +h[c>>3]*3.0))}function MX(a){a=+a;var b=0,c=0,d=0;b=i;i=i+16|0;c=b+8|0;d=b;h[c>>3]=a;h[d>>3]=1.0-+h[c>>3];i=b;return +(+h[c>>3]*+h[c>>3]*(+h[d>>3]*3.0+ +h[c>>3]))}function NX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,p=0,q=0,r=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,fa=0,ha=0,ja=0,la=0;e=i;i=i+112|0;f=e+80|0;g=e+64|0;j=e+48|0;k=4;l=N4(40)|0;c[l>>2]=0;m=e+32|0;p=e+16|0;q=e;r=e+96|0;l=W4(92528,1,l|0,k|0)|0;k=C;n=0;t=n;n=0;if((t|0)!=0&(o|0)!=0){u=Y4(c[t>>2]|0,l|0,k|0)|0;if(!u)Pa(t|0,o|0);C=o}else u=-1;if((u|0)==1)v=C;else v=0;a:while(1){if(v){w=4;break}n=0;ea(107,c[a+4>>2]|0);u=n;n=0;if((u|0)!=0&(o|0)!=0){x=Y4(c[u>>2]|0,l|0,k|0)|0;if(!x)Pa(u|0,o|0);C=o}else x=-1;if((x|0)==1){v=C;continue}c[23171]=0;c[23172]=0;n=0;ea(108,c[a+4>>2]<<1|0);u=n;n=0;if((u|0)!=0&(o|0)!=0){y=Y4(c[u>>2]|0,l|0,k|0)|0;if(!y)Pa(u|0,o|0);C=o}else y=-1;if((y|0)==1){v=C;continue}c[23175]=(c[23174]|0)/2|0;c[23176]=(c[23175]|0)-1;u=-1;z=s;t=0;while(1){if((t|0)>=(c[a+4>>2]|0))break;if(z>+h[(c[a>>2]|0)+(t<<4)>>3]){A=t;B=+h[(c[a>>2]|0)+(t<<4)>>3]}else{A=u;B=z}u=A;z=B;t=t+1|0}t=(c[a>>2]|0)+(u<<4)|0;c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];c[p+12>>2]=c[t+12>>2];if(!u)D=c[a+4>>2]|0;else D=u;t=(c[a>>2]|0)+(D-1<<4)|0;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];c[m+12>>2]=c[t+12>>2];t=(c[a>>2]|0)+(((u|0)==((c[a+4>>2]|0)-1|0)?0:u+1|0)<<4)|0;c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];c[q+12>>2]=c[t+12>>2];if((+h[m>>3]==+h[p>>3]?+h[p>>3]==+h[q>>3]:0)?+h[q+8>>3]>+h[p+8>>3]:0)w=20;else w=18;b:do if((w|0)==18){w=0;n=0;t=ka(40,m|0,p|0,q|0)|0;E=n;n=0;if((E|0)!=0&(o|0)!=0){F=Y4(c[E>>2]|0,l|0,k|0)|0;if(!F)Pa(E|0,o|0);C=o}else F=-1;if((F|0)==1){v=C;continue a}if((t|0)!=1)w=20;else{t=0;while(1){if((t|0)>=(c[a+4>>2]|0))break b;if(!(((t|0)>0?+h[(c[a>>2]|0)+(t<<4)>>3]==+h[(c[a>>2]|0)+(t-1<<4)>>3]:0)?+h[(c[a>>2]|0)+(t<<4)+8>>3]==+h[(c[a>>2]|0)+(t-1<<4)+8>>3]:0)){c[(c[23178]|0)+(c[23171]<<3)>>2]=(c[a>>2]|0)+(t<<4);c[(c[23178]|0)+(c[23171]<<3)+4>>2]=(c[23178]|0)+(((c[23171]|0)%(c[a+4>>2]|0)|0)<<3);c[(c[23179]|0)+(c[23171]<<2)>>2]=(c[23178]|0)+(c[23171]<<3);c[23171]=(c[23171]|0)+1}t=t+1|0}}}while(0);c:do if((w|0)==20){w=0;u=(c[a+4>>2]|0)-1|0;while(1){if((u|0)<0)break c;if(!(((u|0)<((c[a+4>>2]|0)-1|0)?+h[(c[a>>2]|0)+(u<<4)>>3]==+h[(c[a>>2]|0)+(u+1<<4)>>3]:0)?+h[(c[a>>2]|0)+(u<<4)+8>>3]==+h[(c[a>>2]|0)+(u+1<<4)+8>>3]:0)){c[(c[23178]|0)+(c[23171]<<3)>>2]=(c[a>>2]|0)+(u<<4);c[(c[23178]|0)+(c[23171]<<3)+4>>2]=(c[23178]|0)+(((c[23171]|0)%(c[a+4>>2]|0)|0)<<3);c[(c[23179]|0)+(c[23171]<<2)>>2]=(c[23178]|0)+(c[23171]<<3);c[23171]=(c[23171]|0)+1}u=u+-1|0}}while(0);n=0;ga(25,c[23179]|0,c[23171]|0);u=n;n=0;if((u|0)!=0&(o|0)!=0){G=Y4(c[u>>2]|0,l|0,k|0)|0;if(!G)Pa(u|0,o|0);C=o}else G=-1;if((G|0)==1){v=C;continue}u=0;while(1){if((u|0)>=(c[23172]|0))break;t=u+1|0;while(1){if((t|0)>=(c[23172]|0))break;n=0;ga(26,u|0,t|0);E=n;n=0;if((E|0)!=0&(o|0)!=0){H=Y4(c[E>>2]|0,l|0,k|0)|0;if(!H)Pa(E|0,o|0);C=o}else H=-1;if((H|0)==1){v=C;continue a}t=t+1|0}u=u+1|0}u=0;while(1){if((u|0)>=(c[23172]|0))break;n=0;t=ra(105,u|0,b|0)|0;E=n;n=0;if((E|0)!=0&(o|0)!=0){I=Y4(c[E>>2]|0,l|0,k|0)|0;if(!I)Pa(E|0,o|0);C=o}else I=-1;if((I|0)==1){v=C;continue a}if(t)break;u=u+1|0}if((u|0)==(c[23172]|0)){t=c[24742]|0;n=0;c[j>>2]=179802;c[j+4>>2]=192;c[j+8>>2]=179813;ka(36,t|0,179783,j|0)|0;t=n;n=0;if((t|0)!=0&(o|0)!=0){J=Y4(c[t>>2]|0,l|0,k|0)|0;if(!J)Pa(t|0,o|0);C=o}else J=-1;if((J|0)==1){v=C;continue}else{w=49;break}}t=0;while(1){if((t|0)>=(c[23172]|0))break;n=0;E=ra(105,t|0,b+16|0)|0;K=n;n=0;if((K|0)!=0&(o|0)!=0){L=Y4(c[K>>2]|0,l|0,k|0)|0;if(!L)Pa(K|0,o|0);C=o}else L=-1;if((L|0)==1){v=C;continue a}if(E)break;t=t+1|0}if((t|0)==(c[23172]|0)){E=c[24742]|0;n=0;c[g>>2]=179802;c[g+4>>2]=200;c[g+8>>2]=179846;ka(36,E|0,179783,g|0)|0;E=n;n=0;if((E|0)!=0&(o|0)!=0){M=Y4(c[E>>2]|0,l|0,k|0)|0;if(!M)Pa(E|0,o|0);C=o}else M=-1;if((M|0)==1){v=C;continue}else{w=57;break}}n=0;E=ra(106,u|0,t|0)|0;K=n;n=0;if((K|0)!=0&(o|0)!=0){N=Y4(c[K>>2]|0,l|0,k|0)|0;if(!N)Pa(K|0,o|0);C=o}else N=-1;if((N|0)==1){v=C;continue}if(!E){E=c[24742]|0;n=0;c[f>>2]=179802;c[f+4>>2]=207;c[f+8>>2]=179884;ka(36,E|0,179783,f|0)|0;E=n;n=0;if((E|0)!=0&(o|0)!=0){O=Y4(c[E>>2]|0,l|0,k|0)|0;if(!O)Pa(E|0,o|0);C=o}else O=-1;if((O|0)==1){v=C;continue}n=0;ea(109,2);E=n;n=0;if((E|0)!=0&(o|0)!=0){P=Y4(c[E>>2]|0,l|0,k|0)|0;if(!P)Pa(E|0,o|0);C=o}else P=-1;if((P|0)==1){v=C;continue}else{w=62;break}}if((u|0)==(t|0)){n=0;ea(109,2);E=n;n=0;if((E|0)!=0&(o|0)!=0){Q=Y4(c[E>>2]|0,l|0,k|0)|0;if(!Q)Pa(E|0,o|0);C=o}else Q=-1;if((Q|0)==1){v=C;continue}else{w=65;break}}c[r>>2]=b;c[r+4>>2]=0;c[r+8>>2]=b+16;c[r+8+4>>2]=0;n=0;ga(27,1,r|0);E=n;n=0;if((E|0)!=0&(o|0)!=0){R=Y4(c[E>>2]|0,l|0,k|0)|0;if(!R)Pa(E|0,o|0);C=o}else R=-1;if((R|0)==1){v=C;continue}c[23177]=c[23175];E=u;d:while(1){if((E|0)==-1)break;K=(c[23181]|0)+(E*52|0)|0;c[K>>2]=2;S=0;while(1){if((S|0)>=3)break;if((c[K+4+(S<<4)+12>>2]|0)!=0?(c[c[K+4+(S<<4)+12>>2]>>2]|0)==1:0)break;S=S+1|0}do if((S|0)==3){n=0;T=ka(40,b+16|0,c[c[(c[23173]|0)+(c[23175]<<2)>>2]>>2]|0,c[c[(c[23173]|0)+(c[23176]<<2)>>2]>>2]|0)|0;U=n;n=0;if((U|0)!=0&(o|0)!=0){V=Y4(c[U>>2]|0,l|0,k|0)|0;if(!V)Pa(U|0,o|0);C=o}else V=-1;if((V|0)==1){v=C;continue a}if((T|0)==1){W=c[(c[23173]|0)+(c[23176]<<2)>>2]|0;X=r+8|0;break}else{W=r+8|0;X=c[(c[23173]|0)+(c[23176]<<2)>>2]|0;break}}else{n=0;T=ka(40,c[c[K+4+(S<<4)>>2]>>2]|0,c[c[K+4+(((S+1|0)%3|0)<<4)+4>>2]>>2]|0,c[c[K+4+(S<<4)+4>>2]>>2]|0)|0;U=n;n=0;if((U|0)!=0&(o|0)!=0){Y=Y4(c[U>>2]|0,l|0,k|0)|0;if(!Y)Pa(U|0,o|0);C=o}else Y=-1;if((Y|0)==1){v=C;continue a}U=K+4+(S<<4)|0;if((T|0)==1){W=c[U+4>>2]|0;X=c[K+4+(S<<4)>>2]|0;break}else{W=c[U>>2]|0;X=c[K+4+(S<<4)+4>>2]|0;break}}while(0);e:do if((E|0)==(u|0)){n=0;ga(27,2,W|0);S=n;n=0;if((S|0)!=0&(o|0)!=0){Z=Y4(c[S>>2]|0,l|0,k|0)|0;if(!Z)Pa(S|0,o|0);C=o}else Z=-1;if((Z|0)==1){v=C;continue a}n=0;ga(27,1,X|0);S=n;n=0;if((S|0)!=0&(o|0)!=0){_=Y4(c[S>>2]|0,l|0,k|0)|0;if(!_)Pa(S|0,o|0);C=o}else _=-1;if((_|0)==1){v=C;continue a}}else{do if((c[(c[23173]|0)+(c[23175]<<2)>>2]|0)!=(X|0)){if((c[(c[23173]|0)+(c[23176]<<2)>>2]|0)==(X|0))break;n=0;S=ia(34,X|0)|0;U=n;n=0;if((U|0)!=0&(o|0)!=0){$=Y4(c[U>>2]|0,l|0,k|0)|0;if(!$)Pa(U|0,o|0);C=o}else $=-1;if(($|0)==1){v=C;continue a}n=0;ga(28,2,S|0);U=n;n=0;if((U|0)!=0&(o|0)!=0){aa=Y4(c[U>>2]|0,l|0,k|0)|0;if(!aa)Pa(U|0,o|0);C=o}else aa=-1;if((aa|0)==1){v=C;continue a}n=0;ga(27,1,X|0);U=n;n=0;if((U|0)!=0&(o|0)!=0){ba=Y4(c[U>>2]|0,l|0,k|0)|0;if(!ba)Pa(U|0,o|0);C=o}else ba=-1;if((ba|0)==1){v=C;continue a}if((S|0)<=(c[23177]|0))break e;c[23177]=S;break e}while(0);n=0;S=ia(34,W|0)|0;U=n;n=0;if((U|0)!=0&(o|0)!=0){ca=Y4(c[U>>2]|0,l|0,k|0)|0;if(!ca)Pa(U|0,o|0);C=o}else ca=-1;if((ca|0)==1){v=C;continue a}n=0;ga(28,1,S|0);U=n;n=0;if((U|0)!=0&(o|0)!=0){da=Y4(c[U>>2]|0,l|0,k|0)|0;if(!da)Pa(U|0,o|0);C=o}else da=-1;if((da|0)==1){v=C;continue a}n=0;ga(27,2,W|0);U=n;n=0;if((U|0)!=0&(o|0)!=0){fa=Y4(c[U>>2]|0,l|0,k|0)|0;if(!fa)Pa(U|0,o|0);C=o}else fa=-1;if((fa|0)==1){v=C;continue a}if((S|0)>=(c[23177]|0))break;c[23177]=S}while(0);S=0;while(1){if((S|0)>=3){E=-1;continue d}if((c[K+4+(S<<4)+12>>2]|0)!=0?(c[c[K+4+(S<<4)+12>>2]>>2]|0)==1:0)break;S=S+1|0}E=((c[K+4+(S<<4)+12>>2]|0)-(c[23181]|0)|0)/52|0}ha=0;E=r+8|0;while(1){if(!E)break;ha=ha+1|0;E=c[E+4>>2]|0}n=0;ea(109,ha|0);E=n;n=0;if((E|0)!=0&(o|0)!=0){ja=Y4(c[E>>2]|0,l|0,k|0)|0;if(!ja)Pa(E|0,o|0);C=o}else ja=-1;if((ja|0)==1)v=C;else{w=109;break}}if((w|0)==4){la=-2;O4(l|0);i=e;return la|0}else if((w|0)==49){la=-1;O4(l|0);i=e;return la|0}else if((w|0)==57){la=-1;O4(l|0);i=e;return la|0}else if((w|0)==62){c[d+4>>2]=2;v=c[23180]|0;c[v>>2]=c[b>>2];c[v+4>>2]=c[b+4>>2];c[v+8>>2]=c[b+8>>2];c[v+12>>2]=c[b+12>>2];v=(c[23180]|0)+16|0;ja=b+16|0;c[v>>2]=c[ja>>2];c[v+4>>2]=c[ja+4>>2];c[v+8>>2]=c[ja+8>>2];c[v+12>>2]=c[ja+12>>2];c[d>>2]=c[23180];la=0;O4(l|0);i=e;return la|0}else if((w|0)==65){c[d+4>>2]=2;ja=c[23180]|0;c[ja>>2]=c[b>>2];c[ja+4>>2]=c[b+4>>2];c[ja+8>>2]=c[b+8>>2];c[ja+12>>2]=c[b+12>>2];ja=(c[23180]|0)+16|0;v=b+16|0;c[ja>>2]=c[v>>2];c[ja+4>>2]=c[v+4>>2];c[ja+8>>2]=c[v+8>>2];c[ja+12>>2]=c[v+12>>2];c[d>>2]=c[23180];la=0;O4(l|0);i=e;return la|0}else if((w|0)==109){c[d+4>>2]=ha;w=ha-1|0;ha=r+8|0;while(1){if(!ha)break;r=(c[23180]|0)+(w<<4)|0;v=c[ha>>2]|0;c[r>>2]=c[v>>2];c[r+4>>2]=c[v+4>>2];c[r+8>>2]=c[v+8>>2];c[r+12>>2]=c[v+12>>2];w=w+-1|0;ha=c[ha+4>>2]|0}c[d>>2]=c[23180];la=0;O4(l|0);i=e;return la|0}return 0}function OX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+64|0;d=b+48|0;e=b+32|0;f=b+16|0;g=b;h=b+60|0;c[h>>2]=a;if((c[h>>2]|0)<=(c[23184]|0)){i=b;return}if(c[23178]|0){a=Q4(c[23178]|0,c[h>>2]<<3)|0;c[23178]=a;if(!a){a=c[24742]|0;c[e>>2]=179802;c[e+4>>2]=533;c[e+8>>2]=180091;Y2(a,179783,e)|0;Pa(92528,1)}e=Q4(c[23179]|0,c[h>>2]<<2)|0;c[23179]=e;if(!e){e=c[24742]|0;c[d>>2]=179802;c[d+4>>2]=539;c[d+8>>2]=180111;Y2(e,179783,d)|0;Pa(92528,1)}}else{d=N4(c[h>>2]<<3)|0;c[23178]=d;if(!d){d=c[24742]|0;c[g>>2]=179802;c[g+4>>2]=523;c[g+8>>2]=180052;Y2(d,179783,g)|0;Pa(92528,1)}g=N4(c[h>>2]<<2)|0;c[23179]=g;if(!g){g=c[24742]|0;c[f>>2]=179802;c[f+4>>2]=527;c[f+8>>2]=180071;Y2(g,179783,f)|0;Pa(92528,1)}}c[23184]=c[h>>2];i=b;return}function PX(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+16|0;e=b;f=b+28|0;c[f>>2]=a;if((c[f>>2]|0)<=(c[23174]|0)){i=b;return}if(c[23173]|0){a=Q4(c[23173]|0,c[f>>2]<<2)|0;c[23173]=a;if(!a){a=c[24742]|0;c[d>>2]=179802;c[d+4>>2]=580;c[d+8>>2]=180029;Y2(a,179783,d)|0;Pa(92528,1)}}else{d=N4(c[f>>2]<<2)|0;c[23173]=d;if(!d){d=c[24742]|0;c[e>>2]=179802;c[e+4>>2]=573;c[e+8>>2]=180007;Y2(d,179783,e)|0;Pa(92528,1)}}c[23174]=c[f>>2];i=b;return}function QX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;j=e+8|0;k=e;c[f>>2]=a;c[g>>2]=b;c[j>>2]=d;h[k>>3]=(+h[(c[f>>2]|0)+8>>3]-+h[(c[g>>2]|0)+8>>3])*(+h[c[j>>2]>>3]-+h[c[g>>2]>>3])-(+h[(c[j>>2]|0)+8>>3]-+h[(c[g>>2]|0)+8>>3])*(+h[c[f>>2]>>3]-+h[c[g>>2]>>3]);if(+h[k>>3]>0.0){l=1;i=e;return l|0}l=+h[k>>3]<0.0?2:3;i=e;return l|0}function RX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)<=3){_X(c[c[f>>2]>>2]|0,c[(c[f>>2]|0)+4>>2]|0,c[(c[f>>2]|0)+8>>2]|0);i=d;return}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[g>>2]|0)){l=10;break}c[j>>2]=((c[h>>2]|0)+1|0)%(c[g>>2]|0)|0;c[k>>2]=((c[h>>2]|0)+2|0)%(c[g>>2]|0)|0;b=(ZX(c[h>>2]|0,c[k>>2]|0,c[f>>2]|0,c[g>>2]|0)|0)!=0;m=c[h>>2]|0;if(b)break;c[h>>2]=m+1}if((l|0)==10){l=c[24742]|0;c[e>>2]=179802;c[e+4>>2]=324;c[e+8>>2]=179947;Y2(l,179783,e)|0;i=d;return}_X(c[(c[f>>2]|0)+(m<<2)>>2]|0,c[(c[f>>2]|0)+(c[j>>2]<<2)>>2]|0,c[(c[f>>2]|0)+(c[k>>2]<<2)>>2]|0);c[h>>2]=c[j>>2];while(1){if((c[h>>2]|0)>=((c[g>>2]|0)-1|0))break;c[(c[f>>2]|0)+(c[h>>2]<<2)>>2]=c[(c[f>>2]|0)+((c[h>>2]|0)+1<<2)>>2];c[h>>2]=(c[h>>2]|0)+1}RX(c[f>>2]|0,(c[g>>2]|0)-1|0);i=d;return}function SX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=0;while(1){if((c[j>>2]|0)>=3)break;c[k>>2]=0;while(1){if((c[k>>2]|0)>=3)break;c[g>>2]=(c[23181]|0)+((c[e>>2]|0)*52|0);c[h>>2]=(c[23181]|0)+((c[f>>2]|0)*52|0);if((c[c[(c[g>>2]|0)+4+(c[j>>2]<<4)>>2]>>2]|0)==(c[c[(c[h>>2]|0)+4+(c[k>>2]<<4)>>2]>>2]|0)?(c[c[(c[g>>2]|0)+4+(c[j>>2]<<4)+4>>2]>>2]|0)==(c[c[(c[h>>2]|0)+4+(c[k>>2]<<4)+4>>2]>>2]|0):0)l=9;else l=7;if(((l|0)==7?(l=0,(c[c[(c[g>>2]|0)+4+(c[j>>2]<<4)>>2]>>2]|0)==(c[c[(c[h>>2]|0)+4+(c[k>>2]<<4)+4>>2]>>2]|0)):0)?(c[c[(c[g>>2]|0)+4+(c[j>>2]<<4)+4>>2]>>2]|0)==(c[c[(c[h>>2]|0)+4+(c[k>>2]<<4)>>2]>>2]|0):0)l=9;if((l|0)==9){l=0;c[(c[g>>2]|0)+4+(c[j>>2]<<4)+12>>2]=c[h>>2];c[(c[h>>2]|0)+4+(c[k>>2]<<4)+12>>2]=c[g>>2]}c[k>>2]=(c[k>>2]|0)+1}c[j>>2]=(c[j>>2]|0)+1}i=d;return}function TX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;c[h>>2]=0;while(1){if((c[g>>2]|0)>=3)break;if((QX(c[c[(c[23181]|0)+((c[e>>2]|0)*52|0)+4+(c[g>>2]<<4)>>2]>>2]|0,c[c[(c[23181]|0)+((c[e>>2]|0)*52|0)+4+(c[g>>2]<<4)+4>>2]>>2]|0,c[f>>2]|0)|0)!=2)c[h>>2]=(c[h>>2]|0)+1;c[g>>2]=(c[g>>2]|0)+1}i=d;return ((c[h>>2]|0)==3?1:(c[h>>2]|0)==0)&1|0}function UX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;if(c[(c[23181]|0)+((c[f>>2]|0)*52|0)>>2]|0){c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}c[(c[23181]|0)+((c[f>>2]|0)*52|0)>>2]=1;if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}c[h>>2]=0;while(1){if((c[h>>2]|0)>=3){k=11;break}if((c[(c[23181]|0)+((c[f>>2]|0)*52|0)+4+(c[h>>2]<<4)+12>>2]|0)!=0?(UX(((c[(c[23181]|0)+((c[f>>2]|0)*52|0)+4+(c[h>>2]<<4)+12>>2]|0)-(c[23181]|0)|0)/52|0,c[g>>2]|0)|0)!=0:0){k=9;break}c[h>>2]=(c[h>>2]|0)+1}if((k|0)==9){c[e>>2]=1;j=c[e>>2]|0;i=d;return j|0}else if((k|0)==11){c[(c[23181]|0)+((c[f>>2]|0)*52|0)>>2]=0;c[e>>2]=0;j=c[e>>2]|0;i=d;return j|0}return 0}function VX(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+16|0;e=b;f=b+28|0;c[f>>2]=a;if((c[f>>2]|0)<=(c[23182]|0)){i=b;return}if(c[23180]|0){a=Q4(c[23180]|0,c[f>>2]<<4)|0;c[23180]=a;if(!a){a=c[24742]|0;c[d>>2]=179802;c[d+4>>2]=599;c[d+8>>2]=179928;Y2(a,179783,d)|0;Pa(92528,1)}}else{d=N4(c[f>>2]<<4)|0;c[23180]=d;if(!d){d=c[24742]|0;c[e>>2]=179802;c[e+4>>2]=593;c[e+8>>2]=179910;Y2(d,179783,e)|0;Pa(92528,1)}}c[23182]=c[f>>2];i=b;return}function WX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=((c[23176]|0)-(c[23175]|0)|0)>=0;if((c[e>>2]|0)==1){if(b)c[(c[f>>2]|0)+4>>2]=c[(c[23173]|0)+(c[23175]<<2)>>2];c[23175]=(c[23175]|0)+-1;c[(c[23173]|0)+(c[23175]<<2)>>2]=c[f>>2];i=d;return}else{if(b)c[(c[f>>2]|0)+4>>2]=c[(c[23173]|0)+(c[23176]<<2)>>2];c[23176]=(c[23176]|0)+1;c[(c[23173]|0)+(c[23176]<<2)>>2]=c[f>>2];i=d;return}}function XX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;c[f>>2]=c[23175];while(1){if((c[f>>2]|0)>=(c[23177]|0))break;a=(QX(c[c[(c[23173]|0)+((c[f>>2]|0)+1<<2)>>2]>>2]|0,c[c[(c[23173]|0)+(c[f>>2]<<2)>>2]>>2]|0,c[c[e>>2]>>2]|0)|0)==1;g=c[f>>2]|0;if(a){h=4;break}c[f>>2]=g+1}if((h|0)==4){c[d>>2]=g;j=c[d>>2]|0;i=b;return j|0}c[f>>2]=c[23176];while(1){if((c[f>>2]|0)<=(c[23177]|0)){h=11;break}g=(QX(c[c[(c[23173]|0)+((c[f>>2]|0)-1<<2)>>2]>>2]|0,c[c[(c[23173]|0)+(c[f>>2]<<2)>>2]>>2]|0,c[c[e>>2]>>2]|0)|0)==2;k=c[f>>2]|0;if(g){h=9;break}c[f>>2]=k+-1}if((h|0)==9){c[d>>2]=k;j=c[d>>2]|0;i=b;return j|0}else if((h|0)==11){c[d>>2]=c[23177];j=c[d>>2]|0;i=b;return j|0}return 0}function YX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=c[f>>2]|0;if((c[e>>2]|0)==1){c[23176]=b;i=d;return}else{c[23175]=b;i=d;return}}function ZX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+48|0;g=f+36|0;h=f+32|0;j=f+28|0;k=f+24|0;l=f+20|0;m=f+16|0;n=f+12|0;o=f+8|0;p=f+4|0;q=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=((c[h>>2]|0)+1|0)%(c[l>>2]|0)|0;c[n>>2]=((c[h>>2]|0)+(c[l>>2]|0)-1|0)%(c[l>>2]|0)|0;e=(QX(c[c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]>>2]|0,c[c[(c[k>>2]|0)+(c[h>>2]<<2)>>2]>>2]|0,c[c[(c[k>>2]|0)+(c[m>>2]<<2)>>2]>>2]|0)|0)==1;d=c[c[(c[k>>2]|0)+(c[h>>2]<<2)>>2]>>2]|0;b=c[c[(c[k>>2]|0)+(c[j>>2]<<2)>>2]>>2]|0;if(e){if((QX(d,b,c[c[(c[k>>2]|0)+(c[n>>2]<<2)>>2]>>2]|0)|0)==1)r=(QX(c[c[(c[k>>2]|0)+(c[j>>2]<<2)>>2]>>2]|0,c[c[(c[k>>2]|0)+(c[h>>2]<<2)>>2]>>2]|0,c[c[(c[k>>2]|0)+(c[m>>2]<<2)>>2]>>2]|0)|0)==1;else r=0;c[q>>2]=r&1}else c[q>>2]=(QX(d,b,c[c[(c[k>>2]|0)+(c[m>>2]<<2)>>2]>>2]|0)|0)==2&1;if(!(c[q>>2]|0)){c[g>>2]=0;s=c[g>>2]|0;i=f;return s|0}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[l>>2]|0)){t=17;break}c[p>>2]=((c[o>>2]|0)+1|0)%(c[l>>2]|0)|0;if(((((c[o>>2]|0)!=(c[h>>2]|0)?(c[p>>2]|0)!=(c[h>>2]|0):0)?(c[o>>2]|0)!=(c[j>>2]|0):0)?(c[p>>2]|0)!=(c[j>>2]|0):0)?(aY(c[c[(c[k>>2]|0)+(c[h>>2]<<2)>>2]>>2]|0,c[c[(c[k>>2]|0)+(c[j>>2]<<2)>>2]>>2]|0,c[c[(c[k>>2]|0)+(c[o>>2]<<2)>>2]>>2]|0,c[c[(c[k>>2]|0)+(c[p>>2]<<2)>>2]>>2]|0)|0)!=0:0){t=15;break}c[o>>2]=(c[o>>2]|0)+1}if((t|0)==15){c[g>>2]=0;s=c[g>>2]|0;i=f;return s|0}else if((t|0)==17){c[g>>2]=1;s=c[g>>2]|0;i=f;return s|0}return 0}function _X(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if((c[23172]|0)>=(c[23183]|0))$X((c[23183]|0)+20|0);d=c[23172]|0;c[23172]=d+1;c[j>>2]=(c[23181]|0)+(d*52|0);c[c[j>>2]>>2]=0;c[(c[j>>2]|0)+4>>2]=c[f>>2];c[(c[j>>2]|0)+4+4>>2]=c[g>>2];c[(c[j>>2]|0)+4+12>>2]=0;c[(c[j>>2]|0)+4+16>>2]=c[g>>2];c[(c[j>>2]|0)+4+16+4>>2]=c[h>>2];c[(c[j>>2]|0)+4+16+12>>2]=0;c[(c[j>>2]|0)+4+32>>2]=c[h>>2];c[(c[j>>2]|0)+4+32+4>>2]=c[f>>2];c[(c[j>>2]|0)+4+32+12>>2]=0;c[k>>2]=0;while(1){if((c[k>>2]|0)>=3)break;c[(c[j>>2]|0)+4+(c[k>>2]<<4)+8>>2]=c[j>>2];c[k>>2]=(c[k>>2]|0)+1}i=e;return}function $X(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+16|0;e=b;f=b+28|0;c[f>>2]=a;if((c[f>>2]|0)<=(c[23183]|0)){i=b;return}if(c[23181]|0){a=Q4(c[23181]|0,(c[f>>2]|0)*52|0)|0;c[23181]=a;if(!a){a=c[24742]|0;c[d>>2]=179802;c[d+4>>2]=558;c[d+8>>2]=179987;Y2(a,179783,d)|0;Pa(92528,1)}}else{d=N4((c[f>>2]|0)*52|0)|0;c[23181]=d;if(!d){d=c[24742]|0;c[e>>2]=179802;c[e+4>>2]=552;c[e+8>>2]=179968;Y2(d,179783,e)|0;Pa(92528,1)}}c[23183]=c[f>>2];i=b;return}function aY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((((QX(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0)!=3?(QX(c[h>>2]|0,c[j>>2]|0,c[l>>2]|0)|0)!=3:0)?(QX(c[k>>2]|0,c[l>>2]|0,c[h>>2]|0)|0)!=3:0)?(QX(c[k>>2]|0,c[l>>2]|0,c[j>>2]|0)|0)!=3:0){e=(QX(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0)==1;c[m>>2]=e?1:0;e=(QX(c[h>>2]|0,c[j>>2]|0,c[l>>2]|0)|0)==1;c[n>>2]=e?1:0;e=(QX(c[k>>2]|0,c[l>>2]|0,c[h>>2]|0)|0)==1;c[o>>2]=e?1:0;e=(QX(c[k>>2]|0,c[l>>2]|0,c[j>>2]|0)|0)==1;c[p>>2]=e?1:0;if(c[m>>2]^c[n>>2])q=(c[o>>2]^c[p>>2]|0)!=0;else q=0;c[g>>2]=q&1;r=c[g>>2]|0;i=f;return r|0}if((((bY(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0)==0?(bY(c[h>>2]|0,c[j>>2]|0,c[l>>2]|0)|0)==0:0)?(bY(c[k>>2]|0,c[l>>2]|0,c[h>>2]|0)|0)==0:0)?(bY(c[k>>2]|0,c[l>>2]|0,c[j>>2]|0)|0)==0:0){c[g>>2]=0;r=c[g>>2]|0;i=f;return r|0}c[g>>2]=1;r=c[g>>2]|0;i=f;return r|0}function bY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+44|0;g=e+40|0;j=e+36|0;k=e+32|0;l=e+16|0;m=e;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;h[l>>3]=+h[c[j>>2]>>3]-+h[c[g>>2]>>3];h[l+8>>3]=+h[(c[j>>2]|0)+8>>3]-+h[(c[g>>2]|0)+8>>3];h[m>>3]=+h[c[k>>2]>>3]-+h[c[g>>2]>>3];h[m+8>>3]=+h[(c[k>>2]|0)+8>>3]-+h[(c[g>>2]|0)+8>>3];if((QX(c[g>>2]|0,c[j>>2]|0,c[k>>2]|0)|0)!=3){c[f>>2]=0;n=c[f>>2]|0;i=e;return n|0}if(+h[m>>3]*+h[l>>3]+ +h[m+8>>3]*+h[l+8>>3]>=0.0)o=+h[m>>3]*+h[m>>3]+ +h[m+8>>3]*+h[m+8>>3]<=+h[l>>3]*+h[l>>3]+ +h[l+8>>3]*+h[l+8>>3];else o=0;c[f>>2]=o&1;n=c[f>>2]|0;i=e;return n|0}function cY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+64|0;g=f+52|0;j=f+48|0;k=f+44|0;l=f+40|0;m=f+36|0;n=f+32|0;o=f+28|0;p=f+24|0;q=f+20|0;r=f+16|0;s=f+8|0;t=f;c[g>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=N4(c[k>>2]<<2)|0;c[n>>2]=N4((c[k>>2]|0)+1<<3)|0;c[o>>2]=(c[n>>2]|0)+8;c[q>>2]=0;while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[(c[m>>2]|0)+(c[q>>2]<<2)>>2]=-1;h[(c[o>>2]|0)+(c[q>>2]<<3)>>3]=-+h[5507];c[q>>2]=(c[q>>2]|0)+1}h[(c[o>>2]|0)+-8>>3]=-(+h[5507]+1.0);c[p>>2]=c[g>>2];a:while(1){if((c[p>>2]|0)==(c[j>>2]|0))break;c[q>>2]=c[p>>2];g=(c[o>>2]|0)+(c[q>>2]<<3)|0;h[g>>3]=+h[g>>3]*-1.0;c[p>>2]=-1;if(+h[(c[o>>2]|0)+(c[q>>2]<<3)>>3]==+h[5507])h[(c[o>>2]|0)+(c[q>>2]<<3)>>3]=0.0;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[k>>2]|0))continue a;if(+h[(c[o>>2]|0)+(c[r>>2]<<3)>>3]<0.0){if((c[q>>2]|0)>=(c[r>>2]|0))h[t>>3]=+h[(c[(c[l>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[r>>2]<<3)>>3];else h[t>>3]=+h[(c[(c[l>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[q>>2]<<3)>>3];h[s>>3]=-(+h[(c[o>>2]|0)+(c[q>>2]<<3)>>3]+ +h[t>>3]);if(+h[t>>3]!=0.0?+h[(c[o>>2]|0)+(c[r>>2]<<3)>>3]<+h[s>>3]:0){h[(c[o>>2]|0)+(c[r>>2]<<3)>>3]=+h[s>>3];c[(c[m>>2]|0)+(c[r>>2]<<2)>>2]=c[q>>2]}if(+h[(c[o>>2]|0)+(c[r>>2]<<3)>>3]>+h[(c[o>>2]|0)+(c[p>>2]<<3)>>3])c[p>>2]=c[r>>2]}c[r>>2]=(c[r>>2]|0)+1}}O4(c[n>>2]|0);i=f;return c[m>>2]|0}function dY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+80|0;k=j+16|0;l=j;m=j+64|0;n=j+60|0;o=j+56|0;p=j+52|0;q=j+48|0;r=j+44|0;s=j+40|0;t=j+36|0;u=j+32|0;c[n>>2]=b;c[o>>2]=d;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=c[(c[r>>2]|0)+4>>2];h=c[n>>2]|0;n=c[p>>2]|0;p=c[r>>2]|0;c[l>>2]=c[a>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];c[k>>2]=c[e>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];if(pY(l,h,k,n,p)|0){c[t>>2]=N4((c[s>>2]|0)+2<<2)|0;c[(c[t>>2]|0)+(c[s>>2]<<2)>>2]=(c[s>>2]|0)+1;c[(c[t>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=-1;c[m>>2]=c[t>>2];v=c[m>>2]|0;i=j;return v|0}else{c[u>>2]=c[(c[r>>2]|0)+24>>2];c[(c[u>>2]|0)+(c[s>>2]<<2)>>2]=c[q>>2];c[(c[u>>2]|0)+((c[s>>2]|0)+1<<2)>>2]=c[o>>2];c[m>>2]=cY((c[s>>2]|0)+1|0,c[s>>2]|0,(c[s>>2]|0)+2|0,c[u>>2]|0)|0;v=c[m>>2]|0;i=j;return v|0}return 0}function eY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0;d=i;i=i+144|0;e=d+136|0;f=d+132|0;g=d+128|0;j=d+112|0;k=d+104|0;l=d+96|0;m=d+88|0;n=d+124|0;o=d+120|0;p=d+80|0;q=d+72|0;r=d+64|0;s=d+56|0;t=d+48|0;u=d+40|0;v=d+32|0;w=d+24|0;x=d+16|0;y=d+8|0;z=d;c[f>>2]=a;c[g>>2]=b;h[j>>3]=+h[(c[f>>2]|0)+24>>3];h[k>>3]=+h[(c[f>>2]|0)+16>>3];h[l>>3]=+h[(c[f>>2]|0)+8>>3];h[m>>3]=+h[c[f>>2]>>3];if(+h[j>>3]<1.0e-07&+h[j>>3]>-1.0e-07){c[e>>2]=fY(c[f>>2]|0,c[g>>2]|0)|0;A=c[e>>2]|0;i=d;return A|0}h[s>>3]=+h[k>>3]/(+h[j>>3]*3.0);h[t>>3]=+h[l>>3]/+h[j>>3];h[u>>3]=+h[m>>3]/+h[j>>3];h[p>>3]=+h[s>>3]*+h[s>>3];h[q>>3]=+h[s>>3]*2.0*+h[p>>3]-+h[s>>3]*+h[t>>3]+ +h[u>>3];h[p>>3]=+h[t>>3]/3.0-+h[p>>3];h[r>>3]=+h[q>>3]*+h[q>>3]+ +h[p>>3]*4.0*+h[p>>3]*+h[p>>3];B=+h[r>>3];do if(!(+h[r>>3]<0.0)){C=+O(+B);h[y>>3]=(C-+h[q>>3])*.5;h[z>>3]=-+h[q>>3]-+h[y>>3];C=+Y1(+h[y>>3]);D=C+ +Y1(+h[z>>3]);h[c[g>>2]>>3]=D;if(+h[r>>3]>0.0){c[n>>2]=1;break}else{D=+h[c[g>>2]>>3]*-.5;h[(c[g>>2]|0)+16>>3]=D;h[(c[g>>2]|0)+8>>3]=D;c[n>>2]=3;break}}else{h[v>>3]=+O(+(-B+ +h[q>>3]*+h[q>>3]))*.5;D=+O(+-+h[r>>3]);h[w>>3]=+W(+D,+-+h[q>>3]);h[x>>3]=+Y1(+h[v>>3])*2.0;D=+h[x>>3]*+Q(+(+h[w>>3]/3.0));h[c[g>>2]>>3]=D;D=+h[x>>3]*+Q(+((+h[w>>3]+3.141592653589793+3.141592653589793)/3.0));h[(c[g>>2]|0)+8>>3]=D;D=+h[x>>3]*+Q(+((+h[w>>3]-3.141592653589793-3.141592653589793)/3.0));h[(c[g>>2]|0)+16>>3]=D;c[n>>2]=3}while(0);c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[n>>2]|0))break;w=(c[g>>2]|0)+(c[o>>2]<<3)|0;h[w>>3]=+h[w>>3]-+h[s>>3];c[o>>2]=(c[o>>2]|0)+1}c[e>>2]=c[n>>2];A=c[e>>2]|0;i=d;return A|0}function fY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0;d=i;i=i+64|0;e=d+56|0;f=d+52|0;g=d+48|0;j=d+40|0;k=d+32|0;l=d+24|0;m=d+16|0;n=d+8|0;o=d;c[f>>2]=a;c[g>>2]=b;h[j>>3]=+h[(c[f>>2]|0)+16>>3];h[k>>3]=+h[(c[f>>2]|0)+8>>3];h[l>>3]=+h[c[f>>2]>>3];if(+h[j>>3]<1.0e-07&+h[j>>3]>-1.0e-07){c[e>>2]=gY(c[f>>2]|0,c[g>>2]|0)|0;p=c[e>>2]|0;i=d;return p|0}h[n>>3]=+h[k>>3]/(+h[j>>3]*2.0);h[o>>3]=+h[l>>3]/+h[j>>3];h[m>>3]=+h[n>>3]*+h[n>>3]-+h[o>>3];if(+h[m>>3]<0.0){c[e>>2]=0;p=c[e>>2]|0;i=d;return p|0}q=-+h[n>>3];if(+h[m>>3]==0.0){h[c[g>>2]>>3]=q;c[e>>2]=1;p=c[e>>2]|0;i=d;return p|0}else{r=q+ +O(+(+h[m>>3]));h[c[g>>2]>>3]=r;h[(c[g>>2]|0)+8>>3]=+h[n>>3]*-2.0-+h[c[g>>2]>>3];c[e>>2]=2;p=c[e>>2]|0;i=d;return p|0}return 0}function gY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;j=d+8|0;k=d;c[f>>2]=a;c[g>>2]=b;h[j>>3]=+h[(c[f>>2]|0)+8>>3];h[k>>3]=+h[c[f>>2]>>3];l=+h[k>>3];if(!(+h[j>>3]<1.0e-07&+h[j>>3]>-1.0e-07)){h[c[g>>2]>>3]=-l/+h[j>>3];c[e>>2]=1;m=c[e>>2]|0;i=d;return m|0}if(l<1.0e-07&+h[k>>3]>-1.0e-07){c[e>>2]=4;m=c[e>>2]|0;i=d;return m|0}else{c[e>>2]=0;m=c[e>>2]|0;i=d;return m|0}return 0}function hY(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[d>>2]>>2]|0);O4(c[d>>2]|0);i=b;return}function iY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=b;c[h>>2]=4+(((c[a+4>>2]|0)-2|0)*3|0);if((c[h>>2]|0)>(c[23185]|0)){if(c[23186]|0)j=Q4(c[23186]|0,c[h>>2]<<4)|0;else j=N4(c[h>>2]<<4)|0;c[23186]=j;c[23185]=c[h>>2]}c[f>>2]=0;c[g>>2]=0;j=(c[23186]|0)+((c[g>>2]|0)+1<<4)|0;b=(c[23186]|0)+(c[g>>2]<<4)|0;k=(c[a>>2]|0)+(c[f>>2]<<4)|0;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];c[b+8>>2]=c[k+8>>2];c[b+12>>2]=c[k+12>>2];c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];c[g>>2]=(c[g>>2]|0)+2;c[f>>2]=(c[f>>2]|0)+1;while(1){l=c[g>>2]|0;if((c[f>>2]|0)>=((c[a+4>>2]|0)-1|0))break;b=(c[23186]|0)+(l+2<<4)|0;j=(c[23186]|0)+((c[g>>2]|0)+1<<4)|0;k=(c[23186]|0)+(c[g>>2]<<4)|0;m=(c[a>>2]|0)+(c[f>>2]<<4)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[b>>2]=c[j>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];c[g>>2]=(c[g>>2]|0)+3;c[f>>2]=(c[f>>2]|0)+1}j=(c[23186]|0)+(l+1<<4)|0;l=(c[23186]|0)+(c[g>>2]<<4)|0;g=(c[a>>2]|0)+(c[f>>2]<<4)|0;c[l>>2]=c[g>>2];c[l+4>>2]=c[g+4>>2];c[l+8>>2]=c[g+8>>2];c[l+12>>2]=c[g+12>>2];c[j>>2]=c[l>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];c[(c[e>>2]|0)+4>>2]=c[h>>2];c[c[e>>2]>>2]=c[23186];i=d;return}function jY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;h[e>>3]=(+h[a+8>>3]-+h[b+8>>3])*(+h[c>>3]-+h[b>>3])-(+h[c+8>>3]-+h[b+8>>3])*(+h[a>>3]-+h[b>>3]);if(+h[e>>3]>.0001){f=1;i=d;return f|0}f=+h[e>>3]<-.0001?-1:0;i=d;return f|0}function kY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+16|0;f=e;if(+h[a>>3]!=+h[b>>3]){if(+h[a>>3]<+h[d>>3]?+h[d>>3]<+h[b>>3]:0)g=1;else if(+h[b>>3]<+h[d>>3])g=+h[d>>3]<+h[a>>3];else g=0;c[f>>2]=g&1;j=c[f>>2]|0;i=e;return j|0}else{if(+h[a+8>>3]<+h[d+8>>3]?+h[d+8>>3]<+h[b+8>>3]:0)k=1;else if(+h[b+8>>3]<+h[d+8>>3])k=+h[d+8>>3]<+h[a+8>>3];else k=0;c[f>>2]=k&1;j=c[f>>2]|0;i=e;return j|0}return 0}function lY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f+32|0;h=f+16|0;j=f;k=f+64|0;l=f+60|0;m=f+56|0;n=f+52|0;o=f+48|0;c[j>>2]=c[a>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[h>>2]=c[b>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[l>>2]=jY(j,h,g)|0;if((c[l>>2]|0)==0?(c[j>>2]=c[a>>2],c[j+4>>2]=c[a+4>>2],c[j+8>>2]=c[a+8>>2],c[j+12>>2]=c[a+12>>2],c[h>>2]=c[b>>2],c[h+4>>2]=c[b+4>>2],c[h+8>>2]=c[b+8>>2],c[h+12>>2]=c[b+12>>2],c[g>>2]=c[d>>2],c[g+4>>2]=c[d+4>>2],c[g+8>>2]=c[d+8>>2],c[g+12>>2]=c[d+12>>2],(kY(j,h,g)|0)!=0):0){c[k>>2]=1;p=c[k>>2]|0;i=f;return p|0};c[j>>2]=c[a>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[h>>2]=c[b>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[m>>2]=jY(j,h,g)|0;if((c[m>>2]|0)==0?(c[j>>2]=c[a>>2],c[j+4>>2]=c[a+4>>2],c[j+8>>2]=c[a+8>>2],c[j+12>>2]=c[a+12>>2],c[h>>2]=c[b>>2],c[h+4>>2]=c[b+4>>2],c[h+8>>2]=c[b+8>>2],c[h+12>>2]=c[b+12>>2],c[g>>2]=c[e>>2],c[g+4>>2]=c[e+4>>2],c[g+8>>2]=c[e+8>>2],c[g+12>>2]=c[e+12>>2],(kY(j,h,g)|0)!=0):0){c[k>>2]=1;p=c[k>>2]|0;i=f;return p|0};c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[h>>2]=c[e>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[g>>2]=c[a>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[n>>2]=jY(j,h,g)|0;c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[h>>2]=c[e>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[o>>2]=jY(j,h,g)|0;if((_(c[l>>2]|0,c[m>>2]|0)|0)<0)q=(_(c[n>>2]|0,c[o>>2]|0)|0)<0;else q=0;c[k>>2]=q&1;p=c[k>>2]|0;i=f;return p|0}function mY(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=c+8|0;e=c;h[d>>3]=+h[a>>3]-+h[b>>3];h[e>>3]=+h[a+8>>3]-+h[b+8>>3];i=c;return +(+h[d>>3]*+h[d>>3]+ +h[e>>3]*+h[e>>3])}function nY(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=qY(c[(c[d>>2]|0)+4>>2]|0,2)|0;c[(c[d>>2]|0)+24>>2]=a;rY(c[d>>2]|0,0);i=b;return}function oY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+128|0;f=e+72|0;g=e+56|0;j=e+40|0;k=e+24|0;l=e+124|0;m=e+120|0;n=e+116|0;o=e+112|0;p=e+108|0;q=e+104|0;r=e+100|0;s=e+96|0;t=e+92|0;u=e+88|0;v=e+8|0;w=e;c[l>>2]=a;c[m>>2]=b;c[n>>2]=c[(c[l>>2]|0)+4>>2];c[o>>2]=c[(c[l>>2]|0)+8>>2];c[p>>2]=c[(c[l>>2]|0)+16>>2];c[q>>2]=c[(c[l>>2]|0)+20>>2];c[u>>2]=N4((c[n>>2]|0)+2<<3)|0;if((c[m>>2]|0)==-2222){b=c[l>>2]|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[m>>2]=sY(b,f)|0}if((c[m>>2]|0)>=0){c[s>>2]=c[(c[(c[l>>2]|0)+12>>2]|0)+(c[m>>2]<<2)>>2];c[t>>2]=c[(c[(c[l>>2]|0)+12>>2]|0)+((c[m>>2]|0)+1<<2)>>2]}else{c[s>>2]=c[n>>2];c[t>>2]=c[n>>2]}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[s>>2]|0))break;m=(c[o>>2]|0)+(c[r>>2]<<4)|0;c[v>>2]=c[m>>2];c[v+4>>2]=c[m+4>>2];c[v+8>>2]=c[m+8>>2];c[v+12>>2]=c[m+12>>2];m=(c[o>>2]|0)+(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]<<4)|0;l=(c[o>>2]|0)+(c[(c[p>>2]|0)+(c[r>>2]<<2)>>2]<<4)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];if((tY(k,j,g,f)|0)!=0?(l=c[s>>2]|0,m=c[t>>2]|0,b=c[n>>2]|0,a=c[o>>2]|0,x=c[p>>2]|0,y=c[q>>2]|0,c[g>>2]=c[d>>2],c[g+4>>2]=c[d+4>>2],c[g+8>>2]=c[d+8>>2],c[g+12>>2]=c[d+12>>2],c[f>>2]=c[v>>2],c[f+4>>2]=c[v+4>>2],c[f+8>>2]=c[v+8>>2],c[f+12>>2]=c[v+12>>2],(uY(g,f,l,m,b,a,x,y)|0)!=0):0){c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f>>2]=c[v>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];h[w>>3]=+vY(g,f);h[(c[u>>2]|0)+(c[r>>2]<<3)>>3]=+h[w>>3]}else h[(c[u>>2]|0)+(c[r>>2]<<3)>>3]=0.0;c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=c[s>>2];while(1){if((c[r>>2]|0)>=(c[t>>2]|0))break;h[(c[u>>2]|0)+(c[r>>2]<<3)>>3]=0.0;c[r>>2]=(c[r>>2]|0)+1}c[r>>2]=c[t>>2];while(1){if((c[r>>2]|0)>=(c[n>>2]|0))break;y=(c[o>>2]|0)+(c[r>>2]<<4)|0;c[v>>2]=c[y>>2];c[v+4>>2]=c[y+4>>2];c[v+8>>2]=c[y+8>>2];c[v+12>>2]=c[y+12>>2];y=(c[o>>2]|0)+(c[(c[q>>2]|0)+(c[r>>2]<<2)>>2]<<4)|0;x=(c[o>>2]|0)+(c[(c[p>>2]|0)+(c[r>>2]<<2)>>2]<<4)|0;c[k>>2]=c[y>>2];c[k+4>>2]=c[y+4>>2];c[k+8>>2]=c[y+8>>2];c[k+12>>2]=c[y+12>>2];c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[g>>2]=c[x>>2];c[g+4>>2]=c[x+4>>2];c[g+8>>2]=c[x+8>>2];c[g+12>>2]=c[x+12>>2];c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];if((tY(k,j,g,f)|0)!=0?(x=c[s>>2]|0,y=c[t>>2]|0,a=c[n>>2]|0,b=c[o>>2]|0,m=c[p>>2]|0,l=c[q>>2]|0,c[g>>2]=c[d>>2],c[g+4>>2]=c[d+4>>2],c[g+8>>2]=c[d+8>>2],c[g+12>>2]=c[d+12>>2],c[f>>2]=c[v>>2],c[f+4>>2]=c[v+4>>2],c[f+8>>2]=c[v+8>>2],c[f+12>>2]=c[v+12>>2],(uY(g,f,x,y,a,b,m,l)|0)!=0):0){c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[f>>2]=c[v>>2];c[f+4>>2]=c[v+4>>2];c[f+8>>2]=c[v+8>>2];c[f+12>>2]=c[v+12>>2];h[w>>3]=+vY(g,f);h[(c[u>>2]|0)+(c[r>>2]<<3)>>3]=+h[w>>3]}else h[(c[u>>2]|0)+(c[r>>2]<<3)>>3]=0.0;c[r>>2]=(c[r>>2]|0)+1}h[(c[u>>2]|0)+(c[n>>2]<<3)>>3]=0.0;h[(c[u>>2]|0)+((c[n>>2]|0)+1<<3)>>3]=0.0;i=e;return c[u>>2]|0}function pY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+112|0;h=g+48|0;j=g+32|0;k=g+16|0;l=g;m=g+108|0;n=g+104|0;o=g+100|0;p=g+96|0;q=g+92|0;r=g+88|0;s=g+84|0;t=g+80|0;u=g+76|0;v=g+72|0;w=g+68|0;x=g+64|0;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=c[(c[p>>2]|0)+4>>2];c[r>>2]=c[(c[p>>2]|0)+8>>2];c[s>>2]=c[(c[p>>2]|0)+16>>2];do if((c[n>>2]|0)<0){c[u>>2]=0;c[v>>2]=0;if((c[o>>2]|0)<0){c[w>>2]=0;c[x>>2]=0;break}else{c[w>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[o>>2]<<2)>>2];c[x>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+((c[o>>2]|0)+1<<2)>>2];break}}else{if((c[o>>2]|0)<0){c[u>>2]=0;c[v>>2]=0;c[w>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[n>>2]<<2)>>2];c[x>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+((c[n>>2]|0)+1<<2)>>2];break}if((c[n>>2]|0)<=(c[o>>2]|0)){c[u>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[n>>2]<<2)>>2];c[v>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+((c[n>>2]|0)+1<<2)>>2];c[w>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[o>>2]<<2)>>2];c[x>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+((c[o>>2]|0)+1<<2)>>2];break}else{c[u>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[o>>2]<<2)>>2];c[v>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+((c[o>>2]|0)+1<<2)>>2];c[w>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+(c[n>>2]<<2)>>2];c[x>>2]=c[(c[(c[p>>2]|0)+12>>2]|0)+((c[n>>2]|0)+1<<2)>>2];break}}while(0);c[t>>2]=0;while(1){if((c[t>>2]|0)>=(c[u>>2]|0))break;n=(c[r>>2]|0)+(c[t>>2]<<4)|0;p=(c[r>>2]|0)+(c[(c[s>>2]|0)+(c[t>>2]<<2)>>2]<<4)|0;c[l>>2]=c[a>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];c[h>>2]=c[p>>2];c[h+4>>2]=c[p+4>>2];c[h+8>>2]=c[p+8>>2];c[h+12>>2]=c[p+12>>2];if(lY(l,k,j,h)|0){y=13;break}c[t>>2]=(c[t>>2]|0)+1}if((y|0)==13){c[m>>2]=0;z=c[m>>2]|0;i=g;return z|0}c[t>>2]=c[v>>2];while(1){if((c[t>>2]|0)>=(c[w>>2]|0))break;v=(c[r>>2]|0)+(c[t>>2]<<4)|0;u=(c[r>>2]|0)+(c[(c[s>>2]|0)+(c[t>>2]<<2)>>2]<<4)|0;c[l>>2]=c[a>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];c[j+12>>2]=c[v+12>>2];c[h>>2]=c[u>>2];c[h+4>>2]=c[u+4>>2];c[h+8>>2]=c[u+8>>2];c[h+12>>2]=c[u+12>>2];if(lY(l,k,j,h)|0){y=18;break}c[t>>2]=(c[t>>2]|0)+1}if((y|0)==18){c[m>>2]=0;z=c[m>>2]|0;i=g;return z|0}c[t>>2]=c[x>>2];while(1){if((c[t>>2]|0)>=(c[q>>2]|0)){y=25;break}x=(c[r>>2]|0)+(c[t>>2]<<4)|0;w=(c[r>>2]|0)+(c[(c[s>>2]|0)+(c[t>>2]<<2)>>2]<<4)|0;c[l>>2]=c[a>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[j>>2]=c[x>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];c[h>>2]=c[w>>2];c[h+4>>2]=c[w+4>>2];c[h+8>>2]=c[w+8>>2];c[h+12>>2]=c[w+12>>2];if(lY(l,k,j,h)|0){y=23;break}c[t>>2]=(c[t>>2]|0)+1}if((y|0)==23){c[m>>2]=0;z=c[m>>2]|0;i=g;return z|0}else if((y|0)==25){c[m>>2]=1;z=c[m>>2]|0;i=g;return z|0}return 0}function qY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=N4((c[e>>2]|0)+(c[f>>2]|0)<<2)|0;c[j>>2]=P4(_(c[e>>2]|0,c[e>>2]|0)|0,8)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[e>>2]|0))break;c[(c[h>>2]|0)+(c[g>>2]<<2)>>2]=c[j>>2];c[j>>2]=(c[j>>2]|0)+(c[e>>2]<<3);c[g>>2]=(c[g>>2]|0)+1}c[g>>2]=c[e>>2];while(1){if((c[g>>2]|0)>=((c[e>>2]|0)+(c[f>>2]|0)|0))break;c[(c[h>>2]|0)+(c[g>>2]<<2)>>2]=0;c[g>>2]=(c[g>>2]|0)+1}i=d;return c[h>>2]|0}function rY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+80|0;e=d+24|0;f=d+8|0;g=d+76|0;j=d+72|0;k=d+68|0;l=d+64|0;m=d+60|0;n=d+56|0;o=d+52|0;p=d+48|0;q=d+44|0;r=d+40|0;s=d;c[g>>2]=a;c[j>>2]=b;c[k>>2]=c[(c[g>>2]|0)+4>>2];c[l>>2]=c[(c[g>>2]|0)+8>>2];c[m>>2]=c[(c[g>>2]|0)+16>>2];c[n>>2]=c[(c[g>>2]|0)+20>>2];c[o>>2]=c[(c[g>>2]|0)+24>>2];c[q>>2]=c[j>>2];while(1){if((c[q>>2]|0)>=(c[k>>2]|0))break;c[r>>2]=c[(c[n>>2]|0)+(c[q>>2]<<2)>>2];j=(c[l>>2]|0)+(c[q>>2]<<4)|0;g=(c[l>>2]|0)+(c[r>>2]<<4)|0;c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];h[s>>3]=+vY(f,e);h[(c[(c[o>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[r>>2]<<3)>>3]=+h[s>>3];h[(c[(c[o>>2]|0)+(c[r>>2]<<2)>>2]|0)+(c[q>>2]<<3)>>3]=+h[s>>3];g=c[q>>2]|0;if((c[r>>2]|0)==((c[q>>2]|0)-1|0))c[p>>2]=g-2;else c[p>>2]=g-1;while(1){t=c[q>>2]|0;if((c[p>>2]|0)<0)break;if(((wY(t,c[p>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0)!=0?(wY(c[p>>2]|0,c[q>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0)!=0:0)?(g=(c[l>>2]|0)+(c[q>>2]<<4)|0,j=(c[l>>2]|0)+(c[p>>2]<<4)|0,b=c[k>>2]|0,a=c[k>>2]|0,u=c[k>>2]|0,v=c[l>>2]|0,w=c[m>>2]|0,x=c[n>>2]|0,c[f>>2]=c[g>>2],c[f+4>>2]=c[g+4>>2],c[f+8>>2]=c[g+8>>2],c[f+12>>2]=c[g+12>>2],c[e>>2]=c[j>>2],c[e+4>>2]=c[j+4>>2],c[e+8>>2]=c[j+8>>2],c[e+12>>2]=c[j+12>>2],(uY(f,e,b,a,u,v,w,x)|0)!=0):0){x=(c[l>>2]|0)+(c[q>>2]<<4)|0;w=(c[l>>2]|0)+(c[p>>2]<<4)|0;c[f>>2]=c[x>>2];c[f+4>>2]=c[x+4>>2];c[f+8>>2]=c[x+8>>2];c[f+12>>2]=c[x+12>>2];c[e>>2]=c[w>>2];c[e+4>>2]=c[w+4>>2];c[e+8>>2]=c[w+8>>2];c[e+12>>2]=c[w+12>>2];h[s>>3]=+vY(f,e);h[(c[(c[o>>2]|0)+(c[q>>2]<<2)>>2]|0)+(c[p>>2]<<3)>>3]=+h[s>>3];h[(c[(c[o>>2]|0)+(c[p>>2]<<2)>>2]|0)+(c[q>>2]<<3)>>3]=+h[s>>3]}c[p>>2]=(c[p>>2]|0)+-1}c[q>>2]=t+1}i=d;return}function sY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+48|0;e=d;f=d+40|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+16|0;c[h>>2]=a;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[c[h>>2]>>2]|0)){l=6;break}c[k>>2]=(c[(c[h>>2]|0)+8>>2]|0)+(c[(c[(c[h>>2]|0)+12>>2]|0)+(c[j>>2]<<2)>>2]<<4);c[k+4>>2]=(c[(c[(c[h>>2]|0)+12>>2]|0)+((c[j>>2]|0)+1<<2)>>2]|0)-(c[(c[(c[h>>2]|0)+12>>2]|0)+(c[j>>2]<<2)>>2]|0);c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];a=(qX(f,e)|0)!=0;m=c[j>>2]|0;if(a){l=4;break}c[j>>2]=m+1}if((l|0)==4){c[g>>2]=m;n=c[g>>2]|0;i=d;return n|0}else if((l|0)==6){c[g>>2]=-1111;n=c[g>>2]|0;i=d;return n|0}return 0}function tY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+64|0;g=f+32|0;h=f+16|0;j=f;k=f+56|0;l=f+52|0;m=f+48|0;c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[h>>2]=c[a>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[l>>2]=jY(j,h,g)|0;c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[h>>2]=c[b>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[m>>2]=jY(j,h,g)|0;c[j>>2]=c[a>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[h>>2]=c[b>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];d=(jY(j,h,g)|0)>0;g=(c[l>>2]|0)>=0;l=(c[m>>2]|0)>=0;if(d){c[k>>2]=(g?l:0)&1;n=c[k>>2]|0;i=f;return n|0}else{c[k>>2]=(g?1:l)&1;n=c[k>>2]|0;i=f;return n|0}return 0}function uY(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+96|0;l=k+48|0;m=k+32|0;n=k+16|0;o=k;p=k+92|0;q=k+88|0;r=k+84|0;s=k+80|0;t=k+76|0;u=k+72|0;v=k+64|0;c[q>>2]=d;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;c[u>>2]=h;c[k+68>>2]=j;c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[q>>2]|0))break;j=(c[t>>2]|0)+(c[v>>2]<<4)|0;h=(c[t>>2]|0)+(c[(c[u>>2]|0)+(c[v>>2]<<2)>>2]<<4)|0;c[o>>2]=c[a>>2];c[o+4>>2]=c[a+4>>2];c[o+8>>2]=c[a+8>>2];c[o+12>>2]=c[a+12>>2];c[n>>2]=c[b>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];c[m>>2]=c[j>>2];c[m+4>>2]=c[j+4>>2];c[m+8>>2]=c[j+8>>2];c[m+12>>2]=c[j+12>>2];c[l>>2]=c[h>>2];c[l+4>>2]=c[h+4>>2];c[l+8>>2]=c[h+8>>2];c[l+12>>2]=c[h+12>>2];if(lY(o,n,m,l)|0){w=4;break}c[v>>2]=(c[v>>2]|0)+1}if((w|0)==4){c[p>>2]=0;x=c[p>>2]|0;i=k;return x|0}c[v>>2]=c[r>>2];while(1){if((c[v>>2]|0)>=(c[s>>2]|0)){w=11;break}r=(c[t>>2]|0)+(c[v>>2]<<4)|0;q=(c[t>>2]|0)+(c[(c[u>>2]|0)+(c[v>>2]<<2)>>2]<<4)|0;c[o>>2]=c[a>>2];c[o+4>>2]=c[a+4>>2];c[o+8>>2]=c[a+8>>2];c[o+12>>2]=c[a+12>>2];c[n>>2]=c[b>>2];c[n+4>>2]=c[b+4>>2];c[n+8>>2]=c[b+8>>2];c[n+12>>2]=c[b+12>>2];c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];c[l>>2]=c[q>>2];c[l+4>>2]=c[q+4>>2];c[l+8>>2]=c[q+8>>2];c[l+12>>2]=c[q+12>>2];if(lY(o,n,m,l)|0){w=9;break}c[v>>2]=(c[v>>2]|0)+1}if((w|0)==9){c[p>>2]=0;x=c[p>>2]|0;i=k;return x|0}else if((w|0)==11){c[p>>2]=1;x=c[p>>2]|0;i=k;return x|0}return 0}function vY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;i=i+32|0;e=d+16|0;f=d;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];g=+O(+(+mY(f,e)));i=d;return +g}function wY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+96|0;h=g+48|0;j=g+32|0;k=g+16|0;l=g;m=g+80|0;n=g+76|0;o=g+72|0;p=g+68|0;q=g+64|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;f=(c[o>>2]|0)+(c[(c[q>>2]|0)+(c[m>>2]<<2)>>2]<<4)|0;q=(c[o>>2]|0)+(c[m>>2]<<4)|0;e=(c[o>>2]|0)+(c[(c[p>>2]|0)+(c[m>>2]<<2)>>2]<<4)|0;m=(c[o>>2]|0)+(c[n>>2]<<4)|0;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[k>>2]=c[q>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];c[j>>2]=c[e>>2];c[j+4>>2]=c[e+4>>2];c[j+8>>2]=c[e+8>>2];c[j+12>>2]=c[e+12>>2];c[h>>2]=c[m>>2];c[h+4>>2]=c[m+4>>2];c[h+8>>2]=c[m+8>>2];c[h+12>>2]=c[m+12>>2];m=tY(l,k,j,h)|0;i=g;return m|0}function xY(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=yY(c[d>>2]|0,0,0)|0;i=b;return a|0}function yY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=JY(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0,0)|0;i=e;return d|0}function zY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;if(!(c[e>>2]|0)){i=d;return}c[f>>2]=c[(c[e>>2]|0)+364>>2];while(1){if(!(c[f>>2]|0)){k=c[e>>2]|0;if(!(c[(c[e>>2]|0)+368>>2]|0))break;c[f>>2]=c[k+368>>2];c[(c[e>>2]|0)+368>>2]=0}c[h>>2]=c[f>>2];c[f>>2]=c[c[f>>2]>>2];Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[(c[h>>2]|0)+36>>2]|0);OY(c[(c[h>>2]|0)+44>>2]|0,c[e>>2]|0);Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[h>>2]|0)}c[g>>2]=c[k+300>>2];while(1){if(!(c[g>>2]|0)){l=c[e>>2]|0;if(!(c[(c[e>>2]|0)+304>>2]|0))break;c[g>>2]=c[l+304>>2];c[(c[e>>2]|0)+304>>2]=0}c[j>>2]=c[g>>2];c[g>>2]=c[(c[g>>2]|0)+8>>2];Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[j>>2]|0)}OY(c[l+376>>2]|0,c[e>>2]|0);OY(c[(c[e>>2]|0)+372>>2]|0,c[e>>2]|0);PY((c[e>>2]|0)+416|0);PY((c[e>>2]|0)+440|0);if((a[(c[e>>2]|0)+488>>0]|0)==0?(c[(c[e>>2]|0)+356>>2]|0)!=0:0)QY(c[(c[e>>2]|0)+356>>2]|0,((c[(c[e>>2]|0)+476>>2]|0)!=0^1)&1,(c[e>>2]|0)+12|0);Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[(c[e>>2]|0)+392>>2]|0);Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[(c[e>>2]|0)+464>>2]|0);Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[(c[e>>2]|0)+8>>2]|0);Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[(c[e>>2]|0)+44>>2]|0);Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[(c[e>>2]|0)+396>>2]|0);Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[(c[e>>2]|0)+240>>2]|0);if(c[(c[e>>2]|0)+252>>2]|0)Bb[c[(c[e>>2]|0)+252>>2]&127](c[(c[e>>2]|0)+244>>2]|0);Bb[c[(c[e>>2]|0)+12+8>>2]&127](c[e>>2]|0);i=d;return}function AY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=(c[(c[e>>2]|0)+4>>2]|0)==(c[c[e>>2]>>2]|0);a=c[f>>2]|0;c[c[e>>2]>>2]=a;if(!b){i=d;return}c[(c[e>>2]|0)+4>>2]=a;i=d;return}function BY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[(c[f>>2]|0)+52>>2]=c[g>>2];c[(c[f>>2]|0)+56>>2]=c[h>>2];i=e;return}function CY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[(c[e>>2]|0)+60>>2]=c[f>>2];i=d;return}function DY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;switch(c[(c[j>>2]|0)+480>>2]|0){case 3:{c[(c[j>>2]|0)+284>>2]=33;c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}case 2:{c[(c[j>>2]|0)+284>>2]=36;c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}case 0:{if((c[(c[j>>2]|0)+476>>2]|0)==0?(RY(c[j>>2]|0)|0)<<24>>24==0:0){c[(c[j>>2]|0)+284>>2]=1;c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}break}default:{}}c[(c[j>>2]|0)+480>>2]=1;if(c[l>>2]|0){c[n>>2]=EY(c[j>>2]|0,c[l>>2]|0)|0;if(!(c[n>>2]|0)){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else{Z4(c[n>>2]|0,c[k>>2]|0,c[l>>2]|0)|0;c[h>>2]=FY(c[j>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}}a[(c[j>>2]|0)+480+4>>0]=c[m>>2];if(!(c[m>>2]|0)){c[h>>2]=1;o=c[h>>2]|0;i=g;return o|0}c[(c[j>>2]|0)+296>>2]=c[(c[j>>2]|0)+24>>2];c[(c[j>>2]|0)+40>>2]=c[(c[j>>2]|0)+28>>2];m=Sb[c[(c[j>>2]|0)+280>>2]&127](c[j>>2]|0,c[(c[j>>2]|0)+24>>2]|0,c[(c[j>>2]|0)+40>>2]|0,(c[j>>2]|0)+24|0)|0;c[(c[j>>2]|0)+284>>2]=m;m=c[j>>2]|0;if(c[(c[j>>2]|0)+284>>2]|0){c[(c[j>>2]|0)+292>>2]=c[m+288>>2];c[(c[j>>2]|0)+280>>2]=56;c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}switch(c[m+480>>2]|0){case 3:{Vb[c[(c[(c[j>>2]|0)+144>>2]|0)+52>>2]&31](c[(c[j>>2]|0)+144>>2]|0,c[(c[j>>2]|0)+296>>2]|0,c[(c[j>>2]|0)+24>>2]|0,(c[j>>2]|0)+408|0);c[(c[j>>2]|0)+296>>2]=c[(c[j>>2]|0)+24>>2];c[h>>2]=2;o=c[h>>2]|0;i=g;return o|0}case 1:case 0:{c[(c[j>>2]|0)+480>>2]=2;break}default:{}}c[h>>2]=1;o=c[h>>2]|0;i=g;return o|0}function EY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[f>>2]=a;c[g>>2]=b;switch(c[(c[f>>2]|0)+480>>2]|0){case 3:{c[(c[f>>2]|0)+284>>2]=33;c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}case 2:{c[(c[f>>2]|0)+284>>2]=36;c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}default:{if((c[g>>2]|0)>((c[(c[f>>2]|0)+32>>2]|0)-(c[(c[f>>2]|0)+28>>2]|0)|0)){c[h>>2]=(c[g>>2]|0)+((c[(c[f>>2]|0)+28>>2]|0)-(c[(c[f>>2]|0)+24>>2]|0));g=(c[(c[f>>2]|0)+24>>2]|0)-(c[(c[f>>2]|0)+8>>2]|0)|0;c[j>>2]=g;c[j>>2]=(c[j>>2]|0)>1024?1024:g;c[h>>2]=(c[h>>2]|0)+(c[j>>2]|0);do if((c[h>>2]|0)<=((c[(c[f>>2]|0)+32>>2]|0)-(c[(c[f>>2]|0)+8>>2]|0)|0)){if((c[j>>2]|0)<((c[(c[f>>2]|0)+24>>2]|0)-(c[(c[f>>2]|0)+8>>2]|0)|0)){c[k>>2]=(c[(c[f>>2]|0)+24>>2]|0)-(c[(c[f>>2]|0)+8>>2]|0)-(c[j>>2]|0);_4(c[(c[f>>2]|0)+8>>2]|0,(c[(c[f>>2]|0)+8>>2]|0)+(c[k>>2]|0)|0,(c[(c[f>>2]|0)+28>>2]|0)-(c[(c[f>>2]|0)+24>>2]|0)+(c[j>>2]|0)|0)|0;g=(c[f>>2]|0)+28|0;c[g>>2]=(c[g>>2]|0)+(0-(c[k>>2]|0));g=(c[f>>2]|0)+24|0;c[g>>2]=(c[g>>2]|0)+(0-(c[k>>2]|0))}}else{g=(c[(c[f>>2]|0)+32>>2]|0)-(c[(c[f>>2]|0)+24>>2]|0)|0;c[m>>2]=g;c[m>>2]=(c[m>>2]|0)==0?1024:g;do c[m>>2]=c[m>>2]<<1;while((c[m>>2]|0)<(c[h>>2]|0));c[l>>2]=Fb[c[(c[f>>2]|0)+12>>2]&63](c[m>>2]|0)|0;if(!(c[l>>2]|0)){c[(c[f>>2]|0)+284>>2]=1;c[e>>2]=0;o=c[e>>2]|0;i=d;return o|0}c[(c[f>>2]|0)+32>>2]=(c[l>>2]|0)+(c[m>>2]|0);if(c[(c[f>>2]|0)+24>>2]|0){g=(c[(c[f>>2]|0)+24>>2]|0)-(c[(c[f>>2]|0)+8>>2]|0)|0;c[n>>2]=g;c[n>>2]=(c[n>>2]|0)>1024?1024:g;Z4(c[l>>2]|0,(c[(c[f>>2]|0)+24>>2]|0)+(0-(c[n>>2]|0))|0,(c[(c[f>>2]|0)+28>>2]|0)-(c[(c[f>>2]|0)+24>>2]|0)+(c[n>>2]|0)|0)|0;Bb[c[(c[f>>2]|0)+12+8>>2]&127](c[(c[f>>2]|0)+8>>2]|0);c[(c[f>>2]|0)+8>>2]=c[l>>2];c[(c[f>>2]|0)+28>>2]=(c[(c[f>>2]|0)+8>>2]|0)+((c[(c[f>>2]|0)+28>>2]|0)-(c[(c[f>>2]|0)+24>>2]|0))+(c[n>>2]|0);c[(c[f>>2]|0)+24>>2]=(c[(c[f>>2]|0)+8>>2]|0)+(c[n>>2]|0);break}else{c[(c[f>>2]|0)+28>>2]=(c[l>>2]|0)+((c[(c[f>>2]|0)+28>>2]|0)-(c[(c[f>>2]|0)+24>>2]|0));g=c[l>>2]|0;c[(c[f>>2]|0)+8>>2]=g;c[(c[f>>2]|0)+24>>2]=g;break}}while(0);c[(c[f>>2]|0)+292>>2]=0;c[(c[f>>2]|0)+288>>2]=0;c[(c[f>>2]|0)+296>>2]=0}c[e>>2]=c[(c[f>>2]|0)+28>>2];o=c[e>>2]|0;i=d;return o|0}}return 0}function FY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=1;switch(c[(c[h>>2]|0)+480>>2]|0){case 3:{c[(c[h>>2]|0)+284>>2]=33;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}case 2:{c[(c[h>>2]|0)+284>>2]=36;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}case 0:{if((c[(c[h>>2]|0)+476>>2]|0)==0?(RY(c[h>>2]|0)|0)<<24>>24==0:0){c[(c[h>>2]|0)+284>>2]=1;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}break}default:{}}c[(c[h>>2]|0)+480>>2]=1;c[l>>2]=c[(c[h>>2]|0)+24>>2];c[(c[h>>2]|0)+296>>2]=c[l>>2];e=(c[h>>2]|0)+28|0;c[e>>2]=(c[e>>2]|0)+(c[j>>2]|0);c[(c[h>>2]|0)+40>>2]=c[(c[h>>2]|0)+28>>2];e=(c[h>>2]|0)+36|0;c[e>>2]=(c[e>>2]|0)+(c[j>>2]|0);a[(c[h>>2]|0)+480+4>>0]=c[k>>2];j=Sb[c[(c[h>>2]|0)+280>>2]&127](c[h>>2]|0,c[l>>2]|0,c[(c[h>>2]|0)+40>>2]|0,(c[h>>2]|0)+24|0)|0;c[(c[h>>2]|0)+284>>2]=j;j=c[h>>2]|0;if(c[(c[h>>2]|0)+284>>2]|0){c[(c[h>>2]|0)+292>>2]=c[j+288>>2];c[(c[h>>2]|0)+280>>2]=56;c[g>>2]=0;n=c[g>>2]|0;i=f;return n|0}switch(c[j+480>>2]|0){case 3:{c[m>>2]=2;break}case 1:case 0:{if(c[k>>2]|0){c[(c[h>>2]|0)+480>>2]=2;c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}break}default:{}}Vb[c[(c[(c[h>>2]|0)+144>>2]|0)+52>>2]&31](c[(c[h>>2]|0)+144>>2]|0,c[(c[h>>2]|0)+296>>2]|0,c[(c[h>>2]|0)+24>>2]|0,(c[h>>2]|0)+408|0);c[(c[h>>2]|0)+296>>2]=c[(c[h>>2]|0)+24>>2];c[g>>2]=c[m>>2];n=c[g>>2]|0;i=f;return n|0}function GY(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;i=b;return c[(c[d>>2]|0)+284>>2]|0}function HY(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[(c[d>>2]|0)+288>>2]|0)!=0?(c[(c[d>>2]|0)+288>>2]|0)>>>0>=(c[(c[d>>2]|0)+296>>2]|0)>>>0:0){Vb[c[(c[(c[d>>2]|0)+144>>2]|0)+52>>2]&31](c[(c[d>>2]|0)+144>>2]|0,c[(c[d>>2]|0)+296>>2]|0,c[(c[d>>2]|0)+288>>2]|0,(c[d>>2]|0)+408|0);c[(c[d>>2]|0)+296>>2]=c[(c[d>>2]|0)+288>>2]}i=b;return (c[(c[d>>2]|0)+408>>2]|0)+1|0}function IY(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;if((c[e>>2]|0)>>>0>0&(c[e>>2]|0)>>>0<41){c[d>>2]=c[92748+(c[e>>2]<<2)>>2];f=c[d>>2]|0;i=b;return f|0}else{c[d>>2]=0;f=c[d>>2]|0;i=b;return f|0}return 0}function JY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+28|0;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;o=g+4|0;p=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;if(c[k>>2]|0){c[n>>2]=Fb[c[c[k>>2]>>2]&63](500)|0;if(c[n>>2]|0){c[o>>2]=(c[n>>2]|0)+12;c[c[o>>2]>>2]=c[c[k>>2]>>2];c[(c[o>>2]|0)+4>>2]=c[(c[k>>2]|0)+4>>2];c[(c[o>>2]|0)+8>>2]=c[(c[k>>2]|0)+8>>2]}}else{c[n>>2]=N4(500)|0;if(c[n>>2]|0){c[p>>2]=(c[n>>2]|0)+12;c[c[p>>2]>>2]=35;c[(c[p>>2]|0)+4>>2]=107;c[(c[p>>2]|0)+8>>2]=96}}p=c[n>>2]|0;if(!(c[n>>2]|0)){c[h>>2]=p;q=c[h>>2]|0;i=g;return q|0}c[p+8>>2]=0;c[(c[n>>2]|0)+32>>2]=0;c[(c[n>>2]|0)+380>>2]=16;p=Fb[c[(c[n>>2]|0)+12>>2]&63](c[(c[n>>2]|0)+380>>2]<<4)|0;c[(c[n>>2]|0)+392>>2]=p;p=(c[n>>2]|0)+12|0;if(!(c[(c[n>>2]|0)+392>>2]|0)){Bb[c[p+8>>2]&127](c[n>>2]|0);c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}k=Fb[c[p>>2]&63](1024)|0;c[(c[n>>2]|0)+44>>2]=k;k=c[n>>2]|0;if(!(c[(c[n>>2]|0)+44>>2]|0)){Bb[c[k+12+8>>2]&127](c[(c[n>>2]|0)+392>>2]|0);Bb[c[(c[n>>2]|0)+12+8>>2]&127](c[n>>2]|0);c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}c[(c[n>>2]|0)+48>>2]=(c[k+44>>2]|0)+1024;if(!(c[m>>2]|0)){k=LZ((c[n>>2]|0)+12|0)|0;c[(c[n>>2]|0)+356>>2]=k;if(!(c[(c[n>>2]|0)+356>>2]|0)){Bb[c[(c[n>>2]|0)+12+8>>2]&127](c[(c[n>>2]|0)+44>>2]|0);Bb[c[(c[n>>2]|0)+12+8>>2]&127](c[(c[n>>2]|0)+392>>2]|0);Bb[c[(c[n>>2]|0)+12+8>>2]&127](c[n>>2]|0);c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}}else c[(c[n>>2]|0)+356>>2]=c[m>>2];c[(c[n>>2]|0)+376>>2]=0;c[(c[n>>2]|0)+368>>2]=0;c[(c[n>>2]|0)+304>>2]=0;c[(c[n>>2]|0)+468>>2]=0;c[(c[n>>2]|0)+464>>2]=0;c[(c[n>>2]|0)+124>>2]=0;c[(c[n>>2]|0)+248>>2]=0;a[(c[n>>2]|0)+472>>0]=33;a[(c[n>>2]|0)+236>>0]=0;a[(c[n>>2]|0)+237>>0]=0;c[(c[n>>2]|0)+396>>2]=0;c[(c[n>>2]|0)+400>>2]=0;a[(c[n>>2]|0)+404>>0]=0;MZ((c[n>>2]|0)+416|0,(c[n>>2]|0)+12|0);MZ((c[n>>2]|0)+440|0,(c[n>>2]|0)+12|0);LY(c[n>>2]|0,c[j>>2]|0);if((c[j>>2]|0)!=0?(c[(c[n>>2]|0)+232>>2]|0)==0:0){zY(c[n>>2]|0);c[h>>2]=0;q=c[h>>2]|0;i=g;return q|0}if(c[l>>2]|0){a[(c[n>>2]|0)+236>>0]=1;j=UZ()|0;c[(c[n>>2]|0)+228>>2]=j;a[(c[n>>2]|0)+472>>0]=a[c[l>>2]>>0]|0}else{l=RZ()|0;c[(c[n>>2]|0)+228>>2]=l}c[h>>2]=c[n>>2];q=c[h>>2]|0;i=g;return q|0}function KY(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;a=c[c[d>>2]>>2]|0;a:do if(c[(c[d>>2]|0)+4>>2]|0){c[e>>2]=a;while(1){if(!(c[e>>2]|0))break a;c[f>>2]=c[c[e>>2]>>2];c[c[e>>2]>>2]=c[(c[d>>2]|0)+4>>2];c[(c[d>>2]|0)+4>>2]=c[e>>2];c[e>>2]=c[f>>2]}}else c[(c[d>>2]|0)+4>>2]=a;while(0);c[c[d>>2]>>2]=0;c[(c[d>>2]|0)+16>>2]=0;c[(c[d>>2]|0)+12>>2]=0;c[(c[d>>2]|0)+8>>2]=0;i=b;return}function LY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;c[(c[f>>2]|0)+280>>2]=57;n0((c[f>>2]|0)+256|0);if(c[g>>2]|0)h=MY((c[f>>2]|0)+416|0,c[g>>2]|0)|0;else h=0;c[(c[f>>2]|0)+232>>2]=h;c[(c[f>>2]|0)+360>>2]=0;SZ((c[f>>2]|0)+148|0,(c[f>>2]|0)+144|0,0)|0;c[c[f>>2]>>2]=0;c[(c[f>>2]|0)+4>>2]=0;c[(c[f>>2]|0)+52>>2]=0;c[(c[f>>2]|0)+56>>2]=0;c[(c[f>>2]|0)+60>>2]=0;c[(c[f>>2]|0)+64>>2]=0;c[(c[f>>2]|0)+68>>2]=0;c[(c[f>>2]|0)+72>>2]=0;c[(c[f>>2]|0)+76>>2]=0;c[(c[f>>2]|0)+80>>2]=0;c[(c[f>>2]|0)+84>>2]=0;c[(c[f>>2]|0)+88>>2]=0;c[(c[f>>2]|0)+92>>2]=0;c[(c[f>>2]|0)+96>>2]=0;c[(c[f>>2]|0)+100>>2]=0;c[(c[f>>2]|0)+104>>2]=0;c[(c[f>>2]|0)+108>>2]=0;c[(c[f>>2]|0)+112>>2]=0;c[(c[f>>2]|0)+116>>2]=c[f>>2];c[(c[f>>2]|0)+120>>2]=0;c[(c[f>>2]|0)+128>>2]=0;c[(c[f>>2]|0)+132>>2]=0;c[(c[f>>2]|0)+136>>2]=0;c[(c[f>>2]|0)+140>>2]=0;c[(c[f>>2]|0)+24>>2]=c[(c[f>>2]|0)+8>>2];c[(c[f>>2]|0)+28>>2]=c[(c[f>>2]|0)+8>>2];c[(c[f>>2]|0)+36>>2]=0;c[(c[f>>2]|0)+40>>2]=0;c[(c[f>>2]|0)+344>>2]=0;c[(c[f>>2]|0)+348>>2]=0;c[(c[f>>2]|0)+316>>2]=0;c[(c[f>>2]|0)+320>>2]=0;c[(c[f>>2]|0)+324>>2]=0;c[(c[f>>2]|0)+328>>2]=0;c[(c[f>>2]|0)+332>>2]=0;c[(c[f>>2]|0)+336>>2]=0;c[(c[f>>2]|0)+340>>2]=0;a[(c[f>>2]|0)+352>>0]=0;a[(c[f>>2]|0)+353>>0]=0;h=(c[f>>2]|0)+408|0;c[h>>2]=0;c[h+4>>2]=0;c[(c[f>>2]|0)+284>>2]=0;c[(c[f>>2]|0)+288>>2]=0;c[(c[f>>2]|0)+292>>2]=0;c[(c[f>>2]|0)+296>>2]=0;c[(c[f>>2]|0)+300>>2]=0;a[(c[f>>2]|0)+308>>0]=1;c[(c[f>>2]|0)+312>>2]=0;c[(c[f>>2]|0)+364>>2]=0;c[(c[f>>2]|0)+372>>2]=0;c[(c[f>>2]|0)+384>>2]=0;c[(c[f>>2]|0)+240>>2]=0;c[(c[f>>2]|0)+252>>2]=0;c[(c[f>>2]|0)+244>>2]=0;c[(c[f>>2]|0)+476>>2]=0;c[(c[f>>2]|0)+480>>2]=0;a[(c[f>>2]|0)+488>>0]=0;a[(c[f>>2]|0)+489>>0]=0;c[(c[f>>2]|0)+492>>2]=0;c[(c[f>>2]|0)+496>>2]=0;i=e;return}function MY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[g>>2]=b;c[h>>2]=d;while(1){if((c[(c[g>>2]|0)+12>>2]|0)==(c[(c[g>>2]|0)+8>>2]|0)?(jZ(c[g>>2]|0)|0)<<24>>24==0:0){j=5;break}d=a[c[h>>2]>>0]|0;b=(c[g>>2]|0)+12|0;k=c[b>>2]|0;c[b>>2]=k+1;a[k>>0]=d;d=c[h>>2]|0;c[h>>2]=d+1;if(!(a[d>>0]|0)){j=6;break}}if((j|0)==5){c[f>>2]=0;l=c[f>>2]|0;i=e;return l|0}else if((j|0)==6){c[h>>2]=c[(c[g>>2]|0)+16>>2];c[(c[g>>2]|0)+16>>2]=c[(c[g>>2]|0)+12>>2];c[f>>2]=c[h>>2];l=c[f>>2]|0;i=e;return l|0}return 0}function NY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;h=e+16|0;j=e+12|0;k=e+8|0;l=e+4|0;m=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[(c[g>>2]|0)+356>>2];c[k>>2]=c[h>>2];a:while(1){if(!(a[c[h>>2]>>0]|0)){n=45;break}if((a[c[k>>2]>>0]|0)!=12?(a[c[k>>2]>>0]|0)!=0:0){d=c[(c[g>>2]|0)+416+12>>2]|0;b=(c[g>>2]|0)+416|0;if((a[c[k>>2]>>0]|0)!=61){if((d|0)==(c[b+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){n=44;break}o=a[c[k>>2]>>0]|0;p=(c[g>>2]|0)+416+12|0;q=c[p>>2]|0;c[p>>2]=q+1;a[q>>0]=o;c[k>>2]=(c[k>>2]|0)+1;continue}if(!(d-(c[b+16>>2]|0)|0))c[m>>2]=(c[j>>2]|0)+152;else{if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){n=19;break}b=(c[g>>2]|0)+416+12|0;d=c[b>>2]|0;c[b>>2]=d+1;a[d>>0]=0;c[m>>2]=bZ(c[g>>2]|0,(c[j>>2]|0)+60|0,c[(c[g>>2]|0)+416+16>>2]|0,8)|0;if(!(c[m>>2]|0)){n=20;break}if((c[c[m>>2]>>2]|0)==(c[(c[g>>2]|0)+416+16>>2]|0)?(d=MY((c[j>>2]|0)+80|0,c[c[m>>2]>>2]|0)|0,c[c[m>>2]>>2]=d,(c[c[m>>2]>>2]|0)==0):0){n=23;break}c[(c[g>>2]|0)+416+12>>2]=c[(c[g>>2]|0)+416+16>>2]}c[h>>2]=(c[k>>2]|0)+1;while(1){if((a[c[h>>2]>>0]|0)!=12)r=(a[c[h>>2]>>0]|0)!=0;else r=0;s=(c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0);if(!r)break;if(s?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){n=32;break a}d=a[c[h>>2]>>0]|0;b=(c[g>>2]|0)+416+12|0;o=c[b>>2]|0;c[b>>2]=o+1;a[o>>0]=d;c[h>>2]=(c[h>>2]|0)+1}if(s?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){n=36;break}d=(c[g>>2]|0)+416+12|0;o=c[d>>2]|0;c[d>>2]=o+1;a[o>>0]=0;if(FZ(c[g>>2]|0,c[m>>2]|0,0,c[(c[g>>2]|0)+416+16>>2]|0,(c[g>>2]|0)+372|0)|0){n=37;break}c[(c[g>>2]|0)+416+12>>2]=c[(c[g>>2]|0)+416+16>>2];if(a[c[h>>2]>>0]|0)c[h>>2]=(c[h>>2]|0)+1;c[k>>2]=c[h>>2];continue}if((c[(c[g>>2]|0)+416+12>>2]|0)==(c[(c[g>>2]|0)+416+8>>2]|0)?(jZ((c[g>>2]|0)+416|0)|0)<<24>>24==0:0){n=8;break}o=(c[g>>2]|0)+416+12|0;d=c[o>>2]|0;c[o>>2]=d+1;a[d>>0]=0;c[l>>2]=bZ(c[g>>2]|0,c[j>>2]|0,c[(c[g>>2]|0)+416+16>>2]|0,0)|0;if(c[l>>2]|0)a[(c[l>>2]|0)+32>>0]=1;if(a[c[k>>2]>>0]|0)c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=c[k>>2];c[(c[g>>2]|0)+416+12>>2]=c[(c[g>>2]|0)+416+16>>2]}if((n|0)==8){a[f>>0]=0;t=a[f>>0]|0;i=e;return t|0}else if((n|0)==19){a[f>>0]=0;t=a[f>>0]|0;i=e;return t|0}else if((n|0)==20){a[f>>0]=0;t=a[f>>0]|0;i=e;return t|0}else if((n|0)==23){a[f>>0]=0;t=a[f>>0]|0;i=e;return t|0}else if((n|0)==32){a[f>>0]=0;t=a[f>>0]|0;i=e;return t|0}else if((n|0)==36){a[f>>0]=0;t=a[f>>0]|0;i=e;return t|0}else if((n|0)==37){a[f>>0]=0;t=a[f>>0]|0;i=e;return t|0}else if((n|0)==44){a[f>>0]=0;t=a[f>>0]|0;i=e;return t|0}else if((n|0)==45){a[f>>0]=1;t=a[f>>0]|0;i=e;return t|0}return 0}function OY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;while(1){c[g>>2]=c[e>>2];if(!(c[g>>2]|0))break;c[e>>2]=c[(c[g>>2]|0)+4>>2];Bb[c[(c[f>>2]|0)+12+8>>2]&127](c[(c[g>>2]|0)+16>>2]|0);Bb[c[(c[f>>2]|0)+12+8>>2]&127](c[g>>2]|0)}i=d;return}function PY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=c[c[d>>2]>>2];while(1){if(!(c[e>>2]|0))break;c[f>>2]=c[c[e>>2]>>2];Bb[c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]&127](c[e>>2]|0);c[e>>2]=c[f>>2]}c[e>>2]=c[(c[d>>2]|0)+4>>2];while(1){if(!(c[e>>2]|0))break;c[g>>2]=c[c[e>>2]>>2];Bb[c[(c[(c[d>>2]|0)+20>>2]|0)+8>>2]&127](c[e>>2]|0);c[e>>2]=c[g>>2]}i=b;return}function QY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+32|0;g=f+20|0;h=f+24|0;j=f+16|0;k=f+8|0;l=f;c[g>>2]=b;a[h>>0]=d;c[j>>2]=e;VY(k,(c[g>>2]|0)+20|0);while(1){c[l>>2]=WY(k)|0;if(!(c[l>>2]|0))break;if(!(c[(c[l>>2]|0)+16>>2]|0))continue;Bb[c[(c[j>>2]|0)+8>>2]&127](c[(c[l>>2]|0)+20>>2]|0)}XY(c[g>>2]|0);XY((c[g>>2]|0)+132|0);XY((c[g>>2]|0)+20|0);XY((c[g>>2]|0)+40|0);XY((c[g>>2]|0)+60|0);PY((c[g>>2]|0)+80|0);PY((c[g>>2]|0)+104|0);if(!(a[h>>0]|0)){m=c[j>>2]|0;n=m+8|0;o=c[n>>2]|0;p=c[g>>2]|0;Bb[o&127](p);i=f;return}Bb[c[(c[j>>2]|0)+8>>2]&127](c[(c[g>>2]|0)+184>>2]|0);Bb[c[(c[j>>2]|0)+8>>2]&127](c[(c[g>>2]|0)+164>>2]|0);m=c[j>>2]|0;n=m+8|0;o=c[n>>2]|0;p=c[g>>2]|0;Bb[o&127](p);i=f;return}function RY(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;if(!(c[(c[f>>2]|0)+496>>2]|0)){b=UY()|0;c[(c[f>>2]|0)+496>>2]=b}if(a[(c[f>>2]|0)+236>>0]|0){a[e>>0]=NY(c[f>>2]|0,181401)|0;g=a[e>>0]|0;i=d;return g|0}else{a[e>>0]=1;g=a[e>>0]|0;i=d;return g|0}return 0}function SY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f+12|0;c[g>>2]=a;c[f+8>>2]=b;c[f+4>>2]=d;c[f>>2]=e;i=f;return c[(c[g>>2]|0)+284>>2]|0}function TY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;if(a[(c[j>>2]|0)+72>>0]|0){Tb[c[(c[h>>2]|0)+80>>2]&127](c[(c[h>>2]|0)+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);i=g;return}f=c[h>>2]|0;if((c[j>>2]|0)==(c[(c[h>>2]|0)+144>>2]|0)){c[m>>2]=f+288;c[n>>2]=(c[h>>2]|0)+292}else{c[m>>2]=c[f+300>>2];c[n>>2]=(c[(c[h>>2]|0)+300>>2]|0)+4}do{c[o>>2]=c[(c[h>>2]|0)+44>>2];Ab[c[(c[j>>2]|0)+60>>2]&31](c[j>>2]|0,k,c[l>>2]|0,o,c[(c[h>>2]|0)+48>>2]|0);c[c[n>>2]>>2]=c[k>>2];Tb[c[(c[h>>2]|0)+80>>2]&127](c[(c[h>>2]|0)+4>>2]|0,c[(c[h>>2]|0)+44>>2]|0,(c[o>>2]|0)-(c[(c[h>>2]|0)+44>>2]|0)|0);c[c[m>>2]>>2]=c[k>>2]}while((c[k>>2]|0)!=(c[l>>2]|0));i=g;return}function UY(){var a=0,b=0;a=i;i=i+16|0;b=a;c[b>>2]=((sb(0)|0)>>>0)%4294967295|0;s2(c[b>>2]|0);b=t2()|0;i=a;return b|0}function VY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[c[e>>2]>>2]=c[c[f>>2]>>2];c[(c[e>>2]|0)+4>>2]=(c[c[e>>2]>>2]|0)+(c[(c[f>>2]|0)+8>>2]<<2);i=d;return}function WY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;while(1){if((c[c[e>>2]>>2]|0)==(c[(c[e>>2]|0)+4>>2]|0)){g=5;break}a=c[e>>2]|0;h=c[a>>2]|0;c[a>>2]=h+4;c[f>>2]=c[h>>2];if(c[f>>2]|0){g=4;break}}if((g|0)==4){c[d>>2]=c[f>>2];j=c[d>>2]|0;i=b;return j|0}else if((g|0)==5){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}return 0}function XY(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;while(1){f=c[(c[(c[d>>2]|0)+16>>2]|0)+8>>2]|0;if((c[e>>2]|0)>>>0>=(c[(c[d>>2]|0)+8>>2]|0)>>>0)break;Bb[f&127](c[(c[c[d>>2]>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}Bb[f&127](c[c[d>>2]>>2]|0);i=b;return}function YY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;c[g>>2]=c[(c[f>>2]|0)+232>>2];if(Hb[((a[(c[f>>2]|0)+236>>0]&255|0)!=0?41:42)&63]((c[f>>2]|0)+148|0,(c[f>>2]|0)+144|0,c[g>>2]|0)|0){c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=JZ(c[f>>2]|0,c[(c[f>>2]|0)+232>>2]|0)|0;h=c[e>>2]|0;i=d;return h|0}return 0}function ZY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=c[j>>2];c[n>>2]=Sb[c[c[(c[h>>2]|0)+144>>2]>>2]&127](c[(c[h>>2]|0)+144>>2]|0,c[j>>2]|0,c[k>>2]|0,m)|0;f=_Y(c[h>>2]|0,c[(c[h>>2]|0)+144>>2]|0,c[j>>2]|0,c[k>>2]|0,c[n>>2]|0,c[m>>2]|0,c[l>>2]|0,((a[(c[h>>2]|0)+480+4>>0]|0)!=0^1)&1)|0;i=g;return f|0}
function qh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[e+16>>2]=a;c[f>>2]=b;c[g>>2]=d;vk(c[f>>2]|0);Gh(c[f>>2]|0);Hh(c[f>>2]|0);Ih(c[f>>2]|0);c[j>>2]=oh(c[f>>2]|0,2,2,c[g>>2]|0)|0;c[h>>2]=1;while(1){k=c[f>>2]|0;if((c[h>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;d=qh(k,c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[h>>2]<<2)>>2]|0,c[g>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+d;c[h>>2]=(c[h>>2]|0)+1}ch(k);i=e;return c[j>>2]|0}function rh(d,e){d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;f=i;i=i+48|0;g=f;j=f+44|0;k=f+40|0;l=f+36|0;m=f+32|0;n=f+28|0;o=f+24|0;p=f+20|0;q=f+16|0;c[j>>2]=d;c[k>>2]=e;if(c[12559]|0){O4(c[12559]|0);c[12559]=0}if(c[12560]|0){O4(c[12560]|0);c[12560]=0}c[o>>2]=1;while(1){if((c[o>>2]|0)>(c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]|0))break;eh(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2]|0);c[o>>2]=(c[o>>2]|0)+1}c[n>>2]=b[(c[(c[j>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[n>>2]|0)>(b[(c[(c[j>>2]|0)+8>>2]|0)+238>>1]|0))break;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)>>2]|0))break;c[p>>2]=c[(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+4>>2]|0)+(c[l>>2]<<2)>>2];c[(c[(c[p>>2]|0)+8>>2]|0)+236>>2]=c[l>>2];a:do if(c[(c[(c[p>>2]|0)+8>>2]|0)+188>>2]|0){c[m>>2]=0;while(1){o=c[(c[(c[(c[p>>2]|0)+8>>2]|0)+188>>2]|0)+(c[m>>2]<<2)>>2]|0;c[q>>2]=o;if(!o)break a;if((a[(c[(c[q>>2]|0)+8>>2]|0)+112>>0]|0)==4){Ug(c[q>>2]|0);O4(c[(c[q>>2]|0)+8>>2]|0);O4(c[q>>2]|0);c[m>>2]=(c[m>>2]|0)+-1}c[m>>2]=(c[m>>2]|0)+1}}while(0);c[l>>2]=(c[l>>2]|0)+1}Fh(c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+56>>2]|0);c[n>>2]=(c[n>>2]|0)+1}if(!(a[138998]|0)){i=f;return}n=c[24742]|0;l=wB(c[j>>2]|0)|0;j=c[k>>2]|0;r=+$N();c[g>>2]=l;c[g+4>>2]=j;h[g+8>>3]=r;Y2(n,123311,g)|0;i=f;return}function sh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=c[g>>2]|0;c[j>>2]=d;c[k>>2]=d;while(1){d=Ch(c[j>>2]|0,c[h>>2]|0)|0;c[j>>2]=d;if(!d)break;if(Dh(c[f>>2]|0,c[j>>2]|0)|0){c[k>>2]=c[j>>2];continue}if(!(Eh(c[f>>2]|0,c[j>>2]|0)|0))continue;c[k>>2]=c[j>>2]}i=e;return c[k>>2]|0}function th(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+232>>2];c[g>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+236>>2];c[h>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2];c[(c[(c[e>>2]|0)+8>>2]|0)+236>>2]=c[h>>2];c[(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2]=c[e>>2];c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2]=c[g>>2];c[(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2]=c[f>>2];i=d;return}function uh(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+8|0;j=f+4|0;k=f;c[g>>2]=d;c[h>>2]=e;c[j>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0))break;a[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+48>>0]=1;c[j>>2]=(c[j>>2]|0)+1}do{c[k>>2]=0;c[j>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0))break;if(a[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+48>>0]|0){e=yh(c[g>>2]|0,c[j>>2]|0,c[h>>2]|0)|0;c[k>>2]=(c[k>>2]|0)+e}c[j>>2]=(c[j>>2]|0)+1}}while((c[k>>2]|0)>=1);i=f;return}function vh(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+64|0;g=f+48|0;h=f+44|0;j=f+40|0;k=f+36|0;l=f+32|0;m=f+28|0;n=f+24|0;o=f+20|0;p=f+16|0;q=f+12|0;r=f+8|0;s=f+4|0;t=f;c[h>>2]=d;c[j>>2]=e;c[m>>2]=0;c[n>>2]=0;c[q>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2];if((c[12557]|0)<=(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)+1<<6)>>2]|0)){c[12557]=(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)+1<<6)>>2]|0)+1;if(c[12558]|0)u=eK(c[12558]|0,c[12557]<<2)|0;else u=cK(c[12557]<<2)|0;c[12558]=u}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)+1<<6)>>2]|0))break;c[(c[12558]|0)+(c[o>>2]<<2)>>2]=0;c[o>>2]=(c[o>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;a:do if((c[n>>2]|0)>0){c[o>>2]=0;while(1){u=c[(c[(c[(c[(c[q>>2]|0)+(c[k>>2]<<2)>>2]|0)+8>>2]|0)+180>>2]|0)+(c[o>>2]<<2)>>2]|0;c[s>>2]=u;if(!u)break a;u=c[s>>2]|0;c[p>>2]=(c[(c[(c[((c[c[s>>2]>>2]&3|0)==2?u:u+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)+1;while(1){if((c[p>>2]|0)>(c[n>>2]|0))break;u=_(c[(c[12558]|0)+(c[p>>2]<<2)>>2]|0,b[(c[(c[s>>2]|0)+8>>2]|0)+154>>1]|0)|0;c[m>>2]=(c[m>>2]|0)+u;c[p>>2]=(c[p>>2]|0)+1}c[o>>2]=(c[o>>2]|0)+1}}while(0);c[o>>2]=0;while(1){u=c[(c[(c[(c[(c[q>>2]|0)+(c[k>>2]<<2)>>2]|0)+8>>2]|0)+180>>2]|0)+(c[o>>2]<<2)>>2]|0;c[s>>2]=u;if(!u)break;u=c[s>>2]|0;c[t>>2]=c[(c[(c[((c[c[s>>2]>>2]&3|0)==2?u:u+-32|0)+28>>2]|0)+8>>2]|0)+236>>2];if((c[t>>2]|0)>(c[n>>2]|0))c[n>>2]=c[t>>2];u=(c[12558]|0)+(c[t>>2]<<2)|0;c[u>>2]=(c[u>>2]|0)+(b[(c[(c[s>>2]|0)+8>>2]|0)+154>>1]|0);c[o>>2]=(c[o>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;c[r>>2]=c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[k>>2]<<2)>>2];if(a[(c[(c[r>>2]|0)+8>>2]|0)+145>>0]|0){o=(c[(c[r>>2]|0)+8>>2]|0)+180|0;c[g>>2]=c[o>>2];c[g+4>>2]=c[o+4>>2];o=xh(g,1)|0;c[m>>2]=(c[m>>2]|0)+o}c[k>>2]=(c[k>>2]|0)+1}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)+1<<6)>>2]|0))break;c[r>>2]=c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)+1<<6)+4>>2]|0)+(c[l>>2]<<2)>>2];if(a[(c[(c[r>>2]|0)+8>>2]|0)+145>>0]|0){k=(c[(c[r>>2]|0)+8>>2]|0)+172|0;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];k=xh(g,-1)|0;c[m>>2]=(c[m>>2]|0)+k}c[l>>2]=(c[l>>2]|0)+1}i=f;return c[m>>2]|0}function wh(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[f>>2]=b;do if((a[(c[(c[f>>2]|0)+8>>2]|0)+156>>0]|0)!=1)if((a[(c[(c[f>>2]|0)+8>>2]|0)+160>>0]|0)<=1){c[e>>2]=1;break}else{c[e>>2]=0;break}else c[e>>2]=2;while(0);i=d;return c[e>>2]|0}function xh(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=d;c[l>>2]=0;if((c[f>>2]|0)>0)c[k>>2]=1;else c[k>>2]=0;c[g>>2]=0;while(1){f=c[(c[a>>2]|0)+(c[g>>2]<<2)>>2]|0;c[m>>2]=f;if(!f)break;f=(c[k>>2]|0)!=0;c[j>>2]=(c[g>>2]|0)+1;a:do if(f)while(1){d=c[(c[a>>2]|0)+(c[j>>2]<<2)>>2]|0;c[n>>2]=d;if(!d)break a;d=c[n>>2]|0;o=c[m>>2]|0;if(+((c[(c[(c[((c[c[n>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?o:o+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)|0)*(+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[m>>2]|0)+8>>2]|0)+16>>3])<0.0){o=_(b[(c[(c[m>>2]|0)+8>>2]|0)+154>>1]|0,b[(c[(c[n>>2]|0)+8>>2]|0)+154>>1]|0)|0;c[l>>2]=(c[l>>2]|0)+o}c[j>>2]=(c[j>>2]|0)+1}else while(1){o=c[(c[a>>2]|0)+(c[j>>2]<<2)>>2]|0;c[n>>2]=o;if(!o)break a;o=c[n>>2]|0;d=c[m>>2]|0;if(+((c[(c[(c[((c[c[n>>2]>>2]&3|0)==3?o:o+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)|0)*(+h[(c[(c[n>>2]|0)+8>>2]|0)+56>>3]-+h[(c[(c[m>>2]|0)+8>>2]|0)+56>>3])<0.0){d=_(b[(c[(c[m>>2]|0)+8>>2]|0)+154>>1]|0,b[(c[(c[n>>2]|0)+8>>2]|0)+154>>1]|0)|0;c[l>>2]=(c[l>>2]|0)+d}c[j>>2]=(c[j>>2]|0)+1}while(0);c[g>>2]=(c[g>>2]|0)+1}i=e;return c[l>>2]|0}function yh(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+48|0;h=g+32|0;j=g+28|0;k=g+24|0;l=g+20|0;m=g+16|0;n=g+12|0;o=g+8|0;p=g+4|0;q=g;c[h>>2]=d;c[j>>2]=e;c[k>>2]=f;c[o>>2]=0;a[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+48>>0]=0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=((c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0)-1|0)){r=18;break}c[p>>2]=c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[l>>2]<<2)>>2];c[q>>2]=c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+((c[l>>2]|0)+1<<2)>>2];if((c[(c[(c[p>>2]|0)+8>>2]|0)+236>>2]|0)>=(c[(c[(c[q>>2]|0)+8>>2]|0)+236>>2]|0)){r=4;break}do if(!(zh(c[h>>2]|0,c[p>>2]|0,c[q>>2]|0)|0)){c[n>>2]=0;c[m>>2]=0;if((c[j>>2]|0)>0){f=Ah(c[p>>2]|0,c[q>>2]|0)|0;c[m>>2]=(c[m>>2]|0)+f;f=Ah(c[q>>2]|0,c[p>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+f}if((c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)+1<<6)>>2]|0)>0){f=Bh(c[p>>2]|0,c[q>>2]|0)|0;c[m>>2]=(c[m>>2]|0)+f;f=Bh(c[q>>2]|0,c[p>>2]|0)|0;c[n>>2]=(c[n>>2]|0)+f}if((c[n>>2]|0)>=(c[m>>2]|0)){if(!((c[m>>2]|0)>0&(c[k>>2]|0)!=0))break;if((c[n>>2]|0)!=(c[m>>2]|0))break}th(c[p>>2]|0,c[q>>2]|0);c[o>>2]=(c[o>>2]|0)+((c[m>>2]|0)-(c[n>>2]|0));a[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+49>>0]=0;a[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+48>>0]=1;if((c[j>>2]|0)>(b[(c[(c[h>>2]|0)+8>>2]|0)+236>>1]|0)){a[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)-1<<6)+49>>0]=0;a[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)-1<<6)+48>>0]=1}if((c[j>>2]|0)<(b[(c[(c[h>>2]|0)+8>>2]|0)+238>>1]|0)){a[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)+1<<6)+49>>0]=0;a[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+((c[j>>2]|0)+1<<6)+48>>0]=1}}while(0);c[l>>2]=(c[l>>2]|0)+1}if((r|0)==4)La(123211,122928,514,123237);else if((r|0)==18){i=g;return c[o>>2]|0}return 0}function zh(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;f=(c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]|0)!=(c[(c[(c[l>>2]|0)+8>>2]|0)+212>>2]|0);if(!(d[122836]|0)){if((f?(c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]|0)!=0:0)?(c[(c[(c[l>>2]|0)+8>>2]|0)+212>>2]|0)!=0:0){if((a[(c[(c[k>>2]|0)+8>>2]|0)+159>>0]|0)==7?(a[(c[(c[k>>2]|0)+8>>2]|0)+156>>0]|0)==1:0){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}if((a[(c[(c[l>>2]|0)+8>>2]|0)+159>>0]|0)==7?(a[(c[(c[l>>2]|0)+8>>2]|0)+156>>0]|0)==1:0){c[h>>2]=0;p=c[h>>2]|0;i=g;return p|0}c[h>>2]=1;p=c[h>>2]|0;i=g;return p|0}}else if(f){c[h>>2]=1;p=c[h>>2]|0;i=g;return p|0}c[m>>2]=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]<<6)+56>>2];if(!(c[m>>2]|0))c[n>>2]=0;else{if(c[(c[(c[j>>2]|0)+8>>2]|0)+116>>2]&1){c[o>>2]=c[k>>2];c[k>>2]=c[l>>2];c[l>>2]=c[o>>2]}o=_(c[(c[(c[k>>2]|0)+8>>2]|0)+284>>2]|0,c[(c[m>>2]|0)+4>>2]|0)|0;c[n>>2]=a[(c[(c[m>>2]|0)+8>>2]|0)+(o+(c[(c[(c[l>>2]|0)+8>>2]|0)+284>>2]|0))>>0]}c[h>>2]=c[n>>2];p=c[h>>2]|0;i=g;return p|0}function Ah(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[f>>2]=a;c[g>>2]=d;c[m>>2]=0;c[k>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2];while(1){if(!(c[c[k>>2]>>2]|0))break;c[o>>2]=b[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+154>>1];g=c[c[k>>2]>>2]|0;c[l>>2]=c[(c[(c[((c[c[c[k>>2]>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)+8>>2]|0)+236>>2];c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+172>>2];while(1){if(!(c[c[j>>2]>>2]|0))break;g=c[c[j>>2]>>2]|0;c[n>>2]=(c[(c[(c[((c[c[c[j>>2]>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)-(c[l>>2]|0);if((c[n>>2]|0)<=0){if((c[n>>2]|0)==0?+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3]>+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3]:0)p=8}else p=8;if((p|0)==8){p=0;g=_(b[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+154>>1]|0,c[o>>2]|0)|0;c[m>>2]=(c[m>>2]|0)+g}c[j>>2]=(c[j>>2]|0)+4}c[k>>2]=(c[k>>2]|0)+4}i=e;return c[m>>2]|0}function Bh(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[f>>2]=a;c[g>>2]=d;c[m>>2]=0;c[k>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2];while(1){if(!(c[c[k>>2]>>2]|0))break;c[o>>2]=b[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+154>>1];g=c[c[k>>2]>>2]|0;c[l>>2]=c[(c[(c[((c[c[c[k>>2]>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+236>>2];c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2];while(1){if(!(c[c[j>>2]>>2]|0))break;g=c[c[j>>2]>>2]|0;c[n>>2]=(c[(c[(c[((c[c[c[j>>2]>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)-(c[l>>2]|0);if((c[n>>2]|0)<=0){if((c[n>>2]|0)==0?+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+56>>3]>+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+56>>3]:0)p=8}else p=8;if((p|0)==8){p=0;g=_(b[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+154>>1]|0,c[o>>2]|0)|0;c[m>>2]=(c[m>>2]|0)+g}c[j>>2]=(c[j>>2]|0)+4}c[k>>2]=(c[k>>2]|0)+4}i=e;return c[m>>2]|0}function Ch(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=0;if(!(c[e>>2]|0))La(123252,122928,754,123254);b=c[(c[(c[e>>2]|0)+8>>2]|0)+236>>2]|0;if((c[f>>2]|0)<0){if((b|0)>0)c[g>>2]=c[(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[e>>2]|0)+8>>2]|0)+232>>2]<<6)+4>>2]|0)+((c[(c[(c[e>>2]|0)+8>>2]|0)+236>>2]|0)-1<<2)>>2]}else c[g>>2]=c[(c[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[e>>2]|0)+8>>2]|0)+232>>2]<<6)+4>>2]|0)+(b+1<<2)>>2];if(!(c[g>>2]|0)){h=c[g>>2]|0;i=d;return h|0}if((_((c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[e>>2]|0)+8>>2]|0)+236>>2]|0)|0,c[f>>2]|0)|0)>0){h=c[g>>2]|0;i=d;return h|0}else La(123263,122928,760,123254);return 0}function Dh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;if(a[(c[(c[g>>2]|0)+8>>2]|0)+156>>0]|0){h=0;j=h&1;i=e;return j|0}h=(AC(c[f>>2]|0,c[g>>2]|0)|0)!=0;j=h&1;i=e;return j|0}function Eh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if(((a[(c[(c[h>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[h>>2]|0)+8>>2]|0)+172+4>>2]|0)==1:0)?(c[(c[(c[h>>2]|0)+8>>2]|0)+180+4>>2]|0)==1:0){c[j>>2]=c[c[(c[(c[h>>2]|0)+8>>2]|0)+180>>2]>>2];while(1){if(!(a[(c[(c[j>>2]|0)+8>>2]|0)+112>>0]|0))break;c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+116>>2]}if(AC(c[g>>2]|0,c[j>>2]|0)|0){c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}}c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}function Fh(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[d>>2]|0)){i=b;return}O4(c[(c[d>>2]|0)+8>>2]|0);O4(c[d>>2]|0);i=b;return}function Gh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;h=d+4|0;c[f>>2]=b;if(!((c[13809]|0)!=0|(c[13838]|0)!=0)){i=d;return}b=hO(c[f>>2]|0,c[13809]|0,0)|0;c[g>>2]=b;if(!b){c[h>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;if(!(Vi(c[h>>2]|0)|0))Gh(c[h>>2]|0);c[h>>2]=HD(c[h>>2]|0)|0}if(!(c[13838]|0)){i=d;return}Ph(c[f>>2]|0);i=d;return}if((a[c[g>>2]>>0]|0)==(a[123504]|0)?(J3(c[g>>2]|0,123504)|0)==0:0){Oh(c[f>>2]|0,1);i=d;return}if((a[c[g>>2]>>0]|0)==(a[136320]|0)?(J3(c[g>>2]|0,136320)|0)==0:0){Oh(c[f>>2]|0,0);i=d;return}if(!(a[c[g>>2]>>0]|0)){i=d;return}c[e>>2]=c[g>>2];$z(1,123508,e)|0;i=d;return}function Hh(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=d;c[h>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[h>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;c[j>>2]=0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]|0))break;c[k>>2]=c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2];a[(c[(c[k>>2]|0)+8>>2]|0)+158>>0]=0;a[(c[(c[k>>2]|0)+8>>2]|0)+157>>0]=0;c[(c[(c[k>>2]|0)+8>>2]|0)+284>>2]=c[g>>2];if((c[j>>2]|0)==0?(c[(c[(c[k>>2]|0)+8>>2]|0)+188+4>>2]|0)>0:0){d=Mh(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]|0,c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]|0)|0;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)+56>>2]=d;c[j>>2]=1}c[g>>2]=(c[g>>2]|0)+1}a:do if(c[j>>2]|0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]|0))break a;c[k>>2]=c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2];if(!(a[(c[(c[k>>2]|0)+8>>2]|0)+157>>0]|0))Nh(c[f>>2]|0,c[k>>2]|0);c[g>>2]=(c[g>>2]|0)+1}}while(0);c[h>>2]=(c[h>>2]|0)+1}i=e;return}function Ih(e){e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+64|0;g=f+60|0;h=f+56|0;j=f+52|0;k=f+48|0;l=f+44|0;m=f+40|0;n=f+36|0;o=f+32|0;p=f+28|0;q=f+24|0;r=f+20|0;s=f+16|0;t=f+12|0;u=f+8|0;v=f+4|0;w=f;c[g>>2]=e;c[u>>2]=0;if(!(d[(c[(c[g>>2]|0)+8>>2]|0)+240>>0]|0)){i=f;return}c[k>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];a:while(1){if((c[k>>2]|0)>(b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0))break;if(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0){c[p>>2]=c[(c[(c[c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+236>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0))break;a[(c[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2]|0)+8>>2]|0)+157>>0]=0;c[h>>2]=(c[h>>2]|0)+1}if(c[u>>2]|0)x=eK(c[u>>2]|0,(c[h>>2]|0)+1<<2)|0;else x=cK((c[h>>2]|0)+1<<2)|0;c[u>>2]=x;c[l>>2]=0;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0))break;if(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1)c[q>>2]=c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2];else c[q>>2]=c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+((c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0)-(c[h>>2]|0)-1<<2)>>2];c[o>>2]=0;c[n>>2]=0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[(c[q>>2]|0)+8>>2]|0)+196+4>>2]|0))break;c[v>>2]=c[(c[(c[(c[q>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<2)>>2];if(Jh(c[g>>2]|0,c[q>>2]|0,c[v>>2]|0)|0)c[n>>2]=(c[n>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1}c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[(c[q>>2]|0)+8>>2]|0)+188+4>>2]|0))break;c[v>>2]=c[(c[(c[(c[q>>2]|0)+8>>2]|0)+188>>2]|0)+(c[j>>2]<<2)>>2];if(Jh(c[g>>2]|0,c[q>>2]|0,c[v>>2]|0)|0)c[o>>2]=(c[o>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1}e=c[q>>2]|0;if(!((c[n>>2]|0)==0&(c[o>>2]|0)==0)){if((c[n>>2]|0)==0?(a[(c[e+8>>2]|0)+157>>0]|0)==0:0){c[r>>2]=(c[u>>2]|0)+(c[l>>2]<<2);c[m>>2]=Kh(c[g>>2]|0,c[q>>2]|0,c[r>>2]|0,c[k>>2]|0)|0;c[l>>2]=(c[l>>2]|0)+(c[m>>2]|0)}}else{y=c[l>>2]|0;c[l>>2]=y+1;c[(c[u>>2]|0)+(y<<2)>>2]=e}c[h>>2]=(c[h>>2]|0)+1}b:do if(c[l>>2]|0){c:do if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1)){c[r>>2]=c[u>>2];c[s>>2]=(c[u>>2]|0)+(c[l>>2]<<2)+-4;while(1){if((c[r>>2]|0)>>>0>=(c[s>>2]|0)>>>0)break c;c[t>>2]=c[c[r>>2]>>2];c[c[r>>2]>>2]=c[c[s>>2]>>2];c[c[s>>2]>>2]=c[t>>2];c[r>>2]=(c[r>>2]|0)+4;c[s>>2]=(c[s>>2]|0)+-4}}while(0);c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0))break;e=c[(c[u>>2]|0)+(c[h>>2]<<2)>>2]|0;c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2]=e;c[q>>2]=e;c[(c[(c[q>>2]|0)+8>>2]|0)+236>>2]=(c[h>>2]|0)+(c[p>>2]|0);c[h>>2]=(c[h>>2]|0)+1}c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0))break b;c[q>>2]=c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2];d:do if(c[(c[(c[q>>2]|0)+8>>2]|0)+188>>2]|0){c[j>>2]=0;while(1){e=c[(c[(c[(c[q>>2]|0)+8>>2]|0)+188>>2]|0)+(c[j>>2]<<2)>>2]|0;c[w>>2]=e;if(!e)break d;if((c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1|0)==0?(e=c[w>>2]|0,y=c[w>>2]|0,(c[(c[(c[((c[c[w>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)<(c[(c[(c[((c[c[w>>2]>>2]&3|0)==3?y:y+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)):0)z=48;else z=46;if(((z|0)==46?(z=0,(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1|0)!=0):0)?(y=c[w>>2]|0,e=c[w>>2]|0,(c[(c[(c[((c[c[w>>2]>>2]&3|0)==2?y:y+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)>(c[(c[(c[((c[c[w>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)):0)z=48;if((z|0)==48){z=0;if(Jh(c[g>>2]|0,c[q>>2]|0,c[w>>2]|0)|0){z=49;break a}Ug(c[w>>2]|0);c[j>>2]=(c[j>>2]|0)+-1;fh(c[g>>2]|0,c[w>>2]|0)}c[j>>2]=(c[j>>2]|0)+1}}while(0);c[h>>2]=(c[h>>2]|0)+1}}while(0);a[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+49>>0]=0}c[k>>2]=(c[k>>2]|0)+1}if((z|0)==49)La(123350,122928,1292,123389);if(!(c[u>>2]|0)){i=f;return}O4(c[u>>2]|0);i=f;return}function Jh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e;c[g>>2]=a;c[e+4>>2]=b;c[h>>2]=d;if(!(c[(c[(c[h>>2]|0)+8>>2]|0)+156>>2]|0)){c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}d=c[h>>2]|0;if(!(Lh(c[g>>2]|0,c[((c[c[h>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)|0)){c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}d=c[h>>2]|0;if(Lh(c[g>>2]|0,c[((c[c[h>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)|0){c[f>>2]=1;j=c[f>>2]|0;i=e;return j|0}else{c[f>>2]=0;j=c[f>>2]|0;i=e;return j|0}return 0}function Kh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[o>>2]=0;a[(c[(c[j>>2]|0)+8>>2]|0)+157>>0]=1;a:do if((c[(c[(c[j>>2]|0)+8>>2]|0)+188+4>>2]|0)>0){c[n>>2]=0;while(1){f=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+188>>2]|0)+(c[n>>2]<<2)>>2]|0;c[m>>2]=f;if(!f)break a;if((Jh(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0)|0)!=0?(f=c[m>>2]|0,(a[(c[(c[((c[c[m>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0)==0):0){f=c[m>>2]|0;e=Kh(c[h>>2]|0,c[((c[c[m>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0,(c[k>>2]|0)+(c[o>>2]<<2)|0,c[l>>2]|0)|0;c[o>>2]=(c[o>>2]|0)+e}c[n>>2]=(c[n>>2]|0)+1}}while(0);if((c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0)==(c[l>>2]|0)){l=c[j>>2]|0;j=c[o>>2]|0;c[o>>2]=j+1;c[(c[k>>2]|0)+(j<<2)>>2]=l;i=g;return c[o>>2]|0}else La(123402,122928,1221,123418);return 0}function Lh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Dh(c[e>>2]|0,c[f>>2]|0)|0;a=b|(Eh(c[e>>2]|0,c[f>>2]|0)|0);i=d;return a|0}function Mh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=bK(12)|0;c[c[g>>2]>>2]=c[e>>2];c[(c[g>>2]|0)+4>>2]=c[f>>2];b=bK(_(c[e>>2]|0,c[f>>2]|0)|0)|0;c[(c[g>>2]|0)+8>>2]=b;i=d;return c[g>>2]|0}function Nh(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+20|0;l=f+4|0;m=f;c[g>>2]=b;c[h>>2]=e;c[m>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[h>>2]|0)+8>>2]|0)+232>>2]<<6)+56>>2];a[(c[(c[h>>2]|0)+8>>2]|0)+157>>0]=1;a[(c[(c[h>>2]|0)+8>>2]|0)+158>>0]=1;a[k>>0]=(c[(c[(uf(c[g>>2]|0)|0)+8>>2]|0)+180>>2]|0)>0;if(!(c[(c[(c[h>>2]|0)+8>>2]|0)+188>>2]|0)){n=c[h>>2]|0;o=n+8|0;p=c[o>>2]|0;q=p+158|0;a[q>>0]=0;i=f;return}c[j>>2]=0;a:while(1){e=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+188>>2]|0)+(c[j>>2]<<2)>>2]|0;c[l>>2]=e;if(!e){r=22;break}if(d[k>>0]|0){e=c[l>>2]|0;if((AC(c[g>>2]|0,c[((c[c[l>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)|0)!=0?(e=c[l>>2]|0,(AC(c[g>>2]|0,c[((c[c[l>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)|0)!=0):0)r=7}else r=7;do if((r|0)==7?(r=0,(c[(c[(c[l>>2]|0)+8>>2]|0)+156>>2]|0)!=0):0){e=c[l>>2]|0;b=c[l>>2]|0;s=(c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+284>>2]|0)<(c[c[m>>2]>>2]|0);if((a[(c[(c[((c[c[l>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+158>>0]|0)==1){if(!s){r=10;break a}e=c[l>>2]|0;if((c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+284>>2]|0)>=(c[(c[m>>2]|0)+4>>2]|0)){r=12;break a}e=c[l>>2]|0;b=_(c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+284>>2]|0,c[(c[m>>2]|0)+4>>2]|0)|0;e=c[l>>2]|0;a[(c[(c[m>>2]|0)+8>>2]|0)+(b+(c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+284>>2]|0))>>0]=1;Ug(c[l>>2]|0);c[j>>2]=(c[j>>2]|0)+-1;if((a[(c[(c[l>>2]|0)+8>>2]|0)+112>>0]|0)==4)break;fh(c[g>>2]|0,c[l>>2]|0);break}else{if(!s){r=16;break a}s=c[l>>2]|0;if((c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?s:s+32|0)+28>>2]|0)+8>>2]|0)+284>>2]|0)>=(c[(c[m>>2]|0)+4>>2]|0)){r=18;break a}s=c[l>>2]|0;e=_(c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?s:s+32|0)+28>>2]|0)+8>>2]|0)+284>>2]|0,c[(c[m>>2]|0)+4>>2]|0)|0;s=c[l>>2]|0;a[(c[(c[m>>2]|0)+8>>2]|0)+(e+(c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?s:s+-32|0)+28>>2]|0)+8>>2]|0)+284>>2]|0))>>0]=1;s=c[l>>2]|0;if(a[(c[(c[((c[c[l>>2]>>2]&3|0)==2?s:s+-32|0)+28>>2]|0)+8>>2]|0)+157>>0]|0)break;s=c[l>>2]|0;Nh(c[g>>2]|0,c[((c[c[l>>2]>>2]&3|0)==2?s:s+-32|0)+28>>2]|0);break}}while(0);c[j>>2]=(c[j>>2]|0)+1}if((r|0)==10)La(123428,122928,982,123460);else if((r|0)==12)La(123472,122928,983,123460);else if((r|0)==16)La(123428,122928,991,123460);else if((r|0)==18)La(123472,122928,992,123460);else if((r|0)==22){n=c[h>>2]|0;o=n+8|0;p=c[o>>2]|0;q=p+158|0;a[q>>0]=0;i=f;return}}function Oh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;Qh(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0);c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}i=d;return}function Ph(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;c[f>>2]=b;c[g>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;b=hO(c[g>>2]|0,c[13838]|0,0)|0;c[h>>2]=b;do if(b){if((a[c[h>>2]>>0]|0)==(a[123504]|0)?(J3(c[h>>2]|0,123504)|0)==0:0){Qh(c[f>>2]|0,c[g>>2]|0,1);break}if((a[c[h>>2]>>0]|0)==(a[136320]|0)?(J3(c[h>>2]|0,136320)|0)==0:0){Qh(c[f>>2]|0,c[g>>2]|0,0);break}if(a[c[h>>2]>>0]|0){j=c[h>>2]|0;k=wB(c[g>>2]|0)|0;c[e>>2]=j;c[e+4>>2]=k;$z(1,123539,e)|0}}while(0);c[g>>2]=aC(c[f>>2]|0,c[g>>2]|0)|0}i=d;return}function Qh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+48|0;g=f+40|0;h=f+36|0;j=f+32|0;k=f+28|0;l=f+24|0;m=f+20|0;n=f+16|0;o=f+12|0;p=f+8|0;q=f+4|0;r=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[r>>2]=c[12560];if(c[(c[(c[h>>2]|0)+8>>2]|0)+212>>2]|0){i=f;return}e=(c[j>>2]|0)!=0;c[l>>2]=0;c[k>>2]=0;a:do if(e)while(1){d=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+180>>2]|0)+(c[k>>2]<<2)>>2]|0;c[o>>2]=d;if(!d)break a;if(!(Rh(c[o>>2]|0)|0)){d=c[o>>2]|0;b=c[l>>2]|0;c[l>>2]=b+1;c[(c[r>>2]|0)+(b<<2)>>2]=d}c[k>>2]=(c[k>>2]|0)+1}else while(1){d=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]|0)+(c[k>>2]<<2)>>2]|0;c[o>>2]=d;if(!d)break a;if(!(Rh(c[o>>2]|0)|0)){d=c[o>>2]|0;b=c[l>>2]|0;c[l>>2]=b+1;c[(c[r>>2]|0)+(b<<2)>>2]=d}c[k>>2]=(c[k>>2]|0)+1}while(0);if((c[l>>2]|0)<=1){i=f;return}c[(c[r>>2]|0)+(c[l>>2]<<2)>>2]=0;w3(c[r>>2]|0,c[l>>2]|0,4,60);c[l>>2]=1;while(1){k=c[(c[r>>2]|0)+(c[l>>2]<<2)>>2]|0;c[p>>2]=k;if(!k){s=19;break}c[o>>2]=c[(c[r>>2]|0)+((c[l>>2]|0)-1<<2)>>2];k=c[c[o>>2]>>2]&3;if(c[j>>2]|0){h=c[o>>2]|0;c[m>>2]=c[((k|0)==2?h:h+-32|0)+28>>2];h=c[p>>2]|0;c[n>>2]=c[((c[c[p>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]}else{h=c[o>>2]|0;c[m>>2]=c[((k|0)==3?h:h+32|0)+28>>2];h=c[p>>2]|0;c[n>>2]=c[((c[c[p>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]}if(Hg(c[m>>2]|0,c[n>>2]|0)|0){s=19;break}c[q>>2]=Ng(c[m>>2]|0,c[n>>2]|0,0)|0;a[(c[(c[q>>2]|0)+8>>2]|0)+112>>0]=4;Tg(c[g>>2]|0,c[q>>2]|0);c[l>>2]=(c[l>>2]|0)+1}if((s|0)==19){i=f;return}}function Rh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b;c[d>>2]=a;while(1){e=c[d>>2]|0;if(!(c[(c[(c[d>>2]|0)+8>>2]|0)+116>>2]|0))break;c[d>>2]=c[(c[e+8>>2]|0)+116>>2]}a=c[d>>2]|0;f=c[d>>2]|0;i=b;return (c[(c[(c[((c[e>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)!=(c[(c[(c[((c[c[d>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)|0}function Sh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;i=d;return ((c[c[c[e>>2]>>2]>>2]|0)>>>4)-((c[c[c[f>>2]>>2]>>2]|0)>>>4)|0}function Th(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;if((c[(c[(c[e>>2]|0)+8>>2]|0)+216+4>>2]|0)<=1){i=d;return}c[g>>2]=0;c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[(c[e>>2]|0)+8>>2]|0)+216+4>>2]|0))break;c[h>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0)+(c[f>>2]<<2)>>2];if(c[g>>2]|0)c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]=c[h>>2];c[(c[(c[h>>2]|0)+8>>2]|0)+168>>2]=c[g>>2];while(1){j=c[h>>2]|0;if(!(c[(c[(c[h>>2]|0)+8>>2]|0)+164>>2]|0))break;c[h>>2]=c[(c[j+8>>2]|0)+164>>2]}c[g>>2]=j;c[f>>2]=(c[f>>2]|0)+1}c[(c[(c[e>>2]|0)+8>>2]|0)+216+4>>2]=1;c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]=c[c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]>>2];b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]=c[12561];b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]=c[12562];i=d;return}function Uh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[e>>2]|0))break;h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]=+(c[(c[(c[e>>2]|0)+8>>2]|0)+236>>2]|0);c[e>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+164>>2]}i=b;return}function Vh(d){d=d|0;var e=0,f=0,g=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=d;c[g>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]=~~+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}c[j>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;a[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+49>>0]=0;w3(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0,c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0,4,61);c[j>>2]=(c[j>>2]|0)+1}i=e;return}function Wh(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[f>>2]=a;c[g>>2]=d;if(((c[g>>2]|0)%4|0|0)<2)c[o>>2]=1;else c[o>>2]=0;if((c[g>>2]|0)%2|0){c[h>>2]=(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0)-1;c[m>>2]=-1}else{c[h>>2]=1;c[m>>2]=1}d=c[(c[f>>2]|0)+8>>2]|0;if(!((c[g>>2]|0)%2|0)){c[k>>2]=(b[d+236>>1]|0)+1;if((b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0)>(b[(c[(c[12547]|0)+8>>2]|0)+236>>1]|0))c[k>>2]=(c[k>>2]|0)+-1;c[l>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1];c[m>>2]=1}else{c[k>>2]=(b[d+238>>1]|0)-1;c[l>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];if((b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0)<(b[(c[(c[12547]|0)+8>>2]|0)+238>>1]|0))c[k>>2]=(c[k>>2]|0)+1;c[m>>2]=-1}c[h>>2]=c[k>>2];while(1){if((c[h>>2]|0)==((c[l>>2]|0)+(c[m>>2]|0)|0))break;c[j>>2]=(c[h>>2]|0)-(c[m>>2]|0);c[n>>2]=(Zh(c[f>>2]|0,c[h>>2]|0,c[j>>2]|0)|0)&255;_h(c[f>>2]|0,c[h>>2]|0,c[o>>2]|0,c[n>>2]|0);c[h>>2]=(c[h>>2]|0)+(c[m>>2]|0)}uh(c[f>>2]|0,((c[o>>2]|0)!=0^1)&1);i=e;return}function Xh(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=d;c[k>>2]=0;c[n>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1];a:while(1){if((c[n>>2]|0)<(b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0)){o=16;break}a[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+48>>0]=0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=((c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)>>2]|0)-1|0))break;c[l>>2]=c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2];c[m>>2]=c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[n>>2]<<6)+4>>2]|0)+((c[g>>2]|0)+1<<2)>>2];if((c[(c[(c[l>>2]|0)+8>>2]|0)+236>>2]|0)>=(c[(c[(c[m>>2]|0)+8>>2]|0)+236>>2]|0)){o=6;break a}if(!(zh(c[f>>2]|0,c[l>>2]|0,c[m>>2]|0)|0)){c[j>>2]=0;c[h>>2]=0;if((c[n>>2]|0)>0){d=Ah(c[l>>2]|0,c[m>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+d;d=Ah(c[m>>2]|0,c[l>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+d}if((c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+((c[n>>2]|0)+1<<6)>>2]|0)>0){d=Bh(c[l>>2]|0,c[m>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+d;d=Bh(c[m>>2]|0,c[l>>2]|0)|0;c[j>>2]=(c[j>>2]|0)+d}if((c[j>>2]|0)<=(c[h>>2]|0))Yh(c[f>>2]|0,c[n>>2]|0,c[l>>2]|0,c[m>>2]|0)}c[g>>2]=(c[g>>2]|0)+1}c[n>>2]=(c[n>>2]|0)+-1}if((o|0)==6)La(123211,122928,465,123698);else if((o|0)==16){i=e;return c[k>>2]|0}return 0}function Yh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+64|0;h=g+52|0;j=g+48|0;k=g+44|0;l=g+40|0;m=g+36|0;n=g+32|0;o=g+28|0;p=g+24|0;q=g+20|0;r=g+16|0;s=g+12|0;t=g+8|0;u=g+4|0;v=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;if((a[(c[(c[k>>2]|0)+8>>2]|0)+156>>0]|0)==(a[(c[(c[l>>2]|0)+8>>2]|0)+156>>0]|0)){i=g;return}c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;if(!(a[(c[(c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[v>>2]<<2)>>2]|0)+8>>2]|0)+156>>0]|0))c[q>>2]=(c[q>>2]|0)+1;else c[p>>2]=(c[p>>2]|0)+1;c[v>>2]=(c[v>>2]|0)+1}f=(a[(c[(c[k>>2]|0)+8>>2]|0)+156>>0]|0)==0;do if((c[q>>2]|0)<(c[p>>2]|0))if(f){c[m>>2]=c[k>>2];break}else{c[m>>2]=c[l>>2];break}else if(f){c[m>>2]=c[l>>2];break}else{c[m>>2]=c[k>>2];break}while(0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;if((c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[v>>2]<<2)>>2]|0)==(c[m>>2]|0))c[n>>2]=c[v>>2];c[v>>2]=(c[v>>2]|0)+1}c[o>>2]=(a[(c[(c[m>>2]|0)+8>>2]|0)+156>>0]|0)==0?1:0;c[v>>2]=(c[n>>2]|0)-1;while(1){if((c[v>>2]|0)<0)break;if((a[(c[(c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[v>>2]<<2)>>2]|0)+8>>2]|0)+156>>0]|0)!=(c[o>>2]|0))break;c[r>>2]=(c[r>>2]|0)+1;c[v>>2]=(c[v>>2]|0)+-1}c[v>>2]=(c[n>>2]|0)+1;while(1){if((c[v>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;if((a[(c[(c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[v>>2]<<2)>>2]|0)+8>>2]|0)+156>>0]|0)!=(c[o>>2]|0))break;c[s>>2]=(c[s>>2]|0)+1;c[v>>2]=(c[v>>2]|0)+1}th(c[k>>2]|0,c[l>>2]|0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;if((c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[v>>2]<<2)>>2]|0)==(c[m>>2]|0))c[n>>2]=c[v>>2];c[v>>2]=(c[v>>2]|0)+1}c[v>>2]=(c[n>>2]|0)-1;while(1){if((c[v>>2]|0)<0)break;if((a[(c[(c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[v>>2]<<2)>>2]|0)+8>>2]|0)+156>>0]|0)!=(c[o>>2]|0))break;c[t>>2]=(c[t>>2]|0)+1;c[v>>2]=(c[v>>2]|0)+-1}c[v>>2]=(c[n>>2]|0)+1;while(1){if((c[v>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;if((a[(c[(c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[v>>2]<<2)>>2]|0)+8>>2]|0)+156>>0]|0)!=(c[o>>2]|0))break;c[u>>2]=(c[u>>2]|0)+1;c[v>>2]=(c[v>>2]|0)+1}v=N((c[t>>2]|0)-(c[u>>2]|0)|0)|0;if((v|0)<=(N((c[r>>2]|0)-(c[s>>2]|0)|0)|0)){i=g;return}th(c[k>>2]|0,c[l>>2]|0);i=g;return}function Zh(e,f,g){e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+64|0;k=j+56|0;l=j+52|0;m=j+48|0;n=j+44|0;o=j+40|0;p=j+36|0;q=j+32|0;r=j+28|0;s=j+24|0;t=j+20|0;u=j+16|0;v=j+12|0;w=j+8|0;x=j+4|0;y=j+60|0;z=j;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;a[y>>0]=0;c[u>>2]=c[12559];c[w>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)+4>>2];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)>>2]|0))break;c[v>>2]=c[(c[w>>2]|0)+(c[n>>2]<<2)>>2];c[o>>2]=0;g=(c[m>>2]|0)>(c[l>>2]|0);c[p>>2]=0;a:do if(g)while(1){f=c[(c[(c[(c[v>>2]|0)+8>>2]|0)+180>>2]|0)+(c[p>>2]<<2)>>2]|0;c[x>>2]=f;if(!f)break a;if((b[(c[(c[x>>2]|0)+8>>2]|0)+154>>1]|0)>0){f=c[x>>2]|0;e=(c[(c[(c[((c[c[x>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]<<8)+(d[(c[(c[x>>2]|0)+8>>2]|0)+56+32>>0]|0)|0;f=c[o>>2]|0;c[o>>2]=f+1;c[(c[u>>2]|0)+(f<<2)>>2]=e}c[p>>2]=(c[p>>2]|0)+1}else while(1){e=c[(c[(c[(c[v>>2]|0)+8>>2]|0)+172>>2]|0)+(c[p>>2]<<2)>>2]|0;c[x>>2]=e;if(!e)break a;if((b[(c[(c[x>>2]|0)+8>>2]|0)+154>>1]|0)>0){e=c[x>>2]|0;f=(c[(c[(c[((c[c[x>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+236>>2]<<8)+(d[(c[(c[x>>2]|0)+8>>2]|0)+16+32>>0]|0)|0;e=c[o>>2]|0;c[o>>2]=e+1;c[(c[u>>2]|0)+(e<<2)>>2]=f}c[p>>2]=(c[p>>2]|0)+1}while(0);b:do switch(c[o>>2]|0){case 0:{h[(c[(c[v>>2]|0)+8>>2]|0)+240>>3]=-1.0;break}case 1:{h[(c[(c[v>>2]|0)+8>>2]|0)+240>>3]=+(c[c[u>>2]>>2]|0);break}case 2:{h[(c[(c[v>>2]|0)+8>>2]|0)+240>>3]=+(((c[c[u>>2]>>2]|0)+(c[(c[u>>2]|0)+4>>2]|0)|0)/2|0|0);break}default:{w3(c[u>>2]|0,c[o>>2]|0,4,62);g=(c[o>>2]|0)/2|0;if((c[o>>2]|0)%2|0){h[(c[(c[v>>2]|0)+8>>2]|0)+240>>3]=+(c[(c[u>>2]|0)+(g<<2)>>2]|0);break b}c[r>>2]=g;c[q>>2]=(c[r>>2]|0)-1;c[t>>2]=(c[(c[u>>2]|0)+((c[o>>2]|0)-1<<2)>>2]|0)-(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0);c[s>>2]=(c[(c[u>>2]|0)+(c[q>>2]<<2)>>2]|0)-(c[c[u>>2]>>2]|0);g=c[(c[u>>2]|0)+(c[q>>2]<<2)>>2]|0;if((c[s>>2]|0)==(c[t>>2]|0)){h[(c[(c[v>>2]|0)+8>>2]|0)+240>>3]=+((g+(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0)|0)/2|0|0);break b}else{f=_(g,c[t>>2]|0)|0;c[z>>2]=f+(_(c[(c[u>>2]|0)+(c[r>>2]<<2)>>2]|0,c[s>>2]|0)|0);h[(c[(c[v>>2]|0)+8>>2]|0)+240>>3]=+((c[z>>2]|0)/((c[s>>2]|0)+(c[t>>2]|0)|0)|0|0);break b}}}while(0);c[n>>2]=(c[n>>2]|0)+1}c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)>>2]|0))break;c[v>>2]=c[(c[w>>2]|0)+(c[n>>2]<<2)>>2];if((c[(c[(c[v>>2]|0)+8>>2]|0)+180+4>>2]|0)==0?(c[(c[(c[v>>2]|0)+8>>2]|0)+172+4>>2]|0)==0:0){t=ai(c[v>>2]|0)|0;a[y>>0]=d[y>>0]|t}c[n>>2]=(c[n>>2]|0)+1}i=j;return a[y>>0]|0}function _h(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;j=i;i=i+64|0;k=j+44|0;l=j+40|0;m=j+36|0;n=j+32|0;o=j+28|0;p=j+24|0;q=j+49|0;r=j+48|0;s=j+20|0;t=j+16|0;u=j+12|0;v=j+8|0;w=j+4|0;x=j;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=0;c[s>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)+4>>2];c[v>>2]=(c[s>>2]|0)+(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)>>2]<<2);c[p>>2]=(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)>>2]|0)-1;while(1){if((c[p>>2]|0)<0)break;c[t>>2]=c[s>>2];while(1){if((c[t>>2]|0)>>>0>=(c[v>>2]|0)>>>0)break;while(1){if((c[t>>2]|0)>>>0<(c[v>>2]|0)>>>0)y=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+240>>3]<0.0;else y=0;z=c[t>>2]|0;if(!y)break;c[t>>2]=z+4}if(z>>>0>=(c[v>>2]|0)>>>0)break;a[q>>0]=0;a[r>>0]=0;c[u>>2]=(c[t>>2]|0)+4;while(1){if((c[u>>2]|0)>>>0>=(c[v>>2]|0)>>>0)break;if(!((d[r>>0]|0|0)!=0?(c[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+212>>2]|0)!=0:0)){if(zh(c[k>>2]|0,c[c[t>>2]>>2]|0,c[c[u>>2]>>2]|0)|0){A=15;break}if(+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+240>>3]>=0.0)break;if(c[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+212>>2]|0)a[r>>0]=1}c[u>>2]=(c[u>>2]|0)+4}if((A|0)==15){A=0;a[q>>0]=1}if((c[u>>2]|0)>>>0>=(c[v>>2]|0)>>>0)break;do if(!(d[q>>0]|0)){c[w>>2]=~~+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+240>>3];c[x>>2]=~~+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+240>>3];if((c[w>>2]|0)<=(c[x>>2]|0)?!((c[m>>2]|0)!=0?(c[w>>2]|0)==(c[x>>2]|0):0):0)break;th(c[c[t>>2]>>2]|0,c[c[u>>2]>>2]|0);c[o>>2]=(c[o>>2]|0)+1}while(0);c[t>>2]=c[u>>2]}if((c[n>>2]|0)==0&(c[m>>2]|0)==0)c[v>>2]=(c[v>>2]|0)+-4;c[p>>2]=(c[p>>2]|0)+-1}if(!(c[o>>2]|0)){i=j;return}a[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)+49>>0]=0;if((c[l>>2]|0)<=0){i=j;return}a[(c[(c[(c[12547]|0)+8>>2]|0)+196>>2]|0)+((c[l>>2]|0)-1<<6)+49>>0]=0;i=j;return}function $h(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;i=d;return (c[c[e>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0}function ai(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;j=b+4|0;k=b;c[e>>2]=a;a=c[(c[e>>2]|0)+8>>2]|0;if((c[(c[(c[e>>2]|0)+8>>2]|0)+196+4>>2]|0)>0){c[j>>2]=c[a+196>>2];l=c[c[j>>2]>>2]|0;c[k>>2]=c[((c[c[c[j>>2]>>2]>>2]&3|0)==3?l:l+32|0)+28>>2];c[f>>2]=1;while(1){l=c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0;c[g>>2]=l;if(!l)break;l=c[g>>2]|0;if((c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)>(c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]|0)){l=c[g>>2]|0;c[k>>2]=c[((c[c[g>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]}c[f>>2]=(c[f>>2]|0)+1}if(+h[(c[(c[k>>2]|0)+8>>2]|0)+240>>3]>=0.0){h[(c[(c[e>>2]|0)+8>>2]|0)+240>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+240>>3]+1.0;c[d>>2]=0;m=c[d>>2]|0;i=b;return m|0}}else if((c[a+188+4>>2]|0)>0){c[j>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+188>>2];a=c[c[j>>2]>>2]|0;c[k>>2]=c[((c[c[c[j>>2]>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2];c[f>>2]=1;while(1){a=c[(c[j>>2]|0)+(c[f>>2]<<2)>>2]|0;c[g>>2]=a;if(!a)break;a=c[g>>2]|0;if((c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)<(c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]|0)){a=c[g>>2]|0;c[k>>2]=c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]}c[f>>2]=(c[f>>2]|0)+1}if(+h[(c[(c[k>>2]|0)+8>>2]|0)+240>>3]>0.0){h[(c[(c[e>>2]|0)+8>>2]|0)+240>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+240>>3]-1.0;c[d>>2]=0;m=c[d>>2]|0;i=b;return m|0}}c[d>>2]=1;m=c[d>>2]|0;i=b;return m|0}function bi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;i=d;return (c[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+236>>2]|0)-(c[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+236>>2]|0)|0}function ci(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,k=0.0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b;c[d>>2]=a;c[12563]=8;c[13798]=24;h[4138]=.995;c[e>>2]=yA(c[d>>2]|0,123716)|0;if(!(c[e>>2]|0)){i=b;return}g=+t3(c[e>>2]|0);h[f>>3]=g;if(!(g>0.0)){i=b;return}if(1.0>+(c[12563]|0)*+h[f>>3])j=1.0;else j=+(c[12563]|0)*+h[f>>3];c[12563]=~~j;if(1.0>+(c[13798]|0)*+h[f>>3])k=1.0;else k=+(c[13798]|0)*+h[f>>3];c[13798]=~~k;i=b;return}function di(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+12|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0)+2;c[g>>2]=bK(c[f>>2]<<2)|0;c[d+8>>2]=ei(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0,0)|0;O4(c[g>>2]|0);i=d;return}function ei(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+48|0;j=g+32|0;k=g+28|0;l=g+24|0;m=g+20|0;n=g+16|0;o=g+12|0;p=g+8|0;q=g+4|0;r=g;c[k>>2]=a;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[p>>2]=1;while(1){if((c[p>>2]|0)>(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0))break;c[n>>2]=ei(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+184>>2]|0)+(c[p>>2]<<2)>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;c[p>>2]=(c[p>>2]|0)+1}p=uf(c[k>>2]|0)|0;if((p|0)==(c[k>>2]|0)){c[j>>2]=c[n>>2];s=c[j>>2]|0;i=g;return s|0}$4(c[l>>2]|0,0,c[m>>2]<<2|0)|0;c[r>>2]=$B(c[k>>2]|0)|0;while(1){if(!(c[r>>2]|0))break;c[(c[l>>2]|0)+(c[(c[(c[r>>2]|0)+8>>2]|0)+232>>2]<<2)>>2]=1;c[q>>2]=OA(c[k>>2]|0,c[r>>2]|0)|0;while(1){if(!(c[q>>2]|0))break;c[o>>2]=(c[(c[(c[r>>2]|0)+8>>2]|0)+232>>2]|0)+1;while(1){m=c[q>>2]|0;if((c[o>>2]|0)>(c[(c[(c[((c[c[q>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0))break;c[(c[l>>2]|0)+(c[o>>2]<<2)>>2]=1;c[o>>2]=(c[o>>2]|0)+1}c[q>>2]=QA(c[k>>2]|0,c[q>>2]|0)|0}c[r>>2]=aC(c[k>>2]|0,c[r>>2]|0)|0}c[o>>2]=b[(c[(c[k>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[o>>2]|0)>(b[(c[(c[k>>2]|0)+8>>2]|0)+238>>1]|0))break;if(!(c[(c[l>>2]|0)+(c[o>>2]<<2)>>2]|0)){if(!(c[n>>2]|0))c[n>>2]=FD(uf(c[k>>2]|0)|0,123706,1)|0;c[r>>2]=fC(c[n>>2]|0,0,1)|0;MC(c[r>>2]|0,175026,304,1)|0;c[(c[(c[r>>2]|0)+8>>2]|0)+232>>2]=c[o>>2];h[(c[(c[r>>2]|0)+8>>2]|0)+96>>3]=.5;h[(c[(c[r>>2]|0)+8>>2]|0)+88>>3]=.5;h[(c[(c[r>>2]|0)+8>>2]|0)+80>>3]=1.0;c[(c[(c[r>>2]|0)+8>>2]|0)+216>>2]=1;c[(c[(c[r>>2]|0)+8>>2]|0)+172+4>>2]=0;q=bK(20)|0;c[(c[(c[r>>2]|0)+8>>2]|0)+172>>2]=q;c[(c[(c[r>>2]|0)+8>>2]|0)+180+4>>2]=0;q=bK(20)|0;c[(c[(c[r>>2]|0)+8>>2]|0)+180>>2]=q;eC(c[k>>2]|0,c[r>>2]|0,1)|0}c[o>>2]=(c[o>>2]|0)+1}c[j>>2]=c[n>>2];s=c[j>>2]|0;i=g;return s|0}function fi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=b;c[g>>2]=d;if(!(c[(c[(c[f>>2]|0)+8>>2]|0)+192>>2]|0)){i=e;return}zk(c[f>>2]|0);ii(c[f>>2]|0);if(a[139e3]|0)Uk(c[f>>2]|0);ji(c[f>>2]|0);if(gl(c[f>>2]|0)|0)ii(c[f>>2]|0);ki(c[f>>2]|0);d=c[f>>2]|0;do if(gK(d,2,li(c[f>>2]|0)|0)|0){mi(c[f>>2]|0);b=c[f>>2]|0;if(!(gK(b,2,li(c[f>>2]|0)|0)|0))break;else La(123724,123752,134,123763)}while(0);ni(c[f>>2]|0);oi(c[f>>2]|0,c[g>>2]|0);pi(c[f>>2]|0);i=e;return}function gi(a,d,e,f){a=a|0;d=d|0;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;j=g+24|0;k=g+20|0;l=g;m=g+16|0;n=g+12|0;o=g+8|0;c[j>>2]=a;c[k>>2]=d;h[l>>3]=e;c[m>>2]=f;c[o>>2]=bK(64)|0;f=(c[o>>2]|0)+32|0;c[f>>2]=c[f>>2]&-4|3;f=c[o>>2]|0;c[f>>2]=c[f>>2]&-4|2;f=bK(176)|0;c[(c[o>>2]|0)+8>>2]=f;c[n>>2]=c[o>>2];o=c[n>>2]|0;c[((c[c[n>>2]>>2]&3|0)==3?o:o+32|0)+28>>2]=c[j>>2];j=c[n>>2]|0;c[((c[c[n>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]=c[k>>2];if(+h[l>>3]>65535.0)h[l>>3]=+qi(+h[l>>3]);e=+h[l>>3];b[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]=~~(+h[l>>3]>=0.0?e+.5:e-.5);c[(c[(c[n>>2]|0)+8>>2]|0)+156>>2]=c[m>>2];Ig(c[n>>2]|0)|0;i=g;return c[n>>2]|0}function hi(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=a;c[g>>2]=b;if((d[(c[(c[f>>2]|0)+8>>2]|0)+56+28>>0]|0|0)!=(d[(c[(c[g>>2]|0)+8>>2]|0)+56+28>>0]|0|0)){j=0;k=j&1;i=e;return k|0}if(!(+h[(c[(c[f>>2]|0)+8>>2]|0)+56>>3]==+h[(c[(c[g>>2]|0)+8>>2]|0)+56>>3]?+h[(c[(c[f>>2]|0)+8>>2]|0)+56+8>>3]==+h[(c[(c[g>>2]|0)+8>>2]|0)+56+8>>3]:0))l=4;if((l|0)==4?(d[(c[(c[f>>2]|0)+8>>2]|0)+56+28>>0]|0|0)!=0:0){j=0;k=j&1;i=e;return k|0}if(+h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]==+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3]?+h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]==+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3]:0){j=1;k=j&1;i=e;return k|0}j=(d[(c[(c[f>>2]|0)+8>>2]|0)+16+28>>0]|0|0)==0;k=j&1;i=e;return k|0}function ii(d){d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0.0;e=i;i=i+80|0;f=e+76|0;g=e+72|0;j=e+68|0;k=e+64|0;l=e+32|0;m=e+24|0;n=e+16|0;o=e+8|0;p=e;q=e+60|0;r=e+56|0;s=e+52|0;t=e+48|0;u=e+44|0;v=e+40|0;c[f>>2]=d;c[s>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2];h[m>>3]=0.0;h[l>>3]=0.0;c[k>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[k>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[s>>2]|0)+(c[k>>2]<<6)>>2]|0))break;c[q>>2]=c[(c[(c[s>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2];h[l>>3]=+h[(c[(c[q>>2]|0)+8>>2]|0)+80>>3]/2.0;a:do if(c[(c[(c[q>>2]|0)+8>>2]|0)+204>>2]|0){c[j>>2]=0;while(1){d=c[(c[(c[(c[q>>2]|0)+8>>2]|0)+204>>2]|0)+(c[j>>2]<<2)>>2]|0;c[r>>2]=d;if(!d)break a;d=c[r>>2]|0;w=c[r>>2]|0;if((c[((c[c[r>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)==(c[((c[c[r>>2]>>2]&3|0)==2?w:w+-32|0)+28>>2]|0)?(c[(c[(c[r>>2]|0)+8>>2]|0)+96>>2]|0)!=0:0){if(+h[l>>3]>+h[(c[(c[(c[r>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]/2.0)x=+h[l>>3];else x=+h[(c[(c[(c[r>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]/2.0;h[l>>3]=x}c[j>>2]=(c[j>>2]|0)+1}}while(0);if(+h[(c[s>>2]|0)+(c[k>>2]<<6)+40>>3]<+h[l>>3]){y=+h[l>>3];h[(c[s>>2]|0)+(c[k>>2]<<6)+24>>3]=y;h[(c[s>>2]|0)+(c[k>>2]<<6)+40>>3]=y}if(+h[(c[s>>2]|0)+(c[k>>2]<<6)+32>>3]<+h[l>>3]){y=+h[l>>3];h[(c[s>>2]|0)+(c[k>>2]<<6)+16>>3]=y;h[(c[s>>2]|0)+(c[k>>2]<<6)+32>>3]=y}w=c[(c[(c[q>>2]|0)+8>>2]|0)+212>>2]|0;c[t>>2]=w;if(w){if((c[t>>2]|0)==(c[f>>2]|0))z=0;else z=eO(c[t>>2]|0,c[13813]|0,8,0)|0;c[v>>2]=z;if((c[(c[(c[q>>2]|0)+8>>2]|0)+232>>2]|0)==(b[(c[(c[t>>2]|0)+8>>2]|0)+236>>1]|0)){if(+h[(c[(c[t>>2]|0)+8>>2]|0)+128>>3]>+h[l>>3]+ +(c[v>>2]|0))A=+h[(c[(c[t>>2]|0)+8>>2]|0)+128>>3];else A=+h[l>>3]+ +(c[v>>2]|0);h[(c[(c[t>>2]|0)+8>>2]|0)+128>>3]=A}if((c[(c[(c[q>>2]|0)+8>>2]|0)+232>>2]|0)==(b[(c[(c[t>>2]|0)+8>>2]|0)+238>>1]|0)){if(+h[(c[(c[t>>2]|0)+8>>2]|0)+120>>3]>+h[l>>3]+ +(c[v>>2]|0))B=+h[(c[(c[t>>2]|0)+8>>2]|0)+120>>3];else B=+h[l>>3]+ +(c[v>>2]|0);h[(c[(c[t>>2]|0)+8>>2]|0)+120>>3]=B}}c[g>>2]=(c[g>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}c[u>>2]=Pi(c[f>>2]|0)|0;h[m>>3]=0.0;c[k>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1];h[(c[(c[c[(c[s>>2]|0)+(c[k>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+(c[k>>2]<<6)+16>>3];while(1){g=(c[k>>2]|0)+-1|0;c[k>>2]=g;if((g|0)<(b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0))break;h[o>>3]=+h[(c[s>>2]|0)+((c[k>>2]|0)+1<<6)+40>>3]+ +h[(c[s>>2]|0)+(c[k>>2]<<6)+32>>3]+ +(c[(c[(c[f>>2]|0)+8>>2]|0)+252>>2]|0);h[p>>3]=+h[(c[s>>2]|0)+((c[k>>2]|0)+1<<6)+24>>3]+ +h[(c[s>>2]|0)+(c[k>>2]<<6)+16>>3]+8.0;h[n>>3]=+h[o>>3]>+h[p>>3]?+h[o>>3]:+h[p>>3];if((c[(c[s>>2]|0)+(c[k>>2]<<6)>>2]|0)>0)h[(c[(c[c[(c[s>>2]|0)+(c[k>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]=+h[(c[(c[c[(c[s>>2]|0)+((c[k>>2]|0)+1<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]+ +h[n>>3];h[m>>3]=+h[m>>3]>+h[n>>3]?+h[m>>3]:+h[n>>3]}b:do if(((c[u>>2]|0)!=0?(c[(c[(c[f>>2]|0)+8>>2]|0)+116>>2]&1|0)!=0:0)?(Qi(c[f>>2]|0,0),(a[(c[(c[f>>2]|0)+8>>2]|0)+276>>0]|0)!=0):0){h[m>>3]=0.0;c[k>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1];h[o>>3]=+h[(c[(c[c[(c[s>>2]|0)+(c[k>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3];while(1){g=(c[k>>2]|0)+-1|0;c[k>>2]=g;if((g|0)<(b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0))break b;h[p>>3]=+h[(c[(c[c[(c[s>>2]|0)+(c[k>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3];h[n>>3]=+h[p>>3]-+h[o>>3];h[m>>3]=+h[m>>3]>+h[n>>3]?+h[m>>3]:+h[n>>3];h[o>>3]=+h[p>>3]}}while(0);c:do if(a[(c[(c[f>>2]|0)+8>>2]|0)+276>>0]|0){c[k>>2]=(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0)-1;while(1){if((c[k>>2]|0)<(b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0))break c;if((c[(c[s>>2]|0)+(c[k>>2]<<6)>>2]|0)>0)h[(c[(c[c[(c[s>>2]|0)+(c[k>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]=+h[(c[(c[c[(c[s>>2]|0)+((c[k>>2]|0)+1<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]+ +h[m>>3];c[k>>2]=(c[k>>2]|0)+-1}}while(0);c[q>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[q>>2]|0))break;h[(c[(c[q>>2]|0)+8>>2]|0)+16+8>>3]=+h[(c[(c[c[(c[s>>2]|0)+(c[(c[(c[q>>2]|0)+8>>2]|0)+232>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3];c[q>>2]=c[(c[(c[q>>2]|0)+8>>2]|0)+164>>2]}i=e;return}function ji(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;Li(c[d>>2]|0);c[g>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;if(c[(c[(c[g>>2]|0)+8>>2]|0)+224>>2]|0)Mi(c[d>>2]|0,c[(c[(c[g>>2]|0)+8>>2]|0)+224>>2]|0);if(c[(c[(c[g>>2]|0)+8>>2]|0)+228>>2]|0)Mi(c[d>>2]|0,c[(c[(c[g>>2]|0)+8>>2]|0)+228>>2]|0);a:do if(c[(c[(c[g>>2]|0)+8>>2]|0)+204>>2]|0){c[e>>2]=0;while(1){a=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+204>>2]|0)+(c[e>>2]<<2)>>2]|0;c[h>>2]=a;if(!a)break a;a=c[h>>2]|0;k=c[h>>2]|0;l=(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0;c[f>>2]=l;if((l|0)!=0?(c[j>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+116>>2],(hi(c[h>>2]|0,c[j>>2]|0)|0)==0):0){Jg((c[(c[g>>2]|0)+8>>2]|0)+204|0,c[h>>2]|0);if((c[f>>2]|0)==1)Ig(c[h>>2]|0)|0;c[e>>2]=(c[e>>2]|0)+-1}c[e>>2]=(c[e>>2]|0)+1}}while(0);c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}i=b;return}function ki(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;xi(c[d>>2]|0);yi(c[d>>2]|0);zi(c[d>>2]|0);Ai(c[d>>2]|0);Bi(c[d>>2]|0);i=b;return}function li(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0.0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=2147483647;a=yA(c[d>>2]|0,123952)|0;c[f>>2]=a;if(!a){g=c[e>>2]|0;i=b;return g|0}h=+t3(c[f>>2]|0);c[e>>2]=~~(h*+(kB(c[d>>2]|0)|0));g=c[e>>2]|0;i=b;return g|0}function mi(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+36|0;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;o=e+4|0;p=e;c[f>>2]=d;c[j>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0)){q=33;break}c[p>>2]=(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6);c[k>>2]=0;c[l>>2]=0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[c[p>>2]>>2]|0))break;c[l>>2]=c[(c[(c[p>>2]|0)+4>>2]|0)+(c[g>>2]<<2)>>2];if(c[(c[(c[l>>2]|0)+8>>2]|0)+256>>2]|0){c[h>>2]=0;while(1){d=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+256>>2]|0)+(c[h>>2]<<2)>>2]|0;c[o>>2]=d;if(!d)break;d=c[o>>2]|0;if((c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[j>>2]|0)){q=10;break}d=c[o>>2]|0;if((c[(c[(c[((c[c[o>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[j>>2]|0)){q=10;break}c[h>>2]=(c[h>>2]|0)+1}if((q|0)==10){q=0;c[k>>2]=1}if(c[k>>2]|0)break}if(c[(c[(c[l>>2]|0)+8>>2]|0)+248>>2]|0){c[h>>2]=0;while(1){d=c[(c[(c[(c[l>>2]|0)+8>>2]|0)+248>>2]|0)+(c[h>>2]<<2)>>2]|0;c[o>>2]=d;if(!d)break;d=c[o>>2]|0;if((c[(c[(c[((c[c[o>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[j>>2]|0)){q=18;break}d=c[o>>2]|0;if((c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[j>>2]|0)){q=18;break}c[h>>2]=(c[h>>2]|0)+1}if((q|0)==18){q=0;c[k>>2]=1}if(c[k>>2]|0)break}c[g>>2]=(c[g>>2]|0)+1}if((c[k>>2]|0)==0&(c[l>>2]|0)!=0){c[l>>2]=c[c[(c[p>>2]|0)+4>>2]>>2];d=c[p>>2]|0;if((c[j>>2]|0)<(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))c[m>>2]=c[c[d+64+4>>2]>>2];else c[m>>2]=c[c[d+-64+4>>2]>>2];if(!(c[m>>2]|0)){q=27;break}c[n>>2]=Sg(c[f>>2]|0)|0;a[(c[(c[n>>2]|0)+8>>2]|0)+156>>0]=2;gi(c[n>>2]|0,c[l>>2]|0,0.0,0)|0;gi(c[n>>2]|0,c[m>>2]|0,0.0,0)|0;if((c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0)<(c[(c[(c[m>>2]|0)+8>>2]|0)+232>>2]|0))r=c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0;else r=c[(c[(c[m>>2]|0)+8>>2]|0)+232>>2]|0;c[(c[(c[n>>2]|0)+8>>2]|0)+232>>2]=r}c[j>>2]=(c[j>>2]|0)+1}if((q|0)==27)La(123936,123752,111,123939);else if((q|0)==33){i=e;return}}function ni(a){a=a|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[k>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2];c[f>>2]=b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[f>>2]|0)>(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0))break;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[k>>2]|0)+(c[f>>2]<<6)>>2]|0))break;c[j>>2]=c[(c[(c[k>>2]|0)+(c[f>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2];h[(c[(c[j>>2]|0)+8>>2]|0)+16>>3]=+(c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0);c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]=c[f>>2];c[g>>2]=(c[g>>2]|0)+1}c[f>>2]=(c[f>>2]|0)+1}i=d;return}function oi(d,e){d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;f=i;i=i+80|0;g=f+72|0;j=f+68|0;k=f+40|0;l=f+32|0;m=f+24|0;n=f+16|0;o=f+64|0;p=f+77|0;q=f+76|0;r=f+56|0;s=f+48|0;t=f+8|0;u=f;c[g>>2]=d;c[j>>2]=e;h[k>>3]=0.0;h[l>>3]=0.0;ri(c[g>>2]|0,c[g>>2]|0);if((b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0)>0?(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]|0)!=0:0){c[r>>2]=~~(+h[(c[(c[g>>2]|0)+8>>2]|0)+16+16>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3]);c[r+4>>2]=~~(+h[(c[(c[g>>2]|0)+8>>2]|0)+16+16+8>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3]);if(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1){c[s>>2]=c[r>>2];c[r>>2]=c[r+4>>2];c[r+4>>2]=c[s>>2]}a[p>>0]=1;s=c[g>>2]|0;if((c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]|0)==4)a[q>>0]=si(s,.5)|0;else a[q>>0]=(c[(c[(c[s+8>>2]|0)+8>>2]|0)+84>>2]|0)==2;s=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0;do if(a[q>>0]|0){if(+h[s+64>>3]<=0.0){a[p>>0]=0;break}h[k>>3]=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+64>>3]/+(c[r>>2]|0);h[l>>3]=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+64+8>>3]/+(c[r+4>>2]|0);if(+h[k>>3]<1.0|+h[l>>3]<1.0)if(+h[k>>3]<+h[l>>3]){h[l>>3]=+h[l>>3]/+h[k>>3];h[k>>3]=1.0;break}else{h[k>>3]=+h[k>>3]/+h[l>>3];h[l>>3]=1.0;break}}else{e=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0;if((c[s+84>>2]|0)==5){if(+h[e+64>>3]<=0.0){a[p>>0]=0;break}h[k>>3]=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+64>>3]/+h[(c[(c[g>>2]|0)+8>>2]|0)+16+16>>3];h[l>>3]=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+64+8>>3]/+h[(c[(c[g>>2]|0)+8>>2]|0)+16+16+8>>3];if(+h[k>>3]>1.0&+h[l>>3]>1.0){h[t>>3]=+h[k>>3]<+h[l>>3]?+h[k>>3]:+h[l>>3];v=+h[t>>3];h[l>>3]=v;h[k>>3]=v;break}else{a[p>>0]=0;break}}else{if((c[e+84>>2]|0)!=1){a[p>>0]=0;break}h[n>>3]=+h[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+16>>3];h[m>>3]=+(c[r+4>>2]|0)/+(c[r>>2]|0);if(+h[m>>3]<+h[n>>3]){h[l>>3]=+h[n>>3]/+h[m>>3];h[k>>3]=1.0;break}else{h[k>>3]=+h[m>>3]/+h[n>>3];h[l>>3]=1.0;break}}}while(0);if(a[p>>0]|0){if(c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]&1){h[u>>3]=+h[k>>3];h[k>>3]=+h[l>>3];h[l>>3]=+h[u>>3]}c[o>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[o>>2]|0))break;v=+h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3]*+h[k>>3];h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3]=+(~~(+h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3]*+h[k>>3]>=0.0?v+.5:v-.5)|0);v=+h[(c[(c[o>>2]|0)+8>>2]|0)+16+8>>3]*+h[l>>3];h[(c[(c[o>>2]|0)+8>>2]|0)+16+8>>3]=+(~~(+h[(c[(c[o>>2]|0)+8>>2]|0)+16+8>>3]*+h[l>>3]>=0.0?v+.5:v-.5)|0);c[o>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+164>>2]}ti(c[g>>2]|0,c[g>>2]|0,+h[k>>3],+h[l>>3])}}if(!(c[j>>2]|0)){i=f;return}ui(c[g>>2]|0,c[j>>2]|0);i=f;return}function pi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=b;c[g>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;c[f>>2]=0;while(1){b=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0)+(c[f>>2]<<2)>>2]|0;c[k>>2]=b;if(!b)break;O4(c[(c[k>>2]|0)+8>>2]|0);O4(c[k>>2]|0);c[f>>2]=(c[f>>2]|0)+1}if(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0)O4(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0);if(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)O4(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0);b=(c[(c[g>>2]|0)+8>>2]|0)+180|0;l=(c[(c[g>>2]|0)+8>>2]|0)+256|0;c[b>>2]=c[l>>2];c[b+4>>2]=c[l+4>>2];l=(c[(c[g>>2]|0)+8>>2]|0)+172|0;b=(c[(c[g>>2]|0)+8>>2]|0)+248|0;c[l>>2]=c[b>>2];c[l+4>>2]=c[b+4>>2];c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}c[j>>2]=0;c[g>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;c[h>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2];if((a[(c[(c[g>>2]|0)+8>>2]|0)+156>>0]|0)==2){f=c[h>>2]|0;if(c[j>>2]|0)c[(c[(c[j>>2]|0)+8>>2]|0)+164>>2]=f;else c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]=f;O4(c[(c[g>>2]|0)+8>>2]|0);O4(c[g>>2]|0)}else c[j>>2]=c[g>>2];c[g>>2]=c[h>>2]}c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]|0)+8>>2]|0)+168>>2]=0;i=d;return}function qi(a){a=+a;var b=0,d=0,e=0;b=i;i=i+32|0;d=b+8|0;e=b;h[e>>3]=a;h[d>>3]=+h[e>>3];c[d+8>>2]=65535;$z(1,123776,d)|0;i=b;return 65535.0}function ri(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=1;while(1){if((c[g>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;ri(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[g>>2]<<2)>>2]|0,c[f>>2]|0);c[g>>2]=(c[g>>2]|0)+1}wi(c[e>>2]|0,c[f>>2]|0);i=d;return}function si(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+160|0;f=e+136|0;g=e+120|0;j=e+156|0;k=e+152|0;l=e+112|0;m=e+104|0;n=e+96|0;o=e+88|0;p=e+80|0;q=e+64|0;r=e+48|0;s=e+32|0;t=e+16|0;u=e;c[k>>2]=b;h[l>>3]=d;b=(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+48|0;c[r>>2]=c[b>>2];c[r+4>>2]=c[b+4>>2];c[r+8>>2]=c[b+8>>2];c[r+12>>2]=c[b+12>>2];if(!(+h[r>>3]<.001)?!(+h[r+8>>3]<.001):0){b=(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+32|0;c[s>>2]=c[b>>2];c[s+4>>2]=c[b+4>>2];c[s+8>>2]=c[b+8>>2];c[s+12>>2]=c[b+12>>2];c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[f>>2]=c[s>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];vi(t,g,f);c[r>>2]=c[t>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[f>>2]=c[s>>2];c[f+4>>2]=c[s+4>>2];c[f+8>>2]=c[s+8>>2];c[f+12>>2]=c[s+12>>2];vi(u,g,f);c[r>>2]=c[u>>2];c[r+4>>2]=c[u+4>>2];c[r+8>>2]=c[u+8>>2];c[r+12>>2]=c[u+12>>2];h[q>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+16+16>>3];h[q+8>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+16+16+8>>3];h[m>>3]=+h[r>>3]/+h[q>>3];h[n>>3]=+h[r+8>>3]/+h[q+8>>3];if(+h[m>>3]>=1.0&+h[n>>3]>=1.0){a[j>>0]=0;v=a[j>>0]|0;i=e;return v|0}else{h[o>>3]=+h[m>>3]<+h[n>>3]?+h[m>>3]:+h[n>>3];d=+h[o>>3]>+h[l>>3]?+h[o>>3]:+h[l>>3];h[n>>3]=d;h[m>>3]=d;h[p>>3]=+Z(+(+h[m>>3]*+h[q>>3]/+h[r>>3]));h[m>>3]=+h[p>>3]*+h[r>>3]/+h[q>>3];h[p>>3]=+Z(+(+h[n>>3]*+h[q+8>>3]/+h[r+8>>3]));h[n>>3]=+h[p>>3]*+h[r+8>>3]/+h[q+8>>3];h[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+64>>3]=+h[q>>3]*+h[m>>3];h[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+64+8>>3]=+h[q+8>>3]*+h[n>>3];a[j>>0]=1;v=a[j>>0]|0;i=e;return v|0}}a[j>>0]=0;v=a[j>>0]|0;i=e;return v|0}function ti(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+24|0;j=f+20|0;k=f+8|0;l=f;m=f+16|0;c[g>>2]=a;c[j>>2]=b;h[k>>3]=d;h[l>>3]=e;c[m>>2]=1;while(1){if((c[m>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break;ti(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[m>>2]<<2)>>2]|0,c[j>>2]|0,+h[k>>3],+h[l>>3]);c[m>>2]=(c[m>>2]|0)+1}m=(c[(c[g>>2]|0)+8>>2]|0)+16|0;h[m>>3]=+h[m>>3]*+h[k>>3];m=(c[(c[g>>2]|0)+8>>2]|0)+16+8|0;h[m>>3]=+h[m>>3]*+h[l>>3];m=(c[(c[g>>2]|0)+8>>2]|0)+16+16|0;h[m>>3]=+h[m>>3]*+h[k>>3];k=(c[(c[g>>2]|0)+8>>2]|0)+16+16+8|0;h[k>>3]=+h[k>>3]*+h[l>>3];i=f;return}function ui(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;e=i;i=i+64|0;f=e+40|0;g=e+32|0;j=e+24|0;k=e+8|0;l=e+48|0;m=e+44|0;n=e;c[l>>2]=b;c[m>>2]=d;h[n>>3]=(+h[(c[(c[l>>2]|0)+8>>2]|0)+16+16>>3]-+h[(c[(c[l>>2]|0)+8>>2]|0)+16>>3])/(+h[(c[(c[l>>2]|0)+8>>2]|0)+16+16+8>>3]-+h[(c[(c[l>>2]|0)+8>>2]|0)+16+8>>3]);if(a[138998]|0){d=c[24742]|0;o=(+h[(c[(c[l>>2]|0)+8>>2]|0)+16+16>>3]-+h[(c[(c[l>>2]|0)+8>>2]|0)+16>>3])*(+h[(c[(c[l>>2]|0)+8>>2]|0)+16+16+8>>3]-+h[(c[(c[l>>2]|0)+8>>2]|0)+16+8>>3])/1.0e4;h[k>>3]=+h[n>>3];h[k+8>>3]=o;Y2(d,123852,k)|0;k=c[24742]|0;c[j>>2]=Uj(c[l>>2]|0)|0;Y2(k,123877,j)|0}do if(!(+h[n>>3]>+h[c[m>>2]>>3]*1.1)){j=(c[m>>2]|0)+24|0;if(!(+h[n>>3]<=+h[c[m>>2]>>3]*.8)){c[j>>2]=0;break}c[j>>2]=-1;if(a[138998]|0)Y2(c[24742]|0,123887,g)|0}else c[(c[m>>2]|0)+24>>2]=~~(+h[c[m>>2]>>3]*+((c[(c[m>>2]|0)+20>>2]|0)-(c[(c[m>>2]|0)+16>>2]|0)|0)/+h[n>>3]);while(0);if(!(a[138998]|0)){i=e;return}n=c[24742]|0;c[f>>2]=c[(c[m>>2]|0)+24>>2];Y2(n,123922,f)|0;i=e;return}function vi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]-+h[d>>3];h[f+8>>3]=+h[b+8>>3]-+h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function wi(d,e){d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+80|0;g=f+68|0;j=f+64|0;k=f+60|0;l=f+56|0;m=f+40|0;n=f+32|0;o=f+52|0;p=f+16|0;q=f;r=f+48|0;c[g>>2]=d;c[j>>2]=e;e=c[g>>2]|0;a:do if((e|0)==(uf(c[g>>2]|0)|0)){h[p>>3]=2147483647.0;h[q>>3]=-2147483647.0;c[k>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[k>>2]|0)>(b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0))break;c[r>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2];if((c[r>>2]|0)!=0?(d=c[c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]>>2]|0,c[o>>2]=d,(d|0)!=0):0){c[l>>2]=1;while(1){if(!(a[(c[(c[o>>2]|0)+8>>2]|0)+156>>0]|0))break;if((c[l>>2]|0)>=(c[r>>2]|0))break;c[o>>2]=c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+(c[l>>2]<<2)>>2];c[l>>2]=(c[l>>2]|0)+1}if(!(a[(c[(c[o>>2]|0)+8>>2]|0)+156>>0]|0)){h[m>>3]=+h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[o>>2]|0)+8>>2]|0)+88>>3];h[p>>3]=+h[p>>3]<+h[m>>3]?+h[p>>3]:+h[m>>3];c[o>>2]=c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+((c[r>>2]|0)-1<<2)>>2];c[l>>2]=(c[r>>2]|0)-2;while(1){if(!(a[(c[(c[o>>2]|0)+8>>2]|0)+156>>0]|0))break;c[o>>2]=c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]|0)+(c[l>>2]<<2)>>2];c[l>>2]=(c[l>>2]|0)+-1}h[m>>3]=+h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[o>>2]|0)+8>>2]|0)+96>>3];h[q>>3]=+h[q>>3]>+h[m>>3]?+h[q>>3]:+h[m>>3]}}c[k>>2]=(c[k>>2]|0)+1}h[n>>3]=8.0;c[l>>2]=1;while(1){if((c[l>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break a;h[m>>3]=+h[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[l>>2]<<2)>>2]|0)+8>>2]|0)+16>>3]-+h[n>>3];h[p>>3]=+h[p>>3]<+h[m>>3]?+h[p>>3]:+h[m>>3];h[m>>3]=+h[(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[l>>2]<<2)>>2]|0)+8>>2]|0)+16+16>>3]+ +h[n>>3];h[q>>3]=+h[q>>3]>+h[m>>3]?+h[q>>3]:+h[m>>3];c[l>>2]=(c[l>>2]|0)+1}}else{h[p>>3]=+(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+256>>2]|0)+8>>2]|0)+232>>2]|0);h[q>>3]=+(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+260>>2]|0)+8>>2]|0)+232>>2]|0)}while(0);h[p+8>>3]=+h[(c[(c[c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+120>>3];h[q+8>>3]=+h[(c[(c[c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+128>>3];j=(c[(c[g>>2]|0)+8>>2]|0)+16|0;c[j>>2]=c[p>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];p=(c[(c[g>>2]|0)+8>>2]|0)+16+16|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2];i=f;return}function xi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[h>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[h>>2]|0))break;d=(c[(c[h>>2]|0)+8>>2]|0)+248|0;a=(c[(c[h>>2]|0)+8>>2]|0)+172|0;c[d>>2]=c[a>>2];c[d+4>>2]=c[a+4>>2];a=(c[(c[h>>2]|0)+8>>2]|0)+256|0;d=(c[(c[h>>2]|0)+8>>2]|0)+180|0;c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[e>>2]=0;while(1){if(!(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+180>>2]|0)+(c[e>>2]<<2)>>2]|0))break;c[e>>2]=(c[e>>2]|0)+1}c[f>>2]=0;while(1){if(!(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]|0)+(c[f>>2]<<2)>>2]|0))break;c[f>>2]=(c[f>>2]|0)+1}c[g>>2]=(c[e>>2]|0)+(c[f>>2]|0);c[(c[(c[h>>2]|0)+8>>2]|0)+172+4>>2]=0;d=bK((c[g>>2]|0)+3+1<<2)|0;c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]=d;c[(c[(c[h>>2]|0)+8>>2]|0)+180+4>>2]=0;d=bK(16)|0;c[(c[(c[h>>2]|0)+8>>2]|0)+180>>2]=d;c[h>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+164>>2]}i=b;return}function yi(a){a=a|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0,H=0;f=i;i=i+96|0;g=f+88|0;j=f+84|0;k=f+80|0;l=f+76|0;m=f+72|0;n=f+68|0;o=f+64|0;p=f+8|0;q=f+56|0;r=f+52|0;s=f+48|0;t=f+44|0;u=f+40|0;v=f+36|0;w=f+32|0;x=f+28|0;y=f+24|0;z=f+20|0;A=f+16|0;B=f;c[g>>2]=a;c[A>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2];a=(d[(c[(c[g>>2]|0)+8>>2]|0)+113>>0]&1|0)!=0;C=c[(c[(c[g>>2]|0)+8>>2]|0)+248>>2]|0;c[q>>2]=C;D=q+4|0;if(a)c[D>>2]=5;else c[D>>2]=C;c[j>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0))break;c[(c[(c[c[(c[A>>2]|0)+(c[j>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+232>>2]=0;h[B>>3]=0.0;c[r>>2]=c[q+((c[j>>2]&1)<<2)>>2];c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[A>>2]|0)+(c[j>>2]<<6)>>2]|0))break;c[w>>2]=c[(c[(c[A>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[k>>2]<<2)>>2];h[(c[(c[w>>2]|0)+8>>2]|0)+240>>3]=+h[(c[(c[w>>2]|0)+8>>2]|0)+96>>3];if((c[(c[(c[w>>2]|0)+8>>2]|0)+204+4>>2]|0)>0){c[m>>2]=0;c[l>>2]=0;while(1){C=c[(c[(c[(c[w>>2]|0)+8>>2]|0)+204>>2]|0)+(c[l>>2]<<2)>>2]|0;c[s>>2]=C;if(!C)break;C=c[s>>2]|0;D=c[s>>2]|0;if((c[((c[c[s>>2]>>2]&3|0)==3?C:C+32|0)+28>>2]|0)==(c[((c[c[s>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2]|0)){D=nN(c[s>>2]|0)|0;c[m>>2]=(c[m>>2]|0)+D}c[l>>2]=(c[l>>2]|0)+1}D=(c[(c[w>>2]|0)+8>>2]|0)+96|0;h[D>>3]=+h[D>>3]+ +(c[m>>2]|0)}c[x>>2]=c[(c[(c[A>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+((c[k>>2]|0)+1<<2)>>2];if(c[x>>2]|0){h[p>>3]=+h[(c[(c[w>>2]|0)+8>>2]|0)+96>>3]+ +h[(c[(c[x>>2]|0)+8>>2]|0)+88>>3]+ +(c[r>>2]|0);c[t>>2]=gi(c[w>>2]|0,c[x>>2]|0,+h[p>>3],0)|0;D=~~(+h[B>>3]+ +h[p>>3]);c[(c[(c[x>>2]|0)+8>>2]|0)+232>>2]=D;h[B>>3]=+(D|0)}D=c[(c[(c[w>>2]|0)+8>>2]|0)+112>>2]|0;c[s>>2]=D;if(D){c[t>>2]=c[c[(c[(c[w>>2]|0)+8>>2]|0)+256>>2]>>2];c[u>>2]=c[(c[(c[(c[w>>2]|0)+8>>2]|0)+256>>2]|0)+4>>2];D=c[t>>2]|0;C=c[u>>2]|0;if((c[(c[(c[((c[c[t>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)>(c[(c[(c[((c[c[u>>2]>>2]&3|0)==2?C:C+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)){c[v>>2]=c[t>>2];c[t>>2]=c[u>>2];c[u>>2]=c[v>>2]}c[n>>2]=(_(e[(c[(c[s>>2]|0)+8>>2]|0)+170>>1]|0,c[(c[(c[g>>2]|0)+8>>2]|0)+248>>2]|0)|0)/2|0;C=c[t>>2]|0;D=c[t>>2]|0;c[o>>2]=~~(+(c[n>>2]|0)+ +h[(c[(c[((c[c[t>>2]>>2]&3|0)==2?C:C+-32|0)+28>>2]|0)+8>>2]|0)+96>>3]+ +h[(c[(c[((c[c[t>>2]>>2]&3|0)==3?D:D+32|0)+28>>2]|0)+8>>2]|0)+88>>3]);D=c[t>>2]|0;C=c[t>>2]|0;if(!(Ji(c[((c[c[t>>2]>>2]&3|0)==3?D:D+32|0)+28>>2]|0,c[((c[c[t>>2]>>2]&3|0)==2?C:C+-32|0)+28>>2]|0)|0)){C=c[t>>2]|0;D=c[t>>2]|0;gi(c[((c[c[t>>2]>>2]&3|0)==2?C:C+-32|0)+28>>2]|0,c[((c[c[t>>2]>>2]&3|0)==3?D:D+32|0)+28>>2]|0,+(c[o>>2]|0),c[(c[(c[s>>2]|0)+8>>2]|0)+156>>2]|0)|0}D=c[u>>2]|0;C=c[u>>2]|0;c[o>>2]=~~(+(c[n>>2]|0)+ +h[(c[(c[((c[c[u>>2]>>2]&3|0)==3?D:D+32|0)+28>>2]|0)+8>>2]|0)+96>>3]+ +h[(c[(c[((c[c[u>>2]>>2]&3|0)==2?C:C+-32|0)+28>>2]|0)+8>>2]|0)+88>>3]);C=c[u>>2]|0;D=c[u>>2]|0;if(!(Ji(c[((c[c[u>>2]>>2]&3|0)==2?C:C+-32|0)+28>>2]|0,c[((c[c[u>>2]>>2]&3|0)==3?D:D+32|0)+28>>2]|0)|0)){D=c[u>>2]|0;C=c[u>>2]|0;gi(c[((c[c[u>>2]>>2]&3|0)==3?D:D+32|0)+28>>2]|0,c[((c[c[u>>2]>>2]&3|0)==2?C:C+-32|0)+28>>2]|0,+(c[o>>2]|0),c[(c[(c[s>>2]|0)+8>>2]|0)+156>>2]|0)|0}}c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[(c[w>>2]|0)+8>>2]|0)+188+4>>2]|0))break;c[s>>2]=c[(c[(c[(c[w>>2]|0)+8>>2]|0)+188>>2]|0)+(c[l>>2]<<2)>>2];C=c[s>>2]|0;D=c[s>>2]|0;a=c[c[s>>2]>>2]&3;if((c[(c[(c[((c[c[s>>2]>>2]&3|0)==3?C:C+32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)<(c[(c[(c[((c[c[s>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)){D=c[s>>2]|0;c[y>>2]=c[((a|0)==3?D:D+32|0)+28>>2];D=c[s>>2]|0;c[z>>2]=c[((c[c[s>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2]}else{D=c[s>>2]|0;c[y>>2]=c[((a|0)==2?D:D+-32|0)+28>>2];D=c[s>>2]|0;c[z>>2]=c[((c[c[s>>2]>>2]&3|0)==3?D:D+32|0)+28>>2]}h[p>>3]=+h[(c[(c[y>>2]|0)+8>>2]|0)+96>>3]+ +h[(c[(c[z>>2]|0)+8>>2]|0)+88>>3];E=+(_(e[(c[(c[s>>2]|0)+8>>2]|0)+170>>1]|0,c[(c[(c[g>>2]|0)+8>>2]|0)+248>>2]|0)|0);c[n>>2]=~~(E+ +h[p>>3]);D=Gg(c[y>>2]|0,c[z>>2]|0)|0;c[t>>2]=D;if(!D){if(!(c[(c[(c[s>>2]|0)+8>>2]|0)+96>>2]|0))gi(c[y>>2]|0,c[z>>2]|0,+(c[n>>2]|0),c[(c[(c[s>>2]|0)+8>>2]|0)+156>>2]|0)|0}else{E=+h[(c[(c[s>>2]|0)+8>>2]|0)+136>>3];if(+(c[n>>2]|0)>+h[p>>3]+ +(c[(c[(c[g>>2]|0)+8>>2]|0)+248>>2]|0)+ +(~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+136>>3]>=0.0?E+.5:E-.5)|0))F=+(c[n>>2]|0);else{E=+h[(c[(c[s>>2]|0)+8>>2]|0)+136>>3];F=+h[p>>3]+ +(c[(c[(c[g>>2]|0)+8>>2]|0)+248>>2]|0)+ +(~~(+h[(c[(c[s>>2]|0)+8>>2]|0)+136>>3]>=0.0?E+.5:E-.5)|0)}c[n>>2]=~~F;if((c[n>>2]|0)>65535)c[n>>2]=~~+qi(+(c[n>>2]|0));if((e[(c[(c[t>>2]|0)+8>>2]|0)+170>>1]|0)>(c[n>>2]|0))G=e[(c[(c[t>>2]|0)+8>>2]|0)+170>>1]|0;else G=c[n>>2]|0;b[(c[(c[t>>2]|0)+8>>2]|0)+170>>1]=G;if((c[(c[(c[t>>2]|0)+8>>2]|0)+156>>2]|0)>(c[(c[(c[s>>2]|0)+8>>2]|0)+156>>2]|0))H=c[(c[(c[t>>2]|0)+8>>2]|0)+156>>2]|0;else H=c[(c[(c[s>>2]|0)+8>>2]|0)+156>>2]|0;c[(c[(c[t>>2]|0)+8>>2]|0)+156>>2]=H}c[l>>2]=(c[l>>2]|0)+1}c[k>>2]=(c[k>>2]|0)+1}c[j>>2]=(c[j>>2]|0)+1}i=f;return}function zi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[e>>2]=b;c[k>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[k>>2]|0))break;a:do if(c[(c[(c[k>>2]|0)+8>>2]|0)+256>>2]|0){c[f>>2]=0;while(1){b=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+256>>2]|0)+(c[f>>2]<<2)>>2]|0;c[m>>2]=b;if(!b)break a;c[l>>2]=Sg(c[e>>2]|0)|0;a[(c[(c[l>>2]|0)+8>>2]|0)+156>>0]=2;c[g>>2]=~~(+h[(c[(c[m>>2]|0)+8>>2]|0)+56>>3]-+h[(c[(c[m>>2]|0)+8>>2]|0)+16>>3]);if((c[g>>2]|0)>0)c[j>>2]=0;else{c[j>>2]=0-(c[g>>2]|0);c[g>>2]=0}b=c[m>>2]|0;gi(c[l>>2]|0,c[((c[c[m>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0,+((c[g>>2]|0)+1|0),c[(c[(c[m>>2]|0)+8>>2]|0)+156>>2]|0)|0;b=c[m>>2]|0;gi(c[l>>2]|0,c[((c[c[m>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,+((c[j>>2]|0)+1|0),c[(c[(c[m>>2]|0)+8>>2]|0)+156>>2]|0)|0;b=c[m>>2]|0;n=c[m>>2]|0;o=c[c[m>>2]>>2]&3;if(((c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[g>>2]|0)-1|0)<((c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[j>>2]|0)-1|0)){n=c[m>>2]|0;p=(c[(c[(c[((o|0)==3?n:n+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[g>>2]|0)|0}else{n=c[m>>2]|0;p=(c[(c[(c[((o|0)==2?n:n+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[j>>2]|0)|0}c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]=p-1;c[f>>2]=(c[f>>2]|0)+1}}while(0);c[k>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2]}i=d;return}function Ai(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0)<=0){i=b;return}Ei(c[d>>2]|0);Fi(c[d>>2]|0);Gi(c[d>>2]|0);Hi(c[d>>2]|0);i=b;return}function Bi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+32|0;d=b+24|0;e=b+16|0;f=b;c[d>>2]=a;if((c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]|0)!=3){i=b;return}a=(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+64|0;c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];if(+h[f>>3]*+h[f+8>>3]<=1.0){i=b;return}Ci(c[d>>2]|0);if(!(c[(c[(c[d>>2]|0)+8>>2]|0)+116>>2]&1))h[e>>3]=+h[f>>3];else h[e>>3]=+h[f+8>>3];h[e>>3]=+h[e>>3]<65535.0?+h[e>>3]:65535.0;gi(c[(c[(c[d>>2]|0)+8>>2]|0)+256>>2]|0,c[(c[(c[d>>2]|0)+8>>2]|0)+260>>2]|0,+h[e>>3],1e3)|0;i=b;return}function Ci(a){a=a|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d;f=d+28|0;g=d+24|0;j=d+20|0;k=d+16|0;l=d+12|0;m=d+8|0;c[f>>2]=a;c[g>>2]=eO(c[f>>2]|0,c[13813]|0,8,0)|0;Di(c[f>>2]|0);c[k>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+256>>2];c[l>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+260>>2];c[j>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;do if(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0){c[m>>2]=c[c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]>>2];if(!(c[m>>2]|0)){a=wB(c[f>>2]|0)|0;n=c[j>>2]|0;c[e>>2]=a;c[e+4>>2]=n;$z(1,123960,e)|0;break}else{gi(c[k>>2]|0,c[m>>2]|0,+h[(c[(c[m>>2]|0)+8>>2]|0)+88>>3]+ +(c[g>>2]|0)+ +h[(c[(c[f>>2]|0)+8>>2]|0)+48+48>>3],0)|0;c[m>>2]=c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+((c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0)-1<<2)>>2];gi(c[m>>2]|0,c[l>>2]|0,+h[(c[(c[m>>2]|0)+8>>2]|0)+96>>3]+ +(c[g>>2]|0)+ +h[(c[(c[f>>2]|0)+8>>2]|0)+48+16>>3],0)|0;break}}while(0);c[j>>2]=(c[j>>2]|0)+1}i=d;return}function Di(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[e>>2]=b;if(c[(c[(c[e>>2]|0)+8>>2]|0)+256>>2]|0){i=d;return}c[f>>2]=Sg(uf(c[e>>2]|0)|0)|0;a[(c[(c[f>>2]|0)+8>>2]|0)+156>>0]=2;c[g>>2]=Sg(uf(c[e>>2]|0)|0)|0;a[(c[(c[g>>2]|0)+8>>2]|0)+156>>0]=2;if(((c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)!=0?(b=c[e>>2]|0,(b|0)!=(uf(c[e>>2]|0)|0)):0)?(c[(c[(rC(c[e>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)==0:0){b=(c[(c[e>>2]|0)+8>>2]|0)+48|0;if(+h[(c[(c[e>>2]|0)+8>>2]|0)+48>>3]>+h[(c[(c[e>>2]|0)+8>>2]|0)+48+32>>3])k=+h[b>>3];else k=+h[b+32>>3];c[j>>2]=~~k;gi(c[f>>2]|0,c[g>>2]|0,+(c[j>>2]|0),0)|0}c[(c[(c[e>>2]|0)+8>>2]|0)+256>>2]=c[f>>2];c[(c[(c[e>>2]|0)+8>>2]|0)+260>>2]=c[g>>2];i=d;return}function Ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;a=c[d>>2]|0;do if((a|0)!=(uf(c[d>>2]|0)|0)){Ci(c[d>>2]|0);g=Gg(c[(c[(c[d>>2]|0)+8>>2]|0)+256>>2]|0,c[(c[(c[d>>2]|0)+8>>2]|0)+260>>2]|0)|0;c[f>>2]=g;if(g){g=(c[(c[f>>2]|0)+8>>2]|0)+156|0;c[g>>2]=(c[g>>2]|0)+128;break}else{gi(c[(c[(c[d>>2]|0)+8>>2]|0)+256>>2]|0,c[(c[(c[d>>2]|0)+8>>2]|0)+260>>2]|0,1.0,128)|0;break}}while(0);c[e>>2]=1;while(1){if((c[e>>2]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0))break;Ei(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+184>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}i=b;return}function Fi(d){d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=d;c[l>>2]=eO(c[f>>2]|0,c[13813]|0,8,0)|0;c[k>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[k>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;a:do if((c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0)!=0?(c[n>>2]=c[c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)+4>>2]>>2],(c[n>>2]|0)!=0):0){c[g>>2]=(c[(c[(c[n>>2]|0)+8>>2]|0)+236>>2]|0)-1;while(1){if((c[g>>2]|0)<0)break;d=c[g>>2]|0;o=c[k>>2]|0;c[m>>2]=c[(c[(c[(c[(uf(c[f>>2]|0)|0)+8>>2]|0)+196>>2]|0)+(o<<6)+4>>2]|0)+(d<<2)>>2];if(!(a[(c[(c[m>>2]|0)+8>>2]|0)+156>>0]|0)){p=9;break}if(Ii(c[f>>2]|0,c[m>>2]|0)|0){p=9;break}c[g>>2]=(c[g>>2]|0)+-1}if((p|0)==9){p=0;gi(c[m>>2]|0,c[(c[(c[f>>2]|0)+8>>2]|0)+256>>2]|0,+(c[l>>2]|0)+ +h[(c[(c[m>>2]|0)+8>>2]|0)+96>>3],0)|0}c[g>>2]=(c[(c[(c[n>>2]|0)+8>>2]|0)+236>>2]|0)+(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[k>>2]<<6)>>2]|0);while(1){d=c[g>>2]|0;o=c[k>>2]|0;if((d|0)>=(c[(c[(c[(uf(c[f>>2]|0)|0)+8>>2]|0)+196>>2]|0)+(o<<6)>>2]|0))break a;o=c[g>>2]|0;d=c[k>>2]|0;c[m>>2]=c[(c[(c[(c[(uf(c[f>>2]|0)|0)+8>>2]|0)+196>>2]|0)+(d<<6)+4>>2]|0)+(o<<2)>>2];if(!(a[(c[(c[m>>2]|0)+8>>2]|0)+156>>0]|0))break;if(Ii(c[f>>2]|0,c[m>>2]|0)|0)break;c[g>>2]=(c[g>>2]|0)+1}gi(c[(c[(c[f>>2]|0)+8>>2]|0)+260>>2]|0,c[m>>2]|0,+(c[l>>2]|0)+ +h[(c[(c[m>>2]|0)+8>>2]|0)+88>>3],0)|0}while(0);c[k>>2]=(c[k>>2]|0)+1}c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;Fi(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2]|0);c[j>>2]=(c[j>>2]|0)+1}i=e;return}function Gi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=eO(c[d>>2]|0,c[13813]|0,8,0)|0;Di(c[d>>2]|0);c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0))break;c[g>>2]=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2];Di(c[g>>2]|0);gi(c[(c[(c[d>>2]|0)+8>>2]|0)+256>>2]|0,c[(c[(c[g>>2]|0)+8>>2]|0)+256>>2]|0,+(c[e>>2]|0)+ +h[(c[(c[d>>2]|0)+8>>2]|0)+48+48>>3],0)|0;gi(c[(c[(c[g>>2]|0)+8>>2]|0)+260>>2]|0,c[(c[(c[d>>2]|0)+8>>2]|0)+260>>2]|0,+(c[e>>2]|0)+ +h[(c[(c[d>>2]|0)+8>>2]|0)+48+16>>3],0)|0;Gi(c[g>>2]|0);c[f>>2]=(c[f>>2]|0)+1}i=b;return}function Hi(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[e>>2]=a;c[h>>2]=eO(c[e>>2]|0,c[13813]|0,8,0)|0;c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;Di(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2]|0);c[f>>2]=(c[f>>2]|0)+1}c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;c[g>>2]=(c[f>>2]|0)+1;while(1){o=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2]|0;if((c[g>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;c[j>>2]=o;c[k>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[g>>2]<<2)>>2];if((b[(c[(c[j>>2]|0)+8>>2]|0)+236>>1]|0)>(b[(c[(c[k>>2]|0)+8>>2]|0)+236>>1]|0)){c[n>>2]=c[j>>2];c[j>>2]=c[k>>2];c[k>>2]=c[n>>2]}if((b[(c[(c[j>>2]|0)+8>>2]|0)+238>>1]|0)>=(b[(c[(c[k>>2]|0)+8>>2]|0)+236>>1]|0)){if((c[(c[(c[c[(c[(c[(c[j>>2]|0)+8>>2]|0)+196>>2]|0)+(b[(c[(c[k>>2]|0)+8>>2]|0)+236>>1]<<6)+4>>2]>>2]|0)+8>>2]|0)+236>>2]|0)<(c[(c[(c[c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(b[(c[(c[k>>2]|0)+8>>2]|0)+236>>1]<<6)+4>>2]>>2]|0)+8>>2]|0)+236>>2]|0)){c[l>>2]=c[j>>2];c[m>>2]=c[k>>2]}else{c[l>>2]=c[k>>2];c[m>>2]=c[j>>2]}gi(c[(c[(c[l>>2]|0)+8>>2]|0)+260>>2]|0,c[(c[(c[m>>2]|0)+8>>2]|0)+256>>2]|0,+(c[h>>2]|0),0)|0}c[g>>2]=(c[g>>2]|0)+1}Hi(o);c[f>>2]=(c[f>>2]|0)+1}i=d;return}function Ii(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[g>>2]=b;c[h>>2]=d;if((a[(c[(c[h>>2]|0)+8>>2]|0)+156>>0]|0)!=1){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}c[j>>2]=c[c[(c[(c[h>>2]|0)+8>>2]|0)+256>>2]>>2];while(1){if(!(c[(c[(c[j>>2]|0)+8>>2]|0)+116>>2]|0))break;c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+116>>2]}h=c[j>>2]|0;if(AC(c[g>>2]|0,c[((c[c[j>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)|0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}h=c[j>>2]|0;if(AC(c[g>>2]|0,c[((c[c[j>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)|0){c[f>>2]=0;k=c[f>>2]|0;i=e;return k|0}else{c[f>>2]=1;k=c[f>>2]|0;i=e;return k|0}return 0}function Ji(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=Ki(c[e>>2]|0,c[f>>2]|0)|0;i=d;return b|0}function Ki(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[f>>2]=a;c[g>>2]=b;if((c[f>>2]|0)==(c[g>>2]|0)){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}c[h>>2]=0;while(1){b=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0)+(c[h>>2]<<2)>>2]|0;c[j>>2]=b;if(!b){l=8;break}b=c[j>>2]|0;if(Ki(c[((c[c[j>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,c[g>>2]|0)|0){l=6;break}c[h>>2]=(c[h>>2]|0)+1}if((l|0)==6){c[e>>2]=1;k=c[e>>2]|0;i=d;return k|0}else if((l|0)==8){c[e>>2]=0;k=c[e>>2]|0;i=d;return k|0}return 0}function Li(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=d;c[j>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;c[h>>2]=0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;c[k>>2]=c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2];c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]=c[h>>2];d=c[h>>2]|0;if((a[(c[(c[k>>2]|0)+8>>2]|0)+159>>0]|0)==6)c[h>>2]=d+(c[(c[(c[k>>2]|0)+8>>2]|0)+216>>2]|0);else c[h>>2]=d+1;c[g>>2]=(c[g>>2]|0)+1}if((c[h>>2]|0)>(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0)){if(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)l=eK(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0,(c[h>>2]|0)+1<<2)|0;else l=cK((c[h>>2]|0)+1<<2)|0;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]=l;c[g>>2]=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0)-1;while(1){if((c[g>>2]|0)<0)break;c[k>>2]=c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2];c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]<<2)>>2]=c[k>>2];c[g>>2]=(c[g>>2]|0)+-1}c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]=c[h>>2];c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[h>>2]<<2)>>2]=0}c[j>>2]=(c[j>>2]|0)+1}i=e;return}function Mi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+80|0;e=d+64|0;f=d+56|0;g=d+52|0;j=d+48|0;k=d+40|0;l=d+36|0;m=d+32|0;n=d+24|0;o=d+16|0;p=d+8|0;q=d;c[f>>2]=a;c[g>>2]=b;if((c[(c[(c[g>>2]|0)+8>>2]|0)+216>>2]|0)<=1){i=d;return}c[k>>2]=~~(+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+88>>3]);c[k+4>>2]=~~+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];b=c[g>>2]|0;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Ni(n,b,e);c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];n=c[(c[g>>2]|0)+8>>2]|0;if((c[(c[(c[g>>2]|0)+8>>2]|0)+180+4>>2]|0)>0){b=c[c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]>>2]|0;c[l>>2]=c[((c[c[c[n+180>>2]>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];c[j>>2]=(c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]|0)+1;c[m>>2]=RA(c[f>>2]|0,c[l>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;b=c[m>>2]|0;c[o>>2]=(c[c[m>>2]>>2]&3|0)==2?b:b+-32|0;b=c[o>>2]|0;if((c[((c[c[o>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)!=(c[g>>2]|0)?(b=c[o>>2]|0,a=lO(c[((c[c[o>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0,(a|0)==(c[g>>2]|0)):0){a=c[f>>2]|0;b=c[o>>2]|0;r=c[((c[c[o>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0;b=c[j>>2]|0;c[j>>2]=b+1;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Oi(p,a,r,e,b);c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];Wg(c[o>>2]|0);b=c[o>>2]|0;r=(c[(c[((c[c[o>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+172|0;if(c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?c[o>>2]|0:(c[o>>2]|0)+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0){b=c[o>>2]|0;s=eK(c[r>>2]|0,(c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]|0)+2<<2)|0}else s=cK((c[r+4>>2]|0)+2<<2)|0;r=c[o>>2]|0;c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]=s;r=c[o>>2]|0;b=c[o>>2]|0;a=(c[(c[((c[c[o>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+172+4|0;b=c[a>>2]|0;c[a>>2]=b+1;a=c[o>>2]|0;c[(c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(b<<2)>>2]=r;r=c[o>>2]|0;b=c[o>>2]|0;c[(c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(c[(c[(c[((c[c[o>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]<<2)>>2]=0}c[m>>2]=SA(c[f>>2]|0,c[m>>2]|0)|0}i=d;return}else{o=c[c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]>>2]|0;c[l>>2]=c[((c[c[c[n+172>>2]>>2]>>2]&3|0)==3?o:o+32|0)+28>>2];c[j>>2]=(c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]|0)+1;c[m>>2]=OA(c[f>>2]|0,c[l>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;l=c[m>>2]|0;if((c[((c[c[m>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)!=(c[g>>2]|0)?(l=c[m>>2]|0,o=lO(c[((c[c[m>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)|0,(o|0)==(c[g>>2]|0)):0){o=c[f>>2]|0;l=c[m>>2]|0;n=c[((c[c[m>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0;l=c[j>>2]|0;c[j>>2]=l+1;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Oi(q,o,n,e,l);c[k>>2]=c[q>>2];c[k+4>>2]=c[q+4>>2];Wg(c[m>>2]|0);l=c[m>>2]|0;n=(c[(c[((c[c[m>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+180|0;if(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?c[m>>2]|0:(c[m>>2]|0)+32|0)+28>>2]|0)+8>>2]|0)+180>>2]|0){l=c[m>>2]|0;t=eK(c[n>>2]|0,(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+180+4>>2]|0)+2<<2)|0}else t=cK((c[n+4>>2]|0)+2<<2)|0;n=c[m>>2]|0;c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?n:n+32|0)+28>>2]|0)+8>>2]|0)+180>>2]=t;n=c[m>>2]|0;l=c[m>>2]|0;o=(c[(c[((c[c[m>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+180+4|0;l=c[o>>2]|0;c[o>>2]=l+1;o=c[m>>2]|0;c[(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?o:o+32|0)+28>>2]|0)+8>>2]|0)+180>>2]|0)+(l<<2)>>2]=n;n=c[m>>2]|0;l=c[m>>2]|0;c[(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+180>>2]|0)+(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?n:n+32|0)+28>>2]|0)+8>>2]|0)+180+4>>2]<<2)>>2]=0}c[m>>2]=QA(c[f>>2]|0,c[m>>2]|0)|0}i=d;return}}function Ni(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0;e=i;i=i+16|0;f=e;c[f>>2]=b;b=c[f>>2]|0;VO(b,c[(c[(qC(c[f>>2]|0)|0)+8>>2]|0)+116>>2]&1);h[(c[(c[f>>2]|0)+8>>2]|0)+16+8>>3]=+(c[d+4>>2]|0);h[(c[(c[f>>2]|0)+8>>2]|0)+16>>3]=+(c[d>>2]|0)+ +h[(c[(c[f>>2]|0)+8>>2]|0)+88>>3];g=+(c[d>>2]|0)+ +h[(c[(c[f>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[f>>2]|0)+8>>2]|0)+96>>3];c[d>>2]=~~(g+ +(c[(c[(qC(c[f>>2]|0)|0)+8>>2]|0)+248>>2]|0));c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];i=e;return}function Oi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+24|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=f;c[n>>2]=uf(c[j>>2]|0)|0;c[m>>2]=lO(c[k>>2]|0)|0;if((c[k>>2]|0)!=(c[m>>2]|0))Qg(c[m>>2]|0,c[k>>2]|0);c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]=c[l>>2];c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]=c[(c[(c[m>>2]|0)+8>>2]|0)+232>>2];c[(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]<<6)+4>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+236>>2]<<2)>>2]=c[k>>2];n=c[k>>2]|0;c[h>>2]=c[e>>2];c[h+4>>2]=c[e+4>>2];Ni(a,n,h);i=g;return}function Pi(a){a=a|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0,r=0.0,s=0.0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+8|0;j=d;k=d+28|0;l=d+24|0;m=d+20|0;n=d+16|0;c[e>>2]=a;c[l>>2]=c[(c[(uf(c[e>>2]|0)|0)+8>>2]|0)+196>>2];c[n>>2]=0;a=c[e>>2]|0;if((a|0)==(uf(c[e>>2]|0)|0))c[m>>2]=8;else c[m>>2]=eO(c[e>>2]|0,c[13813]|0,8,0)|0;h[g>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+120>>3];h[j>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+128>>3];c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;c[k>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2];a=Pi(c[k>>2]|0)|0;c[n>>2]=c[n>>2]|a;if((b[(c[(c[k>>2]|0)+8>>2]|0)+238>>1]|0)==(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0)){if(+h[g>>3]>+h[(c[(c[k>>2]|0)+8>>2]|0)+120>>3]+ +(c[m>>2]|0))o=+h[g>>3];else o=+h[(c[(c[k>>2]|0)+8>>2]|0)+120>>3]+ +(c[m>>2]|0);h[g>>3]=o}if((b[(c[(c[k>>2]|0)+8>>2]|0)+236>>1]|0)==(b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]|0)){if(+h[j>>3]>+h[(c[(c[k>>2]|0)+8>>2]|0)+128>>3]+ +(c[m>>2]|0))p=+h[j>>3];else p=+h[(c[(c[k>>2]|0)+8>>2]|0)+128>>3]+ +(c[m>>2]|0);h[j>>3]=p}c[f>>2]=(c[f>>2]|0)+1}f=c[e>>2]|0;if(((f|0)!=(uf(c[e>>2]|0)|0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0)?(c[n>>2]=1,(c[(c[(rC(c[e>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)==0):0){h[g>>3]=+h[g>>3]+ +h[(c[(c[e>>2]|0)+8>>2]|0)+48+8>>3];h[j>>3]=+h[j>>3]+ +h[(c[(c[e>>2]|0)+8>>2]|0)+48+32+8>>3]}h[(c[(c[e>>2]|0)+8>>2]|0)+120>>3]=+h[g>>3];h[(c[(c[e>>2]|0)+8>>2]|0)+128>>3]=+h[j>>3];f=c[e>>2]|0;if((f|0)==(uf(c[e>>2]|0)|0)){q=c[n>>2]|0;i=d;return q|0}if(+h[(c[l>>2]|0)+(b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]<<6)+24>>3]>+h[j>>3])r=+h[(c[l>>2]|0)+(b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]<<6)+24>>3];else r=+h[j>>3];h[(c[l>>2]|0)+(b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]<<6)+24>>3]=r;if(+h[(c[l>>2]|0)+(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]<<6)+16>>3]>+h[g>>3])s=+h[(c[l>>2]|0)+(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]<<6)+16>>3];else s=+h[g>>3];h[(c[l>>2]|0)+(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]<<6)+16>>3]=s;q=c[n>>2]|0;i=d;return q|0}function Qi(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0;e=i;i=i+80|0;f=e+68|0;g=e+64|0;j=e+32|0;k=e+24|0;l=e+60|0;m=e+56|0;n=e+52|0;o=e+48|0;p=e+16|0;q=e+8|0;r=e;s=e+44|0;t=e+40|0;c[f>>2]=a;c[g>>2]=d;c[s>>2]=c[(c[(uf(c[f>>2]|0)|0)+8>>2]|0)+196>>2];d=c[f>>2]|0;if((d|0)==(uf(c[f>>2]|0)|0))c[n>>2]=0;else c[n>>2]=eO(c[f>>2]|0,c[13813]|0,8,0)|0;h[q>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+120>>3];h[r>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+128>>3];c[o>>2]=1;while(1){if((c[o>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;c[t>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[o>>2]<<2)>>2];Qi(c[t>>2]|0,(c[n>>2]|0)+(c[g>>2]|0)|0);if((b[(c[(c[t>>2]|0)+8>>2]|0)+238>>1]|0)==(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0)){if(+h[q>>3]>+h[(c[(c[t>>2]|0)+8>>2]|0)+120>>3]+ +(c[n>>2]|0))u=+h[q>>3];else u=+h[(c[(c[t>>2]|0)+8>>2]|0)+120>>3]+ +(c[n>>2]|0);h[q>>3]=u}if((b[(c[(c[t>>2]|0)+8>>2]|0)+236>>1]|0)==(b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0)){if(+h[r>>3]>+h[(c[(c[t>>2]|0)+8>>2]|0)+128>>3]+ +(c[n>>2]|0))v=+h[r>>3];else v=+h[(c[(c[t>>2]|0)+8>>2]|0)+128>>3]+ +(c[n>>2]|0);h[r>>3]=v}c[o>>2]=(c[o>>2]|0)+1}h[(c[(c[f>>2]|0)+8>>2]|0)+120>>3]=+h[q>>3];h[(c[(c[f>>2]|0)+8>>2]|0)+128>>3]=+h[r>>3];o=c[f>>2]|0;if((o|0)!=(uf(c[f>>2]|0)|0)?(c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0){o=(c[(c[f>>2]|0)+8>>2]|0)+48|0;if(+h[(c[(c[f>>2]|0)+8>>2]|0)+48+48+8>>3]>+h[(c[(c[f>>2]|0)+8>>2]|0)+48+16+8>>3])w=+h[o+48+8>>3];else w=+h[o+16+8>>3];h[j>>3]=w;c[l>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1];c[m>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];h[k>>3]=+h[(c[(c[c[(c[s>>2]|0)+(c[m>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[c[(c[s>>2]|0)+(c[l>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8>>3];h[p>>3]=+h[j>>3]-(+h[k>>3]+ +h[q>>3]+ +h[r>>3]);if(+h[p>>3]>0.0)Ri(c[f>>2]|0,~~+h[p>>3],c[g>>2]|0)}g=c[f>>2]|0;if((g|0)==(uf(c[f>>2]|0)|0)){i=e;return}g=c[(c[f>>2]|0)+8>>2]|0;if(+h[(c[s>>2]|0)+(b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]<<6)+24>>3]>+h[(c[(c[f>>2]|0)+8>>2]|0)+128>>3])x=+h[(c[s>>2]|0)+(b[g+236>>1]<<6)+24>>3];else x=+h[g+128>>3];h[(c[s>>2]|0)+(b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]<<6)+24>>3]=x;g=c[(c[f>>2]|0)+8>>2]|0;if(+h[(c[s>>2]|0)+(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]<<6)+16>>3]>+h[(c[(c[f>>2]|0)+8>>2]|0)+120>>3])y=+h[(c[s>>2]|0)+(b[g+238>>1]<<6)+16>>3];else y=+h[g+120>>3];h[(c[s>>2]|0)+(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]<<6)+16>>3]=y;i=e;return}function Ri(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0.0,K=0.0;f=i;i=i+48|0;g=f+40|0;j=f+36|0;k=f+32|0;l=f+28|0;m=f+24|0;n=f+20|0;o=f+16|0;p=f+12|0;q=f+8|0;r=f+4|0;s=f;c[g>>2]=a;c[j>>2]=d;c[k>>2]=e;c[p>>2]=uf(c[g>>2]|0)|0;c[q>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+196>>2];c[r>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1];c[s>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];c[m>>2]=((c[j>>2]|0)+1|0)/2|0;c[o>>2]=~~(+h[(c[(c[g>>2]|0)+8>>2]|0)+120>>3]+ +(c[m>>2]|0)-(+h[(c[q>>2]|0)+(c[r>>2]<<6)+16>>3]-+(c[k>>2]|0)));if((c[o>>2]|0)>0){c[l>>2]=c[r>>2];while(1){if((c[l>>2]|0)<(c[s>>2]|0))break;if((c[(c[q>>2]|0)+(c[l>>2]<<6)>>2]|0)>0){r=(c[(c[c[(c[q>>2]|0)+(c[l>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8|0;h[r>>3]=+h[r>>3]+ +(c[o>>2]|0)}c[l>>2]=(c[l>>2]|0)+-1}c[n>>2]=~~(+h[(c[(c[g>>2]|0)+8>>2]|0)+128>>3]+ +((c[j>>2]|0)-(c[m>>2]|0)|0)+ +(c[o>>2]|0)-(+h[(c[q>>2]|0)+(c[s>>2]<<6)+24>>3]-+(c[k>>2]|0)))}else c[n>>2]=~~(+h[(c[(c[g>>2]|0)+8>>2]|0)+128>>3]+ +((c[j>>2]|0)-(c[m>>2]|0)|0)-(+h[(c[q>>2]|0)+(c[s>>2]<<6)+24>>3]-+(c[k>>2]|0)));if((c[n>>2]|0)<=0){t=c[j>>2]|0;u=c[m>>2]|0;v=t-u|0;w=+(v|0);x=c[g>>2]|0;y=x+8|0;z=c[y>>2]|0;A=z+128|0;B=+h[A>>3];C=B+w;h[A>>3]=C;D=c[m>>2]|0;E=+(D|0);F=c[g>>2]|0;G=F+8|0;H=c[G>>2]|0;I=H+120|0;J=+h[I>>3];K=J+E;h[I>>3]=K;i=f;return}c[l>>2]=(c[s>>2]|0)-1;while(1){if((c[l>>2]|0)<(b[(c[(c[p>>2]|0)+8>>2]|0)+236>>1]|0))break;if((c[(c[q>>2]|0)+(c[l>>2]<<6)>>2]|0)>0){s=(c[(c[c[(c[q>>2]|0)+(c[l>>2]<<6)+4>>2]>>2]|0)+8>>2]|0)+16+8|0;h[s>>3]=+h[s>>3]+ +(c[n>>2]|0)}c[l>>2]=(c[l>>2]|0)+-1}t=c[j>>2]|0;u=c[m>>2]|0;v=t-u|0;w=+(v|0);x=c[g>>2]|0;y=x+8|0;z=c[y>>2]|0;A=z+128|0;B=+h[A>>3];C=B+w;h[A>>3]=C;D=c[m>>2]|0;E=+(D|0);F=c[g>>2]|0;G=F+8|0;H=c[G>>2]|0;I=H+120|0;J=+h[I>>3];K=J+E;h[I>>3]=K;i=f;return}function Si(a){a=a|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[g>>2]=0;b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]=32767;b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]=-1;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;if((b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0)<(c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0))b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]=c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2];if((b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0))b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]=c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2];a=c[f>>2]|0;if(c[g>>2]|0){if((c[(c[a+8>>2]|0)+232>>2]|0)<(c[(c[(c[g>>2]|0)+8>>2]|0)+232>>2]|0))c[g>>2]=c[f>>2]}else c[g>>2]=a;c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]=c[g>>2];i=d;return}function Ti(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0.0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=2147483647;a=yA(c[d>>2]|0,124005)|0;c[g>>2]=a;if(a){h=+t3(c[g>>2]|0);c[e>>2]=~~(h*+(kB(c[d>>2]|0)|0))}c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[(c[d>>2]|0)+8>>2]|0)+216+4>>2]|0))break;c[(c[(c[d>>2]|0)+8>>2]|0)+192>>2]=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+216>>2]|0)+(c[f>>2]<<2)>>2];gK(c[d>>2]|0,(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0)==0?1:0,c[e>>2]|0)|0;c[f>>2]=(c[f>>2]|0)+1}i=b;return}function Ui(d,f){d=d|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+16|0;h=g;j=g+12|0;k=g+8|0;c[j>>2]=d;c[k>>2]=f;f=(yA(c[j>>2]|0,124014)|0)!=0;d=c[j>>2]|0;if(f){f=(c[d+8>>2]|0)+136|0;b[f>>1]=e[f>>1]|16;Wi(c[j>>2]|0,c[k>>2]|0)}else Xi(d,c[k>>2]|0);if(!(a[138998]|0)){i=g;return}k=c[24742]|0;d=b[(c[(c[j>>2]|0)+8>>2]|0)+236>>1]|0;c[h>>2]=b[(c[(c[j>>2]|0)+8>>2]|0)+238>>1];c[h+4>>2]=d;Y2(k,124022,h)|0;i=g;return}function Vi(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=(P3(wB(c[d>>2]|0)|0,145613,7)|0)==0&1;i=b;return a|0}function Wi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[f>>2]=a;c[g>>2]=b;c[k>>2]=2147483647;c[12579]=0;c[e>>2]=c[13066];c[m>>2]=gB(124232,e,0)|0;MC(c[m>>2]|0,124261,280,1)|0;yC(c[m>>2]|0,50320,50256);Yi(c[f>>2]|0);e=yA(c[f>>2]|0,124005)|0;c[l>>2]=e;if(e){n=+t3(c[l>>2]|0);c[k>>2]=~~(n*+(kB(c[f>>2]|0)|0))}else c[k>>2]=2147483647;lj(c[f>>2]|0,0);mj(c[f>>2]|0,c[m>>2]|0);nj(c[f>>2]|0,c[m>>2]|0);oj(c[f>>2]|0,c[m>>2]|0,0,0);pj(c[m>>2]|0);c[j>>2]=qj(c[m>>2]|0)|0;rj(c[m>>2]|0);if(c[g>>2]|0){Xj(c[m>>2]|0);Vj(c[m>>2]|0)}g=yA(c[f>>2]|0,140042)|0;c[l>>2]=g;if(g){c[h>>2]=u3(c[l>>2]|0)|0;o=c[m>>2]|0;p=c[k>>2]|0;q=c[h>>2]|0;fK(o,1,p,q)|0;r=c[f>>2]|0;s=c[m>>2]|0;t=c[j>>2]|0;sj(r,s,t);u=c[m>>2]|0;jB(u)|0;i=d;return}else{c[h>>2]=-1;o=c[m>>2]|0;p=c[k>>2]|0;q=c[h>>2]|0;fK(o,1,p,q)|0;r=c[f>>2]|0;s=c[m>>2]|0;t=c[j>>2]|0;sj(r,s,t);u=c[m>>2]|0;jB(u)|0;i=d;return}}function Xi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+8|0;j=d;c[f>>2]=a;c[g>>2]=b;Yi(c[f>>2]|0);if(c[g>>2]|0){Xj(c[f>>2]|0);Vj(c[f>>2]|0)}Zi(c[f>>2]|0,c[f>>2]|0);ik(c[f>>2]|0);_i(j,c[f>>2]|0);c[h>>2]=c[j>>2];c[h+4>>2]=c[j+4>>2];bl(c[f>>2]|0,0);do if(c[g>>2]|0){if((c[(c[(c[f>>2]|0)+8>>2]|0)+216+4>>2]|0)<=1?(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0)<=0:0)break;c[(c[g>>2]|0)+32>>2]=1;c[g>>2]=0}while(0);Sj(c[f>>2]|0);j=c[f>>2]|0;c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];if($i(j,e)|0)bl(c[f>>2]|0,0);e=c[f>>2]|0;if(c[g>>2]|0){Wj(e,c[g>>2]|0);k=c[f>>2]|0;l=c[g>>2]|0;aj(k,l);m=c[f>>2]|0;bj(m);i=d;return}else{Ti(e);k=c[f>>2]|0;l=c[g>>2]|0;aj(k,l);m=c[f>>2]|0;bj(m);i=d;return}}function Yi(a){a=a|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+8|0;h=f+4|0;j=f;c[g>>2]=a;if(!((d[(c[(c[g>>2]|0)+8>>2]|0)+113>>0]|0)&1)){i=f;return}c[h>>2]=$B(c[g>>2]|0)|0;while(1){k=c[g>>2]|0;if(!(c[h>>2]|0))break;c[j>>2]=OA(k,c[h>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;a=(c[(c[j>>2]|0)+8>>2]|0)+170|0;b[a>>1]=(e[a>>1]|0)<<1;c[j>>2]=QA(c[g>>2]|0,c[j>>2]|0)|0}c[h>>2]=aC(c[g>>2]|0,c[h>>2]|0)|0}c[(c[(c[g>>2]|0)+8>>2]|0)+252>>2]=((c[(c[k+8>>2]|0)+252>>2]|0)+1|0)/2|0;i=f;return}function Zi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b;c[h>>2]=GD(c[f>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;c[g>>2]=jj(c[h>>2]|0)|0;do if(c[g>>2]|0){f=c[e>>2]|0;b=c[h>>2]|0;if((c[g>>2]|0)==7&(c[13797]|0)==100){fj(f,b);break}else{kj(f,b,c[g>>2]|0);break}}else Zi(c[e>>2]|0,c[h>>2]|0);while(0);c[h>>2]=HD(c[h>>2]|0)|0}i=d;return}function _i(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e;c[f>>2]=d;c[j+4>>2]=0;c[j>>2]=0;if((c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0)==0?(c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0)==0:0){c[b>>2]=c[j>>2];c[b+4>>2]=c[j+4>>2];i=e;return}if(c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0){d=lO(c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]=d}if(c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0){d=lO(c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]=d}d=c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0;c[g>>2]=d;a:do if(d){c[j+4>>2]=(a[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0)+8>>2]|0)+159>>0]|0)==5&1;while(1){k=c[c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]>>2]|0;c[h>>2]=k;if(!k)break a;k=c[h>>2]|0;l=c[((c[c[h>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0;k=c[h>>2]|0;if((l|0)!=(lO(c[((c[c[h>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)|0))break;Rj(c[h>>2]|0)}La(124125,124065,346,124157)}while(0);d=c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0;c[g>>2]=d;b:do if(d){c[j>>2]=(a[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0)+8>>2]|0)+159>>0]|0)==3&1;while(1){k=c[c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]>>2]|0;c[h>>2]=k;if(!k)break b;k=c[h>>2]|0;l=c[((c[c[h>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0;k=c[h>>2]|0;if((l|0)!=(lO(c[((c[c[h>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)|0))break;Rj(c[h>>2]|0)}La(124170,124065,353,124157)}while(0);c[b>>2]=c[j>>2];c[b+4>>2]=c[j+4>>2];i=e;return}function $i(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[h>>2]=0;if((c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0)==0?(c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0)==0:0){j=c[h>>2]|0;k=(j|0)!=0;l=k&1;i=e;return l|0}c[g>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;a=c[g>>2]|0;if((a|0)==(lO(c[g>>2]|0)|0)){if(((c[(c[(c[g>>2]|0)+8>>2]|0)+180+4>>2]|0)==0?(c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0)!=0:0)?(c[g>>2]|0)!=(c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0):0){c[h>>2]=Og(c[g>>2]|0,c[(c[(c[f>>2]|0)+8>>2]|0)+228>>2]|0,0)|0;b[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]=c[d+4>>2];c[(c[(c[h>>2]|0)+8>>2]|0)+156>>2]=0}if(((c[(c[(c[g>>2]|0)+8>>2]|0)+172+4>>2]|0)==0?(c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0)!=0:0)?(c[g>>2]|0)!=(c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0):0){c[h>>2]=Og(c[(c[(c[f>>2]|0)+8>>2]|0)+224>>2]|0,c[g>>2]|0,0)|0;b[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]=c[d>>2];c[(c[(c[h>>2]|0)+8>>2]|0)+156>>2]=0}}c[g>>2]=aC(c[f>>2]|0,c[g>>2]|0)|0}j=c[h>>2]|0;k=(j|0)!=0;l=k&1;i=e;return l|0}function aj(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=d;c[h>>2]=e;e=$B(c[g>>2]|0)|0;c[k>>2]=e;d=c[(c[g>>2]|0)+8>>2]|0;if(!e){b[d+238>>1]=0;b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1]=0;i=f;return}b[d+236>>1]=32767;b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]=-1;while(1){if(!(c[k>>2]|0))break;c[l>>2]=lO(c[k>>2]|0)|0;do if((c[l>>2]|0)!=(c[k>>2]|0)){if((c[h>>2]|0)!=0?(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0)!=0:0)break;d=(c[(c[k>>2]|0)+8>>2]|0)+232|0;c[d>>2]=(c[d>>2]|0)+(c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0)}while(0);if((b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0)<(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0))b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]=c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2];if((b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1]|0)>(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0))b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1]=c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2];if((a[(c[(c[k>>2]|0)+8>>2]|0)+159>>0]|0)!=0?(a[(c[(c[k>>2]|0)+8>>2]|0)+159>>0]|0)!=6:0)nO(c[k>>2]|0);c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}k=c[g>>2]|0;if((k|0)!=(uf(c[g>>2]|0)|0)){i=f;return}if((c[13797]|0)!=100){ej(c[g>>2]|0);i=f;return}c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]|0))break;dj(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2]|0);c[j>>2]=(c[j>>2]|0)+1}i=f;return}function bj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[e>>2]=b;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[(c[e>>2]|0)+8>>2]|0)+216+4>>2]|0))break;c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0)+(c[j>>2]<<2)>>2];c[f>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[f>>2]|0))break;cj((c[(c[f>>2]|0)+8>>2]|0)+172|0);cj((c[(c[f>>2]|0)+8>>2]|0)+180|0);a[(c[(c[f>>2]|0)+8>>2]|0)+157>>0]=0;c[f>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+164>>2]}c[j>>2]=(c[j>>2]|0)+1}c[f>>2]=$B(c[e>>2]|0)|0;while(1){n=c[e>>2]|0;if(!(c[f>>2]|0))break;c[g>>2]=OA(n,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[h>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2];if((c[h>>2]|0)!=0?(c[g>>2]|0)==(c[(c[(c[h>>2]|0)+8>>2]|0)+116>>2]|0):0){c[m>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;c[k>>2]=OA(c[e>>2]|0,c[m>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;if(((c[g>>2]|0)!=(c[k>>2]|0)?(c[l>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2],(c[l>>2]|0)!=0):0)?(c[h>>2]|0)==(c[l>>2]|0):0)c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]=0;c[k>>2]=QA(c[e>>2]|0,c[k>>2]|0)|0}c[m>>2]=aC(c[e>>2]|0,c[m>>2]|0)|0}O4(c[(c[h>>2]|0)+8>>2]|0);O4(c[h>>2]|0)}c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]=0;c[g>>2]=QA(c[e>>2]|0,c[g>>2]|0)|0}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}O4(c[(c[n+8>>2]|0)+216>>2]|0);c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]=0;c[(c[(c[e>>2]|0)+8>>2]|0)+216+4>>2]=0;i=d;return}function cj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[d>>2]|0)+4>>2];while(1){if((c[e>>2]|0)<0)break;c[(c[c[d>>2]>>2]|0)+(c[e>>2]<<2)>>2]=0;c[e>>2]=(c[e>>2]|0)+-1}c[(c[d>>2]|0)+4>>2]=0;i=b;return}function dj(a){a=a|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;a=(c[(c[e>>2]|0)+8>>2]|0)+236|0;b[a>>1]=(b[a>>1]|0)+(c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]|0)+8>>2]|0)+232>>2]|0);a=(c[(c[e>>2]|0)+8>>2]|0)+238|0;b[a>>1]=(b[a>>1]|0)+(c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]|0)+8>>2]|0)+232>>2]|0);c[f>>2]=1;while(1){if((c[f>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;dj(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2]|0);c[f>>2]=(c[f>>2]|0)+1}i=d;return}function ej(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=GD(uf(c[e>>2]|0)|0)|0;while(1){if(!(c[f>>2]|0))break;if((a[(c[(c[f>>2]|0)+8>>2]|0)+274>>0]|0)==7)fj(c[e>>2]|0,c[f>>2]|0);c[f>>2]=HD(c[f>>2]|0)|0}i=d;return}function fj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;if(c[(c[(c[f>>2]|0)+8>>2]|0)+200>>2]|0){i=d;return}c[(c[(c[f>>2]|0)+8>>2]|0)+200>>2]=c[e>>2];gj(c[e>>2]|0,c[f>>2]|0);if(!($B(c[f>>2]|0)|0)){i=d;return}hj(c[e>>2]|0,c[f>>2]|0)|0;e=c[f>>2]|0;if((c[13797]|0)==100){Xi(e,0);ij(c[f>>2]|0);i=d;return}else{Si(e);i=d;return}}function gj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=$B(c[g>>2]|0)|0;while(1){m=c[g>>2]|0;if(!(c[h>>2]|0))break;c[j>>2]=aC(m,c[h>>2]|0)|0;if(a[(c[(c[h>>2]|0)+8>>2]|0)+159>>0]|0)pC(c[g>>2]|0,c[h>>2]|0)|0;else{c[l>>2]=1;while(1){if((c[l>>2]|0)>=(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;if(AC(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[l>>2]<<2)>>2]|0,c[h>>2]|0)|0)break;c[l>>2]=(c[l>>2]|0)+1}if((c[l>>2]|0)<(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))pC(c[g>>2]|0,c[h>>2]|0)|0;c[(c[(c[h>>2]|0)+8>>2]|0)+212>>2]=0}c[h>>2]=c[j>>2]}c[h>>2]=$B(m)|0;while(1){if(!(c[h>>2]|0))break;m=uf(c[g>>2]|0)|0;c[k>>2]=OA(m,c[h>>2]|0)|0;while(1){n=c[g>>2]|0;if(!(c[k>>2]|0))break;m=c[k>>2]|0;if(AC(n,c[((c[c[k>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)|0)YA(c[g>>2]|0,c[k>>2]|0,1)|0;m=uf(c[g>>2]|0)|0;c[k>>2]=QA(m,c[k>>2]|0)|0}c[h>>2]=aC(n,c[h>>2]|0)|0}i=e;return}function hj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;b=(c[(c[e>>2]|0)+8>>2]|0)+180|0;a=(c[b>>2]|0)+1|0;c[b>>2]=a;c[g>>2]=a;if(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)h=dK(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0,(c[g>>2]|0)+1|0,4,c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)|0;else h=bK((c[g>>2]|0)+1<<2)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]=h;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[g>>2]<<2)>>2]=c[f>>2];LJ(c[f>>2]|0);i=d;return c[g>>2]|0}function ij(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=b;c[h>>2]=0;c[f>>2]=0;c[g>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;if((c[(c[(c[g>>2]|0)+8>>2]|0)+232>>2]|0)==0?(a[(c[(c[g>>2]|0)+8>>2]|0)+156>>0]|0)==0:0)c[f>>2]=c[g>>2];if((c[h>>2]|0)<(c[(c[(c[g>>2]|0)+8>>2]|0)+232>>2]|0))c[h>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+232>>2];c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}if(!(c[f>>2]|0))La(124050,124065,238,124072);c[(c[(c[e>>2]|0)+8>>2]|0)+264>>2]=c[f>>2];c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0)){j=17;break}if((c[(c[(c[g>>2]|0)+8>>2]|0)+216>>2]|0)>1?(c[g>>2]|0)!=(c[f>>2]|0):0){j=15;break}mO(c[g>>2]|0,c[f>>2]|0)|0;a[(c[(c[g>>2]|0)+8>>2]|0)+159>>0]=7;c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}if((j|0)==15)La(124087,124065,242,124072);else if((j|0)==17){i=d;return}}function jj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;if(Vi(c[f>>2]|0)|0){c[e>>2]=7;h=c[e>>2]|0;i=d;return h|0}else{c[g>>2]=tO(yA(c[f>>2]|0,124202)|0,50268,50292)|0;a[(c[(c[f>>2]|0)+8>>2]|0)+274>>0]=c[g>>2];c[e>>2]=c[g>>2];h=c[e>>2]|0;i=d;return h|0}return 0}function kj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;e=$B(c[h>>2]|0)|0;c[l>>2]=e;c[k>>2]=e;if(!(c[k>>2]|0)){i=f;return}a[(c[(c[k>>2]|0)+8>>2]|0)+159>>0]=c[j>>2];while(1){e=aC(c[h>>2]|0,c[l>>2]|0)|0;c[l>>2]=e;if(!e)break;mO(c[k>>2]|0,c[l>>2]|0)|0;a[(c[(c[l>>2]|0)+8>>2]|0)+159>>0]=a[(c[(c[k>>2]|0)+8>>2]|0)+159>>0]|0}a:do switch(c[j>>2]|0){case 3:case 2:{if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+224>>2]|0)){c[(c[(c[g>>2]|0)+8>>2]|0)+224>>2]=c[k>>2];break a}else{l=mO(c[(c[(c[g>>2]|0)+8>>2]|0)+224>>2]|0,c[k>>2]|0)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+224>>2]=l;break a}break}case 5:case 4:{if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+228>>2]|0)){c[(c[(c[g>>2]|0)+8>>2]|0)+228>>2]=c[k>>2];break a}else{l=mO(c[(c[(c[g>>2]|0)+8>>2]|0)+228>>2]|0,c[k>>2]|0)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+228>>2]=l;break a}break}default:{}}while(0);switch(c[j>>2]|0){case 3:{a[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+224>>2]|0)+8>>2]|0)+159>>0]=c[j>>2];i=f;return}case 5:{a[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+228>>2]|0)+8>>2]|0)+159>>0]=c[j>>2];i=f;return}default:{i=f;return}}}function lj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+48|0;f=e;g=e+32|0;h=e+28|0;j=e+24|0;k=e+20|0;l=e+16|0;m=e+12|0;n=e+8|0;c[g>>2]=b;c[h>>2]=d;if(Gj(c[g>>2]|0)|0){i=e;return}do if(CO(c[g>>2]|0)|0){c[k>>2]=c[g>>2];if(c[h>>2]|0){c[(c[(c[g>>2]|0)+8>>2]|0)+204>>2]=(c[(c[(c[h>>2]|0)+8>>2]|0)+204>>2]|0)+1;Hj(c[g>>2]|0,c[h>>2]|0);break}else{c[(c[(c[g>>2]|0)+8>>2]|0)+204>>2]=0;break}}else c[k>>2]=c[h>>2];while(0);c[j>>2]=GD(c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;lj(c[j>>2]|0,c[k>>2]|0);c[j>>2]=HD(c[j>>2]|0)|0}a:do if(CO(c[g>>2]|0)|0){c[l>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[l>>2]|0))break a;if(!(c[(c[(c[l>>2]|0)+8>>2]|0)+212>>2]|0))c[(c[(c[l>>2]|0)+8>>2]|0)+212>>2]=c[g>>2];c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}}while(0);switch(Ij(c[g>>2]|0)|0){case 3:{a[(c[(c[k>>2]|0)+8>>2]|0)+241>>0]=1;o=18;break}case 2:{o=18;break}case 5:{a[(c[(c[k>>2]|0)+8>>2]|0)+242>>0]=1;o=20;break}case 4:{o=20;break}case 1:{c[m>>2]=Jj(c[g>>2]|0)|0;break}case 6:break;default:{l=wB(c[g>>2]|0)|0;j=yA(c[g>>2]|0,124202)|0;c[f>>2]=l;c[f+4>>2]=j;$z(0,124385,f)|0}}if((o|0)==18){c[m>>2]=Jj(c[g>>2]|0)|0;f=Kj(c[m>>2]|0,c[(c[(c[k>>2]|0)+8>>2]|0)+208>>2]|0)|0;c[(c[(c[k>>2]|0)+8>>2]|0)+208>>2]=f}else if((o|0)==20){c[m>>2]=Jj(c[g>>2]|0)|0;o=Kj(c[m>>2]|0,c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]|0)|0;c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]=o}if(!(CO(c[g>>2]|0)|0)){i=e;return}if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+208>>2]|0)){i=e;return}if((c[(c[(c[g>>2]|0)+8>>2]|0)+208>>2]|0)!=(c[(c[(c[g>>2]|0)+8>>2]|0)+212>>2]|0)){i=e;return}c[n>>2]=Jj(c[g>>2]|0)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+208>>2]=c[n>>2];c[(c[(c[g>>2]|0)+8>>2]|0)+212>>2]=c[n>>2];i=e;return}function mj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[12579]=0;c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;b=tj(c[g>>2]|0)|0;if((b|0)==(c[g>>2]|0)){b=c[f>>2]|0;a=wj(b,wB(c[g>>2]|0)|0)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+148>>2]=a}c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+148>>2]|0)){f=c[(c[(tj(c[g>>2]|0)|0)+8>>2]|0)+148>>2]|0;c[(c[(c[g>>2]|0)+8>>2]|0)+148>>2]=f}c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}i=d;return}function nj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+48|0;e=d+32|0;f=d+28|0;g=d+24|0;h=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;m=d+4|0;n=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[j>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+148>>2];c[h>>2]=OA(c[e>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;do if((Bj(c[h>>2]|0)|0)==0?(b=c[h>>2]|0,c[k>>2]=c[(c[(tj(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)|0)+8>>2]|0)+148>>2],(c[j>>2]|0)!=(c[k>>2]|0)):0){b=c[h>>2]|0;c[l>>2]=c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+212>>2];b=c[h>>2]|0;c[m>>2]=c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+212>>2];if(Cj(c[h>>2]|0)|0){b=c[h>>2]|0;a=tj(c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0;b=c[h>>2]|0;if(!((a|0)!=(c[(c[(c[(c[(c[((c[c[h>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)+8>>2]|0)+212>>2]|0)?(b=c[h>>2]|0,a=tj(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)|0,b=c[h>>2]|0,(a|0)!=(c[(c[(c[(c[(c[((c[c[h>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)+8>>2]|0)+208>>2]|0)):0)){c[n>>2]=c[j>>2];c[j>>2]=c[k>>2];c[k>>2]=c[n>>2]}Dj(c[f>>2]|0,c[j>>2]|0,c[k>>2]|0,c[h>>2]|0);break}else{if((Aj(c[l>>2]|0)|0)==0?(Aj(c[m>>2]|0)|0)==0:0){Dj(c[f>>2]|0,c[j>>2]|0,c[k>>2]|0,c[h>>2]|0);break}Ej(c[f>>2]|0,c[j>>2]|0,c[k>>2]|0,c[h>>2]|0);break}}while(0);c[h>>2]=QA(c[e>>2]|0,c[h>>2]|0)|0}c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}i=d;return}function oj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+32|0;g=f+28|0;h=f+24|0;j=f+20|0;k=f+16|0;l=f+12|0;m=f+8|0;n=f+4|0;o=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;if((CO(c[g>>2]|0)|0)!=0?(Aj(c[g>>2]|0)|0)!=0:0){c[l>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;if(!(RA(c[g>>2]|0,c[l>>2]|0)|0)){c[m>>2]=c[(c[(tj(c[l>>2]|0)|0)+8>>2]|0)+148>>2];if(!(c[j>>2]|0))c[j>>2]=wj(c[h>>2]|0,124283)|0;VA(c[h>>2]|0,c[j>>2]|0,c[m>>2]|0,0,1)|0}if(!(OA(c[g>>2]|0,c[l>>2]|0)|0)){c[m>>2]=c[(c[(tj(c[l>>2]|0)|0)+8>>2]|0)+148>>2];if(!(c[k>>2]|0))c[k>>2]=wj(c[h>>2]|0,124288)|0;VA(c[h>>2]|0,c[m>>2]|0,c[k>>2]|0,0,1)|0}c[l>>2]=aC(c[g>>2]|0,c[l>>2]|0)|0}if((c[j>>2]|0)!=0&(c[k>>2]|0)!=0){c[n>>2]=VA(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0,0,1)|0;zj(c[n>>2]|0,0,1e3)}}c[o>>2]=GD(c[g>>2]|0)|0;while(1){if(!(c[o>>2]|0))break;oj(c[o>>2]|0,c[h>>2]|0,c[j>>2]|0,c[k>>2]|0);c[o>>2]=HD(c[o>>2]|0)|0}i=f;return}function pj(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=b;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;a[(c[(c[f>>2]|0)+8>>2]|0)+158>>0]=0;a[(c[(c[f>>2]|0)+8>>2]|0)+157>>0]=0;c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;xj(c[e>>2]|0,c[f>>2]|0);c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}i=d;return}function qj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[e>>2]=0;c[f>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[(c[(c[f>>2]|0)+8>>2]|0)+128>>2]=0;c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}c[f>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;if(!(c[(c[(c[f>>2]|0)+8>>2]|0)+128>>2]|0)){a=c[d>>2]|0;j=c[f>>2]|0;k=(c[e>>2]|0)+1|0;c[e>>2]=k;vj(a,j,k)}c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}if((c[e>>2]|0)<=1){l=c[e>>2]|0;i=b;return l|0}c[g>>2]=wj(c[d>>2]|0,124277)|0;c[h>>2]=1;c[f>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;if((c[(c[(c[f>>2]|0)+8>>2]|0)+128>>2]|0)==(c[h>>2]|0)){VA(c[d>>2]|0,c[g>>2]|0,c[f>>2]|0,0,1)|0;c[h>>2]=(c[h>>2]|0)+1}c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}l=c[e>>2]|0;i=b;return l|0}function rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;a=(c[(c[e>>2]|0)+8>>2]|0)+180|0;if(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)g=eK(c[a>>2]|0,(c[(c[(c[e>>2]|0)+8>>2]|0)+180+4>>2]|0)+2<<2)|0;else g=cK((c[a+4>>2]|0)+2<<2)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]=g;a=c[f>>2]|0;h=(c[(c[e>>2]|0)+8>>2]|0)+180+4|0;j=c[h>>2]|0;c[h>>2]=j+1;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)+(j<<2)>>2]=a;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)+(c[(c[(c[e>>2]|0)+8>>2]|0)+180+4>>2]<<2)>>2]=0;a=c[f>>2]|0;j=(c[(c[((c[c[f>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+172|0;if(c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?c[f>>2]|0:(c[f>>2]|0)+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0){a=c[f>>2]|0;k=eK(c[j>>2]|0,(c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]|0)+2<<2)|0}else k=cK((c[j+4>>2]|0)+2<<2)|0;j=c[f>>2]|0;c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]=k;j=c[f>>2]|0;a=c[f>>2]|0;h=(c[(c[((c[c[f>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+172+4|0;a=c[h>>2]|0;c[h>>2]=a+1;h=c[f>>2]|0;c[(c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(a<<2)>>2]=j;j=c[f>>2]|0;a=c[f>>2]|0;c[(c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+172>>2]|0)+(c[(c[(c[((c[c[f>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]<<2)>>2]=0;c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function sj(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=a;c[h>>2]=d;c[j>>2]=e;c[m>>2]=0;c[n>>2]=0;b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1]=32767;b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]=-1;a:do if((c[j>>2]|0)>1){c[m>>2]=bK((c[j>>2]|0)+1<<2)|0;c[o>>2]=1;while(1){if((c[o>>2]|0)>(c[j>>2]|0))break a;c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]=32767;c[o>>2]=(c[o>>2]|0)+1}}while(0);c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[l>>2]=c[(c[(tj(c[k>>2]|0)|0)+8>>2]|0)+148>>2];c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2];if((b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]|0)<(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0))b[(c[(c[g>>2]|0)+8>>2]|0)+238>>1]=c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2];if((b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1]|0)>(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0))b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1]=c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2];if(c[m>>2]|0){c[(c[(c[k>>2]|0)+8>>2]|0)+128>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+128>>2];o=c[(c[k>>2]|0)+8>>2]|0;if((c[(c[m>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+128>>2]<<2)>>2]|0)<(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0))q=c[(c[m>>2]|0)+(c[o+128>>2]<<2)>>2]|0;else q=c[o+232>>2]|0;c[(c[m>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+128>>2]<<2)>>2]=q}c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}q=c[g>>2]|0;if(!(c[m>>2]|0)){if((b[(c[q+8>>2]|0)+236>>1]|0)>0){c[p>>2]=b[(c[(c[g>>2]|0)+8>>2]|0)+236>>1];c[k>>2]=$B(c[g>>2]|0)|0;while(1){r=c[p>>2]|0;if(!(c[k>>2]|0))break;l=(c[(c[k>>2]|0)+8>>2]|0)+232|0;c[l>>2]=(c[l>>2]|0)-r;c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}l=(c[(c[g>>2]|0)+8>>2]|0)+236|0;b[l>>1]=(b[l>>1]|0)-r;r=(c[(c[g>>2]|0)+8>>2]|0)+238|0;b[r>>1]=(b[r>>1]|0)-(c[p>>2]|0)}}else{c[k>>2]=$B(q)|0;while(1){if(!(c[k>>2]|0))break;q=(c[(c[k>>2]|0)+8>>2]|0)+232|0;c[q>>2]=(c[q>>2]|0)-(c[(c[m>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+128>>2]<<2)>>2]|0);c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}c[n>>2]=1}uj(c[g>>2]|0,c[n>>2]|0);c[k>>2]=$B(c[h>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;if(c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]|0)O4(c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]|0);if(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0)O4(c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]|0);c[k>>2]=aC(c[h>>2]|0,c[k>>2]|0)|0}O4(c[(c[($B(c[g>>2]|0)|0)+8>>2]|0)+112>>2]|0);c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[(c[(c[k>>2]|0)+8>>2]|0)+112>>2]=0;c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}if(!(c[m>>2]|0)){i=f;return}O4(c[m>>2]|0);i=f;return}function tj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;a=c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]|0;c[e>>2]=a;if(!a){a=c[d>>2]|0;c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]=a;c[e>>2]=a;f=c[e>>2]|0;i=b;return f|0}if((c[e>>2]|0)==(c[d>>2]|0)){f=c[e>>2]|0;i=b;return f|0}a=tj(c[e>>2]|0)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+152>>2]=a;c[e>>2]=a;f=c[e>>2]|0;i=b;return f|0}function uj(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=d;c[h>>2]=1;while(1){if((c[h>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;uj(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[h>>2]<<2)>>2]|0,0);c[h>>2]=(c[h>>2]|0)+1}if(!((c[g>>2]|0)!=0?1:(c[(c[(c[f>>2]|0)+8>>2]|0)+200>>2]|0)!=0)){i=e;return}b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]=32767;b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]=-1;c[k>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[j>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2];if((b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0)<(c[j>>2]|0))b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]=c[j>>2];if((b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0)>(c[j>>2]|0)){b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]=c[j>>2];c[l>>2]=c[k>>2]}c[k>>2]=aC(c[f>>2]|0,c[k>>2]|0)|0}c[(c[(c[f>>2]|0)+8>>2]|0)+264>>2]=c[l>>2];i=e;return}function vj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;if(c[(c[(c[g>>2]|0)+8>>2]|0)+128>>2]|0){i=e;return}c[(c[(c[g>>2]|0)+8>>2]|0)+128>>2]=c[h>>2];c[j>>2]=OA(c[f>>2]|0,c[g>>2]|0)|0;while(1){k=c[f>>2]|0;if(!(c[j>>2]|0))break;d=c[j>>2]|0;vj(k,c[((c[c[j>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0,c[h>>2]|0);c[j>>2]=QA(c[f>>2]|0,c[j>>2]|0)|0}c[j>>2]=RA(k,c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;g=c[j>>2]|0;vj(c[f>>2]|0,c[((c[c[j>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0,c[h>>2]|0);c[j>>2]=SA(c[f>>2]|0,c[j>>2]|0)|0}i=e;return}function wj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=fC(c[e>>2]|0,c[f>>2]|0,1)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+172+4>>2]=0;f=bK(20)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]=f;c[(c[(c[g>>2]|0)+8>>2]|0)+180+4>>2]=0;f=bK(20)|0;c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]=f;if(c[12579]|0){c[(c[(c[g>>2]|0)+8>>2]|0)+168>>2]=c[12579];c[(c[(c[12579]|0)+8>>2]|0)+164>>2]=c[g>>2];h=c[g>>2]|0;c[12579]=h;j=c[g>>2]|0;k=j+8|0;l=c[k>>2]|0;m=l+164|0;c[m>>2]=0;n=c[g>>2]|0;i=d;return n|0}else{c[(c[(c[g>>2]|0)+8>>2]|0)+168>>2]=0;c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]=c[g>>2];h=c[g>>2]|0;c[12579]=h;j=c[g>>2]|0;k=j+8|0;l=c[k>>2]|0;m=l+164|0;c[m>>2]=0;n=c[g>>2]|0;i=d;return n|0}return 0}function xj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;if(a[(c[(c[g>>2]|0)+8>>2]|0)+157>>0]|0){i=e;return}a[(c[(c[g>>2]|0)+8>>2]|0)+157>>0]=1;a[(c[(c[g>>2]|0)+8>>2]|0)+158>>0]=1;c[h>>2]=OA(c[f>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;c[j>>2]=QA(c[f>>2]|0,c[h>>2]|0)|0;d=c[h>>2]|0;c[k>>2]=c[((c[c[h>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2];if(!(a[(c[(c[k>>2]|0)+8>>2]|0)+158>>0]|0)){if(!(a[(c[(c[k>>2]|0)+8>>2]|0)+157>>0]|0))xj(c[f>>2]|0,c[k>>2]|0)}else yj(c[f>>2]|0,c[h>>2]|0);c[h>>2]=c[j>>2]}a[(c[(c[g>>2]|0)+8>>2]|0)+158>>0]=0;i=e;return}function yj(a,b){a=a|0;b=b|0;var d=0,f=0,g=0,h=0;d=i;i=i+16|0;f=d+8|0;g=d+4|0;h=d;c[f>>2]=a;c[g>>2]=b;b=c[g>>2]|0;a=c[g>>2]|0;c[h>>2]=VA(c[f>>2]|0,c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,c[((c[c[g>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0,0,0)|0;if(!(c[h>>2]|0)){a=c[g>>2]|0;b=c[g>>2]|0;c[h>>2]=VA(c[f>>2]|0,c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0,c[((c[c[g>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0,0,1)|0}zj(c[h>>2]|0,e[(c[(c[g>>2]|0)+8>>2]|0)+170>>1]|0,c[(c[(c[g>>2]|0)+8>>2]|0)+156>>2]|0);pC(c[f>>2]|0,c[g>>2]|0)|0;i=d;return}function zj(a,d,f){a=a|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g+8|0;j=g+4|0;k=g;c[h>>2]=a;c[j>>2]=d;c[k>>2]=f;if((e[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]|0|0)>(c[j>>2]|0))l=e[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]|0;else l=c[j>>2]|0;b[(c[(c[h>>2]|0)+8>>2]|0)+170>>1]=l;l=(c[(c[h>>2]|0)+8>>2]|0)+156|0;c[l>>2]=(c[l>>2]|0)+(c[k>>2]|0);i=g;return}function Aj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[f>>2]=yA(c[d>>2]|0,124293)|0;c[e>>2]=(uO(c[f>>2]|0,0)|0)&255;i=b;return c[e>>2]|0}function Bj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;if((((c[13873]|0)!=0?(b=zA(c[f>>2]|0,c[13873]|0)|0,c[g>>2]=b,(b|0)!=0):0)?(a[c[g>>2]>>0]|0)!=0:0)?((kO(c[g>>2]|0)|0)&255|0)==0:0){c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function Cj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[e>>2]=a;a=c[e>>2]|0;c[g>>2]=c[(c[(c[((c[c[e>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+212>>2];a=c[e>>2]|0;c[h>>2]=c[(c[(c[((c[c[e>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+212>>2];if((c[g>>2]|0)==(c[h>>2]|0)){c[d>>2]=1;j=c[d>>2]|0;i=b;return j|0}c[f>>2]=Fj(c[g>>2]|0,c[h>>2]|0)|0;if((c[f>>2]|0)!=(c[g>>2]|0)?(c[f>>2]|0)!=(c[h>>2]|0):0){c[d>>2]=0;j=c[d>>2]|0;i=b;return j|0}c[d>>2]=1;j=c[d>>2]|0;i=b;return j|0}function Dj(a,b,d,f){a=a|0;b=b|0;d=d|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g;j=g+24|0;k=g+20|0;l=g+16|0;m=g+12|0;n=g+8|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=f;f=VA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,0,0)|0;c[n>>2]=f;if(((f|0)==0?(f=VA(c[j>>2]|0,c[l>>2]|0,c[k>>2]|0,0,0)|0,c[n>>2]=f,(f|0)==0):0)?(f=VA(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,0,1)|0,c[n>>2]=f,(f|0)==0):0){f=wB(c[k>>2]|0)|0;k=wB(c[l>>2]|0)|0;c[h>>2]=f;c[h+4>>2]=k;$z(1,124310,h)|0;i=g;return}zj(c[n>>2]|0,e[(c[(c[m>>2]|0)+8>>2]|0)+170>>1]|0,c[(c[(c[m>>2]|0)+8>>2]|0)+156>>2]|0);i=g;return}function Ej(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+144|0;j=h;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h+32|0;c[k>>2]=a;c[l>>2]=d;c[m>>2]=f;c[n>>2]=g;c[p>>2]=RA(c[k>>2]|0,c[l>>2]|0)|0;while(1){s=c[p>>2]|0;if(!(c[p>>2]|0))break;g=c[p>>2]|0;c[o>>2]=c[((c[s>>2]&3|0)==3?g:g+32|0)+28>>2];g=OA(c[k>>2]|0,c[o>>2]|0)|0;c[q>>2]=g;if((g|0)!=0?(g=c[q>>2]|0,(c[((c[c[q>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)==(c[m>>2]|0)):0){t=14;break}c[p>>2]=SA(c[k>>2]|0,c[p>>2]|0)|0}if((t|0)==14){i=h;return}if(!s){s=c[12589]|0;c[12589]=s+1;c[j>>2]=s;k3(r,124301,j)|0;c[o>>2]=wj(c[k>>2]|0,r)|0;c[p>>2]=VA(c[k>>2]|0,c[o>>2]|0,c[l>>2]|0,0,1)|0;c[q>>2]=VA(c[k>>2]|0,c[o>>2]|0,c[m>>2]|0,0,1)|0}if((e[(c[(c[p>>2]|0)+8>>2]|0)+170>>1]|0|0)>0)u=e[(c[(c[p>>2]|0)+8>>2]|0)+170>>1]|0;else u=0;b[(c[(c[p>>2]|0)+8>>2]|0)+170>>1]=u;u=(c[(c[p>>2]|0)+8>>2]|0)+156|0;c[u>>2]=(c[u>>2]|0)+((c[(c[(c[n>>2]|0)+8>>2]|0)+156>>2]|0)*1e3|0);if((e[(c[(c[q>>2]|0)+8>>2]|0)+170>>1]|0|0)>(e[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]|0|0))v=b[(c[(c[q>>2]|0)+8>>2]|0)+170>>1]|0;else v=b[(c[(c[n>>2]|0)+8>>2]|0)+170>>1]|0;b[(c[(c[q>>2]|0)+8>>2]|0)+170>>1]=v;v=(c[(c[q>>2]|0)+8>>2]|0)+156|0;c[v>>2]=(c[v>>2]|0)+(c[(c[(c[n>>2]|0)+8>>2]|0)+156>>2]|0);i=h;return}function Fj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;while(1){g=c[e>>2]|0;if((c[e>>2]|0)==(c[f>>2]|0))break;if((c[(c[g+8>>2]|0)+204>>2]|0)>=(c[(c[(c[f>>2]|0)+8>>2]|0)+204>>2]|0)){c[e>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+200>>2];continue}else{c[f>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+200>>2];continue}}i=d;return g|0}function Gj(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=(($B(c[d>>2]|0)|0)!=0^1)&1;i=b;return a|0}function Hj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;c[(c[(c[e>>2]|0)+8>>2]|0)+200>>2]=c[f>>2];hj(c[f>>2]|0,c[e>>2]|0)|0;gj(c[f>>2]|0,c[e>>2]|0);i=d;return}function Ij(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;c[g>>2]=yA(c[f>>2]|0,124202)|0;do if((c[g>>2]|0)!=0?(a[c[g>>2]>>0]|0)!=0:0){if(!(J3(c[g>>2]|0,124212)|0)){c[e>>2]=2;break}if(!(J3(c[g>>2]|0,124216)|0)){c[e>>2]=3;break}if(!(J3(c[g>>2]|0,124223)|0)){c[e>>2]=4;break}if(!(J3(c[g>>2]|0,124227)|0)){c[e>>2]=5;break}if(!(J3(c[g>>2]|0,124207)|0))c[e>>2]=1;else h=13}else h=13;while(0);if((h|0)==13)c[e>>2]=6;i=d;return c[e>>2]|0}function Jj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=$B(c[e>>2]|0)|0;a=c[f>>2]|0;if(!(c[f>>2]|0)){c[d>>2]=a;h=c[d>>2]|0;i=b;return h|0}c[g>>2]=tj(a)|0;while(1){a=aC(c[e>>2]|0,c[f>>2]|0)|0;c[f>>2]=a;j=c[g>>2]|0;if(!a)break;Kj(j,c[f>>2]|0)|0}c[d>>2]=j;h=c[d>>2]|0;i=b;return h|0}function Kj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;b=c[f>>2]|0;if(c[g>>2]|0){f=tj(b)|0;c[(c[(tj(c[g>>2]|0)|0)+8>>2]|0)+152>>2]=f;c[e>>2]=f;h=c[e>>2]|0;i=d;return h|0}else{c[e>>2]=b;h=c[e>>2]|0;i=d;return h|0}return 0}function Lj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[e+12>>2]=a;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[g>>2];MC(c[f>>2]|0,124261,c[c[h>>2]>>2]|0,1)|0;i=e;return}function Mj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[e+12>>2]=a;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[g>>2];MC(c[f>>2]|0,124428,c[(c[h>>2]|0)+4>>2]|0,1)|0;i=e;return}function Nj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[e+12>>2]=a;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[g>>2];MC(c[f>>2]|0,124413,c[(c[h>>2]|0)+8>>2]|0,1)|0;i=e;return}function Oj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+272|0;e=d+264|0;f=d+260|0;g=d+256|0;j=d+252|0;k=d+120|0;l=d;m=d+248|0;n=d+244|0;o=d+240|0;c[e>>2]=b;c[13877]=qA(c[e>>2]|0,2,124443,0)|0;c[13878]=qA(c[e>>2]|0,2,124452,0)|0;if(!((c[13877]|0)!=0|(c[13878]|0)!=0)){i=d;return}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[n>>2]=0;c[m>>2]=0;c[g>>2]=TA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;b=c[g>>2]|0;p=c[g>>2]|0;do if((c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)!=(c[((c[c[g>>2]>>2]&3|0)==3?p:p+32|0)+28>>2]|0)){q=c[g>>2]|0;if(((c[13877]|0)!=0?(c[((c[c[g>>2]>>2]&3|0)==2?q:q+-32|0)+28>>2]|0)==(c[f>>2]|0):0)?(q=zA(c[g>>2]|0,c[13877]|0)|0,c[j>>2]=q,(a[q>>0]|0)!=0):0){c[m>>2]=Pj(k,c[m>>2]|0,c[f>>2]|0,c[g>>2]|0,c[j>>2]|0)|0;break}q=c[g>>2]|0;if(((c[13878]|0)!=0?(c[((c[c[g>>2]>>2]&3|0)==3?q:q+32|0)+28>>2]|0)==(c[f>>2]|0):0)?(q=zA(c[g>>2]|0,c[13878]|0)|0,c[j>>2]=q,(a[q>>0]|0)!=0):0)c[n>>2]=Pj(l,c[n>>2]|0,c[f>>2]|0,c[g>>2]|0,c[j>>2]|0)|0}while(0);c[g>>2]=UA(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0)|0}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[m>>2]|0))break;if((c[k+((c[o>>2]|0)*24|0)+4+4>>2]|0)>1)Qj(c[f>>2]|0,k+((c[o>>2]|0)*24|0)+4|0,+h[k+((c[o>>2]|0)*24|0)+16>>3]);if(c[k+((c[o>>2]|0)*24|0)+4>>2]|0)O4(c[k+((c[o>>2]|0)*24|0)+4>>2]|0);c[o>>2]=(c[o>>2]|0)+1}c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[n>>2]|0))break;if((c[l+((c[o>>2]|0)*24|0)+4+4>>2]|0)>1)Qj(c[f>>2]|0,l+((c[o>>2]|0)*24|0)+4|0,+h[l+((c[o>>2]|0)*24|0)+16>>3]);if(c[l+((c[o>>2]|0)*24|0)+4>>2]|0)O4(c[l+((c[o>>2]|0)*24|0)+4>>2]|0);c[o>>2]=(c[o>>2]|0)+1}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}i=d;return}function Pj(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;j=i;i=i+48|0;k=j;l=j+44|0;m=j+40|0;n=j+36|0;o=j+32|0;p=j+28|0;q=j+24|0;r=j+20|0;s=j+16|0;t=j+12|0;u=j+8|0;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[n>>2]|0)){v=10;break}if((a[c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)>>2]>>0]|0)==(a[c[q>>2]>>0]|0)?(J3(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)>>2]|0,c[q>>2]|0)|0)==0:0){v=5;break}c[r>>2]=(c[r>>2]|0)+1}do if((v|0)==5){g=(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4|0;if(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4>>2]|0)w=eK(c[g>>2]|0,(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4+4>>2]|0)+2<<2)|0;else w=cK((c[g+4>>2]|0)+2<<2)|0;c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4>>2]=w;g=c[p>>2]|0;f=(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4+4|0;e=c[f>>2]|0;c[f>>2]=e+1;c[(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4>>2]|0)+(e<<2)>>2]=g;c[(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4>>2]|0)+(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4+4>>2]<<2)>>2]=0}else if((v|0)==10){g=(c[n>>2]|0)+1|0;c[n>>2]=g;if((g|0)<=5){c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4+4>>2]=0;g=bK(8)|0;c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4>>2]=g;g=c[p>>2]|0;e=(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4+4|0;f=c[e>>2]|0;c[e>>2]=f+1;c[(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4>>2]|0)+(f<<2)>>2]=g;c[(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4>>2]|0)+(c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+4+4>>2]<<2)>>2]=0;c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)>>2]=c[q>>2];c[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+12>>2]=0;h[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+16>>3]=0.0;break}c[n>>2]=(c[n>>2]|0)+-1;g=wB(c[o>>2]|0)|0;c[k>>2]=5;c[k+4>>2]=g;$z(1,124461,k)|0;c[l>>2]=c[n>>2];x=c[l>>2]|0;i=j;return x|0}while(0);bH(c[p>>2]|0,s,t);k=c[p>>2]|0;q=(c[((c[c[p>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)==(c[o>>2]|0)?c[t>>2]|0:c[s>>2]|0;c[u>>2]=q;if(q){q=(c[m>>2]|0)+((c[r>>2]|0)*24|0)+12|0;s=(c[q>>2]|0)+1|0;c[q>>2]=s;if((s|0)==1)y=+cH(c[p>>2]|0,c[u>>2]|0);else y=0.0;h[(c[m>>2]|0)+((c[r>>2]|0)*24|0)+16>>3]=y}c[l>>2]=c[n>>2];x=c[l>>2]|0;i=j;return x|0}function Qj(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0;f=i;i=i+208|0;g=f+196|0;j=f+192|0;k=f+188|0;l=f+184|0;m=f+180|0;n=f+176|0;o=f+152|0;p=f+144|0;q=f+136|0;r=f+128|0;s=f+120|0;t=f+112|0;u=f+104|0;v=f+64|0;w=f+172|0;x=f+168|0;y=f;c[g>>2]=b;c[j>>2]=d;h[f+160>>3]=e;h[o>>3]=0.0;h[p>>3]=0.0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break;c[l>>2]=c[(c[c[j>>2]>>2]|0)+(c[n>>2]<<2)>>2];d=c[l>>2]|0;b=c[c[l>>2]>>2]&3;if((c[((c[c[l>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)==(c[g>>2]|0)){d=c[l>>2]|0;c[k>>2]=c[((b|0)==3?d:d+32|0)+28>>2]}else{d=c[l>>2]|0;c[k>>2]=c[((b|0)==2?d:d+-32|0)+28>>2]}h[q>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];h[r>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];h[u>>3]=+d2(+h[q>>3],+h[r>>3]);h[o>>3]=+h[o>>3]+ +h[q>>3]/+h[u>>3];h[p>>3]=+h[p>>3]+ +h[r>>3]/+h[u>>3];c[n>>2]=(c[n>>2]|0)+1}h[u>>3]=+d2(+h[o>>3],+h[p>>3]);h[o>>3]=+h[o>>3]/+h[u>>3];h[p>>3]=+h[p>>3]/+h[u>>3];h[q>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];h[r>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];e=+h[(c[(c[g>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+96>>3];z=+h[(c[(c[g>>2]|0)+8>>2]|0)+80>>3];k=e>z+ +(c[(c[(qC(c[g>>2]|0)|0)+8>>2]|0)+252>>2]|0);d=c[(c[g>>2]|0)+8>>2]|0;if(k)A=+h[d+88>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+96>>3];else{z=+h[d+80>>3];A=z+ +(c[(c[(qC(c[g>>2]|0)|0)+8>>2]|0)+252>>2]|0)}h[u>>3]=A;h[s>>3]=+h[o>>3]*+h[u>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];h[t>>3]=+h[p>>3]*+h[u>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];h[y>>3]=+h[q>>3];h[y+8>>3]=+h[r>>3];h[y+16>>3]=(+h[q>>3]*2.0+ +h[s>>3])/3.0;h[y+16+8>>3]=(+h[r>>3]*2.0+ +h[t>>3])/3.0;h[y+32>>3]=(+h[s>>3]*2.0+ +h[q>>3])/3.0;h[y+32+8>>3]=(+h[t>>3]*2.0+ +h[r>>3])/3.0;h[y+48>>3]=+h[s>>3];h[y+48+8>>3]=+h[t>>3];hN(c[g>>2]|0,y);h[q>>3]=+h[y>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];h[r>>3]=+h[y+8>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];A=+h[q>>3];h[v>>3]=+(~~(+h[q>>3]>=0.0?A+.5:A-.5)|0);A=+h[r>>3];h[v+8>>3]=+(~~(+h[r>>3]>=0.0?A+.5:A-.5)|0);c[v+24>>2]=0;a[v+32>>0]=~~((+h[(c[(c[g>>2]|0)+8>>2]|0)+88>>3]+ +h[v>>3])*256.0/(+h[(c[(c[g>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[g>>2]|0)+8>>2]|0)+96>>3]));a[v+29>>0]=0;a[v+28>>0]=1;a[v+30>>0]=0;a[v+31>>0]=0;h[v+16>>3]=0.0;a[v+33>>0]=0;c[v+36>>2]=0;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break;c[l>>2]=c[(c[c[j>>2]>>2]|0)+(c[n>>2]<<2)>>2];bH(c[l>>2]|0,w,x);while(1){if(!(c[l>>2]|0))break;c[m>>2]=c[l>>2];while(1){if(!(c[m>>2]|0))break;r=c[m>>2]|0;if((c[((c[c[m>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)==(c[g>>2]|0)){B=(c[(c[m>>2]|0)+8>>2]|0)+56|0;C=v;D=B+40|0;do{c[B>>2]=c[C>>2];B=B+4|0;C=C+4|0}while((B|0)<(D|0))}r=c[m>>2]|0;if((c[((c[c[m>>2]>>2]&3|0)==3?r:r+32|0)+28>>2]|0)==(c[g>>2]|0)){B=(c[(c[m>>2]|0)+8>>2]|0)+16|0;C=v;D=B+40|0;do{c[B>>2]=c[C>>2];B=B+4|0;C=C+4|0}while((B|0)<(D|0))}if(((a[(c[(c[m>>2]|0)+8>>2]|0)+112>>0]|0)==1?(r=c[m>>2]|0,(a[(c[(c[((c[c[m>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)+8>>2]|0)+156>>0]|0)==1):0)?(r=c[m>>2]|0,(c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)+8>>2]|0)+180+4>>2]|0)==1):0){r=c[m>>2]|0;E=c[c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2]|0}else E=0;c[m>>2]=E}c[m>>2]=c[l>>2];while(1){if(!(c[m>>2]|0))break;r=c[m>>2]|0;if((c[((c[c[m>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)==(c[g>>2]|0)){B=(c[(c[m>>2]|0)+8>>2]|0)+56|0;C=v;D=B+40|0;do{c[B>>2]=c[C>>2];B=B+4|0;C=C+4|0}while((B|0)<(D|0))}r=c[m>>2]|0;if((c[((c[c[m>>2]>>2]&3|0)==3?r:r+32|0)+28>>2]|0)==(c[g>>2]|0)){B=(c[(c[m>>2]|0)+8>>2]|0)+16|0;C=v;D=B+40|0;do{c[B>>2]=c[C>>2];B=B+4|0;C=C+4|0}while((B|0)<(D|0))}if(((a[(c[(c[m>>2]|0)+8>>2]|0)+112>>0]|0)==1?(r=c[m>>2]|0,(a[(c[(c[((c[c[m>>2]>>2]&3|0)==3?r:r+32|0)+28>>2]|0)+8>>2]|0)+156>>0]|0)==1):0)?(r=c[m>>2]|0,(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?r:r+32|0)+28>>2]|0)+8>>2]|0)+172+4>>2]|0)==1):0){r=c[m>>2]|0;F=c[c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?r:r+32|0)+28>>2]|0)+8>>2]|0)+172>>2]>>2]|0}else F=0;c[m>>2]=F}c[l>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]}c[n>>2]=(c[n>>2]|0)+1}a[(c[(c[g>>2]|0)+8>>2]|0)+145>>0]=1;i=f;return}function Rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;Kg(c[d>>2]|0);a=c[d>>2]|0;f=c[d>>2]|0;g=Gg(c[((c[c[d>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0,c[((c[c[d>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)|0;c[e>>2]=g;f=c[d>>2]|0;if(g){Vg(f,c[e>>2]|0);i=b;return}else{e=c[d>>2]|0;g=c[d>>2]|0;Og(c[((c[f>>2]&3|0)==2?e:e+-32|0)+28>>2]|0,c[((c[c[d>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0,c[d>>2]|0)|0;i=b;return}}function Sj(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=b;c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[(c[(c[e>>2]|0)+8>>2]|0)+216+4>>2]|0))break;c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0)+(c[f>>2]<<2)>>2];c[g>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;a[(c[(c[g>>2]|0)+8>>2]|0)+157>>0]=0;c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}c[g>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[g>>2]|0))break;Tj(c[g>>2]|0);c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+164>>2]}c[f>>2]=(c[f>>2]|0)+1}i=d;return}function Tj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=b;if(a[(c[(c[e>>2]|0)+8>>2]|0)+157>>0]|0){i=d;return}a[(c[(c[e>>2]|0)+8>>2]|0)+157>>0]=1;a[(c[(c[e>>2]|0)+8>>2]|0)+158>>0]=1;c[f>>2]=0;while(1){b=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)+(c[f>>2]<<2)>>2]|0;c[g>>2]=b;if(!b)break;b=c[g>>2]|0;c[h>>2]=c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];if(!(a[(c[(c[h>>2]|0)+8>>2]|0)+158>>0]|0)){if(!(a[(c[(c[h>>2]|0)+8>>2]|0)+157>>0]|0))Tj(c[h>>2]|0)}else{Rj(c[g>>2]|0);c[f>>2]=(c[f>>2]|0)+-1}c[f>>2]=(c[f>>2]|0)+1}a[(c[(c[e>>2]|0)+8>>2]|0)+158>>0]=0;i=d;return}function Uj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[e>>2]=0;c[f>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[g>>2]=OA(c[d>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;a=c[g>>2]|0;h=c[g>>2]|0;if((c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)!=(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){h=c[g>>2]|0;a=c[g>>2]|0;j=(N((c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0)|0)-1|0;c[e>>2]=(c[e>>2]|0)+j}c[g>>2]=QA(c[d>>2]|0,c[g>>2]|0)|0}c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}i=b;return c[e>>2]|0}function Vj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=b;c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[(c[g>>2]|0)+8>>2]|0)+172+4>>2]|0))break;c[f>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)+(c[h>>2]<<2)>>2];a[(c[(c[f>>2]|0)+8>>2]|0)+112>>0]=0;c[h>>2]=(c[h>>2]|0)+1}c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}i=d;return}function Wj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;e=i;i=i+48|0;f=e+8|0;g=e+32|0;j=e+28|0;k=e+24|0;l=e+20|0;m=e+16|0;n=e;c[g>>2]=b;c[j>>2]=d;c[m>>2]=c[(c[j>>2]|0)+24>>2];h[n>>3]=1797693134862315708145274.0e284;Zj(c[g>>2]|0);c[l>>2]=0;while(1){if(!((c[l>>2]|0)<(c[m>>2]|0)?1:(c[m>>2]|0)==-1)){o=13;break}c[k>>2]=$B(c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]=0;c[k>>2]=aC(c[g>>2]|0,c[k>>2]|0)|0}Ti(c[g>>2]|0);p=+_j(c[g>>2]|0);h[(c[j>>2]|0)+8>>3]=p;if(a[138998]|0){d=c[24742]|0;h[f>>3]=+h[(c[j>>2]|0)+8>>3];Y2(d,124513,f)|0}if(+h[(c[j>>2]|0)+8>>3]<=+h[c[j>>2]>>3])break;if((c[m>>2]|0)==-1?+h[n>>3]<=+h[(c[j>>2]|0)+8>>3]:0)break;h[n>>3]=+h[(c[j>>2]|0)+8>>3];$j(c[g>>2]|0);c[l>>2]=(c[l>>2]|0)+1}if((o|0)==13){q=c[g>>2]|0;Ti(q);r=c[g>>2]|0;ak(r);s=c[g>>2]|0;bk(s);t=c[g>>2]|0;u=+_j(t);v=c[j>>2]|0;w=v+8|0;h[w>>3]=u;i=e;return}c[(c[j>>2]|0)+16>>2]=c[(c[j>>2]|0)+20>>2];c[(c[j>>2]|0)+20>>2]=c[l>>2];q=c[g>>2]|0;Ti(q);r=c[g>>2]|0;ak(r);s=c[g>>2]|0;bk(s);t=c[g>>2]|0;u=+_j(t);v=c[j>>2]|0;w=v+8|0;h[w>>3]=u;i=e;return}function Xj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]=0;c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function Yj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+48|0;e=d+16|0;f=d+8|0;g=d+40|0;h=d+36|0;j=d+32|0;k=d+28|0;l=d+20|0;c[h>>2]=a;c[j>>2]=b;c[l>>2]=5;c[k>>2]=yA(c[h>>2]|0,136937)|0;if((c[k>>2]|0)!=0?(h=c[k>>2]|0,c[f>>2]=d,c[f+4>>2]=l,l=l3(h,124528,f)|0,c[d+24>>2]=l,(l|0)>0):0){$z(0,124535,e)|0;c[(c[j>>2]|0)+24>>2]=0;c[(c[j>>2]|0)+32>>2]=0;c[g>>2]=0;m=c[g>>2]|0;i=d;return m|0}c[(c[j>>2]|0)+24>>2]=0;c[(c[j>>2]|0)+32>>2]=0;c[g>>2]=0;m=c[g>>2]|0;i=d;return m|0}function Zj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[12593]=cK((kB(c[d>>2]|0)|0)*24|0)|0;c[12592]=0;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[(c[(c[e>>2]|0)+8>>2]|0)+120>>2]=-1;c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;do if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0)){a=bK(4)|0;c[(c[12593]|0)+((c[12592]|0)*24|0)>>2]=a;c[c[(c[12593]|0)+((c[12592]|0)*24|0)>>2]>>2]=c[e>>2];c[(c[12593]|0)+((c[12592]|0)*24|0)+4>>2]=1;h[(c[12593]|0)+((c[12592]|0)*24|0)+8>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];h[(c[12593]|0)+((c[12592]|0)*24|0)+16>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3];c[(c[(c[e>>2]|0)+8>>2]|0)+120>>2]=c[12592];c[12592]=(c[12592]|0)+1}else{c[f>>2]=lO(c[e>>2]|0)|0;a=c[(c[f>>2]|0)+8>>2]|0;if((c[(c[(c[f>>2]|0)+8>>2]|0)+120>>2]|0)>-1){c[g>>2]=c[a+120>>2];j=c[e>>2]|0;k=(c[12593]|0)+((c[g>>2]|0)*24|0)+4|0;l=c[k>>2]|0;c[k>>2]=l+1;c[(c[(c[12593]|0)+((c[g>>2]|0)*24|0)>>2]|0)+(l<<2)>>2]=j;j=(c[12593]|0)+((c[g>>2]|0)*24|0)+8|0;h[j>>3]=+h[j>>3]+ +h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];if(+h[(c[12593]|0)+((c[g>>2]|0)*24|0)+16>>3]<+h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3])m=+h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3];else m=+h[(c[12593]|0)+((c[g>>2]|0)*24|0)+16>>3];h[(c[12593]|0)+((c[g>>2]|0)*24|0)+16>>3]=m;c[(c[(c[e>>2]|0)+8>>2]|0)+120>>2]=c[g>>2];break}j=bK(c[a+216>>2]<<2)|0;c[(c[12593]|0)+((c[12592]|0)*24|0)>>2]=j;j=(c[f>>2]|0)==(c[e>>2]|0);c[c[(c[12593]|0)+((c[12592]|0)*24|0)>>2]>>2]=c[f>>2];if(j){c[(c[12593]|0)+((c[12592]|0)*24|0)+4>>2]=1;h[(c[12593]|0)+((c[12592]|0)*24|0)+8>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3];h[(c[12593]|0)+((c[12592]|0)*24|0)+16>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3]}else{c[(c[(c[12593]|0)+((c[12592]|0)*24|0)>>2]|0)+4>>2]=c[e>>2];c[(c[12593]|0)+((c[12592]|0)*24|0)+4>>2]=2;h[(c[12593]|0)+((c[12592]|0)*24|0)+8>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3]+ +h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];if(+h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3]<+h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3])n=+h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3];else n=+h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3];h[(c[12593]|0)+((c[12592]|0)*24|0)+16>>3]=n}c[(c[(c[f>>2]|0)+8>>2]|0)+120>>2]=c[12592];c[(c[(c[e>>2]|0)+8>>2]|0)+120>>2]=c[12592];c[12592]=(c[12592]|0)+1}while(0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function _j(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b+32|0;e=b+28|0;f=b+24|0;g=b+16|0;j=b+8|0;k=b;c[d>>2]=a;h[g>>3]=0.0;ak(c[d>>2]|0);h[j>>3]=+(_((c[12590]|0)-1|0,c[(c[(c[d>>2]|0)+8>>2]|0)+252>>2]|0)|0);c[e>>2]=0;while(1){l=+h[g>>3];if((c[e>>2]|0)>=(c[12590]|0))break;if(l<+h[(c[12591]|0)+((c[e>>2]|0)*40|0)+24>>3]+ +(_(c[(c[12591]|0)+((c[e>>2]|0)*40|0)+16>>2]|0,c[(c[(c[d>>2]|0)+8>>2]|0)+248>>2]|0)|0)){h[g>>3]=+h[(c[12591]|0)+((c[e>>2]|0)*40|0)+24>>3]+ +(_(c[(c[12591]|0)+((c[e>>2]|0)*40|0)+16>>2]|0,c[(c[(c[d>>2]|0)+8>>2]|0)+248>>2]|0)|0);c[f>>2]=c[e>>2]}h[j>>3]=+h[j>>3]+ +h[(c[12591]|0)+((c[e>>2]|0)*40|0)+32>>3];c[e>>2]=(c[e>>2]|0)+1}h[k>>3]=l/+h[j>>3];i=b;return +(+h[k>>3])}function $j(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[12594]=bK((kB(c[d>>2]|0)|0)<<2)|0;c[e>>2]=0;while(1){a=c[e>>2]|0;if((a|0)>=(kB(c[d>>2]|0)|0))break;c[(c[12594]|0)+(c[e>>2]<<2)>>2]=c[e>>2];c[e>>2]=(c[e>>2]|0)+1}ak(c[d>>2]|0);ck(c[d>>2]|0);dk(c[d>>2]|0);i=b;return}function ak(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;j=b+8|0;k=b+4|0;l=b;c[d>>2]=a;c[12590]=0;if(c[12591]|0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[12592]|0))break;if(c[(c[12591]|0)+((c[e>>2]|0)*40|0)+4>>2]|0){c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[12591]|0)+((c[e>>2]|0)*40|0)+12>>2]|0))break;c[k>>2]=(c[k>>2]|0)+1}O4(c[(c[12591]|0)+((c[e>>2]|0)*40|0)+4>>2]|0)}if(c[(c[12591]|0)+((c[e>>2]|0)*40|0)+8>>2]|0)O4(c[(c[12591]|0)+((c[e>>2]|0)*40|0)+8>>2]|0);c[e>>2]=(c[e>>2]|0)+1}O4(c[12591]|0)}c[12591]=bK((c[12592]|0)*40|0)|0;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[12592]|0))break;k=bK(c[12592]<<2)|0;c[(c[12591]|0)+((c[e>>2]|0)*40|0)+4>>2]=k;k=bK(c[12592]<<2)|0;c[(c[12591]|0)+((c[e>>2]|0)*40|0)+8>>2]=k;c[(c[12591]|0)+((c[e>>2]|0)*40|0)>>2]=c[e>>2];c[(c[12591]|0)+((c[e>>2]|0)*40|0)+12>>2]=0;c[(c[12591]|0)+((c[e>>2]|0)*40|0)+16>>2]=0;h[(c[12591]|0)+((c[e>>2]|0)*40|0)+24>>3]=0.0;h[(c[12591]|0)+((c[e>>2]|0)*40|0)+32>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1}c[g>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[j>>2]=OA(c[d>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;k=c[j>>2]|0;c[l>>2]=(c[(c[(c[((c[c[j>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)+1;while(1){k=c[j>>2]|0;if((c[l>>2]|0)>=(c[(c[(c[((c[c[j>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0))break;k=(c[12591]|0)+((c[l>>2]|0)*40|0)+16|0;c[k>>2]=(c[k>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1}c[j>>2]=QA(c[d>>2]|0,c[j>>2]|0)|0}c[g>>2]=aC(c[d>>2]|0,c[g>>2]|0)|0}c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[12592]|0))break;c[f>>2]=c[c[(c[12593]|0)+((c[e>>2]|0)*24|0)>>2]>>2];if(((c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)+1|0)>(c[12590]|0))c[12590]=(c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)+1;m=+h[(c[12593]|0)+((c[e>>2]|0)*24|0)+8>>3]*72.0+ +(_(+h[(c[12591]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)*40|0)+24>>3]>0.0&1,c[(c[(c[d>>2]|0)+8>>2]|0)+248>>2]|0)|0);g=(c[12591]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)*40|0)+24|0;h[g>>3]=+h[g>>3]+m;if(+h[(c[12591]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)*40|0)+32>>3]<+h[(c[12593]|0)+((c[e>>2]|0)*24|0)+16>>3]*72.0)h[(c[12591]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)*40|0)+32>>3]=+h[(c[12593]|0)+((c[e>>2]|0)*24|0)+16>>3]*72.0;c[(c[(c[12591]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)*40|0)+4>>2]|0)+(c[(c[12591]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)*40|0)+12>>2]<<2)>>2]=(c[12593]|0)+((c[e>>2]|0)*24|0);g=(c[12591]|0)+((c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0)*40|0)+12|0;c[g>>2]=(c[g>>2]|0)+1;c[e>>2]=(c[e>>2]|0)+1}i=b;return}function bk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[b+28>>2]=a;c[f>>2]=0;c[g>>2]=0;c[d>>2]=0;while(1){if((c[d>>2]|0)>=(c[12590]|0))break;a=c[g>>2]|0;a:do if(c[(c[12591]|0)+((c[d>>2]|0)*40|0)+12>>2]|0){if((a|0)!=0?(c[(c[12591]|0)+((c[d>>2]|0)*40|0)>>2]|0)>(c[f>>2]|0):0){c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[12591]|0)+((c[d>>2]|0)*40|0)+12>>2]|0))break a;c[j>>2]=c[(c[(c[12591]|0)+((c[d>>2]|0)*40|0)+4>>2]|0)+(c[e>>2]<<2)>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>=(c[(c[j>>2]|0)+4>>2]|0))break;c[k>>2]=c[(c[c[j>>2]>>2]|0)+(c[h>>2]<<2)>>2];l=(c[(c[k>>2]|0)+8>>2]|0)+232|0;c[l>>2]=(c[l>>2]|0)-(c[g>>2]|0);c[h>>2]=(c[h>>2]|0)+1}c[e>>2]=(c[e>>2]|0)+1}}}else{if(!a)c[f>>2]=c[(c[12591]|0)+((c[d>>2]|0)*40|0)>>2];c[g>>2]=(c[g>>2]|0)+1}while(0);c[d>>2]=(c[d>>2]|0)+1}i=b;return}function ck(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=c[12594]|0;w3(a,kB(c[d>>2]|0)|0,4,63);i=b;return}function dk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0;d=i;i=i+80|0;e=d+72|0;f=d+68|0;g=d+64|0;j=d+16|0;k=d+8|0;l=d;m=d+60|0;n=d+56|0;o=d+52|0;p=d+48|0;q=d+44|0;r=d+40|0;s=d+36|0;t=d+32|0;u=d+28|0;v=d+24|0;c[e>>2]=b;h[k>>3]=0.0;c[f>>2]=0;while(1){if((c[f>>2]|0)>=(c[12590]|0))break;w=c[f>>2]|0;if((c[(c[12591]|0)+((c[(c[12594]|0)+(c[f>>2]<<2)>>2]|0)*40|0)+12>>2]|0)>1){x=4;break}c[f>>2]=w+1}if((x|0)==4){c[g>>2]=c[(c[12594]|0)+(w<<2)>>2];if((c[12590]|0)>((c[f>>2]|0)+1|0))y=+h[(c[12591]|0)+((c[(c[12594]|0)+((c[f>>2]|0)+1<<2)>>2]|0)*40|0)+24>>3];else y=0.0;h[j>>3]=y}if((c[f>>2]|0)==(c[12590]|0)){i=d;return}w3(c[(c[12591]|0)+((c[g>>2]|0)*40|0)+4>>2]|0,c[(c[12591]|0)+((c[g>>2]|0)*40|0)+12>>2]|0,4,64);if(!(!(+h[j>>3]<=+h[(c[12591]|0)+((c[g>>2]|0)*40|0)+24>>3]/4.0)?!(+h[j>>3]>=+h[(c[12591]|0)+((c[g>>2]|0)*40|0)+24>>3]*3.0/4.0):0))h[j>>3]=+h[(c[12591]|0)+((c[g>>2]|0)*40|0)+24>>3]/2.0;h[l>>3]=+h[j>>3];c[m>>2]=0;c[o>>2]=0;c[r>>2]=c[(c[12591]|0)+((c[g>>2]|0)*40|0)+12>>2];c[s>>2]=0;c[t>>2]=0;h[k>>3]=0.0;c[f>>2]=0;while(1){if((c[f>>2]|0)>=((c[r>>2]|0)+(c[s>>2]|0)|0))break;do if(c[(c[(c[12591]|0)+((c[g>>2]|0)*40|0)+8>>2]|0)+(c[f>>2]<<2)>>2]|0)c[s>>2]=(c[s>>2]|0)+1;else{y=+h[k>>3]+ +h[(c[(c[(c[12591]|0)+((c[g>>2]|0)*40|0)+4>>2]|0)+(c[f>>2]<<2)>>2]|0)+8>>3]*72.0+ +(_(+h[k>>3]>0.0&1,c[(c[(c[e>>2]|0)+8>>2]|0)+248>>2]|0)|0);j=c[(c[(c[12591]|0)+((c[g>>2]|0)*40|0)+4>>2]|0)+(c[f>>2]<<2)>>2]|0;if(!((c[m>>2]|0)!=0?!(y<=+h[l>>3]):0)){y=+h[j+8>>3]*72.0+ +(_(+h[k>>3]>0.0&1,c[(c[(c[e>>2]|0)+8>>2]|0)+248>>2]|0)|0);h[k>>3]=+h[k>>3]+y;if(c[m>>2]|0)break;c[n>>2]=c[(c[(c[12591]|0)+((c[g>>2]|0)*40|0)+4>>2]|0)+(c[f>>2]<<2)>>2];c[m>>2]=1;break}c[u>>2]=j;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[(c[n>>2]|0)+4>>2]|0))break;c[q>>2]=0;while(1){z=c[p>>2]|0;if((c[q>>2]|0)>=(c[(c[u>>2]|0)+4>>2]|0))break;c[v>>2]=Og(c[(c[c[n>>2]>>2]|0)+(z<<2)>>2]|0,c[(c[c[u>>2]>>2]|0)+(c[q>>2]<<2)>>2]|0,0)|0;a[(c[(c[v>>2]|0)+8>>2]|0)+112>>0]=1;c[o>>2]=(c[o>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1}c[p>>2]=z+1}c[(c[(c[12591]|0)+((c[g>>2]|0)*40|0)+8>>2]|0)+(c[f>>2]<<2)>>2]=1;c[t>>2]=(c[t>>2]|0)+1;j=(c[12591]|0)+((c[g>>2]|0)*40|0)+12|0;c[j>>2]=(c[j>>2]|0)+-1;j=(c[12591]|0)+((c[g>>2]|0)*40|0)+16|0;c[j>>2]=(c[j>>2]|0)+1;j=(c[12591]|0)+((c[g>>2]|0)*40|0)+24|0;h[j>>3]=+h[j>>3]-(+h[(c[u>>2]|0)+8>>3]*72.0+ +(c[(c[(c[e>>2]|0)+8>>2]|0)+248>>2]|0))}while(0);c[f>>2]=(c[f>>2]|0)+1}i=d;return}function ek(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d+20|0;f=d+16|0;g=d+12|0;h=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];c[h>>2]=c[f>>2];c[j>>2]=fk(c[c[g>>2]>>2]|0)|0;c[k>>2]=fk(c[c[h>>2]>>2]|0)|0;i=d;return ((c[k>>2]|0)<(c[j>>2]|0)&1)-((c[k>>2]|0)>(c[j>>2]|0)&1)|0}function fk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;c[f>>2]=0;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+4>>2]|0))break;c[g>>2]=c[(c[c[d>>2]>>2]|0)+(c[e>>2]<<2)>>2];c[j>>2]=qC(c[g>>2]|0)|0;c[h>>2]=OA(c[j>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;c[f>>2]=(c[f>>2]|0)+1;c[h>>2]=QA(c[j>>2]|0,c[h>>2]|0)|0}c[e>>2]=(c[e>>2]|0)+1}i=b;return c[f>>2]|0}function gk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[e>>2];c[j>>2]=c[f>>2];i=d;return (+h[(c[12591]|0)+((c[c[j>>2]>>2]|0)*40|0)+24>>3]>+h[(c[12591]|0)+((c[c[g>>2]>>2]|0)*40|0)+24>>3]&1)-(+h[(c[12591]|0)+((c[c[j>>2]>>2]|0)*40|0)+24>>3]<+h[(c[12591]|0)+((c[c[g>>2]>>2]|0)*40|0)+24>>3]&1)|0}function hk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;if((((c[13873]|0)!=0?(b=zA(c[f>>2]|0,c[13873]|0)|0,c[g>>2]=b,(b|0)!=0):0)?(a[c[g>>2]>>0]|0)!=0:0)?((kO(c[g>>2]|0)|0)&255|0)==0:0){c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function ik(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[d>>2]=a;wk(c[d>>2]|0);c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[h>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;do if(((c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]|0)==0?(hk(c[h>>2]|0)|0)==0:0)?(a=c[h>>2]|0,c[f>>2]=lO(c[((c[c[h>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)|0,a=c[h>>2]|0,c[g>>2]=lO(c[((c[c[h>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)|0,(c[f>>2]|0)!=(c[g>>2]|0)):0){if((c[(c[(c[f>>2]|0)+8>>2]|0)+212>>2]|0)==0?(c[(c[(c[g>>2]|0)+8>>2]|0)+212>>2]|0)==0:0){a=Gg(c[f>>2]|0,c[g>>2]|0)|0;c[j>>2]=a;if(a){Vg(c[h>>2]|0,c[j>>2]|0);break}else{Og(c[f>>2]|0,c[g>>2]|0,c[h>>2]|0)|0;break}}a=c[h>>2]|0;k=c[h>>2]|0;jk(c[d>>2]|0,c[((c[c[h>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0,c[((c[c[h>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0,c[h>>2]|0)}while(0);c[h>>2]=QA(c[d>>2]|0,c[h>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function jk(b,d,f,g){b=b|0;d=d|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+64|0;j=h+52|0;k=h+48|0;l=h+44|0;m=h+40|0;n=h+36|0;o=h+32|0;p=h+28|0;q=h+24|0;r=h+20|0;s=h+16|0;t=h+12|0;u=h+8|0;v=h+4|0;w=h;c[j>>2]=b;c[k>>2]=d;c[l>>2]=f;c[m>>2]=g;g=c[m>>2]|0;if(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0){g=c[m>>2]|0;f=c[m>>2]|0;c[t>>2]=(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[(c[(c[(c[(c[((c[c[m>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)+8>>2]|0)+264>>2]|0)+8>>2]|0)+232>>2]|0)}else c[t>>2]=0;f=c[m>>2]|0;if(c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0){f=c[m>>2]|0;g=c[m>>2]|0;c[u>>2]=(c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[(c[(c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+212>>2]|0)+8>>2]|0)+264>>2]|0)+8>>2]|0)+232>>2]|0)}else c[u>>2]=0;c[q>>2]=(e[(c[(c[m>>2]|0)+8>>2]|0)+170>>1]|0)+(c[t>>2]|0)-(c[u>>2]|0);if((c[q>>2]|0)>0){c[r>>2]=0;c[s>>2]=c[q>>2]}else{c[r>>2]=0-(c[q>>2]|0);c[s>>2]=0}c[n>>2]=Sg(c[j>>2]|0)|0;a[(c[(c[n>>2]|0)+8>>2]|0)+156>>0]=2;c[o>>2]=lO(c[k>>2]|0)|0;c[p>>2]=lO(c[l>>2]|0)|0;c[v>>2]=gi(c[n>>2]|0,c[o>>2]|0,+(c[r>>2]|0),(c[(c[(c[m>>2]|0)+8>>2]|0)+156>>2]|0)*10|0)|0;c[w>>2]=gi(c[n>>2]|0,c[p>>2]|0,+(c[s>>2]|0),c[(c[(c[m>>2]|0)+8>>2]|0)+156>>2]|0)|0;s=c[m>>2]|0;c[(c[(c[w>>2]|0)+8>>2]|0)+116>>2]=s;c[(c[(c[v>>2]|0)+8>>2]|0)+116>>2]=s;i=h;return}function kk(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=a;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;f=c[j>>2]|0;e=c[j>>2]|0;d=c[c[j>>2]>>2]&3;if((c[(c[(c[((c[c[j>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[(c[(c[((c[c[j>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){e=c[j>>2]|0;o=c[(c[(c[((d|0)==3?e:e+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0}else{e=c[j>>2]|0;o=c[(c[(c[((d|0)==2?e:e+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0}c[n>>2]=o;if(c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2]|0)La(124624,124646,149,124655);c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2]=c[k>>2];c[m>>2]=c[k>>2];while(1){if(c[l>>2]|0){k=(c[(c[m>>2]|0)+8>>2]|0)+168|0;b[k>>1]=(b[k>>1]|0)+(b[(c[(c[j>>2]|0)+8>>2]|0)+168>>1]|0)}k=(c[(c[m>>2]|0)+8>>2]|0)+154|0;b[k>>1]=(b[k>>1]|0)+(b[(c[(c[j>>2]|0)+8>>2]|0)+154>>1]|0);k=(c[(c[m>>2]|0)+8>>2]|0)+156|0;c[k>>2]=(c[k>>2]|0)+(c[(c[(c[j>>2]|0)+8>>2]|0)+156>>2]|0);k=c[m>>2]|0;if((c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)==(c[n>>2]|0)){p=11;break}k=c[m>>2]|0;nk(c[h>>2]|0,c[((c[c[m>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0);k=c[m>>2]|0;c[m>>2]=c[c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2];if(!(c[m>>2]|0)){p=11;break}}if((p|0)==11){i=g;return}}function lk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if(((((c[f>>2]|0)!=0&(c[g>>2]|0)!=0?(b=c[f>>2]|0,a=c[g>>2]|0,(c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)==(c[((c[c[g>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)):0)?(a=c[f>>2]|0,b=c[g>>2]|0,(c[((c[c[f>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)==(c[((c[c[g>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)):0)?(c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0)==(c[(c[(c[g>>2]|0)+8>>2]|0)+96>>2]|0):0)?(hi(c[f>>2]|0,c[g>>2]|0)|0)!=0:0){c[e>>2]=1;h=c[e>>2]|0;i=d;return h|0}c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function mk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[e>>2]=b;c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2]=0;c[(c[(c[e>>2]|0)+8>>2]|0)+232>>2]=0;wk(c[e>>2]|0);c[f>>2]=1;while(1){n=c[e>>2]|0;if((c[f>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;xk(n,c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[f>>2]<<2)>>2]|0);c[f>>2]=(c[f>>2]|0)+1}c[g>>2]=$B(n)|0;while(1){o=c[e>>2]|0;if(!(c[g>>2]|0))break;c[k>>2]=OA(o,c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;n=c[k>>2]|0;if((a[(c[(c[((c[c[k>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0)+8>>2]|0)+160>>0]|0)<=2){n=c[k>>2]|0;f=(c[(c[((c[c[k>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0)+8>>2]|0)+160|0;a[f>>0]=(a[f>>0]|0)+1<<24>>24}f=c[k>>2]|0;if((a[(c[(c[((c[c[k>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+160>>0]|0)<=2){f=c[k>>2]|0;n=(c[(c[((c[c[k>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+160|0;a[n>>0]=(a[n>>0]|0)+1<<24>>24}c[k>>2]=QA(c[e>>2]|0,c[k>>2]|0)|0}c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}c[g>>2]=$B(o)|0;while(1){if(!(c[g>>2]|0))break;if((c[(c[(c[g>>2]|0)+8>>2]|0)+212>>2]|0)==0?(o=c[g>>2]|0,(o|0)==(lO(c[g>>2]|0)|0)):0){Pg(c[e>>2]|0,c[g>>2]|0);o=(c[(c[e>>2]|0)+8>>2]|0)+232|0;c[o>>2]=(c[o>>2]|0)+1}c[l>>2]=0;c[k>>2]=OA(c[e>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;o=c[k>>2]|0;a:do if(!(c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]|0)){n=(ok(o)|0)!=0;f=c[l>>2]|0;if(n){if(!(lk(f,c[k>>2]|0)|0)){pk(c[e>>2]|0,c[k>>2]|0);c[l>>2]=c[k>>2];break}if(c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]|0){kk(c[e>>2]|0,c[k>>2]|0,c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]|0,0);Lg(c[k>>2]|0);break}n=c[k>>2]|0;b=c[k>>2]|0;if((c[(c[(c[((c[c[k>>2]>>2]&3|0)==3?n:n+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)!=(c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0))break;Vg(c[k>>2]|0,c[l>>2]|0);Lg(c[k>>2]|0);break}if(((f|0)!=0?(f=c[k>>2]|0,b=c[l>>2]|0,(c[((c[c[k>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)==(c[((c[c[l>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)):0)?(b=c[k>>2]|0,f=c[l>>2]|0,(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)==(c[((c[c[l>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)):0){f=c[k>>2]|0;b=c[k>>2]|0;n=c[k>>2]|0;if((c[(c[(c[((c[c[k>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){Vg(n,c[l>>2]|0);Lg(c[k>>2]|0);break}if(((c[(c[n+8>>2]|0)+96>>2]|0)==0?(c[(c[(c[l>>2]|0)+8>>2]|0)+96>>2]|0)==0:0)?(hi(c[k>>2]|0,c[l>>2]|0)|0)!=0:0)if(a[139e3]|0){a[(c[(c[k>>2]|0)+8>>2]|0)+112>>0]=6;break}else{kk(c[e>>2]|0,c[k>>2]|0,c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]|0,1);Lg(c[k>>2]|0);break}}n=c[k>>2]|0;b=c[k>>2]|0;f=c[k>>2]|0;if((c[((c[c[k>>2]>>2]&3|0)==3?n:n+32|0)+28>>2]|0)==(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)){Lg(f);c[l>>2]=c[k>>2];break}b=c[k>>2]|0;c[h>>2]=lO(c[((c[f>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0;b=c[k>>2]|0;c[j>>2]=lO(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)|0;b=c[k>>2]|0;if((c[((c[c[k>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)==(c[h>>2]|0)?(b=c[k>>2]|0,(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)==(c[j>>2]|0)):0){b=c[k>>2]|0;f=c[k>>2]|0;if((c[(c[(c[((c[c[k>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){Tg(c[e>>2]|0,c[k>>2]|0);c[l>>2]=c[k>>2];break}f=c[k>>2]|0;b=c[k>>2]|0;n=c[e>>2]|0;p=c[c[k>>2]>>2]&3;if((c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[(c[(c[((c[c[k>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){b=c[k>>2]|0;f=c[k>>2]|0;qk(n,c[((p|0)==3?b:b+32|0)+28>>2]|0,c[((c[c[k>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0,c[k>>2]|0);c[l>>2]=c[k>>2];break}f=c[k>>2]|0;b=c[k>>2]|0;q=VA(n,c[((p|0)==2?f:f+-32|0)+28>>2]|0,c[((c[c[k>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0,0,0)|0;c[m>>2]=q;do if((q|0)!=0?(b=c[m>>2]|0,f=c[k>>2]|0,(c[((c[c[m>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)!=(c[((c[c[k>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)):0){if(!(c[(c[(c[m>>2]|0)+8>>2]|0)+172>>2]|0)){f=c[m>>2]|0;b=c[m>>2]|0;qk(c[e>>2]|0,c[((c[c[m>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0,c[((c[c[m>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,c[m>>2]|0)}if((c[(c[(c[k>>2]|0)+8>>2]|0)+96>>2]|0)==0?(c[(c[(c[m>>2]|0)+8>>2]|0)+96>>2]|0)==0:0){if(!(hi(c[k>>2]|0,c[m>>2]|0)|0))break;b=c[k>>2]|0;if(a[139e3]|0){a[(c[b+8>>2]|0)+112>>0]=6;a[(c[(c[m>>2]|0)+8>>2]|0)+153>>0]=1;break a}else{Lg(b);kk(c[e>>2]|0,c[k>>2]|0,c[(c[(c[m>>2]|0)+8>>2]|0)+172>>2]|0,1);break a}}}while(0);q=c[k>>2]|0;b=c[k>>2]|0;qk(c[e>>2]|0,c[((c[c[k>>2]>>2]&3|0)==2?q:q+-32|0)+28>>2]|0,c[((c[c[k>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0,c[k>>2]|0);c[l>>2]=c[k>>2]}}else c[l>>2]=o;while(0);c[k>>2]=QA(c[e>>2]|0,c[k>>2]|0)|0}c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}g=c[e>>2]|0;if((g|0)==(uf(c[e>>2]|0)|0)){i=d;return}if(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0)r=eK(c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]|0,4)|0;else r=cK(4)|0;c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]=r;c[c[(c[(c[e>>2]|0)+8>>2]|0)+216>>2]>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];i=d;return}function nk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=(c[(c[(c[e>>2]|0)+8>>2]|0)+248>>2]|0)/2|0;e=(c[(c[f>>2]|0)+8>>2]|0)+88|0;h[e>>3]=+h[e>>3]+ +(c[g>>2]|0);e=(c[(c[f>>2]|0)+8>>2]|0)+96|0;h[e>>3]=+h[e>>3]+ +(c[g>>2]|0);i=d;return}function ok(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=c[e>>2]|0;if((a[(c[(c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+159>>0]|0)==7){f=1;g=f&1;i=d;return g|0}b=c[e>>2]|0;f=(a[(c[(c[((c[c[e>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+159>>0]|0)==7;g=f&1;i=d;return g|0}function pk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=b;c[g>>2]=d;d=c[g>>2]|0;c[h>>2]=tk(c[f>>2]|0,c[((c[c[g>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)|0;d=c[g>>2]|0;c[j>>2]=tk(c[f>>2]|0,c[((c[c[g>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)|0;if((c[(c[(c[h>>2]|0)+8>>2]|0)+232>>2]|0)>(c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0)){c[l>>2]=c[h>>2];c[h>>2]=c[j>>2];c[j>>2]=c[l>>2]}if((c[(c[(c[h>>2]|0)+8>>2]|0)+212>>2]|0)==(c[(c[(c[j>>2]|0)+8>>2]|0)+212>>2]|0)){i=e;return}l=Gg(c[h>>2]|0,c[j>>2]|0)|0;c[k>>2]=l;if(l){kk(c[f>>2]|0,c[g>>2]|0,c[k>>2]|0,1);i=e;return}if((c[(c[(c[h>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0)){i=e;return}qk(c[f>>2]|0,c[h>>2]|0,c[j>>2]|0,c[g>>2]|0);c[k>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2];while(1){if(!(c[k>>2]|0)){m=11;break}g=c[k>>2]|0;if((c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0)){m=11;break}a[(c[(c[k>>2]|0)+8>>2]|0)+112>>0]=5;c[k>>2]=c[c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?c[k>>2]|0:(c[k>>2]|0)+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2]}if((m|0)==11){i=e;return}}function qk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f+32|0;h=f+28|0;j=f+24|0;k=f+20|0;l=f+16|0;m=f+12|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[n>>2]=c[h>>2];if(c[(c[(c[k>>2]|0)+8>>2]|0)+96>>2]|0)c[m>>2]=((c[(c[(c[h>>2]|0)+8>>2]|0)+232>>2]|0)+(c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0)|0)/2|0;else c[m>>2]=-1;if(c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]|0)La(124667,124646,90,124692);c[l>>2]=(c[(c[(c[h>>2]|0)+8>>2]|0)+232>>2]|0)+1;while(1){if((c[l>>2]|0)>(c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0))break;if((c[l>>2]|0)<(c[(c[(c[j>>2]|0)+8>>2]|0)+232>>2]|0)){h=c[g>>2]|0;e=c[k>>2]|0;if((c[l>>2]|0)==(c[m>>2]|0))c[o>>2]=rk(h,e)|0;else c[o>>2]=sk(h,e)|0;c[(c[(c[o>>2]|0)+8>>2]|0)+232>>2]=c[l>>2]}else c[o>>2]=c[j>>2];c[p>>2]=Og(c[n>>2]|0,c[o>>2]|0,c[k>>2]|0)|0;lh(c[p>>2]|0);c[n>>2]=c[o>>2];c[l>>2]=(c[l>>2]|0)+1}if(c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]|0){i=f;return}else La(124703,124646,104,124692)}function rk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+16|0;k=e;c[f>>2]=b;c[g>>2]=d;d=(c[(c[(c[g>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];c[k+12>>2]=c[d+12>>2];c[j>>2]=Sg(c[f>>2]|0)|0;c[(c[(c[j>>2]|0)+8>>2]|0)+104>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+96>>2];l=+(c[(c[(rC(c[j>>2]|0)|0)+8>>2]|0)+248>>2]|0);h[(c[(c[j>>2]|0)+8>>2]|0)+88>>3]=l;if(a[(c[(c[g>>2]|0)+8>>2]|0)+114>>0]|0){m=c[j>>2]|0;i=e;return m|0}if(c[(c[(rC(c[f>>2]|0)|0)+8>>2]|0)+116>>2]&1){h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3]=+h[k>>3];h[(c[(c[j>>2]|0)+8>>2]|0)+96>>3]=+h[k+8>>3];m=c[j>>2]|0;i=e;return m|0}else{h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3]=+h[k+8>>3];h[(c[(c[j>>2]|0)+8>>2]|0)+96>>3]=+h[k>>3];m=c[j>>2]|0;i=e;return m|0}return 0}function sk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[f>>2]=c[f>>2];c[g>>2]=Sg(c[e>>2]|0)|0;nk(c[e>>2]|0,c[g>>2]|0);i=d;return c[g>>2]|0}function tk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[e+12>>2]=b;c[f>>2]=d;d=c[f>>2]|0;if((a[(c[(c[f>>2]|0)+8>>2]|0)+159>>0]|0)!=7){c[h>>2]=lO(d)|0;j=c[h>>2]|0;i=e;return j|0}else{c[g>>2]=c[(c[d+8>>2]|0)+212>>2];c[h>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+268>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]<<2)>>2];j=c[h>>2]|0;i=e;return j|0}return 0}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;i=i+32|0;d=b+24|0;e=b+20|0;f=b+16|0;g=b+12|0;h=b+8|0;j=b+4|0;k=b;c[d>>2]=a;c[e>>2]=uf(c[d>>2]|0)|0;c[f>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[h>>2]=0;c[g>>2]=TA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;c[j>>2]=UA(c[e>>2]|0,c[g>>2]|0,c[f>>2]|0)|0;do if(!(AC(c[d>>2]|0,c[g>>2]|0)|0)){a=c[g>>2]|0;c[g>>2]=(c[c[g>>2]>>2]&3|0)==2?a:a+-32|0;a=(lk(c[h>>2]|0,c[g>>2]|0)|0)!=0;l=c[g>>2]|0;m=c[g>>2]|0;n=(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0);if(a){if(n)c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]=c[h>>2];else c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]=0;if(!(c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]|0))break;kk(c[d>>2]|0,c[g>>2]|0,c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]|0,0);Mg(c[g>>2]|0);break}a=c[c[g>>2]>>2]&3;if(!n){n=c[g>>2]|0;m=c[g>>2]|0;l=c[e>>2]|0;o=c[c[g>>2]>>2]&3;if((c[(c[(c[((a|0)==2?n:n+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>(c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)){m=c[g>>2]|0;n=c[g>>2]|0;Ak(l,c[((o|0)==3?m:m+32|0)+28>>2]|0,c[((c[c[g>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0,c[g>>2]|0);c[h>>2]=c[g>>2];break}else{n=c[g>>2]|0;m=c[g>>2]|0;Ak(l,c[((o|0)==2?n:n+-32|0)+28>>2]|0,c[((c[c[g>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0,c[g>>2]|0);c[h>>2]=c[g>>2];break}}m=c[g>>2]|0;n=c[g>>2]|0;o=Hg(c[((a|0)==3?m:m+32|0)+28>>2]|0,c[((c[c[g>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0)|0;c[k>>2]=o;if(!o){Tg(c[e>>2]|0,c[g>>2]|0);c[h>>2]=c[g>>2];break}if((c[g>>2]|0)!=(c[k>>2]|0)?(Mg(c[g>>2]|0),(c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]|0)==0):0)Vg(c[g>>2]|0,c[k>>2]|0)}while(0);c[g>>2]=c[j>>2]}c[f>>2]=aC(c[d>>2]|0,c[f>>2]|0)|0}i=b;return}function vk(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;mk(c[d>>2]|0);c[(c[(c[d>>2]|0)+8>>2]|0)+216+4>>2]=1;c[c[(c[(c[d>>2]|0)+8>>2]|0)+216>>2]>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+192>>2];gh(c[d>>2]|0);ih(c[d>>2]|0,0);Bk(c[d>>2]|0);uk(c[d>>2]|0);Ck(c[d>>2]|0);i=b;return}function wk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+48|0;e=d;f=d+36|0;g=d+32|0;h=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;c[f>>2]=b;c[h>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;if((a[(c[(c[h>>2]|0)+8>>2]|0)+159>>0]|0)==7)nO(c[h>>2]|0);c[(c[(c[h>>2]|0)+8>>2]|0)+212>>2]=0;c[h>>2]=aC(c[f>>2]|0,c[h>>2]|0)|0}c[g>>2]=1;while(1){if((c[g>>2]|0)>(c[(c[(c[f>>2]|0)+8>>2]|0)+180>>2]|0))break;c[n>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+184>>2]|0)+(c[g>>2]<<2)>>2];c[h>>2]=$B(c[n>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;c[j>>2]=aC(c[n>>2]|0,c[h>>2]|0)|0;b=c[h>>2]|0;a:do if(a[(c[(c[h>>2]|0)+8>>2]|0)+159>>0]|0){o=wB(b)|0;p=wB(c[f>>2]|0)|0;c[e>>2]=o;c[e+4>>2]=p;$z(0,124728,e)|0;pC(c[n>>2]|0,c[h>>2]|0)|0}else{oO(b,c[(c[(c[n>>2]|0)+8>>2]|0)+264>>2]|0);c[(c[(c[h>>2]|0)+8>>2]|0)+212>>2]=c[n>>2];a[(c[(c[h>>2]|0)+8>>2]|0)+159>>0]=7;c[l>>2]=OA(c[n>>2]|0,c[h>>2]|0)|0;while(1){if(!(c[l>>2]|0))break a;p=c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]|0;c[m>>2]=p;b:do if((p|0)!=0&(c[m>>2]|0)!=0)do{o=c[m>>2]|0;q=c[((c[c[m>>2]>>2]&3|0)==2?o:o+-32|0)+28>>2]|0;c[k>>2]=q;if((a[(c[q+8>>2]|0)+156>>0]|0)!=1)break b;c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]=c[n>>2];q=c[m>>2]|0;c[m>>2]=c[c[(c[(c[((c[c[m>>2]>>2]&3|0)==2?q:q+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2]}while((c[m>>2]|0)!=0);while(0);c[l>>2]=QA(c[n>>2]|0,c[l>>2]|0)|0}}while(0);c[h>>2]=c[j>>2]}c[g>>2]=(c[g>>2]|0)+1}i=d;return}function xk(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=d;c[h>>2]=e;c[l>>2]=0;e=bK((b[(c[(c[h>>2]|0)+8>>2]|0)+238>>1]|0)+2<<2)|0;c[(c[(c[h>>2]|0)+8>>2]|0)+268>>2]=e;c[j>>2]=b[(c[(c[h>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[h>>2]|0)+8>>2]|0)+238>>1]|0))break;e=Sg(c[g>>2]|0)|0;c[(c[(c[(c[h>>2]|0)+8>>2]|0)+268>>2]|0)+(c[j>>2]<<2)>>2]=e;c[k>>2]=e;c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]=c[j>>2];a[(c[(c[k>>2]|0)+8>>2]|0)+159>>0]=7;c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]=c[h>>2];if(c[l>>2]|0){c[n>>2]=Og(c[l>>2]|0,c[k>>2]|0,0)|0;e=(c[(c[n>>2]|0)+8>>2]|0)+154|0;b[e>>1]=(b[e>>1]|0)*1e3}c[l>>2]=c[k>>2];c[j>>2]=(c[j>>2]|0)+1}c[k>>2]=$B(c[h>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;c[m>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+268>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]<<2)>>2];l=(c[(c[m>>2]|0)+8>>2]|0)+216|0;c[l>>2]=(c[l>>2]|0)+1;c[n>>2]=OA(c[h>>2]|0,c[k>>2]|0)|0;while(1){if(!(c[n>>2]|0))break;l=c[n>>2]|0;c[j>>2]=c[(c[(c[((c[c[n>>2]>>2]&3|0)==3?l:l+32|0)+28>>2]|0)+8>>2]|0)+232>>2];while(1){l=c[n>>2]|0;if((c[j>>2]|0)>=(c[(c[(c[((c[c[n>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0))break;l=(c[(c[c[(c[(c[m>>2]|0)+8>>2]|0)+180>>2]>>2]|0)+8>>2]|0)+168|0;b[l>>1]=(b[l>>1]|0)+1<<16>>16;c[j>>2]=(c[j>>2]|0)+1}c[n>>2]=QA(c[h>>2]|0,c[n>>2]|0)|0}c[k>>2]=aC(c[h>>2]|0,c[k>>2]|0)|0}c[j>>2]=b[(c[(c[h>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[j>>2]|0)>(b[(c[(c[h>>2]|0)+8>>2]|0)+238>>1]|0))break;c[m>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+268>>2]|0)+(c[j>>2]<<2)>>2];if((c[(c[(c[m>>2]|0)+8>>2]|0)+216>>2]|0)>1){k=(c[(c[m>>2]|0)+8>>2]|0)+216|0;c[k>>2]=(c[k>>2]|0)+-1}c[j>>2]=(c[j>>2]|0)+1}i=f;return}function yk(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[o>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2];if((a[(c[(c[o>>2]|0)+8>>2]|0)+273>>0]|0)==((c[l>>2]|0)+1|0)){i=h;return}c[n>>2]=b[(c[(c[o>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[n>>2]|0)>(b[(c[(c[o>>2]|0)+8>>2]|0)+238>>1]|0))break;hh(c[j>>2]|0,c[(c[(c[(c[o>>2]|0)+8>>2]|0)+268>>2]|0)+(c[n>>2]<<2)>>2]|0);c[n>>2]=(c[n>>2]|0)+1}c[n>>2]=b[(c[(c[o>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[n>>2]|0)>(b[(c[(c[o>>2]|0)+8>>2]|0)+238>>1]|0))break;jh(c[m>>2]|0,c[(c[(c[(c[o>>2]|0)+8>>2]|0)+268>>2]|0)+(c[n>>2]<<2)>>2]|0,c[l>>2]|0);c[n>>2]=(c[n>>2]|0)+1}a[(c[(c[o>>2]|0)+8>>2]|0)+273>>0]=(c[l>>2]|0)+1;i=h;return}function zk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+16|0;f=d+12|0;g=d+8|0;h=d+4|0;j=d;c[e>>2]=b;c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[(c[(c[f>>2]|0)+8>>2]|0)+212>>2]=0;c[h>>2]=OA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[h>>2]|0))break;b=c[(c[(c[h>>2]|0)+8>>2]|0)+172>>2]|0;c[j>>2]=b;a:do if((b|0)!=0&(c[j>>2]|0)!=0)do{k=c[j>>2]|0;l=c[((c[c[j>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0;c[g>>2]=l;if((a[(c[l+8>>2]|0)+156>>0]|0)!=1)break a;c[(c[(c[g>>2]|0)+8>>2]|0)+212>>2]=0;l=c[j>>2]|0;c[j>>2]=c[c[(c[(c[((c[c[j>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2]}while((c[j>>2]|0)!=0);while(0);c[h>>2]=QA(c[e>>2]|0,c[h>>2]|0)|0}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}Dk(c[e>>2]|0);i=d;return}function Ak(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+20|0;h=f+16|0;j=f+12|0;k=f+8|0;l=f+4|0;m=f;c[f+24>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=e;c[l>>2]=Fk(c[g>>2]|0)|0;c[m>>2]=Fk(c[h>>2]|0)|0;if((c[l>>2]|0)==(c[g>>2]|0)?(c[m>>2]|0)==(c[h>>2]|0):0)c[k>>2]=1;else c[k>>2]=5;Gk(c[l>>2]|0,c[m>>2]|0,c[j>>2]|0,c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2]|0,c[k>>2]|0);i=f;return}function Bk(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e+28|0;g=e+24|0;h=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e+4|0;n=e;c[f>>2]=d;c[n>>2]=uf(c[f>>2]|0)|0;if((b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0)>0)a[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+((b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1]|0)-1<<6)+49>>0]=0;c[j>>2]=b[(c[(c[f>>2]|0)+8>>2]|0)+236>>1];while(1){o=c[j>>2]|0;if((c[j>>2]|0)>(b[(c[(c[f>>2]|0)+8>>2]|0)+238>>1]|0))break;c[h>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(o<<6)>>2];d=c[(c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+268>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]|0)+236>>2]|0;c[k>>2]=d;c[l>>2]=d;Ek(c[n>>2]|0,c[j>>2]|0,c[k>>2]|0,c[h>>2]|0);c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;d=c[(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[g>>2]<<2)>>2]|0;c[(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[k>>2]<<2)>>2]=d;c[m>>2]=d;d=c[k>>2]|0;c[k>>2]=d+1;c[(c[(c[m>>2]|0)+8>>2]|0)+236>>2]=d;if((a[(c[(c[m>>2]|0)+8>>2]|0)+156>>0]|0)==1){d=rC(c[n>>2]|0)|0;c[(c[m>>2]|0)+12>>2]=d}Rg(c[f>>2]|0,c[m>>2]|0);Pg(c[n>>2]|0,c[m>>2]|0);d=(c[(c[n>>2]|0)+8>>2]|0)+232|0;c[d>>2]=(c[d>>2]|0)+1;c[g>>2]=(c[g>>2]|0)+1}c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]=(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[l>>2]<<2);a[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+49>>0]=0;c[j>>2]=(c[j>>2]|0)+1}if((o|0)>=(b[(c[(c[n>>2]|0)+8>>2]|0)+238>>1]|0)){p=c[f>>2]|0;q=p+8|0;r=c[q>>2]|0;s=r+272|0;a[s>>0]=1;i=e;return}a[(c[(c[(c[n>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+49>>0]=0;p=c[f>>2]|0;q=p+8|0;r=c[q>>2]|0;s=r+272|0;a[s>>0]=1;i=e;return}function Ck(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;h=d;c[e>>2]=a;c[f>>2]=b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[f>>2]|0)>(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0))break;c[g>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)+(c[f>>2]<<2)>>2];while(1){a=c[c[(c[(c[g>>2]|0)+8>>2]|0)+180>>2]>>2]|0;c[h>>2]=a;if(!a)break;Kg(c[h>>2]|0)}while(1){a=c[c[(c[(c[g>>2]|0)+8>>2]|0)+172>>2]>>2]|0;c[h>>2]=a;if(!a)break;Kg(c[h>>2]|0)}a=uf(c[e>>2]|0)|0;Rg(a,c[g>>2]|0);c[(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)+(c[f>>2]<<2)>>2]=0;c[f>>2]=(c[f>>2]|0)+1}i=d;return}function Dk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;k=d+4|0;l=d;c[e>>2]=b;c[l>>2]=1;while(1){if((c[l>>2]|0)>(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0))break;c[f>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+184>>2]|0)+(c[l>>2]<<2)>>2];Dk(c[f>>2]|0);c[l>>2]=(c[l>>2]|0)+1}c[g>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+212>>2]|0))c[(c[(c[g>>2]|0)+8>>2]|0)+212>>2]=c[e>>2];c[j>>2]=OA(c[e>>2]|0,c[g>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;l=c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2]|0;c[k>>2]=l;a:do if((l|0)!=0&(c[k>>2]|0)!=0)do{f=c[k>>2]|0;b=c[((c[c[k>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0;c[h>>2]=b;if((a[(c[b+8>>2]|0)+156>>0]|0)!=1)break a;if(!(c[(c[(c[h>>2]|0)+8>>2]|0)+212>>2]|0))c[(c[(c[h>>2]|0)+8>>2]|0)+212>>2]=c[e>>2];b=c[k>>2]|0;c[k>>2]=c[c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2]}while((c[k>>2]|0)!=0);while(0);c[j>>2]=QA(c[e>>2]|0,c[j>>2]|0)|0}c[g>>2]=aC(c[e>>2]|0,c[g>>2]|0)|0}i=d;return}function Ek(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[n>>2]=c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)+4>>2];if((c[k>>2]|0)<=0){c[l>>2]=(c[j>>2]|0)-(c[k>>2]|0)+1;while(1){if((c[l>>2]|0)>=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]|0))break;c[m>>2]=c[(c[n>>2]|0)+(c[l>>2]<<2)>>2];c[(c[(c[m>>2]|0)+8>>2]|0)+236>>2]=(c[l>>2]|0)+(c[k>>2]|0)-1;c[(c[n>>2]|0)+(c[(c[(c[m>>2]|0)+8>>2]|0)+236>>2]<<2)>>2]=c[m>>2];c[l>>2]=(c[l>>2]|0)+1}c[l>>2]=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]|0)+(c[k>>2]|0)-1;while(1){if((c[l>>2]|0)>=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]|0))break;c[(c[n>>2]|0)+(c[l>>2]<<2)>>2]=0;c[l>>2]=(c[l>>2]|0)+1}o=c[k>>2]|0;p=o-1|0;q=c[h>>2]|0;r=c[g>>2]|0;s=r+8|0;t=c[s>>2]|0;u=t+196|0;v=c[u>>2]|0;w=v+(q<<6)|0;x=c[w>>2]|0;y=x+p|0;c[w>>2]=y;i=f;return}else{c[l>>2]=(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+196>>2]|0)+(c[h>>2]<<6)>>2]|0)-1;while(1){if((c[l>>2]|0)<=(c[j>>2]|0))break;c[m>>2]=c[(c[n>>2]|0)+(c[l>>2]<<2)>>2];c[(c[(c[m>>2]|0)+8>>2]|0)+236>>2]=(c[l>>2]|0)+(c[k>>2]|0)-1;c[(c[n>>2]|0)+(c[(c[(c[m>>2]|0)+8>>2]|0)+236>>2]<<2)>>2]=c[m>>2];c[l>>2]=(c[l>>2]|0)+-1}c[l>>2]=(c[j>>2]|0)+1;while(1){if((c[l>>2]|0)>=((c[j>>2]|0)+(c[k>>2]|0)|0))break;c[(c[n>>2]|0)+(c[l>>2]<<2)>>2]=0;c[l>>2]=(c[l>>2]|0)+1}o=c[k>>2]|0;p=o-1|0;q=c[h>>2]|0;r=c[g>>2]|0;s=r+8|0;t=c[s>>2]|0;u=t+196|0;v=c[u>>2]|0;w=v+(q<<6)|0;x=c[w>>2]|0;y=x+p|0;c[w>>2]=y;i=f;return}}function Fk(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;i=i+16|0;e=b+4|0;f=b;c[e>>2]=a;if((c[(c[(c[e>>2]|0)+8>>2]|0)+212>>2]|0)!=0?(d[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+212>>2]|0)+8>>2]|0)+272>>0]|0|0)==0:0){c[f>>2]=c[(c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+212>>2]|0)+8>>2]|0)+268>>2]|0)+(c[(c[(c[e>>2]|0)+8>>2]|0)+232>>2]<<2)>>2];g=c[f>>2]|0;i=b;return g|0}c[f>>2]=c[e>>2];g=c[f>>2]|0;i=b;return g|0}function Gk(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;j=i;i=i+48|0;k=j+32|0;l=j+28|0;m=j+24|0;n=j+20|0;o=j+16|0;p=j+12|0;q=j+8|0;r=j+4|0;s=j;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;if((c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0)>=(c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0))La(124782,124810,81,124820);h=c[n>>2]|0;if((c[((c[c[n>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)==(c[k>>2]|0)?(h=c[n>>2]|0,(c[((c[c[n>>2]>>2]&3|0)==2?h:h+-32|0)+28>>2]|0)==(c[l>>2]|0)):0){i=j;return}if((b[(c[(c[n>>2]|0)+8>>2]|0)+168>>1]|0)>1){c[(c[(c[m>>2]|0)+8>>2]|0)+172>>2]=0;if((((c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0)|0)==1?(h=Gg(c[k>>2]|0,c[l>>2]|0)|0,c[s>>2]=h,(h|0)!=0):0)?(hi(c[m>>2]|0,c[s>>2]|0)|0)!=0:0){Vg(c[m>>2]|0,c[s>>2]|0);if(a[(c[(c[k>>2]|0)+8>>2]|0)+156>>0]|0){i=j;return}if(a[(c[(c[l>>2]|0)+8>>2]|0)+156>>0]|0){i=j;return}Lg(c[m>>2]|0);i=j;return}c[q>>2]=c[k>>2];c[p>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2];while(1){if((c[p>>2]|0)>=(c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0))break;if((c[p>>2]|0)<((c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0)-1|0)){h=uf(c[k>>2]|0)|0;g=c[n>>2]|0;c[r>>2]=Hk(h,c[((c[c[n>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)|0}else c[r>>2]=c[l>>2];c[s>>2]=Og(c[q>>2]|0,c[r>>2]|0,c[m>>2]|0)|0;a[(c[(c[s>>2]|0)+8>>2]|0)+112>>0]=c[o>>2];c[q>>2]=c[r>>2];g=(c[(c[n>>2]|0)+8>>2]|0)+168|0;b[g>>1]=(b[g>>1]|0)+-1<<16>>16;g=c[n>>2]|0;c[n>>2]=c[c[(c[(c[((c[c[n>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2];c[p>>2]=(c[p>>2]|0)+1}i=j;return}do if(((c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0)|0)==1){p=Gg(c[k>>2]|0,c[l>>2]|0)|0;c[n>>2]=p;if((p|0)!=0?(hi(c[m>>2]|0,c[n>>2]|0)|0)!=0:0){c[(c[(c[m>>2]|0)+8>>2]|0)+172>>2]=c[n>>2];a[(c[(c[n>>2]|0)+8>>2]|0)+112>>0]=c[o>>2];p=(c[(c[n>>2]|0)+8>>2]|0)+168|0;b[p>>1]=(b[p>>1]|0)+1<<16>>16;if(a[(c[(c[k>>2]|0)+8>>2]|0)+156>>0]|0)break;if(a[(c[(c[l>>2]|0)+8>>2]|0)+156>>0]|0)break;Lg(c[m>>2]|0);break}c[(c[(c[m>>2]|0)+8>>2]|0)+172>>2]=0;c[n>>2]=Og(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;a[(c[(c[n>>2]|0)+8>>2]|0)+112>>0]=c[o>>2]}while(0);if(((c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]|0)|0)<=1){i=j;return}c[s>>2]=c[n>>2];p=c[n>>2]|0;if((c[((c[c[n>>2]>>2]&3|0)==3?p:p+32|0)+28>>2]|0)!=(c[k>>2]|0)){c[(c[(c[m>>2]|0)+8>>2]|0)+172>>2]=0;p=c[n>>2]|0;r=Og(c[k>>2]|0,c[((c[c[n>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0,c[m>>2]|0)|0;c[(c[(c[m>>2]|0)+8>>2]|0)+172>>2]=r;c[s>>2]=r;Kg(c[n>>2]|0)}else c[s>>2]=c[n>>2];while(1){r=c[s>>2]|0;p=c[s>>2]|0;t=c[((c[c[s>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0;if((c[(c[(c[((c[c[s>>2]>>2]&3|0)==2?r:r+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]|0))break;c[s>>2]=c[c[(c[t+8>>2]|0)+180>>2]>>2]}if((t|0)==(c[l>>2]|0)){i=j;return}c[n>>2]=c[s>>2];t=c[s>>2]|0;c[s>>2]=Og(c[((c[c[s>>2]>>2]&3|0)==3?t:t+32|0)+28>>2]|0,c[l>>2]|0,c[m>>2]|0)|0;a[(c[(c[s>>2]|0)+8>>2]|0)+112>>0]=c[o>>2];Kg(c[n>>2]|0);i=j;return}function Hk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+16|0;e=d+12|0;f=d+8|0;g=d+4|0;j=d;c[e>>2]=a;c[f>>2]=b;c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2];Ek(c[e>>2]|0,c[j>>2]|0,c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2]|0,2);c[g>>2]=Sg(c[e>>2]|0)|0;h[(c[(c[g>>2]|0)+8>>2]|0)+88>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+88>>3];h[(c[(c[g>>2]|0)+8>>2]|0)+96>>3]=+h[(c[(c[f>>2]|0)+8>>2]|0)+96>>3];c[(c[(c[g>>2]|0)+8>>2]|0)+232>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2];c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]=(c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2]|0)+1;c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]<<2)>>2]=c[g>>2];i=d;return c[g>>2]|0}function Ik(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[d>>2]=a;c[g>>2]=FO(c[d>>2]|0)|0;c[f>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[e>>2]=OA(c[d>>2]|0,c[f>>2]|0)|0;while(1){h=c[d>>2]|0;if(!(c[e>>2]|0))break;Jk(h,c[e>>2]|0,c[g>>2]|0);c[e>>2]=QA(c[d>>2]|0,c[e>>2]|0)|0}c[f>>2]=aC(h,c[f>>2]|0)|0}Jz(c[g>>2]|0)|0;i=b;return}function Jk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;e=i;i=i+416|0;f=e+328|0;g=e+312|0;h=e+184|0;j=e+168|0;k=e+120|0;l=e+88|0;m=e+64|0;n=e+404|0;o=e+400|0;p=e+396|0;q=e+392|0;r=e+388|0;s=e+384|0;t=e+380|0;u=e+376|0;v=e+372|0;w=e+368|0;x=e+364|0;y=e+360|0;z=e+356|0;A=e+352|0;B=e+348|0;C=e+248|0;D=e+232|0;E=e+344|0;F=e+216|0;G=e+200|0;H=e+152|0;I=e+136|0;J=e+104|0;K=e+72|0;L=e+48|0;M=e+32|0;N=e+16|0;O=e;c[n>>2]=a;c[o>>2]=b;c[p>>2]=d;c[u>>2]=0;c[v>>2]=0;d=c[n>>2]|0;b=yA(c[o>>2]|0,124829)|0;c[q>>2]=Kk(d,b,c[p>>2]|0)|0;b=c[n>>2]|0;n=yA(c[o>>2]|0,124835)|0;c[r>>2]=Kk(b,n,c[p>>2]|0)|0;if(!((c[r>>2]|0)!=0|(c[q>>2]|0)!=0)){i=e;return}if(!(c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]|0)){i=e;return}p=c[o>>2]|0;if((c[(c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)>1){n=c[o>>2]|0;b=wB(c[((c[p>>2]&3|0)==3?n:n+32|0)+28>>2]|0)|0;n=c[o>>2]|0;d=wB(c[((c[c[o>>2]>>2]&3|0)==2?n:n+-32|0)+28>>2]|0)|0;c[m>>2]=b;c[m+4>>2]=d;$z(0,124841,m)|0;i=e;return}c[s>>2]=c[c[(c[p+8>>2]|0)+8>>2]>>2];c[B>>2]=c[(c[s>>2]|0)+4>>2];p=c[o>>2]|0;c[w>>2]=c[((c[c[o>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2];p=c[o>>2]|0;c[x>>2]=c[((c[c[o>>2]>>2]&3|0)==3?p:p+32|0)+28>>2];c[t>>2]=cK(48)|0;c[(c[t>>2]|0)+12>>2]=c[(c[s>>2]|0)+12>>2];c[(c[t>>2]|0)+8>>2]=c[(c[s>>2]|0)+8>>2];c[E>>2]=0;do if(c[q>>2]|0){c[y>>2]=(c[(c[q>>2]|0)+8>>2]|0)+16;p=(c[(c[w>>2]|0)+8>>2]|0)+16|0;m=c[y>>2]|0;c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];if(!(Lk(f,m)|0)){m=c[o>>2]|0;p=wB(c[((c[c[o>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)|0;m=c[o>>2]|0;d=wB(c[((c[c[o>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)|0;m=yA(c[o>>2]|0,124829)|0;c[l>>2]=p;c[l+4>>2]=d;c[l+8>>2]=m;$z(0,124882,l)|0;break}m=c[c[s>>2]>>2]|0;d=c[y>>2]|0;c[f>>2]=c[m>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];if(Lk(f,d)|0){d=(c[(c[x>>2]|0)+8>>2]|0)+16|0;m=c[y>>2]|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];if(Lk(f,m)|0){m=c[o>>2]|0;d=wB(c[((c[c[o>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)|0;m=c[o>>2]|0;p=wB(c[((c[c[o>>2]>>2]&3|0)==2?m:m+-32|0)+28>>2]|0)|0;m=yA(c[o>>2]|0,124829)|0;c[k>>2]=d;c[k+4>>2]=p;c[k+8>>2]=m;$z(0,124925,k)|0;break}if(!(c[(c[s>>2]|0)+8>>2]|0))La(124967,124978,361,124989);m=c[c[s>>2]>>2]|0;p=(c[s>>2]|0)+16|0;d=c[y>>2]|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];Mk(F,g,f,d);c[D>>2]=c[F>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];d=(c[c[s>>2]>>2]|0)+48|0;c[d>>2]=c[D>>2];c[d+4>>2]=c[D+4>>2];c[d+8>>2]=c[D+8>>2];c[d+12>>2]=c[D+12>>2];d=(c[c[s>>2]>>2]|0)+16|0;p=(c[s>>2]|0)+16|0;c[g>>2]=c[D>>2];c[g+4>>2]=c[D+4>>2];c[g+8>>2]=c[D+8>>2];c[g+12>>2]=c[D+12>>2];c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];Nk(G,g,f);c[d>>2]=c[G>>2];c[d+4>>2]=c[G+4>>2];c[d+8>>2]=c[G+8>>2];c[d+12>>2]=c[G+12>>2];d=c[c[s>>2]>>2]|0;p=(c[c[s>>2]>>2]|0)+16|0;m=(c[s>>2]|0)+16|0;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];c[f>>2]=c[m>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];Nk(H,g,f);c[d>>2]=c[H>>2];c[d+4>>2]=c[H+4>>2];c[d+8>>2]=c[H+8>>2];c[d+12>>2]=c[H+12>>2];d=(c[c[s>>2]>>2]|0)+32|0;m=(c[c[s>>2]>>2]|0)+16|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];c[f>>2]=c[D>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];Nk(I,g,f);c[d>>2]=c[I>>2];c[d+4>>2]=c[I+4>>2];c[d+8>>2]=c[I+8>>2];c[d+12>>2]=c[I+12>>2];if(c[(c[s>>2]|0)+12>>2]|0)c[v>>2]=dH(c[o>>2]|0,c[c[s>>2]>>2]|0,c[u>>2]|0,0,c[t>>2]|0,c[(c[s>>2]|0)+12>>2]|0)|0;c[v>>2]=(c[v>>2]|0)+3;c[E>>2]=1;break}c[v>>2]=0;while(1){if((c[v>>2]|0)>=((c[B>>2]|0)-1|0))break;if(Ok((c[c[s>>2]>>2]|0)+(c[v>>2]<<4)|0,c[y>>2]|0)|0)break;c[v>>2]=(c[v>>2]|0)+3}d=(c[(c[s>>2]|0)+12>>2]|0)!=0;do if((c[v>>2]|0)==((c[B>>2]|0)-1|0))if(d){m=(c[t>>2]|0)+32|0;p=(c[s>>2]|0)+32|0;b=(c[c[s>>2]>>2]|0)+(c[v>>2]<<4)|0;n=c[y>>2]|0;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];Mk(J,g,f,n);c[m>>2]=c[J>>2];c[m+4>>2]=c[J+4>>2];c[m+8>>2]=c[J+8>>2];c[m+12>>2]=c[J+12>>2];break}else La(125006,124978,379,124989);else{if(d)c[v>>2]=dH(c[o>>2]|0,c[c[s>>2]>>2]|0,c[u>>2]|0,c[v>>2]|0,c[t>>2]|0,c[(c[s>>2]|0)+12>>2]|0)|0;c[v>>2]=(c[v>>2]|0)+3}while(0);c[E>>2]=1}while(0);if((c[E>>2]|0)==0?(c[v>>2]=(c[B>>2]|0)-1,(c[(c[s>>2]|0)+12>>2]|0)!=0):0){B=(c[t>>2]|0)+32|0;J=(c[s>>2]|0)+32|0;c[B>>2]=c[J>>2];c[B+4>>2]=c[J+4>>2];c[B+8>>2]=c[J+8>>2];c[B+12>>2]=c[J+12>>2]}c[E>>2]=0;do if(c[r>>2]|0){c[y>>2]=(c[(c[r>>2]|0)+8>>2]|0)+16;J=(c[(c[x>>2]|0)+8>>2]|0)+16|0;B=c[y>>2]|0;c[f>>2]=c[J>>2];c[f+4>>2]=c[J+4>>2];c[f+8>>2]=c[J+8>>2];c[f+12>>2]=c[J+12>>2];if(!(Lk(f,B)|0)){B=c[o>>2]|0;J=wB(c[((c[c[o>>2]>>2]&3|0)==3?B:B+32|0)+28>>2]|0)|0;B=c[o>>2]|0;I=wB(c[((c[c[o>>2]>>2]&3|0)==2?B:B+-32|0)+28>>2]|0)|0;B=yA(c[o>>2]|0,124835)|0;c[j>>2]=J;c[j+4>>2]=I;c[j+8>>2]=B;$z(0,125017,j)|0;break}B=(c[c[s>>2]>>2]|0)+(c[v>>2]<<4)|0;I=c[y>>2]|0;c[f>>2]=c[B>>2];c[f+4>>2]=c[B+4>>2];c[f+8>>2]=c[B+8>>2];c[f+12>>2]=c[B+12>>2];if(Lk(f,I)|0){I=(c[(c[w>>2]|0)+8>>2]|0)+16|0;B=c[y>>2]|0;c[f>>2]=c[I>>2];c[f+4>>2]=c[I+4>>2];c[f+8>>2]=c[I+8>>2];c[f+12>>2]=c[I+12>>2];if(Lk(f,B)|0){B=c[o>>2]|0;I=wB(c[((c[c[o>>2]>>2]&3|0)==3?B:B+32|0)+28>>2]|0)|0;B=c[o>>2]|0;J=wB(c[((c[c[o>>2]>>2]&3|0)==2?B:B+-32|0)+28>>2]|0)|0;B=yA(c[o>>2]|0,124835)|0;c[h>>2]=I;c[h+4>>2]=J;c[h+8>>2]=B;$z(0,125060,h)|0;break}if(!(c[(c[s>>2]|0)+12>>2]|0))La(125006,124978,421,124989);B=(c[c[s>>2]>>2]|0)+(c[v>>2]<<4)|0;J=(c[t>>2]|0)+32|0;I=c[y>>2]|0;c[g>>2]=c[B>>2];c[g+4>>2]=c[B+4>>2];c[g+8>>2]=c[B+8>>2];c[g+12>>2]=c[B+12>>2];c[f>>2]=c[J>>2];c[f+4>>2]=c[J+4>>2];c[f+8>>2]=c[J+8>>2];c[f+12>>2]=c[J+12>>2];Mk(K,g,f,I);c[D>>2]=c[K>>2];c[D+4>>2]=c[K+4>>2];c[D+8>>2]=c[K+8>>2];c[D+12>>2]=c[K+12>>2];c[u>>2]=(c[v>>2]|0)-3;I=(c[c[s>>2]>>2]|0)+(c[u>>2]<<4)|0;c[I>>2]=c[D>>2];c[I+4>>2]=c[D+4>>2];c[I+8>>2]=c[D+8>>2];c[I+12>>2]=c[D+12>>2];I=(c[c[s>>2]>>2]|0)+((c[u>>2]|0)+2<<4)|0;J=(c[t>>2]|0)+32|0;c[g>>2]=c[D>>2];c[g+4>>2]=c[D+4>>2];c[g+8>>2]=c[D+8>>2];c[g+12>>2]=c[D+12>>2];c[f>>2]=c[J>>2];c[f+4>>2]=c[J+4>>2];c[f+8>>2]=c[J+8>>2];c[f+12>>2]=c[J+12>>2];Nk(L,g,f);c[I>>2]=c[L>>2];c[I+4>>2]=c[L+4>>2];c[I+8>>2]=c[L+8>>2];c[I+12>>2]=c[L+12>>2];I=(c[c[s>>2]>>2]|0)+((c[u>>2]|0)+3<<4)|0;J=(c[c[s>>2]>>2]|0)+((c[u>>2]|0)+2<<4)|0;B=(c[t>>2]|0)+32|0;c[g>>2]=c[J>>2];c[g+4>>2]=c[J+4>>2];c[g+8>>2]=c[J+8>>2];c[g+12>>2]=c[J+12>>2];c[f>>2]=c[B>>2];c[f+4>>2]=c[B+4>>2];c[f+8>>2]=c[B+8>>2];c[f+12>>2]=c[B+12>>2];Nk(M,g,f);c[I>>2]=c[M>>2];c[I+4>>2]=c[M+4>>2];c[I+8>>2]=c[M+8>>2];c[I+12>>2]=c[M+12>>2];I=(c[c[s>>2]>>2]|0)+((c[u>>2]|0)+1<<4)|0;B=(c[c[s>>2]>>2]|0)+((c[u>>2]|0)+2<<4)|0;c[g>>2]=c[B>>2];c[g+4>>2]=c[B+4>>2];c[g+8>>2]=c[B+8>>2];c[g+12>>2]=c[B+12>>2];c[f>>2]=c[D>>2];c[f+4>>2]=c[D+4>>2];c[f+8>>2]=c[D+8>>2];c[f+12>>2]=c[D+12>>2];Nk(N,g,f);c[I>>2]=c[N>>2];c[I+4>>2]=c[N+4>>2];c[I+8>>2]=c[N+8>>2];c[I+12>>2]=c[N+12>>2];if(c[(c[s>>2]|0)+8>>2]|0)c[u>>2]=eH(c[o>>2]|0,c[c[s>>2]>>2]|0,c[u>>2]|0,(c[v>>2]|0)-3|0,c[t>>2]|0,c[(c[s>>2]|0)+8>>2]|0)|0;c[E>>2]=1;break}c[u>>2]=c[v>>2];while(1){if((c[u>>2]|0)<=0)break;c[z>>2]=0;while(1){if((c[z>>2]|0)>=4)break;I=C+(c[z>>2]<<4)|0;B=(c[c[s>>2]>>2]|0)+((c[u>>2]|0)-(c[z>>2]|0)<<4)|0;c[I>>2]=c[B>>2];c[I+4>>2]=c[B+4>>2];c[I+8>>2]=c[B+8>>2];c[I+12>>2]=c[B+12>>2];c[z>>2]=(c[z>>2]|0)+1}if(Ok(C,c[y>>2]|0)|0){P=48;break}c[u>>2]=(c[u>>2]|0)-3}a:do if((P|0)==48){c[z>>2]=0;while(1){if((c[z>>2]|0)>=4)break a;B=(c[c[s>>2]>>2]|0)+((c[u>>2]|0)-(c[z>>2]|0)<<4)|0;I=C+(c[z>>2]<<4)|0;c[B>>2]=c[I>>2];c[B+4>>2]=c[I+4>>2];c[B+8>>2]=c[I+8>>2];c[B+12>>2]=c[I+12>>2];c[z>>2]=(c[z>>2]|0)+1}}while(0);do if(!(c[u>>2]|0))if(c[(c[s>>2]|0)+8>>2]|0){I=(c[t>>2]|0)+16|0;B=(c[s>>2]|0)+16|0;J=(c[c[s>>2]>>2]|0)+(c[u>>2]<<4)|0;H=c[y>>2]|0;c[g>>2]=c[B>>2];c[g+4>>2]=c[B+4>>2];c[g+8>>2]=c[B+8>>2];c[g+12>>2]=c[B+12>>2];c[f>>2]=c[J>>2];c[f+4>>2]=c[J+4>>2];c[f+8>>2]=c[J+8>>2];c[f+12>>2]=c[J+12>>2];Mk(O,g,f,H);c[I>>2]=c[O>>2];c[I+4>>2]=c[O+4>>2];c[I+8>>2]=c[O+8>>2];c[I+12>>2]=c[O+12>>2];break}else La(124967,124978,444,124989);else{c[u>>2]=(c[u>>2]|0)-3;if(c[(c[s>>2]|0)+8>>2]|0)c[u>>2]=eH(c[o>>2]|0,c[c[s>>2]>>2]|0,c[u>>2]|0,(c[v>>2]|0)-3|0,c[t>>2]|0,c[(c[s>>2]|0)+8>>2]|0)|0}while(0);c[E>>2]=1}while(0);if((c[E>>2]|0)==0?(c[(c[s>>2]|0)+8>>2]|0)!=0:0){E=(c[t>>2]|0)+16|0;O=(c[s>>2]|0)+16|0;c[E>>2]=c[O>>2];c[E+4>>2]=c[O+4>>2];c[E+8>>2]=c[O+8>>2];c[E+12>>2]=c[O+12>>2]}c[(c[t>>2]|0)+4>>2]=(c[v>>2]|0)-(c[u>>2]|0)+1;v=cK(c[(c[t>>2]|0)+4>>2]<<4)|0;c[c[t>>2]>>2]=v;c[z>>2]=0;c[A>>2]=c[u>>2];while(1){if((c[z>>2]|0)>=(c[(c[t>>2]|0)+4>>2]|0))break;u=(c[c[t>>2]>>2]|0)+(c[z>>2]<<4)|0;v=(c[c[s>>2]>>2]|0)+(c[A>>2]<<4)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[z>>2]=(c[z>>2]|0)+1;c[A>>2]=(c[A>>2]|0)+1}O4(c[c[s>>2]>>2]|0);O4(c[s>>2]|0);c[c[(c[(c[o>>2]|0)+8>>2]|0)+8>>2]>>2]=c[t>>2];i=e;return}function Kk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+20|0;j=f+12|0;k=f+8|0;l=f+4|0;c[f+16>>2]=b;c[j>>2]=d;c[k>>2]=e;if((c[j>>2]|0)!=0?(a[c[j>>2]>>0]|0)!=0:0){c[l>>2]=WO(c[k>>2]|0,c[j>>2]|0)|0;if(!(c[l>>2]|0)){c[g>>2]=c[j>>2];$z(0,125180,g)|0}c[h>>2]=c[l>>2];m=c[h>>2]|0;i=f;return m|0}c[h>>2]=0;m=c[h>>2]|0;i=f;return m|0}function Lk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if((+h[c[e>>2]>>3]<=+h[a>>3]?+h[a>>3]<=+h[(c[e>>2]|0)+16>>3]:0)?+h[(c[e>>2]|0)+8>>3]<=+h[a+8>>3]:0)f=+h[a+8>>3]<=+h[(c[e>>2]|0)+16+8>>3];else f=0;i=d;return f&1|0}function Mk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+528|0;g=f+96|0;j=f+64|0;k=f+112|0;l=f+80|0;m=f+56|0;n=f+48|0;o=f+40|0;p=f+32|0;q=f+16|0;r=f;s=f+416|0;t=f+316|0;u=f+216|0;v=f+116|0;c[k>>2]=e;h[m>>3]=+h[b>>3];h[n>>3]=+h[b+8>>3];h[o>>3]=+h[d>>3];h[p>>3]=+h[d+8>>3];e=c[k>>2]|0;c[q>>2]=c[e>>2];c[q+4>>2]=c[e+4>>2];c[q+8>>2]=c[e+8>>2];c[q+12>>2]=c[e+12>>2];e=(c[k>>2]|0)+16|0;c[r>>2]=c[e>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];if((+h[d>>3]<+h[q>>3]?(h[l>>3]=+h[q>>3],h[l+8>>3]=+h[b+8>>3]+ +(~~((+h[l>>3]-+h[m>>3])*(+h[n>>3]-+h[p>>3])/(+h[m>>3]-+h[o>>3]))|0),+h[l+8>>3]>=+h[q+8>>3]):0)?+h[l+8>>3]<=+h[r+8>>3]:0){c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];i=f;return}if((+h[d>>3]>+h[r>>3]?(h[l>>3]=+h[r>>3],h[l+8>>3]=+h[b+8>>3]+ +(~~((+h[l>>3]-+h[m>>3])*(+h[n>>3]-+h[p>>3])/(+h[m>>3]-+h[o>>3]))|0),+h[l+8>>3]>=+h[q+8>>3]):0)?+h[l+8>>3]<=+h[r+8>>3]:0){c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];i=f;return}if((+h[d+8>>3]<+h[q+8>>3]?(h[l+8>>3]=+h[q+8>>3],h[l>>3]=+h[b>>3]+ +(~~((+h[l+8>>3]-+h[n>>3])*(+h[m>>3]-+h[o>>3])/(+h[n>>3]-+h[p>>3]))|0),+h[l>>3]>=+h[q>>3]):0)?+h[l>>3]<=+h[r>>3]:0){c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];i=f;return}if((+h[d+8>>3]>+h[r+8>>3]?(h[l+8>>3]=+h[r+8>>3],h[l>>3]=+h[b>>3]+ +(~~((+h[l+8>>3]-+h[n>>3])*(+h[m>>3]-+h[o>>3])/(+h[n>>3]-+h[p>>3]))|0),+h[l>>3]>=+h[q>>3]):0)?+h[l>>3]<=+h[r>>3]:0){c[a>>2]=c[l>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];c[a+12>>2]=c[l+12>>2];i=f;return};c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];b=Tk(g,s)|0;c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];d=Tk(g,t)|0;c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];c[g+12>>2]=c[q+12>>2];q=Tk(g,u)|0;c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];r=Tk(g,v)|0;c[j>>2]=b;c[j+4>>2]=d;c[j+8>>2]=q;c[j+12>>2]=r;$z(1,125102,j)|0;La(176099,124978,78,125154)}function Nk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=(+h[b>>3]+ +h[d>>3])/2.0;h[f+8>>3]=(+h[b+8>>3]+ +h[d+8>>3])/2.0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function Ok(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+160|0;e=d+156|0;f=d+152|0;g=d+148|0;j=d+136|0;k=d+128|0;l=d+64|0;m=d+144|0;n=d+48|0;o=d+32|0;p=d+16|0;q=d;c[f>>2]=a;c[g>>2]=b;h[j>>3]=2.0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=4)break;b=l+(c[m>>2]<<4)|0;a=(c[f>>2]|0)+(c[m>>2]<<4)|0;c[b>>2]=c[a>>2];c[b+4>>2]=c[a+4>>2];c[b+8>>2]=c[a+8>>2];c[b+12>>2]=c[a+12>>2];c[m>>2]=(c[m>>2]|0)+1}h[k>>3]=+Pk(c[f>>2]|0,0.0,1.0,+h[c[g>>2]>>3],+h[(c[g>>2]|0)+8>>3],+h[(c[g>>2]|0)+16+8>>3]);if(+h[k>>3]>=0.0?+h[k>>3]<+h[j>>3]:0){qO(n,l,3,+h[k>>3],c[f>>2]|0,0);h[j>>3]=+h[k>>3]}h[k>>3]=+Pk(c[f>>2]|0,0.0,1.0<+h[j>>3]?1.0:+h[j>>3],+h[(c[g>>2]|0)+16>>3],+h[(c[g>>2]|0)+8>>3],+h[(c[g>>2]|0)+16+8>>3]);if(+h[k>>3]>=0.0?+h[k>>3]<+h[j>>3]:0){qO(o,l,3,+h[k>>3],c[f>>2]|0,0);h[j>>3]=+h[k>>3]}h[k>>3]=+Qk(c[f>>2]|0,0.0,1.0<+h[j>>3]?1.0:+h[j>>3],+h[(c[g>>2]|0)+8>>3],+h[c[g>>2]>>3],+h[(c[g>>2]|0)+16>>3]);if(+h[k>>3]>=0.0?+h[k>>3]<+h[j>>3]:0){qO(p,l,3,+h[k>>3],c[f>>2]|0,0);h[j>>3]=+h[k>>3]}h[k>>3]=+Qk(c[f>>2]|0,0.0,1.0<+h[j>>3]?1.0:+h[j>>3],+h[(c[g>>2]|0)+16+8>>3],+h[c[g>>2]>>3],+h[(c[g>>2]|0)+16>>3]);if(+h[k>>3]>=0.0?+h[k>>3]<+h[j>>3]:0){qO(q,l,3,+h[k>>3],c[f>>2]|0,0);h[j>>3]=+h[k>>3]}if(+h[j>>3]<2.0){c[e>>2]=1;r=c[e>>2]|0;i=d;return r|0}else{c[e>>2]=0;r=c[e>>2]|0;i=d;return r|0}return 0}function Pk(a,b,d,e,f,g){a=a|0;b=+b;d=+d;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;j=i;i=i+208|0;k=j+192|0;l=j+204|0;m=j+184|0;n=j+176|0;o=j+168|0;p=j+160|0;q=j+152|0;r=j+88|0;s=j+24|0;t=j+16|0;u=j+200|0;v=j;c[l>>2]=a;h[m>>3]=b;h[n>>3]=d;h[o>>3]=e;h[p>>3]=f;h[q>>3]=g;c[u>>2]=Sk(c[l>>2]|0,+h[o>>3])|0;if(!(c[u>>2]|0)){h[k>>3]=-1.0;w=+h[k>>3];i=j;return +w}if((c[u>>2]|0)==1?(g=+h[(c[l>>2]|0)+48>>3],f=+h[o>>3],(~~(+h[(c[l>>2]|0)+48>>3]>=0.0?g+.5:g-.5)|0)==(~~(+h[o>>3]>=0.0?f+.5:f-.5)|0)):0){if(+h[p>>3]<=+h[(c[l>>2]|0)+48+8>>3]?+h[(c[l>>2]|0)+48+8>>3]<=+h[q>>3]:0){h[k>>3]=+h[n>>3];w=+h[k>>3];i=j;return +w}h[k>>3]=-1.0;w=+h[k>>3];i=j;return +w}qO(v,c[l>>2]|0,3,.5,r,s);h[t>>3]=+Pk(r,+h[m>>3],(+h[m>>3]+ +h[n>>3])/2.0,+h[o>>3],+h[p>>3],+h[q>>3]);if(+h[t>>3]>=0.0){h[k>>3]=+h[t>>3];w=+h[k>>3];i=j;return +w}else{h[k>>3]=+Pk(s,(+h[m>>3]+ +h[n>>3])/2.0,+h[n>>3],+h[o>>3],+h[p>>3],+h[q>>3]);w=+h[k>>3];i=j;return +w}return +(0.0)}function Qk(a,b,d,e,f,g){a=a|0;b=+b;d=+d;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;j=i;i=i+208|0;k=j+192|0;l=j+204|0;m=j+184|0;n=j+176|0;o=j+168|0;p=j+160|0;q=j+152|0;r=j+88|0;s=j+24|0;t=j+16|0;u=j+200|0;v=j;c[l>>2]=a;h[m>>3]=b;h[n>>3]=d;h[o>>3]=e;h[p>>3]=f;h[q>>3]=g;c[u>>2]=Rk(c[l>>2]|0,+h[o>>3])|0;if(!(c[u>>2]|0)){h[k>>3]=-1.0;w=+h[k>>3];i=j;return +w}if((c[u>>2]|0)==1?(g=+h[(c[l>>2]|0)+48+8>>3],f=+h[o>>3],(~~(+h[(c[l>>2]|0)+48+8>>3]>=0.0?g+.5:g-.5)|0)==(~~(+h[o>>3]>=0.0?f+.5:f-.5)|0)):0){if(+h[p>>3]<=+h[(c[l>>2]|0)+48>>3]?+h[(c[l>>2]|0)+48>>3]<=+h[q>>3]:0){h[k>>3]=+h[n>>3];w=+h[k>>3];i=j;return +w}h[k>>3]=-1.0;w=+h[k>>3];i=j;return +w}qO(v,c[l>>2]|0,3,.5,r,s);h[t>>3]=+Qk(r,+h[m>>3],(+h[m>>3]+ +h[n>>3])/2.0,+h[o>>3],+h[p>>3],+h[q>>3]);if(+h[t>>3]>=0.0){h[k>>3]=+h[t>>3];w=+h[k>>3];i=j;return +w}else{h[k>>3]=+Qk(s,(+h[m>>3]+ +h[n>>3])/2.0,+h[n>>3],+h[o>>3],+h[p>>3],+h[q>>3]);w=+h[k>>3];i=j;return +w}return +(0.0)}function Rk(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d;g=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;c[e>>2]=a;h[f>>3]=b;c[l>>2]=0;if(+h[(c[e>>2]|0)+8>>3]<+h[f>>3])m=-1;else m=+h[(c[e>>2]|0)+8>>3]>+h[f>>3]?1:0;c[j>>2]=m;if(!(c[j>>2]|0))c[l>>2]=(c[l>>2]|0)+1;c[g>>2]=1;while(1){if((c[g>>2]|0)>3)break;c[k>>2]=c[j>>2];if(+h[(c[e>>2]|0)+(c[g>>2]<<4)+8>>3]<+h[f>>3])n=-1;else n=+h[(c[e>>2]|0)+(c[g>>2]<<4)+8>>3]>+h[f>>3]?1:0;c[j>>2]=n;if((c[k>>2]|0)!=0?(c[j>>2]|0)!=(c[k>>2]|0):0)c[l>>2]=(c[l>>2]|0)+1;c[g>>2]=(c[g>>2]|0)+1}i=d;return c[l>>2]|0}function Sk(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+32|0;e=d+24|0;f=d;g=d+20|0;j=d+16|0;k=d+12|0;l=d+8|0;c[e>>2]=a;h[f>>3]=b;c[l>>2]=0;if(+h[c[e>>2]>>3]<+h[f>>3])m=-1;else m=+h[c[e>>2]>>3]>+h[f>>3]?1:0;c[j>>2]=m;if(!(c[j>>2]|0))c[l>>2]=(c[l>>2]|0)+1;c[g>>2]=1;while(1){if((c[g>>2]|0)>3)break;c[k>>2]=c[j>>2];if(+h[(c[e>>2]|0)+(c[g>>2]<<4)>>3]<+h[f>>3])n=-1;else n=+h[(c[e>>2]|0)+(c[g>>2]<<4)>>3]>+h[f>>3]?1:0;c[j>>2]=n;if((c[k>>2]|0)!=0?(c[j>>2]|0)!=(c[k>>2]|0):0)c[l>>2]=(c[l>>2]|0)+1;c[g>>2]=(c[g>>2]|0)+1}i=d;return c[l>>2]|0}function Tk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;i=i+32|0;e=d;f=d+16|0;c[f>>2]=b;b=c[f>>2]|0;g=+h[a+8>>3];h[e>>3]=+h[a>>3];h[e+8>>3]=g;k3(b,125168,e)|0;i=d;return c[f>>2]|0}function Uk(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;i=i+16|0;e=d;f=4;g=N4(40)|0;c[g>>2]=0;if(((b[(c[a+8>>2]|0)+238>>1]|0)-(b[(c[a+8>>2]|0)+236>>1]|0)|0)<=1){O4(g|0);i=d;return}h=1;a:while(1){if(!(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(h+1<<6)>>2]|0)){j=h;k=18;break}l=0;while(1){if((l|0)>=(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(h<<6)>>2]|0))break;m=c[(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(h<<6)+4>>2]|0)+(l<<2)>>2]|0;n=0;p=ia(20,m|0)|0;q=n;n=0;if((q|0)!=0&(o|0)!=0){r=Y4(c[q>>2]|0,g|0,f|0)|0;if(!r)Pa(q|0,o|0);C=o}else r=-1;if((r|0)==1){s=C;break a}if(p&255){p=l+1|0;while(1){if((p|0)>=(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(h<<6)>>2]|0))break;n=0;q=ra(65,m|0,c[(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(h<<6)+4>>2]|0)+(p<<2)>>2]|0)|0;t=n;n=0;if((t|0)!=0&(o|0)!=0){u=Y4(c[t>>2]|0,g|0,f|0)|0;if(!u)Pa(t|0,o|0);C=o}else u=-1;if((u|0)==1){s=C;break a}if(!(q&255))break;p=p+1|0}if((p-l|0)>1){n=0;da(15,a|0,h|0,l|0,p-1|0,1);m=n;n=0;if((m|0)!=0&(o|0)!=0){v=Y4(c[m>>2]|0,g|0,f|0)|0;if(!v)Pa(m|0,o|0);C=o}else v=-1;if((v|0)==1){s=C;break a}}}l=l+1|0}h=h+1|0}b:do if((k|0)==18){while(1){k=0;if((j|0)<=0)break;h=0;while(1){if((h|0)>=(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(j<<6)>>2]|0))break;v=c[(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(j<<6)+4>>2]|0)+(h<<2)>>2]|0;n=0;u=ia(21,v|0)|0;r=n;n=0;if((r|0)!=0&(o|0)!=0){w=Y4(c[r>>2]|0,g|0,f|0)|0;if(!w)Pa(r|0,o|0);C=o}else w=-1;if((w|0)==1){s=C;break b}if(u&255){u=h+1|0;while(1){if((u|0)>=(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(j<<6)>>2]|0))break;n=0;r=ra(66,v|0,c[(c[(c[(c[a+8>>2]|0)+196>>2]|0)+(j<<6)+4>>2]|0)+(u<<2)>>2]|0)|0;l=n;n=0;if((l|0)!=0&(o|0)!=0){x=Y4(c[l>>2]|0,g|0,f|0)|0;if(!x)Pa(l|0,o|0);C=o}else x=-1;if((x|0)==1){s=C;break b}if(!(r&255))break;u=u+1|0}if((u-h|0)>1){n=0;da(15,a|0,j|0,h|0,u-1|0,0);v=n;n=0;if((v|0)!=0&(o|0)!=0){y=Y4(c[v>>2]|0,g|0,f|0)|0;if(!y)Pa(v|0,o|0);C=o}else y=-1;if((y|0)==1){s=C;break b}}}h=h+1|0}j=j+-1|0;k=18}g=W4(50380,1,g|0,f|0)|0;f=C;n=0;h=n;n=0;if((h|0)!=0&(o|0)!=0){z=Y4(c[h>>2]|0,g|0,f|0)|0;if(!z)Pa(h|0,o|0);C=o}else z=-1;if((z|0)==1)s=C;else s=0}while(0);c:while(1){if(s){n=0;ka(25,3,125208,e|0)|0;z=n;n=0;if((z|0)!=0&(o|0)!=0){A=Y4(c[z>>2]|0,g|0,f|0)|0;if(!A)Pa(z|0,o|0);C=o}else A=-1;if((A|0)==1){s=C;continue}else break}z=1;while(1){if((z|0)>(c[(c[a+8>>2]|0)+180>>2]|0)){k=42;break c}n=0;ea(92,c[(c[(c[a+8>>2]|0)+184>>2]|0)+(z<<2)>>2]|0);j=n;n=0;if((j|0)!=0&(o|0)!=0){B=Y4(c[j>>2]|0,g|0,f|0)|0;if(!B)Pa(j|0,o|0);C=o}else B=-1;if((B|0)==1){s=C;continue c}z=z+1|0}}if((k|0)==42){O4(g|0);i=d;return}O4(g|0);i=d;return}function Vk(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if(((a[(c[(c[e>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[e>>2]|0)+8>>2]|0)+172+4>>2]|0)==1:0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+180+4>>2]|0)==1:0)f=(c[(c[(c[e>>2]|0)+8>>2]|0)+104>>2]|0)==0;else f=0;i=d;return f&1|0}function Wk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+112|0;f=e+40|0;g=e;h=e+96|0;j=e+92|0;k=e+88|0;l=e+84|0;m=e+80|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=c[c[(c[(c[j>>2]|0)+8>>2]|0)+172>>2]>>2];c[m>>2]=c[c[(c[(c[k>>2]|0)+8>>2]|0)+172>>2]>>2];if(((Vk(c[k>>2]|0)|0)&255|0)!=0?(k=c[l>>2]|0,j=c[m>>2]|0,(c[((c[c[l>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)==(c[((c[c[m>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)):0){if((al(c[l>>2]|0,c[m>>2]|0)|0)&255){j=(c[(c[m>>2]|0)+8>>2]|0)+16|0;m=g;k=(c[(c[l>>2]|0)+8>>2]|0)+16|0;l=m+40|0;do{c[m>>2]=c[k>>2];m=m+4|0;k=k+4|0}while((m|0)<(l|0));m=f;k=j;l=m+40|0;do{c[m>>2]=c[k>>2];m=m+4|0;k=k+4|0}while((m|0)<(l|0));n=(Kf(g,f)|0)==0}else n=0;a[h>>0]=n&1;o=a[h>>0]|0;i=e;return o|0}a[h>>0]=0;o=a[h>>0]|0;i=e;return o|0}function Xk(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+64|0;h=g+48|0;j=g+44|0;k=g+40|0;l=g+36|0;m=g+32|0;n=g+28|0;o=g+24|0;p=g+20|0;q=g+16|0;r=g+12|0;s=g+8|0;t=g+4|0;u=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;c[p>>2]=c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[k>>2]<<2)>>2];c[n>>2]=(c[k>>2]|0)+1;while(1){if((c[n>>2]|0)>(c[l>>2]|0))break;c[q>>2]=c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[n>>2]<<2)>>2];a:do if((c[m>>2]|0)==1)while(1){f=c[c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]>>2]|0;c[r>>2]=f;if(!f)break a;c[o>>2]=0;while(1){f=c[(c[(c[(c[p>>2]|0)+8>>2]|0)+180>>2]|0)+(c[o>>2]<<2)>>2]|0;c[s>>2]=f;if(!f)break;f=c[s>>2]|0;e=c[r>>2]|0;if((c[((c[c[s>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)==(c[((c[c[r>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0))break;c[o>>2]=(c[o>>2]|0)+1}if(!(c[s>>2]|0)){e=c[r>>2]|0;c[s>>2]=Og(c[p>>2]|0,c[((c[c[r>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0,c[r>>2]|0)|0}while(1){e=c[c[(c[(c[q>>2]|0)+8>>2]|0)+172>>2]>>2]|0;c[t>>2]=e;if(!e)break;Vg(c[t>>2]|0,c[s>>2]|0);Kg(c[t>>2]|0)}Kg(c[r>>2]|0)}else while(1){e=c[c[(c[(c[q>>2]|0)+8>>2]|0)+172>>2]>>2]|0;c[r>>2]=e;if(!e)break a;c[o>>2]=0;while(1){e=c[(c[(c[(c[p>>2]|0)+8>>2]|0)+172>>2]|0)+(c[o>>2]<<2)>>2]|0;c[s>>2]=e;if(!e)break;e=c[s>>2]|0;f=c[r>>2]|0;if((c[((c[c[s>>2]>>2]&3|0)==3?e:e+32|0)+28>>2]|0)==(c[((c[c[r>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0))break;c[o>>2]=(c[o>>2]|0)+1}if(!(c[s>>2]|0)){f=c[r>>2]|0;c[s>>2]=Og(c[((c[c[r>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0,c[p>>2]|0,c[r>>2]|0)|0}while(1){f=c[c[(c[(c[q>>2]|0)+8>>2]|0)+180>>2]>>2]|0;c[t>>2]=f;if(!f)break;Vg(c[t>>2]|0,c[s>>2]|0);Kg(c[t>>2]|0)}Kg(c[r>>2]|0)}while(0);if((c[(c[(c[q>>2]|0)+8>>2]|0)+172+4>>2]|0)+(c[(c[(c[q>>2]|0)+8>>2]|0)+180+4>>2]|0)|0){v=25;break}Rg(c[h>>2]|0,c[q>>2]|0);c[n>>2]=(c[n>>2]|0)+1}if((v|0)==25)La(125344,125388,115,125395);c[o>>2]=(c[k>>2]|0)+1;c[n>>2]=(c[l>>2]|0)+1;while(1){if((c[n>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0))break;l=c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[n>>2]<<2)>>2]|0;c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[o>>2]<<2)>>2]=l;c[u>>2]=l;c[(c[(c[u>>2]|0)+8>>2]|0)+236>>2]=c[o>>2];c[o>>2]=(c[o>>2]|0)+1;c[n>>2]=(c[n>>2]|0)+1}c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]=c[o>>2];c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2]|0)+(c[o>>2]<<2)>>2]=0;i=g;return}function Yk(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if(((a[(c[(c[e>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[e>>2]|0)+8>>2]|0)+180+4>>2]|0)==1:0)?(c[(c[(c[e>>2]|0)+8>>2]|0)+172+4>>2]|0)==1:0)f=(c[(c[(c[e>>2]|0)+8>>2]|0)+104>>2]|0)==0;else f=0;i=d;return f&1|0}function Zk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+112|0;f=e+40|0;g=e;h=e+96|0;j=e+92|0;k=e+88|0;l=e+84|0;m=e+80|0;c[j>>2]=b;c[k>>2]=d;c[l>>2]=c[c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]>>2];c[m>>2]=c[c[(c[(c[k>>2]|0)+8>>2]|0)+180>>2]>>2];if(((Yk(c[k>>2]|0)|0)&255|0)!=0?(k=c[l>>2]|0,j=c[m>>2]|0,(c[((c[c[l>>2]>>2]&3|0)==2?k:k+-32|0)+28>>2]|0)==(c[((c[c[m>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)):0){if((al(c[l>>2]|0,c[m>>2]|0)|0)&255){j=(c[(c[m>>2]|0)+8>>2]|0)+56|0;m=g;k=(c[(c[l>>2]|0)+8>>2]|0)+56|0;l=m+40|0;do{c[m>>2]=c[k>>2];m=m+4|0;k=k+4|0}while((m|0)<(l|0));m=f;k=j;l=m+40|0;do{c[m>>2]=c[k>>2];m=m+4|0;k=k+4|0}while((m|0)<(l|0));n=(Kf(g,f)|0)==0}else n=0;a[h>>0]=n&1;o=a[h>>0]|0;i=e;return o|0}a[h>>0]=0;o=a[h>>0]|0;i=e;return o|0}function _k(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;e=i;i=i+64|0;f=e+16|0;g=e;h=e+60|0;j=e+56|0;k=e+52|0;l=e+48|0;m=e+44|0;n=e+40|0;o=e+36|0;p=e+32|0;q=e+28|0;r=e+24|0;c[h>>2]=d;c[l>>2]=b[(c[(c[h>>2]|0)+8>>2]|0)+236>>1];while(1){if((c[l>>2]|0)>(b[(c[(c[h>>2]|0)+8>>2]|0)+238>>1]|0))break;c[(c[(c[(c[h>>2]|0)+8>>2]|0)+268>>2]|0)+(c[l>>2]<<2)>>2]=0;c[l>>2]=(c[l>>2]|0)+1}Si(c[h>>2]|0);c[n>>2]=$B(c[h>>2]|0)|0;while(1){s=c[h>>2]|0;if(!(c[n>>2]|0))break;$k(s,c[n>>2]|0);c[p>>2]=OA(c[h>>2]|0,c[n>>2]|0)|0;while(1){if(!(c[p>>2]|0))break;c[q>>2]=c[p>>2];while(1){if(!(c[(c[(c[q>>2]|0)+8>>2]|0)+172>>2]|0))break;c[q>>2]=c[(c[(c[q>>2]|0)+8>>2]|0)+172>>2]}while(1){d=c[q>>2]|0;t=c[p>>2]|0;u=c[h>>2]|0;if((c[(c[(c[((c[c[q>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)>=(c[(c[(c[((c[c[p>>2]>>2]&3|0)==2?t:t+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0))break;t=c[q>>2]|0;$k(u,c[((c[c[q>>2]>>2]&3|0)==2?t:t+-32|0)+28>>2]|0);t=c[q>>2]|0;c[q>>2]=c[c[(c[(c[((c[c[q>>2]>>2]&3|0)==2?t:t+-32|0)+28>>2]|0)+8>>2]|0)+180>>2]>>2]}c[p>>2]=QA(u,c[p>>2]|0)|0}c[n>>2]=aC(c[h>>2]|0,c[n>>2]|0)|0}c[l>>2]=b[(c[s+8>>2]|0)+236>>1];while(1){if((c[l>>2]|0)>(b[(c[(c[h>>2]|0)+8>>2]|0)+238>>1]|0))break;c[o>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+268>>2]|0)+(c[l>>2]<<2)>>2];s=c[(c[(c[o>>2]|0)+8>>2]|0)+236>>2]|0;p=c[l>>2]|0;u=c[(c[(c[(c[(uf(c[h>>2]|0)|0)+8>>2]|0)+196>>2]|0)+(p<<6)+4>>2]|0)+(s<<2)>>2]|0;if((u|0)!=(c[o>>2]|0)){v=18;break}u=c[l>>2]|0;s=c[(c[(c[(uf(c[h>>2]|0)|0)+8>>2]|0)+196>>2]|0)+(u<<6)+4>>2]|0;c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)+4>>2]=s+(c[(c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+268>>2]|0)+(c[l>>2]<<2)>>2]|0)+8>>2]|0)+236>>2]<<2);c[m>>2]=-1;c[k>>2]=0;while(1){if((c[k>>2]|0)>=(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)>>2]|0))break;s=c[(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)+4>>2]|0)+(c[k>>2]<<2)>>2]|0;c[n>>2]=s;if(!s)break;if(a[(c[(c[n>>2]|0)+8>>2]|0)+156>>0]|0){c[r>>2]=c[c[(c[(c[n>>2]|0)+8>>2]|0)+172>>2]>>2];while(1){if(!(c[r>>2]|0))break;if(!(c[(c[(c[r>>2]|0)+8>>2]|0)+116>>2]|0))break;c[r>>2]=c[(c[(c[r>>2]|0)+8>>2]|0)+116>>2]}if(((c[r>>2]|0)!=0?(s=c[r>>2]|0,(AC(c[h>>2]|0,c[((c[c[r>>2]>>2]&3|0)==3?s:s+32|0)+28>>2]|0)|0)!=0):0)?(s=c[r>>2]|0,(AC(c[h>>2]|0,c[((c[c[r>>2]>>2]&3|0)==2?s:s+-32|0)+28>>2]|0)|0)!=0):0)c[m>>2]=c[k>>2]}else{if(!(AC(c[h>>2]|0,c[n>>2]|0)|0))break;c[m>>2]=c[k>>2]}c[k>>2]=(c[k>>2]|0)+1}if((c[m>>2]|0)==-1){s=wB(c[h>>2]|0)|0;u=c[l>>2]|0;c[f>>2]=s;c[f+4>>2]=u;$z(0,125308,f)|0}c[(c[(c[(c[h>>2]|0)+8>>2]|0)+196>>2]|0)+(c[l>>2]<<6)>>2]=(c[m>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1}if((v|0)==18){v=wB(c[o>>2]|0)|0;m=c[(c[(c[o>>2]|0)+8>>2]|0)+236>>2]|0;o=c[l>>2]|0;c[g>>2]=v;c[g+4>>2]=m;c[g+8>>2]=o;$z(1,125250,g)|0;Pa(50380,1)}c[j>>2]=1;while(1){if((c[j>>2]|0)>(c[(c[(c[h>>2]|0)+8>>2]|0)+180>>2]|0))break;_k(c[(c[(c[(c[h>>2]|0)+8>>2]|0)+184>>2]|0)+(c[j>>2]<<2)>>2]|0);c[j>>2]=(c[j>>2]|0)+1}i=e;return}function $k(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;c[f>>2]=b;c[g>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]<<2)>>2];if((c[g>>2]|0)!=0?(c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]|0)<=(c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2]|0):0){i=d;return}c[(c[(c[(c[e>>2]|0)+8>>2]|0)+268>>2]|0)+(c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]<<2)>>2]=c[f>>2];i=d;return}function al(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[g>>2]=b;c[h>>2]=d;c[j>>2]=c[g>>2];while(1){if(!(a[(c[(c[j>>2]|0)+8>>2]|0)+112>>0]|0))break;c[j>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+116>>2]}c[k>>2]=c[h>>2];while(1){if(!(a[(c[(c[k>>2]|0)+8>>2]|0)+112>>0]|0))break;c[k>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+116>>2]}if(a[(c[(c[j>>2]|0)+8>>2]|0)+153>>0]|0){a[f>>0]=0;l=a[f>>0]|0;i=e;return l|0}if(a[(c[(c[k>>2]|0)+8>>2]|0)+153>>0]|0){a[f>>0]=0;l=a[f>>0]|0;i=e;return l|0}else{h=c[k>>2]|0;g=c[k>>2]|0;d=c[j>>2]|0;b=c[j>>2]|0;a[f>>0]=(_((c[(c[(c[((c[c[k>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[k>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0,(c[(c[(c[((c[c[j>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-(c[(c[(c[((c[c[j>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)|0)|0)>0;l=a[f>>0]|0;i=e;return l|0}return 0}function bl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;c[12634]=c[f>>2];d=(a[125408]|0)+1<<24>>24;a[125408]=d;a[125408]=(d<<24>>24|0)==0?1:d;c[(c[(c[f>>2]|0)+8>>2]|0)+216+4>>2]=0;c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]=0;c[j>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;c[k>>2]=c[j>>2];if((c[g>>2]|0)>0?(d=c[(c[(c[k>>2]|0)+8>>2]|0)+212>>2]|0,c[h>>2]=d,(d|0)!=0):0){c[k>>2]=c[(c[(c[(c[h>>2]|0)+8>>2]|0)+268>>2]|0)+(c[(c[(c[k>>2]|0)+8>>2]|0)+232>>2]<<2)>>2];l=7}else l=6;if((l|0)==6?(l=0,d=c[k>>2]|0,(d|0)==(lO(c[k>>2]|0)|0)):0)l=7;if((l|0)==7?(l=0,(a[(c[(c[k>>2]|0)+8>>2]|0)+157>>0]|0)!=(a[125408]|0)):0){cl();dl(c[f>>2]|0,c[k>>2]|0);el()}c[j>>2]=aC(c[f>>2]|0,c[j>>2]|0)|0}i=e;return}function cl(){c[(c[(c[12634]|0)+8>>2]|0)+192>>2]=0;c[12635]=0;return}function dl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+64|0;f=e+52|0;g=e+48|0;h=e+44|0;j=e+40|0;k=e+8|0;l=e+4|0;m=e;c[f>>2]=b;c[g>>2]=d;fl(c[g>>2]|0);d=(c[(c[g>>2]|0)+8>>2]|0)+180|0;c[k>>2]=c[d>>2];c[k+4>>2]=c[d+4>>2];d=k+8|0;b=(c[(c[g>>2]|0)+8>>2]|0)+172|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];b=k+16|0;d=(c[(c[g>>2]|0)+8>>2]|0)+188|0;c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];d=k+24|0;b=(c[(c[g>>2]|0)+8>>2]|0)+196|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[h>>2]=0;while(1){if((c[h>>2]|0)>3)break;a:do if(c[k+(c[h>>2]<<3)>>2]|0){c[j>>2]=0;while(1){b=c[(c[k+(c[h>>2]<<3)>>2]|0)+(c[j>>2]<<2)>>2]|0;c[m>>2]=b;if(!b)break a;b=c[m>>2]|0;d=c[((c[c[m>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0;c[l>>2]=d;if((d|0)==(c[g>>2]|0)){d=c[m>>2]|0;c[l>>2]=c[((c[c[m>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]}if((a[(c[(c[l>>2]|0)+8>>2]|0)+157>>0]|0)!=(a[125408]|0)?(d=c[l>>2]|0,(d|0)==(lO(c[l>>2]|0)|0)):0)dl(c[f>>2]|0,c[l>>2]|0);c[j>>2]=(c[j>>2]|0)+1}}while(0);c[h>>2]=(c[h>>2]|0)+1}i=e;return}function el(){var a=0,b=0,d=0,e=0,f=0;a=i;i=i+16|0;b=a;d=(c[(c[12634]|0)+8>>2]|0)+216+4|0;e=c[d>>2]|0;c[d>>2]=e+1;c[b>>2]=e;e=(c[(c[12634]|0)+8>>2]|0)+216|0;if(c[(c[(c[12634]|0)+8>>2]|0)+216>>2]|0)f=eK(c[e>>2]|0,c[(c[(c[12634]|0)+8>>2]|0)+216+4>>2]<<2)|0;else f=cK(c[e+4>>2]<<2)|0;c[(c[(c[12634]|0)+8>>2]|0)+216>>2]=f;c[(c[(c[(c[12634]|0)+8>>2]|0)+216>>2]|0)+(c[b>>2]<<2)>>2]=c[(c[(c[12634]|0)+8>>2]|0)+192>>2];i=a;return}function fl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=(c[(c[12634]|0)+8>>2]|0)+232|0;c[b>>2]=(c[b>>2]|0)+1;a[(c[(c[e>>2]|0)+8>>2]|0)+157>>0]=a[125408]|0;if(c[12635]|0){c[(c[(c[e>>2]|0)+8>>2]|0)+168>>2]=c[12635];c[(c[(c[12635]|0)+8>>2]|0)+164>>2]=c[e>>2];f=c[e>>2]|0;c[12635]=f;g=c[e>>2]|0;h=g+8|0;j=c[h>>2]|0;k=j+164|0;c[k>>2]=0;i=d;return}else{c[(c[(c[e>>2]|0)+8>>2]|0)+168>>2]=0;c[(c[(c[12634]|0)+8>>2]|0)+192>>2]=c[e>>2];f=c[e>>2]|0;c[12635]=f;g=c[e>>2]|0;h=g+8|0;j=c[h>>2]|0;k=j+164|0;c[k>>2]=0;i=d;return}}function gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;d=i;i=i+48|0;e=d+36|0;f=d+32|0;g=d+28|0;j=d+24|0;k=d+20|0;l=d+16|0;m=d+12|0;n=d+8|0;o=d;c[e>>2]=b;c[j>>2]=0;c[m>>2]=0;c[k>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[k>>2]|0))break;a:do if(c[(c[(c[k>>2]|0)+8>>2]|0)+188>>2]|0){c[g>>2]=0;while(1){b=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+188>>2]|0)+(c[g>>2]<<2)>>2]|0;c[l>>2]=b;if(!b)break a;hl(c[l>>2]|0);c[g>>2]=(c[g>>2]|0)+1}}while(0);c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[k>>2]|0)+8>>2]|0)+204+4>>2]|0))break;c[l>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+204>>2]|0)+(c[g>>2]<<2)>>2];b=c[l>>2]|0;p=c[l>>2]|0;if((c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?p:p+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0))hl(c[l>>2]|0);c[g>>2]=(c[g>>2]|0)+1}c[k>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2]}if(!((c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+56>>2]|0)==0?(c[(c[(c[e>>2]|0)+8>>2]|0)+180>>2]|0)<=0:0))q=15;b:do if((q|0)==15){c[f>>2]=0;while(1){p=c[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+4>>2]|0)+(c[f>>2]<<2)>>2]|0;c[k>>2]=p;if(!p)break b;c[g>>2]=0;while(1){p=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<2)>>2]|0;c[l>>2]=p;if(!p)break;if((c[(c[(c[l>>2]|0)+8>>2]|0)+96>>2]|0)!=0?(a[(c[(c[l>>2]|0)+8>>2]|0)+113>>0]|0)==0:0){q=21;break}c[g>>2]=(c[g>>2]|0)+1}if((q|0)==21){q=0;il(c[e>>2]|0);c[m>>2]=1}if(c[m>>2]|0)break b;c[f>>2]=(c[f>>2]|0)+1}}while(0);dh(c[e>>2]|0);c[k>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+192>>2];while(1){if(!(c[k>>2]|0))break;c:do if(c[(c[(c[k>>2]|0)+8>>2]|0)+188>>2]|0){c[f>>2]=0;while(1){m=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+188>>2]|0)+(c[f>>2]<<2)>>2]|0;c[l>>2]=m;if(!m)break;do if(c[(c[(c[l>>2]|0)+8>>2]|0)+96>>2]|0){if(!(a[(c[(c[l>>2]|0)+8>>2]|0)+113>>0]|0)){c[j>>2]=1;jl(c[l>>2]|0);break}m=(c[(c[(c[l>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;if(c[(c[(c[e>>2]|0)+8>>2]|0)+116>>2]&1){h[(c[(c[l>>2]|0)+8>>2]|0)+136>>3]=+h[m+8>>3];break}else{h[(c[(c[l>>2]|0)+8>>2]|0)+136>>3]=+h[m>>3];break}}while(0);c[f>>2]=(c[f>>2]|0)+1}c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[(c[(c[k>>2]|0)+8>>2]|0)+204+4>>2]|0))break c;c[l>>2]=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+204>>2]|0)+(c[g>>2]<<2)>>2];m=c[l>>2]|0;q=c[l>>2]|0;do if((c[(c[(c[((c[c[l>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[((c[c[l>>2]>>2]&3|0)==2?q:q+-32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)?(p=c[l>>2]|0,b=c[l>>2]|0,(c[((c[c[l>>2]>>2]&3|0)==3?p:p+32|0)+28>>2]|0)!=(c[((c[c[l>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0)):0){c[n>>2]=c[l>>2];while(1){r=c[(c[n>>2]|0)+8>>2]|0;if(!(c[(c[(c[n>>2]|0)+8>>2]|0)+172>>2]|0))break;c[n>>2]=c[r+172>>2]}a[(c[(c[l>>2]|0)+8>>2]|0)+113>>0]=a[r+113>>0]|0;if(c[(c[(c[l>>2]|0)+8>>2]|0)+96>>2]|0){if(!(a[(c[(c[l>>2]|0)+8>>2]|0)+113>>0]|0)){c[j>>2]=1;jl(c[l>>2]|0);break}b=(c[(c[(c[l>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;if(c[(c[(c[e>>2]|0)+8>>2]|0)+116>>2]&1)h[o>>3]=+h[b+8>>3];else h[o>>3]=+h[b>>3];if(+h[o>>3]>+h[(c[(c[n>>2]|0)+8>>2]|0)+136>>3])s=+h[o>>3];else s=+h[(c[(c[n>>2]|0)+8>>2]|0)+136>>3];h[(c[(c[n>>2]|0)+8>>2]|0)+136>>3]=s}}while(0);c[g>>2]=(c[g>>2]|0)+1}}while(0);c[k>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+164>>2]}if(!(c[j>>2]|0)){t=c[j>>2]|0;i=d;return t|0}eh(c[e>>2]|0);t=c[j>>2]|0;i=d;return t|0}function hl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d+28|0;f=d+24|0;g=d+20|0;h=d+16|0;j=d+12|0;k=d+8|0;l=d+4|0;m=d;c[e>>2]=b;b=c[e>>2]|0;c[f>>2]=c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2];b=c[e>>2]|0;c[g>>2]=c[((c[c[e>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2];if((c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2]|0)<(c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]|0)){c[j>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2];c[k>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2]}else{c[j>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2];c[k>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+236>>2]}g=c[(c[(c[f>>2]|0)+8>>2]|0)+232>>2]|0;c[m>>2]=(c[(c[(uf(c[f>>2]|0)|0)+8>>2]|0)+196>>2]|0)+(g<<6);c[h>>2]=(c[j>>2]|0)+1;while(1){if((c[h>>2]|0)>=(c[k>>2]|0))break;c[l>>2]=c[(c[(c[m>>2]|0)+4>>2]|0)+(c[h>>2]<<2)>>2];if((a[(c[(c[l>>2]|0)+8>>2]|0)+156>>0]|0)==1?(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)!=0:0)break;if(!(a[(c[(c[l>>2]|0)+8>>2]|0)+156>>0]|0))break;c[h>>2]=(c[h>>2]|0)+1}if((c[h>>2]|0)!=(c[k>>2]|0)){i=d;return}do{a[(c[(c[e>>2]|0)+8>>2]|0)+113>>0]=1;c[e>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+172>>2]}while((c[e>>2]|0)!=0);i=d;return}function il(a){a=a|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[e>>2]=a;if(b[(c[(c[e>>2]|0)+8>>2]|0)+236>>1]|0)La(125446,125429,190,125465);c[f>>2]=(b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1]|0)+3;if(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)j=eK(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0,c[f>>2]<<6)|0;else j=cK(c[f>>2]<<6)|0;c[g>>2]=j;c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]=(c[g>>2]|0)+64;c[f>>2]=b[(c[(c[e>>2]|0)+8>>2]|0)+238>>1];while(1){k=(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)|0;if((c[f>>2]|0)<0)break;g=k;j=(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+((c[f>>2]|0)-1<<6)|0;a=g+64|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(a|0));c[f>>2]=(c[f>>2]|0)+-1}c[k+8>>2]=0;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)>>2]=0;k=bK(8)|0;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+12>>2]=k;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+4>>2]=k;c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+56>>2]=0;h[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+24>>3]=1.0;h[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+16>>3]=1.0;h[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+40>>3]=1.0;h[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+32>>3]=1.0;f=(c[(c[e>>2]|0)+8>>2]|0)+236|0;b[f>>1]=(b[f>>1]|0)+-1<<16>>16;i=d;return}function jl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0;d=i;i=i+64|0;e=d+56|0;f=d+52|0;g=d+48|0;j=d+44|0;k=d+40|0;l=d+36|0;m=d+32|0;n=d+28|0;o=d+24|0;p=d+8|0;q=d;c[e>>2]=b;if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+96>>2]|0)){i=d;return}b=c[e>>2]|0;c[l>>2]=uf(c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0;b=c[e>>2]|0;c[f>>2]=c[(c[(c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+232>>2];c[g>>2]=kl(c[l>>2]|0,c[e>>2]|0)|0;b=c[c[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+((c[f>>2]|0)-1<<6)+4>>2]>>2]|0;c[m>>2]=b;if(b)c[j>>2]=~~(+h[(c[(c[m>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+((c[f>>2]|0)-1<<6)+16>>3]);else{c[m>>2]=c[c[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+4>>2]>>2];c[j>>2]=~~(+h[(c[(c[m>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+(c[f>>2]<<6)+24>>3]+ +(c[(c[(c[l>>2]|0)+8>>2]|0)+252>>2]|0))}c[n>>2]=ll(c[l>>2]|0,(c[f>>2]|0)-1|0,c[g>>2]|0)|0;g=(c[(c[(c[e>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;c[p>>2]=c[g>>2];c[p+4>>2]=c[g+4>>2];c[p+8>>2]=c[g+8>>2];c[p+12>>2]=c[g+12>>2];if(c[(c[(c[l>>2]|0)+8>>2]|0)+116>>2]&1){h[q>>3]=+h[p>>3];h[p>>3]=+h[p+8>>3];h[p+8>>3]=+h[q>>3]}h[(c[(c[n>>2]|0)+8>>2]|0)+80>>3]=+h[p+8>>3];c[k>>2]=~~(+h[(c[(c[n>>2]|0)+8>>2]|0)+80>>3]/2.0);r=+h[p>>3]/2.0;h[(c[(c[n>>2]|0)+8>>2]|0)+96>>3]=r;h[(c[(c[n>>2]|0)+8>>2]|0)+88>>3]=r;c[(c[(c[n>>2]|0)+8>>2]|0)+104>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+96>>2];h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3]=+((c[j>>2]|0)+(c[k>>2]|0)|0);j=c[e>>2]|0;c[o>>2]=Og(c[n>>2]|0,c[((c[c[e>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0,c[e>>2]|0)|0;h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3]=-+h[(c[(c[n>>2]|0)+8>>2]|0)+88>>3];j=c[e>>2]|0;h[(c[(c[o>>2]|0)+8>>2]|0)+56>>3]=+h[(c[(c[((c[c[e>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)+8>>2]|0)+96>>3];a[(c[(c[o>>2]|0)+8>>2]|0)+112>>0]=4;j=c[e>>2]|0;c[o>>2]=Og(c[n>>2]|0,c[((c[c[e>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0,c[e>>2]|0)|0;h[(c[(c[o>>2]|0)+8>>2]|0)+16>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+96>>3];j=c[e>>2]|0;h[(c[(c[o>>2]|0)+8>>2]|0)+56>>3]=+h[(c[(c[((c[c[e>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)+8>>2]|0)+88>>3];a[(c[(c[o>>2]|0)+8>>2]|0)+112>>0]=4;if(+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+((c[f>>2]|0)-1<<6)+16>>3]<+(c[k>>2]|0))h[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+((c[f>>2]|0)-1<<6)+16>>3]=+(c[k>>2]|0);if(+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+((c[f>>2]|0)-1<<6)+24>>3]<+(c[k>>2]|0))h[(c[(c[(c[l>>2]|0)+8>>2]|0)+196>>2]|0)+((c[f>>2]|0)-1<<6)+24>>3]=+(c[k>>2]|0);c[(c[(c[n>>2]|0)+8>>2]|0)+112>>2]=c[e>>2];i=d;return}function kl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d+48|0;f=d+44|0;g=d+40|0;h=d+36|0;j=d+32|0;k=d+16|0;l=d+12|0;m=d+8|0;n=d+4|0;o=d;c[e>>2]=a;c[f>>2]=b;b=c[f>>2]|0;c[j>>2]=(c[(c[(c[((c[c[f>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)+8>>2]|0)+232>>2]|0)-1;c[o>>2]=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)+4>>2];c[g>>2]=0;c[h>>2]=(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+196>>2]|0)+(c[j>>2]<<6)>>2]|0)-1;j=(c[g>>2]|0)-1|0;c[k+8>>2]=j;c[k>>2]=j;j=(c[h>>2]|0)+1|0;c[k+12>>2]=j;c[k+4>>2]=j;j=c[f>>2]|0;e=c[f>>2]|0;ml(c[((c[c[f>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0,c[((c[c[f>>2]>>2]&3|0)==2?e:e+-32|0)+28>>2]|0,l,m);do{if((c[g>>2]|0)>(c[h>>2]|0))break;nl(c[(c[o>>2]|0)+(c[g>>2]<<2)>>2]|0,k,c[l>>2]|0,c[m>>2]|0);if((c[g>>2]|0)!=(c[h>>2]|0))nl(c[(c[o>>2]|0)+(c[h>>2]<<2)>>2]|0,k,c[l>>2]|0,c[m>>2]|0);c[g>>2]=(c[g>>2]|0)+1;c[h>>2]=(c[h>>2]|0)+-1}while(((c[k+4>>2]|0)-(c[k>>2]|0)|0)>1);if((c[k>>2]|0)<=(c[k+4>>2]|0)){c[n>>2]=((c[k>>2]|0)+(c[k+4>>2]|0)+1|0)/2|0;p=c[n>>2]|0;i=d;return p|0}else{c[n>>2]=((c[k+8>>2]|0)+(c[k+12>>2]|0)+1|0)/2|0;p=c[n>>2]|0;i=d;return p|0}return 0}function ll(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)|0;if(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)+4>>2]|0)m=eK(c[d+4>>2]|0,(c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)>>2]|0)+2<<2)|0;else m=cK((c[d>>2]|0)+2<<2)|0;c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)+4>>2]=m;c[k>>2]=m;c[j>>2]=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)>>2];while(1){if((c[j>>2]|0)<=(c[h>>2]|0))break;c[(c[k>>2]|0)+(c[j>>2]<<2)>>2]=c[(c[k>>2]|0)+((c[j>>2]|0)-1<<2)>>2];m=(c[(c[(c[k>>2]|0)+(c[j>>2]<<2)>>2]|0)+8>>2]|0)+236|0;c[m>>2]=(c[m>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+-1}j=Sg(c[f>>2]|0)|0;c[(c[k>>2]|0)+(c[h>>2]<<2)>>2]=j;c[l>>2]=j;c[(c[(c[l>>2]|0)+8>>2]|0)+236>>2]=c[h>>2];c[(c[(c[l>>2]|0)+8>>2]|0)+232>>2]=c[g>>2];l=(c[(c[(c[f>>2]|0)+8>>2]|0)+196>>2]|0)+(c[g>>2]<<6)|0;g=(c[l>>2]|0)+1|0;c[l>>2]=g;c[(c[k>>2]|0)+(g<<2)>>2]=0;i=e;return c[(c[k>>2]|0)+(c[h>>2]<<2)>>2]|0}function ml(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+32|0;g=f+24|0;h=f+20|0;j=f+16|0;k=f+12|0;l=f+8|0;m=f+4|0;n=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+236>>2];c[m>>2]=c[(c[(c[h>>2]|0)+8>>2]|0)+236>>2];if((c[l>>2]|0)<=(c[m>>2]|0)){o=c[l>>2]|0;p=c[j>>2]|0;c[p>>2]=o;q=c[m>>2]|0;r=c[k>>2]|0;c[r>>2]=q;i=f;return}c[n>>2]=c[l>>2];c[l>>2]=c[m>>2];c[m>>2]=c[n>>2];o=c[l>>2]|0;p=c[j>>2]|0;c[p>>2]=o;q=c[m>>2]|0;r=c[k>>2]|0;c[r>>2]=q;i=f;return}function nl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=h+32|0;k=h+28|0;l=h+24|0;m=h+20|0;n=h+16|0;o=h+12|0;p=h+8|0;q=h+4|0;r=h;s=h+37|0;t=h+36|0;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;if((a[(c[(c[j>>2]|0)+8>>2]|0)+156>>0]|0)!=1){i=h;return}c[q>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+236>>2];if(c[(c[(c[j>>2]|0)+8>>2]|0)+172+4>>2]|0){a[t>>0]=0;a[s>>0]=0;c[n>>2]=0;while(1){g=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]|0)+(c[n>>2]<<2)>>2]|0;c[r>>2]=g;if(!g)break;g=c[r>>2]|0;if((c[(c[(c[((c[c[r>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)>(c[l>>2]|0)){g=c[r>>2]|0;if((c[(c[(c[((c[c[r>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)+8>>2]|0)+236>>2]|0)>=(c[m>>2]|0))a[t>>0]=1}else a[s>>0]=1;c[n>>2]=(c[n>>2]|0)+1}if((d[s>>0]|0)!=0?(d[t>>0]|0)==0:0)c[c[k>>2]>>2]=(c[q>>2]|0)+1;if(!(d[t>>0]|0)){i=h;return}if(d[s>>0]|0){i=h;return}c[(c[k>>2]|0)+4>>2]=(c[q>>2]|0)-1;i=h;return}if((c[(c[(c[j>>2]|0)+8>>2]|0)+180+4>>2]|0)!=2)La(125409,125429,63,125436);s=c[c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]>>2]|0;t=c[(c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]|0)+4>>2]|0;ml(c[((c[c[c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]>>2]>>2]&3|0)==2?s:s+-32|0)+28>>2]|0,c[((c[c[(c[(c[(c[j>>2]|0)+8>>2]|0)+180>>2]|0)+4>>2]>>2]&3|0)==2?t:t+-32|0)+28>>2]|0,o,p);if((c[p>>2]|0)<=(c[l>>2]|0)){t=c[q>>2]|0;c[c[k>>2]>>2]=t;c[(c[k>>2]|0)+8>>2]=t;i=h;return}if((c[o>>2]|0)>=(c[m>>2]|0)){t=c[q>>2]|0;c[(c[k>>2]|0)+4>>2]=t;c[(c[k>>2]|0)+12>>2]=t;i=h;return}if((c[o>>2]|0)<(c[l>>2]|0)?(c[p>>2]|0)>(c[m>>2]|0):0){i=h;return}if((c[o>>2]|0)>=(c[l>>2]|0)){if((c[o>>2]|0)==(c[l>>2]|0)?(c[p>>2]|0)<(c[m>>2]|0):0)u=14}else u=14;if((u|0)==14)c[(c[k>>2]|0)+8>>2]=c[q>>2];if((c[p>>2]|0)<=(c[m>>2]|0)){if((c[p>>2]|0)!=(c[m>>2]|0)){i=h;return}if((c[o>>2]|0)<=(c[l>>2]|0)){i=h;return}}c[(c[k>>2]|0)+12>>2]=c[q>>2];i=h;return}function ol(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[13795]=1;wl(c[d>>2]|0);c[13795]=0;i=b;return}function pl(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[13795]=2;wl(c[d>>2]|0);c[13795]=0;i=b;return}function ql(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;MC(c[d>>2]|0,175026,304,1)|0;xO(c[d>>2]|0);a=bK((e[(c[(qC(c[d>>2]|0)|0)+8>>2]|0)+176>>1]|0)<<3)|0;c[(c[(c[d>>2]|0)+8>>2]|0)+132>>2]=a;a=c[d>>2]|0;VO(a,c[(c[(qC(c[d>>2]|0)|0)+8>>2]|0)+116>>2]&1);i=b;return}function rl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;g=i;i=i+96|0;j=g+48|0;k=g+40|0;l=g+24|0;m=g+8|0;n=g+88|0;o=g+84|0;p=g+80|0;q=g+76|0;r=g+72|0;s=g+68|0;t=g+64|0;u=g+92|0;v=g;w=g+60|0;x=g+56|0;c[o>>2]=b;c[p>>2]=d;c[q>>2]=e;c[r>>2]=f;if(!(c[o>>2]|0)){c[n>>2]=0;y=c[n>>2]|0;i=g;return y|0}c[s>>2]=c[(c[(c[q>>2]|0)+8>>2]|0)+132>>2];c[t>>2]=zA(c[q>>2]|0,c[o>>2]|0)|0;do if(a[c[t>>2]>>0]|0){a[u>>0]=0;if((c[13799]|0)>=3?(o=c[t>>2]|0,f=(c[s>>2]|0)+8|0,e=(c[s>>2]|0)+16|0,c[m>>2]=c[s>>2],c[m+4>>2]=f,c[m+8>>2]=e,c[m+12>>2]=u,(l3(o,125547,m)|0)>=3):0){a[(c[(c[q>>2]|0)+8>>2]|0)+119>>0]=1;a:do if(+h[4246]>0.0){c[w>>2]=0;while(1){if((c[w>>2]|0)>=(c[13799]|0))break a;h[(c[s>>2]|0)+(c[w>>2]<<3)>>3]=+h[(c[s>>2]|0)+(c[w>>2]<<3)>>3]/+h[4246];c[w>>2]=(c[w>>2]|0)+1}}while(0);if((c[13799]|0)>3)Rm(c[q>>2]|0,c[r>>2]|0,3);if((a[u>>0]|0)!=33){if((c[p>>2]|0)!=0?((kO(zA(c[q>>2]|0,c[p>>2]|0)|0)|0)&255|0)!=0:0)z=15}else z=15;if((z|0)==15)a[(c[(c[q>>2]|0)+8>>2]|0)+119>>0]=3;c[n>>2]=1;y=c[n>>2]|0;i=g;return y|0}o=c[t>>2]|0;e=(c[s>>2]|0)+8|0;c[l>>2]=c[s>>2];c[l+4>>2]=e;c[l+8>>2]=u;e=(l3(o,139594,l)|0)>=2;o=c[q>>2]|0;if(!e){e=wB(o)|0;f=c[t>>2]|0;c[j>>2]=e;c[j+4>>2]=f;$z(1,125561,j)|0;break}a[(c[o+8>>2]|0)+119>>0]=1;b:do if(+h[4246]>0.0){c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[13799]|0))break b;h[(c[s>>2]|0)+(c[x>>2]<<3)>>3]=+h[(c[s>>2]|0)+(c[x>>2]<<3)>>3]/+h[4246];c[x>>2]=(c[x>>2]|0)+1}}while(0);do if((c[13799]|0)>2){if(((c[13848]|0)!=0?(o=zA(c[q>>2]|0,c[13848]|0)|0,c[t>>2]=o,(o|0)!=0):0)?(o=c[t>>2]|0,c[k>>2]=v,(l3(o,139001,k)|0)==1):0){A=+h[v>>3];if(+h[4246]>0.0)h[(c[s>>2]|0)+16>>3]=A/+h[4246];else h[(c[s>>2]|0)+16>>3]=A;Rm(c[q>>2]|0,c[r>>2]|0,3);break}Sm(c[q>>2]|0,c[r>>2]|0)}while(0);if((a[u>>0]|0)!=33){if((c[p>>2]|0)!=0?((kO(zA(c[q>>2]|0,c[p>>2]|0)|0)|0)&255|0)!=0:0)z=34}else z=34;if((z|0)==34)a[(c[(c[q>>2]|0)+8>>2]|0)+119>>0]=3;c[n>>2]=1;y=c[n>>2]|0;i=g;return y|0}while(0);c[n>>2]=0;y=c[n>>2]|0;i=g;return y|0}function sl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){g=c[d>>2]|0;if(!(c[e>>2]|0))break;c[f>>2]=OA(g,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;TO(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}UO(c[e>>2]|0);c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}xl(g);i=b;return}function tl(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;f=i;i=i+96|0;g=f+32|0;j=f+80|0;k=f+76|0;l=f+72|0;m=f+68|0;n=f+64|0;o=f+60|0;p=f+56|0;q=f+52|0;r=f+48|0;s=f+44|0;t=f;u=f+40|0;v=f+84|0;c[k>>2]=b;c[l>>2]=e;c[p>>2]=qA(c[k>>2]|0,0,140260,0)|0;c[q>>2]=qA(c[k>>2]|0,0,140294,0)|0;c[r>>2]=0;if(!(c[q>>2]|0))c[q>>2]=qA(c[k>>2]|0,0,140294,178518)|0;Pm(c[k>>2]|0)|0;c[m>>2]=0;while(1){e=c[(c[(c[(c[k>>2]|0)+8>>2]|0)+152>>2]|0)+(c[m>>2]<<2)>>2]|0;c[n>>2]=e;if(!e)break;if((d[(c[(c[n>>2]|0)+8>>2]|0)+119>>0]|0|0)<=0?(P3(wB(c[n>>2]|0)|0,145613,7)|0)!=0:0){w=7;break}if(c[(c[(c[n>>2]|0)+8>>2]|0)+108>>2]|0)yl(c[n>>2]|0,c[(c[(c[n>>2]|0)+8>>2]|0)+108>>2]|0,140256);c[m>>2]=(c[m>>2]|0)+1}if((w|0)==7){w=wB(c[n>>2]|0)|0;n=wB(c[k>>2]|0)|0;c[g>>2]=w;c[g+4>>2]=n;$z(1,125605,g)|0;c[j>>2]=-1;x=c[j>>2]|0;i=f;return x|0}zl(c[k>>2]|0,c[p>>2]|0,c[q>>2]|0);c[o>>2]=Al(c[k>>2]|0)|0;if(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+88>>2]|0){c[s>>2]=1;c[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+84>>2]=0}else c[s>>2]=0;if(!((c[l>>2]|0)!=0&(c[13795]|0)==1^1|(c[s>>2]|0)!=0))c[r>>2]=fq(c[k>>2]|0)|0;if((c[r>>2]|0)!=0?(c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0)a[(c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]=0;BO(c[k>>2]|0);if(c[s>>2]|0){q=(c[(c[k>>2]|0)+8>>2]|0)+16|0;EH(t,c[k>>2]|0);c[q>>2]=c[t>>2];c[q+4>>2]=c[t+4>>2];c[q+8>>2]=c[t+8>>2];c[q+12>>2]=c[t+12>>2];c[q+16>>2]=c[t+16>>2];c[q+20>>2]=c[t+20>>2];c[q+24>>2]=c[t+24>>2];c[q+28>>2]=c[t+28>>2]}a:do if(c[l>>2]|0){a[v>>0]=fm(c[k>>2]|0)|0;if((c[o>>2]|0)!=0?(d[v>>0]|0|0)!=0|(c[r>>2]|0)!=0:0){Bl(c[k>>2]|0);c[o>>2]=0}if((c[o>>2]|0)!=2){em(c[k>>2]|0,0);break}else{c[13800]=1;break}}else{c[13800]=1;c[u>>2]=$B(c[k>>2]|0)|0;while(1){if(!(c[u>>2]|0))break a;h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]=+h[c[(c[(c[u>>2]|0)+8>>2]|0)+132>>2]>>3]*72.0;h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]=+h[(c[(c[(c[u>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]*72.0;c[u>>2]=aC(c[k>>2]|0,c[u>>2]|0)|0}}while(0);c[j>>2]=c[s>>2];x=c[j>>2]|0;i=f;return x|0}function ul(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;i=i+80|0;h=g+8|0;j=g;k=g+36|0;l=g+32|0;m=g+28|0;n=g+24|0;o=g+40|0;p=g+20|0;q=g+16|0;r=g+12|0;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[p>>2]=yA(c[l>>2]|0,125642)|0;c[q>>2]=c[m>>2];if((c[p>>2]|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){f=(m1(d[c[p>>2]>>0]|0)|0)!=0;e=c[p>>2]|0;do if(f){if(!(P3(e,125648,4)|0)){c[q>>2]=0;c[p>>2]=(c[p>>2]|0)+4;break}if(!(P3(c[p>>2]|0,143973,7)|0)){c[q>>2]=1;c[p>>2]=(c[p>>2]|0)+7;break}if(P3(c[p>>2]|0,125653,6)|0){c[q>>2]=c[m>>2];break}else{c[q>>2]=2;c[p>>2]=(c[p>>2]|0)+6;break}}else if(p1(d[e>>0]|0)|0)c[q>>2]=2;while(0);if((c[q>>2]|0)==2){if(!((p1(d[c[p>>2]>>0]|0)|0)!=0?(e=c[p>>2]|0,c[j>>2]=r,(l3(e,137605,j)|0)>=1):0)){j=_3()|0;c[r>>2]=j^(sb(0)|0);c[h>>2]=c[r>>2];k3(o,137605,h)|0;AA(c[l>>2]|0,125642,o)|0}c[c[n>>2]>>2]=c[r>>2]}c[k>>2]=c[q>>2];s=c[k>>2]|0;i=g;return s|0}c[k>>2]=c[m>>2];s=c[k>>2]|0;i=g;return s|0}function vl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;c[j>>2]=1;c[k>>2]=ul(c[f>>2]|0,c[h>>2]|0,j)|0;if((c[12716]|0)!=0&(c[k>>2]|0)!=2)$z(0,125660,e)|0;if((c[k>>2]|0)!=1){l=c[j>>2]|0;v2(l);m=c[k>>2]|0;i=e;return m|0}Cl(c[f>>2]|0,c[g>>2]|0);l=c[j>>2]|0;v2(l);m=c[k>>2]|0;i=e;return m|0}function wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+128|0;e=d+32|0;f=d+108|0;g=d+104|0;j=d+100|0;k=d+96|0;l=d+64|0;m=d+8|0;n=d;o=d+56|0;p=d+52|0;q=d+48|0;r=d+44|0;s=d+40|0;t=d+112|0;u=d+36|0;c[f>>2]=b;h[n>>3]=+h[4246];do if(c[13795]|0){h[4246]=72.0;Dl(c[f>>2]|0);El(c[f>>2]|0);c[o>>2]=tl(c[f>>2]|0,1)|0;if((c[o>>2]|0)>=0){lL(c[f>>2]|0,0);break}$z(3,125708,e)|0;i=d;return}else{h[4246]=+gO(c[f>>2]|0);Dl(c[f>>2]|0);c[g>>2]=Fl(c[f>>2]|0)|0;cq(c[f>>2]|0,m,0)|0;c[j>>2]=Gl(c[f>>2]|0)|0;c[k>>2]=IG(c[f>>2]|0,0,l)|0;c[12717]=JG(c[f>>2]|0,-1,8)|0;b=(c[12717]|0)<0;if(c[k>>2]|0){if(b)c[12717]=8}else{if(b&(c[g>>2]|0)!=0)c[12717]=8;c[l+16>>2]=2}b=c[f>>2]|0;if((c[12717]|0)>=0){c[q>>2]=eG(b,r,c[12718]|0,t)|0;if((c[r>>2]|0)>1){c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[r>>2]|0))break;c[p>>2]=c[(c[q>>2]|0)+(c[s>>2]<<2)>>2];iG(c[p>>2]|0)|0;Hl(c[f>>2]|0,c[p>>2]|0,c[g>>2]|0,c[j>>2]|0,m);dq(c[p>>2]|0,m)|0;QO(c[p>>2]|0,2);Il(c[p>>2]|0);c[s>>2]=(c[s>>2]|0)+1}if(a[t>>0]|0){c[u>>2]=bK(c[r>>2]|0)|0;a[c[u>>2]>>0]=1}else c[u>>2]=0;c[l+8>>2]=c[12717];c[l+20>>2]=c[u>>2];c[l+12>>2]=1;EG(c[r>>2]|0,c[q>>2]|0,c[f>>2]|0,l)|0;if(c[u>>2]|0)O4(c[u>>2]|0)}else{Hl(c[f>>2]|0,c[f>>2]|0,c[g>>2]|0,c[j>>2]|0,m);dq(c[f>>2]|0,m)|0;Il(c[f>>2]|0)}BO(c[f>>2]|0);El(c[f>>2]|0);c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[r>>2]|0))break;c[p>>2]=c[(c[q>>2]|0)+(c[s>>2]<<2)>>2];Qm(c[p>>2]|0);NC(c[p>>2]|0,175049)|0;pC(c[f>>2]|0,c[p>>2]|0)|0;c[s>>2]=(c[s>>2]|0)+1}O4(c[q>>2]|0)}else{Hl(b,c[f>>2]|0,c[g>>2]|0,c[j>>2]|0,m);dq(c[f>>2]|0,m)|0;El(c[f>>2]|0);Il(c[f>>2]|0)}lL(c[f>>2]|0,0)}while(0);h[4246]=+h[n>>3];i=d;return}function xl(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if((c[13795]|0)!=0|(c[12717]|0)<0)Qm(c[d>>2]|0);a=c[d>>2]|0;if((a|0)==(rC(c[d>>2]|0)|0)){i=b;return}PC(c[d>>2]|0,0,175049);i=b;return}function yl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+64|0;g=f+32|0;j=f+52|0;k=f+48|0;l=f+44|0;m=f+24|0;n=f+16|0;o=f+40|0;p=f;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[o>>2]=yA(c[j>>2]|0,c[l>>2]|0)|0;if(!(c[o>>2]|0)){i=f;return}l=c[o>>2]|0;c[g>>2]=m;c[g+4>>2]=n;if((l3(l,143965,g)|0)!=2){i=f;return}g=(c[k>>2]|0)+56|0;Wl(p,+h[m>>3],+h[n>>3]);c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];a[(c[k>>2]|0)+81>>0]=1;i=f;return}function zl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+64|0;g=f+32|0;j=f+56|0;k=f+52|0;l=f+48|0;m=f+44|0;n=f+40|0;o=f+24|0;p=f+16|0;q=f;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if(((c[k>>2]|0)!=0?(c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2]|0)!=0:0)?(c[n>>2]=zA(c[j>>2]|0,c[k>>2]|0)|0,e=c[n>>2]|0,c[g>>2]=o,c[g+4>>2]=p,(l3(e,143965,g)|0)==2):0){g=(c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2]|0)+56|0;Wl(q,+h[o>>3],+h[p>>3]);c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];c[g+12>>2]=c[q+12>>2];a[(c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2]|0)+81>>0]=1}if(!(c[l>>2]|0)){i=f;return}c[m>>2]=GD(c[j>>2]|0)|0;while(1){if(!(c[m>>2]|0))break;Xl(c[m>>2]|0,c[j>>2]|0,c[k>>2]|0,c[l>>2]|0);c[m>>2]=HD(c[m>>2]|0)|0}i=f;return}function Al(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+32|0;d=b+20|0;e=b+16|0;f=b+12|0;g=b+8|0;h=b+4|0;j=b;c[e>>2]=a;c[h>>2]=0;if(!(lB(c[e>>2]|0)|0)){c[d>>2]=2;k=c[d>>2]|0;i=b;return k|0}c[j>>2]=qA(c[e>>2]|0,2,140246,0)|0;if((c[j>>2]|0)==0|(c[13795]|0)<2){c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;c[g>>2]=OA(c[e>>2]|0,c[f>>2]|0)|0;while(1){if(!(c[g>>2]|0))break;if(Ul(c[j>>2]|0,c[g>>2]|0)|0)c[h>>2]=(c[h>>2]|0)+1;c[g>>2]=QA(c[e>>2]|0,c[g>>2]|0)|0}c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}if(!(c[h>>2]|0)){c[d>>2]=0;k=c[d>>2]|0;i=b;return k|0}f=c[h>>2]|0;if((f|0)==(lB(c[e>>2]|0)|0)){c[d>>2]=2;k=c[d>>2]|0;i=b;return k|0}else{c[d>>2]=1;k=c[d>>2]|0;i=b;return k|0}return 0}function Bl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[d>>2]=a;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;SO(c[f>>2]|0);UJ(c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2]|0);UJ(c[(c[(c[f>>2]|0)+8>>2]|0)+108>>2]|0);UJ(c[(c[(c[f>>2]|0)+8>>2]|0)+100>>2]|0);UJ(c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function Cl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+8|0;k=e;l=e+16|0;c[f>>2]=b;c[g>>2]=d;h[j>>3]=0.0;h[k>>3]=6.283185307179586/+(c[g>>2]|0);c[l>>2]=$B(c[f>>2]|0)|0;while(1){if(!(c[l>>2]|0))break;m=+(c[g>>2]|0)*1.0*+Q(+(+h[j>>3]));h[c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]>>3]=m;m=+(c[g>>2]|0)*1.0*+R(+(+h[j>>3]));h[(c[(c[(c[l>>2]|0)+8>>2]|0)+132>>2]|0)+8>>3]=m;a[(c[(c[l>>2]|0)+8>>2]|0)+119>>0]=1;h[j>>3]=+h[j>>3]+ +h[k>>3];if((c[13799]|0)>2)Sm(c[l>>2]|0,c[g>>2]|0);c[l>>2]=aC(c[f>>2]|0,c[l>>2]|0)|0}i=e;return}function Dl(a){a=a|0;var d=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;f=d+4|0;g=d;c[f>>2]=a;QO(c[f>>2]|0,2);a=c[f>>2]|0;c[g>>2]=eO(a,qA(c[f>>2]|0,0,129471,0)|0,2,2)|0;a=c[f>>2]|0;h=qA(c[f>>2]|0,0,129477,0)|0;j=(eO(a,h,c[g>>2]|0,2)|0)&65535;b[(c[(rC(c[f>>2]|0)|0)+8>>2]|0)+176>>1]=j;if((e[(c[(c[(c[f>>2]|0)+48>>2]|0)+8>>2]|0)+176>>1]|0|0)<10)k=e[(c[(c[(c[f>>2]|0)+48>>2]|0)+8>>2]|0)+176>>1]|0;else k=10;j=k&65535;b[(c[(c[(c[f>>2]|0)+48>>2]|0)+8>>2]|0)+176>>1]=j;c[13799]=j&65535;b[(c[(c[(c[f>>2]|0)+48>>2]|0)+8>>2]|0)+178>>1]=(c[g>>2]|0)<(c[13799]|0)?c[g>>2]|0:c[13799]|0;Sl(c[f>>2]|0);i=d;return}function El(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+1040|0;d=b;e=b+12|0;f=b+8|0;g=b+16|0;c[e>>2]=a;if(!((c[13799]|0)>=3&(c[13848]|0)!=0)){i=b;return}c[f>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;h[d>>3]=+h[(c[(c[(c[f>>2]|0)+8>>2]|0)+132>>2]|0)+16>>3]*72.0;k3(g,139001,d)|0;BA(c[f>>2]|0,c[13848]|0,g)|0;c[f>>2]=aC(c[e>>2]|0,c[f>>2]|0)|0}i=b;return}function Fl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;c[f>>2]=b;c[h>>2]=1;c[g>>2]=yA(c[f>>2]|0,126421)|0;do if((c[g>>2]|0)!=0?(a[c[g>>2]>>0]|0)!=0:0){if((a[c[g>>2]>>0]|0)==(a[126426]|0)?(J3(c[g>>2]|0,126426)|0)==0:0){c[h>>2]=0;break}if((a[c[g>>2]>>0]|0)==(a[126429]|0)?(J3(c[g>>2]|0,126429)|0)==0:0){c[h>>2]=1;break}if((a[c[g>>2]>>0]|0)==(a[126435]|0)?(J3(c[g>>2]|0,126435)|0)==0:0){c[h>>2]=2;break}b=c[g>>2]|0;j=wB(c[f>>2]|0)|0;c[e>>2]=b;c[e+4>>2]=j;$z(0,126440,e)|0}while(0);i=d;return c[h>>2]|0}function Gl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+48|0;e=d+16|0;f=d+8|0;g=d;h=d+32|0;j=d+28|0;k=d+24|0;l=d+36|0;c[j>>2]=b;c[k>>2]=yA(c[j>>2]|0,126204)|0;if((c[k>>2]|0)!=0?(b=a[c[k>>2]>>0]|0,a[l>>0]=b,b<<24>>24!=0):0){if(((a[l>>0]|0)==99?(a[c[k>>2]>>0]|0)==(a[126210]|0):0)?(J3(c[k>>2]|0,126210)|0)==0:0){c[h>>2]=1;m=c[h>>2]|0;i=d;return m|0}if((a[l>>0]|0)==115){if((a[c[k>>2]>>0]|0)==(a[126218]|0)?(J3(c[k>>2]|0,126218)|0)==0:0){c[h>>2]=2;m=c[h>>2]|0;i=d;return m|0}if((a[c[k>>2]>>0]|0)==(a[126225]|0)?(J3(c[k>>2]|0,126225)|0)==0:0){c[h>>2]=0;m=c[h>>2]|0;i=d;return m|0}}if(((a[l>>0]|0)==109?(a[c[k>>2]>>0]|0)==(a[126235]|0):0)?(J3(c[k>>2]|0,126235)|0)==0:0)if(qA(c[j>>2]|0,2,129937,0)|0){c[h>>2]=3;m=c[h>>2]|0;i=d;return m|0}else{c[g>>2]=wB(c[j>>2]|0)|0;$z(0,126239,g)|0;$z(3,126302,f)|0;c[h>>2]=0;m=c[h>>2]|0;i=d;return m|0}f=c[k>>2]|0;k=wB(c[j>>2]|0)|0;c[e>>2]=f;c[e+4>>2]=k;$z(0,126359,e)|0;c[h>>2]=0;m=c[h>>2]|0;i=d;return m|0}c[h>>2]=0;m=c[h>>2]|0;i=d;return m|0}function Hl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;c[m>>2]=f;f=yA(c[j>>2]|0,129092)|0;c[o>>2]=f;do if(!f)if((c[k>>2]|0)==1){c[13798]=200;break}else{c[13798]=(kB(c[j>>2]|0)|0)*100;break}else c[13798]=u3(c[o>>2]|0)|0;while(0);c[n>>2]=Om(c[j>>2]|0,c[k>>2]|0)|0;if((c[n>>2]|0)<2|(c[13798]|0)<0){i=g;return}if(c[k>>2]|0){Jl(c[h>>2]|0,c[j>>2]|0,c[n>>2]|0,c[k>>2]|0,c[l>>2]|0,c[13799]|0,c[13798]|0,c[m>>2]|0);i=g;return}else{Kl(c[j>>2]|0,c[n>>2]|0,c[l>>2]|0);i=g;return}}function Il(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;BO(c[d>>2]|0);em(c[d>>2]|0,1);i=b;return}function Jl(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0;m=i;i=i+144|0;n=m+64|0;o=m+48|0;p=m+40|0;q=m+32|0;r=m+8|0;s=m+136|0;t=m+132|0;u=m+128|0;v=m+124|0;w=m+120|0;x=m+108|0;y=m+104|0;z=m+100|0;A=m+96|0;B=m+92|0;C=m+88|0;D=m+84|0;E=m+80|0;F=m+76|0;G=m;H=m+72|0;I=m+68|0;c[m+140>>2]=b;c[s>>2]=d;c[t>>2]=e;c[u>>2]=f;c[v>>2]=g;c[w>>2]=j;c[m+116>>2]=k;c[m+112>>2]=l;c[A>>2]=0;c[E>>2]=vl(c[s>>2]|0,c[t>>2]|0,(c[u>>2]|0)==2?0:2)|0;c[F>>2]=Rl(c[s>>2]|0)|0;if(!(c[E>>2]|0))c[F>>2]=c[F>>2]|4;c[x>>2]=cK(c[w>>2]<<2)|0;l=cK((_(c[t>>2]|0,c[w>>2]|0)|0)<<3)|0;c[c[x>>2]>>2]=l;c[z>>2]=1;while(1){if((c[z>>2]|0)>=(c[13799]|0))break;l=(c[c[x>>2]>>2]|0)+((_(c[z>>2]|0,c[t>>2]|0)|0)<<3)|0;c[(c[x>>2]|0)+(c[z>>2]<<2)>>2]=l;c[z>>2]=(c[z>>2]|0)+1}if(a[138998]|0){z=c[24742]|0;l=(c[E>>2]|0)==0&1;E=c[F>>2]&3;w=c[13798]|0;J=+h[4247];c[r>>2]=c[v>>2];c[r+4>>2]=l;c[r+8>>2]=E;c[r+12>>2]=w;h[r+16>>3]=J;Y2(z,126007,r)|0;Y2(c[24742]|0,126064,q)|0;_N();Y2(c[24742]|0,126080,p)|0}c[C>>2]=Nl(c[s>>2]|0,c[t>>2]|0,y,c[u>>2]|0,c[v>>2]|0,D)|0;if(a[138998]|0){p=c[24742]|0;q=c[t>>2]|0;J=+$N();c[o>>2]=q;h[o+8>>3]=J;Y2(p,126094,o)|0}if((c[u>>2]|0)!=1){o=c[s>>2]|0;h[G>>3]=+fO(o,qA(c[s>>2]|0,0,126113,0)|0,0.0,-1797693134862315708145274.0e284);if((c[u>>2]|0)==2)c[A>>2]=Uq(c[C>>2]|0,c[t>>2]|0,c[y>>2]|0,c[x>>2]|0,c[D>>2]|0,c[13799]|0,c[F>>2]|0,c[v>>2]|0,c[13798]|0,+h[G>>3])|0}else c[A>>2]=Fm(c[C>>2]|0,c[t>>2]|0,c[y>>2]|0,c[x>>2]|0,c[D>>2]|0,c[13799]|0,c[F>>2]|0,c[v>>2]|0,c[13798]|0)|0;if((c[A>>2]|0)<0){$z(3,126123,n)|0;K=c[C>>2]|0;tr(K);L=c[x>>2]|0;M=c[L>>2]|0;O4(M);N=c[x>>2]|0;O4(N);O=c[D>>2]|0;O4(O);i=m;return}c[B>>2]=$B(c[s>>2]|0)|0;while(1){if(!(c[B>>2]|0))break;c[H>>2]=c[(c[(c[B>>2]|0)+8>>2]|0)+120>>2];c[I>>2]=0;while(1){if((c[I>>2]|0)>=(c[13799]|0))break;h[(c[(c[(c[B>>2]|0)+8>>2]|0)+132>>2]|0)+(c[I>>2]<<3)>>3]=+h[(c[(c[x>>2]|0)+(c[I>>2]<<2)>>2]|0)+(c[H>>2]<<3)>>3];c[I>>2]=(c[I>>2]|0)+1}c[B>>2]=aC(c[s>>2]|0,c[B>>2]|0)|0}K=c[C>>2]|0;tr(K);L=c[x>>2]|0;M=c[L>>2]|0;O4(M);N=c[x>>2]|0;O4(N);O=c[D>>2]|0;O4(O);i=m;return}function Kl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;f=i;i=i+64|0;g=f+32|0;j=f+24|0;k=f+16|0;l=f+8|0;m=f;n=f+56|0;o=f+52|0;p=f+48|0;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;do if((c[p>>2]|0)!=2)if((c[p>>2]|0)==1){if(Qq(c[n>>2]|0,c[o>>2]|0)|0)break;c[m>>2]=wB(c[n>>2]|0)|0;$z(0,125736,m)|0;$z(3,130772,l)|0;$z(3,125788,k)|0;$z(3,125860,j)|0;dn(c[n>>2]|0,c[o>>2]|0);break}else{e=(c[p>>2]|0)==3;dn(c[n>>2]|0,c[o>>2]|0);if(!e)break;Ml(c[n>>2]|0,c[o>>2]|0);break}else Ll(c[n>>2]|0,c[o>>2]|0);while(0);Um(c[n>>2]|0,c[o>>2]|0);Vm(c[n>>2]|0,c[o>>2]|0);if(!(a[138998]|0)){q=c[n>>2]|0;r=c[o>>2]|0;Wm(q,r);i=f;return}j=c[24742]|0;k=c[13798]|0;s=+h[4247];c[g>>2]=c[p>>2];c[g+4>>2]=k;h[g+8>>3]=s;Y2(j,125898,g)|0;_N();q=c[n>>2]|0;r=c[o>>2]|0;Wm(q,r);i=f;return}function Ll(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;i=i+32|0;e=d+24|0;f=d+20|0;g=d+16|0;j=d+12|0;k=d+4|0;l=d;c[e>>2]=a;c[f>>2]=b;c[l>>2]=Nl(c[e>>2]|0,c[f>>2]|0,d+8|0,0,2,0)|0;c[k>>2]=vs(c[l>>2]|0,c[f>>2]|0)|0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[f>>2]|0))break;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[f>>2]|0))break;h[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)+(c[g>>2]<<2)>>2]|0)+(c[j>>2]<<3)>>3]=+(c[(c[(c[k>>2]|0)+(c[g>>2]<<2)>>2]|0)+(c[j>>2]<<2)>>2]|0);c[j>>2]=(c[j>>2]|0)+1}c[g>>2]=(c[g>>2]|0)+1}O4(c[c[k>>2]>>2]|0);O4(c[k>>2]|0);tr(c[l>>2]|0);i=d;return}function Ml(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;d=i;i=i+32|0;e=d+20|0;f=d+12|0;g=d+8|0;j=d+4|0;k=d;c[e>>2]=a;c[d+16>>2]=b;c[j>>2]=$B(c[e>>2]|0)|0;while(1){if(!(c[j>>2]|0))break;c[k>>2]=OA(c[e>>2]|0,c[j>>2]|0)|0;while(1){if(!(c[k>>2]|0))break;b=c[k>>2]|0;c[f>>2]=(c[c[((c[c[k>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]>>2]|0)>>>4;b=c[k>>2]|0;c[g>>2]=(c[c[((c[c[k>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]>>2]|0)>>>4;if((c[f>>2]|0)!=(c[g>>2]|0)){l=+h[(c[(c[k>>2]|0)+8>>2]|0)+136>>3];h[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)+(c[g>>2]<<2)>>2]|0)+(c[f>>2]<<3)>>3]=l;h[(c[(c[(c[(c[e>>2]|0)+8>>2]|0)+160>>2]|0)+(c[f>>2]<<2)>>2]|0)+(c[g>>2]<<3)>>3]=l}c[k>>2]=QA(c[e>>2]|0,c[k>>2]|0)|0}c[j>>2]=aC(c[e>>2]|0,c[j>>2]|0)|0}i=d;return}function Nl(a,b,d,e,f,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0,R=0;k=i;i=i+112|0;l=k+104|0;m=k+100|0;n=k+96|0;o=k+92|0;p=k+88|0;q=k+84|0;r=k+80|0;s=k+76|0;t=k+72|0;u=k+68|0;v=k+64|0;w=k+60|0;x=k+56|0;y=k+52|0;z=k+48|0;A=k+44|0;B=k+40|0;C=k+36|0;D=k+32|0;E=k+28|0;F=k+24|0;G=k+20|0;H=k+16|0;I=k+12|0;J=k+8|0;K=k+4|0;L=k;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=j;c[t>>2]=lB(c[l>>2]|0)|0;c[v>>2]=0;c[y>>2]=0;c[z>>2]=0;c[D>>2]=bL()|0;if((c[p>>2]|0)==2){c[A>>2]=0;c[B>>2]=0}else{c[A>>2]=qA(c[l>>2]|0,2,129937,0)|0;c[B>>2]=(c[13851]|0)!=0&1}if((c[o>>2]|0)==2|(c[o>>2]|0)==3)c[C>>2]=1;else c[C>>2]=0;c[r>>2]=cK((c[m>>2]|0)*20|0)|0;c[s>>2]=cK(c[m>>2]<<2)|0;c[u>>2]=cK((c[t>>2]<<1)+(c[m>>2]|0)<<2)|0;if((c[A>>2]|0)!=0|(c[C>>2]|0)!=0)c[v>>2]=cK((c[t>>2]<<1)+(c[m>>2]|0)<<2)|0;if(c[B>>2]|0)c[y>>2]=cK((c[t>>2]<<1)+(c[m>>2]|0)<<2)|0;if(c[C>>2]|0)c[z>>2]=cK((c[t>>2]<<1)+(c[m>>2]|0)<<2)|0;c[E>>2]=0;c[t>>2]=0;c[w>>2]=$B(c[l>>2]|0)|0;while(1){if(!(c[w>>2]|0))break;c[H>>2]=1;cL(c[D>>2]|0);if((c[(c[(c[w>>2]|0)+8>>2]|0)+120>>2]|0)!=(c[E>>2]|0)){M=16;break}c[(c[s>>2]|0)+(c[E>>2]<<2)>>2]=c[w>>2];p=c[u>>2]|0;c[u>>2]=p+4;c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+4>>2]=p;if((c[A>>2]|0)!=0|(c[C>>2]|0)!=0){p=c[v>>2]|0;c[v>>2]=p+4;c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+8>>2]=p}else c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+8>>2]=0;if(c[B>>2]|0){p=c[y>>2]|0;c[y>>2]=p+4;c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+12>>2]=p}else c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+12>>2]=0;if(c[C>>2]|0){p=c[z>>2]|0;c[z>>2]=p+4;c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+16>>2]=p}else c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+16>>2]=0;c[F>>2]=1;c[x>>2]=TA(c[l>>2]|0,c[w>>2]|0)|0;while(1){if(!(c[x>>2]|0))break;p=c[x>>2]|0;j=c[x>>2]|0;do if((c[((c[c[x>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0)!=(c[((c[c[x>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0)){c[G>>2]=Ol(c[D>>2]|0,c[x>>2]|0,c[H>>2]|0)|0;if((c[G>>2]|0)!=(c[H>>2]|0)){if(c[B>>2]|0){f=(c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+12>>2]|0)+(c[G>>2]<<2)|0;g[f>>2]=+g[f>>2]+ +h[(c[(c[x>>2]|0)+8>>2]|0)+128>>3]}if(!(c[A>>2]|0))break;c[I>>2]=~~+g[(c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+8>>2]|0)+(c[G>>2]<<2)>>2];if(+h[(c[(c[x>>2]|0)+8>>2]|0)+136>>3]>+(c[I>>2]|0))N=+h[(c[(c[x>>2]|0)+8>>2]|0)+136>>3];else N=+(c[I>>2]|0);g[(c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+8>>2]|0)+(c[G>>2]<<2)>>2]=N;break}f=c[x>>2]|0;e=c[c[x>>2]>>2]&3;if((c[((c[c[x>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)==(c[w>>2]|0)){f=c[x>>2]|0;O=c[((e|0)==2?f:f+-32|0)+28>>2]|0}else{f=c[x>>2]|0;O=c[((e|0)==3?f:f+32|0)+28>>2]|0}c[J>>2]=O;c[t>>2]=(c[t>>2]|0)+1;c[H>>2]=(c[H>>2]|0)+1;f=c[(c[(c[J>>2]|0)+8>>2]|0)+120>>2]|0;e=c[u>>2]|0;c[u>>2]=e+4;c[e>>2]=f;if(c[B>>2]|0){P=+h[(c[(c[x>>2]|0)+8>>2]|0)+128>>3];f=c[y>>2]|0;c[y>>2]=f+4;g[f>>2]=P}do if(c[A>>2]|0){P=+h[(c[(c[x>>2]|0)+8>>2]|0)+136>>3];f=c[v>>2]|0;c[v>>2]=f+4;g[f>>2]=P}else{if(!(c[C>>2]|0))break;f=c[v>>2]|0;c[v>>2]=f+4;g[f>>2]=1.0}while(0);a:do if(c[C>>2]|0){c[K>>2]=yA(c[x>>2]|0,139351)|0;do if(c[K>>2]|0){if(P3(c[K>>2]|0,173312,4)|0)break;f=c[z>>2]|0;c[z>>2]=f+4;g[f>>2]=0.0;break a}while(0);f=c[x>>2]|0;P=(c[w>>2]|0)==(c[((c[c[x>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0)?1.0:-1.0;f=c[z>>2]|0;c[z>>2]=f+4;g[f>>2]=P}while(0);c[F>>2]=(c[F>>2]|0)+1}while(0);c[x>>2]=UA(c[l>>2]|0,c[x>>2]|0,c[w>>2]|0)|0}c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)>>2]=c[F>>2];c[c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+4>>2]>>2]=c[E>>2];c[E>>2]=(c[E>>2]|0)+1;c[w>>2]=aC(c[l>>2]|0,c[w>>2]|0)|0}if((M|0)==16)La(125937,125952,817,125964);if(c[C>>2]|0)Pl(c[r>>2]|0,c[m>>2]|0,c[o>>2]|0,c[s>>2]|0);c[t>>2]=(c[t>>2]|0)/2|0;o=c[t>>2]|0;b:do if((o|0)!=(lB(c[l>>2]|0)|0)){c[u>>2]=eK(c[(c[r>>2]|0)+4>>2]|0,(c[t>>2]<<1)+(c[m>>2]|0)<<2)|0;if(c[A>>2]|0)c[v>>2]=eK(c[(c[r>>2]|0)+8>>2]|0,(c[t>>2]<<1)+(c[m>>2]|0)<<2)|0;if(c[B>>2]|0)c[y>>2]=eK(c[(c[r>>2]|0)+12>>2]|0,(c[t>>2]<<1)+(c[m>>2]|0)<<2)|0;c[E>>2]=0;while(1){if((c[E>>2]|0)>=(c[m>>2]|0))break b;c[L>>2]=c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)>>2];c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+4>>2]=c[u>>2];c[u>>2]=(c[u>>2]|0)+(c[L>>2]<<2);if(c[A>>2]|0){c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+8>>2]=c[v>>2];c[v>>2]=(c[v>>2]|0)+(c[L>>2]<<2)}if(c[B>>2]|0){c[(c[r>>2]|0)+((c[E>>2]|0)*20|0)+12>>2]=c[y>>2];c[y>>2]=(c[y>>2]|0)+(c[L>>2]<<2)}c[E>>2]=(c[E>>2]|0)+1}}while(0);c[c[n>>2]>>2]=c[t>>2];t=c[s>>2]|0;if(c[q>>2]|0){c[c[q>>2]>>2]=t;Q=c[D>>2]|0;dL(Q);R=c[r>>2]|0;i=k;return R|0}else{O4(t);Q=c[D>>2]|0;dL(Q);R=c[r>>2]|0;i=k;return R|0}return 0}function Ol(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;l=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=c[g>>2]|0;c[j>>2]=c[(c[(c[((c[c[g>>2]>>2]&3|0)==3?d:d+32|0)+28>>2]|0)+8>>2]|0)+120>>2];d=c[g>>2]|0;c[k>>2]=c[(c[(c[((c[c[g>>2]>>2]&3|0)==2?d:d+-32|0)+28>>2]|0)+8>>2]|0)+120>>2];if((c[j>>2]|0)<=(c[k>>2]|0)){m=c[f>>2]|0;n=c[j>>2]|0;o=c[k>>2]|0;p=c[h>>2]|0;q=eL(m,n,o,p)|0;i=e;return q|0}c[l>>2]=c[j>>2];c[j>>2]=c[k>>2];c[k>>2]=c[l>>2];m=c[f>>2]|0;n=c[j>>2]|0;o=c[k>>2]|0;p=c[h>>2]|0;q=eL(m,n,o,p)|0;i=e;return q|0}function Pl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;c[n>>2]=c[(c[l>>2]|0)+(c[m>>2]<<2)>>2];a[(c[(c[n>>2]|0)+8>>2]|0)+157>>0]=0;a[(c[(c[n>>2]|0)+8>>2]|0)+158>>0]=0;c[m>>2]=(c[m>>2]|0)+1}c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[j>>2]|0))break;if(!(a[(c[(c[(c[l>>2]|0)+(c[m>>2]<<2)>>2]|0)+8>>2]|0)+157>>0]|0))Ql(c[h>>2]|0,c[m>>2]|0,c[k>>2]|0,c[l>>2]|0);c[m>>2]=(c[m>>2]|0)+1}i=g;return}function Ql(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+48|0;k=j+40|0;l=j+36|0;m=j+32|0;n=j+28|0;o=j+24|0;p=j+20|0;q=j+16|0;r=j+12|0;s=j+8|0;t=j;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;h[t>>3]=(c[m>>2]|0)==3?-1.0:1.0;c[o>>2]=c[(c[n>>2]|0)+(c[l>>2]<<2)>>2];a[(c[(c[o>>2]|0)+8>>2]|0)+157>>0]=1;a[(c[(c[o>>2]|0)+8>>2]|0)+158>>0]=1;c[r>>2]=1;a:while(1){if((c[r>>2]|0)>=(c[(c[k>>2]|0)+((c[l>>2]|0)*20|0)>>2]|0)){u=15;break}do if(!(+g[(c[(c[k>>2]|0)+((c[l>>2]|0)*20|0)+16>>2]|0)+(c[r>>2]<<2)>>2]==1.0)){c[q>>2]=c[(c[(c[k>>2]|0)+((c[l>>2]|0)*20|0)+4>>2]|0)+(c[r>>2]<<2)>>2];c[p>>2]=c[(c[n>>2]|0)+(c[q>>2]<<2)>>2];if(!(a[(c[(c[p>>2]|0)+8>>2]|0)+158>>0]|0)){if(a[(c[(c[p>>2]|0)+8>>2]|0)+157>>0]|0)break;Ql(c[k>>2]|0,c[q>>2]|0,c[m>>2]|0,c[n>>2]|0);break}g[(c[(c[k>>2]|0)+((c[l>>2]|0)*20|0)+16>>2]|0)+(c[r>>2]<<2)>>2]=+h[t>>3];c[s>>2]=1;while(1){if((c[s>>2]|0)>=(c[(c[k>>2]|0)+((c[q>>2]|0)*20|0)>>2]|0))break;if((c[(c[(c[k>>2]|0)+((c[q>>2]|0)*20|0)+4>>2]|0)+(c[s>>2]<<2)>>2]|0)==(c[l>>2]|0))break;c[s>>2]=(c[s>>2]|0)+1}if((c[s>>2]|0)>=(c[(c[k>>2]|0)+((c[q>>2]|0)*20|0)>>2]|0)){u=10;break a}g[(c[(c[k>>2]|0)+((c[q>>2]|0)*20|0)+16>>2]|0)+(c[s>>2]<<2)>>2]=-1.0}while(0);c[r>>2]=(c[r>>2]|0)+1}if((u|0)==10)La(125978,125952,719,125998);else if((u|0)==15){a[(c[(c[o>>2]|0)+8>>2]|0)+158>>0]=0;i=j;return}}function Rl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+8|0;f=b+4|0;c[e>>2]=a;a=c[e>>2]|0;c[f>>2]=eO(a,qA(c[e>>2]|0,0,126139,0)|0,2,0)|0;if(!((c[f>>2]|0)==0|(c[f>>2]|0)>2)){g=c[f>>2]|0;i=b;return g|0}c[d>>2]=126139;$z(0,126148,d)|0;c[f>>2]=2;g=c[f>>2]|0;i=b;return g|0}function Sl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+32|0;d=b+16|0;e=b+12|0;f=b+8|0;g=b+4|0;h=b;c[d>>2]=a;c[g>>2]=kB(c[d>>2]|0)|0;c[12716]=qA(c[d>>2]|0,1,140246,0)|0;c[h>>2]=qA(c[d>>2]|0,1,127690,0)|0;c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;ql(c[e>>2]|0);rl(c[12716]|0,c[h>>2]|0,c[e>>2]|0,c[g>>2]|0)|0;c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}c[e>>2]=$B(c[d>>2]|0)|0;while(1){if(!(c[e>>2]|0))break;c[f>>2]=OA(c[d>>2]|0,c[e>>2]|0)|0;while(1){if(!(c[f>>2]|0))break;Tl(c[f>>2]|0);c[f>>2]=QA(c[d>>2]|0,c[f>>2]|0)|0}c[e>>2]=aC(c[d>>2]|0,c[e>>2]|0)|0}i=b;return}function Tl(a){a=a|0;var b=0,d=0,e=0.0;b=i;i=i+16|0;d=b;c[d>>2]=a;MC(c[d>>2]|0,175319,176,1)|0;yO(c[d>>2]|0)|0;e=+fO(c[d>>2]|0,c[13851]|0,1.0,1.0);h[(c[(c[d>>2]|0)+8>>2]|0)+128>>3]=e;i=b;return}
function A$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;do if((c[k>>2]|0)!=(c[l>>2]|0)){c[n>>2]=c[k>>2];a:while(1){p=c[k>>2]|0;if((c[k>>2]|0)==(c[l>>2]|0)){q=26;break}switch(d[(c[j>>2]|0)+76+(d[p>>0]|0)>>0]|0|0){case 3:{q=9;break a;break}case 30:{q=12;break a;break}case 10:{q=15;break a;break}case 9:{q=18;break a;break}case 5:{c[k>>2]=(c[k>>2]|0)+2;continue a;break}case 6:{c[k>>2]=(c[k>>2]|0)+3;continue a;break}case 7:{c[k>>2]=(c[k>>2]|0)+4;continue a;break}default:{c[k>>2]=(c[k>>2]|0)+1;continue a}}}if((q|0)==9)if((c[k>>2]|0)==(c[n>>2]|0)){c[h>>2]=U$(c[j>>2]|0,(c[k>>2]|0)+1|0,c[l>>2]|0,c[m>>2]|0)|0;break}else{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=6;break}else if((q|0)==12)if((c[k>>2]|0)==(c[n>>2]|0)){c[o>>2]=V$(c[j>>2]|0,(c[k>>2]|0)+1|0,c[l>>2]|0,c[m>>2]|0)|0;c[h>>2]=(c[o>>2]|0)==22?0:c[o>>2]|0;break}else{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=6;break}else if((q|0)==15){f=c[k>>2]|0;if((c[k>>2]|0)==(c[n>>2]|0)){c[c[m>>2]>>2]=f+1;c[h>>2]=7;break}else{c[c[m>>2]>>2]=f;c[h>>2]=6;break}}else if((q|0)==18){f=c[k>>2]|0;if((c[k>>2]|0)!=(c[n>>2]|0)){c[c[m>>2]>>2]=f;c[h>>2]=6;break}c[k>>2]=f+1;if((c[k>>2]|0)==(c[l>>2]|0)){c[h>>2]=-3;break}if((d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0)==10)c[k>>2]=(c[k>>2]|0)+1;c[c[m>>2]>>2]=c[k>>2];c[h>>2]=7;break}else if((q|0)==26){c[c[m>>2]>>2]=p;c[h>>2]=6;break}}else c[h>>2]=-4;while(0);i=g;return c[h>>2]|0}function B$(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;a:while(1){switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0){case 7:{f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){m=4;break a}else m=5;break}case 6:{m=5;break}case 5:break;case 27:case 26:case 25:case 24:case 23:case 22:case 29:{f=c[l>>2]|0;c[l>>2]=f+1;e=a[f>>0]|0;f=c[k>>2]|0;c[k>>2]=f+1;if((e|0)!=(a[f>>0]|0)){m=12;break a}else continue a;break}default:{m=13;break a}}if((m|0)==5?(m=0,f=c[k>>2]|0,c[k>>2]=f+1,e=a[f>>0]|0,f=c[l>>2]|0,c[l>>2]=f+1,(e|0)!=(a[f>>0]|0)):0){m=6;break}f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){m=8;break}f=c[k>>2]|0;c[k>>2]=f+1;e=a[f>>0]|0;f=c[l>>2]|0;c[l>>2]=f+1;if((e|0)!=(a[f>>0]|0)){m=10;break}}if((m|0)==4){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else if((m|0)==6){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else if((m|0)==8){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else if((m|0)==10){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else if((m|0)==12){c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else if((m|0)==13){if((a[c[k>>2]>>0]|0)==(a[c[l>>2]>>0]|0)){c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}switch(d[(c[j>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}default:{c[h>>2]=1;n=c[h>>2]|0;i=g;return n|0}}}return 0}function C$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+16|0;j=g+8|0;k=g+4|0;l=g;c[g+12>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;while(1){m=(c[j>>2]|0)==(c[k>>2]|0);if(!(a[c[l>>2]>>0]|0)){n=8;break}if(m){n=4;break}if((a[c[j>>2]>>0]|0)!=(a[c[l>>2]>>0]|0)){n=6;break}c[j>>2]=(c[j>>2]|0)+1;c[l>>2]=(c[l>>2]|0)+1}if((n|0)==4){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==6){c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}else if((n|0)==8){c[h>>2]=m&1;o=c[h>>2]|0;i=g;return o|0}return 0}function D$(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[g>>2];a:while(1)switch(d[(c[f>>2]|0)+76+(d[c[g>>2]>>0]|0)>>0]|0|0){case 5:{c[g>>2]=(c[g>>2]|0)+2;continue a;break}case 6:{c[g>>2]=(c[g>>2]|0)+3;continue a;break}case 7:{c[g>>2]=(c[g>>2]|0)+4;continue a;break}case 27:case 26:case 25:case 24:case 23:case 22:case 29:{c[g>>2]=(c[g>>2]|0)+1;continue a;break}default:break a}i=e;return (c[g>>2]|0)-(c[h>>2]|0)|0}function E$(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+4|0;g=e;c[f>>2]=a;c[g>>2]=b;a:while(1){switch(d[(c[f>>2]|0)+76+(d[c[g>>2]>>0]|0)>>0]|0|0){case 21:case 9:case 10:break;default:break a}c[g>>2]=(c[g>>2]|0)+1}i=e;return c[g>>2]|0}function F$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=1;c[o>>2]=0;c[p>>2]=0;c[k>>2]=(c[k>>2]|0)+1;a:while(1){b:do switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0){case 5:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=(c[k>>2]|0)+1;break}case 6:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=(c[k>>2]|0)+2;break}case 7:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}c[k>>2]=(c[k>>2]|0)+3;break}case 24:case 22:case 29:{if(!(c[n>>2]|0)){if((c[o>>2]|0)<(c[l>>2]|0)){c[(c[m>>2]|0)+(c[o>>2]<<4)>>2]=c[k>>2];a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=1}c[n>>2]=1}break}case 12:{if((c[n>>2]|0)!=2){if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]=(c[k>>2]|0)+1;c[n>>2]=2;c[p>>2]=12;break b}if((c[p>>2]|0)==12){c[n>>2]=0;if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+8>>2]=c[k>>2];c[o>>2]=(c[o>>2]|0)+1}break}case 13:{if((c[n>>2]|0)!=2){if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]=(c[k>>2]|0)+1;c[n>>2]=2;c[p>>2]=13;break b}if((c[p>>2]|0)==13){c[n>>2]=0;if((c[o>>2]|0)<(c[l>>2]|0))c[(c[m>>2]|0)+(c[o>>2]<<4)+8>>2]=c[k>>2];c[o>>2]=(c[o>>2]|0)+1}break}case 3:{if((c[o>>2]|0)<(c[l>>2]|0))a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0;break}case 21:{if((c[n>>2]|0)==1){c[n>>2]=0;break b}if(((c[n>>2]|0)==2?(c[o>>2]|0)<(c[l>>2]|0):0)?(a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]|0)!=0:0){if((((c[k>>2]|0)!=(c[(c[m>>2]|0)+(c[o>>2]<<4)+4>>2]|0)?(a[c[k>>2]>>0]|0)==32:0)?(a[(c[k>>2]|0)+1>>0]|0)!=32:0)?(d[(c[j>>2]|0)+76+(d[(c[k>>2]|0)+1>>0]|0)>>0]|0)!=(c[p>>2]|0):0)break b;a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0}break}case 10:case 9:{if((c[n>>2]|0)==1){c[n>>2]=0;break b}if((c[n>>2]|0)==2?(c[o>>2]|0)<(c[l>>2]|0):0)a[(c[m>>2]|0)+(c[o>>2]<<4)+12>>0]=0;break}case 17:case 11:{if((c[n>>2]|0)!=2)break a;break}default:{}}while(0);c[k>>2]=(c[k>>2]|0)+1}i=h;return c[o>>2]|0}function G$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+32|0;f=e+20|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[e+16>>2]=b;c[g>>2]=d;c[h>>2]=0;c[g>>2]=(c[g>>2]|0)+2;a:do if((a[c[g>>2]>>0]|0)==120){c[g>>2]=(c[g>>2]|0)+1;while(1){if(!((a[c[g>>2]>>0]|0)==59^1))break a;c[j>>2]=a[c[g>>2]>>0];switch(c[j>>2]|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c[h>>2]=c[h>>2]<<4;c[h>>2]=c[h>>2]|(c[j>>2]|0)-48;break}case 70:case 69:case 68:case 67:case 66:case 65:{c[h>>2]=c[h>>2]<<4;c[h>>2]=(c[h>>2]|0)+(10+((c[j>>2]|0)-65));break}case 102:case 101:case 100:case 99:case 98:case 97:{c[h>>2]=c[h>>2]<<4;c[h>>2]=(c[h>>2]|0)+(10+((c[j>>2]|0)-97));break}default:{}}if((c[h>>2]|0)>=1114112)break;c[g>>2]=(c[g>>2]|0)+1}c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}else{while(1){if(!((a[c[g>>2]>>0]|0)==59^1))break a;c[k>>2]=a[c[g>>2]>>0];c[h>>2]=(c[h>>2]|0)*10;c[h>>2]=(c[h>>2]|0)+((c[k>>2]|0)-48);if((c[h>>2]|0)>=1114112)break;c[g>>2]=(c[g>>2]|0)+1}c[f>>2]=-1;l=c[f>>2]|0;i=e;return l|0}while(0);c[f>>2]=YZ(c[h>>2]|0)|0;l=c[f>>2]|0;i=e;return l|0}function H$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+16|0;g=f+12|0;h=f+4|0;j=f;c[f+8>>2]=b;c[h>>2]=d;c[j>>2]=e;a:do switch(((c[j>>2]|0)-(c[h>>2]|0)|0)/1|0|0){case 2:{if((a[(c[h>>2]|0)+1>>0]|0)==116)switch(a[c[h>>2]>>0]|0){case 108:{c[g>>2]=60;k=c[g>>2]|0;i=f;return k|0}case 103:{c[g>>2]=62;k=c[g>>2]|0;i=f;return k|0}default:break a}break}case 3:{if(((a[c[h>>2]>>0]|0)==97?(c[h>>2]=(c[h>>2]|0)+1,(a[c[h>>2]>>0]|0)==109):0)?(c[h>>2]=(c[h>>2]|0)+1,(a[c[h>>2]>>0]|0)==112):0){c[g>>2]=38;k=c[g>>2]|0;i=f;return k|0}break}case 4:{switch(a[c[h>>2]>>0]|0){case 113:{c[h>>2]=(c[h>>2]|0)+1;if((a[c[h>>2]>>0]|0)!=117)break a;c[h>>2]=(c[h>>2]|0)+1;if((a[c[h>>2]>>0]|0)!=111)break a;c[h>>2]=(c[h>>2]|0)+1;if((a[c[h>>2]>>0]|0)!=116)break a;c[g>>2]=34;k=c[g>>2]|0;i=f;return k|0}case 97:{c[h>>2]=(c[h>>2]|0)+1;if((a[c[h>>2]>>0]|0)!=112)break a;c[h>>2]=(c[h>>2]|0)+1;if((a[c[h>>2]>>0]|0)!=111)break a;c[h>>2]=(c[h>>2]|0)+1;if((a[c[h>>2]>>0]|0)!=115)break a;c[g>>2]=39;k=c[g>>2]|0;i=f;return k|0}default:break a}break}default:{}}while(0);c[g>>2]=0;k=c[g>>2]|0;i=f;return k|0}function I$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+16|0;h=g+12|0;j=g+8|0;k=g+4|0;l=g;c[h>>2]=a;c[j>>2]=b;c[k>>2]=e;c[l>>2]=f;while(1){if((c[j>>2]|0)>>>0>=(c[k>>2]|0)>>>0)break;switch(d[(c[h>>2]|0)+76+(d[c[j>>2]>>0]|0)>>0]|0|0){case 5:{c[j>>2]=(c[j>>2]|0)+2;break}case 6:{c[j>>2]=(c[j>>2]|0)+3;break}case 7:{c[j>>2]=(c[j>>2]|0)+4;break}case 10:{c[(c[l>>2]|0)+4>>2]=-1;f=c[l>>2]|0;c[f>>2]=(c[f>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1;break}case 9:{f=c[l>>2]|0;c[f>>2]=(c[f>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)!=(c[k>>2]|0)?(d[(c[h>>2]|0)+76+(d[c[j>>2]>>0]|0)>>0]|0|0)==10:0)c[j>>2]=(c[j>>2]|0)+1;c[(c[l>>2]|0)+4>>2]=-1;break}default:c[j>>2]=(c[j>>2]|0)+1}f=(c[l>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function J$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[l>>2]=(c[l>>2]|0)+1;c[m>>2]=(c[m>>2]|0)+-1;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){o=10;break}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:break;case 21:{if((a[c[l>>2]>>0]|0)==9){o=5;break a}break}case 22:case 26:{if(a[c[l>>2]>>0]&-128)o=7;break}default:o=7}if((o|0)==7){o=0;switch(a[c[l>>2]>>0]|0){case 64:case 36:break;default:{o=8;break a}}}c[l>>2]=(c[l>>2]|0)+1}if((o|0)==5){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}else if((o|0)==8){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;p=c[j>>2]|0;i=h;return p|0}else if((o|0)==10){c[j>>2]=1;p=c[j>>2]|0;i=h;return p|0}return 0}function K$(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+32|0;k=j+20|0;l=j+16|0;m=j+12|0;n=j+8|0;o=j+4|0;p=j;c[j+24>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=h;a:do if(((c[l>>2]|0)-(c[c[k>>2]>>2]|0)|0)>((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)){c[l>>2]=(c[c[k>>2]>>2]|0)+((c[n>>2]|0)-(c[c[m>>2]>>2]|0));while(1){if((c[l>>2]|0)>>>0<=(c[c[k>>2]>>2]|0)>>>0)break a;if(((d[(c[l>>2]|0)+-1>>0]|0)&192|0)!=128)break a;c[l>>2]=(c[l>>2]|0)+-1}}while(0);c[o>>2]=c[c[m>>2]>>2];c[p>>2]=c[c[k>>2]>>2];while(1){q=c[p>>2]|0;if((c[p>>2]|0)==(c[l>>2]|0))break;a[c[o>>2]>>0]=a[q>>0]|0;c[p>>2]=(c[p>>2]|0)+1;c[o>>2]=(c[o>>2]|0)+1}c[c[k>>2]>>2]=q;c[c[m>>2]>>2]=c[o>>2];i=j;return}function L$(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k+28|0;m=k+24|0;n=k+20|0;o=k+16|0;p=k+12|0;q=k+8|0;r=k+4|0;s=k;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=h;c[p>>2]=j;c[q>>2]=c[c[o>>2]>>2];c[r>>2]=c[c[m>>2]>>2];a:while(1){if((c[r>>2]|0)==(c[n>>2]|0)){t=10;break}if((c[q>>2]|0)==(c[p>>2]|0)){t=10;break}switch(d[(c[l>>2]|0)+76+(d[c[r>>2]>>0]|0)>>0]|0){case 5:{j=((a[c[r>>2]>>0]&31)<<6|a[(c[r>>2]|0)+1>>0]&63)&65535;h=c[q>>2]|0;c[q>>2]=h+2;b[h>>1]=j;c[r>>2]=(c[r>>2]|0)+2;continue a;break}case 6:{j=((a[c[r>>2]>>0]&15)<<12|(a[(c[r>>2]|0)+1>>0]&63)<<6|a[(c[r>>2]|0)+2>>0]&63)&65535;h=c[q>>2]|0;c[q>>2]=h+2;b[h>>1]=j;c[r>>2]=(c[r>>2]|0)+3;continue a;break}case 7:{if(((c[q>>2]|0)+2|0)==(c[p>>2]|0)){t=10;break a}c[s>>2]=(a[c[r>>2]>>0]&7)<<18|(a[(c[r>>2]|0)+1>>0]&63)<<12|(a[(c[r>>2]|0)+2>>0]&63)<<6|a[(c[r>>2]|0)+3>>0]&63;c[s>>2]=(c[s>>2]|0)-65536;b[c[q>>2]>>1]=(c[s>>2]|0)>>>10|55296;b[(c[q>>2]|0)+2>>1]=c[s>>2]&1023|56320;c[q>>2]=(c[q>>2]|0)+4;c[r>>2]=(c[r>>2]|0)+4;continue a;break}default:{j=c[r>>2]|0;c[r>>2]=j+1;h=a[j>>0]|0;j=c[q>>2]|0;c[q>>2]=j+2;b[j>>1]=h;continue a}}}if((t|0)==10){c[c[m>>2]>>2]=c[r>>2];c[c[o>>2]>>2]=c[q>>2];i=k;return}}function M$(a,b){a=a|0;b=b|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[e+4>>2]=a;c[f>>2]=b;i=e;return c[93280+(((d[181834+((d[c[f>>2]>>0]|0)>>2&7)>>0]|0)<<3)+(((d[c[f>>2]>>0]|0)&3)<<1)+((d[(c[f>>2]|0)+1>>0]|0)>>5&1)<<2)>>2]&1<<((d[(c[f>>2]|0)+1>>0]|0)&31)|0}function N$(a,b){a=a|0;b=b|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[e+4>>2]=a;c[f>>2]=b;i=e;return c[93280+(((d[181834+((((d[c[f>>2]>>0]|0)&15)<<4)+((d[(c[f>>2]|0)+1>>0]|0)>>2&15))>>0]|0)<<3)+(((d[(c[f>>2]|0)+1>>0]|0)&3)<<1)+((d[(c[f>>2]|0)+2>>0]|0)>>5&1)<<2)>>2]&1<<((d[(c[f>>2]|0)+2>>0]|0)&31)|0}function O$(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+16|0;c[d+4>>2]=a;c[d>>2]=b;i=d;return 0}function P$(a,b){a=a|0;b=b|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[e+4>>2]=a;c[f>>2]=b;i=e;return c[93280+(((d[181578+((d[c[f>>2]>>0]|0)>>2&7)>>0]|0)<<3)+(((d[c[f>>2]>>0]|0)&3)<<1)+((d[(c[f>>2]|0)+1>>0]|0)>>5&1)<<2)>>2]&1<<((d[(c[f>>2]|0)+1>>0]|0)&31)|0}function Q$(a,b){a=a|0;b=b|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[e+4>>2]=a;c[f>>2]=b;i=e;return c[93280+(((d[181578+((((d[c[f>>2]>>0]|0)&15)<<4)+((d[(c[f>>2]|0)+1>>0]|0)>>2&15))>>0]|0)<<3)+(((d[(c[f>>2]|0)+1>>0]|0)&3)<<1)+((d[(c[f>>2]|0)+2>>0]|0)>>5&1)<<2)>>2]&1<<((d[(c[f>>2]|0)+2>>0]|0)&31)|0}function R$(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;c[e+4>>2]=a;c[f>>2]=b;if((d[c[f>>2]>>0]|0|0)>=194?((d[(c[f>>2]|0)+1>>0]|0)&128|0)!=0:0)g=((d[(c[f>>2]|0)+1>>0]|0)&192|0)==192;else g=1;i=e;return g&1|0}function S$(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;c[e+4>>2]=a;c[f>>2]=b;if(!((d[(c[f>>2]|0)+2>>0]|0)&128)){g=1;h=g&1;i=e;return h|0}if((d[c[f>>2]>>0]|0|0)==239?(d[(c[f>>2]|0)+1>>0]|0|0)==191:0){if((d[(c[f>>2]|0)+2>>0]|0|0)>189){g=1;h=g&1;i=e;return h|0}}else j=5;if((j|0)==5?((d[(c[f>>2]|0)+2>>0]|0)&192|0)==192:0){g=1;h=g&1;i=e;return h|0}j=d[(c[f>>2]|0)+1>>0]|0;if((d[c[f>>2]>>0]|0|0)==224)if((j|0)<160)k=1;else k=((d[(c[f>>2]|0)+1>>0]|0)&192|0)==192;else if(!(j&128))k=1;else{j=d[(c[f>>2]|0)+1>>0]|0;k=(((d[c[f>>2]>>0]|0|0)==237?(j|0)>159:(j&192|0)==192)&1|0)!=0}g=(k&1|0)!=0;h=g&1;i=e;return h|0}function T$(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e;c[e+4>>2]=a;c[f>>2]=b;if(!((d[(c[f>>2]|0)+3>>0]|0)&128)){g=1;h=g&1;i=e;return h|0}if(((d[(c[f>>2]|0)+3>>0]|0)&192|0)==192){g=1;h=g&1;i=e;return h|0}if(!((d[(c[f>>2]|0)+2>>0]|0)&128)){g=1;h=g&1;i=e;return h|0}if(((d[(c[f>>2]|0)+2>>0]|0)&192|0)==192){g=1;h=g&1;i=e;return h|0}b=d[(c[f>>2]|0)+1>>0]|0;if((d[c[f>>2]>>0]|0|0)==240)if((b|0)<144)j=1;else j=((d[(c[f>>2]|0)+1>>0]|0)&192|0)==192;else if(!(b&128))j=1;else{b=d[(c[f>>2]|0)+1>>0]|0;j=(((d[c[f>>2]>>0]|0|0)==244?(b|0)>143:(b&192|0)==192)&1|0)!=0}g=(j&1|0)!=0;h=g&1;i=e;return h|0}function U$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;a:do if((c[k>>2]|0)==(c[l>>2]|0))c[h>>2]=-1;else{b:do switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 29:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;break}case 5:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<2){c[h>>2]=-2;break a}f=(Ob[c[(c[j>>2]|0)+344>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;e=c[k>>2]|0;if(f){c[k>>2]=e+2;break b}else{c[c[m>>2]>>2]=e;c[h>>2]=0;break a}break}case 6:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<3){c[h>>2]=-2;break a}e=(Ob[c[(c[j>>2]|0)+348>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;f=c[k>>2]|0;if(e){c[k>>2]=f+3;break b}else{c[c[m>>2]>>2]=f;c[h>>2]=0;break a}break}case 7:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<4){c[h>>2]=-2;break a}f=(Ob[c[(c[j>>2]|0)+352>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;e=c[k>>2]|0;if(f){c[k>>2]=e+4;break b}else{c[c[m>>2]>>2]=e;c[h>>2]=0;break a}break}case 19:{c[h>>2]=W$(c[j>>2]|0,(c[k>>2]|0)+1|0,c[l>>2]|0,c[m>>2]|0)|0;break a;break}default:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a}}while(0);c:while(1){if((c[k>>2]|0)==(c[l>>2]|0)){n=44;break}switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 29:{n=25;break c;break}case 18:{n=42;break c;break}case 27:case 26:case 25:case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;continue c;break}case 5:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<2){n=28;break c}e=(Ob[c[(c[j>>2]|0)+332>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;o=c[k>>2]|0;if(!e){n=30;break c}c[k>>2]=o+2;continue c;break}case 6:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<3){n=33;break c}e=(Ob[c[(c[j>>2]|0)+336>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;p=c[k>>2]|0;if(!e){n=35;break c}c[k>>2]=p+3;continue c;break}case 7:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<4){n=38;break c}e=(Ob[c[(c[j>>2]|0)+340>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;q=c[k>>2]|0;if(!e){n=40;break c}c[k>>2]=q+4;continue c;break}default:{n=43;break c}}}switch(n|0){case 25:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 28:{c[h>>2]=-2;break a;break}case 30:{c[c[m>>2]>>2]=o;c[h>>2]=0;break a;break}case 33:{c[h>>2]=-2;break a;break}case 35:{c[c[m>>2]>>2]=p;c[h>>2]=0;break a;break}case 38:{c[h>>2]=-2;break a;break}case 40:{c[c[m>>2]>>2]=q;c[h>>2]=0;break a;break}case 42:{c[c[m>>2]>>2]=(c[k>>2]|0)+1;c[h>>2]=9;break a;break}case 43:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 44:{c[h>>2]=-1;break a;break}}}while(0);i=g;return c[h>>2]|0}function V$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;a:do if((c[k>>2]|0)==(c[l>>2]|0))c[h>>2]=-1;else{b:do switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 29:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;break}case 5:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<2){c[h>>2]=-2;break a}f=(Ob[c[(c[j>>2]|0)+344>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;e=c[k>>2]|0;if(f){c[k>>2]=e+2;break b}else{c[c[m>>2]>>2]=e;c[h>>2]=0;break a}break}case 6:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<3){c[h>>2]=-2;break a}e=(Ob[c[(c[j>>2]|0)+348>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;f=c[k>>2]|0;if(e){c[k>>2]=f+3;break b}else{c[c[m>>2]>>2]=f;c[h>>2]=0;break a}break}case 7:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<4){c[h>>2]=-2;break a}f=(Ob[c[(c[j>>2]|0)+352>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;e=c[k>>2]|0;if(f){c[k>>2]=e+4;break b}else{c[c[m>>2]>>2]=e;c[h>>2]=0;break a}break}case 30:case 9:case 10:case 21:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=22;break a;break}default:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a}}while(0);c:while(1){if((c[k>>2]|0)==(c[l>>2]|0)){n=44;break}switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 29:{n=25;break c;break}case 18:{n=42;break c;break}case 27:case 26:case 25:case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;continue c;break}case 5:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<2){n=28;break c}e=(Ob[c[(c[j>>2]|0)+332>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;o=c[k>>2]|0;if(!e){n=30;break c}c[k>>2]=o+2;continue c;break}case 6:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<3){n=33;break c}e=(Ob[c[(c[j>>2]|0)+336>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;p=c[k>>2]|0;if(!e){n=35;break c}c[k>>2]=p+3;continue c;break}case 7:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<4){n=38;break c}e=(Ob[c[(c[j>>2]|0)+340>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;q=c[k>>2]|0;if(!e){n=40;break c}c[k>>2]=q+4;continue c;break}default:{n=43;break c}}}switch(n|0){case 25:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 28:{c[h>>2]=-2;break a;break}case 30:{c[c[m>>2]>>2]=o;c[h>>2]=0;break a;break}case 33:{c[h>>2]=-2;break a;break}case 35:{c[c[m>>2]>>2]=p;c[h>>2]=0;break a;break}case 38:{c[h>>2]=-2;break a;break}case 40:{c[c[m>>2]>>2]=q;c[h>>2]=0;break a;break}case 42:{c[c[m>>2]>>2]=(c[k>>2]|0)+1;c[h>>2]=28;break a;break}case 43:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 44:{c[h>>2]=-1;break a;break}}}while(0);i=g;return c[h>>2]|0}function W$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){if((a[c[l>>2]>>0]|0)==120){c[j>>2]=X$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;o=c[j>>2]|0;i=h;return o|0}g=c[l>>2]|0;if((d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0)!=25){c[c[n>>2]>>2]=g;c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}c[l>>2]=g+1;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0))break a;switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 18:{p=9;break b;break}case 25:break;default:{p=10;break b}}c[l>>2]=(c[l>>2]|0)+1}if((p|0)==9){c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=10;o=c[j>>2]|0;i=h;return o|0}else if((p|0)==10){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;o=c[j>>2]|0;i=h;return o|0}}while(0);c[j>>2]=-1;o=c[j>>2]|0;i=h;return o|0}function X$(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;a:do if((c[k>>2]|0)!=(c[l>>2]|0)){f=c[k>>2]|0;if(((d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0)+-24|0)>>>0>=2){c[c[m>>2]>>2]=f;c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}c[k>>2]=f+1;b:while(1){if((c[k>>2]|0)==(c[l>>2]|0))break a;switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 18:{o=7;break b;break}case 24:case 25:break;default:{o=8;break b}}c[k>>2]=(c[k>>2]|0)+1}if((o|0)==7){c[c[m>>2]>>2]=(c[k>>2]|0)+1;c[h>>2]=10;n=c[h>>2]|0;i=g;return n|0}else if((o|0)==8){c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}}while(0);c[h>>2]=-1;n=c[h>>2]|0;i=g;return n|0}function Y$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;h=i;i=i+32|0;j=h+20|0;k=h+16|0;l=h+12|0;m=h+8|0;n=h+4|0;o=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){b:do switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}g=(Ob[c[(c[k>>2]|0)+344>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(g){c[l>>2]=f+2;break b}else{c[c[n>>2]>>2]=f;c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}f=(Ob[c[(c[k>>2]|0)+348>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;g=c[l>>2]|0;if(f){c[l>>2]=g+3;break b}else{c[c[n>>2]>>2]=g;c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}g=(Ob[c[(c[k>>2]|0)+352>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(g){c[l>>2]=f+4;break b}else{c[c[n>>2]>>2]=f;c[j>>2]=0;break a}break}case 16:{f=(c[l>>2]|0)+1|0;c[l>>2]=f;if((f|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 27:{c[j>>2]=Z$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 20:{c[j>>2]=_$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}break}case 15:{c[j>>2]=$$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 17:{c[j>>2]=a0(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}while(0);c[o>>2]=0;c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=104;break}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{p=33;break c;break}case 10:case 9:case 21:{p=73;break c;break}case 11:{p=97;break c;break}case 17:{break c;break}case 27:case 26:case 25:case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;continue c;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){p=36;break c}f=(Ob[c[(c[k>>2]|0)+332>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;q=c[l>>2]|0;if(!f){p=38;break c}c[l>>2]=q+2;continue c;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){p=41;break c}f=(Ob[c[(c[k>>2]|0)+336>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;r=c[l>>2]|0;if(!f){p=43;break c}c[l>>2]=r+3;continue c;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){p=46;break c}f=(Ob[c[(c[k>>2]|0)+340>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;s=c[l>>2]|0;if(!f){p=48;break c}c[l>>2]=s+4;continue c;break}case 23:{if(c[o>>2]|0){p=51;break c}c[o>>2]=1;c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){p=53;break c}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{p=55;break c;break}case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;continue c;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){p=58;break c}f=(Ob[c[(c[k>>2]|0)+344>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;t=c[l>>2]|0;if(!f){p=60;break c}c[l>>2]=t+2;continue c;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){p=63;break c}f=(Ob[c[(c[k>>2]|0)+348>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;u=c[l>>2]|0;if(!f){p=65;break c}c[l>>2]=u+3;continue c;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){p=68;break c}f=(Ob[c[(c[k>>2]|0)+352>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;v=c[l>>2]|0;if(!f){p=70;break c}c[l>>2]=v+4;continue c;break}default:{p=72;break c}}break}default:{p=103;break c}}}d:switch(p|0){case 33:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 36:{c[j>>2]=-2;break a;break}case 38:{c[c[n>>2]>>2]=q;c[j>>2]=0;break a;break}case 41:{c[j>>2]=-2;break a;break}case 43:{c[c[n>>2]>>2]=r;c[j>>2]=0;break a;break}case 46:{c[j>>2]=-2;break a;break}case 48:{c[c[n>>2]>>2]=s;c[j>>2]=0;break a;break}case 51:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 53:{c[j>>2]=-1;break a;break}case 55:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 58:{c[j>>2]=-2;break a;break}case 60:{c[c[n>>2]>>2]=t;c[j>>2]=0;break a;break}case 63:{c[j>>2]=-2;break a;break}case 65:{c[c[n>>2]>>2]=u;c[j>>2]=0;break a;break}case 68:{c[j>>2]=-2;break a;break}case 70:{c[c[n>>2]>>2]=v;c[j>>2]=0;break a;break}case 72:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 73:{c[l>>2]=(c[l>>2]|0)+1;e:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){p=96;break}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 11:{p=97;break d;break}case 17:{break d;break}case 29:{p=76;break e;break}case 24:case 22:{p=77;break e;break}case 5:{p=78;break e;break}case 6:{p=83;break e;break}case 7:{p=88;break e;break}case 10:case 9:case 21:break;default:{p=94;break e}}c[l>>2]=(c[l>>2]|0)+1}do if((p|0)==76){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((p|0)==77)c[l>>2]=(c[l>>2]|0)+1;else if((p|0)==78){if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}f=(Ob[c[(c[k>>2]|0)+344>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;g=c[l>>2]|0;if(f){c[l>>2]=g+2;break}else{c[c[n>>2]>>2]=g;c[j>>2]=0;break a}}else if((p|0)==83){if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}g=(Ob[c[(c[k>>2]|0)+348>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(g){c[l>>2]=f+3;break}else{c[c[n>>2]>>2]=f;c[j>>2]=0;break a}}else if((p|0)==88){if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}f=(Ob[c[(c[k>>2]|0)+352>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;g=c[l>>2]|0;if(f){c[l>>2]=g+4;break}else{c[c[n>>2]>>2]=g;c[j>>2]=0;break a}}else if((p|0)==94){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}else if((p|0)==96){c[j>>2]=-1;break a}while(0);c[j>>2]=b0(c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;break a;break}case 103:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 104:{c[j>>2]=-1;break a;break}}if((p|0)==97){c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=2;break}c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break}g=c[l>>2]|0;if((a[c[l>>2]>>0]|0)==62){c[c[n>>2]>>2]=g+1;c[j>>2]=4;break}else{c[c[n>>2]>>2]=g;c[j>>2]=0;break}}else c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function Z$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;a:do if((c[l>>2]|0)!=(c[m>>2]|0)){g=c[l>>2]|0;if((a[c[l>>2]>>0]|0)!=45){c[c[n>>2]>>2]=g;c[j>>2]=0;break}c[l>>2]=g+1;b:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){o=32;break a}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 8:case 1:case 0:{o=22;break b;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){o=8;break b}g=(Ob[c[(c[k>>2]|0)+356>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;p=c[l>>2]|0;if(g){o=10;break b}c[l>>2]=p+2;continue b;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){o=13;break b}g=(Ob[c[(c[k>>2]|0)+360>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;q=c[l>>2]|0;if(g){o=15;break b}c[l>>2]=q+3;continue b;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){o=18;break b}g=(Ob[c[(c[k>>2]|0)+364>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;r=c[l>>2]|0;if(g){o=20;break b}c[l>>2]=r+4;continue b;break}case 27:{g=(c[l>>2]|0)+1|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){o=24;break b}if((a[c[l>>2]>>0]|0)==45){o=26;break b}else continue b;break}default:{c[l>>2]=(c[l>>2]|0)+1;continue b}}}if((o|0)==8){c[j>>2]=-2;break}else if((o|0)==10){c[c[n>>2]>>2]=p;c[j>>2]=0;break}else if((o|0)==13){c[j>>2]=-2;break}else if((o|0)==15){c[c[n>>2]>>2]=q;c[j>>2]=0;break}else if((o|0)==18){c[j>>2]=-2;break}else if((o|0)==20){c[c[n>>2]>>2]=r;c[j>>2]=0;break}else if((o|0)==22){c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}else if((o|0)==24){c[j>>2]=-1;break}else if((o|0)==26){g=(c[l>>2]|0)+1|0;c[l>>2]=g;if((g|0)==(c[m>>2]|0)){c[j>>2]=-1;break}g=c[l>>2]|0;if((a[c[l>>2]>>0]|0)==62){c[c[n>>2]>>2]=g+1;c[j>>2]=13;break}else{c[c[n>>2]>>2]=g;c[j>>2]=0;break}}}else o=32;while(0);if((o|0)==32)c[j>>2]=-1;i=h;return c[j>>2]|0}function _$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+20|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[g+16>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;if(((c[k>>2]|0)-(c[j>>2]|0)|0)<6){c[h>>2]=-1;n=c[h>>2]|0;i=g;return n|0}c[m>>2]=0;while(1){o=c[j>>2]|0;if((c[m>>2]|0)>=6){p=8;break}if((a[o>>0]|0)!=(a[182109+(c[m>>2]|0)>>0]|0)){p=6;break}c[m>>2]=(c[m>>2]|0)+1;c[j>>2]=(c[j>>2]|0)+1}if((p|0)==6){c[c[l>>2]>>2]=c[j>>2];c[h>>2]=0;n=c[h>>2]|0;i=g;return n|0}else if((p|0)==8){c[c[l>>2]>>2]=o;c[h>>2]=8;n=c[h>>2]|0;i=g;return n|0}return 0}function $$(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[p>>2]=c[l>>2];a:do if((c[l>>2]|0)==(c[m>>2]|0))c[j>>2]=-1;else{b:do switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){c[j>>2]=-2;break a}g=(Ob[c[(c[k>>2]|0)+344>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(g){c[l>>2]=f+2;break b}else{c[c[n>>2]>>2]=f;c[j>>2]=0;break a}break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){c[j>>2]=-2;break a}f=(Ob[c[(c[k>>2]|0)+348>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;g=c[l>>2]|0;if(f){c[l>>2]=g+3;break b}else{c[c[n>>2]>>2]=g;c[j>>2]=0;break a}break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){c[j>>2]=-2;break a}g=(Ob[c[(c[k>>2]|0)+352>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;f=c[l>>2]|0;if(g){c[l>>2]=f+4;break b}else{c[c[n>>2]>>2]=f;c[j>>2]=0;break a}break}default:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a}}while(0);c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){q=75;break}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{q=24;break c;break}case 10:case 9:case 21:{q=41;break c;break}case 15:{q=68;break c;break}case 27:case 26:case 25:case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;continue c;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){q=27;break c}f=(Ob[c[(c[k>>2]|0)+332>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;r=c[l>>2]|0;if(!f){q=29;break c}c[l>>2]=r+2;continue c;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){q=32;break c}f=(Ob[c[(c[k>>2]|0)+336>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;s=c[l>>2]|0;if(!f){q=34;break c}c[l>>2]=s+3;continue c;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){q=37;break c}f=(Ob[c[(c[k>>2]|0)+340>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;t=c[l>>2]|0;if(!f){q=39;break c}c[l>>2]=t+4;continue c;break}default:break c}}switch(q|0){case 24:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 27:{c[j>>2]=-2;break a;break}case 29:{c[c[n>>2]>>2]=r;c[j>>2]=0;break a;break}case 32:{c[j>>2]=-2;break a;break}case 34:{c[c[n>>2]>>2]=s;c[j>>2]=0;break a;break}case 37:{c[j>>2]=-2;break a;break}case 39:{c[c[n>>2]>>2]=t;c[j>>2]=0;break a;break}case 41:{f=(c0(c[k>>2]|0,c[p>>2]|0,c[l>>2]|0,o)|0)!=0;g=c[l>>2]|0;if(!f){c[c[n>>2]>>2]=g;c[j>>2]=0;break a}c[l>>2]=g+1;d:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){q=67;break}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 8:case 1:case 0:{q=61;break d;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){q=47;break d}g=(Ob[c[(c[k>>2]|0)+356>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;u=c[l>>2]|0;if(g){q=49;break d}c[l>>2]=u+2;continue d;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){q=52;break d}g=(Ob[c[(c[k>>2]|0)+360>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;v=c[l>>2]|0;if(g){q=54;break d}c[l>>2]=v+3;continue d;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){q=57;break d}g=(Ob[c[(c[k>>2]|0)+364>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;w=c[l>>2]|0;if(g){q=59;break d}c[l>>2]=w+4;continue d;break}case 15:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){q=63;break d}if((a[c[l>>2]>>0]|0)==62){q=65;break d}else continue d;break}default:{c[l>>2]=(c[l>>2]|0)+1;continue d}}}switch(q|0){case 47:{c[j>>2]=-2;break a;break}case 49:{c[c[n>>2]>>2]=u;c[j>>2]=0;break a;break}case 52:{c[j>>2]=-2;break a;break}case 54:{c[c[n>>2]>>2]=v;c[j>>2]=0;break a;break}case 57:{c[j>>2]=-2;break a;break}case 59:{c[c[n>>2]>>2]=w;c[j>>2]=0;break a;break}case 61:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break a;break}case 63:{c[j>>2]=-1;break a;break}case 65:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=c[o>>2];break a;break}case 67:{c[j>>2]=-1;break a;break}}break}case 68:{g=(c0(c[k>>2]|0,c[p>>2]|0,c[l>>2]|0,o)|0)!=0;f=c[l>>2]|0;if(!g){c[c[n>>2]>>2]=f;c[j>>2]=0;break a}c[l>>2]=f+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break a}if((a[c[l>>2]>>0]|0)==62){c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=c[o>>2];break a}break}case 75:{c[j>>2]=-1;break a;break}}c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0}while(0);i=h;return c[j>>2]|0}function a0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;a:do if((c[k>>2]|0)==(c[l>>2]|0))c[h>>2]=-1;else{b:do switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 29:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;break}case 5:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<2){c[h>>2]=-2;break a}f=(Ob[c[(c[j>>2]|0)+344>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;e=c[k>>2]|0;if(f){c[k>>2]=e+2;break b}else{c[c[m>>2]>>2]=e;c[h>>2]=0;break a}break}case 6:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<3){c[h>>2]=-2;break a}e=(Ob[c[(c[j>>2]|0)+348>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;f=c[k>>2]|0;if(e){c[k>>2]=f+3;break b}else{c[c[m>>2]>>2]=f;c[h>>2]=0;break a}break}case 7:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<4){c[h>>2]=-2;break a}f=(Ob[c[(c[j>>2]|0)+352>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;e=c[k>>2]|0;if(f){c[k>>2]=e+4;break b}else{c[c[m>>2]>>2]=e;c[h>>2]=0;break a}break}default:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a}}while(0);c:while(1){if((c[k>>2]|0)==(c[l>>2]|0)){n=51;break}switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 29:{n=24;break c;break}case 10:case 9:case 21:{n=41;break c;break}case 11:{n=49;break c;break}case 27:case 26:case 25:case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;continue c;break}case 5:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<2){n=27;break c}e=(Ob[c[(c[j>>2]|0)+332>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;o=c[k>>2]|0;if(!e){n=29;break c}c[k>>2]=o+2;continue c;break}case 6:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<3){n=32;break c}e=(Ob[c[(c[j>>2]|0)+336>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;p=c[k>>2]|0;if(!e){n=34;break c}c[k>>2]=p+3;continue c;break}case 7:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<4){n=37;break c}e=(Ob[c[(c[j>>2]|0)+340>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;q=c[k>>2]|0;if(!e){n=39;break c}c[k>>2]=q+4;continue c;break}case 23:{c[k>>2]=(c[k>>2]|0)+1;continue c;break}default:{n=50;break c}}}switch(n|0){case 24:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 27:{c[h>>2]=-2;break a;break}case 29:{c[c[m>>2]>>2]=o;c[h>>2]=0;break a;break}case 32:{c[h>>2]=-2;break a;break}case 34:{c[c[m>>2]>>2]=p;c[h>>2]=0;break a;break}case 37:{c[h>>2]=-2;break a;break}case 39:{c[c[m>>2]>>2]=q;c[h>>2]=0;break a;break}case 41:{c[k>>2]=(c[k>>2]|0)+1;d:while(1){if((c[k>>2]|0)==(c[l>>2]|0)){n=47;break}switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 11:{n=44;break d;break}case 10:case 9:case 21:break;default:{n=45;break d}}c[k>>2]=(c[k>>2]|0)+1}if((n|0)==44){c[c[m>>2]>>2]=(c[k>>2]|0)+1;c[h>>2]=5;break a}else if((n|0)==45){c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a}else if((n|0)==47){c[h>>2]=-1;break a}break}case 49:{c[c[m>>2]>>2]=(c[k>>2]|0)+1;c[h>>2]=5;break a;break}case 50:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 51:{c[h>>2]=-1;break a;break}}}while(0);i=g;return c[h>>2]|0}function b0(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;h=i;i=i+48|0;j=h+36|0;k=h+32|0;l=h+28|0;m=h+24|0;n=h+20|0;o=h+16|0;p=h+12|0;q=h+8|0;r=h+4|0;s=h;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[o>>2]=0;a:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){t=114;break}b:do switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{t=4;break a;break}case 27:case 26:case 25:case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;continue a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=7;break a}g=(Ob[c[(c[k>>2]|0)+332>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;u=c[l>>2]|0;if(!g){t=9;break a}c[l>>2]=u+2;continue a;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=12;break a}g=(Ob[c[(c[k>>2]|0)+336>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;v=c[l>>2]|0;if(!g){t=14;break a}c[l>>2]=v+3;continue a;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=17;break a}g=(Ob[c[(c[k>>2]|0)+340>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;w=c[l>>2]|0;if(!g){t=19;break a}c[l>>2]=w+4;continue a;break}case 23:{if(c[o>>2]|0){t=22;break a}c[o>>2]=1;c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){t=24;break a}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{t=26;break a;break}case 24:case 22:{c[l>>2]=(c[l>>2]|0)+1;continue a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=29;break a}g=(Ob[c[(c[k>>2]|0)+344>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;x=c[l>>2]|0;if(!g){t=31;break a}c[l>>2]=x+2;continue a;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=34;break a}g=(Ob[c[(c[k>>2]|0)+348>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;y=c[l>>2]|0;if(!g){t=36;break a}c[l>>2]=y+3;continue a;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=39;break a}g=(Ob[c[(c[k>>2]|0)+352>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;z=c[l>>2]|0;if(!g){t=41;break a}c[l>>2]=z+4;continue a;break}default:{t=43;break a}}break}case 10:case 9:case 21:{while(1){c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){t=45;break a}c[p>>2]=d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0];if((c[p>>2]|0)==14)break b;switch(c[p>>2]|0){case 9:case 10:case 21:break;default:{t=48;break a}}}break}case 14:break;default:{t=113;break a}}while(0);c[o>>2]=0;while(1){c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){t=51;break a}c[q>>2]=d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0];if((c[q>>2]|0)==12|(c[q>>2]|0)==13)break;switch(c[q>>2]|0){case 9:case 10:case 21:break;default:{t=54;break a}}}c[l>>2]=(c[l>>2]|0)+1;c:while(1){if((c[l>>2]|0)==(c[m>>2]|0)){t=57;break a}c[r>>2]=d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0];if((c[r>>2]|0)==(c[q>>2]|0))break;switch(c[r>>2]|0){case 8:case 1:case 0:{t=75;break a;break}case 2:{t=80;break a;break}case 5:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=61;break a}g=(Ob[c[(c[k>>2]|0)+356>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;A=c[l>>2]|0;if(g){t=63;break a}c[l>>2]=A+2;continue c;break}case 6:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=66;break a}g=(Ob[c[(c[k>>2]|0)+360>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;B=c[l>>2]|0;if(g){t=68;break a}c[l>>2]=B+3;continue c;break}case 7:{if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=71;break a}g=(Ob[c[(c[k>>2]|0)+364>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;C=c[l>>2]|0;if(g){t=73;break a}c[l>>2]=C+4;continue c;break}case 3:{c[s>>2]=U$(c[k>>2]|0,(c[l>>2]|0)+1|0,c[m>>2]|0,l)|0;if((c[s>>2]|0)<=0){t=77;break a}else continue c;break}default:{c[l>>2]=(c[l>>2]|0)+1;continue c}}}c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){t=83;break}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 11:{t=106;break a;break}case 17:{t=107;break a;break}case 10:case 9:case 21:break;default:{t=85;break a}}d:while(1){c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){t=87;break a}switch(d[(c[k>>2]|0)+76+(d[c[l>>2]>>0]|0)>>0]|0){case 29:{t=89;break a;break}case 11:{t=106;break a;break}case 17:{t=107;break a;break}case 10:case 9:case 21:break;case 24:case 22:{t=90;break d;break}case 5:{t=91;break d;break}case 6:{t=96;break d;break}case 7:{t=101;break d;break}default:{t=112;break a}}}if((t|0)==90){t=0;c[l>>2]=(c[l>>2]|0)+1;continue}else if((t|0)==91){t=0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<2){t=92;break}g=(Ob[c[(c[k>>2]|0)+344>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;D=c[l>>2]|0;if(!g){t=94;break}c[l>>2]=D+2;continue}else if((t|0)==96){t=0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<3){t=97;break}g=(Ob[c[(c[k>>2]|0)+348>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;E=c[l>>2]|0;if(!g){t=99;break}c[l>>2]=E+3;continue}else if((t|0)==101){t=0;if(((c[m>>2]|0)-(c[l>>2]|0)|0)<4){t=102;break}g=(Ob[c[(c[k>>2]|0)+352>>2]&127](c[k>>2]|0,c[l>>2]|0)|0)!=0;F=c[l>>2]|0;if(!g){t=104;break}c[l>>2]=F+4;continue}}switch(t|0){case 4:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 7:{c[j>>2]=-2;break}case 9:{c[c[n>>2]>>2]=u;c[j>>2]=0;break}case 12:{c[j>>2]=-2;break}case 14:{c[c[n>>2]>>2]=v;c[j>>2]=0;break}case 17:{c[j>>2]=-2;break}case 19:{c[c[n>>2]>>2]=w;c[j>>2]=0;break}case 22:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 24:{c[j>>2]=-1;break}case 26:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 29:{c[j>>2]=-2;break}case 31:{c[c[n>>2]>>2]=x;c[j>>2]=0;break}case 34:{c[j>>2]=-2;break}case 36:{c[c[n>>2]>>2]=y;c[j>>2]=0;break}case 39:{c[j>>2]=-2;break}case 41:{c[c[n>>2]>>2]=z;c[j>>2]=0;break}case 43:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 45:{c[j>>2]=-1;break}case 48:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 51:{c[j>>2]=-1;break}case 54:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 57:{c[j>>2]=-1;break}case 61:{c[j>>2]=-2;break}case 63:{c[c[n>>2]>>2]=A;c[j>>2]=0;break}case 66:{c[j>>2]=-2;break}case 68:{c[c[n>>2]>>2]=B;c[j>>2]=0;break}case 71:{c[j>>2]=-2;break}case 73:{c[c[n>>2]>>2]=C;c[j>>2]=0;break}case 75:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 77:{if(!(c[s>>2]|0))c[c[n>>2]>>2]=c[l>>2];c[j>>2]=c[s>>2];break}case 80:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 83:{c[j>>2]=-1;break}case 85:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 87:{c[j>>2]=-1;break}case 89:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 92:{c[j>>2]=-2;break}case 94:{c[c[n>>2]>>2]=D;c[j>>2]=0;break}case 97:{c[j>>2]=-2;break}case 99:{c[c[n>>2]>>2]=E;c[j>>2]=0;break}case 102:{c[j>>2]=-2;break}case 104:{c[c[n>>2]>>2]=F;c[j>>2]=0;break}case 106:{c[c[n>>2]>>2]=(c[l>>2]|0)+1;c[j>>2]=1;break}case 107:{c[l>>2]=(c[l>>2]|0)+1;if((c[l>>2]|0)==(c[m>>2]|0)){c[j>>2]=-1;break}m=c[l>>2]|0;if((a[c[l>>2]>>0]|0)==62){c[c[n>>2]>>2]=m+1;c[j>>2]=3;break}else{c[c[n>>2]>>2]=m;c[j>>2]=0;break}break}case 112:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 113:{c[c[n>>2]>>2]=c[l>>2];c[j>>2]=0;break}case 114:{c[j>>2]=-1;break}}i=h;return c[j>>2]|0}function c0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+32|0;h=g+20|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[g+16>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=0;c[c[l>>2]>>2]=11;a:do if(((c[k>>2]|0)-(c[j>>2]|0)|0)==3){switch(a[c[j>>2]>>0]|0){case 120:break;case 88:{c[m>>2]=1;break}default:{c[h>>2]=1;break a}}c[j>>2]=(c[j>>2]|0)+1;switch(a[c[j>>2]>>0]|0){case 109:break;case 77:{c[m>>2]=1;break}default:{c[h>>2]=1;break a}}c[j>>2]=(c[j>>2]|0)+1;switch(a[c[j>>2]>>0]|0){case 108:break;case 76:{c[m>>2]=1;break}default:{c[h>>2]=1;break a}}if(c[m>>2]|0){c[h>>2]=0;break}else{c[c[l>>2]>>2]=12;c[h>>2]=1;break}}else c[h>>2]=1;while(0);i=g;return c[h>>2]|0}function d0(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+32|0;j=h+24|0;k=h+20|0;l=h+16|0;m=h+12|0;n=h+8|0;o=h+4|0;p=h;c[k>>2]=a;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;a:while(1){if((c[m>>2]|0)==(c[n>>2]|0)){q=27;break}c[p>>2]=d[(c[l>>2]|0)+76+(d[c[m>>2]>>0]|0)>>0];switch(c[p>>2]|0){case 8:case 1:case 0:{q=19;break a;break}case 5:{if(((c[n>>2]|0)-(c[m>>2]|0)|0)<2){q=5;break a}g=(Ob[c[(c[l>>2]|0)+356>>2]&127](c[l>>2]|0,c[m>>2]|0)|0)!=0;r=c[m>>2]|0;if(g){q=7;break a}c[m>>2]=r+2;continue a;break}case 6:{if(((c[n>>2]|0)-(c[m>>2]|0)|0)<3){q=10;break a}g=(Ob[c[(c[l>>2]|0)+360>>2]&127](c[l>>2]|0,c[m>>2]|0)|0)!=0;s=c[m>>2]|0;if(g){q=12;break a}c[m>>2]=s+3;continue a;break}case 7:{if(((c[n>>2]|0)-(c[m>>2]|0)|0)<4){q=15;break a}g=(Ob[c[(c[l>>2]|0)+364>>2]&127](c[l>>2]|0,c[m>>2]|0)|0)!=0;t=c[m>>2]|0;if(g){q=17;break a}c[m>>2]=t+4;continue a;break}case 13:case 12:{c[m>>2]=(c[m>>2]|0)+1;if((c[p>>2]|0)!=(c[k>>2]|0))continue a;else{q=21;break a}break}default:{c[m>>2]=(c[m>>2]|0)+1;continue a}}}b:do if((q|0)==5)c[j>>2]=-2;else if((q|0)==7){c[c[o>>2]>>2]=r;c[j>>2]=0}else if((q|0)==10)c[j>>2]=-2;else if((q|0)==12){c[c[o>>2]>>2]=s;c[j>>2]=0}else if((q|0)==15)c[j>>2]=-2;else if((q|0)==17){c[c[o>>2]>>2]=t;c[j>>2]=0}else if((q|0)==19){c[c[o>>2]>>2]=c[m>>2];c[j>>2]=0}else if((q|0)==21){if((c[m>>2]|0)==(c[n>>2]|0)){c[j>>2]=-27;break}c[c[o>>2]>>2]=c[m>>2];switch(d[(c[l>>2]|0)+76+(d[c[m>>2]>>0]|0)>>0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{c[j>>2]=27;break b;break}default:{c[j>>2]=0;break b}}}else if((q|0)==27)c[j>>2]=-1;while(0);i=h;return c[j>>2]|0}function e0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;a:do if((c[k>>2]|0)==(c[l>>2]|0))c[h>>2]=-1;else switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 27:{c[h>>2]=Z$(c[j>>2]|0,(c[k>>2]|0)+1|0,c[l>>2]|0,c[m>>2]|0)|0;break a;break}case 20:{c[c[m>>2]>>2]=(c[k>>2]|0)+1;c[h>>2]=33;break a;break}case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;b:while(1){if((c[k>>2]|0)==(c[l>>2]|0)){n=17;break}switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 30:{n=10;break b;break}case 10:case 9:case 21:{break b;break}case 24:case 22:break;default:{n=16;break b}}c[k>>2]=(c[k>>2]|0)+1}c:do if((n|0)==10){if(((c[k>>2]|0)+1|0)==(c[l>>2]|0)){c[h>>2]=-1;break a}switch(d[(c[j>>2]|0)+76+(d[(c[k>>2]|0)+1>>0]|0)>>0]|0|0){case 30:case 10:case 9:case 21:break;default:break c}c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a}else if((n|0)==16){c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a}else if((n|0)==17){c[h>>2]=-1;break a}while(0);c[c[m>>2]>>2]=c[k>>2];c[h>>2]=16;break a;break}default:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a}}while(0);i=g;return c[h>>2]|0}function f0(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+32|0;h=g+16|0;j=g+12|0;k=g+8|0;l=g+4|0;m=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;a:do if((c[k>>2]|0)==(c[l>>2]|0))c[h>>2]=-1;else{b:do switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 29:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;break}case 5:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<2){c[h>>2]=-2;break a}f=(Ob[c[(c[j>>2]|0)+344>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;e=c[k>>2]|0;if(f){c[k>>2]=e+2;break b}else{c[c[m>>2]>>2]=e;c[h>>2]=0;break a}break}case 6:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<3){c[h>>2]=-2;break a}e=(Ob[c[(c[j>>2]|0)+348>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;f=c[k>>2]|0;if(e){c[k>>2]=f+3;break b}else{c[c[m>>2]>>2]=f;c[h>>2]=0;break a}break}case 7:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<4){c[h>>2]=-2;break a}f=(Ob[c[(c[j>>2]|0)+352>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;e=c[k>>2]|0;if(f){c[k>>2]=e+4;break b}else{c[c[m>>2]>>2]=e;c[h>>2]=0;break a}break}default:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a}}while(0);c:while(1){if((c[k>>2]|0)==(c[l>>2]|0)){n=43;break}switch(d[(c[j>>2]|0)+76+(d[c[k>>2]>>0]|0)>>0]|0|0){case 29:{n=24;break c;break}case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=41;break c;break}case 27:case 26:case 25:case 24:case 22:{c[k>>2]=(c[k>>2]|0)+1;continue c;break}case 5:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<2){n=27;break c}e=(Ob[c[(c[j>>2]|0)+332>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;o=c[k>>2]|0;if(!e){n=29;break c}c[k>>2]=o+2;continue c;break}case 6:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<3){n=32;break c}e=(Ob[c[(c[j>>2]|0)+336>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;p=c[k>>2]|0;if(!e){n=34;break c}c[k>>2]=p+3;continue c;break}case 7:{if(((c[l>>2]|0)-(c[k>>2]|0)|0)<4){n=37;break c}e=(Ob[c[(c[j>>2]|0)+340>>2]&127](c[j>>2]|0,c[k>>2]|0)|0)!=0;q=c[k>>2]|0;if(!e){n=39;break c}c[k>>2]=q+4;continue c;break}default:{n=42;break c}}}switch(n|0){case 24:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 27:{c[h>>2]=-2;break a;break}case 29:{c[c[m>>2]>>2]=o;c[h>>2]=0;break a;break}case 32:{c[h>>2]=-2;break a;break}case 34:{c[c[m>>2]>>2]=p;c[h>>2]=0;break a;break}case 37:{c[h>>2]=-2;break a;break}case 39:{c[c[m>>2]>>2]=q;c[h>>2]=0;break a;break}case 41:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=20;break a;break}case 42:{c[c[m>>2]>>2]=c[k>>2];c[h>>2]=0;break a;break}case 43:{c[h>>2]=-20;break a;break}}}while(0);i=g;return c[h>>2]|0}function g0(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+32|0;j=h+12|0;k=h+8|0;l=h+4|0;m=h;c[h+16>>2]=b;c[j>>2]=d;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;while(1){if((c[c[j>>2]>>2]|0)==(c[k>>2]|0)){n=5;break}if((c[c[l>>2]>>2]|0)==(c[m>>2]|0)){n=5;break}g=c[j>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;g=a[f>>0]|0;f=c[l>>2]|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e>>0]=g}if((n|0)==5){i=h;return}}function h0(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+32|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;c[j+16>>2]=a;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=h;while(1){if((c[c[k>>2]>>2]|0)==(c[l>>2]|0)){o=5;break}if((c[c[m>>2]>>2]|0)==(c[n>>2]|0)){o=5;break}h=c[k>>2]|0;g=c[h>>2]|0;c[h>>2]=g+1;h=d[g>>0]|0;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+2;b[f>>1]=h}if((o|0)==5){i=j;return}}function i0(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+32|0;k=j+12|0;l=j+8|0;m=j+4|0;n=j;o=j+20|0;c[j+16>>2]=b;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;c[n>>2]=h;while(1){if((c[c[k>>2]>>2]|0)==(c[l>>2]|0)){p=8;break}a[o>>0]=a[c[c[k>>2]>>2]>>0]|0;if((d[o>>0]|0)&128){if(((c[n>>2]|0)-(c[c[m>>2]>>2]|0)|0)<2){p=8;break}h=((d[o>>0]|0)>>6|192)&255;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;h=((d[o>>0]|0)&63|128)&255;f=c[m>>2]|0;g=c[f>>2]|0;c[f>>2]=g+1;a[g>>0]=h;h=c[k>>2]|0;c[h>>2]=(c[h>>2]|0)+1;continue}else{if((c[c[m>>2]>>2]|0)==(c[n>>2]|0)){p=8;break}h=c[k>>2]|0;g=c[h>>2]|0;c[h>>2]=g+1;h=a[g>>0]|0;g=c[m>>2]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=h;continue}}if((p|0)==8){i=j;return}}function j0(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+48|0;l=k+32|0;m=k+28|0;n=k+24|0;o=k+20|0;p=k+16|0;q=k+12|0;r=k+8|0;s=k+4|0;t=k;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=j;if((c[p>>2]|0)==(c[q>>2]|0)){c[l>>2]=-4;u=c[l>>2]|0;i=k;return u|0}c[s>>2]=c[(c[n>>2]|0)+76>>2];a:do if(((c[p>>2]|0)+1|0)==(c[q>>2]|0)){if(((a[(c[n>>2]|0)+73>>0]|0)+-3|0)>>>0<3){c[l>>2]=-1;u=c[l>>2]|0;i=k;return u|0}switch(d[c[p>>2]>>0]|0){case 239:case 255:case 254:{if((c[o>>2]|0)==1?(a[(c[n>>2]|0)+73>>0]|0)==0:0)break a;break}case 60:case 0:break;default:break a}c[l>>2]=-1;u=c[l>>2]|0;i=k;return u|0}else{j=d[c[p>>2]>>0]<<8|d[(c[p>>2]|0)+1>>0];b:do if((j|0)<65279){if((j|0)<61371){switch(j|0){case 15360:break;default:break b}if((a[(c[n>>2]|0)+73>>0]|0)==4){if((c[o>>2]|0)==1)break a}else if((c[o>>2]|0)==1?(a[(c[n>>2]|0)+73>>0]|0)==3:0)break a;c[c[s>>2]>>2]=c[(c[m>>2]|0)+20>>2];c[l>>2]=Sb[c[(c[c[s>>2]>>2]|0)+(c[o>>2]<<2)>>2]&127](c[c[s>>2]>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0)|0;u=c[l>>2]|0;i=k;return u|0}switch(j|0){case 61371:break;default:break b}if((c[o>>2]|0)==1?(c[t>>2]=a[(c[n>>2]|0)+73>>0],(c[t>>2]|0)==0|(c[t>>2]|0)==4|(c[t>>2]|0)==5|(c[t>>2]|0)==3):0)break a;if(((c[p>>2]|0)+2|0)==(c[q>>2]|0)){c[l>>2]=-1;u=c[l>>2]|0;i=k;return u|0}if((d[(c[p>>2]|0)+2>>0]|0)!=191)break a;c[c[r>>2]>>2]=(c[p>>2]|0)+3;c[c[s>>2]>>2]=c[(c[m>>2]|0)+8>>2];c[l>>2]=14;u=c[l>>2]|0;i=k;return u|0}else switch(j|0){case 65279:{if((c[o>>2]|0)==1?(a[(c[n>>2]|0)+73>>0]|0)==0:0)break a;c[c[r>>2]>>2]=(c[p>>2]|0)+2;c[c[s>>2]>>2]=c[(c[m>>2]|0)+16>>2];c[l>>2]=14;u=c[l>>2]|0;i=k;return u|0}case 65534:{if((c[o>>2]|0)==1?(a[(c[n>>2]|0)+73>>0]|0)==0:0)break a;c[c[r>>2]>>2]=(c[p>>2]|0)+2;c[c[s>>2]>>2]=c[(c[m>>2]|0)+20>>2];c[l>>2]=14;u=c[l>>2]|0;i=k;return u|0}default:break b}while(0);if(a[c[p>>2]>>0]|0){if((c[o>>2]|0)==1?1:(a[(c[p>>2]|0)+1>>0]|0)!=0)break;c[c[s>>2]>>2]=c[(c[m>>2]|0)+20>>2];c[l>>2]=Sb[c[(c[c[s>>2]>>2]|0)+(c[o>>2]<<2)>>2]&127](c[c[s>>2]>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0)|0;u=c[l>>2]|0;i=k;return u|0}if((c[o>>2]|0)==1?(a[(c[n>>2]|0)+73>>0]|0)==5:0)break;c[c[s>>2]>>2]=c[(c[m>>2]|0)+16>>2];c[l>>2]=Sb[c[(c[c[s>>2]>>2]|0)+(c[o>>2]<<2)>>2]&127](c[c[s>>2]>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0)|0;u=c[l>>2]|0;i=k;return u|0}while(0);c[c[s>>2]>>2]=c[(c[m>>2]|0)+(a[(c[n>>2]|0)+73>>0]<<2)>>2];c[l>>2]=Sb[c[(c[c[s>>2]>>2]|0)+(c[o>>2]<<2)>>2]&127](c[c[s>>2]>>2]|0,c[p>>2]|0,c[q>>2]|0,c[r>>2]|0)|0;u=c[l>>2]|0;i=k;return u|0}function k0(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+48|0;l=k+32|0;m=k+28|0;n=k+24|0;o=k+20|0;p=k+16|0;q=k+12|0;r=k+8|0;s=k+4|0;t=k;u=k+36|0;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=h;c[s>>2]=j;if((c[n>>2]|0)==(c[o>>2]|0)){c[c[p>>2]>>2]=0;c[l>>2]=1;v=c[l>>2]|0;i=k;return v|0}if(!(m0(l0(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0)|0)){c[c[s>>2]>>2]=c[n>>2];c[l>>2]=0;v=c[l>>2]|0;i=k;return v|0}do c[n>>2]=(c[n>>2]|0)+(c[(c[m>>2]|0)+68>>2]|0);while((m0(l0(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0)|0)!=0);if((c[n>>2]|0)==(c[o>>2]|0)){c[c[p>>2]>>2]=0;c[l>>2]=1;v=c[l>>2]|0;i=k;return v|0}c[c[p>>2]>>2]=c[n>>2];while(1){c[t>>2]=l0(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;if((c[t>>2]|0)==-1){w=10;break}if((c[t>>2]|0)==61){w=12;break}if(m0(c[t>>2]|0)|0){w=14;break}c[n>>2]=(c[n>>2]|0)+(c[(c[m>>2]|0)+68>>2]|0)}if((w|0)==10){c[c[s>>2]>>2]=c[n>>2];c[l>>2]=0;v=c[l>>2]|0;i=k;return v|0}else if((w|0)==12)c[c[q>>2]>>2]=c[n>>2];else if((w|0)==14){c[c[q>>2]>>2]=c[n>>2];do{c[n>>2]=(c[n>>2]|0)+(c[(c[m>>2]|0)+68>>2]|0);q=l0(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;c[t>>2]=q}while((m0(q)|0)!=0);if((c[t>>2]|0)!=61){c[c[s>>2]>>2]=c[n>>2];c[l>>2]=0;v=c[l>>2]|0;i=k;return v|0}}if((c[n>>2]|0)==(c[c[p>>2]>>2]|0)){c[c[s>>2]>>2]=c[n>>2];c[l>>2]=0;v=c[l>>2]|0;i=k;return v|0}c[n>>2]=(c[n>>2]|0)+(c[(c[m>>2]|0)+68>>2]|0);c[t>>2]=l0(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;while(1){if(!(m0(c[t>>2]|0)|0))break;c[n>>2]=(c[n>>2]|0)+(c[(c[m>>2]|0)+68>>2]|0);c[t>>2]=l0(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0}if((c[t>>2]|0)!=34&(c[t>>2]|0)!=39){c[c[s>>2]>>2]=c[n>>2];c[l>>2]=0;v=c[l>>2]|0;i=k;return v|0}a[u>>0]=c[t>>2];c[n>>2]=(c[n>>2]|0)+(c[(c[m>>2]|0)+68>>2]|0);c[c[r>>2]>>2]=c[n>>2];while(1){c[t>>2]=l0(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0)|0;if((c[t>>2]|0)==(a[u>>0]|0)){w=33;break}if((!(97<=(c[t>>2]|0)&(c[t>>2]|0)<=122)?!(65<=(c[t>>2]|0)&(c[t>>2]|0)<=90):0)?(48<=(c[t>>2]|0)&(c[t>>2]|0)<=57^1)&(c[t>>2]|0)!=46&(c[t>>2]|0)!=45&(c[t>>2]|0)!=95:0){w=31;break}c[n>>2]=(c[n>>2]|0)+(c[(c[m>>2]|0)+68>>2]|0)}if((w|0)==31){c[c[s>>2]>>2]=c[n>>2];c[l>>2]=0;v=c[l>>2]|0;i=k;return v|0}else if((w|0)==33){c[c[s>>2]>>2]=(c[n>>2]|0)+(c[(c[m>>2]|0)+68>>2]|0);c[l>>2]=1;v=c[l>>2]|0;i=k;return v|0}return 0}function l0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f+20|0;m=f;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[m>>2]=l;Ab[c[(c[h>>2]|0)+60>>2]&31](c[h>>2]|0,j,c[k>>2]|0,m,(c[m>>2]|0)+1|0);if((c[m>>2]|0)==(l|0)){c[g>>2]=-1;n=c[g>>2]|0;i=f;return n|0}else{c[g>>2]=a[l>>0];n=c[g>>2]|0;i=f;return n|0}return 0}function m0(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[e>>2]=a;switch(c[e>>2]|0){case 9:case 10:case 13:case 32:{c[d>>2]=1;break}default:c[d>>2]=0}i=b;return c[d>>2]|0}function n0(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;c[c[d>>2]>>2]=4;c[(c[d>>2]|0)+16>>2]=1;c[(c[d>>2]|0)+12>>2]=0;c[(c[d>>2]|0)+20>>2]=0;i=b;return}function o0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[c[j>>2]>>2]=5;c[h>>2]=0;break}case 12:{c[c[j>>2]>>2]=5;c[h>>2]=1;break}case 11:{c[c[j>>2]>>2]=5;c[h>>2]=55;break}case 13:{c[c[j>>2]>>2]=5;c[h>>2]=56;break}case 14:{c[h>>2]=0;break}case 16:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]<<1)|0,c[m>>2]|0,182325)|0){c[c[j>>2]>>2]=6;c[h>>2]=3}else o=10;break}case 29:{c[c[j>>2]>>2]=7;c[h>>2]=2;break}default:o=10}if((o|0)==10)c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;i=g;return c[h>>2]|0}function p0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 33:{c[c[j>>2]>>2]=8;c[h>>2]=0;break}case 34:{if(!(c[(c[j>>2]|0)+12>>2]|0))o=9;else{f=(c[j>>2]|0)+12|0;c[f>>2]=(c[f>>2]|0)-1;c[h>>2]=0}break}case 15:{c[h>>2]=0;break}case 26:{o=9;break}case -4:{if(c[(c[j>>2]|0)+12>>2]|0)o=9;else c[h>>2]=0;break}default:c[h>>2]=r0(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0}if((o|0)==9)c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;i=g;return c[h>>2]|0}function q0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}case 18:{p=3;break}default:{}}if((p|0)==3){if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182310)|0){c[c[j>>2]>>2]=9;c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182318)|0){c[c[j>>2]>>2]=10;c[h>>2]=0;o=c[h>>2]|0;i=g;return o|0}}c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}function r0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;a:do switch(c[k>>2]|0){case 15:{c[h>>2]=0;break}case 16:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]<<1)|0,c[m>>2]|0,182170)|0){c[c[j>>2]>>2]=11;c[h>>2]=11;break a}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]<<1)|0,c[m>>2]|0,182177)|0){c[c[j>>2]>>2]=12;c[h>>2]=33;break a}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]<<1)|0,c[m>>2]|0,182185)|0){c[c[j>>2]>>2]=13;c[h>>2]=39;break a}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]<<1)|0,c[m>>2]|0,182193)|0){c[c[j>>2]>>2]=14;c[h>>2]=17}else o=16;break}case 11:{c[h>>2]=55;break}case 13:{c[h>>2]=56;break}case 28:{c[h>>2]=60;break}case 26:{c[c[j>>2]>>2]=15;c[h>>2]=3;break}case -4:{c[h>>2]=0;break}default:o=16}while(0);if((o|0)==16)c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;i=g;return c[h>>2]|0}function s0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=a;c[g>>2]=b;if((c[g>>2]|0)==28?(c[(c[f>>2]|0)+16>>2]|0)==0:0){c[e>>2]=59;h=c[e>>2]|0;i=d;return h|0}else{c[c[f>>2]>>2]=7;c[e>>2]=-1;h=c[e>>2]|0;i=d;return h|0}return 0}function t0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;i=i+32|0;c[g+16>>2]=a;c[g+12>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;i=g;return 0}function u0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;break}case 22:{c[c[j>>2]>>2]=16;c[h>>2]=11;break}case 18:{c[c[j>>2]>>2]=17;c[h>>2]=9;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function v0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;break}case 41:case 18:{c[c[j>>2]>>2]=18;c[h>>2]=34;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function w0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=39;break}case 41:case 18:{c[c[j>>2]>>2]=19;c[h>>2]=40;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function x0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=17;break}case 18:{c[c[j>>2]>>2]=20;c[h>>2]=18;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function y0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=3;break}case 17:{c[c[j>>2]>>2]=21;c[h>>2]=8;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function z0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=0;break}case 11:{c[h>>2]=55;break}case 13:{c[h>>2]=56;break}case 29:{c[c[j>>2]>>2]=7;c[h>>2]=2;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function A0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=17;o=c[h>>2]|0;i=g;return o|0}case 18:{p=3;break}default:{}}if((p|0)==3){if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182202)|0){c[c[j>>2]>>2]=22;c[h>>2]=17;o=c[h>>2]|0;i=g;return o|0}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182209)|0){c[c[j>>2]>>2]=23;c[h>>2]=17;o=c[h>>2]|0;i=g;return o|0}}c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}function B0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=17;break}case 27:{c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=17;c[h>>2]=19;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function C0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=17;break}case 27:{c[c[j>>2]>>2]=25;c[h>>2]=21;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function D0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=17;break}case 27:{c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=17;c[h>>2]=19;break}case 17:{c[c[j>>2]>>2]=(c[(c[j>>2]|0)+16>>2]|0)!=0?26:27;c[h>>2]=20;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function E0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=c[(c[j>>2]|0)+8>>2];l=c[h>>2]|0;i=g;return l|0}case 17:{c[c[j>>2]>>2]=(c[(c[j>>2]|0)+16>>2]|0)!=0?26:27;c[h>>2]=c[(c[j>>2]|0)+8>>2];l=c[h>>2]|0;i=g;return l|0}default:{c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;l=c[h>>2]|0;i=g;return l|0}}return 0}function F0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=39;o=c[h>>2]|0;i=g;return o|0}case 18:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182216)|0){c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39;c[h>>2]=42;o=c[h>>2]|0;i=g;return o|0}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182222)|0){c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39;c[h>>2]=41;o=c[h>>2]|0;i=g;return o|0}break}case 23:{c[c[j>>2]>>2]=28;c[(c[j>>2]|0)+4>>2]=1;c[h>>2]=44;o=c[h>>2]|0;i=g;return o|0}default:{}}c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}function G0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=39;break}case 20:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]|0)|0,c[m>>2]|0,182226)|0){c[c[j>>2]>>2]=29;c[h>>2]=43}else o=10;break}case 23:{c[(c[j>>2]|0)+4>>2]=2;c[c[j>>2]>>2]=30;c[h>>2]=44;break}case 41:case 18:{c[c[j>>2]>>2]=31;c[h>>2]=51;break}case 30:{c[c[j>>2]>>2]=31;c[h>>2]=53;break}case 31:{c[c[j>>2]>>2]=31;c[h>>2]=52;break}case 32:{c[c[j>>2]>>2]=31;c[h>>2]=54;break}default:o=10}if((o|0)==10)c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;i=g;return c[h>>2]|0}function H0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=39;break}case 24:{c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39;c[h>>2]=45;break}case 36:{c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39;c[h>>2]=46;break}case 21:{c[c[j>>2]>>2]=32;c[h>>2]=39;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function I0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=39;break}case 23:{f=(c[j>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)+1;c[h>>2]=44;break}case 41:case 18:{c[c[j>>2]>>2]=31;c[h>>2]=51;break}case 30:{c[c[j>>2]>>2]=31;c[h>>2]=53;break}case 31:{c[c[j>>2]>>2]=31;c[h>>2]=52;break}case 32:{c[c[j>>2]>>2]=31;c[h>>2]=54;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function J0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=39;break}case 24:{f=(c[j>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)-1;if(!(c[(c[j>>2]|0)+4>>2]|0)){c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39}c[h>>2]=45;break}case 36:{f=(c[j>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)-1;if(!(c[(c[j>>2]|0)+4>>2]|0)){c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39}c[h>>2]=46;break}case 35:{f=(c[j>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)-1;if(!(c[(c[j>>2]|0)+4>>2]|0)){c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39}c[h>>2]=47;break}case 37:{f=(c[j>>2]|0)+4|0;c[f>>2]=(c[f>>2]|0)-1;if(!(c[(c[j>>2]|0)+4>>2]|0)){c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39}c[h>>2]=48;break}case 38:{c[c[j>>2]>>2]=30;c[h>>2]=50;break}case 21:{c[c[j>>2]>>2]=30;c[h>>2]=49;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function K0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=39;break}case 41:case 18:{c[c[j>>2]>>2]=33;c[h>>2]=51;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function L0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=39;break}case 36:{c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=39;c[h>>2]=46;break}case 21:{c[c[j>>2]>>2]=32;c[h>>2]=39;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function M0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;break}case 17:{c[c[j>>2]>>2]=(c[(c[j>>2]|0)+16>>2]|0)!=0?26:27;c[h>>2]=33;break}case 41:case 18:{c[c[j>>2]>>2]=34;c[h>>2]=22;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function N0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+32|0;h=g+24|0;j=g+20|0;k=g+16|0;l=g+12|0;m=g+8|0;n=g+4|0;o=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;p=c[h>>2]|0;i=g;return p|0}case 18:{c[o>>2]=0;while(1){q=c[(c[n>>2]|0)+28>>2]|0;r=c[n>>2]|0;s=c[l>>2]|0;t=c[m>>2]|0;if((c[o>>2]|0)>=8)break;if(Sb[q&127](r,s,t,c[98688+(c[o>>2]<<2)>>2]|0)|0){u=6;break}c[o>>2]=(c[o>>2]|0)+1}if((u|0)==6){c[c[j>>2]>>2]=35;c[h>>2]=23+(c[o>>2]|0);p=c[h>>2]|0;i=g;return p|0}if(Sb[q&127](r,s,t,182193)|0){c[c[j>>2]>>2]=36;c[h>>2]=33;p=c[h>>2]|0;i=g;return p|0}break}case 23:{c[c[j>>2]>>2]=37;c[h>>2]=33;p=c[h>>2]|0;i=g;return p|0}default:{}}c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;p=c[h>>2]|0;i=g;return p|0}function O0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;o=c[h>>2]|0;i=g;return o|0}case 20:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]|0)|0,c[m>>2]|0,182233)|0){c[c[j>>2]>>2]=18;c[h>>2]=35;o=c[h>>2]|0;i=g;return o|0}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]|0)|0,c[m>>2]|0,182241)|0){c[c[j>>2]>>2]=18;c[h>>2]=36;o=c[h>>2]|0;i=g;return o|0}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]|0)|0,c[m>>2]|0,182250)|0){c[c[j>>2]>>2]=38;c[h>>2]=33;o=c[h>>2]|0;i=g;return o|0}break}case 27:{c[c[j>>2]>>2]=18;c[h>>2]=37;o=c[h>>2]|0;i=g;return o|0}default:{}}c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}function P0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;break}case 23:{c[c[j>>2]>>2]=39;c[h>>2]=33;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function Q0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;break}case 41:case 18:case 19:{c[c[j>>2]>>2]=40;c[h>>2]=31;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function R0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;break}case 24:{c[c[j>>2]>>2]=35;c[h>>2]=33;break}case 21:{c[c[j>>2]>>2]=37;c[h>>2]=33;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function S0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;break}case 18:{c[c[j>>2]>>2]=41;c[h>>2]=32;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function T0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;break}case 24:{c[c[j>>2]>>2]=35;c[h>>2]=33;break}case 21:{c[c[j>>2]>>2]=39;c[h>>2]=33;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function U0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=33;break}case 27:{c[c[j>>2]>>2]=18;c[h>>2]=38;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function V0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;break}case 18:{c[c[j>>2]>>2]=42;c[h>>2]=10;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function W0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;o=c[h>>2]|0;i=g;return o|0}case 18:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182202)|0){c[c[j>>2]>>2]=43;c[h>>2]=11;o=c[h>>2]|0;i=g;return o|0}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182209)|0){c[c[j>>2]>>2]=44;c[h>>2]=11;o=c[h>>2]|0;i=g;return o|0}break}case 27:{c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=11;c[h>>2]=12;o=c[h>>2]|0;i=g;return o|0}default:{}}c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}function X0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;break}case 27:{c[c[j>>2]>>2]=45;c[h>>2]=13;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function Y0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;break}case 27:{c[c[j>>2]>>2]=43;c[h>>2]=14;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function Z0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;o=c[h>>2]|0;i=g;return o|0}case 17:{c[c[j>>2]>>2]=(c[(c[j>>2]|0)+16>>2]|0)!=0?26:27;c[h>>2]=15;o=c[h>>2]|0;i=g;return o|0}case 18:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182304)|0){c[c[j>>2]>>2]=46;c[h>>2]=11;o=c[h>>2]|0;i=g;return o|0}break}default:{}}c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}function _0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;break}case 18:{c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=11;c[h>>2]=16;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function $0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;o=c[h>>2]|0;i=g;return o|0}case 18:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182202)|0){c[c[j>>2]>>2]=47;c[h>>2]=11;o=c[h>>2]|0;i=g;return o|0}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182209)|0){c[c[j>>2]>>2]=48;c[h>>2]=11;o=c[h>>2]|0;i=g;return o|0}break}case 27:{c[c[j>>2]>>2]=24;c[(c[j>>2]|0)+8>>2]=11;c[h>>2]=12;o=c[h>>2]|0;i=g;return o|0}default:{}}c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;o=c[h>>2]|0;i=g;return o|0}function a1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;break}case 27:{c[c[j>>2]>>2]=49;c[h>>2]=13;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function b1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;break}case 27:{c[c[j>>2]>>2]=47;c[h>>2]=14;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function c1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=11;l=c[h>>2]|0;i=g;return l|0}case 17:{c[c[j>>2]>>2]=(c[(c[j>>2]|0)+16>>2]|0)!=0?26:27;c[h>>2]=15;l=c[h>>2]|0;i=g;return l|0}default:{c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;l=c[h>>2]|0;i=g;return l|0}}return 0}function d1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=0;l=c[h>>2]|0;i=g;return l|0}case 25:{c[c[j>>2]>>2]=27;f=(c[j>>2]|0)+12|0;c[f>>2]=(c[f>>2]|0)+1;c[h>>2]=0;l=c[h>>2]|0;i=g;return l|0}default:{c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;l=c[h>>2]|0;i=g;return l|0}}return 0}function e1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=0;break}case 25:{c[c[j>>2]>>2]=27;c[h>>2]=58;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function f1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=0;break}case 11:{c[h>>2]=55;break}case 13:{c[h>>2]=56;break}case 14:{c[h>>2]=0;break}case 16:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,(c[l>>2]|0)+(c[(c[n>>2]|0)+68>>2]<<1)|0,c[m>>2]|0,182325)|0){c[c[j>>2]>>2]=6;c[h>>2]=3}else o=9;break}case 29:{c[c[j>>2]>>2]=7;c[h>>2]=2;break}default:o=9}if((o|0)==9)c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;i=g;return c[h>>2]|0}function g1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=3;break}case 41:case 18:{c[c[j>>2]>>2]=50;c[h>>2]=4;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function h1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;l=g+8|0;m=g+4|0;n=g;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;a:do switch(c[k>>2]|0){case 15:{c[h>>2]=3;break}case 25:{c[c[j>>2]>>2]=26;c[h>>2]=7;break}case 17:{c[c[j>>2]>>2]=21;c[h>>2]=8;break}case 18:{if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182202)|0){c[c[j>>2]>>2]=51;c[h>>2]=3;break a}if(Sb[c[(c[n>>2]|0)+28>>2]&127](c[n>>2]|0,c[l>>2]|0,c[m>>2]|0,182209)|0){c[c[j>>2]>>2]=52;c[h>>2]=3}else o=9;break}default:o=9}while(0);if((o|0)==9)c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0;i=g;return c[h>>2]|0}function i1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=3;break}case 27:{c[c[j>>2]>>2]=53;c[h>>2]=5;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function j1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=3;break}case 27:{c[c[j>>2]>>2]=51;c[h>>2]=6;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function k1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+32|0;h=g+20|0;j=g+16|0;k=g+12|0;c[j>>2]=a;c[k>>2]=b;c[g+8>>2]=d;c[g+4>>2]=e;c[g>>2]=f;switch(c[k>>2]|0){case 15:{c[h>>2]=3;break}case 25:{c[c[j>>2]>>2]=26;c[h>>2]=7;break}case 17:{c[c[j>>2]>>2]=21;c[h>>2]=8;break}default:c[h>>2]=s0(c[j>>2]|0,c[k>>2]|0)|0}i=g;return c[h>>2]|0}function l1(a){a=a|0;return ((a+-48|0)>>>0<10|(m1(a)|0)!=0)&1|0}function m1(a){a=a|0;return ((a|32)+-97|0)>>>0<26|0}function n1(a){a=a|0;return a>>>0<128|0}function o1(a){a=a|0;return ((a|0)==32|(a|0)==9)&1|0}function p1(a){a=a|0;return (a+-48|0)>>>0<10|0}function q1(a){a=a|0;return (a+-97|0)>>>0<26|0}function r1(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function s1(a){a=a|0;return (a+-65|0)>>>0<26|0}function t1(a){a=a|0;var b=0;if(!(z1(a)|0))b=(u1(a)|0)!=0;else b=1;return b&1|0}function u1(a){a=a|0;var b=0;if(a>>>0<131072)b=(d[182333+((d[182333+(a>>>8)>>0]|0)<<5|a>>>3&31)>>0]|0)>>>(a&7)&1;else b=a>>>0<196606&1;return b|0}function v1(a){a=a|0;return o1(a)|0}function w1(a){a=a|0;var b=0;if((a&-2|0)==8232|(a>>>0<32|(a+-127|0)>>>0<33))b=1;else b=(a+-65529|0)>>>0<3;return b&1|0}function x1(a,b){a=a|0;b=b|0;var c=0;do switch(b|0){case 1:{c=t1(a)|0;break}case 2:{c=u1(a)|0;break}case 3:{c=v1(a)|0;break}case 4:{c=w1(a)|0;break}case 5:{c=z1(a)|0;break}case 6:{c=A1(a)|0;break}case 7:{c=B1(a)|0;break}case 8:{c=C1(a)|0;break}case 9:{c=D1(a)|0;break}case 10:{c=E1(a)|0;break}case 11:{c=F1(a)|0;break}case 12:{c=G1(a)|0;break}default:c=0}while(0);return c|0}function y1(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=a[b>>0]|0;d=97;e=1;f=185309;while(1){if(c<<24>>24==d<<24>>24?(J3(b,f)|0)==0:0){g=e;break}f=f+6|0;d=a[f>>0]|0;if(!(d<<24>>24)){g=0;break}else e=e+1|0}return g|0}function z1(a){a=a|0;return (a+-48|0)>>>0<10|0}function A1(a){a=a|0;var b=0;if(!(E1(a)|0))b=(C1(a)|0)!=0;else b=0;return b&1|0}function B1(a){a=a|0;return ((a|0)==223|(J1(a)|0)!=(a|0))&1|0}function C1(a){a=a|0;var b=0;if(a>>>0>=255)if((a+-57344|0)>>>0<8185|(a>>>0<8232|(a+-8234|0)>>>0<47062))b=1;else return ((a+-65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0;else b=(a+1&127)>>>0>32&1;return b|0}function D1(a){a=a|0;var b=0;if(a>>>0<131072)b=(d[185382+((d[185382+(a>>>8)>>0]|0)<<5|a>>>3&31)>>0]|0)>>>(a&7)&1;else b=0;return b|0}function E1(a){a=a|0;var b=0;if(!a)b=0;else b=(X3(98984,a)|0)!=0;return b&1|0}function F1(a){a=a|0;return (K1(a)|0)!=(a|0)|0}function G1(a){a=a|0;var b=0;if((a+-48|0)>>>0<10)b=1;else b=((a|32)+-97|0)>>>0<6;return b&1|0}function H1(a){a=a|0;var b=0;b=(s1(a)|0)==0;return (b?a:a|32)|0}function I1(a){a=a|0;var b=0;b=(q1(a)|0)==0;return (b?a:a&95)|0}function J1(a){a=a|0;return $3(a,0)|0}function K1(a){a=a|0;return $3(a,1)|0}function L1(){var a=0;if(!(c[24680]|0))a=99072;else a=c[(cb()|0)+60>>2]|0;return a|0}function M1(b){b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0,j=0;c=0;while(1){if((d[188550+c>>0]|0)==(b|0)){e=c;f=2;break}c=c+1|0;if((c|0)==87){g=87;h=188638;f=5;break}}if((f|0)==2)if(!e)i=188638;else{g=e;h=188638;f=5}if((f|0)==5)while(1){f=0;e=h;while(1){c=e+1|0;if(!(a[e>>0]|0)){j=c;break}else e=c}g=g+-1|0;if(!g){i=j;break}else{h=j;f=5}}return i|0}function N1(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0.0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0,Pa=0.0,Qa=0,Ra=0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0.0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0.0,fd=0.0,gd=0.0,hd=0.0,id=0.0,jd=0.0,kd=0.0,ld=0,md=0,nd=0.0,od=0,pd=0.0;g=i;i=i+512|0;h=g;switch(e|0){case 0:{j=24;k=-149;l=4;break}case 1:{j=53;k=-1074;l=4;break}case 2:{j=53;k=-1074;l=4;break}default:m=0.0}a:do if((l|0)==4){e=b+4|0;n=b+100|0;do{o=c[e>>2]|0;if(o>>>0<(c[n>>2]|0)>>>0){c[e>>2]=o+1;p=d[o>>0]|0}else p=R1(b)|0}while((r1(p)|0)!=0);q=p;b:do switch(q|0){case 43:case 45:{o=1-(((q|0)==45&1)<<1)|0;t=c[e>>2]|0;if(t>>>0<(c[n>>2]|0)>>>0){c[e>>2]=t+1;u=d[t>>0]|0;v=o;break b}else{u=R1(b)|0;v=o;break b}break}default:{u=q;v=1}}while(0);o=u;t=0;while(1){if((o|32|0)!=(a[190442+t>>0]|0)){w=o;x=t;break}do if(t>>>0<7){y=c[e>>2]|0;if(y>>>0<(c[n>>2]|0)>>>0){c[e>>2]=y+1;z=d[y>>0]|0;break}else{z=R1(b)|0;break}}else z=o;while(0);y=t+1|0;if(y>>>0<8){o=z;t=y}else{w=z;x=y;break}}c:do switch(x|0){case 8:break;case 3:{l=23;break}default:{t=(f|0)!=0;if(t&x>>>0>3)if((x|0)==8)break c;else{l=23;break c}d:do if(!x){o=w;y=0;while(1){if((o|32|0)!=(a[193380+y>>0]|0)){A=o;B=y;break d}do if(y>>>0<2){D=c[e>>2]|0;if(D>>>0<(c[n>>2]|0)>>>0){c[e>>2]=D+1;E=d[D>>0]|0;break}else{E=R1(b)|0;break}}else E=o;while(0);D=y+1|0;if(D>>>0<3){o=E;y=D}else{A=E;B=D;break}}}else{A=w;B=x}while(0);switch(B|0){case 3:{y=c[e>>2]|0;if(y>>>0<(c[n>>2]|0)>>>0){c[e>>2]=y+1;F=d[y>>0]|0}else F=R1(b)|0;if((F|0)==40)G=1;else{if(!(c[n>>2]|0)){m=r;break a}c[e>>2]=(c[e>>2]|0)+-1;m=r;break a}while(1){y=c[e>>2]|0;if(y>>>0<(c[n>>2]|0)>>>0){c[e>>2]=y+1;H=d[y>>0]|0}else H=R1(b)|0;if(!((H+-48|0)>>>0<10|(H+-65|0)>>>0<26)?!((H|0)==95|(H+-97|0)>>>0<26):0){I=H;J=G;break}G=G+1|0}if((I|0)==41){m=r;break a}y=(c[n>>2]|0)==0;if(!y)c[e>>2]=(c[e>>2]|0)+-1;if(!t){c[(L1()|0)>>2]=22;Q1(b,0);m=0.0;break a}if(!J){m=r;break a}else K=J;while(1){K=K+-1|0;if(!y)c[e>>2]=(c[e>>2]|0)+-1;if(!K){m=r;break a}}break}case 0:{do if((A|0)==48){y=c[e>>2]|0;if(y>>>0<(c[n>>2]|0)>>>0){c[e>>2]=y+1;L=d[y>>0]|0}else L=R1(b)|0;if((L|32|0)!=120){if(!(c[n>>2]|0)){M=48;break}c[e>>2]=(c[e>>2]|0)+-1;M=48;break}y=c[e>>2]|0;if(y>>>0<(c[n>>2]|0)>>>0){c[e>>2]=y+1;O=d[y>>0]|0;P=0}else{O=R1(b)|0;P=0}e:while(1){switch(O|0){case 46:{Q=P;l=74;break e;break}case 48:break;default:{R=0;S=0;T=0;U=0;V=O;W=P;X=0;Y=0;Z=1.0;$=0;aa=0.0;break e}}y=c[e>>2]|0;if(y>>>0<(c[n>>2]|0)>>>0){c[e>>2]=y+1;O=d[y>>0]|0;P=1;continue}else{O=R1(b)|0;P=1;continue}}if((l|0)==74){y=c[e>>2]|0;if(y>>>0<(c[n>>2]|0)>>>0){c[e>>2]=y+1;ba=d[y>>0]|0}else ba=R1(b)|0;if((ba|0)==48){y=0;t=0;while(1){o=c[e>>2]|0;if(o>>>0<(c[n>>2]|0)>>>0){c[e>>2]=o+1;ca=d[o>>0]|0}else ca=R1(b)|0;o=V4(y|0,t|0,-1,-1)|0;D=C;if((ca|0)==48){y=o;t=D}else{R=0;S=0;T=o;U=D;V=ca;W=1;X=1;Y=0;Z=1.0;$=0;aa=0.0;break}}}else{R=0;S=0;T=0;U=0;V=ba;W=Q;X=1;Y=0;Z=1.0;$=0;aa=0.0}}while(1){t=V+-48|0;y=V|32;if(t>>>0>=10){D=(V|0)==46;if(!(D|(y+-97|0)>>>0<6)){da=S;ea=T;fa=R;ga=U;ha=V;ia=W;ja=X;ka=$;la=aa;break}if(D)if(!X){ma=S;na=R;oa=S;pa=R;qa=W;ra=1;sa=Y;ta=Z;ua=$;va=aa}else{da=S;ea=T;fa=R;ga=U;ha=46;ia=W;ja=X;ka=$;la=aa;break}else l=86}else l=86;if((l|0)==86){l=0;D=(V|0)>57?y+-87|0:t;do if(!((R|0)<0|(R|0)==0&S>>>0<8)){if((R|0)<0|(R|0)==0&S>>>0<14){wa=Z*.0625;xa=Y;ya=wa;za=$;Aa=aa+wa*+(D|0);break}if((Y|0)!=0|(D|0)==0){xa=Y;ya=Z;za=$;Aa=aa}else{xa=1;ya=Z;za=$;Aa=aa+Z*.5}}else{xa=Y;ya=Z;za=D+($<<4)|0;Aa=aa}while(0);D=V4(S|0,R|0,1,0)|0;ma=T;na=U;oa=D;pa=C;qa=1;ra=X;sa=xa;ta=ya;ua=za;va=Aa}D=c[e>>2]|0;if(D>>>0<(c[n>>2]|0)>>>0){c[e>>2]=D+1;R=pa;S=oa;T=ma;U=na;V=d[D>>0]|0;W=qa;X=ra;Y=sa;Z=ta;$=ua;aa=va;continue}else{R=pa;S=oa;T=ma;U=na;V=R1(b)|0;W=qa;X=ra;Y=sa;Z=ta;$=ua;aa=va;continue}}if(!ia){D=(c[n>>2]|0)==0;if(!D)c[e>>2]=(c[e>>2]|0)+-1;if(f){if(!D?(D=c[e>>2]|0,c[e>>2]=D+-1,(ja|0)!=0):0)c[e>>2]=D+-2}else Q1(b,0);m=+(v|0)*0.0;break a}D=(ja|0)==0;t=D?da:ea;y=D?fa:ga;if((fa|0)<0|(fa|0)==0&da>>>0<8){D=da;o=fa;Ba=ka;while(1){Ca=Ba<<4;D=V4(D|0,o|0,1,0)|0;o=C;if(!((o|0)<0|(o|0)==0&D>>>0<8)){Da=Ca;break}else Ba=Ca}}else Da=ka;if((ha|32|0)==112){Ba=a4(b,f)|0;D=C;if((Ba|0)==0&(D|0)==-2147483648){if(!f){Q1(b,0);m=0.0;break a}if(!(c[n>>2]|0)){Ea=0;Fa=0}else{c[e>>2]=(c[e>>2]|0)+-1;Ea=0;Fa=0}}else{Ea=Ba;Fa=D}}else if(!(c[n>>2]|0)){Ea=0;Fa=0}else{c[e>>2]=(c[e>>2]|0)+-1;Ea=0;Fa=0}D=a5(t|0,y|0,2)|0;Ba=V4(D|0,C|0,-32,-1)|0;D=V4(Ba|0,C|0,Ea|0,Fa|0)|0;Ba=C;if(!Da){m=+(v|0)*0.0;break a}if((Ba|0)>0|(Ba|0)==0&D>>>0>(0-k|0)>>>0){c[(L1()|0)>>2]=34;m=+(v|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break a}o=k+-106|0;Ca=((o|0)<0)<<31>>31;if((Ba|0)<(Ca|0)|(Ba|0)==(Ca|0)&D>>>0<o>>>0){c[(L1()|0)>>2]=34;m=+(v|0)*2.2250738585072014e-308*2.2250738585072014e-308;break a}if((Da|0)>-1){o=D;Ca=Ba;Ga=Da;wa=la;while(1){Ha=!(wa>=.5);Ia=Ha&1|Ga<<1;Ja=Ia^1;Ka=wa+(Ha?wa:wa+-1.0);Ha=V4(o|0,Ca|0,-1,-1)|0;La=C;if((Ia|0)>-1){o=Ha;Ca=La;Ga=Ja;wa=Ka}else{Ma=Ha;Na=La;Oa=Ja;Pa=Ka;break}}}else{Ma=D;Na=Ba;Oa=Da;Pa=la}Ga=U4(32,0,k|0,((k|0)<0)<<31>>31|0)|0;Ca=V4(Ma|0,Na|0,Ga|0,C|0)|0;Ga=C;if(0>(Ga|0)|0==(Ga|0)&j>>>0>Ca>>>0)if((Ca|0)<0){Qa=0;l=127}else{Ra=Ca;l=125}else{Ra=j;l=125}if((l|0)==125)if((Ra|0)<53){Qa=Ra;l=127}else{Sa=Ra;Ta=+(v|0);Ua=0.0}if((l|0)==127){wa=+(v|0);Sa=Qa;Ta=wa;Ua=+_1(+g2(1.0,84-Qa|0),wa)}Ca=(Oa&1|0)==0&(Pa!=0.0&(Sa|0)<32);wa=Ta*(Ca?0.0:Pa)+(Ua+Ta*+(((Ca&1)+Oa|0)>>>0))-Ua;if(!(wa!=0.0))c[(L1()|0)>>2]=34;m=+h2(wa,Ma);break a}else M=A;while(0);Ca=k+j|0;Ga=0-Ca|0;o=M;y=0;f:while(1){switch(o|0){case 46:{Va=y;l=138;break f;break}case 48:break;default:{Wa=o;Xa=0;Ya=0;Za=y;_a=0;break f}}t=c[e>>2]|0;if(t>>>0<(c[n>>2]|0)>>>0){c[e>>2]=t+1;o=d[t>>0]|0;y=1;continue}else{o=R1(b)|0;y=1;continue}}if((l|0)==138){y=c[e>>2]|0;if(y>>>0<(c[n>>2]|0)>>>0){c[e>>2]=y+1;$a=d[y>>0]|0}else $a=R1(b)|0;if(($a|0)==48){y=0;o=0;while(1){t=V4(y|0,o|0,-1,-1)|0;Ja=C;La=c[e>>2]|0;if(La>>>0<(c[n>>2]|0)>>>0){c[e>>2]=La+1;ab=d[La>>0]|0}else ab=R1(b)|0;if((ab|0)==48){y=t;o=Ja}else{Wa=ab;Xa=t;Ya=Ja;Za=1;_a=1;break}}}else{Wa=$a;Xa=0;Ya=0;Za=Va;_a=1}}c[h>>2]=0;o=Wa+-48|0;y=(Wa|0)==46;g:do if(y|o>>>0<10){Ja=h+496|0;t=Wa;La=0;Ha=0;Ia=y;bb=o;cb=Xa;db=Ya;eb=Za;fb=_a;gb=0;hb=0;ib=0;h:while(1){do if(Ia)if(!fb){jb=La;kb=Ha;lb=La;mb=Ha;nb=eb;ob=1;pb=gb;qb=hb;rb=ib}else{sb=cb;tb=db;ub=La;vb=Ha;wb=eb;xb=gb;yb=hb;zb=ib;break h}else{Ab=V4(La|0,Ha|0,1,0)|0;Bb=C;Cb=(t|0)!=48;if((hb|0)>=125){if(!Cb){jb=cb;kb=db;lb=Ab;mb=Bb;nb=eb;ob=fb;pb=gb;qb=hb;rb=ib;break}c[Ja>>2]=c[Ja>>2]|1;jb=cb;kb=db;lb=Ab;mb=Bb;nb=eb;ob=fb;pb=gb;qb=hb;rb=ib;break}Db=h+(hb<<2)|0;if(!gb)Eb=bb;else Eb=t+-48+((c[Db>>2]|0)*10|0)|0;c[Db>>2]=Eb;Db=gb+1|0;Fb=(Db|0)==9;jb=cb;kb=db;lb=Ab;mb=Bb;nb=1;ob=fb;pb=Fb?0:Db;qb=(Fb&1)+hb|0;rb=Cb?Ab:ib}while(0);Ab=c[e>>2]|0;if(Ab>>>0<(c[n>>2]|0)>>>0){c[e>>2]=Ab+1;Gb=d[Ab>>0]|0}else Gb=R1(b)|0;bb=Gb+-48|0;Ia=(Gb|0)==46;if(!(Ia|bb>>>0<10)){Hb=Gb;Ib=lb;Jb=jb;Kb=mb;Lb=kb;Mb=nb;Nb=ob;Ob=pb;Pb=qb;Qb=rb;l=161;break g}else{t=Gb;La=lb;Ha=mb;cb=jb;db=kb;eb=nb;fb=ob;gb=pb;hb=qb;ib=rb}}Rb=ub;Sb=vb;Tb=sb;Ub=tb;Vb=(wb|0)!=0;Wb=xb;Xb=yb;Yb=zb;l=169}else{Hb=Wa;Ib=0;Jb=Xa;Kb=0;Lb=Ya;Mb=Za;Nb=_a;Ob=0;Pb=0;Qb=0;l=161}while(0);do if((l|0)==161){o=(Nb|0)==0;y=o?Ib:Jb;ib=o?Kb:Lb;o=(Mb|0)!=0;if(!((Hb|32|0)==101&o))if((Hb|0)>-1){Rb=Ib;Sb=Kb;Tb=y;Ub=ib;Vb=o;Wb=Ob;Xb=Pb;Yb=Qb;l=169;break}else{Zb=Ib;_b=Kb;$b=o;ac=y;bc=ib;cc=Ob;dc=Pb;ec=Qb;l=171;break}o=a4(b,f)|0;hb=C;if((o|0)==0&(hb|0)==-2147483648){if(!f){Q1(b,0);fc=0.0;break}if(!(c[n>>2]|0)){gc=0;hc=0}else{c[e>>2]=(c[e>>2]|0)+-1;gc=0;hc=0}}else{gc=o;hc=hb}hb=V4(gc|0,hc|0,y|0,ib|0)|0;ic=hb;jc=Ib;kc=C;lc=Kb;mc=Ob;nc=Pb;oc=Qb;l=173}while(0);if((l|0)==169)if(c[n>>2]|0){c[e>>2]=(c[e>>2]|0)+-1;if(Vb){ic=Tb;jc=Rb;kc=Ub;lc=Sb;mc=Wb;nc=Xb;oc=Yb;l=173}else l=172}else{Zb=Rb;_b=Sb;$b=Vb;ac=Tb;bc=Ub;cc=Wb;dc=Xb;ec=Yb;l=171}if((l|0)==171)if($b){ic=ac;jc=Zb;kc=bc;lc=_b;mc=cc;nc=dc;oc=ec;l=173}else l=172;do if((l|0)==172){c[(L1()|0)>>2]=22;Q1(b,0);fc=0.0}else if((l|0)==173){hb=c[h>>2]|0;if(!hb){fc=+(v|0)*0.0;break}if(((lc|0)<0|(lc|0)==0&jc>>>0<10)&((ic|0)==(jc|0)&(kc|0)==(lc|0))?j>>>0>30|(hb>>>j|0)==0:0){fc=+(v|0)*+(hb>>>0);break}hb=(k|0)/-2|0;ib=((hb|0)<0)<<31>>31;if((kc|0)>(ib|0)|(kc|0)==(ib|0)&ic>>>0>hb>>>0){c[(L1()|0)>>2]=34;fc=+(v|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}hb=k+-106|0;ib=((hb|0)<0)<<31>>31;if((kc|0)<(ib|0)|(kc|0)==(ib|0)&ic>>>0<hb>>>0){c[(L1()|0)>>2]=34;fc=+(v|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(!mc)pc=nc;else{if((mc|0)<9){hb=h+(nc<<2)|0;ib=c[hb>>2]|0;y=mc;while(1){o=ib*10|0;y=y+1|0;if((y|0)==9){qc=o;break}else ib=o}c[hb>>2]=qc}pc=nc+1|0}if((oc|0)<9?(oc|0)<=(ic|0)&(ic|0)<18:0){if((ic|0)==9){fc=+(v|0)*+((c[h>>2]|0)>>>0);break}if((ic|0)<9){fc=+(v|0)*+((c[h>>2]|0)>>>0)/+(c[99076+(8-ic<<2)>>2]|0);break}ib=j+27+(_(ic,-3)|0)|0;y=c[h>>2]|0;if((ib|0)>30|(y>>>ib|0)==0){fc=+(v|0)*+(y>>>0)*+(c[99076+(ic+-10<<2)>>2]|0);break}}y=(ic|0)%9|0;if(!y){rc=0;sc=0;tc=ic;uc=pc}else{ib=(ic|0)>-1?y:y+9|0;y=c[99076+(8-ib<<2)>>2]|0;if(pc){o=1e9/(y|0)|0;gb=0;fb=0;eb=0;db=ic;while(1){cb=h+(eb<<2)|0;Ha=c[cb>>2]|0;La=((Ha>>>0)/(y>>>0)|0)+fb|0;c[cb>>2]=La;cb=_((Ha>>>0)%(y>>>0)|0,o)|0;Ha=(eb|0)==(gb|0)&(La|0)==0;eb=eb+1|0;La=Ha?db+-9|0:db;t=Ha?eb&127:gb;if((eb|0)==(pc|0)){vc=cb;wc=t;xc=La;break}else{gb=t;fb=cb;db=La}}if(!vc){yc=wc;zc=xc;Ac=pc}else{c[h+(pc<<2)>>2]=vc;yc=wc;zc=xc;Ac=pc+1|0}}else{yc=0;zc=ic;Ac=0}rc=yc;sc=0;tc=9-ib+zc|0;uc=Ac}i:while(1){db=(tc|0)<18;fb=(tc|0)==18;gb=h+(rc<<2)|0;eb=sc;o=uc;while(1){if(!db){if(!fb){Bc=rc;Cc=eb;Dc=tc;Ec=o;break i}if((c[gb>>2]|0)>>>0>=9007199){Bc=rc;Cc=eb;Dc=18;Ec=o;break i}}y=0;hb=o+127|0;La=o;while(1){cb=hb&127;t=h+(cb<<2)|0;Ha=a5(c[t>>2]|0,0,29)|0;bb=V4(Ha|0,C|0,y|0,0)|0;Ha=C;if(Ha>>>0>0|(Ha|0)==0&bb>>>0>1e9){Ia=h5(bb|0,Ha|0,1e9,0)|0;Ja=i5(bb|0,Ha|0,1e9,0)|0;Fc=Ja;Gc=Ia}else{Fc=bb;Gc=0}c[t>>2]=Fc;t=(cb|0)==(rc|0);bb=(cb|0)!=(La+127&127|0)|t?La:(Fc|0)==0?cb:La;if(t){Hc=Gc;Ic=bb;break}else{y=Gc;hb=cb+-1|0;La=bb}}La=eb+-29|0;if(!Hc){eb=La;o=Ic}else{Jc=La;Kc=Hc;Lc=Ic;break}}o=rc+127&127;if((o|0)==(Lc|0)){eb=Lc+127&127;gb=h+((Lc+126&127)<<2)|0;c[gb>>2]=c[gb>>2]|c[h+(eb<<2)>>2];Mc=eb}else Mc=Lc;c[h+(o<<2)>>2]=Kc;rc=o;sc=Jc;tc=tc+9|0;uc=Mc}j:while(1){Nc=Ec+1&127;ib=h+((Ec+127&127)<<2)|0;o=Bc;eb=Cc;gb=Dc;while(1){fb=(gb|0)==18;db=(gb|0)>27?9:1;La=fb^1;Oc=o;Pc=eb;while(1){Qc=Oc&127;Rc=(Qc|0)==(Ec|0);do if(!Rc){hb=c[h+(Qc<<2)>>2]|0;if(hb>>>0<9007199){l=219;break}if(hb>>>0>9007199)break;hb=Oc+1&127;if((hb|0)==(Ec|0)){l=219;break}y=c[h+(hb<<2)>>2]|0;if(y>>>0<254740991){l=219;break}if(!(y>>>0>254740991|La)){Sc=Qc;Tc=Oc;Uc=Pc;Vc=Ec;break j}}else l=219;while(0);if((l|0)==219?(l=0,fb):0){l=220;break j}y=Pc+db|0;if((Oc|0)==(Ec|0)){Oc=Ec;Pc=y}else{Wc=y;Xc=Oc;break}}fb=(1<<db)+-1|0;La=1e9>>>db;y=Xc;hb=0;bb=Xc;cb=gb;while(1){t=h+(bb<<2)|0;Ia=c[t>>2]|0;Ja=(Ia>>>db)+hb|0;c[t>>2]=Ja;t=_(Ia&fb,La)|0;Ia=(bb|0)==(y|0)&(Ja|0)==0;bb=bb+1&127;Ja=Ia?cb+-9|0:cb;Ha=Ia?bb:y;if((bb|0)==(Ec|0)){Yc=t;Zc=Ha;_c=Ja;break}else{y=Ha;hb=t;cb=Ja}}if(!Yc){o=Zc;eb=Wc;gb=_c;continue}if((Nc|0)!=(Zc|0)){$c=Wc;ad=Yc;bd=Zc;cd=_c;break}c[ib>>2]=c[ib>>2]|1;o=Zc;eb=Wc;gb=_c}c[h+(Ec<<2)>>2]=ad;Bc=bd;Cc=$c;Dc=cd;Ec=Nc}if((l|0)==220)if(Rc){c[h+(Nc+-1<<2)>>2]=0;Sc=Ec;Tc=Oc;Uc=Pc;Vc=Nc}else{Sc=Qc;Tc=Oc;Uc=Pc;Vc=Ec}wa=+((c[h+(Sc<<2)>>2]|0)>>>0);gb=Tc+1&127;if((gb|0)==(Vc|0)){eb=Tc+2&127;c[h+(eb+-1<<2)>>2]=0;dd=eb}else dd=Vc;Ka=+(v|0);ed=Ka*(wa*1.0e9+ +((c[h+(gb<<2)>>2]|0)>>>0));gb=Uc+53|0;eb=gb-k|0;o=(eb|0)<(j|0);ib=o&1;cb=o?((eb|0)<0?0:eb):j;if((cb|0)<53){wa=+_1(+g2(1.0,105-cb|0),ed);fd=+a2(ed,+g2(1.0,53-cb|0));gd=wa;hd=fd;id=wa+(ed-fd)}else{gd=0.0;hd=0.0;id=ed}hb=Tc+2&127;do if((hb|0)==(dd|0))jd=hd;else{y=c[h+(hb<<2)>>2]|0;do if(y>>>0>=5e8){if(y>>>0>5e8){kd=Ka*.75+hd;break}if((Tc+3&127|0)==(dd|0)){kd=Ka*.5+hd;break}else{kd=Ka*.75+hd;break}}else{if((y|0)==0?(Tc+3&127|0)==(dd|0):0){kd=hd;break}kd=Ka*.25+hd}while(0);if((53-cb|0)<=1){jd=kd;break}if(+a2(kd,1.0)!=0.0){jd=kd;break}jd=kd+1.0}while(0);Ka=id+jd-gd;do if((gb&2147483647|0)>(-2-Ca|0)){if(!(+N(+Ka)>=9007199254740992.0)){ld=ib;md=Uc;nd=Ka}else{ld=o&(cb|0)==(eb|0)?0:ib;md=Uc+1|0;nd=Ka*.5}if((md+50|0)<=(Ga|0)?!(jd!=0.0&(ld|0)!=0):0){od=md;pd=nd;break}c[(L1()|0)>>2]=34;od=md;pd=nd}else{od=Uc;pd=Ka}while(0);fc=+h2(pd,od)}while(0);m=fc;break a;break}default:{if(c[n>>2]|0)c[e>>2]=(c[e>>2]|0)+-1;c[(L1()|0)>>2]=22;Q1(b,0);m=0.0;break a}}}}while(0);if((l|0)==23){Ga=(c[n>>2]|0)==0;if(!Ga)c[e>>2]=(c[e>>2]|0)+-1;if((f|0)!=0&x>>>0>3){Ca=x;do{if(!Ga)c[e>>2]=(c[e>>2]|0)+-1;Ca=Ca+-1|0}while(Ca>>>0>3)}}m=+(v|0)*s}while(0);i=g;return +m}function O1(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0;a:do if(e>>>0>36){c[(L1()|0)>>2]=22;i=0;j=0}else{k=b+4|0;l=b+100|0;do{m=c[k>>2]|0;if(m>>>0<(c[l>>2]|0)>>>0){c[k>>2]=m+1;n=d[m>>0]|0}else n=R1(b)|0}while((r1(n)|0)!=0);o=n;b:do switch(o|0){case 43:case 45:{m=((o|0)==45)<<31>>31;p=c[k>>2]|0;if(p>>>0<(c[l>>2]|0)>>>0){c[k>>2]=p+1;q=d[p>>0]|0;r=m;break b}else{q=R1(b)|0;r=m;break b}break}default:{q=o;r=0}}while(0);m=(e|0)==0;do if((e&-17|0)==0&(q|0)==48){p=c[k>>2]|0;if(p>>>0<(c[l>>2]|0)>>>0){c[k>>2]=p+1;s=d[p>>0]|0}else s=R1(b)|0;if((s|32|0)!=120)if(m){t=8;u=s;v=46;break}else{w=e;x=s;v=32;break}p=c[k>>2]|0;if(p>>>0<(c[l>>2]|0)>>>0){c[k>>2]=p+1;y=d[p>>0]|0}else y=R1(b)|0;if((d[190452+y>>0]|0)>15){p=(c[l>>2]|0)==0;if(!p)c[k>>2]=(c[k>>2]|0)+-1;if(!f){Q1(b,0);i=0;j=0;break a}if(p){i=0;j=0;break a}c[k>>2]=(c[k>>2]|0)+-1;i=0;j=0;break a}else{t=16;u=y;v=46}}else{p=m?10:e;if((d[190452+q>>0]|0)>>>0<p>>>0){w=p;x=q;v=32}else{if(c[l>>2]|0)c[k>>2]=(c[k>>2]|0)+-1;Q1(b,0);c[(L1()|0)>>2]=22;i=0;j=0;break a}}while(0);if((v|0)==32)if((w|0)==10){m=x+-48|0;if(m>>>0<10){p=m;m=0;while(1){z=(m*10|0)+p|0;A=c[k>>2]|0;if(A>>>0<(c[l>>2]|0)>>>0){c[k>>2]=A+1;B=d[A>>0]|0}else B=R1(b)|0;p=B+-48|0;if(!(p>>>0<10&z>>>0<429496729)){D=z;E=B;break}else m=z}F=D;G=0;H=E}else{F=0;G=0;H=x}m=H+-48|0;if(m>>>0<10){p=F;z=G;A=m;m=H;while(1){I=g5(p|0,z|0,10,0)|0;J=C;K=((A|0)<0)<<31>>31;L=~K;if(J>>>0>L>>>0|(J|0)==(L|0)&I>>>0>~A>>>0){M=A;N=p;O=z;P=m;break}L=V4(I|0,J|0,A|0,K|0)|0;K=C;J=c[k>>2]|0;if(J>>>0<(c[l>>2]|0)>>>0){c[k>>2]=J+1;Q=d[J>>0]|0}else Q=R1(b)|0;J=Q+-48|0;if(J>>>0<10&(K>>>0<429496729|(K|0)==429496729&L>>>0<2576980378)){p=L;z=K;A=J;m=Q}else{M=J;N=L;O=K;P=Q;break}}if(M>>>0>9){R=O;S=N;T=r}else{U=10;V=N;W=O;X=P;v=72}}else{R=G;S=F;T=r}}else{t=w;u=x;v=46}c:do if((v|0)==46){if(!(t+-1&t)){m=a[190708+((t*23|0)>>>5&7)>>0]|0;A=a[190452+u>>0]|0;z=A&255;if(z>>>0<t>>>0){p=z;z=0;while(1){K=p|z<<m;L=c[k>>2]|0;if(L>>>0<(c[l>>2]|0)>>>0){c[k>>2]=L+1;Y=d[L>>0]|0}else Y=R1(b)|0;L=a[190452+Y>>0]|0;p=L&255;if(!(K>>>0<134217728&p>>>0<t>>>0)){Z=K;$=L;aa=Y;break}else z=K}ba=$;ca=0;da=Z;ea=aa}else{ba=A;ca=0;da=0;ea=u}z=X4(-1,-1,m|0)|0;p=C;if((ba&255)>>>0>=t>>>0|(ca>>>0>p>>>0|(ca|0)==(p|0)&da>>>0>z>>>0)){U=t;V=da;W=ca;X=ea;v=72;break}else{fa=da;ga=ca;ha=ba}while(1){K=a5(fa|0,ga|0,m|0)|0;L=C;J=ha&255|K;K=c[k>>2]|0;if(K>>>0<(c[l>>2]|0)>>>0){c[k>>2]=K+1;ia=d[K>>0]|0}else ia=R1(b)|0;ha=a[190452+ia>>0]|0;if((ha&255)>>>0>=t>>>0|(L>>>0>p>>>0|(L|0)==(p|0)&J>>>0>z>>>0)){U=t;V=J;W=L;X=ia;v=72;break c}else{fa=J;ga=L}}}z=a[190452+u>>0]|0;p=z&255;if(p>>>0<t>>>0){m=p;p=0;while(1){A=m+(_(p,t)|0)|0;L=c[k>>2]|0;if(L>>>0<(c[l>>2]|0)>>>0){c[k>>2]=L+1;ja=d[L>>0]|0}else ja=R1(b)|0;L=a[190452+ja>>0]|0;m=L&255;if(!(A>>>0<119304647&m>>>0<t>>>0)){ka=A;la=L;ma=ja;break}else p=A}na=la;oa=ka;pa=0;qa=ma}else{na=z;oa=0;pa=0;qa=u}if((na&255)>>>0<t>>>0){p=h5(-1,-1,t|0,0)|0;m=C;A=pa;L=oa;J=na;K=qa;while(1){if(A>>>0>m>>>0|(A|0)==(m|0)&L>>>0>p>>>0){U=t;V=L;W=A;X=K;v=72;break c}I=g5(L|0,A|0,t|0,0)|0;ra=C;sa=J&255;if(ra>>>0>4294967295|(ra|0)==-1&I>>>0>~sa>>>0){U=t;V=L;W=A;X=K;v=72;break c}ta=V4(sa|0,0,I|0,ra|0)|0;ra=C;I=c[k>>2]|0;if(I>>>0<(c[l>>2]|0)>>>0){c[k>>2]=I+1;ua=d[I>>0]|0}else ua=R1(b)|0;J=a[190452+ua>>0]|0;if((J&255)>>>0>=t>>>0){U=t;V=ta;W=ra;X=ua;v=72;break}else{A=ra;L=ta;K=ua}}}else{U=t;V=oa;W=pa;X=qa;v=72}}while(0);if((v|0)==72)if((d[190452+X>>0]|0)>>>0<U>>>0){do{K=c[k>>2]|0;if(K>>>0<(c[l>>2]|0)>>>0){c[k>>2]=K+1;va=d[K>>0]|0}else va=R1(b)|0}while((d[190452+va>>0]|0)>>>0<U>>>0);c[(L1()|0)>>2]=34;R=h;S=g;T=(g&1|0)==0&0==0?r:0}else{R=W;S=V;T=r}if(c[l>>2]|0)c[k>>2]=(c[k>>2]|0)+-1;if(!(R>>>0<h>>>0|(R|0)==(h|0)&S>>>0<g>>>0)){if(!((g&1|0)!=0|0!=0|(T|0)!=0)){c[(L1()|0)>>2]=34;K=V4(g|0,h|0,-1,-1)|0;i=C;j=K;break}if(R>>>0>h>>>0|(R|0)==(h|0)&S>>>0>g>>>0){c[(L1()|0)>>2]=34;i=h;j=g;break}}K=((T|0)<0)<<31>>31;L=U4(S^T|0,R^K|0,T|0,K|0)|0;i=C;j=L}while(0);C=i;return j|0}function P1(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=b;e=190717;f=d+15|0;do{a[d>>0]=a[e>>0]|0;d=d+1|0;e=e+1|0}while((d|0)<(f|0));if(!c){a[b+14>>0]=48;a[b+15>>0]=0}else{e=14;d=c;while(1){f=e+1|0;if(d>>>0<10){g=f;break}else{e=f;d=(d>>>0)/10|0}}a[b+g>>0]=0;d=c;c=g;while(1){c=c+-1|0;a[b+c>>0]=(d>>>0)%10|0|48;if(d>>>0<10)break;else d=(d>>>0)/10|0}}return}function Q1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a+104>>2]=b;d=c[a+8>>2]|0;e=c[a+4>>2]|0;f=d-e|0;c[a+108>>2]=f;if((b|0)!=0&(f|0)>(b|0))c[a+100>>2]=e+b;else c[a+100>>2]=d;return}function R1(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;e=b+104|0;f=c[e>>2]|0;if((f|0)!=0?(c[b+108>>2]|0)>=(f|0):0)g=4;else{f=Q2(b)|0;if((f|0)>=0){h=c[e>>2]|0;e=c[b+8>>2]|0;if(h){i=c[b+4>>2]|0;j=h-(c[b+108>>2]|0)|0;h=e;if((e-i|0)<(j|0)){k=h;g=9}else{c[b+100>>2]=i+(j+-1);l=h}}else{k=e;g=9}if((g|0)==9){c[b+100>>2]=e;l=k}k=b+4|0;if(!l)m=c[k>>2]|0;else{e=c[k>>2]|0;k=b+108|0;c[k>>2]=l+1-e+(c[k>>2]|0);m=e}e=m+-1|0;if((d[e>>0]|0|0)==(f|0))n=f;else{a[e>>0]=f;n=f}}else g=4}if((g|0)==4){c[b+100>>2]=0;n=-1}return n|0}function S1(a){a=a|0;var b=0;if(a>>>0>4294963200){c[(L1()|0)>>2]=0-a;b=-1}else b=a;return b|0}function T1(a,b){a=a|0;b=b|0;return 190732}function U1(a,b){a=+a;b=+b;var c=0.0,d=0.0,e=0.0,f=0.0;c=a*a;d=c*c;e=c*.5;f=1.0-e;return +(f+(1.0-f-e+(c*(c*(c*(c*2.480158728947673e-05+-.001388888888887411)+.0416666666666666)+d*d*(c*(2.087572321298175e-09-c*1.1359647557788195e-11)+-2.7557314351390663e-07))-a*b)))}function V1(a,b){a=+a;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0;d=i;i=i+48|0;e=d+16|0;f=d;h[k>>3]=a;g=c[k>>2]|0;j=c[k+4>>2]|0;l=X4(g|0,j|0,63)|0;m=j&2147483647;do if(m>>>0<1074752123)if((j&1048575|0)!=598523){n=(l|0)!=0;if(m>>>0<1073928573)if(n){o=a+1.5707963267341256;p=o+6.077100506506192e-11;h[b>>3]=p;h[b+8>>3]=o-p+6.077100506506192e-11;q=-1;break}else{p=a+-1.5707963267341256;o=p+-6.077100506506192e-11;h[b>>3]=o;h[b+8>>3]=p-o+-6.077100506506192e-11;q=1;break}else if(n){o=a+3.1415926534682512;p=o+1.2154201013012384e-10;h[b>>3]=p;h[b+8>>3]=o-p+1.2154201013012384e-10;q=-2;break}else{p=a+-3.1415926534682512;o=p+-1.2154201013012384e-10;h[b>>3]=o;h[b+8>>3]=p-o+-1.2154201013012384e-10;q=2;break}}else r=21;else{if(m>>>0>=1075594812){if(m>>>0<1094263291){r=21;break}if(m>>>0>2146435071){o=a-a;h[b+8>>3]=o;h[b>>3]=o;q=0;break}c[k>>2]=g;c[k+4>>2]=j&1048575|1096810496;o=+h[k>>3];p=+(~~o|0);h[e>>3]=p;s=(o-p)*16777216.0;p=+(~~s|0);h[e+8>>3]=p;o=(s-p)*16777216.0;h[e+16>>3]=o;if(o==0.0){n=1;while(1)if(+h[e+(n<<3)>>3]==0.0)n=n+-1|0;else{t=n;break}}else t=2;n=W1(e,f,(m>>>20)+-1046|0,t+1|0,1)|0;o=+h[f>>3];p=+h[f+8>>3];if(!l){h[b>>3]=o;h[b+8>>3]=p;q=n;break}else{h[b>>3]=-o;h[b+8>>3]=-p;q=0-n|0;break}}if(m>>>0<1075183037){if((m|0)==1074977148){r=21;break}if(!l){p=a+-4.712388980202377;o=p+-1.8231301519518578e-10;h[b>>3]=o;h[b+8>>3]=p-o+-1.8231301519518578e-10;q=3;break}else{o=a+4.712388980202377;p=o+1.8231301519518578e-10;h[b>>3]=p;h[b+8>>3]=o-p+1.8231301519518578e-10;q=-3;break}}else{if((m|0)==1075388923){r=21;break}if(!l){p=a+-6.2831853069365025;o=p+-2.430840202602477e-10;h[b>>3]=o;h[b+8>>3]=p-o+-2.430840202602477e-10;q=4;break}else{o=a+6.2831853069365025;p=o+2.430840202602477e-10;h[b>>3]=p;h[b+8>>3]=o-p+2.430840202602477e-10;q=-4;break}}}while(0);if((r|0)==21){p=a*.6366197723675814+6755399441055744.0+-6755399441055744.0;r=~~p;o=a-p*1.5707963267341256;a=p*6.077100506506192e-11;s=o-a;h[b>>3]=s;h[k>>3]=s;l=X4(c[k>>2]|0,c[k+4>>2]|0,52)|0;f=m>>>20;if((f-(l&2047)|0)>16){u=p*6.077100506303966e-11;v=o-u;w=p*2.0222662487959506e-21-(o-v-u);u=v-w;h[b>>3]=u;h[k>>3]=u;l=X4(c[k>>2]|0,c[k+4>>2]|0,52)|0;if((f-(l&2047)|0)>49){x=p*2.0222662487111665e-21;y=v-x;z=p*8.4784276603689e-32-(v-y-x);x=y-z;h[b>>3]=x;A=x;B=y;C=z}else{A=u;B=v;C=w}}else{A=s;B=o;C=a}h[b+8>>3]=B-A-C;q=r}i=d;return q|0}function W1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0,I=0,J=0,K=0,L=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0;g=i;i=i+560|0;j=g+480|0;k=g+320|0;l=g+160|0;m=g;n=c[99108+(f<<2)>>2]|0;o=e+-1|0;p=(d+-3|0)/24|0;q=(p|0)<0?0:p;p=(q*24|0)+24|0;r=d-p|0;if((n+o|0)>=0){s=n+e|0;t=0;u=q-o|0;while(1){if((u|0)<0)v=0.0;else v=+(c[99124+(u<<2)>>2]|0);h[k+(t<<3)>>3]=v;t=t+1|0;if((t|0)==(s|0))break;else u=u+1|0}}u=(e|0)>0;s=0;while(1){if(u){t=s+o|0;v=0.0;w=0;while(1){x=v+ +h[a+(w<<3)>>3]*+h[k+(t-w<<3)>>3];w=w+1|0;if((w|0)==(e|0)){y=x;break}else v=x}}else y=0.0;h[m+(s<<3)>>3]=y;if((s|0)<(n|0))s=s+1|0;else break}s=(r|0)>0;o=24-r|0;u=23-r|0;w=(e|0)>0;t=(p|0)==(d|0);d=n;a:while(1){y=+h[m+(d<<3)>>3];p=(d|0)>0;if(p){z=0;A=d;v=y;while(1){x=+(~~(v*5.9604644775390625e-08)|0);c[j+(z<<2)>>2]=~~(v-x*16777216.0);B=A;A=A+-1|0;C=x+ +h[m+(A<<3)>>3];if((B|0)<=1){D=C;break}else{z=z+1|0;v=C}}}else D=y;v=+g2(D,r);C=v-+M(+(v*.125))*8.0;z=~~C;v=C-+(z|0);do if(!s)if(!t)if(!(v>=.5)){E=0;F=z;G=v;break}else{H=2;I=z;J=20;break}else{K=c[j+(d+-1<<2)>>2]>>23;L=z;J=19;break}else{A=j+(d+-1<<2)|0;B=c[A>>2]|0;N=B>>o;O=B-(N<<o)|0;c[A>>2]=O;K=O>>u;L=N+z|0;J=19}while(0);if((J|0)==19){J=0;if((K|0)>0){H=K;I=L;J=20}else{E=K;F=L;G=v}}if((J|0)==20){J=0;z=I+1|0;if(p){N=0;O=0;while(1){A=j+(O<<2)|0;B=c[A>>2]|0;if(!N)if(!B)P=0;else{c[A>>2]=16777216-B;P=1}else{c[A>>2]=16777215-B;P=N}O=O+1|0;if((O|0)==(d|0)){Q=P;break}else N=P}}else Q=0;b:do if(s)switch(r|0){case 1:{N=j+(d+-1<<2)|0;c[N>>2]=c[N>>2]&8388607;break b;break}case 2:{N=j+(d+-1<<2)|0;c[N>>2]=c[N>>2]&4194303;break b;break}default:break b}while(0);if((H|0)==2){y=1.0-v;if(!Q){E=2;F=z;G=y}else{E=2;F=z;G=y-+g2(1.0,r)}}else{E=H;F=z;G=v}}if(!(G==0.0)){R=E;S=d;T=F;U=G;J=44;break}if((d|0)>(n|0)){N=d;O=0;while(1){N=N+-1|0;p=c[j+(N<<2)>>2]|O;if((N|0)<=(n|0)){V=p;break}else O=p}if(V){W=E;X=d;Y=F;J=37;break}else Z=1}else Z=1;while(1)if(!(c[j+(n-Z<<2)>>2]|0))Z=Z+1|0;else{_=Z;break}O=_+d|0;if((_|0)>0)$=d;else{d=O;continue}while(1){N=$+1|0;z=$+e|0;h[k+(z<<3)>>3]=+(c[99124+(N+q<<2)>>2]|0);if(w){v=0.0;p=0;while(1){y=v+ +h[a+(p<<3)>>3]*+h[k+(z-p<<3)>>3];p=p+1|0;if((p|0)==(e|0)){aa=y;break}else v=y}}else aa=0.0;h[m+(N<<3)>>3]=aa;if((N|0)<(O|0))$=N;else{d=O;continue a}}}do if((J|0)==37){d=X;$=r;while(1){e=$+-24|0;k=d+-1|0;if(!(c[j+(k<<2)>>2]|0)){d=k;$=e}else{ba=W;ca=k;da=Y;ea=e;break}}}else if((J|0)==44){aa=+g2(U,0-r|0);if(!(aa>=16777216.0)){c[j+(S<<2)>>2]=~~aa;ba=R;ca=S;da=T;ea=r;break}else{$=~~(aa*5.9604644775390625e-08);c[j+(S<<2)>>2]=~~(aa-+($|0)*16777216.0);d=S+1|0;c[j+(d<<2)>>2]=$;ba=R;ca=d;da=T;ea=r+24|0;break}}while(0);r=(ca|0)>-1;if(r){U=+g2(1.0,ea);ea=ca;while(1){h[m+(ea<<3)>>3]=U*+(c[j+(ea<<2)>>2]|0);if((ea|0)>0){U=U*5.9604644775390625e-08;ea=ea+-1|0}else break}if(r){ea=ca;while(1){j=ca-ea|0;U=0.0;T=0;while(1){aa=U+ +h[44064+(T<<3)>>3]*+h[m+(T+ea<<3)>>3];if((T|0)>=(n|0)|(T|0)>=(j|0)){fa=aa;break}else{U=aa;T=T+1|0}}h[l+(j<<3)>>3]=fa;if((ea|0)>0)ea=ea+-1|0;else break}}}c:do switch(f|0){case 0:{if(r){fa=0.0;ea=ca;while(1){U=fa+ +h[l+(ea<<3)>>3];if((ea|0)>0){fa=U;ea=ea+-1|0}else{ga=U;break}}}else ga=0.0;h[b>>3]=(ba|0)==0?ga:-ga;break}case 2:case 1:{if(r){fa=0.0;ea=ca;while(1){U=fa+ +h[l+(ea<<3)>>3];if((ea|0)>0){fa=U;ea=ea+-1|0}else{ha=U;break}}}else ha=0.0;ea=(ba|0)==0;h[b>>3]=ea?ha:-ha;fa=+h[l>>3]-ha;if((ca|0)<1)ia=fa;else{U=fa;j=1;while(1){fa=U+ +h[l+(j<<3)>>3];if((j|0)==(ca|0)){ia=fa;break}else{U=fa;j=j+1|0}}}h[b+8>>3]=ea?ia:-ia;break}case 3:{if((ca|0)>0){U=+h[l+(ca<<3)>>3];j=ca;do{n=j;j=j+-1|0;m=l+(j<<3)|0;fa=+h[m>>3];aa=U;U=fa+U;h[l+(n<<3)>>3]=aa+(fa-U);h[m>>3]=U}while((n|0)>1);j=(ca|0)>1;if(j){U=+h[l+(ca<<3)>>3];ea=ca;do{n=ea;ea=ea+-1|0;m=l+(ea<<3)|0;fa=+h[m>>3];aa=U;U=fa+U;h[l+(n<<3)>>3]=aa+(fa-U);h[m>>3]=U}while((ea|0)>1);if(j){U=0.0;ea=ca;while(1){fa=U+ +h[l+(ea<<3)>>3];ea=ea+-1|0;if((ea|0)<=1){ja=fa;break}else U=fa}}else ja=0.0}else ja=0.0}else ja=0.0;U=+h[l>>3];fa=+h[l+8>>3];if(!ba){h[b>>3]=U;h[b+8>>3]=fa;h[b+16>>3]=ja;break c}else{h[b>>3]=-U;h[b+8>>3]=-fa;h[b+16>>3]=-ja;break c}break}default:{}}while(0);i=g;return da&7|0}function X1(a,b,c){a=+a;b=+b;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0;d=a*a;e=d*(d*d)*(d*1.58969099521155e-10+-2.5050760253406863e-08)+(d*(d*2.7557313707070068e-06+-1.984126982985795e-04)+.00833333333332249);f=d*a;if(!c)g=f*(d*e+-.16666666666666632)+a;else g=a-(f*.16666666666666632+(d*(b*.5-f*e)-b));return +g}function Y1(a){a=+a;var b=0,d=0,e=0,f=0.0,g=0,i=0,j=0,l=0,m=0,n=0.0,o=0.0;h[k>>3]=a;b=c[k>>2]|0;d=c[k+4>>2]|0;e=d&2147483647;do if(e>>>0>2146435071)f=a+a;else{if(e>>>0<1048576){h[k>>3]=a*18014398509481984.0;g=c[k+4>>2]|0;i=g&2147483647;if(!i){f=a;break}j=g;l=c[k>>2]|0;m=((i>>>0)/3|0)+696219795|0}else{j=d;l=b;m=((e>>>0)/3|0)+715094163|0}c[k>>2]=0;c[k+4>>2]=m|j&-2147483648;n=+h[k>>3];o=n*n*(n/a);h[k>>3]=n*(o*(o*o)*(o*.14599619288661245+-.758397934778766)+(o*(o*1.6214297201053545+-1.8849797954337717)+1.87595182427177));i=V4(c[k>>2]|0,c[k+4>>2]|0,-2147483648,0)|0;g=C;c[k>>2]=i&-1073741824;c[k+4>>2]=g;o=+h[k>>3];n=a/(o*o);f=o+o*((n-o)/(o+o+n))}while(0);return +f}function Z1(a,b){a=+a;b=+b;var d=0,e=0;h[k>>3]=b;d=c[k+4>>2]|0;b=+N(+a);h[k>>3]=b;e=d&-2147483648|c[k+4>>2];c[k>>2]=c[k>>2];c[k+4>>2]=e;return +(+h[k>>3])}function _1(a,b){a=+a;b=+b;return +(+Z1(a,b))}function $1(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;h[k>>3]=a;d=c[k>>2]|0;e=c[k+4>>2]|0;h[k>>3]=b;f=c[k>>2]|0;g=c[k+4>>2]|0;i=X4(d|0,e|0,52)|0;j=i&2047;i=X4(f|0,g|0,52)|0;l=i&2047;i=e&-2147483648;m=a5(f|0,g|0,1)|0;n=C;a:do if(!((m|0)==0&(n|0)==0)?(o=+N(+b),h[k>>3]=o,p=c[k+4>>2]|0,!(p>>>0>2146435072|(p|0)==2146435072&(c[k>>2]|0)>>>0>0|(j|0)==2047)):0){p=a5(d|0,e|0,1)|0;q=C;if(!(q>>>0>n>>>0|(q|0)==(n|0)&p>>>0>m>>>0))return +((p|0)==(m|0)&(q|0)==(n|0)?a*0.0:a);if(!j){q=a5(d|0,e|0,12)|0;p=C;if((p|0)>-1|(p|0)==-1&q>>>0>4294967295){r=q;q=p;p=0;while(1){s=p+-1|0;r=a5(r|0,q|0,1)|0;q=C;if(!((q|0)>-1|(q|0)==-1&r>>>0>4294967295)){t=s;break}else p=s}}else t=0;p=a5(d|0,e|0,1-t|0)|0;u=p;v=C;w=t}else{u=d;v=e&1048575|1048576;w=j}if(!l){p=a5(f|0,g|0,12)|0;r=C;if((r|0)>-1|(r|0)==-1&p>>>0>4294967295){q=p;p=r;r=0;while(1){s=r+-1|0;q=a5(q|0,p|0,1)|0;p=C;if(!((p|0)>-1|(p|0)==-1&q>>>0>4294967295)){x=s;break}else r=s}}else x=0;r=a5(f|0,g|0,1-x|0)|0;y=r;z=C;A=x}else{y=f;z=g&1048575|1048576;A=l}r=U4(u|0,v|0,y|0,z|0)|0;q=C;p=(q|0)>-1|(q|0)==-1&r>>>0>4294967295;b:do if((w|0)>(A|0)){s=p;B=r;D=q;E=u;F=v;G=w;while(1){if(s)if((E|0)==(y|0)&(F|0)==(z|0))break;else{H=B;I=D}else{H=E;I=F}J=a5(H|0,I|0,1)|0;K=C;L=G+-1|0;M=U4(J|0,K|0,y|0,z|0)|0;O=C;P=(O|0)>-1|(O|0)==-1&M>>>0>4294967295;if((L|0)>(A|0)){s=P;B=M;D=O;E=J;F=K;G=L}else{Q=P;R=J;S=K;T=M;U=O;V=L;break b}}W=a*0.0;break a}else{Q=p;R=u;S=v;T=r;U=q;V=w}while(0);if(Q)if((R|0)==(y|0)&(S|0)==(z|0)){W=a*0.0;break}else{X=U;Y=T}else{X=S;Y=R}if(X>>>0<1048576|(X|0)==1048576&Y>>>0<0){q=Y;r=X;p=V;while(1){G=a5(q|0,r|0,1)|0;F=C;E=p+-1|0;if(F>>>0<1048576|(F|0)==1048576&G>>>0<0){q=G;r=F;p=E}else{Z=G;_=F;$=E;break}}}else{Z=Y;_=X;$=V}if(($|0)>0){p=V4(Z|0,_|0,0,-1048576)|0;r=C;q=a5($|0,0,52)|0;aa=r|C;ba=p|q}else{q=X4(Z|0,_|0,1-$|0)|0;aa=C;ba=q}c[k>>2]=ba;c[k+4>>2]=aa|i;W=+h[k>>3]}else ca=3;while(0);if((ca|0)==3){o=a*b;W=o/o}return +W}function a2(a,b){a=+a;b=+b;return +(+$1(a,b))}function b2(a,b){a=+a;b=b|0;var d=0,e=0,f=0,g=0,i=0.0,j=0.0,l=0,m=0.0;h[k>>3]=a;d=c[k>>2]|0;e=c[k+4>>2]|0;f=X4(d|0,e|0,52)|0;g=f&2047;switch(g|0){case 0:{if(a!=0.0){i=+b2(a*18446744073709551616.0,b);j=i;l=(c[b>>2]|0)+-64|0}else{j=a;l=0}c[b>>2]=l;m=j;break}case 2047:{m=a;break}default:{c[b>>2]=g+-1022;c[k>>2]=d;c[k+4>>2]=e&-2146435073|1071644672;m=+h[k>>3]}}return +m}function c2(a,b){a=+a;b=b|0;return +(+b2(a,b))}function d2(a,b){a=+a;b=+b;var d=0.0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0;d=+N(+a);h[k>>3]=d;e=c[k>>2]|0;f=c[k+4>>2]|0;d=+N(+b);h[k>>3]=d;g=c[k>>2]|0;i=c[k+4>>2]|0;j=f>>>0<i>>>0|(f|0)==(i|0)&e>>>0<g>>>0;l=j?g:e;m=j?i:f;n=j?e:g;g=j?f:i;i=X4(l|0,m|0,52)|0;f=X4(n|0,g|0,52)|0;c[k>>2]=l;c[k+4>>2]=m;d=+h[k>>3];c[k>>2]=n;c[k+4>>2]=g;b=+h[k>>3];do if((f|0)!=2047)if((n|0)==0&(g|0)==0|(i|0)==2047)o=d;else{if((i-f|0)>64){o=d+b;break}if(i>>>0<=1533)if(f>>>0<573){p=d*5260135901548373507240989.0e186;q=b*5260135901548373507240989.0e186;r=1.90109156629516e-211}else{p=d;q=b;r=1.0}else{p=d*1.90109156629516e-211;q=b*1.90109156629516e-211;r=5260135901548373507240989.0e186}a=p*134217729.0;s=a+(p-a);a=p-s;t=p*p;u=q*134217729.0;v=u+(q-u);u=q-v;w=q*q;o=r*+O(+(t+(w+(u*u+(v*v-w+v*2.0*u)+(a*a+(s*s-t+s*2.0*a))))))}else o=b;while(0);return +o}function e2(a){a=+a;var b=0,d=0,e=0,f=0.0,g=0.0,i=0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;h[k>>3]=a;b=c[k>>2]|0;d=c[k+4>>2]|0;e=(d|0)<0;do if(e|d>>>0<1048576){f=+N(+a);h[k>>3]=f;if((c[k>>2]|0)==0&(c[k+4>>2]|0)==0){g=-1.0/(a*a);break}if(e){g=(a-a)/0.0;break}else{h[k>>3]=a*18014398509481984.0;i=c[k+4>>2]|0;j=c[k>>2]|0;l=i;m=i;n=-1077;o=9;break}}else if(d>>>0<=2146435071)if((b|0)==0&0==0&(d|0)==1072693248)g=0.0;else{j=b;l=d;m=d;n=-1023;o=9}else g=a;while(0);if((o|0)==9){o=m+614242|0;c[k>>2]=j;c[k+4>>2]=(o&1048575)+1072079006;a=+h[k>>3]+-1.0;f=a*(a*.5);p=a/(a+2.0);q=p*p;r=q*q;h[k>>3]=a-f;j=c[k+4>>2]|0;c[k>>2]=0;c[k+4>>2]=j;s=+h[k>>3];t=a-s-f+p*(f+(r*(r*(r*.15313837699209373+.22222198432149784)+.3999999999940942)+q*(r*(r*(r*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)));r=s*.4342944818781689;q=+(n+(o>>>20)|0);f=q*.30102999566361177;p=f+r;g=p+(r+(f-p)+(t*.4342944818781689+(q*3.694239077158931e-13+(s+t)*2.5082946711645275e-11)))}return +g}function f2(a){a=+a;var b=0,d=0,e=0,f=0.0,g=0.0,i=0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;h[k>>3]=a;b=c[k>>2]|0;d=c[k+4>>2]|0;e=(d|0)<0;do if(e|d>>>0<1048576){f=+N(+a);h[k>>3]=f;if((c[k>>2]|0)==0&(c[k+4>>2]|0)==0){g=-1.0/(a*a);break}if(e){g=(a-a)/0.0;break}else{h[k>>3]=a*18014398509481984.0;i=c[k+4>>2]|0;j=c[k>>2]|0;l=i;m=i;n=-1077;o=9;break}}else if(d>>>0<=2146435071)if((b|0)==0&0==0&(d|0)==1072693248)g=0.0;else{j=b;l=d;m=d;n=-1023;o=9}else g=a;while(0);if((o|0)==9){o=m+614242|0;c[k>>2]=j;c[k+4>>2]=(o&1048575)+1072079006;a=+h[k>>3]+-1.0;f=a*(a*.5);p=a/(a+2.0);q=p*p;r=q*q;h[k>>3]=a-f;j=c[k+4>>2]|0;c[k>>2]=0;c[k+4>>2]=j;s=+h[k>>3];t=a-s-f+p*(f+(r*(r*(r*.15313837699209373+.22222198432149784)+.3999999999940942)+q*(r*(r*(r*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)));r=s*1.4426950407214463;q=+(n+(o>>>20)|0);f=q+r;g=f+(r+(q-f)+(t*1.4426950407214463+(s+t)*1.6751713164886512e-10))}return +g}function g2(a,b){a=+a;b=b|0;var d=0.0,e=0,f=0,g=0,i=0.0;if((b|0)>1023){d=a*8988465674311579538646525.0e283;e=b+-1023|0;if((e|0)>1023){f=b+-2046|0;g=(f|0)>1023?1023:f;i=d*8988465674311579538646525.0e283}else{g=e;i=d}}else if((b|0)<-1022){d=a*2.2250738585072014e-308;e=b+1022|0;if((e|0)<-1022){f=b+2044|0;g=(f|0)<-1022?-1022:f;i=d*2.2250738585072014e-308}else{g=e;i=d}}else{g=b;i=a}b=a5(g+1023|0,0,52)|0;g=C;c[k>>2]=b;c[k+4>>2]=g;return +(i*+h[k>>3])}function h2(a,b){a=+a;b=b|0;return +(+g2(a,b))}function i2(a,b,d){a=+a;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,l=0,m=0,n=0.0;e=i;i=i+16|0;f=e;h[k>>3]=a;g=c[k+4>>2]&2147483647;a:do if(g>>>0<1072243196)if(g>>>0<1044816030){h[b>>3]=a;h[d>>3]=1.0;break}else{h[b>>3]=+X1(a,0.0,0);h[d>>3]=+U1(a,0.0);break}else{if(g>>>0>2146435071){j=a-a;h[d>>3]=j;h[b>>3]=j;break}l=V1(a,f)|0;m=f+8|0;j=+X1(+h[f>>3],+h[m>>3],1);n=+U1(+h[f>>3],+h[m>>3]);switch(l&3|0){case 0:{h[b>>3]=j;h[d>>3]=n;break a;break}case 1:{h[b>>3]=n;h[d>>3]=-j;break a;break}case 2:{h[b>>3]=-j;h[d>>3]=-n;break a;break}case 3:{h[b>>3]=-n;h[d>>3]=j;break a;break}default:{}}}while(0);i=e;return}function j2(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+32|0;j=h;do if((g&4095|0)==0&(((g|0)<0)<<31>>31&-4096|0)==0){if(b>>>0>2147483646){c[(L1()|0)>>2]=12;k=-1;break}l=(e&16|0)!=0;if(l)A4(-1);c[j>>2]=a;c[j+4>>2]=b;c[j+8>>2]=d;c[j+12>>2]=e;c[j+16>>2]=f;c[j+20>>2]=g>>12;m=S1(Ua(192,j|0)|0)|0;if(l){B4();k=m}else k=m}else{c[(L1()|0)>>2]=22;k=-1}while(0);i=h;return k|0}function k2(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;A4(-1);c[e>>2]=a;c[e+4>>2]=b;b=S1($a(91,e|0)|0)|0;B4();i=d;return b|0}function l2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+16|0;h=g;j=(f|0)==0?99388:f;f=c[j>>2]|0;a:do if(!d)if(!f)k=0;else l=15;else{m=(b|0)==0?h:b;if(!e)k=-2;else{if(!f){n=a[d>>0]|0;o=n&255;if(n<<24>>24>-1){c[m>>2]=o;k=n<<24>>24!=0&1;break}n=o+-194|0;if(n>>>0>50){l=15;break}o=c[98764+(n<<2)>>2]|0;n=e+-1|0;if(!n)p=o;else{q=n;r=o;s=d+1|0;l=9}}else{q=e;r=f;s=d;l=9}b:do if((l|0)==9){o=a[s>>0]|0;n=(o&255)>>>3;if((n+-16|n+(r>>26))>>>0>7){l=15;break a}else{t=q;u=o;v=r;w=s}while(1){w=w+1|0;v=(u&255)+-128|v<<6;t=t+-1|0;if((v|0)>=0){x=v;y=t;break}if(!t){p=v;break b}u=a[w>>0]|0;if((u&-64)<<24>>24!=-128){l=15;break a}}c[j>>2]=0;c[m>>2]=x;k=e-y|0;break a}while(0);c[j>>2]=p;k=-2}}while(0);if((l|0)==15){c[j>>2]=0;c[(L1()|0)>>2]=84;k=-1}i=g;return k|0}function m2(a){a=a|0;var b=0;if(!a)b=1;else b=(c[a>>2]|0)==0;return b&1|0}function n2(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+16|0;h=g;a:do if(!e)j=0;else{do if(f){k=(b|0)==0?h:b;l=a[e>>0]|0;m=l&255;if(l<<24>>24>-1){c[k>>2]=m;j=l<<24>>24!=0&1;break a}l=m+-194|0;if(l>>>0<=50){m=e+1|0;n=c[98764+(l<<2)>>2]|0;if(f>>>0<4?(n&-2147483648>>>((f*6|0)+-6|0)|0)!=0:0)break;l=d[m>>0]|0;m=l>>>3;if((m+-16|m+(n>>26))>>>0<=7){m=l+-128|n<<6;if((m|0)>=0){c[k>>2]=m;j=2;break a}n=d[e+2>>0]|0;if((n&192|0)==128){l=n+-128|m<<6;if((l|0)>=0){c[k>>2]=l;j=3;break a}m=d[e+3>>0]|0;if((m&192|0)==128){c[k>>2]=m+-128|l<<6;j=4;break a}}}}}while(0);c[(L1()|0)>>2]=84;j=-1}while(0);i=g;return j|0}function o2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;do if(b){if(d>>>0<128){a[b>>0]=d;f=1;break}if(d>>>0<2048){a[b>>0]=d>>>6|192;a[b+1>>0]=d&63|128;f=2;break}if(d>>>0<55296|(d&-8192|0)==57344){a[b>>0]=d>>>12|224;a[b+1>>0]=d>>>6&63|128;a[b+2>>0]=d&63|128;f=3;break}if((d+-65536|0)>>>0<1048576){a[b>>0]=d>>>18|240;a[b+1>>0]=d>>>12&63|128;a[b+2>>0]=d>>>6&63|128;a[b+3>>0]=d&63|128;f=4;break}else{c[(L1()|0)>>2]=84;f=-1;break}}else f=1;while(0);return f|0}function p2(a,b){a=a|0;b=b|0;var c=0;if(!a)c=0;else c=o2(a,b,0)|0;return c|0}function q2(a,c){a=a|0;c=c|0;var d=0,f=0,g=0,h=0;d=a+2|0;f=a+4|0;g=g5((e[c+2>>1]|0)<<16|(e[c>>1]|0)|0,e[c+4>>1]|0|0,(e[d>>1]|0)<<16|(e[a>>1]|0)|0,e[f>>1]|0|0)|0;h=V4(g|0,C|0,e[c+6>>1]|0|0,0)|0;c=C;b[a>>1]=h;a=X4(h|0,c|0,16)|0;b[d>>1]=a;b[f>>1]=c;C=c&65535;return h|0}function r2(){var a=0,b=0;a=q2(104016,104022)|0;b=a5(a|0,C|0,4)|0;a=C|1072693248;c[k>>2]=b;c[k+4>>2]=a;return +(+h[k>>3]+-1.0)}function s2(a){a=a|0;var b=0;b=44128;c[b>>2]=a+-1;c[b+4>>2]=0;return}function t2(){var a=0,b=0,d=0;a=44128;b=g5(c[a>>2]|0,c[a+4>>2]|0,1284865837,1481765933)|0;a=V4(b|0,C|0,1,0)|0;b=C;d=44128;c[d>>2]=a;c[d+4>>2]=b;d=X4(a|0,b|0,33)|0;return d|0}function u2(a){a=a|0;b[52015]=b[52008]|0;b[52016]=b[52009]|0;b[52017]=b[52010]|0;b[52008]=b[a>>1]|0;b[52009]=b[a+2>>1]|0;b[52010]=b[a+4>>1]|0;return 104030}function v2(a){a=a|0;var c=0,d=0;c=i;i=i+16|0;d=c;b[d>>1]=13070;b[d+2>>1]=a;b[d+4>>1]=a>>>16;u2(d)|0;i=c;return}function w2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e+48|0;j=e+44|0;k=e;l=N4(20)|0;a:do if(!l)m=12;else{n=N4(2048)|0;o=l+16|0;c[o>>2]=n;if(!n){O4(l);m=12;break}c[l>>2]=512;c[l+4>>2]=10240;c[l+8>>2]=128;n=l+12|0;c[n>>2]=0;p=z2(0,0)|0;if(!p){O4(c[o>>2]|0);O4(l);m=12;break}q=k;r=q+44|0;do{c[q>>2]=0;q=q+4|0}while((q|0)<(r|0));c[k>>2]=p;c[k+4>>2]=l;c[k+12>>2]=b;c[k+36>>2]=d;q=k+28|0;c[q>>2]=-1;r=b4(k)|0;b:do if(!r){s=k+20|0;t=c[s>>2]|0;c[a>>2]=t+-1;u=c[k+8>>2]|0;v=c[q>>2]|0;if((v|0)>-1?(c[k+32>>2]|0)!=0:0){w=0;x=2;y=0;z=0;break}if((v|0)<(t|0)){A=P4(1,68)|0;if(!A){w=0;x=12;y=0;z=A}else{B=v>>>31;c[A+60>>2]=B^1;c[A+64>>2]=c[k+32>>2];c[A+28>>2]=t;if((d&8|0)==0|(B|0)!=1){B=c4(0,l,u,A)|0;if(B){w=0;x=B;y=0;z=A;break}B=c[A+40>>2]|0;if((B|0)>0){t=(B<<2)+4|0;v=N4(t)|0;if(!v){w=0;x=12;y=0;z=A;break}c[A+32>>2]=v;$4(v|0,-1,t|0)|0;C=v}else C=0;v=P4(B<<1|1,4)|0;c[A+36>>2]=v;if(!v){w=0;x=12;y=0;z=A;break}v=P4(c[s>>2]|0,12)|0;if(!v){w=0;x=12;y=0;z=A;break}c[A+16>>2]=v;v=c4(p,l,u,A)|0;if(!v)D=C;else{w=0;x=v;y=0;z=A;break}}else D=0;v=k+24|0;s=c[n>>2]|0;c[h>>2]=0;c[j>>2]=0;c[g>>2]=u;c[f>>2]=c[g>>2];B=d4(l,f)|0;c:do if(!B){c[g>>2]=0;c[f>>2]=c[g>>2];t=d4(l,f)|0;if(!t){E=c[n>>2]|0;do if((E|0)>(s|0)){F=E;G=0;H=0;I=0;d:while(1){J=F+-1|0;c[n>>2]=J;K=c[o>>2]|0;L=c[K+(J<<2)>>2]|0;J=F+-2|0;c[n>>2]=J;M=c[K+(J<<2)>>2]|0;e:do switch(L|0){case 0:{switch(c[M>>2]|0){case 0:{J=c[M+4>>2]|0;N=c[J>>2]|0;if(!((N|0)>-1|(N|0)==-4)){O=G;P=H;Q=I;break e}N=J+8|0;J=(c[N>>2]|0)+G|0;c[N>>2]=J;if((J|0)<=(c[j>>2]|0)){O=G;P=H;Q=I;break e}c[j>>2]=J;O=G;P=H;Q=I;break e;break}case 3:{J=c[M+4>>2]|0;c[g>>2]=c[J+4>>2];c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}c[g>>2]=0;c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}c[g>>2]=c[J>>2];c[f>>2]=c[g>>2];J=d4(l,f)|0;if(J){R=I;S=J;T=81;break d}c[g>>2]=0;c[f>>2]=c[g>>2];U=d4(l,f)|0;break}case 1:{J=c[M+4>>2]|0;c[g>>2]=c[J+4>>2];c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}c[g>>2]=0;c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}c[g>>2]=c[J>>2];c[f>>2]=c[g>>2];J=d4(l,f)|0;if(J){R=I;S=J;T=81;break d}c[g>>2]=0;c[f>>2]=c[g>>2];U=d4(l,f)|0;break}case 2:{J=c[M+4>>2]|0;c[g>>2]=G;c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}c[g>>2]=M;c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}c[g>>2]=1;c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}c[g>>2]=c[J>>2];c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}c[g>>2]=0;c[f>>2]=c[g>>2];N=d4(l,f)|0;if(N){R=I;S=N;T=81;break d}if((c[J+4>>2]|0)<=1?(c[J+8>>2]|0)<=1:0)V=G;else{c[h>>2]=0;V=0}O=V;P=H+1|0;Q=I;break e;break}default:{O=G;P=H;Q=I;break e}}if(!U){O=G;P=H;Q=I}else{R=I;S=U;T=81;break d}break}case 1:{J=M+4|0;N=c[J>>2]|0;W=F+-3|0;c[n>>2]=W;X=c[K+(W<<2)>>2]|0;c[h>>2]=X;W=N+4|0;Y=c[W>>2]|0;Z=(Y|0)>1;if(!Z){_=N+8|0;$=c[_>>2]|0;if(($|0)>1){c[f>>2]=0;if((Y|0)>0)T=50;else{aa=Y;ba=_;ca=$;da=X;ea=0;T=58}}else fa=X}else{c[f>>2]=0;T=50}do if((T|0)==50){T=0;$=e4(p,l,c[N>>2]|0,Z?1:2,h,D,g,j)|0;if(!$){ga=1;ha=X;ia=0}else{ja=$;T=54;break d}while(1){$=c[g>>2]|0;if(!ia)ka=$;else ka=f4(p,ia,$)|0;if(!ka){ja=12;T=54;break d}$=c[W>>2]|0;if((ga|0)>=($|0)){la=ha;ma=$;na=ka;break}ha=c[h>>2]|0;ga=ga+1|0;_=e4(p,l,c[N>>2]|0,(ga|0)<($|0)?1:2,h,D,g,j)|0;if(_){ja=_;T=54;break d}else ia=ka}_=N+8|0;$=c[_>>2]|0;if(($|0)!=-1){aa=ma;ba=_;ca=$;da=la;ea=na;T=58;break}$=c[h>>2]|0;_=e4(p,l,c[N>>2]|0,0,h,0,f,j)|0;if(_){oa=_;break d}_=g4(p,c[f>>2]|0,0,-1,0)|0;c[f>>2]=_;if(!_){oa=12;break d}c[h>>2]=$;pa=_;qa=$;ra=na;T=74}while(0);do if((T|0)==58){T=0;if((aa|0)<(ca|0)){W=0;Z=aa;while(1){$=c[h>>2]|0;_=e4(p,l,c[N>>2]|0,0,h,0,g,j)|0;if(_){sa=_;T=70;break d}if(!W){_=c[g>>2]|0;c[f>>2]=_;ta=_}else{_=f4(p,c[g>>2]|0,W)|0;c[f>>2]=_;ta=_}if(!ta){sa=12;T=70;break d}_=h4(p,0,20)|0;if(!_){sa=12;T=70;break d}Y=c[_+4>>2]|0;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;Y=i4(p,_,ta)|0;c[f>>2]=Y;if(!Y){sa=12;T=70;break d}Z=Z+1|0;if((Z|0)>=(c[ba>>2]|0)){ua=Y;va=$;break}else W=Y}}else{ua=0;va=da}c[h>>2]=va;if(!ea){wa=va;xa=ua;T=75;break}if(!ua){ya=va;za=ea;T=76}else{pa=ua;qa=va;ra=ea;T=74}}while(0);if((T|0)==74){T=0;wa=qa;xa=f4(p,ra,pa)|0;T=75}if((T|0)==75){T=0;if(!xa){oa=12;break d}else{ya=wa;za=xa;T=76}}if((T|0)==76){T=0;c[J>>2]=c[za+4>>2];c[M>>2]=c[za>>2];fa=ya}N=H+-1|0;W=fa-X+I|0;if(!N){c[h>>2]=W;O=W;P=0;Q=W}else{O=fa;P=N;Q=W}break}default:{O=G;P=H;Q=I}}while(0);F=c[n>>2]|0;if((F|0)<=(s|0)){R=Q;S=0;T=81;break}else{G=O;H=P;I=Q}}if((T|0)==54)oa=ja;else if((T|0)==70)oa=sa;else if((T|0)==81){Aa=c[j>>2]|0;Ba=R;Ca=S;break}Da=oa;break c}else{Aa=0;Ba=0;Ca=0}while(0);E=(c[v>>2]|0)+Ba|0;I=(Aa|0)>(E|0)?Aa:E;c[v>>2]=I;if(Ca){w=0;x=Ca;y=0;z=A;break b}c[v>>2]=I+1;E=h4(p,0,20)|0;if(!E){w=0;x=12;y=0;z=A;break b}H=c[E+4>>2]|0;c[H>>2]=0;c[H+4>>2]=0;c[H+8>>2]=I;I=f4(p,u,E)|0;if(!I){w=0;x=12;y=0;z=A;break b}E=c[n>>2]|0;c[g>>2]=I;c[f>>2]=c[g>>2];H=d4(l,f)|0;if(H){w=0;x=H;y=0;z=A;break b}c[g>>2]=0;c[f>>2]=c[g>>2];H=d4(l,f)|0;if(H){w=0;x=H;y=0;z=A;break b}H=c[n>>2]|0;f:do if((H|0)>(E|0)){G=H;g:while(1){F=G+-1|0;c[n>>2]=F;M=c[o>>2]|0;K=c[M+(F<<2)>>2]|0;F=G+-2|0;c[n>>2]=F;L=c[M+(F<<2)>>2]|0;h:do switch(K|0){case 0:{switch(c[L>>2]|0){case 0:{F=c[L+4>>2]|0;M=c[F>>2]|0;if((M|0)==-4){c[L+8>>2]=0;W=F+8|0;N=j4(p,c[W>>2]|0,0,1114111,0,0,-1)|0;c[L+24>>2]=N;if(!N){w=0;x=12;y=0;z=A;break b}N=j4(p,c[W>>2]|0,0,1114111,0,0,c[F+4>>2]|0)|0;c[L+28>>2]=N;if(!N){w=0;x=12;y=0;z=A;break b}else break h}N=L+8|0;if((M|0)<0){c[N>>2]=1;W=k4(p)|0;c[L+24>>2]=W;if(!W){w=0;x=12;y=0;z=A;break b}W=k4(p)|0;c[L+28>>2]=W;if(!W){w=0;x=12;y=0;z=A;break b}else break h}else{c[N>>2]=0;N=F+8|0;W=F+4|0;Z=j4(p,c[N>>2]|0,M,c[W>>2]|0,0,0,-1)|0;c[L+24>>2]=Z;if(!Z){w=0;x=12;y=0;z=A;break b}Z=j4(p,c[N>>2]|0,c[F>>2]|0,c[W>>2]|0,c[F+12>>2]|0,c[F+16>>2]|0,-1)|0;c[L+28>>2]=Z;if(!Z){w=0;x=12;y=0;z=A;break b}else break h}break}case 3:{c[g>>2]=L;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}c[g>>2]=1;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}Z=L+4|0;c[g>>2]=c[(c[Z>>2]|0)+4>>2];c[f>>2]=c[g>>2];F=d4(l,f)|0;if(F){w=0;x=F;y=0;z=A;break b}c[g>>2]=0;c[f>>2]=c[g>>2];F=d4(l,f)|0;if(F){w=0;x=F;y=0;z=A;break b}c[g>>2]=c[c[Z>>2]>>2];c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}c[g>>2]=0;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(!Z)break h;else{w=0;x=Z;y=0;z=A;break b}break}case 1:{c[g>>2]=L;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}c[g>>2]=2;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}Z=L+4|0;c[g>>2]=c[(c[Z>>2]|0)+4>>2];c[f>>2]=c[g>>2];F=d4(l,f)|0;if(F){w=0;x=F;y=0;z=A;break b}c[g>>2]=0;c[f>>2]=c[g>>2];F=d4(l,f)|0;if(F){w=0;x=F;y=0;z=A;break b}c[g>>2]=c[c[Z>>2]>>2];c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}c[g>>2]=0;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(!Z)break h;else{w=0;x=Z;y=0;z=A;break b}break}case 2:{c[g>>2]=L;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}c[g>>2]=3;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}c[g>>2]=c[c[L+4>>2]>>2];c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(Z){w=0;x=Z;y=0;z=A;break b}c[g>>2]=0;c[f>>2]=c[g>>2];Z=d4(l,f)|0;if(!Z)break h;else{w=0;x=Z;y=0;z=A;break b}break}default:break h}break}case 1:{Z=c[L+4>>2]|0;F=c[Z>>2]|0;W=Z+4|0;N=c[W>>2]|0;if(!(c[F+8>>2]|0))Ea=(c[N+8>>2]|0)!=0;else Ea=1;c[L+8>>2]=Ea&1;M=l4(p,c[F+24>>2]|0,c[N+24>>2]|0,0,0)|0;c[L+24>>2]=M;if(!M){w=0;x=12;y=0;z=A;break b}M=l4(p,c[(c[Z>>2]|0)+28>>2]|0,c[(c[W>>2]|0)+28>>2]|0,0,0)|0;c[L+28>>2]=M;if(!M){w=0;x=12;y=0;z=A;break b}break}case 3:{M=c[L+4>>2]|0;W=c[M>>2]|0;do if(!(c[M+4>>2]|0))T=121;else{if(c[W+8>>2]|0){T=121;break}c[L+8>>2]=0}while(0);if((T|0)==121){T=0;c[L+8>>2]=1}c[L+24>>2]=c[W+24>>2];c[L+28>>2]=c[W+28>>2];break}case 2:{M=c[L+4>>2]|0;X=c[M>>2]|0;J=X+8|0;if(!(c[J>>2]|0))Fa=0;else Fa=(c[(c[M+4>>2]|0)+8>>2]|0)!=0;c[L+8>>2]=Fa&1;if(c[J>>2]|0){J=m4(l,X,0,0,f)|0;if(J){Ga=J;break g}J=N4((c[f>>2]<<2)+4|0)|0;if(!J){Ga=12;break g}c[J>>2]=-1;c[g>>2]=0;Z=m4(l,c[M>>2]|0,J,g,0)|0;if(Z){Ha=J;Ia=Z;T=131;break g}Z=M+4|0;N=L+24|0;c[N>>2]=l4(p,c[(c[Z>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,J,c[g>>2]|0)|0;O4(J);if(!(c[N>>2]|0)){Ga=12;break g}else Ja=Z}else{c[L+24>>2]=c[X+24>>2];Ja=M+4|0}X=c[Ja>>2]|0;if(c[X+8>>2]|0){Z=m4(l,X,0,0,f)|0;if(Z){Ga=Z;break g}Z=N4((c[f>>2]<<2)+4|0)|0;if(!Z){Ga=12;break g}c[Z>>2]=-1;c[g>>2]=0;N=m4(l,c[Ja>>2]|0,Z,g,0)|0;if(N){Ka=Z;La=N;T=138;break g}N=L+28|0;c[N>>2]=l4(p,c[(c[M>>2]|0)+28>>2]|0,c[(c[Ja>>2]|0)+28>>2]|0,Z,c[g>>2]|0)|0;O4(Z);if(!(c[N>>2]|0)){Ga=12;break g}}else c[L+28>>2]=c[X+28>>2];break}default:{}}while(0);G=c[n>>2]|0;if((G|0)<=(E|0))break f}if((T|0)==131){O4(Ha);Ga=Ia}else if((T|0)==138){O4(Ka);Ga=La}w=0;x=Ga;y=0;z=A;break b}while(0);E=c[v>>2]|0;H=E<<2;G=N4(H)|0;if(!G){w=G;x=12;y=0;z=A;break b}L=N4(H)|0;if(!L){w=G;x=12;y=L;z=A;break b}if((E|0)>0)$4(G|0,0,((E|0)>1?E:1)<<2|0)|0;n4(I,0,G,0)|0;E=c[v>>2]|0;if((E|0)>0){H=0;K=0;while(1){c[L+(K<<2)>>2]=H;X=G+(K<<2)|0;N=H+1+(c[X>>2]|0)|0;c[X>>2]=0;K=K+1|0;if((K|0)>=(E|0)){Ma=N;break}else H=N}}else Ma=0;H=P4(Ma+1|0,32)|0;if(!H){w=G;x=12;y=L;z=A;break b}c[A>>2]=H;E=A+4|0;c[E>>2]=Ma;K=n4(I,H,G,L)|0;if(K){w=G;x=K;y=L;z=A;break b}c[A+20>>2]=0;K=I+24|0;N=0;X=c[K>>2]|0;while(1){Z=N+1|0;if((c[X>>2]|0)>-1){N=Z;X=X+32|0}else{Na=Z;break}}X=P4(Na,32)|0;if(!X){w=G;x=12;y=L;z=A;break b}c[A+8>>2]=X;N=c[K>>2]|0;Z=c[N>>2]|0;if((Z|0)>-1){M=Z;Z=N;N=0;while(1){c[X+(N<<5)+8>>2]=H+(c[L+(M<<2)>>2]<<5);c[X+(N<<5)+12>>2]=M;J=X+(N<<5)+16|0;c[J>>2]=0;F=Z+12|0;Y=c[F>>2]|0;if(Y){$=0;while(1){_=$+1|0;if((c[Y+($<<2)>>2]|0)>-1)$=_;else{Oa=_;break}}$=Oa<<2;Y=N4($)|0;c[J>>2]=Y;if(!Y){w=G;x=12;y=L;z=A;break b}Z4(Y|0,c[F>>2]|0,$|0)|0}c[X+(N<<5)+20>>2]=c[Z+16>>2];$=N+1|0;Z=Z+32|0;M=c[Z>>2]|0;if((M|0)<=-1){Pa=$;break}else N=$}}else Pa=0;c[X+(Pa<<5)+8>>2]=0;c[E>>2]=Ma;c[A+12>>2]=H+(c[L+(c[c[I+28>>2]>>2]<<2)>>2]<<5);c[A+52>>2]=c[v>>2];c[A+56>>2]=d;A2(p);O4(c[o>>2]|0);O4(l);O4(G);O4(L);c[a+4>>2]=A;m=0;break a}else Da=t}else Da=B;while(0);w=0;x=Da;y=0;z=A}}else{w=0;x=6;y=0;z=0}}else{w=0;x=r;y=0;z=0}while(0);A2(p);O4(c[o>>2]|0);O4(l);if(w)O4(w);if(y)O4(y);c[a+4>>2]=z;x2(a);m=x}while(0);i=e;return m|0}function x2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;b=c[a+4>>2]|0;if(b){a=b+4|0;d=c[b>>2]|0;if(!(c[a>>2]|0))e=d;else{f=d;d=0;while(1){if(c[f+(d<<5)+8>>2]|0){g=c[f+(d<<5)+16>>2]|0;if(!g)h=f;else{O4(g);h=c[b>>2]|0}g=c[h+(d<<5)+28>>2]|0;if(!g)i=h;else{O4(g);i=c[b>>2]|0}}else i=f;d=d+1|0;if(d>>>0>=(c[a>>2]|0)>>>0){e=i;break}else f=i}}if(e)O4(e);e=b+8|0;i=c[e>>2]|0;if(i){if(!(c[i+8>>2]|0))j=i;else{f=i;while(1){i=c[f+16>>2]|0;if(i)O4(i);if(!(c[f+40>>2]|0))break;else f=f+32|0}j=c[e>>2]|0}O4(j)}j=b+16|0;e=c[j>>2]|0;if(e){f=b+28|0;i=c[f>>2]|0;if(!i)k=e;else{a=e;e=i;i=0;while(1){d=c[a+(i*12|0)+8>>2]|0;if(!d)l=e;else{O4(d);l=c[f>>2]|0}d=i+1|0;if(d>>>0>=l>>>0)break;a=c[j>>2]|0;e=l;i=d}k=c[j>>2]|0}O4(k)}k=c[b+32>>2]|0;if(k)O4(k);k=c[b+20>>2]|0;if(k)O4(k);k=c[b+36>>2]|0;if(k)O4(k);O4(b)}return}function y2(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0;g=i;i=i+16|0;h=g;j=c[a+4>>2]|0;a=j+56|0;k=(c[a>>2]&8|0)==0?d:0;d=j+40|0;l=c[d>>2]|0;if((l|0)>0&(k|0)!=0){m=N4(l<<2)|0;if(!m)n=12;else{o=m;p=3}}else{o=0;p=3}if((p|0)==3){if(!(c[j+60>>2]|0)){c[h>>2]=0;m=f&1;l=f&2;q=c[a>>2]&4;if(!o)r=0;else r=c[d>>2]|0;s=r<<2;t=c[j+52>>2]|0;u=t<<3;v=u+8|0;w=s+12+u+(v+(_(s,t)|0)<<1)|0;x=N4(w)|0;if(!x){y=12;z=0}else{$4(x|0,0,w|0)|0;w=x+s|0;A=w&3;B=w+((A|0)==0?0:4-A|0)|0;A=B+v|0;w=A&3;C=A+((w|0)==0?0:4-w|0)|0;w=C+v|0;v=w&3;A=w+((v|0)==0?0:4-v|0)|0;v=A+u|0;u=v&3;if((t|0)>0){w=0;D=v+((u|0)==0?0:4-u|0)|0;while(1){c[C+(w<<3)+4>>2]=D;u=D+s|0;c[B+(w<<3)+4>>2]=u;w=w+1|0;if((w|0)==(t|0)){E=0;break}else D=u+s|0}do{c[A+(E<<3)>>2]=-1;E=E+1|0}while((E|0)!=(t|0))}t=n2(h,b,4)|0;if((t|0)<1)if((t|0)<0){F=0;G=1}else{H=1;p=201}else{H=t;p=201}a:do if((p|0)==201){t=j+8|0;E=(q|0)!=0;D=(r|0)>0;w=j+12|0;u=j+44|0;v=j+32|0;I=j+36|0;J=(r|0)==0;K=(m|0)==0;L=(r|0)<1;M=-1;N=0;O=0;P=H;Q=0;R=C;S=B;T=B;U=b+H|0;V=x;while(1){if((M|0)<0){W=c[t>>2]|0;X=W+8|0;b:do if(!(c[X>>2]|0)){Y=M;Z=N;$=T}else{aa=(O|0)!=0;ba=(Q|0)==95;ca=(O|0)==0;da=E&(Q|0)==10;ea=K&(O|0)<1;fa=X;ga=M;ha=N;ia=T;ja=W;while(1){ka=fa;la=ja;c:while(1){ma=la+12|0;if((c[A+(c[ma>>2]<<3)>>2]|0)>=(O|0)){na=ga;oa=ha;pa=ia;qa=la;break}ra=la+20|0;sa=c[ra>>2]|0;if(!sa){ta=ka;ua=ma;va=la;p=236;break}d:do if(da|(ea|(sa&1|0)==0)){if((sa&2|0)!=0?(wa=c[h>>2]|0,!((wa|l|0)==0|E&(wa|0)==10)):0)break;do if(sa&16){if(ba)break d;if(t1(Q)|0)break d;wa=c[h>>2]|0;if((wa|0)==95)break;if(!(t1(wa)|0))break d}while(0);wa=c[ra>>2]|0;if(!(wa&32))xa=wa;else{if(ba){wa=c[h>>2]|0;if((wa|0)==95)break;else ya=wa}else{wa=(t1(Q)|0)==0;za=c[h>>2]|0;if(wa|(za|0)==95)break;else ya=za}if(t1(ya)|0)break;xa=c[ra>>2]|0}za=c[h>>2]|0;do if((za|0)!=0&(aa&(xa&64|0)!=0)){if(ba){Aa=za;Ba=1}else{wa=(t1(Q)|0)!=0;Aa=c[h>>2]|0;Ba=wa}if((Aa|0)==95)if(Ba)break d;else break;else if(Ba^(t1(Aa)|0)!=0)break;else break d}while(0);if(!(c[ra>>2]&128)){ta=ka;ua=ma;va=la;p=236;break c}za=c[h>>2]|0;if(ca|(za|0)==0)break;if(ba){Ca=za;Da=1}else{za=(t1(Q)|0)!=0;Ca=c[h>>2]|0;Da=za}if((Ca|0)==95)if(Da){ta=ka;ua=ma;va=la;p=236;break c}else break;else if(Da^(t1(Ca)|0)!=0)break;else{ta=ka;ua=ma;va=la;p=236;break c}}while(0);ka=la+40|0;if(!(c[ka>>2]|0)){Y=ga;Z=ha;$=ia;break b}else la=la+32|0}if((p|0)==236){p=0;c[ia>>2]=c[ta>>2];if(D)$4(c[ia+4>>2]|0,-1,s|0)|0;la=c[va+16>>2]|0;do if(la){ka=c[la>>2]|0;if((ka|0)<=-1)break;ma=ia+4|0;ra=ka;ka=la;do{if((ra|0)<(r|0))c[(c[ma>>2]|0)+(ra<<2)>>2]=O;ka=ka+4|0;ra=c[ka>>2]|0}while((ra|0)>-1)}while(0);la=(c[ia>>2]|0)!=(c[w>>2]|0);if(L|la){Ea=ia+4|0;Fa=la?ga:O;Ga=la?ha:1}else{la=ia+4|0;ra=c[la>>2]|0;ka=0;do{c[o+(ka<<2)>>2]=c[ra+(ka<<2)>>2];ka=ka+1|0}while((ka|0)!=(r|0));Ea=la;Fa=O;Ga=1}la=c[ua>>2]|0;c[A+(la<<3)>>2]=O;c[A+(la<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0;qa=va}fa=qa+40|0;if(!(c[fa>>2]|0)){Y=na;Z=oa;$=pa;break}else{ga=na;ha=oa;ia=pa;ja=qa+32|0}}}while(0);c[$>>2]=0;W=c[h>>2]|0;if(!W){Ha=Y;break}else{Ia=W;Ja=Y;Ka=Z}}else{if(J){Ha=M;break}W=c[h>>2]|0;if((T|0)!=(S|0)&(W|0)!=0){Ia=W;Ja=M;Ka=N}else{Ha=M;break}}W=O+P|0;X=n2(h,U,4)|0;if((X|0)<1)if((X|0)<0){F=0;G=1;break a}else La=1;else La=X;X=U+La|0;if((Ka|0)!=0&(c[u>>2]|0)!=0){if(!(c[S>>2]|0))Ma=R;else{ja=c[I>>2]|0;ia=c[ja>>2]|0;ha=(ia|0)>-1;ga=S;fa=R;while(1){ba=ga+4|0;e:do if(ha){ca=ia;aa=0;while(1){ea=c[ja+((aa|1)<<2)>>2]|0;if((ca|0)>=(r|0)){Na=fa;break e}da=c[ba>>2]|0;if((c[da+(ea<<2)>>2]|0)==(c[o+(ea<<2)>>2]|0)?(c[da+(ca<<2)>>2]|0)<(c[o+(ca<<2)>>2]|0):0){Na=fa;break e}aa=aa+2|0;ca=c[ja+(aa<<2)>>2]|0;if((ca|0)<=-1){Oa=da;break}}Pa=ba;Qa=Oa;p=265}else{Pa=ba;Qa=c[ba>>2]|0;p=265}while(0);if((p|0)==265){p=0;c[fa>>2]=c[ga>>2];ba=fa+4|0;ca=c[ba>>2]|0;c[ba>>2]=Qa;c[Pa>>2]=ca;Na=fa+8|0}ga=ga+8|0;if(!(c[ga>>2]|0)){Ma=Na;break}else fa=Na}}c[Ma>>2]=0;Ra=0;Sa=R;Ta=S}else{Ra=Ka;Sa=S;Ta=R}fa=c[Sa>>2]|0;if(!fa){Ua=Ja;Va=Ra;Wa=Ta;Xa=V}else{ga=(W|0)!=0;ja=(Ia|0)==95;ia=(W|0)==0;ha=E&(Ia|0)==10;ca=K&(W|0)<1;ba=fa;fa=Ja;aa=Ra;da=Sa;ea=Ta;la=V;while(1){ka=ba+8|0;if(!(c[ka>>2]|0)){Ya=fa;Za=aa;_a=ea;$a=la}else{ra=da+4|0;ma=la;sa=ka;ka=fa;za=aa;wa=ea;ab=ba;while(1){f:do if((c[ab>>2]|0)>>>0>Ia>>>0){bb=ka;cb=za;db=wa;eb=ma}else{if((c[ab+4>>2]|0)>>>0<Ia>>>0){bb=ka;cb=za;db=wa;eb=ma;break}fb=ab+20|0;gb=c[fb>>2]|0;do if(gb){if(!(ha|(ca|(gb&1|0)==0))){bb=ka;cb=za;db=wa;eb=ma;break f}if((gb&2|0)!=0?(hb=c[h>>2]|0,!((hb|l|0)==0|E&(hb|0)==10)):0){bb=ka;cb=za;db=wa;eb=ma;break f}do if(gb&16){if(ja){bb=ka;cb=za;db=wa;eb=ma;break f}if(t1(Ia)|0){bb=ka;cb=za;db=wa;eb=ma;break f}hb=c[h>>2]|0;if((hb|0)==95)break;if(!(t1(hb)|0)){bb=ka;cb=za;db=wa;eb=ma;break f}}while(0);hb=c[fb>>2]|0;if(!(hb&32))ib=hb;else{if(ja){hb=c[h>>2]|0;if((hb|0)==95){bb=ka;cb=za;db=wa;eb=ma;break f}else jb=hb}else{hb=(t1(Ia)|0)==0;kb=c[h>>2]|0;if(hb|(kb|0)==95){bb=ka;cb=za;db=wa;eb=ma;break f}else jb=kb}if(t1(jb)|0){bb=ka;cb=za;db=wa;eb=ma;break f}ib=c[fb>>2]|0}kb=c[h>>2]|0;do if((kb|0)!=0&(ga&(ib&64|0)!=0)){if(ja){lb=kb;mb=1}else{hb=(t1(Ia)|0)!=0;lb=c[h>>2]|0;mb=hb}if((lb|0)==95)if(mb){bb=ka;cb=za;db=wa;eb=ma;break f}else break;else if(mb^(t1(lb)|0)!=0)break;else{bb=ka;cb=za;db=wa;eb=ma;break f}}while(0);do if(c[fb>>2]&128){kb=c[h>>2]|0;if(ia|(kb|0)==0){bb=ka;cb=za;db=wa;eb=ma;break f}if(ja){nb=kb;ob=1}else{kb=(t1(Ia)|0)!=0;nb=c[h>>2]|0;ob=kb}if((nb|0)==95)if(ob)break;else{bb=ka;cb=za;db=wa;eb=ma;break f}else if(ob^(t1(nb)|0)!=0){bb=ka;cb=za;db=wa;eb=ma;break f}else break}while(0);kb=c[fb>>2]|0;do if(!(kb&4))pb=kb;else{if(c[a>>2]&2){pb=kb;break}if(!(x1(Ia,c[ab+24>>2]|0)|0)){bb=ka;cb=za;db=wa;eb=ma;break f}pb=c[fb>>2]|0}while(0);do if(pb&4){if(!(c[a>>2]&2))break;kb=K1(Ia)|0;hb=ab+24|0;if(x1(kb,c[hb>>2]|0)|0)break;kb=J1(Ia)|0;if(!(x1(kb,c[hb>>2]|0)|0)){bb=ka;cb=za;db=wa;eb=ma;break f}}while(0);if(!(c[fb>>2]&8))break;if(q4(c[ab+28>>2]|0,Ia,c[a>>2]&2)|0){bb=ka;cb=za;db=wa;eb=ma;break f}}while(0);if(D){fb=c[ra>>2]|0;gb=0;do{c[ma+(gb<<2)>>2]=c[fb+(gb<<2)>>2];gb=gb+1|0}while((gb|0)!=(r|0))}gb=c[ab+16>>2]|0;do if(gb){fb=c[gb>>2]|0;if((fb|0)>-1){qb=fb;rb=gb}else break;do{if((qb|0)<(r|0))c[ma+(qb<<2)>>2]=W;rb=rb+4|0;qb=c[rb>>2]|0}while((qb|0)>-1)}while(0);gb=c[ab+12>>2]|0;fb=A+(gb<<3)|0;if((c[fb>>2]|0)>=(W|0)){hb=c[A+(gb<<3)+4>>2]|0;kb=c[hb>>2]|0;if(!(o4(r,c[v>>2]|0,ma,kb)|0)){bb=ka;cb=za;db=wa;eb=ma;break}c[hb>>2]=ma;if((c[sa>>2]|0)!=(c[w>>2]|0)){bb=ka;cb=za;db=wa;eb=kb;break}if(D)sb=0;else{bb=W;cb=1;db=wa;eb=kb;break}while(1){c[o+(sb<<2)>>2]=c[ma+(sb<<2)>>2];sb=sb+1|0;if((sb|0)==(r|0)){bb=W;cb=1;db=wa;eb=kb;break f}}}kb=c[sa>>2]|0;c[wa>>2]=kb;hb=wa+4|0;tb=c[hb>>2]|0;c[hb>>2]=ma;c[fb>>2]=W;c[A+(gb<<3)+4>>2]=hb;do if((kb|0)==(c[w>>2]|0)){if((ka|0)==-1)if(D)ub=0;else{vb=W;wb=1;break}else{if(!D){vb=ka;wb=za;break}if((c[ma>>2]|0)>(c[o>>2]|0)){vb=ka;wb=za;break}else ub=0}do{c[o+(ub<<2)>>2]=c[ma+(ub<<2)>>2];ub=ub+1|0}while((ub|0)<(r|0));vb=W;wb=1}else{vb=ka;wb=za}while(0);bb=vb;cb=wb;db=wa+8|0;eb=tb}while(0);sa=ab+40|0;if(!(c[sa>>2]|0)){Ya=bb;Za=cb;_a=db;$a=eb;break}else{ma=eb;ka=bb;za=cb;wa=db;ab=ab+32|0}}}da=da+8|0;ba=c[da>>2]|0;if(!ba){Ua=Ya;Va=Za;Wa=_a;Xa=$a;break}else{fa=Ya;aa=Za;ea=_a;la=$a}}}c[Wa>>2]=0;M=Ua;N=Va;O=W;P=La;Q=Ia;R=Sa;S=Ta;T=Wa;U=X;V=Xa}F=Ha;G=Ha>>>31}while(0);O4(x);y=G;z=F}xb=z;yb=y}else{c[h>>2]=0;y=f&1;z=f&2;f=c[a>>2]&4;F=z2(0,0)|0;g:do if(F){G=B2(F,0,0,0,32)|0;if(!G){A2(F);zb=12;Ab=0;break}c[G+24>>2]=0;c[G+28>>2]=0;x=c[d>>2]|0;if(x){Ha=N4(x<<2)|0;if(!Ha){Bb=0;Cb=0;Db=12;Eb=0;Fb=Ha}else{Gb=Ha;p=9}}else{Gb=0;p=9}h:do if((p|0)==9){Ha=c[j+28>>2]|0;if(Ha){Xa=N4(Ha<<3)|0;if(!Xa){Bb=0;Cb=Xa;Db=12;Eb=0;Fb=Gb;break}else Hb=Xa}else Hb=0;Xa=j+52|0;Ha=c[Xa>>2]|0;if(Ha){Wa=N4(Ha<<2)|0;if(!Wa){Bb=0;Cb=Hb;Db=12;Eb=Wa;Fb=Gb;break}else Ib=Wa}else Ib=0;Wa=j+8|0;Ha=j+12|0;Ta=(o|0)==0;Sa=(o|0)!=0;Ia=j+32|0;La=(f|0)!=0;Va=(Gb|0)==0;Ua=(Hb|0)==0;$a=(Ib|0)==0;_a=(y|0)==0;Za=x;Ya=-1;db=1;cb=-1;bb=G;eb=b;i:while(1){if((Za|0)>0){wb=Za;vb=0;while(1){c[Gb+(vb<<2)>>2]=-1;if(Ta)Jb=wb;else{c[o+(vb<<2)>>2]=-1;Jb=c[d>>2]|0}vb=vb+1|0;if((vb|0)>=(Jb|0))break;else wb=Jb}}wb=c[Xa>>2]|0;if((wb|0)>0)$4(Ib|0,0,((wb|0)>1?wb:1)<<2|0)|0;wb=c[h>>2]|0;vb=db+cb|0;r=n2(h,eb,4)|0;if((r|0)<1)if((r|0)<0){Bb=0;Cb=Hb;Db=1;Eb=Ib;Fb=Gb;break h}else Kb=1;else Kb=r;r=eb+Kb|0;ub=c[h>>2]|0;A=c[Wa>>2]|0;sb=A+8|0;if(c[sb>>2]|0){qb=(vb|0)!=0;rb=(wb|0)==95;pb=(vb|0)==0;nb=La&(wb|0)==10;ob=_a&(vb|0)<1;lb=sb;sb=0;mb=bb;ib=0;jb=A;while(1){A=jb+20|0;l=c[A>>2]|0;j:do if(l){if(!(nb|(ob|(l&1|0)==0))){Lb=sb;Mb=mb;Nb=ib;break}if((l&2|0)!=0?(Ra=c[h>>2]|0,!((Ra|z|0)==0|La&(Ra|0)==10)):0){Lb=sb;Mb=mb;Nb=ib;break}do if(l&16){if(rb){Lb=sb;Mb=mb;Nb=ib;break j}if(t1(wb)|0){Lb=sb;Mb=mb;Nb=ib;break j}Ra=c[h>>2]|0;if((Ra|0)==95)break;if(!(t1(Ra)|0)){Lb=sb;Mb=mb;Nb=ib;break j}}while(0);tb=c[A>>2]|0;if(!(tb&32))Ob=tb;else{if(rb){tb=c[h>>2]|0;if((tb|0)==95){Lb=sb;Mb=mb;Nb=ib;break}else Pb=tb}else{tb=(t1(wb)|0)==0;Ra=c[h>>2]|0;if(tb|(Ra|0)==95){Lb=sb;Mb=mb;Nb=ib;break}else Pb=Ra}if(t1(Pb)|0){Lb=sb;Mb=mb;Nb=ib;break}Ob=c[A>>2]|0}Ra=c[h>>2]|0;do if((Ra|0)!=0&(qb&(Ob&64|0)!=0)){if(rb){Qb=Ra;Rb=1}else{tb=(t1(wb)|0)!=0;Qb=c[h>>2]|0;Rb=tb}if((Qb|0)==95)if(Rb){Lb=sb;Mb=mb;Nb=ib;break j}else break;else if(Rb^(t1(Qb)|0)!=0)break;else{Lb=sb;Mb=mb;Nb=ib;break j}}while(0);if(!(c[A>>2]&128)){p=52;break}Ra=c[h>>2]|0;if(pb|(Ra|0)==0){Lb=sb;Mb=mb;Nb=ib;break}if(rb){Sb=Ra;Tb=1}else{Ra=(t1(wb)|0)!=0;Sb=c[h>>2]|0;Tb=Ra}if((Sb|0)==95)if(Tb){p=52;break}else{Lb=sb;Mb=mb;Nb=ib;break}else if(Tb^(t1(Sb)|0)!=0){Lb=sb;Mb=mb;Nb=ib;break}else{p=52;break}}else p=52;while(0);do if((p|0)==52){p=0;if(!ib){Lb=c[jb+16>>2]|0;Mb=mb;Nb=c[lb>>2]|0;break}A=mb+28|0;l=c[A>>2]|0;if(!l){Ra=B2(F,0,0,0,32)|0;if(!Ra){p=56;break i}c[Ra+24>>2]=mb;c[Ra+28>>2]=0;tb=B2(F,0,0,0,c[d>>2]<<2)|0;c[Ra+20>>2]=tb;if(!tb){p=63;break i}c[A>>2]=Ra;Ub=Ra}else Ub=l;c[Ub>>2]=vb;c[Ub+4>>2]=r;c[Ub+8>>2]=c[lb>>2];c[Ub+12>>2]=c[jb+12>>2];c[Ub+16>>2]=c[h>>2];if((c[d>>2]|0)>0){l=c[Ub+20>>2]|0;Ra=0;do{c[l+(Ra<<2)>>2]=c[Gb+(Ra<<2)>>2];Ra=Ra+1|0}while((Ra|0)<(c[d>>2]|0))}Ra=c[jb+16>>2]|0;if(!Ra){Lb=sb;Mb=Ub;Nb=ib;break}l=c[Ra>>2]|0;if((l|0)<=-1){Lb=sb;Mb=Ub;Nb=ib;break}A=c[Ub+20>>2]|0;tb=l;l=Ra;do{l=l+4|0;c[A+(tb<<2)>>2]=vb;tb=c[l>>2]|0}while((tb|0)>-1);Lb=sb;Mb=Ub;Nb=ib}while(0);lb=jb+40|0;if(!(c[lb>>2]|0)){Vb=Lb;Wb=Mb;Xb=Nb;break}else{sb=Lb;mb=Mb;ib=Nb;jb=jb+32|0}}if(Vb){jb=c[Vb>>2]|0;if((jb|0)>-1){ib=jb;jb=Vb;while(1){c[Gb+(ib<<2)>>2]=vb;mb=jb+4|0;ib=c[mb>>2]|0;if((ib|0)<=-1){Yb=mb;break}else jb=mb}}else Yb=Vb}else Yb=0;if(!Xb){Zb=Ya;_b=Yb;$b=vb;ac=Kb;bc=Wb;cc=0;dc=r;p=174}else{ec=Ya;fc=Yb;gc=vb;hc=Kb;ic=Wb;jc=Xb;kc=r;p=82}}else{Zb=Ya;_b=0;$b=vb;ac=Kb;bc=bb;cc=0;dc=r;p=174}k:while(1){l:do if((p|0)==82){p=0;if((jc|0)==(c[Ha>>2]|0)){if((ec|0)>=(gc|0)){if(!(Sa&(ec|0)==(gc|0))){Zb=ec;_b=fc;$b=gc;ac=hc;bc=ic;cc=jc;dc=kc;p=174;continue k}if(!(o4(c[d>>2]|0,c[Ia>>2]|0,Gb,o)|0)){Zb=ec;_b=fc;$b=ec;ac=hc;bc=ic;cc=jc;dc=kc;p=174;continue k}}if(Ta){Zb=gc;_b=fc;$b=gc;ac=hc;bc=ic;cc=jc;dc=kc;p=174;continue k}if((c[d>>2]|0)>0)lc=0;else{Zb=gc;_b=fc;$b=gc;ac=hc;bc=ic;cc=jc;dc=kc;p=174;continue k}while(1){c[o+(lc<<2)>>2]=c[Gb+(lc<<2)>>2];jb=lc+1|0;if((jb|0)<(c[d>>2]|0))lc=jb;else{Zb=gc;_b=fc;$b=gc;ac=hc;bc=ic;cc=jc;dc=kc;p=174;continue k}}}jb=jc+8|0;do if(!(c[jb>>2]|0))p=97;else{if(!(c[jc+20>>2]&256)){p=97;break}ib=c[jc+24>>2]|0;p4(ib+1|0,Hb,c[a>>2]&-9,j,Gb,gc);mb=c[Hb+(ib<<3)>>2]|0;sb=c[Hb+(ib<<3)+4>>2]|0;ib=sb-mb|0;if(P3(b+mb|0,kc+-1|0,ib)|0){Zb=ec;_b=fc;$b=gc;ac=hc;bc=ic;cc=jc;dc=kc;p=174;continue k}lb=(sb|0)==(mb|0);mb=lb&1;sb=Ib+(c[jc+12>>2]<<2)|0;if(lb?(c[sb>>2]|0)!=0:0){Zb=ec;_b=fc;$b=gc;ac=hc;bc=ic;cc=jc;dc=kc;p=174;continue k}c[sb>>2]=mb;mb=ib+-1|0;ib=kc+mb|0;sb=c[h>>2]|0;lb=gc+hc+mb|0;mb=n2(h,ib,4)|0;if((mb|0)<1)if((mb|0)<0){mc=2;nc=ec;oc=fc;pc=lb;qc=mb;rc=ic;sc=jc;tc=ib;break l}else uc=1;else uc=mb;vc=lb;wc=uc;xc=sb;yc=ib+uc|0}while(0);if((p|0)==97){p=0;ib=c[h>>2]|0;if(!ib){Zb=ec;_b=fc;$b=gc;ac=hc;bc=ic;cc=jc;dc=kc;p=174;continue k}sb=gc+hc|0;lb=n2(h,kc,4)|0;if((lb|0)<1){if((lb|0)<0){mc=2;nc=ec;oc=fc;pc=sb;qc=lb;rc=ic;sc=jc;tc=kc;break}zc=lb+1|0}else zc=lb;vc=sb;wc=zc;xc=ib;yc=kc+zc|0}if(!(c[jb>>2]|0)){Zb=ec;_b=fc;$b=vc;ac=wc;bc=ic;cc=jc;dc=yc;p=174;continue k}ib=(vc|0)!=0;sb=(xc|0)==95;lb=(vc|0)==0;mb=La&(xc|0)==10;wb=_a&(vc|0)<1;rb=jb;pb=0;qb=fc;ob=ic;nb=jc;m:while(1){n:do if((c[nb>>2]|0)>>>0>xc>>>0){Ac=pb;Bc=qb;Cc=ob}else{if((c[nb+4>>2]|0)>>>0<xc>>>0){Ac=pb;Bc=qb;Cc=ob;break}tb=nb+20|0;l=c[tb>>2]|0;do if(l){if(!(mb|(wb|(l&1|0)==0))){Ac=pb;Bc=qb;Cc=ob;break n}if((l&2|0)!=0?(A=c[h>>2]|0,!((A|z|0)==0|La&(A|0)==10)):0){Ac=pb;Bc=qb;Cc=ob;break n}do if(l&16){if(sb){Ac=pb;Bc=qb;Cc=ob;break n}if(t1(xc)|0){Ac=pb;Bc=qb;Cc=ob;break n}A=c[h>>2]|0;if((A|0)==95)break;if(!(t1(A)|0)){Ac=pb;Bc=qb;Cc=ob;break n}}while(0);A=c[tb>>2]|0;if(!(A&32))Dc=A;else{if(sb){A=c[h>>2]|0;if((A|0)==95){Ac=pb;Bc=qb;Cc=ob;break n}else Ec=A}else{A=(t1(xc)|0)==0;Ra=c[h>>2]|0;if(A|(Ra|0)==95){Ac=pb;Bc=qb;Cc=ob;break n}else Ec=Ra}if(t1(Ec)|0){Ac=pb;Bc=qb;Cc=ob;break n}Dc=c[tb>>2]|0}Ra=c[h>>2]|0;do if((Ra|0)!=0&(ib&(Dc&64|0)!=0)){if(sb){Fc=Ra;Gc=1}else{A=(t1(xc)|0)!=0;Fc=c[h>>2]|0;Gc=A}if((Fc|0)==95)if(Gc){Ac=pb;Bc=qb;Cc=ob;break n}else break;else if(Gc^(t1(Fc)|0)!=0)break;else{Ac=pb;Bc=qb;Cc=ob;break n}}while(0);do if(c[tb>>2]&128){Ra=c[h>>2]|0;if(lb|(Ra|0)==0){Ac=pb;Bc=qb;Cc=ob;break n}if(sb){Hc=Ra;Ic=1}else{Ra=(t1(xc)|0)!=0;Hc=c[h>>2]|0;Ic=Ra}if((Hc|0)==95)if(Ic)break;else{Ac=pb;Bc=qb;Cc=ob;break n}else if(Ic^(t1(Hc)|0)!=0){Ac=pb;Bc=qb;Cc=ob;break n}else break}while(0);Ra=c[tb>>2]|0;do if(!(Ra&4))Jc=Ra;else{if(c[a>>2]&2){Jc=Ra;break}if(!(x1(xc,c[nb+24>>2]|0)|0)){Ac=pb;Bc=qb;Cc=ob;break n}Jc=c[tb>>2]|0}while(0);do if(Jc&4){if(!(c[a>>2]&2))break;Ra=K1(xc)|0;A=nb+24|0;if(x1(Ra,c[A>>2]|0)|0)break;Ra=J1(xc)|0;if(!(x1(Ra,c[A>>2]|0)|0)){Ac=pb;Bc=qb;Cc=ob;break n}}while(0);if(!(c[tb>>2]&8))break;if(q4(c[nb+28>>2]|0,xc,c[a>>2]&2)|0){Ac=pb;Bc=qb;Cc=ob;break n}}while(0);if(!pb){Ac=c[rb>>2]|0;Bc=c[nb+16>>2]|0;Cc=ob;break}tb=ob+28|0;l=c[tb>>2]|0;if(!l){A=B2(F,0,0,0,32)|0;if(!A){Kc=qb;Lc=ob;p=148;break m}c[A+24>>2]=ob;c[A+28>>2]=0;Ra=B2(F,0,0,0,c[d>>2]<<2)|0;c[A+20>>2]=Ra;if(!Ra){Mc=qb;Nc=ob;p=155;break m}c[tb>>2]=A;Oc=A}else Oc=l;c[Oc>>2]=vc;c[Oc+4>>2]=yc;c[Oc+8>>2]=c[rb>>2];c[Oc+12>>2]=c[nb+12>>2];c[Oc+16>>2]=c[h>>2];if((c[d>>2]|0)>0){l=c[Oc+20>>2]|0;A=0;do{c[l+(A<<2)>>2]=c[Gb+(A<<2)>>2];A=A+1|0}while((A|0)<(c[d>>2]|0))}A=c[nb+16>>2]|0;if(!A){Ac=pb;Bc=qb;Cc=Oc;break}l=c[A>>2]|0;if((l|0)<=-1){Ac=pb;Bc=qb;Cc=Oc;break}tb=c[Oc+20>>2]|0;Ra=l;l=A;do{c[tb+(Ra<<2)>>2]=vc;l=l+4|0;Ra=c[l>>2]|0}while((Ra|0)>-1);Ac=pb;Bc=qb;Cc=Oc}while(0);rb=nb+40|0;if(!(c[rb>>2]|0)){Pc=Ac;Qc=Bc;Rc=Cc;p=170;break}else{pb=Ac;qb=Bc;ob=Cc;nb=nb+32|0}}if((p|0)==148){p=0;A2(F);if(!Va)O4(Gb);if(!Ua)O4(Hb);if($a){mc=1;nc=ec;oc=Kc;pc=vc;qc=wc;rc=Lc;sc=jc;tc=yc;break}O4(Ib);mc=1;nc=ec;oc=Kc;pc=vc;qc=wc;rc=Lc;sc=jc;tc=yc;break}else if((p|0)==155){p=0;A2(F);if(!Va)O4(Gb);if(!Ua)O4(Hb);if($a){mc=1;nc=ec;oc=Mc;pc=vc;qc=wc;rc=Nc;sc=jc;tc=yc;break}O4(Ib);mc=1;nc=ec;oc=Mc;pc=vc;qc=wc;rc=Nc;sc=jc;tc=yc;break}else if((p|0)==170){p=0;if(!Pc){Zb=ec;_b=Qc;$b=vc;ac=wc;bc=Rc;cc=jc;dc=yc;p=174;continue k}if(!Qc){mc=0;nc=ec;oc=0;pc=vc;qc=wc;rc=Rc;sc=Pc;tc=yc;break}nb=c[Qc>>2]|0;if((nb|0)>-1){Sc=nb;Tc=Qc}else{mc=0;nc=ec;oc=Qc;pc=vc;qc=wc;rc=Rc;sc=Pc;tc=yc;break}while(1){nb=Tc+4|0;c[Gb+(Sc<<2)>>2]=vc;Sc=c[nb>>2]|0;if((Sc|0)<=-1){mc=0;nc=ec;oc=nb;pc=vc;qc=wc;rc=Rc;sc=Pc;tc=yc;break}else Tc=nb}}}else if((p|0)==174){p=0;nb=c[bc+24>>2]|0;if(!nb){if((Zb|0)>-1|(c[h>>2]|0)==0){mc=27;nc=Zb;oc=_b;pc=$b;qc=ac;rc=bc;sc=cc;tc=dc;break}c[h>>2]=ub;mc=3;nc=Zb;oc=_b;pc=$b;qc=ac;rc=bc;sc=cc;tc=r;break}ob=c[bc+8>>2]|0;if(c[ob+20>>2]&256)c[Ib+(c[bc+12>>2]<<2)>>2]=0;qb=c[bc>>2]|0;pb=c[bc+4>>2]|0;c[h>>2]=c[bc+16>>2];rb=c[d>>2]|0;if((rb|0)<=0){mc=0;nc=Zb;oc=_b;pc=qb;qc=ac;rc=nb;sc=ob;tc=pb;break}sb=c[bc+20>>2]|0;lb=0;do{c[Gb+(lb<<2)>>2]=c[sb+(lb<<2)>>2];lb=lb+1|0}while((lb|0)!=(rb|0));mc=0;nc=Zb;oc=_b;pc=qb;qc=ac;rc=nb;sc=ob;tc=pb}while(0);switch(mc|0){case 2:{Bb=0;Cb=Hb;Db=1;Eb=Ib;Fb=Gb;break h;break}case 27:{Uc=nc;p=184;break i;break}case 0:{ec=nc;fc=oc;gc=pc;hc=qc;ic=rc;jc=sc;kc=tc;p=82;break}case 3:{break k;break}default:{zb=12;Ab=0;break g}}}Za=c[d>>2]|0;Ya=nc;db=qc;cb=vb;bb=rc;eb=tc}if((p|0)==56){A2(F);if(!Va)O4(Gb);if(!Ua)O4(Hb);if($a){zb=12;Ab=0;break g}O4(Ib);zb=12;Ab=0;break g}else if((p|0)==63){A2(F);if(!Va)O4(Gb);if(!Ua)O4(Hb);if($a){zb=12;Ab=0;break g}O4(Ib);zb=12;Ab=0;break g}else if((p|0)==184){Bb=Uc;Cb=Hb;Db=Uc>>>31;Eb=Ib;Fb=Gb;break}}while(0);A2(F);if(Fb)O4(Fb);if(Cb)O4(Cb);if(!Eb){zb=Db;Ab=Bb}else{O4(Eb);zb=Db;Ab=Bb}}else{zb=12;Ab=0}while(0);xb=Ab;yb=zb}if(!yb)p4(k,e,c[a>>2]|0,j,o,xb);if(!o)n=yb;else{O4(o);n=yb}}i=g;return n|0}function z2(a,b){a=a|0;b=b|0;var d=0;if(!a)d=P4(1,24)|0;else{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;d=b}return d|0}function A2(a){a=a|0;var b=0,d=0;b=c[a>>2]|0;if(b){d=b;do{O4(c[d>>2]|0);b=d;d=c[d+4>>2]|0;O4(b)}while((d|0)!=0)}O4(a);return}function B2(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=a+16|0;a:do if(!(c[g>>2]|0)){h=a+12|0;i=c[h>>2]|0;do if(i>>>0<f>>>0){if(b)if(!d){c[g>>2]=1;j=0;break a}else{k=a+8|0;c[k>>2]=d;c[h>>2]=1024;l=k;m=d;n=d;o=1024;break}k=f<<3;p=k>>>0>1024?k:1024;k=N4(8)|0;if(!k){c[g>>2]=1;j=0;break a}q=N4(p)|0;c[k>>2]=q;r=q;if(!q){O4(k);c[g>>2]=1;j=0;break a}c[k+4>>2]=0;s=a+4|0;t=c[s>>2]|0;if(t)c[t+4>>2]=k;if(!(c[a>>2]|0))c[a>>2]=k;c[s>>2]=k;k=a+8|0;c[k>>2]=r;c[h>>2]=p;l=k;m=r;n=q;o=p}else{p=a+8|0;q=c[p>>2]|0;l=p;m=q;n=q;o=i}while(0);i=m+f&3;q=((i|0)==0?0:4-i|0)+f|0;c[l>>2]=n+q;c[h>>2]=o-q;if(!e)j=n;else{$4(n|0,0,q|0)|0;j=n}}else j=0;while(0);return j|0}function C2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=d+40|0;f=d+8|0;g=d;c[g>>2]=a;c[g+4>>2]=b;h=Va(197,g|0)|0;if((h|0)==-9?(c[f>>2]=a,c[f+4>>2]=1,(Za(221,f|0)|0)>=0):0){P1(f,a);c[e>>2]=f;c[e+4>>2]=b;j=S1(Wa(195,e|0)|0)|0}else j=S1(h)|0;i=d;return j|0}function D2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+112|0;f=e+40|0;g=e+24|0;h=e+16|0;j=e;k=e+52|0;l=a[d>>0]|0;if(A3(190740,l<<24>>24,4)|0){m=N4(1144)|0;if(!m)n=0;else{o=m;p=o+112|0;do{c[o>>2]=0;o=o+4|0}while((o|0)<(p|0));if(!(H3(d,43)|0))c[m>>2]=l<<24>>24==114?8:4;if(!(H3(d,101)|0))q=l;else{c[j>>2]=b;c[j+4>>2]=2;c[j+8>>2]=1;Za(221,j|0)|0;q=a[d>>0]|0}if(q<<24>>24==97){c[h>>2]=b;c[h+4>>2]=3;q=Za(221,h|0)|0;if(!(q&1024)){c[g>>2]=b;c[g+4>>2]=4;c[g+8>>2]=q|1024;Za(221,g|0)|0}g=c[m>>2]|128;c[m>>2]=g;r=g}else r=c[m>>2]|0;c[m+60>>2]=b;c[m+44>>2]=m+120;c[m+48>>2]=1024;g=m+75|0;a[g>>0]=-1;if((r&8|0)==0?(c[f>>2]=b,c[f+4>>2]=21505,c[f+8>>2]=k,(hb(54,f|0)|0)==0):0)a[g>>0]=10;c[m+32>>2]=23;c[m+36>>2]=21;c[m+40>>2]=22;c[m+12>>2]=17;if(!(c[24681]|0))c[m+76>>2]=-1;ob(98748);g=c[24686]|0;c[m+56>>2]=g;if(g)c[g+52>>2]=m;c[24686]=m;ib(98748);n=m}}else{c[(L1()|0)>>2]=22;n=0}i=e;return n|0}function E2(b){b=b|0;var c=0,d=0,e=0,f=0;c=(H3(b,43)|0)==0;d=a[b>>0]|0;e=c?d<<24>>24!=114&1:2;c=(H3(b,120)|0)==0;f=c?e:e|128;e=(H3(b,101)|0)==0;b=e?f:f|524288;f=d<<24>>24==114?b:b|64;b=d<<24>>24==119?f|512:f;return (d<<24>>24==97?b|1024:b)|0}function F2(a){a=a|0;return 0}function G2(a){a=a|0;return}function H2(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=e&255;a[g>>0]=h;j=b+16|0;k=c[j>>2]|0;if(!k)if(!(P2(b)|0)){l=c[j>>2]|0;m=4}else n=-1;else{l=k;m=4}do if((m|0)==4){k=b+20|0;j=c[k>>2]|0;if(j>>>0<l>>>0?(o=e&255,(o|0)!=(a[b+75>>0]|0)):0){c[k>>2]=j+1;a[j>>0]=h;n=o;break}if((Hb[c[b+36>>2]&63](b,g,1)|0)==1)n=d[g>>0]|0;else n=-1}while(0);i=f;return n|0}function I2(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=c[a+60>>2];a=S1(pb(6,d|0)|0)|0;i=b;return a|0}function J2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+48|0;g=f+16|0;h=f;j=f+32|0;c[j>>2]=d;k=j+4|0;l=b+48|0;m=c[l>>2]|0;c[k>>2]=e-((m|0)!=0&1);n=b+44|0;c[j+8>>2]=c[n>>2];c[j+12>>2]=m;if(!(c[24680]|0)){c[g>>2]=c[b+60>>2];c[g+4>>2]=j;c[g+8>>2]=2;o=S1(xb(145,g|0)|0)|0}else{qb(110,b|0);c[h>>2]=c[b+60>>2];c[h+4>>2]=j;c[h+8>>2]=2;j=S1(xb(145,h|0)|0)|0;za(0);o=j}if((o|0)>=1){j=c[k>>2]|0;if(o>>>0>j>>>0){k=c[n>>2]|0;n=b+4|0;c[n>>2]=k;h=k;c[b+8>>2]=h+(o-j);if(!(c[l>>2]|0))p=e;else{c[n>>2]=h+1;a[d+(e+-1)>>0]=a[h>>0]|0;p=e}}else p=o}else{c[b>>2]=c[b>>2]|o&48^16;c[b+8>>2]=0;c[b+4>>2]=0;p=o}i=f;return p|0}function K2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+32|0;f=e;g=e+20|0;c[f>>2]=c[a+60>>2];c[f+4>>2]=0;c[f+8>>2]=b;c[f+12>>2]=g;c[f+16>>2]=d;if((S1(vb(140,f|0)|0)|0)<0){c[g>>2]=-1;h=-1}else h=c[g>>2]|0;i=e;return h|0}function L2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+48|0;f=e+16|0;g=e;h=e+32|0;j=a+28|0;k=c[j>>2]|0;c[h>>2]=k;l=a+20|0;m=(c[l>>2]|0)-k|0;c[h+4>>2]=m;c[h+8>>2]=b;c[h+12>>2]=d;b=a+60|0;k=a+44|0;n=h;h=2;o=m+d|0;while(1){if(!(c[24680]|0)){c[f>>2]=c[b>>2];c[f+4>>2]=n;c[f+8>>2]=h;p=S1(Fa(146,f|0)|0)|0}else{qb(111,a|0);c[g>>2]=c[b>>2];c[g+4>>2]=n;c[g+8>>2]=h;m=S1(Fa(146,g|0)|0)|0;za(0);p=m}if((o|0)==(p|0)){q=6;break}if((p|0)<0){r=n;s=h;q=8;break}m=o-p|0;t=c[n+4>>2]|0;if(p>>>0<=t>>>0)if((h|0)==2){c[j>>2]=(c[j>>2]|0)+p;u=t;v=p;w=n;x=2}else{u=t;v=p;w=n;x=h}else{y=c[k>>2]|0;c[j>>2]=y;c[l>>2]=y;u=c[n+12>>2]|0;v=p-t|0;w=n+8|0;x=h+-1|0}c[w>>2]=(c[w>>2]|0)+v;c[w+4>>2]=u-v;n=w;h=x;o=m}if((q|0)==6){o=c[k>>2]|0;c[a+16>>2]=o+(c[a+48>>2]|0);k=o;c[j>>2]=k;c[l>>2]=k;z=d}else if((q|0)==8){c[a+16>>2]=0;c[j>>2]=0;c[l>>2]=0;c[a>>2]=c[a>>2]|32;if((s|0)==2)z=0;else z=d-(c[r+4>>2]|0)|0}i=e;return z|0}function M2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+80|0;g=f;c[b+36>>2]=21;if((c[b>>2]&64|0)==0?(c[g>>2]=c[b+60>>2],c[g+4>>2]=21505,c[g+8>>2]=f+12,(hb(54,g|0)|0)!=0):0)a[b+75>>0]=-1;g=L2(b,d,e)|0;i=f;return g|0}function N2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=a+84|0;f=c[e>>2]|0;g=d+256|0;h=A3(f,0,g)|0;i=(h|0)==0?g:h-f|0;h=i>>>0<d>>>0?i:d;Z4(b|0,f|0,h|0)|0;c[a+4>>2]=f+h;b=f+i|0;c[a+8>>2]=b;c[e>>2]=b;return h|0}function O2(b){b=b|0;var d=0,e=0,f=0;d=b+74|0;e=a[d>>0]|0;a[d>>0]=e+255|e;e=b+20|0;d=b+44|0;if((c[e>>2]|0)>>>0>(c[d>>2]|0)>>>0)Hb[c[b+36>>2]&63](b,0,0)|0;c[b+16>>2]=0;c[b+28>>2]=0;c[e>>2]=0;e=c[b>>2]|0;if(e&20)if(!(e&4))f=-1;else{c[b>>2]=e|32;f=-1}else{e=c[d>>2]|0;c[b+8>>2]=e;c[b+4>>2]=e;f=0}return f|0}function P2(b){b=b|0;var d=0,e=0,f=0;d=b+74|0;e=a[d>>0]|0;a[d>>0]=e+255|e;e=c[b>>2]|0;if(!(e&8)){c[b+8>>2]=0;c[b+4>>2]=0;d=c[b+44>>2]|0;c[b+28>>2]=d;c[b+20>>2]=d;c[b+16>>2]=d+(c[b+48>>2]|0);f=0}else{c[b>>2]=e|32;f=-1}return f|0}function Q2(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+16|0;e=b;if((c[a+8>>2]|0)==0?(O2(a)|0)!=0:0)f=-1;else if((Hb[c[a+32>>2]&63](a,e,1)|0)==1)f=d[e>>0]|0;else f=-1;i=b;return f|0}function R2(a){a=a|0;var b=0,d=0,e=0,f=0;b=(c[a>>2]&1|0)!=0;if(!b){ob(98748);d=c[a+52>>2]|0;e=a+56|0;if(d)c[d+56>>2]=c[e>>2];f=c[e>>2]|0;if(f)c[f+52>>2]=d;if((c[24686]|0)==(a|0))c[24686]=f;ib(98748)}f=T2(a)|0;d=Fb[c[a+12>>2]&63](a)|0|f;f=c[a+92>>2]|0;if(f)O4(f);if(!b)O4(a);return d|0}function S2(a){a=a|0;var b=0,d=0,e=0;if((c[a+76>>2]|0)>-1){b=(F2(a)|0)==0;d=(c[a>>2]|0)>>>4&1;if(b)e=d;else e=d}else e=(c[a>>2]|0)>>>4&1;return e|0}function T2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;do if(a){if((c[a+76>>2]|0)<=-1){b=t4(a)|0;break}d=(F2(a)|0)==0;e=t4(a)|0;if(d)b=e;else{G2(a);b=e}}else{if(!(c[24745]|0))f=0;else f=T2(c[24745]|0)|0;ob(98748);e=c[24686]|0;if(!e)g=f;else{d=e;e=f;while(1){if((c[d+76>>2]|0)>-1)h=F2(d)|0;else h=0;if((c[d+20>>2]|0)>>>0>(c[d+28>>2]|0)>>>0)i=t4(d)|0|e;else i=e;if(h)G2(d);d=c[d+56>>2]|0;if(!d){g=i;break}else e=i}}ib(98748);b=g}while(0);return b|0}function U2(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;if((c[a+76>>2]|0)>=0?(F2(a)|0)!=0:0){b=a+4|0;e=c[b>>2]|0;if(e>>>0<(c[a+8>>2]|0)>>>0){c[b>>2]=e+1;f=d[e>>0]|0}else f=Q2(a)|0;g=f}else h=3;do if((h|0)==3){f=a+4|0;e=c[f>>2]|0;if(e>>>0<(c[a+8>>2]|0)>>>0){c[f>>2]=e+1;g=d[e>>0]|0;break}else{g=Q2(a)|0;break}}while(0);return g|0}function V2(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;if((c[f+76>>2]|0)>-1)g=F2(f)|0;else g=0;h=e+-1|0;if((e|0)<2){e=f+74|0;i=a[e>>0]|0;a[e>>0]=i+255|i;if(g)G2(f);if(!h){a[b>>0]=0;j=b}else j=0}else{a:do if(h){i=f+4|0;e=f+8|0;k=h;l=b;while(1){m=c[i>>2]|0;n=m;o=(c[e>>2]|0)-n|0;p=A3(m,10,o)|0;q=(p|0)==0;r=q?o:1-n+p|0;p=r>>>0<k>>>0;n=p?r:k;Z4(l|0,m|0,n|0)|0;m=(c[i>>2]|0)+n|0;c[i>>2]=m;r=l+n|0;o=k-n|0;if(!(q&p)){s=r;t=17;break a}if(m>>>0>=(c[e>>2]|0)>>>0){p=Q2(f)|0;if((p|0)<0){u=r;break}else v=p}else{c[i>>2]=m+1;v=d[m>>0]|0}k=o+-1|0;o=r+1|0;a[r>>0]=v;if(!((k|0)!=0&(v&255|0)!=10)){s=o;t=17;break a}else l=o}if((u|0)!=(b|0)?(c[f>>2]&16|0)!=0:0){s=u;t=17}else w=0}else{s=b;t=17}while(0);if((t|0)==17)if(!b)w=0;else{a[s>>0]=0;w=b}if(!g)j=w;else{G2(f);j=w}}return j|0}function W2(a){a=a|0;(c[a+76>>2]|0)>-1?(F2(a)|0)!=0:0;return c[a+60>>2]|0}function X2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+32|0;f=e+16|0;g=e;if(A3(190740,a[d>>0]|0,4)|0){h=E2(d)|0|32768;c[g>>2]=b;c[g+4>>2]=h;c[g+8>>2]=438;h=S1(lb(5,g|0)|0)|0;if((h|0)>=0){g=D2(h,d)|0;if(!g){c[f>>2]=h;pb(6,f|0)|0;j=0}else j=g}else j=0}else{c[(L1()|0)>>2]=22;j=0}i=e;return j|0}function Y2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=o3(a,b,f)|0;i=e;return d|0}function Z2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;if((c[d+76>>2]|0)>=0?(F2(d)|0)!=0:0){if((a[d+75>>0]|0)!=(b|0)?(e=d+20|0,f=c[e>>2]|0,f>>>0<(c[d+16>>2]|0)>>>0):0){c[e>>2]=f+1;a[f>>0]=b;g=b&255}else g=H2(d,b)|0;G2(d);h=g}else i=3;do if((i|0)==3){if((a[d+75>>0]|0)!=(b|0)?(g=d+20|0,f=c[g>>2]|0,f>>>0<(c[d+16>>2]|0)>>>0):0){c[g>>2]=f+1;a[f>>0]=b;h=b&255;break}h=H2(d,b)|0}while(0);return h|0}function _2(a,b){a=a|0;b=b|0;return (h3(a,N3(a)|0,1,b)|0)+-1|0}function $2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=_(e,d)|0;if((c[f+76>>2]|0)>-1)h=F2(f)|0;else h=0;i=f+74|0;j=a[i>>0]|0;a[i>>0]=j+255|j;j=f+4|0;i=c[j>>2]|0;k=(c[f+8>>2]|0)-i|0;l=i;if((k|0)>0){i=k>>>0<g>>>0?k:g;Z4(b|0,l|0,i|0)|0;c[j>>2]=l+i;m=b+i|0;n=g-i|0}else{m=b;n=g}a:do if(!n)o=13;else{b=f+32|0;i=m;l=n;while(1){if(O2(f)|0){p=l;break}j=Hb[c[b>>2]&63](f,i,l)|0;if((j+1|0)>>>0<2){p=l;break}if((l|0)==(j|0)){o=13;break a}else{i=i+j|0;l=l-j|0}}if(h)G2(f);q=((g-p|0)>>>0)/(d>>>0)|0}while(0);if((o|0)==13)if(!h)q=e;else{G2(f);q=e}return q|0}function a3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)==1)e=b-(c[a+8>>2]|0)+(c[a+4>>2]|0)|0;else e=b;b=a+20|0;f=a+28|0;if((c[b>>2]|0)>>>0>(c[f>>2]|0)>>>0?(Hb[c[a+36>>2]&63](a,0,0)|0,(c[b>>2]|0)==0):0)g=-1;else{c[a+16>>2]=0;c[f>>2]=0;c[b>>2]=0;if((Hb[c[a+40>>2]&63](a,e,d)|0)<0)g=-1;else{c[a+8>>2]=0;c[a+4>>2]=0;c[a>>2]=c[a>>2]&-17;g=0}}return g|0}function b3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;if((c[a+76>>2]|0)>-1){e=(F2(a)|0)==0;f=a3(a,b,d)|0;if(e)g=f;else{G2(a);g=f}}else g=a3(a,b,d)|0;return g|0}function c3(a,b,c){a=a|0;b=b|0;c=c|0;return b3(a,b,c)|0}function d3(a){a=a|0;var b=0,d=0,e=0;if(!(c[a>>2]&128))b=1;else b=(c[a+20>>2]|0)>>>0>(c[a+28>>2]|0)>>>0?2:1;d=Hb[c[a+40>>2]&63](a,0,b)|0;if((d|0)<0)e=d;else e=d-(c[a+8>>2]|0)+(c[a+4>>2]|0)+(c[a+20>>2]|0)-(c[a+28>>2]|0)|0;return e|0}function e3(a){a=a|0;var b=0,d=0,e=0;if((c[a+76>>2]|0)>-1){b=(F2(a)|0)==0;d=d3(a)|0;if(b)e=d;else e=d}else e=d3(a)|0;return e|0}function f3(a){a=a|0;return e3(a)|0}function g3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=e+16|0;g=c[f>>2]|0;if(!g)if(!(P2(e)|0)){h=c[f>>2]|0;i=5}else j=0;else{h=g;i=5}a:do if((i|0)==5){g=e+20|0;f=c[g>>2]|0;k=f;if((h-f|0)>>>0<d>>>0){j=Hb[c[e+36>>2]&63](e,b,d)|0;break}b:do if((a[e+75>>0]|0)>-1){f=d;while(1){if(!f){l=d;m=b;n=k;o=0;break b}p=f+-1|0;if((a[b+p>>0]|0)==10){q=f;break}else f=p}if((Hb[c[e+36>>2]&63](e,b,q)|0)>>>0<q>>>0){j=q;break a}l=d-q|0;m=b+q|0;n=c[g>>2]|0;o=q}else{l=d;m=b;n=k;o=0}while(0);Z4(n|0,m|0,l|0)|0;c[g>>2]=(c[g>>2]|0)+l;j=o+l|0}while(0);return j|0}function h3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=_(d,b)|0;if((c[e+76>>2]|0)>-1){g=(F2(e)|0)==0;h=g3(a,f,e)|0;if(g)i=h;else{G2(e);i=h}}else i=g3(a,f,e)|0;if((i|0)==(f|0))j=d;else j=(i>>>0)/(b>>>0)|0;return j|0}function i3(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=o3(c[24744]|0,a,e)|0;i=d;return b|0}function j3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=q3(a,b,d,g)|0;i=f;return e|0}function k3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=r3(a,b,f)|0;i=e;return d|0}function l3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=s3(a,b,f)|0;i=e;return d|0}function m3(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;a=i;i=i+48|0;b=a+16|0;d=a;e=a+20|0;f=0;while(1){g=n3(e)|0;if(!g){h=0;break}c[d>>2]=g;c[d+4>>2]=32962;c[d+8>>2]=384;j=S1(lb(5,d|0)|0)|0;f=f+1|0;if((j|0)>-1){k=j;l=g;m=5;break}if((f|0)>=100){h=0;break}}if((m|0)==5){m=D2(k,190744)|0;c[b>>2]=l;kb(10,b|0)|0;h=m}i=a;return h|0}function n3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+64|0;d=b+32|0;e=b+24|0;f=b+8|0;g=b;h=b+40|0;j=b+48|0;c[h>>2]=a;if(!a)c[h>>2]=190747;c[g>>2]=190767;c[g+4>>2]=7;if(!(gb(33,g|0)|0)){g=j+4|0;a=h;k=0;while(1){c[f>>2]=0;c[f+4>>2]=j;c[f+8>>2]=0;Ea(265,f|0)|0;l=c[h>>2]|0;m=c[g>>2]^a^l;n=c[24848]|0;c[24848]=n+1;c[e>>2]=n;c[e+4>>2]=m;j3(l,20,190772,e)|0;c[d>>2]=c[h>>2];c[d+4>>2]=0;if(gb(33,d|0)|0){o=k;break}l=k+1|0;if((k|0)<100)k=l;else{o=l;break}}p=(o|0)>99?0:c[h>>2]|0}else p=0;i=b;return p|0}function o3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+224|0;g=f+120|0;h=f+80|0;j=f;k=f+136|0;l=h;m=l+40|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));c[g>>2]=c[e>>2];if((u4(0,d,g,j,h)|0)<0)n=-1;else{if((c[b+76>>2]|0)>-1)o=F2(b)|0;else o=0;e=c[b>>2]|0;l=e&32;if((a[b+74>>0]|0)<1)c[b>>2]=e&-33;e=b+48|0;if(!(c[e>>2]|0)){m=b+44|0;p=c[m>>2]|0;c[m>>2]=k;q=b+28|0;c[q>>2]=k;r=b+20|0;c[r>>2]=k;c[e>>2]=80;s=b+16|0;c[s>>2]=k+80;k=u4(b,d,g,j,h)|0;if(!p)t=k;else{Hb[c[b+36>>2]&63](b,0,0)|0;u=(c[r>>2]|0)==0?-1:k;c[m>>2]=p;c[e>>2]=0;c[s>>2]=0;c[q>>2]=0;c[r>>2]=0;t=u}}else t=u4(b,d,g,j,h)|0;h=c[b>>2]|0;c[b>>2]=h|l;if(o)G2(b);n=(h&32|0)==0?t:-1}i=f;return n|0}function p3(e,f,j){e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0.0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0;k=i;i=i+304|0;l=k+16|0;m=k+8|0;n=k+33|0;o=k;p=k+32|0;if((c[e+76>>2]|0)>-1)q=F2(e)|0;else q=0;r=a[f>>0]|0;a:do if(r<<24>>24){s=e+4|0;t=e+100|0;u=e+108|0;v=e+8|0;w=n+10|0;x=n+33|0;y=m+4|0;z=n+46|0;A=n+94|0;B=r;D=0;E=f;F=0;G=0;H=0;b:while(1){c:do if(!(r1(B&255)|0)){I=(a[E>>0]|0)==37;d:do if(I){J=E+1|0;K=a[J>>0]|0;e:do switch(K<<24>>24){case 37:{break d;break}case 42:{L=0;M=E+2|0;break}default:{N=(K&255)+-48|0;if(N>>>0<10?(a[E+2>>0]|0)==36:0){c[l>>2]=c[j>>2];O=N;while(1){N=(c[l>>2]|0)+(4-1)&~(4-1);P=c[N>>2]|0;c[l>>2]=N+4;if(O>>>0>1)O=O+-1|0;else{Q=P;break}}L=Q;M=E+3|0;break e}O=(c[j>>2]|0)+(4-1)&~(4-1);P=c[O>>2]|0;c[j>>2]=O+4;L=P;M=J}}while(0);J=a[M>>0]|0;K=J&255;if((K+-48|0)>>>0<10){P=K;K=M;O=0;while(1){N=(O*10|0)+-48+P|0;R=K+1|0;S=a[R>>0]|0;P=S&255;if((P+-48|0)>>>0>=10){T=S;U=R;V=N;break}else{K=R;O=N}}}else{T=J;U=M;V=0}if(T<<24>>24==109){O=U+1|0;W=a[O>>0]|0;X=(L|0)!=0&1;Y=O;Z=0;_=0}else{W=T;X=0;Y=U;Z=G;_=H}O=Y+1|0;switch(W&255|0){case 104:{K=(a[O>>0]|0)==104;$=K?Y+2|0:O;aa=K?-2:-1;break}case 108:{K=(a[O>>0]|0)==108;$=K?Y+2|0:O;aa=K?3:1;break}case 106:{$=O;aa=3;break}case 116:case 122:{$=O;aa=1;break}case 76:{$=O;aa=2;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{$=Y;aa=0;break}default:{ba=X;ca=D;da=Z;ea=_;fa=154;break b}}O=d[$>>0]|0;K=(O&47|0)==3;P=K?O|32:O;O=K?1:aa;switch(P|0){case 99:{ga=F;ha=(V|0)<1?1:V;break}case 91:{ga=F;ha=V;break}case 110:{if(!L){ia=D;ja=$;ka=F;la=Z;ma=_;break c}switch(O|0){case -2:{a[L>>0]=F;ia=D;ja=$;ka=F;la=Z;ma=_;break c;break}case -1:{b[L>>1]=F;ia=D;ja=$;ka=F;la=Z;ma=_;break c;break}case 0:{c[L>>2]=F;ia=D;ja=$;ka=F;la=Z;ma=_;break c;break}case 1:{c[L>>2]=F;ia=D;ja=$;ka=F;la=Z;ma=_;break c;break}case 3:{K=L;c[K>>2]=F;c[K+4>>2]=((F|0)<0)<<31>>31;ia=D;ja=$;ka=F;la=Z;ma=_;break c;break}default:{ia=D;ja=$;ka=F;la=Z;ma=_;break c}}break}default:{Q1(e,0);do{K=c[s>>2]|0;if(K>>>0<(c[t>>2]|0)>>>0){c[s>>2]=K+1;na=d[K>>0]|0}else na=R1(e)|0}while((r1(na)|0)!=0);if(!(c[t>>2]|0))oa=c[s>>2]|0;else{J=(c[s>>2]|0)+-1|0;c[s>>2]=J;oa=J}ga=(c[u>>2]|0)+F+oa-(c[v>>2]|0)|0;ha=V}}Q1(e,ha);J=c[s>>2]|0;K=c[t>>2]|0;if(J>>>0<K>>>0){c[s>>2]=J+1;pa=K}else{if((R1(e)|0)<0){ba=X;ca=D;da=Z;ea=_;fa=154;break b}pa=c[t>>2]|0}if(pa)c[s>>2]=(c[s>>2]|0)+-1;f:do switch(P|0){case 91:case 99:case 115:{K=(P|0)==99;g:do if((P&239|0)==99){$4(n|0,-1,257)|0;a[n>>0]=0;if((P|0)==115){a[x>>0]=0;a[w>>0]=0;a[w+1>>0]=0;a[w+2>>0]=0;a[w+3>>0]=0;a[w+4>>0]=0;qa=$}else qa=$}else{J=$+1|0;N=(a[J>>0]|0)==94;R=N&1;S=N?$+2|0:J;$4(n|0,N&1|0,257)|0;a[n>>0]=0;switch(a[S>>0]|0){case 45:{N=(R^1)&255;a[z>>0]=N;ra=N;sa=S+1|0;break}case 93:{N=(R^1)&255;a[A>>0]=N;ra=N;sa=S+1|0;break}default:{ra=(R^1)&255;sa=S}}S=sa;while(1){R=a[S>>0]|0;h:do switch(R<<24>>24){case 0:{ba=X;ca=D;da=Z;ea=_;fa=154;break b;break}case 93:{qa=S;break g;break}case 45:{N=S+1|0;J=a[N>>0]|0;switch(J<<24>>24){case 93:case 0:{ta=45;ua=S;break h;break}default:{}}va=a[S+-1>>0]|0;if((va&255)<(J&255)){wa=va&255;do{wa=wa+1|0;a[n+wa>>0]=ra;va=a[N>>0]|0}while((wa|0)<(va&255|0));ta=va;ua=N}else{ta=J;ua=N}break}default:{ta=R;ua=S}}while(0);a[n+((ta&255)+1)>>0]=ra;S=ua+1|0}}while(0);S=K?ha+1|0:31;R=(O|0)==1;wa=(X|0)!=0;i:do if(R){if(wa){va=N4(S<<2)|0;if(!va){ba=X;ca=D;da=0;ea=va;fa=154;break b}else xa=va}else xa=L;c[m>>2]=0;c[y>>2]=0;va=0;ya=S;za=xa;j:while(1){Aa=(za|0)==0;Ba=va;while(1){k:while(1){Ca=c[s>>2]|0;if(Ca>>>0<(c[t>>2]|0)>>>0){c[s>>2]=Ca+1;Da=d[Ca>>0]|0}else Da=R1(e)|0;if(!(a[n+(Da+1)>>0]|0)){Ea=Ba;Fa=za;break j}a[p>>0]=Da;switch(l2(o,p,1,m)|0){case -1:{ba=X;ca=D;da=0;ea=za;fa=154;break b;break}case -2:break;default:break k}}if(Aa)Ga=Ba;else{c[za+(Ba<<2)>>2]=c[o>>2];Ga=Ba+1|0}if(wa&(Ga|0)==(ya|0))break;else Ba=Ga}Ba=ya<<1|1;Aa=Q4(za,Ba<<2)|0;if(!Aa){ba=X;ca=D;da=0;ea=za;fa=154;break b}else{N=ya;ya=Ba;za=Aa;va=N}}if(!(m2(m)|0)){ba=X;ca=D;da=0;ea=Fa;fa=154;break b}else{Ha=Ea;Ia=0;Ja=Fa}}else{if(wa){va=N4(S)|0;if(!va){ba=X;ca=D;da=0;ea=0;fa=154;break b}else{Ka=0;La=S;Ma=va}while(1){va=Ka;do{za=c[s>>2]|0;if(za>>>0<(c[t>>2]|0)>>>0){c[s>>2]=za+1;Na=d[za>>0]|0}else Na=R1(e)|0;if(!(a[n+(Na+1)>>0]|0)){Ha=va;Ia=Ma;Ja=0;break i}a[Ma+va>>0]=Na;va=va+1|0}while((va|0)!=(La|0));va=La<<1|1;za=Q4(Ma,va)|0;if(!za){ba=X;ca=D;da=Ma;ea=0;fa=154;break b}else{ya=La;La=va;Ma=za;Ka=ya}}}if(!L){ya=pa;while(1){za=c[s>>2]|0;if(za>>>0<ya>>>0){c[s>>2]=za+1;Oa=d[za>>0]|0}else Oa=R1(e)|0;if(!(a[n+(Oa+1)>>0]|0)){Ha=0;Ia=0;Ja=0;break i}ya=c[t>>2]|0}}else{ya=pa;za=0;while(1){va=c[s>>2]|0;if(va>>>0<ya>>>0){c[s>>2]=va+1;Pa=d[va>>0]|0}else Pa=R1(e)|0;if(!(a[n+(Pa+1)>>0]|0)){Ha=za;Ia=L;Ja=0;break i}a[L+za>>0]=Pa;ya=c[t>>2]|0;za=za+1|0}}}while(0);if(!(c[t>>2]|0))Qa=c[s>>2]|0;else{S=(c[s>>2]|0)+-1|0;c[s>>2]=S;Qa=S}S=Qa-(c[v>>2]|0)+(c[u>>2]|0)|0;if(!S){Ra=X;Sa=D;Ta=Ia;Ua=Ja;break b}if(!((S|0)==(ha|0)|K^1)){Ra=X;Sa=D;Ta=Ia;Ua=Ja;break b}do if(wa)if(R){c[L>>2]=Ja;break}else{c[L>>2]=Ia;break}while(0);if(K){Va=qa;Wa=Ia;Xa=Ja}else{if(Ja)c[Ja+(Ha<<2)>>2]=0;if(!Ia){Va=qa;Wa=0;Xa=Ja;break f}a[Ia+Ha>>0]=0;Va=qa;Wa=Ia;Xa=Ja}break}case 120:case 88:case 112:{Ya=16;fa=136;break}case 111:{Ya=8;fa=136;break}case 117:case 100:{Ya=10;fa=136;break}case 105:{Ya=0;fa=136;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{Za=+N1(e,O,0);if((c[u>>2]|0)==((c[v>>2]|0)-(c[s>>2]|0)|0)){Ra=X;Sa=D;Ta=Z;Ua=_;break b}if(!L){Va=$;Wa=Z;Xa=_}else switch(O|0){case 0:{g[L>>2]=Za;Va=$;Wa=Z;Xa=_;break f;break}case 1:{h[L>>3]=Za;Va=$;Wa=Z;Xa=_;break f;break}case 2:{h[L>>3]=Za;Va=$;Wa=Z;Xa=_;break f;break}default:{Va=$;Wa=Z;Xa=_;break f}}break}default:{Va=$;Wa=Z;Xa=_}}while(0);l:do if((fa|0)==136){fa=0;R=O1(e,Ya,0,-1,-1)|0;if((c[u>>2]|0)==((c[v>>2]|0)-(c[s>>2]|0)|0)){Ra=X;Sa=D;Ta=Z;Ua=_;break b}if((L|0)!=0&(P|0)==112){c[L>>2]=R;Va=$;Wa=Z;Xa=_;break}if(!L){Va=$;Wa=Z;Xa=_}else switch(O|0){case -2:{a[L>>0]=R;Va=$;Wa=Z;Xa=_;break l;break}case -1:{b[L>>1]=R;Va=$;Wa=Z;Xa=_;break l;break}case 0:{c[L>>2]=R;Va=$;Wa=Z;Xa=_;break l;break}case 1:{c[L>>2]=R;Va=$;Wa=Z;Xa=_;break l;break}case 3:{wa=L;c[wa>>2]=R;c[wa+4>>2]=C;Va=$;Wa=Z;Xa=_;break l;break}default:{Va=$;Wa=Z;Xa=_;break l}}}while(0);ia=((L|0)!=0&1)+D|0;ja=Va;ka=(c[u>>2]|0)+ga+(c[s>>2]|0)-(c[v>>2]|0)|0;la=Wa;ma=Xa;break c}while(0);O=E+(I&1)|0;Q1(e,0);P=c[s>>2]|0;if(P>>>0<(c[t>>2]|0)>>>0){c[s>>2]=P+1;_a=d[P>>0]|0}else _a=R1(e)|0;if((_a|0)!=(d[O>>0]|0)){$a=_a;ab=D;bb=G;cb=H;fa=22;break b}ia=D;ja=O;ka=F+1|0;la=G;ma=H}else{O=E;while(1){P=O+1|0;if(!(r1(d[P>>0]|0)|0)){db=O;break}else O=P}Q1(e,0);do{O=c[s>>2]|0;if(O>>>0<(c[t>>2]|0)>>>0){c[s>>2]=O+1;eb=d[O>>0]|0}else eb=R1(e)|0}while((r1(eb)|0)!=0);if(!(c[t>>2]|0))fb=c[s>>2]|0;else{O=(c[s>>2]|0)+-1|0;c[s>>2]=O;fb=O}ia=D;ja=db;ka=(c[u>>2]|0)+F+fb-(c[v>>2]|0)|0;la=G;ma=H}while(0);E=ja+1|0;B=a[E>>0]|0;if(!(B<<24>>24)){gb=ia;break a}else{D=ia;F=ka;G=la;H=ma}}if((fa|0)==22){if(c[t>>2]|0)c[s>>2]=(c[s>>2]|0)+-1;if((ab|0)!=0|($a|0)>-1){gb=ab;break}else{hb=0;ib=bb;jb=cb;fa=155}}else if((fa|0)==154)if(!ca){hb=ba;ib=da;jb=ea;fa=155}else{Ra=ba;Sa=ca;Ta=da;Ua=ea}if((fa|0)==155){Ra=hb;Sa=-1;Ta=ib;Ua=jb}if(!Ra)gb=Sa;else{O4(Ta);O4(Ua);gb=Sa}}else gb=0;while(0);if(q)G2(e);i=k;return gb|0}function q3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+128|0;h=g+112|0;j=g;k=j;l=99396;m=k+112|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));if((d+-1|0)>>>0>2147483646)if(!d){n=h;o=1;p=4}else{c[(L1()|0)>>2]=75;q=-1}else{n=b;o=d;p=4}if((p|0)==4){p=-2-n|0;d=o>>>0>p>>>0?p:o;c[j+48>>2]=d;o=j+20|0;c[o>>2]=n;c[j+44>>2]=n;p=n+d|0;n=j+16|0;c[n>>2]=p;c[j+28>>2]=p;p=o3(j,e,f)|0;if(!d)q=p;else{d=c[o>>2]|0;a[d+(((d|0)==(c[n>>2]|0))<<31>>31)>>0]=0;q=p}}i=g;return q|0}function r3(a,b,c){a=a|0;b=b|0;c=c|0;return q3(a,2147483647,b,c)|0}function s3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+112|0;f=e;g=f;h=g+112|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));c[f+32>>2]=45;c[f+44>>2]=a;c[f+76>>2]=-1;c[f+84>>2]=a;a=p3(f,b,d)|0;i=e;return a|0}function t3(a){a=a|0;return +(+x3(a,0))}function u3(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;c=b;while(1){b=c+1|0;if(!(r1(a[c>>0]|0)|0)){d=c;e=b;break}else c=b}c=a[d>>0]|0;switch(c<<24>>24|0){case 45:{f=1;g=5;break}case 43:{f=0;g=5;break}default:{h=d;i=c;j=0}}if((g|0)==5){h=e;i=a[e>>0]|0;j=f}f=(i<<24>>24)+-48|0;if(f>>>0<10){i=h;h=f;f=0;while(1){i=i+1|0;e=(f*10|0)-h|0;h=(a[i>>0]|0)+-48|0;if(h>>>0>=10){k=e;break}else f=e}}else k=0;return ((j|0)!=0?k:0-k|0)|0}function v3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;a:do if(!c)f=0;else{g=b;h=c;while(1){i=h>>>1;j=g+(_(i,d)|0)|0;k=Ob[e&127](a,j)|0;if(!k){f=j;break a}if((h|0)==1){f=0;break a}l=(k|0)<0;h=l?i:h-i|0;if(!h){f=0;break}else g=l?g:j}}while(0);return f|0}function w3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;f=i;i=i+208|0;g=f+8|0;h=f;j=_(d,b)|0;b=h;c[b>>2]=1;c[b+4>>2]=0;if(j){b=0-d|0;c[g+4>>2]=d;c[g>>2]=d;k=d;l=d;m=2;while(1){n=l+d+k|0;c[g+(m<<2)>>2]=n;if(n>>>0<j>>>0){o=k;k=n;m=m+1|0;l=o}else break}l=a+j+b|0;j=h+4|0;if(l>>>0>a>>>0){m=l;k=1;o=a;n=1;while(1){do if((k&3|0)==3){w4(o,d,e,n,g);p=c[j>>2]|0;q=p<<30|(c[h>>2]|0)>>>2;c[h>>2]=q;c[j>>2]=p>>>2;r=q;s=n+2|0}else{q=n+-1|0;if((c[g+(q<<2)>>2]|0)>>>0<(m-o|0)>>>0)w4(o,d,e,n,g);else x4(o,d,e,h,n,0,g);if((n|0)==1){p=c[h>>2]|0;c[j>>2]=p>>>31|c[j>>2]<<1;t=p<<1;c[h>>2]=t;r=t;s=0;break}if(q>>>0>31){t=c[h>>2]|0;c[j>>2]=t;c[h>>2]=0;u=n+-33|0;v=t;w=0}else{u=q;v=c[j>>2]|0;w=c[h>>2]|0}c[j>>2]=w>>>(32-u|0)|v<<u;q=w<<u;c[h>>2]=q;r=q;s=1}while(0);k=r|1;c[h>>2]=k;q=o+d|0;if(q>>>0>=l>>>0){x=q;y=s;break}else{o=q;n=s}}}else{x=a;y=1}x4(x,d,e,h,y,0,g);a=h+4|0;s=c[h>>2]|0;n=c[a>>2]|0;o=(n|0)==0;if(!((y|0)==1&(s|0)==1&o)){l=o;o=s;s=n;n=x;x=y;while(1){if((x|0)<2){y=o+-1|0;do if(y){if(!(y&1)){k=y;r=0;while(1){u=r+1|0;k=k>>>1;if(k&1){z=u;break}else r=u}}else{if(l)A=32;else{if(!(s&1)){B=s;C=0}else{D=0;E=o;F=s;G=0;break}while(1){r=C+1|0;B=B>>>1;if(B&1){A=r;break}else C=r}}z=A+32|0}if(z>>>0>31){H=z;I=28}else{D=z;E=o;F=s;G=z}}else{H=32;I=28}while(0);if((I|0)==28){I=0;c[h>>2]=s;c[j>>2]=0;D=H+-32|0;E=s;F=0;G=H}c[h>>2]=F<<32-D|E>>>D;c[j>>2]=F>>>D;J=n+b|0;K=G+x|0}else{y=o>>>30;r=x+-2|0;c[h>>2]=(o<<1&2147483646|y<<31)^3;c[j>>2]=(y|s<<2)>>>1;x4(n+(0-(c[g+(r<<2)>>2]|0))+b|0,d,e,h,x+-1|0,1,g);y=c[h>>2]|0;c[j>>2]=y>>>31|c[j>>2]<<1;c[h>>2]=y<<1|1;y=n+b|0;x4(y,d,e,h,r,1,g);J=y;K=r}o=c[h>>2]|0;s=c[a>>2]|0;l=(s|0)==0;if((K|0)==1&(o|0)==1&l)break;else{n=J;x=K}}}}i=f;return}function x3(a,b){a=a|0;b=b|0;return +(+y4(a,b,1))}function y3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=z4(a,b,c,-1,0)|0;return d|0}function z3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=z4(a,b,c,-2147483648,0)|0;return d|0}function A3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=d&255;g=(e|0)!=0;a:do if(g&(b&3|0)!=0){h=d&255;i=e;j=b;while(1){if((a[j>>0]|0)==h<<24>>24){k=i;l=j;m=6;break a}n=j+1|0;o=i+-1|0;p=(o|0)!=0;if(p&(n&3|0)!=0){i=o;j=n}else{q=o;r=p;s=n;m=5;break}}}else{q=e;r=g;s=b;m=5}while(0);if((m|0)==5)if(r){k=q;l=s;m=6}else{t=0;u=s}b:do if((m|0)==6){s=d&255;if((a[l>>0]|0)==s<<24>>24){t=k;u=l}else{q=_(f,16843009)|0;c:do if(k>>>0>3){r=k;b=l;while(1){g=c[b>>2]^q;if((g&-2139062144^-2139062144)&g+-16843009){v=r;w=b;break}g=b+4|0;e=r+-4|0;if(e>>>0>3){r=e;b=g}else{x=e;y=g;m=11;break c}}z=v;A=w}else{x=k;y=l;m=11}while(0);if((m|0)==11)if(!x){t=0;u=y;break}else{z=x;A=y}while(1){if((a[A>>0]|0)==s<<24>>24){t=z;u=A;break b}q=A+1|0;z=z+-1|0;if(!z){t=0;u=q;break}else A=q}}}while(0);return ((t|0)!=0?u:0)|0}function B3(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;a:do if(!d)e=0;else{f=d;g=b;h=c;while(1){i=a[g>>0]|0;j=a[h>>0]|0;if(i<<24>>24!=j<<24>>24){k=i;l=j;break}f=f+-1|0;if(!f){e=0;break a}else{g=g+1|0;h=h+1|0}}e=(k&255)-(l&255)|0}while(0);return e|0}function C3(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;e=c&255;c=d;while(1){if(!c){f=0;break}c=c+-1|0;d=b+c|0;if((a[d>>0]|0)==e<<24>>24){f=d;break}}return f|0}function D3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=d;a:do if(!((e^b)&3)){if(!(e&3)){f=d;g=b}else{h=b;i=d;while(1){j=a[i>>0]|0;a[h>>0]=j;if(!(j<<24>>24)){k=h;break a}j=i+1|0;l=h+1|0;if(!(j&3)){f=j;g=l;break}else{h=l;i=j}}}i=c[f>>2]|0;if(!((i&-2139062144^-2139062144)&i+-16843009)){h=i;i=g;j=f;while(1){l=j+4|0;m=i+4|0;c[i>>2]=h;h=c[l>>2]|0;if((h&-2139062144^-2139062144)&h+-16843009){n=m;o=l;break}else{i=m;j=l}}}else{n=g;o=f}p=o;q=n;r=8}else{p=d;q=b;r=8}while(0);if((r|0)==8){r=a[p>>0]|0;a[q>>0]=r;if(!(r<<24>>24))k=q;else{r=q;q=p;while(1){q=q+1|0;p=r+1|0;b=a[q>>0]|0;a[p>>0]=b;if(!(b<<24>>24)){k=p;break}else r=p}}}return k|0}function E3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;f=d;do if(!((f^b)&3)){g=(e|0)!=0;a:do if(g&(f&3|0)!=0){h=e;i=d;j=b;while(1){k=a[i>>0]|0;a[j>>0]=k;if(!(k<<24>>24)){l=h;m=i;n=j;break a}k=h+-1|0;o=i+1|0;p=j+1|0;q=(k|0)!=0;if(q&(o&3|0)!=0){h=k;i=o;j=p}else{r=k;s=o;t=p;u=q;v=5;break}}}else{r=e;s=d;t=b;u=g;v=5}while(0);if((v|0)==5)if(u){l=r;m=s;n=t}else{w=t;x=0;break}if(!(a[m>>0]|0)){w=n;x=l}else{b:do if(l>>>0>3){g=l;j=n;i=m;while(1){h=c[i>>2]|0;if((h&-2139062144^-2139062144)&h+-16843009){y=g;z=j;A=i;break b}c[j>>2]=h;h=g+-4|0;q=i+4|0;p=j+4|0;if(h>>>0>3){g=h;j=p;i=q}else{y=h;z=p;A=q;break}}}else{y=l;z=n;A=m}while(0);B=A;C=z;D=y;v=11}}else{B=d;C=b;D=e;v=11}while(0);c:do if((v|0)==11)if(!D){w=C;x=0}else{e=B;b=C;d=D;while(1){y=a[e>>0]|0;a[b>>0]=y;if(!(y<<24>>24)){w=b;x=d;break c}d=d+-1|0;y=b+1|0;if(!d){w=y;x=0;break}else{e=e+1|0;b=y}}}while(0);$4(w|0,0,x|0)|0;return w|0}function F3(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;e=a[b>>0]|0;a:do if(!(e<<24>>24)){f=0;g=c}else{h=e;i=e&255;j=b;k=c;while(1){l=a[k>>0]|0;if(!(l<<24>>24)){f=h;g=k;break a}if(h<<24>>24!=l<<24>>24?(l=H1(i)|0,(l|0)!=(H1(d[k>>0]|0)|0)):0){m=j;n=k;break}j=j+1|0;l=k+1|0;o=a[j>>0]|0;if(!(o<<24>>24)){f=0;g=l;break a}else{h=o;i=o&255;k=l}}f=a[m>>0]|0;g=n}while(0);n=H1(f&255)|0;return n-(H1(d[g>>0]|0)|0)|0}function G3(a,b){a=a|0;b=b|0;K3(a+(N3(a)|0)|0,b)|0;return a|0}function H3(b,c){b=b|0;c=c|0;var d=0;d=I3(b,c)|0;return ((a[d>>0]|0)==(c&255)<<24>>24?d:0)|0}function I3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=d&255;a:do if(!e)f=b+(N3(b)|0)|0;else{if(!(b&3))g=b;else{h=d&255;i=b;while(1){j=a[i>>0]|0;if(j<<24>>24==0?1:j<<24>>24==h<<24>>24){f=i;break a}j=i+1|0;if(!(j&3)){g=j;break}else i=j}}i=_(e,16843009)|0;h=c[g>>2]|0;b:do if(!((h&-2139062144^-2139062144)&h+-16843009)){j=h;k=g;while(1){l=j^i;if((l&-2139062144^-2139062144)&l+-16843009){m=k;break b}l=k+4|0;j=c[l>>2]|0;if((j&-2139062144^-2139062144)&j+-16843009){m=l;break}else k=l}}else m=g;while(0);i=d&255;h=m;while(1){k=a[h>>0]|0;if(k<<24>>24==0?1:k<<24>>24==i<<24>>24){f=h;break}else h=h+1|0}}while(0);return f|0}function J3(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=a[b>>0]|0;e=a[c>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=e<<24>>24){f=d;g=e}else{e=b;b=c;do{e=e+1|0;b=b+1|0;c=a[e>>0]|0;d=a[b>>0]|0}while(!(c<<24>>24==0?1:c<<24>>24!=d<<24>>24));f=c;g=d}return (f&255)-(g&255)|0}function K3(a,b){a=a|0;b=b|0;D3(a,b)|0;return a|0}function L3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e;g=a[d>>0]|0;if(g<<24>>24!=0?(a[d+1>>0]|0)!=0:0){c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;h=d;d=g;do{j=f+(((d&255)>>>5&255)<<2)|0;c[j>>2]=c[j>>2]|1<<(d&31);h=h+1|0;d=a[h>>0]|0}while(d<<24>>24!=0);d=a[b>>0]|0;a:do if(!(d<<24>>24))k=b;else{h=b;j=d;while(1){if(c[f+(((j&255)>>>5&255)<<2)>>2]&1<<(j&31)){k=h;break a}l=h+1|0;j=a[l>>0]|0;if(!(j<<24>>24)){k=l;break}else h=l}}while(0);m=k-b|0}else m=(I3(b,g<<24>>24)|0)-b|0;i=e;return m|0}function M3(a){a=a|0;var b=0,c=0,d=0;b=(N3(a)|0)+1|0;c=N4(b)|0;if(!c)d=0;else{Z4(c|0,a|0,b|0)|0;d=c}return d|0}function N3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=b;a:do if(!(d&3)){e=b;f=4}else{g=b;h=d;while(1){if(!(a[g>>0]|0)){i=h;break a}j=g+1|0;h=j;if(!(h&3)){e=j;f=4;break}else g=j}}while(0);if((f|0)==4){f=e;while(1){e=c[f>>2]|0;if(!((e&-2139062144^-2139062144)&e+-16843009))f=f+4|0;else{k=e;l=f;break}}if(!((k&255)<<24>>24))m=l;else{k=l;while(1){l=k+1|0;if(!(a[l>>0]|0)){m=l;break}else k=l}}i=m}return i-d|0}function O3(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if(!e)f=0;else{g=a[b>>0]|0;a:do if(!(g<<24>>24)){h=0;i=c}else{j=e;k=g;l=g&255;m=b;n=c;while(1){j=j+-1|0;o=a[n>>0]|0;if(!((j|0)!=0&o<<24>>24!=0)){h=k;i=n;break a}if(k<<24>>24!=o<<24>>24?(o=H1(l)|0,(o|0)!=(H1(d[n>>0]|0)|0)):0){p=m;q=n;break}m=m+1|0;o=n+1|0;r=a[m>>0]|0;if(!(r<<24>>24)){h=0;i=o;break a}else{k=r;l=r&255;n=o}}h=a[p>>0]|0;i=q}while(0);q=H1(h&255)|0;f=q-(H1(d[i>>0]|0)|0)|0}return f|0}function P3(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;if(!e)f=0;else{g=a[b>>0]|0;a:do if(!(g<<24>>24)){h=0;i=c}else{j=e;k=g;l=b;m=c;while(1){j=j+-1|0;n=a[m>>0]|0;if(!(k<<24>>24==n<<24>>24&((j|0)!=0&n<<24>>24!=0))){h=k;i=m;break a}l=l+1|0;n=m+1|0;k=a[l>>0]|0;if(!(k<<24>>24)){h=0;i=n;break}else m=n}}while(0);f=(h&255)-(d[i>>0]|0)|0}return f|0}function Q3(a,b,c){a=a|0;b=b|0;c=c|0;E3(a,b,c)|0;return a|0}function R3(b,c){b=b|0;c=c|0;var d=0;d=b+(L3(b,c)|0)|0;return ((a[d>>0]|0)!=0?d:0)|0}function S3(a,b){a=a|0;b=b|0;return C3(a,b,(N3(a)|0)+1|0)|0}function T3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+32|0;f=e;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;g=a[d>>0]|0;do if(!(g<<24>>24))h=0;else{if(!(a[d+1>>0]|0)){j=b;while(1)if((a[j>>0]|0)==g<<24>>24)j=j+1|0;else{k=j;break}h=k-b|0;break}else{l=d;m=g}do{j=f+(((m&255)>>>5&255)<<2)|0;c[j>>2]=c[j>>2]|1<<(m&31);l=l+1|0;m=a[l>>0]|0}while(m<<24>>24!=0);j=a[b>>0]|0;a:do if(!(j<<24>>24))n=b;else{o=b;p=j;while(1){if(!(c[f+(((p&255)>>>5&255)<<2)>>2]&1<<(p&31))){n=o;break a}q=o+1|0;p=a[q>>0]|0;if(!(p<<24>>24)){n=q;break}else o=q}}while(0);h=n-b|0}while(0);i=e;return h|0}function U3(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+1056|0;g=f+1024|0;h=f;j=a[e>>0]|0;do if(j<<24>>24){k=H3(b,j<<24>>24)|0;if(k){l=a[e+1>>0]|0;if(l<<24>>24){m=k+1|0;n=a[m>>0]|0;if(n<<24>>24){o=a[e+2>>0]|0;if(!(o<<24>>24)){p=l&255|(j&255)<<8;q=m;m=n;r=d[k>>0]<<8|n&255;while(1){s=r&65535;if((s|0)==(p|0)){t=q;u=m;break}v=q+1|0;w=a[v>>0]|0;if(!(w<<24>>24)){t=v;u=0;break}else{q=v;m=w;r=w&255|s<<8}}x=u<<24>>24!=0?t+-1|0:0;break}r=k+2|0;m=a[r>>0]|0;if(m<<24>>24){q=a[e+3>>0]|0;if(!(q<<24>>24)){p=(l&255)<<16|(j&255)<<24|(o&255)<<8;s=(m&255)<<8|(n&255)<<16|d[k>>0]<<24;if((s|0)==(p|0)){y=r;z=m}else{w=r;r=s;while(1){s=w+1|0;v=a[s>>0]|0;r=(v&255|r)<<8;if(v<<24>>24==0|(r|0)==(p|0)){y=s;z=v;break}else w=s}}x=z<<24>>24!=0?y+-2|0:0;break}w=k+3|0;p=a[w>>0]|0;if(p<<24>>24){if(!(a[e+4>>0]|0)){r=(l&255)<<16|(j&255)<<24|(o&255)<<8|q&255;s=(m&255)<<8|(n&255)<<16|p&255|d[k>>0]<<24;if((s|0)==(r|0)){A=w;B=p}else{p=w;w=s;while(1){s=p+1|0;v=a[s>>0]|0;w=v&255|w<<8;if(v<<24>>24==0|(w|0)==(r|0)){A=s;B=v;break}else p=s}}x=B<<24>>24!=0?A+-3|0:0;break};c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[g+24>>2]=0;c[g+28>>2]=0;p=j;r=0;while(1){if(!(a[k+r>>0]|0)){C=0;break}w=g+(((p&255)>>>5&255)<<2)|0;c[w>>2]=c[w>>2]|1<<(p&31);w=r+1|0;c[h+((p&255)<<2)>>2]=w;p=a[e+w>>0]|0;if(!(p<<24>>24)){D=w;E=r;F=23;break}else r=w}a:do if((F|0)==23){b:do if(D>>>0>1){r=1;p=-1;w=0;c:while(1){n=r;m=w;q=1;while(1){o=n;l=m;d:while(1){s=o;v=1;while(1){G=a[e+(v+p)>>0]|0;H=a[e+s>>0]|0;if(G<<24>>24!=H<<24>>24){I=s;J=G;K=H;L=l;break d}if((v|0)==(q|0))break;v=v+1|0;s=v+l|0;if(s>>>0>=D>>>0){M=p;N=q;break c}}l=l+q|0;o=l+1|0;if(o>>>0>=D>>>0){M=p;N=q;break c}}o=I-p|0;if((J&255)<=(K&255)){O=L;break}l=I+1|0;if(l>>>0<D>>>0){n=l;m=I;q=o}else{M=p;N=o;break c}}r=O+2|0;if(r>>>0>=D>>>0){M=O;N=1;break}else{p=O;w=O+1|0}}w=1;p=-1;r=0;while(1){q=w;m=r;n=1;while(1){o=q;l=m;e:while(1){s=o;v=1;while(1){H=a[e+(v+p)>>0]|0;G=a[e+s>>0]|0;if(H<<24>>24!=G<<24>>24){P=s;Q=H;R=G;S=l;break e}if((v|0)==(n|0))break;v=v+1|0;s=v+l|0;if(s>>>0>=D>>>0){T=M;U=p;V=N;W=n;break b}}l=l+n|0;o=l+1|0;if(o>>>0>=D>>>0){T=M;U=p;V=N;W=n;break b}}o=P-p|0;if((Q&255)>=(R&255)){X=S;break}l=P+1|0;if(l>>>0<D>>>0){q=l;m=P;n=o}else{T=M;U=p;V=N;W=o;break b}}w=X+2|0;if(w>>>0>=D>>>0){T=M;U=X;V=N;W=1;break}else{p=X;r=X+1|0}}}else{T=-1;U=-1;V=1;W=1}while(0);r=(U+1|0)>>>0>(T+1|0)>>>0;p=r?W:V;w=r?U:T;r=w+1|0;if(!(B3(e,e+p|0,r)|0)){Y=D-p|0;Z=p}else{p=D-w+-1|0;Y=0;Z=(w>>>0>p>>>0?w:p)+1|0}p=D|63;n=(Y|0)!=0;m=D-Z|0;q=k;o=0;l=k;f:while(1){s=q;do if((l-s|0)>>>0<D>>>0){v=A3(l,0,p)|0;if(v)if((v-s|0)>>>0<D>>>0){C=0;break a}else{_=v;break}else{_=l+p|0;break}}else _=l;while(0);s=a[q+E>>0]|0;if(!(1<<(s&31)&c[g+(((s&255)>>>5&255)<<2)>>2])){q=q+D|0;o=0;l=_;continue}v=c[h+((s&255)<<2)>>2]|0;s=D-v|0;if((D|0)!=(v|0)){q=q+(n&(o|0)!=0&s>>>0<Z>>>0?m:s)|0;o=0;l=_;continue}s=r>>>0>o>>>0?r:o;v=a[e+s>>0]|0;g:do if(!(v<<24>>24))$=r;else{G=v;H=s;while(1){if(G<<24>>24!=(a[q+H>>0]|0)){aa=H;break}H=H+1|0;G=a[e+H>>0]|0;if(!(G<<24>>24)){$=r;break g}}q=q+(aa-w)|0;o=0;l=_;continue f}while(0);do{if($>>>0<=o>>>0){C=q;break a}$=$+-1|0}while((a[e+$>>0]|0)==(a[q+$>>0]|0));q=q+Z|0;o=Y;l=_}}while(0);x=C}else x=0}else x=0}else x=0}else x=k}else x=0}else x=b;while(0);i=f;return x|0}function V3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;if(!b){e=c[24877]|0;if(!e)f=0;else{g=e;h=3}}else{g=b;h=3}do if((h|0)==3){b=g+(T3(g,d)|0)|0;if(!(a[b>>0]|0)){c[24877]=0;f=0;break}e=b+(L3(b,d)|0)|0;c[24877]=e;if(!(a[e>>0]|0)){c[24877]=0;f=b;break}else{c[24877]=e+1;a[e>>0]=0;f=b;break}}while(0);return f|0}function W3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(!b){f=c[e>>2]|0;if(!f)g=0;else{h=f;i=3}}else{h=b;i=3}do if((i|0)==3){b=h+(T3(h,d)|0)|0;if(!(a[b>>0]|0)){c[e>>2]=0;g=0;break}f=b+(L3(b,d)|0)|0;c[e>>2]=f;if(!(a[f>>0]|0)){c[e>>2]=0;g=b;break}else{c[e>>2]=f+1;a[f>>0]=0;g=b;break}}while(0);return g|0}function X3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;if(!b)d=a+((Y3(a)|0)<<2)|0;else{e=a;while(1){a=c[e>>2]|0;if((a|0)==0|(a|0)==(b|0)){f=e;g=a;break}else e=e+4|0}d=(g|0)!=0?f:0}return d|0}function Y3(a){a=a|0;var b=0,d=0;b=a;while(1)if(!(c[b>>2]|0)){d=b;break}else b=b+4|0;return d-a>>2|0}function Z3(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=a;c[e+4>>2]=b;b=S1(gb(33,e|0)|0)|0;i=d;return b|0}function _3(){var a=0,b=0;a=i;i=i+16|0;b=Ka(20,a|0)|0;i=a;return b|0}function $3(c,f){c=c|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=(f<<1)+-1|0;h=f+-1|0;a:do if(!((c+-43008|0)>>>0<22272|((c+-11776|0)>>>0<30784|((c+-1536|0)>>>0<2560|(u1(c)|0)==0)))){i=(f|0)!=0;if(i&(c+-4256|0)>>>0<46){if((c|0)>4293)switch(c|0){case 4295:case 4301:break;default:{j=c;break a}}j=c+7264|0;break}if((c+-11520|0)>>>0<38&(i^1)){if((c|0)>11557)switch(c|0){case 11559:case 11565:break;default:{j=c;break a}}j=c+-7264|0;break}else k=0;do{i=a[104528+(k<<2)+2>>0]|0;l=i<<24>>24;m=c-(e[104528+(k<<2)>>1]|0)|0;if((m-(l&h)|0)>>>0<(d[104528+(k<<2)+3>>0]|0)>>>0){n=i;o=l;p=m;q=13;break}k=k+1|0}while((k|0)!=61);if((q|0)==13)if(n<<24>>24==1){j=f+c-(p&1)|0;break}else{j=(_(o,g)|0)+c|0;break}m=1-f|0;l=b[104036+(m<<1)>>1]|0;b:do if(l<<16>>16){i=l;r=0;while(1){if((i&65535|0)==(c|0)){s=r;break}r=r+1|0;i=b[104036+(r<<2)+(m<<1)>>1]|0;if(!(i<<16>>16))break b}j=e[104036+(s<<2)+(f<<1)>>1]|0;break a}while(0);if((c+-66600+(f*40|0)|0)>>>0<40)j=c+-40+(f*80|0)|0;else j=c}else j=c;while(0);return j|0}function a4(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=a+4|0;f=c[e>>2]|0;g=a+100|0;if(f>>>0<(c[g>>2]|0)>>>0){c[e>>2]=f+1;h=d[f>>0]|0}else h=R1(a)|0;switch(h|0){case 43:case 45:{f=(h|0)==45&1;i=c[e>>2]|0;if(i>>>0<(c[g>>2]|0)>>>0){c[e>>2]=i+1;j=d[i>>0]|0}else j=R1(a)|0;if((b|0)!=0&(j+-48|0)>>>0>9?(c[g>>2]|0)!=0:0){c[e>>2]=(c[e>>2]|0)+-1;k=j;l=f}else{k=j;l=f}break}default:{k=h;l=0}}if((k+-48|0)>>>0>9)if(!(c[g>>2]|0)){m=-2147483648;n=0}else{c[e>>2]=(c[e>>2]|0)+-1;m=-2147483648;n=0}else{h=k;k=0;while(1){f=h+-48+(k*10|0)|0;j=c[e>>2]|0;if(j>>>0<(c[g>>2]|0)>>>0){c[e>>2]=j+1;o=d[j>>0]|0}else o=R1(a)|0;if((o+-48|0)>>>0<10&(f|0)<214748364){h=o;k=f}else{p=f;q=o;break}}o=((p|0)<0)<<31>>31;if((q+-48|0)>>>0<10){k=p;h=o;f=q;while(1){j=g5(k|0,h|0,10,0)|0;b=C;i=V4(f|0,((f|0)<0)<<31>>31|0,-48,-1)|0;r=V4(i|0,C|0,j|0,b|0)|0;b=C;j=c[e>>2]|0;if(j>>>0<(c[g>>2]|0)>>>0){c[e>>2]=j+1;s=d[j>>0]|0}else s=R1(a)|0;if((s+-48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&r>>>0<2061584302)){k=r;h=b;f=s}else{t=r;u=b;v=s;break}}}else{t=p;u=o;v=q}if((v+-48|0)>>>0<10)do{v=c[e>>2]|0;if(v>>>0<(c[g>>2]|0)>>>0){c[e>>2]=v+1;w=d[v>>0]|0}else w=R1(a)|0}while((w+-48|0)>>>0<10);if(c[g>>2]|0)c[e>>2]=(c[e>>2]|0)+-1;e=(l|0)!=0;l=U4(0,0,t|0,u|0)|0;m=e?C:u;n=e?l:t}C=m;return n|0}function b4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0;d=i;i=i+384|0;e=d+276|0;f=d+272|0;g=d+268|0;h=d+320|0;j=d+264|0;k=d+8|0;l=d;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if(!(c[b+40>>2]|0)){p=b+20|0;c[f>>2]=c[p>>2];c[e>>2]=c[f>>2];d4(m,e)|0;c[f>>2]=2;c[e>>2]=c[f>>2];d4(m,e)|0;c[p>>2]=(c[p>>2]|0)+1}c[f>>2]=0;c[e>>2]=c[f>>2];p=d4(m,e)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do if(!((p|0)!=0|t&(s|0)>(o|0)^1)){u=m+16|0;v=b+36|0;w=b+24|0;x=b+20|0;y=b+28|0;z=e+1|0;A=e+12|0;B=e+40|0;C=e+24|0;D=e+8|0;E=s;F=0;G=0;b:while(1){H=E+-1|0;c[n>>2]=H;I=c[u>>2]|0;c:do switch(c[I+(H<<2)>>2]|0){case 0:{if((c[v>>2]&1|0)!=0?(c[f>>2]=7,c[e>>2]=c[f>>2],J=d4(m,e)|0,(J|0)!=0):0){K=F;L=G;M=J;break c}c[f>>2]=3;c[e>>2]=c[f>>2];K=F;L=G;M=d4(m,e)|0;break}case 3:{c[f>>2]=5;c[e>>2]=c[f>>2];J=d4(m,e)|0;if(!J){c[f>>2]=4;c[e>>2]=c[f>>2];K=F;L=G;M=d4(m,e)|0}else{K=F;L=G;M=J}break}case 4:{c[f>>2]=9;c[e>>2]=c[f>>2];J=d4(m,e)|0;if(!J){c[f>>2]=1;c[e>>2]=c[f>>2];K=F;L=G;M=d4(m,e)|0}else{K=F;L=G;M=J}break}case 5:{J=c[q>>2]|0;N=a[J>>0]|0;if(N<<24>>24!=0?(O=c[v>>2]&1,P=(O|0)!=0,!(N<<24>>24==124&P)):0){do if(!((F|0)>0&(N<<24>>24==41&P))){if(N<<24>>24==92&(O|0)==0?(a[J+1>>0]|0)==41:0)break;c[f>>2]=5;c[e>>2]=c[f>>2];Q=d4(m,e)|0;if(Q){K=F;L=G;M=Q;break c}c[f>>2]=G;c[e>>2]=c[f>>2];Q=d4(m,e)|0;if(Q){K=F;L=G;M=Q;break c}c[f>>2]=6;c[e>>2]=c[f>>2];Q=d4(m,e)|0;if(Q){K=F;L=G;M=Q;break c}c[f>>2]=4;c[e>>2]=c[f>>2];K=F;L=G;M=d4(m,e)|0;break c}while(0);N=(O|F|0)==0?8:0;P=F+-1|0;if(!O){c[q>>2]=J+2;K=P;L=G;M=N}else{K=P;L=G;M=N}}else{K=F;L=G;M=0}break}case 6:{N=E+-2|0;c[n>>2]=N;P=f4(c[b>>2]|0,c[I+(N<<2)>>2]|0,G)|0;if(!P){R=12;break a}K=F;L=P;M=0;break}case 7:{P=c[q>>2]|0;switch(a[P>>0]|0){case 124:break;case 41:{c[q>>2]=P+1;K=F;L=G;M=0;break c;break}default:{K=F;L=G;M=0;break c}}c[f>>2]=7;c[e>>2]=c[f>>2];P=d4(m,e)|0;if(!P){c[f>>2]=G;c[e>>2]=c[f>>2];N=d4(m,e)|0;if(!N){c[f>>2]=8;c[e>>2]=c[f>>2];Q=d4(m,e)|0;if(!Q){c[f>>2]=3;c[e>>2]=c[f>>2];S=d4(m,e)|0;if(!S){c[q>>2]=(c[q>>2]|0)+1;K=F;L=G;M=0}else{K=F;L=G;M=S}}else{K=F;L=G;M=Q}}else{K=F;L=G;M=N}}else{K=F;L=G;M=P}break}case 8:{P=E+-2|0;c[n>>2]=P;N=i4(c[b>>2]|0,c[I+(P<<2)>>2]|0,G)|0;if(!N){R=12;break a}K=F;L=N;M=0;break}case 9:{N=c[q>>2]|0;P=a[N>>0]|0;switch(P<<24>>24|0){case 63:case 43:{if(!(c[v>>2]&1)){K=F;L=G;M=0;break c}else T=38;break}case 42:{T=38;break}case 92:{Q=c[v>>2]|0;if(Q&1){K=F;L=G;M=0;break c}S=N+1|0;if((a[S>>0]|0)!=123){K=F;L=G;M=0;break c}c[q>>2]=S;U=S;V=Q;break}case 123:{Q=c[v>>2]|0;if(!(Q&1)){K=F;L=G;M=0;break c}else{U=N;V=Q}break}default:{K=F;L=G;M=0;break c}}if((T|0)==38){T=0;c[q>>2]=N+1;N=g4(c[b>>2]|0,G,P<<24>>24==43&1,P<<24>>24==63?1:-1,0)|0;if(!N){R=12;break a}c[f>>2]=9;c[e>>2]=c[f>>2];K=F;L=N;M=d4(m,e)|0;break c}N=U+1|0;c[q>>2]=N;P=a[N>>0]|0;if((P+-48&255)<10){Q=P<<24>>24;if((Q+-48|0)>>>0<10){W=Q;X=-1;Y=N}else{R=10;break a}while(1){Q=W+-48+(((X|0)<0?0:X)*10|0)|0;S=Y+1|0;Z=a[S>>0]|0;W=Z<<24>>24;if((W+-48|0)>>>0>=10){_=Z;$=Q;aa=S;break}else{X=Q;Y=S}}}else{_=P;$=-1;aa=N}if(_<<24>>24==44){J=aa+1|0;O=a[J>>0]|0;S=O<<24>>24;if((S+-48|0)>>>0<10){Q=S;S=-1;Z=J;while(1){ba=Q+-48+(((S|0)<0?0:S)*10|0)|0;ca=Z+1|0;da=a[ca>>0]|0;Q=da<<24>>24;if((Q+-48|0)>>>0>=10){ea=da;fa=ba;ga=ca;T=50;break}else{S=ba;Z=ca}}}else{ha=O;ia=-1;ja=J}}else{ea=_;fa=$;ga=aa;T=50}if((T|0)==50){T=0;if((fa|0)>-1?($|0)>(fa|0)|(fa|0)>255:0){R=10;break a}else{ha=ea;ia=fa;ja=ga}}if(!(ha<<24>>24)){R=9;break a}if((ja|0)==(N|0)){R=10;break a}if(!(V&1)){if(ha<<24>>24!=92){R=10;break a}if((a[ja+1>>0]|0)!=125){R=10;break a}ka=ja+2|0}else{if(ha<<24>>24!=125){R=10;break a}ka=ja+1|0}Z=ka;if(ia|$){S=(ia&$|0)<0;Q=g4(c[b>>2]|0,G,S?1:$,S?1:ia,0)|0;if(!Q){R=12;break a}else la=Q}else{Q=h4(c[b>>2]|0,0,20)|0;if(!Q){R=12;break a}S=c[Q+4>>2]|0;c[S>>2]=-1;c[S+4>>2]=-1;c[S+8>>2]=-1;la=Q}c[q>>2]=Z;c[f>>2]=9;c[e>>2]=c[f>>2];K=F;L=la;M=d4(m,e)|0;break}case 1:{Z=c[q>>2]|0;d:do switch(a[Z>>0]|0){case 40:{if(!(c[v>>2]&1))ma=Z;else{na=Z;T=67}break}case 91:{Q=Z+1|0;c[q>>2]=Q;S=N4(128)|0;c[j>>2]=S;if(!S){T=72;break b}if((a[Q>>0]|0)==94){S=Z+2|0;c[q>>2]=S;oa=S;pa=1}else{oa=Q;pa=0}c[e>>2]=0;c[f>>2]=32;Q=0;S=oa;P=0;e:while(1){switch(a[S>>0]|0){case 0:{qa=Q;ra=S;sa=7;break e;break}case 93:{if(S>>>0>(c[q>>2]|0)>>>0){ta=Q;ua=S;va=P;T=78;break e}break}default:{}}ca=n2(g,S,-1)|0;if((ca|0)<0){c[g>>2]=-1;wa=1}else wa=ca;ca=S+wa|0;if((a[ca>>0]|0)==45?(a[ca+1>>0]|0)!=93:0){ba=c[g>>2]|0;da=S+(wa+1)|0;xa=n2(g,da,-1)|0;if((xa|0)<0){c[g>>2]=-1;ya=-1;za=1}else{ya=c[g>>2]|0;za=xa}xa=da+za|0;if(ba>>>0>ya>>>0){Aa=3;Ba=Q;Ca=xa;Da=11}else{Ea=0;Fa=ya;Ga=ba;Ha=xa;Ia=P;T=97}}else T=87;f:do if((T|0)==87){T=0;g:do switch(a[S>>0]|0){case 91:{switch(a[S+1>>0]|0){case 61:case 46:{Aa=3;Ba=Q;Ca=S;Da=3;break f;break}case 58:break;default:{Ja=P;break g}}xa=S+2|0;ba=xa;while(1){da=a[ba>>0]|0;Ka=da<<24>>24==0;if(da<<24>>24!=58&(Ka^1))ba=ba+1|0;else break}if(Ka){La=0;Ma=S;Na=4}else{da=ba-S+-2|0;Oa=(da|0)>63?63:da;Q3(h,xa,Oa)|0;a[h+Oa>>0]=0;Oa=y1(h)|0;La=Oa;Ma=ba+2|0;Na=(Oa|0)==0?4:P}Ea=La;Fa=1114111;Ga=0;Ha=Ma;Ia=Na;T=97;break f;break}case 45:{if((a[S+1>>0]|0)==93)Ja=P;else Ja=(c[q>>2]|0)==(S|0)?P:11;break}default:Ja=P}while(0);Oa=c[g>>2]|0;Ea=0;Fa=Oa;Ga=Oa;Ha=ca;Ia=Ja;T=97}while(0);h:do if((T|0)==97){T=0;if(!Ia){if(pa&(Ea|0)!=0)if((Q|0)>63){Pa=Q;Qa=12}else{c[k+(Q<<2)>>2]=Ea;Pa=Q+1|0;Qa=0}else{ca=L4(c[b>>2]|0,Ga,Fa,e,f,j)|0;if(ca){Aa=3;Ba=Q;Ca=Ha;Da=ca;break}c[(c[(c[(c[j>>2]|0)+((c[e>>2]|0)+-1<<2)>>2]|0)+4>>2]|0)+12>>2]=Ea;Pa=Q;Qa=0}if(!((Qa|Ea|0)!=0|(c[v>>2]&2|0)==0)){ca=Ga;Oa=Qa;while(1){if(ca>>>0>Fa>>>0){Ra=Oa;break}do if(!(B1(ca)|0)){da=ca+1|0;if(!(F1(ca)|0)){Sa=da;Ta=Oa;break}Ua=K1(ca)|0;i:do if(!(F1(da)|0)){Va=Ua;Wa=da}else{Xa=Ua;Ya=da;while(1){if(Ya>>>0>Fa>>>0|(K1(Ya)|0)!=(Xa+1|0)){Va=Xa;Wa=Ya;break i}Za=Ya+1|0;_a=K1(Ya)|0;if(!(F1(Za)|0)){Va=_a;Wa=Za;break}else{Xa=_a;Ya=Za}}}while(0);Sa=Wa;Ta=L4(c[b>>2]|0,Ua,Va,e,f,j)|0}else{da=J1(ca)|0;Ya=ca+1|0;j:do if(!(B1(Ya)|0)){$a=da;ab=Ya}else{Xa=da;Za=Ya;while(1){if(Za>>>0>Fa>>>0|(J1(Za)|0)!=(Xa+1|0)){$a=Xa;ab=Za;break j}_a=J1(Za)|0;bb=Za+1|0;if(!(B1(bb)|0)){$a=_a;ab=bb;break}else{Xa=_a;Za=bb}}}while(0);Sa=ab;Ta=L4(c[b>>2]|0,da,$a,e,f,j)|0}while(0);if(!Ta){ca=Sa;Oa=0}else{Aa=3;Ba=Pa;Ca=Ha;Da=Ta;break h}}if(!Ra)cb=0;else{Aa=3;Ba=Pa;Ca=Ha;Da=Ra;break}}else cb=Qa;Aa=0;Ba=Pa;Ca=Ha;Da=cb}else{Aa=3;Ba=Q;Ca=Ha;Da=Ia}}while(0);if(!(Aa|Da)){Q=Ba;S=Ca;P=Da}else{qa=Ba;ra=Ca;sa=Da;break}}if((T|0)==78){T=0;qa=ta;ra=ua+1|0;sa=va}P=c[e>>2]|0;c[q>>2]=ra;k:do if(!sa){if(pa)w3(c[j>>2]|0,P,4,111);if((P|0)>0){S=(qa|0)>0;Q=qa<<2;Oa=Q+4|0;ca=c[j>>2]|0;ba=0;xa=0;Ya=0;Ua=0;while(1){Za=c[(c[ca+(Ya<<2)>>2]|0)+4>>2]|0;Xa=c[Za>>2]|0;bb=Za+4|0;_a=c[bb>>2]|0;do if(pa){if((Xa|0)<(ba|0)){db=_a+1|0;eb=ca;fb=(db|0)>=(ba|0)?db:ba;gb=xa;hb=Ua;ib=0;break}if((Xa|0)>(xa|0)){c[Za>>2]=xa;c[bb>>2]=Xa+-1;jb=Za}else jb=0;db=_a+1|0;kb=db;lb=db;mb=jb;T=130}else{kb=ba;lb=xa;mb=Za;T=130}while(0);do if((T|0)==130){T=0;if(mb){c[mb+8>>2]=c[w>>2];if(S){Za=B2(c[b>>2]|0,0,0,0,Oa)|0;_a=mb+16|0;c[_a>>2]=Za;if(!Za){nb=Ua;ob=12;break k}Z4(Za|0,k|0,Q|0)|0;c[(c[_a>>2]|0)+(qa<<2)>>2]=0}else c[mb+16>>2]=0;if(!Ua){_a=c[j>>2]|0;eb=_a;fb=kb;gb=lb;hb=c[_a+(Ya<<2)>>2]|0;ib=0;break}else{_a=c[j>>2]|0;Za=i4(c[b>>2]|0,Ua,c[_a+(Ya<<2)>>2]|0)|0;eb=_a;fb=kb;gb=lb;hb=Za;ib=(Za|0)==0?12:0;break}}else{eb=ca;fb=kb;gb=lb;hb=Ua;ib=0}}while(0);Ya=Ya+1|0;if(!((Ya|0)<(P|0)&(ib|0)==0)){pb=gb;qb=hb;rb=ib;break}else{ca=eb;ba=fb;xa=gb;Ua=hb}}}else{pb=0;qb=0;rb=0}if(pa&(rb|0)==0){Ua=c[w>>2]|0;xa=h4(c[b>>2]|0,0,20)|0;if(xa){ba=c[xa+4>>2]|0;c[ba>>2]=pb;c[ba+4>>2]=1114111;c[ba+8>>2]=Ua;if((qa|0)>0){Ua=qa<<2;ca=B2(c[b>>2]|0,0,0,0,Ua+4|0)|0;Ya=ba+16|0;c[Ya>>2]=ca;if(!ca){nb=qb;ob=12;break}Z4(ca|0,k|0,Ua|0)|0;c[(c[Ya>>2]|0)+(qa<<2)>>2]=0}else c[ba+16>>2]=0;if(!qb){nb=xa;ob=0}else{ba=i4(c[b>>2]|0,qb,xa)|0;nb=ba;ob=(ba|0)==0?12:0}}else{nb=qb;ob=12}}else{nb=qb;ob=rb}}else{nb=0;ob=sa}while(0);O4(c[j>>2]|0);c[w>>2]=(c[w>>2]|0)+1;if(!ob){K=F;L=nb;M=0;break c}else{R=ob;break a}break}case 92:{P=Z+1|0;ba=a[P>>0]|0;do if(!(c[v>>2]&1))if(ba<<24>>24!=40){xa=Z+1|0;Ya=a[xa>>0]|0;if(Ya<<24>>24==41){T=212;break d}else{sb=xa;tb=Ya;break}}else{c[q>>2]=P;na=P;T=67;break d}else{sb=P;tb=ba}while(0);ba=tb<<24>>24==0;if(ba){R=5;break a}else{ub=99852;vb=0}while(1){if((a[99848+(vb<<3)>>0]|0)==tb<<24>>24){wb=ub;break}vb=vb+1|0;P=99848+(vb<<3)+4|0;if((vb|0)==12){wb=P;break}else ub=P}P=c[wb>>2]|0;if(P){Ya=e;xa=b;Ua=Ya+40|0;do{c[Ya>>2]=c[xa>>2];Ya=Ya+4|0;xa=xa+4|0}while((Ya|0)<(Ua|0));c[A>>2]=P;c[B>>2]=1;xa=b4(e)|0;if(xa){xb=xa;T=157;break b}c[q>>2]=(c[q>>2]|0)+2;c[w>>2]=c[C>>2];K=F;L=c[D>>2]|0;M=0;break c}if(ba){R=5;break a}c[q>>2]=sb;xa=a[sb>>0]|0;l:do switch(xa|0){case 98:{Ya=h4(c[b>>2]|0,0,20)|0;if(!Ya)yb=0;else{Ua=c[Ya+4>>2]|0;c[Ua>>2]=-2;c[Ua+4>>2]=64;c[Ua+8>>2]=-1;yb=Ya}c[q>>2]=(c[q>>2]|0)+1;zb=yb;break}case 66:{Ya=h4(c[b>>2]|0,0,20)|0;if(!Ya)Ab=0;else{Ua=c[Ya+4>>2]|0;c[Ua>>2]=-2;c[Ua+4>>2]=128;c[Ua+8>>2]=-1;Ab=Ya}c[q>>2]=(c[q>>2]|0)+1;zb=Ab;break}case 60:{Ya=h4(c[b>>2]|0,0,20)|0;if(!Ya)Bb=0;else{Ua=c[Ya+4>>2]|0;c[Ua>>2]=-2;c[Ua+4>>2]=16;c[Ua+8>>2]=-1;Bb=Ya}c[q>>2]=(c[q>>2]|0)+1;zb=Bb;break}case 62:{Ya=h4(c[b>>2]|0,0,20)|0;if(!Ya)Cb=0;else{Ua=c[Ya+4>>2]|0;c[Ua>>2]=-2;c[Ua+4>>2]=32;c[Ua+8>>2]=-1;Cb=Ya}c[q>>2]=(c[q>>2]|0)+1;zb=Cb;break}case 120:{Ya=Z+2|0;c[q>>2]=Ya;Ua=a[Ya>>0]|0;if(Ua<<24>>24==123){ca=Z+3|0;c[q>>2]=ca;Q=ca;ca=Ya;Ya=0;m:while(1){Oa=a[Q>>0]|0;switch(Oa<<24>>24){case 0:case 125:{Db=ca;Eb=Ya;break m;break}default:{}}if(!(G1(Oa<<24>>24)|0)){T=188;break b}Oa=c[q>>2]|0;a[e+Ya>>0]=a[Oa>>0]|0;S=Ya+1|0;Q=Oa+1|0;c[q>>2]=Q;if(S>>>0>31){Db=Oa;Eb=S;break}else{ca=Oa;Ya=S}}c[q>>2]=Db+2;a[e+Eb>>0]=0;Ya=z3(e,0,16)|0;ca=c[w>>2]|0;Q=h4(c[b>>2]|0,0,20)|0;if(!Q)Fb=0;else{S=c[Q+4>>2]|0;c[S>>2]=Ya;c[S+4>>2]=Ya;c[S+8>>2]=ca;Fb=Q}c[w>>2]=(c[w>>2]|0)+1;zb=Fb;break l}else{a[e>>0]=0;a[e+1>>0]=0;a[e+2>>0]=0;Q=(G1(Ua<<24>>24)|0)==0;ca=c[q>>2]|0;if(Q)Gb=ca;else{a[e>>0]=a[ca>>0]|0;Q=ca+1|0;c[q>>2]=Q;Gb=Q}if(G1(a[Gb>>0]|0)|0){Q=c[q>>2]|0;a[z>>0]=a[Q>>0]|0;c[q>>2]=Q+1}Q=z3(e,0,16)|0;ca=c[w>>2]|0;S=h4(c[b>>2]|0,0,20)|0;if(!S)Hb=0;else{Ya=c[S+4>>2]|0;c[Ya>>2]=Q;c[Ya+4>>2]=Q;c[Ya+8>>2]=ca;Hb=S}c[w>>2]=(c[w>>2]|0)+1;zb=Hb;break l}break}default:{S=(z1(xa)|0)==0;ca=c[q>>2]|0;if(S){ma=ca;break d}S=(a[ca>>0]|0)+-48|0;ca=c[w>>2]|0;Ya=h4(c[b>>2]|0,0,20)|0;if(!Ya){R=12;break a}Q=c[Ya+4>>2]|0;c[Q>>2]=-4;c[Q+4>>2]=S;c[Q+8>>2]=ca;c[w>>2]=(c[w>>2]|0)+1;ca=c[y>>2]|0;c[y>>2]=(S|0)<(ca|0)?ca:S;c[q>>2]=(c[q>>2]|0)+1;K=F;L=Ya;M=0;break c}}while(0);if(!zb){R=12;break a}else{K=F;L=zb;M=0;break c}break}case 46:{xa=(c[v>>2]&4|0)==0;ba=c[w>>2]|0;P=h4(c[b>>2]|0,0,20)|0;Ya=(P|0)==0;if(xa){if(Ya){R=12;break a}xa=c[P+4>>2]|0;c[xa>>2]=0;c[xa+4>>2]=1114111;c[xa+8>>2]=ba;Ib=P;Jb=(c[w>>2]|0)+1|0}else{if(Ya){R=12;break a}Ya=c[P+4>>2]|0;c[Ya>>2]=0;c[Ya+4>>2]=9;c[Ya+8>>2]=ba;ba=c[w>>2]|0;Ya=h4(c[b>>2]|0,0,20)|0;if(!Ya){R=12;break a}xa=c[Ya+4>>2]|0;c[xa>>2]=11;c[xa+4>>2]=1114111;c[xa+8>>2]=ba+1;ba=i4(c[b>>2]|0,P,Ya)|0;if(!ba){R=12;break a}Ib=ba;Jb=(c[w>>2]|0)+2|0}c[w>>2]=Jb;c[q>>2]=(c[q>>2]|0)+1;K=F;L=Ib;M=0;break c;break}case 94:{if(!(c[v>>2]&1)){if((Z|0)!=(c[r>>2]|0)){ma=Z;break d}c[f>>2]=5;c[e>>2]=c[f>>2];ba=d4(m,e)|0;if(ba){K=F;L=G;M=ba;break c}}ba=h4(c[b>>2]|0,0,20)|0;if(!ba){R=12;break a}Ya=c[ba+4>>2]|0;c[Ya>>2]=-2;c[Ya+4>>2]=1;c[Ya+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;K=F;L=ba;M=0;break c;break}case 36:{if((c[v>>2]&1|0)==0?(a[Z+1>>0]|0)!=0:0){ma=Z;break d}ba=h4(c[b>>2]|0,0,20)|0;if(!ba){R=12;break a}Ya=c[ba+4>>2]|0;c[Ya>>2]=-2;c[Ya+4>>2]=2;c[Ya+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;K=F;L=ba;M=0;break c;break}case 41:{if(!F)ma=Z;else T=211;break}case 63:case 43:case 123:case 124:case 42:{T=211;break}case 0:{T=212;break}default:ma=Z}while(0);if((T|0)==67){T=0;N=F+1|0;c[q>>2]=na+1;c[f>>2]=c[x>>2];c[e>>2]=c[f>>2];J=d4(m,e)|0;if(J){K=N;L=G;M=J;break c}c[f>>2]=2;c[e>>2]=c[f>>2];J=d4(m,e)|0;if(J){K=N;L=G;M=J;break c}c[f>>2]=0;c[e>>2]=c[f>>2];J=d4(m,e)|0;if(J){K=N;L=G;M=J;break c}c[x>>2]=(c[x>>2]|0)+1;K=N;L=G;M=0;break c}else if((T|0)==211){T=0;if(!(c[v>>2]&1))ma=Z;else T=212}if((T|0)==212){T=0;N=h4(c[b>>2]|0,0,20)|0;if(!N){R=12;break a}J=c[N+4>>2]|0;c[J>>2]=-1;c[J+4>>2]=-1;c[J+8>>2]=-1;K=F;L=N;M=0;break c}N=n2(l,ma,-1)|0;if((N|0)<0){c[l>>2]=-1;Kb=1}else Kb=N;do if(c[v>>2]&2){if((F1(c[l>>2]|0)|0)==0?(B1(c[l>>2]|0)|0)==0:0){T=222;break}N=c[b>>2]|0;J=J1(c[l>>2]|0)|0;O=J1(c[l>>2]|0)|0;ba=c[w>>2]|0;Ya=h4(N,0,20)|0;if(!Ya){R=12;break a}N=c[Ya+4>>2]|0;c[N>>2]=J;c[N+4>>2]=O;c[N+8>>2]=ba;ba=c[b>>2]|0;N=K1(c[l>>2]|0)|0;O=K1(c[l>>2]|0)|0;J=c[w>>2]|0;P=h4(ba,0,20)|0;if(!P){R=12;break a}ba=c[P+4>>2]|0;c[ba>>2]=N;c[ba+4>>2]=O;c[ba+8>>2]=J;J=i4(c[b>>2]|0,Ya,P)|0;if(!J){R=12;break a}else Lb=J}else T=222;while(0);if((T|0)==222){T=0;Z=c[l>>2]|0;J=c[w>>2]|0;P=h4(c[b>>2]|0,0,20)|0;if(!P){R=12;break a}Ya=c[P+4>>2]|0;c[Ya>>2]=Z;c[Ya+4>>2]=Z;c[Ya+8>>2]=J;Lb=P}c[w>>2]=(c[w>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+Kb;K=F;L=Lb;M=0;break}case 2:{P=E+-2|0;c[n>>2]=P;J=c[I+(P<<2)>>2]|0;P=G;if((c[P+12>>2]|0)>-1){Ya=h4(c[b>>2]|0,0,20)|0;if(!Ya){R=12;break a}Z=c[Ya+4>>2]|0;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=f4(c[b>>2]|0,Ya,P)|0;if(!Z){R=12;break a}c[Z+16>>2]=c[P+16>>2];Mb=Z}else Mb=G;Z=Mb;c[Z+12>>2]=J;J=Z+16|0;c[J>>2]=(c[J>>2]|0)+1;K=F;L=Mb;M=0;break}case 10:{J=E+-2|0;c[n>>2]=J;c[v>>2]=c[I+(J<<2)>>2];K=F;L=G;M=0;break}default:{K=F;L=G;M=0}}while(0);E=c[n>>2]|0;I=(M|0)==0;if((M|0)!=0|I&(E|0)>(o|0)^1){Nb=I;Ob=K;Pb=L;Qb=M;T=231;break a}else{F=K;G=L}}if((T|0)==72){R=12;break}else if((T|0)==157){R=xb;break}else if((T|0)==188){R=9;break}}else{Nb=t;Ob=0;Pb=0;Qb=p;T=231}while(0);if((T|0)==231){T=(Ob|0)>0;if(T|Nb^1)R=T?8:Qb;else{c[b+8>>2]=Pb;R=Qb}}i=d;return R|0}function c4(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0;g=i;i=i+16|0;h=g+4|0;j=g;k=d+12|0;l=c[k>>2]|0;m=(b|0)==0|(f|0)==0;if(!m){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}n=c[f+28>>2]|0;o=N4((n<<3)+8|0)|0;do if(!o)p=12;else{c[o>>2]=-1;q=N4((n<<2)+4|0)|0;if(!q){O4(o);p=12;break}c[q>>2]=-1;r=0;while(1)if(r>>>0>n>>>0)break;else r=r+1|0;c[j>>2]=e;c[h>>2]=c[j>>2];d4(d,h)|0;c[j>>2]=0;c[h>>2]=c[j>>2];r=d4(d,h)|0;s=c[k>>2]|0;a:do if((r|0)!=0|(s|0)<=(l|0)){t=-1;u=0;v=0;w=o;x=r;y=0}else{z=d+16|0;A=f+32|0;B=f+36|0;C=f+16|0;D=s;E=0;F=-1;G=1;H=0;I=0;J=o;K=0;while(1){L=D+-1|0;c[k>>2]=L;M=c[z>>2]|0;switch(c[M+(L<<2)>>2]|0){case 6:{L=D+-2|0;c[k>>2]=L;N=c[M+(L<<2)>>2]|0;L=0;while(1){O=J+(L<<2)|0;P=L+1|0;if((c[O>>2]|0)>-1)L=P;else{Q=O;R=P;break}}c[Q>>2]=N<<1|1;c[J+(R<<2)>>2]=-1;L=0;while(1)if((c[q+(L<<2)>>2]|0)>-1)L=L+1|0;else{S=L;break}c[q+(S+-1<<2)>>2]=-1;T=E;U=F;V=G;W=H;X=I;Y=J;Z=0;_=K;break}case 0:{L=D+-2|0;c[k>>2]=L;N=c[M+(L<<2)>>2]|0;L=N+12|0;P=c[L>>2]|0;if((P|0)>-1){O=0;while(1){$=J+(O<<2)|0;aa=O+1|0;if((c[$>>2]|0)>-1)O=aa;else{ba=$;ca=aa;break}}c[ba>>2]=P<<1;c[J+(ca<<2)>>2]=-1;if(!m){O=0;while(1)if((c[q+(O<<2)>>2]|0)>-1)O=O+1|0;else{da=O;break}O=(c[C>>2]|0)+(P*12|0)+8|0;c[O>>2]=0;if((da|0)>0){aa=N4((da<<2)+4|0)|0;if(!aa){t=F;u=H;v=I;w=J;x=12;y=K;break a}c[O>>2]=aa;O=c[q>>2]|0;if((O|0)>-1){$=O;O=aa;ea=0;while(1){c[O>>2]=$;ea=ea+1|0;$=c[q+(ea<<2)>>2]|0;fa=aa+(ea<<2)|0;if(($|0)<=-1){ga=fa;break}else O=fa}}else ga=aa;c[ga>>2]=-1}}c[j>>2]=c[L>>2];c[h>>2]=c[j>>2];O=d4(d,h)|0;if(O){t=F;u=H;v=I;w=J;x=O;y=K;break a}c[j>>2]=6;c[h>>2]=c[j>>2];O=d4(d,h)|0;if(O){t=F;u=H;v=I;w=J;x=O;y=K;break a}}b:do switch(c[N>>2]|0){case 0:{O=c[c[N+4>>2]>>2]|0;if((O|0)>-1|(O|0)==-4?(c[J>>2]|0)>-1:0){if(m){c[N+20>>2]=1;ha=F;ia=H;ja=0}else{O=I4(b,N,K)|0;c[(c[A>>2]|0)+(K<<2)>>2]=E;if((F|0)>-1){$=c[B>>2]|0;ea=0;while(1){P=$+(ea<<2)|0;fa=ea+1|0;if((c[P>>2]|0)>-1)ea=fa;else{ka=P;la=fa;ma=ea;break}}c[ka>>2]=K;c[$+(la<<2)>>2]=F;c[$+(ma+2<<2)>>2]=-1;na=-1;oa=H+1|0}else{na=F;oa=H}J4(J,f,K);ha=na;ia=oa;ja=O}c[J>>2]=-1;pa=E;qa=ha;ra=G+1|0;sa=ia;ta=I+1|0;ua=ja;va=G}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=0;va=K}break}case 1:{ea=c[N+4>>2]|0;fa=c[ea>>2]|0;P=c[ea+4>>2]|0;c[j>>2]=N;c[h>>2]=c[j>>2];ea=d4(d,h)|0;if(!ea){c[j>>2]=5;c[h>>2]=c[j>>2];wa=d4(d,h)|0;if(!wa){c[j>>2]=P;c[h>>2]=c[j>>2];xa=d4(d,h)|0;if(!xa){c[j>>2]=0;c[h>>2]=c[j>>2];ya=d4(d,h)|0;if(!ya){za=fa+20|0;c[j>>2]=(c[za>>2]|0)+G;c[h>>2]=c[j>>2];Aa=d4(d,h)|0;if(!Aa){if((c[za>>2]|0)>0){za=(c[P+20>>2]|0)>0;Ba=(za&1)+G|0;Ca=za?G:-1}else{Ba=G;Ca=-1}c[j>>2]=Ca;c[h>>2]=c[j>>2];za=d4(d,h)|0;if(!za){c[j>>2]=4;c[h>>2]=c[j>>2];P=d4(d,h)|0;if(!P){c[j>>2]=fa;c[h>>2]=c[j>>2];fa=d4(d,h)|0;if(!fa){c[j>>2]=0;c[h>>2]=c[j>>2];pa=E;qa=F;ra=Ba;sa=H;ta=I;ua=d4(d,h)|0;va=K}else{pa=E;qa=F;ra=Ba;sa=H;ta=I;ua=fa;va=K}}else{pa=E;qa=F;ra=Ba;sa=H;ta=I;ua=P;va=K}}else{pa=E;qa=F;ra=Ba;sa=H;ta=I;ua=za;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Aa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=ya;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=xa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=wa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=ea;va=K}break}case 2:{ea=c[N+4>>2]|0;if(m){if((c[J>>2]|0)>-1)Da=1;else Da=(a[ea+12>>0]&1)!=0;c[j>>2]=Da&1;c[h>>2]=c[j>>2];wa=d4(d,h)|0;if(wa){pa=E;qa=F;ra=G;sa=H;ta=I;ua=wa;va=K;break b}}else{c[j>>2]=K;c[h>>2]=c[j>>2];wa=d4(d,h)|0;if(wa){pa=E;qa=F;ra=G;sa=H;ta=I;ua=wa;va=K;break b}c[j>>2]=a[ea+12>>0]&1;c[h>>2]=c[j>>2];wa=d4(d,h)|0;if(wa){pa=E;qa=F;ra=G;sa=H;ta=I;ua=wa;va=K;break b}}c[j>>2]=N;c[h>>2]=c[j>>2];wa=d4(d,h)|0;if(!wa){c[j>>2]=1;c[h>>2]=c[j>>2];xa=d4(d,h)|0;if(!xa){c[j>>2]=c[ea>>2];c[h>>2]=c[j>>2];ya=d4(d,h)|0;if(!ya){c[j>>2]=0;c[h>>2]=c[j>>2];Aa=d4(d,h)|0;if(!Aa){if((c[J>>2]|0)<=-1?(a[ea+12>>0]&1)==0:0){pa=0;qa=F;ra=G;sa=H;ta=I;ua=0;va=K;break b}if(m){Ea=F;Fa=H;Ga=0}else{za=I4(b,N,K)|0;c[(c[A>>2]|0)+(K<<2)>>2]=(a[ea+12>>0]&1)==0?E:1;if((F|0)>-1){ea=c[B>>2]|0;P=0;while(1){fa=ea+(P<<2)|0;Ha=P+1|0;if((c[fa>>2]|0)>-1)P=Ha;else{Ia=fa;Ja=Ha;Ka=P;break}}c[Ia>>2]=K;c[ea+(Ja<<2)>>2]=F;c[ea+(Ka+2<<2)>>2]=-1;La=-1;Ma=H+1|0}else{La=F;Ma=H}J4(J,f,K);Ea=La;Fa=Ma;Ga=za}c[J>>2]=-1;pa=0;qa=Ea;ra=G+1|0;sa=Fa;ta=I+1|0;ua=Ga;va=G}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Aa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=ya;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=xa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=wa;va=K}break}case 3:{P=c[N+4>>2]|0;O=c[P>>2]|0;$=c[P+4>>2]|0;P=(c[J>>2]|0)>-1;Ha=G+1|0;c[j>>2]=P?Ha:G;c[h>>2]=c[j>>2];fa=d4(d,h)|0;if(!fa){c[j>>2]=P?G:K;c[h>>2]=c[j>>2];P=d4(d,h)|0;if(!P){c[j>>2]=J;c[h>>2]=c[j>>2];Na=d4(d,h)|0;if(!Na){c[j>>2]=(c[J>>2]|0)>>>31^1;c[h>>2]=c[j>>2];Oa=d4(d,h)|0;if(!Oa){c[j>>2]=N;c[h>>2]=c[j>>2];Pa=d4(d,h)|0;if(!Pa){c[j>>2]=$;c[h>>2]=c[j>>2];Qa=d4(d,h)|0;if(!Qa){c[j>>2]=O;c[h>>2]=c[j>>2];Ra=d4(d,h)|0;if(!Ra){c[j>>2]=3;c[h>>2]=c[j>>2];Sa=d4(d,h)|0;if(!Sa){c[j>>2]=$;c[h>>2]=c[j>>2];$=d4(d,h)|0;if(!$){c[j>>2]=0;c[h>>2]=c[j>>2];Ta=d4(d,h)|0;if(!Ta){c[j>>2]=2;c[h>>2]=c[j>>2];Ua=d4(d,h)|0;if(Ua){pa=E;qa=F;ra=G;sa=H;ta=I;ua=Ua;va=K;break b}c[j>>2]=O;c[h>>2]=c[j>>2];O=d4(d,h)|0;if(O){pa=E;qa=F;ra=G;sa=H;ta=I;ua=O;va=K;break b}c[j>>2]=0;c[h>>2]=c[j>>2];O=d4(d,h)|0;if(O){pa=E;qa=F;ra=G;sa=H;ta=I;ua=O;va=K;break b}if((c[J>>2]|0)>-1){if(m){Va=F;Wa=H;Xa=0}else{O=I4(b,N,K)|0;c[(c[A>>2]|0)+(K<<2)>>2]=E;if((F|0)>-1){Ua=c[B>>2]|0;Ya=0;while(1){Za=Ua+(Ya<<2)|0;_a=Ya+1|0;if((c[Za>>2]|0)>-1)Ya=_a;else{$a=Za;ab=_a;bb=Ya;break}}c[$a>>2]=K;c[Ua+(ab<<2)>>2]=F;c[Ua+(bb+2<<2)>>2]=-1;cb=-1;db=H+1|0}else{cb=F;db=H}J4(J,f,K);Va=cb;Wa=db;Xa=O}c[J>>2]=-1;eb=Va;fb=Ha;gb=Wa;hb=I+1|0;ib=Xa;jb=G}else{eb=F;fb=G;gb=H;hb=I;ib=0;jb=K}Ya=(c[N+16>>2]|0)>0;pa=E;qa=eb;ra=Ya?fb+2|0:fb;sa=gb;ta=hb;ua=ib;va=Ya?fb+1|0:jb}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Ta;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=$;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Sa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Ra;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Qa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Pa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Oa;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=Na;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=P;va=K}}else{pa=E;qa=F;ra=G;sa=H;ta=I;ua=fa;va=K}break}default:{pa=E;qa=F;ra=G;sa=H;ta=I;ua=0;va=K}}while(0);N=c[L>>2]|0;if((N|0)>-1){aa=0;while(1){Ya=q+(aa<<2)|0;wa=aa+1|0;if((c[Ya>>2]|0)>-1)aa=wa;else{kb=Ya;lb=wa;break}}c[kb>>2]=N;c[q+(lb<<2)>>2]=-1;T=pa;U=qa;V=ra;W=sa;X=ta;Y=J;Z=ua;_=va}else{T=pa;U=qa;V=ra;W=sa;X=ta;Y=J;Z=ua;_=va}break}case 1:{aa=D+-2|0;c[k>>2]=aa;L=c[M+(aa<<2)>>2]|0;if(m){aa=c[(c[c[L+4>>2]>>2]|0)+20>>2]|0;wa=D+-3|0;c[k>>2]=wa;c[L+20>>2]=(c[M+(wa<<2)>>2]|0)+aa;mb=0;nb=-1}else{aa=D+-3|0;c[k>>2]=aa;wa=c[M+(aa<<2)>>2]|0;aa=D+-4|0;c[k>>2]=aa;mb=wa;nb=(wa|0)==0?F:c[M+(aa<<2)>>2]|0}T=m?E:(mb|0)==0&1;U=nb;V=G;W=H;X=I;Y=J;Z=0;_=K;break}case 4:{aa=D+-2|0;c[k>>2]=aa;wa=c[M+(aa<<2)>>2]|0;aa=D+-3|0;c[k>>2]=aa;T=E;U=F;V=c[M+(aa<<2)>>2]|0;W=H;X=I;Y=J;Z=0;_=(wa|0)>-1?wa:K;break}case 5:{wa=D+-2|0;c[k>>2]=wa;aa=c[M+(wa<<2)>>2]|0;if(m){wa=c[aa+4>>2]|0;c[aa+20>>2]=(c[(c[wa+4>>2]|0)+20>>2]|0)+(c[(c[wa>>2]|0)+20>>2]|0);T=E;U=F;V=G;W=H;X=I;Y=J;Z=0;_=K}else{T=E;U=F;V=G;W=H;X=I;Y=J;Z=0;_=K}break}case 2:{wa=J;while(1)if((c[wa>>2]|0)>-1)wa=wa+4|0;else{T=E;U=F;V=G;W=H;X=I;Y=wa;Z=0;_=K;break}break}case 3:{wa=c[M+(D+-2<<2)>>2]|0;N=c[M+(D+-3<<2)>>2]|0;aa=c[M+(D+-4<<2)>>2]|0;L=D+-5|0;c[k>>2]=L;if(m){Ya=c[aa+4>>2]|0;xa=c[aa+16>>2]|0;c[aa+20>>2]=(c[(c[Ya>>2]|0)+20>>2]|0)+(c[M+(L<<2)>>2]|0)+(c[(c[Ya+4>>2]|0)+20>>2]|0)+((xa|0)>0?2:0);ob=xa}else ob=c[aa+16>>2]|0;aa=c[M+(D+-6<<2)>>2]|0;xa=D+-7|0;c[k>>2]=xa;Ya=c[M+(xa<<2)>>2]|0;xa=D+-8|0;c[k>>2]=xa;L=c[M+(xa<<2)>>2]|0;if((ob|0)>0){if(m)pb=0;else{K4(b,wa,Ya)|0;c[(c[A>>2]|0)+(Ya<<2)>>2]=1;Ya=K4(b,N,L)|0;c[(c[A>>2]|0)+(L<<2)>>2]=1;pb=Ya}T=1;U=F;V=G;W=H;X=I+2|0;Y=aa;Z=pb;_=K}else{T=1;U=F;V=G;W=H;X=I;Y=aa;Z=0;_=K}break}default:{T=E;U=F;V=G;W=H;X=I;Y=J;Z=0;_=K}}D=c[k>>2]|0;if((Z|0)!=0|(D|0)<=(l|0)){t=U;u=W;v=X;w=Y;x=Z;y=_;break a}else{E=T;F=U;G=V;H=W;I=X;J=Y;K=_}}}while(0);if(!m?(J4(w,f,y),(t|0)>-1):0){s=c[f+36>>2]|0;r=0;while(1){K=s+(r<<2)|0;J=r+1|0;if((c[K>>2]|0)>-1)r=J;else{qb=K;rb=J;sb=r;break}}c[qb>>2]=y;c[s+(rb<<2)>>2]=t;c[s+(sb+2<<2)>>2]=-1;tb=u+1|0}else tb=u;c[f+48>>2]=v;c[f+40>>2]=v;c[f+44>>2]=tb;O4(o);O4(q);p=x}while(0);i=g;return p|0}function d4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;f=a+12|0;g=c[f>>2]|0;h=c[a>>2]|0;if((g|0)>=(h|0)){j=c[a+4>>2]|0;if((h|0)<(j|0)?(k=(c[a+8>>2]|0)+h|0,h=(k|0)>(j|0)?j:k,k=a+16|0,j=Q4(c[k>>2]|0,h<<2)|0,(j|0)!=0):0){c[a>>2]=h;c[k>>2]=j;c[e>>2]=c[b>>2];d4(a,e)|0;l=0}else l=12}else{c[(c[a+16>>2]|0)+(g<<2)>>2]=c[b>>2];c[f>>2]=(c[f>>2]|0)+1;l=0}i=d;return l|0}function e4(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;l=i;i=i+16|0;m=l+4|0;n=l;o=d+12|0;p=c[o>>2]|0;c[n>>2]=e;c[m>>2]=c[n>>2];d4(d,m)|0;c[n>>2]=0;c[m>>2]=c[n>>2];e=d4(d,m)|0;a:do if(!e){q=d+16|0;r=(f&1|0)==0;s=(f&2|0)!=0;t=1;u=0;v=j;while(1){w=c[o>>2]|0;if((w|0)>(p|0)){x=w;y=v}else{z=u;A=0;break a}b:while(1){w=c[q>>2]|0;B=x;c:while(1){C=B+-1|0;c[o>>2]=C;switch(c[w+(C<<2)>>2]|0){case 1:{D=B;E=w;F=7;break c;break}case 0:{C=B+-2|0;c[o>>2]=C;G=c[w+(C<<2)>>2]|0;switch(c[G>>2]|0){case 0:{H=G;I=y;F=9;break b;break}case 3:{J=G;K=y;F=20;break b;break}case 1:{L=G;M=y;F=27;break b;break}case 2:{N=G;F=34;break c;break}default:{}}break}default:{}}B=c[o>>2]|0;if((B|0)<=(p|0)){z=u;A=0;break a}}if((F|0)==7){F=0;B=D+-2|0;c[o>>2]=B;O=c[E+(B<<2)>>2]|0}else if((F|0)==34){F=0;B=c[N+4>>2]|0;c[n>>2]=c[B>>2];c[m>>2]=c[n>>2];w=d4(d,m)|0;if(w){z=u;A=w;break a}c[n>>2]=0;c[m>>2]=c[n>>2];w=d4(d,m)|0;if(w){z=u;A=w;break a}w=g4(b,c[B>>2]|0,c[B+4>>2]|0,c[B+8>>2]|0,a[B+12>>0]&1)|0;c[y>>2]=w;if(!w){z=u;A=12;break a}O=c[w+4>>2]|0}x=c[o>>2]|0;if((x|0)<=(p|0)){z=u;A=0;break a}else y=O}if((F|0)==9){F=0;w=c[H+4>>2]|0;B=c[w+8>>2]|0;G=c[w>>2]|0;C=c[w+4>>2]|0;if(!((G|0)>-1|(G|0)==-4))if(r|(G|0)!=-3)if((G|0)==-3)if(s&(t|0)!=0){c[h+(C<<2)>>2]=1;P=0;Q=C;R=-3;S=u;T=B}else{P=t;Q=C;R=-3;S=u;T=B}else{P=t;Q=C;R=G;S=u;T=B}else{P=t;Q=-1;R=-1;S=u;T=-1}else{P=t;Q=C;R=G;S=u+1|0;T=(c[g>>2]|0)+B|0}B=h4(b,0,20)|0;if(!B){c[I>>2]=0;U=12}else{G=B+4|0;C=c[G>>2]|0;c[C>>2]=R;c[C+4>>2]=Q;c[C+8>>2]=T;c[I>>2]=B;B=c[G>>2]|0;c[B+12>>2]=c[w+12>>2];c[B+16>>2]=c[w+16>>2];U=0}if((T|0)>(c[k>>2]|0)){c[k>>2]=T;V=P;W=S;X=I;Y=U}else{V=P;W=S;X=I;Y=U}}else if((F|0)==20){F=0;w=c[J+4>>2]|0;B=w+4|0;G=i4(b,c[w>>2]|0,c[B>>2]|0)|0;c[K>>2]=G;if(!G){z=u;A=12;break a}C=c[G+4>>2]|0;c[n>>2]=c[B>>2];c[m>>2]=c[n>>2];B=d4(d,m)|0;if(B){z=u;A=B;break a}c[n>>2]=0;c[m>>2]=c[n>>2];B=d4(d,m)|0;if(B){z=u;A=B;break a}c[n>>2]=C+4;c[m>>2]=c[n>>2];B=d4(d,m)|0;if(B){z=u;A=B;break a}c[n>>2]=1;c[m>>2]=c[n>>2];B=d4(d,m)|0;if(B){z=u;A=B;break a}c[n>>2]=c[w>>2];c[m>>2]=c[n>>2];w=d4(d,m)|0;if(w){z=u;A=w;break a}c[n>>2]=0;c[m>>2]=c[n>>2];V=t;W=u;X=C;Y=d4(d,m)|0}else if((F|0)==27){F=0;C=c[L+4>>2]|0;w=C+4|0;B=f4(b,c[C>>2]|0,c[w>>2]|0)|0;c[M>>2]=B;if(!B){z=u;A=12;break a}G=c[B+4>>2]|0;c[G>>2]=0;B=G+4|0;c[B>>2]=0;c[n>>2]=c[w>>2];c[m>>2]=c[n>>2];w=d4(d,m)|0;if(w){z=u;A=w;break a}c[n>>2]=0;c[m>>2]=c[n>>2];w=d4(d,m)|0;if(w){z=u;A=w;break a}c[n>>2]=B;c[m>>2]=c[n>>2];B=d4(d,m)|0;if(B){z=u;A=B;break a}c[n>>2]=1;c[m>>2]=c[n>>2];B=d4(d,m)|0;if(B){z=u;A=B;break a}c[n>>2]=c[C>>2];c[m>>2]=c[n>>2];C=d4(d,m)|0;if(C){z=u;A=C;break a}c[n>>2]=0;c[m>>2]=c[n>>2];V=t;W=u;X=G;Y=d4(d,m)|0}if(!Y){t=V;u=W;v=X}else{z=W;A=Y;break}}}else{z=0;A=e}while(0);c[g>>2]=(c[g>>2]|0)+z;i=l;return A|0}function f4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=h4(a,1,8)|0;if(!e)f=0;else{a=c[e+4>>2]|0;c[a>>2]=b;c[a+4>>2]=d;c[e+16>>2]=(c[d+16>>2]|0)+(c[b+16>>2]|0);f=e}return f|0}function g4(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=h4(b,2,16)|0;if(!h)i=0;else{b=c[h+4>>2]|0;c[b>>2]=d;c[b+4>>2]=e;c[b+8>>2]=f;f=b+12|0;a[f>>0]=a[f>>0]&-2|g&1;c[h+16>>2]=c[d+16>>2];i=h}return i|0}function h4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=B2(a,0,0,1,32)|0;if((e|0)!=0?(f=B2(a,0,0,1,d)|0,c[e+4>>2]=f,(f|0)!=0):0){c[e>>2]=b;c[e+8>>2]=-1;c[e+12>>2]=-1;g=e}else g=0;return g|0}function i4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=h4(a,3,8)|0;if(!e)f=0;else{a=c[e+4>>2]|0;c[a>>2]=b;c[a+4>>2]=d;c[e+16>>2]=(c[d+16>>2]|0)+(c[b+16>>2]|0);f=e}return f|0}function j4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;i=B2(a,0,0,1,64)|0;if(!i)j=0;else{c[i>>2]=b;c[i+4>>2]=d;c[i+8>>2]=e;c[i+20>>2]=f;c[i+24>>2]=g;c[i+28>>2]=h;c[i+32>>2]=-1;c[i+36>>2]=-1;c[i+40>>2]=-1;j=i}return j|0}function k4(a){a=a|0;var b=0,d=0;b=B2(a,0,0,1,32)|0;if(!b)d=0;else{c[b>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;d=b}return d|0}function l4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=(e|0)==0;if(g)h=0;else{i=0;while(1)if((c[e+(i<<2)>>2]|0)>-1)i=i+1|0;else{h=i;break}}i=0;while(1)if((c[b+(i<<5)>>2]|0)>-1)i=i+1|0;else{j=i;break}i=0;while(1)if((c[d+(i<<5)>>2]|0)>-1)i=i+1|0;else{k=i;break}i=B2(a,0,0,1,(k+j<<5)+32|0)|0;a:do if(!i)l=0;else{j=c[b>>2]|0;if((j|0)>-1){k=(h|0)>0;m=j;j=0;while(1){c[i+(j<<5)>>2]=m;c[i+(j<<5)+4>>2]=c[b+(j<<5)+4>>2];c[i+(j<<5)+8>>2]=c[b+(j<<5)+8>>2];c[i+(j<<5)+16>>2]=c[b+(j<<5)+16>>2]|f;c[i+(j<<5)+20>>2]=c[b+(j<<5)+20>>2];c[i+(j<<5)+24>>2]=c[b+(j<<5)+24>>2];c[i+(j<<5)+28>>2]=c[b+(j<<5)+28>>2];n=b+(j<<5)+12|0;o=c[n>>2]|0;p=(o|0)==0;if(g&p)c[i+(j<<5)+12>>2]=0;else{if(p)q=0;else{p=0;while(1)if((c[o+(p<<2)>>2]|0)>-1)p=p+1|0;else{q=p;break}}p=B2(a,0,0,0,(q+h<<2)+4|0)|0;if(!p){l=0;break a}if((q|0)>0){o=c[n>>2]|0;r=0;do{c[p+(r<<2)>>2]=c[o+(r<<2)>>2];r=r+1|0}while((r|0)!=(q|0));s=q}else s=0;if(k){r=0;do{c[p+(r+s<<2)>>2]=c[e+(r<<2)>>2];r=r+1|0}while((r|0)!=(h|0));t=h}else t=0;c[p+(t+s<<2)>>2]=-1;c[i+(j<<5)+12>>2]=p}r=j+1|0;m=c[b+(r<<5)>>2]|0;if((m|0)<=-1){u=r;break}else j=r}}else u=0;j=c[d>>2]|0;m=i+(u<<5)|0;if((j|0)>-1){k=j;j=m;r=u;o=0;while(1){c[j>>2]=k;c[i+(r<<5)+4>>2]=c[d+(o<<5)+4>>2];c[i+(r<<5)+8>>2]=c[d+(o<<5)+8>>2];c[i+(r<<5)+16>>2]=c[d+(o<<5)+16>>2];c[i+(r<<5)+20>>2]=c[d+(o<<5)+20>>2];c[i+(r<<5)+24>>2]=c[d+(o<<5)+24>>2];c[i+(r<<5)+28>>2]=c[d+(o<<5)+28>>2];n=d+(o<<5)+12|0;v=c[n>>2]|0;if(!v)c[i+(r<<5)+12>>2]=0;else{w=0;while(1)if((c[v+(w<<2)>>2]|0)>-1)w=w+1|0;else{x=w;break}w=B2(a,0,0,0,(x<<2)+4|0)|0;if(!w){l=0;break a}if((x|0)>0){v=c[n>>2]|0;p=0;do{c[w+(p<<2)>>2]=c[v+(p<<2)>>2];p=p+1|0}while((p|0)!=(x|0));y=x}else y=0;c[w+(y<<2)>>2]=-1;c[i+(r<<5)+12>>2]=w}o=o+1|0;k=c[d+(o<<5)>>2]|0;r=o+u|0;p=i+(r<<5)|0;if((k|0)<=-1){z=p;break}else j=p}}else z=m;c[z>>2]=-1;l=i}while(0);return l|0}function m4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;g=i;i=i+16|0;h=g+4|0;j=g;k=a+12|0;l=c[k>>2]|0;m=(f|0)!=0;if(m)c[f>>2]=0;c[j>>2]=b;c[h>>2]=c[j>>2];b=d4(a,h)|0;a:do if(!b){n=a+16|0;o=(d|0)==0;p=(e|0)==0;q=c[k>>2]|0;if((q|0)>(l|0)){r=q;while(1){q=r+-1|0;c[k>>2]=q;s=c[(c[n>>2]|0)+(q<<2)>>2]|0;b:do switch(c[s>>2]|0){case 0:{q=c[s+4>>2]|0;switch(c[q>>2]|0){case -3:break;case -2:{if(p)break b;c[e>>2]=c[e>>2]|c[q+4>>2];break b;break}default:break b}t=c[q+4>>2]|0;if((t|0)>-1){c:do if(!o){q=c[d>>2]|0;d:do if((q|0)>-1){u=q;v=d;w=0;while(1){if((u|0)==(t|0)){x=v;y=w;break}z=w+1|0;A=d+(z<<2)|0;u=c[A>>2]|0;if((u|0)<=-1){B=A;C=z;break d}else{v=A;w=z}}if((t|0)<0){B=x;C=y}else break c}else{B=d;C=0}while(0);c[B>>2]=t;c[d+(C+1<<2)>>2]=-1}while(0);if(m)c[f>>2]=(c[f>>2]|0)+1}break}case 3:{t=c[s+4>>2]|0;q=c[t>>2]|0;if(c[q+8>>2]|0){c[j>>2]=q;c[h>>2]=c[j>>2];D=d4(a,h)|0;E=6;break b}q=c[t+4>>2]|0;if(c[q+8>>2]|0){c[j>>2]=q;c[h>>2]=c[j>>2];D=d4(a,h)|0;E=6}break}case 1:{q=c[s+4>>2]|0;c[j>>2]=c[q>>2];c[h>>2]=c[j>>2];t=d4(a,h)|0;if(t){F=t;break a}c[j>>2]=c[q+4>>2];c[h>>2]=c[j>>2];D=d4(a,h)|0;E=6;break}case 2:{q=c[c[s+4>>2]>>2]|0;if(c[q+8>>2]|0){c[j>>2]=q;c[h>>2]=c[j>>2];D=d4(a,h)|0;E=6}break}default:{}}while(0);if((E|0)==6?(E=0,(D|0)!=0):0){F=D;break a}r=c[k>>2]|0;if((r|0)<=(l|0)){F=0;break a}}}else F=0}else F=b;while(0);i=g;return F|0}function n4(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=a;a:while(1){switch(c[f>>2]|0){case 2:{a=c[f+4>>2]|0;if((c[a+8>>2]|0)==-1?(g=c[a>>2]|0,h=H4(c[g+28>>2]|0,c[g+24>>2]|0,b,d,e)|0,(h|0)!=0):0){i=h;break a}else j=a;break}case 3:{a=c[f+4>>2]|0;h=n4(c[a>>2]|0,b,d,e)|0;if(h){i=h;break a}j=a+4|0;break}case 1:{a=c[f+4>>2]|0;h=a+4|0;g=H4(c[(c[a>>2]|0)+28>>2]|0,c[(c[h>>2]|0)+24>>2]|0,b,d,e)|0;if(g){i=g;break a}g=n4(c[a>>2]|0,b,d,e)|0;if(!g)j=h;else{i=g;break a}break}default:{i=0;break a}}f=c[j>>2]|0}return i|0}function o4(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;a:do if((a|0)>0){f=0;while(1){g=c[d+(f<<2)>>2]|0;h=c[e+(f<<2)>>2]|0;if(!(c[b+(f<<2)>>2]|0)){if((g|0)<(h|0)){i=1;break a}if((g|0)>(h|0)){i=0;break a}}else{if((g|0)>(h|0)){i=1;break a}if((g|0)<(h|0)){i=0;break a}}f=f+1|0;if((f|0)>=(a|0)){i=0;break}}}else i=0;while(0);return i|0}function p4(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((d&8|0)==0&(g|0)>-1){d=c[e+16>>2]|0;h=e+28|0;i=c[h>>2]|0;j=(a|0)!=0;if(j&(i|0)!=0){k=e+48|0;e=0;do{l=c[d+(e*12|0)>>2]|0;if((l|0)==(c[k>>2]|0))m=g;else m=c[f+(l<<2)>>2]|0;l=b+(e<<3)|0;c[l>>2]=m;n=c[d+(e*12|0)+4>>2]|0;if((n|0)==(c[k>>2]|0))o=g;else o=c[f+(n<<2)>>2]|0;n=b+(e<<3)+4|0;c[n>>2]=o;if((m|0)==-1|(o|0)==-1){c[n>>2]=-1;c[l>>2]=-1}e=e+1|0;l=c[h>>2]|0}while(e>>>0<a>>>0&e>>>0<l>>>0);p=l}else p=i;if(j&(p|0)!=0){j=0;while(1){i=b+(j<<3)+4|0;e=c[d+(j*12|0)+8>>2]|0;if((e|0)!=0?(h=c[e>>2]|0,(h|0)>-1):0){o=b+(j<<3)|0;m=h;h=c[o>>2]|0;f=0;while(1){if((h|0)>=(c[b+(m<<3)>>2]|0)?(c[i>>2]|0)<=(c[b+(m<<3)+4>>2]|0):0)q=h;else{c[i>>2]=-1;c[o>>2]=-1;q=-1}f=f+1|0;m=c[e+(f<<2)>>2]|0;if((m|0)<=-1)break;else h=q}}h=j+1|0;if(h>>>0<a>>>0&h>>>0<p>>>0)j=h;else{r=h;break}}}else r=0}else r=0;if(r>>>0<a>>>0){j=r;do{c[b+(j<<3)>>2]=-1;c[b+(j<<3)+4>>2]=-1;j=j+1|0}while((j|0)!=(a|0))}return}function q4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=c[a>>2]|0;a:do if(!e)f=0;else{g=(d|0)==0;h=a;i=e;while(1){if(g){if(x1(b,i)|0){f=1;break a}}else{j=J1(b)|0;if(x1(j,c[h>>2]|0)|0){f=1;break a}j=K1(b)|0;if(x1(j,c[h>>2]|0)|0){f=1;break a}}h=h+4|0;i=c[h>>2]|0;if(!i){f=0;break}}}while(0);return f|0}function r4(a){a=a|0;if(!(c[a+68>>2]|0))G2(a);return}function s4(a){a=a|0;if(!(c[a+68>>2]|0))G2(a);return}function t4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;b=a+20|0;d=a+28|0;if((c[b>>2]|0)>>>0>(c[d>>2]|0)>>>0?(Hb[c[a+36>>2]&63](a,0,0)|0,(c[b>>2]|0)==0):0)e=-1;else{f=a+4|0;g=c[f>>2]|0;h=a+8|0;i=c[h>>2]|0;if(g>>>0<i>>>0)Hb[c[a+40>>2]&63](a,g-i|0,1)|0;c[a+16>>2]=0;c[d>>2]=0;c[b>>2]=0;c[h>>2]=0;c[f>>2]=0;e=0}return e|0}function u4(e,f,g,j,l){e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0.0,db=0.0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0.0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0;m=i;i=i+624|0;n=m+24|0;o=m+16|0;p=m+588|0;q=m+576|0;r=m;s=m+536|0;t=m+8|0;u=m+528|0;v=(e|0)!=0;w=s+40|0;x=w;y=s+39|0;s=t+4|0;z=p;A=0-z|0;B=q+12|0;D=q+11|0;q=B;E=q-z|0;F=-2-z|0;G=q+2|0;H=n+288|0;I=p+9|0;J=I;K=p+8|0;L=0;M=0;N=0;O=f;a:while(1){do if((L|0)>-1)if((M|0)>(2147483647-L|0)){c[(L1()|0)>>2]=75;P=-1;break}else{P=M+L|0;break}else P=L;while(0);f=a[O>>0]|0;if(!(f<<24>>24)){Q=P;R=N;S=244;break}else{T=f;U=O}b:while(1){switch(T<<24>>24){case 37:{V=U;W=U;S=9;break b;break}case 0:{X=U;Y=U;break b;break}default:{}}f=U+1|0;T=a[f>>0]|0;U=f}c:do if((S|0)==9)while(1){S=0;if((a[V+1>>0]|0)!=37){X=V;Y=W;break c}f=W+1|0;Z=V+2|0;if((a[Z>>0]|0)==37){V=Z;W=f;S=9}else{X=Z;Y=f;break}}while(0);f=Y-O|0;if(v?(c[e>>2]&32|0)==0:0)g3(O,f,e)|0;if((Y|0)!=(O|0)){L=P;M=f;O=X;continue}Z=X+1|0;$=a[Z>>0]|0;aa=($<<24>>24)+-48|0;if(aa>>>0<10){ba=(a[X+2>>0]|0)==36;ca=ba?X+3|0:Z;da=a[ca>>0]|0;ea=ba?aa:-1;fa=ba?1:N;ga=ca}else{da=$;ea=-1;fa=N;ga=Z}Z=da<<24>>24;d:do if((Z&-32|0)==32){$=Z;ca=da;ba=0;aa=ga;while(1){if(!(1<<$+-32&75913)){ha=ca;ia=ba;ja=aa;break d}ka=1<<(ca<<24>>24)+-32|ba;la=aa+1|0;ma=a[la>>0]|0;$=ma<<24>>24;if(($&-32|0)!=32){ha=ma;ia=ka;ja=la;break}else{ca=ma;ba=ka;aa=la}}}else{ha=da;ia=0;ja=ga}while(0);do if(ha<<24>>24==42){Z=ja+1|0;aa=(a[Z>>0]|0)+-48|0;if(aa>>>0<10?(a[ja+2>>0]|0)==36:0){c[l+(aa<<2)>>2]=10;na=1;oa=ja+3|0;pa=c[j+((a[Z>>0]|0)+-48<<3)>>2]|0}else{if(fa){qa=-1;break a}if(!v){ra=ia;sa=0;ta=Z;ua=0;break}aa=(c[g>>2]|0)+(4-1)&~(4-1);ba=c[aa>>2]|0;c[g>>2]=aa+4;na=0;oa=Z;pa=ba}if((pa|0)<0){ra=ia|8192;sa=na;ta=oa;ua=0-pa|0}else{ra=ia;sa=na;ta=oa;ua=pa}}else{ba=(ha<<24>>24)+-48|0;if(ba>>>0<10){Z=ja;aa=0;ca=ba;while(1){ba=(aa*10|0)+ca|0;$=Z+1|0;ca=(a[$>>0]|0)+-48|0;if(ca>>>0>=10){va=ba;wa=$;break}else{Z=$;aa=ba}}if((va|0)<0){qa=-1;break a}else{ra=ia;sa=fa;ta=wa;ua=va}}else{ra=ia;sa=fa;ta=ja;ua=0}}while(0);e:do if((a[ta>>0]|0)==46){aa=ta+1|0;Z=a[aa>>0]|0;if(Z<<24>>24!=42){ca=(Z<<24>>24)+-48|0;if(ca>>>0<10){xa=aa;ya=0;za=ca}else{Aa=0;Ba=aa;break}while(1){aa=(ya*10|0)+za|0;ca=xa+1|0;za=(a[ca>>0]|0)+-48|0;if(za>>>0>=10){Aa=aa;Ba=ca;break e}else{xa=ca;ya=aa}}}aa=ta+2|0;ca=(a[aa>>0]|0)+-48|0;if(ca>>>0<10?(a[ta+3>>0]|0)==36:0){c[l+(ca<<2)>>2]=10;Aa=c[j+((a[aa>>0]|0)+-48<<3)>>2]|0;Ba=ta+4|0;break}if(sa){qa=-1;break a}if(v){ca=(c[g>>2]|0)+(4-1)&~(4-1);Z=c[ca>>2]|0;c[g>>2]=ca+4;Aa=Z;Ba=aa}else{Aa=0;Ba=aa}}else{Aa=-1;Ba=ta}while(0);aa=Ba;Z=0;while(1){ca=(a[aa>>0]|0)+-65|0;if(ca>>>0>57){qa=-1;break a}ba=aa+1|0;$=a[192856+(Z*58|0)+ca>>0]|0;ca=$&255;if((ca+-1|0)>>>0<8){aa=ba;Z=ca}else{Ca=ba;Da=$;Ea=ca;Fa=aa;Ga=Z;break}}if(!(Da<<24>>24)){qa=-1;break}Z=(ea|0)>-1;do if(Da<<24>>24==19)if(Z){qa=-1;break a}else S=52;else{if(Z){c[l+(ea<<2)>>2]=Ea;aa=j+(ea<<3)|0;ca=c[aa+4>>2]|0;$=r;c[$>>2]=c[aa>>2];c[$+4>>2]=ca;S=52;break}if(!v){qa=0;break a}E4(r,Ea,g)}while(0);if((S|0)==52?(S=0,!v):0){L=P;M=f;N=sa;O=Ca;continue}Z=a[Fa>>0]|0;ca=(Ga|0)!=0&(Z&15|0)==3?Z&-33:Z;Z=ra&-65537;$=(ra&8192|0)==0?ra:Z;f:do switch(ca|0){case 110:{switch(Ga|0){case 0:{c[c[r>>2]>>2]=P;L=P;M=f;N=sa;O=Ca;continue a;break}case 1:{c[c[r>>2]>>2]=P;L=P;M=f;N=sa;O=Ca;continue a;break}case 2:{aa=c[r>>2]|0;c[aa>>2]=P;c[aa+4>>2]=((P|0)<0)<<31>>31;L=P;M=f;N=sa;O=Ca;continue a;break}case 3:{b[c[r>>2]>>1]=P;L=P;M=f;N=sa;O=Ca;continue a;break}case 4:{a[c[r>>2]>>0]=P;L=P;M=f;N=sa;O=Ca;continue a;break}case 6:{c[c[r>>2]>>2]=P;L=P;M=f;N=sa;O=Ca;continue a;break}case 7:{aa=c[r>>2]|0;c[aa>>2]=P;c[aa+4>>2]=((P|0)<0)<<31>>31;L=P;M=f;N=sa;O=Ca;continue a;break}default:{L=P;M=f;N=sa;O=Ca;continue a}}break}case 112:{Ha=$|8;Ia=Aa>>>0>8?Aa:8;Ja=120;S=64;break}case 88:case 120:{Ha=$;Ia=Aa;Ja=ca;S=64;break}case 111:{aa=r;ba=c[aa>>2]|0;la=c[aa+4>>2]|0;if((ba|0)==0&(la|0)==0)Ka=w;else{aa=w;ka=ba;ba=la;while(1){la=aa+-1|0;a[la>>0]=ka&7|48;ka=X4(ka|0,ba|0,3)|0;ba=C;if((ka|0)==0&(ba|0)==0){Ka=la;break}else aa=la}}if(!($&8)){La=Ka;Ma=$;Na=Aa;Oa=0;Pa=193336;S=77}else{aa=x-Ka|0;La=Ka;Ma=$;Na=(Aa|0)>(aa|0)?Aa:aa+1|0;Oa=0;Pa=193336;S=77}break}case 105:case 100:{aa=r;ba=c[aa>>2]|0;ka=c[aa+4>>2]|0;if((ka|0)<0){aa=U4(0,0,ba|0,ka|0)|0;la=C;ma=r;c[ma>>2]=aa;c[ma+4>>2]=la;Qa=aa;Ra=la;Sa=1;Ta=193336;S=76;break f}if(!($&2048)){la=$&1;Qa=ba;Ra=ka;Sa=la;Ta=(la|0)==0?193336:193338;S=76}else{Qa=ba;Ra=ka;Sa=1;Ta=193337;S=76}break}case 117:{ka=r;Qa=c[ka>>2]|0;Ra=c[ka+4>>2]|0;Sa=0;Ta=193336;S=76;break}case 99:{a[y>>0]=c[r>>2];Ua=y;Va=Z;Wa=1;Xa=0;Ya=193336;Za=w;break}case 109:{_a=M1(c[(L1()|0)>>2]|0)|0;S=82;break}case 115:{ka=c[r>>2]|0;_a=(ka|0)!=0?ka:193346;S=82;break}case 67:{c[t>>2]=c[r>>2];c[s>>2]=0;c[r>>2]=t;$a=t;ab=-1;S=86;break}case 83:{ka=c[r>>2]|0;if(!Aa){G4(e,32,ua,0,$);bb=0;S=97}else{$a=ka;ab=Aa;S=86}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{cb=+h[r>>3];c[o>>2]=0;h[k>>3]=cb;if((c[k+4>>2]|0)>=0)if(!($&2048)){ka=$&1;db=cb;eb=ka;fb=(ka|0)==0?193354:193359}else{db=cb;eb=1;fb=193356}else{db=-cb;eb=1;fb=193353}h[k>>3]=db;ka=c[k+4>>2]&2146435072;do if(ka>>>0<2146435072|(ka|0)==2146435072&0<0){cb=+c2(db,o)*2.0;ba=cb!=0.0;if(ba)c[o>>2]=(c[o>>2]|0)+-1;la=ca|32;if((la|0)==97){aa=ca&32;ma=(aa|0)==0?fb:fb+9|0;gb=eb|2;hb=12-Aa|0;do if(!(Aa>>>0>11|(hb|0)==0)){ib=hb;jb=8.0;while(1){ib=ib+-1|0;kb=jb*16.0;if(!ib){lb=kb;break}else jb=kb}if((a[ma>>0]|0)==45){mb=-(lb+(-cb-lb));break}else{mb=cb+lb-lb;break}}else mb=cb;while(0);hb=c[o>>2]|0;ib=(hb|0)<0?0-hb|0:hb;nb=F4(ib,((ib|0)<0)<<31>>31,B)|0;if((nb|0)==(B|0)){a[D>>0]=48;ob=D}else ob=nb;a[ob+-1>>0]=(hb>>31&2)+43;hb=ob+-2|0;a[hb>>0]=ca+15;nb=(Aa|0)<1;ib=($&8|0)==0;jb=mb;pb=p;while(1){qb=~~jb;rb=pb+1|0;a[pb>>0]=d[193320+qb>>0]|aa;jb=(jb-+(qb|0))*16.0;do if((rb-z|0)==1){if(ib&(nb&jb==0.0)){sb=rb;break}a[rb>>0]=46;sb=pb+2|0}else sb=rb;while(0);if(!(jb!=0.0)){tb=sb;break}else pb=sb}pb=tb;nb=hb;ib=(Aa|0)!=0&(F+pb|0)<(Aa|0)?G+Aa-nb|0:E-nb+pb|0;aa=ib+gb|0;G4(e,32,ua,aa,$);if(!(c[e>>2]&32))g3(ma,gb,e)|0;G4(e,48,ua,aa,$^65536);rb=pb-z|0;if(!(c[e>>2]&32))g3(p,rb,e)|0;pb=q-nb|0;G4(e,48,ib-(rb+pb)|0,0,0);if(!(c[e>>2]&32))g3(hb,pb,e)|0;G4(e,32,ua,aa,$^8192);ub=(aa|0)<(ua|0)?ua:aa;break}aa=(Aa|0)<0?6:Aa;if(ba){pb=(c[o>>2]|0)+-28|0;c[o>>2]=pb;vb=cb*268435456.0;wb=pb}else{vb=cb;wb=c[o>>2]|0}pb=(wb|0)<0?n:H;rb=pb;jb=vb;ib=pb;while(1){nb=~~jb>>>0;c[ib>>2]=nb;qb=ib+4|0;jb=(jb-+(nb>>>0))*1.0e9;if(!(jb!=0.0)){xb=qb;break}else ib=qb}ib=c[o>>2]|0;if((ib|0)>0){ba=ib;hb=pb;gb=xb;while(1){ma=(ba|0)>29?29:ba;qb=gb+-4|0;do if(qb>>>0<hb>>>0)yb=hb;else{nb=0;zb=qb;while(1){Ab=a5(c[zb>>2]|0,0,ma|0)|0;Bb=V4(Ab|0,C|0,nb|0,0)|0;Ab=C;Cb=i5(Bb|0,Ab|0,1e9,0)|0;c[zb>>2]=Cb;Cb=h5(Bb|0,Ab|0,1e9,0)|0;zb=zb+-4|0;if(zb>>>0<hb>>>0){Db=Cb;break}else nb=Cb}if(!Db){yb=hb;break}nb=hb+-4|0;c[nb>>2]=Db;yb=nb}while(0);qb=gb;while(1){if(qb>>>0<=yb>>>0){Eb=qb;break}nb=qb+-4|0;if(!(c[nb>>2]|0))qb=nb;else{Eb=qb;break}}qb=(c[o>>2]|0)-ma|0;c[o>>2]=qb;if((qb|0)>0){ba=qb;hb=yb;gb=Eb}else{Fb=qb;Gb=yb;Hb=Eb;break}}}else{Fb=ib;Gb=pb;Hb=xb}if((Fb|0)<0){gb=((aa+25|0)/9|0)+1|0;hb=(la|0)==102;ba=Fb;qb=Gb;nb=Hb;while(1){zb=0-ba|0;Cb=(zb|0)>9?9:zb;do if(qb>>>0<nb>>>0){zb=(1<<Cb)+-1|0;Ab=1e9>>>Cb;Bb=0;Ib=qb;while(1){Jb=c[Ib>>2]|0;c[Ib>>2]=(Jb>>>Cb)+Bb;Kb=_(Jb&zb,Ab)|0;Ib=Ib+4|0;if(Ib>>>0>=nb>>>0){Lb=Kb;break}else Bb=Kb}Bb=(c[qb>>2]|0)==0?qb+4|0:qb;if(!Lb){Mb=Bb;Nb=nb;break}c[nb>>2]=Lb;Mb=Bb;Nb=nb+4|0}else{Mb=(c[qb>>2]|0)==0?qb+4|0:qb;Nb=nb}while(0);ma=hb?pb:Mb;Bb=(Nb-ma>>2|0)>(gb|0)?ma+(gb<<2)|0:Nb;ba=(c[o>>2]|0)+Cb|0;c[o>>2]=ba;if((ba|0)>=0){Ob=Mb;Pb=Bb;break}else{qb=Mb;nb=Bb}}}else{Ob=Gb;Pb=Hb}do if(Ob>>>0<Pb>>>0){nb=(rb-Ob>>2)*9|0;qb=c[Ob>>2]|0;if(qb>>>0<10){Qb=nb;break}else{Rb=nb;Sb=10}while(1){Sb=Sb*10|0;nb=Rb+1|0;if(qb>>>0<Sb>>>0){Qb=nb;break}else Rb=nb}}else Qb=0;while(0);qb=(la|0)==103;Cb=(aa|0)!=0;nb=aa-((la|0)!=102?Qb:0)+((Cb&qb)<<31>>31)|0;if((nb|0)<(((Pb-rb>>2)*9|0)+-9|0)){ba=nb+9216|0;nb=pb+4+(((ba|0)/9|0)+-1024<<2)|0;gb=((ba|0)%9|0)+1|0;if((gb|0)<9){ba=10;hb=gb;while(1){gb=ba*10|0;hb=hb+1|0;if((hb|0)==9){Tb=gb;break}else ba=gb}}else Tb=10;ba=c[nb>>2]|0;hb=(ba>>>0)%(Tb>>>0)|0;la=(nb+4|0)==(Pb|0);do if(la&(hb|0)==0){Ub=Ob;Vb=nb;Wb=Qb}else{jb=(((ba>>>0)/(Tb>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;gb=(Tb|0)/2|0;if(hb>>>0<gb>>>0)Xb=.5;else Xb=la&(hb|0)==(gb|0)?1.0:1.5;do if(!eb){Yb=jb;Zb=Xb}else{if((a[fb>>0]|0)!=45){Yb=jb;Zb=Xb;break}Yb=-jb;Zb=-Xb}while(0);gb=ba-hb|0;c[nb>>2]=gb;if(!(Yb+Zb!=Yb)){Ub=Ob;Vb=nb;Wb=Qb;break}ib=gb+Tb|0;c[nb>>2]=ib;if(ib>>>0>999999999){ib=Ob;gb=nb;while(1){Bb=gb+-4|0;c[gb>>2]=0;if(Bb>>>0<ib>>>0){ma=ib+-4|0;c[ma>>2]=0;_b=ma}else _b=ib;ma=(c[Bb>>2]|0)+1|0;c[Bb>>2]=ma;if(ma>>>0>999999999){ib=_b;gb=Bb}else{$b=_b;ac=Bb;break}}}else{$b=Ob;ac=nb}gb=(rb-$b>>2)*9|0;ib=c[$b>>2]|0;if(ib>>>0<10){Ub=$b;Vb=ac;Wb=gb;break}else{bc=gb;cc=10}while(1){cc=cc*10|0;gb=bc+1|0;if(ib>>>0<cc>>>0){Ub=$b;Vb=ac;Wb=gb;break}else bc=gb}}while(0);nb=Vb+4|0;dc=Ub;ec=Wb;fc=Pb>>>0>nb>>>0?nb:Pb}else{dc=Ob;ec=Qb;fc=Pb}nb=0-ec|0;hb=fc;while(1){if(hb>>>0<=dc>>>0){gc=0;hc=hb;break}ba=hb+-4|0;if(!(c[ba>>2]|0))hb=ba;else{gc=1;hc=hb;break}}do if(qb){hb=(Cb&1^1)+aa|0;if((hb|0)>(ec|0)&(ec|0)>-5){ic=ca+-1|0;jc=hb+-1-ec|0}else{ic=ca+-2|0;jc=hb+-1|0}hb=$&8;if(hb){kc=ic;lc=jc;mc=hb;break}do if(gc){hb=c[hc+-4>>2]|0;if(!hb){nc=9;break}if(!((hb>>>0)%10|0)){oc=10;pc=0}else{nc=0;break}while(1){oc=oc*10|0;ba=pc+1|0;if((hb>>>0)%(oc>>>0)|0){nc=ba;break}else pc=ba}}else nc=9;while(0);hb=((hc-rb>>2)*9|0)+-9|0;if((ic|32|0)==102){ba=hb-nc|0;la=(ba|0)<0?0:ba;kc=ic;lc=(jc|0)<(la|0)?jc:la;mc=0;break}else{la=hb+ec-nc|0;hb=(la|0)<0?0:la;kc=ic;lc=(jc|0)<(hb|0)?jc:hb;mc=0;break}}else{kc=ca;lc=aa;mc=$&8}while(0);aa=lc|mc;rb=(aa|0)!=0&1;Cb=(kc|32|0)==102;if(Cb){qc=(ec|0)>0?ec:0;rc=0}else{qb=(ec|0)<0?nb:ec;hb=F4(qb,((qb|0)<0)<<31>>31,B)|0;if((q-hb|0)<2){qb=hb;while(1){la=qb+-1|0;a[la>>0]=48;if((q-la|0)<2)qb=la;else{sc=la;break}}}else sc=hb;a[sc+-1>>0]=(ec>>31&2)+43;qb=sc+-2|0;a[qb>>0]=kc;qc=q-qb|0;rc=qb}qb=eb+1+lc+rb+qc|0;G4(e,32,ua,qb,$);if(!(c[e>>2]&32))g3(fb,eb,e)|0;G4(e,48,ua,qb,$^65536);do if(Cb){nb=dc>>>0>pb>>>0?pb:dc;la=nb;while(1){ba=F4(c[la>>2]|0,0,I)|0;do if((la|0)==(nb|0)){if((ba|0)!=(I|0)){tc=ba;break}a[K>>0]=48;tc=K}else{if(ba>>>0<=p>>>0){tc=ba;break}$4(p|0,48,ba-z|0)|0;ib=ba;while(1){gb=ib+-1|0;if(gb>>>0>p>>>0)ib=gb;else{tc=gb;break}}}while(0);if(!(c[e>>2]&32))g3(tc,J-tc|0,e)|0;ba=la+4|0;if(ba>>>0>pb>>>0){uc=ba;break}else la=ba}do if(aa){if(c[e>>2]&32)break;g3(193388,1,e)|0}while(0);if((lc|0)>0&uc>>>0<hc>>>0){la=lc;nb=uc;while(1){ba=F4(c[nb>>2]|0,0,I)|0;if(ba>>>0>p>>>0){$4(p|0,48,ba-z|0)|0;ib=ba;while(1){gb=ib+-1|0;if(gb>>>0>p>>>0)ib=gb;else{vc=gb;break}}}else vc=ba;if(!(c[e>>2]&32))g3(vc,(la|0)>9?9:la,e)|0;nb=nb+4|0;ib=la+-9|0;if(!((la|0)>9&nb>>>0<hc>>>0)){wc=ib;break}else la=ib}}else wc=lc;G4(e,48,wc+9|0,9,0)}else{la=gc?hc:dc+4|0;if((lc|0)>-1){nb=(mc|0)==0;ib=lc;gb=dc;while(1){Bb=F4(c[gb>>2]|0,0,I)|0;if((Bb|0)==(I|0)){a[K>>0]=48;xc=K}else xc=Bb;do if((gb|0)==(dc|0)){Bb=xc+1|0;if(!(c[e>>2]&32))g3(xc,1,e)|0;if(nb&(ib|0)<1){yc=Bb;break}if(c[e>>2]&32){yc=Bb;break}g3(193388,1,e)|0;yc=Bb}else{if(xc>>>0<=p>>>0){yc=xc;break}$4(p|0,48,xc+A|0)|0;Bb=xc;while(1){ma=Bb+-1|0;if(ma>>>0>p>>>0)Bb=ma;else{yc=ma;break}}}while(0);ba=J-yc|0;if(!(c[e>>2]&32))g3(yc,(ib|0)>(ba|0)?ba:ib,e)|0;Bb=ib-ba|0;gb=gb+4|0;if(!(gb>>>0<la>>>0&(Bb|0)>-1)){zc=Bb;break}else ib=Bb}}else zc=lc;G4(e,48,zc+18|0,18,0);if(c[e>>2]&32)break;g3(rc,q-rc|0,e)|0}while(0);G4(e,32,ua,qb,$^8192);ub=(qb|0)<(ua|0)?ua:qb}else{aa=(ca&32|0)!=0;pb=db!=db|0.0!=0.0;Cb=pb?0:eb;rb=Cb+3|0;G4(e,32,ua,rb,Z);hb=c[e>>2]|0;if(!(hb&32)){g3(fb,Cb,e)|0;Ac=c[e>>2]|0}else Ac=hb;if(!(Ac&32))g3(pb?(aa?193380:193384):aa?193372:193376,3,e)|0;G4(e,32,ua,rb,$^8192);ub=(rb|0)<(ua|0)?ua:rb}while(0);L=P;M=ub;N=sa;O=Ca;continue a;break}default:{Ua=O;Va=$;Wa=Aa;Xa=0;Ya=193336;Za=w}}while(0);g:do if((S|0)==64){S=0;ca=r;f=c[ca>>2]|0;ka=c[ca+4>>2]|0;ca=Ja&32;if(!((f|0)==0&(ka|0)==0)){rb=w;aa=f;f=ka;while(1){ka=rb+-1|0;a[ka>>0]=d[193320+(aa&15)>>0]|ca;aa=X4(aa|0,f|0,4)|0;f=C;if((aa|0)==0&(f|0)==0){Bc=ka;break}else rb=ka}rb=r;if((Ha&8|0)==0|(c[rb>>2]|0)==0&(c[rb+4>>2]|0)==0){La=Bc;Ma=Ha;Na=Ia;Oa=0;Pa=193336;S=77}else{La=Bc;Ma=Ha;Na=Ia;Oa=2;Pa=193336+(Ja>>4)|0;S=77}}else{La=w;Ma=Ha;Na=Ia;Oa=0;Pa=193336;S=77}}else if((S|0)==76){S=0;La=F4(Qa,Ra,w)|0;Ma=$;Na=Aa;Oa=Sa;Pa=Ta;S=77}else if((S|0)==82){S=0;rb=A3(_a,0,Aa)|0;f=(rb|0)==0;Ua=_a;Va=Z;Wa=f?Aa:rb-_a|0;Xa=0;Ya=193336;Za=f?_a+Aa|0:rb}else if((S|0)==86){S=0;rb=0;f=0;aa=$a;while(1){ca=c[aa>>2]|0;if(!ca){Cc=rb;Dc=f;break}ka=p2(u,ca)|0;if((ka|0)<0|ka>>>0>(ab-rb|0)>>>0){Cc=rb;Dc=ka;break}ca=ka+rb|0;if(ab>>>0>ca>>>0){rb=ca;f=ka;aa=aa+4|0}else{Cc=ca;Dc=ka;break}}if((Dc|0)<0){qa=-1;break a}G4(e,32,ua,Cc,$);if(!Cc){bb=0;S=97}else{aa=0;f=$a;while(1){rb=c[f>>2]|0;if(!rb){bb=Cc;S=97;break g}ka=p2(u,rb)|0;aa=ka+aa|0;if((aa|0)>(Cc|0)){bb=Cc;S=97;break g}if(!(c[e>>2]&32))g3(u,ka,e)|0;if(aa>>>0>=Cc>>>0){bb=Cc;S=97;break}else f=f+4|0}}}while(0);if((S|0)==97){S=0;G4(e,32,ua,bb,$^8192);L=P;M=(ua|0)>(bb|0)?ua:bb;N=sa;O=Ca;continue}if((S|0)==77){S=0;Z=(Na|0)>-1?Ma&-65537:Ma;f=r;aa=(c[f>>2]|0)!=0|(c[f+4>>2]|0)!=0;if((Na|0)!=0|aa){f=(aa&1^1)+(x-La)|0;Ua=La;Va=Z;Wa=(Na|0)>(f|0)?Na:f;Xa=Oa;Ya=Pa;Za=w}else{Ua=w;Va=Z;Wa=0;Xa=Oa;Ya=Pa;Za=w}}Z=Za-Ua|0;f=(Wa|0)<(Z|0)?Z:Wa;aa=Xa+f|0;ka=(ua|0)<(aa|0)?aa:ua;G4(e,32,ka,aa,Va);if(!(c[e>>2]&32))g3(Ya,Xa,e)|0;G4(e,48,ka,aa,Va^65536);G4(e,48,f,Z,0);if(!(c[e>>2]&32))g3(Ua,Z,e)|0;G4(e,32,ka,aa,Va^8192);L=P;M=ka;N=sa;O=Ca}h:do if((S|0)==244)if(!e)if(R){Ca=1;while(1){O=c[l+(Ca<<2)>>2]|0;if(!O){Ec=Ca;break}E4(j+(Ca<<3)|0,O,g);Ca=Ca+1|0;if((Ca|0)>=10){qa=1;break h}}if((Ec|0)<10){Ca=Ec;while(1){if(c[l+(Ca<<2)>>2]|0){qa=-1;break h}Ca=Ca+1|0;if((Ca|0)>=10){qa=1;break}}}else qa=1}else qa=0;else qa=Q;while(0);i=m;return qa|0}function v4(a,b,c){a=a|0;b=b|0;c=c|0;return N2(a,b,c)|0}function w4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+240|0;h=g;c[h>>2]=a;a:do if((e|0)>1){j=0-b|0;k=e;l=a;m=a;n=1;while(1){o=l+j|0;p=k+-2|0;q=o+(0-(c[f+(p<<2)>>2]|0))|0;if((Ob[d&127](m,q)|0)>-1?(Ob[d&127](m,o)|0)>-1:0){r=n;break a}s=n+1|0;t=h+(n<<2)|0;if((Ob[d&127](q,o)|0)>-1){c[t>>2]=q;u=q;v=k+-1|0}else{c[t>>2]=o;u=o;v=p}if((v|0)<=1){r=s;break a}k=v;l=u;m=c[h>>2]|0;n=s}}else r=1;while(0);C4(b,h,r);i=g;return}function x4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;j=i;i=i+240|0;k=j;l=c[e>>2]|0;m=c[e+4>>2]|0;c[k>>2]=a;e=0-b|0;a:do if((m|0)!=0|(l|0)!=1?(n=a+(0-(c[h+(f<<2)>>2]|0))|0,(Ob[d&127](n,a)|0)>=1):0){o=a;p=f;q=(g|0)==0;r=n;n=1;s=l;t=m;while(1){if(q&(p|0)>1){u=o+e|0;v=c[h+(p+-2<<2)>>2]|0;if((Ob[d&127](u,r)|0)>-1){w=o;x=p;y=n;z=19;break a}if((Ob[d&127](u+(0-v)|0,r)|0)>-1){w=o;x=p;y=n;z=19;break a}}v=n+1|0;c[k+(n<<2)>>2]=r;u=s+-1|0;do if(u){if(!(u&1)){A=u;B=0;while(1){C=B+1|0;A=A>>>1;if(A&1){D=C;break}else B=C}}else{if(!t)E=32;else{if(!(t&1)){F=t;G=0}else{H=0;I=s;J=t;K=0;break}while(1){B=G+1|0;F=F>>>1;if(F&1){E=B;break}else G=B}}D=E+32|0}if(D>>>0>31){L=D;z=15}else{H=D;I=s;J=t;K=D}}else{L=32;z=15}while(0);if((z|0)==15){z=0;H=L+-32|0;I=t;J=0;K=L}s=J<<32-H|I>>>H;t=J>>>H;u=K+p|0;if(!((t|0)!=0|(s|0)!=1)){w=r;x=u;y=v;z=19;break a}B=r+(0-(c[h+(u<<2)>>2]|0))|0;if((Ob[d&127](B,c[k>>2]|0)|0)<1){M=r;N=u;O=0;P=v;z=18;break}else{A=r;p=u;q=1;r=B;n=v;o=A}}}else{M=a;N=f;O=g;P=1;z=18}while(0);if((z|0)==18?(O|0)==0:0){w=M;x=N;y=P;z=19}if((z|0)==19){C4(b,k,y);w4(w,b,d,x,h)}i=j;return}function y4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0.0;e=i;i=i+112|0;f=e;g=f;h=g+112|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));g=f+4|0;c[g>>2]=a;h=f+8|0;c[h>>2]=-1;c[f+44>>2]=a;c[f+76>>2]=-1;Q1(f,0);j=+N1(f,d,1);d=(c[g>>2]|0)-(c[h>>2]|0)+(c[f+108>>2]|0)|0;if(b)c[b>>2]=(d|0)!=0?a+d|0:a;i=e;return +j}function z4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+112|0;h=g;c[h>>2]=0;j=h+4|0;c[j>>2]=a;c[h+44>>2]=a;k=h+8|0;c[k>>2]=(a|0)<0?-1:a+2147483647|0;c[h+76>>2]=-1;Q1(h,0);l=O1(h,d,1,e,f)|0;if(b)c[b>>2]=a+((c[j>>2]|0)+(c[h+108>>2]|0)-(c[k>>2]|0));i=g;return l|0}function A4(a){a=a|0;return}function B4(){return}function C4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+256|0;f=e;a:do if((d|0)>=2?(g=b+(d<<2)|0,c[g>>2]=f,(a|0)!=0):0){h=a;j=f;while(1){k=h>>>0>256?256:h;Z4(j|0,c[b>>2]|0,k|0)|0;l=0;do{m=b+(l<<2)|0;l=l+1|0;Z4(c[m>>2]|0,c[b+(l<<2)>>2]|0,k|0)|0;c[m>>2]=(c[m>>2]|0)+k}while((l|0)!=(d|0));if((h|0)==(k|0))break a;h=h-k|0;j=c[g>>2]|0}}while(0);i=e;return}function D4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=a+20|0;f=c[e>>2]|0;g=(c[a+16>>2]|0)-f|0;a=g>>>0>d>>>0?d:g;Z4(f|0,b|0,a|0)|0;c[e>>2]=(c[e>>2]|0)+a;return d|0}function E4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,i=0,j=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=f;break a;break}case 10:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;f=a;c[f>>2]=e;c[f+4>>2]=((e|0)<0)<<31>>31;break a;break}case 11:{e=(c[d>>2]|0)+(4-1)&~(4-1);f=c[e>>2]|0;c[d>>2]=e+4;e=a;c[e>>2]=f;c[e+4>>2]=0;break a;break}case 12:{e=(c[d>>2]|0)+(8-1)&~(8-1);f=e;g=c[f>>2]|0;i=c[f+4>>2]|0;c[d>>2]=e+8;e=a;c[e>>2]=g;c[e+4>>2]=i;break a;break}case 13:{i=(c[d>>2]|0)+(4-1)&~(4-1);e=c[i>>2]|0;c[d>>2]=i+4;i=(e&65535)<<16>>16;e=a;c[e>>2]=i;c[e+4>>2]=((i|0)<0)<<31>>31;break a;break}case 14:{i=(c[d>>2]|0)+(4-1)&~(4-1);e=c[i>>2]|0;c[d>>2]=i+4;i=a;c[i>>2]=e&65535;c[i+4>>2]=0;break a;break}case 15:{i=(c[d>>2]|0)+(4-1)&~(4-1);e=c[i>>2]|0;c[d>>2]=i+4;i=(e&255)<<24>>24;e=a;c[e>>2]=i;c[e+4>>2]=((i|0)<0)<<31>>31;break a;break}case 16:{i=(c[d>>2]|0)+(4-1)&~(4-1);e=c[i>>2]|0;c[d>>2]=i+4;i=a;c[i>>2]=e&255;c[i+4>>2]=0;break a;break}case 17:{i=(c[d>>2]|0)+(8-1)&~(8-1);j=+h[i>>3];c[d>>2]=i+8;h[a>>3]=j;break a;break}case 18:{i=(c[d>>2]|0)+(8-1)&~(8-1);j=+h[i>>3];c[d>>2]=i+8;h[a>>3]=j;break a;break}default:break a}while(0);while(0);return}function F4(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(c>>>0>0|(c|0)==0&b>>>0>4294967295){e=d;f=b;g=c;while(1){c=i5(f|0,g|0,10,0)|0;h=e+-1|0;a[h>>0]=c|48;c=h5(f|0,g|0,10,0)|0;if(g>>>0>9|(g|0)==9&f>>>0>4294967295){e=h;f=c;g=C}else{i=h;j=c;break}}k=i;l=j}else{k=d;l=b}if(!l)m=k;else{b=k;k=l;while(1){l=b+-1|0;a[l>>0]=(k>>>0)%10|0|48;if(k>>>0<10){m=l;break}else{b=l;k=(k>>>0)/10|0}}}return m|0}function G4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+256|0;h=g;do if((d|0)>(e|0)&(f&73728|0)==0){j=d-e|0;$4(h|0,b|0,(j>>>0>256?256:j)|0)|0;k=c[a>>2]|0;l=(k&32|0)==0;if(j>>>0>255){m=d-e|0;n=j;o=k;k=l;while(1){if(k){g3(h,256,a)|0;p=c[a>>2]|0}else p=o;n=n+-256|0;k=(p&32|0)==0;if(n>>>0<=255)break;else o=p}if(k)q=m&255;else break}else if(l)q=j;else break;g3(h,q,a)|0}while(0);i=g;return}function H4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;g=c[a>>2]|0;h=(g|0)>-1;a:do if(!d)if(h){i=b+32|0;j=g;k=a;do{if((c[b>>2]|0)>-1?(l=e+(j<<2)|0,c[l>>2]=(c[l>>2]|0)+1,(c[i>>2]|0)>-1):0){l=i;do{m=e+(c[k>>2]<<2)|0;c[m>>2]=(c[m>>2]|0)+1;l=l+32|0}while((c[l>>2]|0)>-1)}k=k+32|0;j=c[k>>2]|0}while((j|0)>-1);n=0}else n=0;else if(h){j=a;while(1){k=c[b>>2]|0;b:do if((k|0)>-1){i=j+4|0;l=j+8|0;m=j+16|0;o=j+20|0;p=j+24|0;q=j+28|0;r=j+12|0;s=b;t=k;u=-1;while(1){v=s;w=t;while(1){if((w|0)!=(u|0)){x=v;y=w;break}v=v+32|0;w=c[v>>2]|0;if((w|0)<=-1)break b}w=d+(c[f+(c[j>>2]<<2)>>2]<<5)|0;while(1){v=w+8|0;if(!(c[v>>2]|0)){z=v;A=w;break}else w=w+32|0}c[A+40>>2]=0;c[A>>2]=c[i>>2];c[A+4>>2]=c[l>>2];c[z>>2]=d+(c[f+(y<<2)>>2]<<5);c[A+12>>2]=y;w=c[o>>2]|0;v=c[x+16>>2]|c[m>>2]|((w|0)!=0?4:0)|((c[p>>2]|0)!=0?8:0);B=A+20|0;c[B>>2]=v;C=c[q>>2]|0;if((C|0)>-1){c[B>>2]=v|256;D=C}else D=w;c[A+24>>2]=D;w=c[p>>2]|0;if(!w)c[A+28>>2]=0;else{C=0;while(1){v=C+1|0;if(!(c[w+(C<<2)>>2]|0)){E=v;break}else C=v}C=N4(E<<2)|0;c[A+28>>2]=C;if(!C){n=12;break a}w=c[p>>2]|0;v=c[w>>2]|0;if(!v)F=C;else{B=v;v=C;G=0;while(1){c[v>>2]=B;G=G+1|0;B=c[w+(G<<2)>>2]|0;H=C+(G<<2)|0;if(!B){F=H;break}else v=H}}c[F>>2]=0}v=c[r>>2]|0;if(!v)I=0;else{B=0;while(1)if((c[v+(B<<2)>>2]|0)>-1)B=B+1|0;else{I=B;break}}B=x+12|0;v=c[B>>2]|0;if(!v)J=0;else{G=0;while(1)if((c[v+(G<<2)>>2]|0)>-1)G=G+1|0;else{J=G;break}}G=A+16|0;v=c[G>>2]|0;if(v)O4(v);c[G>>2]=0;v=J+I|0;if((v|0)>0){C=N4((v<<2)+4|0)|0;c[G>>2]=C;if(!C){n=12;break a}G=c[r>>2]|0;if((G|0)!=0?(v=c[G>>2]|0,(v|0)>-1):0){w=v;v=0;while(1){c[C+(v<<2)>>2]=w;H=v+1|0;w=c[G+(H<<2)>>2]|0;if((w|0)<=-1){K=H;break}else v=H}}else K=0;v=c[B>>2]|0;if((v|0)!=0?(w=c[v>>2]|0,(w|0)>-1):0){G=(K|0)>0;H=w;w=0;L=K;while(1){c:do if(G){M=0;while(1){if((c[C+(M<<2)>>2]|0)==(H|0)){N=L;break c}M=M+1|0;if((M|0)>=(K|0)){O=39;break}}}else O=39;while(0);if((O|0)==39){O=0;c[C+(L<<2)>>2]=H;N=L+1|0}w=w+1|0;H=c[v+(w<<2)>>2]|0;if((H|0)<=-1){P=N;break}else L=N}}else P=K;c[C+(P<<2)>>2]=-1}L=x+32|0;H=c[L>>2]|0;if((H|0)>-1){s=L;t=H;u=y}else break}}while(0);j=j+32|0;if((c[j>>2]|0)<=-1){n=0;break}}}else n=0;while(0);return n|0}function I4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=B2(a,0,0,0,8)|0;do if(e){f=h4(a,0,20)|0;if(!f){c[e>>2]=0;g=12;break}h=c[f+4>>2]|0;c[h>>2]=-3;c[h+4>>2]=d;c[h+8>>2]=-1;c[e>>2]=f;f=B2(a,0,0,0,32)|0;c[e+4>>2]=f;if(f){h=b+4|0;c[f+4>>2]=c[h>>2];c[f>>2]=c[b>>2];c[f+8>>2]=-1;c[f+12>>2]=-1;c[f+24>>2]=0;c[f+28>>2]=0;c[f+20>>2]=0;c[h>>2]=e;c[b>>2]=1;g=0}else g=12}else g=12;while(0);return g|0}function J4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=c[a>>2]|0;if((e|0)>-1){f=c[b+16>>2]|0;b=e;e=0;do{g=(b|0)/2|0;if(!(b&1))c[f+(g*12|0)>>2]=d;else c[f+(g*12|0)+4>>2]=d;e=e+1|0;b=c[a+(e<<2)>>2]|0}while((b|0)>-1)}c[a>>2]=-1;return}function K4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=B2(a,0,0,0,8)|0;do if(e){f=h4(a,0,20)|0;if(!f){c[e+4>>2]=0;g=12;break}h=c[f+4>>2]|0;c[h>>2]=-3;c[h+4>>2]=d;c[h+8>>2]=-1;c[e+4>>2]=f;f=B2(a,0,0,0,32)|0;c[e>>2]=f;if(f){h=b+4|0;c[f+4>>2]=c[h>>2];c[f>>2]=c[b>>2];c[f+8>>2]=-1;c[f+12>>2]=-1;c[f+24>>2]=0;c[f+28>>2]=0;c[f+20>>2]=0;c[h>>2]=e;c[b>>2]=1;g=0}else g=12}else g=12;while(0);return g|0}function L4(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;h=c[g>>2]|0;i=c[f>>2]|0;if((c[e>>2]|0)>=(i|0))if((i|0)<=1024?(c[f>>2]=i<<1,f=Q4(h,i<<3)|0,(f|0)!=0):0){c[g>>2]=f;j=f;k=5}else l=12;else{j=h;k=5}if((k|0)==5){k=h4(a,0,20)|0;if(!k)m=0;else{a=c[k+4>>2]|0;c[a>>2]=b;c[a+4>>2]=d;c[a+8>>2]=-1;m=k}k=c[e>>2]|0;c[j+(k<<2)>>2]=m;c[e>>2]=k+1;l=(m|0)==0?12:0}return l|0}function M4(a,b){a=a|0;b=b|0;var d=0;d=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;return ((d|0)<(a|0)?-1:(d|0)>(a|0)&1)|0}
function CL(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0;j=i;i=i+208|0;k=j+112|0;l=j+104|0;m=j+56|0;n=j;o=j+196|0;p=j+192|0;q=j+188|0;r=j+184|0;s=j+180|0;t=j+176|0;u=j+172|0;v=j+168|0;c[p>>2]=a;c[q>>2]=b;c[r>>2]=e;c[s>>2]=f;c[t>>2]=g;g=c[24742]|0;f=c[s>>2]|0;e=d[(c[t>>2]|0)+32>>0]|0;w=+h[c[t>>2]>>3];x=+h[(c[t>>2]|0)+8>>3];y=+h[(c[t>>2]|0)+16>>3];z=+h[(c[t>>2]|0)+16+8>>3];c[n>>2]=c[q>>2];c[n+4>>2]=f;c[n+8>>2]=e;h[n+16>>3]=w;h[n+24>>3]=x;h[n+32>>3]=y;h[n+40>>3]=z;Y2(g,141696,n)|0;if((d[138998]|0|0)<2){c[o>>2]=0;A=c[o>>2]|0;i=j;return A|0}Y2(c[24742]|0,141756,j+48|0)|0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[q>>2]|0))break;c[v>>2]=c[(c[p>>2]|0)+32>>2];n=c[24742]|0;z=+h[c[p>>2]>>3];y=+h[(c[p>>2]|0)+8>>3];x=+h[(c[p>>2]|0)+16>>3];w=+h[(c[p>>2]|0)+16+8>>3];g=c[(c[p>>2]|0)+32>>2]|0;if(c[v>>2]|0)B=c[c[(c[v>>2]|0)+32>>2]>>2]|0;else B=178518;c[m>>2]=c[u>>2];h[m+8>>3]=z;h[m+16>>3]=y;h[m+24>>3]=x;h[m+32>>3]=w;c[m+40>>2]=g;c[m+44>>2]=B;Y2(n,141765,m)|0;c[p>>2]=(c[p>>2]|0)+40;c[u>>2]=(c[u>>2]|0)+1}Y2(c[24742]|0,141808,l)|0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[s>>2]|0))break;l=c[24742]|0;p=c[r>>2]|0;m=d[(c[r>>2]|0)+36>>0]|0;w=+h[(c[r>>2]|0)+16>>3];x=+h[(c[r>>2]|0)+16+8>>3];y=+h[c[r>>2]>>3];z=+h[(c[r>>2]|0)+8>>3];B=c[c[(c[r>>2]|0)+32>>2]>>2]|0;c[k>>2]=c[u>>2];c[k+4>>2]=p;c[k+8>>2]=m;h[k+16>>3]=w;h[k+24>>3]=x;h[k+32>>3]=y;h[k+40>>3]=z;c[k+48>>2]=B;Y2(l,141817,k)|0;c[r>>2]=(c[r>>2]|0)+40;c[u>>2]=(c[u>>2]|0)+1}c[o>>2]=0;A=c[o>>2]|0;i=j;return A|0}function DL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=d+16|0;f=d;c[e>>2]=b;b=(c[e>>2]|0)+16|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];h[f>>3]=+h[f>>3]+ +h[c[e>>2]>>3]/2.0;b=f+8|0;h[b>>3]=+h[b>>3]+ +h[(c[e>>2]|0)+8>>3]/2.0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=d;return}function EL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0;e=i;i=i+32|0;f=e+16|0;g=e;c[f>>2]=b;if(+h[d>>3]<+h[c[f>>2]>>3])j=+h[d>>3];else j=+h[c[f>>2]>>3];h[d>>3]=j;if(+h[d+8>>3]<+h[(c[f>>2]|0)+8>>3])k=+h[d+8>>3];else k=+h[(c[f>>2]|0)+8>>3];h[d+8>>3]=k;h[g>>3]=+h[c[f>>2]>>3]+ +h[(c[f>>2]|0)+16>>3];h[g+8>>3]=+h[(c[f>>2]|0)+8>>3]+ +h[(c[f>>2]|0)+16+8>>3];h[d+16>>3]=+h[d+16>>3]>+h[g>>3]?+h[d+16>>3]:+h[g>>3];if(+h[d+16+8>>3]>+h[g+8>>3])l=+h[d+16+8>>3];else l=+h[g+8>>3];h[d+16+8>>3]=l;c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];c[a+28>>2]=c[d+28>>2];i=e;return}function FL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+24|0;f=b+20|0;g=b+16|0;j=b+12|0;k=b+8|0;l=b+4|0;c[e>>2]=a;a=sO(yA(c[e>>2]|0,143103)|0)|0;c[g>>2]=a;if(!a){c[d>>2]=wB(c[e>>2]|0)|0;$z(0,141865,d)|0;i=b;return}c[j>>2]=LL(c[g>>2]|0)|0;if(!(c[j>>2]|0)){i=b;return}c[k>>2]=c[(c[j>>2]|0)+40>>2];c[l>>2]=c[(c[j>>2]|0)+44>>2];h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3]=+(c[k>>2]|0)/72.0;h[(c[(c[e>>2]|0)+8>>2]|0)+40>>3]=+(c[l>>2]|0)/72.0;g=bK(12)|0;c[f>>2]=g;c[(c[(c[e>>2]|0)+8>>2]|0)+12>>2]=g;c[c[f>>2]>>2]=c[(c[j>>2]|0)+12>>2];c[(c[f>>2]|0)+4>>2]=0-(c[(c[j>>2]|0)+32>>2]|0)-((c[k>>2]|0)/2|0);c[(c[f>>2]|0)+4+4>>2]=0-(c[(c[j>>2]|0)+36>>2]|0)-((c[l>>2]|0)/2|0);i=b;return}function GL(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[(c[(c[d>>2]|0)+8>>2]|0)+12>>2]|0)){i=b;return}O4(c[(c[(c[d>>2]|0)+8>>2]|0)+12>>2]|0);i=b;return}function HL(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=i;i=i+64|0;h=g+8|0;j=g;k=g+44|0;l=g+40|0;m=g+36|0;n=g+32|0;o=g+28|0;p=g+24|0;q=g+20|0;r=g+16|0;s=g+12|0;t=g+48|0;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;a[t>>0]=1;a:do if(c[l>>2]|0){c[s>>2]=0;while(1){if(!(d[t>>0]|0))break a;f=c[(c[l>>2]|0)+(c[s>>2]<<2)>>2]|0;c[q>>2]=f;if(!f)break a;if(!(a[c[q>>2]>>0]|0))a[t>>0]=0;c[s>>2]=(c[s>>2]|0)+1}}while(0);b:do if(a[t>>0]|0){c[o>>2]=c[m>>2];while(1){if(!(c[c[o>>2]>>2]|0))break b;jF(c[k>>2]|0,c[c[o>>2]>>2]|0)|0;jF(c[k>>2]|0,193392)|0;c[o>>2]=(c[o>>2]|0)+4}}while(0);if(!(c[l>>2]|0)){i=g;return}c[s>>2]=0;while(1){o=c[(c[l>>2]|0)+(c[s>>2]<<2)>>2]|0;c[q>>2]=o;if(!o)break;do if(a[c[q>>2]>>0]|0){c[r>>2]=sO(c[q>>2]|0)|0;if(!(c[r>>2]|0)){c[j>>2]=c[q>>2];$z(0,141914,j)|0;break}o=X2(c[r>>2]|0,176526)|0;c[n>>2]=o;if(!o){c[h>>2]=c[r>>2];$z(0,141942,h)|0;break}while(1){o=rO(c[n>>2]|0)|0;c[p>>2]=o;u=c[k>>2]|0;if(!o)break;jF(u,c[p>>2]|0)|0}jF(u,193392)|0;R2(c[n>>2]|0)|0}while(0);c[s>>2]=(c[s>>2]|0)+1}i=g;return}function IL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[f>>2]=b;c[g>>2]=d;c[h>>2]=c[(c[g>>2]|0)+52>>2];a:while(1){if(!(a[c[h>>2]>>0]|0))break;do if((a[c[h>>2]>>0]|0)==37?(a[(c[h>>2]|0)+1>>0]|0)==37:0){if((((O3((c[h>>2]|0)+2|0,141970,3)|0)!=0?(O3((c[h>>2]|0)+2|0,141974,5)|0)!=0:0)?(O3((c[h>>2]|0)+2|0,141980,3)|0)!=0:0)?(O3((c[h>>2]|0)+2|0,141984,7)|0)!=0:0)break;while(1){g=a[c[h>>2]>>0]|0;a[j>>0]=g;if((g<<24>>24|0)!=0?(a[j>>0]|0)!=13:0)k=(a[j>>0]|0)!=10;else k=0;l=c[h>>2]|0;if(!k)break;c[h>>2]=l+1}if((a[l>>0]|0)==13?(a[(c[h>>2]|0)+1>>0]|0)==10:0){c[h>>2]=(c[h>>2]|0)+2;continue a}if(!(a[c[h>>2]>>0]|0))continue a;c[h>>2]=(c[h>>2]|0)+1;continue a}while(0);while(1){g=a[c[h>>2]>>0]|0;a[j>>0]=g;if(!(g<<24>>24))break;if((a[j>>0]|0)==13)break;if((a[j>>0]|0)==10)break;kF(c[f>>2]|0,a[j>>0]|0)|0;c[h>>2]=(c[h>>2]|0)+1}if((a[c[h>>2]>>0]|0)==13?(a[(c[h>>2]|0)+1>>0]|0)==10:0)c[h>>2]=(c[h>>2]|0)+2;else m=26;if((m|0)==26?(m=0,(a[c[h>>2]>>0]|0)!=0):0)c[h>>2]=(c[h>>2]|0)+1;kF(c[f>>2]|0,10)|0}i=e;return}function JL(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;g=d+4|0;c[f>>2]=b;if(!(c[13985]|0)){i=d;return}c[g>>2]=Hb[c[c[13985]>>2]&63](c[13985]|0,0,128)|0;while(1){if(!(c[g>>2]|0))break;if(!(a[(c[g>>2]|0)+16>>0]|0)){b=c[f>>2]|0;c[e>>2]=c[(c[g>>2]|0)+12>>2];oF(b,141992,e);jF(c[f>>2]|0,142010)|0;IL(c[f>>2]|0,c[g>>2]|0);jF(c[f>>2]|0,142028)|0;jF(c[f>>2]|0,142043)|0}c[g>>2]=Hb[c[c[13985]>>2]&63](c[13985]|0,c[g>>2]|0,8)|0}i=d;return}function KL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+32|0;f=e+20|0;g=e+16|0;h=e+12|0;j=e+8|0;k=e+4|0;c[f>>2]=b;c[g>>2]=d;a:do switch(c[g>>2]|0){case 0:{c[j>>2]=c[f>>2];break}case 1:{c[j>>2]=LO(c[f>>2]|0)|0;break}default:switch(ML(c[f>>2]|0)|0){case 0:{c[j>>2]=c[f>>2];break a;break}case 1:{c[j>>2]=LO(c[f>>2]|0)|0;break a;break}case 2:{if(!(c[13986]|0)){$z(0,142055,e)|0;c[13986]=1}c[j>>2]=c[f>>2];break a;break}default:{c[j>>2]=c[f>>2];break a}}}while(0);if(!(c[13987]|0))dA(55948,0,0);if((c[13988]|0)>>>0>=(c[13989]|0)>>>0)eA(55948,1)|0;g=c[13988]|0;c[13988]=g+1;a[g>>0]=40;c[k>>2]=40;c[h>>2]=c[j>>2];while(1){if(!(a[c[h>>2]>>0]|0))break;if(!(((a[c[h>>2]>>0]|0)!=40?(a[c[h>>2]>>0]|0)!=41:0)?(a[c[h>>2]>>0]|0)!=92:0)){if((c[13988]|0)>>>0>=(c[13989]|0)>>>0)eA(55948,1)|0;g=c[13988]|0;c[13988]=g+1;a[g>>0]=92;c[k>>2]=92}if((c[13988]|0)>>>0>=(c[13989]|0)>>>0)eA(55948,1)|0;g=c[h>>2]|0;c[h>>2]=g+1;d=a[g>>0]|0;g=c[13988]|0;c[13988]=g+1;a[g>>0]=d;c[k>>2]=d&255}if((c[13988]|0)>>>0>=(c[13989]|0)>>>0)eA(55948,1)|0;k=c[13988]|0;c[13988]=k+1;a[k>>0]=41;if((c[j>>2]|0)!=(c[f>>2]|0))O4(c[j>>2]|0);if((c[13988]|0)>>>0<(c[13989]|0)>>>0){l=c[13988]|0;m=l+1|0;c[13988]=m;a[l>>0]=0;n=c[13987]|0;c[13988]=n;c[h>>2]=n;o=c[h>>2]|0;i=e;return o|0}eA(55948,1)|0;l=c[13988]|0;m=l+1|0;c[13988]=m;a[l>>0]=0;n=c[13987]|0;c[13988]=n;c[h>>2]=n;o=c[h>>2]|0;i=e;return o|0}function LL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;i=i+1184|0;e=d+24|0;f=d+8|0;g=d;h=d+148|0;j=d+144|0;k=d+140|0;l=d+152|0;m=d+136|0;n=d+60|0;o=d+56|0;p=d+52|0;q=d+48|0;r=d+44|0;s=d+40|0;t=d+36|0;u=d+32|0;v=d+28|0;c[j>>2]=b;if(!(c[13985]|0))c[13985]=Nz(55964,c[12989]|0)|0;c[v>>2]=Hb[c[c[13985]>>2]&63](c[13985]|0,c[j>>2]|0,512)|0;if(c[v>>2]|0){c[h>>2]=c[v>>2];w=c[h>>2]|0;i=d;return w|0}b=X2(c[j>>2]|0,176526)|0;c[m>>2]=b;if(!b){c[g>>2]=c[j>>2];$z(0,142145,g)|0;c[h>>2]=0;w=c[h>>2]|0;i=d;return w|0}c[p>>2]=0;c[o>>2]=0;do{if(!(V2(l,1024,c[m>>2]|0)|0))break;c[f>>2]=r;c[f+4>>2]=s;c[f+8>>2]=t;c[f+12>>2]=u;if((l3(l,142173,f)|0)==4)c[o>>2]=1;if((a[l>>0]|0)!=37?(U3(l,142202)|0)!=0:0)c[p>>2]=1}while(!((c[o>>2]|0)!=0&(c[p>>2]|0)!=0));if(c[o>>2]|0){c[v>>2]=cK(64)|0;c[(c[v>>2]|0)+32>>2]=c[r>>2];c[(c[v>>2]|0)+36>>2]=c[s>>2];c[(c[v>>2]|0)+40>>2]=(c[t>>2]|0)-(c[r>>2]|0);c[(c[v>>2]|0)+36>>2]=(c[u>>2]|0)-(c[s>>2]|0);c[(c[v>>2]|0)+8>>2]=c[j>>2];s=c[14e3]|0;c[14e3]=s+1;c[(c[v>>2]|0)+12>>2]=s;C2(W2(c[m>>2]|0)|0,n)|0;s=cK((c[n+36>>2]|0)+1|0)|0;c[(c[v>>2]|0)+52>>2]=s;c[k>>2]=s;c3(c[m>>2]|0,0,0)|0;c[q>>2]=$2(c[k>>2]|0,c[n+36>>2]|0,1,c[m>>2]|0)|0;a[(c[k>>2]|0)+(c[n+36>>2]|0)>>0]=0;Hb[c[c[13985]>>2]&63](c[13985]|0,c[v>>2]|0,1)|0;a[(c[v>>2]|0)+16>>0]=c[p>>2]}else{c[e>>2]=c[j>>2];$z(0,142207,e)|0;c[v>>2]=0}R2(c[m>>2]|0)|0;c[h>>2]=c[v>>2];w=c[h>>2]|0;i=d;return w|0}function ML(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;j=e+12|0;c[g>>2]=b;c[h>>2]=0;while(1){b=c[g>>2]|0;c[g>>2]=b+1;k=a[b>>0]|0;a[j>>0]=k;if(!(k<<24>>24)){l=7;break}if((d[j>>0]|0|0)<127)continue;if(((d[j>>0]|0)&252|0)!=192){l=6;break}c[h>>2]=1;c[g>>2]=(c[g>>2]|0)+1}if((l|0)==6){c[f>>2]=2;m=c[f>>2]|0;i=e;return m|0}else if((l|0)==7){c[f>>2]=c[h>>2];m=c[f>>2]|0;i=e;return m|0}return 0}function NL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e+4|0;c[e+8>>2]=a;c[f>>2]=b;c[e>>2]=d;O4(c[(c[f>>2]|0)+52>>2]|0);i=e;return}function OL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+112|0;j=g+104|0;k=g+96|0;l=g+92|0;m=g+88|0;n=g+80|0;o=g+72|0;p=g+32|0;q=g;r=g+64|0;c[l>>2]=e;c[m>>2]=f;h[p>>3]=+h[a>>3];h[p+8>>3]=+h[a+8>>3];h[p+16>>3]=+h[b>>3];h[p+16+8>>3]=+h[b+8>>3];if((NX(d,p,n)|0)<0){c[k>>2]=0;s=c[k>>2]|0;i=g;return s|0}if(!(c[m>>2]|0)){if((c[d+4>>2]|0)>(c[14001]|0)){if(c[14002]|0)t=eK(c[14002]|0,c[d+4>>2]<<5)|0;else t=cK(c[d+4>>2]<<5)|0;c[14002]=t;c[14001]=c[d+4>>2]}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[d+4>>2]|0))break;t=(c[14002]|0)+(c[r>>2]<<5)|0;m=(c[d>>2]|0)+(c[r>>2]<<4)|0;c[t>>2]=c[m>>2];c[t+4>>2]=c[m+4>>2];c[t+8>>2]=c[m+8>>2];c[t+12>>2]=c[m+12>>2];m=(c[14002]|0)+(c[r>>2]<<5)+16|0;t=(c[d>>2]|0)+((((c[r>>2]|0)+1|0)%(c[d+4>>2]|0)|0)<<4)|0;c[m>>2]=c[t>>2];c[m+4>>2]=c[t+4>>2];c[m+8>>2]=c[t+8>>2];c[m+12>>2]=c[t+12>>2];c[r>>2]=(c[r>>2]|0)+1}h[q+8>>3]=0.0;h[q>>3]=0.0;h[q+16+8>>3]=0.0;h[q+16>>3]=0.0;t=c[14002]|0;m=c[d+4>>2]|0;c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];if((rX(t,m,j,q,o)|0)<0){c[k>>2]=0;s=c[k>>2]|0;i=g;return s|0}}else{c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];iY(j,o)}if(VL(c[o+4>>2]|0)|0){c[k>>2]=0;s=c[k>>2]|0;i=g;return s|0}c[r>>2]=0;while(1){if((c[r>>2]|0)>=(c[o+4>>2]|0))break;j=(c[14003]|0)+(c[r>>2]<<4)|0;n=(c[o>>2]|0)+(c[r>>2]<<4)|0;c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];c[r>>2]=(c[r>>2]|0)+1}c[c[l>>2]>>2]=c[o+4>>2];c[k>>2]=c[14003];s=c[k>>2]|0;i=g;return s|0}function PL(){var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;e=b+4|0;f=(c[14004]|0)+1|0;c[14004]=f;do if((f|0)>1)c[e>>2]=0;else{g=cK(4800)|0;c[14003]=g;if(!g){$z(1,142246,d)|0;c[e>>2]=1;break}c[14005]=300;c[14006]=0;c[14007]=0;if(a[138998]|0)_N();c[e>>2]=0}while(0);i=b;return c[e>>2]|0}function QL(){var b=0,d=0,e=0,f=0,g=0,j=0.0;b=i;i=i+16|0;d=b;e=(c[14004]|0)+-1|0;c[14004]=e;if((e|0)>0){i=b;return}O4(c[14003]|0);if(!(a[138998]|0)){i=b;return}e=c[24742]|0;f=c[14006]|0;g=c[14007]|0;j=+$N();c[d>>2]=f;c[d+4>>2]=g;h[d+8>>3]=j;Y2(e,142284,d)|0;i=b;return}function RL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=WL(c[e>>2]|0,c[f>>2]|0,0)|0;i=d;return b|0}function SL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;b=WL(c[e>>2]|0,c[f>>2]|0,1)|0;i=d;return b|0}function TL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+112|0;g=f+108|0;h=f+104|0;j=f+100|0;k=f+96|0;l=f+92|0;m=f+88|0;n=f+8|0;o=f+4|0;p=f;c[g>>2]=a;c[h>>2]=b;c[j>>2]=d;c[k>>2]=e;c[p>>2]=1;c[l>>2]=c[h>>2];while(1){e=c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2]|0;c[l>>2]=e;q=c[p>>2]|0;if(!e)break;c[p>>2]=q+1}if((q|0)<=20)c[m>>2]=n;else c[m>>2]=bK(c[p>>2]<<2)|0;c[l>>2]=c[h>>2];c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[p>>2]|0))break;c[(c[m>>2]|0)+(c[o>>2]<<2)>>2]=c[l>>2];c[l>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+172>>2];c[o>>2]=(c[o>>2]|0)+1}UL(c[g>>2]|0,c[m>>2]|0,c[p>>2]|0,c[j>>2]|0,c[k>>2]|0);if((c[p>>2]|0)<=20){i=f;return}O4(c[m>>2]|0);i=f;return}function UL(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;j=i;i=i+416|0;k=j+328|0;l=j+312|0;m=j+412|0;n=j+408|0;o=j+404|0;p=j+400|0;q=j+396|0;r=j+248|0;s=j+392|0;t=j+388|0;u=j+384|0;v=j+232|0;w=j+216|0;x=j+380|0;y=j+376|0;z=j+372|0;A=j+368|0;B=j+364|0;C=j+360|0;D=j+208|0;E=j+144|0;F=j+128|0;G=j+112|0;H=j+96|0;I=j+80|0;J=j+64|0;K=j;L=j+352|0;M=j+344|0;c[m>>2]=a;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[u>>2]=(c[p>>2]|0)==4&1;c[y>>2]=c[c[n>>2]>>2];g=c[y>>2]|0;c[s>>2]=c[((c[c[y>>2]>>2]&3|0)==3?g:g+32|0)+28>>2];g=c[y>>2]|0;c[t>>2]=c[((c[c[y>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2];g=r+16|0;f=(c[(c[s>>2]|0)+8>>2]|0)+16|0;s=(c[(c[y>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[f>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];c[k>>2]=c[s>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];c[k+12>>2]=c[s+12>>2];XL(H,l,k);c[r>>2]=c[H>>2];c[r+4>>2]=c[H+4>>2];c[r+8>>2]=c[H+8>>2];c[r+12>>2]=c[H+12>>2];c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[F>>2]=c[g>>2];c[F+4>>2]=c[g+4>>2];c[F+8>>2]=c[g+8>>2];c[F+12>>2]=c[g+12>>2];g=r+32|0;H=r+48|0;s=(c[(c[t>>2]|0)+8>>2]|0)+16|0;f=(c[(c[y>>2]|0)+8>>2]|0)+56|0;c[l>>2]=c[s>>2];c[l+4>>2]=c[s+4>>2];c[l+8>>2]=c[s+8>>2];c[l+12>>2]=c[s+12>>2];c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[k+12>>2]=c[f+12>>2];XL(I,l,k);c[H>>2]=c[I>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];c[H+12>>2]=c[I+12>>2];c[g>>2]=c[H>>2];c[g+4>>2]=c[H+4>>2];c[g+8>>2]=c[H+8>>2];c[g+12>>2]=c[H+12>>2];c[G>>2]=c[g>>2];c[G+4>>2]=c[g+4>>2];c[G+8>>2]=c[g+8>>2];c[G+12>>2]=c[g+12>>2];if((c[o>>2]|0)!=1?(d[139e3]|0|0)==0:0){c[x>>2]=c[y>>2];if((+h[r>>3]-+h[r+48>>3])*(+h[r>>3]-+h[r+48>>3])+(+h[r+8>>3]-+h[r+48+8>>3])*(+h[r+8>>3]-+h[r+48+8>>3])<1.0e-06){g=r+16|0;c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];g=r+32|0;H=r+48|0;c[g>>2]=c[H>>2];c[g+4>>2]=c[H+4>>2];c[g+8>>2]=c[H+8>>2];c[g+12>>2]=c[H+12>>2];h[w>>3]=0.0;h[w+8>>3]=0.0}else{h[v>>3]=+h[r+8>>3]-+h[r+48+8>>3];h[v+8>>3]=+h[r+48>>3]-+h[r>>3];h[D>>3]=+O(+(+h[v>>3]*+h[v>>3]+ +h[v+8>>3]*+h[v+8>>3]));c[B>>2]=c[(c[(c[(c[m>>2]|0)+48>>2]|0)+8>>2]|0)+248>>2];c[C>>2]=(_(c[B>>2]|0,(c[o>>2]|0)-1|0)|0)/2|0;h[r+16>>3]=+h[r>>3]+ +(c[C>>2]|0)*+h[v>>3]/+h[D>>3];h[r+16+8>>3]=+h[r+8>>3]+ +(c[C>>2]|0)*+h[v+8>>3]/+h[D>>3];h[r+32>>3]=+h[r+48>>3]+ +(c[C>>2]|0)*+h[v>>3]/+h[D>>3];h[r+32+8>>3]=+h[r+48+8>>3]+ +(c[C>>2]|0)*+h[v+8>>3]/+h[D>>3];h[w>>3]=+(0-(c[B>>2]|0)|0)*+h[v>>3]/+h[D>>3];h[w+8>>3]=+(0-(c[B>>2]|0)|0)*+h[v+8>>3]/+h[D>>3]}c[z>>2]=0;while(1){if((c[z>>2]|0)>=(c[o>>2]|0))break;c[x>>2]=c[(c[n>>2]|0)+(c[z>>2]<<2)>>2];D=c[x>>2]|0;a:do if((c[((c[c[x>>2]>>2]&3|0)==2?D:D+-32|0)+28>>2]|0)==(c[t>>2]|0)){c[F>>2]=c[r>>2];c[F+4>>2]=c[r+4>>2];c[F+8>>2]=c[r+8>>2];c[F+12>>2]=c[r+12>>2];v=r+48|0;c[G>>2]=c[v>>2];c[G+4>>2]=c[v+4>>2];c[G+8>>2]=c[v+8>>2];c[G+12>>2]=c[v+12>>2];c[A>>2]=0;while(1){if((c[A>>2]|0)>=4)break a;v=E+(c[A>>2]<<4)|0;B=r+(c[A>>2]<<4)|0;c[v>>2]=c[B>>2];c[v+4>>2]=c[B+4>>2];c[v+8>>2]=c[B+8>>2];c[v+12>>2]=c[B+12>>2];c[A>>2]=(c[A>>2]|0)+1}}else{B=r+48|0;c[F>>2]=c[B>>2];c[F+4>>2]=c[B+4>>2];c[F+8>>2]=c[B+8>>2];c[F+12>>2]=c[B+12>>2];c[G>>2]=c[r>>2];c[G+4>>2]=c[r+4>>2];c[G+8>>2]=c[r+8>>2];c[G+12>>2]=c[r+12>>2];c[A>>2]=0;while(1){if((c[A>>2]|0)>=4)break a;B=E+(3-(c[A>>2]|0)<<4)|0;v=r+(c[A>>2]<<4)|0;c[B>>2]=c[v>>2];c[B+4>>2]=c[v+4>>2];c[B+8>>2]=c[v+8>>2];c[B+12>>2]=c[v+12>>2];c[A>>2]=(c[A>>2]|0)+1}}while(0);if((c[p>>2]|0)==6){c[M+4>>2]=4;c[M>>2]=K;c[A>>2]=0;while(1){if((c[A>>2]|0)>=4)break;D=K+(c[A>>2]<<4)|0;v=E+(c[A>>2]<<4)|0;c[D>>2]=c[v>>2];c[D+4>>2]=c[v+4>>2];c[D+8>>2]=c[v+8>>2];c[D+12>>2]=c[v+12>>2];c[A>>2]=(c[A>>2]|0)+1}c[k>>2]=c[M>>2];c[k+4>>2]=c[M+4>>2];iY(k,L);v=c[x>>2]|0;jN(c[x>>2]|0,c[((c[c[x>>2]>>2]&3|0)==2?v:v+-32|0)+28>>2]|0,c[L>>2]|0,c[L+4>>2]|0,c[q>>2]|0)}else{v=c[x>>2]|0;jN(c[x>>2]|0,c[((c[c[x>>2]>>2]&3|0)==2?v:v+-32|0)+28>>2]|0,E,4,c[q>>2]|0)}v=c[m>>2]|0;D=c[x>>2]|0;c[l>>2]=c[F>>2];c[l+4>>2]=c[F+4>>2];c[l+8>>2]=c[F+8>>2];c[l+12>>2]=c[F+12>>2];c[k>>2]=c[G>>2];c[k+4>>2]=c[G+4>>2];c[k+8>>2]=c[G+8>>2];c[k+12>>2]=c[G+12>>2];sN(v,D,l,k);D=r+16|0;h[D>>3]=+h[D>>3]+ +h[w>>3];D=r+16+8|0;h[D>>3]=+h[D>>3]+ +h[w+8>>3];D=r+32|0;h[D>>3]=+h[D>>3]+ +h[w>>3];D=r+32+8|0;h[D>>3]=+h[D>>3]+ +h[w+8>>3];c[z>>2]=(c[z>>2]|0)+1}i=j;return}if(c[u>>2]|0){YL(J,c[m>>2]|0);c[k>>2]=c[J>>2];c[k+4>>2]=c[J+4>>2];c[k+8>>2]=c[J+8>>2];c[k+12>>2]=c[J+12>>2];ZL(r,k)}J=c[y>>2]|0;jN(c[y>>2]|0,c[((c[c[y>>2]>>2]&3|0)==2?J:J+-32|0)+28>>2]|0,r,4,c[q>>2]|0);q=c[m>>2]|0;m=c[y>>2]|0;c[l>>2]=c[F>>2];c[l+4>>2]=c[F+4>>2];c[l+8>>2]=c[F+8>>2];c[l+12>>2]=c[F+12>>2];c[k>>2]=c[G>>2];c[k+4>>2]=c[G+4>>2];c[k+8>>2]=c[G+8>>2];c[k+12>>2]=c[G+12>>2];sN(q,m,l,k);i=j;return}function VL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+16|0;d=b;e=b+12|0;f=b+8|0;g=b+4|0;c[f>>2]=a;do if((c[f>>2]|0)>(c[14005]|0)){c[g>>2]=(c[14005]|0)+((((c[f>>2]|0)/300|0)+1|0)*300|0);c[14003]=eK(c[14003]|0,c[g>>2]<<4)|0;if(c[14003]|0){c[14005]=c[g>>2];break}$z(1,143046,d)|0;c[e>>2]=1;h=c[e>>2]|0;i=b;return h|0}while(0);c[e>>2]=0;h=c[e>>2]|0;i=b;return h|0}function WL(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,S=0,T=0,U=0,V=0,W=0.0,X=0;g=i;i=i+272|0;j=g+248|0;k=g+136|0;l=g+128|0;m=g+120|0;n=g+112|0;o=g+96|0;p=g+80|0;q=g+72|0;r=g+244|0;s=g+240|0;t=g+236|0;u=g+232|0;v=g+224|0;w=g+216|0;x=g+208|0;y=g+204|0;z=g+40|0;A=g+8|0;B=g+200|0;C=g+196|0;D=g+192|0;E=g+188|0;F=g+184|0;G=g+180|0;H=g+176|0;I=g+172|0;J=g+168|0;K=g+164|0;L=g+160|0;M=g+256|0;N=g;O=g+156|0;P=g+152|0;S=g+144|0;c[s>>2]=b;c[t>>2]=e;c[u>>2]=f;c[L>>2]=10;c[14006]=(c[14006]|0)+1;c[14007]=(c[14007]|0)+(c[(c[s>>2]|0)+80>>2]|0);c[I>>2]=c[(c[s>>2]|0)+88>>2];while(1){if(!(c[I>>2]|0))break;if(!(a[(c[(c[I>>2]|0)+8>>2]|0)+112>>0]|0))break;c[I>>2]=c[(c[(c[I>>2]|0)+8>>2]|0)+116>>2]}if(!(c[I>>2]|0)){$z(1,142327,q)|0;c[r>>2]=0;T=c[r>>2]|0;i=g;return T|0}c[G>>2]=c[(c[s>>2]|0)+84>>2];c[H>>2]=c[(c[s>>2]|0)+80>>2];if(_L(c[H>>2]|0,c[G>>2]|0,c[s>>2]|0)|0){c[r>>2]=0;T=c[r>>2]|0;i=g;return T|0}if((c[H>>2]<<3|0)>(c[14008]|0)){if(c[14009]|0)U=eK(c[14009]|0,c[H>>2]<<3<<4)|0;else U=cK(c[H>>2]<<3<<4)|0;c[14009]=U;c[14008]=c[H>>2]<<3}a:do if((c[H>>2]|0)>1?+h[(c[G>>2]|0)+8>>3]>+h[(c[G>>2]|0)+32+8>>3]:0){c[J>>2]=1;c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[H>>2]|0))break a;h[N>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3]*-1.0;h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3]=-+h[N>>3];c[F>>2]=(c[F>>2]|0)+1}}else V=19;while(0);if((V|0)==19)c[J>>2]=0;N=c[I>>2]|0;U=c[I>>2]|0;if((c[((c[c[I>>2]>>2]&3|0)==3?N:N+32|0)+28>>2]|0)==(c[((c[c[I>>2]>>2]&3|0)==2?U:U+-32|0)+28>>2]|0)){U=c[I>>2]|0;c[n>>2]=wB(c[((c[c[I>>2]>>2]&3|0)==2?U:U+-32|0)+28>>2]|0)|0;$z(1,142434,n)|0;c[r>>2]=0;T=c[r>>2]|0;i=g;return T|0}c[F>>2]=0;c[E>>2]=0;b:while(1){if((c[F>>2]|0)>=(c[H>>2]|0))break;c[C>>2]=0;c[D>>2]=0;if((c[F>>2]|0)>0)c[C>>2]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3]>+h[(c[G>>2]|0)+((c[F>>2]|0)-1<<5)+8>>3]?-1:1;if((c[F>>2]|0)<((c[H>>2]|0)-1|0))c[D>>2]=+h[(c[G>>2]|0)+((c[F>>2]|0)+1<<5)+8>>3]>+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3]?1:-1;do if((c[C>>2]|0)!=(c[D>>2]|0)){n=(c[G>>2]|0)+(c[F>>2]<<5)|0;if((c[D>>2]|0)==-1|(c[C>>2]|0)==1){h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[n>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];U=c[E>>2]|0;c[E>>2]=U+1;h[(c[14009]|0)+(U<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3];U=c[E>>2]|0;c[E>>2]=U+1;h[(c[14009]|0)+(U<<4)+8>>3]=W;break}else{h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[n+16>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3];n=c[E>>2]|0;c[E>>2]=n+1;h[(c[14009]|0)+(n<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];n=c[E>>2]|0;c[E>>2]=n+1;h[(c[14009]|0)+(n<<4)+8>>3]=W;break}}else if(c[C>>2]|0)if((c[C>>2]|0)==-1&(c[D>>2]|0)==-1)break;else{V=34;break b}else{h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];n=c[E>>2]|0;c[E>>2]=n+1;h[(c[14009]|0)+(n<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3];n=c[E>>2]|0;c[E>>2]=n+1;h[(c[14009]|0)+(n<<4)+8>>3]=W;break}while(0);c[F>>2]=(c[F>>2]|0)+1}if((V|0)==34){n=c[D>>2]|0;c[p>>2]=c[C>>2];c[p+4>>2]=n;c[p+8>>2]=480;$z(1,142369,p)|0;c[r>>2]=0;T=c[r>>2]|0;i=g;return T|0}c[F>>2]=(c[H>>2]|0)-1;c:while(1){if((c[F>>2]|0)<0)break;c[C>>2]=0;c[D>>2]=0;if((c[F>>2]|0)<((c[H>>2]|0)-1|0))c[C>>2]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3]>+h[(c[G>>2]|0)+((c[F>>2]|0)+1<<5)+8>>3]?-1:1;if((c[F>>2]|0)>0)c[D>>2]=+h[(c[G>>2]|0)+((c[F>>2]|0)-1<<5)+8>>3]>+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3]?1:-1;do if((c[C>>2]|0)!=(c[D>>2]|0)){p=(c[G>>2]|0)+(c[F>>2]<<5)|0;if((c[D>>2]|0)==-1|(c[C>>2]|0)==1){h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[p>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];n=c[E>>2]|0;c[E>>2]=n+1;h[(c[14009]|0)+(n<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3];n=c[E>>2]|0;c[E>>2]=n+1;h[(c[14009]|0)+(n<<4)+8>>3]=W;break}else{h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[p+16>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3];p=c[E>>2]|0;c[E>>2]=p+1;h[(c[14009]|0)+(p<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];p=c[E>>2]|0;c[E>>2]=p+1;h[(c[14009]|0)+(p<<4)+8>>3]=W;break}}else{if(!(c[C>>2]|0)){h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3];p=c[E>>2]|0;c[E>>2]=p+1;h[(c[14009]|0)+(p<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];p=c[E>>2]|0;c[E>>2]=p+1;h[(c[14009]|0)+(p<<4)+8>>3]=W;break}if(!((c[C>>2]|0)==-1&(c[D>>2]|0)==-1)){V=49;break c}h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3];p=c[E>>2]|0;c[E>>2]=p+1;h[(c[14009]|0)+(p<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];p=c[E>>2]|0;c[E>>2]=p+1;h[(c[14009]|0)+(p<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];p=c[E>>2]|0;c[E>>2]=p+1;h[(c[14009]|0)+(p<<4)+8>>3]=W;h[(c[14009]|0)+(c[E>>2]<<4)>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)>>3];W=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3];p=c[E>>2]|0;c[E>>2]=p+1;h[(c[14009]|0)+(p<<4)+8>>3]=W}while(0);c[F>>2]=(c[F>>2]|0)+-1}if((V|0)==49){p=c[D>>2]|0;c[o>>2]=c[C>>2];c[o+4>>2]=p;c[o+8>>2]=513;$z(1,142369,o)|0;c[r>>2]=0;T=c[r>>2]|0;i=g;return T|0}d:do if(c[J>>2]|0){c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[H>>2]|0))break;c[P>>2]=~~+h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3];h[(c[G>>2]|0)+(c[F>>2]<<5)+16+8>>3]=+h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3]*-1.0;h[(c[G>>2]|0)+(c[F>>2]<<5)+8>>3]=+(0-(c[P>>2]|0)|0);c[F>>2]=(c[F>>2]|0)+1}c[O>>2]=0;while(1){if((c[O>>2]|0)>=(c[E>>2]|0))break d;o=(c[14009]|0)+(c[O>>2]<<4)+8|0;h[o>>3]=+h[o>>3]*-1.0;c[O>>2]=(c[O>>2]|0)+1}}while(0);c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[H>>2]|0))break;h[(c[G>>2]|0)+(c[F>>2]<<5)>>3]=2147483647.0;h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3]=-2147483648.0;c[F>>2]=(c[F>>2]|0)+1}c[v>>2]=c[14009];c[v+4>>2]=c[E>>2];h[z>>3]=+h[c[s>>2]>>3];h[z+8>>3]=+h[(c[s>>2]|0)+8>>3];h[z+16>>3]=+h[(c[s>>2]|0)+40>>3];h[z+16+8>>3]=+h[(c[s>>2]|0)+40+8>>3];if((NX(v,z,w)|0)<0){$z(1,142473,m)|0;c[r>>2]=0;T=c[r>>2]|0;i=g;return T|0}if(!(c[u>>2]|0)){if((c[v+4>>2]|0)>(c[14001]|0)){if(c[14002]|0)X=eK(c[14002]|0,c[v+4>>2]<<5)|0;else X=cK(c[v+4>>2]<<5)|0;c[14002]=X;c[14001]=c[v+4>>2]}c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[v+4>>2]|0))break;X=(c[14002]|0)+(c[B>>2]<<5)|0;u=(c[14009]|0)+(c[B>>2]<<4)|0;c[X>>2]=c[u>>2];c[X+4>>2]=c[u+4>>2];c[X+8>>2]=c[u+8>>2];c[X+12>>2]=c[u+12>>2];u=(c[14002]|0)+(c[B>>2]<<5)+16|0;X=(c[14009]|0)+((((c[B>>2]|0)+1|0)%(c[v+4>>2]|0)|0)<<4)|0;c[u>>2]=c[X>>2];c[u+4>>2]=c[X+4>>2];c[u+8>>2]=c[X+8>>2];c[u+12>>2]=c[X+12>>2];c[B>>2]=(c[B>>2]|0)+1}if(a[(c[s>>2]|0)+29>>0]|0){h[A>>3]=+Q(+(+h[(c[s>>2]|0)+16>>3]));h[A+8>>3]=+R(+(+h[(c[s>>2]|0)+16>>3]))}else{h[A+8>>3]=0.0;h[A>>3]=0.0}if(a[(c[s>>2]|0)+40+29>>0]|0){h[A+16>>3]=-+Q(+(+h[(c[s>>2]|0)+40+16>>3]));h[A+16+8>>3]=-+R(+(+h[(c[s>>2]|0)+40+16>>3]))}else{h[A+16+8>>3]=0.0;h[A+16>>3]=0.0}s=c[14002]|0;B=c[v+4>>2]|0;c[j>>2]=c[w>>2];c[j+4>>2]=c[w+4>>2];if((rX(s,B,j,A,x)|0)<0){$z(1,142512,l)|0;c[r>>2]=0;T=c[r>>2]|0;i=g;return T|0}}else{c[j>>2]=c[w>>2];c[j+4>>2]=c[w+4>>2];iY(j,x)}if(VL(c[x+4>>2]|0)|0){c[r>>2]=0;T=c[r>>2]|0;i=g;return T|0}c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[H>>2]|0))break;h[(c[G>>2]|0)+(c[F>>2]<<5)>>3]=2147483647.0;h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3]=-2147483648.0;c[F>>2]=(c[F>>2]|0)+1}a[M>>0]=1;c[y>>2]=0;while(1){if((c[y>>2]|0)>=(c[x+4>>2]|0))break;l=(c[14003]|0)+(c[y>>2]<<4)|0;A=(c[x>>2]|0)+(c[y>>2]<<4)|0;c[l>>2]=c[A>>2];c[l+4>>2]=c[A+4>>2];c[l+8>>2]=c[A+8>>2];c[l+12>>2]=c[A+12>>2];c[y>>2]=(c[y>>2]|0)+1}c[K>>2]=0;while(1){if(!((d[M>>0]|0)!=0?(c[K>>2]|0)<15:0))break;$L(c[G>>2]|0,c[H>>2]|0,c[14003]|0,c[x+4>>2]|0,c[L>>2]|0);c[F>>2]=0;while(1){if((c[F>>2]|0)>=(c[H>>2]|0))break;if(+h[(c[G>>2]|0)+(c[F>>2]<<5)>>3]==2147483647.0){V=97;break}if(+h[(c[G>>2]|0)+(c[F>>2]<<5)+16>>3]==-2147483648.0){V=97;break}c[F>>2]=(c[F>>2]|0)+1}if((V|0)==97?(V=0,c[L>>2]=c[L>>2]<<1,(c[L>>2]|0)>(2147483647/(c[H>>2]|0)|0|0)):0)c[K>>2]=15;if((c[F>>2]|0)==(c[H>>2]|0))a[M>>0]=0;c[K>>2]=(c[K>>2]|0)+1}if(a[M>>0]|0){M=c[I>>2]|0;K=wB(c[((c[c[I>>2]>>2]&3|0)==3?M:M+32|0)+28>>2]|0)|0;M=c[I>>2]|0;F=wB(c[((c[c[I>>2]>>2]&3|0)==2?M:M+-32|0)+28>>2]|0)|0;c[k>>2]=K;c[k+4>>2]=F;$z(0,142550,k)|0;c[j>>2]=c[w>>2];c[j+4>>2]=c[w+4>>2];iY(j,S);$L(c[G>>2]|0,c[H>>2]|0,c[S>>2]|0,c[S+4>>2]|0,10);O4(c[S>>2]|0)}c[c[t>>2]>>2]=c[x+4>>2];c[r>>2]=c[14003];T=c[r>>2]|0;i=g;return T|0}function XL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]+ +h[d>>3];h[f+8>>3]=+h[b+8>>3]+ +h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function YL(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d+4|0;c[e>>2]=b;c[d>>2]=0;h[4264]=(+h[(c[(c[e>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[e>>2]|0)+8>>2]|0)+16+16>>3])/2.0;h[4265]=(+h[(c[(c[e>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[e>>2]|0)+8>>2]|0)+16+16+8>>3])/2.0;c[a>>2]=c[8528];c[a+4>>2]=c[8529];c[a+8>>2]=c[8530];c[a+12>>2]=c[8531];i=d;return}function ZL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;d=i;i=i+96|0;e=d+88|0;f=d+72|0;g=d+56|0;j=d+48|0;k=d+40|0;l=d+32|0;m=d+24|0;n=d+16|0;o=d+8|0;p=d;c[e>>2]=a;h[f>>3]=(+h[c[e>>2]>>3]+ +h[(c[e>>2]|0)+48>>3])/2.0;h[f+8>>3]=(+h[(c[e>>2]|0)+8>>3]+ +h[(c[e>>2]|0)+48+8>>3])/2.0;h[l>>3]=+h[(c[e>>2]|0)+48>>3]-+h[c[e>>2]>>3];h[m>>3]=+h[(c[e>>2]|0)+48+8>>3]-+h[(c[e>>2]|0)+8>>3];h[k>>3]=+O(+(+h[l>>3]*+h[l>>3]+ +h[m>>3]*+h[m>>3]));h[j>>3]=+h[k>>3]/5.0;h[n>>3]=+h[b>>3]-+h[f>>3];h[o>>3]=+h[b+8>>3]-+h[f+8>>3];h[p>>3]=+O(+(+h[n>>3]*+h[n>>3]+ +h[o>>3]*+h[o>>3]));h[g>>3]=+h[f>>3]-+h[n>>3]/+h[p>>3]*+h[j>>3];h[g+8>>3]=+h[f+8>>3]-+h[o>>3]/+h[p>>3]*+h[j>>3];q=+h[g>>3];h[(c[e>>2]|0)+32>>3]=q;h[(c[e>>2]|0)+16>>3]=q;q=+h[g+8>>3];h[(c[e>>2]|0)+32+8>>3]=q;h[(c[e>>2]|0)+16+8>>3]=q;i=d;return}function _L(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+112|0;j=g+32|0;k=g+24|0;l=g+16|0;m=g+8|0;n=g;o=g+96|0;p=g+92|0;q=g+88|0;r=g+84|0;s=g+80|0;t=g+76|0;u=g+72|0;v=g+68|0;w=g+64|0;x=g+60|0;y=g+56|0;z=g+52|0;A=g+48|0;B=g+44|0;C=g+40|0;D=g+36|0;c[p>>2]=b;c[q>>2]=e;c[r>>2]=f;c[v>>2]=0;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[p>>2]|0))break;E=+h[(c[q>>2]|0)+(c[u>>2]<<5)+8>>3]-+h[(c[q>>2]|0)+(c[u>>2]<<5)+16+8>>3];if(!((+h[(c[q>>2]|0)+(c[u>>2]<<5)+8>>3]-+h[(c[q>>2]|0)+(c[u>>2]<<5)+16+8>>3]>=0.0?E:-E)<.01)?(E=+h[(c[q>>2]|0)+(c[u>>2]<<5)>>3]-+h[(c[q>>2]|0)+(c[u>>2]<<5)+16>>3],!((+h[(c[q>>2]|0)+(c[u>>2]<<5)>>3]-+h[(c[q>>2]|0)+(c[u>>2]<<5)+16>>3]>=0.0?E:-E)<.01)):0){if((c[v>>2]|0)!=(c[u>>2]|0)){f=(c[q>>2]|0)+(c[v>>2]<<5)|0;e=(c[q>>2]|0)+(c[u>>2]<<5)|0;c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[f+16>>2]=c[e+16>>2];c[f+20>>2]=c[e+20>>2];c[f+24>>2]=c[e+24>>2];c[f+28>>2]=c[e+28>>2]}c[v>>2]=(c[v>>2]|0)+1}c[u>>2]=(c[u>>2]|0)+1}c[p>>2]=c[v>>2];c[s>>2]=c[q>>2];if(!(+h[c[s>>2]>>3]>+h[(c[s>>2]|0)+16>>3])?!(+h[(c[s>>2]|0)+8>>3]>+h[(c[s>>2]|0)+16+8>>3]):0){c[u>>2]=0;while(1){if((c[u>>2]|0)>=((c[p>>2]|0)-1|0))break;c[s>>2]=(c[q>>2]|0)+(c[u>>2]<<5);c[t>>2]=(c[q>>2]|0)+((c[u>>2]|0)+1<<5);if(+h[c[t>>2]>>3]>+h[(c[t>>2]|0)+16>>3]){F=16;break}if(+h[(c[t>>2]|0)+8>>3]>+h[(c[t>>2]|0)+16+8>>3]){F=16;break}c[x>>2]=+h[(c[s>>2]|0)+16>>3]<+h[c[t>>2]>>3]?1:0;c[y>>2]=+h[c[s>>2]>>3]>+h[(c[t>>2]|0)+16>>3]?1:0;c[z>>2]=+h[(c[s>>2]|0)+16+8>>3]<+h[(c[t>>2]|0)+8>>3]?1:0;c[A>>2]=+h[(c[s>>2]|0)+8>>3]>+h[(c[t>>2]|0)+16+8>>3]?1:0;c[w>>2]=(c[x>>2]|0)+(c[y>>2]|0)+(c[z>>2]|0)+(c[A>>2]|0);if((c[w>>2]|0)>0?(d[138998]|0)!=0:0){e=c[24742]|0;f=(c[u>>2]|0)+1|0;c[l>>2]=c[u>>2];c[l+4>>2]=f;Y2(e,142750,l)|0;aM(c[r>>2]|0)}a:do if((c[w>>2]|0)>0){do if((c[x>>2]|0)!=1){if((c[y>>2]|0)==1){c[D>>2]=~~+h[c[s>>2]>>3];h[c[s>>2]>>3]=+h[(c[t>>2]|0)+16>>3];h[(c[t>>2]|0)+16>>3]=+(c[D>>2]|0);c[y>>2]=0;break}if((c[z>>2]|0)==1){c[D>>2]=~~+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[t>>2]|0)+8>>3];h[(c[t>>2]|0)+8>>3]=+(c[D>>2]|0);c[z>>2]=0;break}if((c[A>>2]|0)==1){c[D>>2]=~~+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+8>>3]=+h[(c[t>>2]|0)+16+8>>3];h[(c[t>>2]|0)+16+8>>3]=+(c[D>>2]|0);c[A>>2]=0}}else{c[D>>2]=~~+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+16>>3]=+h[c[t>>2]>>3];h[c[t>>2]>>3]=+(c[D>>2]|0);c[x>>2]=0}while(0);c[v>>2]=0;while(1){if((c[v>>2]|0)>=((c[w>>2]|0)-1|0))break a;do if((c[x>>2]|0)!=1){if((c[y>>2]|0)==1){c[D>>2]=~~((+h[c[s>>2]>>3]+ +h[(c[t>>2]|0)+16>>3])/2.0+.5);E=+(c[D>>2]|0);h[(c[t>>2]|0)+16>>3]=E;h[c[s>>2]>>3]=E;c[y>>2]=0;break}if((c[z>>2]|0)==1){c[D>>2]=~~((+h[(c[s>>2]|0)+16+8>>3]+ +h[(c[t>>2]|0)+8>>3])/2.0+.5);E=+(c[D>>2]|0);h[(c[t>>2]|0)+8>>3]=E;h[(c[s>>2]|0)+16+8>>3]=E;c[z>>2]=0;break}if((c[A>>2]|0)==1){c[D>>2]=~~((+h[(c[s>>2]|0)+8>>3]+ +h[(c[t>>2]|0)+16+8>>3])/2.0+.5);E=+(c[D>>2]|0);h[(c[t>>2]|0)+16+8>>3]=E;h[(c[s>>2]|0)+8>>3]=E;c[A>>2]=0}}else{c[D>>2]=~~((+h[(c[s>>2]|0)+16>>3]+ +h[c[t>>2]>>3])/2.0+.5);E=+(c[D>>2]|0);h[c[t>>2]>>3]=E;h[(c[s>>2]|0)+16>>3]=E;c[x>>2]=0}while(0);c[v>>2]=(c[v>>2]|0)+1}}while(0);c[B>>2]=bM(~~+h[c[s>>2]>>3],~~+h[(c[s>>2]|0)+16>>3],~~+h[c[t>>2]>>3],~~+h[(c[t>>2]|0)+16>>3])|0;c[C>>2]=bM(~~+h[(c[s>>2]|0)+8>>3],~~+h[(c[s>>2]|0)+16+8>>3],~~+h[(c[t>>2]|0)+8>>3],~~+h[(c[t>>2]|0)+16+8>>3])|0;do if((c[B>>2]|0)!=0&(c[C>>2]|0)!=0){e=(c[s>>2]|0)+16|0;if((c[B>>2]|0)<(c[C>>2]|0)){f=+h[(c[s>>2]|0)+16>>3]<+h[(c[t>>2]|0)+16>>3];if(+h[e>>3]-+h[c[s>>2]>>3]>+h[(c[t>>2]|0)+16>>3]-+h[c[t>>2]>>3]){b=c[t>>2]|0;if(f){h[(c[s>>2]|0)+16>>3]=+h[b>>3];break}else{h[c[s>>2]>>3]=+h[b+16>>3];break}}else{b=c[s>>2]|0;if(f){h[c[t>>2]>>3]=+h[b+16>>3];break}else{h[(c[t>>2]|0)+16>>3]=+h[b>>3];break}}}else{b=+h[(c[s>>2]|0)+16+8>>3]<+h[(c[t>>2]|0)+16+8>>3];if(+h[e+8>>3]-+h[(c[s>>2]|0)+8>>3]>+h[(c[t>>2]|0)+16+8>>3]-+h[(c[t>>2]|0)+8>>3]){e=c[t>>2]|0;if(b){h[(c[s>>2]|0)+16+8>>3]=+h[e+8>>3];break}else{h[(c[s>>2]|0)+8>>3]=+h[e+16+8>>3];break}}else{e=c[s>>2]|0;if(b){h[(c[t>>2]|0)+8>>3]=+h[e+16+8>>3];break}else{h[(c[t>>2]|0)+16+8>>3]=+h[e+8>>3];break}}}}while(0);c[u>>2]=(c[u>>2]|0)+1}if((F|0)==16){c[m>>2]=(c[u>>2]|0)+1;$z(1,142704,m)|0;aM(c[r>>2]|0);c[o>>2]=1;G=c[o>>2]|0;i=g;return G|0}if(!(((!(+h[c[r>>2]>>3]<+h[c[q>>2]>>3])?!(+h[c[r>>2]>>3]>+h[(c[q>>2]|0)+16>>3]):0)?!(+h[(c[r>>2]|0)+8>>3]<+h[(c[q>>2]|0)+8>>3]):0)?!(+h[(c[r>>2]|0)+8>>3]>+h[(c[q>>2]|0)+16+8>>3]):0)){if(a[138998]|0){Y2(c[24742]|0,142793,k)|0;aM(c[r>>2]|0)}if(+h[c[r>>2]>>3]<+h[c[q>>2]>>3])h[c[r>>2]>>3]=+h[c[q>>2]>>3];if(+h[c[r>>2]>>3]>+h[(c[q>>2]|0)+16>>3])h[c[r>>2]>>3]=+h[(c[q>>2]|0)+16>>3];if(+h[(c[r>>2]|0)+8>>3]<+h[(c[q>>2]|0)+8>>3])h[(c[r>>2]|0)+8>>3]=+h[(c[q>>2]|0)+8>>3];if(+h[(c[r>>2]|0)+8>>3]>+h[(c[q>>2]|0)+16+8>>3])h[(c[r>>2]|0)+8>>3]=+h[(c[q>>2]|0)+16+8>>3]}if(!(((!(+h[(c[r>>2]|0)+40>>3]<+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)>>3])?!(+h[(c[r>>2]|0)+40>>3]>+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+16>>3]):0)?!(+h[(c[r>>2]|0)+40+8>>3]<+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+8>>3]):0)?!(+h[(c[r>>2]|0)+40+8>>3]>+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+16+8>>3]):0)){if(a[138998]|0){Y2(c[24742]|0,142836,j)|0;aM(c[r>>2]|0)}if(+h[(c[r>>2]|0)+40>>3]<+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)>>3])h[(c[r>>2]|0)+40>>3]=+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)>>3];if(+h[(c[r>>2]|0)+40>>3]>+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+16>>3])h[(c[r>>2]|0)+40>>3]=+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+16>>3];if(+h[(c[r>>2]|0)+40+8>>3]<+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+8>>3])h[(c[r>>2]|0)+40+8>>3]=+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+8>>3];if(+h[(c[r>>2]|0)+40+8>>3]>+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+16+8>>3])h[(c[r>>2]|0)+40+8>>3]=+h[(c[q>>2]|0)+((c[p>>2]|0)-1<<5)+16+8>>3]}c[o>>2]=0;G=c[o>>2]|0;i=g;return G|0}$z(1,142659,n)|0;aM(c[r>>2]|0);c[o>>2]=1;G=c[o>>2]|0;i=g;return G|0}function $L(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+112|0;j=g+104|0;k=g+100|0;l=g+96|0;m=g+92|0;n=g+88|0;o=g+84|0;p=g+80|0;q=g+76|0;r=g+64|0;s=g;t=g+72|0;c[j>>2]=a;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;c[n>>2]=f;c[t>>2]=_(c[n>>2]|0,c[k>>2]|0)|0;c[q>>2]=0;while(1){if(((c[q>>2]|0)+3|0)>=(c[m>>2]|0))break;c[p>>2]=0;while(1){if((c[p>>2]|0)>(c[t>>2]|0))break;h[r>>3]=+(c[p>>2]|0)/+(c[t>>2]|0);n=(c[l>>2]|0)+(c[q>>2]<<4)|0;c[s>>2]=c[n>>2];c[s+4>>2]=c[n+4>>2];c[s+8>>2]=c[n+8>>2];c[s+12>>2]=c[n+12>>2];n=s+16|0;f=(c[l>>2]|0)+((c[q>>2]|0)+1<<4)|0;c[n>>2]=c[f>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];f=s+32|0;n=(c[l>>2]|0)+((c[q>>2]|0)+2<<4)|0;c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];n=s+48|0;f=(c[l>>2]|0)+((c[q>>2]|0)+3<<4)|0;c[n>>2]=c[f>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[n+12>>2]=c[f+12>>2];h[s>>3]=+h[s>>3]+ +h[r>>3]*(+h[s+16>>3]-+h[s>>3]);h[s+8>>3]=+h[s+8>>3]+ +h[r>>3]*(+h[s+16+8>>3]-+h[s+8>>3]);h[s+16>>3]=+h[s+16>>3]+ +h[r>>3]*(+h[s+32>>3]-+h[s+16>>3]);h[s+16+8>>3]=+h[s+16+8>>3]+ +h[r>>3]*(+h[s+32+8>>3]-+h[s+16+8>>3]);h[s+32>>3]=+h[s+32>>3]+ +h[r>>3]*(+h[s+48>>3]-+h[s+32>>3]);h[s+32+8>>3]=+h[s+32+8>>3]+ +h[r>>3]*(+h[s+48+8>>3]-+h[s+32+8>>3]);h[s>>3]=+h[s>>3]+ +h[r>>3]*(+h[s+16>>3]-+h[s>>3]);h[s+8>>3]=+h[s+8>>3]+ +h[r>>3]*(+h[s+16+8>>3]-+h[s+8>>3]);h[s+16>>3]=+h[s+16>>3]+ +h[r>>3]*(+h[s+32>>3]-+h[s+16>>3]);h[s+16+8>>3]=+h[s+16+8>>3]+ +h[r>>3]*(+h[s+32+8>>3]-+h[s+16+8>>3]);h[s>>3]=+h[s>>3]+ +h[r>>3]*(+h[s+16>>3]-+h[s>>3]);h[s+8>>3]=+h[s+8>>3]+ +h[r>>3]*(+h[s+16+8>>3]-+h[s+8>>3]);c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[k>>2]|0))break;if(+h[s+8>>3]<=+h[(c[j>>2]|0)+(c[o>>2]<<5)+16+8>>3]+.0001?+h[s+8>>3]>=+h[(c[j>>2]|0)+(c[o>>2]<<5)+8>>3]-.0001:0){if(+h[(c[j>>2]|0)+(c[o>>2]<<5)>>3]>+h[s>>3])h[(c[j>>2]|0)+(c[o>>2]<<5)>>3]=+h[s>>3];if(+h[(c[j>>2]|0)+(c[o>>2]<<5)+16>>3]<+h[s>>3])h[(c[j>>2]|0)+(c[o>>2]<<5)+16>>3]=+h[s>>3]}c[o>>2]=(c[o>>2]|0)+1}c[p>>2]=(c[p>>2]|0)+1}c[q>>2]=(c[q>>2]|0)+3}i=g;return}function aM(a){a=a|0;var b=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;i=i+128|0;e=b+80|0;f=b+48|0;g=b+8|0;j=b;k=b+116|0;l=b+112|0;c[k>>2]=a;a=c[24742]|0;c[j>>2]=c[(c[k>>2]|0)+80>>2];Y2(a,142876,j)|0;c[l>>2]=0;while(1){m=c[24742]|0;if((c[l>>2]|0)>=(c[(c[k>>2]|0)+80>>2]|0))break;n=+h[(c[(c[k>>2]|0)+84>>2]|0)+(c[l>>2]<<5)>>3];o=+h[(c[(c[k>>2]|0)+84>>2]|0)+(c[l>>2]<<5)+8>>3];p=+h[(c[(c[k>>2]|0)+84>>2]|0)+(c[l>>2]<<5)+16>>3];q=+h[(c[(c[k>>2]|0)+84>>2]|0)+(c[l>>2]<<5)+16+8>>3];c[g>>2]=c[l>>2];h[g+8>>3]=n;h[g+16>>3]=o;h[g+24>>3]=p;h[g+32>>3]=q;Y2(m,142887,g)|0;c[l>>2]=(c[l>>2]|0)+1}q=+h[(c[k>>2]|0)+8>>3];p=+h[(c[k>>2]|0)+16>>3];l=(d[(c[k>>2]|0)+29>>0]|0|0)!=0?142918:142930;h[f>>3]=+h[c[k>>2]>>3];h[f+8>>3]=q;h[f+16>>3]=p;c[f+24>>2]=l;Y2(m,142946,f)|0;f=c[24742]|0;p=+h[(c[k>>2]|0)+40+8>>3];q=+h[(c[k>>2]|0)+40+16>>3];m=(d[(c[k>>2]|0)+40+29>>0]|0|0)!=0?142918:142930;h[e>>3]=+h[(c[k>>2]|0)+40>>3];h[e+8>>3]=p;h[e+16>>3]=q;c[e+24>>2]=m;Y2(f,142997,e)|0;i=b;return}function bM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=f+16|0;h=f+12|0;j=f+8|0;k=f+4|0;l=f;c[h>>2]=a;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;if((c[j>>2]|0)<=(c[k>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}if((c[h>>2]|0)>=(c[l>>2]|0)){c[g>>2]=0;m=c[g>>2]|0;i=f;return m|0}if((c[k>>2]|0)<=(c[h>>2]|0)?(c[h>>2]|0)<=(c[l>>2]|0):0){c[g>>2]=(c[l>>2]|0)-(c[h>>2]|0);m=c[g>>2]|0;i=f;return m|0}if((c[k>>2]|0)<=(c[j>>2]|0)?(c[j>>2]|0)<=(c[l>>2]|0):0){c[g>>2]=(c[j>>2]|0)-(c[k>>2]|0);m=c[g>>2]|0;i=f;return m|0}if(((c[j>>2]|0)-(c[h>>2]|0)|0)<((c[l>>2]|0)-(c[k>>2]|0)|0))n=(c[j>>2]|0)-(c[h>>2]|0)|0;else n=(c[l>>2]|0)-(c[k>>2]|0)|0;c[g>>2]=n;m=c[g>>2]|0;i=f;return m|0}function cM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0;g=i;i=i+304|0;j=g+232|0;k=g+216|0;l=g+292|0;m=g+288|0;n=g+284|0;o=g+280|0;p=g+276|0;q=g+272|0;r=g+136|0;s=g+268|0;t=g+120|0;u=g+104|0;v=g+96|0;w=g+88|0;x=g+80|0;y=g+72|0;z=g+64|0;A=g+264|0;B=g+260|0;C=g+256|0;D=g+252|0;E=g+248|0;F=g+48|0;G=g+32|0;H=g+16|0;I=g;c[l>>2]=a;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[D>>2]=c[o>>2]&2130706432;do if(!(c[o>>2]&8))if(c[o>>2]&2130706432){c[C>>2]=c[D>>2];break}else{c[C>>2]=4;break}else c[C>>2]=8;while(0);c[q>>2]=bK((c[n>>2]<<2)+4<<4)|0;c[A>>2]=0;h[v>>3]=12.0;c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[n>>2]|0))break;o=(c[m>>2]|0)+(c[B>>2]<<4)|0;c[t>>2]=c[o>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];if((c[B>>2]|0)<((c[n>>2]|0)-1|0)){o=(c[m>>2]|0)+((c[B>>2]|0)+1<<4)|0;c[u>>2]=c[o>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2]}else{o=c[m>>2]|0;c[u>>2]=c[o>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2]}h[x>>3]=+h[u>>3]-+h[t>>3];h[y>>3]=+h[u+8>>3]-+h[t+8>>3];h[w>>3]=+O(+(+h[x>>3]*+h[x>>3]+ +h[y>>3]*+h[y>>3]));if(+h[v>>3]<+h[w>>3]/3.0)J=+h[v>>3];else J=+h[w>>3]/3.0;h[v>>3]=J;c[B>>2]=(c[B>>2]|0)+1}c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[n>>2]|0))break;o=(c[m>>2]|0)+(c[B>>2]<<4)|0;c[t>>2]=c[o>>2];c[t+4>>2]=c[o+4>>2];c[t+8>>2]=c[o+8>>2];c[t+12>>2]=c[o+12>>2];if((c[B>>2]|0)<((c[n>>2]|0)-1|0)){o=(c[m>>2]|0)+((c[B>>2]|0)+1<<4)|0;c[u>>2]=c[o>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2]}else{o=c[m>>2]|0;c[u>>2]=c[o>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2]}h[x>>3]=+h[u>>3]-+h[t>>3];h[y>>3]=+h[u+8>>3]-+h[t+8>>3];h[w>>3]=+O(+(+h[x>>3]*+h[x>>3]+ +h[y>>3]*+h[y>>3]));h[z>>3]=+h[v>>3]/+h[w>>3];if(!((c[D>>2]|0)==67108864|(c[D>>2]|0)==83886080)){if((c[D>>2]|0)==16777216)h[z>>3]=+h[z>>3]/2.0}else h[z>>3]=+h[z>>3]/3.0;o=(c[C>>2]|0)!=4;f=c[A>>2]|0;c[A>>2]=f+1;e=(c[q>>2]|0)+(f<<4)|0;if(o){c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[e+12>>2]=c[t+12>>2]}else{J=+h[z>>3]*.5;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];c[k+12>>2]=c[t+12>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];jM(F,J,k,j);c[e>>2]=c[F>>2];c[e+4>>2]=c[F+4>>2];c[e+8>>2]=c[F+8>>2];c[e+12>>2]=c[F+12>>2]}e=c[A>>2]|0;c[A>>2]=e+1;o=(c[q>>2]|0)+(e<<4)|0;J=+h[z>>3];c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];c[k+12>>2]=c[t+12>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];jM(G,J,k,j);c[o>>2]=c[G>>2];c[o+4>>2]=c[G+4>>2];c[o+8>>2]=c[G+8>>2];c[o+12>>2]=c[G+12>>2];o=c[A>>2]|0;c[A>>2]=o+1;e=(c[q>>2]|0)+(o<<4)|0;J=1.0-+h[z>>3];c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];c[k+12>>2]=c[t+12>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];jM(H,J,k,j);c[e>>2]=c[H>>2];c[e+4>>2]=c[H+4>>2];c[e+8>>2]=c[H+8>>2];c[e+12>>2]=c[H+12>>2];if((c[C>>2]|0)==4){e=c[A>>2]|0;c[A>>2]=e+1;o=(c[q>>2]|0)+(e<<4)|0;J=1.0-+h[z>>3]*.5;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];c[k+12>>2]=c[t+12>>2];c[j>>2]=c[u>>2];c[j+4>>2]=c[u+4>>2];c[j+8>>2]=c[u+8>>2];c[j+12>>2]=c[u+12>>2];jM(I,J,k,j);c[o>>2]=c[I>>2];c[o+4>>2]=c[I+4>>2];c[o+8>>2]=c[I+8>>2];c[o+12>>2]=c[I+12>>2]}c[B>>2]=(c[B>>2]|0)+1}I=c[A>>2]|0;c[A>>2]=I+1;j=(c[q>>2]|0)+(I<<4)|0;I=c[q>>2]|0;c[j>>2]=c[I>>2];c[j+4>>2]=c[I+4>>2];c[j+8>>2]=c[I+8>>2];c[j+12>>2]=c[I+12>>2];I=c[A>>2]|0;c[A>>2]=I+1;j=(c[q>>2]|0)+(I<<4)|0;I=(c[q>>2]|0)+16|0;c[j>>2]=c[I>>2];c[j+4>>2]=c[I+4>>2];c[j+8>>2]=c[I+8>>2];c[j+12>>2]=c[I+12>>2];I=c[A>>2]|0;c[A>>2]=I+1;j=(c[q>>2]|0)+(I<<4)|0;I=(c[q>>2]|0)+32|0;c[j>>2]=c[I>>2];c[j+4>>2]=c[I+4>>2];c[j+8>>2]=c[I+8>>2];c[j+12>>2]=c[I+12>>2];I=c[C>>2]|0;if((I|0)>=201326592)if((I|0)<318767104){if((I|0)<251658240){if((I|0)<218103808){switch(I|0){case 201326592:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3];h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*2.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);O4(c[s>>2]|0);c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])*5.0/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);h[r>>3]=+h[(c[s>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}if((I|0)<234881024){switch(I|0){case 218103808:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[c[m>>2]>>3];h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])*2.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+48>>3]=+h[(c[s>>2]|0)+32>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);O4(c[s>>2]|0);c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[c[m>>2]>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])*5.0/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3]);h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+48>>3]=+h[(c[s>>2]|0)+32>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[(c[s>>2]|0)+48>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 234881024:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*9.0/8.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);O4(c[s>>2]|0);c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*9.0/8.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])*5.0/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);O4(c[s>>2]|0);c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])*5.0/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);O4(c[s>>2]|0);c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);h[r>>3]=+h[(c[s>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*9.0/8.0;h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[(c[m>>2]|0)+16>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}}if((I|0)<285212672)if((I|0)<268435456){switch(I|0){case 251658240:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*2.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);O4(c[s>>2]|0);c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])*5.0/8.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*2.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);h[r>>3]=+h[(c[s>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[s>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 268435456:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[c[m>>2]>>3];h[(c[s>>2]|0)+8>>3]=+h[(c[q>>2]|0)+16+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[(c[q>>2]|0)+48>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[q>>2]|0)+48+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[m>>2]|0)+32>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[c[m>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[r+16>>3]=+h[r>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[r+16+8>>3]=+h[r+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[r+16>>3]=+h[r>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[r+16+8>>3]=+h[r+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])*3.0/4.0;h[r+16>>3]=+h[c[m>>2]>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[r+16+8>>3]=+h[r+8>>3];wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else if((I|0)<301989888){switch(I|0){case 285212672:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK(c[n>>2]<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+48>>3]=+h[(c[s>>2]|0)+32>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,c[n>>2]|0,c[p>>2]|0);O4(c[s>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[r+16>>3]=+h[r>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[r+32>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[r+32+8>>3]=+h[r+16+8>>3];h[r+48>>3]=+h[r+32>>3];h[r+48+8>>3]=+h[r+8>>3];C=r+64|0;c[C>>2]=c[r>>2];c[C+4>>2]=c[r+4>>2];c[C+8>>2]=c[r+8>>2];c[C+12>>2]=c[r+12>>2];wR(c[l>>2]|0,r,5);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 301989888:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+12<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+32>>3]=+h[c[s>>2]>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+64>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+64+8>>3]=+h[(c[s>>2]|0)+48+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+80>>3]=+h[(c[s>>2]|0)+32>>3];h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+64+8>>3];h[(c[s>>2]|0)+96>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0;h[(c[s>>2]|0)+96+8>>3]=+h[(c[s>>2]|0)+48+8>>3];h[(c[s>>2]|0)+112>>3]=+h[(c[s>>2]|0)+96>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+112+8>>3]=+h[(c[s>>2]|0)+80+8>>3];h[(c[s>>2]|0)+128>>3]=+h[(c[s>>2]|0)+112>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+128+8>>3]=+h[(c[s>>2]|0)+112+8>>3];h[(c[s>>2]|0)+144>>3]=+h[(c[s>>2]|0)+128>>3];h[(c[s>>2]|0)+144+8>>3]=+h[(c[s>>2]|0)+48+8>>3];h[(c[s>>2]|0)+160>>3]=+h[(c[s>>2]|0)+128>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+160+8>>3]=+h[(c[s>>2]|0)+32+8>>3];h[(c[s>>2]|0)+176>>3]=+h[(c[s>>2]|0)+128>>3];h[(c[s>>2]|0)+176+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+192>>3]=+h[(c[s>>2]|0)+128>>3];h[(c[s>>2]|0)+192+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+208>>3]=+h[(c[s>>2]|0)+160>>3];h[(c[s>>2]|0)+208+8>>3]=+h[(c[s>>2]|0)+192+8>>3];h[(c[s>>2]|0)+224>>3]=+h[(c[s>>2]|0)+96>>3];h[(c[s>>2]|0)+224+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+240>>3]=+h[(c[s>>2]|0)+32>>3];h[(c[s>>2]|0)+240+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+12|0,c[p>>2]|0);h[r>>3]=+h[(c[s>>2]|0)+224>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[r>>3];h[r+16+8>>3]=+h[r+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[s>>2]|0)+224>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[r+16>>3]=+h[r>>3];h[r+16+8>>3]=+h[r+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}}else{if((I|0)<369098752){if((I|0)<335544320){switch(I|0){case 318767104:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+4<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+64>>3]=+h[(c[s>>2]|0)+48>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[s>>2]|0)+48+8>>3];h[(c[s>>2]|0)+80>>3]=+h[(c[s>>2]|0)+64>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+32+8>>3];h[(c[s>>2]|0)+96>>3]=+h[(c[s>>2]|0)+80>>3];h[(c[s>>2]|0)+96+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+112>>3]=+h[(c[s>>2]|0)+64>>3];h[(c[s>>2]|0)+112+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+4|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0;h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[r>>3];h[r+16+8>>3]=+h[r+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0;h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[r+16>>3]=+h[r>>3];h[r+16+8>>3]=+h[r+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}if((I|0)<352321536){switch(I|0){case 335544320:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+12<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+32>>3]=+h[c[s>>2]>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+64>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+64+8>>3]=+h[(c[s>>2]|0)+48+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+80>>3]=+h[(c[s>>2]|0)+32>>3];h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+64+8>>3];h[(c[s>>2]|0)+96>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0;h[(c[s>>2]|0)+96+8>>3]=+h[(c[s>>2]|0)+48+8>>3];h[(c[s>>2]|0)+112>>3]=+h[(c[s>>2]|0)+96>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+112+8>>3]=+h[(c[s>>2]|0)+80+8>>3];h[(c[s>>2]|0)+128>>3]=+h[(c[s>>2]|0)+112>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+128+8>>3]=+h[(c[s>>2]|0)+112+8>>3];h[(c[s>>2]|0)+144>>3]=+h[(c[s>>2]|0)+128>>3];h[(c[s>>2]|0)+144+8>>3]=+h[(c[s>>2]|0)+48+8>>3];h[(c[s>>2]|0)+160>>3]=+h[(c[s>>2]|0)+128>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+160+8>>3]=+h[(c[s>>2]|0)+32+8>>3];h[(c[s>>2]|0)+176>>3]=+h[(c[s>>2]|0)+128>>3];h[(c[s>>2]|0)+176+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+192>>3]=+h[(c[s>>2]|0)+128>>3];h[(c[s>>2]|0)+192+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+208>>3]=+h[(c[s>>2]|0)+160>>3];h[(c[s>>2]|0)+208+8>>3]=+h[(c[s>>2]|0)+192+8>>3];h[(c[s>>2]|0)+224>>3]=+h[(c[s>>2]|0)+96>>3];h[(c[s>>2]|0)+224+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+240>>3]=+h[(c[s>>2]|0)+32>>3];h[(c[s>>2]|0)+240+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+12|0,c[p>>2]|0);C=(c[s>>2]|0)+224|0;c[r>>2]=c[C>>2];c[r+4>>2]=c[C+4>>2];c[r+8>>2]=c[C+8>>2];c[r+12>>2]=c[C+12>>2];h[r+16>>3]=+h[r>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 352321536:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+4<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[(c[s>>2]|0)+48>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/8.0;h[(c[s>>2]|0)+64>>3]=+h[(c[s>>2]|0)+48>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[s>>2]|0)+48+8>>3];h[(c[s>>2]|0)+80>>3]=+h[(c[s>>2]|0)+64>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/8.0;h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+32+8>>3];h[(c[s>>2]|0)+96>>3]=+h[(c[s>>2]|0)+80>>3];h[(c[s>>2]|0)+96+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+112>>3]=+h[(c[s>>2]|0)+64>>3];h[(c[s>>2]|0)+112+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+4|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0;h[r+8>>3]=+h[(c[s>>2]|0)+8>>3];h[r+16>>3]=+h[r>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}}if((I|0)<402653184)if((I|0)<385875968){switch(I|0){case 369098752:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+5<<4)|0;h[c[s>>2]>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+8>>3]=+h[(c[q>>2]|0)+16+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[(c[q>>2]|0)+48>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[q>>2]|0)+48+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[m>>2]|0)+32>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[m>>2]|0)+32+8>>3];h[(c[s>>2]|0)+48>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+48+8>>3]=+h[(c[m>>2]|0)+32+8>>3];h[(c[s>>2]|0)+64>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+80>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+80+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+96>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+96+8>>3]=+h[(c[m>>2]|0)+48+8>>3];h[(c[s>>2]|0)+112+8>>3]=+h[(c[m>>2]|0)+8>>3]-(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;h[(c[s>>2]|0)+112>>3]=+h[c[m>>2]>>3];h[(c[s>>2]|0)+128+8>>3]=+h[(c[m>>2]|0)+8>>3];h[(c[s>>2]|0)+128>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+5|0,c[p>>2]|0);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 385875968:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+3<<4)|0;h[c[s>>2]>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+8>>3]=+h[(c[q>>2]|0)+16+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[(c[q>>2]|0)+48>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[q>>2]|0)+48+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[m>>2]|0)+32>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+48+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+64>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[m>>2]|0)+48+8>>3];h[(c[s>>2]|0)+80+8>>3]=+h[(c[m>>2]|0)+8>>3]-(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;h[(c[s>>2]|0)+80>>3]=+h[c[m>>2]>>3];h[(c[s>>2]|0)+96+8>>3]=+h[(c[m>>2]|0)+8>>3];h[(c[s>>2]|0)+96>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+3|0,c[p>>2]|0);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else if((I|0)<419430400){switch(I|0){case 402653184:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+3<<4)|0;h[c[s>>2]>>3]=+h[c[m>>2]>>3];h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[m>>2]|0)+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[q>>2]|0)+32+8>>3];h[(c[s>>2]|0)+48>>3]=+h[(c[m>>2]|0)+16>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[m>>2]|0)+16+8>>3]-(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[(c[s>>2]|0)+64>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[m>>2]|0)+32+8>>3];h[(c[s>>2]|0)+80+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+80>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+96+8>>3]=+h[(c[m>>2]|0)+48+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+96>>3]=+h[c[m>>2]>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+3|0,c[p>>2]|0);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 419430400:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+5<<4)|0;h[c[s>>2]>>3]=+h[c[m>>2]>>3];h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[m>>2]|0)+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[q>>2]|0)+32+8>>3];h[(c[s>>2]|0)+48>>3]=+h[(c[m>>2]|0)+16>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[m>>2]|0)+16+8>>3]-(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[(c[s>>2]|0)+64>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[m>>2]|0)+32+8>>3];h[(c[s>>2]|0)+80+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+80>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+96+8>>3]=+h[(c[m>>2]|0)+48+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+96>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+112>>3]=+h[(c[q>>2]|0)+16>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+112+8>>3]=+h[(c[m>>2]|0)+48+8>>3];h[(c[s>>2]|0)+128>>3]=+h[(c[m>>2]|0)+48>>3];h[(c[s>>2]|0)+128+8>>3]=+h[(c[m>>2]|0)+48+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+5|0,c[p>>2]|0);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}}if((I|0)>=83886080){if((I|0)<134217728){if((I|0)<100663296){switch(I|0){case 83886080:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}if((c[n>>2]|0)!=4)La(143069,143080,711,143089);c[s>>2]=bK((c[n>>2]|0)+8<<4)|0;C=c[s>>2]|0;j=c[m>>2]|0;c[C>>2]=c[j>>2];c[C+4>>2]=c[j+4>>2];c[C+8>>2]=c[j+8>>2];c[C+12>>2]=c[j+12>>2];j=(c[s>>2]|0)+16|0;C=(c[m>>2]|0)+16|0;c[j>>2]=c[C>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];h[(c[s>>2]|0)+32>>3]=+h[(c[q>>2]|0)+48>>3]+(+h[(c[q>>2]|0)+64>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+32+8>>3]=+h[(c[q>>2]|0)+48+8>>3]+(+h[(c[q>>2]|0)+64+8>>3]-+h[(c[q>>2]|0)+48+8>>3]);h[(c[s>>2]|0)+48>>3]=+h[(c[s>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+48>>3]-+h[(c[q>>2]|0)+32>>3]);h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+32+8>>3]);h[(c[s>>2]|0)+64>>3]=+h[(c[s>>2]|0)+48>>3]+(+h[(c[q>>2]|0)+64>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+64+8>>3]=+h[(c[s>>2]|0)+48+8>>3]+(+h[(c[q>>2]|0)+64+8>>3]-+h[(c[q>>2]|0)+48+8>>3]);h[(c[s>>2]|0)+80>>3]=+h[(c[s>>2]|0)+64>>3]+(+h[(c[s>>2]|0)+32>>3]-+h[(c[s>>2]|0)+48>>3]);h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+64+8>>3]+(+h[(c[s>>2]|0)+32+8>>3]-+h[(c[s>>2]|0)+48+8>>3]);h[(c[s>>2]|0)+144>>3]=+h[(c[q>>2]|0)+96>>3]+(+h[(c[q>>2]|0)+80>>3]-+h[(c[q>>2]|0)+96>>3]);h[(c[s>>2]|0)+144+8>>3]=+h[(c[q>>2]|0)+96+8>>3]+(+h[(c[q>>2]|0)+80+8>>3]-+h[(c[q>>2]|0)+96+8>>3]);h[(c[s>>2]|0)+128>>3]=+h[(c[s>>2]|0)+144>>3]+(+h[(c[q>>2]|0)+96>>3]-+h[(c[q>>2]|0)+112>>3]);h[(c[s>>2]|0)+128+8>>3]=+h[(c[s>>2]|0)+144+8>>3]+(+h[(c[q>>2]|0)+96+8>>3]-+h[(c[q>>2]|0)+112+8>>3]);h[(c[s>>2]|0)+112>>3]=+h[(c[s>>2]|0)+128>>3]+(+h[(c[q>>2]|0)+80>>3]-+h[(c[q>>2]|0)+96>>3]);h[(c[s>>2]|0)+112+8>>3]=+h[(c[s>>2]|0)+128+8>>3]+(+h[(c[q>>2]|0)+80+8>>3]-+h[(c[q>>2]|0)+96+8>>3]);h[(c[s>>2]|0)+96>>3]=+h[(c[s>>2]|0)+112>>3]+(+h[(c[s>>2]|0)+144>>3]-+h[(c[s>>2]|0)+128>>3]);h[(c[s>>2]|0)+96+8>>3]=+h[(c[s>>2]|0)+112+8>>3]+(+h[(c[s>>2]|0)+144+8>>3]-+h[(c[s>>2]|0)+128+8>>3]);C=(c[s>>2]|0)+160|0;j=(c[m>>2]|0)+32|0;c[C>>2]=c[j>>2];c[C+4>>2]=c[j+4>>2];c[C+8>>2]=c[j+8>>2];c[C+12>>2]=c[j+12>>2];j=(c[s>>2]|0)+176|0;C=(c[m>>2]|0)+48|0;c[j>>2]=c[C>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+8|0,c[p>>2]|0);C=(c[s>>2]|0)+32|0;c[r>>2]=c[C>>2];c[r+4>>2]=c[C+4>>2];c[r+8>>2]=c[C+8>>2];c[r+12>>2]=c[C+12>>2];h[r+16>>3]=+h[(c[s>>2]|0)+32>>3]-(+h[(c[s>>2]|0)+48>>3]-+h[(c[s>>2]|0)+32>>3]);h[r+16+8>>3]=+h[(c[s>>2]|0)+32+8>>3]-(+h[(c[s>>2]|0)+48+8>>3]-+h[(c[s>>2]|0)+32+8>>3]);h[r+32>>3]=+h[r+16>>3]+(+h[(c[s>>2]|0)+64>>3]-+h[(c[s>>2]|0)+48>>3]);h[r+32+8>>3]=+h[r+16+8>>3]+(+h[(c[s>>2]|0)+64+8>>3]-+h[(c[s>>2]|0)+48+8>>3]);C=r+48|0;j=(c[s>>2]|0)+80|0;c[C>>2]=c[j>>2];c[C+4>>2]=c[j+4>>2];c[C+8>>2]=c[j+8>>2];c[C+12>>2]=c[j+12>>2];wR(c[l>>2]|0,r,4);j=(c[s>>2]|0)+96|0;c[r>>2]=c[j>>2];c[r+4>>2]=c[j+4>>2];c[r+8>>2]=c[j+8>>2];c[r+12>>2]=c[j+12>>2];h[r+16>>3]=+h[(c[s>>2]|0)+96>>3]-(+h[(c[s>>2]|0)+112>>3]-+h[(c[s>>2]|0)+96>>3]);h[r+16+8>>3]=+h[(c[s>>2]|0)+96+8>>3]-(+h[(c[s>>2]|0)+112+8>>3]-+h[(c[s>>2]|0)+96+8>>3]);h[r+32>>3]=+h[r+16>>3]+(+h[(c[s>>2]|0)+128>>3]-+h[(c[s>>2]|0)+112>>3]);h[r+32+8>>3]=+h[r+16+8>>3]+(+h[(c[s>>2]|0)+128+8>>3]-+h[(c[s>>2]|0)+112+8>>3]);j=r+48|0;C=(c[s>>2]|0)+144|0;c[j>>2]=c[C>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];wR(c[l>>2]|0,r,4);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}if((I|0)<117440512){switch(I|0){case 100663296:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+5<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/8.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])*3.0/2.0;h[(c[s>>2]|0)+16>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/4.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[(c[s>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+48+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[(c[s>>2]|0)+64>>3]=+h[(c[s>>2]|0)+48>>3];h[(c[s>>2]|0)+64+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3]);h[(c[s>>2]|0)+80>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+64+8>>3];h[(c[s>>2]|0)+96>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+96+8>>3]=+h[(c[s>>2]|0)+64+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[(c[s>>2]|0)+112>>3]=+h[(c[s>>2]|0)+96>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+112+8>>3]=+h[(c[s>>2]|0)+96+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+128>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+128+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+5|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 117440512:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+1<<4)|0;h[c[s>>2]>>3]=+h[(c[q>>2]|0)+16>>3];h[(c[s>>2]|0)+8>>3]=+h[(c[q>>2]|0)+16+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[(c[q>>2]|0)+48>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[q>>2]|0)+48+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[m>>2]|0)+32>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[(c[q>>2]|0)+16>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[m>>2]|0)+8>>3]-(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;h[(c[s>>2]|0)+64>>3]=+h[c[m>>2]>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+1|0,c[p>>2]|0);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}}if((I|0)<167772160)if((I|0)<150994944){switch(I|0){case 134217728:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+4<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3]+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+48>>3]=+h[(c[s>>2]|0)+32>>3];h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+64>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[s>>2]|0)+48+8>>3];h[(c[s>>2]|0)+80>>3]=+h[(c[s>>2]|0)+64>>3];h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+32+8>>3];h[(c[s>>2]|0)+96>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[(c[s>>2]|0)+96+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+112>>3]=+h[(c[s>>2]|0)+96>>3];h[(c[s>>2]|0)+112+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+4|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 150994944:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+2<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[(c[s>>2]|0)+32>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/4.0;h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];h[(c[s>>2]|0)+64>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])*3.0/4.0;h[(c[s>>2]|0)+64+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+80>>3]=+h[(c[s>>2]|0)+64>>3];h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+2|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else if((I|0)<184549376){switch(I|0){case 167772160:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+1<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[(c[s>>2]|0)+16>>3]=+h[c[s>>2]>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3]);h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3]);h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/4.0;h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];h[(c[s>>2]|0)+64>>3]=+h[(c[s>>2]|0)+48>>3];h[(c[s>>2]|0)+64+8>>3]=+h[(c[s>>2]|0)+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+1|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}else{switch(I|0){case 184549376:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+4<<4)|0;h[c[s>>2]>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/8.0+(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[(c[s>>2]|0)+16>>3]=+h[(c[m>>2]|0)+16>>3]+(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/2.0-(+h[c[m>>2]>>3]-+h[(c[m>>2]|0)+16>>3])/8.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[s>>2]|0)+8>>3];h[(c[s>>2]|0)+32>>3]=+h[(c[s>>2]|0)+16>>3];h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+48>>3]=+h[(c[s>>2]|0)+32>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+48+8>>3]=+h[(c[s>>2]|0)+32+8>>3];h[(c[s>>2]|0)+64>>3]=+h[(c[s>>2]|0)+48>>3];h[(c[s>>2]|0)+64+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/4.0;h[(c[s>>2]|0)+80>>3]=+h[c[s>>2]>>3]-(+h[(c[q>>2]|0)+32>>3]-+h[(c[q>>2]|0)+48>>3])/2.0;h[(c[s>>2]|0)+80+8>>3]=+h[(c[s>>2]|0)+64+8>>3];h[(c[s>>2]|0)+96>>3]=+h[(c[s>>2]|0)+80>>3];h[(c[s>>2]|0)+96+8>>3]=+h[(c[s>>2]|0)+80+8>>3]-(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/2.0;h[(c[s>>2]|0)+112>>3]=+h[c[s>>2]>>3];h[(c[s>>2]|0)+112+8>>3]=+h[(c[s>>2]|0)+96+8>>3];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+4|0,c[p>>2]|0);h[r>>3]=+h[(c[m>>2]|0)+16>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[(c[s>>2]|0)+64>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);h[r>>3]=+h[(c[s>>2]|0)+112>>3];h[r+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+16+8>>3]-+h[(c[m>>2]|0)+32+8>>3])/2.0;h[r+16>>3]=+h[c[m>>2]>>3];h[r+16+8>>3]=+h[(c[m>>2]|0)+32+8>>3]+(+h[(c[m>>2]|0)+8>>3]-+h[(c[m>>2]|0)+48+8>>3])/2.0;wR(c[l>>2]|0,r,2);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}}if((I|0)<33554432){if((I|0)<8){switch(I|0){case 4:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[E>>2]=cK(((c[n>>2]|0)*6|0)+2<<4)|0;c[A>>2]=0;c[B>>2]=0;while(1){C=(c[B>>2]|0)<(c[n>>2]|0);j=c[A>>2]|0;c[A>>2]=j+1;L=(c[E>>2]|0)+(j<<4)|0;if(!C)break;C=(c[q>>2]|0)+(c[B>>2]<<2<<4)|0;c[L>>2]=c[C>>2];c[L+4>>2]=c[C+4>>2];c[L+8>>2]=c[C+8>>2];c[L+12>>2]=c[C+12>>2];C=c[A>>2]|0;c[A>>2]=C+1;j=(c[E>>2]|0)+(C<<4)|0;C=(c[q>>2]|0)+((c[B>>2]<<2)+1<<4)|0;c[j>>2]=c[C>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];C=c[A>>2]|0;c[A>>2]=C+1;j=(c[E>>2]|0)+(C<<4)|0;C=(c[q>>2]|0)+((c[B>>2]<<2)+1<<4)|0;c[j>>2]=c[C>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];C=c[A>>2]|0;c[A>>2]=C+1;j=(c[E>>2]|0)+(C<<4)|0;C=(c[q>>2]|0)+((c[B>>2]<<2)+2<<4)|0;c[j>>2]=c[C>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];C=c[A>>2]|0;c[A>>2]=C+1;j=(c[E>>2]|0)+(C<<4)|0;C=(c[q>>2]|0)+((c[B>>2]<<2)+2<<4)|0;c[j>>2]=c[C>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];C=c[A>>2]|0;c[A>>2]=C+1;j=(c[E>>2]|0)+(C<<4)|0;C=(c[q>>2]|0)+((c[B>>2]<<2)+3<<4)|0;c[j>>2]=c[C>>2];c[j+4>>2]=c[C+4>>2];c[j+8>>2]=c[C+8>>2];c[j+12>>2]=c[C+12>>2];c[B>>2]=(c[B>>2]|0)+1}C=c[E>>2]|0;c[L>>2]=c[C>>2];c[L+4>>2]=c[C+4>>2];c[L+8>>2]=c[C+8>>2];c[L+12>>2]=c[C+12>>2];C=c[A>>2]|0;c[A>>2]=C+1;L=(c[E>>2]|0)+(C<<4)|0;C=(c[E>>2]|0)+16|0;c[L>>2]=c[C>>2];c[L+4>>2]=c[C+4>>2];c[L+8>>2]=c[C+8>>2];c[L+12>>2]=c[C+12>>2];vR(c[l>>2]|0,(c[E>>2]|0)+16|0,(c[A>>2]|0)-1|0,0,0,c[p>>2]&255);O4(c[E>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}if((I|0)<16777216){switch(I|0){case 8:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}tR(c[l>>2]|0,c[m>>2]|0,c[n>>2]|0,c[p>>2]|0);c[B>>2]=0;while(1){if((c[B>>2]|0)>=(c[n>>2]|0))break;E=(c[q>>2]|0)+(((c[B>>2]|0)*3|0)+2<<4)|0;c[r>>2]=c[E>>2];c[r+4>>2]=c[E+4>>2];c[r+8>>2]=c[E+8>>2];c[r+12>>2]=c[E+12>>2];E=r+16|0;A=(c[q>>2]|0)+(((c[B>>2]|0)*3|0)+4<<4)|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];wR(c[l>>2]|0,r,2);c[B>>2]=(c[B>>2]|0)+1}K=c[q>>2]|0;O4(K);i=g;return}switch(I|0){case 16777216:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+1<<4)|0;c[B>>2]=1;while(1){if((c[B>>2]|0)>=(c[n>>2]|0))break;A=(c[s>>2]|0)+(c[B>>2]<<4)|0;E=(c[m>>2]|0)+(c[B>>2]<<4)|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];c[B>>2]=(c[B>>2]|0)+1}E=c[s>>2]|0;A=(c[q>>2]|0)+((((c[n>>2]|0)-1|0)*3|0)+4<<4)|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];A=(c[s>>2]|0)+(c[n>>2]<<4)|0;E=(c[q>>2]|0)+((((c[n>>2]|0)-1|0)*3|0)+2<<4)|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+1|0,c[p>>2]|0);O4(c[s>>2]|0);c[B>>2]=(c[n>>2]|0)-1;E=(c[q>>2]|0)+(((c[B>>2]|0)*3|0)+2<<4)|0;c[r>>2]=c[E>>2];c[r+4>>2]=c[E+4>>2];c[r+8>>2]=c[E+8>>2];c[r+12>>2]=c[E+12>>2];E=r+16|0;A=(c[q>>2]|0)+(((c[B>>2]|0)*3|0)+4<<4)|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];h[r+32>>3]=+h[r+16>>3]+(+h[r>>3]-+h[(c[q>>2]|0)+(((c[B>>2]|0)*3|0)+3<<4)>>3]);h[r+32+8>>3]=+h[r+16+8>>3]+(+h[r+8>>3]-+h[(c[q>>2]|0)+(((c[B>>2]|0)*3|0)+3<<4)+8>>3]);wR(c[l>>2]|0,r+16|0,2);A=r+16|0;E=r+32|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];wR(c[l>>2]|0,r,2);K=c[q>>2]|0;O4(K);i=g;return}else{if((I|0)<50331648){switch(I|0){case 33554432:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+2<<4)|0;E=c[s>>2]|0;A=c[m>>2]|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];A=(c[s>>2]|0)+16|0;E=(c[q>>2]|0)+32|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];h[(c[s>>2]|0)+32>>3]=+h[(c[q>>2]|0)+32>>3]+(+h[(c[q>>2]|0)+48>>3]-+h[(c[q>>2]|0)+64>>3])/3.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[q>>2]|0)+32+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/3.0;h[(c[s>>2]|0)+48>>3]=+h[(c[q>>2]|0)+48>>3]+(+h[(c[q>>2]|0)+48>>3]-+h[(c[q>>2]|0)+64>>3])/3.0;h[(c[s>>2]|0)+48+8>>3]=+h[(c[q>>2]|0)+48+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/3.0;c[B>>2]=4;while(1){if((c[B>>2]|0)>=((c[n>>2]|0)+2|0))break;E=(c[s>>2]|0)+(c[B>>2]<<4)|0;A=(c[m>>2]|0)+((c[B>>2]|0)-2<<4)|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];c[B>>2]=(c[B>>2]|0)+1}tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+2|0,c[p>>2]|0);O4(c[s>>2]|0);A=(c[q>>2]|0)+48|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];A=r+16|0;E=(c[q>>2]|0)+32|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];wR(c[l>>2]|0,r,2);K=c[q>>2]|0;O4(K);i=g;return}if((I|0)>=67108864){switch(I|0){case 67108864:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}if((c[n>>2]|0)!=4)La(143069,143080,688,143089);c[s>>2]=bK((c[n>>2]|0)+2<<4)|0;E=c[s>>2]|0;A=c[m>>2]|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];A=(c[s>>2]|0)+16|0;E=(c[q>>2]|0)+32|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];E=(c[s>>2]|0)+32|0;A=(c[q>>2]|0)+64|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];A=(c[s>>2]|0)+48|0;E=(c[m>>2]|0)+32|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];E=(c[s>>2]|0)+64|0;A=(c[q>>2]|0)+128|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];A=(c[s>>2]|0)+80|0;E=(c[q>>2]|0)+160|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+2|0,c[p>>2]|0);O4(c[s>>2]|0);h[r>>3]=+h[(c[q>>2]|0)+16>>3]+(+h[(c[q>>2]|0)+176>>3]-+h[c[q>>2]>>3]);h[r+8>>3]=+h[(c[q>>2]|0)+16+8>>3]+(+h[(c[q>>2]|0)+176+8>>3]-+h[(c[q>>2]|0)+8>>3]);E=r+16|0;A=(c[q>>2]|0)+64|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];wR(c[l>>2]|0,r,2);A=r+16|0;E=(c[q>>2]|0)+128|0;c[A>>2]=c[E>>2];c[A+4>>2]=c[E+4>>2];c[A+8>>2]=c[E+8>>2];c[A+12>>2]=c[E+12>>2];wR(c[l>>2]|0,r,2);E=r+16|0;A=c[q>>2]|0;c[E>>2]=c[A>>2];c[E+4>>2]=c[A+4>>2];c[E+8>>2]=c[A+8>>2];c[E+12>>2]=c[A+12>>2];wR(c[l>>2]|0,r,2);K=c[q>>2]|0;O4(K);i=g;return}switch(I|0){case 50331648:break;default:{K=c[q>>2]|0;O4(K);i=g;return}}c[s>>2]=bK((c[n>>2]|0)+3<<4)|0;I=c[s>>2]|0;r=c[m>>2]|0;c[I>>2]=c[r>>2];c[I+4>>2]=c[r+4>>2];c[I+8>>2]=c[r+8>>2];c[I+12>>2]=c[r+12>>2];h[(c[s>>2]|0)+16>>3]=+h[c[m>>2]>>3]-(+h[c[m>>2]>>3]-+h[(c[q>>2]|0)+16>>3])/4.0;h[(c[s>>2]|0)+16+8>>3]=+h[(c[m>>2]|0)+8>>3]+(+h[(c[q>>2]|0)+48+8>>3]-+h[(c[q>>2]|0)+64+8>>3])/3.0;h[(c[s>>2]|0)+32>>3]=+h[c[m>>2]>>3]-(+h[c[m>>2]>>3]-+h[(c[q>>2]|0)+16>>3])*2.0;h[(c[s>>2]|0)+32+8>>3]=+h[(c[s>>2]|0)+16+8>>3];h[(c[s>>2]|0)+48>>3]=+h[c[m>>2]>>3]-(+h[c[m>>2]>>3]-+h[(c[q>>2]|0)+16>>3])*2.25;h[(c[s>>2]|0)+48+8>>3]=+h[(c[q>>2]|0)+48+8>>3];h[(c[s>>2]|0)+64>>3]=+h[(c[q>>2]|0)+48>>3];h[(c[s>>2]|0)+64+8>>3]=+h[(c[q>>2]|0)+48+8>>3];c[B>>2]=4;while(1){if((c[B>>2]|0)>=((c[n>>2]|0)+3|0))break;r=(c[s>>2]|0)+(c[B>>2]<<4)|0;I=(c[m>>2]|0)+((c[B>>2]|0)-3<<4)|0;c[r>>2]=c[I>>2];c[r+4>>2]=c[I+4>>2];c[r+8>>2]=c[I+8>>2];c[r+12>>2]=c[I+12>>2];c[B>>2]=(c[B>>2]|0)+1}tR(c[l>>2]|0,c[s>>2]|0,(c[n>>2]|0)+3|0,c[p>>2]|0);O4(c[s>>2]|0);K=c[q>>2]|0;O4(K);i=g;return}}function dM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+12|0;e=b+8|0;f=b+4|0;g=b;c[e>>2]=a;c[f>>2]=c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2];do if(c[f>>2]|0){c[g>>2]=c[c[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]>>2];if((c[g>>2]|0)==82){c[d>>2]=1;break}if((c[g>>2]|0)==85){c[d>>2]=2;break}if((c[g>>2]|0)==84){c[d>>2]=3;break}if((c[g>>2]|0)==87){c[d>>2]=4;break}else{c[d>>2]=0;break}}else c[d>>2]=0;while(0);i=b;return c[d>>2]|0}function eM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b;c[d>>2]=a;if(!(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)){e=0;f=e&1;g=f&255;i=b;return g|0}e=(c[c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]>>2]|0)==82;f=e&1;g=f&255;i=b;return g|0}function fM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=d+4|0;g=d;c[f>>2]=b;a:do if(c[14010]|0){c[g>>2]=0;while(1){if((c[g>>2]|0)>=(c[14011]|0))break a;if((a[c[c[(c[14010]|0)+(c[g>>2]<<2)>>2]>>2]>>0]|0)==(a[c[f>>2]>>0]|0)?(J3(c[c[(c[14010]|0)+(c[g>>2]<<2)>>2]>>2]|0,c[f>>2]|0)|0)==0:0)break;c[g>>2]=(c[g>>2]|0)+1}c[e>>2]=c[(c[14010]|0)+(c[g>>2]<<2)>>2];h=c[e>>2]|0;i=d;return h|0}while(0);c[e>>2]=0;h=c[e>>2]|0;i=d;return h|0}function gM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;h=e+8|0;j=e+4|0;k=e;c[f>>2]=b;c[g>>2]=d;c[j>>2]=0;c[k>>2]=sO(yA(c[g>>2]|0,143103)|0)|0;do if(c[k>>2]|0){if((a[c[f>>2]>>0]|0)==(a[143113]|0)?(J3(c[f>>2]|0,143113)|0)==0:0)break;c[f>>2]=143118}while(0);if(!((a[c[f>>2]>>0]|0)==(a[143118]|0)?(J3(c[f>>2]|0,143118)|0)==0:0))l=7;a:do if((l|0)==7){c[h>>2]=56048;while(1){if(!(c[c[h>>2]>>2]|0))break a;if((a[c[c[h>>2]>>2]>>0]|0)==(a[c[f>>2]>>0]|0)?(J3(c[c[h>>2]>>2]|0,c[f>>2]|0)|0)==0:0)break;c[h>>2]=(c[h>>2]|0)+16}c[j>>2]=c[h>>2]}while(0);if(c[j>>2]|0){m=c[j>>2]|0;i=e;return m|0}c[j>>2]=nM(c[f>>2]|0)|0;m=c[j>>2]|0;i=e;return m|0}function hM(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+64|0;h=g+52|0;j=g+48|0;k=g+44|0;l=g;m=g+40|0;c[h>>2]=b;c[j>>2]=e;c[k>>2]=f;c[m>>2]=oM(c[h>>2]|0,c[j>>2]|0,c[k>>2]|0)|0;c[l+36>>2]=c[(c[k>>2]|0)+36>>2];pM(c[h>>2]|0,c[(c[k>>2]|0)+24>>2]|0,l,c[m>>2]|0,d[(c[k>>2]|0)+33>>0]|0,0)|0;k=a;a=l;l=k+40|0;do{c[k>>2]=c[a>>2];k=k+4|0;a=a+4|0}while((k|0)<(l|0));i=g;return}function iM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+96|0;e=d+80|0;f=d+40|0;g=d;c[e>>2]=b;if(a[(c[(c[e>>2]|0)+8>>2]|0)+16+31>>0]|0){b=(c[(c[e>>2]|0)+8>>2]|0)+16|0;h=c[e>>2]|0;j=c[e>>2]|0;hM(f,c[((c[c[e>>2]>>2]&3|0)==3?h:h+32|0)+28>>2]|0,c[((c[c[e>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2]|0,(c[(c[e>>2]|0)+8>>2]|0)+16|0);k=b;l=f;m=k+40|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0))}if(!(a[(c[(c[e>>2]|0)+8>>2]|0)+56+31>>0]|0)){i=d;return}f=(c[(c[e>>2]|0)+8>>2]|0)+56|0;b=c[e>>2]|0;j=c[e>>2]|0;hM(g,c[((c[c[e>>2]>>2]&3|0)==2?b:b+-32|0)+28>>2]|0,c[((c[c[e>>2]>>2]&3|0)==3?j:j+32|0)+28>>2]|0,(c[(c[e>>2]|0)+8>>2]|0)+56|0);k=f;l=g;m=k+40|0;do{c[k>>2]=c[l>>2];k=k+4|0;l=l+4|0}while((k|0)<(m|0));i=d;return}function jM(a,b,d,e){a=a|0;b=+b;d=d|0;e=e|0;var f=0,g=0,j=0;f=i;i=i+32|0;g=f+16|0;j=f;h[g>>3]=b;h[j>>3]=+h[d>>3]+ +h[g>>3]*(+h[e>>3]-+h[d>>3]);h[j+8>>3]=+h[d+8>>3]+ +h[g>>3]*(+h[e+8>>3]-+h[d+8>>3]);c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=f;return}function kM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,P=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0,ya=0,za=0,Aa=0,Ba=0;d=i;i=i+448|0;e=d+344|0;f=d+336|0;g=d+328|0;j=d+320|0;k=d+312|0;l=d+440|0;m=d+296|0;n=d+280|0;o=d+264|0;p=d+432|0;q=d+248|0;r=d+232|0;s=d+216|0;t=d+428|0;u=d+424|0;v=d+420|0;w=d+416|0;x=d+208|0;y=d+200|0;z=d+192|0;A=d+184|0;B=d+176|0;C=d+168|0;D=d+160|0;E=d+152|0;F=d+144|0;G=d+136|0;H=d+128|0;I=d+120|0;J=d+112|0;K=d+104|0;L=d+96|0;M=d+88|0;P=d+80|0;S=d+72|0;T=d+64|0;U=d+56|0;V=d+48|0;X=d+40|0;Y=d+32|0;Z=d+24|0;$=d+412|0;aa=d+408|0;ba=d+404|0;ca=d+400|0;da=d+396|0;ea=d+392|0;fa=d+388|0;ga=d+384|0;ha=d+16|0;ia=d+376|0;ja=d+368|0;ka=d+364|0;la=d;ma=d+360|0;c[l>>2]=b;c[ga>>2]=bK(48)|0;c[$>>2]=c[c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]>>2];c[aa>>2]=c[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2];c[ba>>2]=c[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2];h[B>>3]=+h[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+16>>3];h[D>>3]=+h[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+32>>3];h[C>>3]=+h[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+24>>3];b=(kO(yA(c[l>>2]|0,143973)|0)|0)&255;c[$>>2]=c[$>>2]|b;b=c[l>>2]|0;do if(c[$>>2]|0){h[ha>>3]=+eN(b);if(+h[ha>>3]>0.0){na=+h[ha>>3];h[V>>3]=na;h[U>>3]=na;break}else{h[U>>3]=+h[(c[(c[l>>2]|0)+8>>2]|0)+32>>3];h[V>>3]=+h[(c[(c[l>>2]|0)+8>>2]|0)+40>>3];na=(+h[U>>3]<+h[V>>3]?+h[U>>3]:+h[V>>3])*72.0;oa=+(~~((+h[U>>3]<+h[V>>3]?+h[U>>3]:+h[V>>3])*72.0>=0.0?na+.5:na-.5)|0);h[V>>3]=oa;h[U>>3]=oa;break}}else{oa=+h[(c[(c[l>>2]|0)+8>>2]|0)+32>>3]*72.0;h[U>>3]=+(~~(+h[(c[b+8>>2]|0)+32>>3]*72.0>=0.0?oa+.5:oa-.5)|0);oa=+h[(c[(c[l>>2]|0)+8>>2]|0)+40>>3]*72.0;h[V>>3]=+(~~(+h[(c[(c[l>>2]|0)+8>>2]|0)+40>>3]*72.0>=0.0?oa+.5:oa-.5)|0)}while(0);c[aa>>2]=eO(c[l>>2]|0,c[13837]|0,c[aa>>2]|0,0)|0;oa=+fO(c[l>>2]|0,c[13839]|0,0.0,-360.0);h[B>>3]=+h[B>>3]+oa;if(!(c[ba>>2]|0)){h[D>>3]=+fO(c[l>>2]|0,c[13840]|0,0.0,-100.0);c[ba>>2]=eO(c[l>>2]|0,c[13836]|0,4,0)|0;h[C>>3]=+fO(c[l>>2]|0,c[13841]|0,0.0,-100.0)}b=(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+24|0;c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];c[m+8>>2]=c[b+8>>2];c[m+12>>2]=c[b+12>>2];b=(N(~~+h[m>>3]|0)|0)>=0;oa=+(N(~~+h[m>>3]|0)|0);if(b)if(~~(oa+.5))pa=14;else pa=11;else if(~~(oa-.5))pa=14;else pa=11;do if((pa|0)==11){b=(N(~~+h[m+8>>3]|0)|0)>=0;oa=+(N(~~+h[m+8>>3]|0)|0);if(b)if(~~(oa+.5)){pa=14;break}else break;else if(~~(oa-.5)){pa=14;break}else break}while(0);do if((pa|0)==14){b=yA(c[l>>2]|0,143958)|0;c[u>>2]=b;if(!b){h[m>>3]=+h[m>>3]+16.0;b=m+8|0;h[b>>3]=+h[b>>3]+8.0;break}h[Y>>3]=0.0;h[X>>3]=0.0;b=c[u>>2]|0;c[k>>2]=X;c[k+4>>2]=Y;c[ca>>2]=l3(b,143965,k)|0;if(+h[X>>3]<0.0)h[X>>3]=0.0;if(+h[Y>>3]<0.0)h[Y>>3]=0.0;if((c[ca>>2]|0)<=0){h[m>>3]=+h[m>>3]+16.0;b=m+8|0;h[b>>3]=+h[b>>3]+8.0;break}oa=+h[X>>3]*72.0;h[m>>3]=+h[m>>3]+ +(~~(+h[X>>3]*72.0>=0.0?oa+.5:oa-.5)<<1|0);if((c[ca>>2]|0)>1){oa=+h[Y>>3]*72.0;b=m+8|0;h[b>>3]=+h[b>>3]+ +(~~(+h[Y>>3]*72.0>=0.0?oa+.5:oa-.5)<<1|0);break}else{oa=+h[X>>3]*72.0;b=m+8|0;h[b>>3]=+h[b>>3]+ +(~~(+h[X>>3]*72.0>=0.0?oa+.5:oa-.5)<<1|0);break}}while(0);h[Z>>3]=+h[m>>3]-+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+24>>3];oa=+h[c[(c[(qC(c[l>>2]|0)|0)+8>>2]|0)+8>>2]>>3];h[x>>3]=oa;if(oa>0.0){oa=+h[x>>3]*72.0;h[x>>3]=+(~~(+h[x>>3]*72.0>=0.0?oa+.5:oa-.5)|0);h[m>>3]=+fN(+h[m>>3],+h[x>>3]);h[m+8>>3]=+fN(+h[m+8>>3],+h[x>>3])}c[p+4>>2]=0;c[p>>2]=0;X=c[l>>2]|0;do if(a[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+12>>0]|0){if((a[c[c[(c[X+8>>2]|0)+8>>2]>>2]>>0]|0)==(a[143118]|0)?(J3(c[c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]>>2]|0,143118)|0)==0:0){c[v>>2]=yA(c[l>>2]|0,143103)|0;Y=qC(c[l>>2]|0)|0;FF(ia,Y,c[v>>2]|0);c[p>>2]=c[ia>>2];c[p+4>>2]=c[ia+4>>2];if((c[p>>2]|0)==-1?(c[p+4>>2]|0)==-1:0){Y=(c[v>>2]|0)!=0?c[v>>2]|0:143981;k=wB(c[l>>2]|0)|0;c[j>>2]=Y;c[j+4>>2]=k;$z(0,143987,j)|0;c[p+4>>2]=0;c[p>>2]=0;break}a[(c[(qC(c[l>>2]|0)|0)+8>>2]|0)+114>>0]=1;c[p>>2]=(c[p>>2]|0)+2;k=p+4|0;c[k>>2]=(c[k>>2]|0)+2}}else{k=yA(X,146722)|0;c[v>>2]=k;if((k|0)!=0?(a[c[v>>2]>>0]|0)!=0:0){k=qC(c[l>>2]|0)|0;FF(ja,k,c[v>>2]|0);c[p>>2]=c[ja>>2];c[p+4>>2]=c[ja+4>>2];if((c[p>>2]|0)==-1?(c[p+4>>2]|0)==-1:0){k=(c[v>>2]|0)!=0?c[v>>2]|0:143981;Y=wB(c[l>>2]|0)|0;c[g>>2]=k;c[g+4>>2]=Y;$z(0,144032,g)|0;c[p+4>>2]=0;c[p>>2]=0;break}a[(c[(qC(c[l>>2]|0)|0)+8>>2]|0)+114>>0]=1;c[p>>2]=(c[p>>2]|0)+2;Y=p+4|0;c[Y>>2]=(c[Y>>2]|0)+2}}while(0);h[o>>3]=+h[m>>3]>+(c[p>>2]|0)?+h[m>>3]:+(c[p>>2]|0);if(+h[m+8>>3]>+(c[p+4>>2]|0))qa=+h[m+8>>3];else qa=+(c[p+4>>2]|0);h[o+8>>3]=qa;if((c[ba>>2]|0)<=2?+h[C>>3]!=0.0|+h[D>>3]!=0.0:0)c[ba>>2]=120;c[u>>2]=yA(c[l>>2]|0,144073)|0;do if(c[u>>2]|0){if((a[c[u>>2]>>0]|0)!=116?(a[c[u>>2]>>0]|0)!=98:0){pa=50;break}a[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+80>>0]=a[c[u>>2]>>0]|0}else pa=50;while(0);if((pa|0)==50)a[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+80>>0]=99;if((c[ba>>2]|0)==4?(qa=+h[B>>3],+h[C>>3]==0.0?((~~(+h[B>>3]>=0.0?qa+.5:qa-.5)|0)%90|0|0)==0:0):0)ra=+h[D>>3]==0.0;else ra=0;c[ea>>2]=ra&1;do if(!(c[ea>>2]|0)){if(c[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+44>>2]|0){c[ka>>2]=c[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+44>>2];ra=c[c[ka>>2]>>2]|0;c[e>>2]=c[o>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2];c[e+12>>2]=c[o+12>>2];Db[ra&31](la,e);c[o>>2]=c[la>>2];c[o+4>>2]=c[la+4>>2];c[o+8>>2]=c[la+8>>2];c[o+12>>2]=c[la+12>>2];break}h[x>>3]=+h[o+8>>3]*1.4142135623730951;if(+h[V>>3]>+h[x>>3]?(a[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+80>>0]|0)==99:0){qa=+O(+(1.0/(1.0-+h[o+8>>3]/+h[V>>3]*(+h[o+8>>3]/+h[V>>3]))));h[o>>3]=+h[o>>3]*qa}else{h[o>>3]=+h[o>>3]*1.4142135623730951;h[o+8>>3]=+h[x>>3]}if((c[ba>>2]|0)>2){h[x>>3]=+Q(+(3.141592653589793/+(c[ba>>2]|0)));h[o>>3]=+h[o>>3]/+h[x>>3];ra=o+8|0;h[ra>>3]=+h[ra>>3]/+h[x>>3]}}while(0);c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[w>>2]=hO(c[l>>2]|0,c[13842]|0,174911)|0;if(((a[c[w>>2]>>0]|0)==115?(a[c[w>>2]>>0]|0)==(a[147662]|0):0)?(J3(c[w>>2]|0,147662)|0)==0:0){h[o>>3]=+h[U>>3];h[o+8>>3]=+h[V>>3];la=(c[ga>>2]|0)+40|0;c[la>>2]=c[la>>2]|2048}else pa=67;do if((pa|0)==67){la=(kO(c[w>>2]|0)|0)<<24>>24!=0;qa=+h[U>>3];if(!la){oa=qa>+h[o>>3]?+h[U>>3]:+h[o>>3];h[U>>3]=oa;h[o>>3]=oa;oa=+h[V>>3]>+h[o+8>>3]?+h[V>>3]:+h[o+8>>3];h[V>>3]=oa;h[o+8>>3]=oa;break}if(!(!(qa<+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+24>>3])?!(+h[V>>3]<+h[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+24+8>>3]):0)){la=wB(c[l>>2]|0)|0;e=wB(qC(c[l>>2]|0)|0)|0;c[f>>2]=la;c[f+4>>2]=e;$z(0,144082,f)|0}h[o>>3]=+h[U>>3];h[o+8>>3]=+h[V>>3]}while(0);if(c[$>>2]|0){qa=+h[o>>3]>+h[o+8>>3]?+h[o>>3]:+h[o+8>>3];h[o+8>>3]=qa;h[o>>3]=qa;h[V>>3]=qa;h[U>>3]=qa}do if(!((kO(hO(c[l>>2]|0,c[13833]|0,174911)|0)|0)<<24>>24)){if(c[ea>>2]|0){h[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+40>>3]=(+h[m>>3]>+h[o>>3]?+h[m>>3]:+h[o>>3])-+h[Z>>3];break}if(+h[m+8>>3]<+h[o+8>>3]){h[x>>3]=+h[o>>3]*+O(+(1.0-+h[m+8>>3]*+h[m+8>>3]/(+h[o+8>>3]*+h[o+8>>3])));h[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+40>>3]=(+h[m>>3]>+h[x>>3]?+h[m>>3]:+h[x>>3])-+h[Z>>3];break}else{h[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+40>>3]=+h[m>>3]-+h[Z>>3];break}}else h[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+40>>3]=+h[m>>3]-+h[Z>>3];while(0);if(!(c[(c[ga>>2]|0)+40>>2]&2048)){h[x>>3]=+h[o+8>>3]-+h[n+8>>3];if(+h[m+8>>3]<+(c[p+4>>2]|0))h[x>>3]=+h[x>>3]+(+(c[p+4>>2]|0)-+h[m+8>>3]);h[(c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2]|0)+40+8>>3]=+h[m+8>>3]+ +h[x>>3]}p=c[aa>>2]|0;c[fa>>2]=p;c[fa>>2]=(c[aa>>2]|0)<1?1:p;a:do if((c[ba>>2]|0)<3){c[ba>>2]=2;c[t>>2]=bK((_(c[fa>>2]|0,c[ba>>2]|0)|0)<<4)|0;h[q>>3]=+h[o>>3]/2.0;h[q+8>>3]=+h[o+8>>3]/2.0;h[c[t>>2]>>3]=-+h[q>>3];h[(c[t>>2]|0)+8>>3]=-+h[q+8>>3];p=(c[t>>2]|0)+16|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2];if((c[aa>>2]|0)>1){c[da>>2]=1;c[ca>>2]=2;while(1){sa=+h[q>>3];if((c[da>>2]|0)>=(c[aa>>2]|0))break;h[q>>3]=sa+4.0;p=q+8|0;h[p>>3]=+h[p>>3]+4.0;h[(c[t>>2]|0)+(c[ca>>2]<<4)>>3]=-+h[q>>3];h[(c[t>>2]|0)+(c[ca>>2]<<4)+8>>3]=-+h[q+8>>3];c[ca>>2]=(c[ca>>2]|0)+1;h[(c[t>>2]|0)+(c[ca>>2]<<4)>>3]=+h[q>>3];h[(c[t>>2]|0)+(c[ca>>2]<<4)+8>>3]=+h[q+8>>3];c[ca>>2]=(c[ca>>2]|0)+1;c[da>>2]=(c[da>>2]|0)+1}h[o>>3]=2.0*sa;h[o+8>>3]=+h[q+8>>3]*2.0}}else{c[t>>2]=bK((_(c[fa>>2]|0,c[ba>>2]|0)|0)<<4)|0;b:do if(c[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+44>>2]|0){c[ma>>2]=c[(c[(c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+44>>2];Db[c[(c[ma>>2]|0)+4>>2]&31](c[t>>2]|0,o);h[M>>3]=+h[o>>3]/2.0;h[P>>3]=+h[o+8>>3]/2.0}else{h[E>>3]=6.283185307179586/+(c[ba>>2]|0);h[F>>3]=+R(+(+h[E>>3]/2.0));qa=+N(+(+h[C>>3]));h[G>>3]=+d2(qa+ +N(+(+h[D>>3])),1.0);h[H>>3]=+h[C>>3]*1.4142135623730951/+Q(+(+h[E>>3]/2.0));h[I>>3]=+h[D>>3]/2.0;h[J>>3]=(+h[E>>3]-3.141592653589793)/2.0;i2(+h[J>>3],K,L);h[s>>3]=+h[L>>3]*.5;h[s+8>>3]=+h[K>>3]*.5;h[P>>3]=0.0;h[M>>3]=0.0;h[J>>3]=+h[J>>3]+(3.141592653589793-+h[E>>3])/2.0;c[ca>>2]=0;while(1){if((c[ca>>2]|0)>=(c[ba>>2]|0))break b;h[J>>3]=+h[J>>3]+ +h[E>>3];i2(+h[J>>3],K,L);h[s>>3]=+h[s>>3]+ +h[F>>3]*+h[L>>3];p=s+8|0;h[p>>3]=+h[p>>3]+ +h[F>>3]*+h[K>>3];h[q>>3]=+h[s>>3]*(+h[G>>3]+ +h[s+8>>3]*+h[H>>3])+ +h[s+8>>3]*+h[I>>3];h[q+8>>3]=+h[s+8>>3];h[y>>3]=+h[B>>3]/180.0*3.141592653589793+ +W(+(+h[q+8>>3]),+(+h[q>>3]));i2(+h[y>>3],K,L);qa=+d2(+h[q>>3],+h[q+8>>3]);h[q+8>>3]=qa;h[q>>3]=qa;h[q>>3]=+h[q>>3]*+h[L>>3];p=q+8|0;h[p>>3]=+h[p>>3]*+h[K>>3];h[q>>3]=+h[q>>3]*+h[o>>3];p=q+8|0;h[p>>3]=+h[p>>3]*+h[o+8>>3];qa=+N(+(+h[q>>3]));if(qa>+h[M>>3])ta=+N(+(+h[q>>3]));else ta=+h[M>>3];h[M>>3]=ta;qa=+N(+(+h[q+8>>3]));if(qa>+h[P>>3])ua=+N(+(+h[q+8>>3]));else ua=+h[P>>3];h[P>>3]=ua;p=(c[t>>2]|0)+(c[ca>>2]<<4)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2];if(c[ea>>2]|0)break;c[ca>>2]=(c[ca>>2]|0)+1}h[(c[t>>2]|0)+16>>3]=-+h[q>>3];h[(c[t>>2]|0)+16+8>>3]=+h[q+8>>3];h[(c[t>>2]|0)+32>>3]=-+h[q>>3];h[(c[t>>2]|0)+32+8>>3]=-+h[q+8>>3];h[(c[t>>2]|0)+48>>3]=+h[q>>3];h[(c[t>>2]|0)+48+8>>3]=-+h[q+8>>3]}while(0);h[M>>3]=+h[M>>3]*2.0;h[P>>3]=+h[P>>3]*2.0;h[o>>3]=+h[U>>3]>+h[M>>3]?+h[U>>3]:+h[M>>3];h[o+8>>3]=+h[V>>3]>+h[P>>3]?+h[V>>3]:+h[P>>3];h[S>>3]=+h[o>>3]/+h[M>>3];h[T>>3]=+h[o+8>>3]/+h[P>>3];c[ca>>2]=0;while(1){if((c[ca>>2]|0)>=(c[ba>>2]|0))break;p=(c[t>>2]|0)+(c[ca>>2]<<4)|0;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];c[q+12>>2]=c[p+12>>2];h[q>>3]=+h[q>>3]*+h[S>>3];p=q+8|0;h[p>>3]=+h[p>>3]*+h[T>>3];p=(c[t>>2]|0)+(c[ca>>2]<<4)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2];c[ca>>2]=(c[ca>>2]|0)+1}if((c[aa>>2]|0)>1){p=(c[t>>2]|0)+((c[ba>>2]|0)-1<<4)|0;c[r>>2]=c[p>>2];c[r+4>>2]=c[p+4>>2];c[r+8>>2]=c[p+8>>2];c[r+12>>2]=c[p+12>>2];p=c[t>>2]|0;c[s>>2]=c[p>>2];c[s+4>>2]=c[p+4>>2];c[s+8>>2]=c[p+8>>2];c[s+12>>2]=c[p+12>>2];h[z>>3]=+W(+(+h[s+8>>3]-+h[r+8>>3]),+(+h[s>>3]-+h[r>>3]));c[ca>>2]=0;while(1){if((c[ca>>2]|0)>=(c[ba>>2]|0))break;c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];p=(c[t>>2]|0)+((((c[ca>>2]|0)+1|0)%(c[ba>>2]|0)|0)<<4)|0;c[s>>2]=c[p>>2];c[s+4>>2]=c[p+4>>2];c[s+8>>2]=c[p+8>>2];c[s+12>>2]=c[p+12>>2];h[y>>3]=+h[z>>3];h[z>>3]=+W(+(+h[s+8>>3]-+h[r+8>>3]),+(+h[s>>3]-+h[r>>3]));h[A>>3]=(+h[y>>3]+3.141592653589793-+h[z>>3])/2.0;h[x>>3]=4.0/+R(+(+h[A>>3]));i2(+h[y>>3]-+h[A>>3],K,L);h[K>>3]=+h[K>>3]*+h[x>>3];h[L>>3]=+h[L>>3]*+h[x>>3];c[da>>2]=1;while(1){if((c[da>>2]|0)>=(c[aa>>2]|0))break;h[r>>3]=+h[r>>3]+ +h[L>>3];p=r+8|0;h[p>>3]=+h[p>>3]+ +h[K>>3];p=(c[ca>>2]|0)+(_(c[da>>2]|0,c[ba>>2]|0)|0)|0;n=(c[t>>2]|0)+(p<<4)|0;c[n>>2]=c[r>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];c[da>>2]=(c[da>>2]|0)+1}c[ca>>2]=(c[ca>>2]|0)+1}c[ca>>2]=0;while(1){if((c[ca>>2]|0)>=(c[ba>>2]|0))break a;n=(c[ca>>2]|0)+(_((c[aa>>2]|0)-1|0,c[ba>>2]|0)|0)|0;p=(c[t>>2]|0)+(n<<4)|0;c[q>>2]=c[p>>2];c[q+4>>2]=c[p+4>>2];c[q+8>>2]=c[p+8>>2];c[q+12>>2]=c[p+12>>2];qa=+N(+(+h[q>>3]))*2.0;if(qa>+h[o>>3])va=+N(+(+h[q>>3]))*2.0;else va=+h[o>>3];h[o>>3]=va;qa=+N(+(+h[q+8>>3]))*2.0;if(qa>+h[o+8>>3])wa=+N(+(+h[q+8>>3]))*2.0;else wa=+h[o+8>>3];h[o+8>>3]=wa;c[ca>>2]=(c[ca>>2]|0)+1}}}while(0);c[c[ga>>2]>>2]=c[$>>2];c[(c[ga>>2]|0)+4>>2]=c[aa>>2];c[(c[ga>>2]|0)+8>>2]=c[ba>>2];h[(c[ga>>2]|0)+16>>3]=+h[B>>3];h[(c[ga>>2]|0)+32>>3]=+h[D>>3];h[(c[ga>>2]|0)+24>>3]=+h[C>>3];c[(c[ga>>2]|0)+44>>2]=c[t>>2];if(c[(c[ga>>2]|0)+40>>2]&2048){h[(c[(c[l>>2]|0)+8>>2]|0)+32>>3]=(+h[m>>3]>+h[o>>3]?+h[m>>3]:+h[o>>3])/72.0;h[(c[(c[l>>2]|0)+8>>2]|0)+40>>3]=(+h[m+8>>3]>+h[o+8>>3]?+h[m+8>>3]:+h[o+8>>3])/72.0;xa=c[ga>>2]|0;ya=c[l>>2]|0;za=ya+8|0;Aa=c[za>>2]|0;Ba=Aa+12|0;c[Ba>>2]=xa;i=d;return}else{h[(c[(c[l>>2]|0)+8>>2]|0)+32>>3]=+h[o>>3]/72.0;h[(c[(c[l>>2]|0)+8>>2]|0)+40>>3]=+h[o+8>>3]/72.0;xa=c[ga>>2]|0;ya=c[l>>2]|0;za=ya+8|0;Aa=c[za>>2]|0;Ba=Aa+12|0;c[Ba>>2]=xa;i=d;return}}function lM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0;b=i;i=i+112|0;d=b+72|0;e=b+64|0;f=b+108|0;g=b+104|0;j=b+48|0;k=b+32|0;l=b+100|0;m=b+96|0;n=b+92|0;o=b+88|0;p=b;c[f>>2]=a;c[o>>2]=15;c[l>>2]=((c[(c[(qC(c[f>>2]|0)|0)+8>>2]|0)+116>>2]>>2&1|0)!=0^1)&1;c[14311]=c[c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]>>2];c[m>>2]=N3(c[14311]|0)|0;c[m>>2]=(c[m>>2]|0)>1?c[m>>2]|0:1;c[n>>2]=bK((c[m>>2]|0)+1|0)|0;m=$M(c[f>>2]|0,c[l>>2]|0,1,c[n>>2]|0)|0;c[g>>2]=m;if(!m){c[e>>2]=c[c[(c[(c[f>>2]|0)+8>>2]|0)+104>>2]>>2];$z(1,143934,e)|0;c[14311]=143955;c[g>>2]=$M(c[f>>2]|0,c[l>>2]|0,1,c[n>>2]|0)|0}O4(c[n>>2]|0);aN(b+16|0,c[f>>2]|0,c[g>>2]|0);q=+h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3]*72.0;h[k>>3]=+(~~(+h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3]*72.0>=0.0?q+.5:q-.5)|0);q=+h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3]*72.0;h[k+8>>3]=+(~~(+h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3]*72.0>=0.0?q+.5:q-.5)|0);if(!((kO(hO(c[f>>2]|0,c[13842]|0,174911)|0)|0)<<24>>24)){if(+h[c[g>>2]>>3]>+h[k>>3])r=+h[c[g>>2]>>3];else r=+h[k>>3];h[k>>3]=r;if(+h[(c[g>>2]|0)+8>>3]>+h[k+8>>3])s=+h[(c[g>>2]|0)+8>>3];else s=+h[k+8>>3];h[k+8>>3]=s}n=c[g>>2]|0;l=(kO(hO(c[f>>2]|0,c[13833]|0,174911)|0)|0)&255;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];c[d+12>>2]=c[k+12>>2];bN(n,d,l);qM(p,-+h[k>>3]/2.0,+h[k+8>>3]/2.0);c[j>>2]=c[p>>2];c[j+4>>2]=c[p+4>>2];c[j+8>>2]=c[p+8>>2];c[j+12>>2]=c[p+12>>2];p=c[g>>2]|0;k=c[o>>2]|0;c[d>>2]=c[j>>2];c[d+4>>2]=c[j+4>>2];c[d+8>>2]=c[j+8>>2];c[d+12>>2]=c[j+12>>2];cN(p,d,k);h[(c[(c[f>>2]|0)+8>>2]|0)+32>>3]=+h[c[g>>2]>>3]/72.0;h[(c[(c[f>>2]|0)+8>>2]|0)+40>>3]=(+h[(c[g>>2]|0)+8>>3]+1.0)/72.0;c[(c[(c[f>>2]|0)+8>>2]|0)+12>>2]=c[g>>2];i=b;return}function mM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0;b=i;i=i+80|0;d=b+68|0;e=b+64|0;f=b+60|0;g=b+56|0;j=b+52|0;k=b+32|0;l=b+16|0;m=b+48|0;n=b+44|0;o=b+40|0;p=b+8|0;q=b;c[d>>2]=a;c[e>>2]=bK(48)|0;c[j>>2]=c[(c[(c[(c[(c[d>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2];h[p>>3]=+fO(c[d>>2]|0,c[13815]|0,1797693134862315708145274.0e284,0.0);h[q>>3]=+fO(c[d>>2]|0,c[13814]|0,1797693134862315708145274.0e284,0.0);h[p>>3]=+h[p>>3]<+h[q>>3]?+h[p>>3]:+h[q>>3];if(+h[p>>3]==1797693134862315708145274.0e284&+h[q>>3]==1797693134862315708145274.0e284){h[(c[(c[d>>2]|0)+8>>2]|0)+40>>3]=.05;h[(c[(c[d>>2]|0)+8>>2]|0)+32>>3]=.05}else{h[p>>3]=+h[p>>3]<+h[q>>3]?+h[p>>3]:+h[q>>3];if(+h[p>>3]>0.0)h[p>>3]=+h[p>>3]>.0003?+h[p>>3]:.0003;r=+h[p>>3];h[(c[(c[d>>2]|0)+8>>2]|0)+40>>3]=r;h[(c[(c[d>>2]|0)+8>>2]|0)+32>>3]=r}h[k>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+32>>3]*72.0;c[j>>2]=eO(c[d>>2]|0,c[13837]|0,c[j>>2]|0,0)|0;if((c[j>>2]|0)<1)c[g>>2]=1;else c[g>>2]=c[j>>2];c[f>>2]=2;c[m>>2]=bK((_(c[g>>2]|0,c[f>>2]|0)|0)<<4)|0;r=+h[k>>3]/2.0;h[l>>3]=r;h[l+8>>3]=r;h[c[m>>2]>>3]=-+h[l>>3];h[(c[m>>2]|0)+8>>3]=-+h[l+8>>3];f=(c[m>>2]|0)+16|0;c[f>>2]=c[l>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[f+12>>2]=c[l+12>>2];if((c[j>>2]|0)<=1){s=c[e>>2]|0;c[s>>2]=1;t=c[j>>2]|0;u=c[e>>2]|0;v=u+4|0;c[v>>2]=t;w=c[e>>2]|0;x=w+8|0;c[x>>2]=2;y=c[e>>2]|0;z=y+16|0;h[z>>3]=0.0;A=c[e>>2]|0;B=A+32|0;h[B>>3]=0.0;C=c[e>>2]|0;D=C+24|0;h[D>>3]=0.0;E=c[m>>2]|0;F=c[e>>2]|0;G=F+44|0;c[G>>2]=E;H=+h[k>>3];I=H/72.0;J=c[d>>2]|0;K=J+8|0;L=c[K>>2]|0;M=L+32|0;h[M>>3]=I;N=c[d>>2]|0;O=N+8|0;P=c[O>>2]|0;Q=P+40|0;h[Q>>3]=I;R=c[e>>2]|0;S=c[d>>2]|0;T=S+8|0;U=c[T>>2]|0;V=U+12|0;c[V>>2]=R;i=b;return}c[o>>2]=1;c[n>>2]=2;while(1){W=+h[l>>3];if((c[o>>2]|0)>=(c[j>>2]|0))break;h[l>>3]=W+4.0;f=l+8|0;h[f>>3]=+h[f>>3]+4.0;h[(c[m>>2]|0)+(c[n>>2]<<4)>>3]=-+h[l>>3];h[(c[m>>2]|0)+(c[n>>2]<<4)+8>>3]=-+h[l+8>>3];c[n>>2]=(c[n>>2]|0)+1;h[(c[m>>2]|0)+(c[n>>2]<<4)>>3]=+h[l>>3];h[(c[m>>2]|0)+(c[n>>2]<<4)+8>>3]=+h[l+8>>3];c[n>>2]=(c[n>>2]|0)+1;c[o>>2]=(c[o>>2]|0)+1}h[k>>3]=2.0*W;s=c[e>>2]|0;c[s>>2]=1;t=c[j>>2]|0;u=c[e>>2]|0;v=u+4|0;c[v>>2]=t;w=c[e>>2]|0;x=w+8|0;c[x>>2]=2;y=c[e>>2]|0;z=y+16|0;h[z>>3]=0.0;A=c[e>>2]|0;B=A+32|0;h[B>>3]=0.0;C=c[e>>2]|0;D=C+24|0;h[D>>3]=0.0;E=c[m>>2]|0;F=c[e>>2]|0;G=F+44|0;c[G>>2]=E;H=+h[k>>3];I=H/72.0;J=c[d>>2]|0;K=J+8|0;L=c[K>>2]|0;M=L+32|0;h[M>>3]=I;N=c[d>>2]|0;O=N+8|0;P=c[O>>2]|0;Q=P+40|0;h[Q>>3]=I;R=c[e>>2]|0;S=c[d>>2]|0;T=S+8|0;U=c[T>>2]|0;V=U+12|0;c[V>>2]=R;i=b;return}function nM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+20|0;g=d+16|0;h=d+12|0;j=d+8|0;c[g>>2]=b;b=fM(c[g>>2]|0)|0;c[j>>2]=b;if(b){c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}b=c[14011]|0;c[14011]=b+1;c[h>>2]=b;if(c[14010]|0)l=eK(c[14010]|0,c[14011]<<2)|0;else l=cK(c[14011]<<2)|0;c[14010]=l;l=bK(16)|0;c[(c[14010]|0)+(c[h>>2]<<2)>>2]=l;c[j>>2]=l;l=c[j>>2]|0;c[l>>2]=c[14012];c[l+4>>2]=c[14013];c[l+8>>2]=c[14014];c[l+12>>2]=c[14015];l=M3(c[g>>2]|0)|0;c[c[j>>2]>>2]=l;do if(!(c[13791]|0)){if((a[c[g>>2]>>0]|0)==(a[143118]|0)?(J3(c[g>>2]|0,143118)|0)==0:0){m=10;break}l=c[c[j>>2]>>2]|0;c[e>>2]=c[14012];c[e+4>>2]=l;$z(0,143131,e)|0;a[(c[j>>2]|0)+12>>0]=0}else m=10;while(0);if((m|0)==10)a[(c[j>>2]|0)+12>>0]=1;c[f>>2]=c[j>>2];k=c[f>>2]|0;i=d;return k|0}function oM(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;f=i;i=i+128|0;g=f+32|0;j=f+112|0;k=f+108|0;l=f+104|0;m=f+100|0;n=f;o=f+96|0;p=f+88|0;q=f+80|0;r=f+72|0;s=f+64|0;t=f+60|0;u=f+56|0;v=f+52|0;w=f+48|0;c[k>>2]=a;c[l>>2]=b;c[m>>2]=e;c[o>>2]=c[(c[(c[(qC(c[k>>2]|0)|0)+48>>2]|0)+8>>2]|0)+116>>2]&3;c[p>>2]=0;c[p+4>>2]=0;e=(c[(c[k>>2]|0)+8>>2]|0)+16|0;b=c[o>>2]|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];uM(q,g,b);b=(c[(c[l>>2]|0)+8>>2]|0)+16|0;l=c[o>>2]|0;c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];uM(r,g,l);c[s>>2]=d[(c[m>>2]|0)+33>>0];c[t>>2]=0;c[w>>2]=0;if((c[s>>2]|0)==0|(c[s>>2]|0)==15){c[j>>2]=c[t>>2];x=c[j>>2]|0;i=f;return x|0}do if(!(c[(c[m>>2]|0)+24>>2]|0)){l=(c[(c[(qC(c[k>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;y=+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]/2.0;g=n+16|0;if(l){h[g>>3]=y;h[n>>3]=-+h[n+16>>3];h[n+16+8>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];h[n+8>>3]=-+h[n+16+8>>3];break}else{h[g+8>>3]=y;h[n+8>>3]=-+h[n+16+8>>3];h[n+16>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3];h[n>>3]=-+h[n+16>>3];break}}else{g=c[(c[m>>2]|0)+24>>2]|0;c[n>>2]=c[g>>2];c[n+4>>2]=c[g+4>>2];c[n+8>>2]=c[g+8>>2];c[n+12>>2]=c[g+12>>2];c[n+16>>2]=c[g+16>>2];c[n+20>>2]=c[g+20>>2];c[n+24>>2]=c[g+24>>2];c[n+28>>2]=c[g+28>>2]}while(0);c[u>>2]=0;while(1){if((c[u>>2]|0)>=4)break;do if(c[s>>2]&1<<c[u>>2]){switch(c[u>>2]|0){case 0:{c[p+4>>2]=~~+h[n+8>>3];c[p>>2]=~~((+h[n>>3]+ +h[n+16>>3])/2.0);break}case 1:{c[p>>2]=~~+h[n+16>>3];c[p+4>>2]=~~((+h[n+8>>3]+ +h[n+16+8>>3])/2.0);break}case 2:{c[p+4>>2]=~~+h[n+16+8>>3];c[p>>2]=~~((+h[n>>3]+ +h[n+16>>3])/2.0);break}case 3:{c[p>>2]=~~+h[n>>3];c[p+4>>2]=~~((+h[n+8>>3]+ +h[n+16+8>>3])/2.0);break}default:{}}c[p>>2]=(c[p>>2]|0)+(c[q>>2]|0);m=p+4|0;c[m>>2]=(c[m>>2]|0)+(c[q+4>>2]|0);m=_((c[p>>2]|0)-(c[r>>2]|0)|0,(c[p>>2]|0)-(c[r>>2]|0)|0)|0;c[v>>2]=m+(_((c[p+4>>2]|0)-(c[r+4>>2]|0)|0,(c[p+4>>2]|0)-(c[r+4>>2]|0)|0)|0);if((c[t>>2]|0)!=0?(c[v>>2]|0)>=(c[w>>2]|0):0)break;c[w>>2]=c[v>>2];c[t>>2]=c[57024+(c[u>>2]<<2)>>2]}while(0);c[u>>2]=(c[u>>2]|0)+1}c[j>>2]=c[t>>2];x=c[j>>2]|0;i=f;return x|0}function pM(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;k=i;i=i+304|0;l=k+248|0;m=k+292|0;n=k+288|0;o=k+284|0;p=k+280|0;q=k+276|0;r=k+272|0;s=k+216|0;t=k+200|0;u=k+184|0;v=k+268|0;w=k+176|0;x=k+299|0;y=k+298|0;z=k+264|0;A=k+297|0;B=k+296|0;C=k+168|0;D=k+152|0;E=k+136|0;F=k+120|0;G=k+104|0;H=k+88|0;I=k+72|0;J=k+56|0;K=k+40|0;L=k+24|0;M=k+8|0;N=k;c[m>>2]=b;c[n>>2]=d;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;c[r>>2]=j;c[v>>2]=0;h[w>>3]=0.0;a[x>>0]=0;a[y>>0]=0;c[z>>2]=0;a[A>>0]=1;if(c[n>>2]|0){j=c[n>>2]|0;c[s>>2]=c[j>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];c[s+16>>2]=c[j+16>>2];c[s+20>>2]=c[j+20>>2];c[s+24>>2]=c[j+24>>2];c[s+28>>2]=c[j+28>>2];qM(D,(+h[s>>3]+ +h[s+16>>3])/2.0,(+h[s+8>>3]+ +h[s+16+8>>3])/2.0);c[t>>2]=c[D>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[t+12>>2]=c[D+12>>2];a[B>>0]=1}else{h[t+8>>3]=0.0;h[t>>3]=0.0;D=(c[(c[(qC(c[m>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;O=+h[(c[(c[m>>2]|0)+8>>2]|0)+80>>3]/2.0;j=s+16|0;if(D){h[j>>3]=O;h[s>>3]=-+h[s+16>>3];h[s+16+8>>3]=+h[(c[(c[m>>2]|0)+8>>2]|0)+88>>3];h[s+8>>3]=-+h[s+16+8>>3]}else{h[j+8>>3]=O;h[s+8>>3]=-+h[s+16+8>>3];h[s+16>>3]=+h[(c[(c[m>>2]|0)+8>>2]|0)+88>>3];h[s>>3]=-+h[s+16>>3]}a[B>>0]=0}j=s+16|0;h[C>>3]=+h[s+16>>3]>+h[s+16+8>>3]?+h[j>>3]:+h[j+8>>3];h[C>>3]=+h[C>>3]*4.0;c[u>>2]=c[t>>2];c[u+4>>2]=c[t+4>>2];c[u+8>>2]=c[t+8>>2];c[u+12>>2]=c[t+12>>2];a:do if((c[p>>2]|0)!=0?(a[c[p>>2]>>0]|0)!=0:0){j=c[p>>2]|0;c[p>>2]=j+1;switch(a[j>>0]|0){case 99:{break a;break}case 101:{if(a[c[p>>2]>>0]|0){c[v>>2]=1;break a}if(c[r>>2]|0){rM(E,c[r>>2]|0,+h[u+8>>3],+h[C>>3]);c[t>>2]=c[E>>2];c[t+4>>2]=c[E+4>>2];c[t+8>>2]=c[E+8>>2];c[t+12>>2]=c[E+12>>2]}else h[t>>3]=+h[s+16>>3];h[w>>3]=0.0;a[x>>0]=1;a[B>>0]=1;a[A>>0]=0;c[z>>2]=c[q>>2]&2;break a;break}case 115:{h[t+8>>3]=+h[s+8>>3];a[x>>0]=1;a[A>>0]=0;switch(a[c[p>>2]>>0]|0){case 0:{h[w>>3]=-1.5707963267948966;a[B>>0]=1;if(c[r>>2]|0){rM(F,c[r>>2]|0,-+h[C>>3],+h[u>>3]);c[t>>2]=c[F>>2];c[t+4>>2]=c[F+4>>2];c[t+8>>2]=c[F+8>>2];c[t+12>>2]=c[F+12>>2]}else h[t>>3]=+h[u>>3];c[z>>2]=c[q>>2]&1;break a;break}case 101:{h[w>>3]=-.7853981633974483;a[B>>0]=1;if(c[r>>2]|0){rM(G,c[r>>2]|0,-+h[C>>3],+h[C>>3]);c[t>>2]=c[G>>2];c[t+4>>2]=c[G+4>>2];c[t+8>>2]=c[G+8>>2];c[t+12>>2]=c[G+12>>2]}else h[t>>3]=+h[s+16>>3];c[z>>2]=c[q>>2]&3;break a;break}case 119:{h[w>>3]=-2.356194490192345;a[B>>0]=1;if(c[r>>2]|0){rM(H,c[r>>2]|0,-+h[C>>3],-+h[C>>3]);c[t>>2]=c[H>>2];c[t+4>>2]=c[H+4>>2];c[t+8>>2]=c[H+8>>2];c[t+12>>2]=c[H+12>>2]}else h[t>>3]=+h[s>>3];c[z>>2]=c[q>>2]&9;break a;break}default:{h[t+8>>3]=+h[u+8>>3];a[x>>0]=0;a[A>>0]=1;c[v>>2]=1;break a}}break}case 119:{if(a[c[p>>2]>>0]|0){c[v>>2]=1;break a}if(c[r>>2]|0){rM(I,c[r>>2]|0,+h[u+8>>3],-+h[C>>3]);c[t>>2]=c[I>>2];c[t+4>>2]=c[I+4>>2];c[t+8>>2]=c[I+8>>2];c[t+12>>2]=c[I+12>>2]}else h[t>>3]=+h[s>>3];h[w>>3]=3.141592653589793;a[x>>0]=1;a[B>>0]=1;a[A>>0]=0;c[z>>2]=c[q>>2]&8;break a;break}case 110:{h[t+8>>3]=+h[s+16+8>>3];a[x>>0]=1;a[A>>0]=0;switch(a[c[p>>2]>>0]|0){case 0:{a[B>>0]=1;h[w>>3]=1.5707963267948966;if(c[r>>2]|0){rM(J,c[r>>2]|0,+h[C>>3],+h[u>>3]);c[t>>2]=c[J>>2];c[t+4>>2]=c[J+4>>2];c[t+8>>2]=c[J+8>>2];c[t+12>>2]=c[J+12>>2]}else h[t>>3]=+h[u>>3];c[z>>2]=c[q>>2]&4;break a;break}case 101:{a[B>>0]=1;h[w>>3]=.7853981633974483;if(c[r>>2]|0){rM(K,c[r>>2]|0,+h[C>>3],+h[C>>3]);c[t>>2]=c[K>>2];c[t+4>>2]=c[K+4>>2];c[t+8>>2]=c[K+8>>2];c[t+12>>2]=c[K+12>>2]}else h[t>>3]=+h[s+16>>3];c[z>>2]=c[q>>2]&6;break a;break}case 119:{a[B>>0]=1;h[w>>3]=2.356194490192345;if(c[r>>2]|0){rM(L,c[r>>2]|0,+h[C>>3],-+h[C>>3]);c[t>>2]=c[L>>2];c[t+4>>2]=c[L+4>>2];c[t+8>>2]=c[L+8>>2];c[t+12>>2]=c[L+12>>2]}else h[t>>3]=+h[s>>3];c[z>>2]=c[q>>2]&12;break a;break}default:{h[t+8>>3]=+h[u+8>>3];a[x>>0]=0;a[A>>0]=1;c[v>>2]=1;break a}}break}case 95:{a[y>>0]=1;c[z>>2]=c[q>>2];break a;break}default:{c[v>>2]=1;break a}}}while(0);q=(c[(c[(qC(c[m>>2]|0)|0)+8>>2]|0)+116>>2]&3)*90|0;c[l>>2]=c[t>>2];c[l+4>>2]=c[t+4>>2];c[l+8>>2]=c[t+8>>2];c[l+12>>2]=c[t+12>>2];EJ(M,l,q);c[t>>2]=c[M>>2];c[t+4>>2]=c[M+4>>2];c[t+8>>2]=c[M+8>>2];c[t+12>>2]=c[M+12>>2];M=c[z>>2]|0;if(a[y>>0]|0)a[(c[o>>2]|0)+33>>0]=M;else{z=(sM(M,c[(c[(qC(c[m>>2]|0)|0)+8>>2]|0)+116>>2]&3)|0)&255;a[(c[o>>2]|0)+33>>0]=z}c[(c[o>>2]|0)+24>>2]=c[n>>2];O=+h[t>>3];h[c[o>>2]>>3]=+(~~(+h[t>>3]>=0.0?O+.5:O-.5)|0);O=+h[t+8>>3];h[(c[o>>2]|0)+8>>3]=+(~~(+h[t+8>>3]>=0.0?O+.5:O-.5)|0);O=+h[w>>3];P=+tM(O,c[(c[(qC(c[m>>2]|0)|0)+8>>2]|0)+116>>2]&3);h[(c[o>>2]|0)+16>>3]=P;if(+h[t>>3]==0.0?+h[t+8>>3]==0.0:0){a[(c[o>>2]|0)+32>>0]=-128;Q=a[x>>0]|0;R=c[o>>2]|0;S=R+29|0;a[S>>0]=Q;T=a[B>>0]|0;U=c[o>>2]|0;V=U+28|0;a[V>>0]=T;X=a[A>>0]|0;Y=c[o>>2]|0;Z=Y+30|0;a[Z>>0]=X;_=a[y>>0]|0;$=c[o>>2]|0;aa=$+31|0;a[aa>>0]=_;ba=c[v>>2]|0;i=k;return ba|0}h[N>>3]=+W(+(+h[t+8>>3]),+(+h[t>>3]))+4.71238898038469;if(+h[N>>3]>=6.283185307179586)h[N>>3]=+h[N>>3]-6.283185307179586;a[(c[o>>2]|0)+32>>0]=~~(+h[N>>3]*256.0/6.283185307179586);Q=a[x>>0]|0;R=c[o>>2]|0;S=R+29|0;a[S>>0]=Q;T=a[B>>0]|0;U=c[o>>2]|0;V=U+28|0;a[V>>0]=T;X=a[A>>0]|0;Y=c[o>>2]|0;Z=Y+30|0;a[Z>>0]=X;_=a[y>>0]|0;$=c[o>>2]|0;aa=$+31|0;a[aa>>0]=_;ba=c[v>>2]|0;i=k;return ba|0}function qM(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3];h[j+8>>3]=+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function rM(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+160|0;g=f+128|0;j=f+156|0;k=f+120|0;l=f+112|0;m=f+48|0;n=f+152|0;o=f+148|0;p=f+144|0;q=f+32|0;r=f+16|0;s=f;c[j>>2]=b;h[k>>3]=d;h[l>>3]=e;c[n>>2]=c[c[j>>2]>>2];c[o>>2]=qC(c[n>>2]|0)|0;c[p>>2]=c[(c[(c[o>>2]|0)+8>>2]|0)+116>>2]&3;h[q>>3]=+h[l>>3];h[q+8>>3]=+h[k>>3];if(c[p>>2]|0){k=(c[p>>2]|0)*90|0;c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];c[g+12>>2]=c[q+12>>2];EJ(r,g,k);c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2]}h[m+8>>3]=0.0;h[m>>3]=0.0;r=m+16|0;c[r>>2]=c[m>>2];c[r+4>>2]=c[m+4>>2];c[r+8>>2]=c[m+8>>2];c[r+12>>2]=c[m+12>>2];r=m+48|0;k=m+32|0;c[k>>2]=c[q>>2];c[k+4>>2]=c[q+4>>2];c[k+8>>2]=c[q+8>>2];c[k+12>>2]=c[q+12>>2];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];c[r+12>>2]=c[k+12>>2];gN(c[j>>2]|0,c[(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0,m,1);if(!(c[p>>2]|0)){c[a>>2]=c[m>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];i=f;return}n=(c[p>>2]|0)*90|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];FJ(s,g,n);c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];c[a>>2]=c[m>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];i=f;return}function sM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;a:do switch(c[f>>2]|0){case 3:{switch(c[e>>2]|0){case 4:{c[e>>2]=2;break a;break}case 1:{c[e>>2]=8;break a;break}case 8:{c[e>>2]=1;break a;break}case 2:{c[e>>2]=4;break a;break}default:break a}break}case 2:{switch(c[e>>2]|0){case 4:{c[e>>2]=1;break a;break}case 1:{c[e>>2]=4;break a;break}default:break a}break}case 1:{switch(c[e>>2]|0){case 4:{c[e>>2]=2;break a;break}case 1:{c[e>>2]=8;break a;break}case 8:{c[e>>2]=4;break a;break}case 2:{c[e>>2]=1;break a;break}default:break a}break}default:{}}while(0);i=d;return c[e>>2]|0}function tM(a,b){a=+a;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;f=d+8|0;h[e>>3]=a;c[f>>2]=b;a:do switch(c[f>>2]|0){case 3:{if(+h[e>>3]==3.141592653589793){h[e>>3]=-1.5707963267948966;break a}if(+h[e>>3]==2.356194490192345){h[e>>3]=-.7853981633974483;break a}if(+h[e>>3]==1.5707963267948966){h[e>>3]=0.0;break a}if(+h[e>>3]==0.0){h[e>>3]=1.5707963267948966;break a}if(+h[e>>3]==-.7853981633974483){h[e>>3]=2.356194490192345;break a}if(+h[e>>3]==-1.5707963267948966)h[e>>3]=3.141592653589793;break}case 2:{h[e>>3]=+h[e>>3]*-1.0;break}case 1:{h[e>>3]=+h[e>>3]-1.5707963267948966;break}default:{}}while(0);i=d;return +(+h[e>>3])}function uM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0.0;e=i;i=i+32|0;f=e+24|0;g=e;j=e+16|0;c[f>>2]=d;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;switch(c[f>>2]|0){case 0:{c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];break}case 2:{h[g>>3]=+h[b>>3];h[g+8>>3]=-+h[b+8>>3];break}case 1:{h[g+8>>3]=+h[b>>3];h[g>>3]=-+h[b+8>>3];break}case 3:{h[g+8>>3]=+h[b>>3];h[g>>3]=+h[b+8>>3];break}default:{}}k=+h[g>>3];c[j>>2]=~~(+h[g>>3]>=0.0?k+.5:k-.5);k=+h[g+8>>3];c[j+4>>2]=~~(+h[g+8>>3]>=0.0?k+.5:k-.5);c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];i=e;return}function vM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+48|0;e=d+32|0;f=d+24|0;g=d+16|0;j=d+8|0;k=d;h[j>>3]=+h[b>>3]/(+Q(.3141592653589793)*2.0);h[k>>3]=+h[b+8>>3]/(+R(.3141592653589793)+ +R(.9424777960769379));h[f>>3]=+h[j>>3]>+h[k>>3]?+h[j>>3]:+h[k>>3];h[g>>3]=+h[f>>3]*+R(1.2566370614359172)*+Q(.6283185307179586)/(+Q(.3141592653589793)*+Q(1.2566370614359172));h[e>>3]=+h[g>>3]*2.0*+Q(.3141592653589793);h[e+8>>3]=+h[g>>3]*(+R(.9424777960769379)+1.0);c[a>>2]=c[e>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];i=d;return}function wM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0;d=i;i=i+80|0;e=d+72|0;f=d+68|0;g=d+64|0;j=d+48|0;k=d+40|0;l=d+32|0;m=d+24|0;n=d+16|0;o=d+8|0;p=d;c[e>>2]=a;c[f>>2]=b;b=c[f>>2]|0;c[j>>2]=c[b>>2];c[j+4>>2]=c[b+4>>2];c[j+8>>2]=c[b+8>>2];c[j+12>>2]=c[b+12>>2];h[m>>3]=(+R(.9424777960769379)+1.0)/(+Q(.3141592653589793)*2.0);h[p>>3]=.3141592653589793;h[l>>3]=+h[j+8>>3]/+h[j>>3];if(!(+h[l>>3]>+h[m>>3])){if(+h[l>>3]<+h[m>>3])h[j+8>>3]=+h[j>>3]*+h[m>>3]}else h[j>>3]=+h[j+8>>3]/+h[m>>3];h[n>>3]=+h[j>>3]/(+Q(.3141592653589793)*2.0);h[o>>3]=+h[n>>3]*+Q(.3141592653589793)*+Q(1.2566370614359172)/(+R(1.2566370614359172)*+Q(.6283185307179586));h[k>>3]=+h[n>>3]*(1.0-+R(.9424777960769379))/2.0;c[g>>2]=0;while(1){if((c[g>>2]|0)>=10)break;q=+h[n>>3]*+Q(+(+h[p>>3]));h[(c[e>>2]|0)+(c[g>>2]<<4)>>3]=q;q=+h[n>>3]*+R(+(+h[p>>3]));h[(c[e>>2]|0)+(c[g>>2]<<4)+8>>3]=q-+h[k>>3];h[p>>3]=+h[p>>3]+.6283185307179586;q=+h[o>>3]*+Q(+(+h[p>>3]));h[(c[e>>2]|0)+((c[g>>2]|0)+1<<4)>>3]=q;q=+h[o>>3]*+R(+(+h[p>>3]));h[(c[e>>2]|0)+((c[g>>2]|0)+1<<4)+8>>3]=q-+h[k>>3];h[p>>3]=+h[p>>3]+.6283185307179586;c[g>>2]=(c[g>>2]|0)+2}g=c[f>>2]|0;c[g>>2]=c[j>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=d;return}function xM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+12>>2];if(!(c[e>>2]|0)){i=b;return}O4(c[(c[e>>2]|0)+44>>2]|0);O4(c[e>>2]|0);i=b;return}function yM(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+96|0;j=h+40|0;k=h+84|0;l=h+80|0;m=h+76|0;n=h;o=h+72|0;p=h+68|0;q=h+64|0;r=h+56|0;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;if(!(a[c[l>>2]>>0]|0)){s=b;t=36640;u=s+40|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));i=h;return}if(!(c[m>>2]|0))c[m>>2]=143782;c[p>>2]=15;if((d[(c[(c[(c[k>>2]|0)+8>>2]|0)+104>>2]|0)+82>>0]|0)!=0?(g=AT(c[k>>2]|0,c[l>>2]|0,p)|0,c[o>>2]=g,(g|0)!=0):0){if(pM(c[k>>2]|0,c[o>>2]|0,n,c[m>>2]|0,c[p>>2]|0,0)|0){o=wB(c[k>>2]|0)|0;g=c[l>>2]|0;f=c[m>>2]|0;c[j>>2]=o;c[j+4>>2]=g;c[j+8>>2]=f;$z(0,143784,j)|0}}else{if((c[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0)==34128)c[q>>2]=0;else{c[r>>2]=c[k>>2];c[r+4>>2]=0;c[q>>2]=r}if(pM(c[k>>2]|0,0,n,c[l>>2]|0,c[p>>2]|0,c[q>>2]|0)|0)MM(c[k>>2]|0,c[l>>2]|0)}s=b;t=n;u=s+40|0;do{c[s>>2]=c[t>>2];s=s+4|0;t=t+4|0}while((s|0)<(u|0));i=h;return}function zM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+192|0;f=e+144|0;g=e+128|0;j=e+112|0;k=e+96|0;l=e+180|0;m=e+176|0;n=e+172|0;o=e+168|0;p=e+80|0;q=e+64|0;r=e+48|0;s=e+164|0;t=e+160|0;u=e+32|0;v=e;c[m>>2]=b;c[n>>2]=c[(c[m>>2]|0)+4>>2];c[o>>2]=c[c[m>>2]>>2];m=(c[(c[(qC(c[o>>2]|0)|0)+8>>2]|0)+116>>2]&3)*90|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];FJ(u,f,m);c[p>>2]=c[u>>2];c[p+4>>2]=c[u+4>>2];c[p+8>>2]=c[u+8>>2];c[p+12>>2]=c[u+12>>2];if(c[n>>2]|0){u=c[n>>2]|0;c[v>>2]=c[u>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[v+20>>2]=c[u+20>>2];c[v+24>>2]=c[u+24>>2];c[v+28>>2]=c[u+28>>2];if((+h[v>>3]<=+h[p>>3]?+h[p>>3]<=+h[v+16>>3]:0)?+h[v+8>>3]<=+h[p+8>>3]:0)w=+h[p+8>>3]<=+h[v+16+8>>3];else w=0;a[l>>0]=w&1;x=a[l>>0]|0;i=e;return x|0}if((c[o>>2]|0)!=(c[14294]|0)){c[14295]=c[(c[(c[o>>2]|0)+8>>2]|0)+12>>2];c[14296]=c[(c[14295]|0)+44>>2];c[14297]=c[(c[14295]|0)+8>>2];w=_((c[(c[14295]|0)+4>>2]|0)-1|0,c[14297]|0)|0;c[14298]=w;c[14298]=(c[14298]|0)<0?0:w;c[14294]=c[o>>2]}c[t>>2]=0;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[14297]|0)){y=16;break}o=(c[14296]|0)+((c[s>>2]|0)+(c[14298]|0)<<4)|0;c[q>>2]=c[o>>2];c[q+4>>2]=c[o+4>>2];c[q+8>>2]=c[o+8>>2];c[q+12>>2]=c[o+12>>2];o=(c[14296]|0)+((((c[s>>2]|0)+4|0)%(c[14297]|0)|0)+(c[14298]|0)<<4)|0;c[r>>2]=c[o>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];c[k>>2]=c[p>>2];c[k+4>>2]=c[p+4>>2];c[k+8>>2]=c[p+8>>2];c[k+12>>2]=c[p+12>>2];c[j>>2]=c[9156];c[j+4>>2]=c[9157];c[j+8>>2]=c[9158];c[j+12>>2]=c[9159];c[g>>2]=c[q>>2];c[g+4>>2]=c[q+4>>2];c[g+8>>2]=c[q+8>>2];c[g+12>>2]=c[q+12>>2];c[f>>2]=c[r>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];if(!(LM(k,j,g,f)|0))c[t>>2]=(c[t>>2]|0)+1;if((c[t>>2]|0)==2){y=14;break}c[s>>2]=(c[s>>2]|0)+2}if((y|0)==14){a[l>>0]=0;x=a[l>>0]|0;i=e;return x|0}else if((y|0)==16){a[l>>0]=1;x=a[l>>0]|0;i=e;return x|0}return 0}function AM(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+32|0;j=h+16|0;k=h+12|0;l=h+8|0;m=h+4|0;n=h;c[j>>2]=a;c[k>>2]=b;c[l>>2]=e;c[m>>2]=f;c[n>>2]=g;c[l>>2]=0;if(!(d[(c[(c[(c[j>>2]|0)+8>>2]|0)+104>>2]|0)+82>>0]|0)){o=c[l>>2]|0;i=h;return o|0}if(!(d[(c[(c[j>>2]|0)+8>>2]|0)+145>>0]|0)){o=c[l>>2]|0;i=h;return o|0}c[l>>2]=BT(c[j>>2]|0,c[k>>2]|0,c[l>>2]|0,c[m>>2]|0,c[n>>2]|0)|0;o=c[l>>2]|0;i=h;return o|0}function BM(e,f){e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0;j=i;i=i+160|0;k=j+56|0;l=j+48|0;m=j+40|0;n=j+32|0;o=j+144|0;p=j+140|0;q=j+136|0;r=j+132|0;s=j+24|0;t=j+16|0;u=j+128|0;v=j+124|0;w=j+120|0;x=j+116|0;y=j+112|0;z=j;A=j+108|0;B=j+150|0;C=j+149|0;D=j+148|0;E=j+104|0;F=j+100|0;G=j+96|0;H=j+92|0;I=j+88|0;J=j+80|0;K=j+76|0;L=j+72|0;M=j+68|0;N=j+64|0;O=j+60|0;c[o>>2]=e;c[p>>2]=f;c[q>>2]=c[(c[o>>2]|0)+16>>2];if(c[(c[q>>2]|0)+208>>2]|0)P=1;else P=((b[(c[q>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)!=0;c[G>>2]=P&1;c[H>>2]=0;c[I>>2]=0;if((c[G>>2]|0)!=0?(c[(c[o>>2]|0)+152>>2]&4|0)==0:0)jR(c[o>>2]|0,c[(c[q>>2]|0)+208>>2]|0,c[(c[q>>2]|0)+228>>2]|0,c[(c[q>>2]|0)+244>>2]|0,c[(c[q>>2]|0)+212>>2]|0);c[r>>2]=c[(c[(c[p>>2]|0)+8>>2]|0)+12>>2];c[A>>2]=c[(c[r>>2]|0)+44>>2];c[x>>2]=c[(c[r>>2]|0)+8>>2];c[w>>2]=c[(c[r>>2]|0)+4>>2];if((c[14292]|0)<(c[x>>2]|0)){c[14292]=(c[x>>2]|0)+5;if(c[14293]|0)Q=eK(c[14293]|0,c[14292]<<4)|0;else Q=cK(c[14292]<<4)|0;c[14293]=Q}Q=(c[(c[(c[p>>2]|0)+8>>2]|0)+104>>2]|0)+56|0;r=(c[(c[p>>2]|0)+8>>2]|0)+16|0;c[Q>>2]=c[r>>2];c[Q+4>>2]=c[r+4>>2];c[Q+8>>2]=c[r+8>>2];c[Q+12>>2]=c[r+12>>2];R=+h[(c[(c[p>>2]|0)+8>>2]|0)+32>>3]*72.0;h[s>>3]=(+h[(c[(c[p>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[p>>2]|0)+8>>2]|0)+96>>3])/+(~~(+h[(c[(c[p>>2]|0)+8>>2]|0)+32>>3]*72.0>=0.0?R+.5:R-.5)|0);R=+h[(c[(c[p>>2]|0)+8>>2]|0)+40>>3]*72.0;h[t>>3]=+h[(c[(c[p>>2]|0)+8>>2]|0)+80>>3]/+(~~(+h[(c[(c[p>>2]|0)+8>>2]|0)+40>>3]*72.0>=0.0?R+.5:R-.5)|0);c[y>>2]=CM(c[o>>2]|0,c[p>>2]|0)|0;c[J>>2]=0;r=c[p>>2]|0;do if(d[(c[(c[p>>2]|0)+8>>2]|0)+117>>0]&1){c[I>>2]=iO(r,c[13819]|0,143666)|0;oR(c[o>>2]|0,c[I>>2]|0);c[E>>2]=iO(c[p>>2]|0,c[13820]|0,143674)|0;pR(c[o>>2]|0,c[E>>2]|0);a[B>>0]=1}else{Q=c[p>>2]|0;if(d[(c[r+8>>2]|0)+117>>0]&2){c[I>>2]=iO(Q,c[13821]|0,143682)|0;oR(c[o>>2]|0,c[I>>2]|0);c[E>>2]=iO(c[p>>2]|0,c[13822]|0,143690)|0;pR(c[o>>2]|0,c[E>>2]|0);a[B>>0]=1;break}P=c[p>>2]|0;if(d[(c[Q+8>>2]|0)+117>>0]&8){c[I>>2]=iO(P,c[13825]|0,143698)|0;oR(c[o>>2]|0,c[I>>2]|0);c[E>>2]=iO(c[p>>2]|0,c[13826]|0,143706)|0;pR(c[o>>2]|0,c[E>>2]|0);a[B>>0]=1;break}if(d[(c[P+8>>2]|0)+117>>0]&4){c[I>>2]=iO(c[p>>2]|0,c[13823]|0,143714)|0;oR(c[o>>2]|0,c[I>>2]|0);c[E>>2]=iO(c[p>>2]|0,c[13824]|0,143722)|0;pR(c[o>>2]|0,c[E>>2]|0);a[B>>0]=1;break}do if(c[y>>2]&1){c[H>>2]=DM(c[p>>2]|0)|0;P=(IH(c[H>>2]|0,J,K)|0)<<24>>24!=0;Q=c[o>>2]|0;if(!P){pR(Q,c[H>>2]|0);a[B>>0]=1;break}pR(Q,c[J>>2]|0);Q=c[o>>2]|0;if(c[J+4>>2]|0){P=c[J+4>>2]|0;f=eO(c[p>>2]|0,c[13850]|0,0,0)|0;qR(Q,P,f,+g[K>>2])}else{f=eO(c[p>>2]|0,c[13850]|0,0,0)|0;qR(Q,174917,f,+g[K>>2])}if(c[y>>2]&2){a[B>>0]=3;break}else{a[B>>0]=2;break}}else if(c[y>>2]&576){c[H>>2]=DM(c[p>>2]|0)|0;a[B>>0]=1;break}else{a[B>>0]=0;break}while(0);c[I>>2]=EM(c[o>>2]|0,c[p>>2]|0)|0}while(0);if(a[(c[(c[(c[p>>2]|0)+8>>2]|0)+8>>2]|0)+12>>0]|0)if((a[c[c[(c[(c[p>>2]|0)+8>>2]|0)+8>>2]>>2]>>0]|0)==(a[143118]|0))S=(J3(c[c[(c[(c[p>>2]|0)+8>>2]|0)+8>>2]>>2]|0,143118)|0)!=0^1;else S=0;else S=1;a[D>>0]=S&1;if(((c[w>>2]|0)==0?(d[B>>0]|0)!=0:0)?(d[D>>0]|0)!=0:0){c[w>>2]=1;oR(c[o>>2]|0,175430)}c[v>>2]=0;while(1){if((c[v>>2]|0)>=(c[w>>2]|0))break;c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[x>>2]|0))break;S=(c[u>>2]|0)+(_(c[v>>2]|0,c[x>>2]|0)|0)|0;K=(c[A>>2]|0)+(S<<4)|0;c[z>>2]=c[K>>2];c[z+4>>2]=c[K+4>>2];c[z+8>>2]=c[K+8>>2];c[z+12>>2]=c[K+12>>2];h[(c[14293]|0)+(c[u>>2]<<4)>>3]=+h[z>>3]*+h[s>>3]+ +h[(c[(c[p>>2]|0)+8>>2]|0)+16>>3];h[(c[14293]|0)+(c[u>>2]<<4)+8>>3]=+h[z+8>>3]*+h[t>>3]+ +h[(c[(c[p>>2]|0)+8>>2]|0)+16+8>>3];c[u>>2]=(c[u>>2]|0)+1}K=c[y>>2]|0;do if((c[x>>2]|0)<=2){if((K&512|0)!=0&(c[v>>2]|0)==0?(H3(c[H>>2]|0,58)|0)!=0:0){c[L>>2]=AH(c[o>>2]|0,c[14293]|0,c[H>>2]|0)|0;if((c[L>>2]|0)>1){c[n>>2]=wB(c[p>>2]|0)|0;$z(3,143730,n)|0}a[B>>0]=0}sR(c[o>>2]|0,c[14293]|0,c[x>>2]|0,d[B>>0]|0);if(c[y>>2]&8)FM(c[o>>2]|0,c[p>>2]|0)}else{if(K&64){if((c[v>>2]|0)==0?(c[M>>2]=BH(c[o>>2]|0,c[14293]|0,c[H>>2]|0,1)|0,(c[M>>2]|0)>1):0){c[m>>2]=wB(c[p>>2]|0)|0;$z(3,143730,m)|0}tR(c[o>>2]|0,c[14293]|0,c[x>>2]|0,0);break}if(c[y>>2]&1024){oR(c[o>>2]|0,175430);tR(c[o>>2]|0,c[14293]|0,c[x>>2]|0,d[B>>0]|0);oR(c[o>>2]|0,c[I>>2]|0);wR(c[o>>2]|0,(c[14293]|0)+32|0,2);break}S=c[o>>2]|0;E=c[14293]|0;r=c[x>>2]|0;if(c[y>>2]&2130706444){cM(S,E,r,c[y>>2]|0,d[B>>0]|0);break}else{tR(S,E,r,d[B>>0]|0);break}}while(0);a[B>>0]=0;c[v>>2]=(c[v>>2]|0)+1}a[C>>0]=0;I=c[p>>2]|0;do if(!(a[(c[(c[(c[p>>2]|0)+8>>2]|0)+8>>2]|0)+12>>0]|0)){m=yA(I,146722)|0;c[F>>2]=m;if((m|0)!=0?(a[c[F>>2]>>0]|0)!=0:0)a[C>>0]=1}else{c[F>>2]=c[c[(c[I+8>>2]|0)+8>>2]>>2];if((a[c[F>>2]>>0]|0)==(a[143118]|0)?(J3(c[F>>2]|0,143118)|0)==0:0){m=yA(c[p>>2]|0,143103)|0;c[F>>2]=m;if(!m)break;if(!(a[c[F>>2]>>0]|0))break;a[C>>0]=1;break}a[C>>0]=1}while(0);if(a[C>>0]|0){c[u>>2]=0;while(1){if((c[u>>2]|0)>=(c[x>>2]|0))break;C=(c[A>>2]|0)+(c[u>>2]<<4)|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];h[(c[14293]|0)+(c[u>>2]<<4)>>3]=+h[z>>3]*+h[s>>3]+ +h[(c[(c[p>>2]|0)+8>>2]|0)+16>>3];h[(c[14293]|0)+(c[u>>2]<<4)+8>>3]=+h[z+8>>3]*+h[t>>3]+ +h[(c[(c[p>>2]|0)+8>>2]|0)+16+8>>3];c[u>>2]=(c[u>>2]|0)+1}do if((d[B>>0]|0)!=0?(d[D>>0]|0)!=0:0){u=c[y>>2]|0;if((c[x>>2]|0)>2)if(!(u&64)){t=c[o>>2]|0;z=c[14293]|0;s=c[x>>2]|0;if(c[y>>2]&12){cM(t,z,s,c[y>>2]|0,d[B>>0]|0);break}else{tR(t,z,s,d[B>>0]|0);break}}else{c[O>>2]=BH(c[o>>2]|0,c[14293]|0,c[H>>2]|0,1)|0;if((c[O>>2]|0)>1){c[k>>2]=wB(c[p>>2]|0)|0;$z(3,143730,k)|0}tR(c[o>>2]|0,c[14293]|0,c[x>>2]|0,0);break}else{if((u&512|0)!=0&(c[v>>2]|0)==0?(H3(c[H>>2]|0,58)|0)!=0:0){c[N>>2]=AH(c[o>>2]|0,c[14293]|0,c[H>>2]|0)|0;if((c[N>>2]|0)>1){c[l>>2]=wB(c[p>>2]|0)|0;$z(3,143730,l)|0}a[B>>0]=0}sR(c[o>>2]|0,c[14293]|0,c[x>>2]|0,d[B>>0]|0);if(!(c[y>>2]&8))break;FM(c[o>>2]|0,c[p>>2]|0);break}}while(0);y=c[o>>2]|0;l=c[F>>2]|0;F=c[14293]|0;N=c[x>>2]|0;x=a[B>>0]|0;yR(y,l,F,N,x,hO(c[p>>2]|0,c[13843]|0,174911)|0);a[B>>0]=0}O4(c[J>>2]|0);VJ(c[o>>2]|0,10,c[(c[(c[p>>2]|0)+8>>2]|0)+104>>2]|0);if(!(c[G>>2]|0)){i=j;return}if(c[(c[o>>2]|0)+152>>2]&4)jR(c[o>>2]|0,c[(c[q>>2]|0)+208>>2]|0,c[(c[q>>2]|0)+228>>2]|0,c[(c[q>>2]|0)+244>>2]|0,c[(c[q>>2]|0)+212>>2]|0);kR(c[o>>2]|0);i=j;return}function CM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+32|0;f=e+24|0;g=e+20|0;j=e+16|0;k=e+12|0;l=e+8|0;m=e;c[f>>2]=b;c[g>>2]=d;d=IM(c[g>>2]|0,l)|0;c[j>>2]=d;if(d)rR(c[f>>2]|0,c[j>>2]|0);if(((c[13849]|0)!=0?(j=zA(c[g>>2]|0,c[13849]|0)|0,c[k>>2]=j,(j|0)!=0):0)?(a[c[k>>2]>>0]|0)!=0:0){h[m>>3]=+fO(c[g>>2]|0,c[13849]|0,1.0,0.0);zR(c[f>>2]|0,+h[m>>3])}i=e;return c[l>>2]|0}function DM(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;a=HM(c[d>>2]|0,172403)|0;i=b;return a|0}function EM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=d;d=iO(c[g>>2]|0,c[13817]|0,178518)|0;c[h>>2]=d;c[h>>2]=(a[c[h>>2]>>0]|0)!=0?d:174917;oR(c[f>>2]|0,c[h>>2]|0);i=e;return c[h>>2]|0}function FM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+128|0;e=d+96|0;f=d+80|0;g=d+116|0;j=d+112|0;k=d+72|0;l=d+64|0;m=d+32|0;n=d+16|0;o=d;c[g>>2]=a;c[j>>2]=b;h[l>>3]=.75;h[k>>3]=.6614;h[n+8>>3]=+h[l>>3]*+h[(c[(c[j>>2]|0)+8>>2]|0)+80>>3]/2.0;h[n>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+96>>3]*+h[k>>3];k=(c[(c[j>>2]|0)+8>>2]|0)+16|0;c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];GM(o,f,e);c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];c[m+12>>2]=c[o+12>>2];h[m+16+8>>3]=+h[m+8>>3];h[m+16>>3]=+h[m>>3]-+h[n>>3]*2.0;wR(c[g>>2]|0,m,2);o=m+8|0;h[o>>3]=+h[o>>3]-+h[n+8>>3]*2.0;h[m+16+8>>3]=+h[m+8>>3];wR(c[g>>2]|0,m,2);i=d;return}function GM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]+ +h[d>>3];h[f+8>>3]=+h[b+8>>3]+ +h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function HM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;h=e;c[f>>2]=b;c[g>>2]=d;c[h>>2]=iO(c[f>>2]|0,c[13818]|0,178518)|0;if((a[c[h>>2]>>0]|0)==0?(c[h>>2]=iO(c[f>>2]|0,c[13817]|0,178518)|0,(a[c[h>>2]>>0]|0)==0):0)c[h>>2]=c[g>>2];i=e;return c[h>>2]|0}function IM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+48|0;f=e+32|0;g=e+28|0;h=e+24|0;j=e+20|0;k=e+16|0;l=e+12|0;m=e+8|0;n=e+4|0;o=e;c[f>>2]=b;c[g>>2]=d;c[j>>2]=0;c[k>>2]=0;c[h>>2]=iO(c[f>>2]|0,c[13834]|0,178518)|0;a:do if(a[c[h>>2]>>0]|0){d=JH(c[h>>2]|0)|0;c[j>>2]=d;c[m>>2]=d;b:while(1){d=c[c[m>>2]>>2]|0;c[o>>2]=d;if(!d)break a;if((a[c[o>>2]>>0]|0)==(a[148663]|0)?(J3(c[o>>2]|0,148663)|0)==0:0){c[k>>2]=c[k>>2]|1;c[m>>2]=(c[m>>2]|0)+4;continue}if((a[c[o>>2]>>0]|0)==(a[143742]|0)?(J3(c[o>>2]|0,143742)|0)==0:0){c[k>>2]=c[k>>2]|4;c[n>>2]=c[m>>2];while(1){c[n>>2]=(c[n>>2]|0)+4;c[(c[n>>2]|0)+-4>>2]=c[c[n>>2]>>2];if(!(c[c[n>>2]>>2]|0))continue b}}if((a[c[o>>2]>>0]|0)==(a[143750]|0)?(J3(c[o>>2]|0,143750)|0)==0:0){c[k>>2]=c[k>>2]|8;c[n>>2]=c[m>>2];while(1){c[n>>2]=(c[n>>2]|0)+4;c[(c[n>>2]|0)+-4>>2]=c[c[n>>2]>>2];if(!(c[c[n>>2]>>2]|0))continue b}}if((a[c[o>>2]>>0]|0)==(a[171938]|0)?(J3(c[o>>2]|0,171938)|0)==0:0){c[k>>2]=c[k>>2]|32;c[m>>2]=(c[m>>2]|0)+4;continue}if((a[c[o>>2]>>0]|0)==(a[143760]|0)?(J3(c[o>>2]|0,143760)|0)==0:0){c[k>>2]=c[k>>2]|3;c[n>>2]=c[m>>2];while(1){c[n>>2]=(c[n>>2]|0)+4;c[(c[n>>2]|0)+-4>>2]=c[c[n>>2]>>2];if(!(c[c[n>>2]>>2]|0))continue b}}if(((a[c[o>>2]>>0]|0)==(a[143767]|0)?(J3(c[o>>2]|0,143767)|0)==0:0)?(JM(c[f>>2]|0)|0)!=0:0){c[k>>2]=c[k>>2]|64;c[n>>2]=c[m>>2];while(1){c[n>>2]=(c[n>>2]|0)+4;c[(c[n>>2]|0)+-4>>2]=c[c[n>>2]>>2];if(!(c[c[n>>2]>>2]|0))continue b}}if(((a[c[o>>2]>>0]|0)==(a[143775]|0)?(J3(c[o>>2]|0,143775)|0)==0:0)?(KM(c[f>>2]|0)|0)!=0:0){c[k>>2]=c[k>>2]|512;c[n>>2]=c[m>>2];while(1){c[n>>2]=(c[n>>2]|0)+4;c[(c[n>>2]|0)+-4>>2]=c[c[n>>2]>>2];if(!(c[c[n>>2]>>2]|0))continue b}}c[m>>2]=(c[m>>2]|0)+4}}while(0);m=c[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0;c[l>>2]=m;if(!m){p=c[k>>2]|0;q=c[g>>2]|0;c[q>>2]=p;r=c[j>>2]|0;i=e;return r|0}c[k>>2]=c[k>>2]|c[(c[l>>2]|0)+40>>2];p=c[k>>2]|0;q=c[g>>2]|0;c[q>>2]=p;r=c[j>>2]|0;i=e;return r|0}function JM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;a=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0;c[f>>2]=a;if(!a){c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}if(((c[(c[f>>2]|0)+8>>2]|0)==4?(j=+h[(c[f>>2]|0)+16>>3],((~~(+h[(c[f>>2]|0)+16>>3]>=0.0?j+.5:j-.5)|0)%90|0|0)==0):0)?+h[(c[f>>2]|0)+24>>3]==0.0:0)k=+h[(c[f>>2]|0)+32>>3]==0.0;else k=0;c[d>>2]=k&1;g=c[d>>2]|0;i=b;return g|0}function KM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+16|0;d=b+8|0;e=b+4|0;f=b;c[e>>2]=a;a=c[(c[(c[(c[e>>2]|0)+8>>2]|0)+8>>2]|0)+8>>2]|0;c[f>>2]=a;if(a){c[d>>2]=(c[(c[f>>2]|0)+8>>2]|0)<=2&1;g=c[d>>2]|0;i=b;return g|0}else{c[d>>2]=0;g=c[d>>2]|0;i=b;return g|0}return 0}function LM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f+28|0;j=f+24|0;k=f+16|0;l=f+8|0;m=f;h[k>>3]=-(+h[e+8>>3]-+h[d+8>>3]);h[l>>3]=+h[e>>3]-+h[d>>3];h[m>>3]=+h[k>>3]*+h[d>>3]+ +h[l>>3]*+h[d+8>>3];c[g>>2]=+h[k>>3]*+h[a>>3]+ +h[l>>3]*+h[a+8>>3]-+h[m>>3]>=0.0&1;c[j>>2]=+h[k>>3]*+h[b>>3]+ +h[l>>3]*+h[b+8>>3]-+h[m>>3]>=0.0&1;i=f;return (c[g>>2]|0)==(c[j>>2]|0)|0}function MM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+12|0;g=d+8|0;c[f>>2]=a;c[g>>2]=b;b=wB(c[f>>2]|0)|0;f=c[g>>2]|0;c[e>>2]=b;c[e+4>>2]=f;$z(0,143845,e)|0;i=d;return}function NM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+64|0;e=d+40|0;f=d+60|0;g=d+24|0;j=d+16|0;k=d+56|0;l=d;c[f>>2]=a;c[k>>2]=c[c[f>>2]>>2];f=(c[(c[(qC(c[k>>2]|0)|0)+8>>2]|0)+116>>2]&3)*90|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];FJ(l,e,f);c[g>>2]=c[l>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[g+12>>2]=c[l+12>>2];h[j>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+80>>3]/2.0;if(!(+h[g+8>>3]>=-+h[j>>3])){m=0;n=m&1;o=n&255;i=d;return o|0}if(!(+h[g+8>>3]<=+h[j>>3])){m=0;n=m&1;o=n&255;i=d;return o|0}if(!(+h[g>>3]>=-+h[(c[(c[k>>2]|0)+8>>2]|0)+88>>3])){m=0;n=m&1;o=n&255;i=d;return o|0}m=+h[g>>3]<=+h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3];n=m&1;o=n&255;i=d;return o|0}function OM(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;e=i;i=i+48|0;f=e;g=e+40|0;j=e+36|0;k=e+32|0;l=e+28|0;m=e+24|0;c[g>>2]=a;c[j>>2]=d;c[k>>2]=c[(c[g>>2]|0)+16>>2];if(c[(c[k>>2]|0)+208>>2]|0)n=1;else n=((b[(c[k>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)!=0;c[m>>2]=n&1;c[l>>2]=c[(c[(c[j>>2]|0)+8>>2]|0)+12>>2];if(!(c[l>>2]|0)){i=e;return}if((c[m>>2]|0)!=0?(c[(c[g>>2]|0)+152>>2]&4|0)==0:0)jR(c[g>>2]|0,c[(c[k>>2]|0)+208>>2]|0,c[(c[k>>2]|0)+228>>2]|0,c[(c[k>>2]|0)+244>>2]|0,c[(c[k>>2]|0)+212>>2]|0);if(c[l>>2]|0){n=c[(c[g>>2]|0)+36>>2]|0;o=+h[(c[(c[j>>2]|0)+8>>2]|0)+16+8>>3]+ +(c[(c[l>>2]|0)+4+4>>2]|0);d=c[c[l>>2]>>2]|0;h[f>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+16>>3]+ +(c[(c[l>>2]|0)+4>>2]|0);h[f+8>>3]=o;c[f+16>>2]=d;Y2(n,143876,f)|0}f=(c[(c[(c[j>>2]|0)+8>>2]|0)+104>>2]|0)+56|0;n=(c[(c[j>>2]|0)+8>>2]|0)+16|0;c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];VJ(c[g>>2]|0,10,c[(c[(c[j>>2]|0)+8>>2]|0)+104>>2]|0);if(!(c[m>>2]|0)){i=e;return}if(c[(c[g>>2]|0)+152>>2]&4)jR(c[g>>2]|0,c[(c[k>>2]|0)+208>>2]|0,c[(c[k>>2]|0)+228>>2]|0,c[(c[k>>2]|0)+244>>2]|0,c[(c[k>>2]|0)+212>>2]|0);kR(c[g>>2]|0);i=e;return}function PM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=c[(c[(c[d>>2]|0)+8>>2]|0)+12>>2];XM(c[e>>2]|0);i=b;return}function QM(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+80|0;j=h+40|0;k=h+72|0;l=h+68|0;m=h+64|0;n=h+60|0;o=h+56|0;p=h;q=h+52|0;c[k>>2]=e;c[l>>2]=f;c[m>>2]=g;if(!(a[c[l>>2]>>0]|0)){r=b;s=36640;t=r+40|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));i=h;return}c[q>>2]=15;if(!(c[m>>2]|0))c[m>>2]=143782;c[n>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2];g=WM(c[n>>2]|0,c[l>>2]|0)|0;c[o>>2]=g;f=c[k>>2]|0;if(g){if(pM(f,(c[o>>2]|0)+16|0,p,c[m>>2]|0,d[(c[o>>2]|0)+65>>0]|0,0)|0){o=wB(c[k>>2]|0)|0;g=c[l>>2]|0;e=c[m>>2]|0;c[j>>2]=o;c[j+4>>2]=g;c[j+8>>2]=e;$z(0,143784,j)|0}}else if(pM(f,(c[n>>2]|0)+16|0,p,c[l>>2]|0,c[q>>2]|0,0)|0)MM(c[k>>2]|0,c[l>>2]|0);r=b;s=p;t=r+40|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(t|0));i=h;return}function RM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+80|0;e=d+48|0;f=d+76|0;g=d+72|0;j=d+68|0;k=d+64|0;l=d+16|0;m=d;c[f>>2]=a;c[j>>2]=c[(c[f>>2]|0)+4>>2];c[k>>2]=c[c[f>>2]>>2];f=(c[(c[(qC(c[k>>2]|0)|0)+8>>2]|0)+116>>2]&3)*90|0;c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];FJ(m,e,f);c[b>>2]=c[m>>2];c[b+4>>2]=c[m+4>>2];c[b+8>>2]=c[m+8>>2];c[b+12>>2]=c[m+12>>2];if(!(c[j>>2]|0)){c[g>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2];k=(c[g>>2]|0)+16|0;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2];c[l+16>>2]=c[k+16>>2];c[l+20>>2]=c[k+20>>2];c[l+24>>2]=c[k+24>>2];c[l+28>>2]=c[k+28>>2]}else{k=c[j>>2]|0;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];c[l+12>>2]=c[k+12>>2];c[l+16>>2]=c[k+16>>2];c[l+20>>2]=c[k+20>>2];c[l+24>>2]=c[k+24>>2];c[l+28>>2]=c[k+28>>2]}if(!(+h[l>>3]<=+h[b>>3])){n=0;o=n&1;p=o&255;i=d;return p|0}if(!(+h[b>>3]<=+h[l+16>>3])){n=0;o=n&1;p=o&255;i=d;return p|0}if(!(+h[l+8>>3]<=+h[b+8>>3])){n=0;o=n&1;p=o&255;i=d;return p|0}n=+h[b+8>>3]<=+h[l+16+8>>3];o=n&1;p=o&255;i=d;return p|0}function SM(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+144|0;k=j+80|0;l=j+48|0;m=j+132|0;n=j+128|0;o=j+124|0;p=j+120|0;q=j+116|0;r=j+112|0;s=j+108|0;t=j+104|0;u=j+100|0;v=j+32|0;w=j+96|0;x=j;c[n>>2]=b;c[o>>2]=d;c[p>>2]=e;c[q>>2]=f;c[r>>2]=g;if(!(a[(c[o>>2]|0)+28>>0]|0)){c[m>>2]=0;y=c[m>>2]|0;i=j;return y|0}g=c[o>>2]|0;c[v>>2]=c[g>>2];c[v+4>>2]=c[g+4>>2];c[v+8>>2]=c[g+8>>2];c[v+12>>2]=c[g+12>>2];c[w>>2]=c[(c[(c[n>>2]|0)+8>>2]|0)+12>>2];c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[(c[w>>2]|0)+48>>2]|0))break;g=(c[(c[(qC(c[n>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;o=(c[(c[(c[w>>2]|0)+56>>2]|0)+(c[s>>2]<<2)>>2]|0)+16|0;if(g){c[t>>2]=~~+h[o+8>>3];c[u>>2]=~~+h[(c[(c[(c[w>>2]|0)+56>>2]|0)+(c[s>>2]<<2)>>2]|0)+16+16+8>>3]}else{c[t>>2]=~~+h[o>>3];c[u>>2]=~~+h[(c[(c[(c[w>>2]|0)+56>>2]|0)+(c[s>>2]<<2)>>2]|0)+16+16>>3]}if(+(c[t>>2]|0)<=+h[v>>3]?+h[v>>3]<=+(c[u>>2]|0):0){z=10;break}c[s>>2]=(c[s>>2]|0)+1}if((z|0)==10){if(c[(c[(qC(c[n>>2]|0)|0)+8>>2]|0)+116>>2]&1){z=c[q>>2]|0;v=(c[(c[(c[w>>2]|0)+56>>2]|0)+(c[s>>2]<<2)>>2]|0)+16|0;s=(c[(c[n>>2]|0)+8>>2]|0)+16|0;c[l>>2]=c[v>>2];c[l+4>>2]=c[v+4>>2];c[l+8>>2]=c[v+8>>2];c[l+12>>2]=c[v+12>>2];c[l+16>>2]=c[v+16>>2];c[l+20>>2]=c[v+20>>2];c[l+24>>2]=c[v+24>>2];c[l+28>>2]=c[v+28>>2];c[k>>2]=c[s>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];c[k+12>>2]=c[s+12>>2];GJ(x,l,k);c[z>>2]=c[x>>2];c[z+4>>2]=c[x+4>>2];c[z+8>>2]=c[x+8>>2];c[z+12>>2]=c[x+12>>2];c[z+16>>2]=c[x+16>>2];c[z+20>>2]=c[x+20>>2];c[z+24>>2]=c[x+24>>2];c[z+28>>2]=c[x+28>>2]}else{h[c[q>>2]>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3]+ +(c[t>>2]|0);h[(c[q>>2]|0)+8>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[n>>2]|0)+8>>2]|0)+80>>3]/2.0;h[(c[q>>2]|0)+16>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3]+ +(c[u>>2]|0)}h[(c[q>>2]|0)+16+8>>3]=+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[n>>2]|0)+8>>2]|0)+80>>3]/2.0;c[c[r>>2]>>2]=1}c[m>>2]=c[p>>2];y=c[m>>2]|0;i=j;return y|0}function TM(d,e){d=d|0;e=e|0;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;f=i;i=i+176|0;j=f+96|0;k=f+168|0;l=f+164|0;m=f+160|0;n=f+64|0;o=f;p=f+156|0;q=f+152|0;r=f+148|0;s=f+144|0;t=f+136|0;u=f+132|0;v=f+128|0;c[k>>2]=d;c[l>>2]=e;c[m>>2]=c[(c[k>>2]|0)+16>>2];if(c[(c[m>>2]|0)+208>>2]|0)w=1;else w=((b[(c[m>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)!=0;c[r>>2]=w&1;c[q>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+12>>2];w=(c[q>>2]|0)+16|0;c[n>>2]=c[w>>2];c[n+4>>2]=c[w+4>>2];c[n+8>>2]=c[w+8>>2];c[n+12>>2]=c[w+12>>2];c[n+16>>2]=c[w+16>>2];c[n+20>>2]=c[w+20>>2];c[n+24>>2]=c[w+24>>2];c[n+28>>2]=c[w+28>>2];h[n>>3]=+h[n>>3]+ +h[(c[(c[l>>2]|0)+8>>2]|0)+16>>3];w=n+8|0;h[w>>3]=+h[w>>3]+ +h[(c[(c[l>>2]|0)+8>>2]|0)+16+8>>3];w=n+16|0;h[w>>3]=+h[w>>3]+ +h[(c[(c[l>>2]|0)+8>>2]|0)+16>>3];w=n+16+8|0;h[w>>3]=+h[w>>3]+ +h[(c[(c[l>>2]|0)+8>>2]|0)+16+8>>3];if((c[r>>2]|0)!=0?(c[(c[k>>2]|0)+152>>2]&4|0)==0:0)jR(c[k>>2]|0,c[(c[m>>2]|0)+208>>2]|0,c[(c[m>>2]|0)+228>>2]|0,c[(c[m>>2]|0)+244>>2]|0,c[(c[m>>2]|0)+212>>2]|0);c[p>>2]=CM(c[k>>2]|0,c[l>>2]|0)|0;EM(c[k>>2]|0,c[l>>2]|0)|0;c[t>>2]=0;do if(c[p>>2]&1){c[u>>2]=DM(c[l>>2]|0)|0;if(!((IH(c[u>>2]|0,t,v)|0)<<24>>24)){c[s>>2]=1;pR(c[k>>2]|0,c[u>>2]|0);break}pR(c[k>>2]|0,c[t>>2]|0);w=c[k>>2]|0;if(c[t+4>>2]|0){e=c[t+4>>2]|0;d=eO(c[l>>2]|0,c[13850]|0,0,0)|0;qR(w,e,d,+g[v>>2])}else{d=eO(c[l>>2]|0,c[13850]|0,0,0)|0;qR(w,174917,d,+g[v>>2])}if(c[p>>2]&2){c[s>>2]=3;break}else{c[s>>2]=2;break}}else c[s>>2]=0;while(0);if((a[c[c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]>>2]>>0]|0)==(a[143653]|0)?(J3(c[c[(c[(c[l>>2]|0)+8>>2]|0)+8>>2]>>2]|0,143653)|0)==0:0)c[p>>2]=c[p>>2]|4;if(c[p>>2]&2130706444){c[o>>2]=c[n>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];c[o+12>>2]=c[n+12>>2];v=o+32|0;u=n+16|0;c[v>>2]=c[u>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];h[o+16>>3]=+h[o+32>>3];h[o+16+8>>3]=+h[o+8>>3];h[o+48>>3]=+h[o>>3];h[o+48+8>>3]=+h[o+32+8>>3];cM(c[k>>2]|0,o,4,c[p>>2]|0,c[s>>2]|0)}else{p=c[k>>2]|0;o=c[s>>2]|0;c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];c[j+12>>2]=c[n+12>>2];c[j+16>>2]=c[n+16>>2];c[j+20>>2]=c[n+20>>2];c[j+24>>2]=c[n+24>>2];c[j+28>>2]=c[n+28>>2];uR(p,j,o)}UM(c[k>>2]|0,c[l>>2]|0,c[q>>2]|0);if(c[t>>2]|0)O4(c[t>>2]|0);if(!(c[r>>2]|0)){i=f;return}if(c[(c[k>>2]|0)+152>>2]&4)jR(c[k>>2]|0,c[(c[m>>2]|0)+208>>2]|0,c[(c[m>>2]|0)+228>>2]|0,c[(c[m>>2]|0)+244>>2]|0,c[(c[m>>2]|0)+212>>2]|0);kR(c[k>>2]|0);i=f;return}function UM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+160|0;g=f+128|0;j=f+112|0;k=f+156|0;l=f+152|0;m=f+148|0;n=f+144|0;o=f+80|0;p=f+64|0;q=f+48|0;r=f+32|0;s=f+16|0;t=f;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;if(c[(c[m>>2]|0)+52>>2]|0){e=(c[(c[m>>2]|0)+52>>2]|0)+56|0;d=(c[m>>2]|0)+16|0;b=(c[m>>2]|0)+16+16|0;c[j>>2]=c[d>>2];c[j+4>>2]=c[d+4>>2];c[j+8>>2]=c[d+8>>2];c[j+12>>2]=c[d+12>>2];c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];VM(q,j,g);b=(c[(c[l>>2]|0)+8>>2]|0)+16|0;c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];GM(r,j,g);c[e>>2]=c[r>>2];c[e+4>>2]=c[r+4>>2];c[e+8>>2]=c[r+8>>2];c[e+12>>2]=c[r+12>>2];VJ(c[k>>2]|0,10,c[(c[m>>2]|0)+52>>2]|0);EM(c[k>>2]|0,c[l>>2]|0)|0}r=(c[(c[l>>2]|0)+8>>2]|0)+16|0;c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2];c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[(c[m>>2]|0)+48>>2]|0))break;if((c[n>>2]|0)>0){if(a[(c[m>>2]|0)+64>>0]|0){r=(c[(c[(c[m>>2]|0)+56>>2]|0)+(c[n>>2]<<2)>>2]|0)+16|0;c[o>>2]=c[r>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2];h[o+16>>3]=+h[o>>3];h[o+16+8>>3]=+h[(c[(c[(c[m>>2]|0)+56>>2]|0)+(c[n>>2]<<2)>>2]|0)+16+16+8>>3]}else{r=o+16|0;e=(c[(c[(c[m>>2]|0)+56>>2]|0)+(c[n>>2]<<2)>>2]|0)+16+16|0;c[r>>2]=c[e>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];h[o>>3]=+h[(c[(c[(c[m>>2]|0)+56>>2]|0)+(c[n>>2]<<2)>>2]|0)+16>>3];h[o+8>>3]=+h[o+16+8>>3]};c[j>>2]=c[o>>2];c[j+4>>2]=c[o+4>>2];c[j+8>>2]=c[o+8>>2];c[j+12>>2]=c[o+12>>2];c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];GM(s,j,g);c[o>>2]=c[s>>2];c[o+4>>2]=c[s+4>>2];c[o+8>>2]=c[s+8>>2];c[o+12>>2]=c[s+12>>2];e=o+16|0;r=o+16|0;c[j>>2]=c[r>>2];c[j+4>>2]=c[r+4>>2];c[j+8>>2]=c[r+8>>2];c[j+12>>2]=c[r+12>>2];c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];GM(t,j,g);c[e>>2]=c[t>>2];c[e+4>>2]=c[t+4>>2];c[e+8>>2]=c[t+8>>2];c[e+12>>2]=c[t+12>>2];wR(c[k>>2]|0,o,2)}UM(c[k>>2]|0,c[l>>2]|0,c[(c[(c[m>>2]|0)+56>>2]|0)+(c[n>>2]<<2)>>2]|0);c[n>>2]=(c[n>>2]|0)+1}i=f;return}function VM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=(+h[b>>3]+ +h[d>>3])/2.0;h[f+8>>3]=(+h[b+8>>3]+ +h[d+8>>3])/2.0;c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function WM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+12|0;g=e+8|0;h=e+4|0;j=e;c[f>>2]=b;c[g>>2]=d;if(((c[(c[f>>2]|0)+60>>2]|0)!=0?(a[c[(c[f>>2]|0)+60>>2]>>0]|0)==(a[c[g>>2]>>0]|0):0)?(J3(c[(c[f>>2]|0)+60>>2]|0,c[g>>2]|0)|0)==0:0){c[h>>2]=c[f>>2];k=c[h>>2]|0;i=e;return k|0}c[h>>2]=0;c[j>>2]=0;while(1){if((c[j>>2]|0)>=(c[(c[f>>2]|0)+48>>2]|0)){l=9;break}d=WM(c[(c[(c[f>>2]|0)+56>>2]|0)+(c[j>>2]<<2)>>2]|0,c[g>>2]|0)|0;c[h>>2]=d;if(d){l=9;break}c[j>>2]=(c[j>>2]|0)+1}if((l|0)==9){k=c[h>>2]|0;i=e;return k|0}return 0}function XM(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=b+4|0;e=b;c[d>>2]=a;c[e>>2]=0;while(1){if((c[e>>2]|0)>=(c[(c[d>>2]|0)+48>>2]|0))break;XM(c[(c[(c[d>>2]|0)+56>>2]|0)+(c[e>>2]<<2)>>2]|0);c[e>>2]=(c[e>>2]|0)+1}O4(c[(c[d>>2]|0)+60>>2]|0);UJ(c[(c[d>>2]|0)+52>>2]|0);O4(c[(c[d>>2]|0)+56>>2]|0);O4(c[d>>2]|0);i=b;return}function YM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;e=i;i=i+80|0;f=e+32|0;g=e+64|0;j=e+60|0;k=e+16|0;l=e+56|0;m=e;n=e+52|0;o=e+48|0;c[j>>2]=b;c[l>>2]=c[c[j>>2]>>2];j=(c[(c[(qC(c[l>>2]|0)|0)+8>>2]|0)+116>>2]&3)*90|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];FJ(m,f,j);c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];c[k+12>>2]=c[m+12>>2];if((c[l>>2]|0)!=(c[14304]|0)){c[o>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+12>>2];m=(c[(c[o>>2]|0)+4>>2]|0)-1<<1;c[n>>2]=m;c[n>>2]=(c[n>>2]|0)<0?0:m;h[4585]=+h[(c[(c[o>>2]|0)+44>>2]|0)+((c[n>>2]|0)+1<<4)>>3];c[14304]=c[l>>2]}p=+N(+(+h[k>>3]));if(!(p>+h[4585])?(p=+N(+(+h[k+8>>3])),!(p>+h[4585])):0){p=+d2(+h[k>>3],+h[k+8>>3]);a[g>>0]=p<=+h[4585];q=a[g>>0]|0;i=e;return q|0}a[g>>0]=0;q=a[g>>0]|0;i=e;return q|0}function ZM(e,f){e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;g=i;i=i+80|0;j=g+60|0;k=g+56|0;l=g+52|0;m=g+48|0;n=g+44|0;o=g+40|0;p=g+36|0;q=g+32|0;r=g+28|0;s=g;t=g+24|0;u=g+64|0;v=g+20|0;w=g+16|0;c[j>>2]=e;c[k>>2]=f;c[l>>2]=c[(c[j>>2]|0)+16>>2];if(c[(c[l>>2]|0)+208>>2]|0)x=1;else x=((b[(c[l>>2]|0)+260>>1]<<15&65535)<<16>>16>>15<<16>>16|0)!=0;c[w>>2]=x&1;if((c[w>>2]|0)!=0?(c[(c[j>>2]|0)+152>>2]&4|0)==0:0)jR(c[j>>2]|0,c[(c[l>>2]|0)+208>>2]|0,c[(c[l>>2]|0)+228>>2]|0,c[(c[l>>2]|0)+244>>2]|0,c[(c[l>>2]|0)+212>>2]|0);c[m>>2]=c[(c[(c[k>>2]|0)+8>>2]|0)+12>>2];c[t>>2]=c[(c[m>>2]|0)+44>>2];c[p>>2]=c[(c[m>>2]|0)+8>>2];c[q>>2]=c[(c[m>>2]|0)+4>>2];if((c[14299]|0)<(c[p>>2]|0)){c[14299]=(c[p>>2]|0)+2;if(c[14300]|0)y=eK(c[14300]|0,c[14299]<<4)|0;else y=cK(c[14299]<<4)|0;c[14300]=y}IM(c[k>>2]|0,r)|0;y=c[j>>2]|0;if(c[r>>2]&32)rR(y,57204);else rR(y,57208);y=c[k>>2]|0;do if(!(d[(c[(c[k>>2]|0)+8>>2]|0)+117>>0]&1)){r=c[k>>2]|0;if(d[(c[y+8>>2]|0)+117>>0]&2){c[v>>2]=iO(r,c[13821]|0,143682)|0;oR(c[j>>2]|0,c[v>>2]|0);c[v>>2]=iO(c[k>>2]|0,c[13822]|0,143690)|0;pR(c[j>>2]|0,c[v>>2]|0);break}m=c[k>>2]|0;if(d[(c[r+8>>2]|0)+117>>0]&8){c[v>>2]=iO(m,c[13825]|0,143698)|0;oR(c[j>>2]|0,c[v>>2]|0);c[v>>2]=iO(c[k>>2]|0,c[13826]|0,143706)|0;pR(c[j>>2]|0,c[v>>2]|0);break}r=c[k>>2]|0;if(d[(c[m+8>>2]|0)+117>>0]&4){c[v>>2]=iO(r,c[13823]|0,143714)|0;oR(c[j>>2]|0,c[v>>2]|0);c[v>>2]=iO(c[k>>2]|0,c[13824]|0,143722)|0;pR(c[j>>2]|0,c[v>>2]|0);break}else{c[v>>2]=HM(r,174917)|0;pR(c[j>>2]|0,c[v>>2]|0);EM(c[j>>2]|0,c[k>>2]|0)|0;break}}else{c[v>>2]=iO(y,c[13819]|0,143666)|0;oR(c[j>>2]|0,c[v>>2]|0);c[v>>2]=iO(c[k>>2]|0,c[13820]|0,143674)|0;pR(c[j>>2]|0,c[v>>2]|0)}while(0);a[u>>0]=1;if((c[q>>2]|0)==0?(c[q>>2]=1,(a[c[v>>2]>>0]|0)!=0):0)oR(c[j>>2]|0,c[v>>2]|0);c[o>>2]=0;while(1){if((c[o>>2]|0)>=(c[q>>2]|0))break;c[n>>2]=0;while(1){if((c[n>>2]|0)>=(c[p>>2]|0))break;v=(c[n>>2]|0)+(_(c[o>>2]|0,c[p>>2]|0)|0)|0;y=(c[t>>2]|0)+(v<<4)|0;c[s>>2]=c[y>>2];c[s+4>>2]=c[y+4>>2];c[s+8>>2]=c[y+8>>2];c[s+12>>2]=c[y+12>>2];h[(c[14300]|0)+(c[n>>2]<<4)>>3]=+h[s>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3];h[(c[14300]|0)+(c[n>>2]<<4)+8>>3]=+h[s+8>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3];c[n>>2]=(c[n>>2]|0)+1}sR(c[j>>2]|0,c[14300]|0,c[p>>2]|0,d[u>>0]|0);a[u>>0]=0;c[o>>2]=(c[o>>2]|0)+1}if(!(c[w>>2]|0)){i=g;return}if(c[(c[j>>2]|0)+152>>2]&4)jR(c[j>>2]|0,c[(c[l>>2]|0)+208>>2]|0,c[(c[l>>2]|0)+228>>2]|0,c[(c[l>>2]|0)+244>>2]|0,c[(c[l>>2]|0)+212>>2]|0);kR(c[j>>2]|0);i=g;return}function _M(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0;e=i;i=i+240|0;f=e+192|0;g=e+176|0;j=e+160|0;k=e+144|0;l=e+236|0;m=e+232|0;n=e+228|0;o=e+224|0;p=e+220|0;q=e+216|0;r=e+128|0;s=e+112|0;t=e+96|0;u=e+212|0;v=e+208|0;w=e+80|0;x=e+48|0;y=e+40|0;z=e+32|0;A=e;c[m>>2]=b;c[u>>2]=c[(c[m>>2]|0)+4>>2];c[v>>2]=c[c[m>>2]>>2];m=(c[(c[(qC(c[v>>2]|0)|0)+8>>2]|0)+116>>2]&3)*90|0;c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];FJ(w,f,m);c[r>>2]=c[w>>2];c[r+4>>2]=c[w+4>>2];c[r+8>>2]=c[w+8>>2];c[r+12>>2]=c[w+12>>2];if(c[u>>2]|0){w=c[u>>2]|0;c[x>>2]=c[w>>2];c[x+4>>2]=c[w+4>>2];c[x+8>>2]=c[w+8>>2];c[x+12>>2]=c[w+12>>2];c[x+16>>2]=c[w+16>>2];c[x+20>>2]=c[w+20>>2];c[x+24>>2]=c[w+24>>2];c[x+28>>2]=c[w+28>>2];if((+h[x>>3]<=+h[r>>3]?+h[r>>3]<=+h[x+16>>3]:0)?+h[x+8>>3]<=+h[r+8>>3]:0)B=+h[r+8>>3]<=+h[x+16+8>>3];else B=0;a[l>>0]=B&1;C=a[l>>0]|0;i=e;return C|0}if((c[v>>2]|0)!=(c[14305]|0)){c[14306]=c[(c[(c[v>>2]|0)+8>>2]|0)+12>>2];c[14307]=c[(c[14306]|0)+44>>2];c[14308]=c[(c[14306]|0)+8>>2];do if(c[(c[14306]|0)+40>>2]&2048){zO(A,c[14306]|0);h[y>>3]=+h[A+16>>3]-+h[A>>3];h[z>>3]=+h[A+16+8>>3]-+h[A+8>>3];B=(c[(c[(qC(c[v>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;D=+h[y>>3];if(B){h[4586]=D;h[4587]=+h[z>>3];break}else{h[4587]=D;h[4586]=+h[z>>3];break}}else{B=(c[(c[(qC(c[v>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;D=+h[(c[(c[v>>2]|0)+8>>2]|0)+88>>3]+ +h[(c[(c[v>>2]|0)+8>>2]|0)+96>>3];if(B){h[4586]=D;h[4587]=+h[(c[(c[v>>2]|0)+8>>2]|0)+80>>3]}else{h[4587]=D;h[4586]=+h[(c[(c[v>>2]|0)+8>>2]|0)+80>>3]}D=+h[(c[(c[v>>2]|0)+8>>2]|0)+32>>3]*72.0;h[y>>3]=+(~~(+h[(c[(c[v>>2]|0)+8>>2]|0)+32>>3]*72.0>=0.0?D+.5:D-.5)|0);D=+h[(c[(c[v>>2]|0)+8>>2]|0)+40>>3]*72.0;h[z>>3]=+(~~(+h[(c[(c[v>>2]|0)+8>>2]|0)+40>>3]*72.0>=0.0?D+.5:D-.5)|0)}while(0);if(+h[4587]==0.0)h[4587]=1.0;if(+h[4586]==0.0)h[4586]=1.0;h[4588]=+h[y>>3]/+h[4587];h[4589]=+h[z>>3]/+h[4586];h[4590]=+h[y>>3]/2.0;h[4591]=+h[z>>3]/2.0;z=_((c[(c[14306]|0)+4>>2]|0)-1|0,c[14308]|0)|0;c[14309]=z;c[14309]=(c[14309]|0)<0?0:z;c[14305]=c[v>>2]}h[r>>3]=+h[r>>3]*+h[4588];v=r+8|0;h[v>>3]=+h[v>>3]*+h[4589];D=+N(+(+h[r>>3]));if(!(D>+h[4590])?(D=+N(+(+h[r+8>>3])),!(D>+h[4591])):0){if((c[14308]|0)<=2){a[l>>0]=+d2(+h[r>>3]/+h[4590],+h[r+8>>3]/+h[4591])<1.0;C=a[l>>0]|0;i=e;return C|0}c[n>>2]=(c[14310]|0)%(c[14308]|0)|0;c[o>>2]=((c[n>>2]|0)+1|0)%(c[14308]|0)|0;v=(c[14307]|0)+((c[n>>2]|0)+(c[14309]|0)<<4)|0;c[s>>2]=c[v>>2];c[s+4>>2]=c[v+4>>2];c[s+8>>2]=c[v+8>>2];c[s+12>>2]=c[v+12>>2];v=(c[14307]|0)+((c[o>>2]|0)+(c[14309]|0)<<4)|0;c[t>>2]=c[v>>2];c[t+4>>2]=c[v+4>>2];c[t+8>>2]=c[v+8>>2];c[t+12>>2]=c[v+12>>2];c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];c[j>>2]=c[9184];c[j+4>>2]=c[9185];c[j+8>>2]=c[9186];c[j+12>>2]=c[9187];c[g>>2]=c[s>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];c[f>>2]=c[t>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];if(!(LM(k,j,g,f)|0)){a[l>>0]=0;C=a[l>>0]|0;i=e;return C|0};c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];c[j>>2]=c[s>>2];c[j+4>>2]=c[s+4>>2];c[j+8>>2]=c[s+8>>2];c[j+12>>2]=c[s+12>>2];c[g>>2]=c[t>>2];c[g+4>>2]=c[t+4>>2];c[g+8>>2]=c[t+8>>2];c[g+12>>2]=c[t+12>>2];c[f>>2]=c[9184];c[f+4>>2]=c[9185];c[f+8>>2]=c[9186];c[f+12>>2]=c[9187];v=LM(k,j,g,f)|0;c[q>>2]=v;if((v|0)!=0?(c[k>>2]=c[r>>2],c[k+4>>2]=c[r+4>>2],c[k+8>>2]=c[r+8>>2],c[k+12>>2]=c[r+12>>2],c[j>>2]=c[t>>2],c[j+4>>2]=c[t+4>>2],c[j+8>>2]=c[t+8>>2],c[j+12>>2]=c[t+12>>2],c[g>>2]=c[9184],c[g+4>>2]=c[9185],c[g+8>>2]=c[9186],c[g+12>>2]=c[9187],c[f>>2]=c[s>>2],c[f+4>>2]=c[s+4>>2],c[f+8>>2]=c[s+8>>2],c[f+12>>2]=c[s+12>>2],(LM(k,j,g,f)|0)!=0):0){a[l>>0]=1;C=a[l>>0]|0;i=e;return C|0}c[p>>2]=1;while(1){if((c[p>>2]|0)>=(c[14308]|0)){E=39;break}if(c[q>>2]|0){c[n>>2]=c[o>>2];c[o>>2]=((c[n>>2]|0)+1|0)%(c[14308]|0)|0}else{c[o>>2]=c[n>>2];c[n>>2]=((c[n>>2]|0)+(c[14308]|0)-1|0)%(c[14308]|0)|0}s=(c[14307]|0)+((c[n>>2]|0)+(c[14309]|0)<<4)|0;t=(c[14307]|0)+((c[o>>2]|0)+(c[14309]|0)<<4)|0;c[k>>2]=c[r>>2];c[k+4>>2]=c[r+4>>2];c[k+8>>2]=c[r+8>>2];c[k+12>>2]=c[r+12>>2];c[j>>2]=c[9184];c[j+4>>2]=c[9185];c[j+8>>2]=c[9186];c[j+12>>2]=c[9187];c[g>>2]=c[s>>2];c[g+4>>2]=c[s+4>>2];c[g+8>>2]=c[s+8>>2];c[g+12>>2]=c[s+12>>2];c[f>>2]=c[t>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];c[f+12>>2]=c[t+12>>2];if(!(LM(k,j,g,f)|0)){E=37;break}c[p>>2]=(c[p>>2]|0)+1}if((E|0)==37){c[14310]=c[n>>2];a[l>>0]=0;C=a[l>>0]|0;i=e;return C|0}else if((E|0)==39){c[14310]=c[n>>2];a[l>>0]=1;C=a[l>>0]|0;i=e;return C|0}}a[l>>0]=0;C=a[l>>0]|0;i=e;return C|0}function $M(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+80|0;k=j+76|0;l=j+72|0;m=j+68|0;n=j+64|0;o=j+60|0;p=j+56|0;q=j+52|0;r=j+48|0;s=j+44|0;t=j+40|0;u=j+36|0;v=j+32|0;w=j+28|0;x=j+24|0;y=j+20|0;z=j+16|0;A=j+12|0;B=j+8|0;C=j+4|0;D=j;c[l>>2]=b;c[m>>2]=e;c[n>>2]=f;c[o>>2]=g;c[q>>2]=bK(72)|0;c[s>>2]=0;c[u>>2]=0;c[w>>2]=0;c[D>>2]=c[(c[(c[l>>2]|0)+8>>2]|0)+104>>2];c[p>>2]=0;c[x>>2]=1;c[y>>2]=0;c[v>>2]=c[14311];while(1){if(!(a[c[v>>2]>>0]|0))break;if((a[c[v>>2]>>0]|0)==92?(c[v>>2]=(c[v>>2]|0)+1,(a[c[v>>2]>>0]|0)!=0):0){if((((a[c[v>>2]>>0]|0)!=123?(a[c[v>>2]>>0]|0)!=125:0)?(a[c[v>>2]>>0]|0)!=124:0)?(a[c[v>>2]>>0]|0)!=92:0)E=9}else E=9;if((E|0)==9){E=0;do if((a[c[v>>2]>>0]|0)!=123){if((a[c[v>>2]>>0]|0)==125){c[y>>2]=(c[y>>2]|0)+-1;break}if((c[y>>2]|0)==0?(a[c[v>>2]>>0]|0)==124:0)c[x>>2]=(c[x>>2]|0)+1}else c[y>>2]=(c[y>>2]|0)+1;while(0);if((c[y>>2]|0)<0)break}c[v>>2]=(c[v>>2]|0)+1}v=bK(c[x>>2]<<2)|0;c[(c[q>>2]|0)+56>>2]=v;a[(c[q>>2]|0)+64>>0]=c[m>>2];c[z>>2]=0;c[C>>2]=0;v=c[o>>2]|0;c[r>>2]=v;c[t>>2]=v;c[A>>2]=1;c[B>>2]=0;a:while(1){if(!(c[A>>2]|0)){E=94;break}if((a[c[14311]>>0]|0)<32?(a[c[14311]>>0]|0)!=0:0){c[14311]=(c[14311]|0)+1;continue}b:do switch(a[c[14311]>>0]|0){case 60:{if(c[z>>2]&6){E=24;break a}if(!(a[(c[D>>2]|0)+82>>0]|0)){c[z>>2]=c[z>>2]|18;c[14311]=(c[14311]|0)+1;v=c[o>>2]|0;c[s>>2]=v;c[u>>2]=v;continue a}break}case 62:{if(!(a[(c[D>>2]|0)+82>>0]|0)){if(!(c[z>>2]&16)){E=29;break a}if(((c[s>>2]|0)>>>0>((c[o>>2]|0)+1|0)>>>0?((c[s>>2]|0)+-1|0)!=(c[u>>2]|0):0)?(a[(c[s>>2]|0)+-1>>0]|0)==32:0)c[s>>2]=(c[s>>2]|0)+-1;a[c[s>>2]>>0]=0;c[w>>2]=M3(c[o>>2]|0)|0;c[z>>2]=c[z>>2]&-17;c[14311]=(c[14311]|0)+1;continue a}break}case 123:{c[14311]=(c[14311]|0)+1;if(c[z>>2]|0){E=37;break a}if(!(a[c[14311]>>0]|0)){E=37;break a}c[z>>2]=4;v=$M(c[l>>2]|0,((c[m>>2]|0)!=0^1)&1,0,c[o>>2]|0)|0;x=c[C>>2]|0;c[C>>2]=x+1;c[(c[(c[q>>2]|0)+56>>2]|0)+(x<<2)>>2]=v;if(v)continue a;else{E=39;break a}break}case 0:case 124:case 125:{if(!((a[c[14311]>>0]|0)!=0|(c[n>>2]|0)!=0)){E=42;break a}if(c[z>>2]&16){E=42;break a}if(!(c[z>>2]&4)){v=bK(72)|0;x=c[C>>2]|0;c[C>>2]=x+1;c[(c[(c[q>>2]|0)+56>>2]|0)+(x<<2)>>2]=v;c[p>>2]=v}if(c[w>>2]|0){c[(c[p>>2]|0)+60>>2]=c[w>>2];c[w>>2]=0}if(!(c[z>>2]&5)){c[z>>2]=c[z>>2]|1;v=c[r>>2]|0;c[r>>2]=v+1;a[v>>0]=32}if(c[z>>2]&1){if(((c[r>>2]|0)>>>0>((c[o>>2]|0)+1|0)>>>0?((c[r>>2]|0)+-1|0)!=(c[t>>2]|0):0)?(a[(c[r>>2]|0)+-1>>0]|0)==32:0)c[r>>2]=(c[r>>2]|0)+-1;a[c[r>>2]>>0]=0;v=c[l>>2]|0;x=M3(c[o>>2]|0)|0;y=SJ(v,x,(d[(c[D>>2]|0)+82>>0]|0)!=0?2:0,+h[(c[D>>2]|0)+16>>3],c[(c[D>>2]|0)+4>>2]|0,c[(c[D>>2]|0)+8>>2]|0)|0;c[(c[p>>2]|0)+52>>2]=y;a[(c[p>>2]|0)+64>>0]=1;y=c[o>>2]|0;c[r>>2]=y;c[t>>2]=y}if(!(a[c[14311]>>0]|0)){c[A>>2]=0;continue a}if((a[c[14311]>>0]|0)==125){E=57;break a}c[z>>2]=0;c[14311]=(c[14311]|0)+1;continue a;break}case 92:{if(a[(c[14311]|0)+1>>0]|0){if(((((a[(c[14311]|0)+1>>0]|0)!=123?(a[(c[14311]|0)+1>>0]|0)!=125:0)?(a[(c[14311]|0)+1>>0]|0)!=124:0)?(a[(c[14311]|0)+1>>0]|0)!=60:0)?(a[(c[14311]|0)+1>>0]|0)!=62:0){if((a[(c[14311]|0)+1>>0]|0)==32?(a[(c[D>>2]|0)+82>>0]|0)==0:0){c[B>>2]=1;c[14311]=(c[14311]|0)+1;break b}y=c[r>>2]|0;c[r>>2]=y+1;a[y>>0]=92;c[z>>2]=c[z>>2]|9;c[14311]=(c[14311]|0)+1;break b}c[14311]=(c[14311]|0)+1}break}default:{}}while(0);if((c[z>>2]&4|0)!=0?(a[c[14311]>>0]|0)!=32:0){E=73;break}if((c[z>>2]&24|0)==0?(a[c[14311]>>0]|0)!=32:0)c[z>>2]=c[z>>2]|9;if(c[z>>2]&8){if(!((!((c[B>>2]|0)!=0?1:(a[c[14311]>>0]|0)!=32)?(a[(c[r>>2]|0)+-1>>0]|0)==32:0)?(a[(c[D>>2]|0)+82>>0]|0)==0:0)){y=a[c[14311]>>0]|0;x=c[r>>2]|0;c[r>>2]=x+1;a[x>>0]=y}if(c[B>>2]|0)c[t>>2]=(c[r>>2]|0)+-1}else if(c[z>>2]&16){if(!((c[B>>2]|0)!=0?1:(a[c[14311]>>0]|0)!=32)){if((c[s>>2]|0)!=(c[o>>2]|0)?(a[(c[s>>2]|0)+-1>>0]|0)!=32:0)E=88}else E=88;if((E|0)==88){E=0;y=a[c[14311]>>0]|0;x=c[s>>2]|0;c[s>>2]=x+1;a[x>>0]=y}if(c[B>>2]|0)c[u>>2]=(c[s>>2]|0)+-1}c[14311]=(c[14311]|0)+1;while(1){if(!(a[c[14311]>>0]&128))continue a;y=c[14311]|0;c[14311]=y+1;x=a[y>>0]|0;y=c[r>>2]|0;c[r>>2]=y+1;a[y>>0]=x}}if((E|0)==24){c[k>>2]=dN(c[q>>2]|0,c[w>>2]|0)|0;F=c[k>>2]|0;i=j;return F|0}else if((E|0)==29){c[k>>2]=dN(c[q>>2]|0,c[w>>2]|0)|0;F=c[k>>2]|0;i=j;return F|0}else if((E|0)==37){c[k>>2]=dN(c[q>>2]|0,c[w>>2]|0)|0;F=c[k>>2]|0;i=j;return F|0}else if((E|0)==39){c[k>>2]=dN(c[q>>2]|0,c[w>>2]|0)|0;F=c[k>>2]|0;i=j;return F|0}else if((E|0)==42){c[k>>2]=dN(c[q>>2]|0,c[w>>2]|0)|0;F=c[k>>2]|0;i=j;return F|0}else if((E|0)==57){c[14311]=(c[14311]|0)+1;c[(c[q>>2]|0)+48>>2]=c[C>>2];c[k>>2]=c[q>>2];F=c[k>>2]|0;i=j;return F|0}else if((E|0)==73){c[k>>2]=dN(c[q>>2]|0,c[w>>2]|0)|0;F=c[k>>2]|0;i=j;return F|0}else if((E|0)==94){c[(c[q>>2]|0)+48>>2]=c[C>>2];c[k>>2]=c[q>>2];F=c[k>>2]|0;i=j;return F|0}return 0}function aN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;f=i;i=i+112|0;g=f+80|0;j=f+100|0;k=f+96|0;l=f+92|0;m=f+88|0;n=f+72|0;o=f+64|0;p=f+48|0;q=f+32|0;r=f+16|0;s=f;c[j>>2]=d;c[k>>2]=e;if(!(c[(c[k>>2]|0)+52>>2]|0)){h[p+8>>3]=0.0;h[p>>3]=0.0;c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[k>>2]|0)+48>>2]|0))break;aN(s,c[j>>2]|0,c[(c[(c[k>>2]|0)+56>>2]|0)+(c[l>>2]<<2)>>2]|0);c[q>>2]=c[s>>2];c[q+4>>2]=c[s+4>>2];c[q+8>>2]=c[s+8>>2];c[q+12>>2]=c[s+12>>2];if(a[(c[k>>2]|0)+64>>0]|0){h[p>>3]=+h[p>>3]+ +h[q>>3];h[p+8>>3]=+h[p+8>>3]>+h[q+8>>3]?+h[p+8>>3]:+h[q+8>>3]}else{e=p+8|0;h[e>>3]=+h[e>>3]+ +h[q+8>>3];h[p>>3]=+h[p>>3]>+h[q>>3]?+h[p>>3]:+h[q>>3]}c[l>>2]=(c[l>>2]|0)+1}t=c[k>>2]|0;c[t>>2]=c[p>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];c[b>>2]=c[p>>2];c[b+4>>2]=c[p+4>>2];c[b+8>>2]=c[p+8>>2];c[b+12>>2]=c[p+12>>2];i=f;return}q=(c[(c[k>>2]|0)+52>>2]|0)+24|0;c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];if(!(!(+h[r>>3]>0.0)?!(+h[r+8>>3]>0.0):0))u=4;do if((u|0)==4){q=yA(c[j>>2]|0,143958)|0;c[m>>2]=q;if(!q){h[r>>3]=+h[r>>3]+16.0;q=r+8|0;h[q>>3]=+h[q>>3]+8.0;break}q=c[m>>2]|0;c[g>>2]=n;c[g+4>>2]=o;c[l>>2]=l3(q,143965,g)|0;if((c[l>>2]|0)>0){v=+h[n>>3]*72.0;h[r>>3]=+h[r>>3]+ +(~~(+h[n>>3]*72.0>=0.0?v+.5:v-.5)<<1|0);v=+h[o>>3]*72.0;q=r+8|0;h[q>>3]=+h[q>>3]+ +(~~(+h[o>>3]*72.0>=0.0?v+.5:v-.5)<<1|0);break}else{h[r>>3]=+h[r>>3]+16.0;q=r+8|0;h[q>>3]=+h[q>>3]+8.0;break}}while(0);c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2];t=c[k>>2]|0;c[t>>2]=c[p>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];c[b>>2]=c[p>>2];c[b+4>>2]=c[p+4>>2];c[b+8>>2]=c[p+8>>2];c[b+12>>2]=c[p+12>>2];i=f;return}function bN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+112|0;g=f+72|0;j=f+104|0;k=f+100|0;l=f+96|0;m=f+92|0;n=f+64|0;o=f+48|0;p=f+32|0;q=f+88|0;r=f+16|0;s=f;c[j>>2]=b;c[k>>2]=e;h[o>>3]=+h[d>>3]-+h[c[j>>2]>>3];h[o+8>>3]=+h[d+8>>3]-+h[(c[j>>2]|0)+8>>3];e=c[j>>2]|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];if(!((c[k>>2]|0)!=0?1:(c[(c[j>>2]|0)+52>>2]|0)==0)){e=(c[(c[j>>2]|0)+52>>2]|0)+40|0;h[e>>3]=+h[e>>3]+ +h[o>>3];e=(c[(c[j>>2]|0)+52>>2]|0)+40+8|0;h[e>>3]=+h[e>>3]+ +h[o+8>>3]}if(!(c[(c[j>>2]|0)+48>>2]|0)){i=f;return}if(a[(c[j>>2]|0)+64>>0]|0)h[n>>3]=+h[o>>3]/+(c[(c[j>>2]|0)+48>>2]|0);else h[n>>3]=+h[o+8>>3]/+(c[(c[j>>2]|0)+48>>2]|0);c[l>>2]=0;while(1){if((c[l>>2]|0)>=(c[(c[j>>2]|0)+48>>2]|0))break;c[q>>2]=c[(c[(c[j>>2]|0)+56>>2]|0)+(c[l>>2]<<2)>>2];c[m>>2]=~~(+((c[l>>2]|0)+1|0)*+h[n>>3])-~~(+(c[l>>2]|0)*+h[n>>3]);if(a[(c[j>>2]|0)+64>>0]|0){qM(r,+h[c[q>>2]>>3]+ +(c[m>>2]|0),+h[d+8>>3]);c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2]}else{qM(s,+h[d>>3],+h[(c[q>>2]|0)+8>>3]+ +(c[m>>2]|0));c[p>>2]=c[s>>2];c[p+4>>2]=c[s+4>>2];c[p+8>>2]=c[s+8>>2];c[p+12>>2]=c[s+12>>2]}o=c[q>>2]|0;e=c[k>>2]|0;c[g>>2]=c[p>>2];c[g+4>>2]=c[p+4>>2];c[g+8>>2]=c[p+8>>2];c[g+12>>2]=c[p+12>>2];bN(o,g,e);c[l>>2]=(c[l>>2]|0)+1}i=f;return}function cN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+80|0;g=f+32|0;j=f+64|0;k=f+60|0;l=f+56|0;m=f+52|0;n=f+48|0;o=f+16|0;p=f;c[j>>2]=b;c[k>>2]=e;a[(c[j>>2]|0)+65>>0]=c[k>>2];e=(c[j>>2]|0)+16|0;qM(o,+h[d>>3],+h[d+8>>3]-+h[(c[j>>2]|0)+8>>3]);c[e>>2]=c[o>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2];c[e+12>>2]=c[o+12>>2];o=(c[j>>2]|0)+16+16|0;qM(p,+h[d>>3]+ +h[c[j>>2]>>3],+h[d+8>>3]);c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];c[m>>2]=(c[(c[j>>2]|0)+48>>2]|0)-1;c[l>>2]=0;while(1){if((c[l>>2]|0)>(c[m>>2]|0))break;do if(c[k>>2]|0){p=(c[l>>2]|0)==0;o=(c[l>>2]|0)==(c[m>>2]|0);if(a[(c[j>>2]|0)+64>>0]|0)if(p)if(o){c[n>>2]=15;break}else{c[n>>2]=13;break}else if(o){c[n>>2]=7;break}else{c[n>>2]=5;break}else if(p)if(o){c[n>>2]=15;break}else{c[n>>2]=14;break}else if(o){c[n>>2]=11;break}else{c[n>>2]=10;break}}else c[n>>2]=0;while(0);o=c[(c[(c[j>>2]|0)+56>>2]|0)+(c[l>>2]<<2)>>2]|0;p=c[k>>2]&c[n>>2];c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];cN(o,g,p);if(a[(c[j>>2]|0)+64>>0]|0)h[d>>3]=+h[d>>3]+ +h[c[(c[(c[j>>2]|0)+56>>2]|0)+(c[l>>2]<<2)>>2]>>3];else h[d+8>>3]=+h[d+8>>3]-+h[(c[(c[(c[j>>2]|0)+56>>2]|0)+(c[l>>2]<<2)>>2]|0)+8>>3];c[l>>2]=(c[l>>2]|0)+1}i=f;return}function dN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+4|0;f=d;c[e>>2]=a;c[f>>2]=b;XM(c[e>>2]|0);if(!(c[f>>2]|0)){i=d;return 0}O4(c[f>>2]|0);i=d;return 0}function eN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+32|0;d=b+16|0;e=b+8|0;f=b;c[d>>2]=a;h[e>>3]=+fO(c[d>>2]|0,c[13815]|0,0.0,.01);h[f>>3]=+fO(c[d>>2]|0,c[13814]|0,0.0,.02);g=(+h[e>>3]>+h[f>>3]?+h[e>>3]:+h[f>>3])*72.0;i=b;return +(+(~~((+h[e>>3]>+h[f>>3]?+h[e>>3]:+h[f>>3])*72.0>=0.0?g+.5:g-.5)|0))}function fN(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d+8|0;f=d;g=d+16|0;h[e>>3]=a;h[f>>3]=b;c[g>>2]=~~(+h[e>>3]/+h[f>>3]);if(+(c[g>>2]|0)*+h[f>>3]+1.0e-05<+h[e>>3])c[g>>2]=(c[g>>2]|0)+1;i=d;return +(+(c[g>>2]|0)*+h[f>>3])}function gN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0;g=i;i=i+256|0;j=g+200|0;k=g+244|0;l=g+240|0;m=g+236|0;n=g+249|0;o=g+136|0;p=g+72|0;q=g+56|0;r=g+40|0;s=g+232|0;t=g+228|0;u=g+32|0;v=g+24|0;w=g+16|0;x=g+224|0;y=g+220|0;z=g+248|0;A=g+216|0;B=g;c[k>>2]=b;c[l>>2]=d;c[m>>2]=e;a[n>>0]=f;if(a[n>>0]|0){c[s>>2]=0;c[t>>2]=o;n=c[m>>2]|0;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[x>>2]=u;c[y>>2]=v}else{c[s>>2]=o;c[t>>2]=0;n=(c[m>>2]|0)+48|0;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[x>>2]=v;c[y>>2]=u}a[z>>0]=0;h[u>>3]=0.0;h[v>>3]=1.0;while(1){c[r>>2]=c[q>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];h[w>>3]=(+h[v>>3]+ +h[u>>3])/2.0;qO(B,c[m>>2]|0,3,+h[w>>3],c[s>>2]|0,c[t>>2]|0);c[q>>2]=c[B>>2];c[q+4>>2]=c[B+4>>2];c[q+8>>2]=c[B+8>>2];c[q+12>>2]=c[B+12>>2];n=c[l>>2]|0;f=c[k>>2]|0;c[j>>2]=c[q>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];if((Ob[n&127](f,j)|0)<<24>>24)h[c[x>>2]>>3]=+h[w>>3];else{c[A>>2]=0;while(1){if((c[A>>2]|0)>=4)break;f=p+(c[A>>2]<<4)|0;n=o+(c[A>>2]<<4)|0;c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];c[A>>2]=(c[A>>2]|0)+1}a[z>>0]=1;h[c[y>>2]>>3]=+h[w>>3]}C=+h[r>>3]-+h[q>>3];if((+h[r>>3]-+h[q>>3]>=0.0?C:-C)>.5)continue;C=+h[r+8>>3]-+h[q+8>>3];if(!((+h[r+8>>3]-+h[q+8>>3]>=0.0?C:-C)>.5))break}q=(a[z>>0]|0)!=0;c[A>>2]=0;if(q){while(1){if((c[A>>2]|0)>=4)break;q=(c[m>>2]|0)+(c[A>>2]<<4)|0;z=p+(c[A>>2]<<4)|0;c[q>>2]=c[z>>2];c[q+4>>2]=c[z+4>>2];c[q+8>>2]=c[z+8>>2];c[q+12>>2]=c[z+12>>2];c[A>>2]=(c[A>>2]|0)+1}i=g;return}else{while(1){if((c[A>>2]|0)>=4)break;p=(c[m>>2]|0)+(c[A>>2]<<4)|0;z=o+(c[A>>2]<<4)|0;c[p>>2]=c[z>>2];c[p+4>>2]=c[z+4>>2];c[p+8>>2]=c[z+8>>2];c[p+12>>2]=c[z+12>>2];c[A>>2]=(c[A>>2]|0)+1}i=g;return}}function hN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+64|0;f=e+24|0;g=e+52|0;j=e+48|0;k=e+16|0;l=e+56|0;m=e;n=e+40|0;c[g>>2]=b;c[j>>2]=d;if(!(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)){i=e;return}if(!(c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0)){i=e;return}c[n>>2]=c[g>>2];c[n+4>>2]=0;h[k>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+96>>3];h[m>>3]=+h[c[j>>2]>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+16>>3];h[m+8>>3]=+h[(c[j>>2]|0)+8>>3]-+h[(c[(c[g>>2]|0)+8>>2]|0)+16+8>>3];d=c[(c[(c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0;c[f>>2]=c[m>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];a[l>>0]=Ob[d&127](n,f)|0;h[(c[(c[g>>2]|0)+8>>2]|0)+96>>3]=+h[k>>3];uN(n,c[g>>2]|0,c[j>>2]|0,a[l>>0]|0);i=e;return}function iN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0;e=i;i=i+16|0;f=e+8|0;g=e+4|0;j=e;c[f>>2]=b;c[g>>2]=d;while(1){k=c[(c[f>>2]|0)+8>>2]|0;if(!(a[(c[(c[f>>2]|0)+8>>2]|0)+112>>0]|0))break;c[f>>2]=c[k+116>>2]}if(!(c[k+8>>2]|0)){k=bK(40)|0;c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]=k}k=c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0;if(c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2]|0)l=eK(c[k>>2]|0,((c[(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+1|0)*48|0)|0;else l=cK(((c[k+4>>2]|0)+1|0)*48|0)|0;c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2]=l;l=(c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]|0)+4|0;k=c[l>>2]|0;c[l>>2]=k+1;c[j>>2]=(c[c[(c[(c[f>>2]|0)+8>>2]|0)+8>>2]>>2]|0)+(k*48|0);k=bK(c[g>>2]<<4)|0;c[c[j>>2]>>2]=k;c[(c[j>>2]|0)+4>>2]=c[g>>2];c[(c[j>>2]|0)+12>>2]=0;c[(c[j>>2]|0)+8>>2]=0;h[(c[j>>2]|0)+32+8>>3]=0.0;h[(c[j>>2]|0)+32>>3]=0.0;h[(c[j>>2]|0)+16+8>>3]=0.0;h[(c[j>>2]|0)+16>>3]=0.0;i=e;return c[j>>2]|0}function jN(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;k=i;i=i+176|0;l=k+80|0;m=k+172|0;n=k+168|0;o=k+164|0;p=k+160|0;q=k+156|0;r=k+64|0;s=k+152|0;t=k+148|0;u=k+144|0;v=k+140|0;w=k+136|0;x=k+132|0;y=k+128|0;z=k+124|0;A=k+120|0;B=k+116|0;C=k+112|0;D=k+104|0;E=k+96|0;F=k;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=j;j=c[m>>2]|0;c[t>>2]=c[((c[c[m>>2]>>2]&3|0)==3?j:j+32|0)+28>>2];c[z>>2]=qC(c[t>>2]|0)|0;c[s>>2]=iN(c[m>>2]|0,c[p>>2]|0)|0;c[A>>2]=c[m>>2];while(1){if(!(a[(c[(c[A>>2]|0)+8>>2]|0)+112>>0]|0))break;c[A>>2]=c[(c[(c[A>>2]|0)+8>>2]|0)+116>>2]}if(((a[(c[q>>2]|0)+8>>0]|0)==0?(c[(c[(c[t>>2]|0)+8>>2]|0)+232>>2]|0)==(c[(c[(c[n>>2]|0)+8>>2]|0)+232>>2]|0):0)?(c[(c[(c[t>>2]|0)+8>>2]|0)+236>>2]|0)>(c[(c[(c[n>>2]|0)+8>>2]|0)+236>>2]|0):0){c[E>>2]=c[n>>2];c[n>>2]=c[t>>2];c[t>>2]=c[E>>2]}E=c[A>>2]|0;j=c[(c[A>>2]|0)+8>>2]|0;if((c[t>>2]|0)==(c[((c[c[A>>2]>>2]&3|0)==3?E:E+32|0)+28>>2]|0)){c[x>>2]=d[j+16+30>>0];c[y>>2]=d[(c[(c[A>>2]|0)+8>>2]|0)+56+30>>0];c[B>>2]=c[(c[(c[A>>2]|0)+8>>2]|0)+16+24>>2];c[C>>2]=c[(c[(c[A>>2]|0)+8>>2]|0)+56+24>>2]}else{c[x>>2]=d[j+56+30>>0];c[y>>2]=d[(c[(c[A>>2]|0)+8>>2]|0)+16+30>>0];c[C>>2]=c[(c[(c[A>>2]|0)+8>>2]|0)+16+24>>2];c[B>>2]=c[(c[(c[A>>2]|0)+8>>2]|0)+56+24>>2]}if(((c[x>>2]|0)!=0?(c[(c[(c[t>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[(c[(c[t>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0)!=0:0){c[D>>2]=c[t>>2];c[D+4>>2]=c[B>>2];c[u>>2]=0;while(1){if((c[u>>2]|0)>=((c[p>>2]|0)-4|0))break;h[r>>3]=+h[(c[o>>2]|0)+((c[u>>2]|0)+3<<4)>>3]-+h[(c[(c[t>>2]|0)+8>>2]|0)+16>>3];h[r+8>>3]=+h[(c[o>>2]|0)+((c[u>>2]|0)+3<<4)+8>>3]-+h[(c[(c[t>>2]|0)+8>>2]|0)+16+8>>3];B=c[(c[(c[(c[(c[t>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0;c[l>>2]=c[r>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[l+12>>2]=c[r+12>>2];if(!((Ob[B&127](D,l)|0)&255))break;c[u>>2]=(c[u>>2]|0)+3}uN(D,c[t>>2]|0,(c[o>>2]|0)+(c[u>>2]<<4)|0,1)}else c[u>>2]=0;if(((c[y>>2]|0)!=0?(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)!=0:0)?(c[(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0)!=0:0){c[D>>2]=c[n>>2];c[D+4>>2]=c[C>>2];c[v>>2]=(c[p>>2]|0)-4;while(1){if((c[v>>2]|0)<=0)break;h[r>>3]=+h[(c[o>>2]|0)+(c[v>>2]<<4)>>3]-+h[(c[(c[n>>2]|0)+8>>2]|0)+16>>3];h[r+8>>3]=+h[(c[o>>2]|0)+(c[v>>2]<<4)+8>>3]-+h[(c[(c[n>>2]|0)+8>>2]|0)+16+8>>3];C=c[(c[(c[(c[(c[n>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0;c[l>>2]=c[r>>2];c[l+4>>2]=c[r+4>>2];c[l+8>>2]=c[r+8>>2];c[l+12>>2]=c[r+12>>2];if(!((Ob[C&127](D,l)|0)&255))break;c[v>>2]=(c[v>>2]|0)-3}uN(D,c[n>>2]|0,(c[o>>2]|0)+(c[v>>2]<<4)|0,0)}else c[v>>2]=(c[p>>2]|0)-4;while(1){if((c[u>>2]|0)>=((c[p>>2]|0)-4|0))break;if(!((+h[(c[o>>2]|0)+(c[u>>2]<<4)>>3]-+h[(c[o>>2]|0)+((c[u>>2]|0)+3<<4)>>3])*(+h[(c[o>>2]|0)+(c[u>>2]<<4)>>3]-+h[(c[o>>2]|0)+((c[u>>2]|0)+3<<4)>>3])+(+h[(c[o>>2]|0)+(c[u>>2]<<4)+8>>3]-+h[(c[o>>2]|0)+((c[u>>2]|0)+3<<4)+8>>3])*(+h[(c[o>>2]|0)+(c[u>>2]<<4)+8>>3]-+h[(c[o>>2]|0)+((c[u>>2]|0)+3<<4)+8>>3])<1.0e-06))break;c[u>>2]=(c[u>>2]|0)+3}while(1){if((c[v>>2]|0)<=0)break;if(!((+h[(c[o>>2]|0)+(c[v>>2]<<4)>>3]-+h[(c[o>>2]|0)+((c[v>>2]|0)+3<<4)>>3])*(+h[(c[o>>2]|0)+(c[v>>2]<<4)>>3]-+h[(c[o>>2]|0)+((c[v>>2]|0)+3<<4)>>3])+(+h[(c[o>>2]|0)+(c[v>>2]<<4)+8>>3]-+h[(c[o>>2]|0)+((c[v>>2]|0)+3<<4)+8>>3])*(+h[(c[o>>2]|0)+(c[v>>2]<<4)+8>>3]-+h[(c[o>>2]|0)+((c[v>>2]|0)+3<<4)+8>>3])<1.0e-06))break;c[v>>2]=(c[v>>2]|0)-3}vN(c[m>>2]|0,c[n>>2]|0,c[o>>2]|0,u,v,c[s>>2]|0,c[q>>2]|0);c[w>>2]=c[u>>2];while(1){if((c[w>>2]|0)>=((c[v>>2]|0)+4|0)){G=39;break}q=(c[c[s>>2]>>2]|0)+((c[w>>2]|0)-(c[u>>2]|0)<<4)|0;n=(c[o>>2]|0)+(c[w>>2]<<4)|0;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];n=(c[o>>2]|0)+(c[w>>2]<<4)|0;c[F>>2]=c[n>>2];c[F+4>>2]=c[n+4>>2];c[F+8>>2]=c[n+8>>2];c[F+12>>2]=c[n+12>>2];c[w>>2]=(c[w>>2]|0)+1;if((c[w>>2]|0)>=((c[v>>2]|0)+4|0)){G=39;break}n=(c[c[s>>2]>>2]|0)+((c[w>>2]|0)-(c[u>>2]|0)<<4)|0;q=(c[o>>2]|0)+(c[w>>2]<<4)|0;c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];q=F+16|0;n=(c[o>>2]|0)+(c[w>>2]<<4)|0;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[w>>2]=(c[w>>2]|0)+1;n=(c[c[s>>2]>>2]|0)+((c[w>>2]|0)-(c[u>>2]|0)<<4)|0;q=(c[o>>2]|0)+(c[w>>2]<<4)|0;c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];q=F+32|0;n=(c[o>>2]|0)+(c[w>>2]<<4)|0;c[q>>2]=c[n>>2];c[q+4>>2]=c[n+4>>2];c[q+8>>2]=c[n+8>>2];c[q+12>>2]=c[n+12>>2];c[w>>2]=(c[w>>2]|0)+1;n=F+48|0;q=(c[o>>2]|0)+(c[w>>2]<<4)|0;c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];DH((c[(c[z>>2]|0)+8>>2]|0)+16|0,F)}if((G|0)==39){c[(c[s>>2]|0)+4>>2]=(c[v>>2]|0)-(c[u>>2]|0)+4;i=k;return}}function kN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=a;if(!(+h[b>>3]<+h[b+16>>3])){i=d;return}if(!(+h[b+8>>3]<+h[b+16+8>>3])){i=d;return}a=(c[e>>2]|0)+80|0;f=c[a>>2]|0;c[a>>2]=f+1;a=(c[(c[e>>2]|0)+84>>2]|0)+(f<<5)|0;c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];i=d;return}function lN(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0;k=i;i=i+272|0;l=k+200|0;m=k+184|0;n=k+252|0;o=k+248|0;p=k+244|0;q=k+240|0;r=k+256|0;s=k+236|0;t=k+232|0;u=k+228|0;v=k+224|0;w=k+144|0;x=k+128|0;y=k+220|0;z=k+96|0;A=k+64|0;B=k+32|0;C=k;D=k+216|0;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;a[r>>0]=j;j=c[o>>2]|0;c[u>>2]=c[((c[c[o>>2]>>2]&3|0)==3?j:j+32|0)+28>>2];if(a[(c[(c[o>>2]|0)+8>>2]|0)+16+31>>0]|0){j=(c[(c[o>>2]|0)+8>>2]|0)+16|0;g=c[o>>2]|0;f=c[o>>2]|0;hM(w,c[((c[c[o>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0,c[((c[c[o>>2]>>2]&3|0)==2?f:f+-32|0)+28>>2]|0,(c[(c[o>>2]|0)+8>>2]|0)+16|0);f=j;j=w;w=f+40|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(w|0))}if(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0)c[v>>2]=c[(c[(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+16>>2];else c[v>>2]=0;j=c[n>>2]|0;f=(c[(c[u>>2]|0)+8>>2]|0)+16|0;w=(c[(c[o>>2]|0)+8>>2]|0)+16|0;c[m>>2]=c[f>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];c[l>>2]=c[w>>2];c[l+4>>2]=c[w+4>>2];c[l+8>>2]=c[w+8>>2];c[l+12>>2]=c[w+12>>2];wN(x,m,l);c[j>>2]=c[x>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];x=c[o>>2]|0;do if(!(a[r>>0]|0))if(a[(c[x+8>>2]|0)+16+29>>0]|0){h[(c[n>>2]|0)+16>>3]=+h[(c[(c[o>>2]|0)+8>>2]|0)+16+16>>3];a[(c[n>>2]|0)+29>>0]=1;break}else{a[(c[n>>2]|0)+29>>0]=0;break}else{j=c[o>>2]|0;E=+xN(c[((c[x>>2]&3|0)==3?j:j+32|0)+28>>2]|0);h[(c[n>>2]|0)+16>>3]=E;a[(c[n>>2]|0)+29>>0]=1}while(0);c[(c[n>>2]|0)+80>>2]=0;c[(c[n>>2]|0)+88>>2]=c[o>>2];x=(c[q>>2]|0)+32|0;r=c[n>>2]|0;c[x>>2]=c[r>>2];c[x+4>>2]=c[r+4>>2];c[x+8>>2]=c[r+8>>2];c[x+12>>2]=c[r+12>>2];if(((c[p>>2]|0)==1?(a[(c[(c[u>>2]|0)+8>>2]|0)+156>>0]|0)==0:0)?(r=d[(c[(c[o>>2]|0)+8>>2]|0)+16+33>>0]|0,c[s>>2]=r,(r|0)!=0):0){r=c[q>>2]|0;c[A>>2]=c[r>>2];c[A+4>>2]=c[r+4>>2];c[A+8>>2]=c[r+8>>2];c[A+12>>2]=c[r+12>>2];c[A+16>>2]=c[r+16>>2];c[A+20>>2]=c[r+20>>2];c[A+24>>2]=c[r+24>>2];c[A+28>>2]=c[r+28>>2];do if(c[s>>2]&4){c[(c[q>>2]|0)+48>>2]=4;E=+h[A>>3];if(+h[c[n>>2]>>3]<+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]){h[z>>3]=E-1.0;h[z+8>>3]=+h[(c[n>>2]|0)+8>>3];h[z+16>>3]=+h[A+16>>3];F=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[z+16+8>>3]=F+ +((c[(c[(qC(c[u>>2]|0)|0)+8>>2]|0)+252>>2]|0)/2|0|0);h[A+16>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+88>>3]-0.0;h[A+16+8>>3]=+h[z+8>>3];h[A+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[A>>3]=+h[A>>3]-1.0;r=(c[q>>2]|0)+56|0;c[r>>2]=c[z>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];c[r+12>>2]=c[z+12>>2];c[r+16>>2]=c[z+16>>2];c[r+20>>2]=c[z+20>>2];c[r+24>>2]=c[z+24>>2];c[r+28>>2]=c[z+28>>2];r=(c[q>>2]|0)+56+32|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[r+16>>2]=c[A+16>>2];c[r+20>>2]=c[A+20>>2];c[r+24>>2]=c[A+24>>2];c[r+28>>2]=c[A+28>>2]}else{h[z>>3]=E;h[z+8>>3]=+h[(c[n>>2]|0)+8>>3];h[z+16>>3]=+h[A+16>>3]+1.0;E=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[z+16+8>>3]=E+ +((c[(c[(qC(c[u>>2]|0)|0)+8>>2]|0)+252>>2]|0)/2|0|0);h[A>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+96>>3]+0.0;h[A+16+8>>3]=+h[z+8>>3];h[A+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;r=A+16|0;h[r>>3]=+h[r>>3]+1.0;r=(c[q>>2]|0)+56|0;c[r>>2]=c[z>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];c[r+12>>2]=c[z+12>>2];c[r+16>>2]=c[z+16>>2];c[r+20>>2]=c[z+20>>2];c[r+24>>2]=c[z+24>>2];c[r+28>>2]=c[z+28>>2];r=(c[q>>2]|0)+56+32|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[r+16>>2]=c[A+16>>2];c[r+20>>2]=c[A+20>>2];c[r+24>>2]=c[A+24>>2];c[r+28>>2]=c[A+28>>2]}r=(c[n>>2]|0)+8|0;h[r>>3]=+h[r>>3]+1.0;c[(c[q>>2]|0)+52>>2]=2}else{if(!(c[s>>2]&1)){r=(c[q>>2]|0)+48|0;if(c[s>>2]&8){c[r>>2]=8;h[A+16>>3]=+h[c[n>>2]>>3];h[A+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[A+16+8>>3]=+h[(c[n>>2]|0)+8>>3];x=(c[q>>2]|0)+56|0;c[x>>2]=c[A>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];c[x+24>>2]=c[A+24>>2];c[x+28>>2]=c[A+28>>2];c[(c[q>>2]|0)+52>>2]=1;x=c[n>>2]|0;h[x>>3]=+h[x>>3]-1.0;break}else{c[r>>2]=2;h[A>>3]=+h[c[n>>2]>>3];h[A+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[A+16+8>>3]=+h[(c[n>>2]|0)+8>>3];r=(c[q>>2]|0)+56|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[r+16>>2]=c[A+16>>2];c[r+20>>2]=c[A+20>>2];c[r+24>>2]=c[A+24>>2];c[r+28>>2]=c[A+28>>2];c[(c[q>>2]|0)+52>>2]=1;r=c[n>>2]|0;h[r>>3]=+h[r>>3]+1.0;break}}c[(c[q>>2]|0)+48>>2]=1;if(+h[A+16+8>>3]>+h[(c[n>>2]|0)+8>>3])G=+h[A+16+8>>3];else G=+h[(c[n>>2]|0)+8>>3];h[A+16+8>>3]=G;r=(c[q>>2]|0)+56|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[r+16>>2]=c[A+16>>2];c[r+20>>2]=c[A+20>>2];c[r+24>>2]=c[A+24>>2];c[r+28>>2]=c[A+28>>2];c[(c[q>>2]|0)+52>>2]=1;r=(c[n>>2]|0)+8|0;h[r>>3]=+h[r>>3]-1.0}while(0);c[y>>2]=c[o>>2];while(1){if(!(a[(c[(c[y>>2]|0)+8>>2]|0)+112>>0]|0))break;c[y>>2]=c[(c[(c[y>>2]|0)+8>>2]|0)+116>>2]}A=c[y>>2]|0;z=c[(c[y>>2]|0)+8>>2]|0;if((c[u>>2]|0)==(c[((c[c[y>>2]>>2]&3|0)==3?A:A+32|0)+28>>2]|0)){a[z+16+30>>0]=0;i=k;return}else{a[z+56+30>>0]=0;i=k;return}}if((c[p>>2]|0)==2?(z=d[(c[(c[o>>2]|0)+8>>2]|0)+16+33>>0]|0,c[s>>2]=z,(z|0)!=0):0){z=c[q>>2]|0;c[C>>2]=c[z>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];c[C+16>>2]=c[z+16>>2];c[C+20>>2]=c[z+20>>2];c[C+24>>2]=c[z+24>>2];c[C+28>>2]=c[z+28>>2];do if(!(c[s>>2]&4)){if(c[s>>2]&1){if((c[(c[q>>2]|0)+48>>2]|0)==4){h[B+16+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[B+16>>3]=+h[C+16>>3]+1.0;h[B>>3]=+h[c[n>>2]>>3];G=+h[B+16+8>>3];h[B+8>>3]=G-+((c[(c[(qC(c[u>>2]|0)|0)+8>>2]|0)+252>>2]|0)/2|0|0);h[C>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+96>>3]+0.0;h[C+8>>3]=+h[B+16+8>>3];h[C+16+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;z=C+16|0;h[z>>3]=+h[z>>3]+1.0;z=(c[q>>2]|0)+56|0;c[z>>2]=c[B>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];c[z+12>>2]=c[B+12>>2];c[z+16>>2]=c[B+16>>2];c[z+20>>2]=c[B+20>>2];c[z+24>>2]=c[B+24>>2];c[z+28>>2]=c[B+28>>2];z=(c[q>>2]|0)+56+32|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=2}else{if(+h[C+16+8>>3]>+h[(c[n>>2]|0)+8>>3])H=+h[C+16+8>>3];else H=+h[(c[n>>2]|0)+8>>3];h[C+16+8>>3]=H;z=(c[q>>2]|0)+56|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=1}z=(c[n>>2]|0)+8|0;h[z>>3]=+h[z>>3]-1.0;break}G=+h[c[n>>2]>>3];if(c[s>>2]&8){h[C+16>>3]=G+1.0;E=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3];F=+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;if((c[(c[q>>2]|0)+48>>2]|0)==4){h[C+16+8>>3]=E+F;h[C+8>>3]=+h[(c[n>>2]|0)+8>>3]-1.0}else{h[C+8>>3]=E-F;h[C+16+8>>3]=+h[(c[n>>2]|0)+8>>3]+1.0}z=(c[q>>2]|0)+56|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=1;z=c[n>>2]|0;h[z>>3]=+h[z>>3]-1.0;break}else{h[C>>3]=G;G=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3];F=+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;if((c[(c[q>>2]|0)+48>>2]|0)==4){h[C+16+8>>3]=G+F;h[C+8>>3]=+h[(c[n>>2]|0)+8>>3]}else{h[C+8>>3]=G-F;h[C+16+8>>3]=+h[(c[n>>2]|0)+8>>3]+1.0}z=(c[q>>2]|0)+56|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=1;z=c[n>>2]|0;h[z>>3]=+h[z>>3]+1.0;break}}else{if(+h[C+8>>3]<+h[(c[n>>2]|0)+8>>3])I=+h[C+8>>3];else I=+h[(c[n>>2]|0)+8>>3];h[C+8>>3]=I;z=(c[q>>2]|0)+56|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=1;z=(c[n>>2]|0)+8|0;h[z>>3]=+h[z>>3]+1.0}while(0);c[D>>2]=c[o>>2];while(1){if(!(a[(c[(c[D>>2]|0)+8>>2]|0)+112>>0]|0))break;c[D>>2]=c[(c[(c[D>>2]|0)+8>>2]|0)+116>>2]}C=c[D>>2]|0;B=c[(c[D>>2]|0)+8>>2]|0;if((c[u>>2]|0)==(c[((c[c[D>>2]>>2]&3|0)==3?C:C+32|0)+28>>2]|0))a[B+16+30>>0]=0;else a[B+56+30>>0]=0;c[(c[q>>2]|0)+48>>2]=c[s>>2];i=k;return}if((c[p>>2]|0)==1)c[s>>2]=1;else c[s>>2]=c[(c[q>>2]|0)+48>>2];if((c[v>>2]|0)!=0?(B=Gb[c[v>>2]&63](c[u>>2]|0,(c[(c[o>>2]|0)+8>>2]|0)+16|0,c[s>>2]|0,(c[q>>2]|0)+56|0,(c[q>>2]|0)+52|0)|0,c[t>>2]=B,(B|0)!=0):0){c[(c[q>>2]|0)+48>>2]=c[t>>2];i=k;return}t=(c[q>>2]|0)+56|0;B=c[q>>2]|0;c[t>>2]=c[B>>2];c[t+4>>2]=c[B+4>>2];c[t+8>>2]=c[B+8>>2];c[t+12>>2]=c[B+12>>2];c[t+16>>2]=c[B+16>>2];c[t+20>>2]=c[B+20>>2];c[t+24>>2]=c[B+24>>2];c[t+28>>2]=c[B+28>>2];c[(c[q>>2]|0)+52>>2]=1;switch(c[p>>2]|0){case 8:{La(176099,144130,569,144140);break}case 2:{I=+h[(c[n>>2]|0)+8>>3];p=(c[q>>2]|0)+56|0;if((c[(c[q>>2]|0)+48>>2]|0)==4){h[p+8>>3]=I;i=k;return}else{h[p+16+8>>3]=I;i=k;return}break}case 1:{h[(c[q>>2]|0)+56+16+8>>3]=+h[(c[n>>2]|0)+8>>3];c[(c[q>>2]|0)+48>>2]=1;q=(c[n>>2]|0)+8|0;h[q>>3]=+h[q>>3]-1.0;i=k;return}default:{i=k;return}}}function mN(b,e,f,g,j){b=b|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0;k=i;i=i+272|0;l=k+200|0;m=k+184|0;n=k+252|0;o=k+248|0;p=k+244|0;q=k+240|0;r=k+256|0;s=k+236|0;t=k+232|0;u=k+228|0;v=k+224|0;w=k+144|0;x=k+128|0;y=k+220|0;z=k+96|0;A=k+64|0;B=k+32|0;C=k;D=k+216|0;c[n>>2]=b;c[o>>2]=e;c[p>>2]=f;c[q>>2]=g;a[r>>0]=j;j=c[o>>2]|0;c[u>>2]=c[((c[c[o>>2]>>2]&3|0)==2?j:j+-32|0)+28>>2];if(a[(c[(c[o>>2]|0)+8>>2]|0)+56+31>>0]|0){j=(c[(c[o>>2]|0)+8>>2]|0)+56|0;g=c[o>>2]|0;f=c[o>>2]|0;hM(w,c[((c[c[o>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0,c[((c[c[o>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0,(c[(c[o>>2]|0)+8>>2]|0)+56|0);f=j;j=w;w=f+40|0;do{c[f>>2]=c[j>>2];f=f+4|0;j=j+4|0}while((f|0)<(w|0))}if(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0)c[v>>2]=c[(c[(c[(c[(c[u>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+16>>2];else c[v>>2]=0;j=(c[n>>2]|0)+40|0;f=(c[(c[u>>2]|0)+8>>2]|0)+16|0;w=(c[(c[o>>2]|0)+8>>2]|0)+56|0;c[m>>2]=c[f>>2];c[m+4>>2]=c[f+4>>2];c[m+8>>2]=c[f+8>>2];c[m+12>>2]=c[f+12>>2];c[l>>2]=c[w>>2];c[l+4>>2]=c[w+4>>2];c[l+8>>2]=c[w+8>>2];c[l+12>>2]=c[w+12>>2];wN(x,m,l);c[j>>2]=c[x>>2];c[j+4>>2]=c[x+4>>2];c[j+8>>2]=c[x+8>>2];c[j+12>>2]=c[x+12>>2];x=c[o>>2]|0;do if(a[r>>0]|0){j=c[o>>2]|0;E=+xN(c[((c[x>>2]&3|0)==2?j:j+-32|0)+28>>2]|0)+3.141592653589793;h[(c[n>>2]|0)+40+16>>3]=E;if(+h[(c[n>>2]|0)+40+16>>3]<6.283185307179586){a[(c[n>>2]|0)+40+29>>0]=1;break}else La(144150,144130,606,144174)}else if(a[(c[x+8>>2]|0)+56+29>>0]|0){h[(c[n>>2]|0)+40+16>>3]=+h[(c[(c[o>>2]|0)+8>>2]|0)+56+16>>3];a[(c[n>>2]|0)+40+29>>0]=1;break}else{a[(c[n>>2]|0)+40+29>>0]=0;break}while(0);x=(c[q>>2]|0)+32|0;r=(c[n>>2]|0)+40|0;c[x>>2]=c[r>>2];c[x+4>>2]=c[r+4>>2];c[x+8>>2]=c[r+8>>2];c[x+12>>2]=c[r+12>>2];if(((c[p>>2]|0)==1?(a[(c[(c[u>>2]|0)+8>>2]|0)+156>>0]|0)==0:0)?(r=d[(c[(c[o>>2]|0)+8>>2]|0)+56+33>>0]|0,c[s>>2]=r,(r|0)!=0):0){r=c[q>>2]|0;c[A>>2]=c[r>>2];c[A+4>>2]=c[r+4>>2];c[A+8>>2]=c[r+8>>2];c[A+12>>2]=c[r+12>>2];c[A+16>>2]=c[r+16>>2];c[A+20>>2]=c[r+20>>2];c[A+24>>2]=c[r+24>>2];c[A+28>>2]=c[r+28>>2];do if(c[s>>2]&4){c[(c[q>>2]|0)+48>>2]=4;if(+h[A+8>>3]<+h[(c[n>>2]|0)+40+8>>3])F=+h[A+8>>3];else F=+h[(c[n>>2]|0)+40+8>>3];h[A+8>>3]=F;r=(c[q>>2]|0)+56|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[r+16>>2]=c[A+16>>2];c[r+20>>2]=c[A+20>>2];c[r+24>>2]=c[A+24>>2];c[r+28>>2]=c[A+28>>2];c[(c[q>>2]|0)+52>>2]=1;r=(c[n>>2]|0)+40+8|0;h[r>>3]=+h[r>>3]+1.0}else{if(!(c[s>>2]&1)){r=(c[q>>2]|0)+48|0;if(c[s>>2]&8){c[r>>2]=8;h[A+16>>3]=+h[(c[n>>2]|0)+40>>3];h[A+16+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[A+8>>3]=+h[(c[n>>2]|0)+40+8>>3];x=(c[q>>2]|0)+56|0;c[x>>2]=c[A>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];c[x+24>>2]=c[A+24>>2];c[x+28>>2]=c[A+28>>2];c[(c[q>>2]|0)+52>>2]=1;x=(c[n>>2]|0)+40|0;h[x>>3]=+h[x>>3]-1.0;break}else{c[r>>2]=2;h[A>>3]=+h[(c[n>>2]|0)+40>>3];h[A+16+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[A+8>>3]=+h[(c[n>>2]|0)+40+8>>3];r=(c[q>>2]|0)+56|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[r+16>>2]=c[A+16>>2];c[r+20>>2]=c[A+20>>2];c[r+24>>2]=c[A+24>>2];c[r+28>>2]=c[A+28>>2];c[(c[q>>2]|0)+52>>2]=1;r=(c[n>>2]|0)+40|0;h[r>>3]=+h[r>>3]+1.0;break}}c[(c[q>>2]|0)+48>>2]=1;E=+h[A>>3];if(+h[(c[n>>2]|0)+40>>3]<+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]){h[z>>3]=E-1.0;h[z+16+8>>3]=+h[(c[n>>2]|0)+40+8>>3];h[z+16>>3]=+h[A+16>>3];G=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[z+8>>3]=G-+((c[(c[(qC(c[u>>2]|0)|0)+8>>2]|0)+252>>2]|0)/2|0|0);h[A+16>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+88>>3]-0.0;h[A+8>>3]=+h[z+16+8>>3];h[A+16+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[A>>3]=+h[A>>3]-1.0;r=(c[q>>2]|0)+56|0;c[r>>2]=c[z>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];c[r+12>>2]=c[z+12>>2];c[r+16>>2]=c[z+16>>2];c[r+20>>2]=c[z+20>>2];c[r+24>>2]=c[z+24>>2];c[r+28>>2]=c[z+28>>2];r=(c[q>>2]|0)+56+32|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[r+16>>2]=c[A+16>>2];c[r+20>>2]=c[A+20>>2];c[r+24>>2]=c[A+24>>2];c[r+28>>2]=c[A+28>>2]}else{h[z>>3]=E;h[z+16+8>>3]=+h[(c[n>>2]|0)+40+8>>3];h[z+16>>3]=+h[A+16>>3]+1.0;E=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[z+8>>3]=E-+((c[(c[(qC(c[u>>2]|0)|0)+8>>2]|0)+252>>2]|0)/2|0|0);h[A>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+96>>3]+0.0;h[A+8>>3]=+h[z+16+8>>3];h[A+16+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;r=A+16|0;h[r>>3]=+h[r>>3]+1.0;r=(c[q>>2]|0)+56|0;c[r>>2]=c[z>>2];c[r+4>>2]=c[z+4>>2];c[r+8>>2]=c[z+8>>2];c[r+12>>2]=c[z+12>>2];c[r+16>>2]=c[z+16>>2];c[r+20>>2]=c[z+20>>2];c[r+24>>2]=c[z+24>>2];c[r+28>>2]=c[z+28>>2];r=(c[q>>2]|0)+56+32|0;c[r>>2]=c[A>>2];c[r+4>>2]=c[A+4>>2];c[r+8>>2]=c[A+8>>2];c[r+12>>2]=c[A+12>>2];c[r+16>>2]=c[A+16>>2];c[r+20>>2]=c[A+20>>2];c[r+24>>2]=c[A+24>>2];c[r+28>>2]=c[A+28>>2]}c[(c[q>>2]|0)+52>>2]=2;r=(c[n>>2]|0)+40+8|0;h[r>>3]=+h[r>>3]-1.0}while(0);c[y>>2]=c[o>>2];while(1){if(!(a[(c[(c[y>>2]|0)+8>>2]|0)+112>>0]|0))break;c[y>>2]=c[(c[(c[y>>2]|0)+8>>2]|0)+116>>2]}A=c[y>>2]|0;z=c[(c[y>>2]|0)+8>>2]|0;if((c[u>>2]|0)==(c[((c[c[y>>2]>>2]&3|0)==2?A:A+-32|0)+28>>2]|0))a[z+56+30>>0]=0;else a[z+16+30>>0]=0;c[(c[q>>2]|0)+48>>2]=c[s>>2];i=k;return}if((c[p>>2]|0)==2?(z=d[(c[(c[o>>2]|0)+8>>2]|0)+56+33>>0]|0,c[s>>2]=z,(z|0)!=0):0){z=c[q>>2]|0;c[C>>2]=c[z>>2];c[C+4>>2]=c[z+4>>2];c[C+8>>2]=c[z+8>>2];c[C+12>>2]=c[z+12>>2];c[C+16>>2]=c[z+16>>2];c[C+20>>2]=c[z+20>>2];c[C+24>>2]=c[z+24>>2];c[C+28>>2]=c[z+28>>2];do if(!(c[s>>2]&4)){if(c[s>>2]&1){if((c[(c[q>>2]|0)+48>>2]|0)==4){h[B>>3]=+h[C>>3]-1.0;h[B+16+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[B+16>>3]=+h[(c[n>>2]|0)+40>>3];F=+h[B+16+8>>3];h[B+8>>3]=F-+((c[(c[(qC(c[u>>2]|0)|0)+8>>2]|0)+252>>2]|0)/2|0|0);h[C+16>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16>>3]-+h[(c[(c[u>>2]|0)+8>>2]|0)+88>>3]-2.0;h[C+8>>3]=+h[B+16+8>>3];h[C+16+8>>3]=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3]+ +h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;h[C>>3]=+h[C>>3]-1.0;z=(c[q>>2]|0)+56|0;c[z>>2]=c[B>>2];c[z+4>>2]=c[B+4>>2];c[z+8>>2]=c[B+8>>2];c[z+12>>2]=c[B+12>>2];c[z+16>>2]=c[B+16>>2];c[z+20>>2]=c[B+20>>2];c[z+24>>2]=c[B+24>>2];c[z+28>>2]=c[B+28>>2];z=(c[q>>2]|0)+56+32|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=2}else{if(+h[C+16+8>>3]>+h[(c[n>>2]|0)+8>>3])H=+h[C+16+8>>3];else H=+h[(c[n>>2]|0)+8>>3];h[C+16+8>>3]=H;z=(c[q>>2]|0)+56|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=1}z=(c[n>>2]|0)+40+8|0;h[z>>3]=+h[z>>3]-1.0;break}F=+h[(c[n>>2]|0)+40>>3];if(c[s>>2]&8){h[C+16>>3]=F+1.0;E=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3];G=+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;if((c[(c[q>>2]|0)+48>>2]|0)==4){h[C+16+8>>3]=E+G;h[C+8>>3]=+h[(c[n>>2]|0)+40+8>>3]-1.0}else{h[C+8>>3]=E-G;h[C+16+8>>3]=+h[(c[n>>2]|0)+40+8>>3]+1.0}z=(c[q>>2]|0)+56|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=1;z=(c[n>>2]|0)+40|0;h[z>>3]=+h[z>>3]-1.0;break}else{h[C>>3]=F-1.0;F=+h[(c[(c[u>>2]|0)+8>>2]|0)+16+8>>3];G=+h[(c[(c[u>>2]|0)+8>>2]|0)+80>>3]/2.0;if((c[(c[q>>2]|0)+48>>2]|0)==4){h[C+16+8>>3]=F+G;h[C+8>>3]=+h[(c[n>>2]|0)+40+8>>3]-1.0}else{h[C+8>>3]=F-G;h[C+16+8>>3]=+h[(c[n>>2]|0)+40+8>>3]}z=(c[q>>2]|0)+56|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=1;z=(c[n>>2]|0)+40|0;h[z>>3]=+h[z>>3]+1.0;break}}else{if(+h[C+8>>3]<+h[(c[n>>2]|0)+40+8>>3])I=+h[C+8>>3];else I=+h[(c[n>>2]|0)+40+8>>3];h[C+8>>3]=I;z=(c[q>>2]|0)+56|0;c[z>>2]=c[C>>2];c[z+4>>2]=c[C+4>>2];c[z+8>>2]=c[C+8>>2];c[z+12>>2]=c[C+12>>2];c[z+16>>2]=c[C+16>>2];c[z+20>>2]=c[C+20>>2];c[z+24>>2]=c[C+24>>2];c[z+28>>2]=c[C+28>>2];c[(c[q>>2]|0)+52>>2]=1;z=(c[n>>2]|0)+40+8|0;h[z>>3]=+h[z>>3]+1.0}while(0);c[D>>2]=c[o>>2];while(1){if(!(a[(c[(c[D>>2]|0)+8>>2]|0)+112>>0]|0))break;c[D>>2]=c[(c[(c[D>>2]|0)+8>>2]|0)+116>>2]}C=c[D>>2]|0;B=c[(c[D>>2]|0)+8>>2]|0;if((c[u>>2]|0)==(c[((c[c[D>>2]>>2]&3|0)==2?C:C+-32|0)+28>>2]|0))a[B+56+30>>0]=0;else a[B+16+30>>0]=0;c[(c[q>>2]|0)+48>>2]=c[s>>2];i=k;return}if((c[p>>2]|0)==1)c[s>>2]=4;else c[s>>2]=c[(c[q>>2]|0)+48>>2];if((c[v>>2]|0)!=0?(B=Gb[c[v>>2]&63](c[u>>2]|0,(c[(c[o>>2]|0)+8>>2]|0)+56|0,c[s>>2]|0,(c[q>>2]|0)+56|0,(c[q>>2]|0)+52|0)|0,c[t>>2]=B,(B|0)!=0):0){c[(c[q>>2]|0)+48>>2]=c[t>>2];i=k;return}t=(c[q>>2]|0)+56|0;B=c[q>>2]|0;c[t>>2]=c[B>>2];c[t+4>>2]=c[B+4>>2];c[t+8>>2]=c[B+8>>2];c[t+12>>2]=c[B+12>>2];c[t+16>>2]=c[B+16>>2];c[t+20>>2]=c[B+20>>2];c[t+24>>2]=c[B+24>>2];c[t+28>>2]=c[B+28>>2];c[(c[q>>2]|0)+52>>2]=1;switch(c[p>>2]|0){case 8:{La(176099,144130,765,144174);break}case 2:{I=+h[(c[n>>2]|0)+40+8>>3];p=(c[q>>2]|0)+56|0;if((c[(c[q>>2]|0)+48>>2]|0)==4){h[p+8>>3]=I;i=k;return}else{h[p+16+8>>3]=I;i=k;return}break}case 1:{h[(c[q>>2]|0)+56+8>>3]=+h[(c[n>>2]|0)+40+8>>3];c[(c[q>>2]|0)+48>>2]=4;q=(c[n>>2]|0)+40+8|0;h[q>>3]=+h[q>>3]+1.0;i=k;return}default:{i=k;return}}}function nN(b){b=b|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0;e=i;i=i+32|0;f=e+16|0;g=e+12|0;j=e;k=e+8|0;c[f>>2]=b;c[k>>2]=c[(c[(c[f>>2]|0)+8>>2]|0)+96>>2];if(!((a[(c[(c[f>>2]|0)+8>>2]|0)+16+28>>0]|0)==0?(a[(c[(c[f>>2]|0)+8>>2]|0)+56+28>>0]|0)==0:0))l=3;do if((l|0)==3){if((d[(c[(c[f>>2]|0)+8>>2]|0)+16+33>>0]&8|0)==0?(d[(c[(c[f>>2]|0)+8>>2]|0)+56+33>>0]&8|0)==0:0){if((d[(c[(c[f>>2]|0)+8>>2]|0)+16+33>>0]|0)!=(d[(c[(c[f>>2]|0)+8>>2]|0)+56+33>>0]|0))break;if(!(d[(c[(c[f>>2]|0)+8>>2]|0)+16+33>>0]&5))break}c[g>>2]=0;m=c[g>>2]|0;i=e;return m|0}while(0);c[g>>2]=18;if(!(c[k>>2]|0)){m=c[g>>2]|0;i=e;return m|0}l=c[f>>2]|0;b=(c[(c[(qC(c[((c[c[f>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;l=(c[k>>2]|0)+24|0;if(b)n=+h[l+8>>3];else n=+h[l>>3];h[j>>3]=n;c[g>>2]=~~(+(c[g>>2]|0)+ +h[j>>3]);m=c[g>>2]|0;i=e;return m|0}function oN(b,e,f,g,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;j=+j;k=+k;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;m=i;i=i+48|0;n=m+32|0;o=m+28|0;p=m+24|0;q=m+8|0;r=m;s=m+20|0;t=m+16|0;c[m+36>>2]=b;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;h[q>>3]=j;h[r>>3]=k;c[s>>2]=l;c[t>>2]=c[(c[n>>2]|0)+(c[o>>2]<<2)>>2];if(!((a[(c[(c[t>>2]|0)+8>>2]|0)+16+28>>0]|0)==0?(a[(c[(c[t>>2]|0)+8>>2]|0)+56+28>>0]|0)==0:0))u=3;do if((u|0)==3){if((d[(c[(c[t>>2]|0)+8>>2]|0)+16+33>>0]&8|0)==0?(d[(c[(c[t>>2]|0)+8>>2]|0)+56+33>>0]&8|0)==0:0){if((d[(c[(c[t>>2]|0)+8>>2]|0)+16+33>>0]|0)!=(d[(c[(c[t>>2]|0)+8>>2]|0)+56+33>>0]|0))break;if(!(d[(c[(c[t>>2]|0)+8>>2]|0)+16+33>>0]&5))break}if((d[(c[(c[t>>2]|0)+8>>2]|0)+16+33>>0]&8|0)==0?(d[(c[(c[t>>2]|0)+8>>2]|0)+56+33>>0]&8|0)==0:0){if(d[(c[(c[t>>2]|0)+8>>2]|0)+16+33>>0]&4){zN(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],c[s>>2]|0);i=m;return}if(!(d[(c[(c[t>>2]|0)+8>>2]|0)+16+33>>0]&1))La(176099,144130,1231,144182);BN(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],c[s>>2]|0);i=m;return}if((d[(c[(c[t>>2]|0)+8>>2]|0)+16+33>>0]&2|0)==0?(d[(c[(c[t>>2]|0)+8>>2]|0)+56+33>>0]&2|0)==0:0){AN(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],c[s>>2]|0);i=m;return}zN(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],c[s>>2]|0);i=m;return}while(0);yN(c[n>>2]|0,c[o>>2]|0,c[p>>2]|0,+h[q>>3],+h[r>>3],c[s>>2]|0);i=m;return}function pN(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d;c[e>>2]=b;if(!((c[13887]|0)!=0|(c[13886]|0)!=0)){i=d;return}if(((c[(c[(c[e>>2]|0)+8>>2]|0)+100>>2]|0)!=0?(a[(c[(c[(c[e>>2]|0)+8>>2]|0)+100>>2]|0)+81>>0]|0)==0:0)?(qN(c[e>>2]|0,1)|0)!=0:0){b=c[e>>2]|0;f=qC(c[((c[c[e>>2]>>2]&3|0)==3?b:b+32|0)+28>>2]|0)|0;AO(f,c[(c[(c[e>>2]|0)+8>>2]|0)+100>>2]|0)}if(!(c[(c[(c[e>>2]|0)+8>>2]|0)+104>>2]|0)){i=d;return}if(a[(c[(c[(c[e>>2]|0)+8>>2]|0)+104>>2]|0)+81>>0]|0){i=d;return}if(!(qN(c[e>>2]|0,0)|0)){i=d;return}f=c[e>>2]|0;b=qC(c[((c[c[e>>2]>>2]&3|0)==3?f:f+32|0)+28>>2]|0)|0;AO(b,c[(c[(c[e>>2]|0)+8>>2]|0)+104>>2]|0);i=d;return}function qN(b,e){b=b|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0;f=i;i=i+192|0;g=f+172|0;j=f+168|0;k=f+176|0;l=f+164|0;m=f+160|0;n=f+156|0;o=f+136|0;p=f+128|0;q=f+64|0;r=f+48|0;s=f+32|0;t=f+152|0;u=f+144|0;v=f+16|0;w=f;c[j>>2]=b;a[k>>0]=e;if((a[(c[(c[j>>2]|0)+8>>2]|0)+112>>0]|0)==6){c[g>>2]=0;x=c[g>>2]|0;i=f;return x|0}if(!((c[13887]|0)!=0?(e=zA(c[j>>2]|0,c[13887]|0)|0,c[f+148>>2]=e,(a[e>>0]|0)!=0):0))y=5;do if((y|0)==5){if((c[13886]|0)!=0?(e=zA(c[j>>2]|0,c[13886]|0)|0,c[u>>2]=e,(a[e>>0]|0)!=0):0)break;c[g>>2]=0;x=c[g>>2]|0;i=f;return x|0}while(0);u=c[(c[j>>2]|0)+8>>2]|0;if(d[k>>0]|0)z=c[u+100>>2]|0;else z=c[u+104>>2]|0;c[l>>2]=z;z=tN(c[j>>2]|0)|0;c[m>>2]=z;if(!z){c[g>>2]=0;x=c[g>>2]|0;i=f;return x|0}z=c[m>>2]|0;do if(a[k>>0]|0){c[n>>2]=(c[c[m>>2]>>2]|0)+(((c[z+4>>2]|0)-1|0)*48|0);u=c[n>>2]|0;if(c[(c[n>>2]|0)+12>>2]|0){y=u+32|0;c[r>>2]=c[y>>2];c[r+4>>2]=c[y+4>>2];c[r+8>>2]=c[y+8>>2];c[r+12>>2]=c[y+12>>2];y=(c[c[n>>2]>>2]|0)+((c[(c[n>>2]|0)+4>>2]|0)-1<<4)|0;c[s>>2]=c[y>>2];c[s+4>>2]=c[y+4>>2];c[s+8>>2]=c[y+8>>2];c[s+12>>2]=c[y+12>>2];break}y=(c[c[n>>2]>>2]|0)+((c[u+4>>2]|0)-1<<4)|0;c[r>>2]=c[y>>2];c[r+4>>2]=c[y+4>>2];c[r+8>>2]=c[y+8>>2];c[r+12>>2]=c[y+12>>2];c[t>>2]=0;while(1){if((c[t>>2]|0)>=4)break;y=q+(c[t>>2]<<4)|0;u=(c[c[n>>2]>>2]|0)+((c[(c[n>>2]|0)+4>>2]|0)-4+(c[t>>2]|0)<<4)|0;c[y>>2]=c[u>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];c[y+12>>2]=c[u+12>>2];c[t>>2]=(c[t>>2]|0)+1}qO(w,q,3,.9,0,0);c[s>>2]=c[w>>2];c[s+4>>2]=c[w+4>>2];c[s+8>>2]=c[w+8>>2];c[s+12>>2]=c[w+12>>2]}else{c[n>>2]=c[z>>2];u=c[n>>2]|0;if(c[(c[n>>2]|0)+8>>2]|0){y=u+16|0;c[r>>2]=c[y>>2];c[r+4>>2]=c[y+4>>2];c[r+8>>2]=c[y+8>>2];c[r+12>>2]=c[y+12>>2];y=c[c[n>>2]>>2]|0;c[s>>2]=c[y>>2];c[s+4>>2]=c[y+4>>2];c[s+8>>2]=c[y+8>>2];c[s+12>>2]=c[y+12>>2];break}y=c[u>>2]|0;c[r>>2]=c[y>>2];c[r+4>>2]=c[y+4>>2];c[r+8>>2]=c[y+8>>2];c[r+12>>2]=c[y+12>>2];c[t>>2]=0;while(1){if((c[t>>2]|0)>=4)break;y=q+(c[t>>2]<<4)|0;u=(c[c[n>>2]>>2]|0)+(c[t>>2]<<4)|0;c[y>>2]=c[u>>2];c[y+4>>2]=c[u+4>>2];c[y+8>>2]=c[u+8>>2];c[y+12>>2]=c[u+12>>2];c[t>>2]=(c[t>>2]|0)+1}qO(v,q,3,.1,0,0);c[s>>2]=c[v>>2];c[s+4>>2]=c[v+4>>2];c[s+8>>2]=c[v+8>>2];c[s+12>>2]=c[v+12>>2]}while(0);A=+W(+(+h[s+8>>3]-+h[r+8>>3]),+(+h[s>>3]-+h[r>>3]));h[p>>3]=A+ +fO(c[j>>2]|0,c[13887]|0,-25.0,-180.0)/180.0*3.141592653589793;h[o>>3]=+fO(c[j>>2]|0,c[13886]|0,1.0,0.0)*10.0;A=+h[r>>3]+ +h[o>>3]*+Q(+(+h[p>>3]));h[(c[l>>2]|0)+56>>3]=A;A=+h[r+8>>3]+ +h[o>>3]*+R(+(+h[p>>3]));h[(c[l>>2]|0)+56+8>>3]=A;a[(c[l>>2]|0)+81>>0]=1;c[g>>2]=1;x=c[g>>2]|0;i=f;return x|0}function rN(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;i=i+128|0;g=f+96|0;j=f+120|0;k=f+116|0;l=f+112|0;m=f+80|0;n=f+64|0;o=f+48|0;p=f+32|0;q=f+16|0;r=f;c[j>>2]=b;c[k>>2]=d;c[l>>2]=(e[(c[(c[j>>2]|0)+8>>2]|0)+136>>1]|0)&14;CN(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0,o,p);if((+h[o>>3]-+h[p>>3])*(+h[o>>3]-+h[p>>3])+(+h[o+8>>3]-+h[p+8>>3])*(+h[o+8>>3]-+h[p+8>>3])<1.0e-06){c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];c[n+12>>2]=c[o+12>>2];c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];i=f;return}if((c[l>>2]|0)==10|(c[l>>2]|0)==4){h[m>>3]=(+h[p>>3]+ +h[o>>3])/2.0;h[m+8>>3]=(+h[o+8>>3]+ +h[p+8>>3])/2.0;l=c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0;c[g>>2]=c[m>>2];c[g+4>>2]=c[m+4>>2];c[g+8>>2]=c[m+8>>2];c[g+12>>2]=c[m+12>>2];vO(q,l,g);c[n>>2]=c[q>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];i=f;return}else{DN(r,c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0,o,p);c[n>>2]=c[r>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];c[a>>2]=c[n>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];c[a+12>>2]=c[n+12>>2];i=f;return}}function sN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+16|0;d=e;c[e+4>>2]=a;c[d>>2]=b;pN(c[d>>2]|0);i=e;return}function tN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+16|0;g=d+12|0;h=d+8|0;c[f>>2]=b;c[g>>2]=c[f>>2];while(1){b=c[(c[(c[g>>2]|0)+8>>2]|0)+8>>2]|0;c[h>>2]=b;if(b)break;if(!(a[(c[(c[g>>2]|0)+8>>2]|0)+112>>0]|0))break;c[g>>2]=c[(c[(c[g>>2]|0)+8>>2]|0)+116>>2]}if(c[h>>2]|0){j=c[h>>2]|0;i=d;return j|0}g=c[f>>2]|0;b=wB(c[((c[c[f>>2]>>2]&3|0)==3?g:g+32|0)+28>>2]|0)|0;g=c[f>>2]|0;k=wB(c[((c[c[f>>2]>>2]&3|0)==2?g:g+-32|0)+28>>2]|0)|0;c[e>>2]=b;c[e+4>>2]=k;$z(1,144195,e)|0;j=c[h>>2]|0;i=d;return j|0}function uN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;i=i+96|0;j=g+84|0;k=g+80|0;l=g+76|0;m=g+88|0;n=g+72|0;o=g+64|0;p=g;c[j>>2]=b;c[k>>2]=d;c[l>>2]=e;a[m>>0]=f;h[o>>3]=+h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3];c[n>>2]=0;while(1){if((c[n>>2]|0)>=4)break;h[p+(c[n>>2]<<4)>>3]=+h[(c[l>>2]|0)+(c[n>>2]<<4)>>3]-+h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3];h[p+(c[n>>2]<<4)+8>>3]=+h[(c[l>>2]|0)+(c[n>>2]<<4)+8>>3]-+h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3];c[n>>2]=(c[n>>2]|0)+1}gN(c[j>>2]|0,c[(c[(c[(c[(c[k>>2]|0)+8>>2]|0)+8>>2]|0)+4>>2]|0)+12>>2]|0,p,a[m>>0]|0);c[n>>2]=0;while(1){if((c[n>>2]|0)>=4)break;h[(c[l>>2]|0)+(c[n>>2]<<4)>>3]=+h[p+(c[n>>2]<<4)>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+16>>3];h[(c[l>>2]|0)+(c[n>>2]<<4)+8>>3]=+h[p+(c[n>>2]<<4)+8>>3]+ +h[(c[(c[k>>2]|0)+8>>2]|0)+16+8>>3];c[n>>2]=(c[n>>2]|0)+1}h[(c[(c[k>>2]|0)+8>>2]|0)+96>>3]=+h[o>>3];i=g;return}function vN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+48|0;l=k+44|0;m=k+40|0;n=k+36|0;o=k+32|0;p=k+28|0;q=k+24|0;r=k+20|0;s=k+16|0;t=k+12|0;u=k+8|0;v=k+4|0;w=k;c[l>>2]=b;c[m>>2]=d;c[n>>2]=e;c[o>>2]=f;c[p>>2]=g;c[q>>2]=h;c[r>>2]=j;c[s>>2]=c[l>>2];while(1){if(!(c[(c[(c[s>>2]|0)+8>>2]|0)+116>>2]|0))break;c[s>>2]=c[(c[(c[s>>2]|0)+8>>2]|0)+116>>2]}if(a[(c[r>>2]|0)+8>>0]|0)c[u>>2]=0;else c[u>>2]=(Fb[c[c[r>>2]>>2]&63](c[s>>2]|0)|0)&255;bH(c[s>>2]|0,v,w);if((Fb[c[(c[r>>2]|0)+4>>2]&63](c[m>>2]|0)|0)<<24>>24)c[w>>2]=0;m=c[l>>2]|0;if((Fb[c[(c[r>>2]|0)+4>>2]&63](c[((c[c[l>>2]>>2]&3|0)==3?m:m+32|0)+28>>2]|0)|0)<<24>>24)c[v>>2]=0;if(c[u>>2]|0){c[t>>2]=c[v>>2];c[v>>2]=c[w>>2];c[w>>2]=c[t>>2]}if(a[(c[r>>2]|0)+9>>0]|0){if(!((c[w>>2]|0)!=0|(c[v>>2]|0)!=0)){i=k;return}fH(c[s>>2]|0,c[n>>2]|0,c[c[o>>2]>>2]|0,c[c[p>>2]>>2]|0,c[q>>2]|0,c[v>>2]|0,c[w>>2]|0);i=k;return}if(c[v>>2]|0){r=eH(c[s>>2]|0,c[n>>2]|0,c[c[o>>2]>>2]|0,c[c[p>>2]>>2]|0,c[q>>2]|0,c[v>>2]|0)|0;c[c[o>>2]>>2]=r}if(!(c[w>>2]|0)){i=k;return}r=dH(c[s>>2]|0,c[n>>2]|0,c[c[o>>2]>>2]|0,c[c[p>>2]>>2]|0,c[q>>2]|0,c[w>>2]|0)|0;c[c[p>>2]>>2]=r;i=k;return}function wN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;h[f>>3]=+h[b>>3]+ +h[d>>3];h[f+8>>3]=+h[b+8>>3]+ +h[d+8>>3];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];i=e;return}function xN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+64|0;d=b+60|0;e=b+40|0;f=b+32|0;g=b+24|0;j=b+16|0;k=b+56|0;l=b+52|0;m=b;n=b+48|0;c[d>>2]=a;h[f>>3]=0.0;h[e>>3]=0.0;c[k>>2]=0;while(1){a=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]|0)+(c[k>>2]<<2)>>2]|0;c[n>>2]=a;if(!a)break;a=c[n>>2]|0;h[e>>3]=+h[e>>3]+ +h[(c[(c[((c[c[n>>2]>>2]&3|0)==3?a:a+32|0)+28>>2]|0)+8>>2]|0)+16>>3];c[k>>2]=(c[k>>2]|0)+1}c[l>>2]=0;while(1){a=c[(c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]|0)+(c[l>>2]<<2)>>2]|0;c[n>>2]=a;if(!a)break;a=c[n>>2]|0;h[f>>3]=+h[f>>3]+ +h[(c[(c[((c[c[n>>2]>>2]&3|0)==2?a:a+-32|0)+28>>2]|0)+8>>2]|0)+16>>3];c[l>>2]=(c[l>>2]|0)+1}h[m>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+16>>3]-+h[e>>3]/+(c[k>>2]|0);k=c[c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]>>2]|0;h[m+8>>3]=+h[(c[(c[d>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[((c[c[c[(c[(c[d>>2]|0)+8>>2]|0)+172>>2]>>2]>>2]&3|0)==3?k:k+32|0)+28>>2]|0)+8>>2]|0)+16+8>>3];h[g>>3]=+W(+(+h[m+8>>3]),+(+h[m>>3]));h[m>>3]=+h[f>>3]/+(c[l>>2]|0)-+h[(c[(c[d>>2]|0)+8>>2]|0)+16>>3];l=c[c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]>>2]|0;h[m+8>>3]=+h[(c[(c[((c[c[c[(c[(c[d>>2]|0)+8>>2]|0)+180>>2]>>2]>>2]&3|0)==2?l:l+-32|0)+28>>2]|0)+8>>2]|0)+16+8>>3]-+h[(c[(c[d>>2]|0)+8>>2]|0)+16+8>>3];h[j>>3]=+W(+(+h[m+8>>3]),+(+h[m>>3]));i=b;return +((+h[g>>3]+ +h[j>>3])/2.0)}function yN(b,e,f,g,j,k){b=b|0;e=e|0;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0;l=i;i=i+16240|0;m=l+16236|0;n=l+16232|0;o=l+16228|0;p=l+16192|0;q=l+16184|0;r=l+16224|0;s=l+16220|0;t=l+16216|0;u=l+16212|0;v=l+16176|0;w=l+16168|0;x=l+16160|0;y=l+16152|0;z=l+16144|0;A=l+16136|0;B=l+16128|0;C=l+16112|0;D=l+16096|0;E=l+16080|0;F=l+16208|0;G=l+16204|0;H=l+80|0;I=l+16200|0;J=l+64|0;K=l+48|0;L=l+32|0;M=l+16|0;N=l;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;h[p>>3]=g;h[q>>3]=j;c[r>>2]=k;c[G>>2]=c[(c[m>>2]|0)+(c[n>>2]<<2)>>2];k=c[G>>2]|0;c[F>>2]=c[((c[c[G>>2]>>2]&3|0)==3?k:k+32|0)+28>>2];h[x>>3]=+h[q>>3]/2.0/+(c[o>>2]|0);h[x>>3]=+h[x>>3]>2.0?+h[x>>3]:2.0;c[I>>2]=0;q=(c[(c[F>>2]|0)+8>>2]|0)+16|0;c[E>>2]=c[q>>2];c[E+4>>2]=c[q+4>>2];c[E+8>>2]=c[q+8>>2];c[E+12>>2]=c[q+12>>2];q=(c[(c[G>>2]|0)+8>>2]|0)+16|0;c[C>>2]=c[q>>2];c[C+4>>2]=c[q+4>>2];c[C+8>>2]=c[q+8>>2];c[C+12>>2]=c[q+12>>2];h[C>>3]=+h[C>>3]+ +h[E>>3];q=C+8|0;h[q>>3]=+h[q>>3]+ +h[E+8>>3];q=(c[(c[G>>2]|0)+8>>2]|0)+56|0;c[D>>2]=c[q>>2];c[D+4>>2]=c[q+4>>2];c[D+8>>2]=c[q+8>>2];c[D+12>>2]=c[q+12>>2];h[D>>3]=+h[D>>3]+ +h[E>>3];q=D+8|0;h[q>>3]=+h[q>>3]+ +h[E+8>>3];if(+h[C+8>>3]>=+h[D+8>>3])c[t>>2]=1;else c[t>>2]=-1;h[y>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+96>>3];h[z>>3]=0.0;c[u>>2]=EN(d[(c[(c[G>>2]|0)+8>>2]|0)+16+33>>0]|0,d[(c[(c[G>>2]|0)+8>>2]|0)+56+33>>0]|0)|0;switch(c[u>>2]|0){case 65:case 32:{if(+h[C+8>>3]==+h[D+8>>3])c[t>>2]=0-(c[t>>2]|0);break}default:{}}if(+h[y>>3]<(+h[E>>3]+ +h[y>>3]-+h[C>>3])*3.0)O=+h[y>>3];else O=(+h[E>>3]+ +h[y>>3]-+h[C>>3])*3.0;h[w>>3]=O;if(+h[y>>3]<(+h[E>>3]+ +h[y>>3]-+h[D>>3])*3.0)P=+h[y>>3];else P=(+h[E>>3]+ +h[y>>3]-+h[D>>3])*3.0;h[v>>3]=P;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[o>>2]|0))break;u=c[n>>2]|0;c[n>>2]=u+1;c[G>>2]=c[(c[m>>2]|0)+(u<<2)>>2];h[y>>3]=+h[y>>3]+ +h[p>>3];h[w>>3]=+h[w>>3]+ +h[p>>3];h[v>>3]=+h[v>>3]+ +h[p>>3];h[z>>3]=+h[z>>3]+ +(c[t>>2]|0)*+h[x>>3];c[I>>2]=0;u=c[I>>2]|0;c[I>>2]=u+1;q=H+(u<<4)|0;c[q>>2]=c[C>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];c[q+12>>2]=c[C+12>>2];q=c[I>>2]|0;c[I>>2]=q+1;u=H+(q<<4)|0;FN(J,+h[C>>3]+ +h[w>>3]/3.0,+h[C+8>>3]+ +h[z>>3]);c[u>>2]=c[J>>2];c[u+4>>2]=c[J+4>>2];c[u+8>>2]=c[J+8>>2];c[u+12>>2]=c[J+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;q=H+(u<<4)|0;FN(K,+h[E>>3]+ +h[y>>3],+h[C+8>>3]+ +h[z>>3]);c[q>>2]=c[K>>2];c[q+4>>2]=c[K+4>>2];c[q+8>>2]=c[K+8>>2];c[q+12>>2]=c[K+12>>2];q=c[I>>2]|0;c[I>>2]=q+1;u=H+(q<<4)|0;FN(L,+h[E>>3]+ +h[y>>3],(+h[C+8>>3]+ +h[D+8>>3])/2.0);c[u>>2]=c[L>>2];c[u+4>>2]=c[L+4>>2];c[u+8>>2]=c[L+8>>2];c[u+12>>2]=c[L+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;q=H+(u<<4)|0;FN(M,+h[E>>3]+ +h[y>>3],+h[D+8>>3]-+h[z>>3]);c[q>>2]=c[M>>2];c[q+4>>2]=c[M+4>>2];c[q+8>>2]=c[M+8>>2];c[q+12>>2]=c[M+12>>2];q=c[I>>2]|0;c[I>>2]=q+1;u=H+(q<<4)|0;FN(N,+h[D>>3]+ +h[v>>3]/3.0,+h[D+8>>3]-+h[z>>3]);c[u>>2]=c[N>>2];c[u+4>>2]=c[N+4>>2];c[u+8>>2]=c[N+8>>2];c[u+12>>2]=c[N+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;q=H+(u<<4)|0;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];c[q+12>>2]=c[D+12>>2];if(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0){q=c[G>>2]|0;u=(c[(c[(qC(c[((c[c[G>>2]>>2]&3|0)==3?q:q+32|0)+28>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;q=(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;if(u){h[A>>3]=+h[q+8>>3];h[B>>3]=+h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24>>3]}else{h[A>>3]=+h[q>>3];h[B>>3]=+h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]}h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+56>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+16>>3]+ +h[y>>3]+ +h[A>>3]/2.0;h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+56+8>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+16+8>>3];a[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;if(+h[A>>3]>+h[p>>3])h[y>>3]=+h[y>>3]+(+h[A>>3]-+h[p>>3])}q=c[G>>2]|0;jN(c[G>>2]|0,c[((c[c[G>>2]>>2]&3|0)==2?q:q+-32|0)+28>>2]|0,H,c[I>>2]|0,c[r>>2]|0);c[s>>2]=(c[s>>2]|0)+1}i=l;return}function zN(b,e,f,g,j,k){b=b|0;e=e|0;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0;l=i;i=i+16240|0;m=l+16236|0;n=l+16232|0;o=l+16228|0;p=l+16192|0;q=l+16184|0;r=l+16224|0;s=l+16220|0;t=l+16216|0;u=l+16212|0;v=l+16176|0;w=l+16168|0;x=l+16160|0;y=l+16152|0;z=l+16144|0;A=l+16136|0;B=l+16128|0;C=l+16112|0;D=l+16096|0;E=l+16080|0;F=l+16208|0;G=l+16204|0;H=l+80|0;I=l+16200|0;J=l+64|0;K=l+48|0;L=l+32|0;M=l+16|0;N=l;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;h[p>>3]=g;h[q>>3]=j;c[r>>2]=k;c[G>>2]=c[(c[m>>2]|0)+(c[n>>2]<<2)>>2];k=c[G>>2]|0;c[F>>2]=c[((c[c[G>>2]>>2]&3|0)==3?k:k+32|0)+28>>2];h[x>>3]=+h[p>>3]/2.0/+(c[o>>2]|0);h[x>>3]=+h[x>>3]>2.0?+h[x>>3]:2.0;c[I>>2]=0;p=(c[(c[F>>2]|0)+8>>2]|0)+16|0;c[E>>2]=c[p>>2];c[E+4>>2]=c[p+4>>2];c[E+8>>2]=c[p+8>>2];c[E+12>>2]=c[p+12>>2];p=(c[(c[G>>2]|0)+8>>2]|0)+16|0;c[C>>2]=c[p>>2];c[C+4>>2]=c[p+4>>2];c[C+8>>2]=c[p+8>>2];c[C+12>>2]=c[p+12>>2];h[C>>3]=+h[C>>3]+ +h[E>>3];p=C+8|0;h[p>>3]=+h[p>>3]+ +h[E+8>>3];p=(c[(c[G>>2]|0)+8>>2]|0)+56|0;c[D>>2]=c[p>>2];c[D+4>>2]=c[p+4>>2];c[D+8>>2]=c[p+8>>2];c[D+12>>2]=c[p+12>>2];h[D>>3]=+h[D>>3]+ +h[E>>3];p=D+8|0;h[p>>3]=+h[p>>3]+ +h[E+8>>3];if(+h[C>>3]>=+h[D>>3])c[t>>2]=1;else c[t>>2]=-1;h[z>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+80>>3]/2.0;h[y>>3]=0.0;c[u>>2]=EN(d[(c[(c[G>>2]|0)+8>>2]|0)+16+33>>0]|0,d[(c[(c[G>>2]|0)+8>>2]|0)+56+33>>0]|0)|0;switch(c[u>>2]|0){case 15:{h[y>>3]=+(c[t>>2]|0)*(+h[(c[(c[F>>2]|0)+8>>2]|0)+96>>3]-(+h[D>>3]-+h[E>>3])+ +h[x>>3]);break}case 38:{h[y>>3]=+(c[t>>2]|0)*(+h[(c[(c[F>>2]|0)+8>>2]|0)+88>>3]-(+h[E>>3]-+h[D>>3])+ +h[x>>3]);break}case 41:{h[y>>3]=+(c[t>>2]|0)*(+h[(c[(c[F>>2]|0)+8>>2]|0)+96>>3]-(+h[C>>3]-+h[E>>3])+ +h[x>>3]);break}case 48:{h[y>>3]=+(c[t>>2]|0)*(+h[(c[(c[F>>2]|0)+8>>2]|0)+96>>3]-(+h[C>>3]-+h[E>>3])+ +h[x>>3]);break}case 58:case 57:case 51:case 47:case 37:case 14:{h[y>>3]=+(c[t>>2]|0)*((+h[(c[(c[F>>2]|0)+8>>2]|0)+88>>3]-(+h[E>>3]-+h[C>>3])+(+h[(c[(c[F>>2]|0)+8>>2]|0)+96>>3]-(+h[D>>3]-+h[E>>3])))/3.0);break}case 73:{h[y>>3]=+(c[t>>2]|0)*(+h[(c[(c[F>>2]|0)+8>>2]|0)+88>>3]-(+h[E>>3]-+h[C>>3])+ +h[x>>3]);break}case 83:{h[y>>3]=+(c[t>>2]|0)*(+h[(c[(c[F>>2]|0)+8>>2]|0)+88>>3]-(+h[E>>3]-+h[C>>3]));break}case 84:{h[y>>3]=+(c[t>>2]|0)*((+h[(c[(c[F>>2]|0)+8>>2]|0)+88>>3]-(+h[E>>3]-+h[C>>3])+(+h[(c[(c[F>>2]|0)+8>>2]|0)+96>>3]-(+h[D>>3]-+h[E>>3])))/2.0+ +h[x>>3]);break}case 85:case 75:case 74:{h[y>>3]=+(c[t>>2]|0)*((+h[(c[(c[F>>2]|0)+8>>2]|0)+88>>3]-(+h[E>>3]-+h[C>>3])+(+h[(c[(c[F>>2]|0)+8>>2]|0)+96>>3]-(+h[D>>3]-+h[E>>3])))/2.0+ +h[x>>3]*2.0);break}default:{}}if(+h[z>>3]<(+h[E+8>>3]+ +h[z>>3]-+h[C+8>>3])*3.0)O=+h[z>>3];else O=(+h[E+8>>3]+ +h[z>>3]-+h[C+8>>3])*3.0;h[w>>3]=O;if(+h[z>>3]<(+h[E+8>>3]+ +h[z>>3]-+h[D+8>>3])*3.0)P=+h[z>>3];else P=(+h[E+8>>3]+ +h[z>>3]-+h[D+8>>3])*3.0;h[v>>3]=P;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[o>>2]|0))break;u=c[n>>2]|0;c[n>>2]=u+1;c[G>>2]=c[(c[m>>2]|0)+(u<<2)>>2];h[z>>3]=+h[z>>3]+ +h[q>>3];h[w>>3]=+h[w>>3]+ +h[q>>3];h[v>>3]=+h[v>>3]+ +h[q>>3];h[y>>3]=+h[y>>3]+ +(c[t>>2]|0)*+h[x>>3];c[I>>2]=0;u=c[I>>2]|0;c[I>>2]=u+1;p=H+(u<<4)|0;c[p>>2]=c[C>>2];c[p+4>>2]=c[C+4>>2];c[p+8>>2]=c[C+8>>2];c[p+12>>2]=c[C+12>>2];p=c[I>>2]|0;c[I>>2]=p+1;u=H+(p<<4)|0;FN(J,+h[C>>3]+ +h[y>>3],+h[C+8>>3]+ +h[w>>3]/3.0);c[u>>2]=c[J>>2];c[u+4>>2]=c[J+4>>2];c[u+8>>2]=c[J+8>>2];c[u+12>>2]=c[J+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;p=H+(u<<4)|0;FN(K,+h[C>>3]+ +h[y>>3],+h[E+8>>3]+ +h[z>>3]);c[p>>2]=c[K>>2];c[p+4>>2]=c[K+4>>2];c[p+8>>2]=c[K+8>>2];c[p+12>>2]=c[K+12>>2];p=c[I>>2]|0;c[I>>2]=p+1;u=H+(p<<4)|0;FN(L,(+h[C>>3]+ +h[D>>3])/2.0,+h[E+8>>3]+ +h[z>>3]);c[u>>2]=c[L>>2];c[u+4>>2]=c[L+4>>2];c[u+8>>2]=c[L+8>>2];c[u+12>>2]=c[L+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;p=H+(u<<4)|0;FN(M,+h[D>>3]-+h[y>>3],+h[E+8>>3]+ +h[z>>3]);c[p>>2]=c[M>>2];c[p+4>>2]=c[M+4>>2];c[p+8>>2]=c[M+8>>2];c[p+12>>2]=c[M+12>>2];p=c[I>>2]|0;c[I>>2]=p+1;u=H+(p<<4)|0;FN(N,+h[D>>3]-+h[y>>3],+h[D+8>>3]+ +h[v>>3]/3.0);c[u>>2]=c[N>>2];c[u+4>>2]=c[N+4>>2];c[u+8>>2]=c[N+8>>2];c[u+12>>2]=c[N+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;p=H+(u<<4)|0;c[p>>2]=c[D>>2];c[p+4>>2]=c[D+4>>2];c[p+8>>2]=c[D+8>>2];c[p+12>>2]=c[D+12>>2];if(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0){p=c[G>>2]|0;u=(c[(c[(qC(c[((c[c[G>>2]>>2]&3|0)==3?p:p+32|0)+28>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;p=(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;if(u){h[A>>3]=+h[p+8>>3];h[B>>3]=+h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24>>3]}else{h[A>>3]=+h[p>>3];h[B>>3]=+h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]}h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+56+8>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+16+8>>3]+ +h[z>>3]+ +h[B>>3]/2.0;h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+56>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+16>>3];a[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;if(+h[B>>3]>+h[q>>3])h[z>>3]=+h[z>>3]+(+h[B>>3]-+h[q>>3])}p=c[G>>2]|0;jN(c[G>>2]|0,c[((c[c[G>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0,H,c[I>>2]|0,c[r>>2]|0);c[s>>2]=(c[s>>2]|0)+1}i=l;return}function AN(b,e,f,g,j,k){b=b|0;e=e|0;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0;l=i;i=i+16240|0;m=l+16236|0;n=l+16232|0;o=l+16228|0;p=l+16192|0;q=l+16184|0;r=l+16224|0;s=l+16220|0;t=l+16216|0;u=l+16212|0;v=l+16176|0;w=l+16168|0;x=l+16160|0;y=l+16152|0;z=l+16144|0;A=l+16136|0;B=l+16128|0;C=l+16112|0;D=l+16096|0;E=l+16080|0;F=l+16208|0;G=l+16204|0;H=l+80|0;I=l+16200|0;J=l+64|0;K=l+48|0;L=l+32|0;M=l+16|0;N=l;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;h[p>>3]=g;h[q>>3]=j;c[r>>2]=k;c[G>>2]=c[(c[m>>2]|0)+(c[n>>2]<<2)>>2];k=c[G>>2]|0;c[F>>2]=c[((c[c[G>>2]>>2]&3|0)==3?k:k+32|0)+28>>2];h[x>>3]=+h[q>>3]/2.0/+(c[o>>2]|0);h[x>>3]=+h[x>>3]>2.0?+h[x>>3]:2.0;c[I>>2]=0;q=(c[(c[F>>2]|0)+8>>2]|0)+16|0;c[E>>2]=c[q>>2];c[E+4>>2]=c[q+4>>2];c[E+8>>2]=c[q+8>>2];c[E+12>>2]=c[q+12>>2];q=(c[(c[G>>2]|0)+8>>2]|0)+16|0;c[C>>2]=c[q>>2];c[C+4>>2]=c[q+4>>2];c[C+8>>2]=c[q+8>>2];c[C+12>>2]=c[q+12>>2];h[C>>3]=+h[C>>3]+ +h[E>>3];q=C+8|0;h[q>>3]=+h[q>>3]+ +h[E+8>>3];q=(c[(c[G>>2]|0)+8>>2]|0)+56|0;c[D>>2]=c[q>>2];c[D+4>>2]=c[q+4>>2];c[D+8>>2]=c[q+8>>2];c[D+12>>2]=c[q+12>>2];h[D>>3]=+h[D>>3]+ +h[E>>3];q=D+8|0;h[q>>3]=+h[q>>3]+ +h[E+8>>3];if(+h[C+8>>3]>=+h[D+8>>3])c[t>>2]=1;else c[t>>2]=-1;h[y>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+88>>3];h[z>>3]=0.0;c[u>>2]=EN(d[(c[(c[G>>2]|0)+8>>2]|0)+16+33>>0]|0,d[(c[(c[G>>2]|0)+8>>2]|0)+56+33>>0]|0)|0;switch(c[u>>2]|0){case 67:case 12:{if(+h[C+8>>3]==+h[D+8>>3])c[t>>2]=0-(c[t>>2]|0);break}default:{}}if(+h[y>>3]<(+h[C>>3]+ +h[y>>3]-+h[E>>3])*3.0)O=+h[y>>3];else O=(+h[C>>3]+ +h[y>>3]-+h[E>>3])*3.0;h[w>>3]=O;if(+h[y>>3]<(+h[D>>3]+ +h[y>>3]-+h[E>>3])*3.0)P=+h[y>>3];else P=(+h[D>>3]+ +h[y>>3]-+h[E>>3])*3.0;h[v>>3]=P;c[s>>2]=0;while(1){if((c[s>>2]|0)>=(c[o>>2]|0))break;u=c[n>>2]|0;c[n>>2]=u+1;c[G>>2]=c[(c[m>>2]|0)+(u<<2)>>2];h[y>>3]=+h[y>>3]+ +h[p>>3];h[w>>3]=+h[w>>3]+ +h[p>>3];h[v>>3]=+h[v>>3]+ +h[p>>3];h[z>>3]=+h[z>>3]+ +(c[t>>2]|0)*+h[x>>3];c[I>>2]=0;u=c[I>>2]|0;c[I>>2]=u+1;q=H+(u<<4)|0;c[q>>2]=c[C>>2];c[q+4>>2]=c[C+4>>2];c[q+8>>2]=c[C+8>>2];c[q+12>>2]=c[C+12>>2];q=c[I>>2]|0;c[I>>2]=q+1;u=H+(q<<4)|0;FN(J,+h[C>>3]-+h[w>>3]/3.0,+h[C+8>>3]+ +h[z>>3]);c[u>>2]=c[J>>2];c[u+4>>2]=c[J+4>>2];c[u+8>>2]=c[J+8>>2];c[u+12>>2]=c[J+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;q=H+(u<<4)|0;FN(K,+h[E>>3]-+h[y>>3],+h[C+8>>3]+ +h[z>>3]);c[q>>2]=c[K>>2];c[q+4>>2]=c[K+4>>2];c[q+8>>2]=c[K+8>>2];c[q+12>>2]=c[K+12>>2];q=c[I>>2]|0;c[I>>2]=q+1;u=H+(q<<4)|0;FN(L,+h[E>>3]-+h[y>>3],(+h[C+8>>3]+ +h[D+8>>3])/2.0);c[u>>2]=c[L>>2];c[u+4>>2]=c[L+4>>2];c[u+8>>2]=c[L+8>>2];c[u+12>>2]=c[L+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;q=H+(u<<4)|0;FN(M,+h[E>>3]-+h[y>>3],+h[D+8>>3]-+h[z>>3]);c[q>>2]=c[M>>2];c[q+4>>2]=c[M+4>>2];c[q+8>>2]=c[M+8>>2];c[q+12>>2]=c[M+12>>2];q=c[I>>2]|0;c[I>>2]=q+1;u=H+(q<<4)|0;FN(N,+h[D>>3]-+h[v>>3]/3.0,+h[D+8>>3]-+h[z>>3]);c[u>>2]=c[N>>2];c[u+4>>2]=c[N+4>>2];c[u+8>>2]=c[N+8>>2];c[u+12>>2]=c[N+12>>2];u=c[I>>2]|0;c[I>>2]=u+1;q=H+(u<<4)|0;c[q>>2]=c[D>>2];c[q+4>>2]=c[D+4>>2];c[q+8>>2]=c[D+8>>2];c[q+12>>2]=c[D+12>>2];if(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0){q=c[G>>2]|0;u=(c[(c[(qC(c[((c[c[G>>2]>>2]&3|0)==3?q:q+32|0)+28>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;q=(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;if(u){h[A>>3]=+h[q+8>>3];h[B>>3]=+h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24>>3]}else{h[A>>3]=+h[q>>3];h[B>>3]=+h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]}h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+56>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+16>>3]-+h[y>>3]-+h[A>>3]/2.0;h[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+56+8>>3]=+h[(c[(c[F>>2]|0)+8>>2]|0)+16+8>>3];a[(c[(c[(c[G>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;if(+h[A>>3]>+h[p>>3])h[y>>3]=+h[y>>3]+(+h[A>>3]-+h[p>>3])}q=c[G>>2]|0;jN(c[G>>2]|0,c[((c[c[G>>2]>>2]&3|0)==2?q:q+-32|0)+28>>2]|0,H,c[I>>2]|0,c[r>>2]|0);c[s>>2]=(c[s>>2]|0)+1}i=l;return}function BN(b,e,f,g,j,k){b=b|0;e=e|0;f=f|0;g=+g;j=+j;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0.0;l=i;i=i+16240|0;m=l+16236|0;n=l+16232|0;o=l+16228|0;p=l+16192|0;q=l+16184|0;r=l+16224|0;s=l+16168|0;t=l+16152|0;u=l+16136|0;v=l+16220|0;w=l+16216|0;x=l+16212|0;y=l+16208|0;z=l+16204|0;A=l+16128|0;B=l+16120|0;C=l+16112|0;D=l+16104|0;E=l+16096|0;F=l+16088|0;G=l+16080|0;H=l+80|0;I=l+16200|0;J=l+64|0;K=l+48|0;L=l+32|0;M=l+16|0;N=l;c[m>>2]=b;c[n>>2]=e;c[o>>2]=f;h[p>>3]=g;h[q>>3]=j;c[r>>2]=k;c[w>>2]=c[(c[m>>2]|0)+(c[n>>2]<<2)>>2];k=c[w>>2]|0;c[v>>2]=c[((c[c[w>>2]>>2]&3|0)==3?k:k+32|0)+28>>2];h[C>>3]=+h[p>>3]/2.0/+(c[o>>2]|0);h[C>>3]=+h[C>>3]>2.0?+h[C>>3]:2.0;c[I>>2]=0;p=(c[(c[v>>2]|0)+8>>2]|0)+16|0;c[u>>2]=c[p>>2];c[u+4>>2]=c[p+4>>2];c[u+8>>2]=c[p+8>>2];c[u+12>>2]=c[p+12>>2];p=(c[(c[w>>2]|0)+8>>2]|0)+16|0;c[s>>2]=c[p>>2];c[s+4>>2]=c[p+4>>2];c[s+8>>2]=c[p+8>>2];c[s+12>>2]=c[p+12>>2];h[s>>3]=+h[s>>3]+ +h[u>>3];p=s+8|0;h[p>>3]=+h[p>>3]+ +h[u+8>>3];p=(c[(c[w>>2]|0)+8>>2]|0)+56|0;c[t>>2]=c[p>>2];c[t+4>>2]=c[p+4>>2];c[t+8>>2]=c[p+8>>2];c[t+12>>2]=c[p+12>>2];h[t>>3]=+h[t>>3]+ +h[u>>3];p=t+8|0;h[p>>3]=+h[p>>3]+ +h[u+8>>3];if(+h[s>>3]>=+h[t>>3])c[y>>2]=1;else c[y>>2]=-1;h[E>>3]=+h[(c[(c[v>>2]|0)+8>>2]|0)+80>>3]/2.0;h[D>>3]=0.0;c[z>>2]=EN(d[(c[(c[w>>2]|0)+8>>2]|0)+16+33>>0]|0,d[(c[(c[w>>2]|0)+8>>2]|0)+56+33>>0]|0)|0;if((c[z>>2]|0)==67)c[y>>2]=0-(c[y>>2]|0);if(+h[E>>3]<(+h[s+8>>3]+ +h[E>>3]-+h[u+8>>3])*3.0)O=+h[E>>3];else O=(+h[s+8>>3]+ +h[E>>3]-+h[u+8>>3])*3.0;h[B>>3]=O;if(+h[E>>3]<(+h[t+8>>3]+ +h[E>>3]-+h[u+8>>3])*3.0)P=+h[E>>3];else P=(+h[t+8>>3]+ +h[E>>3]-+h[u+8>>3])*3.0;h[A>>3]=P;c[x>>2]=0;while(1){if((c[x>>2]|0)>=(c[o>>2]|0))break;z=c[n>>2]|0;c[n>>2]=z+1;c[w>>2]=c[(c[m>>2]|0)+(z<<2)>>2];h[E>>3]=+h[E>>3]+ +h[q>>3];h[B>>3]=+h[B>>3]+ +h[q>>3];h[A>>3]=+h[A>>3]+ +h[q>>3];h[D>>3]=+h[D>>3]+ +(c[y>>2]|0)*+h[C>>3];c[I>>2]=0;z=c[I>>2]|0;c[I>>2]=z+1;p=H+(z<<4)|0;c[p>>2]=c[s>>2];c[p+4>>2]=c[s+4>>2];c[p+8>>2]=c[s+8>>2];c[p+12>>2]=c[s+12>>2];p=c[I>>2]|0;c[I>>2]=p+1;z=H+(p<<4)|0;FN(J,+h[s>>3]+ +h[D>>3],+h[s+8>>3]-+h[B>>3]/3.0);c[z>>2]=c[J>>2];c[z+4>>2]=c[J+4>>2];c[z+8>>2]=c[J+8>>2];c[z+12>>2]=c[J+12>>2];z=c[I>>2]|0;c[I>>2]=z+1;p=H+(z<<4)|0;FN(K,+h[s>>3]+ +h[D>>3],+h[u+8>>3]-+h[E>>3]);c[p>>2]=c[K>>2];c[p+4>>2]=c[K+4>>2];c[p+8>>2]=c[K+8>>2];c[p+12>>2]=c[K+12>>2];p=c[I>>2]|0;c[I>>2]=p+1;z=H+(p<<4)|0;FN(L,(+h[s>>3]+ +h[t>>3])/2.0,+h[u+8>>3]-+h[E>>3]);c[z>>2]=c[L>>2];c[z+4>>2]=c[L+4>>2];c[z+8>>2]=c[L+8>>2];c[z+12>>2]=c[L+12>>2];z=c[I>>2]|0;c[I>>2]=z+1;p=H+(z<<4)|0;FN(M,+h[t>>3]-+h[D>>3],+h[u+8>>3]-+h[E>>3]);c[p>>2]=c[M>>2];c[p+4>>2]=c[M+4>>2];c[p+8>>2]=c[M+8>>2];c[p+12>>2]=c[M+12>>2];p=c[I>>2]|0;c[I>>2]=p+1;z=H+(p<<4)|0;FN(N,+h[t>>3]-+h[D>>3],+h[t+8>>3]-+h[A>>3]/3.0);c[z>>2]=c[N>>2];c[z+4>>2]=c[N+4>>2];c[z+8>>2]=c[N+8>>2];c[z+12>>2]=c[N+12>>2];z=c[I>>2]|0;c[I>>2]=z+1;p=H+(z<<4)|0;c[p>>2]=c[t>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];c[p+12>>2]=c[t+12>>2];if(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0){p=c[w>>2]|0;z=(c[(c[(qC(c[((c[c[w>>2]>>2]&3|0)==3?p:p+32|0)+28>>2]|0)|0)+8>>2]|0)+116>>2]&1|0)!=0;p=(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0)+24|0;if(z){h[F>>3]=+h[p+8>>3];h[G>>3]=+h[(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0)+24>>3]}else{h[F>>3]=+h[p>>3];h[G>>3]=+h[(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0)+24+8>>3]}h[(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0)+56+8>>3]=+h[(c[(c[v>>2]|0)+8>>2]|0)+16+8>>3]-+h[E>>3]-+h[G>>3]/2.0;h[(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0)+56>>3]=+h[(c[(c[v>>2]|0)+8>>2]|0)+16>>3];a[(c[(c[(c[w>>2]|0)+8>>2]|0)+96>>2]|0)+81>>0]=1;if(+h[G>>3]>+h[q>>3])h[E>>3]=+h[E>>3]+(+h[G>>3]-+h[q>>3])}p=c[w>>2]|0;jN(c[w>>2]|0,c[((c[c[w>>2]>>2]&3|0)==2?p:p+-32|0)+28>>2]|0,H,c[I>>2]|0,c[r>>2]|0);c[x>>2]=(c[x>>2]|0)+1}i=l;return}function CN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+64|0;f=e+56|0;g=e+52|0;h=e+48|0;j=e;c[f>>2]=a;c[g>>2]=b;c[h>>2]=d;d=j;b=c[c[f>>2]>>2]|0;a=d+48|0;do{c[d>>2]=c[b>>2];d=d+4|0;b=b+4|0}while((d|0)<(a|0));k=c[g>>2]|0;if(c[j+8>>2]|0){g=j+16|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2]}else{g=c[j>>2]|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2]}d=j;b=(c[c[f>>2]>>2]|0)+(((c[(c[f>>2]|0)+4>>2]|0)-1|0)*48|0)|0;a=d+48|0;do{c[d>>2]=c[b>>2];d=d+4|0;b=b+4|0}while((d|0)<(a|0));b=c[h>>2]|0;if(c[j+12>>2]|0){h=j+32|0;c[b>>2]=c[h>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];i=e;return}else{h=(c[j>>2]|0)+((c[j+4>>2]|0)-1<<4)|0;c[b>>2]=c[h>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];i=e;return}}function DN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;f=i;i=i+144|0;g=f+132|0;j=f+128|0;k=f+124|0;l=f+64|0;m=f+120|0;n=f+116|0;o=f+112|0;p=f+56|0;q=f+48|0;r=f+32|0;s=f+16|0;t=f;c[g>>2]=b;c[j>>2]=d;c[k>>2]=e;h[q>>3]=0.0;c[m>>2]=0;while(1){if((c[m>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0))break;u=l;v=(c[c[g>>2]>>2]|0)+((c[m>>2]|0)*48|0)|0;w=u+48|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));c[n>>2]=0;c[o>>2]=3;while(1){if((c[o>>2]|0)>=(c[l+4>>2]|0))break;e=(c[l>>2]|0)+(c[n>>2]<<4)|0;c[r>>2]=c[e>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];e=(c[l>>2]|0)+(c[o>>2]<<4)|0;c[s>>2]=c[e>>2];c[s+4>>2]=c[e+4>>2];c[s+8>>2]=c[e+8>>2];c[s+12>>2]=c[e+12>>2];x=+O(+((+h[r>>3]-+h[s>>3])*(+h[r>>3]-+h[s>>3])+(+h[r+8>>3]-+h[s+8>>3])*(+h[r+8>>3]-+h[s+8>>3])));h[q>>3]=+h[q>>3]+x;c[n>>2]=(c[n>>2]|0)+3;c[o>>2]=(c[o>>2]|0)+3}c[m>>2]=(c[m>>2]|0)+1}h[q>>3]=+h[q>>3]/2.0;c[m>>2]=0;a:while(1){if((c[m>>2]|0)>=(c[(c[g>>2]|0)+4>>2]|0)){y=15;break}u=l;v=(c[c[g>>2]>>2]|0)+((c[m>>2]|0)*48|0)|0;w=u+48|0;do{c[u>>2]=c[v>>2];u=u+4|0;v=v+4|0}while((u|0)<(w|0));c[n>>2]=0;c[o>>2]=3;while(1){if((c[o>>2]|0)>=(c[l+4>>2]|0))break;e=(c[l>>2]|0)+(c[n>>2]<<4)|0;c[r>>2]=c[e>>2];c[r+4>>2]=c[e+4>>2];c[r+8>>2]=c[e+8>>2];c[r+12>>2]=c[e+12>>2];e=(c[l>>2]|0)+(c[o>>2]<<4)|0;c[s>>2]=c[e>>2];c[s+4>>2]=c[e+4>>2];c[s+8>>2]=c[e+8>>2];c[s+12>>2]=c[e+12>>2];h[p>>3]=+O(+((+h[r>>3]-+h[s>>3])*(+h[r>>3]-+h[s>>3])+(+h[r+8>>3]-+h[s+8>>3])*(+h[r+8>>3]-+h[s+8>>3])));if(+h[p>>3]>=+h[q>>3]){y=12;break a}h[q>>3]=+h[q>>3]-+h[p>>3];c[n>>2]=(c[n>>2]|0)+3;c[o>>2]=(c[o>>2]|0)+3}c[m>>2]=(c[m>>2]|0)+1}if((y|0)==12){m=c[j>>2]|0;c[m>>2]=c[r>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[m+12>>2]=c[r+12>>2];m=c[k>>2]|0;c[m>>2]=c[s>>2];c[m+4>>2]=c[s+4>>2];c[m+8>>2]=c[s+8>>2];c[m+12>>2]=c[s+12>>2];h[t>>3]=(+h[s>>3]*+h[q>>3]+ +h[r>>3]*(+h[p>>3]-+h[q>>3]))/+h[p>>3];h[t+8>>3]=(+h[s+8>>3]*+h[q>>3]+ +h[r+8>>3]*(+h[p>>3]-+h[q>>3]))/+h[p>>3];c[a>>2]=c[t>>2];c[a+4>>2]=c[t+4>>2];c[a+8>>2]=c[t+8>>2];c[a+12>>2]=c[t+12>>2];i=f;return}else if((y|0)==15)La(176417,144130,1316,144257)}function EN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;d=i;i=i+320|0;e=d+312|0;f=d+308|0;g=d+304|0;h=d+272|0;j=d+264|0;k=d+260|0;l=d+256|0;m=d;c[f>>2]=a;c[g>>2]=b;c[h>>2]=c[14312];c[h+4>>2]=c[14313];c[h+8>>2]=c[14314];c[h+12>>2]=c[14315];c[h+16>>2]=c[14316];c[h+20>>2]=c[14317];c[h+24>>2]=c[14318];c[h+28>>2]=c[14319];Z4(m|0,57280,256)|0;c[l>>2]=-1;c[k>>2]=-1;c[j>>2]=0;while(1){if((c[j>>2]|0)>=8)break;n=c[j>>2]|0;if((c[g>>2]|0)==(c[h+(c[j>>2]<<2)>>2]|0)){o=4;break}c[j>>2]=n+1}if((o|0)==4)c[l>>2]=n;c[j>>2]=0;while(1){if((c[j>>2]|0)>=8)break;p=c[j>>2]|0;if((c[f>>2]|0)==(c[h+(c[j>>2]<<2)>>2]|0)){o=9;break}c[j>>2]=p+1}if((o|0)==9)c[k>>2]=p;if((c[k>>2]|0)<0|(c[l>>2]|0)<0){c[e>>2]=0;q=c[e>>2]|0;i=d;return q|0}else{c[e>>2]=c[m+(c[k>>2]<<5)+(c[l>>2]<<2)>>2];q=c[e>>2]|0;i=d;return q|0}return 0}function FN(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0;e=i;i=i+32|0;f=e+24|0;g=e+16|0;j=e;h[f>>3]=b;h[g>>3]=d;h[j>>3]=+h[f>>3];h[j+8>>3]=+h[g>>3];c[a>>2]=c[j>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];c[a+12>>2]=c[j+12>>2];i=e;return}function GN(b,d,e,f,g){b=b|0;d=d|0;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0;j=i;i=i+384|0;k=j+372|0;l=j+368|0;m=j+320|0;n=j+364|0;o=j+360|0;p=j+356|0;q=j+352|0;r=j+348|0;s=j+344|0;t=j+340|0;u=j+312|0;v=j+304|0;w=j+336|0;x=j+332|0;y=j+240|0;z=j+176|0;A=j+112|0;B=j+104|0;C=j+96|0;D=j+88|0;E=j+80|0;F=j+72|0;G=j+64|0;H=j+56|0;I=j+48|0;J=j+40|0;K=j+32|0;L=j+24|0;M=j+16|0;N=j+8|0;O=j;P=j+328|0;c[k>>2]=b;c[l>>2]=d;h[m>>3]=e;c[n>>2]=f;c[o>>2]=g;h[u>>3]=0.0;h[v>>3]=0.0;c[w>>2]=HN(c[k>>2]|0,+h[m>>3])|0;h[B>>3]=0.0;h[C>>3]=0.0;h[K>>3]=0.0;h[L>>3]=0.0;h[M>>3]=0.0;c[s>>2]=c[(c[w>>2]|0)+4>>2];c[x>>2]=c[c[w>>2]>>2];h[M>>3]=+h[(c[x>>2]|0)+((c[s>>2]|0)-1<<6)+16>>3];c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[s>>2]|0))break;c[q>>2]=~~+IN(+((c[p>>2]|0)-1|0),+(c[s>>2]|0));c[r>>2]=~~+IN(+((c[p>>2]|0)+1|0),+(c[s>>2]|0));S=y;T=(c[x>>2]|0)+(c[p>>2]<<6)|0;U=S+64|0;do{c[S>>2]=c[T>>2];S=S+4|0;T=T+4|0}while((S|0)<(U|0));h[B>>3]=+h[y>>3];h[C>>3]=+h[y+8>>3];h[D>>3]=+h[y+16>>3];S=A;T=(c[x>>2]|0)+(c[r>>2]<<6)|0;U=S+64|0;do{c[S>>2]=c[T>>2];S=S+4|0;T=T+4|0}while((S|0)<(U|0));h[E>>3]=+h[A>>3];h[F>>3]=+h[A+8>>3];h[G>>3]=+JN(+h[F>>3]-+h[C>>3],+h[E>>3]-+h[B>>3]);S=z;T=(c[x>>2]|0)+(c[q>>2]<<6)|0;U=S+64|0;do{c[S>>2]=c[T>>2];S=S+4|0;T=T+4|0}while((S|0)<(U|0));h[H>>3]=+h[z>>3];h[I>>3]=+h[z+8>>3];h[J>>3]=+JN(+h[I>>3]-+h[C>>3],+h[H>>3]-+h[B>>3]);c[t>>2]=0;h[v>>3]=0.0;h[L>>3]=+Lb[c[l>>2]&7](+h[D>>3],+h[M>>3],+h[m>>3]);do if((c[p>>2]|0)!=0?(c[p>>2]|0)!=((c[s>>2]|0)-1|0):0){h[N>>3]=+h[G>>3]-+h[J>>3];if(+h[N>>3]<0.0)h[N>>3]=+h[N>>3]+6.283185307179586;h[O>>3]=1.5707963267948966-+h[N>>3]/2.0;if(+Q(+(+h[O>>3]))==0.0)h[K>>3]=0.0;else h[K>>3]=+h[L>>3]/+Q(+(+h[O>>3]));h[u>>3]=+h[G>>3]+1.5707963267948966+ +h[O>>3];if(0==(c[n>>2]|0)?!(+h[K>>3]>+h[4594]*+h[L>>3]):0){h[v>>3]=+h[u>>3];break}c[t>>2]=1;h[K>>3]=+h[L>>3];h[u>>3]=+IN(+h[J>>3]-1.5707963267948966,6.283185307179586);h[v>>3]=+IN(+h[G>>3]+1.5707963267948966,6.283185307179586);if((c[p>>2]|0)==((c[s>>2]|0)-1|0))c[t>>2]=0}else V=5;while(0);if((V|0)==5){V=0;h[K>>3]=+h[L>>3];if(!(c[p>>2]|0)){h[u>>3]=+h[G>>3]+1.5707963267948966;if((c[o>>2]|0)==2){e=+Q(+(+h[G>>3]));h[B>>3]=+h[B>>3]-e*+h[K>>3];e=+R(+(+h[G>>3]));h[C>>3]=+h[C>>3]-e*+h[K>>3]}}else{h[u>>3]=+h[J>>3]-1.5707963267948966;if((c[o>>2]|0)==2){e=+Q(+(+h[J>>3]));h[B>>3]=+h[B>>3]-e*+h[K>>3];e=+R(+(+h[J>>3]));h[C>>3]=+h[C>>3]-e*+h[K>>3]}}h[v>>3]=+h[u>>3]}h[(c[x>>2]|0)+(c[p>>2]<<6)>>3]=+h[B>>3];h[(c[x>>2]|0)+(c[p>>2]<<6)+8>>3]=+h[C>>3];h[(c[x>>2]|0)+(c[p>>2]<<6)+16>>3]=+h[D>>3];a[(c[x>>2]|0)+(c[p>>2]<<6)+24>>0]=108;h[(c[x>>2]|0)+(c[p>>2]<<6)+32>>3]=+h[u>>3];h[(c[x>>2]|0)+(c[p>>2]<<6)+40>>3]=+h[K>>3];c[(c[x>>2]|0)+(c[p>>2]<<6)+48>>2]=c[t>>2];h[(c[x>>2]|0)+(c[p>>2]<<6)+56>>3]=+h[v>>3];c[p>>2]=(c[p>>2]|0)+1}c[P>>2]=bK(12)|0;c[p>>2]=0;while(1){if((c[p>>2]|0)>=(c[s>>2]|0))break;S=y;T=(c[x>>2]|0)+(c[p>>2]<<6)|0;U=S+64|0;do{c[S>>2]=c[T>>2];S=S+4|0;T=T+4|0}while((S|0)<(U|0));h[B>>3]=+h[y>>3];h[C>>3]=+h[y+8>>3];h[u>>3]=+h[y+32>>3];h[K>>3]=+h[y+40>>3];c[t>>2]=c[y+48>>2];h[v>>3]=+h[y+56>>3];e=+Q(+(+h[u>>3]));W=+R(+(+h[u>>3]));KN(c[P>>2]|0,+h[B>>3]+e*+h[K>>3],+h[C>>3]+W*+h[K>>3]);if(c[t>>2]|0)LN(+h[B>>3],+h[C>>3],+h[K>>3],1,+h[u>>3],+h[v>>3],c[n>>2]|0,c[P>>2]|0);c[p>>2]=(c[p>>2]|0)+1}if((c[o>>2]|0)==1)MN(c[P>>2]|0,+h[B>>3],+h[C>>3],+h[K>>3],+h[u>>3],+h[u>>3]+3.141592653589793);else{h[u>>3]=+h[u>>3]+3.141592653589793;W=+Q(+(+h[u>>3]));e=+R(+(+h[u>>3]));KN(c[P>>2]|0,+h[B>>3]+W*+h[K>>3],+h[C>>3]+e*+h[K>>3])}c[p>>2]=(c[s>>2]|0)-2;while(1){if((c[p>>2]|0)<0)break;S=y;T=(c[x>>2]|0)+(c[p>>2]<<6)|0;U=S+64|0;do{c[S>>2]=c[T>>2];S=S+4|0;T=T+4|0}while((S|0)<(U|0));h[B>>3]=+h[y>>3];h[C>>3]=+h[y+8>>3];h[u>>3]=+h[y+32>>3]+3.141592653589793;h[K>>3]=+h[y+40>>3];c[t>>2]=c[y+48>>2];h[v>>3]=+h[y+56>>3]+3.141592653589793;e=+Q(+(+h[v>>3]));W=+R(+(+h[v>>3]));KN(c[P>>2]|0,+h[B>>3]+e*+h[K>>3],+h[C>>3]+W*+h[K>>3]);if(c[t>>2]|0)LN(+h[B>>3],+h[C>>3],+h[K>>3],0,+h[u>>3],+h[v>>3],c[n>>2]|0,c[P>>2]|0);c[p>>2]=(c[p>>2]|0)+-1}if((c[o>>2]|0)!=1){X=c[w>>2]|0;NN(X);Y=c[P>>2]|0;i=j;return Y|0}MN(c[P>>2]|0,+h[B>>3],+h[C>>3],+h[K>>3],+h[u>>3],+h[u>>3]+3.141592653589793);X=c[w>>2]|0;NN(X);Y=c[P>>2]|0;i=j;return Y|0}function HN(a,b){a=a|0;b=+b;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+208|0;e=d+152|0;f=d+136|0;g=d+192|0;j=d+188|0;k=d+184|0;l=d+180|0;m=d+120|0;n=d+112|0;o=d+176|0;p=d+96|0;q=d+80|0;r=d+16|0;s=d+172|0;t=d+168|0;u=d;c[g>>2]=a;h[d+128>>3]=b;h[n>>3]=0.0;c[o>>2]=ON()|0;c[s>>2]=c[(c[g>>2]|0)+4>>2];c[t>>2]=c[c[g>>2]>>2];g=c[o>>2]|0;a=c[t>>2]|0;c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];PN(g,e,0.0);g=r+48|0;a=c[t>>2]|0;c[g>>2]=c[a>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[j>>2]=0;while(1){if(((c[j>>2]|0)+3|0)>=(c[s>>2]|0))break;a=r+48|0;c[r>>2]=c[a>>2];c[r+4>>2]=c[a+4>>2];c[r+8>>2]=c[a+8>>2];c[r+12>>2]=c[a+12>>2];c[k>>2]=1;while(1){if((c[k>>2]|0)>3)break;a=r+(c[k>>2]<<4)|0;g=(c[t>>2]|0)+((c[j>>2]|0)+(c[k>>2]|0)<<4)|0;c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];c[k>>2]=(c[k>>2]|0)+1}c[p>>2]=c[r>>2];c[p+4>>2]=c[r+4>>2];c[p+8>>2]=c[r+8>>2];c[p+12>>2]=c[r+12>>2];c[l>>2]=1;while(1){if((c[l>>2]|0)>20)break;qO(u,r,3,+(c[l>>2]|0)/20.0,0,0);c[q>>2]=c[u>>2];c[q+4>>2]=c[u+4>>2];c[q+8>>2]=c[u+8>>2];c[q+12>>2]=c[u+12>>2];c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];c[e+12>>2]=c[q+12>>2];h[m>>3]=+QN(f,e);h[n>>3]=+h[n>>3]+ +h[m>>3];g=c[o>>2]|0;b=+h[n>>3];c[e>>2]=c[q>>2];c[e+4>>2]=c[q+4>>2];c[e+8>>2]=c[q+8>>2];c[e+12>>2]=c[q+12>>2];PN(g,e,b);c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];c[p+12>>2]=c[q+12>>2];c[l>>2]=(c[l>>2]|0)+1}c[j>>2]=(c[j>>2]|0)+3}RN(c[o>>2]|0);i=d;return c[o>>2]|0}function IN(a,b){a=+a;b=+b;var c=0,d=0,e=0,f=0,g=0,j=0.0;c=i;i=i+32|0;d=c+24|0;e=c+16|0;f=c+8|0;g=c;h[e>>3]=a;h[f>>3]=b;if(!(+h[e>>3]<0.0)?!(+h[e>>3]>=+h[f>>3]):0){h[d>>3]=+h[e>>3];j=+h[d>>3];i=c;return +j}h[g>>3]=-+M(+(+h[e>>3]/+h[f>>3]));h[d>>3]=+h[g>>3]*+h[f>>3]+ +h[e>>3];j=+h[d>>3];i=c;return +j}function JN(a,b){a=+a;b=+b;var c=0,d=0,e=0,f=0,g=0;c=i;i=i+32|0;d=c+24|0;e=c+16|0;f=c+8|0;g=c;h[e>>3]=a;h[f>>3]=b;do if(!(+h[f>>3]==0.0&+h[e>>3]==0.0)){h[g>>3]=+W(+(+h[e>>3]),+(+h[f>>3]));b=+h[g>>3];if(+h[g>>3]>=0.0){h[d>>3]=b;break}else{h[d>>3]=b+6.283185307179586;break}}else h[d>>3]=0.0;while(0);i=c;return +(+h[d>>3])}function KN(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0;e=i;i=i+48|0;f=e+32|0;g=e+24|0;j=e+16|0;k=e;c[f>>2]=a;h[g>>3]=b;h[j>>3]=d;if((c[c[f>>2]>>2]|0)>=(c[(c[f>>2]|0)+4>>2]|0)){c[(c[f>>2]|0)+4>>2]=2e3;a=eK(c[(c[f>>2]|0)+8>>2]|0,c[(c[f>>2]|0)+4>>2]<<4)|0;c[(c[f>>2]|0)+8>>2]=a}h[k>>3]=+h[g>>3];h[k+8>>3]=+h[j>>3];j=c[f>>2]|0;g=c[j>>2]|0;c[j>>2]=g+1;j=(c[(c[f>>2]|0)+8>>2]|0)+(g<<4)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];i=e;return}function LN(a,b,d,e,f,g,j,k){a=+a;b=+b;d=+d;e=e|0;f=+f;g=+g;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+80|0;m=l+56|0;n=l+48|0;o=l+40|0;p=l+72|0;q=l+32|0;r=l+24|0;s=l+68|0;t=l+64|0;u=l+16|0;v=l+8|0;w=l;h[m>>3]=a;h[n>>3]=b;h[o>>3]=d;c[p>>2]=e;h[q>>3]=f;h[r>>3]=g;c[s>>2]=j;c[t>>2]=k;if(c[p>>2]|0){h[v>>3]=+h[q>>3];h[w>>3]=+h[r>>3]}else{h[v>>3]=+h[r>>3];h[w>>3]=+h[q>>3]}if((c[s>>2]|0)!=1){g=+h[m>>3]+ +h[o>>3]*+Q(+(+h[w>>3]));KN(c[t>>2]|0,g,+h[m>>3]+ +h[o>>3]*+R(+(+h[w>>3])));i=l;return}h[u>>3]=+h[v>>3]-+h[w>>3];if(+h[u>>3]<=1.7453292519943296e-03)h[u>>3]=+h[u>>3]+6.283185307179586;if(+h[u>>3]<3.141592653589793){h[v>>3]=+h[u>>3]+ +h[w>>3];MN(c[t>>2]|0,+h[m>>3],+h[n>>3],+h[o>>3],+h[v>>3],+h[w>>3]);i=l;return}else{g=+h[m>>3]+ +h[o>>3]*+Q(+(+h[w>>3]));KN(c[t>>2]|0,g,+h[m>>3]+ +h[o>>3]*+R(+(+h[w>>3])));i=l;return}}function MN(a,b,d,e,f,g){a=a|0;b=+b;d=+d;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;j=i;i=i+64|0;k=j+52|0;l=j+40|0;m=j+32|0;n=j+24|0;o=j+16|0;p=j+8|0;q=j;r=j+48|0;c[k>>2]=a;h[l>>3]=b;h[m>>3]=d;h[n>>3]=e;h[o>>3]=f;h[p>>3]=g;g=+h[l>>3]+ +h[n>>3]*+Q(+(+h[o>>3]));KN(c[k>>2]|0,g,+h[m>>3]+ +h[n>>3]*+R(+(+h[o>>3])));if(+h[n>>3]==0.0){i=j;return}while(1){if(!(+h[p>>3]>+h[o>>3]))break;h[p>>3]=+h[p>>3]-6.283185307179586}h[q>>3]=+h[o>>3]-+h[p>>3];while(1){s=+h[q>>3];if(!(+h[q>>3]>6.283185307179586))break;h[q>>3]=s-6.283185307179586}h[q>>3]=s/19.0;c[r>>2]=1;while(1){if((c[r>>2]|0)>=20)break;s=+h[l>>3]+ +h[n>>3]*+Q(+(+h[o>>3]-+(c[r>>2]|0)*+h[q>>3]));KN(c[k>>2]|0,s,+h[m>>3]+ +h[n>>3]*+R(+(+h[o>>3]-+(c[r>>2]|0)*+h[q>>3])));c[r>>2]=(c[r>>2]|0)+1}i=j;return}function NN(a){a=a|0;var b=0,d=0;b=i;i=i+16|0;d=b;c[d>>2]=a;O4(c[c[d>>2]>>2]|0);O4(c[d>>2]|0);i=b;return}function ON(){var a=0,b=0,d=0;a=i;i=i+16|0;b=a;c[b>>2]=bK(12)|0;c[(c[b>>2]|0)+4>>2]=0;c[(c[b>>2]|0)+8>>2]=2e3;d=bK(128e3)|0;c[c[b>>2]>>2]=d;i=a;return c[b>>2]|0}
function N4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;do if(a>>>0<245){b=a>>>0<11?16:a+11&-8;d=b>>>3;e=c[24988]|0;f=e>>>d;if(f&3){g=(f&1^1)+d|0;h=99992+(g<<1<<2)|0;i=h+8|0;j=c[i>>2]|0;k=j+8|0;l=c[k>>2]|0;do if((h|0)!=(l|0)){if(l>>>0<(c[24992]|0)>>>0)Ga();m=l+12|0;if((c[m>>2]|0)==(j|0)){c[m>>2]=h;c[i>>2]=l;break}else Ga()}else c[24988]=e&~(1<<g);while(0);l=g<<3;c[j+4>>2]=l|3;i=j+l+4|0;c[i>>2]=c[i>>2]|1;n=k;return n|0}i=c[24990]|0;if(b>>>0>i>>>0){if(f){l=2<<d;h=f<<d&(l|0-l);l=(h&0-h)+-1|0;h=l>>>12&16;m=l>>>h;l=m>>>5&8;o=m>>>l;m=o>>>2&4;p=o>>>m;o=p>>>1&2;q=p>>>o;p=q>>>1&1;r=(l|h|m|o|p)+(q>>>p)|0;p=99992+(r<<1<<2)|0;q=p+8|0;o=c[q>>2]|0;m=o+8|0;h=c[m>>2]|0;do if((p|0)!=(h|0)){if(h>>>0<(c[24992]|0)>>>0)Ga();l=h+12|0;if((c[l>>2]|0)==(o|0)){c[l>>2]=p;c[q>>2]=h;s=c[24990]|0;break}else Ga()}else{c[24988]=e&~(1<<r);s=i}while(0);i=(r<<3)-b|0;c[o+4>>2]=b|3;e=o+b|0;c[e+4>>2]=i|1;c[e+i>>2]=i;if(s){h=c[24993]|0;q=s>>>3;p=99992+(q<<1<<2)|0;d=c[24988]|0;f=1<<q;if(d&f){q=p+8|0;k=c[q>>2]|0;if(k>>>0<(c[24992]|0)>>>0)Ga();else{t=q;u=k}}else{c[24988]=d|f;t=p+8|0;u=p}c[t>>2]=h;c[u+12>>2]=h;c[h+8>>2]=u;c[h+12>>2]=p}c[24990]=i;c[24993]=e;n=m;return n|0}e=c[24989]|0;if(e){i=(e&0-e)+-1|0;e=i>>>12&16;p=i>>>e;i=p>>>5&8;h=p>>>i;p=h>>>2&4;f=h>>>p;h=f>>>1&2;d=f>>>h;f=d>>>1&1;k=c[100256+((i|e|p|h|f)+(d>>>f)<<2)>>2]|0;f=(c[k+4>>2]&-8)-b|0;d=k;h=k;while(1){k=c[d+16>>2]|0;if(!k){p=c[d+20>>2]|0;if(!p){v=f;w=h;break}else x=p}else x=k;k=(c[x+4>>2]&-8)-b|0;p=k>>>0<f>>>0;f=p?k:f;d=x;h=p?x:h}h=c[24992]|0;if(w>>>0<h>>>0)Ga();d=w+b|0;if(w>>>0>=d>>>0)Ga();f=c[w+24>>2]|0;m=c[w+12>>2]|0;do if((m|0)==(w|0)){o=w+20|0;r=c[o>>2]|0;if(!r){p=w+16|0;k=c[p>>2]|0;if(!k){y=0;break}else{z=k;A=p}}else{z=r;A=o}while(1){o=z+20|0;r=c[o>>2]|0;if(r){z=r;A=o;continue}o=z+16|0;r=c[o>>2]|0;if(!r){B=z;C=A;break}else{z=r;A=o}}if(C>>>0<h>>>0)Ga();else{c[C>>2]=0;y=B;break}}else{o=c[w+8>>2]|0;if(o>>>0<h>>>0)Ga();r=o+12|0;if((c[r>>2]|0)!=(w|0))Ga();p=m+8|0;if((c[p>>2]|0)==(w|0)){c[r>>2]=m;c[p>>2]=o;y=m;break}else Ga()}while(0);do if(f){m=c[w+28>>2]|0;h=100256+(m<<2)|0;if((w|0)==(c[h>>2]|0)){c[h>>2]=y;if(!y){c[24989]=c[24989]&~(1<<m);break}}else{if(f>>>0<(c[24992]|0)>>>0)Ga();m=f+16|0;if((c[m>>2]|0)==(w|0))c[m>>2]=y;else c[f+20>>2]=y;if(!y)break}m=c[24992]|0;if(y>>>0<m>>>0)Ga();c[y+24>>2]=f;h=c[w+16>>2]|0;do if(h)if(h>>>0<m>>>0)Ga();else{c[y+16>>2]=h;c[h+24>>2]=y;break}while(0);h=c[w+20>>2]|0;if(h)if(h>>>0<(c[24992]|0)>>>0)Ga();else{c[y+20>>2]=h;c[h+24>>2]=y;break}}while(0);if(v>>>0<16){f=v+b|0;c[w+4>>2]=f|3;h=w+f+4|0;c[h>>2]=c[h>>2]|1}else{c[w+4>>2]=b|3;c[d+4>>2]=v|1;c[d+v>>2]=v;h=c[24990]|0;if(h){f=c[24993]|0;m=h>>>3;h=99992+(m<<1<<2)|0;o=c[24988]|0;p=1<<m;if(o&p){m=h+8|0;r=c[m>>2]|0;if(r>>>0<(c[24992]|0)>>>0)Ga();else{D=m;E=r}}else{c[24988]=o|p;D=h+8|0;E=h}c[D>>2]=f;c[E+12>>2]=f;c[f+8>>2]=E;c[f+12>>2]=h}c[24990]=v;c[24993]=d}n=w+8|0;return n|0}else F=b}else F=b}else if(a>>>0<=4294967231){h=a+11|0;f=h&-8;p=c[24989]|0;if(p){o=0-f|0;r=h>>>8;if(r)if(f>>>0>16777215)G=31;else{h=(r+1048320|0)>>>16&8;m=r<<h;r=(m+520192|0)>>>16&4;k=m<<r;m=(k+245760|0)>>>16&2;e=14-(r|h|m)+(k<<m>>>15)|0;G=f>>>(e+7|0)&1|e<<1}else G=0;e=c[100256+(G<<2)>>2]|0;a:do if(!e){H=o;I=0;J=0;K=86}else{m=o;k=0;h=f<<((G|0)==31?0:25-(G>>>1)|0);r=e;i=0;while(1){q=c[r+4>>2]&-8;j=q-f|0;if(j>>>0<m>>>0)if((q|0)==(f|0)){L=j;M=r;N=r;K=90;break a}else{O=j;P=r}else{O=m;P=i}j=c[r+20>>2]|0;r=c[r+16+(h>>>31<<2)>>2]|0;q=(j|0)==0|(j|0)==(r|0)?k:j;j=(r|0)==0;if(j){H=O;I=q;J=P;K=86;break}else{m=O;k=q;h=h<<(j&1^1);i=P}}}while(0);if((K|0)==86){if((I|0)==0&(J|0)==0){e=2<<G;o=p&(e|0-e);if(!o){F=f;break}e=(o&0-o)+-1|0;o=e>>>12&16;b=e>>>o;e=b>>>5&8;d=b>>>e;b=d>>>2&4;i=d>>>b;d=i>>>1&2;h=i>>>d;i=h>>>1&1;Q=c[100256+((e|o|b|d|i)+(h>>>i)<<2)>>2]|0}else Q=I;if(!Q){R=H;S=J}else{L=H;M=Q;N=J;K=90}}if((K|0)==90)while(1){K=0;i=(c[M+4>>2]&-8)-f|0;h=i>>>0<L>>>0;d=h?i:L;i=h?M:N;h=c[M+16>>2]|0;if(h){L=d;M=h;N=i;K=90;continue}M=c[M+20>>2]|0;if(!M){R=d;S=i;break}else{L=d;N=i;K=90}}if((S|0)!=0?R>>>0<((c[24990]|0)-f|0)>>>0:0){p=c[24992]|0;if(S>>>0<p>>>0)Ga();i=S+f|0;if(S>>>0>=i>>>0)Ga();d=c[S+24>>2]|0;h=c[S+12>>2]|0;do if((h|0)==(S|0)){b=S+20|0;o=c[b>>2]|0;if(!o){e=S+16|0;k=c[e>>2]|0;if(!k){T=0;break}else{U=k;V=e}}else{U=o;V=b}while(1){b=U+20|0;o=c[b>>2]|0;if(o){U=o;V=b;continue}b=U+16|0;o=c[b>>2]|0;if(!o){W=U;X=V;break}else{U=o;V=b}}if(X>>>0<p>>>0)Ga();else{c[X>>2]=0;T=W;break}}else{b=c[S+8>>2]|0;if(b>>>0<p>>>0)Ga();o=b+12|0;if((c[o>>2]|0)!=(S|0))Ga();e=h+8|0;if((c[e>>2]|0)==(S|0)){c[o>>2]=h;c[e>>2]=b;T=h;break}else Ga()}while(0);do if(d){h=c[S+28>>2]|0;p=100256+(h<<2)|0;if((S|0)==(c[p>>2]|0)){c[p>>2]=T;if(!T){c[24989]=c[24989]&~(1<<h);break}}else{if(d>>>0<(c[24992]|0)>>>0)Ga();h=d+16|0;if((c[h>>2]|0)==(S|0))c[h>>2]=T;else c[d+20>>2]=T;if(!T)break}h=c[24992]|0;if(T>>>0<h>>>0)Ga();c[T+24>>2]=d;p=c[S+16>>2]|0;do if(p)if(p>>>0<h>>>0)Ga();else{c[T+16>>2]=p;c[p+24>>2]=T;break}while(0);p=c[S+20>>2]|0;if(p)if(p>>>0<(c[24992]|0)>>>0)Ga();else{c[T+20>>2]=p;c[p+24>>2]=T;break}}while(0);do if(R>>>0>=16){c[S+4>>2]=f|3;c[i+4>>2]=R|1;c[i+R>>2]=R;d=R>>>3;if(R>>>0<256){p=99992+(d<<1<<2)|0;h=c[24988]|0;b=1<<d;if(h&b){d=p+8|0;e=c[d>>2]|0;if(e>>>0<(c[24992]|0)>>>0)Ga();else{Y=d;Z=e}}else{c[24988]=h|b;Y=p+8|0;Z=p}c[Y>>2]=i;c[Z+12>>2]=i;c[i+8>>2]=Z;c[i+12>>2]=p;break}p=R>>>8;if(p)if(R>>>0>16777215)_=31;else{b=(p+1048320|0)>>>16&8;h=p<<b;p=(h+520192|0)>>>16&4;e=h<<p;h=(e+245760|0)>>>16&2;d=14-(p|b|h)+(e<<h>>>15)|0;_=R>>>(d+7|0)&1|d<<1}else _=0;d=100256+(_<<2)|0;c[i+28>>2]=_;h=i+16|0;c[h+4>>2]=0;c[h>>2]=0;h=c[24989]|0;e=1<<_;if(!(h&e)){c[24989]=h|e;c[d>>2]=i;c[i+24>>2]=d;c[i+12>>2]=i;c[i+8>>2]=i;break}e=R<<((_|0)==31?0:25-(_>>>1)|0);h=c[d>>2]|0;while(1){if((c[h+4>>2]&-8|0)==(R|0)){$=h;K=148;break}d=h+16+(e>>>31<<2)|0;b=c[d>>2]|0;if(!b){aa=d;ba=h;K=145;break}else{e=e<<1;h=b}}if((K|0)==145)if(aa>>>0<(c[24992]|0)>>>0)Ga();else{c[aa>>2]=i;c[i+24>>2]=ba;c[i+12>>2]=i;c[i+8>>2]=i;break}else if((K|0)==148){h=$+8|0;e=c[h>>2]|0;b=c[24992]|0;if(e>>>0>=b>>>0&$>>>0>=b>>>0){c[e+12>>2]=i;c[h>>2]=i;c[i+8>>2]=e;c[i+12>>2]=$;c[i+24>>2]=0;break}else Ga()}}else{e=R+f|0;c[S+4>>2]=e|3;h=S+e+4|0;c[h>>2]=c[h>>2]|1}while(0);n=S+8|0;return n|0}else F=f}else F=f}else F=-1;while(0);S=c[24990]|0;if(S>>>0>=F>>>0){R=S-F|0;$=c[24993]|0;if(R>>>0>15){ba=$+F|0;c[24993]=ba;c[24990]=R;c[ba+4>>2]=R|1;c[ba+R>>2]=R;c[$+4>>2]=F|3}else{c[24990]=0;c[24993]=0;c[$+4>>2]=S|3;R=$+S+4|0;c[R>>2]=c[R>>2]|1}n=$+8|0;return n|0}$=c[24991]|0;if($>>>0>F>>>0){R=$-F|0;c[24991]=R;$=c[24994]|0;S=$+F|0;c[24994]=S;c[S+4>>2]=R|1;c[$+4>>2]=F|3;n=$+8|0;return n|0}do if(!(c[25106]|0)){$=Xa(30)|0;if(!($+-1&$)){c[25108]=$;c[25107]=$;c[25109]=-1;c[25110]=-1;c[25111]=0;c[25099]=0;c[25106]=(sb(0)|0)&-16^1431655768;break}else Ga()}while(0);$=F+48|0;R=c[25108]|0;S=F+47|0;ba=R+S|0;aa=0-R|0;R=ba&aa;if(R>>>0<=F>>>0){n=0;return n|0}_=c[25098]|0;if((_|0)!=0?(Z=c[25096]|0,Y=Z+R|0,Y>>>0<=Z>>>0|Y>>>0>_>>>0):0){n=0;return n|0}b:do if(!(c[25099]&4)){_=c[24994]|0;c:do if(_){Y=100400;while(1){Z=c[Y>>2]|0;if(Z>>>0<=_>>>0?(T=Y+4|0,(Z+(c[T>>2]|0)|0)>>>0>_>>>0):0){ca=Y;da=T;break}Y=c[Y+8>>2]|0;if(!Y){K=173;break c}}Y=ba-(c[24991]|0)&aa;if(Y>>>0<2147483647){T=Ta(Y|0)|0;if((T|0)==((c[ca>>2]|0)+(c[da>>2]|0)|0)){if((T|0)!=(-1|0)){ea=T;fa=Y;K=193;break b}}else{ga=T;ha=Y;K=183}}}else K=173;while(0);do if((K|0)==173?(_=Ta(0)|0,(_|0)!=(-1|0)):0){f=_;Y=c[25107]|0;T=Y+-1|0;if(!(T&f))ia=R;else ia=R-f+(T+f&0-Y)|0;Y=c[25096]|0;f=Y+ia|0;if(ia>>>0>F>>>0&ia>>>0<2147483647){T=c[25098]|0;if((T|0)!=0?f>>>0<=Y>>>0|f>>>0>T>>>0:0)break;T=Ta(ia|0)|0;if((T|0)==(_|0)){ea=_;fa=ia;K=193;break b}else{ga=T;ha=ia;K=183}}}while(0);d:do if((K|0)==183){T=0-ha|0;do if($>>>0>ha>>>0&(ha>>>0<2147483647&(ga|0)!=(-1|0))?(_=c[25108]|0,f=S-ha+_&0-_,f>>>0<2147483647):0)if((Ta(f|0)|0)==(-1|0)){Ta(T|0)|0;break d}else{ja=f+ha|0;break}else ja=ha;while(0);if((ga|0)!=(-1|0)){ea=ga;fa=ja;K=193;break b}}while(0);c[25099]=c[25099]|4;K=190}else K=190;while(0);if((((K|0)==190?R>>>0<2147483647:0)?(ja=Ta(R|0)|0,R=Ta(0)|0,ja>>>0<R>>>0&((ja|0)!=(-1|0)&(R|0)!=(-1|0))):0)?(ga=R-ja|0,ga>>>0>(F+40|0)>>>0):0){ea=ja;fa=ga;K=193}if((K|0)==193){ga=(c[25096]|0)+fa|0;c[25096]=ga;if(ga>>>0>(c[25097]|0)>>>0)c[25097]=ga;ga=c[24994]|0;do if(ga){ja=100400;do{R=c[ja>>2]|0;ha=ja+4|0;S=c[ha>>2]|0;if((ea|0)==(R+S|0)){ka=R;la=ha;ma=S;na=ja;K=203;break}ja=c[ja+8>>2]|0}while((ja|0)!=0);if(((K|0)==203?(c[na+12>>2]&8|0)==0:0)?ga>>>0<ea>>>0&ga>>>0>=ka>>>0:0){c[la>>2]=ma+fa;ja=ga+8|0;S=(ja&7|0)==0?0:0-ja&7;ja=ga+S|0;ha=fa-S+(c[24991]|0)|0;c[24994]=ja;c[24991]=ha;c[ja+4>>2]=ha|1;c[ja+ha+4>>2]=40;c[24995]=c[25110];break}ha=c[24992]|0;if(ea>>>0<ha>>>0){c[24992]=ea;oa=ea}else oa=ha;ha=ea+fa|0;ja=100400;while(1){if((c[ja>>2]|0)==(ha|0)){pa=ja;qa=ja;K=211;break}ja=c[ja+8>>2]|0;if(!ja){ra=100400;break}}if((K|0)==211)if(!(c[qa+12>>2]&8)){c[pa>>2]=ea;ja=qa+4|0;c[ja>>2]=(c[ja>>2]|0)+fa;ja=ea+8|0;S=ea+((ja&7|0)==0?0:0-ja&7)|0;ja=ha+8|0;R=ha+((ja&7|0)==0?0:0-ja&7)|0;ja=S+F|0;$=R-S-F|0;c[S+4>>2]=F|3;do if((R|0)!=(ga|0)){if((R|0)==(c[24993]|0)){ia=(c[24990]|0)+$|0;c[24990]=ia;c[24993]=ja;c[ja+4>>2]=ia|1;c[ja+ia>>2]=ia;break}ia=c[R+4>>2]|0;if((ia&3|0)==1){da=ia&-8;ca=ia>>>3;e:do if(ia>>>0>=256){aa=c[R+24>>2]|0;ba=c[R+12>>2]|0;do if((ba|0)==(R|0)){T=R+16|0;f=T+4|0;_=c[f>>2]|0;if(!_){Y=c[T>>2]|0;if(!Y){sa=0;break}else{ta=Y;ua=T}}else{ta=_;ua=f}while(1){f=ta+20|0;_=c[f>>2]|0;if(_){ta=_;ua=f;continue}f=ta+16|0;_=c[f>>2]|0;if(!_){va=ta;wa=ua;break}else{ta=_;ua=f}}if(wa>>>0<oa>>>0)Ga();else{c[wa>>2]=0;sa=va;break}}else{f=c[R+8>>2]|0;if(f>>>0<oa>>>0)Ga();_=f+12|0;if((c[_>>2]|0)!=(R|0))Ga();T=ba+8|0;if((c[T>>2]|0)==(R|0)){c[_>>2]=ba;c[T>>2]=f;sa=ba;break}else Ga()}while(0);if(!aa)break;ba=c[R+28>>2]|0;f=100256+(ba<<2)|0;do if((R|0)!=(c[f>>2]|0)){if(aa>>>0<(c[24992]|0)>>>0)Ga();T=aa+16|0;if((c[T>>2]|0)==(R|0))c[T>>2]=sa;else c[aa+20>>2]=sa;if(!sa)break e}else{c[f>>2]=sa;if(sa)break;c[24989]=c[24989]&~(1<<ba);break e}while(0);ba=c[24992]|0;if(sa>>>0<ba>>>0)Ga();c[sa+24>>2]=aa;f=R+16|0;T=c[f>>2]|0;do if(T)if(T>>>0<ba>>>0)Ga();else{c[sa+16>>2]=T;c[T+24>>2]=sa;break}while(0);T=c[f+4>>2]|0;if(!T)break;if(T>>>0<(c[24992]|0)>>>0)Ga();else{c[sa+20>>2]=T;c[T+24>>2]=sa;break}}else{T=c[R+8>>2]|0;ba=c[R+12>>2]|0;aa=99992+(ca<<1<<2)|0;do if((T|0)!=(aa|0)){if(T>>>0<oa>>>0)Ga();if((c[T+12>>2]|0)==(R|0))break;Ga()}while(0);if((ba|0)==(T|0)){c[24988]=c[24988]&~(1<<ca);break}do if((ba|0)==(aa|0))xa=ba+8|0;else{if(ba>>>0<oa>>>0)Ga();f=ba+8|0;if((c[f>>2]|0)==(R|0)){xa=f;break}Ga()}while(0);c[T+12>>2]=ba;c[xa>>2]=T}while(0);ya=R+da|0;za=da+$|0}else{ya=R;za=$}ca=ya+4|0;c[ca>>2]=c[ca>>2]&-2;c[ja+4>>2]=za|1;c[ja+za>>2]=za;ca=za>>>3;if(za>>>0<256){ia=99992+(ca<<1<<2)|0;aa=c[24988]|0;f=1<<ca;do if(!(aa&f)){c[24988]=aa|f;Aa=ia+8|0;Ba=ia}else{ca=ia+8|0;_=c[ca>>2]|0;if(_>>>0>=(c[24992]|0)>>>0){Aa=ca;Ba=_;break}Ga()}while(0);c[Aa>>2]=ja;c[Ba+12>>2]=ja;c[ja+8>>2]=Ba;c[ja+12>>2]=ia;break}f=za>>>8;do if(!f)Ca=0;else{if(za>>>0>16777215){Ca=31;break}aa=(f+1048320|0)>>>16&8;da=f<<aa;_=(da+520192|0)>>>16&4;ca=da<<_;da=(ca+245760|0)>>>16&2;Y=14-(_|aa|da)+(ca<<da>>>15)|0;Ca=za>>>(Y+7|0)&1|Y<<1}while(0);f=100256+(Ca<<2)|0;c[ja+28>>2]=Ca;ia=ja+16|0;c[ia+4>>2]=0;c[ia>>2]=0;ia=c[24989]|0;Y=1<<Ca;if(!(ia&Y)){c[24989]=ia|Y;c[f>>2]=ja;c[ja+24>>2]=f;c[ja+12>>2]=ja;c[ja+8>>2]=ja;break}Y=za<<((Ca|0)==31?0:25-(Ca>>>1)|0);ia=c[f>>2]|0;while(1){if((c[ia+4>>2]&-8|0)==(za|0)){Da=ia;K=281;break}f=ia+16+(Y>>>31<<2)|0;da=c[f>>2]|0;if(!da){Ea=f;Fa=ia;K=278;break}else{Y=Y<<1;ia=da}}if((K|0)==278)if(Ea>>>0<(c[24992]|0)>>>0)Ga();else{c[Ea>>2]=ja;c[ja+24>>2]=Fa;c[ja+12>>2]=ja;c[ja+8>>2]=ja;break}else if((K|0)==281){ia=Da+8|0;Y=c[ia>>2]|0;da=c[24992]|0;if(Y>>>0>=da>>>0&Da>>>0>=da>>>0){c[Y+12>>2]=ja;c[ia>>2]=ja;c[ja+8>>2]=Y;c[ja+12>>2]=Da;c[ja+24>>2]=0;break}else Ga()}}else{Y=(c[24991]|0)+$|0;c[24991]=Y;c[24994]=ja;c[ja+4>>2]=Y|1}while(0);n=S+8|0;return n|0}else ra=100400;while(1){ja=c[ra>>2]|0;if(ja>>>0<=ga>>>0?($=ja+(c[ra+4>>2]|0)|0,$>>>0>ga>>>0):0){Ha=$;break}ra=c[ra+8>>2]|0}S=Ha+-47|0;$=S+8|0;ja=S+(($&7|0)==0?0:0-$&7)|0;$=ga+16|0;S=ja>>>0<$>>>0?ga:ja;ja=S+8|0;R=ea+8|0;ha=(R&7|0)==0?0:0-R&7;R=ea+ha|0;Y=fa+-40-ha|0;c[24994]=R;c[24991]=Y;c[R+4>>2]=Y|1;c[R+Y+4>>2]=40;c[24995]=c[25110];Y=S+4|0;c[Y>>2]=27;c[ja>>2]=c[25100];c[ja+4>>2]=c[25101];c[ja+8>>2]=c[25102];c[ja+12>>2]=c[25103];c[25100]=ea;c[25101]=fa;c[25103]=0;c[25102]=ja;ja=S+24|0;do{ja=ja+4|0;c[ja>>2]=7}while((ja+4|0)>>>0<Ha>>>0);if((S|0)!=(ga|0)){ja=S-ga|0;c[Y>>2]=c[Y>>2]&-2;c[ga+4>>2]=ja|1;c[S>>2]=ja;R=ja>>>3;if(ja>>>0<256){ha=99992+(R<<1<<2)|0;ia=c[24988]|0;da=1<<R;if(ia&da){R=ha+8|0;f=c[R>>2]|0;if(f>>>0<(c[24992]|0)>>>0)Ga();else{Ia=R;Ja=f}}else{c[24988]=ia|da;Ia=ha+8|0;Ja=ha}c[Ia>>2]=ga;c[Ja+12>>2]=ga;c[ga+8>>2]=Ja;c[ga+12>>2]=ha;break}ha=ja>>>8;if(ha)if(ja>>>0>16777215)Ka=31;else{da=(ha+1048320|0)>>>16&8;ia=ha<<da;ha=(ia+520192|0)>>>16&4;f=ia<<ha;ia=(f+245760|0)>>>16&2;R=14-(ha|da|ia)+(f<<ia>>>15)|0;Ka=ja>>>(R+7|0)&1|R<<1}else Ka=0;R=100256+(Ka<<2)|0;c[ga+28>>2]=Ka;c[ga+20>>2]=0;c[$>>2]=0;ia=c[24989]|0;f=1<<Ka;if(!(ia&f)){c[24989]=ia|f;c[R>>2]=ga;c[ga+24>>2]=R;c[ga+12>>2]=ga;c[ga+8>>2]=ga;break}f=ja<<((Ka|0)==31?0:25-(Ka>>>1)|0);ia=c[R>>2]|0;while(1){if((c[ia+4>>2]&-8|0)==(ja|0)){La=ia;K=307;break}R=ia+16+(f>>>31<<2)|0;da=c[R>>2]|0;if(!da){Ma=R;Na=ia;K=304;break}else{f=f<<1;ia=da}}if((K|0)==304)if(Ma>>>0<(c[24992]|0)>>>0)Ga();else{c[Ma>>2]=ga;c[ga+24>>2]=Na;c[ga+12>>2]=ga;c[ga+8>>2]=ga;break}else if((K|0)==307){ia=La+8|0;f=c[ia>>2]|0;ja=c[24992]|0;if(f>>>0>=ja>>>0&La>>>0>=ja>>>0){c[f+12>>2]=ga;c[ia>>2]=ga;c[ga+8>>2]=f;c[ga+12>>2]=La;c[ga+24>>2]=0;break}else Ga()}}}else{f=c[24992]|0;if((f|0)==0|ea>>>0<f>>>0)c[24992]=ea;c[25100]=ea;c[25101]=fa;c[25103]=0;c[24997]=c[25106];c[24996]=-1;f=0;do{ia=99992+(f<<1<<2)|0;c[ia+12>>2]=ia;c[ia+8>>2]=ia;f=f+1|0}while((f|0)!=32);f=ea+8|0;ia=(f&7|0)==0?0:0-f&7;f=ea+ia|0;ja=fa+-40-ia|0;c[24994]=f;c[24991]=ja;c[f+4>>2]=ja|1;c[f+ja+4>>2]=40;c[24995]=c[25110]}while(0);fa=c[24991]|0;if(fa>>>0>F>>>0){ea=fa-F|0;c[24991]=ea;fa=c[24994]|0;ga=fa+F|0;c[24994]=ga;c[ga+4>>2]=ea|1;c[fa+4>>2]=F|3;n=fa+8|0;return n|0}}c[(L1()|0)>>2]=12;n=0;return n|0}function O4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;if(!a)return;b=a+-8|0;d=c[24992]|0;if(b>>>0<d>>>0)Ga();e=c[a+-4>>2]|0;a=e&3;if((a|0)==1)Ga();f=e&-8;g=b+f|0;do if(!(e&1)){h=c[b>>2]|0;if(!a)return;i=b+(0-h)|0;j=h+f|0;if(i>>>0<d>>>0)Ga();if((i|0)==(c[24993]|0)){k=g+4|0;l=c[k>>2]|0;if((l&3|0)!=3){m=i;n=j;break}c[24990]=j;c[k>>2]=l&-2;c[i+4>>2]=j|1;c[i+j>>2]=j;return}l=h>>>3;if(h>>>0<256){h=c[i+8>>2]|0;k=c[i+12>>2]|0;o=99992+(l<<1<<2)|0;if((h|0)!=(o|0)){if(h>>>0<d>>>0)Ga();if((c[h+12>>2]|0)!=(i|0))Ga()}if((k|0)==(h|0)){c[24988]=c[24988]&~(1<<l);m=i;n=j;break}if((k|0)!=(o|0)){if(k>>>0<d>>>0)Ga();o=k+8|0;if((c[o>>2]|0)==(i|0))p=o;else Ga()}else p=k+8|0;c[h+12>>2]=k;c[p>>2]=h;m=i;n=j;break}h=c[i+24>>2]|0;k=c[i+12>>2]|0;do if((k|0)==(i|0)){o=i+16|0;l=o+4|0;q=c[l>>2]|0;if(!q){r=c[o>>2]|0;if(!r){s=0;break}else{t=r;u=o}}else{t=q;u=l}while(1){l=t+20|0;q=c[l>>2]|0;if(q){t=q;u=l;continue}l=t+16|0;q=c[l>>2]|0;if(!q){v=t;w=u;break}else{t=q;u=l}}if(w>>>0<d>>>0)Ga();else{c[w>>2]=0;s=v;break}}else{l=c[i+8>>2]|0;if(l>>>0<d>>>0)Ga();q=l+12|0;if((c[q>>2]|0)!=(i|0))Ga();o=k+8|0;if((c[o>>2]|0)==(i|0)){c[q>>2]=k;c[o>>2]=l;s=k;break}else Ga()}while(0);if(h){k=c[i+28>>2]|0;l=100256+(k<<2)|0;if((i|0)==(c[l>>2]|0)){c[l>>2]=s;if(!s){c[24989]=c[24989]&~(1<<k);m=i;n=j;break}}else{if(h>>>0<(c[24992]|0)>>>0)Ga();k=h+16|0;if((c[k>>2]|0)==(i|0))c[k>>2]=s;else c[h+20>>2]=s;if(!s){m=i;n=j;break}}k=c[24992]|0;if(s>>>0<k>>>0)Ga();c[s+24>>2]=h;l=i+16|0;o=c[l>>2]|0;do if(o)if(o>>>0<k>>>0)Ga();else{c[s+16>>2]=o;c[o+24>>2]=s;break}while(0);o=c[l+4>>2]|0;if(o)if(o>>>0<(c[24992]|0)>>>0)Ga();else{c[s+20>>2]=o;c[o+24>>2]=s;m=i;n=j;break}else{m=i;n=j}}else{m=i;n=j}}else{m=b;n=f}while(0);if(m>>>0>=g>>>0)Ga();f=g+4|0;b=c[f>>2]|0;if(!(b&1))Ga();if(!(b&2)){if((g|0)==(c[24994]|0)){s=(c[24991]|0)+n|0;c[24991]=s;c[24994]=m;c[m+4>>2]=s|1;if((m|0)!=(c[24993]|0))return;c[24993]=0;c[24990]=0;return}if((g|0)==(c[24993]|0)){s=(c[24990]|0)+n|0;c[24990]=s;c[24993]=m;c[m+4>>2]=s|1;c[m+s>>2]=s;return}s=(b&-8)+n|0;d=b>>>3;do if(b>>>0>=256){v=c[g+24>>2]|0;w=c[g+12>>2]|0;do if((w|0)==(g|0)){u=g+16|0;t=u+4|0;p=c[t>>2]|0;if(!p){a=c[u>>2]|0;if(!a){x=0;break}else{y=a;z=u}}else{y=p;z=t}while(1){t=y+20|0;p=c[t>>2]|0;if(p){y=p;z=t;continue}t=y+16|0;p=c[t>>2]|0;if(!p){A=y;B=z;break}else{y=p;z=t}}if(B>>>0<(c[24992]|0)>>>0)Ga();else{c[B>>2]=0;x=A;break}}else{t=c[g+8>>2]|0;if(t>>>0<(c[24992]|0)>>>0)Ga();p=t+12|0;if((c[p>>2]|0)!=(g|0))Ga();u=w+8|0;if((c[u>>2]|0)==(g|0)){c[p>>2]=w;c[u>>2]=t;x=w;break}else Ga()}while(0);if(v){w=c[g+28>>2]|0;j=100256+(w<<2)|0;if((g|0)==(c[j>>2]|0)){c[j>>2]=x;if(!x){c[24989]=c[24989]&~(1<<w);break}}else{if(v>>>0<(c[24992]|0)>>>0)Ga();w=v+16|0;if((c[w>>2]|0)==(g|0))c[w>>2]=x;else c[v+20>>2]=x;if(!x)break}w=c[24992]|0;if(x>>>0<w>>>0)Ga();c[x+24>>2]=v;j=g+16|0;i=c[j>>2]|0;do if(i)if(i>>>0<w>>>0)Ga();else{c[x+16>>2]=i;c[i+24>>2]=x;break}while(0);i=c[j+4>>2]|0;if(i)if(i>>>0<(c[24992]|0)>>>0)Ga();else{c[x+20>>2]=i;c[i+24>>2]=x;break}}}else{i=c[g+8>>2]|0;w=c[g+12>>2]|0;v=99992+(d<<1<<2)|0;if((i|0)!=(v|0)){if(i>>>0<(c[24992]|0)>>>0)Ga();if((c[i+12>>2]|0)!=(g|0))Ga()}if((w|0)==(i|0)){c[24988]=c[24988]&~(1<<d);break}if((w|0)!=(v|0)){if(w>>>0<(c[24992]|0)>>>0)Ga();v=w+8|0;if((c[v>>2]|0)==(g|0))C=v;else Ga()}else C=w+8|0;c[i+12>>2]=w;c[C>>2]=i}while(0);c[m+4>>2]=s|1;c[m+s>>2]=s;if((m|0)==(c[24993]|0)){c[24990]=s;return}else D=s}else{c[f>>2]=b&-2;c[m+4>>2]=n|1;c[m+n>>2]=n;D=n}n=D>>>3;if(D>>>0<256){b=99992+(n<<1<<2)|0;f=c[24988]|0;s=1<<n;if(f&s){n=b+8|0;C=c[n>>2]|0;if(C>>>0<(c[24992]|0)>>>0)Ga();else{E=n;F=C}}else{c[24988]=f|s;E=b+8|0;F=b}c[E>>2]=m;c[F+12>>2]=m;c[m+8>>2]=F;c[m+12>>2]=b;return}b=D>>>8;if(b)if(D>>>0>16777215)G=31;else{F=(b+1048320|0)>>>16&8;E=b<<F;b=(E+520192|0)>>>16&4;s=E<<b;E=(s+245760|0)>>>16&2;f=14-(b|F|E)+(s<<E>>>15)|0;G=D>>>(f+7|0)&1|f<<1}else G=0;f=100256+(G<<2)|0;c[m+28>>2]=G;c[m+20>>2]=0;c[m+16>>2]=0;E=c[24989]|0;s=1<<G;do if(E&s){F=D<<((G|0)==31?0:25-(G>>>1)|0);b=c[f>>2]|0;while(1){if((c[b+4>>2]&-8|0)==(D|0)){H=b;I=130;break}C=b+16+(F>>>31<<2)|0;n=c[C>>2]|0;if(!n){J=C;K=b;I=127;break}else{F=F<<1;b=n}}if((I|0)==127)if(J>>>0<(c[24992]|0)>>>0)Ga();else{c[J>>2]=m;c[m+24>>2]=K;c[m+12>>2]=m;c[m+8>>2]=m;break}else if((I|0)==130){b=H+8|0;F=c[b>>2]|0;j=c[24992]|0;if(F>>>0>=j>>>0&H>>>0>=j>>>0){c[F+12>>2]=m;c[b>>2]=m;c[m+8>>2]=F;c[m+12>>2]=H;c[m+24>>2]=0;break}else Ga()}}else{c[24989]=E|s;c[f>>2]=m;c[m+24>>2]=f;c[m+12>>2]=m;c[m+8>>2]=m}while(0);m=(c[24996]|0)+-1|0;c[24996]=m;if(!m)L=100408;else return;while(1){m=c[L>>2]|0;if(!m)break;else L=m+8|0}c[24996]=-1;return}function P4(a,b){a=a|0;b=b|0;var d=0,e=0;if(a){d=_(b,a)|0;if((b|a)>>>0>65535)e=((d>>>0)/(a>>>0)|0|0)==(b|0)?d:-1;else e=d}else e=0;d=N4(e)|0;if(!d)return d|0;if(!(c[d+-4>>2]&3))return d|0;$4(d|0,0,e|0)|0;return d|0}function Q4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;if(!a){d=N4(b)|0;return d|0}if(b>>>0>4294967231){c[(L1()|0)>>2]=12;d=0;return d|0}e=R4(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(e){d=e+8|0;return d|0}e=N4(b)|0;if(!e){d=0;return d|0}f=c[a+-4>>2]|0;g=(f&-8)-((f&3|0)==0?8:4)|0;Z4(e|0,a|0,(g>>>0<b>>>0?g:b)|0)|0;O4(a);d=e;return d|0}function R4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=a+4|0;e=c[d>>2]|0;f=e&-8;g=a+f|0;h=c[24992]|0;i=e&3;if(!((i|0)!=1&a>>>0>=h>>>0&a>>>0<g>>>0))Ga();j=c[g+4>>2]|0;if(!(j&1))Ga();if(!i){if(b>>>0<256){k=0;return k|0}if(f>>>0>=(b+4|0)>>>0?(f-b|0)>>>0<=c[25108]<<1>>>0:0){k=a;return k|0}k=0;return k|0}if(f>>>0>=b>>>0){i=f-b|0;if(i>>>0<=15){k=a;return k|0}l=a+b|0;c[d>>2]=e&1|b|2;c[l+4>>2]=i|3;m=l+i+4|0;c[m>>2]=c[m>>2]|1;S4(l,i);k=a;return k|0}if((g|0)==(c[24994]|0)){i=(c[24991]|0)+f|0;if(i>>>0<=b>>>0){k=0;return k|0}l=i-b|0;i=a+b|0;c[d>>2]=e&1|b|2;c[i+4>>2]=l|1;c[24994]=i;c[24991]=l;k=a;return k|0}if((g|0)==(c[24993]|0)){l=(c[24990]|0)+f|0;if(l>>>0<b>>>0){k=0;return k|0}i=l-b|0;if(i>>>0>15){m=a+b|0;n=m+i|0;c[d>>2]=e&1|b|2;c[m+4>>2]=i|1;c[n>>2]=i;o=n+4|0;c[o>>2]=c[o>>2]&-2;p=m;q=i}else{c[d>>2]=e&1|l|2;i=a+l+4|0;c[i>>2]=c[i>>2]|1;p=0;q=0}c[24990]=q;c[24993]=p;k=a;return k|0}if(j&2){k=0;return k|0}p=(j&-8)+f|0;if(p>>>0<b>>>0){k=0;return k|0}f=p-b|0;q=j>>>3;do if(j>>>0>=256){i=c[g+24>>2]|0;l=c[g+12>>2]|0;do if((l|0)==(g|0)){m=g+16|0;o=m+4|0;n=c[o>>2]|0;if(!n){r=c[m>>2]|0;if(!r){s=0;break}else{t=r;u=m}}else{t=n;u=o}while(1){o=t+20|0;n=c[o>>2]|0;if(n){t=n;u=o;continue}o=t+16|0;n=c[o>>2]|0;if(!n){v=t;w=u;break}else{t=n;u=o}}if(w>>>0<h>>>0)Ga();else{c[w>>2]=0;s=v;break}}else{o=c[g+8>>2]|0;if(o>>>0<h>>>0)Ga();n=o+12|0;if((c[n>>2]|0)!=(g|0))Ga();m=l+8|0;if((c[m>>2]|0)==(g|0)){c[n>>2]=l;c[m>>2]=o;s=l;break}else Ga()}while(0);if(i){l=c[g+28>>2]|0;o=100256+(l<<2)|0;if((g|0)==(c[o>>2]|0)){c[o>>2]=s;if(!s){c[24989]=c[24989]&~(1<<l);break}}else{if(i>>>0<(c[24992]|0)>>>0)Ga();l=i+16|0;if((c[l>>2]|0)==(g|0))c[l>>2]=s;else c[i+20>>2]=s;if(!s)break}l=c[24992]|0;if(s>>>0<l>>>0)Ga();c[s+24>>2]=i;o=g+16|0;m=c[o>>2]|0;do if(m)if(m>>>0<l>>>0)Ga();else{c[s+16>>2]=m;c[m+24>>2]=s;break}while(0);m=c[o+4>>2]|0;if(m)if(m>>>0<(c[24992]|0)>>>0)Ga();else{c[s+20>>2]=m;c[m+24>>2]=s;break}}}else{m=c[g+8>>2]|0;l=c[g+12>>2]|0;i=99992+(q<<1<<2)|0;if((m|0)!=(i|0)){if(m>>>0<h>>>0)Ga();if((c[m+12>>2]|0)!=(g|0))Ga()}if((l|0)==(m|0)){c[24988]=c[24988]&~(1<<q);break}if((l|0)!=(i|0)){if(l>>>0<h>>>0)Ga();i=l+8|0;if((c[i>>2]|0)==(g|0))x=i;else Ga()}else x=l+8|0;c[m+12>>2]=l;c[x>>2]=m}while(0);if(f>>>0<16){c[d>>2]=p|e&1|2;x=a+p+4|0;c[x>>2]=c[x>>2]|1;k=a;return k|0}else{x=a+b|0;c[d>>2]=e&1|b|2;c[x+4>>2]=f|3;b=x+f+4|0;c[b>>2]=c[b>>2]|1;S4(x,f);k=a;return k|0}return 0}function S4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=a+b|0;e=c[a+4>>2]|0;do if(!(e&1)){f=c[a>>2]|0;if(!(e&3))return;g=a+(0-f)|0;h=f+b|0;i=c[24992]|0;if(g>>>0<i>>>0)Ga();if((g|0)==(c[24993]|0)){j=d+4|0;k=c[j>>2]|0;if((k&3|0)!=3){l=g;m=h;break}c[24990]=h;c[j>>2]=k&-2;c[g+4>>2]=h|1;c[g+h>>2]=h;return}k=f>>>3;if(f>>>0<256){f=c[g+8>>2]|0;j=c[g+12>>2]|0;n=99992+(k<<1<<2)|0;if((f|0)!=(n|0)){if(f>>>0<i>>>0)Ga();if((c[f+12>>2]|0)!=(g|0))Ga()}if((j|0)==(f|0)){c[24988]=c[24988]&~(1<<k);l=g;m=h;break}if((j|0)!=(n|0)){if(j>>>0<i>>>0)Ga();n=j+8|0;if((c[n>>2]|0)==(g|0))o=n;else Ga()}else o=j+8|0;c[f+12>>2]=j;c[o>>2]=f;l=g;m=h;break}f=c[g+24>>2]|0;j=c[g+12>>2]|0;do if((j|0)==(g|0)){n=g+16|0;k=n+4|0;p=c[k>>2]|0;if(!p){q=c[n>>2]|0;if(!q){r=0;break}else{s=q;t=n}}else{s=p;t=k}while(1){k=s+20|0;p=c[k>>2]|0;if(p){s=p;t=k;continue}k=s+16|0;p=c[k>>2]|0;if(!p){u=s;v=t;break}else{s=p;t=k}}if(v>>>0<i>>>0)Ga();else{c[v>>2]=0;r=u;break}}else{k=c[g+8>>2]|0;if(k>>>0<i>>>0)Ga();p=k+12|0;if((c[p>>2]|0)!=(g|0))Ga();n=j+8|0;if((c[n>>2]|0)==(g|0)){c[p>>2]=j;c[n>>2]=k;r=j;break}else Ga()}while(0);if(f){j=c[g+28>>2]|0;i=100256+(j<<2)|0;if((g|0)==(c[i>>2]|0)){c[i>>2]=r;if(!r){c[24989]=c[24989]&~(1<<j);l=g;m=h;break}}else{if(f>>>0<(c[24992]|0)>>>0)Ga();j=f+16|0;if((c[j>>2]|0)==(g|0))c[j>>2]=r;else c[f+20>>2]=r;if(!r){l=g;m=h;break}}j=c[24992]|0;if(r>>>0<j>>>0)Ga();c[r+24>>2]=f;i=g+16|0;k=c[i>>2]|0;do if(k)if(k>>>0<j>>>0)Ga();else{c[r+16>>2]=k;c[k+24>>2]=r;break}while(0);k=c[i+4>>2]|0;if(k)if(k>>>0<(c[24992]|0)>>>0)Ga();else{c[r+20>>2]=k;c[k+24>>2]=r;l=g;m=h;break}else{l=g;m=h}}else{l=g;m=h}}else{l=a;m=b}while(0);b=c[24992]|0;if(d>>>0<b>>>0)Ga();a=d+4|0;r=c[a>>2]|0;if(!(r&2)){if((d|0)==(c[24994]|0)){u=(c[24991]|0)+m|0;c[24991]=u;c[24994]=l;c[l+4>>2]=u|1;if((l|0)!=(c[24993]|0))return;c[24993]=0;c[24990]=0;return}if((d|0)==(c[24993]|0)){u=(c[24990]|0)+m|0;c[24990]=u;c[24993]=l;c[l+4>>2]=u|1;c[l+u>>2]=u;return}u=(r&-8)+m|0;v=r>>>3;do if(r>>>0>=256){t=c[d+24>>2]|0;s=c[d+12>>2]|0;do if((s|0)==(d|0)){o=d+16|0;e=o+4|0;k=c[e>>2]|0;if(!k){j=c[o>>2]|0;if(!j){w=0;break}else{x=j;y=o}}else{x=k;y=e}while(1){e=x+20|0;k=c[e>>2]|0;if(k){x=k;y=e;continue}e=x+16|0;k=c[e>>2]|0;if(!k){z=x;A=y;break}else{x=k;y=e}}if(A>>>0<b>>>0)Ga();else{c[A>>2]=0;w=z;break}}else{e=c[d+8>>2]|0;if(e>>>0<b>>>0)Ga();k=e+12|0;if((c[k>>2]|0)!=(d|0))Ga();o=s+8|0;if((c[o>>2]|0)==(d|0)){c[k>>2]=s;c[o>>2]=e;w=s;break}else Ga()}while(0);if(t){s=c[d+28>>2]|0;h=100256+(s<<2)|0;if((d|0)==(c[h>>2]|0)){c[h>>2]=w;if(!w){c[24989]=c[24989]&~(1<<s);break}}else{if(t>>>0<(c[24992]|0)>>>0)Ga();s=t+16|0;if((c[s>>2]|0)==(d|0))c[s>>2]=w;else c[t+20>>2]=w;if(!w)break}s=c[24992]|0;if(w>>>0<s>>>0)Ga();c[w+24>>2]=t;h=d+16|0;g=c[h>>2]|0;do if(g)if(g>>>0<s>>>0)Ga();else{c[w+16>>2]=g;c[g+24>>2]=w;break}while(0);g=c[h+4>>2]|0;if(g)if(g>>>0<(c[24992]|0)>>>0)Ga();else{c[w+20>>2]=g;c[g+24>>2]=w;break}}}else{g=c[d+8>>2]|0;s=c[d+12>>2]|0;t=99992+(v<<1<<2)|0;if((g|0)!=(t|0)){if(g>>>0<b>>>0)Ga();if((c[g+12>>2]|0)!=(d|0))Ga()}if((s|0)==(g|0)){c[24988]=c[24988]&~(1<<v);break}if((s|0)!=(t|0)){if(s>>>0<b>>>0)Ga();t=s+8|0;if((c[t>>2]|0)==(d|0))B=t;else Ga()}else B=s+8|0;c[g+12>>2]=s;c[B>>2]=g}while(0);c[l+4>>2]=u|1;c[l+u>>2]=u;if((l|0)==(c[24993]|0)){c[24990]=u;return}else C=u}else{c[a>>2]=r&-2;c[l+4>>2]=m|1;c[l+m>>2]=m;C=m}m=C>>>3;if(C>>>0<256){r=99992+(m<<1<<2)|0;a=c[24988]|0;u=1<<m;if(a&u){m=r+8|0;B=c[m>>2]|0;if(B>>>0<(c[24992]|0)>>>0)Ga();else{D=m;E=B}}else{c[24988]=a|u;D=r+8|0;E=r}c[D>>2]=l;c[E+12>>2]=l;c[l+8>>2]=E;c[l+12>>2]=r;return}r=C>>>8;if(r)if(C>>>0>16777215)F=31;else{E=(r+1048320|0)>>>16&8;D=r<<E;r=(D+520192|0)>>>16&4;u=D<<r;D=(u+245760|0)>>>16&2;a=14-(r|E|D)+(u<<D>>>15)|0;F=C>>>(a+7|0)&1|a<<1}else F=0;a=100256+(F<<2)|0;c[l+28>>2]=F;c[l+20>>2]=0;c[l+16>>2]=0;D=c[24989]|0;u=1<<F;if(!(D&u)){c[24989]=D|u;c[a>>2]=l;c[l+24>>2]=a;c[l+12>>2]=l;c[l+8>>2]=l;return}u=C<<((F|0)==31?0:25-(F>>>1)|0);F=c[a>>2]|0;while(1){if((c[F+4>>2]&-8|0)==(C|0)){G=F;H=127;break}a=F+16+(u>>>31<<2)|0;D=c[a>>2]|0;if(!D){I=a;J=F;H=124;break}else{u=u<<1;F=D}}if((H|0)==124){if(I>>>0<(c[24992]|0)>>>0)Ga();c[I>>2]=l;c[l+24>>2]=J;c[l+12>>2]=l;c[l+8>>2]=l;return}else if((H|0)==127){H=G+8|0;J=c[H>>2]|0;I=c[24992]|0;if(!(J>>>0>=I>>>0&G>>>0>=I>>>0))Ga();c[J+12>>2]=l;c[H>>2]=l;c[l+8>>2]=J;c[l+12>>2]=G;c[l+24>>2]=0;return}}function T4(){}function U4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return (C=e,a-c>>>0|0)|0}function V4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return (C=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function W4(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;p=p+1|0;c[a>>2]=p;while((f|0)<(e|0)){if(!(c[d+(f<<3)>>2]|0)){c[d+(f<<3)>>2]=p;c[d+((f<<3)+4)>>2]=b;c[d+((f<<3)+8)>>2]=0;C=e;return d|0}f=f+1|0}e=e*2|0;d=Q4(d|0,8*(e+1|0)|0)|0;d=W4(a|0,b|0,d|0,e|0)|0;C=e;return d|0}function X4(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){C=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}C=0;return b>>>c-32|0}function Y4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){f=c[b+(e<<3)>>2]|0;if(!f)break;if((f|0)==(a|0))return c[b+((e<<3)+4)>>2]|0;e=e+1|0}return 0}function Z4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return _a(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if(!e)return f|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function _4(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else Z4(b,c,d)|0;return b|0}function $4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b>>0]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b>>0]=d;b=b+1|0}return b-e|0}function a5(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){C=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}C=a<<c-32;return 0}function b5(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){C=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}C=(b|0)<0?-1:0;return b>>c-32|0}function c5(b){b=b|0;var c=0;c=a[m+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[m+(b>>>24)>>0]|0)+24|0}function d5(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=_(d,c)|0;f=a>>>16;a=(e>>>16)+(_(d,f)|0)|0;d=b>>>16;b=_(d,c)|0;return (C=(a>>>16)+(_(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function e5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=U4(e^a,f^b,e,f)|0;b=C;a=g^e;e=h^f;return U4((j5(i,b,U4(g^c,h^d,g,h)|0,C,0)|0)^a,C^e,a,e)|0}function f5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+16|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=U4(h^a,j^b,h,j)|0;b=C;j5(m,b,U4(k^d,l^e,k,l)|0,C,g)|0;l=U4(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=C;i=f;return (C=j,l)|0}function g5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=d5(e,a)|0;f=C;return (C=(_(b,a)|0)+(_(d,e)|0)+f|f&0,c|0|0)|0}function h5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return j5(a,b,c,d,0)|0}function i5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f|0;j5(a,b,d,e,g)|0;i=f;return (C=c[g+4>>2]|0,c[g>>2]|0)|0}function j5(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,D=0,E=0,F=0,G=0,H=0;g=a;h=b;i=h;j=d;k=e;l=k;if(!i){m=(f|0)!=0;if(!l){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return (C=n,o)|0}else{if(!m){n=0;o=0;return (C=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return (C=n,o)|0}}m=(l|0)==0;do if(j){if(!m){p=(aa(l|0)|0)-(aa(i|0)|0)|0;if(p>>>0<=31){q=p+1|0;r=31-p|0;s=p-31>>31;t=q;u=g>>>(q>>>0)&s|i<<r;v=i>>>(q>>>0)&s;w=0;x=g<<r;break}if(!f){n=0;o=0;return (C=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return (C=n,o)|0}r=j-1|0;if(r&j){s=(aa(j|0)|0)+33-(aa(i|0)|0)|0;q=64-s|0;p=32-s|0;y=p>>31;z=s-32|0;A=z>>31;t=s;u=p-1>>31&i>>>(z>>>0)|(i<<p|g>>>(s>>>0))&A;v=A&i>>>(s>>>0);w=g<<q&y;x=(i<<q|g>>>(z>>>0))&y|g<<p&s-33>>31;break}if(f){c[f>>2]=r&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return (C=n,o)|0}else{r=c5(j|0)|0;n=i>>>(r>>>0)|0;o=i<<32-r|g>>>(r>>>0)|0;return (C=n,o)|0}}else{if(m){if(f){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return (C=n,o)|0}if(!g){if(f){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return (C=n,o)|0}r=l-1|0;if(!(r&l)){if(f){c[f>>2]=a|0;c[f+4>>2]=r&i|b&0}n=0;o=i>>>((c5(l|0)|0)>>>0);return (C=n,o)|0}r=(aa(l|0)|0)-(aa(i|0)|0)|0;if(r>>>0<=30){s=r+1|0;p=31-r|0;t=s;u=i<<p|g>>>(s>>>0);v=i>>>(s>>>0);w=0;x=g<<p;break}if(!f){n=0;o=0;return (C=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return (C=n,o)|0}while(0);if(!t){B=x;D=w;E=v;F=u;G=0;H=0}else{b=d|0|0;d=k|e&0;e=V4(b|0,d|0,-1,-1)|0;k=C;h=x;x=w;w=v;v=u;u=t;t=0;do{a=h;h=x>>>31|h<<1;x=t|x<<1;g=v<<1|a>>>31|0;a=v>>>31|w<<1|0;U4(e,k,g,a)|0;i=C;l=i>>31|((i|0)<0?-1:0)<<1;t=l&1;v=U4(g,a,l&b,(((i|0)<0?-1:0)>>31|((i|0)<0?-1:0)<<1)&d)|0;w=C;u=u-1|0}while((u|0)!=0);B=h;D=x;E=w;F=v;G=0;H=t}t=D;D=0;if(f){c[f>>2]=F;c[f+4>>2]=E}n=(t|0)>>>31|(B|D)<<1|(D<<1|t>>>31)&0|G;o=(t<<1|0>>>31)&-2|H;return (C=n,o)|0}function k5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Ab[a&31](b|0,c|0,d|0,e|0,f|0)}function l5(a,b){a=a|0;b=b|0;Bb[a&127](b|0)}function m5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;return Cb[a&3](b|0,c|0,+d,+e)|0}function n5(a,b,c){a=a|0;b=b|0;c=c|0;Db[a&31](b|0,c|0)}function o5(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return Eb[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function p5(a,b){a=a|0;b=b|0;return Fb[a&63](b|0)|0}function q5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Gb[a&63](b|0,c|0,d|0,e|0,f|0)|0}function r5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Hb[a&63](b|0,c|0,d|0)|0}function s5(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;Ib[a&15](b|0,c|0,d|0,e|0,f|0,g|0)}function t5(a,b){a=a|0;b=b|0;return +Jb[a&1](b|0)}function u5(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return Kb[a&1](b|0,c|0,d|0,e|0,f|0,g|0)|0}function v5(a,b,c,d){a=a|0;b=+b;c=+c;d=+d;return +Lb[a&7](+b,+c,+d)}function w5(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Mb[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function x5(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Nb[a&0](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function y5(a,b,c){a=a|0;b=b|0;c=c|0;return Ob[a&127](b|0,c|0)|0}function z5(a){a=a|0;return +Pb[a&1]()}function A5(a){a=a|0;return Qb[a&7]()|0}function B5(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=g|0;Rb[a&15](b|0,c|0,d|0,+e,+f,g|0)}function C5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Sb[a&127](b|0,c|0,d|0,e|0)|0}function D5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Tb[a&127](b|0,c|0,d|0)}function E5(a){a=a|0;Ub[a&7]()}function F5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Vb[a&31](b|0,c|0,d|0,e|0)}function G5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ba(0)}function H5(a){a=a|0;ba(1)}function I5(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;ba(2);return 0}function J5(a,b){a=a|0;b=b|0;ba(3)}function K5(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ba(4);return 0}function L5(a){a=a|0;ba(5);return 0}function M5(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ba(6);return 0}function N5(a,b,c){a=a|0;b=b|0;c=c|0;ba(7);return 0}function O5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ba(8)}function P5(a){a=a|0;ba(9);return 0.0}function Q5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ba(10);return 0}function R5(a,b,c){a=+a;b=+b;c=+c;ba(11);return 0.0}function S5(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ba(12)}function T5(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ba(13)}function U5(a,b){a=a|0;b=b|0;ba(14);return 0}function V5(){ba(15);return 0.0}function W5(){ba(16);return 0}function X5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=+e;f=f|0;ba(17)}function Y5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ba(18);return 0}function Z5(a,b,c){a=a|0;b=b|0;c=c|0;ba(19)}function _5(){ba(20)}function $5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ba(21)}

// EMSCRIPTEN_END_FUNCS
var Ab=[G5,_c,md,td,Jd,ne,i0,h0,K$,L$,g0,f$,g$,B_,C_,Xk,mG,JP,a_,b_,G5,G5,G5,G5,G5,G5,G5,G5,G5,G5,G5,G5];var Bb=[H5,jc,kc,lc,mc,nc,Gc,Hc,Ic,Jc,Kc,Lc,Mc,Yc,Zc,ad,bd,cd,ed,fd,gd,hd,id,jd,kd,ld,wd,xd,yd,Ad,Bd,Cd,Dd,Ed,Fd,Gd,Hd,Id,Kd,Wd,Xd,Yd,Zd,ke,le,me,oe,Ae,Be,Ce,Ee,Fe,Ge,He,Ie,Je,Ke,Le,Me,Ue,Ve,We,Xe,tf,sf,wl,sl,$n,Sn,ep,fp,pn,qn,Zo,_o,ol,pl,un,vn,En,Fn,DB,kM,xM,mM,lM,PM,FL,GL,VR,_R,nf,_k,Zn,_n,go,O4,qv,sA,oG,TH,kK,xU,HQ,WK,IU,tX,OX,PX,VX,r4,s4,H5,H5,H5,H5,H5,H5,H5,H5,H5,H5,H5,H5,H5,H5,H5,H5];var Cb=[I5,Lt,Mt,I5];var Db=[J5,Oc,Tc,sd,Qd,de,ue,Se,bf,ZB,BM,ZM,TM,OM,vM,wM,YR,aS,lL,kG,oK,zP,aA,wW,sX,RX,SX,WX,YX,J5,J5,J5];var Eb=[K5,WZ,TZ,K5];var Fb=[L5,Fg,_f,ym,zm,SB,WB,PP,QP,NR,OR,PR,QR,RR,SR,TR,UR,I2,dc,lF,Vk,Yk,fm,cK,kB,$B,jB,iK,nK,lB,AP,bK,FP,GP,XX,N4,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5,L5];var Gb=[M5,zB,AM,SM,o0,f1,g1,t0,q0,d1,e1,u0,v0,w0,x0,y0,V0,W0,M0,F0,A0,z0,B0,C0,E0,D0,r0,p0,G0,H0,I0,J0,K0,L0,N0,O0,P0,Q0,U0,S0,R0,T0,$0,X0,Y0,Z0,_0,a1,b1,c1,h1,i1,j1,k1,M5,M5,M5,M5,M5,M5,M5,M5,M5,M5];var Hb=[N5,pm,nv,zz,Gz,Mz,Rz,AB,CB,QB,TB,gL,vP,uU,B$,H$,Y_,c$,s_,y_,D4,L2,K2,J2,M2,$z,mm,Vu,Jo,Is,xx,zx,Cx,Tz,k3,FD,Y2,WN,_K,NQ,QX,VZ,SZ,g_,k_,v4,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5,N5];var Ib=[O5,rc,Rc,qd,Od,be,se,Qe,$e,O5,O5,O5,O5,O5,O5,O5];var Jb=[P5,gO];var Kb=[Q5,uX];var Lb=[R5,XI,YI,ZI,_I,R5,R5,R5];var Mb=[S5,KP];var Nb=[T5];var Ob=[U5,yB,RB,XB,_M,YM,RM,NM,zM,IW,JW,KW,LW,MW,NW,PW,QW,RW,SW,TW,UW,VW,WW,XW,YW,ZW,_W,$W,aX,bX,cX,dX,eX,fX,gX,hX,iX,jX,kX,lX,D$,E$,G$,M$,N$,O$,P$,Q$,R$,S$,T$,__,$_,b$,u_,v_,x_,jF,Qf,Eg,Sh,bi,$h,gk,ek,Wk,Zk,po,zp,Fq,Zq,$q,br,cr,jr,ir,hr,Ds,Js,Ou,pw,_w,wE,xE,yE,lG,aC,eK,qG,TG,WG,XG,jH,_2,Z2,ZN,iP,yA,HU,OA,QA,BP,CR,iT,HW,TX,UX,Q4,ZZ,_Z,$Z,M4,U5,U5,U5,U5,U5,U5,U5,U5,U5,U5,U5,U5,U5,U5,U5,U5];var Pb=[V5,$N];var Qb=[W5,vq,lK,mK,VK,W5,W5,W5];var Rb=[X5,lH,mH,nH,oH,pH,qH,rH,sH,X5,X5,X5,X5,X5,X5,X5];var Sb=[Y5,rm,or,ov,Bz,Iz,_A,MD,ZA,qB,OB,NB,YB,iC,jC,iL,xP,pQ,nQ,PS,wU,RU,QU,v$,w$,x$,y$,z$,A$,C$,F$,J$,S_,T_,U_,V_,W_,X_,Z_,a$,e$,m_,n_,o_,p_,q_,r_,t_,w_,A_,Hs,Wz,jG,MC,nG,YN,SY,KZ,dZ,nZ,ZY,wZ,BZ,zZ,CZ,XZ,QZ,d_,e_,i_,j_,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5,Y5];var Tb=[Z5,oc,pc,sc,Nc,Pc,Sc,nd,od,rd,Ld,Md,Pd,_d,$d,ce,pe,qe,te,Ne,Oe,Re,Ye,Ze,af,Lj,Mj,Nj,qm,Az,Hz,KA,BB,EB,oC,JC,ND,_F,rJ,jL,hL,NL,wP,rP,oQ,mQ,WR,XR,ZR,$R,bS,vU,iW,hW,NA,WA,gC,UC,VC,hK,XN,YK,DP,HP,IP,jW,lW,mW,vW,xW,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5,Z5];var Ub=[_5,_N,jK,pK,qK,rK,yU,_5];var Vb=[$5,qc,Qc,dd,pd,zd,Nd,ae,re,De,Pe,_e,qf,pf,of,mf,lf,hf,fc,kf,jf,yM,QM,I$,d$,z_,w3,CP,EP,f_,$5,$5];return{_vizRenderFromString:ec,_i64Subtract:U4,_fflush:T2,_aglasterr:_z,_realloc:Q4,_dtextract:Kz,_memmove:_4,_saveSetjmp:W4,_memset:$4,_malloc:N4,_i64Add:V4,_memcpy:Z4,_bitshift64Lshr:X4,_free:O4,_bitshift64Shl:a5,___errno_location:L1,_testSetjmp:Y4,runPostSets:T4,stackAlloc:Wb,stackSave:Xb,stackRestore:Yb,establishStackSpace:Zb,setThrew:_b,setTempRet0:bc,getTempRet0:cc,dynCall_viiiii:k5,dynCall_vi:l5,dynCall_iiidd:m5,dynCall_vii:n5,dynCall_iiiiiiiiiii:o5,dynCall_ii:p5,dynCall_iiiiii:q5,dynCall_iiii:r5,dynCall_viiiiii:s5,dynCall_di:t5,dynCall_iiiiiii:u5,dynCall_dddd:v5,dynCall_viiiiiii:w5,dynCall_viiiiiiiii:x5,dynCall_iii:y5,dynCall_d:z5,dynCall_i:A5,dynCall_viiiddi:B5,dynCall_iiiii:C5,dynCall_viii:D5,dynCall_v:E5,dynCall_viiii:F5}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var _vizRenderFromString=Module["_vizRenderFromString"]=asm["_vizRenderFromString"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var _fflush=Module["_fflush"]=asm["_fflush"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var _aglasterr=Module["_aglasterr"]=asm["_aglasterr"];var _realloc=Module["_realloc"]=asm["_realloc"];var _dtextract=Module["_dtextract"]=asm["_dtextract"];var _memmove=Module["_memmove"]=asm["_memmove"];var _saveSetjmp=Module["_saveSetjmp"]=asm["_saveSetjmp"];var _testSetjmp=Module["_testSetjmp"]=asm["_testSetjmp"];var _memset=Module["_memset"]=asm["_memset"];var _malloc=Module["_malloc"]=asm["_malloc"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var _free=Module["_free"]=asm["_free"];var ___errno_location=Module["___errno_location"]=asm["___errno_location"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_iiidd=Module["dynCall_iiidd"]=asm["dynCall_iiidd"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_iiiiiiiiiii=Module["dynCall_iiiiiiiiiii"]=asm["dynCall_iiiiiiiiiii"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_di=Module["dynCall_di"]=asm["dynCall_di"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_dddd=Module["dynCall_dddd"]=asm["dynCall_dddd"];var dynCall_viiiiiii=Module["dynCall_viiiiiii"]=asm["dynCall_viiiiiii"];var dynCall_viiiiiiiii=Module["dynCall_viiiiiiiii"]=asm["dynCall_viiiiiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_d=Module["dynCall_d"]=asm["dynCall_d"];var dynCall_i=Module["dynCall_i"]=asm["dynCall_i"];var dynCall_viiiddi=Module["dynCall_viiiddi"]=asm["dynCall_viiiddi"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];Runtime.stackAlloc=asm["stackAlloc"];Runtime.stackSave=asm["stackSave"];Runtime.stackRestore=asm["stackRestore"];Runtime.establishStackSpace=asm["establishStackSpace"];Runtime.setTempRet0=asm["setTempRet0"];Runtime.getTempRet0=asm["getTempRet0"];function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){assert(runDependencies==0,"cannot call main when async dependencies remain! (listen on __ATMAIN__)");assert(__ATPRERUN__.length==0,"cannot call main when preRun functions remain to be called");args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["stdout"]["once"]("drain",(function(){process["exit"](status)}));console.log(" ");setTimeout((function(){process["exit"](status)}),500)}else if(ENVIRONMENT_IS_SHELL&&typeof quit==="function"){quit(status)}throw new ExitStatus(status)}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}run()





  return Module;
};
  function Viz(src) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    var format = options.format === undefined ? "svg" : options.format;
    var engine = options.engine === undefined ? "dot" : options.engine;
  
    if (format == "png-image-element") {
      return Viz.svgXmlToPngImageElement(render(src, "svg", engine));
    } else {
      return render(src, format, engine);
    }
  }

  var graphviz;
  var errors;
  
  function appendError(buf) {
    errors += graphviz["Pointer_stringify"](buf);
  }
  
  function render(src, format, engine) {
    if (typeof graphviz === "undefined") {
      graphviz = Module();
    }
    
    errors = "";
    
    var resultPointer = graphviz["ccall"]("vizRenderFromString", "number", ["string", "string", "string"], [src, format, engine]);
    var resultString = graphviz["Pointer_stringify"](resultPointer);
    graphviz["_free"](resultPointer);
    
    if (errors != "") {
      throw errors;
    }
    
    return resultString;
  }
  
  Viz.svgXmlToPngImageElement = function(svgXml) {
    var scaleFactor = 1;
    
    if ("devicePixelRatio" in window) {
      if (window.devicePixelRatio > 1) {
        scaleFactor = window.devicePixelRatio;
      }
    }
    
    var svgImage = new Image();
    svgImage.src = "data:image/svg+xml;utf8," + svgXml;

    var pngImage = new Image();

    svgImage.onload = function() {
      var canvas = document.createElement("canvas");
      canvas.width = svgImage.width * scaleFactor;
      canvas.height = svgImage.height * scaleFactor;

      var context = canvas.getContext("2d");
      context.drawImage(svgImage, 0, 0, canvas.width, canvas.height);

      pngImage.src = canvas.toDataURL("image/png");
      pngImage.width = svgImage.width;
      pngImage.height = svgImage.height;
    }
    
    return pngImage;
  }
  
  if (typeof module === "object" && module.exports) {
    module.exports = Viz;
  } else {
    global.Viz = Viz;
  }
  
})(this);
